/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var oe=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/platform","vs/platform/log/common/log","vs/platform/instantiation/common/instantiation","vs/base/common/uri","vs/base/common/async","vs/base/common/path","vs/nls!vs/code/electron-main/main","vs/nls","vs/base/common/types","vs/base/common/network","electron","vs/platform/files/common/files","vs/base/common/errors","vs/base/common/buffer","vs/platform/configuration/common/configuration","vs/base/common/resources","vs/platform/lifecycle/electron-main/lifecycleMainService","vs/base/node/pfs","vs/base/common/arrays","vs/base/common/cancellation","vs/platform/telemetry/common/telemetry","vs/platform/environment/electron-main/environmentMainService","vs/base/common/strings","os","vs/platform/product/common/productService","vs/platform/windows/electron-main/windows","vs/platform/workspace/common/workspace","vs/base/common/extpath","vs/base/common/map","vs/base/common/uuid","vs/platform/state/node/state","vs/base/common/objects","vs/base/common/process","vs/base/parts/ipc/electron-main/ipcMain","vs/platform/environment/common/environment","vs/base/common/charCode","vs/platform/policy/common/policy","vs/platform/uriIdentity/common/uriIdentity","vs/platform/userDataProfile/common/userDataProfile","vs/base/common/json","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/base/common/hash","fs","vs/base/common/labels","child_process","vs/platform/update/common/update","vs/platform/window/electron-main/window","vs/base/common/decorators","vs/base/common/errorMessage","vs/platform/configuration/common/configurationRegistry","vs/platform/request/common/request","vs/platform/telemetry/common/telemetryUtils","vs/platform/window/common/window","vs/platform/dialogs/electron-main/dialogMainService","vs/platform/userDataProfile/electron-main/userDataProfile","vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/base/common/ternarySearchTree","vs/platform/files/common/watcher","vs/platform/storage/common/storage","vs/platform/utilityProcess/electron-main/utilityProcess","vs/base/common/lazy","vs/base/common/stopwatch","vs/base/common/stream","vs/platform/environment/node/argvHelper","vs/platform/backup/electron-main/backup","vs/base/common/performance","vs/platform/log/electron-main/loggerService","vs/platform/remote/common/remoteHosts","vs/platform/terminal/common/terminal","vs/platform/theme/electron-main/themeMainService","vs/platform/native/electron-main/nativeHostMainService","vs/base/common/iterator","vs/base/common/normalization","vs/base/common/codicons","vs/base/common/severity","vs/base/common/processes","vs/base/common/marshalling","vs/platform/instantiation/common/descriptors","vs/platform/auxiliaryWindow/electron-main/auxiliaryWindows","vs/platform/product/common/product","vs/platform/protocol/electron-main/protocol","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/platform/storage/electron-main/storageMainService","vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/base/common/functional","vs/base/common/marshallingIds","crypto","net","vs/base/node/id","vs/base/node/processes","vs/platform/environment/node/environmentService","vs/platform/diagnostics/common/diagnostics","vs/platform/encryption/common/encryptionService","vs/platform/instantiation/common/serviceCollection","vs/platform/files/node/diskFileSystemProvider","vs/platform/extensions/common/extensions","vs/platform/shell/node/shellEnv","vs/platform/sign/common/sign","vs/platform/workspaces/common/workspaces","vs/platform/workspaces/node/workspaces","vs/base/parts/ipc/node/ipc.net","vs/platform/update/electron-main/abstractUpdateService","vs/base/node/unc","vs/base/common/jsonEdit","vs/base/common/linkedList","vs/base/common/codiconsUtil","vs/base/common/themables","vs/base/node/ports","vs/base/common/glob","vs/base/node/extpath","vs/base/node/powershell","vs/base/node/ps","vs/base/node/shell","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/electron-main/ipc.mp","vs/base/parts/storage/common/storage","vs/platform/environment/node/argv","path","vs/platform/contextkey/common/contextkey","vs/platform/dialogs/common/dialogs","vs/platform/files/common/io","vs/platform/configuration/common/configurationModels","vs/platform/extensionManagement/common/extensionManagement","vs/platform/state/node/stateService","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariable","vs/platform/tunnel/common/tunnel","vs/platform/url/common/url","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/windows/electron-main/windowsFinder","vs/platform/diagnostics/electron-main/diagnosticsMainService","vs/platform/windows/electron-main/windowImpl","vs/base/common/arraysFind","vs/base/common/collections","vs/base/common/color","vs/base/common/assert","vs/base/common/jsonFormatter","vs/base/common/numbers","vs/base/common/skipList","vs/base/common/cache","vs/base/common/symbols","vs/base/common/codiconsLibrary","vs/base/common/uint","vs/base/node/crypto","vs/base/node/macAddress","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/common/platform","vs/base/common/console","vs/base/common/uriIpc","util","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/contextmenu/electron-main/contextmenu","vs/base/parts/ipc/electron-main/ipc.electron","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/node/storage","vs/nls!vs/code/electron-main/app","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/dialogs/common/dialogs","vs/nls!vs/platform/dialogs/electron-main/dialogMainService","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/electron-main/diskFileSystemProviderServer","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/issue/electron-main/issueMainService","vs/nls!vs/platform/log/common/log","vs/nls!vs/platform/menubar/electron-main/menubar","vs/nls!vs/platform/native/electron-main/nativeHostMainService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/terminal/common/terminalPlatformConfiguration","vs/nls!vs/platform/terminal/common/terminalProfiles","vs/nls!vs/platform/update/common/update.config.contribution","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/windows/electron-main/windowImpl","vs/nls!vs/platform/windows/electron-main/windowsMainService","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/nls!vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/platform/backup/common/backup","vs/platform/backup/node/backup","vs/platform/contextkey/common/scanner","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/wait","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensions/common/extensionValidator","vs/base/common/semver/semver","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/extensions/common/extensionHostStarter","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/electron-main/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/baseWatcher","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/issue/common/issue","vs/platform/encryption/electron-main/encryptionMainService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProviderServer","vs/platform/files/electron-main/diskFileSystemProviderServer","vs/platform/log/common/bufferLog","vs/platform/log/common/logIpc","vs/platform/log/common/logService","vs/platform/log/electron-main/logIpc","vs/platform/log/node/spdlogLog","vs/platform/log/node/loggerService","vs/platform/menubar/common/menubar","vs/platform/policy/common/filePolicyService","vs/platform/policy/common/policyIpc","vs/platform/policy/node/nativePolicyService","vs/platform/profiling/electron-main/windowProfiling","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/electronRemoteResources","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/remote/node/wsl","vs/platform/request/common/requestIpc","vs/platform/request/node/proxy","url","vs/platform/sharedProcess/common/sharedProcess","vs/platform/sign/common/abstractSignService","vs/platform/sign/node/signService","vs/platform/diagnostics/node/diagnosticsService","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryService","vs/platform/telemetry/node/telemetryUtils","vs/platform/telemetry/electron-main/telemetryUtils","vs/platform/terminal/common/environmentVariableCollection","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/requestStore","vs/platform/terminal/common/terminalProfiles","vs/platform/terminal/common/terminalPlatformConfiguration","vs/platform/terminal/node/terminalEnvironment","vs/platform/terminal/node/terminalProfiles","vs/platform/terminal/node/ptyHostService","vs/platform/update/common/update.config.contribution","vs/platform/update/common/updateIpc","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/url/common/urlIpc","vs/platform/url/common/urlService","vs/platform/url/electron-main/electronUrlListener","vs/platform/userData/common/fileUserDataProvider","vs/platform/utilityProcess/common/utilityProcessWorkerService","vs/platform/webview/common/webviewManagerService","vs/platform/webview/electron-main/webviewProtocolProvider","vs/platform/windows/node/windowTracker","vs/platform/storage/electron-main/storageIpc","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/protocol/electron-main/protocolMainService","vs/platform/externalServices/common/serviceMachineId","vs/platform/externalServices/common/marketplace","vs/platform/storage/electron-main/storageMain","vs/platform/userDataProfile/electron-main/userDataProfileStorageIpc","vs/platform/userDataProfile/node/userDataProfile","zlib","vs/platform/backup/electron-main/backupMainService","vs/platform/keyboardLayout/electron-main/keyboardLayoutMainService","vs/platform/request/node/requestService","vs/platform/request/electron-main/requestMainService","vs/platform/tunnel/node/tunnelService","vs/platform/update/electron-main/updateService.darwin","vs/platform/update/electron-main/updateService.snap","vs/code/electron-main/auth","vs/platform/debug/electron-main/extensionHostDebugIpc","vs/platform/launch/electron-main/launchMainService","vs/platform/userDataProfile/electron-main/userDataProfilesHandler","vs/platform/extensions/electron-main/extensionHostStarter","vs/platform/sharedProcess/electron-main/sharedProcess","vs/platform/terminal/electron-main/electronPtyHostStarter","vs/platform/utilityProcess/electron-main/utilityProcessWorkerMainService","vs/platform/webview/electron-main/webviewMainService","vs/platform/windows/electron-main/windowsStateHandler","vs/platform/issue/electron-main/issueMainService","vs/platform/update/electron-main/updateService.linux","vs/platform/update/electron-main/updateService.win32","vs/platform/auxiliaryWindow/electron-main/auxiliaryWindow","vs/platform/auxiliaryWindow/electron-main/auxiliaryWindowsMainService","vs/platform/menubar/electron-main/menubar","vs/platform/menubar/electron-main/menubarMainService","vs/platform/windows/electron-main/windowsMainService","vs/platform/workspaces/electron-main/workspacesMainService","vs/code/electron-main/app","minimist","assert","string_decoder","vs/base/common/jsonc","vs/code/electron-main/main"],ae=function(V){for(var e=[],i=0,o=V.length;i<o;i++)e[i]=oe[V[i]];return e};define(oe[138],ae([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ob=void 0,e.$hb=i,e.$ib=o,e.$jb=S,e.$kb=D,e.$lb=O,e.$mb=P,e.$nb=y,e.$pb=h,e.$qb=f,e.$rb=g,e.$sb=b,e.$tb=l;function i(m,p){const $=o(m,p);if($!==-1)return m[$]}function o(m,p,$=m.length-1){for(let w=$;w>=0;w--){const v=m[w];if(p(v))return w}return-1}function S(m,p){const $=D(m,p);return $===-1?void 0:m[$]}function D(m,p,$=0,w=m.length){let v=$,k=w;for(;v<k;){const t=Math.floor((v+k)/2);p(m[t])?v=t+1:k=t}return v-1}function O(m,p){const $=P(m,p);return $===m.length?void 0:m[$]}function P(m,p,$=0,w=m.length){let v=$,k=w;for(;v<k;){const t=Math.floor((v+k)/2);p(m[t])?k=t:v=t+1}return v}function y(m,p,$=0,w=m.length){const v=P(m,p,$,w);return v===m.length?-1:v}class a{static{this.assertInvariants=!1}constructor(p){this.e=p,this.c=0}findLastMonotonous(p){if(a.assertInvariants){if(this.d){for(const w of this.e)if(this.d(w)&&!p(w))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=p}const $=D(this.e,p,this.c);return this.c=$+1,$===-1?void 0:this.e[$]}}e.$ob=a;function h(m,p){if(m.length===0)return;let $=m[0];for(let w=1;w<m.length;w++){const v=m[w];p(v,$)>0&&($=v)}return $}function f(m,p){if(m.length===0)return;let $=m[0];for(let w=1;w<m.length;w++){const v=m[w];p(v,$)>=0&&($=v)}return $}function g(m,p){return h(m,($,w)=>-p($,w))}function b(m,p){if(m.length===0)return-1;let $=0;for(let w=1;w<m.length;w++){const v=m[w];p(v,m[$])>0&&($=w)}return $}function l(m,p){for(const $ of m){const w=p($);if(w!==void 0)return w}}}),define(oe[39],ae([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharCode=void 0;var i;(function(o){o[o.Null=0]="Null",o[o.Backspace=8]="Backspace",o[o.Tab=9]="Tab",o[o.LineFeed=10]="LineFeed",o[o.CarriageReturn=13]="CarriageReturn",o[o.Space=32]="Space",o[o.ExclamationMark=33]="ExclamationMark",o[o.DoubleQuote=34]="DoubleQuote",o[o.Hash=35]="Hash",o[o.DollarSign=36]="DollarSign",o[o.PercentSign=37]="PercentSign",o[o.Ampersand=38]="Ampersand",o[o.SingleQuote=39]="SingleQuote",o[o.OpenParen=40]="OpenParen",o[o.CloseParen=41]="CloseParen",o[o.Asterisk=42]="Asterisk",o[o.Plus=43]="Plus",o[o.Comma=44]="Comma",o[o.Dash=45]="Dash",o[o.Period=46]="Period",o[o.Slash=47]="Slash",o[o.Digit0=48]="Digit0",o[o.Digit1=49]="Digit1",o[o.Digit2=50]="Digit2",o[o.Digit3=51]="Digit3",o[o.Digit4=52]="Digit4",o[o.Digit5=53]="Digit5",o[o.Digit6=54]="Digit6",o[o.Digit7=55]="Digit7",o[o.Digit8=56]="Digit8",o[o.Digit9=57]="Digit9",o[o.Colon=58]="Colon",o[o.Semicolon=59]="Semicolon",o[o.LessThan=60]="LessThan",o[o.Equals=61]="Equals",o[o.GreaterThan=62]="GreaterThan",o[o.QuestionMark=63]="QuestionMark",o[o.AtSign=64]="AtSign",o[o.A=65]="A",o[o.B=66]="B",o[o.C=67]="C",o[o.D=68]="D",o[o.E=69]="E",o[o.F=70]="F",o[o.G=71]="G",o[o.H=72]="H",o[o.I=73]="I",o[o.J=74]="J",o[o.K=75]="K",o[o.L=76]="L",o[o.M=77]="M",o[o.N=78]="N",o[o.O=79]="O",o[o.P=80]="P",o[o.Q=81]="Q",o[o.R=82]="R",o[o.S=83]="S",o[o.T=84]="T",o[o.U=85]="U",o[o.V=86]="V",o[o.W=87]="W",o[o.X=88]="X",o[o.Y=89]="Y",o[o.Z=90]="Z",o[o.OpenSquareBracket=91]="OpenSquareBracket",o[o.Backslash=92]="Backslash",o[o.CloseSquareBracket=93]="CloseSquareBracket",o[o.Caret=94]="Caret",o[o.Underline=95]="Underline",o[o.BackTick=96]="BackTick",o[o.a=97]="a",o[o.b=98]="b",o[o.c=99]="c",o[o.d=100]="d",o[o.e=101]="e",o[o.f=102]="f",o[o.g=103]="g",o[o.h=104]="h",o[o.i=105]="i",o[o.j=106]="j",o[o.k=107]="k",o[o.l=108]="l",o[o.m=109]="m",o[o.n=110]="n",o[o.o=111]="o",o[o.p=112]="p",o[o.q=113]="q",o[o.r=114]="r",o[o.s=115]="s",o[o.t=116]="t",o[o.u=117]="u",o[o.v=118]="v",o[o.w=119]="w",o[o.x=120]="x",o[o.y=121]="y",o[o.z=122]="z",o[o.OpenCurlyBrace=123]="OpenCurlyBrace",o[o.Pipe=124]="Pipe",o[o.CloseCurlyBrace=125]="CloseCurlyBrace",o[o.Tilde=126]="Tilde",o[o.NoBreakSpace=160]="NoBreakSpace",o[o.U_Combining_Grave_Accent=768]="U_Combining_Grave_Accent",o[o.U_Combining_Acute_Accent=769]="U_Combining_Acute_Accent",o[o.U_Combining_Circumflex_Accent=770]="U_Combining_Circumflex_Accent",o[o.U_Combining_Tilde=771]="U_Combining_Tilde",o[o.U_Combining_Macron=772]="U_Combining_Macron",o[o.U_Combining_Overline=773]="U_Combining_Overline",o[o.U_Combining_Breve=774]="U_Combining_Breve",o[o.U_Combining_Dot_Above=775]="U_Combining_Dot_Above",o[o.U_Combining_Diaeresis=776]="U_Combining_Diaeresis",o[o.U_Combining_Hook_Above=777]="U_Combining_Hook_Above",o[o.U_Combining_Ring_Above=778]="U_Combining_Ring_Above",o[o.U_Combining_Double_Acute_Accent=779]="U_Combining_Double_Acute_Accent",o[o.U_Combining_Caron=780]="U_Combining_Caron",o[o.U_Combining_Vertical_Line_Above=781]="U_Combining_Vertical_Line_Above",o[o.U_Combining_Double_Vertical_Line_Above=782]="U_Combining_Double_Vertical_Line_Above",o[o.U_Combining_Double_Grave_Accent=783]="U_Combining_Double_Grave_Accent",o[o.U_Combining_Candrabindu=784]="U_Combining_Candrabindu",o[o.U_Combining_Inverted_Breve=785]="U_Combining_Inverted_Breve",o[o.U_Combining_Turned_Comma_Above=786]="U_Combining_Turned_Comma_Above",o[o.U_Combining_Comma_Above=787]="U_Combining_Comma_Above",o[o.U_Combining_Reversed_Comma_Above=788]="U_Combining_Reversed_Comma_Above",o[o.U_Combining_Comma_Above_Right=789]="U_Combining_Comma_Above_Right",o[o.U_Combining_Grave_Accent_Below=790]="U_Combining_Grave_Accent_Below",o[o.U_Combining_Acute_Accent_Below=791]="U_Combining_Acute_Accent_Below",o[o.U_Combining_Left_Tack_Below=792]="U_Combining_Left_Tack_Below",o[o.U_Combining_Right_Tack_Below=793]="U_Combining_Right_Tack_Below",o[o.U_Combining_Left_Angle_Above=794]="U_Combining_Left_Angle_Above",o[o.U_Combining_Horn=795]="U_Combining_Horn",o[o.U_Combining_Left_Half_Ring_Below=796]="U_Combining_Left_Half_Ring_Below",o[o.U_Combining_Up_Tack_Below=797]="U_Combining_Up_Tack_Below",o[o.U_Combining_Down_Tack_Below=798]="U_Combining_Down_Tack_Below",o[o.U_Combining_Plus_Sign_Below=799]="U_Combining_Plus_Sign_Below",o[o.U_Combining_Minus_Sign_Below=800]="U_Combining_Minus_Sign_Below",o[o.U_Combining_Palatalized_Hook_Below=801]="U_Combining_Palatalized_Hook_Below",o[o.U_Combining_Retroflex_Hook_Below=802]="U_Combining_Retroflex_Hook_Below",o[o.U_Combining_Dot_Below=803]="U_Combining_Dot_Below",o[o.U_Combining_Diaeresis_Below=804]="U_Combining_Diaeresis_Below",o[o.U_Combining_Ring_Below=805]="U_Combining_Ring_Below",o[o.U_Combining_Comma_Below=806]="U_Combining_Comma_Below",o[o.U_Combining_Cedilla=807]="U_Combining_Cedilla",o[o.U_Combining_Ogonek=808]="U_Combining_Ogonek",o[o.U_Combining_Vertical_Line_Below=809]="U_Combining_Vertical_Line_Below",o[o.U_Combining_Bridge_Below=810]="U_Combining_Bridge_Below",o[o.U_Combining_Inverted_Double_Arch_Below=811]="U_Combining_Inverted_Double_Arch_Below",o[o.U_Combining_Caron_Below=812]="U_Combining_Caron_Below",o[o.U_Combining_Circumflex_Accent_Below=813]="U_Combining_Circumflex_Accent_Below",o[o.U_Combining_Breve_Below=814]="U_Combining_Breve_Below",o[o.U_Combining_Inverted_Breve_Below=815]="U_Combining_Inverted_Breve_Below",o[o.U_Combining_Tilde_Below=816]="U_Combining_Tilde_Below",o[o.U_Combining_Macron_Below=817]="U_Combining_Macron_Below",o[o.U_Combining_Low_Line=818]="U_Combining_Low_Line",o[o.U_Combining_Double_Low_Line=819]="U_Combining_Double_Low_Line",o[o.U_Combining_Tilde_Overlay=820]="U_Combining_Tilde_Overlay",o[o.U_Combining_Short_Stroke_Overlay=821]="U_Combining_Short_Stroke_Overlay",o[o.U_Combining_Long_Stroke_Overlay=822]="U_Combining_Long_Stroke_Overlay",o[o.U_Combining_Short_Solidus_Overlay=823]="U_Combining_Short_Solidus_Overlay",o[o.U_Combining_Long_Solidus_Overlay=824]="U_Combining_Long_Solidus_Overlay",o[o.U_Combining_Right_Half_Ring_Below=825]="U_Combining_Right_Half_Ring_Below",o[o.U_Combining_Inverted_Bridge_Below=826]="U_Combining_Inverted_Bridge_Below",o[o.U_Combining_Square_Below=827]="U_Combining_Square_Below",o[o.U_Combining_Seagull_Below=828]="U_Combining_Seagull_Below",o[o.U_Combining_X_Above=829]="U_Combining_X_Above",o[o.U_Combining_Vertical_Tilde=830]="U_Combining_Vertical_Tilde",o[o.U_Combining_Double_Overline=831]="U_Combining_Double_Overline",o[o.U_Combining_Grave_Tone_Mark=832]="U_Combining_Grave_Tone_Mark",o[o.U_Combining_Acute_Tone_Mark=833]="U_Combining_Acute_Tone_Mark",o[o.U_Combining_Greek_Perispomeni=834]="U_Combining_Greek_Perispomeni",o[o.U_Combining_Greek_Koronis=835]="U_Combining_Greek_Koronis",o[o.U_Combining_Greek_Dialytika_Tonos=836]="U_Combining_Greek_Dialytika_Tonos",o[o.U_Combining_Greek_Ypogegrammeni=837]="U_Combining_Greek_Ypogegrammeni",o[o.U_Combining_Bridge_Above=838]="U_Combining_Bridge_Above",o[o.U_Combining_Equals_Sign_Below=839]="U_Combining_Equals_Sign_Below",o[o.U_Combining_Double_Vertical_Line_Below=840]="U_Combining_Double_Vertical_Line_Below",o[o.U_Combining_Left_Angle_Below=841]="U_Combining_Left_Angle_Below",o[o.U_Combining_Not_Tilde_Above=842]="U_Combining_Not_Tilde_Above",o[o.U_Combining_Homothetic_Above=843]="U_Combining_Homothetic_Above",o[o.U_Combining_Almost_Equal_To_Above=844]="U_Combining_Almost_Equal_To_Above",o[o.U_Combining_Left_Right_Arrow_Below=845]="U_Combining_Left_Right_Arrow_Below",o[o.U_Combining_Upwards_Arrow_Below=846]="U_Combining_Upwards_Arrow_Below",o[o.U_Combining_Grapheme_Joiner=847]="U_Combining_Grapheme_Joiner",o[o.U_Combining_Right_Arrowhead_Above=848]="U_Combining_Right_Arrowhead_Above",o[o.U_Combining_Left_Half_Ring_Above=849]="U_Combining_Left_Half_Ring_Above",o[o.U_Combining_Fermata=850]="U_Combining_Fermata",o[o.U_Combining_X_Below=851]="U_Combining_X_Below",o[o.U_Combining_Left_Arrowhead_Below=852]="U_Combining_Left_Arrowhead_Below",o[o.U_Combining_Right_Arrowhead_Below=853]="U_Combining_Right_Arrowhead_Below",o[o.U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below=854]="U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below",o[o.U_Combining_Right_Half_Ring_Above=855]="U_Combining_Right_Half_Ring_Above",o[o.U_Combining_Dot_Above_Right=856]="U_Combining_Dot_Above_Right",o[o.U_Combining_Asterisk_Below=857]="U_Combining_Asterisk_Below",o[o.U_Combining_Double_Ring_Below=858]="U_Combining_Double_Ring_Below",o[o.U_Combining_Zigzag_Above=859]="U_Combining_Zigzag_Above",o[o.U_Combining_Double_Breve_Below=860]="U_Combining_Double_Breve_Below",o[o.U_Combining_Double_Breve=861]="U_Combining_Double_Breve",o[o.U_Combining_Double_Macron=862]="U_Combining_Double_Macron",o[o.U_Combining_Double_Macron_Below=863]="U_Combining_Double_Macron_Below",o[o.U_Combining_Double_Tilde=864]="U_Combining_Double_Tilde",o[o.U_Combining_Double_Inverted_Breve=865]="U_Combining_Double_Inverted_Breve",o[o.U_Combining_Double_Rightwards_Arrow_Below=866]="U_Combining_Double_Rightwards_Arrow_Below",o[o.U_Combining_Latin_Small_Letter_A=867]="U_Combining_Latin_Small_Letter_A",o[o.U_Combining_Latin_Small_Letter_E=868]="U_Combining_Latin_Small_Letter_E",o[o.U_Combining_Latin_Small_Letter_I=869]="U_Combining_Latin_Small_Letter_I",o[o.U_Combining_Latin_Small_Letter_O=870]="U_Combining_Latin_Small_Letter_O",o[o.U_Combining_Latin_Small_Letter_U=871]="U_Combining_Latin_Small_Letter_U",o[o.U_Combining_Latin_Small_Letter_C=872]="U_Combining_Latin_Small_Letter_C",o[o.U_Combining_Latin_Small_Letter_D=873]="U_Combining_Latin_Small_Letter_D",o[o.U_Combining_Latin_Small_Letter_H=874]="U_Combining_Latin_Small_Letter_H",o[o.U_Combining_Latin_Small_Letter_M=875]="U_Combining_Latin_Small_Letter_M",o[o.U_Combining_Latin_Small_Letter_R=876]="U_Combining_Latin_Small_Letter_R",o[o.U_Combining_Latin_Small_Letter_T=877]="U_Combining_Latin_Small_Letter_T",o[o.U_Combining_Latin_Small_Letter_V=878]="U_Combining_Latin_Small_Letter_V",o[o.U_Combining_Latin_Small_Letter_X=879]="U_Combining_Latin_Small_Letter_X",o[o.LINE_SEPARATOR=8232]="LINE_SEPARATOR",o[o.PARAGRAPH_SEPARATOR=8233]="PARAGRAPH_SEPARATOR",o[o.NEXT_LINE=133]="NEXT_LINE",o[o.U_CIRCUMFLEX=94]="U_CIRCUMFLEX",o[o.U_GRAVE_ACCENT=96]="U_GRAVE_ACCENT",o[o.U_DIAERESIS=168]="U_DIAERESIS",o[o.U_MACRON=175]="U_MACRON",o[o.U_ACUTE_ACCENT=180]="U_ACUTE_ACCENT",o[o.U_CEDILLA=184]="U_CEDILLA",o[o.U_MODIFIER_LETTER_LEFT_ARROWHEAD=706]="U_MODIFIER_LETTER_LEFT_ARROWHEAD",o[o.U_MODIFIER_LETTER_RIGHT_ARROWHEAD=707]="U_MODIFIER_LETTER_RIGHT_ARROWHEAD",o[o.U_MODIFIER_LETTER_UP_ARROWHEAD=708]="U_MODIFIER_LETTER_UP_ARROWHEAD",o[o.U_MODIFIER_LETTER_DOWN_ARROWHEAD=709]="U_MODIFIER_LETTER_DOWN_ARROWHEAD",o[o.U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING=722]="U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING",o[o.U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING=723]="U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING",o[o.U_MODIFIER_LETTER_UP_TACK=724]="U_MODIFIER_LETTER_UP_TACK",o[o.U_MODIFIER_LETTER_DOWN_TACK=725]="U_MODIFIER_LETTER_DOWN_TACK",o[o.U_MODIFIER_LETTER_PLUS_SIGN=726]="U_MODIFIER_LETTER_PLUS_SIGN",o[o.U_MODIFIER_LETTER_MINUS_SIGN=727]="U_MODIFIER_LETTER_MINUS_SIGN",o[o.U_BREVE=728]="U_BREVE",o[o.U_DOT_ABOVE=729]="U_DOT_ABOVE",o[o.U_RING_ABOVE=730]="U_RING_ABOVE",o[o.U_OGONEK=731]="U_OGONEK",o[o.U_SMALL_TILDE=732]="U_SMALL_TILDE",o[o.U_DOUBLE_ACUTE_ACCENT=733]="U_DOUBLE_ACUTE_ACCENT",o[o.U_MODIFIER_LETTER_RHOTIC_HOOK=734]="U_MODIFIER_LETTER_RHOTIC_HOOK",o[o.U_MODIFIER_LETTER_CROSS_ACCENT=735]="U_MODIFIER_LETTER_CROSS_ACCENT",o[o.U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR=741]="U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR",o[o.U_MODIFIER_LETTER_HIGH_TONE_BAR=742]="U_MODIFIER_LETTER_HIGH_TONE_BAR",o[o.U_MODIFIER_LETTER_MID_TONE_BAR=743]="U_MODIFIER_LETTER_MID_TONE_BAR",o[o.U_MODIFIER_LETTER_LOW_TONE_BAR=744]="U_MODIFIER_LETTER_LOW_TONE_BAR",o[o.U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR=745]="U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR",o[o.U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK=746]="U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK",o[o.U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK=747]="U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK",o[o.U_MODIFIER_LETTER_UNASPIRATED=749]="U_MODIFIER_LETTER_UNASPIRATED",o[o.U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD=751]="U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD",o[o.U_MODIFIER_LETTER_LOW_UP_ARROWHEAD=752]="U_MODIFIER_LETTER_LOW_UP_ARROWHEAD",o[o.U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD=753]="U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD",o[o.U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD=754]="U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD",o[o.U_MODIFIER_LETTER_LOW_RING=755]="U_MODIFIER_LETTER_LOW_RING",o[o.U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT=756]="U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT",o[o.U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT=757]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT",o[o.U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT=758]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT",o[o.U_MODIFIER_LETTER_LOW_TILDE=759]="U_MODIFIER_LETTER_LOW_TILDE",o[o.U_MODIFIER_LETTER_RAISED_COLON=760]="U_MODIFIER_LETTER_RAISED_COLON",o[o.U_MODIFIER_LETTER_BEGIN_HIGH_TONE=761]="U_MODIFIER_LETTER_BEGIN_HIGH_TONE",o[o.U_MODIFIER_LETTER_END_HIGH_TONE=762]="U_MODIFIER_LETTER_END_HIGH_TONE",o[o.U_MODIFIER_LETTER_BEGIN_LOW_TONE=763]="U_MODIFIER_LETTER_BEGIN_LOW_TONE",o[o.U_MODIFIER_LETTER_END_LOW_TONE=764]="U_MODIFIER_LETTER_END_LOW_TONE",o[o.U_MODIFIER_LETTER_SHELF=765]="U_MODIFIER_LETTER_SHELF",o[o.U_MODIFIER_LETTER_OPEN_SHELF=766]="U_MODIFIER_LETTER_OPEN_SHELF",o[o.U_MODIFIER_LETTER_LOW_LEFT_ARROW=767]="U_MODIFIER_LETTER_LOW_LEFT_ARROW",o[o.U_GREEK_LOWER_NUMERAL_SIGN=885]="U_GREEK_LOWER_NUMERAL_SIGN",o[o.U_GREEK_TONOS=900]="U_GREEK_TONOS",o[o.U_GREEK_DIALYTIKA_TONOS=901]="U_GREEK_DIALYTIKA_TONOS",o[o.U_GREEK_KORONIS=8125]="U_GREEK_KORONIS",o[o.U_GREEK_PSILI=8127]="U_GREEK_PSILI",o[o.U_GREEK_PERISPOMENI=8128]="U_GREEK_PERISPOMENI",o[o.U_GREEK_DIALYTIKA_AND_PERISPOMENI=8129]="U_GREEK_DIALYTIKA_AND_PERISPOMENI",o[o.U_GREEK_PSILI_AND_VARIA=8141]="U_GREEK_PSILI_AND_VARIA",o[o.U_GREEK_PSILI_AND_OXIA=8142]="U_GREEK_PSILI_AND_OXIA",o[o.U_GREEK_PSILI_AND_PERISPOMENI=8143]="U_GREEK_PSILI_AND_PERISPOMENI",o[o.U_GREEK_DASIA_AND_VARIA=8157]="U_GREEK_DASIA_AND_VARIA",o[o.U_GREEK_DASIA_AND_OXIA=8158]="U_GREEK_DASIA_AND_OXIA",o[o.U_GREEK_DASIA_AND_PERISPOMENI=8159]="U_GREEK_DASIA_AND_PERISPOMENI",o[o.U_GREEK_DIALYTIKA_AND_VARIA=8173]="U_GREEK_DIALYTIKA_AND_VARIA",o[o.U_GREEK_DIALYTIKA_AND_OXIA=8174]="U_GREEK_DIALYTIKA_AND_OXIA",o[o.U_GREEK_VARIA=8175]="U_GREEK_VARIA",o[o.U_GREEK_OXIA=8189]="U_GREEK_OXIA",o[o.U_GREEK_DASIA=8190]="U_GREEK_DASIA",o[o.U_IDEOGRAPHIC_FULL_STOP=12290]="U_IDEOGRAPHIC_FULL_STOP",o[o.U_LEFT_CORNER_BRACKET=12300]="U_LEFT_CORNER_BRACKET",o[o.U_RIGHT_CORNER_BRACKET=12301]="U_RIGHT_CORNER_BRACKET",o[o.U_LEFT_BLACK_LENTICULAR_BRACKET=12304]="U_LEFT_BLACK_LENTICULAR_BRACKET",o[o.U_RIGHT_BLACK_LENTICULAR_BRACKET=12305]="U_RIGHT_BLACK_LENTICULAR_BRACKET",o[o.U_OVERLINE=8254]="U_OVERLINE",o[o.UTF8_BOM=65279]="UTF8_BOM",o[o.U_FULLWIDTH_SEMICOLON=65307]="U_FULLWIDTH_SEMICOLON",o[o.U_FULLWIDTH_COMMA=65292]="U_FULLWIDTH_COMMA"})(i||(e.CharCode=i={}))}),define(oe[139],ae([0,1]),function(V,e){"use strict";var i;Object.defineProperty(e,"__esModule",{value:!0}),e.$O=void 0,e.$K=o,e.$L=S,e.$M=D,e.$N=O;function o(y,a){const h=Object.create(null);for(const f of y){const g=a(f);let b=h[g];b||(b=h[g]=[]),b.push(f)}return h}function S(y,a){const h=[],f=[];for(const g of y)a.has(g)||h.push(g);for(const g of a)y.has(g)||f.push(g);return{removed:h,added:f}}function D(y,a){const h=[],f=[];for(const[g,b]of y)a.has(g)||h.push(b);for(const[g,b]of a)y.has(g)||f.push(b);return{removed:h,added:f}}function O(y,a){const h=new Set;for(const f of a)y.has(f)&&h.add(f);return h}class P{static{i=Symbol.toStringTag}constructor(a,h){this.b=h,this.a=new Map,this[i]="SetWithKey";for(const f of a)this.add(f)}get size(){return this.a.size}add(a){const h=this.b(a);return this.a.set(h,a),this}delete(a){return this.a.delete(this.b(a))}has(a){return this.a.has(this.b(a))}*entries(){for(const a of this.a.values())yield[a,a]}keys(){return this.values()}*values(){for(const a of this.a.values())yield a}clear(){this.a.clear()}forEach(a,h){this.a.forEach(f=>a.call(h,f,f,this))}[Symbol.iterator](){return this.values()}}e.$O=P}),define(oe[140],ae([0,1,39]),function(V,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gu=e.$fu=e.$eu=e.$du=void 0;function o(y,a){const h=Math.pow(10,a);return Math.round(y*h)/h}class S{constructor(a,h,f,g=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,a))|0,this.g=Math.min(255,Math.max(0,h))|0,this.b=Math.min(255,Math.max(0,f))|0,this.a=o(Math.max(Math.min(1,g),0),3)}static equals(a,h){return a.r===h.r&&a.g===h.g&&a.b===h.b&&a.a===h.a}}e.$du=S;class D{constructor(a,h,f,g){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,a),0)|0,this.s=o(Math.max(Math.min(1,h),0),3),this.l=o(Math.max(Math.min(1,f),0),3),this.a=o(Math.max(Math.min(1,g),0),3)}static equals(a,h){return a.h===h.h&&a.s===h.s&&a.l===h.l&&a.a===h.a}static fromRGBA(a){const h=a.r/255,f=a.g/255,g=a.b/255,b=a.a,l=Math.max(h,f,g),m=Math.min(h,f,g);let p=0,$=0;const w=(m+l)/2,v=l-m;if(v>0){switch($=Math.min(w<=.5?v/(2*w):v/(2-2*w),1),l){case h:p=(f-g)/v+(f<g?6:0);break;case f:p=(g-h)/v+2;break;case g:p=(h-f)/v+4;break}p*=60,p=Math.round(p)}return new D(p,$,w,b)}static i(a,h,f){return f<0&&(f+=1),f>1&&(f-=1),f<1/6?a+(h-a)*6*f:f<1/2?h:f<2/3?a+(h-a)*(2/3-f)*6:a}static toRGBA(a){const h=a.h/360,{s:f,l:g,a:b}=a;let l,m,p;if(f===0)l=m=p=g;else{const $=g<.5?g*(1+f):g+f-g*f,w=2*g-$;l=D.i(w,$,h+1/3),m=D.i(w,$,h),p=D.i(w,$,h-1/3)}return new S(Math.round(l*255),Math.round(m*255),Math.round(p*255),b)}}e.$eu=D;class O{constructor(a,h,f,g){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,a),0)|0,this.s=o(Math.max(Math.min(1,h),0),3),this.v=o(Math.max(Math.min(1,f),0),3),this.a=o(Math.max(Math.min(1,g),0),3)}static equals(a,h){return a.h===h.h&&a.s===h.s&&a.v===h.v&&a.a===h.a}static fromRGBA(a){const h=a.r/255,f=a.g/255,g=a.b/255,b=Math.max(h,f,g),l=Math.min(h,f,g),m=b-l,p=b===0?0:m/b;let $;return m===0?$=0:b===h?$=((f-g)/m%6+6)%6:b===f?$=(g-h)/m+2:$=(h-f)/m+4,new O(Math.round($*60),p,b,a.a)}static toRGBA(a){const{h,s:f,v:g,a:b}=a,l=g*f,m=l*(1-Math.abs(h/60%2-1)),p=g-l;let[$,w,v]=[0,0,0];return h<60?($=l,w=m):h<120?($=m,w=l):h<180?(w=l,v=m):h<240?(w=m,v=l):h<300?($=m,v=l):h<=360&&($=l,v=m),$=Math.round(($+p)*255),w=Math.round((w+p)*255),v=Math.round((v+p)*255),new S($,w,v,b)}}e.$fu=O;class P{static fromHex(a){return P.Format.CSS.parseHex(a)||P.red}static equals(a,h){return!a&&!h?!0:!a||!h?!1:a.equals(h)}get hsla(){return this.i?this.i:D.fromRGBA(this.rgba)}get hsva(){return this.j?this.j:O.fromRGBA(this.rgba)}constructor(a){if(a)if(a instanceof S)this.rgba=a;else if(a instanceof D)this.i=a,this.rgba=D.toRGBA(a);else if(a instanceof O)this.j=a,this.rgba=O.toRGBA(a);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(a){return!!a&&S.equals(this.rgba,a.rgba)&&D.equals(this.hsla,a.hsla)&&O.equals(this.hsva,a.hsva)}getRelativeLuminance(){const a=P.k(this.rgba.r),h=P.k(this.rgba.g),f=P.k(this.rgba.b),g=.2126*a+.7152*h+.0722*f;return o(g,4)}static k(a){const h=a/255;return h<=.03928?h/12.92:Math.pow((h+.055)/1.055,2.4)}getContrastRatio(a){const h=this.getRelativeLuminance(),f=a.getRelativeLuminance();return h>f?(h+.05)/(f+.05):(f+.05)/(h+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(a){const h=this.getRelativeLuminance(),f=a.getRelativeLuminance();return h>f}isDarkerThan(a){const h=this.getRelativeLuminance(),f=a.getRelativeLuminance();return h<f}lighten(a){return new P(new D(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*a,this.hsla.a))}darken(a){return new P(new D(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*a,this.hsla.a))}transparent(a){const{r:h,g:f,b:g,a:b}=this.rgba;return new P(new S(h,f,g,b*a))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new P(new S(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(a){const h=a.rgba,f=this.rgba.a,g=h.a,b=f+g*(1-f);if(b<1e-6)return P.transparent;const l=this.rgba.r*f/b+h.r*g*(1-f)/b,m=this.rgba.g*f/b+h.g*g*(1-f)/b,p=this.rgba.b*f/b+h.b*g*(1-f)/b;return new P(new S(l,m,p,b))}makeOpaque(a){if(this.isOpaque()||a.rgba.a!==1)return this;const{r:h,g:f,b:g,a:b}=this.rgba;return new P(new S(a.rgba.r-b*(a.rgba.r-h),a.rgba.g-b*(a.rgba.g-f),a.rgba.b-b*(a.rgba.b-g),1))}flatten(...a){const h=a.reduceRight((f,g)=>P.o(g,f));return P.o(this,h)}static o(a,h){const f=1-a.rgba.a;return new P(new S(f*h.rgba.r+a.rgba.a*a.rgba.r,f*h.rgba.g+a.rgba.a*a.rgba.g,f*h.rgba.b+a.rgba.a*a.rgba.b))}toString(){return this.u||(this.u=P.Format.CSS.format(this)),this.u}static getLighterColor(a,h,f){if(a.isLighterThan(h))return a;f=f||.5;const g=a.getRelativeLuminance(),b=h.getRelativeLuminance();return f=f*(b-g)/b,a.lighten(f)}static getDarkerColor(a,h,f){if(a.isDarkerThan(h))return a;f=f||.5;const g=a.getRelativeLuminance(),b=h.getRelativeLuminance();return f=f*(g-b)/g,a.darken(f)}static{this.white=new P(new S(255,255,255,1))}static{this.black=new P(new S(0,0,0,1))}static{this.red=new P(new S(255,0,0,1))}static{this.blue=new P(new S(0,0,255,1))}static{this.green=new P(new S(0,255,0,1))}static{this.cyan=new P(new S(0,255,255,1))}static{this.lightgrey=new P(new S(211,211,211,1))}static{this.transparent=new P(new S(0,0,0,0))}}e.$gu=P,function(y){let a;(function(h){let f;(function(g){function b(n){return n.rgba.a===1?`rgb(${n.rgba.r}, ${n.rgba.g}, ${n.rgba.b})`:y.Format.CSS.formatRGBA(n)}g.formatRGB=b;function l(n){return`rgba(${n.rgba.r}, ${n.rgba.g}, ${n.rgba.b}, ${+n.rgba.a.toFixed(2)})`}g.formatRGBA=l;function m(n){return n.hsla.a===1?`hsl(${n.hsla.h}, ${(n.hsla.s*100).toFixed(2)}%, ${(n.hsla.l*100).toFixed(2)}%)`:y.Format.CSS.formatHSLA(n)}g.formatHSL=m;function p(n){return`hsla(${n.hsla.h}, ${(n.hsla.s*100).toFixed(2)}%, ${(n.hsla.l*100).toFixed(2)}%, ${n.hsla.a.toFixed(2)})`}g.formatHSLA=p;function $(n){const c=n.toString(16);return c.length!==2?"0"+c:c}function w(n){return`#${$(n.rgba.r)}${$(n.rgba.g)}${$(n.rgba.b)}`}g.formatHex=w;function v(n,c=!1){return c&&n.rgba.a===1?y.Format.CSS.formatHex(n):`#${$(n.rgba.r)}${$(n.rgba.g)}${$(n.rgba.b)}${$(Math.round(n.rgba.a*255))}`}g.formatHexA=v;function k(n){return n.isOpaque()?y.Format.CSS.formatHex(n):y.Format.CSS.formatRGBA(n)}g.format=k;function t(n){const c=n.length;if(c===0||n.charCodeAt(0)!==i.CharCode.Hash)return null;if(c===7){const s=16*r(n.charCodeAt(1))+r(n.charCodeAt(2)),u=16*r(n.charCodeAt(3))+r(n.charCodeAt(4)),d=16*r(n.charCodeAt(5))+r(n.charCodeAt(6));return new y(new S(s,u,d,1))}if(c===9){const s=16*r(n.charCodeAt(1))+r(n.charCodeAt(2)),u=16*r(n.charCodeAt(3))+r(n.charCodeAt(4)),d=16*r(n.charCodeAt(5))+r(n.charCodeAt(6)),I=16*r(n.charCodeAt(7))+r(n.charCodeAt(8));return new y(new S(s,u,d,I/255))}if(c===4){const s=r(n.charCodeAt(1)),u=r(n.charCodeAt(2)),d=r(n.charCodeAt(3));return new y(new S(16*s+s,16*u+u,16*d+d))}if(c===5){const s=r(n.charCodeAt(1)),u=r(n.charCodeAt(2)),d=r(n.charCodeAt(3)),I=r(n.charCodeAt(4));return new y(new S(16*s+s,16*u+u,16*d+d,(16*I+I)/255))}return null}g.parseHex=t;function r(n){switch(n){case i.CharCode.Digit0:return 0;case i.CharCode.Digit1:return 1;case i.CharCode.Digit2:return 2;case i.CharCode.Digit3:return 3;case i.CharCode.Digit4:return 4;case i.CharCode.Digit5:return 5;case i.CharCode.Digit6:return 6;case i.CharCode.Digit7:return 7;case i.CharCode.Digit8:return 8;case i.CharCode.Digit9:return 9;case i.CharCode.a:return 10;case i.CharCode.A:return 10;case i.CharCode.b:return 11;case i.CharCode.B:return 11;case i.CharCode.c:return 12;case i.CharCode.C:return 12;case i.CharCode.d:return 13;case i.CharCode.D:return 13;case i.CharCode.e:return 14;case i.CharCode.E:return 14;case i.CharCode.f:return 15;case i.CharCode.F:return 15}return 0}})(f=h.CSS||(h.CSS={}))})(a=y.Format||(y.Format={}))}(P||(e.$gu=P={}))}),define(oe[52],ae([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0h=o,e.$$h=S,e.$_h=D;function i(O){return(P,y,a)=>{let h=null,f=null;if(typeof a.value=="function"?(h="value",f=a.value):typeof a.get=="function"&&(h="get",f=a.get),!f)throw new Error("not supported");a[h]=O(f,y)}}function o(O,P,y){let a=null,h=null;if(typeof y.value=="function"?(a="value",h=y.value,h.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof y.get=="function"&&(a="get",h=y.get),!h)throw new Error("not supported");const f=`$memoize$${P}`;y[a]=function(...g){return this.hasOwnProperty(f)||Object.defineProperty(this,f,{configurable:!1,enumerable:!1,writable:!1,value:h.apply(this,g)}),this[f]}}function S(O,P,y){return i((a,h)=>{const f=`$debounce$${h}`,g=`$debounce$result$${h}`;return function(...b){this[g]||(this[g]=y?y():void 0),clearTimeout(this[f]),P&&(this[g]=P(this[g],...b),b=[this[g]]),this[f]=setTimeout(()=>{a.apply(this,b),this[g]=y?y():void 0},O)}})}function D(O,P,y){return i((a,h)=>{const f=`$throttle$timer$${h}`,g=`$throttle$result$${h}`,b=`$throttle$lastRun$${h}`,l=`$throttle$pending$${h}`;return function(...m){if(this[g]||(this[g]=y?y():void 0),(this[b]===null||this[b]===void 0)&&(this[b]=-Number.MAX_VALUE),P&&(this[g]=P(this[g],...m)),this[l])return;const p=this[b]+O;p<=Date.now()?(this[b]=Date.now(),a.apply(this,[this[g]]),this[g]=y?y():void 0):(this[l]=!0,this[f]=setTimeout(()=>{this[l]=!1,this[b]=Date.now(),a.apply(this,[this[g]]),this[g]=y?y():void 0},p-Date.now()))}})}}),define(oe[16],ae([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eb=e.$db=e.$cb=e.$bb=e.$ab=e.$$=e.$7=e.$Z=e.$Y=void 0,e.setUnexpectedErrorHandler=o,e.$2=S,e.$3=D,e.$4=O,e.$5=P,e.$6=a,e.$8=f,e.$9=g,e.$0=b,e.$_=m;class i{constructor(){this.b=[],this.a=function(r){setTimeout(()=>{throw r.stack?v.isErrorNoTelemetry(r)?new v(r.message+`

`+r.stack):new Error(r.message+`

`+r.stack):r},0)}}addListener(r){return this.b.push(r),()=>{this.d(r)}}c(r){this.b.forEach(n=>{n(r)})}d(r){this.b.splice(this.b.indexOf(r),1)}setUnexpectedErrorHandler(r){this.a=r}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(r){this.a(r),this.c(r)}onUnexpectedExternalError(r){this.a(r)}}e.$Y=i,e.$Z=new i;function o(t){e.$Z.setUnexpectedErrorHandler(t)}function S(t){if(!t||typeof t!="object")return!1;const r=t;return r.code==="EPIPE"&&r.syscall?.toUpperCase()==="WRITE"}function D(t){a(t)||e.$Z.onUnexpectedError(t)}function O(t){a(t)||e.$Z.onUnexpectedExternalError(t)}function P(t){if(t instanceof Error){const{name:r,message:n}=t,c=t.stacktrace||t.stack;return{$isError:!0,name:r,message:n,stack:c,noTelemetry:v.isErrorNoTelemetry(t)}}return t}const y="Canceled";function a(t){return t instanceof h?!0:t instanceof Error&&t.name===y&&t.message===y}class h extends Error{constructor(){super(y),this.name=this.message}}e.$7=h;function f(){const t=new Error(y);return t.name=t.message,t}function g(t){return t?new Error(`Illegal argument: ${t}`):new Error("Illegal argument")}function b(t){return t?new Error(`Illegal state: ${t}`):new Error("Illegal state")}class l extends TypeError{constructor(r){super(r?`${r} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$$=l;function m(t){return t?t.message?t.message:t.stack?t.stack.split(`
`)[0]:String(t):"Error"}class p extends Error{constructor(r){super("NotImplemented"),r&&(this.message=r)}}e.$ab=p;class $ extends Error{constructor(r){super("NotSupported"),r&&(this.message=r)}}e.$bb=$;class w extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$cb=w;class v extends Error{constructor(r){super(r),this.name="CodeExpectedError"}static fromError(r){if(r instanceof v)return r;const n=new v;return n.message=r.message,n.stack=r.stack,n}static isErrorNoTelemetry(r){return r.name==="CodeExpectedError"}}e.$db=v;class k extends Error{constructor(r){super(r||"An unexpected bug occurred."),Object.setPrototypeOf(this,k.prototype)}}e.$eb=k}),define(oe[22],ae([0,1,16,138]),function(V,e,i,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cc=e.$bc=e.$ac=e.$$b=e.$0b=e.CompareResult=void 0,e.$ub=S,e.$vb=D,e.$wb=O,e.$xb=P,e.$yb=y,e.$zb=a,e.$Ab=h,e.$Bb=f,e.$Cb=g,e.$Db=b,e.$Eb=l,e.$Fb=m,e.$Gb=p,e.top=$,e.$Ib=w,e.$Jb=k,e.$Kb=t,e.$Lb=r,e.$Mb=n,e.$Nb=c,e.$Ob=s,e.$Pb=u,e.$Qb=d,e.$Rb=I,e.$Sb=E,e.$Tb=A,e.$Ub=T,e.$Vb=L,e.$Wb=R,e.$Xb=M,e.$Yb=U,e.$Zb=N,e.$1b=z,e.$2b=ne,e.$3b=Q,e.$4b=le,e.$5b=K,e.$6b=ee,e.$7b=H,e.$8b=x,e.$9b=ce,e.$_b=se;function S(W,q=0){return W[W.length-(1+q)]}function D(W){if(W.length===0)throw new Error("Invalid tail call");return[W.slice(0,W.length-1),W[W.length-1]]}function O(W,q,J=(X,Z)=>X===Z){if(W===q)return!0;if(!W||!q||W.length!==q.length)return!1;for(let X=0,Z=W.length;X<Z;X++)if(!J(W[X],q[X]))return!1;return!0}function P(W,q){const J=W.length-1;q<J&&(W[q]=W[J]),W.pop()}function y(W,q,J){return a(W.length,X=>J(W[X],q))}function a(W,q){let J=0,X=W-1;for(;J<=X;){const Z=(J+X)/2|0,ie=q(Z);if(ie<0)J=Z+1;else if(ie>0)X=Z-1;else return Z}return-(J+1)}function h(W,q,J){if(W=W|0,W>=q.length)throw new TypeError("invalid index");const X=q[Math.floor(q.length*Math.random())],Z=[],ie=[],de=[];for(const me of q){const pe=J(me,X);pe<0?Z.push(me):pe>0?ie.push(me):de.push(me)}return W<Z.length?h(W,Z,J):W<Z.length+de.length?de[0]:h(W-(Z.length+de.length),ie,J)}function f(W,q){const J=[];let X;for(const Z of W.slice(0).sort(q))!X||q(X[0],Z)!==0?(X=[Z],J.push(X)):X.push(Z);return J}function*g(W,q){let J,X;for(const Z of W)X!==void 0&&q(X,Z)?J.push(Z):(J&&(yield J),J=[Z]),X=Z;J&&(yield J)}function b(W,q){for(let J=0;J<=W.length;J++)q(J===0?void 0:W[J-1],J===W.length?void 0:W[J])}function l(W,q){for(let J=0;J<W.length;J++)q(J===0?void 0:W[J-1],W[J],J+1===W.length?void 0:W[J+1])}function m(W,q,J){const X=[];function Z(me,pe,Ie){if(pe===0&&Ie.length===0)return;const ke=X[X.length-1];ke&&ke.start+ke.deleteCount===me?(ke.deleteCount+=pe,ke.toInsert.push(...Ie)):X.push({start:me,deleteCount:pe,toInsert:Ie})}let ie=0,de=0;for(;;){if(ie===W.length){Z(ie,0,q.slice(de));break}if(de===q.length){Z(ie,W.length-ie,[]);break}const me=W[ie],pe=q[de],Ie=J(me,pe);Ie===0?(ie+=1,de+=1):Ie<0?(Z(ie,1,[]),ie+=1):Ie>0&&(Z(ie,0,[pe]),de+=1)}return X}function p(W,q,J){const X=m(W,q,J),Z=[],ie=[];for(const de of X)Z.push(...W.slice(de.start,de.start+de.deleteCount)),ie.push(...de.toInsert);return{removed:Z,added:ie}}function $(W,q,J){if(J===0)return[];const X=W.slice(0,J).sort(q);return v(W,q,X,J,W.length),X}function w(W,q,J,X,Z){return J===0?Promise.resolve([]):new Promise((ie,de)=>{(async()=>{const me=W.length,pe=W.slice(0,J).sort(q);for(let Ie=J,ke=Math.min(J+X,me);Ie<me;Ie=ke,ke=Math.min(ke+X,me)){if(Ie>J&&await new Promise(Pe=>setTimeout(Pe)),Z&&Z.isCancellationRequested)throw new i.$7;v(W,q,pe,Ie,ke)}return pe})().then(ie,de)})}function v(W,q,J,X,Z){for(const ie=J.length;X<Z;X++){const de=W[X];if(q(de,J[ie-1])<0){J.pop();const me=(0,o.$mb)(J,pe=>q(de,pe)<0);J.splice(me,0,de)}}}function k(W){return W.filter(q=>!!q)}function t(W){let q=0;for(let J=0;J<W.length;J++)W[J]&&(W[q]=W[J],q+=1);W.length=q}function r(W,q,J){W.splice(J,0,W.splice(q,1)[0])}function n(W){return!Array.isArray(W)||W.length===0}function c(W){return Array.isArray(W)&&W.length>0}function s(W,q=J=>J){const J=new Set;return W.filter(X=>{const Z=q(X);return J.has(Z)?!1:(J.add(Z),!0)})}function u(W){const q=new Set;return J=>{const X=W(J);return q.has(X)?!1:(q.add(X),!0)}}function d(W,q){return W.length>0?W[0]:q}function I(W,q){return W.length>0?W[W.length-1]:q}function E(W,q,J=(X,Z)=>X===Z){let X=0;for(let Z=0,ie=Math.min(W.length,q.length);Z<ie&&J(W[Z],q[Z]);Z++)X++;return X}function A(W,q){let J=typeof q=="number"?W:0;typeof q=="number"?J=W:(J=0,q=W);const X=[];if(J<=q)for(let Z=J;Z<q;Z++)X.push(Z);else for(let Z=J;Z>q;Z--)X.push(Z);return X}function T(W,q,J){return W.reduce((X,Z)=>(X[q(Z)]=J?J(Z):Z,X),Object.create(null))}function L(W,q){return W.push(q),()=>R(W,q)}function R(W,q){const J=W.indexOf(q);if(J>-1)return W.splice(J,1),q}function M(W,q,J){const X=W.slice(0,q),Z=W.slice(q);return X.concat(J,Z)}function U(W,q){let J;if(typeof q=="number"){let X=q;J=()=>{const Z=Math.sin(X++)*179426549;return Z-Math.floor(Z)}}else J=Math.random;for(let X=W.length-1;X>0;X-=1){const Z=Math.floor(J()*(X+1)),ie=W[X];W[X]=W[Z],W[Z]=ie}}function N(W,q){const J=W.indexOf(q);J>-1&&(W.splice(J,1),W.unshift(q))}function z(W,q){const J=W.indexOf(q);J>-1&&(W.splice(J,1),W.push(q))}function ne(W,q){for(const J of q)W.push(J)}function Q(W,q){return Array.isArray(W)?W.map(q):q(W)}function le(W){return Array.isArray(W)?W:[W]}function K(W){return W[Math.floor(Math.random()*W.length)]}function ee(W,q,J){const X=j(W,q),Z=W.length,ie=J.length;W.length=Z+ie;for(let de=Z-1;de>=X;de--)W[de+ie]=W[de];for(let de=0;de<ie;de++)W[de+X]=J[de]}function H(W,q,J,X){const Z=j(W,q);let ie=W.splice(Z,J);return ie===void 0&&(ie=[]),ee(W,Z,X),ie}function j(W,q){return q<0?Math.max(q+W.length,0):Math.min(q,W.length)}var B;(function(W){function q(ie){return ie<0}W.isLessThan=q;function J(ie){return ie<=0}W.isLessThanOrEqual=J;function X(ie){return ie>0}W.isGreaterThan=X;function Z(ie){return ie===0}W.isNeitherLessOrGreaterThan=Z,W.greaterThan=1,W.lessThan=-1,W.neitherLessOrGreaterThan=0})(B||(e.CompareResult=B={}));function x(W,q){return(J,X)=>q(W(J),W(X))}function ce(...W){return(q,J)=>{for(const X of W){const Z=X(q,J);if(!B.isNeitherLessOrGreaterThan(Z))return Z}return B.neitherLessOrGreaterThan}}const G=(W,q)=>W-q;e.$0b=G;const he=(W,q)=>(0,e.$0b)(W?1:0,q?1:0);e.$$b=he;function se(W){return(q,J)=>-W(q,J)}class _{constructor(q){this.g=q,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(q){let J=this.c;for(;J<this.g.length&&q(this.g[J]);)J++;const X=J===this.c?null:this.g.slice(this.c,J);return this.c=J,X}takeFromEndWhile(q){let J=this.d;for(;J>=0&&q(this.g[J]);)J--;const X=J===this.d?null:this.g.slice(J+1,this.d+1);return this.d=J,X}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const q=this.g[this.c];return this.c++,q}removeLast(){const q=this.g[this.d];return this.d--,q}takeCount(q){const J=this.g.slice(this.c,this.c+q);return this.c+=q,J}}e.$ac=_;class F{static{this.empty=new F(q=>{})}constructor(q){this.iterate=q}forEach(q){this.iterate(J=>(q(J),!0))}toArray(){const q=[];return this.iterate(J=>(q.push(J),!0)),q}filter(q){return new F(J=>this.iterate(X=>q(X)?J(X):!0))}map(q){return new F(J=>this.iterate(X=>J(q(X))))}some(q){let J=!1;return this.iterate(X=>(J=q(X),!J)),J}findFirst(q){let J;return this.iterate(X=>q(X)?(J=X,!1):!0),J}findLast(q){let J;return this.iterate(X=>(q(X)&&(J=X),!0)),J}findLastMaxBy(q){let J,X=!0;return this.iterate(Z=>((X||B.isGreaterThan(q(Z,J)))&&(X=!1,J=Z),!0)),J}}e.$bc=F;class C{constructor(q){this.c=q}static createSortPermutation(q,J){const X=Array.from(q.keys()).sort((Z,ie)=>J(q[Z],q[ie]));return new C(X)}apply(q){return q.map((J,X)=>q[this.c[X]])}inverse(){const q=this.c.slice();for(let J=0;J<this.c.length;J++)q[this.c[J]]=J;return new C(q)}}e.$cc=C}),define(oe[141],ae([0,1,16]),function(V,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=o,e.$gd=S,e.$hd=D,e.$id=O,e.$jd=P,e.$kd=y;function o(a,h){if(!a)throw new Error(h?`Assertion failed (${h})`:"Assertion Failed")}function S(a,h="Unreachable"){throw new Error(h)}function D(a,h="unexpected state"){if(!a)throw new i.$eb(`Assertion Failed: ${h}`)}function O(a){a||(0,i.$3)(new i.$eb("Soft Assertion Failed"))}function P(a){if(!a()){debugger;a(),(0,i.$3)(new i.$eb("Assertion Failed"))}}function y(a,h){let f=0;for(;f<a.length-1;){const g=a[f],b=a[f+1];if(!h(g,b))return!1;f++}return!0}}),define(oe[89],ae([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fb=i;function i(o,S){const D=this;let O=!1,P;return function(){if(O)return P;if(O=!0,S)try{P=o.apply(D,arguments)}finally{S()}else P=o.apply(D,arguments);return P}}}),define(oe[76],ae([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var i;(function(o){function S(n){return n&&typeof n=="object"&&typeof n[Symbol.iterator]=="function"}o.is=S;const D=Object.freeze([]);function O(){return D}o.empty=O;function*P(n){yield n}o.single=P;function y(n){return S(n)?n:P(n)}o.wrap=y;function a(n){return n||D}o.from=a;function*h(n){for(let c=n.length-1;c>=0;c--)yield n[c]}o.reverse=h;function f(n){return!n||n[Symbol.iterator]().next().done===!0}o.isEmpty=f;function g(n){return n[Symbol.iterator]().next().value}o.first=g;function b(n,c){let s=0;for(const u of n)if(c(u,s++))return!0;return!1}o.some=b;function l(n,c){for(const s of n)if(c(s))return s}o.find=l;function*m(n,c){for(const s of n)c(s)&&(yield s)}o.filter=m;function*p(n,c){let s=0;for(const u of n)yield c(u,s++)}o.map=p;function*$(n,c){let s=0;for(const u of n)yield*c(u,s++)}o.flatMap=$;function*w(...n){for(const c of n)yield*c}o.concat=w;function v(n,c,s){let u=s;for(const d of n)u=c(u,d);return u}o.reduce=v;function*k(n,c,s=n.length){for(c<0&&(c+=n.length),s<0?s+=n.length:s>n.length&&(s=n.length);c<s;c++)yield n[c]}o.slice=k;function t(n,c=Number.POSITIVE_INFINITY){const s=[];if(c===0)return[s,n];const u=n[Symbol.iterator]();for(let d=0;d<c;d++){const I=u.next();if(I.done)return[s,o.empty()];s.push(I.value)}return[s,{[Symbol.iterator](){return u}}]}o.consume=t;async function r(n){const c=[];for await(const s of n)c.push(s);return Promise.resolve(c)}o.asyncToArray=r})(i||(e.Iterable=i={}))}),define(oe[43],ae([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0,e.$Tn=O,e.$Un=f,e.$Vn=g,e.$Wn=b,e.$Xn=l,e.$Yn=m,e.$Zn=p,e.$1n=$,e.$2n=w,e.$3n=v,e.$4n=k;var i;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(i||(e.ScanError=i={}));var o;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(o||(e.SyntaxKind=o={}));var S;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(S||(e.ParseErrorCode=S={}));var D;(function(t){t.DEFAULT={allowTrailingComma:!0}})(D||(e.ParseOptions=D={}));function O(t,r=!1){let n=0;const c=t.length;let s="",u=0,d=o.Unknown,I=i.None;function E(N){let z=0,ne=0;for(;z<N;){const Q=t.charCodeAt(n);if(Q>=h._0&&Q<=h._9)ne=ne*16+Q-h._0;else if(Q>=h.A&&Q<=h.F)ne=ne*16+Q-h.A+10;else if(Q>=h.a&&Q<=h.f)ne=ne*16+Q-h.a+10;else break;n++,z++}return z<N&&(ne=-1),ne}function A(N){n=N,s="",u=0,d=o.Unknown,I=i.None}function T(){const N=n;if(t.charCodeAt(n)===h._0)n++;else for(n++;n<t.length&&a(t.charCodeAt(n));)n++;if(n<t.length&&t.charCodeAt(n)===h.dot)if(n++,n<t.length&&a(t.charCodeAt(n)))for(n++;n<t.length&&a(t.charCodeAt(n));)n++;else return I=i.UnexpectedEndOfNumber,t.substring(N,n);let z=n;if(n<t.length&&(t.charCodeAt(n)===h.E||t.charCodeAt(n)===h.e))if(n++,(n<t.length&&t.charCodeAt(n)===h.plus||t.charCodeAt(n)===h.minus)&&n++,n<t.length&&a(t.charCodeAt(n))){for(n++;n<t.length&&a(t.charCodeAt(n));)n++;z=n}else I=i.UnexpectedEndOfNumber;return t.substring(N,z)}function L(){let N="",z=n;for(;;){if(n>=c){N+=t.substring(z,n),I=i.UnexpectedEndOfString;break}const ne=t.charCodeAt(n);if(ne===h.doubleQuote){N+=t.substring(z,n),n++;break}if(ne===h.backslash){if(N+=t.substring(z,n),n++,n>=c){I=i.UnexpectedEndOfString;break}switch(t.charCodeAt(n++)){case h.doubleQuote:N+='"';break;case h.backslash:N+="\\";break;case h.slash:N+="/";break;case h.b:N+="\b";break;case h.f:N+="\f";break;case h.n:N+=`
`;break;case h.r:N+="\r";break;case h.t:N+="	";break;case h.u:{const le=E(4);le>=0?N+=String.fromCharCode(le):I=i.InvalidUnicode;break}default:I=i.InvalidEscapeCharacter}z=n;continue}if(ne>=0&&ne<=31)if(y(ne)){N+=t.substring(z,n),I=i.UnexpectedEndOfString;break}else I=i.InvalidCharacter;n++}return N}function R(){if(s="",I=i.None,u=n,n>=c)return u=c,d=o.EOF;let N=t.charCodeAt(n);if(P(N)){do n++,s+=String.fromCharCode(N),N=t.charCodeAt(n);while(P(N));return d=o.Trivia}if(y(N))return n++,s+=String.fromCharCode(N),N===h.carriageReturn&&t.charCodeAt(n)===h.lineFeed&&(n++,s+=`
`),d=o.LineBreakTrivia;switch(N){case h.openBrace:return n++,d=o.OpenBraceToken;case h.closeBrace:return n++,d=o.CloseBraceToken;case h.openBracket:return n++,d=o.OpenBracketToken;case h.closeBracket:return n++,d=o.CloseBracketToken;case h.colon:return n++,d=o.ColonToken;case h.comma:return n++,d=o.CommaToken;case h.doubleQuote:return n++,s=L(),d=o.StringLiteral;case h.slash:{const z=n-1;if(t.charCodeAt(n+1)===h.slash){for(n+=2;n<c&&!y(t.charCodeAt(n));)n++;return s=t.substring(z,n),d=o.LineCommentTrivia}if(t.charCodeAt(n+1)===h.asterisk){n+=2;const ne=c-1;let Q=!1;for(;n<ne;){if(t.charCodeAt(n)===h.asterisk&&t.charCodeAt(n+1)===h.slash){n+=2,Q=!0;break}n++}return Q||(n++,I=i.UnexpectedEndOfComment),s=t.substring(z,n),d=o.BlockCommentTrivia}return s+=String.fromCharCode(N),n++,d=o.Unknown}case h.minus:if(s+=String.fromCharCode(N),n++,n===c||!a(t.charCodeAt(n)))return d=o.Unknown;case h._0:case h._1:case h._2:case h._3:case h._4:case h._5:case h._6:case h._7:case h._8:case h._9:return s+=T(),d=o.NumericLiteral;default:for(;n<c&&M(N);)n++,N=t.charCodeAt(n);if(u!==n){switch(s=t.substring(u,n),s){case"true":return d=o.TrueKeyword;case"false":return d=o.FalseKeyword;case"null":return d=o.NullKeyword}return d=o.Unknown}return s+=String.fromCharCode(N),n++,d=o.Unknown}}function M(N){if(P(N)||y(N))return!1;switch(N){case h.closeBrace:case h.closeBracket:case h.openBrace:case h.openBracket:case h.doubleQuote:case h.colon:case h.comma:case h.slash:return!1}return!0}function U(){let N;do N=R();while(N>=o.LineCommentTrivia&&N<=o.Trivia);return N}return{setPosition:A,getPosition:()=>n,scan:r?U:R,getToken:()=>d,getTokenValue:()=>s,getTokenOffset:()=>u,getTokenLength:()=>n-u,getTokenError:()=>I}}function P(t){return t===h.space||t===h.tab||t===h.verticalTab||t===h.formFeed||t===h.nonBreakingSpace||t===h.ogham||t>=h.enQuad&&t<=h.zeroWidthSpace||t===h.narrowNoBreakSpace||t===h.mathematicalSpace||t===h.ideographicSpace||t===h.byteOrderMark}function y(t){return t===h.lineFeed||t===h.carriageReturn||t===h.lineSeparator||t===h.paragraphSeparator}function a(t){return t>=h._0&&t<=h._9}var h;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(h||(h={}));function f(t,r){const n=[],c=new Object;let s;const u={value:{},offset:0,length:0,type:"object",parent:void 0};let d=!1;function I(E,A,T,L){u.value=E,u.offset=A,u.length=T,u.type=L,u.colonOffset=void 0,s=u}try{v(t,{onObjectBegin:(E,A)=>{if(r<=E)throw c;s=void 0,d=r>E,n.push("")},onObjectProperty:(E,A,T)=>{if(r<A||(I(E,A,T,"property"),n[n.length-1]=E,r<=A+T))throw c},onObjectEnd:(E,A)=>{if(r<=E)throw c;s=void 0,n.pop()},onArrayBegin:(E,A)=>{if(r<=E)throw c;s=void 0,n.push(0)},onArrayEnd:(E,A)=>{if(r<=E)throw c;s=void 0,n.pop()},onLiteralValue:(E,A,T)=>{if(r<A||(I(E,A,T,k(E)),r<=A+T))throw c},onSeparator:(E,A,T)=>{if(r<=A)throw c;if(E===":"&&s&&s.type==="property")s.colonOffset=A,d=!1,s=void 0;else if(E===","){const L=n[n.length-1];typeof L=="number"?n[n.length-1]=L+1:(d=!0,n[n.length-1]=""),s=void 0}}})}catch(E){if(E!==c)throw E}return{path:n,previousNode:s,isAtPropertyKey:d,matches:E=>{let A=0;for(let T=0;A<E.length&&T<n.length;T++)if(E[A]===n[T]||E[A]==="*")A++;else if(E[A]!=="**")return!1;return A===E.length}}}function g(t,r=[],n=D.DEFAULT){let c=null,s=[];const u=[];function d(E){Array.isArray(s)?s.push(E):c!==null&&(s[c]=E)}return v(t,{onObjectBegin:()=>{const E={};d(E),u.push(s),s=E,c=null},onObjectProperty:E=>{c=E},onObjectEnd:()=>{s=u.pop()},onArrayBegin:()=>{const E=[];d(E),u.push(s),s=E,c=null},onArrayEnd:()=>{s=u.pop()},onLiteralValue:d,onError:(E,A,T)=>{r.push({error:E,offset:A,length:T})}},n),s[0]}function b(t,r=[],n=D.DEFAULT){let c={type:"array",offset:-1,length:-1,children:[],parent:void 0};function s(E){c.type==="property"&&(c.length=E-c.offset,c=c.parent)}function u(E){return c.children.push(E),E}v(t,{onObjectBegin:E=>{c=u({type:"object",offset:E,length:-1,parent:c,children:[]})},onObjectProperty:(E,A,T)=>{c=u({type:"property",offset:A,length:-1,parent:c,children:[]}),c.children.push({type:"string",value:E,offset:A,length:T,parent:c})},onObjectEnd:(E,A)=>{c.length=E+A-c.offset,c=c.parent,s(E+A)},onArrayBegin:(E,A)=>{c=u({type:"array",offset:E,length:-1,parent:c,children:[]})},onArrayEnd:(E,A)=>{c.length=E+A-c.offset,c=c.parent,s(E+A)},onLiteralValue:(E,A,T)=>{u({type:k(E),offset:A,length:T,parent:c,value:E}),s(A+T)},onSeparator:(E,A,T)=>{c.type==="property"&&(E===":"?c.colonOffset=A:E===","&&s(A))},onError:(E,A,T)=>{r.push({error:E,offset:A,length:T})}},n);const I=c.children[0];return I&&delete I.parent,I}function l(t,r){if(!t)return;let n=t;for(const c of r)if(typeof c=="string"){if(n.type!=="object"||!Array.isArray(n.children))return;let s=!1;for(const u of n.children)if(Array.isArray(u.children)&&u.children[0].value===c){n=u.children[1],s=!0;break}if(!s)return}else{const s=c;if(n.type!=="array"||s<0||!Array.isArray(n.children)||s>=n.children.length)return;n=n.children[s]}return n}function m(t){if(!t.parent||!t.parent.children)return[];const r=m(t.parent);if(t.parent.type==="property"){const n=t.parent.children[0].value;r.push(n)}else if(t.parent.type==="array"){const n=t.parent.children.indexOf(t);n!==-1&&r.push(n)}return r}function p(t){switch(t.type){case"array":return t.children.map(p);case"object":{const r=Object.create(null);for(const n of t.children){const c=n.children[1];c&&(r[n.children[0].value]=p(c))}return r}case"null":case"string":case"number":case"boolean":return t.value;default:return}}function $(t,r,n=!1){return r>=t.offset&&r<t.offset+t.length||n&&r===t.offset+t.length}function w(t,r,n=!1){if($(t,r,n)){const c=t.children;if(Array.isArray(c))for(let s=0;s<c.length&&c[s].offset<=r;s++){const u=w(c[s],r,n);if(u)return u}return t}}function v(t,r,n=D.DEFAULT){const c=O(t,!1);function s(x){return x?()=>x(c.getTokenOffset(),c.getTokenLength()):()=>!0}function u(x){return x?ce=>x(ce,c.getTokenOffset(),c.getTokenLength()):()=>!0}const d=s(r.onObjectBegin),I=u(r.onObjectProperty),E=s(r.onObjectEnd),A=s(r.onArrayBegin),T=s(r.onArrayEnd),L=u(r.onLiteralValue),R=u(r.onSeparator),M=s(r.onComment),U=u(r.onError),N=n&&n.disallowComments,z=n&&n.allowTrailingComma;function ne(){for(;;){const x=c.scan();switch(c.getTokenError()){case i.InvalidUnicode:Q(S.InvalidUnicode);break;case i.InvalidEscapeCharacter:Q(S.InvalidEscapeCharacter);break;case i.UnexpectedEndOfNumber:Q(S.UnexpectedEndOfNumber);break;case i.UnexpectedEndOfComment:N||Q(S.UnexpectedEndOfComment);break;case i.UnexpectedEndOfString:Q(S.UnexpectedEndOfString);break;case i.InvalidCharacter:Q(S.InvalidCharacter);break}switch(x){case o.LineCommentTrivia:case o.BlockCommentTrivia:N?Q(S.InvalidCommentToken):M();break;case o.Unknown:Q(S.InvalidSymbol);break;case o.Trivia:case o.LineBreakTrivia:break;default:return x}}}function Q(x,ce=[],G=[]){if(U(x),ce.length+G.length>0){let he=c.getToken();for(;he!==o.EOF;){if(ce.indexOf(he)!==-1){ne();break}else if(G.indexOf(he)!==-1)break;he=ne()}}}function le(x){const ce=c.getTokenValue();return x?L(ce):I(ce),ne(),!0}function K(){switch(c.getToken()){case o.NumericLiteral:{let x=0;try{x=JSON.parse(c.getTokenValue()),typeof x!="number"&&(Q(S.InvalidNumberFormat),x=0)}catch{Q(S.InvalidNumberFormat)}L(x);break}case o.NullKeyword:L(null);break;case o.TrueKeyword:L(!0);break;case o.FalseKeyword:L(!1);break;default:return!1}return ne(),!0}function ee(){return c.getToken()!==o.StringLiteral?(Q(S.PropertyNameExpected,[],[o.CloseBraceToken,o.CommaToken]),!1):(le(!1),c.getToken()===o.ColonToken?(R(":"),ne(),B()||Q(S.ValueExpected,[],[o.CloseBraceToken,o.CommaToken])):Q(S.ColonExpected,[],[o.CloseBraceToken,o.CommaToken]),!0)}function H(){d(),ne();let x=!1;for(;c.getToken()!==o.CloseBraceToken&&c.getToken()!==o.EOF;){if(c.getToken()===o.CommaToken){if(x||Q(S.ValueExpected,[],[]),R(","),ne(),c.getToken()===o.CloseBraceToken&&z)break}else x&&Q(S.CommaExpected,[],[]);ee()||Q(S.ValueExpected,[],[o.CloseBraceToken,o.CommaToken]),x=!0}return E(),c.getToken()!==o.CloseBraceToken?Q(S.CloseBraceExpected,[o.CloseBraceToken],[]):ne(),!0}function j(){A(),ne();let x=!1;for(;c.getToken()!==o.CloseBracketToken&&c.getToken()!==o.EOF;){if(c.getToken()===o.CommaToken){if(x||Q(S.ValueExpected,[],[]),R(","),ne(),c.getToken()===o.CloseBracketToken&&z)break}else x&&Q(S.CommaExpected,[],[]);B()||Q(S.ValueExpected,[],[o.CloseBracketToken,o.CommaToken]),x=!0}return T(),c.getToken()!==o.CloseBracketToken?Q(S.CloseBracketExpected,[o.CloseBracketToken],[]):ne(),!0}function B(){switch(c.getToken()){case o.OpenBracketToken:return j();case o.OpenBraceToken:return H();case o.StringLiteral:return le(!0);default:return K()}}return ne(),c.getToken()===o.EOF?n.allowEmptyContent?!0:(Q(S.ValueExpected,[],[]),!1):B()?(c.getToken()!==o.EOF&&Q(S.EndOfFileExpected,[],[]),!0):(Q(S.ValueExpected,[],[]),!1)}function k(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}}),define(oe[142],ae([0,1,43]),function(V,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5n=o,e.$6n=S,e.$7n=P,e.$8n=y;function o(a,h,f){let g,b,l,m,p;if(h){for(m=h.offset,p=m+h.length,l=m;l>0&&!y(a,l-1);)l--;let I=p;for(;I<a.length&&!y(a,I);)I++;b=a.substring(l,I),g=O(b,f)}else b=a,g=0,l=0,m=0,p=a.length;const $=P(f,a);let w=!1,v=0,k;f.insertSpaces?k=D(" ",f.tabSize||4):k="	";const t=(0,i.$Tn)(b,!1);let r=!1;function n(){return $+D(k,g+v)}function c(){let I=t.scan();for(w=!1;I===i.SyntaxKind.Trivia||I===i.SyntaxKind.LineBreakTrivia;)w=w||I===i.SyntaxKind.LineBreakTrivia,I=t.scan();return r=I===i.SyntaxKind.Unknown||t.getTokenError()!==i.ScanError.None,I}const s=[];function u(I,E,A){!r&&E<p&&A>m&&a.substring(E,A)!==I&&s.push({offset:E,length:A-E,content:I})}let d=c();if(d!==i.SyntaxKind.EOF){const I=t.getTokenOffset()+l,E=D(k,g);u(E,l,I)}for(;d!==i.SyntaxKind.EOF;){let I=t.getTokenOffset()+t.getTokenLength()+l,E=c(),A="";for(;!w&&(E===i.SyntaxKind.LineCommentTrivia||E===i.SyntaxKind.BlockCommentTrivia);){const L=t.getTokenOffset()+l;u(" ",I,L),I=t.getTokenOffset()+t.getTokenLength()+l,A=E===i.SyntaxKind.LineCommentTrivia?n():"",E=c()}if(E===i.SyntaxKind.CloseBraceToken)d!==i.SyntaxKind.OpenBraceToken&&(v--,A=n());else if(E===i.SyntaxKind.CloseBracketToken)d!==i.SyntaxKind.OpenBracketToken&&(v--,A=n());else{switch(d){case i.SyntaxKind.OpenBracketToken:case i.SyntaxKind.OpenBraceToken:v++,A=n();break;case i.SyntaxKind.CommaToken:case i.SyntaxKind.LineCommentTrivia:A=n();break;case i.SyntaxKind.BlockCommentTrivia:w?A=n():A=" ";break;case i.SyntaxKind.ColonToken:A=" ";break;case i.SyntaxKind.StringLiteral:if(E===i.SyntaxKind.ColonToken){A="";break}case i.SyntaxKind.NullKeyword:case i.SyntaxKind.TrueKeyword:case i.SyntaxKind.FalseKeyword:case i.SyntaxKind.NumericLiteral:case i.SyntaxKind.CloseBraceToken:case i.SyntaxKind.CloseBracketToken:E===i.SyntaxKind.LineCommentTrivia||E===i.SyntaxKind.BlockCommentTrivia?A=" ":E!==i.SyntaxKind.CommaToken&&E!==i.SyntaxKind.EOF&&(r=!0);break;case i.SyntaxKind.Unknown:r=!0;break}w&&(E===i.SyntaxKind.LineCommentTrivia||E===i.SyntaxKind.BlockCommentTrivia)&&(A=n())}const T=t.getTokenOffset()+l;u(A,I,T),d=E}return s}function S(a,h){const f=JSON.stringify(a,void 0,h.insertSpaces?h.tabSize||4:"	");return h.eol!==void 0?f.replace(/\r\n|\r|\n/g,h.eol):f}function D(a,h){let f="";for(let g=0;g<h;g++)f+=a;return f}function O(a,h){let f=0,g=0;const b=h.tabSize||4;for(;f<a.length;){const l=a.charAt(f);if(l===" ")g++;else if(l==="	")g+=b;else break;f++}return Math.floor(g/b)}function P(a,h){for(let f=0;f<h.length;f++){const g=h.charAt(f);if(g==="\r")return f+1<h.length&&h.charAt(f+1)===`
`?`\r
`:"\r";if(g===`
`)return`
`}return a&&a.eol||`
`}function y(a,h){return`\r
`.indexOf(a.charAt(h))!==-1}}),define(oe[108],ae([0,1,43,142]),function(V,e,i,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9n=S,e.$0n=D,e.$$n=O,e.$_n=P,e.$ao=y;function S(a,h,f){return D(a,h,void 0,f)}function D(a,h,f,g,b){const l=h.slice(),m=[],p=(0,i.$Wn)(a,m);let $,w;for(;l.length>0&&(w=l.pop(),$=(0,i.$Xn)(p,l),$===void 0&&f!==void 0);)typeof w=="string"?f={[w]:f}:f=[f];if($)if($.type==="object"&&typeof w=="string"&&Array.isArray($.children)){const v=(0,i.$Xn)($,[w]);if(v!==void 0)if(f===void 0){if(!v.parent)throw new Error("Malformed AST");const k=$.children.indexOf(v.parent);let t,r=v.parent.offset+v.parent.length;if(k>0){const n=$.children[k-1];t=n.offset+n.length}else t=$.offset+1,$.children.length>1&&(r=$.children[1].offset);return O(a,{offset:t,length:r-t,content:""},g)}else return O(a,{offset:v.offset,length:v.length,content:JSON.stringify(f)},g);else{if(f===void 0)return[];const k=`${JSON.stringify(w)}: ${JSON.stringify(f)}`,t=b?b($.children.map(n=>n.children[0].value)):$.children.length;let r;if(t>0){const n=$.children[t-1];r={offset:n.offset+n.length,length:0,content:","+k}}else $.children.length===0?r={offset:$.offset+1,length:0,content:k}:r={offset:$.offset+1,length:0,content:k+","};return O(a,r,g)}}else if($.type==="array"&&typeof w=="number"&&Array.isArray($.children))if(f!==void 0){const v=`${JSON.stringify(f)}`;let k;if($.children.length===0||w===0)k={offset:$.offset+1,length:0,content:$.children.length===0?v:v+","};else{const t=w===-1||w>$.children.length?$.children.length:w,r=$.children[t-1];k={offset:r.offset+r.length,length:0,content:","+v}}return O(a,k,g)}else{const v=w,k=$.children[v];let t;if($.children.length===1)t={offset:$.offset+1,length:$.length-2,content:""};else if($.children.length-1===v){const r=$.children[v-1],n=r.offset+r.length,c=$.offset+$.length;t={offset:n,length:c-2-n,content:""}}else t={offset:k.offset,length:$.children[v+1].offset-k.offset,content:""};return O(a,t,g)}else throw new Error(`Can not add ${typeof w!="number"?"index":"property"} to parent of type ${$.type}`);else return f===void 0?[]:O(a,{offset:p?p.offset:0,length:p?p.length:0,content:JSON.stringify(f)},g)}function O(a,h,f){let g=P(a,h),b=h.offset,l=h.offset+h.content.length;if(h.length===0||h.content.length===0){for(;b>0&&!(0,o.$8n)(g,b-1);)b--;for(;l<g.length&&!(0,o.$8n)(g,l);)l++}const m=(0,o.$5n)(g,{offset:b,length:l-b},f);for(let $=m.length-1;$>=0;$--){const w=m[$];g=P(g,w),b=Math.min(b,w.offset),l=Math.max(l,w.offset+w.length),l+=w.content.length-w.length}const p=a.length-(g.length-l)-b;return[{offset:b,length:p,content:g.substring(b,l)}]}function P(a,h){return a.substring(0,h.offset)+h.content+a.substring(h.offset+h.length)}function y(a,h){const f=h.slice(0).sort((b,l)=>{const m=b.offset-l.offset;return m===0?b.length-l.length:m});let g=a.length;for(let b=f.length-1;b>=0;b--){const l=f[b];if(l.offset+l.length<=g)a=P(a,l);else throw new Error("Overlapping edit");g=l.offset}return a}}),function(){function V(e,i,o,S){const D=/("[^"\\]*(?:\\.[^"\\]*)*")|('[^'\\]*(?:\\.[^'\\]*)*')|(\/\*[^\/\*]*(?:(?:\*|\/)[^\/\*]*)*?\*\/)|(\/{2,}.*?(?:(?:\r?\n)|$))|(,\s*[}\]])/g;function O(y){return y.replace(D,function(a,h,f,g,b,l){if(g)return"";if(b){const m=b.length;return b[m-1]===`
`?b[m-2]==="\r"?`\r
`:`
`:""}else return l?a.substring(1):a})}function P(y){const a=O(y);try{return JSON.parse(a)}catch{const f=a.replace(/,\s*([}\]])/g,"$1");return JSON.parse(f)}}return{stripComments:O,parse:P}}typeof define=="function"?define("vs/base/common/jsonc",[],function(){return V()}):typeof module=="object"&&typeof module.exports=="object"?module.exports=V():console.trace("jsonc defined in UNKNOWN context (neither requirejs or commonjs)")}(),define(oe[65],ae([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$X=void 0;class i{constructor(S){this.d=S,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(S){this.c=S}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$X=i}),define(oe[109],ae([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7c=void 0;class i{static{this.Undefined=new i(void 0)}constructor(D){this.element=D,this.next=i.Undefined,this.prev=i.Undefined}}class o{constructor(){this.a=i.Undefined,this.b=i.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===i.Undefined}clear(){let D=this.a;for(;D!==i.Undefined;){const O=D.next;D.prev=i.Undefined,D.next=i.Undefined,D=O}this.a=i.Undefined,this.b=i.Undefined,this.c=0}unshift(D){return this.d(D,!1)}push(D){return this.d(D,!0)}d(D,O){const P=new i(D);if(this.a===i.Undefined)this.a=P,this.b=P;else if(O){const a=this.b;this.b=P,P.prev=a,a.next=P}else{const a=this.a;this.a=P,P.next=a,a.prev=P}this.c+=1;let y=!1;return()=>{y||(y=!0,this.e(P))}}shift(){if(this.a!==i.Undefined){const D=this.a.element;return this.e(this.a),D}}pop(){if(this.b!==i.Undefined){const D=this.b.element;return this.e(this.b),D}}e(D){if(D.prev!==i.Undefined&&D.next!==i.Undefined){const O=D.prev;O.next=D.next,D.next.prev=O}else D.prev===i.Undefined&&D.next===i.Undefined?(this.a=i.Undefined,this.b=i.Undefined):D.next===i.Undefined?(this.b=this.b.prev,this.b.next=i.Undefined):D.prev===i.Undefined&&(this.a=this.a.next,this.a.prev=i.Undefined);this.c-=1}*[Symbol.iterator](){let D=this.a;for(;D!==i.Undefined;)yield D.element,D=D.next}}e.$7c=o}),define(oe[32],ae([0,1]),function(V,e){"use strict";var i,o,S;Object.defineProperty(e,"__esModule",{value:!0}),e.$Jc=e.$Ic=e.$Hc=e.$Gc=e.$Fc=e.$Ec=e.Touch=e.$Dc=e.$Cc=void 0,e.$zc=D,e.$Ac=O,e.$Bc=P,e.$Kc=k;function D(t,r,n){let c=t.get(r);return c===void 0&&(c=n,t.set(r,c)),c}function O(t){const r=[];return t.forEach((n,c)=>{r.push(`${c} => ${n}`)}),`Map(${t.size}) {${r.join(", ")}}`}function P(t){const r=[];return t.forEach(n=>{r.push(n)}),`Set(${t.size}) {${r.join(", ")}}`}class y{constructor(r,n){this.uri=r,this.value=n}}function a(t){return Array.isArray(t)}class h{static{this.c=r=>r.toString()}constructor(r,n){if(this[i]="ResourceMap",r instanceof h)this.d=new Map(r.d),this.e=n??h.c;else if(a(r)){this.d=new Map,this.e=n??h.c;for(const[c,s]of r)this.set(c,s)}else this.d=new Map,this.e=r??h.c}set(r,n){return this.d.set(this.e(r),new y(r,n)),this}get(r){return this.d.get(this.e(r))?.value}has(r){return this.d.has(this.e(r))}get size(){return this.d.size}clear(){this.d.clear()}delete(r){return this.d.delete(this.e(r))}forEach(r,n){typeof n<"u"&&(r=r.bind(n));for(const[c,s]of this.d)r(s.value,s.uri,this)}*values(){for(const r of this.d.values())yield r.value}*keys(){for(const r of this.d.values())yield r.uri}*entries(){for(const r of this.d.values())yield[r.uri,r.value]}*[(i=Symbol.toStringTag,Symbol.iterator)](){for(const[,r]of this.d)yield[r.uri,r.value]}}e.$Cc=h;class f{constructor(r,n){this[o]="ResourceSet",!r||typeof r=="function"?this.c=new h(r):(this.c=new h(n),r.forEach(this.add,this))}get size(){return this.c.size}add(r){return this.c.set(r,r),this}clear(){this.c.clear()}delete(r){return this.c.delete(r)}forEach(r,n){this.c.forEach((c,s)=>r.call(n,s,s,this))}has(r){return this.c.has(r)}entries(){return this.c.entries()}keys(){return this.c.keys()}values(){return this.c.keys()}[(o=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$Dc=f;var g;(function(t){t[t.None=0]="None",t[t.AsOld=1]="AsOld",t[t.AsNew=2]="AsNew"})(g||(e.Touch=g={}));class b{constructor(){this[S]="LinkedMap",this.c=new Map,this.d=void 0,this.e=void 0,this.f=0,this.g=0}clear(){this.c.clear(),this.d=void 0,this.e=void 0,this.f=0,this.g++}isEmpty(){return!this.d&&!this.e}get size(){return this.f}get first(){return this.d?.value}get last(){return this.e?.value}has(r){return this.c.has(r)}get(r,n=g.None){const c=this.c.get(r);if(c)return n!==g.None&&this.m(c,n),c.value}set(r,n,c=g.None){let s=this.c.get(r);if(s)s.value=n,c!==g.None&&this.m(s,c);else{switch(s={key:r,value:n,next:void 0,previous:void 0},c){case g.None:this.k(s);break;case g.AsOld:this.j(s);break;case g.AsNew:this.k(s);break;default:this.k(s);break}this.c.set(r,s),this.f++}return this}delete(r){return!!this.remove(r)}remove(r){const n=this.c.get(r);if(n)return this.c.delete(r),this.l(n),this.f--,n.value}shift(){if(!this.d&&!this.e)return;if(!this.d||!this.e)throw new Error("Invalid list");const r=this.d;return this.c.delete(r.key),this.l(r),this.f--,r.value}forEach(r,n){const c=this.g;let s=this.d;for(;s;){if(n?r.bind(n)(s.value,s.key,this):r(s.value,s.key,this),this.g!==c)throw new Error("LinkedMap got modified during iteration.");s=s.next}}keys(){const r=this,n=this.g;let c=this.d;const s={[Symbol.iterator](){return s},next(){if(r.g!==n)throw new Error("LinkedMap got modified during iteration.");if(c){const u={value:c.key,done:!1};return c=c.next,u}else return{value:void 0,done:!0}}};return s}values(){const r=this,n=this.g;let c=this.d;const s={[Symbol.iterator](){return s},next(){if(r.g!==n)throw new Error("LinkedMap got modified during iteration.");if(c){const u={value:c.value,done:!1};return c=c.next,u}else return{value:void 0,done:!0}}};return s}entries(){const r=this,n=this.g;let c=this.d;const s={[Symbol.iterator](){return s},next(){if(r.g!==n)throw new Error("LinkedMap got modified during iteration.");if(c){const u={value:[c.key,c.value],done:!1};return c=c.next,u}else return{value:void 0,done:!0}}};return s}[(S=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}h(r){if(r>=this.size)return;if(r===0){this.clear();return}let n=this.d,c=this.size;for(;n&&c>r;)this.c.delete(n.key),n=n.next,c--;this.d=n,this.f=c,n&&(n.previous=void 0),this.g++}i(r){if(r>=this.size)return;if(r===0){this.clear();return}let n=this.e,c=this.size;for(;n&&c>r;)this.c.delete(n.key),n=n.previous,c--;this.e=n,this.f=c,n&&(n.next=void 0),this.g++}j(r){if(!this.d&&!this.e)this.e=r;else if(this.d)r.next=this.d,this.d.previous=r;else throw new Error("Invalid list");this.d=r,this.g++}k(r){if(!this.d&&!this.e)this.d=r;else if(this.e)r.previous=this.e,this.e.next=r;else throw new Error("Invalid list");this.e=r,this.g++}l(r){if(r===this.d&&r===this.e)this.d=void 0,this.e=void 0;else if(r===this.d){if(!r.next)throw new Error("Invalid list");r.next.previous=void 0,this.d=r.next}else if(r===this.e){if(!r.previous)throw new Error("Invalid list");r.previous.next=void 0,this.e=r.previous}else{const n=r.next,c=r.previous;if(!n||!c)throw new Error("Invalid list");n.previous=c,c.next=n}r.next=void 0,r.previous=void 0,this.g++}m(r,n){if(!this.d||!this.e)throw new Error("Invalid list");if(!(n!==g.AsOld&&n!==g.AsNew)){if(n===g.AsOld){if(r===this.d)return;const c=r.next,s=r.previous;r===this.e?(s.next=void 0,this.e=s):(c.previous=s,s.next=c),r.previous=void 0,r.next=this.d,this.d.previous=r,this.d=r,this.g++}else if(n===g.AsNew){if(r===this.e)return;const c=r.next,s=r.previous;r===this.d?(c.previous=void 0,this.d=c):(c.previous=s,s.next=c),r.next=void 0,r.previous=this.e,this.e.next=r,this.e=r,this.g++}}}toJSON(){const r=[];return this.forEach((n,c)=>{r.push([c,n])}),r}fromJSON(r){this.clear();for(const[n,c]of r)this.set(n,c)}}e.$Ec=b;class l extends b{constructor(r,n=1){super(),this.n=r,this.o=Math.min(Math.max(0,n),1)}get limit(){return this.n}set limit(r){this.n=r,this.p()}get ratio(){return this.o}set ratio(r){this.o=Math.min(Math.max(0,r),1),this.p()}get(r,n=g.AsNew){return super.get(r,n)}peek(r){return super.get(r,g.None)}set(r,n){return super.set(r,n,g.AsNew),this}p(){this.size>this.n&&this.q(Math.round(this.n*this.o))}}class m extends l{constructor(r,n=1){super(r,n)}q(r){this.h(r)}set(r,n){return super.set(r,n),this.p(),this}}e.$Fc=m;class p extends l{constructor(r,n=1){super(r,n)}q(r){this.i(r)}set(r,n){return this.n<=this.size&&!this.has(r)&&this.q(Math.round(this.n*this.o)-1),super.set(r,n),this}}e.$Gc=p;class ${constructor(){this.c=new Map}add(r){return this.c.set(r,(this.c.get(r)||0)+1),this}delete(r){let n=this.c.get(r)||0;return n===0?!1:(n--,n===0?this.c.delete(r):this.c.set(r,n),!0)}has(r){return this.c.has(r)}}e.$Hc=$;class w{constructor(r){if(this.c=new Map,this.d=new Map,r)for(const[n,c]of r)this.set(n,c)}clear(){this.c.clear(),this.d.clear()}set(r,n){this.c.set(r,n),this.d.set(n,r)}get(r){return this.c.get(r)}getKey(r){return this.d.get(r)}delete(r){const n=this.c.get(r);return n===void 0?!1:(this.c.delete(r),this.d.delete(n),!0)}forEach(r,n){this.c.forEach((c,s)=>{r.call(n,c,s,this)})}keys(){return this.c.keys()}values(){return this.c.values()}}e.$Ic=w;class v{constructor(){this.c=new Map}add(r,n){let c=this.c.get(r);c||(c=new Set,this.c.set(r,c)),c.add(n)}delete(r,n){const c=this.c.get(r);c&&(c.delete(n),c.size===0&&this.c.delete(r))}forEach(r,n){const c=this.c.get(r);c&&c.forEach(n)}get(r){const n=this.c.get(r);return n||new Set}}e.$Jc=v;function k(t,r){if(t===r)return!0;if(t.size!==r.size)return!1;for(const[n,c]of t)if(!r.has(n)||r.get(n)!==c)return!1;for(const[n]of r)if(!t.has(n))return!1;return!0}}),define(oe[2],ae([0,1,22,139,32,89,76]),function(V,e,i,o,S,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6c=e.$4c=e.$3c=e.$2c=e.$1c=e.$Zc=e.$Yc=e.$Xc=e.$Wc=e.$Vc=e.$Lc=void 0,e.$Mc=h,e.$Nc=f,e.$Oc=g,e.$Pc=m,e.$Qc=p,e.$Rc=$,e.$Sc=w,e.$Tc=v,e.$Uc=k,e.$5c=A;const P=!1;let y=null;class a{constructor(){this.b=new Map}static{this.a=0}c(R){let M=this.b.get(R);return M||(M={parent:null,source:null,isSingleton:!1,value:R,idx:a.a++},this.b.set(R,M)),M}trackDisposable(R){const M=this.c(R);M.source||(M.source=new Error().stack)}setParent(R,M){const U=this.c(R);U.parent=M}markAsDisposed(R){this.b.delete(R)}markAsSingleton(R){this.c(R).isSingleton=!0}f(R,M){const U=M.get(R);if(U)return U;const N=R.parent?this.f(this.c(R.parent),M):R;return M.set(R,N),N}getTrackedDisposables(){const R=new Map;return[...this.b.entries()].filter(([,U])=>U.source!==null&&!this.f(U,R).isSingleton).flatMap(([U])=>U)}computeLeakingDisposables(R=10,M){let U;if(M)U=M;else{const le=new Map,K=[...this.b.values()].filter(H=>H.source!==null&&!this.f(H,le).isSingleton);if(K.length===0)return;const ee=new Set(K.map(H=>H.value));if(U=K.filter(H=>!(H.parent&&ee.has(H.parent))),U.length===0)throw new Error("There are cyclic diposable chains!")}if(!U)return;function N(le){function K(H,j){for(;H.length>0&&j.some(B=>typeof B=="string"?B===H[0]:H[0].match(B));)H.shift()}const ee=le.source.split(`
`).map(H=>H.trim().replace("at ","")).filter(H=>H!=="");return K(ee,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),ee.reverse()}const z=new S.$Jc;for(const le of U){const K=N(le);for(let ee=0;ee<=K.length;ee++)z.add(K.slice(0,ee).join(`
`),le)}U.sort((0,i.$8b)(le=>le.idx,i.$0b));let ne="",Q=0;for(const le of U.slice(0,R)){Q++;const K=N(le),ee=[];for(let H=0;H<K.length;H++){let j=K[H];j=`(shared with ${z.get(K.slice(0,H+1).join(`
`)).size}/${U.length} leaks) at ${j}`;const x=z.get(K.slice(0,H).join(`
`)),ce=(0,o.$K)([...x].map(G=>N(G)[H]),G=>G);delete ce[K[H]];for(const[G,he]of Object.entries(ce))ee.unshift(`    - stacktraces of ${he.length} other leaks continue with ${G}`);ee.unshift(j)}ne+=`


==================== Leaking disposable ${Q}/${U.length}: ${le.value.constructor.name} ====================
${ee.join(`
`)}
============================================================

`}return U.length>R&&(ne+=`


... and ${U.length-R} more leaking disposables

`),{leaks:U,details:ne}}}e.$Lc=a;function h(L){y=L}if(P){const L="__is_disposable_tracked__";h(new class{trackDisposable(R){const M=new Error("Potentially leaked disposable").stack;setTimeout(()=>{R[L]||console.log(M)},3e3)}setParent(R,M){if(R&&R!==r.None)try{R[L]=!0}catch{}}markAsDisposed(R){if(R&&R!==r.None)try{R[L]=!0}catch{}}markAsSingleton(R){}})}function f(L){return y?.trackDisposable(L),L}function g(L){y?.markAsDisposed(L)}function b(L,R){y?.setParent(L,R)}function l(L,R){if(y)for(const M of L)y.setParent(M,R)}function m(L){return y?.markAsSingleton(L),L}function p(L){return typeof L=="object"&&L!==null&&typeof L.dispose=="function"&&L.dispose.length===0}function $(L){if(O.Iterable.is(L)){const R=[];for(const M of L)if(M)try{M.dispose()}catch(U){R.push(U)}if(R.length===1)throw R[0];if(R.length>1)throw new AggregateError(R,"Encountered errors while disposing of store");return Array.isArray(L)?[]:L}else if(L)return L.dispose(),L}function w(L){for(const R of L)p(R)&&R.dispose();return[]}function v(...L){const R=k(()=>$(L));return l(L,R),R}function k(L){const R=f({dispose:(0,D.$fb)(()=>{g(R),L()})});return R}class t{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,f(this)}dispose(){this.g||(g(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{$(this.f)}finally{this.f.clear()}}add(R){if(!R)return R;if(R===this)throw new Error("Cannot register a disposable on itself!");return b(R,this),this.g?t.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(R),R}delete(R){if(R){if(R===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(R),R.dispose()}}deleteAndLeak(R){R&&this.f.has(R)&&(this.f.delete(R),b(R,null))}}e.$Vc=t;class r{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new t,f(this),b(this.q,this)}dispose(){g(this),this.q.dispose()}B(R){if(R===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(R)}}e.$Wc=r;class n{constructor(){this.b=!1,f(this)}get value(){return this.b?void 0:this.a}set value(R){this.b||R===this.a||(this.a?.dispose(),R&&b(R,this),this.a=R)}clear(){this.value=void 0}dispose(){this.b=!0,g(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const R=this.a;return this.a=void 0,R&&b(R,null),R}}e.$Xc=n;class c{constructor(R){this.a=new n,this.b=!1,this.a.value=R}get value(){return this.a.value}set value(R){this.b||R===this.a.value||(this.a.value=R)}dispose(){this.b=!0,this.a.dispose()}}e.$Yc=c;class s{constructor(R){this.b=R,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$Zc=s;class u{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,f(this)}set(R){let M=R;return this.unset=()=>M=void 0,this.isset=()=>M!==void 0,this.dispose=()=>{M&&(M(),M=void 0,g(this))},this}}e.$1c=u;class d{constructor(){this.a=new Map}acquire(R,...M){let U=this.a.get(R);U||(U={counter:0,object:this.b(R,...M)},this.a.set(R,U));const{object:N}=U,z=(0,D.$fb)(()=>{--U.counter===0&&(this.c(R,U.object),this.a.delete(R))});return U.counter++,{object:N,dispose:z}}}e.$2c=d;class I{constructor(R){this.a=R}async acquire(R,...M){const U=this.a.acquire(R,...M);try{return{object:await U.object,dispose:()=>U.dispose()}}catch(N){throw U.dispose(),N}}}e.$3c=I;class E{constructor(R){this.object=R}dispose(){}}e.$4c=E;function A(L){const R=new t;try{L(R)}finally{R.dispose()}}class T{constructor(){this.a=new Map,this.b=!1,f(this)}dispose(){g(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{$(this.a.values())}finally{this.a.clear()}}has(R){return this.a.has(R)}get size(){return this.a.size}get(R){return this.a.get(R)}set(R,M,U=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),U||this.a.get(R)?.dispose(),this.a.set(R,M)}deleteAndDispose(R){this.a.get(R)?.dispose(),this.a.delete(R)}deleteAndLeak(R){const M=this.a.get(R);return this.a.delete(R),M}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$6c=T}),define(oe[90],ae([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MarshalledId=void 0;var i;(function(o){o[o.Uri=1]="Uri",o[o.Regexp=2]="Regexp",o[o.ScmResource=3]="ScmResource",o[o.ScmResourceGroup=4]="ScmResourceGroup",o[o.ScmProvider=5]="ScmProvider",o[o.CommentController=6]="CommentController",o[o.CommentThread=7]="CommentThread",o[o.CommentThreadInstance=8]="CommentThreadInstance",o[o.CommentThreadReply=9]="CommentThreadReply",o[o.CommentNode=10]="CommentNode",o[o.CommentThreadNode=11]="CommentThreadNode",o[o.TimelineActionContext=12]="TimelineActionContext",o[o.NotebookCellActionContext=13]="NotebookCellActionContext",o[o.NotebookActionContext=14]="NotebookActionContext",o[o.TerminalContext=15]="TerminalContext",o[o.TestItemContext=16]="TestItemContext",o[o.Date=17]="Date",o[o.TestMessageMenuArgs=18]="TestMessageMenuArgs"})(i||(e.MarshalledId=i={}))}),define(oe[77],ae([0,1,32]),function(V,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$om=void 0,e.$mm=S,e.$nm=O;const o=new i.$Fc(1e4);function S(a){return y(a,"NFC",o)}const D=new i.$Fc(1e4);function O(a){return y(a,"NFD",D)}const P=/[^\u0000-\u0080]/;function y(a,h,f){if(!a)return a;const g=f.get(a);if(g)return g;let b;return P.test(a)?b=a.normalize(h):b=a,f.set(a,b),b}e.$om=function(){const a=/[\u0300-\u036f]/g;return function(h){return O(h).replace(a,"")}}()}),define(oe[143],ae([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Om=e.$Nm=e.$Mm=void 0,e.$Km=i,e.rot=o,e.$Pm=P;function i(y,a,h){return Math.min(Math.max(y,a),h)}function o(y,a){return(a+y%a)%a}class S{constructor(){this.a=0}getNext(){return this.a++}}e.$Mm=S;class D{constructor(){this.a=1,this.b=0}update(a){return this.b=this.b+(a-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$Nm=D;class O{constructor(a){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(a),this.c.fill(0,0,a)}update(a){const h=this.c[this.d];return this.c[this.d]=a,this.d=(this.d+1)%this.c.length,this.e-=h,this.e+=a,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$Om=O;function P(y,a,h,f,g,b,l,m){const p=l-h,$=m-f,w=g-h,v=b-f,k=y-h,t=a-f,r=p*p+$*$,n=p*w+$*v,c=p*k+$*t,s=w*w+v*v,u=w*k+v*t,d=1/(r*s-n*n),I=(s*c-n*u)*d,E=(r*u-n*c)*d;return I>=0&&E>=0&&I+E<1}}),function(){function V(S){const D=[];typeof S=="number"&&D.push("code/timeOrigin",S);function O(y){D.push(y,Date.now())}function P(){const y=[];for(let a=0;a<D.length;a+=2)y.push({name:D[a],startTime:D[a+1]});return y}return{mark:O,getMarks:P}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?V():{mark(S){performance.mark(S)},getMarks(){let S=performance.timeOrigin;typeof S!="number"&&(S=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const D=[{name:"code/timeOrigin",startTime:Math.round(S)}];for(const O of performance.getEntriesByType("mark"))D.push({name:O.name,startTime:Math.round(S+O.startTime)});return D}};if(typeof process=="object"){const S=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return V(S)}else return console.trace("perf-util loaded in UNKNOWN environment"),V()}function i(S){return S.MonacoPerformanceMarks||(S.MonacoPerformanceMarks=e()),S.MonacoPerformanceMarks}var o;typeof global=="object"?o=global:typeof self=="object"?o=self:o={},typeof define=="function"?define("vs/base/common/performance",[],function(){return i(o)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=i(o):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),o.perf=i(o))}(),function(V,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var i=e();for(var o in i)(typeof exports=="object"?exports:V)[o]=i[o]}}(typeof self<"u"?self:this,function(){return function(V){var e={};function i(o){if(e[o])return e[o].exports;var S=e[o]={i:o,l:!1,exports:{}};return V[o].call(S.exports,S,S.exports,i),S.l=!0,S.exports}return i.m=V,i.c=e,i.d=function(o,S,D){i.o(o,S)||Object.defineProperty(o,S,{enumerable:!0,get:D})},i.r=function(o){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(o,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(o,"__esModule",{value:!0})},i.t=function(o,S){if(1&S&&(o=i(o)),8&S||4&S&&typeof o=="object"&&o&&o.__esModule)return o;var D=Object.create(null);if(i.r(D),Object.defineProperty(D,"default",{enumerable:!0,value:o}),2&S&&typeof o!="string")for(var O in o)i.d(D,O,function(P){return o[P]}.bind(null,O));return D},i.n=function(o){var S=o&&o.__esModule?function(){return o.default}:function(){return o};return i.d(S,"a",S),S},i.o=function(o,S){return Object.prototype.hasOwnProperty.call(o,S)},i.p="",i(i.s=0)}([function(V,e,i){(function(o){var S;e=V.exports=he,S=typeof o=="object"&&o.env&&o.env.NODE_DEBUG&&/\bsemver\b/i.test(o.env.NODE_DEBUG)?function(){var Y=Array.prototype.slice.call(arguments,0);Y.unshift("SEMVER"),console.log.apply(console,Y)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var D=256,O=Number.MAX_SAFE_INTEGER||9007199254740991,P=e.re=[],y=e.src=[],a=0,h=a++;y[h]="0|[1-9]\\d*";var f=a++;y[f]="[0-9]+";var g=a++;y[g]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var b=a++;y[b]="("+y[h]+")\\.("+y[h]+")\\.("+y[h]+")";var l=a++;y[l]="("+y[f]+")\\.("+y[f]+")\\.("+y[f]+")";var m=a++;y[m]="(?:"+y[h]+"|"+y[g]+")";var p=a++;y[p]="(?:"+y[f]+"|"+y[g]+")";var $=a++;y[$]="(?:-("+y[m]+"(?:\\."+y[m]+")*))";var w=a++;y[w]="(?:-?("+y[p]+"(?:\\."+y[p]+")*))";var v=a++;y[v]="[0-9A-Za-z-]+";var k=a++;y[k]="(?:\\+("+y[v]+"(?:\\."+y[v]+")*))";var t=a++,r="v?"+y[b]+y[$]+"?"+y[k]+"?";y[t]="^"+r+"$";var n="[v=\\s]*"+y[l]+y[w]+"?"+y[k]+"?",c=a++;y[c]="^"+n+"$";var s=a++;y[s]="((?:<|>)?=?)";var u=a++;y[u]=y[f]+"|x|X|\\*";var d=a++;y[d]=y[h]+"|x|X|\\*";var I=a++;y[I]="[v=\\s]*("+y[d]+")(?:\\.("+y[d]+")(?:\\.("+y[d]+")(?:"+y[$]+")?"+y[k]+"?)?)?";var E=a++;y[E]="[v=\\s]*("+y[u]+")(?:\\.("+y[u]+")(?:\\.("+y[u]+")(?:"+y[w]+")?"+y[k]+"?)?)?";var A=a++;y[A]="^"+y[s]+"\\s*"+y[I]+"$";var T=a++;y[T]="^"+y[s]+"\\s*"+y[E]+"$";var L=a++;y[L]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var R=a++;y[R]="(?:~>?)";var M=a++;y[M]="(\\s*)"+y[R]+"\\s+",P[M]=new RegExp(y[M],"g");var U=a++;y[U]="^"+y[R]+y[I]+"$";var N=a++;y[N]="^"+y[R]+y[E]+"$";var z=a++;y[z]="(?:\\^)";var ne=a++;y[ne]="(\\s*)"+y[z]+"\\s+",P[ne]=new RegExp(y[ne],"g");var Q=a++;y[Q]="^"+y[z]+y[I]+"$";var le=a++;y[le]="^"+y[z]+y[E]+"$";var K=a++;y[K]="^"+y[s]+"\\s*("+n+")$|^$";var ee=a++;y[ee]="^"+y[s]+"\\s*("+r+")$|^$";var H=a++;y[H]="(\\s*)"+y[s]+"\\s*("+n+"|"+y[I]+")",P[H]=new RegExp(y[H],"g");var j=a++;y[j]="^\\s*("+y[I]+")\\s+-\\s+("+y[I]+")\\s*$";var B=a++;y[B]="^\\s*("+y[E]+")\\s+-\\s+("+y[E]+")\\s*$";var x=a++;y[x]="(<|>)?=?\\s*\\*";for(var ce=0;ce<35;ce++)S(ce,y[ce]),P[ce]||(P[ce]=new RegExp(y[ce]));function G(Y,ue){if(Y instanceof he)return Y;if(typeof Y!="string"||Y.length>D||!(ue?P[c]:P[t]).test(Y))return null;try{return new he(Y,ue)}catch{return null}}function he(Y,ue){if(Y instanceof he){if(Y.loose===ue)return Y;Y=Y.version}else if(typeof Y!="string")throw new TypeError("Invalid Version: "+Y);if(Y.length>D)throw new TypeError("version is longer than "+D+" characters");if(!(this instanceof he))return new he(Y,ue);S("SemVer",Y,ue),this.loose=ue;var fe=Y.trim().match(ue?P[c]:P[t]);if(!fe)throw new TypeError("Invalid Version: "+Y);if(this.raw=Y,this.major=+fe[1],this.minor=+fe[2],this.patch=+fe[3],this.major>O||this.major<0)throw new TypeError("Invalid major version");if(this.minor>O||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>O||this.patch<0)throw new TypeError("Invalid patch version");fe[4]?this.prerelease=fe[4].split(".").map(function(be){if(/^[0-9]+$/.test(be)){var Oe=+be;if(Oe>=0&&Oe<O)return Oe}return be}):this.prerelease=[],this.build=fe[5]?fe[5].split("."):[],this.format()}e.parse=G,e.valid=function(Y,ue){var fe=G(Y,ue);return fe?fe.version:null},e.clean=function(Y,ue){var fe=G(Y.trim().replace(/^[=v]+/,""),ue);return fe?fe.version:null},e.SemVer=he,he.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},he.prototype.toString=function(){return this.version},he.prototype.compare=function(Y){return S("SemVer.compare",this.version,this.loose,Y),Y instanceof he||(Y=new he(Y,this.loose)),this.compareMain(Y)||this.comparePre(Y)},he.prototype.compareMain=function(Y){return Y instanceof he||(Y=new he(Y,this.loose)),_(this.major,Y.major)||_(this.minor,Y.minor)||_(this.patch,Y.patch)},he.prototype.comparePre=function(Y){if(Y instanceof he||(Y=new he(Y,this.loose)),this.prerelease.length&&!Y.prerelease.length)return-1;if(!this.prerelease.length&&Y.prerelease.length)return 1;if(!this.prerelease.length&&!Y.prerelease.length)return 0;var ue=0;do{var fe=this.prerelease[ue],be=Y.prerelease[ue];if(S("prerelease compare",ue,fe,be),fe===void 0&&be===void 0)return 0;if(be===void 0)return 1;if(fe===void 0)return-1;if(fe!==be)return _(fe,be)}while(++ue)},he.prototype.inc=function(Y,ue){switch(Y){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",ue);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",ue);break;case"prepatch":this.prerelease.length=0,this.inc("patch",ue),this.inc("pre",ue);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",ue),this.inc("pre",ue);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var fe=this.prerelease.length;--fe>=0;)typeof this.prerelease[fe]=="number"&&(this.prerelease[fe]++,fe=-2);fe===-1&&this.prerelease.push(0)}ue&&(this.prerelease[0]===ue?isNaN(this.prerelease[1])&&(this.prerelease=[ue,0]):this.prerelease=[ue,0]);break;default:throw new Error("invalid increment argument: "+Y)}return this.format(),this.raw=this.version,this},e.inc=function(Y,ue,fe,be){typeof fe=="string"&&(be=fe,fe=void 0);try{return new he(Y,fe).inc(ue,be).version}catch{return null}},e.diff=function(Y,ue){if(q(Y,ue))return null;var fe=G(Y),be=G(ue);if(fe.prerelease.length||be.prerelease.length){for(var Oe in fe)if((Oe==="major"||Oe==="minor"||Oe==="patch")&&fe[Oe]!==be[Oe])return"pre"+Oe;return"prerelease"}for(var Oe in fe)if((Oe==="major"||Oe==="minor"||Oe==="patch")&&fe[Oe]!==be[Oe])return Oe},e.compareIdentifiers=_;var se=/^[0-9]+$/;function _(Y,ue){var fe=se.test(Y),be=se.test(ue);return fe&&be&&(Y=+Y,ue=+ue),fe&&!be?-1:be&&!fe?1:Y<ue?-1:Y>ue?1:0}function F(Y,ue,fe){return new he(Y,fe).compare(new he(ue,fe))}function C(Y,ue,fe){return F(Y,ue,fe)>0}function W(Y,ue,fe){return F(Y,ue,fe)<0}function q(Y,ue,fe){return F(Y,ue,fe)===0}function J(Y,ue,fe){return F(Y,ue,fe)!==0}function X(Y,ue,fe){return F(Y,ue,fe)>=0}function Z(Y,ue,fe){return F(Y,ue,fe)<=0}function ie(Y,ue,fe,be){var Oe;switch(ue){case"===":typeof Y=="object"&&(Y=Y.version),typeof fe=="object"&&(fe=fe.version),Oe=Y===fe;break;case"!==":typeof Y=="object"&&(Y=Y.version),typeof fe=="object"&&(fe=fe.version),Oe=Y!==fe;break;case"":case"=":case"==":Oe=q(Y,fe,be);break;case"!=":Oe=J(Y,fe,be);break;case">":Oe=C(Y,fe,be);break;case">=":Oe=X(Y,fe,be);break;case"<":Oe=W(Y,fe,be);break;case"<=":Oe=Z(Y,fe,be);break;default:throw new TypeError("Invalid operator: "+ue)}return Oe}function de(Y,ue){if(Y instanceof de){if(Y.loose===ue)return Y;Y=Y.value}if(!(this instanceof de))return new de(Y,ue);S("comparator",Y,ue),this.loose=ue,this.parse(Y),this.semver===me?this.value="":this.value=this.operator+this.semver.version,S("comp",this)}e.rcompareIdentifiers=function(Y,ue){return _(ue,Y)},e.major=function(Y,ue){return new he(Y,ue).major},e.minor=function(Y,ue){return new he(Y,ue).minor},e.patch=function(Y,ue){return new he(Y,ue).patch},e.compare=F,e.compareLoose=function(Y,ue){return F(Y,ue,!0)},e.rcompare=function(Y,ue,fe){return F(ue,Y,fe)},e.sort=function(Y,ue){return Y.sort(function(fe,be){return e.compare(fe,be,ue)})},e.rsort=function(Y,ue){return Y.sort(function(fe,be){return e.rcompare(fe,be,ue)})},e.gt=C,e.lt=W,e.eq=q,e.neq=J,e.gte=X,e.lte=Z,e.cmp=ie,e.Comparator=de;var me={};function pe(Y,ue){if(Y instanceof pe)return Y.loose===ue?Y:new pe(Y.raw,ue);if(Y instanceof de)return new pe(Y.value,ue);if(!(this instanceof pe))return new pe(Y,ue);if(this.loose=ue,this.raw=Y,this.set=Y.split(/\s*\|\|\s*/).map(function(fe){return this.parseRange(fe.trim())},this).filter(function(fe){return fe.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+Y);this.format()}function Ie(Y){return!Y||Y.toLowerCase()==="x"||Y==="*"}function ke(Y,ue,fe,be,Oe,We,Fe,Ae,Be,xe,Ye,qe,Je){return((ue=Ie(fe)?"":Ie(be)?">="+fe+".0.0":Ie(Oe)?">="+fe+"."+be+".0":">="+ue)+" "+(Ae=Ie(Be)?"":Ie(xe)?"<"+(+Be+1)+".0.0":Ie(Ye)?"<"+Be+"."+(+xe+1)+".0":qe?"<="+Be+"."+xe+"."+Ye+"-"+qe:"<="+Ae)).trim()}function Pe(Y,ue){for(var fe=0;fe<Y.length;fe++)if(!Y[fe].test(ue))return!1;if(ue.prerelease.length){for(fe=0;fe<Y.length;fe++)if(S(Y[fe].semver),Y[fe].semver!==me&&Y[fe].semver.prerelease.length>0){var be=Y[fe].semver;if(be.major===ue.major&&be.minor===ue.minor&&be.patch===ue.patch)return!0}return!1}return!0}function De(Y,ue,fe){try{ue=new pe(ue,fe)}catch{return!1}return ue.test(Y)}function $e(Y,ue,fe,be){var Oe,We,Fe,Ae,Be;switch(Y=new he(Y,be),ue=new pe(ue,be),fe){case">":Oe=C,We=Z,Fe=W,Ae=">",Be=">=";break;case"<":Oe=W,We=X,Fe=C,Ae="<",Be="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(De(Y,ue,be))return!1;for(var xe=0;xe<ue.set.length;++xe){var Ye=ue.set[xe],qe=null,Je=null;if(Ye.forEach(function(Xe){Xe.semver===me&&(Xe=new de(">=0.0.0")),qe=qe||Xe,Je=Je||Xe,Oe(Xe.semver,qe.semver,be)?qe=Xe:Fe(Xe.semver,Je.semver,be)&&(Je=Xe)}),qe.operator===Ae||qe.operator===Be||(!Je.operator||Je.operator===Ae)&&We(Y,Je.semver)||Je.operator===Be&&Fe(Y,Je.semver))return!1}return!0}de.prototype.parse=function(Y){var ue=this.loose?P[K]:P[ee],fe=Y.match(ue);if(!fe)throw new TypeError("Invalid comparator: "+Y);this.operator=fe[1],this.operator==="="&&(this.operator=""),fe[2]?this.semver=new he(fe[2],this.loose):this.semver=me},de.prototype.toString=function(){return this.value},de.prototype.test=function(Y){return S("Comparator.test",Y,this.loose),this.semver===me||(typeof Y=="string"&&(Y=new he(Y,this.loose)),ie(Y,this.operator,this.semver,this.loose))},de.prototype.intersects=function(Y,ue){if(!(Y instanceof de))throw new TypeError("a Comparator is required");var fe;if(this.operator==="")return fe=new pe(Y.value,ue),De(this.value,fe,ue);if(Y.operator==="")return fe=new pe(this.value,ue),De(Y.semver,fe,ue);var be=!(this.operator!==">="&&this.operator!==">"||Y.operator!==">="&&Y.operator!==">"),Oe=!(this.operator!=="<="&&this.operator!=="<"||Y.operator!=="<="&&Y.operator!=="<"),We=this.semver.version===Y.semver.version,Fe=!(this.operator!==">="&&this.operator!=="<="||Y.operator!==">="&&Y.operator!=="<="),Ae=ie(this.semver,"<",Y.semver,ue)&&(this.operator===">="||this.operator===">")&&(Y.operator==="<="||Y.operator==="<"),Be=ie(this.semver,">",Y.semver,ue)&&(this.operator==="<="||this.operator==="<")&&(Y.operator===">="||Y.operator===">");return be||Oe||We&&Fe||Ae||Be},e.Range=pe,pe.prototype.format=function(){return this.range=this.set.map(function(Y){return Y.join(" ").trim()}).join("||").trim(),this.range},pe.prototype.toString=function(){return this.range},pe.prototype.parseRange=function(Y){var ue=this.loose;Y=Y.trim(),S("range",Y,ue);var fe=ue?P[B]:P[j];Y=Y.replace(fe,ke),S("hyphen replace",Y),Y=Y.replace(P[H],"$1$2$3"),S("comparator trim",Y,P[H]),Y=(Y=(Y=Y.replace(P[M],"$1~")).replace(P[ne],"$1^")).split(/\s+/).join(" ");var be=ue?P[K]:P[ee],Oe=Y.split(" ").map(function(We){return function(Fe,Ae){return S("comp",Fe),Fe=function(Be,xe){return Be.trim().split(/\s+/).map(function(Ye){return function(qe,Je){S("caret",qe,Je);var Xe=Je?P[le]:P[Q];return qe.replace(Xe,function(Ke,Ce,te,ge,we){var ye;return S("caret",qe,Ke,Ce,te,ge,we),Ie(Ce)?ye="":Ie(te)?ye=">="+Ce+".0.0 <"+(+Ce+1)+".0.0":Ie(ge)?ye=Ce==="0"?">="+Ce+"."+te+".0 <"+Ce+"."+(+te+1)+".0":">="+Ce+"."+te+".0 <"+(+Ce+1)+".0.0":we?(S("replaceCaret pr",we),we.charAt(0)!=="-"&&(we="-"+we),ye=Ce==="0"?te==="0"?">="+Ce+"."+te+"."+ge+we+" <"+Ce+"."+te+"."+(+ge+1):">="+Ce+"."+te+"."+ge+we+" <"+Ce+"."+(+te+1)+".0":">="+Ce+"."+te+"."+ge+we+" <"+(+Ce+1)+".0.0"):(S("no pr"),ye=Ce==="0"?te==="0"?">="+Ce+"."+te+"."+ge+" <"+Ce+"."+te+"."+(+ge+1):">="+Ce+"."+te+"."+ge+" <"+Ce+"."+(+te+1)+".0":">="+Ce+"."+te+"."+ge+" <"+(+Ce+1)+".0.0"),S("caret return",ye),ye})}(Ye,xe)}).join(" ")}(Fe,Ae),S("caret",Fe),Fe=function(Be,xe){return Be.trim().split(/\s+/).map(function(Ye){return function(qe,Je){var Xe=Je?P[N]:P[U];return qe.replace(Xe,function(Ke,Ce,te,ge,we){var ye;return S("tilde",qe,Ke,Ce,te,ge,we),Ie(Ce)?ye="":Ie(te)?ye=">="+Ce+".0.0 <"+(+Ce+1)+".0.0":Ie(ge)?ye=">="+Ce+"."+te+".0 <"+Ce+"."+(+te+1)+".0":we?(S("replaceTilde pr",we),we.charAt(0)!=="-"&&(we="-"+we),ye=">="+Ce+"."+te+"."+ge+we+" <"+Ce+"."+(+te+1)+".0"):ye=">="+Ce+"."+te+"."+ge+" <"+Ce+"."+(+te+1)+".0",S("tilde return",ye),ye})}(Ye,xe)}).join(" ")}(Fe,Ae),S("tildes",Fe),Fe=function(Be,xe){return S("replaceXRanges",Be,xe),Be.split(/\s+/).map(function(Ye){return function(qe,Je){qe=qe.trim();var Xe=Je?P[T]:P[A];return qe.replace(Xe,function(Ke,Ce,te,ge,we,ye){S("xRange",qe,Ke,Ce,te,ge,we,ye);var Me=Ie(te),Ue=Me||Ie(ge),Qe=Ue||Ie(we);return Ce==="="&&Qe&&(Ce=""),Me?Ke=Ce===">"||Ce==="<"?"<0.0.0":"*":Ce&&Qe?(Ue&&(ge=0),Qe&&(we=0),Ce===">"?(Ce=">=",Ue?(te=+te+1,ge=0,we=0):Qe&&(ge=+ge+1,we=0)):Ce==="<="&&(Ce="<",Ue?te=+te+1:ge=+ge+1),Ke=Ce+te+"."+ge+"."+we):Ue?Ke=">="+te+".0.0 <"+(+te+1)+".0.0":Qe&&(Ke=">="+te+"."+ge+".0 <"+te+"."+(+ge+1)+".0"),S("xRange return",Ke),Ke})}(Ye,xe)}).join(" ")}(Fe,Ae),S("xrange",Fe),Fe=function(Be,xe){return S("replaceStars",Be,xe),Be.trim().replace(P[x],"")}(Fe,Ae),S("stars",Fe),Fe}(We,ue)}).join(" ").split(/\s+/);return this.loose&&(Oe=Oe.filter(function(We){return!!We.match(be)})),Oe=Oe.map(function(We){return new de(We,ue)})},pe.prototype.intersects=function(Y,ue){if(!(Y instanceof pe))throw new TypeError("a Range is required");return this.set.some(function(fe){return fe.every(function(be){return Y.set.some(function(Oe){return Oe.every(function(We){return be.intersects(We,ue)})})})})},e.toComparators=function(Y,ue){return new pe(Y,ue).set.map(function(fe){return fe.map(function(be){return be.value}).join(" ").trim().split(" ")})},pe.prototype.test=function(Y){if(!Y)return!1;typeof Y=="string"&&(Y=new he(Y,this.loose));for(var ue=0;ue<this.set.length;ue++)if(Pe(this.set[ue],Y))return!0;return!1},e.satisfies=De,e.maxSatisfying=function(Y,ue,fe){var be=null,Oe=null;try{var We=new pe(ue,fe)}catch{return null}return Y.forEach(function(Fe){We.test(Fe)&&(be&&Oe.compare(Fe)!==-1||(Oe=new he(be=Fe,fe)))}),be},e.minSatisfying=function(Y,ue,fe){var be=null,Oe=null;try{var We=new pe(ue,fe)}catch{return null}return Y.forEach(function(Fe){We.test(Fe)&&(be&&Oe.compare(Fe)!==1||(Oe=new he(be=Fe,fe)))}),be},e.validRange=function(Y,ue){try{return new pe(Y,ue).range||"*"}catch{return null}},e.ltr=function(Y,ue,fe){return $e(Y,ue,"<",fe)},e.gtr=function(Y,ue,fe){return $e(Y,ue,">",fe)},e.outside=$e,e.prerelease=function(Y,ue){var fe=G(Y,ue);return fe&&fe.prerelease.length?fe.prerelease:null},e.intersects=function(Y,ue,fe){return Y=new pe(Y,fe),ue=new pe(ue,fe),Y.intersects(ue)},e.coerce=function(Y){if(Y instanceof he)return Y;if(typeof Y!="string")return null;var ue=Y.match(P[L]);return ue==null?null:G((ue[1]||"0")+"."+(ue[2]||"0")+"."+(ue[3]||"0"))}}).call(this,i(1))},function(V,e){var i,o,S=V.exports={};function D(){throw new Error("setTimeout has not been defined")}function O(){throw new Error("clearTimeout has not been defined")}function P(p){if(i===setTimeout)return setTimeout(p,0);if((i===D||!i)&&setTimeout)return i=setTimeout,setTimeout(p,0);try{return i(p,0)}catch{try{return i.call(null,p,0)}catch{return i.call(this,p,0)}}}(function(){try{i=typeof setTimeout=="function"?setTimeout:D}catch{i=D}try{o=typeof clearTimeout=="function"?clearTimeout:O}catch{o=O}})();var y,a=[],h=!1,f=-1;function g(){h&&y&&(h=!1,y.length?a=y.concat(a):f=-1,a.length&&b())}function b(){if(!h){var p=P(g);h=!0;for(var $=a.length;$;){for(y=a,a=[];++f<$;)y&&y[f].run();f=-1,$=a.length}y=null,h=!1,function(w){if(o===clearTimeout)return clearTimeout(w);if((o===O||!o)&&clearTimeout)return o=clearTimeout,clearTimeout(w);try{o(w)}catch{try{return o.call(null,w)}catch{return o.call(this,w)}}}(p)}}function l(p,$){this.fun=p,this.array=$}function m(){}S.nextTick=function(p){var $=new Array(arguments.length-1);if(arguments.length>1)for(var w=1;w<arguments.length;w++)$[w-1]=arguments[w];a.push(new l(p,$)),a.length!==1||h||P(b)},l.prototype.run=function(){this.fun.apply(null,this.array)},S.title="browser",S.browser=!0,S.env={},S.argv=[],S.version="",S.versions={},S.on=m,S.addListener=m,S.once=m,S.off=m,S.removeListener=m,S.removeAllListeners=m,S.emit=m,S.prependListener=m,S.prependOnceListener=m,S.listeners=function(p){return[]},S.binding=function(p){throw new Error("process.binding is not supported")},S.cwd=function(){return"/"},S.chdir=function(p){throw new Error("process.chdir is not supported")},S.umask=function(){return 0}}])}),define(oe[144],ae([0,1]),function(V,e){"use strict";var i;Object.defineProperty(e,"__esModule",{value:!0}),e.$Ms=void 0;class o{constructor(P,y,a){this.level=P,this.key=y,this.value=a,this.forward=[]}}const S=void 0;class D{constructor(P,y=2**16){this.comparator=P,this[i]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(y)|0),this.e=new o(this.c,S,S)}get size(){return this.f}clear(){this.e=new o(this.c,S,S),this.f=0}has(P){return!!D.g(this,P,this.comparator)}get(P){return D.g(this,P,this.comparator)?.value}set(P,y){return D.h(this,P,y,this.comparator)&&(this.f+=1),this}delete(P){const y=D.k(this,P,this.comparator);return y&&(this.f-=1),y}forEach(P,y){let a=this.e.forward[0];for(;a;)P.call(y,a.value,a.key,this),a=a.forward[0]}[(i=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let P=this.e.forward[0];for(;P;)yield[P.key,P.value],P=P.forward[0]}*keys(){let P=this.e.forward[0];for(;P;)yield P.key,P=P.forward[0]}*values(){let P=this.e.forward[0];for(;P;)yield P.value,P=P.forward[0]}toString(){let P="[SkipList]:",y=this.e.forward[0];for(;y;)P+=`node(${y.key}, ${y.value}, lvl:${y.level})`,y=y.forward[0];return P}static g(P,y,a){let h=P.e;for(let f=P.d-1;f>=0;f--)for(;h.forward[f]&&a(h.forward[f].key,y)<0;)h=h.forward[f];if(h=h.forward[0],h&&a(h.key,y)===0)return h}static h(P,y,a,h){const f=[];let g=P.e;for(let b=P.d-1;b>=0;b--){for(;g.forward[b]&&h(g.forward[b].key,y)<0;)g=g.forward[b];f[b]=g}if(g=g.forward[0],g&&h(g.key,y)===0)return g.value=a,!1;{const b=D.j(P);if(b>P.d){for(let l=P.d;l<b;l++)f[l]=P.e;P.d=b}g=new o(b,y,a);for(let l=0;l<b;l++)g.forward[l]=f[l].forward[l],f[l].forward[l]=g;return!0}}static j(P,y=.5){let a=1;for(;Math.random()<y&&a<P.c;)a+=1;return a}static k(P,y,a){const h=[];let f=P.e;for(let g=P.d-1;g>=0;g--){for(;f.forward[g]&&a(f.forward[g].key,y)<0;)f=f.forward[g];h[g]=f}if(f=f.forward[0],!f||a(f.key,y)!==0)return!1;for(let g=0;g<P.d&&h[g].forward[g]===f;g++)h[g].forward[g]=f.forward[g];for(;P.d>0&&P.e.forward[P.d-1]===S;)P.d-=1;return!0}}e.$Ms=D}),define(oe[66],ae([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ge=void 0;const i=globalThis.performance&&typeof globalThis.performance.now=="function";class o{static create(D){return new o(D)}constructor(D){this.c=i&&D===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$ge=o}),define(oe[3],ae([0,1,16,89,2,109,66]),function(V,e,i,o,S,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$we=e.$ve=e.$ue=e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$ie=e.Event=void 0,e.$je=b;const P=!1,y=!1,a=!1;var h;(function(N){N.None=()=>S.$Wc.None;function z(ke){if(a){const{onDidAddListener:Pe}=ke,De=m.create();let $e=0;ke.onDidAddListener=()=>{++$e===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),De.print()),Pe?.()}}}function ne(ke,Pe){return G(ke,()=>{},0,void 0,!0,void 0,Pe)}N.defer=ne;function Q(ke){return(Pe,De=null,$e)=>{let Y=!1,ue;return ue=ke(fe=>{if(!Y)return ue?ue.dispose():Y=!0,Pe.call(De,fe)},null,$e),Y&&ue.dispose(),ue}}N.once=Q;function le(ke,Pe,De){return x(($e,Y=null,ue)=>ke(fe=>$e.call(Y,Pe(fe)),null,ue),De)}N.map=le;function K(ke,Pe,De){return x(($e,Y=null,ue)=>ke(fe=>{Pe(fe),$e.call(Y,fe)},null,ue),De)}N.forEach=K;function ee(ke,Pe,De){return x(($e,Y=null,ue)=>ke(fe=>Pe(fe)&&$e.call(Y,fe),null,ue),De)}N.filter=ee;function H(ke){return ke}N.signal=H;function j(...ke){return(Pe,De=null,$e)=>{const Y=(0,S.$Tc)(...ke.map(ue=>ue(fe=>Pe.call(De,fe))));return ce(Y,$e)}}N.any=j;function B(ke,Pe,De,$e){let Y=De;return le(ke,ue=>(Y=Pe(Y,ue),Y),$e)}N.reduce=B;function x(ke,Pe){let De;const $e={onWillAddFirstListener(){De=ke(Y.fire,Y)},onDidRemoveLastListener(){De?.dispose()}};Pe||z($e);const Y=new n($e);return Pe?.add(Y),Y.event}function ce(ke,Pe){return Pe instanceof Array?Pe.push(ke):Pe&&Pe.add(ke),ke}function G(ke,Pe,De=100,$e=!1,Y=!1,ue,fe){let be,Oe,We,Fe=0,Ae;const Be={leakWarningThreshold:ue,onWillAddFirstListener(){be=ke(Ye=>{Fe++,Oe=Pe(Oe,Ye),$e&&!We&&(xe.fire(Oe),Oe=void 0),Ae=()=>{const qe=Oe;Oe=void 0,We=void 0,(!$e||Fe>1)&&xe.fire(qe),Fe=0},typeof De=="number"?(clearTimeout(We),We=setTimeout(Ae,De)):We===void 0&&(We=0,queueMicrotask(Ae))})},onWillRemoveListener(){Y&&Fe>0&&Ae?.()},onDidRemoveLastListener(){Ae=void 0,be.dispose()}};fe||z(Be);const xe=new n(Be);return fe?.add(xe),xe.event}N.debounce=G;function he(ke,Pe=0,De){return N.debounce(ke,($e,Y)=>$e?($e.push(Y),$e):[Y],Pe,void 0,!0,void 0,De)}N.accumulate=he;function se(ke,Pe=($e,Y)=>$e===Y,De){let $e=!0,Y;return ee(ke,ue=>{const fe=$e||!Pe(ue,Y);return $e=!1,Y=ue,fe},De)}N.latch=se;function _(ke,Pe,De){return[N.filter(ke,Pe,De),N.filter(ke,$e=>!Pe($e),De)]}N.split=_;function F(ke,Pe=!1,De=[],$e){let Y=De.slice(),ue=ke(Oe=>{Y?Y.push(Oe):be.fire(Oe)});$e&&$e.add(ue);const fe=()=>{Y?.forEach(Oe=>be.fire(Oe)),Y=null},be=new n({onWillAddFirstListener(){ue||(ue=ke(Oe=>be.fire(Oe)),$e&&$e.add(ue))},onDidAddFirstListener(){Y&&(Pe?setTimeout(fe):fe())},onDidRemoveLastListener(){ue&&ue.dispose(),ue=null}});return $e&&$e.add(be),be.event}N.buffer=F;function C(ke,Pe){return($e,Y,ue)=>{const fe=Pe(new q);return ke(function(be){const Oe=fe.evaluate(be);Oe!==W&&$e.call(Y,Oe)},void 0,ue)}}N.chain=C;const W=Symbol("HaltChainable");class q{constructor(){this.f=[]}map(Pe){return this.f.push(Pe),this}forEach(Pe){return this.f.push(De=>(Pe(De),De)),this}filter(Pe){return this.f.push(De=>Pe(De)?De:W),this}reduce(Pe,De){let $e=De;return this.f.push(Y=>($e=Pe($e,Y),$e)),this}latch(Pe=(De,$e)=>De===$e){let De=!0,$e;return this.f.push(Y=>{const ue=De||!Pe(Y,$e);return De=!1,$e=Y,ue?Y:W}),this}evaluate(Pe){for(const De of this.f)if(Pe=De(Pe),Pe===W)break;return Pe}}function J(ke,Pe,De=$e=>$e){const $e=(...be)=>fe.fire(De(...be)),Y=()=>ke.on(Pe,$e),ue=()=>ke.removeListener(Pe,$e),fe=new n({onWillAddFirstListener:Y,onDidRemoveLastListener:ue});return fe.event}N.fromNodeEventEmitter=J;function X(ke,Pe,De=$e=>$e){const $e=(...be)=>fe.fire(De(...be)),Y=()=>ke.addEventListener(Pe,$e),ue=()=>ke.removeEventListener(Pe,$e),fe=new n({onWillAddFirstListener:Y,onDidRemoveLastListener:ue});return fe.event}N.fromDOMEventEmitter=X;function Z(ke){return new Promise(Pe=>Q(ke)(Pe))}N.toPromise=Z;function ie(ke){const Pe=new n;return ke.then(De=>{Pe.fire(De)},()=>{Pe.fire(void 0)}).finally(()=>{Pe.dispose()}),Pe.event}N.fromPromise=ie;function de(ke,Pe,De){return Pe(De),ke($e=>Pe($e))}N.runAndSubscribe=de;class me{constructor(Pe,De){this._observable=Pe,this.f=0,this.g=!1;const $e={onWillAddFirstListener:()=>{Pe.addObserver(this)},onDidRemoveLastListener:()=>{Pe.removeObserver(this)}};De||z($e),this.emitter=new n($e),De&&De.add(this.emitter)}beginUpdate(Pe){this.f++}handlePossibleChange(Pe){}handleChange(Pe,De){this.g=!0}endUpdate(Pe){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function pe(ke,Pe){return new me(ke,Pe).emitter.event}N.fromObservable=pe;function Ie(ke){return(Pe,De,$e)=>{let Y=0,ue=!1;const fe={beginUpdate(){Y++},endUpdate(){Y--,Y===0&&(ke.reportChanges(),ue&&(ue=!1,Pe.call(De)))},handlePossibleChange(){},handleChange(){ue=!0}};ke.addObserver(fe),ke.reportChanges();const be={dispose(){ke.removeObserver(fe)}};return $e instanceof S.$Vc?$e.add(be):Array.isArray($e)&&$e.push(be),be}}N.fromObservableLight=Ie})(h||(e.Event=h={}));class f{static{this.all=new Set}static{this.f=0}constructor(z){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${z}_${f.f++}`,f.all.add(this)}start(z){this.g=new O.$ge,this.listenerCount=z}stop(){if(this.g){const z=this.g.elapsed();this.durations.push(z),this.elapsedOverall+=z,this.invocationCount+=1,this.g=void 0}}}e.$ie=f;let g=-1;function b(N){const z=g;return g=N,{dispose(){g=z}}}class l{static{this.f=1}constructor(z,ne,Q=(l.f++).toString(16).padStart(3,"0")){this.j=z,this.threshold=ne,this.name=Q,this.h=0}dispose(){this.g?.clear()}check(z,ne){const Q=this.threshold;if(Q<=0||ne<Q)return;this.g||(this.g=new Map);const le=this.g.get(z.value)||0;if(this.g.set(z.value,le+1),this.h-=1,this.h<=0){this.h=Q*.5;const[K,ee]=this.getMostFrequentStack(),H=`[${this.name}] potential listener LEAK detected, having ${ne} listeners already. MOST frequent listener (${ee}):`;console.warn(H),console.warn(K);const j=new p(H,K);this.j(j)}return()=>{const K=this.g.get(z.value)||0;this.g.set(z.value,K-1)}}getMostFrequentStack(){if(!this.g)return;let z,ne=0;for(const[Q,le]of this.g)(!z||ne<le)&&(z=[Q,le],ne=le);return z}}class m{static create(){const z=new Error;return new m(z.stack??"")}constructor(z){this.value=z}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class p extends Error{constructor(z,ne){super(z),this.name="ListenerLeakError",this.stack=ne}}e.$ke=p;class $ extends Error{constructor(z,ne){super(z),this.name="ListenerRefusalError",this.stack=ne}}e.$le=$;let w=0;class v{constructor(z){this.value=z,this.id=w++}}const k=2,t=(N,z)=>{if(N instanceof v)z(N);else for(let ne=0;ne<N.length;ne++){const Q=N[ne];Q&&z(Q)}};let r;if(P){const N=[];setInterval(()=>{N.length!==0&&(console.warn("[LEAKING LISTENERS] GC'ed these listeners that were NOT yet disposed:"),console.warn(N.join(`
`)),N.length=0)},3e3),r=new FinalizationRegistry(z=>{typeof z=="string"&&N.push(z)})}class n{constructor(z){this.z=0,this.f=z,this.g=g>0||this.f?.leakWarningThreshold?new l(z?.onListenerError??i.$3,this.f?.leakWarningThreshold??g):void 0,this.j=this.f?._profName?new f(this.f._profName):void 0,this.w=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.w?.current===this&&this.w.reset(),this.u){if(y){const z=this.u;queueMicrotask(()=>{t(z,ne=>ne.stack?.print())})}this.u=void 0,this.z=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(z,ne,Q)=>{if(this.g&&this.z>this.g.threshold**2){const j=`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far (${this.z} vs ${this.g.threshold})`;console.warn(j);const B=this.g.getMostFrequentStack()??["UNKNOWN stack",-1],x=new $(`${j}. HINT: Stack shows most frequent listener (${B[1]}-times)`,B[0]);return(this.f?.onListenerError||i.$3)(x),S.$Wc.None}if(this.m)return S.$Wc.None;ne&&(z=z.bind(ne));const le=new v(z);let K,ee;this.g&&this.z>=Math.ceil(this.g.threshold*.2)&&(le.stack=m.create(),K=this.g.check(le.stack,this.z+1)),y&&(le.stack=ee??m.create()),this.u?this.u instanceof v?(this.w??=new s,this.u=[this.u,le]):this.u.push(le):(this.f?.onWillAddFirstListener?.(this),this.u=le,this.f?.onDidAddFirstListener?.(this)),this.z++;const H=(0,S.$Uc)(()=>{r?.unregister(H),K?.(),this.A(le)});if(Q instanceof S.$Vc?Q.add(H):Array.isArray(Q)&&Q.push(H),r){const j=new Error().stack.split(`
`).slice(2,3).join(`
`).trim(),B=/(file:|vscode-file:\/\/vscode-app)?(\/[^:]*:\d+:\d+)/.exec(j);r.register(H,B?.[2]??j,H)}return H},this.q}A(z){if(this.f?.onWillRemoveListener?.(this),!this.u)return;if(this.z===1){this.u=void 0,this.f?.onDidRemoveLastListener?.(this),this.z=0;return}const ne=this.u,Q=ne.indexOf(z);if(Q===-1)throw console.log("disposed?",this.m),console.log("size?",this.z),console.log("arr?",JSON.stringify(this.u)),new Error("Attempted to dispose unknown listener");this.z--,ne[Q]=void 0;const le=this.w.current===this;if(this.z*k<=ne.length){let K=0;for(let ee=0;ee<ne.length;ee++)ne[ee]?ne[K++]=ne[ee]:le&&(this.w.end--,K<this.w.i&&this.w.i--);ne.length=K}}B(z,ne){if(!z)return;const Q=this.f?.onListenerError||i.$3;if(!Q){z.value(ne);return}try{z.value(ne)}catch(le){Q(le)}}C(z){const ne=z.current.u;for(;z.i<z.end;)this.B(ne[z.i++],z.value);z.reset()}fire(z){if(this.w?.current&&(this.C(this.w),this.j?.stop()),this.j?.start(this.z),this.u)if(this.u instanceof v)this.B(this.u,z);else{const ne=this.w;ne.enqueue(this,z,this.u.length),this.C(ne)}this.j?.stop()}hasListeners(){return this.z>0}}e.$me=n;const c=()=>new s;e.$ne=c;class s{constructor(){this.i=-1,this.end=0}enqueue(z,ne,Q){this.i=0,this.end=Q,this.current=z,this.value=ne}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class u extends n{async fireAsync(z,ne,Q){if(this.u)for(this.h||(this.h=new D.$7c),t(this.u,le=>this.h.push([le.value,z]));this.h.size>0&&!ne.isCancellationRequested;){const[le,K]=this.h.shift(),ee=[],H={...K,token:ne,waitUntil:j=>{if(Object.isFrozen(ee))throw new Error("waitUntil can NOT be called asynchronous");Q&&(j=Q(j,le)),ee.push(j)}};try{le(H)}catch(j){(0,i.$3)(j);continue}Object.freeze(ee),await Promise.allSettled(ee).then(j=>{for(const B of j)B.status==="rejected"&&(0,i.$3)(B.reason)})}}}e.$oe=u;class d extends n{get isPaused(){return this.h!==0}constructor(z){super(z),this.h=0,this.s=new D.$7c,this.t=z?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.t){if(this.s.size>0){const z=Array.from(this.s);this.s.clear(),super.fire(this.t(z))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(z){this.z&&(this.h!==0?this.s.push(z):super.fire(z))}}e.$pe=d;class I extends d{constructor(z){super(z),this.k=z.delay??100}fire(z){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(z)}}e.$qe=I;class E extends n{constructor(z){super(z),this.h=[],this.k=z?.merge}fire(z){this.hasListeners()&&(this.h.push(z),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(ne=>super.fire(ne)),this.h=[]}))}}e.$re=E;class A{constructor(){this.g=!1,this.h=[],this.f=new n({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(z){const ne={event:z,listener:null};this.h.push(ne),this.g&&this.m(ne);const Q=()=>{this.g&&this.o(ne);const le=this.h.indexOf(ne);this.h.splice(le,1)};return(0,S.$Uc)((0,o.$fb)(Q))}j(){this.g=!0,this.h.forEach(z=>this.m(z))}k(){this.g=!1,this.h.forEach(z=>this.o(z))}m(z){z.listener=z.event(ne=>this.f.fire(ne))}o(z){z.listener?.dispose(),z.listener=null}dispose(){this.f.dispose();for(const z of this.h)z.listener?.dispose();this.h=[]}}e.$se=A;class T{constructor(z,ne,Q,le){this.f=new S.$Vc;const K=this.f.add(new A),ee=this.f.add(new S.$6c);function H(j){ee.set(j,K.add(le(j)))}for(const j of z)H(j);this.f.add(ne(j=>{H(j)})),this.f.add(Q(j=>{ee.deleteAndDispose(j)})),this.event=K.event}dispose(){this.f.dispose()}}e.$te=T;class L{constructor(){this.f=[]}wrapEvent(z,ne,Q){return(le,K,ee)=>z(H=>{const j=this.f[this.f.length-1];if(!ne){j?j.buffers.push(()=>le.call(K,H)):le.call(K,H);return}const B=j;if(!B){le.call(K,ne(Q,H));return}B.items??=[],B.items.push(H),B.buffers.length===0&&j.buffers.push(()=>{B.reducedResult??=Q?B.items.reduce(ne,Q):B.items.reduce(ne),le.call(K,B.reducedResult)})},void 0,ee)}bufferEvents(z){const ne={buffers:new Array};this.f.push(ne);const Q=z();return this.f.pop(),ne.buffers.forEach(le=>le()),Q}}e.$ue=L;class R{constructor(){this.f=!1,this.g=h.None,this.h=S.$Wc.None,this.j=new n({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(z){this.g=z,this.f&&(this.h.dispose(),this.h=z(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$ve=R;class M{static const(z){return new U(z)}constructor(z){this.g=z,this.f=new n,this.onDidChange=this.f.event}get value(){return this.g}set value(z){z!==this.g&&(this.g=z,this.f.fire(void 0))}}e.$we=M;class U{constructor(z){this.value=z,this.onDidChange=h.None}}}),define(oe[23],ae([0,1,3]),function(V,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xe=e.CancellationToken=void 0,e.$ye=P;const o=Object.freeze(function(y,a){const h=setTimeout(y.bind(a),0);return{dispose(){clearTimeout(h)}}});var S;(function(y){function a(h){return h===y.None||h===y.Cancelled||h instanceof D?!0:!h||typeof h!="object"?!1:typeof h.isCancellationRequested=="boolean"&&typeof h.onCancellationRequested=="function"}y.isCancellationToken=a,y.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:i.Event.None}),y.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:o})})(S||(e.CancellationToken=S={}));class D{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?o:(this.b||(this.b=new i.$me),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class O{constructor(a){this.f=void 0,this.g=void 0,this.g=a&&a.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new D),this.f}cancel(){this.f?this.f instanceof D&&this.f.cancel():this.f=S.Cancelled}dispose(a=!1){a&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof D&&this.f.dispose():this.f=S.None}}e.$xe=O;function P(y){const a=new O;return y.add({dispose(){a.cancel()}}),a.token}}),define(oe[145],ae([0,1,23]),function(V,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$af=e.$_e=e.$0e=void 0,e.$$e=S;class o{constructor(y){this.b=y,this.a=null}get(){if(this.a)return this.a;const y=new i.$xe,a=this.b(y.token);return this.a={promise:a,dispose:()=>{this.a=null,y.cancel(),y.dispose()}},this.a}}e.$0e=o;function S(P){return P}class D{constructor(y,a){this.a=void 0,this.b=void 0,typeof y=="function"?(this.c=y,this.d=S):(this.c=a,this.d=y.getCacheKey)}get(y){const a=this.d(y);return this.b!==a&&(this.b=a,this.a=this.c(y)),this.a}}e.$_e=D;class O{get cachedValues(){return this.a}constructor(y,a){this.a=new Map,this.b=new Map,typeof y=="function"?(this.c=y,this.d=S):(this.c=a,this.d=y.getCacheKey)}get(y){const a=this.d(y);if(this.b.has(a))return this.b.get(a);const h=this.c(y);return this.a.set(y,h),this.b.set(a,h),h}}e.$af=O}),define(oe[67],ae([0,1,16,2]),function(V,e,i,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ze=S,e.$Ae=D,e.$Be=O,e.$Ce=P,e.$De=a,e.$Ee=h,e.$Fe=f,e.$Ge=g,e.$He=b,e.$Ie=l,e.$Je=m,e.$Ke=p,e.$Le=$,e.$Me=w,e.$Ne=v;function S(k){const t=k;return t?typeof t.read=="function":!1}function D(k){const t=k;return t?[t.on,t.pause,t.resume,t.destroy].every(r=>typeof r=="function"):!1}function O(k){const t=k;return t?D(t.stream)&&Array.isArray(t.buffer)&&typeof t.ended=="boolean":!1}function P(k,t){return new y(k,t)}class y{constructor(t,r){this.e=t,this.f=r,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(t){if(!this.a.destroyed){if(this.a.flowing)this.g(t);else if(this.b.data.push(t),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(r=>this.d.push(r))}}error(t){this.a.destroyed||(this.a.flowing?this.h(t):this.b.error.push(t))}end(t){this.a.destroyed||(typeof t<"u"&&this.write(t),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(t){this.c.data.slice(0).forEach(r=>r(t))}h(t){this.c.error.length===0?(0,i.$3)(t):this.c.error.slice(0).forEach(r=>r(t))}i(){this.c.end.slice(0).forEach(t=>t())}on(t,r){if(!this.a.destroyed)switch(t){case"data":this.c.data.push(r),this.resume();break;case"end":this.c.end.push(r),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(r),this.a.flowing&&this.k();break}}removeListener(t,r){if(this.a.destroyed)return;let n;switch(t){case"data":n=this.c.data;break;case"end":n=this.c.end;break;case"error":n=this.c.error;break}if(n){const c=n.indexOf(r);c>=0&&n.splice(c,1)}}j(){if(this.b.data.length>0){const t=this.e(this.b.data);this.g(t),this.b.data.length=0;const r=[...this.d];this.d.length=0,r.forEach(n=>n())}}k(){if(this.c.error.length>0){for(const t of this.b.error)this.h(t);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function a(k,t){const r=[];let n;for(;(n=k.read())!==null;)r.push(n);return t(r)}function h(k,t,r){const n=[];let c;for(;(c=k.read())!==null&&n.length<r;)n.push(c);return c===null&&n.length>0?t(n):{read:()=>{if(n.length>0)return n.shift();if(typeof c<"u"){const s=c;return c=void 0,s}return k.read()}}}function f(k,t){return new Promise((r,n)=>{const c=[];g(k,{onData:s=>{t&&c.push(s)},onError:s=>{t?n(s):r(void 0)},onEnd:()=>{r(t?t(c):void 0)}})})}function g(k,t,r){k.on("error",n=>{r?.isCancellationRequested||t.onError(n)}),k.on("end",()=>{r?.isCancellationRequested||t.onEnd()}),k.on("data",n=>{r?.isCancellationRequested||t.onData(n)})}function b(k,t){return new Promise((r,n)=>{const c=new o.$Vc,s=[],u=E=>{if(s.push(E),s.length>t)return c.dispose(),k.pause(),r({stream:k,buffer:s,ended:!1})},d=E=>(c.dispose(),n(E)),I=()=>(c.dispose(),r({stream:k,buffer:s,ended:!0}));c.add((0,o.$Uc)(()=>k.removeListener("error",d))),k.on("error",d),c.add((0,o.$Uc)(()=>k.removeListener("end",I))),k.on("end",I),c.add((0,o.$Uc)(()=>k.removeListener("data",u))),k.on("data",u)})}function l(k,t){const r=P(t);return r.end(k),r}function m(){const k=P(()=>{throw new Error("not supported")});return k.end(),k}function p(k){let t=!1;return{read:()=>t?null:(t=!0,k)}}function $(k,t,r){const n=P(r);return g(k,{onData:c=>n.write(t.data(c)),onError:c=>n.error(t.error?t.error(c):c),onEnd:()=>n.end()}),n}function w(k,t,r){let n=!1;return{read:()=>{const c=t.read();return n?c:(n=!0,c!==null?r([k,c]):k)}}}function v(k,t,r){let n=!1;const c=P(r);return g(t,{onData:s=>n?c.write(s):(n=!0,c.write(r([k,s]))),onError:s=>c.error(s),onEnd:()=>{n||(n=!0,c.write(k)),c.end()}}),c}});var Dt=this&&this.__createBinding||(Object.create?function(V,e,i,o){o===void 0&&(o=i);var S=Object.getOwnPropertyDescriptor(e,i);(!S||("get"in S?!e.__esModule:S.writable||S.configurable))&&(S={enumerable:!0,get:function(){return e[i]}}),Object.defineProperty(V,o,S)}:function(V,e,i,o){o===void 0&&(o=i),V[o]=e[i]}),Rt=this&&this.__setModuleDefault||(Object.create?function(V,e){Object.defineProperty(V,"default",{enumerable:!0,value:e})}:function(V,e){V.default=e}),Re=this&&this.__importStar||function(V){if(V&&V.__esModule)return V;var e={};if(V!=null)for(var i in V)i!=="default"&&Object.prototype.hasOwnProperty.call(V,i)&&Dt(e,V,i);return Rt(e,V),e};define(oe[17],ae([0,1,65,67]),function(V,e,i,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oe=void 0,e.$Pe=a,e.$Qe=h,e.$Re=f,e.$Se=g,e.$Te=b,e.$Ue=l,e.$Ve=m,e.$We=p,e.$Xe=$,e.$Ye=w,e.$Ze=v,e.$1e=k,e.$2e=t,e.$3e=r,e.$4e=n,e.$5e=c,e.$6e=s,e.$7e=u,e.$8e=d,e.$9e=A,o=Re(o);const S=typeof Buffer<"u",D=new i.$X(()=>new Uint8Array(256));let O,P;class y{static alloc(L){return S?new y(Buffer.allocUnsafe(L)):new y(new Uint8Array(L))}static wrap(L){return S&&!Buffer.isBuffer(L)&&(L=Buffer.from(L.buffer,L.byteOffset,L.byteLength)),new y(L)}static fromString(L,R){return!(R?.dontUseNodeBuffer||!1)&&S?new y(Buffer.from(L)):(O||(O=new TextEncoder),new y(O.encode(L)))}static fromByteArray(L){const R=y.alloc(L.length);for(let M=0,U=L.length;M<U;M++)R.buffer[M]=L[M];return R}static concat(L,R){if(typeof R>"u"){R=0;for(let N=0,z=L.length;N<z;N++)R+=L[N].byteLength}const M=y.alloc(R);let U=0;for(let N=0,z=L.length;N<z;N++){const ne=L[N];M.set(ne,U),U+=ne.byteLength}return M}constructor(L){this.buffer=L,this.byteLength=this.buffer.byteLength}clone(){const L=y.alloc(this.byteLength);return L.set(this),L}toString(){return S?this.buffer.toString():(P||(P=new TextDecoder),P.decode(this.buffer))}slice(L,R){return new y(this.buffer.subarray(L,R))}set(L,R){if(L instanceof y)this.buffer.set(L.buffer,R);else if(L instanceof Uint8Array)this.buffer.set(L,R);else if(L instanceof ArrayBuffer)this.buffer.set(new Uint8Array(L),R);else if(ArrayBuffer.isView(L))this.buffer.set(new Uint8Array(L.buffer,L.byteOffset,L.byteLength),R);else throw new Error("Unknown argument 'array'")}readUInt32BE(L){return g(this.buffer,L)}writeUInt32BE(L,R){b(this.buffer,L,R)}readUInt32LE(L){return l(this.buffer,L)}writeUInt32LE(L,R){m(this.buffer,L,R)}readUInt8(L){return p(this.buffer,L)}writeUInt8(L,R){$(this.buffer,L,R)}indexOf(L,R=0){return a(this.buffer,L instanceof y?L.buffer:L,R)}}e.$Oe=y;function a(T,L,R=0){const M=L.byteLength,U=T.byteLength;if(M===0)return 0;if(M===1)return T.indexOf(L[0]);if(M>U-R)return-1;const N=D.value;N.fill(L.length);for(let le=0;le<L.length;le++)N[L[le]]=L.length-le-1;let z=R+L.length-1,ne=z,Q=-1;for(;z<U;)if(T[z]===L[ne]){if(ne===0){Q=z;break}z--,ne--}else z+=Math.max(L.length-ne,N[T[z]]),ne=L.length-1;return Q}function h(T,L){return T[L+0]<<0>>>0|T[L+1]<<8>>>0}function f(T,L,R){T[R+0]=L&255,L=L>>>8,T[R+1]=L&255}function g(T,L){return T[L]*2**24+T[L+1]*2**16+T[L+2]*2**8+T[L+3]}function b(T,L,R){T[R+3]=L,L=L>>>8,T[R+2]=L,L=L>>>8,T[R+1]=L,L=L>>>8,T[R]=L}function l(T,L){return T[L+0]<<0>>>0|T[L+1]<<8>>>0|T[L+2]<<16>>>0|T[L+3]<<24>>>0}function m(T,L,R){T[R+0]=L&255,L=L>>>8,T[R+1]=L&255,L=L>>>8,T[R+2]=L&255,L=L>>>8,T[R+3]=L&255}function p(T,L){return T[L]}function $(T,L,R){T[R]=L}function w(T){return o.$De(T,L=>y.concat(L))}function v(T){return o.$Ke(T)}function k(T){return o.$Fe(T,L=>y.concat(L))}async function t(T){return T.ended?y.concat(T.buffer):y.concat([...T.buffer,await k(T.stream)])}function r(T){return o.$Ie(T,L=>y.concat(L))}function n(T){return o.$Le(T,{data:L=>typeof L=="string"?y.fromString(L):y.wrap(L)},L=>y.concat(L))}function c(T){return o.$Ce(L=>y.concat(L),T)}function s(T,L){return o.$Me(T,L,R=>y.concat(R))}function u(T,L){return o.$Ne(T,L,R=>y.concat(R))}function d(T){let L=0,R=0,M=0;const U=new Uint8Array(Math.floor(T.length/4*3)),N=ne=>{switch(R){case 3:U[M++]=L|ne,R=0;break;case 2:U[M++]=L|ne>>>2,L=ne<<6,R=3;break;case 1:U[M++]=L|ne>>>4,L=ne<<4,R=2;break;default:L=ne<<2,R=1}};for(let ne=0;ne<T.length;ne++){const Q=T.charCodeAt(ne);if(Q>=65&&Q<=90)N(Q-65);else if(Q>=97&&Q<=122)N(Q-97+26);else if(Q>=48&&Q<=57)N(Q-48+52);else if(Q===43||Q===45)N(62);else if(Q===47||Q===95)N(63);else{if(Q===61)break;throw new SyntaxError(`Unexpected base64 character ${T[ne]}`)}}const z=M;for(;R>0;)N(0);return y.wrap(U).slice(0,z)}const I="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",E="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function A({buffer:T},L=!0,R=!1){const M=R?E:I;let U="";const N=T.byteLength%3;let z=0;for(;z<T.byteLength-N;z+=3){const ne=T[z+0],Q=T[z+1],le=T[z+2];U+=M[ne>>>2],U+=M[(ne<<4|Q>>>4)&63],U+=M[(Q<<2|le>>>6)&63],U+=M[le&63]}if(N===1){const ne=T[z+0];U+=M[ne>>>2],U+=M[ne<<4&63],L&&(U+="==")}else if(N===2){const ne=T[z+0],Q=T[z+1];U+=M[ne>>>2],U+=M[(ne<<4|Q>>>4)&63],U+=M[Q<<2&63],L&&(U+="=")}return U}}),define(oe[146],ae([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$he=void 0,e.$he=Symbol("MicrotaskDelay")}),define(oe[12],ae([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fg=i,e.$gg=o,e.$hg=S,e.$ig=D,e.$jg=O,e.$kg=P,e.$lg=y,e.$mg=a,e.$ng=h,e.$og=f,e.$pg=g,e.$qg=b,e.$rg=l,e.$sg=p,e.$tg=$,e.$ug=w,e.$vg=v,e.$wg=k;function i(t){return typeof t=="string"}function o(t){return Array.isArray(t)&&t.every(r=>i(r))}function S(t){return typeof t=="object"&&t!==null&&!Array.isArray(t)&&!(t instanceof RegExp)&&!(t instanceof Date)}function D(t){const r=Object.getPrototypeOf(Uint8Array);return typeof t=="object"&&t instanceof r}function O(t){return typeof t=="number"&&!isNaN(t)}function P(t){return!!t&&typeof t[Symbol.iterator]=="function"}function y(t){return t===!0||t===!1}function a(t){return typeof t>"u"}function h(t){return!f(t)}function f(t){return a(t)||t===null}function g(t,r){if(!t)throw new Error(r?`Unexpected type, expected '${r}'`:"Unexpected type")}function b(t){if(f(t))throw new Error("Assertion Failed: argument is undefined or null");return t}function l(...t){const r=[];for(let n=0;n<t.length;n++){const c=t[n];if(f(c))throw new Error(`Assertion Failed: argument at index ${n} is undefined or null`);r.push(c)}return r}const m=Object.prototype.hasOwnProperty;function p(t){if(!S(t))return!1;for(const r in t)if(m.call(t,r))return!1;return!0}function $(t){return typeof t=="function"}function w(...t){return t.length>0&&t.every($)}function v(t,r){const n=Math.min(t.length,r.length);for(let c=0;c<n;c++)k(t[c],r[c])}function k(t,r){if(i(r)){if(typeof t!==r)throw new Error(`argument does not match constraint: typeof ${r}`)}else if($(r)){try{if(t instanceof r)return}catch{}if(!f(t)&&t.constructor===r||r.length===1&&r.call(void 0,t)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}}),define(oe[110],ae([0,1,12]),function(V,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zj=S,e.$1j=D;const o=Object.create(null);function S(O,P){if((0,i.$fg)(P)){const y=o[P];if(y===void 0)throw new Error(`${O} references an unknown codicon: ${P}`);P=y}return o[O]=P,{id:O}}function D(){return o}}),define(oe[147],ae([0,1,110]),function(V,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2j=void 0,e.$2j={add:(0,i.$Zj)("add",6e4),plus:(0,i.$Zj)("plus",6e4),gistNew:(0,i.$Zj)("gist-new",6e4),repoCreate:(0,i.$Zj)("repo-create",6e4),lightbulb:(0,i.$Zj)("lightbulb",60001),lightBulb:(0,i.$Zj)("light-bulb",60001),repo:(0,i.$Zj)("repo",60002),repoDelete:(0,i.$Zj)("repo-delete",60002),gistFork:(0,i.$Zj)("gist-fork",60003),repoForked:(0,i.$Zj)("repo-forked",60003),gitPullRequest:(0,i.$Zj)("git-pull-request",60004),gitPullRequestAbandoned:(0,i.$Zj)("git-pull-request-abandoned",60004),recordKeys:(0,i.$Zj)("record-keys",60005),keyboard:(0,i.$Zj)("keyboard",60005),tag:(0,i.$Zj)("tag",60006),gitPullRequestLabel:(0,i.$Zj)("git-pull-request-label",60006),tagAdd:(0,i.$Zj)("tag-add",60006),tagRemove:(0,i.$Zj)("tag-remove",60006),person:(0,i.$Zj)("person",60007),personFollow:(0,i.$Zj)("person-follow",60007),personOutline:(0,i.$Zj)("person-outline",60007),personFilled:(0,i.$Zj)("person-filled",60007),gitBranch:(0,i.$Zj)("git-branch",60008),gitBranchCreate:(0,i.$Zj)("git-branch-create",60008),gitBranchDelete:(0,i.$Zj)("git-branch-delete",60008),sourceControl:(0,i.$Zj)("source-control",60008),mirror:(0,i.$Zj)("mirror",60009),mirrorPublic:(0,i.$Zj)("mirror-public",60009),star:(0,i.$Zj)("star",60010),starAdd:(0,i.$Zj)("star-add",60010),starDelete:(0,i.$Zj)("star-delete",60010),starEmpty:(0,i.$Zj)("star-empty",60010),comment:(0,i.$Zj)("comment",60011),commentAdd:(0,i.$Zj)("comment-add",60011),alert:(0,i.$Zj)("alert",60012),warning:(0,i.$Zj)("warning",60012),search:(0,i.$Zj)("search",60013),searchSave:(0,i.$Zj)("search-save",60013),logOut:(0,i.$Zj)("log-out",60014),signOut:(0,i.$Zj)("sign-out",60014),logIn:(0,i.$Zj)("log-in",60015),signIn:(0,i.$Zj)("sign-in",60015),eye:(0,i.$Zj)("eye",60016),eyeUnwatch:(0,i.$Zj)("eye-unwatch",60016),eyeWatch:(0,i.$Zj)("eye-watch",60016),circleFilled:(0,i.$Zj)("circle-filled",60017),primitiveDot:(0,i.$Zj)("primitive-dot",60017),closeDirty:(0,i.$Zj)("close-dirty",60017),debugBreakpoint:(0,i.$Zj)("debug-breakpoint",60017),debugBreakpointDisabled:(0,i.$Zj)("debug-breakpoint-disabled",60017),debugHint:(0,i.$Zj)("debug-hint",60017),terminalDecorationSuccess:(0,i.$Zj)("terminal-decoration-success",60017),primitiveSquare:(0,i.$Zj)("primitive-square",60018),edit:(0,i.$Zj)("edit",60019),pencil:(0,i.$Zj)("pencil",60019),info:(0,i.$Zj)("info",60020),issueOpened:(0,i.$Zj)("issue-opened",60020),gistPrivate:(0,i.$Zj)("gist-private",60021),gitForkPrivate:(0,i.$Zj)("git-fork-private",60021),lock:(0,i.$Zj)("lock",60021),mirrorPrivate:(0,i.$Zj)("mirror-private",60021),close:(0,i.$Zj)("close",60022),removeClose:(0,i.$Zj)("remove-close",60022),x:(0,i.$Zj)("x",60022),repoSync:(0,i.$Zj)("repo-sync",60023),sync:(0,i.$Zj)("sync",60023),clone:(0,i.$Zj)("clone",60024),desktopDownload:(0,i.$Zj)("desktop-download",60024),beaker:(0,i.$Zj)("beaker",60025),microscope:(0,i.$Zj)("microscope",60025),vm:(0,i.$Zj)("vm",60026),deviceDesktop:(0,i.$Zj)("device-desktop",60026),file:(0,i.$Zj)("file",60027),fileText:(0,i.$Zj)("file-text",60027),more:(0,i.$Zj)("more",60028),ellipsis:(0,i.$Zj)("ellipsis",60028),kebabHorizontal:(0,i.$Zj)("kebab-horizontal",60028),mailReply:(0,i.$Zj)("mail-reply",60029),reply:(0,i.$Zj)("reply",60029),organization:(0,i.$Zj)("organization",60030),organizationFilled:(0,i.$Zj)("organization-filled",60030),organizationOutline:(0,i.$Zj)("organization-outline",60030),newFile:(0,i.$Zj)("new-file",60031),fileAdd:(0,i.$Zj)("file-add",60031),newFolder:(0,i.$Zj)("new-folder",60032),fileDirectoryCreate:(0,i.$Zj)("file-directory-create",60032),trash:(0,i.$Zj)("trash",60033),trashcan:(0,i.$Zj)("trashcan",60033),history:(0,i.$Zj)("history",60034),clock:(0,i.$Zj)("clock",60034),folder:(0,i.$Zj)("folder",60035),fileDirectory:(0,i.$Zj)("file-directory",60035),symbolFolder:(0,i.$Zj)("symbol-folder",60035),logoGithub:(0,i.$Zj)("logo-github",60036),markGithub:(0,i.$Zj)("mark-github",60036),github:(0,i.$Zj)("github",60036),terminal:(0,i.$Zj)("terminal",60037),console:(0,i.$Zj)("console",60037),repl:(0,i.$Zj)("repl",60037),zap:(0,i.$Zj)("zap",60038),symbolEvent:(0,i.$Zj)("symbol-event",60038),error:(0,i.$Zj)("error",60039),stop:(0,i.$Zj)("stop",60039),variable:(0,i.$Zj)("variable",60040),symbolVariable:(0,i.$Zj)("symbol-variable",60040),array:(0,i.$Zj)("array",60042),symbolArray:(0,i.$Zj)("symbol-array",60042),symbolModule:(0,i.$Zj)("symbol-module",60043),symbolPackage:(0,i.$Zj)("symbol-package",60043),symbolNamespace:(0,i.$Zj)("symbol-namespace",60043),symbolObject:(0,i.$Zj)("symbol-object",60043),symbolMethod:(0,i.$Zj)("symbol-method",60044),symbolFunction:(0,i.$Zj)("symbol-function",60044),symbolConstructor:(0,i.$Zj)("symbol-constructor",60044),symbolBoolean:(0,i.$Zj)("symbol-boolean",60047),symbolNull:(0,i.$Zj)("symbol-null",60047),symbolNumeric:(0,i.$Zj)("symbol-numeric",60048),symbolNumber:(0,i.$Zj)("symbol-number",60048),symbolStructure:(0,i.$Zj)("symbol-structure",60049),symbolStruct:(0,i.$Zj)("symbol-struct",60049),symbolParameter:(0,i.$Zj)("symbol-parameter",60050),symbolTypeParameter:(0,i.$Zj)("symbol-type-parameter",60050),symbolKey:(0,i.$Zj)("symbol-key",60051),symbolText:(0,i.$Zj)("symbol-text",60051),symbolReference:(0,i.$Zj)("symbol-reference",60052),goToFile:(0,i.$Zj)("go-to-file",60052),symbolEnum:(0,i.$Zj)("symbol-enum",60053),symbolValue:(0,i.$Zj)("symbol-value",60053),symbolRuler:(0,i.$Zj)("symbol-ruler",60054),symbolUnit:(0,i.$Zj)("symbol-unit",60054),activateBreakpoints:(0,i.$Zj)("activate-breakpoints",60055),archive:(0,i.$Zj)("archive",60056),arrowBoth:(0,i.$Zj)("arrow-both",60057),arrowDown:(0,i.$Zj)("arrow-down",60058),arrowLeft:(0,i.$Zj)("arrow-left",60059),arrowRight:(0,i.$Zj)("arrow-right",60060),arrowSmallDown:(0,i.$Zj)("arrow-small-down",60061),arrowSmallLeft:(0,i.$Zj)("arrow-small-left",60062),arrowSmallRight:(0,i.$Zj)("arrow-small-right",60063),arrowSmallUp:(0,i.$Zj)("arrow-small-up",60064),arrowUp:(0,i.$Zj)("arrow-up",60065),bell:(0,i.$Zj)("bell",60066),bold:(0,i.$Zj)("bold",60067),book:(0,i.$Zj)("book",60068),bookmark:(0,i.$Zj)("bookmark",60069),debugBreakpointConditionalUnverified:(0,i.$Zj)("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:(0,i.$Zj)("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:(0,i.$Zj)("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:(0,i.$Zj)("debug-breakpoint-data-unverified",60072),debugBreakpointData:(0,i.$Zj)("debug-breakpoint-data",60073),debugBreakpointDataDisabled:(0,i.$Zj)("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:(0,i.$Zj)("debug-breakpoint-log-unverified",60074),debugBreakpointLog:(0,i.$Zj)("debug-breakpoint-log",60075),debugBreakpointLogDisabled:(0,i.$Zj)("debug-breakpoint-log-disabled",60075),briefcase:(0,i.$Zj)("briefcase",60076),broadcast:(0,i.$Zj)("broadcast",60077),browser:(0,i.$Zj)("browser",60078),bug:(0,i.$Zj)("bug",60079),calendar:(0,i.$Zj)("calendar",60080),caseSensitive:(0,i.$Zj)("case-sensitive",60081),check:(0,i.$Zj)("check",60082),checklist:(0,i.$Zj)("checklist",60083),chevronDown:(0,i.$Zj)("chevron-down",60084),chevronLeft:(0,i.$Zj)("chevron-left",60085),chevronRight:(0,i.$Zj)("chevron-right",60086),chevronUp:(0,i.$Zj)("chevron-up",60087),chromeClose:(0,i.$Zj)("chrome-close",60088),chromeMaximize:(0,i.$Zj)("chrome-maximize",60089),chromeMinimize:(0,i.$Zj)("chrome-minimize",60090),chromeRestore:(0,i.$Zj)("chrome-restore",60091),circleOutline:(0,i.$Zj)("circle-outline",60092),circle:(0,i.$Zj)("circle",60092),debugBreakpointUnverified:(0,i.$Zj)("debug-breakpoint-unverified",60092),terminalDecorationIncomplete:(0,i.$Zj)("terminal-decoration-incomplete",60092),circleSlash:(0,i.$Zj)("circle-slash",60093),circuitBoard:(0,i.$Zj)("circuit-board",60094),clearAll:(0,i.$Zj)("clear-all",60095),clippy:(0,i.$Zj)("clippy",60096),closeAll:(0,i.$Zj)("close-all",60097),cloudDownload:(0,i.$Zj)("cloud-download",60098),cloudUpload:(0,i.$Zj)("cloud-upload",60099),code:(0,i.$Zj)("code",60100),collapseAll:(0,i.$Zj)("collapse-all",60101),colorMode:(0,i.$Zj)("color-mode",60102),commentDiscussion:(0,i.$Zj)("comment-discussion",60103),creditCard:(0,i.$Zj)("credit-card",60105),dash:(0,i.$Zj)("dash",60108),dashboard:(0,i.$Zj)("dashboard",60109),database:(0,i.$Zj)("database",60110),debugContinue:(0,i.$Zj)("debug-continue",60111),debugDisconnect:(0,i.$Zj)("debug-disconnect",60112),debugPause:(0,i.$Zj)("debug-pause",60113),debugRestart:(0,i.$Zj)("debug-restart",60114),debugStart:(0,i.$Zj)("debug-start",60115),debugStepInto:(0,i.$Zj)("debug-step-into",60116),debugStepOut:(0,i.$Zj)("debug-step-out",60117),debugStepOver:(0,i.$Zj)("debug-step-over",60118),debugStop:(0,i.$Zj)("debug-stop",60119),debug:(0,i.$Zj)("debug",60120),deviceCameraVideo:(0,i.$Zj)("device-camera-video",60121),deviceCamera:(0,i.$Zj)("device-camera",60122),deviceMobile:(0,i.$Zj)("device-mobile",60123),diffAdded:(0,i.$Zj)("diff-added",60124),diffIgnored:(0,i.$Zj)("diff-ignored",60125),diffModified:(0,i.$Zj)("diff-modified",60126),diffRemoved:(0,i.$Zj)("diff-removed",60127),diffRenamed:(0,i.$Zj)("diff-renamed",60128),diff:(0,i.$Zj)("diff",60129),diffSidebyside:(0,i.$Zj)("diff-sidebyside",60129),discard:(0,i.$Zj)("discard",60130),editorLayout:(0,i.$Zj)("editor-layout",60131),emptyWindow:(0,i.$Zj)("empty-window",60132),exclude:(0,i.$Zj)("exclude",60133),extensions:(0,i.$Zj)("extensions",60134),eyeClosed:(0,i.$Zj)("eye-closed",60135),fileBinary:(0,i.$Zj)("file-binary",60136),fileCode:(0,i.$Zj)("file-code",60137),fileMedia:(0,i.$Zj)("file-media",60138),filePdf:(0,i.$Zj)("file-pdf",60139),fileSubmodule:(0,i.$Zj)("file-submodule",60140),fileSymlinkDirectory:(0,i.$Zj)("file-symlink-directory",60141),fileSymlinkFile:(0,i.$Zj)("file-symlink-file",60142),fileZip:(0,i.$Zj)("file-zip",60143),files:(0,i.$Zj)("files",60144),filter:(0,i.$Zj)("filter",60145),flame:(0,i.$Zj)("flame",60146),foldDown:(0,i.$Zj)("fold-down",60147),foldUp:(0,i.$Zj)("fold-up",60148),fold:(0,i.$Zj)("fold",60149),folderActive:(0,i.$Zj)("folder-active",60150),folderOpened:(0,i.$Zj)("folder-opened",60151),gear:(0,i.$Zj)("gear",60152),gift:(0,i.$Zj)("gift",60153),gistSecret:(0,i.$Zj)("gist-secret",60154),gist:(0,i.$Zj)("gist",60155),gitCommit:(0,i.$Zj)("git-commit",60156),gitCompare:(0,i.$Zj)("git-compare",60157),compareChanges:(0,i.$Zj)("compare-changes",60157),gitMerge:(0,i.$Zj)("git-merge",60158),githubAction:(0,i.$Zj)("github-action",60159),githubAlt:(0,i.$Zj)("github-alt",60160),globe:(0,i.$Zj)("globe",60161),grabber:(0,i.$Zj)("grabber",60162),graph:(0,i.$Zj)("graph",60163),gripper:(0,i.$Zj)("gripper",60164),heart:(0,i.$Zj)("heart",60165),home:(0,i.$Zj)("home",60166),horizontalRule:(0,i.$Zj)("horizontal-rule",60167),hubot:(0,i.$Zj)("hubot",60168),inbox:(0,i.$Zj)("inbox",60169),issueReopened:(0,i.$Zj)("issue-reopened",60171),issues:(0,i.$Zj)("issues",60172),italic:(0,i.$Zj)("italic",60173),jersey:(0,i.$Zj)("jersey",60174),json:(0,i.$Zj)("json",60175),kebabVertical:(0,i.$Zj)("kebab-vertical",60176),key:(0,i.$Zj)("key",60177),law:(0,i.$Zj)("law",60178),lightbulbAutofix:(0,i.$Zj)("lightbulb-autofix",60179),linkExternal:(0,i.$Zj)("link-external",60180),link:(0,i.$Zj)("link",60181),listOrdered:(0,i.$Zj)("list-ordered",60182),listUnordered:(0,i.$Zj)("list-unordered",60183),liveShare:(0,i.$Zj)("live-share",60184),loading:(0,i.$Zj)("loading",60185),location:(0,i.$Zj)("location",60186),mailRead:(0,i.$Zj)("mail-read",60187),mail:(0,i.$Zj)("mail",60188),markdown:(0,i.$Zj)("markdown",60189),megaphone:(0,i.$Zj)("megaphone",60190),mention:(0,i.$Zj)("mention",60191),milestone:(0,i.$Zj)("milestone",60192),gitPullRequestMilestone:(0,i.$Zj)("git-pull-request-milestone",60192),mortarBoard:(0,i.$Zj)("mortar-board",60193),move:(0,i.$Zj)("move",60194),multipleWindows:(0,i.$Zj)("multiple-windows",60195),mute:(0,i.$Zj)("mute",60196),noNewline:(0,i.$Zj)("no-newline",60197),note:(0,i.$Zj)("note",60198),octoface:(0,i.$Zj)("octoface",60199),openPreview:(0,i.$Zj)("open-preview",60200),package:(0,i.$Zj)("package",60201),paintcan:(0,i.$Zj)("paintcan",60202),pin:(0,i.$Zj)("pin",60203),play:(0,i.$Zj)("play",60204),run:(0,i.$Zj)("run",60204),plug:(0,i.$Zj)("plug",60205),preserveCase:(0,i.$Zj)("preserve-case",60206),preview:(0,i.$Zj)("preview",60207),project:(0,i.$Zj)("project",60208),pulse:(0,i.$Zj)("pulse",60209),question:(0,i.$Zj)("question",60210),quote:(0,i.$Zj)("quote",60211),radioTower:(0,i.$Zj)("radio-tower",60212),reactions:(0,i.$Zj)("reactions",60213),references:(0,i.$Zj)("references",60214),refresh:(0,i.$Zj)("refresh",60215),regex:(0,i.$Zj)("regex",60216),remoteExplorer:(0,i.$Zj)("remote-explorer",60217),remote:(0,i.$Zj)("remote",60218),remove:(0,i.$Zj)("remove",60219),replaceAll:(0,i.$Zj)("replace-all",60220),replace:(0,i.$Zj)("replace",60221),repoClone:(0,i.$Zj)("repo-clone",60222),repoForcePush:(0,i.$Zj)("repo-force-push",60223),repoPull:(0,i.$Zj)("repo-pull",60224),repoPush:(0,i.$Zj)("repo-push",60225),report:(0,i.$Zj)("report",60226),requestChanges:(0,i.$Zj)("request-changes",60227),rocket:(0,i.$Zj)("rocket",60228),rootFolderOpened:(0,i.$Zj)("root-folder-opened",60229),rootFolder:(0,i.$Zj)("root-folder",60230),rss:(0,i.$Zj)("rss",60231),ruby:(0,i.$Zj)("ruby",60232),saveAll:(0,i.$Zj)("save-all",60233),saveAs:(0,i.$Zj)("save-as",60234),save:(0,i.$Zj)("save",60235),screenFull:(0,i.$Zj)("screen-full",60236),screenNormal:(0,i.$Zj)("screen-normal",60237),searchStop:(0,i.$Zj)("search-stop",60238),server:(0,i.$Zj)("server",60240),settingsGear:(0,i.$Zj)("settings-gear",60241),settings:(0,i.$Zj)("settings",60242),shield:(0,i.$Zj)("shield",60243),smiley:(0,i.$Zj)("smiley",60244),sortPrecedence:(0,i.$Zj)("sort-precedence",60245),splitHorizontal:(0,i.$Zj)("split-horizontal",60246),splitVertical:(0,i.$Zj)("split-vertical",60247),squirrel:(0,i.$Zj)("squirrel",60248),starFull:(0,i.$Zj)("star-full",60249),starHalf:(0,i.$Zj)("star-half",60250),symbolClass:(0,i.$Zj)("symbol-class",60251),symbolColor:(0,i.$Zj)("symbol-color",60252),symbolConstant:(0,i.$Zj)("symbol-constant",60253),symbolEnumMember:(0,i.$Zj)("symbol-enum-member",60254),symbolField:(0,i.$Zj)("symbol-field",60255),symbolFile:(0,i.$Zj)("symbol-file",60256),symbolInterface:(0,i.$Zj)("symbol-interface",60257),symbolKeyword:(0,i.$Zj)("symbol-keyword",60258),symbolMisc:(0,i.$Zj)("symbol-misc",60259),symbolOperator:(0,i.$Zj)("symbol-operator",60260),symbolProperty:(0,i.$Zj)("symbol-property",60261),wrench:(0,i.$Zj)("wrench",60261),wrenchSubaction:(0,i.$Zj)("wrench-subaction",60261),symbolSnippet:(0,i.$Zj)("symbol-snippet",60262),tasklist:(0,i.$Zj)("tasklist",60263),telescope:(0,i.$Zj)("telescope",60264),textSize:(0,i.$Zj)("text-size",60265),threeBars:(0,i.$Zj)("three-bars",60266),thumbsdown:(0,i.$Zj)("thumbsdown",60267),thumbsup:(0,i.$Zj)("thumbsup",60268),tools:(0,i.$Zj)("tools",60269),triangleDown:(0,i.$Zj)("triangle-down",60270),triangleLeft:(0,i.$Zj)("triangle-left",60271),triangleRight:(0,i.$Zj)("triangle-right",60272),triangleUp:(0,i.$Zj)("triangle-up",60273),twitter:(0,i.$Zj)("twitter",60274),unfold:(0,i.$Zj)("unfold",60275),unlock:(0,i.$Zj)("unlock",60276),unmute:(0,i.$Zj)("unmute",60277),unverified:(0,i.$Zj)("unverified",60278),verified:(0,i.$Zj)("verified",60279),versions:(0,i.$Zj)("versions",60280),vmActive:(0,i.$Zj)("vm-active",60281),vmOutline:(0,i.$Zj)("vm-outline",60282),vmRunning:(0,i.$Zj)("vm-running",60283),watch:(0,i.$Zj)("watch",60284),whitespace:(0,i.$Zj)("whitespace",60285),wholeWord:(0,i.$Zj)("whole-word",60286),window:(0,i.$Zj)("window",60287),wordWrap:(0,i.$Zj)("word-wrap",60288),zoomIn:(0,i.$Zj)("zoom-in",60289),zoomOut:(0,i.$Zj)("zoom-out",60290),listFilter:(0,i.$Zj)("list-filter",60291),listFlat:(0,i.$Zj)("list-flat",60292),listSelection:(0,i.$Zj)("list-selection",60293),selection:(0,i.$Zj)("selection",60293),listTree:(0,i.$Zj)("list-tree",60294),debugBreakpointFunctionUnverified:(0,i.$Zj)("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:(0,i.$Zj)("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:(0,i.$Zj)("debug-breakpoint-function-disabled",60296),debugStackframeActive:(0,i.$Zj)("debug-stackframe-active",60297),circleSmallFilled:(0,i.$Zj)("circle-small-filled",60298),debugStackframeDot:(0,i.$Zj)("debug-stackframe-dot",60298),terminalDecorationMark:(0,i.$Zj)("terminal-decoration-mark",60298),debugStackframe:(0,i.$Zj)("debug-stackframe",60299),debugStackframeFocused:(0,i.$Zj)("debug-stackframe-focused",60299),debugBreakpointUnsupported:(0,i.$Zj)("debug-breakpoint-unsupported",60300),symbolString:(0,i.$Zj)("symbol-string",60301),debugReverseContinue:(0,i.$Zj)("debug-reverse-continue",60302),debugStepBack:(0,i.$Zj)("debug-step-back",60303),debugRestartFrame:(0,i.$Zj)("debug-restart-frame",60304),debugAlt:(0,i.$Zj)("debug-alt",60305),callIncoming:(0,i.$Zj)("call-incoming",60306),callOutgoing:(0,i.$Zj)("call-outgoing",60307),menu:(0,i.$Zj)("menu",60308),expandAll:(0,i.$Zj)("expand-all",60309),feedback:(0,i.$Zj)("feedback",60310),gitPullRequestReviewer:(0,i.$Zj)("git-pull-request-reviewer",60310),groupByRefType:(0,i.$Zj)("group-by-ref-type",60311),ungroupByRefType:(0,i.$Zj)("ungroup-by-ref-type",60312),account:(0,i.$Zj)("account",60313),gitPullRequestAssignee:(0,i.$Zj)("git-pull-request-assignee",60313),bellDot:(0,i.$Zj)("bell-dot",60314),debugConsole:(0,i.$Zj)("debug-console",60315),library:(0,i.$Zj)("library",60316),output:(0,i.$Zj)("output",60317),runAll:(0,i.$Zj)("run-all",60318),syncIgnored:(0,i.$Zj)("sync-ignored",60319),pinned:(0,i.$Zj)("pinned",60320),githubInverted:(0,i.$Zj)("github-inverted",60321),serverProcess:(0,i.$Zj)("server-process",60322),serverEnvironment:(0,i.$Zj)("server-environment",60323),pass:(0,i.$Zj)("pass",60324),issueClosed:(0,i.$Zj)("issue-closed",60324),stopCircle:(0,i.$Zj)("stop-circle",60325),playCircle:(0,i.$Zj)("play-circle",60326),record:(0,i.$Zj)("record",60327),debugAltSmall:(0,i.$Zj)("debug-alt-small",60328),vmConnect:(0,i.$Zj)("vm-connect",60329),cloud:(0,i.$Zj)("cloud",60330),merge:(0,i.$Zj)("merge",60331),export:(0,i.$Zj)("export",60332),graphLeft:(0,i.$Zj)("graph-left",60333),magnet:(0,i.$Zj)("magnet",60334),notebook:(0,i.$Zj)("notebook",60335),redo:(0,i.$Zj)("redo",60336),checkAll:(0,i.$Zj)("check-all",60337),pinnedDirty:(0,i.$Zj)("pinned-dirty",60338),passFilled:(0,i.$Zj)("pass-filled",60339),circleLargeFilled:(0,i.$Zj)("circle-large-filled",60340),circleLarge:(0,i.$Zj)("circle-large",60341),circleLargeOutline:(0,i.$Zj)("circle-large-outline",60341),combine:(0,i.$Zj)("combine",60342),gather:(0,i.$Zj)("gather",60342),table:(0,i.$Zj)("table",60343),variableGroup:(0,i.$Zj)("variable-group",60344),typeHierarchy:(0,i.$Zj)("type-hierarchy",60345),typeHierarchySub:(0,i.$Zj)("type-hierarchy-sub",60346),typeHierarchySuper:(0,i.$Zj)("type-hierarchy-super",60347),gitPullRequestCreate:(0,i.$Zj)("git-pull-request-create",60348),runAbove:(0,i.$Zj)("run-above",60349),runBelow:(0,i.$Zj)("run-below",60350),notebookTemplate:(0,i.$Zj)("notebook-template",60351),debugRerun:(0,i.$Zj)("debug-rerun",60352),workspaceTrusted:(0,i.$Zj)("workspace-trusted",60353),workspaceUntrusted:(0,i.$Zj)("workspace-untrusted",60354),workspaceUnknown:(0,i.$Zj)("workspace-unknown",60355),terminalCmd:(0,i.$Zj)("terminal-cmd",60356),terminalDebian:(0,i.$Zj)("terminal-debian",60357),terminalLinux:(0,i.$Zj)("terminal-linux",60358),terminalPowershell:(0,i.$Zj)("terminal-powershell",60359),terminalTmux:(0,i.$Zj)("terminal-tmux",60360),terminalUbuntu:(0,i.$Zj)("terminal-ubuntu",60361),terminalBash:(0,i.$Zj)("terminal-bash",60362),arrowSwap:(0,i.$Zj)("arrow-swap",60363),copy:(0,i.$Zj)("copy",60364),personAdd:(0,i.$Zj)("person-add",60365),filterFilled:(0,i.$Zj)("filter-filled",60366),wand:(0,i.$Zj)("wand",60367),debugLineByLine:(0,i.$Zj)("debug-line-by-line",60368),inspect:(0,i.$Zj)("inspect",60369),layers:(0,i.$Zj)("layers",60370),layersDot:(0,i.$Zj)("layers-dot",60371),layersActive:(0,i.$Zj)("layers-active",60372),compass:(0,i.$Zj)("compass",60373),compassDot:(0,i.$Zj)("compass-dot",60374),compassActive:(0,i.$Zj)("compass-active",60375),azure:(0,i.$Zj)("azure",60376),issueDraft:(0,i.$Zj)("issue-draft",60377),gitPullRequestClosed:(0,i.$Zj)("git-pull-request-closed",60378),gitPullRequestDraft:(0,i.$Zj)("git-pull-request-draft",60379),debugAll:(0,i.$Zj)("debug-all",60380),debugCoverage:(0,i.$Zj)("debug-coverage",60381),runErrors:(0,i.$Zj)("run-errors",60382),folderLibrary:(0,i.$Zj)("folder-library",60383),debugContinueSmall:(0,i.$Zj)("debug-continue-small",60384),beakerStop:(0,i.$Zj)("beaker-stop",60385),graphLine:(0,i.$Zj)("graph-line",60386),graphScatter:(0,i.$Zj)("graph-scatter",60387),pieChart:(0,i.$Zj)("pie-chart",60388),bracket:(0,i.$Zj)("bracket",60175),bracketDot:(0,i.$Zj)("bracket-dot",60389),bracketError:(0,i.$Zj)("bracket-error",60390),lockSmall:(0,i.$Zj)("lock-small",60391),azureDevops:(0,i.$Zj)("azure-devops",60392),verifiedFilled:(0,i.$Zj)("verified-filled",60393),newline:(0,i.$Zj)("newline",60394),layout:(0,i.$Zj)("layout",60395),layoutActivitybarLeft:(0,i.$Zj)("layout-activitybar-left",60396),layoutActivitybarRight:(0,i.$Zj)("layout-activitybar-right",60397),layoutPanelLeft:(0,i.$Zj)("layout-panel-left",60398),layoutPanelCenter:(0,i.$Zj)("layout-panel-center",60399),layoutPanelJustify:(0,i.$Zj)("layout-panel-justify",60400),layoutPanelRight:(0,i.$Zj)("layout-panel-right",60401),layoutPanel:(0,i.$Zj)("layout-panel",60402),layoutSidebarLeft:(0,i.$Zj)("layout-sidebar-left",60403),layoutSidebarRight:(0,i.$Zj)("layout-sidebar-right",60404),layoutStatusbar:(0,i.$Zj)("layout-statusbar",60405),layoutMenubar:(0,i.$Zj)("layout-menubar",60406),layoutCentered:(0,i.$Zj)("layout-centered",60407),target:(0,i.$Zj)("target",60408),indent:(0,i.$Zj)("indent",60409),recordSmall:(0,i.$Zj)("record-small",60410),errorSmall:(0,i.$Zj)("error-small",60411),terminalDecorationError:(0,i.$Zj)("terminal-decoration-error",60411),arrowCircleDown:(0,i.$Zj)("arrow-circle-down",60412),arrowCircleLeft:(0,i.$Zj)("arrow-circle-left",60413),arrowCircleRight:(0,i.$Zj)("arrow-circle-right",60414),arrowCircleUp:(0,i.$Zj)("arrow-circle-up",60415),layoutSidebarRightOff:(0,i.$Zj)("layout-sidebar-right-off",60416),layoutPanelOff:(0,i.$Zj)("layout-panel-off",60417),layoutSidebarLeftOff:(0,i.$Zj)("layout-sidebar-left-off",60418),blank:(0,i.$Zj)("blank",60419),heartFilled:(0,i.$Zj)("heart-filled",60420),map:(0,i.$Zj)("map",60421),mapHorizontal:(0,i.$Zj)("map-horizontal",60421),foldHorizontal:(0,i.$Zj)("fold-horizontal",60421),mapFilled:(0,i.$Zj)("map-filled",60422),mapHorizontalFilled:(0,i.$Zj)("map-horizontal-filled",60422),foldHorizontalFilled:(0,i.$Zj)("fold-horizontal-filled",60422),circleSmall:(0,i.$Zj)("circle-small",60423),bellSlash:(0,i.$Zj)("bell-slash",60424),bellSlashDot:(0,i.$Zj)("bell-slash-dot",60425),commentUnresolved:(0,i.$Zj)("comment-unresolved",60426),gitPullRequestGoToChanges:(0,i.$Zj)("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:(0,i.$Zj)("git-pull-request-new-changes",60428),searchFuzzy:(0,i.$Zj)("search-fuzzy",60429),commentDraft:(0,i.$Zj)("comment-draft",60430),send:(0,i.$Zj)("send",60431),sparkle:(0,i.$Zj)("sparkle",60432),insert:(0,i.$Zj)("insert",60433),mic:(0,i.$Zj)("mic",60434),thumbsdownFilled:(0,i.$Zj)("thumbsdown-filled",60435),thumbsupFilled:(0,i.$Zj)("thumbsup-filled",60436),coffee:(0,i.$Zj)("coffee",60437),snake:(0,i.$Zj)("snake",60438),game:(0,i.$Zj)("game",60439),vr:(0,i.$Zj)("vr",60440),chip:(0,i.$Zj)("chip",60441),piano:(0,i.$Zj)("piano",60442),music:(0,i.$Zj)("music",60443),micFilled:(0,i.$Zj)("mic-filled",60444),repoFetch:(0,i.$Zj)("repo-fetch",60445),copilot:(0,i.$Zj)("copilot",60446),lightbulbSparkle:(0,i.$Zj)("lightbulb-sparkle",60447),robot:(0,i.$Zj)("robot",60448),sparkleFilled:(0,i.$Zj)("sparkle-filled",60449),diffSingle:(0,i.$Zj)("diff-single",60450),diffMultiple:(0,i.$Zj)("diff-multiple",60451),surroundWith:(0,i.$Zj)("surround-with",60452),share:(0,i.$Zj)("share",60453),gitStash:(0,i.$Zj)("git-stash",60454),gitStashApply:(0,i.$Zj)("git-stash-apply",60455),gitStashPop:(0,i.$Zj)("git-stash-pop",60456),vscode:(0,i.$Zj)("vscode",60457),vscodeInsiders:(0,i.$Zj)("vscode-insiders",60458),codeOss:(0,i.$Zj)("code-oss",60459),runCoverage:(0,i.$Zj)("run-coverage",60460),runAllCoverage:(0,i.$Zj)("run-all-coverage",60461),coverage:(0,i.$Zj)("coverage",60462),githubProject:(0,i.$Zj)("github-project",60463),mapVertical:(0,i.$Zj)("map-vertical",60464),foldVertical:(0,i.$Zj)("fold-vertical",60464),mapVerticalFilled:(0,i.$Zj)("map-vertical-filled",60465),foldVerticalFilled:(0,i.$Zj)("fold-vertical-filled",60465),goToSearch:(0,i.$Zj)("go-to-search",60466),percentage:(0,i.$Zj)("percentage",60467),sortPercentage:(0,i.$Zj)("sort-percentage",60467),attach:(0,i.$Zj)("attach",60468)}}),define(oe[78],ae([0,1,110,147]),function(V,e,i,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5j=e.$4j=void 0,e.$3j=S;function S(){return Object.values(e.$5j)}e.$4j={dialogError:(0,i.$Zj)("dialog-error","error"),dialogWarning:(0,i.$Zj)("dialog-warning","warning"),dialogInfo:(0,i.$Zj)("dialog-info","info"),dialogClose:(0,i.$Zj)("dialog-close","close"),treeItemExpanded:(0,i.$Zj)("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:(0,i.$Zj)("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:(0,i.$Zj)("tree-filter-on-type-off","list-selection"),treeFilterClear:(0,i.$Zj)("tree-filter-clear","close"),treeItemLoading:(0,i.$Zj)("tree-item-loading","loading"),menuSelection:(0,i.$Zj)("menu-selection","check"),menuSubmenu:(0,i.$Zj)("menu-submenu","chevron-right"),menuBarMore:(0,i.$Zj)("menubar-more","more"),scrollbarButtonLeft:(0,i.$Zj)("scrollbar-button-left","triangle-left"),scrollbarButtonRight:(0,i.$Zj)("scrollbar-button-right","triangle-right"),scrollbarButtonUp:(0,i.$Zj)("scrollbar-button-up","triangle-up"),scrollbarButtonDown:(0,i.$Zj)("scrollbar-button-down","triangle-down"),toolBarMore:(0,i.$Zj)("toolbar-more","more"),quickInputBack:(0,i.$Zj)("quick-input-back","arrow-left"),dropDownButton:(0,i.$Zj)("drop-down-button",60084),symbolCustomColor:(0,i.$Zj)("symbol-customcolor",60252),exportIcon:(0,i.$Zj)("export",60332),workspaceUnspecified:(0,i.$Zj)("workspace-unspecified",60355),newLine:(0,i.$Zj)("newline",60394),thumbsDownFilled:(0,i.$Zj)("thumbsdown-filled",60435),thumbsUpFilled:(0,i.$Zj)("thumbsup-filled",60436),gitFetch:(0,i.$Zj)("git-fetch",60445),lightbulbSparkleAutofix:(0,i.$Zj)("lightbulb-sparkle-autofix",60447),debugBreakpointPending:(0,i.$Zj)("debug-breakpoint-pending",60377)},e.$5j={...o.$2j,...e.$4j}}),define(oe[35],ae([0,1,12]),function(V,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bo=o,e.$co=S,e.$do=O,e.$eo=y,e.$fo=a,e.$go=h,e.$ho=f,e.$io=g,e.$jo=b,e.$ko=l,e.$lo=m,e.$mo=p,e.$no=$;function o(w){if(!w||typeof w!="object"||w instanceof RegExp)return w;const v=Array.isArray(w)?[]:{};return Object.entries(w).forEach(([k,t])=>{v[k]=t&&typeof t=="object"?o(t):t}),v}function S(w){if(!w||typeof w!="object")return w;const v=[w];for(;v.length>0;){const k=v.shift();Object.freeze(k);for(const t in k)if(D.call(k,t)){const r=k[t];typeof r=="object"&&!Object.isFrozen(r)&&!(0,i.$ig)(r)&&v.push(r)}}return w}const D=Object.prototype.hasOwnProperty;function O(w,v){return P(w,v,new Set)}function P(w,v,k){if((0,i.$og)(w))return w;const t=v(w);if(typeof t<"u")return t;if(Array.isArray(w)){const r=[];for(const n of w)r.push(P(n,v,k));return r}if((0,i.$hg)(w)){if(k.has(w))throw new Error("Cannot clone recursive data-structure");k.add(w);const r={};for(const n in w)D.call(w,n)&&(r[n]=P(w[n],v,k));return k.delete(w),r}return w}function y(w,v,k=!0){return(0,i.$hg)(w)?((0,i.$hg)(v)&&Object.keys(v).forEach(t=>{t in w?k&&((0,i.$hg)(w[t])&&(0,i.$hg)(v[t])?y(w[t],v[t],k):w[t]=v[t]):w[t]=v[t]}),w):v}function a(w,v){if(w===v)return!0;if(w==null||v===null||v===void 0||typeof w!=typeof v||typeof w!="object"||Array.isArray(w)!==Array.isArray(v))return!1;let k,t;if(Array.isArray(w)){if(w.length!==v.length)return!1;for(k=0;k<w.length;k++)if(!a(w[k],v[k]))return!1}else{const r=[];for(t in w)r.push(t);r.sort();const n=[];for(t in v)n.push(t);if(n.sort(),!a(r,n))return!1;for(k=0;k<r.length;k++)if(!a(w[r[k]],v[r[k]]))return!1}return!0}function h(w){const v=new Set;return JSON.stringify(w,(k,t)=>{if((0,i.$hg)(t)||Array.isArray(t)){if(v.has(t))return"[Circular]";v.add(t)}return typeof t=="bigint"?`[BigInt ${t.toString()}]`:t})}function f(w,v){const k=Object.create(null);return!w||!v||Object.keys(v).forEach(r=>{const n=w[r],c=v[r];a(n,c)||(k[r]=c)}),k}function g(w,v){const k=v.toLowerCase(),t=Object.keys(w).find(r=>r.toLowerCase()===k);return t?w[t]:w[v]}function b(w,v){const k=Object.create(null);for(const[t,r]of Object.entries(w))v(t,r)&&(k[t]=r);return k}function l(w){let v=[];for(;Object.prototype!==w;)v=v.concat(Object.getOwnPropertyNames(w)),w=Object.getPrototypeOf(w);return v}function m(w){const v=[];for(const k of l(w))typeof w[k]=="function"&&v.push(k);return v}function p(w,v){const k=r=>function(){const n=Array.prototype.slice.call(arguments,0);return v(r,n)},t={};for(const r of w)t[r]=k(r);return t}function $(w,v){const k={};for(const[t,r]of Object.entries(w))k[t]=v(r,t);return k}}),define(oe[111],ae([0,1,78]),function(V,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.ThemeColor=void 0,e.$6j=S;var o;(function(O){function P(y){return y&&typeof y=="object"&&typeof y.id=="string"}O.isThemeColor=P})(o||(e.ThemeColor=o={}));function S(O){return{id:O}}var D;(function(O){O.iconNameSegment="[A-Za-z0-9]+",O.iconNameExpression="[A-Za-z0-9-]+",O.iconModifierExpression="~[A-Za-z]+",O.iconNameCharacter="[A-Za-z0-9~-]";const P=new RegExp(`^(${O.iconNameExpression})(${O.iconModifierExpression})?$`);function y(w){const v=P.exec(w.id);if(!v)return y(i.$5j.error);const[,k,t]=v,r=["codicon","codicon-"+k];return t&&r.push("codicon-modifier-"+t.substring(1)),r}O.asClassNameArray=y;function a(w){return y(w).join(" ")}O.asClassName=a;function h(w){return"."+y(w).join(".")}O.asCSSSelector=h;function f(w){return w&&typeof w=="object"&&typeof w.id=="string"&&(typeof w.color>"u"||o.isThemeColor(w.color))}O.isThemeIcon=f;const g=new RegExp(`^\\$\\((${O.iconNameExpression}(?:${O.iconModifierExpression})?)\\)$`);function b(w){const v=g.exec(w);if(!v)return;const[,k]=v;return{id:k}}O.fromString=b;function l(w){return{id:w}}O.fromId=l;function m(w,v){let k=w.id;const t=k.lastIndexOf("~");return t!==-1&&(k=k.substring(0,t)),v&&(k=`${k}~${v}`),{id:k}}O.modify=m;function p(w){const v=w.id.lastIndexOf("~");if(v!==-1)return w.id.substring(v+1)}O.getModifier=p;function $(w,v){return w.id===v.id&&w.color?.id===v.color?.id}O.isEqual=$})(D||(e.ThemeIcon=D={}))}),define(oe[148],ae([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Constants=void 0,e.$bf=o,e.$cf=S;var i;(function(D){D[D.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",D[D.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",D[D.MAX_UINT_8=255]="MAX_UINT_8",D[D.MAX_UINT_16=65535]="MAX_UINT_16",D[D.MAX_UINT_32=4294967295]="MAX_UINT_32",D[D.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(i||(e.Constants=i={}));function o(D){return D<0?0:D>i.MAX_UINT_8?i.MAX_UINT_8:D|0}function S(D){return D<0?0:D>i.MAX_UINT_32?i.MAX_UINT_32:D|0}}),define(oe[26],ae([0,1,145,39,65,148]),function(V,e,i,o,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eg=e.$dg=e.$cg=e.GraphemeBreakType=e.$5f=e.$Wf=e.$Pf=e.$Of=void 0,e.$df=O,e.$ef=y,e.$ff=h,e.$gf=f,e.$hf=g,e.$if=b,e.$jf=l,e.$kf=m,e.$lf=p,e.$mf=$,e.$nf=w,e.$of=v,e.$pf=k,e.$qf=t,e.$rf=r,e.$sf=n,e.$tf=c,e.$uf=s,e.$vf=u,e.$wf=d,e.$xf=I,e.$yf=E,e.$zf=A,e.$Af=T,e.$Bf=L,e.$Cf=R,e.$Df=M,e.$Ef=U,e.$Ff=N,e.$Gf=z,e.$Hf=ne,e.$If=Q,e.$Jf=le,e.$Kf=K,e.$Lf=ee,e.$Mf=H,e.$Nf=j,e.$Qf=G,e.$Rf=he,e.$Sf=se,e.$Tf=_,e.$Uf=W,e.$Vf=J,e.$Xf=X,e.$Yf=Z,e.$Zf=ie,e.$1f=de,e.$2f=pe,e.$3f=Ie,e.$4f=Pe,e.$6f=De,e.$7f=$e,e.$8f=Y,e.$9f=ue,e.$0f=fe,e.$$f=be,e.$_f=Oe,e.$ag=We,e.$bg=Ye;function O(te){return!te||typeof te!="string"?!0:te.trim().length===0}const P=/{(\d+)}/g;function y(te,...ge){return ge.length===0?te:te.replace(P,function(we,ye){const Me=parseInt(ye,10);return isNaN(Me)||Me<0||Me>=ge.length?we:ge[Me]})}const a=/{([^}]+)}/g;function h(te,ge){return Object.keys(ge).length===0?te:te.replace(a,(we,ye)=>ge[ye]??we)}function f(te){return te.replace(/[<>"'&]/g,ge=>{switch(ge){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return ge})}function g(te){return te.replace(/[<>&]/g,function(ge){switch(ge){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ge}})}function b(te){return te.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}function l(te,ge){let we=0,ye=te.indexOf(ge);for(;ye!==-1;)we++,ye=te.indexOf(ge,ye+ge.length);return we}function m(te,ge,we="\u2026"){return te.length<=ge?te:`${te.substr(0,ge)}${we}`}function p(te,ge,we="\u2026"){if(te.length<=ge)return te;const ye=Math.ceil(ge/2)-we.length/2,Me=Math.floor(ge/2)-we.length/2;return`${te.substr(0,ye)}${we}${te.substr(te.length-Me)}`}function $(te,ge=" "){const we=w(te,ge);return v(we,ge)}function w(te,ge){if(!te||!ge)return te;const we=ge.length;if(we===0||te.length===0)return te;let ye=0;for(;te.indexOf(ge,ye)===ye;)ye=ye+we;return te.substring(ye)}function v(te,ge){if(!te||!ge)return te;const we=ge.length,ye=te.length;if(we===0||ye===0)return te;let Me=ye,Ue=-1;for(;Ue=te.lastIndexOf(ge,Me-1),!(Ue===-1||Ue+we!==Me);){if(Ue===0)return"";Me=Ue}return te.substring(0,Me)}function k(te){return te.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}function t(te){return te.replace(/\*/g,"")}function r(te,ge,we={}){if(!te)throw new Error("Cannot create regex from empty string");ge||(te=b(te)),we.wholeWord&&(/\B/.test(te.charAt(0))||(te="\\b"+te),/\B/.test(te.charAt(te.length-1))||(te=te+"\\b"));let ye="";return we.global&&(ye+="g"),we.matchCase||(ye+="i"),we.multiline&&(ye+="m"),we.unicode&&(ye+="u"),new RegExp(te,ye)}function n(te){return te.source==="^"||te.source==="^$"||te.source==="$"||te.source==="^\\s*$"?!1:!!(te.exec("")&&te.lastIndex===0)}function c(te){return te.split(/\r\n|\r|\n/)}function s(te){const ge=[],we=te.split(/(\r\n|\r|\n)/);for(let ye=0;ye<Math.ceil(we.length/2);ye++)ge.push(we[2*ye]+(we[2*ye+1]??""));return ge}function u(te){for(let ge=0,we=te.length;ge<we;ge++){const ye=te.charCodeAt(ge);if(ye!==o.CharCode.Space&&ye!==o.CharCode.Tab)return ge}return-1}function d(te,ge=0,we=te.length){for(let ye=ge;ye<we;ye++){const Me=te.charCodeAt(ye);if(Me!==o.CharCode.Space&&Me!==o.CharCode.Tab)return te.substring(ge,ye)}return te.substring(ge,we)}function I(te,ge=te.length-1){for(let we=ge;we>=0;we--){const ye=te.charCodeAt(we);if(ye!==o.CharCode.Space&&ye!==o.CharCode.Tab)return we}return-1}function E(te,ge,we){const ye=[];let Me=0;for(const Ue of te.matchAll(ge)){if(ye.push(te.slice(Me,Ue.index)),Ue.index===void 0)throw new Error("match.index should be defined");Me=Ue.index+Ue[0].length,ye.push(we(Ue[0],...Ue.slice(1),Ue.index,te,Ue.groups))}return ye.push(te.slice(Me)),Promise.all(ye).then(Ue=>Ue.join(""))}function A(te,ge){return te<ge?-1:te>ge?1:0}function T(te,ge,we=0,ye=te.length,Me=0,Ue=ge.length){for(;we<ye&&Me<Ue;we++,Me++){const rt=te.charCodeAt(we),at=ge.charCodeAt(Me);if(rt<at)return-1;if(rt>at)return 1}const Qe=ye-we,lt=Ue-Me;return Qe<lt?-1:Qe>lt?1:0}function L(te,ge){return R(te,ge,0,te.length,0,ge.length)}function R(te,ge,we=0,ye=te.length,Me=0,Ue=ge.length){for(;we<ye&&Me<Ue;we++,Me++){let rt=te.charCodeAt(we),at=ge.charCodeAt(Me);if(rt===at)continue;if(rt>=128||at>=128)return T(te.toLowerCase(),ge.toLowerCase(),we,ye,Me,Ue);U(rt)&&(rt-=32),U(at)&&(at-=32);const tt=rt-at;if(tt!==0)return tt}const Qe=ye-we,lt=Ue-Me;return Qe<lt?-1:Qe>lt?1:0}function M(te){return te>=o.CharCode.Digit0&&te<=o.CharCode.Digit9}function U(te){return te>=o.CharCode.a&&te<=o.CharCode.z}function N(te){return te>=o.CharCode.A&&te<=o.CharCode.Z}function z(te,ge){return te.length===ge.length&&R(te,ge)===0}function ne(te,ge){const we=ge.length;return ge.length>te.length?!1:R(te,ge,0,we)===0}function Q(te,ge){const we=Math.min(te.length,ge.length);let ye;for(ye=0;ye<we;ye++)if(te.charCodeAt(ye)!==ge.charCodeAt(ye))return ye;return we}function le(te,ge){const we=Math.min(te.length,ge.length);let ye;const Me=te.length-1,Ue=ge.length-1;for(ye=0;ye<we;ye++)if(te.charCodeAt(Me-ye)!==ge.charCodeAt(Ue-ye))return ye;return we}function K(te){return 55296<=te&&te<=56319}function ee(te){return 56320<=te&&te<=57343}function H(te,ge){return(te-55296<<10)+(ge-56320)+65536}function j(te,ge,we){const ye=te.charCodeAt(we);if(K(ye)&&we+1<ge){const Me=te.charCodeAt(we+1);if(ee(Me))return H(ye,Me)}return ye}function B(te,ge){const we=te.charCodeAt(ge-1);if(ee(we)&&ge>1){const ye=te.charCodeAt(ge-2);if(K(ye))return H(ye,we)}return we}class x{get offset(){return this.e}constructor(ge,we=0){this.c=ge,this.d=ge.length,this.e=we}setOffset(ge){this.e=ge}prevCodePoint(){const ge=B(this.c,this.e);return this.e-=ge>=D.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,ge}nextCodePoint(){const ge=j(this.c,this.d,this.e);return this.e+=ge>=D.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,ge}eol(){return this.e>=this.d}}e.$Of=x;class ce{get offset(){return this.c.offset}constructor(ge,we=0){this.c=new x(ge,we)}nextGraphemeLength(){const ge=Be.getInstance(),we=this.c,ye=we.offset;let Me=ge.getGraphemeBreakType(we.nextCodePoint());for(;!we.eol();){const Ue=we.offset,Qe=ge.getGraphemeBreakType(we.nextCodePoint());if(Fe(Me,Qe)){we.setOffset(Ue);break}Me=Qe}return we.offset-ye}prevGraphemeLength(){const ge=Be.getInstance(),we=this.c,ye=we.offset;let Me=ge.getGraphemeBreakType(we.prevCodePoint());for(;we.offset>0;){const Ue=we.offset,Qe=ge.getGraphemeBreakType(we.prevCodePoint());if(Fe(Qe,Me)){we.setOffset(Ue);break}Me=Qe}return ye-we.offset}eol(){return this.c.eol()}}e.$Pf=ce;function G(te,ge){return new ce(te,ge).nextGraphemeLength()}function he(te,ge){return new ce(te,ge).prevGraphemeLength()}function se(te,ge){ge>0&&ee(te.charCodeAt(ge))&&ge--;const we=ge+G(te,ge);return[we-he(te,we),we]}function _(te){const ge=new ce(te);let we=0;for(;!ge.eol();)we++,ge.nextGraphemeLength();return we}let F;function C(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function W(te){return F||(F=C()),F.test(te)}const q=/^[\t\n\r\x20-\x7E]*$/;function J(te){return q.test(te)}e.$Wf=/[\u2028\u2029]/;function X(te){return e.$Wf.test(te)}function Z(te){return te>=11904&&te<=55215||te>=63744&&te<=64255||te>=65281&&te<=65374}function ie(te){return te>=127462&&te<=127487||te===8986||te===8987||te===9200||te===9203||te>=9728&&te<=10175||te===11088||te===11093||te>=127744&&te<=128591||te>=128640&&te<=128764||te>=128992&&te<=129008||te>=129280&&te<=129535||te>=129648&&te<=129782}function de(te,ge,we=""){const ye=te.trimStart();if(ye.length<ge)return ye;const Me=/\b/g;let Ue=0;for(;Me.test(ye)&&!(ye.length-Me.lastIndex<ge);)Ue=Me.lastIndex,Me.lastIndex+=1;return Ue===0?ye:we+ye.substring(Ue).trimStart()}const me=/(?:(?:\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~])|(:?\x1b\].*?\x07)/g;function*pe(te){let ge=0;for(const we of te.matchAll(me))ge!==we.index&&(yield{isCode:!1,str:te.substring(ge,we.index)}),yield{isCode:!0,str:we[0]},ge=we.index+we[0].length;ge!==te.length&&(yield{isCode:!1,str:te.substring(ge)})}function Ie(te){return te&&(te=te.replace(me,"")),te}const ke=/\\\[.*?\\\]/g;function Pe(te){return Ie(te).replace(ke,"")}e.$5f=String.fromCharCode(o.CharCode.UTF8_BOM);function De(te){return!!(te&&te.length>0&&te.charCodeAt(0)===o.CharCode.UTF8_BOM)}function $e(te){return De(te)?te.substr(1):te}function Y(te,ge){if(!te||!ge||te.length<ge.length)return!1;const we=ge.length,ye=te.toLowerCase();let Me=0,Ue=-1;for(;Me<we;){const Qe=ye.indexOf(ge[Me],Ue+1);if(Qe<0)return!1;Ue=Qe,Me++}return!0}function ue(te,ge=!1){return te?(ge&&(te=te.replace(/\\./g,"")),te.toLowerCase()!==te):!1}function fe(te){return te.charAt(0).toUpperCase()+te.slice(1)}function be(te,ge=1){if(ge===0)return"";let we=-1;do we=te.indexOf(`
`,we+1),ge--;while(ge>0&&we>=0);return we===-1?te:(te[we-1]==="\r"&&we--,te.substr(0,we))}function Oe(te){const ge=o.CharCode.Z-o.CharCode.A+1;return te=te%(2*ge),te<ge?String.fromCharCode(o.CharCode.a+te):String.fromCharCode(o.CharCode.A+te-ge)}function We(te){return Be.getInstance().getGraphemeBreakType(te)}function Fe(te,ge){return te===Ae.Other?ge!==Ae.Extend&&ge!==Ae.SpacingMark:te===Ae.CR&&ge===Ae.LF?!1:te===Ae.Control||te===Ae.CR||te===Ae.LF||ge===Ae.Control||ge===Ae.CR||ge===Ae.LF?!0:!(te===Ae.L&&(ge===Ae.L||ge===Ae.V||ge===Ae.LV||ge===Ae.LVT)||(te===Ae.LV||te===Ae.V)&&(ge===Ae.V||ge===Ae.T)||(te===Ae.LVT||te===Ae.T)&&ge===Ae.T||ge===Ae.Extend||ge===Ae.ZWJ||ge===Ae.SpacingMark||te===Ae.Prepend||te===Ae.ZWJ&&ge===Ae.Extended_Pictographic||te===Ae.Regional_Indicator&&ge===Ae.Regional_Indicator)}var Ae;(function(te){te[te.Other=0]="Other",te[te.Prepend=1]="Prepend",te[te.CR=2]="CR",te[te.LF=3]="LF",te[te.Control=4]="Control",te[te.Extend=5]="Extend",te[te.Regional_Indicator=6]="Regional_Indicator",te[te.SpacingMark=7]="SpacingMark",te[te.L=8]="L",te[te.V=9]="V",te[te.T=10]="T",te[te.LV=11]="LV",te[te.LVT=12]="LVT",te[te.ZWJ=13]="ZWJ",te[te.Extended_Pictographic=14]="Extended_Pictographic"})(Ae||(e.GraphemeBreakType=Ae={}));class Be{static{this.c=null}static getInstance(){return Be.c||(Be.c=new Be),Be.c}constructor(){this.d=xe()}getGraphemeBreakType(ge){if(ge<32)return ge===o.CharCode.LineFeed?Ae.LF:ge===o.CharCode.CarriageReturn?Ae.CR:Ae.Control;if(ge<127)return Ae.Other;const we=this.d,ye=we.length/3;let Me=1;for(;Me<=ye;)if(ge<we[3*Me])Me=2*Me;else if(ge>we[3*Me+1])Me=2*Me+1;else return we[3*Me+2];return Ae.Other}}function xe(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Ye(te,ge){if(te===0)return 0;const we=qe(te,ge);if(we!==void 0)return we;const ye=new x(ge,te);return ye.prevCodePoint(),ye.offset}function qe(te,ge){const we=new x(ge,te);let ye=we.prevCodePoint();for(;Je(ye)||ye===Xe.emojiVariantSelector||ye===Xe.enclosingKeyCap;){if(we.offset===0)return;ye=we.prevCodePoint()}if(!ie(ye))return;let Me=we.offset;return Me>0&&we.prevCodePoint()===Xe.zwj&&(Me=we.offset),Me}function Je(te){return 127995<=te&&te<=127999}var Xe;(function(te){te[te.zwj=8205]="zwj",te[te.emojiVariantSelector=65039]="emojiVariantSelector",te[te.enclosingKeyCap=8419]="enclosingKeyCap"})(Xe||(Xe={})),e.$cg="\xA0";class Ke{static{this.c=new S.$X(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new i.$_e({getCacheKey:JSON.stringify},ge=>{function we(tt){const ut=new Map;for(let ct=0;ct<tt.length;ct+=2)ut.set(tt[ct],tt[ct+1]);return ut}function ye(tt,ut){const ct=new Map(tt);for(const[ft,gt]of ut)ct.set(ft,gt);return ct}function Me(tt,ut){if(!tt)return ut;const ct=new Map;for(const[ft,gt]of tt)ut.has(ft)&&ct.set(ft,gt);return ct}const Ue=this.c.value;let Qe=ge.filter(tt=>!tt.startsWith("_")&&tt in Ue);Qe.length===0&&(Qe=["_default"]);let lt;for(const tt of Qe){const ut=we(Ue[tt]);lt=Me(lt,ut)}const rt=we(Ue._common),at=ye(rt,lt);return new Ke(at)})}static getInstance(ge){return Ke.d.get(Array.from(ge))}static{this.e=new S.$X(()=>Object.keys(Ke.c.value).filter(ge=>!ge.startsWith("_")))}static getLocales(){return Ke.e.value}constructor(ge){this.f=ge}isAmbiguous(ge){return this.f.has(ge)}containsAmbiguousCharacter(ge){for(let we=0;we<ge.length;we++){const ye=ge.codePointAt(we);if(typeof ye=="number"&&this.isAmbiguous(ye))return!0}return!1}getPrimaryConfusable(ge){return this.f.get(ge)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$dg=Ke;class Ce{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(Ce.c())),this.d}static isInvisibleCharacter(ge){return Ce.e().has(ge)}static containsInvisibleCharacter(ge){for(let we=0;we<ge.length;we++){const ye=ge.codePointAt(we);if(typeof ye=="number"&&Ce.isInvisibleCharacter(ye))return!0}return!1}static get codePoints(){return Ce.e()}}e.$eg=Ce}),define(oe[46],ae([0,1,26]),function(V,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zj=e.$xj=void 0,e.$tj=o,e.$uj=S,e.$vj=D,e.$wj=P,e.$yj=m,i=Re(i);function o($){return S($,0)}function S($,w){switch(typeof $){case"object":return $===null?D(349,w):Array.isArray($)?y($,w):a($,w);case"string":return P($,w);case"boolean":return O($,w);case"number":return D($,w);case"undefined":return D(937,w);default:return D(617,w)}}function D($,w){return(w<<5)-w+$|0}function O($,w){return D($?433:863,w)}function P($,w){w=D(149417,w);for(let v=0,k=$.length;v<k;v++)w=D($.charCodeAt(v),w);return w}function y($,w){return w=D(104579,w),$.reduce((v,k)=>S(k,v),w)}function a($,w){return w=D(181387,w),Object.keys($).sort().reduce((v,k)=>(v=P(k,v),S($[k],v)),w)}class h{constructor(){this.g=0}get value(){return this.g}hash(w){return this.g=S(w,this.g),this.g}}e.$xj=h;var f;(function($){$[$.BLOCK_SIZE=64]="BLOCK_SIZE",$[$.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(f||(f={}));function g($,w,v=32){const k=v-w,t=~((1<<k)-1);return($<<w|(t&$)>>>k)>>>0}function b($,w=0,v=$.byteLength,k=0){for(let t=0;t<v;t++)$[w+t]=k}function l($,w,v="0"){for(;$.length<w;)$=v+$;return $}function m($,w=32){return $ instanceof ArrayBuffer?Array.from(new Uint8Array($)).map(v=>v.toString(16).padStart(2,"0")).join(""):l(($>>>0).toString(16),w/4)}class p{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(f.BLOCK_SIZE+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(w){const v=w.length;if(v===0)return;const k=this.p;let t=this.r,r=this.u,n,c;for(r!==0?(n=r,c=-1,r=0):(n=w.charCodeAt(0),c=0);;){let s=n;if(i.$Kf(n))if(c+1<v){const u=w.charCodeAt(c+1);i.$Lf(u)?(c++,s=i.$Mf(n,u)):s=f.UNICODE_REPLACEMENT}else{r=n;break}else i.$Lf(n)&&(s=f.UNICODE_REPLACEMENT);if(t=this.w(k,t,s),c++,c<v)n=w.charCodeAt(c);else break}this.r=t,this.u=r}w(w,v,k){return k<128?w[v++]=k:k<2048?(w[v++]=192|(k&1984)>>>6,w[v++]=128|(k&63)>>>0):k<65536?(w[v++]=224|(k&61440)>>>12,w[v++]=128|(k&4032)>>>6,w[v++]=128|(k&63)>>>0):(w[v++]=240|(k&1835008)>>>18,w[v++]=128|(k&258048)>>>12,w[v++]=128|(k&4032)>>>6,w[v++]=128|(k&63)>>>0),v>=f.BLOCK_SIZE&&(this.y(),v-=f.BLOCK_SIZE,this.t+=f.BLOCK_SIZE,w[0]=w[f.BLOCK_SIZE+0],w[1]=w[f.BLOCK_SIZE+1],w[2]=w[f.BLOCK_SIZE+2]),v}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,f.UNICODE_REPLACEMENT)),this.t+=this.r,this.x()),m(this.h)+m(this.l)+m(this.m)+m(this.n)+m(this.o)}x(){this.p[this.r++]=128,b(this.p,this.r),this.r>56&&(this.y(),b(this.p));const w=8*this.t;this.q.setUint32(56,Math.floor(w/4294967296),!1),this.q.setUint32(60,w%4294967296,!1),this.y()}y(){const w=p.g,v=this.q;for(let I=0;I<64;I+=4)w.setUint32(I,v.getUint32(I,!1),!1);for(let I=64;I<320;I+=4)w.setUint32(I,g(w.getUint32(I-12,!1)^w.getUint32(I-32,!1)^w.getUint32(I-56,!1)^w.getUint32(I-64,!1),1),!1);let k=this.h,t=this.l,r=this.m,n=this.n,c=this.o,s,u,d;for(let I=0;I<80;I++)I<20?(s=t&r|~t&n,u=1518500249):I<40?(s=t^r^n,u=1859775393):I<60?(s=t&r|t&n|r&n,u=2400959708):(s=t^r^n,u=3395469782),d=g(k,5)+s+c+u+w.getUint32(I*4,!1)&4294967295,c=n,n=r,r=g(t,30),t=k,k=d;this.h=this.h+k&4294967295,this.l=this.l+t&4294967295,this.m=this.m+r&4294967295,this.n=this.n+n&4294967295,this.o=this.o+c&4294967295}}e.$zj=p}),define(oe[79],ae([0,1,26]),function(V,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),i=Re(i);var o;(function(S){S[S.Ignore=0]="Ignore",S[S.Info=1]="Info",S[S.Warning=2]="Warning",S[S.Error=3]="Error"})(o||(o={})),function(S){const D="error",O="warning",P="warn",y="info",a="ignore";function h(g){return g?i.$Gf(D,g)?S.Error:i.$Gf(O,g)||i.$Gf(P,g)?S.Warning:i.$Gf(y,g)?S.Info:S.Ignore:S.Ignore}S.fromValue=h;function f(g){switch(g){case S.Error:return D;case S.Warning:return O;case S.Info:return y;default:return a}}S.toString=f}(o||(o={})),e.default=o}),define(oe[61],ae([0,1,22,39,26]),function(V,e,i,o,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Li=e.$Ki=e.$Ji=e.$Ii=e.$Hi=void 0;class D{constructor(){this.b="",this.c=0}reset(l){return this.b=l,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(l){const m=l.charCodeAt(0),p=this.b.charCodeAt(this.c);return m-p}value(){return this.b[this.c]}}e.$Hi=D;class O{constructor(l=!0){this.e=l}reset(l){return this.b=l,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let l=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===o.CharCode.Period)if(l)this.c++;else break;else l=!1;return this}cmp(l){return this.e?(0,S.$Af)(l,this.b,0,l.length,this.c,this.d):(0,S.$Cf)(l,this.b,0,l.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$Ii=O;class P{constructor(l=!0,m=!0){this.f=l,this.g=m}reset(l){this.d=0,this.e=0,this.b=l,this.c=l.length;for(let m=l.length-1;m>=0;m--,this.c--){const p=this.b.charCodeAt(m);if(!(p===o.CharCode.Slash||this.f&&p===o.CharCode.Backslash))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let l=!0;for(;this.e<this.c;this.e++){const m=this.b.charCodeAt(this.e);if(m===o.CharCode.Slash||this.f&&m===o.CharCode.Backslash)if(l)this.d++;else break;else l=!1}return this}cmp(l){return this.g?(0,S.$Af)(l,this.b,0,l.length,this.d,this.e):(0,S.$Cf)(l,this.b,0,l.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$Ji=P;var y;(function(b){b[b.Scheme=1]="Scheme",b[b.Authority=2]="Authority",b[b.Path=3]="Path",b[b.Query=4]="Query",b[b.Fragment=5]="Fragment"})(y||(y={}));class a{constructor(l,m){this.f=l,this.g=m,this.d=[],this.e=0}reset(l){return this.c=l,this.d=[],this.c.scheme&&this.d.push(y.Scheme),this.c.authority&&this.d.push(y.Authority),this.c.path&&(this.b=new P(!1,!this.f(l)),this.b.reset(l.path),this.b.value()&&this.d.push(y.Path)),this.g(l)||(this.c.query&&this.d.push(y.Query),this.c.fragment&&this.d.push(y.Fragment)),this.e=0,this}next(){return this.d[this.e]===y.Path&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===y.Path&&this.b.hasNext()||this.e<this.d.length-1}cmp(l){if(this.d[this.e]===y.Scheme)return(0,S.$Bf)(l,this.c.scheme);if(this.d[this.e]===y.Authority)return(0,S.$Bf)(l,this.c.authority);if(this.d[this.e]===y.Path)return this.b.cmp(l);if(this.d[this.e]===y.Query)return(0,S.$zf)(l,this.c.query);if(this.d[this.e]===y.Fragment)return(0,S.$zf)(l,this.c.fragment);throw new Error}value(){if(this.d[this.e]===y.Scheme)return this.c.scheme;if(this.d[this.e]===y.Authority)return this.c.authority;if(this.d[this.e]===y.Path)return this.b.value();if(this.d[this.e]===y.Query)return this.c.query;if(this.d[this.e]===y.Fragment)return this.c.fragment;throw new Error}}e.$Ki=a;class h{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const l=this.right;return this.right=l.left,l.left=this,this.updateHeight(),l.updateHeight(),l}rotateRight(){const l=this.left;return this.left=l.right,l.right=this,this.updateHeight(),l.updateHeight(),l}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var f;(function(b){b[b.Left=-1]="Left",b[b.Mid=0]="Mid",b[b.Right=1]="Right"})(f||(f={}));class g{static forUris(l=()=>!1,m=()=>!1){return new g(new a(l,m))}static forPaths(l=!1){return new g(new P(void 0,!l))}static forStrings(){return new g(new D)}static forConfigKeys(){return new g(new O)}constructor(l){this.b=l}clear(){this.c=void 0}fill(l,m){if(m){const p=m.slice(0);(0,i.$Yb)(p);for(const $ of p)this.set($,l)}else{const p=l.slice(0);(0,i.$Yb)(p);for(const $ of p)this.set($[0],$[1])}}set(l,m){const p=this.b.reset(l);let $;this.c||(this.c=new h,this.c.segment=p.value());const w=[];for($=this.c;;){const k=p.cmp($.segment);if(k>0)$.left||($.left=new h,$.left.segment=p.value()),w.push([f.Left,$]),$=$.left;else if(k<0)$.right||($.right=new h,$.right.segment=p.value()),w.push([f.Right,$]),$=$.right;else if(p.hasNext())p.next(),$.mid||($.mid=new h,$.mid.segment=p.value()),w.push([f.Mid,$]),$=$.mid;else break}const v=$.value;$.value=m,$.key=l;for(let k=w.length-1;k>=0;k--){const t=w[k][1];t.updateHeight();const r=t.balanceFactor();if(r<-1||r>1){const n=w[k][0],c=w[k+1][0];if(n===f.Right&&c===f.Right)w[k][1]=t.rotateLeft();else if(n===f.Left&&c===f.Left)w[k][1]=t.rotateRight();else if(n===f.Right&&c===f.Left)t.right=w[k+1][1]=w[k+1][1].rotateRight(),w[k][1]=t.rotateLeft();else if(n===f.Left&&c===f.Right)t.left=w[k+1][1]=w[k+1][1].rotateLeft(),w[k][1]=t.rotateRight();else throw new Error;if(k>0)switch(w[k-1][0]){case f.Left:w[k-1][1].left=w[k][1];break;case f.Right:w[k-1][1].right=w[k][1];break;case f.Mid:w[k-1][1].mid=w[k][1];break}else this.c=w[0][1]}}return v}get(l){return this.d(l)?.value}d(l){const m=this.b.reset(l);let p=this.c;for(;p;){const $=m.cmp(p.segment);if($>0)p=p.left;else if($<0)p=p.right;else if(m.hasNext())m.next(),p=p.mid;else break}return p}has(l){const m=this.d(l);return!(m?.value===void 0&&m?.mid===void 0)}delete(l){return this.e(l,!1)}deleteSuperstr(l){return this.e(l,!0)}e(l,m){const p=this.b.reset(l),$=[];let w=this.c;for(;w;){const v=p.cmp(w.segment);if(v>0)$.push([f.Left,w]),w=w.left;else if(v<0)$.push([f.Right,w]),w=w.right;else if(p.hasNext())p.next(),$.push([f.Mid,w]),w=w.mid;else break}if(w){if(m?(w.left=void 0,w.mid=void 0,w.right=void 0,w.height=1):(w.key=void 0,w.value=void 0),!w.mid&&!w.value)if(w.left&&w.right){const v=this.f(w.right);if(v.key){const{key:k,value:t,segment:r}=v;this.e(v.key,!1),w.key=k,w.value=t,w.segment=r}}else{const v=w.left??w.right;if($.length>0){const[k,t]=$[$.length-1];switch(k){case f.Left:t.left=v;break;case f.Mid:t.mid=v;break;case f.Right:t.right=v;break}}else this.c=v}for(let v=$.length-1;v>=0;v--){const k=$[v][1];k.updateHeight();const t=k.balanceFactor();if(t>1?(k.right.balanceFactor()>=0||(k.right=k.right.rotateRight()),$[v][1]=k.rotateLeft()):t<-1&&(k.left.balanceFactor()<=0||(k.left=k.left.rotateLeft()),$[v][1]=k.rotateRight()),v>0)switch($[v-1][0]){case f.Left:$[v-1][1].left=$[v][1];break;case f.Right:$[v-1][1].right=$[v][1];break;case f.Mid:$[v-1][1].mid=$[v][1];break}else this.c=$[0][1]}}}f(l){for(;l.left;)l=l.left;return l}findSubstr(l){const m=this.b.reset(l);let p=this.c,$;for(;p;){const w=m.cmp(p.segment);if(w>0)p=p.left;else if(w<0)p=p.right;else if(m.hasNext())m.next(),$=p.value||$,p=p.mid;else break}return p&&p.value||$}findSuperstr(l){return this.g(l,!1)}g(l,m){const p=this.b.reset(l);let $=this.c;for(;$;){const w=p.cmp($.segment);if(w>0)$=$.left;else if(w<0)$=$.right;else if(p.hasNext())p.next(),$=$.mid;else return $.mid?this.h($.mid):m?$.value:void 0}}hasElementOrSubtree(l){return this.g(l,!0)!==void 0}forEach(l){for(const[m,p]of this)l(p,m)}*[Symbol.iterator](){yield*this.h(this.c)}h(l){const m=[];return this.j(l,m),m[Symbol.iterator]()}j(l,m){l&&(l.left&&this.j(l.left,m),l.value&&m.push([l.key,l.value]),l.mid&&this.j(l.mid,m),l.right&&this.j(l.right,m))}_isBalanced(){const l=m=>{if(!m)return!0;const p=m.balanceFactor();return p<-1||p>1?!1:l(m.left)&&l(m.right)};return l(this.c)}}e.$Li=g}),define(oe[33],ae([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2g=void 0,e.$1g=o;const i=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function o(S){return i.test(S)}e.$2g=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let S;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?S=crypto.getRandomValues.bind(crypto):S=function(P){for(let y=0;y<P.length;y++)P[y]=Math.floor(Math.random()*256);return P};const D=new Uint8Array(16),O=[];for(let P=0;P<256;P++)O.push(P.toString(16).padStart(2,"0"));return function(){S(D),D[6]=D[6]&15|64,D[8]=D[8]&63|128;let y=0,a="";return a+=O[D[y++]],a+=O[D[y++]],a+=O[D[y++]],a+=O[D[y++]],a+="-",a+=O[D[y++]],a+=O[D[y++]],a+="-",a+=O[D[y++]],a+=O[D[y++]],a+="-",a+=O[D[y++]],a+=O[D[y++]],a+="-",a+=O[D[y++]],a+=O[D[y++]],a+=O[D[y++]],a+=O[D[y++]],a+=O[D[y++]],a+=O[D[y++]],a}}()}),define(oe[149],ae([0,1,91,47,89]),function(V,e,i,o,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uX=D,i=Re(i),o=Re(o);async function D(O,P){if(await new Promise((h,f)=>{const g=o.createReadStream(O),b=i.createHash("sha256");g.pipe(b);const l=(0,S.$fb)((m,p)=>{g.removeAllListeners(),b.removeAllListeners(),m?f(m):h(p)});g.once("error",l),g.once("end",l),b.once("error",l),b.once("data",m=>l(void 0,m.toString("hex")))})!==P)throw new Error("Hash mismatch")}}),define(oe[150],ae([0,1,27]),function(V,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$On=D;const o=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function S(O){const P=O.replace(/\-/g,":").toLowerCase();return!o.has(P)}function D(){const O=(0,i.networkInterfaces)();for(const P in O){const y=O[P];if(y){for(const{mac:a}of y)if(S(a))return a}}throw new Error("Unable to retrieve mac address (unexpected format)")}}),define(oe[112],ae([0,1,92]),function(V,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5g=void 0,e.$4g=o,e.$6g=D,i=Re(i);function o(P,y,a,h=1){let f=!1;return new Promise(g=>{const b=setTimeout(()=>{if(!f)return f=!0,g(0)},a);S(P,y,h,l=>{if(!f)return f=!0,clearTimeout(b),g(l)})})}function S(P,y,a,h){if(y===0)return h(0);const f=new i.Socket;f.once("connect",()=>(O(f),S(P+a,y-1,a,h))),f.once("data",()=>{}),f.once("error",g=>(O(f),g.code!=="ECONNREFUSED"?S(P+a,y-1,a,h):h(P))),f.connect(P,"127.0.0.1")}e.$5g={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function D(P,y,a,h="127.0.0.1"){let f=!1,g,b=1;const l=i.createServer({pauseOnConnect:!0});function m(p,$){f||(f=!0,l.removeAllListeners(),l.close(),g&&clearTimeout(g),$(p))}return new Promise(p=>{g=setTimeout(()=>{m(0,p)},a),l.on("listening",()=>{m(P,p)}),l.on("error",$=>{$&&($.code==="EADDRINUSE"||$.code==="EACCES")&&b<y?(P++,b++,l.listen(P,h)):m(0,p)}),l.on("close",()=>{m(0,p)}),l.listen(P,h)})}function O(P){try{P.removeAllListeners("connect"),P.removeAllListeners("error"),P.end(),P.destroy(),P.unref()}catch(y){console.error(y)}}}),function(){function V(){function e(){return process.uncHostAllowlist}function i(y){const a=new Set;if(Array.isArray(y))for(const h of y)typeof h=="string"&&a.add(h);return Array.from(a)}function o(){const y=e();return y?Array.from(y):[]}function S(y){if(process.platform!=="win32")return;const a=e();if(a)if(typeof y=="string")a.add(y.toLowerCase());else for(const h of i(y))S(h)}function D(y){if(typeof y!="string")return;const a=["\\\\.\\UNC\\","\\\\?\\UNC\\","\\\\"];let h;for(const f of a){if(y.indexOf(f)!==0)continue;const b=y.indexOf("\\",f.length);if(b===-1)continue;const l=y.substring(f.length,b);if(l){h=l;break}}return h}function O(){process.platform==="win32"&&(process.restrictUNCAccess=!1)}function P(){return process.platform!=="win32"?!0:process.restrictUNCAccess===!1}return{getUNCHostAllowlist:o,addUNCHostToAllowlist:S,getUNCHost:D,disableUNCAccessRestrictions:O,isUNCAccessRestrictionsDisabled:P}}typeof define=="function"?define("vs/base/node/unc",[],function(){return V()}):typeof module=="object"&&typeof module.exports=="object"?module.exports=V():console.trace("vs/base/node/unc defined in UNKNOWN context (neither requirejs or commonjs)")}(),define(oe[151],ae([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$AX=e.$zX=void 0,e.$zX="vscode:contextmenu",e.$AX="vscode:onCloseContextMenu"}),define(oe[152],ae([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$HX=void 0;class i{constructor(S,D){this.a=S,this.onMessage=D}send(S){try{this.a.send("vscode:message",S.buffer)}catch{}}disconnect(){this.a.send("vscode:disconnect",null)}}e.$HX=i}),define(oe[153],ae([11,10]),function(V,e){return V.create("vs/base/common/date",e)}),define(oe[154],ae([0,1,153]),function(V,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1m=a,e.$2m=h,e.$3m=f;const o=60,S=o*60,D=S*24,O=D*7,P=D*30,y=D*365;function a(g,b,l,m){typeof g!="number"&&(g=g.getTime());const p=Math.round((new Date().getTime()-g)/1e3);if(p<-30)return(0,i.localize)(0,null,a(new Date().getTime()+p*1e3,!1));if(!m&&p<30)return(0,i.localize)(1,null);let $;return p<o?($=p,b?$===1?l?(0,i.localize)(2,null,$):(0,i.localize)(3,null,$):l?(0,i.localize)(4,null,$):(0,i.localize)(5,null,$):$===1?l?(0,i.localize)(6,null,$):(0,i.localize)(7,null,$):l?(0,i.localize)(8,null,$):(0,i.localize)(9,null,$)):p<S?($=Math.floor(p/o),b?$===1?l?(0,i.localize)(10,null,$):(0,i.localize)(11,null,$):l?(0,i.localize)(12,null,$):(0,i.localize)(13,null,$):$===1?l?(0,i.localize)(14,null,$):(0,i.localize)(15,null,$):l?(0,i.localize)(16,null,$):(0,i.localize)(17,null,$)):p<D?($=Math.floor(p/S),b?$===1?l?(0,i.localize)(18,null,$):(0,i.localize)(19,null,$):l?(0,i.localize)(20,null,$):(0,i.localize)(21,null,$):$===1?l?(0,i.localize)(22,null,$):(0,i.localize)(23,null,$):l?(0,i.localize)(24,null,$):(0,i.localize)(25,null,$)):p<O?($=Math.floor(p/D),b?$===1?(0,i.localize)(26,null,$):(0,i.localize)(27,null,$):$===1?(0,i.localize)(28,null,$):(0,i.localize)(29,null,$)):p<P?($=Math.floor(p/O),b?$===1?l?(0,i.localize)(30,null,$):(0,i.localize)(31,null,$):l?(0,i.localize)(32,null,$):(0,i.localize)(33,null,$):$===1?l?(0,i.localize)(34,null,$):(0,i.localize)(35,null,$):l?(0,i.localize)(36,null,$):(0,i.localize)(37,null,$)):p<y?($=Math.floor(p/P),b?$===1?l?(0,i.localize)(38,null,$):(0,i.localize)(39,null,$):l?(0,i.localize)(40,null,$):(0,i.localize)(41,null,$):$===1?l?(0,i.localize)(42,null,$):(0,i.localize)(43,null,$):l?(0,i.localize)(44,null,$):(0,i.localize)(45,null,$)):($=Math.floor(p/y),b?$===1?l?(0,i.localize)(46,null,$):(0,i.localize)(47,null,$):l?(0,i.localize)(48,null,$):(0,i.localize)(49,null,$):$===1?l?(0,i.localize)(50,null,$):(0,i.localize)(51,null,$):l?(0,i.localize)(52,null,$):(0,i.localize)(53,null,$))}function h(g,b){const l=Math.abs(g/1e3);return l<1?b?(0,i.localize)(54,null,g):(0,i.localize)(55,null,g):l<o?b?(0,i.localize)(56,null,Math.round(g)/1e3):(0,i.localize)(57,null,Math.round(g)/1e3):l<S?b?(0,i.localize)(58,null,Math.round(g/(1e3*o))):(0,i.localize)(59,null,Math.round(g/(1e3*o))):l<D?b?(0,i.localize)(60,null,Math.round(g/(1e3*S))):(0,i.localize)(61,null,Math.round(g/(1e3*S))):(0,i.localize)(62,null,Math.round(g/(1e3*D)))}function f(g){return g.getFullYear()+"-"+String(g.getMonth()+1).padStart(2,"0")+"-"+String(g.getDate()).padStart(2,"0")+"T"+String(g.getHours()).padStart(2,"0")+":"+String(g.getMinutes()).padStart(2,"0")+":"+String(g.getSeconds()).padStart(2,"0")+"."+(g.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}}),define(oe[155],ae([11,10]),function(V,e){return V.create("vs/base/common/errorMessage",e)}),define(oe[53],ae([0,1,22,12,155]),function(V,e,i,o,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qj=y,e.$rj=a,e.$sj=h,i=Re(i),o=Re(o),S=Re(S);function D(f,g){return g&&(f.stack||f.stacktrace)?S.localize(0,null,P(f),O(f.stack)||O(f.stacktrace)):P(f)}function O(f){return Array.isArray(f)?f.join(`
`):f}function P(f){return f.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${f.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof f.code=="string"&&typeof f.errno=="number"&&typeof f.syscall=="string"?S.localize(1,null,f.message):f.message||S.localize(2,null)}function y(f=null,g=!1){if(!f)return S.localize(3,null);if(Array.isArray(f)){const b=i.$Jb(f),l=y(b[0],g);return b.length>1?S.localize(4,null,l,b.length):l}if(o.$fg(f))return f;if(f.detail){const b=f.detail;if(b.error)return D(b.error,g);if(b.exception)return D(b.exception,g)}return f.stack?D(f,g):f.message?f.message:S.localize(5,null)}function a(f){const g=f;return g instanceof Error&&Array.isArray(g.actions)}function h(f,g){let b;return typeof f=="string"?b=new Error(f):b=f,b.actions=g,b}}),define(oe[156],ae([11,10]),function(V,e){return V.create("vs/base/common/jsonErrorMessages",e)}),define(oe[157],ae([0,1,156,43]),function(V,e,i,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eq=S;function S(D){switch(D){case o.ParseErrorCode.InvalidSymbol:return(0,i.localize)(0,null);case o.ParseErrorCode.InvalidNumberFormat:return(0,i.localize)(1,null);case o.ParseErrorCode.PropertyNameExpected:return(0,i.localize)(2,null);case o.ParseErrorCode.ValueExpected:return(0,i.localize)(3,null);case o.ParseErrorCode.ColonExpected:return(0,i.localize)(4,null);case o.ParseErrorCode.CommaExpected:return(0,i.localize)(5,null);case o.ParseErrorCode.CloseBraceExpected:return(0,i.localize)(6,null);case o.ParseErrorCode.CloseBracketExpected:return(0,i.localize)(7,null);case o.ParseErrorCode.EndOfFileExpected:return(0,i.localize)(8,null);default:return""}}}),define(oe[158],ae([11,10]),function(V,e){return V.create("vs/base/common/platform",e)}),define(oe[4],ae([0,1,158]),function(V,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$I=e.$H=e.$G=e.$F=e.$E=e.OS=e.OperatingSystem=e.$B=e.$A=e.$z=e.$y=e.$x=e.Language=e.$w=e.$v=e.$u=e.$t=e.$s=e.$r=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.$i=e.Platform=e.$g=void 0,e.$h=n,e.$D=E,e.$J=A,i=Re(i),e.$g="en";let o=!1,S=!1,D=!1,O=!1,P=!1,y=!1,a=!1,h=!1,f=!1,g=!1,b,l=e.$g,m=e.$g,p,$;const w=globalThis;let v;typeof w.vscode<"u"&&typeof w.vscode.process<"u"?v=w.vscode.process:typeof process<"u"&&typeof process?.versions?.node=="string"&&(v=process);const k=typeof v?.versions?.electron=="string",t=k&&v?.type==="renderer";if(typeof v=="object"){o=v.platform==="win32",S=v.platform==="darwin",D=v.platform==="linux",O=D&&!!v.env.SNAP&&!!v.env.SNAP_REVISION,a=k,f=!!v.env.CI||!!v.env.BUILD_ARTIFACTSTAGINGDIRECTORY,b=e.$g,l=e.$g;const T=v.env.VSCODE_NLS_CONFIG;if(T)try{const L=JSON.parse(T),R=L.availableLanguages["*"];b=L.locale,m=L.osLocale,l=R||e.$g,p=L._translationsConfigFile}catch{}P=!0}else typeof navigator=="object"&&!t?($=navigator.userAgent,o=$.indexOf("Windows")>=0,S=$.indexOf("Macintosh")>=0,h=($.indexOf("Macintosh")>=0||$.indexOf("iPad")>=0||$.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,D=$.indexOf("Linux")>=0,g=$?.indexOf("Mobi")>=0,y=!0,b=i.getConfiguredDefaultLocale(i.localize(0,null))||e.$g,l=b,m=navigator.language):console.error("Unable to resolve platform.");var r;(function(T){T[T.Web=0]="Web",T[T.Mac=1]="Mac",T[T.Linux=2]="Linux",T[T.Windows=3]="Windows"})(r||(e.Platform=r={}));function n(T){switch(T){case r.Web:return"Web";case r.Mac:return"Mac";case r.Linux:return"Linux";case r.Windows:return"Windows"}}let c=r.Web;S?c=r.Mac:o?c=r.Windows:D&&(c=r.Linux),e.$i=o,e.$j=S,e.$k=D,e.$l=O,e.$m=P,e.$n=a,e.$o=y,e.$p=y&&typeof w.importScripts=="function",e.$q=e.$p?w.origin:void 0,e.$r=h,e.$s=g,e.$t=f,e.$u=c,e.$v=$,e.$w=l;var s;(function(T){function L(){return e.$w}T.value=L;function R(){return e.$w.length===2?e.$w==="en":e.$w.length>=3?e.$w[0]==="e"&&e.$w[1]==="n"&&e.$w[2]==="-":!1}T.isDefaultVariant=R;function M(){return e.$w==="en"}T.isDefault=M})(s||(e.Language=s={})),e.$x=b,e.$y=m,e.$z=p,e.$A=typeof w.postMessage=="function"&&!w.importScripts,e.$B=(()=>{if(e.$A){const T=[];w.addEventListener("message",R=>{if(R.data&&R.data.vscodeScheduleAsyncWork)for(let M=0,U=T.length;M<U;M++){const N=T[M];if(N.id===R.data.vscodeScheduleAsyncWork){T.splice(M,1),N.callback();return}}});let L=0;return R=>{const M=++L;T.push({id:M,callback:R}),w.postMessage({vscodeScheduleAsyncWork:M},"*")}}return T=>setTimeout(T)})();var u;(function(T){T[T.Windows=1]="Windows",T[T.Macintosh=2]="Macintosh",T[T.Linux=3]="Linux"})(u||(e.OperatingSystem=u={})),e.OS=S||h?u.Macintosh:o?u.Windows:u.Linux;let d=!0,I=!1;function E(){if(!I){I=!0;const T=new Uint8Array(2);T[0]=1,T[1]=2,d=new Uint16Array(T.buffer)[0]===513}return d}e.$E=!!(e.$v&&e.$v.indexOf("Chrome")>=0),e.$F=!!(e.$v&&e.$v.indexOf("Firefox")>=0),e.$G=!!(!e.$E&&e.$v&&e.$v.indexOf("Safari")>=0),e.$H=!!(e.$v&&e.$v.indexOf("Edg/")>=0),e.$I=!!(e.$v&&e.$v.indexOf("Android")>=0);function A(T){return parseFloat(T)>=20}}),define(oe[36],ae([0,1,4]),function(V,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gc=e.$fc=e.env=e.cwd=void 0;let o;const S=globalThis.vscode;if(typeof S<"u"&&typeof S.process<"u"){const D=S.process;o={get platform(){return D.platform},get arch(){return D.arch},get env(){return D.env},cwd(){return D.cwd()}}}else typeof process<"u"?o={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:o={get platform(){return i.$i?"win32":i.$j?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=o.cwd,e.env=o.env,e.$fc=o.platform,e.$gc=o.arch}),define(oe[9],ae([0,1,36]),function(V,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vc=e.sep=e.$tc=e.$sc=e.$rc=e.$qc=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=e.$jc=e.$ic=e.$hc=void 0,i=Re(i);const o=65,S=97,D=90,O=122,P=46,y=47,a=92,h=58,f=63;class g extends Error{constructor(n,c,s){let u;typeof c=="string"&&c.indexOf("not ")===0?(u="must not be",c=c.replace(/^not /,"")):u="must be";const d=n.indexOf(".")!==-1?"property":"argument";let I=`The "${n}" ${d} ${u} of type ${c}`;I+=`. Received type ${typeof s}`,super(I),this.code="ERR_INVALID_ARG_TYPE"}}function b(r,n){if(r===null||typeof r!="object")throw new g(n,"Object",r)}function l(r,n){if(typeof r!="string")throw new g(n,"string",r)}const m=i.$fc==="win32";function p(r){return r===y||r===a}function $(r){return r===y}function w(r){return r>=o&&r<=D||r>=S&&r<=O}function v(r,n,c,s){let u="",d=0,I=-1,E=0,A=0;for(let T=0;T<=r.length;++T){if(T<r.length)A=r.charCodeAt(T);else{if(s(A))break;A=y}if(s(A)){if(!(I===T-1||E===1))if(E===2){if(u.length<2||d!==2||u.charCodeAt(u.length-1)!==P||u.charCodeAt(u.length-2)!==P){if(u.length>2){const L=u.lastIndexOf(c);L===-1?(u="",d=0):(u=u.slice(0,L),d=u.length-1-u.lastIndexOf(c)),I=T,E=0;continue}else if(u.length!==0){u="",d=0,I=T,E=0;continue}}n&&(u+=u.length>0?`${c}..`:"..",d=2)}else u.length>0?u+=`${c}${r.slice(I+1,T)}`:u=r.slice(I+1,T),d=T-I-1;I=T,E=0}else A===P&&E!==-1?++E:E=-1}return u}function k(r,n){b(n,"pathObject");const c=n.dir||n.root,s=n.base||`${n.name||""}${n.ext||""}`;return c?c===n.root?`${c}${s}`:`${c}${r}${s}`:s}e.$hc={resolve(...r){let n="",c="",s=!1;for(let u=r.length-1;u>=-1;u--){let d;if(u>=0){if(d=r[u],l(d,"path"),d.length===0)continue}else n.length===0?d=i.cwd():(d=i.env[`=${n}`]||i.cwd(),(d===void 0||d.slice(0,2).toLowerCase()!==n.toLowerCase()&&d.charCodeAt(2)===a)&&(d=`${n}\\`));const I=d.length;let E=0,A="",T=!1;const L=d.charCodeAt(0);if(I===1)p(L)&&(E=1,T=!0);else if(p(L))if(T=!0,p(d.charCodeAt(1))){let R=2,M=R;for(;R<I&&!p(d.charCodeAt(R));)R++;if(R<I&&R!==M){const U=d.slice(M,R);for(M=R;R<I&&p(d.charCodeAt(R));)R++;if(R<I&&R!==M){for(M=R;R<I&&!p(d.charCodeAt(R));)R++;(R===I||R!==M)&&(A=`\\\\${U}\\${d.slice(M,R)}`,E=R)}}}else E=1;else w(L)&&d.charCodeAt(1)===h&&(A=d.slice(0,2),E=2,I>2&&p(d.charCodeAt(2))&&(T=!0,E=3));if(A.length>0)if(n.length>0){if(A.toLowerCase()!==n.toLowerCase())continue}else n=A;if(s){if(n.length>0)break}else if(c=`${d.slice(E)}\\${c}`,s=T,T&&n.length>0)break}return c=v(c,!s,"\\",p),s?`${n}\\${c}`:`${n}${c}`||"."},normalize(r){l(r,"path");const n=r.length;if(n===0)return".";let c=0,s,u=!1;const d=r.charCodeAt(0);if(n===1)return $(d)?"\\":r;if(p(d))if(u=!0,p(r.charCodeAt(1))){let E=2,A=E;for(;E<n&&!p(r.charCodeAt(E));)E++;if(E<n&&E!==A){const T=r.slice(A,E);for(A=E;E<n&&p(r.charCodeAt(E));)E++;if(E<n&&E!==A){for(A=E;E<n&&!p(r.charCodeAt(E));)E++;if(E===n)return`\\\\${T}\\${r.slice(A)}\\`;E!==A&&(s=`\\\\${T}\\${r.slice(A,E)}`,c=E)}}}else c=1;else w(d)&&r.charCodeAt(1)===h&&(s=r.slice(0,2),c=2,n>2&&p(r.charCodeAt(2))&&(u=!0,c=3));let I=c<n?v(r.slice(c),!u,"\\",p):"";return I.length===0&&!u&&(I="."),I.length>0&&p(r.charCodeAt(n-1))&&(I+="\\"),s===void 0?u?`\\${I}`:I:u?`${s}\\${I}`:`${s}${I}`},isAbsolute(r){l(r,"path");const n=r.length;if(n===0)return!1;const c=r.charCodeAt(0);return p(c)||n>2&&w(c)&&r.charCodeAt(1)===h&&p(r.charCodeAt(2))},join(...r){if(r.length===0)return".";let n,c;for(let d=0;d<r.length;++d){const I=r[d];l(I,"path"),I.length>0&&(n===void 0?n=c=I:n+=`\\${I}`)}if(n===void 0)return".";let s=!0,u=0;if(typeof c=="string"&&p(c.charCodeAt(0))){++u;const d=c.length;d>1&&p(c.charCodeAt(1))&&(++u,d>2&&(p(c.charCodeAt(2))?++u:s=!1))}if(s){for(;u<n.length&&p(n.charCodeAt(u));)u++;u>=2&&(n=`\\${n.slice(u)}`)}return e.$hc.normalize(n)},relative(r,n){if(l(r,"from"),l(n,"to"),r===n)return"";const c=e.$hc.resolve(r),s=e.$hc.resolve(n);if(c===s||(r=c.toLowerCase(),n=s.toLowerCase(),r===n))return"";let u=0;for(;u<r.length&&r.charCodeAt(u)===a;)u++;let d=r.length;for(;d-1>u&&r.charCodeAt(d-1)===a;)d--;const I=d-u;let E=0;for(;E<n.length&&n.charCodeAt(E)===a;)E++;let A=n.length;for(;A-1>E&&n.charCodeAt(A-1)===a;)A--;const T=A-E,L=I<T?I:T;let R=-1,M=0;for(;M<L;M++){const N=r.charCodeAt(u+M);if(N!==n.charCodeAt(E+M))break;N===a&&(R=M)}if(M!==L){if(R===-1)return s}else{if(T>L){if(n.charCodeAt(E+M)===a)return s.slice(E+M+1);if(M===2)return s.slice(E+M)}I>L&&(r.charCodeAt(u+M)===a?R=M:M===2&&(R=3)),R===-1&&(R=0)}let U="";for(M=u+R+1;M<=d;++M)(M===d||r.charCodeAt(M)===a)&&(U+=U.length===0?"..":"\\..");return E+=R,U.length>0?`${U}${s.slice(E,A)}`:(s.charCodeAt(E)===a&&++E,s.slice(E,A))},toNamespacedPath(r){if(typeof r!="string"||r.length===0)return r;const n=e.$hc.resolve(r);if(n.length<=2)return r;if(n.charCodeAt(0)===a){if(n.charCodeAt(1)===a){const c=n.charCodeAt(2);if(c!==f&&c!==P)return`\\\\?\\UNC\\${n.slice(2)}`}}else if(w(n.charCodeAt(0))&&n.charCodeAt(1)===h&&n.charCodeAt(2)===a)return`\\\\?\\${n}`;return r},dirname(r){l(r,"path");const n=r.length;if(n===0)return".";let c=-1,s=0;const u=r.charCodeAt(0);if(n===1)return p(u)?r:".";if(p(u)){if(c=s=1,p(r.charCodeAt(1))){let E=2,A=E;for(;E<n&&!p(r.charCodeAt(E));)E++;if(E<n&&E!==A){for(A=E;E<n&&p(r.charCodeAt(E));)E++;if(E<n&&E!==A){for(A=E;E<n&&!p(r.charCodeAt(E));)E++;if(E===n)return r;E!==A&&(c=s=E+1)}}}}else w(u)&&r.charCodeAt(1)===h&&(c=n>2&&p(r.charCodeAt(2))?3:2,s=c);let d=-1,I=!0;for(let E=n-1;E>=s;--E)if(p(r.charCodeAt(E))){if(!I){d=E;break}}else I=!1;if(d===-1){if(c===-1)return".";d=c}return r.slice(0,d)},basename(r,n){n!==void 0&&l(n,"ext"),l(r,"path");let c=0,s=-1,u=!0,d;if(r.length>=2&&w(r.charCodeAt(0))&&r.charCodeAt(1)===h&&(c=2),n!==void 0&&n.length>0&&n.length<=r.length){if(n===r)return"";let I=n.length-1,E=-1;for(d=r.length-1;d>=c;--d){const A=r.charCodeAt(d);if(p(A)){if(!u){c=d+1;break}}else E===-1&&(u=!1,E=d+1),I>=0&&(A===n.charCodeAt(I)?--I===-1&&(s=d):(I=-1,s=E))}return c===s?s=E:s===-1&&(s=r.length),r.slice(c,s)}for(d=r.length-1;d>=c;--d)if(p(r.charCodeAt(d))){if(!u){c=d+1;break}}else s===-1&&(u=!1,s=d+1);return s===-1?"":r.slice(c,s)},extname(r){l(r,"path");let n=0,c=-1,s=0,u=-1,d=!0,I=0;r.length>=2&&r.charCodeAt(1)===h&&w(r.charCodeAt(0))&&(n=s=2);for(let E=r.length-1;E>=n;--E){const A=r.charCodeAt(E);if(p(A)){if(!d){s=E+1;break}continue}u===-1&&(d=!1,u=E+1),A===P?c===-1?c=E:I!==1&&(I=1):c!==-1&&(I=-1)}return c===-1||u===-1||I===0||I===1&&c===u-1&&c===s+1?"":r.slice(c,u)},format:k.bind(null,"\\"),parse(r){l(r,"path");const n={root:"",dir:"",base:"",ext:"",name:""};if(r.length===0)return n;const c=r.length;let s=0,u=r.charCodeAt(0);if(c===1)return p(u)?(n.root=n.dir=r,n):(n.base=n.name=r,n);if(p(u)){if(s=1,p(r.charCodeAt(1))){let R=2,M=R;for(;R<c&&!p(r.charCodeAt(R));)R++;if(R<c&&R!==M){for(M=R;R<c&&p(r.charCodeAt(R));)R++;if(R<c&&R!==M){for(M=R;R<c&&!p(r.charCodeAt(R));)R++;R===c?s=R:R!==M&&(s=R+1)}}}}else if(w(u)&&r.charCodeAt(1)===h){if(c<=2)return n.root=n.dir=r,n;if(s=2,p(r.charCodeAt(2))){if(c===3)return n.root=n.dir=r,n;s=3}}s>0&&(n.root=r.slice(0,s));let d=-1,I=s,E=-1,A=!0,T=r.length-1,L=0;for(;T>=s;--T){if(u=r.charCodeAt(T),p(u)){if(!A){I=T+1;break}continue}E===-1&&(A=!1,E=T+1),u===P?d===-1?d=T:L!==1&&(L=1):d!==-1&&(L=-1)}return E!==-1&&(d===-1||L===0||L===1&&d===E-1&&d===I+1?n.base=n.name=r.slice(I,E):(n.name=r.slice(I,d),n.base=r.slice(I,E),n.ext=r.slice(d,E))),I>0&&I!==s?n.dir=r.slice(0,I-1):n.dir=n.root,n},sep:"\\",delimiter:";",win32:null,posix:null};const t=(()=>{if(m){const r=/\\/g;return()=>{const n=i.cwd().replace(r,"/");return n.slice(n.indexOf("/"))}}return()=>i.cwd()})();e.$ic={resolve(...r){let n="",c=!1;for(let s=r.length-1;s>=-1&&!c;s--){const u=s>=0?r[s]:t();l(u,"path"),u.length!==0&&(n=`${u}/${n}`,c=u.charCodeAt(0)===y)}return n=v(n,!c,"/",$),c?`/${n}`:n.length>0?n:"."},normalize(r){if(l(r,"path"),r.length===0)return".";const n=r.charCodeAt(0)===y,c=r.charCodeAt(r.length-1)===y;return r=v(r,!n,"/",$),r.length===0?n?"/":c?"./":".":(c&&(r+="/"),n?`/${r}`:r)},isAbsolute(r){return l(r,"path"),r.length>0&&r.charCodeAt(0)===y},join(...r){if(r.length===0)return".";let n;for(let c=0;c<r.length;++c){const s=r[c];l(s,"path"),s.length>0&&(n===void 0?n=s:n+=`/${s}`)}return n===void 0?".":e.$ic.normalize(n)},relative(r,n){if(l(r,"from"),l(n,"to"),r===n||(r=e.$ic.resolve(r),n=e.$ic.resolve(n),r===n))return"";const c=1,s=r.length,u=s-c,d=1,I=n.length-d,E=u<I?u:I;let A=-1,T=0;for(;T<E;T++){const R=r.charCodeAt(c+T);if(R!==n.charCodeAt(d+T))break;R===y&&(A=T)}if(T===E)if(I>E){if(n.charCodeAt(d+T)===y)return n.slice(d+T+1);if(T===0)return n.slice(d+T)}else u>E&&(r.charCodeAt(c+T)===y?A=T:T===0&&(A=0));let L="";for(T=c+A+1;T<=s;++T)(T===s||r.charCodeAt(T)===y)&&(L+=L.length===0?"..":"/..");return`${L}${n.slice(d+A)}`},toNamespacedPath(r){return r},dirname(r){if(l(r,"path"),r.length===0)return".";const n=r.charCodeAt(0)===y;let c=-1,s=!0;for(let u=r.length-1;u>=1;--u)if(r.charCodeAt(u)===y){if(!s){c=u;break}}else s=!1;return c===-1?n?"/":".":n&&c===1?"//":r.slice(0,c)},basename(r,n){n!==void 0&&l(n,"ext"),l(r,"path");let c=0,s=-1,u=!0,d;if(n!==void 0&&n.length>0&&n.length<=r.length){if(n===r)return"";let I=n.length-1,E=-1;for(d=r.length-1;d>=0;--d){const A=r.charCodeAt(d);if(A===y){if(!u){c=d+1;break}}else E===-1&&(u=!1,E=d+1),I>=0&&(A===n.charCodeAt(I)?--I===-1&&(s=d):(I=-1,s=E))}return c===s?s=E:s===-1&&(s=r.length),r.slice(c,s)}for(d=r.length-1;d>=0;--d)if(r.charCodeAt(d)===y){if(!u){c=d+1;break}}else s===-1&&(u=!1,s=d+1);return s===-1?"":r.slice(c,s)},extname(r){l(r,"path");let n=-1,c=0,s=-1,u=!0,d=0;for(let I=r.length-1;I>=0;--I){const E=r.charCodeAt(I);if(E===y){if(!u){c=I+1;break}continue}s===-1&&(u=!1,s=I+1),E===P?n===-1?n=I:d!==1&&(d=1):n!==-1&&(d=-1)}return n===-1||s===-1||d===0||d===1&&n===s-1&&n===c+1?"":r.slice(n,s)},format:k.bind(null,"/"),parse(r){l(r,"path");const n={root:"",dir:"",base:"",ext:"",name:""};if(r.length===0)return n;const c=r.charCodeAt(0)===y;let s;c?(n.root="/",s=1):s=0;let u=-1,d=0,I=-1,E=!0,A=r.length-1,T=0;for(;A>=s;--A){const L=r.charCodeAt(A);if(L===y){if(!E){d=A+1;break}continue}I===-1&&(E=!1,I=A+1),L===P?u===-1?u=A:T!==1&&(T=1):u!==-1&&(T=-1)}if(I!==-1){const L=d===0&&c?1:d;u===-1||T===0||T===1&&u===I-1&&u===d+1?n.base=n.name=r.slice(L,I):(n.name=r.slice(L,u),n.base=r.slice(L,I),n.ext=r.slice(u,I))}return d>0?n.dir=r.slice(0,d-1):c&&(n.dir="/"),n},sep:"/",delimiter:":",win32:null,posix:null},e.$ic.win32=e.$hc.win32=e.$hc,e.$ic.posix=e.$hc.posix=e.$ic,e.$jc=m?e.$hc.normalize:e.$ic.normalize,e.$kc=m?e.$hc.isAbsolute:e.$ic.isAbsolute,e.$lc=m?e.$hc.join:e.$ic.join,e.$mc=m?e.$hc.resolve:e.$ic.resolve,e.$nc=m?e.$hc.relative:e.$ic.relative,e.$oc=m?e.$hc.dirname:e.$ic.dirname,e.$pc=m?e.$hc.basename:e.$ic.basename,e.$qc=m?e.$hc.extname:e.$ic.extname,e.$rc=m?e.$hc.format:e.$ic.format,e.$sc=m?e.$hc.parse:e.$ic.parse,e.$tc=m?e.$hc.toNamespacedPath:e.$ic.toNamespacedPath,e.sep=m?e.$hc.sep:e.$ic.sep,e.$vc=m?e.$hc.delimiter:e.$ic.delimiter}),define(oe[31],ae([0,1,39,9,4,26,12]),function(V,e,i,o,S,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xg=P,e.$yg=y,e.$zg=a,e.$Ag=h,e.$Bg=f,e.$Cg=m,e.$Dg=p,e.$Eg=$,e.$Fg=w,e.$Gg=v,e.$Hg=k,e.$Ig=t,e.$Jg=r,e.$Kg=n,e.$Lg=c,e.$Mg=s,e.$Ng=I;function P(E){return E===i.CharCode.Slash||E===i.CharCode.Backslash}function y(E){return E.replace(/[\\/]/g,o.$ic.sep)}function a(E){return E.indexOf("/")===-1&&(E=y(E)),/^[a-zA-Z]:(\/|$)/.test(E)&&(E="/"+E),E}function h(E,A=o.$ic.sep){if(!E)return"";const T=E.length,L=E.charCodeAt(0);if(P(L)){if(P(E.charCodeAt(1))&&!P(E.charCodeAt(2))){let M=3;const U=M;for(;M<T&&!P(E.charCodeAt(M));M++);if(U!==M&&!P(E.charCodeAt(M+1))){for(M+=1;M<T;M++)if(P(E.charCodeAt(M)))return E.slice(0,M+1).replace(/[\\/]/g,A)}}return A}else if(w(L)&&E.charCodeAt(1)===i.CharCode.Colon)return P(E.charCodeAt(2))?E.slice(0,2)+A:E.slice(0,2);let R=E.indexOf("://");if(R!==-1){for(R+=3;R<T;R++)if(P(E.charCodeAt(R)))return E.slice(0,R+1)}return""}function f(E){if(!S.$i||!E||E.length<5)return!1;let A=E.charCodeAt(0);if(A!==i.CharCode.Backslash||(A=E.charCodeAt(1),A!==i.CharCode.Backslash))return!1;let T=2;const L=T;for(;T<E.length&&(A=E.charCodeAt(T),A!==i.CharCode.Backslash);T++);return!(L===T||(A=E.charCodeAt(T+1),isNaN(A)||A===i.CharCode.Backslash))}const g=/[\\/:\*\?"<>\|]/g,b=/[/]/g,l=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function m(E,A=S.$i){const T=A?g:b;return!(!E||E.length===0||/^\s+$/.test(E)||(T.lastIndex=0,T.test(E))||A&&l.test(E)||E==="."||E===".."||A&&E[E.length-1]==="."||A&&E.length!==E.trim().length||E.length>255)}function p(E,A,T){const L=E===A;return!T||L?L:!E||!A?!1:(0,D.$Gf)(E,A)}function $(E,A,T,L=o.sep){if(E===A)return!0;if(!E||!A||A.length>E.length)return!1;if(T){if(!(0,D.$Hf)(E,A))return!1;if(A.length===E.length)return!0;let M=A.length;return A.charAt(A.length-1)===L&&M--,E.charAt(M)===L}return A.charAt(A.length-1)!==L&&(A+=L),E.indexOf(A)===0}function w(E){return E>=i.CharCode.A&&E<=i.CharCode.Z||E>=i.CharCode.a&&E<=i.CharCode.z}function v(E,A){return S.$i&&E.endsWith(":")&&(E+=o.sep),(0,o.$kc)(E)||(E=(0,o.$lc)(A,E)),E=(0,o.$jc)(E),k(E)}function k(E){return S.$i?(E=(0,D.$of)(E,o.sep),E.endsWith(":")&&(E+=o.sep)):(E=(0,D.$of)(E,o.sep),E||(E=o.sep)),E}function t(E){const A=(0,o.$jc)(E);return S.$i?E.length>3?!1:r(A)&&(E.length===2||A.charCodeAt(2)===i.CharCode.Backslash):A===o.$ic.sep}function r(E,A=S.$i){return A?w(E.charCodeAt(0))&&E.charCodeAt(1)===i.CharCode.Colon:!1}function n(E,A=S.$i){return r(E,A)?E[0]:void 0}function c(E,A,T){return A.length>E.length?-1:E===A?0:(T&&(E=E.toLowerCase(),A=A.toLowerCase()),E.indexOf(A))}function s(E){const A=E.split(":");let T,L,R;for(const M of A){const U=Number(M);(0,O.$jg)(U)?L===void 0?L=U:R===void 0&&(R=U):T=T?[T,M].join(":"):M}if(!T)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:T,line:L!==void 0?L:void 0,column:R!==void 0?R:L!==void 0?1:void 0}}const u="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",d="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function I(E,A,T=8){let L="";for(let M=0;M<T;M++){let U;M===0&&S.$i&&!A&&(T===3||T===4)?U=d:U=u,L+=U.charAt(Math.floor(Math.random()*U.length))}let R;return A?R=`${A}-${L}`:R=L,E?(0,o.$lc)(E,R):R}}),define(oe[80],ae([0,1,4]),function(V,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminateResponseCode=e.Source=void 0,e.$km=D,e.$lm=O;var o;(function(P){P[P.stdout=0]="stdout",P[P.stderr=1]="stderr"})(o||(e.Source=o={}));var S;(function(P){P[P.Success=0]="Success",P[P.Unknown=1]="Unknown",P[P.AccessDenied=2]="AccessDenied",P[P.ProcessNotFound=3]="ProcessNotFound"})(S||(e.TerminateResponseCode=S={}));function D(P,...y){const a=y.reduce((g,b)=>(g[b]=!0,g),{}),h=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(P).filter(g=>!a[g]).forEach(g=>{for(let b=0;b<h.length;b++)if(g.search(h[b])!==-1){delete P[g];break}})}function O(P){P&&(delete P.DEBUG,i.$j&&delete P.DYLD_LIBRARY_PATH,i.$k&&delete P.LD_PRELOAD)}}),define(oe[7],ae([0,1,39,90,9,4]),function(V,e,i,o,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URI=void 0,e.$xc=p,e.$yc=r,S=Re(S);const O=/^\w[\w\d+.-]*$/,P=/^\//,y=/^\/\//;function a(d,I){if(!d.scheme&&I)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${d.authority}", path: "${d.path}", query: "${d.query}", fragment: "${d.fragment}"}`);if(d.scheme&&!O.test(d.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(d.path){if(d.authority){if(!P.test(d.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(y.test(d.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function h(d,I){return!d&&!I?"file":d}function f(d,I){switch(d){case"https":case"http":case"file":I?I[0]!==b&&(I=b+I):I=b;break}return I}const g="",b="/",l=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class m{static isUri(I){return I instanceof m?!0:I?typeof I.authority=="string"&&typeof I.fragment=="string"&&typeof I.path=="string"&&typeof I.query=="string"&&typeof I.scheme=="string"&&typeof I.fsPath=="string"&&typeof I.with=="function"&&typeof I.toString=="function":!1}constructor(I,E,A,T,L,R=!1){typeof I=="object"?(this.scheme=I.scheme||g,this.authority=I.authority||g,this.path=I.path||g,this.query=I.query||g,this.fragment=I.fragment||g):(this.scheme=h(I,R),this.authority=E||g,this.path=f(this.scheme,A||g),this.query=T||g,this.fragment=L||g,a(this,R))}get fsPath(){return r(this,!1)}with(I){if(!I)return this;let{scheme:E,authority:A,path:T,query:L,fragment:R}=I;return E===void 0?E=this.scheme:E===null&&(E=g),A===void 0?A=this.authority:A===null&&(A=g),T===void 0?T=this.path:T===null&&(T=g),L===void 0?L=this.query:L===null&&(L=g),R===void 0?R=this.fragment:R===null&&(R=g),E===this.scheme&&A===this.authority&&T===this.path&&L===this.query&&R===this.fragment?this:new w(E,A,T,L,R)}static parse(I,E=!1){const A=l.exec(I);return A?new w(A[2]||g,u(A[4]||g),u(A[5]||g),u(A[7]||g),u(A[9]||g),E):new w(g,g,g,g,g)}static file(I){let E=g;if(D.$i&&(I=I.replace(/\\/g,b)),I[0]===b&&I[1]===b){const A=I.indexOf(b,2);A===-1?(E=I.substring(2),I=b):(E=I.substring(2,A),I=I.substring(A)||b)}return new w("file",E,I,g,g)}static from(I,E){return new w(I.scheme,I.authority,I.path,I.query,I.fragment,E)}static joinPath(I,...E){if(!I.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let A;return D.$i&&I.scheme==="file"?A=m.file(S.$hc.join(r(I,!0),...E)).path:A=S.$ic.join(I.path,...E),I.with({path:A})}toString(I=!1){return n(this,I)}toJSON(){return this}static revive(I){if(I){if(I instanceof m)return I;{const E=new w(I);return E._formatted=I.external??null,E._fsPath=I._sep===$?I.fsPath??null:null,E}}else return I}}e.URI=m;function p(d){return!d||typeof d!="object"?!1:typeof d.scheme=="string"&&(typeof d.authority=="string"||typeof d.authority>"u")&&(typeof d.path=="string"||typeof d.path>"u")&&(typeof d.query=="string"||typeof d.query>"u")&&(typeof d.fragment=="string"||typeof d.fragment>"u")}const $=D.$i?1:void 0;class w extends m{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=r(this,!1)),this._fsPath}toString(I=!1){return I?n(this,!0):(this._formatted||(this._formatted=n(this,!1)),this._formatted)}toJSON(){const I={$mid:o.MarshalledId.Uri};return this._fsPath&&(I.fsPath=this._fsPath,I._sep=$),this._formatted&&(I.external=this._formatted),this.path&&(I.path=this.path),this.scheme&&(I.scheme=this.scheme),this.authority&&(I.authority=this.authority),this.query&&(I.query=this.query),this.fragment&&(I.fragment=this.fragment),I}}const v={[i.CharCode.Colon]:"%3A",[i.CharCode.Slash]:"%2F",[i.CharCode.QuestionMark]:"%3F",[i.CharCode.Hash]:"%23",[i.CharCode.OpenSquareBracket]:"%5B",[i.CharCode.CloseSquareBracket]:"%5D",[i.CharCode.AtSign]:"%40",[i.CharCode.ExclamationMark]:"%21",[i.CharCode.DollarSign]:"%24",[i.CharCode.Ampersand]:"%26",[i.CharCode.SingleQuote]:"%27",[i.CharCode.OpenParen]:"%28",[i.CharCode.CloseParen]:"%29",[i.CharCode.Asterisk]:"%2A",[i.CharCode.Plus]:"%2B",[i.CharCode.Comma]:"%2C",[i.CharCode.Semicolon]:"%3B",[i.CharCode.Equals]:"%3D",[i.CharCode.Space]:"%20"};function k(d,I,E){let A,T=-1;for(let L=0;L<d.length;L++){const R=d.charCodeAt(L);if(R>=i.CharCode.a&&R<=i.CharCode.z||R>=i.CharCode.A&&R<=i.CharCode.Z||R>=i.CharCode.Digit0&&R<=i.CharCode.Digit9||R===i.CharCode.Dash||R===i.CharCode.Period||R===i.CharCode.Underline||R===i.CharCode.Tilde||I&&R===i.CharCode.Slash||E&&R===i.CharCode.OpenSquareBracket||E&&R===i.CharCode.CloseSquareBracket||E&&R===i.CharCode.Colon)T!==-1&&(A+=encodeURIComponent(d.substring(T,L)),T=-1),A!==void 0&&(A+=d.charAt(L));else{A===void 0&&(A=d.substr(0,L));const M=v[R];M!==void 0?(T!==-1&&(A+=encodeURIComponent(d.substring(T,L)),T=-1),A+=M):T===-1&&(T=L)}}return T!==-1&&(A+=encodeURIComponent(d.substring(T))),A!==void 0?A:d}function t(d){let I;for(let E=0;E<d.length;E++){const A=d.charCodeAt(E);A===i.CharCode.Hash||A===i.CharCode.QuestionMark?(I===void 0&&(I=d.substr(0,E)),I+=v[A]):I!==void 0&&(I+=d[E])}return I!==void 0?I:d}function r(d,I){let E;return d.authority&&d.path.length>1&&d.scheme==="file"?E=`//${d.authority}${d.path}`:d.path.charCodeAt(0)===i.CharCode.Slash&&(d.path.charCodeAt(1)>=i.CharCode.A&&d.path.charCodeAt(1)<=i.CharCode.Z||d.path.charCodeAt(1)>=i.CharCode.a&&d.path.charCodeAt(1)<=i.CharCode.z)&&d.path.charCodeAt(2)===i.CharCode.Colon?I?E=d.path.substr(1):E=d.path[1].toLowerCase()+d.path.substr(2):E=d.path,D.$i&&(E=E.replace(/\//g,"\\")),E}function n(d,I){const E=I?t:k;let A="",{scheme:T,authority:L,path:R,query:M,fragment:U}=d;if(T&&(A+=T,A+=":"),(L||T==="file")&&(A+=b,A+=b),L){let N=L.indexOf("@");if(N!==-1){const z=L.substr(0,N);L=L.substr(N+1),N=z.lastIndexOf(":"),N===-1?A+=E(z,!1,!1):(A+=E(z.substr(0,N),!1,!1),A+=":",A+=E(z.substr(N+1),!1,!0)),A+="@"}L=L.toLowerCase(),N=L.lastIndexOf(":"),N===-1?A+=E(L,!1,!0):(A+=E(L.substr(0,N),!1,!0),A+=L.substr(N))}if(R){if(R.length>=3&&R.charCodeAt(0)===i.CharCode.Slash&&R.charCodeAt(2)===i.CharCode.Colon){const N=R.charCodeAt(1);N>=i.CharCode.A&&N<=i.CharCode.Z&&(R=`/${String.fromCharCode(N+32)}:${R.substr(3)}`)}else if(R.length>=2&&R.charCodeAt(1)===i.CharCode.Colon){const N=R.charCodeAt(0);N>=i.CharCode.A&&N<=i.CharCode.Z&&(R=`${String.fromCharCode(N+32)}:${R.substr(2)}`)}A+=E(R,!0,!1)}return M&&(A+="?",A+=E(M,!1,!1)),U&&(A+="#",A+=I?U:k(U,!1,!1)),A}function c(d){try{return decodeURIComponent(d)}catch{return d.length>3?d.substr(0,3)+c(d.substr(3)):d}}const s=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function u(d){return d.match(s)?d.replace(s,I=>c(I)):d}}),define(oe[159],ae([0,1,7]),function(V,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9q=o,e.$0q=S,e.$$q=D,e.log=P;function o(a){const h=a;return h&&typeof h.type=="string"&&typeof h.severity=="string"}function S(a){const h=[];let f;try{const g=JSON.parse(a.arguments),b=g[g.length-1];b&&b.__$stack&&(g.pop(),f=b.__$stack),h.push(...g)}catch{h.push("Unable to log remote console arguments",a.arguments)}return{args:h,stack:f}}function D(a){if(typeof a!="string")return D(S(a).stack);const h=a;if(h){const f=O(h),g=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(f||"");if(g&&g.length===4)return{uri:i.URI.file(g[1]),line:Number(g[2]),column:Number(g[3])}}}function O(a){if(!a)return a;const h=a.indexOf(`
`);return h===-1?a:a.substring(0,h)}function P(a,h){const{args:f,stack:g}=S(a),b=typeof f[0]=="string"&&f.length===1;let l=O(g);l&&(l=`(${l.trim()})`);let m=[];if(typeof f[0]=="string"?l&&b?m=[`%c[${h}] %c${f[0]} %c${l}`,y("blue"),y(""),y("grey")]:m=[`%c[${h}] %c${f[0]}`,y("blue"),y(""),...f.slice(1)]:m=[`%c[${h}]%`,y("blue"),...f],l&&!b&&m.push(l),typeof console[a.severity]!="function")throw new Error("Unknown console method");console[a.severity].apply(console,m)}function y(a){return`color: ${a}`}}),define(oe[81],ae([0,1,17,7,90]),function(V,e,i,o,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ai=D,e.$bi=O,e.$ci=y;function D(a){return JSON.stringify(a,P)}function O(a){let h=JSON.parse(a);return h=y(h),h}function P(a,h){return h instanceof RegExp?{$mid:S.MarshalledId.Regexp,source:h.source,flags:h.flags}:h}function y(a,h=0){if(!a||h>200)return a;if(typeof a=="object"){switch(a.$mid){case S.MarshalledId.Uri:return o.URI.revive(a);case S.MarshalledId.Regexp:return new RegExp(a.source,a.flags);case S.MarshalledId.Date:return new Date(a.source)}if(a instanceof i.$Oe||a instanceof Uint8Array)return a;if(Array.isArray(a))for(let f=0;f<a.length;++f)a[f]=y(a[f],h+1);else for(const f in a)Object.hasOwnProperty.call(a,f)&&(a[f]=y(a[f],h+1))}return a}}),define(oe[13],ae([0,1,16,4,26,7,9]),function(V,e,i,o,S,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Sg=e.$Rg=e.$Qg=e.Schemas=void 0,e.$Og=y,e.$Pg=a,e.$Tg=f,i=Re(i),o=Re(o),O=Re(O);var P;(function(l){l.inMemory="inmemory",l.vscode="vscode",l.internal="private",l.walkThrough="walkThrough",l.walkThroughSnippet="walkThroughSnippet",l.http="http",l.https="https",l.file="file",l.mailto="mailto",l.untitled="untitled",l.data="data",l.command="command",l.vscodeRemote="vscode-remote",l.vscodeRemoteResource="vscode-remote-resource",l.vscodeManagedRemoteResource="vscode-managed-remote-resource",l.vscodeUserData="vscode-userdata",l.vscodeCustomEditor="vscode-custom-editor",l.vscodeNotebookCell="vscode-notebook-cell",l.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",l.vscodeNotebookCellOutput="vscode-notebook-cell-output",l.vscodeInteractiveInput="vscode-interactive-input",l.vscodeSettings="vscode-settings",l.vscodeWorkspaceTrust="vscode-workspace-trust",l.vscodeTerminal="vscode-terminal",l.vscodeChatCodeBlock="vscode-chat-code-block",l.vscodeCopilotBackingChatCodeBlock="vscode-copilot-chat-code-block",l.vscodeChatCodeCompareBlock="vscode-chat-code-compare-block",l.vscodeChatSesssion="vscode-chat-editor",l.webviewPanel="webview-panel",l.vscodeWebview="vscode-webview",l.extension="extension",l.vscodeFileResource="vscode-file",l.tmp="tmp",l.vsls="vsls",l.vscodeSourceControl="vscode-scm",l.commentsInput="comment",l.codeSetting="code-setting"})(P||(e.Schemas=P={}));function y(l,m){return D.URI.isUri(l)?(0,S.$Gf)(l.scheme,m):(0,S.$Hf)(l,m+":")}function a(l,...m){return m.some(p=>y(l,p))}e.$Qg="vscode-tkn",e.$Rg="tkn";class h{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f="/"}setPreferredWebSchema(m){this.d=m}setDelegate(m){this.e=m}setServerRootPath(m,p){this.f=f(m,p)}getServerRootPath(){return this.f}get g(){return O.$ic.join(this.f,P.vscodeRemoteResource)}set(m,p,$){this.a[m]=p,this.b[m]=$}setConnectionToken(m,p){this.c[m]=p}getPreferredWebSchema(){return this.d}rewrite(m){if(this.e)try{return this.e(m)}catch(t){return i.$3(t),m}const p=m.authority;let $=this.a[p];$&&$.indexOf(":")!==-1&&$.indexOf("[")===-1&&($=`[${$}]`);const w=this.b[p],v=this.c[p];let k=`path=${encodeURIComponent(m.path)}`;return typeof v=="string"&&(k+=`&${e.$Rg}=${encodeURIComponent(v)}`),D.URI.from({scheme:o.$o?this.d:P.vscodeRemoteResource,authority:`${$}:${w}`,path:this.g,query:k})}}e.$Sg=new h;function f(l,m){return O.$ic.join(m??"/",`${l.quality??"oss"}-${l.commit??"dev"}`)}e.$Ug="vs/../../extensions",e.$Vg="vs/../../node_modules",e.$Wg="vs/../../node_modules.asar",e.$Xg="vs/../../node_modules.asar.unpacked",e.$Yg="vscode-app";class g{static{this.a=e.$Yg}asBrowserUri(m){const p=this.b(m,V);return this.uriToBrowserUri(p)}uriToBrowserUri(m){return m.scheme===P.vscodeRemote?e.$Sg.rewrite(m):m.scheme===P.file&&(o.$m||o.$q===`${P.vscodeFileResource}://${g.a}`)?m.with({scheme:P.vscodeFileResource,authority:m.authority||g.a,query:null,fragment:null}):m}asFileUri(m){const p=this.b(m,V);return this.uriToFileUri(p)}uriToFileUri(m){return m.scheme===P.vscodeFileResource?m.with({scheme:P.file,authority:m.authority!==g.a?m.authority:null,query:null,fragment:null}):m}b(m,p){return D.URI.isUri(m)?m:D.URI.parse(p.toUrl(m))}}e.$Zg=new g;var b;(function(l){const m=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);l.CoopAndCoep=Object.freeze(m.get("3"));const p="vscode-coi";function $(v){let k;typeof v=="string"?k=new URL(v).searchParams:v instanceof URL?k=v.searchParams:D.URI.isUri(v)&&(k=new URL(v.toString(!0)).searchParams);const t=k?.get(p);if(t)return m.get(t)}l.getHeadersFromQuery=$;function w(v,k,t){if(!globalThis.crossOriginIsolated)return;const r=k&&t?"3":t?"2":"1";v instanceof URLSearchParams?v.set(p,r):v[p]=r}l.addSearchParam=w})(b||(e.COI=b={}))}),define(oe[19],ae([0,1,39,31,13,9,4,26,7]),function(V,e,i,o,S,D,O,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataUri=e.$oh=e.$nh=e.$mh=e.$lh=e.$kh=e.$jh=e.$ih=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=void 0,e.$7g=a,e.$ph=f,e.$qh=b,o=Re(o),D=Re(D);function a(l){return(0,y.$yc)(l,!0)}class h{constructor(m){this.a=m}compare(m,p,$=!1){return m===p?0:(0,P.$zf)(this.getComparisonKey(m,$),this.getComparisonKey(p,$))}isEqual(m,p,$=!1){return m===p?!0:!m||!p?!1:this.getComparisonKey(m,$)===this.getComparisonKey(p,$)}getComparisonKey(m,p=!1){return m.with({path:this.a(m)?m.path.toLowerCase():void 0,fragment:p?null:void 0}).toString()}ignorePathCasing(m){return this.a(m)}isEqualOrParent(m,p,$=!1){if(m.scheme===p.scheme){if(m.scheme===S.Schemas.file)return o.$Eg(a(m),a(p),this.a(m))&&m.query===p.query&&($||m.fragment===p.fragment);if((0,e.$lh)(m.authority,p.authority))return o.$Eg(m.path,p.path,this.a(m),"/")&&m.query===p.query&&($||m.fragment===p.fragment)}return!1}joinPath(m,...p){return y.URI.joinPath(m,...p)}basenameOrAuthority(m){return(0,e.$dh)(m)||m.authority}basename(m){return D.$ic.basename(m.path)}extname(m){return D.$ic.extname(m.path)}dirname(m){if(m.path.length===0)return m;let p;return m.scheme===S.Schemas.file?p=y.URI.file(D.$oc(a(m))).path:(p=D.$ic.dirname(m.path),m.authority&&p.length&&p.charCodeAt(0)!==i.CharCode.Slash&&(console.error(`dirname("${m.toString})) resulted in a relative path`),p="/")),m.with({path:p})}normalizePath(m){if(!m.path.length)return m;let p;return m.scheme===S.Schemas.file?p=y.URI.file(D.$jc(a(m))).path:p=D.$ic.normalize(m.path),m.with({path:p})}relativePath(m,p){if(m.scheme!==p.scheme||!(0,e.$lh)(m.authority,p.authority))return;if(m.scheme===S.Schemas.file){const v=D.$nc(a(m),a(p));return O.$i?o.$yg(v):v}let $=m.path||"/";const w=p.path||"/";if(this.a(m)){let v=0;for(const k=Math.min($.length,w.length);v<k&&!($.charCodeAt(v)!==w.charCodeAt(v)&&$.charAt(v).toLowerCase()!==w.charAt(v).toLowerCase());v++);$=w.substr(0,v)+$.substr(v)}return D.$ic.relative($,w)}resolvePath(m,p){if(m.scheme===S.Schemas.file){const $=y.URI.file(D.$mc(a(m),p));return m.with({authority:$.authority,path:$.path})}return p=o.$zg(p),m.with({path:D.$ic.resolve(m.path,p)})}isAbsolutePath(m){return!!m.path&&m.path[0]==="/"}isEqualAuthority(m,p){return m===p||m!==void 0&&p!==void 0&&(0,P.$Gf)(m,p)}hasTrailingPathSeparator(m,p=D.sep){if(m.scheme===S.Schemas.file){const $=a(m);return $.length>o.$Ag($).length&&$[$.length-1]===p}else{const $=m.path;return $.length>1&&$.charCodeAt($.length-1)===i.CharCode.Slash&&!/^[a-zA-Z]:(\/$|\\$)/.test(m.fsPath)}}removeTrailingPathSeparator(m,p=D.sep){return(0,e.$mh)(m,p)?m.with({path:m.path.substr(0,m.path.length-1)}):m}addTrailingPathSeparator(m,p=D.sep){let $=!1;if(m.scheme===S.Schemas.file){const w=a(m);$=w!==void 0&&w.length===o.$Ag(w).length&&w[w.length-1]===p}else{p="/";const w=m.path;$=w.length===1&&w.charCodeAt(w.length-1)===i.CharCode.Slash}return!$&&!(0,e.$mh)(m,p)?m.with({path:m.path+"/"}):m}}e.$8g=h,e.$9g=new h(()=>!1),e.$0g=new h(l=>l.scheme===S.Schemas.file?!O.$k:!0),e.$$g=new h(l=>!0),e.$_g=e.$9g.isEqual.bind(e.$9g),e.$ah=e.$9g.isEqualOrParent.bind(e.$9g),e.$bh=e.$9g.getComparisonKey.bind(e.$9g),e.$ch=e.$9g.basenameOrAuthority.bind(e.$9g),e.$dh=e.$9g.basename.bind(e.$9g),e.$eh=e.$9g.extname.bind(e.$9g),e.$fh=e.$9g.dirname.bind(e.$9g),e.$gh=e.$9g.joinPath.bind(e.$9g),e.$hh=e.$9g.normalizePath.bind(e.$9g),e.$ih=e.$9g.relativePath.bind(e.$9g),e.$jh=e.$9g.resolvePath.bind(e.$9g),e.$kh=e.$9g.isAbsolutePath.bind(e.$9g),e.$lh=e.$9g.isEqualAuthority.bind(e.$9g),e.$mh=e.$9g.hasTrailingPathSeparator.bind(e.$9g),e.$nh=e.$9g.removeTrailingPathSeparator.bind(e.$9g),e.$oh=e.$9g.addTrailingPathSeparator.bind(e.$9g);function f(l,m){const p=[];for(let $=0;$<l.length;$++){const w=m(l[$]);l.some((v,k)=>k===$?!1:(0,e.$ah)(w,m(v)))||p.push(l[$])}return p}var g;(function(l){l.META_DATA_LABEL="label",l.META_DATA_DESCRIPTION="description",l.META_DATA_SIZE="size",l.META_DATA_MIME="mime";function m(p){const $=new Map;p.path.substring(p.path.indexOf(";")+1,p.path.lastIndexOf(";")).split(";").forEach(k=>{const[t,r]=k.split(":");t&&r&&$.set(t,r)});const v=p.path.substring(0,p.path.indexOf(";"));return v&&$.set(l.META_DATA_MIME,v),$}l.parseMetaData=m})(g||(e.DataUri=g={}));function b(l,m,p){if(m){let $=l.path;return $&&$[0]!==D.$ic.sep&&($=D.$ic.sep+$),l.with({scheme:p,authority:m,path:$})}return l.with({scheme:p})}}),define(oe[8],ae([0,1,23,16,3,2,19,4,146,65]),function(V,e,i,o,S,D,O,P,y,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9h=e.$7h=e.$6h=e.$5h=e.$4h=e.Promises=e.$3h=e.$2h=e.$1h=e.$Yh=e.$Xh=e.$Wh=e.$Vh=e.$Uh=e.$Th=e.$Sh=e.$Rh=e.$Qh=e.$Ph=e.$Oh=e.$Nh=e.$Mh=e.$Lh=e.$Fh=e.$Eh=e.$Dh=e.$Ch=e.$Bh=e.$Ah=e.$zh=void 0,e.$rh=h,e.$sh=f,e.$th=g,e.$uh=b,e.$vh=l,e.$wh=m,e.$xh=p,e.$yh=$,e.$Gh=d,e.$Hh=I,e.$Ih=E,e.$Jh=A,e.$Kh=T,e.$Zh=j,e.$8h=q;function h(X){return!!X&&typeof X.then=="function"}function f(X){const Z=new i.$xe,ie=X(Z.token),de=new Promise((me,pe)=>{const Ie=Z.token.onCancellationRequested(()=>{Ie.dispose(),pe(new o.$7)});Promise.resolve(ie).then(ke=>{Ie.dispose(),Z.dispose(),me(ke)},ke=>{Ie.dispose(),Z.dispose(),pe(ke)})});return new class{cancel(){Z.cancel(),Z.dispose()}then(me,pe){return de.then(me,pe)}catch(me){return this.then(void 0,me)}finally(me){return de.finally(me)}}}function g(X,Z,ie){return new Promise((de,me)=>{const pe=Z.onCancellationRequested(()=>{pe.dispose(),de(ie)});X.then(de,me).finally(()=>pe.dispose())})}function b(X,Z){return new Promise((ie,de)=>{const me=Z.onCancellationRequested(()=>{me.dispose(),de(new o.$7)});X.then(ie,de).finally(()=>me.dispose())})}async function l(X){let Z=-1;const ie=X.map((de,me)=>de.then(pe=>(Z=me,pe)));try{return await Promise.race(ie)}finally{X.forEach((de,me)=>{me!==Z&&de.cancel()})}}function m(X,Z,ie){let de;const me=setTimeout(()=>{de?.(void 0),ie?.()},Z);return Promise.race([X.finally(()=>clearTimeout(me)),new Promise(pe=>de=pe)])}function p(X){return new Promise((Z,ie)=>{const de=X();h(de)?de.then(Z,ie):Z(de)})}function $(){let X,Z;return{promise:new Promise((de,me)=>{X=de,Z=me}),resolve:X,reject:Z}}class w{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(Z){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=Z,!this.b){const ie=()=>{if(this.b=null,this.f)return;const de=this.queue(this.d);return this.d=null,de};this.b=new Promise(de=>{this.a.then(ie,ie).then(de)})}return new Promise((ie,de)=>{this.b.then(ie,de)})}return this.a=Z(),new Promise((ie,de)=>{this.a.then(me=>{this.a=null,ie(me)},me=>{this.a=null,de(me)})})}dispose(){this.f=!0}}e.$zh=w;class v{constructor(){this.a=Promise.resolve(null)}queue(Z){return this.a=this.a.then(()=>Z(),()=>Z())}}e.$Ah=v;class k{constructor(){this.a=new Map}queue(Z,ie){const me=(this.a.get(Z)??Promise.resolve()).catch(()=>{}).then(ie).finally(()=>{this.a.get(Z)===me&&this.a.delete(Z)});return this.a.set(Z,me),me}}e.$Bh=k;const t=(X,Z)=>{let ie=!0;const de=setTimeout(()=>{ie=!1,Z()},X);return{isTriggered:()=>ie,dispose:()=>{clearTimeout(de),ie=!1}}},r=X=>{let Z=!0;return queueMicrotask(()=>{Z&&(Z=!1,X())}),{isTriggered:()=>Z,dispose:()=>{Z=!1}}};class n{constructor(Z){this.defaultDelay=Z,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(Z,ie=this.defaultDelay){this.g=Z,this.h(),this.b||(this.b=new Promise((me,pe)=>{this.d=me,this.f=pe}).then(()=>{if(this.b=null,this.d=null,this.g){const me=this.g;return this.g=null,me()}}));const de=()=>{this.a=null,this.d?.(null)};return this.a=ie===y.$he?r(de):t(ie,de),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new o.$7),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$Ch=n;class c{constructor(Z){this.a=new n(Z),this.b=new w}trigger(Z,ie){return this.a.trigger(()=>this.b.queue(Z),ie)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$Dh=c;class s{constructor(){this.a=!1,this.b=new Promise((Z,ie)=>{this.d=Z})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$Eh=s;class u extends s{constructor(Z){super(),this.f=setTimeout(()=>this.open(),Z)}open(){clearTimeout(this.f),super.open()}}e.$Fh=u;function d(X,Z){return Z?new Promise((ie,de)=>{const me=setTimeout(()=>{pe.dispose(),ie()},X),pe=Z.onCancellationRequested(()=>{clearTimeout(me),pe.dispose(),de(new o.$7)})}):f(ie=>d(X,ie))}function I(X,Z=0,ie){const de=setTimeout(()=>{X(),ie&&me.dispose()},Z),me=(0,D.$Uc)(()=>{clearTimeout(de),ie?.deleteAndLeak(me)});return ie?.add(me),me}function E(X){const Z=[];let ie=0;const de=X.length;function me(){return ie<de?X[ie++]():null}function pe(Ie){Ie!=null&&Z.push(Ie);const ke=me();return ke?ke.then(pe):Promise.resolve(Z)}return Promise.resolve(null).then(pe)}function A(X,Z=de=>!!de,ie=null){let de=0;const me=X.length,pe=()=>{if(de>=me)return Promise.resolve(ie);const Ie=X[de++];return Promise.resolve(Ie()).then(Pe=>Z(Pe)?Promise.resolve(Pe):pe())};return pe()}function T(X,Z=de=>!!de,ie=null){if(X.length===0)return Promise.resolve(ie);let de=X.length;const me=()=>{de=-1;for(const pe of X)pe.cancel?.()};return new Promise((pe,Ie)=>{for(const ke of X)ke.then(Pe=>{--de>=0&&Z(Pe)?(me(),pe(Pe)):de===0&&pe(ie)}).catch(Pe=>{--de>=0&&(me(),Ie(Pe))})})}class L{constructor(Z){this.a=0,this.b=!1,this.f=Z,this.g=[],this.d=0,this.h=new S.$me}whenIdle(){return this.size>0?S.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(Z){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((ie,de)=>{this.g.push({factory:Z,c:ie,e:de}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const Z=this.g.shift();this.d++;const ie=Z.factory();ie.then(Z.c,Z.e),ie.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$Lh=L;class R extends L{constructor(){super(1)}}e.$Mh=R;class M{constructor(){this.a=new B,this.b=0}queue(Z){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,Z())):this.a.run(this.b++,Z())}}e.$Nh=M;class U{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const Z=new G;return this.b.add(Z),Z.p}g(){for(const[,Z]of this.a)if(Z.size>0)return!1;return!0}queueSize(Z,ie=O.$9g){const de=ie.getComparisonKey(Z);return this.a.get(de)?.size??0}queueFor(Z,ie,de=O.$9g){const me=de.getComparisonKey(Z);let pe=this.a.get(me);if(!pe){pe=new R;const Ie=this.f++,ke=S.Event.once(pe.onDrained)(()=>{pe?.dispose(),this.a.delete(me),this.h(),this.d?.deleteAndDispose(Ie),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new D.$6c),this.d.set(Ie,ke),this.a.set(me,pe)}return pe.queue(ie)}h(){this.g()&&this.j()}j(){for(const Z of this.b)Z.complete();this.b.clear()}dispose(){for(const[,Z]of this.a)Z.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$Oh=U;class N{constructor(Z,ie){this.b=!1,this.a=-1,typeof Z=="function"&&typeof ie=="number"&&this.setIfNotSet(Z,ie)}dispose(){this.cancel(),this.b=!0}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(Z,ie){if(this.b)throw new o.$eb("Calling 'cancelAndSet' on a disposed TimeoutTimer");this.cancel(),this.a=setTimeout(()=>{this.a=-1,Z()},ie)}setIfNotSet(Z,ie){if(this.b)throw new o.$eb("Calling 'setIfNotSet' on a disposed TimeoutTimer");this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,Z()},ie))}}e.$Ph=N;class z{constructor(){this.d=void 0,this.f=!1}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(Z,ie,de=globalThis){if(this.f)throw new o.$eb("Calling 'cancelAndSet' on a disposed IntervalTimer");this.cancel();const me=de.setInterval(()=>{Z()},ie);this.d=(0,D.$Uc)(()=>{de.clearInterval(me),this.d=void 0})}dispose(){this.cancel(),this.f=!0}}e.$Qh=z;class ne{constructor(Z,ie){this.b=-1,this.a=Z,this.d=ie,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(Z=this.d){this.cancel(),this.b=setTimeout(this.f,Z)}get delay(){return this.d}set delay(Z){this.d=Z}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$Rh=ne;class Q{constructor(Z,ie){ie%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${ie}ms is not a multiple of 1000ms.`),this.a=Z,this.b=ie,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(Z=this.b){Z%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${Z}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(Z/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$Sh=Q;class le extends ne{constructor(Z,ie){super(Z,ie),this.j=[]}work(Z){this.j.push(Z),this.isScheduled()||this.schedule()}h(){const Z=this.j;this.j=[],this.a?.(Z)}dispose(){this.j=[],super.dispose()}}e.$Th=le;class K extends D.$Wc{constructor(Z,ie){super(),this.g=Z,this.h=ie,this.a=[],this.b=this.B(new D.$Xc),this.f=!1}get pending(){return this.a.length}work(Z){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+Z.length>this.g.maxBufferedWork)return!1}else if(this.pending+Z.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const ie of Z)this.a.push(ie);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new ne(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$Uh=K,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$Wh=(X,Z)=>{(0,P.$B)(()=>{if(ie)return;const de=Date.now()+15;Z(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,de-Date.now())}}))});let ie=!1;return{dispose(){ie||(ie=!0)}}}:e.$Wh=(X,Z,ie)=>{const de=X.requestIdleCallback(Z,typeof ie=="number"?{timeout:ie}:void 0);let me=!1;return{dispose(){me||(me=!0,X.cancelIdleCallback(de))}}},e.$Vh=X=>(0,e.$Wh)(globalThis,X)}();class ee{constructor(Z,ie){this.g=!1,this.d=()=>{try{this.j=ie()}catch(de){this.l=de}finally{this.g=!0}},this.f=(0,e.$Wh)(Z,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$Xh=ee;class H extends ee{constructor(Z){super(globalThis,Z)}}e.$Yh=H;async function j(X,Z,ie){let de;for(let me=0;me<ie;me++)try{return await X()}catch(pe){de=pe,await d(Z)}throw de}class B{isRunning(Z){return typeof Z=="number"?this.a?.taskId===Z:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(Z,ie,de){return this.a={taskId:Z,cancel:()=>de?.(),promise:ie},ie.then(()=>this.d(Z),()=>this.d(Z)),ie}d(Z){this.a&&Z===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const Z=this.b;this.b=void 0,Z.run().then(Z.promiseResolve,Z.promiseReject)}}queue(Z){if(this.b)this.b.run=Z;else{const{promise:ie,resolve:de,reject:me}=$();this.b={run:Z,promise:ie,promiseResolve:de,promiseReject:me}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$1h=B;class x{constructor(Z,ie=()=>Date.now()){this.d=Z,this.f=ie,this.a=0,this.b=0}increment(){const Z=this.f();return Z-this.a>this.d&&(this.a=Z,this.b=0),this.b++,this.b}}e.$2h=x;var ce;(function(X){X[X.Resolved=0]="Resolved",X[X.Rejected=1]="Rejected"})(ce||(ce={}));class G{get isRejected(){return this.d?.outcome===ce.Rejected}get isResolved(){return this.d?.outcome===ce.Resolved}get isSettled(){return!!this.d}get value(){return this.d?.outcome===ce.Resolved?this.d?.value:void 0}constructor(){this.p=new Promise((Z,ie)=>{this.a=Z,this.b=ie})}complete(Z){return new Promise(ie=>{this.a(Z),this.d={outcome:ce.Resolved,value:Z},ie()})}error(Z){return new Promise(ie=>{this.b(Z),this.d={outcome:ce.Rejected,value:Z},ie()})}cancel(){return this.error(new o.$7)}}e.$3h=G;var he;(function(X){async function Z(de){let me;const pe=await Promise.all(de.map(Ie=>Ie.then(ke=>ke,ke=>{me||(me=ke)})));if(typeof me<"u")throw me;return pe}X.settled=Z;function ie(de){return new Promise(async(me,pe)=>{try{await de(me,pe)}catch(Ie){pe(Ie)}})}X.withAsyncBody=ie})(he||(e.Promises=he={}));class se{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(Z){this.a=void 0,this.b=void 0,this.d=!1,this.promise=Z.then(ie=>(this.a=ie,this.d=!0,ie),ie=>{throw this.b=ie,this.d=!0,ie})}requireValue(){if(!this.d)throw new o.$eb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$4h=se;class _{constructor(Z){this.b=Z,this.a=new a.$X(()=>new se(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}e.$5h=_;var F;(function(X){X[X.Initial=0]="Initial",X[X.DoneOK=1]="DoneOK",X[X.DoneError=2]="DoneError"})(F||(F={}));class C{static fromArray(Z){return new C(ie=>{ie.emitMany(Z)})}static fromPromise(Z){return new C(async ie=>{ie.emitMany(await Z)})}static fromPromises(Z){return new C(async ie=>{await Promise.all(Z.map(async de=>ie.emitOne(await de)))})}static merge(Z){return new C(async ie=>{await Promise.all(Z.map(async de=>{for await(const me of de)ie.emitOne(me)}))})}static{this.EMPTY=C.fromArray([])}constructor(Z,ie){this.a=F.Initial,this.b=[],this.d=null,this.f=ie,this.g=new S.$me,queueMicrotask(async()=>{const de={emitOne:me=>this.h(me),emitMany:me=>this.j(me),reject:me=>this.l(me)};try{await Promise.resolve(Z(de)),this.k()}catch(me){this.l(me)}finally{de.emitOne=void 0,de.emitMany=void 0,de.reject=void 0}})}[Symbol.asyncIterator](){let Z=0;return{next:async()=>{do{if(this.a===F.DoneError)throw this.d;if(Z<this.b.length)return{done:!1,value:this.b[Z++]};if(this.a===F.DoneOK)return{done:!0,value:void 0};await S.Event.toPromise(this.g.event)}while(!0)},return:async()=>(this.f?.(),{done:!0,value:void 0})}}static map(Z,ie){return new C(async de=>{for await(const me of Z)de.emitOne(ie(me))})}map(Z){return C.map(this,Z)}static filter(Z,ie){return new C(async de=>{for await(const me of Z)ie(me)&&de.emitOne(me)})}filter(Z){return C.filter(this,Z)}static coalesce(Z){return C.filter(Z,ie=>!!ie)}coalesce(){return C.coalesce(this)}static async toPromise(Z){const ie=[];for await(const de of Z)ie.push(de);return ie}toPromise(){return C.toPromise(this)}h(Z){this.a===F.Initial&&(this.b.push(Z),this.g.fire())}j(Z){this.a===F.Initial&&(this.b=this.b.concat(Z),this.g.fire())}k(){this.a===F.Initial&&(this.a=F.DoneOK,this.g.fire())}l(Z){this.a===F.Initial&&(this.a=F.DoneError,this.d=Z,this.g.fire())}}e.$6h=C;class W extends C{constructor(Z,ie){super(ie),this.m=Z}cancel(){this.m.cancel()}}e.$7h=W;function q(X){const Z=new i.$xe,ie=X(Z.token);return new W(Z,async de=>{const me=Z.token.onCancellationRequested(()=>{me.dispose(),Z.dispose(),de.reject(new o.$7)});try{for await(const pe of ie){if(Z.token.isCancellationRequested)return;de.emitOne(pe)}me.dispose(),Z.dispose()}catch(pe){me.dispose(),Z.dispose(),de.reject(pe)}})}class J{constructor(Z){this.a=new G,this.b=new C(me=>{if(ie){me.reject(ie);return}return de&&me.emitMany(de),this.d=pe=>me.reject(pe),this.f=pe=>me.emitOne(pe),this.a.p},Z);let ie,de;this.f=me=>{de||(de=[]),de.push(me)},this.d=me=>{ie||(ie=me)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(Z){this.d(Z),this.a.complete()}emitOne(Z){this.f(Z)}}e.$9h=J}),define(oe[113],ae([0,1,22,8,39,31,32,9,4,26]),function(V,e,i,o,S,D,O,P,y,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wk=e.$vk=void 0,e.$uk=h,e.$xk=m,e.$yk=M,e.$zk=U,e.$Ak=N,e.$Bk=z,e.$Ck=ne,e.$Dk=ee;function h(){return Object.create(null)}e.$vk="**",e.$wk="/";const f="[/\\\\]",g="[^/\\\\]",b=/\//g;function l(H,j){switch(H){case 0:return"";case 1:return`${g}*?`;default:return`(?:${f}|${g}+${f}${j?`|${f}${g}+`:""})*?`}}function m(H,j){if(!H)return[];const B=[];let x=!1,ce=!1,G="";for(const he of H){switch(he){case j:if(!x&&!ce){B.push(G),G="";continue}break;case"{":x=!0;break;case"}":x=!1;break;case"[":ce=!0;break;case"]":ce=!1;break}G+=he}return G&&B.push(G),B}function p(H){if(!H)return"";let j="";const B=m(H,e.$wk);if(B.every(x=>x===e.$vk))j=".*";else{let x=!1;B.forEach((ce,G)=>{if(ce===e.$vk){if(x)return;j+=l(2,G===B.length-1)}else{let he=!1,se="",_=!1,F="";for(const C of ce){if(C!=="}"&&he){se+=C;continue}if(_&&(C!=="]"||!F)){let W;C==="-"?W=C:(C==="^"||C==="!")&&!F?W="^":C===e.$wk?W="":W=(0,a.$if)(C),F+=W;continue}switch(C){case"{":he=!0;continue;case"[":_=!0;continue;case"}":{const q=`(?:${m(se,",").map(J=>p(J)).join("|")})`;j+=q,he=!1,se="";break}case"]":{j+="["+F+"]",_=!1,F="";break}case"?":j+=g;continue;case"*":j+=l(1);continue;default:j+=(0,a.$if)(C)}}G<B.length-1&&(B[G+1]!==e.$vk||G+2<B.length)&&(j+=f)}x=ce===e.$vk})}return j}const $=/^\*\*\/\*\.[\w\.-]+$/,w=/^\*\*\/([\w\.-]+)\/?$/,v=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,k=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,t=/^\*\*((\/[\w\.-]+)+)\/?$/,r=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,n=new O.$Fc(1e4),c=function(){return!1},s=function(){return null};function u(H,j){if(!H)return s;let B;typeof H!="string"?B=H.pattern:B=H,B=B.trim();const x=`${B}_${!!j.trimForExclusions}`;let ce=n.get(x);if(ce)return d(ce,H);let G;return $.test(B)?ce=E(B.substr(4),B):(G=w.exec(I(B,j)))?ce=A(G[1],B):(j.trimForExclusions?k:v).test(B)?ce=T(B,j):(G=t.exec(I(B,j)))?ce=L(G[1].substr(1),B,!0):(G=r.exec(I(B,j)))?ce=L(G[1],B,!1):ce=R(B),n.set(x,ce),d(ce,H)}function d(H,j){if(typeof j=="string")return H;const B=function(x,ce){return(0,D.$Eg)(x,j.base,!y.$k)?H((0,a.$nf)(x.substr(j.base.length),P.sep),ce):null};return B.allBasenames=H.allBasenames,B.allPaths=H.allPaths,B.basenames=H.basenames,B.patterns=H.patterns,B}function I(H,j){return j.trimForExclusions&&H.endsWith("/**")?H.substr(0,H.length-2):H}function E(H,j){return function(B,x){return typeof B=="string"&&B.endsWith(H)?j:null}}function A(H,j){const B=`/${H}`,x=`\\${H}`,ce=function(he,se){return typeof he!="string"?null:se?se===H?j:null:he===H||he.endsWith(B)||he.endsWith(x)?j:null},G=[H];return ce.basenames=G,ce.patterns=[j],ce.allBasenames=G,ce}function T(H,j){const B=K(H.slice(1,-1).split(",").map(se=>u(se,j)).filter(se=>se!==s),H),x=B.length;if(!x)return s;if(x===1)return B[0];const ce=function(se,_){for(let F=0,C=B.length;F<C;F++)if(B[F](se,_))return H;return null},G=B.find(se=>!!se.allBasenames);G&&(ce.allBasenames=G.allBasenames);const he=B.reduce((se,_)=>_.allPaths?se.concat(_.allPaths):se,[]);return he.length&&(ce.allPaths=he),ce}function L(H,j,B){const x=P.sep===P.$ic.sep,ce=x?H:H.replace(b,P.sep),G=P.sep+ce,he=P.$ic.sep+H;let se;return B?se=function(_,F){return typeof _=="string"&&(_===ce||_.endsWith(G)||!x&&(_===H||_.endsWith(he)))?j:null}:se=function(_,F){return typeof _=="string"&&(_===ce||!x&&_===H)?j:null},se.allPaths=[(B?"*/":"./")+H],se}function R(H){try{const j=new RegExp(`^${p(H)}$`);return function(B){return j.lastIndex=0,typeof B=="string"&&j.test(B)?H:null}}catch{return s}}function M(H,j,B){return!H||typeof j!="string"?!1:U(H)(j,void 0,B)}function U(H,j={}){if(!H)return c;if(typeof H=="string"||N(H)){const B=u(H,j);if(B===s)return c;const x=function(ce,G){return!!B(ce,G)};return B.allBasenames&&(x.allBasenames=B.allBasenames),B.allPaths&&(x.allPaths=B.allPaths),x}return Q(H,j)}function N(H){const j=H;return j?typeof j.base=="string"&&typeof j.pattern=="string":!1}function z(H){return H.allBasenames||[]}function ne(H){return H.allPaths||[]}function Q(H,j){const B=K(Object.getOwnPropertyNames(H).map(se=>le(se,H[se],j)).filter(se=>se!==s)),x=B.length;if(!x)return s;if(!B.some(se=>!!se.requiresSiblings)){if(x===1)return B[0];const se=function(C,W){let q;for(let J=0,X=B.length;J<X;J++){const Z=B[J](C,W);if(typeof Z=="string")return Z;(0,o.$rh)(Z)&&(q||(q=[]),q.push(Z))}return q?(async()=>{for(const J of q){const X=await J;if(typeof X=="string")return X}return null})():null},_=B.find(C=>!!C.allBasenames);_&&(se.allBasenames=_.allBasenames);const F=B.reduce((C,W)=>W.allPaths?C.concat(W.allPaths):C,[]);return F.length&&(se.allPaths=F),se}const ce=function(se,_,F){let C,W;for(let q=0,J=B.length;q<J;q++){const X=B[q];X.requiresSiblings&&F&&(_||(_=(0,P.$pc)(se)),C||(C=_.substr(0,_.length-(0,P.$qc)(se).length)));const Z=X(se,_,C,F);if(typeof Z=="string")return Z;(0,o.$rh)(Z)&&(W||(W=[]),W.push(Z))}return W?(async()=>{for(const q of W){const J=await q;if(typeof J=="string")return J}return null})():null},G=B.find(se=>!!se.allBasenames);G&&(ce.allBasenames=G.allBasenames);const he=B.reduce((se,_)=>_.allPaths?se.concat(_.allPaths):se,[]);return he.length&&(ce.allPaths=he),ce}function le(H,j,B){if(j===!1)return s;const x=u(H,B);if(x===s)return s;if(typeof j=="boolean")return x;if(j){const ce=j.when;if(typeof ce=="string"){const G=(he,se,_,F)=>{if(!F||!x(he,se))return null;const C=ce.replace("$(basename)",()=>_),W=F(C);return(0,o.$rh)(W)?W.then(q=>q?H:null):W?H:null};return G.requiresSiblings=!0,G}}return x}function K(H,j){const B=H.filter(se=>!!se.basenames);if(B.length<2)return H;const x=B.reduce((se,_)=>{const F=_.basenames;return F?se.concat(F):se},[]);let ce;if(j){ce=[];for(let se=0,_=x.length;se<_;se++)ce.push(j)}else ce=B.reduce((se,_)=>{const F=_.patterns;return F?se.concat(F):se},[]);const G=function(se,_){if(typeof se!="string")return null;if(!_){let C;for(C=se.length;C>0;C--){const W=se.charCodeAt(C-1);if(W===S.CharCode.Slash||W===S.CharCode.Backslash)break}_=se.substr(C)}const F=x.indexOf(_);return F!==-1?ce[F]:null};G.basenames=x,G.patterns=ce,G.allBasenames=x;const he=H.filter(se=>!se.basenames);return he.push(G),he}function ee(H,j){return(0,i.$wb)(H,j,(B,x)=>typeof B=="string"&&typeof x=="string"?B===x:typeof B!="string"&&typeof x!="string"?B.base===x.base&&B.pattern===x.pattern:!1)}}),define(oe[48],ae([0,1,22,31,9,4,19,26]),function(V,e,i,o,S,D,O,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rw=y,e.$Sw=h,e.$Tw=g,e.$Uw=b,e.$Vw=$,e.$Ww=v,e.$Xw=k,e.$Yw=t,e.$Zw=r,e.$1w=n;function y(s,u){const{os:d,tildify:I,relative:E}=u;if(E){const L=a(s,E,d);if(typeof L=="string")return L}let A=s.fsPath;if(d===D.OperatingSystem.Windows&&!D.$i?A=A.replace(/\//g,"\\"):d!==D.OperatingSystem.Windows&&D.$i&&(A=A.replace(/\\/g,"/")),d!==D.OperatingSystem.Windows&&I?.userHome){const L=I.userHome.fsPath;let R;s.scheme!==I.userHome.scheme&&s.path[0]===S.$ic.sep&&s.path[1]!==S.$ic.sep?R=I.userHome.with({path:s.path}).fsPath:R=A,A=g(R,L,d)}return(d===D.OperatingSystem.Windows?S.$hc:S.$ic).normalize(h(A,d===D.OperatingSystem.Windows))}function a(s,u,d){const I=d===D.OperatingSystem.Windows?S.$hc:S.$ic,E=d===D.OperatingSystem.Linux?O.$9g:O.$$g,A=u.getWorkspace(),T=(0,i.$Qb)(A.folders);if(!T)return;s.scheme!==T.uri.scheme&&s.path[0]===S.$ic.sep&&s.path[1]!==S.$ic.sep&&(s=T.uri.with({path:s.path}));const L=u.getWorkspaceFolder(s);if(!L)return;let R;if(E.isEqual(L.uri,s)?R="":R=E.relativePath(L.uri,s)??"",R&&(R=I.normalize(R)),A.folders.length>1&&!u.noPrefix){const M=L.name?L.name:E.basenameOrAuthority(L.uri);R=R?`${M} \u2022 ${R}`:M}return R}function h(s,u=D.$i){return(0,o.$Jg)(s,u)?s.charAt(0).toUpperCase()+s.slice(1):s}let f=Object.create(null);function g(s,u,d=D.OS){if(d===D.OperatingSystem.Windows||!s||!u)return s;let I=f.original===u?f.normalized:void 0;I||(I=u,D.$i&&(I=(0,o.$yg)(I)),I=`${(0,P.$of)(I,S.$ic.sep)}${S.$ic.sep}`,f={original:u,normalized:I});let E=s;return D.$i&&(E=(0,o.$yg)(E)),(d===D.OperatingSystem.Linux?E.startsWith(I):(0,P.$Hf)(E,I))?`~/${E.substr(I.length)}`:s}function b(s,u){return s.replace(/^~($|\/|\\)/,`${u}$1`)}const l="\u2026",m="\\\\",p="~";function $(s,u=S.sep){const d=new Array(s.length);let I=!1;for(let E=0;E<s.length;E++){const A=s[E];if(A===""){d[E]=`.${u}`;continue}if(!A){d[E]=A;continue}I=!0;let T="",L=A;L.indexOf(m)===0?(T=L.substr(0,L.indexOf(m)+m.length),L=L.substr(L.indexOf(m)+m.length)):L.indexOf(u)===0?(T=L.substr(0,L.indexOf(u)+u.length),L=L.substr(L.indexOf(u)+u.length)):L.indexOf(p)===0&&(T=L.substr(0,L.indexOf(p)+p.length),L=L.substr(L.indexOf(p)+p.length));const R=L.split(u);for(let M=1;I&&M<=R.length;M++)for(let U=R.length-M;I&&U>=0;U--){I=!1;let N=R.slice(U,U+M).join(u);for(let z=0;!I&&z<s.length;z++)if(z!==E&&s[z]&&s[z].indexOf(N)>-1){const ne=U+M===R.length,Q=U>0&&s[z].indexOf(u)>-1?u+N:N,le=s[z].endsWith(Q);I=!ne||le}if(!I){let z="";(R[0].endsWith(":")||T!=="")&&(U===1&&(U=0,M++,N=R[0]+u+N),U>0&&(z=R[0]+u),z=T+z),U>0&&(z=z+l+u),z=z+N,U+M<R.length&&(z=z+u+l),d[E]=z}}I&&(d[E]=A)}return d}var w;(function(s){s[s.TEXT=0]="TEXT",s[s.VARIABLE=1]="VARIABLE",s[s.SEPARATOR=2]="SEPARATOR"})(w||(w={}));function v(s,u=Object.create(null)){const d=[];let I=!1,E="";for(const A of s)if(A==="$"||I&&A==="{")E&&d.push({value:E,type:w.TEXT}),E="",I=!0;else if(A==="}"&&I){const T=u[E];if(typeof T=="string")T.length&&d.push({value:T,type:w.VARIABLE});else if(T){const L=d[d.length-1];(!L||L.type!==w.SEPARATOR)&&d.push({value:T.label,type:w.SEPARATOR})}E="",I=!1}else E+=A;return E&&!I&&d.push({value:E,type:w.TEXT}),d.filter((A,T)=>{if(A.type===w.SEPARATOR){const L=d[T-1],R=d[T+1];return[L,R].every(M=>M&&(M.type===w.VARIABLE||M.type===w.TEXT)&&M.value.length>0)}return!0}).map(A=>A.value).join("")}function k(s,u){return D.$j||u?s.replace(/\(&&\w\)|&&/g,"").replace(/&/g,D.$j?"&":"&&"):s.replace(/&&|&/g,d=>d==="&"?"&&":"&")}function t(s,u){return D.$j||u?s.replace(/\(&&\w\)|&&/g,""):D.$i?s.replace(/&&|&/g,d=>d==="&"?"&&":"&"):s.replace(/&&/g,"_")}function r(s){return s.replace(/&/g,"&&")}function n(s){if(s.endsWith("]")){const u=s.lastIndexOf(" [",s.length-2);if(u!==-1){const d=c(s.substring(0,u)),I=s.substring(u);return{name:d.name+I,parentPath:d.parentPath}}}return c(s)}function c(s){const u=s.indexOf("/")!==-1?S.$ic:S.$hc,d=u.basename(s),I=u.dirname(s);return d.length?{name:d,parentPath:I}:{name:I,parentPath:""}}}),define(oe[160],ae([0,1,17,90,7]),function(V,e,i,o,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kn=e.$Jn=void 0,e.$Ln=y,e.$Mn=h,e.$Nn=f;function D(g){return g.toJSON()}class O{constructor(b){this.a=b}transformIncoming(b){const l=this.a.transformIncoming(b);return l===b?b:D(S.URI.from(l))}transformOutgoing(b){const l=this.a.transformOutgoing(b);return l===b?b:D(S.URI.from(l))}transformOutgoingURI(b){const l=this.a.transformOutgoing(b);return l===b?b:S.URI.from(l)}transformOutgoingScheme(b){return this.a.transformOutgoingScheme(b)}}e.$Jn=O,e.$Kn=new class{transformIncoming(g){return g}transformOutgoing(g){return g}transformOutgoingURI(g){return g}transformOutgoingScheme(g){return g}};function P(g,b,l){if(!g||l>200)return null;if(typeof g=="object"){if(g instanceof S.URI)return b.transformOutgoing(g);for(const m in g)if(Object.hasOwnProperty.call(g,m)){const p=P(g[m],b,l+1);p!==null&&(g[m]=p)}}return null}function y(g,b){const l=P(g,b,0);return l===null?g:l}function a(g,b,l,m){if(!g||m>200)return null;if(typeof g=="object"){if(g.$mid===o.MarshalledId.Uri)return l?S.URI.revive(b.transformIncoming(g)):b.transformIncoming(g);if(g instanceof i.$Oe)return null;for(const p in g)if(Object.hasOwnProperty.call(g,p)){const $=a(g[p],b,l,m+1);$!==null&&(g[p]=$)}}return null}function h(g,b){const l=a(g,b,!1,0);return l===null?g:l}function f(g,b){const l=a(g,b,!0,0);return l===null?g:l}}),define(oe[93],ae([0,1,27,61,33,150,4]),function(V,e,i,o,S,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pn=void 0,e.$Qn=y,e.$Rn=f,e.$Sn=g,S=Re(S),e.$Pn=new class{c(b){return this.a||(this.a=o.$Li.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(b)}value(){if(this.b===void 0){let b=0,l=0;const m=(0,i.networkInterfaces)();for(const p in m){const $=m[p];if($)for(const{mac:w,internal:v}of $)v||(l+=1,this.c(w.toUpperCase())&&(b+=1))}this.b=l>0?b/l:0}return this.b}};let P;async function y(b){return P||(P=(async()=>await a(b)||S.$2g())()),P}async function a(b){try{const l=await new Promise((p,$)=>{V(["crypto"],p,$)}).then(Re),m=(0,D.$On)();return l.createHash("sha256").update(m,"utf8").digest("hex")}catch(l){b(l);return}}const h="Software\\Microsoft\\SQMClient";async function f(b){if(O.$i){const l=await new Promise((m,p)=>{V(["@vscode/windows-registry"],m,p)}).then(Re);try{return l.GetStringRegKey("HKEY_LOCAL_MACHINE",h,"MachineId")||""}catch(m){return b(m),""}}return""}async function g(b){try{return await(await new Promise((p,$)=>{V(["@vscode/deviceid"],p,$)}).then(Re)).getDeviceId()}catch(l){return b(l),""}}}),define(oe[21],ae([0,1,47,27,161,8,31,77,9,4,19,7]),function(V,e,i,o,S,D,O,P,y,a,h,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.SymlinkSupport=e.RimRafMode=void 0,e.rimrafSync=p,e.readdirSync=v,e.whenDeleted=r,e.configureFlushOnWrite=d,e.writeFileSync=E,i=Re(i);var g;(function(Q){Q[Q.UNLINK=0]="UNLINK",Q[Q.MOVE=1]="MOVE"})(g||(e.RimRafMode=g={}));async function b(Q,le=g.UNLINK,K){if((0,O.$Ig)(Q))throw new Error("rimraf - will refuse to recursively delete root");return le===g.UNLINK?m(Q):l(Q,K)}async function l(Q,le=(0,O.$Ng)((0,o.tmpdir)())){try{try{await i.promises.rename(Q,le)}catch(K){return K.code==="ENOENT"?void 0:m(Q)}m(le).catch(K=>{})}catch(K){if(K.code!=="ENOENT")throw K}}async function m(Q){return i.promises.rm(Q,{recursive:!0,force:!0,maxRetries:3})}function p(Q){if((0,O.$Ig)(Q))throw new Error("rimraf - will refuse to recursively delete root");i.rmSync(Q,{recursive:!0,force:!0,maxRetries:3})}async function $(Q,le){return k(await(le?w(Q):i.promises.readdir(Q)))}async function w(Q){try{return await i.promises.readdir(Q,{withFileTypes:!0})}catch(ee){console.warn("[node.js fs] readdir with filetypes failed with error: ",ee)}const le=[],K=await $(Q);for(const ee of K){let H=!1,j=!1,B=!1;try{const x=await e.Promises.lstat((0,y.$lc)(Q,ee));H=x.isFile(),j=x.isDirectory(),B=x.isSymbolicLink()}catch(x){console.warn("[node.js fs] unexpected error from lstat after readdir: ",x)}le.push({name:ee,isFile:()=>H,isDirectory:()=>j,isSymbolicLink:()=>B})}return le}function v(Q){return k(i.readdirSync(Q))}function k(Q){return Q.map(le=>typeof le=="string"?a.$j?(0,P.$mm)(le):le:(le.name=a.$j?(0,P.$mm)(le.name):le.name,le))}async function t(Q){const le=await $(Q),K=[];for(const ee of le)await n.existsDirectory((0,y.$lc)(Q,ee))&&K.push(ee);return K}function r(Q,le=1e3){return new Promise(K=>{let ee=!1;const H=setInterval(()=>{ee||(ee=!0,i.access(Q,j=>{ee=!1,j&&(clearInterval(H),K(void 0))}))},le)})}var n;(function(Q){async function le(H){let j;try{if(j=await e.Promises.lstat(H),!j.isSymbolicLink())return{stat:j}}catch{}try{return{stat:await e.Promises.stat(H),symbolicLink:j?.isSymbolicLink()?{dangling:!1}:void 0}}catch(B){if(B.code==="ENOENT"&&j)return{stat:j,symbolicLink:{dangling:!0}};if(a.$i&&B.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(H)),symbolicLink:{dangling:!1}}}catch(x){if(x.code==="ENOENT"&&j)return{stat:j,symbolicLink:{dangling:!0}};throw x}throw B}}Q.stat=le;async function K(H){try{const{stat:j,symbolicLink:B}=await Q.stat(H);return j.isFile()&&B?.dangling!==!0}catch{}return!1}Q.existsFile=K;async function ee(H){try{const{stat:j,symbolicLink:B}=await Q.stat(H);return j.isDirectory()&&B?.dangling!==!0}catch{}return!1}Q.existsDirectory=ee})(n||(e.SymlinkSupport=n={}));const c=new D.$Oh;function s(Q,le,K){return c.queueFor(f.URI.file(Q),()=>{const ee=A(K);return new Promise((H,j)=>I(Q,le,ee,B=>B?j(B):H()))},h.$0g)}let u=!0;function d(Q){u=Q}function I(Q,le,K,ee){if(!u)return i.writeFile(Q,le,{mode:K.mode,flag:K.flag},ee);i.open(Q,K.flag,K.mode,(H,j)=>{if(H)return ee(H);i.writeFile(j,le,B=>{if(B)return i.close(j,()=>ee(B));i.fdatasync(j,x=>(x&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",x),d(!1)),i.close(j,ce=>ee(ce))))})})}function E(Q,le,K){const ee=A(K);if(!u)return i.writeFileSync(Q,le,{mode:ee.mode,flag:ee.flag});const H=i.openSync(Q,ee.flag,ee.mode);try{i.writeFileSync(H,le);try{i.fdatasyncSync(H)}catch(j){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",j),d(!1)}}finally{i.closeSync(H)}}function A(Q){return Q?{mode:typeof Q.mode=="number"?Q.mode:438,flag:typeof Q.flag=="string"?Q.flag:"w"}:{mode:438,flag:"w"}}async function T(Q,le,K=6e4){if(Q!==le)try{a.$i&&typeof K=="number"?await L(Q,le,Date.now(),K):await i.promises.rename(Q,le)}catch(ee){if(Q.toLowerCase()!==le.toLowerCase()&&ee.code==="EXDEV"||Q.endsWith("."))await R(Q,le,{preserveSymlinks:!1}),await b(Q,g.MOVE);else throw ee}}async function L(Q,le,K,ee,H=0){try{return await i.promises.rename(Q,le)}catch(j){if(j.code!=="EACCES"&&j.code!=="EPERM"&&j.code!=="EBUSY")throw j;if(Date.now()-K>=ee)throw console.error(`[node.js fs] rename failed after ${H} retries with error: ${j}`),j;if(H===0){let B=!1;try{const{stat:x}=await n.stat(le);x.isFile()||(B=!0)}catch{}if(B)throw j}return await(0,D.$Gh)(Math.min(100,H*10)),L(Q,le,K,ee,H+1)}}async function R(Q,le,K){return U(Q,le,{root:{source:Q,target:le},options:K,handledSourcePaths:new Set})}const M=511;async function U(Q,le,K){if(K.handledSourcePaths.has(Q))return;K.handledSourcePaths.add(Q);const{stat:ee,symbolicLink:H}=await n.stat(Q);if(H){if(K.options.preserveSymlinks)try{return await ne(Q,le,K)}catch{}if(H.dangling)return}return ee.isDirectory()?N(Q,le,ee.mode&M,K):z(Q,le,ee.mode&M)}async function N(Q,le,K,ee){await e.Promises.mkdir(le,{recursive:!0,mode:K});const H=await $(Q);for(const j of H)await U((0,y.$lc)(Q,j),(0,y.$lc)(le,j),ee)}async function z(Q,le,K){await e.Promises.copyFile(Q,le),await e.Promises.chmod(le,K)}async function ne(Q,le,K){let ee=await e.Promises.readlink(Q);(0,O.$Eg)(ee,K.root.source,!a.$k)&&(ee=(0,y.$lc)(K.root.target,ee.substr(K.root.source.length+1))),await e.Promises.symlink(ee,le)}e.Promises=new class{get access(){return i.promises.access}get stat(){return i.promises.stat}get lstat(){return i.promises.lstat}get utimes(){return i.promises.utimes}get read(){return(Q,le,K,ee,H)=>new Promise((j,B)=>{i.read(Q,le,K,ee,H,(x,ce,G)=>x?B(x):j({bytesRead:ce,buffer:G}))})}get readFile(){return i.promises.readFile}get write(){return(Q,le,K,ee,H)=>new Promise((j,B)=>{i.write(Q,le,K,ee,H,(x,ce,G)=>x?B(x):j({bytesWritten:ce,buffer:G}))})}get appendFile(){return i.promises.appendFile}get fdatasync(){return(0,S.promisify)(i.fdatasync)}get truncate(){return i.promises.truncate}get copyFile(){return i.promises.copyFile}get open(){return(0,S.promisify)(i.open)}get close(){return(0,S.promisify)(i.close)}get symlink(){return i.promises.symlink}get readlink(){return i.promises.readlink}get chmod(){return i.promises.chmod}get mkdir(){return i.promises.mkdir}get unlink(){return i.promises.unlink}get rmdir(){return i.promises.rmdir}get realpath(){return(0,S.promisify)(i.realpath)}async exists(Q){try{return await e.Promises.access(Q),!0}catch{return!1}}get readdir(){return $}get readDirsInDir(){return t}get writeFile(){return s}get rm(){return b}get rename(){return T}get copy(){return R}}}),define(oe[114],ae([0,1,47,9,4,26,21]),function(V,e,i,o,S,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$er=P,e.$fr=y,e.$gr=a,e.$hr=h,i=Re(i);function P(g){if(S.$k)return g;const b=(0,o.$oc)(g);if(g===b)return g;const l=((0,o.$pc)(g)||g).toLowerCase();try{const p=(0,O.readdirSync)(b).filter($=>$.toLowerCase()===l);if(p.length===1){const $=P(b);if($)return(0,o.$lc)($,p[0])}else if(p.length>1){const $=p.indexOf(l);if($>=0){const w=P(b);if(w)return(0,o.$lc)(w,p[$])}}}catch{}return null}async function y(g,b){if(S.$k)return g;const l=(0,o.$oc)(g);if(g===l)return g;const m=((0,o.$pc)(g)||g).toLowerCase();try{if(b?.isCancellationRequested)return null;const $=(await O.Promises.readdir(l)).filter(w=>w.toLowerCase()===m);if($.length===1){const w=await y(l,b);if(w)return(0,o.$lc)(w,$[0])}else if($.length>1){const w=$.indexOf(m);if(w>=0){const v=await y(l,b);if(v)return(0,o.$lc)(v,$[w])}}}catch{}return null}async function a(g){try{return await O.Promises.realpath(g)}catch{const l=f(g);return await O.Promises.access(l,i.constants.R_OK),l}}function h(g){try{return i.realpathSync(g)}catch{const l=f(g);return i.accessSync(l,i.constants.R_OK),l}}function f(g){return(0,D.$of)((0,o.$jc)(g),o.sep)}}),define(oe[115],ae([0,1,27,9,21]),function(V,e,i,o,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vm=w,e.$wm=v,i=Re(i),o=Re(o),S=Re(S);const D=/^\d+$/,O=/^Microsoft.PowerShell_.*/,P=/^Microsoft.PowerShellPreview_.*/;var y;(function(k){k[k.x64=0]="x64",k[k.x86=1]="x86",k[k.ARM=2]="ARM"})(y||(y={}));let a;switch(process.arch){case"ia32":a=y.x86;break;case"arm":case"arm64":a=y.ARM;break;default:a=y.x64;break}let h;process.env.PROCESSOR_ARCHITEW6432?h=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?y.ARM:y.x64:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?h=y.ARM:process.env.PROCESSOR_ARCHITECTURE==="X86"?h=y.x86:h=y.x64;class f{constructor(t,r,n){this.exePath=t,this.displayName=r,this.a=n}async exists(){return this.a===void 0&&(this.a=await S.SymlinkSupport.existsFile(this.exePath)),this.a}}function g({useAlternateBitness:k=!1}={}){return k?a===y.x64?process.env["ProgramFiles(x86)"]||null:h===y.x64&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function b({useAlternateBitness:k=!1,findPreview:t=!1}={}){const r=g({useAlternateBitness:k});if(!r)return null;const n=o.$lc(r,"PowerShell");if(!await S.SymlinkSupport.existsDirectory(n))return null;let c=-1,s=null;for(const I of await S.Promises.readdir(n)){let E=-1;if(t){const T=I.indexOf("-");if(T<0)continue;const L=I.substring(0,T);if(!D.test(L)||I.substring(T+1)!=="preview")continue;E=parseInt(L,10)}else{if(!D.test(I))continue;E=parseInt(I,10)}if(E<=c)continue;const A=o.$lc(n,I,"pwsh.exe");await S.SymlinkSupport.existsFile(A)&&(s=A,c=E)}if(!s)return null;const u=r.includes("x86")?" (x86)":"",d=t?" Preview":"";return new f(s,`PowerShell${d}${u}`,!0)}async function l({findPreview:k}={}){if(!process.env.LOCALAPPDATA)return null;const t=o.$lc(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await S.SymlinkSupport.existsDirectory(t))return null;const{pwshMsixDirRegex:r,pwshMsixName:n}=k?{pwshMsixDirRegex:P,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:O,pwshMsixName:"PowerShell (Store)"};for(const c of await S.Promises.readdir(t))if(r.test(c)){const s=o.$lc(t,c,"pwsh.exe");return new f(s,n)}return null}function m(){const k=o.$lc(i.homedir(),".dotnet","tools","pwsh.exe");return new f(k,".NET Core PowerShell Global Tool")}function p(){const k=o.$lc(process.env.windir,a===y.x86&&h!==y.x86?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new f(k,"Windows PowerShell",!0)}async function*$(){let k=await b();k&&(yield k),k=await b({useAlternateBitness:!0}),k&&(yield k),k=await l(),k&&(yield k),k=m(),k&&(yield k),k=await b({findPreview:!0}),k&&(yield k),k=await l({findPreview:!0}),k&&(yield k),k=await b({useAlternateBitness:!0,findPreview:!0}),k&&(yield k),k=p(),k&&(yield k)}async function*w(){for await(const k of $())await k.exists()&&(yield k)}async function v(){for await(const k of w())return k;return null}}),define(oe[94],ae([0,1,9,4,36,80,12,21]),function(V,e,i,o,S,D,O,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.TerminateResponseCode=e.Source=void 0,e.$xm=y,e.$ym=a,i=Re(i),o=Re(o),S=Re(S),O=Re(O),P=Re(P),Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return D.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return D.TerminateResponseCode}});function y(f=S.env){return f.comspec||"cmd.exe"}function a(f){let g=[],b=!1;const l=function(m){if(b){g.push(m);return}(!f.send(m,$=>{if($&&console.error($),b=!1,g.length>0){const w=g.slice(0);g=[],w.forEach(v=>l(v))}})||o.$i)&&(b=!0)};return{send:l}}var h;(function(f){async function g(b,l,m){if(i.$kc(b))return b;if(l===void 0&&(l=S.cwd()),i.$oc(b)!=="."||(m===void 0&&O.$fg(S.env.PATH)&&(m=S.env.PATH.split(i.$vc)),m===void 0||m.length===0))return i.$lc(l,b);async function $(w){if(await P.Promises.exists(w)){let v;try{v=await P.Promises.stat(w)}catch(k){k.message.startsWith("EACCES")&&(v=await P.Promises.lstat(w))}return v?!v.isDirectory():!1}return!1}for(const w of m){let v;if(i.$kc(w)?v=i.$lc(w,b):v=i.$lc(l,w,b),await $(v))return v;let k=v+".com";if(await $(k)||(k=v+".exe",await $(k)))return k}return i.$lc(l,b)}f.findExecutable=g})(h||(e.win32=h={}))}),define(oe[116],ae([0,1,49,13]),function(V,e,i,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qs=S;function S(O){return new Promise((P,y)=>{let a;const h=new Map;function f(b,l,m,p,$){const w=h.get(l);if(b===O||w){const v={name:g(m),cmd:m,pid:b,ppid:l,load:p,mem:$};h.set(b,v),b===O&&(a=v),w&&(w.children||(w.children=[]),w.children.push(v),w.children.length>1&&(w.children=w.children.sort((k,t)=>k.pid-t.pid)))}}function g(b){const l=/--utility-sub-type=network/i,m=/--crashes-directory/i,p=/\\pipe\\winpty-control/i,$=/conhost\.exe.+--headless/i,w=/--type=([a-zA-Z-]+)/;if(m.exec(b))return"electron-crash-reporter";if(p.exec(b))return"winpty-agent";if($.exec(b))return"conpty-agent";let v=w.exec(b);if(v&&v.length===2)return v[1]==="renderer"?"window":v[1]==="utility"?l.exec(b)?"utility-network-service":"utility-process":v[1]==="extensionHost"?"extension-host":v[1];const k=/[a-zA-Z-]+\.js/g;let t="";do v=k.exec(b),v&&(t+=v+" ");while(v);return t&&b.indexOf("node ")<0&&b.indexOf("node.exe")<0?`electron-nodejs (${t})`:b}if(process.platform==="win32"){const b=l=>l.indexOf("\\\\?\\")===0||l.indexOf("\\??\\")===0?l.substring(4):l.indexOf('"\\\\?\\')===0||l.indexOf('"\\??\\')===0?'"'+l.substring(5):l;new Promise((l,m)=>{V(["@vscode/windows-process-tree"],l,m)}).then(Re).then(l=>{l.getProcessList(O,m=>{if(!m){y(new Error(`Root process ${O} not found`));return}l.getProcessCpuUsage(m,p=>{const $=new Map;p.forEach(w=>{const v=b(w.commandLine||"");$.set(w.pid,{name:g(v),cmd:v,pid:w.pid,ppid:w.ppid,load:w.cpu||0,mem:w.memory||0})}),a=$.get(O),a?($.forEach(w=>{const v=$.get(w.ppid);v&&(v.children||(v.children=[]),v.children.push(w))}),$.forEach(w=>{w.children&&(w.children=w.children.sort((v,k)=>v.pid-k.pid))}),P(a)):y(new Error(`Root process ${O} not found`))})},l.ProcessDataFlag.CommandLine|l.ProcessDataFlag.Memory)})}else{let b=function(){let l=[a];const m=[];for(;l.length;){const $=l.shift();$&&(m.push($.pid),$.children&&(l=l.concat($.children)))}let p=JSON.stringify(o.$Zg.asFileUri("vs/base/node/cpuUsage.sh").fsPath);p+=" "+m.join(" "),(0,i.exec)(p,{},($,w,v)=>{if($||v)y($||new Error(v.toString()));else{const k=w.toString().split(`
`);for(let t=0;t<m.length;t++){const r=h.get(m[t]);r.load=parseFloat(k[t])}if(!a){y(new Error(`Root process ${O} not found`));return}P(a)}})};(0,i.exec)("which ps",{},(l,m,p)=>{if(l||p)if(process.platform!=="linux")y(l||new Error(p.toString()));else{const $=JSON.stringify(o.$Zg.asFileUri("vs/base/node/ps.sh").fsPath);(0,i.exec)($,{},(w,v,k)=>{w||k?y(w||new Error(k.toString())):(D(v,f),b())})}else{const $=m.toString().trim();(0,i.exec)(`${$} -ax -o pid=,ppid=,pcpu=,pmem=,command=`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(v,k,t)=>{v||t&&!t.includes("screen size is bogus")?y(v||new Error(t.toString())):(D(k,f),process.platform==="linux"?b():a?P(a):y(new Error(`Root process ${O} not found`)))})}})}})}function D(O,P){const y=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,a=O.toString().split(`
`);for(const h of a){const f=y.exec(h.trim());f&&f.length===6&&P(parseInt(f[1]),parseInt(f[2]),f[5],parseFloat(f[3]),parseFloat(f[4]))}}}),define(oe[117],ae([0,1,27,4,115,94]),function(V,e,i,o,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zm=O,o=Re(o),D=Re(D);async function O(f,g){return f===o.OperatingSystem.Windows?o.$i?h():D.$xm(g):y(f,g)}let P=null;function y(f,g){if(o.$k&&f===o.OperatingSystem.Macintosh||o.$j&&f===o.OperatingSystem.Linux)return"/bin/bash";if(!P){let b;if(o.$i)b="/bin/bash";else{if(b=g.SHELL,!b)try{b=(0,i.userInfo)().shell}catch{}b||(b="sh"),b==="/bin/false"&&(b="/bin/bash")}P=b}return P}let a=null;async function h(){return a||(a=(await(0,S.$wm)()).exePath),a}});var Se=this&&this.__decorate||function(V,e,i,o){var S=arguments.length,D=S<3?e:o===null?o=Object.getOwnPropertyDescriptor(e,i):o,O;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")D=Reflect.decorate(V,e,i,o);else for(var P=V.length-1;P>=0;P--)(O=V[P])&&(D=(S<3?O(D):S>3?O(e,i,D):O(e,i))||D);return S>3&&D&&Object.defineProperty(e,i,D),D};define(oe[44],ae([0,1,22,8,17,23,52,16,3,2,81,26,12]),function(V,e,i,o,S,D,O,P,y,a,h,f,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oi=e.ProxyChannel=e.$ni=e.$ki=e.$ji=e.$ii=e.RequestInitiator=e.$hi=e.$ei=e.$di=void 0,e.$fi=d,e.$gi=I,e.$li=M,e.$mi=U,f=Re(f);var b;(function(H){H[H.Promise=100]="Promise",H[H.PromiseCancel=101]="PromiseCancel",H[H.EventListen=102]="EventListen",H[H.EventDispose=103]="EventDispose"})(b||(b={}));function l(H){switch(H){case b.Promise:return"req";case b.PromiseCancel:return"cancel";case b.EventListen:return"subscribe";case b.EventDispose:return"unsubscribe"}}var m;(function(H){H[H.Initialize=200]="Initialize",H[H.PromiseSuccess=201]="PromiseSuccess",H[H.PromiseError=202]="PromiseError",H[H.PromiseErrorObj=203]="PromiseErrorObj",H[H.EventFire=204]="EventFire"})(m||(m={}));function p(H){switch(H){case m.Initialize:return"init";case m.PromiseSuccess:return"reply:";case m.PromiseError:case m.PromiseErrorObj:return"replyErr:";case m.EventFire:return"event:"}}var $;(function(H){H[H.Uninitialized=0]="Uninitialized",H[H.Idle=1]="Idle"})($||($={}));function w(H){let j=0;for(let B=0;;B+=7){const x=H.read(1);if(j|=(x.buffer[0]&127)<<B,!(x.buffer[0]&128))return j}}const v=c(0);function k(H,j){if(j===0){H.write(v);return}let B=0;for(let ce=j;ce!==0;ce=ce>>>7)B++;const x=S.$Oe.alloc(B);for(let ce=0;j!==0;ce++)x.buffer[ce]=j&127,j=j>>>7,j>0&&(x.buffer[ce]|=128);H.write(x)}class t{constructor(j){this.b=j,this.a=0}read(j){const B=this.b.slice(this.a,this.a+j);return this.a+=B.byteLength,B}}e.$di=t;class r{constructor(){this.a=[]}get buffer(){return S.$Oe.concat(this.a)}write(j){this.a.push(j)}}e.$ei=r;var n;(function(H){H[H.Undefined=0]="Undefined",H[H.String=1]="String",H[H.Buffer=2]="Buffer",H[H.VSBuffer=3]="VSBuffer",H[H.Array=4]="Array",H[H.Object=5]="Object",H[H.Int=6]="Int"})(n||(n={}));function c(H){const j=S.$Oe.alloc(1);return j.writeUInt8(H,0),j}const s={Undefined:c(n.Undefined),String:c(n.String),Buffer:c(n.Buffer),VSBuffer:c(n.VSBuffer),Array:c(n.Array),Object:c(n.Object),Uint:c(n.Int)},u=typeof Buffer<"u";function d(H,j){if(typeof j>"u")H.write(s.Undefined);else if(typeof j=="string"){const B=S.$Oe.fromString(j);H.write(s.String),k(H,B.byteLength),H.write(B)}else if(u&&Buffer.isBuffer(j)){const B=S.$Oe.wrap(j);H.write(s.Buffer),k(H,B.byteLength),H.write(B)}else if(j instanceof S.$Oe)H.write(s.VSBuffer),k(H,j.byteLength),H.write(j);else if(Array.isArray(j)){H.write(s.Array),k(H,j.length);for(const B of j)d(H,B)}else if(typeof j=="number"&&(j|0)===j)H.write(s.Uint),k(H,j);else{const B=S.$Oe.fromString(JSON.stringify(j));H.write(s.Object),k(H,B.byteLength),H.write(B)}}function I(H){switch(H.read(1).readUInt8(0)){case n.Undefined:return;case n.String:return H.read(w(H)).toString();case n.Buffer:return H.read(w(H)).buffer;case n.VSBuffer:return H.read(w(H));case n.Array:{const B=w(H),x=[];for(let ce=0;ce<B;ce++)x.push(I(H));return x}case n.Object:return JSON.parse(H.read(w(H)).toString());case n.Int:return w(H)}}class E{constructor(j,B,x=null,ce=1e3){this.h=j,this.j=B,this.k=x,this.l=ce,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(G=>this.q(G)),this.m({type:m.Initialize})}registerChannel(j,B){this.b.set(j,B),setTimeout(()=>this.w(j),0)}m(j){switch(j.type){case m.Initialize:{const B=this.o([j.type]);this.k?.logOutgoing(B,0,A.OtherSide,p(j.type));return}case m.PromiseSuccess:case m.PromiseError:case m.EventFire:case m.PromiseErrorObj:{const B=this.o([j.type,j.id],j.data);this.k?.logOutgoing(B,j.id,A.OtherSide,p(j.type),j.data);return}}}o(j,B=void 0){const x=new r;return d(x,j),d(x,B),this.p(x.buffer)}p(j){try{return this.h.send(j),j.byteLength}catch{return 0}}q(j){const B=new t(j),x=I(B),ce=I(B),G=x[0];switch(G){case b.Promise:return this.k?.logIncoming(j.byteLength,x[1],A.OtherSide,`${l(G)}: ${x[2]}.${x[3]}`,ce),this.s({type:G,id:x[1],channelName:x[2],name:x[3],arg:ce});case b.EventListen:return this.k?.logIncoming(j.byteLength,x[1],A.OtherSide,`${l(G)}: ${x[2]}.${x[3]}`,ce),this.t({type:G,id:x[1],channelName:x[2],name:x[3],arg:ce});case b.PromiseCancel:return this.k?.logIncoming(j.byteLength,x[1],A.OtherSide,`${l(G)}`),this.u({type:G,id:x[1]});case b.EventDispose:return this.k?.logIncoming(j.byteLength,x[1],A.OtherSide,`${l(G)}`),this.u({type:G,id:x[1]})}}s(j){const B=this.b.get(j.channelName);if(!B){this.v(j);return}const x=new D.$xe;let ce;try{ce=B.call(this.j,j.name,j.arg,x.token)}catch(se){ce=Promise.reject(se)}const G=j.id;ce.then(se=>{this.m({id:G,data:se,type:m.PromiseSuccess})},se=>{se instanceof Error?this.m({id:G,data:{message:se.message,name:se.name,stack:se.stack?se.stack.split(`
`):void 0},type:m.PromiseError}):this.m({id:G,data:se,type:m.PromiseErrorObj})}).finally(()=>{he.dispose(),this.d.delete(j.id)});const he=(0,a.$Uc)(()=>x.cancel());this.d.set(j.id,he)}t(j){const B=this.b.get(j.channelName);if(!B){this.v(j);return}const x=j.id,G=B.listen(this.j,j.name,j.arg)(he=>this.m({id:x,data:he,type:m.EventFire}));this.d.set(j.id,G)}u(j){const B=this.d.get(j.id);B&&(B.dispose(),this.d.delete(j.id))}v(j){let B=this.g.get(j.channelName);B||(B=[],this.g.set(j.channelName,B));const x=setTimeout(()=>{console.error(`Unknown channel: ${j.channelName}`),j.type===b.Promise&&this.m({id:j.id,data:{name:"Unknown channel",message:`Channel name '${j.channelName}' timed out after ${this.l}ms`,stack:void 0},type:m.PromiseError})},this.l);B.push({request:j,timeoutTimer:x})}w(j){const B=this.g.get(j);if(B){for(const x of B)switch(clearTimeout(x.timeoutTimer),x.request.type){case b.Promise:this.s(x.request);break;case b.EventListen:this.t(x.request);break}this.g.delete(j)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,a.$Rc)(this.d.values()),this.d.clear()}}e.$hi=E;var A;(function(H){H[H.LocalSide=0]="LocalSide",H[H.OtherSide=1]="OtherSide"})(A||(e.RequestInitiator=A={}));class T{constructor(j,B=null){this.l=j,this.a=!1,this.b=$.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new y.$me,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(x=>this.s(x)),this.j=B}getChannel(j){const B=this;return{call(x,ce,G){return B.a?Promise.reject(new P.$7):B.m(j,x,ce,G)},listen(x,ce){return B.a?y.Event.None:B.o(j,x,ce)}}}m(j,B,x,ce=D.CancellationToken.None){const G=this.g++,he=b.Promise,se={id:G,type:he,channelName:j,name:B,arg:x};if(ce.isCancellationRequested)return Promise.reject(new P.$7);let _;return new Promise((C,W)=>{if(ce.isCancellationRequested)return W(new P.$7);const q=()=>{const ie=de=>{switch(de.type){case m.PromiseSuccess:this.f.delete(G),C(de.data);break;case m.PromiseError:{this.f.delete(G);const me=new Error(de.data.message);me.stack=Array.isArray(de.data.stack)?de.data.stack.join(`
`):de.data.stack,me.name=de.data.name,W(me);break}case m.PromiseErrorObj:this.f.delete(G),W(de.data);break}};this.f.set(G,ie),this.p(se)};let J=null;this.b===$.Idle?q():(J=(0,o.$sh)(ie=>this.u()),J.then(()=>{J=null,q()}));const X=()=>{J?(J.cancel(),J=null):this.p({id:G,type:b.PromiseCancel}),W(new P.$7)},Z=ce.onCancellationRequested(X);_=(0,a.$Tc)((0,a.$Uc)(X),Z),this.d.add(_)}).finally(()=>{_.dispose(),this.d.delete(_)})}o(j,B,x){const ce=this.g++,G=b.EventListen,he={id:ce,type:G,channelName:j,name:B,arg:x};let se=null;const _=new y.$me({onWillAddFirstListener:()=>{se=(0,o.$sh)(C=>this.u()),se.then(()=>{se=null,this.d.add(_),this.p(he)})},onDidRemoveLastListener:()=>{se?(se.cancel(),se=null):(this.d.delete(_),this.p({id:ce,type:b.EventDispose}))}}),F=C=>_.fire(C.data);return this.f.set(ce,F),_.event}p(j){switch(j.type){case b.Promise:case b.EventListen:{const B=this.q([j.type,j.id,j.channelName,j.name],j.arg);this.j?.logOutgoing(B,j.id,A.LocalSide,`${l(j.type)}: ${j.channelName}.${j.name}`,j.arg);return}case b.PromiseCancel:case b.EventDispose:{const B=this.q([j.type,j.id]);this.j?.logOutgoing(B,j.id,A.LocalSide,l(j.type));return}}}q(j,B=void 0){const x=new r;return d(x,j),d(x,B),this.r(x.buffer)}r(j){try{return this.l.send(j),j.byteLength}catch{return 0}}s(j){const B=new t(j),x=I(B),ce=I(B),G=x[0];switch(G){case m.Initialize:return this.j?.logIncoming(j.byteLength,0,A.LocalSide,p(G)),this.t({type:x[0]});case m.PromiseSuccess:case m.PromiseError:case m.EventFire:case m.PromiseErrorObj:return this.j?.logIncoming(j.byteLength,x[1],A.LocalSide,p(G),ce),this.t({type:x[0],id:x[1],data:ce})}}t(j){if(j.type===m.Initialize){this.b=$.Idle,this.k.fire();return}this.f.get(j.id)?.(j)}get onDidInitializePromise(){return y.Event.toPromise(this.onDidInitialize)}u(){return this.b===$.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,a.$Rc)(this.d.values()),this.d.clear()}}e.$ii=T,Se([O.$0h],T.prototype,"onDidInitializePromise",null);class L{get connections(){const j=[];return this.f.forEach(B=>j.push(B)),j}constructor(j,B,x){this.a=new Map,this.f=new Set,this.g=new y.$me,this.onDidAddConnection=this.g.event,this.h=new y.$me,this.onDidRemoveConnection=this.h.event,this.j=new a.$Vc,this.j.add(j(({protocol:ce,onDidClientDisconnect:G})=>{const he=y.Event.once(ce.onMessage);this.j.add(he(se=>{const _=new t(se),F=I(_),C=new E(ce,F,B,x),W=new T(ce,B);this.a.forEach((J,X)=>C.registerChannel(X,J));const q={channelServer:C,channelClient:W,ctx:F};this.f.add(q),this.g.fire(q),this.j.add(G(()=>{C.dispose(),W.dispose(),this.f.delete(q),this.h.fire(q)}))}))}))}getChannel(j,B){const x=this;return{call(ce,G,he){let se;if((0,g.$tg)(B)){const F=(0,i.$5b)(x.connections.filter(B));se=F?Promise.resolve(F):y.Event.toPromise(y.Event.filter(x.onDidAddConnection,B))}else se=B.routeCall(x,ce,G);const _=se.then(F=>F.channelClient.getChannel(j));return M(_).call(ce,G,he)},listen(ce,G){if((0,g.$tg)(B))return x.k(j,B,ce,G);const he=B.routeEvent(x,ce,G).then(se=>se.channelClient.getChannel(j));return M(he).listen(ce,G)}}}k(j,B,x,ce){const G=this;let he;const se=new y.$me({onWillAddFirstListener:()=>{he=new a.$Vc;const _=new y.$se,F=new Map,C=q=>{const X=q.channelClient.getChannel(j).listen(x,ce),Z=_.add(X);F.set(q,Z)},W=q=>{const J=F.get(q);J&&(J.dispose(),F.delete(q))};G.connections.filter(B).forEach(C),y.Event.filter(G.onDidAddConnection,B)(C,void 0,he),G.onDidRemoveConnection(W,void 0,he),_.event(se.fire,se,he),he.add(_)},onDidRemoveLastListener:()=>{he?.dispose(),he=void 0}});return se.event}registerChannel(j,B){this.a.set(j,B);for(const x of this.f)x.channelServer.registerChannel(j,B)}dispose(){this.j.dispose();for(const j of this.f)j.channelClient.dispose(),j.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$ji=L;class R{constructor(j,B,x=null){const ce=new r;d(ce,B),j.send(ce.buffer),this.a=new T(j,x),this.d=new E(j,B,x)}getChannel(j){return this.a.getChannel(j)}registerChannel(j,B){this.d.registerChannel(j,B)}dispose(){this.a.dispose(),this.d.dispose()}}e.$ki=R;function M(H){return{call(j,B,x){return H.then(ce=>ce.call(j,B,x))},listen(j,B){const x=new y.$ve;return H.then(ce=>x.input=ce.listen(j,B)),x.event}}}function U(H){let j=!1;return{call(B,x,ce){return j?H.call(B,x,ce):(0,o.$Gh)(0).then(()=>j=!0).then(()=>H.call(B,x,ce))},listen(B,x){if(j)return H.listen(B,x);const ce=new y.$ve;return(0,o.$Gh)(0).then(()=>j=!0).then(()=>ce.input=H.listen(B,x)),ce.event}}}class N{constructor(j){this.a=j}routeCall(j){return this.b(j)}routeEvent(j){return this.b(j)}async b(j){for(const B of j.connections)if(await Promise.resolve(this.a(B.ctx)))return Promise.resolve(B);return await y.Event.toPromise(j.onDidAddConnection),await this.b(j)}}e.$ni=N;var z;(function(H){function j(G,he,se){const _=G,F=se&&se.disableMarshalling,C=new Map;for(const W in _)x(W)&&C.set(W,y.Event.buffer(_[W],!0,void 0,he));return new class{listen(W,q,J){const X=C.get(q);if(X)return X;const Z=_[q];if(typeof Z=="function"){if(ce(q))return Z.call(_,J);if(x(q))return C.set(q,y.Event.buffer(_[q],!0,void 0,he)),C.get(q)}throw new P.$db(`Event not found: ${q}`)}call(W,q,J){const X=_[q];if(typeof X=="function"){if(!F&&Array.isArray(J))for(let ie=0;ie<J.length;ie++)J[ie]=(0,h.$ci)(J[ie]);let Z=X.apply(_,J);return Z instanceof Promise||(Z=Promise.resolve(Z)),Z}throw new P.$db(`Method not found: ${q}`)}}}H.fromService=j;function B(G,he){const se=he&&he.disableMarshalling;return new Proxy({},{get(_,F){if(typeof F=="string")return he?.properties?.has(F)?he.properties.get(F):ce(F)?function(C){return G.listen(F,C)}:x(F)?G.listen(F):async function(...C){let W;he&&!(0,g.$og)(he.context)?W=[he.context,...C]:W=C;const q=await G.call(F,W);return se?q:(0,h.$ci)(q)};throw new P.$db(`Property not found: ${String(F)}`)}})}H.toService=B;function x(G){return G[0]==="o"&&G[1]==="n"&&f.$Ff(G.charCodeAt(2))}function ce(G){return/^onDynamic/.test(G)&&f.$Ff(G.charCodeAt(9))}})(z||(e.ProxyChannel=z={}));const ne=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function Q(H){if(Array.isArray(H))return H;if(H&&typeof H=="object"&&typeof H.toString=="function"){const j=H.toString();if(j!=="[object Object]")return j}return H}function le(H){return Array.isArray(H)?H.map(Q):Q(H)}function K(H,j,B,x,ce,G,he){he=le(he);const se=ne[ce],_=se[x%se.length];let F=[`%c[${H}]%c[${String(j).padStart(7," ")}]%c[len: ${String(B).padStart(5," ")}]%c${String(x).padStart(5," ")} - ${G}`,"color: darkgreen","color: grey","color: grey",`color: ${_}`];/\($/.test(G)?(F=F.concat(he),F.push(")")):F.push(he),console.log.apply(console,F)}class ee{constructor(j,B){this.d=j,this.f=B,this.a=0,this.b=0}logOutgoing(j,B,x,ce,G){this.b+=j,K(this.d,this.b,j,B,x,ce,G)}logIncoming(j,B,x,ce,G){this.a+=j,K(this.f,this.a,j,B,x,ce,G)}}e.$oi=ee}),define(oe[162],ae([0,1,17,3,44]),function(V,e,i,o,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$FX=e.$EX=void 0;class D{constructor(y){this.a=y,this.onMessage=o.Event.fromDOMEventEmitter(this.a,"message",a=>a.data?i.$Oe.wrap(a.data):i.$Oe.alloc(0)),y.start()}send(y){this.a.postMessage(y.buffer)}disconnect(){this.a.close()}}e.$EX=D;class O extends S.$ki{constructor(y,a){const h=new D(y);super(h,a),this.b=h}dispose(){this.b.disconnect(),super.dispose()}}e.$FX=O}),define(oe[118],ae([0,1,17,3,2,44]),function(V,e,i,o,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ti=e.$si=e.$ri=e.$qi=e.ProtocolConstants=e.$pi=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var O;(function(s){s.Created="created",s.Read="read",s.Write="write",s.Open="open",s.Error="error",s.Close="close",s.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",s.NodeEndReceived="nodeEndReceived",s.NodeEndSent="nodeEndSent",s.NodeDrainBegin="nodeDrainBegin",s.NodeDrainEnd="nodeDrainEnd",s.zlibInflateError="zlibInflateError",s.zlibInflateData="zlibInflateData",s.zlibInflateInitialWrite="zlibInflateInitialWrite",s.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",s.zlibInflateWrite="zlibInflateWrite",s.zlibInflateFlushFired="zlibInflateFlushFired",s.zlibDeflateError="zlibDeflateError",s.zlibDeflateData="zlibDeflateData",s.zlibDeflateWrite="zlibDeflateWrite",s.zlibDeflateFlushFired="zlibDeflateFlushFired",s.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",s.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",s.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",s.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",s.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",s.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",s.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",s.ProtocolHeaderRead="protocolHeaderRead",s.ProtocolMessageRead="protocolMessageRead",s.ProtocolHeaderWrite="protocolHeaderWrite",s.ProtocolMessageWrite="protocolMessageWrite",s.ProtocolWrite="protocolWrite"})(O||(e.SocketDiagnosticsEventType=O={}));var P;(function(s){s.enableDiagnostics=!1,s.records=[];const u=new WeakMap;let d=0;function I(A,T){if(!u.has(A)){const L=String(++d);u.set(A,L)}return u.get(A)}function E(A,T,L,R){if(!s.enableDiagnostics)return;const M=I(A,T);if(R instanceof i.$Oe||R instanceof Uint8Array||R instanceof ArrayBuffer||ArrayBuffer.isView(R)){const U=i.$Oe.alloc(R.byteLength);U.set(R),s.records.push({timestamp:Date.now(),id:M,label:T,type:L,buff:U})}else s.records.push({timestamp:Date.now(),id:M,label:T,type:L,data:R})}s.traceSocketEvent=E})(P||(e.SocketDiagnostics=P={}));var y;(function(s){s[s.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",s[s.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(y||(e.SocketCloseEventType=y={}));let a=null;function h(){return a||(a=i.$Oe.alloc(0)),a}class f{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(u){this.a.push(u),this.b+=u.byteLength}read(u){return this.c(u,!0)}peek(u){return this.c(u,!1)}c(u,d){if(u===0)return h();if(u>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===u){const T=this.a[0];return d&&(this.a.shift(),this.b-=u),T}if(this.a[0].byteLength>u){const T=this.a[0].slice(0,u);return d&&(this.a[0]=this.a[0].slice(u),this.b-=u),T}const I=i.$Oe.alloc(u);let E=0,A=0;for(;u>0;){const T=this.a[A];if(T.byteLength>u){const L=T.slice(0,u);I.set(L,E),E+=u,d&&(this.a[A]=T.slice(u),this.b-=u),u-=u}else I.set(T,E),E+=T.byteLength,d?(this.a.shift(),this.b-=T.byteLength):A++,u-=T.byteLength}return I}}e.$pi=f;var g;(function(s){s[s.None=0]="None",s[s.Regular=1]="Regular",s[s.Control=2]="Control",s[s.Ack=3]="Ack",s[s.Disconnect=5]="Disconnect",s[s.ReplayRequest=6]="ReplayRequest",s[s.Pause=7]="Pause",s[s.Resume=8]="Resume",s[s.KeepAlive=9]="KeepAlive"})(g||(g={}));function b(s){switch(s){case g.None:return"None";case g.Regular:return"Regular";case g.Control:return"Control";case g.Ack:return"Ack";case g.Disconnect:return"Disconnect";case g.ReplayRequest:return"ReplayRequest";case g.Pause:return"PauseWriting";case g.Resume:return"ResumeWriting";case g.KeepAlive:return"KeepAlive"}}var l;(function(s){s[s.HeaderLength=13]="HeaderLength",s[s.AcknowledgeTime=2e3]="AcknowledgeTime",s[s.TimeoutTime=2e4]="TimeoutTime",s[s.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",s[s.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",s[s.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(l||(e.ProtocolConstants=l={}));class m{constructor(u,d,I,E){this.type=u,this.id=d,this.ack=I,this.data=E,this.writtenTime=0}get size(){return this.data.byteLength}}class p extends S.$Wc{constructor(u){super(),this.f=this.B(new o.$me),this.onMessage=this.f.event,this.g={readHead:!0,readLen:l.HeaderLength,messageType:g.None,id:0,ack:0},this.a=u,this.b=!1,this.c=new f,this.B(this.a.onData(d=>this.acceptChunk(d))),this.lastReadTime=Date.now()}acceptChunk(u){if(!(!u||u.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(u);this.c.byteLength>=this.g.readLen;){const d=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=d.readUInt32BE(9),this.g.messageType=d.readUInt8(0),this.g.id=d.readUInt32BE(1),this.g.ack=d.readUInt32BE(5),this.a.traceSocketEvent(O.ProtocolHeaderRead,{messageType:b(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const I=this.g.messageType,E=this.g.id,A=this.g.ack;if(this.g.readHead=!0,this.g.readLen=l.HeaderLength,this.g.messageType=g.None,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent(O.ProtocolMessageRead,d),this.f.fire(new m(I,E,A,d)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class ${constructor(u){this.k=null,this.a=!1,this.b=!1,this.c=u,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(u){if(this.a)return;u.writtenTime=Date.now(),this.lastWriteTime=Date.now();const d=i.$Oe.alloc(l.HeaderLength);d.writeUInt8(u.type,0),d.writeUInt32BE(u.id,1),d.writeUInt32BE(u.ack,5),d.writeUInt32BE(u.data.byteLength,9),this.c.traceSocketEvent(O.ProtocolHeaderWrite,{messageType:b(u.type),id:u.id,ack:u.ack,messageSize:u.data.byteLength}),this.c.traceSocketEvent(O.ProtocolMessageWrite,u.data),this.j(d,u.data)}g(u,d){const I=this.f===0;return this.d.push(u,d),this.f+=u.byteLength+d.byteLength,I}h(){const u=i.$Oe.concat(this.d,this.f);return this.d.length=0,this.f=0,u}j(u,d){this.g(u,d)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const u=this.h();this.c.traceSocketEvent(O.ProtocolWrite,{byteLength:u.byteLength}),this.c.write(u)}}class w extends S.$Wc{constructor(u){super(),this.f=new o.$me,this.onMessage=this.f.event,this.g=new o.$me,this.onDidDispose=this.g.event,this.a=u,this.b=this.B(new $(this.a)),this.c=this.B(new p(this.a)),this.B(this.c.onMessage(d=>{d.type===g.Regular&&this.f.fire(d.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(u){this.b.write(new m(g.Regular,0,0,u))}}e.$qi=w;class v extends D.$ki{static fromSocket(u,d){return new v(new w(u),d)}get onDidDispose(){return this.b.onDidDispose}constructor(u,d,I=null){super(u,d,I),this.b=u}dispose(){super.dispose();const u=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),u.end()}}e.$ri=v;class k{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new o.$me({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(u){this.b?this.d.length>0?this.d.push(u):this.a.fire(u):this.d.push(u)}flushBuffer(){this.d=[]}}e.$si=k;class t{constructor(u){this.data=u,this.next=null}}class r{constructor(){this.a=null,this.b=null}length(){let u=0,d=this.a;for(;d;)d=d.next,u++;return u}peek(){return this.a?this.a.data:null}toArray(){const u=[];let d=0,I=this.a;for(;I;)u[d++]=I.data,I=I.next;return u}pop(){if(this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(u){const d=new t(u);if(!this.a){this.a=d,this.b=d;return}this.b.next=d,this.b=d}}class n{static{this.a=10}static{this.b=null}static getInstance(){return n.b||(n.b=new n),n.b}constructor(){this.c=[];const u=Date.now();for(let d=0;d<n.a;d++)this.c[d]=u-1e3*d;setInterval(()=>{for(let d=n.a;d>=1;d--)this.c[d]=this.c[d-1];this.c[0]=Date.now()},1e3)}d(){const u=Date.now(),d=(1+n.a)*1e3;let I=0;for(let E=0;E<n.a;E++)u-this.c[E]<=d&&I++;return 1-I/n.a}hasHighLoad(){return this.d()>=.5}}class c{get unacknowledgedCount(){return this.c-this.d}constructor(u){this.u=new k,this.onControlMessage=this.u.event,this.v=new k,this.onMessage=this.v.event,this.w=new k,this.onDidDispose=this.w.event,this.x=new k,this.onSocketClose=this.x.event,this.y=new k,this.onSocketTimeout=this.y.event,this.s=u.loadEstimator??n.getInstance(),this.t=u.sendKeepAlive??!0,this.a=!1,this.b=new r,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.r=new S.$Vc,this.o=u.socket,this.p=this.r.add(new $(this.o)),this.q=this.r.add(new p(this.o)),this.r.add(this.q.onMessage(d=>this.z(d))),this.r.add(this.o.onClose(d=>this.x.fire(d))),u.initialChunk&&this.q.acceptChunk(u.initialChunk),this.t?this.l=setInterval(()=>{this.D()},l.KeepAliveSendTime):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.r.dispose()}drain(){return this.p.drain()}sendDisconnect(){const u=new m(g.Disconnect,0,0,h());this.p.write(u),this.p.flush()}sendPause(){const u=new m(g.Pause,0,0,h());this.p.write(u)}sendResume(){const u=new m(g.Resume,0,0,h());this.p.write(u)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(u,d){this.a=!0,this.r.dispose(),this.r=new S.$Vc,this.u.flushBuffer(),this.x.flushBuffer(),this.y.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=u,this.p=this.r.add(new $(this.o)),this.q=this.r.add(new p(this.o)),this.r.add(this.q.onMessage(I=>this.z(I))),this.r.add(this.o.onClose(I=>this.x.fire(I))),this.q.acceptChunk(d)}endAcceptReconnection(){this.a=!1,this.h=this.g;const u=new m(g.Ack,0,this.h,h());this.p.write(u);const d=this.b.toArray();for(let I=0,E=d.length;I<E;I++)this.p.write(d[I]);this.B()}acceptDisconnect(){this.w.fire()}z(u){if(u.ack>this.d){this.d=u.ack;do{const d=this.b.peek();if(d&&d.id<=u.ack)this.b.pop();else break}while(!0)}switch(u.type){case g.None:break;case g.Regular:{if(u.id>this.g)if(u.id!==this.g+1){const d=Date.now();d-this.m>1e4&&(this.m=d,this.p.write(new m(g.ReplayRequest,0,0,h())))}else this.g=u.id,this.j=Date.now(),this.A(),this.v.fire(u.data);break}case g.Control:{this.u.fire(u.data);break}case g.Ack:break;case g.Disconnect:{this.w.fire();break}case g.ReplayRequest:{const d=this.b.toArray();for(let I=0,E=d.length;I<E;I++)this.p.write(d[I]);this.B();break}case g.Pause:{this.p.pause();break}case g.Resume:{this.p.resume();break}case g.KeepAlive:break}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(u){const d=++this.c;this.h=this.g;const I=new m(g.Regular,d,this.h,u);this.b.push(I),this.a||(this.p.write(I),this.B())}sendControl(u){const d=new m(g.Control,0,0,u);this.p.write(d)}A(){if(this.g<=this.h||this.k)return;const u=Date.now()-this.j;if(u>=l.AcknowledgeTime){this.C();return}this.k=setTimeout(()=>{this.k=null,this.A()},l.AcknowledgeTime-u+5)}B(){if(this.c<=this.d||this.f||this.a)return;const u=this.b.peek(),d=Date.now()-u.writtenTime,I=Date.now()-this.q.lastReadTime,E=Date.now()-this.n;if(d>=l.TimeoutTime&&I>=l.TimeoutTime&&E>=l.TimeoutTime&&!this.s.hasHighLoad()){this.n=Date.now(),this.y.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:d,timeSinceLastReceivedSomeData:I});return}const A=Math.max(l.TimeoutTime-d,l.TimeoutTime-I,l.TimeoutTime-E,500);this.f=setTimeout(()=>{this.f=null,this.B()},A)}C(){if(this.g<=this.h)return;this.h=this.g;const u=new m(g.Ack,0,this.h,h());this.p.write(u)}D(){this.h=this.g;const u=new m(g.KeepAlive,0,this.h,h());this.p.write(u)}}e.$ti=c}),define(oe[37],ae([0,1,14,16,13]),function(V,e,i,o,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$BX=void 0;class D{constructor(){this.a=new WeakMap}on(P,y){const a=(h,...f)=>{this.b(P,h)&&y(h,...f)};return this.a.set(y,a),i.ipcMain.on(P,a),this}once(P,y){return i.ipcMain.once(P,(a,...h)=>{this.b(P,a)&&y(a,...h)}),this}handle(P,y){return i.ipcMain.handle(P,(a,...h)=>this.b(P,a)?y(a,...h):Promise.reject(`Invalid channel '${P}' or sender for ipcMain.handle() usage.`)),this}removeHandler(P){return i.ipcMain.removeHandler(P),this}removeListener(P,y){const a=this.a.get(y);return a&&(i.ipcMain.removeListener(P,a),this.a.delete(y)),this}b(P,y){if(!P||!P.startsWith("vscode:"))return(0,o.$3)(`Refused to handle ipcMain event for channel '${P}' because the channel is unknown.`),!1;const a=y.senderFrame,h=a.url;if(!h||h==="about:blank")return!0;let f="unknown";try{f=new URL(h).host}catch{return(0,o.$3)(`Refused to handle ipcMain event for channel '${P}' because of a malformed URL '${h}'.`),!1}return f!==S.$Yg?((0,o.$3)(`Refused to handle ipcMain event for channel '${P}' because of a bad origin of '${f}'.`),!1):a.parent!==null?((0,o.$3)(`Refused to handle ipcMain event for channel '${P}' because sender of origin '${f}' is not a main frame.`),!1):!0}}e.$BX=new D}),define(oe[163],ae([0,1,14,37,151]),function(V,e,i,o,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$CX=D;function D(){o.$BX.on(S.$zX,(P,y,a,h,f)=>{const g=O(P,h,a);g.popup({x:f?f.x:void 0,y:f?f.y:void 0,positioningItem:f?f.positioningItem:void 0,callback:()=>{g&&P.sender.send(S.$AX,y)}})})}function O(P,y,a){const h=new i.Menu;return a.forEach(f=>{let g;f.type==="separator"?g=new i.MenuItem({type:f.type}):Array.isArray(f.submenu)?g=new i.MenuItem({submenu:O(P,y,f.submenu),label:f.label}):g=new i.MenuItem({label:f.label,type:f.type,accelerator:f.accelerator,checked:f.checked,enabled:f.enabled,visible:f.visible,click:(b,l,m)=>P.sender.send(y,f.id,m)}),h.append(g)}),h}}),define(oe[164],ae([0,1,37,17,3,2,44,152]),function(V,e,i,o,S,D,O,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$IX=void 0;function y(h,f){const g=S.Event.fromNodeEventEmitter(i.$BX,f,(l,m)=>({event:l,message:m})),b=S.Event.filter(g,({event:l})=>l.sender.id===h);return S.Event.map(b,({message:l})=>l&&o.$Oe.wrap(l))}class a extends O.$ji{static{this.b=new Map}static d(){const f=S.Event.fromNodeEventEmitter(i.$BX,"vscode:hello",({sender:g})=>g);return S.Event.map(f,g=>{const b=g.id;a.b.get(b)?.dispose();const m=new S.$me;a.b.set(b,(0,D.$Uc)(()=>m.fire()));const p=y(b,"vscode:message"),$=S.Event.any(S.Event.signal(y(b,"vscode:disconnect")),m.event);return{protocol:new P.$HX(g,p),onDidClientDisconnect:$}})}constructor(){super(a.d())}}e.$IX=a}),define(oe[119],ae([0,1,37,3,33,162]),function(V,e,i,o,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$JX=void 0,e.$KX=P;class O extends D.$FX{constructor(a,h){super({addEventListener:(f,g)=>a.addListener(f,g),removeEventListener:(f,g)=>a.removeListener(f,g),postMessage:f=>a.postMessage(f),start:()=>a.start(),close:()=>a.close()},h)}}e.$JX=O;async function P(y){if(y.isDestroyed()||y.webContents.isDestroyed())throw new Error("ipc.mp#connect: Cannot talk to window because it is closed or destroyed");const a=(0,S.$2g)();y.webContents.send("vscode:createMessageChannel",a);const h=o.Event.fromNodeEventEmitter(i.$BX,"vscode:createMessageChannelResult",(g,b)=>({nonce:b,port:g.ports[0]})),{port:f}=await o.Event.toPromise(o.Event.once(o.Event.filter(h,g=>g.nonce===a)));return f}}),define(oe[165],ae([0,1,49,8,17,23,159,16,3,2,35,94,80,44]),function(V,e,i,o,S,D,O,P,y,a,h,f,g,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$br=e.$ar=void 0,P=Re(P);class l extends b.$hi{constructor($){super({send:w=>{try{process.send?.(w.buffer.toString("base64"))}catch{}},onMessage:y.Event.fromNodeEventEmitter(process,"message",w=>S.$Oe.wrap(Buffer.from(w,"base64")))},$),process.once("disconnect",()=>this.dispose())}}e.$ar=l;class m{constructor($,w){this.i=$,this.j=w,this.c=new Set,this.g=new Map,this.h=new y.$me,this.onDidProcessExit=this.h.event;const v=w&&w.timeout?w.timeout:6e4;this.b=new o.$Ch(v),this.d=null,this.f=null}getChannel($){const w=this;return{call(v,k,t){return w.k($,v,k,t)},listen(v,k){return w.l($,v,k)}}}k($,w,v,k=D.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(k.isCancellationRequested)return Promise.reject(P.$8());this.b.cancel();const t=this.n($),r=(0,o.$sh)(s=>t.call(w,v,s)),n=k.onCancellationRequested(()=>r.cancel()),c=(0,a.$Uc)(()=>r.cancel());return this.c.add(c),r.finally(()=>{n.dispose(),this.c.delete(c),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),r}l($,w,v){if(!this.b)return y.Event.None;this.b.cancel();let k;const t=new y.$me({onWillAddFirstListener:()=>{k=this.n($).listen(w,v)(t.fire,t),this.c.add(k)},onDidRemoveLastListener:()=>{this.c.delete(k),k.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return t.event}get m(){if(!this.f){const $=this.j&&this.j.args?this.j.args:[],w=Object.create(null);w.env={...(0,h.$bo)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(w.env={...w.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(w.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(w.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(w.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),w.execArgv===void 0&&(w.execArgv=process.execArgv.filter(d=>!/^--inspect(-brk)?=/.test(d)).filter(d=>!d.startsWith("--vscode-"))),(0,g.$lm)(w.env),this.d=(0,i.fork)(this.i,$,w);const v=new y.$me,t=y.Event.fromNodeEventEmitter(this.d,"message",d=>d)(d=>{if((0,O.$9q)(d)){(0,O.log)(d,`IPC Library: ${this.j.serverName}`);return}v.fire(S.$Oe.wrap(Buffer.from(d,"base64")))}),r=this.j.useQueue?(0,f.$ym)(this.d):this.d,n=d=>this.d&&this.d.connected&&r.send(d.buffer.toString("base64")),c=v.event,s={send:n,onMessage:c};this.f=new b.$ii(s);const u=()=>this.o();process.once("exit",u),this.d.on("error",d=>console.warn('IPC "'+this.j.serverName+'" errored with '+d)),this.d.on("exit",(d,I)=>{process.removeListener("exit",u),t.dispose(),this.c.forEach(E=>(0,a.$Rc)(E)),this.c.clear(),d!==0&&I!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+d+" and signal "+I),this.b?.cancel(),this.o(),this.h.fire({code:d,signal:I})})}return this.f}n($){let w=this.g.get($);return w||(w=this.m.getChannel($),this.g.set($,w)),w}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$br=m}),define(oe[120],ae([0,1,8,3,2,81,12]),function(V,e,i,o,S,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$p=e.$0p=e.StorageState=e.StorageHint=void 0,e.$9p=y;var P;(function(g){g[g.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",g[g.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(P||(e.StorageHint=P={}));function y(g){const b=g;return b?.changed instanceof Map||b?.deleted instanceof Set}var a;(function(g){g[g.None=0]="None",g[g.Initialized=1]="Initialized",g[g.Closed=2]="Closed"})(a||(e.StorageState=a={}));class h extends S.$Wc{static{this.a=100}constructor(b,l=Object.create(null)){super(),this.r=b,this.s=l,this.b=this.B(new o.$pe),this.onDidChangeStorage=this.b.event,this.c=a.None,this.f=new Map,this.g=this.B(new i.$Dh(h.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(b=>this.u(b)))}u(b){this.b.pause();try{b.changed?.forEach((l,m)=>this.w(m,l)),b.deleted?.forEach(l=>this.w(l,void 0))}finally{this.b.resume()}}w(b,l){if(this.c===a.Closed)return;let m=!1;(0,O.$og)(l)?m=this.f.delete(b):this.f.get(b)!==l&&(this.f.set(b,l),m=!0),m&&this.b.fire({key:b,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===a.None&&(this.c=a.Initialized,this.s.hint!==P.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(b,l){const m=this.f.get(b);return(0,O.$og)(m)?l:m}getBoolean(b,l){const m=this.get(b);return(0,O.$og)(m)?l:m==="true"}getNumber(b,l){const m=this.get(b);return(0,O.$og)(m)?l:parseInt(m,10)}getObject(b,l){const m=this.get(b);return(0,O.$og)(m)?l:(0,D.$bi)(m)}async set(b,l,m=!1){if(this.c===a.Closed)return;if((0,O.$og)(l))return this.delete(b,m);const p=(0,O.$hg)(l)||Array.isArray(l)?(0,D.$ai)(l):String(l);if(this.f.get(b)!==p)return this.f.set(b,p),this.j.set(b,p),this.h.delete(b),this.b.fire({key:b,external:m}),this.D()}async delete(b,l=!1){if(!(this.c===a.Closed||!this.f.delete(b)))return this.h.has(b)||this.h.add(b),this.j.delete(b),this.b.fire({key:b,external:l}),this.D()}async optimize(){if(this.c!==a.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=a.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const b={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(b).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(b){if(!(this.c===a.Closed||this.m))return this.D(b)}async D(b){return this.s.hint===P.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),b)}async whenFlushed(){if(this.z)return new Promise(b=>this.n.push(b))}isInMemory(){return this.s.hint===P.STORAGE_IN_MEMORY}}e.$0p=h;class f{constructor(){this.onDidChangeItemsExternal=o.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(b){b.insert?.forEach((l,m)=>this.a.set(m,l)),b.delete?.forEach(l=>this.a.delete(l))}async optimize(){}async close(){}}e.$$p=f}),define(oe[166],ae([0,1,8,3,32,9,21]),function(V,e,i,o,S,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7X=void 0;class P{static{this.IN_MEMORY_PATH=":memory:"}get onDidChangeItemsExternal(){return o.Event.None}static{this.a=2e3}static{this.b=256}constructor(h,f=Object.create(null)){this.g=h,this.h=f,this.c=(0,D.$pc)(this.g),this.d=new y(this.h.logging),this.f=this.n(this.g)}async getItems(){const h=await this.f,f=new Map;return(await this.s(h,"SELECT * FROM ItemTable")).forEach(b=>f.set(b.key,b.value)),this.d.isTracing&&this.d.trace(`[storage ${this.c}] getItems(): ${f.size} rows`),f}async updateItems(h){const f=await this.f;return this.j(f,h)}j(h,f){return this.d.isTracing&&this.d.trace(`[storage ${this.c}] updateItems(): insert(${f.insert?(0,S.$Ac)(f.insert):"0"}), delete(${f.delete?(0,S.$Bc)(f.delete):"0"})`),this.t(h,()=>{const g=f.insert,b=f.delete;if(g&&g.size>0){const l=[];l.push([]);let m=0;g.forEach((p,$)=>{let w=l[m];w.length>P.b&&(m++,w=[],l.push(w)),w.push($,p)}),l.forEach(p=>{this.u(h,`INSERT INTO ItemTable VALUES ${new Array(p.length/2).fill("(?,?)").join(",")}`,$=>$.run(p),()=>{const $=[];let w=0;return g.forEach((v,k)=>{$.push(k),w+=v.length}),`Keys: ${$.join(", ")} Length: ${w}`})})}if(b&&b.size){const l=[];l.push([]);let m=0;b.forEach(p=>{let $=l[m];$.length>P.b&&(m++,$=[],l.push($)),$.push(p)}),l.forEach(p=>{this.u(h,`DELETE FROM ItemTable WHERE key IN (${new Array(p.length).fill("?").join(",")})`,$=>$.run(p),()=>{const $=[];return b.forEach(w=>{$.push(w)}),`Keys: ${$.join(", ")}`})})}})}async optimize(){this.d.trace(`[storage ${this.c}] vacuum()`);const h=await this.f;return this.q(h,"VACUUM")}async close(h){this.d.trace(`[storage ${this.c}] close()`);const f=await this.f;return this.k(f,h)}k(h,f){return new Promise((g,b)=>{h.db.close(l=>(l&&this.o(h,`[storage ${this.c}] close(): ${l}`),this.g===P.IN_MEMORY_PATH?g():!h.isErroneous&&!h.isInMemory?this.l().then(g,m=>(this.d.error(`[storage ${this.c}] backup(): ${m}`),g())):typeof f=="function"?O.Promises.unlink(this.g).then(()=>this.p(this.g).then(m=>{const p=()=>this.k(m,void 0);return this.j(m,{insert:f()}).then(()=>p(),$=>(p(),Promise.reject($)))})).then(g,b):b(l||new Error("Database has errors or is in-memory without recovery option"))))})}l(){const h=this.m(this.g);return O.Promises.copy(this.g,h,{preserveSymlinks:!1})}m(h){return`${h}.backup`}async checkIntegrity(h){this.d.trace(`[storage ${this.c}] checkIntegrity(full: ${h})`);const f=await this.f,g=await this.r(f,h?"PRAGMA integrity_check":"PRAGMA quick_check"),b=h?g.integrity_check:g.quick_check;return f.isErroneous?`${b} (last error: ${f.lastError})`:f.isInMemory?`${b} (in-memory!)`:b}async n(h,f=!0){this.d.trace(`[storage ${this.c}] open(${h}, retryOnBusy: ${f})`);try{return await this.p(h)}catch(g){if(this.d.error(`[storage ${this.c}] open(): Unable to open DB due to ${g}`),g.code==="SQLITE_BUSY"&&f)return await(0,i.$Gh)(P.a),this.n(h,!1);try{await O.Promises.unlink(h);try{await O.Promises.rename(this.m(h),h,!1)}catch{}return await this.p(h)}catch(b){return this.d.error(`[storage ${this.c}] open(): Unable to use backup due to ${b}`),this.p(P.IN_MEMORY_PATH)}}}o(h,f){h.isErroneous=!0,h.lastError=f,this.d.error(f)}p(h){return new Promise((f,g)=>{new Promise((b,l)=>{V(["@vscode/sqlite3"],b,l)}).then(Re).then(b=>{const l={db:new(this.d.isTracing?b.verbose().Database:b.Database)(h,m=>m?l.db&&m.code!=="SQLITE_CANTOPEN"?l.db.close(()=>g(m)):g(m):this.q(l,["PRAGMA user_version = 1;","CREATE TABLE IF NOT EXISTS ItemTable (key TEXT UNIQUE ON CONFLICT REPLACE, value BLOB)"].join("")).then(()=>f(l),p=>l.db.close(()=>g(p)))),isInMemory:h===P.IN_MEMORY_PATH};l.db.on("error",m=>this.o(l,`[storage ${this.c}] Error (event): ${m}`)),this.d.isTracing&&l.db.on("trace",m=>this.d.trace(`[storage ${this.c}] Trace (event): ${m}`))},g)})}q(h,f){return new Promise((g,b)=>{h.db.exec(f,l=>l?(this.o(h,`[storage ${this.c}] exec(): ${l}`),b(l)):g())})}r(h,f){return new Promise((g,b)=>{h.db.get(f,(l,m)=>l?(this.o(h,`[storage ${this.c}] get(): ${l}`),b(l)):g(m))})}s(h,f){return new Promise((g,b)=>{h.db.all(f,(l,m)=>l?(this.o(h,`[storage ${this.c}] all(): ${l}`),b(l)):g(m))})}t(h,f){return new Promise((g,b)=>{h.db.serialize(()=>{h.db.run("BEGIN TRANSACTION"),f(),h.db.run("END TRANSACTION",l=>l?(this.o(h,`[storage ${this.c}] transaction(): ${l}`),b(l)):g())})})}u(h,f,g,b){const l=h.db.prepare(f),m=p=>{this.o(h,`[storage ${this.c}] prepare(): ${p} (${f}). Details: ${b()}`)};l.on("error",m),g(l),l.finalize(p=>{p&&m(p),l.removeListener("error",m)})}}e.$7X=P;class y{static{this.a="VSCODE_TRACE_STORAGE"}constructor(h){h&&typeof h.logTrace=="function"&&process.env[y.a]&&(this.b=h.logTrace),h&&typeof h.logError=="function"&&(this.c=h.logError)}get isTracing(){return!!this.b}trace(h){this.b?.(h)}error(h){this.c?.(h)}}}),define(oe[167],ae([11,10]),function(V,e){return V.create("vs/code/electron-main/app",e)}),define(oe[168],ae([11,10]),function(V,e){return V.create("vs/platform/configuration/common/configurationRegistry",e)}),define(oe[169],ae([11,10]),function(V,e){return V.create("vs/platform/contextkey/common/contextkey",e)}),define(oe[170],ae([11,10]),function(V,e){return V.create("vs/platform/contextkey/common/scanner",e)}),define(oe[171],ae([11,10]),function(V,e){return V.create("vs/platform/dialogs/common/dialogs",e)}),define(oe[172],ae([11,10]),function(V,e){return V.create("vs/platform/dialogs/electron-main/dialogMainService",e)}),define(oe[173],ae([11,10]),function(V,e){return V.create("vs/platform/environment/node/argv",e)}),define(oe[174],ae([11,10]),function(V,e){return V.create("vs/platform/environment/node/argvHelper",e)}),define(oe[175],ae([11,10]),function(V,e){return V.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(oe[176],ae([11,10]),function(V,e){return V.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(oe[177],ae([11,10]),function(V,e){return V.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(oe[178],ae([11,10]),function(V,e){return V.create("vs/platform/extensions/common/extensionValidator",e)}),define(oe[179],ae([11,10]),function(V,e){return V.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(oe[180],ae([11,10]),function(V,e){return V.create("vs/platform/files/common/fileService",e)}),define(oe[181],ae([11,10]),function(V,e){return V.create("vs/platform/files/common/files",e)}),define(oe[182],ae([11,10]),function(V,e){return V.create("vs/platform/files/common/io",e)}),define(oe[183],ae([11,10]),function(V,e){return V.create("vs/platform/files/electron-main/diskFileSystemProviderServer",e)}),define(oe[184],ae([11,10]),function(V,e){return V.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(oe[185],ae([11,10]),function(V,e){return V.create("vs/platform/issue/electron-main/issueMainService",e)}),define(oe[186],ae([11,10]),function(V,e){return V.create("vs/platform/log/common/log",e)}),define(oe[187],ae([11,10]),function(V,e){return V.create("vs/platform/menubar/electron-main/menubar",e)}),define(oe[188],ae([11,10]),function(V,e){return V.create("vs/platform/native/electron-main/nativeHostMainService",e)}),define(oe[189],ae([11,10]),function(V,e){return V.create("vs/platform/request/common/request",e)}),define(oe[190],ae([11,10]),function(V,e){return V.create("vs/platform/shell/node/shellEnv",e)}),define(oe[191],ae([11,10]),function(V,e){return V.create("vs/platform/telemetry/common/telemetryService",e)}),define(oe[192],ae([11,10]),function(V,e){return V.create("vs/platform/terminal/common/terminalPlatformConfiguration",e)}),define(oe[193],ae([11,10]),function(V,e){return V.create("vs/platform/terminal/common/terminalProfiles",e)}),define(oe[194],ae([11,10]),function(V,e){return V.create("vs/platform/update/common/update.config.contribution",e)}),define(oe[195],ae([11,10]),function(V,e){return V.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(oe[196],ae([11,10]),function(V,e){return V.create("vs/platform/windows/electron-main/windowImpl",e)}),define(oe[197],ae([11,10]),function(V,e){return V.create("vs/platform/windows/electron-main/windowsMainService",e)}),define(oe[198],ae([11,10]),function(V,e){return V.create("vs/platform/workspace/common/workspace",e)}),define(oe[199],ae([11,10]),function(V,e){return V.create("vs/platform/workspaces/electron-main/workspacesHistoryMainService",e)}),define(oe[200],ae([11,10]),function(V,e){return V.create("vs/platform/workspaces/electron-main/workspacesManagementMainService",e)}),define(oe[201],ae([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dhb=i,e.$Ehb=o;function i(S){return S&&S.hasOwnProperty("folderUri")}function o(S){return S&&S.hasOwnProperty("workspace")}}),define(oe[202],ae([0,1,7]),function(V,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mec=o,e.$nec=S,e.$oec=D;function o(O){return typeof O?.backupFolder=="string"}function S(O){let P=[];try{Array.isArray(O.workspaces)&&(P=O.workspaces.map(y=>({workspace:{id:y.id,configPath:i.URI.parse(y.configURIPath)},remoteAuthority:y.remoteAuthority})))}catch{}return P}function D(O){let P=[];try{Array.isArray(O.folders)&&(P=O.folders.map(y=>({folderUri:i.URI.parse(y.folderUri),remoteAuthority:y.remoteAuthority})))}catch{}return P}}),define(oe[203],ae([0,1,39,16,170]),function(V,e,i,o,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Aj=e.TokenType=void 0;var D;(function(h){h[h.LParen=0]="LParen",h[h.RParen=1]="RParen",h[h.Neg=2]="Neg",h[h.Eq=3]="Eq",h[h.NotEq=4]="NotEq",h[h.Lt=5]="Lt",h[h.LtEq=6]="LtEq",h[h.Gt=7]="Gt",h[h.GtEq=8]="GtEq",h[h.RegexOp=9]="RegexOp",h[h.RegexStr=10]="RegexStr",h[h.True=11]="True",h[h.False=12]="False",h[h.In=13]="In",h[h.Not=14]="Not",h[h.And=15]="And",h[h.Or=16]="Or",h[h.Str=17]="Str",h[h.QuotedStr=18]="QuotedStr",h[h.Error=19]="Error",h[h.EOF=20]="EOF"})(D||(e.TokenType=D={}));function O(...h){switch(h.length){case 1:return(0,S.localize)(0,null,h[0]);case 2:return(0,S.localize)(1,null,h[0],h[1]);case 3:return(0,S.localize)(2,null,h[0],h[1],h[2]);default:return}}const P=(0,S.localize)(3,null),y=(0,S.localize)(4,null);class a{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(f){switch(f.type){case D.LParen:return"(";case D.RParen:return")";case D.Neg:return"!";case D.Eq:return f.isTripleEq?"===":"==";case D.NotEq:return f.isTripleEq?"!==":"!=";case D.Lt:return"<";case D.LtEq:return"<=";case D.Gt:return">=";case D.GtEq:return">=";case D.RegexOp:return"=~";case D.RegexStr:return f.lexeme;case D.True:return"true";case D.False:return"false";case D.In:return"in";case D.Not:return"not";case D.And:return"&&";case D.Or:return"||";case D.Str:return f.lexeme;case D.QuotedStr:return f.lexeme;case D.Error:return f.lexeme;case D.EOF:return"EOF";default:throw(0,o.$0)(`unhandled token type: ${JSON.stringify(f)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(f=>f.charCodeAt(0)))}static{this.b=new Map([["not",D.Not],["in",D.In],["false",D.False],["true",D.True]])}get errors(){return this.g}reset(f){return this.c=f,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case i.CharCode.OpenParen:this.k(D.LParen);break;case i.CharCode.CloseParen:this.k(D.RParen);break;case i.CharCode.ExclamationMark:if(this.h(i.CharCode.Equals)){const g=this.h(i.CharCode.Equals);this.f.push({type:D.NotEq,offset:this.d,isTripleEq:g})}else this.k(D.Neg);break;case i.CharCode.SingleQuote:this.o();break;case i.CharCode.Slash:this.q();break;case i.CharCode.Equals:if(this.h(i.CharCode.Equals)){const g=this.h(i.CharCode.Equals);this.f.push({type:D.Eq,offset:this.d,isTripleEq:g})}else this.h(i.CharCode.Tilde)?this.k(D.RegexOp):this.l(O("==","=~"));break;case i.CharCode.LessThan:this.k(this.h(i.CharCode.Equals)?D.LtEq:D.Lt);break;case i.CharCode.GreaterThan:this.k(this.h(i.CharCode.Equals)?D.GtEq:D.Gt);break;case i.CharCode.Ampersand:this.h(i.CharCode.Ampersand)?this.k(D.And):this.l(O("&&"));break;case i.CharCode.Pipe:this.h(i.CharCode.Pipe)?this.k(D.Or):this.l(O("||"));break;case i.CharCode.Space:case i.CharCode.CarriageReturn:case i.CharCode.Tab:case i.CharCode.LineFeed:case i.CharCode.NoBreakSpace:break;default:this.n()}return this.d=this.e,this.k(D.EOF),Array.from(this.f)}h(f){return this.r()||this.c.charCodeAt(this.e)!==f?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?i.CharCode.Null:this.c.charCodeAt(this.e)}k(f){this.f.push({type:f,offset:this.d})}l(f){const g=this.d,b=this.c.substring(this.d,this.e),l={type:D.Error,offset:this.d,lexeme:b};this.g.push({offset:g,lexeme:b,additionalInfo:f}),this.f.push(l)}n(){this.m.lastIndex=this.d;const f=this.m.exec(this.c);if(f){this.e=this.d+f[0].length;const g=this.c.substring(this.d,this.e),b=a.b.get(g);b?this.k(b):this.f.push({type:D.Str,lexeme:g,offset:this.d})}}o(){for(;this.j()!==i.CharCode.SingleQuote&&!this.r();)this.i();if(this.r()){this.l(P);return}this.i(),this.f.push({type:D.QuotedStr,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let f=this.e,g=!1,b=!1;for(;;){if(f>=this.c.length){this.e=f,this.l(y);return}const m=this.c.charCodeAt(f);if(g)g=!1;else if(m===i.CharCode.Slash&&!b){f++;break}else m===i.CharCode.OpenSquareBracket?b=!0:m===i.CharCode.Backslash?g=!0:m===i.CharCode.CloseSquareBracket&&(b=!1);f++}for(;f<this.c.length&&a.a.has(this.c.charCodeAt(f));)f++;this.e=f;const l=this.c.substring(this.d,this.e);this.f.push({type:D.RegexStr,lexeme:l,offset:this.d})}r(){return this.e>=this.c.length}}e.$Aj=a}),define(oe[204],ae([0,1,3,2]),function(V,e,i,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vo=e.$Uo=void 0;class S{constructor(){this.a=new i.$me,this.b=new i.$me,this.c=new i.$me,this.d=new i.$me}static{this.ChannelName="extensionhostdebugservice"}call(P,y,a){switch(y){case"close":return Promise.resolve(this.a.fire({sessionId:a[0]}));case"reload":return Promise.resolve(this.b.fire({sessionId:a[0]}));case"terminate":return Promise.resolve(this.c.fire({sessionId:a[0]}));case"attach":return Promise.resolve(this.d.fire({sessionId:a[0],port:a[1],subId:a[2]}))}throw new Error("Method not implemented.")}listen(P,y,a){switch(y){case"close":return this.a.event;case"reload":return this.b.event;case"terminate":return this.c.event;case"attach":return this.d.event}throw new Error("Method not implemented.")}}e.$Uo=S;class D extends o.$Wc{constructor(P){super(),this.b=P}reload(P){this.b.call("reload",[P])}get onReload(){return this.b.listen("reload")}close(P){this.b.call("close",[P])}get onClose(){return this.b.listen("close")}attachSession(P,y,a){this.b.call("attach",[P,y,a])}get onAttachSession(){return this.b.listen("attach")}terminateSession(P,y){this.b.call("terminate",[P,y])}get onTerminateSession(){return this.b.listen("terminate")}openExtensionDevelopmentHostWindow(P,y){return this.b.call("openExtensionDevelopmentHostWindow",[P,y])}}e.$Vo=D}),define(oe[205],ae([0,1,154,52,13,9,36,19,7]),function(V,e,i,o,S,D,O,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5m=e.$4m=void 0,e.$6m=h,e.$7m=f,e.$4m=/^([^.]+\..+)[:=](.+)$/;class a{get appRoot(){return(0,D.$oc)(S.$Zg.asFileUri("").fsPath)}get userHome(){return y.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return y.URI.file((0,D.$lc)(this.userDataPath,"User"))}get tmpDir(){return y.URI.file(this.b.tmpDir)}get cacheHome(){return y.URI.file(this.userDataPath)}get stateResource(){return(0,P.$gh)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:S.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,P.$gh)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const b=(0,i.$3m)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,D.$lc)(this.userDataPath,"logs",b)}return y.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,P.$gh)(y.URI.file((0,D.$lc)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,P.$gh)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,P.$gh)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,P.$gh)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const b=O.env.VSCODE_PORTABLE;return b?y.URI.file((0,D.$lc)(b,"argv.json")):(0,P.$gh)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return y.URI.file((0,D.$lc)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const b=this.args["builtin-extensions-dir"];return b?(0,D.$mc)(b):(0,D.$jc)((0,D.$lc)(S.$Zg.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const b=this.args["extensions-download-dir"];return b?y.URI.file((0,D.$mc)(b)):y.URI.file((0,D.$lc)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const b=this.args["extensions-dir"];if(b)return(0,D.$mc)(b);const l=O.env.VSCODE_EXTENSIONS;if(l)return l;const m=O.env.VSCODE_PORTABLE;return m?(0,D.$lc)(m,"extensions"):(0,P.$gh)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const b=this.args.extensionDevelopmentPath;if(Array.isArray(b))return b.map(l=>/^[^:/?#]+?:\/\//.test(l)?y.URI.parse(l):y.URI.file((0,D.$jc)(l)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(b=>b==="ui"||b==="workspace"||b==="web"?b:"workspace")}get extensionTestsLocationURI(){const b=this.args.extensionTestsPath;if(b)return/^[^:/?#]+?:\/\//.test(b)?y.URI.parse(b):y.URI.file((0,D.$jc)(b))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const b=this.args["disable-extension"];if(b){if(typeof b=="string")return[b];if(Array.isArray(b)&&b.length>0)return b}return!1}get debugExtensionHost(){return h(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!O.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(b=>!e.$4m.test(b))}get extensionLogLevel(){const b=[];for(const l of this.args.log||[]){const m=e.$4m.exec(l);m&&m[1]&&m[2]&&b.push([m[1],m[2]])}return b.length?b:void 0}get serviceMachineIdResource(){return(0,P.$gh)(y.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get useInMemorySecretStorage(){return!!this.args["use-inmemory-secretstorage"]}get policyFile(){if(this.args["__enable-file-policy"]){const b=O.env.VSCODE_PORTABLE;return b?y.URI.file((0,D.$lc)(b,"policy.json")):(0,P.$gh)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(b){this.args.continueOn=b}get args(){return this.a}constructor(b,l,m){this.a=b,this.b=l,this.c=m,this.editSessionId=this.args.editSessionId}}e.$5m=a,Se([o.$0h],a.prototype,"appRoot",null),Se([o.$0h],a.prototype,"userHome",null),Se([o.$0h],a.prototype,"userDataPath",null),Se([o.$0h],a.prototype,"appSettingsHome",null),Se([o.$0h],a.prototype,"tmpDir",null),Se([o.$0h],a.prototype,"cacheHome",null),Se([o.$0h],a.prototype,"stateResource",null),Se([o.$0h],a.prototype,"userRoamingDataHome",null),Se([o.$0h],a.prototype,"userDataSyncHome",null),Se([o.$0h],a.prototype,"sync",null),Se([o.$0h],a.prototype,"machineSettingsResource",null),Se([o.$0h],a.prototype,"workspaceStorageHome",null),Se([o.$0h],a.prototype,"localHistoryHome",null),Se([o.$0h],a.prototype,"keyboardLayoutResource",null),Se([o.$0h],a.prototype,"argvResource",null),Se([o.$0h],a.prototype,"isExtensionDevelopment",null),Se([o.$0h],a.prototype,"untitledWorkspacesHome",null),Se([o.$0h],a.prototype,"builtinExtensionsPath",null),Se([o.$0h],a.prototype,"extensionsPath",null),Se([o.$0h],a.prototype,"extensionDevelopmentLocationURI",null),Se([o.$0h],a.prototype,"extensionDevelopmentKind",null),Se([o.$0h],a.prototype,"extensionTestsLocationURI",null),Se([o.$0h],a.prototype,"debugExtensionHost",null),Se([o.$0h],a.prototype,"logLevel",null),Se([o.$0h],a.prototype,"extensionLogLevel",null),Se([o.$0h],a.prototype,"serviceMachineIdResource",null),Se([o.$0h],a.prototype,"disableTelemetry",null),Se([o.$0h],a.prototype,"disableWorkspaceTrust",null),Se([o.$0h],a.prototype,"useInMemorySecretStorage",null),Se([o.$0h],a.prototype,"policyFile",null);function h(g,b){return f(g["inspect-extensions"],g["inspect-brk-extensions"],5870,b,g.debugId,g.extensionEnvironment)}function f(g,b,l,m,p,$){const v=Number(b||g)||(m?null:l),k=v?!!b:!1;let t;if($)try{t=JSON.parse($)}catch{}return{port:v,break:k,debugId:p,env:t}}});var et=this&&this.__importDefault||function(V){return V&&V.__esModule?V:{default:V}};define(oe[121],ae([0,1,316,4,173]),function(V,e,i,o,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bm=e.$Am=void 0,e.$Cm=P,e.$Dm=a,e.$Em=b,e.$Fm=l,i=et(i);const D={o:(0,S.localize)(0,null),e:(0,S.localize)(1,null),t:(0,S.localize)(2,null)};e.$Am=["tunnel","serve-web"],e.$Bm={tunnel:{type:"subcommand",description:"Make the current machine accessible from vscode.dev or other machines through a secure tunnel",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,S.localize)(3,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"},user:{type:"subcommand",options:{login:{type:"subcommand",options:{provider:{type:"string"},"access-token":{type:"string"}}}}}}},"serve-web":{type:"subcommand",description:"Run a server that displays the editor UI in browsers.",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,S.localize)(4,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"}}},diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,S.localize)(5,null)},merge:{type:"boolean",cat:"o",alias:"m",args:["path1","path2","base","result"],description:(0,S.localize)(6,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,S.localize)(7,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,S.localize)(8,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,S.localize)(9,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,S.localize)(10,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,S.localize)(11,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,S.localize)(12,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,S.localize)(13,null)},profile:{type:"string",cat:"o",args:"profileName",description:(0,S.localize)(14,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,S.localize)(15,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,S.localize)(16,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,S.localize)(17,null)},"show-versions":{type:"boolean",cat:"e",description:(0,S.localize)(18,null)},category:{type:"string",allowEmptyValue:!0,cat:"e",description:(0,S.localize)(19,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,S.localize)(20,null)},"pre-release":{type:"boolean",cat:"e",description:(0,S.localize)(21,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,S.localize)(22,null)},"update-extensions":{type:"boolean",cat:"e",description:(0,S.localize)(23,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,S.localize)(24,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,S.localize)(25,null)},verbose:{type:"boolean",cat:"t",global:!0,description:(0,S.localize)(26,null)},log:{type:"string[]",cat:"t",args:"level",global:!0,description:(0,S.localize)(27,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,S.localize)(28,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,S.localize)(29,null)},"prof-append-timers":{type:"string"},"prof-duration-markers":{type:"string[]"},"prof-duration-markers-file":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,S.localize)(30,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,S.localize)(31,null)},sync:{type:"string",cat:"t",description:(0,S.localize)(32,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,S.localize)(33,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,S.localize)(34,null)},"disable-lcd-text":{type:"boolean",cat:"t",description:(0,S.localize)(35,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,S.localize)(36,null)},"disable-chromium-sandbox":{type:"boolean",cat:"t",description:(0,S.localize)(37,null)},sandbox:{type:"boolean"},telemetry:{type:"boolean",cat:"t",description:(0,S.localize)(38,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"inspect-sharedprocess":{type:"string",allowEmptyValue:!0},"inspect-brk-sharedprocess":{type:"string",allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"use-inmemory-secretstorage":{type:"boolean",deprecates:["disable-keytar"]},"password-store":{type:"string"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"preserve-env":{type:"boolean"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},"disable-gpu-sandbox":{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},editSessionId:{type:"string"},continueOn:{type:"string"},"locate-shell-integration-path":{type:"string",args:["bash","pwsh","zsh","fish"]},"enable-coi":{type:"boolean"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},"profile-temp":{type:"boolean"},"ozone-platform":{type:"string"},"enable-tracing":{type:"string"},"trace-startup-format":{type:"string"},"trace-startup-file":{type:"string"},"trace-startup-duration":{type:"string"},_:{type:"string[]"}};const O={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function P(m,p,$=O){const w=m.find(d=>d.length>0&&d[0]!=="-"),v={},k=["_"],t=[],r={};let n;for(const d in p){const I=p[d];I.type==="subcommand"?d===w&&(n=I):(I.alias&&(v[d]=I.alias),I.type==="string"||I.type==="string[]"?(k.push(d),I.deprecates&&k.push(...I.deprecates)):I.type==="boolean"&&(t.push(d),I.deprecates&&t.push(...I.deprecates)),I.global&&(r[d]=I))}if(n&&w){const d=r;for(const T in n.options)d[T]=n.options[T];const I=m.filter(T=>T!==w),E=$.getSubcommandReporter?$.getSubcommandReporter(w):void 0,A=P(I,d,E);return{[w]:A,_:[]}}const c=(0,i.default)(m,{string:k,boolean:t,alias:v}),s={},u=c;s._=c._.map(d=>String(d)).filter(d=>d.length>0),delete u._;for(const d in p){const I=p[d];if(I.type==="subcommand")continue;I.alias&&delete u[I.alias];let E=u[d];if(I.deprecates)for(const A of I.deprecates)u.hasOwnProperty(A)&&(E||(E=u[A],E&&$.onDeprecatedOption(A,I.deprecationMessage||(0,S.localize)(39,null,d))),delete u[A]);if(typeof E<"u"){if(I.type==="string[]"){if(Array.isArray(E)||(E=[E]),!I.allowEmptyValue){const A=E.filter(T=>T.length>0);A.length!==E.length&&($.onEmptyValue(d),E=A.length>0?A:void 0)}}else I.type==="string"&&(Array.isArray(E)?(E=E.pop(),$.onMultipleValues(d,E)):!E&&!I.allowEmptyValue&&($.onEmptyValue(d),E=void 0));s[d]=E,I.deprecationMessage&&$.onDeprecatedOption(d,I.deprecationMessage)}delete u[d]}for(const d in u)$.onUnknownOption(d);return s}function y(m,p){let $="";return p.args&&(Array.isArray(p.args)?$=` <${p.args.join("> <")}>`:$=` <${p.args}>`),p.alias?`-${p.alias} --${m}${$}`:`--${m}${$}`}function a(m,p){const $=[];for(const w in m){const v=m[w],k=y(w,v);$.push([k,v.description])}return h($,p)}function h(m,p){const w=m.reduce((t,r)=>Math.max(t,r[0].length),12)+2+1;if(p-w<25)return m.reduce((t,r)=>t.concat([`  ${r[0]}`,`      ${r[1]}`]),[]);const v=p-w-1,k=[];for(const t of m){const r=t[0],n=g(t[1],v),c=f(w-r.length-2);k.push("  "+r+c+n[0]);for(let s=1;s<n.length;s++)k.push(f(w)+n[s])}return k}function f(m){return" ".repeat(m)}function g(m,p){const $=[];for(;m.length;){const w=m.length<p?m.length:m.lastIndexOf(" ",p),v=m.slice(0,w).trim();m=m.slice(w),$.push(v)}return $}function b(m,p,$,w,v){const k=process.stdout.isTTY&&process.stdout.columns||80,t=v?.noInputFiles!==!0?`[${(0,S.localize)(40,null)}...]`:"",r=[`${m} ${$}`];r.push(""),r.push(`${(0,S.localize)(41,null)}: ${p} [${(0,S.localize)(42,null)}]${t}`),r.push(""),v?.noPipe!==!0&&(o.$i?r.push((0,S.localize)(43,null,p)):r.push((0,S.localize)(44,null,p)),r.push(""));const n={},c=[];for(const s in w){const u=w[s];if(u.type==="subcommand")u.description&&c.push({command:s,description:u.description});else if(u.description&&u.cat){let d=n[u.cat];d||(n[u.cat]=d={}),d[s]=u}}for(const s in n){const u=s,d=n[u];d&&(r.push(D[u]),r.push(...a(d,k)),r.push(""))}return c.length&&(r.push((0,S.localize)(45,null)),r.push(...h(c.map(s=>[s.command,s.description]),k)),r.push("")),r.join(`
`)}function l(m,p){return`${m||(0,S.localize)(46,null)}
${p||(0,S.localize)(47,null)}
${process.arch}`}});var et=this&&this.__importDefault||function(V){return V&&V.__esModule?V:{default:V}};define(oe[68],ae([0,1,317,174,121]),function(V,e,i,o,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gm=P,e.$Hm=y,e.$Im=a,e.$Jm=h,i=et(i);function D(f,g){const b=(v,k)=>{console.warn((0,o.localize)(0,null,v,k))},l=v=>{console.warn((0,o.localize)(1,null,v))},m=(v,k)=>{console.warn((0,o.localize)(2,null,v,k))},p=v=>({onUnknownOption:k=>{S.$Am.includes(v)||console.warn((0,o.localize)(3,null,k,v))},onMultipleValues:b,onEmptyValue:l,onDeprecatedOption:m,getSubcommandReporter:S.$Am.includes(v)?p:void 0}),$={onUnknownOption:v=>{console.warn((0,o.localize)(4,null,v))},onMultipleValues:b,onEmptyValue:l,onDeprecatedOption:m,getSubcommandReporter:p},w=(0,S.$Cm)(f,S.$Bm,g?$:void 0);return w.goto&&w._.forEach(v=>(0,i.default)(/^(\w:)?[^:]+(:\d*){0,2}:?$/.test(v),(0,o.localize)(5,null))),w}function O(f){const g=f.findIndex(b=>!/^-/.test(b));if(g>-1)return[...f.slice(0,g),...f.slice(g+1)]}function P(f){let[,...g]=f;process.env.VSCODE_DEV&&(g=O(g)||[]);const b=!h(process.env);return D(g,b)}function y(f){let[,,...g]=f;return process.env.VSCODE_DEV&&(g=O(g)||[]),D(g,!0)}function a(f,...g){const b=f.indexOf("--");return b===-1?f.push(...g):f.splice(b,0,...g),f}function h(f){return f.VSCODE_CLI==="1"}}),function(){"use strict";function V(e,i,o){function S(O,P){const y=D(O,P),a=[y];return e.isAbsolute(y)||a.unshift(o),e.resolve(...a)}function D(O,P){process.env.VSCODE_DEV&&(P="code-oss-dev");const y=process.env.VSCODE_PORTABLE;if(y)return e.join(y,"user-data");let a=process.env.VSCODE_APPDATA;if(a)return e.join(a,P);const h=O["user-data-dir"];if(h)return h;switch(process.platform){case"win32":if(a=process.env.APPDATA,!a){const f=process.env.USERPROFILE;if(typeof f!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");a=e.join(f,"AppData","Roaming")}break;case"darwin":a=e.join(i.homedir(),"Library","Application Support");break;case"linux":a=process.env.XDG_CONFIG_HOME||e.join(i.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(a,P)}return{getUserDataPath:S}}if(typeof define=="function")define(oe[206],ae([122,27,36]),function(e,i,o){return V(e,i,o.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),i=require("os");module.exports=V(e,i,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(oe[95],ae([0,1,27,205,206]),function(V,e,i,o,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8m=void 0,e.$9m=O,e.$0m=P;class D extends o.$5m{constructor(a,h){super(a,{homeDir:(0,i.homedir)(),tmpDir:(0,i.tmpdir)(),userDataDir:(0,S.getUserDataPath)(a,h.nameShort)},h)}}e.$8m=D;function O(y,a){return(0,o.$7m)(y["inspect-ptyhost"],y["inspect-brk-ptyhost"],5877,a,y.extensionEnvironment)}function P(y,a){return(0,o.$7m)(y["inspect-sharedprocess"],y["inspect-brk-sharedprocess"],5879,a,y.extensionEnvironment)}}),define(oe[207],ae([0,1,47,27,31]),function(V,e,i,o,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jgc=D;function D(O){const P=(0,S.$Ng)((0,o.tmpdir)());try{return(0,i.writeFileSync)(P,""),O&&console.log(`Marker file for --wait created: ${P}`),P}catch(y){O&&console.error(`Failed to create marker file for --wait: ${y}`);return}}}),define(oe[208],ae([0,1,12,176]),function(V,e,i,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fq=S;function S(O,P,y,a){try{D(O,P,y,a)}catch(h){O.error(h?.message??h)}return P}function D(O,P,y,a){const h=(f,g,b)=>{const l=f[g];if((0,i.$fg)(l)){const m=l,p=m.length;if(p>1&&m[0]==="%"&&m[p-1]==="%"){const $=m.substr(1,p-2);let w=y[$];w===void 0&&a&&(w=a[$]);const v=typeof w=="string"?w:w?.message,k=a?.[$],t=typeof k=="string"?k:k?.message;if(!v){t||O.warn(`[${P.name}]: ${(0,o.localize)(0,null,$)}`);return}if(b&&(g==="title"||g==="category")&&t&&t!==v){const r={value:v,original:t};f[g]=r}else f[g]=v}}else if((0,i.$hg)(l))for(const m in l)l.hasOwnProperty(m)&&(m==="commands"?h(l,m,!0):h(l,m,b));else if(Array.isArray(l))for(let m=0;m<l.length;m++)h(l,m,b)};for(const f in P)P.hasOwnProperty(f)&&h(P,f)}});var et=this&&this.__importDefault||function(V){return V&&V.__esModule?V:{default:V}};define(oe[209],ae([0,1,19,79,178,210]),function(V,e,i,o,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tp=y,e.$Up=a,e.$Vp=h,e.$Wp=f,e.$Xp=g,e.$Yp=b,e.$Zp=l,o=et(o),S=Re(S),D=Re(D);const O=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,P=/^-(\d{4})(\d{2})(\d{2})$/;function y($){return $=$.trim(),$==="*"||O.test($)}function a($){if(!y($))return null;if($=$.trim(),$==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const w=$.match(O);return w?{hasCaret:w[1]==="^",hasGreaterEquals:w[1]===">=",majorBase:w[2]==="x"?0:parseInt(w[2],10),majorMustEqual:w[2]!=="x",minorBase:w[4]==="x"?0:parseInt(w[4],10),minorMustEqual:w[4]!=="x",patchBase:w[6]==="x"?0:parseInt(w[6],10),patchMustEqual:w[6]!=="x",preRelease:w[8]||null}:null}function h($){if(!$)return null;const w=$.majorBase,v=$.majorMustEqual,k=$.minorBase;let t=$.minorMustEqual;const r=$.patchBase;let n=$.patchMustEqual;$.hasCaret&&(w===0||(t=!1),n=!1);let c=0;if($.preRelease){const s=P.exec($.preRelease);if(s){const[,u,d,I]=s;c=Date.UTC(Number(u),Number(d)-1,Number(I))}}return{majorBase:w,majorMustEqual:v,minorBase:k,minorMustEqual:t,patchBase:r,patchMustEqual:n,isMinimum:$.hasGreaterEquals,notBefore:c}}function f($,w,v){let k;typeof $=="string"?k=h(a($)):k=$;let t;w instanceof Date?t=w.getTime():typeof w=="string"&&(t=new Date(w).getTime());let r;if(typeof v=="string"?r=h(a(v)):r=v,!k||!r)return!1;const n=k.majorBase,c=k.minorBase,s=k.patchBase;let u=r.majorBase,d=r.minorBase,I=r.patchBase;const E=r.notBefore;let A=r.majorMustEqual,T=r.minorMustEqual,L=r.patchMustEqual;return r.isMinimum?n>u?!0:n<u?!1:c>d?!0:c<d||t&&t<E?!1:s>=I:(n===1&&u===0&&(!A||!T||!L)&&(u=1,d=0,I=0,A=!0,T=!1,L=!1),n<u?!1:n>u?!A:c<d?!1:c>d?!T:s<I?!1:s>I?!L:!(t&&t<E))}function g($,w,v,k,t){const r=[];if(typeof k.publisher<"u"&&typeof k.publisher!="string")return r.push([o.default.Error,S.localize(0,null)]),r;if(typeof k.name!="string")return r.push([o.default.Error,S.localize(1,null,"name")]),r;if(typeof k.version!="string")return r.push([o.default.Error,S.localize(2,null,"version")]),r;if(!k.engines)return r.push([o.default.Error,S.localize(3,null,"engines")]),r;if(typeof k.engines.vscode!="string")return r.push([o.default.Error,S.localize(4,null,"engines.vscode")]),r;if(typeof k.extensionDependencies<"u"&&!p(k.extensionDependencies))return r.push([o.default.Error,S.localize(5,null,"extensionDependencies")]),r;if(typeof k.activationEvents<"u"){if(!p(k.activationEvents))return r.push([o.default.Error,S.localize(6,null,"activationEvents")]),r;if(typeof k.main>"u"&&typeof k.browser>"u")return r.push([o.default.Error,S.localize(7,null,"activationEvents","main","browser")]),r}if(typeof k.extensionKind<"u"&&typeof k.main>"u"&&r.push([o.default.Warning,S.localize(8,null,"extensionKind")]),typeof k.main<"u"){if(typeof k.main!="string")return r.push([o.default.Error,S.localize(9,null,"main")]),r;{const s=(0,i.$gh)(v,k.main);(0,i.$ah)(s,v)||r.push([o.default.Warning,S.localize(10,null,s.path,v.path)])}}if(typeof k.browser<"u"){if(typeof k.browser!="string")return r.push([o.default.Error,S.localize(11,null,"browser")]),r;{const s=(0,i.$gh)(v,k.browser);(0,i.$ah)(s,v)||r.push([o.default.Warning,S.localize(12,null,s.path,v.path)])}}if(!D.valid(k.version))return r.push([o.default.Error,S.localize(13,null)]),r;const n=[];if(!b($,w,k,t,n))for(const s of n)r.push([o.default.Error,s]);return r}function b($,w,v,k,t){return k||typeof v.main>"u"&&typeof v.browser>"u"?!0:m($,w,v.engines.vscode,t)}function l($,w,v){return $==="*"||m(w,v,$)}function m($,w,v,k=[]){const t=h(a(v));if(!t)return k.push(S.localize(14,null,v)),!1;if(t.majorBase===0){if(!t.majorMustEqual||!t.minorMustEqual)return k.push(S.localize(15,null,v)),!1}else if(!t.majorMustEqual)return k.push(S.localize(16,null,v)),!1;return f($,w,t)?!0:(k.push(S.localize(17,null,$,v)),!1)}function p($){if(!Array.isArray($))return!1;for(let w=0,v=$.length;w<v;w++)if(typeof $[w]!="string")return!1;return!0}}),define(oe[82],ae([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ci=void 0;class i{constructor(S,D=[],O=!1){this.ctor=S,this.staticArguments=D,this.supportsDelayedInstantiation=O}}e.$Ci=i}),define(oe[211],ae([0,1,82]),function(V,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationType=void 0,e.$Ks=D,e.$Ls=O;const o=[];var S;(function(P){P[P.Eager=0]="Eager",P[P.Delayed=1]="Delayed"})(S||(e.InstantiationType=S={}));function D(P,y,a){y instanceof i.$Ci||(y=new i.$Ci(y,[],!!a)),o.push([P,y])}function O(){return o}}),define(oe[212],ae([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$or=e.$nr=void 0;class i{constructor(D,O){this.key=D,this.data=O,this.incoming=new Map,this.outgoing=new Map}}e.$nr=i;class o{constructor(D){this.b=D,this.a=new Map}roots(){const D=[];for(const O of this.a.values())O.outgoing.size===0&&D.push(O);return D}insertEdge(D,O){const P=this.lookupOrInsertNode(D),y=this.lookupOrInsertNode(O);P.outgoing.set(y.key,y),y.incoming.set(P.key,P)}removeNode(D){const O=this.b(D);this.a.delete(O);for(const P of this.a.values())P.outgoing.delete(O),P.incoming.delete(O)}lookupOrInsertNode(D){const O=this.b(D);let P=this.a.get(O);return P||(P=new i(O,D),this.a.set(O,P)),P}lookup(D){return this.a.get(this.b(D))}isEmpty(){return this.a.size===0}toString(){const D=[];for(const[O,P]of this.a)D.push(`${O}
	(-> incoming)[${[...P.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...P.outgoing.keys()].join(",")}]
`);return D.join(`
`)}findCycleSlow(){for(const[D,O]of this.a){const P=new Set([D]),y=this.c(O,P);if(y)return y}}c(D,O){for(const[P,y]of D.outgoing){if(O.has(P))return[...O,P].join(" -> ");O.add(P);const a=this.c(y,O);if(a)return a;O.delete(P)}}}e.$or=o}),define(oe[6],ae([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ei=e._util=void 0,e.$Fi=S,e.$Gi=D;var i;(function(O){O.serviceIds=new Map,O.DI_TARGET="$di$target",O.DI_DEPENDENCIES="$di$dependencies";function P(y){return y[O.DI_DEPENDENCIES]||[]}O.getServiceDependencies=P})(i||(e._util=i={})),e.$Ei=S("instantiationService");function o(O,P,y){P[i.DI_TARGET]===P?P[i.DI_DEPENDENCIES].push({id:O,index:y}):(P[i.DI_DEPENDENCIES]=[{id:O,index:y}],P[i.DI_TARGET]=P)}function S(O){if(i.serviceIds.has(O))return i.serviceIds.get(O);const P=function(y,a,h){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");o(P,y,h)};return P.toString=()=>O,i.serviceIds.set(O,P),P}function D(O){return O}}),define(oe[83],ae([0,1,6]),function(V,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gfc=void 0,e.$gfc=(0,i.$Fi)("auxiliaryWindowsMainService")}),define(oe[69],ae([0,1,6]),function(V,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pec=void 0,e.$pec=(0,i.$Fi)("backupMainService")}),define(oe[18],ae([0,1,12,7,6]),function(V,e,i,o,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationTarget=e.$_i=void 0,e.$aj=D,e.$bj=O,e.$cj=y,e.$dj=a,e.$ej=h,e.$fj=f,e.$gj=g,e.$hj=l,e.$ij=m,e.$jj=p,i=Re(i),e.$_i=(0,S.$Fi)("configurationService");function D($){return $&&typeof $=="object"&&(!$.overrideIdentifier||typeof $.overrideIdentifier=="string")&&(!$.resource||$.resource instanceof o.URI)}function O($){return $&&typeof $=="object"&&(!$.overrideIdentifiers||Array.isArray($.overrideIdentifiers))&&!$.overrideIdentifier&&(!$.resource||$.resource instanceof o.URI)}var P;(function($){$[$.APPLICATION=1]="APPLICATION",$[$.USER=2]="USER",$[$.USER_LOCAL=3]="USER_LOCAL",$[$.USER_REMOTE=4]="USER_REMOTE",$[$.WORKSPACE=5]="WORKSPACE",$[$.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",$[$.DEFAULT=7]="DEFAULT",$[$.MEMORY=8]="MEMORY"})(P||(e.ConfigurationTarget=P={}));function y($){switch($){case P.APPLICATION:return"APPLICATION";case P.USER:return"USER";case P.USER_LOCAL:return"USER_LOCAL";case P.USER_REMOTE:return"USER_REMOTE";case P.WORKSPACE:return"WORKSPACE";case P.WORKSPACE_FOLDER:return"WORKSPACE_FOLDER";case P.DEFAULT:return"DEFAULT";case P.MEMORY:return"MEMORY"}}function a($){return $.applicationValue!==void 0||$.userValue!==void 0||$.userLocalValue!==void 0||$.userRemoteValue!==void 0||$.workspaceValue!==void 0||$.workspaceFolderValue!==void 0}function h($,w){const v=Object.create(null);for(const k in $)f(v,k,$[k],w);return v}function f($,w,v,k){const t=w.split("."),r=t.pop();let n=$;for(let c=0;c<t.length;c++){const s=t[c];let u=n[s];switch(typeof u){case"undefined":u=n[s]=Object.create(null);break;case"object":if(u===null){k(`Ignoring ${w} as ${t.slice(0,c+1).join(".")} is null`);return}break;default:k(`Ignoring ${w} as ${t.slice(0,c+1).join(".")} is ${JSON.stringify(u)}`);return}n=u}if(typeof n=="object"&&n!==null)try{n[r]=v}catch{k(`Ignoring ${w} as ${t.join(".")} is ${JSON.stringify(n)}`)}else k(`Ignoring ${w} as ${t.join(".")} is ${JSON.stringify(n)}`)}function g($,w){const v=w.split(".");b($,v)}function b($,w){const v=w.shift();if(w.length===0){delete $[v];return}if(Object.keys($).indexOf(v)!==-1){const k=$[v];typeof k=="object"&&!Array.isArray(k)&&(b(k,w),Object.keys(k).length===0&&delete $[v])}}function l($,w,v){function k(n,c){let s=n;for(const u of c){if(typeof s!="object"||s===null)return;s=s[u]}return s}const t=w.split("."),r=k($,t);return typeof r>"u"?v:r}function m($,w,v){Object.keys(w).forEach(k=>{k!=="__proto__"&&(k in $?i.$hg($[k])&&i.$hg(w[k])?m($[k],w[k],v):v&&($[k]=w[k]):$[k]=w[k])})}function p($){return $.replace(/[\[\]]/g,"")}}),define(oe[123],ae([0,1,39,4,26,203,6,169,16]),function(V,e,i,o,S,D,O,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xj=e.$Wj=e.$Vj=e.$Uj=e.$Tj=e.$Sj=e.$Rj=e.$Qj=e.$Pj=e.$Oj=e.$Nj=e.$Mj=e.$Lj=e.$Kj=e.$Jj=e.$Ij=e.$Hj=e.$Gj=e.$Dj=e.$Cj=e.ContextKeyExprType=void 0,e.$Bj=h,e.$Ej=c,e.$Fj=s,e.$Yj=G;const a=new Map;a.set("false",!1),a.set("true",!0),a.set("isMac",o.$j),a.set("isLinux",o.$k),a.set("isWindows",o.$i),a.set("isWeb",o.$o),a.set("isMacNative",o.$j&&!o.$o),a.set("isEdge",o.$H),a.set("isFirefox",o.$F),a.set("isChrome",o.$E),a.set("isSafari",o.$G);function h(_,F){if(a.get(_)!==void 0)throw(0,y.$9)("contextkey.setConstant(k, v) invoked with already set constant `k`");a.set(_,F)}const f=Object.prototype.hasOwnProperty;var g;(function(_){_[_.False=0]="False",_[_.True=1]="True",_[_.Defined=2]="Defined",_[_.Not=3]="Not",_[_.Equals=4]="Equals",_[_.NotEquals=5]="NotEquals",_[_.And=6]="And",_[_.Regex=7]="Regex",_[_.NotRegex=8]="NotRegex",_[_.Or=9]="Or",_[_.In=10]="In",_[_.NotIn=11]="NotIn",_[_.Greater=12]="Greater",_[_.GreaterEquals=13]="GreaterEquals",_[_.Smaller=14]="Smaller",_[_.SmallerEquals=15]="SmallerEquals"})(g||(e.ContextKeyExprType=g={}));const b={regexParsingWithErrorRecovery:!0},l=(0,P.localize)(0,null),m=(0,P.localize)(1,null),p=(0,P.localize)(2,null),$=(0,P.localize)(3,null),w=(0,P.localize)(4,null),v=(0,P.localize)(5,null),k=(0,P.localize)(6,null),t=(0,P.localize)(7,null);class r{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(F=b){this.k=F,this.d=new D.$Aj,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(F){if(F===""){this.h.push({message:l,offset:0,lexeme:"",additionalInfo:m});return}this.f=this.d.reset(F).scan(),this.g=0,this.h=[];try{const C=this.l();if(!this.E()){const W=this.D(),q=W.type===D.TokenType.Str?v:void 0;throw this.h.push({message:w,offset:W.offset,lexeme:D.$Aj.getLexeme(W),additionalInfo:q}),r.c}return C}catch(C){if(C!==r.c)throw C;return}}l(){return this.m()}m(){const F=[this.o()];for(;this.y(D.TokenType.Or);){const C=this.o();F.push(C)}return F.length===1?F[0]:n.or(...F)}o(){const F=[this.s()];for(;this.y(D.TokenType.And);){const C=this.s();F.push(C)}return F.length===1?F[0]:n.and(...F)}s(){if(this.y(D.TokenType.Neg)){const F=this.D();switch(F.type){case D.TokenType.True:return this.z(),d.INSTANCE;case D.TokenType.False:return this.z(),I.INSTANCE;case D.TokenType.LParen:{this.z();const C=this.l();return this.A(D.TokenType.RParen,$),C?.negate()}case D.TokenType.Str:return this.z(),M.create(F.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",F)}}return this.t()}t(){const F=this.D();switch(F.type){case D.TokenType.True:return this.z(),n.true();case D.TokenType.False:return this.z(),n.false();case D.TokenType.LParen:{this.z();const C=this.l();return this.A(D.TokenType.RParen,$),C}case D.TokenType.Str:{const C=F.lexeme;if(this.z(),this.y(D.TokenType.RegexOp)){const q=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),q.type!==D.TokenType.RegexStr)throw this.B("REGEX",q);const J=q.lexeme,X=J.lastIndexOf("/"),Z=X===J.length-1?void 0:this.w(J.substring(X+1));let ie;try{ie=new RegExp(J.substring(1,X),Z)}catch{throw this.B("REGEX",q)}return le.create(C,ie)}switch(q.type){case D.TokenType.RegexStr:case D.TokenType.Error:{const J=[q.lexeme];this.z();let X=this.D(),Z=0;for(let Ie=0;Ie<q.lexeme.length;Ie++)q.lexeme.charCodeAt(Ie)===i.CharCode.OpenParen?Z++:q.lexeme.charCodeAt(Ie)===i.CharCode.CloseParen&&Z--;for(;!this.E()&&X.type!==D.TokenType.And&&X.type!==D.TokenType.Or;){switch(X.type){case D.TokenType.LParen:Z++;break;case D.TokenType.RParen:Z--;break;case D.TokenType.RegexStr:case D.TokenType.QuotedStr:for(let Ie=0;Ie<X.lexeme.length;Ie++)X.lexeme.charCodeAt(Ie)===i.CharCode.OpenParen?Z++:q.lexeme.charCodeAt(Ie)===i.CharCode.CloseParen&&Z--}if(Z<0)break;J.push(D.$Aj.getLexeme(X)),this.z(),X=this.D()}const ie=J.join(""),de=ie.lastIndexOf("/"),me=de===ie.length-1?void 0:this.w(ie.substring(de+1));let pe;try{pe=new RegExp(ie.substring(1,de),me)}catch{throw this.B("REGEX",q)}return n.regex(C,pe)}case D.TokenType.QuotedStr:{const J=q.lexeme;this.z();let X=null;if(!(0,S.$df)(J)){const Z=J.indexOf("/"),ie=J.lastIndexOf("/");if(Z!==ie&&Z>=0){const de=J.slice(Z+1,ie),me=J[ie+1]==="i"?"i":"";try{X=new RegExp(de,me)}catch{throw this.B("REGEX",q)}}}if(X===null)throw this.B("REGEX",q);return le.create(C,X)}default:throw this.B("REGEX",this.D())}}if(this.y(D.TokenType.Not)){this.A(D.TokenType.In,p);const q=this.u();return n.notIn(C,q)}switch(this.D().type){case D.TokenType.Eq:{this.z();const q=this.u();if(this.x().type===D.TokenType.QuotedStr)return n.equals(C,q);switch(q){case"true":return n.has(C);case"false":return n.not(C);default:return n.equals(C,q)}}case D.TokenType.NotEq:{this.z();const q=this.u();if(this.x().type===D.TokenType.QuotedStr)return n.notEquals(C,q);switch(q){case"true":return n.not(C);case"false":return n.has(C);default:return n.notEquals(C,q)}}case D.TokenType.Lt:return this.z(),ne.create(C,this.u());case D.TokenType.LtEq:return this.z(),Q.create(C,this.u());case D.TokenType.Gt:return this.z(),N.create(C,this.u());case D.TokenType.GtEq:return this.z(),z.create(C,this.u());case D.TokenType.In:return this.z(),n.in(C,this.u());default:return n.has(C)}}case D.TokenType.EOF:throw this.h.push({message:k,offset:F.offset,lexeme:"",additionalInfo:t}),r.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const F=this.D();switch(F.type){case D.TokenType.Str:case D.TokenType.QuotedStr:return this.z(),F.lexeme;case D.TokenType.True:return this.z(),"true";case D.TokenType.False:return this.z(),"false";case D.TokenType.In:return this.z(),"in";default:return""}}w(F){return F.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(F){return this.C(F)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(F,C){if(this.C(F))return this.z();throw this.B(C,this.D())}B(F,C,W){const q=(0,P.localize)(8,null,F,D.$Aj.getLexeme(C)),J=C.offset,X=D.$Aj.getLexeme(C);return this.h.push({message:q,offset:J,lexeme:X,additionalInfo:W}),r.c}C(F){return this.D().type===F}D(){return this.f[this.g]}E(){return this.D().type===D.TokenType.EOF}}e.$Cj=r;class n{static false(){return d.INSTANCE}static true(){return I.INSTANCE}static has(F){return E.create(F)}static equals(F,C){return A.create(F,C)}static notEquals(F,C){return R.create(F,C)}static regex(F,C){return le.create(F,C)}static in(F,C){return T.create(F,C)}static notIn(F,C){return L.create(F,C)}static not(F){return M.create(F)}static and(...F){return H.create(F,null,!0)}static or(...F){return j.create(F,null,!0)}static greater(F,C){return N.create(F,C)}static greaterEquals(F,C){return z.create(F,C)}static smaller(F,C){return ne.create(F,C)}static smallerEquals(F,C){return Q.create(F,C)}static{this.c=new r({regexParsingWithErrorRecovery:!1})}static deserialize(F){return F==null?void 0:this.c.parse(F)}}e.$Dj=n;function c(_){const F=new r({regexParsingWithErrorRecovery:!1});return _.map(C=>(F.parse(C),F.lexingErrors.length>0?F.lexingErrors.map(W=>({errorMessage:W.additionalInfo?(0,P.localize)(9,null,W.additionalInfo):(0,P.localize)(10,null),offset:W.offset,length:W.lexeme.length})):F.parsingErrors.length>0?F.parsingErrors.map(W=>({errorMessage:W.additionalInfo?`${W.message}. ${W.additionalInfo}`:W.message,offset:W.offset,length:W.lexeme.length})):[]))}function s(_,F){const C=_?_.substituteConstants():void 0,W=F?F.substituteConstants():void 0;return!C&&!W?!0:!C||!W?!1:C.equals(W)}function u(_,F){return _.cmp(F)}class d{static{this.INSTANCE=new d}constructor(){this.type=g.False}cmp(F){return this.type-F.type}equals(F){return F.type===this.type}substituteConstants(){return this}evaluate(F){return!1}serialize(){return"false"}keys(){return[]}map(F){return this}negate(){return I.INSTANCE}}e.$Gj=d;class I{static{this.INSTANCE=new I}constructor(){this.type=g.True}cmp(F){return this.type-F.type}equals(F){return F.type===this.type}substituteConstants(){return this}evaluate(F){return!0}serialize(){return"true"}keys(){return[]}map(F){return this}negate(){return d.INSTANCE}}e.$Hj=I;class E{static create(F,C=null){const W=a.get(F);return typeof W=="boolean"?W?I.INSTANCE:d.INSTANCE:new E(F,C)}constructor(F,C){this.key=F,this.c=C,this.type=g.Defined}cmp(F){return F.type!==this.type?this.type-F.type:x(this.key,F.key)}equals(F){return F.type===this.type?this.key===F.key:!1}substituteConstants(){const F=a.get(this.key);return typeof F=="boolean"?F?I.INSTANCE:d.INSTANCE:this}evaluate(F){return!!F.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(F){return F.mapDefined(this.key)}negate(){return this.c||(this.c=M.create(this.key,this)),this.c}}e.$Ij=E;class A{static create(F,C,W=null){if(typeof C=="boolean")return C?E.create(F,W):M.create(F,W);const q=a.get(F);return typeof q=="boolean"?C===(q?"true":"false")?I.INSTANCE:d.INSTANCE:new A(F,C,W)}constructor(F,C,W){this.c=F,this.d=C,this.f=W,this.type=g.Equals}cmp(F){return F.type!==this.type?this.type-F.type:ce(this.c,this.d,F.c,F.d)}equals(F){return F.type===this.type?this.c===F.c&&this.d===F.d:!1}substituteConstants(){const F=a.get(this.c);if(typeof F=="boolean"){const C=F?"true":"false";return this.d===C?I.INSTANCE:d.INSTANCE}return this}evaluate(F){return F.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(F){return F.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=R.create(this.c,this.d,this)),this.f}}e.$Jj=A;class T{static create(F,C){return new T(F,C)}constructor(F,C){this.d=F,this.f=C,this.type=g.In,this.c=null}cmp(F){return F.type!==this.type?this.type-F.type:ce(this.d,this.f,F.d,F.f)}equals(F){return F.type===this.type?this.d===F.d&&this.f===F.f:!1}substituteConstants(){return this}evaluate(F){const C=F.getValue(this.f),W=F.getValue(this.d);return Array.isArray(C)?C.includes(W):typeof W=="string"&&typeof C=="object"&&C!==null?f.call(C,W):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(F){return F.mapIn(this.d,this.f)}negate(){return this.c||(this.c=L.create(this.d,this.f)),this.c}}e.$Kj=T;class L{static create(F,C){return new L(F,C)}constructor(F,C){this.d=F,this.f=C,this.type=g.NotIn,this.c=T.create(F,C)}cmp(F){return F.type!==this.type?this.type-F.type:this.c.cmp(F.c)}equals(F){return F.type===this.type?this.c.equals(F.c):!1}substituteConstants(){return this}evaluate(F){return!this.c.evaluate(F)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(F){return F.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Lj=L;class R{static create(F,C,W=null){if(typeof C=="boolean")return C?M.create(F,W):E.create(F,W);const q=a.get(F);return typeof q=="boolean"?C===(q?"true":"false")?d.INSTANCE:I.INSTANCE:new R(F,C,W)}constructor(F,C,W){this.c=F,this.d=C,this.f=W,this.type=g.NotEquals}cmp(F){return F.type!==this.type?this.type-F.type:ce(this.c,this.d,F.c,F.d)}equals(F){return F.type===this.type?this.c===F.c&&this.d===F.d:!1}substituteConstants(){const F=a.get(this.c);if(typeof F=="boolean"){const C=F?"true":"false";return this.d===C?d.INSTANCE:I.INSTANCE}return this}evaluate(F){return F.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(F){return F.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=A.create(this.c,this.d,this)),this.f}}e.$Mj=R;class M{static create(F,C=null){const W=a.get(F);return typeof W=="boolean"?W?d.INSTANCE:I.INSTANCE:new M(F,C)}constructor(F,C){this.c=F,this.d=C,this.type=g.Not}cmp(F){return F.type!==this.type?this.type-F.type:x(this.c,F.c)}equals(F){return F.type===this.type?this.c===F.c:!1}substituteConstants(){const F=a.get(this.c);return typeof F=="boolean"?F?d.INSTANCE:I.INSTANCE:this}evaluate(F){return!F.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(F){return F.mapNot(this.c)}negate(){return this.d||(this.d=E.create(this.c,this)),this.d}}e.$Nj=M;function U(_,F){if(typeof _=="string"){const C=parseFloat(_);isNaN(C)||(_=C)}return typeof _=="string"||typeof _=="number"?F(_):d.INSTANCE}class N{static create(F,C,W=null){return U(C,q=>new N(F,q,W))}constructor(F,C,W){this.c=F,this.d=C,this.f=W,this.type=g.Greater}cmp(F){return F.type!==this.type?this.type-F.type:ce(this.c,this.d,F.c,F.d)}equals(F){return F.type===this.type?this.c===F.c&&this.d===F.d:!1}substituteConstants(){return this}evaluate(F){return typeof this.d=="string"?!1:parseFloat(F.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(F){return F.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=Q.create(this.c,this.d,this)),this.f}}e.$Oj=N;class z{static create(F,C,W=null){return U(C,q=>new z(F,q,W))}constructor(F,C,W){this.c=F,this.d=C,this.f=W,this.type=g.GreaterEquals}cmp(F){return F.type!==this.type?this.type-F.type:ce(this.c,this.d,F.c,F.d)}equals(F){return F.type===this.type?this.c===F.c&&this.d===F.d:!1}substituteConstants(){return this}evaluate(F){return typeof this.d=="string"?!1:parseFloat(F.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(F){return F.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=ne.create(this.c,this.d,this)),this.f}}e.$Pj=z;class ne{static create(F,C,W=null){return U(C,q=>new ne(F,q,W))}constructor(F,C,W){this.c=F,this.d=C,this.f=W,this.type=g.Smaller}cmp(F){return F.type!==this.type?this.type-F.type:ce(this.c,this.d,F.c,F.d)}equals(F){return F.type===this.type?this.c===F.c&&this.d===F.d:!1}substituteConstants(){return this}evaluate(F){return typeof this.d=="string"?!1:parseFloat(F.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(F){return F.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=z.create(this.c,this.d,this)),this.f}}e.$Qj=ne;class Q{static create(F,C,W=null){return U(C,q=>new Q(F,q,W))}constructor(F,C,W){this.c=F,this.d=C,this.f=W,this.type=g.SmallerEquals}cmp(F){return F.type!==this.type?this.type-F.type:ce(this.c,this.d,F.c,F.d)}equals(F){return F.type===this.type?this.c===F.c&&this.d===F.d:!1}substituteConstants(){return this}evaluate(F){return typeof this.d=="string"?!1:parseFloat(F.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(F){return F.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=N.create(this.c,this.d,this)),this.f}}e.$Rj=Q;class le{static create(F,C){return new le(F,C)}constructor(F,C){this.d=F,this.f=C,this.type=g.Regex,this.c=null}cmp(F){if(F.type!==this.type)return this.type-F.type;if(this.d<F.d)return-1;if(this.d>F.d)return 1;const C=this.f?this.f.source:"",W=F.f?F.f.source:"";return C<W?-1:C>W?1:0}equals(F){if(F.type===this.type){const C=this.f?this.f.source:"",W=F.f?F.f.source:"";return this.d===F.d&&C===W}return!1}substituteConstants(){return this}evaluate(F){const C=F.getValue(this.d);return this.f?this.f.test(C):!1}serialize(){const F=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${F}`}keys(){return[this.d]}map(F){return F.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=K.create(this)),this.c}}e.$Sj=le;class K{static create(F){return new K(F)}constructor(F){this.c=F,this.type=g.NotRegex}cmp(F){return F.type!==this.type?this.type-F.type:this.c.cmp(F.c)}equals(F){return F.type===this.type?this.c.equals(F.c):!1}substituteConstants(){return this}evaluate(F){return!this.c.evaluate(F)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(F){return new K(this.c.map(F))}negate(){return this.c}}e.$Tj=K;function ee(_){let F=null;for(let C=0,W=_.length;C<W;C++){const q=_[C].substituteConstants();if(_[C]!==q&&F===null){F=[];for(let J=0;J<C;J++)F[J]=_[J]}F!==null&&(F[C]=q)}return F===null?_:F}class H{static create(F,C,W){return H.d(F,C,W)}constructor(F,C){this.expr=F,this.c=C,this.type=g.And}cmp(F){if(F.type!==this.type)return this.type-F.type;if(this.expr.length<F.expr.length)return-1;if(this.expr.length>F.expr.length)return 1;for(let C=0,W=this.expr.length;C<W;C++){const q=u(this.expr[C],F.expr[C]);if(q!==0)return q}return 0}equals(F){if(F.type===this.type){if(this.expr.length!==F.expr.length)return!1;for(let C=0,W=this.expr.length;C<W;C++)if(!this.expr[C].equals(F.expr[C]))return!1;return!0}return!1}substituteConstants(){const F=ee(this.expr);return F===this.expr?this:H.create(F,this.c,!1)}evaluate(F){for(let C=0,W=this.expr.length;C<W;C++)if(!this.expr[C].evaluate(F))return!1;return!0}static d(F,C,W){const q=[];let J=!1;for(const X of F)if(X){if(X.type===g.True){J=!0;continue}if(X.type===g.False)return d.INSTANCE;if(X.type===g.And){q.push(...X.expr);continue}q.push(X)}if(q.length===0&&J)return I.INSTANCE;if(q.length!==0){if(q.length===1)return q[0];q.sort(u);for(let X=1;X<q.length;X++)q[X-1].equals(q[X])&&(q.splice(X,1),X--);if(q.length===1)return q[0];for(;q.length>1;){const X=q[q.length-1];if(X.type!==g.Or)break;q.pop();const Z=q.pop(),ie=q.length===0,de=j.create(X.expr.map(me=>H.create([me,Z],null,W)),null,ie);de&&(q.push(de),q.sort(u))}if(q.length===1)return q[0];if(W){for(let X=0;X<q.length;X++)for(let Z=X+1;Z<q.length;Z++)if(q[X].negate().equals(q[Z]))return d.INSTANCE;if(q.length===1)return q[0]}return new H(q,C)}}serialize(){return this.expr.map(F=>F.serialize()).join(" && ")}keys(){const F=[];for(const C of this.expr)F.push(...C.keys());return F}map(F){return new H(this.expr.map(C=>C.map(F)),null)}negate(){if(!this.c){const F=[];for(const C of this.expr)F.push(C.negate());this.c=j.create(F,this,!0)}return this.c}}e.$Uj=H;class j{static create(F,C,W){return j.d(F,C,W)}constructor(F,C){this.expr=F,this.c=C,this.type=g.Or}cmp(F){if(F.type!==this.type)return this.type-F.type;if(this.expr.length<F.expr.length)return-1;if(this.expr.length>F.expr.length)return 1;for(let C=0,W=this.expr.length;C<W;C++){const q=u(this.expr[C],F.expr[C]);if(q!==0)return q}return 0}equals(F){if(F.type===this.type){if(this.expr.length!==F.expr.length)return!1;for(let C=0,W=this.expr.length;C<W;C++)if(!this.expr[C].equals(F.expr[C]))return!1;return!0}return!1}substituteConstants(){const F=ee(this.expr);return F===this.expr?this:j.create(F,this.c,!1)}evaluate(F){for(let C=0,W=this.expr.length;C<W;C++)if(this.expr[C].evaluate(F))return!0;return!1}static d(F,C,W){let q=[],J=!1;if(F){for(let X=0,Z=F.length;X<Z;X++){const ie=F[X];if(ie){if(ie.type===g.False){J=!0;continue}if(ie.type===g.True)return I.INSTANCE;if(ie.type===g.Or){q=q.concat(ie.expr);continue}q.push(ie)}}if(q.length===0&&J)return d.INSTANCE;q.sort(u)}if(q.length!==0){if(q.length===1)return q[0];for(let X=1;X<q.length;X++)q[X-1].equals(q[X])&&(q.splice(X,1),X--);if(q.length===1)return q[0];if(W){for(let X=0;X<q.length;X++)for(let Z=X+1;Z<q.length;Z++)if(q[X].negate().equals(q[Z]))return I.INSTANCE;if(q.length===1)return q[0]}return new j(q,C)}}serialize(){return this.expr.map(F=>F.serialize()).join(" || ")}keys(){const F=[];for(const C of this.expr)F.push(...C.keys());return F}map(F){return new j(this.expr.map(C=>C.map(F)),null)}negate(){if(!this.c){const F=[];for(const C of this.expr)F.push(C.negate());for(;F.length>1;){const C=F.shift(),W=F.shift(),q=[];for(const J of se(C))for(const X of se(W))q.push(H.create([J,X],null,!1));F.unshift(j.create(q,null,!1))}this.c=j.create(F,this,!0)}return this.c}}e.$Vj=j;class B extends E{static{this.d=[]}static all(){return B.d.values()}constructor(F,C,W){super(F,null),this.f=C,typeof W=="object"?B.d.push({...W,key:F}):W!==!0&&B.d.push({key:F,description:W,type:C!=null?typeof C:void 0})}bindTo(F){return F.createKey(this.key,this.f)}getValue(F){return F.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(F){return A.create(this.key,F)}notEqualsTo(F){return R.create(this.key,F)}}e.$Wj=B,e.$Xj=(0,O.$Fi)("contextKeyService");function x(_,F){return _<F?-1:_>F?1:0}function ce(_,F,C,W){return _<C?-1:_>C?1:F<W?-1:F>W?1:0}function G(_,F){if(_.type===g.False||F.type===g.True)return!0;if(_.type===g.Or)return F.type===g.Or?he(_.expr,F.expr):!1;if(F.type===g.Or){for(const C of F.expr)if(G(_,C))return!0;return!1}if(_.type===g.And){if(F.type===g.And)return he(F.expr,_.expr);for(const C of _.expr)if(G(C,F))return!0;return!1}return _.equals(F)}function he(_,F){let C=0,W=0;for(;C<_.length&&W<F.length;){const q=_[C].cmp(F[W]);if(q<0)return!1;q===0&&C++,W++}return C===_.length}function se(_){return _.type===g.Or?_.expr:[_]}}),define(oe[96],ae([0,1,6]),function(V,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Um=e.$Sm=e.ID=void 0,e.$Tm=o,e.ID="diagnosticsService",e.$Sm=(0,i.$Fi)(e.ID);function o(D){return!!D.hostName&&!!D.errorMessage}class S{async getPerformanceInfo(O,P){return{}}async getSystemInfo(O,P){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(O,P){return""}async getWorkspaceFileExtensions(O){return{extensions:[]}}async reportWorkspaceStats(O){}}e.$Um=S});var et=this&&this.__importDefault||function(V){return V&&V.__esModule?V:{default:V}};define(oe[124],ae([0,1,19,79,171,6,48,4,35]),function(V,e,i,o,S,D,O,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfirmResult=e.$4w=e.$3w=e.$2w=void 0,e.$5w=b,e.$6w=l,o=et(o),e.$2w=(0,D.$Fi)("dialogService");var a;(function(m){m[m.Confirmation=1]="Confirmation",m[m.Prompt=2]="Prompt",m[m.Input=3]="Input"})(a||(a={}));class h{a(p){return this.d(p,a.Confirmation)}b(p){return this.d(p,a.Prompt)}c(p){return this.d(p,a.Input)}d(p,$){const w=[];switch($){case a.Confirmation:{const v=p;v.primaryButton?w.push(v.primaryButton):w.push((0,S.localize)(0,null)),v.cancelButton?w.push(v.cancelButton):w.push((0,S.localize)(1,null));break}case a.Prompt:{const v=p;Array.isArray(v.buttons)&&v.buttons.length>0&&w.push(...v.buttons.map(k=>k.label)),v.cancelButton&&(v.cancelButton===!0?w.push((0,S.localize)(2,null)):typeof v.cancelButton=="string"?w.push(v.cancelButton):v.cancelButton.label?w.push(v.cancelButton.label):w.push((0,S.localize)(3,null))),w.length===0&&w.push((0,S.localize)(4,null));break}case a.Input:{const v=p;v.primaryButton?w.push(v.primaryButton):w.push((0,S.localize)(5,null)),v.cancelButton?w.push(v.cancelButton):w.push((0,S.localize)(6,null));break}}return w}e(p){if(typeof p=="string")return p;if(typeof p=="number")return p===o.default.Info?"info":p===o.default.Error?"error":p===o.default.Warning?"warning":"none"}f(p,$,w){const v=[...p.buttons??[]];p.cancelButton&&typeof p.cancelButton!="string"&&typeof p.cancelButton!="boolean"&&v.push(p.cancelButton);let k=v[$]?.run({checkboxChecked:w});return k instanceof Promise||(k=Promise.resolve(k)),{result:k,checkboxChecked:w}}}e.$3w=h,e.$4w=(0,D.$Fi)("fileDialogService");var f;(function(m){m[m.SAVE=0]="SAVE",m[m.DONT_SAVE=1]="DONT_SAVE",m[m.CANCEL=2]="CANCEL"})(f||(e.ConfirmResult=f={}));const g=10;function b(m){const p=[];return p.push(...m.slice(0,g).map($=>typeof $=="string"?$:(0,i.$dh)($))),m.length>g&&(m.length-g===1?p.push((0,S.localize)(7,null)):p.push((0,S.localize)(8,null,m.length-g))),p.push(""),p.join(`
`)}function l(m,p){const $=(0,y.$bo)(m);let w=($.buttons??[]).map(r=>(0,O.$Yw)(r)),v=(m.buttons||[]).map((r,n)=>n),k=0,t=$.cancelId??w.length-1;if(w.length>1){const r=typeof t=="number"?w[t]:void 0;if(P.$k||P.$j){if(typeof r=="string"&&w.length>1&&t!==1){w.splice(t,1),w.splice(1,0,r);const n=v[t];v.splice(t,1),v.splice(1,0,n),t=1}P.$k&&w.length>1&&(w=w.reverse(),v=v.reverse(),k=w.length-1,typeof r=="string"&&(t=k-1))}else if(P.$i&&typeof r=="string"&&w.length>1&&t!==w.length-1){w.splice(t,1),w.push(r);const n=v[t];v.splice(t,1),v.push(n),t=w.length-1}}return $.buttons=w,$.defaultId=k,$.cancelId=t,$.noLink=!0,$.title=$.title||p.nameLong,{options:$,buttonIndeces:v}}}),define(oe[97],ae([0,1,6]),function(V,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KnownStorageProvider=e.PasswordStoreCLIOption=e.$kY=e.$jY=void 0,e.$lY=D,e.$mY=O,e.$jY=(0,i.$Fi)("encryptionService"),e.$kY=(0,i.$Fi)("encryptionMainService");var o;(function(P){P.kwallet="kwallet",P.kwallet5="kwallet5",P.gnomeLibsecret="gnome-libsecret",P.basic="basic"})(o||(e.PasswordStoreCLIOption=o={}));var S;(function(P){P.unknown="unknown",P.basicText="basic_text",P.gnomeAny="gnome_any",P.gnomeLibsecret="gnome_libsecret",P.gnomeKeyring="gnome_keyring",P.kwallet="kwallet",P.kwallet5="kwallet5",P.kwallet6="kwallet6",P.dplib="dpapi",P.keychainAccess="keychain_access"})(S||(e.KnownStorageProvider=S={}));function D(P){return P===S.kwallet||P===S.kwallet5||P===S.kwallet6}function O(P){return P===S.gnomeAny||P===S.gnomeLibsecret||P===S.gnomeKeyring}}),define(oe[38],ae([0,1,6]),function(V,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ni=e.$Mi=void 0,e.$Mi=(0,i.$Fi)("environmentService"),e.$Ni=(0,i.$Gi)(e.$Mi)}),define(oe[213],ae([0,1,6]),function(V,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9ec=e.$8ec=void 0,e.$8ec=(0,i.$Fi)("extensionHostStarter"),e.$9ec="extensionHostStarter"}),define(oe[214],ae([0,1,6]),function(V,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$o9b=e.$n9b=void 0,e.$n9b=(0,i.$Fi)("externalTerminal"),e.$o9b="Terminal.app"}),define(oe[215],ae([0,1,6]),function(V,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$ec=void 0,e.$$ec=(0,i.$Fi)("externalTerminal")}),define(oe[216],ae([0,1,49,52,13,9,4,80,21,94,179,214]),function(V,e,i,o,S,D,O,P,y,a,h,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bfc=e.$afc=e.$_ec=void 0,i=Re(i),D=Re(D),O=Re(O),y=Re(y),a=Re(a),h=Re(h);const g=h.localize(0,null);class b{async getDefaultTerminalForPlatforms(){return{windows:l.getDefaultTerminalWindows(),linux:await p.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class l extends b{static{this.b="cmd.exe"}openTerminal(t,r){return this.spawnTerminal(i,t,a.$xm(),r)}spawnTerminal(t,r,n,c){const s=r.windowsExec||l.getDefaultTerminalWindows();c&&c[1]===":"&&(c=c[0].toUpperCase()+c.substr(1));const u=D.$pc(s,".exe").toLowerCase();if(u==="cmder")return t.spawn(s,c?[c]:void 0),Promise.resolve(void 0);const d=["/c","start","/wait"];return s.indexOf(" ")>=0&&d.push('""'),d.push(s),u==="wt"&&d.push("-d ."),new Promise((I,E)=>{const A=$(process),T=t.spawn(n,d,{cwd:c,env:A,detached:!0});T.on("error",E),T.on("exit",()=>I())})}async runInTerminal(t,r,n,c,s){const u="windowsExec"in s&&s.windowsExec?s.windowsExec:l.getDefaultTerminalWindows(),d=await l.f();return new Promise((I,E)=>{const A=`"${r} - ${g}"`,T=`"${n.join('" "')}" & pause`,L=Object.assign({},$(process),c);Object.keys(L).filter(z=>L[z]===null).forEach(z=>delete L[z]);const R={cwd:r,env:L,windowsVerbatimArguments:!0};let M,U;D.$pc(u,".exe")==="wt"?(M=u,U=["-d",".",l.b,"/c",T]):d?(M=d,U=["-d",".",u,"/c",T]):(M=l.b,U=["/c","start",A,"/wait",u,"/c",`"${T}"`]),i.spawn(M,U,R).on("error",z=>{E(w(z))}),I(void 0)})}static getDefaultTerminalWindows(){if(!l.d){const t=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");l.d=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${t?"Sysnative":"System32"}\\cmd.exe`}return l.d}static async f(){try{const t=await a.win32.findExecutable("wt");return await y.Promises.exists(t)?t:void 0}catch{return}}}e.$_ec=l,Se([o.$0h],l,"f",null);class m extends b{static{this.b="/usr/bin/osascript"}openTerminal(t,r){return this.spawnTerminal(i,t,r)}runInTerminal(t,r,n,c,s){const u=s.osxExec||f.$o9b;return new Promise((d,I)=>{if(u===f.$o9b||u==="iTerm.app"){const E=u===f.$o9b?"TerminalHelper":"iTermHelper",T=[S.$Zg.asFileUri(`vs/workbench/contrib/externalTerminal/node/${E}.scpt`).fsPath,"-t",t||g,"-w",r];for(const M of n)T.push("-a"),T.push(M);if(c){const M=Object.assign({},$(process),c);for(const U in M){const N=M[U];N===null?(T.push("-u"),T.push(U)):(T.push("-e"),T.push(`${U}=${N}`))}}let L="";const R=i.spawn(m.b,T);R.on("error",M=>{I(w(M))}),R.stderr.on("data",M=>{L+=M.toString()}),R.on("exit",M=>{if(M===0)d(void 0);else if(L){const U=L.split(`
`,1);I(new Error(U[0]))}else I(new Error(h.localize(1,null,E,M)))})}else I(new Error(h.localize(2,null,u)))})}spawnTerminal(t,r,n){const c=r.osxExec||f.$o9b;return new Promise((s,u)=>{const d=["-a",c];n&&d.push(n);const I=$(process),E=t.spawn("/usr/bin/open",d,{cwd:n,env:I});E.on("error",u),E.on("exit",()=>s())})}}e.$afc=m;class p extends b{static{this.b=h.localize(3,null)}openTerminal(t,r){return this.spawnTerminal(i,t,r)}runInTerminal(t,r,n,c,s){const u=s.linuxExec?Promise.resolve(s.linuxExec):p.getDefaultTerminalLinuxReady();return new Promise((d,I)=>{const E=[];u.then(A=>{A.indexOf("gnome-terminal")>=0?E.push("-x"):E.push("-e"),E.push("bash"),E.push("-c");const T=`${v(n)}; echo; read -p "${p.b}" -n1;`;E.push(`''${T}''`);const L=Object.assign({},$(process),c);Object.keys(L).filter(N=>L[N]===null).forEach(N=>delete L[N]);const R={cwd:r,env:L};let M="";const U=i.spawn(A,E,R);U.on("error",N=>{I(w(N))}),U.stderr.on("data",N=>{M+=N.toString()}),U.on("exit",N=>{if(N===0)d(void 0);else if(M){const z=M.split(`
`,1);I(new Error(z[0]))}else I(new Error(h.localize(4,null,A,N)))})})})}static async getDefaultTerminalLinuxReady(){if(!p.d)if(!O.$k)p.d=Promise.resolve("xterm");else{const t=await y.Promises.exists("/etc/debian_version");p.d=new Promise(r=>{t?r("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?r("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?r("konsole"):process.env.COLORTERM?r(process.env.COLORTERM):process.env.TERM?r(process.env.TERM):r("xterm")})}return p.d}spawnTerminal(t,r,n){const c=r.linuxExec?Promise.resolve(r.linuxExec):p.getDefaultTerminalLinuxReady();return new Promise((s,u)=>{c.then(d=>{const I=$(process),E=t.spawn(d,[],{cwd:n,env:I});E.on("error",u),E.on("exit",()=>s())})})}}e.$bfc=p;function $(k){const t={...k.env};return(0,P.$km)(t),t}function w(k){return"errno"in k&&k.errno==="ENOENT"&&"path"in k&&typeof k.path=="string"?new Error(h.localize(5,null,k.path)):k}function v(k){let t="";for(const r of k)r.indexOf(" ")>=0?t+='"'+r+'"':t+=r,t+=" ";return t}}),define(oe[15],ae([0,1,61,9,26,12,7,181,6,4,13,65]),function(V,e,i,o,S,D,O,P,y,a,h,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hl=e.$El=e.FileKind=e.$Dl=e.$Cl=e.$Bl=e.$Al=e.$zl=e.$yl=e.$xl=e.FileOperationResult=e.$wl=e.$vl=e.$ul=e.$sl=e.FileChangeType=e.$rl=e.FileOperation=e.$ll=e.FileSystemProviderErrorCode=e.FileSystemProviderCapabilities=e.FileChangeFilter=e.FilePermission=e.FileType=e.$_k=void 0,e.$al=g,e.$bl=p,e.$cl=w,e.$dl=v,e.$el=k,e.$fl=t,e.$gl=r,e.$hl=n,e.$il=c,e.$jl=s,e.$kl=u,e.$ml=E,e.$nl=A,e.$ol=T,e.$pl=L,e.$ql=R,e.$tl=ne,e.$Fl=j,e.$Gl=B,e.$Il=ce,e.$_k=(0,y.$Fi)("fileService");function g(G){return G.create===!0}var b;(function(G){G[G.Unknown=0]="Unknown",G[G.File=1]="File",G[G.Directory=2]="Directory",G[G.SymbolicLink=64]="SymbolicLink"})(b||(e.FileType=b={}));var l;(function(G){G[G.Readonly=1]="Readonly",G[G.Locked=2]="Locked"})(l||(e.FilePermission=l={}));var m;(function(G){G[G.UPDATED=2]="UPDATED",G[G.ADDED=4]="ADDED",G[G.DELETED=8]="DELETED"})(m||(e.FileChangeFilter=m={}));function p(G){const he=G;return!!he&&typeof he.onDidChange=="function"}var $;(function(G){G[G.None=0]="None",G[G.FileReadWrite=2]="FileReadWrite",G[G.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",G[G.FileReadStream=16]="FileReadStream",G[G.FileFolderCopy=8]="FileFolderCopy",G[G.PathCaseSensitive=1024]="PathCaseSensitive",G[G.Readonly=2048]="Readonly",G[G.Trash=4096]="Trash",G[G.FileWriteUnlock=8192]="FileWriteUnlock",G[G.FileAtomicRead=16384]="FileAtomicRead",G[G.FileAtomicWrite=32768]="FileAtomicWrite",G[G.FileAtomicDelete=65536]="FileAtomicDelete",G[G.FileClone=131072]="FileClone"})($||(e.FileSystemProviderCapabilities=$={}));function w(G){return!!(G.capabilities&$.FileReadWrite)}function v(G){return!!(G.capabilities&$.FileFolderCopy)}function k(G){return!!(G.capabilities&$.FileClone)}function t(G){return!!(G.capabilities&$.FileOpenReadWriteClose)}function r(G){return!!(G.capabilities&$.FileReadStream)}function n(G){return w(G)?!!(G.capabilities&$.FileAtomicRead):!1}function c(G){return w(G)?!!(G.capabilities&$.FileAtomicWrite):!1}function s(G){return!!(G.capabilities&$.FileAtomicDelete)}function u(G){return!!(G.capabilities&$.Readonly)}var d;(function(G){G.FileExists="EntryExists",G.FileNotFound="EntryNotFound",G.FileNotADirectory="EntryNotADirectory",G.FileIsADirectory="EntryIsADirectory",G.FileExceedsStorageQuota="EntryExceedsStorageQuota",G.FileTooLarge="EntryTooLarge",G.FileWriteLocked="EntryWriteLocked",G.NoPermissions="NoPermissions",G.Unavailable="Unavailable",G.Unknown="Unknown"})(d||(e.FileSystemProviderErrorCode=d={}));class I extends Error{static create(he,se){const _=new I(he.toString(),se);return T(_,se),_}constructor(he,se){super(he),this.code=se}}e.$ll=I;function E(G,he){return I.create(G,he)}function A(G){return G||E((0,P.localize)(0,null),d.Unknown)}function T(G,he){return G.name=he?`${he} (FileSystemError)`:"FileSystemError",G}function L(G){if(!G)return d.Unknown;if(G instanceof I)return G.code;const he=/^(.+) \(FileSystemError\)$/.exec(G.name);if(!he)return d.Unknown;switch(he[1]){case d.FileExists:return d.FileExists;case d.FileIsADirectory:return d.FileIsADirectory;case d.FileNotADirectory:return d.FileNotADirectory;case d.FileNotFound:return d.FileNotFound;case d.FileTooLarge:return d.FileTooLarge;case d.FileWriteLocked:return d.FileWriteLocked;case d.NoPermissions:return d.NoPermissions;case d.Unavailable:return d.Unavailable}return d.Unknown}function R(G){if(G instanceof Q)return G.fileOperationResult;switch(L(G)){case d.FileNotFound:return ee.FILE_NOT_FOUND;case d.FileIsADirectory:return ee.FILE_IS_DIRECTORY;case d.FileNotADirectory:return ee.FILE_NOT_DIRECTORY;case d.FileWriteLocked:return ee.FILE_WRITE_LOCKED;case d.NoPermissions:return ee.FILE_PERMISSION_DENIED;case d.FileExists:return ee.FILE_MOVE_CONFLICT;case d.FileTooLarge:return ee.FILE_TOO_LARGE;default:return ee.FILE_OTHER_ERROR}}var M;(function(G){G[G.CREATE=0]="CREATE",G[G.DELETE=1]="DELETE",G[G.MOVE=2]="MOVE",G[G.COPY=3]="COPY",G[G.WRITE=4]="WRITE"})(M||(e.FileOperation=M={}));class U{constructor(he,se,_){this.resource=he,this.operation=se,this.target=_}isOperation(he){return this.operation===he}}e.$rl=U;var N;(function(G){G[G.UPDATED=0]="UPDATED",G[G.ADDED=1]="ADDED",G[G.DELETED=2]="DELETED"})(N||(e.FileChangeType=N={}));class z{static{this.a=null}constructor(he,se){this.c=se,this.b=void 0,this.d=new f.$X(()=>{const _=i.$Li.forUris(()=>this.c);return _.fill(this.rawAdded.map(F=>[F,!0])),_}),this.f=new f.$X(()=>{const _=i.$Li.forUris(()=>this.c);return _.fill(this.rawUpdated.map(F=>[F,!0])),_}),this.g=new f.$X(()=>{const _=i.$Li.forUris(()=>this.c);return _.fill(this.rawDeleted.map(F=>[F,!0])),_}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const _ of he){switch(_.type){case N.ADDED:this.rawAdded.push(_.resource);break;case N.UPDATED:this.rawUpdated.push(_.resource);break;case N.DELETED:this.rawDeleted.push(_.resource);break}this.b!==z.a&&(typeof _.cId=="number"?this.b===void 0?this.b=_.cId:this.b!==_.cId&&(this.b=z.a):this.b!==void 0&&(this.b=z.a))}}contains(he,...se){return this.h(he,{includeChildren:!1},...se)}affects(he,...se){return this.h(he,{includeChildren:!0},...se)}h(he,se,..._){if(!he)return!1;const F=_.length>0;return!!((!F||_.includes(N.ADDED))&&(this.d.value.get(he)||se.includeChildren&&this.d.value.findSuperstr(he))||(!F||_.includes(N.UPDATED))&&(this.f.value.get(he)||se.includeChildren&&this.f.value.findSuperstr(he))||(!F||_.includes(N.DELETED))&&(this.g.value.findSubstr(he)||se.includeChildren&&this.g.value.findSuperstr(he)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(he){return this.b===he}hasCorrelation(){return typeof this.b=="number"}}e.$sl=z;function ne(G,he,se){return!G||!he||G===he||he.length>G.length?!1:(he.charAt(he.length-1)!==o.sep&&(he+=o.sep),se?(0,S.$Hf)(G,he):G.indexOf(he)===0)}class Q extends Error{constructor(he,se,_){super(he),this.fileOperationResult=se,this.options=_}}e.$ul=Q;class le extends Q{constructor(he,se,_,F){super(he,se,F),this.fileOperationResult=se,this.size=_}}e.$vl=le;class K extends Q{constructor(he,se,_){super(he,ee.FILE_NOT_MODIFIED_SINCE,_),this.stat=se}}e.$wl=K;var ee;(function(G){G[G.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",G[G.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",G[G.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",G[G.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",G[G.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",G[G.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",G[G.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",G[G.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",G[G.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",G[G.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",G[G.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(ee||(e.FileOperationResult=ee={})),e.$xl={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$yl={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$zl="files.associations",e.$Al="files.exclude",e.$Bl="files.readonlyInclude",e.$Cl="files.readonlyExclude",e.$Dl="files.readonlyFromPermissions";var H;(function(G){G[G.FILE=0]="FILE",G[G.FOLDER=1]="FOLDER",G[G.ROOT_FOLDER=2]="ROOT_FOLDER"})(H||(e.FileKind=H={})),e.$El="";function j(G){if(!(typeof G.size!="number"||typeof G.mtime!="number"))return G.mtime.toString(29)+G.size.toString(31)}async function B(G,he){if(!he.hasProvider(O.URI.from({scheme:G.scheme})))return new Promise(se=>{const _=he.onDidChangeFileSystemProviderRegistrations(F=>{F.scheme===G.scheme&&F.added&&(_.dispose(),se())})})}class x{static{this.KB=1024}static{this.MB=x.KB*x.KB}static{this.GB=x.MB*x.KB}static{this.TB=x.GB*x.KB}static formatSize(he){return(0,D.$jg)(he)||(he=0),he<x.KB?(0,P.localize)(1,null,he.toFixed(0)):he<x.MB?(0,P.localize)(2,null,(he/x.KB).toFixed(2)):he<x.GB?(0,P.localize)(3,null,(he/x.MB).toFixed(2)):he<x.TB?(0,P.localize)(4,null,(he/x.GB).toFixed(2)):(0,P.localize)(5,null,(he/x.TB).toFixed(2))}}e.$Hl=x;function ce(G){const he=typeof G=="string"||G?.scheme===h.Schemas.vscodeRemote;return typeof G!="string"&&G?.scheme===h.Schemas.file?1024*x.MB:he?10*x.MB:a.$o?50*x.MB:1024*x.MB}}),define(oe[125],ae([0,1,17,16,182,15]),function(V,e,i,o,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uq=O;async function O(h,f,g,b,l,m){let p;try{await P(h,f,g,b,l,m)}catch($){p=$}finally{p&&l.errorTransformer&&(p=l.errorTransformer(p)),typeof p<"u"&&g.error(p),g.end()}}async function P(h,f,g,b,l,m){y(m);const p=await h.open(f,{create:!1});try{y(m);let $=0,w=0,v=l&&typeof l.length=="number"?l.length:void 0,k=i.$Oe.alloc(Math.min(l.bufferSize,typeof v=="number"?v:l.bufferSize)),t=l&&typeof l.position=="number"?l.position:0,r=0;do w=await h.read(p,t,k.buffer,r,k.byteLength-r),t+=w,r+=w,$+=w,typeof v=="number"&&(v-=w),r===k.byteLength&&(await g.write(b(k)),k=i.$Oe.alloc(Math.min(l.bufferSize,typeof v=="number"?v:l.bufferSize)),r=0);while(w>0&&(typeof v!="number"||v>0)&&y(m)&&a($,l));if(r>0){let n=r;typeof v=="number"&&(n=Math.min(r,v)),g.write(b(k.slice(0,n)))}}catch($){throw(0,D.$nl)($)}finally{await h.close(p)}}function y(h){if(h.isCancellationRequested)throw(0,o.$8)();return!0}function a(h,f){if(typeof f?.limits?.size=="number"&&h>f.limits.size)throw(0,D.$ml)((0,S.localize)(0,null),D.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(oe[62],ae([0,1,113,2,9,4,7,15]),function(V,e,i,o,S,D,O,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1q=e.$Zq=e.$Yq=void 0,e.$Wq=y,e.$Xq=a,e.$2q=b,e.$3q=l,e.$4q=m,e.$5q=p,e.$6q=w,e.$7q=v;function y(k){return typeof k.correlationId=="number"}function a(k){return k.recursive===!0}class h extends o.$Wc{static{this.a=5}constructor(t,r,n,c){super(),this.h=t,this.j=r,this.m=n,this.n=c,this.c=this.B(new o.$Xc),this.f=void 0,this.g=0}s(){const t=new o.$Vc;this.c.value=t,this.b=this.r(t),this.b.setVerboseLogging(this.m),t.add(this.b.onDidChangeFile(r=>this.h(r))),t.add(this.b.onDidLogMessage(r=>this.j(r))),t.add(this.b.onDidError(r=>this.t(r.error,r.request)))}t(t,r){this.u(t,r)?this.g<h.a&&this.f?(this.y(`restarting watcher after unexpected error: ${t}`),this.w(this.f)):this.y(`gave up attempting to restart watcher after unexpected error: ${t}`):this.y(t)}u(t,r){return!(!this.n.restartOnError||r||t.indexOf("No space left on device")!==-1||t.indexOf("EMFILE")!==-1)}w(t){this.g++,this.s(),this.watch(t)}async watch(t){this.f=t,await this.b?.watch(t)}async setVerboseLogging(t){this.m=t,await this.b?.setVerboseLogging(t)}y(t){this.j({type:"error",message:`[File Watcher (${this.n.type})] ${t}`})}z(t){this.j({type:"trace",message:`[File Watcher (${this.n.type})] ${t}`})}dispose(){return this.b=void 0,super.dispose()}}e.$Yq=h;class f extends h{constructor(t,r,n){super(t,r,n,{type:"node.js",restartOnError:!1})}}e.$Zq=f;class g extends h{constructor(t,r,n){super(t,r,n,{type:"universal",restartOnError:!0})}}e.$1q=g;function b(k){return k.map(t=>({type:t.type,resource:O.URI.revive(t.resource),cId:t.cId}))}function l(k){const t=new $;for(const r of k)t.processEvent(r);return t.coalesce()}function m(k,t){return typeof t=="string"&&!t.startsWith(i.$vk)&&!(0,S.$kc)(t)?{base:k,pattern:t}:t}function p(k,t){const r=[];for(const n of t)r.push((0,i.$zk)(m(k,n)));return r}class ${constructor(){this.a=new Set,this.b=new Map}c(t){return D.$k?t.resource.fsPath:t.resource.fsPath.toLowerCase()}processEvent(t){const r=this.b.get(this.c(t));let n=!1;if(r){const c=r.type,s=t.type;r.resource.fsPath!==t.resource.fsPath&&(t.type===P.FileChangeType.DELETED||t.type===P.FileChangeType.ADDED)?n=!0:c===P.FileChangeType.ADDED&&s===P.FileChangeType.DELETED?(this.b.delete(this.c(t)),this.a.delete(r)):c===P.FileChangeType.DELETED&&s===P.FileChangeType.ADDED?r.type=P.FileChangeType.UPDATED:c===P.FileChangeType.ADDED&&s===P.FileChangeType.UPDATED||(r.type=s)}else n=!0;n&&(this.a.add(t),this.b.set(this.c(t),t))}coalesce(){const t=[],r=[];return Array.from(this.a).filter(n=>n.type!==P.FileChangeType.DELETED?(t.push(n),!1):!0).sort((n,c)=>n.resource.fsPath.length-c.resource.fsPath.length).filter(n=>r.some(c=>(0,P.$tl)(n.resource.fsPath,c,!D.$k))?!1:(r.push(n.resource.fsPath),!0)).concat(t)}}function w(k,t){if(typeof t=="number")switch(k.type){case P.FileChangeType.ADDED:return(t&P.FileChangeFilter.ADDED)===0;case P.FileChangeType.DELETED:return(t&P.FileChangeFilter.DELETED)===0;case P.FileChangeType.UPDATED:return(t&P.FileChangeFilter.UPDATED)===0}return!1}function v(k){if(typeof k=="number"){const t=[];return k&P.FileChangeFilter.ADDED&&t.push("Added"),k&P.FileChangeFilter.DELETED&&t.push("Deleted"),k&P.FileChangeFilter.UPDATED&&t.push("Updated"),t.length===0?"<all>":`[${t.join(", ")}]`}return"<none>"}}),define(oe[217],ae([0,1,17,53,16,3,2,67,33,15,62]),function(V,e,i,o,S,D,O,P,y,a,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7Q=e.$6Q=void 0,e.$6Q="localFilesystem";class f extends O.$Wc{constructor(b,l){super(),this.a=b,this.b=l,this.onDidChangeCapabilities=D.Event.None,this.f=this.B(new D.$me),this.onDidChangeFile=this.f.event,this.g=this.B(new D.$me),this.onDidWatchError=this.g.event,this.h=(0,y.$2g)(),this.j()}get capabilities(){return this.c||(this.c=a.FileSystemProviderCapabilities.FileReadWrite|a.FileSystemProviderCapabilities.FileOpenReadWriteClose|a.FileSystemProviderCapabilities.FileReadStream|a.FileSystemProviderCapabilities.FileFolderCopy|a.FileSystemProviderCapabilities.FileWriteUnlock|a.FileSystemProviderCapabilities.FileAtomicRead|a.FileSystemProviderCapabilities.FileAtomicWrite|a.FileSystemProviderCapabilities.FileAtomicDelete|a.FileSystemProviderCapabilities.FileClone,this.b.pathCaseSensitive&&(this.c|=a.FileSystemProviderCapabilities.PathCaseSensitive),this.b.trash&&(this.c|=a.FileSystemProviderCapabilities.Trash)),this.c}stat(b){return this.a.call("stat",[b])}readdir(b){return this.a.call("readdir",[b])}async readFile(b,l){const{buffer:m}=await this.a.call("readFile",[b,l]);return m}readFileStream(b,l,m){const p=(0,P.$Ce)(w=>i.$Oe.concat(w.map(v=>i.$Oe.wrap(v))).buffer),$=new O.$Vc;return $.add(this.a.listen("readFileStream",[b,l])(w=>{if(w instanceof i.$Oe)p.write(w.buffer);else{if(w==="end")p.end();else{let v;if(w instanceof Error)v=w;else{const k=w;v=(0,a.$ml)(k.message??(0,o.$qj)(k),k.code??a.FileSystemProviderErrorCode.Unknown)}p.error(v),p.end()}$.dispose()}})),$.add(m.onCancellationRequested(()=>{p.error((0,S.$8)()),p.end(),$.dispose()})),p}writeFile(b,l,m){return this.a.call("writeFile",[b,i.$Oe.wrap(l),m])}open(b,l){return this.a.call("open",[b,l])}close(b){return this.a.call("close",[b])}async read(b,l,m,p,$){const[w,v]=await this.a.call("read",[b,l,$]);return m.set(w.buffer.slice(0,v),p),v}write(b,l,m,p,$){return this.a.call("write",[b,l,i.$Oe.wrap(m),p,$])}mkdir(b){return this.a.call("mkdir",[b])}delete(b,l){return this.a.call("delete",[b,l])}rename(b,l,m){return this.a.call("rename",[b,l,m])}copy(b,l,m){return this.a.call("copy",[b,l,m])}cloneFile(b,l){return this.a.call("cloneFile",[b,l])}j(){this.B(this.a.listen("fileChange",[this.h])(b=>{if(Array.isArray(b)){const l=b;this.f.fire((0,h.$2q)(l))}else{const l=b;this.g.fire(l)}}))}watch(b,l){const m=(0,y.$2g)();return this.a.call("watch",[this.h,m,b,l]),(0,O.$Uc)(()=>this.a.call("unwatch",[this.h,m]))}}e.$7Q=f}),define(oe[218],ae([0,1,47,2,62,3,15,7,8]),function(V,e,i,o,S,D,O,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dr=void 0;class a extends o.$Wc{constructor(){super(),this.a=this.B(new D.$me),this.onDidChangeFile=this.a.event,this.b=this.B(new D.$me),this.onDidLogMessage=this.b.event,this.c=this.B(new D.$me),this.f=this.c.event,this.g=new Set,this.h=new Map,this.j=this.B(new o.$6c),this.m=new Set,this.n=this.B(new y.$Dh(this.y())),this.r=5007,this.s=new y.$3h,this.R=!1,this.B(this.f(f=>this.t(f)))}t(f){this.u(f)&&this.z(f)}u(f){return(0,S.$Wq)(f)}async watch(f){this.s.isSettled||this.s.complete(),this.s=new y.$3h;try{this.h.clear(),this.g.clear();for(const g of f)this.u(g)?this.h.set(g.correlationId,g):this.g.add(g);for(const[g]of this.j)this.h.has(g)||(this.j.deleteAndDispose(g),this.m.delete(g));return await this.w(!1)}finally{this.s.complete()}}w(f){return this.n.trigger(()=>this.N([...this.g,...Array.from(this.h.values()).filter(g=>!this.j.has(g.correlationId))]),f?this.y():0)}y(){return 800}isSuspended(f){return typeof f.correlationId!="number"?!1:this.m.has(f.correlationId)?"polling":this.j.has(f.correlationId)}async z(f){if(this.j.has(f.correlationId))return;const g=new o.$Vc;this.j.set(f.correlationId,g),await this.s.p,!g.isDisposed&&(this.D(f,g),this.w(!0))}C(f){this.j.deleteAndDispose(f.correlationId),this.m.delete(f.correlationId),this.w(!1)}D(f,g){this.F(f,g)?(this.P(`reusing an existing recursive watcher to monitor ${f.path}`),this.m.delete(f.correlationId)):(this.G(f,g),this.m.add(f.correlationId))}F(f,g){const b=this.O?.subscribe(f.path,(l,m)=>{g.isDisposed||(l?this.D(f,g):m?.type===O.FileChangeType.ADDED&&this.H(f))});return b?(g.add(b),!0):!1}G(f,g){let b=!1;const l=(m,p)=>{if(g.isDisposed)return;const $=this.I(m),w=this.I(p),v=b;b=$,!$&&(w||v)&&this.H(f)};this.P(`starting fs.watchFile() on ${f.path} (correlationId: ${f.correlationId})`);try{(0,i.watchFile)(f.path,{persistent:!1,interval:this.r},l)}catch(m){this.Q(`fs.watchFile() failed with error ${m} on path ${f.path} (correlationId: ${f.correlationId})`)}g.add((0,o.$Uc)(()=>{this.P(`stopping fs.watchFile() on ${f.path} (correlationId: ${f.correlationId})`);try{(0,i.unwatchFile)(f.path,l)}catch(m){this.Q(`fs.unwatchFile() failed with error ${m} on path ${f.path} (correlationId: ${f.correlationId})`)}}))}H(f){this.P(`detected ${f.path} exists again, resuming watcher (correlationId: ${f.correlationId})`);const g={resource:P.URI.file(f.path),type:O.FileChangeType.ADDED,cId:f.correlationId};this.a.fire([g]),this.J(g,f),this.C(f)}I(f){return f.ctimeMs===0&&f.ino===0}async stop(){this.j.clearAndDisposeAll(),this.m.clear()}J(f,g){if(this.R){const b=` >> normalized ${f.type===O.FileChangeType.ADDED?"[ADDED]":f.type===O.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${f.resource.fsPath}`;this.L(b,g)}}L(f,g){this.R&&this.P(`${f}${typeof g.correlationId=="number"?` <${g.correlationId}> `:""}`)}M(f){return`${f.path} (excludes: ${f.excludes.length>0?f.excludes:"<none>"}, includes: ${f.includes&&f.includes.length>0?JSON.stringify(f.includes):"<all>"}, filter: ${(0,S.$7q)(f.filter)}, correlationId: ${typeof f.correlationId=="number"?f.correlationId:"<none>"})`}async setVerboseLogging(f){this.R=f}}e.$dr=a}),define(oe[219],ae([0,1,47,8,23,31,2,77,9,4,19,7,114,21,15,62]),function(V,e,i,o,S,D,O,P,y,a,h,f,g,b,l,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ir=void 0,e.$jr=$;class p extends O.$Wc{static{this.a=100}static{this.b=75}get isReusingRecursiveWatcher(){return this.n}get failed(){return this.r}constructor(v,k,t,r,n,c){super(),this.s=v,this.t=k,this.u=t,this.w=r,this.y=n,this.z=c,this.c=this.B(new o.$Uh({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},s=>this.u(s))),this.f=this.B(new o.$Th(s=>this.M(s),p.b)),this.g=(0,m.$5q)(this.s.path,this.s.excludes),this.h=this.s.includes?(0,m.$5q)(this.s.path,this.s.includes):void 0,this.j=(0,m.$Wq)(this.s)?this.s.filter:void 0,this.m=new S.$xe,this.ready=this.C(),this.n=!1,this.r=!1}async C(){try{const v=await this.F(this.s);if(this.m.token.isCancellationRequested)return;const k=await b.Promises.stat(v);if(this.m.token.isCancellationRequested)return;this.B(await this.G(v,k.isDirectory()))}catch(v){v.code!=="ENOENT"?this.O(v):this.Q(`ignoring a path for watching who's stat info failed to resolve: ${this.s.path} (error: ${v})`),this.D()}}D(){this.r=!0,this.w?.()}async F(v){let k=v.path;try{k=await b.Promises.realpath(v.path),v.path===k&&(k=await(0,g.$fr)(v.path,this.m.token)??v.path),v.path!==k&&this.Q(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${v.path}, real: ${k})`)}catch{}return k}async G(v,k){const t=new O.$Vc;return this.H(v,k,t)?(this.Q(`reusing an existing recursive watcher for ${this.s.path}`),this.n=!0):(this.n=!1,await this.I(v,k,t)),t}H(v,k,t){if(k)return!1;const r=f.URI.file(this.s.path),n=this.t?.subscribe(this.s.path,async(c,s)=>{if(!t.isDisposed)if(c){const u=await this.G(v,k);t.isDisposed?u.dispose():t.add(u)}else s&&(typeof s.cId=="number"||typeof this.s.correlationId=="number")&&this.L({resource:r,type:s.type,cId:this.s.correlationId},!0)});return n?(t.add(n),!0):!1}async I(v,k,t){if(a.$j&&(0,D.$Eg)(v,"/Volumes/",!0)){this.O(`Refusing to watch ${v} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`);return}const r=new S.$xe(this.m.token);t.add((0,O.$Uc)(()=>r.dispose(!0)));const n=new O.$Vc;t.add(n);try{const c=f.URI.file(this.s.path),s=(0,y.$pc)(v),u=(0,i.watch)(v);n.add((0,O.$Uc)(()=>{u.removeAllListeners(),u.close()})),this.Q(`Started watching: '${v}'`);const d=new Set;if(k)try{for(const E of await b.Promises.readdir(v))d.add(E)}catch(E){this.O(E)}if(r.token.isCancellationRequested)return;const I=new Map;n.add((0,O.$Uc)(()=>{for(const[,E]of I)E.dispose();I.clear()})),u.on("error",(E,A)=>{r.token.isCancellationRequested||(this.O(`Failed to watch ${v} for changes using fs.watch() (${E}, ${A})`),this.D())}),u.on("change",(E,A)=>{if(r.token.isCancellationRequested)return;this.z&&this.R(`[raw] ["${E}"] ${A}`);let T="";if(A&&(T=A.toString(),a.$j&&(T=(0,P.$mm)(T))),!(!T||E!=="change"&&E!=="rename"))if(k)if(E==="rename"){I.get(T)?.dispose();const L=setTimeout(async()=>{if(I.delete(T),T===s&&!await b.Promises.exists(v)){this.J(c);return}if(r.token.isCancellationRequested)return;const R=await this.N((0,y.$lc)(v,T));if(r.token.isCancellationRequested)return;let M;R?d.has(T)?M=l.FileChangeType.UPDATED:(M=l.FileChangeType.ADDED,d.add(T)):(d.delete(T),M=l.FileChangeType.DELETED),this.L({resource:(0,h.$gh)(c,T),type:M,cId:this.s.correlationId})},p.a);I.set(T,(0,O.$Uc)(()=>clearTimeout(L)))}else{let L;d.has(T)?L=l.FileChangeType.UPDATED:(L=l.FileChangeType.ADDED,d.add(T)),this.L({resource:(0,h.$gh)(c,T),type:L,cId:this.s.correlationId})}else if(E==="rename"||T!==s){const L=setTimeout(async()=>{const R=await b.Promises.exists(v);r.token.isCancellationRequested||(R?(this.L({resource:c,type:l.FileChangeType.UPDATED,cId:this.s.correlationId},!0),n.add(await this.G(v,!1))):this.J(c))},p.a);n.clear(),n.add((0,O.$Uc)(()=>clearTimeout(L)))}else this.L({resource:c,type:l.FileChangeType.UPDATED,cId:this.s.correlationId},!0)})}catch(c){r.token.isCancellationRequested||this.O(`Failed to watch ${v} for changes using fs.watch() (${c.toString()})`),this.D()}}J(v){this.P("Watcher shutdown because watched path got deleted"),this.L({resource:v,type:l.FileChangeType.DELETED,cId:this.s.correlationId},!0),this.f.flush(),this.D()}L(v,k=!1){this.m.token.isCancellationRequested||(this.z&&this.R(`${v.type===l.FileChangeType.ADDED?"[ADDED]":v.type===l.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${v.resource.fsPath}`),!k&&this.g.some(t=>t(v.resource.fsPath))?this.z&&this.R(` >> ignored (excluded) ${v.resource.fsPath}`):!k&&this.h&&this.h.length>0&&!this.h.some(t=>t(v.resource.fsPath))?this.z&&this.R(` >> ignored (not included) ${v.resource.fsPath}`):this.f.work(v))}M(v){const k=(0,m.$3q)(v),t=[];for(const n of k){if((0,m.$6q)(n,this.j)){this.z&&this.R(` >> ignored (filtered) ${n.resource.fsPath}`);continue}t.push(n)}if(t.length===0)return;if(this.z)for(const n of t)this.R(` >> normalized ${n.type===l.FileChangeType.ADDED?"[ADDED]":n.type===l.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${n.resource.fsPath}`);this.c.work(t)?this.c.pending>0&&this.Q(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${t[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.P(`started ignoring events due to too many file change events at once (incoming: ${t.length}, most recent change: ${t[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}async N(v){if(a.$k)return b.Promises.exists(v);try{const k=(0,y.$pc)(v);return(await b.Promises.readdir((0,y.$oc)(v))).some(r=>r===k)}catch(k){return this.Q(k),!1}}setVerboseLogging(v){this.z=v}O(v){this.m.token.isCancellationRequested||this.y?.({type:"error",message:`[File Watcher (node.js)] ${v}`})}P(v){this.m.token.isCancellationRequested||this.y?.({type:"warn",message:`[File Watcher (node.js)] ${v}`})}Q(v){!this.m.token.isCancellationRequested&&this.z&&this.y?.({type:"trace",message:`[File Watcher (node.js)] ${v}`})}R(v){!this.m.token.isCancellationRequested&&this.z&&this.Q(`${v}${typeof this.s.correlationId=="number"?` <${this.s.correlationId}> `:""}`)}dispose(){this.m.dispose(!0),super.dispose()}}e.$ir=p;async function $(w,v,k,t,r=512){const n=await b.Promises.open(w,"r"),c=Buffer.allocUnsafe(r),s=new S.$xe(t);let u,d=!1;const I={path:w,excludes:[],recursive:!1},E=new p(I,void 0,A=>{(async()=>{for(const{type:T}of A)if(T===l.FileChangeType.UPDATED){if(d)return;d=!0;try{for(;!s.token.isCancellationRequested;){const{bytesRead:L}=await b.Promises.read(n,c,0,r,null);if(!L||s.token.isCancellationRequested)break;v(c.slice(0,L))}}catch(L){u=new Error(L),s.dispose(!0)}finally{d=!1}}})()});return await E.ready,k(),new Promise((A,T)=>{s.token.onCancellationRequested(async()=>{E.dispose();try{await b.Promises.close(n)}catch(L){u=new Error(L)}u?T(u):A()})})}}),define(oe[220],ae([0,1,3,113,218,4,219,31]),function(V,e,i,o,S,D,O,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kr=void 0;class y extends S.$dr{constructor(h){super(),this.O=h,this.onDidError=i.Event.None,this.watchers=new Set}async N(h){h=this.Z(h);const f=[],g=new Set(Array.from(this.watchers));for(const b of h){const l=this.W(b);l&&(0,o.$Dk)(l.request.excludes,b.excludes)&&(0,o.$Dk)(l.request.includes,b.includes)?g.delete(l):f.push(b)}f.length&&this.P(`Request to start watching: ${f.map(b=>this.M(b)).join(",")}`),g.size&&this.P(`Request to stop watching: ${Array.from(g).map(b=>this.M(b.request)).join(",")}`);for(const b of g)this.Y(b);for(const b of f)this.X(b)}W(h){for(const f of this.watchers)if(typeof h.correlationId=="number"||typeof f.request.correlationId=="number"){if(f.request.correlationId===h.correlationId)return f}else if((0,P.$Dg)(f.request.path,h.path,!D.$k))return f}X(h){const f=new O.$ir(h,this.O,b=>this.a.fire(b),()=>this.c.fire(h),b=>this.b.fire(b),this.R),g={request:h,instance:f};this.watchers.add(g)}async stop(){await super.stop();for(const h of this.watchers)this.Y(h)}Y(h){this.P("stopping file watcher",h),this.watchers.delete(h),h.instance.dispose()}Z(h){const f=new Map;for(const g of h){const b=D.$k?g.path:g.path.toLowerCase();let l=f.get(g.correlationId);l||(l=new Map,f.set(g.correlationId,l)),l.has(b)&&this.P(`ignoring a request for watching who's path is already watched: ${this.M(g)}`),l.set(b,g)}return Array.from(f.values()).map(g=>Array.from(g.values())).flat()}async setVerboseLogging(h){super.setVerboseLogging(h);for(const f of this.watchers)f.instance.setVerboseLogging(h)}P(h,f){this.R&&this.b.fire({type:"trace",message:this.bb(h,f)})}Q(h){this.b.fire({type:"warn",message:this.bb(h)})}bb(h,f){return f?`[File Watcher (node.js)] ${h} (${this.M(f.request)})`:`[File Watcher (node.js)] ${h}`}}e.$kr=y}),define(oe[221],ae([0,1,62,220]),function(V,e,i,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lr=void 0;class S extends i.$Zq{constructor(O,P,y){super(O,P,y),this.s()}r(O){return O.add(new o.$kr(void 0))}}e.$lr=S}),define(oe[222],ae([0,1,13,44,165,62]),function(V,e,i,o,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cr=void 0;class O extends D.$1q{constructor(y,a,h){super(y,a,h),this.s()}r(y){const a=y.add(new S.$br(i.$Zg.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return y.add(a.onDidProcessExit(({code:h,signal:f})=>this.t(`terminated by itself with code ${h}, signal: ${f} (ETERM)`))),o.ProxyChannel.toService((0,o.$mi)(a.getChannel("watcher")))}}e.$cr=O}),define(oe[98],ae([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Di=void 0;class i{constructor(...S){this.a=new Map;for(const[D,O]of S)this.set(D,O)}set(S,D){const O=this.a.get(S);return this.a.set(S,D),O}has(S){return this.a.has(S)}get(S){return this.a.get(S)}}e.$Di=i}),define(oe[223],ae([0,1,8,16,2,82,212,6,98,109]),function(V,e,i,o,S,D,O,P,y,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qr=e.$pr=void 0;const h=!1;class f extends Error{constructor(p){super("cyclic dependency between services"),this.message=p.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${p.toString()}`}}class g{constructor(p=new y.$Di,$=!1,w,v=h){this.i=p,this.j=$,this.k=w,this.l=v,this.f=!1,this.g=new Set,this.h=new Set,this.t=new Set,this.i.set(P.$Ei,this),this._globalGraph=v?w?._globalGraph??new O.$or(k=>k):void 0}dispose(){if(!this.f){this.f=!0,(0,S.$Rc)(this.h),this.h.clear();for(const p of this.g)(0,S.$Qc)(p)&&p.dispose();this.g.clear()}}m(){if(this.f)throw new Error("InstantiationService has been disposed")}createChild(p,$){this.m();const w=this,v=new class extends g{dispose(){w.h.delete(v),super.dispose()}}(p,this.j,this,this.l);return this.h.add(v),$?.add(v),v}invokeFunction(p,...$){this.m();const w=l.traceInvocation(this.l,p);let v=!1;try{return p({get:t=>{if(v)throw(0,o.$0)("service accessor is only valid during the invocation of its target method");const r=this.s(t,w);if(!r)throw new Error(`[invokeFunction] unknown service '${t}'`);return r}},...$)}finally{v=!0,w.stop()}}createInstance(p,...$){this.m();let w,v;return p instanceof D.$Ci?(w=l.traceCreation(this.l,p.ctor),v=this.o(p.ctor,p.staticArguments.concat($),w)):(w=l.traceCreation(this.l,p),v=this.o(p,$,w)),w.stop(),v}o(p,$=[],w){const v=P._util.getServiceDependencies(p).sort((r,n)=>r.index-n.index),k=[];for(const r of v){const n=this.s(r.id,w);n||this.y(`[createInstance] ${p.name} depends on UNKNOWN service ${r.id}.`,!1),k.push(n)}const t=v.length>0?v[0].index:$.length;if($.length!==t){console.trace(`[createInstance] First service dependency of ${p.name} at position ${t+1} conflicts with ${$.length} static arguments`);const r=t-$.length;r>0?$=$.concat(new Array(r)):$=$.slice(0,t)}return Reflect.construct(p,$.concat(k))}q(p,$){if(this.i.get(p)instanceof D.$Ci)this.i.set(p,$);else if(this.k)this.k.q(p,$);else throw new Error("illegalState - setting UNKNOWN service instance")}r(p){const $=this.i.get(p);return!$&&this.k?this.k.r(p):$}s(p,$){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(p));const w=this.r(p);return w instanceof D.$Ci?this.u(p,w,$.branch(p,!0)):($.branch(p,!1),w)}u(p,$,w){if(this.t.has(p))throw new Error(`illegal state - RECURSIVELY instantiating service '${p}'`);this.t.add(p);try{return this.v(p,$,w)}finally{this.t.delete(p)}}v(p,$,w){const v=new O.$or(r=>r.id.toString());let k=0;const t=[{id:p,desc:$,_trace:w}];for(;t.length;){const r=t.pop();if(v.lookupOrInsertNode(r),k++>1e3)throw new f(v);for(const n of P._util.getServiceDependencies(r.desc.ctor)){const c=this.r(n.id);if(c||this.y(`[createInstance] ${p} depends on ${n.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(r.id),String(n.id)),c instanceof D.$Ci){const s={id:n.id,desc:c,_trace:r._trace.branch(n.id,!0)};v.insertEdge(r,s),t.push(s)}}}for(;;){const r=v.roots();if(r.length===0){if(!v.isEmpty())throw new f(v);break}for(const{data:n}of r){if(this.r(n.id)instanceof D.$Ci){const s=this.w(n.id,n.desc.ctor,n.desc.staticArguments,n.desc.supportsDelayedInstantiation,n._trace);this.q(n.id,s)}v.removeNode(n)}}return this.r(p)}w(p,$,w=[],v,k){if(this.i.get(p)instanceof D.$Ci)return this.x(p,$,w,v,k,this.g);if(this.k)return this.k.w(p,$,w,v,k);throw new Error(`illegalState - creating UNKNOWN service instance ${$.name}`)}x(p,$,w=[],v,k,t){if(v){const r=new g(void 0,this.j,this,this.l);r.c=String(p);const n=new Map,c=new i.$Yh(()=>{const s=r.o($,w,k);for(const[u,d]of n){const I=s[u];if(typeof I=="function")for(const E of d)E.disposable=I.apply(s,E.listener)}return n.clear(),t.add(s),s});return new Proxy(Object.create(null),{get(s,u){if(!c.isInitialized&&typeof u=="string"&&(u.startsWith("onDid")||u.startsWith("onWill"))){let E=n.get(u);return E||(E=new a.$7c,n.set(u,E)),(T,L,R)=>{if(c.isInitialized)return c.value[u](T,L,R);{const M={listener:[T,L,R],disposable:void 0},U=E.push(M);return(0,S.$Uc)(()=>{U(),M.disposable?.dispose()})}}}if(u in s)return s[u];const d=c.value;let I=d[u];return typeof I!="function"||(I=I.bind(d),s[u]=I),I},set(s,u,d){return c.value[u]=d,!0},getPrototypeOf(s){return $.prototype}})}else{const r=this.o($,w,k);return t.add(r),r}}y(p,$){if($&&console.warn(p),this.j)throw new Error(p)}}e.$pr=g;var b;(function(m){m[m.None=0]="None",m[m.Creation=1]="Creation",m[m.Invocation=2]="Invocation",m[m.Branch=3]="Branch"})(b||(b={}));class l{static{this.all=new Set}static{this.c=new class extends l{constructor(){super(b.None,null)}stop(){}branch(){return this}}}static traceInvocation(p,$){return p?new l(b.Invocation,$.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):l.c}static traceCreation(p,$){return p?new l(b.Creation,$.name):l.c}static{this.f=0}constructor(p,$){this.type=p,this.name=$,this.g=Date.now(),this.h=[]}branch(p,$){const w=new l(b.Branch,p.toString());return this.h.push([p,$,w]),w}stop(){const p=Date.now()-this.g;l.f+=p;let $=!1;function w(k,t){const r=[],n=new Array(k+1).join("	");for(const[c,s,u]of t.h)if(s&&u){$=!0,r.push(`${n}CREATES -> ${c}`);const d=w(k+1,u);d&&r.push(d)}else r.push(`${n}uses -> ${c}`);return r.join(`
`)}const v=[`${this.type===b.Creation?"CREATE":"CALL"} ${this.name}`,`${w(1,this)}`,`DONE, took ${p.toFixed(2)}ms (grand total ${l.f.toFixed(2)}ms)`];(p>2||$)&&l.all.add(v.join(`
`))}}e.$qr=l}),define(oe[224],ae([0,1,6]),function(V,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$T$b=e.IssueSource=e.IssueType=void 0;var o;(function(D){D[D.Bug=0]="Bug",D[D.PerformanceIssue=1]="PerformanceIssue",D[D.FeatureRequest=2]="FeatureRequest"})(o||(e.IssueType=o={}));var S;(function(D){D.VSCode="vscode",D.Extension="extension",D.Marketplace="marketplace"})(S||(e.IssueSource=S={})),e.$T$b=(0,i.$Fi)("issueService")}),define(oe[5],ae([0,1,186,53,3,46,2,32,4,19,12,7,123,6]),function(V,e,i,o,S,D,O,P,y,a,h,f,g,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rk=e.$mk=e.$lk=e.$kk=e.$jk=e.$ik=e.$hk=e.$gk=e.$fk=e.$ek=e.$ck=e.LogLevel=e.$ak=e.$_j=void 0,e.$bk=m,e.log=$,e.$nk=I,e.$ok=E,e.$pk=A,e.$qk=T,i=Re(i),e.$_j=(0,b.$Fi)("logService"),e.$ak=(0,b.$Fi)("loggerService");function l(){return new Date().toISOString()}function m(L){return(0,h.$jg)(L)}var p;(function(L){L[L.Off=0]="Off",L[L.Trace=1]="Trace",L[L.Debug=2]="Debug",L[L.Info=3]="Info",L[L.Warning=4]="Warning",L[L.Error=5]="Error"})(p||(e.LogLevel=p={})),e.$ck=p.Info;function $(L,R,M){switch(R){case p.Trace:L.trace(M);break;case p.Debug:L.debug(M);break;case p.Info:L.info(M);break;case p.Warning:L.warn(M);break;case p.Error:L.error(M);break;case p.Off:break;default:throw new Error(`Invalid log level ${R}`)}}function w(L,R=!1){let M="";for(let U=0;U<L.length;U++){let N=L[U];if(N instanceof Error&&(N=(0,o.$qj)(N,R)),typeof N=="object")try{N=JSON.stringify(N)}catch{}M+=(U>0?" ":"")+N}return M}class v extends O.$Wc{constructor(){super(...arguments),this.b=e.$ck,this.c=this.B(new S.$me),this.onDidChangeLogLevel=this.c.event}setLevel(R){this.b!==R&&(this.b=R,this.c.fire(this.b))}getLevel(){return this.b}f(R){return this.b!==p.Off&&this.b<=R}}e.$ek=v;class k extends v{constructor(R){super(),this.h=R}f(R){return this.h||super.f(R)}trace(R,...M){this.f(p.Trace)&&this.g(p.Trace,w([R,...M],!0))}debug(R,...M){this.f(p.Debug)&&this.g(p.Debug,w([R,...M]))}info(R,...M){this.f(p.Info)&&this.g(p.Info,w([R,...M]))}warn(R,...M){this.f(p.Warning)&&this.g(p.Warning,w([R,...M]))}error(R,...M){if(this.f(p.Error))if(R instanceof Error){const U=Array.prototype.slice.call(arguments);U[0]=R.stack,this.g(p.Error,w(U))}else this.g(p.Error,w([R,...M]))}flush(){}}e.$fk=k;class t extends v{constructor(R=e.$ck){super(),this.setLevel(R),this.g=!y.$i}trace(R,...M){this.f(p.Trace)&&(this.g?console.log(`\x1B[90m[main ${l()}]\x1B[0m`,R,...M):console.log(`[main ${l()}]`,R,...M))}debug(R,...M){this.f(p.Debug)&&(this.g?console.log(`\x1B[90m[main ${l()}]\x1B[0m`,R,...M):console.log(`[main ${l()}]`,R,...M))}info(R,...M){this.f(p.Info)&&(this.g?console.log(`\x1B[90m[main ${l()}]\x1B[0m`,R,...M):console.log(`[main ${l()}]`,R,...M))}warn(R,...M){this.f(p.Warning)&&(this.g?console.warn(`\x1B[93m[main ${l()}]\x1B[0m`,R,...M):console.warn(`[main ${l()}]`,R,...M))}error(R,...M){this.f(p.Error)&&(this.g?console.error(`\x1B[91m[main ${l()}]\x1B[0m`,R,...M):console.error(`[main ${l()}]`,R,...M))}flush(){}}e.$gk=t;class r extends v{constructor(R=e.$ck,M=!0){super(),this.g=M,this.setLevel(R)}trace(R,...M){this.f(p.Trace)&&(this.g?console.log("%cTRACE","color: #888",R,...M):console.log(R,...M))}debug(R,...M){this.f(p.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",R,...M):console.log(R,...M))}info(R,...M){this.f(p.Info)&&(this.g?console.log("%c INFO","color: #33f",R,...M):console.log(R,...M))}warn(R,...M){this.f(p.Warning)&&(this.g?console.log("%c WARN","color: #993",R,...M):console.log(R,...M))}error(R,...M){this.f(p.Error)&&(this.g?console.log("%c  ERR","color: #f33",R,...M):console.error(R,...M))}flush(){}}e.$hk=r;class n extends v{constructor(R,M=e.$ck){super(),this.g=R,this.setLevel(M)}trace(R,...M){this.f(p.Trace)&&this.g.log(p.Trace,[this.h(R),...M])}debug(R,...M){this.f(p.Debug)&&this.g.log(p.Debug,[this.h(R),...M])}info(R,...M){this.f(p.Info)&&this.g.log(p.Info,[this.h(R),...M])}warn(R,...M){this.f(p.Warning)&&this.g.log(p.Warning,[this.h(R),...M])}error(R,...M){this.f(p.Error)&&this.g.log(p.Error,[this.h(R),...M])}h(R){return typeof R=="string"?R:(0,o.$qj)(R,this.f(p.Trace))}flush(){}}e.$ik=n;class c extends v{constructor(R){super(),this.g=R,R.length&&this.setLevel(R[0].getLevel())}setLevel(R){for(const M of this.g)M.setLevel(R);super.setLevel(R)}trace(R,...M){for(const U of this.g)U.trace(R,...M)}debug(R,...M){for(const U of this.g)U.debug(R,...M)}info(R,...M){for(const U of this.g)U.info(R,...M)}warn(R,...M){for(const U of this.g)U.warn(R,...M)}error(R,...M){for(const U of this.g)U.error(R,...M)}flush(){for(const R of this.g)R.flush()}dispose(){for(const R of this.g)R.dispose();super.dispose()}}e.$jk=c;class s extends O.$Wc{constructor(R,M,U){if(super(),this.h=R,this.j=M,this.b=new P.$Cc,this.c=this.B(new S.$me),this.onDidChangeLoggers=this.c.event,this.f=this.B(new S.$me),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new S.$me),this.onDidChangeVisibility=this.g.event,U)for(const N of U)this.b.set(N.resource,{logger:void 0,info:N})}m(R){return(0,h.$fg)(R)?[...this.b.values()].find(M=>M.info.id===R):this.b.get(R)}getLogger(R){return this.m(R)?.logger}createLogger(R,M){const U=this.n(R),N=(0,h.$fg)(R)?R:M?.id??(0,D.$tj)(U.toString()).toString(16);let z=this.b.get(U)?.logger;const ne=M?.logLevel==="always"?p.Trace:M?.logLevel;z||(z=this.s(U,ne??this.getLogLevel(U)??this.h,{...M,id:N}));const Q={logger:z,info:{resource:U,id:N,logLevel:ne,name:M?.name,hidden:M?.hidden,extensionId:M?.extensionId,when:M?.when}};return this.registerLogger(Q.info),this.b.set(U,Q),z}n(R){return(0,h.$fg)(R)?(0,a.$gh)(this.j,`${R}.log`):R}setLogLevel(R,M){if(f.URI.isUri(R)){const U=R,N=M,z=this.b.get(U);z&&N!==z.info.logLevel&&(z.info.logLevel=N===this.h?void 0:N,z.logger?.setLevel(N),this.b.set(z.info.resource,z),this.f.fire([U,N]))}else{this.h=R;for(const[U,N]of this.b.entries())this.b.get(U)?.info.logLevel===void 0&&N.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(R,M){const U=this.m(R);U&&M!==!U.info.hidden&&(U.info.hidden=!M,this.b.set(U.info.resource,U),this.g.fire([U.info.resource,M]))}getLogLevel(R){let M;return R&&(M=this.b.get(R)?.info.logLevel),M??this.h}registerLogger(R){const M=this.b.get(R.resource);M?M.info.hidden!==R.hidden&&this.setVisibility(R.resource,!R.hidden):(this.b.set(R.resource,{info:R,logger:void 0}),this.c.fire({added:[R],removed:[]}))}deregisterLogger(R){const M=this.b.get(R);M&&(M.logger&&M.logger.dispose(),this.b.delete(R),this.c.fire({added:[],removed:[M.info]}))}*getRegisteredLoggers(){for(const R of this.b.values())yield R.info}getRegisteredLogger(R){return this.b.get(R)?.info}dispose(){this.b.forEach(R=>R.logger?.dispose()),this.b.clear(),super.dispose()}}e.$kk=s;class u{constructor(){this.onDidChangeLogLevel=new S.$me().event}setLevel(R){}getLevel(){return p.Info}trace(R,...M){}debug(R,...M){}info(R,...M){}warn(R,...M){}error(R,...M){}critical(R,...M){}dispose(){}flush(){}}e.$lk=u;class d extends u{}e.$mk=d;function I(L){if(L.verbose)return p.Trace;if(typeof L.logLevel=="string"){const R=T(L.logLevel.toLowerCase());if(R!==void 0)return R}return e.$ck}function E(L){switch(L){case p.Trace:return"trace";case p.Debug:return"debug";case p.Info:return"info";case p.Warning:return"warn";case p.Error:return"error";case p.Off:return"off"}}function A(L){switch(L){case p.Trace:return{original:"Trace",value:i.localize(0,null)};case p.Debug:return{original:"Debug",value:i.localize(1,null)};case p.Info:return{original:"Info",value:i.localize(2,null)};case p.Warning:return{original:"Warning",value:i.localize(3,null)};case p.Error:return{original:"Error",value:i.localize(4,null)};case p.Off:return{original:"Off",value:i.localize(5,null)}}}function T(L){switch(L){case"trace":return p.Trace;case"debug":return p.Debug;case"info":return p.Info;case"warn":return p.Warning;case"error":return p.Error;case"critical":return p.Error;case"off":return p.Off}}e.$rk=new g.$Wj("logLevel",E(p.Info))});var re=this&&this.__param||function(V,e){return function(i,o){e(i,o,V)}};define(oe[225],ae([0,1,14,4,97,5]),function(V,e,i,o,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7ec=void 0;const O=i.safeStorage;let P=class{constructor(a){this.a=a,i.app.commandLine.getSwitchValue("password-store")===S.PasswordStoreCLIOption.basic&&O.setUsePlainTextEncryption?.(!0)}async encrypt(a){this.a.trace("[EncryptionMainService] Encrypting value.");try{const h=JSON.stringify(O.encryptString(a));return this.a.trace("[EncryptionMainService] Encrypted value."),h}catch(h){throw this.a.error(h),h}}async decrypt(a){let h;try{if(h=JSON.parse(a),!h.data)throw new Error(`[EncryptionMainService] Invalid encrypted value: ${a}`);const f=Buffer.from(h.data);this.a.trace("[EncryptionMainService] Decrypting value.");const g=O.decryptString(f);return this.a.trace("[EncryptionMainService] Decrypted value."),g}catch(f){throw this.a.error(f),f}}isEncryptionAvailable(){return Promise.resolve(O.isEncryptionAvailable())}getKeyStorageProvider(){if(o.$i)return Promise.resolve(S.KnownStorageProvider.dplib);if(o.$j)return Promise.resolve(S.KnownStorageProvider.keychainAccess);if(O.getSelectedStorageBackend)try{const a=O.getSelectedStorageBackend();return Promise.resolve(a)}catch(a){this.a.error(a)}return Promise.resolve(S.KnownStorageProvider.unknown)}async setUsePlainTextEncryption(){if(o.$i)throw new Error("Setting plain text encryption is not supported on Windows.");if(o.$j)throw new Error("Setting plain text encryption is not supported on macOS.");if(!O.setUsePlainTextEncryption)throw new Error("Setting plain text encryption is not supported.");O.setUsePlainTextEncryption(!0)}};e.$7ec=P,e.$7ec=P=Se([re(0,D.$_j)],P)}),define(oe[226],ae([0,1,22,8,16,3,31,2,9,62,5]),function(V,e,i,o,S,D,O,P,y,a,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8q=void 0;class f extends P.$Wc{constructor(b,l){super(),this.a=b,this.b=l,this.c=this.B(new D.$me),this.onDidChangeFile=this.c.event,this.g=this.B(new D.$me),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new o.$Dh(0)),this.w=[],this.y=this.B(new o.$Dh(0))}watch(b,l){return l.recursive||this.b?.watcher?.forceUniversal?this.n(b,l):this.z(b,l)}n(b,l){const m={path:this.J(b),excludes:l.excludes,includes:l.includes,recursive:l.recursive,filter:l.filter,correlationId:l.correlationId},p=(0,i.$Vb)(this.j,m);return this.r(),(0,P.$Uc)(()=>{p(),this.r()})}r(){this.m.trigger(()=>this.s()).catch(b=>(0,S.$3)(b))}s(){this.h||(this.h=this.B(this.t(l=>this.c.fire((0,a.$2q)(l)),l=>this.G(l),this.a.getLevel()===h.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===h.LogLevel.Trace)})));const b=this.b?.watcher?.recursive?.usePolling;if(b===!0)for(const l of this.j)(0,a.$Xq)(l)&&(l.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(b))for(const l of this.j)(0,a.$Xq)(l)&&b.includes(l.path)&&(l.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z(b,l){const m={path:this.J(b),excludes:l.excludes,includes:l.includes,recursive:!1,filter:l.filter,correlationId:l.correlationId},p=(0,i.$Vb)(this.w,m);return this.C(),(0,P.$Uc)(()=>{p(),this.C()})}C(){this.y.trigger(()=>this.D()).catch(b=>(0,S.$3)(b))}D(){return this.u||(this.u=this.B(this.F(b=>this.c.fire((0,a.$2q)(b)),b=>this.G(b),this.a.getLevel()===h.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===h.LogLevel.Trace)}))),this.u.watch(this.w)}G(b){b.type==="error"&&this.g.fire(b.message),this.H(b)}H(b){this.a[b.type](b.message)}I(b){return(0,y.$jc)(b.fsPath)}J(b){const l=this.I(b);return(0,O.$Hg)(l)}}e.$8q=f}),define(oe[227],ae([0,1,22,8,17,23,3,46,76,2,61,13,70,19,67,180,15,125,5,16]),function(V,e,i,o,S,D,O,P,y,a,h,f,g,b,l,m,p,$,w,v){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.$Vq=void 0;let t=class extends a.$Wc{static{k=this}constructor(n){super(),this.b=n,this.a=256*1024,this.c=this.B(new O.$me),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new O.$me),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new O.$me),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.r=this.B(new O.$me),this.onDidRunOperation=this.r.event,this.X=this.B(new O.$me),this.Y=this.B(new O.$me),this.onDidFilesChange=this.Y.event,this.Z=this.B(new O.$me),this.onDidWatchError=this.Z.event,this.$=new Map,this.cb=this.B(new o.$Oh)}registerProvider(n,c){if(this.h.has(n))throw new Error(`A filesystem provider for the scheme '${n}' is already registered.`);(0,g.mark)(`code/registerFilesystem/${n}`);const s=new a.$Vc;return this.h.set(n,c),this.c.fire({added:!0,scheme:n,provider:c}),s.add(c.onDidChangeFile(u=>{const d=new p.$sl(u,!this.S(c));this.X.fire(d),d.hasCorrelation()||this.Y.fire(d)})),typeof c.onDidWatchError=="function"&&s.add(c.onDidWatchError(u=>this.Z.fire(new Error(u)))),s.add(c.onDidChangeCapabilities(()=>this.g.fire({provider:c,scheme:n}))),(0,a.$Uc)(()=>{this.c.fire({added:!1,scheme:n,provider:c}),this.h.delete(n),(0,a.$Rc)(s)})}getProvider(n){return this.h.get(n)}async activateProvider(n){const c=[];this.f.fire({scheme:n,join(s){c.push(s)}}),!this.h.has(n)&&await o.Promises.settled(c)}async canHandleResource(n){return await this.activateProvider(n.scheme),this.hasProvider(n)}hasProvider(n){return this.h.has(n.scheme)}hasCapability(n,c){const s=this.h.get(n.scheme);return!!(s&&s.capabilities&c)}listCapabilities(){return y.Iterable.map(this.h,([n,c])=>({scheme:n,capabilities:c.capabilities}))}async j(n){if(!(0,b.$kh)(n))throw new p.$ul((0,m.localize)(0,null,this.sb(n)),p.FileOperationResult.FILE_INVALID_PATH);await this.activateProvider(n.scheme);const c=this.h.get(n.scheme);if(!c){const s=new v.$db;throw s.message=(0,m.localize)(1,null,n.toString()),s}return c}async m(n){const c=await this.j(n);if((0,p.$fl)(c)||(0,p.$cl)(c)||(0,p.$gl)(c))return c;throw new Error(`Filesystem provider for scheme '${n.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async n(n){const c=await this.j(n);if((0,p.$fl)(c)||(0,p.$cl)(c))return c;throw new Error(`Filesystem provider for scheme '${n.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(n,c){try{return await this.s(n,c)}catch(s){throw(0,p.$pl)(s)===p.FileSystemProviderErrorCode.FileNotFound?new p.$ul((0,m.localize)(2,null,this.sb(n)),p.FileOperationResult.FILE_NOT_FOUND):(0,p.$nl)(s)}}async s(n,c){const s=await this.j(n),u=this.S(s),d=c?.resolveTo,I=c?.resolveSingleChildDescendants,E=c?.resolveMetadata,A=await s.stat(n);let T;return this.t(s,n,A,void 0,!!E,(L,R)=>(T||(T=h.$Li.forUris(()=>!u),T.set(n,!0),d&&T.fill(!0,d)),T.get(L.resource)||T.findSuperstr(L.resource.with({query:null,fragment:null}))?!0:L.isDirectory&&I?R===1:!1))}async t(n,c,s,u,d,I){const{providerExtUri:E}=this.R(n),A={resource:c,name:E.basename(c),isFile:(s.type&p.FileType.File)!==0,isDirectory:(s.type&p.FileType.Directory)!==0,isSymbolicLink:(s.type&p.FileType.SymbolicLink)!==0,mtime:s.mtime,ctime:s.ctime,size:s.size,readonly:!!((s.permissions??0)&p.FilePermission.Readonly)||!!(n.capabilities&p.FileSystemProviderCapabilities.Readonly),locked:!!((s.permissions??0)&p.FilePermission.Locked),etag:(0,p.$Fl)({mtime:s.mtime,size:s.size}),children:void 0};if(A.isDirectory&&I(A,u)){try{const T=await n.readdir(c),L=await o.Promises.settled(T.map(async([R,M])=>{try{const U=E.joinPath(c,R),N=d?await n.stat(U):{type:M};return await this.t(n,U,N,T.length,d,I)}catch(U){return this.b.trace(U),null}}));A.children=(0,i.$Jb)(L)}catch(T){this.b.trace(T),A.children=[]}return A}return A}async resolveAll(n){return o.Promises.settled(n.map(async c=>{try{return{stat:await this.s(c.resource,c.options),success:!0}}catch(s){return this.b.trace(s),{stat:void 0,success:!1}}}))}async stat(n){const c=await this.j(n),s=await c.stat(n);return this.t(c,n,s,void 0,!0,()=>!1)}async exists(n){const c=await this.j(n);try{return!!await c.stat(n)}catch{return!1}}async canCreateFile(n,c){try{await this.u(n,c)}catch(s){return s}return!0}async u(n,c){if(!c?.overwrite&&await this.exists(n))throw new p.$ul((0,m.localize)(3,null,this.sb(n)),p.FileOperationResult.FILE_MODIFIED_SINCE,c)}async createFile(n,c=S.$Oe.fromString(""),s){await this.u(n,s);const u=await this.writeFile(n,c);return this.r.fire(new p.$rl(n,p.FileOperation.CREATE,u)),u}async writeFile(n,c,s){const u=this.qb(await this.n(n),n),{providerExtUri:d}=this.R(u);let I=s;if((0,p.$il)(u)&&!I?.atomic){const E=u.enforceAtomicWriteFile?.(n);E&&(I={...s,atomic:E})}try{await this.w(u,n,I)||await this.U(u,d.dirname(n));let A;if((0,p.$cl)(u)&&!(c instanceof S.$Oe))if((0,l.$Ae)(c)){const T=await(0,l.$He)(c,3);T.ended?A=S.$Oe.concat(T.buffer):A=T}else A=(0,l.$Ee)(c,T=>S.$Oe.concat(T),3);else A=c;!(0,p.$fl)(u)||(0,p.$cl)(u)&&A instanceof S.$Oe||(0,p.$cl)(u)&&(0,p.$il)(u)&&I?.atomic?await this.hb(u,n,I,A):await this.db(u,n,I,A instanceof S.$Oe?(0,S.$Ze)(A):A),this.r.fire(new p.$rl(n,p.FileOperation.WRITE))}catch(E){throw new p.$ul((0,m.localize)(4,null,this.sb(n),(0,p.$nl)(E).toString()),(0,p.$ql)(E),I)}return this.resolve(n,{resolveMetadata:!0})}async w(n,c,s){const u=!!s?.unlock;if(u&&!(n.capabilities&p.FileSystemProviderCapabilities.FileWriteUnlock))throw new Error((0,m.localize)(5,null,this.sb(c)));if(!!s?.atomic){if(!(n.capabilities&p.FileSystemProviderCapabilities.FileAtomicWrite))throw new Error((0,m.localize)(6,null,this.sb(c)));if(!(n.capabilities&p.FileSystemProviderCapabilities.FileReadWrite))throw new Error((0,m.localize)(7,null,this.sb(c)));if(u)throw new Error((0,m.localize)(8,null,this.sb(c)))}let I;try{I=await n.stat(c)}catch{return}if(I.type&p.FileType.Directory)throw new p.$ul((0,m.localize)(9,null,this.sb(c)),p.FileOperationResult.FILE_IS_DIRECTORY,s);if(this.rb(c,I),typeof s?.mtime=="number"&&typeof s.etag=="string"&&s.etag!==p.$El&&typeof I.mtime=="number"&&typeof I.size=="number"&&s.mtime<I.mtime&&s.etag!==(0,p.$Fl)({mtime:s.mtime,size:I.size}))throw new p.$ul((0,m.localize)(10,null),p.FileOperationResult.FILE_MODIFIED_SINCE,s);return I}async readFile(n,c,s){const u=await this.m(n);return c?.atomic?this.z(u,n,c,s):this.C(u,n,c,s)}async z(n,c,s,u){return new Promise((d,I)=>{this.cb.queueFor(c,async()=>{try{const E=await this.C(n,c,s,u);d(E)}catch(E){I(E)}},this.R(n).providerExtUri)})}async C(n,c,s,u){const d=await this.D(n,c,{...s,preferUnbuffered:!0},u);return{...d,value:await(0,S.$1e)(d.value)}}async readFileStream(n,c,s){const u=await this.m(n);return this.D(u,n,c,s)}async D(n,c,s,u){const d=new D.$xe(u);let I=s;(0,p.$hl)(n)&&n.enforceAtomicReadFile?.(c)&&(I={...s,atomic:!0});const E=this.J(c,I).then(T=>T,T=>{throw d.dispose(!0),T});let A;try{return typeof I?.etag=="string"&&I.etag!==p.$El&&await E,I?.atomic&&(0,p.$hl)(n)||!((0,p.$fl)(n)||(0,p.$gl)(n))||(0,p.$cl)(n)&&I?.preferUnbuffered?A=this.I(n,c,I):(0,p.$gl)(n)?A=this.G(n,c,d.token,I):A=this.H(n,c,d.token,I),A.on("end",()=>d.dispose()),A.on("error",()=>d.dispose()),{...await E,value:A}}catch(T){throw A&&await(0,l.$Fe)(A),this.F(T,c,I)}}F(n,c,s){const u=(0,m.localize)(11,null,this.sb(c),(0,p.$nl)(n).toString());return n instanceof p.$wl?new p.$wl(u,n.stat,s):n instanceof p.$vl?new p.$vl(u,n.fileOperationResult,n.size,n.options):new p.$ul(u,(0,p.$ql)(n),s)}G(n,c,s,u=Object.create(null)){const d=n.readFileStream(c,u,s);return(0,l.$Le)(d,{data:I=>I instanceof S.$Oe?I:S.$Oe.wrap(I),error:I=>this.F(I,c,u)},I=>S.$Oe.concat(I))}H(n,c,s,u=Object.create(null)){const d=(0,S.$5e)();return(0,$.$Uq)(n,c,d,I=>I,{...u,bufferSize:this.a,errorTransformer:I=>this.F(I,c,u)},s),d}I(n,c,s){const u=(0,l.$Ce)(d=>S.$Oe.concat(d));return(async()=>{try{let d;s?.atomic&&(0,p.$hl)(n)?d=await n.readFile(c,{atomic:!0}):d=await n.readFile(c),typeof s?.position=="number"&&(d=d.slice(s.position)),typeof s?.length=="number"&&(d=d.slice(0,s.length)),this.L(c,d.byteLength,s),u.end(S.$Oe.wrap(d))}catch(d){u.error(d),u.end()}})(),u}async J(n,c){const s=await this.resolve(n,{resolveMetadata:!0});if(s.isDirectory)throw new p.$ul((0,m.localize)(12,null,this.sb(n)),p.FileOperationResult.FILE_IS_DIRECTORY,c);if(typeof c?.etag=="string"&&c.etag!==p.$El&&c.etag===s.etag)throw new p.$wl((0,m.localize)(13,null),s,c);return this.L(n,s.size,c),s}L(n,c,s){if(typeof s?.limits?.size=="number"&&c>s.limits.size)throw new p.$vl((0,m.localize)(14,null,this.sb(n)),p.FileOperationResult.FILE_TOO_LARGE,c,s)}async canMove(n,c,s){return this.M(n,c,"move",s)}async canCopy(n,c,s){return this.M(n,c,"copy",s)}async M(n,c,s,u){if(n.toString()!==c.toString())try{const d=s==="move"?this.qb(await this.n(n),n):await this.m(n),I=this.qb(await this.n(c),c);await this.Q(d,n,I,c,s,u)}catch(d){return d}return!0}async move(n,c,s){const u=this.qb(await this.n(n),n),d=this.qb(await this.n(c),c),I=await this.N(u,n,d,c,"move",!!s),E=await this.resolve(c,{resolveMetadata:!0});return this.r.fire(new p.$rl(n,I==="move"?p.FileOperation.MOVE:p.FileOperation.COPY,E)),E}async copy(n,c,s){const u=await this.m(n),d=this.qb(await this.n(c),c),I=await this.N(u,n,d,c,"copy",!!s),E=await this.resolve(c,{resolveMetadata:!0});return this.r.fire(new p.$rl(n,I==="copy"?p.FileOperation.COPY:p.FileOperation.MOVE,E)),E}async N(n,c,s,u,d,I){if(c.toString()===u.toString())return d;const{exists:E,isSameResourceWithDifferentPathCase:A}=await this.Q(n,c,s,u,d,I);if(E&&!A&&I&&await this.del(u,{recursive:!0}),await this.U(s,this.R(s).providerExtUri.dirname(u)),d==="copy"){if(n===s&&(0,p.$dl)(n))await n.copy(c,u,{overwrite:I});else{const T=await this.resolve(c);T.isDirectory?await this.P(n,T,s,u):await this.O(n,c,s,u)}return d}else return n===s?(await n.rename(c,u,{overwrite:I}),d):(await this.N(n,c,s,u,"copy",I),await this.del(c,{recursive:!0}),"copy")}async O(n,c,s,u){if((0,p.$fl)(n)&&(0,p.$fl)(s))return this.jb(n,c,s,u);if((0,p.$fl)(n)&&(0,p.$cl)(s))return this.pb(n,c,s,u);if((0,p.$cl)(n)&&(0,p.$fl)(s))return this.nb(n,c,s,u);if((0,p.$cl)(n)&&(0,p.$cl)(s))return this.lb(n,c,s,u)}async P(n,c,s,u){await s.mkdir(u),Array.isArray(c.children)&&await o.Promises.settled(c.children.map(async d=>{const I=this.R(s).providerExtUri.joinPath(u,d.name);return d.isDirectory?this.P(n,await this.resolve(d.resource),s,I):this.O(n,d.resource,s,I)}))}async Q(n,c,s,u,d,I){let E=!1;if(n===s){const{providerExtUri:T,isPathCaseSensitive:L}=this.R(n);if(L||(E=T.isEqual(c,u)),E&&d==="copy")throw new Error((0,m.localize)(15,null,this.sb(c),this.sb(u)));if(!E&&T.isEqualOrParent(u,c))throw new Error((0,m.localize)(16,null,this.sb(c),this.sb(u)))}const A=await this.exists(u);if(A&&!E){if(!I)throw new p.$ul((0,m.localize)(17,null,this.sb(c),this.sb(u)),p.FileOperationResult.FILE_MOVE_CONFLICT);if(n===s){const{providerExtUri:T}=this.R(n);if(T.isEqualOrParent(c,u))throw new Error((0,m.localize)(18,null,this.sb(c),this.sb(u)))}}return{exists:A,isSameResourceWithDifferentPathCase:E}}R(n){const c=this.S(n);return{providerExtUri:c?b.$9g:b.$$g,isPathCaseSensitive:c}}S(n){return!!(n.capabilities&p.FileSystemProviderCapabilities.PathCaseSensitive)}async createFolder(n){const c=this.qb(await this.j(n),n);await this.U(c,n);const s=await this.resolve(n,{resolveMetadata:!0});return this.r.fire(new p.$rl(n,p.FileOperation.CREATE,s)),s}async U(n,c){const s=[],{providerExtUri:u}=this.R(n);for(;!u.isEqual(c,u.dirname(c));)try{if(!((await n.stat(c)).type&p.FileType.Directory))throw new Error((0,m.localize)(19,null,this.sb(c)));break}catch(d){if((0,p.$pl)(d)!==p.FileSystemProviderErrorCode.FileNotFound)throw d;s.push(u.basename(c)),c=u.dirname(c)}for(let d=s.length-1;d>=0;d--){c=u.joinPath(c,s[d]);try{await n.mkdir(c)}catch(I){if((0,p.$pl)(I)!==p.FileSystemProviderErrorCode.FileExists)throw I}}}async canDelete(n,c){try{await this.W(n,c)}catch(s){return s}return!0}async W(n,c){const s=this.qb(await this.j(n),n),u=!!c?.useTrash;if(u&&!(s.capabilities&p.FileSystemProviderCapabilities.Trash))throw new Error((0,m.localize)(20,null,this.sb(n)));const d=c?.atomic;if(d&&!(s.capabilities&p.FileSystemProviderCapabilities.FileAtomicDelete))throw new Error((0,m.localize)(21,null,this.sb(n)));if(u&&d)throw new Error((0,m.localize)(22,null,this.sb(n)));let I;try{I=await s.stat(n)}catch{}if(I)this.rb(n,I);else throw new p.$ul((0,m.localize)(23,null,this.sb(n)),p.FileOperationResult.FILE_NOT_FOUND);if(!!!c?.recursive){const A=await this.resolve(n);if(A.isDirectory&&Array.isArray(A.children)&&A.children.length>0)throw new Error((0,m.localize)(24,null,this.sb(n)))}return s}async del(n,c){const s=await this.W(n,c);let u=c;if((0,p.$jl)(s)&&!u?.atomic){const A=s.enforceAtomicDelete?.(n);A&&(u={...c,atomic:A})}const d=!!u?.useTrash,I=!!u?.recursive,E=u?.atomic??!1;await s.delete(n,{recursive:I,useTrash:d,atomic:E}),this.r.fire(new p.$rl(n,p.FileOperation.DELETE))}async cloneFile(n,c){const s=await this.j(n),u=this.qb(await this.n(c),c);if(!(s===u&&this.R(s).providerExtUri.isEqual(n,c)))return s===u&&(0,p.$el)(s)?s.cloneFile(n,c):(await this.U(u,this.R(u).providerExtUri.dirname(c)),s===u&&(0,p.$dl)(s)?this.cb.queueFor(n,()=>s.copy(n,c,{overwrite:!0}),this.R(s).providerExtUri):this.cb.queueFor(n,()=>this.O(s,n,u,c),this.R(s).providerExtUri))}static{this.ab=0}createWatcher(n,c){return this.watch(n,{...c,correlationId:k.ab++})}watch(n,c={recursive:!1,excludes:[]}){const s=new a.$Vc;let u=!1,d=()=>{u=!0};s.add((0,a.$Uc)(()=>d())),(async()=>{try{const E=await this.bb(n,c);u?(0,a.$Rc)(E):d=()=>(0,a.$Rc)(E)}catch(E){this.b.error(E)}})();const I=c.correlationId;if(typeof I=="number"){const E=s.add(new O.$me);return s.add(this.X.event(T=>{T.correlates(I)&&E.fire(T)})),{onDidChange:E.event,dispose:()=>s.dispose()}}return s}async bb(n,c){const s=await this.j(n),u=(0,P.$tj)([this.R(s).providerExtUri.getComparisonKey(n),c]);let d=this.$.get(u);return d||(d={count:0,disposable:s.watch(n,c)},this.$.set(u,d)),d.count+=1,(0,a.$Uc)(()=>{d&&(d.count--,d.count===0&&((0,a.$Rc)(d.disposable),this.$.delete(u)))})}dispose(){super.dispose();for(const[,n]of this.$)(0,a.$Rc)(n.disposable);this.$.clear()}async db(n,c,s,u){return this.cb.queueFor(c,async()=>{const d=await n.open(c,{create:!0,unlock:s?.unlock??!1});try{(0,l.$Ae)(u)||(0,l.$Be)(u)?await this.eb(n,d,u):await this.fb(n,d,u)}catch(I){throw(0,p.$nl)(I)}finally{await n.close(d)}},this.R(n).providerExtUri)}async eb(n,c,s){let u=0,d;if((0,l.$Be)(s)){if(s.buffer.length>0){const I=S.$Oe.concat(s.buffer);await this.gb(n,c,I,I.byteLength,u,0),u+=I.byteLength}if(s.ended)return;d=s.stream}else d=s;return new Promise((I,E)=>{(0,l.$Ge)(d,{onData:async A=>{d.pause();try{await this.gb(n,c,A,A.byteLength,u,0)}catch(T){return E(T)}u+=A.byteLength,setTimeout(()=>d.resume())},onError:A=>E(A),onEnd:()=>I()})})}async fb(n,c,s){let u=0,d;for(;(d=s.read())!==null;)await this.gb(n,c,d,d.byteLength,u,0),u+=d.byteLength}async gb(n,c,s,u,d,I){let E=0;for(;E<u;){const A=await n.write(c,d+E,s.buffer,I+E,u-E);E+=A}}async hb(n,c,s,u){return this.cb.queueFor(c,()=>this.ib(n,c,s,u),this.R(n).providerExtUri)}async ib(n,c,s,u){let d;u instanceof S.$Oe?d=u:(0,l.$Ae)(u)?d=await(0,S.$1e)(u):(0,l.$Be)(u)?d=await(0,S.$2e)(u):d=(0,S.$Ye)(u),await n.writeFile(c,d.buffer,{create:!0,overwrite:!0,unlock:s?.unlock??!1,atomic:s?.atomic??!1})}async jb(n,c,s,u){return this.cb.queueFor(u,()=>this.kb(n,c,s,u),this.R(s).providerExtUri)}async kb(n,c,s,u){let d,I;try{d=await n.open(c,{create:!1}),I=await s.open(u,{create:!0,unlock:!1});const E=S.$Oe.alloc(this.a);let A=0,T=0,L=0;do L=await n.read(d,A,E.buffer,T,E.byteLength-T),await this.gb(s,I,E,L,A,T),A+=L,T+=L,T===E.byteLength&&(T=0);while(L>0)}catch(E){throw(0,p.$nl)(E)}finally{await o.Promises.settled([typeof d=="number"?n.close(d):Promise.resolve(),typeof I=="number"?s.close(I):Promise.resolve()])}}async lb(n,c,s,u){return this.cb.queueFor(u,()=>this.mb(n,c,s,u),this.R(s).providerExtUri)}async mb(n,c,s,u){return s.writeFile(u,await n.readFile(c),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async nb(n,c,s,u){return this.cb.queueFor(u,()=>this.ob(n,c,s,u),this.R(s).providerExtUri)}async ob(n,c,s,u){const d=await s.open(u,{create:!0,unlock:!1});try{const I=await n.readFile(c);await this.gb(s,d,S.$Oe.wrap(I),I.byteLength,0,0)}catch(I){throw(0,p.$nl)(I)}finally{await s.close(d)}}async pb(n,c,s,u){const d=await(0,S.$1e)(this.H(n,c,D.CancellationToken.None));await this.hb(s,u,void 0,d)}qb(n,c){if(n.capabilities&p.FileSystemProviderCapabilities.Readonly)throw new p.$ul((0,m.localize)(25,null,this.sb(c)),p.FileOperationResult.FILE_PERMISSION_DENIED);return n}rb(n,c){if((c.permissions??0)&p.FilePermission.Readonly)throw new p.$ul((0,m.localize)(26,null,this.sb(n)),p.FileOperationResult.FILE_PERMISSION_DENIED)}sb(n){return n.scheme===f.Schemas.file?n.fsPath:n.toString(!0)}};e.$Vq=t,e.$Vq=t=k=Se([re(0,w.$_j)],t)}),define(oe[99],ae([0,1,8,32,17,3,31,2,9,4,19,67,21,184,15,125,226,222,221]),function(V,e,i,o,S,D,O,P,y,a,h,f,g,b,l,m,p,$,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mr=void 0;class v extends p.$8q{static{this.L=!1}constructor(t,r){super(t,r),this.onDidChangeCapabilities=D.Event.None,this.P=new o.$Cc(n=>h.$0g.getComparisonKey(n)),this.X=new Map,this.Y=new Map,this.Z=new Map}get capabilities(){return this.M||(this.M=l.FileSystemProviderCapabilities.FileReadWrite|l.FileSystemProviderCapabilities.FileOpenReadWriteClose|l.FileSystemProviderCapabilities.FileReadStream|l.FileSystemProviderCapabilities.FileFolderCopy|l.FileSystemProviderCapabilities.FileWriteUnlock|l.FileSystemProviderCapabilities.FileAtomicRead|l.FileSystemProviderCapabilities.FileAtomicWrite|l.FileSystemProviderCapabilities.FileAtomicDelete|l.FileSystemProviderCapabilities.FileClone,a.$k&&(this.M|=l.FileSystemProviderCapabilities.PathCaseSensitive)),this.M}async stat(t){try{const{stat:r,symbolicLink:n}=await g.SymlinkSupport.stat(this.I(t));return{type:this.O(r,n),ctime:r.birthtime.getTime(),mtime:r.mtime.getTime(),size:r.size,permissions:r.mode&128?void 0:l.FilePermission.Locked}}catch(r){throw this.hb(r)}}async N(t){try{return await this.stat(t)}catch{return}}async readdir(t){try{const r=await g.Promises.readdir(this.I(t),{withFileTypes:!0}),n=[];return await Promise.all(r.map(async c=>{try{let s;c.isSymbolicLink()?s=(await this.stat((0,h.$gh)(t,c.name))).type:s=this.O(c),n.push([c.name,s])}catch(s){this.a.trace(s)}})),n}catch(r){throw this.hb(r)}}O(t,r){let n;return r?.dangling?n=l.FileType.Unknown:t.isFile()?n=l.FileType.File:t.isDirectory()?n=l.FileType.Directory:n=l.FileType.Unknown,r&&(n|=l.FileType.SymbolicLink),n}async Q(t){const r=this.I(t);this.R(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${r})`);let n;for(;n=this.P.get(t);)this.R(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${r})`),await n.wait();const c=new i.$Eh;return this.P.set(t,c),this.R(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${r})`),(0,P.$Uc)(()=>{this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${r})`),this.P.get(t)===c&&(this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${r})`),this.P.delete(t)),this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${r})`),c.open()})}async readFile(t,r){let n;try{r?.atomic&&(this.R(`[Disk FileSystemProvider]: atomic read operation started (${this.I(t)})`),n=await this.Q(t));const c=this.I(t);return await g.Promises.readFile(c)}catch(c){throw this.hb(c)}finally{n?.dispose()}}R(t){v.L&&this.a.trace(t)}readFileStream(t,r,n){const c=(0,f.$Ce)(s=>S.$Oe.concat(s.map(u=>S.$Oe.wrap(u))).buffer);return(0,m.$Uq)(this,t,c,s=>s.buffer,{...r,bufferSize:256*1024},n),c}async writeFile(t,r,n){return n?.atomic!==!1&&n?.atomic?.postfix&&await this.S(t)?this.U(t,(0,h.$gh)((0,h.$fh)(t),`${(0,h.$dh)(t)}${n.atomic.postfix}`),r,n):this.W(t,r,n)}async S(t){try{const r=this.I(t),{symbolicLink:n}=await g.SymlinkSupport.stat(r);if(n)return!1}catch{}return!0}async U(t,r,n,c){const s=new P.$Vc;try{s.add(await this.Q(t)),s.add(await this.Q(r)),await this.W(r,n,c,!0);try{await this.rename(r,t,{overwrite:!0})}catch(u){try{await this.delete(r,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw u}}finally{s.dispose()}}async W(t,r,n,c){let s;try{const u=this.I(t);if(!n.create||!n.overwrite){if(await g.Promises.exists(u)){if(!n.overwrite)throw(0,l.$ml)((0,b.localize)(0,null),l.FileSystemProviderErrorCode.FileExists)}else if(!n.create)throw(0,l.$ml)((0,b.localize)(1,null),l.FileSystemProviderErrorCode.FileNotFound)}s=await this.open(t,{create:!0,unlock:n.unlock},c),await this.write(s,0,r,0,r.byteLength)}catch(u){throw await this.ib(t,u)}finally{typeof s=="number"&&await this.close(s)}}static{this.$=!0}static configureFlushOnWrite(t){v.$=t}async open(t,r,n){const c=this.I(t);let s;(0,l.$al)(r)&&!n&&(s=await this.Q(t));let u;try{if((0,l.$al)(r)&&r.unlock)try{const{stat:I}=await g.SymlinkSupport.stat(c);I.mode&128||await g.Promises.chmod(c,I.mode|128)}catch(I){I.code!=="ENOENT"&&this.a.trace(I)}let d;if((0,l.$al)(r)){if(a.$i)try{await g.Promises.truncate(c,0),d="r+"}catch(I){I.code!=="ENOENT"&&this.a.trace(I)}d||(d="w")}else d="r";u=await g.Promises.open(c,d)}catch(d){throw s?.dispose(),(0,l.$al)(r)?await this.ib(t,d):this.hb(d)}if(this.X.set(u,0),(0,l.$al)(r)&&this.Z.set(u,t),s){const d=this.Y.get(u);this.R(`[Disk FileSystemProvider]: open() - storing lock for handle ${u} (${c})`),this.Y.set(u,s),d&&(this.R(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${u} (${c})`),d.dispose())}return u}async close(t){const r=this.Y.get(t);try{if(this.X.delete(t),this.Z.delete(t)&&v.$)try{await g.Promises.fdatasync(t)}catch(n){v.configureFlushOnWrite(!1),this.a.error(n)}return await g.Promises.close(t)}catch(n){throw this.hb(n)}finally{r&&(this.Y.get(t)===r&&(this.R(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${t}`),this.Y.delete(t)),this.R(`[Disk FileSystemProvider]: close() - disposing lock for handle ${t}`),r.dispose())}}async read(t,r,n,c,s){const u=this.ab(t,r);let d=null;try{d=(await g.Promises.read(t,n,c,s,u)).bytesRead}catch(I){throw this.hb(I)}finally{this.bb(t,u,d)}return d}ab(t,r){return r===this.X.get(t)?null:r}bb(t,r,n){const c=this.X.get(t);typeof c=="number"&&(typeof r=="number"||(typeof n=="number"?this.X.set(t,c+n):this.X.delete(t)))}async write(t,r,n,c,s){return(0,i.$Zh)(()=>this.cb(t,r,n,c,s),100,3)}async cb(t,r,n,c,s){const u=this.ab(t,r);let d=null;try{d=(await g.Promises.write(t,n,c,s,u)).bytesWritten}catch(I){throw await this.ib(this.Z.get(t),I)}finally{this.bb(t,u,d)}return d}async mkdir(t){try{await g.Promises.mkdir(this.I(t))}catch(r){throw this.hb(r)}}async delete(t,r){try{const n=this.I(t);if(r.recursive){let c;r?.atomic!==!1&&r.atomic.postfix&&(c=(0,y.$lc)((0,y.$oc)(n),`${(0,y.$pc)(n)}${r.atomic.postfix}`)),await g.Promises.rm(n,g.RimRafMode.MOVE,c)}else try{await g.Promises.unlink(n)}catch(c){if(c.code==="EPERM"||c.code==="EISDIR"){let s=!1;try{const{stat:u,symbolicLink:d}=await g.SymlinkSupport.stat(n);s=u.isDirectory()&&!d}catch{}if(s)await g.Promises.rmdir(n);else throw c}else throw c}}catch(n){throw this.hb(n)}}async rename(t,r,n){const c=this.I(t),s=this.I(r);if(c!==s)try{await this.db(t,r,"move",n.overwrite),await g.Promises.rename(c,s)}catch(u){throw(u.code==="EINVAL"||u.code==="EBUSY"||u.code==="ENAMETOOLONG")&&(u=new Error((0,b.localize)(2,null,(0,y.$pc)(c),(0,y.$pc)((0,y.$oc)(s)),u.toString()))),this.hb(u)}}async copy(t,r,n){const c=this.I(t),s=this.I(r);if(c!==s)try{await this.db(t,r,"copy",n.overwrite),await g.Promises.copy(c,s,{preserveSymlinks:!0})}catch(u){throw(u.code==="EINVAL"||u.code==="EBUSY"||u.code==="ENAMETOOLONG")&&(u=new Error((0,b.localize)(3,null,(0,y.$pc)(c),(0,y.$pc)((0,y.$oc)(s)),u.toString()))),this.hb(u)}}async db(t,r,n,c){const s=this.I(t),u=this.I(r);let d=!1;if(!!(this.capabilities&l.FileSystemProviderCapabilities.PathCaseSensitive)||(d=(0,O.$Dg)(s,u,!0)),d){if(n==="copy")throw(0,l.$ml)((0,b.localize)(4,null),l.FileSystemProviderErrorCode.FileExists);if(n==="move")return}const E=await this.N(t);if(!E)throw(0,l.$ml)((0,b.localize)(5,null),l.FileSystemProviderErrorCode.FileNotFound);const A=await this.N(r);if(A){if(!c)throw(0,l.$ml)((0,b.localize)(6,null),l.FileSystemProviderErrorCode.FileExists);E.type&l.FileType.File&&A.type&l.FileType.File||await this.delete(r,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(t,r){return this.eb(t,r,!1)}async eb(t,r,n){const c=this.I(t),s=this.I(r),u=!!(this.capabilities&l.FileSystemProviderCapabilities.PathCaseSensitive);if((0,O.$Dg)(c,s,!u))return;const d=new P.$Vc;try{d.add(await this.Q(t)),d.add(await this.Q(r)),n&&await g.Promises.mkdir((0,y.$oc)(s),{recursive:!0}),await g.Promises.copyFile(c,s)}catch(I){if(I.code==="ENOENT"&&!n)return this.eb(t,r,!0);throw this.hb(I)}finally{d.dispose()}}t(t,r,n){return new $.$cr(c=>t(c),c=>r(c),n)}F(t,r,n){return new w.$lr(c=>t(c),c=>r(c),n)}hb(t){if(t instanceof l.$ll)return t;let r=t,n;switch(t.code){case"ENOENT":n=l.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":n=l.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":n=l.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":n=l.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":n=l.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":r=`${t.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,n=l.FileSystemProviderErrorCode.Unknown;break;default:n=l.FileSystemProviderErrorCode.Unknown}return(0,l.$ml)(r,n)}async ib(t,r){let n=this.hb(r);if(t&&n.code===l.FileSystemProviderErrorCode.NoPermissions)try{const{stat:c}=await g.SymlinkSupport.stat(this.I(t));c.mode&128||(n=(0,l.$ml)(r,l.FileSystemProviderErrorCode.FileWriteLocked))}catch(c){this.a.trace(c)}return n}}e.$mr=v}),define(oe[228],ae([0,1,3,99,2,17,67,23]),function(V,e,i,o,S,D,O,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xs=e.$Ws=void 0;class y extends S.$Wc{constructor(f,g){super(),this.a=f,this.b=g,this.F=new Map,this.G=new Map}call(f,g,b){const l=this.c(f);switch(g){case"stat":return this.g(l,b[0]);case"readdir":return this.h(l,b[0]);case"open":return this.r(l,b[0],b[1]);case"close":return this.s(b[0]);case"read":return this.t(b[0],b[1],b[2]);case"readFile":return this.j(l,b[0],b[1]);case"write":return this.u(b[0],b[1],b[2],b[3],b[4]);case"writeFile":return this.n(l,b[0],b[1],b[2]);case"rename":return this.z(l,b[0],b[1],b[2]);case"copy":return this.C(l,b[0],b[1],b[2]);case"cloneFile":return this.D(l,b[0],b[1]);case"mkdir":return this.w(l,b[0]);case"delete":return this.y(l,b[0],b[1]);case"watch":return this.I(l,b[0],b[1],b[2],b[3]);case"unwatch":return this.J(b[0],b[1])}throw new Error(`IPC Command ${g} not found`)}listen(f,g,b){const l=this.c(f);switch(g){case"fileChange":return this.H(l,b[0]);case"readFileStream":return this.m(l,b[0],b[1])}throw new Error(`Unknown event ${g}`)}g(f,g){const b=this.f(f,g,!0);return this.a.stat(b)}h(f,g){const b=this.f(f,g);return this.a.readdir(b)}async j(f,g,b){const l=this.f(f,g,!0),m=await this.a.readFile(l,b);return D.$Oe.wrap(m)}m(f,g,b){const l=this.f(f,g,!0),m=new P.$xe,p=new i.$me({onDidRemoveLastListener:()=>{m.cancel()}}),$=this.a.readFileStream(l,b,m.token);return(0,O.$Ge)($,{onData:w=>p.fire(D.$Oe.wrap(w)),onError:w=>p.fire(w),onEnd:()=>{p.fire("end"),p.dispose(),m.dispose()}}),p.event}n(f,g,b,l){const m=this.f(f,g);return this.a.writeFile(m,b.buffer,l)}r(f,g,b){const l=this.f(f,g,!0);return this.a.open(l,b)}s(f){return this.a.close(f)}async t(f,g,b){const l=D.$Oe.alloc(b),p=await this.a.read(f,g,l.buffer,0,b);return[l,p]}u(f,g,b,l,m){return this.a.write(f,g,b.buffer,l,m)}w(f,g){const b=this.f(f,g);return this.a.mkdir(b)}y(f,g,b){const l=this.f(f,g);return this.a.delete(l,b)}z(f,g,b,l){const m=this.f(f,g),p=this.f(f,b);return this.a.rename(m,p,l)}C(f,g,b,l){const m=this.f(f,g),p=this.f(f,b);return this.a.copy(m,p,l)}D(f,g,b){const l=this.f(f,g),m=this.f(f,b);return this.a.cloneFile(l,m)}H(f,g){const b=new i.$me({onWillAddFirstListener:()=>{this.F.set(g,this.L(f,b))},onDidRemoveLastListener:()=>{(0,S.$Rc)(this.F.get(g)),this.F.delete(g)}});return b.event}async I(f,g,b,l,m){const p=this.F.get(g);if(p){const $=this.f(f,l),w=p.watch(b,$,m);this.G.set(g+b,w)}}async J(f,g){const b=f+g,l=this.G.get(b);l&&((0,S.$Rc)(l),this.G.delete(b))}dispose(){super.dispose();for(const[,f]of this.G)f.dispose();this.G.clear();for(const[,f]of this.F)f.dispose();this.F.clear()}}e.$Ws=y;class a extends S.$Wc{constructor(f,g,b,l){super(),this.c=f,this.f=b,this.g=l,this.a=new Map,this.b=this.B(new o.$mr(this.f,{watcher:{recursive:this.j(this.g)}})),this.h(g)}h(f){const g=this.B(new i.$me);this.B(g.event(b=>{f.fire(b.map(l=>({resource:this.c.transformOutgoingURI(l.resource),type:l.type,cId:l.cId})))})),this.B(this.b.onDidChangeFile(b=>g.fire(b))),this.B(this.b.onDidWatchError(b=>f.fire(b)))}j(f){}m(f){}watch(f,g,b){const l=this.m(this.g);return Array.isArray(l)&&(b.excludes=[...b.excludes,...l]),this.a.set(f,this.b.watch(g,b)),(0,S.$Uc)(()=>{(0,S.$Rc)(this.a.get(f)),this.a.delete(f)})}dispose(){for(const[,f]of this.a)f.dispose();this.a.clear(),super.dispose()}}e.$Xs=a}),define(oe[229],ae([0,1,14,183,4,7,15,9,228,160,53]),function(V,e,i,o,S,D,O,P,y,a,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cfc=void 0;class f extends y.$Ws{constructor(l,m,p){super(l,m),this.M=p}c(l){return a.$Kn}f(l,m){return D.URI.revive(m)}async y(l,m,p){if(!p.useTrash)return super.y(l,m,p);const $=this.f(l,m),w=(0,P.$jc)($.fsPath);try{await i.shell.trashItem(w)}catch(v){throw(0,O.$ml)(S.$i?(0,o.localize)(0,null,(0,P.$pc)(w),(0,h.$qj)(v)):(0,o.localize)(1,null,(0,P.$pc)(w),(0,h.$qj)(v)),O.FileSystemProviderErrorCode.Unknown)}}L(l,m){return new g(l,m,this.b,this.M)}}e.$cfc=f;class g extends y.$Xs{watch(l,m,p){if(p.recursive)throw(0,O.$ml)("Recursive file watching is not supported from main process for performance reasons.",O.FileSystemProviderErrorCode.Unavailable);return super.watch(l,m,p)}}}),define(oe[230],ae([0,1,5]),function(V,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vbc=void 0;class o extends i.$fk{constructor(D=i.$ck){super(),this.m=[],this.n=void 0,this.setLevel(D),this.B(this.onDidChangeLogLevel(O=>{this.n?.setLevel(O)}))}set logger(D){this.n=D;for(const{level:O,message:P}of this.m)(0,i.log)(D,O,P);this.m=[]}g(D,O){this.n?(0,i.log)(this.n,D,O):this.getLevel()<=D&&this.m.push({level:D,message:O})}dispose(){this.n?.dispose(),super.dispose()}flush(){this.n?.flush()}}e.$Vbc=o}),define(oe[231],ae([0,1,7,3,5,2]),function(V,e,i,o,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$os=e.$ns=e.$ms=void 0;class O extends S.$kk{constructor(f,g,b,l,m){super(g,b,l),this.r=f,this.t=m,this.B(m.listen("onDidChangeLogLevel",f)(p=>{(0,S.$bk)(p)?super.setLogLevel(p):super.setLogLevel(i.URI.revive(p[0]),p[1])})),this.B(m.listen("onDidChangeVisibility",f)(([p,$])=>super.setVisibility(i.URI.revive(p),$))),this.B(m.listen("onDidChangeLoggers",f)(({added:p,removed:$})=>{for(const w of p)super.registerLogger({...w,resource:i.URI.revive(w.resource)});for(const w of $)super.deregisterLogger(w.resource)}))}createConsoleMainLogger(){return new S.$ik({log:(f,g)=>{this.t.call("consoleLog",[f,g])}})}registerLogger(f){super.registerLogger(f),this.t.call("registerLogger",[f,this.r])}deregisterLogger(f){super.deregisterLogger(f),this.t.call("deregisterLogger",[f,this.r])}setLogLevel(f,g){super.setLogLevel(f,g),this.t.call("setLogLevel",[f,g])}setVisibility(f,g){super.setVisibility(f,g),this.t.call("setVisibility",[this.n(f),g])}s(f,g,b){return new P(this.t,f,g,b,this.r)}static setLogLevel(f,g,b){return f.call("setLogLevel",[g,b])}}e.$ms=O;class P extends S.$fk{constructor(f,g,b,l,m){super(l?.logLevel==="always"),this.r=f,this.s=g,this.m=!1,this.n=[],this.setLevel(b),this.r.call("createLogger",[g,l,m]).then(()=>{this.u(this.n),this.m=!0})}g(f,g){const b=[[f,g]];this.m?this.u(b):this.n.push(...b)}u(f){this.r.call("log",[this.s,f])}}class y{constructor(f,g){this.a=f,this.b=g}listen(f,g){const b=this.b(f);switch(g){case"onDidChangeLoggers":return o.Event.map(this.a.onDidChangeLoggers,l=>({added:[...l.added].map(m=>this.c(m,b)),removed:[...l.removed].map(m=>this.c(m,b))}));case"onDidChangeVisibility":return o.Event.map(this.a.onDidChangeVisibility,l=>[b.transformOutgoingURI(l[0]),l[1]]);case"onDidChangeLogLevel":return o.Event.map(this.a.onDidChangeLogLevel,l=>(0,S.$bk)(l)?l:[b.transformOutgoingURI(l[0]),l[1]])}throw new Error(`Event not found: ${g}`)}async call(f,g,b){const l=this.b(f);switch(g){case"setLogLevel":return(0,S.$bk)(b[0])?this.a.setLogLevel(b[0]):this.a.setLogLevel(i.URI.revive(l.transformIncoming(b[0][0])),b[0][1]);case"getRegisteredLoggers":return Promise.resolve([...this.a.getRegisteredLoggers()].map(m=>this.c(m,l)))}throw new Error(`Call not found: ${g}`)}c(f,g){return{...f,resource:g.transformOutgoingURI(f.resource)}}}e.$ns=y;class a extends D.$Wc{constructor(f,g){super(),g.call("setLogLevel",[f.getLogLevel()]),this.B(f.onDidChangeLogLevel(b=>g.call("setLogLevel",[b]))),g.call("getRegisteredLoggers").then(b=>{for(const l of b)f.registerLogger({...l,resource:i.URI.revive(l.resource)})}),this.B(g.listen("onDidChangeVisibility")(([b,l])=>f.setVisibility(i.URI.revive(b),l))),this.B(g.listen("onDidChangeLoggers")(({added:b,removed:l})=>{for(const m of b)f.registerLogger({...m,resource:i.URI.revive(m.resource)});for(const m of l)f.deregisterLogger(m.resource)}))}}e.$os=a}),define(oe[232],ae([0,1,2,5]),function(V,e,i,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lR=void 0;class S extends i.$Wc{constructor(O,P=[]){super(),this.a=new o.$jk([O,...P]),this.B(O.onDidChangeLogLevel(y=>this.setLevel(y)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(O){this.a.setLevel(O)}getLevel(){return this.a.getLevel()}trace(O,...P){this.a.trace(O,...P)}debug(O,...P){this.a.debug(O,...P)}info(O,...P){this.a.info(O,...P)}warn(O,...P){this.a.warn(O,...P)}error(O,...P){this.a.error(O,...P)}flush(){this.a.flush()}}e.$lR=S}),define(oe[233],ae([0,1,32,7,5]),function(V,e,i,o,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_fc=void 0;class D{constructor(P){this.b=P,this.a=new i.$Cc}listen(P,y,a){switch(y){case"onDidChangeLoggers":return a?this.b.getOnDidChangeLoggersEvent(a):this.b.onDidChangeLoggers;case"onDidChangeLogLevel":return a?this.b.getOnDidChangeLogLevelEvent(a):this.b.onDidChangeLogLevel;case"onDidChangeVisibility":return a?this.b.getOnDidChangeVisibilityEvent(a):this.b.onDidChangeVisibility}throw new Error(`Event not found: ${y}`)}async call(P,y,a){switch(y){case"createLogger":this.c(o.URI.revive(a[0]),a[1],a[2]);return;case"log":return this.e(o.URI.revive(a[0]),a[1]);case"consoleLog":return this.d(a[0],a[1]);case"setLogLevel":return(0,S.$bk)(a[0])?this.b.setLogLevel(a[0]):this.b.setLogLevel(o.URI.revive(a[0]),a[1]);case"setVisibility":return this.b.setVisibility(o.URI.revive(a[0]),a[1]);case"registerLogger":return this.b.registerLogger({...a[0],resource:o.URI.revive(a[0].resource)},a[1]);case"deregisterLogger":return this.b.deregisterLogger(o.URI.revive(a[0]))}throw new Error(`Call not found: ${y}`)}c(P,y,a){this.a.set(P,this.b.createLogger(P,y,a))}d(P,y){let a=console.log;switch(P){case S.LogLevel.Error:a=console.error;break;case S.LogLevel.Warning:a=console.warn;break;case S.LogLevel.Info:a=console.info;break}a.call(console,...y)}e(P,y){const a=this.a.get(P);if(!a)throw new Error("Create the logger before logging");for(const[h,f]of y)(0,S.log)(a,h,f)}}e.$_fc=D}),define(oe[234],ae([0,1,15,5]),function(V,e,i,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aR=void 0;var S;(function(a){a[a.Trace=0]="Trace",a[a.Debug=1]="Debug",a[a.Info=2]="Info",a[a.Warning=3]="Warning",a[a.Error=4]="Error",a[a.Critical=5]="Critical",a[a.Off=6]="Off"})(S||(S={}));async function D(a,h,f,g,b){try{const l=await new Promise((p,$)=>{V(["@vscode/spdlog"],p,$)}).then(Re);l.setFlushOn(S.Trace);const m=await l.createAsyncRotatingLogger(a,h,f,g);return b?m.clearFormatters():m.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),m}catch(l){console.error(l)}return null}function O(a,h,f){switch(h){case o.LogLevel.Trace:a.trace(f);break;case o.LogLevel.Debug:a.debug(f);break;case o.LogLevel.Info:a.info(f);break;case o.LogLevel.Warning:a.warn(f);break;case o.LogLevel.Error:a.error(f);break;case o.LogLevel.Off:break;default:throw new Error(`Invalid log level ${h}`)}}function P(a,h){switch(h){case o.LogLevel.Trace:a.setLevel(S.Trace);break;case o.LogLevel.Debug:a.setLevel(S.Debug);break;case o.LogLevel.Info:a.setLevel(S.Info);break;case o.LogLevel.Warning:a.setLevel(S.Warning);break;case o.LogLevel.Error:a.setLevel(S.Error);break;case o.LogLevel.Off:a.setLevel(S.Off);break;default:throw new Error(`Invalid log level ${h}`)}}class y extends o.$fk{constructor(h,f,g,b,l){super(),this.m=[],this.setLevel(l),this.n=this.s(h,f,g,b),this.B(this.onDidChangeLogLevel(m=>{this.r&&P(this.r,m)}))}async s(h,f,g,b){const l=g?6:1,m=30/l*i.$Hl.MB,p=await D(h,f,m,l,b);if(p){this.r=p,P(this.r,this.getLevel());for(const{level:$,message:w}of this.m)O(this.r,$,w);this.m=[]}}g(h,f){this.r?O(this.r,h,f):this.getLevel()<=h&&this.m.push({level:h,message:f})}flush(){this.r?this.r.flush():this.n.then(()=>this.flush())}dispose(){this.r?this.u():this.n.then(()=>this.u()),super.dispose()}u(){this.r&&(this.r.drop(),this.r=void 0)}}e.$aR=y}),define(oe[235],ae([0,1,33,5,234]),function(V,e,i,o,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bR=void 0;class D extends o.$kk{s(P,y,a){return new S.$aR((0,i.$2g)(),P.fsPath,!a?.donotRotate,!!a?.donotUseFormatters,y)}}e.$bR=D}),define(oe[71],ae([0,1,32,3,6,5,235]),function(V,e,i,o,S,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kec=e.$Jec=void 0,e.$Jec=(0,S.$Gi)(D.$ak);class P extends O.$bR{constructor(){super(...arguments),this.u=new i.$Cc}createLogger(a,h,f){f!==void 0&&this.u.set(this.n(a),f);try{return super.createLogger(a,h)}catch(g){throw this.u.delete(this.n(a)),g}}registerLogger(a,h){h!==void 0&&this.u.set(a.resource,h),super.registerLogger(a)}deregisterLogger(a){this.u.delete(a),super.deregisterLogger(a)}getRegisteredLoggers(a){const h=[];for(const f of super.getRegisteredLoggers())a===this.u.get(f.resource)&&h.push(f);return h}getOnDidChangeLogLevelEvent(a){return o.Event.filter(this.onDidChangeLogLevel,h=>(0,D.$bk)(h)||this.w(h[0],a))}getOnDidChangeVisibilityEvent(a){return o.Event.filter(this.onDidChangeVisibility,([h])=>this.w(h,a))}getOnDidChangeLoggersEvent(a){return o.Event.filter(o.Event.map(this.onDidChangeLoggers,h=>({added:[...h.added].filter(g=>this.w(g.resource,a)),removed:[...h.removed].filter(g=>this.w(g.resource,a))})),h=>h.added.length>0||h.removed.length>0)}deregisterLoggers(a){for(const[h,f]of this.u)f===a&&this.deregisterLogger(h)}w(a,h){const f=this.u.get(a);return f===void 0||f===h}dispose(){super.dispose(),this.u.clear()}}e.$Kec=P}),define(oe[236],ae([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pfc=i,e.$qfc=o,e.$rfc=S,e.$sfc=D;function i(O){return O.submenu!==void 0}function o(O){return O.id==="vscode.menubar.separator"}function S(O){return O.uri!==void 0}function D(O){return!i(O)&&!o(O)&&!S(O)}}),define(oe[40],ae([0,1,3,76,2,6]),function(V,e,i,o,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$so=e.$ro=e.$qo=void 0,e.$qo=(0,D.$Fi)("policy");class O extends S.$Wc{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new i.$me),this.onDidChange=this.h.event}async updatePolicyDefinitions(a){const h=Object.keys(this.f).length;return this.f={...a,...this.f},h!==Object.keys(this.f).length&&await this.j(a),o.Iterable.reduce(this.g.entries(),(f,[g,b])=>({...f,[g]:b}),{})}getPolicyValue(a){return this.g.get(a)}serialize(){return o.Iterable.reduce(Object.entries(this.f),(a,[h,f])=>({...a,[h]:{definition:f,value:this.g.get(h)}}),{})}}e.$ro=O;class P{constructor(){this.onDidChange=i.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.$so=P}),define(oe[237],ae([0,1,8,3,76,12,15,5,40]),function(V,e,i,o,S,D,O,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sgc=void 0;function a(f,g){const b=[];for(const l of new Set(S.Iterable.concat(f.keys(),g.keys())))f.get(l)!==g.get(l)&&b.push(l);return b}let h=class extends y.$ro{constructor(g,b,l){super(),this.m=g,this.n=b,this.s=l,this.c=this.B(new i.$Dh(500));const m=o.Event.filter(b.onDidFilesChange,p=>p.affects(g));this.B(b.watch(g)),this.B(m(()=>this.c.trigger(()=>this.w())))}async j(){await this.w()}async u(){const g=new Map;try{const b=await this.n.readFile(this.m),l=JSON.parse(b.value.toString());if(!(0,D.$hg)(l))throw new Error("Policy file isn't a JSON object");for(const m of Object.keys(l))this.f[m]&&g.set(m,l[m])}catch(b){b.fileOperationResult!==O.FileOperationResult.FILE_NOT_FOUND&&this.s.error("[FilePolicyService] Failed to read policies",b)}return g}async w(){const g=await this.u(),b=a(this.g,g);this.g=g,b.length>0&&this.h.fire(b)}};e.$sgc=h,e.$sgc=h=Se([re(1,O.$_k),re(2,P.$_j)],h)}),define(oe[238],ae([0,1,3,2,40]),function(V,e,i,o,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2fc=e.$1fc=void 0;class D{constructor(y){this.b=y,this.a=new o.$Vc}listen(y,a){switch(a){case"onDidChange":return i.Event.map(this.b.onDidChange,h=>h.reduce((f,g)=>({...f,[g]:this.b.getPolicyValue(g)??null}),{}),this.a)}throw new Error(`Event not found: ${a}`)}call(y,a,h){switch(a){case"updatePolicyDefinitions":return this.b.updatePolicyDefinitions(h)}throw new Error(`Call not found: ${a}`)}dispose(){this.a.dispose()}}e.$1fc=D;class O extends S.$ro{constructor(y,a){super(),this.a=a;for(const h in y){const{definition:f,value:g}=y[h];this.f[h]=f,g!==void 0&&this.g.set(h,g)}this.a.listen("onDidChange")(h=>{for(const f in h){const g=h[f];g===null?this.g.delete(f):this.g.set(f,g)}this.h.fire(Object.keys(h))})}async j(y){const a=await this.a.call("updatePolicyDefinitions",y);for(const h in a)this.g.set(h,a[h])}}e.$2fc=O}),define(oe[239],ae([0,1,40,8,2,5]),function(V,e,i,o,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rgc=void 0;let O=class extends i.$ro{constructor(y,a){super(),this.m=y,this.n=a,this.a=new o.$zh,this.b=this.B(new S.$Xc)}async j(y){this.m.trace(`NativePolicyService#_updatePolicyDefinitions - Found ${Object.keys(y).length} policy definitions`);const{createWatcher:a}=await new Promise((h,f)=>{V(["@vscode/policy-watcher"],h,f)}).then(Re);await this.a.queue(()=>new Promise((h,f)=>{try{this.b.value=a(this.n,y,g=>{this.t(g),h()})}catch(g){this.m.error("NativePolicyService#_updatePolicyDefinitions - Error creating watcher:",g),f(g)}}))}t(y){this.m.trace(`NativePolicyService#_onDidPolicyChange - Updated policy values: ${JSON.stringify(y)}`);for(const a in y){const h=y[a];h===void 0?this.g.delete(a):this.g.set(a,h)}this.h.fire(Object.keys(y))}};e.$rgc=O,e.$rgc=O=Se([re(0,D.$_j)],O)}),define(oe[84],ae([0,1,36]),function(V,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let o;const S=globalThis.vscode;if(typeof S<"u"&&typeof S.context<"u"){const D=S.context.configuration();if(D)o=D.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(o=globalThis._VSCODE_PRODUCT_JSON,i.env.VSCODE_DEV&&Object.assign(o,{nameShort:`${o.nameShort} Dev`,nameLong:`${o.nameLong} Dev`,dataFolderName:`${o.dataFolderName}-dev`,serverDataFolderName:o.serverDataFolderName?`${o.serverDataFolderName}-dev`:void 0}),!o.version){const D=globalThis._VSCODE_PACKAGE_JSON;Object.assign(o,{version:D.version})}}else o={},Object.keys(o).length===0&&Object.assign(o,{version:"1.91.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=o}),define(oe[28],ae([0,1,6]),function(V,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tk=e.$sk=void 0,e.$sk=(0,i.$Fi)("productService"),e.$tk="vscode://schemas/vscode-product"}),define(oe[240],ae([0,1,8,5]),function(V,e,i,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ffc=void 0;let S=class{constructor(O,P,y){this.a=O,this.b=P,this.c=y}async inspect(O){await this.d();const P=this.a.webContents.debugger;await P.sendCommand("Profiler.start"),this.c.warn("[perf] profiling STARTED",this.b),await(0,i.$Gh)(O);const y=await P.sendCommand("Profiler.stop");return this.c.warn("[perf] profiling DONE",this.b),await this.e(),y.profile}async d(){const O=this.a.webContents.debugger;O.attach(),await O.sendCommand("Profiler.enable")}async e(){const O=this.a.webContents.debugger;await O.sendCommand("Profiler.disable"),O.detach()}};e.$ffc=S,e.$ffc=S=Se([re(2,o.$_j)],S)}),define(oe[85],ae([0,1,6]),function(V,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sec=void 0,e.$sec=(0,i.$Fi)("protocolMainService")}),define(oe[45],ae([0,1,141,12]),function(V,e,i,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oo=void 0,i=Re(i),o=Re(o);class S{constructor(){this.a=new Map}add(O,P){i.ok(o.$fg(O)),i.ok(o.$hg(P)),i.ok(!this.a.has(O),"There is already an extension with this id"),this.a.set(O,P)}knows(O){return this.a.has(O)}as(O){return this.a.get(O)||null}}e.$oo=new S}),define(oe[241],ae([0,1,3,45]),function(V,e,i,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$po=void 0,o=Re(o),e.$po={JSONContribution:"base.contributions.json"};function S(P){return P.length>0&&P.charAt(P.length-1)==="#"?P.substring(0,P.length-1):P}class D{constructor(){this.b=new i.$me,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(y,a){this.a[S(y)]=a,this.b.fire(y)}notifySchemaChanged(y){this.b.fire(y)}getSchemaContributions(){return{schemas:this.a}}}const O=new D;o.$oo.add(e.$po.JSONContribution,O)}),define(oe[54],ae([0,1,22,3,12,168,18,241,45]),function(V,e,i,o,S,D,O,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Do=e.$Co=e.$Bo=e.$Ao=e.$zo=e.$yo=e.$xo=e.$wo=e.$vo=e.$uo=e.ConfigurationScope=e.$to=e.EditPresentationTypes=void 0,e.$Eo=m,e.$Fo=p,e.$Go=$,e.$Ho=v,e.$Io=k,S=Re(S),D=Re(D);var a;(function(t){t.Multiline="multilineText",t.Singleline="singlelineText"})(a||(e.EditPresentationTypes=a={})),e.$to={Configuration:"base.contributions.configuration"};var h;(function(t){t[t.APPLICATION=1]="APPLICATION",t[t.MACHINE=2]="MACHINE",t[t.WINDOW=3]="WINDOW",t[t.RESOURCE=4]="RESOURCE",t[t.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",t[t.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(h||(e.ConfigurationScope=h={})),e.$uo={properties:{},patternProperties:{}},e.$vo={properties:{},patternProperties:{}},e.$wo={properties:{},patternProperties:{}},e.$xo={properties:{},patternProperties:{}},e.$yo={properties:{},patternProperties:{}},e.$zo={properties:{},patternProperties:{}},e.$Ao="vscode://schemas/settings/resourceLanguage",e.$Bo="vscode://schemas/settings/configurationDefaults";const f=y.$oo.as(P.$po.JSONContribution);class g{constructor(){this.h=new Set,this.i=new o.$me,this.onDidSchemaChange=this.i.event,this.j=new o.$me,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:D.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},f.registerSchema(e.$Ao,this.g),this.v()}registerConfiguration(r,n=!0){this.registerConfigurations([r],n)}registerConfigurations(r,n=!0){const c=new Set;this.n(r,n,c),f.registerSchema(e.$Ao,this.g),this.i.fire(),this.j.fire({properties:c})}deregisterConfigurations(r){const n=new Set;this.o(r,n),f.registerSchema(e.$Ao,this.g),this.i.fire(),this.j.fire({properties:n})}updateConfigurations({add:r,remove:n}){const c=new Set;this.o(n,c),this.n(r,!1,c),f.registerSchema(e.$Ao,this.g),this.i.fire(),this.j.fire({properties:c})}registerDefaultConfigurations(r){const n=new Set;this.k(r,n),this.i.fire(),this.j.fire({properties:n,defaultsOverrides:!0})}k(r,n){const c=[];for(const{overrides:s,source:u}of r)for(const d in s)if(n.add(d),e.$Do.test(d)){const I=this.a.get(d),E=I?.valuesSources??new Map;if(u)for(const R of Object.keys(s[d]))E.set(R,u);const A={...I?.value||{},...s[d]};this.a.set(d,{source:u,value:A,valuesSources:E});const T=(0,O.$jj)(d),L={type:"object",default:A,description:D.localize(1,null,T),$ref:e.$Ao,defaultDefaultValue:A,source:S.$fg(u)?void 0:u,defaultValueSource:u};c.push(...m(d)),this.d[d]=L,this.b.properties[d]=L}else{this.a.set(d,{value:s[d],source:u});const I=this.d[d];I&&(this.w(d,I),this.r(d,I))}this.m(c)}deregisterDefaultConfigurations(r){const n=new Set;this.l(r,n),this.i.fire(),this.j.fire({properties:n,defaultsOverrides:!0})}l(r,n){for(const{overrides:c,source:s}of r)for(const u in c){const d=this.a.get(u),I=S.$fg(s)?s:s?.id,E=S.$fg(d?.source)?d?.source:d?.source?.id;if(I===E)if(n.add(u),this.a.delete(u),e.$Do.test(u))delete this.d[u],delete this.b.properties[u];else{const A=this.d[u];A&&(this.w(u,A),this.r(u,A))}}this.u()}deltaConfiguration(r){let n=!1;const c=new Set;r.removedDefaults&&(this.l(r.removedDefaults,c),n=!0),r.addedDefaults&&(this.k(r.addedDefaults,c),n=!0),r.removedConfigurations&&this.o(r.removedConfigurations,c),r.addedConfigurations&&this.n(r.addedConfigurations,!1,c),this.i.fire(),this.j.fire({properties:c,defaultsOverrides:n})}notifyConfigurationSchemaUpdated(...r){this.i.fire()}registerOverrideIdentifiers(r){this.m(r),this.i.fire()}m(r){for(const n of r)this.h.add(n);this.u()}n(r,n,c){r.forEach(s=>{this.p(s,n,s.extensionInfo,s.restrictedProperties,void 0,c),this.c.push(s),this.q(s)})}o(r,n){const c=s=>{if(s.properties)for(const u in s.properties){n.add(u);const d=this.d[u];d?.policy?.name&&this.e.delete(d.policy.name),delete this.d[u],this.s(u,s.properties[u])}s.allOf?.forEach(u=>c(u))};for(const s of r){c(s);const u=this.c.indexOf(s);u!==-1&&this.c.splice(u,1)}}p(r,n=!0,c,s,u=h.WINDOW,d){u=S.$og(r.scope)?u:r.scope;const I=r.properties;if(I)for(const A in I){const T=I[A];if(n&&v(A,T)){delete I[A];continue}if(T.source=c,T.defaultDefaultValue=I[A].default,this.w(A,T),e.$Do.test(A)?T.scope=void 0:(T.scope=S.$og(T.scope)?u:T.scope,T.restricted=S.$og(T.restricted)?!!s?.includes(A):T.restricted),I[A].hasOwnProperty("included")&&!I[A].included){this.f[A]=I[A],delete I[A];continue}else this.d[A]=I[A],I[A].policy?.name&&this.e.set(I[A].policy.name,A);!I[A].deprecationMessage&&I[A].markdownDeprecationMessage&&(I[A].deprecationMessage=I[A].markdownDeprecationMessage),d.add(A)}const E=r.allOf;if(E)for(const A of E)this.p(A,n,c,s,u,d)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(r){const n=c=>{const s=c.properties;if(s)for(const d in s)this.r(d,s[d]);c.allOf?.forEach(n)};n(r)}r(r,n){switch(e.$uo.properties[r]=n,n.scope){case h.APPLICATION:e.$vo.properties[r]=n;break;case h.MACHINE:e.$wo.properties[r]=n;break;case h.MACHINE_OVERRIDABLE:e.$xo.properties[r]=n;break;case h.WINDOW:e.$yo.properties[r]=n;break;case h.RESOURCE:e.$zo.properties[r]=n;break;case h.LANGUAGE_OVERRIDABLE:e.$zo.properties[r]=n,this.g.properties[r]=n;break}}s(r,n){switch(delete e.$uo.properties[r],n.scope){case h.APPLICATION:delete e.$vo.properties[r];break;case h.MACHINE:delete e.$wo.properties[r];break;case h.MACHINE_OVERRIDABLE:delete e.$xo.properties[r];break;case h.WINDOW:delete e.$yo.properties[r];break;case h.RESOURCE:case h.LANGUAGE_OVERRIDABLE:delete e.$zo.properties[r],delete this.g.properties[r];break}}u(){for(const r of this.h.values()){const n=`[${r}]`,c={type:"object",description:D.localize(2,null),errorMessage:D.localize(3,null),$ref:e.$Ao};this.w(n,c),e.$uo.properties[n]=c,e.$vo.properties[n]=c,e.$wo.properties[n]=c,e.$xo.properties[n]=c,e.$yo.properties[n]=c,e.$zo.properties[n]=c}}v(){const r={type:"object",description:D.localize(4,null),errorMessage:D.localize(5,null),$ref:e.$Ao};e.$uo.patternProperties[e.$Co]=r,e.$vo.patternProperties[e.$Co]=r,e.$wo.patternProperties[e.$Co]=r,e.$xo.patternProperties[e.$Co]=r,e.$yo.patternProperties[e.$Co]=r,e.$zo.patternProperties[e.$Co]=r,this.i.fire()}w(r,n){const c=this.a.get(r);let s=c?.value,u=c?.source;S.$mg(s)&&(s=n.defaultDefaultValue,u=void 0),S.$mg(s)&&(s=$(n.type)),n.default=s,n.defaultValueSource=u}}const b="\\[([^\\]]+)\\]",l=new RegExp(b,"g");e.$Co=`^(${b})+$`,e.$Do=new RegExp(e.$Co);function m(t){const r=[];if(e.$Do.test(t)){let n=l.exec(t);for(;n?.length;){const c=n[1].trim();c&&r.push(c),n=l.exec(t)}}return(0,i.$Ob)(r)}function p(t){return t.reduce((r,n)=>`${r}[${n}]`,"")}function $(t){switch(Array.isArray(t)?t[0]:t){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}const w=new g;y.$oo.add(e.$to.Configuration,w);function v(t,r){return t.trim()?e.$Do.test(t)?D.localize(7,null,t):w.getConfigurationProperties()[t]!==void 0?D.localize(8,null,t):r.policy?.name&&w.getPolicyConfigurations().get(r.policy?.name)!==void 0?D.localize(9,null,t,r.policy?.name,w.getPolicyConfigurations().get(r.policy?.name)):null:D.localize(6,null)}function k(){const t=[],r=w.getConfigurationProperties();for(const n of Object.keys(r))t.push([n,r[n].scope]);return t.push(["launch",h.RESOURCE]),t.push(["task",h.RESOURCE]),t}}),define(oe[126],ae([0,1,22,3,43,2,32,35,12,7,18,54,15,45]),function(V,e,i,o,S,D,O,P,y,a,h,f,g,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oo=e.$Mo=e.$Lo=e.$Ko=e.$Jo=void 0,e.$No=k,i=Re(i),S=Re(S),P=Re(P),y=Re(y);function l(c){return Object.isFrozen(c)?c:P.$co(c)}class m{static createEmptyModel(s){return new m({},[],[],void 0,s)}constructor(s,u,d,I,E){this.b=s,this.c=u,this.d=d,this.raw=I,this.f=E,this.a=new Map}get rawConfiguration(){if(!this.g)if(this.raw?.length){const s=this.raw.map(u=>{if(u instanceof m)return u;const d=new p("",this.f);return d.parseRaw(u),d.configurationModel});this.g=s.reduce((u,d)=>d===u?d:u.merge(d),s[0])}else this.g=this;return this.g}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(s){return s?(0,h.$hj)(this.contents,s):this.contents}inspect(s,u){const d=this;return{get value(){return l(d.rawConfiguration.getValue(s))},get override(){return u?l(d.rawConfiguration.getOverrideValue(s,u)):void 0},get merged(){return l(u?d.rawConfiguration.override(u).getValue(s):d.rawConfiguration.getValue(s))},get overrides(){const I=[];for(const{contents:E,identifiers:A,keys:T}of d.rawConfiguration.overrides){const L=new m(E,T,[],void 0,d.f).getValue(s);L!==void 0&&I.push({identifiers:A,value:L})}return I.length?l(I):void 0}}}getOverrideValue(s,u){const d=this.j(u);return d?s?(0,h.$hj)(d,s):d:void 0}getKeysForOverrideIdentifier(s){const u=[];for(const d of this.overrides)d.identifiers.includes(s)&&u.push(...d.keys);return i.$Ob(u)}getAllOverrideIdentifiers(){const s=[];for(const u of this.overrides)s.push(...u.identifiers);return i.$Ob(s)}override(s){let u=this.a.get(s);return u||(u=this.h(s),this.a.set(s,u)),u}merge(...s){const u=P.$bo(this.contents),d=P.$bo(this.overrides),I=[...this.keys],E=this.raw?.length?[...this.raw]:[this];for(const A of s)if(E.push(...A.raw?.length?A.raw:[A]),!A.isEmpty()){this.i(u,A.contents);for(const T of A.overrides){const[L]=d.filter(R=>i.$wb(R.identifiers,T.identifiers));L?(this.i(L.contents,T.contents),L.keys.push(...T.keys),L.keys=i.$Ob(L.keys)):d.push(P.$bo(T))}for(const T of A.keys)I.indexOf(T)===-1&&I.push(T)}return new m(u,I,d,E.every(A=>A instanceof m)?void 0:E,this.f)}h(s){const u=this.j(s);if(!u||typeof u!="object"||!Object.keys(u).length)return this;const d={};for(const I of i.$Ob([...Object.keys(this.contents),...Object.keys(u)])){let E=this.contents[I];const A=u[I];A&&(typeof E=="object"&&typeof A=="object"?(E=P.$bo(E),this.i(E,A)):E=A),d[I]=E}return new m(d,this.keys,this.overrides,void 0,this.f)}i(s,u){for(const d of Object.keys(u)){if(d in s&&y.$hg(s[d])&&y.$hg(u[d])){this.i(s[d],u[d]);continue}s[d]=P.$bo(u[d])}}j(s){let u=null,d=null;const I=E=>{E&&(d?this.i(d,E):d=P.$bo(E))};for(const E of this.overrides)E.identifiers.length===1&&E.identifiers[0]===s?u=E.contents:E.identifiers.includes(s)&&I(E.contents);return I(u),d}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(s,u){this.k(s,u,!0)}setValue(s,u){this.k(s,u,!1)}removeValue(s){const u=this.keys.indexOf(s);u!==-1&&(this.keys.splice(u,1),(0,h.$gj)(this.contents,s),f.$Do.test(s)&&this.overrides.splice(this.overrides.findIndex(d=>i.$wb(d.identifiers,(0,f.$Eo)(s))),1))}k(s,u,d){(0,h.$fj)(this.contents,s,u,I=>this.f.error(I)),d=d||this.keys.indexOf(s)===-1,d&&this.keys.push(s),f.$Do.test(s)&&this.overrides.push({identifiers:(0,f.$Eo)(s),keys:Object.keys(this.contents[s]),contents:(0,h.$ej)(this.contents[s],I=>this.f.error(I))})}}e.$Jo=m;class p{constructor(s,u){this.f=s,this.g=u,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||m.createEmptyModel(this.g)}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(s,u){if(!y.$og(s)){const d=this.h(s);this.parseRaw(d,u)}}reparse(s){this.a&&this.parseRaw(this.a,s)}parseRaw(s,u){this.a=s;const{contents:d,keys:I,overrides:E,restricted:A,hasExcludedProperties:T}=this.i(s,u);this.b=new m(d,I,E,T?[s]:void 0,this.g),this.c=A||[]}h(s){let u={},d=null,I=[];const E=[],A=[];function T(R){Array.isArray(I)?I.push(R):d!==null&&(I[d]=R)}const L={onObjectBegin:()=>{const R={};T(R),E.push(I),I=R,d=null},onObjectProperty:R=>{d=R},onObjectEnd:()=>{I=E.pop()},onArrayBegin:()=>{const R=[];T(R),E.push(I),I=R,d=null},onArrayEnd:()=>{I=E.pop()},onLiteralValue:T,onError:(R,M,U)=>{A.push({error:R,offset:M,length:U})}};if(s)try{S.$3n(s,L),u=I[0]||{}}catch(R){this.g.error(`Error while parsing settings file ${this.f}: ${R}`),this.d=[R]}return u}i(s,u){const d=b.$oo.as(f.$to.Configuration).getConfigurationProperties(),I=this.j(s,d,!0,u);s=I.raw;const E=(0,h.$ej)(s,L=>this.g.error(`Conflict in settings file ${this.f}: ${L}`)),A=Object.keys(s),T=this.l(s,L=>this.g.error(`Conflict in settings file ${this.f}: ${L}`));return{contents:E,keys:A,overrides:T,restricted:I.restricted,hasExcludedProperties:I.hasExcludedProperties}}j(s,u,d,I){let E=!1;if(!I?.scopes&&!I?.skipRestricted&&!I?.exclude?.length)return{raw:s,restricted:[],hasExcludedProperties:E};const A={},T=[];for(const L in s)if(f.$Do.test(L)&&d){const R=this.j(s[L],u,!1,I);A[L]=R.raw,E=E||R.hasExcludedProperties,T.push(...R.restricted)}else{const R=u[L],M=R?typeof R.scope<"u"?R.scope:f.ConfigurationScope.WINDOW:void 0;R?.restricted&&T.push(L),!I.exclude?.includes(L)&&(I.include?.includes(L)||(M===void 0||I.scopes===void 0||I.scopes.includes(M))&&!(I.skipRestricted&&R?.restricted))?A[L]=s[L]:E=!0}return{raw:A,restricted:T,hasExcludedProperties:E}}l(s,u){const d=[];for(const I of Object.keys(s))if(f.$Do.test(I)){const E={};for(const A in s[I])E[A]=s[I][A];d.push({identifiers:(0,f.$Eo)(I),keys:Object.keys(E),contents:(0,h.$ej)(E,u)})}return d}}e.$Ko=p;class $ extends D.$Wc{constructor(s,u,d,I,E){super(),this.c=s,this.f=u,this.g=I,this.h=E,this.b=this.B(new o.$me),this.onDidChange=this.b.event,this.a=new p(this.c.toString(),E),this.B(this.g.watch(d.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(o.Event.any(o.Event.filter(this.g.onDidFilesChange,A=>A.contains(this.c)),o.Event.filter(this.g.onDidRunOperation,A=>(A.isOperation(g.FileOperation.CREATE)||A.isOperation(g.FileOperation.COPY)||A.isOperation(g.FileOperation.DELETE)||A.isOperation(g.FileOperation.WRITE))&&d.isEqual(A.resource,s)))(()=>this.b.fire()))}async loadConfiguration(){try{const s=await this.g.readFile(this.c);return this.a.parse(s.value.toString()||"{}",this.f),this.a.configurationModel}catch{return m.createEmptyModel(this.h)}}reparse(s){return s&&(this.f=s),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$Lo=$;class w{constructor(s,u,d,I,E,A,T,L,R,M,U,N,z){this.a=s,this.b=u,this.c=d,this.overrideIdentifiers=I,this.d=E,this.f=A,this.g=T,this.h=L,this.i=R,this.j=M,this.k=U,this.l=N,this.m=z}get value(){return l(this.c)}n(s){return s?.value!==void 0||s?.override!==void 0||s?.overrides!==void 0?s:void 0}get q(){return this.p||(this.p=this.d.inspect(this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.n(this.q)}get s(){return this.r===void 0&&(this.r=this.f?this.f.inspect(this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.g.inspect(this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.n(this.u)}get w(){return this.v||(this.v=this.h.inspect(this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.n(this.w)}get y(){return this.x||(this.x=this.i.inspect(this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.n(this.y)}get A(){return this.z||(this.z=this.j.inspect(this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.n(this.A)}get D(){return this.B===void 0&&(this.B=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.n(this.D)}get F(){return this.E===void 0&&(this.E=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.n(this.F)}get H(){return this.G===void 0&&(this.G=this.m.inspect(this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.n(this.H)}}class v{constructor(s,u,d,I,E,A,T,L,R,M){this.j=s,this.l=u,this.m=d,this.n=I,this.p=E,this.q=A,this.r=T,this.s=L,this.t=R,this.u=M,this.h=null,this.i=new O.$Cc,this.v=null}getValue(s,u,d){return this.w(s,u,d).getValue(s)}updateValue(s,u,d={}){let I;d.resource?(I=this.t.get(d.resource),I||(I=m.createEmptyModel(this.u),this.t.set(d.resource,I))):I=this.s,u===void 0?I.removeValue(s):I.setValue(s,u),d.resource||(this.h=null)}inspect(s,u,d){const I=this.w(s,u,d),E=this.A(u.resource,d),A=u.resource?this.t.get(u.resource)||this.s:this.s,T=new Set;for(const L of I.overrides)for(const R of L.identifiers)I.getOverrideValue(s,R)!==void 0&&T.add(R);return new w(s,u,I.getValue(s),T.size?[...T]:void 0,this.j,this.l.isEmpty()?void 0:this.l,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,d?this.q:void 0,E||void 0,A)}keys(s){const u=this.A(void 0,s);return{default:this.j.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.q.keys.slice(0),workspaceFolder:u?u.keys.slice(0):[]}}updateDefaultConfiguration(s){this.j=s,this.h=null,this.i.clear()}updatePolicyConfiguration(s){this.l=s}updateApplicationConfiguration(s){this.m=s,this.h=null,this.i.clear()}updateLocalUserConfiguration(s){this.n=s,this.v=null,this.h=null,this.i.clear()}updateRemoteUserConfiguration(s){this.p=s,this.v=null,this.h=null,this.i.clear()}updateWorkspaceConfiguration(s){this.q=s,this.h=null,this.i.clear()}updateFolderConfiguration(s,u){this.r.set(s,u),this.i.delete(s)}deleteFolderConfiguration(s){this.folderConfigurations.delete(s),this.i.delete(s)}compareAndUpdateDefaultConfiguration(s,u){const d=[];if(!u){const{added:I,updated:E,removed:A}=r(this.j,s);u=[...I,...E,...A]}for(const I of u)for(const E of(0,f.$Eo)(I)){const A=this.j.getKeysForOverrideIdentifier(E),T=s.getKeysForOverrideIdentifier(E),L=[...T.filter(R=>A.indexOf(R)===-1),...A.filter(R=>T.indexOf(R)===-1),...A.filter(R=>!P.$fo(this.j.override(E).getValue(R),s.override(E).getValue(R)))];d.push([E,L])}return this.updateDefaultConfiguration(s),{keys:u,overrides:d}}compareAndUpdatePolicyConfiguration(s){const{added:u,updated:d,removed:I}=r(this.l,s),E=[...u,...d,...I];return E.length&&this.updatePolicyConfiguration(s),{keys:E,overrides:[]}}compareAndUpdateApplicationConfiguration(s){const{added:u,updated:d,removed:I,overrides:E}=r(this.applicationConfiguration,s),A=[...u,...d,...I];return A.length&&this.updateApplicationConfiguration(s),{keys:A,overrides:E}}compareAndUpdateLocalUserConfiguration(s){const{added:u,updated:d,removed:I,overrides:E}=r(this.localUserConfiguration,s),A=[...u,...d,...I];return A.length&&this.updateLocalUserConfiguration(s),{keys:A,overrides:E}}compareAndUpdateRemoteUserConfiguration(s){const{added:u,updated:d,removed:I,overrides:E}=r(this.remoteUserConfiguration,s),A=[...u,...d,...I];return A.length&&this.updateRemoteUserConfiguration(s),{keys:A,overrides:E}}compareAndUpdateWorkspaceConfiguration(s){const{added:u,updated:d,removed:I,overrides:E}=r(this.workspaceConfiguration,s),A=[...u,...d,...I];return A.length&&this.updateWorkspaceConfiguration(s),{keys:A,overrides:E}}compareAndUpdateFolderConfiguration(s,u){const d=this.folderConfigurations.get(s),{added:I,updated:E,removed:A,overrides:T}=r(d,u),L=[...I,...E,...A];return(L.length||!d)&&this.updateFolderConfiguration(s,u),{keys:L,overrides:T}}compareAndDeleteFolderConfiguration(s){const u=this.folderConfigurations.get(s);if(!u)throw new Error("Unknown folder");this.deleteFolderConfiguration(s);const{added:d,updated:I,removed:E,overrides:A}=r(u,void 0);return{keys:[...d,...I,...E],overrides:A}}get defaults(){return this.j}get applicationConfiguration(){return this.m}get userConfiguration(){return this.v||(this.v=this.p.isEmpty()?this.n:this.n.merge(this.p)),this.v}get localUserConfiguration(){return this.n}get remoteUserConfiguration(){return this.p}get workspaceConfiguration(){return this.q}get folderConfigurations(){return this.r}w(s,u,d){let I=this.x(u,d);return u.overrideIdentifier&&(I=I.override(u.overrideIdentifier)),!this.l.isEmpty()&&this.l.getValue(s)!==void 0&&(I=I.merge(this.l)),I}x({resource:s},u){let d=this.y();if(u&&s){const I=u.getFolder(s);I&&(d=this.z(I.uri)||d);const E=this.t.get(s);E&&(d=d.merge(E))}return d}y(){return this.h||(this.h=this.j.merge(this.applicationConfiguration,this.userConfiguration,this.q,this.s)),this.h}z(s){let u=this.i.get(s);if(!u){const d=this.y(),I=this.r.get(s);I?(u=d.merge(I),this.i.set(s,u)):u=d}return u}A(s,u){if(u&&s){const d=u.getFolder(s);if(d)return this.r.get(d.uri)}}toData(){return{defaults:{contents:this.j.contents,overrides:this.j.overrides,keys:this.j.keys},policy:{contents:this.l.contents,overrides:this.l.overrides,keys:this.l.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.q.contents,overrides:this.q.overrides,keys:this.q.keys},folders:[...this.r.keys()].reduce((s,u)=>{const{contents:d,overrides:I,keys:E}=this.r.get(u);return s.push([u,{contents:d,overrides:I,keys:E}]),s},[])}}allKeys(){const s=new Set;return this.j.keys.forEach(u=>s.add(u)),this.userConfiguration.keys.forEach(u=>s.add(u)),this.q.keys.forEach(u=>s.add(u)),this.r.forEach(u=>u.keys.forEach(d=>s.add(d))),[...s.values()]}B(){const s=new Set;return this.j.getAllOverrideIdentifiers().forEach(u=>s.add(u)),this.userConfiguration.getAllOverrideIdentifiers().forEach(u=>s.add(u)),this.q.getAllOverrideIdentifiers().forEach(u=>s.add(u)),this.r.forEach(u=>u.getAllOverrideIdentifiers().forEach(d=>s.add(d))),[...s.values()]}D(s){const u=new Set;return this.j.getKeysForOverrideIdentifier(s).forEach(d=>u.add(d)),this.userConfiguration.getKeysForOverrideIdentifier(s).forEach(d=>u.add(d)),this.q.getKeysForOverrideIdentifier(s).forEach(d=>u.add(d)),this.r.forEach(d=>d.getKeysForOverrideIdentifier(s).forEach(I=>u.add(I))),[...u.values()]}static parse(s,u){const d=this.E(s.defaults,u),I=this.E(s.policy,u),E=this.E(s.application,u),A=this.E(s.user,u),T=this.E(s.workspace,u),L=s.folders.reduce((R,M)=>(R.set(a.URI.revive(M[0]),this.E(M[1],u)),R),new O.$Cc);return new v(d,I,E,A,m.createEmptyModel(u),T,L,m.createEmptyModel(u),new O.$Cc,u)}static E(s,u){return new m(s.contents,s.keys,s.overrides,void 0,u)}}e.$Mo=v;function k(...c){if(c.length===0)return{keys:[],overrides:[]};if(c.length===1)return c[0];const s=new Set,u=new Map;for(const I of c)I.keys.forEach(E=>s.add(E)),I.overrides.forEach(([E,A])=>{const T=(0,O.$zc)(u,E,new Set);A.forEach(L=>T.add(L))});const d=[];return u.forEach((I,E)=>d.push([E,[...I.values()]])),{keys:[...s.values()],overrides:d}}class t{constructor(s,u,d,I,E){this.change=s,this.f=u,this.g=d,this.h=I,this.i=E,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=46,this.affectedKeys=new Set,this.j=void 0;for(const A of s.keys)this.affectedKeys.add(A);for(const[,A]of s.overrides)for(const T of A)this.affectedKeys.add(T);this.d=this.a;for(const A of this.affectedKeys)this.d+=A+this.a}get previousConfiguration(){return!this.j&&this.f&&(this.j=v.parse(this.f.data,this.i)),this.j}affectsConfiguration(s,u){const d=this.a+s,I=this.d.indexOf(d);if(I<0)return!1;const E=I+d.length;if(E>=this.d.length)return!1;const A=this.d.charCodeAt(E);if(A!==this.b&&A!==this.c)return!1;if(u){const T=this.previousConfiguration?this.previousConfiguration.getValue(s,u,this.f?.workspace):void 0,L=this.g.getValue(s,u,this.h);return!P.$fo(T,L)}return!0}}e.$Oo=t;function r(c,s){const{added:u,removed:d,updated:I}=n(s?.rawConfiguration,c?.rawConfiguration),E=[],A=c?.getAllOverrideIdentifiers()||[],T=s?.getAllOverrideIdentifiers()||[];if(s){const L=T.filter(R=>!A.includes(R));for(const R of L)E.push([R,s.getKeysForOverrideIdentifier(R)])}if(c){const L=A.filter(R=>!T.includes(R));for(const R of L)E.push([R,c.getKeysForOverrideIdentifier(R)])}if(s&&c){for(const L of A)if(T.includes(L)){const R=n({contents:c.getOverrideValue(void 0,L)||{},keys:c.getKeysForOverrideIdentifier(L)},{contents:s.getOverrideValue(void 0,L)||{},keys:s.getKeysForOverrideIdentifier(L)});E.push([L,[...R.added,...R.removed,...R.updated]])}}return{added:u,removed:d,updated:I,overrides:E}}function n(c,s){const u=c?s?c.keys.filter(E=>s.keys.indexOf(E)===-1):[...c.keys]:[],d=s?c?s.keys.filter(E=>c.keys.indexOf(E)===-1):[...s.keys]:[],I=[];if(c&&s){for(const E of s.keys)if(c.keys.indexOf(E)!==-1){const A=(0,h.$hj)(s.contents,E),T=(0,h.$hj)(c.contents,E);P.$fo(A,T)||I.push(E)}}return{added:u,removed:d,updated:I}}}),define(oe[242],ae([0,1,22,3,2,35,12,126,54,5,40,45]),function(V,e,i,o,S,D,O,P,y,a,h,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ro=e.$Qo=e.$Po=void 0;class g extends S.$Wc{get configurationModel(){return this.b}constructor(p){super(),this.c=p,this.a=this.B(new o.$me),this.onDidChangeConfiguration=this.a.event,this.b=P.$Jo.createEmptyModel(this.c)}async initialize(){return this.h(),this.B(f.$oo.as(y.$to.Configuration).onDidUpdateConfiguration(({properties:p,defaultsOverrides:$})=>this.f(Array.from(p),$))),this.configurationModel}reload(){return this.h(),this.configurationModel}f(p,$){this.j(p,f.$oo.as(y.$to.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:p})}g(){return{}}h(){this.b=P.$Jo.createEmptyModel(this.c);const p=f.$oo.as(y.$to.Configuration).getConfigurationProperties();this.j(Object.keys(p),p)}j(p,$){const w=this.g();for(const v of p){const k=w[v],t=$[v];k!==void 0?this.b.addValue(v,k):t?this.b.addValue(v,t.default):this.b.removeValue(v)}}}e.$Po=g;class b{constructor(){this.onDidChangeConfiguration=o.Event.None,this.configurationModel=P.$Jo.createEmptyModel(new a.$mk)}async initialize(){return this.configurationModel}}e.$Qo=b;let l=class extends S.$Wc{get configurationModel(){return this.b}constructor(p,$,w){super(),this.c=p,this.f=$,this.g=w,this.a=this.B(new o.$me),this.onDidChangeConfiguration=this.a.event,this.b=P.$Jo.createEmptyModel(this.g)}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.m(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(p=>this.j(p))),this.B(this.c.onDidChangeConfiguration(async({properties:p})=>this.m(await this.h(p),!0))),this.b}async h(p){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",p);const $={},w=[],v=f.$oo.as(y.$to.Configuration).getConfigurationProperties();for(const k of p){const t=v[k];if(!t){w.push(k);continue}if(t.policy){if(t.type!=="string"&&t.type!=="number"){this.g.warn(`Policy ${t.policy.name} has unsupported type ${t.type}`);continue}w.push(k),$[t.policy.name]={type:t.type}}}return(0,O.$sg)($)||await this.f.updatePolicyDefinitions($),w}j(p){this.g.trace("PolicyConfiguration#onDidChangePolicies",p);const $=f.$oo.as(y.$to.Configuration).getPolicyConfigurations(),w=(0,i.$Jb)(p.map(v=>$.get(v)));this.m(w,!0)}m(p,$){this.g.trace("PolicyConfiguration#update",p);const w=f.$oo.as(y.$to.Configuration).getConfigurationProperties(),v=[],k=this.b.isEmpty();for(const t of p){const r=w[t]?.policy?.name;if(r){const n=this.f.getPolicyValue(r);(k?n!==void 0:!(0,D.$fo)(this.b.getValue(t),n))&&v.push([t,n])}else this.b.getValue(t)!==void 0&&v.push([t,void 0])}if(v.length){this.g.trace("PolicyConfiguration#changed",v);const t=this.b;this.b=P.$Jo.createEmptyModel(this.g);for(const r of t.keys)this.b.setValue(r,t.getValue(r));for(const[r,n]of v)n===void 0?this.b.removeValue(r):this.b.setValue(r,n);$&&this.a.fire(this.b)}}};e.$Ro=l,e.$Ro=l=Se([re(1,h.$qo),re(2,a.$_j)],l)}),define(oe[243],ae([0,1,22,8,17,3,43,108,2,32,35,4,19,18,126,54,242,15,40]),function(V,e,i,o,S,D,O,P,y,a,h,f,g,b,l,m,p,$,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$So=void 0;class v extends y.$Wc{constructor(r,n,c,s){super(),this.m=r,this.n=s,this.h=this.B(new D.$me),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new p.$Po(s)),this.c=c instanceof w.$so?new p.$Qo:this.B(new p.$Ro(this.b,c,s)),this.f=this.B(new l.$Lo(this.m,{},g.$0g,n,s)),this.a=new l.$Mo(this.b.configurationModel,this.c.configurationModel,l.$Jo.createEmptyModel(s),l.$Jo.createEmptyModel(s),l.$Jo.createEmptyModel(s),l.$Jo.createEmptyModel(s),new a.$Cc,l.$Jo.createEmptyModel(s),new a.$Cc,s),this.j=new k(r,n,this),this.g=this.B(new o.$Rh(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:u,properties:d})=>this.s(u,d))),this.B(this.c.onDidChangeConfiguration(u=>this.t(u))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[r,n,c]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new l.$Mo(r,n,l.$Jo.createEmptyModel(this.n),c,l.$Jo.createEmptyModel(this.n),l.$Jo.createEmptyModel(this.n),new a.$Cc,l.$Jo.createEmptyModel(this.n),new a.$Cc,this.n)}getConfigurationData(){return this.a.toData()}getValue(r,n){const c=typeof r=="string"?r:void 0,s=(0,b.$aj)(r)?r:(0,b.$aj)(n)?n:{};return this.a.getValue(c,s,void 0)}async updateValue(r,n,c,s,u){const d=(0,b.$bj)(c)?c:(0,b.$aj)(c)?{resource:c.resource,overrideIdentifiers:c.overrideIdentifier?[c.overrideIdentifier]:void 0}:void 0,I=d?s:c;if(I!==void 0&&I!==b.ConfigurationTarget.USER_LOCAL&&I!==b.ConfigurationTarget.USER)throw new Error(`Unable to write ${r} to target ${I}.`);d?.overrideIdentifiers&&(d.overrideIdentifiers=(0,i.$Ob)(d.overrideIdentifiers),d.overrideIdentifiers=d.overrideIdentifiers.length?d.overrideIdentifiers:void 0);const E=this.inspect(r,{resource:d?.resource,overrideIdentifier:d?.overrideIdentifiers?d.overrideIdentifiers[0]:void 0});if(E.policyValue!==void 0)throw new Error(`Unable to write ${r} because it is configured in system policy.`);if((0,h.$fo)(n,E.defaultValue)&&(n=void 0),d?.overrideIdentifiers?.length&&d.overrideIdentifiers.length>1){const T=d.overrideIdentifiers.sort(),L=this.a.localUserConfiguration.overrides.find(R=>(0,i.$wb)([...R.identifiers].sort(),T));L&&(d.overrideIdentifiers=L.identifiers)}const A=d?.overrideIdentifiers?.length?[(0,m.$Fo)(d.overrideIdentifiers),r]:[r];await this.j.write(A,n),await this.reloadConfiguration()}inspect(r,n={}){return this.a.inspect(r,n,void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const r=await this.f.loadConfiguration();this.r(r)}r(r){const n=this.a.toData(),c=this.a.compareAndUpdateLocalUserConfiguration(r);this.u(c,n,b.ConfigurationTarget.USER)}s(r,n){const c=this.a.toData(),s=this.a.compareAndUpdateDefaultConfiguration(r,n);this.u(s,c,b.ConfigurationTarget.DEFAULT)}t(r){const n=this.a.toData(),c=this.a.compareAndUpdatePolicyConfiguration(r);this.u(c,n,b.ConfigurationTarget.DEFAULT)}u(r,n,c){const s=new l.$Oo(r,{data:n},this.a,void 0,this.n);s.source=c,this.h.fire(s)}}e.$So=v;class k{constructor(r,n,c){this.b=r,this.c=n,this.d=c,this.a=new o.$Mh}write(r,n){return this.a.queue(()=>this.e(r,n))}async e(r,n){let c;try{c=(await this.c.readFile(this.b)).value.toString()}catch(d){if(d.fileOperationResult===$.FileOperationResult.FILE_NOT_FOUND)c="{}";else throw d}const s=[];if((0,O.$Vn)(c,s,{allowTrailingComma:!0,allowEmptyContent:!0}),s.length>0)throw new Error("Unable to write into the settings file. Please open the file to correct errors/warnings in the file and try again.");const u=this.f(c,r,n);c=(0,P.$ao)(c,u),await this.c.writeFile(this.b,S.$Oe.fromString(c))}f(r,n,c){const{tabSize:s,insertSpaces:u,eol:d}=this.h;if(!n.length){const I=JSON.stringify(c,null,u?" ".repeat(s):"	");return[{content:I,length:I.length,offset:0}]}return(0,P.$0n)(r,n,c,{tabSize:s,insertSpaces:u,eol:d})}get h(){if(!this.g){let r=f.OS===f.OperatingSystem.Linux||f.OS===f.OperatingSystem.Macintosh?`
`:`\r
`;const n=this.d.getValue("files.eol",{overrideIdentifier:"jsonc"});n&&typeof n=="string"&&n!=="auto"&&(r=n),this.g={eol:r,insertSpaces:!!this.d.getValue("editor.insertSpaces",{overrideIdentifier:"jsonc"}),tabSize:this.d.getValue("editor.tabSize",{overrideIdentifier:"jsonc"})}}return this.g}}}),define(oe[244],ae([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ggc=e.$fgc=e.$egc=void 0,e.$egc="request",e.$fgc="remoteResourceHandler";class i{async routeCall(S,D,O){if(D!==e.$egc)throw new Error(`Call not found: ${D}`);const P=O[0];if(P?.authority){const y=S.connections.find(a=>a.ctx===P.authority);if(y)return y}throw new Error("Caller not found")}routeEvent(S,D){throw new Error(`Event not found: ${D}`)}}e.$ggc=i}),define(oe[245],ae([0,1,16,6]),function(V,e,i,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tl=e.RemoteAuthorityResolverErrorCode=e.$Sl=e.$Rl=e.RemoteConnectionType=e.$Ql=void 0,e.$Ul=a,e.$Ql=(0,o.$Fi)("remoteAuthorityResolverService");var S;(function(h){h[h.WebSocket=0]="WebSocket",h[h.Managed=1]="Managed"})(S||(e.RemoteConnectionType=S={}));class D{constructor(f){this.id=f,this.type=S.Managed}toString(){return`Managed(${this.id})`}}e.$Rl=D;class O{constructor(f,g){this.host=f,this.port=g,this.type=S.WebSocket}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$Sl=O;var P;(function(h){h.Unknown="Unknown",h.NotAvailable="NotAvailable",h.TemporarilyNotAvailable="TemporarilyNotAvailable",h.NoResolverFound="NoResolverFound",h.InvalidAuthority="InvalidAuthority"})(P||(e.RemoteAuthorityResolverErrorCode=P={}));class y extends i.$db{static isNotAvailable(f){return f instanceof y&&f._code===P.NotAvailable}static isTemporarilyNotAvailable(f){return f instanceof y&&f._code===P.TemporarilyNotAvailable}static isNoResolverFound(f){return f instanceof y&&f._code===P.NoResolverFound}static isInvalidAuthority(f){return f instanceof y&&f._code===P.InvalidAuthority}static isHandled(f){return f instanceof y&&f.isHandled}constructor(f,g=P.Unknown,b){super(f),this._message=f,this._code=g,this._detail=b,this.isHandled=g===P.NotAvailable&&b===!0,Object.setPrototypeOf(this,y.prototype)}}e.$Tl=y;function a(h){const f=h.indexOf("+");return f===-1?h:h.substring(0,f)}}),define(oe[246],ae([0,1,8,17,23,16,3,2,13,70,66,33,118,245]),function(V,e,i,o,S,D,O,P,y,a,h,f,g,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0l=e.$9l=e.$8l=e.$7l=e.$6l=e.$5l=e.$4l=e.$3l=e.PersistentConnectionEventType=e.ConnectionType=void 0,e.$Zl=E,e.$1l=A,e.$2l=L,a=Re(a);const l=30*1e3;var m;(function(se){se[se.Management=1]="Management",se[se.ExtensionHost=2]="ExtensionHost",se[se.Tunnel=3]="Tunnel"})(m||(e.ConnectionType=m={}));function p(se){switch(se){case m.Management:return"Management";case m.ExtensionHost:return"ExtensionHost";case m.Tunnel:return"Tunnel"}}function $(se){const _=new S.$xe;return setTimeout(()=>_.cancel(),se),_.token}function w(se,_){if(se.isCancellationRequested||_.isCancellationRequested)return S.CancellationToken.Cancelled;const F=new S.$xe;return se.onCancellationRequested(()=>F.cancel()),_.onCancellationRequested(()=>F.cancel()),F.token}class v{get didTimeout(){return this.c==="timedout"}constructor(_){this.c="pending",this.d=new P.$Vc,{promise:this.promise,resolve:this.f,reject:this.g}=(0,i.$yh)(),_.isCancellationRequested?this.h():this.d.add(_.onCancellationRequested(()=>this.h()))}registerDisposable(_){this.c==="pending"?this.d.add(_):_.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const _=new Error("Time limit reached");return _.code="ETIMEDOUT",_.syscall="connect",_}resolve(_){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(_))}reject(_){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(_))}}function k(se,_){const F=new v(_);return F.registerDisposable(se.onControlMessage(C=>{const W=JSON.parse(C.toString()),q=j(W);q?F.reject(q):F.resolve(W)})),F.promise}function t(se,_,F,C,W,q,J,X){const Z=new v(X),ie=h.$ge.create(!1);return se.info(`Creating a socket (${J})...`),a.mark(`code/willCreateSocket/${q}`),_.connect(F,C,W,J).then(de=>{Z.didTimeout?(a.mark(`code/didCreateSocketError/${q}`),se.info(`Creating a socket (${J}) finished after ${ie.elapsed()} ms, but this is too late and has timed out already.`),de?.dispose()):(a.mark(`code/didCreateSocketOK/${q}`),se.info(`Creating a socket (${J}) was successful after ${ie.elapsed()} ms.`),Z.resolve(de))},de=>{a.mark(`code/didCreateSocketError/${q}`),se.info(`Creating a socket (${J}) returned an error after ${ie.elapsed()} ms.`),se.error(de),Z.reject(de)}),Z.promise}function r(se,_){const F=new v(_);return se.then(C=>{F.didTimeout||F.resolve(C)},C=>{F.didTimeout||F.reject(C)}),F.promise}async function n(se,_,F,C){const W=G(se,_);se.logService.trace(`${W} 1/6. invoking socketFactory.connect().`);let q;try{q=await t(se.logService,se.remoteSocketFactoryService,se.connectTo,y.$Sg.getServerRootPath(),`reconnectionToken=${se.reconnectionToken}&reconnection=${se.reconnectionProtocol?"true":"false"}`,p(_),`renderer-${p(_)}-${se.reconnectionToken}`,C)}catch(de){throw se.logService.error(`${W} socketFactory.connect() failed or timed out. Error:`),se.logService.error(de),de}se.logService.trace(`${W} 2/6. socketFactory.connect() was successful.`);let J,X;se.reconnectionProtocol?(se.reconnectionProtocol.beginAcceptReconnection(q,null),J=se.reconnectionProtocol,X=!1):(J=new g.$ti({socket:q}),X=!0),se.logService.trace(`${W} 3/6. sending AuthRequest control message.`);const Z=await r(se.signService.createNewMessage((0,f.$2g)()),C),ie={type:"auth",auth:se.connectionToken||"00000000000000000000",data:Z.data};J.sendControl(o.$Oe.fromString(JSON.stringify(ie)));try{const de=await k(J,w(C,$(1e4)));if(de.type!=="sign"||typeof de.data!="string"){const ke=new Error("Unexpected handshake message");throw ke.code="VSCODE_CONNECTION_ERROR",ke}if(se.logService.trace(`${W} 4/6. received SignRequest control message.`),!await r(se.signService.validate(Z,de.signedData),C)){const ke=new Error("Refused to connect to unsupported server");throw ke.code="VSCODE_CONNECTION_ERROR",ke}const pe=await r(se.signService.sign(de.data),C),Ie={type:"connectionType",commit:se.commit,signedData:pe,desiredConnectionType:_};return F&&(Ie.args=F),se.logService.trace(`${W} 5/6. sending ConnectionTypeRequest control message.`),J.sendControl(o.$Oe.fromString(JSON.stringify(Ie))),{protocol:J,ownsProtocol:X}}catch(de){throw de&&de.code==="ETIMEDOUT"&&(se.logService.error(`${W} the handshake timed out. Error:`),se.logService.error(de)),de&&de.code==="VSCODE_CONNECTION_ERROR"&&(se.logService.error(`${W} received error control message when negotiating connection. Error:`),se.logService.error(de)),X&&H(J),de}}async function c(se,_,F,C){const W=Date.now(),q=G(se,_),{protocol:J,ownsProtocol:X}=await n(se,_,F,C),Z=new v(C);return Z.registerDisposable(J.onControlMessage(ie=>{const de=JSON.parse(ie.toString()),me=j(de);me?(se.logService.error(`${q} received error control message when negotiating connection. Error:`),se.logService.error(me),X&&H(J),Z.reject(me)):(se.reconnectionProtocol?.endAcceptReconnection(),se.logService.trace(`${q} 6/6. handshake finished, connection is up and running after ${he(W)}!`),Z.resolve({protocol:J,firstMessage:de}))})),Z.promise}async function s(se,_){const{protocol:F}=await c(se,m.Management,void 0,_);return{protocol:F}}async function u(se,_,F){const{protocol:C,firstMessage:W}=await c(se,m.ExtensionHost,_,F),q=W&&W.debugPort;return{protocol:C,debugPort:q}}async function d(se,_,F){const C=Date.now(),W=G(se,m.Tunnel),{protocol:q}=await n(se,m.Tunnel,_,F);return se.logService.trace(`${W} 6/6. handshake finished, connection is up and running after ${he(C)}!`),q}async function I(se,_,F){const{connectTo:C,connectionToken:W}=await se.addressProvider.getAddress();return{commit:se.commit,quality:se.quality,connectTo:C,connectionToken:W,reconnectionToken:_,reconnectionProtocol:F,remoteSocketFactoryService:se.remoteSocketFactoryService,signService:se.signService,logService:se.logService}}async function E(se,_,F){return T(se,async C=>{const{protocol:W}=await s(C,S.CancellationToken.None);return new K(se,_,F,C.reconnectionToken,W)})}async function A(se,_){return T(se,async F=>{const{protocol:C,debugPort:W}=await u(F,_,S.CancellationToken.None);return new ee(se,_,F.reconnectionToken,C,W)})}async function T(se,_){for(let C=1;;C++)try{const W=(0,f.$2g)(),q=await I(se,W,null);return await _(q)}catch(W){if(C<5)se.logService.error(`[remote-connection][attempt ${C}] An error occurred in initial connection! Will retry... Error:`),se.logService.error(W);else throw se.logService.error(`[remote-connection][attempt ${C}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),se.logService.error(W),le.triggerPermanentFailure(0,0,b.$Tl.isHandled(W)),W}}async function L(se,_,F){const C=await I(se,(0,f.$2g)(),null);return await d(C,{host:_,port:F},S.CancellationToken.None)}function R(se){return(0,i.$sh)(_=>new Promise((F,C)=>{const W=setTimeout(F,se*1e3);_.onCancellationRequested(()=>{clearTimeout(W),F()})}))}var M;(function(se){se[se.ConnectionLost=0]="ConnectionLost",se[se.ReconnectionWait=1]="ReconnectionWait",se[se.ReconnectionRunning=2]="ReconnectionRunning",se[se.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",se[se.ConnectionGain=4]="ConnectionGain"})(M||(e.PersistentConnectionEventType=M={}));class U{constructor(_,F){this.reconnectionToken=_,this.millisSinceLastIncomingData=F,this.type=M.ConnectionLost}}e.$3l=U;class N{constructor(_,F,C,W){this.reconnectionToken=_,this.millisSinceLastIncomingData=F,this.durationSeconds=C,this.c=W,this.type=M.ReconnectionWait}skipWait(){this.c.cancel()}}e.$4l=N;class z{constructor(_,F,C){this.reconnectionToken=_,this.millisSinceLastIncomingData=F,this.attempt=C,this.type=M.ReconnectionRunning}}e.$5l=z;class ne{constructor(_,F,C){this.reconnectionToken=_,this.millisSinceLastIncomingData=F,this.attempt=C,this.type=M.ConnectionGain}}e.$6l=ne;class Q{constructor(_,F,C,W){this.reconnectionToken=_,this.millisSinceLastIncomingData=F,this.attempt=C,this.handled=W,this.type=M.ReconnectionPermanentFailure}}e.$7l=Q;class le extends P.$Wc{static triggerPermanentFailure(_,F,C){this._permanentFailure=!0,this.f=_,this.g=F,this.h=C,this.j.forEach(W=>W.D(this.f,this.g,this.h))}static debugTriggerReconnection(){this.j.forEach(_=>_.y())}static debugPauseSocketWriting(){this.j.forEach(_=>_.F())}static{this._permanentFailure=!1}static{this.f=0}static{this.g=0}static{this.h=!1}static{this.j=[]}get n(){return this.c||le._permanentFailure}constructor(_,F,C,W,q){super(),this.t=_,this.u=F,this.reconnectionToken=C,this.protocol=W,this.w=q,this.m=this.B(new O.$me),this.onDidStateChange=this.m.event,this.c=!1,this.r=!1,this.s=!1,this.m.fire(new ne(this.reconnectionToken,0,0)),this.B(W.onSocketClose(J=>{const X=ce(this.t,this.reconnectionToken,!0);J?J.type===g.SocketCloseEventType.NodeSocketCloseEvent?(this.u.logService.info(`${X} received socket close event (hadError: ${J.hadError}).`),J.error&&this.u.logService.error(J.error)):(this.u.logService.info(`${X} received socket close event (wasClean: ${J.wasClean}, code: ${J.code}, reason: ${J.reason}).`),J.event&&this.u.logService.error(J.event)):this.u.logService.info(`${X} received socket close event.`),this.y()})),this.B(W.onSocketTimeout(J=>{const X=ce(this.t,this.reconnectionToken,!0);this.u.logService.info(`${X} received socket timeout event (unacknowledgedMsgCount: ${J.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${J.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${J.timeSinceLastReceivedSomeData}).`),this.y()})),le.j.push(this),this.B((0,P.$Uc)(()=>{const J=le.j.indexOf(this);J>=0&&le.j.splice(J,1)})),this.n&&this.D(le.f,le.g,le.h)}dispose(){super.dispose(),this.s=!0}async y(){if(!this.r)try{this.r=!0,await this.z()}finally{this.r=!1}}async z(){if(this.n||this.s)return;const _=ce(this.t,this.reconnectionToken,!0);this.u.logService.info(`${_} starting reconnecting loop. You can get more information with the trace log level.`),this.m.fire(new U(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const F=[0,5,5,10,10,10,10,10,30];let C=-1;do{C++;const W=C<F.length?F[C]:F[F.length-1];try{if(W>0){const J=R(W);this.m.fire(new N(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),W,J)),this.u.logService.info(`${_} waiting for ${W} seconds before reconnecting...`);try{await J}catch{}}if(this.n){this.u.logService.error(`${_} permanent failure occurred while running the reconnecting loop.`);break}this.m.fire(new z(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),C+1)),this.u.logService.info(`${_} resolving connection...`);const q=await I(this.u,this.reconnectionToken,this.protocol);this.u.logService.info(`${_} connecting to ${q.connectTo}...`),await this.G(q,$(l)),this.u.logService.info(`${_} reconnected!`),this.m.fire(new ne(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),C+1));break}catch(q){if(q.code==="VSCODE_CONNECTION_ERROR"){this.u.logService.error(`${_} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.u.logService.error(q),this.C(this.protocol.getMillisSinceLastIncomingData(),C+1,!1);break}if(C>360){this.u.logService.error(`${_} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.u.logService.error(q),this.C(this.protocol.getMillisSinceLastIncomingData(),C+1,!1);break}if(b.$Tl.isTemporarilyNotAvailable(q)){this.u.logService.info(`${_} A temporarily not available error occurred while trying to reconnect, will try again...`),this.u.logService.trace(q);continue}if((q.code==="ETIMEDOUT"||q.code==="ENETUNREACH"||q.code==="ECONNREFUSED"||q.code==="ECONNRESET")&&q.syscall==="connect"){this.u.logService.info(`${_} A network error occurred while trying to reconnect, will try again...`),this.u.logService.trace(q);continue}if((0,D.$6)(q)){this.u.logService.info(`${_} A promise cancelation error occurred while trying to reconnect, will try again...`),this.u.logService.trace(q);continue}if(q instanceof b.$Tl){this.u.logService.error(`${_} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.u.logService.error(q),this.C(this.protocol.getMillisSinceLastIncomingData(),C+1,b.$Tl.isHandled(q));break}this.u.logService.error(`${_} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.u.logService.error(q),this.C(this.protocol.getMillisSinceLastIncomingData(),C+1,!1);break}}while(!this.n&&!this.s)}C(_,F,C){this.w?le.triggerPermanentFailure(_,F,C):this.D(_,F,C)}D(_,F,C){this.m.fire(new Q(this.reconnectionToken,_,F,C)),H(this.protocol)}F(){this.protocol.pauseSocketWriting()}}e.$8l=le;class K extends le{constructor(_,F,C,W,q){super(m.Management,_,W,q,!0),this.client=this.B(new g.$ri(q,{remoteAuthority:F,clientId:C},_.ipcLogger))}async G(_,F){await s(_,F)}}e.$9l=K;class ee extends le{constructor(_,F,C,W,q){super(m.ExtensionHost,_,C,W,!1),this.H=F,this.debugPort=q}async G(_,F){await u(_,this.H,F)}}e.$0l=ee;function H(se){try{se.acceptDisconnect();const _=se.getSocket();se.dispose(),_.dispose()}catch(_){(0,D.$3)(_)}}function j(se){if(se&&se.type==="error"){const _=new Error(`Connection error: ${se.reason}`);return _.code="VSCODE_CONNECTION_ERROR",_}return null}function B(se,_){for(;se.length<_;)se+=" ";return se}function x(se,_){return`[remote-connection][${B(p(se),13)}][${_.substr(0,5)}\u2026]`}function ce(se,_,F){return`${x(se,_)}[${F?"reconnect":"initial"}]`}function G(se,_){return`${ce(_,se.reconnectionToken,!!se.reconnectionProtocol)}[${se.connectTo}]`}function he(se){return`${Date.now()-se} ms`}}),define(oe[72],ae([0,1,13]),function(V,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gn=o,e.$hn=S,e.$in=D,e.$jn=O;function o(y){return y.scheme===i.Schemas.vscodeRemote?y.authority:void 0}function S(y){if(!y)return;const a=y.indexOf("+");return a<0?y:y.substr(0,a)}function D(y){const{host:a,port:h}=P(y);if(typeof h>"u")throw new Error(`Invalid remote authority: ${y}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:a,port:h}}function O(y,a){let{host:h,port:f}=P(y);return typeof f>"u"&&(f=a),{host:h,port:f}}function P(y){const a=y.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(a)return{host:a[1],port:parseInt(a[2],10)};const h=y.match(/^(\[[0-9a-z:]+\])$/);if(h)return{host:h[1],port:void 0};const f=y.match(/(.*):(\d+)$/);return f?{host:f[1],port:parseInt(f[2],10)}:{host:y,port:void 0}}}),define(oe[100],ae([0,1,26,6,72]),function(V,e,i,o,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xn=e.$sn=e.$rn=e.$qn=e.TargetPlatform=e.ExtensionType=e.$pn=e.$nn=e.$mn=e.$ln=e.$kn=void 0,e.$on=D,e.$tn=f,e.$un=g,e.$vn=b,e.$wn=l,i=Re(i),e.$kn="extensions.user.cache",e.$ln="extensions.builtin.cache",e.$mn="undefined_publisher",e.$nn=["ui","workspace","web"];function D(m){if(typeof m=="object"&&m!==null&&m.supported!==!0)return m.description}e.$pn=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","AI","Chat","Other"];var O;(function(m){m[m.System=0]="System",m[m.User=1]="User"})(O||(e.ExtensionType=O={}));var P;(function(m){m.WIN32_X64="win32-x64",m.WIN32_ARM64="win32-arm64",m.LINUX_X64="linux-x64",m.LINUX_ARM64="linux-arm64",m.LINUX_ARMHF="linux-armhf",m.ALPINE_X64="alpine-x64",m.ALPINE_ARM64="alpine-arm64",m.DARWIN_X64="darwin-x64",m.DARWIN_ARM64="darwin-arm64",m.WEB="web",m.UNIVERSAL="universal",m.UNKNOWN="unknown",m.UNDEFINED="undefined"})(P||(e.TargetPlatform=P={}));class y{constructor(p){this.value=p,this._lower=p.toLowerCase()}static equals(p,$){if(typeof p>"u"||p===null)return typeof $>"u"||$===null;if(typeof $>"u"||$===null)return!1;if(typeof p=="string"||typeof $=="string"){const w=typeof p=="string"?p:p.value,v=typeof $=="string"?$:$.value;return i.$Gf(w,v)}return p._lower===$._lower}static toKey(p){return typeof p=="string"?p.toLowerCase():p._lower}}e.$qn=y;class a{get size(){return this.c.size}constructor(p){if(this.c=new Set,p)for(const $ of p)this.add($)}add(p){this.c.add(y.toKey(p))}delete(p){return this.c.delete(y.toKey(p))}has(p){return this.c.has(y.toKey(p))}}e.$rn=a;class h{constructor(){this.c=new Map}clear(){this.c.clear()}delete(p){this.c.delete(y.toKey(p))}get(p){return this.c.get(y.toKey(p))}has(p){return this.c.has(y.toKey(p))}set(p,$){this.c.set(y.toKey(p),$)}values(){return this.c.values()}forEach(p){this.c.forEach(p)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$sn=h;function f(m){return g(m)}function g(m){return m.contributes&&m.contributes.localizations?m.contributes.localizations.length>0:!1}function b(m){return m.contributes&&m.contributes.authentication?m.contributes.authentication.length>0:!1}function l(m,p){if(p){const $=`onResolveRemoteAuthority:${(0,S.$hn)(p)}`;return!!m.activationEvents?.includes($)}return!1}e.$xn=(0,o.$Fi)("IBuiltinExtensionsScannerService")}),define(oe[127],ae([0,1,4,175,100,6]),function(V,e,i,o,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pp=e.$op=e.$np=e.$mp=e.$lp=e.$kp=e.$jp=e.$ip=e.ExtensionManagementErrorCode=e.$hp=e.ExtensionGalleryErrorCode=e.$gp=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.ExtensionInstallSource=e.$_o=e.$$o=e.$0o=e.$9o=e.$8o=e.$7o=e.$6o=void 0,e.$ap=P,e.$bp=y,e.$cp=a,e.$dp=h,e.$ep=f,e.$fp=g,e.$6o="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$7o=new RegExp(e.$6o),e.$8o="__web_extension",e.$9o="skipWalkthrough",e.$0o="extensionInstallSource",e.$$o="dependecyOrPackExtensionInstall",e.$_o="clientTargetPlatform";var O;(function(t){t.COMMAND="command",t.SETTINGS_SYNC="settingsSync"})(O||(e.ExtensionInstallSource=O={}));function P(t){switch(t){case S.TargetPlatform.WIN32_X64:return"Windows 64 bit";case S.TargetPlatform.WIN32_ARM64:return"Windows ARM";case S.TargetPlatform.LINUX_X64:return"Linux 64 bit";case S.TargetPlatform.LINUX_ARM64:return"Linux ARM 64";case S.TargetPlatform.LINUX_ARMHF:return"Linux ARM";case S.TargetPlatform.ALPINE_X64:return"Alpine Linux 64 bit";case S.TargetPlatform.ALPINE_ARM64:return"Alpine ARM 64";case S.TargetPlatform.DARWIN_X64:return"Mac";case S.TargetPlatform.DARWIN_ARM64:return"Mac Silicon";case S.TargetPlatform.WEB:return"Web";case S.TargetPlatform.UNIVERSAL:return S.TargetPlatform.UNIVERSAL;case S.TargetPlatform.UNKNOWN:return S.TargetPlatform.UNKNOWN;case S.TargetPlatform.UNDEFINED:return S.TargetPlatform.UNDEFINED}}function y(t){switch(t){case S.TargetPlatform.WIN32_X64:return S.TargetPlatform.WIN32_X64;case S.TargetPlatform.WIN32_ARM64:return S.TargetPlatform.WIN32_ARM64;case S.TargetPlatform.LINUX_X64:return S.TargetPlatform.LINUX_X64;case S.TargetPlatform.LINUX_ARM64:return S.TargetPlatform.LINUX_ARM64;case S.TargetPlatform.LINUX_ARMHF:return S.TargetPlatform.LINUX_ARMHF;case S.TargetPlatform.ALPINE_X64:return S.TargetPlatform.ALPINE_X64;case S.TargetPlatform.ALPINE_ARM64:return S.TargetPlatform.ALPINE_ARM64;case S.TargetPlatform.DARWIN_X64:return S.TargetPlatform.DARWIN_X64;case S.TargetPlatform.DARWIN_ARM64:return S.TargetPlatform.DARWIN_ARM64;case S.TargetPlatform.WEB:return S.TargetPlatform.WEB;case S.TargetPlatform.UNIVERSAL:return S.TargetPlatform.UNIVERSAL;default:return S.TargetPlatform.UNKNOWN}}function a(t,r){switch(t){case i.Platform.Windows:return r==="x64"?S.TargetPlatform.WIN32_X64:r==="arm64"?S.TargetPlatform.WIN32_ARM64:S.TargetPlatform.UNKNOWN;case i.Platform.Linux:return r==="x64"?S.TargetPlatform.LINUX_X64:r==="arm64"?S.TargetPlatform.LINUX_ARM64:r==="arm"?S.TargetPlatform.LINUX_ARMHF:S.TargetPlatform.UNKNOWN;case"alpine":return r==="x64"?S.TargetPlatform.ALPINE_X64:r==="arm64"?S.TargetPlatform.ALPINE_ARM64:S.TargetPlatform.UNKNOWN;case i.Platform.Mac:return r==="x64"?S.TargetPlatform.DARWIN_X64:r==="arm64"?S.TargetPlatform.DARWIN_ARM64:S.TargetPlatform.UNKNOWN;case i.Platform.Web:return S.TargetPlatform.WEB}}function h(t,r){return r===S.TargetPlatform.WEB&&!t.includes(S.TargetPlatform.WEB)}function f(t,r,n){return h(r,n)?!1:t===S.TargetPlatform.UNDEFINED||t===S.TargetPlatform.UNIVERSAL?!0:t===S.TargetPlatform.UNKNOWN?!1:t===n}function g(t){return t&&typeof t=="object"&&typeof t.id=="string"&&(!t.uuid||typeof t.uuid=="string")}var b;(function(t){t[t.NoneOrRelevance=0]="NoneOrRelevance",t[t.LastUpdatedDate=1]="LastUpdatedDate",t[t.Title=2]="Title",t[t.PublisherName=3]="PublisherName",t[t.InstallCount=4]="InstallCount",t[t.PublishedDate=10]="PublishedDate",t[t.AverageRating=6]="AverageRating",t[t.WeightedRating=12]="WeightedRating"})(b||(e.SortBy=b={}));var l;(function(t){t[t.Default=0]="Default",t[t.Ascending=1]="Ascending",t[t.Descending=2]="Descending"})(l||(e.SortOrder=l={}));var m;(function(t){t.Install="install",t.Uninstall="uninstall"})(m||(e.StatisticType=m={}));var p;(function(t){t[t.None=1]="None",t[t.Install=2]="Install",t[t.Update=3]="Update",t[t.Migrate=4]="Migrate"})(p||(e.InstallOperation=p={})),e.$gp=(0,D.$Fi)("extensionGalleryService");var $;(function(t){t.Timeout="Timeout",t.Cancelled="Cancelled",t.Failed="Failed",t.DownloadFailedWriting="DownloadFailedWriting"})($||(e.ExtensionGalleryErrorCode=$={}));class w extends Error{constructor(r,n){super(r),this.code=n,this.name=n}}e.$hp=w;var v;(function(t){t.Unsupported="Unsupported",t.Deprecated="Deprecated",t.Malicious="Malicious",t.Incompatible="Incompatible",t.IncompatibleTargetPlatform="IncompatibleTargetPlatform",t.ReleaseVersionNotFound="ReleaseVersionNotFound",t.Invalid="Invalid",t.Download="Download",t.DownloadSignature="DownloadSignature",t.DownloadFailedWriting="DownloadFailedWriting",t.UpdateExistingMetadata="UpdateExistingMetadata",t.UpdateMetadata="UpdateMetadata",t.Extract="Extract",t.Scanning="Scanning",t.ScanningExtension="ScanningExtension",t.ReadUninstalled="ReadUninstalled",t.UnsetUninstalled="UnsetUninstalled",t.Delete="Delete",t.Rename="Rename",t.IntializeDefaultProfile="IntializeDefaultProfile",t.AddToProfile="AddToProfile",t.InstalledExtensionNotFound="InstalledExtensionNotFound",t.PostInstall="PostInstall",t.CorruptZip="CorruptZip",t.IncompleteZip="IncompleteZip",t.Signature="Signature",t.NotAllowed="NotAllowed",t.Gallery="Gallery",t.Cancelled="Cancelled",t.Unknown="Unknown",t.Internal="Internal"})(v||(e.ExtensionManagementErrorCode=v={}));class k extends Error{constructor(r,n){super(r),this.code=n,this.name=n}}e.$ip=k,e.$jp=(0,D.$Fi)("extensionManagementService"),e.$kp="extensionsIdentifiers/disabled",e.$lp="extensionsIdentifiers/enabled",e.$mp=(0,D.$Fi)("IGlobalExtensionEnablementService"),e.$np=(0,D.$Fi)("IExtensionTipsService"),e.$op=(0,o.localize2)(0,"Extensions"),e.$pp=(0,o.localize2)(1,"Preferences")}),define(oe[247],ae([0,1,2,6]),function(V,e,i,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wl=e.$Vl=void 0,e.$Vl=(0,o.$Fi)("remoteSocketFactoryService");class S{constructor(){this.a={}}register(O,P){return this.a[O]??=[],this.a[O].push(P),(0,i.$Uc)(()=>{const y=this.a[O]?.indexOf(P);typeof y=="number"&&y>=0&&this.a[O]?.splice(y,1)})}b(O){return(this.a[O.type]||[]).find(y=>y.supports(O))}connect(O,P,y,a){const h=this.b(O);if(!h)throw new Error(`No socket factory found for ${O}`);return h.connect(O,P,y,a)}}e.$Wl=S}),define(oe[248],ae([0,1,27,49,21,122]),function(V,e,i,o,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$efc=P,i=Re(i),o=Re(o),D=Re(D);let O;async function P(b=!1){return(O===void 0||b)&&(O=y()),O}async function y(){const b=a();if(b===void 0)return!1;if(b>=22e3){const l=f();if(l)return new Promise(m=>{o.execFile(l,["--status"],p=>m(!p))})}else{const l=g();if(l)try{if((await S.Promises.stat(l)).isFile())return!0}catch{}}return!1}function a(){const b=/(\d+)\.(\d+)\.(\d+)/g.exec(i.release());if(b)return parseInt(b[3])}function h(b){const l=process.env.SystemRoot;if(l){const m=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");return D.join(l,m?"Sysnative":"System32",b)}}function f(){return h("wsl.exe")}function g(){return h("lxss\\LxssManager.dll")}}),define(oe[55],ae([0,1,17,16,2,189,54,6,5,45]),function(V,e,i,o,S,D,O,P,y,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2p=e.$1p=void 0,e.$3p=g,e.$4p=b,e.$5p=l,e.$6p=m,e.$7p=p,e.$8p=$,e.$1p=(0,P.$Fi)("requestService");class h{constructor(t){this.b=t}toJSON(){if(!this.a){const t=Object.create(null);for(const r in this.b)r.toLowerCase()==="authorization"||r.toLowerCase()==="proxy-authorization"?t[r]="*****":t[r]=this.b[r];this.a=t}return this.a}}class f extends S.$Wc{constructor(t){super(),this.b=0,this.a=t.createLogger("network",{name:(0,D.localize)(0,null),when:y.$rk.isEqualTo((0,y.$ok)(y.LogLevel.Trace)).serialize()})}async c(t,r,n){const c=`${t} #${++this.b}: ${r.url}`;this.a.trace(`${c} - begin`,r.type,new h(r.headers??{}));try{const s=await n();return this.a.trace(`${c} - end`,r.type,s.res.statusCode,s.res.headers),s}catch(s){throw this.a.error(`${c} - error`,r.type,(0,o.$_)(s)),s}}}e.$2p=f;function g(k){return k.res.statusCode&&k.res.statusCode>=200&&k.res.statusCode<300||k.res.statusCode===1223}function b(k){return k.res.statusCode===204}async function l(k){return b(k)?null:(await(0,i.$1e)(k.stream)).toString()}async function m(k){if(!g(k))throw new Error("Server returned "+k.res.statusCode);return l(k)}async function p(k){if(!g(k))throw new Error("Server returned "+k.res.statusCode);if(b(k))return null;const r=(await(0,i.$1e)(k.stream)).toString();try{return JSON.parse(r)}catch(n){throw n.message+=`:
`+r,n}}function $(k){v(k)}let w;function v(k){const t=a.$oo.as(O.$to.Configuration),r=w;w={id:"http",order:15,title:(0,D.localize)(1,null),type:"object",scope:k,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,D.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,D.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,D.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,D.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,D.localize)(6,null),(0,D.localize)(7,null),(0,D.localize)(8,null),(0,D.localize)(9,null)],default:"override",description:(0,D.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,D.localize)(11,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,D.localize)(12,null),restricted:!0}}},t.updateConfigurations({add:[w],remove:r?[r]:[]})}v(O.ConfigurationScope.APPLICATION)}),define(oe[249],ae([0,1,17,23]),function(V,e,i,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9r=e.$8r=void 0;class S{constructor(P){this.a=P}listen(P,y){throw new Error("Invalid listen")}call(P,y,a,h=o.CancellationToken.None){switch(y){case"request":return this.a.request(a[0],h).then(async({res:f,stream:g})=>{const b=await(0,i.$1e)(g);return[{statusCode:f.statusCode,headers:f.headers},b]});case"resolveProxy":return this.a.resolveProxy(a[0]);case"loadCertificates":return this.a.loadCertificates()}throw new Error("Invalid call")}}e.$8r=S;class D{constructor(P){this.a=P}async request(P,y){const[a,h]=await this.a.call("request",[P],y);return{res:a,stream:(0,i.$3e)(h)}}async resolveProxy(P){return this.a.call("resolveProxy",[P])}async loadCertificates(){return this.a.call("loadCertificates")}}e.$9r=D}),define(oe[250],ae([0,1,251,12]),function(V,e,i,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0r=D;function S(O,P){return O.protocol==="http:"?P.HTTP_PROXY||P.http_proxy||null:O.protocol==="https:"&&(P.HTTPS_PROXY||P.https_proxy||P.HTTP_PROXY||P.http_proxy)||null}async function D(O,P,y={}){const a=(0,i.parse)(O),h=y.proxyUrl||S(a,P);if(!h)return null;const f=(0,i.parse)(h);if(!/^https?:$/.test(f.protocol||""))return null;const g={host:f.hostname||"",port:(f.port?+f.port:0)||(f.protocol==="https"?443:80),auth:f.auth,rejectUnauthorized:(0,o.$lg)(y.strictSSL)?y.strictSSL:!0};return a.protocol==="http:"?new(await new Promise((b,l)=>{V(["http-proxy-agent"],b,l)}).then(Re)).HttpProxyAgent(h,g):new(await new Promise((b,l)=>{V(["https-proxy-agent"],b,l)}).then(Re)).HttpsProxyAgent(h,g)}}),define(oe[252],ae([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Afc=e.$zfc=e.$yfc=void 0,e.$yfc={exit:"vscode:electron-main->shared-process=exit",ipcReady:"vscode:shared-process->electron-main=ipc-ready",initDone:"vscode:shared-process->electron-main=init-done"},e.$zfc={request:"vscode:createSharedProcessChannelConnection",response:"vscode:createSharedProcessChannelConnectionResult"},e.$Afc={request:"vscode:createSharedProcessRawConnection",response:"vscode:createSharedProcessRawConnectionResult"}}),define(oe[101],ae([0,1,49,9,190,23,53,16,4,33,117,68,8,143]),function(V,e,i,o,S,D,O,P,y,a,h,f,g,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qm=m;let l;async function m($,w,v,k){return v["force-disable-user-env"]?(w.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):y.$i?(w.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,f.$Jm)(k)&&!v["force-user-env"]?(w.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,f.$Jm)(k)?w.trace("resolveShellEnv(): running (--force-user-env)"):w.trace("resolveShellEnv(): running (macOS/Linux)"),l||(l=g.Promises.withAsyncBody(async(t,r)=>{const n=new D.$xe;let c=1e4;const s=$.getValue("application.shellEnvironmentResolutionTimeout");typeof s=="number"&&(c=(0,b.$Km)(s,1,120)*1e3);const u=setTimeout(()=>{n.dispose(!0),r(new Error((0,S.localize)(0,null)))},c);try{t(await p(w,n.token))}catch(d){!(0,P.$6)(d)&&!n.token.isCancellationRequested?r(new Error((0,S.localize)(1,null,(0,O.$qj)(d)))):t({})}finally{clearTimeout(u),n.dispose()}})),l)}async function p($,w){const v=process.env.ELECTRON_RUN_AS_NODE;$.trace("getUnixShellEnvironment#runAsNode",v);const k=process.env.ELECTRON_NO_ATTACH_CONSOLE;$.trace("getUnixShellEnvironment#noAttach",k);const t=(0,a.$2g)().replace(/-/g,"").substr(0,12),r=new RegExp(t+"({.*})"+t),n={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};$.trace("getUnixShellEnvironment#env",n);const c=await(0,h.$zm)(y.OS,n);return $.trace("getUnixShellEnvironment#shell",c),new Promise((s,u)=>{if(w.isCancellationRequested)return u(new P.$7);const d=(0,o.$pc)(c);let I,E;const A="";/^pwsh(-preview)?$/.test(d)?(I=`& '${process.execPath}' ${A} -p '''${t}'' + JSON.stringify(process.env) + ''${t}'''`,E=["-Login","-Command"]):d==="nu"?(I=`^'${process.execPath}' ${A} -p '"${t}" + JSON.stringify(process.env) + "${t}"'`,E=["-i","-l","-c"]):d==="xonsh"?(I=`import os, json; print("${t}", json.dumps(dict(os.environ)), "${t}")`,E=["-i","-l","-c"]):(I=`'${process.execPath}' ${A} -p '"${t}" + JSON.stringify(process.env) + "${t}"'`,d==="tcsh"||d==="csh"?E=["-ic"]:E=["-i","-l","-c"]),$.trace("getUnixShellEnvironment#spawn",JSON.stringify(E),I);const T=(0,i.spawn)(c,[...E,I],{detached:!0,stdio:["ignore","pipe","pipe"],env:n});w.onCancellationRequested(()=>(T.kill(),u(new P.$7))),T.on("error",M=>{$.error("getUnixShellEnvironment#errorChildProcess",(0,O.$qj)(M)),u(M)});const L=[];T.stdout.on("data",M=>L.push(M));const R=[];T.stderr.on("data",M=>R.push(M)),T.on("close",(M,U)=>{const N=Buffer.concat(L).toString("utf8");$.trace("getUnixShellEnvironment#raw",N);const z=Buffer.concat(R).toString("utf8");if(z.trim()&&$.trace("getUnixShellEnvironment#stderr",z),M||U)return u(new Error((0,S.localize)(2,null,M,U)));const ne=r.exec(N),Q=ne?ne[1]:"{}";try{const le=JSON.parse(Q);v?le.ELECTRON_RUN_AS_NODE=v:delete le.ELECTRON_RUN_AS_NODE,k?le.ELECTRON_NO_ATTACH_CONSOLE=k:delete le.ELECTRON_NO_ATTACH_CONSOLE,delete le.VSCODE_RESOLVING_ENVIRONMENT,delete le.XDG_RUNTIME_DIR,$.trace("getUnixShellEnvironment#result",le),s(le)}catch(le){$.error("getUnixShellEnvironment#errorCaught",(0,O.$qj)(le)),u(le)}})})}}),define(oe[253],ae([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lbc=void 0;class i{constructor(){this.b=new Map}static{this.a=1}async createNewMessage(S){try{const D=await this.c();if(D){const O=String(i.a++);return this.b.set(O,D),{id:O,data:D.createNewMessage(S)}}}catch{}return{id:"",data:S}}async validate(S,D){if(!S.id)return!0;const O=this.b.get(S.id);if(!O)return!1;this.b.delete(S.id);try{return O.validate(D)==="ok"}catch{return!1}finally{O.dispose?.()}}async sign(S){try{return await this.d(S)}catch{}return S}}e.$lbc=i}),define(oe[102],ae([0,1,6]),function(V,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yl=e.$Xl=void 0,e.$Xl="signService",e.$Yl=(0,i.$Fi)(e.$Xl)}),define(oe[254],ae([0,1,253]),function(V,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qgc=void 0;class o extends i.$lbc{c(){return this.h().then(D=>new D.validator)}d(D){return this.h().then(O=>new O.signer().sign(D))}h(){return new Promise((D,O)=>V(["vsda"],D,O))}}e.$qgc=o}),define(oe[34],ae([0,1,6]),function(V,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dR=e.$cR=void 0,e.$cR=(0,i.$Fi)("stateReadService"),e.$dR=(0,i.$Fi)("stateService")}),define(oe[128],ae([0,1,8,17,2,12,38,15,5]),function(V,e,i,o,S,D,O,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gR=e.$fR=e.$eR=e.SaveStrategy=void 0;var a;(function(b){b[b.IMMEDIATE=0]="IMMEDIATE",b[b.DELAYED=1]="DELAYED"})(a||(e.SaveStrategy=a={}));class h extends S.$Wc{constructor(l,m,p,$){super(),this.h=l,this.j=m,this.m=p,this.n=$,this.a=Object.create(null),this.b="",this.c=this.B(new i.$Dh(this.j===a.IMMEDIATE?0:100)),this.f=void 0,this.g=void 0}init(){return this.f||(this.f=this.r()),this.f}async r(){try{this.b=(await this.n.readFile(this.h)).value.toString(),this.a=JSON.parse(this.b)}catch(l){l.fileOperationResult!==P.FileOperationResult.FILE_NOT_FOUND&&this.m.error(l)}}getItem(l,m){const p=this.a[l];return(0,D.$og)(p)?m:p}setItem(l,m){this.setItems([{key:l,data:m}])}setItems(l){let m=!1;for(const{key:p,data:$}of l)this.a[p]!==$&&((0,D.$og)($)?(0,D.$mg)(this.a[p])||(this.a[p]=void 0,m=!0):(this.a[p]=$,m=!0));m&&this.s()}removeItem(l){(0,D.$mg)(this.a[l])||(this.a[l]=void 0,this.s())}async s(){if(!this.g)return this.c.trigger(()=>this.t())}async t(){if(!this.f)return;await this.f;const l=JSON.stringify(this.a,null,4);if(l!==this.b)try{await this.n.writeFile(this.h,o.$Oe.fromString(l),{atomic:{postfix:".vsctmp"}}),this.b=l}catch(m){this.m.error(m)}}async close(){return this.g||(this.g=this.c.trigger(()=>this.t(),0)),this.g}}e.$eR=h;let f=class extends S.$Wc{constructor(l,m,p,$){super(),this.a=this.B(new h(m.stateResource,l,p,$))}async init(){await this.a.init()}getItem(l,m){return this.a.getItem(l,m)}};e.$fR=f,e.$fR=f=Se([re(1,O.$Mi),re(2,y.$_j),re(3,P.$_k)],f);class g extends f{setItem(l,m){this.a.setItem(l,m)}setItems(l){this.a.setItems(l)}removeItem(l){this.a.removeItem(l)}close(){return this.a.close()}}e.$gR=g}),define(oe[129],ae([0,1,4,36,33]),function(V,e,i,o,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qp=O,e.$rp=P;function D(y){if(i.$u===i.Platform.Linux&&/^penguin(\.|$)/i.test(y))return"chromebook"}function O(y,a,h,f,g,b,l,m,p,$){const w=Object.create(null);w["common.machineId"]=b,w["common.sqmId"]=l,w["common.devDeviceId"]=m,w.sessionID=(0,S.$2g)()+Date.now(),w.commitHash=f,w.version=g,w["common.platformVersion"]=(y||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),w["common.platform"]=(0,i.$h)(i.$u),w["common.nodePlatform"]=o.$fc,w["common.nodeArch"]=h,w["common.product"]=$||"desktop",p&&(w["common.msftInternal"]=p);let v=0;const k=Date.now();Object.defineProperties(w,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-k,enumerable:!0},"common.sequence":{get:()=>v++,enumerable:!0}}),i.$l&&(w["common.snap"]="true");const t=D(a);return t&&(w["common.platformDetail"]=t),w}function P(y){const a=o.env.USERDNSDOMAIN;if(!a)return!1;const h=a.toLowerCase();return y.some(f=>h===f)}}),define(oe[24],ae([0,1,6]),function(V,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$jm=e.$im=e.$hm=e.$gm=e.$fm=e.$em=e.$dm=e.$cm=e.$bm=e.$am=e.$_l=e.$$l=void 0,e.$$l=(0,i.$Fi)("telemetryService"),e.$_l=(0,i.$Fi)("customEndpointTelemetryService"),e.$am="telemetry.currentSessionDate",e.$bm="telemetry.firstSessionDate",e.$cm="telemetry.lastSessionDate",e.$dm="telemetry.machineId",e.$em="telemetry.sqmId",e.$fm="telemetry.devDeviceId",e.$gm="telemetry",e.$hm="telemetry.telemetryLevel",e.$im="telemetry.enableCrashReporter",e.$jm="telemetry.enableTelemetry";var o;(function(D){D[D.NONE=0]="NONE",D[D.CRASH=1]="CRASH",D[D.ERROR=2]="ERROR",D[D.USAGE=3]="USAGE"})(o||(e.TelemetryLevel=o={}));var S;(function(D){D.OFF="off",D.CRASH="crash",D.ERROR="error",D.ON="all"})(S||(e.TelemetryConfiguration=S={}))}),define(oe[255],ae([0,1,27,8,43,13,9,4,66,7,93,21,116,96,15,28,24]),function(V,e,i,o,S,D,O,P,y,a,h,f,g,b,l,m,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Us=void 0,e.$Rs=w,e.$Ss=k,e.$Ts=t,i=Re(i);const $=new Map;async function w(n,c){const s=`${n}::${c.join(":")}`,u=$.get(s);if(u)return u;const d=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],I=new Map,E=new Map,A=2e4;function T(R,M,U,N){const z=M.substring(R.length+1);return o.Promises.withAsyncBody(async ne=>{let Q;N.readdirCount++;try{Q=await f.Promises.readdir(M,{withFileTypes:!0})}catch{ne();return}if(N.count>=A){N.count+=Q.length,N.maxReached=!0,ne();return}let le=Q.length;if(le===0){ne();return}let K=Q;N.count+Q.length>A&&(N.maxReached=!0,le=A-N.count,K=Q.slice(0,le)),N.count+=Q.length;for(const ee of K)if(ee.isDirectory()){if(U.includes(ee.name)||await T(R,(0,O.$lc)(M,ee.name),U,N),--le===0){ne();return}}else{const H=ee.name.lastIndexOf(".");if(H>=0){const j=ee.name.substring(H+1);j&&I.set(j,(I.get(j)??0)+1)}for(const j of d)j.relativePathPattern?.test(z)!==!1&&j.filePattern.test(ee.name)&&E.set(j.tag,(E.get(j.tag)??0)+1);if(--le===0){ne();return}}})}const L=o.Promises.withAsyncBody(async R=>{const M={count:0,maxReached:!1,readdirCount:0},U=new y.$ge(!0);await T(n,n,c,M);const N=await t(n);R({configFiles:v(E),fileTypes:v(I),fileCount:M.count,maxFilesReached:M.maxReached,launchConfigFiles:N,totalScanTime:U.elapsed(),totalReaddirCount:M.readdirCount})});return $.set(s,L),L}function v(n){return Array.from(n.entries(),([c,s])=>({name:c,count:s})).sort((c,s)=>s.count-c.count)}function k(){const n={os:`${i.type()} ${i.arch()} ${i.release()}`,memory:`${(i.totalmem()/l.$Hl.GB).toFixed(2)}GB (${(i.freemem()/l.$Hl.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(h.$Pn.value()*100)}%`},c=i.cpus();return c&&c.length>0&&(n.cpus=`${c[0].model} (${c.length} x ${c[0].speed})`),n}async function t(n){try{const c=new Map,s=(0,O.$lc)(n,".vscode","launch.json"),u=await f.Promises.readFile(s),d=[],I=(0,S.$Vn)(u.toString(),d);if(d.length)return console.log(`Unable to parse ${s}`),[];if((0,S.$4n)(I)==="object"&&I.configurations)for(const E of I.configurations){const A=E.type;A&&(c.has(A)?c.set(A,c.get(A)+1):c.set(A,1))}return v(c)}catch{return[]}}let r=class{constructor(c,s){this.c=c,this.d=s}f(c){const s=[];return s.push(`OS Version:       ${c.os}`),s.push(`CPUs:             ${c.cpus}`),s.push(`Memory (System):  ${c.memory}`),s.push(`VM:               ${c.vmHint}`),s.join(`
`)}g(c){const s=[];s.push(`Version:          ${this.d.nameShort} ${this.d.version} (${this.d.commit||"Commit unknown"}, ${this.d.date||"Date unknown"})`),s.push(`OS Version:       ${i.type()} ${i.arch()} ${i.release()}`);const u=i.cpus();return u&&u.length>0&&s.push(`CPUs:             ${u[0].model} (${u.length} x ${u[0].speed})`),s.push(`Memory (System):  ${(i.totalmem()/l.$Hl.GB).toFixed(2)}GB (${(i.freemem()/l.$Hl.GB).toFixed(2)}GB free)`),P.$i||s.push(`Load (avg):       ${i.loadavg().map(d=>Math.round(d)).join(", ")}`),s.push(`VM:               ${Math.round(h.$Pn.value()*100)}%`),s.push(`Screen Reader:    ${c.screenReader?"yes":"no"}`),s.push(`Process Argv:     ${c.mainArguments.join(" ")}`),s.push(`GPU Status:       ${this.j(c.gpuFeatureStatus)}`),s.join(`
`)}async getPerformanceInfo(c,s){return Promise.all([(0,g.$Qs)(c.mainPID),this.k(c)]).then(async u=>{let[d,I]=u,E=this.m(c,d);return s.forEach(A=>{if((0,b.$Tm)(A))E+=`
${A.errorMessage}`,I+=`
${A.errorMessage}`;else if(E+=`

Remote: ${A.hostName}`,A.processes&&(E+=`
${this.m(c,A.processes)}`),A.workspaceMetadata){I+=`
|  Remote: ${A.hostName}`;for(const T of Object.keys(A.workspaceMetadata)){const L=A.workspaceMetadata[T];let R=`${L.fileCount} files`;L.maxFilesReached&&(R=`more than ${R}`),I+=`|    Folder (${T}): ${R}`,I+=this.h(L)}}}),{processInfo:E,workspaceInfo:I}})}async getSystemInfo(c,s){const{memory:u,vmHint:d,os:I,cpus:E}=k(),A={os:I,memory:u,cpus:E,vmHint:d,processArgs:`${c.mainArguments.join(" ")}`,gpuStatus:c.gpuFeatureStatus,screenReader:`${c.screenReader?"yes":"no"}`,remoteData:s};return P.$i||(A.load=`${i.loadavg().map(T=>Math.round(T)).join(", ")}`),P.$k&&(A.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(A)}async getDiagnostics(c,s){const u=[];return(0,g.$Qs)(c.mainPID).then(async d=>(u.push(""),u.push(this.g(c)),u.push(""),u.push(this.m(c,d)),c.windows.some(I=>I.folderURIs&&I.folderURIs.length>0&&!I.remoteAuthority)&&(u.push(""),u.push("Workspace Stats: "),u.push(await this.k(c))),s.forEach(I=>{if((0,b.$Tm)(I))u.push(`
${I.errorMessage}`);else if(u.push(`

`),u.push(`Remote:           ${I.hostName}`),u.push(this.f(I.machineInfo)),I.processes&&u.push(this.m(c,I.processes)),I.workspaceMetadata)for(const E of Object.keys(I.workspaceMetadata)){const A=I.workspaceMetadata[E];let T=`${A.fileCount} files`;A.maxFilesReached&&(T=`more than ${T}`),u.push(`Folder (${E}): ${T}`),u.push(this.h(A))}}),u.push(""),u.push(""),u.join(`
`)))}h(c){const s=[];let d=0;const I=(L,R)=>{const M=` ${L}(${R})`;d+M.length>60?(s.push(E),E="|                 ",d=E.length):d+=M.length,E+=M};let E="|      File types:";const A=10,T=c.fileTypes.length>A?A:c.fileTypes.length;for(let L=0;L<T;L++){const R=c.fileTypes[L];I(R.name,R.count)}if(s.push(E),c.configFiles.length>=0&&(E="|      Conf files:",d=0,c.configFiles.forEach(L=>{I(L.name,L.count)}),s.push(E)),c.launchConfigFiles.length>0){let L="|      Launch Configs:";c.launchConfigFiles.forEach(R=>{const M=R.count>1?` ${R.name}(${R.count})`:` ${R.name}`;L+=M}),s.push(L)}return s.join(`
`)}j(c){const s=Math.max(...Object.keys(c).map(u=>u.length));return Object.keys(c).map(u=>`${u}:  ${" ".repeat(s-u.length)}  ${c[u]}`).join(`
                  `)}k(c){const s=[],u=[];return c.windows.forEach(d=>{d.folderURIs.length===0||d.remoteAuthority||(s.push(`|  Window (${d.title})`),d.folderURIs.forEach(I=>{const E=a.URI.revive(I);if(E.scheme===D.Schemas.file){const A=E.fsPath;u.push(w(A,["node_modules",".git"]).then(T=>{let L=`${T.fileCount} files`;T.maxFilesReached&&(L=`more than ${L}`),s.push(`|    Folder (${(0,O.$pc)(A)}): ${L}`),s.push(this.h(T))}).catch(T=>{s.push(`|      Error: Unable to collect workspace stats for folder ${A} (${T.toString()})`)}))}else s.push(`|    Folder (${E.toString()}): Workspace stats not available.`)}))}),Promise.all(u).then(d=>s.join(`
`)).catch(d=>`Unable to collect workspace stats: ${d}`)}m(c,s){const u=new Map;c.windows.forEach(I=>u.set(I.pid,`window [${I.id}] (${I.title})`)),c.pidToNames.forEach(({pid:I,name:E})=>u.set(I,E));const d=[];return d.push("CPU %	Mem MB	   PID	Process"),s&&this.n(c.mainPID,u,d,s,0),d.join(`
`)}n(c,s,u,d,I){const E=I===0;let A;E?A=d.pid===c?`${this.d.applicationName} main`:"remote agent":s.has(d.pid)?A=s.get(d.pid):A=`${"  ".repeat(I)} ${d.name}`;const T=process.platform==="win32"?d.mem:i.totalmem()*(d.mem/100);u.push(`${d.load.toFixed(0).padStart(5," ")}	${(T/l.$Hl.MB).toFixed(0).padStart(6," ")}	${d.pid.toFixed(0).padStart(6," ")}	${A}`),Array.isArray(d.children)&&d.children.forEach(L=>this.n(c,s,u,L,I+1))}async getWorkspaceFileExtensions(c){const s=new Set;for(const{uri:u}of c.folders){const d=a.URI.revive(u);if(d.scheme!==D.Schemas.file)continue;const I=d.fsPath;try{(await w(I,["node_modules",".git"])).fileTypes.forEach(A=>s.add(A.name))}catch{}}return{extensions:[...s]}}async reportWorkspaceStats(c){for(const{uri:s}of c.folders){const u=a.URI.revive(s);if(u.scheme!==D.Schemas.file)continue;const d=u.fsPath;try{const I=await w(d,["node_modules",".git"]);this.c.publicLog2("workspace.stats",{"workspace.id":c.telemetryId,rendererSessionId:c.rendererSessionId}),I.fileTypes.forEach(E=>{this.c.publicLog2("workspace.stats.file",{rendererSessionId:c.rendererSessionId,type:E.name,count:E.count})}),I.launchConfigFiles.forEach(E=>{this.c.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:c.rendererSessionId,type:E.name,count:E.count})}),I.configFiles.forEach(E=>{this.c.publicLog2("workspace.stats.configFiles",{rendererSessionId:c.rendererSessionId,type:E.name,count:E.count})}),this.c.publicLog2("workspace.stats.metadata",{duration:I.totalScanTime,reachedLimit:I.maxFilesReached,fileCount:I.fileCount,readdirCount:I.totalReaddirCount})}catch{}}}};e.$Us=r,e.$Us=r=Se([re(0,p.$$l),re(1,m.$sk)],r)}),define(oe[256],ae([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Efc=e.$Dfc=void 0;class i{constructor(D){this.b=D}listen(D,O){throw new Error(`Event not found: ${O}`)}call(D,O,{eventName:P,data:y}){return this.b.forEach(a=>a.log(P,y)),Promise.resolve(null)}}e.$Dfc=i;class o{constructor(D){this.b=D}log(D,O){return this.b.call("log",{eventName:D,data:O}).then(void 0,P=>`Failed to log telemetry: ${console.warn(P)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.$Efc=o}),define(oe[56],ae([0,1,35,12,72,129,24]),function(V,e,i,o,S,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yp=e.$xp=e.$wp=e.$vp=e.$up=e.$tp=e.$sp=void 0,e.$zp=h,e.$Ap=f,e.$Bp=g,e.$Cp=b,e.$Dp=m,e.$Ep=$,e.$Fp=w,e.$Gp=t;class P{constructor(n){this.value=n,this.isTrustedTelemetryValue=!0}}e.$sp=P;class y{constructor(){this.telemetryLevel=O.TelemetryLevel.NONE,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.devDeviceId="someValue.devDeviceId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$tp=y,e.$up=new y;class a{async publicLog(n,c,s){}async publicLogError(n,c,s){}}e.$vp=a,e.$wp="telemetry",e.$xp="extensionTelemetryLog",e.$yp={log:()=>null,flush:()=>Promise.resolve(null)};function h(r,n){return!n.isBuilt&&!n.disableTelemetry?!0:!(n.disableTelemetry||!r.enableTelemetry)}function f(r,n){return n.extensionTestsLocationURI?!0:!(n.isBuilt||n.disableTelemetry||r.enableTelemetry&&r.aiConfig?.ariaKey)}function g(r){const n=r.getValue(O.$hm),c=r.getValue(O.$im);if(r.getValue(O.$jm)===!1||c===!1)return O.TelemetryLevel.NONE;switch(n??O.TelemetryConfiguration.ON){case O.TelemetryConfiguration.ON:return O.TelemetryLevel.USAGE;case O.TelemetryConfiguration.ERROR:return O.TelemetryLevel.ERROR;case O.TelemetryConfiguration.CRASH:return O.TelemetryLevel.CRASH;case O.TelemetryConfiguration.OFF:return O.TelemetryLevel.NONE}}function b(r){const n={},c={},s={};p(r,s);for(let u in s){u=u.length>150?u.substr(u.length-149):u;const d=s[u];typeof d=="number"?c[u]=d:typeof d=="boolean"?c[u]=d?1:0:typeof d=="string"?(d.length>8192&&console.warn(`Telemetry property: ${u} has been trimmed to 8192, the original length is ${d.length}`),n[u]=d.substring(0,8191)):typeof d<"u"&&d!==null&&(n[u]=d)}return{properties:n,measurements:c}}const l=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function m(r){if(!r)return"none";const n=(0,S.$hn)(r);return l.has(n)?n:"other"}function p(r,n,c=0,s){if(r)for(const u of Object.getOwnPropertyNames(r)){const d=r[u],I=s?s+u:u;Array.isArray(d)?n[I]=(0,i.$go)(d):d instanceof Date?n[I]=d.toISOString():(0,o.$hg)(d)?c<2?p(d,n,c+1,I+"."):n[I]=(0,i.$go)(d):n[I]=d}}function $(r,n){const c=r.msftInternalDomains||[],s=n.getValue("telemetry.internalTesting");return(0,D.$rp)(c)||s}function w(r){return[r.appRoot,r.extensionsPath,r.userHome.fsPath,r.tmpDir.fsPath,r.userDataPath]}function v(r,n){if(!r||!r.includes("/")&&!r.includes("\\"))return r;let c=r;const s=[];for(const E of n)for(;;){const A=E.exec(r);if(!A)break;s.push([A.index,E.lastIndex])}const u=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,d=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let I=0;for(c="";;){const E=d.exec(r);if(!E)break;const A=s.some(([T,L])=>E.index<L&&T<d.lastIndex);!u.test(E[0])&&!A&&(c+=r.substring(I,E.index)+"<REDACTED: user-file-path>",I=d.lastIndex)}return I<r.length&&(c+=r.substr(I)),c}function k(r){if(!r)return r;const n=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"CLI Credentials",regex:/((login|psexec|(certutil|psexec)\.exe).{1,50}(\s-u(ser(name)?)?\s+.{3,100})?\s-(admin|user|vm|root)?p(ass(word)?)?\s+["']?[^$\-\/\s]|(^|[\s\r\n\\])net(\.exe)?.{1,5}(user\s+|share\s+\/user:| user -? secrets ? set) \s + [^ $\s \/])/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const c of n)if(c.regex.test(r))return`<REDACTED: ${c.label}>`;return r}function t(r,n){return(0,i.$do)(r,c=>{if(c instanceof P||Object.hasOwnProperty.call(c,"isTrustedTelemetryValue"))return c.value;if(typeof c=="string"){let s=c.replaceAll("%20"," ");s=v(s,n);for(const u of n)s=s.replace(u,"");return s=k(s),s}})}}),define(oe[130],ae([0,1,26,127,100,4,7,16,36,56]),function(V,e,i,o,S,D,O,P,y,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qp=e.$Ip=void 0,e.$Hp=h,e.$Jp=l,e.$Kp=m,e.$Lp=p,e.$Mp=$,e.$Np=w,e.$Op=v,e.$Pp=k,e.$Rp=t,e.$Sp=n;function h(c,s){return c.uuid&&s.uuid?c.uuid===s.uuid:c.id===s.id?!0:(0,i.$Bf)(c.id,s.id)===0}const f=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class g{static create(s){const u=s.manifest?s.manifest.version:s.version,d=s.manifest?s.targetPlatform:s.properties.targetPlatform;return new g(s.identifier,u,d)}static parse(s){const u=f.exec(s);return u&&u[1]&&u[2]?new g({id:u[1]},u[2],u[4]||void 0):null}constructor(s,u,d=S.TargetPlatform.UNDEFINED){this.identifier=s,this.version=u,this.targetPlatform=d,this.id=s.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!==S.TargetPlatform.UNDEFINED?`-${this.targetPlatform}`:""}`}equals(s){return s instanceof g?h(this,s)&&this.version===s.version&&this.targetPlatform===s.targetPlatform:!1}}e.$Ip=g;const b=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function l(c){const s=b.exec(c);return s&&s[1]?[p(s[1]),s[2]]:[p(c),void 0]}function m(c,s){return`${c}.${s}`}function p(c){return c.toLowerCase()}function $(c,s){return p(m(c??S.$mn,s))}function w(c,s){const u=[],d=I=>{for(const E of u)if(E.some(A=>h(s(A),s(I))))return E;return null};for(const I of c){const E=d(I);E?E.push(I):u.push([I])}return u}function v(c){return{id:c.identifier.id,name:c.manifest.name,galleryId:null,publisherId:c.publisherId,publisherName:c.manifest.publisher,publisherDisplayName:c.publisherDisplayName,dependencies:c.manifest.extensionDependencies&&c.manifest.extensionDependencies.length>0}}function k(c){return{id:new a.$sp(c.identifier.id),name:new a.$sp(c.name),version:c.version,galleryId:c.identifier.uuid,publisherId:c.publisherId,publisherName:c.publisher,publisherDisplayName:c.publisherDisplayName,isPreReleaseVersion:c.properties.isPreReleaseVersion,dependencies:!!(c.properties.dependencies&&c.properties.dependencies.length>0),isSigned:c.isSigned,...c.telemetryData}}e.$Qp=new S.$qn("pprice.better-merge");function t(c,s){const u=[],d=s.manifest.extensionDependencies?.slice(0)??[];for(;d.length;){const I=d.shift();if(I&&u.every(E=>!h(E.identifier,{id:I}))){const E=c.filter(A=>h(A.identifier,{id:I}));E.length===1&&(u.push(E[0]),d.push(...E[0].manifest.extensionDependencies?.slice(0)??[]))}}return u}async function r(c,s){if(!D.$k)return!1;let u;try{u=(await c.readFile(O.URI.file("/etc/os-release"))).value.toString()}catch{try{u=(await c.readFile(O.URI.file("/usr/lib/os-release"))).value.toString()}catch(I){s.debug("Error while getting the os-release file.",(0,P.$_)(I))}}return!!u&&(u.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function n(c,s){const u=await r(c,s),d=(0,o.$cp)(u?"alpine":D.$u,y.$gc);return s.debug("ComputeTargetPlatform:",d),d}});var et=this&&this.__importDefault||function(V){return V&&V.__esModule?V:{default:V}};define(oe[257],ae([0,1,2,35,4,26,191,18,54,84,28,45,24,56]),function(V,e,i,o,S,D,O,P,y,a,h,f,g,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$as=void 0,a=et(a);let l=class{static{this.IDLE_START_EVENT_NAME="UserIdleStart"}static{this.IDLE_STOP_EVENT_NAME="UserIdleStop"}constructor($,w,v){this.k=w,this.l=v,this.d={},this.i=new i.$Vc,this.j=[],this.b=$.appenders,this.c=$.commonProperties??Object.create(null),this.sessionId=this.c.sessionID,this.machineId=this.c["common.machineId"],this.sqmId=this.c["common.sqmId"],this.devDeviceId=this.c["common.devDeviceId"],this.firstSessionDate=this.c["common.firstSessionDate"],this.msftInternal=this.c["common.msftInternal"],this.f=$.piiPaths||[],this.g=g.TelemetryLevel.USAGE,this.h=!!$.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const k of this.f)this.j.push(new RegExp((0,D.$if)(k),"gi")),k.indexOf("\\")>=0&&this.j.push(new RegExp((0,D.$if)(k.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(k=>{(k.affectsConfiguration(g.$hm)||k.affectsConfiguration(g.$jm)||k.affectsConfiguration(g.$im))&&this.m()}))}setExperimentProperty($,w){this.d[$]=w}m(){let $=(0,b.$Bp)(this.k);const w=this.l.enabledTelemetryLevels;if(w){this.h=this.sendErrorTelemetry?w.error:!1;const v=w.usage?g.TelemetryLevel.USAGE:w.error?g.TelemetryLevel.ERROR:g.TelemetryLevel.NONE;$=Math.min($,v)}this.g=$}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}dispose(){this.i.dispose()}n($,w,v){this.g<w||(v=(0,o.$eo)(v,this.d),v=(0,b.$Gp)(v,this.j),v=(0,o.$eo)(v,this.c),this.b.forEach(k=>k.log($,v)))}publicLog($,w){this.n($,g.TelemetryLevel.USAGE,w)}publicLog2($,w){this.publicLog($,w)}publicLogError($,w){this.h&&this.n($,g.TelemetryLevel.ERROR,w)}publicLogError2($,w){this.publicLogError($,w)}};e.$as=l,e.$as=l=Se([re(1,P.$_i),re(2,h.$sk)],l);function m(){const p=(0,O.localize)(0,null,a.default.nameLong),$=a.default.privacyStatementUrl?(0,O.localize)(2,null,"https://aka.ms/vscode-telemetry",a.default.privacyStatementUrl):(0,O.localize)(1,null,"https://aka.ms/vscode-telemetry"),w=S.$o?"":(0,O.localize)(3,null),v=(0,O.localize)(4,null),k=(0,O.localize)(5,null),t=(0,O.localize)(6,null),r=(0,O.localize)(7,null),n=`
|       | ${v} | ${k} | ${t} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,c=(0,O.localize)(8,null);return`
${p} ${$} ${w}

&nbsp;

${r}
${n}

&nbsp;

${c}
`}f.$oo.as(y.$to.Configuration).registerConfiguration({id:g.$gm,order:1,type:"object",title:(0,O.localize)(9,null),properties:{[g.$hm]:{type:"string",enum:[g.TelemetryConfiguration.ON,g.TelemetryConfiguration.ERROR,g.TelemetryConfiguration.CRASH,g.TelemetryConfiguration.OFF],enumDescriptions:[(0,O.localize)(10,null),(0,O.localize)(11,null),(0,O.localize)(12,null),(0,O.localize)(13,null)],markdownDescription:m(),default:g.TelemetryConfiguration.ON,restricted:!0,scope:y.ConfigurationScope.APPLICATION,tags:["usesOnlineServices","telemetry"]}}}),f.$oo.as(y.$to.Configuration).registerConfiguration({id:g.$gm,order:110,type:"object",title:(0,O.localize)(14,null),properties:{[g.$jm]:{type:"boolean",markdownDescription:a.default.privacyStatementUrl?(0,O.localize)(16,null,a.default.nameLong,a.default.privacyStatementUrl):(0,O.localize)(15,null,a.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,O.localize)(17,null,`\`#${g.$hm}#\``),scope:y.ConfigurationScope.APPLICATION,tags:["usesOnlineServices","telemetry"]}}})}),define(oe[258],ae([0,1,4,93,24]),function(V,e,i,o,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6fc=D,e.$7fc=O,e.$8fc=P;async function D(y,a){let h=y.getItem(S.$dm);return(typeof h!="string"||i.$j&&h==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(h=await(0,o.$Qn)(a.error.bind(a))),h}async function O(y,a){let h=y.getItem(S.$em);return typeof h!="string"&&(h=await(0,o.$Rn)(a.error.bind(a))),h}async function P(y,a){let h=y.getItem(S.$fm);return typeof h!="string"&&(h=await(0,o.$Sn)(a.error.bind(a))),h}}),define(oe[259],ae([0,1,24,258]),function(V,e,i,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9fc=S,e.$0fc=D,e.$$fc=O;async function S(P,y){const a=await(0,o.$6fc)(P,y);return P.setItem(i.$dm,a),a}async function D(P,y){const a=await(0,o.$7fc)(P,y);return P.setItem(i.$em,a),a}async function O(P,y){const a=await(0,o.$8fc)(P,y);return P.setItem(i.$fm,a),a}}),define(oe[131],ae([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentVariableMutatorType=void 0;var i;(function(o){o[o.Replace=1]="Replace",o[o.Append=2]="Append",o[o.Prepend=3]="Prepend"})(i||(e.EnvironmentVariableMutatorType=i={}))}),define(oe[260],ae([0,1,4,131]),function(V,e,i,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Es=void 0;const S=new Map([[o.EnvironmentVariableMutatorType.Append,"APPEND"],[o.EnvironmentVariableMutatorType.Prepend,"PREPEND"],[o.EnvironmentVariableMutatorType.Replace,"REPLACE"]]);class D{constructor(h){this.collections=h,this.a=new Map,this.b=new Map,h.forEach((f,g)=>{this.d(f,g);const b=f.map.entries();let l=b.next();for(;!l.done;){const m=l.value[1],p=l.value[0];let $=this.a.get(p);if($||($=[],this.a.set(p,$)),$.length>0&&$[0].type===o.EnvironmentVariableMutatorType.Replace){l=b.next();continue}const w={extensionIdentifier:g,value:m.value,type:m.type,scope:m.scope,variable:m.variable,options:m.options};w.scope||delete w.scope,$.unshift(w),l=b.next()}})}async applyToProcessEnvironment(h,f,g){let b;i.$i&&(b={},Object.keys(h).forEach(l=>b[l.toLowerCase()]=l));for(const[l,m]of this.getVariableMap(f)){const p=i.$i&&b[l.toLowerCase()]||l;for(const $ of m){const w=g?await g($.value):$.value;if($.options?.applyAtProcessCreation??!0)switch($.type){case o.EnvironmentVariableMutatorType.Append:h[p]=(h[p]||"")+w;break;case o.EnvironmentVariableMutatorType.Prepend:h[p]=w+(h[p]||"");break;case o.EnvironmentVariableMutatorType.Replace:h[p]=w;break}if($.options?.applyAtShellIntegration??!1){const v=`VSCODE_ENV_${S.get($.type)}`;h[v]=(h[v]?h[v]+":":"")+l+"="+this.c(w)}}}}c(h){return h.replaceAll(":","\\x3a")}diff(h,f){const g=new Map,b=new Map,l=new Map;if(h.getVariableMap(f).forEach((m,p)=>{const $=this.getVariableMap(f).get(p),w=P(m,$);w&&g.set(p,w)}),this.getVariableMap(f).forEach((m,p)=>{const $=h.getVariableMap(f).get(p),w=P(m,$);w&&l.set(p,w)}),this.getVariableMap(f).forEach((m,p)=>{const $=h.getVariableMap(f).get(p),w=y(m,$);w&&b.set(p,w)}),!(g.size===0&&b.size===0&&l.size===0))return{added:g,changed:b,removed:l}}getVariableMap(h){const f=new Map;for(const g of this.a.values()){const b=g.filter(l=>O(l,h));b.length>0&&f.set(b[0].variable,b)}return f}getDescriptionMap(h){const f=new Map;for(const g of this.b.values()){const b=g.filter(l=>O(l,h,!0));for(const l of b)f.set(l.extensionIdentifier,l.description)}return f}d(h,f){if(!h.descriptionMap)return;const g=h.descriptionMap.entries();let b=g.next();for(;!b.done;){const l=b.value[1],m=b.value[0];let p=this.b.get(m);p||(p=[],this.b.set(m,p));const $={extensionIdentifier:f,scope:l.scope,description:l.description};$.scope||delete $.scope,p.push($),b=g.next()}}}e.$Es=D;function O(a,h,f=!1){return a.scope?!!(a.scope.workspaceFolder&&h?.workspaceFolder&&a.scope.workspaceFolder.index===h.workspaceFolder.index):f?h===a.scope:!0}function P(a,h){if(!h)return a;const f=new Set;h.forEach(b=>f.add(b.extensionIdentifier));const g=[];return a.forEach(b=>{f.has(b.extensionIdentifier)||g.push(b)}),g.length===0?void 0:g}function y(a,h){if(!h)return;const f=new Map;h.forEach(b=>f.set(b.extensionIdentifier,b));const g=[];return a.forEach(b=>{const l=f.get(b.extensionIdentifier);l&&(b.type!==l.type||b.value!==l.value||b.scope?.workspaceFolder?.index!==l.scope?.workspaceFolder?.index)&&g.push(l)}),g.length===0?void 0:g}}),define(oe[261],ae([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ys=i,e.$zs=o,e.$As=S,e.$Bs=D,e.$Cs=O,e.$Ds=P;function i(y){return[...y.entries()]}function o(y){return y?[...y.entries()]:[]}function S(y){return new Map(y)}function D(y){return new Map(y??[])}function O(y){return Array.from(y.entries()).map(a=>[a[0],i(a[1].map),o(a[1].descriptionMap)])}function P(y){return new Map(y.map(a=>[a[0],{map:S(a[1]),descriptionMap:D(a[2])}]))}}),define(oe[262],ae([0,1,8,23,3,2,5]),function(V,e,i,o,S,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ps=void 0;let P=class extends D.$Wc{constructor(a,h){super(),this.h=h,this.a=0,this.c=new Map,this.f=new Map,this.g=this.B(new S.$me),this.onCreateRequest=this.g.event,this.b=a===void 0?15e3:a,this.B((0,D.$Uc)(()=>{for(const f of this.f.values())(0,D.$Rc)(f)}))}createRequest(a){return new Promise((h,f)=>{const g=++this.a;this.c.set(g,h),this.g.fire({requestId:g,...a});const b=new o.$xe;(0,i.$Gh)(this.b,b.token).then(()=>f(`Request ${g} timed out (${this.b}ms)`)),this.f.set(g,[(0,D.$Uc)(()=>b.cancel())])})}acceptReply(a,h){const f=this.c.get(a);f?(this.c.delete(a),(0,D.$Rc)(this.f.get(a)||[]),this.f.delete(a),f(h)):this.h.warn(`RequestStore#acceptReply was called without receiving a matching request ${a}`)}};e.$ps=P,e.$ps=P=Se([re(1,O.$_j)],P)}),define(oe[73],ae([0,1,6,123,45]),function(V,e,i,o,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ls=e.$ks=e.$js=e.TerminalExitReason=e.ShellIntegrationStatus=e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.$is=e.ProcessPropertyType=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.PosixShellType=e.TerminalSettingId=e.TerminalSettingPrefix=e.$hs=void 0,e.$hs=new o.$Wj("terminalTabFocusMode",!1,!0);var D;(function(t){t.AutomationProfile="terminal.integrated.automationProfile.",t.DefaultProfile="terminal.integrated.defaultProfile.",t.Profiles="terminal.integrated.profiles."})(D||(e.TerminalSettingPrefix=D={}));var O;(function(t){t.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",t.AutomationProfileLinux="terminal.integrated.automationProfile.linux",t.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",t.AutomationProfileWindows="terminal.integrated.automationProfile.windows",t.ProfilesWindows="terminal.integrated.profiles.windows",t.ProfilesMacOs="terminal.integrated.profiles.osx",t.ProfilesLinux="terminal.integrated.profiles.linux",t.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",t.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",t.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",t.UseWslProfiles="terminal.integrated.useWslProfiles",t.TabsDefaultColor="terminal.integrated.tabs.defaultColor",t.TabsDefaultIcon="terminal.integrated.tabs.defaultIcon",t.TabsEnabled="terminal.integrated.tabs.enabled",t.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",t.TabsHideCondition="terminal.integrated.tabs.hideCondition",t.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",t.TabsShowActions="terminal.integrated.tabs.showActions",t.TabsLocation="terminal.integrated.tabs.location",t.TabsFocusMode="terminal.integrated.tabs.focusMode",t.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",t.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",t.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",t.CopyOnSelection="terminal.integrated.copyOnSelection",t.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",t.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",t.FontFamily="terminal.integrated.fontFamily",t.FontSize="terminal.integrated.fontSize",t.LetterSpacing="terminal.integrated.letterSpacing",t.LineHeight="terminal.integrated.lineHeight",t.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",t.TabStopWidth="terminal.integrated.tabStopWidth",t.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",t.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",t.BellDuration="terminal.integrated.bellDuration",t.FontWeight="terminal.integrated.fontWeight",t.FontWeightBold="terminal.integrated.fontWeightBold",t.CursorBlinking="terminal.integrated.cursorBlinking",t.CursorStyle="terminal.integrated.cursorStyle",t.CursorStyleInactive="terminal.integrated.cursorStyleInactive",t.CursorWidth="terminal.integrated.cursorWidth",t.Scrollback="terminal.integrated.scrollback",t.DetectLocale="terminal.integrated.detectLocale",t.DefaultLocation="terminal.integrated.defaultLocation",t.GpuAcceleration="terminal.integrated.gpuAcceleration",t.TerminalTitleSeparator="terminal.integrated.tabs.separator",t.TerminalTitle="terminal.integrated.tabs.title",t.TerminalDescription="terminal.integrated.tabs.description",t.RightClickBehavior="terminal.integrated.rightClickBehavior",t.MiddleClickBehavior="terminal.integrated.middleClickBehavior",t.Cwd="terminal.integrated.cwd",t.ConfirmOnExit="terminal.integrated.confirmOnExit",t.ConfirmOnKill="terminal.integrated.confirmOnKill",t.EnableBell="terminal.integrated.enableBell",t.EnableVisualBell="terminal.integrated.enableVisualBell",t.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",t.AllowChords="terminal.integrated.allowChords",t.AllowMnemonics="terminal.integrated.allowMnemonics",t.TabFocusMode="terminal.integrated.tabFocusMode",t.EnvMacOs="terminal.integrated.env.osx",t.EnvLinux="terminal.integrated.env.linux",t.EnvWindows="terminal.integrated.env.windows",t.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",t.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",t.ShowExitAlert="terminal.integrated.showExitAlert",t.SplitCwd="terminal.integrated.splitCwd",t.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",t.WordSeparators="terminal.integrated.wordSeparators",t.EnableFileLinks="terminal.integrated.enableFileLinks",t.AllowedLinkSchemes="terminal.integrated.allowedLinkSchemes",t.UnicodeVersion="terminal.integrated.unicodeVersion",t.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",t.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",t.HideOnStartup="terminal.integrated.hideOnStartup",t.CustomGlyphs="terminal.integrated.customGlyphs",t.RescaleOverlappingGlyphs="terminal.integrated.rescaleOverlappingGlyphs",t.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",t.InheritEnv="terminal.integrated.inheritEnv",t.ShowLinkHover="terminal.integrated.showLinkHover",t.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",t.AutoReplies="terminal.integrated.autoReplies",t.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",t.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",t.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",t.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history",t.EnableImages="terminal.integrated.enableImages",t.SmoothScrolling="terminal.integrated.smoothScrolling",t.IgnoreBracketedPasteMode="terminal.integrated.ignoreBracketedPasteMode",t.FocusAfterRun="terminal.integrated.focusAfterRun",t.DeveloperPtyHostLatency="terminal.integrated.developer.ptyHost.latency",t.DeveloperPtyHostStartupDelay="terminal.integrated.developer.ptyHost.startupDelay",t.DevMode="terminal.integrated.developer.devMode"})(O||(e.TerminalSettingId=O={}));var P;(function(t){t.PowerShell="pwsh",t.Bash="bash",t.Fish="fish",t.Sh="sh",t.Csh="csh",t.Ksh="ksh",t.Zsh="zsh",t.Python="python"})(P||(e.PosixShellType=P={}));var y;(function(t){t.CommandPrompt="cmd",t.PowerShell="pwsh",t.Wsl="wsl",t.GitBash="gitbash",t.Python="python"})(y||(e.WindowsShellType=y={}));var a;(function(t){t[t.Api=0]="Api",t[t.Process=1]="Process",t[t.Sequence=2]="Sequence",t[t.Config=3]="Config"})(a||(e.TitleEventSource=a={}));var h;(function(t){t.LocalPty="localPty",t.PtyHost="ptyHost",t.PtyHostWindow="ptyHostWindow",t.Logger="logger",t.Heartbeat="heartbeat"})(h||(e.TerminalIpcChannels=h={}));var f;(function(t){t.Cwd="cwd",t.InitialCwd="initialCwd",t.FixedDimensions="fixedDimensions",t.Title="title",t.ShellType="shellType",t.HasChildProcesses="hasChildProcesses",t.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",t.OverrideDimensions="overrideDimensions",t.FailedShellIntegrationActivation="failedShellIntegrationActivation",t.UsedShellIntegrationInjection="usedShellIntegrationInjection"})(f||(e.ProcessPropertyType=f={})),e.$is=(0,i.$Fi)("ptyService");var g;(function(t){t[t.BeatInterval=5e3]="BeatInterval",t[t.ConnectingBeatInterval=2e4]="ConnectingBeatInterval",t[t.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",t[t.SecondWaitMultiplier=1]="SecondWaitMultiplier",t[t.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(g||(e.HeartbeatConstants=g={}));var b;(function(t){t[t.Panel=1]="Panel",t[t.Editor=2]="Editor"})(b||(e.TerminalLocation=b={}));var l;(function(t){t.TerminalView="view",t.Editor="editor"})(l||(e.TerminalLocationString=l={}));var m;(function(t){t[t.GraceTime=6e4]="GraceTime",t[t.ShortGraceTime=6e3]="ShortGraceTime"})(m||(e.LocalReconnectConstants=m={}));var p;(function(t){t[t.HighWatermarkChars=1e5]="HighWatermarkChars",t[t.LowWatermarkChars=5e3]="LowWatermarkChars",t[t.CharCountAckSize=5e3]="CharCountAckSize"})(p||(e.FlowControlConstants=p={}));var $;(function(t){t.GitBash="Git Bash",t.Pwsh="PowerShell"})($||(e.ProfileSource=$={}));var w;(function(t){t[t.Off=0]="Off",t[t.FinalTerm=1]="FinalTerm",t[t.VSCode=2]="VSCode"})(w||(e.ShellIntegrationStatus=w={}));var v;(function(t){t[t.Unknown=0]="Unknown",t[t.Shutdown=1]="Shutdown",t[t.Process=2]="Process",t[t.User=3]="User",t[t.Extension=4]="Extension"})(v||(e.TerminalExitReason=v={})),e.$js={Backend:"workbench.contributions.terminal.processBackend"};class k{constructor(){this.a=new Map}get backends(){return this.a}registerTerminalBackend(r){const n=this.b(r.remoteAuthority);if(this.a.has(n))throw new Error(`A terminal backend with remote authority '${n}' was already registered.`);this.a.set(n,r)}getTerminalBackend(r){return this.a.get(this.b(r))}b(r){return r?.toLowerCase()??""}}S.$oo.add(e.$js.Backend,new k),e.$ks=(0,i.$Fi)("localPtyService"),e.$ls=(0,i.$Fi)("terminalLogService")}),define(oe[263],ae([0,1,78,7,193,111]),function(V,e,i,o,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qs=O,e.$rs=a,e.$ss=h,e.$ts=f;function O(g,b){const l=[{name:null,description:(0,S.localize)(0,null)}];return l.push(...g.map(m=>({name:m.profileName,description:P(m)}))),b&&l.push(...b.map(m=>({name:m.title,description:y(m)}))),{values:l.map(m=>m.name),markdownDescriptions:l.map(m=>m.description)}}function P(g){let b=`$(${D.ThemeIcon.isThemeIcon(g.icon)?g.icon.id:g.icon?g.icon:i.$5j.terminal.id}) ${g.profileName}
- path: ${g.path}`;return g.args&&(typeof g.args=="string"?b+=`
- args: "${g.args}"`:b+=`
- args: [${g.args.length===0?"":`'${g.args.join("','")}'`}]`),g.overrideName!==void 0&&(b+=`
- overrideName: ${g.overrideName}`),g.color&&(b+=`
- color: ${g.color}`),g.env&&(b+=`
- env: ${JSON.stringify(g.env)}`),b}function y(g){return`$(${D.ThemeIcon.isThemeIcon(g.icon)?g.icon.id:g.icon?g.icon:i.$5j.terminal.id}) ${g.title}
- extensionIdentifier: ${g.extensionIdentifier}`}function a(g,b){if(!g&&!b)return!0;if(typeof g=="string"&&typeof b=="string")return g===b;if(Array.isArray(g)&&Array.isArray(b)){if(g.length!==b.length)return!1;for(let l=0;l<g.length;l++)if(g[l]!==b[l])return!1;return!0}return!1}function h(g,b){if(!g&&!b)return!0;if(!g||!b)return!1;if(D.ThemeIcon.isThemeIcon(g)&&D.ThemeIcon.isThemeIcon(b))return g.id===b.id&&g.color===b.color;if(typeof g=="object"&&"light"in g&&"dark"in g&&typeof b=="object"&&"light"in b&&"dark"in b){const l=g,m=b;if((o.URI.isUri(l.light)||f(l.light))&&(o.URI.isUri(l.dark)||f(l.dark))&&(o.URI.isUri(m.light)||f(m.light))&&(o.URI.isUri(m.dark)||f(m.dark)))return l.light.path===m.light.path&&l.dark.path===m.dark.path}if(o.URI.isUri(g)&&o.URI.isUri(b)||f(g)||f(b)){const l=g,m=b;return l.path===m.path&&l.scheme===m.scheme}return!1}function f(g){return g?typeof g.path=="string"&&typeof g.scheme=="string":!1}}),define(oe[264],ae([0,1,78,4,192,54,45,73,263]),function(V,e,i,o,S,D,O,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vs=e.$us=void 0,e.$ws=l,e.$xs=p,e.$us={type:["string","null"],enum:["terminal.ansiBlack","terminal.ansiRed","terminal.ansiGreen","terminal.ansiYellow","terminal.ansiBlue","terminal.ansiMagenta","terminal.ansiCyan","terminal.ansiWhite"],default:null},e.$vs={type:"string",enum:Array.from((0,i.$3j)(),$=>$.id),markdownEnumDescriptions:Array.from((0,i.$3j)(),$=>`$(${$.id})`)};const a={args:{description:(0,S.localize)(0,null),type:"array",items:{type:"string"}},overrideName:{description:(0,S.localize)(1,null),type:"boolean"},icon:{description:(0,S.localize)(2,null),...e.$vs},color:{description:(0,S.localize)(3,null),...e.$us},env:{markdownDescription:(0,S.localize)(4,null),type:"object",additionalProperties:{type:["string","null"]},default:{}}},h={type:"object",required:["path"],properties:{path:{description:(0,S.localize)(5,null),type:["string","array"],items:{type:"string"}},...a}},f={type:"object",required:["path"],properties:{path:{description:(0,S.localize)(6,null),type:["string"],items:{type:"string"}},...a}};function g($){const w=$===o.Platform.Linux?"linux":$===o.Platform.Mac?"osx":"windows";return(0,S.localize)(7,null,(0,o.$h)($),'```json\n"terminal.integrated.profile.'+w+'": {\n  "bash": null\n}\n```',"[","](https://code.visualstudio.com/docs/terminal/profiles)")}const b={id:"terminal",order:100,title:(0,S.localize)(8,null),type:"object",properties:{[P.TerminalSettingId.AutomationProfileLinux]:{restricted:!0,markdownDescription:(0,S.localize)(9,null),type:["object","null"],default:null,anyOf:[{type:"null"},f],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},[P.TerminalSettingId.AutomationProfileMacOs]:{restricted:!0,markdownDescription:(0,S.localize)(10,null),type:["object","null"],default:null,anyOf:[{type:"null"},f],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},[P.TerminalSettingId.AutomationProfileWindows]:{restricted:!0,markdownDescription:(0,S.localize)(11,null,"`terminal.integrated.automationShell.windows`"),type:["object","null"],default:null,anyOf:[{type:"null"},f],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},[P.TerminalSettingId.ProfilesWindows]:{restricted:!0,markdownDescription:g(o.Platform.Windows),type:"object",default:{PowerShell:{source:"PowerShell",icon:"terminal-powershell"},"Command Prompt":{path:["${env:windir}\\Sysnative\\cmd.exe","${env:windir}\\System32\\cmd.exe"],args:[],icon:"terminal-cmd"},"Git Bash":{source:"Git Bash"}},additionalProperties:{anyOf:[{type:"object",required:["source"],properties:{source:{description:(0,S.localize)(12,null),enum:["PowerShell","Git Bash"]},...a}},{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,S.localize)(13,null),type:"string"},id:{description:(0,S.localize)(14,null),type:"string"},title:{description:(0,S.localize)(15,null),type:"string"},...a}},{type:"null"},h]}},[P.TerminalSettingId.ProfilesMacOs]:{restricted:!0,markdownDescription:g(o.Platform.Mac),type:"object",default:{bash:{path:"bash",args:["-l"],icon:"terminal-bash"},zsh:{path:"zsh",args:["-l"]},fish:{path:"fish",args:["-l"]},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,S.localize)(16,null),type:"string"},id:{description:(0,S.localize)(17,null),type:"string"},title:{description:(0,S.localize)(18,null),type:"string"},...a}},{type:"null"},h]}},[P.TerminalSettingId.ProfilesLinux]:{restricted:!0,markdownDescription:g(o.Platform.Linux),type:"object",default:{bash:{path:"bash",icon:"terminal-bash"},zsh:{path:"zsh"},fish:{path:"fish"},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,S.localize)(19,null),type:"string"},id:{description:(0,S.localize)(20,null),type:"string"},title:{description:(0,S.localize)(21,null),type:"string"},...a}},{type:"null"},h]}},[P.TerminalSettingId.UseWslProfiles]:{description:(0,S.localize)(22,null),type:"boolean",default:!0},[P.TerminalSettingId.InheritEnv]:{scope:D.ConfigurationScope.APPLICATION,description:(0,S.localize)(23,null),type:"boolean",default:!0},[P.TerminalSettingId.PersistentSessionScrollback]:{scope:D.ConfigurationScope.APPLICATION,markdownDescription:(0,S.localize)(24,null),type:"number",default:100},[P.TerminalSettingId.ShowLinkHover]:{scope:D.ConfigurationScope.APPLICATION,description:(0,S.localize)(25,null),type:"boolean",default:!0},[P.TerminalSettingId.IgnoreProcessNames]:{markdownDescription:(0,S.localize)(26,null,"`#terminal.integrated.confirmOnKill#`"),type:"array",items:{type:"string",uniqueItems:!0},default:["starship","oh-my-posh","bash","zsh"]}}};function l(){O.$oo.as(D.$to.Configuration).registerConfiguration(b),p()}let m;function p($,w){const v=O.$oo.as(D.$to.Configuration);let k;$&&(k=(0,y.$qs)($?.profiles,w));const t=m;m={id:"terminal",order:100,title:(0,S.localize)(27,null),type:"object",properties:{[P.TerminalSettingId.DefaultProfileLinux]:{restricted:!0,markdownDescription:(0,S.localize)(28,null),type:["string","null"],default:null,enum:$?.os===o.OperatingSystem.Linux?k?.values:void 0,markdownEnumDescriptions:$?.os===o.OperatingSystem.Linux?k?.markdownDescriptions:void 0},[P.TerminalSettingId.DefaultProfileMacOs]:{restricted:!0,markdownDescription:(0,S.localize)(29,null),type:["string","null"],default:null,enum:$?.os===o.OperatingSystem.Macintosh?k?.values:void 0,markdownEnumDescriptions:$?.os===o.OperatingSystem.Macintosh?k?.markdownDescriptions:void 0},[P.TerminalSettingId.DefaultProfileWindows]:{restricted:!0,markdownDescription:(0,S.localize)(30,null),type:["string","null"],default:null,enum:$?.os===o.OperatingSystem.Windows?k?.values:void 0,markdownEnumDescriptions:$?.os===o.OperatingSystem.Windows?k?.markdownDescriptions:void 0}}},v.updateConfigurations({add:[m],remove:t?[t]:[]})}}),define(oe[265],ae([0,1,27,13,35,9,4,36,26,12,21,131,261,260]),function(V,e,i,o,S,D,O,P,y,a,h,f,g,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fs=l,e.$Gs=m,e.$Hs=p,i=Re(i),D=Re(D),P=Re(P),h=Re(h);function l(){const d=/(\d+)\.(\d+)\.(\d+)/g.exec(i.release());let I=0;return d&&d.length===4&&(I=parseInt(d[3])),I}async function m(d,I,E,A=P.env,T=h.Promises.exists){if(D.$kc(d))return await T(d)?d:void 0;if(I===void 0&&(I=P.cwd()),D.$oc(d)!=="."){const U=D.$lc(I,d);return await T(U)?U:void 0}const R=(0,S.$io)(A,"PATH");if(E===void 0&&(0,a.$fg)(R)&&(E=R.split(D.$vc)),E===void 0||E.length===0){const U=D.$lc(I,d);return await T(U)?U:void 0}for(const U of E){let N;if(D.$kc(U)?N=D.$lc(U,d):N=D.$lc(I,U,d),await T(N))return N;if(O.$i){let z=N+".com";if(await T(z)||(z=N+".exe",await T(z)))return z}}const M=D.$lc(I,d);return await T(M)?M:void 0}function p(d,I,E,A,T){const L=O.$i&&(!I.windowsEnableConpty||l()<18309);if(!I.shellIntegration.enabled||!d.executable||d.isFeatureTerminal&&!d.forceShellIntegration||d.ignoreShellIntegration||L)return;const R=d.args,M=P.$fc==="win32"?D.$pc(d.executable).toLowerCase():D.$pc(d.executable),U=D.$oc(o.$Zg.asFileUri("").fsPath);let N;const z={VSCODE_INJECTION:"1"};if(I.shellIntegration.nonce&&(z.VSCODE_NONCE=I.shellIntegration.nonce),O.$i){if(M==="pwsh.exe"||M==="powershell.exe")return!R||s(R)?N=v.get(w.WindowsPwsh):c(R)&&(N=v.get(w.WindowsPwshLogin)),N?(N=[...N],N[N.length-1]=(0,y.$ef)(N[N.length-1],U,""),z.VSCODE_STABLE=T.quality==="stable"?"1":"0",I.shellIntegration.suggestEnabled&&(z.VSCODE_SUGGEST="1"),{newArgs:N,envMixin:z}):void 0;if(M==="bash.exe")return!R||R.length===0?N=v.get(w.Bash):u(R)&&(z.VSCODE_SHELL_LOGIN="1",$(I,z),N=v.get(w.Bash)),N?(N=[...N],N[N.length-1]=(0,y.$ef)(N[N.length-1],U),z.VSCODE_STABLE=T.quality==="stable"?"1":"0",{newArgs:N,envMixin:z}):void 0;A.warn(`Shell integration cannot be enabled for executable "${d.executable}" and args`,d.args);return}switch(M){case"bash":return!R||R.length===0?N=v.get(w.Bash):u(R)&&(z.VSCODE_SHELL_LOGIN="1",$(I,z),N=v.get(w.Bash)),N?(N=[...N],N[N.length-1]=(0,y.$ef)(N[N.length-1],U),z.VSCODE_STABLE=T.quality==="stable"?"1":"0",{newArgs:N,envMixin:z}):void 0;case"fish":{const ne=E?.XDG_DATA_DIRS??"/usr/local/share:/usr/share",Q=D.$lc(U,"out/vs/workbench/contrib/terminal/browser/media/fish_xdg_data");return z.XDG_DATA_DIRS=`${ne}:${Q}`,$(I,z),{newArgs:void 0,envMixin:z}}case"pwsh":return!R||s(R)?N=v.get(w.Pwsh):c(R)&&(N=v.get(w.PwshLogin)),N?(I.shellIntegration.suggestEnabled&&(z.VSCODE_SUGGEST="1"),N=[...N],N[N.length-1]=(0,y.$ef)(N[N.length-1],U,""),z.VSCODE_STABLE=T.quality==="stable"?"1":"0",{newArgs:N,envMixin:z}):void 0;case"zsh":{if(!R||R.length===0?N=v.get(w.Zsh):u(R)?(N=v.get(w.ZshLogin),$(I,z)):(R===v.get(w.Zsh)||R===v.get(w.ZshLogin))&&(N=R),!N)return;N=[...N],N[N.length-1]=(0,y.$ef)(N[N.length-1],U);let ne;try{ne=i.userInfo().username}catch{ne="unknown"}const Q=D.$lc(i.tmpdir(),`${ne}-${T.applicationName}-zsh`);z.ZDOTDIR=Q;const le=E?.ZDOTDIR??i.homedir()??"~";z.USER_ZDOTDIR=le;const K=[];return K.push({source:D.$lc(U,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-rc.zsh"),dest:D.$lc(Q,".zshrc")}),K.push({source:D.$lc(U,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-profile.zsh"),dest:D.$lc(Q,".zprofile")}),K.push({source:D.$lc(U,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-env.zsh"),dest:D.$lc(Q,".zshenv")}),K.push({source:D.$lc(U,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-login.zsh"),dest:D.$lc(Q,".zlogin")}),{newArgs:N,envMixin:z,filesToCopy:K}}}A.warn(`Shell integration cannot be enabled for executable "${d.executable}" and args`,d.args)}function $(d,I){if(O.$j&&d.environmentVariableCollections){const E=(0,g.$Ds)(d.environmentVariableCollections),T=new b.$Es(E).getVariableMap({workspaceFolder:d.workspaceFolder}).get("PATH"),L=[];if(T)for(const R of T)R.type===f.EnvironmentVariableMutatorType.Prepend&&L.push(R.value);L.length>0&&(I.VSCODE_PATH_PREFIX=L.join(""))}}var w;(function(d){d.WindowsPwsh="windows-pwsh",d.WindowsPwshLogin="windows-pwsh-login",d.Pwsh="pwsh",d.PwshLogin="pwsh-login",d.Zsh="zsh",d.ZshLogin="zsh-login",d.Bash="bash"})(w||(w={}));const v=new Map;v.set(w.WindowsPwsh,["-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),v.set(w.WindowsPwshLogin,["-l","-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),v.set(w.Pwsh,["-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"{1}']),v.set(w.PwshLogin,["-l","-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"']),v.set(w.Zsh,["-i"]),v.set(w.ZshLogin,["-il"]),v.set(w.Bash,["--init-file","{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration-bash.sh"]);const k=["-login","-l"],t=["--login","-l"],r=["-i","--interactive"],n=["-nol","-nologo"];function c(d){return typeof d=="string"?k.includes(d.toLowerCase()):d.length===1&&k.includes(d[0].toLowerCase())||d.length===2&&(k.includes(d[0].toLowerCase())||k.includes(d[1].toLowerCase()))&&(n.includes(d[0].toLowerCase())||n.includes(d[1].toLowerCase()))}function s(d){return typeof d=="string"?n.includes(d.toLowerCase()):d.length===0||d?.length===1&&n.includes(d[0].toLowerCase())}function u(d){return typeof d!="string"&&(d=d.filter(I=>!r.includes(I.toLowerCase()))),d==="string"&&t.includes(d.toLowerCase())||typeof d!="string"&&d.length===1&&t.includes(d[0].toLowerCase())}}),define(oe[266],ae([0,1,49,78,9,4,12,21,115,73,265,122]),function(V,e,i,o,S,D,O,P,y,a,h,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Is=m,i=Re(i),P=Re(P);var g;(function(I){I.UnixShellsPath="/etc/shells"})(g||(g={}));let b,l=!0;function m(I,E,A,T,L=process.env,R,M,U,N){return R=R||{existsFile:P.SymlinkSupport.existsFile,readFile:P.Promises.readFile},D.$i?p(A,R,L,M,T.getValue(a.TerminalSettingId.UseWslProfiles)!==!1,I&&typeof I=="object"?{...I}:T.getValue(a.TerminalSettingId.ProfilesWindows),typeof E=="string"?E:T.getValue(a.TerminalSettingId.DefaultProfileWindows),N,U):s(R,M,A,I&&typeof I=="object"?{...I}:T.getValue(D.$k?a.TerminalSettingId.ProfilesLinux:a.TerminalSettingId.ProfilesMacOs),typeof E=="string"?E:T.getValue(D.$k?a.TerminalSettingId.DefaultProfileLinux:a.TerminalSettingId.DefaultProfileMacOs),N,U,L)}async function p(I,E,A,T,L,R,M,U,N){const z=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),ne=`${process.env.windir}\\${z?"Sysnative":"System32"}`;let Q=!1;(0,h.$Fs)()>=16299&&(Q=!0),await k(U);const le=new Map;if(I){le.set("PowerShell",{source:a.ProfileSource.Pwsh,icon:o.$5j.terminalPowershell,isAutoDetected:!0}),le.set("Windows PowerShell",{path:`${ne}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:o.$5j.terminalPowershell,isAutoDetected:!0}),le.set("Git Bash",{source:a.ProfileSource.GitBash,isAutoDetected:!0}),le.set("Command Prompt",{path:`${ne}\\cmd.exe`,icon:o.$5j.terminalCmd,isAutoDetected:!0}),le.set("Cygwin",{path:[{path:`${process.env.HOMEDRIVE}\\cygwin64\\bin\\bash.exe`,isUnsafe:!0},{path:`${process.env.HOMEDRIVE}\\cygwin\\bin\\bash.exe`,isUnsafe:!0}],args:["--login"],isAutoDetected:!0}),le.set("bash (MSYS2)",{path:[{path:`${process.env.HOMEDRIVE}\\msys64\\usr\\bin\\bash.exe`,isUnsafe:!0}],args:["--login","-i"],env:{CHERE_INVOKING:"1"},icon:o.$5j.terminalBash,isAutoDetected:!0});const ee=`${process.env.CMDER_ROOT||`${process.env.HOMEDRIVE}\\cmder`}\\vendor\\bin\\vscode_init.cmd`;le.set("Cmder",{path:`${ne}\\cmd.exe`,args:["/K",ee],requiresPath:process.env.CMDER_ROOT?ee:{path:ee,isUnsafe:!0},isAutoDetected:!0})}u(R,le);const K=await $(le.entries(),M,E,A,T,N);if(I&&L)try{const ee=await n(`${ne}\\${Q?"wsl":"bash"}.exe`,M);for(const H of ee)(!R||!(H.profileName in R))&&K.push(H)}catch{l&&(T?.trace("WSL is not installed, so could not detect WSL profiles"),l=!1)}return K}async function $(I,E,A,T=process.env,L,R){const M=[];for(const[U,N]of I)M.push(w(U,N,E,A,T,L,R));return(await Promise.all(M)).filter(U=>!!U)}async function w(I,E,A,T,L=process.env,R,M){if(E===null)return;let U,N,z;if("source"in E&&!("path"in E)){const K=b?.get(E.source);if(!K)return;U=K.paths,N=E.args||K.args,E.icon?z=v(E.icon):K.icon&&(z=K.icon)}else U=Array.isArray(E.path)?E.path:[E.path],N=D.$i||Array.isArray(E.args)?E.args:void 0,z=v(E.icon);let ne;if(M){const K=U.map(H=>typeof H=="string"?H:H.path),ee=await M(K);ne=new Array(U.length);for(let H=0;H<U.length;H++)typeof U[H]=="string"?ne[H]=ee[H]:ne[H]={path:ee[H],isUnsafe:!0}}else ne=U.slice();let Q;if(E.requiresPath){let K;if((0,O.$fg)(E.requiresPath)?K=E.requiresPath:(K=E.requiresPath.path,E.requiresPath.isUnsafe&&(Q=K)),!await T.existsFile(K))return}const le=await d(I,A,ne,T,L,N,E.env,E.overrideName,E.isAutoDetected,Q);if(!le){R?.debug("Terminal profile not validated",I,U);return}return le.isAutoDetected=E.isAutoDetected,le.icon=z,le.color=E.color,le}function v(I){return typeof I=="string"?{id:I}:I}async function k(I){if(b&&!I)return;const[E,A]=await Promise.all([t(),I||r()]);b=new Map,b.set(a.ProfileSource.GitBash,{profileName:"Git Bash",paths:E,args:["--login","-i"]}),b.set(a.ProfileSource.Pwsh,{profileName:"PowerShell",paths:A,icon:o.$5j.terminalPowershell})}async function t(){const I=new Set,E=await(0,h.$Gs)("git.exe");if(E){const L=(0,f.dirname)(E);I.add((0,f.resolve)(L,"../.."))}function A(L,R){R&&L.add(R)}A(I,process.env.ProgramW6432),A(I,process.env.ProgramFiles),A(I,process.env["ProgramFiles(X86)"]),A(I,`${process.env.LocalAppData}\\Program`);const T=[];for(const L of I)T.push(`${L}\\Git\\bin\\bash.exe`,`${L}\\Git\\usr\\bin\\bash.exe`,`${L}\\usr\\bin\\bash.exe`);return T.push(`${process.env.UserProfile}\\scoop\\apps\\git\\current\\bin\\bash.exe`),T.push(`${process.env.UserProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`),T}async function r(){const I=[];for await(const E of(0,y.$vm)())I.push(E.exePath);return I}async function n(I,E){const A=[],T=await new Promise((M,U)=>{i.exec("wsl.exe -l -q",{encoding:"utf16le",timeout:1e3},(N,z)=>{if(N)return U("Problem occurred when getting wsl distros");M(z)})});if(!T)return[];const L=new RegExp(/[\r?\n]/),R=T.split(L).filter(M=>M.trim().length>0&&M!=="");for(const M of R){if(M===""||M.startsWith("docker-desktop"))continue;const U=`${M} (WSL)`,N={profileName:U,path:I,args:["-d",`${M}`],isDefault:U===E,icon:c(M),isAutoDetected:!1};A.push(N)}return A}function c(I){return I.includes("Ubuntu")?o.$5j.terminalUbuntu:I.includes("Debian")?o.$5j.terminalDebian:o.$5j.terminalLinux}async function s(I,E,A,T,L,R,M,U){const N=new Map;if(A&&await I.existsFile(g.UnixShellsPath)){const z=(await I.readFile(g.UnixShellsPath)).toString(),ne=(R||z.split(`
`)).map(le=>{const K=le.indexOf("#");return K===-1?le:le.substring(0,K)}).filter(le=>le.trim().length>0),Q=new Map;for(const le of ne){let K=(0,S.$pc)(le),ee=Q.get(K)||0;ee++,ee>1&&(K=`${K} (${ee})`),Q.set(K,ee),N.set(K,{path:le,isAutoDetected:!0})}}return u(T,N),await $(N.entries(),L,I,U,E,M)}function u(I,E){if(I)for(const[A,T]of Object.entries(I))T===null||typeof T!="object"||!("path"in T)&&!("source"in T)?E.delete(A):(T.icon=T.icon||E.get(A)?.icon,E.set(A,T))}async function d(I,E,A,T,L,R,M,U,N,z){if(A.length===0)return Promise.resolve(void 0);const ne=A.shift();if(ne==="")return d(I,E,A,T,L,R,M,U,N);const Q=typeof ne!="string"&&ne.isUnsafe,le=typeof ne=="string"?ne:ne.path,K={profileName:I,path:le,args:R,env:M,overrideName:U,isAutoDetected:N,isDefault:I===E,isUnsafePath:Q,requiresUnsafePath:z};if((0,S.$pc)(le)===le){const H=L.PATH?L.PATH.split(S.$vc):void 0,j=await(0,h.$Gs)(le,void 0,H,void 0,T.existsFile);return j?(K.path=j,K.isFromPath=!0,K):d(I,E,A,T,L,R)}return await T.existsFile((0,S.$jc)(le))?K:d(I,E,A,T,L,R,M,U,N)}}),define(oe[267],ae([0,1,3,2,4,44,18,5,231,101,262,73,264,266,117,66]),function(V,e,i,o,S,D,O,P,y,a,h,f,g,b,l,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Js=void 0;var p;(function(w){w[w.MaxRestarts=5]="MaxRestarts"})(p||(p={}));let $=class extends o.$Wc{get c(){return this.h(),this.a}get f(){return this.h(),this.b}get g(){return this.b}h(){this.a||this.U()}constructor(v,k,t,r){super(),this.M=v,this.N=k,this.O=t,this.P=r,this.m=!1,this.n=0,this.r=!0,this.u=this.B(new i.$me),this.onPtyHostExit=this.u.event,this.w=this.B(new i.$me),this.onPtyHostStart=this.w.event,this.y=this.B(new i.$me),this.onPtyHostUnresponsive=this.y.event,this.z=this.B(new i.$me),this.onPtyHostResponsive=this.z.event,this.C=this.B(new i.$me),this.onPtyHostRequestResolveVariables=this.C.event,this.D=this.B(new i.$me),this.onProcessData=this.D.event,this.F=this.B(new i.$me),this.onProcessReady=this.F.event,this.G=this.B(new i.$me),this.onProcessReplay=this.G.event,this.H=this.B(new i.$me),this.onProcessOrphanQuestion=this.H.event,this.I=this.B(new i.$me),this.onDidRequestDetach=this.I.event,this.J=this.B(new i.$me),this.onDidChangeProperty=this.J.event,this.L=this.B(new i.$me),this.onProcessExit=this.L.event,(0,g.$ws)(),this.B(this.M),this.B((0,o.$Uc)(()=>this.W())),this.j=this.B(new h.$ps(void 0,this.O)),this.B(this.j.onCreateRequest(this.C.fire,this.C)),this.M.onRequestConnection&&this.B(i.Event.once(this.M.onRequestConnection)(()=>this.h())),this.M.onWillShutdown&&this.B(this.M.onWillShutdown(()=>this.m=!0))}get Q(){return this.N.getValue(f.TerminalSettingId.IgnoreProcessNames)}async R(){return this.g?.refreshIgnoreProcessNames?.(this.Q)}async S(){if(S.$i)return process.env;try{return await(0,a.$Qm)(this.N,this.O,{_:[]},process.env)}catch(v){return this.O.error("ptyHost was unable to resolve shell environment",v),{}}}U(){const v=this.M.start(),k=v.client;this.O.getLevel()===P.LogLevel.Trace&&this.O.trace("PtyHostService#_startPtyHost",new Error().stack?.replace(/^Error/,"")),D.ProxyChannel.toService(k.getChannel(f.TerminalIpcChannels.Heartbeat)).onBeat(()=>this.X()),this.X(!0),this.B(v.onDidProcessExit(n=>{this.u.fire(n.code),!this.m&&!this.q.isDisposed&&(this.n<=p.MaxRestarts?(this.O.error(`ptyHost terminated unexpectedly with code ${n.code}`),this.n++,this.restartPtyHost()):this.O.error(`ptyHost terminated unexpectedly with code ${n.code}, giving up`))}));const r=D.ProxyChannel.toService(k.getChannel(f.TerminalIpcChannels.PtyHost));return this.B(r.onProcessData(n=>this.D.fire(n))),this.B(r.onProcessReady(n=>this.F.fire(n))),this.B(r.onProcessExit(n=>this.L.fire(n))),this.B(r.onDidChangeProperty(n=>this.J.fire(n))),this.B(r.onProcessReplay(n=>this.G.fire(n))),this.B(r.onProcessOrphanQuestion(n=>this.H.fire(n))),this.B(r.onDidRequestDetach(n=>this.I.fire(n))),this.B(new y.$os(this.P,k.getChannel(f.TerminalIpcChannels.Logger))),this.a=v,this.b=r,this.w.fire(),this.B(this.N.onDidChangeConfiguration(async n=>{n.affectsConfiguration(f.TerminalSettingId.IgnoreProcessNames)&&await this.R()})),this.R(),[v,r]}async createProcess(v,k,t,r,n,c,s,u,d,I,E){const A=setTimeout(()=>this.$(),f.HeartbeatConstants.CreateProcessTimeout),T=await this.f.createProcess(v,k,t,r,n,c,s,u,d,I,E);return clearTimeout(A),T}updateTitle(v,k,t){return this.f.updateTitle(v,k,t)}updateIcon(v,k,t,r){return this.f.updateIcon(v,k,t,r)}attachToProcess(v){return this.f.attachToProcess(v)}detachFromProcess(v,k){return this.f.detachFromProcess(v,k)}shutdownAll(){return this.f.shutdownAll()}listProcesses(){return this.f.listProcesses()}async getPerformanceMarks(){return this.g?.getPerformanceMarks()??[]}async reduceConnectionGraceTime(){return this.g?.reduceConnectionGraceTime()}start(v){return this.f.start(v)}shutdown(v,k){return this.f.shutdown(v,k)}input(v,k){return this.f.input(v,k)}processBinary(v,k){return this.f.processBinary(v,k)}resize(v,k,t){return this.f.resize(v,k,t)}clearBuffer(v){return this.f.clearBuffer(v)}acknowledgeDataEvent(v,k){return this.f.acknowledgeDataEvent(v,k)}setUnicodeVersion(v,k){return this.f.setUnicodeVersion(v,k)}getInitialCwd(v){return this.f.getInitialCwd(v)}getCwd(v){return this.f.getCwd(v)}async getLatency(){const v=new m.$ge,k=await this.f.getLatency();return v.stop(),[{label:"ptyhostservice<->ptyhost",latency:v.elapsed()},...k]}orphanQuestionReply(v){return this.f.orphanQuestionReply(v)}installAutoReply(v,k){return this.f.installAutoReply(v,k)}uninstallAllAutoReplies(){return this.f.uninstallAllAutoReplies()}uninstallAutoReply(v){return this.f.uninstallAutoReply(v)}getDefaultSystemShell(v){return this.g?.getDefaultSystemShell(v)??(0,l.$zm)(v??S.OS,process.env)}async getProfiles(v,k,t,r=!1){const n=await this.S();return(0,b.$Is)(k,t,r,this.N,n,void 0,this.O,this.bb.bind(this,v))}async getEnvironment(){return this.b?this.f.getEnvironment():{...process.env}}getWslPath(v,k){return this.f.getWslPath(v,k)}getRevivedPtyNewId(v,k){return this.f.getRevivedPtyNewId(v,k)}setTerminalLayoutInfo(v){return this.f.setTerminalLayoutInfo(v)}async getTerminalLayoutInfo(v){return this.g?.getTerminalLayoutInfo(v)}async requestDetachInstance(v,k){return this.f.requestDetachInstance(v,k)}async acceptDetachInstanceReply(v,k){return this.f.acceptDetachInstanceReply(v,k)}async freePortKillProcess(v){if(!this.f.freePortKillProcess)throw new Error("freePortKillProcess does not exist on the pty proxy");return this.f.freePortKillProcess(v)}async serializeTerminalState(v){return this.f.serializeTerminalState(v)}async reviveTerminalProcesses(v,k,t){return this.f.reviveTerminalProcesses(v,k,t)}async refreshProperty(v,k){return this.f.refreshProperty(v,k)}async updateProperty(v,k,t){return this.f.updateProperty(v,k,t)}async restartPtyHost(){this.W(),this.r=!0,this.U()}W(){this.f.shutdownAll(),this.c.store.dispose()}X(v){this.ab(),this.s=setTimeout(()=>this.Y(),v?f.HeartbeatConstants.ConnectingBeatInterval:f.HeartbeatConstants.BeatInterval*f.HeartbeatConstants.FirstWaitMultiplier),this.r||(this.r=!0,this.z.fire())}Y(){this.O.warn(`No ptyHost heartbeat after ${f.HeartbeatConstants.BeatInterval*f.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this.s=void 0,this.t=setTimeout(()=>this.Z(),f.HeartbeatConstants.BeatInterval*f.HeartbeatConstants.SecondWaitMultiplier)}Z(){this.O.error(`No ptyHost heartbeat after ${(f.HeartbeatConstants.BeatInterval*f.HeartbeatConstants.FirstWaitMultiplier+f.HeartbeatConstants.BeatInterval*f.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this.t=void 0,this.r&&(this.r=!1,this.y.fire())}$(){this.ab(),this.O.error(`No ptyHost response to createProcess after ${f.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this.r&&(this.r=!1,this.y.fire())}ab(){this.s&&(clearTimeout(this.s),this.s=void 0),this.t&&(clearTimeout(this.t),this.t=void 0)}bb(v,k){return this.j.createRequest({workspaceId:v,originalText:k})}async acceptPtyHostResolvedVariables(v,k){this.j.acceptReply(v,k)}};e.$Js=$,e.$Js=$=Se([re(1,O.$_i),re(2,P.$_j),re(3,P.$ak)],$)}),define(oe[74],ae([0,1,14,3,2,4,18,6,34]),function(V,e,i,o,S,D,O,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uec=e.$tec=void 0;const a="#FFFFFF",h="#1E1E1E",f="#000000",g="#FFFFFF",b="theme",l="themeBackground",m="windowSplash";var p;(function(w){w.DETECT_COLOR_SCHEME="window.autoDetectColorScheme",w.SYSTEM_COLOR_THEME="window.systemColorTheme"})(p||(p={})),e.$tec=(0,P.$Fi)("themeMainService");let $=class extends S.$Wc{constructor(v,k){super(),this.b=v,this.c=k,this.a=this.B(new o.$me),this.onDidChangeColorScheme=this.a.event,D.$k||this.B(this.c.onDidChangeConfiguration(t=>{(t.affectsConfiguration(p.SYSTEM_COLOR_THEME)||t.affectsConfiguration(p.DETECT_COLOR_SCHEME))&&this.f()})),this.f(),this.B(o.Event.fromNodeEventEmitter(i.nativeTheme,"updated")(()=>this.a.fire(this.getColorScheme())))}f(){if(D.$k||this.c.getValue(p.DETECT_COLOR_SCHEME))i.nativeTheme.themeSource="system";else switch(this.c.getValue(p.SYSTEM_COLOR_THEME)){case"dark":i.nativeTheme.themeSource="dark";break;case"light":i.nativeTheme.themeSource="light";break;case"auto":switch(this.g()){case"vs":i.nativeTheme.themeSource="light";break;case"vs-dark":i.nativeTheme.themeSource="dark";break;default:i.nativeTheme.themeSource="system"}break;default:i.nativeTheme.themeSource="system";break}}getColorScheme(){if(D.$i){if(i.nativeTheme.shouldUseHighContrastColors)return{dark:i.nativeTheme.shouldUseInvertedColorScheme,highContrast:!0}}else if(D.$j){if(i.nativeTheme.shouldUseInvertedColorScheme||i.nativeTheme.shouldUseHighContrastColors)return{dark:i.nativeTheme.shouldUseDarkColors,highContrast:!0}}else if(D.$k&&i.nativeTheme.shouldUseHighContrastColors)return{dark:!0,highContrast:!0};return{dark:i.nativeTheme.shouldUseDarkColors,highContrast:!1}}getBackgroundColor(){const v=this.getColorScheme();if(v.highContrast&&this.c.getValue("window.autoDetectHighContrast"))return v.dark?f:g;let k=this.b.getItem(l,null);if(!k)switch(this.g()){case"vs":k=a;break;case"hc-black":k=f;break;case"hc-light":k=g;break;default:k=h}return D.$j&&k.toUpperCase()===h&&(k="#171717"),k}g(){switch(this.b.getItem(b,"vs-dark").split(" ")[0]){case"vs":return"vs";case"hc-black":return"hc-black";case"hc-light":return"hc-light";default:return"vs-dark"}}saveWindowSplash(v,k){this.b.setItems([{key:b,data:k.baseTheme},{key:l,data:k.colorInfo.background},{key:m,data:k}]),typeof v=="number"&&this.h(v,k),this.f()}h(v,k){for(const t of i.BrowserWindow.getAllWindows())if(t.id===v){t.setBackgroundColor(k.colorInfo.background);break}}getWindowSplash(){return this.b.getItem(m)}};e.$uec=$,e.$uec=$=Se([re(0,y.$dR),re(1,O.$_i)],$)}),define(oe[132],ae([0,1,3,2,4,7,18,6,5]),function(V,e,i,o,S,D,O,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hw=e.$Gw=e.$Dw=e.$Bw=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.$xw=e.$ww=void 0,e.$yw=f,e.$zw=b,e.$Aw=l,e.$Cw=m,e.$Ew=p,e.$Fw=$,e.$ww=(0,P.$Fi)("tunnelService"),e.$xw=(0,P.$Fi)("sharedTunnelsService");var a;(function(k){k.Http="http",k.Https="https"})(a||(e.TunnelProtocol=a={}));var h;(function(k){k.ConstantPrivate="constantPrivate",k.Private="private",k.Public="public"})(h||(e.TunnelPrivacyId=h={}));function f(k){return!!k.forwardPort}var g;(function(k){k[k.Notify=1]="Notify",k[k.OpenBrowser=2]="OpenBrowser",k[k.OpenPreview=3]="OpenPreview",k[k.Silent=4]="Silent",k[k.Ignore=5]="Ignore",k[k.OpenBrowserOnce=6]="OpenBrowserOnce"})(g||(e.ProvidedOnAutoForward=g={}));function b(k){if(k.scheme!=="http"&&k.scheme!=="https")return;const t=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(k.authority);if(t)return{address:t[1],port:+t[2]}}function l(k){if(k.scheme!=="http"&&k.scheme!=="https"||!k.query)return;const t=k.query.split("&");for(const r of t){const n=r.split("=")[1];if(/^https?:/.exec(n)){const c=b(D.URI.parse(n));if(c)return c}}}e.$Bw=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function m(k){return e.$Bw.indexOf(k)>=0}e.$Dw=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function p(k){return e.$Dw.indexOf(k)>=0}function $(k,t,r,n){if(r===S.OperatingSystem.Windows)return!1;if(r===S.OperatingSystem.Macintosh&&p(t)){const c=/(\d+)\.(\d+)\.(\d+)/g.exec(n);if(c?.length===4&&parseInt(c[1])>=18)return!1}return k<1024}class w{constructor(t,r,n){this.remoteAddress=t,this.localAddress=r,this.b=n,this.a=new i.$me,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$Gw=w;let v=class extends o.$Wc{constructor(t,r){super(),this.r=t,this.s=r,this.a=new i.$me,this.onTunnelOpened=this.a.event,this.b=new i.$me,this.onTunnelClosed=this.b.event,this.c=new i.$me,this.onAddedTunnelProvider=this.c.event,this.f=new Map,this.h=!1,this.j=!0,this.m=[],this.n=new Set}get hasTunnelProvider(){return!!this.g}get t(){const t=this.s.getValue("remote.localPortHost");return!t||t==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(t){return this.g=t,t?(this.c.fire(),{dispose:()=>{this.g=void 0,this.h=!1,this.m=[]}}):(this.h=!1,this.m=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(t){this.h=t.elevation,this.m=t.privacyOptions,this.j=t.protocol}get canChangeProtocol(){return this.j}get canElevate(){return this.h}get canChangePrivacy(){return this.m.length>0}get privacyOptions(){return this.m}get tunnels(){return this.u()}async u(){const t=[],r=Array.from(this.f.values());for(const n of r){const c=Array.from(n.values());for(const s of c){const u=await s.value;u&&typeof u!="string"&&t.push(u)}}return t}async dispose(){super.dispose();for(const t of this.f.values()){for(const{value:r}of t.values())await r.then(n=>typeof n!="string"?n?.dispose():void 0);t.clear()}this.f.clear()}setEnvironmentTunnel(t,r,n,c,s){this.z(t,r,Promise.resolve({tunnelRemoteHost:t,tunnelRemotePort:r,localAddress:n,privacy:c,protocol:s,dispose:()=>Promise.resolve()}))}async getExistingTunnel(t,r){(p(t)||m(t))&&(t=e.$Bw[0]);const n=this.D(t,r);if(n)return++n.refcount,n.value}openTunnel(t,r,n,c,s,u=!1,d,I){this.r.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${r}:${n} on local port ${s}.`);const E=this.g??t;if(!E)return;if(r||(r="localhost"),c||(c=this.t),this.g&&this.n.has(n)){this.r.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const A=this.F(E,r,n,c,s,u,d,I);return A?A.then(T=>{if(T){if(typeof T=="string")return this.r.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.C(r,n),T}else{this.r.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.C(r,n);return}this.r.trace("ForwardedPorts: (TunnelService) New tunnel established.");const L=this.w(T);return(T.tunnelRemoteHost!==r||T.tunnelRemotePort!==n)&&this.r.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),d&&T.privacy!==d&&this.r.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(L),L}):(this.r.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),A)}w(t){return{tunnelRemotePort:t.tunnelRemotePort,tunnelRemoteHost:t.tunnelRemoteHost,tunnelLocalPort:t.tunnelLocalPort,localAddress:t.localAddress,privacy:t.privacy,protocol:t.protocol,dispose:async()=>{this.r.trace(`ForwardedPorts: (TunnelService) dispose request for ${t.tunnelRemoteHost}:${t.tunnelRemotePort} `);const r=this.f.get(t.tunnelRemoteHost);if(r){const n=r.get(t.tunnelRemotePort);n&&(n.refcount--,await this.y(t.tunnelRemoteHost,t.tunnelRemotePort,n))}}}}async y(t,r,n){if(n.refcount<=0){this.r.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${t}:${r}.`);const c=n.value.then(async s=>{s&&typeof s!="string"&&(await s.dispose(!0),this.b.fire({host:s.tunnelRemoteHost,port:s.tunnelRemotePort}))});return this.f.has(t)&&this.f.get(t).delete(r),c}}async closeTunnel(t,r){this.r.trace(`ForwardedPorts: (TunnelService) close request for ${t}:${r} `);const n=this.f.get(t);if(n&&n.has(r)){const c=n.get(r);c.refcount=0,await this.y(t,r,c)}}z(t,r,n){this.f.has(t)||this.f.set(t,new Map),this.f.get(t).set(r,{refcount:1,value:n})}async C(t,r){const n=this.f.get(t);if(n){const c=n.get(r),s=c?await c.value:void 0;(!s||typeof s=="string")&&n.delete(r),n.size===0&&this.f.delete(t)}}D(t,r){const n=[t];m(t)?(n.push(...e.$Bw),n.push(...e.$Dw)):p(t)&&n.push(...e.$Dw);const c=n.map(s=>this.f.get(s));for(const s of c){const u=s?.get(r);if(u)return u}}canTunnel(t){return!!b(t)}G(t,r,n,c,s,u,d){this.r.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${r}:${n} on local port ${c}.`);const I=n;this.n.add(I);const E=c===void 0?n:c,A={elevationRequired:s?this.isPortPrivileged(E):!1},T={remoteAddress:{host:r,port:n},localAddressPort:c,privacy:u,public:u?u!==h.Private:void 0,protocol:d},L=t.forwardPort(T,A);return L?(this.z(r,n,L),L.finally(()=>{this.r.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.n.delete(I)})):this.n.delete(I),L}};e.$Hw=v,e.$Hw=v=Se([re(0,y.$_j),re(1,O.$_i)],v)}),define(oe[50],ae([0,1,6]),function(V,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$AY=e.$zY=e.DisablementReason=e.UpdateType=e.StateType=void 0;var o;(function(O){O.Uninitialized="uninitialized",O.Idle="idle",O.Disabled="disabled",O.CheckingForUpdates="checking for updates",O.AvailableForDownload="available for download",O.Downloading="downloading",O.Downloaded="downloaded",O.Updating="updating",O.Ready="ready"})(o||(e.StateType=o={}));var S;(function(O){O[O.Setup=0]="Setup",O[O.Archive=1]="Archive",O[O.Snap=2]="Snap"})(S||(e.UpdateType=S={}));var D;(function(O){O[O.NotBuilt=0]="NotBuilt",O[O.DisabledByEnvironment=1]="DisabledByEnvironment",O[O.ManuallyDisabled=2]="ManuallyDisabled",O[O.MissingConfiguration=3]="MissingConfiguration",O[O.InvalidConfiguration=4]="InvalidConfiguration",O[O.RunningAsAdmin=5]="RunningAsAdmin"})(D||(e.DisablementReason=D={})),e.$zY={Uninitialized:{type:o.Uninitialized},Disabled:O=>({type:o.Disabled,reason:O}),Idle:(O,P)=>({type:o.Idle,updateType:O,error:P}),CheckingForUpdates:O=>({type:o.CheckingForUpdates,explicit:O}),AvailableForDownload:O=>({type:o.AvailableForDownload,update:O}),Downloading:{type:o.Downloading},Downloaded:O=>({type:o.Downloaded,update:O}),Updating:O=>({type:o.Updating,update:O}),Ready:O=>({type:o.Ready,update:O})},e.$AY=(0,i.$Fi)("updateService")}),define(oe[268],ae([0,1,4,194,54,45]),function(V,e,i,o,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),D.$oo.as(S.$to.Configuration).registerConfiguration({id:"update",order:15,title:(0,o.localize)(0,null),type:"object",properties:{"update.mode":{type:"string",enum:["none","manual","start","default"],default:"default",scope:S.ConfigurationScope.APPLICATION,description:(0,o.localize)(1,null),tags:["usesOnlineServices"],enumDescriptions:[(0,o.localize)(2,null),(0,o.localize)(3,null),(0,o.localize)(4,null),(0,o.localize)(5,null)],policy:{name:"UpdateMode",minimumVersion:"1.67"}},"update.channel":{type:"string",default:"default",scope:S.ConfigurationScope.APPLICATION,description:(0,o.localize)(6,null),deprecationMessage:(0,o.localize)(7,null,"update.mode")},"update.enableWindowsBackgroundUpdates":{type:"boolean",default:!0,scope:S.ConfigurationScope.APPLICATION,title:(0,o.localize)(8,null),description:(0,o.localize)(9,null),included:i.$i&&!i.$o},"update.showReleaseNotes":{type:"boolean",default:!0,scope:S.ConfigurationScope.APPLICATION,description:(0,o.localize)(10,null),tags:["usesOnlineServices"]}}})}),define(oe[269],ae([0,1,3,50]),function(V,e,i,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gfc=e.$Ffc=void 0;class S{constructor(P){this.a=P}listen(P,y){switch(y){case"onStateChange":return this.a.onStateChange}throw new Error(`Event not found: ${y}`)}call(P,y,a){switch(y){case"checkForUpdates":return this.a.checkForUpdates(a);case"downloadUpdate":return this.a.downloadUpdate();case"applyUpdate":return this.a.applyUpdate();case"quitAndInstall":return this.a.quitAndInstall();case"_getInitialState":return Promise.resolve(this.a.state);case"isLatestVersion":return this.a.isLatestVersion();case"_applySpecificUpdate":return this.a._applySpecificUpdate(a)}throw new Error(`Call not found: ${y}`)}}e.$Ffc=S;class D{get state(){return this.b}set state(P){this.b=P,this.a.fire(P)}constructor(P){this.c=P,this.a=new i.$me,this.onStateChange=this.a.event,this.b=o.$zY.Uninitialized,this.c.listen("onStateChange")(y=>this.state=y),this.c.call("_getInitialState").then(y=>this.state=y)}checkForUpdates(P){return this.c.call("checkForUpdates",P)}downloadUpdate(){return this.c.call("downloadUpdate")}applyUpdate(){return this.c.call("applyUpdate")}quitAndInstall(){return this.c.call("quitAndInstall")}isLatestVersion(){return this.c.call("isLatestVersion")}_applySpecificUpdate(P){return this.c.call("_applySpecificUpdate",P)}}e.$Gfc=D}),define(oe[41],ae([0,1,6]),function(V,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jl=void 0,e.$Jl=(0,i.$Fi)("IUriIdentityService")}),define(oe[270],ae([0,1,41,211,15,19,144,3,2]),function(V,e,i,o,S,D,O,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ns=void 0;class a{static{this._clock=0}constructor(g){this.uri=g,this.time=a._clock++}touch(){return this.time=a._clock++,this}}let h=class{constructor(g){this.g=g,this.c=new y.$Vc,this.f=2**16;const b=new Map,l=m=>{let p=b.get(m.scheme);return p===void 0&&(p=g.hasProvider(m)&&!this.g.hasCapability(m,S.FileSystemProviderCapabilities.PathCaseSensitive),b.set(m.scheme,p)),p};this.c.add(P.Event.any(g.onDidChangeFileSystemProviderRegistrations,g.onDidChangeFileSystemProviderCapabilities)(m=>{b.delete(m.scheme)})),this.extUri=new D.$8g(l),this.d=new O.$Ms((m,p)=>this.extUri.compare(m,p,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(g){this.g.hasProvider(g)&&(g=(0,D.$hh)(g));const b=this.d.get(g);return b?b.touch().uri.with({fragment:g.fragment}):(this.d.set(g,new a(g)),this.h(),g)}h(){if(this.d.size<this.f)return;const g=[...this.d.entries()].sort((l,m)=>l[1].time<m[1].time?1:l[1].time>m[1].time?-1:0);a._clock=0,this.d.clear();const b=this.f*.5;for(let l=0;l<b;l++)this.d.set(g[l][0],g[l][1].touch())}};e.$Ns=h,e.$Ns=h=Se([re(0,S.$_k)],h),(0,o.$Ks)(i.$Jl,h,o.InstantiationType.Delayed)}),define(oe[133],ae([0,1,6]),function(V,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qY=void 0,e.$qY=(0,i.$Fi)("urlService")}),define(oe[271],ae([0,1,7]),function(V,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pfc=e.$Ofc=e.$Nfc=void 0;class o{constructor(P){this.a=P}listen(P,y){throw new Error(`Event not found: ${y}`)}call(P,y,a){switch(y){case"handleURL":return this.a.handleURL(i.URI.revive(a[0]),a[1])}throw new Error(`Call not found: ${y}`)}}e.$Nfc=o;class S{constructor(P){this.a=P}handleURL(P,y){return this.a.call("handleURL",[P.toJSON(),y])}}e.$Ofc=S;class D{constructor(P,y){this.a=P,this.b=y}async routeCall(P,y,a,h){if(y!=="handleURL")throw new Error(`Call not found: ${y}`);if(Array.isArray(a)&&a.length>0){const f=i.URI.revive(a[0]);if(this.b.trace("URLHandlerRouter#routeCall() with URI argument",f.toString(!0)),f.query){const g=/\bwindowId=(\d+)/.exec(f.query);if(g){const b=g[1];this.b.trace(`URLHandlerRouter#routeCall(): found windowId query parameter with value "${b}"`,f.toString(!0));const l=new RegExp(`window:${b}`),m=P.connections.find(p=>(this.b.trace("URLHandlerRouter#routeCall(): testing connection",p.ctx),l.test(p.ctx)));if(m)return this.b.trace("URLHandlerRouter#routeCall(): found a connection to route",f.toString(!0)),m;this.b.trace("URLHandlerRouter#routeCall(): did not find a connection to route",f.toString(!0))}else this.b.trace("URLHandlerRouter#routeCall(): did not find windowId query parameter",f.toString(!0))}}else this.b.trace("URLHandlerRouter#routeCall() without URI argument");return this.a.routeCall(P,y,a,h)}routeEvent(P,y){throw new Error(`Event not found: ${y}`)}}e.$Pfc=D}),define(oe[272],ae([0,1,8,2,7,28]),function(V,e,i,o,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sY=e.$rY=void 0;class O extends o.$Wc{constructor(){super(...arguments),this.a=new Set}open(a,h){const f=[...this.a.values()];return(0,i.$Jh)(f.map(g=>()=>g.handleURL(a,h)),void 0,!1).then(g=>g||!1)}registerHandler(a){return this.a.add(a),(0,o.$Uc)(()=>this.a.delete(a))}}e.$rY=O;let P=class extends O{constructor(a){super(),this.b=a}create(a){let{authority:h,path:f,query:g,fragment:b}=a||{authority:void 0,path:void 0,query:void 0,fragment:void 0};return h&&f&&f.indexOf("/")!==0&&(f=`/${f}`),S.URI.from({scheme:this.b.urlProtocol,authority:h,path:f,query:g,fragment:b})}};e.$sY=P,e.$sY=P=Se([re(0,D.$sk)],P)}),define(oe[273],ae([0,1,14,8,3,2,4,7]),function(V,e,i,o,S,D,O,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qfc=void 0;class y extends D.$Wc{constructor(h,f,g,b,l,m){if(super(),this.c=f,this.f=m,this.a=[],this.b=0,h&&(m.trace("ElectronURLListener initialUrisToHandle:",h.map(w=>w.originalUrl)),this.a=h),O.$i){const w=b.isBuilt?[]:[`"${b.appRoot}"`];w.push("--open-url","--"),i.app.setAsDefaultProtocolClient(l.urlProtocol,process.execPath,w)}const p=S.Event.map(S.Event.fromNodeEventEmitter(i.app,"open-url",(w,v)=>({event:w,url:v})),({event:w,url:v})=>(w.preventDefault(),v));this.B(p(w=>{const v=this.g(w);v&&this.c.open(v,{originalUrl:w})})),g.getWindows().filter(w=>w.isReady).length>0?(m.trace("ElectronURLListener: window is ready to handle URLs"),this.h()):(m.trace("ElectronURLListener: waiting for window to be ready to handle URLs..."),this.B(S.Event.once(g.onDidSignalReadyWindow)(()=>this.h())))}g(h){try{return P.URI.parse(h)}catch{return}}async h(){if(this.b++>10){this.f.trace("ElectronURLListener#flush(): giving up after 10 retries");return}this.f.trace("ElectronURLListener#flush(): flushing URLs");const h=[];for(const f of this.a)await this.c.open(f.uri,{originalUrl:f.originalUrl})?this.f.trace("ElectronURLListener#flush(): URL was handled",f.originalUrl):(this.f.trace("ElectronURLListener#flush(): URL was not yet handled",f.originalUrl),h.push(f));h.length!==0&&(this.a=h,(0,o.$Hh)(()=>this.h(),500,this.q))}}e.$Qfc=y}),define(oe[274],ae([0,1,3,2,15,61,32]),function(V,e,i,o,S,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tgc=void 0;class P extends o.$Wc{constructor(a,h,f,g,b,l){super(),this.f=a,this.g=h,this.h=f,this.j=g,this.m=b,this.n=l,this.capabilities=this.g.capabilities,this.onDidChangeCapabilities=this.g.onDidChangeCapabilities,this.a=this.B(new i.$me),this.onDidChangeFile=this.a.event,this.b=D.$Li.forUris(()=>!(this.capabilities&S.FileSystemProviderCapabilities.PathCaseSensitive)),this.c=new O.$Dc(m=>this.m.extUri.getComparisonKey(this.t(m))),this.r(),this.B(g.onDidChangeProfiles(()=>this.r())),this.B(this.g.onDidChangeFile(m=>this.s(m)))}r(){this.c.clear();for(const a of this.j.profiles)this.c.add(a.settingsResource),this.c.add(a.keybindingsResource),this.c.add(a.tasksResource),this.c.add(a.extensionsResource)}open(a,h){return this.g.open(this.t(a),h)}close(a){return this.g.close(a)}read(a,h,f,g,b){return this.g.read(a,h,f,g,b)}write(a,h,f,g,b){return this.g.write(a,h,f,g,b)}watch(a,h){this.b.set(a,a);const f=this.g.watch(this.t(a),h);return(0,o.$Uc)(()=>{this.b.delete(a),f.dispose()})}stat(a){return this.g.stat(this.t(a))}mkdir(a){return this.g.mkdir(this.t(a))}rename(a,h,f){return this.g.rename(this.t(a),this.t(h),f)}readFile(a,h){return this.g.readFile(this.t(a),h)}readFileStream(a,h,f){return this.g.readFileStream(this.t(a),h,f)}readdir(a){return this.g.readdir(this.t(a))}enforceAtomicReadFile(a){return this.c.has(a)}writeFile(a,h,f){return this.g.writeFile(this.t(a),h,f)}enforceAtomicWriteFile(a){return this.c.has(a)?{postfix:".vsctmp"}:!1}delete(a,h){return this.g.delete(this.t(a),h)}copy(a,h,f){if((0,S.$dl)(this.g))return this.g.copy(this.t(a),this.t(h),f);throw new Error("copy not supported")}cloneFile(a,h){if((0,S.$el)(this.g))return this.g.cloneFile(this.t(a),this.t(h));throw new Error("clone not supported")}s(a){const h=[];for(const f of a){if(f.resource.scheme!==this.f)continue;const g=this.u(f.resource);this.b.findSubstr(g)&&h.push({resource:g,type:f.type,cId:f.cId})}h.length&&(this.n.debug("User data changed"),this.a.fire(h))}t(a){return a.with({scheme:this.f})}u(a){return a.with({scheme:this.h})}}e.$tgc=P}),define(oe[275],ae([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$agc=void 0,e.$agc="utilityProcessWorker"}),define(oe[276],ae([0,1,6]),function(V,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rfc=void 0,e.$Rfc=(0,i.$Fi)("webviewManagerService")}),define(oe[277],ae([0,1,14,2,13,7]),function(V,e,i,o,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sfc=void 0;class O extends o.$Wc{static{this.a=new Map([["/index.html","index.html"],["/fake.html","fake.html"],["/service-worker.js","service-worker.js"]])}constructor(){super();const y=this.b.bind(this);i.protocol.registerFileProtocol(S.Schemas.vscodeWebview,y)}b(y,a){try{const h=D.URI.parse(y.url),f=O.a.get(h.path);if(typeof f=="string"){const g=`vs/workbench/contrib/webview/browser/pre/${f}`,b=S.$Zg.asFileUri(g);return a({path:b.fsPath,headers:{...S.COI.getHeadersFromQuery(y.url),"Cross-Origin-Resource-Policy":"cross-origin"}})}else return a({error:-10})}catch{}return a({error:-2})}}e.$Sfc=O}),define(oe[57],ae([0,1,4]),function(V,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3D=e.CustomTitleBarVisibility=e.TitlebarStyle=e.TitleBarSetting=e.$TD=void 0,e.$UD=o,e.$VD=S,e.$WD=D,e.$XD=O,e.$YD=P,e.$ZD=f,e.$1D=g,e.$2D=b,e.$4D=l,e.$5D=m,e.$6D=p,e.$TD={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function o($){return typeof $.parentId=="number"}function S($){return!!$.workspaceUri}function D($){return!!$.folderUri}function O($){return!!$.fileUri}function P($){const w=g($),v=$.getValue("window.menuBarVisibility");return v==="default"||w&&v==="compact"||i.$j&&i.$m?"classic":v}var y;(function($){$.TITLE_BAR_STYLE="window.titleBarStyle",$.CUSTOM_TITLE_BAR_VISIBILITY="window.customTitleBarVisibility"})(y||(e.TitleBarSetting=y={}));var a;(function($){$.NATIVE="native",$.CUSTOM="custom"})(a||(e.TitlebarStyle=a={}));var h;(function($){$.AUTO="auto",$.WINDOWED="windowed",$.NEVER="never"})(h||(e.CustomTitleBarVisibility=h={}));function f($,w){return!0}function g($,w){return w||(w=b($)),w===a.NATIVE}function b($){if(i.$o)return a.CUSTOM;const w=$.getValue("window");if(w){if(i.$j&&w.nativeTabs===!0||i.$j&&w.nativeFullScreen===!1)return a.NATIVE;const t=w.titleBarStyle;if(t===a.NATIVE||t===a.CUSTOM)return t}return i.$k?a.NATIVE:a.CUSTOM}e.$3D=35;function l($){return!(!i.$i||i.$o||g($))}function m($){const w=$.getValue("window");return!w||typeof w.nativeFullScreen!="boolean"||w.nativeTabs?!0:w.nativeFullScreen!==!1}function p($=0){return Math.pow(1.2,$)}}),define(oe[51],ae([0,1,14]),function(V,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowError=e.WindowMode=e.$jec=e.$iec=e.UnloadReason=e.LoadReason=void 0;var o;(function(a){a[a.INITIAL=1]="INITIAL",a[a.LOAD=2]="LOAD",a[a.RELOAD=3]="RELOAD"})(o||(e.LoadReason=o={}));var S;(function(a){a[a.CLOSE=1]="CLOSE",a[a.QUIT=2]="QUIT",a[a.RELOAD=3]="RELOAD",a[a.LOAD=4]="LOAD"})(S||(e.UnloadReason=S={}));const D=function(a=P.Normal){return{width:1024,height:768,mode:a}};e.$iec=D;const O=function(){const f=i.screen.getPrimaryDisplay().workArea,g=Math.max(f.x+f.width/2-800/2,0),b=Math.max(f.y+f.height/2-600/2,0);return{x:g,y:b,width:800,height:600,mode:P.Normal}};e.$jec=O;var P;(function(a){a[a.Maximized=0]="Maximized",a[a.Normal=1]="Normal",a[a.Minimized=2]="Minimized",a[a.Fullscreen=3]="Fullscreen"})(P||(e.WindowMode=P={}));var y;(function(a){a[a.UNRESPONSIVE=1]="UNRESPONSIVE",a[a.PROCESS_GONE=2]="PROCESS_GONE",a[a.LOAD=3]="LOAD"})(y||(e.WindowError=y={}))}),define(oe[278],ae([0,1,8,3,2]),function(V,e,i,o,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yfc=void 0;class D extends S.$Wc{constructor({onDidOpenMainWindow:P,onDidFocusMainWindow:y,getActiveWindowId:a}){super(),this.a=this.B(new S.$Vc),o.Event.latch(o.Event.any(P,y))(this.f,this,this.a),this.b=(0,i.$sh)(()=>a()),(async()=>{try{const f=await this.b;this.c=typeof this.c=="number"?this.c:f}catch{}finally{this.b=void 0}})()}f(P){this.b&&(this.b.cancel(),this.b=void 0),this.c=P}async getActiveClientId(){return`window:${this.b?await this.b:this.c}`}}e.$Yfc=D}),define(oe[30],ae([0,1,198,9,61,19,7,6,13]),function(V,e,i,o,S,D,O,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8i=e.$5i=e.$4i=e.$3i=e.$2i=e.$Zi=e.$Yi=e.WorkbenchState=e.$Si=e.$Ri=e.$Oi=void 0,e.$Pi=a,e.$Qi=h,e.$Ti=f,e.$Ui=g,e.$Vi=b,e.$Wi=m,e.$Xi=p,e.$1i=v,e.$6i=k,e.$7i=t,e.$9i=r,e.$0i=n,e.$$i=c,e.$Oi=(0,P.$Fi)("contextService");function a(s){const u=s;return typeof u?.id=="string"&&O.URI.isUri(u.uri)}function h(s){return typeof s?.id=="string"&&!a(s)&&!g(s)}e.$Ri={id:"ext-dev"},e.$Si={id:"empty-window"};function f(s,u){if(typeof s=="string"||typeof s>"u")return typeof s=="string"?{id:(0,o.$pc)(s)}:u?e.$Ri:e.$Si;const d=s;return d.configuration?{id:d.id,configPath:d.configuration}:d.folders.length===1?{id:d.id,uri:d.folders[0].uri}:{id:d.id}}function g(s){const u=s;return typeof u?.id=="string"&&O.URI.isUri(u.configPath)}function b(s){const u=s;if(u?.uri)return{id:u.id,uri:O.URI.revive(u.uri)};const d=s;if(d?.configPath)return{id:d.id,configPath:O.URI.revive(d.configPath)};if(s?.id)return{id:s.id}}var l;(function(s){s[s.EMPTY=1]="EMPTY",s[s.FOLDER=2]="FOLDER",s[s.WORKSPACE=3]="WORKSPACE"})(l||(e.WorkbenchState=l={}));function m(s){const u=s;return!!(u&&typeof u=="object"&&typeof u.id=="string"&&Array.isArray(u.folders))}function p(s){const u=s;return!!(u&&typeof u=="object"&&O.URI.isUri(u.uri)&&typeof u.name=="string"&&typeof u.toResource=="function")}class ${constructor(u,d,I,E,A){this.h=u,this.j=I,this.k=E,this.l=A,this.c=S.$Li.forUris(this.l,()=>!0),this.folders=d}update(u){this.h=u.id,this.k=u.configuration,this.j=u.transient,this.l=u.l,this.folders=u.folders}get folders(){return this.g}set folders(u){this.g=u,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(u){this.k=u}getFolder(u){return u&&this.c.findSubstr(u)||null}n(){this.c=S.$Li.forUris(this.l,()=>!0);for(const u of this.folders)this.c.set(u.uri,u)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$Yi=$;class w{constructor(u,d){this.raw=d,this.uri=u.uri,this.index=u.index,this.name=u.name}toResource(u){return(0,D.$gh)(this.uri,u)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$Zi=w;function v(s){return new w({uri:s,index:0,name:(0,D.$ch)(s)},{uri:s.toString()})}e.$2i="code-workspace",e.$3i=`.${e.$2i}`,e.$4i=[{name:(0,i.localize)(0,null),extensions:[e.$2i]}],e.$5i="workspace.json";function k(s,u){return D.$0g.isEqualOrParent(s,u.untitledWorkspacesHome)}function t(s){let u;return O.URI.isUri(s)?u=s:u=s.configuration,u?.scheme===y.Schemas.tmp}e.$8i="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function r(s){return s.id===e.$8i}function n(s,u){return!k(s,u)&&!t(s)}function c(s){return(typeof s=="string"?(0,o.$qc)(s):(0,D.$eh)(s))===e.$3i}}),define(oe[58],ae([0,1,14,8,46,48,2,77,4,21,172,124,6,5,28,30]),function(V,e,i,o,S,D,O,P,y,a,h,f,g,b,l,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rec=e.$qec=void 0,e.$qec=(0,g.$Fi)("dialogMainService");let p=class{constructor(w,v){this.d=w,this.e=v,this.a=new Map,this.b=new Map,this.c=new o.$Mh}pickFileFolder(w,v){return this.f({...w,pickFolders:!0,pickFiles:!0,title:(0,h.localize)(0,null)},v)}pickFolder(w,v){return this.f({...w,pickFolders:!0,title:(0,h.localize)(1,null)},v)}pickFile(w,v){return this.f({...w,pickFiles:!0,title:(0,h.localize)(2,null)},v)}pickWorkspace(w,v){const k=(0,h.localize)(3,null),t=(0,D.$Yw)((0,h.localize)(4,null)),r=m.$4i;return this.f({...w,pickFiles:!0,title:k,filters:r,buttonLabel:t},v)}async f(w,v){const k={title:w.title,buttonLabel:w.buttonLabel,filters:w.filters,defaultPath:w.defaultPath};(typeof w.pickFiles=="boolean"||typeof w.pickFolders=="boolean")&&(k.properties=void 0,w.pickFiles&&w.pickFolders&&(k.properties=["multiSelections","openDirectory","openFile","createDirectory"])),k.properties||(k.properties=["multiSelections",w.pickFolders?"openDirectory":"openFile","createDirectory"]),y.$j&&k.properties.push("treatPackageAsDirectory");const t=await this.showOpenDialog(k,(v||i.BrowserWindow.getFocusedWindow())??void 0);if(t&&t.filePaths&&t.filePaths.length>0)return t.filePaths}g(w){if(w){let v=this.b.get(w.id);return v||(v=new o.$Mh,this.b.set(w.id,v)),v}else return this.c}showMessageBox(w,v){return this.g(v).queue(async()=>{const{options:k,buttonIndeces:t}=(0,f.$6w)(w,this.e);let r;return v?r=await i.dialog.showMessageBox(v,k):r=await i.dialog.showMessageBox(k),{response:t[r.response],checkboxChecked:r.checkboxChecked}})}async showSaveDialog(w,v){const k=this.j(w,v);if(!k)return this.d.error("[DialogMainService]: file save dialog is already or will be showing for the window with the same configuration"),{canceled:!0,filePath:""};try{return await this.g(v).queue(async()=>{let t;return v?t=await i.dialog.showSaveDialog(v,w):t=await i.dialog.showSaveDialog(w),t.filePath=this.h(t.filePath),t})}finally{(0,O.$Rc)(k)}}h(w){return w&&y.$j&&(w=(0,P.$mm)(w)),w}i(w){return w.map(v=>this.h(v))}async showOpenDialog(w,v){w.defaultPath&&(await a.Promises.exists(w.defaultPath)||(w.defaultPath=void 0));const k=this.j(w,v);if(!k)return this.d.error("[DialogMainService]: file open dialog is already or will be showing for the window with the same configuration"),{canceled:!0,filePaths:[]};try{return await this.g(v).queue(async()=>{let t;return v?t=await i.dialog.showOpenDialog(v,w):t=await i.dialog.showOpenDialog(w),t.filePaths=this.i(t.filePaths),t})}finally{(0,O.$Rc)(k)}}j(w,v){if(!v)return O.$Wc.None;this.d.trace("[DialogMainService]: request to acquire file dialog lock",w);let k=this.a.get(v.id);k||(k=new Set,this.a.set(v.id,k));const t=(0,S.$tj)(w);if(!k.has(t))return this.d.trace("[DialogMainService]: new file dialog lock created",w),k.add(t),(0,O.$Uc)(()=>{this.d.trace("[DialogMainService]: file dialog lock disposed",w),k?.delete(t),k?.size===0&&this.a.delete(v.id)})}};e.$rec=p,e.$rec=p=Se([re(0,b.$_j),re(1,l.$sk)],p)}),define(oe[279],ae([0,1,3,2,81,30]),function(V,e,i,o,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cfc=void 0;class O extends o.$Wc{static{this.a=100}constructor(y,a){super(),this.f=y,this.g=a,this.b=this.B(new i.$me),this.c=new Map,this.h(a.applicationStorage,this.b)}h(y,a){this.B(i.Event.debounce(y.onDidChangeStorage,(h,f)=>(h?h.push(f):h=[f],h),O.a)(h=>{h.length&&a.fire(this.j(h,y))}))}j(y,a){const h=new Map,f=new Set;return y.forEach(g=>{const b=a.get(g.key);typeof b=="string"?h.set(g.key,b):f.add(g.key)}),{changed:Array.from(h.entries()),deleted:Array.from(f.values())}}listen(y,a,h){switch(a){case"onDidChangeStorage":{const f=h.profile?(0,S.$ci)(h.profile):void 0;if(!f)return this.b.event;let g=this.c.get(f.id);return g||(g=this.B(new i.$me),this.h(this.g.profileStorage(f),g),this.c.set(f.id,g)),g.event}}throw new Error(`Event not found: ${a}`)}async call(y,a,h){const f=h.profile?(0,S.$ci)(h.profile):void 0,g=(0,D.$Vi)(h.workspace),b=await this.m(f,g);switch(a){case"getItems":return Array.from(b.items.entries());case"updateItems":{const l=h;if(l.insert)for(const[m,p]of l.insert)b.set(m,p);l.delete?.forEach(m=>b.delete(m));break}case"optimize":return b.optimize();case"isUsed":{const l=h.payload;if(typeof l=="string")return this.g.isUsed(l)}default:throw new Error(`Call not found: ${a}`)}}async m(y,a){let h;a?h=this.g.workspaceStorage(a):y?h=this.g.profileStorage(y):h=this.g.applicationStorage;try{await h.init()}catch(f){this.f.error(`StorageIPC#init: Unable to init ${a?"workspace":y?"profile":"application"} storage due to ${f}`)}return h}}e.$Cfc=O}),define(oe[42],ae([0,1,46,3,2,19,7,195,38,15,6,5,30,32,41,8,33,26,12]),function(V,e,i,o,S,D,O,P,y,a,h,f,g,b,l,m,p,$,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pl=e.$Ol=e.$Ll=e.ProfileResourceType=void 0,e.$Kl=k,e.$Ml=t,e.$Nl=r;var v;(function(s){s.Settings="settings",s.Keybindings="keybindings",s.Snippets="snippets",s.Tasks="tasks",s.Extensions="extensions",s.GlobalState="globalState"})(v||(e.ProfileResourceType=v={}));function k(s){const u=s;return!!(u&&typeof u=="object"&&typeof u.id=="string"&&typeof u.isDefault=="boolean"&&typeof u.name=="string"&&O.URI.isUri(u.location)&&O.URI.isUri(u.globalStorageHome)&&O.URI.isUri(u.settingsResource)&&O.URI.isUri(u.keybindingsResource)&&O.URI.isUri(u.tasksResource)&&O.URI.isUri(u.snippetsHome)&&O.URI.isUri(u.extensionsResource))}e.$Ll=(0,h.$Fi)("IUserDataProfilesService");function t(s,u){return{id:s.id,isDefault:s.isDefault,name:s.name,shortName:s.shortName,icon:s.icon,location:O.URI.revive(s.location).with({scheme:u}),globalStorageHome:O.URI.revive(s.globalStorageHome).with({scheme:u}),settingsResource:O.URI.revive(s.settingsResource).with({scheme:u}),keybindingsResource:O.URI.revive(s.keybindingsResource).with({scheme:u}),tasksResource:O.URI.revive(s.tasksResource).with({scheme:u}),snippetsHome:O.URI.revive(s.snippetsHome).with({scheme:u}),extensionsResource:O.URI.revive(s.extensionsResource).with({scheme:u}),cacheHome:O.URI.revive(s.cacheHome).with({scheme:u}),useDefaultFlags:s.useDefaultFlags,isTransient:s.isTransient}}function r(s,u,d,I,E,A){return{id:s,name:u,location:d,isDefault:!1,shortName:E?.shortName,icon:E?.icon,globalStorageHome:A&&E?.useDefaultFlags?.globalState?A.globalStorageHome:(0,D.$gh)(d,"globalStorage"),settingsResource:A&&E?.useDefaultFlags?.settings?A.settingsResource:(0,D.$gh)(d,"settings.json"),keybindingsResource:A&&E?.useDefaultFlags?.keybindings?A.keybindingsResource:(0,D.$gh)(d,"keybindings.json"),tasksResource:A&&E?.useDefaultFlags?.tasks?A.tasksResource:(0,D.$gh)(d,"tasks.json"),snippetsHome:A&&E?.useDefaultFlags?.snippets?A.snippetsHome:(0,D.$gh)(d,"snippets"),extensionsResource:A&&E?.useDefaultFlags?.extensions?A.extensionsResource:(0,D.$gh)(d,"extensions.json"),cacheHome:(0,D.$gh)(I,s),useDefaultFlags:E?.useDefaultFlags,isTransient:E?.transient}}let n=class extends S.$Wc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(u,d,I,E){super(),this.t=u,this.u=d,this.w=I,this.y=E,this.f=!0,this.h=this.B(new o.$me),this.onDidChangeProfiles=this.h.event,this.j=this.B(new o.$me),this.onWillCreateProfile=this.j.event,this.m=this.B(new o.$me),this.onWillRemoveProfile=this.m.event,this.n=this.B(new o.$me),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],folders:new b.$Cc,workspaces:new b.$Cc,emptyWindows:new Map},this.profilesHome=(0,D.$gh)(this.t.userRoamingDataHome,"profiles"),this.g=(0,D.$gh)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(u){this.f!==u&&(this.z=void 0,this.f=u)}isEnabled(){return this.f}get C(){if(!this.z){const u=this.D(),d=[u];if(this.f)try{for(const A of this.O()){if(!A.name||!(0,w.$fg)(A.name)||!A.location){this.y.warn("Skipping the invalid stored profile",A.location||A.name);continue}d.push(r((0,D.$dh)(A.location),A.name,A.location,this.g,{shortName:A.shortName,icon:A.icon,useDefaultFlags:A.useDefaultFlags},u))}}catch(A){this.y.error(A)}const I=new b.$Cc,E=new Map;if(d.length)try{const A=this.Q();if(A.workspaces)for(const[T,L]of Object.entries(A.workspaces)){const R=O.URI.parse(T),M=d.find(U=>U.id===L);M&&I.set(R,M)}if(A.emptyWindows)for(const[T,L]of Object.entries(A.emptyWindows)){const R=d.find(M=>M.id===L);R&&E.set(T,R)}}catch(A){this.y.error(A)}this.z={profiles:d,workspaces:I,emptyWindows:E}}return this.z}D(){const u=r("__default__profile__",(0,P.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...u,extensionsResource:this.S()??u.extensionsResource,isDefault:!0}}async createTransientProfile(u){const d="Temp",I=new RegExp(`${(0,$.$if)(d)}\\s(\\d+)`);let E=0;for(const T of this.profiles){const L=I.exec(T.name),R=L?parseInt(L[1]):0;E=R>E?R:E}const A=`${d} ${E+1}`;return this.createProfile((0,i.$tj)((0,p.$2g)()).toString(16),A,{transient:!0},u)}async createNamedProfile(u,d,I){return this.createProfile((0,i.$tj)((0,p.$2g)()).toString(16),u,d,I)}async createProfile(u,d,I,E){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const A=await this.F(u,d,I);return E&&await this.setProfileForWorkspace(E,A),A}async F(u,d,I){if(!(0,w.$fg)(d)||!d)throw new Error("Name of the profile is mandatory and must be of type `string`");let E=this.r.get(d);return E||(E=(async()=>{try{if(this.profiles.find(R=>R.name===d||R.id===u))throw new Error(`Profile with ${d} name already exists`);const T=r(u,d,(0,D.$gh)(this.profilesHome,u),this.g,I,this.defaultProfile);await this.u.createFolder(T.location);const L=[];return this.j.fire({profile:T,join(R){L.push(R)}}),await m.Promises.settled(L),this.I([T],[],[]),T}finally{this.r.delete(d)}})(),this.r.set(d,E)),E}async updateProfile(u,d){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let I=this.profiles.find(E=>E.id===u.id);if(!I)throw new Error(`Profile '${u.name}' does not exist`);return I=r(I.id,d.name??I.name,I.location,this.g,{shortName:d.shortName??I.shortName,icon:d.icon===null?void 0:d.icon??I.icon,transient:d.transient??I.isTransient,useDefaultFlags:d.useDefaultFlags??I.useDefaultFlags},this.defaultProfile),this.I([],[],[I]),I}async removeProfile(u){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(u.isDefault)throw new Error("Cannot remove default profile");const d=this.profiles.find(E=>E.id===u.id);if(!d)throw new Error(`Profile '${u.name}' does not exist`);const I=[];this.m.fire({profile:d,join(E){I.push(E)}});try{await Promise.allSettled(I)}catch(E){this.y.error(E)}for(const E of[...this.C.emptyWindows.keys()])d.id===this.C.emptyWindows.get(E)?.id&&this.C.emptyWindows.delete(E);for(const E of[...this.C.workspaces.keys()])d.id===this.C.workspaces.get(E)?.id&&this.C.workspaces.delete(E);this.M(),this.I([],[d],[]);try{await this.u.del(d.cacheHome,{recursive:!0})}catch(E){(0,a.$ql)(E)!==a.FileOperationResult.FILE_NOT_FOUND&&this.y.error(E)}}async setProfileForWorkspace(u,d){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const I=this.profiles.find(E=>E.id===d.id);if(!I)throw new Error(`Profile '${d.name}' does not exist`);this.L(u,I)}unsetWorkspace(u,d){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(u,void 0,d)}async resetWorkspaces(){this.s.folders.clear(),this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const u=await this.u.resolve(this.profilesHome);await Promise.all((u.children||[]).filter(d=>d.isDirectory&&this.profiles.every(I=>!this.w.extUri.isEqual(I.location,d.resource))).map(d=>this.u.del(d.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const u=this.s.profiles.filter(d=>!this.H(d));await Promise.allSettled(u.map(d=>this.removeProfile(d)))}getProfileForWorkspace(u){const d=this.G(u),I=O.URI.isUri(d)?this.C.workspaces.get(d):this.C.emptyWindows.get(d);return I||((0,g.$Pi)(u)?this.s.folders.get(u.uri):(0,g.$Ui)(u)?this.s.workspaces.get(u.configPath):this.s.emptyWindows.get(u.id))}G(u){return(0,g.$Pi)(u)?u.uri:(0,g.$Ui)(u)?u.configPath:u.id}H(u){return!!([...this.C.emptyWindows.values()].some(d=>this.w.extUri.isEqual(d.location,u.location))||[...this.C.workspaces.values()].some(d=>this.w.extUri.isEqual(d.location,u.location))||[...this.s.emptyWindows.values()].some(d=>this.w.extUri.isEqual(d.location,u.location))||[...this.s.workspaces.values()].some(d=>this.w.extUri.isEqual(d.location,u.location))||[...this.s.folders.values()].some(d=>this.w.extUri.isEqual(d.location,u.location)))}I(u,d,I){const E=[...this.profiles,...u],A=[],T=this.s.profiles;this.s.profiles=[];for(let L of E){if(L.isDefault||d.some(M=>L.id===M.id))continue;L=I.find(M=>L.id===M.id)??L;const R=T.find(M=>L.id===M.id);if(L.isTransient)this.s.profiles.push(L);else{if(R){for(const[M,U]of this.s.emptyWindows.entries())if(L.id===U.id){this.L({id:M},L);break}for(const[M,U]of this.s.workspaces.entries())if(L.id===U.id){this.L({id:"",configPath:M},L);break}for(const[M,U]of this.s.folders.entries())if(L.id===U.id){this.L({id:"",uri:M},L);break}}A.push({location:L.location,name:L.name,shortName:L.shortName,icon:L.icon,useDefaultFlags:L.useDefaultFlags})}}this.P(A),this.z=void 0,this.J(u,d,I)}J(u,d,I){this.h.fire({added:u,removed:d,updated:I,all:this.profiles})}L(u,d,I){if(I=d?.isTransient?!0:I,I)(0,g.$Pi)(u)?(this.s.folders.delete(u.uri),d&&this.s.folders.set(u.uri,d)):(0,g.$Ui)(u)?(this.s.workspaces.delete(u.configPath),d&&this.s.workspaces.set(u.configPath,d)):(this.s.emptyWindows.delete(u.id),d&&this.s.emptyWindows.set(u.id,d));else{this.L(u,void 0,!0);const E=this.G(u);O.URI.isUri(E)?(this.C.workspaces.delete(E),d&&this.C.workspaces.set(E,d)):(this.C.emptyWindows.delete(E),d&&this.C.emptyWindows.set(E,d)),this.M()}}M(){const u={};for(const[I,E]of this.C.workspaces.entries())u[I.toString()]=E.id;const d={};for(const[I,E]of this.C.emptyWindows.entries())d[I.toString()]=E.id;this.R({workspaces:u,emptyWindows:d}),this.z=void 0}N(u){const d={},I=this.D();if(u.workspaces)for(const[A,T]of Object.entries(u.workspaces)){const L=O.URI.parse(T);d[A]=this.w.extUri.isEqual(L,I.location)?I.id:this.w.extUri.basename(L)}const E={};if(u.emptyWindows)for(const[A,T]of Object.entries(u.emptyWindows)){const L=O.URI.parse(T);E[A]=this.w.extUri.isEqual(L,I.location)?I.id:this.w.extUri.basename(L)}return{workspaces:d,emptyWindows:E}}O(){return[]}P(u){throw new Error("not implemented")}Q(){return{}}R(u){throw new Error("not implemented")}S(){}};e.$Ol=n,e.$Ol=n=Se([re(0,y.$Mi),re(1,a.$_k),re(2,l.$Jl),re(3,f.$_j)],n);class c extends n{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(u){this.a=u}Q(){return this.X}R(u){this.X=u}}e.$Pl=c}),define(oe[86],ae([0,1,8,17,2,3,32,7,127,130,15,6,5,42,41,12,16,24]),function(V,e,i,o,S,D,O,P,y,a,h,f,g,b,l,m,p,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dq=e.$Cq=e.$Bq=e.ExtensionsProfileScanningErrorCode=void 0;var w;(function(n){n.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",n.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(w||(e.ExtensionsProfileScanningErrorCode=w={}));class v extends Error{constructor(c,s){super(c),this.code=s}}e.$Bq=v,e.$Cq=(0,f.$Fi)("IExtensionsProfileScannerService");let k=class extends S.$Wc{constructor(c,s,u,d,I,E){super(),this.j=c,this.m=s,this.n=u,this.r=d,this.s=I,this.t=E,this.b=this.B(new D.$me),this.onAddExtensions=this.b.event,this.c=this.B(new D.$me),this.onDidAddExtensions=this.c.event,this.f=this.B(new D.$me),this.onRemoveExtensions=this.f.event,this.g=this.B(new D.$me),this.onDidRemoveExtensions=this.g.event,this.h=new O.$Cc}scanProfileExtensions(c,s){return this.u(c,void 0,s)}async addExtensionsToProfile(c,s,u){const d=[],I=[];try{return await this.u(s,E=>{const A=[];if(u)A.push(...E);else for(const T of E)c.some(([L])=>(0,a.$Hp)(L.identifier,T.identifier)&&L.manifest.version!==T.version)?d.push(T):A.push(T);for(const[T,L]of c){const R=A.findIndex(U=>(0,a.$Hp)(U.identifier,T.identifier)&&U.version===T.manifest.version),M={identifier:T.identifier,version:T.manifest.version,location:T.location,metadata:L};R===-1?(I.push(M),A.push(M)):A.splice(R,1,M)}return I.length&&this.b.fire({extensions:I,profileLocation:s}),d.length&&this.f.fire({extensions:d,profileLocation:s}),A}),I.length&&this.c.fire({extensions:I,profileLocation:s}),d.length&&this.g.fire({extensions:d,profileLocation:s}),I}catch(E){throw I.length&&this.c.fire({extensions:I,error:E,profileLocation:s}),d.length&&this.g.fire({extensions:d,error:E,profileLocation:s}),E}}async updateMetadata(c,s){const u=[];return await this.u(s,d=>{const I=[];for(const E of d){const A=c.find(([T])=>(0,a.$Hp)(T.identifier,E.identifier)&&T.manifest.version===E.version);A&&(E.metadata={...E.metadata,...A[1]},u.push(E)),I.push(E)}return I}),u}async removeExtensionFromProfile(c,s){const u=[];try{await this.u(s,d=>{const I=[];for(const E of d)(0,a.$Hp)(E.identifier,c.identifier)?u.push(E):I.push(E);return u.length&&this.f.fire({extensions:u,profileLocation:s}),I}),u.length&&this.g.fire({extensions:u,profileLocation:s})}catch(d){throw u.length&&this.g.fire({extensions:u,error:d,profileLocation:s}),d}}async u(c,s,u){return this.F(c).queue(async()=>{let d=[],I;try{const E=await this.m.readFile(c);I=JSON.parse(E.value.toString().trim()||"[]")}catch(E){if((0,h.$ql)(E)!==h.FileOperationResult.FILE_NOT_FOUND)throw E;if(this.r.extUri.isEqual(c,this.n.defaultProfile.extensionsResource)&&(I=await this.D()),!I&&u?.bailOutWhenFileNotFound)throw new v((0,p.$_)(E),w.ERROR_PROFILE_NOT_FOUND)}if(I){Array.isArray(I)||this.w(c);let E=!1;for(const A of I){t(A)||this.w(c);let T;if((0,m.$fg)(A.relativeLocation)&&A.relativeLocation)T=this.z(A.relativeLocation);else if((0,m.$fg)(A.location)){this.t.warn(`Extensions profile: Ignoring extension with invalid location: ${A.location}`);continue}else{T=P.URI.revive(A.location);const L=this.y(T);L&&(E=!0,A.relativeLocation=L)}(0,m.$mg)(A.metadata?.hasPreReleaseVersion)&&A.metadata?.preRelease&&(E=!0,A.metadata.hasPreReleaseVersion=!0),d.push({identifier:A.identifier,location:T,version:A.version,metadata:A.metadata})}E&&await this.m.writeFile(c,o.$Oe.fromString(JSON.stringify(I)))}if(s){d=s(d);const E=d.map(A=>({identifier:A.identifier,version:A.version,location:A.location.toJSON(),relativeLocation:this.y(A.location),metadata:A.metadata}));await this.m.writeFile(c,o.$Oe.fromString(JSON.stringify(E)))}return d})}w(c){const s=new v(`Invalid extensions content in ${c.toString()}`,w.ERROR_INVALID_CONTENT);throw this.s.publicLogError2("extensionsProfileScanningError",{code:s.code}),s}y(c){return this.r.extUri.isEqual(this.r.extUri.dirname(c),this.j)?this.r.extUri.basename(c):void 0}z(c){return this.r.extUri.joinPath(this.j,c)}async D(){return this.C||(this.C=(async()=>{const c=this.r.extUri.joinPath(this.n.defaultProfile.location,"extensions.json"),s=this.r.extUri.joinPath(this.j,".init-default-profile-extensions");let u;try{u=(await this.m.readFile(c)).value.toString()}catch(I){if((0,h.$ql)(I)===h.FileOperationResult.FILE_NOT_FOUND)return;throw I}this.t.info("Migrating extensions from old default profile location",c.toString());let d;try{const I=JSON.parse(u);Array.isArray(I)&&I.every(E=>t(E))?d=I:this.t.warn("Skipping migrating from old default profile locaiton: Found invalid data",I)}catch(I){this.t.error(I)}if(d)try{await this.m.createFile(this.n.defaultProfile.extensionsResource,o.$Oe.fromString(JSON.stringify(d)),{overwrite:!1}),this.t.info("Migrated extensions from old default profile location to new location",c.toString(),this.n.defaultProfile.extensionsResource.toString())}catch(I){if((0,h.$ql)(I)===h.FileOperationResult.FILE_MODIFIED_SINCE)this.t.info("Migration from old default profile location to new location is done by another window",c.toString(),this.n.defaultProfile.extensionsResource.toString());else throw I}try{await this.m.del(c)}catch(I){(0,h.$ql)(I)!==h.FileOperationResult.FILE_NOT_FOUND&&this.t.error(I)}try{await this.m.del(s)}catch(I){(0,h.$ql)(I)!==h.FileOperationResult.FILE_NOT_FOUND&&this.t.error(I)}return d})()),this.C}F(c){let s=this.h.get(c);return s||(s=new i.$Mh,this.h.set(c,s)),s}};e.$Dq=k,e.$Dq=k=Se([re(1,h.$_k),re(2,b.$Ll),re(3,l.$Jl),re(4,$.$$l),re(5,g.$_j)],k);function t(n){return(0,m.$hg)(n)&&(0,y.$fp)(n.identifier)&&(r(n.location)||(0,m.$fg)(n.location)&&n.location)&&((0,m.$mg)(n.relativeLocation)||(0,m.$fg)(n.relativeLocation))&&n.version&&(0,m.$fg)(n.version)}function r(n){return n?(0,m.$fg)(n.path)&&(0,m.$fg)(n.scheme):!1}});var et=this&&this.__importDefault||function(V){return V&&V.__esModule?V:{default:V}};define(oe[134],ae([0,1,22,8,35,17,16,43,157,2,13,9,4,19,210,79,12,7,177,38,130,100,209,15,6,5,28,3,81,86,42,41,208]),function(V,e,i,o,S,D,O,P,y,a,h,f,g,b,l,m,p,$,w,v,k,t,r,n,c,s,u,d,I,E,A,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kq=e.$Iq=e.$Hq=e.$Gq=e.Translations=void 0,e.$Jq=ne,S=Re(S),f=Re(f),g=Re(g),l=Re(l),m=et(m);var R;(function(le){function K(ee,H){if(ee===H)return!0;const j=Object.keys(ee),B=new Set;for(const x of Object.keys(H))B.add(x);if(j.length!==B.size)return!1;for(const x of j){if(ee[x]!==H[x])return!1;B.delete(x)}return B.size===0}le.equals=K})(R||(e.Translations=R={})),e.$Gq=(0,c.$Fi)("IExtensionsScannerService");let M=class extends a.$Wc{constructor(K,ee,H,j,B,x,ce,G,he,se,_,F){super(),this.systemExtensionsLocation=K,this.userExtensionsLocation=ee,this.r=H,this.s=j,this.t=B,this.u=x,this.w=ce,this.y=G,this.z=he,this.C=se,this.D=_,this.F=F,this.g=this.B(new d.$me),this.onDidChangeCache=this.g.event,this.h=(0,b.$gh)(this.userExtensionsLocation,".obsolete"),this.j=this.B(this.F.createInstance(z,this.s,this.h)),this.m=this.B(this.F.createInstance(z,this.s,this.h)),this.n=this.B(this.F.createInstance(N,this.h)),this.H=void 0,this.B(this.j.onDidChangeCache(()=>this.g.fire(t.ExtensionType.System))),this.B(this.m.onDidChangeCache(()=>this.g.fire(t.ExtensionType.User)))}getTargetPlatform(){return this.G||(this.G=(0,k.$Sp)(this.w,this.y)),this.G}async scanAllExtensions(K,ee,H){const[j,B]=await Promise.all([this.scanSystemExtensions(K),this.scanUserExtensions(ee)]),x=H?await this.scanExtensionsUnderDevelopment(K,[...j,...B]):[];return this.L(j,B,x,await this.getTargetPlatform(),!0)}async scanSystemExtensions(K){const ee=[];ee.push(this.M(!!K.useCache,K.language)),ee.push(this.N(K.language,!!K.checkControlFile));const[H,j]=await Promise.all(ee);return this.J([...H,...j],t.ExtensionType.System,K,!1)}async scanUserExtensions(K){const ee=K.profileLocation??this.userExtensionsLocation;this.y.trace("Started scanning user extensions",ee);const H=this.D.extUri.isEqual(K.profileLocation,this.t.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,j=await this.P(ee,!!K.profileLocation,t.ExtensionType.User,!K.includeUninstalled,K.language,!0,H,K.productVersion??this.R()),B=K.useCache&&!j.devMode&&j.excludeObsolete?this.m:this.n;let x;try{x=await B.scanExtensions(j)}catch(ce){if(ce instanceof E.$Bq&&ce.code===E.ExtensionsProfileScanningErrorCode.ERROR_PROFILE_NOT_FOUND)await this.I(),x=await B.scanExtensions(j);else throw ce}return x=await this.J(x,t.ExtensionType.User,K,!0),this.y.trace("Scanned user extensions:",x.length),x}async scanExtensionsUnderDevelopment(K,ee){if(this.z.isExtensionDevelopment&&this.z.extensionDevelopmentLocationURI){const H=(await Promise.all(this.z.extensionDevelopmentLocationURI.filter(j=>j.scheme===h.Schemas.file).map(async j=>{const B=await this.P(j,!1,t.ExtensionType.User,!0,K.language,!1,void 0,K.productVersion??this.R());return(await this.n.scanOneOrMultipleExtensions(B)).map(ce=>(ce.type=ee.find(G=>(0,k.$Hp)(G.identifier,ce.identifier))?.type??ce.type,this.n.validate(ce,B)))}))).flat();return this.J(H,"development",K,!0)}return[]}async scanExistingExtension(K,ee,H){const j=await this.P(K,!1,ee,!0,H.language,!0,void 0,H.productVersion??this.R()),B=await this.n.scanExtension(j);return!B||!H.includeInvalid&&!B.isValid?null:B}async scanOneOrMultipleExtensions(K,ee,H){const j=await this.P(K,!1,ee,!0,H.language,!0,void 0,H.productVersion??this.R()),B=await this.n.scanOneOrMultipleExtensions(j);return this.J(B,ee,H,!0)}async scanMultipleExtensions(K,ee,H){const j=[];return await Promise.all(K.map(async B=>{const x=await this.scanOneOrMultipleExtensions(B,ee,H);j.push(...x)})),this.J(j,ee,H,!0)}async scanMetadata(K){const ee=(0,b.$gh)(K,"package.json"),H=(await this.w.readFile(ee)).value.toString();return JSON.parse(H).__metadata}async updateMetadata(K,ee){const H=(0,b.$gh)(K,"package.json"),j=(await this.w.readFile(H)).value.toString(),B=JSON.parse(j);ee.isMachineScoped===!1&&delete ee.isMachineScoped,ee.isBuiltin===!1&&delete ee.isBuiltin,B.__metadata={...B.__metadata,...ee},await this.w.writeFile((0,b.$gh)(K,"package.json"),D.$Oe.fromString(JSON.stringify(B,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.u.scanProfileExtensions(this.t.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(K){if(K instanceof E.$Bq&&K.code===E.ExtensionsProfileScanningErrorCode.ERROR_PROFILE_NOT_FOUND)await this.I();else throw K}}async I(){return this.H||(this.H=(async()=>{try{this.y.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const K=await this.scanUserExtensions({includeInvalid:!0});if(K.length)await this.u.addExtensionsToProfile(K.map(ee=>[ee,ee.metadata]),this.t.defaultProfile.extensionsResource);else try{await this.w.createFile(this.t.defaultProfile.extensionsResource,D.$Oe.fromString(JSON.stringify([])))}catch(ee){(0,n.$ql)(ee)!==n.FileOperationResult.FILE_NOT_FOUND&&this.y.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,O.$_)(ee))}this.y.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(K){this.y.error(K)}finally{this.H=void 0}})()),this.H}async J(K,ee,H,j){return H.includeAllVersions||(K=this.L(ee===t.ExtensionType.System?K:void 0,ee===t.ExtensionType.User?K:void 0,ee==="development"?K:void 0,await this.getTargetPlatform(),j)),H.includeInvalid||(K=K.filter(B=>B.isValid)),K.sort((B,x)=>{const ce=f.$pc(B.location.fsPath),G=f.$pc(x.location.fsPath);return ce<G?-1:ce>G?1:0})}L(K,ee,H,j,B){const x=(G,he,se)=>{if(G.isValid&&!he.isValid)return!1;if(G.isValid===he.isValid){if(B&&l.gt(G.manifest.version,he.manifest.version))return this.y.debug(`Skipping extension ${he.location.path} with lower version ${he.manifest.version} in favour of ${G.location.path} with version ${G.manifest.version}`),!1;if(l.eq(G.manifest.version,he.manifest.version)){if(G.type===t.ExtensionType.System)return this.y.debug(`Skipping extension ${he.location.path} in favour of system extension ${G.location.path} with same version`),!1;if(G.targetPlatform===j)return this.y.debug(`Skipping extension ${he.location.path} from different target platform ${he.targetPlatform}`),!1}}return se?this.y.warn(`Overwriting user extension ${G.location.path} with ${he.location.path}.`):this.y.debug(`Overwriting user extension ${G.location.path} with ${he.location.path}.`),!0},ce=new t.$sn;return K?.forEach(G=>{const he=ce.get(G.identifier.id);(!he||x(he,G,!1))&&ce.set(G.identifier.id,G)}),ee?.forEach(G=>{const he=ce.get(G.identifier.id);if(!he&&K&&G.type===t.ExtensionType.System){this.y.debug(`Skipping obsolete system extension ${G.location.path}.`);return}(!he||x(he,G,!1))&&ce.set(G.identifier.id,G)}),H?.forEach(G=>{const he=ce.get(G.identifier.id);(!he||x(he,G,!0))&&ce.set(G.identifier.id,G),ce.set(G.identifier.id,G)}),[...ce.values()]}async M(K,ee){this.y.trace("Started scanning system extensions");const H=await this.P(this.systemExtensionsLocation,!1,t.ExtensionType.System,!0,ee,!0,void 0,this.R()),B=await(K&&!H.devMode?this.j:this.n).scanExtensions(H);return this.y.trace("Scanned system extensions:",B.length),B}async N(K,ee){const H=this.z.isBuilt?[]:this.C.builtInExtensions;if(!H?.length)return[];this.y.trace("Started scanning dev system extensions");const j=ee?await this.O():{},B=[],x=$.URI.file(f.$jc(f.$lc(h.$Zg.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const G of H){const he=j[G.name]||"marketplace";switch(he){case"disabled":break;case"marketplace":B.push((0,b.$gh)(x,G.name));break;default:B.push($.URI.file(he));break}}const ce=await Promise.all(B.map(async G=>this.n.scanExtension(await this.P(G,!1,t.ExtensionType.System,!0,K,!0,void 0,this.R()))));return this.y.trace("Scanned dev system extensions:",ce.length),(0,i.$Jb)(ce)}async O(){try{const K=await this.w.readFile(this.r);return JSON.parse(K.value.toString())}catch{return{}}}async P(K,ee,H,j,B,x,ce,G){const he=await this.f(B??g.$w),se=await this.Q(K),_=ee&&!this.D.extUri.isEqual(K,this.t.defaultProfile.extensionsResource)?this.t.defaultProfile.extensionsResource:void 0,F=_?await this.Q(_):void 0;return new U(K,se,_,F,ee,ce,H,j,x,G.version,G.date,this.C.commit,!this.z.isBuilt,B,he)}async Q(K){try{const ee=await this.w.stat(K);if(typeof ee.mtime=="number")return ee.mtime}catch{}}R(){return{version:this.C.version,date:this.C.date}}};e.$Hq=M,e.$Hq=M=Se([re(4,A.$Ll),re(5,E.$Cq),re(6,n.$_k),re(7,s.$_j),re(8,v.$Mi),re(9,u.$sk),re(10,T.$Jl),re(11,c.$Ei)],M);class U{constructor(K,ee,H,j,B,x,ce,G,he,se,_,F,C,W,q){this.location=K,this.mtime=ee,this.applicationExtensionslocation=H,this.applicationExtensionslocationMtime=j,this.profile=B,this.profileScanOptions=x,this.type=ce,this.excludeObsolete=G,this.validate=he,this.productVersion=se,this.productDate=_,this.productCommit=F,this.devMode=C,this.language=W,this.translations=q}static createNlsConfiguration(K){return{language:K.language,pseudo:K.language==="pseudo",devMode:K.devMode,translations:K.translations}}static equals(K,ee){return(0,b.$_g)(K.location,ee.location)&&K.mtime===ee.mtime&&(0,b.$_g)(K.applicationExtensionslocation,ee.applicationExtensionslocation)&&K.applicationExtensionslocationMtime===ee.applicationExtensionslocationMtime&&K.profile===ee.profile&&S.$fo(K.profileScanOptions,ee.profileScanOptions)&&K.type===ee.type&&K.excludeObsolete===ee.excludeObsolete&&K.validate===ee.validate&&K.productVersion===ee.productVersion&&K.productDate===ee.productDate&&K.productCommit===ee.productCommit&&K.devMode===ee.devMode&&K.language===ee.language&&R.equals(K.translations,ee.translations)}}e.$Iq=U;let N=class extends a.$Wc{constructor(K,ee,H,j,B){super(),this.f=K,this.g=ee,this.h=H,this.j=j,this.m=B}async scanExtensions(K){const ee=K.profile?await this.r(K):await this.n(K);let H={};if(K.excludeObsolete&&K.type===t.ExtensionType.User)try{const j=(await this.j.readFile(this.f)).value.toString();H=JSON.parse(j)}catch{}return(0,p.$sg)(H)?ee:ee.filter(j=>!H[k.$Ip.create(j).toString()])}async n(K){const ee=await this.j.resolve(K.location);if(!ee.children?.length)return[];const H=await Promise.all(ee.children.map(async j=>{if(!j.isDirectory||K.type===t.ExtensionType.User&&(0,b.$dh)(j.resource).indexOf(".")===0)return null;const B=new U(j.resource,K.mtime,K.applicationExtensionslocation,K.applicationExtensionslocationMtime,K.profile,K.profileScanOptions,K.type,K.excludeObsolete,K.validate,K.productVersion,K.productDate,K.productCommit,K.devMode,K.language,K.translations);return this.scanExtension(B)}));return(0,i.$Jb)(H).sort((j,B)=>j.location.path<B.location.path?-1:1)}async r(K){let ee=await this.s(K.location,()=>!0,K);if(K.applicationExtensionslocation&&!this.h.extUri.isEqual(K.location,K.applicationExtensionslocation)){ee=ee.filter(j=>!j.metadata?.isApplicationScoped);const H=await this.s(K.applicationExtensionslocation,j=>!!j.metadata?.isBuiltin||!!j.metadata?.isApplicationScoped,K);ee.push(...H)}return ee}async s(K,ee,H){const j=await this.g.scanProfileExtensions(K,H.profileScanOptions);if(!j.length)return[];const B=await Promise.all(j.map(async x=>{if(ee(x)){const ce=new U(x.location,H.mtime,H.applicationExtensionslocation,H.applicationExtensionslocationMtime,H.profile,H.profileScanOptions,H.type,H.excludeObsolete,H.validate,H.productVersion,H.productDate,H.productCommit,H.devMode,H.language,H.translations);return this.scanExtension(ce,x.metadata)}return null}));return(0,i.$Jb)(B)}async scanOneOrMultipleExtensions(K){try{if(await this.j.exists((0,b.$gh)(K.location,"package.json"))){const ee=await this.scanExtension(K);return ee?[ee]:[]}else return await this.scanExtensions(K)}catch(ee){return this.m.error(`Error scanning extensions at ${K.location.path}:`,(0,O.$_)(ee)),[]}}async scanExtension(K,ee){try{let H=await this.scanExtensionManifest(K.location);if(H){H.publisher||(H.publisher=t.$mn),ee=ee??H.__metadata,delete H.__metadata;const j=(0,k.$Mp)(H.publisher,H.name),B=ee?.id?{id:j,uuid:ee.id}:{id:j},x=ee?.isSystem?t.ExtensionType.System:K.type,ce=x===t.ExtensionType.System||!!ee?.isBuiltin;H=await this.t(K.location,H,U.createNlsConfiguration(K));const G={type:x,identifier:B,manifest:H,location:K.location,isBuiltin:ce,targetPlatform:ee?.targetPlatform??t.TargetPlatform.UNDEFINED,publisherDisplayName:ee?.publisherDisplayName,metadata:ee,isValid:!0,validations:[]};return K.validate?this.validate(G,K):G}}catch(H){K.type!==t.ExtensionType.System&&this.m.error(H)}return null}validate(K,ee){let H=!0;const j=(0,r.$Xp)(ee.productVersion,ee.productDate,ee.location,K.manifest,K.isBuiltin);for(const[B,x]of j)B===m.default.Error&&(H=!1,this.m.error(this.z(ee.location,x)));return K.isValid=H,K.validations=j,K}async scanExtensionManifest(K){const ee=(0,b.$gh)(K,"package.json");let H;try{H=(await this.j.readFile(ee)).value.toString()}catch(B){return(0,n.$ql)(B)!==n.FileOperationResult.FILE_NOT_FOUND&&this.m.error(this.z(K,(0,w.localize)(0,null,ee.path,B.message))),null}let j;try{j=JSON.parse(H)}catch{const x=[];(0,P.$Vn)(H,x);for(const ce of x)this.m.error(this.z(K,(0,w.localize)(1,null,ee.path,ce.offset,ce.length,(0,y.$Eq)(ce.error))));return null}return(0,P.$4n)(j)!=="object"?(this.m.error(this.z(K,(0,w.localize)(2,null,ee.path))),null):j}async t(K,ee,H){const j=await this.u(K,ee,H);if(j)try{const B=[],x=await this.w(j.default,B);if(B.length>0)return B.forEach(G=>{this.m.error(this.z(K,(0,w.localize)(3,null,j.default?.path,(0,y.$Eq)(G.error))))}),ee;if((0,P.$4n)(j)!=="object")return this.m.error(this.z(K,(0,w.localize)(4,null,j.default?.path))),ee;const ce=j.values||Object.create(null);return(0,L.$Fq)(this.m,ee,ce,x)}catch{}return ee}async u(K,ee,H){const j=(0,b.$gh)(K,"package.nls.json"),B=(he,se)=>{se.forEach(_=>{this.m.error(this.z(K,(0,w.localize)(5,null,he?.path,(0,y.$Eq)(_.error))))})},x=he=>{this.m.error(this.z(K,(0,w.localize)(6,null,he?.path)))},ce=`${ee.publisher}.${ee.name}`,G=H.translations[ce];if(G)try{const he=$.URI.file(G),se=(await this.j.readFile(he)).value.toString(),_=[],F=(0,P.$Vn)(se,_);return _.length>0?(B(he,_),{values:void 0,default:j}):(0,P.$4n)(F)!=="object"?(x(he),{values:void 0,default:j}):{values:F.contents?F.contents.package:void 0,default:j}}catch{return{values:void 0,default:j}}else{if(!await this.j.exists(j))return;let se;try{se=await this.y(K,H)}catch{return}if(!se.localized)return{values:void 0,default:se.original};try{const _=(await this.j.readFile(se.localized)).value.toString(),F=[],C=(0,P.$Vn)(_,F);return F.length>0?(B(se.localized,F),{values:void 0,default:se.original}):(0,P.$4n)(C)!=="object"?(x(se.localized),{values:void 0,default:se.original}):{values:C,default:se.original}}catch{return{values:void 0,default:se.original}}}}async w(K,ee){if(K)try{const H=(await this.j.readFile(K)).value.toString();return(0,P.$Vn)(H,ee)}catch{}}y(K,ee){return new Promise((H,j)=>{const B=x=>{const ce=(0,b.$gh)(K,`package.nls.${x}.json`);this.j.exists(ce).then(G=>{G&&H({localized:ce,original:(0,b.$gh)(K,"package.nls.json")});const he=x.lastIndexOf("-");he===-1?H({localized:(0,b.$gh)(K,"package.nls.json"),original:null}):(x=x.substring(0,he),B(x))})};if(ee.devMode||ee.pseudo||!ee.language)return H({localized:(0,b.$gh)(K,"package.nls.json"),original:null});B(ee.language)})}z(K,ee){return`[${K.path}]: ${ee}`}};N=Se([re(1,E.$Cq),re(2,T.$Jl),re(3,n.$_k),re(4,s.$_j)],N);let z=class extends N{constructor(K,ee,H,j,B,x,ce){super(ee,j,B,x,ce),this.G=K,this.H=H,this.D=this.B(new o.$Dh(3e3)),this.F=this.B(new d.$me),this.onDidChangeCache=this.F.event}async scanExtensions(K){const ee=this.M(K),H=await this.I(ee);if(this.C=K,H&&H.input&&U.equals(H.input,this.C))return this.m.debug("Using cached extensions scan result",K.type===t.ExtensionType.System?"system":"user",K.location.toString()),this.D.trigger(()=>this.L()),H.result.map(B=>(B.location=$.URI.revive(B.location),B));const j=await super.scanExtensions(K);return await this.J(ee,{input:K,result:j}),j}async I(K){try{const ee=await this.j.readFile(K),H=JSON.parse(ee.value.toString());return{result:H.result,input:(0,I.$ci)(H.input)}}catch(ee){this.m.debug("Error while reading the extension cache file:",K.path,(0,O.$_)(ee))}return null}async J(K,ee){try{await this.j.writeFile(K,D.$Oe.fromString(JSON.stringify(ee)))}catch(H){this.m.debug("Error while writing the extension cache file:",K.path,(0,O.$_)(H))}}async L(){if(!this.C)return;const K=this.M(this.C),ee=await this.I(K);if(!ee)return;const H=ee.result,j=JSON.parse(JSON.stringify(await super.scanExtensions(this.C)));if(!S.$fo(j,H))try{this.m.info("Invalidating Cache",H,j),await this.j.del(K),this.F.fire()}catch(B){this.m.error(B)}}M(K){const ee=this.N(K);return this.h.extUri.joinPath(ee.cacheHome,K.type===t.ExtensionType.System?t.$ln:t.$kn)}N(K){return K.type===t.ExtensionType.System?this.H.defaultProfile:K.profile?this.h.extUri.isEqual(K.location,this.G.extensionsResource)?this.G:this.H.profiles.find(ee=>this.h.extUri.isEqual(K.location,ee.extensionsResource))??this.G:this.H.defaultProfile}};z=Se([re(2,A.$Ll),re(3,E.$Cq),re(4,T.$Jl),re(5,n.$_k),re(6,s.$_j)],z);function ne(le,K){const ee=(0,k.$Kp)(le.manifest.publisher,le.manifest.name);return{id:ee,identifier:new t.$qn(ee),isBuiltin:le.type===t.ExtensionType.System,isUserBuiltin:le.type===t.ExtensionType.User&&le.isBuiltin,isUnderDevelopment:K,extensionLocation:le.location,uuid:le.identifier.uuid,targetPlatform:le.targetPlatform,publisherDisplayName:le.publisherDisplayName,...le.manifest}}class Q extends M{constructor(K,ee,H,j,B,x,ce,G,he,se,_,F){super(K,ee,(0,b.$gh)(H,".vscode-oss-dev","extensions","control.json"),j,B,x,ce,G,he,se,_,F),this.S=(async()=>{if(g.$z)try{const C=await this.w.readFile($.URI.file(g.$z));return JSON.parse(C.value.toString())}catch{}return Object.create(null)})()}f(K){return this.S}}e.$Kq=Q}),define(oe[280],ae([0,1,5,42,41,24,86,15,38,7]),function(V,e,i,o,S,D,O,P,y,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kR=void 0;let h=class extends O.$Dq{constructor(g,b,l,m,p,$){super(a.URI.file(g.extensionsPath),b,l,m,p,$)}};e.$kR=h,e.$kR=h=Se([re(0,y.$Ni),re(1,P.$_k),re(2,o.$Ll),re(3,S.$Jl),re(4,D.$$l),re(5,i.$_j)],h)}),define(oe[281],ae([0,1,7,38,86,134,15,6,5,28,41,42]),function(V,e,i,o,S,D,O,P,y,a,h,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3fc=void 0;let g=class extends D.$Kq{constructor(l,m,p,$,w,v,k,t){super(i.URI.file(w.builtinExtensionsPath),i.URI.file(w.extensionsPath),w.userHome,l.defaultProfile,l,m,p,$,w,v,k,t)}};e.$3fc=g,e.$3fc=g=Se([re(0,f.$Ll),re(1,S.$Cq),re(2,O.$_k),re(3,y.$_j),re(4,o.$Ni),re(5,a.$sk),re(6,h.$Jl),re(7,P.$Ei)],g)}),define(oe[282],ae([0,1,14,2,13,9,4,61,7,33,37,38,5,42]),function(V,e,i,o,S,D,O,P,y,a,h,f,g,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kgc=void 0;let l=class extends o.$Wc{constructor(p,$,w){super(),this.c=p,this.f=w,this.a=P.$Li.forPaths(!O.$k),this.b=new Set([".svg",".png",".jpg",".jpeg",".gif",".bmp",".webp",".mp4"]),this.addValidFileRoot(p.appRoot),this.addValidFileRoot(p.extensionsPath),this.addValidFileRoot($.defaultProfile.globalStorageHome.with({scheme:S.Schemas.file}).fsPath),this.addValidFileRoot(p.workspaceStorageHome.with({scheme:S.Schemas.file}).fsPath),this.g()}g(){const{defaultSession:p}=i.session;p.protocol.registerFileProtocol(S.Schemas.vscodeFileResource,($,w)=>this.j($,w)),p.protocol.interceptFileProtocol(S.Schemas.file,($,w)=>this.h($,w)),this.B((0,o.$Uc)(()=>{p.protocol.unregisterProtocol(S.Schemas.vscodeFileResource),p.protocol.uninterceptProtocol(S.Schemas.file)}))}addValidFileRoot(p){const $=(0,D.$jc)(p);return this.a.get($)?o.$Wc.None:(this.a.set($,!0),(0,o.$Uc)(()=>this.a.delete($)))}h(p,$){const w=y.URI.parse(p.url);return this.f.error(`Refused to load resource ${w.fsPath} from ${S.Schemas.file}: protocol (original URL: ${p.url})`),$({error:-3})}j(p,$){const w=this.m(p);let v;return this.c.crossOriginIsolated&&((0,D.$pc)(w)==="workbench.html"||(0,D.$pc)(w)==="workbench-dev.html"?v=S.COI.CoopAndCoep:v=S.COI.getHeadersFromQuery(p.url)),this.a.findSubstr(w)?$({path:w,headers:v}):this.b.has((0,D.$qc)(w).toLowerCase())?$({path:w}):(this.f.error(`${S.Schemas.vscodeFileResource}: Refused to load resource ${w} from ${S.Schemas.vscodeFileResource}: protocol (original URL: ${p.url})`),$({error:-3}))}m(p){const $=y.URI.parse(p.url),w=S.$Zg.uriToFileUri($);return(0,D.$jc)(w.fsPath)}createIPCObjectUrl(){let p;const $=y.URI.from({scheme:"vscode",path:(0,a.$2g)()}),w=$.toString(),v=async()=>p;return h.$BX.handle(w,v),this.f.trace(`IPC Object URL: Registered new channel ${w}.`),{resource:$,update:k=>p=k,dispose:()=>{this.f.trace(`IPC Object URL: Removed channel ${w}.`),h.$BX.removeHandler(w)}}}};e.$kgc=l,e.$kgc=l=Se([re(0,f.$Ni),re(1,b.$Ll),re(2,g.$_j)],l)}),define(oe[63],ae([0,1,8,3,2,70,12,120,6,42]),function(V,e,i,o,S,D,O,P,y,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fq=e.$dq=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$bq=e.$aq=e.$_p=void 0,e.$cq=b,e.$eq=m,e.$gq=$,e.$_p="__$__isNewStorageMarker",e.$aq="__$__targetStorageMarker",e.$bq=(0,y.$Fi)("storageService");var h;(function(w){w[w.NONE=0]="NONE",w[w.SHUTDOWN=1]="SHUTDOWN"})(h||(e.WillSaveStateReason=h={}));var f;(function(w){w[w.APPLICATION=-1]="APPLICATION",w[w.PROFILE=0]="PROFILE",w[w.WORKSPACE=1]="WORKSPACE"})(f||(e.StorageScope=f={}));var g;(function(w){w[w.USER=0]="USER",w[w.MACHINE=1]="MACHINE"})(g||(e.StorageTarget=g={}));function b(w){const v=w.get(e.$aq);if(v)try{return JSON.parse(v)}catch{}return Object.create(null)}class l extends S.$Wc{static{this.a=60*1e3}constructor(v={flushInterval:l.a}){super(),this.m=v,this.b=this.B(new o.$pe),this.c=this.B(new o.$pe),this.onDidChangeTarget=this.c.event,this.f=this.B(new o.$me),this.onWillSaveState=this.f.event,this.h=this.B(new i.$Rh(()=>this.n(),this.m.flushInterval)),this.j=this.B(new S.$Xc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(v,k,t){return o.Event.filter(this.b.event,r=>r.scope===v&&(k===void 0||r.key===k),t)}n(){this.j.value=(0,i.$Vh)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,S.$Rc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,D.mark)("code/willInitStorage");try{await this.O()}finally{(0,D.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(v,k){const{key:t,external:r}=k;if(t===e.$aq){switch(v){case f.APPLICATION:this.H=void 0;break;case f.PROFILE:this.F=void 0;break;case f.WORKSPACE:this.C=void 0;break}this.c.fire({scope:v})}else this.b.fire({scope:v,key:t,target:this.J(v)[t],external:r})}w(v){this.f.fire({reason:v})}get(v,k,t){return this.P(k)?.get(v,t)}getBoolean(v,k,t){return this.P(k)?.getBoolean(v,t)}getNumber(v,k,t){return this.P(k)?.getNumber(v,t)}getObject(v,k,t){return this.P(k)?.getObject(v,t)}storeAll(v,k){this.y(()=>{for(const t of v)this.store(t.key,t.value,t.scope,t.target,k)})}store(v,k,t,r,n=!1){if((0,O.$og)(k)){this.remove(v,t,n);return}this.y(()=>{this.z(v,t,r),this.P(t)?.set(v,k,n)})}remove(v,k,t=!1){this.y(()=>{this.z(v,k,void 0),this.P(k)?.delete(v,t)})}y(v){this.b.pause(),this.c.pause();try{v()}finally{this.b.resume(),this.c.resume()}}keys(v,k){const t=[],r=this.J(v);for(const n of Object.keys(r))r[n]===k&&t.push(n);return t}z(v,k,t,r=!1){const n=this.J(k);typeof t=="number"?n[v]!==t&&(n[v]=t,this.P(k)?.set(e.$aq,JSON.stringify(n),r)):typeof n[v]=="number"&&(delete n[v],this.P(k)?.set(e.$aq,JSON.stringify(n),r))}get D(){return this.C||(this.C=this.L(f.WORKSPACE)),this.C}get G(){return this.F||(this.F=this.L(f.PROFILE)),this.F}get I(){return this.H||(this.H=this.L(f.APPLICATION)),this.H}J(v){switch(v){case f.APPLICATION:return this.I;case f.PROFILE:return this.G;default:return this.D}}L(v){const k=this.P(v);return k?b(k):Object.create(null)}isNew(v){return this.getBoolean(e.$_p,v)===!0}async flush(v=h.NONE){this.f.fire({reason:v});const k=this.P(f.APPLICATION),t=this.P(f.PROFILE),r=this.P(f.WORKSPACE);switch(v){case h.NONE:await i.Promises.settled([k?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve(),r?.whenFlushed()??Promise.resolve()]);break;case h.SHUTDOWN:await i.Promises.settled([k?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve(),r?.flush(0)??Promise.resolve()]);break}}async log(){const v=this.P(f.APPLICATION)?.items??new Map,k=this.P(f.PROFILE)?.items??new Map,t=this.P(f.WORKSPACE)?.items??new Map;return $(v,k,t,this.Q(f.APPLICATION)??"",this.Q(f.PROFILE)??"",this.Q(f.WORKSPACE)??"")}async optimize(v){return await this.flush(),this.P(v)?.optimize()}async switch(v,k){return this.w(h.NONE),(0,a.$Kl)(v)?this.R(v,k):this.S(v,k)}M(v,k){return!(v.id===k.id||m(k)&&m(v))}N(v,k,t){this.y(()=>{const r=new Set;for(const[n,c]of v)r.add(n),k.get(n)!==c&&this.u(t,{key:n,external:!0});for(const[n]of k.items)r.has(n)||this.u(t,{key:n,external:!0})})}}e.$dq=l;function m(w){return w.isDefault||!!w.useDefaultFlags?.globalState}class p extends l{constructor(){super(),this.U=this.B(new P.$0p(new P.$$p,{hint:P.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new P.$0p(new P.$$p,{hint:P.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new P.$0p(new P.$$p,{hint:P.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(v=>this.u(f.WORKSPACE,v))),this.B(this.W.onDidChangeStorage(v=>this.u(f.PROFILE,v))),this.B(this.U.onDidChangeStorage(v=>this.u(f.APPLICATION,v)))}P(v){switch(v){case f.APPLICATION:return this.U;case f.PROFILE:return this.W;default:return this.X}}Q(v){switch(v){case f.APPLICATION:return"inMemory (application)";case f.PROFILE:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(v){return!1}}e.$fq=p;async function $(w,v,k,t,r,n){const c=R=>{try{return JSON.parse(R)}catch{return R}},s=new Map,u=new Map;w.forEach((R,M)=>{s.set(M,R),u.set(M,c(R))});const d=new Map,I=new Map;v.forEach((R,M)=>{d.set(M,R),I.set(M,c(R))});const E=new Map,A=new Map;k.forEach((R,M)=>{E.set(M,R),A.set(M,c(R))}),console.group(t!==r?`Storage: Application (path: ${t})`:`Storage: Application & Profile (path: ${t}, default profile)`);const T=[];if(s.forEach((R,M)=>{T.push({key:M,value:R})}),console.table(T),console.groupEnd(),console.log(u),t!==r){console.group(`Storage: Profile (path: ${r}, profile specific)`);const R=[];d.forEach((M,U)=>{R.push({key:U,value:M})}),console.table(R),console.groupEnd(),console.log(I)}console.group(`Storage: Workspace (path: ${n})`);const L=[];E.forEach((R,M)=>{L.push({key:M,value:R})}),console.table(L),console.groupEnd(),console.log(A)}}),define(oe[283],ae([0,1,17,33,63]),function(V,e,i,o,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hq=D;async function D(O,P,y){let a=y&&y.get("storage.serviceMachineId",S.StorageScope.APPLICATION)||null;if(a)return a;try{const f=(await P.readFile(O.serviceMachineIdResource)).value.toString();a=(0,o.$1g)(f)?f:null}catch{a=null}if(!a){a=(0,o.$2g)();try{await P.writeFile(O.serviceMachineIdResource,i.$Oe.fromString(a))}catch{}}return y?.store("storage.serviceMachineId",a,S.StorageScope.APPLICATION,S.StorageTarget.MACHINE),a}}),define(oe[284],ae([0,1,283,24,56]),function(V,e,i,o,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iq=D;async function D(O,P,y,a,h,f,g){const b={"X-Market-Client-Id":`VSCode ${O}`,"User-Agent":`VSCode ${O} (${P.nameShort})`};if((0,S.$zp)(P,y)&&(0,S.$Bp)(a)===o.TelemetryLevel.USAGE){const l=await(0,i.$hq)(y,h,f);b["X-Market-User-Id"]=l,b["VSCode-SessionId"]=g.machineId||l}return b}}),define(oe[285],ae([0,1,22,8,3,2,9,66,7,21,120,166,5,63,24,30,13]),function(V,e,i,o,S,D,O,P,y,a,h,f,g,b,l,m,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tec=e.$Sec=e.$Rec=e.$Qec=void 0;class $ extends D.$Wc{static{this.a=2e3}get storage(){return this.f}constructor(c,s){super(),this.m=c,this.n=s,this.b=this.B(new S.$me),this.onDidChangeStorage=this.b.event,this.c=this.B(new S.$me),this.onDidCloseStorage=this.c.event,this.f=this.B(new h.$0p(new h.$$p,{hint:h.StorageHint.STORAGE_IN_MEMORY})),this.g=void 0,this.h=new o.$3h,this.whenInit=this.h.p,this.j=h.StorageState.None}isInMemory(){return this.f.isInMemory()}init(){return this.g||(this.g=(async()=>{if(this.j===h.StorageState.None)try{const c=this.B(await this.t());this.f.dispose(),this.f=c,this.B(c.onDidChangeStorage(u=>this.b.fire(u))),await this.s(c);const s=c.getBoolean(b.$_p);s===void 0?c.set(b.$_p,!0):s&&c.set(b.$_p,!1)}catch(c){this.m.error(`[storage main] initialize(): Unable to init storage due to ${c}`)}finally{this.j=h.StorageState.Initialized,this.h.complete()}})()),this.g}r(){return{logTrace:this.m.getLevel()===g.LogLevel.Trace?c=>this.m.trace(c):void 0,logError:c=>this.m.error(c)}}s(c){return c.init()}get items(){return this.f.items}get(c,s){return this.f.get(c,s)}set(c,s){return this.f.set(c,s)}delete(c){return this.f.delete(c)}optimize(){return this.f.optimize()}async close(){const c=new P.$ge(!1);await this.w(),c.stop(),c.elapsed()>$.a&&await this.u(c),this.c.fire()}async u(c){if(this.path)try{const s=(0,i.top)(Array.from(this.f.items.entries()).map(([d,I])=>({key:d,length:I.length})),(d,I)=>I.length-d.length,5).map(d=>`${d.key}:${d.length}`).join(", "),u=(await this.n.stat(y.URI.file(this.path))).size;this.m.warn(`[storage main] detected slow close() operation: Time: ${c.elapsed()}ms, DB size: ${u}b, Large Keys: ${s}`)}catch(s){this.m.error("[storage main] figuring out stats for slow DB on close() resulted in an error",s)}}async w(){this.g&&await this.g,this.j=h.StorageState.Closed,await this.f.close()}}class w extends ${static{this.y="state.vscdb"}get path(){if(!this.C.useInMemoryStorage)return(0,O.$lc)(this.z.globalStorageHome.with({scheme:p.Schemas.file}).fsPath,w.y)}constructor(c,s,u,d){super(u,d),this.z=c,this.C=s}async t(){return new h.$0p(new f.$7X(this.path??f.$7X.IN_MEMORY_PATH,{logging:this.r()}),this.path?void 0:{hint:h.StorageHint.STORAGE_IN_MEMORY})}}class v extends w{constructor(c,s,u,d){super(c,s,u,d)}}e.$Qec=v;class k extends w{constructor(c,s,u,d){super(s.defaultProfile,c,u,d)}async s(c){await super.s(c),this.G(c)}G(c){c.get(l.$bm,void 0)===void 0&&c.set(l.$bm,new Date().toUTCString());const u=c.get(l.$am,void 0),d=new Date().toUTCString();c.set(l.$cm,typeof u>"u"?null:u),c.set(l.$am,d)}}e.$Rec=k;class t extends ${static{this.y="state.vscdb"}static{this.z="workspace.json"}get path(){if(!this.D.useInMemoryStorage)return(0,O.$lc)(this.F.workspaceStorageHome.with({scheme:p.Schemas.file}).fsPath,this.C.id,t.y)}constructor(c,s,u,d,I){super(u,I),this.C=c,this.D=s,this.F=d}async t(){const{storageFilePath:c,wasCreated:s}=await this.H();return new h.$0p(new f.$7X(c,{logging:this.r()}),{hint:this.D.useInMemoryStorage?h.StorageHint.STORAGE_IN_MEMORY:s?h.StorageHint.STORAGE_DOES_NOT_EXIST:void 0})}async H(){if(this.D.useInMemoryStorage)return{storageFilePath:f.$7X.IN_MEMORY_PATH,wasCreated:!0};const c=(0,O.$lc)(this.F.workspaceStorageHome.with({scheme:p.Schemas.file}).fsPath,this.C.id),s=(0,O.$lc)(c,t.y);return await a.Promises.exists(c)?{storageFilePath:s,wasCreated:!1}:(await a.Promises.mkdir(c,{recursive:!0}),this.I(c),{storageFilePath:s,wasCreated:!0})}async I(c){let s;if((0,m.$Pi)(this.C)?s={folder:this.C.uri.toString()}:(0,m.$Ui)(this.C)&&(s={workspace:this.C.configPath.toString()}),s)try{const u=(0,O.$lc)(c,t.z);await a.Promises.exists(u)||await a.Promises.writeFile(u,JSON.stringify(s,void 0,2))}catch(u){this.m.error(`[storage main] ensureWorkspaceStorageFolderMeta(): Unable to create workspace storage metadata due to ${u}`)}}}e.$Sec=t;class r extends ${get path(){}async t(){return new h.$0p(new h.$$p,{hint:h.StorageHint.STORAGE_IN_MEMORY})}}e.$Tec=r}),define(oe[286],ae([0,1,3,2,63]),function(V,e,i,o,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5fc=void 0;class D extends o.$Wc{constructor(P,y,a){super(),this.b=P,this.c=y,this.f=a;const h=this.B(new o.$Xc);this.a=this.B(new i.$me({onWillAddFirstListener:()=>h.value=this.g(),onDidRemoveLastListener:()=>h.value=void 0}))}g(){this.f.debug("ProfileStorageChangesListenerChannel#registerStorageChangeListeners");const P=new o.$Vc;return P.add(i.Event.debounce(this.b.applicationStorage.onDidChangeStorage,(y,a)=>(y?y.push(a.key):y=[a.key],y),100)(y=>this.h(y))),P.add(i.Event.debounce(this.b.onDidChangeProfileStorage,(y,a)=>{y||(y=new Map);let h=y.get(a.profile.id);return h||y.set(a.profile.id,h={profile:a.profile,keys:[],storage:a.storage}),h.keys.push(a.key),y},100)(y=>this.j(y))),P}h(P){const y=P.includes(S.$aq)?[this.c.defaultProfile]:[],a=[];if(P=P.filter(h=>h!==S.$aq),P.length){const h=(0,S.$cq)(this.b.applicationStorage.storage);a.push({profile:this.c.defaultProfile,changes:P.map(f=>({key:f,scope:S.StorageScope.PROFILE,target:h[f]}))})}this.m(y,a)}j(P){const y=[],a=new Map;for(const[h,f]of P.entries()){f.keys.includes(S.$aq)&&y.push(f.profile);const g=f.keys.filter(b=>b!==S.$aq);if(g.length){const b=(0,S.$cq)(f.storage.storage);a.set(h,{profile:f.profile,changes:g.map(l=>({key:l,scope:S.StorageScope.PROFILE,target:b[l]}))})}}this.m(y,[...a.values()])}m(P,y){(P.length||y.length)&&this.a.fire({valueChanges:y,targetChanges:P})}listen(P,y,a){switch(y){case"onDidChange":return this.a.event}throw new Error(`[ProfileStorageChangesListenerChannel] Event not found: ${y}`)}async call(P,y){throw new Error(`Call not found: ${y}`)}}e.$5fc=D}),define(oe[287],ae([0,1,7,38,15,5,34,41,42,12,128]),function(V,e,i,o,S,D,O,P,y,a,h){"use strict";var f,g;Object.defineProperty(e,"__esModule",{value:!0}),e.$jR=e.$iR=e.$hR=void 0;let b=class extends y.$Ol{static{f=this}static{this.a="profileAssociationsMigration"}constructor($,w,v,k,t){super(v,k,w,t),this.U=$,this.W=v}O(){return this.U.getItem(f.b,[]).map(w=>({...w,location:(0,a.$fg)(w.location)?this.w.extUri.joinPath(this.profilesHome,w.location):i.URI.revive(w.location)}))}Q(){const $=this.U.getItem(f.c,{});return this.U.getItem(f.a,!1)?$:this.N($)}S(){return this.w.extUri.joinPath(i.URI.file(this.W.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};e.$hR=b,e.$hR=b=f=Se([re(0,O.$cR),re(1,P.$Jl),re(2,o.$Ni),re(3,S.$_k),re(4,D.$_j)],b);let l=g=class extends b{constructor($,w,v,k,t){super($,w,v,k,t),this.$=$}P($){$.length?this.$.setItem(g.b,$.map(w=>({...w,location:this.w.extUri.basename(w.location)}))):this.$.removeItem(g.b)}O(){const $=super.O();return this.$.getItem("userDataProfilesMigration",!1)||(this.P($),this.$.setItem("userDataProfilesMigration",!0)),$}R($){$.emptyWindows||$.workspaces?this.$.setItem(g.c,$):this.$.removeItem(g.c)}Q(){const $="workspaceAndProfileInfo",w=this.$.getItem($,void 0);if(w){this.$.removeItem($);const k=w.reduce((t,{workspace:r,profile:n})=>(t[i.URI.revive(r).toString()]=i.URI.revive(n).toString(),t),{});this.$.setItem(g.c,{workspaces:k})}const v=super.Q();return this.$.getItem(g.a,!1)||(this.R(v),this.$.setItem(g.a,!0)),v}};e.$iR=l,e.$iR=l=g=Se([re(0,O.$dR),re(1,P.$Jl),re(2,o.$Ni),re(3,S.$_k),re(4,D.$_j)],l);let m=class extends l{constructor($,w,v,k){super(new h.$gR(h.SaveStrategy.IMMEDIATE,w,k,v),$,w,v,k)}async init(){return await this.$.init(),super.init()}};e.$jR=m,e.$jR=m=Se([re(0,P.$Jl),re(1,o.$Ni),re(2,S.$_k),re(3,D.$_j)],m)}),define(oe[59],ae([0,1,38,15,6,5,41,42,287,34]),function(V,e,i,o,S,D,O,P,y,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zec=e.$yec=void 0,e.$yec=(0,S.$Gi)(P.$Ll);let h=class extends y.$iR{constructor(g,b,l,m,p){super(g,b,l,m,p)}getAssociatedEmptyWindows(){const g=[];for(const b of this.C.emptyWindows.keys())g.push({id:b});return g}};e.$zec=h,e.$zec=h=Se([re(0,a.$dR),re(1,O.$Jl),re(2,i.$Ni),re(3,o.$_k),re(4,D.$_j)],h)}),define(oe[135],ae([0,1,19,7,30]),function(V,e,i,o,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Aec=D,e.$Bec=O,e.$Cec=P;async function D(y,a,h){for(const g of y){const b=g.openedWorkspace;if((0,S.$Ui)(b)){const l=await h(b);if(l){if(l.folders.some(m=>i.$0g.isEqualOrParent(a,m.uri)))return g}else if(i.$0g.isEqualOrParent(a,b.configPath))return g}}const f=y.filter(g=>(0,S.$Pi)(g.openedWorkspace)&&i.$0g.isEqualOrParent(a,g.openedWorkspace.uri));if(f.length)return f.sort((g,b)=>-(g.openedWorkspace.uri.path.length-b.openedWorkspace.uri.path.length))[0]}function O(y,a){for(const h of y)if((0,S.$Ui)(h.openedWorkspace)&&i.$0g.isEqual(h.openedWorkspace.configPath,a)||(0,S.$Pi)(h.openedWorkspace)&&i.$0g.isEqual(h.openedWorkspace.uri,a))return h}function P(y,a){const h=f=>a.some(g=>i.$0g.isEqual(o.URI.file(g),o.URI.file(f)));for(const f of y)if(f.config?.extensionDevelopmentPath?.some(g=>h(g)))return f}}),define(oe[103],ae([0,1,31,43,108,48,13,9,4,19,7,6,72,30]),function(V,e,i,o,S,D,O,P,y,a,h,f,g,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fhb=void 0,e.$Ghb=l,e.$Hhb=m,e.$Ihb=p,e.$Jhb=$,e.$Khb=k,e.$Lhb=r,e.$Mhb=n,e.$Nhb=I,e.$Ohb=E,o=Re(o),S=Re(S),e.$Fhb=(0,f.$Fi)("workspacesService");function l(A){return A.hasOwnProperty("workspace")}function m(A){return A.hasOwnProperty("folderUri")}function p(A){return A.hasOwnProperty("fileUri")}function $(A){return w(A)||v(A)}function w(A){const T=A;return typeof T?.path=="string"&&(!T.name||typeof T.name=="string")}function v(A){const T=A;return typeof T?.uri=="string"&&(!T.name||typeof T.name=="string")}function k(A,T,L,R,M){if(A.scheme!==R.scheme)return{name:L,uri:A.toString(!0)};let U=T?void 0:M.relativePath(R,A);if(U!==void 0)U.length===0?U=".":y.$i&&(U=t(U));else if(A.scheme===O.Schemas.file)U=A.fsPath,y.$i&&(U=t(U));else if(M.isEqualAuthority(A.authority,R.authority))U=A.path;else return{name:L,uri:A.toString(!0)};return{name:L,path:U}}function t(A){return A=(0,D.$Sw)(A),(0,i.$Bg)(A)||(A=(0,i.$yg)(A)),A}function r(A,T,L){const R=[],M=new Set,U=L.dirname(T);for(const N of A){let z;if(w(N))N.path&&(z=L.resolvePath(U,N.path));else if(v(N))try{z=h.URI.parse(N.uri),z.path[0]!==P.$ic.sep&&(z=z.with({path:P.$ic.sep+z.path}))}catch(ne){console.warn(ne)}if(z){const ne=L.getComparisonKey(z);if(!M.has(ne)){M.add(ne);const Q=N.name||L.basenameOrAuthority(z);R.push(new b.$Zi({uri:z,name:Q,index:R.length},N))}}}return R}function n(A,T,L,R,M){const U=c(T,A),N=M.dirname(T),z=M.dirname(R),ne=[];for(const ee of U.folders){const H=w(ee)?M.resolvePath(N,ee.path):h.URI.parse(ee.uri);let j;L?j=!1:j=!w(ee)||(0,P.$kc)(ee.path),ne.push(k(H,j,ee.name,z,M))}const Q={insertSpaces:!1,tabSize:4,eol:y.$k||y.$j?`
`:`\r
`},le=S.$0n(A,["folders"],ne,Q);let K=S.$ao(A,le);return(0,a.$lh)(U.remoteAuthority,(0,g.$gn)(R))&&(K=S.$ao(K,S.$9n(K,["remoteAuthority"],Q))),K}function c(A,T){const L=o.$Vn(T);if(L&&Array.isArray(L.folders))L.folders=L.folders.filter(R=>$(R));else throw new Error(`${A} looks like an invalid workspace file.`);return L}function s(A){return A.workspace&&typeof A.workspace=="object"&&typeof A.workspace.id=="string"&&typeof A.workspace.configPath=="string"}function u(A){return typeof A.folderUri=="string"}function d(A){return typeof A.fileUri=="string"}function I(A,T){const L={workspaces:[],files:[]};if(A){const R=function(U,N){for(let z=0;z<U.length;z++)try{N(U[z],z)}catch(ne){T.warn(`Error restoring recent entry ${JSON.stringify(U[z])}: ${ne.toString()}. Skip entry.`)}},M=A;Array.isArray(M.entries)&&R(M.entries,U=>{const N=U.label,z=U.remoteAuthority;s(U)?L.workspaces.push({label:N,remoteAuthority:z,workspace:{id:U.workspace.id,configPath:h.URI.parse(U.workspace.configPath)}}):u(U)?L.workspaces.push({label:N,remoteAuthority:z,folderUri:h.URI.parse(U.folderUri)}):d(U)&&L.files.push({label:N,remoteAuthority:z,fileUri:h.URI.parse(U.fileUri)})})}return L}function E(A){const T={entries:[]};for(const L of A.workspaces)m(L)?T.entries.push({folderUri:L.folderUri.toString(),label:L.label,remoteAuthority:L.remoteAuthority}):T.entries.push({workspace:{id:L.workspace.id,configPath:L.workspace.configPath.toString()},label:L.label,remoteAuthority:L.remoteAuthority});for(const L of A.files)T.entries.push({fileUri:L.fileUri.toString(),label:L.label,remoteAuthority:L.remoteAuthority});return T}}),define(oe[104],ae([0,1,91,13,4,19]),function(V,e,i,o,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dec=void 0,e.$Eec=O,e.$Fec=P,e.$Gec=y,e.$Dec=128/4;function O(a){function h(){let f=a.scheme===o.Schemas.file?(0,D.$7g)(a):a.toString();return S.$k||(f=f.toLowerCase()),(0,i.createHash)("md5").update(f).digest("hex")}return{id:h(),configPath:a}}function P(a,h){function f(){if(a.scheme!==o.Schemas.file)return(0,i.createHash)("md5").update(a.toString()).digest("hex");if(!h)return;let b;return S.$k?b=h.ino:S.$j?b=h.birthtime.getTime():S.$i&&(typeof h.birthtimeMs=="number"?b=Math.floor(h.birthtimeMs):b=h.birthtime.getTime()),(0,i.createHash)("md5").update(a.fsPath).update(b?String(b):"").digest("hex")}const g=f();if(typeof g=="string")return{id:g,uri:a}}function y(){return{id:(Date.now()+Math.round(Math.random()*1e3)).toString()}}}),define(oe[105],ae([0,1,91,92,27,288,17,16,3,2,9,4,33,44,118]),function(V,e,i,o,S,D,O,P,y,a,h,f,g,b,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zi=e.$wi=e.$vi=e.$ui=void 0,e.$xi=s,e.$yi=u,e.$Ai=E,e.$Bi=A;const m=3e4;class p{traceSocketEvent(L,R){l.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,L,R)}constructor(L,R=""){this.f=!0,this.debugLabel=R,this.socket=L,this.traceSocketEvent(l.SocketDiagnosticsEventType.Created,{type:"NodeSocket"}),this.a=U=>{if(this.traceSocketEvent(l.SocketDiagnosticsEventType.Error,{code:U?.code,message:U?.message}),U){if(U.code==="EPIPE")return;(0,P.$3)(U)}},this.socket.on("error",this.a);let M;this.b=U=>{this.traceSocketEvent(l.SocketDiagnosticsEventType.Close,{hadError:U}),this.f=!1,M&&clearTimeout(M)},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent(l.SocketDiagnosticsEventType.NodeEndReceived),this.f=!1,M=setTimeout(()=>L.destroy(),m)},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(L){const R=M=>{this.traceSocketEvent(l.SocketDiagnosticsEventType.Read,M),L(O.$Oe.wrap(M))};return this.socket.on("data",R),{dispose:()=>this.socket.off("data",R)}}onClose(L){const R=M=>{L({type:l.SocketCloseEventType.NodeSocketCloseEvent,hadError:M,error:void 0})};return this.socket.on("close",R),{dispose:()=>this.socket.off("close",R)}}onEnd(L){const R=()=>{L()};return this.socket.on("end",R),{dispose:()=>this.socket.off("end",R)}}write(L){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent(l.SocketDiagnosticsEventType.Write,L),this.socket.write(L.buffer,R=>{if(R){if(R.code==="EPIPE")return;(0,P.$3)(R)}})}catch(R){if(R.code==="EPIPE")return;(0,P.$3)(R)}}end(){this.traceSocketEvent(l.SocketDiagnosticsEventType.NodeEndSent),this.socket.end()}drain(){return this.traceSocketEvent(l.SocketDiagnosticsEventType.NodeDrainBegin),new Promise((L,R)=>{if(this.socket.bufferSize===0){this.traceSocketEvent(l.SocketDiagnosticsEventType.NodeDrainEnd),L();return}const M=()=>{this.socket.off("close",M),this.socket.off("end",M),this.socket.off("error",M),this.socket.off("timeout",M),this.socket.off("drain",M),this.traceSocketEvent(l.SocketDiagnosticsEventType.NodeDrainEnd),L()};this.socket.on("close",M),this.socket.on("end",M),this.socket.on("error",M),this.socket.on("timeout",M),this.socket.on("drain",M)})}}e.$ui=p;var $;(function(T){T[T.MinHeaderByteSize=2]="MinHeaderByteSize",T[T.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})($||($={}));var w;(function(T){T[T.PeekHeader=1]="PeekHeader",T[T.ReadHeader=2]="ReadHeader",T[T.ReadBody=3]="ReadBody",T[T.Fin=4]="Fin"})(w||(w={}));class v extends a.$Wc{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(L,R){this.socket.traceSocketEvent(L,R)}constructor(L,R,M,U){super(),this.f=this.B(new y.$me),this.g=this.B(new y.$me),this.h=!1,this.j={state:w.PeekHeader,readLen:$.MinHeaderByteSize,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0,opcode:0},this.socket=L,this.traceSocketEvent(l.SocketDiagnosticsEventType.Created,{type:"WebSocketNodeSocket",permessageDeflate:R,inflateBytesLength:M?.byteLength||0,recordInflateBytes:U}),this.a=this.B(new k(this,R,M,U,this.f,(N,z)=>this.m(N,z))),this.B(this.a.onError(N=>{console.error(N),(0,P.$3)(N),this.g.fire({type:l.SocketCloseEventType.NodeSocketCloseEvent,hadError:!0,error:N})})),this.b=new l.$pi,this.B(this.socket.onData(N=>this.n(N))),this.B(this.socket.onClose(async N=>{this.a.isProcessingReadQueue()&&await y.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(N)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(L){return this.f.event(L)}onClose(L){return this.g.event(L)}onEnd(L){return this.socket.onEnd(L)}write(L){let R=0;for(;R<L.byteLength;)this.a.writeMessage(L.slice(R,Math.min(R+$.MaxWebSocketMessageLength,L.byteLength)),{compressed:!0,opcode:2}),R+=$.MaxWebSocketMessageLength}m(L,{compressed:R,opcode:M}){if(this.h)return;this.traceSocketEvent(l.SocketDiagnosticsEventType.WebSocketNodeSocketWrite,L);let U=$.MinHeaderByteSize;L.byteLength<126?U+=0:L.byteLength<2**16?U+=2:U+=8;const N=O.$Oe.alloc(U),z=R?64:0,ne=M&15;if(N.writeUInt8(128|z|ne,0),L.byteLength<126)N.writeUInt8(L.byteLength,1);else if(L.byteLength<2**16){N.writeUInt8(126,1);let Q=1;N.writeUInt8(L.byteLength>>>8&255,++Q),N.writeUInt8(L.byteLength>>>0&255,++Q)}else{N.writeUInt8(127,1);let Q=1;N.writeUInt8(0,++Q),N.writeUInt8(0,++Q),N.writeUInt8(0,++Q),N.writeUInt8(0,++Q),N.writeUInt8(L.byteLength>>>24&255,++Q),N.writeUInt8(L.byteLength>>>16&255,++Q),N.writeUInt8(L.byteLength>>>8&255,++Q),N.writeUInt8(L.byteLength>>>0&255,++Q)}this.socket.write(O.$Oe.concat([N,L]))}end(){this.h=!0,this.socket.end()}n(L){if(L.byteLength!==0){for(this.b.acceptChunk(L);this.b.byteLength>=this.j.readLen;)if(this.j.state===w.PeekHeader){const R=this.b.peek(this.j.readLen),M=R.readUInt8(0),U=(M&128)>>>7,N=(M&64)>>>6,z=M&15,ne=R.readUInt8(1),Q=(ne&128)>>>7,le=ne&127;this.j.state=w.ReadHeader,this.j.readLen=$.MinHeaderByteSize+(Q?4:0)+(le===126?2:0)+(le===127?8:0),this.j.fin=U,this.j.firstFrameOfMessage&&(this.j.compressed=!!N),this.j.firstFrameOfMessage=!!U,this.j.mask=0,this.j.opcode=z,this.traceSocketEvent(l.SocketDiagnosticsEventType.WebSocketNodeSocketPeekedHeader,{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,opcode:this.j.opcode})}else if(this.j.state===w.ReadHeader){const R=this.b.read(this.j.readLen),M=R.readUInt8(1),U=(M&128)>>>7;let N=M&127,z=1;N===126?N=R.readUInt8(++z)*2**8+R.readUInt8(++z):N===127&&(N=R.readUInt8(++z)*0+R.readUInt8(++z)*0+R.readUInt8(++z)*0+R.readUInt8(++z)*0+R.readUInt8(++z)*2**24+R.readUInt8(++z)*2**16+R.readUInt8(++z)*2**8+R.readUInt8(++z));let ne=0;U&&(ne=R.readUInt8(++z)*2**24+R.readUInt8(++z)*2**16+R.readUInt8(++z)*2**8+R.readUInt8(++z)),this.j.state=w.ReadBody,this.j.readLen=N,this.j.mask=ne,this.traceSocketEvent(l.SocketDiagnosticsEventType.WebSocketNodeSocketPeekedHeader,{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask,opcode:this.j.opcode})}else if(this.j.state===w.ReadBody){const R=this.b.read(this.j.readLen);this.traceSocketEvent(l.SocketDiagnosticsEventType.WebSocketNodeSocketReadData,R),n(R,this.j.mask),this.traceSocketEvent(l.SocketDiagnosticsEventType.WebSocketNodeSocketUnmaskedData,R),this.j.state=w.PeekHeader,this.j.readLen=$.MinHeaderByteSize,this.j.mask=0,this.j.opcode<=2?this.a.acceptFrame(R,this.j.compressed,!!this.j.fin):this.j.opcode===9&&this.a.writeMessage(R,{compressed:!1,opcode:10})}}}async drain(){this.traceSocketEvent(l.SocketDiagnosticsEventType.WebSocketNodeSocketDrainBegin),this.a.isProcessingWriteQueue()&&await y.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent(l.SocketDiagnosticsEventType.WebSocketNodeSocketDrainEnd)}}e.$vi=v;class k extends a.$Wc{get permessageDeflate(){return!!(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:O.$Oe.alloc(0)}constructor(L,R,M,U,N,z){super(),this.n=L,this.r=N,this.s=z,this.a=this.B(new y.$me),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new y.$me),this.onDidFinishProcessingReadQueue=this.j.event,this.m=this.B(new y.$me),this.onDidFinishProcessingWriteQueue=this.m.event,this.t=!1,this.y=!1,R?(this.b=this.B(new t(this.n,U,M,{windowBits:15})),this.f=this.B(new r(this.n,{windowBits:15})),this.B(this.b.onError(ne=>this.a.fire(ne))),this.B(this.f.onError(ne=>this.a.fire(ne)))):(this.b=null,this.f=null)}writeMessage(L,R){this.g.push({data:L,options:R}),this.u()}async u(){if(!this.t){for(this.t=!0;this.g.length>0;){const{data:L,options:R}=this.g.shift();if(this.f&&R.compressed){const M=await this.w(this.f,L);this.s(M,R)}else this.s(L,{...R,compressed:!1})}this.t=!1,this.m.fire()}}isProcessingWriteQueue(){return this.t}w(L,R){return new Promise((M,U)=>{L.write(R),L.flush(N=>M(N))})}acceptFrame(L,R,M){this.h.push({data:L,isCompressed:R,isLastFrameOfMessage:M}),this.z()}async z(){if(!this.y){for(this.y=!0;this.h.length>0;){const L=this.h.shift();if(this.b&&L.isCompressed){const R=await this.C(this.b,L.data,L.isLastFrameOfMessage);this.r.fire(R)}else this.r.fire(L.data)}this.y=!1,this.j.fire()}}isProcessingReadQueue(){return this.y}C(L,R,M){return new Promise((U,N)=>{L.write(R),M&&L.write(O.$Oe.fromByteArray([0,0,255,255])),L.flush(z=>U(z))})}}class t extends a.$Wc{get recordedInflateBytes(){return this.j?O.$Oe.concat(this.f):O.$Oe.alloc(0)}constructor(L,R,M,U){super(),this.h=L,this.j=R,this.a=this.B(new y.$me),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,D.createInflateRaw)(U),this.b.on("error",N=>{this.h.traceSocketEvent(l.SocketDiagnosticsEventType.zlibInflateError,{message:N?.message,code:N?.code}),this.a.fire(N)}),this.b.on("data",N=>{this.h.traceSocketEvent(l.SocketDiagnosticsEventType.zlibInflateData,N),this.g.push(O.$Oe.wrap(N))}),M&&(this.h.traceSocketEvent(l.SocketDiagnosticsEventType.zlibInflateInitialWrite,M.buffer),this.b.write(M.buffer),this.b.flush(()=>{this.h.traceSocketEvent(l.SocketDiagnosticsEventType.zlibInflateInitialFlushFired),this.g.length=0}))}write(L){this.j&&this.f.push(L.clone()),this.h.traceSocketEvent(l.SocketDiagnosticsEventType.zlibInflateWrite,L),this.b.write(L.buffer)}flush(L){this.b.flush(()=>{this.h.traceSocketEvent(l.SocketDiagnosticsEventType.zlibInflateFlushFired);const R=O.$Oe.concat(this.g);this.g.length=0,L(R)})}}class r extends a.$Wc{constructor(L,R){super(),this.g=L,this.a=this.B(new y.$me),this.onError=this.a.event,this.f=[],this.b=(0,D.createDeflateRaw)({windowBits:15}),this.b.on("error",M=>{this.g.traceSocketEvent(l.SocketDiagnosticsEventType.zlibDeflateError,{message:M?.message,code:M?.code}),this.a.fire(M)}),this.b.on("data",M=>{this.g.traceSocketEvent(l.SocketDiagnosticsEventType.zlibDeflateData,M),this.f.push(O.$Oe.wrap(M))})}write(L){this.g.traceSocketEvent(l.SocketDiagnosticsEventType.zlibDeflateWrite,L.buffer),this.b.write(L.buffer)}flush(L){this.b.flush(2,()=>{this.g.traceSocketEvent(l.SocketDiagnosticsEventType.zlibDeflateFlushFired);let R=O.$Oe.concat(this.f);this.f.length=0,R=R.slice(0,R.byteLength-4),L(R)})}}function n(T,L){if(L===0)return;const R=T.byteLength>>>2;for(let Q=0;Q<R;Q++){const le=T.readUInt32BE(Q*4);T.writeUInt32BE(le^L,Q*4)}const M=R*4,U=T.byteLength-M,N=L>>>24&255,z=L>>>16&255,ne=L>>>8&255;U>=1&&T.writeUInt8(T.readUInt8(M)^N,M),U>=2&&T.writeUInt8(T.readUInt8(M+1)^z,M+1),U>=3&&T.writeUInt8(T.readUInt8(M+2)^ne,M+2)}e.$wi=process.env.XDG_RUNTIME_DIR;const c={[f.Platform.Linux]:107,[f.Platform.Mac]:103};function s(){const T=(0,g.$2g)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${T}-sock`;const L=process.platform!=="darwin"&&e.$wi?e.$wi:(0,S.tmpdir)(),R=(0,h.$lc)(L,`vscode-ipc-${T}.sock`);return d(R),R}function u(T,L,R){const U=(0,i.createHash)("sha256").update(T).digest("hex").substr(0,8);if(process.platform==="win32")return`\\\\.\\pipe\\${U}-${R}-${L}-sock`;const N=R.substr(0,4),z=L.substr(0,6);let ne;return process.platform!=="darwin"&&e.$wi&&!process.env.VSCODE_PORTABLE?ne=(0,h.$lc)(e.$wi,`vscode-${U}-${N}-${z}.sock`):ne=(0,h.$lc)(T,`${N}-${z}.sock`),d(ne),ne}function d(T){const L=c[f.$u];typeof L=="number"&&T.length>=L&&console.warn(`WARNING: IPC handle "${T}" is longer than ${L} chars, try a shorter --user-data-dir`)}class I extends b.$ji{static b(L){const R=y.Event.fromNodeEventEmitter(L,"connection");return y.Event.map(R,M=>({protocol:new l.$qi(new p(M,"ipc-server-connection")),onDidClientDisconnect:y.Event.once(y.Event.fromNodeEventEmitter(M,"close"))}))}constructor(L){super(I.b(L)),this.d=L}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.$zi=I;function E(T){return new Promise((L,R)=>{const M=(0,o.createServer)();M.on("error",R),M.listen(T,()=>{M.removeListener("error",R),L(new I(M))})})}function A(T,L){return new Promise((R,M)=>{const U=(0,o.createConnection)(T,()=>{U.removeListener("error",M),R(l.$ri.fromSocket(new p(U,`ipc-client${L}`),L))});U.once("error",M)})}}),define(oe[25],ae([0,1,52,9,4,105,38,95,6]),function(V,e,i,o,S,D,O,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lec=e.$kec=void 0,e.$kec=(0,y.$Gi)(O.$Mi);class a extends P.$8m{constructor(){super(...arguments),this.d={}}get cachedLanguagesPath(){return(0,o.$lc)(this.userDataPath,"clp")}get backupHome(){return(0,o.$lc)(this.userDataPath,"Backups")}get mainIPCHandle(){return(0,D.$yi)(this.userDataPath,"main",this.c.version)}get mainLockfile(){return(0,o.$lc)(this.userDataPath,"code.lock")}get disableUpdates(){return!!this.args["disable-updates"]}get crossOriginIsolated(){return!!this.args["enable-coi"]}get codeCachePath(){return process.env.VSCODE_CODE_CACHE_PATH||void 0}get useCodeCache(){return!!this.codeCachePath}unsetSnapExportedVariables(){if(S.$k){for(const f in process.env)if(f.endsWith("_VSCODE_SNAP_ORIG")){const g=f.slice(0,-17);if(this.d[g])continue;process.env[g]&&(this.d[g]=process.env[g]),process.env[f]?process.env[g]=process.env[f]:delete process.env[g]}}}restoreSnapExportedVariables(){if(S.$k)for(const f in this.d)process.env[f]=this.d[f],delete this.d[f]}}e.$lec=a,Se([i.$0h],a.prototype,"cachedLanguagesPath",null),Se([i.$0h],a.prototype,"backupHome",null),Se([i.$0h],a.prototype,"mainIPCHandle",null),Se([i.$0h],a.prototype,"mainLockfile",null),Se([i.$0h],a.prototype,"disableUpdates",null),Se([i.$0h],a.prototype,"crossOriginIsolated",null),Se([i.$0h],a.prototype,"codeCachePath",null),Se([i.$0h],a.prototype,"useCodeCache",null)}),define(oe[289],ae([0,1,91,31,13,9,4,19,21,202,18,25,34,15,5,201,30,104]),function(V,e,i,o,S,D,O,P,y,a,h,f,g,b,l,m,p,$){"use strict";var w;Object.defineProperty(e,"__esModule",{value:!0}),e.$Zec=void 0;let v=class{static{w=this}static{this.a="backupWorkspaces"}constructor(t,r,n,c){this.j=t,this.k=r,this.l=n,this.m=c,this.c=this.j.backupHome,this.d=[],this.e=[],this.g=[],this.h=P.$0g,this.i={isEqual:(s,u)=>(0,o.$Dg)(s,u,!O.$k)}}async initialize(){const t=this.m.getItem(w.a)??{workspaces:[],folders:[],emptyWindows:[]};this.g=await this.w(t.emptyWindows),this.d=await this.u((0,a.$nec)(t)),this.e=await this.v((0,a.$oec)(t)),this.C()}n(){return this.q()?[]:this.d.slice(0)}o(){return this.q()?[]:this.e.slice(0)}isHotExitEnabled(){return this.s()!==b.$yl.OFF}q(){return this.s()===b.$yl.ON_EXIT_AND_WINDOW_CLOSE}s(){return this.k.getValue()?.files?.hotExit||b.$yl.ON_EXIT}getEmptyWindowBackups(){return this.g.slice(0)}registerWorkspaceBackup(t,r){this.d.some(c=>t.workspace.id===c.workspace.id)||(this.d.push(t),this.C());const n=(0,D.$lc)(this.c,t.workspace.id);return r?this.t(n,r).then(()=>n):n}async t(t,r){if(await y.Promises.exists(t)&&await this.z(t),await y.Promises.exists(r))try{await y.Promises.rename(r,t,!1)}catch(n){this.l.error(`Backup: Could not move backup folder to new location: ${n.toString()}`)}}registerFolderBackup(t){return this.e.some(r=>this.h.isEqual(t.folderUri,r.folderUri))||(this.e.push(t),this.C()),(0,D.$lc)(this.c,this.D(t))}registerEmptyWindowBackup(t){return this.g.some(r=>!!r.backupFolder&&this.i.isEqual(r.backupFolder,t.backupFolder))||(this.g.push(t),this.C()),(0,D.$lc)(this.c,t.backupFolder)}async u(t){if(!Array.isArray(t))return[];const r=new Set,n=[];for(const c of t){const s=c.workspace;if(!(0,p.$Ui)(s))return[];if(!r.has(s.id)){r.add(s.id);const u=(0,D.$lc)(this.c,s.id);await this.B(u)?s.configPath.scheme!==S.Schemas.file||await y.Promises.exists(s.configPath.fsPath)?n.push(c):await this.z(u):await this.x(u)}}return n}async v(t){if(!Array.isArray(t))return[];const r=[],n=new Set;for(const c of t){const s=c.folderUri,u=this.h.getComparisonKey(s);if(!n.has(u)){n.add(u);const d=(0,D.$lc)(this.c,this.D(c));await this.B(d)?s.scheme!==S.Schemas.file||await y.Promises.exists(s.fsPath)?r.push(c):await this.z(d):await this.x(d)}}return r}async w(t){if(!Array.isArray(t))return[];const r=[],n=new Set;for(const c of t){const s=c.backupFolder;if(typeof s!="string")return[];if(!n.has(s)){n.add(s);const u=(0,D.$lc)(this.c,s);await this.B(u)?r.push(c):await this.x(u)}}return r}async x(t){try{await y.Promises.rm(t,y.RimRafMode.MOVE)}catch(r){this.l.error(`Backup: Could not delete stale backup: ${r.toString()}`)}}y(){let t=(0,$.$Gec)();for(;this.g.some(r=>!!r.backupFolder&&this.i.isEqual(r.backupFolder,t.id));)t=(0,$.$Gec)();return{backupFolder:t.id}}async z(t){const r=this.y(),n=(0,D.$lc)(this.c,r.backupFolder);try{await y.Promises.rename(t,n,!1)}catch(c){return this.l.error(`Backup: Could not rename backup folder: ${c.toString()}`),!1}return this.g.push(r),!0}async getDirtyWorkspaces(){const t=[];for(const r of this.d)await this.A(r)&&t.push(r);for(const r of this.e)await this.A(r)&&t.push(r);return t}A(t){let r;return(0,a.$mec)(t)?r=(0,D.$lc)(this.c,t.backupFolder):(0,m.$Dhb)(t)?r=(0,D.$lc)(this.c,this.D(t)):r=(0,D.$lc)(this.c,t.workspace.id),this.B(r)}async B(t){try{const r=await y.Promises.readdir(t);for(const n of r)try{if((await y.Promises.readdir((0,D.$lc)(t,n))).length>0)return!0}catch{}}catch{}return!1}C(){const t={workspaces:this.d.map(({workspace:r,remoteAuthority:n})=>{const c={id:r.id,configURIPath:r.configPath.toString()};return n&&(c.remoteAuthority=n),c}),folders:this.e.map(({folderUri:r,remoteAuthority:n})=>{const c={folderUri:r.toString()};return n&&(c.remoteAuthority=n),c}),emptyWindows:this.g.map(({backupFolder:r,remoteAuthority:n})=>{const c={backupFolder:r};return n&&(c.remoteAuthority=n),c})};this.m.setItem(w.a,t)}D(t){const r=t.folderUri;let n;return r.scheme===S.Schemas.file?n=O.$k?r.fsPath:r.fsPath.toLowerCase():n=r.toString().toLowerCase(),(0,i.createHash)("md5").update(n).digest("hex")}};e.$Zec=v,e.$Zec=v=w=Se([re(0,f.$kec),re(1,h.$_i),re(2,l.$_j),re(3,g.$dR)],v)}),define(oe[20],ae([0,1,14,37,8,3,2,4,36,12,6,5,34,51,25]),function(V,e,i,o,S,D,O,P,y,a,h,f,g,b,l){"use strict";var m;Object.defineProperty(e,"__esModule",{value:!0}),e.$Pec=e.LifecycleMainPhase=e.ShutdownReason=e.$Oec=void 0,e.$Oec=(0,h.$Fi)("lifecycleMainService");var p;(function(v){v[v.QUIT=1]="QUIT",v[v.KILL=2]="KILL"})(p||(e.ShutdownReason=p={}));var $;(function(v){v[v.Starting=1]="Starting",v[v.Ready=2]="Ready",v[v.AfterWindowOpen=3]="AfterWindowOpen",v[v.Eventually=4]="Eventually"})($||(e.LifecycleMainPhase=$={}));let w=class extends O.$Wc{static{m=this}static{this.b="lifecycle.quitAndRestart"}get quitRequested(){return this.j}get wasRestarted(){return this.m}get phase(){return this.n}constructor(k,t,r){super(),this.F=k,this.G=t,this.H=r,this.c=this.B(new D.$me),this.onBeforeShutdown=this.c.event,this.f=this.B(new D.$me),this.onWillShutdown=this.f.event,this.g=this.B(new D.$me),this.onWillLoadWindow=this.g.event,this.h=this.B(new D.$me),this.onBeforeCloseWindow=this.h.event,this.j=!1,this.m=!1,this.n=$.Starting,this.r=new Set,this.s=0,this.t=0,this.u=void 0,this.w=void 0,this.y=void 0,this.z=new Map,this.C=new Map,this.D=void 0,this.I(),this.when($.Ready).then(()=>this.J())}I(){this.m=!!this.G.getItem(m.b),this.m&&this.G.removeItem(m.b)}J(){const k=()=>{this.j||(this.S("Lifecycle#app.on(before-quit)"),this.j=!0,this.S("Lifecycle#onBeforeShutdown.fire()"),this.c.fire(),P.$j&&this.t===0&&this.L(p.QUIT))};i.app.addListener("before-quit",k);const t=()=>{this.S("Lifecycle#app.on(window-all-closed)"),(this.j||!P.$j)&&i.app.quit()};i.app.addListener("window-all-closed",t),i.app.once("will-quit",r=>{this.S("Lifecycle#app.on(will-quit) - begin"),r.preventDefault(),this.L(p.QUIT).finally(()=>{this.S("Lifecycle#app.on(will-quit) - after fireOnWillShutdown"),this.O(!1),i.app.removeListener("before-quit",k),i.app.removeListener("window-all-closed",t),this.S("Lifecycle#app.on(will-quit) - calling app.quit()"),i.app.quit()})})}L(k){if(this.y)return this.y;const t=this.F;this.S("Lifecycle#onWillShutdown.fire()");const r=[];return this.f.fire({reason:k,join(n,c){t.trace(`Lifecycle#onWillShutdown - begin '${n}'`),r.push(c.finally(()=>{t.trace(`Lifecycle#onWillShutdown - end '${n}'`)}))}}),this.y=(async()=>{try{await S.Promises.settled(r)}catch(n){this.F.error(n)}try{await this.G.close()}catch(n){this.F.error(n)}})(),this.y}set phase(k){if(k<this.phase)throw new Error("Lifecycle cannot go backwards");if(this.n===k)return;this.S(`lifecycle (main): phase changed (value: ${k})`),this.n=k;const t=this.C.get(this.n);t&&(t.open(),this.C.delete(this.n))}async when(k){if(k<=this.n)return;let t=this.C.get(k);t||(t=new S.$Eh,this.C.set(k,t)),await t.wait()}registerWindow(k){const t=new O.$Vc;this.t++,t.add(k.onWillLoad(n=>this.g.fire({window:k,workspace:n.workspace,reason:n.reason})));const r=(0,a.$qg)(k.win);t.add(D.Event.fromNodeEventEmitter(r,"close")(n=>{const c=k.id;if(this.r.has(c)){this.r.delete(c);return}this.S(`Lifecycle#window.on('close') - window ID ${k.id}`),n.preventDefault(),this.unload(k,b.UnloadReason.CLOSE).then(s=>{if(s){this.r.delete(c);return}this.r.add(c),this.S(`Lifecycle#onBeforeCloseWindow.fire() - window ID ${c}`),this.h.fire(k),k.close()})})),t.add(D.Event.fromNodeEventEmitter(r,"closed")(()=>{this.S(`Lifecycle#window.on('closed') - window ID ${k.id}`),this.t--,t.dispose(),this.t===0&&(!P.$j||this.j)&&this.L(p.QUIT)}))}registerAuxWindow(k){const t=(0,a.$qg)(k.win),r=new O.$Vc;r.add(D.Event.fromNodeEventEmitter(t,"close")(n=>{this.S(`Lifecycle#auxWindow.on('close') - window ID ${k.id}`),this.j&&(this.S("Lifecycle#auxWindow.on('close') - preventDefault() because quit requested"),n.preventDefault())})),r.add(D.Event.fromNodeEventEmitter(t,"closed")(()=>{this.S(`Lifecycle#auxWindow.on('closed') - window ID ${k.id}`),r.dispose()}))}async reload(k,t){await this.unload(k,b.UnloadReason.RELOAD)||k.reload(t)}unload(k,t){const r=this.z.get(k.id);if(r)return r;const n=this.M(k,t).finally(()=>{this.z.delete(k.id)});return this.z.set(k.id,n),n}async M(k,t){if(!k.isReady)return!1;this.S(`Lifecycle#unload() - window ID ${k.id}`);const r=this.j?b.UnloadReason.QUIT:t,n=await this.P(k,r);return n?(this.S(`Lifecycle#unload() - veto in renderer (window ID ${k.id})`),this.N(n)):(await this.Q(k,r),!1)}N(k){return k?(this.O(!0),this.j=!1,!0):!1}O(k){this.w&&(this.w(k),this.w=void 0,this.u=void 0)}P(k,t){return new Promise(r=>{const n=this.s++,c=`vscode:ok${n}`,s=`vscode:cancel${n}`;o.$BX.once(c,()=>{r(!1)}),o.$BX.once(s,()=>{r(!0)}),k.send("vscode:onBeforeUnload",{okChannel:c,cancelChannel:s,reason:t})})}Q(k,t){return new Promise(r=>{const c=`vscode:reply${this.s++}`;o.$BX.once(c,()=>r()),k.send("vscode:onWillUnload",{replyChannel:c,reason:t})})}quit(k){return this.R(k).then(t=>{if(!t&&k)try{if(P.$i){const r=(0,y.cwd)();r!==process.cwd()&&process.chdir(r)}}catch(r){this.F.error(r)}return t})}R(k){return this.S(`Lifecycle#quit() - begin (willRestart: ${k})`),this.u?(this.S("Lifecycle#quit() - returning pending quit promise"),this.u):(k&&this.G.setItem(m.b,!0),this.u=new Promise(t=>{this.w=t,this.S("Lifecycle#quit() - calling app.quit()"),i.app.quit()}),this.u)}S(k){this.H.args["enable-smoke-test-driver"]?this.F.info(k):this.F.trace(k)}setRelaunchHandler(k){this.D=k}async relaunch(k){this.S("Lifecycle#relaunch()");const t=process.argv.slice(1);if(k?.addArgs&&t.push(...k.addArgs),k?.removeArgs)for(const c of k.removeArgs){const s=t.indexOf(c);s>=0&&t.splice(s,1)}const r=()=>{this.D?.handleRelaunch(k)||(this.S("Lifecycle#relaunch() - calling app.relaunch()"),i.app.relaunch({args:t}))};i.app.once("quit",r),await this.quit(!0)&&i.app.removeListener("quit",r)}async kill(k){this.S("Lifecycle#kill()"),await this.L(p.KILL),await Promise.race([(0,S.$Gh)(1e3),(async()=>{for(const t of i.BrowserWindow.getAllWindows())if(t&&!t.isDestroyed()){let r;t.webContents&&!t.webContents.isDestroyed()?r=new Promise(n=>t.once("closed",n)):r=Promise.resolve(),t.destroy(),await r}})()]),i.app.exit(k)}};e.$Pec=w,e.$Pec=w=m=Se([re(0,f.$_j),re(1,g.$dR),re(2,l.$kec)],w)}),define(oe[290],ae([0,1,4,3,2,6,20]),function(V,e,i,o,S,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lfc=e.$kfc=void 0,i=Re(i),e.$kfc=(0,D.$Fi)("keyboardLayoutMainService");let P=class extends S.$Wc{constructor(h){super(),this.a=this.B(new o.$me),this.onDidChangeKeyboardLayout=this.a.event,this.b=null,this.c=null,h.when(O.LifecycleMainPhase.AfterWindowOpen).then(()=>this.f())}f(){return this.b||(this.b=this.g()),this.b}async g(){const h=await new Promise((f,g)=>{V(["native-keymap"],f,g)}).then(Re);this.c=y(h),i.$t||h.onDidChangeKeyboardLayout(()=>{this.c=y(h),this.a.fire(this.c)})}async getKeyboardLayoutData(){return await this.f(),this.c}};e.$lfc=P,e.$lfc=P=Se([re(0,O.$Oec)],P);function y(a){const h=a.getKeyMap(),f=a.getCurrentKeyboardLayout();return{keyboardMapping:h,keyboardLayoutInfo:f}}}),define(oe[291],ae([0,1,251,8,17,16,12,18,38,101,5,55,250,288]),function(V,e,i,o,S,D,O,P,y,a,h,f,g,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$r=void 0,e.$_r=p;let l=class extends f.$2p{constructor(w,v,k,t){super(t),this.m=w,this.n=v,this.r=k,this.s(),this.B(w.onDidChangeConfiguration(r=>{r.affectsConfiguration("http")&&this.s()}))}s(){const w=this.m.getValue("http");this.f=w?.proxy,this.g=!!w?.proxyStrictSSL,this.h=w?.proxyAuthorization}async request(w,v){const{f:k,g:t}=this;let r;try{r=await(0,a.$Qm)(this.m,this.r,this.n.args,process.env)}catch(s){this.j||(this.j=!0,this.r.error("resolving shell environment failed",(0,D.$_)(s)))}const n={...process.env,...r},c=w.agent?w.agent:await(0,g.$0r)(w.url||"",n,{proxyUrl:k,strictSSL:t});return w.agent=c,w.strictSSL=t,this.h&&(w.headers={...w.headers||{},"Proxy-Authorization":this.h}),this.c(w.isChromiumNetwork?"electron":"node",w,()=>p(w,v))}async resolveProxy(w){}async loadCertificates(){return(await new Promise((v,k)=>{V(["@vscode/proxy-agent"],v,k)}).then(Re)).loadSystemCertificates({log:this.r})}};e.$$r=l,e.$$r=l=Se([re(0,P.$_i),re(1,y.$Ni),re(2,h.$_j),re(3,h.$ak)],l);async function m($){return((0,i.parse)($.url).protocol==="https:"?await new Promise((k,t)=>{V(["https"],k,t)}).then(Re):await new Promise((k,t)=>{V(["http"],k,t)}).then(Re)).request}async function p($,w){return o.Promises.withAsyncBody(async(v,k)=>{const t=(0,i.parse)($.url),r=$.getRawRequest?$.getRawRequest($):await m($),n={hostname:t.hostname,port:t.port?parseInt(t.port):t.protocol==="https:"?443:80,protocol:t.protocol,path:t.path,method:$.type||"GET",headers:$.headers,agent:$.agent,rejectUnauthorized:(0,O.$lg)($.strictSSL)?$.strictSSL:!0};$.user&&$.password&&(n.auth=$.user+":"+$.password);const c=r(n,s=>{const u=(0,O.$jg)($.followRedirects)?$.followRedirects:3;if(s.statusCode&&s.statusCode>=300&&s.statusCode<400&&u>0&&s.headers.location)p({...$,url:s.headers.location,followRedirects:u-1},w).then(v,k);else{let d=s;!$.isChromiumNetwork&&s.headers["content-encoding"]==="gzip"&&(d=s.pipe((0,b.createGunzip)())),v({res:s,stream:(0,S.$4e)(d)})}});c.on("error",k),$.timeout&&c.setTimeout($.timeout),$.isChromiumNetwork&&c.removeHeader("Content-Length"),$.data&&typeof $.data=="string"&&c.write($.data),c.end(),w.onCancellationRequested(()=>{c.abort(),k(new D.$7)})})}}),define(oe[292],ae([0,1,14,291]),function(V,e,i,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pgc=void 0;function S(O){return i.net.request}class D extends o.$$r{request(P,y){return super.request({...P||{},getRawRequest:S,isChromiumNetwork:!0},y)}}e.$pgc=D}),define(oe[87],ae([0,1,7,3,2,38,15,6,20,5,63,285,42,59,41,13]),function(V,e,i,o,S,D,O,P,y,a,h,f,g,b,l,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xec=e.$Wec=e.$Vec=e.$Uec=void 0,e.$Uec=(0,P.$Fi)("storageMainService");let p=class extends S.$Wc{constructor(v,k,t,r,n,c){super(),this.c=v,this.f=k,this.g=t,this.h=r,this.j=n,this.m=c,this.a=void 0,this.b=this.B(new o.$me),this.onDidChangeProfileStorage=this.b.event,this.applicationStorage=this.B(this.s()),this.t=new Map,this.w=new Map,this.r()}n(){return{useInMemoryStorage:!!this.f.extensionTestsLocationURI}}r(){(async()=>(await this.h.when(y.LifecycleMainPhase.AfterWindowOpen),this.applicationStorage.init()))(),this.B(this.h.onWillLoadWindow(v=>{v.window.profile&&this.profileStorage(v.window.profile).init(),v.workspace&&this.workspaceStorage(v.workspace).init()})),this.B(this.h.onWillShutdown(v=>{this.c.trace("storageMainService#onWillShutdown()"),this.a=v.reason,v.join("applicationStorage",this.applicationStorage.close());for(const[,k]of this.t)v.join("profileStorage",k.close());for(const[,k]of this.w)v.join("workspaceStorage",k.close())})),this.B(this.g.onWillCreateProfile(v=>{v.join((async()=>{await this.j.exists(v.profile.globalStorageHome)||await this.j.createFolder(v.profile.globalStorageHome)})())})),this.B(this.g.onWillRemoveProfile(v=>{const k=this.t.get(v.profile.id);k&&v.join(k.close())}))}s(){this.c.trace("StorageMainService: creating application storage");const v=new f.$Rec(this.n(),this.g,this.c,this.j);return this.B(o.Event.once(v.onDidCloseStorage)(()=>{this.c.trace("StorageMainService: closed application storage")})),v}profileStorage(v){if((0,h.$eq)(v))return this.applicationStorage;let k=this.t.get(v.id);if(!k){this.c.trace(`StorageMainService: creating profile storage (${v.name})`),k=this.B(this.u(v)),this.t.set(v.id,k);const t=this.B(k.onDidChangeStorage(r=>this.b.fire({...r,storage:k,profile:v})));this.B(o.Event.once(k.onDidCloseStorage)(()=>{this.c.trace(`StorageMainService: closed profile storage (${v.name})`),this.t.delete(v.id),t.dispose()}))}return k}u(v){return this.a===y.ShutdownReason.KILL?new f.$Tec(this.c,this.j):new f.$Qec(v,this.n(),this.c,this.j)}workspaceStorage(v){let k=this.w.get(v.id);return k||(this.c.trace(`StorageMainService: creating workspace storage (${v.id})`),k=this.B(this.y(v)),this.w.set(v.id,k),this.B(o.Event.once(k.onDidCloseStorage)(()=>{this.c.trace(`StorageMainService: closed workspace storage (${v.id})`),this.w.delete(v.id)}))),k}y(v){return this.a===y.ShutdownReason.KILL?new f.$Tec(this.c,this.j):new f.$Sec(v,this.n(),this.c,this.f,this.j)}isUsed(v){const k=i.URI.file(v);for(const t of[this.applicationStorage,...this.t.values(),...this.w.values()])if(t.path&&this.m.extUri.isEqualOrParent(i.URI.file(t.path),k))return!0;return!1}};e.$Vec=p,e.$Vec=p=Se([re(0,a.$_j),re(1,D.$Mi),re(2,b.$yec),re(3,y.$Oec),re(4,O.$_k),re(5,l.$Jl)],p),e.$Wec=(0,P.$Fi)("applicationStorageMainService");let $=class extends h.$dq{constructor(v,k){super(),this.s=v,this.U=k,this.whenReady=this.U.applicationStorage.whenInit}O(){return this.U.applicationStorage.whenInit}P(v){if(v===h.StorageScope.APPLICATION)return this.U.applicationStorage.storage}Q(v){if(v===h.StorageScope.APPLICATION)return this.s.defaultProfile.globalStorageHome.with({scheme:m.Schemas.file}).fsPath}r(){return!1}switch(){throw new Error("Migrating storage is unsupported from main process")}R(){throw new Error("Switching storage profile is unsupported from main process")}S(){throw new Error("Switching storage workspace is unsupported from main process")}hasScope(){throw new Error("Main process is never profile or workspace scoped")}};e.$Xec=$,e.$Xec=$=Se([re(0,g.$Ll),re(1,e.$Uec)],$)}),define(oe[293],ae([0,1,92,27,112,105,8,2,4,18,5,28,246,247,102,132,17]),function(V,e,i,o,S,D,O,P,y,a,h,f,g,b,l,m,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ogc=e.$ngc=e.$mgc=e.$lgc=void 0,i=Re(i),o=Re(o);async function $(r,n,c,s,u){let d;for(let I=3;I&&(d?.dispose(),d=await new w(r,n,c,s,u).waitForReady(),!(u&&S.$5g[u]||!S.$5g[d.tunnelLocalPort]));I--);return d}class w extends P.$Wc{constructor(n,c,s,u,d){super(),this.m=c,this.n=d,this.privacy=m.TunnelPrivacyId.Private,this.j=new Map,this.a=n,this.b=i.createServer(),this.c=new O.$Eh,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=I=>this.r(I),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=u,this.tunnelRemoteHost=s}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.j.values()).forEach(c=>{c()})}async waitForReady(){const n=this.n??this.tunnelRemotePort,c=(0,m.$Ew)(this.m)?"0.0.0.0":"127.0.0.1";let s=await(0,S.$6g)(n,2,1e3,c),u=null;return this.b.listen(s,this.m),await this.c.wait(),u=this.b.address(),u||(s=0,this.b.listen(s,this.m),await this.c.wait(),u=this.b.address()),this.tunnelLocalPort=u.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${u.port}`,this}async r(n){n.pause();const c=(0,m.$Cw)(this.tunnelRemoteHost)||(0,m.$Ew)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,s=await(0,g.$2l)(this.a,c,this.tunnelRemotePort),u=s.getSocket(),d=s.readEntireBuffer();s.dispose(),d.byteLength>0&&n.write(d.buffer),n.on("end",()=>{n.localAddress&&this.j.delete(n.localAddress),u.end()}),n.on("close",()=>u.end()),n.on("error",()=>{n.localAddress&&this.j.delete(n.localAddress),u instanceof D.$ui?u.socket.destroy():u.end()}),u instanceof D.$ui?this.t(n,u):this.s(n,u),n.localAddress&&this.j.set(n.localAddress,()=>{n.end(),u.end()})}s(n,c){c.onClose(()=>n.destroy()),c.onEnd(()=>n.end()),c.onData(s=>n.write(s.buffer)),n.on("data",s=>c.write(p.$Oe.wrap(s))),n.resume()}t(n,c){const s=c.socket;s.on("end",()=>n.end()),s.on("close",()=>n.end()),s.on("error",()=>{n.destroy()}),s.pipe(n),n.pipe(s)}}e.$lgc=w;let v=class extends m.$Hw{constructor(n,c,s,u,d){super(c,d),this.H=n,this.I=s,this.J=u}isPortPrivileged(n){return(0,m.$Fw)(n,this.t,y.OS,o.release())}F(n,c,s,u,d,I,E,A){const T=this.D(c,s);if(T)return++T.refcount,T.value;if((0,m.$yw)(n))return this.G(n,c,s,d,I,E,A);{this.r.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${c}:${s} on local port ${d}.`);const L={commit:this.J.commit,quality:this.J.quality,addressProvider:n,remoteSocketFactoryService:this.H,signService:this.I,logService:this.r,ipcLogger:null},R=$(L,u,c,s,d);return this.r.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.z(c,s,R),R}}};e.$mgc=v,e.$mgc=v=Se([re(0,b.$Vl),re(1,h.$_j),re(2,l.$Yl),re(3,f.$sk),re(4,a.$_i)],v);let k=class extends v{constructor(n,c,s,u,d){super(n,c,s,u,d)}};e.$ngc=k,e.$ngc=k=Se([re(0,b.$Vl),re(1,h.$_j),re(2,l.$Yl),re(3,f.$sk),re(4,a.$_i)],k);let t=class extends P.$Wc{constructor(n,c,s,u,d){super(),this.b=n,this.c=c,this.f=s,this.g=u,this.h=d,this.a=new Map}async openTunnel(n,c,s,u,d,I,E,A,T){if(this.c.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${s}:${u} on local port ${I}.`),!this.a.has(n)){const L=new k(this.b,this.c,this.g,this.f,this.h);this.B(L),this.a.set(n,L),L.onTunnelClosed(async()=>{(await L.tunnels).length===0&&(L.dispose(),this.a.delete(n))})}return this.a.get(n).openTunnel(c,s,u,d,I,E,A,T)}};e.$ogc=t,e.$ogc=t=Se([re(0,b.$Vl),re(1,h.$_j),re(2,f.$sk),re(3,l.$Yl),re(4,a.$_i)],t)}),define(oe[106],ae([0,1,8,23,3,18,25,20,5,28,55,50]),function(V,e,i,o,S,D,O,P,y,a,h,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ifc=void 0,e.$Hfc=g;function g(l,m,p){return`${p.updateUrl}/api/update/${l}/${m}/${p.commit}`}let b=class{get state(){return this.b}d(m){this.j.info("update#setState",m.type),this.b=m,this.c.fire(m)}constructor(m,p,$,w,v,k){this.f=m,this.g=p,this.h=$,this.i=w,this.j=v,this.k=k,this.b=f.$zY.Uninitialized,this.c=new S.$me,this.onStateChange=this.c.event,m.when(P.LifecycleMainPhase.AfterWindowOpen).finally(()=>this.l())}async l(){if(!this.h.isBuilt){this.d(f.$zY.Disabled(f.DisablementReason.NotBuilt));return}if(this.h.disableUpdates){this.d(f.$zY.Disabled(f.DisablementReason.DisabledByEnvironment)),this.j.info("update#ctor - updates are disabled by the environment");return}if(!this.k.updateUrl||!this.k.commit){this.d(f.$zY.Disabled(f.DisablementReason.MissingConfiguration)),this.j.info("update#ctor - updates are disabled as there is no update URL");return}const m=this.g.getValue("update.mode"),p=this.m(m);if(!p){this.d(f.$zY.Disabled(f.DisablementReason.ManuallyDisabled)),this.j.info("update#ctor - updates are disabled by user preference");return}if(this.a=this.s(p),!this.a){this.d(f.$zY.Disabled(f.DisablementReason.InvalidConfiguration)),this.j.info("update#ctor - updates are disabled as the update URL is badly formed");return}if(this.g.getValue("_update.prss")){const $=new URL(this.a);$.searchParams.set("prss","true"),this.a=$.toString()}if(this.d(f.$zY.Idle(this.q())),m==="manual"){this.j.info("update#ctor - manual checks only; automatic updates are disabled by user preference");return}m==="start"?(this.j.info("update#ctor - startup checks only; automatic updates are disabled by user preference"),setTimeout(()=>this.checkForUpdates(!1),30*1e3)):this.n(30*1e3).then(void 0,$=>this.j.error($))}m(m){return m==="none"?void 0:this.k.quality}n(m=60*60*1e3){return(0,i.$Gh)(m).then(()=>this.checkForUpdates(!1)).then(()=>this.n(60*60*1e3))}async checkForUpdates(m){this.j.trace("update#checkForUpdates, state = ",this.state.type),this.state.type===f.StateType.Idle&&this.t(m)}async downloadUpdate(){this.j.trace("update#downloadUpdate, state = ",this.state.type),this.state.type===f.StateType.AvailableForDownload&&await this.o(this.state)}async o(m){}async applyUpdate(){this.j.trace("update#applyUpdate, state = ",this.state.type),this.state.type===f.StateType.Downloaded&&await this.p()}async p(){}quitAndInstall(){return this.j.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!==f.StateType.Ready||(this.j.trace("update#quitAndInstall(): before lifecycle quit()"),this.f.quit(!0).then(m=>{this.j.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${m}`),!m&&(this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.r())})),Promise.resolve(void 0)}async isLatestVersion(){if(!this.a)return;if(this.g.getValue("update.mode")==="none")return!1;try{return(await this.i.request({url:this.a},o.CancellationToken.None)).res.statusCode===204}catch(p){this.j.error("update#isLatestVersion(): failed to check for updates"),this.j.error(p);return}}async _applySpecificUpdate(m){}q(){return f.UpdateType.Archive}r(){}};e.$Ifc=b,e.$Ifc=b=Se([re(0,P.$Oec),re(1,D.$_i),re(2,O.$kec),re(3,h.$1p),re(4,y.$_j),re(5,a.$sk)],b)}),define(oe[294],ae([0,1,14,52,3,46,2,18,25,20,5,28,55,24,50,106]),function(V,e,i,o,S,D,O,P,y,a,h,f,g,b,l,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jfc=void 0,i=Re(i);let p=class extends m.$Ifc{get v(){return S.Event.fromNodeEventEmitter(i.autoUpdater,"error",(w,v)=>v)}get w(){return S.Event.fromNodeEventEmitter(i.autoUpdater,"update-not-available")}get x(){return S.Event.fromNodeEventEmitter(i.autoUpdater,"update-available")}get y(){return S.Event.fromNodeEventEmitter(i.autoUpdater,"update-downloaded",(w,v,k,t)=>({version:k,productVersion:k,timestamp:t}))}constructor(w,v,k,t,r,n,c){super(w,v,t,r,n,c),this.z=k,this.u=new O.$Vc,w.setRelaunchHandler(this)}handleRelaunch(w){return w?.addArgs||w?.removeArgs||this.state.type!==l.StateType.Ready?!1:(this.j.trace("update#handleRelaunch(): running raw#quitAndInstall()"),this.r(),!0)}async l(){await super.l(),this.v(this.B,this,this.u),this.x(this.E,this,this.u),this.y(this.F,this,this.u),this.w(this.G,this,this.u)}B(w){this.z.publicLog2("update:error",{messageHash:String((0,D.$tj)(String(w)))}),this.j.error("UpdateService error:",w);const v=this.state.type===l.StateType.CheckingForUpdates&&this.state.explicit?w:void 0;this.d(l.$zY.Idle(l.UpdateType.Archive,v))}s(w){let v;this.k.darwinUniversalAssetId?v=this.k.darwinUniversalAssetId:v=process.arch==="x64"?"darwin":"darwin-arm64";const k=(0,m.$Hfc)(v,w,this.k);try{i.autoUpdater.setFeedURL({url:k})}catch(t){this.j.error("Failed to set update feed URL",t);return}return k}t(w){this.d(l.$zY.CheckingForUpdates(w)),i.autoUpdater.checkForUpdates()}E(){this.state.type===l.StateType.CheckingForUpdates&&this.d(l.$zY.Downloading)}F(w){this.state.type===l.StateType.Downloading&&(this.d(l.$zY.Downloaded(w)),this.z.publicLog2("update:downloaded",{version:w.version}),this.d(l.$zY.Ready(w)))}G(){this.state.type===l.StateType.CheckingForUpdates&&(this.z.publicLog2("update:notAvailable",{explicit:this.state.explicit}),this.d(l.$zY.Idle(l.UpdateType.Archive)))}r(){this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),i.autoUpdater.quitAndInstall()}dispose(){this.u.dispose()}};e.$Jfc=p,Se([o.$0h],p.prototype,"v",null),Se([o.$0h],p.prototype,"w",null),Se([o.$0h],p.prototype,"x",null),Se([o.$0h],p.prototype,"y",null),e.$Jfc=p=Se([re(0,a.$Oec),re(1,P.$_i),re(2,b.$$l),re(3,y.$kec),re(4,g.$1p),re(5,h.$_j),re(6,f.$sk)],p)}),define(oe[295],ae([0,1,49,47,8,3,9,25,20,5,24,50]),function(V,e,i,o,S,D,O,P,y,a,h,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lfc=void 0,O=Re(O);let g=class{get state(){return this.a}d(m){this.g.info("update#setState",m.type),this.a=m,this.b.fire(m)}constructor(m,p,$){if(this.f=m,this.g=$,this.a=f.$zY.Uninitialized,this.b=new D.$me,this.onStateChange=this.b.event,p.disableUpdates){this.g.info("update#ctor - updates are disabled");return}this.d(f.$zY.Idle(this.k())),this.h(30*1e3).then(void 0,w=>this.g.error(w))}h(m=60*60*1e3){return(0,S.$Gh)(m).then(()=>this.checkForUpdates(!1)).then(()=>this.h(60*60*1e3))}async checkForUpdates(m){this.g.trace("update#checkForUpdates, state = ",this.state.type),this.state.type===f.StateType.Idle&&this.m(m)}async downloadUpdate(){this.g.trace("update#downloadUpdate, state = ",this.state.type),this.state.type===f.StateType.AvailableForDownload&&await this.i(this.state)}i(m){return Promise.resolve(void 0)}async applyUpdate(){this.g.trace("update#applyUpdate, state = ",this.state.type),this.state.type===f.StateType.Downloaded&&await this.j()}j(){return Promise.resolve(void 0)}quitAndInstall(){return this.g.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!==f.StateType.Ready||(this.g.trace("update#quitAndInstall(): before lifecycle quit()"),this.f.quit(!0).then(m=>{this.g.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${m}`),!m&&(this.g.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.l())})),Promise.resolve(void 0)}k(){return f.UpdateType.Snap}l(){}async _applySpecificUpdate(m){}};g=Se([re(0,y.$Oec),re(1,P.$kec),re(2,a.$_j)],g);let b=class extends g{constructor(m,p,$,w,v,k){super($,w,v),this.o=m,this.p=p,this.q=k;const t=(0,o.watch)(O.$oc(this.o)),r=D.Event.fromNodeEventEmitter(t,"change",(u,d)=>d),n=D.Event.filter(r,u=>u==="current"),s=D.Event.debounce(n,(u,d)=>d,2e3)(()=>this.checkForUpdates(!1));$.onWillShutdown(()=>{s.dispose(),t.close()})}m(){this.d(f.$zY.CheckingForUpdates(!1)),this.u().then(m=>{m?this.d(f.$zY.Ready({version:"something"})):(this.q.publicLog2("update:notAvailable",{explicit:!1}),this.d(f.$zY.Idle(f.UpdateType.Snap)))},m=>{this.g.error(m),this.q.publicLog2("update:notAvailable",{explicit:!1}),this.d(f.$zY.Idle(f.UpdateType.Snap,m.message||m))})}l(){this.g.trace("update#quitAndInstall(): running raw#quitAndInstall()"),(0,i.spawn)("sleep 3 && "+O.$pc(process.argv[0]),{shell:!0,detached:!0,stdio:"ignore"})}async u(){const m=await new Promise(($,w)=>(0,o.realpath)(`${O.$oc(this.o)}/current`,(v,k)=>v?w(v):$(k))),p=O.$pc(m);return this.p!==p}isLatestVersion(){return this.u().then(void 0,m=>{this.g.error("update#checkForSnapUpdate(): Could not get realpath of application.")})}};e.$Lfc=b,e.$Lfc=b=Se([re(2,y.$Oec),re(3,P.$kec),re(4,a.$_j),re(5,h.$$l)],b)}),define(oe[29],ae([0,1,14,4,6,51,57,74,28,18,25,9,140]),function(V,e,i,o,S,D,O,P,y,a,h,f,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowStateValidator=e.OpenContext=e.$vec=void 0,e.$wec=l,e.$xec=m,e.$vec=(0,S.$Fi)("windowsMainService");var b;(function($){$[$.CLI=0]="CLI",$[$.DOCK=1]="DOCK",$[$.MENU=2]="MENU",$[$.DIALOG=3]="DIALOG",$[$.DESKTOP=4]="DESKTOP",$[$.API=5]="API"})(b||(e.OpenContext=b={}));function l($,w,v){const k=$.get(P.$tec),t=$.get(y.$sk),r=$.get(a.$_i),n=$.get(h.$kec),c=r.getValue("window"),s={backgroundColor:k.getBackgroundColor(),minWidth:O.$TD.WIDTH,minHeight:O.$TD.HEIGHT,title:t.nameLong,show:w.mode!==D.WindowMode.Maximized&&w.mode!==D.WindowMode.Fullscreen,x:w.x,y:w.y,width:w.width,height:w.height,webPreferences:{...v,enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,O.$6D)(w.zoomLevel??c?.zoomLevel),autoplayPolicy:"user-gesture-required",enableBlinkFeatures:"HighlightAPI",sandbox:!0},experimentalDarkMode:!0};if(o.$k?s.icon=(0,f.$lc)(n.appRoot,"resources/linux/code.png"):o.$i&&!n.isBuilt&&(s.icon=(0,f.$lc)(n.appRoot,"resources/win32/code_150x150.png")),o.$j&&(s.acceptFirstMouse=!0,c?.clickThroughInactive===!1&&(s.acceptFirstMouse=!1)),o.$j&&!(0,O.$5D)(r)&&(s.fullscreenable=!1),o.$j&&c?.nativeTabs===!0&&(s.tabbingIdentifier=t.nameShort),!(0,O.$1D)(r)&&(s.titleBarStyle="hidden",o.$j||(s.frame=!1),(0,O.$4D)(r))){const I=k.getWindowSplash()?.colorInfo.titleBarBackground??k.getBackgroundColor(),E=g.$gu.fromHex(I).isDarker()?"#FFFFFF":"#000000";s.titleBarOverlay={height:29,color:I,symbolColor:E}}return s}function m($){let w,v=Number.MIN_VALUE;for(const k of $)k.lastFocusTime>v&&(v=k.lastFocusTime,w=k);return w}var p;(function($){function w(k,t,r=i.screen.getAllDisplays()){if(k.trace(`window#validateWindowState: validating window state on ${r.length} display(s)`,t),typeof t.x!="number"||typeof t.y!="number"||typeof t.width!="number"||typeof t.height!="number"){k.trace("window#validateWindowState: unexpected type of state values");return}if(t.width<=0||t.height<=0){k.trace("window#validateWindowState: unexpected negative values");return}if(r.length===1){const s=v(r[0]);if(k.trace("window#validateWindowState: single monitor working area",s),s){let u=function(){!t||typeof t.x!="number"||typeof t.y!="number"||!s||(t.x<s.x&&(t.x=s.x),t.y<s.y&&(t.y=s.y))};u(),t.width>s.width&&(t.width=s.width),t.height>s.height&&(t.height=s.height),t.x>s.x+s.width-128&&(t.x=s.x+s.width-t.width),t.y>s.y+s.height-128&&(t.y=s.y+s.height-t.height),u()}return t}if(t.display&&t.mode===D.WindowMode.Fullscreen){const s=r.find(u=>u.id===t.display);if(s&&typeof s.bounds?.x=="number"&&typeof s.bounds?.y=="number"){k.trace("window#validateWindowState: restoring fullscreen to previous display");const u=(0,D.$iec)(D.WindowMode.Fullscreen);return u.x=s.bounds.x,u.y=s.bounds.y,u}}let n,c;try{n=i.screen.getDisplayMatching({x:t.x,y:t.y,width:t.width,height:t.height}),c=v(n),k.trace("window#validateWindowState: multi-monitor working area",c)}catch(s){k.error("window#validateWindowState: error finding display for window state",s)}if(n&&c&&t.x+t.width>c.x&&t.y+t.height>c.y&&t.x<c.x+c.width&&t.y<c.y+c.height)return t;k.trace("window#validateWindowState: state is outside of the multi-monitor working area")}$.validateWindowState=w;function v(k){if(k.workArea.width>0&&k.workArea.height>0)return k.workArea;if(k.bounds.width>0&&k.bounds.height>0)return k.bounds}})(p||(e.WindowStateValidator=p={}))}),define(oe[296],ae([0,1,14,23,3,46,2,33,97,5,63,87,29]),function(V,e,i,o,S,D,O,P,y,a,h,f,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yec=void 0;var b;(function(m){m[m.Initial=1]="Initial",m[m.StoredCredentialsUsed=2]="StoredCredentialsUsed",m[m.LoginDialogShown=3]="LoginDialogShown"})(b||(b={}));let l=class extends O.$Wc{constructor(p,$,w,v){super(),this.g=p,this.h=$,this.j=w,this.m=v,this.a="proxy-credentials://",this.b=void 0,this.c=b.Initial,this.f=void 0,this.n()}n(){const p=S.Event.fromNodeEventEmitter(i.app,"login",($,w,v,k,t)=>({event:$,webContents:w,req:v,authInfo:k,callback:t}));this.B(p(this.r,this))}async r({event:p,authInfo:$,req:w,callback:v}){if(!$.isProxy)return;if(!this.b&&this.c===b.LoginDialogShown&&w.firstAuthAttempt){this.g.trace("auth#onLogin (proxy) - exit - proxy dialog already shown");return}p.preventDefault();let k;if(this.b)this.g.trace("auth#onLogin (proxy) - pending proxy handling found"),k=await this.b;else{this.g.trace("auth#onLogin (proxy) - no pending proxy handling found, starting new"),this.b=this.s($);try{k=await this.b}finally{this.b=void 0}}v(k?.username,k?.password)}async s(p){this.g.trace("auth#resolveProxyCredentials (proxy) - enter");try{const $=await this.t(p);if($)return this.g.trace("auth#resolveProxyCredentials (proxy) - got credentials"),$;this.g.trace("auth#resolveProxyCredentials (proxy) - did not get credentials")}finally{this.g.trace("auth#resolveProxyCredentials (proxy) - exit")}}async t(p){this.g.trace("auth#doResolveProxyCredentials - enter",p);const $=String((0,D.$tj)({scheme:p.scheme,host:p.host,port:p.port}));let w,v;try{const n=this.m.get(this.a+$,h.StorageScope.APPLICATION);if(n){const c=JSON.parse(await this.j.decrypt(n));w=c.username,v=c.password}}catch(n){this.g.error(n)}if(this.c!==b.StoredCredentialsUsed&&typeof w=="string"&&typeof v=="string")return this.g.trace("auth#doResolveProxyCredentials (proxy) - exit - found stored credentials to use"),this.c=b.StoredCredentialsUsed,{username:w,password:v};const k=this.h.getFocusedWindow()||this.h.getLastActiveWindow();if(!k){this.g.trace("auth#doResolveProxyCredentials (proxy) - exit - no opened window found to show dialog in");return}this.g.trace(`auth#doResolveProxyCredentials (proxy) - asking window ${k.id} to handle proxy login`);const t={authInfo:p,username:this.f?.username??w,password:this.f?.password??v,replyChannel:`vscode:proxyAuthResponse:${(0,P.$2g)()}`};k.sendWhenReady("vscode:openProxyAuthenticationDialog",o.CancellationToken.None,t),this.c=b.LoginDialogShown;const r=await new Promise(n=>{const c=async(s,u,d)=>{if(u===t.replyChannel)if(this.g.trace(`auth#doResolveProxyCredentials - exit - received credentials from window ${k.id}`),k.win?.webContents.off("ipc-message",c),d){const I={username:d.username,password:d.password};try{if(d.remember){const E=await this.j.encrypt(JSON.stringify(I));this.m.store(this.a+$,E,h.StorageScope.APPLICATION,h.StorageTarget.MACHINE)}else this.m.remove(this.a+$,h.StorageScope.APPLICATION)}catch(E){this.g.error(E)}n({username:I.username,password:I.password})}else n(void 0)};k.win?.webContents.on("ipc-message",c)});return this.f=r,r}};e.$Yec=l,e.$Yec=l=Se([re(0,a.$_j),re(1,g.$vec),re(2,y.$kY),re(3,f.$Wec)],l)}),define(oe[297],ae([0,1,92,204,121,29]),function(V,e,i,o,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1ec=void 0;class O extends o.$Uo{constructor(y){super(),this.f=y}call(y,a,h){return a==="openExtensionDevelopmentHostWindow"?this.g(h[0],h[1]):super.call(y,a,h)}async g(y,a){const h=(0,S.$Cm)(y,S.$Bm);h.debugRenderer=a;const f=h.extensionDevelopmentPath;if(!f)return{success:!1};const[g]=await this.f.openExtensionDevelopmentHostWindow(f,{context:D.OpenContext.API,cli:h,forceProfile:h.profile,forceTempProfile:h["profile-temp"]});if(!a)return{success:!0};const b=g.win;if(!b)return{success:!0};const l=b.webContents.debugger;let m=l.isAttached()?1/0:0;const p=(0,i.createServer)($=>{m++===0&&l.attach();let w=!1;const v=r=>{w||$.write(JSON.stringify(r)+"\0")},k=(r,n,c,s)=>v({method:n,params:c,sessionId:s});b.on("close",()=>{l.removeListener("message",k),$.end(),w=!0}),l.addListener("message",k);let t=Buffer.alloc(0);$.on("data",r=>{t=Buffer.concat([t,r]);for(let n=t.indexOf(0);n!==-1;n=t.indexOf(0)){let c;try{const s=t.slice(0,n).toString("utf8");t=t.slice(n+1),c=JSON.parse(s)}catch(s){console.error("error reading cdp line",s)}l.sendCommand(c.method,c.params,c.sessionId).then(s=>v({id:c.id,sessionId:c.sessionId,result:s})).catch(s=>v({id:c.id,sessionId:c.sessionId,error:{code:0,message:s.message}}))}}),$.on("error",r=>{console.error("error on cdp pipe:",r)}),$.on("close",()=>{w=!0,--m===0&&l.detach()})});return await new Promise($=>p.listen(0,$)),b.on("close",()=>p.close()),{rendererDebugPort:p.address().port,success:!0}}}e.$1ec=O}),define(oe[298],ae([0,1,14,22,4,7,21,18,68,6,5,133,29]),function(V,e,i,o,S,D,O,P,y,a,h,f,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ofc=e.$nfc=e.ID=void 0,e.ID="launchMainService",e.$nfc=(0,a.$Fi)(e.ID);let b=class{constructor(m,p,$,w){this.a=m,this.b=p,this.c=$,this.d=w}async start(m,p){this.a.trace("Received data from other instance: ",m,p),S.$j&&i.app.focus({steal:!0});const $=this.e(m);if($.length){let w=Promise.resolve();if(this.b.getWindowCount()===0){const v=(0,o.$Qb)(await this.b.openEmptyWindow({context:g.OpenContext.DESKTOP}));v&&(w=v.ready())}w.then(()=>{for(const{uri:v,originalUrl:k}of $)this.c.open(v,{originalUrl:k})})}else return this.f(m,p)}e(m){return m["open-url"]&&m._urls&&m._urls.length>0?(0,o.$Jb)(m._urls.map(p=>{try{return{uri:D.URI.parse(p),originalUrl:p}}catch{return null}})):[]}async f(m,p){const $=(0,y.$Jm)(p)?g.OpenContext.CLI:g.OpenContext.DESKTOP;let w=[];const v=m.wait&&m.waitMarkerFilePath?D.URI.file(m.waitMarkerFilePath):void 0,k=m.remote||void 0,t={context:$,cli:m,userEnv:m["preserve-env"]||$===g.OpenContext.CLI?p:void 0,waitMarkerFileURI:v,remoteAuthority:k,forceProfile:m.profile,forceTempProfile:m["profile-temp"]};if(m.extensionDevelopmentPath)await this.b.openExtensionDevelopmentHostWindow(m.extensionDevelopmentPath,t);else if(!m._.length&&!m["folder-uri"]&&!m["file-uri"]){let r=!1;if(m["new-window"]||t.forceProfile||t.forceTempProfile)r=!0;else if(m["reuse-window"])r=!1;else switch(this.d.getValue("window")?.openWithoutArgumentsInNewWindow||"default"){case"on":r=!0;break;case"off":r=!1;break;default:r=!S.$j}if(r)w=await this.b.open({...t,forceNewWindow:!0,forceEmpty:!0});else{const n=this.b.getLastActiveWindow();n?(this.b.openExistingWindow(n,t),w=[n]):w=await this.b.open({...t,forceEmpty:!0})}}else w=await this.b.open({...t,forceNewWindow:m["new-window"],preferNewWindow:!m["reuse-window"]&&!m.wait,forceReuseWindow:m["reuse-window"],diffMode:m.diff,mergeMode:m.merge,addMode:m.add,noRecentEntry:!!m["skip-add-to-recently-opened"],gotoLineMode:m.goto});if(v&&w.length===1&&w[0])return Promise.race([w[0].whenClosedOrLoaded,(0,O.whenDeleted)(v.fsPath)]).then(()=>{},()=>{})}async getMainProcessId(){return this.a.trace("Received request for process ID from other instance."),process.pid}};e.$ofc=b,e.$ofc=b=Se([re(0,h.$_j),re(1,g.$vec),re(2,f.$qY),re(3,P.$_i)],b)}),define(oe[299],ae([0,1,2,20,51,59,30,8,29]),function(V,e,i,o,S,D,O,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4fc=void 0;let a=class extends i.$Wc{constructor(f,g,b){super(),this.a=g,this.b=b,this.B(f.onWillLoadWindow(l=>{l.reason===S.LoadReason.LOAD&&this.c(l.window)})),this.B(f.onBeforeCloseWindow(l=>this.c(l))),this.B(new P.$Rh(()=>this.g(),30*1e3)).schedule()}async c(f){const g=this.f(f),b=this.a.getProfileForWorkspace(g);b?.isTransient&&(this.a.unsetWorkspace(g,b.isTransient),b.isTransient&&await this.a.cleanUpTransientProfiles())}f(f){return f.openedWorkspace??(0,O.$Ti)(f.backupPath,f.isExtensionDevelopmentHost)}g(){const f=this.a.getAssociatedEmptyWindows();if(f.length===0)return;const g=this.b.getWindows().map(b=>this.f(b));for(const b of f)g.some(l=>l.id===b.id)||this.a.unsetWorkspace(b,!1)}};e.$4fc=a,e.$4fc=a=Se([re(0,o.$Oec),re(1,D.$yec),re(2,y.$vec)],a)});var et=this&&this.__importDefault||function(V){return V&&V.__esModule?V:{default:V}};define(oe[64],ae([0,1,14,2,3,5,318,8,13,29,79,24,20,80,35,4,107]),function(V,e,i,o,S,D,O,P,y,a,h,f,g,b,l,m,p){"use strict";var $;Object.defineProperty(e,"__esModule",{value:!0}),e.$3ec=e.$2ec=void 0,h=et(h);function w(t){return typeof t.responseWindowId=="number"}let v=class extends o.$Wc{static{$=this}static{this.a=0}static{this.b=new Map}static getAll(){return Array.from($.b.values())}constructor(r,n,c){super(),this.w=r,this.y=n,this.z=c,this.c=String(++$.a),this.f=this.B(new S.$me),this.onStdout=this.f.event,this.g=this.B(new S.$me),this.onStderr=this.g.event,this.h=this.B(new S.$me),this.onMessage=this.h.event,this.j=this.B(new S.$me),this.onSpawn=this.j.event,this.m=this.B(new S.$me),this.onExit=this.m.event,this.n=this.B(new S.$me),this.onCrash=this.n.event,this.r=void 0,this.s=void 0,this.t=void 0,this.u=!1}C(r,n){let c;switch(this.t?.correlationId?c=`[UtilityProcess id: ${this.t?.correlationId}, type: ${this.t?.type}, pid: ${this.s??"<none>"}]: ${r}`:c=`[UtilityProcess type: ${this.t?.type}, pid: ${this.s??"<none>"}]: ${r}`,n){case h.default.Error:this.w.error(c);break;case h.default.Warning:this.w.warn(c);break;case h.default.Info:this.w.trace(c);break}}D(){return this.r?(this.C("Cannot start utility process because it is already running...",h.default.Error),!1):!0}start(r){const n=this.F(r);return n&&r.payload&&this.postMessage(r.payload)&&this.C("payload sent via postMessage()",h.default.Info),n}F(r){if(!this.D())return!1;this.t=r;const n=`${this.t.type}-${this.c}`,c=y.$Zg.asFileUri("bootstrap-fork.js").fsPath,s=this.t.args??[],u=this.t.execArgv??[],d=this.t.allowLoadingUnsignedLibraries,I=this.t.forceAllocationsToV8Sandbox,E="pipe",A=this.G(r);return this.C("creating new...",h.default.Info),this.r=i.utilityProcess.fork(c,s,{serviceName:n,env:A,execArgv:u,allowLoadingUnsignedLibraries:d,forceAllocationsToV8Sandbox:I,stdio:E}),this.H(this.r,this.t,n),!0}G(r){const n=r.env?{...r.env}:{...(0,l.$bo)(process.env)};n.VSCODE_AMD_ENTRYPOINT=r.entryPoint,typeof r.parentLifecycleBound=="number"&&(n.VSCODE_PARENT_PID=String(r.parentLifecycleBound)),n.VSCODE_CRASH_REPORTER_PROCESS_TYPE=r.type,m.$i&&((0,p.isUNCAccessRestrictionsDisabled)()?n.NODE_DISABLE_UNC_ACCESS_CHECKS="1":n.NODE_UNC_HOST_ALLOWLIST=(0,p.getUNCHostAllowlist)().join("\\")),(0,b.$lm)(n);for(const c of Object.keys(n))n[c]=String(n[c]);return n}H(r,n,c){if(r.stdout){const s=new O.StringDecoder("utf-8");this.B(S.Event.fromNodeEventEmitter(r.stdout,"data")(u=>this.f.fire(typeof u=="string"?u:s.write(u))))}if(r.stderr){const s=new O.StringDecoder("utf-8");this.B(S.Event.fromNodeEventEmitter(r.stderr,"data")(u=>this.g.fire(typeof u=="string"?u:s.write(u))))}this.B(S.Event.fromNodeEventEmitter(r,"message")(s=>this.h.fire(s))),this.B(S.Event.fromNodeEventEmitter(r,"spawn")(()=>{this.s=r.pid,typeof r.pid=="number"&&$.b.set(r.pid,{pid:r.pid,name:w(n)?`${n.type} [${n.responseWindowId}]`:n.type}),this.C("successfully created",h.default.Info),this.j.fire(r.pid)})),this.B(S.Event.fromNodeEventEmitter(r,"exit")(s=>{const u=this.I(s)?0:s;this.C(`received exit event with code ${u}`,h.default.Info),this.m.fire({pid:this.s,code:u,signal:"unknown"}),this.J()})),this.B(S.Event.fromNodeEventEmitter(i.app,"child-process-gone",(s,u)=>({event:s,details:u}))(({details:s})=>{s.type==="Utility"&&s.name===c&&!this.I(s.exitCode)&&(this.C(`crashed with code ${s.exitCode} and reason '${s.reason}'`,h.default.Error),this.y.publicLog2("utilityprocesscrash",{type:n.type,reason:s.reason,code:s.exitCode}),this.n.fire({pid:this.s,code:s.exitCode,reason:s.reason}),this.J())}))}once(r,n){const c=this.B(this.h.event(s=>{s===r&&(c.dispose(),n())}))}postMessage(r,n){return this.r?(this.r.postMessage(r,n),!0):!1}connect(r){const{port1:n,port2:c}=new i.MessageChannelMain;return this.postMessage(r,[c]),n}enableInspectPort(){if(!this.r||typeof this.s!="number")return!1;this.C("enabling inspect port",h.default.Info);const r=process;return typeof r._debugProcess=="function"?(r._debugProcess(this.s),!0):!1}kill(){if(!this.r)return;this.C("attempting to kill the process...",h.default.Info),this.r.kill()?(this.C("successfully killed the process",h.default.Info),this.u=!0,this.J()):this.C("unable to kill the process",h.default.Warning)}I(r){return r===0?!0:this.u&&r===15}J(){typeof this.s=="number"&&$.b.delete(this.s),this.r=void 0}async waitForExit(r){this.r&&(this.C("waiting to exit...",h.default.Info),await Promise.race([S.Event.toPromise(this.onExit),(0,P.$Gh)(r)]),this.r&&(this.C(`did not exit within ${r}ms, will kill it now...`,h.default.Info),this.kill()))}};e.$2ec=v,e.$2ec=v=$=Se([re(0,D.$_j),re(1,f.$$l),re(2,g.$Oec)],v);let k=class extends v{constructor(r,n,c,s){super(r,c,s),this.L=n}start(r){const n=this.L.getWindowById(r.responseWindowId);if(!n?.win||n.win.isDestroyed()||n.win.webContents.isDestroyed())return this.C("Refusing to start utility process because requesting window cannot be found or is destroyed...",h.default.Error),!0;if(!super.F(r))return!1;this.M(n.win,r);const s=this.connect(r.payload);return n.win.webContents.postMessage(r.responseChannel,r.responseNonce,[s]),!0}M(r,n){n.windowLifecycleBound&&(this.B(S.Event.filter(this.z.onWillLoadWindow,c=>c.window.win===r)(()=>this.kill())),this.B(S.Event.fromNodeEventEmitter(r,"closed")(()=>this.kill())))}};e.$3ec=k,e.$3ec=k=Se([re(0,D.$_j),re(1,a.$vec),re(2,f.$$l),re(3,g.$Oec)],k)}),define(oe[300],ae([0,1,8,16,3,2,20,5,24,64,29]),function(V,e,i,o,S,D,O,P,y,a,h){"use strict";var f;Object.defineProperty(e,"__esModule",{value:!0}),e.$0ec=void 0;let g=class extends D.$Wc{static{f=this}static{this.a=0}constructor(l,m,p,$){super(),this.f=l,this.g=m,this.h=p,this.j=$,this.b=new Map,this.c=!1,this.B(this.g.onWillShutdown(w=>{this.c=!0,w.join("extHostStarter",this._waitForAllExit(6e3))}))}dispose(){super.dispose()}m(l){const m=this.b.get(l);if(!m)throw new Error("Unknown extension host!");return m}onDynamicStdout(l){return this.m(l).onStdout}onDynamicStderr(l){return this.m(l).onStderr}onDynamicMessage(l){return this.m(l).onMessage}onDynamicExit(l){return this.m(l).onExit}async createExtensionHost(){if(this.c)throw(0,o.$8)();const l=String(++f.a),m=new a.$3ec(this.f,this.h,this.j,this.g);this.b.set(l,m);const p=m.onExit(({pid:$,code:w,signal:v})=>{p.dispose(),this.f.info(`Extension host with pid ${$} exited with code: ${w}, signal: ${v}.`),setTimeout(()=>{m.dispose(),this.b.delete(l)}),setTimeout(()=>{try{process.kill($,0),this.f.error(`Extension host with pid ${$} still exists, forcefully killing it...`),process.kill($)}catch{}},1e3)});return{id:l}}async start(l,m){if(this.c)throw(0,o.$8)();const p=this.m(l);return p.start({...m,type:"extensionHost",entryPoint:"vs/workbench/api/node/extensionHostProcess",args:["--skipWorkspaceStorageLock"],execArgv:m.execArgv,allowLoadingUnsignedLibraries:!0,forceAllocationsToV8Sandbox:!0,correlationId:l}),{pid:await S.Event.toPromise(p.onSpawn)}}async enableInspectPort(l){if(this.c)throw(0,o.$8)();const m=this.b.get(l);return m?m.enableInspectPort():!1}async kill(l){if(this.c)throw(0,o.$8)();const m=this.b.get(l);m&&m.kill()}async _killAllNow(){for(const[,l]of this.b)l.kill()}async _waitForAllExit(l){const m=[];for(const[,p]of this.b)m.push(p.waitForExit(l));return i.Promises.settled(m).then(()=>{})}};e.$0ec=g,e.$0ec=g=f=Se([re(0,P.$_j),re(1,O.$Oec),re(2,h.$vec),re(3,y.$$l)],g)}),define(oe[301],ae([0,1,37,8,2,25,20,5,42,40,71,64,56,95,12,252,3]),function(V,e,i,o,S,D,O,P,y,a,h,f,g,b,l,m,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bfc=void 0;let $=class extends S.$Wc{constructor(v,k,t,r,n,c,s,u,d){super(),this.g=v,this.h=k,this.j=t,this.m=r,this.n=n,this.r=c,this.s=s,this.t=u,this.u=d,this.a=new o.$Eh,this.b=void 0,this.c=void 0,this.f=this.B(new p.$me),this.onDidCrash=this.f.event,this.C=void 0,this.D=void 0,this.w()}w(){i.$BX.on(m.$zfc.request,(v,k)=>this.y(v,k,m.$zfc.response)),i.$BX.on(m.$Afc.request,(v,k)=>this.y(v,k,m.$Afc.response)),this.B(this.r.onWillShutdown(()=>this.z()))}async y(v,k,t){this.s.trace(`[SharedProcess] onWindowConnection for: ${t}`),this.a.isOpen()||this.a.open(),await this.whenReady();const r=await this.connect(t);if(v.sender.isDestroyed())return r.close();v.sender.postMessage(t,k,[r])}z(){this.s.trace("[SharedProcess] onWillShutdown"),this.b?.postMessage(m.$yfc.exit),this.b=void 0}whenReady(){return this.C||(this.C=(async()=>{await this.F;const v=new o.$3h;this.b?.once(m.$yfc.initDone,()=>v.complete()),await v.p,this.c?.dispose(),this.s.trace("[SharedProcess] Overall ready")})()),this.C}get F(){return this.D||(this.D=(async()=>{await this.a.wait(),this.G();const v=new o.$3h;this.b?.once(m.$yfc.ipcReady,()=>v.complete()),await v.p,this.s.trace("[SharedProcess] IPC ready")})()),this.D}G(){this.b=this.B(new f.$2ec(this.s,g.$up,this.r)),this.c=this.b.onMessage(t=>{typeof t.warning=="string"?this.s.warn(t.warning):typeof t.error=="string"&&this.s.error(t.error)});const v=(0,b.$0m)(this.m.args,this.m.isBuilt);let k;v.port&&(k=["--nolazy"],v.break?k.push(`--inspect-brk=${v.port}`):k.push(`--inspect=${v.port}`)),this.b.start({type:"shared-process",entryPoint:"vs/code/node/sharedProcess/sharedProcessMain",payload:this.H(),execArgv:k}),this.B(this.b.onCrash(()=>this.f.fire()))}H(){return{machineId:this.g,sqmId:this.h,devDeviceId:this.j,codeCachePath:this.m.codeCachePath,profiles:{home:this.n.profilesHome,all:this.n.profiles},args:this.m.args,logLevel:this.t.getLogLevel(),loggers:this.t.getRegisteredLoggers(),policiesData:this.u.serialize()}}async connect(v){return await this.F,(0,l.$qg)(this.b).connect(v)}};e.$Bfc=$,e.$Bfc=$=Se([re(3,D.$kec),re(4,y.$Ll),re(5,O.$Oec),re(6,P.$_j),re(7,h.$Jec),re(8,a.$qo)],$)}),define(oe[302],ae([0,1,25,95,20,5,56,73,64,119,37,2,3,35,18,13]),function(V,e,i,o,S,D,O,P,y,a,h,f,g,b,l,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dgc=void 0;let p=class extends f.$Wc{constructor(w,v,k,t,r){super(),this.f=w,this.g=v,this.h=k,this.j=t,this.m=r,this.a=void 0,this.b=new g.$me,this.onRequestConnection=this.b.event,this.c=new g.$me,this.onWillShutdown=this.c.event,this.B(this.j.onWillShutdown(()=>this.c.fire())),h.$BX.on("vscode:createPtyHostMessageChannel",(n,c)=>this.r(n,c)),this.B((0,f.$Uc)(()=>{h.$BX.removeHandler("vscode:createPtyHostMessageChannel")}))}start(){this.a=new y.$2ec(this.m,O.$up,this.j);const w=(0,o.$9m)(this.h.args,this.h.isBuilt),v=w.port?["--nolazy",`--inspect${w.break?"-brk":""}=${w.port}`]:void 0;this.a.start({type:"ptyHost",entryPoint:"vs/platform/terminal/node/ptyHostMain",execArgv:v,args:["--logsPath",this.h.logsHome.with({scheme:m.Schemas.file}).fsPath],env:this.n()});const k=this.a.connect(),t=new a.$JX(k,"ptyHost"),r=new f.$Vc;return r.add(t),r.add((0,f.$Uc)(()=>{this.a?.kill(),this.a?.dispose(),this.a=void 0})),{client:t,store:r,onDidProcessExit:this.a.onExit}}n(){this.h.unsetSnapExportedVariables();const w={...(0,b.$bo)(process.env),VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_RECONNECT_GRACE_TIME:String(this.f.graceTime),VSCODE_RECONNECT_SHORT_GRACE_TIME:String(this.f.shortGraceTime),VSCODE_RECONNECT_SCROLLBACK:String(this.f.scrollback)},v=this.g.getValue(P.TerminalSettingId.DeveloperPtyHostLatency);v&&typeof v=="number"&&(w.VSCODE_LATENCY=String(v));const k=this.g.getValue(P.TerminalSettingId.DeveloperPtyHostStartupDelay);return k&&typeof k=="number"&&(w.VSCODE_STARTUP_DELAY=String(k)),this.h.restoreSnapExportedVariables(),w}r(w,v){this.b.fire();const k=this.a.connect();if(w.sender.isDestroyed()){k.close();return}w.sender.postMessage("vscode:createPtyHostMessageChannelResult",v,[k])}};e.$dgc=p,e.$dgc=p=Se([re(1,l.$_i),re(2,i.$kec),re(3,S.$Oec),re(4,D.$_j)],p)}),define(oe[303],ae([0,1,2,6,5,29,64,24,46,3,8,20]),function(V,e,i,o,S,D,O,P,y,a,h,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cgc=e.$bgc=void 0,e.$bgc=(0,o.$Fi)("utilityProcessWorker");let g=class extends i.$Wc{constructor(m,p,$,w){super(),this.b=m,this.c=p,this.f=$,this.g=w,this.a=new Map}async createWorker(m){const p=`window: ${m.reply.windowId}, moduleId: ${m.process.moduleId}`;this.b.trace(`[UtilityProcessWorker]: createWorker(${p})`);const $=this.h(m);this.a.has($)&&(this.b.warn(`[UtilityProcessWorker]: createWorker() found an existing worker that will be terminated (${p})`),this.disposeWorker(m));const w=new b(this.b,this.c,this.f,this.g,m);if(!w.spawn())return{reason:{code:1,signal:"EINVALID"}};this.a.set($,w);const v=new h.$3h;return a.Event.once(w.onDidTerminate)(k=>{k.code===0?this.b.trace(`[UtilityProcessWorker]: terminated normally with code ${k.code}, signal: ${k.signal}`):this.b.error(`[UtilityProcessWorker]: terminated unexpectedly with code ${k.code}, signal: ${k.signal}`),this.a.delete($),v.complete({reason:k})}),v.p}h(m){return(0,y.$tj)({moduleId:m.process.moduleId,windowId:m.reply.windowId})}async disposeWorker(m){const p=this.h(m),$=this.a.get(p);$&&(this.b.trace(`[UtilityProcessWorker]: disposeWorker(window: ${m.reply.windowId}, moduleId: ${m.process.moduleId})`),$.kill(),$.dispose(),this.a.delete(p))}};e.$cgc=g,e.$cgc=g=Se([re(0,S.$_j),re(1,D.$vec),re(2,P.$$l),re(3,f.$Oec)],g);let b=class extends i.$Wc{constructor(m,p,$,w,v){super(),this.c=m,this.f=p,this.g=$,this.h=w,this.j=v,this.a=this.B(new a.$me),this.onDidTerminate=this.a.event,this.b=this.B(new O.$3ec(this.c,this.f,this.g,this.h)),this.m()}m(){this.B(this.b.onExit(m=>this.a.fire({code:m.code,signal:m.signal}))),this.B(this.b.onCrash(m=>this.a.fire({code:m.code,signal:"ECRASH"})))}spawn(){const p=this.f.getWindowById(this.j.reply.windowId)?.win?.webContents.getOSProcessId();return this.b.start({type:this.j.process.type,entryPoint:this.j.process.moduleId,parentLifecycleBound:p,windowLifecycleBound:!0,correlationId:`${this.j.reply.windowId}`,responseWindowId:this.j.reply.windowId,responseChannel:this.j.reply.channel,responseNonce:this.j.reply.nonce})}kill(){this.b.kill()}};b=Se([re(0,S.$_j),re(1,D.$vec),re(2,P.$$l),re(3,f.$Oec)],b)}),define(oe[304],ae([0,1,14,3,2,277,29]),function(V,e,i,o,S,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tfc=void 0;let P=class extends S.$Wc{constructor(a){super(),this.b=a,this.a=this.B(new o.$me),this.onFoundInFrame=this.a.event,this.B(new D.$Sfc)}async setIgnoreMenuShortcuts(a,h){let f;if(typeof a.windowId=="number"){const{windowId:g}=a,b=this.b.getWindowById(g);if(!b?.win)throw new Error(`Invalid windowId: ${g}`);f=b.win.webContents}else{const{webContentsId:g}=a;if(f=i.webContents.fromId(g),!f)throw new Error(`Invalid webContentsId: ${g}`)}f.isDestroyed()||f.setIgnoreMenuShortcuts(h)}async findInFrame(a,h,f,g){const l=this.c(a,h);if(typeof l.findInFrame=="function"){l.findInFrame(f,{findNext:g.findNext,forward:g.forward});const m=(p,$)=>{$.finalUpdate&&(this.a.fire($),l.removeListener("found-in-frame",m))};l.on("found-in-frame",m)}}async stopFindInFrame(a,h,f){const b=this.c(a,h);typeof b.stopFindInFrame=="function"&&b.stopFindInFrame(f.keepSelection?"keepSelection":"clearSelection")}c(a,h){const f=this.b.getWindowById(a.windowId);if(!f?.win)throw new Error(`Invalid windowId: ${a}`);const g=f.win.webContents.mainFrame.framesInSubtree.find(b=>b.name===h);if(!g)throw new Error(`Unknown frame: ${h}`);return g}};e.$Tfc=P,e.$Tfc=P=Se([re(0,O.$vec)],P)}),define(oe[305],ae([0,1,14,2,4,19,7,18,20,5,34,29,51,30]),function(V,e,i,o,S,D,O,P,y,a,h,f,g,b){"use strict";var l;Object.defineProperty(e,"__esModule",{value:!0}),e.$Ufc=void 0,e.$Vfc=p,e.$Wfc=w;let m=class extends o.$Wc{static{l=this}static{this.a="windowsState"}get state(){return this.b}constructor(t,r,n,c,s){super(),this.g=t,this.h=r,this.j=n,this.m=c,this.n=s,this.b=p(this.h.getItem(l.a)),this.c=void 0,this.f=!1,this.r()}r(){i.app.on("browser-window-blur",()=>{this.f||this.t()}),this.B(this.j.onBeforeCloseWindow(t=>this.u(t))),this.B(this.j.onBeforeShutdown(()=>this.s())),this.B(this.g.onDidChangeWindowsCount(t=>{t.newCount-t.oldCount>0&&(this.c=void 0)})),this.B(this.g.onDidDestroyWindow(t=>this.u(t)))}s(){this.f=!0,this.t()}t(){const t=new Set,r={openedWindows:[],lastPluginDevelopmentHostWindow:this.b.lastPluginDevelopmentHostWindow,lastActiveWindow:this.c};if(!r.lastActiveWindow){let s=this.g.getLastActiveWindow();(!s||s.isExtensionDevelopmentHost)&&(s=this.g.getWindows().find(u=>!u.isExtensionDevelopmentHost)),s&&(r.lastActiveWindow=this.w(s),r.lastActiveWindow.uiState.mode===g.WindowMode.Fullscreen&&t.add(r.lastActiveWindow.uiState.display))}const n=this.g.getWindows().find(s=>s.isExtensionDevelopmentHost&&!s.isExtensionTestHost);n&&(r.lastPluginDevelopmentHostWindow=this.w(n),r.lastPluginDevelopmentHostWindow.uiState.mode===g.WindowMode.Fullscreen&&(t.has(r.lastPluginDevelopmentHostWindow.uiState.display)?S.$j&&!n.win?.isSimpleFullScreen()&&(r.lastPluginDevelopmentHostWindow.uiState.mode=g.WindowMode.Normal):t.add(r.lastPluginDevelopmentHostWindow.uiState.display))),this.g.getWindowCount()>1&&(r.openedWindows=this.g.getWindows().filter(s=>!s.isExtensionDevelopmentHost).map(s=>{const u=this.w(s);return u.uiState.mode===g.WindowMode.Fullscreen&&(t.has(u.uiState.display)?S.$j&&u.windowId!==r.lastActiveWindow?.windowId&&!s.win?.isSimpleFullScreen()&&(u.uiState.mode=g.WindowMode.Normal):t.add(u.uiState.display)),u}));const c=w(r);this.h.setItem(l.a,c),this.f&&this.m.trace("[WindowsStateHandler] onBeforeShutdown",c)}u(t){if(this.j.quitRequested)return;const r=this.w(t);t.isExtensionDevelopmentHost&&!t.isExtensionTestHost?this.b.lastPluginDevelopmentHostWindow=r:!t.isExtensionDevelopmentHost&&t.openedWorkspace&&this.b.openedWindows.forEach(n=>{const c=(0,b.$Ui)(t.openedWorkspace)&&n.workspace?.id===t.openedWorkspace.id,s=(0,b.$Pi)(t.openedWorkspace)&&n.folderUri&&D.$0g.isEqual(n.folderUri,t.openedWorkspace.uri);(c||s)&&(n.uiState=r.uiState)}),this.g.getWindowCount()===1&&(this.c=r)}w(t){return{windowId:t.id,workspace:(0,b.$Ui)(t.openedWorkspace)?t.openedWorkspace:void 0,folderUri:(0,b.$Pi)(t.openedWorkspace)?t.openedWorkspace.uri:void 0,backupPath:t.backupPath,remoteAuthority:t.remoteAuthority,uiState:t.serializeWindowState()}}getNewWindowState(t){const r=this.z(t),n=this.n.getValue("window");if(r.mode===g.WindowMode.Fullscreen){let c;r.hasDefaultState?c=!!(n?.newWindowDimensions&&["fullscreen","inherit","offset"].indexOf(n.newWindowDimensions)>=0):c=!!(this.j.wasRestarted||n?.restoreFullscreen),c||(r.mode=g.WindowMode.Normal)}return r}z(t){const r=this.g.getLastActiveWindow();if(!t.extensionTestsPath){if(t.extensionDevelopmentPath&&this.state.lastPluginDevelopmentHostWindow)return this.state.lastPluginDevelopmentHostWindow.uiState;const I=t.workspace;if((0,b.$Ui)(I)){const A=this.state.openedWindows.filter(T=>T.workspace&&T.workspace.id===I.id).map(T=>T.uiState);if(A.length)return A[0]}if((0,b.$Pi)(I)){const A=this.state.openedWindows.filter(T=>T.folderUri&&D.$0g.isEqual(T.folderUri,I.uri)).map(T=>T.uiState);if(A.length)return A[0]}else if(t.backupPath){const A=this.state.openedWindows.filter(T=>T.backupPath===t.backupPath).map(T=>T.uiState);if(A.length)return A[0]}const E=this.c||this.state.lastActiveWindow;if(!r&&E)return E.uiState}let n;const c=i.screen.getAllDisplays();if(c.length===1)n=c[0];else{if(S.$j){const I=i.screen.getCursorScreenPoint();n=i.screen.getDisplayNearestPoint(I)}!n&&r&&(n=i.screen.getDisplayMatching(r.getBounds())),n||(n=i.screen.getPrimaryDisplay()||c[0])}let s=(0,g.$iec)();s.x=Math.round(n.bounds.x+n.bounds.width/2-s.width/2),s.y=Math.round(n.bounds.y+n.bounds.height/2-s.height/2);const u=this.n.getValue("window");let d=!0;if(u?.newWindowDimensions){if(u.newWindowDimensions==="maximized")s.mode=g.WindowMode.Maximized,d=!1;else if(u.newWindowDimensions==="fullscreen")s.mode=g.WindowMode.Fullscreen,d=!1;else if((u.newWindowDimensions==="inherit"||u.newWindowDimensions==="offset")&&r){const I=r.serializeWindowState();I.mode===g.WindowMode.Fullscreen?s.mode=g.WindowMode.Fullscreen:s={...I,zoomLevel:void 0},d=s.mode!==g.WindowMode.Fullscreen&&u.newWindowDimensions==="offset"}}return d&&(s=this.C(s)),s.hasDefaultState=!0,s}C(t){if(this.g.getWindows().length===0)return t;t.x=typeof t.x=="number"?t.x:0,t.y=typeof t.y=="number"?t.y:0;const r=this.g.getWindows().map(n=>n.getBounds());for(;r.some(n=>n.x===t.x||n.y===t.y);)t.x+=30,t.y+=30;return t}};e.$Ufc=m,e.$Ufc=m=l=Se([re(0,f.$vec),re(1,h.$dR),re(2,y.$Oec),re(3,a.$_j),re(4,P.$_i)],m);function p(k){const t={openedWindows:[]},r=k||{openedWindows:[]};return r.lastActiveWindow&&(t.lastActiveWindow=$(r.lastActiveWindow)),r.lastPluginDevelopmentHostWindow&&(t.lastPluginDevelopmentHostWindow=$(r.lastPluginDevelopmentHostWindow)),Array.isArray(r.openedWindows)&&(t.openedWindows=r.openedWindows.map(n=>$(n))),t}function $(k){const t={uiState:k.uiState};return k.backupPath&&(t.backupPath=k.backupPath),k.remoteAuthority&&(t.remoteAuthority=k.remoteAuthority),k.folder&&(t.folderUri=O.URI.parse(k.folder)),k.workspaceIdentifier&&(t.workspace={id:k.workspaceIdentifier.id,configPath:O.URI.parse(k.workspaceIdentifier.configURIPath)}),t}function w(k){return{lastActiveWindow:k.lastActiveWindow&&v(k.lastActiveWindow),lastPluginDevelopmentHostWindow:k.lastPluginDevelopmentHostWindow&&v(k.lastPluginDevelopmentHostWindow),openedWindows:k.openedWindows.map(t=>v(t))}}function v(k){return{workspaceIdentifier:k.workspace&&{id:k.workspace.id,configURIPath:k.workspace.configPath.toString()},folder:k.folderUri&&k.folderUri.toString(),backupPath:k.backupPath,remoteAuthority:k.remoteAuthority,uiState:k.uiState}}}),define(oe[60],ae([0,1,14,3,43,2,13,9,19,21,200,69,58,25,6,5,59,135,30,103,104]),function(V,e,i,o,S,D,O,P,y,a,h,f,g,b,l,m,p,$,w,v,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Iec=e.$Hec=void 0,e.$Hec=(0,l.$Fi)("workspacesManagementMainService");let t=class extends D.$Wc{constructor(n,c,s,u,d){super(),this.g=n,this.h=c,this.j=s,this.m=u,this.n=d,this.a=this.B(new o.$me),this.onDidDeleteUntitledWorkspace=this.a.event,this.b=this.B(new o.$me),this.onDidEnterWorkspace=this.b.event,this.c=this.g.untitledWorkspacesHome,this.f=[]}async initialize(){this.f=[];try{const n=(await a.Promises.readdir(this.c.with({scheme:O.Schemas.file}).fsPath)).map(c=>(0,y.$gh)(this.c,c,w.$5i));for(const c of n){const s=(0,k.$Eec)(c),u=await this.resolveLocalWorkspace(c);u?this.f.push({workspace:s,remoteAuthority:u.remoteAuthority}):await this.deleteUntitledWorkspace(s)}}catch(n){n.code!=="ENOENT"&&this.h.warn(`Unable to read folders in ${this.c} (${n}).`)}}resolveLocalWorkspace(n){return this.r(n,c=>a.Promises.readFile(c,"utf8"))}r(n,c){if(this.s(n)&&n.scheme===O.Schemas.file)try{const s=c(n.fsPath);return s instanceof Promise?s.then(u=>this.t(n,u),u=>{}):this.t(n,s)}catch{return}}s(n){return(0,w.$6i)(n,this.g)||(0,w.$$i)(n)}t(n,c){try{const s=this.u(n,c),u=(0,k.$Eec)(n);return{id:u.id,configPath:u.configPath,folders:(0,v.$Lhb)(s.folders,u.configPath,y.$0g),remoteAuthority:s.remoteAuthority,transient:s.transient}}catch(s){this.h.warn(s.toString())}}u(n,c){const s=(0,S.$Vn)(c);if(s&&Array.isArray(s.folders))s.folders=s.folders.filter(u=>(0,v.$Jhb)(u));else throw new Error(`${n.toString(!0)} looks like an invalid workspace file.`);return s}async createUntitledWorkspace(n,c){const{workspace:s,storedWorkspace:u}=this.w(n,c),d=s.configPath.fsPath;return await a.Promises.mkdir((0,P.$oc)(d),{recursive:!0}),await a.Promises.writeFile(d,JSON.stringify(u,null,"	")),this.f.push({workspace:s,remoteAuthority:c}),s}w(n=[],c){const s=(Date.now()+Math.round(Math.random()*1e3)).toString(),u=(0,y.$gh)(this.c,s),d=(0,y.$gh)(u,w.$5i),I=[];for(const E of n)I.push((0,v.$Khb)(E.uri,!0,E.name,u,y.$0g));return{workspace:(0,k.$Eec)(d),storedWorkspace:{folders:I,remoteAuthority:c}}}async getWorkspaceIdentifier(n){return(0,k.$Eec)(n)}isUntitledWorkspace(n){return(0,w.$6i)(n.configPath,this.g)}async deleteUntitledWorkspace(n){this.isUntitledWorkspace(n)&&(await this.y(n),this.j.isEnabled()&&this.j.unsetWorkspace(n),this.a.fire(n))}async y(n){const c=(0,y.$7g)(n.configPath);try{await a.Promises.rm((0,P.$oc)(c));const s=(0,P.$lc)(this.g.workspaceStorageHome.with({scheme:O.Schemas.file}).fsPath,n.id);await a.Promises.exists(s)&&await a.Promises.writeFile((0,P.$lc)(s,"obsolete"),""),this.f=this.f.filter(u=>u.workspace.id!==n.id)}catch(s){this.h.warn(`Unable to delete untitled workspace ${c} (${s}).`)}}getUntitledWorkspaces(){return this.f}async enterWorkspace(n,c,s){if(!n||!n.win||!n.isReady||!await this.z(n,c,s))return;const d=await this.C(n,(0,k.$Eec)(s));if(d)return this.b.fire({window:n,workspace:d.workspace}),d}async z(n,c,s){return s?(0,w.$Ui)(n.openedWorkspace)&&y.$0g.isEqual(n.openedWorkspace.configPath,s)?!1:(0,$.$Bec)(c,s)?(await this.n.showMessageBox({type:"info",buttons:[(0,h.localize)(0,null)],message:(0,h.localize)(1,null,(0,y.$dh)(s)),detail:(0,h.localize)(2,null)},i.BrowserWindow.getFocusedWindow()??void 0),!1):!0:!0}async C(n,c){if(!n.config)return;n.focus();let s;return n.config.extensionDevelopmentPath||(n.config.backupPath?s=await this.m.registerWorkspaceBackup({workspace:c,remoteAuthority:n.remoteAuthority},n.config.backupPath):s=this.m.registerWorkspaceBackup({workspace:c,remoteAuthority:n.remoteAuthority})),(0,w.$Ui)(n.openedWorkspace)&&this.isUntitledWorkspace(n.openedWorkspace)&&await this.deleteUntitledWorkspace(n.openedWorkspace),n.config.workspace=c,n.config.backupPath=s,{workspace:c,backupPath:s}}};e.$Iec=t,e.$Iec=t=Se([re(0,b.$kec),re(1,m.$_j),re(2,p.$yec),re(3,f.$pec),re(4,g.$qec)],t)}),define(oe[136],ae([0,1,14,37,23,6,29,30,60,12,5,64]),function(V,e,i,o,S,D,O,P,y,a,h,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6ec=e.$5ec=e.ID=void 0,e.ID="diagnosticsMainService",e.$5ec=(0,D.$Fi)(e.ID);let g=class{constructor(l,m,p){this.a=l,this.b=m,this.c=p}async getRemoteDiagnostics(l){const m=this.a.getWindows();return(await Promise.all(m.map(async $=>{const w=$.remoteAuthority;if(!w)return;const v=`vscode:getDiagnosticInfoResponse${$.id}`,k={includeProcesses:l.includeProcesses,folders:l.includeWorkspaceMetadata?await this.f($):void 0};return new Promise(t=>{$.sendWhenReady("vscode:getDiagnosticInfo",S.CancellationToken.None,{replyChannel:v,args:k}),o.$BX.once(v,(r,n)=>{n||t({hostName:w,errorMessage:`Unable to resolve connection to '${w}'.`}),t(n)}),setTimeout(()=>{t({hostName:w,errorMessage:`Connection to '${w}' could not be established`})},5e3)})}))).filter($=>!!$)}async getMainDiagnostics(){this.c.trace("Received request for main process info from other instance.");const l=[];for(const p of i.BrowserWindow.getAllWindows()){const $=this.a.getWindowById(p.id);$?l.push(await this.d($)):l.push(this.e(p))}const m=[];for(const{pid:p,name:$}of f.$2ec.getAll())m.push({pid:p,name:$});return{mainPID:process.pid,mainArguments:process.argv.slice(1),windows:l,pidToNames:m,screenReader:!!i.app.accessibilitySupportEnabled,gpuFeatureStatus:i.app.getGPUFeatureStatus()}}async d(l){const m=await this.f(l),p=(0,a.$qg)(l.win);return this.e(p,m,l.remoteAuthority)}e(l,m=[],p){return{id:l.id,pid:l.webContents.getOSProcessId(),title:l.getTitle(),folderURIs:m,remoteAuthority:p}}async f(l){const m=[],p=l.openedWorkspace;if((0,P.$Pi)(p))m.push(p.uri);else if((0,P.$Ui)(p)){const $=await this.b.resolveLocalWorkspace(p.configPath);$&&$.folders.forEach(v=>{m.push(v.uri)})}return m}};e.$6ec=g,e.$6ec=g=Se([re(0,O.$vec),re(1,y.$Hec),re(2,h.$_j)],g)}),define(oe[75],ae([0,1,49,14,27,161,52,3,2,13,9,4,7,114,93,21,112,188,58,25,6,20,5,28,74,29,30,60,17,248,240,83,16]),function(V,e,i,o,S,D,O,P,y,a,h,f,g,b,l,m,p,$,w,v,k,t,r,n,c,s,u,d,I,E,A,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ifc=e.$hfc=void 0,e.$hfc=(0,k.$Fi)("nativeHostMainService");let R=class extends y.$Wc{constructor(U,N,z,ne,Q,le,K,ee,H){super(),this.a=U,this.b=N,this.c=z,this.f=ne,this.g=Q,this.h=le,this.j=K,this.m=ee,this.n=H,this.onDidOpenMainWindow=P.Event.map(this.a.onDidOpenWindow,j=>j.id),this.onDidTriggerWindowSystemContextMenu=P.Event.any(P.Event.map(this.a.onDidTriggerSystemContextMenu,({window:j,x:B,y:x})=>({windowId:j.id,x:B,y:x})),P.Event.map(this.b.onDidTriggerSystemContextMenu,({window:j,x:B,y:x})=>({windowId:j.id,x:B,y:x}))),this.onDidMaximizeWindow=P.Event.any(P.Event.map(this.a.onDidMaximizeWindow,j=>j.id),P.Event.map(this.b.onDidMaximizeWindow,j=>j.id)),this.onDidUnmaximizeWindow=P.Event.any(P.Event.map(this.a.onDidUnmaximizeWindow,j=>j.id),P.Event.map(this.b.onDidUnmaximizeWindow,j=>j.id)),this.onDidChangeWindowFullScreen=P.Event.any(P.Event.map(this.a.onDidChangeFullScreen,j=>({windowId:j.window.id,fullscreen:j.fullscreen})),P.Event.map(this.b.onDidChangeFullScreen,j=>({windowId:j.window.id,fullscreen:j.fullscreen}))),this.onDidBlurMainWindow=P.Event.filter(P.Event.fromNodeEventEmitter(o.app,"browser-window-blur",(j,B)=>B.id),j=>!!this.a.getWindowById(j)),this.onDidFocusMainWindow=P.Event.any(P.Event.map(P.Event.filter(P.Event.map(this.a.onDidChangeWindowsCount,()=>this.a.getLastActiveWindow()),j=>!!j),j=>j.id),P.Event.filter(P.Event.fromNodeEventEmitter(o.app,"browser-window-focus",(j,B)=>B.id),j=>!!this.a.getWindowById(j))),this.onDidBlurMainOrAuxiliaryWindow=P.Event.any(this.onDidBlurMainWindow,P.Event.map(P.Event.filter(P.Event.fromNodeEventEmitter(o.app,"browser-window-blur",(j,B)=>this.b.getWindowByWebContents(B.webContents)),j=>!!j),j=>j.id)),this.onDidFocusMainOrAuxiliaryWindow=P.Event.any(this.onDidFocusMainWindow,P.Event.map(P.Event.filter(P.Event.fromNodeEventEmitter(o.app,"browser-window-focus",(j,B)=>this.b.getWindowByWebContents(B.webContents)),j=>!!j),j=>j.id)),this.onDidResumeOS=P.Event.fromNodeEventEmitter(o.powerMonitor,"resume"),this.onDidChangeColorScheme=this.m.onDidChangeColorScheme,this.r=this.B(new P.$me),this.onDidChangePassword=this.r.event,this.onDidChangeDisplay=P.Event.debounce(P.Event.any(P.Event.filter(P.Event.fromNodeEventEmitter(o.screen,"display-metrics-changed",(j,B,x)=>x),j=>!(Array.isArray(j)&&j.length===1&&j[0]==="workArea")),P.Event.fromNodeEventEmitter(o.screen,"display-added"),P.Event.fromNodeEventEmitter(o.screen,"display-removed")),()=>{},100)}get windowId(){throw new Error("Not implemented in electron-main")}async getWindows(U,N){const z=this.a.getWindows().map(Q=>({id:Q.id,workspace:Q.openedWorkspace??(0,u.$Ti)(Q.backupPath,Q.isExtensionDevelopmentHost),title:Q.win?.getTitle()??"",filename:Q.getRepresentedFilename(),dirty:Q.isDocumentEdited()})),ne=[];return N.includeAuxiliaryWindows&&ne.push(...this.b.getWindows().map(Q=>({id:Q.id,parentId:Q.parentId,title:Q.win?.getTitle()??"",filename:Q.getRepresentedFilename()}))),[...z,...ne]}async getWindowCount(U){return this.a.getWindowCount()}async getActiveWindowId(U){const N=this.a.getFocusedWindow()||this.a.getLastActiveWindow();if(N)return N.id}openWindow(U,N,z){return Array.isArray(N)?this.s(U,N,z):this.t(U,N)}async s(U,N,z=Object.create(null)){N.length>0&&await this.a.open({context:s.OpenContext.API,contextWindowId:U,urisToOpen:N,cli:this.g.args,forceNewWindow:z.forceNewWindow,forceReuseWindow:z.forceReuseWindow,preferNewWindow:z.preferNewWindow,diffMode:z.diffMode,mergeMode:z.mergeMode,addMode:z.addMode,gotoLineMode:z.gotoLineMode,noRecentEntry:z.noRecentEntry,waitMarkerFileURI:z.waitMarkerFileURI,remoteAuthority:z.remoteAuthority||void 0,forceProfile:z.forceProfile,forceTempProfile:z.forceTempProfile})}async t(U,N){await this.a.openEmptyWindow({context:s.OpenContext.API,contextWindowId:U},N)}async isFullScreen(U,N){return this.C(N?.targetWindowId,U)?.isFullScreen??!1}async toggleFullScreen(U,N){this.C(N?.targetWindowId,U)?.toggleFullScreen()}async handleTitleDoubleClick(U,N){this.C(N?.targetWindowId,U)?.handleTitleDoubleClick()}async getCursorScreenPoint(U){const N=o.screen.getCursorScreenPoint(),z=o.screen.getDisplayNearestPoint(N);return{point:N,display:z.bounds}}async isMaximized(U,N){return this.C(N?.targetWindowId,U)?.win?.isMaximized()??!1}async maximizeWindow(U,N){this.C(N?.targetWindowId,U)?.win?.maximize()}async unmaximizeWindow(U,N){this.C(N?.targetWindowId,U)?.win?.unmaximize()}async minimizeWindow(U,N){this.C(N?.targetWindowId,U)?.win?.minimize()}async moveWindowTop(U,N){this.C(N?.targetWindowId,U)?.win?.moveTop()}async positionWindow(U,N,z){const ne=this.C(z?.targetWindowId,U);if(ne?.win){if(ne.win.isFullScreen()){const Q=P.Event.toPromise(P.Event.once(P.Event.fromNodeEventEmitter(ne.win,"leave-full-screen")));ne.win.setFullScreen(!1),await Q}ne.win.setBounds(N)}}async updateWindowControls(U,N){this.C(N?.targetWindowId,U)?.updateWindowControls(N)}async focusWindow(U,N){this.C(N?.targetWindowId,U)?.focus({force:N?.force??!1})}async setMinimumSize(U,N,z){const ne=this.D(U);if(ne?.win){const[Q,le]=ne.win.getSize(),[K,ee]=ne.win.getMinimumSize(),[H,j]=[N??K,z??ee],[B,x]=[Math.max(Q,H),Math.max(le,j)];(K!==H||ee!==j)&&ne.win.setMinimumSize(H,j),(Q!==B||le!==x)&&ne.win.setSize(B,x)}}async saveWindowSplash(U,N){this.m.saveWindowSplash(U,N)}async installShellCommand(U){const{source:N,target:z}=await this.u();try{const{symbolicLink:ne}=await m.SymlinkSupport.stat(N);if(ne&&!ne.dangling){const Q=await(0,b.$gr)(N);if(z===Q)return}await m.Promises.unlink(N)}catch(ne){if(ne.code!=="ENOENT")throw ne}try{await m.Promises.symlink(z,N)}catch(ne){if(ne.code!=="EACCES"&&ne.code!=="ENOENT")throw ne;const{response:Q}=await this.showMessageBox(U,{type:"info",message:(0,$.localize)(0,null,this.j.nameShort),buttons:[(0,$.localize)(1,null),(0,$.localize)(2,null)]});if(Q===1)throw new L.$7;try{const le=`osascript -e "do shell script \\"mkdir -p /usr/local/bin && ln -sf '${z}' '${N}'\\" with administrator privileges"`;await(0,D.promisify)(i.exec)(le)}catch{throw new Error((0,$.localize)(3,null,N))}}}async uninstallShellCommand(U){const{source:N}=await this.u();try{await m.Promises.unlink(N)}catch(z){switch(z.code){case"EACCES":{const{response:ne}=await this.showMessageBox(U,{type:"info",message:(0,$.localize)(4,null,this.j.nameShort),buttons:[(0,$.localize)(5,null),(0,$.localize)(6,null)]});if(ne===1)throw new L.$7;try{const Q=`osascript -e "do shell script \\"rm '${N}'\\" with administrator privileges"`;await(0,D.promisify)(i.exec)(Q)}catch{throw new Error((0,$.localize)(7,null,N))}break}case"ENOENT":break;default:throw z}}}async u(){const U=(0,h.$mc)(this.g.appRoot,"bin","code"),N=`/usr/local/bin/${this.j.applicationName}`;if(!await m.Promises.exists(U))throw new Error((0,$.localize)(8,null,U));return{source:N,target:U}}async showMessageBox(U,N){const z=this.C(N?.targetWindowId,U);return this.c.showMessageBox(N,z?.win??void 0)}async showSaveDialog(U,N){const z=this.C(N?.targetWindowId,U);return this.c.showSaveDialog(N,z?.win??void 0)}async showOpenDialog(U,N){const z=this.C(N?.targetWindowId,U);return this.c.showOpenDialog(N,z?.win??void 0)}async pickFileFolderAndOpen(U,N){const z=await this.c.pickFileFolder(N);z&&await this.w(await Promise.all(z.map(async ne=>await m.SymlinkSupport.existsDirectory(ne)?{folderUri:g.URI.file(ne)}:{fileUri:g.URI.file(ne)})),N,U)}async pickFolderAndOpen(U,N){const z=await this.c.pickFolder(N);z&&await this.w(z.map(ne=>({folderUri:g.URI.file(ne)})),N,U)}async pickFileAndOpen(U,N){const z=await this.c.pickFile(N);z&&await this.w(z.map(ne=>({fileUri:g.URI.file(ne)})),N,U)}async pickWorkspaceAndOpen(U,N){const z=await this.c.pickWorkspace(N);z&&await this.w(z.map(ne=>({workspaceUri:g.URI.file(ne)})),N,U)}async w(U,N,z){await this.a.open({context:s.OpenContext.DIALOG,contextWindowId:z,cli:this.g.args,urisToOpen:U,forceNewWindow:N.forceNewWindow})}async showItemInFolder(U,N){o.shell.showItemInFolder(N)}async setRepresentedFilename(U,N,z){this.C(z?.targetWindowId,U)?.setRepresentedFilename(N)}async setDocumentEdited(U,N,z){this.C(z?.targetWindowId,U)?.setDocumentEdited(N)}async openExternal(U,N){return this.g.unsetSnapExportedVariables(),o.shell.openExternal(N),this.g.restoreSnapExportedVariables(),!0}moveItemToTrash(U,N){return o.shell.trashItem(N)}async isAdmin(){let U;return f.$i?U=(await new Promise((N,z)=>{V(["native-is-elevated"],N,z)}).then(Re)).default():U=process.getuid?.()===0,U}async writeElevated(U,N,z,ne){const Q=await new Promise((le,K)=>{V(["@vscode/sudo-prompt"],le,K)}).then(Re);return new Promise((le,K)=>{const ee=[`"${this.z}"`];ne?.unlock&&ee.push("--file-chmod"),ee.push("--file-write",`"${N.fsPath}"`,`"${z.fsPath}"`);const H={name:this.j.nameLong.replace("-",""),icns:f.$j&&this.g.isBuilt?(0,h.$lc)((0,h.$oc)(this.g.appRoot),`${this.j.nameShort}.icns`):void 0};Q.exec(ee.join(" "),H,(j,B,x)=>{B&&this.h.trace(`[sudo-prompt] received stdout: ${B}`),x&&this.h.trace(`[sudo-prompt] received stderr: ${x}`),j?K(j):le(void 0)})})}async isRunningUnderARM64Translation(){return f.$k||f.$i?!1:o.app.runningUnderARM64Translation}get z(){return f.$i?this.g.isBuilt?(0,h.$lc)((0,h.$oc)(process.execPath),"bin",`${this.j.applicationName}.cmd`):(0,h.$lc)(this.g.appRoot,"scripts","code-cli.bat"):f.$k?this.g.isBuilt?(0,h.$lc)((0,h.$oc)(process.execPath),"bin",`${this.j.applicationName}`):(0,h.$lc)(this.g.appRoot,"scripts","code-cli.sh"):this.g.isBuilt?(0,h.$lc)(this.g.appRoot,"bin","code"):(0,h.$lc)(this.g.appRoot,"scripts","code-cli.sh")}async getOSStatistics(){return{totalmem:(0,S.totalmem)(),freemem:(0,S.freemem)(),loadavg:(0,S.loadavg)()}}async getOSProperties(){return{arch:(0,S.arch)(),platform:(0,S.platform)(),release:(0,S.release)(),type:(0,S.type)(),cpus:(0,S.cpus)()}}async getOSVirtualMachineHint(){return l.$Pn.value()}async getOSColorScheme(){return this.m.getColorScheme()}async hasWSLFeatureInstalled(){return f.$i&&(0,E.$efc)()}async getProcessId(U){return this.C(void 0,U)?.win?.webContents.getOSProcessId()}async killProcess(U,N,z){process.kill(N,z)}async readClipboardText(U,N){return o.clipboard.readText(N)}async writeClipboardText(U,N,z){return o.clipboard.writeText(N,z)}async readClipboardFindText(U){return o.clipboard.readFindText()}async writeClipboardFindText(U,N){return o.clipboard.writeFindText(N)}async writeClipboardBuffer(U,N,z,ne){return o.clipboard.writeBuffer(N,Buffer.from(z.buffer),ne)}async readClipboardBuffer(U,N){return I.$Oe.wrap(o.clipboard.readBuffer(N))}async hasClipboard(U,N,z){return o.clipboard.has(N,z)}async newWindowTab(){await this.a.open({context:s.OpenContext.API,cli:this.g.args,forceNewTabbedWindow:!0,forceEmpty:!0,remoteAuthority:this.g.args.remote||void 0})}async showPreviousWindowTab(){o.Menu.sendActionToFirstResponder("selectPreviousTab:")}async showNextWindowTab(){o.Menu.sendActionToFirstResponder("selectNextTab:")}async moveWindowTabToNewWindow(){o.Menu.sendActionToFirstResponder("moveTabToNewWindow:")}async mergeAllWindowTabs(){o.Menu.sendActionToFirstResponder("mergeAllWindows:")}async toggleWindowTabsBar(){o.Menu.sendActionToFirstResponder("toggleTabBar:")}async updateTouchBar(U,N){this.D(U)?.updateTouchBar(N)}async notifyReady(U){this.D(U)?.setReady()}async relaunch(U,N){return this.f.relaunch(N)}async reload(U,N){const z=this.D(U);if(z){if((0,u.$Ui)(z.openedWorkspace)){const ne=z.openedWorkspace.configPath;if(ne.scheme===a.Schemas.file&&(await this.n.resolveLocalWorkspace(ne))?.transient)return this.openWindow(z.id,{forceReuseWindow:!0})}return this.f.reload(z,N?.disableExtensions!==void 0?{_:[],"disable-extensions":N.disableExtensions}:void 0)}}async closeWindow(U,N){return this.C(N?.targetWindowId,U)?.win?.close()}async quit(U){const N=this.a.getLastActiveWindow();N?.isExtensionDevelopmentHost&&this.a.getWindowCount()>1&&N.win?N.win.close():this.f.quit()}async exit(U,N){await this.f.kill(N)}async resolveProxy(U,N){return this.D(U)?.win?.webContents?.session?.resolveProxy(N)}async loadCertificates(U){return(await new Promise((z,ne)=>{V(["@vscode/proxy-agent"],z,ne)}).then(Re)).loadSystemCertificates({log:this.h})}findFreePort(U,N,z,ne,Q=1){return(0,p.$4g)(N,z,ne,Q)}async openDevTools(U,N){this.C(N?.targetWindowId,U)?.win?.webContents.openDevTools(N?.mode?{mode:N.mode,activate:N.activate}:void 0)}async toggleDevTools(U,N){this.C(N?.targetWindowId,U)?.win?.webContents.toggleDevTools()}async profileRenderer(U,N,z){const ne=this.D(U);if(!ne||!ne.win)throw new Error;return await new A.$ffc(ne.win,N,this.h).inspect(z)}async windowsGetStringRegKey(U,N,z,ne){if(!f.$i)return;const Q=await new Promise((le,K)=>{V(["@vscode/windows-registry"],le,K)}).then(Re);try{return Q.GetStringRegKey(N,z,ne)}catch{return}}C(U,N){return this.D(U)??this.F(U)??this.D(N)}D(U){if(typeof U=="number")return this.a.getWindowById(U)}F(U){if(typeof U!="number")return;const N=o.webContents.fromId(U);if(N)return this.b.getWindowByWebContents(N)}};e.$ifc=R,Se([O.$0h],R.prototype,"z",null),e.$ifc=R=Se([re(0,s.$vec),re(1,T.$gfc),re(2,w.$qec),re(3,t.$Oec),re(4,v.$kec),re(5,r.$_j),re(6,n.$sk),re(7,c.$tec),re(8,d.$Hec)],R)});var et=this&&this.__importDefault||function(V){return V&&V.__esModule?V:{default:V}};define(oe[306],ae([0,1,14,27,8,23,31,2,13,4,116,37,185,96,136,58,25,5,75,84,28,85,34,64,57,29]),function(V,e,i,o,S,D,O,P,y,a,h,f,g,b,l,m,p,$,w,v,k,t,r,n,c,s){"use strict";var u;Object.defineProperty(e,"__esModule",{value:!0}),e.$jfc=void 0,v=et(v);const d="issue.processExplorerWindowState";let I=class{static{u=this}static{this.a="#1E1E1E"}constructor(T,L,R,M,U,N,z,ne,Q,le,K){this.g=T,this.h=L,this.i=R,this.j=M,this.k=U,this.l=N,this.m=z,this.n=ne,this.o=Q,this.p=le,this.q=K,this.b=null,this.c=null,this.d=null,this.f=null,this.r()}r(){f.$BX.on("vscode:listProcesses",async T=>{const L=[];try{L.push({name:(0,g.localize)(0,null),rootProcess:await(0,h.$Qs)(process.pid)}),(await this.k.getRemoteDiagnostics({includeProcesses:!0})).forEach(M=>{(0,b.$Tm)(M)?L.push({name:M.hostName,rootProcess:M}):M.processes&&L.push({name:M.hostName,rootProcess:M.processes})})}catch(R){this.i.error(`Listing processes failed: ${R}`)}this.t(T,"vscode:listProcessesResponse",L)}),f.$BX.on("vscode:workbenchCommand",(T,L)=>{const{id:R,from:M,args:U}=L;let N;switch(M){case"processExplorer":N=this.f;break;default:throw new Error(`Unexpected command source: ${M}`)}N?.webContents.send("vscode:runAction",{id:R,from:M,args:U})}),f.$BX.on("vscode:closeProcessExplorer",T=>{this.d?.close()}),f.$BX.on("vscode:pidToNameRequest",async T=>{const L=await this.k.getMainDiagnostics(),R=[];for(const M of L.windows)R.push([M.pid,`window [${M.id}] (${M.title})`]);for(const{pid:M,name:U}of n.$2ec.getAll())R.push([M,U]);this.t(T,"vscode:pidToNameResponse",R)})}async openReporter(T){if(this.b)this.b&&this.s(this.b);else if(this.c=i.BrowserWindow.getFocusedWindow(),this.c){const L=new P.$Vc,R=L.add(this.n.createIPCObjectUrl()),M=this.v(this.c,700,800);this.b=this.u(M,R,{backgroundColor:T.styles.backgroundColor,title:(0,g.localize)(1,null),zoomLevel:T.zoomLevel,alwaysOnTop:!1},"issue-reporter"),R.update({appRoot:this.h.appRoot,windowId:this.b.id,userEnv:this.g,data:T,disableExtensions:!!this.h.disableExtensions,os:{type:(0,o.type)(),arch:(0,o.arch)(),release:(0,o.release)()},product:v.default}),this.b.loadURL(y.$Zg.asBrowserUri(`vs/workbench/contrib/issue/electron-sandbox/issueReporter${this.h.isBuilt?"":"-dev"}.html`).toString(!0)),this.b.on("close",()=>{this.b=null,L.dispose()}),this.c.on("closed",()=>{this.b&&(this.b.close(),this.b=null,L.dispose())})}}async openProcessExplorer(T){if(!this.d&&(this.f=i.BrowserWindow.getFocusedWindow(),this.f)){const L=new P.$Vc,R=L.add(this.n.createIPCObjectUrl()),M=this.p.getItem(d,void 0),U=E(M)?M:this.v(this.f,800,500);this.d=this.u(U,R,{backgroundColor:T.styles.backgroundColor,title:(0,g.localize)(2,null),zoomLevel:T.zoomLevel,alwaysOnTop:!0},"process-explorer"),R.update({appRoot:this.h.appRoot,windowId:this.d.id,userEnv:this.g,data:T,product:v.default}),this.d.loadURL(y.$Zg.asBrowserUri(`vs/code/electron-sandbox/processExplorer/processExplorer${this.h.isBuilt?"":"-dev"}.html`).toString(!0)),this.d.on("close",()=>{this.d=null,L.dispose()}),this.f.on("close",()=>{this.d&&(this.d.close(),this.d=null,L.dispose())});const N=()=>{if(!this.d)return;const z=this.d.getSize(),ne=this.d.getPosition();if(!z||!ne)return;const Q={width:z[0],height:z[1],x:ne[0],y:ne[1]};this.p.setItem(d,Q)};this.d.on("moved",N),this.d.on("resized",N)}this.d&&this.s(this.d)}async stopTracing(){if(!this.h.args.trace)return;const T=await i.contentTracing.stopRecording(`${(0,O.$Ng)(this.h.userHome.fsPath,this.o.applicationName)}.trace.txt`);await this.l.showMessageBox({type:"info",message:(0,g.localize)(3,null),detail:(0,g.localize)(4,null,T),buttons:[(0,g.localize)(5,null)]},i.BrowserWindow.getFocusedWindow()??void 0),this.m.showItemInFolder(void 0,T)}async getSystemStatus(){const[T,L]=await Promise.all([this.k.getMainDiagnostics(),this.k.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return this.j.getDiagnostics(T,L)}async $getSystemInfo(){const[T,L]=await Promise.all([this.k.getMainDiagnostics(),this.k.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return await this.j.getSystemInfo(T,L)}async $getPerformanceInfo(){try{const[T,L]=await Promise.all([this.k.getMainDiagnostics(),this.k.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0})]);return await this.j.getPerformanceInfo(T,L)}catch(T){throw this.i.warn("issueService#getPerformanceInfo ",T.message),T}}async $reloadWithExtensionsDisabled(){if(this.c)try{await this.m.reload(this.c.id,{disableExtensions:!0})}catch(T){this.i.error(T)}}async $showConfirmCloseDialog(){if(this.b){const{response:T}=await this.l.showMessageBox({type:"warning",message:(0,g.localize)(6,null),buttons:[(0,g.localize)(7,null),(0,g.localize)(8,null)]},this.b);T===0&&this.b&&(this.b.destroy(),this.b=null)}}async $showClipboardDialog(){if(this.b){const{response:T}=await this.l.showMessageBox({type:"warning",message:(0,g.localize)(9,null),buttons:[(0,g.localize)(10,null),(0,g.localize)(11,null)]},this.b);return T===0}return!1}issueReporterWindowCheck(){if(!this.c)throw new Error("Issue reporter window not available");const T=this.q.getWindowById(this.c.id);if(!T)throw new Error("Window not found");return T}async $sendReporterMenu(T,L){const R=this.issueReporterWindowCheck(),M="vscode:triggerReporterMenu",U=new D.$xe;return R.sendWhenReady(M,U.token,{replyChannel:M,extensionId:T,extensionName:L}),await(0,S.$wh)(new Promise(z=>f.$BX.once(`vscode:triggerReporterMenuResponse:${T}`,(ne,Q)=>z(Q))),5e3,()=>{this.i.error(`Error: Extension ${T} timed out waiting for menu response`),U.cancel()})}async $closeReporter(){this.b?.close()}async closeProcessExplorer(){this.d?.close()}s(T){T.isMinimized()&&T.restore(),T.focus()}t(T,L,...R){T.sender.isDestroyed()||T.sender.send(L,...R)}u(T,L,R,M){const U=new i.BrowserWindow({fullscreen:!1,skipTaskbar:!1,resizable:!0,width:T.width,height:T.height,minWidth:300,minHeight:200,x:T.x,y:T.y,title:R.title,backgroundColor:R.backgroundColor||u.a,webPreferences:{preload:y.$Zg.asFileUri("vs/base/parts/sandbox/electron-sandbox/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${L.resource.toString()}`],v8CacheOptions:this.h.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,c.$6D)(R.zoomLevel),sandbox:!0},alwaysOnTop:R.alwaysOnTop,experimentalDarkMode:!0});return U.setMenuBarVisibility(!1),U}v(T,L,R){let M;const U=i.screen.getAllDisplays();if(U.length===1)M=U[0];else{if(a.$j){const ne=i.screen.getCursorScreenPoint();M=i.screen.getDisplayNearestPoint(ne)}!M&&T&&(M=i.screen.getDisplayMatching(T.getBounds())),M||(M=i.screen.getPrimaryDisplay()||U[0])}const N=M.bounds,z={width:L,height:R,x:N.x+N.width/2-L/2,y:N.y+N.height/2-R/2};return N.width>0&&N.height>0&&(z.x<N.x&&(z.x=N.x),z.y<N.y&&(z.y=N.y),z.x>N.x+N.width&&(z.x=N.x),z.y>N.y+N.height&&(z.y=N.y),z.width>N.width&&(z.width=N.width),z.height>N.height&&(z.height=N.height)),z}};e.$jfc=I,e.$jfc=I=u=Se([re(1,p.$kec),re(2,$.$_j),re(3,b.$Sm),re(4,l.$5ec),re(5,m.$qec),re(6,w.$hfc),re(7,t.$sec),re(8,k.$sk),re(9,r.$dR),re(10,s.$vec)],I);function E(A){return typeof A!="object"||A===null?!1:"x"in A&&"y"in A&&"width"in A&&"height"in A}}),define(oe[307],ae([0,1,23,18,25,20,5,75,28,55,24,50,106]),function(V,e,i,o,S,D,O,P,y,a,h,f,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kfc=void 0;let b=class extends g.$Ifc{constructor(m,p,$,w,v,k,t,r){super(m,p,w,v,k,r),this.e=$,this.u=t}s(m){return(0,g.$Hfc)(`linux-${process.arch}`,m,this.k)}t(m){this.a&&(this.d(f.$zY.CheckingForUpdates(m)),this.i.request({url:this.a},i.CancellationToken.None).then(a.$7p).then(p=>{!p||!p.url||!p.version||!p.productVersion?(this.e.publicLog2("update:notAvailable",{explicit:!!m}),this.d(f.$zY.Idle(f.UpdateType.Archive))):this.d(f.$zY.AvailableForDownload(p))}).then(void 0,p=>{this.j.error(p);const $=m?p.message||p:void 0;this.d(f.$zY.Idle(f.UpdateType.Archive,$))}))}async o(m){this.k.downloadUrl&&this.k.downloadUrl.length>0?this.u.openExternal(void 0,this.k.downloadUrl):m.update.url&&this.u.openExternal(void 0,m.update.url),this.d(f.$zY.Idle(f.UpdateType.Archive))}};e.$Kfc=b,e.$Kfc=b=Se([re(0,D.$Oec),re(1,o.$_i),re(2,h.$$l),re(3,S.$kec),re(4,a.$1p),re(5,O.$_j),re(6,P.$hfc),re(7,y.$sk)],b)}),define(oe[308],ae([0,1,49,47,27,8,23,52,46,9,7,149,21,18,25,15,20,5,75,28,55,24,50,106]),function(V,e,i,o,S,D,O,P,y,a,h,f,g,b,l,m,p,$,w,v,k,t,r,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mfc=void 0,o=Re(o),a=Re(a),g=Re(g);async function c(I,E=1e3){for(;!I();)await(0,D.$Gh)(E)}let s;function u(){return typeof s>"u"&&(s=o.existsSync(a.$lc(a.$oc(process.execPath),"unins000.exe"))?r.UpdateType.Setup:r.UpdateType.Archive),s}let d=class extends n.$Ifc{get cachePath(){const E=a.$lc((0,S.tmpdir)(),`vscode-${this.k.quality}-${this.k.target}-${process.arch}`);return g.Promises.mkdir(E,{recursive:!0}).then(()=>E)}constructor(E,A,T,L,R,M,U,N,z){super(E,A,L,R,M,z),this.u=T,this.v=U,this.w=N,E.setRelaunchHandler(this)}handleRelaunch(E){return E?.addArgs||E?.removeArgs||this.state.type!==r.StateType.Ready||!this.e?!1:(this.j.trace("update#handleRelaunch(): running raw#quitAndInstall()"),this.r(),!0)}async l(){if(this.k.target==="user"&&await this.w.isAdmin(void 0)){this.d(r.$zY.Disabled(r.DisablementReason.RunningAsAdmin)),this.j.info("update#ctor - updates are disabled due to running as Admin in user setup");return}await super.l()}s(E){let A=`win32-${process.arch}`;return u()===r.UpdateType.Archive?A+="-archive":this.k.target==="user"&&(A+="-user"),(0,n.$Hfc)(A,E,this.k)}t(E){this.a&&(this.d(r.$zY.CheckingForUpdates(E)),this.i.request({url:this.a},O.CancellationToken.None).then(k.$7p).then(A=>{const T=u();return!A||!A.url||!A.version||!A.productVersion?(this.u.publicLog2("update:notAvailable",{explicit:!!E}),this.d(r.$zY.Idle(T)),Promise.resolve(null)):T===r.UpdateType.Archive?(this.d(r.$zY.AvailableForDownload(A)),Promise.resolve(null)):(this.d(r.$zY.Downloading),this.C(A.version).then(()=>this.B(A.version).then(L=>g.Promises.exists(L).then(R=>{if(R)return Promise.resolve(L);const M=`${L}.tmp`;return this.i.request({url:A.url},O.CancellationToken.None).then(U=>this.v.writeFile(h.URI.file(M),U.stream)).then(A.sha256hash?()=>(0,f.$uX)(M,A.sha256hash):()=>{}).then(()=>g.Promises.rename(M,L,!1)).then(()=>L)})).then(L=>{this.e={packagePath:L},this.d(r.$zY.Downloaded(A)),this.g.getValue("update.enableWindowsBackgroundUpdates")?this.k.target==="user"&&this.p():this.d(r.$zY.Ready(A))})))}).then(void 0,A=>{this.u.publicLog2("update:error",{messageHash:String((0,y.$tj)(String(A)))}),this.j.error(A);const T=E?A.message||A:void 0;this.d(r.$zY.Idle(u(),T))}))}async o(E){E.update.url&&this.w.openExternal(void 0,E.update.url),this.d(r.$zY.Idle(u()))}async B(E){const A=await this.cachePath;return a.$lc(A,`CodeSetup-${this.k.quality}-${E}.exe`)}async C(E=null){const A=E?M=>!new RegExp(`${this.k.quality}-${E}\\.exe$`).test(M):()=>!0,T=await this.cachePath,R=(await g.Promises.readdir(T)).filter(A).map(async M=>{try{await g.Promises.unlink(a.$lc(T,M))}catch{}});await Promise.all(R)}async p(){if(this.state.type!==r.StateType.Downloaded||!this.e)return Promise.resolve(void 0);const E=this.state.update;this.d(r.$zY.Updating(E));const A=await this.cachePath;this.e.updateFilePath=a.$lc(A,`CodeSetup-${this.k.quality}-${E.version}.flag`),await g.Promises.writeFile(this.e.updateFilePath,"flag"),(0,i.spawn)(this.e.packagePath,["/verysilent","/log",`/update="${this.e.updateFilePath}"`,"/nocloseapplications","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"],windowsVerbatimArguments:!0}).once("exit",()=>{this.e=void 0,this.d(r.$zY.Idle(u()))});const L=`${this.k.win32MutexName}-ready`,R=await new Promise((M,U)=>{V(["@vscode/windows-mutex"],M,U)}).then(Re);c(()=>R.isActive(L)).then(()=>this.d(r.$zY.Ready(E)))}r(){this.state.type!==r.StateType.Ready||!this.e||(this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.e.updateFilePath?o.unlinkSync(this.e.updateFilePath):(0,i.spawn)(this.e.packagePath,["/silent","/log","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"]}))}q(){return u()}async _applySpecificUpdate(E){if(this.state.type!==r.StateType.Idle)return;const A=this.g.getValue("update.enableWindowsBackgroundUpdates"),T={version:"unknown",productVersion:"unknown"};this.d(r.$zY.Downloading),this.e={packagePath:E},this.d(r.$zY.Downloaded(T)),A?this.k.target==="user"&&this.p():this.d(r.$zY.Ready(T))}};e.$Mfc=d,Se([P.$0h],d.prototype,"cachePath",null),e.$Mfc=d=Se([re(0,p.$Oec),re(1,b.$_i),re(2,t.$$l),re(3,l.$kec),re(4,k.$1p),re(5,$.$_j),re(6,m.$_k),re(7,w.$hfc),re(8,v.$sk)],d)}),define(oe[137],ae([0,1,14,8,23,53,3,2,13,70,4,7,196,27,69,18,58,25,68,15,20,5,28,85,284,87,24,111,74,57,29,30,60,51,40,34,59,71,22,6]),function(V,e,i,o,S,D,O,P,y,a,h,f,g,b,l,m,p,$,w,v,k,t,r,n,c,s,u,d,I,E,A,T,L,R,M,U,N,z,ne,Q){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mec=e.$Lec=void 0;var le;(function(H){H[H.NONE=0]="NONE",H[H.NAVIGATING=1]="NAVIGATING",H[H.READY=2]="READY"})(le||(le={}));class K extends P.$Wc{get lastFocusTime(){return this.j}get win(){return this.m}n(j){this.m=j,this.B(O.Event.fromNodeEventEmitter(j,"maximize")(()=>this.b.fire())),this.B(O.Event.fromNodeEventEmitter(j,"unmaximize")(()=>this.c.fire())),this.B(O.Event.fromNodeEventEmitter(j,"closed")(()=>{this.a.fire(),this.dispose()})),this.B(O.Event.fromNodeEventEmitter(j,"focus")(()=>{this.j=Date.now()})),this.B(O.Event.fromNodeEventEmitter(this.m,"enter-full-screen")(()=>this.g.fire())),this.B(O.Event.fromNodeEventEmitter(this.m,"leave-full-screen")(()=>this.h.fire()));const B=!(0,E.$1D)(this.r);if(h.$j&&B&&j.setSheetOffset((0,h.$J)((0,b.release)())?28:22),B&&(h.$i&&(0,E.$4D)(this.r)||h.$j)){const x=this.s.getItem(K.D);x?this.updateWindowControls({height:x}):this.updateWindowControls({height:E.$3D})}h.$i&&B&&j.hookWindowMessage(278,()=>{const[ce,G]=j.getPosition(),he=i.screen.getCursorScreenPoint(),se=he.x-ce,_=he.y-G;return!(se>30&&_>=0&&_<=Math.max(j.getBounds().height*.15,35))||(j.setEnabled(!1),j.setEnabled(!0),this.f.fire({x:se,y:_})),0}),this.t.args["open-devtools"]===!0&&j.webContents.openDevTools(),h.$j&&(this.B(this.onDidEnterFullScreen(()=>{this.H?.complete(!0)})),this.B(this.onDidLeaveFullScreen(()=>{this.H?.complete(!0)})))}constructor(j,B,x,ce){super(),this.r=j,this.s=B,this.t=x,this.u=ce,this.a=this.B(new O.$me),this.onDidClose=this.a.event,this.b=this.B(new O.$me),this.onDidMaximize=this.b.event,this.c=this.B(new O.$me),this.onDidUnmaximize=this.c.event,this.f=this.B(new O.$me),this.onDidTriggerSystemContextMenu=this.f.event,this.g=this.B(new O.$me),this.onDidEnterFullScreen=this.g.event,this.h=this.B(new O.$me),this.onDidLeaveFullScreen=this.h.event,this.j=Date.now(),this.m=null,this.F=(0,E.$4D)(this.r),this.G=void 0,this.H=void 0}w(j,B=i.screen.getAllDisplays().length>0){const x=this.r.getValue("window"),ce=h.$j&&x?.nativeTabs===!0;(h.$j||h.$i)&&B&&(!ce||i.BrowserWindow.getAllWindows().length===1)&&[j.width,j.height,j.x,j.y].every(G=>typeof G=="number")&&this.m?.setBounds({width:j.width,height:j.height,x:j.x,y:j.y}),(j.mode===R.WindowMode.Maximized||j.mode===R.WindowMode.Fullscreen)&&(this.m?.maximize(),j.mode===R.WindowMode.Fullscreen&&this.I(!0,!0),this.m?.show())}setRepresentedFilename(j){h.$j?this.win?.setRepresentedFilename(j):this.z=j}getRepresentedFilename(){return h.$j?this.win?.getRepresentedFilename():this.z}setDocumentEdited(j){h.$j&&this.win?.setDocumentEdited(j),this.C=j}isDocumentEdited(){return h.$j?!!this.win?.isDocumentEdited():!!this.C}focus(j){h.$j&&j?.force&&i.app.focus({steal:!0});const B=this.win;B&&(B.isMinimized()&&B.restore(),B.focus())}handleTitleDoubleClick(){const j=this.win;if(j)if(h.$j)switch(i.systemPreferences.getUserDefault("AppleActionOnDoubleClick","string")){case"Minimize":j.minimize();break;case"None":break;case"Maximize":default:j.isMaximized()?j.unmaximize():j.maximize()}else j.isMaximized()?j.unmaximize():j.maximize()}static{this.D="windowControlHeight"}updateWindowControls(j){const B=this.win;if(B){if(j.height&&this.s.setItem(ee.D,j.height),h.$i&&this.F)B.setTitleBarOverlay({color:j.backgroundColor?.trim()===""?void 0:j.backgroundColor,symbolColor:j.foregroundColor?.trim()===""?void 0:j.foregroundColor,height:j.height?j.height-1:void 0});else if(h.$j&&j.height!==void 0){const x=(j.height-15)/2;x?B.setWindowButtonPosition({x,y:x}):B.setWindowButtonPosition(null)}}}toggleFullScreen(){this.I(!this.isFullScreen,!1)}I(j,B){(0,E.$5D)(this.r)?this.J(j,B):this.M(j)}get isFullScreen(){if(h.$j&&typeof this.G=="boolean")return this.G;const j=this.win,B=j?.isFullScreen(),x=j?.isSimpleFullScreen();return!!(B||x)}J(j,B){const x=this.win;x?.isSimpleFullScreen()&&x?.setSimpleFullScreen(!1),this.L(j,B)}L(j,B){if(h.$j){this.G=j;const ce=this.H=new o.$3h;(async()=>{const G=await Promise.race([ce.p,(0,o.$Gh)(1e4).then(()=>!1)]);this.H===ce&&(this.G=void 0,this.H=void 0,!G&&j&&B&&this.win&&!this.win.isFullScreen()&&(this.u.warn("window: native macOS fullscreen transition did not happen within 10s from restoring"),this.h.fire()))})()}this.win?.setFullScreen(j)}M(j){const B=this.win;B?.isFullScreen()&&this.L(!1,!1),B?.setSimpleFullScreen(j),B?.webContents.focus()}dispose(){super.dispose(),this.m=null}}e.$Lec=K;let ee=class extends K{get id(){return this.Q}get backupPath(){return this.S?.backupPath}get openedWorkspace(){return this.S?.workspace}get profile(){if(!this.config)return;const j=this.hb.profiles.find(B=>B.id===this.config?.profiles.profile.id);return this.isExtensionDevelopmentHost&&j?j:this.hb.getProfileForWorkspace(this.config.workspace??(0,T.$Ti)(this.backupPath,this.isExtensionDevelopmentHost))??this.hb.defaultProfile}get remoteAuthority(){return this.S?.remoteAuthority}get config(){return this.S}get isExtensionDevelopmentHost(){return!!this.S?.extensionDevelopmentPath}get isExtensionTestHost(){return!!this.S?.extensionTestsPath}get isExtensionDevelopmentTestFromCli(){return this.isExtensionDevelopmentHost&&this.isExtensionTestHost&&!this.S?.debugId}constructor(j,B,x,ce,G,he,se,_,F,C,W,q,J,X,Z,ie,de,me,pe,Ie,ke){super(C,Ie,ce,B),this.fb=x,this.gb=G,this.hb=he,this.ib=se,this.jb=_,this.kb=F,this.lb=W,this.mb=q,this.nb=J,this.ob=X,this.pb=Z,this.qb=ie,this.rb=de,this.sb=me,this.tb=pe,this.N=this.B(new O.$me),this.onWillLoad=this.N.event,this.O=this.B(new O.$me),this.onDidSignalReady=this.O.event,this.P=this.B(new O.$me),this.onDidDestroy=this.P.event,this.X=[],this.Y=[],this.Z=void 0,this.$=void 0,this.ab=void 0,this.bb=this.B(this.sb.createIPCObjectUrl()),this.eb=!1,this.ub=le.NONE;{const[Pe,De]=this.Eb(j.state);this.U=Pe,this.u.trace("window#ctor: using window state",Pe);const $e=ke.invokeFunction(A.$wec,this.U,{preload:y.$Zg.asFileUri("vs/base/parts/sandbox/electron-sandbox/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${this.bb.resource.toString()}`],v8CacheOptions:this.t.useCodeCache?"bypassHeatCheck":"none"});(0,a.mark)("code/willCreateCodeBrowserWindow"),this.m=new i.BrowserWindow($e),(0,a.mark)("code/didCreateCodeBrowserWindow"),this.Q=this.m.id,this.n(this.m),this.w(this.U,De),this.j=Date.now()}this.Bb(),this.Kb(),this.vb()}setReady(){for(this.u.trace(`window#load: window reported ready (id: ${this.Q})`),this.ub=le.READY;this.X.length;)this.X.pop()(this);this.O.fire()}ready(){return new Promise(j=>{if(this.isReady)return j(this);this.X.push(j)})}get isReady(){return this.ub===le.READY}get whenClosedOrLoaded(){return new Promise(j=>{function B(){x.dispose(),ce.dispose(),j()}const x=this.onDidClose(()=>B()),ce=this.onWillLoad(()=>B())})}vb(){this.B(O.Event.fromNodeEventEmitter(this.m,"unresponsive")(()=>this.yb(R.WindowError.UNRESPONSIVE))),this.B(O.Event.fromNodeEventEmitter(this.m.webContents,"render-process-gone",(B,x)=>x)(B=>this.yb(R.WindowError.PROCESS_GONE,{...B}))),this.B(O.Event.fromNodeEventEmitter(this.m.webContents,"did-fail-load",(B,x,ce)=>({exitCode:x,reason:ce}))(({exitCode:B,reason:x})=>this.yb(R.WindowError.LOAD,{reason:x,exitCode:B}))),this.B(O.Event.fromNodeEventEmitter(this.m.webContents,"will-prevent-unload")(B=>B.preventDefault())),this.B(O.Event.fromNodeEventEmitter(this.m.webContents,"did-finish-load")(()=>{this.db&&(this.S=this.db,this.db=void 0)})),this.B(this.onDidMaximize(()=>{this.S&&(this.S.maximized=!0)})),this.B(this.onDidUnmaximize(()=>{this.S&&(this.S.maximized=!1)})),this.B(this.onDidEnterFullScreen(()=>{this.sendWhenReady("vscode:enterFullScreen",S.CancellationToken.None)})),this.B(this.onDidLeaveFullScreen(()=>{this.sendWhenReady("vscode:leaveFullScreen",S.CancellationToken.None)})),this.B(this.r.onDidChangeConfiguration(B=>this.Bb(B))),this.B(this.mb.onDidDeleteUntitledWorkspace(B=>this.Ab(B)));const j=["https://marketplace.visualstudio.com/*","https://*.vsassets.io/*"];this.m.webContents.session.webRequest.onBeforeSendHeaders({urls:j},async(B,x)=>{const ce=await this.xb();x({cancel:!1,requestHeaders:Object.assign(B.requestHeaders,ce)})})}xb(){return this.wb||(this.wb=(0,c.$iq)(this.rb.version,this.rb,this.t,this.r,this.ib,this.jb,this.ob)),this.wb}async yb(j,B){switch(j){case R.WindowError.PROCESS_GONE:this.u.error(`CodeWindow: renderer process gone (reason: ${B?.reason||"<unknown>"}, code: ${B?.exitCode||"<unknown>"})`);break;case R.WindowError.UNRESPONSIVE:this.u.error("CodeWindow: detected unresponsive");break;case R.WindowError.LOAD:this.u.error(`CodeWindow: failed to load (reason: ${B?.reason||"<unknown>"}, code: ${B?.exitCode||"<unknown>"})`);break}switch(this.ob.publicLog2("windowerror",{type:j,reason:B?.reason,code:B?.exitCode}),j){case R.WindowError.UNRESPONSIVE:case R.WindowError.PROCESS_GONE:if(this.isExtensionDevelopmentTestFromCli){this.qb.kill(1);return}if(this.t.args["enable-smoke-test-driver"]){await this.zb(!1,!1),this.qb.quit();return}if(j===R.WindowError.UNRESPONSIVE){if(this.isExtensionDevelopmentHost||this.isExtensionTestHost||this.m&&this.m.webContents&&this.m.webContents.isDevToolsOpened())return;const{response:x,checkboxChecked:ce}=await this.pb.showMessageBox({type:"warning",buttons:[(0,g.localize)(0,null),(0,g.localize)(1,null),(0,g.localize)(2,null)],message:(0,g.localize)(3,null),detail:(0,g.localize)(4,null),checkboxLabel:this.S?.workspace?(0,g.localize)(5,null):void 0},this.m);if(x!==2){const G=x===0;await this.zb(G,ce)}}else if(j===R.WindowError.PROCESS_GONE){let x;B?x=(0,g.localize)(7,null,B.reason,B.exitCode??"<unknown>"):x=(0,g.localize)(6,null);const{response:ce,checkboxChecked:G}=await this.pb.showMessageBox({type:"warning",buttons:[this.S?.workspace?(0,g.localize)(8,null):(0,g.localize)(9,null),(0,g.localize)(10,null)],message:x,detail:this.S?.workspace?(0,g.localize)(11,null):(0,g.localize)(12,null),checkboxLabel:this.S?.workspace?(0,g.localize)(13,null):void 0},this.m),he=ce===0;await this.zb(he,G)}break}}async zb(j,B){const x=this.S?.workspace;if(B&&x)try{const ce=this.kb.workspaceStorage(x);await ce.init(),ce.delete("memento/workbench.parts.editor"),await ce.close()}catch(ce){this.u.error(ce)}this.P.fire();try{if(j&&this.S){let ce,G;(0,T.$Pi)(x)?ce={folderUri:x.uri}:(0,T.$Ui)(x)?ce={workspaceUri:x.configPath}:G=!0,(0,ne.$Qb)(await this.tb.open({context:A.OpenContext.API,userEnv:this.S.userEnv,cli:{...this.t.args,_:[]},urisToOpen:ce?[ce]:void 0,forceEmpty:G,forceNewWindow:!0,remoteAuthority:this.remoteAuthority}))?.focus()}}finally{this.m?.destroy()}}Ab(j){this.S?.workspace?.id===j.id&&(this.S.workspace=void 0)}Bb(j){if(!j||j.affectsConfiguration("window.menuBarVisibility")){const B=this.Gb();B!==this.W&&(this.W=B,this.Hb(B))}if(!j||j.affectsConfiguration("http.proxy")){let B=(this.r.getValue("http.proxy")||"").trim()||(process.env.https_proxy||process.env.HTTPS_PROXY||process.env.http_proxy||process.env.HTTP_PROXY||"").trim()||void 0;B?.endsWith("/")&&(B=B.substr(0,B.length-1));const x=(process.env.no_proxy||process.env.NO_PROXY||"").trim()||void 0;if((B||"").indexOf("@")===-1&&(B!==this.Z||x!==this.$)){this.Z=B,this.$=x;const ce=B||"",G=x?`${x},<local>`:"<local>";this.u.trace(`Setting proxy to '${ce}', bypassing '${G}'`),this.m.webContents.session.setProxy({proxyRules:ce,proxyBypassRules:G,pacScript:""}),typeof i.app.setProxy=="function"&&i.app.setProxy({proxyRules:ce,proxyBypassRules:G,pacScript:""})}}}addTabbedWindow(j){h.$j&&j.win&&this.m.addTabbedWindow(j.win)}load(j,B=Object.create(null)){this.u.trace(`window#load: attempt to load window (id: ${this.Q})`),this.isDocumentEdited()&&(!B.isReload||!this.nb.isHotExitEnabled())&&this.setDocumentEdited(!1),B.isReload||(this.getRepresentedFilename()&&this.setRepresentedFilename(""),this.m.setTitle(this.rb.nameLong)),this.Cb(j,B),this.ub===le.NONE?this.S=j:this.db=j,this.ub=le.NAVIGATING,this.m.loadURL(y.$Zg.asBrowserUri(`vs/code/electron-sandbox/workbench/workbench${this.t.isBuilt?"":"-dev"}.html`).toString(!0));const x=this.eb;this.eb=!0,!this.t.isBuilt&&!this.t.extensionTestsLocationURI&&this.B(new o.$Rh(()=>{this.m&&!this.m.isVisible()&&!this.m.isMinimized()&&(this.m.show(),this.focus({force:!0}),this.m.webContents.openDevTools())},1e4)).schedule(),this.N.fire({workspace:j.workspace,reason:B.isReload?R.LoadReason.RELOAD:x?R.LoadReason.LOAD:R.LoadReason.INITIAL})}Cb(j,B){const x=(this.S??this.db)?.userEnv;if(x){const ce=(0,w.$Jm)(x)&&!(0,w.$Jm)(j.userEnv),G=this.isExtensionDevelopmentHost;(ce||G)&&(j.userEnv={...x,...j.userEnv})}process.env.CHROME_CRASHPAD_PIPE_NAME&&Object.assign(j.userEnv,{CHROME_CRASHPAD_PIPE_NAME:process.env.CHROME_CRASHPAD_PIPE_NAME}),B.disableExtensions!==void 0&&(j["disable-extensions"]=B.disableExtensions),j.fullscreen=this.isFullScreen,j.maximized=this.m.isMaximized(),j.partsSplash=this.lb.getWindowSplash(),j.zoomLevel=this.Jb(),j.isCustomZoomLevel=typeof this.ab=="number",j.isCustomZoomLevel&&j.partsSplash&&(j.partsSplash.zoomLevel=j.zoomLevel),(0,a.mark)("code/willOpenNewWindow"),j.perfMarks=(0,a.getMarks)(),this.bb.update(j)}async reload(j){const B=Object.assign({},this.S);B.workspace=await this.Db(B),delete B.filesToOpenOrCreate,delete B.filesToDiff,delete B.filesToMerge,delete B.filesToWait,this.isExtensionDevelopmentHost&&j&&(B.verbose=j.verbose,B.debugId=j.debugId,B.extensionEnvironment=j.extensionEnvironment,B["inspect-extensions"]=j["inspect-extensions"],B["inspect-brk-extensions"]=j["inspect-brk-extensions"],B["extensions-dir"]=j["extensions-dir"]),B.accessibilitySupport=i.app.isAccessibilitySupportEnabled(),B.isInitialStartup=!1,B.policiesData=this.gb.serialize(),B.continueOn=this.t.continueOn,B.profiles={all:this.hb.profiles,profile:this.profile||this.hb.defaultProfile,home:this.hb.profilesHome},B.logLevel=this.fb.getLogLevel(),B.loggers={window:this.fb.getRegisteredLoggers(this.id),global:this.fb.getRegisteredLoggers()},this.load(B,{isReload:!0,disableExtensions:j?.["disable-extensions"]})}async Db(j){if((0,T.$Ui)(j.workspace)){const B=j.workspace.configPath;if(B.scheme===y.Schemas.file&&!await this.ib.exists(B))return}else if((0,T.$Pi)(j.workspace)){const B=j.workspace.uri;if(B.scheme===y.Schemas.file&&!await this.ib.exists(B))return}return j.workspace}serializeWindowState(){if(!this.m)return(0,R.$iec)();if(this.isFullScreen){let x;try{x=i.screen.getDisplayMatching(this.getBounds())}catch{}const ce=(0,R.$iec)();return{mode:R.WindowMode.Fullscreen,display:x?x.id:void 0,width:this.U.width||ce.width,height:this.U.height||ce.height,x:this.U.x||0,y:this.U.y||0,zoomLevel:this.ab}}const j=Object.create(null);let B;if(!h.$j&&this.m.isMaximized()?B=R.WindowMode.Maximized:B=R.WindowMode.Normal,B===R.WindowMode.Maximized?j.mode=R.WindowMode.Maximized:j.mode=R.WindowMode.Normal,B===R.WindowMode.Normal||B===R.WindowMode.Maximized){let x;B===R.WindowMode.Normal?x=this.getBounds():x=this.m.getNormalBounds(),j.x=x.x,j.y=x.y,j.width=x.width,j.height=x.height}return j.zoomLevel=this.ab,j}Eb(j){(0,a.mark)("code/willRestoreCodeWindowState");let B=!1;if(j){this.ab=j.zoomLevel;try{const x=i.screen.getAllDisplays();B=x.length>1,j=A.WindowStateValidator.validateWindowState(this.u,j,x)}catch(x){this.u.warn(`Unexpected error validating window state: ${x}
${x.stack}`)}}return(0,a.mark)("code/didRestoreCodeWindowState"),[j||(0,R.$iec)(),B]}getBounds(){const[j,B]=this.m.getPosition(),[x,ce]=this.m.getSize();return{x:j,y:B,width:x,height:ce}}I(j,B){super.I(j,B),this.sendWhenReady(j?"vscode:enterFullScreen":"vscode:leaveFullScreen",S.CancellationToken.None),this.W&&this.Hb(this.W,!1)}Gb(){let j=(0,E.$YD)(this.r);return["visible","toggle","hidden"].indexOf(j)<0&&(j="classic"),j}Hb(j,B=!0){h.$j||(j==="toggle"&&B&&this.send("vscode:showInfoMessage",(0,g.localize)(14,null)),j==="hidden"?setTimeout(()=>{this.Ib(j)}):this.Ib(j))}Ib(j){const B=this.isFullScreen;switch(j){case"classic":this.m.setMenuBarVisibility(!B),this.m.autoHideMenuBar=B;break;case"visible":this.m.setMenuBarVisibility(!0),this.m.autoHideMenuBar=!1;break;case"toggle":this.m.setMenuBarVisibility(!1),this.m.autoHideMenuBar=!0;break;case"hidden":this.m.setMenuBarVisibility(!1),this.m.autoHideMenuBar=!1;break}}notifyZoomLevel(j){this.ab=j}Jb(){return typeof this.ab=="number"?this.ab:this.r.getValue("window")?.zoomLevel}close(){this.m?.close()}sendWhenReady(j,B,...x){this.isReady?this.send(j,...x):this.ready().then(()=>{B.isCancellationRequested||this.send(j,...x)})}send(j,...B){if(this.m){if(this.m.isDestroyed()||this.m.webContents.isDestroyed()){this.u.warn(`Sending IPC message to channel '${j}' for window that is destroyed`);return}try{this.m.webContents.send(j,...B)}catch(x){this.u.warn(`Error sending IPC message to channel '${j}' of window ${this.Q}: ${(0,D.$qj)(x)}`)}}}updateTouchBar(j){h.$j&&this.Y.forEach((B,x)=>{const ce=j[x];B.segments=this.Mb(ce)})}Kb(){if(h.$j){for(let j=0;j<10;j++){const B=this.Lb();this.Y.push(B)}this.m.setTouchBar(new i.TouchBar({items:this.Y}))}}Lb(j=[]){const B=this.Mb(j),x=new i.TouchBar.TouchBarSegmentedControl({segments:B,mode:"buttons",segmentStyle:"automatic",change:ce=>{this.sendWhenReady("vscode:runAction",S.CancellationToken.None,{id:x.segments[ce].id,from:"touchbar"})}});return x}Mb(j=[]){return j.map(x=>{let ce;x.icon&&!d.ThemeIcon.isThemeIcon(x.icon)&&x.icon?.dark?.scheme===y.Schemas.file&&(ce=i.nativeImage.createFromPath(f.URI.revive(x.icon.dark).fsPath),ce.isEmpty()&&(ce=void 0));let G;return typeof x.title=="string"?G=x.title:G=x.title.value,{id:x.id,label:ce?void 0:G,icon:ce}})}matches(j){return this.m?.webContents.id===j.id}dispose(){super.dispose(),this.fb.deregisterLoggers(this.id)}};e.$Mec=ee,e.$Mec=ee=Se([re(1,t.$_j),re(2,z.$Jec),re(3,$.$kec),re(4,M.$qo),re(5,N.$yec),re(6,v.$_k),re(7,s.$Wec),re(8,s.$Uec),re(9,m.$_i),re(10,I.$tec),re(11,L.$Hec),re(12,l.$pec),re(13,u.$$l),re(14,p.$qec),re(15,k.$Oec),re(16,r.$sk),re(17,n.$sec),re(18,A.$vec),re(19,U.$dR),re(20,Q.$Ei)],ee)}),define(oe[309],ae([0,1,14,4,18,25,20,5,34,57,51,137]),function(V,e,i,o,S,D,O,P,y,a,h,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nec=void 0;let g=class extends f.$Lec{get win(){return super.win||this.tryClaimWindow(),super.win}constructor(l,m,p,$,w,v){super($,w,m,p),this.O=l,this.P=v,this.id=this.O.id,this.parentId=-1,this.N=!1,this.tryClaimWindow()}tryClaimWindow(l){this.q.isDisposed||this.O.isDestroyed()||(this.Q(),l&&!this.N&&(this.N=!0,this.w({x:l.x,y:l.y,width:l.width,height:l.height,mode:l.show===!1?h.WindowMode.Maximized:h.WindowMode.Normal})))}Q(){if(this.m)return;const l=i.BrowserWindow.fromWebContents(this.O);l&&(this.u.trace("[aux window] Claimed browser window instance"),this.n(l),l.setMenu(null),(o.$i||o.$k)&&(0,a.$1D)(this.r)&&l.setAutoHideMenuBar(!0),this.P.registerAuxWindow(this))}matches(l){return this.O.id===l.id}};e.$Nec=g,e.$Nec=g=Se([re(1,D.$kec),re(2,P.$_j),re(3,S.$_i),re(4,y.$dR),re(5,O.$Oec)],g)}),define(oe[310],ae([0,1,14,3,2,13,37,309,6,5,51,29]),function(V,e,i,o,S,D,O,P,y,a,h,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hgc=void 0;let g=class extends S.$Wc{constructor(l,m){super(),this.h=l,this.j=m,this.a=this.B(new o.$me),this.onDidMaximizeWindow=this.a.event,this.b=this.B(new o.$me),this.onDidUnmaximizeWindow=this.b.event,this.c=this.B(new o.$me),this.onDidChangeFullScreen=this.c.event,this.f=this.B(new o.$me),this.onDidTriggerSystemContextMenu=this.f.event,this.g=new Map,this.m()}m(){i.app.on("browser-window-created",(l,m)=>{const p=this.getWindowByWebContents(m.webContents);if(p)this.j.trace('[aux window] app.on("browser-window-created"): Trying to claim auxiliary window'),p.tryClaimWindow();else{const $=new S.$Vc;$.add(o.Event.fromNodeEventEmitter(m.webContents,"did-create-window",(w,v)=>({browserWindow:w,details:v}))(({browserWindow:w,details:v})=>{const k=this.getWindowByWebContents(w.webContents);k&&(this.j.trace('[aux window] window.on("did-create-window"): Trying to claim auxiliary window'),k.tryClaimWindow(v.options))})),$.add(o.Event.fromNodeEventEmitter(m,"closed")(()=>$.dispose()))}}),O.$BX.handle("vscode:registerAuxiliaryWindow",async(l,m)=>{const p=this.getWindowByWebContents(l.sender);return p&&(this.j.trace("[aux window] vscode:registerAuxiliaryWindow: Registering auxiliary window to main window"),p.parentId=m),l.sender.id})}createWindow(l){return this.h.invokeFunction(f.$wec,this.n(l),{preload:D.$Zg.asFileUri("vs/base/parts/sandbox/electron-sandbox/preload-aux.js").fsPath})}n(l){const m={},p=l.features.split(",");for(const w of p){const[v,k]=w.split("=");switch(v){case"width":m.width=parseInt(k,10);break;case"height":m.height=parseInt(k,10);break;case"left":m.x=parseInt(k,10);break;case"top":m.y=parseInt(k,10);break;case"window-maximized":m.mode=h.WindowMode.Maximized;break;case"window-fullscreen":m.mode=h.WindowMode.Fullscreen;break}}const $=f.WindowStateValidator.validateWindowState(this.j,m)??(0,h.$jec)();return this.j.trace("[aux window] using window state",$),$}registerWindow(l){const m=new S.$Vc,p=this.h.createInstance(P.$Nec,l);this.g.set(p.id,p),m.add((0,S.$Uc)(()=>this.g.delete(p.id))),m.add(p.onDidMaximize(()=>this.a.fire(p))),m.add(p.onDidUnmaximize(()=>this.b.fire(p))),m.add(p.onDidEnterFullScreen(()=>this.c.fire({window:p,fullscreen:!0}))),m.add(p.onDidLeaveFullScreen(()=>this.c.fire({window:p,fullscreen:!1}))),m.add(p.onDidTriggerSystemContextMenu(({x:$,y:w})=>this.f.fire({window:p,x:$,y:w}))),o.Event.once(p.onDidClose)(()=>m.dispose())}getWindowByWebContents(l){const m=this.g.get(l.id);return m?.matches(l)?m:void 0}getFocusedWindow(){const l=i.BrowserWindow.getFocusedWindow();if(l)return this.getWindowByWebContents(l.webContents)}getLastActiveWindow(){return(0,f.$xec)(Array.from(this.g.values()))}getWindows(){return Array.from(this.g.values())}};e.$hgc=g,e.$hgc=g=Se([re(0,y.$Ei),re(1,a.$_j)],g)}),define(oe[88],ae([0,1,14,22,8,3,48,2,13,4,19,7,21,199,6,20,5,63,87,103,30,60,32,58]),function(V,e,i,o,S,D,O,P,y,a,h,f,g,b,l,m,p,$,w,v,k,t,r,n){"use strict";var c;Object.defineProperty(e,"__esModule",{value:!0}),e.$ufc=e.$tfc=void 0,e.$tfc=(0,l.$Fi)("workspacesHistoryMainService");let s=class extends P.$Wc{static{c=this}static{this.a=500}static{this.b="history.recentlyOpenedPathsList"}constructor(d,I,E,A,T){super(),this.f=d,this.g=I,this.h=E,this.j=A,this.m=T,this.c=this.B(new D.$me),this.onDidChangeRecentlyOpened=this.c.event,this.H=this.B(new S.$Dh(800)),this.n()}n(){this.h.when(m.LifecycleMainPhase.Eventually).then(()=>this.I()),this.B(this.g.onDidEnterWorkspace(d=>this.addRecentlyOpened([{workspace:d.workspace,remoteAuthority:d.window.remoteAuthority}])))}async addRecentlyOpened(d){let I=[],E=[];for(const T of d)if((0,v.$Ghb)(T))!this.g.isUntitledWorkspace(T.workspace)&&!this.w(I,T.workspace)&&I.push(T);else if((0,v.$Hhb)(T))this.y(I,T.folderUri)||I.push(T);else{const L=this.z(E,T.fileUri),R=T.fileUri.scheme===y.Schemas.file&&c.G.indexOf((0,h.$dh)(T.fileUri))>=0;!L&&!R&&(E.push(T),a.$i&&T.fileUri.scheme===y.Schemas.file&&i.app.addRecentDocument(T.fileUri.fsPath))}const A=await this.r({workspaces:I,files:E});I=A.workspaces,E=A.files,I.length>c.a&&(I.length=c.a),E.length>c.a&&(E.length=c.a),await this.t({workspaces:I,files:E}),this.c.fire(),a.$j&&this.H.trigger(()=>this.N())}async removeRecentlyOpened(d){const I=L=>{const R=this.u(L);for(const M of d)if(h.$0g.isEqual(M,R))return!1;return!0},E=await this.getRecentlyOpened(),A=E.workspaces.filter(I),T=E.files.filter(I);(A.length!==E.workspaces.length||T.length!==E.files.length)&&(await this.t({files:T,workspaces:A}),this.c.fire(),a.$j&&this.H.trigger(()=>this.N()))}async clearRecentlyOpened(d){if(d?.confirm){const{response:I}=await this.m.showMessageBox({type:"warning",buttons:[(0,b.localize)(0,null),(0,b.localize)(1,null)],message:(0,b.localize)(2,null),detail:(0,b.localize)(3,null),cancelId:1});if(I!==0)return}await this.t({workspaces:[],files:[]}),i.app.clearRecentDocuments(),this.c.fire()}async getRecentlyOpened(){return this.r()}async r(d){const I=new r.$Cc(T=>h.$0g.getComparisonKey(T));if(d?.workspaces)for(const T of d.workspaces)I.set(this.u(T),T);const E=new r.$Cc(T=>h.$0g.getComparisonKey(T));if(d?.files)for(const T of d.files)E.set(this.u(T),T);const A=await this.s();for(const T of A.workspaces){const L=I.get(this.u(T));L?L.label=L.label??T.label:I.set(this.u(T),T)}for(const T of A.files){const L=E.get(this.u(T));L?L.label=L.label??T.label:E.set(this.u(T),T)}return{workspaces:[...I.values()],files:[...E.values()]}}async s(){await this.j.whenReady;let d;const I=this.j.get(c.b,$.StorageScope.APPLICATION);if(typeof I=="string")try{d=JSON.parse(I)}catch(E){this.f.error("Unexpected error parsing opened paths list",E)}return(0,v.$Nhb)(d,this.f)}async t(d){await this.j.whenReady,this.j.store(c.b,JSON.stringify((0,v.$Ohb)(d)),$.StorageScope.APPLICATION,$.StorageTarget.MACHINE)}u(d){return(0,v.$Hhb)(d)?d.folderUri:(0,v.$Ihb)(d)?d.fileUri:d.workspace.configPath}w(d,I){return!!d.find(E=>(0,v.$Ghb)(E)&&E.workspace.id===I.id)}y(d,I){return!!d.find(E=>(0,v.$Hhb)(E)&&h.$0g.isEqual(E.folderUri,I))}z(d,I){return!!d.find(E=>h.$0g.isEqual(E.fileUri,I))}static{this.C=7}static{this.D=10}static{this.F=7}static{this.G=["COMMIT_EDITMSG","MERGE_MSG","git-rebase-todo"]}async I(){a.$i&&(await this.J(),this.B(this.onDidChangeRecentlyOpened(()=>this.J())))}async J(){if(!a.$i)return;const d=[];if(d.push({type:"tasks",items:[{type:"task",title:(0,b.localize)(4,null),description:(0,b.localize)(5,null),program:process.execPath,args:"-n",iconPath:process.execPath,iconIndex:0}]}),(await this.getRecentlyOpened()).workspaces.length>0){const I=[];for(const T of i.app.getJumpListSettings().removedItems){const L=T.args;if(L){const R=/^--(folder|file)-uri\s+"([^"]+)"$/.exec(L);R&&I.push(f.URI.parse(R[2]))}}await this.removeRecentlyOpened(I);let E=!1;const A=(0,o.$Jb)((await this.getRecentlyOpened()).workspaces.slice(0,c.F).map(T=>{const L=(0,v.$Ghb)(T)?T.workspace:T.folderUri,{title:R,description:M}=this.L(L,T.label);let U;return f.URI.isUri(L)?U=`--folder-uri "${L.toString()}"`:(E=!0,U=`--file-uri "${L.configPath.toString()}"`),{type:"task",title:R.substr(0,255),description:M.substr(0,255),program:process.execPath,args:U,iconPath:"explorer.exe",iconIndex:0}}));A.length>0&&d.push({type:"custom",name:E?(0,b.localize)(6,null):(0,b.localize)(7,null),items:A})}d.push({type:"recent"});try{const I=i.app.setJumpList(d);I&&I!=="ok"&&this.f.warn(`updateWindowsJumpList#setJumpList unexpected result: ${I}`)}catch(I){this.f.warn("updateWindowsJumpList#setJumpList",I)}}L(d,I){if(I)return{title:(0,O.$1w)(I).name,description:I};if(f.URI.isUri(d))return{title:(0,h.$dh)(d),description:this.M(d)};if(this.g.isUntitledWorkspace(d))return{title:(0,b.localize)(8,null),description:""};let E=(0,h.$dh)(d.configPath);return E.endsWith(k.$2i)&&(E=E.substr(0,E.length-k.$2i.length-1)),{title:(0,b.localize)(9,null,E),description:this.M(d.configPath)}}M(d){return d.scheme==="file"?(0,O.$Sw)(d.fsPath):d.toString()}async N(){if(!a.$j)return;i.app.clearRecentDocuments();const d=await this.getRecentlyOpened(),I=[];let E=0;for(let T=0;T<d.workspaces.length&&E<c.C;T++){const L=this.u(d.workspaces[T]);if(L.scheme===y.Schemas.file){const R=(0,h.$7g)(L);await g.Promises.exists(R)&&(I.push(R),E++)}}const A=[];for(let T=0;T<d.files.length&&E<c.D;T++){const L=this.u(d.files[T]);if(L.scheme===y.Schemas.file){const R=(0,h.$7g)(L);if(c.G.includes((0,h.$dh)(L))||I.includes(R))continue;await g.Promises.exists(R)&&(A.push(R),E++)}}A.reverse().forEach(T=>i.app.addRecentDocument(T)),I.reverse().forEach(T=>i.app.addRecentDocument(T))}};e.$ufc=s,e.$ufc=s=c=Se([re(0,p.$_j),re(1,t.$Hec),re(2,m.$Oec),re(3,w.$Wec),re(4,n.$qec)],s)}),define(oe[311],ae([0,1,14,8,23,48,4,7,187,83,18,25,20,5,236,75,28,34,24,50,57,29,88,2]),function(V,e,i,o,S,D,O,P,y,a,h,f,g,b,l,m,p,$,w,v,k,t,r,n){"use strict";var c;Object.defineProperty(e,"__esModule",{value:!0}),e.$vfc=void 0,y=Re(y);const s="menu";let u=class extends n.$Wc{static{c=this}static{this.a="lastKnownMenubarData"}constructor(E,A,T,L,R,M,U,N,z,ne,Q,le){super(),this.t=E,this.u=A,this.w=T,this.y=L,this.z=R,this.C=M,this.D=U,this.F=N,this.G=z,this.H=ne,this.I=Q,this.J=le,this.s=Object.create(null),this.h=new o.$Rh(()=>this.R(),0),this.j=new o.$Rh(()=>{this.m=[]},1e4),this.n=Object.create(null),this.r=Object.create(null),(O.$j||(0,k.$1D)(A))&&this.L(),this.M(),this.f=!1,this.g=!1,this.m=[],this.W(),this.N()}L(){const E=this.D.getItem(c.a);E&&(E.menus&&(this.n=E.menus),E.keybindings&&(this.r=E.keybindings))}M(){this.s["workbench.action.files.newUntitledFile"]=(M,U,N)=>{this.lb({type:"commandId",commandId:"workbench.action.files.newUntitledFile"})||this.w.openEmptyWindow({context:t.OpenContext.MENU,contextWindowId:U?.id})},this.s["workbench.action.newWindow"]=(M,U,N)=>this.w.openEmptyWindow({context:t.OpenContext.MENU,contextWindowId:U?.id}),this.s["workbench.action.files.openFileFolder"]=(M,U,N)=>this.H.pickFileFolderAndOpen(void 0,{forceNewWindow:this.eb(N),telemetryExtraData:{from:s}}),this.s["workbench.action.files.openFolder"]=(M,U,N)=>this.H.pickFolderAndOpen(void 0,{forceNewWindow:this.eb(N),telemetryExtraData:{from:s}}),this.s["workbench.action.openWorkspace"]=(M,U,N)=>this.H.pickWorkspaceAndOpen(void 0,{forceNewWindow:this.eb(N),telemetryExtraData:{from:s}}),this.s["workbench.action.clearRecentFiles"]=()=>this.C.clearRecentlyOpened({confirm:!0});const E=this.I.youTubeUrl;E&&(this.s["workbench.action.openYouTubeUrl"]=()=>this.ob(E,"openYouTubeUrl"));const A=this.I.requestFeatureUrl;A&&(this.s["workbench.action.openRequestFeatureUrl"]=()=>this.ob(A,"openUserVoiceUrl"));const T=this.I.reportIssueUrl;T&&(this.s["workbench.action.openIssueReporter"]=()=>this.ob(T,"openReportIssues"));const L=this.I.licenseUrl;L&&(this.s["workbench.action.openLicenseUrl"]=()=>{if(O.$w){const M=L.indexOf("?")>0?"&":"?";this.ob(`${L}${M}lang=${O.$w}`,"openLicenseUrl")}else this.ob(L,"openLicenseUrl")});const R=this.I.privacyStatementUrl;R&&L&&(this.s["workbench.action.openPrivacyStatementUrl"]=()=>{this.ob(R,"openPrivacyStatement")})}N(){this.B(this.F.onWillShutdown(()=>this.b=!0)),this.B(this.w.onDidChangeWindowsCount(E=>this.S(E))),this.B(this.H.onDidBlurMainWindow(()=>this.U())),this.B(this.H.onDidFocusMainWindow(()=>this.U()))}get O(){const E=this.u.getValue("window.enableMenuBarMnemonics");return typeof E!="boolean"?!0:E}get P(){if(!O.$j)return!1;const E=this.u.getValue("window.nativeTabs");return typeof E!="boolean"?!1:E}updateMenu(E,A){this.n=E.menus,this.r=E.keybindings,this.D.setItem(c.a,E),this.Q()}Q(){this.h.schedule()}R(){this.b||setTimeout(()=>{this.b||this.W()},10)}S(E){O.$j&&(E.oldCount===0&&E.newCount>0||E.oldCount>0&&E.newCount===0)&&(this.f=E.newCount===0,this.Q())}U(){if(!O.$j)return;const E=i.BrowserWindow.getFocusedWindow();this.g=!E||!!this.J.getWindowByWebContents(E.webContents),this.Q()}W(){const E=i.Menu.getApplicationMenu();if(E&&this.m.push(E),Object.keys(this.n).length===0){this.X(O.$j?new i.Menu:null);return}const A=new i.Menu;let T;if(O.$j){const R=new i.Menu;T=new i.MenuItem({label:this.I.nameShort,submenu:R}),this.Y(R),A.append(T)}if(O.$j&&!this.c){this.c=!0;const R=new i.Menu;R.append(new i.MenuItem({label:this.qb(y.localize(0,null)),click:()=>this.w.openEmptyWindow({context:t.OpenContext.DOCK})})),i.app.dock.setMenu(R)}if(this.$("File")){const R=new i.Menu,M=new i.MenuItem({label:this.qb(y.localize(1,null)),submenu:R});this.bb(R,"File"),A.append(M)}if(this.$("Edit")){const R=new i.Menu,M=new i.MenuItem({label:this.qb(y.localize(2,null)),submenu:R});this.bb(R,"Edit"),A.append(M)}if(this.$("Selection")){const R=new i.Menu,M=new i.MenuItem({label:this.qb(y.localize(3,null)),submenu:R});this.bb(R,"Selection"),A.append(M)}if(this.$("View")){const R=new i.Menu,M=new i.MenuItem({label:this.qb(y.localize(4,null)),submenu:R});this.bb(R,"View"),A.append(M)}if(this.$("Go")){const R=new i.Menu,M=new i.MenuItem({label:this.qb(y.localize(5,null)),submenu:R});this.bb(R,"Go"),A.append(M)}if(this.$("Run")){const R=new i.Menu,M=new i.MenuItem({label:this.qb(y.localize(6,null)),submenu:R});this.bb(R,"Run"),A.append(M)}if(this.$("Terminal")){const R=new i.Menu,M=new i.MenuItem({label:this.qb(y.localize(7,null)),submenu:R});this.bb(R,"Terminal"),A.append(M)}let L;if(this.$("Window")){const R=new i.Menu;L=new i.MenuItem({label:this.qb(y.localize(8,null)),submenu:R,role:"window"}),this.hb(R)}if(L&&A.append(L),this.$("Help")){const R=new i.Menu,M=new i.MenuItem({label:this.qb(y.localize(9,null)),submenu:R,role:"help"});this.bb(R,"Help"),A.append(M)}A.items&&A.items.length>0?this.X(A):this.X(null),this.j.schedule()}X(E){if(i.Menu.setApplicationMenu(E),E)for(const A of this.J.getWindows())A.win?.setMenu(null)}Y(E){const A=this.jb(y.localize(10,null,this.I.nameLong),"workbench.action.showAboutDialog"),T=this.ib();let L;if(this.$("Preferences")){const le=new i.Menu;this.bb(le,"Preferences"),L=new i.MenuItem({label:this.qb(y.localize(11,null)),submenu:le})}const R=new i.Menu,M=new i.MenuItem({label:y.localize(12,null),role:"services",submenu:R}),U=new i.MenuItem({label:y.localize(13,null,this.I.nameLong),role:"hide",accelerator:"Command+H"}),N=new i.MenuItem({label:y.localize(14,null),role:"hideOthers",accelerator:"Command+Alt+H"}),z=new i.MenuItem({label:y.localize(15,null),role:"unhide"}),ne=new i.MenuItem(this.nb("workbench.action.quit",{label:y.localize(16,null,this.I.nameLong),click:async(le,K,ee)=>{const H=this.w.getLastActiveWindow();(this.w.getWindowCount()===0||i.BrowserWindow.getFocusedWindow()||H?.win?.isMinimized())&&await this.Z(ee)&&this.H.quit(void 0)}})),Q=[A];Q.push(...T),L&&Q.push(d(),L),Q.push(d(),M,d(),U,N,z,d(),ne),Q.forEach(le=>E.append(le))}async Z(E){if(this.w.getWindowCount()===0)return!0;const A=this.u.getValue("window.confirmBeforeClose");if(A==="always"||A==="keyboardOnly"&&this.fb(E)){const{response:T}=await this.H.showMessageBox(this.w.getFocusedWindow()?.id,{type:"question",buttons:[y.localize(17,null),y.localize(18,null)],message:y.localize(19,null)});return T===0}return!0}$(E){if(!O.$j&&!(0,k.$1D)(this.u))return!1;switch(E){case"File":case"Help":if(O.$j)return this.w.getWindowCount()===0&&this.f||this.w.getWindowCount()>0&&this.g||!!this.n&&!!this.n[E];case"Window":if(O.$j)return this.w.getWindowCount()===0&&this.f||this.w.getWindowCount()>0&&this.g||!!this.n;default:return this.w.getWindowCount()>0&&!!this.n&&!!this.n[E]}}ab(E,A){A.forEach(T=>{if((0,l.$qfc)(T))E.append(d());else if((0,l.$pfc)(T)){const L=new i.Menu,R=new i.MenuItem({label:this.qb(T.label),submenu:L});this.ab(L,T.submenu.items),E.append(R)}else(0,l.$rfc)(T)?E.append(this.db(T)):(0,l.$sfc)(T)&&(T.id==="workbench.action.showAboutDialog"&&this.cb(E),O.$j?this.w.getWindowCount()===0&&this.f||this.w.getWindowCount()>0&&this.g?this.s[T.id]?E.append(new i.MenuItem(this.nb(T.id,{label:this.qb(T.label),click:this.s[T.id]}))):E.append(this.jb(T.label,T.id,!1,T.checked)):E.append(this.jb(T.label,T.id,T.enabled!==!1,!!T.checked)):E.append(this.jb(T.label,T.id,T.enabled!==!1,!!T.checked)))})}bb(E,A){this.n&&this.n[A]&&this.ab(E,this.n[A].items)}cb(E){const A=this.ib();A.length&&(A.forEach(T=>E.append(T)),E.append(d()))}db(E){const A=P.URI.revive(E.uri),T=E.id,L=T==="openRecentFile"?{fileUri:A}:T==="openRecentWorkspace"?{workspaceUri:A}:{folderUri:A};return new i.MenuItem(this.nb(T,{label:E.label,click:async(R,M,U)=>{const N=this.eb(U);(await this.w.open({context:t.OpenContext.MENU,cli:this.y.args,urisToOpen:[L],forceNewWindow:N,gotoLineMode:!1,remoteAuthority:E.remoteAuthority})).length>0||await this.C.removeRecentlyOpened([A])}},!1))}eb(E){return!!(E&&(!O.$j&&(E.ctrlKey||E.shiftKey)||O.$j&&(E.metaKey||E.altKey)))}fb(E){return!!(E.triggeredByAccelerator||E.altKey||E.ctrlKey||E.metaKey||E.shiftKey)}gb(E,A,T){const L={label:this.qb(E),role:T,enabled:!0};return new i.MenuItem(this.mb(A,L))}hb(E){const A=new i.MenuItem({label:y.localize(20,null),role:"minimize",accelerator:"Command+M",enabled:this.w.getWindowCount()>0}),T=new i.MenuItem({label:y.localize(21,null),role:"zoom",enabled:this.w.getWindowCount()>0}),L=new i.MenuItem({label:y.localize(22,null),role:"front",enabled:this.w.getWindowCount()>0}),R=this.jb(y.localize(23,null),"workbench.action.switchWindow"),M=[];this.P&&(M.push(d()),M.push(this.jb(y.localize(24,null),"workbench.action.newWindowTab")),M.push(this.gb(y.localize(25,null),"workbench.action.showPreviousWindowTab","selectPreviousTab")),M.push(this.gb(y.localize(26,null),"workbench.action.showNextWindowTab","selectNextTab")),M.push(this.gb(y.localize(27,null),"workbench.action.moveWindowTabToNewWindow","moveTabToNewWindow")),M.push(this.gb(y.localize(28,null),"workbench.action.mergeAllWindowTabs","mergeAllWindows"))),[A,T,d(),R,...M,d(),L].forEach(U=>E.append(U))}ib(){switch(this.t.state.type){case v.StateType.Idle:return[new i.MenuItem({label:this.qb(y.localize(29,null)),click:()=>setTimeout(()=>{this.pb("CheckForUpdate"),this.t.checkForUpdates(!0)},0)})];case v.StateType.CheckingForUpdates:return[new i.MenuItem({label:y.localize(30,null),enabled:!1})];case v.StateType.AvailableForDownload:return[new i.MenuItem({label:this.qb(y.localize(31,null)),click:()=>{this.t.downloadUpdate()}})];case v.StateType.Downloading:return[new i.MenuItem({label:y.localize(32,null),enabled:!1})];case v.StateType.Downloaded:return O.$j?[]:[new i.MenuItem({label:this.qb(y.localize(33,null)),click:()=>{this.pb("InstallUpdate"),this.t.applyUpdate()}})];case v.StateType.Updating:return[new i.MenuItem({label:y.localize(34,null),enabled:!1})];case v.StateType.Ready:return[new i.MenuItem({label:this.qb(y.localize(35,null)),click:()=>{this.pb("RestartToUpdate"),this.t.quitAndInstall()}})];default:return[]}}jb(E,A,T,L){const R=this.qb(E),M=typeof A=="function"?A:(Q,le,K)=>{const ee=Q?Q.userSettingsLabel:null;let H=A;Array.isArray(A)&&(H=this.eb(K)?A[1]:A[0]),ee&&K.triggeredByAccelerator?this.lb({type:"keybinding",userSettingsLabel:ee}):this.lb({type:"commandId",commandId:H})},U=typeof T=="boolean"?T:this.w.getWindowCount()>0,N=typeof L=="boolean"?L:!1,z={label:R,click:M,enabled:U};N&&(z.type="checkbox",z.checked=N);let ne;return typeof A=="string"?ne=A:Array.isArray(A)&&(ne=A[0]),O.$j&&(ne==="editor.action.clipboardCutAction"?z.role="cut":ne==="editor.action.clipboardCopyAction"?z.role="copy":ne==="editor.action.clipboardPasteAction"&&(z.role="paste"),ne==="undo"?z.click=this.kb(M,{inDevTools:Q=>Q.undo(),inNoWindow:()=>i.Menu.sendActionToFirstResponder("undo:")}):ne==="redo"?z.click=this.kb(M,{inDevTools:Q=>Q.redo(),inNoWindow:()=>i.Menu.sendActionToFirstResponder("redo:")}):ne==="editor.action.selectAll"&&(z.click=this.kb(M,{inDevTools:Q=>Q.selectAll(),inNoWindow:()=>i.Menu.sendActionToFirstResponder("selectAll:")}))),new i.MenuItem(this.mb(ne,z))}kb(E,A){return(T,L,R)=>{const M=i.BrowserWindow.getFocusedWindow();if(!M)return A.inNoWindow();if(M.webContents.isDevToolsFocused()&&M.webContents.devToolsWebContents)return A.inDevTools(M.webContents.devToolsWebContents);E(T,L||M,R)}}lb(E){let A=i.BrowserWindow.getFocusedWindow();if(A){const L=this.J.getWindowByWebContents(A.webContents);L&&(A=this.w.getWindowById(L.parentId)?.win??null)}if(!A){const L=this.w.getLastActiveWindow();L?.win?.isMinimized()&&(A=L.win)}const T=A?this.w.getWindowById(A.id):void 0;if(T){if(this.G.trace("menubar#runActionInRenderer",E),O.$j&&!this.y.isBuilt&&!T.isReady&&(E.type==="commandId"&&E.commandId==="workbench.action.toggleDevTools"||E.type!=="commandId"&&E.userSettingsLabel==="alt+cmd+i"))return!1;if(E.type==="commandId"){const L={id:E.commandId,from:"menu"};T.sendWhenReady("vscode:runAction",S.CancellationToken.None,L)}else{const L={userSettingsLabel:E.userSettingsLabel};T.sendWhenReady("vscode:runKeybinding",S.CancellationToken.None,L)}return!0}else return this.G.trace("menubar#runActionInRenderer: no active window found",E),!1}mb(E,A){const T=typeof E=="string"?this.r[E]:void 0;if(T?.label){if(T.isNative!==!1)A.accelerator=T.label,A.userSettingsLabel=T.userSettingsLabel;else if(typeof A.label=="string"){const L=A.label.indexOf("[");L>=0?A.label=`${A.label.substr(0,L)} [${T.label}]`:A.label=`${A.label} [${T.label}]`}}else A.accelerator=void 0;return A}nb(E,A,T=!A.accelerator){T&&(A=this.mb(E,A));const L=A.click;return A.click=(R,M,U)=>{this.pb(E),L?.(R,M,U)},A}ob(E,A){this.H.openExternal(void 0,E),this.pb(A)}pb(E){this.z.publicLog2("workbenchActionExecuted",{id:E,from:s})}qb(E){return(0,D.$Xw)(E,!this.O)}};e.$vfc=u,e.$vfc=u=c=Se([re(0,v.$AY),re(1,h.$_i),re(2,t.$vec),re(3,f.$kec),re(4,w.$$l),re(5,r.$tfc),re(6,$.$dR),re(7,g.$Oec),re(8,b.$_j),re(9,m.$hfc),re(10,p.$sk),re(11,a.$gfc)],u);function d(){return new i.MenuItem({type:"separator"})}}),define(oe[312],ae([0,1,6,20,5,311,2]),function(V,e,i,o,S,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xfc=e.$wfc=void 0,e.$wfc=(0,i.$Fi)("menubarMainService");let P=class extends O.$Wc{constructor(a,h,f){super(),this.b=a,this.c=h,this.f=f,this.a=this.g()}async g(){return await this.c.when(o.LifecycleMainPhase.AfterWindowOpen),this.B(this.b.createInstance(D.$vfc))}async updateMenubar(a,h){this.f.trace("menubarService#updateMenubar",a),(await this.a).updateMenu(h,a)}};e.$xfc=P,e.$xfc=P=Se([re(0,i.$Ei),re(1,o.$Oec),re(2,S.$_j)],P)});var et=this&&this.__importDefault||function(V){return V&&V.__esModule?V:{default:V}};define(oe[313],ae([0,1,14,21,107,27,22,23,39,3,31,48,2,13,9,70,4,36,19,12,7,197,69,18,58,25,15,6,20,5,84,85,72,34,57,137,29,135,305,30,104,88,60,51,74,40,59,71,83]),function(V,e,i,o,S,D,O,P,y,a,h,f,g,b,l,m,p,$,w,v,k,t,r,n,c,s,u,d,I,E,A,T,L,R,M,U,N,z,ne,Q,le,K,ee,H,j,B,x,ce,G){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xfc=void 0,A=et(A);function he(F){return(0,Q.$Ui)(F?.workspace)}function se(F){return(0,Q.$Pi)(F?.workspace)}let _=class extends g.$Wc{constructor(C,W,q,J,X,Z,ie,de,me,pe,Ie,ke,Pe,De,$e,Y,ue,fe,be,Oe,We){super(),this.s=C,this.t=W,this.u=q,this.w=J,this.z=X,this.C=Z,this.D=ie,this.F=de,this.G=me,this.H=pe,this.I=Ie,this.J=ke,this.L=Pe,this.M=De,this.N=$e,this.O=Y,this.P=ue,this.Q=fe,this.R=be,this.S=Oe,this.U=We,this.a=this.B(new a.$me),this.onDidOpenWindow=this.a.event,this.b=this.B(new a.$me),this.onDidSignalReadyWindow=this.b.event,this.c=this.B(new a.$me),this.onDidDestroyWindow=this.c.event,this.f=this.B(new a.$me),this.onDidChangeWindowsCount=this.f.event,this.g=this.B(new a.$me),this.onDidMaximizeWindow=this.g.event,this.h=this.B(new a.$me),this.onDidUnmaximizeWindow=this.h.event,this.j=this.B(new a.$me),this.onDidChangeFullScreen=this.j.event,this.m=this.B(new a.$me),this.onDidTriggerSystemContextMenu=this.m.event,this.n=new Map,this.r=this.B(new ne.$Ufc(this,this.D,this.I,this.z,this.L)),this.W()}W(){this.B(this.N.onDidEnterWorkspace(C=>this.b.fire(C.window))),this.B(this.onDidSignalReadyWindow(C=>{if(C.config?.extensionDevelopmentPath||C.config?.extensionTestsPath){const W=new g.$Vc;if(W.add(a.Event.any(C.onDidClose,C.onDidDestroy)(()=>W.dispose())),C.config.extensionDevelopmentPath)for(const q of C.config.extensionDevelopmentPath)W.add(this.R.addValidFileRoot(q));C.config.extensionTestsPath&&W.add(this.R.addValidFileRoot(C.config.extensionTestsPath))}}))}openEmptyWindow(C,W){const q=this.G.args,J=W?.remoteAuthority||void 0,X=!0,Z=W?.forceReuseWindow,ie=!Z;return this.open({...C,cli:q,forceEmpty:X,forceNewWindow:ie,forceReuseWindow:Z,remoteAuthority:J,forceTempProfile:W?.forceTempProfile,forceProfile:W?.forceProfile})}openExistingWindow(C,W){C.focus(),this.X(W,[C])}async open(C){this.z.trace("windowsManager#open"),C.addMode&&(C.initialStartup||!this.getLastActiveWindow())&&(C.addMode=!1);const W=[],q=[],J=[],X=[],Z=[];let ie,de=0;const me=await this.db(C);this.z.trace("windowsManager#open pathsToOpen",me);for(const De of me)se(De)?C.addMode?W.push(De):q.push(De):he(De)?J.push(De):De.fileUri?(ie||(ie={filesToOpenOrCreate:[],filesToDiff:[],filesToMerge:[],remoteAuthority:De.remoteAuthority}),ie.filesToOpenOrCreate.push(De)):De.backupPath?Z.push({backupFolder:(0,l.$pc)(De.backupPath),remoteAuthority:De.remoteAuthority}):de++;C.diffMode&&ie&&ie.filesToOpenOrCreate.length>=2&&(ie.filesToDiff=ie.filesToOpenOrCreate.slice(0,2),ie.filesToOpenOrCreate=[]),C.mergeMode&&ie&&ie.filesToOpenOrCreate.length===4&&(ie.filesToMerge=ie.filesToOpenOrCreate.slice(0,4),ie.filesToOpenOrCreate=[],ie.filesToDiff=[]),ie&&C.waitMarkerFileURI&&(ie.filesToWait={paths:(0,O.$Jb)([...ie.filesToDiff,ie.filesToMerge[3],...ie.filesToOpenOrCreate]),waitMarkerFileUri:C.waitMarkerFileURI}),C.initialStartup?(X.push(...this.N.getUntitledWorkspaces()),J.push(...X),Z.push(...this.J.getEmptyWindowBackups())):Z.length=0;const{windows:pe,filesOpenedInWindow:Ie}=await this.Y(C,J,q,Z,de,ie,W);if(this.z.trace(`windowsManager#open used window count ${pe.length} (workspacesToOpen: ${J.length}, foldersToOpen: ${q.length}, emptyToRestore: ${Z.length}, emptyToOpen: ${de})`),pe.length>1)if(Ie)Ie.focus();else{const De=this.r.state.lastActiveWindow&&!C.forceEmpty&&!C.cli._.length&&!C.cli["file-uri"]&&!C.cli["folder-uri"]&&!(C.urisToOpen&&C.urisToOpen.length);let $e=!0,Y=!0;if(De){const ue=pe.filter(fe=>this.r.state.lastActiveWindow&&fe.backupPath===this.r.state.lastActiveWindow.backupPath);ue.length&&(ue[0].focus(),$e=!1,Y=!1)}if($e)for(let ue=pe.length-1;ue>=0;ue--){const fe=pe[ue];if(!(fe.openedWorkspace&&X.some(be=>fe.openedWorkspace&&be.workspace.id===fe.openedWorkspace.id)||fe.backupPath&&Z.some(be=>fe.backupPath&&be.backupFolder===(0,l.$pc)(fe.backupPath)))){fe.focus(),Y=!1;break}}Y&&pe[pe.length-1].focus()}const ke=ie&&ie.filesToDiff.length>0,Pe=ie&&ie.filesToMerge.length>0;if(!pe.some(De=>De.isExtensionDevelopmentHost)&&!ke&&!Pe&&!C.noRecentEntry){const De=[];for(const $e of me)he($e)&&!$e.transient?De.push({label:$e.label,workspace:$e.workspace,remoteAuthority:$e.remoteAuthority}):se($e)?De.push({label:$e.label,folderUri:$e.workspace.uri,remoteAuthority:$e.remoteAuthority}):$e.fileUri&&De.push({label:$e.label,fileUri:$e.fileUri,remoteAuthority:$e.remoteAuthority});this.M.addRecentlyOpened(De)}return this.X(C,pe),pe}X(C,W){const q=C.waitMarkerFileURI;C.context===N.OpenContext.CLI&&q&&W.length===1&&W[0]&&(async()=>{await W[0].whenClosedOrLoaded;try{await this.Q.del(q)}catch{}})()}async Y(C,W,q,J,X,Z,ie){const de=[];let me;function pe(ue,fe){de.push(ue),fe&&(me=ue,Z=void 0)}let{openFolderInNewWindow:Ie,openFilesInNewWindow:ke}=this.pb(C);if(!C.initialStartup&&ie.length>0){const ue=ie[0].remoteAuthority,fe=this.vb(ue);fe&&pe(this.ab(fe,ie.map(be=>be.workspace.uri)))}const Pe=q.length+W.length+J.length;if(Z&&Pe===0){const ue=Z.filesToOpenOrCreate[0]||Z.filesToDiff[0]||Z.filesToMerge[3],fe=this.getWindows().filter(Oe=>Z&&(0,w.$lh)(Oe.remoteAuthority,Z.remoteAuthority));let be;ue?.fileUri&&!ke&&((C.context===N.OpenContext.DESKTOP||C.context===N.OpenContext.CLI||C.context===N.OpenContext.DOCK)&&(be=await(0,z.$Aec)(fe,ue.fileUri,async Oe=>Oe.configPath.scheme===b.Schemas.file?this.N.resolveLocalWorkspace(Oe.configPath):void 0)),be||(be=this.wb(fe))),be?(0,Q.$Ui)(be.openedWorkspace)?W.push({workspace:be.openedWorkspace,remoteAuthority:be.remoteAuthority}):(0,Q.$Pi)(be.openedWorkspace)?q.push({workspace:be.openedWorkspace,remoteAuthority:be.remoteAuthority}):pe(this.Z(C,be,Z),!0):pe(await this.qb({userEnv:C.userEnv,cli:C.cli,initialStartup:C.initialStartup,filesToOpen:Z,forceNewWindow:!0,remoteAuthority:Z.remoteAuthority,forceNewTabbedWindow:C.forceNewTabbedWindow,forceProfile:C.forceProfile,forceTempProfile:C.forceTempProfile}),!0)}const De=(0,O.$Ob)(W,ue=>ue.workspace.id);if(De.length>0){const ue=(0,O.$Jb)(De.map(fe=>(0,z.$Bec)(this.getWindows(),fe.workspace.configPath)));if(ue.length>0){const fe=ue[0],be=(0,w.$lh)(Z?.remoteAuthority,fe.remoteAuthority)?Z:void 0;pe(this.Z(C,fe,be),!!be),Ie=!0}for(const fe of De){if(ue.some(We=>We.openedWorkspace&&We.openedWorkspace.id===fe.workspace.id))continue;const be=fe.remoteAuthority,Oe=(0,w.$lh)(Z?.remoteAuthority,be)?Z:void 0;pe(await this.cb(C,fe,Ie,Oe),!!Oe),Ie=!0}}const $e=(0,O.$Ob)(q,ue=>w.$0g.getComparisonKey(ue.workspace.uri));if($e.length>0){const ue=(0,O.$Jb)($e.map(fe=>(0,z.$Bec)(this.getWindows(),fe.workspace.uri)));if(ue.length>0){const fe=ue[0],be=(0,w.$lh)(Z?.remoteAuthority,fe.remoteAuthority)?Z:void 0;pe(this.Z(C,fe,be),!!be),Ie=!0}for(const fe of $e){if(ue.some(We=>(0,Q.$Pi)(We.openedWorkspace)&&w.$0g.isEqual(We.openedWorkspace.uri,fe.workspace.uri)))continue;const be=fe.remoteAuthority,Oe=(0,w.$lh)(Z?.remoteAuthority,be)?Z:void 0;pe(await this.cb(C,fe,Ie,Oe),!!Oe),Ie=!0}}const Y=(0,O.$Ob)(J,ue=>ue.backupFolder);if(Y.length>0)for(const ue of Y){const fe=ue.remoteAuthority,be=(0,w.$lh)(Z?.remoteAuthority,fe)?Z:void 0;pe(await this.bb(C,!0,fe,be,ue),!!be),Ie=!0}if(de.length===0||Z){Z&&!X&&X++;const ue=Z?Z.remoteAuthority:C.remoteAuthority;for(let fe=0;fe<X;fe++)pe(await this.bb(C,Ie,ue,Z),!!Z),Ie=!0}return{windows:(0,O.$Ob)(de),filesOpenedInWindow:me}}Z(C,W,q){this.z.trace("windowsManager#doOpenFilesInExistingWindow",{filesToOpen:q}),this.$(W);const J={filesToOpenOrCreate:q?.filesToOpenOrCreate,filesToDiff:q?.filesToDiff,filesToMerge:q?.filesToMerge,filesToWait:q?.filesToWait,termProgram:C?.userEnv?.TERM_PROGRAM};return W.sendWhenReady("vscode:openFiles",P.CancellationToken.None,J),W}$(C){let W=C;const q=i.BrowserWindow.getFocusedWindow();if(q&&q.id!==C.id){const J=this.U.getWindowByWebContents(q.webContents);J&&J.parentId===C.id&&(W=J)}W.focus()}ab(C,W){this.z.trace("windowsManager#doAddFoldersToExistingWindow",{foldersToAdd:W}),C.focus();const q={foldersToAdd:W};return C.sendWhenReady("vscode:addFolders",P.CancellationToken.None,q),C}bb(C,W,q,J,X){this.z.trace("windowsManager#doOpenEmpty",{restore:!!X,remoteAuthority:q,filesToOpen:J,forceNewWindow:W});let Z;return!W&&typeof C.contextWindowId=="number"&&(Z=this.getWindowById(C.contextWindowId)),this.qb({userEnv:C.userEnv,cli:C.cli,initialStartup:C.initialStartup,remoteAuthority:q,forceNewWindow:W,forceNewTabbedWindow:C.forceNewTabbedWindow,filesToOpen:J,windowToUse:Z,emptyWindowBackupInfo:X,forceProfile:C.forceProfile,forceTempProfile:C.forceTempProfile})}cb(C,W,q,J,X){return this.z.trace("windowsManager#doOpenFolderOrWorkspace",{folderOrWorkspace:W,filesToOpen:J}),!q&&!X&&typeof C.contextWindowId=="number"&&(X=this.getWindowById(C.contextWindowId)),this.qb({workspace:W.workspace,userEnv:C.userEnv,cli:C.cli,initialStartup:C.initialStartup,remoteAuthority:W.remoteAuthority,forceNewWindow:q,forceNewTabbedWindow:C.forceNewTabbedWindow,filesToOpen:J,windowToUse:X,forceProfile:C.forceProfile,forceTempProfile:C.forceTempProfile})}async db(C){let W,q=!1,J=!1;if(C.urisToOpen&&C.urisToOpen.length>0?(W=await this.eb(C),q=!0):C.forceEmpty?W=[Object.create(null)]:C.cli._.length||C.cli["folder-uri"]||C.cli["file-uri"]?(W=await this.fb(C.cli),W.length===0&&W.push(Object.create(null)),q=!0):(W=await this.hb(),W.length===0&&W.push(Object.create(null)),J=!0),!C.addMode&&q){const X=W.filter(Z=>se(Z));if(X.length>1){const Z=X[0].remoteAuthority;if(X.every(ie=>(0,w.$lh)(ie.remoteAuthority,Z))){const ie=await this.N.createUntitledWorkspace(X.map(de=>({uri:de.workspace.uri})));W.push({workspace:ie,remoteAuthority:Z}),W=W.filter(de=>!se(de))}}}if(C.initialStartup&&!J&&this.L.getValue("window")?.restoreWindows==="preserve"){const X=await this.hb();W.unshift(...X.filter(Z=>he(Z)||se(Z)||Z.backupPath))}return W}async eb(C){const W={gotoLineMode:C.gotoLineMode,remoteAuthority:C.remoteAuthority},q=await Promise.all((0,O.$Jb)(C.urisToOpen||[]).map(async J=>{const X=await this.jb(J,W);if(X)return X.label=J.label,X;const Z=this.lb(J);this.P.showMessageBox({type:"info",buttons:[(0,t.localize)(0,null)],message:Z.scheme===b.Schemas.file?(0,t.localize)(1,null):(0,t.localize)(2,null),detail:Z.scheme===b.Schemas.file?(0,t.localize)(3,null,(0,f.$Rw)(Z,{os:p.OS,tildify:this.G})):(0,t.localize)(4,null,Z.toString(!0))},i.BrowserWindow.getFocusedWindow()??void 0)}));return(0,O.$Jb)(q)}async fb(C){const W=[],q={ignoreFileNotFound:!0,gotoLineMode:C.goto,remoteAuthority:C.remote||void 0,forceOpenWorkspaceAsFile:C.diff&&C._.length===2||C.merge&&C._.length===4},J=C["folder-uri"];if(J){const ie=await Promise.all(J.map(de=>{const me=this.gb(de);if(me)return this.jb({folderUri:me},q)}));W.push(...(0,O.$Jb)(ie))}const X=C["file-uri"];if(X){const ie=await Promise.all(X.map(de=>{const me=this.gb(de);if(me)return this.jb((0,Q.$$i)(de)?{workspaceUri:me}:{fileUri:me},q)}));W.push(...(0,O.$Jb)(ie))}const Z=await Promise.all(C._.map(ie=>q.remoteAuthority?this.ob(ie,q):this.mb(ie,q)));return W.push(...(0,O.$Jb)(Z)),W}gb(C){try{const W=k.URI.parse(C);if(!W.scheme){this.z.error(`Invalid URI input string, scheme missing: ${C}`);return}return W.path?W:W.with({path:"/"})}catch(W){this.z.error(`Invalid URI input string: ${C}, ${W.message}`)}}async hb(){const C=this.ib();switch(C){case"none":return[];case"one":case"all":case"preserve":case"folders":{const W=[];C!=="one"&&W.push(...this.r.state.openedWindows),this.r.state.lastActiveWindow&&W.push(this.r.state.lastActiveWindow);const q=await Promise.all(W.map(async J=>{if(J.workspace){const X=await this.jb({workspaceUri:J.workspace.configPath},{remoteAuthority:J.remoteAuthority,rejectTransientWorkspaces:!0});if(he(X))return X}else if(J.folderUri){const X=await this.jb({folderUri:J.folderUri},{remoteAuthority:J.remoteAuthority});if(se(X))return X}else if(C!=="folders"&&J.backupPath)return{backupPath:J.backupPath,remoteAuthority:J.remoteAuthority}}));return(0,O.$Jb)(q)}}}ib(){let C;return this.I.wasRestarted?C="all":(C=this.L.getValue("window")?.restoreWindows||"all",["preserve","all","folders","one","none"].includes(C)||(C="all")),C}async jb(C,W=Object.create(null)){const q=this.lb(C);return q.scheme===b.Schemas.file?((0,M.$XD)(C)&&(W={...W,forceOpenWorkspaceAsFile:!0}),this.mb(q.fsPath,W)):this.kb(C,W)}kb(C,W){let q=this.lb(C);const J=(0,L.$gn)(q)||W.remoteAuthority;if(q=(0,w.$nh)((0,w.$hh)(q)),(0,M.$XD)(C)){if(W.gotoLineMode){const{path:X,line:Z,column:ie}=(0,h.$Mg)(q.path);return{fileUri:q.with({path:X}),options:{selection:Z?{startLineNumber:Z,startColumn:ie||1}:void 0},remoteAuthority:J}}return{fileUri:q,remoteAuthority:J}}else if((0,M.$VD)(C))return{workspace:(0,le.$Eec)(q),remoteAuthority:J};return{workspace:(0,le.$Fec)(q),remoteAuthority:J}}lb(C){return(0,M.$VD)(C)?C.workspaceUri:(0,M.$WD)(C)?C.folderUri:C.fileUri}async mb(C,W,q){let J,X;W.gotoLineMode&&({path:C,line:J,column:X}=(0,h.$Mg)(C)),C=(0,h.$Gg)((0,l.$jc)(C),(0,$.cwd)());try{const Z=await o.Promises.stat(C);if(Z.isFile()){if(!W.forceOpenWorkspaceAsFile){const ie=await this.N.resolveLocalWorkspace(k.URI.file(C));if(ie)return ie.transient&&W.rejectTransientWorkspaces?void 0:{workspace:{id:ie.id,configPath:ie.configPath},type:u.FileType.File,exists:!0,remoteAuthority:ie.remoteAuthority,transient:ie.transient}}return{fileUri:k.URI.file(C),type:u.FileType.File,exists:!0,options:{selection:J?{startLineNumber:J,startColumn:X||1}:void 0}}}else{if(Z.isDirectory())return{workspace:(0,le.$Fec)(k.URI.file(C),Z),type:u.FileType.Directory,exists:!0};if(!p.$i&&C==="/dev/null")return{fileUri:k.URI.file(C),type:u.FileType.File,exists:!0}}}catch(Z){if(Z.code==="ERR_UNC_HOST_NOT_ALLOWED"&&!q)return this.nb(C,W);const ie=k.URI.file(C);if(this.M.removeRecentlyOpened([ie]),W.ignoreFileNotFound)return{fileUri:ie,type:u.FileType.File,exists:!1}}}async nb(C,W){const q=k.URI.file(C),{response:J,checkboxChecked:X}=await this.P.showMessageBox({type:"warning",buttons:[(0,t.localize)(5,null),(0,t.localize)(6,null),(0,t.localize)(7,null)],message:(0,t.localize)(8,null,q.authority),detail:(0,t.localize)(9,null,(0,f.$Rw)(q,{os:p.OS,tildify:this.G})),checkboxLabel:(0,t.localize)(10,null,q.authority),cancelId:1});if(J===0){if((0,S.addUNCHostToAllowlist)(q.authority),X){const Z={channel:"vscode:configureAllowedUNCHost",args:q.authority};this.sendToFocused(Z.channel,Z.args),this.sendToOpeningWindow(Z.channel,Z.args)}return this.mb(C,W,!0)}if(J===2)return i.shell.openExternal("https://aka.ms/vscode-windows-unc"),this.nb(C,W)}ob(C,W){const q=C.charCodeAt(0),J=W.remoteAuthority;let X,Z;W.gotoLineMode&&({path:C,line:X,column:Z}=(0,h.$Mg)(C)),q!==y.CharCode.Slash&&((0,h.$Fg)(q)&&C.charCodeAt(C.charCodeAt(1))===y.CharCode.Colon&&(C=(0,h.$yg)(C)),C=`/${C}`);const ie=k.URI.from({scheme:b.Schemas.vscodeRemote,authority:J,path:C});if(C.charCodeAt(C.length-1)!==y.CharCode.Slash){if((0,Q.$$i)(C))return W.forceOpenWorkspaceAsFile?{fileUri:ie,options:{selection:X?{startLineNumber:X,startColumn:Z||1}:void 0},remoteAuthority:W.remoteAuthority}:{workspace:(0,le.$Eec)(ie),remoteAuthority:J};if(W.gotoLineMode||l.$ic.basename(C).indexOf(".")!==-1)return{fileUri:ie,options:{selection:X?{startLineNumber:X,startColumn:Z||1}:void 0},remoteAuthority:J}}return{workspace:(0,le.$Fec)(ie),remoteAuthority:J}}pb(C){const W=this.L.getValue("window"),q=W?.openFoldersInNewWindow||"default",J=W?.openFilesInNewWindow||"off";let X=(C.preferNewWindow||C.forceNewWindow)&&!C.forceReuseWindow;!C.forceNewWindow&&!C.forceReuseWindow&&(q==="on"||q==="off")&&(X=q==="on");let Z=!1;return C.forceNewWindow||C.forceReuseWindow?Z=!!C.forceNewWindow&&!C.forceReuseWindow:(p.$j?C.context===N.OpenContext.DOCK&&(Z=!0):C.context!==N.OpenContext.DIALOG&&C.context!==N.OpenContext.MENU&&!(C.userEnv&&C.userEnv.TERM_PROGRAM==="vscode")&&(Z=!0),!C.cli.extensionDevelopmentPath&&(J==="on"||J==="off")&&(Z=J==="on")),{openFolderInNewWindow:!!X,openFilesInNewWindow:Z}}async openExtensionDevelopmentHostWindow(C,W){const q=(0,z.$Cec)(this.getWindows(),C);if(q)return this.I.reload(q,W.cli),q.focus(),[q];let J=W.cli["folder-uri"]||[],X=W.cli["file-uri"]||[],Z=W.cli._;if(!Z.length&&!J.length&&!X.length&&!W.cli.extensionTestsPath){const me=this.r.state.lastPluginDevelopmentHostWindow,pe=me?.workspace??me?.folderUri;pe&&(k.URI.isUri(pe)?pe.scheme===b.Schemas.file?Z=[pe.fsPath]:J=[pe.toString()]:pe.configPath.scheme===b.Schemas.file?Z=[(0,w.$7g)(pe.configPath)]:X=[pe.configPath.toString()])}let ie=W.remoteAuthority;for(const me of C)if(me.match(/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/)){const pe=k.URI.parse(me),Ie=(0,L.$gn)(pe);Ie&&(ie?(0,w.$lh)(Ie,ie)||this.z.error("more than one extension development path authority"):ie=Ie)}Z=Z.filter(me=>{const pe=k.URI.file(me);return(0,z.$Bec)(this.getWindows(),pe)?!1:(0,w.$lh)((0,L.$gn)(pe),ie)}),J=J.filter(me=>{const pe=this.gb(me);return pe&&(0,z.$Bec)(this.getWindows(),pe)?!1:pe?(0,w.$lh)((0,L.$gn)(pe),ie):!1}),X=X.filter(me=>{const pe=this.gb(me);return pe&&(0,z.$Bec)(this.getWindows(),pe)?!1:pe?(0,w.$lh)((0,L.$gn)(pe),ie):!1}),W.cli._=Z,W.cli["folder-uri"]=J,W.cli["file-uri"]=X;const de={context:W.context,cli:W.cli,forceNewWindow:!0,forceEmpty:!Z.length&&!J.length&&!X.length,userEnv:W.userEnv,noRecentEntry:!0,waitMarkerFileURI:W.waitMarkerFileURI,remoteAuthority:ie,forceProfile:W.forceProfile,forceTempProfile:W.forceTempProfile};return this.open(de)}async qb(C){const W=this.L.getValue("window"),q=this.getLastActiveWindow(),X=(W?.newWindowProfile?this.H.profiles.find(de=>de.name===W.newWindowProfile):void 0)??q?.profile??this.H.defaultProfile;let Z;!C.forceNewWindow&&!C.forceNewTabbedWindow&&(Z=C.windowToUse||q,Z&&Z.focus());const ie={...this.G.args,...C.cli,machineId:this.s,sqmId:this.t,devDeviceId:this.u,windowId:-1,mainPid:process.pid,appRoot:this.G.appRoot,execPath:process.execPath,codeCachePath:this.G.codeCachePath,backupPath:C.emptyWindowBackupInfo?(0,l.$lc)(this.G.backupHome,C.emptyWindowBackupInfo.backupFolder):void 0,profiles:{home:this.H.profilesHome,all:this.H.profiles,profile:X},homeDir:this.G.userHome.with({scheme:b.Schemas.file}).fsPath,tmpDir:this.G.tmpDir.with({scheme:b.Schemas.file}).fsPath,userDataDir:this.G.userDataPath,remoteAuthority:C.remoteAuthority,workspace:C.workspace,userEnv:{...this.w,...C.userEnv},filesToOpenOrCreate:C.filesToOpen?.filesToOpenOrCreate,filesToDiff:C.filesToOpen?.filesToDiff,filesToMerge:C.filesToOpen?.filesToMerge,filesToWait:C.filesToOpen?.filesToWait,logLevel:this.C.getLogLevel(),loggers:{window:[],global:this.C.getRegisteredLoggers()},logsPath:this.G.logsHome.with({scheme:b.Schemas.file}).fsPath,product:A.default,isInitialStartup:C.initialStartup,perfMarks:(0,m.getMarks)(),os:{release:(0,D.release)(),hostname:(0,D.hostname)(),arch:(0,D.arch)()},autoDetectHighContrast:W?.autoDetectHighContrast??!0,autoDetectColorScheme:W?.autoDetectColorScheme??!1,accessibilitySupport:i.app.accessibilitySupportEnabled,colorScheme:this.S.getColorScheme(),policiesData:this.F.serialize(),continueOn:this.G.continueOn};if(Z){const de=Z.config;!ie.extensionDevelopmentPath&&de?.extensionDevelopmentPath&&(ie.extensionDevelopmentPath=de.extensionDevelopmentPath,ie.extensionDevelopmentKind=de.extensionDevelopmentKind,ie["enable-proposed-api"]=de["enable-proposed-api"],ie.verbose=de.verbose,ie["inspect-extensions"]=de["inspect-extensions"],ie["inspect-brk-extensions"]=de["inspect-brk-extensions"],ie.debugId=de.debugId,ie.extensionEnvironment=de.extensionEnvironment,ie["extensions-dir"]=de["extensions-dir"],ie["disable-extensions"]=de["disable-extensions"]),ie.loggers={global:ie.loggers.global,window:de?.loggers.window??ie.loggers.window}}else{const de=this.r.getNewWindowState(ie);(0,m.mark)("code/willCreateCodeWindow");const me=Z=this.O.createInstance(U.$Mec,{state:de,extensionDevelopmentPath:ie.extensionDevelopmentPath,isExtensionTestHost:!!ie.extensionTestsPath});(0,m.mark)("code/didCreateCodeWindow"),C.forceNewTabbedWindow&&this.getLastActiveWindow()?.addTabbedWindow(me),this.n.set(me.id,me),this.a.fire(me),this.f.fire({oldCount:this.getWindowCount()-1,newCount:this.getWindowCount()});const pe=new g.$Vc;pe.add(me.onDidSignalReady(()=>this.b.fire(me))),pe.add(a.Event.once(me.onDidClose)(()=>this.tb(me,pe))),pe.add(a.Event.once(me.onDidDestroy)(()=>this.ub(me))),pe.add(me.onDidMaximize(()=>this.g.fire(me))),pe.add(me.onDidUnmaximize(()=>this.h.fire(me))),pe.add(me.onDidEnterFullScreen(()=>this.j.fire({window:me,fullscreen:!0}))),pe.add(me.onDidLeaveFullScreen(()=>this.j.fire({window:me,fullscreen:!1}))),pe.add(me.onDidTriggerSystemContextMenu(({x:ke,y:Pe})=>this.m.fire({window:me,x:ke,y:Pe})));const Ie=(0,v.$qg)(me.win?.webContents);Ie.removeAllListeners("devtools-reload-page"),pe.add(a.Event.fromNodeEventEmitter(Ie,"devtools-reload-page")(()=>this.I.reload(me))),this.I.registerWindow(me)}return ie.windowId=Z.id,Z.isReady?this.I.unload(Z,H.UnloadReason.LOAD).then(async de=>{de||await this.rb(Z,ie,C,X)}):await this.rb(Z,ie,C,X),Z}async rb(C,W,q,J){if(W.extensionDevelopmentPath||((0,Q.$Ui)(W.workspace)?W.backupPath=this.J.registerWorkspaceBackup({workspace:W.workspace,remoteAuthority:W.remoteAuthority}):(0,Q.$Pi)(W.workspace)?W.backupPath=this.J.registerFolderBackup({folderUri:W.workspace.uri,remoteAuthority:W.remoteAuthority}):W.backupPath=this.J.registerEmptyWindowBackup({backupFolder:q.emptyWindowBackupInfo?.backupFolder??(0,le.$Gec)().id,remoteAuthority:W.remoteAuthority})),this.H.isEnabled()){const X=W.workspace??(0,Q.$Ti)(W.backupPath,!1),Z=this.sb(q,X,J),ie=Z instanceof Promise?await Z:Z;W.profiles.profile=ie,W.extensionDevelopmentPath||await this.H.setProfileForWorkspace(X,ie)}C.load(W)}sb(C,W,q){return C.forceProfile?this.H.profiles.find(J=>J.name===C.forceProfile)??this.H.createNamedProfile(C.forceProfile):C.forceTempProfile?this.H.createTransientProfile():this.H.getProfileForWorkspace(W)??q}tb(C,W){this.n.delete(C.id),this.f.fire({oldCount:this.getWindowCount()+1,newCount:this.getWindowCount()}),W.dispose()}ub(C){this.n.delete(C.id),this.c.fire(C)}getFocusedWindow(){const C=i.BrowserWindow.getFocusedWindow();if(C)return this.getWindowById(C.id)}getLastActiveWindow(){return this.wb(this.getWindows())}vb(C){return this.wb(this.getWindows().filter(W=>(0,w.$lh)(W.remoteAuthority,C)))}wb(C){return(0,N.$xec)(C)}sendToFocused(C,...W){(this.getFocusedWindow()||this.getLastActiveWindow())?.sendWhenReady(C,P.CancellationToken.None,...W)}sendToOpeningWindow(C,...W){this.B(a.Event.once(this.onDidSignalReadyWindow)(q=>{q.sendWhenReady(C,P.CancellationToken.None,...W)}))}sendToAll(C,W,q){for(const J of this.getWindows())q&&q.indexOf(J.id)>=0||J.sendWhenReady(C,P.CancellationToken.None,W)}getWindows(){return Array.from(this.n.values())}getWindowCount(){return this.n.size}getWindowById(C){return this.n.get(C)}getWindowByWebContents(C){const W=i.BrowserWindow.fromWebContents(C);if(!W)return;const q=this.getWindowById(W.id);return q?.matches(C)?q:void 0}};e.$Xfc=_,e.$Xfc=_=Se([re(4,E.$_j),re(5,ce.$Jec),re(6,R.$dR),re(7,B.$qo),re(8,s.$kec),re(9,x.$yec),re(10,I.$Oec),re(11,r.$pec),re(12,n.$_i),re(13,K.$tfc),re(14,ee.$Hec),re(15,d.$Ei),re(16,c.$qec),re(17,u.$_k),re(18,T.$sec),re(19,j.$tec),re(20,G.$gfc)],_)}),define(oe[314],ae([0,1,69,29,88,60]),function(V,e,i,o,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zfc=void 0;let O=class{constructor(y,a,h,f){this.a=y,this.b=a,this.c=h,this.d=f,this.onDidChangeRecentlyOpened=this.c.onDidChangeRecentlyOpened}async enterWorkspace(y,a){const h=this.b.getWindowById(y);if(h)return this.a.enterWorkspace(h,this.b.getWindows(),a)}createUntitledWorkspace(y,a,h){return this.a.createUntitledWorkspace(a,h)}deleteUntitledWorkspace(y,a){return this.a.deleteUntitledWorkspace(a)}getWorkspaceIdentifier(y,a){return this.a.getWorkspaceIdentifier(a)}getRecentlyOpened(y){return this.c.getRecentlyOpened()}addRecentlyOpened(y,a){return this.c.addRecentlyOpened(a)}removeRecentlyOpened(y,a){return this.c.removeRecentlyOpened(a)}clearRecentlyOpened(y){return this.c.clearRecentlyOpened()}async getDirtyWorkspaces(){return this.d.getDirtyWorkspaces()}};e.$Zfc=O,e.$Zfc=O=Se([re(0,D.$Hec),re(1,o.$vec),re(2,S.$tfc),re(3,i.$pec)],O)}),define(oe[315],ae([0,1,14,107,37,27,17,53,16,31,3,319,48,2,13,9,4,12,7,33,163,44,164,119,296,167,69,289,18,297,96,136,58,97,225,25,68,101,213,300,215,216,217,15,229,99,82,6,98,224,306,290,298,20,5,312,75,28,72,301,102,34,279,87,129,24,256,257,56,50,269,294,307,295,308,133,271,272,273,276,304,57,29,313,278,30,103,88,314,60,40,238,59,249,55,86,134,281,299,286,8,259,280,233,71,303,275,22,73,302,267,244,65,83,310,77]),function(V,e,i,o,S,D,O,P,y,a,h,f,g,b,l,m,p,$,w,v,k,t,r,n,c,s,u,d,I,E,A,T,L,R,M,U,N,z,ne,Q,le,K,ee,H,j,B,x,ce,G,he,se,_,F,C,W,q,J,X,Z,ie,de,me,pe,Ie,ke,Pe,De,$e,Y,ue,fe,be,Oe,We,Fe,Ae,Be,xe,Ye,qe,Je,Xe,Ke,Ce,te,ge,we,ye,Me,Ue,Qe,lt,rt,at,tt,ut,ct,ft,gt,Ot,$t,wt,At,Lt,Tt,pt,jt,Et,dt,Mt,Ft,bt,Nt,St,Ct,kt){"use strict";var yt;Object.defineProperty(e,"__esModule",{value:!0}),e.$igc=void 0;let vt=class extends b.$Wc{static{yt=this}static{this.a={[l.Schemas.file]:"security.promptForLocalFileProtocolHandling",[l.Schemas.vscodeRemote]:"security.promptForRemoteFileProtocolHandling"}}constructor(Le,Te,je,ve,Ee,He,Ve,Ge,Ne,Ze,ze,_e){super(),this.g=Le,this.h=Te,this.j=je,this.m=ve,this.n=Ee,this.s=He,this.t=Ve,this.u=Ge,this.w=Ne,this.y=Ze,this.z=ze,this.C=_e,this.D(),this.F()}D(){const Le=Ne=>Ne?.startsWith(`${l.Schemas.vscodeWebview}://`),Te=new Set(["clipboard-read","clipboard-sanitized-write"]);i.session.defaultSession.setPermissionRequestHandler((Ne,Ze,ze,_e)=>Le(_e.requestingUrl)?ze(Te.has(Ze)):ze(!1)),i.session.defaultSession.setPermissionCheckHandler((Ne,Ze,ze,_e)=>Le(_e.requestingUrl)?Te.has(Ze):!1);const je=new Set([l.Schemas.file,l.Schemas.vscodeFileResource,l.Schemas.vscodeRemoteResource,l.Schemas.vscodeManagedRemoteResource,"devtools"]),ve=Ne=>{for(let Ze=Ne;Ze;Ze=Ze.parent)if(Ze.url.startsWith(`${l.Schemas.vscodeWebview}://`))return!0;return!1},Ee=Ne=>Ne.resourceType==="xhr"||ve(Ne.frame),He=Ne=>{const Ze=Ne.frame;if(!Ze||!this.b)return!1;const ze=i.BrowserWindow.getAllWindows();for(const _e of ze)if(Ze.processId===_e.webContents.mainFrame.processId)return!0;return!1},Ve=(Ne,Ze)=>{if(Ne.path!=="/index.html")return!0;const ze=Ze.frame;if(!ze||!this.b)return!1;for(const _e of this.b.getWindows())if(_e.win&&ze.processId===_e.win.webContents.mainFrame.processId)return!0;return!1};i.session.defaultSession.webRequest.onBeforeRequest((Ne,Ze)=>{const ze=w.URI.parse(Ne.url);return ze.scheme===l.Schemas.vscodeWebview&&!Ve(ze,Ne)?(this.m.error("Blocked vscode-webview request",Ne.url),Ze({cancel:!0})):ze.scheme===l.Schemas.vscodeFileResource&&!He(Ne)?(this.m.error("Blocked vscode-file request",Ne.url),Ze({cancel:!0})):ze.path.endsWith(".svg")&&!je.has(ze.scheme)?Ze({cancel:!Ee(Ne)}):Ze({cancel:!1})}),i.session.defaultSession.webRequest.onHeadersReceived((Ne,Ze)=>{const ze=Ne.responseHeaders,_e=ze["content-type"]||ze["Content-Type"];if(_e&&Array.isArray(_e)){const it=w.URI.parse(Ne.url);if(it.path.endsWith(".svg")&&je.has(it.scheme))return ze["Content-Type"]=["image/svg+xml"],Ze({cancel:!1,responseHeaders:ze});if(!it.path.endsWith(l.Schemas.vscodeRemoteResource)&&_e.some(ot=>ot.toLowerCase().includes("image/svg")))return Ze({cancel:!Ee(Ne)})}return Ze({cancel:!1})}),i.session.defaultSession.webRequest.onHeadersReceived((Ne,Ze)=>{if(Ne.url.startsWith("https://vscode.download.prss.microsoft.com/")){const ze=Ne.responseHeaders??Object.create(null);if(ze["Access-Control-Allow-Origin"]===void 0)return ze["Access-Control-Allow-Origin"]=["*"],Ze({cancel:!1,responseHeaders:ze})}return Ze({cancel:!1})});const Ge=i.session.defaultSession;typeof Ge.setCodeCachePath=="function"&&this.s.codeCachePath&&Ge.setCodeCachePath((0,m.$lc)(this.s.codeCachePath,"chrome")),p.$i&&(this.u.getValue("security.restrictUNCAccess")===!1?(0,o.disableUNCAccessRestrictions)():(0,o.addUNCHostToAllowlist)(this.u.getValue("security.allowedUNCHosts")))}F(){(0,y.setUnexpectedErrorHandler)(je=>this.H(je)),process.on("uncaughtException",je=>{(0,y.$2)(je)||(0,y.$3)(je)}),process.on("unhandledRejection",je=>(0,y.$3)(je)),h.Event.once(this.t.onWillShutdown)(()=>this.dispose()),(0,k.$CX)(),i.app.on("accessibility-support-changed",(je,ve)=>{this.b?.sendToAll("vscode:accessibilitySupportChanged",ve)}),i.app.on("activate",async(je,ve)=>{this.m.trace("app#activate"),ve||await this.b?.openEmptyWindow({context:Ke.OpenContext.DOCK})}),i.app.on("web-contents-created",(je,ve)=>{ve?.opener?.url.startsWith(`${l.Schemas.vscodeFileResource}://${l.$Yg}/`)&&(this.m.trace('[aux window]  app.on("web-contents-created"): Registering auxiliary window'),this.c?.registerWindow(ve)),ve.on("will-navigate",Ee=>{this.m.error("webContents#will-navigate: Prevented webcontent navigation"),Ee.preventDefault()}),ve.setWindowOpenHandler(Ee=>Ee.url==="about:blank"?(this.m.trace("[aux window] webContents#setWindowOpenHandler: Allowing auxiliary window to open on about:blank"),{action:"allow",overrideBrowserWindowOptions:this.c?.createWindow(Ee)}):(this.m.trace(`webContents#setWindowOpenHandler: Prevented opening window with URL ${Ee.url}}`),this.f?.openExternal(void 0,Ee.url),{action:"deny"}))});let Le=[],Te;i.app.on("open-file",(je,ve)=>{ve=(0,kt.$mm)(ve),this.m.trace("app#open-file: ",ve),je.preventDefault(),Le.push((0,ge.$$i)(ve)?{workspaceUri:w.URI.file(ve)}:{fileUri:w.URI.file(ve)}),Te!==void 0&&(clearTimeout(Te),Te=void 0),Te=setTimeout(async()=>{await this.b?.open({context:Ke.OpenContext.DOCK,cli:this.s.args,urisToOpen:Le,gotoLineMode:!1,preferNewWindow:!0}),Le=[],Te=void 0},100)}),i.app.on("new-window-for-tab",async()=>{await this.b?.openEmptyWindow({context:Ke.OpenContext.DESKTOP})}),S.$BX.handle("vscode:fetchShellEnv",je=>{const ve=this.b?.getWindowByWebContents(je.sender);let Ee,He;return ve?.config?(Ee=ve.config,He={...process.env,...ve.config.userEnv}):(Ee=this.s.args,He=process.env),this.X(Ee,He,!1)}),S.$BX.handle("vscode:writeNlsFile",(je,ve,Ee)=>{const He=this.G([ve]);if(!He||typeof Ee!="string")throw new Error("Invalid operation (vscode:writeNlsFile)");return this.y.writeFile(He,O.$Oe.fromString(Ee))}),S.$BX.handle("vscode:readNlsFile",async(je,...ve)=>{const Ee=this.G(ve);if(!Ee)throw new Error("Invalid operation (vscode:readNlsFile)");return(await this.y.readFile(Ee)).value.toString()}),S.$BX.on("vscode:toggleDevTools",je=>je.sender.toggleDevTools()),S.$BX.on("vscode:openDevTools",je=>je.sender.openDevTools()),S.$BX.on("vscode:reloadWindow",je=>je.sender.reload()),S.$BX.handle("vscode:notifyZoomLevel",async(je,ve)=>{const Ee=this.b?.getWindowByWebContents(je.sender);Ee&&Ee.notifyZoomLevel(ve)})}G(Le){let Te;for(const je of Le)typeof je=="string"&&(typeof Te!="string"?Te=je:Te=(0,m.$lc)(Te,je));if(!(typeof Te!="string"||!(0,m.$kc)(Te)||!(0,a.$Eg)(Te,this.s.cachedLanguagesPath,!p.$k)))return w.URI.file(Te)}H(Le){if(Le){const Te={message:`[uncaught exception in main]: ${Le.message}`,stack:Le.stack};this.b?.sendToFocused("vscode:reportError",JSON.stringify(Te))}this.m.error(`[uncaught exception in main]: ${Le}`),Le.stack&&this.m.error(Le.stack)}async startup(){this.m.debug("Starting VS Code"),this.m.debug(`from: ${this.s.appRoot}`),this.m.debug("args:",this.s.args);const Le=this.z.win32AppUserModelId;p.$i&&Le&&i.app.setAppUserModelId(Le);try{p.$j&&this.u.getValue("window.nativeTabs")===!0&&!i.systemPreferences.getUserDefault("NSUseImprovedLayoutPass","boolean")&&i.systemPreferences.setUserDefault("NSUseImprovedLayoutPass","boolean",!0)}catch(ze){this.m.error(ze)}const Te=new r.$IX;h.Event.once(this.t.onWillShutdown)(ze=>{ze.reason===C.ShutdownReason.KILL&&Te.dispose()}),this.m.trace("Resolving machine identifier...");const[je,ve,Ee]=await Promise.all([(0,wt.$9fc)(this.w,this.m),(0,wt.$0fc)(this.w,this.m),(0,wt.$$fc)(this.w,this.m)]);this.m.trace(`Resolved machine identifier: ${je}`);const{sharedProcessReady:He,sharedProcessClient:Ve}=this.P(je,ve,Ee),Ge=await this.Q(je,ve,Ee,He);this.B(Ge.createInstance(c.$Yec)),this.B(Ge.createInstance(gt.$4fc)),Ge.invokeFunction(ze=>this.R(ze,Te,Ve));const Ne=await Ge.invokeFunction(ze=>this.I(ze,Te));this.J(Te),this.t.phase=C.LifecycleMainPhase.Ready,await Ge.invokeFunction(ze=>this.S(ze,Ne)),this.t.phase=C.LifecycleMainPhase.AfterWindowOpen,this.U(),this.B(new $t.$Rh(()=>{this.B((0,$t.$Vh)(()=>this.t.phase=C.LifecycleMainPhase.Eventually,2500))},2500)).schedule()}async I(Le,Te){const je=this.b=Le.get(Ke.$vec),ve=Le.get(Ae.$qY),Ee=this.f=Le.get(J.$hfc),He=Le.get(L.$qec),Ve=this;ve.registerHandler({async handleURL(it,ot){return Ve.O(je,He,ve,it,ot)}});const Ge=this.B(new te.$Yfc({onDidOpenMainWindow:Ee.onDidOpenMainWindow,onDidFocusMainWindow:Ee.onDidFocusMainWindow,getActiveWindowId:()=>Ee.getActiveWindowId(-1)})),Ne=new t.$ni(it=>Ge.getActiveClientId().then(ot=>it===ot)),Ze=new Be.$Pfc(Ne,this.m),ze=Te.getChannel("urlHandler",Ze);ve.registerHandler(new Be.$Ofc(ze));const _e=await this.L(je,He);return this.B(new Ye.$Qfc(_e?.urls,ve,je,this.s,this.z,this.m)),_e}J(Le){const Te=()=>({statusCode:404,data:"Not found"}),je=new Nt.$X(()=>Le.getChannel(bt.$fgc,new bt.$ggc));i.protocol.registerBufferProtocol(l.Schemas.vscodeManagedRemoteResource,(ve,Ee)=>{const He=w.URI.parse(ve.url);if(!He.authority.startsWith("window:"))return Ee(Te());je.value.call(bt.$egc,[He]).then(Ve=>Ee({...Ve,data:Buffer.from(Ve.body,"base64")}),Ve=>{this.m.warn("error dispatching remote resource call",Ve),Ee({statusCode:500,data:String(Ve)})})})}async L(Le,Te){const je=this.s.args["open-url"]?this.s.args._urls||[]:[];je.length>0&&this.m.trace("app#resolveInitialProtocolUrls() protocol urls from command line:",je);const ve=global.getOpenUrls()||[];if(ve.length>0&&this.m.trace("app#resolveInitialProtocolUrls() protocol urls from macOS 'open-url' event:",ve),je.length+ve.length===0)return;const Ee=[...je,...ve].map(Ge=>{try{return{uri:w.URI.parse(Ge),originalUrl:Ge}}catch{this.m.trace("app#resolveInitialProtocolUrls() protocol url failed to parse:",Ge);return}}),He=[],Ve=[];for(const Ge of Ee){if(!Ge)continue;const Ne=this.N(Ge.uri);if(Ne)if(await this.M(Ne,Le,Te)){this.m.trace("app#resolveInitialProtocolUrls() protocol url was blocked:",Ge.uri.toString(!0));continue}else this.m.trace("app#resolveInitialProtocolUrls() protocol url will be handled as window to open:",Ge.uri.toString(!0),Ne),He.push(Ne);else this.m.trace("app#resolveInitialProtocolUrls() protocol url will be passed to active window for handling:",Ge.uri.toString(!0)),Ve.push(Ge)}return{urls:Ve,openables:He}}async M(Le,Te,je){let ve,Ee;if((0,Xe.$VD)(Le)?(ve=Le.workspaceUri,Ee=(0,s.localize)(0,null,ve.scheme===l.Schemas.file?(0,g.$Rw)(ve,{os:p.OS,tildify:this.s}):ve.toString(!0),this.z.nameShort)):(0,Xe.$WD)(Le)?(ve=Le.folderUri,Ee=(0,s.localize)(1,null,ve.scheme===l.Schemas.file?(0,g.$Rw)(ve,{os:p.OS,tildify:this.s}):ve.toString(!0),this.z.nameShort)):(ve=Le.fileUri,Ee=(0,s.localize)(2,null,ve.scheme===l.Schemas.file?(0,g.$Rw)(ve,{os:p.OS,tildify:this.s}):ve.toString(!0),this.z.nameShort)),ve.scheme!==l.Schemas.file&&ve.scheme!==l.Schemas.vscodeRemote||this.u.getValue(yt.a[ve.scheme])===!1)return!1;const{response:Ve,checkboxChecked:Ge}=await je.showMessageBox({type:"warning",buttons:[(0,s.localize)(3,null),(0,s.localize)(4,null)],message:Ee,detail:(0,s.localize)(5,null),checkboxLabel:ve.scheme===l.Schemas.file?(0,s.localize)(6,null):(0,s.localize)(7,null),cancelId:1});if(Ve!==0)return!0;if(Ge){const Ne={channel:"vscode:disablePromptForProtocolHandling",args:ve.scheme===l.Schemas.file?"local":"remote"};Te.sendToFocused(Ne.channel,Ne.args),Te.sendToOpeningWindow(Ne.channel,Ne.args)}return!1}N(Le){if(Le.path){if(Le.authority===l.Schemas.file){const Te=w.URI.file(Le.fsPath);return(0,ge.$$i)(Te)?{workspaceUri:Te}:{fileUri:Te}}else if(Le.authority===l.Schemas.vscodeRemote){const Te=Le.path.indexOf(m.$ic.sep,1);if(Te!==-1){const je=Le.path.substring(1,Te),ve=Le.path.substring(Te);let Ee=Le.query;const He=new URLSearchParams(Le.query);He.get("windowId")==="_blank"&&(He.delete("windowId"),Ee=He.toString());const Ve=w.URI.from({scheme:l.Schemas.vscodeRemote,authority:je,path:ve,query:Ee,fragment:Le.fragment});return(0,ge.$$i)(ve)?{workspaceUri:Ve}:/:[\d]+$/.test(ve)?{fileUri:Ve}:{folderUri:Ve}}}}}async O(Le,Te,je,ve,Ee){this.m.trace("app#handleProtocolUrl():",ve.toString(!0),Ee),ve.scheme===this.z.urlProtocol&&ve.path==="workspace"&&(ve=ve.with({authority:"file",path:w.URI.parse(ve.query).path,query:""}));let He=!1;const Ve=new URLSearchParams(ve.query);Ve.get("windowId")==="_blank"?(this.m.trace("app#handleProtocolUrl() found 'windowId=_blank' as parameter, setting shouldOpenInNewWindow=true:",ve.toString(!0)),Ve.delete("windowId"),ve=ve.with({query:Ve.toString()}),He=!0):p.$j&&Le.getWindowCount()===0&&(this.m.trace("app#handleProtocolUrl() running on macOS with no window open, setting shouldOpenInNewWindow=true:",ve.toString(!0)),He=!0);const Ge=Ve.get("continueOn");Ge!==null&&(this.m.trace("app#handleProtocolUrl() found 'continueOn' as parameter:",ve.toString(!0)),Ve.delete("continueOn"),ve=ve.with({query:Ve.toString()}),this.s.continueOn=Ge??void 0);const Ne=this.N(ve);return Ne?await this.M(Ne,Le,Te)?(this.m.trace("app#handleProtocolUrl() protocol url was blocked:",ve.toString(!0)),!0):(this.m.trace("app#handleProtocolUrl() opening protocol url as window:",Ne,ve.toString(!0)),(0,Et.$Qb)(await Le.open({context:Ke.OpenContext.API,cli:{...this.s.args},urisToOpen:[Ne],forceNewWindow:He,gotoLineMode:!0}))?.focus(),!0):He?(this.m.trace("app#handleProtocolUrl() opening empty window and passing in protocol url:",ve.toString(!0)),await(0,Et.$Qb)(await Le.open({context:Ke.OpenContext.API,cli:{...this.s.args},forceNewWindow:!0,forceEmpty:!0,gotoLineMode:!0,remoteAuthority:(0,Z.$gn)(ve)}))?.ready(),je.open(ve,Ee)):(this.m.trace("app#handleProtocolUrl(): not handled",ve.toString(!0),Ee),!1)}P(Le,Te,je){const ve=this.B(this.j.createInstance(ie.$Bfc,Le,Te,je));this.B(ve.onDidCrash(()=>this.b?.sendToFocused("vscode:reportSharedProcessCrash")));const Ee=(async()=>{this.m.trace("Main->SharedProcess#connect");const Ve=await ve.connect();return this.m.trace("Main->SharedProcess#connect: connection established"),new n.$JX(Ve,"main")})();return{sharedProcessReady:(async()=>(await ve.whenReady(),Ee))(),sharedProcessClient:Ee}}async Q(Le,Te,je,ve){const Ee=new G.$Di;switch(process.platform){case"win32":Ee.set(ue.$AY,new x.$Ci(Fe.$Mfc));break;case"linux":p.$l?Ee.set(ue.$AY,new x.$Ci(We.$Lfc,[process.env.SNAP,process.env.SNAP_REVISION])):Ee.set(ue.$AY,new x.$Ci(Oe.$Kfc));break;case"darwin":Ee.set(ue.$AY,new x.$Ci(be.$Jfc));break}Ee.set(Ke.$vec,new x.$Ci(Ce.$Xfc,[Le,Te,je,this.h],!1)),Ee.set(St.$gfc,new x.$Ci(Ct.$hgc,void 0,!1));const He=new L.$rec(this.m,this.z);Ee.set(L.$qec,He),Ee.set(F.$nfc,new x.$Ci(F.$ofc,void 0,!1)),Ee.set(T.$5ec,new x.$Ci(T.$6ec,void 0,!1)),Ee.set(A.$Sm,t.ProxyChannel.toService((0,t.$li)(ve.then(ze=>ze.getChannel("diagnostics"))))),Ee.set(he.$T$b,new x.$Ci(se.$jfc,[this.h])),Ee.set(R.$kY,new x.$Ci(M.$7ec)),Ee.set(_.$kfc,new x.$Ci(_.$lfc)),Ee.set(J.$hfc,new x.$Ci(J.$ifc,void 0,!1)),Ee.set(qe.$Rfc,new x.$Ci(Je.$Tfc)),Ee.set(q.$wfc,new x.$Ci(q.$xfc)),Ee.set(ne.$8ec,new x.$Ci(Q.$0ec)),Ee.set(Ie.$Uec,new x.$Ci(Ie.$Vec)),Ee.set(Ie.$Wec,new x.$Ci(Ie.$Xec));const Ve=new Mt.$dgc({graceTime:dt.LocalReconnectConstants.GraceTime,shortGraceTime:dt.LocalReconnectConstants.ShortGraceTime,scrollback:this.u.getValue(dt.TerminalSettingId.PersistentSessionScrollback)??100},this.u,this.s,this.t,this.m),Ge=new Ft.$Js(Ve,this.u,this.m,this.n);Ee.set(dt.$ks,Ge),p.$i?Ee.set(le.$$ec,new x.$Ci(K.$_ec)):p.$j?Ee.set(le.$$ec,new x.$Ci(K.$afc)):p.$k&&Ee.set(le.$$ec,new x.$Ci(K.$bfc));const Ne=new d.$Zec(this.s,this.u,this.m,this.w);Ee.set(u.$pec,Ne);const Ze=new Ue.$Iec(this.s,this.m,this.C,Ne,He);if(Ee.set(Ue.$Hec,Ze),Ee.set(we.$Fhb,new x.$Ci(Me.$Zfc,void 0,!1)),Ee.set(ye.$tfc,new x.$Ci(ye.$ufc,void 0,!1)),Ee.set(Ae.$qY,new x.$Ci(xe.$sY,void 0,!1)),(0,Y.$zp)(this.z,this.s)){const ze=(0,Y.$Ep)(this.z,this.u),_e=(0,t.$li)(ve.then(mt=>mt.getChannel("telemetryAppender"))),it=new De.$Efc(_e),ot=(0,ke.$qp)((0,D.release)(),(0,D.hostname)(),process.arch,this.z.commit,this.z.version,Le,Te,je,ze),nt=(0,Y.$Fp)(this.s),ht={appenders:[it],commonProperties:ot,piiPaths:nt,sendErrorTelemetry:!0};Ee.set(Pe.$$l,new x.$Ci($e.$as,[ht],!1))}else Ee.set(Pe.$$l,Y.$up);return Ee.set(ut.$Cq,new x.$Ci(At.$kR,void 0,!0)),Ee.set(ct.$Gq,new x.$Ci(ft.$3fc,void 0,!0)),Ee.set(pt.$bgc,new x.$Ci(pt.$cgc,void 0,!0)),await $t.Promises.settled([Ne.initialize(),Ze.initialize()]),this.j.createChild(Ee)}R(Le,Te,je){const ve=this.B(new b.$Vc),Ee=t.ProxyChannel.fromService(Le.get(F.$nfc),ve,{disableMarshalling:!0});this.g.registerChannel("launch",Ee);const He=t.ProxyChannel.fromService(Le.get(T.$5ec),ve,{disableMarshalling:!0});this.g.registerChannel("diagnostics",He);const Ve=ve.add(new lt.$1fc(Le.get(Qe.$qo)));Te.registerChannel("policy",Ve),je.then(st=>st.registerChannel("policy",Ve));const Ge=this.y.getProvider(l.Schemas.file);(0,$.$pg)(Ge instanceof B.$mr);const Ne=ve.add(new j.$cfc(Ge,this.m,this.s));Te.registerChannel(ee.$6Q,Ne),je.then(st=>st.registerChannel(ee.$6Q,Ne));const Ze=t.ProxyChannel.fromService(Le.get(rt.$yec),ve);Te.registerChannel("userDataProfiles",Ze),je.then(st=>st.registerChannel("userDataProfiles",Ze));const ze=new at.$8r(Le.get(tt.$1p));je.then(st=>st.registerChannel("request",ze));const _e=new fe.$Ffc(Le.get(ue.$AY));Te.registerChannel("update",_e);const it=t.ProxyChannel.fromService(Le.get(he.$T$b),ve);Te.registerChannel("issue",it);const ot=t.ProxyChannel.fromService(Le.get(R.$kY),ve);Te.registerChannel("encryption",ot);const nt=t.ProxyChannel.fromService(Le.get(de.$Yl),ve);Te.registerChannel("sign",nt);const ht=t.ProxyChannel.fromService(Le.get(_.$kfc),ve);Te.registerChannel("keyboardLayout",ht),this.f=Le.get(J.$hfc);const mt=t.ProxyChannel.fromService(this.f,ve);Te.registerChannel("nativeHost",mt),je.then(st=>st.registerChannel("nativeHost",mt));const Wt=t.ProxyChannel.fromService(Le.get(we.$Fhb),ve);Te.registerChannel("workspaces",Wt);const Bt=t.ProxyChannel.fromService(Le.get(q.$wfc),ve);Te.registerChannel("menubar",Bt);const Ut=t.ProxyChannel.fromService(Le.get(Ae.$qY),ve);Te.registerChannel("url",Ut);const zt=t.ProxyChannel.fromService(Le.get(qe.$Rfc),ve);Te.registerChannel("webview",zt);const Pt=ve.add(new pe.$Cfc(this.m,Le.get(Ie.$Uec)));Te.registerChannel("storage",Pt),je.then(st=>st.registerChannel("storage",Pt));const qt=ve.add(new Ot.$5fc(Le.get(Ie.$Uec),Le.get(rt.$yec),this.m));je.then(st=>st.registerChannel("profileStorageListener",qt));const Ht=t.ProxyChannel.fromService(Le.get(dt.$ks),ve);Te.registerChannel(dt.TerminalIpcChannels.LocalPty,Ht);const Zt=t.ProxyChannel.fromService(Le.get(le.$$ec),ve);Te.registerChannel("externalTerminal",Zt);const It=new Lt.$_fc(Le.get(Tt.$Jec));Te.registerChannel("logger",It),je.then(st=>st.registerChannel("logger",It));const Vt=new E.$1ec(Le.get(Ke.$vec));Te.registerChannel("extensionhostdebugservice",Vt);const xt=t.ProxyChannel.fromService(Le.get(ne.$8ec),ve);Te.registerChannel(ne.$9ec,xt);const Gt=t.ProxyChannel.fromService(Le.get(pt.$bgc),ve);Te.registerChannel(jt.$agc,Gt)}async S(Le,Te){const je=this.b=Le.get(Ke.$vec);this.c=Le.get(St.$gfc);const ve=(0,N.$Jm)(process.env)?Ke.OpenContext.CLI:Ke.OpenContext.DESKTOP,Ee=this.s.args;if(Te){if(Te.openables.length>0)return je.open({context:ve,cli:Ee,urisToOpen:Te.openables,gotoLineMode:!0,initialStartup:!0});if(Te.urls.length>0)for(const nt of Te.urls){const ht=new URLSearchParams(nt.uri.query);if(ht.get("windowId")==="_blank")return ht.delete("windowId"),nt.originalUrl=nt.uri.toString(!0),nt.uri=nt.uri.with({query:ht.toString()}),je.open({context:ve,cli:Ee,forceNewWindow:!0,forceEmpty:!0,gotoLineMode:!0,initialStartup:!0})}}const He=global.macOpenFiles,Ve=Ee._.length,Ge=!!Ee["folder-uri"],Ne=!!Ee["file-uri"],Ze=Ee["skip-add-to-recently-opened"]===!0,ze=Ee.wait&&Ee.waitMarkerFilePath?w.URI.file(Ee.waitMarkerFilePath):void 0,_e=Ee.remote||void 0,it=Ee.profile,ot=Ee["profile-temp"];if(!Ve&&!Ge&&!Ne){if(Ee["new-window"]||it||ot)return je.open({context:ve,cli:Ee,forceNewWindow:!0,forceEmpty:!0,noRecentEntry:Ze,waitMarkerFileURI:ze,initialStartup:!0,remoteAuthority:_e,forceProfile:it,forceTempProfile:ot});if(He.length)return je.open({context:Ke.OpenContext.DOCK,cli:Ee,urisToOpen:He.map(nt=>(nt=(0,kt.$mm)(nt),(0,ge.$$i)(nt)?{workspaceUri:w.URI.file(nt)}:{fileUri:w.URI.file(nt)})),noRecentEntry:Ze,waitMarkerFileURI:ze,initialStartup:!0})}return je.open({context:ve,cli:Ee,forceNewWindow:Ee["new-window"],diffMode:Ee.diff,mergeMode:Ee.merge,noRecentEntry:Ze,waitMarkerFileURI:ze,gotoLineMode:Ee.goto,initialStartup:!0,remoteAuthority:_e,forceProfile:it,forceTempProfile:ot})}U(){this.W(),i.protocol.registerHttpProtocol(l.Schemas.vscodeRemoteResource,(Le,Te)=>{Te({url:Le.url.replace(/^vscode-remote-resource:/,"http:"),method:Le.method})}),this.X(this.s.args,process.env,!0),this.Y(),p.$j&&i.app.runningUnderARM64Translation&&this.b?.sendToFocused("vscode:showTranslatedBuildWarning")}async W(){const Le=this.z.win32MutexName;if(p.$i&&Le)try{const Te=await new Promise((ve,Ee)=>{V(["@vscode/windows-mutex"],ve,Ee)}).then(Re),je=new Te.Mutex(Le);h.Event.once(this.t.onWillShutdown)(()=>je.release())}catch(Te){this.m.error(Te)}}async X(Le,Te,je){try{return await(0,z.$Qm)(this.u,this.m,Le,Te)}catch(ve){const Ee=(0,P.$qj)(ve);je?this.b?.sendToFocused("vscode:showResolveShellEnvError",Ee):this.m.error(Ee)}return{}}async Y(){try{const Te=(await this.y.readFile(this.s.argvResource)).value.toString(),je=(0,f.parse)(Te),Ee=(0,Y.$Bp)(this.u)>=Pe.TelemetryLevel.CRASH;if(je["enable-crash-reporter"]===void 0){const He=["","	// Allows to disable crash reporting.","	// Should restart the app if the value is changed.",`	"enable-crash-reporter": ${Ee},`,"","	// Unique id used for correlating crash reports sent from this instance.","	// Do not edit this value.",`	"crash-reporter-id": "${(0,v.$2g)()}"`,"}"],Ve=Te.substring(0,Te.length-2).concat(`,
`,He.join(`
`));await this.y.writeFile(this.s.argvResource,O.$Oe.fromString(Ve))}else{const He=Te.replace(/"enable-crash-reporter": .*,/,`"enable-crash-reporter": ${Ee},`);He!==Te&&await this.y.writeFile(this.s.argvResource,O.$Oe.fromString(He))}}catch(Le){this.m.error(Le),this.b?.sendToFocused("vscode:showArgvParseWarning")}}};e.$igc=vt,e.$igc=vt=yt=Se([re(2,ce.$Ei),re(3,W.$_j),re(4,W.$ak),re(5,U.$kec),re(6,C.$Oec),re(7,I.$_i),re(8,me.$dR),re(9,H.$_k),re(10,X.$sk),re(11,rt.$yec)],vt)});var et=this&&this.__importDefault||function(V){return V&&V.__esModule?V:{default:V}};define(oe[320],ae([0,1,14,47,7,22,8,53,16,31,3,48,13,9,70,4,36,26,21,44,105,315,10,18,243,255,25,68,207,15,227,99,82,223,98,20,230,5,84,28,85,282,132,293,55,292,102,254,34,56,74,59,40,239,237,2,41,270,71,232,124,128,274,107,268]),function(V,e,i,o,S,D,O,P,y,a,h,f,g,b,l,m,p,$,w,v,k,t,r,n,c,s,u,d,I,E,A,T,L,R,M,U,N,z,ne,Q,le,K,ee,H,j,B,x,ce,G,he,se,_,F,C,W,q,J,X,Z,ie,de,me,pe,Ie){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),ne=et(ne);class ke{main(){try{this.a()}catch($e){console.error($e.message),i.app.exit(1)}}async a(){(0,y.setUnexpectedErrorHandler)(Ae=>console.error(Ae));const[$e,Y,ue,fe,be,Oe,We,Fe]=this.b();try{try{await this.d(ue,Fe,fe,be,We)}catch(Ae){throw this.g(ue,We,Ae),Ae}await $e.invokeFunction(async Ae=>{const Be=Ae.get(z.$_j),xe=Ae.get(U.$Oec),Ye=Ae.get(E.$_k),qe=Ae.get(z.$ak),Je=await this.f(Be,ue,xe,$e,We,!0);return w.Promises.writeFile(ue.mainLockfile,String(process.pid)).catch(Xe=>{Be.warn(`app#startup(): Error writing main lockfile: ${Xe.stack}`)}),Oe.logger=qe.createLogger("main",{name:(0,r.localize)(0,null)}),h.Event.once(xe.onWillShutdown)(Xe=>{Ye.dispose(),fe.dispose(),Xe.join("instanceLockfile",w.Promises.unlink(ue.mainLockfile).catch(()=>{}))}),$e.createInstance(t.$igc,Je,Y).startup()})}catch(Ae){$e.invokeFunction(this.j,Ae)}}b(){const $e=new M.$Di,Y=new q.$Vc;process.once("exit",()=>Y.dispose());const ue={_serviceBrand:void 0,...ne.default};$e.set(Q.$sk,ue);const fe=new u.$lec(this.k(),ue),be=this.c(fe);$e.set(u.$kec,fe);const Oe=new Z.$Kec((0,z.$nk)(fe),fe.logsHome);$e.set(Z.$Jec,Oe);const We=new N.$Vbc(Oe.getLogLevel()),Fe=Y.add(new ie.$lR(We,[new z.$gk(Oe.getLogLevel())]));$e.set(z.$_j,Fe);const Ae=new A.$Vq(Fe);$e.set(E.$_k,Ae);const Be=new T.$mr(Fe);Ae.registerProvider(g.Schemas.file,Be);const xe=new X.$Ns(Ae);$e.set(J.$Jl,xe);const Ye=new me.$gR(me.SaveStrategy.DELAYED,fe,Fe,Ae);$e.set(G.$cR,Ye),$e.set(G.$dR,Ye);const qe=new _.$zec(Ye,xe,fe,Ae,Fe);$e.set(_.$yec,qe),Ae.registerProvider(g.Schemas.vscodeUserData,new pe.$tgc(g.Schemas.file,Be,g.Schemas.vscodeUserData,qe,xe,Fe));const Je=m.$i&&ue.win32RegValueName?Y.add(new C.$rgc(Fe,ue.win32RegValueName)):fe.policyFile?Y.add(new W.$sgc(fe.policyFile,Ae,Fe)):new F.$so;$e.set(F.$qo,Je);const Xe=new c.$So(qe.defaultProfile.settingsResource,Ae,Je,Fe);return $e.set(n.$_i,Xe),$e.set(U.$Oec,new L.$Ci(U.$Pec,void 0,!1)),$e.set(j.$1p,new L.$Ci(B.$pgc,void 0,!0)),$e.set(se.$tec,new L.$Ci(se.$uec)),$e.set(x.$Yl,new L.$Ci(ce.$qgc,void 0,!1)),$e.set(ee.$ww,new L.$Ci(H.$ngc)),$e.set(le.$sec,new K.$kgc(fe,qe,Fe)),[new R.$pr($e,!0),be,fe,Xe,Ye,We,ue,qe]}c($e){const Y={VSCODE_IPC_HOOK:$e.mainIPCHandle};return["VSCODE_NLS_CONFIG","VSCODE_PORTABLE"].forEach(ue=>{const fe=process.env[ue];typeof fe=="string"&&(Y[ue]=fe)}),Object.assign(process.env,Y),Y}async d($e,Y,ue,fe,be){await O.Promises.settled([Promise.all([this.e($e.extensionsPath),$e.codeCachePath,$e.logsHome.with({scheme:g.Schemas.file}).fsPath,Y.defaultProfile.globalStorageHome.with({scheme:g.Schemas.file}).fsPath,$e.workspaceStorageHome.with({scheme:g.Schemas.file}).fsPath,$e.localHistoryHome.with({scheme:g.Schemas.file}).fsPath,$e.backupHome].map(Oe=>Oe?w.Promises.mkdir(Oe,{recursive:!0}):void 0)),fe.init(),ue.initialize()]),Y.init()}e($e){if(m.$i){const Y=(0,Ie.getUNCHost)($e);Y&&(0,Ie.addUNCHostToAllowlist)(Y)}return $e}async f($e,Y,ue,fe,be,Oe){let We;try{(0,l.mark)("code/willStartMainServer"),We=await(0,k.$Ai)(Y.mainIPCHandle),(0,l.mark)("code/didStartMainServer"),h.Event.once(ue.onWillShutdown)(()=>We.dispose())}catch(Fe){if(Fe.code!=="EADDRINUSE")throw this.g(Y,be,Fe),Fe;let Ae;try{Ae=await(0,k.$Bi)(Y.mainIPCHandle,"main")}catch(qe){if(!Oe||m.$i||qe.code!=="ECONNREFUSED")throw qe.code==="EPERM"&&this.h((0,r.localize)(1,null,be.nameShort),(0,r.localize)(2,null),be),qe;try{(0,o.unlinkSync)(Y.mainIPCHandle)}catch(Je){throw $e.warn("Could not delete obsolete instance handle",Je),Je}return this.f($e,Y,ue,fe,be,!1)}if(Y.extensionTestsLocationURI&&!Y.debugExtensionHost.break){const qe=`Running extension tests from the command line is currently only supported if no other instance of ${be.nameShort} is running.`;throw $e.error(qe),Ae.dispose(),new Error(qe)}let Be;!Y.args.wait&&!Y.args.status&&(Be=setTimeout(()=>{this.h((0,r.localize)(3,null,be.nameShort),(0,r.localize)(4,null),be)},1e4));const xe=v.ProxyChannel.toService(Ae.getChannel("launch"),{disableMarshalling:!0}),Ye=v.ProxyChannel.toService(Ae.getChannel("diagnostics"),{disableMarshalling:!0});if(Y.args.status)return fe.invokeFunction(async()=>{const qe=new s.$Us(he.$up,be),Je=await Ye.getMainDiagnostics(),Xe=await Ye.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0}),Ke=await qe.getDiagnostics(Je,Xe);throw console.log(Ke),new y.$cb});throw m.$i&&await this.i(xe,$e),$e.trace("Sending env to running instance..."),await xe.start(Y.args,process.env),Ae.dispose(),Be&&clearTimeout(Be),new y.$cb("Sent env to running instance. Terminating...")}if(Y.args.status)throw console.log((0,r.localize)(5,null,be.nameShort)),new y.$cb("Terminating...");return process.env.VSCODE_PID=String(process.pid),We}g($e,Y,ue){if(ue.code==="EACCES"||ue.code==="EPERM"){const fe=(0,D.$Jb)([$e.userDataPath,$e.extensionsPath,k.$wi]).map(be=>(0,f.$Rw)(S.URI.file(be),{os:m.OS,tildify:$e}));this.h((0,r.localize)(6,null),(0,r.localize)(7,null,(0,P.$qj)(ue),fe.join(`
`)),Y)}}h($e,Y,ue){i.dialog.showMessageBoxSync((0,de.$6w)({type:"warning",buttons:[(0,r.localize)(8,null)],message:$e,detail:Y},ue).options)}async i($e,Y){if(m.$i){const ue=await $e.getMainProcessId();Y.trace("Sending some foreground love to the running instance:",ue);try{(await new Promise((fe,be)=>{V(["windows-foreground-love"],fe,be)}).then(Re)).allowSetForegroundWindow(ue)}catch(fe){Y.error(fe)}}}j($e,Y){const ue=$e.get(z.$_j),fe=$e.get(U.$Oec);let be=0;Y&&(Y.isExpected?Y.message&&ue.trace(Y.message):(be=1,Y.stack?ue.error(Y.stack):ue.error(`Startup error: ${Y.toString()}`))),fe.kill(be)}k(){const $e=this.l((0,d.$Gm)(process.argv));if($e.wait&&!$e.waitMarkerFilePath){const Y=(0,I.$jgc)($e.verbose);Y&&((0,d.$Im)(process.argv,"--waitMarkerFilePath",Y),$e.waitMarkerFilePath=Y)}return $e}l($e){if($e["open-url"]&&($e._urls=$e._,$e._=[]),!$e.remote){const Y=this.m($e._,$e.goto);$e._=Y}return $e}m($e,Y){const ue=(0,p.cwd)(),fe=$e.map(We=>{let Fe=String(We),Ae;Y&&(Ae=(0,a.$Mg)(Fe),Fe=Ae.path),Fe&&(Fe=this.n(ue,Fe));const Be=(0,a.$Gg)(Fe,ue),xe=(0,b.$pc)(Be);return xe&&!(0,a.$Cg)(xe)?null:Y&&Ae?(Ae.path=Be,this.o(Ae)):Be}),be=m.$i||m.$j,Oe=(0,D.$Ob)(fe,We=>We&&be?We.toLowerCase():We||"");return(0,D.$Jb)(Oe)}n($e,Y){return m.$i&&(Y=(0,$.$of)(Y,'"')),Y=(0,$.$mf)((0,$.$mf)(Y," "),"	"),m.$i&&(Y=(0,b.$mc)($e,Y),Y=(0,$.$of)(Y,".")),Y}o($e){const Y=[$e.path];return typeof $e.line=="number"&&Y.push(String($e.line)),typeof $e.column=="number"&&Y.push(String($e.column)),Y.join(":")}}new ke().main()})}).call(this);

//# sourceMappingURL=https://main.vscode-cdn.net/sourcemaps/c2e20cb17fae44eb26611cb9a4690059cea0e605/core/vs/code/electron-main/main.js.map
