/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var re=["require","exports","vs/base/common/lifecycle","vs/base/common/types","vs/nls!vs/code/node/cliProcessMain","vs/base/common/event","vs/platform/log/common/log","vs/nls","vs/base/common/async","vs/base/common/errors","vs/platform/files/common/files","vs/platform/instantiation/common/instantiation","vs/base/common/uri","vs/base/common/platform","vs/base/common/buffer","vs/base/common/network","vs/base/common/path","vs/base/common/resources","vs/platform/environment/common/environment","vs/platform/telemetry/common/telemetry","vs/base/common/arrays","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/cancellation","vs/platform/uriIdentity/common/uriIdentity","vs/platform/userDataProfile/common/userDataProfile","vs/base/node/pfs","vs/platform/extensions/common/extensions","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/objects","vs/base/common/uuid","vs/platform/configuration/common/configuration","vs/base/common/map","vs/base/common/strings","vs/platform/product/common/productService","vs/base/common/json","os","vs/base/common/process","vs/platform/registry/common/platform","vs/base/common/errorMessage","vs/platform/policy/common/policy","vs/platform/configuration/common/configurationRegistry","vs/platform/telemetry/common/telemetryUtils","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/base/common/hash","vs/base/common/semver/semver","vs/platform/request/common/request","vs/base/common/stream","vs/base/common/marshalling","vs/base/common/ternarySearchTree","vs/base/node/zip","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/descriptors","vs/platform/files/common/watcher","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/common/extensionsScannerService","vs/base/common/decorators","vs/base/common/severity","vs/base/common/processes","vs/base/node/processes","vs/base/parts/ipc/common/ipc","child_process","vs/platform/download/common/download","vs/platform/files/common/io","vs/base/common/extpath","vs/platform/instantiation/common/serviceCollection","vs/base/common/iterator","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/remoteHosts","vs/platform/languagePacks/common/languagePacks","vs/platform/state/node/stateService","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/node/extensionSignatureVerificationService","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/storage/common/storage","vs/base/common/amd","vs/base/common/assert","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/numbers","vs/base/common/skipList","vs/base/node/macAddress","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/base/common/console","vs/amdX","vs/base/node/id","vs/base/node/powershell","vs/base/node/shell","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/common/storage","vs/nls!vs/base/node/zip","fs","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionManagementCLI","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/log/common/log","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/platform/contextkey/common/scanner","vs/base/common/charCode","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/contextkey/common/contextkey","vs/platform/files/node/watcher/baseWatcher","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logService","vs/platform/log/node/spdlogLog","vs/platform/log/node/loggerService","vs/platform/policy/common/filePolicyService","vs/platform/policy/node/nativePolicyService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/download/common/downloadService","vs/platform/request/node/proxy","url","vs/platform/shell/node/shellEnv","vs/platform/state/node/state","vs/platform/extensionManagement/common/extensionManagementCLI","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/languagePacks/node/languagePacks","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/common/telemetryService","vs/platform/product/common/product","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/telemetry","vs/platform/telemetry/node/telemetryUtils","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/userData/common/fileUserDataProvider","vs/platform/workspace/common/workspace","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/externalServices/common/serviceMachineId","vs/platform/externalServices/common/marketplace","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/userDataProfile/node/userDataProfile","vs/platform/request/node/requestService","vs/base/common/lazy","vs/base/common/marshallingIds","path","vs/base/common/glob","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/base/common/linkedList","vs/platform/environment/node/argvHelper","crypto","https","vs/base/common/stopwatch","zlib","vs/code/node/cliProcessMain","vs/base/node/unc"],oe=function(H){for(var t=[],E=0,P=H.length;E<P;E++)t[E]=re[H[E]];return t};define(re[74],oe([0,1]),function(H,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$W=t.LoaderEventType=t.$V=void 0,t.$V=!1;var E;(function(y){y[y.LoaderAvailable=1]="LoaderAvailable",y[y.BeginLoadingScript=10]="BeginLoadingScript",y[y.EndLoadingScriptOK=11]="EndLoadingScriptOK",y[y.EndLoadingScriptError=12]="EndLoadingScriptError",y[y.BeginInvokeFactory=21]="BeginInvokeFactory",y[y.EndInvokeFactory=22]="EndInvokeFactory",y[y.NodeBeginEvaluatingScript=31]="NodeBeginEvaluatingScript",y[y.NodeEndEvaluatingScript=32]="NodeEndEvaluatingScript",y[y.NodeBeginNativeRequire=33]="NodeBeginNativeRequire",y[y.NodeEndNativeRequire=34]="NodeEndNativeRequire",y[y.CachedDataFound=60]="CachedDataFound",y[y.CachedDataMissed=61]="CachedDataMissed",y[y.CachedDataRejected=62]="CachedDataRejected",y[y.CachedDataCreated=63]="CachedDataCreated"})(E||(t.LoaderEventType=E={}));class P{static get(){const O=new Map,A=new Map,k=new Map,g=new Map;function c(m,R){m.has(R.detail)||m.set(R.detail,-R.timestamp)}function l(m,R){const p=m.get(R.detail);p&&(p>=0||m.set(R.detail,p+R.timestamp))}let u=[];typeof H=="function"&&typeof H.getStats=="function"&&(u=H.getStats().slice(0).sort((m,R)=>m.timestamp-R.timestamp));for(const m of u)switch(m.type){case E.BeginLoadingScript:c(O,m);break;case E.EndLoadingScriptOK:case E.EndLoadingScriptError:l(O,m);break;case E.BeginInvokeFactory:c(A,m);break;case E.EndInvokeFactory:l(A,m);break;case E.NodeBeginNativeRequire:c(k,m);break;case E.NodeEndNativeRequire:l(k,m);break;case E.NodeBeginEvaluatingScript:c(g,m);break;case E.NodeEndEvaluatingScript:l(g,m);break}let h=0;k.forEach(m=>h+=m);function w(m){const R=[];return m.forEach((p,f)=>R.push([f,p])),R}return{amdLoad:w(O),amdInvoke:w(A),nodeRequire:w(k),nodeEval:w(g),nodeRequireTotal:h}}static toMarkdownTable(O,A){let k="";const g=[];return O.forEach((c,l)=>{g[l]=c.length}),A.forEach(c=>{c.forEach((l,u)=>{typeof l>"u"&&(l=c[u]="-");const h=l.toString().length;g[u]=Math.max(h,g[u])})}),O.forEach((c,l)=>{k+=`| ${c+" ".repeat(g[l]-c.toString().length)} `}),k+=`|
`,O.forEach((c,l)=>{k+=`| ${"-".repeat(g[l])} `}),k+=`|
`,A.forEach(c=>{c.forEach((l,u)=>{typeof l<"u"&&(k+=`| ${l+" ".repeat(g[u]-l.toString().length)} `)}),k+=`|
`}),k}}t.$W=P}),define(re[55],oe([0,1]),function(H,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$0h=P,t.$$h=y,t.$_h=O;function E(A){return(k,g,c)=>{let l=null,u=null;if(typeof c.value=="function"?(l="value",u=c.value):typeof c.get=="function"&&(l="get",u=c.get),!u)throw new Error("not supported");c[l]=A(u,g)}}function P(A,k,g){let c=null,l=null;if(typeof g.value=="function"?(c="value",l=g.value,l.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof g.get=="function"&&(c="get",l=g.get),!l)throw new Error("not supported");const u=`$memoize$${k}`;g[c]=function(...h){return this.hasOwnProperty(u)||Object.defineProperty(this,u,{configurable:!1,enumerable:!1,writable:!1,value:l.apply(this,h)}),this[u]}}function y(A,k,g){return E((c,l)=>{const u=`$debounce$${l}`,h=`$debounce$result$${l}`;return function(...w){this[h]||(this[h]=g?g():void 0),clearTimeout(this[u]),k&&(this[h]=k(this[h],...w),w=[this[h]]),this[u]=setTimeout(()=>{c.apply(this,w),this[h]=g?g():void 0},A)}})}function O(A,k,g){return E((c,l)=>{const u=`$throttle$timer$${l}`,h=`$throttle$result$${l}`,w=`$throttle$lastRun$${l}`,m=`$throttle$pending$${l}`;return function(...R){if(this[h]||(this[h]=g?g():void 0),(this[w]===null||this[w]===void 0)&&(this[w]=-Number.MAX_VALUE),k&&(this[h]=k(this[h],...R)),this[m])return;const p=this[w]+A;p<=Date.now()?(this[w]=Date.now(),c.apply(this,[this[h]]),this[h]=g?g():void 0):(this[m]=!0,this[u]=setTimeout(()=>{this[m]=!1,this[w]=Date.now(),c.apply(this,[this[h]]),this[h]=g?g():void 0},p-Date.now()))}})}}),define(re[75],oe([0,1,9]),function(H,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ok=P,t.$gd=y,t.$hd=O,t.$id=A,t.$jd=k,t.$kd=g;function P(c,l){if(!c)throw new Error(l?`Assertion failed (${l})`:"Assertion Failed")}function y(c,l="Unreachable"){throw new Error(l)}function O(c,l="unexpected state"){if(!c)throw new E.$eb(`Assertion Failed: ${l}`)}function A(c){c||(0,E.$3)(new E.$eb("Soft Assertion Failed"))}function k(c){if(!c()){debugger;c(),(0,E.$3)(new E.$eb("Assertion Failed"))}}function g(c,l){let u=0;for(;u<c.length-1;){const h=c[u],w=c[u+1];if(!l(h,w))return!1;u++}return!0}}),define(re[34],oe([0,1]),function(H,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ParseOptions=t.ParseErrorCode=t.SyntaxKind=t.ScanError=void 0,t.$Tn=A,t.$Un=u,t.$Vn=h,t.$Wn=w,t.$Xn=m,t.$Yn=R,t.$Zn=p,t.$1n=f,t.$2n=$,t.$3n=I,t.$4n=v;var E;(function(e){e[e.None=0]="None",e[e.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",e[e.UnexpectedEndOfString=2]="UnexpectedEndOfString",e[e.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",e[e.InvalidUnicode=4]="InvalidUnicode",e[e.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",e[e.InvalidCharacter=6]="InvalidCharacter"})(E||(t.ScanError=E={}));var P;(function(e){e[e.OpenBraceToken=1]="OpenBraceToken",e[e.CloseBraceToken=2]="CloseBraceToken",e[e.OpenBracketToken=3]="OpenBracketToken",e[e.CloseBracketToken=4]="CloseBracketToken",e[e.CommaToken=5]="CommaToken",e[e.ColonToken=6]="ColonToken",e[e.NullKeyword=7]="NullKeyword",e[e.TrueKeyword=8]="TrueKeyword",e[e.FalseKeyword=9]="FalseKeyword",e[e.StringLiteral=10]="StringLiteral",e[e.NumericLiteral=11]="NumericLiteral",e[e.LineCommentTrivia=12]="LineCommentTrivia",e[e.BlockCommentTrivia=13]="BlockCommentTrivia",e[e.LineBreakTrivia=14]="LineBreakTrivia",e[e.Trivia=15]="Trivia",e[e.Unknown=16]="Unknown",e[e.EOF=17]="EOF"})(P||(t.SyntaxKind=P={}));var y;(function(e){e[e.InvalidSymbol=1]="InvalidSymbol",e[e.InvalidNumberFormat=2]="InvalidNumberFormat",e[e.PropertyNameExpected=3]="PropertyNameExpected",e[e.ValueExpected=4]="ValueExpected",e[e.ColonExpected=5]="ColonExpected",e[e.CommaExpected=6]="CommaExpected",e[e.CloseBraceExpected=7]="CloseBraceExpected",e[e.CloseBracketExpected=8]="CloseBracketExpected",e[e.EndOfFileExpected=9]="EndOfFileExpected",e[e.InvalidCommentToken=10]="InvalidCommentToken",e[e.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",e[e.UnexpectedEndOfString=12]="UnexpectedEndOfString",e[e.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",e[e.InvalidUnicode=14]="InvalidUnicode",e[e.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",e[e.InvalidCharacter=16]="InvalidCharacter"})(y||(t.ParseErrorCode=y={}));var O;(function(e){e.DEFAULT={allowTrailingComma:!0}})(O||(t.ParseOptions=O={}));function A(e,a=!1){let n=0;const r=e.length;let i="",s=0,o=P.Unknown,d=E.None;function S(Y){let ae=0,le=0;for(;ae<Y;){const ce=e.charCodeAt(n);if(ce>=l._0&&ce<=l._9)le=le*16+ce-l._0;else if(ce>=l.A&&ce<=l.F)le=le*16+ce-l.A+10;else if(ce>=l.a&&ce<=l.f)le=le*16+ce-l.a+10;else break;n++,ae++}return ae<Y&&(le=-1),le}function N(Y){n=Y,i="",s=0,o=P.Unknown,d=E.None}function C(){const Y=n;if(e.charCodeAt(n)===l._0)n++;else for(n++;n<e.length&&c(e.charCodeAt(n));)n++;if(n<e.length&&e.charCodeAt(n)===l.dot)if(n++,n<e.length&&c(e.charCodeAt(n)))for(n++;n<e.length&&c(e.charCodeAt(n));)n++;else return d=E.UnexpectedEndOfNumber,e.substring(Y,n);let ae=n;if(n<e.length&&(e.charCodeAt(n)===l.E||e.charCodeAt(n)===l.e))if(n++,(n<e.length&&e.charCodeAt(n)===l.plus||e.charCodeAt(n)===l.minus)&&n++,n<e.length&&c(e.charCodeAt(n))){for(n++;n<e.length&&c(e.charCodeAt(n));)n++;ae=n}else d=E.UnexpectedEndOfNumber;return e.substring(Y,ae)}function D(){let Y="",ae=n;for(;;){if(n>=r){Y+=e.substring(ae,n),d=E.UnexpectedEndOfString;break}const le=e.charCodeAt(n);if(le===l.doubleQuote){Y+=e.substring(ae,n),n++;break}if(le===l.backslash){if(Y+=e.substring(ae,n),n++,n>=r){d=E.UnexpectedEndOfString;break}switch(e.charCodeAt(n++)){case l.doubleQuote:Y+='"';break;case l.backslash:Y+="\\";break;case l.slash:Y+="/";break;case l.b:Y+="\b";break;case l.f:Y+="\f";break;case l.n:Y+=`
`;break;case l.r:Y+="\r";break;case l.t:Y+="	";break;case l.u:{const de=S(4);de>=0?Y+=String.fromCharCode(de):d=E.InvalidUnicode;break}default:d=E.InvalidEscapeCharacter}ae=n;continue}if(le>=0&&le<=31)if(g(le)){Y+=e.substring(ae,n),d=E.UnexpectedEndOfString;break}else d=E.InvalidCharacter;n++}return Y}function T(){if(i="",d=E.None,s=n,n>=r)return s=r,o=P.EOF;let Y=e.charCodeAt(n);if(k(Y)){do n++,i+=String.fromCharCode(Y),Y=e.charCodeAt(n);while(k(Y));return o=P.Trivia}if(g(Y))return n++,i+=String.fromCharCode(Y),Y===l.carriageReturn&&e.charCodeAt(n)===l.lineFeed&&(n++,i+=`
`),o=P.LineBreakTrivia;switch(Y){case l.openBrace:return n++,o=P.OpenBraceToken;case l.closeBrace:return n++,o=P.CloseBraceToken;case l.openBracket:return n++,o=P.OpenBracketToken;case l.closeBracket:return n++,o=P.CloseBracketToken;case l.colon:return n++,o=P.ColonToken;case l.comma:return n++,o=P.CommaToken;case l.doubleQuote:return n++,i=D(),o=P.StringLiteral;case l.slash:{const ae=n-1;if(e.charCodeAt(n+1)===l.slash){for(n+=2;n<r&&!g(e.charCodeAt(n));)n++;return i=e.substring(ae,n),o=P.LineCommentTrivia}if(e.charCodeAt(n+1)===l.asterisk){n+=2;const le=r-1;let ce=!1;for(;n<le;){if(e.charCodeAt(n)===l.asterisk&&e.charCodeAt(n+1)===l.slash){n+=2,ce=!0;break}n++}return ce||(n++,d=E.UnexpectedEndOfComment),i=e.substring(ae,n),o=P.BlockCommentTrivia}return i+=String.fromCharCode(Y),n++,o=P.Unknown}case l.minus:if(i+=String.fromCharCode(Y),n++,n===r||!c(e.charCodeAt(n)))return o=P.Unknown;case l._0:case l._1:case l._2:case l._3:case l._4:case l._5:case l._6:case l._7:case l._8:case l._9:return i+=C(),o=P.NumericLiteral;default:for(;n<r&&M(Y);)n++,Y=e.charCodeAt(n);if(s!==n){switch(i=e.substring(s,n),i){case"true":return o=P.TrueKeyword;case"false":return o=P.FalseKeyword;case"null":return o=P.NullKeyword}return o=P.Unknown}return i+=String.fromCharCode(Y),n++,o=P.Unknown}}function M(Y){if(k(Y)||g(Y))return!1;switch(Y){case l.closeBrace:case l.closeBracket:case l.openBrace:case l.openBracket:case l.doubleQuote:case l.colon:case l.comma:case l.slash:return!1}return!0}function K(){let Y;do Y=T();while(Y>=P.LineCommentTrivia&&Y<=P.Trivia);return Y}return{setPosition:N,getPosition:()=>n,scan:a?K:T,getToken:()=>o,getTokenValue:()=>i,getTokenOffset:()=>s,getTokenLength:()=>n-s,getTokenError:()=>d}}function k(e){return e===l.space||e===l.tab||e===l.verticalTab||e===l.formFeed||e===l.nonBreakingSpace||e===l.ogham||e>=l.enQuad&&e<=l.zeroWidthSpace||e===l.narrowNoBreakSpace||e===l.mathematicalSpace||e===l.ideographicSpace||e===l.byteOrderMark}function g(e){return e===l.lineFeed||e===l.carriageReturn||e===l.lineSeparator||e===l.paragraphSeparator}function c(e){return e>=l._0&&e<=l._9}var l;(function(e){e[e.nullCharacter=0]="nullCharacter",e[e.maxAsciiCharacter=127]="maxAsciiCharacter",e[e.lineFeed=10]="lineFeed",e[e.carriageReturn=13]="carriageReturn",e[e.lineSeparator=8232]="lineSeparator",e[e.paragraphSeparator=8233]="paragraphSeparator",e[e.nextLine=133]="nextLine",e[e.space=32]="space",e[e.nonBreakingSpace=160]="nonBreakingSpace",e[e.enQuad=8192]="enQuad",e[e.emQuad=8193]="emQuad",e[e.enSpace=8194]="enSpace",e[e.emSpace=8195]="emSpace",e[e.threePerEmSpace=8196]="threePerEmSpace",e[e.fourPerEmSpace=8197]="fourPerEmSpace",e[e.sixPerEmSpace=8198]="sixPerEmSpace",e[e.figureSpace=8199]="figureSpace",e[e.punctuationSpace=8200]="punctuationSpace",e[e.thinSpace=8201]="thinSpace",e[e.hairSpace=8202]="hairSpace",e[e.zeroWidthSpace=8203]="zeroWidthSpace",e[e.narrowNoBreakSpace=8239]="narrowNoBreakSpace",e[e.ideographicSpace=12288]="ideographicSpace",e[e.mathematicalSpace=8287]="mathematicalSpace",e[e.ogham=5760]="ogham",e[e._=95]="_",e[e.$=36]="$",e[e._0=48]="_0",e[e._1=49]="_1",e[e._2=50]="_2",e[e._3=51]="_3",e[e._4=52]="_4",e[e._5=53]="_5",e[e._6=54]="_6",e[e._7=55]="_7",e[e._8=56]="_8",e[e._9=57]="_9",e[e.a=97]="a",e[e.b=98]="b",e[e.c=99]="c",e[e.d=100]="d",e[e.e=101]="e",e[e.f=102]="f",e[e.g=103]="g",e[e.h=104]="h",e[e.i=105]="i",e[e.j=106]="j",e[e.k=107]="k",e[e.l=108]="l",e[e.m=109]="m",e[e.n=110]="n",e[e.o=111]="o",e[e.p=112]="p",e[e.q=113]="q",e[e.r=114]="r",e[e.s=115]="s",e[e.t=116]="t",e[e.u=117]="u",e[e.v=118]="v",e[e.w=119]="w",e[e.x=120]="x",e[e.y=121]="y",e[e.z=122]="z",e[e.A=65]="A",e[e.B=66]="B",e[e.C=67]="C",e[e.D=68]="D",e[e.E=69]="E",e[e.F=70]="F",e[e.G=71]="G",e[e.H=72]="H",e[e.I=73]="I",e[e.J=74]="J",e[e.K=75]="K",e[e.L=76]="L",e[e.M=77]="M",e[e.N=78]="N",e[e.O=79]="O",e[e.P=80]="P",e[e.Q=81]="Q",e[e.R=82]="R",e[e.S=83]="S",e[e.T=84]="T",e[e.U=85]="U",e[e.V=86]="V",e[e.W=87]="W",e[e.X=88]="X",e[e.Y=89]="Y",e[e.Z=90]="Z",e[e.ampersand=38]="ampersand",e[e.asterisk=42]="asterisk",e[e.at=64]="at",e[e.backslash=92]="backslash",e[e.bar=124]="bar",e[e.caret=94]="caret",e[e.closeBrace=125]="closeBrace",e[e.closeBracket=93]="closeBracket",e[e.closeParen=41]="closeParen",e[e.colon=58]="colon",e[e.comma=44]="comma",e[e.dot=46]="dot",e[e.doubleQuote=34]="doubleQuote",e[e.equals=61]="equals",e[e.exclamation=33]="exclamation",e[e.greaterThan=62]="greaterThan",e[e.lessThan=60]="lessThan",e[e.minus=45]="minus",e[e.openBrace=123]="openBrace",e[e.openBracket=91]="openBracket",e[e.openParen=40]="openParen",e[e.percent=37]="percent",e[e.plus=43]="plus",e[e.question=63]="question",e[e.semicolon=59]="semicolon",e[e.singleQuote=39]="singleQuote",e[e.slash=47]="slash",e[e.tilde=126]="tilde",e[e.backspace=8]="backspace",e[e.formFeed=12]="formFeed",e[e.byteOrderMark=65279]="byteOrderMark",e[e.tab=9]="tab",e[e.verticalTab=11]="verticalTab"})(l||(l={}));function u(e,a){const n=[],r=new Object;let i;const s={value:{},offset:0,length:0,type:"object",parent:void 0};let o=!1;function d(S,N,C,D){s.value=S,s.offset=N,s.length=C,s.type=D,s.colonOffset=void 0,i=s}try{I(e,{onObjectBegin:(S,N)=>{if(a<=S)throw r;i=void 0,o=a>S,n.push("")},onObjectProperty:(S,N,C)=>{if(a<N||(d(S,N,C,"property"),n[n.length-1]=S,a<=N+C))throw r},onObjectEnd:(S,N)=>{if(a<=S)throw r;i=void 0,n.pop()},onArrayBegin:(S,N)=>{if(a<=S)throw r;i=void 0,n.push(0)},onArrayEnd:(S,N)=>{if(a<=S)throw r;i=void 0,n.pop()},onLiteralValue:(S,N,C)=>{if(a<N||(d(S,N,C,v(S)),a<=N+C))throw r},onSeparator:(S,N,C)=>{if(a<=N)throw r;if(S===":"&&i&&i.type==="property")i.colonOffset=N,o=!1,i=void 0;else if(S===","){const D=n[n.length-1];typeof D=="number"?n[n.length-1]=D+1:(o=!0,n[n.length-1]=""),i=void 0}}})}catch(S){if(S!==r)throw S}return{path:n,previousNode:i,isAtPropertyKey:o,matches:S=>{let N=0;for(let C=0;N<S.length&&C<n.length;C++)if(S[N]===n[C]||S[N]==="*")N++;else if(S[N]!=="**")return!1;return N===S.length}}}function h(e,a=[],n=O.DEFAULT){let r=null,i=[];const s=[];function o(S){Array.isArray(i)?i.push(S):r!==null&&(i[r]=S)}return I(e,{onObjectBegin:()=>{const S={};o(S),s.push(i),i=S,r=null},onObjectProperty:S=>{r=S},onObjectEnd:()=>{i=s.pop()},onArrayBegin:()=>{const S=[];o(S),s.push(i),i=S,r=null},onArrayEnd:()=>{i=s.pop()},onLiteralValue:o,onError:(S,N,C)=>{a.push({error:S,offset:N,length:C})}},n),i[0]}function w(e,a=[],n=O.DEFAULT){let r={type:"array",offset:-1,length:-1,children:[],parent:void 0};function i(S){r.type==="property"&&(r.length=S-r.offset,r=r.parent)}function s(S){return r.children.push(S),S}I(e,{onObjectBegin:S=>{r=s({type:"object",offset:S,length:-1,parent:r,children:[]})},onObjectProperty:(S,N,C)=>{r=s({type:"property",offset:N,length:-1,parent:r,children:[]}),r.children.push({type:"string",value:S,offset:N,length:C,parent:r})},onObjectEnd:(S,N)=>{r.length=S+N-r.offset,r=r.parent,i(S+N)},onArrayBegin:(S,N)=>{r=s({type:"array",offset:S,length:-1,parent:r,children:[]})},onArrayEnd:(S,N)=>{r.length=S+N-r.offset,r=r.parent,i(S+N)},onLiteralValue:(S,N,C)=>{s({type:v(S),offset:N,length:C,parent:r,value:S}),i(N+C)},onSeparator:(S,N,C)=>{r.type==="property"&&(S===":"?r.colonOffset=N:S===","&&i(N))},onError:(S,N,C)=>{a.push({error:S,offset:N,length:C})}},n);const d=r.children[0];return d&&delete d.parent,d}function m(e,a){if(!e)return;let n=e;for(const r of a)if(typeof r=="string"){if(n.type!=="object"||!Array.isArray(n.children))return;let i=!1;for(const s of n.children)if(Array.isArray(s.children)&&s.children[0].value===r){n=s.children[1],i=!0;break}if(!i)return}else{const i=r;if(n.type!=="array"||i<0||!Array.isArray(n.children)||i>=n.children.length)return;n=n.children[i]}return n}function R(e){if(!e.parent||!e.parent.children)return[];const a=R(e.parent);if(e.parent.type==="property"){const n=e.parent.children[0].value;a.push(n)}else if(e.parent.type==="array"){const n=e.parent.children.indexOf(e);n!==-1&&a.push(n)}return a}function p(e){switch(e.type){case"array":return e.children.map(p);case"object":{const a=Object.create(null);for(const n of e.children){const r=n.children[1];r&&(a[n.children[0].value]=p(r))}return a}case"null":case"string":case"number":case"boolean":return e.value;default:return}}function f(e,a,n=!1){return a>=e.offset&&a<e.offset+e.length||n&&a===e.offset+e.length}function $(e,a,n=!1){if(f(e,a,n)){const r=e.children;if(Array.isArray(r))for(let i=0;i<r.length&&r[i].offset<=a;i++){const s=$(r[i],a,n);if(s)return s}return e}}function I(e,a,n=O.DEFAULT){const r=A(e,!1);function i(X){return X?()=>X(r.getTokenOffset(),r.getTokenLength()):()=>!0}function s(X){return X?ee=>X(ee,r.getTokenOffset(),r.getTokenLength()):()=>!0}const o=i(a.onObjectBegin),d=s(a.onObjectProperty),S=i(a.onObjectEnd),N=i(a.onArrayBegin),C=i(a.onArrayEnd),D=s(a.onLiteralValue),T=s(a.onSeparator),M=i(a.onComment),K=s(a.onError),Y=n&&n.disallowComments,ae=n&&n.allowTrailingComma;function le(){for(;;){const X=r.scan();switch(r.getTokenError()){case E.InvalidUnicode:ce(y.InvalidUnicode);break;case E.InvalidEscapeCharacter:ce(y.InvalidEscapeCharacter);break;case E.UnexpectedEndOfNumber:ce(y.UnexpectedEndOfNumber);break;case E.UnexpectedEndOfComment:Y||ce(y.UnexpectedEndOfComment);break;case E.UnexpectedEndOfString:ce(y.UnexpectedEndOfString);break;case E.InvalidCharacter:ce(y.InvalidCharacter);break}switch(X){case P.LineCommentTrivia:case P.BlockCommentTrivia:Y?ce(y.InvalidCommentToken):M();break;case P.Unknown:ce(y.InvalidSymbol);break;case P.Trivia:case P.LineBreakTrivia:break;default:return X}}}function ce(X,ee=[],j=[]){if(K(X),ee.length+j.length>0){let q=r.getToken();for(;q!==P.EOF;){if(ee.indexOf(q)!==-1){le();break}else if(j.indexOf(q)!==-1)break;q=le()}}}function de(X){const ee=r.getTokenValue();return X?D(ee):d(ee),le(),!0}function x(){switch(r.getToken()){case P.NumericLiteral:{let X=0;try{X=JSON.parse(r.getTokenValue()),typeof X!="number"&&(ce(y.InvalidNumberFormat),X=0)}catch{ce(y.InvalidNumberFormat)}D(X);break}case P.NullKeyword:D(null);break;case P.TrueKeyword:D(!0);break;case P.FalseKeyword:D(!1);break;default:return!1}return le(),!0}function _(){return r.getToken()!==P.StringLiteral?(ce(y.PropertyNameExpected,[],[P.CloseBraceToken,P.CommaToken]),!1):(de(!1),r.getToken()===P.ColonToken?(T(":"),le(),J()||ce(y.ValueExpected,[],[P.CloseBraceToken,P.CommaToken])):ce(y.ColonExpected,[],[P.CloseBraceToken,P.CommaToken]),!0)}function B(){o(),le();let X=!1;for(;r.getToken()!==P.CloseBraceToken&&r.getToken()!==P.EOF;){if(r.getToken()===P.CommaToken){if(X||ce(y.ValueExpected,[],[]),T(","),le(),r.getToken()===P.CloseBraceToken&&ae)break}else X&&ce(y.CommaExpected,[],[]);_()||ce(y.ValueExpected,[],[P.CloseBraceToken,P.CommaToken]),X=!0}return S(),r.getToken()!==P.CloseBraceToken?ce(y.CloseBraceExpected,[P.CloseBraceToken],[]):le(),!0}function U(){N(),le();let X=!1;for(;r.getToken()!==P.CloseBracketToken&&r.getToken()!==P.EOF;){if(r.getToken()===P.CommaToken){if(X||ce(y.ValueExpected,[],[]),T(","),le(),r.getToken()===P.CloseBracketToken&&ae)break}else X&&ce(y.CommaExpected,[],[]);J()||ce(y.ValueExpected,[],[P.CloseBracketToken,P.CommaToken]),X=!0}return C(),r.getToken()!==P.CloseBracketToken?ce(y.CloseBracketExpected,[P.CloseBracketToken],[]):le(),!0}function J(){switch(r.getToken()){case P.OpenBracketToken:return U();case P.OpenBraceToken:return B();case P.StringLiteral:return de(!0);default:return x()}}return le(),r.getToken()===P.EOF?n.allowEmptyContent?!0:(ce(y.ValueExpected,[],[]),!1):J()?(r.getToken()!==P.EOF&&ce(y.EndOfFileExpected,[],[]),!0):(ce(y.ValueExpected,[],[]),!1)}function v(e){switch(typeof e){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(e){if(Array.isArray(e))return"array"}else return"null";return"object"}default:return"null"}}}),define(re[76],oe([0,1,34]),function(H,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$5n=P,t.$6n=y,t.$7n=k,t.$8n=g;function P(c,l,u){let h,w,m,R,p;if(l){for(R=l.offset,p=R+l.length,m=R;m>0&&!g(c,m-1);)m--;let d=p;for(;d<c.length&&!g(c,d);)d++;w=c.substring(m,d),h=A(w,u)}else w=c,h=0,m=0,R=0,p=c.length;const f=k(u,c);let $=!1,I=0,v;u.insertSpaces?v=O(" ",u.tabSize||4):v="	";const e=(0,E.$Tn)(w,!1);let a=!1;function n(){return f+O(v,h+I)}function r(){let d=e.scan();for($=!1;d===E.SyntaxKind.Trivia||d===E.SyntaxKind.LineBreakTrivia;)$=$||d===E.SyntaxKind.LineBreakTrivia,d=e.scan();return a=d===E.SyntaxKind.Unknown||e.getTokenError()!==E.ScanError.None,d}const i=[];function s(d,S,N){!a&&S<p&&N>R&&c.substring(S,N)!==d&&i.push({offset:S,length:N-S,content:d})}let o=r();if(o!==E.SyntaxKind.EOF){const d=e.getTokenOffset()+m,S=O(v,h);s(S,m,d)}for(;o!==E.SyntaxKind.EOF;){let d=e.getTokenOffset()+e.getTokenLength()+m,S=r(),N="";for(;!$&&(S===E.SyntaxKind.LineCommentTrivia||S===E.SyntaxKind.BlockCommentTrivia);){const D=e.getTokenOffset()+m;s(" ",d,D),d=e.getTokenOffset()+e.getTokenLength()+m,N=S===E.SyntaxKind.LineCommentTrivia?n():"",S=r()}if(S===E.SyntaxKind.CloseBraceToken)o!==E.SyntaxKind.OpenBraceToken&&(I--,N=n());else if(S===E.SyntaxKind.CloseBracketToken)o!==E.SyntaxKind.OpenBracketToken&&(I--,N=n());else{switch(o){case E.SyntaxKind.OpenBracketToken:case E.SyntaxKind.OpenBraceToken:I++,N=n();break;case E.SyntaxKind.CommaToken:case E.SyntaxKind.LineCommentTrivia:N=n();break;case E.SyntaxKind.BlockCommentTrivia:$?N=n():N=" ";break;case E.SyntaxKind.ColonToken:N=" ";break;case E.SyntaxKind.StringLiteral:if(S===E.SyntaxKind.ColonToken){N="";break}case E.SyntaxKind.NullKeyword:case E.SyntaxKind.TrueKeyword:case E.SyntaxKind.FalseKeyword:case E.SyntaxKind.NumericLiteral:case E.SyntaxKind.CloseBraceToken:case E.SyntaxKind.CloseBracketToken:S===E.SyntaxKind.LineCommentTrivia||S===E.SyntaxKind.BlockCommentTrivia?N=" ":S!==E.SyntaxKind.CommaToken&&S!==E.SyntaxKind.EOF&&(a=!0);break;case E.SyntaxKind.Unknown:a=!0;break}$&&(S===E.SyntaxKind.LineCommentTrivia||S===E.SyntaxKind.BlockCommentTrivia)&&(N=n())}const C=e.getTokenOffset()+m;s(N,d,C),o=S}return i}function y(c,l){const u=JSON.stringify(c,void 0,l.insertSpaces?l.tabSize||4:"	");return l.eol!==void 0?u.replace(/\r\n|\r|\n/g,l.eol):u}function O(c,l){let u="";for(let h=0;h<l;h++)u+=c;return u}function A(c,l){let u=0,h=0;const w=l.tabSize||4;for(;u<c.length;){const m=c.charAt(u);if(m===" ")h++;else if(m==="	")h+=w;else break;u++}return Math.floor(h/w)}function k(c,l){for(let u=0;u<l.length;u++){const h=l.charAt(u);if(h==="\r")return u+1<l.length&&l.charAt(u+1)===`
`?`\r
`:"\r";if(h===`
`)return`
`}return c&&c.eol||`
`}function g(c,l){return`\r
`.indexOf(c.charAt(l))!==-1}}),define(re[77],oe([0,1,34,76]),function(H,t,E,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$9n=y,t.$0n=O,t.$$n=A,t.$_n=k,t.$ao=g;function y(c,l,u){return O(c,l,void 0,u)}function O(c,l,u,h,w){const m=l.slice(),R=[],p=(0,E.$Wn)(c,R);let f,$;for(;m.length>0&&($=m.pop(),f=(0,E.$Xn)(p,m),f===void 0&&u!==void 0);)typeof $=="string"?u={[$]:u}:u=[u];if(f)if(f.type==="object"&&typeof $=="string"&&Array.isArray(f.children)){const I=(0,E.$Xn)(f,[$]);if(I!==void 0)if(u===void 0){if(!I.parent)throw new Error("Malformed AST");const v=f.children.indexOf(I.parent);let e,a=I.parent.offset+I.parent.length;if(v>0){const n=f.children[v-1];e=n.offset+n.length}else e=f.offset+1,f.children.length>1&&(a=f.children[1].offset);return A(c,{offset:e,length:a-e,content:""},h)}else return A(c,{offset:I.offset,length:I.length,content:JSON.stringify(u)},h);else{if(u===void 0)return[];const v=`${JSON.stringify($)}: ${JSON.stringify(u)}`,e=w?w(f.children.map(n=>n.children[0].value)):f.children.length;let a;if(e>0){const n=f.children[e-1];a={offset:n.offset+n.length,length:0,content:","+v}}else f.children.length===0?a={offset:f.offset+1,length:0,content:v}:a={offset:f.offset+1,length:0,content:v+","};return A(c,a,h)}}else if(f.type==="array"&&typeof $=="number"&&Array.isArray(f.children))if(u!==void 0){const I=`${JSON.stringify(u)}`;let v;if(f.children.length===0||$===0)v={offset:f.offset+1,length:0,content:f.children.length===0?I:I+","};else{const e=$===-1||$>f.children.length?f.children.length:$,a=f.children[e-1];v={offset:a.offset+a.length,length:0,content:","+I}}return A(c,v,h)}else{const I=$,v=f.children[I];let e;if(f.children.length===1)e={offset:f.offset+1,length:f.length-2,content:""};else if(f.children.length-1===I){const a=f.children[I-1],n=a.offset+a.length,r=f.offset+f.length;e={offset:n,length:r-2-n,content:""}}else e={offset:v.offset,length:f.children[I+1].offset-v.offset,content:""};return A(c,e,h)}else throw new Error(`Can not add ${typeof $!="number"?"index":"property"} to parent of type ${f.type}`);else return u===void 0?[]:A(c,{offset:p?p.offset:0,length:p?p.length:0,content:JSON.stringify(u)},h)}function A(c,l,u){let h=k(c,l),w=l.offset,m=l.offset+l.content.length;if(l.length===0||l.content.length===0){for(;w>0&&!(0,P.$8n)(h,w-1);)w--;for(;m<h.length&&!(0,P.$8n)(h,m);)m++}const R=(0,P.$5n)(h,{offset:w,length:m-w},u);for(let f=R.length-1;f>=0;f--){const $=R[f];h=k(h,$),w=Math.min(w,$.offset),m=Math.max(m,$.offset+$.length),m+=$.content.length-$.length}const p=c.length-(h.length-m)-w;return[{offset:w,length:p,content:h.substring(w,m)}]}function k(c,l){return c.substring(0,l.offset)+l.content+c.substring(l.offset+l.length)}function g(c,l){const u=l.slice(0).sort((w,m)=>{const R=w.offset-m.offset;return R===0?w.length-m.length:R});let h=c.length;for(let w=u.length-1;w>=0;w--){const m=u[w];if(m.offset+m.length<=h)c=k(c,m);else throw new Error("Overlapping edit");h=m.offset}return c}}),define(re[78],oe([0,1]),function(H,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Om=t.$Nm=t.$Mm=void 0,t.$Km=E,t.rot=P,t.$Pm=k;function E(g,c,l){return Math.min(Math.max(g,c),l)}function P(g,c){return(c+g%c)%c}class y{constructor(){this.a=0}getNext(){return this.a++}}t.$Mm=y;class O{constructor(){this.a=1,this.b=0}update(c){return this.b=this.b+(c-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}t.$Nm=O;class A{constructor(c){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(c),this.c.fill(0,0,c)}update(c){const l=this.c[this.d];return this.c[this.d]=c,this.d=(this.d+1)%this.c.length,this.e-=l,this.e+=c,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}t.$Om=A;function k(g,c,l,u,h,w,m,R){const p=m-l,f=R-u,$=h-l,I=w-u,v=g-l,e=c-u,a=p*p+f*f,n=p*$+f*I,r=p*v+f*e,i=$*$+I*I,s=$*v+I*e,o=1/(a*i-n*n),d=(i*r-n*s)*o,S=(a*s-n*r)*o;return d>=0&&S>=0&&d+S<1}}),function(){function H(y){const O=[];typeof y=="number"&&O.push("code/timeOrigin",y);function A(g){O.push(g,Date.now())}function k(){const g=[];for(let c=0;c<O.length;c+=2)g.push({name:O[c],startTime:O[c+1]});return g}return{mark:A,getMarks:k}}function t(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?H():{mark(y){performance.mark(y)},getMarks(){let y=performance.timeOrigin;typeof y!="number"&&(y=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const O=[{name:"code/timeOrigin",startTime:Math.round(y)}];for(const A of performance.getEntriesByType("mark"))O.push({name:A.name,startTime:Math.round(y+A.startTime)});return O}};if(typeof process=="object"){const y=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return H(y)}else return console.trace("perf-util loaded in UNKNOWN environment"),H()}function E(y){return y.MonacoPerformanceMarks||(y.MonacoPerformanceMarks=t()),y.MonacoPerformanceMarks}var P;typeof global=="object"?P=global:typeof self=="object"?P=self:P={},typeof define=="function"?define("vs/base/common/performance",[],function(){return E(P)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=E(P):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),P.perf=E(P))}(),function(H,t){if(typeof exports=="object"&&typeof module=="object")module.exports=t();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],t);else{var E=t();for(var P in E)(typeof exports=="object"?exports:H)[P]=E[P]}}(typeof self<"u"?self:this,function(){return function(H){var t={};function E(P){if(t[P])return t[P].exports;var y=t[P]={i:P,l:!1,exports:{}};return H[P].call(y.exports,y,y.exports,E),y.l=!0,y.exports}return E.m=H,E.c=t,E.d=function(P,y,O){E.o(P,y)||Object.defineProperty(P,y,{enumerable:!0,get:O})},E.r=function(P){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(P,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(P,"__esModule",{value:!0})},E.t=function(P,y){if(1&y&&(P=E(P)),8&y||4&y&&typeof P=="object"&&P&&P.__esModule)return P;var O=Object.create(null);if(E.r(O),Object.defineProperty(O,"default",{enumerable:!0,value:P}),2&y&&typeof P!="string")for(var A in P)E.d(O,A,function(k){return P[k]}.bind(null,A));return O},E.n=function(P){var y=P&&P.__esModule?function(){return P.default}:function(){return P};return E.d(y,"a",y),y},E.o=function(P,y){return Object.prototype.hasOwnProperty.call(P,y)},E.p="",E(E.s=0)}([function(H,t,E){(function(P){var y;t=H.exports=q,y=typeof P=="object"&&P.env&&P.env.NODE_DEBUG&&/\bsemver\b/i.test(P.env.NODE_DEBUG)?function(){var W=Array.prototype.slice.call(arguments,0);W.unshift("SEMVER"),console.log.apply(console,W)}:function(){},t.SEMVER_SPEC_VERSION="2.0.0";var O=256,A=Number.MAX_SAFE_INTEGER||9007199254740991,k=t.re=[],g=t.src=[],c=0,l=c++;g[l]="0|[1-9]\\d*";var u=c++;g[u]="[0-9]+";var h=c++;g[h]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var w=c++;g[w]="("+g[l]+")\\.("+g[l]+")\\.("+g[l]+")";var m=c++;g[m]="("+g[u]+")\\.("+g[u]+")\\.("+g[u]+")";var R=c++;g[R]="(?:"+g[l]+"|"+g[h]+")";var p=c++;g[p]="(?:"+g[u]+"|"+g[h]+")";var f=c++;g[f]="(?:-("+g[R]+"(?:\\."+g[R]+")*))";var $=c++;g[$]="(?:-?("+g[p]+"(?:\\."+g[p]+")*))";var I=c++;g[I]="[0-9A-Za-z-]+";var v=c++;g[v]="(?:\\+("+g[I]+"(?:\\."+g[I]+")*))";var e=c++,a="v?"+g[w]+g[f]+"?"+g[v]+"?";g[e]="^"+a+"$";var n="[v=\\s]*"+g[m]+g[$]+"?"+g[v]+"?",r=c++;g[r]="^"+n+"$";var i=c++;g[i]="((?:<|>)?=?)";var s=c++;g[s]=g[u]+"|x|X|\\*";var o=c++;g[o]=g[l]+"|x|X|\\*";var d=c++;g[d]="[v=\\s]*("+g[o]+")(?:\\.("+g[o]+")(?:\\.("+g[o]+")(?:"+g[f]+")?"+g[v]+"?)?)?";var S=c++;g[S]="[v=\\s]*("+g[s]+")(?:\\.("+g[s]+")(?:\\.("+g[s]+")(?:"+g[$]+")?"+g[v]+"?)?)?";var N=c++;g[N]="^"+g[i]+"\\s*"+g[d]+"$";var C=c++;g[C]="^"+g[i]+"\\s*"+g[S]+"$";var D=c++;g[D]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var T=c++;g[T]="(?:~>?)";var M=c++;g[M]="(\\s*)"+g[T]+"\\s+",k[M]=new RegExp(g[M],"g");var K=c++;g[K]="^"+g[T]+g[d]+"$";var Y=c++;g[Y]="^"+g[T]+g[S]+"$";var ae=c++;g[ae]="(?:\\^)";var le=c++;g[le]="(\\s*)"+g[ae]+"\\s+",k[le]=new RegExp(g[le],"g");var ce=c++;g[ce]="^"+g[ae]+g[d]+"$";var de=c++;g[de]="^"+g[ae]+g[S]+"$";var x=c++;g[x]="^"+g[i]+"\\s*("+n+")$|^$";var _=c++;g[_]="^"+g[i]+"\\s*("+a+")$|^$";var B=c++;g[B]="(\\s*)"+g[i]+"\\s*("+n+"|"+g[d]+")",k[B]=new RegExp(g[B],"g");var U=c++;g[U]="^\\s*("+g[d]+")\\s+-\\s+("+g[d]+")\\s*$";var J=c++;g[J]="^\\s*("+g[S]+")\\s+-\\s+("+g[S]+")\\s*$";var X=c++;g[X]="(<|>)?=?\\s*\\*";for(var ee=0;ee<35;ee++)y(ee,g[ee]),k[ee]||(k[ee]=new RegExp(g[ee]));function j(W,te){if(W instanceof q)return W;if(typeof W!="string"||W.length>O||!(te?k[r]:k[e]).test(W))return null;try{return new q(W,te)}catch{return null}}function q(W,te){if(W instanceof q){if(W.loose===te)return W;W=W.version}else if(typeof W!="string")throw new TypeError("Invalid Version: "+W);if(W.length>O)throw new TypeError("version is longer than "+O+" characters");if(!(this instanceof q))return new q(W,te);y("SemVer",W,te),this.loose=te;var ie=W.trim().match(te?k[r]:k[e]);if(!ie)throw new TypeError("Invalid Version: "+W);if(this.raw=W,this.major=+ie[1],this.minor=+ie[2],this.patch=+ie[3],this.major>A||this.major<0)throw new TypeError("Invalid major version");if(this.minor>A||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>A||this.patch<0)throw new TypeError("Invalid patch version");ie[4]?this.prerelease=ie[4].split(".").map(function(me){if(/^[0-9]+$/.test(me)){var be=+me;if(be>=0&&be<A)return be}return me}):this.prerelease=[],this.build=ie[5]?ie[5].split("."):[],this.format()}t.parse=j,t.valid=function(W,te){var ie=j(W,te);return ie?ie.version:null},t.clean=function(W,te){var ie=j(W.trim().replace(/^[=v]+/,""),te);return ie?ie.version:null},t.SemVer=q,q.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},q.prototype.toString=function(){return this.version},q.prototype.compare=function(W){return y("SemVer.compare",this.version,this.loose,W),W instanceof q||(W=new q(W,this.loose)),this.compareMain(W)||this.comparePre(W)},q.prototype.compareMain=function(W){return W instanceof q||(W=new q(W,this.loose)),V(this.major,W.major)||V(this.minor,W.minor)||V(this.patch,W.patch)},q.prototype.comparePre=function(W){if(W instanceof q||(W=new q(W,this.loose)),this.prerelease.length&&!W.prerelease.length)return-1;if(!this.prerelease.length&&W.prerelease.length)return 1;if(!this.prerelease.length&&!W.prerelease.length)return 0;var te=0;do{var ie=this.prerelease[te],me=W.prerelease[te];if(y("prerelease compare",te,ie,me),ie===void 0&&me===void 0)return 0;if(me===void 0)return 1;if(ie===void 0)return-1;if(ie!==me)return V(ie,me)}while(++te)},q.prototype.inc=function(W,te){switch(W){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",te);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",te);break;case"prepatch":this.prerelease.length=0,this.inc("patch",te),this.inc("pre",te);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",te),this.inc("pre",te);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ie=this.prerelease.length;--ie>=0;)typeof this.prerelease[ie]=="number"&&(this.prerelease[ie]++,ie=-2);ie===-1&&this.prerelease.push(0)}te&&(this.prerelease[0]===te?isNaN(this.prerelease[1])&&(this.prerelease=[te,0]):this.prerelease=[te,0]);break;default:throw new Error("invalid increment argument: "+W)}return this.format(),this.raw=this.version,this},t.inc=function(W,te,ie,me){typeof ie=="string"&&(me=ie,ie=void 0);try{return new q(W,ie).inc(te,me).version}catch{return null}},t.diff=function(W,te){if(z(W,te))return null;var ie=j(W),me=j(te);if(ie.prerelease.length||me.prerelease.length){for(var be in ie)if((be==="major"||be==="minor"||be==="patch")&&ie[be]!==me[be])return"pre"+be;return"prerelease"}for(var be in ie)if((be==="major"||be==="minor"||be==="patch")&&ie[be]!==me[be])return be},t.compareIdentifiers=V;var G=/^[0-9]+$/;function V(W,te){var ie=G.test(W),me=G.test(te);return ie&&me&&(W=+W,te=+te),ie&&!me?-1:me&&!ie?1:W<te?-1:W>te?1:0}function b(W,te,ie){return new q(W,ie).compare(new q(te,ie))}function L(W,te,ie){return b(W,te,ie)>0}function F(W,te,ie){return b(W,te,ie)<0}function z(W,te,ie){return b(W,te,ie)===0}function Z(W,te,ie){return b(W,te,ie)!==0}function Q(W,te,ie){return b(W,te,ie)>=0}function se(W,te,ie){return b(W,te,ie)<=0}function he(W,te,ie,me){var be;switch(te){case"===":typeof W=="object"&&(W=W.version),typeof ie=="object"&&(ie=ie.version),be=W===ie;break;case"!==":typeof W=="object"&&(W=W.version),typeof ie=="object"&&(ie=ie.version),be=W!==ie;break;case"":case"=":case"==":be=z(W,ie,me);break;case"!=":be=Z(W,ie,me);break;case">":be=L(W,ie,me);break;case">=":be=Q(W,ie,me);break;case"<":be=F(W,ie,me);break;case"<=":be=se(W,ie,me);break;default:throw new TypeError("Invalid operator: "+te)}return be}function ue(W,te){if(W instanceof ue){if(W.loose===te)return W;W=W.value}if(!(this instanceof ue))return new ue(W,te);y("comparator",W,te),this.loose=te,this.parse(W),this.semver===Ee?this.value="":this.value=this.operator+this.semver.version,y("comp",this)}t.rcompareIdentifiers=function(W,te){return V(te,W)},t.major=function(W,te){return new q(W,te).major},t.minor=function(W,te){return new q(W,te).minor},t.patch=function(W,te){return new q(W,te).patch},t.compare=b,t.compareLoose=function(W,te){return b(W,te,!0)},t.rcompare=function(W,te,ie){return b(te,W,ie)},t.sort=function(W,te){return W.sort(function(ie,me){return t.compare(ie,me,te)})},t.rsort=function(W,te){return W.sort(function(ie,me){return t.rcompare(ie,me,te)})},t.gt=L,t.lt=F,t.eq=z,t.neq=Z,t.gte=Q,t.lte=se,t.cmp=he,t.Comparator=ue;var Ee={};function pe(W,te){if(W instanceof pe)return W.loose===te?W:new pe(W.raw,te);if(W instanceof ue)return new pe(W.value,te);if(!(this instanceof pe))return new pe(W,te);if(this.loose=te,this.raw=W,this.set=W.split(/\s*\|\|\s*/).map(function(ie){return this.parseRange(ie.trim())},this).filter(function(ie){return ie.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+W);this.format()}function ge(W){return!W||W.toLowerCase()==="x"||W==="*"}function fe(W,te,ie,me,be,Ae,Ie,Ce,Re,Le,ze,De,Te){return((te=ge(ie)?"":ge(me)?">="+ie+".0.0":ge(be)?">="+ie+"."+me+".0":">="+te)+" "+(Ce=ge(Re)?"":ge(Le)?"<"+(+Re+1)+".0.0":ge(ze)?"<"+Re+"."+(+Le+1)+".0":De?"<="+Re+"."+Le+"."+ze+"-"+De:"<="+Ce)).trim()}function $e(W,te){for(var ie=0;ie<W.length;ie++)if(!W[ie].test(te))return!1;if(te.prerelease.length){for(ie=0;ie<W.length;ie++)if(y(W[ie].semver),W[ie].semver!==Ee&&W[ie].semver.prerelease.length>0){var me=W[ie].semver;if(me.major===te.major&&me.minor===te.minor&&me.patch===te.patch)return!0}return!1}return!0}function ve(W,te,ie){try{te=new pe(te,ie)}catch{return!1}return te.test(W)}function ke(W,te,ie,me){var be,Ae,Ie,Ce,Re;switch(W=new q(W,me),te=new pe(te,me),ie){case">":be=L,Ae=se,Ie=F,Ce=">",Re=">=";break;case"<":be=F,Ae=Q,Ie=L,Ce="<",Re="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(ve(W,te,me))return!1;for(var Le=0;Le<te.set.length;++Le){var ze=te.set[Le],De=null,Te=null;if(ze.forEach(function(Fe){Fe.semver===Ee&&(Fe=new ue(">=0.0.0")),De=De||Fe,Te=Te||Fe,be(Fe.semver,De.semver,me)?De=Fe:Ie(Fe.semver,Te.semver,me)&&(Te=Fe)}),De.operator===Ce||De.operator===Re||(!Te.operator||Te.operator===Ce)&&Ae(W,Te.semver)||Te.operator===Re&&Ie(W,Te.semver))return!1}return!0}ue.prototype.parse=function(W){var te=this.loose?k[x]:k[_],ie=W.match(te);if(!ie)throw new TypeError("Invalid comparator: "+W);this.operator=ie[1],this.operator==="="&&(this.operator=""),ie[2]?this.semver=new q(ie[2],this.loose):this.semver=Ee},ue.prototype.toString=function(){return this.value},ue.prototype.test=function(W){return y("Comparator.test",W,this.loose),this.semver===Ee||(typeof W=="string"&&(W=new q(W,this.loose)),he(W,this.operator,this.semver,this.loose))},ue.prototype.intersects=function(W,te){if(!(W instanceof ue))throw new TypeError("a Comparator is required");var ie;if(this.operator==="")return ie=new pe(W.value,te),ve(this.value,ie,te);if(W.operator==="")return ie=new pe(this.value,te),ve(W.semver,ie,te);var me=!(this.operator!==">="&&this.operator!==">"||W.operator!==">="&&W.operator!==">"),be=!(this.operator!=="<="&&this.operator!=="<"||W.operator!=="<="&&W.operator!=="<"),Ae=this.semver.version===W.semver.version,Ie=!(this.operator!==">="&&this.operator!=="<="||W.operator!==">="&&W.operator!=="<="),Ce=he(this.semver,"<",W.semver,te)&&(this.operator===">="||this.operator===">")&&(W.operator==="<="||W.operator==="<"),Re=he(this.semver,">",W.semver,te)&&(this.operator==="<="||this.operator==="<")&&(W.operator===">="||W.operator===">");return me||be||Ae&&Ie||Ce||Re},t.Range=pe,pe.prototype.format=function(){return this.range=this.set.map(function(W){return W.join(" ").trim()}).join("||").trim(),this.range},pe.prototype.toString=function(){return this.range},pe.prototype.parseRange=function(W){var te=this.loose;W=W.trim(),y("range",W,te);var ie=te?k[J]:k[U];W=W.replace(ie,fe),y("hyphen replace",W),W=W.replace(k[B],"$1$2$3"),y("comparator trim",W,k[B]),W=(W=(W=W.replace(k[M],"$1~")).replace(k[le],"$1^")).split(/\s+/).join(" ");var me=te?k[x]:k[_],be=W.split(" ").map(function(Ae){return function(Ie,Ce){return y("comp",Ie),Ie=function(Re,Le){return Re.trim().split(/\s+/).map(function(ze){return function(De,Te){y("caret",De,Te);var Fe=Te?k[de]:k[ce];return De.replace(Fe,function(Ue,Se,Pe,Oe,Ne){var je;return y("caret",De,Ue,Se,Pe,Oe,Ne),ge(Se)?je="":ge(Pe)?je=">="+Se+".0.0 <"+(+Se+1)+".0.0":ge(Oe)?je=Se==="0"?">="+Se+"."+Pe+".0 <"+Se+"."+(+Pe+1)+".0":">="+Se+"."+Pe+".0 <"+(+Se+1)+".0.0":Ne?(y("replaceCaret pr",Ne),Ne.charAt(0)!=="-"&&(Ne="-"+Ne),je=Se==="0"?Pe==="0"?">="+Se+"."+Pe+"."+Oe+Ne+" <"+Se+"."+Pe+"."+(+Oe+1):">="+Se+"."+Pe+"."+Oe+Ne+" <"+Se+"."+(+Pe+1)+".0":">="+Se+"."+Pe+"."+Oe+Ne+" <"+(+Se+1)+".0.0"):(y("no pr"),je=Se==="0"?Pe==="0"?">="+Se+"."+Pe+"."+Oe+" <"+Se+"."+Pe+"."+(+Oe+1):">="+Se+"."+Pe+"."+Oe+" <"+Se+"."+(+Pe+1)+".0":">="+Se+"."+Pe+"."+Oe+" <"+(+Se+1)+".0.0"),y("caret return",je),je})}(ze,Le)}).join(" ")}(Ie,Ce),y("caret",Ie),Ie=function(Re,Le){return Re.trim().split(/\s+/).map(function(ze){return function(De,Te){var Fe=Te?k[Y]:k[K];return De.replace(Fe,function(Ue,Se,Pe,Oe,Ne){var je;return y("tilde",De,Ue,Se,Pe,Oe,Ne),ge(Se)?je="":ge(Pe)?je=">="+Se+".0.0 <"+(+Se+1)+".0.0":ge(Oe)?je=">="+Se+"."+Pe+".0 <"+Se+"."+(+Pe+1)+".0":Ne?(y("replaceTilde pr",Ne),Ne.charAt(0)!=="-"&&(Ne="-"+Ne),je=">="+Se+"."+Pe+"."+Oe+Ne+" <"+Se+"."+(+Pe+1)+".0"):je=">="+Se+"."+Pe+"."+Oe+" <"+Se+"."+(+Pe+1)+".0",y("tilde return",je),je})}(ze,Le)}).join(" ")}(Ie,Ce),y("tildes",Ie),Ie=function(Re,Le){return y("replaceXRanges",Re,Le),Re.split(/\s+/).map(function(ze){return function(De,Te){De=De.trim();var Fe=Te?k[C]:k[N];return De.replace(Fe,function(Ue,Se,Pe,Oe,Ne,je){y("xRange",De,Ue,Se,Pe,Oe,Ne,je);var Ve=ge(Pe),Me=Ve||ge(Oe),Be=Me||ge(Ne);return Se==="="&&Be&&(Se=""),Ve?Ue=Se===">"||Se==="<"?"<0.0.0":"*":Se&&Be?(Me&&(Oe=0),Be&&(Ne=0),Se===">"?(Se=">=",Me?(Pe=+Pe+1,Oe=0,Ne=0):Be&&(Oe=+Oe+1,Ne=0)):Se==="<="&&(Se="<",Me?Pe=+Pe+1:Oe=+Oe+1),Ue=Se+Pe+"."+Oe+"."+Ne):Me?Ue=">="+Pe+".0.0 <"+(+Pe+1)+".0.0":Be&&(Ue=">="+Pe+"."+Oe+".0 <"+Pe+"."+(+Oe+1)+".0"),y("xRange return",Ue),Ue})}(ze,Le)}).join(" ")}(Ie,Ce),y("xrange",Ie),Ie=function(Re,Le){return y("replaceStars",Re,Le),Re.trim().replace(k[X],"")}(Ie,Ce),y("stars",Ie),Ie}(Ae,te)}).join(" ").split(/\s+/);return this.loose&&(be=be.filter(function(Ae){return!!Ae.match(me)})),be=be.map(function(Ae){return new ue(Ae,te)})},pe.prototype.intersects=function(W,te){if(!(W instanceof pe))throw new TypeError("a Range is required");return this.set.some(function(ie){return ie.every(function(me){return W.set.some(function(be){return be.every(function(Ae){return me.intersects(Ae,te)})})})})},t.toComparators=function(W,te){return new pe(W,te).set.map(function(ie){return ie.map(function(me){return me.value}).join(" ").trim().split(" ")})},pe.prototype.test=function(W){if(!W)return!1;typeof W=="string"&&(W=new q(W,this.loose));for(var te=0;te<this.set.length;te++)if($e(this.set[te],W))return!0;return!1},t.satisfies=ve,t.maxSatisfying=function(W,te,ie){var me=null,be=null;try{var Ae=new pe(te,ie)}catch{return null}return W.forEach(function(Ie){Ae.test(Ie)&&(me&&be.compare(Ie)!==-1||(be=new q(me=Ie,ie)))}),me},t.minSatisfying=function(W,te,ie){var me=null,be=null;try{var Ae=new pe(te,ie)}catch{return null}return W.forEach(function(Ie){Ae.test(Ie)&&(me&&be.compare(Ie)!==1||(be=new q(me=Ie,ie)))}),me},t.validRange=function(W,te){try{return new pe(W,te).range||"*"}catch{return null}},t.ltr=function(W,te,ie){return ke(W,te,"<",ie)},t.gtr=function(W,te,ie){return ke(W,te,">",ie)},t.outside=ke,t.prerelease=function(W,te){var ie=j(W,te);return ie&&ie.prerelease.length?ie.prerelease:null},t.intersects=function(W,te,ie){return W=new pe(W,ie),te=new pe(te,ie),W.intersects(te)},t.coerce=function(W){if(W instanceof q)return W;if(typeof W!="string")return null;var te=W.match(k[D]);return te==null?null:j((te[1]||"0")+"."+(te[2]||"0")+"."+(te[3]||"0"))}}).call(this,E(1))},function(H,t){var E,P,y=H.exports={};function O(){throw new Error("setTimeout has not been defined")}function A(){throw new Error("clearTimeout has not been defined")}function k(p){if(E===setTimeout)return setTimeout(p,0);if((E===O||!E)&&setTimeout)return E=setTimeout,setTimeout(p,0);try{return E(p,0)}catch{try{return E.call(null,p,0)}catch{return E.call(this,p,0)}}}(function(){try{E=typeof setTimeout=="function"?setTimeout:O}catch{E=O}try{P=typeof clearTimeout=="function"?clearTimeout:A}catch{P=A}})();var g,c=[],l=!1,u=-1;function h(){l&&g&&(l=!1,g.length?c=g.concat(c):u=-1,c.length&&w())}function w(){if(!l){var p=k(h);l=!0;for(var f=c.length;f;){for(g=c,c=[];++u<f;)g&&g[u].run();u=-1,f=c.length}g=null,l=!1,function($){if(P===clearTimeout)return clearTimeout($);if((P===A||!P)&&clearTimeout)return P=clearTimeout,clearTimeout($);try{P($)}catch{try{return P.call(null,$)}catch{return P.call(this,$)}}}(p)}}function m(p,f){this.fun=p,this.array=f}function R(){}y.nextTick=function(p){var f=new Array(arguments.length-1);if(arguments.length>1)for(var $=1;$<arguments.length;$++)f[$-1]=arguments[$];c.push(new m(p,f)),c.length!==1||l||k(w)},m.prototype.run=function(){this.fun.apply(null,this.array)},y.title="browser",y.browser=!0,y.env={},y.argv=[],y.version="",y.versions={},y.on=R,y.addListener=R,y.once=R,y.off=R,y.removeListener=R,y.removeAllListeners=R,y.emit=R,y.prependListener=R,y.prependOnceListener=R,y.listeners=function(p){return[]},y.binding=function(p){throw new Error("process.binding is not supported")},y.cwd=function(){return"/"},y.chdir=function(p){throw new Error("process.chdir is not supported")},y.umask=function(){return 0}}])}),define(re[79],oe([0,1]),function(H,t){"use strict";var E;Object.defineProperty(t,"__esModule",{value:!0}),t.$Ms=void 0;class P{constructor(k,g,c){this.level=k,this.key=g,this.value=c,this.forward=[]}}const y=void 0;class O{constructor(k,g=2**16){this.comparator=k,this[E]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(g)|0),this.e=new P(this.c,y,y)}get size(){return this.f}clear(){this.e=new P(this.c,y,y),this.f=0}has(k){return!!O.g(this,k,this.comparator)}get(k){return O.g(this,k,this.comparator)?.value}set(k,g){return O.h(this,k,g,this.comparator)&&(this.f+=1),this}delete(k){const g=O.k(this,k,this.comparator);return g&&(this.f-=1),g}forEach(k,g){let c=this.e.forward[0];for(;c;)k.call(g,c.value,c.key,this),c=c.forward[0]}[(E=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let k=this.e.forward[0];for(;k;)yield[k.key,k.value],k=k.forward[0]}*keys(){let k=this.e.forward[0];for(;k;)yield k.key,k=k.forward[0]}*values(){let k=this.e.forward[0];for(;k;)yield k.value,k=k.forward[0]}toString(){let k="[SkipList]:",g=this.e.forward[0];for(;g;)k+=`node(${g.key}, ${g.value}, lvl:${g.level})`,g=g.forward[0];return k}static g(k,g,c){let l=k.e;for(let u=k.d-1;u>=0;u--)for(;l.forward[u]&&c(l.forward[u].key,g)<0;)l=l.forward[u];if(l=l.forward[0],l&&c(l.key,g)===0)return l}static h(k,g,c,l){const u=[];let h=k.e;for(let w=k.d-1;w>=0;w--){for(;h.forward[w]&&l(h.forward[w].key,g)<0;)h=h.forward[w];u[w]=h}if(h=h.forward[0],h&&l(h.key,g)===0)return h.value=c,!1;{const w=O.j(k);if(w>k.d){for(let m=k.d;m<w;m++)u[m]=k.e;k.d=w}h=new P(w,g,c);for(let m=0;m<w;m++)h.forward[m]=u[m].forward[m],u[m].forward[m]=h;return!0}}static j(k,g=.5){let c=1;for(;Math.random()<g&&c<k.c;)c+=1;return c}static k(k,g,c){const l=[];let u=k.e;for(let h=k.d-1;h>=0;h--){for(;u.forward[h]&&c(u.forward[h].key,g)<0;)u=u.forward[h];l[h]=u}if(u=u.forward[0],!u||c(u.key,g)!==0)return!1;for(let h=0;h<k.d&&l[h].forward[h]===u;h++)l[h].forward[h]=u.forward[h];for(;k.d>0&&k.e.forward[k.d-1]===y;)k.d-=1;return!0}}t.$Ms=O}),define(re[46],oe([0,1,9,2]),function(H,t,E,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ze=y,t.$Ae=O,t.$Be=A,t.$Ce=k,t.$De=c,t.$Ee=l,t.$Fe=u,t.$Ge=h,t.$He=w,t.$Ie=m,t.$Je=R,t.$Ke=p,t.$Le=f,t.$Me=$,t.$Ne=I;function y(v){const e=v;return e?typeof e.read=="function":!1}function O(v){const e=v;return e?[e.on,e.pause,e.resume,e.destroy].every(a=>typeof a=="function"):!1}function A(v){const e=v;return e?O(e.stream)&&Array.isArray(e.buffer)&&typeof e.ended=="boolean":!1}function k(v,e){return new g(v,e)}class g{constructor(e,a){this.e=e,this.f=a,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(e){if(!this.a.destroyed){if(this.a.flowing)this.g(e);else if(this.b.data.push(e),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(a=>this.d.push(a))}}error(e){this.a.destroyed||(this.a.flowing?this.h(e):this.b.error.push(e))}end(e){this.a.destroyed||(typeof e<"u"&&this.write(e),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(e){this.c.data.slice(0).forEach(a=>a(e))}h(e){this.c.error.length===0?(0,E.$3)(e):this.c.error.slice(0).forEach(a=>a(e))}i(){this.c.end.slice(0).forEach(e=>e())}on(e,a){if(!this.a.destroyed)switch(e){case"data":this.c.data.push(a),this.resume();break;case"end":this.c.end.push(a),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(a),this.a.flowing&&this.k();break}}removeListener(e,a){if(this.a.destroyed)return;let n;switch(e){case"data":n=this.c.data;break;case"end":n=this.c.end;break;case"error":n=this.c.error;break}if(n){const r=n.indexOf(a);r>=0&&n.splice(r,1)}}j(){if(this.b.data.length>0){const e=this.e(this.b.data);this.g(e),this.b.data.length=0;const a=[...this.d];this.d.length=0,a.forEach(n=>n())}}k(){if(this.c.error.length>0){for(const e of this.b.error)this.h(e);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function c(v,e){const a=[];let n;for(;(n=v.read())!==null;)a.push(n);return e(a)}function l(v,e,a){const n=[];let r;for(;(r=v.read())!==null&&n.length<a;)n.push(r);return r===null&&n.length>0?e(n):{read:()=>{if(n.length>0)return n.shift();if(typeof r<"u"){const i=r;return r=void 0,i}return v.read()}}}function u(v,e){return new Promise((a,n)=>{const r=[];h(v,{onData:i=>{e&&r.push(i)},onError:i=>{e?n(i):a(void 0)},onEnd:()=>{a(e?e(r):void 0)}})})}function h(v,e,a){v.on("error",n=>{a?.isCancellationRequested||e.onError(n)}),v.on("end",()=>{a?.isCancellationRequested||e.onEnd()}),v.on("data",n=>{a?.isCancellationRequested||e.onData(n)})}function w(v,e){return new Promise((a,n)=>{const r=new P.$Vc,i=[],s=S=>{if(i.push(S),i.length>e)return r.dispose(),v.pause(),a({stream:v,buffer:i,ended:!1})},o=S=>(r.dispose(),n(S)),d=()=>(r.dispose(),a({stream:v,buffer:i,ended:!0}));r.add((0,P.$Uc)(()=>v.removeListener("error",o))),v.on("error",o),r.add((0,P.$Uc)(()=>v.removeListener("end",d))),v.on("end",d),r.add((0,P.$Uc)(()=>v.removeListener("data",s))),v.on("data",s)})}function m(v,e){const a=k(e);return a.end(v),a}function R(){const v=k(()=>{throw new Error("not supported")});return v.end(),v}function p(v){let e=!1;return{read:()=>e?null:(e=!0,v)}}function f(v,e,a){const n=k(a);return h(v,{onData:r=>n.write(e.data(r)),onError:r=>n.error(e.error?e.error(r):r),onEnd:()=>n.end()}),n}function $(v,e,a){let n=!1;return{read:()=>{const r=e.read();return n?r:(n=!0,r!==null?a([v,r]):v)}}}function I(v,e,a){let n=!1;const r=k(a);return h(e,{onData:i=>n?r.write(i):(n=!0,r.write(a([v,i]))),onError:i=>r.error(i),onEnd:()=>{n||(n=!0,r.write(v)),r.end()}}),r}});var We=this&&this.__createBinding||(Object.create?function(H,t,E,P){P===void 0&&(P=E);var y=Object.getOwnPropertyDescriptor(t,E);(!y||("get"in y?!t.__esModule:y.writable||y.configurable))&&(y={enumerable:!0,get:function(){return t[E]}}),Object.defineProperty(H,P,y)}:function(H,t,E,P){P===void 0&&(P=E),H[P]=t[E]}),He=this&&this.__setModuleDefault||(Object.create?function(H,t){Object.defineProperty(H,"default",{enumerable:!0,value:t})}:function(H,t){H.default=t}),ye=this&&this.__importStar||function(H){if(H&&H.__esModule)return H;var t={};if(H!=null)for(var E in H)E!=="default"&&Object.prototype.hasOwnProperty.call(H,E)&&We(t,H,E);return He(t,H),t};define(re[14],oe([0,1,170,46]),function(H,t,E,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Oe=void 0,t.$Pe=c,t.$Qe=l,t.$Re=u,t.$Se=h,t.$Te=w,t.$Ue=m,t.$Ve=R,t.$We=p,t.$Xe=f,t.$Ye=$,t.$Ze=I,t.$1e=v,t.$2e=e,t.$3e=a,t.$4e=n,t.$5e=r,t.$6e=i,t.$7e=s,t.$8e=o,t.$9e=N,P=ye(P);const y=typeof Buffer<"u",O=new E.$X(()=>new Uint8Array(256));let A,k;class g{static alloc(D){return y?new g(Buffer.allocUnsafe(D)):new g(new Uint8Array(D))}static wrap(D){return y&&!Buffer.isBuffer(D)&&(D=Buffer.from(D.buffer,D.byteOffset,D.byteLength)),new g(D)}static fromString(D,T){return!(T?.dontUseNodeBuffer||!1)&&y?new g(Buffer.from(D)):(A||(A=new TextEncoder),new g(A.encode(D)))}static fromByteArray(D){const T=g.alloc(D.length);for(let M=0,K=D.length;M<K;M++)T.buffer[M]=D[M];return T}static concat(D,T){if(typeof T>"u"){T=0;for(let Y=0,ae=D.length;Y<ae;Y++)T+=D[Y].byteLength}const M=g.alloc(T);let K=0;for(let Y=0,ae=D.length;Y<ae;Y++){const le=D[Y];M.set(le,K),K+=le.byteLength}return M}constructor(D){this.buffer=D,this.byteLength=this.buffer.byteLength}clone(){const D=g.alloc(this.byteLength);return D.set(this),D}toString(){return y?this.buffer.toString():(k||(k=new TextDecoder),k.decode(this.buffer))}slice(D,T){return new g(this.buffer.subarray(D,T))}set(D,T){if(D instanceof g)this.buffer.set(D.buffer,T);else if(D instanceof Uint8Array)this.buffer.set(D,T);else if(D instanceof ArrayBuffer)this.buffer.set(new Uint8Array(D),T);else if(ArrayBuffer.isView(D))this.buffer.set(new Uint8Array(D.buffer,D.byteOffset,D.byteLength),T);else throw new Error("Unknown argument 'array'")}readUInt32BE(D){return h(this.buffer,D)}writeUInt32BE(D,T){w(this.buffer,D,T)}readUInt32LE(D){return m(this.buffer,D)}writeUInt32LE(D,T){R(this.buffer,D,T)}readUInt8(D){return p(this.buffer,D)}writeUInt8(D,T){f(this.buffer,D,T)}indexOf(D,T=0){return c(this.buffer,D instanceof g?D.buffer:D,T)}}t.$Oe=g;function c(C,D,T=0){const M=D.byteLength,K=C.byteLength;if(M===0)return 0;if(M===1)return C.indexOf(D[0]);if(M>K-T)return-1;const Y=O.value;Y.fill(D.length);for(let de=0;de<D.length;de++)Y[D[de]]=D.length-de-1;let ae=T+D.length-1,le=ae,ce=-1;for(;ae<K;)if(C[ae]===D[le]){if(le===0){ce=ae;break}ae--,le--}else ae+=Math.max(D.length-le,Y[C[ae]]),le=D.length-1;return ce}function l(C,D){return C[D+0]<<0>>>0|C[D+1]<<8>>>0}function u(C,D,T){C[T+0]=D&255,D=D>>>8,C[T+1]=D&255}function h(C,D){return C[D]*2**24+C[D+1]*2**16+C[D+2]*2**8+C[D+3]}function w(C,D,T){C[T+3]=D,D=D>>>8,C[T+2]=D,D=D>>>8,C[T+1]=D,D=D>>>8,C[T]=D}function m(C,D){return C[D+0]<<0>>>0|C[D+1]<<8>>>0|C[D+2]<<16>>>0|C[D+3]<<24>>>0}function R(C,D,T){C[T+0]=D&255,D=D>>>8,C[T+1]=D&255,D=D>>>8,C[T+2]=D&255,D=D>>>8,C[T+3]=D&255}function p(C,D){return C[D]}function f(C,D,T){C[T]=D}function $(C){return P.$De(C,D=>g.concat(D))}function I(C){return P.$Ke(C)}function v(C){return P.$Fe(C,D=>g.concat(D))}async function e(C){return C.ended?g.concat(C.buffer):g.concat([...C.buffer,await v(C.stream)])}function a(C){return P.$Ie(C,D=>g.concat(D))}function n(C){return P.$Le(C,{data:D=>typeof D=="string"?g.fromString(D):g.wrap(D)},D=>g.concat(D))}function r(C){return P.$Ce(D=>g.concat(D),C)}function i(C,D){return P.$Me(C,D,T=>g.concat(T))}function s(C,D){return P.$Ne(C,D,T=>g.concat(T))}function o(C){let D=0,T=0,M=0;const K=new Uint8Array(Math.floor(C.length/4*3)),Y=le=>{switch(T){case 3:K[M++]=D|le,T=0;break;case 2:K[M++]=D|le>>>2,D=le<<6,T=3;break;case 1:K[M++]=D|le>>>4,D=le<<4,T=2;break;default:D=le<<2,T=1}};for(let le=0;le<C.length;le++){const ce=C.charCodeAt(le);if(ce>=65&&ce<=90)Y(ce-65);else if(ce>=97&&ce<=122)Y(ce-97+26);else if(ce>=48&&ce<=57)Y(ce-48+52);else if(ce===43||ce===45)Y(62);else if(ce===47||ce===95)Y(63);else{if(ce===61)break;throw new SyntaxError(`Unexpected base64 character ${C[le]}`)}}const ae=M;for(;T>0;)Y(0);return g.wrap(K).slice(0,ae)}const d="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",S="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function N({buffer:C},D=!0,T=!1){const M=T?S:d;let K="";const Y=C.byteLength%3;let ae=0;for(;ae<C.byteLength-Y;ae+=3){const le=C[ae+0],ce=C[ae+1],de=C[ae+2];K+=M[le>>>2],K+=M[(le<<4|ce>>>4)&63],K+=M[(ce<<2|de>>>6)&63],K+=M[de&63]}if(Y===1){const le=C[ae+0];K+=M[le>>>2],K+=M[le<<4&63],D&&(K+="==")}else if(Y===2){const le=C[ae+0],ce=C[ae+1];K+=M[le>>>2],K+=M[(le<<4|ce>>>4)&63],K+=M[ce<<2&63],D&&(K+="=")}return K}}),define(re[28],oe([0,1,3]),function(H,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$bo=P,t.$co=y,t.$do=A,t.$eo=g,t.$fo=c,t.$go=l,t.$ho=u,t.$io=h,t.$jo=w,t.$ko=m,t.$lo=R,t.$mo=p,t.$no=f;function P($){if(!$||typeof $!="object"||$ instanceof RegExp)return $;const I=Array.isArray($)?[]:{};return Object.entries($).forEach(([v,e])=>{I[v]=e&&typeof e=="object"?P(e):e}),I}function y($){if(!$||typeof $!="object")return $;const I=[$];for(;I.length>0;){const v=I.shift();Object.freeze(v);for(const e in v)if(O.call(v,e)){const a=v[e];typeof a=="object"&&!Object.isFrozen(a)&&!(0,E.$ig)(a)&&I.push(a)}}return $}const O=Object.prototype.hasOwnProperty;function A($,I){return k($,I,new Set)}function k($,I,v){if((0,E.$og)($))return $;const e=I($);if(typeof e<"u")return e;if(Array.isArray($)){const a=[];for(const n of $)a.push(k(n,I,v));return a}if((0,E.$hg)($)){if(v.has($))throw new Error("Cannot clone recursive data-structure");v.add($);const a={};for(const n in $)O.call($,n)&&(a[n]=k($[n],I,v));return v.delete($),a}return $}function g($,I,v=!0){return(0,E.$hg)($)?((0,E.$hg)(I)&&Object.keys(I).forEach(e=>{e in $?v&&((0,E.$hg)($[e])&&(0,E.$hg)(I[e])?g($[e],I[e],v):$[e]=I[e]):$[e]=I[e]}),$):I}function c($,I){if($===I)return!0;if($==null||I===null||I===void 0||typeof $!=typeof I||typeof $!="object"||Array.isArray($)!==Array.isArray(I))return!1;let v,e;if(Array.isArray($)){if($.length!==I.length)return!1;for(v=0;v<$.length;v++)if(!c($[v],I[v]))return!1}else{const a=[];for(e in $)a.push(e);a.sort();const n=[];for(e in I)n.push(e);if(n.sort(),!c(a,n))return!1;for(v=0;v<a.length;v++)if(!c($[a[v]],I[a[v]]))return!1}return!0}function l($){const I=new Set;return JSON.stringify($,(v,e)=>{if((0,E.$hg)(e)||Array.isArray(e)){if(I.has(e))return"[Circular]";I.add(e)}return typeof e=="bigint"?`[BigInt ${e.toString()}]`:e})}function u($,I){const v=Object.create(null);return!$||!I||Object.keys(I).forEach(a=>{const n=$[a],r=I[a];c(n,r)||(v[a]=r)}),v}function h($,I){const v=I.toLowerCase(),e=Object.keys($).find(a=>a.toLowerCase()===v);return e?$[e]:$[I]}function w($,I){const v=Object.create(null);for(const[e,a]of Object.entries($))I(e,a)&&(v[e]=a);return v}function m($){let I=[];for(;Object.prototype!==$;)I=I.concat(Object.getOwnPropertyNames($)),$=Object.getPrototypeOf($);return I}function R($){const I=[];for(const v of m($))typeof $[v]=="function"&&I.push(v);return I}function p($,I){const v=a=>function(){const n=Array.prototype.slice.call(arguments,0);return I(a,n)},e={};for(const a of $)e[a]=v(a);return e}function f($,I){const v={};for(const[e,a]of Object.entries($))v[e]=I(a,e);return v}}),define(re[43],oe([0,1,32]),function(H,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$zj=t.$xj=void 0,t.$tj=P,t.$uj=y,t.$vj=O,t.$wj=k,t.$yj=R,E=ye(E);function P(f){return y(f,0)}function y(f,$){switch(typeof f){case"object":return f===null?O(349,$):Array.isArray(f)?g(f,$):c(f,$);case"string":return k(f,$);case"boolean":return A(f,$);case"number":return O(f,$);case"undefined":return O(937,$);default:return O(617,$)}}function O(f,$){return($<<5)-$+f|0}function A(f,$){return O(f?433:863,$)}function k(f,$){$=O(149417,$);for(let I=0,v=f.length;I<v;I++)$=O(f.charCodeAt(I),$);return $}function g(f,$){return $=O(104579,$),f.reduce((I,v)=>y(v,I),$)}function c(f,$){return $=O(181387,$),Object.keys(f).sort().reduce((I,v)=>(I=k(v,I),y(f[v],I)),$)}class l{constructor(){this.g=0}get value(){return this.g}hash($){return this.g=y($,this.g),this.g}}t.$xj=l;var u;(function(f){f[f.BLOCK_SIZE=64]="BLOCK_SIZE",f[f.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(u||(u={}));function h(f,$,I=32){const v=I-$,e=~((1<<v)-1);return(f<<$|(e&f)>>>v)>>>0}function w(f,$=0,I=f.byteLength,v=0){for(let e=0;e<I;e++)f[$+e]=v}function m(f,$,I="0"){for(;f.length<$;)f=I+f;return f}function R(f,$=32){return f instanceof ArrayBuffer?Array.from(new Uint8Array(f)).map(I=>I.toString(16).padStart(2,"0")).join(""):m((f>>>0).toString(16),$/4)}class p{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(u.BLOCK_SIZE+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update($){const I=$.length;if(I===0)return;const v=this.p;let e=this.r,a=this.u,n,r;for(a!==0?(n=a,r=-1,a=0):(n=$.charCodeAt(0),r=0);;){let i=n;if(E.$Kf(n))if(r+1<I){const s=$.charCodeAt(r+1);E.$Lf(s)?(r++,i=E.$Mf(n,s)):i=u.UNICODE_REPLACEMENT}else{a=n;break}else E.$Lf(n)&&(i=u.UNICODE_REPLACEMENT);if(e=this.w(v,e,i),r++,r<I)n=$.charCodeAt(r);else break}this.r=e,this.u=a}w($,I,v){return v<128?$[I++]=v:v<2048?($[I++]=192|(v&1984)>>>6,$[I++]=128|(v&63)>>>0):v<65536?($[I++]=224|(v&61440)>>>12,$[I++]=128|(v&4032)>>>6,$[I++]=128|(v&63)>>>0):($[I++]=240|(v&1835008)>>>18,$[I++]=128|(v&258048)>>>12,$[I++]=128|(v&4032)>>>6,$[I++]=128|(v&63)>>>0),I>=u.BLOCK_SIZE&&(this.y(),I-=u.BLOCK_SIZE,this.t+=u.BLOCK_SIZE,$[0]=$[u.BLOCK_SIZE+0],$[1]=$[u.BLOCK_SIZE+1],$[2]=$[u.BLOCK_SIZE+2]),I}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,u.UNICODE_REPLACEMENT)),this.t+=this.r,this.x()),R(this.h)+R(this.l)+R(this.m)+R(this.n)+R(this.o)}x(){this.p[this.r++]=128,w(this.p,this.r),this.r>56&&(this.y(),w(this.p));const $=8*this.t;this.q.setUint32(56,Math.floor($/4294967296),!1),this.q.setUint32(60,$%4294967296,!1),this.y()}y(){const $=p.g,I=this.q;for(let d=0;d<64;d+=4)$.setUint32(d,I.getUint32(d,!1),!1);for(let d=64;d<320;d+=4)$.setUint32(d,h($.getUint32(d-12,!1)^$.getUint32(d-32,!1)^$.getUint32(d-56,!1)^$.getUint32(d-64,!1),1),!1);let v=this.h,e=this.l,a=this.m,n=this.n,r=this.o,i,s,o;for(let d=0;d<80;d++)d<20?(i=e&a|~e&n,s=1518500249):d<40?(i=e^a^n,s=1859775393):d<60?(i=e&a|e&n|a&n,s=2400959708):(i=e^a^n,s=3395469782),o=h(v,5)+i+r+s+$.getUint32(d*4,!1)&4294967295,r=n,n=a,a=h(e,30),e=v,v=o;this.h=this.h+v&4294967295,this.l=this.l+e&4294967295,this.m=this.m+a&4294967295,this.n=this.n+n&4294967295,this.o=this.o+r&4294967295}}t.$zj=p}),define(re[56],oe([0,1,32]),function(H,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),E=ye(E);var P;(function(y){y[y.Ignore=0]="Ignore",y[y.Info=1]="Info",y[y.Warning=2]="Warning",y[y.Error=3]="Error"})(P||(P={})),function(y){const O="error",A="warning",k="warn",g="info",c="ignore";function l(h){return h?E.$Gf(O,h)?y.Error:E.$Gf(A,h)||E.$Gf(k,h)?y.Warning:E.$Gf(g,h)?y.Info:y.Ignore:y.Ignore}y.fromValue=l;function u(h){switch(h){case y.Error:return O;case y.Warning:return A;case y.Info:return g;default:return c}}y.toString=u}(P||(P={})),t.default=P}),define(re[29],oe([0,1]),function(H,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$2g=void 0,t.$1g=P;const E=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function P(y){return E.test(y)}t.$2g=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let y;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?y=crypto.getRandomValues.bind(crypto):y=function(k){for(let g=0;g<k.length;g++)k[g]=Math.floor(Math.random()*256);return k};const O=new Uint8Array(16),A=[];for(let k=0;k<256;k++)A.push(k.toString(16).padStart(2,"0"));return function(){y(O),O[6]=O[6]&15|64,O[8]=O[8]&63|128;let g=0,c="";return c+=A[O[g++]],c+=A[O[g++]],c+=A[O[g++]],c+=A[O[g++]],c+="-",c+=A[O[g++]],c+=A[O[g++]],c+="-",c+=A[O[g++]],c+=A[O[g++]],c+="-",c+=A[O[g++]],c+=A[O[g++]],c+="-",c+=A[O[g++]],c+=A[O[g++]],c+=A[O[g++]],c+=A[O[g++]],c+=A[O[g++]],c+=A[O[g++]],c}}()}),define(re[80],oe([0,1,35]),function(H,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$On=O;const P=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function y(A){const k=A.replace(/\-/g,":").toLowerCase();return!P.has(k)}function O(){const A=(0,E.networkInterfaces)();for(const k in A){const g=A[k];if(g){for(const{mac:c}of g)if(y(c))return c}}throw new Error("Unable to retrieve mac address (unexpected format)")}}),define(re[81],oe([7,4]),function(H,t){return H.create("vs/base/common/date",t)}),define(re[82],oe([0,1,81]),function(H,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$1m=c,t.$2m=l,t.$3m=u;const P=60,y=P*60,O=y*24,A=O*7,k=O*30,g=O*365;function c(h,w,m,R){typeof h!="number"&&(h=h.getTime());const p=Math.round((new Date().getTime()-h)/1e3);if(p<-30)return(0,E.localize)(0,null,c(new Date().getTime()+p*1e3,!1));if(!R&&p<30)return(0,E.localize)(1,null);let f;return p<P?(f=p,w?f===1?m?(0,E.localize)(2,null,f):(0,E.localize)(3,null,f):m?(0,E.localize)(4,null,f):(0,E.localize)(5,null,f):f===1?m?(0,E.localize)(6,null,f):(0,E.localize)(7,null,f):m?(0,E.localize)(8,null,f):(0,E.localize)(9,null,f)):p<y?(f=Math.floor(p/P),w?f===1?m?(0,E.localize)(10,null,f):(0,E.localize)(11,null,f):m?(0,E.localize)(12,null,f):(0,E.localize)(13,null,f):f===1?m?(0,E.localize)(14,null,f):(0,E.localize)(15,null,f):m?(0,E.localize)(16,null,f):(0,E.localize)(17,null,f)):p<O?(f=Math.floor(p/y),w?f===1?m?(0,E.localize)(18,null,f):(0,E.localize)(19,null,f):m?(0,E.localize)(20,null,f):(0,E.localize)(21,null,f):f===1?m?(0,E.localize)(22,null,f):(0,E.localize)(23,null,f):m?(0,E.localize)(24,null,f):(0,E.localize)(25,null,f)):p<A?(f=Math.floor(p/O),w?f===1?(0,E.localize)(26,null,f):(0,E.localize)(27,null,f):f===1?(0,E.localize)(28,null,f):(0,E.localize)(29,null,f)):p<k?(f=Math.floor(p/A),w?f===1?m?(0,E.localize)(30,null,f):(0,E.localize)(31,null,f):m?(0,E.localize)(32,null,f):(0,E.localize)(33,null,f):f===1?m?(0,E.localize)(34,null,f):(0,E.localize)(35,null,f):m?(0,E.localize)(36,null,f):(0,E.localize)(37,null,f)):p<g?(f=Math.floor(p/k),w?f===1?m?(0,E.localize)(38,null,f):(0,E.localize)(39,null,f):m?(0,E.localize)(40,null,f):(0,E.localize)(41,null,f):f===1?m?(0,E.localize)(42,null,f):(0,E.localize)(43,null,f):m?(0,E.localize)(44,null,f):(0,E.localize)(45,null,f)):(f=Math.floor(p/g),w?f===1?m?(0,E.localize)(46,null,f):(0,E.localize)(47,null,f):m?(0,E.localize)(48,null,f):(0,E.localize)(49,null,f):f===1?m?(0,E.localize)(50,null,f):(0,E.localize)(51,null,f):m?(0,E.localize)(52,null,f):(0,E.localize)(53,null,f))}function l(h,w){const m=Math.abs(h/1e3);return m<1?w?(0,E.localize)(54,null,h):(0,E.localize)(55,null,h):m<P?w?(0,E.localize)(56,null,Math.round(h)/1e3):(0,E.localize)(57,null,Math.round(h)/1e3):m<y?w?(0,E.localize)(58,null,Math.round(h/(1e3*P))):(0,E.localize)(59,null,Math.round(h/(1e3*P))):m<O?w?(0,E.localize)(60,null,Math.round(h/(1e3*y))):(0,E.localize)(61,null,Math.round(h/(1e3*y))):(0,E.localize)(62,null,Math.round(h/(1e3*O)))}function u(h){return h.getFullYear()+"-"+String(h.getMonth()+1).padStart(2,"0")+"-"+String(h.getDate()).padStart(2,"0")+"T"+String(h.getHours()).padStart(2,"0")+":"+String(h.getMinutes()).padStart(2,"0")+":"+String(h.getSeconds()).padStart(2,"0")+"."+(h.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}}),define(re[83],oe([7,4]),function(H,t){return H.create("vs/base/common/errorMessage",t)}),define(re[38],oe([0,1,20,3,83]),function(H,t,E,P,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$qj=g,t.$rj=c,t.$sj=l,E=ye(E),P=ye(P),y=ye(y);function O(u,h){return h&&(u.stack||u.stacktrace)?y.localize(0,null,k(u),A(u.stack)||A(u.stacktrace)):k(u)}function A(u){return Array.isArray(u)?u.join(`
`):u}function k(u){return u.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${u.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof u.code=="string"&&typeof u.errno=="number"&&typeof u.syscall=="string"?y.localize(1,null,u.message):u.message||y.localize(2,null)}function g(u=null,h=!1){if(!u)return y.localize(3,null);if(Array.isArray(u)){const w=E.$Jb(u),m=g(w[0],h);return w.length>1?y.localize(4,null,m,w.length):m}if(P.$fg(u))return u;if(u.detail){const w=u.detail;if(w.error)return O(w.error,h);if(w.exception)return O(w.exception,h)}return u.stack?O(u,h):u.message?u.message:y.localize(5,null)}function c(u){const h=u;return h instanceof Error&&Array.isArray(h.actions)}function l(u,h){let w;return typeof u=="string"?w=new Error(u):w=u,w.actions=h,w}}),define(re[84],oe([7,4]),function(H,t){return H.create("vs/base/common/jsonErrorMessages",t)}),define(re[85],oe([0,1,84,34]),function(H,t,E,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Eq=y;function y(O){switch(O){case P.ParseErrorCode.InvalidSymbol:return(0,E.localize)(0,null);case P.ParseErrorCode.InvalidNumberFormat:return(0,E.localize)(1,null);case P.ParseErrorCode.PropertyNameExpected:return(0,E.localize)(2,null);case P.ParseErrorCode.ValueExpected:return(0,E.localize)(3,null);case P.ParseErrorCode.ColonExpected:return(0,E.localize)(4,null);case P.ParseErrorCode.CommaExpected:return(0,E.localize)(5,null);case P.ParseErrorCode.CloseBraceExpected:return(0,E.localize)(6,null);case P.ParseErrorCode.CloseBracketExpected:return(0,E.localize)(7,null);case P.ParseErrorCode.EndOfFileExpected:return(0,E.localize)(8,null);default:return""}}}),define(re[57],oe([0,1,13]),function(H,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.TerminateResponseCode=t.Source=void 0,t.$km=O,t.$lm=A;var P;(function(k){k[k.stdout=0]="stdout",k[k.stderr=1]="stderr"})(P||(t.Source=P={}));var y;(function(k){k[k.Success=0]="Success",k[k.Unknown=1]="Unknown",k[k.AccessDenied=2]="AccessDenied",k[k.ProcessNotFound=3]="ProcessNotFound"})(y||(t.TerminateResponseCode=y={}));function O(k,...g){const c=g.reduce((h,w)=>(h[w]=!0,h),{}),l=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(k).filter(h=>!c[h]).forEach(h=>{for(let w=0;w<l.length;w++)if(h.search(l[w])!==-1){delete k[h];break}})}function A(k){k&&(delete k.DEBUG,E.$j&&delete k.DYLD_LIBRARY_PATH,E.$k&&delete k.LD_PRELOAD)}}),define(re[86],oe([0,1,12]),function(H,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$9q=P,t.$0q=y,t.$$q=O,t.log=k;function P(c){const l=c;return l&&typeof l.type=="string"&&typeof l.severity=="string"}function y(c){const l=[];let u;try{const h=JSON.parse(c.arguments),w=h[h.length-1];w&&w.__$stack&&(h.pop(),u=w.__$stack),l.push(...h)}catch{l.push("Unable to log remote console arguments",c.arguments)}return{args:l,stack:u}}function O(c){if(typeof c!="string")return O(y(c).stack);const l=c;if(l){const u=A(l),h=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(u||"");if(h&&h.length===4)return{uri:E.URI.file(h[1]),line:Number(h[2]),column:Number(h[3])}}}function A(c){if(!c)return c;const l=c.indexOf(`
`);return l===-1?c:c.substring(0,l)}function k(c,l){const{args:u,stack:h}=y(c),w=typeof u[0]=="string"&&u.length===1;let m=A(h);m&&(m=`(${m.trim()})`);let R=[];if(typeof u[0]=="string"?m&&w?R=[`%c[${l}] %c${u[0]} %c${m}`,g("blue"),g(""),g("grey")]:R=[`%c[${l}] %c${u[0]}`,g("blue"),g(""),...u.slice(1)]:R=[`%c[${l}]%`,g("blue"),...u],m&&!w&&R.push(m),typeof console[c.severity]!="function")throw new Error("Unknown console method");console[c.severity].apply(console,R)}function g(c){return`color: ${c}`}}),define(re[47],oe([0,1,14,12,171]),function(H,t,E,P,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ai=O,t.$bi=A,t.$ci=g;function O(c){return JSON.stringify(c,k)}function A(c){let l=JSON.parse(c);return l=g(l),l}function k(c,l){return l instanceof RegExp?{$mid:y.MarshalledId.Regexp,source:l.source,flags:l.flags}:l}function g(c,l=0){if(!c||l>200)return c;if(typeof c=="object"){switch(c.$mid){case y.MarshalledId.Uri:return P.URI.revive(c);case y.MarshalledId.Regexp:return new RegExp(c.source,c.flags);case y.MarshalledId.Date:return new Date(c.source)}if(c instanceof E.$Oe||c instanceof Uint8Array)return c;if(Array.isArray(c))for(let u=0;u<c.length;++u)c[u]=g(c[u],l+1);else for(const u in c)Object.hasOwnProperty.call(c,u)&&(c[u]=g(c[u],l+1))}return c}}),define(re[87],oe([0,1,74,15,13,12]),function(H,t,E,P,y,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$oE=l,y=ye(y);class A{constructor(h,w,m){this.id=h,this.dependencies=w,this.callback=m}}class k{static{this.INSTANCE=new k}constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=(h,w,m)=>{typeof h!="string"&&(m=w,w=h,h=null),(typeof w!="object"||!Array.isArray(w))&&(m=w,w=null),this.c.push(new A(h,w,m))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(h){if(h.startsWith(window.location.origin)||h.startsWith("vscode-file://vscode-app"))return h;throw new Error(`[trusted_script_src] Invalid script url: ${h}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(h){return h}})))}async load(h){this.g();const w=await(this.a?this.i(h):this.b?this.h(h):this.j(h));if(!w)throw new Error(`Did not receive a define call from script ${h}`);if(Array.isArray(w.dependencies)&&w.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${h}. The dependencies are: ${w.dependencies.join(", ")}`);return typeof w.callback=="function"?w.callback([]):w.callback}h(h){return new Promise((w,m)=>{const R=document.createElement("script");R.setAttribute("async","async"),R.setAttribute("type","text/javascript");const p=()=>{R.removeEventListener("load",f),R.removeEventListener("error",$)},f=I=>{p(),w(this.c.pop())},$=I=>{p(),m(I)};R.addEventListener("load",f),R.addEventListener("error",$),this.f&&(h=this.f.createScriptURL(h)),R.setAttribute("src",h),window.document.getElementsByTagName("head")[0].appendChild(R)})}i(h){return new Promise((w,m)=>{try{this.f&&(h=this.f.createScriptURL(h)),importScripts(h),w(this.c.pop())}catch(R){m(R)}})}async j(h){try{const w=globalThis._VSCODE_NODE_MODULES.fs,m=globalThis._VSCODE_NODE_MODULES.vm,R=globalThis._VSCODE_NODE_MODULES.module,p=O.URI.parse(h).fsPath,f=w.readFileSync(p).toString(),$=R.wrap(f.replace(/^#!.*/,""));return new m.Script($).runInThisContext().apply(),this.c.pop()}catch(w){throw w}}}const g=new Map;let c={};typeof globalThis.require=="object"&&(c=globalThis.require.paths??{});async function l(u,h,w){if(E.$V){w===void 0&&(w=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),c[u]&&(u=c[u]);const m=`${u}/${h}`;if(g.has(m))return g.get(m);let R;if(/^\w[\w\d+.-]*:\/\//.test(m))R=m;else{const I=`${w&&!y.$o?P.$Wg:P.$Vg}/${m}`;R=P.$Zg.asBrowserUri(I).toString(!0)}const p=k.INSTANCE.load(R);return g.set(m,p),p}else return await new Promise((m,R)=>{H([u],m,R)}).then(ye)}}),define(re[88],oe([0,1,35,48,29,80,13]),function(H,t,E,P,y,O,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Pn=void 0,t.$Qn=g,t.$Rn=u,t.$Sn=h,y=ye(y),t.$Pn=new class{c(w){return this.a||(this.a=P.$Li.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(w)}value(){if(this.b===void 0){let w=0,m=0;const R=(0,E.networkInterfaces)();for(const p in R){const f=R[p];if(f)for(const{mac:$,internal:I}of f)I||(m+=1,this.c($.toUpperCase())&&(w+=1))}this.b=m>0?w/m:0}return this.b}};let k;async function g(w){return k||(k=(async()=>await c(w)||y.$2g())()),k}async function c(w){try{const m=await new Promise((p,f)=>{H(["crypto"],p,f)}).then(ye),R=(0,O.$On)();return m.createHash("sha256").update(R,"utf8").digest("hex")}catch(m){w(m);return}}const l="Software\\Microsoft\\SQMClient";async function u(w){if(A.$i){const m=await new Promise((R,p)=>{H(["@vscode/windows-registry"],R,p)}).then(ye);try{return m.GetStringRegKey("HKEY_LOCAL_MACHINE",l,"MachineId")||""}catch(R){return w(R),""}}return""}async function h(w){try{return await(await new Promise((p,f)=>{H(["@vscode/deviceid"],p,f)}).then(ye)).getDeviceId()}catch(m){return w(m),""}}}),define(re[89],oe([0,1,35,16,25]),function(H,t,E,P,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$vm=$,t.$wm=I,E=ye(E),P=ye(P),y=ye(y);const O=/^\d+$/,A=/^Microsoft.PowerShell_.*/,k=/^Microsoft.PowerShellPreview_.*/;var g;(function(v){v[v.x64=0]="x64",v[v.x86=1]="x86",v[v.ARM=2]="ARM"})(g||(g={}));let c;switch(process.arch){case"ia32":c=g.x86;break;case"arm":case"arm64":c=g.ARM;break;default:c=g.x64;break}let l;process.env.PROCESSOR_ARCHITEW6432?l=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?g.ARM:g.x64:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?l=g.ARM:process.env.PROCESSOR_ARCHITECTURE==="X86"?l=g.x86:l=g.x64;class u{constructor(e,a,n){this.exePath=e,this.displayName=a,this.a=n}async exists(){return this.a===void 0&&(this.a=await y.SymlinkSupport.existsFile(this.exePath)),this.a}}function h({useAlternateBitness:v=!1}={}){return v?c===g.x64?process.env["ProgramFiles(x86)"]||null:l===g.x64&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function w({useAlternateBitness:v=!1,findPreview:e=!1}={}){const a=h({useAlternateBitness:v});if(!a)return null;const n=P.$lc(a,"PowerShell");if(!await y.SymlinkSupport.existsDirectory(n))return null;let r=-1,i=null;for(const d of await y.Promises.readdir(n)){let S=-1;if(e){const C=d.indexOf("-");if(C<0)continue;const D=d.substring(0,C);if(!O.test(D)||d.substring(C+1)!=="preview")continue;S=parseInt(D,10)}else{if(!O.test(d))continue;S=parseInt(d,10)}if(S<=r)continue;const N=P.$lc(n,d,"pwsh.exe");await y.SymlinkSupport.existsFile(N)&&(i=N,r=S)}if(!i)return null;const s=a.includes("x86")?" (x86)":"",o=e?" Preview":"";return new u(i,`PowerShell${o}${s}`,!0)}async function m({findPreview:v}={}){if(!process.env.LOCALAPPDATA)return null;const e=P.$lc(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await y.SymlinkSupport.existsDirectory(e))return null;const{pwshMsixDirRegex:a,pwshMsixName:n}=v?{pwshMsixDirRegex:k,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:A,pwshMsixName:"PowerShell (Store)"};for(const r of await y.Promises.readdir(e))if(a.test(r)){const i=P.$lc(e,r,"pwsh.exe");return new u(i,n)}return null}function R(){const v=P.$lc(E.homedir(),".dotnet","tools","pwsh.exe");return new u(v,".NET Core PowerShell Global Tool")}function p(){const v=P.$lc(process.env.windir,c===g.x86&&l!==g.x86?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new u(v,"Windows PowerShell",!0)}async function*f(){let v=await w();v&&(yield v),v=await w({useAlternateBitness:!0}),v&&(yield v),v=await m(),v&&(yield v),v=R(),v&&(yield v),v=await w({findPreview:!0}),v&&(yield v),v=await m({findPreview:!0}),v&&(yield v),v=await w({useAlternateBitness:!0,findPreview:!0}),v&&(yield v),v=p(),v&&(yield v)}async function*$(){for await(const v of f())await v.exists()&&(yield v)}async function I(){for await(const v of $())return v;return null}}),define(re[58],oe([0,1,16,13,36,57,3,25]),function(H,t,E,P,y,O,A,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.win32=t.TerminateResponseCode=t.Source=void 0,t.$xm=g,t.$ym=c,E=ye(E),P=ye(P),y=ye(y),A=ye(A),k=ye(k),Object.defineProperty(t,"Source",{enumerable:!0,get:function(){return O.Source}}),Object.defineProperty(t,"TerminateResponseCode",{enumerable:!0,get:function(){return O.TerminateResponseCode}});function g(u=y.env){return u.comspec||"cmd.exe"}function c(u){let h=[],w=!1;const m=function(R){if(w){h.push(R);return}(!u.send(R,f=>{if(f&&console.error(f),w=!1,h.length>0){const $=h.slice(0);h=[],$.forEach(I=>m(I))}})||P.$i)&&(w=!0)};return{send:m}}var l;(function(u){async function h(w,m,R){if(E.$kc(w))return w;if(m===void 0&&(m=y.cwd()),E.$oc(w)!=="."||(R===void 0&&A.$fg(y.env.PATH)&&(R=y.env.PATH.split(E.$vc)),R===void 0||R.length===0))return E.$lc(m,w);async function f($){if(await k.Promises.exists($)){let I;try{I=await k.Promises.stat($)}catch(v){v.message.startsWith("EACCES")&&(I=await k.Promises.lstat($))}return I?!I.isDirectory():!1}return!1}for(const $ of R){let I;if(E.$kc($)?I=E.$lc($,w):I=E.$lc(m,$,w),await f(I))return I;let v=I+".com";if(await f(v)||(v=I+".exe",await f(v)))return v}return E.$lc(m,w)}u.findExecutable=h})(l||(t.win32=l={}))}),define(re[90],oe([0,1,35,13,89,58]),function(H,t,E,P,y,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$zm=A,P=ye(P),O=ye(O);async function A(u,h){return u===P.OperatingSystem.Windows?P.$i?l():O.$xm(h):g(u,h)}let k=null;function g(u,h){if(P.$k&&u===P.OperatingSystem.Macintosh||P.$j&&u===P.OperatingSystem.Linux)return"/bin/bash";if(!k){let w;if(P.$i)w="/bin/bash";else{if(w=h.SHELL,!w)try{w=(0,E.userInfo)().shell}catch{}w||(w="sh"),w==="/bin/false"&&(w="/bin/bash")}k=w}return k}let c=null;async function l(){return c||(c=(await(0,y.$wm)()).exePath),c}});var we=this&&this.__decorate||function(H,t,E,P){var y=arguments.length,O=y<3?t:P===null?P=Object.getOwnPropertyDescriptor(t,E):P,A;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")O=Reflect.decorate(H,t,E,P);else for(var k=H.length-1;k>=0;k--)(A=H[k])&&(O=(y<3?A(O):y>3?A(t,E,O):A(t,E))||O);return y>3&&O&&Object.defineProperty(t,E,O),O};define(re[59],oe([0,1,20,8,14,22,55,9,5,2,47,32,3]),function(H,t,E,P,y,O,A,k,g,c,l,u,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$oi=t.ProxyChannel=t.$ni=t.$ki=t.$ji=t.$ii=t.RequestInitiator=t.$hi=t.$ei=t.$di=void 0,t.$fi=o,t.$gi=d,t.$li=M,t.$mi=K,u=ye(u);var w;(function(B){B[B.Promise=100]="Promise",B[B.PromiseCancel=101]="PromiseCancel",B[B.EventListen=102]="EventListen",B[B.EventDispose=103]="EventDispose"})(w||(w={}));function m(B){switch(B){case w.Promise:return"req";case w.PromiseCancel:return"cancel";case w.EventListen:return"subscribe";case w.EventDispose:return"unsubscribe"}}var R;(function(B){B[B.Initialize=200]="Initialize",B[B.PromiseSuccess=201]="PromiseSuccess",B[B.PromiseError=202]="PromiseError",B[B.PromiseErrorObj=203]="PromiseErrorObj",B[B.EventFire=204]="EventFire"})(R||(R={}));function p(B){switch(B){case R.Initialize:return"init";case R.PromiseSuccess:return"reply:";case R.PromiseError:case R.PromiseErrorObj:return"replyErr:";case R.EventFire:return"event:"}}var f;(function(B){B[B.Uninitialized=0]="Uninitialized",B[B.Idle=1]="Idle"})(f||(f={}));function $(B){let U=0;for(let J=0;;J+=7){const X=B.read(1);if(U|=(X.buffer[0]&127)<<J,!(X.buffer[0]&128))return U}}const I=r(0);function v(B,U){if(U===0){B.write(I);return}let J=0;for(let ee=U;ee!==0;ee=ee>>>7)J++;const X=y.$Oe.alloc(J);for(let ee=0;U!==0;ee++)X.buffer[ee]=U&127,U=U>>>7,U>0&&(X.buffer[ee]|=128);B.write(X)}class e{constructor(U){this.b=U,this.a=0}read(U){const J=this.b.slice(this.a,this.a+U);return this.a+=J.byteLength,J}}t.$di=e;class a{constructor(){this.a=[]}get buffer(){return y.$Oe.concat(this.a)}write(U){this.a.push(U)}}t.$ei=a;var n;(function(B){B[B.Undefined=0]="Undefined",B[B.String=1]="String",B[B.Buffer=2]="Buffer",B[B.VSBuffer=3]="VSBuffer",B[B.Array=4]="Array",B[B.Object=5]="Object",B[B.Int=6]="Int"})(n||(n={}));function r(B){const U=y.$Oe.alloc(1);return U.writeUInt8(B,0),U}const i={Undefined:r(n.Undefined),String:r(n.String),Buffer:r(n.Buffer),VSBuffer:r(n.VSBuffer),Array:r(n.Array),Object:r(n.Object),Uint:r(n.Int)},s=typeof Buffer<"u";function o(B,U){if(typeof U>"u")B.write(i.Undefined);else if(typeof U=="string"){const J=y.$Oe.fromString(U);B.write(i.String),v(B,J.byteLength),B.write(J)}else if(s&&Buffer.isBuffer(U)){const J=y.$Oe.wrap(U);B.write(i.Buffer),v(B,J.byteLength),B.write(J)}else if(U instanceof y.$Oe)B.write(i.VSBuffer),v(B,U.byteLength),B.write(U);else if(Array.isArray(U)){B.write(i.Array),v(B,U.length);for(const J of U)o(B,J)}else if(typeof U=="number"&&(U|0)===U)B.write(i.Uint),v(B,U);else{const J=y.$Oe.fromString(JSON.stringify(U));B.write(i.Object),v(B,J.byteLength),B.write(J)}}function d(B){switch(B.read(1).readUInt8(0)){case n.Undefined:return;case n.String:return B.read($(B)).toString();case n.Buffer:return B.read($(B)).buffer;case n.VSBuffer:return B.read($(B));case n.Array:{const J=$(B),X=[];for(let ee=0;ee<J;ee++)X.push(d(B));return X}case n.Object:return JSON.parse(B.read($(B)).toString());case n.Int:return $(B)}}class S{constructor(U,J,X=null,ee=1e3){this.h=U,this.j=J,this.k=X,this.l=ee,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(j=>this.q(j)),this.m({type:R.Initialize})}registerChannel(U,J){this.b.set(U,J),setTimeout(()=>this.w(U),0)}m(U){switch(U.type){case R.Initialize:{const J=this.o([U.type]);this.k?.logOutgoing(J,0,N.OtherSide,p(U.type));return}case R.PromiseSuccess:case R.PromiseError:case R.EventFire:case R.PromiseErrorObj:{const J=this.o([U.type,U.id],U.data);this.k?.logOutgoing(J,U.id,N.OtherSide,p(U.type),U.data);return}}}o(U,J=void 0){const X=new a;return o(X,U),o(X,J),this.p(X.buffer)}p(U){try{return this.h.send(U),U.byteLength}catch{return 0}}q(U){const J=new e(U),X=d(J),ee=d(J),j=X[0];switch(j){case w.Promise:return this.k?.logIncoming(U.byteLength,X[1],N.OtherSide,`${m(j)}: ${X[2]}.${X[3]}`,ee),this.s({type:j,id:X[1],channelName:X[2],name:X[3],arg:ee});case w.EventListen:return this.k?.logIncoming(U.byteLength,X[1],N.OtherSide,`${m(j)}: ${X[2]}.${X[3]}`,ee),this.t({type:j,id:X[1],channelName:X[2],name:X[3],arg:ee});case w.PromiseCancel:return this.k?.logIncoming(U.byteLength,X[1],N.OtherSide,`${m(j)}`),this.u({type:j,id:X[1]});case w.EventDispose:return this.k?.logIncoming(U.byteLength,X[1],N.OtherSide,`${m(j)}`),this.u({type:j,id:X[1]})}}s(U){const J=this.b.get(U.channelName);if(!J){this.v(U);return}const X=new O.$xe;let ee;try{ee=J.call(this.j,U.name,U.arg,X.token)}catch(G){ee=Promise.reject(G)}const j=U.id;ee.then(G=>{this.m({id:j,data:G,type:R.PromiseSuccess})},G=>{G instanceof Error?this.m({id:j,data:{message:G.message,name:G.name,stack:G.stack?G.stack.split(`
`):void 0},type:R.PromiseError}):this.m({id:j,data:G,type:R.PromiseErrorObj})}).finally(()=>{q.dispose(),this.d.delete(U.id)});const q=(0,c.$Uc)(()=>X.cancel());this.d.set(U.id,q)}t(U){const J=this.b.get(U.channelName);if(!J){this.v(U);return}const X=U.id,j=J.listen(this.j,U.name,U.arg)(q=>this.m({id:X,data:q,type:R.EventFire}));this.d.set(U.id,j)}u(U){const J=this.d.get(U.id);J&&(J.dispose(),this.d.delete(U.id))}v(U){let J=this.g.get(U.channelName);J||(J=[],this.g.set(U.channelName,J));const X=setTimeout(()=>{console.error(`Unknown channel: ${U.channelName}`),U.type===w.Promise&&this.m({id:U.id,data:{name:"Unknown channel",message:`Channel name '${U.channelName}' timed out after ${this.l}ms`,stack:void 0},type:R.PromiseError})},this.l);J.push({request:U,timeoutTimer:X})}w(U){const J=this.g.get(U);if(J){for(const X of J)switch(clearTimeout(X.timeoutTimer),X.request.type){case w.Promise:this.s(X.request);break;case w.EventListen:this.t(X.request);break}this.g.delete(U)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,c.$Rc)(this.d.values()),this.d.clear()}}t.$hi=S;var N;(function(B){B[B.LocalSide=0]="LocalSide",B[B.OtherSide=1]="OtherSide"})(N||(t.RequestInitiator=N={}));class C{constructor(U,J=null){this.l=U,this.a=!1,this.b=f.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new g.$me,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(X=>this.s(X)),this.j=J}getChannel(U){const J=this;return{call(X,ee,j){return J.a?Promise.reject(new k.$7):J.m(U,X,ee,j)},listen(X,ee){return J.a?g.Event.None:J.o(U,X,ee)}}}m(U,J,X,ee=O.CancellationToken.None){const j=this.g++,q=w.Promise,G={id:j,type:q,channelName:U,name:J,arg:X};if(ee.isCancellationRequested)return Promise.reject(new k.$7);let V;return new Promise((L,F)=>{if(ee.isCancellationRequested)return F(new k.$7);const z=()=>{const he=ue=>{switch(ue.type){case R.PromiseSuccess:this.f.delete(j),L(ue.data);break;case R.PromiseError:{this.f.delete(j);const Ee=new Error(ue.data.message);Ee.stack=Array.isArray(ue.data.stack)?ue.data.stack.join(`
`):ue.data.stack,Ee.name=ue.data.name,F(Ee);break}case R.PromiseErrorObj:this.f.delete(j),F(ue.data);break}};this.f.set(j,he),this.p(G)};let Z=null;this.b===f.Idle?z():(Z=(0,P.$sh)(he=>this.u()),Z.then(()=>{Z=null,z()}));const Q=()=>{Z?(Z.cancel(),Z=null):this.p({id:j,type:w.PromiseCancel}),F(new k.$7)},se=ee.onCancellationRequested(Q);V=(0,c.$Tc)((0,c.$Uc)(Q),se),this.d.add(V)}).finally(()=>{V.dispose(),this.d.delete(V)})}o(U,J,X){const ee=this.g++,j=w.EventListen,q={id:ee,type:j,channelName:U,name:J,arg:X};let G=null;const V=new g.$me({onWillAddFirstListener:()=>{G=(0,P.$sh)(L=>this.u()),G.then(()=>{G=null,this.d.add(V),this.p(q)})},onDidRemoveLastListener:()=>{G?(G.cancel(),G=null):(this.d.delete(V),this.p({id:ee,type:w.EventDispose}))}}),b=L=>V.fire(L.data);return this.f.set(ee,b),V.event}p(U){switch(U.type){case w.Promise:case w.EventListen:{const J=this.q([U.type,U.id,U.channelName,U.name],U.arg);this.j?.logOutgoing(J,U.id,N.LocalSide,`${m(U.type)}: ${U.channelName}.${U.name}`,U.arg);return}case w.PromiseCancel:case w.EventDispose:{const J=this.q([U.type,U.id]);this.j?.logOutgoing(J,U.id,N.LocalSide,m(U.type));return}}}q(U,J=void 0){const X=new a;return o(X,U),o(X,J),this.r(X.buffer)}r(U){try{return this.l.send(U),U.byteLength}catch{return 0}}s(U){const J=new e(U),X=d(J),ee=d(J),j=X[0];switch(j){case R.Initialize:return this.j?.logIncoming(U.byteLength,0,N.LocalSide,p(j)),this.t({type:X[0]});case R.PromiseSuccess:case R.PromiseError:case R.EventFire:case R.PromiseErrorObj:return this.j?.logIncoming(U.byteLength,X[1],N.LocalSide,p(j),ee),this.t({type:X[0],id:X[1],data:ee})}}t(U){if(U.type===R.Initialize){this.b=f.Idle,this.k.fire();return}this.f.get(U.id)?.(U)}get onDidInitializePromise(){return g.Event.toPromise(this.onDidInitialize)}u(){return this.b===f.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,c.$Rc)(this.d.values()),this.d.clear()}}t.$ii=C,we([A.$0h],C.prototype,"onDidInitializePromise",null);class D{get connections(){const U=[];return this.f.forEach(J=>U.push(J)),U}constructor(U,J,X){this.a=new Map,this.f=new Set,this.g=new g.$me,this.onDidAddConnection=this.g.event,this.h=new g.$me,this.onDidRemoveConnection=this.h.event,this.j=new c.$Vc,this.j.add(U(({protocol:ee,onDidClientDisconnect:j})=>{const q=g.Event.once(ee.onMessage);this.j.add(q(G=>{const V=new e(G),b=d(V),L=new S(ee,b,J,X),F=new C(ee,J);this.a.forEach((Z,Q)=>L.registerChannel(Q,Z));const z={channelServer:L,channelClient:F,ctx:b};this.f.add(z),this.g.fire(z),this.j.add(j(()=>{L.dispose(),F.dispose(),this.f.delete(z),this.h.fire(z)}))}))}))}getChannel(U,J){const X=this;return{call(ee,j,q){let G;if((0,h.$tg)(J)){const b=(0,E.$5b)(X.connections.filter(J));G=b?Promise.resolve(b):g.Event.toPromise(g.Event.filter(X.onDidAddConnection,J))}else G=J.routeCall(X,ee,j);const V=G.then(b=>b.channelClient.getChannel(U));return M(V).call(ee,j,q)},listen(ee,j){if((0,h.$tg)(J))return X.k(U,J,ee,j);const q=J.routeEvent(X,ee,j).then(G=>G.channelClient.getChannel(U));return M(q).listen(ee,j)}}}k(U,J,X,ee){const j=this;let q;const G=new g.$me({onWillAddFirstListener:()=>{q=new c.$Vc;const V=new g.$se,b=new Map,L=z=>{const Q=z.channelClient.getChannel(U).listen(X,ee),se=V.add(Q);b.set(z,se)},F=z=>{const Z=b.get(z);Z&&(Z.dispose(),b.delete(z))};j.connections.filter(J).forEach(L),g.Event.filter(j.onDidAddConnection,J)(L,void 0,q),j.onDidRemoveConnection(F,void 0,q),V.event(G.fire,G,q),q.add(V)},onDidRemoveLastListener:()=>{q?.dispose(),q=void 0}});return G.event}registerChannel(U,J){this.a.set(U,J);for(const X of this.f)X.channelServer.registerChannel(U,J)}dispose(){this.j.dispose();for(const U of this.f)U.channelClient.dispose(),U.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}t.$ji=D;class T{constructor(U,J,X=null){const ee=new a;o(ee,J),U.send(ee.buffer),this.a=new C(U,X),this.d=new S(U,J,X)}getChannel(U){return this.a.getChannel(U)}registerChannel(U,J){this.d.registerChannel(U,J)}dispose(){this.a.dispose(),this.d.dispose()}}t.$ki=T;function M(B){return{call(U,J,X){return B.then(ee=>ee.call(U,J,X))},listen(U,J){const X=new g.$ve;return B.then(ee=>X.input=ee.listen(U,J)),X.event}}}function K(B){let U=!1;return{call(J,X,ee){return U?B.call(J,X,ee):(0,P.$Gh)(0).then(()=>U=!0).then(()=>B.call(J,X,ee))},listen(J,X){if(U)return B.listen(J,X);const ee=new g.$ve;return(0,P.$Gh)(0).then(()=>U=!0).then(()=>ee.input=B.listen(J,X)),ee.event}}}class Y{constructor(U){this.a=U}routeCall(U){return this.b(U)}routeEvent(U){return this.b(U)}async b(U){for(const J of U.connections)if(await Promise.resolve(this.a(J.ctx)))return Promise.resolve(J);return await g.Event.toPromise(U.onDidAddConnection),await this.b(U)}}t.$ni=Y;var ae;(function(B){function U(j,q,G){const V=j,b=G&&G.disableMarshalling,L=new Map;for(const F in V)X(F)&&L.set(F,g.Event.buffer(V[F],!0,void 0,q));return new class{listen(F,z,Z){const Q=L.get(z);if(Q)return Q;const se=V[z];if(typeof se=="function"){if(ee(z))return se.call(V,Z);if(X(z))return L.set(z,g.Event.buffer(V[z],!0,void 0,q)),L.get(z)}throw new k.$db(`Event not found: ${z}`)}call(F,z,Z){const Q=V[z];if(typeof Q=="function"){if(!b&&Array.isArray(Z))for(let he=0;he<Z.length;he++)Z[he]=(0,l.$ci)(Z[he]);let se=Q.apply(V,Z);return se instanceof Promise||(se=Promise.resolve(se)),se}throw new k.$db(`Method not found: ${z}`)}}}B.fromService=U;function J(j,q){const G=q&&q.disableMarshalling;return new Proxy({},{get(V,b){if(typeof b=="string")return q?.properties?.has(b)?q.properties.get(b):ee(b)?function(L){return j.listen(b,L)}:X(b)?j.listen(b):async function(...L){let F;q&&!(0,h.$og)(q.context)?F=[q.context,...L]:F=L;const z=await j.call(b,F);return G?z:(0,l.$ci)(z)};throw new k.$db(`Property not found: ${String(b)}`)}})}B.toService=J;function X(j){return j[0]==="o"&&j[1]==="n"&&u.$Ff(j.charCodeAt(2))}function ee(j){return/^onDynamic/.test(j)&&u.$Ff(j.charCodeAt(9))}})(ae||(t.ProxyChannel=ae={}));const le=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function ce(B){if(Array.isArray(B))return B;if(B&&typeof B=="object"&&typeof B.toString=="function"){const U=B.toString();if(U!=="[object Object]")return U}return B}function de(B){return Array.isArray(B)?B.map(ce):ce(B)}function x(B,U,J,X,ee,j,q){q=de(q);const G=le[ee],V=G[X%G.length];let b=[`%c[${B}]%c[${String(U).padStart(7," ")}]%c[len: ${String(J).padStart(5," ")}]%c${String(X).padStart(5," ")} - ${j}`,"color: darkgreen","color: grey","color: grey",`color: ${V}`];/\($/.test(j)?(b=b.concat(q),b.push(")")):b.push(q),console.log.apply(console,b)}class _{constructor(U,J){this.d=U,this.f=J,this.a=0,this.b=0}logOutgoing(U,J,X,ee,j){this.b+=U,x(this.d,this.b,U,J,X,ee,j)}logIncoming(U,J,X,ee,j){this.a+=U,x(this.f,this.a,U,J,X,ee,j)}}t.$oi=_}),define(re[91],oe([0,1,60,8,14,22,86,9,5,2,28,58,57,59]),function(H,t,E,P,y,O,A,k,g,c,l,u,h,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$br=t.$ar=void 0,k=ye(k);class m extends w.$hi{constructor(f){super({send:$=>{try{process.send?.($.buffer.toString("base64"))}catch{}},onMessage:g.Event.fromNodeEventEmitter(process,"message",$=>y.$Oe.wrap(Buffer.from($,"base64")))},f),process.once("disconnect",()=>this.dispose())}}t.$ar=m;class R{constructor(f,$){this.i=f,this.j=$,this.c=new Set,this.g=new Map,this.h=new g.$me,this.onDidProcessExit=this.h.event;const I=$&&$.timeout?$.timeout:6e4;this.b=new P.$Ch(I),this.d=null,this.f=null}getChannel(f){const $=this;return{call(I,v,e){return $.k(f,I,v,e)},listen(I,v){return $.l(f,I,v)}}}k(f,$,I,v=O.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(v.isCancellationRequested)return Promise.reject(k.$8());this.b.cancel();const e=this.n(f),a=(0,P.$sh)(i=>e.call($,I,i)),n=v.onCancellationRequested(()=>a.cancel()),r=(0,c.$Uc)(()=>a.cancel());return this.c.add(r),a.finally(()=>{n.dispose(),this.c.delete(r),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),a}l(f,$,I){if(!this.b)return g.Event.None;this.b.cancel();let v;const e=new g.$me({onWillAddFirstListener:()=>{v=this.n(f).listen($,I)(e.fire,e),this.c.add(v)},onDidRemoveLastListener:()=>{this.c.delete(v),v.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return e.event}get m(){if(!this.f){const f=this.j&&this.j.args?this.j.args:[],$=Object.create(null);$.env={...(0,l.$bo)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&($.env={...$.env,...this.j.env}),this.j&&this.j.freshExecArgv&&($.execArgv=[]),this.j&&typeof this.j.debug=="number"&&($.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&($.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),$.execArgv===void 0&&($.execArgv=process.execArgv.filter(o=>!/^--inspect(-brk)?=/.test(o)).filter(o=>!o.startsWith("--vscode-"))),(0,h.$lm)($.env),this.d=(0,E.fork)(this.i,f,$);const I=new g.$me,e=g.Event.fromNodeEventEmitter(this.d,"message",o=>o)(o=>{if((0,A.$9q)(o)){(0,A.log)(o,`IPC Library: ${this.j.serverName}`);return}I.fire(y.$Oe.wrap(Buffer.from(o,"base64")))}),a=this.j.useQueue?(0,u.$ym)(this.d):this.d,n=o=>this.d&&this.d.connected&&a.send(o.buffer.toString("base64")),r=I.event,i={send:n,onMessage:r};this.f=new w.$ii(i);const s=()=>this.o();process.once("exit",s),this.d.on("error",o=>console.warn('IPC "'+this.j.serverName+'" errored with '+o)),this.d.on("exit",(o,d)=>{process.removeListener("exit",s),e.dispose(),this.c.forEach(S=>(0,c.$Rc)(S)),this.c.clear(),o!==0&&d!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+o+" and signal "+d),this.b?.cancel(),this.o(),this.h.fire({code:o,signal:d})})}return this.f}n(f){let $=this.g.get(f);return $||($=this.m.getChannel(f),this.g.set(f,$)),$}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}t.$br=R}),define(re[92],oe([0,1,8,5,2,47,3]),function(H,t,E,P,y,O,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$$p=t.$0p=t.StorageState=t.StorageHint=void 0,t.$9p=g;var k;(function(h){h[h.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",h[h.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(k||(t.StorageHint=k={}));function g(h){const w=h;return w?.changed instanceof Map||w?.deleted instanceof Set}var c;(function(h){h[h.None=0]="None",h[h.Initialized=1]="Initialized",h[h.Closed=2]="Closed"})(c||(t.StorageState=c={}));class l extends y.$Wc{static{this.a=100}constructor(w,m=Object.create(null)){super(),this.r=w,this.s=m,this.b=this.B(new P.$pe),this.onDidChangeStorage=this.b.event,this.c=c.None,this.f=new Map,this.g=this.B(new E.$Dh(l.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(w=>this.u(w)))}u(w){this.b.pause();try{w.changed?.forEach((m,R)=>this.w(R,m)),w.deleted?.forEach(m=>this.w(m,void 0))}finally{this.b.resume()}}w(w,m){if(this.c===c.Closed)return;let R=!1;(0,A.$og)(m)?R=this.f.delete(w):this.f.get(w)!==m&&(this.f.set(w,m),R=!0),R&&this.b.fire({key:w,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===c.None&&(this.c=c.Initialized,this.s.hint!==k.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(w,m){const R=this.f.get(w);return(0,A.$og)(R)?m:R}getBoolean(w,m){const R=this.get(w);return(0,A.$og)(R)?m:R==="true"}getNumber(w,m){const R=this.get(w);return(0,A.$og)(R)?m:parseInt(R,10)}getObject(w,m){const R=this.get(w);return(0,A.$og)(R)?m:(0,O.$bi)(R)}async set(w,m,R=!1){if(this.c===c.Closed)return;if((0,A.$og)(m))return this.delete(w,R);const p=(0,A.$hg)(m)||Array.isArray(m)?(0,O.$ai)(m):String(m);if(this.f.get(w)!==p)return this.f.set(w,p),this.j.set(w,p),this.h.delete(w),this.b.fire({key:w,external:R}),this.D()}async delete(w,m=!1){if(!(this.c===c.Closed||!this.f.delete(w)))return this.h.has(w)||this.h.add(w),this.j.delete(w),this.b.fire({key:w,external:m}),this.D()}async optimize(){if(this.c!==c.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=c.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const w={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(w).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(w){if(!(this.c===c.Closed||this.m))return this.D(w)}async D(w){return this.s.hint===k.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),w)}async whenFlushed(){if(this.z)return new Promise(w=>this.n.push(w))}isInMemory(){return this.s.hint===k.STORAGE_IN_MEMORY}}t.$0p=l;class u{constructor(){this.onDidChangeItemsExternal=P.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(w){w.insert?.forEach((m,R)=>this.a.set(R,m)),w.delete?.forEach(m=>this.a.delete(m))}async optimize(){}async close(){}}t.$$p=u}),define(re[93],oe([7,4]),function(H,t){return H.create("vs/base/node/zip",t)}),define(re[49],oe([0,1,94,8,16,3,25,93]),function(H,t,E,P,y,O,A,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$uq=t.$tq=void 0,t.zip=p,t.$wq=f,t.$xq=I,y=ye(y),k=ye(k),t.$tq="end of central directory record signature not found";const g=new RegExp(t.$tq);class c extends Error{constructor(e,a){let n=a.message;switch(e){case"CorruptZip":n=`Corrupt ZIP: ${n}`;break}super(n),this.type=e,this.cause=a}}t.$uq=c;function l(v){const e=v.externalFileAttributes>>16||33188;return[448,56,7].map(a=>e&a).reduce((a,n)=>a+n,e&61440)}function u(v){if(v instanceof c)return v;let e;return g.test(v.message)&&(e="CorruptZip"),new c(e,v)}function h(v,e,a,n,r,i){const s=y.$oc(e),o=y.$lc(n,s);if(!o.startsWith(n))return Promise.reject(new Error(k.localize(0,null,e)));const d=y.$lc(n,e);let S;return i.onCancellationRequested(()=>{S?.destroy()}),Promise.resolve(A.Promises.mkdir(o,{recursive:!0})).then(()=>new Promise((N,C)=>{if(!i.isCancellationRequested)try{S=(0,E.createWriteStream)(d,{mode:a}),S.once("close",()=>N()),S.once("error",C),v.once("error",C),v.pipe(S)}catch(D){C(D)}}))}function w(v,e,a,n){let r=(0,P.$sh)(()=>Promise.resolve()),i=0;const s=n.onCancellationRequested(()=>{r.cancel(),v.close()});return new Promise((o,d)=>{const S=new P.$Ah,N=C=>{C.isCancellationRequested||(i++,v.readEntry())};v.once("error",d),v.once("close",()=>r.then(()=>{n.isCancellationRequested||v.entryCount===i?o():d(new c("Incomplete",new Error(k.localize(1,null,i,v.entryCount))))},d)),v.readEntry(),v.on("entry",C=>{if(n.isCancellationRequested)return;if(!a.sourcePathRegex.test(C.fileName)){N(n);return}const D=C.fileName.replace(a.sourcePathRegex,"");if(/\/$/.test(D)){const K=y.$lc(e,D);r=(0,P.$sh)(Y=>A.Promises.mkdir(K,{recursive:!0}).then(()=>N(Y)).then(void 0,d));return}const T=R(v,C),M=l(C);r=(0,P.$sh)(K=>S.queue(()=>T.then(Y=>h(Y,D,M,e,a,K).then(()=>N(K)))).then(null,d))})}).finally(()=>s.dispose())}async function m(v,e=!1){const{open:a}=await new Promise((n,r)=>{H(["yauzl"],n,r)}).then(ye);return new Promise((n,r)=>{a(v,e?{lazyEntries:!0}:void 0,(i,s)=>{i?r(u(i)):n((0,O.$qg)(s))})})}function R(v,e){return new Promise((a,n)=>{v.openReadStream(e,(r,i)=>{r?n(u(r)):a((0,O.$qg)(i))})})}async function p(v,e){const{ZipFile:a}=await new Promise((n,r)=>{H(["yazl"],n,r)}).then(ye);return new Promise((n,r)=>{const i=new a;e.forEach(o=>{o.contents?i.addBuffer(typeof o.contents=="string"?Buffer.from(o.contents,"utf8"):o.contents,o.path):o.localPath&&i.addFile(o.localPath,o.path)}),i.end();const s=(0,E.createWriteStream)(v);i.outputStream.pipe(s),i.outputStream.once("error",r),s.once("error",r),s.once("finish",()=>n(v))})}function f(v,e,a={},n){const r=new RegExp(a.sourcePath?`^${a.sourcePath}`:"");let i=m(v,!0);return a.overwrite&&(i=i.then(s=>A.Promises.rm(e).then(()=>s))),i.then(s=>w(s,e,{sourcePathRegex:r},n))}function $(v,e){return m(v).then(a=>new Promise((n,r)=>{a.on("entry",i=>{i.fileName===e&&R(a,i).then(s=>n(s),s=>r(s))}),a.once("close",()=>r(new Error(k.localize(2,null,e))))}))}function I(v,e){return $(v,e).then(a=>new Promise((n,r)=>{const i=[];a.once("error",r),a.on("data",s=>i.push(s)),a.on("end",()=>n(Buffer.concat(i)))}))}}),define(re[95],oe([7,4]),function(H,t){return H.create("vs/platform/configuration/common/configurationRegistry",t)}),define(re[96],oe([7,4]),function(H,t){return H.create("vs/platform/contextkey/common/contextkey",t)}),define(re[97],oe([7,4]),function(H,t){return H.create("vs/platform/contextkey/common/scanner",t)}),define(re[98],oe([7,4]),function(H,t){return H.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",t)}),define(re[99],oe([7,4]),function(H,t){return H.create("vs/platform/extensionManagement/common/extensionManagement",t)}),define(re[100],oe([7,4]),function(H,t){return H.create("vs/platform/extensionManagement/common/extensionManagementCLI",t)}),define(re[101],oe([7,4]),function(H,t){return H.create("vs/platform/extensionManagement/common/extensionNls",t)}),define(re[102],oe([7,4]),function(H,t){return H.create("vs/platform/extensionManagement/common/extensionsScannerService",t)}),define(re[103],oe([7,4]),function(H,t){return H.create("vs/platform/extensionManagement/node/extensionManagementService",t)}),define(re[104],oe([7,4]),function(H,t){return H.create("vs/platform/extensionManagement/node/extensionManagementUtil",t)}),define(re[105],oe([7,4]),function(H,t){return H.create("vs/platform/extensions/common/extensionValidator",t)}),define(re[106],oe([7,4]),function(H,t){return H.create("vs/platform/files/common/fileService",t)}),define(re[107],oe([7,4]),function(H,t){return H.create("vs/platform/files/common/io",t)}),define(re[108],oe([7,4]),function(H,t){return H.create("vs/platform/files/node/diskFileSystemProvider",t)}),define(re[109],oe([7,4]),function(H,t){return H.create("vs/platform/languagePacks/common/languagePacks",t)}),define(re[110],oe([7,4]),function(H,t){return H.create("vs/platform/log/common/log",t)}),define(re[111],oe([7,4]),function(H,t){return H.create("vs/platform/request/common/request",t)}),define(re[112],oe([7,4]),function(H,t){return H.create("vs/platform/shell/node/shellEnv",t)}),define(re[113],oe([7,4]),function(H,t){return H.create("vs/platform/telemetry/common/telemetryService",t)}),define(re[114],oe([7,4]),function(H,t){return H.create("vs/platform/userDataProfile/common/userDataProfile",t)}),define(re[115],oe([7,4]),function(H,t){return H.create("vs/platform/workspace/common/workspace",t)}),define(re[116],oe([0,1,117,9,97]),function(H,t,E,P,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Aj=t.TokenType=void 0;var O;(function(l){l[l.LParen=0]="LParen",l[l.RParen=1]="RParen",l[l.Neg=2]="Neg",l[l.Eq=3]="Eq",l[l.NotEq=4]="NotEq",l[l.Lt=5]="Lt",l[l.LtEq=6]="LtEq",l[l.Gt=7]="Gt",l[l.GtEq=8]="GtEq",l[l.RegexOp=9]="RegexOp",l[l.RegexStr=10]="RegexStr",l[l.True=11]="True",l[l.False=12]="False",l[l.In=13]="In",l[l.Not=14]="Not",l[l.And=15]="And",l[l.Or=16]="Or",l[l.Str=17]="Str",l[l.QuotedStr=18]="QuotedStr",l[l.Error=19]="Error",l[l.EOF=20]="EOF"})(O||(t.TokenType=O={}));function A(...l){switch(l.length){case 1:return(0,y.localize)(0,null,l[0]);case 2:return(0,y.localize)(1,null,l[0],l[1]);case 3:return(0,y.localize)(2,null,l[0],l[1],l[2]);default:return}}const k=(0,y.localize)(3,null),g=(0,y.localize)(4,null);class c{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(u){switch(u.type){case O.LParen:return"(";case O.RParen:return")";case O.Neg:return"!";case O.Eq:return u.isTripleEq?"===":"==";case O.NotEq:return u.isTripleEq?"!==":"!=";case O.Lt:return"<";case O.LtEq:return"<=";case O.Gt:return">=";case O.GtEq:return">=";case O.RegexOp:return"=~";case O.RegexStr:return u.lexeme;case O.True:return"true";case O.False:return"false";case O.In:return"in";case O.Not:return"not";case O.And:return"&&";case O.Or:return"||";case O.Str:return u.lexeme;case O.QuotedStr:return u.lexeme;case O.Error:return u.lexeme;case O.EOF:return"EOF";default:throw(0,P.$0)(`unhandled token type: ${JSON.stringify(u)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(u=>u.charCodeAt(0)))}static{this.b=new Map([["not",O.Not],["in",O.In],["false",O.False],["true",O.True]])}get errors(){return this.g}reset(u){return this.c=u,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case E.CharCode.OpenParen:this.k(O.LParen);break;case E.CharCode.CloseParen:this.k(O.RParen);break;case E.CharCode.ExclamationMark:if(this.h(E.CharCode.Equals)){const h=this.h(E.CharCode.Equals);this.f.push({type:O.NotEq,offset:this.d,isTripleEq:h})}else this.k(O.Neg);break;case E.CharCode.SingleQuote:this.o();break;case E.CharCode.Slash:this.q();break;case E.CharCode.Equals:if(this.h(E.CharCode.Equals)){const h=this.h(E.CharCode.Equals);this.f.push({type:O.Eq,offset:this.d,isTripleEq:h})}else this.h(E.CharCode.Tilde)?this.k(O.RegexOp):this.l(A("==","=~"));break;case E.CharCode.LessThan:this.k(this.h(E.CharCode.Equals)?O.LtEq:O.Lt);break;case E.CharCode.GreaterThan:this.k(this.h(E.CharCode.Equals)?O.GtEq:O.Gt);break;case E.CharCode.Ampersand:this.h(E.CharCode.Ampersand)?this.k(O.And):this.l(A("&&"));break;case E.CharCode.Pipe:this.h(E.CharCode.Pipe)?this.k(O.Or):this.l(A("||"));break;case E.CharCode.Space:case E.CharCode.CarriageReturn:case E.CharCode.Tab:case E.CharCode.LineFeed:case E.CharCode.NoBreakSpace:break;default:this.n()}return this.d=this.e,this.k(O.EOF),Array.from(this.f)}h(u){return this.r()||this.c.charCodeAt(this.e)!==u?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?E.CharCode.Null:this.c.charCodeAt(this.e)}k(u){this.f.push({type:u,offset:this.d})}l(u){const h=this.d,w=this.c.substring(this.d,this.e),m={type:O.Error,offset:this.d,lexeme:w};this.g.push({offset:h,lexeme:w,additionalInfo:u}),this.f.push(m)}n(){this.m.lastIndex=this.d;const u=this.m.exec(this.c);if(u){this.e=this.d+u[0].length;const h=this.c.substring(this.d,this.e),w=c.b.get(h);w?this.k(w):this.f.push({type:O.Str,lexeme:h,offset:this.d})}}o(){for(;this.j()!==E.CharCode.SingleQuote&&!this.r();)this.i();if(this.r()){this.l(k);return}this.i(),this.f.push({type:O.QuotedStr,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let u=this.e,h=!1,w=!1;for(;;){if(u>=this.c.length){this.e=u,this.l(g);return}const R=this.c.charCodeAt(u);if(h)h=!1;else if(R===E.CharCode.Slash&&!w){u++;break}else R===E.CharCode.OpenSquareBracket?w=!0:R===E.CharCode.Backslash?h=!0:R===E.CharCode.CloseSquareBracket&&(w=!1);u++}for(;u<this.c.length&&c.a.has(this.c.charCodeAt(u));)u++;this.e=u;const m=this.c.substring(this.d,this.e);this.f.push({type:O.RegexStr,lexeme:m,offset:this.d})}r(){return this.e>=this.c.length}}t.$Aj=c}),define(re[118],oe([0,1,82,55,15,16,36,17,12]),function(H,t,E,P,y,O,A,k,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$5m=t.$4m=void 0,t.$6m=l,t.$7m=u,t.$4m=/^([^.]+\..+)[:=](.+)$/;class c{get appRoot(){return(0,O.$oc)(y.$Zg.asFileUri("").fsPath)}get userHome(){return g.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return g.URI.file((0,O.$lc)(this.userDataPath,"User"))}get tmpDir(){return g.URI.file(this.b.tmpDir)}get cacheHome(){return g.URI.file(this.userDataPath)}get stateResource(){return(0,k.$gh)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:y.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,k.$gh)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const w=(0,E.$3m)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,O.$lc)(this.userDataPath,"logs",w)}return g.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,k.$gh)(g.URI.file((0,O.$lc)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,k.$gh)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,k.$gh)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,k.$gh)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const w=A.env.VSCODE_PORTABLE;return w?g.URI.file((0,O.$lc)(w,"argv.json")):(0,k.$gh)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return g.URI.file((0,O.$lc)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const w=this.args["builtin-extensions-dir"];return w?(0,O.$mc)(w):(0,O.$jc)((0,O.$lc)(y.$Zg.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const w=this.args["extensions-download-dir"];return w?g.URI.file((0,O.$mc)(w)):g.URI.file((0,O.$lc)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const w=this.args["extensions-dir"];if(w)return(0,O.$mc)(w);const m=A.env.VSCODE_EXTENSIONS;if(m)return m;const R=A.env.VSCODE_PORTABLE;return R?(0,O.$lc)(R,"extensions"):(0,k.$gh)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const w=this.args.extensionDevelopmentPath;if(Array.isArray(w))return w.map(m=>/^[^:/?#]+?:\/\//.test(m)?g.URI.parse(m):g.URI.file((0,O.$jc)(m)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(w=>w==="ui"||w==="workspace"||w==="web"?w:"workspace")}get extensionTestsLocationURI(){const w=this.args.extensionTestsPath;if(w)return/^[^:/?#]+?:\/\//.test(w)?g.URI.parse(w):g.URI.file((0,O.$jc)(w))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const w=this.args["disable-extension"];if(w){if(typeof w=="string")return[w];if(Array.isArray(w)&&w.length>0)return w}return!1}get debugExtensionHost(){return l(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!A.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(w=>!t.$4m.test(w))}get extensionLogLevel(){const w=[];for(const m of this.args.log||[]){const R=t.$4m.exec(m);R&&R[1]&&R[2]&&w.push([R[1],R[2]])}return w.length?w:void 0}get serviceMachineIdResource(){return(0,k.$gh)(g.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get useInMemorySecretStorage(){return!!this.args["use-inmemory-secretstorage"]}get policyFile(){if(this.args["__enable-file-policy"]){const w=A.env.VSCODE_PORTABLE;return w?g.URI.file((0,O.$lc)(w,"policy.json")):(0,k.$gh)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(w){this.args.continueOn=w}get args(){return this.a}constructor(w,m,R){this.a=w,this.b=m,this.c=R,this.editSessionId=this.args.editSessionId}}t.$5m=c,we([P.$0h],c.prototype,"appRoot",null),we([P.$0h],c.prototype,"userHome",null),we([P.$0h],c.prototype,"userDataPath",null),we([P.$0h],c.prototype,"appSettingsHome",null),we([P.$0h],c.prototype,"tmpDir",null),we([P.$0h],c.prototype,"cacheHome",null),we([P.$0h],c.prototype,"stateResource",null),we([P.$0h],c.prototype,"userRoamingDataHome",null),we([P.$0h],c.prototype,"userDataSyncHome",null),we([P.$0h],c.prototype,"sync",null),we([P.$0h],c.prototype,"machineSettingsResource",null),we([P.$0h],c.prototype,"workspaceStorageHome",null),we([P.$0h],c.prototype,"localHistoryHome",null),we([P.$0h],c.prototype,"keyboardLayoutResource",null),we([P.$0h],c.prototype,"argvResource",null),we([P.$0h],c.prototype,"isExtensionDevelopment",null),we([P.$0h],c.prototype,"untitledWorkspacesHome",null),we([P.$0h],c.prototype,"builtinExtensionsPath",null),we([P.$0h],c.prototype,"extensionsPath",null),we([P.$0h],c.prototype,"extensionDevelopmentLocationURI",null),we([P.$0h],c.prototype,"extensionDevelopmentKind",null),we([P.$0h],c.prototype,"extensionTestsLocationURI",null),we([P.$0h],c.prototype,"debugExtensionHost",null),we([P.$0h],c.prototype,"logLevel",null),we([P.$0h],c.prototype,"extensionLogLevel",null),we([P.$0h],c.prototype,"serviceMachineIdResource",null),we([P.$0h],c.prototype,"disableTelemetry",null),we([P.$0h],c.prototype,"disableWorkspaceTrust",null),we([P.$0h],c.prototype,"useInMemorySecretStorage",null),we([P.$0h],c.prototype,"policyFile",null);function l(h,w){return u(h["inspect-extensions"],h["inspect-brk-extensions"],5870,w,h.debugId,h.extensionEnvironment)}function u(h,w,m,R,p,f){const I=Number(w||h)||(R?null:m),v=I?!!w:!1;let e;if(f)try{e=JSON.parse(f)}catch{}return{port:I,break:v,debugId:p,env:e}}}),function(){"use strict";function H(t,E,P){function y(A,k){const g=O(A,k),c=[g];return t.isAbsolute(g)||c.unshift(P),t.resolve(...c)}function O(A,k){process.env.VSCODE_DEV&&(k="code-oss-dev");const g=process.env.VSCODE_PORTABLE;if(g)return t.join(g,"user-data");let c=process.env.VSCODE_APPDATA;if(c)return t.join(c,k);const l=A["user-data-dir"];if(l)return l;switch(process.platform){case"win32":if(c=process.env.APPDATA,!c){const u=process.env.USERPROFILE;if(typeof u!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");c=t.join(u,"AppData","Roaming")}break;case"darwin":c=t.join(E.homedir(),"Library","Application Support");break;case"linux":c=process.env.XDG_CONFIG_HOME||t.join(E.homedir(),".config");break;default:throw new Error("Platform not supported")}return t.join(c,k)}return{getUserDataPath:y}}if(typeof define=="function")define(re[119],oe([172,35,36]),function(t,E,P){return H(t,E,P.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const t=require("path"),E=require("os");module.exports=H(t,E,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(re[120],oe([0,1,35,118,119]),function(H,t,E,P,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$8m=void 0,t.$9m=A,t.$0m=k;class O extends P.$5m{constructor(c,l){super(c,{homeDir:(0,E.homedir)(),tmpDir:(0,E.tmpdir)(),userDataDir:(0,y.getUserDataPath)(c,l.nameShort)},l)}}t.$8m=O;function A(g,c){return(0,P.$7m)(g["inspect-ptyhost"],g["inspect-brk-ptyhost"],5877,c,g.extensionEnvironment)}function k(g,c){return(0,P.$7m)(g["inspect-sharedprocess"],g["inspect-brk-sharedprocess"],5879,c,g.extensionEnvironment)}}),define(re[121],oe([0,1,3,101]),function(H,t,E,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Fq=y;function y(A,k,g,c){try{O(A,k,g,c)}catch(l){A.error(l?.message??l)}return k}function O(A,k,g,c){const l=(u,h,w)=>{const m=u[h];if((0,E.$fg)(m)){const R=m,p=R.length;if(p>1&&R[0]==="%"&&R[p-1]==="%"){const f=R.substr(1,p-2);let $=g[f];$===void 0&&c&&($=c[f]);const I=typeof $=="string"?$:$?.message,v=c?.[f],e=typeof v=="string"?v:v?.message;if(!I){e||A.warn(`[${k.name}]: ${(0,P.localize)(0,null,f)}`);return}if(w&&(h==="title"||h==="category")&&e&&e!==I){const a={value:I,original:e};u[h]=a}else u[h]=I}}else if((0,E.$hg)(m))for(const R in m)m.hasOwnProperty(R)&&(R==="commands"?l(m,R,!0):l(m,R,w));else if(Array.isArray(m))for(let R=0;R<m.length;R++)l(m,R,w)};for(const u in k)k.hasOwnProperty(u)&&l(k,u)}});var qe=this&&this.__importDefault||function(H){return H&&H.__esModule?H:{default:H}};define(re[50],oe([0,1,17,56,105,44]),function(H,t,E,P,y,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Tp=g,t.$Up=c,t.$Vp=l,t.$Wp=u,t.$Xp=h,t.$Yp=w,t.$Zp=m,P=qe(P),y=ye(y),O=ye(O);const A=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,k=/^-(\d{4})(\d{2})(\d{2})$/;function g(f){return f=f.trim(),f==="*"||A.test(f)}function c(f){if(!g(f))return null;if(f=f.trim(),f==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const $=f.match(A);return $?{hasCaret:$[1]==="^",hasGreaterEquals:$[1]===">=",majorBase:$[2]==="x"?0:parseInt($[2],10),majorMustEqual:$[2]!=="x",minorBase:$[4]==="x"?0:parseInt($[4],10),minorMustEqual:$[4]!=="x",patchBase:$[6]==="x"?0:parseInt($[6],10),patchMustEqual:$[6]!=="x",preRelease:$[8]||null}:null}function l(f){if(!f)return null;const $=f.majorBase,I=f.majorMustEqual,v=f.minorBase;let e=f.minorMustEqual;const a=f.patchBase;let n=f.patchMustEqual;f.hasCaret&&($===0||(e=!1),n=!1);let r=0;if(f.preRelease){const i=k.exec(f.preRelease);if(i){const[,s,o,d]=i;r=Date.UTC(Number(s),Number(o)-1,Number(d))}}return{majorBase:$,majorMustEqual:I,minorBase:v,minorMustEqual:e,patchBase:a,patchMustEqual:n,isMinimum:f.hasGreaterEquals,notBefore:r}}function u(f,$,I){let v;typeof f=="string"?v=l(c(f)):v=f;let e;$ instanceof Date?e=$.getTime():typeof $=="string"&&(e=new Date($).getTime());let a;if(typeof I=="string"?a=l(c(I)):a=I,!v||!a)return!1;const n=v.majorBase,r=v.minorBase,i=v.patchBase;let s=a.majorBase,o=a.minorBase,d=a.patchBase;const S=a.notBefore;let N=a.majorMustEqual,C=a.minorMustEqual,D=a.patchMustEqual;return a.isMinimum?n>s?!0:n<s?!1:r>o?!0:r<o||e&&e<S?!1:i>=d:(n===1&&s===0&&(!N||!C||!D)&&(s=1,o=0,d=0,N=!0,C=!1,D=!1),n<s?!1:n>s?!N:r<o?!1:r>o?!C:i<d?!1:i>d?!D:!(e&&e<S))}function h(f,$,I,v,e){const a=[];if(typeof v.publisher<"u"&&typeof v.publisher!="string")return a.push([P.default.Error,y.localize(0,null)]),a;if(typeof v.name!="string")return a.push([P.default.Error,y.localize(1,null,"name")]),a;if(typeof v.version!="string")return a.push([P.default.Error,y.localize(2,null,"version")]),a;if(!v.engines)return a.push([P.default.Error,y.localize(3,null,"engines")]),a;if(typeof v.engines.vscode!="string")return a.push([P.default.Error,y.localize(4,null,"engines.vscode")]),a;if(typeof v.extensionDependencies<"u"&&!p(v.extensionDependencies))return a.push([P.default.Error,y.localize(5,null,"extensionDependencies")]),a;if(typeof v.activationEvents<"u"){if(!p(v.activationEvents))return a.push([P.default.Error,y.localize(6,null,"activationEvents")]),a;if(typeof v.main>"u"&&typeof v.browser>"u")return a.push([P.default.Error,y.localize(7,null,"activationEvents","main","browser")]),a}if(typeof v.extensionKind<"u"&&typeof v.main>"u"&&a.push([P.default.Warning,y.localize(8,null,"extensionKind")]),typeof v.main<"u"){if(typeof v.main!="string")return a.push([P.default.Error,y.localize(9,null,"main")]),a;{const i=(0,E.$gh)(I,v.main);(0,E.$ah)(i,I)||a.push([P.default.Warning,y.localize(10,null,i.path,I.path)])}}if(typeof v.browser<"u"){if(typeof v.browser!="string")return a.push([P.default.Error,y.localize(11,null,"browser")]),a;{const i=(0,E.$gh)(I,v.browser);(0,E.$ah)(i,I)||a.push([P.default.Warning,y.localize(12,null,i.path,I.path)])}}if(!O.valid(v.version))return a.push([P.default.Error,y.localize(13,null)]),a;const n=[];if(!w(f,$,v,e,n))for(const i of n)a.push([P.default.Error,i]);return a}function w(f,$,I,v,e){return v||typeof I.main>"u"&&typeof I.browser>"u"?!0:R(f,$,I.engines.vscode,e)}function m(f,$,I){return f==="*"||R($,I,f)}function R(f,$,I,v=[]){const e=l(c(I));if(!e)return v.push(y.localize(14,null,I)),!1;if(e.majorBase===0){if(!e.majorMustEqual||!e.minorMustEqual)return v.push(y.localize(15,null,I)),!1}else if(!e.majorMustEqual)return v.push(y.localize(16,null,I)),!1;return u(f,$,e)?!0:(v.push(y.localize(17,null,f,I)),!1)}function p(f){if(!Array.isArray(f))return!1;for(let $=0,I=f.length;$<I;$++)if(typeof f[$]!="string")return!1;return!0}}),define(re[51],oe([0,1]),function(H,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Ci=void 0;class E{constructor(y,O=[],A=!1){this.ctor=y,this.staticArguments=O,this.supportsDelayedInstantiation=A}}t.$Ci=E}),define(re[122],oe([0,1,51]),function(H,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.InstantiationType=void 0,t.$Ks=O,t.$Ls=A;const P=[];var y;(function(k){k[k.Eager=0]="Eager",k[k.Delayed=1]="Delayed"})(y||(t.InstantiationType=y={}));function O(k,g,c){g instanceof E.$Ci||(g=new E.$Ci(g,[],!!c)),P.push([k,g])}function A(){return P}}),define(re[123],oe([0,1]),function(H,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$or=t.$nr=void 0;class E{constructor(O,A){this.key=O,this.data=A,this.incoming=new Map,this.outgoing=new Map}}t.$nr=E;class P{constructor(O){this.b=O,this.a=new Map}roots(){const O=[];for(const A of this.a.values())A.outgoing.size===0&&O.push(A);return O}insertEdge(O,A){const k=this.lookupOrInsertNode(O),g=this.lookupOrInsertNode(A);k.outgoing.set(g.key,g),g.incoming.set(k.key,k)}removeNode(O){const A=this.b(O);this.a.delete(A);for(const k of this.a.values())k.outgoing.delete(A),k.incoming.delete(A)}lookupOrInsertNode(O){const A=this.b(O);let k=this.a.get(A);return k||(k=new E(A,O),this.a.set(A,k)),k}lookup(O){return this.a.get(this.b(O))}isEmpty(){return this.a.size===0}toString(){const O=[];for(const[A,k]of this.a)O.push(`${A}
	(-> incoming)[${[...k.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...k.outgoing.keys()].join(",")}]
`);return O.join(`
`)}findCycleSlow(){for(const[O,A]of this.a){const k=new Set([O]),g=this.c(A,k);if(g)return g}}c(O,A){for(const[k,g]of O.outgoing){if(A.has(k))return[...A,k].join(" -> ");A.add(k);const c=this.c(g,A);if(c)return c;A.delete(k)}}}t.$or=P}),define(re[30],oe([0,1,3,12,11]),function(H,t,E,P,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ConfigurationTarget=t.$_i=void 0,t.$aj=O,t.$bj=A,t.$cj=g,t.$dj=c,t.$ej=l,t.$fj=u,t.$gj=h,t.$hj=m,t.$ij=R,t.$jj=p,E=ye(E),t.$_i=(0,y.$Fi)("configurationService");function O(f){return f&&typeof f=="object"&&(!f.overrideIdentifier||typeof f.overrideIdentifier=="string")&&(!f.resource||f.resource instanceof P.URI)}function A(f){return f&&typeof f=="object"&&(!f.overrideIdentifiers||Array.isArray(f.overrideIdentifiers))&&!f.overrideIdentifier&&(!f.resource||f.resource instanceof P.URI)}var k;(function(f){f[f.APPLICATION=1]="APPLICATION",f[f.USER=2]="USER",f[f.USER_LOCAL=3]="USER_LOCAL",f[f.USER_REMOTE=4]="USER_REMOTE",f[f.WORKSPACE=5]="WORKSPACE",f[f.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",f[f.DEFAULT=7]="DEFAULT",f[f.MEMORY=8]="MEMORY"})(k||(t.ConfigurationTarget=k={}));function g(f){switch(f){case k.APPLICATION:return"APPLICATION";case k.USER:return"USER";case k.USER_LOCAL:return"USER_LOCAL";case k.USER_REMOTE:return"USER_REMOTE";case k.WORKSPACE:return"WORKSPACE";case k.WORKSPACE_FOLDER:return"WORKSPACE_FOLDER";case k.DEFAULT:return"DEFAULT";case k.MEMORY:return"MEMORY"}}function c(f){return f.applicationValue!==void 0||f.userValue!==void 0||f.userLocalValue!==void 0||f.userRemoteValue!==void 0||f.workspaceValue!==void 0||f.workspaceFolderValue!==void 0}function l(f,$){const I=Object.create(null);for(const v in f)u(I,v,f[v],$);return I}function u(f,$,I,v){const e=$.split("."),a=e.pop();let n=f;for(let r=0;r<e.length;r++){const i=e[r];let s=n[i];switch(typeof s){case"undefined":s=n[i]=Object.create(null);break;case"object":if(s===null){v(`Ignoring ${$} as ${e.slice(0,r+1).join(".")} is null`);return}break;default:v(`Ignoring ${$} as ${e.slice(0,r+1).join(".")} is ${JSON.stringify(s)}`);return}n=s}if(typeof n=="object"&&n!==null)try{n[a]=I}catch{v(`Ignoring ${$} as ${e.join(".")} is ${JSON.stringify(n)}`)}else v(`Ignoring ${$} as ${e.join(".")} is ${JSON.stringify(n)}`)}function h(f,$){const I=$.split(".");w(f,I)}function w(f,$){const I=$.shift();if($.length===0){delete f[I];return}if(Object.keys(f).indexOf(I)!==-1){const v=f[I];typeof v=="object"&&!Array.isArray(v)&&(w(v,$),Object.keys(v).length===0&&delete f[I])}}function m(f,$,I){function v(n,r){let i=n;for(const s of r){if(typeof i!="object"||i===null)return;i=i[s]}return i}const e=$.split("."),a=v(f,e);return typeof a>"u"?I:a}function R(f,$,I){Object.keys($).forEach(v=>{v!=="__proto__"&&(v in f?E.$hg(f[v])&&E.$hg($[v])?R(f[v],$[v],I):I&&(f[v]=$[v]):f[v]=$[v])})}function p(f){return f.replace(/[\[\]]/g,"")}}),define(re[124],oe([0,1,117,13,32,116,11,96,9]),function(H,t,E,P,y,O,A,k,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Xj=t.$Wj=t.$Vj=t.$Uj=t.$Tj=t.$Sj=t.$Rj=t.$Qj=t.$Pj=t.$Oj=t.$Nj=t.$Mj=t.$Lj=t.$Kj=t.$Jj=t.$Ij=t.$Hj=t.$Gj=t.$Dj=t.$Cj=t.ContextKeyExprType=void 0,t.$Bj=l,t.$Ej=r,t.$Fj=i,t.$Yj=j;const c=new Map;c.set("false",!1),c.set("true",!0),c.set("isMac",P.$j),c.set("isLinux",P.$k),c.set("isWindows",P.$i),c.set("isWeb",P.$o),c.set("isMacNative",P.$j&&!P.$o),c.set("isEdge",P.$H),c.set("isFirefox",P.$F),c.set("isChrome",P.$E),c.set("isSafari",P.$G);function l(V,b){if(c.get(V)!==void 0)throw(0,g.$9)("contextkey.setConstant(k, v) invoked with already set constant `k`");c.set(V,b)}const u=Object.prototype.hasOwnProperty;var h;(function(V){V[V.False=0]="False",V[V.True=1]="True",V[V.Defined=2]="Defined",V[V.Not=3]="Not",V[V.Equals=4]="Equals",V[V.NotEquals=5]="NotEquals",V[V.And=6]="And",V[V.Regex=7]="Regex",V[V.NotRegex=8]="NotRegex",V[V.Or=9]="Or",V[V.In=10]="In",V[V.NotIn=11]="NotIn",V[V.Greater=12]="Greater",V[V.GreaterEquals=13]="GreaterEquals",V[V.Smaller=14]="Smaller",V[V.SmallerEquals=15]="SmallerEquals"})(h||(t.ContextKeyExprType=h={}));const w={regexParsingWithErrorRecovery:!0},m=(0,k.localize)(0,null),R=(0,k.localize)(1,null),p=(0,k.localize)(2,null),f=(0,k.localize)(3,null),$=(0,k.localize)(4,null),I=(0,k.localize)(5,null),v=(0,k.localize)(6,null),e=(0,k.localize)(7,null);class a{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(b=w){this.k=b,this.d=new O.$Aj,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(b){if(b===""){this.h.push({message:m,offset:0,lexeme:"",additionalInfo:R});return}this.f=this.d.reset(b).scan(),this.g=0,this.h=[];try{const L=this.l();if(!this.E()){const F=this.D(),z=F.type===O.TokenType.Str?I:void 0;throw this.h.push({message:$,offset:F.offset,lexeme:O.$Aj.getLexeme(F),additionalInfo:z}),a.c}return L}catch(L){if(L!==a.c)throw L;return}}l(){return this.m()}m(){const b=[this.o()];for(;this.y(O.TokenType.Or);){const L=this.o();b.push(L)}return b.length===1?b[0]:n.or(...b)}o(){const b=[this.s()];for(;this.y(O.TokenType.And);){const L=this.s();b.push(L)}return b.length===1?b[0]:n.and(...b)}s(){if(this.y(O.TokenType.Neg)){const b=this.D();switch(b.type){case O.TokenType.True:return this.z(),o.INSTANCE;case O.TokenType.False:return this.z(),d.INSTANCE;case O.TokenType.LParen:{this.z();const L=this.l();return this.A(O.TokenType.RParen,f),L?.negate()}case O.TokenType.Str:return this.z(),M.create(b.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",b)}}return this.t()}t(){const b=this.D();switch(b.type){case O.TokenType.True:return this.z(),n.true();case O.TokenType.False:return this.z(),n.false();case O.TokenType.LParen:{this.z();const L=this.l();return this.A(O.TokenType.RParen,f),L}case O.TokenType.Str:{const L=b.lexeme;if(this.z(),this.y(O.TokenType.RegexOp)){const z=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),z.type!==O.TokenType.RegexStr)throw this.B("REGEX",z);const Z=z.lexeme,Q=Z.lastIndexOf("/"),se=Q===Z.length-1?void 0:this.w(Z.substring(Q+1));let he;try{he=new RegExp(Z.substring(1,Q),se)}catch{throw this.B("REGEX",z)}return de.create(L,he)}switch(z.type){case O.TokenType.RegexStr:case O.TokenType.Error:{const Z=[z.lexeme];this.z();let Q=this.D(),se=0;for(let ge=0;ge<z.lexeme.length;ge++)z.lexeme.charCodeAt(ge)===E.CharCode.OpenParen?se++:z.lexeme.charCodeAt(ge)===E.CharCode.CloseParen&&se--;for(;!this.E()&&Q.type!==O.TokenType.And&&Q.type!==O.TokenType.Or;){switch(Q.type){case O.TokenType.LParen:se++;break;case O.TokenType.RParen:se--;break;case O.TokenType.RegexStr:case O.TokenType.QuotedStr:for(let ge=0;ge<Q.lexeme.length;ge++)Q.lexeme.charCodeAt(ge)===E.CharCode.OpenParen?se++:z.lexeme.charCodeAt(ge)===E.CharCode.CloseParen&&se--}if(se<0)break;Z.push(O.$Aj.getLexeme(Q)),this.z(),Q=this.D()}const he=Z.join(""),ue=he.lastIndexOf("/"),Ee=ue===he.length-1?void 0:this.w(he.substring(ue+1));let pe;try{pe=new RegExp(he.substring(1,ue),Ee)}catch{throw this.B("REGEX",z)}return n.regex(L,pe)}case O.TokenType.QuotedStr:{const Z=z.lexeme;this.z();let Q=null;if(!(0,y.$df)(Z)){const se=Z.indexOf("/"),he=Z.lastIndexOf("/");if(se!==he&&se>=0){const ue=Z.slice(se+1,he),Ee=Z[he+1]==="i"?"i":"";try{Q=new RegExp(ue,Ee)}catch{throw this.B("REGEX",z)}}}if(Q===null)throw this.B("REGEX",z);return de.create(L,Q)}default:throw this.B("REGEX",this.D())}}if(this.y(O.TokenType.Not)){this.A(O.TokenType.In,p);const z=this.u();return n.notIn(L,z)}switch(this.D().type){case O.TokenType.Eq:{this.z();const z=this.u();if(this.x().type===O.TokenType.QuotedStr)return n.equals(L,z);switch(z){case"true":return n.has(L);case"false":return n.not(L);default:return n.equals(L,z)}}case O.TokenType.NotEq:{this.z();const z=this.u();if(this.x().type===O.TokenType.QuotedStr)return n.notEquals(L,z);switch(z){case"true":return n.not(L);case"false":return n.has(L);default:return n.notEquals(L,z)}}case O.TokenType.Lt:return this.z(),le.create(L,this.u());case O.TokenType.LtEq:return this.z(),ce.create(L,this.u());case O.TokenType.Gt:return this.z(),Y.create(L,this.u());case O.TokenType.GtEq:return this.z(),ae.create(L,this.u());case O.TokenType.In:return this.z(),n.in(L,this.u());default:return n.has(L)}}case O.TokenType.EOF:throw this.h.push({message:v,offset:b.offset,lexeme:"",additionalInfo:e}),a.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const b=this.D();switch(b.type){case O.TokenType.Str:case O.TokenType.QuotedStr:return this.z(),b.lexeme;case O.TokenType.True:return this.z(),"true";case O.TokenType.False:return this.z(),"false";case O.TokenType.In:return this.z(),"in";default:return""}}w(b){return b.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(b){return this.C(b)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(b,L){if(this.C(b))return this.z();throw this.B(L,this.D())}B(b,L,F){const z=(0,k.localize)(8,null,b,O.$Aj.getLexeme(L)),Z=L.offset,Q=O.$Aj.getLexeme(L);return this.h.push({message:z,offset:Z,lexeme:Q,additionalInfo:F}),a.c}C(b){return this.D().type===b}D(){return this.f[this.g]}E(){return this.D().type===O.TokenType.EOF}}t.$Cj=a;class n{static false(){return o.INSTANCE}static true(){return d.INSTANCE}static has(b){return S.create(b)}static equals(b,L){return N.create(b,L)}static notEquals(b,L){return T.create(b,L)}static regex(b,L){return de.create(b,L)}static in(b,L){return C.create(b,L)}static notIn(b,L){return D.create(b,L)}static not(b){return M.create(b)}static and(...b){return B.create(b,null,!0)}static or(...b){return U.create(b,null,!0)}static greater(b,L){return Y.create(b,L)}static greaterEquals(b,L){return ae.create(b,L)}static smaller(b,L){return le.create(b,L)}static smallerEquals(b,L){return ce.create(b,L)}static{this.c=new a({regexParsingWithErrorRecovery:!1})}static deserialize(b){return b==null?void 0:this.c.parse(b)}}t.$Dj=n;function r(V){const b=new a({regexParsingWithErrorRecovery:!1});return V.map(L=>(b.parse(L),b.lexingErrors.length>0?b.lexingErrors.map(F=>({errorMessage:F.additionalInfo?(0,k.localize)(9,null,F.additionalInfo):(0,k.localize)(10,null),offset:F.offset,length:F.lexeme.length})):b.parsingErrors.length>0?b.parsingErrors.map(F=>({errorMessage:F.additionalInfo?`${F.message}. ${F.additionalInfo}`:F.message,offset:F.offset,length:F.lexeme.length})):[]))}function i(V,b){const L=V?V.substituteConstants():void 0,F=b?b.substituteConstants():void 0;return!L&&!F?!0:!L||!F?!1:L.equals(F)}function s(V,b){return V.cmp(b)}class o{static{this.INSTANCE=new o}constructor(){this.type=h.False}cmp(b){return this.type-b.type}equals(b){return b.type===this.type}substituteConstants(){return this}evaluate(b){return!1}serialize(){return"false"}keys(){return[]}map(b){return this}negate(){return d.INSTANCE}}t.$Gj=o;class d{static{this.INSTANCE=new d}constructor(){this.type=h.True}cmp(b){return this.type-b.type}equals(b){return b.type===this.type}substituteConstants(){return this}evaluate(b){return!0}serialize(){return"true"}keys(){return[]}map(b){return this}negate(){return o.INSTANCE}}t.$Hj=d;class S{static create(b,L=null){const F=c.get(b);return typeof F=="boolean"?F?d.INSTANCE:o.INSTANCE:new S(b,L)}constructor(b,L){this.key=b,this.c=L,this.type=h.Defined}cmp(b){return b.type!==this.type?this.type-b.type:X(this.key,b.key)}equals(b){return b.type===this.type?this.key===b.key:!1}substituteConstants(){const b=c.get(this.key);return typeof b=="boolean"?b?d.INSTANCE:o.INSTANCE:this}evaluate(b){return!!b.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(b){return b.mapDefined(this.key)}negate(){return this.c||(this.c=M.create(this.key,this)),this.c}}t.$Ij=S;class N{static create(b,L,F=null){if(typeof L=="boolean")return L?S.create(b,F):M.create(b,F);const z=c.get(b);return typeof z=="boolean"?L===(z?"true":"false")?d.INSTANCE:o.INSTANCE:new N(b,L,F)}constructor(b,L,F){this.c=b,this.d=L,this.f=F,this.type=h.Equals}cmp(b){return b.type!==this.type?this.type-b.type:ee(this.c,this.d,b.c,b.d)}equals(b){return b.type===this.type?this.c===b.c&&this.d===b.d:!1}substituteConstants(){const b=c.get(this.c);if(typeof b=="boolean"){const L=b?"true":"false";return this.d===L?d.INSTANCE:o.INSTANCE}return this}evaluate(b){return b.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(b){return b.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=T.create(this.c,this.d,this)),this.f}}t.$Jj=N;class C{static create(b,L){return new C(b,L)}constructor(b,L){this.d=b,this.f=L,this.type=h.In,this.c=null}cmp(b){return b.type!==this.type?this.type-b.type:ee(this.d,this.f,b.d,b.f)}equals(b){return b.type===this.type?this.d===b.d&&this.f===b.f:!1}substituteConstants(){return this}evaluate(b){const L=b.getValue(this.f),F=b.getValue(this.d);return Array.isArray(L)?L.includes(F):typeof F=="string"&&typeof L=="object"&&L!==null?u.call(L,F):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(b){return b.mapIn(this.d,this.f)}negate(){return this.c||(this.c=D.create(this.d,this.f)),this.c}}t.$Kj=C;class D{static create(b,L){return new D(b,L)}constructor(b,L){this.d=b,this.f=L,this.type=h.NotIn,this.c=C.create(b,L)}cmp(b){return b.type!==this.type?this.type-b.type:this.c.cmp(b.c)}equals(b){return b.type===this.type?this.c.equals(b.c):!1}substituteConstants(){return this}evaluate(b){return!this.c.evaluate(b)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(b){return b.mapNotIn(this.d,this.f)}negate(){return this.c}}t.$Lj=D;class T{static create(b,L,F=null){if(typeof L=="boolean")return L?M.create(b,F):S.create(b,F);const z=c.get(b);return typeof z=="boolean"?L===(z?"true":"false")?o.INSTANCE:d.INSTANCE:new T(b,L,F)}constructor(b,L,F){this.c=b,this.d=L,this.f=F,this.type=h.NotEquals}cmp(b){return b.type!==this.type?this.type-b.type:ee(this.c,this.d,b.c,b.d)}equals(b){return b.type===this.type?this.c===b.c&&this.d===b.d:!1}substituteConstants(){const b=c.get(this.c);if(typeof b=="boolean"){const L=b?"true":"false";return this.d===L?o.INSTANCE:d.INSTANCE}return this}evaluate(b){return b.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(b){return b.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=N.create(this.c,this.d,this)),this.f}}t.$Mj=T;class M{static create(b,L=null){const F=c.get(b);return typeof F=="boolean"?F?o.INSTANCE:d.INSTANCE:new M(b,L)}constructor(b,L){this.c=b,this.d=L,this.type=h.Not}cmp(b){return b.type!==this.type?this.type-b.type:X(this.c,b.c)}equals(b){return b.type===this.type?this.c===b.c:!1}substituteConstants(){const b=c.get(this.c);return typeof b=="boolean"?b?o.INSTANCE:d.INSTANCE:this}evaluate(b){return!b.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(b){return b.mapNot(this.c)}negate(){return this.d||(this.d=S.create(this.c,this)),this.d}}t.$Nj=M;function K(V,b){if(typeof V=="string"){const L=parseFloat(V);isNaN(L)||(V=L)}return typeof V=="string"||typeof V=="number"?b(V):o.INSTANCE}class Y{static create(b,L,F=null){return K(L,z=>new Y(b,z,F))}constructor(b,L,F){this.c=b,this.d=L,this.f=F,this.type=h.Greater}cmp(b){return b.type!==this.type?this.type-b.type:ee(this.c,this.d,b.c,b.d)}equals(b){return b.type===this.type?this.c===b.c&&this.d===b.d:!1}substituteConstants(){return this}evaluate(b){return typeof this.d=="string"?!1:parseFloat(b.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(b){return b.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=ce.create(this.c,this.d,this)),this.f}}t.$Oj=Y;class ae{static create(b,L,F=null){return K(L,z=>new ae(b,z,F))}constructor(b,L,F){this.c=b,this.d=L,this.f=F,this.type=h.GreaterEquals}cmp(b){return b.type!==this.type?this.type-b.type:ee(this.c,this.d,b.c,b.d)}equals(b){return b.type===this.type?this.c===b.c&&this.d===b.d:!1}substituteConstants(){return this}evaluate(b){return typeof this.d=="string"?!1:parseFloat(b.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(b){return b.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=le.create(this.c,this.d,this)),this.f}}t.$Pj=ae;class le{static create(b,L,F=null){return K(L,z=>new le(b,z,F))}constructor(b,L,F){this.c=b,this.d=L,this.f=F,this.type=h.Smaller}cmp(b){return b.type!==this.type?this.type-b.type:ee(this.c,this.d,b.c,b.d)}equals(b){return b.type===this.type?this.c===b.c&&this.d===b.d:!1}substituteConstants(){return this}evaluate(b){return typeof this.d=="string"?!1:parseFloat(b.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(b){return b.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=ae.create(this.c,this.d,this)),this.f}}t.$Qj=le;class ce{static create(b,L,F=null){return K(L,z=>new ce(b,z,F))}constructor(b,L,F){this.c=b,this.d=L,this.f=F,this.type=h.SmallerEquals}cmp(b){return b.type!==this.type?this.type-b.type:ee(this.c,this.d,b.c,b.d)}equals(b){return b.type===this.type?this.c===b.c&&this.d===b.d:!1}substituteConstants(){return this}evaluate(b){return typeof this.d=="string"?!1:parseFloat(b.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(b){return b.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=Y.create(this.c,this.d,this)),this.f}}t.$Rj=ce;class de{static create(b,L){return new de(b,L)}constructor(b,L){this.d=b,this.f=L,this.type=h.Regex,this.c=null}cmp(b){if(b.type!==this.type)return this.type-b.type;if(this.d<b.d)return-1;if(this.d>b.d)return 1;const L=this.f?this.f.source:"",F=b.f?b.f.source:"";return L<F?-1:L>F?1:0}equals(b){if(b.type===this.type){const L=this.f?this.f.source:"",F=b.f?b.f.source:"";return this.d===b.d&&L===F}return!1}substituteConstants(){return this}evaluate(b){const L=b.getValue(this.d);return this.f?this.f.test(L):!1}serialize(){const b=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${b}`}keys(){return[this.d]}map(b){return b.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=x.create(this)),this.c}}t.$Sj=de;class x{static create(b){return new x(b)}constructor(b){this.c=b,this.type=h.NotRegex}cmp(b){return b.type!==this.type?this.type-b.type:this.c.cmp(b.c)}equals(b){return b.type===this.type?this.c.equals(b.c):!1}substituteConstants(){return this}evaluate(b){return!this.c.evaluate(b)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(b){return new x(this.c.map(b))}negate(){return this.c}}t.$Tj=x;function _(V){let b=null;for(let L=0,F=V.length;L<F;L++){const z=V[L].substituteConstants();if(V[L]!==z&&b===null){b=[];for(let Z=0;Z<L;Z++)b[Z]=V[Z]}b!==null&&(b[L]=z)}return b===null?V:b}class B{static create(b,L,F){return B.d(b,L,F)}constructor(b,L){this.expr=b,this.c=L,this.type=h.And}cmp(b){if(b.type!==this.type)return this.type-b.type;if(this.expr.length<b.expr.length)return-1;if(this.expr.length>b.expr.length)return 1;for(let L=0,F=this.expr.length;L<F;L++){const z=s(this.expr[L],b.expr[L]);if(z!==0)return z}return 0}equals(b){if(b.type===this.type){if(this.expr.length!==b.expr.length)return!1;for(let L=0,F=this.expr.length;L<F;L++)if(!this.expr[L].equals(b.expr[L]))return!1;return!0}return!1}substituteConstants(){const b=_(this.expr);return b===this.expr?this:B.create(b,this.c,!1)}evaluate(b){for(let L=0,F=this.expr.length;L<F;L++)if(!this.expr[L].evaluate(b))return!1;return!0}static d(b,L,F){const z=[];let Z=!1;for(const Q of b)if(Q){if(Q.type===h.True){Z=!0;continue}if(Q.type===h.False)return o.INSTANCE;if(Q.type===h.And){z.push(...Q.expr);continue}z.push(Q)}if(z.length===0&&Z)return d.INSTANCE;if(z.length!==0){if(z.length===1)return z[0];z.sort(s);for(let Q=1;Q<z.length;Q++)z[Q-1].equals(z[Q])&&(z.splice(Q,1),Q--);if(z.length===1)return z[0];for(;z.length>1;){const Q=z[z.length-1];if(Q.type!==h.Or)break;z.pop();const se=z.pop(),he=z.length===0,ue=U.create(Q.expr.map(Ee=>B.create([Ee,se],null,F)),null,he);ue&&(z.push(ue),z.sort(s))}if(z.length===1)return z[0];if(F){for(let Q=0;Q<z.length;Q++)for(let se=Q+1;se<z.length;se++)if(z[Q].negate().equals(z[se]))return o.INSTANCE;if(z.length===1)return z[0]}return new B(z,L)}}serialize(){return this.expr.map(b=>b.serialize()).join(" && ")}keys(){const b=[];for(const L of this.expr)b.push(...L.keys());return b}map(b){return new B(this.expr.map(L=>L.map(b)),null)}negate(){if(!this.c){const b=[];for(const L of this.expr)b.push(L.negate());this.c=U.create(b,this,!0)}return this.c}}t.$Uj=B;class U{static create(b,L,F){return U.d(b,L,F)}constructor(b,L){this.expr=b,this.c=L,this.type=h.Or}cmp(b){if(b.type!==this.type)return this.type-b.type;if(this.expr.length<b.expr.length)return-1;if(this.expr.length>b.expr.length)return 1;for(let L=0,F=this.expr.length;L<F;L++){const z=s(this.expr[L],b.expr[L]);if(z!==0)return z}return 0}equals(b){if(b.type===this.type){if(this.expr.length!==b.expr.length)return!1;for(let L=0,F=this.expr.length;L<F;L++)if(!this.expr[L].equals(b.expr[L]))return!1;return!0}return!1}substituteConstants(){const b=_(this.expr);return b===this.expr?this:U.create(b,this.c,!1)}evaluate(b){for(let L=0,F=this.expr.length;L<F;L++)if(this.expr[L].evaluate(b))return!0;return!1}static d(b,L,F){let z=[],Z=!1;if(b){for(let Q=0,se=b.length;Q<se;Q++){const he=b[Q];if(he){if(he.type===h.False){Z=!0;continue}if(he.type===h.True)return d.INSTANCE;if(he.type===h.Or){z=z.concat(he.expr);continue}z.push(he)}}if(z.length===0&&Z)return o.INSTANCE;z.sort(s)}if(z.length!==0){if(z.length===1)return z[0];for(let Q=1;Q<z.length;Q++)z[Q-1].equals(z[Q])&&(z.splice(Q,1),Q--);if(z.length===1)return z[0];if(F){for(let Q=0;Q<z.length;Q++)for(let se=Q+1;se<z.length;se++)if(z[Q].negate().equals(z[se]))return d.INSTANCE;if(z.length===1)return z[0]}return new U(z,L)}}serialize(){return this.expr.map(b=>b.serialize()).join(" || ")}keys(){const b=[];for(const L of this.expr)b.push(...L.keys());return b}map(b){return new U(this.expr.map(L=>L.map(b)),null)}negate(){if(!this.c){const b=[];for(const L of this.expr)b.push(L.negate());for(;b.length>1;){const L=b.shift(),F=b.shift(),z=[];for(const Z of G(L))for(const Q of G(F))z.push(B.create([Z,Q],null,!1));b.unshift(U.create(z,null,!1))}this.c=U.create(b,this,!0)}return this.c}}t.$Vj=U;class J extends S{static{this.d=[]}static all(){return J.d.values()}constructor(b,L,F){super(b,null),this.f=L,typeof F=="object"?J.d.push({...F,key:b}):F!==!0&&J.d.push({key:b,description:F,type:L!=null?typeof L:void 0})}bindTo(b){return b.createKey(this.key,this.f)}getValue(b){return b.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(b){return N.create(this.key,b)}notEqualsTo(b){return T.create(this.key,b)}}t.$Wj=J,t.$Xj=(0,A.$Fi)("contextKeyService");function X(V,b){return V<b?-1:V>b?1:0}function ee(V,b,L,F){return V<L?-1:V>L?1:b<F?-1:b>F?1:0}function j(V,b){if(V.type===h.False||b.type===h.True)return!0;if(V.type===h.Or)return b.type===h.Or?q(V.expr,b.expr):!1;if(b.type===h.Or){for(const L of b.expr)if(j(V,L))return!0;return!1}if(V.type===h.And){if(b.type===h.And)return q(b.expr,V.expr);for(const L of V.expr)if(j(L,b))return!0;return!1}return V.equals(b)}function q(V,b){let L=0,F=0;for(;L<V.length&&F<b.length;){const z=V[L].cmp(b[F]);if(z<0)return!1;z===0&&L++,F++}return L===V.length}function G(V){return V.type===h.Or?V.expr:[V]}}),define(re[61],oe([0,1,11]),function(H,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Wo=void 0,t.$Wo=(0,E.$Fi)("downloadService")}),define(re[18],oe([0,1,11]),function(H,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Ni=t.$Mi=void 0,t.$Mi=(0,E.$Fi)("environmentService"),t.$Ni=(0,E.$Gi)(t.$Mi)}),define(re[62],oe([0,1,14,9,107,10]),function(H,t,E,P,y,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Uq=A;async function A(l,u,h,w,m,R){let p;try{await k(l,u,h,w,m,R)}catch(f){p=f}finally{p&&m.errorTransformer&&(p=m.errorTransformer(p)),typeof p<"u"&&h.error(p),h.end()}}async function k(l,u,h,w,m,R){g(R);const p=await l.open(u,{create:!1});try{g(R);let f=0,$=0,I=m&&typeof m.length=="number"?m.length:void 0,v=E.$Oe.alloc(Math.min(m.bufferSize,typeof I=="number"?I:m.bufferSize)),e=m&&typeof m.position=="number"?m.position:0,a=0;do $=await l.read(p,e,v.buffer,a,v.byteLength-a),e+=$,a+=$,f+=$,typeof I=="number"&&(I-=$),a===v.byteLength&&(await h.write(w(v)),v=E.$Oe.alloc(Math.min(m.bufferSize,typeof I=="number"?I:m.bufferSize)),a=0);while($>0&&(typeof I!="number"||I>0)&&g(R)&&c(f,m));if(a>0){let n=a;typeof I=="number"&&(n=Math.min(a,I)),h.write(w(v.slice(0,n)))}}catch(f){throw(0,O.$nl)(f)}finally{await l.close(p)}}function g(l){if(l.isCancellationRequested)throw(0,P.$8)();return!0}function c(l,u){if(typeof u?.limits?.size=="number"&&l>u.limits.size)throw(0,O.$ml)((0,y.localize)(0,null),O.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(re[125],oe([0,1,94,2,52,5,10,12,8]),function(H,t,E,P,y,O,A,k,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$dr=void 0;class c extends P.$Wc{constructor(){super(),this.a=this.B(new O.$me),this.onDidChangeFile=this.a.event,this.b=this.B(new O.$me),this.onDidLogMessage=this.b.event,this.c=this.B(new O.$me),this.f=this.c.event,this.g=new Set,this.h=new Map,this.j=this.B(new P.$6c),this.m=new Set,this.n=this.B(new g.$Dh(this.y())),this.r=5007,this.s=new g.$3h,this.R=!1,this.B(this.f(u=>this.t(u)))}t(u){this.u(u)&&this.z(u)}u(u){return(0,y.$Wq)(u)}async watch(u){this.s.isSettled||this.s.complete(),this.s=new g.$3h;try{this.h.clear(),this.g.clear();for(const h of u)this.u(h)?this.h.set(h.correlationId,h):this.g.add(h);for(const[h]of this.j)this.h.has(h)||(this.j.deleteAndDispose(h),this.m.delete(h));return await this.w(!1)}finally{this.s.complete()}}w(u){return this.n.trigger(()=>this.N([...this.g,...Array.from(this.h.values()).filter(h=>!this.j.has(h.correlationId))]),u?this.y():0)}y(){return 800}isSuspended(u){return typeof u.correlationId!="number"?!1:this.m.has(u.correlationId)?"polling":this.j.has(u.correlationId)}async z(u){if(this.j.has(u.correlationId))return;const h=new P.$Vc;this.j.set(u.correlationId,h),await this.s.p,!h.isDisposed&&(this.D(u,h),this.w(!0))}C(u){this.j.deleteAndDispose(u.correlationId),this.m.delete(u.correlationId),this.w(!1)}D(u,h){this.F(u,h)?(this.P(`reusing an existing recursive watcher to monitor ${u.path}`),this.m.delete(u.correlationId)):(this.G(u,h),this.m.add(u.correlationId))}F(u,h){const w=this.O?.subscribe(u.path,(m,R)=>{h.isDisposed||(m?this.D(u,h):R?.type===A.FileChangeType.ADDED&&this.H(u))});return w?(h.add(w),!0):!1}G(u,h){let w=!1;const m=(R,p)=>{if(h.isDisposed)return;const f=this.I(R),$=this.I(p),I=w;w=f,!f&&($||I)&&this.H(u)};this.P(`starting fs.watchFile() on ${u.path} (correlationId: ${u.correlationId})`);try{(0,E.watchFile)(u.path,{persistent:!1,interval:this.r},m)}catch(R){this.Q(`fs.watchFile() failed with error ${R} on path ${u.path} (correlationId: ${u.correlationId})`)}h.add((0,P.$Uc)(()=>{this.P(`stopping fs.watchFile() on ${u.path} (correlationId: ${u.correlationId})`);try{(0,E.unwatchFile)(u.path,m)}catch(R){this.Q(`fs.unwatchFile() failed with error ${R} on path ${u.path} (correlationId: ${u.correlationId})`)}}))}H(u){this.P(`detected ${u.path} exists again, resuming watcher (correlationId: ${u.correlationId})`);const h={resource:k.URI.file(u.path),type:A.FileChangeType.ADDED,cId:u.correlationId};this.a.fire([h]),this.J(h,u),this.C(u)}I(u){return u.ctimeMs===0&&u.ino===0}async stop(){this.j.clearAndDisposeAll(),this.m.clear()}J(u,h){if(this.R){const w=` >> normalized ${u.type===A.FileChangeType.ADDED?"[ADDED]":u.type===A.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${u.resource.fsPath}`;this.L(w,h)}}L(u,h){this.R&&this.P(`${u}${typeof h.correlationId=="number"?` <${h.correlationId}> `:""}`)}M(u){return`${u.path} (excludes: ${u.excludes.length>0?u.excludes:"<none>"}, includes: ${u.includes&&u.includes.length>0?JSON.stringify(u.includes):"<all>"}, filter: ${(0,y.$7q)(u.filter)}, correlationId: ${typeof u.correlationId=="number"?u.correlationId:"<none>"})`}async setVerboseLogging(u){this.R=u}}t.$dr=c}),define(re[126],oe([0,1,5,173,125,13,174,63]),function(H,t,E,P,y,O,A,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$kr=void 0;class g extends y.$dr{constructor(l){super(),this.O=l,this.onDidError=E.Event.None,this.watchers=new Set}async N(l){l=this.Z(l);const u=[],h=new Set(Array.from(this.watchers));for(const w of l){const m=this.W(w);m&&(0,P.$Dk)(m.request.excludes,w.excludes)&&(0,P.$Dk)(m.request.includes,w.includes)?h.delete(m):u.push(w)}u.length&&this.P(`Request to start watching: ${u.map(w=>this.M(w)).join(",")}`),h.size&&this.P(`Request to stop watching: ${Array.from(h).map(w=>this.M(w.request)).join(",")}`);for(const w of h)this.Y(w);for(const w of u)this.X(w)}W(l){for(const u of this.watchers)if(typeof l.correlationId=="number"||typeof u.request.correlationId=="number"){if(u.request.correlationId===l.correlationId)return u}else if((0,k.$Dg)(u.request.path,l.path,!O.$k))return u}X(l){const u=new A.$ir(l,this.O,w=>this.a.fire(w),()=>this.c.fire(l),w=>this.b.fire(w),this.R),h={request:l,instance:u};this.watchers.add(h)}async stop(){await super.stop();for(const l of this.watchers)this.Y(l)}Y(l){this.P("stopping file watcher",l),this.watchers.delete(l),l.instance.dispose()}Z(l){const u=new Map;for(const h of l){const w=O.$k?h.path:h.path.toLowerCase();let m=u.get(h.correlationId);m||(m=new Map,u.set(h.correlationId,m)),m.has(w)&&this.P(`ignoring a request for watching who's path is already watched: ${this.M(h)}`),m.set(w,h)}return Array.from(u.values()).map(h=>Array.from(h.values())).flat()}async setVerboseLogging(l){super.setVerboseLogging(l);for(const u of this.watchers)u.instance.setVerboseLogging(l)}P(l,u){this.R&&this.b.fire({type:"trace",message:this.bb(l,u)})}Q(l){this.b.fire({type:"warn",message:this.bb(l)})}bb(l,u){return u?`[File Watcher (node.js)] ${l} (${this.M(u.request)})`:`[File Watcher (node.js)] ${l}`}}t.$kr=g}),define(re[127],oe([0,1,52,126]),function(H,t,E,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$lr=void 0;class y extends E.$Zq{constructor(A,k,g){super(A,k,g),this.s()}r(A){return A.add(new P.$kr(void 0))}}t.$lr=y}),define(re[128],oe([0,1,15,59,91,52]),function(H,t,E,P,y,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$cr=void 0;class A extends O.$1q{constructor(g,c,l){super(g,c,l),this.s()}r(g){const c=g.add(new y.$br(E.$Zg.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return g.add(c.onDidProcessExit(({code:l,signal:u})=>this.t(`terminated by itself with code ${l}, signal: ${u} (ETERM)`))),P.ProxyChannel.toService((0,P.$mi)(c.getChannel("watcher")))}}t.$cr=A}),define(re[64],oe([0,1]),function(H,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Di=void 0;class E{constructor(...y){this.a=new Map;for(const[O,A]of y)this.set(O,A)}set(y,O){const A=this.a.get(y);return this.a.set(y,O),A}has(y){return this.a.has(y)}get(y){return this.a.get(y)}}t.$Di=E}),define(re[129],oe([0,1,8,9,2,51,123,11,64,175]),function(H,t,E,P,y,O,A,k,g,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$qr=t.$pr=void 0;const l=!1;class u extends Error{constructor(p){super("cyclic dependency between services"),this.message=p.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${p.toString()}`}}class h{constructor(p=new g.$Di,f=!1,$,I=l){this.i=p,this.j=f,this.k=$,this.l=I,this.f=!1,this.g=new Set,this.h=new Set,this.t=new Set,this.i.set(k.$Ei,this),this._globalGraph=I?$?._globalGraph??new A.$or(v=>v):void 0}dispose(){if(!this.f){this.f=!0,(0,y.$Rc)(this.h),this.h.clear();for(const p of this.g)(0,y.$Qc)(p)&&p.dispose();this.g.clear()}}m(){if(this.f)throw new Error("InstantiationService has been disposed")}createChild(p,f){this.m();const $=this,I=new class extends h{dispose(){$.h.delete(I),super.dispose()}}(p,this.j,this,this.l);return this.h.add(I),f?.add(I),I}invokeFunction(p,...f){this.m();const $=m.traceInvocation(this.l,p);let I=!1;try{return p({get:e=>{if(I)throw(0,P.$0)("service accessor is only valid during the invocation of its target method");const a=this.s(e,$);if(!a)throw new Error(`[invokeFunction] unknown service '${e}'`);return a}},...f)}finally{I=!0,$.stop()}}createInstance(p,...f){this.m();let $,I;return p instanceof O.$Ci?($=m.traceCreation(this.l,p.ctor),I=this.o(p.ctor,p.staticArguments.concat(f),$)):($=m.traceCreation(this.l,p),I=this.o(p,f,$)),$.stop(),I}o(p,f=[],$){const I=k._util.getServiceDependencies(p).sort((a,n)=>a.index-n.index),v=[];for(const a of I){const n=this.s(a.id,$);n||this.y(`[createInstance] ${p.name} depends on UNKNOWN service ${a.id}.`,!1),v.push(n)}const e=I.length>0?I[0].index:f.length;if(f.length!==e){console.trace(`[createInstance] First service dependency of ${p.name} at position ${e+1} conflicts with ${f.length} static arguments`);const a=e-f.length;a>0?f=f.concat(new Array(a)):f=f.slice(0,e)}return Reflect.construct(p,f.concat(v))}q(p,f){if(this.i.get(p)instanceof O.$Ci)this.i.set(p,f);else if(this.k)this.k.q(p,f);else throw new Error("illegalState - setting UNKNOWN service instance")}r(p){const f=this.i.get(p);return!f&&this.k?this.k.r(p):f}s(p,f){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(p));const $=this.r(p);return $ instanceof O.$Ci?this.u(p,$,f.branch(p,!0)):(f.branch(p,!1),$)}u(p,f,$){if(this.t.has(p))throw new Error(`illegal state - RECURSIVELY instantiating service '${p}'`);this.t.add(p);try{return this.v(p,f,$)}finally{this.t.delete(p)}}v(p,f,$){const I=new A.$or(a=>a.id.toString());let v=0;const e=[{id:p,desc:f,_trace:$}];for(;e.length;){const a=e.pop();if(I.lookupOrInsertNode(a),v++>1e3)throw new u(I);for(const n of k._util.getServiceDependencies(a.desc.ctor)){const r=this.r(n.id);if(r||this.y(`[createInstance] ${p} depends on ${n.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(a.id),String(n.id)),r instanceof O.$Ci){const i={id:n.id,desc:r,_trace:a._trace.branch(n.id,!0)};I.insertEdge(a,i),e.push(i)}}}for(;;){const a=I.roots();if(a.length===0){if(!I.isEmpty())throw new u(I);break}for(const{data:n}of a){if(this.r(n.id)instanceof O.$Ci){const i=this.w(n.id,n.desc.ctor,n.desc.staticArguments,n.desc.supportsDelayedInstantiation,n._trace);this.q(n.id,i)}I.removeNode(n)}}return this.r(p)}w(p,f,$=[],I,v){if(this.i.get(p)instanceof O.$Ci)return this.x(p,f,$,I,v,this.g);if(this.k)return this.k.w(p,f,$,I,v);throw new Error(`illegalState - creating UNKNOWN service instance ${f.name}`)}x(p,f,$=[],I,v,e){if(I){const a=new h(void 0,this.j,this,this.l);a.c=String(p);const n=new Map,r=new E.$Yh(()=>{const i=a.o(f,$,v);for(const[s,o]of n){const d=i[s];if(typeof d=="function")for(const S of o)S.disposable=d.apply(i,S.listener)}return n.clear(),e.add(i),i});return new Proxy(Object.create(null),{get(i,s){if(!r.isInitialized&&typeof s=="string"&&(s.startsWith("onDid")||s.startsWith("onWill"))){let S=n.get(s);return S||(S=new c.$7c,n.set(s,S)),(C,D,T)=>{if(r.isInitialized)return r.value[s](C,D,T);{const M={listener:[C,D,T],disposable:void 0},K=S.push(M);return(0,y.$Uc)(()=>{K(),M.disposable?.dispose()})}}}if(s in i)return i[s];const o=r.value;let d=o[s];return typeof d!="function"||(d=d.bind(o),i[s]=d),d},set(i,s,o){return r.value[s]=o,!0},getPrototypeOf(i){return f.prototype}})}else{const a=this.o(f,$,v);return e.add(a),a}}y(p,f){if(f&&console.warn(p),this.j)throw new Error(p)}}t.$pr=h;var w;(function(R){R[R.None=0]="None",R[R.Creation=1]="Creation",R[R.Invocation=2]="Invocation",R[R.Branch=3]="Branch"})(w||(w={}));class m{static{this.all=new Set}static{this.c=new class extends m{constructor(){super(w.None,null)}stop(){}branch(){return this}}}static traceInvocation(p,f){return p?new m(w.Invocation,f.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):m.c}static traceCreation(p,f){return p?new m(w.Creation,f.name):m.c}static{this.f=0}constructor(p,f){this.type=p,this.name=f,this.g=Date.now(),this.h=[]}branch(p,f){const $=new m(w.Branch,p.toString());return this.h.push([p,f,$]),$}stop(){const p=Date.now()-this.g;m.f+=p;let f=!1;function $(v,e){const a=[],n=new Array(v+1).join("	");for(const[r,i,s]of e.h)if(i&&s){f=!0,a.push(`${n}CREATES -> ${r}`);const o=$(v+1,s);o&&a.push(o)}else a.push(`${n}uses -> ${r}`);return a.join(`
`)}const I=[`${this.type===w.Creation?"CREATE":"CALL"} ${this.name}`,`${$(1,this)}`,`DONE, took ${p.toFixed(2)}ms (grand total ${m.f.toFixed(2)}ms)`];(p>2||f)&&m.all.add(I.join(`
`))}}t.$qr=m}),define(re[6],oe([0,1,110,38,5,43,2,31,13,17,3,12,124,11]),function(H,t,E,P,y,O,A,k,g,c,l,u,h,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$rk=t.$mk=t.$lk=t.$kk=t.$jk=t.$ik=t.$hk=t.$gk=t.$fk=t.$ek=t.$ck=t.LogLevel=t.$ak=t.$_j=void 0,t.$bk=R,t.log=f,t.$nk=d,t.$ok=S,t.$pk=N,t.$qk=C,E=ye(E),t.$_j=(0,w.$Fi)("logService"),t.$ak=(0,w.$Fi)("loggerService");function m(){return new Date().toISOString()}function R(D){return(0,l.$jg)(D)}var p;(function(D){D[D.Off=0]="Off",D[D.Trace=1]="Trace",D[D.Debug=2]="Debug",D[D.Info=3]="Info",D[D.Warning=4]="Warning",D[D.Error=5]="Error"})(p||(t.LogLevel=p={})),t.$ck=p.Info;function f(D,T,M){switch(T){case p.Trace:D.trace(M);break;case p.Debug:D.debug(M);break;case p.Info:D.info(M);break;case p.Warning:D.warn(M);break;case p.Error:D.error(M);break;case p.Off:break;default:throw new Error(`Invalid log level ${T}`)}}function $(D,T=!1){let M="";for(let K=0;K<D.length;K++){let Y=D[K];if(Y instanceof Error&&(Y=(0,P.$qj)(Y,T)),typeof Y=="object")try{Y=JSON.stringify(Y)}catch{}M+=(K>0?" ":"")+Y}return M}class I extends A.$Wc{constructor(){super(...arguments),this.b=t.$ck,this.c=this.B(new y.$me),this.onDidChangeLogLevel=this.c.event}setLevel(T){this.b!==T&&(this.b=T,this.c.fire(this.b))}getLevel(){return this.b}f(T){return this.b!==p.Off&&this.b<=T}}t.$ek=I;class v extends I{constructor(T){super(),this.h=T}f(T){return this.h||super.f(T)}trace(T,...M){this.f(p.Trace)&&this.g(p.Trace,$([T,...M],!0))}debug(T,...M){this.f(p.Debug)&&this.g(p.Debug,$([T,...M]))}info(T,...M){this.f(p.Info)&&this.g(p.Info,$([T,...M]))}warn(T,...M){this.f(p.Warning)&&this.g(p.Warning,$([T,...M]))}error(T,...M){if(this.f(p.Error))if(T instanceof Error){const K=Array.prototype.slice.call(arguments);K[0]=T.stack,this.g(p.Error,$(K))}else this.g(p.Error,$([T,...M]))}flush(){}}t.$fk=v;class e extends I{constructor(T=t.$ck){super(),this.setLevel(T),this.g=!g.$i}trace(T,...M){this.f(p.Trace)&&(this.g?console.log(`\x1B[90m[main ${m()}]\x1B[0m`,T,...M):console.log(`[main ${m()}]`,T,...M))}debug(T,...M){this.f(p.Debug)&&(this.g?console.log(`\x1B[90m[main ${m()}]\x1B[0m`,T,...M):console.log(`[main ${m()}]`,T,...M))}info(T,...M){this.f(p.Info)&&(this.g?console.log(`\x1B[90m[main ${m()}]\x1B[0m`,T,...M):console.log(`[main ${m()}]`,T,...M))}warn(T,...M){this.f(p.Warning)&&(this.g?console.warn(`\x1B[93m[main ${m()}]\x1B[0m`,T,...M):console.warn(`[main ${m()}]`,T,...M))}error(T,...M){this.f(p.Error)&&(this.g?console.error(`\x1B[91m[main ${m()}]\x1B[0m`,T,...M):console.error(`[main ${m()}]`,T,...M))}flush(){}}t.$gk=e;class a extends I{constructor(T=t.$ck,M=!0){super(),this.g=M,this.setLevel(T)}trace(T,...M){this.f(p.Trace)&&(this.g?console.log("%cTRACE","color: #888",T,...M):console.log(T,...M))}debug(T,...M){this.f(p.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",T,...M):console.log(T,...M))}info(T,...M){this.f(p.Info)&&(this.g?console.log("%c INFO","color: #33f",T,...M):console.log(T,...M))}warn(T,...M){this.f(p.Warning)&&(this.g?console.log("%c WARN","color: #993",T,...M):console.log(T,...M))}error(T,...M){this.f(p.Error)&&(this.g?console.log("%c  ERR","color: #f33",T,...M):console.error(T,...M))}flush(){}}t.$hk=a;class n extends I{constructor(T,M=t.$ck){super(),this.g=T,this.setLevel(M)}trace(T,...M){this.f(p.Trace)&&this.g.log(p.Trace,[this.h(T),...M])}debug(T,...M){this.f(p.Debug)&&this.g.log(p.Debug,[this.h(T),...M])}info(T,...M){this.f(p.Info)&&this.g.log(p.Info,[this.h(T),...M])}warn(T,...M){this.f(p.Warning)&&this.g.log(p.Warning,[this.h(T),...M])}error(T,...M){this.f(p.Error)&&this.g.log(p.Error,[this.h(T),...M])}h(T){return typeof T=="string"?T:(0,P.$qj)(T,this.f(p.Trace))}flush(){}}t.$ik=n;class r extends I{constructor(T){super(),this.g=T,T.length&&this.setLevel(T[0].getLevel())}setLevel(T){for(const M of this.g)M.setLevel(T);super.setLevel(T)}trace(T,...M){for(const K of this.g)K.trace(T,...M)}debug(T,...M){for(const K of this.g)K.debug(T,...M)}info(T,...M){for(const K of this.g)K.info(T,...M)}warn(T,...M){for(const K of this.g)K.warn(T,...M)}error(T,...M){for(const K of this.g)K.error(T,...M)}flush(){for(const T of this.g)T.flush()}dispose(){for(const T of this.g)T.dispose();super.dispose()}}t.$jk=r;class i extends A.$Wc{constructor(T,M,K){if(super(),this.h=T,this.j=M,this.b=new k.$Cc,this.c=this.B(new y.$me),this.onDidChangeLoggers=this.c.event,this.f=this.B(new y.$me),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new y.$me),this.onDidChangeVisibility=this.g.event,K)for(const Y of K)this.b.set(Y.resource,{logger:void 0,info:Y})}m(T){return(0,l.$fg)(T)?[...this.b.values()].find(M=>M.info.id===T):this.b.get(T)}getLogger(T){return this.m(T)?.logger}createLogger(T,M){const K=this.n(T),Y=(0,l.$fg)(T)?T:M?.id??(0,O.$tj)(K.toString()).toString(16);let ae=this.b.get(K)?.logger;const le=M?.logLevel==="always"?p.Trace:M?.logLevel;ae||(ae=this.s(K,le??this.getLogLevel(K)??this.h,{...M,id:Y}));const ce={logger:ae,info:{resource:K,id:Y,logLevel:le,name:M?.name,hidden:M?.hidden,extensionId:M?.extensionId,when:M?.when}};return this.registerLogger(ce.info),this.b.set(K,ce),ae}n(T){return(0,l.$fg)(T)?(0,c.$gh)(this.j,`${T}.log`):T}setLogLevel(T,M){if(u.URI.isUri(T)){const K=T,Y=M,ae=this.b.get(K);ae&&Y!==ae.info.logLevel&&(ae.info.logLevel=Y===this.h?void 0:Y,ae.logger?.setLevel(Y),this.b.set(ae.info.resource,ae),this.f.fire([K,Y]))}else{this.h=T;for(const[K,Y]of this.b.entries())this.b.get(K)?.info.logLevel===void 0&&Y.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(T,M){const K=this.m(T);K&&M!==!K.info.hidden&&(K.info.hidden=!M,this.b.set(K.info.resource,K),this.g.fire([K.info.resource,M]))}getLogLevel(T){let M;return T&&(M=this.b.get(T)?.info.logLevel),M??this.h}registerLogger(T){const M=this.b.get(T.resource);M?M.info.hidden!==T.hidden&&this.setVisibility(T.resource,!T.hidden):(this.b.set(T.resource,{info:T,logger:void 0}),this.c.fire({added:[T],removed:[]}))}deregisterLogger(T){const M=this.b.get(T);M&&(M.logger&&M.logger.dispose(),this.b.delete(T),this.c.fire({added:[],removed:[M.info]}))}*getRegisteredLoggers(){for(const T of this.b.values())yield T.info}getRegisteredLogger(T){return this.b.get(T)?.info}dispose(){this.b.forEach(T=>T.logger?.dispose()),this.b.clear(),super.dispose()}}t.$kk=i;class s{constructor(){this.onDidChangeLogLevel=new y.$me().event}setLevel(T){}getLevel(){return p.Info}trace(T,...M){}debug(T,...M){}info(T,...M){}warn(T,...M){}error(T,...M){}critical(T,...M){}dispose(){}flush(){}}t.$lk=s;class o extends s{}t.$mk=o;function d(D){if(D.verbose)return p.Trace;if(typeof D.logLevel=="string"){const T=C(D.logLevel.toLowerCase());if(T!==void 0)return T}return t.$ck}function S(D){switch(D){case p.Trace:return"trace";case p.Debug:return"debug";case p.Info:return"info";case p.Warning:return"warn";case p.Error:return"error";case p.Off:return"off"}}function N(D){switch(D){case p.Trace:return{original:"Trace",value:E.localize(0,null)};case p.Debug:return{original:"Debug",value:E.localize(1,null)};case p.Info:return{original:"Info",value:E.localize(2,null)};case p.Warning:return{original:"Warning",value:E.localize(3,null)};case p.Error:return{original:"Error",value:E.localize(4,null)};case p.Off:return{original:"Off",value:E.localize(5,null)}}}function C(D){switch(D){case"trace":return p.Trace;case"debug":return p.Debug;case"info":return p.Info;case"warn":return p.Warning;case"error":return p.Error;case"critical":return p.Error;case"off":return p.Off}}t.$rk=new h.$Wj("logLevel",S(p.Info))}),define(re[130],oe([0,1,20,8,9,5,63,2,16,52,6]),function(H,t,E,P,y,O,A,k,g,c,l){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$8q=void 0;class u extends k.$Wc{constructor(w,m){super(),this.a=w,this.b=m,this.c=this.B(new O.$me),this.onDidChangeFile=this.c.event,this.g=this.B(new O.$me),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new P.$Dh(0)),this.w=[],this.y=this.B(new P.$Dh(0))}watch(w,m){return m.recursive||this.b?.watcher?.forceUniversal?this.n(w,m):this.z(w,m)}n(w,m){const R={path:this.J(w),excludes:m.excludes,includes:m.includes,recursive:m.recursive,filter:m.filter,correlationId:m.correlationId},p=(0,E.$Vb)(this.j,R);return this.r(),(0,k.$Uc)(()=>{p(),this.r()})}r(){this.m.trigger(()=>this.s()).catch(w=>(0,y.$3)(w))}s(){this.h||(this.h=this.B(this.t(m=>this.c.fire((0,c.$2q)(m)),m=>this.G(m),this.a.getLevel()===l.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===l.LogLevel.Trace)})));const w=this.b?.watcher?.recursive?.usePolling;if(w===!0)for(const m of this.j)(0,c.$Xq)(m)&&(m.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(w))for(const m of this.j)(0,c.$Xq)(m)&&w.includes(m.path)&&(m.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z(w,m){const R={path:this.J(w),excludes:m.excludes,includes:m.includes,recursive:!1,filter:m.filter,correlationId:m.correlationId},p=(0,E.$Vb)(this.w,R);return this.C(),(0,k.$Uc)(()=>{p(),this.C()})}C(){this.y.trigger(()=>this.D()).catch(w=>(0,y.$3)(w))}D(){return this.u||(this.u=this.B(this.F(w=>this.c.fire((0,c.$2q)(w)),w=>this.G(w),this.a.getLevel()===l.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===l.LogLevel.Trace)}))),this.u.watch(this.w)}G(w){w.type==="error"&&this.g.fire(w.message),this.H(w)}H(w){this.a[w.type](w.message)}I(w){return(0,g.$jc)(w.fsPath)}J(w){const m=this.I(w);return(0,A.$Hg)(m)}}t.$8q=u});var ne=this&&this.__param||function(H,t){return function(E,P){t(E,P,H)}};define(re[131],oe([0,1,20,8,14,22,5,43,65,2,48,15,132,17,46,106,10,62,6,9]),function(H,t,E,P,y,O,A,k,g,c,l,u,h,w,m,R,p,f,$,I){"use strict";var v;Object.defineProperty(t,"__esModule",{value:!0}),t.$Vq=void 0;let e=class extends c.$Wc{static{v=this}constructor(n){super(),this.b=n,this.a=256*1024,this.c=this.B(new A.$me),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new A.$me),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new A.$me),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.r=this.B(new A.$me),this.onDidRunOperation=this.r.event,this.X=this.B(new A.$me),this.Y=this.B(new A.$me),this.onDidFilesChange=this.Y.event,this.Z=this.B(new A.$me),this.onDidWatchError=this.Z.event,this.$=new Map,this.cb=this.B(new P.$Oh)}registerProvider(n,r){if(this.h.has(n))throw new Error(`A filesystem provider for the scheme '${n}' is already registered.`);(0,h.mark)(`code/registerFilesystem/${n}`);const i=new c.$Vc;return this.h.set(n,r),this.c.fire({added:!0,scheme:n,provider:r}),i.add(r.onDidChangeFile(s=>{const o=new p.$sl(s,!this.S(r));this.X.fire(o),o.hasCorrelation()||this.Y.fire(o)})),typeof r.onDidWatchError=="function"&&i.add(r.onDidWatchError(s=>this.Z.fire(new Error(s)))),i.add(r.onDidChangeCapabilities(()=>this.g.fire({provider:r,scheme:n}))),(0,c.$Uc)(()=>{this.c.fire({added:!1,scheme:n,provider:r}),this.h.delete(n),(0,c.$Rc)(i)})}getProvider(n){return this.h.get(n)}async activateProvider(n){const r=[];this.f.fire({scheme:n,join(i){r.push(i)}}),!this.h.has(n)&&await P.Promises.settled(r)}async canHandleResource(n){return await this.activateProvider(n.scheme),this.hasProvider(n)}hasProvider(n){return this.h.has(n.scheme)}hasCapability(n,r){const i=this.h.get(n.scheme);return!!(i&&i.capabilities&r)}listCapabilities(){return g.Iterable.map(this.h,([n,r])=>({scheme:n,capabilities:r.capabilities}))}async j(n){if(!(0,w.$kh)(n))throw new p.$ul((0,R.localize)(0,null,this.sb(n)),p.FileOperationResult.FILE_INVALID_PATH);await this.activateProvider(n.scheme);const r=this.h.get(n.scheme);if(!r){const i=new I.$db;throw i.message=(0,R.localize)(1,null,n.toString()),i}return r}async m(n){const r=await this.j(n);if((0,p.$fl)(r)||(0,p.$cl)(r)||(0,p.$gl)(r))return r;throw new Error(`Filesystem provider for scheme '${n.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async n(n){const r=await this.j(n);if((0,p.$fl)(r)||(0,p.$cl)(r))return r;throw new Error(`Filesystem provider for scheme '${n.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(n,r){try{return await this.s(n,r)}catch(i){throw(0,p.$pl)(i)===p.FileSystemProviderErrorCode.FileNotFound?new p.$ul((0,R.localize)(2,null,this.sb(n)),p.FileOperationResult.FILE_NOT_FOUND):(0,p.$nl)(i)}}async s(n,r){const i=await this.j(n),s=this.S(i),o=r?.resolveTo,d=r?.resolveSingleChildDescendants,S=r?.resolveMetadata,N=await i.stat(n);let C;return this.t(i,n,N,void 0,!!S,(D,T)=>(C||(C=l.$Li.forUris(()=>!s),C.set(n,!0),o&&C.fill(!0,o)),C.get(D.resource)||C.findSuperstr(D.resource.with({query:null,fragment:null}))?!0:D.isDirectory&&d?T===1:!1))}async t(n,r,i,s,o,d){const{providerExtUri:S}=this.R(n),N={resource:r,name:S.basename(r),isFile:(i.type&p.FileType.File)!==0,isDirectory:(i.type&p.FileType.Directory)!==0,isSymbolicLink:(i.type&p.FileType.SymbolicLink)!==0,mtime:i.mtime,ctime:i.ctime,size:i.size,readonly:!!((i.permissions??0)&p.FilePermission.Readonly)||!!(n.capabilities&p.FileSystemProviderCapabilities.Readonly),locked:!!((i.permissions??0)&p.FilePermission.Locked),etag:(0,p.$Fl)({mtime:i.mtime,size:i.size}),children:void 0};if(N.isDirectory&&d(N,s)){try{const C=await n.readdir(r),D=await P.Promises.settled(C.map(async([T,M])=>{try{const K=S.joinPath(r,T),Y=o?await n.stat(K):{type:M};return await this.t(n,K,Y,C.length,o,d)}catch(K){return this.b.trace(K),null}}));N.children=(0,E.$Jb)(D)}catch(C){this.b.trace(C),N.children=[]}return N}return N}async resolveAll(n){return P.Promises.settled(n.map(async r=>{try{return{stat:await this.s(r.resource,r.options),success:!0}}catch(i){return this.b.trace(i),{stat:void 0,success:!1}}}))}async stat(n){const r=await this.j(n),i=await r.stat(n);return this.t(r,n,i,void 0,!0,()=>!1)}async exists(n){const r=await this.j(n);try{return!!await r.stat(n)}catch{return!1}}async canCreateFile(n,r){try{await this.u(n,r)}catch(i){return i}return!0}async u(n,r){if(!r?.overwrite&&await this.exists(n))throw new p.$ul((0,R.localize)(3,null,this.sb(n)),p.FileOperationResult.FILE_MODIFIED_SINCE,r)}async createFile(n,r=y.$Oe.fromString(""),i){await this.u(n,i);const s=await this.writeFile(n,r);return this.r.fire(new p.$rl(n,p.FileOperation.CREATE,s)),s}async writeFile(n,r,i){const s=this.qb(await this.n(n),n),{providerExtUri:o}=this.R(s);let d=i;if((0,p.$il)(s)&&!d?.atomic){const S=s.enforceAtomicWriteFile?.(n);S&&(d={...i,atomic:S})}try{await this.w(s,n,d)||await this.U(s,o.dirname(n));let N;if((0,p.$cl)(s)&&!(r instanceof y.$Oe))if((0,m.$Ae)(r)){const C=await(0,m.$He)(r,3);C.ended?N=y.$Oe.concat(C.buffer):N=C}else N=(0,m.$Ee)(r,C=>y.$Oe.concat(C),3);else N=r;!(0,p.$fl)(s)||(0,p.$cl)(s)&&N instanceof y.$Oe||(0,p.$cl)(s)&&(0,p.$il)(s)&&d?.atomic?await this.hb(s,n,d,N):await this.db(s,n,d,N instanceof y.$Oe?(0,y.$Ze)(N):N),this.r.fire(new p.$rl(n,p.FileOperation.WRITE))}catch(S){throw new p.$ul((0,R.localize)(4,null,this.sb(n),(0,p.$nl)(S).toString()),(0,p.$ql)(S),d)}return this.resolve(n,{resolveMetadata:!0})}async w(n,r,i){const s=!!i?.unlock;if(s&&!(n.capabilities&p.FileSystemProviderCapabilities.FileWriteUnlock))throw new Error((0,R.localize)(5,null,this.sb(r)));if(!!i?.atomic){if(!(n.capabilities&p.FileSystemProviderCapabilities.FileAtomicWrite))throw new Error((0,R.localize)(6,null,this.sb(r)));if(!(n.capabilities&p.FileSystemProviderCapabilities.FileReadWrite))throw new Error((0,R.localize)(7,null,this.sb(r)));if(s)throw new Error((0,R.localize)(8,null,this.sb(r)))}let d;try{d=await n.stat(r)}catch{return}if(d.type&p.FileType.Directory)throw new p.$ul((0,R.localize)(9,null,this.sb(r)),p.FileOperationResult.FILE_IS_DIRECTORY,i);if(this.rb(r,d),typeof i?.mtime=="number"&&typeof i.etag=="string"&&i.etag!==p.$El&&typeof d.mtime=="number"&&typeof d.size=="number"&&i.mtime<d.mtime&&i.etag!==(0,p.$Fl)({mtime:i.mtime,size:d.size}))throw new p.$ul((0,R.localize)(10,null),p.FileOperationResult.FILE_MODIFIED_SINCE,i);return d}async readFile(n,r,i){const s=await this.m(n);return r?.atomic?this.z(s,n,r,i):this.C(s,n,r,i)}async z(n,r,i,s){return new Promise((o,d)=>{this.cb.queueFor(r,async()=>{try{const S=await this.C(n,r,i,s);o(S)}catch(S){d(S)}},this.R(n).providerExtUri)})}async C(n,r,i,s){const o=await this.D(n,r,{...i,preferUnbuffered:!0},s);return{...o,value:await(0,y.$1e)(o.value)}}async readFileStream(n,r,i){const s=await this.m(n);return this.D(s,n,r,i)}async D(n,r,i,s){const o=new O.$xe(s);let d=i;(0,p.$hl)(n)&&n.enforceAtomicReadFile?.(r)&&(d={...i,atomic:!0});const S=this.J(r,d).then(C=>C,C=>{throw o.dispose(!0),C});let N;try{return typeof d?.etag=="string"&&d.etag!==p.$El&&await S,d?.atomic&&(0,p.$hl)(n)||!((0,p.$fl)(n)||(0,p.$gl)(n))||(0,p.$cl)(n)&&d?.preferUnbuffered?N=this.I(n,r,d):(0,p.$gl)(n)?N=this.G(n,r,o.token,d):N=this.H(n,r,o.token,d),N.on("end",()=>o.dispose()),N.on("error",()=>o.dispose()),{...await S,value:N}}catch(C){throw N&&await(0,m.$Fe)(N),this.F(C,r,d)}}F(n,r,i){const s=(0,R.localize)(11,null,this.sb(r),(0,p.$nl)(n).toString());return n instanceof p.$wl?new p.$wl(s,n.stat,i):n instanceof p.$vl?new p.$vl(s,n.fileOperationResult,n.size,n.options):new p.$ul(s,(0,p.$ql)(n),i)}G(n,r,i,s=Object.create(null)){const o=n.readFileStream(r,s,i);return(0,m.$Le)(o,{data:d=>d instanceof y.$Oe?d:y.$Oe.wrap(d),error:d=>this.F(d,r,s)},d=>y.$Oe.concat(d))}H(n,r,i,s=Object.create(null)){const o=(0,y.$5e)();return(0,f.$Uq)(n,r,o,d=>d,{...s,bufferSize:this.a,errorTransformer:d=>this.F(d,r,s)},i),o}I(n,r,i){const s=(0,m.$Ce)(o=>y.$Oe.concat(o));return(async()=>{try{let o;i?.atomic&&(0,p.$hl)(n)?o=await n.readFile(r,{atomic:!0}):o=await n.readFile(r),typeof i?.position=="number"&&(o=o.slice(i.position)),typeof i?.length=="number"&&(o=o.slice(0,i.length)),this.L(r,o.byteLength,i),s.end(y.$Oe.wrap(o))}catch(o){s.error(o),s.end()}})(),s}async J(n,r){const i=await this.resolve(n,{resolveMetadata:!0});if(i.isDirectory)throw new p.$ul((0,R.localize)(12,null,this.sb(n)),p.FileOperationResult.FILE_IS_DIRECTORY,r);if(typeof r?.etag=="string"&&r.etag!==p.$El&&r.etag===i.etag)throw new p.$wl((0,R.localize)(13,null),i,r);return this.L(n,i.size,r),i}L(n,r,i){if(typeof i?.limits?.size=="number"&&r>i.limits.size)throw new p.$vl((0,R.localize)(14,null,this.sb(n)),p.FileOperationResult.FILE_TOO_LARGE,r,i)}async canMove(n,r,i){return this.M(n,r,"move",i)}async canCopy(n,r,i){return this.M(n,r,"copy",i)}async M(n,r,i,s){if(n.toString()!==r.toString())try{const o=i==="move"?this.qb(await this.n(n),n):await this.m(n),d=this.qb(await this.n(r),r);await this.Q(o,n,d,r,i,s)}catch(o){return o}return!0}async move(n,r,i){const s=this.qb(await this.n(n),n),o=this.qb(await this.n(r),r),d=await this.N(s,n,o,r,"move",!!i),S=await this.resolve(r,{resolveMetadata:!0});return this.r.fire(new p.$rl(n,d==="move"?p.FileOperation.MOVE:p.FileOperation.COPY,S)),S}async copy(n,r,i){const s=await this.m(n),o=this.qb(await this.n(r),r),d=await this.N(s,n,o,r,"copy",!!i),S=await this.resolve(r,{resolveMetadata:!0});return this.r.fire(new p.$rl(n,d==="copy"?p.FileOperation.COPY:p.FileOperation.MOVE,S)),S}async N(n,r,i,s,o,d){if(r.toString()===s.toString())return o;const{exists:S,isSameResourceWithDifferentPathCase:N}=await this.Q(n,r,i,s,o,d);if(S&&!N&&d&&await this.del(s,{recursive:!0}),await this.U(i,this.R(i).providerExtUri.dirname(s)),o==="copy"){if(n===i&&(0,p.$dl)(n))await n.copy(r,s,{overwrite:d});else{const C=await this.resolve(r);C.isDirectory?await this.P(n,C,i,s):await this.O(n,r,i,s)}return o}else return n===i?(await n.rename(r,s,{overwrite:d}),o):(await this.N(n,r,i,s,"copy",d),await this.del(r,{recursive:!0}),"copy")}async O(n,r,i,s){if((0,p.$fl)(n)&&(0,p.$fl)(i))return this.jb(n,r,i,s);if((0,p.$fl)(n)&&(0,p.$cl)(i))return this.pb(n,r,i,s);if((0,p.$cl)(n)&&(0,p.$fl)(i))return this.nb(n,r,i,s);if((0,p.$cl)(n)&&(0,p.$cl)(i))return this.lb(n,r,i,s)}async P(n,r,i,s){await i.mkdir(s),Array.isArray(r.children)&&await P.Promises.settled(r.children.map(async o=>{const d=this.R(i).providerExtUri.joinPath(s,o.name);return o.isDirectory?this.P(n,await this.resolve(o.resource),i,d):this.O(n,o.resource,i,d)}))}async Q(n,r,i,s,o,d){let S=!1;if(n===i){const{providerExtUri:C,isPathCaseSensitive:D}=this.R(n);if(D||(S=C.isEqual(r,s)),S&&o==="copy")throw new Error((0,R.localize)(15,null,this.sb(r),this.sb(s)));if(!S&&C.isEqualOrParent(s,r))throw new Error((0,R.localize)(16,null,this.sb(r),this.sb(s)))}const N=await this.exists(s);if(N&&!S){if(!d)throw new p.$ul((0,R.localize)(17,null,this.sb(r),this.sb(s)),p.FileOperationResult.FILE_MOVE_CONFLICT);if(n===i){const{providerExtUri:C}=this.R(n);if(C.isEqualOrParent(r,s))throw new Error((0,R.localize)(18,null,this.sb(r),this.sb(s)))}}return{exists:N,isSameResourceWithDifferentPathCase:S}}R(n){const r=this.S(n);return{providerExtUri:r?w.$9g:w.$$g,isPathCaseSensitive:r}}S(n){return!!(n.capabilities&p.FileSystemProviderCapabilities.PathCaseSensitive)}async createFolder(n){const r=this.qb(await this.j(n),n);await this.U(r,n);const i=await this.resolve(n,{resolveMetadata:!0});return this.r.fire(new p.$rl(n,p.FileOperation.CREATE,i)),i}async U(n,r){const i=[],{providerExtUri:s}=this.R(n);for(;!s.isEqual(r,s.dirname(r));)try{if(!((await n.stat(r)).type&p.FileType.Directory))throw new Error((0,R.localize)(19,null,this.sb(r)));break}catch(o){if((0,p.$pl)(o)!==p.FileSystemProviderErrorCode.FileNotFound)throw o;i.push(s.basename(r)),r=s.dirname(r)}for(let o=i.length-1;o>=0;o--){r=s.joinPath(r,i[o]);try{await n.mkdir(r)}catch(d){if((0,p.$pl)(d)!==p.FileSystemProviderErrorCode.FileExists)throw d}}}async canDelete(n,r){try{await this.W(n,r)}catch(i){return i}return!0}async W(n,r){const i=this.qb(await this.j(n),n),s=!!r?.useTrash;if(s&&!(i.capabilities&p.FileSystemProviderCapabilities.Trash))throw new Error((0,R.localize)(20,null,this.sb(n)));const o=r?.atomic;if(o&&!(i.capabilities&p.FileSystemProviderCapabilities.FileAtomicDelete))throw new Error((0,R.localize)(21,null,this.sb(n)));if(s&&o)throw new Error((0,R.localize)(22,null,this.sb(n)));let d;try{d=await i.stat(n)}catch{}if(d)this.rb(n,d);else throw new p.$ul((0,R.localize)(23,null,this.sb(n)),p.FileOperationResult.FILE_NOT_FOUND);if(!!!r?.recursive){const N=await this.resolve(n);if(N.isDirectory&&Array.isArray(N.children)&&N.children.length>0)throw new Error((0,R.localize)(24,null,this.sb(n)))}return i}async del(n,r){const i=await this.W(n,r);let s=r;if((0,p.$jl)(i)&&!s?.atomic){const N=i.enforceAtomicDelete?.(n);N&&(s={...r,atomic:N})}const o=!!s?.useTrash,d=!!s?.recursive,S=s?.atomic??!1;await i.delete(n,{recursive:d,useTrash:o,atomic:S}),this.r.fire(new p.$rl(n,p.FileOperation.DELETE))}async cloneFile(n,r){const i=await this.j(n),s=this.qb(await this.n(r),r);if(!(i===s&&this.R(i).providerExtUri.isEqual(n,r)))return i===s&&(0,p.$el)(i)?i.cloneFile(n,r):(await this.U(s,this.R(s).providerExtUri.dirname(r)),i===s&&(0,p.$dl)(i)?this.cb.queueFor(n,()=>i.copy(n,r,{overwrite:!0}),this.R(i).providerExtUri):this.cb.queueFor(n,()=>this.O(i,n,s,r),this.R(i).providerExtUri))}static{this.ab=0}createWatcher(n,r){return this.watch(n,{...r,correlationId:v.ab++})}watch(n,r={recursive:!1,excludes:[]}){const i=new c.$Vc;let s=!1,o=()=>{s=!0};i.add((0,c.$Uc)(()=>o())),(async()=>{try{const S=await this.bb(n,r);s?(0,c.$Rc)(S):o=()=>(0,c.$Rc)(S)}catch(S){this.b.error(S)}})();const d=r.correlationId;if(typeof d=="number"){const S=i.add(new A.$me);return i.add(this.X.event(C=>{C.correlates(d)&&S.fire(C)})),{onDidChange:S.event,dispose:()=>i.dispose()}}return i}async bb(n,r){const i=await this.j(n),s=(0,k.$tj)([this.R(i).providerExtUri.getComparisonKey(n),r]);let o=this.$.get(s);return o||(o={count:0,disposable:i.watch(n,r)},this.$.set(s,o)),o.count+=1,(0,c.$Uc)(()=>{o&&(o.count--,o.count===0&&((0,c.$Rc)(o.disposable),this.$.delete(s)))})}dispose(){super.dispose();for(const[,n]of this.$)(0,c.$Rc)(n.disposable);this.$.clear()}async db(n,r,i,s){return this.cb.queueFor(r,async()=>{const o=await n.open(r,{create:!0,unlock:i?.unlock??!1});try{(0,m.$Ae)(s)||(0,m.$Be)(s)?await this.eb(n,o,s):await this.fb(n,o,s)}catch(d){throw(0,p.$nl)(d)}finally{await n.close(o)}},this.R(n).providerExtUri)}async eb(n,r,i){let s=0,o;if((0,m.$Be)(i)){if(i.buffer.length>0){const d=y.$Oe.concat(i.buffer);await this.gb(n,r,d,d.byteLength,s,0),s+=d.byteLength}if(i.ended)return;o=i.stream}else o=i;return new Promise((d,S)=>{(0,m.$Ge)(o,{onData:async N=>{o.pause();try{await this.gb(n,r,N,N.byteLength,s,0)}catch(C){return S(C)}s+=N.byteLength,setTimeout(()=>o.resume())},onError:N=>S(N),onEnd:()=>d()})})}async fb(n,r,i){let s=0,o;for(;(o=i.read())!==null;)await this.gb(n,r,o,o.byteLength,s,0),s+=o.byteLength}async gb(n,r,i,s,o,d){let S=0;for(;S<s;){const N=await n.write(r,o+S,i.buffer,d+S,s-S);S+=N}}async hb(n,r,i,s){return this.cb.queueFor(r,()=>this.ib(n,r,i,s),this.R(n).providerExtUri)}async ib(n,r,i,s){let o;s instanceof y.$Oe?o=s:(0,m.$Ae)(s)?o=await(0,y.$1e)(s):(0,m.$Be)(s)?o=await(0,y.$2e)(s):o=(0,y.$Ye)(s),await n.writeFile(r,o.buffer,{create:!0,overwrite:!0,unlock:i?.unlock??!1,atomic:i?.atomic??!1})}async jb(n,r,i,s){return this.cb.queueFor(s,()=>this.kb(n,r,i,s),this.R(i).providerExtUri)}async kb(n,r,i,s){let o,d;try{o=await n.open(r,{create:!1}),d=await i.open(s,{create:!0,unlock:!1});const S=y.$Oe.alloc(this.a);let N=0,C=0,D=0;do D=await n.read(o,N,S.buffer,C,S.byteLength-C),await this.gb(i,d,S,D,N,C),N+=D,C+=D,C===S.byteLength&&(C=0);while(D>0)}catch(S){throw(0,p.$nl)(S)}finally{await P.Promises.settled([typeof o=="number"?n.close(o):Promise.resolve(),typeof d=="number"?i.close(d):Promise.resolve()])}}async lb(n,r,i,s){return this.cb.queueFor(s,()=>this.mb(n,r,i,s),this.R(i).providerExtUri)}async mb(n,r,i,s){return i.writeFile(s,await n.readFile(r),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async nb(n,r,i,s){return this.cb.queueFor(s,()=>this.ob(n,r,i,s),this.R(i).providerExtUri)}async ob(n,r,i,s){const o=await i.open(s,{create:!0,unlock:!1});try{const d=await n.readFile(r);await this.gb(i,o,y.$Oe.wrap(d),d.byteLength,0,0)}catch(d){throw(0,p.$nl)(d)}finally{await i.close(o)}}async pb(n,r,i,s){const o=await(0,y.$1e)(this.H(n,r,O.CancellationToken.None));await this.hb(i,s,void 0,o)}qb(n,r){if(n.capabilities&p.FileSystemProviderCapabilities.Readonly)throw new p.$ul((0,R.localize)(25,null,this.sb(r)),p.FileOperationResult.FILE_PERMISSION_DENIED);return n}rb(n,r){if((r.permissions??0)&p.FilePermission.Readonly)throw new p.$ul((0,R.localize)(26,null,this.sb(n)),p.FileOperationResult.FILE_PERMISSION_DENIED)}sb(n){return n.scheme===u.Schemas.file?n.fsPath:n.toString(!0)}};t.$Vq=e,t.$Vq=e=v=we([ne(0,$.$_j)],e)}),define(re[133],oe([0,1,8,31,14,5,63,2,16,13,17,46,25,108,10,62,130,128,127]),function(H,t,E,P,y,O,A,k,g,c,l,u,h,w,m,R,p,f,$){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$mr=void 0;class I extends p.$8q{static{this.L=!1}constructor(e,a){super(e,a),this.onDidChangeCapabilities=O.Event.None,this.P=new P.$Cc(n=>l.$0g.getComparisonKey(n)),this.X=new Map,this.Y=new Map,this.Z=new Map}get capabilities(){return this.M||(this.M=m.FileSystemProviderCapabilities.FileReadWrite|m.FileSystemProviderCapabilities.FileOpenReadWriteClose|m.FileSystemProviderCapabilities.FileReadStream|m.FileSystemProviderCapabilities.FileFolderCopy|m.FileSystemProviderCapabilities.FileWriteUnlock|m.FileSystemProviderCapabilities.FileAtomicRead|m.FileSystemProviderCapabilities.FileAtomicWrite|m.FileSystemProviderCapabilities.FileAtomicDelete|m.FileSystemProviderCapabilities.FileClone,c.$k&&(this.M|=m.FileSystemProviderCapabilities.PathCaseSensitive)),this.M}async stat(e){try{const{stat:a,symbolicLink:n}=await h.SymlinkSupport.stat(this.I(e));return{type:this.O(a,n),ctime:a.birthtime.getTime(),mtime:a.mtime.getTime(),size:a.size,permissions:a.mode&128?void 0:m.FilePermission.Locked}}catch(a){throw this.hb(a)}}async N(e){try{return await this.stat(e)}catch{return}}async readdir(e){try{const a=await h.Promises.readdir(this.I(e),{withFileTypes:!0}),n=[];return await Promise.all(a.map(async r=>{try{let i;r.isSymbolicLink()?i=(await this.stat((0,l.$gh)(e,r.name))).type:i=this.O(r),n.push([r.name,i])}catch(i){this.a.trace(i)}})),n}catch(a){throw this.hb(a)}}O(e,a){let n;return a?.dangling?n=m.FileType.Unknown:e.isFile()?n=m.FileType.File:e.isDirectory()?n=m.FileType.Directory:n=m.FileType.Unknown,a&&(n|=m.FileType.SymbolicLink),n}async Q(e){const a=this.I(e);this.R(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${a})`);let n;for(;n=this.P.get(e);)this.R(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${a})`),await n.wait();const r=new E.$Eh;return this.P.set(e,r),this.R(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${a})`),(0,k.$Uc)(()=>{this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${a})`),this.P.get(e)===r&&(this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${a})`),this.P.delete(e)),this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${a})`),r.open()})}async readFile(e,a){let n;try{a?.atomic&&(this.R(`[Disk FileSystemProvider]: atomic read operation started (${this.I(e)})`),n=await this.Q(e));const r=this.I(e);return await h.Promises.readFile(r)}catch(r){throw this.hb(r)}finally{n?.dispose()}}R(e){I.L&&this.a.trace(e)}readFileStream(e,a,n){const r=(0,u.$Ce)(i=>y.$Oe.concat(i.map(s=>y.$Oe.wrap(s))).buffer);return(0,R.$Uq)(this,e,r,i=>i.buffer,{...a,bufferSize:256*1024},n),r}async writeFile(e,a,n){return n?.atomic!==!1&&n?.atomic?.postfix&&await this.S(e)?this.U(e,(0,l.$gh)((0,l.$fh)(e),`${(0,l.$dh)(e)}${n.atomic.postfix}`),a,n):this.W(e,a,n)}async S(e){try{const a=this.I(e),{symbolicLink:n}=await h.SymlinkSupport.stat(a);if(n)return!1}catch{}return!0}async U(e,a,n,r){const i=new k.$Vc;try{i.add(await this.Q(e)),i.add(await this.Q(a)),await this.W(a,n,r,!0);try{await this.rename(a,e,{overwrite:!0})}catch(s){try{await this.delete(a,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw s}}finally{i.dispose()}}async W(e,a,n,r){let i;try{const s=this.I(e);if(!n.create||!n.overwrite){if(await h.Promises.exists(s)){if(!n.overwrite)throw(0,m.$ml)((0,w.localize)(0,null),m.FileSystemProviderErrorCode.FileExists)}else if(!n.create)throw(0,m.$ml)((0,w.localize)(1,null),m.FileSystemProviderErrorCode.FileNotFound)}i=await this.open(e,{create:!0,unlock:n.unlock},r),await this.write(i,0,a,0,a.byteLength)}catch(s){throw await this.ib(e,s)}finally{typeof i=="number"&&await this.close(i)}}static{this.$=!0}static configureFlushOnWrite(e){I.$=e}async open(e,a,n){const r=this.I(e);let i;(0,m.$al)(a)&&!n&&(i=await this.Q(e));let s;try{if((0,m.$al)(a)&&a.unlock)try{const{stat:d}=await h.SymlinkSupport.stat(r);d.mode&128||await h.Promises.chmod(r,d.mode|128)}catch(d){d.code!=="ENOENT"&&this.a.trace(d)}let o;if((0,m.$al)(a)){if(c.$i)try{await h.Promises.truncate(r,0),o="r+"}catch(d){d.code!=="ENOENT"&&this.a.trace(d)}o||(o="w")}else o="r";s=await h.Promises.open(r,o)}catch(o){throw i?.dispose(),(0,m.$al)(a)?await this.ib(e,o):this.hb(o)}if(this.X.set(s,0),(0,m.$al)(a)&&this.Z.set(s,e),i){const o=this.Y.get(s);this.R(`[Disk FileSystemProvider]: open() - storing lock for handle ${s} (${r})`),this.Y.set(s,i),o&&(this.R(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${s} (${r})`),o.dispose())}return s}async close(e){const a=this.Y.get(e);try{if(this.X.delete(e),this.Z.delete(e)&&I.$)try{await h.Promises.fdatasync(e)}catch(n){I.configureFlushOnWrite(!1),this.a.error(n)}return await h.Promises.close(e)}catch(n){throw this.hb(n)}finally{a&&(this.Y.get(e)===a&&(this.R(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${e}`),this.Y.delete(e)),this.R(`[Disk FileSystemProvider]: close() - disposing lock for handle ${e}`),a.dispose())}}async read(e,a,n,r,i){const s=this.ab(e,a);let o=null;try{o=(await h.Promises.read(e,n,r,i,s)).bytesRead}catch(d){throw this.hb(d)}finally{this.bb(e,s,o)}return o}ab(e,a){return a===this.X.get(e)?null:a}bb(e,a,n){const r=this.X.get(e);typeof r=="number"&&(typeof a=="number"||(typeof n=="number"?this.X.set(e,r+n):this.X.delete(e)))}async write(e,a,n,r,i){return(0,E.$Zh)(()=>this.cb(e,a,n,r,i),100,3)}async cb(e,a,n,r,i){const s=this.ab(e,a);let o=null;try{o=(await h.Promises.write(e,n,r,i,s)).bytesWritten}catch(d){throw await this.ib(this.Z.get(e),d)}finally{this.bb(e,s,o)}return o}async mkdir(e){try{await h.Promises.mkdir(this.I(e))}catch(a){throw this.hb(a)}}async delete(e,a){try{const n=this.I(e);if(a.recursive){let r;a?.atomic!==!1&&a.atomic.postfix&&(r=(0,g.$lc)((0,g.$oc)(n),`${(0,g.$pc)(n)}${a.atomic.postfix}`)),await h.Promises.rm(n,h.RimRafMode.MOVE,r)}else try{await h.Promises.unlink(n)}catch(r){if(r.code==="EPERM"||r.code==="EISDIR"){let i=!1;try{const{stat:s,symbolicLink:o}=await h.SymlinkSupport.stat(n);i=s.isDirectory()&&!o}catch{}if(i)await h.Promises.rmdir(n);else throw r}else throw r}}catch(n){throw this.hb(n)}}async rename(e,a,n){const r=this.I(e),i=this.I(a);if(r!==i)try{await this.db(e,a,"move",n.overwrite),await h.Promises.rename(r,i)}catch(s){throw(s.code==="EINVAL"||s.code==="EBUSY"||s.code==="ENAMETOOLONG")&&(s=new Error((0,w.localize)(2,null,(0,g.$pc)(r),(0,g.$pc)((0,g.$oc)(i)),s.toString()))),this.hb(s)}}async copy(e,a,n){const r=this.I(e),i=this.I(a);if(r!==i)try{await this.db(e,a,"copy",n.overwrite),await h.Promises.copy(r,i,{preserveSymlinks:!0})}catch(s){throw(s.code==="EINVAL"||s.code==="EBUSY"||s.code==="ENAMETOOLONG")&&(s=new Error((0,w.localize)(3,null,(0,g.$pc)(r),(0,g.$pc)((0,g.$oc)(i)),s.toString()))),this.hb(s)}}async db(e,a,n,r){const i=this.I(e),s=this.I(a);let o=!1;if(!!(this.capabilities&m.FileSystemProviderCapabilities.PathCaseSensitive)||(o=(0,A.$Dg)(i,s,!0)),o){if(n==="copy")throw(0,m.$ml)((0,w.localize)(4,null),m.FileSystemProviderErrorCode.FileExists);if(n==="move")return}const S=await this.N(e);if(!S)throw(0,m.$ml)((0,w.localize)(5,null),m.FileSystemProviderErrorCode.FileNotFound);const N=await this.N(a);if(N){if(!r)throw(0,m.$ml)((0,w.localize)(6,null),m.FileSystemProviderErrorCode.FileExists);S.type&m.FileType.File&&N.type&m.FileType.File||await this.delete(a,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(e,a){return this.eb(e,a,!1)}async eb(e,a,n){const r=this.I(e),i=this.I(a),s=!!(this.capabilities&m.FileSystemProviderCapabilities.PathCaseSensitive);if((0,A.$Dg)(r,i,!s))return;const o=new k.$Vc;try{o.add(await this.Q(e)),o.add(await this.Q(a)),n&&await h.Promises.mkdir((0,g.$oc)(i),{recursive:!0}),await h.Promises.copyFile(r,i)}catch(d){if(d.code==="ENOENT"&&!n)return this.eb(e,a,!0);throw this.hb(d)}finally{o.dispose()}}t(e,a,n){return new f.$cr(r=>e(r),r=>a(r),n)}F(e,a,n){return new $.$lr(r=>e(r),r=>a(r),n)}hb(e){if(e instanceof m.$ll)return e;let a=e,n;switch(e.code){case"ENOENT":n=m.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":n=m.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":n=m.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":n=m.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":n=m.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":a=`${e.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,n=m.FileSystemProviderErrorCode.Unknown;break;default:n=m.FileSystemProviderErrorCode.Unknown}return(0,m.$ml)(a,n)}async ib(e,a){let n=this.hb(a);if(e&&n.code===m.FileSystemProviderErrorCode.NoPermissions)try{const{stat:r}=await h.SymlinkSupport.stat(this.I(e));r.mode&128||(n=(0,m.$ml)(a,m.FileSystemProviderErrorCode.FileWriteLocked))}catch(r){this.a.trace(r)}return n}}t.$mr=I}),define(re[134],oe([0,1,2,6]),function(H,t,E,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$lR=void 0;class y extends E.$Wc{constructor(A,k=[]){super(),this.a=new P.$jk([A,...k]),this.B(A.onDidChangeLogLevel(g=>this.setLevel(g)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(A){this.a.setLevel(A)}getLevel(){return this.a.getLevel()}trace(A,...k){this.a.trace(A,...k)}debug(A,...k){this.a.debug(A,...k)}info(A,...k){this.a.info(A,...k)}warn(A,...k){this.a.warn(A,...k)}error(A,...k){this.a.error(A,...k)}flush(){this.a.flush()}}t.$lR=y}),define(re[135],oe([0,1,10,6]),function(H,t,E,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$aR=void 0;var y;(function(c){c[c.Trace=0]="Trace",c[c.Debug=1]="Debug",c[c.Info=2]="Info",c[c.Warning=3]="Warning",c[c.Error=4]="Error",c[c.Critical=5]="Critical",c[c.Off=6]="Off"})(y||(y={}));async function O(c,l,u,h,w){try{const m=await new Promise((p,f)=>{H(["@vscode/spdlog"],p,f)}).then(ye);m.setFlushOn(y.Trace);const R=await m.createAsyncRotatingLogger(c,l,u,h);return w?R.clearFormatters():R.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),R}catch(m){console.error(m)}return null}function A(c,l,u){switch(l){case P.LogLevel.Trace:c.trace(u);break;case P.LogLevel.Debug:c.debug(u);break;case P.LogLevel.Info:c.info(u);break;case P.LogLevel.Warning:c.warn(u);break;case P.LogLevel.Error:c.error(u);break;case P.LogLevel.Off:break;default:throw new Error(`Invalid log level ${l}`)}}function k(c,l){switch(l){case P.LogLevel.Trace:c.setLevel(y.Trace);break;case P.LogLevel.Debug:c.setLevel(y.Debug);break;case P.LogLevel.Info:c.setLevel(y.Info);break;case P.LogLevel.Warning:c.setLevel(y.Warning);break;case P.LogLevel.Error:c.setLevel(y.Error);break;case P.LogLevel.Off:c.setLevel(y.Off);break;default:throw new Error(`Invalid log level ${l}`)}}class g extends P.$fk{constructor(l,u,h,w,m){super(),this.m=[],this.setLevel(m),this.n=this.s(l,u,h,w),this.B(this.onDidChangeLogLevel(R=>{this.r&&k(this.r,R)}))}async s(l,u,h,w){const m=h?6:1,R=30/m*E.$Hl.MB,p=await O(l,u,R,m,w);if(p){this.r=p,k(this.r,this.getLevel());for(const{level:f,message:$}of this.m)A(this.r,f,$);this.m=[]}}g(l,u){this.r?A(this.r,l,u):this.getLevel()<=l&&this.m.push({level:l,message:u})}flush(){this.r?this.r.flush():this.n.then(()=>this.flush())}dispose(){this.r?this.u():this.n.then(()=>this.u()),super.dispose()}u(){this.r&&(this.r.drop(),this.r=void 0)}}t.$aR=g}),define(re[136],oe([0,1,29,6,135]),function(H,t,E,P,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$bR=void 0;class O extends P.$kk{s(k,g,c){return new y.$aR((0,E.$2g)(),k.fsPath,!c?.donotRotate,!!c?.donotUseFormatters,g)}}t.$bR=O}),define(re[39],oe([0,1,5,65,2,11]),function(H,t,E,P,y,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$so=t.$ro=t.$qo=void 0,t.$qo=(0,O.$Fi)("policy");class A extends y.$Wc{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new E.$me),this.onDidChange=this.h.event}async updatePolicyDefinitions(c){const l=Object.keys(this.f).length;return this.f={...c,...this.f},l!==Object.keys(this.f).length&&await this.j(c),P.Iterable.reduce(this.g.entries(),(u,[h,w])=>({...u,[h]:w}),{})}getPolicyValue(c){return this.g.get(c)}serialize(){return P.Iterable.reduce(Object.entries(this.f),(c,[l,u])=>({...c,[l]:{definition:u,value:this.g.get(l)}}),{})}}t.$ro=A;class k{constructor(){this.onDidChange=E.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}t.$so=k}),define(re[137],oe([0,1,8,5,65,3,10,6,39]),function(H,t,E,P,y,O,A,k,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$sgc=void 0;function c(u,h){const w=[];for(const m of new Set(y.Iterable.concat(u.keys(),h.keys())))u.get(m)!==h.get(m)&&w.push(m);return w}let l=class extends g.$ro{constructor(h,w,m){super(),this.m=h,this.n=w,this.s=m,this.c=this.B(new E.$Dh(500));const R=P.Event.filter(w.onDidFilesChange,p=>p.affects(h));this.B(w.watch(h)),this.B(R(()=>this.c.trigger(()=>this.w())))}async j(){await this.w()}async u(){const h=new Map;try{const w=await this.n.readFile(this.m),m=JSON.parse(w.value.toString());if(!(0,O.$hg)(m))throw new Error("Policy file isn't a JSON object");for(const R of Object.keys(m))this.f[R]&&h.set(R,m[R])}catch(w){w.fileOperationResult!==A.FileOperationResult.FILE_NOT_FOUND&&this.s.error("[FilePolicyService] Failed to read policies",w)}return h}async w(){const h=await this.u(),w=c(this.g,h);this.g=h,w.length>0&&this.h.fire(w)}};t.$sgc=l,t.$sgc=l=we([ne(1,A.$_k),ne(2,k.$_j)],l)}),define(re[138],oe([0,1,39,8,2,6]),function(H,t,E,P,y,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$rgc=void 0;let A=class extends E.$ro{constructor(g,c){super(),this.m=g,this.n=c,this.a=new P.$zh,this.b=this.B(new y.$Xc)}async j(g){this.m.trace(`NativePolicyService#_updatePolicyDefinitions - Found ${Object.keys(g).length} policy definitions`);const{createWatcher:c}=await new Promise((l,u)=>{H(["@vscode/policy-watcher"],l,u)}).then(ye);await this.a.queue(()=>new Promise((l,u)=>{try{this.b.value=c(this.n,g,h=>{this.t(h),l()})}catch(h){this.m.error("NativePolicyService#_updatePolicyDefinitions - Error creating watcher:",h),u(h)}}))}t(g){this.m.trace(`NativePolicyService#_onDidPolicyChange - Updated policy values: ${JSON.stringify(g)}`);for(const c in g){const l=g[c];l===void 0?this.g.delete(c):this.g.set(c,l)}this.h.fire(Object.keys(g))}};t.$rgc=A,t.$rgc=A=we([ne(0,O.$_j)],A)}),define(re[33],oe([0,1,11]),function(H,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$tk=t.$sk=void 0,t.$sk=(0,E.$Fi)("productService"),t.$tk="vscode://schemas/vscode-product"}),define(re[37],oe([0,1,75,3]),function(H,t,E,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$oo=void 0,E=ye(E),P=ye(P);class y{constructor(){this.a=new Map}add(A,k){E.ok(P.$fg(A)),E.ok(P.$hg(k)),E.ok(!this.a.has(A),"There is already an extension with this id"),this.a.set(A,k)}knows(A){return this.a.has(A)}as(A){return this.a.get(A)||null}}t.$oo=new y}),define(re[139],oe([0,1,5,37]),function(H,t,E,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$po=void 0,P=ye(P),t.$po={JSONContribution:"base.contributions.json"};function y(k){return k.length>0&&k.charAt(k.length-1)==="#"?k.substring(0,k.length-1):k}class O{constructor(){this.b=new E.$me,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(g,c){this.a[y(g)]=c,this.b.fire(g)}notifySchemaChanged(g){this.b.fire(g)}getSchemaContributions(){return{schemas:this.a}}}const A=new O;P.$oo.add(t.$po.JSONContribution,A)}),define(re[40],oe([0,1,20,5,3,95,30,139,37]),function(H,t,E,P,y,O,A,k,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Do=t.$Co=t.$Bo=t.$Ao=t.$zo=t.$yo=t.$xo=t.$wo=t.$vo=t.$uo=t.ConfigurationScope=t.$to=t.EditPresentationTypes=void 0,t.$Eo=R,t.$Fo=p,t.$Go=f,t.$Ho=I,t.$Io=v,y=ye(y),O=ye(O);var c;(function(e){e.Multiline="multilineText",e.Singleline="singlelineText"})(c||(t.EditPresentationTypes=c={})),t.$to={Configuration:"base.contributions.configuration"};var l;(function(e){e[e.APPLICATION=1]="APPLICATION",e[e.MACHINE=2]="MACHINE",e[e.WINDOW=3]="WINDOW",e[e.RESOURCE=4]="RESOURCE",e[e.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",e[e.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(l||(t.ConfigurationScope=l={})),t.$uo={properties:{},patternProperties:{}},t.$vo={properties:{},patternProperties:{}},t.$wo={properties:{},patternProperties:{}},t.$xo={properties:{},patternProperties:{}},t.$yo={properties:{},patternProperties:{}},t.$zo={properties:{},patternProperties:{}},t.$Ao="vscode://schemas/settings/resourceLanguage",t.$Bo="vscode://schemas/settings/configurationDefaults";const u=g.$oo.as(k.$po.JSONContribution);class h{constructor(){this.h=new Set,this.i=new P.$me,this.onDidSchemaChange=this.i.event,this.j=new P.$me,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:O.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},u.registerSchema(t.$Ao,this.g),this.v()}registerConfiguration(a,n=!0){this.registerConfigurations([a],n)}registerConfigurations(a,n=!0){const r=new Set;this.n(a,n,r),u.registerSchema(t.$Ao,this.g),this.i.fire(),this.j.fire({properties:r})}deregisterConfigurations(a){const n=new Set;this.o(a,n),u.registerSchema(t.$Ao,this.g),this.i.fire(),this.j.fire({properties:n})}updateConfigurations({add:a,remove:n}){const r=new Set;this.o(n,r),this.n(a,!1,r),u.registerSchema(t.$Ao,this.g),this.i.fire(),this.j.fire({properties:r})}registerDefaultConfigurations(a){const n=new Set;this.k(a,n),this.i.fire(),this.j.fire({properties:n,defaultsOverrides:!0})}k(a,n){const r=[];for(const{overrides:i,source:s}of a)for(const o in i)if(n.add(o),t.$Do.test(o)){const d=this.a.get(o),S=d?.valuesSources??new Map;if(s)for(const T of Object.keys(i[o]))S.set(T,s);const N={...d?.value||{},...i[o]};this.a.set(o,{source:s,value:N,valuesSources:S});const C=(0,A.$jj)(o),D={type:"object",default:N,description:O.localize(1,null,C),$ref:t.$Ao,defaultDefaultValue:N,source:y.$fg(s)?void 0:s,defaultValueSource:s};r.push(...R(o)),this.d[o]=D,this.b.properties[o]=D}else{this.a.set(o,{value:i[o],source:s});const d=this.d[o];d&&(this.w(o,d),this.r(o,d))}this.m(r)}deregisterDefaultConfigurations(a){const n=new Set;this.l(a,n),this.i.fire(),this.j.fire({properties:n,defaultsOverrides:!0})}l(a,n){for(const{overrides:r,source:i}of a)for(const s in r){const o=this.a.get(s),d=y.$fg(i)?i:i?.id,S=y.$fg(o?.source)?o?.source:o?.source?.id;if(d===S)if(n.add(s),this.a.delete(s),t.$Do.test(s))delete this.d[s],delete this.b.properties[s];else{const N=this.d[s];N&&(this.w(s,N),this.r(s,N))}}this.u()}deltaConfiguration(a){let n=!1;const r=new Set;a.removedDefaults&&(this.l(a.removedDefaults,r),n=!0),a.addedDefaults&&(this.k(a.addedDefaults,r),n=!0),a.removedConfigurations&&this.o(a.removedConfigurations,r),a.addedConfigurations&&this.n(a.addedConfigurations,!1,r),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:n})}notifyConfigurationSchemaUpdated(...a){this.i.fire()}registerOverrideIdentifiers(a){this.m(a),this.i.fire()}m(a){for(const n of a)this.h.add(n);this.u()}n(a,n,r){a.forEach(i=>{this.p(i,n,i.extensionInfo,i.restrictedProperties,void 0,r),this.c.push(i),this.q(i)})}o(a,n){const r=i=>{if(i.properties)for(const s in i.properties){n.add(s);const o=this.d[s];o?.policy?.name&&this.e.delete(o.policy.name),delete this.d[s],this.s(s,i.properties[s])}i.allOf?.forEach(s=>r(s))};for(const i of a){r(i);const s=this.c.indexOf(i);s!==-1&&this.c.splice(s,1)}}p(a,n=!0,r,i,s=l.WINDOW,o){s=y.$og(a.scope)?s:a.scope;const d=a.properties;if(d)for(const N in d){const C=d[N];if(n&&I(N,C)){delete d[N];continue}if(C.source=r,C.defaultDefaultValue=d[N].default,this.w(N,C),t.$Do.test(N)?C.scope=void 0:(C.scope=y.$og(C.scope)?s:C.scope,C.restricted=y.$og(C.restricted)?!!i?.includes(N):C.restricted),d[N].hasOwnProperty("included")&&!d[N].included){this.f[N]=d[N],delete d[N];continue}else this.d[N]=d[N],d[N].policy?.name&&this.e.set(d[N].policy.name,N);!d[N].deprecationMessage&&d[N].markdownDeprecationMessage&&(d[N].deprecationMessage=d[N].markdownDeprecationMessage),o.add(N)}const S=a.allOf;if(S)for(const N of S)this.p(N,n,r,i,s,o)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(a){const n=r=>{const i=r.properties;if(i)for(const o in i)this.r(o,i[o]);r.allOf?.forEach(n)};n(a)}r(a,n){switch(t.$uo.properties[a]=n,n.scope){case l.APPLICATION:t.$vo.properties[a]=n;break;case l.MACHINE:t.$wo.properties[a]=n;break;case l.MACHINE_OVERRIDABLE:t.$xo.properties[a]=n;break;case l.WINDOW:t.$yo.properties[a]=n;break;case l.RESOURCE:t.$zo.properties[a]=n;break;case l.LANGUAGE_OVERRIDABLE:t.$zo.properties[a]=n,this.g.properties[a]=n;break}}s(a,n){switch(delete t.$uo.properties[a],n.scope){case l.APPLICATION:delete t.$vo.properties[a];break;case l.MACHINE:delete t.$wo.properties[a];break;case l.MACHINE_OVERRIDABLE:delete t.$xo.properties[a];break;case l.WINDOW:delete t.$yo.properties[a];break;case l.RESOURCE:case l.LANGUAGE_OVERRIDABLE:delete t.$zo.properties[a],delete this.g.properties[a];break}}u(){for(const a of this.h.values()){const n=`[${a}]`,r={type:"object",description:O.localize(2,null),errorMessage:O.localize(3,null),$ref:t.$Ao};this.w(n,r),t.$uo.properties[n]=r,t.$vo.properties[n]=r,t.$wo.properties[n]=r,t.$xo.properties[n]=r,t.$yo.properties[n]=r,t.$zo.properties[n]=r}}v(){const a={type:"object",description:O.localize(4,null),errorMessage:O.localize(5,null),$ref:t.$Ao};t.$uo.patternProperties[t.$Co]=a,t.$vo.patternProperties[t.$Co]=a,t.$wo.patternProperties[t.$Co]=a,t.$xo.patternProperties[t.$Co]=a,t.$yo.patternProperties[t.$Co]=a,t.$zo.patternProperties[t.$Co]=a,this.i.fire()}w(a,n){const r=this.a.get(a);let i=r?.value,s=r?.source;y.$mg(i)&&(i=n.defaultDefaultValue,s=void 0),y.$mg(i)&&(i=f(n.type)),n.default=i,n.defaultValueSource=s}}const w="\\[([^\\]]+)\\]",m=new RegExp(w,"g");t.$Co=`^(${w})+$`,t.$Do=new RegExp(t.$Co);function R(e){const a=[];if(t.$Do.test(e)){let n=m.exec(e);for(;n?.length;){const r=n[1].trim();r&&a.push(r),n=m.exec(e)}}return(0,E.$Ob)(a)}function p(e){return e.reduce((a,n)=>`${a}[${n}]`,"")}function f(e){switch(Array.isArray(e)?e[0]:e){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}const $=new h;g.$oo.add(t.$to.Configuration,$);function I(e,a){return e.trim()?t.$Do.test(e)?O.localize(7,null,e):$.getConfigurationProperties()[e]!==void 0?O.localize(8,null,e):a.policy?.name&&$.getPolicyConfigurations().get(a.policy?.name)!==void 0?O.localize(9,null,e,a.policy?.name,$.getPolicyConfigurations().get(a.policy?.name)):null:O.localize(6,null)}function v(){const e=[],a=$.getConfigurationProperties();for(const n of Object.keys(a))e.push([n,a[n].scope]);return e.push(["launch",l.RESOURCE]),e.push(["task",l.RESOURCE]),e}}),define(re[66],oe([0,1,20,5,34,2,31,28,3,12,30,40,10,37]),function(H,t,E,P,y,O,A,k,g,c,l,u,h,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Oo=t.$Mo=t.$Lo=t.$Ko=t.$Jo=void 0,t.$No=v,E=ye(E),y=ye(y),k=ye(k),g=ye(g);function m(r){return Object.isFrozen(r)?r:k.$co(r)}class R{static createEmptyModel(i){return new R({},[],[],void 0,i)}constructor(i,s,o,d,S){this.b=i,this.c=s,this.d=o,this.raw=d,this.f=S,this.a=new Map}get rawConfiguration(){if(!this.g)if(this.raw?.length){const i=this.raw.map(s=>{if(s instanceof R)return s;const o=new p("",this.f);return o.parseRaw(s),o.configurationModel});this.g=i.reduce((s,o)=>o===s?o:s.merge(o),i[0])}else this.g=this;return this.g}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(i){return i?(0,l.$hj)(this.contents,i):this.contents}inspect(i,s){const o=this;return{get value(){return m(o.rawConfiguration.getValue(i))},get override(){return s?m(o.rawConfiguration.getOverrideValue(i,s)):void 0},get merged(){return m(s?o.rawConfiguration.override(s).getValue(i):o.rawConfiguration.getValue(i))},get overrides(){const d=[];for(const{contents:S,identifiers:N,keys:C}of o.rawConfiguration.overrides){const D=new R(S,C,[],void 0,o.f).getValue(i);D!==void 0&&d.push({identifiers:N,value:D})}return d.length?m(d):void 0}}}getOverrideValue(i,s){const o=this.j(s);return o?i?(0,l.$hj)(o,i):o:void 0}getKeysForOverrideIdentifier(i){const s=[];for(const o of this.overrides)o.identifiers.includes(i)&&s.push(...o.keys);return E.$Ob(s)}getAllOverrideIdentifiers(){const i=[];for(const s of this.overrides)i.push(...s.identifiers);return E.$Ob(i)}override(i){let s=this.a.get(i);return s||(s=this.h(i),this.a.set(i,s)),s}merge(...i){const s=k.$bo(this.contents),o=k.$bo(this.overrides),d=[...this.keys],S=this.raw?.length?[...this.raw]:[this];for(const N of i)if(S.push(...N.raw?.length?N.raw:[N]),!N.isEmpty()){this.i(s,N.contents);for(const C of N.overrides){const[D]=o.filter(T=>E.$wb(T.identifiers,C.identifiers));D?(this.i(D.contents,C.contents),D.keys.push(...C.keys),D.keys=E.$Ob(D.keys)):o.push(k.$bo(C))}for(const C of N.keys)d.indexOf(C)===-1&&d.push(C)}return new R(s,d,o,S.every(N=>N instanceof R)?void 0:S,this.f)}h(i){const s=this.j(i);if(!s||typeof s!="object"||!Object.keys(s).length)return this;const o={};for(const d of E.$Ob([...Object.keys(this.contents),...Object.keys(s)])){let S=this.contents[d];const N=s[d];N&&(typeof S=="object"&&typeof N=="object"?(S=k.$bo(S),this.i(S,N)):S=N),o[d]=S}return new R(o,this.keys,this.overrides,void 0,this.f)}i(i,s){for(const o of Object.keys(s)){if(o in i&&g.$hg(i[o])&&g.$hg(s[o])){this.i(i[o],s[o]);continue}i[o]=k.$bo(s[o])}}j(i){let s=null,o=null;const d=S=>{S&&(o?this.i(o,S):o=k.$bo(S))};for(const S of this.overrides)S.identifiers.length===1&&S.identifiers[0]===i?s=S.contents:S.identifiers.includes(i)&&d(S.contents);return d(s),o}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(i,s){this.k(i,s,!0)}setValue(i,s){this.k(i,s,!1)}removeValue(i){const s=this.keys.indexOf(i);s!==-1&&(this.keys.splice(s,1),(0,l.$gj)(this.contents,i),u.$Do.test(i)&&this.overrides.splice(this.overrides.findIndex(o=>E.$wb(o.identifiers,(0,u.$Eo)(i))),1))}k(i,s,o){(0,l.$fj)(this.contents,i,s,d=>this.f.error(d)),o=o||this.keys.indexOf(i)===-1,o&&this.keys.push(i),u.$Do.test(i)&&this.overrides.push({identifiers:(0,u.$Eo)(i),keys:Object.keys(this.contents[i]),contents:(0,l.$ej)(this.contents[i],d=>this.f.error(d))})}}t.$Jo=R;class p{constructor(i,s){this.f=i,this.g=s,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||R.createEmptyModel(this.g)}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(i,s){if(!g.$og(i)){const o=this.h(i);this.parseRaw(o,s)}}reparse(i){this.a&&this.parseRaw(this.a,i)}parseRaw(i,s){this.a=i;const{contents:o,keys:d,overrides:S,restricted:N,hasExcludedProperties:C}=this.i(i,s);this.b=new R(o,d,S,C?[i]:void 0,this.g),this.c=N||[]}h(i){let s={},o=null,d=[];const S=[],N=[];function C(T){Array.isArray(d)?d.push(T):o!==null&&(d[o]=T)}const D={onObjectBegin:()=>{const T={};C(T),S.push(d),d=T,o=null},onObjectProperty:T=>{o=T},onObjectEnd:()=>{d=S.pop()},onArrayBegin:()=>{const T=[];C(T),S.push(d),d=T,o=null},onArrayEnd:()=>{d=S.pop()},onLiteralValue:C,onError:(T,M,K)=>{N.push({error:T,offset:M,length:K})}};if(i)try{y.$3n(i,D),s=d[0]||{}}catch(T){this.g.error(`Error while parsing settings file ${this.f}: ${T}`),this.d=[T]}return s}i(i,s){const o=w.$oo.as(u.$to.Configuration).getConfigurationProperties(),d=this.j(i,o,!0,s);i=d.raw;const S=(0,l.$ej)(i,D=>this.g.error(`Conflict in settings file ${this.f}: ${D}`)),N=Object.keys(i),C=this.l(i,D=>this.g.error(`Conflict in settings file ${this.f}: ${D}`));return{contents:S,keys:N,overrides:C,restricted:d.restricted,hasExcludedProperties:d.hasExcludedProperties}}j(i,s,o,d){let S=!1;if(!d?.scopes&&!d?.skipRestricted&&!d?.exclude?.length)return{raw:i,restricted:[],hasExcludedProperties:S};const N={},C=[];for(const D in i)if(u.$Do.test(D)&&o){const T=this.j(i[D],s,!1,d);N[D]=T.raw,S=S||T.hasExcludedProperties,C.push(...T.restricted)}else{const T=s[D],M=T?typeof T.scope<"u"?T.scope:u.ConfigurationScope.WINDOW:void 0;T?.restricted&&C.push(D),!d.exclude?.includes(D)&&(d.include?.includes(D)||(M===void 0||d.scopes===void 0||d.scopes.includes(M))&&!(d.skipRestricted&&T?.restricted))?N[D]=i[D]:S=!0}return{raw:N,restricted:C,hasExcludedProperties:S}}l(i,s){const o=[];for(const d of Object.keys(i))if(u.$Do.test(d)){const S={};for(const N in i[d])S[N]=i[d][N];o.push({identifiers:(0,u.$Eo)(d),keys:Object.keys(S),contents:(0,l.$ej)(S,s)})}return o}}t.$Ko=p;class f extends O.$Wc{constructor(i,s,o,d,S){super(),this.c=i,this.f=s,this.g=d,this.h=S,this.b=this.B(new P.$me),this.onDidChange=this.b.event,this.a=new p(this.c.toString(),S),this.B(this.g.watch(o.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(P.Event.any(P.Event.filter(this.g.onDidFilesChange,N=>N.contains(this.c)),P.Event.filter(this.g.onDidRunOperation,N=>(N.isOperation(h.FileOperation.CREATE)||N.isOperation(h.FileOperation.COPY)||N.isOperation(h.FileOperation.DELETE)||N.isOperation(h.FileOperation.WRITE))&&o.isEqual(N.resource,i)))(()=>this.b.fire()))}async loadConfiguration(){try{const i=await this.g.readFile(this.c);return this.a.parse(i.value.toString()||"{}",this.f),this.a.configurationModel}catch{return R.createEmptyModel(this.h)}}reparse(i){return i&&(this.f=i),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}t.$Lo=f;class ${constructor(i,s,o,d,S,N,C,D,T,M,K,Y,ae){this.a=i,this.b=s,this.c=o,this.overrideIdentifiers=d,this.d=S,this.f=N,this.g=C,this.h=D,this.i=T,this.j=M,this.k=K,this.l=Y,this.m=ae}get value(){return m(this.c)}n(i){return i?.value!==void 0||i?.override!==void 0||i?.overrides!==void 0?i:void 0}get q(){return this.p||(this.p=this.d.inspect(this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.n(this.q)}get s(){return this.r===void 0&&(this.r=this.f?this.f.inspect(this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.g.inspect(this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.n(this.u)}get w(){return this.v||(this.v=this.h.inspect(this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.n(this.w)}get y(){return this.x||(this.x=this.i.inspect(this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.n(this.y)}get A(){return this.z||(this.z=this.j.inspect(this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.n(this.A)}get D(){return this.B===void 0&&(this.B=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.n(this.D)}get F(){return this.E===void 0&&(this.E=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.n(this.F)}get H(){return this.G===void 0&&(this.G=this.m.inspect(this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.n(this.H)}}class I{constructor(i,s,o,d,S,N,C,D,T,M){this.j=i,this.l=s,this.m=o,this.n=d,this.p=S,this.q=N,this.r=C,this.s=D,this.t=T,this.u=M,this.h=null,this.i=new A.$Cc,this.v=null}getValue(i,s,o){return this.w(i,s,o).getValue(i)}updateValue(i,s,o={}){let d;o.resource?(d=this.t.get(o.resource),d||(d=R.createEmptyModel(this.u),this.t.set(o.resource,d))):d=this.s,s===void 0?d.removeValue(i):d.setValue(i,s),o.resource||(this.h=null)}inspect(i,s,o){const d=this.w(i,s,o),S=this.A(s.resource,o),N=s.resource?this.t.get(s.resource)||this.s:this.s,C=new Set;for(const D of d.overrides)for(const T of D.identifiers)d.getOverrideValue(i,T)!==void 0&&C.add(T);return new $(i,s,d.getValue(i),C.size?[...C]:void 0,this.j,this.l.isEmpty()?void 0:this.l,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,o?this.q:void 0,S||void 0,N)}keys(i){const s=this.A(void 0,i);return{default:this.j.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.q.keys.slice(0),workspaceFolder:s?s.keys.slice(0):[]}}updateDefaultConfiguration(i){this.j=i,this.h=null,this.i.clear()}updatePolicyConfiguration(i){this.l=i}updateApplicationConfiguration(i){this.m=i,this.h=null,this.i.clear()}updateLocalUserConfiguration(i){this.n=i,this.v=null,this.h=null,this.i.clear()}updateRemoteUserConfiguration(i){this.p=i,this.v=null,this.h=null,this.i.clear()}updateWorkspaceConfiguration(i){this.q=i,this.h=null,this.i.clear()}updateFolderConfiguration(i,s){this.r.set(i,s),this.i.delete(i)}deleteFolderConfiguration(i){this.folderConfigurations.delete(i),this.i.delete(i)}compareAndUpdateDefaultConfiguration(i,s){const o=[];if(!s){const{added:d,updated:S,removed:N}=a(this.j,i);s=[...d,...S,...N]}for(const d of s)for(const S of(0,u.$Eo)(d)){const N=this.j.getKeysForOverrideIdentifier(S),C=i.getKeysForOverrideIdentifier(S),D=[...C.filter(T=>N.indexOf(T)===-1),...N.filter(T=>C.indexOf(T)===-1),...N.filter(T=>!k.$fo(this.j.override(S).getValue(T),i.override(S).getValue(T)))];o.push([S,D])}return this.updateDefaultConfiguration(i),{keys:s,overrides:o}}compareAndUpdatePolicyConfiguration(i){const{added:s,updated:o,removed:d}=a(this.l,i),S=[...s,...o,...d];return S.length&&this.updatePolicyConfiguration(i),{keys:S,overrides:[]}}compareAndUpdateApplicationConfiguration(i){const{added:s,updated:o,removed:d,overrides:S}=a(this.applicationConfiguration,i),N=[...s,...o,...d];return N.length&&this.updateApplicationConfiguration(i),{keys:N,overrides:S}}compareAndUpdateLocalUserConfiguration(i){const{added:s,updated:o,removed:d,overrides:S}=a(this.localUserConfiguration,i),N=[...s,...o,...d];return N.length&&this.updateLocalUserConfiguration(i),{keys:N,overrides:S}}compareAndUpdateRemoteUserConfiguration(i){const{added:s,updated:o,removed:d,overrides:S}=a(this.remoteUserConfiguration,i),N=[...s,...o,...d];return N.length&&this.updateRemoteUserConfiguration(i),{keys:N,overrides:S}}compareAndUpdateWorkspaceConfiguration(i){const{added:s,updated:o,removed:d,overrides:S}=a(this.workspaceConfiguration,i),N=[...s,...o,...d];return N.length&&this.updateWorkspaceConfiguration(i),{keys:N,overrides:S}}compareAndUpdateFolderConfiguration(i,s){const o=this.folderConfigurations.get(i),{added:d,updated:S,removed:N,overrides:C}=a(o,s),D=[...d,...S,...N];return(D.length||!o)&&this.updateFolderConfiguration(i,s),{keys:D,overrides:C}}compareAndDeleteFolderConfiguration(i){const s=this.folderConfigurations.get(i);if(!s)throw new Error("Unknown folder");this.deleteFolderConfiguration(i);const{added:o,updated:d,removed:S,overrides:N}=a(s,void 0);return{keys:[...o,...d,...S],overrides:N}}get defaults(){return this.j}get applicationConfiguration(){return this.m}get userConfiguration(){return this.v||(this.v=this.p.isEmpty()?this.n:this.n.merge(this.p)),this.v}get localUserConfiguration(){return this.n}get remoteUserConfiguration(){return this.p}get workspaceConfiguration(){return this.q}get folderConfigurations(){return this.r}w(i,s,o){let d=this.x(s,o);return s.overrideIdentifier&&(d=d.override(s.overrideIdentifier)),!this.l.isEmpty()&&this.l.getValue(i)!==void 0&&(d=d.merge(this.l)),d}x({resource:i},s){let o=this.y();if(s&&i){const d=s.getFolder(i);d&&(o=this.z(d.uri)||o);const S=this.t.get(i);S&&(o=o.merge(S))}return o}y(){return this.h||(this.h=this.j.merge(this.applicationConfiguration,this.userConfiguration,this.q,this.s)),this.h}z(i){let s=this.i.get(i);if(!s){const o=this.y(),d=this.r.get(i);d?(s=o.merge(d),this.i.set(i,s)):s=o}return s}A(i,s){if(s&&i){const o=s.getFolder(i);if(o)return this.r.get(o.uri)}}toData(){return{defaults:{contents:this.j.contents,overrides:this.j.overrides,keys:this.j.keys},policy:{contents:this.l.contents,overrides:this.l.overrides,keys:this.l.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.q.contents,overrides:this.q.overrides,keys:this.q.keys},folders:[...this.r.keys()].reduce((i,s)=>{const{contents:o,overrides:d,keys:S}=this.r.get(s);return i.push([s,{contents:o,overrides:d,keys:S}]),i},[])}}allKeys(){const i=new Set;return this.j.keys.forEach(s=>i.add(s)),this.userConfiguration.keys.forEach(s=>i.add(s)),this.q.keys.forEach(s=>i.add(s)),this.r.forEach(s=>s.keys.forEach(o=>i.add(o))),[...i.values()]}B(){const i=new Set;return this.j.getAllOverrideIdentifiers().forEach(s=>i.add(s)),this.userConfiguration.getAllOverrideIdentifiers().forEach(s=>i.add(s)),this.q.getAllOverrideIdentifiers().forEach(s=>i.add(s)),this.r.forEach(s=>s.getAllOverrideIdentifiers().forEach(o=>i.add(o))),[...i.values()]}D(i){const s=new Set;return this.j.getKeysForOverrideIdentifier(i).forEach(o=>s.add(o)),this.userConfiguration.getKeysForOverrideIdentifier(i).forEach(o=>s.add(o)),this.q.getKeysForOverrideIdentifier(i).forEach(o=>s.add(o)),this.r.forEach(o=>o.getKeysForOverrideIdentifier(i).forEach(d=>s.add(d))),[...s.values()]}static parse(i,s){const o=this.E(i.defaults,s),d=this.E(i.policy,s),S=this.E(i.application,s),N=this.E(i.user,s),C=this.E(i.workspace,s),D=i.folders.reduce((T,M)=>(T.set(c.URI.revive(M[0]),this.E(M[1],s)),T),new A.$Cc);return new I(o,d,S,N,R.createEmptyModel(s),C,D,R.createEmptyModel(s),new A.$Cc,s)}static E(i,s){return new R(i.contents,i.keys,i.overrides,void 0,s)}}t.$Mo=I;function v(...r){if(r.length===0)return{keys:[],overrides:[]};if(r.length===1)return r[0];const i=new Set,s=new Map;for(const d of r)d.keys.forEach(S=>i.add(S)),d.overrides.forEach(([S,N])=>{const C=(0,A.$zc)(s,S,new Set);N.forEach(D=>C.add(D))});const o=[];return s.forEach((d,S)=>o.push([S,[...d.values()]])),{keys:[...i.values()],overrides:o}}class e{constructor(i,s,o,d,S){this.change=i,this.f=s,this.g=o,this.h=d,this.i=S,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=46,this.affectedKeys=new Set,this.j=void 0;for(const N of i.keys)this.affectedKeys.add(N);for(const[,N]of i.overrides)for(const C of N)this.affectedKeys.add(C);this.d=this.a;for(const N of this.affectedKeys)this.d+=N+this.a}get previousConfiguration(){return!this.j&&this.f&&(this.j=I.parse(this.f.data,this.i)),this.j}affectsConfiguration(i,s){const o=this.a+i,d=this.d.indexOf(o);if(d<0)return!1;const S=d+o.length;if(S>=this.d.length)return!1;const N=this.d.charCodeAt(S);if(N!==this.b&&N!==this.c)return!1;if(s){const C=this.previousConfiguration?this.previousConfiguration.getValue(i,s,this.f?.workspace):void 0,D=this.g.getValue(i,s,this.h);return!k.$fo(C,D)}return!0}}t.$Oo=e;function a(r,i){const{added:s,removed:o,updated:d}=n(i?.rawConfiguration,r?.rawConfiguration),S=[],N=r?.getAllOverrideIdentifiers()||[],C=i?.getAllOverrideIdentifiers()||[];if(i){const D=C.filter(T=>!N.includes(T));for(const T of D)S.push([T,i.getKeysForOverrideIdentifier(T)])}if(r){const D=N.filter(T=>!C.includes(T));for(const T of D)S.push([T,r.getKeysForOverrideIdentifier(T)])}if(i&&r){for(const D of N)if(C.includes(D)){const T=n({contents:r.getOverrideValue(void 0,D)||{},keys:r.getKeysForOverrideIdentifier(D)},{contents:i.getOverrideValue(void 0,D)||{},keys:i.getKeysForOverrideIdentifier(D)});S.push([D,[...T.added,...T.removed,...T.updated]])}}return{added:s,removed:o,updated:d,overrides:S}}function n(r,i){const s=r?i?r.keys.filter(S=>i.keys.indexOf(S)===-1):[...r.keys]:[],o=i?r?i.keys.filter(S=>r.keys.indexOf(S)===-1):[...i.keys]:[],d=[];if(r&&i){for(const S of i.keys)if(r.keys.indexOf(S)!==-1){const N=(0,l.$hj)(i.contents,S),C=(0,l.$hj)(r.contents,S);k.$fo(N,C)||d.push(S)}}return{added:s,removed:o,updated:d}}}),define(re[140],oe([0,1,20,5,2,28,3,66,40,6,39,37]),function(H,t,E,P,y,O,A,k,g,c,l,u){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Ro=t.$Qo=t.$Po=void 0;class h extends y.$Wc{get configurationModel(){return this.b}constructor(p){super(),this.c=p,this.a=this.B(new P.$me),this.onDidChangeConfiguration=this.a.event,this.b=k.$Jo.createEmptyModel(this.c)}async initialize(){return this.h(),this.B(u.$oo.as(g.$to.Configuration).onDidUpdateConfiguration(({properties:p,defaultsOverrides:f})=>this.f(Array.from(p),f))),this.configurationModel}reload(){return this.h(),this.configurationModel}f(p,f){this.j(p,u.$oo.as(g.$to.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:p})}g(){return{}}h(){this.b=k.$Jo.createEmptyModel(this.c);const p=u.$oo.as(g.$to.Configuration).getConfigurationProperties();this.j(Object.keys(p),p)}j(p,f){const $=this.g();for(const I of p){const v=$[I],e=f[I];v!==void 0?this.b.addValue(I,v):e?this.b.addValue(I,e.default):this.b.removeValue(I)}}}t.$Po=h;class w{constructor(){this.onDidChangeConfiguration=P.Event.None,this.configurationModel=k.$Jo.createEmptyModel(new c.$mk)}async initialize(){return this.configurationModel}}t.$Qo=w;let m=class extends y.$Wc{get configurationModel(){return this.b}constructor(p,f,$){super(),this.c=p,this.f=f,this.g=$,this.a=this.B(new P.$me),this.onDidChangeConfiguration=this.a.event,this.b=k.$Jo.createEmptyModel(this.g)}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.m(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(p=>this.j(p))),this.B(this.c.onDidChangeConfiguration(async({properties:p})=>this.m(await this.h(p),!0))),this.b}async h(p){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",p);const f={},$=[],I=u.$oo.as(g.$to.Configuration).getConfigurationProperties();for(const v of p){const e=I[v];if(!e){$.push(v);continue}if(e.policy){if(e.type!=="string"&&e.type!=="number"){this.g.warn(`Policy ${e.policy.name} has unsupported type ${e.type}`);continue}$.push(v),f[e.policy.name]={type:e.type}}}return(0,A.$sg)(f)||await this.f.updatePolicyDefinitions(f),$}j(p){this.g.trace("PolicyConfiguration#onDidChangePolicies",p);const f=u.$oo.as(g.$to.Configuration).getPolicyConfigurations(),$=(0,E.$Jb)(p.map(I=>f.get(I)));this.m($,!0)}m(p,f){this.g.trace("PolicyConfiguration#update",p);const $=u.$oo.as(g.$to.Configuration).getConfigurationProperties(),I=[],v=this.b.isEmpty();for(const e of p){const a=$[e]?.policy?.name;if(a){const n=this.f.getPolicyValue(a);(v?n!==void 0:!(0,O.$fo)(this.b.getValue(e),n))&&I.push([e,n])}else this.b.getValue(e)!==void 0&&I.push([e,void 0])}if(I.length){this.g.trace("PolicyConfiguration#changed",I);const e=this.b;this.b=k.$Jo.createEmptyModel(this.g);for(const a of e.keys)this.b.setValue(a,e.getValue(a));for(const[a,n]of I)n===void 0?this.b.removeValue(a):this.b.setValue(a,n);f&&this.a.fire(this.b)}}};t.$Ro=m,t.$Ro=m=we([ne(1,l.$qo),ne(2,c.$_j)],m)}),define(re[141],oe([0,1,20,8,14,5,34,77,2,31,28,13,17,30,66,40,140,10,39]),function(H,t,E,P,y,O,A,k,g,c,l,u,h,w,m,R,p,f,$){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$So=void 0;class I extends g.$Wc{constructor(a,n,r,i){super(),this.m=a,this.n=i,this.h=this.B(new O.$me),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new p.$Po(i)),this.c=r instanceof $.$so?new p.$Qo:this.B(new p.$Ro(this.b,r,i)),this.f=this.B(new m.$Lo(this.m,{},h.$0g,n,i)),this.a=new m.$Mo(this.b.configurationModel,this.c.configurationModel,m.$Jo.createEmptyModel(i),m.$Jo.createEmptyModel(i),m.$Jo.createEmptyModel(i),m.$Jo.createEmptyModel(i),new c.$Cc,m.$Jo.createEmptyModel(i),new c.$Cc,i),this.j=new v(a,n,this),this.g=this.B(new P.$Rh(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:s,properties:o})=>this.s(s,o))),this.B(this.c.onDidChangeConfiguration(s=>this.t(s))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[a,n,r]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new m.$Mo(a,n,m.$Jo.createEmptyModel(this.n),r,m.$Jo.createEmptyModel(this.n),m.$Jo.createEmptyModel(this.n),new c.$Cc,m.$Jo.createEmptyModel(this.n),new c.$Cc,this.n)}getConfigurationData(){return this.a.toData()}getValue(a,n){const r=typeof a=="string"?a:void 0,i=(0,w.$aj)(a)?a:(0,w.$aj)(n)?n:{};return this.a.getValue(r,i,void 0)}async updateValue(a,n,r,i,s){const o=(0,w.$bj)(r)?r:(0,w.$aj)(r)?{resource:r.resource,overrideIdentifiers:r.overrideIdentifier?[r.overrideIdentifier]:void 0}:void 0,d=o?i:r;if(d!==void 0&&d!==w.ConfigurationTarget.USER_LOCAL&&d!==w.ConfigurationTarget.USER)throw new Error(`Unable to write ${a} to target ${d}.`);o?.overrideIdentifiers&&(o.overrideIdentifiers=(0,E.$Ob)(o.overrideIdentifiers),o.overrideIdentifiers=o.overrideIdentifiers.length?o.overrideIdentifiers:void 0);const S=this.inspect(a,{resource:o?.resource,overrideIdentifier:o?.overrideIdentifiers?o.overrideIdentifiers[0]:void 0});if(S.policyValue!==void 0)throw new Error(`Unable to write ${a} because it is configured in system policy.`);if((0,l.$fo)(n,S.defaultValue)&&(n=void 0),o?.overrideIdentifiers?.length&&o.overrideIdentifiers.length>1){const C=o.overrideIdentifiers.sort(),D=this.a.localUserConfiguration.overrides.find(T=>(0,E.$wb)([...T.identifiers].sort(),C));D&&(o.overrideIdentifiers=D.identifiers)}const N=o?.overrideIdentifiers?.length?[(0,R.$Fo)(o.overrideIdentifiers),a]:[a];await this.j.write(N,n),await this.reloadConfiguration()}inspect(a,n={}){return this.a.inspect(a,n,void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const a=await this.f.loadConfiguration();this.r(a)}r(a){const n=this.a.toData(),r=this.a.compareAndUpdateLocalUserConfiguration(a);this.u(r,n,w.ConfigurationTarget.USER)}s(a,n){const r=this.a.toData(),i=this.a.compareAndUpdateDefaultConfiguration(a,n);this.u(i,r,w.ConfigurationTarget.DEFAULT)}t(a){const n=this.a.toData(),r=this.a.compareAndUpdatePolicyConfiguration(a);this.u(r,n,w.ConfigurationTarget.DEFAULT)}u(a,n,r){const i=new m.$Oo(a,{data:n},this.a,void 0,this.n);i.source=r,this.h.fire(i)}}t.$So=I;class v{constructor(a,n,r){this.b=a,this.c=n,this.d=r,this.a=new P.$Mh}write(a,n){return this.a.queue(()=>this.e(a,n))}async e(a,n){let r;try{r=(await this.c.readFile(this.b)).value.toString()}catch(o){if(o.fileOperationResult===f.FileOperationResult.FILE_NOT_FOUND)r="{}";else throw o}const i=[];if((0,A.$Vn)(r,i,{allowTrailingComma:!0,allowEmptyContent:!0}),i.length>0)throw new Error("Unable to write into the settings file. Please open the file to correct errors/warnings in the file and try again.");const s=this.f(r,a,n);r=(0,k.$ao)(r,s),await this.c.writeFile(this.b,y.$Oe.fromString(r))}f(a,n,r){const{tabSize:i,insertSpaces:s,eol:o}=this.h;if(!n.length){const d=JSON.stringify(r,null,s?" ".repeat(i):"	");return[{content:d,length:d.length,offset:0}]}return(0,k.$0n)(a,n,r,{tabSize:i,insertSpaces:s,eol:o})}get h(){if(!this.g){let a=u.OS===u.OperatingSystem.Linux||u.OS===u.OperatingSystem.Macintosh?`
`:`\r
`;const n=this.d.getValue("files.eol",{overrideIdentifier:"jsonc"});n&&typeof n=="string"&&n!=="auto"&&(a=n),this.g={eol:a,insertSpaces:!!this.d.getValue("editor.insertSpaces",{overrideIdentifier:"jsonc"}),tabSize:this.d.getValue("editor.tabSize",{overrideIdentifier:"jsonc"})}}return this.g}}}),define(re[67],oe([0,1,15]),function(H,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$gn=P,t.$hn=y,t.$in=O,t.$jn=A;function P(g){return g.scheme===E.Schemas.vscodeRemote?g.authority:void 0}function y(g){if(!g)return;const c=g.indexOf("+");return c<0?g:g.substr(0,c)}function O(g){const{host:c,port:l}=k(g);if(typeof l>"u")throw new Error(`Invalid remote authority: ${g}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:c,port:l}}function A(g,c){let{host:l,port:u}=k(g);return typeof u>"u"&&(u=c),{host:l,port:u}}function k(g){const c=g.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(c)return{host:c[1],port:parseInt(c[2],10)};const l=g.match(/^(\[[0-9a-z:]+\])$/);if(l)return{host:l[1],port:void 0};const u=g.match(/(.*):(\d+)$/);return u?{host:u[1],port:parseInt(u[2],10)}:{host:g,port:void 0}}}),define(re[26],oe([0,1,32,11,67]),function(H,t,E,P,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$xn=t.$sn=t.$rn=t.$qn=t.TargetPlatform=t.ExtensionType=t.$pn=t.$nn=t.$mn=t.$ln=t.$kn=void 0,t.$on=O,t.$tn=u,t.$un=h,t.$vn=w,t.$wn=m,E=ye(E),t.$kn="extensions.user.cache",t.$ln="extensions.builtin.cache",t.$mn="undefined_publisher",t.$nn=["ui","workspace","web"];function O(R){if(typeof R=="object"&&R!==null&&R.supported!==!0)return R.description}t.$pn=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","AI","Chat","Other"];var A;(function(R){R[R.System=0]="System",R[R.User=1]="User"})(A||(t.ExtensionType=A={}));var k;(function(R){R.WIN32_X64="win32-x64",R.WIN32_ARM64="win32-arm64",R.LINUX_X64="linux-x64",R.LINUX_ARM64="linux-arm64",R.LINUX_ARMHF="linux-armhf",R.ALPINE_X64="alpine-x64",R.ALPINE_ARM64="alpine-arm64",R.DARWIN_X64="darwin-x64",R.DARWIN_ARM64="darwin-arm64",R.WEB="web",R.UNIVERSAL="universal",R.UNKNOWN="unknown",R.UNDEFINED="undefined"})(k||(t.TargetPlatform=k={}));class g{constructor(p){this.value=p,this._lower=p.toLowerCase()}static equals(p,f){if(typeof p>"u"||p===null)return typeof f>"u"||f===null;if(typeof f>"u"||f===null)return!1;if(typeof p=="string"||typeof f=="string"){const $=typeof p=="string"?p:p.value,I=typeof f=="string"?f:f.value;return E.$Gf($,I)}return p._lower===f._lower}static toKey(p){return typeof p=="string"?p.toLowerCase():p._lower}}t.$qn=g;class c{get size(){return this.c.size}constructor(p){if(this.c=new Set,p)for(const f of p)this.add(f)}add(p){this.c.add(g.toKey(p))}delete(p){return this.c.delete(g.toKey(p))}has(p){return this.c.has(g.toKey(p))}}t.$rn=c;class l{constructor(){this.c=new Map}clear(){this.c.clear()}delete(p){this.c.delete(g.toKey(p))}get(p){return this.c.get(g.toKey(p))}has(p){return this.c.has(g.toKey(p))}set(p,f){this.c.set(g.toKey(p),f)}values(){return this.c.values()}forEach(p){this.c.forEach(p)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}t.$sn=l;function u(R){return h(R)}function h(R){return R.contributes&&R.contributes.localizations?R.contributes.localizations.length>0:!1}function w(R){return R.contributes&&R.contributes.authentication?R.contributes.authentication.length>0:!1}function m(R,p){if(p){const f=`onResolveRemoteAuthority:${(0,y.$hn)(p)}`;return!!R.activationEvents?.includes(f)}return!1}t.$xn=(0,P.$Fi)("IBuiltinExtensionsScannerService")}),define(re[21],oe([0,1,13,99,26,11]),function(H,t,E,P,y,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$pp=t.$op=t.$np=t.$mp=t.$lp=t.$kp=t.$jp=t.$ip=t.ExtensionManagementErrorCode=t.$hp=t.ExtensionGalleryErrorCode=t.$gp=t.InstallOperation=t.StatisticType=t.SortOrder=t.SortBy=t.ExtensionInstallSource=t.$_o=t.$$o=t.$0o=t.$9o=t.$8o=t.$7o=t.$6o=void 0,t.$ap=k,t.$bp=g,t.$cp=c,t.$dp=l,t.$ep=u,t.$fp=h,t.$6o="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",t.$7o=new RegExp(t.$6o),t.$8o="__web_extension",t.$9o="skipWalkthrough",t.$0o="extensionInstallSource",t.$$o="dependecyOrPackExtensionInstall",t.$_o="clientTargetPlatform";var A;(function(e){e.COMMAND="command",e.SETTINGS_SYNC="settingsSync"})(A||(t.ExtensionInstallSource=A={}));function k(e){switch(e){case y.TargetPlatform.WIN32_X64:return"Windows 64 bit";case y.TargetPlatform.WIN32_ARM64:return"Windows ARM";case y.TargetPlatform.LINUX_X64:return"Linux 64 bit";case y.TargetPlatform.LINUX_ARM64:return"Linux ARM 64";case y.TargetPlatform.LINUX_ARMHF:return"Linux ARM";case y.TargetPlatform.ALPINE_X64:return"Alpine Linux 64 bit";case y.TargetPlatform.ALPINE_ARM64:return"Alpine ARM 64";case y.TargetPlatform.DARWIN_X64:return"Mac";case y.TargetPlatform.DARWIN_ARM64:return"Mac Silicon";case y.TargetPlatform.WEB:return"Web";case y.TargetPlatform.UNIVERSAL:return y.TargetPlatform.UNIVERSAL;case y.TargetPlatform.UNKNOWN:return y.TargetPlatform.UNKNOWN;case y.TargetPlatform.UNDEFINED:return y.TargetPlatform.UNDEFINED}}function g(e){switch(e){case y.TargetPlatform.WIN32_X64:return y.TargetPlatform.WIN32_X64;case y.TargetPlatform.WIN32_ARM64:return y.TargetPlatform.WIN32_ARM64;case y.TargetPlatform.LINUX_X64:return y.TargetPlatform.LINUX_X64;case y.TargetPlatform.LINUX_ARM64:return y.TargetPlatform.LINUX_ARM64;case y.TargetPlatform.LINUX_ARMHF:return y.TargetPlatform.LINUX_ARMHF;case y.TargetPlatform.ALPINE_X64:return y.TargetPlatform.ALPINE_X64;case y.TargetPlatform.ALPINE_ARM64:return y.TargetPlatform.ALPINE_ARM64;case y.TargetPlatform.DARWIN_X64:return y.TargetPlatform.DARWIN_X64;case y.TargetPlatform.DARWIN_ARM64:return y.TargetPlatform.DARWIN_ARM64;case y.TargetPlatform.WEB:return y.TargetPlatform.WEB;case y.TargetPlatform.UNIVERSAL:return y.TargetPlatform.UNIVERSAL;default:return y.TargetPlatform.UNKNOWN}}function c(e,a){switch(e){case E.Platform.Windows:return a==="x64"?y.TargetPlatform.WIN32_X64:a==="arm64"?y.TargetPlatform.WIN32_ARM64:y.TargetPlatform.UNKNOWN;case E.Platform.Linux:return a==="x64"?y.TargetPlatform.LINUX_X64:a==="arm64"?y.TargetPlatform.LINUX_ARM64:a==="arm"?y.TargetPlatform.LINUX_ARMHF:y.TargetPlatform.UNKNOWN;case"alpine":return a==="x64"?y.TargetPlatform.ALPINE_X64:a==="arm64"?y.TargetPlatform.ALPINE_ARM64:y.TargetPlatform.UNKNOWN;case E.Platform.Mac:return a==="x64"?y.TargetPlatform.DARWIN_X64:a==="arm64"?y.TargetPlatform.DARWIN_ARM64:y.TargetPlatform.UNKNOWN;case E.Platform.Web:return y.TargetPlatform.WEB}}function l(e,a){return a===y.TargetPlatform.WEB&&!e.includes(y.TargetPlatform.WEB)}function u(e,a,n){return l(a,n)?!1:e===y.TargetPlatform.UNDEFINED||e===y.TargetPlatform.UNIVERSAL?!0:e===y.TargetPlatform.UNKNOWN?!1:e===n}function h(e){return e&&typeof e=="object"&&typeof e.id=="string"&&(!e.uuid||typeof e.uuid=="string")}var w;(function(e){e[e.NoneOrRelevance=0]="NoneOrRelevance",e[e.LastUpdatedDate=1]="LastUpdatedDate",e[e.Title=2]="Title",e[e.PublisherName=3]="PublisherName",e[e.InstallCount=4]="InstallCount",e[e.PublishedDate=10]="PublishedDate",e[e.AverageRating=6]="AverageRating",e[e.WeightedRating=12]="WeightedRating"})(w||(t.SortBy=w={}));var m;(function(e){e[e.Default=0]="Default",e[e.Ascending=1]="Ascending",e[e.Descending=2]="Descending"})(m||(t.SortOrder=m={}));var R;(function(e){e.Install="install",e.Uninstall="uninstall"})(R||(t.StatisticType=R={}));var p;(function(e){e[e.None=1]="None",e[e.Install=2]="Install",e[e.Update=3]="Update",e[e.Migrate=4]="Migrate"})(p||(t.InstallOperation=p={})),t.$gp=(0,O.$Fi)("extensionGalleryService");var f;(function(e){e.Timeout="Timeout",e.Cancelled="Cancelled",e.Failed="Failed",e.DownloadFailedWriting="DownloadFailedWriting"})(f||(t.ExtensionGalleryErrorCode=f={}));class $ extends Error{constructor(a,n){super(a),this.code=n,this.name=n}}t.$hp=$;var I;(function(e){e.Unsupported="Unsupported",e.Deprecated="Deprecated",e.Malicious="Malicious",e.Incompatible="Incompatible",e.IncompatibleTargetPlatform="IncompatibleTargetPlatform",e.ReleaseVersionNotFound="ReleaseVersionNotFound",e.Invalid="Invalid",e.Download="Download",e.DownloadSignature="DownloadSignature",e.DownloadFailedWriting="DownloadFailedWriting",e.UpdateExistingMetadata="UpdateExistingMetadata",e.UpdateMetadata="UpdateMetadata",e.Extract="Extract",e.Scanning="Scanning",e.ScanningExtension="ScanningExtension",e.ReadUninstalled="ReadUninstalled",e.UnsetUninstalled="UnsetUninstalled",e.Delete="Delete",e.Rename="Rename",e.IntializeDefaultProfile="IntializeDefaultProfile",e.AddToProfile="AddToProfile",e.InstalledExtensionNotFound="InstalledExtensionNotFound",e.PostInstall="PostInstall",e.CorruptZip="CorruptZip",e.IncompleteZip="IncompleteZip",e.Signature="Signature",e.NotAllowed="NotAllowed",e.Gallery="Gallery",e.Cancelled="Cancelled",e.Unknown="Unknown",e.Internal="Internal"})(I||(t.ExtensionManagementErrorCode=I={}));class v extends Error{constructor(a,n){super(a),this.code=n,this.name=n}}t.$ip=v,t.$jp=(0,O.$Fi)("extensionManagementService"),t.$kp="extensionsIdentifiers/disabled",t.$lp="extensionsIdentifiers/enabled",t.$mp=(0,O.$Fi)("IGlobalExtensionEnablementService"),t.$np=(0,O.$Fi)("IExtensionTipsService"),t.$op=(0,P.localize2)(0,"Extensions"),t.$pp=(0,P.localize2)(1,"Preferences")}),define(re[142],oe([0,1,2,26,10]),function(H,t,E,P,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Pq=void 0;class O extends E.$Wc{constructor(k,g,c,l,u){super(),this.a=k,this.b=g,this.c=c,this.f=u,this.B(l.onDidInstallExtensions(h=>this.g(h))),this.B(l.onDidUninstallExtension(h=>this.h(h)))}g(k){for(const g of k)g.local&&this.invalidate(g.profileLocation)}h(k){k.error||this.invalidate(k.profileLocation)}async invalidate(k){if(k)for(const g of this.a.profiles)this.c.extUri.isEqual(g.extensionsResource,k)&&await this.j(g);else await this.j(this.a.defaultProfile)}async j(k){try{await this.b.del(this.c.extUri.joinPath(k.cacheHome,P.$kn))}catch(g){(0,y.$ql)(g)!==y.FileOperationResult.FILE_NOT_FOUND&&this.f.error(g)}}}t.$Pq=O}),define(re[68],oe([0,1,22,2,13,109,21,11]),function(H,t,E,P,y,O,A,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$6r=t.$5r=void 0,t.$4r=g;function g(l){return l.tags.find(u=>u.startsWith("lp-"))?.split("lp-")[1]}t.$5r=(0,k.$Fi)("languagePackService");let c=class extends P.$Wc{constructor(u){super(),this.c=u}async getAvailableLanguages(){const u=new E.$xe;setTimeout(()=>u.cancel(),1e3);let h;try{h=await this.c.query({text:'category:"language packs"',pageSize:20},u.token)}catch{return[]}const m=h.firstPage.filter(R=>R.properties.localizedLanguages?.length&&R.tags.some(p=>p.startsWith("lp-"))).map(R=>{const p=R.properties.localizedLanguages?.[0],f=g(R);return{...this.f(f,p,R),extensionId:R.identifier.id,galleryExtension:R}});return m.push(this.f("en","English")),m}f(u,h,w){const m=h??u;let R;if(m!==u&&(R=`(${u})`),u.toLowerCase()===y.$w.toLowerCase()&&(R??="",R+=(0,O.localize)(0,null)),w?.installCount){R??="";const p=w.installCount;let f;p>1e6?f=`${Math.floor(p/1e5)/10}M`:p>1e3?f=`${Math.floor(p/1e3)}K`:f=String(p),R+=` $(cloud-download) ${f}`}return{id:u,label:m,description:R}}};t.$6r=c,t.$6r=c=we([ne(0,A.$gp)],c)}),define(re[45],oe([0,1,14,9,2,111,40,11,6,37]),function(H,t,E,P,y,O,A,k,g,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$2p=t.$1p=void 0,t.$3p=h,t.$4p=w,t.$5p=m,t.$6p=R,t.$7p=p,t.$8p=f,t.$1p=(0,k.$Fi)("requestService");class l{constructor(e){this.b=e}toJSON(){if(!this.a){const e=Object.create(null);for(const a in this.b)a.toLowerCase()==="authorization"||a.toLowerCase()==="proxy-authorization"?e[a]="*****":e[a]=this.b[a];this.a=e}return this.a}}class u extends y.$Wc{constructor(e){super(),this.b=0,this.a=e.createLogger("network",{name:(0,O.localize)(0,null),when:g.$rk.isEqualTo((0,g.$ok)(g.LogLevel.Trace)).serialize()})}async c(e,a,n){const r=`${e} #${++this.b}: ${a.url}`;this.a.trace(`${r} - begin`,a.type,new l(a.headers??{}));try{const i=await n();return this.a.trace(`${r} - end`,a.type,i.res.statusCode,i.res.headers),i}catch(i){throw this.a.error(`${r} - error`,a.type,(0,P.$_)(i)),i}}}t.$2p=u;function h(v){return v.res.statusCode&&v.res.statusCode>=200&&v.res.statusCode<300||v.res.statusCode===1223}function w(v){return v.res.statusCode===204}async function m(v){return w(v)?null:(await(0,E.$1e)(v.stream)).toString()}async function R(v){if(!h(v))throw new Error("Server returned "+v.res.statusCode);return m(v)}async function p(v){if(!h(v))throw new Error("Server returned "+v.res.statusCode);if(w(v))return null;const a=(await(0,E.$1e)(v.stream)).toString();try{return JSON.parse(a)}catch(n){throw n.message+=`:
`+a,n}}function f(v){I(v)}let $;function I(v){const e=c.$oo.as(A.$to.Configuration),a=$;$={id:"http",order:15,title:(0,O.localize)(1,null),type:"object",scope:v,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,O.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,O.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,O.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,O.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,O.localize)(6,null),(0,O.localize)(7,null),(0,O.localize)(8,null),(0,O.localize)(9,null)],default:"override",description:(0,O.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,O.localize)(11,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,O.localize)(12,null),restricted:!0}}},e.updateConfigurations({add:[$],remove:a?[a]:[]})}I(A.ConfigurationScope.APPLICATION)}),define(re[143],oe([0,1,22,15,10,45]),function(H,t,E,P,y,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$AR=void 0;let A=class{constructor(g,c){this.a=g,this.b=c}async download(g,c,l=E.CancellationToken.None){if(g.scheme===P.Schemas.file||g.scheme===P.Schemas.vscodeRemote){await this.b.copy(g,c);return}const u={type:"GET",url:g.toString(!0)},h=await this.a.request(u,l);if(h.res.statusCode===200)await this.b.writeFile(c,h.stream);else{const w=await(0,O.$6p)(h);throw new Error(`Expected 200, got back ${h.res.statusCode} instead.

${w}`)}}};t.$AR=A,t.$AR=A=we([ne(0,O.$1p),ne(1,y.$_k)],A)}),define(re[144],oe([0,1,145,3]),function(H,t,E,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$0r=O;function y(A,k){return A.protocol==="http:"?k.HTTP_PROXY||k.http_proxy||null:A.protocol==="https:"&&(k.HTTPS_PROXY||k.https_proxy||k.HTTP_PROXY||k.http_proxy)||null}async function O(A,k,g={}){const c=(0,E.parse)(A),l=g.proxyUrl||y(c,k);if(!l)return null;const u=(0,E.parse)(l);if(!/^https?:$/.test(u.protocol||""))return null;const h={host:u.hostname||"",port:(u.port?+u.port:0)||(u.protocol==="https"?443:80),auth:u.auth,rejectUnauthorized:(0,P.$lg)(g.strictSSL)?g.strictSSL:!0};return c.protocol==="http:"?new(await new Promise((w,m)=>{H(["http-proxy-agent"],w,m)}).then(ye)).HttpProxyAgent(l,h):new(await new Promise((w,m)=>{H(["https-proxy-agent"],w,m)}).then(ye)).HttpsProxyAgent(l,h)}}),define(re[146],oe([0,1,60,16,112,22,38,9,13,29,90,176,8,78]),function(H,t,E,P,y,O,A,k,g,c,l,u,h,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Qm=R;let m;async function R(f,$,I,v){return I["force-disable-user-env"]?($.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):g.$i?($.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,u.$Jm)(v)&&!I["force-user-env"]?($.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,u.$Jm)(v)?$.trace("resolveShellEnv(): running (--force-user-env)"):$.trace("resolveShellEnv(): running (macOS/Linux)"),m||(m=h.Promises.withAsyncBody(async(e,a)=>{const n=new O.$xe;let r=1e4;const i=f.getValue("application.shellEnvironmentResolutionTimeout");typeof i=="number"&&(r=(0,w.$Km)(i,1,120)*1e3);const s=setTimeout(()=>{n.dispose(!0),a(new Error((0,y.localize)(0,null)))},r);try{e(await p($,n.token))}catch(o){!(0,k.$6)(o)&&!n.token.isCancellationRequested?a(new Error((0,y.localize)(1,null,(0,A.$qj)(o)))):e({})}finally{clearTimeout(s),n.dispose()}})),m)}async function p(f,$){const I=process.env.ELECTRON_RUN_AS_NODE;f.trace("getUnixShellEnvironment#runAsNode",I);const v=process.env.ELECTRON_NO_ATTACH_CONSOLE;f.trace("getUnixShellEnvironment#noAttach",v);const e=(0,c.$2g)().replace(/-/g,"").substr(0,12),a=new RegExp(e+"({.*})"+e),n={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};f.trace("getUnixShellEnvironment#env",n);const r=await(0,l.$zm)(g.OS,n);return f.trace("getUnixShellEnvironment#shell",r),new Promise((i,s)=>{if($.isCancellationRequested)return s(new k.$7);const o=(0,P.$pc)(r);let d,S;const N="";/^pwsh(-preview)?$/.test(o)?(d=`& '${process.execPath}' ${N} -p '''${e}'' + JSON.stringify(process.env) + ''${e}'''`,S=["-Login","-Command"]):o==="nu"?(d=`^'${process.execPath}' ${N} -p '"${e}" + JSON.stringify(process.env) + "${e}"'`,S=["-i","-l","-c"]):o==="xonsh"?(d=`import os, json; print("${e}", json.dumps(dict(os.environ)), "${e}")`,S=["-i","-l","-c"]):(d=`'${process.execPath}' ${N} -p '"${e}" + JSON.stringify(process.env) + "${e}"'`,o==="tcsh"||o==="csh"?S=["-ic"]:S=["-i","-l","-c"]),f.trace("getUnixShellEnvironment#spawn",JSON.stringify(S),d);const C=(0,E.spawn)(r,[...S,d],{detached:!0,stdio:["ignore","pipe","pipe"],env:n});$.onCancellationRequested(()=>(C.kill(),s(new k.$7))),C.on("error",M=>{f.error("getUnixShellEnvironment#errorChildProcess",(0,A.$qj)(M)),s(M)});const D=[];C.stdout.on("data",M=>D.push(M));const T=[];C.stderr.on("data",M=>T.push(M)),C.on("close",(M,K)=>{const Y=Buffer.concat(D).toString("utf8");f.trace("getUnixShellEnvironment#raw",Y);const ae=Buffer.concat(T).toString("utf8");if(ae.trim()&&f.trace("getUnixShellEnvironment#stderr",ae),M||K)return s(new Error((0,y.localize)(2,null,M,K)));const le=a.exec(Y),ce=le?le[1]:"{}";try{const de=JSON.parse(ce);I?de.ELECTRON_RUN_AS_NODE=I:delete de.ELECTRON_RUN_AS_NODE,v?de.ELECTRON_NO_ATTACH_CONSOLE=v:delete de.ELECTRON_NO_ATTACH_CONSOLE,delete de.VSCODE_RESOLVING_ENVIRONMENT,delete de.XDG_RUNTIME_DIR,f.trace("getUnixShellEnvironment#result",de),i(de)}catch(de){f.error("getUnixShellEnvironment#errorCaught",(0,A.$qj)(de)),s(de)}})})}}),define(re[147],oe([0,1,11]),function(H,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$dR=t.$cR=void 0,t.$cR=(0,E.$Fi)("stateReadService"),t.$dR=(0,E.$Fi)("stateService")}),define(re[69],oe([0,1,8,14,2,3,18,10,6]),function(H,t,E,P,y,O,A,k,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$gR=t.$fR=t.$eR=t.SaveStrategy=void 0;var c;(function(w){w[w.IMMEDIATE=0]="IMMEDIATE",w[w.DELAYED=1]="DELAYED"})(c||(t.SaveStrategy=c={}));class l extends y.$Wc{constructor(m,R,p,f){super(),this.h=m,this.j=R,this.m=p,this.n=f,this.a=Object.create(null),this.b="",this.c=this.B(new E.$Dh(this.j===c.IMMEDIATE?0:100)),this.f=void 0,this.g=void 0}init(){return this.f||(this.f=this.r()),this.f}async r(){try{this.b=(await this.n.readFile(this.h)).value.toString(),this.a=JSON.parse(this.b)}catch(m){m.fileOperationResult!==k.FileOperationResult.FILE_NOT_FOUND&&this.m.error(m)}}getItem(m,R){const p=this.a[m];return(0,O.$og)(p)?R:p}setItem(m,R){this.setItems([{key:m,data:R}])}setItems(m){let R=!1;for(const{key:p,data:f}of m)this.a[p]!==f&&((0,O.$og)(f)?(0,O.$mg)(this.a[p])||(this.a[p]=void 0,R=!0):(this.a[p]=f,R=!0));R&&this.s()}removeItem(m){(0,O.$mg)(this.a[m])||(this.a[m]=void 0,this.s())}async s(){if(!this.g)return this.c.trigger(()=>this.t())}async t(){if(!this.f)return;await this.f;const m=JSON.stringify(this.a,null,4);if(m!==this.b)try{await this.n.writeFile(this.h,P.$Oe.fromString(m),{atomic:{postfix:".vsctmp"}}),this.b=m}catch(R){this.m.error(R)}}async close(){return this.g||(this.g=this.c.trigger(()=>this.t(),0)),this.g}}t.$eR=l;let u=class extends y.$Wc{constructor(m,R,p,f){super(),this.a=this.B(new l(R.stateResource,m,p,f))}async init(){await this.a.init()}getItem(m,R){return this.a.getItem(m,R)}};t.$fR=u,t.$fR=u=we([ne(1,A.$Mi),ne(2,g.$_j),ne(3,k.$_k)],u);class h extends u{setItem(m,R){this.a.setItem(m,R)}setItems(m){this.a.setItems(m)}removeItem(m){this.a.removeItem(m)}close(){return this.a.close()}}t.$gR=h}),define(re[70],oe([0,1,13,36,29]),function(H,t,E,P,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$qp=A,t.$rp=k;function O(g){if(E.$u===E.Platform.Linux&&/^penguin(\.|$)/i.test(g))return"chromebook"}function A(g,c,l,u,h,w,m,R,p,f){const $=Object.create(null);$["common.machineId"]=w,$["common.sqmId"]=m,$["common.devDeviceId"]=R,$.sessionID=(0,y.$2g)()+Date.now(),$.commitHash=u,$.version=h,$["common.platformVersion"]=(g||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),$["common.platform"]=(0,E.$h)(E.$u),$["common.nodePlatform"]=P.$fc,$["common.nodeArch"]=l,$["common.product"]=f||"desktop",p&&($["common.msftInternal"]=p);let I=0;const v=Date.now();Object.defineProperties($,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-v,enumerable:!0},"common.sequence":{get:()=>I++,enumerable:!0}}),E.$l&&($["common.snap"]="true");const e=O(c);return e&&($["common.platformDetail"]=e),$}function k(g){const c=P.env.USERDNSDOMAIN;if(!c)return!1;const l=c.toLowerCase();return g.some(u=>l===u)}}),define(re[19],oe([0,1,11]),function(H,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.TelemetryConfiguration=t.TelemetryLevel=t.$jm=t.$im=t.$hm=t.$gm=t.$fm=t.$em=t.$dm=t.$cm=t.$bm=t.$am=t.$_l=t.$$l=void 0,t.$$l=(0,E.$Fi)("telemetryService"),t.$_l=(0,E.$Fi)("customEndpointTelemetryService"),t.$am="telemetry.currentSessionDate",t.$bm="telemetry.firstSessionDate",t.$cm="telemetry.lastSessionDate",t.$dm="telemetry.machineId",t.$em="telemetry.sqmId",t.$fm="telemetry.devDeviceId",t.$gm="telemetry",t.$hm="telemetry.telemetryLevel",t.$im="telemetry.enableCrashReporter",t.$jm="telemetry.enableTelemetry";var P;(function(O){O[O.NONE=0]="NONE",O[O.CRASH=1]="CRASH",O[O.ERROR=2]="ERROR",O[O.USAGE=3]="USAGE"})(P||(t.TelemetryLevel=P={}));var y;(function(O){O.OFF="off",O.CRASH="crash",O.ERROR="error",O.ON="all"})(y||(t.TelemetryConfiguration=y={}))}),define(re[71],oe([0,1,9,11,6,19]),function(H,t,E,P,y,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$oq=t.$nq=t.ExtensionSignatureVerificationCode=t.$mq=void 0,t.$mq=(0,P.$Fi)("IExtensionSignatureVerificationService");var A;(function(c){c.Success="Success",c.RequiredArgumentMissing="RequiredArgumentMissing",c.InvalidArgument="InvalidArgument",c.PackageIsUnreadable="PackageIsUnreadable",c.UnhandledException="UnhandledException",c.SignatureManifestIsMissing="SignatureManifestIsMissing",c.SignatureManifestIsUnreadable="SignatureManifestIsUnreadable",c.SignatureIsMissing="SignatureIsMissing",c.SignatureIsUnreadable="SignatureIsUnreadable",c.CertificateIsUnreadable="CertificateIsUnreadable",c.SignatureArchiveIsUnreadable="SignatureArchiveIsUnreadable",c.FileAlreadyExists="FileAlreadyExists",c.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip",c.SignatureArchiveHasSameSignatureFile="SignatureArchiveHasSameSignatureFile",c.PackageIntegrityCheckFailed="PackageIntegrityCheckFailed",c.SignatureIsInvalid="SignatureIsInvalid",c.SignatureManifestIsInvalid="SignatureManifestIsInvalid",c.SignatureIntegrityCheckFailed="SignatureIntegrityCheckFailed",c.EntryIsMissing="EntryIsMissing",c.EntryIsTampered="EntryIsTampered",c.Untrusted="Untrusted",c.CertificateRevoked="CertificateRevoked",c.SignatureIsNotValid="SignatureIsNotValid",c.UnknownError="UnknownError",c.PackageIsInvalidZip="PackageIsInvalidZip",c.SignatureArchiveHasTooManyEntries="SignatureArchiveHasTooManyEntries"})(A||(t.ExtensionSignatureVerificationCode=A={}));class k extends Error{constructor(l){super(l),this.code=l}}t.$nq=k;let g=class{constructor(l,u){this.b=l,this.c=u}d(){return this.a||(this.a=new Promise((l,u)=>H(["@vscode/vsce-sign"],async h=>l(h),u))),this.a}async verify(l,u,h,w){let m;const R=l.identifier.id;try{m=await this.d()}catch(I){return this.b.error("Could not load vsce-sign module",(0,E.$_)(I)),this.b.info(`Extension signature verification is not done: ${R}`),!1}const p=new Date().getTime();let f;try{this.b.trace(`Verifying extension signature for ${R}...`),f=await m.verify(u,h,this.b.getLevel()===y.LogLevel.Trace)}catch(I){f={code:A.UnknownError,didExecute:!1,output:(0,E.$_)(I)}}const $=new Date().getTime()-p;if(this.b.info(`Extension signature verification result for ${R}: ${f.code}. Executed: ${f.didExecute}. Duration: ${$}ms.`),this.b.trace(`Extension signature verification output for ${R}:
${f.output}`),this.c.publicLog2("extensionsignature:verification",{extensionId:R,extensionVersion:l.version,code:f.code,internalCode:f.internalCode,duration:$,didExecute:f.didExecute,clientTargetPlatform:w}),f.code===A.Success)return!0;throw new k(f.code)}};t.$oq=g,t.$oq=g=we([ne(0,y.$_j),ne(1,O.$$l)],g)}),define(re[41],oe([0,1,28,3,67,70,19]),function(H,t,E,P,y,O,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$yp=t.$xp=t.$wp=t.$vp=t.$up=t.$tp=t.$sp=void 0,t.$zp=l,t.$Ap=u,t.$Bp=h,t.$Cp=w,t.$Dp=R,t.$Ep=f,t.$Fp=$,t.$Gp=e;class k{constructor(n){this.value=n,this.isTrustedTelemetryValue=!0}}t.$sp=k;class g{constructor(){this.telemetryLevel=A.TelemetryLevel.NONE,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.devDeviceId="someValue.devDeviceId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}t.$tp=g,t.$up=new g;class c{async publicLog(n,r,i){}async publicLogError(n,r,i){}}t.$vp=c,t.$wp="telemetry",t.$xp="extensionTelemetryLog",t.$yp={log:()=>null,flush:()=>Promise.resolve(null)};function l(a,n){return!n.isBuilt&&!n.disableTelemetry?!0:!(n.disableTelemetry||!a.enableTelemetry)}function u(a,n){return n.extensionTestsLocationURI?!0:!(n.isBuilt||n.disableTelemetry||a.enableTelemetry&&a.aiConfig?.ariaKey)}function h(a){const n=a.getValue(A.$hm),r=a.getValue(A.$im);if(a.getValue(A.$jm)===!1||r===!1)return A.TelemetryLevel.NONE;switch(n??A.TelemetryConfiguration.ON){case A.TelemetryConfiguration.ON:return A.TelemetryLevel.USAGE;case A.TelemetryConfiguration.ERROR:return A.TelemetryLevel.ERROR;case A.TelemetryConfiguration.CRASH:return A.TelemetryLevel.CRASH;case A.TelemetryConfiguration.OFF:return A.TelemetryLevel.NONE}}function w(a){const n={},r={},i={};p(a,i);for(let s in i){s=s.length>150?s.substr(s.length-149):s;const o=i[s];typeof o=="number"?r[s]=o:typeof o=="boolean"?r[s]=o?1:0:typeof o=="string"?(o.length>8192&&console.warn(`Telemetry property: ${s} has been trimmed to 8192, the original length is ${o.length}`),n[s]=o.substring(0,8191)):typeof o<"u"&&o!==null&&(n[s]=o)}return{properties:n,measurements:r}}const m=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function R(a){if(!a)return"none";const n=(0,y.$hn)(a);return m.has(n)?n:"other"}function p(a,n,r=0,i){if(a)for(const s of Object.getOwnPropertyNames(a)){const o=a[s],d=i?i+s:s;Array.isArray(o)?n[d]=(0,E.$go)(o):o instanceof Date?n[d]=o.toISOString():(0,P.$hg)(o)?r<2?p(o,n,r+1,d+"."):n[d]=(0,E.$go)(o):n[d]=o}}function f(a,n){const r=a.msftInternalDomains||[],i=n.getValue("telemetry.internalTesting");return(0,O.$rp)(r)||i}function $(a){return[a.appRoot,a.extensionsPath,a.userHome.fsPath,a.tmpDir.fsPath,a.userDataPath]}function I(a,n){if(!a||!a.includes("/")&&!a.includes("\\"))return a;let r=a;const i=[];for(const S of n)for(;;){const N=S.exec(a);if(!N)break;i.push([N.index,S.lastIndex])}const s=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,o=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let d=0;for(r="";;){const S=o.exec(a);if(!S)break;const N=i.some(([C,D])=>S.index<D&&C<o.lastIndex);!s.test(S[0])&&!N&&(r+=a.substring(d,S.index)+"<REDACTED: user-file-path>",d=o.lastIndex)}return d<a.length&&(r+=a.substr(d)),r}function v(a){if(!a)return a;const n=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"CLI Credentials",regex:/((login|psexec|(certutil|psexec)\.exe).{1,50}(\s-u(ser(name)?)?\s+.{3,100})?\s-(admin|user|vm|root)?p(ass(word)?)?\s+["']?[^$\-\/\s]|(^|[\s\r\n\\])net(\.exe)?.{1,5}(user\s+|share\s+\/user:| user -? secrets ? set) \s + [^ $\s \/])/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const r of n)if(r.regex.test(a))return`<REDACTED: ${r.label}>`;return a}function e(a,n){return(0,E.$do)(a,r=>{if(r instanceof k||Object.hasOwnProperty.call(r,"isTrustedTelemetryValue"))return r.value;if(typeof r=="string"){let i=r.replaceAll("%20"," ");i=I(i,n);for(const s of n)i=i.replace(s,"");return i=v(i),i}})}}),define(re[27],oe([0,1,32,21,26,13,12,9,36,41]),function(H,t,E,P,y,O,A,k,g,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Qp=t.$Ip=void 0,t.$Hp=l,t.$Jp=m,t.$Kp=R,t.$Lp=p,t.$Mp=f,t.$Np=$,t.$Op=I,t.$Pp=v,t.$Rp=e,t.$Sp=n;function l(r,i){return r.uuid&&i.uuid?r.uuid===i.uuid:r.id===i.id?!0:(0,E.$Bf)(r.id,i.id)===0}const u=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class h{static create(i){const s=i.manifest?i.manifest.version:i.version,o=i.manifest?i.targetPlatform:i.properties.targetPlatform;return new h(i.identifier,s,o)}static parse(i){const s=u.exec(i);return s&&s[1]&&s[2]?new h({id:s[1]},s[2],s[4]||void 0):null}constructor(i,s,o=y.TargetPlatform.UNDEFINED){this.identifier=i,this.version=s,this.targetPlatform=o,this.id=i.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!==y.TargetPlatform.UNDEFINED?`-${this.targetPlatform}`:""}`}equals(i){return i instanceof h?l(this,i)&&this.version===i.version&&this.targetPlatform===i.targetPlatform:!1}}t.$Ip=h;const w=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function m(r){const i=w.exec(r);return i&&i[1]?[p(i[1]),i[2]]:[p(r),void 0]}function R(r,i){return`${r}.${i}`}function p(r){return r.toLowerCase()}function f(r,i){return p(R(r??y.$mn,i))}function $(r,i){const s=[],o=d=>{for(const S of s)if(S.some(N=>l(i(N),i(d))))return S;return null};for(const d of r){const S=o(d);S?S.push(d):s.push([d])}return s}function I(r){return{id:r.identifier.id,name:r.manifest.name,galleryId:null,publisherId:r.publisherId,publisherName:r.manifest.publisher,publisherDisplayName:r.publisherDisplayName,dependencies:r.manifest.extensionDependencies&&r.manifest.extensionDependencies.length>0}}function v(r){return{id:new c.$sp(r.identifier.id),name:new c.$sp(r.name),version:r.version,galleryId:r.identifier.uuid,publisherId:r.publisherId,publisherName:r.publisher,publisherDisplayName:r.publisherDisplayName,isPreReleaseVersion:r.properties.isPreReleaseVersion,dependencies:!!(r.properties.dependencies&&r.properties.dependencies.length>0),isSigned:r.isSigned,...r.telemetryData}}t.$Qp=new y.$qn("pprice.better-merge");function e(r,i){const s=[],o=i.manifest.extensionDependencies?.slice(0)??[];for(;o.length;){const d=o.shift();if(d&&s.every(S=>!l(S.identifier,{id:d}))){const S=r.filter(N=>l(N.identifier,{id:d}));S.length===1&&(s.push(S[0]),o.push(...S[0].manifest.extensionDependencies?.slice(0)??[]))}}return s}async function a(r,i){if(!O.$k)return!1;let s;try{s=(await r.readFile(A.URI.file("/etc/os-release"))).value.toString()}catch{try{s=(await r.readFile(A.URI.file("/usr/lib/os-release"))).value.toString()}catch(d){i.debug("Error while getting the os-release file.",(0,k.$_)(d))}}return!!s&&(s.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function n(r,i){const s=await a(r,i),o=(0,P.$cp)(s?"alpine":O.$u,g.$gc);return i.debug("ComputeTargetPlatform:",o),o}}),define(re[148],oe([0,1,22,9,15,17,44,12,100,21,27,26]),function(H,t,E,P,y,O,A,k,g,c,l,u){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$pq=void 0;const h=R=>(0,g.localize)(0,null,R),w=(0,g.localize)(1,null,"ms-dotnettools.csharp");let m=class{constructor(p,f,$){this.a=p,this.b=f,this.d=$}get f(){}async listExtensions(p,f,$){let I=await this.b.getInstalled(u.ExtensionType.User,$);const v=u.$pn.map(a=>a.toLowerCase());if(f&&f!==""){if(v.indexOf(f.toLowerCase())<0){this.a.info("Invalid category please enter a valid category. To list valid categories run --category without a category specified");return}I=I.filter(a=>a.manifest.categories?a.manifest.categories.map(r=>r.toLowerCase()).indexOf(f.toLowerCase())>-1:!1)}else if(f===""){this.a.info("Possible Categories: "),v.forEach(a=>{this.a.info(a)});return}this.f&&this.a.info((0,g.localize)(2,null,this.f)),I=I.sort((a,n)=>a.identifier.id.localeCompare(n.identifier.id));let e;for(const a of I)e!==a.identifier.id&&(e=a.identifier.id,this.a.info(p?`${e}@${a.manifest.version}`:e))}async installExtensions(p,f,$,I){const v=[];try{p.length&&this.a.info(this.f?(0,g.localize)(3,null,this.f):(0,g.localize)(4,null));const e=[],a=[],n=(i,s,o)=>{a.push({id:i,version:s!=="prerelease"?s:void 0,installOptions:{...$,isBuiltin:o,installPreReleaseVersion:s==="prerelease"||$.installPreReleaseVersion}})};for(const i of p)if(i instanceof k.URI)e.push({vsix:i,installOptions:$});else{const[s,o]=(0,l.$Jp)(i);n(s,o,!1)}for(const i of f)if(i instanceof k.URI)e.push({vsix:i,installOptions:{...$,isBuiltin:!0,donotIncludePackAndDependencies:!0}});else{const[s,o]=(0,l.$Jp)(i);n(s,o,!0)}const r=await this.b.getInstalled(void 0,$.profileLocation);if(e.length&&await Promise.all(e.map(async({vsix:i,installOptions:s})=>{try{await this.h(i,s,I,r)}catch(o){this.a.error(o),v.push(i.toString())}})),a.length){const i=await this.g(a,r,I);v.push(...i)}}catch(e){throw this.a.error((0,g.localize)(5,null,(0,P.$_)(e))),e}if(v.length)throw new Error((0,g.localize)(6,null,v.join(", ")))}async updateExtensions(p){const f=await this.b.getInstalled(u.ExtensionType.User,p),$=[];for(const a of f)a.identifier.uuid&&$.push({...a.identifier,preRelease:a.preRelease});this.a.trace((0,g.localize)(7,null,$.length));const I=await this.d.getExtensions($,{compatible:!0},E.CancellationToken.None),v=[];for(const a of I)for(const n of f)(0,l.$Hp)(n.identifier,a.identifier)&&(0,A.gt)(a.version,n.manifest.version)&&v.push({extension:a,options:{operation:c.InstallOperation.Update,installPreReleaseVersion:n.preRelease,profileLocation:p,isApplicationScoped:n.isApplicationScoped}});if(!v.length){this.a.info((0,g.localize)(8,null));return}this.a.info((0,g.localize)(9,null,v.map(a=>a.extension.identifier.id).join(", ")));const e=await this.b.installGalleryExtensions(v);for(const a of e)a.error?this.a.error((0,g.localize)(10,null,a.identifier.id,(0,P.$_)(a.error))):this.a.info((0,g.localize)(11,null,a.identifier.id,a.local?.manifest.version))}async g(p,f,$){if(p=p.filter(({id:a,version:n})=>{const r=f.find(i=>(0,l.$Hp)(i.identifier,{id:a}));if(r){if(!$&&(!n||n==="prerelease"&&r.preRelease))return this.a.info((0,g.localize)(12,null,a,r.manifest.version,a)),!1;if(n&&r.manifest.version===n)return this.a.info((0,g.localize)(13,null,`${a}@${n}`)),!1}return!0}),!p.length)return[];const I=[],v=[],e=await this.j(p);if(await Promise.all(p.map(async({id:a,version:n,installOptions:r})=>{const i=e.get(a.toLowerCase());if(!i){this.a.error(`${h(n?`${a}@${n}`:a)}
${w}`),I.push(a);return}try{const o=await this.d.getManifest(i,E.CancellationToken.None);if(o&&!this.k(o))return}catch(o){this.a.error(o.message||o.stack||o),I.push(a);return}const s=f.find(o=>(0,l.$Hp)(o.identifier,i.identifier));if(s){if(i.version===s.manifest.version){this.a.info((0,g.localize)(14,null,n?`${a}@${n}`:a));return}this.a.info((0,g.localize)(15,null,a,i.version))}r.isBuiltin?this.a.info(n?(0,g.localize)(16,null,a,n):(0,g.localize)(17,null,a)):this.a.info(n?(0,g.localize)(18,null,a,n):(0,g.localize)(19,null,a)),v.push({extension:i,options:{...r,installGivenVersion:!!n,isApplicationScoped:s?.isApplicationScoped}})})),v.length){const a=await this.b.installGalleryExtensions(v);for(const n of a)n.error?(this.a.error((0,g.localize)(20,null,n.identifier.id,(0,P.$_)(n.error))),I.push(n.identifier.id)):this.a.info((0,g.localize)(21,null,n.identifier.id,n.local?.manifest.version))}return I}async h(p,f,$,I){const v=await this.b.getManifest(p);if(!v)throw new Error("Invalid vsix");if(await this.l(v,$,f.profileLocation,I))try{await this.b.install(p,f),this.a.info((0,g.localize)(22,null,(0,O.$dh)(p)))}catch(a){if((0,P.$6)(a))this.a.info((0,g.localize)(23,null,(0,O.$dh)(p)));else throw a}}async j(p){const f=new Map,$=p.some(e=>e.installOptions.installPreReleaseVersion),I=await this.b.getTargetPlatform(),v=[];for(const e of p)c.$7o.test(e.id)&&v.push({...e,preRelease:$});if(v.length){const e=await this.d.getExtensions(v,{targetPlatform:I},E.CancellationToken.None);for(const a of e)f.set(a.identifier.id.toLowerCase(),a)}return f}k(p){return!0}async l(p,f,$,I){if(!f){const v={id:(0,l.$Mp)(p.publisher,p.name)},e=I.find(a=>(0,l.$Hp)(v,a.identifier)&&(0,A.gt)(a.manifest.version,p.version));if(e)return this.a.info((0,g.localize)(24,null,e.identifier.id,e.manifest.version,p.version)),!1}return this.k(p)}async uninstallExtensions(p,f,$){const I=async e=>{if(e instanceof k.URI){const a=await this.b.getManifest(e);return(0,l.$Kp)(a.publisher,a.name)}return e},v=[];for(const e of p){const a=await I(e),r=(await this.b.getInstalled(void 0,$)).filter(i=>(0,l.$Hp)(i.identifier,{id:a}));if(!r.length)throw new Error(`${this.m(a)}
${w}`);if(r.some(i=>i.type===u.ExtensionType.System)){this.a.info((0,g.localize)(25,null,a));return}if(!f&&r.some(i=>i.isBuiltin)){this.a.info((0,g.localize)(26,null,a));return}this.a.info((0,g.localize)(27,null,a));for(const i of r)await this.b.uninstall(i,{profileLocation:$}),v.push(i);this.f?this.a.info((0,g.localize)(28,null,a,this.f)):this.a.info((0,g.localize)(29,null,a))}}async locateExtension(p){const f=await this.b.getInstalled();p.forEach($=>{f.forEach(I=>{if(I.identifier.id===$&&I.location.scheme===y.Schemas.file){this.a.info(I.location.fsPath);return}})})}m(p){return this.f?(0,g.localize)(30,null,p,this.f):(0,g.localize)(31,null,p)}};t.$pq=m,t.$pq=m=we([ne(1,c.$jp),ne(2,c.$gp)],m)}),define(re[149],oe([0,1,5,2,31,27,26,10]),function(H,t,E,P,y,O,A,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Qq=void 0;class g extends P.$Wc{constructor(l,u,h,w,m,R,p){super(),this.f=l,this.g=u,this.h=h,this.j=w,this.m=m,this.n=R,this.r=p,this.a=this.B(new E.$me),this.onDidChangeExtensionsByAnotherSource=this.a.event,this.b=new Map,this.c=this.B(new P.$6c),this.s().then(null,f=>p.error(f))}async s(){await this.g.initializeDefaultProfileExtensions(),await this.u(this.h.profiles),this.t(),await this.H()}t(){this.B(this.h.onDidChangeProfiles(l=>this.u(l.added))),this.B(this.j.onAddExtensions(l=>this.w(l))),this.B(this.j.onDidAddExtensions(l=>this.y(l))),this.B(this.j.onRemoveExtensions(l=>this.z(l))),this.B(this.j.onDidRemoveExtensions(l=>this.C(l))),this.B(this.n.onDidFilesChange(l=>this.D(l)))}async u(l){try{l.length&&await Promise.all(l.map(u=>(this.c.set(u.id,(0,P.$Tc)(this.n.watch(this.m.extUri.dirname(u.extensionsResource)),this.n.watch(u.extensionsResource))),this.G(u.extensionsResource))))}catch(u){throw this.r.error(u),u}}async w(l){for(const u of l.extensions)this.I(this.L(u.identifier,u.version),l.profileLocation)}async y(l){for(const u of l.extensions){const h=this.L(u.identifier,u.version);l.error?this.J(h,l.profileLocation):this.I(h,l.profileLocation)}}async z(l){for(const u of l.extensions)this.J(this.L(u.identifier,u.version),l.profileLocation)}async C(l){const u=[],h=[];for(const w of l.extensions){const m=this.L(w.identifier,w.version);l.error?this.I(m,l.profileLocation):(this.J(m,l.profileLocation),this.b.has(m)||(this.r.debug("Extension is removed from all profiles",w.identifier.id,w.version),h.push(this.f.scanInstalledExtensionAtLocation(w.location).then(R=>{R?u.push(R):this.r.info("Extension not found at the location",w.location.toString())},R=>this.r.error(R)))))}try{await Promise.all(h),u.length&&await this.H(u)}catch(w){this.r.error(w)}}D(l){for(const u of this.h.profiles)l.contains(u.extensionsResource,k.FileChangeType.UPDATED,k.FileChangeType.ADDED)&&this.F(u.extensionsResource)}async F(l){const u=[],h=[],w=await this.j.scanProfileExtensions(l),m=new Set,R=new Set;for(const[p,f]of this.b)f.has(l)&&R.add(p);for(const p of w){const f=this.L(p.identifier,p.version);m.add(f),R.has(f)||(u.push(p.identifier),this.I(f,l))}for(const p of R)if(!m.has(p)){const f=this.M(p);f&&(h.push(f.identifier),this.J(p,l))}(u.length||h.length)&&this.a.fire({added:u.length?{extensions:u,profileLocation:l}:void 0,removed:h.length?{extensions:h,profileLocation:l}:void 0})}async G(l){const u=await this.j.scanProfileExtensions(l);for(const h of u)this.I(this.L(h.identifier,h.version),l)}async H(l){l||(l=(await this.f.scanAllUserInstalledExtensions()).filter(h=>!this.b.has(this.L(h.identifier,h.manifest.version)))),l.length&&await this.f.markAsUninstalled(...l)}I(l,u){let h=this.b.get(l);h||this.b.set(l,h=new y.$Dc(w=>this.m.extUri.getComparisonKey(w))),h.add(u)}J(l,u){const h=this.b.get(l);h&&h.delete(u),h?.size||this.b.delete(l)}L(l,u){return`${A.$qn.toKey(l.id)}@${u}`}M(l){const[u,h]=(0,O.$Jp)(l);return h?{identifier:{id:u},version:h}:void 0}}t.$Qq=g}),define(re[150],oe([0,1,177,20,8,2,15,16,25,18,21,27,6,68,12]),function(H,t,E,P,y,O,A,k,g,c,l,u,h,w,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$7r=void 0;let R=class extends w.$6r{constructor(I,v,e,a){super(e),this.h=I,this.j=a,this.g=this.B(new p(v,a)),this.h.registerParticipant({postInstall:async n=>this.m(n),postUninstall:async n=>this.n(n)})}async getBuiltInExtensionTranslationsUri(I,v){const a=(await this.g.getLanguagePacks())[v];if(!a){this.j.warn(`No language pack found for ${v}`);return}const n=a.translations[I];return n?m.URI.file(n):void 0}async getInstalledLanguages(){const I=await this.g.getLanguagePacks(),v=Object.keys(I).map(e=>{const a=I[e];return{...this.f(e,a.label),extensionId:a.extensions[0].extensionIdentifier.id}});return v.push(this.f("en","English")),v.sort((e,a)=>e.label.localeCompare(a.label)),v}async m(I){I&&I.manifest&&I.manifest.contributes&&I.manifest.contributes.localizations&&I.manifest.contributes.localizations.length&&(this.j.info("Adding language packs from the extension",I.identifier.id),await this.update())}async n(I){const v=await this.g.getLanguagePacks();Object.keys(v).some(e=>v[e]&&v[e].extensions.some(a=>(0,u.$Hp)(a.extensionIdentifier,I.identifier)))&&(this.j.info("Removing language packs from the extension",I.identifier.id),await this.update())}async update(){const[I,v]=await Promise.all([this.g.getLanguagePacks(),this.h.getInstalled()]),e=await this.g.update(v);return!(0,P.$wb)(Object.keys(I),Object.keys(e))}};t.$7r=R,t.$7r=R=we([ne(0,l.$jp),ne(1,c.$Ni),ne(2,l.$gp),ne(3,h.$_j)],R);let p=class extends O.$Wc{constructor(I,v){super(),this.j=v,this.c={},this.f=(0,k.$lc)(I.userDataPath,"languagepacks.json"),this.g=new y.$Mh}getLanguagePacks(){return this.g.size||!this.h?this.s().then(()=>this.c):Promise.resolve(this.c)}update(I){return this.s(v=>{Object.keys(v).forEach(e=>delete v[e]),this.m(v,...I)}).then(()=>this.c)}m(I,...v){for(const e of v)e&&e.manifest&&e.manifest.contributes&&e.manifest.contributes.localizations&&e.manifest.contributes.localizations.length&&this.n(I,e);Object.keys(I).forEach(e=>this.r(I[e]))}n(I,v){const e=v.identifier,a=v.manifest.contributes&&v.manifest.contributes.localizations?v.manifest.contributes.localizations:[];for(const n of a)if(v.location.scheme===A.Schemas.file&&f(n)){let r=I[n.languageId];r||(r={hash:"",extensions:[],translations:{},label:n.localizedLanguageName??n.languageName},I[n.languageId]=r);const i=r.extensions.filter(s=>(0,u.$Hp)(s.extensionIdentifier,e))[0];i?i.version=v.manifest.version:r.extensions.push({extensionIdentifier:e,version:v.manifest.version});for(const s of n.translations)r.translations[s.id]=(0,k.$lc)(v.location.fsPath,s.path)}}r(I){if(I){const v=(0,E.createHash)("md5");for(const e of I.extensions)v.update(e.extensionIdentifier.uuid||e.extensionIdentifier.id).update(e.version);I.hash=v.digest("hex")}}s(I=()=>null){return this.g.queue(()=>{let v=null;return g.Promises.readFile(this.f,"utf8").then(void 0,e=>e.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(e)).then(e=>{try{return JSON.parse(e)}catch{return{}}}).then(e=>(v=I(e),e)).then(e=>{for(const n of Object.keys(e))e[n]||delete e[n];this.c=e,this.h=!0;const a=JSON.stringify(this.c);return this.j.debug("Writing language packs",a),g.Promises.writeFile(this.f,a)}).then(()=>v,e=>this.j.error(e))})}};p=we([ne(0,c.$Ni),ne(1,h.$_j)],p);function f($){if(typeof $.languageId!="string"||!Array.isArray($.translations)||$.translations.length===0)return!1;for(const I of $.translations)if(typeof I.id!="string"||typeof I.path!="string")return!1;return!($.languageName&&typeof $.languageName!="string"||$.localizedLanguageName&&typeof $.localizedLanguageName!="string")}}),define(re[151],oe([0,1,87,9,28,41]),function(H,t,E,P,y,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$$Q=void 0;const A="https://mobile.events.data.microsoft.com/OneCollector/1.0",k="https://mobile.events.data.microsoft.com/ping";async function g(l,u,h){const w=await(0,E.$oE)("@microsoft/1ds-core-js","dist/ms.core.js"),m=await(0,E.$oE)("@microsoft/1ds-post-js","dist/ms.post.js"),R=new w.AppInsightsCore,p=new m.PostChannel,f={instrumentationKey:l,endpointUrl:A,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[p]]};if(h){f.extensionConfig={};const $={alwaysUseXhrOverride:!0,ignoreMc1Ms0CookieProcessing:!0,httpXHROverride:h};f.extensionConfig[p.identifier]=$}return R.initialize(f,[]),R.addTelemetryInitializer($=>{$.ext=$.ext??{},$.ext.web=$.ext.web??{},$.ext.web.consentDetails='{"GPC_DataSharingOptIn":false}',u&&($.ext.utc=$.ext.utc??{},$.ext.utc.flags=8462029)}),R}class c{constructor(u,h,w,m,R){this.e=u,this.f=h,this.g=w,this.h=R,this.c=A,this.d=k,this.g||(this.g={}),typeof m=="function"?this.a=m():this.a=m,this.b=null}i(u){if(this.a){if(typeof this.a!="string"){u(this.a);return}this.b||(this.b=g(this.a,this.e,this.h)),this.b.then(h=>{u(h)},h=>{(0,P.$3)(h),console.error(h)})}}log(u,h){if(!this.a)return;h=(0,y.$eo)(h,this.g),h=(0,O.$Cp)(h);const w=this.f+"/"+u;try{this.i(m=>{m.pluginVersionString=h?.properties.version??"Unknown",m.track({name:w,baseData:{name:w,properties:h?.properties,measurements:h?.measurements}})})}catch{}}flush(){return this.a?new Promise(u=>{this.i(h=>{h.unload(!0,()=>{this.a=void 0,u(void 0)})})}):Promise.resolve(void 0)}}t.$$Q=c});var qe=this&&this.__importDefault||function(H){return H&&H.__esModule?H:{default:H}};define(re[152],oe([0,1,2,28,13,32,113,30,40,153,33,37,19,41]),function(H,t,E,P,y,O,A,k,g,c,l,u,h,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$as=void 0,c=qe(c);let m=class{static{this.IDLE_START_EVENT_NAME="UserIdleStart"}static{this.IDLE_STOP_EVENT_NAME="UserIdleStop"}constructor(f,$,I){this.k=$,this.l=I,this.d={},this.i=new E.$Vc,this.j=[],this.b=f.appenders,this.c=f.commonProperties??Object.create(null),this.sessionId=this.c.sessionID,this.machineId=this.c["common.machineId"],this.sqmId=this.c["common.sqmId"],this.devDeviceId=this.c["common.devDeviceId"],this.firstSessionDate=this.c["common.firstSessionDate"],this.msftInternal=this.c["common.msftInternal"],this.f=f.piiPaths||[],this.g=h.TelemetryLevel.USAGE,this.h=!!f.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const v of this.f)this.j.push(new RegExp((0,O.$if)(v),"gi")),v.indexOf("\\")>=0&&this.j.push(new RegExp((0,O.$if)(v.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(v=>{(v.affectsConfiguration(h.$hm)||v.affectsConfiguration(h.$jm)||v.affectsConfiguration(h.$im))&&this.m()}))}setExperimentProperty(f,$){this.d[f]=$}m(){let f=(0,w.$Bp)(this.k);const $=this.l.enabledTelemetryLevels;if($){this.h=this.sendErrorTelemetry?$.error:!1;const I=$.usage?h.TelemetryLevel.USAGE:$.error?h.TelemetryLevel.ERROR:h.TelemetryLevel.NONE;f=Math.min(f,I)}this.g=f}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}dispose(){this.i.dispose()}n(f,$,I){this.g<$||(I=(0,P.$eo)(I,this.d),I=(0,w.$Gp)(I,this.j),I=(0,P.$eo)(I,this.c),this.b.forEach(v=>v.log(f,I)))}publicLog(f,$){this.n(f,h.TelemetryLevel.USAGE,$)}publicLog2(f,$){this.publicLog(f,$)}publicLogError(f,$){this.h&&this.n(f,h.TelemetryLevel.ERROR,$)}publicLogError2(f,$){this.publicLogError(f,$)}};t.$as=m,t.$as=m=we([ne(1,k.$_i),ne(2,l.$sk)],m);function R(){const p=(0,A.localize)(0,null,c.default.nameLong),f=c.default.privacyStatementUrl?(0,A.localize)(2,null,"https://aka.ms/vscode-telemetry",c.default.privacyStatementUrl):(0,A.localize)(1,null,"https://aka.ms/vscode-telemetry"),$=y.$o?"":(0,A.localize)(3,null),I=(0,A.localize)(4,null),v=(0,A.localize)(5,null),e=(0,A.localize)(6,null),a=(0,A.localize)(7,null),n=`
|       | ${I} | ${v} | ${e} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,r=(0,A.localize)(8,null);return`
${p} ${f} ${$}

&nbsp;

${a}
${n}

&nbsp;

${r}
`}u.$oo.as(g.$to.Configuration).registerConfiguration({id:h.$gm,order:1,type:"object",title:(0,A.localize)(9,null),properties:{[h.$hm]:{type:"string",enum:[h.TelemetryConfiguration.ON,h.TelemetryConfiguration.ERROR,h.TelemetryConfiguration.CRASH,h.TelemetryConfiguration.OFF],enumDescriptions:[(0,A.localize)(10,null),(0,A.localize)(11,null),(0,A.localize)(12,null),(0,A.localize)(13,null)],markdownDescription:R(),default:h.TelemetryConfiguration.ON,restricted:!0,scope:g.ConfigurationScope.APPLICATION,tags:["usesOnlineServices","telemetry"]}}}),u.$oo.as(g.$to.Configuration).registerConfiguration({id:h.$gm,order:110,type:"object",title:(0,A.localize)(14,null),properties:{[h.$jm]:{type:"boolean",markdownDescription:c.default.privacyStatementUrl?(0,A.localize)(16,null,c.default.nameLong,c.default.privacyStatementUrl):(0,A.localize)(15,null,c.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,A.localize)(17,null,`\`#${h.$hm}#\``),scope:g.ConfigurationScope.APPLICATION,tags:["usesOnlineServices","telemetry"]}}})}),define(re[154],oe([0,1,14,22,178,151]),function(H,t,E,P,y,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$_Q=void 0,y=ye(y);async function A(l,u){const h=await u.request(l,P.CancellationToken.None),w=(await(0,E.$1e)(h.stream)).toString(),m=h.res.statusCode??200;return{headers:h.res.headers,statusCode:m,responseData:w}}async function k(l){const u={method:l.type,headers:l.headers};return new Promise((w,m)=>{const R=y.request(l.url??"",u,p=>{p.on("data",function(f){w({headers:p.headers,statusCode:p.statusCode??200,responseData:f.toString()})}),p.on("error",function(f){m(f)})});R.write(l.data,p=>{p&&m(p)}),R.end()})}async function g(l,u,h){const w=typeof u.data=="string"?u.data:new TextDecoder().decode(u.data),m={type:"POST",headers:{...u.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(u.data).toString()},url:u.urlString,data:w};try{const R=l?await A(m,l):await k(m);h(R.statusCode,R.headers,R.responseData)}catch{h(0,{})}}class c extends O.$$Q{constructor(u,h,w,m,R){const p={sendPOST:(f,$)=>{g(u,f,$)}};super(h,w,m,R,p)}}t.$_Q=c}),define(re[155],oe([0,1,16,25]),function(H,t,E,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Jgc=y;async function y(O,A){const k=Object.create(null),g=(l,u)=>{const h=JSON.parse(l);k[u]=h};if(A){const l=[],u=await P.Promises.readdir(A);for(const w of u)try{(await P.Promises.stat((0,E.$lc)(A,w))).isDirectory()&&l.push(w)}catch{}const h=[];for(const w of l)(await P.Promises.readdir((0,E.$lc)(A,w))).filter(R=>R==="telemetry.json").length===1&&h.push(w);for(const w of h){const m=(await P.Promises.readFile((0,E.$lc)(A,w,"telemetry.json"))).toString();g(m,w)}}let c=(await P.Promises.readFile((0,E.$lc)(O,"telemetry-core.json"))).toString();return g(c,"vscode-core"),c=(await P.Promises.readFile((0,E.$lc)(O,"telemetry-extensions.json"))).toString(),g(c,"vscode-extensions"),JSON.stringify(k,null,4)}}),define(re[156],oe([0,1,13,88,19]),function(H,t,E,P,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$6fc=O,t.$7fc=A,t.$8fc=k;async function O(g,c){let l=g.getItem(y.$dm);return(typeof l!="string"||E.$j&&l==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(l=await(0,P.$Qn)(c.error.bind(c))),l}async function A(g,c){let l=g.getItem(y.$em);return typeof l!="string"&&(l=await(0,P.$Rn)(c.error.bind(c))),l}async function k(g,c){let l=g.getItem(y.$fm);return typeof l!="string"&&(l=await(0,P.$Sn)(c.error.bind(c))),l}}),define(re[23],oe([0,1,11]),function(H,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Jl=void 0,t.$Jl=(0,E.$Fi)("IUriIdentityService")}),define(re[157],oe([0,1,23,122,10,17,79,5,2]),function(H,t,E,P,y,O,A,k,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Ns=void 0;class c{static{this._clock=0}constructor(h){this.uri=h,this.time=c._clock++}touch(){return this.time=c._clock++,this}}let l=class{constructor(h){this.g=h,this.c=new g.$Vc,this.f=2**16;const w=new Map,m=R=>{let p=w.get(R.scheme);return p===void 0&&(p=h.hasProvider(R)&&!this.g.hasCapability(R,y.FileSystemProviderCapabilities.PathCaseSensitive),w.set(R.scheme,p)),p};this.c.add(k.Event.any(h.onDidChangeFileSystemProviderRegistrations,h.onDidChangeFileSystemProviderCapabilities)(R=>{w.delete(R.scheme)})),this.extUri=new O.$8g(m),this.d=new A.$Ms((R,p)=>this.extUri.compare(R,p,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(h){this.g.hasProvider(h)&&(h=(0,O.$hh)(h));const w=this.d.get(h);return w?w.touch().uri.with({fragment:h.fragment}):(this.d.set(h,new c(h)),this.h(),h)}h(){if(this.d.size<this.f)return;const h=[...this.d.entries()].sort((m,R)=>m[1].time<R[1].time?1:m[1].time>R[1].time?-1:0);c._clock=0,this.d.clear();const w=this.f*.5;for(let m=0;m<w;m++)this.d.set(h[m][0],h[m][1].touch())}};t.$Ns=l,t.$Ns=l=we([ne(0,y.$_k)],l),(0,P.$Ks)(E.$Jl,l,P.InstantiationType.Delayed)}),define(re[158],oe([0,1,5,2,10,48,31]),function(H,t,E,P,y,O,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$tgc=void 0;class k extends P.$Wc{constructor(c,l,u,h,w,m){super(),this.f=c,this.g=l,this.h=u,this.j=h,this.m=w,this.n=m,this.capabilities=this.g.capabilities,this.onDidChangeCapabilities=this.g.onDidChangeCapabilities,this.a=this.B(new E.$me),this.onDidChangeFile=this.a.event,this.b=O.$Li.forUris(()=>!(this.capabilities&y.FileSystemProviderCapabilities.PathCaseSensitive)),this.c=new A.$Dc(R=>this.m.extUri.getComparisonKey(this.t(R))),this.r(),this.B(h.onDidChangeProfiles(()=>this.r())),this.B(this.g.onDidChangeFile(R=>this.s(R)))}r(){this.c.clear();for(const c of this.j.profiles)this.c.add(c.settingsResource),this.c.add(c.keybindingsResource),this.c.add(c.tasksResource),this.c.add(c.extensionsResource)}open(c,l){return this.g.open(this.t(c),l)}close(c){return this.g.close(c)}read(c,l,u,h,w){return this.g.read(c,l,u,h,w)}write(c,l,u,h,w){return this.g.write(c,l,u,h,w)}watch(c,l){this.b.set(c,c);const u=this.g.watch(this.t(c),l);return(0,P.$Uc)(()=>{this.b.delete(c),u.dispose()})}stat(c){return this.g.stat(this.t(c))}mkdir(c){return this.g.mkdir(this.t(c))}rename(c,l,u){return this.g.rename(this.t(c),this.t(l),u)}readFile(c,l){return this.g.readFile(this.t(c),l)}readFileStream(c,l,u){return this.g.readFileStream(this.t(c),l,u)}readdir(c){return this.g.readdir(this.t(c))}enforceAtomicReadFile(c){return this.c.has(c)}writeFile(c,l,u){return this.g.writeFile(this.t(c),l,u)}enforceAtomicWriteFile(c){return this.c.has(c)?{postfix:".vsctmp"}:!1}delete(c,l){return this.g.delete(this.t(c),l)}copy(c,l,u){if((0,y.$dl)(this.g))return this.g.copy(this.t(c),this.t(l),u);throw new Error("copy not supported")}cloneFile(c,l){if((0,y.$el)(this.g))return this.g.cloneFile(this.t(c),this.t(l));throw new Error("clone not supported")}s(c){const l=[];for(const u of c){if(u.resource.scheme!==this.f)continue;const h=this.u(u.resource);this.b.findSubstr(h)&&l.push({resource:h,type:u.type,cId:u.cId})}l.length&&(this.n.debug("User data changed"),this.a.fire(l))}t(c){return c.with({scheme:this.f})}u(c){return c.with({scheme:this.h})}}t.$tgc=k}),define(re[159],oe([0,1,115,16,48,17,12,11,15]),function(H,t,E,P,y,O,A,k,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$8i=t.$5i=t.$4i=t.$3i=t.$2i=t.$Zi=t.$Yi=t.WorkbenchState=t.$Si=t.$Ri=t.$Oi=void 0,t.$Pi=c,t.$Qi=l,t.$Ti=u,t.$Ui=h,t.$Vi=w,t.$Wi=R,t.$Xi=p,t.$1i=I,t.$6i=v,t.$7i=e,t.$9i=a,t.$0i=n,t.$$i=r,t.$Oi=(0,k.$Fi)("contextService");function c(i){const s=i;return typeof s?.id=="string"&&A.URI.isUri(s.uri)}function l(i){return typeof i?.id=="string"&&!c(i)&&!h(i)}t.$Ri={id:"ext-dev"},t.$Si={id:"empty-window"};function u(i,s){if(typeof i=="string"||typeof i>"u")return typeof i=="string"?{id:(0,P.$pc)(i)}:s?t.$Ri:t.$Si;const o=i;return o.configuration?{id:o.id,configPath:o.configuration}:o.folders.length===1?{id:o.id,uri:o.folders[0].uri}:{id:o.id}}function h(i){const s=i;return typeof s?.id=="string"&&A.URI.isUri(s.configPath)}function w(i){const s=i;if(s?.uri)return{id:s.id,uri:A.URI.revive(s.uri)};const o=i;if(o?.configPath)return{id:o.id,configPath:A.URI.revive(o.configPath)};if(i?.id)return{id:i.id}}var m;(function(i){i[i.EMPTY=1]="EMPTY",i[i.FOLDER=2]="FOLDER",i[i.WORKSPACE=3]="WORKSPACE"})(m||(t.WorkbenchState=m={}));function R(i){const s=i;return!!(s&&typeof s=="object"&&typeof s.id=="string"&&Array.isArray(s.folders))}function p(i){const s=i;return!!(s&&typeof s=="object"&&A.URI.isUri(s.uri)&&typeof s.name=="string"&&typeof s.toResource=="function")}class f{constructor(s,o,d,S,N){this.h=s,this.j=d,this.k=S,this.l=N,this.c=y.$Li.forUris(this.l,()=>!0),this.folders=o}update(s){this.h=s.id,this.k=s.configuration,this.j=s.transient,this.l=s.l,this.folders=s.folders}get folders(){return this.g}set folders(s){this.g=s,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(s){this.k=s}getFolder(s){return s&&this.c.findSubstr(s)||null}n(){this.c=y.$Li.forUris(this.l,()=>!0);for(const s of this.folders)this.c.set(s.uri,s)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}t.$Yi=f;class ${constructor(s,o){this.raw=o,this.uri=s.uri,this.index=s.index,this.name=s.name}toResource(s){return(0,O.$gh)(this.uri,s)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}t.$Zi=$;function I(i){return new $({uri:i,index:0,name:(0,O.$ch)(i)},{uri:i.toString()})}t.$2i="code-workspace",t.$3i=`.${t.$2i}`,t.$4i=[{name:(0,E.localize)(0,null),extensions:[t.$2i]}],t.$5i="workspace.json";function v(i,s){return O.$0g.isEqualOrParent(i,s.untitledWorkspacesHome)}function e(i){let s;return A.URI.isUri(i)?s=i:s=i.configuration,s?.scheme===g.Schemas.tmp}t.$8i="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function a(i){return i.id===t.$8i}function n(i,s){return!v(i,s)&&!e(i)}function r(i){return(typeof i=="string"?(0,P.$qc)(i):(0,O.$eh)(i))===t.$3i}}),define(re[24],oe([0,1,43,5,2,17,12,114,18,10,11,6,159,31,23,8,29,32,3]),function(H,t,E,P,y,O,A,k,g,c,l,u,h,w,m,R,p,f,$){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Pl=t.$Ol=t.$Ll=t.ProfileResourceType=void 0,t.$Kl=v,t.$Ml=e,t.$Nl=a;var I;(function(i){i.Settings="settings",i.Keybindings="keybindings",i.Snippets="snippets",i.Tasks="tasks",i.Extensions="extensions",i.GlobalState="globalState"})(I||(t.ProfileResourceType=I={}));function v(i){const s=i;return!!(s&&typeof s=="object"&&typeof s.id=="string"&&typeof s.isDefault=="boolean"&&typeof s.name=="string"&&A.URI.isUri(s.location)&&A.URI.isUri(s.globalStorageHome)&&A.URI.isUri(s.settingsResource)&&A.URI.isUri(s.keybindingsResource)&&A.URI.isUri(s.tasksResource)&&A.URI.isUri(s.snippetsHome)&&A.URI.isUri(s.extensionsResource))}t.$Ll=(0,l.$Fi)("IUserDataProfilesService");function e(i,s){return{id:i.id,isDefault:i.isDefault,name:i.name,shortName:i.shortName,icon:i.icon,location:A.URI.revive(i.location).with({scheme:s}),globalStorageHome:A.URI.revive(i.globalStorageHome).with({scheme:s}),settingsResource:A.URI.revive(i.settingsResource).with({scheme:s}),keybindingsResource:A.URI.revive(i.keybindingsResource).with({scheme:s}),tasksResource:A.URI.revive(i.tasksResource).with({scheme:s}),snippetsHome:A.URI.revive(i.snippetsHome).with({scheme:s}),extensionsResource:A.URI.revive(i.extensionsResource).with({scheme:s}),cacheHome:A.URI.revive(i.cacheHome).with({scheme:s}),useDefaultFlags:i.useDefaultFlags,isTransient:i.isTransient}}function a(i,s,o,d,S,N){return{id:i,name:s,location:o,isDefault:!1,shortName:S?.shortName,icon:S?.icon,globalStorageHome:N&&S?.useDefaultFlags?.globalState?N.globalStorageHome:(0,O.$gh)(o,"globalStorage"),settingsResource:N&&S?.useDefaultFlags?.settings?N.settingsResource:(0,O.$gh)(o,"settings.json"),keybindingsResource:N&&S?.useDefaultFlags?.keybindings?N.keybindingsResource:(0,O.$gh)(o,"keybindings.json"),tasksResource:N&&S?.useDefaultFlags?.tasks?N.tasksResource:(0,O.$gh)(o,"tasks.json"),snippetsHome:N&&S?.useDefaultFlags?.snippets?N.snippetsHome:(0,O.$gh)(o,"snippets"),extensionsResource:N&&S?.useDefaultFlags?.extensions?N.extensionsResource:(0,O.$gh)(o,"extensions.json"),cacheHome:(0,O.$gh)(d,i),useDefaultFlags:S?.useDefaultFlags,isTransient:S?.transient}}let n=class extends y.$Wc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(s,o,d,S){super(),this.t=s,this.u=o,this.w=d,this.y=S,this.f=!0,this.h=this.B(new P.$me),this.onDidChangeProfiles=this.h.event,this.j=this.B(new P.$me),this.onWillCreateProfile=this.j.event,this.m=this.B(new P.$me),this.onWillRemoveProfile=this.m.event,this.n=this.B(new P.$me),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],folders:new w.$Cc,workspaces:new w.$Cc,emptyWindows:new Map},this.profilesHome=(0,O.$gh)(this.t.userRoamingDataHome,"profiles"),this.g=(0,O.$gh)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(s){this.f!==s&&(this.z=void 0,this.f=s)}isEnabled(){return this.f}get C(){if(!this.z){const s=this.D(),o=[s];if(this.f)try{for(const N of this.O()){if(!N.name||!(0,$.$fg)(N.name)||!N.location){this.y.warn("Skipping the invalid stored profile",N.location||N.name);continue}o.push(a((0,O.$dh)(N.location),N.name,N.location,this.g,{shortName:N.shortName,icon:N.icon,useDefaultFlags:N.useDefaultFlags},s))}}catch(N){this.y.error(N)}const d=new w.$Cc,S=new Map;if(o.length)try{const N=this.Q();if(N.workspaces)for(const[C,D]of Object.entries(N.workspaces)){const T=A.URI.parse(C),M=o.find(K=>K.id===D);M&&d.set(T,M)}if(N.emptyWindows)for(const[C,D]of Object.entries(N.emptyWindows)){const T=o.find(M=>M.id===D);T&&S.set(C,T)}}catch(N){this.y.error(N)}this.z={profiles:o,workspaces:d,emptyWindows:S}}return this.z}D(){const s=a("__default__profile__",(0,k.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...s,extensionsResource:this.S()??s.extensionsResource,isDefault:!0}}async createTransientProfile(s){const o="Temp",d=new RegExp(`${(0,f.$if)(o)}\\s(\\d+)`);let S=0;for(const C of this.profiles){const D=d.exec(C.name),T=D?parseInt(D[1]):0;S=T>S?T:S}const N=`${o} ${S+1}`;return this.createProfile((0,E.$tj)((0,p.$2g)()).toString(16),N,{transient:!0},s)}async createNamedProfile(s,o,d){return this.createProfile((0,E.$tj)((0,p.$2g)()).toString(16),s,o,d)}async createProfile(s,o,d,S){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const N=await this.F(s,o,d);return S&&await this.setProfileForWorkspace(S,N),N}async F(s,o,d){if(!(0,$.$fg)(o)||!o)throw new Error("Name of the profile is mandatory and must be of type `string`");let S=this.r.get(o);return S||(S=(async()=>{try{if(this.profiles.find(T=>T.name===o||T.id===s))throw new Error(`Profile with ${o} name already exists`);const C=a(s,o,(0,O.$gh)(this.profilesHome,s),this.g,d,this.defaultProfile);await this.u.createFolder(C.location);const D=[];return this.j.fire({profile:C,join(T){D.push(T)}}),await R.Promises.settled(D),this.I([C],[],[]),C}finally{this.r.delete(o)}})(),this.r.set(o,S)),S}async updateProfile(s,o){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let d=this.profiles.find(S=>S.id===s.id);if(!d)throw new Error(`Profile '${s.name}' does not exist`);return d=a(d.id,o.name??d.name,d.location,this.g,{shortName:o.shortName??d.shortName,icon:o.icon===null?void 0:o.icon??d.icon,transient:o.transient??d.isTransient,useDefaultFlags:o.useDefaultFlags??d.useDefaultFlags},this.defaultProfile),this.I([],[],[d]),d}async removeProfile(s){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(s.isDefault)throw new Error("Cannot remove default profile");const o=this.profiles.find(S=>S.id===s.id);if(!o)throw new Error(`Profile '${s.name}' does not exist`);const d=[];this.m.fire({profile:o,join(S){d.push(S)}});try{await Promise.allSettled(d)}catch(S){this.y.error(S)}for(const S of[...this.C.emptyWindows.keys()])o.id===this.C.emptyWindows.get(S)?.id&&this.C.emptyWindows.delete(S);for(const S of[...this.C.workspaces.keys()])o.id===this.C.workspaces.get(S)?.id&&this.C.workspaces.delete(S);this.M(),this.I([],[o],[]);try{await this.u.del(o.cacheHome,{recursive:!0})}catch(S){(0,c.$ql)(S)!==c.FileOperationResult.FILE_NOT_FOUND&&this.y.error(S)}}async setProfileForWorkspace(s,o){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const d=this.profiles.find(S=>S.id===o.id);if(!d)throw new Error(`Profile '${o.name}' does not exist`);this.L(s,d)}unsetWorkspace(s,o){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(s,void 0,o)}async resetWorkspaces(){this.s.folders.clear(),this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const s=await this.u.resolve(this.profilesHome);await Promise.all((s.children||[]).filter(o=>o.isDirectory&&this.profiles.every(d=>!this.w.extUri.isEqual(d.location,o.resource))).map(o=>this.u.del(o.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const s=this.s.profiles.filter(o=>!this.H(o));await Promise.allSettled(s.map(o=>this.removeProfile(o)))}getProfileForWorkspace(s){const o=this.G(s),d=A.URI.isUri(o)?this.C.workspaces.get(o):this.C.emptyWindows.get(o);return d||((0,h.$Pi)(s)?this.s.folders.get(s.uri):(0,h.$Ui)(s)?this.s.workspaces.get(s.configPath):this.s.emptyWindows.get(s.id))}G(s){return(0,h.$Pi)(s)?s.uri:(0,h.$Ui)(s)?s.configPath:s.id}H(s){return!!([...this.C.emptyWindows.values()].some(o=>this.w.extUri.isEqual(o.location,s.location))||[...this.C.workspaces.values()].some(o=>this.w.extUri.isEqual(o.location,s.location))||[...this.s.emptyWindows.values()].some(o=>this.w.extUri.isEqual(o.location,s.location))||[...this.s.workspaces.values()].some(o=>this.w.extUri.isEqual(o.location,s.location))||[...this.s.folders.values()].some(o=>this.w.extUri.isEqual(o.location,s.location)))}I(s,o,d){const S=[...this.profiles,...s],N=[],C=this.s.profiles;this.s.profiles=[];for(let D of S){if(D.isDefault||o.some(M=>D.id===M.id))continue;D=d.find(M=>D.id===M.id)??D;const T=C.find(M=>D.id===M.id);if(D.isTransient)this.s.profiles.push(D);else{if(T){for(const[M,K]of this.s.emptyWindows.entries())if(D.id===K.id){this.L({id:M},D);break}for(const[M,K]of this.s.workspaces.entries())if(D.id===K.id){this.L({id:"",configPath:M},D);break}for(const[M,K]of this.s.folders.entries())if(D.id===K.id){this.L({id:"",uri:M},D);break}}N.push({location:D.location,name:D.name,shortName:D.shortName,icon:D.icon,useDefaultFlags:D.useDefaultFlags})}}this.P(N),this.z=void 0,this.J(s,o,d)}J(s,o,d){this.h.fire({added:s,removed:o,updated:d,all:this.profiles})}L(s,o,d){if(d=o?.isTransient?!0:d,d)(0,h.$Pi)(s)?(this.s.folders.delete(s.uri),o&&this.s.folders.set(s.uri,o)):(0,h.$Ui)(s)?(this.s.workspaces.delete(s.configPath),o&&this.s.workspaces.set(s.configPath,o)):(this.s.emptyWindows.delete(s.id),o&&this.s.emptyWindows.set(s.id,o));else{this.L(s,void 0,!0);const S=this.G(s);A.URI.isUri(S)?(this.C.workspaces.delete(S),o&&this.C.workspaces.set(S,o)):(this.C.emptyWindows.delete(S),o&&this.C.emptyWindows.set(S,o)),this.M()}}M(){const s={};for(const[d,S]of this.C.workspaces.entries())s[d.toString()]=S.id;const o={};for(const[d,S]of this.C.emptyWindows.entries())o[d.toString()]=S.id;this.R({workspaces:s,emptyWindows:o}),this.z=void 0}N(s){const o={},d=this.D();if(s.workspaces)for(const[N,C]of Object.entries(s.workspaces)){const D=A.URI.parse(C);o[N]=this.w.extUri.isEqual(D,d.location)?d.id:this.w.extUri.basename(D)}const S={};if(s.emptyWindows)for(const[N,C]of Object.entries(s.emptyWindows)){const D=A.URI.parse(C);S[N]=this.w.extUri.isEqual(D,d.location)?d.id:this.w.extUri.basename(D)}return{workspaces:o,emptyWindows:S}}O(){return[]}P(s){throw new Error("not implemented")}Q(){return{}}R(s){throw new Error("not implemented")}S(){}};t.$Ol=n,t.$Ol=n=we([ne(0,g.$Mi),ne(1,c.$_k),ne(2,m.$Jl),ne(3,u.$_j)],n);class r extends n{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(s){this.a=s}Q(){return this.X}R(s){this.X=s}}t.$Pl=r}),define(re[53],oe([0,1,20,8,22,9,5,2,13,3,12,98,21,27,26,6,33,19,23,24]),function(H,t,E,P,y,O,A,k,g,c,l,u,h,w,m,R,p,f,$,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Aq=t.$yq=void 0,t.$zq=e,u=ye(u);let v=class extends k.$Wc{get onInstallExtension(){return this.n.event}get onDidInstallExtensions(){return this.s.event}get onUninstallExtension(){return this.t.event}get onDidUninstallExtension(){return this.u.event}get onDidUpdateExtensionMetadata(){return this.w.event}constructor(i,s,o,d,S,N){super(),this.z=i,this.C=s,this.D=o,this.F=d,this.G=S,this.H=N,this.h=0,this.j=new Map,this.m=new Map,this.n=this.B(new A.$me),this.s=this.B(new A.$me),this.t=this.B(new A.$me),this.u=this.B(new A.$me),this.w=this.B(new A.$me),this.y=[],this.B((0,k.$Uc)(()=>{this.j.forEach(({task:C})=>C.cancel()),this.m.forEach(C=>C.cancel()),this.j.clear(),this.m.clear()}))}async canInstall(i){const s=await this.getTargetPlatform();return i.allTargetPlatforms.some(o=>(0,h.$ep)(o,i.allTargetPlatforms,s))}async installFromGallery(i,s={}){try{const d=(await this.installGalleryExtensions([{extension:i,options:s}])).find(({identifier:S})=>(0,w.$Hp)(S,i.identifier));if(d?.local)return d?.local;throw d?.error?d.error:new h.$ip(`Unknown error while installing extension ${i.identifier.id}`,h.ExtensionManagementErrorCode.Unknown)}catch(o){throw e(o)}}async installGalleryExtensions(i){if(!this.z.isEnabled())throw new h.$ip(u.localize(0,null),h.ExtensionManagementErrorCode.NotAllowed);const s=[],o=[];return await Promise.allSettled(i.map(async({extension:d,options:S})=>{try{const N=await this.N(d,!!S?.installGivenVersion,!!S?.installPreReleaseVersion,S.productVersion??{version:this.G.version,date:this.G.date});o.push({...N,options:S})}catch(N){s.push({identifier:d.identifier,operation:h.InstallOperation.Install,source:d,error:N,profileLocation:S.profileLocation??this.X()})}})),o.length&&s.push(...await this.I(o)),s}async uninstall(i,s={}){return this.F.trace("ExtensionManagementService#uninstall",i.identifier.id),this.P(i,s)}async toggleAppliationScope(i,s){if((0,m.$tn)(i.manifest)||i.isBuiltin)return i;if(i.isApplicationScoped){let o=await this.updateMetadata(i,{isApplicationScoped:!1},this.H.defaultProfile.extensionsResource);this.D.extUri.isEqual(s,this.H.defaultProfile.extensionsResource)||(o=await this.$(i,this.H.defaultProfile.extensionsResource,s));for(const d of this.H.profiles){const S=(await this.getInstalled(m.ExtensionType.User,d.extensionsResource)).find(N=>(0,w.$Hp)(N.identifier,i.identifier));S?this.w.fire({local:S,profileLocation:d.extensionsResource}):this.u.fire({identifier:i.identifier,profileLocation:d.extensionsResource})}return o}else{const o=this.D.extUri.isEqual(s,this.H.defaultProfile.extensionsResource)?await this.updateMetadata(i,{isApplicationScoped:!0},this.H.defaultProfile.extensionsResource):await this.$(i,s,this.H.defaultProfile.extensionsResource,{isApplicationScoped:!0});return this.s.fire([{identifier:o.identifier,operation:h.InstallOperation.Install,local:o,profileLocation:this.H.defaultProfile.extensionsResource,applicationScoped:!0}]),o}}getExtensionsControlManifest(){const i=new Date().getTime();return(!this.g||i-this.h>1e3*60*5)&&(this.g=this.W(),this.h=i),this.g}registerParticipant(i){this.y.push(i)}async I(i){const s=new Map,o=new Map,d=[],S=(C,D)=>`${w.$Ip.create(C).toString()}-${D.toString()}`,N=(C,D,T,M)=>{const K=this.Y(C,D,T),Y=`${(0,w.$Mp)(C.publisher,C.name)}-${T.profileLocation.toString()}`;o.set(Y,{task:K,root:M}),this.n.fire({identifier:K.identifier,source:D,profileLocation:T.profileLocation}),this.F.info("Installing extension:",K.identifier.id,T),l.URI.isUri(D)||this.j.set(S(D,T.profileLocation),{task:K,waitingTasks:[]})};try{for(const{manifest:C,extension:D,options:T}of i){const M=T.isApplicationScoped||T.isBuiltin||(0,m.$tn)(C),K={...T,installOnlyNewlyAddedFromExtensionPack:T.installOnlyNewlyAddedFromExtensionPack??!l.URI.isUri(D),isApplicationScoped:M,profileLocation:M?this.H.defaultProfile.extensionsResource:T.profileLocation??this.X(),productVersion:T.productVersion??{version:this.G.version,date:this.G.date}},Y=l.URI.isUri(D)?void 0:this.j.get(S(D,K.profileLocation));Y?(this.F.info("Extension is already requested to install",Y.task.identifier.id,K.profileLocation.toString()),d.push(Y.task.waitUntilTaskIsFinished())):N(C,D,K,void 0)}return await Promise.all([...o.values()].map(async({task:C})=>{if(C.options.donotIncludePackAndDependencies)this.F.info("Installing the extension without checking dependencies and pack",C.identifier.id);else try{const D=await this.M(C.identifier,C.manifest,!!C.options.installOnlyNewlyAddedFromExtensionPack,!!C.options.installPreReleaseVersion,C.options.profileLocation,C.options.productVersion),T=await this.getInstalled(void 0,C.options.profileLocation,C.options.productVersion),M={...C.options,context:{...C.options.context,[h.$$o]:!0}};for(const{gallery:K,manifest:Y}of(0,E.$Ob)(D,({gallery:ae})=>ae.identifier.id)){if(o.has(`${K.identifier.id.toLowerCase()}-${M.profileLocation.toString()}`))continue;const ae=this.j.get(S(K,M.profileLocation));if(ae){if(this.J(C,ae.task)){const le=ae.task.identifier;this.F.info("Waiting for already requested installing extension",le.id,C.identifier.id,M.profileLocation.toString()),ae.waitingTasks.push(C),d.push(A.Event.toPromise(A.Event.filter(this.onDidInstallExtensions,ce=>ce.some(de=>(0,w.$Hp)(de.identifier,le)))).then(ce=>{if(this.F.info("Finished waiting for already requested installing extension",le.id,C.identifier.id,M.profileLocation.toString()),!ce.find(x=>(0,w.$Hp)(x.identifier,le))?.local)throw new Error(`Extension ${le.id} is not installed`)}))}}else T.some(({identifier:le})=>(0,w.$Hp)(le,K.identifier))||N(Y,K,M,C)}}catch(D){if(l.URI.isUri(C.source))(0,E.$Nb)(C.manifest.extensionDependencies)&&this.F.warn("Cannot install dependencies of extension:",C.identifier.id,D.message),(0,E.$Nb)(C.manifest.extensionPack)&&this.F.warn("Cannot install packed extensions of extension:",C.identifier.id,D.message);else throw this.F.error("Error while preparing to install dependencies and extension packs of the extension:",C.identifier.id),D}})),await this.L([...o.entries()].map(async([C,{task:D}])=>{const T=new Date().getTime();let M;try{M=await D.run(),await this.L(this.y.map(K=>K.postInstall(M,D.source,D.options,y.CancellationToken.None)),h.ExtensionManagementErrorCode.PostInstall)}catch(K){const Y=e(K);throw l.URI.isUri(D.source)||a(this.C,D.operation===h.InstallOperation.Update?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,w.$Pp)(D.source),error:Y,source:D.options.context?.[h.$0o]}),s.set(C,{error:Y,identifier:D.identifier,operation:D.operation,source:D.source,context:D.options.context,profileLocation:D.options.profileLocation,applicationScoped:D.options.isApplicationScoped}),this.F.error("Error while installing the extension",D.identifier.id,(0,O.$_)(Y),D.options.profileLocation.toString()),Y}if(!l.URI.isUri(D.source)){const K=D.operation===h.InstallOperation.Update,Y=K?void 0:(new Date().getTime()-D.source.lastUpdated)/1e3;if(a(this.C,K?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,w.$Pp)(D.source),verificationStatus:D.verificationStatus,duration:new Date().getTime()-T,durationSinceUpdate:Y,source:D.options.context?.[h.$0o]}),g.$o&&D.operation!==h.InstallOperation.Update)try{await this.z.reportStatistic(M.manifest.publisher,M.manifest.name,M.manifest.version,h.StatisticType.Install)}catch{}}s.set(C,{local:M,identifier:D.identifier,operation:D.operation,source:D.source,context:D.options.context,profileLocation:D.options.profileLocation,applicationScoped:M.isApplicationScoped})})),d.length&&await this.L(d),[...s.values()]}catch(C){const D=(K,Y,ae)=>{const le=[];K.manifest.extensionDependencies?.length&&le.push(...K.manifest.extensionDependencies),K.manifest.extensionPack?.length&&le.push(...K.manifest.extensionPack);for(const ce of le){if(ae.includes(ce.toLowerCase()))continue;ae.push(ce.toLowerCase());const de=s.get(`${ce.toLowerCase()}-${Y.toString()}`);de?.local&&(ae=D(de.local,Y,ae))}return ae},T=K=>({identifier:K.identifier,operation:h.InstallOperation.Install,source:K.source,context:K.options.context,profileLocation:K.options.profileLocation,error:C}),M=[];for(const[K,{task:Y,root:ae}]of o){const le=s.get(K);le?le.local&&ae&&!s.get(`${ae.identifier.id.toLowerCase()}-${Y.options.profileLocation.toString()}`)?.local&&(M.push(this.Z(le.local,{versionOnly:!0,profileLocation:Y.options.profileLocation})),s.set(K,T(Y))):(Y.cancel(),s.set(K,T(Y)))}for(const[K,{task:Y}]of o){const ae=s.get(K);if(!ae?.local||Y.options.donotIncludePackAndDependencies)continue;D(ae.local,Y.options.profileLocation,[ae.local.identifier.id.toLowerCase()]).slice(1).some(ce=>o.has(`${ce.toLowerCase()}-${Y.options.profileLocation.toString()}`)&&!s.get(`${ce.toLowerCase()}-${Y.options.profileLocation.toString()}`)?.local)&&(M.push(this.Z(ae.local,{versionOnly:!0,profileLocation:Y.options.profileLocation})),s.set(K,T(Y)))}throw M.length&&await Promise.allSettled(M.map(async K=>{try{await K.run(),this.F.info("Rollback: Uninstalled extension",K.extension.identifier.id)}catch(Y){this.F.warn("Rollback: Error while uninstalling extension",K.extension.identifier.id,(0,O.$_)(Y))}})),C}finally{for(const{task:C}of o.values())C.source&&!l.URI.isUri(C.source)&&this.j.delete(S(C.source,C.options.profileLocation));if(s.size){const C=[...s.values()];for(const D of C)D.local&&this.F.info("Extension installed successfully:",D.identifier.id,D.profileLocation.toString());this.s.fire(C)}}}J(i,s){for(const[,{task:o,waitingTasks:d}]of this.j.entries())if(o===i&&(d.includes(s)||d.some(S=>this.J(S,s)))||o===s&&d[0]&&!this.J(i,d[0]))return!1;return!0}async L(i,s){const o=[],d=[],S=await Promise.allSettled(i);for(const C of S)C.status==="fulfilled"?o.push(C.value):d.push(e(C.reason,s));if(!d.length)return o;if(d.length===1)throw d[0];let N=new h.$ip("",h.ExtensionManagementErrorCode.Unknown);for(const C of d)N=new h.$ip(N.message?`${N.message}, ${C.message}`:C.message,C.code!==h.ExtensionManagementErrorCode.Unknown&&C.code!==h.ExtensionManagementErrorCode.Internal?C.code:N.code);throw N}async M(i,s,o,d,S,N){if(!this.z.isEnabled())return[];const C=await this.getInstalled(void 0,S,N),D=[],T=[],M=async(K,Y)=>{D.push(K);const ae=Y.extensionDependencies||[],le=[...ae];if(Y.extensionPack){const ce=o?C.find(de=>(0,w.$Hp)(de.identifier,K)):void 0;for(const de of Y.extensionPack)ce&&ce.manifest.extensionPack&&ce.manifest.extensionPack.some(x=>(0,w.$Hp)({id:x},{id:de}))||le.every(x=>!(0,w.$Hp)({id:x},{id:de}))&&le.push(de)}if(le.length){const ce=le.filter(de=>D.every(x=>!(0,w.$Hp)(x,{id:de})));if(ce.length){const de=await this.z.getExtensions(ce.map(x=>({id:x,preRelease:d})),y.CancellationToken.None);for(const x of de){if(D.find(U=>(0,w.$Hp)(U,x.identifier)))continue;const _=ae.some(U=>(0,w.$Hp)({id:U},x.identifier));let B;try{B=await this.N(x,!1,d,N)}catch(U){if(_)throw U;this.F.info("Skipping the packed extension as it cannot be installed",x.identifier.id,(0,O.$_)(U));continue}T.push({gallery:B.extension,manifest:B.manifest}),await M(B.extension.identifier,B.manifest)}}}};return await M(i,s),T}async N(i,s,o,d){let S;const N=await this.getExtensionsControlManifest();if(N.malicious.some(T=>(0,w.$Hp)(i.identifier,T)))throw new h.$ip(u.localize(1,null,i.identifier.id),h.ExtensionManagementErrorCode.Malicious);const C=N.deprecated[i.identifier.id.toLowerCase()];if(C?.extension?.autoMigrate){if(this.F.info(`The '${i.identifier.id}' extension is deprecated, fetching the compatible '${C.extension.id}' extension instead.`),S=(await this.z.getExtensions([{id:C.extension.id,preRelease:C.extension.preRelease}],{targetPlatform:await this.getTargetPlatform(),compatible:!0,productVersion:d},y.CancellationToken.None))[0],!S)throw new h.$ip(u.localize(2,null,i.identifier.id,C.extension.id),h.ExtensionManagementErrorCode.Deprecated)}else{if(!await this.canInstall(i)){const T=await this.getTargetPlatform();throw new h.$ip(u.localize(3,null,i.identifier.id,this.G.nameLong,(0,h.$ap)(T)),h.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}if(S=await this.O(i,s,o,d),!S)throw!o&&i.properties.isPreReleaseVersion&&(await this.z.getExtensions([i.identifier],y.CancellationToken.None))[0]?new h.$ip(u.localize(4,null,i.displayName??i.identifier.id),h.ExtensionManagementErrorCode.ReleaseVersionNotFound):new h.$ip(u.localize(5,null,i.identifier.id,this.G.nameLong,this.G.version),h.ExtensionManagementErrorCode.Incompatible)}this.F.info("Getting Manifest...",S.identifier.id);const D=await this.z.getManifest(S,y.CancellationToken.None);if(D===null)throw new h.$ip(`Missing manifest for extension ${S.identifier.id}`,h.ExtensionManagementErrorCode.Invalid);if(D.version!==S.version)throw new h.$ip(`Cannot install '${S.identifier.id}' extension because of version mismatch in Marketplace`,h.ExtensionManagementErrorCode.Invalid);return{extension:S,manifest:D}}async O(i,s,o,d){const S=await this.getTargetPlatform();let N=null;return!s&&i.hasPreReleaseVersion&&i.properties.isPreReleaseVersion!==o&&(N=(await this.z.getExtensions([{...i.identifier,preRelease:o}],{targetPlatform:S,compatible:!0,productVersion:d},y.CancellationToken.None))[0]||null),!N&&await this.z.isExtensionCompatible(i,o,S,d)&&(N=i),N||(s?N=(await this.z.getExtensions([{...i.identifier,version:i.version}],{targetPlatform:S,compatible:!0,productVersion:d},y.CancellationToken.None))[0]||null:N=await this.z.getCompatibleExtension(i,o,S,d)),N}async P(i,s){const o={...s,profileLocation:i.isApplicationScoped?this.H.defaultProfile.extensionsResource:s.profileLocation??this.X()},d=M=>`${M.id.toLowerCase()}${o.versionOnly?`-${i.manifest.version}`:""}${o.profileLocation?`@${o.profileLocation.toString()}`:""}`,S=this.m.get(d(i.identifier));if(S)return this.F.info("Extensions is already requested to uninstall",i.identifier.id),S.waitUntilTaskIsFinished();const N=M=>{const K=this.Z(M,o);return this.m.set(d(K.extension.identifier),K),o.profileLocation?this.F.info("Uninstalling extension from the profile:",`${M.identifier.id}@${M.manifest.version}`,o.profileLocation.toString()):this.F.info("Uninstalling extension:",`${M.identifier.id}@${M.manifest.version}`),this.t.fire({identifier:M.identifier,profileLocation:o.profileLocation,applicationScoped:M.isApplicationScoped}),K},C=(M,K)=>{K?o.profileLocation?this.F.error("Failed to uninstall extension from the profile:",`${M.identifier.id}@${M.manifest.version}`,o.profileLocation.toString(),K.message):this.F.error("Failed to uninstall extension:",`${M.identifier.id}@${M.manifest.version}`,K.message):o.profileLocation?this.F.info("Successfully uninstalled extension from the profile",`${M.identifier.id}@${M.manifest.version}`,o.profileLocation.toString()):this.F.info("Successfully uninstalled extension:",`${M.identifier.id}@${M.manifest.version}`),a(this.C,"extensionGallery:uninstall",{extensionData:(0,w.$Op)(M),error:K}),this.u.fire({identifier:M.identifier,error:K?.code,profileLocation:o.profileLocation,applicationScoped:M.isApplicationScoped})},D=[],T=[];try{D.push(N(i));const M=await this.getInstalled(m.ExtensionType.User,o.profileLocation);if(o.donotIncludePack)this.F.info("Uninstalling the extension without including packed extension",`${i.identifier.id}@${i.manifest.version}`);else{const K=this.S(i,M);for(const Y of K)this.m.has(d(Y.identifier))?this.F.info("Extensions is already requested to uninstall",Y.identifier.id):D.push(N(Y))}o.donotCheckDependents?this.F.info("Uninstalling the extension without checking dependents",`${i.identifier.id}@${i.manifest.version}`):this.Q(D.map(K=>K.extension),M,i),await this.L(D.map(async K=>{try{if(await K.run(),await this.L(this.y.map(Y=>Y.postUninstall(K.extension,o,y.CancellationToken.None))),K.extension.identifier.uuid)try{await this.z.reportStatistic(K.extension.manifest.publisher,K.extension.manifest.name,K.extension.manifest.version,h.StatisticType.Uninstall)}catch{}C(K.extension)}catch(Y){const ae=e(Y);throw C(K.extension,ae),ae}finally{T.push(K)}}))}catch(M){const K=e(M);for(const Y of D){try{Y.cancel()}catch{}T.includes(Y)||C(Y.extension,K)}throw K}finally{for(const M of D)this.m.delete(d(M.extension.identifier))||this.F.warn("Uninstallation task is not found in the cache",M.extension.identifier.id)}}Q(i,s,o){for(const d of i){const S=this.U(d,s);if(S.length){const N=S.filter(C=>!i.some(D=>(0,w.$Hp)(D.identifier,C.identifier)));if(N.length)throw new Error(this.R(d,N,o))}}}R(i,s,o){return o===i?s.length===1?u.localize(6,null,o.manifest.displayName||o.manifest.name,s[0].manifest.displayName||s[0].manifest.name):s.length===2?u.localize(7,null,o.manifest.displayName||o.manifest.name,s[0].manifest.displayName||s[0].manifest.name,s[1].manifest.displayName||s[1].manifest.name):u.localize(8,null,o.manifest.displayName||o.manifest.name,s[0].manifest.displayName||s[0].manifest.name,s[1].manifest.displayName||s[1].manifest.name):s.length===1?u.localize(9,null,o.manifest.displayName||o.manifest.name,i.manifest.displayName||i.manifest.name,s[0].manifest.displayName||s[0].manifest.name):s.length===2?u.localize(10,null,o.manifest.displayName||o.manifest.name,i.manifest.displayName||i.manifest.name,s[0].manifest.displayName||s[0].manifest.name,s[1].manifest.displayName||s[1].manifest.name):u.localize(11,null,o.manifest.displayName||o.manifest.name,i.manifest.displayName||i.manifest.name,s[0].manifest.displayName||s[0].manifest.name,s[1].manifest.displayName||s[1].manifest.name)}S(i,s,o=[]){if(o.indexOf(i)!==-1)return[];o.push(i);const d=i.manifest.extensionPack?i.manifest.extensionPack:[];if(d.length){const S=s.filter(C=>!C.isBuiltin&&d.some(D=>(0,w.$Hp)({id:D},C.identifier))),N=[];for(const C of S)N.push(...this.S(C,s,o));return[...S,...N]}return[]}U(i,s){return s.filter(o=>o.manifest.extensionDependencies&&o.manifest.extensionDependencies.some(d=>(0,w.$Hp)({id:d},i.identifier)))}async W(){try{return this.F.trace("ExtensionManagementService.updateControlCache"),await this.z.getExtensionsControlManifest()}catch(i){return this.F.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest",(0,O.$_)(i)),{malicious:[],deprecated:{},search:[]}}}};t.$yq=v,t.$yq=v=we([ne(0,h.$gp),ne(1,f.$$l),ne(2,$.$Jl),ne(3,R.$_j),ne(4,p.$sk),ne(5,I.$Ll)],v);function e(r,i){if(r instanceof h.$ip)return r;let s;return r instanceof h.$hp?s=new h.$ip(r.message,r.code===h.ExtensionGalleryErrorCode.DownloadFailedWriting?h.ExtensionManagementErrorCode.DownloadFailedWriting:h.ExtensionManagementErrorCode.Gallery):s=new h.$ip(r.message,(0,O.$6)(r)?h.ExtensionManagementErrorCode.Cancelled:i??h.ExtensionManagementErrorCode.Internal),s.stack=r.stack,s}function a(r,i,{extensionData:s,verificationStatus:o,duration:d,error:S,source:N,durationSinceUpdate:C}){let D,T;(0,c.$ng)(o)&&(o===!0?o="Verified":(o===!1||(D=h.ExtensionManagementErrorCode.Signature,T=o),o="Unverified")),S&&(D=S.code,S.code===h.ExtensionManagementErrorCode.Signature&&(T=S.message)),r.publicLog(i,{...s,verificationStatus:o,success:!S,duration:d,errorcode:D,errorcodeDetail:T,durationSinceUpdate:C,source:N})}class n{constructor(){this.d=new P.$Eh}async waitUntilTaskIsFinished(){return await this.d.wait(),this.g}run(){return this.g||(this.g=(0,P.$sh)(i=>this.h(i))),this.d.open(),this.g}cancel(){this.g||(this.g=(0,P.$sh)(i=>new Promise((s,o)=>{const d=i.onCancellationRequested(()=>{d.dispose(),o(new O.$7)})})),this.d.open()),this.g.cancel()}}t.$Aq=n}),define(re[42],oe([0,1,8,14,2,5,31,12,21,27,10,11,6,24,23,3,9,19]),function(H,t,E,P,y,O,A,k,g,c,l,u,h,w,m,R,p,f){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Dq=t.$Cq=t.$Bq=t.ExtensionsProfileScanningErrorCode=void 0;var $;(function(n){n.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",n.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})($||(t.ExtensionsProfileScanningErrorCode=$={}));class I extends Error{constructor(r,i){super(r),this.code=i}}t.$Bq=I,t.$Cq=(0,u.$Fi)("IExtensionsProfileScannerService");let v=class extends y.$Wc{constructor(r,i,s,o,d,S){super(),this.j=r,this.m=i,this.n=s,this.r=o,this.s=d,this.t=S,this.b=this.B(new O.$me),this.onAddExtensions=this.b.event,this.c=this.B(new O.$me),this.onDidAddExtensions=this.c.event,this.f=this.B(new O.$me),this.onRemoveExtensions=this.f.event,this.g=this.B(new O.$me),this.onDidRemoveExtensions=this.g.event,this.h=new A.$Cc}scanProfileExtensions(r,i){return this.u(r,void 0,i)}async addExtensionsToProfile(r,i,s){const o=[],d=[];try{return await this.u(i,S=>{const N=[];if(s)N.push(...S);else for(const C of S)r.some(([D])=>(0,c.$Hp)(D.identifier,C.identifier)&&D.manifest.version!==C.version)?o.push(C):N.push(C);for(const[C,D]of r){const T=N.findIndex(K=>(0,c.$Hp)(K.identifier,C.identifier)&&K.version===C.manifest.version),M={identifier:C.identifier,version:C.manifest.version,location:C.location,metadata:D};T===-1?(d.push(M),N.push(M)):N.splice(T,1,M)}return d.length&&this.b.fire({extensions:d,profileLocation:i}),o.length&&this.f.fire({extensions:o,profileLocation:i}),N}),d.length&&this.c.fire({extensions:d,profileLocation:i}),o.length&&this.g.fire({extensions:o,profileLocation:i}),d}catch(S){throw d.length&&this.c.fire({extensions:d,error:S,profileLocation:i}),o.length&&this.g.fire({extensions:o,error:S,profileLocation:i}),S}}async updateMetadata(r,i){const s=[];return await this.u(i,o=>{const d=[];for(const S of o){const N=r.find(([C])=>(0,c.$Hp)(C.identifier,S.identifier)&&C.manifest.version===S.version);N&&(S.metadata={...S.metadata,...N[1]},s.push(S)),d.push(S)}return d}),s}async removeExtensionFromProfile(r,i){const s=[];try{await this.u(i,o=>{const d=[];for(const S of o)(0,c.$Hp)(S.identifier,r.identifier)?s.push(S):d.push(S);return s.length&&this.f.fire({extensions:s,profileLocation:i}),d}),s.length&&this.g.fire({extensions:s,profileLocation:i})}catch(o){throw s.length&&this.g.fire({extensions:s,error:o,profileLocation:i}),o}}async u(r,i,s){return this.F(r).queue(async()=>{let o=[],d;try{const S=await this.m.readFile(r);d=JSON.parse(S.value.toString().trim()||"[]")}catch(S){if((0,l.$ql)(S)!==l.FileOperationResult.FILE_NOT_FOUND)throw S;if(this.r.extUri.isEqual(r,this.n.defaultProfile.extensionsResource)&&(d=await this.D()),!d&&s?.bailOutWhenFileNotFound)throw new I((0,p.$_)(S),$.ERROR_PROFILE_NOT_FOUND)}if(d){Array.isArray(d)||this.w(r);let S=!1;for(const N of d){e(N)||this.w(r);let C;if((0,R.$fg)(N.relativeLocation)&&N.relativeLocation)C=this.z(N.relativeLocation);else if((0,R.$fg)(N.location)){this.t.warn(`Extensions profile: Ignoring extension with invalid location: ${N.location}`);continue}else{C=k.URI.revive(N.location);const D=this.y(C);D&&(S=!0,N.relativeLocation=D)}(0,R.$mg)(N.metadata?.hasPreReleaseVersion)&&N.metadata?.preRelease&&(S=!0,N.metadata.hasPreReleaseVersion=!0),o.push({identifier:N.identifier,location:C,version:N.version,metadata:N.metadata})}S&&await this.m.writeFile(r,P.$Oe.fromString(JSON.stringify(d)))}if(i){o=i(o);const S=o.map(N=>({identifier:N.identifier,version:N.version,location:N.location.toJSON(),relativeLocation:this.y(N.location),metadata:N.metadata}));await this.m.writeFile(r,P.$Oe.fromString(JSON.stringify(S)))}return o})}w(r){const i=new I(`Invalid extensions content in ${r.toString()}`,$.ERROR_INVALID_CONTENT);throw this.s.publicLogError2("extensionsProfileScanningError",{code:i.code}),i}y(r){return this.r.extUri.isEqual(this.r.extUri.dirname(r),this.j)?this.r.extUri.basename(r):void 0}z(r){return this.r.extUri.joinPath(this.j,r)}async D(){return this.C||(this.C=(async()=>{const r=this.r.extUri.joinPath(this.n.defaultProfile.location,"extensions.json"),i=this.r.extUri.joinPath(this.j,".init-default-profile-extensions");let s;try{s=(await this.m.readFile(r)).value.toString()}catch(d){if((0,l.$ql)(d)===l.FileOperationResult.FILE_NOT_FOUND)return;throw d}this.t.info("Migrating extensions from old default profile location",r.toString());let o;try{const d=JSON.parse(s);Array.isArray(d)&&d.every(S=>e(S))?o=d:this.t.warn("Skipping migrating from old default profile locaiton: Found invalid data",d)}catch(d){this.t.error(d)}if(o)try{await this.m.createFile(this.n.defaultProfile.extensionsResource,P.$Oe.fromString(JSON.stringify(o)),{overwrite:!1}),this.t.info("Migrated extensions from old default profile location to new location",r.toString(),this.n.defaultProfile.extensionsResource.toString())}catch(d){if((0,l.$ql)(d)===l.FileOperationResult.FILE_MODIFIED_SINCE)this.t.info("Migration from old default profile location to new location is done by another window",r.toString(),this.n.defaultProfile.extensionsResource.toString());else throw d}try{await this.m.del(r)}catch(d){(0,l.$ql)(d)!==l.FileOperationResult.FILE_NOT_FOUND&&this.t.error(d)}try{await this.m.del(i)}catch(d){(0,l.$ql)(d)!==l.FileOperationResult.FILE_NOT_FOUND&&this.t.error(d)}return o})()),this.C}F(r){let i=this.h.get(r);return i||(i=new E.$Mh,this.h.set(r,i)),i}};t.$Dq=v,t.$Dq=v=we([ne(1,l.$_k),ne(2,w.$Ll),ne(3,m.$Jl),ne(4,f.$$l),ne(5,h.$_j)],v);function e(n){return(0,R.$hg)(n)&&(0,g.$fp)(n.identifier)&&(a(n.location)||(0,R.$fg)(n.location)&&n.location)&&((0,R.$mg)(n.relativeLocation)||(0,R.$fg)(n.relativeLocation))&&n.version&&(0,R.$fg)(n.version)}function a(n){return n?(0,R.$fg)(n.path)&&(0,R.$fg)(n.scheme):!1}});var qe=this&&this.__importDefault||function(H){return H&&H.__esModule?H:{default:H}};define(re[54],oe([0,1,20,8,28,14,9,34,85,2,15,16,13,17,44,56,3,12,102,18,27,26,50,10,11,6,33,5,47,42,24,23,121]),function(H,t,E,P,y,O,A,k,g,c,l,u,h,w,m,R,p,f,$,I,v,e,a,n,r,i,s,o,d,S,N,C,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Kq=t.$Iq=t.$Hq=t.$Gq=t.Translations=void 0,t.$Jq=le,y=ye(y),u=ye(u),h=ye(h),m=ye(m),R=qe(R);var T;(function(de){function x(_,B){if(_===B)return!0;const U=Object.keys(_),J=new Set;for(const X of Object.keys(B))J.add(X);if(U.length!==J.size)return!1;for(const X of U){if(_[X]!==B[X])return!1;J.delete(X)}return J.size===0}de.equals=x})(T||(t.Translations=T={})),t.$Gq=(0,r.$Fi)("IExtensionsScannerService");let M=class extends c.$Wc{constructor(x,_,B,U,J,X,ee,j,q,G,V,b){super(),this.systemExtensionsLocation=x,this.userExtensionsLocation=_,this.r=B,this.s=U,this.t=J,this.u=X,this.w=ee,this.y=j,this.z=q,this.C=G,this.D=V,this.F=b,this.g=this.B(new o.$me),this.onDidChangeCache=this.g.event,this.h=(0,w.$gh)(this.userExtensionsLocation,".obsolete"),this.j=this.B(this.F.createInstance(ae,this.s,this.h)),this.m=this.B(this.F.createInstance(ae,this.s,this.h)),this.n=this.B(this.F.createInstance(Y,this.h)),this.H=void 0,this.B(this.j.onDidChangeCache(()=>this.g.fire(e.ExtensionType.System))),this.B(this.m.onDidChangeCache(()=>this.g.fire(e.ExtensionType.User)))}getTargetPlatform(){return this.G||(this.G=(0,v.$Sp)(this.w,this.y)),this.G}async scanAllExtensions(x,_,B){const[U,J]=await Promise.all([this.scanSystemExtensions(x),this.scanUserExtensions(_)]),X=B?await this.scanExtensionsUnderDevelopment(x,[...U,...J]):[];return this.L(U,J,X,await this.getTargetPlatform(),!0)}async scanSystemExtensions(x){const _=[];_.push(this.M(!!x.useCache,x.language)),_.push(this.N(x.language,!!x.checkControlFile));const[B,U]=await Promise.all(_);return this.J([...B,...U],e.ExtensionType.System,x,!1)}async scanUserExtensions(x){const _=x.profileLocation??this.userExtensionsLocation;this.y.trace("Started scanning user extensions",_);const B=this.D.extUri.isEqual(x.profileLocation,this.t.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,U=await this.P(_,!!x.profileLocation,e.ExtensionType.User,!x.includeUninstalled,x.language,!0,B,x.productVersion??this.R()),J=x.useCache&&!U.devMode&&U.excludeObsolete?this.m:this.n;let X;try{X=await J.scanExtensions(U)}catch(ee){if(ee instanceof S.$Bq&&ee.code===S.ExtensionsProfileScanningErrorCode.ERROR_PROFILE_NOT_FOUND)await this.I(),X=await J.scanExtensions(U);else throw ee}return X=await this.J(X,e.ExtensionType.User,x,!0),this.y.trace("Scanned user extensions:",X.length),X}async scanExtensionsUnderDevelopment(x,_){if(this.z.isExtensionDevelopment&&this.z.extensionDevelopmentLocationURI){const B=(await Promise.all(this.z.extensionDevelopmentLocationURI.filter(U=>U.scheme===l.Schemas.file).map(async U=>{const J=await this.P(U,!1,e.ExtensionType.User,!0,x.language,!1,void 0,x.productVersion??this.R());return(await this.n.scanOneOrMultipleExtensions(J)).map(ee=>(ee.type=_.find(j=>(0,v.$Hp)(j.identifier,ee.identifier))?.type??ee.type,this.n.validate(ee,J)))}))).flat();return this.J(B,"development",x,!0)}return[]}async scanExistingExtension(x,_,B){const U=await this.P(x,!1,_,!0,B.language,!0,void 0,B.productVersion??this.R()),J=await this.n.scanExtension(U);return!J||!B.includeInvalid&&!J.isValid?null:J}async scanOneOrMultipleExtensions(x,_,B){const U=await this.P(x,!1,_,!0,B.language,!0,void 0,B.productVersion??this.R()),J=await this.n.scanOneOrMultipleExtensions(U);return this.J(J,_,B,!0)}async scanMultipleExtensions(x,_,B){const U=[];return await Promise.all(x.map(async J=>{const X=await this.scanOneOrMultipleExtensions(J,_,B);U.push(...X)})),this.J(U,_,B,!0)}async scanMetadata(x){const _=(0,w.$gh)(x,"package.json"),B=(await this.w.readFile(_)).value.toString();return JSON.parse(B).__metadata}async updateMetadata(x,_){const B=(0,w.$gh)(x,"package.json"),U=(await this.w.readFile(B)).value.toString(),J=JSON.parse(U);_.isMachineScoped===!1&&delete _.isMachineScoped,_.isBuiltin===!1&&delete _.isBuiltin,J.__metadata={...J.__metadata,..._},await this.w.writeFile((0,w.$gh)(x,"package.json"),O.$Oe.fromString(JSON.stringify(J,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.u.scanProfileExtensions(this.t.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(x){if(x instanceof S.$Bq&&x.code===S.ExtensionsProfileScanningErrorCode.ERROR_PROFILE_NOT_FOUND)await this.I();else throw x}}async I(){return this.H||(this.H=(async()=>{try{this.y.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const x=await this.scanUserExtensions({includeInvalid:!0});if(x.length)await this.u.addExtensionsToProfile(x.map(_=>[_,_.metadata]),this.t.defaultProfile.extensionsResource);else try{await this.w.createFile(this.t.defaultProfile.extensionsResource,O.$Oe.fromString(JSON.stringify([])))}catch(_){(0,n.$ql)(_)!==n.FileOperationResult.FILE_NOT_FOUND&&this.y.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,A.$_)(_))}this.y.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(x){this.y.error(x)}finally{this.H=void 0}})()),this.H}async J(x,_,B,U){return B.includeAllVersions||(x=this.L(_===e.ExtensionType.System?x:void 0,_===e.ExtensionType.User?x:void 0,_==="development"?x:void 0,await this.getTargetPlatform(),U)),B.includeInvalid||(x=x.filter(J=>J.isValid)),x.sort((J,X)=>{const ee=u.$pc(J.location.fsPath),j=u.$pc(X.location.fsPath);return ee<j?-1:ee>j?1:0})}L(x,_,B,U,J){const X=(j,q,G)=>{if(j.isValid&&!q.isValid)return!1;if(j.isValid===q.isValid){if(J&&m.gt(j.manifest.version,q.manifest.version))return this.y.debug(`Skipping extension ${q.location.path} with lower version ${q.manifest.version} in favour of ${j.location.path} with version ${j.manifest.version}`),!1;if(m.eq(j.manifest.version,q.manifest.version)){if(j.type===e.ExtensionType.System)return this.y.debug(`Skipping extension ${q.location.path} in favour of system extension ${j.location.path} with same version`),!1;if(j.targetPlatform===U)return this.y.debug(`Skipping extension ${q.location.path} from different target platform ${q.targetPlatform}`),!1}}return G?this.y.warn(`Overwriting user extension ${j.location.path} with ${q.location.path}.`):this.y.debug(`Overwriting user extension ${j.location.path} with ${q.location.path}.`),!0},ee=new e.$sn;return x?.forEach(j=>{const q=ee.get(j.identifier.id);(!q||X(q,j,!1))&&ee.set(j.identifier.id,j)}),_?.forEach(j=>{const q=ee.get(j.identifier.id);if(!q&&x&&j.type===e.ExtensionType.System){this.y.debug(`Skipping obsolete system extension ${j.location.path}.`);return}(!q||X(q,j,!1))&&ee.set(j.identifier.id,j)}),B?.forEach(j=>{const q=ee.get(j.identifier.id);(!q||X(q,j,!0))&&ee.set(j.identifier.id,j),ee.set(j.identifier.id,j)}),[...ee.values()]}async M(x,_){this.y.trace("Started scanning system extensions");const B=await this.P(this.systemExtensionsLocation,!1,e.ExtensionType.System,!0,_,!0,void 0,this.R()),J=await(x&&!B.devMode?this.j:this.n).scanExtensions(B);return this.y.trace("Scanned system extensions:",J.length),J}async N(x,_){const B=this.z.isBuilt?[]:this.C.builtInExtensions;if(!B?.length)return[];this.y.trace("Started scanning dev system extensions");const U=_?await this.O():{},J=[],X=f.URI.file(u.$jc(u.$lc(l.$Zg.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const j of B){const q=U[j.name]||"marketplace";switch(q){case"disabled":break;case"marketplace":J.push((0,w.$gh)(X,j.name));break;default:J.push(f.URI.file(q));break}}const ee=await Promise.all(J.map(async j=>this.n.scanExtension(await this.P(j,!1,e.ExtensionType.System,!0,x,!0,void 0,this.R()))));return this.y.trace("Scanned dev system extensions:",ee.length),(0,E.$Jb)(ee)}async O(){try{const x=await this.w.readFile(this.r);return JSON.parse(x.value.toString())}catch{return{}}}async P(x,_,B,U,J,X,ee,j){const q=await this.f(J??h.$w),G=await this.Q(x),V=_&&!this.D.extUri.isEqual(x,this.t.defaultProfile.extensionsResource)?this.t.defaultProfile.extensionsResource:void 0,b=V?await this.Q(V):void 0;return new K(x,G,V,b,_,ee,B,U,X,j.version,j.date,this.C.commit,!this.z.isBuilt,J,q)}async Q(x){try{const _=await this.w.stat(x);if(typeof _.mtime=="number")return _.mtime}catch{}}R(){return{version:this.C.version,date:this.C.date}}};t.$Hq=M,t.$Hq=M=we([ne(4,N.$Ll),ne(5,S.$Cq),ne(6,n.$_k),ne(7,i.$_j),ne(8,I.$Mi),ne(9,s.$sk),ne(10,C.$Jl),ne(11,r.$Ei)],M);class K{constructor(x,_,B,U,J,X,ee,j,q,G,V,b,L,F,z){this.location=x,this.mtime=_,this.applicationExtensionslocation=B,this.applicationExtensionslocationMtime=U,this.profile=J,this.profileScanOptions=X,this.type=ee,this.excludeObsolete=j,this.validate=q,this.productVersion=G,this.productDate=V,this.productCommit=b,this.devMode=L,this.language=F,this.translations=z}static createNlsConfiguration(x){return{language:x.language,pseudo:x.language==="pseudo",devMode:x.devMode,translations:x.translations}}static equals(x,_){return(0,w.$_g)(x.location,_.location)&&x.mtime===_.mtime&&(0,w.$_g)(x.applicationExtensionslocation,_.applicationExtensionslocation)&&x.applicationExtensionslocationMtime===_.applicationExtensionslocationMtime&&x.profile===_.profile&&y.$fo(x.profileScanOptions,_.profileScanOptions)&&x.type===_.type&&x.excludeObsolete===_.excludeObsolete&&x.validate===_.validate&&x.productVersion===_.productVersion&&x.productDate===_.productDate&&x.productCommit===_.productCommit&&x.devMode===_.devMode&&x.language===_.language&&T.equals(x.translations,_.translations)}}t.$Iq=K;let Y=class extends c.$Wc{constructor(x,_,B,U,J){super(),this.f=x,this.g=_,this.h=B,this.j=U,this.m=J}async scanExtensions(x){const _=x.profile?await this.r(x):await this.n(x);let B={};if(x.excludeObsolete&&x.type===e.ExtensionType.User)try{const U=(await this.j.readFile(this.f)).value.toString();B=JSON.parse(U)}catch{}return(0,p.$sg)(B)?_:_.filter(U=>!B[v.$Ip.create(U).toString()])}async n(x){const _=await this.j.resolve(x.location);if(!_.children?.length)return[];const B=await Promise.all(_.children.map(async U=>{if(!U.isDirectory||x.type===e.ExtensionType.User&&(0,w.$dh)(U.resource).indexOf(".")===0)return null;const J=new K(U.resource,x.mtime,x.applicationExtensionslocation,x.applicationExtensionslocationMtime,x.profile,x.profileScanOptions,x.type,x.excludeObsolete,x.validate,x.productVersion,x.productDate,x.productCommit,x.devMode,x.language,x.translations);return this.scanExtension(J)}));return(0,E.$Jb)(B).sort((U,J)=>U.location.path<J.location.path?-1:1)}async r(x){let _=await this.s(x.location,()=>!0,x);if(x.applicationExtensionslocation&&!this.h.extUri.isEqual(x.location,x.applicationExtensionslocation)){_=_.filter(U=>!U.metadata?.isApplicationScoped);const B=await this.s(x.applicationExtensionslocation,U=>!!U.metadata?.isBuiltin||!!U.metadata?.isApplicationScoped,x);_.push(...B)}return _}async s(x,_,B){const U=await this.g.scanProfileExtensions(x,B.profileScanOptions);if(!U.length)return[];const J=await Promise.all(U.map(async X=>{if(_(X)){const ee=new K(X.location,B.mtime,B.applicationExtensionslocation,B.applicationExtensionslocationMtime,B.profile,B.profileScanOptions,B.type,B.excludeObsolete,B.validate,B.productVersion,B.productDate,B.productCommit,B.devMode,B.language,B.translations);return this.scanExtension(ee,X.metadata)}return null}));return(0,E.$Jb)(J)}async scanOneOrMultipleExtensions(x){try{if(await this.j.exists((0,w.$gh)(x.location,"package.json"))){const _=await this.scanExtension(x);return _?[_]:[]}else return await this.scanExtensions(x)}catch(_){return this.m.error(`Error scanning extensions at ${x.location.path}:`,(0,A.$_)(_)),[]}}async scanExtension(x,_){try{let B=await this.scanExtensionManifest(x.location);if(B){B.publisher||(B.publisher=e.$mn),_=_??B.__metadata,delete B.__metadata;const U=(0,v.$Mp)(B.publisher,B.name),J=_?.id?{id:U,uuid:_.id}:{id:U},X=_?.isSystem?e.ExtensionType.System:x.type,ee=X===e.ExtensionType.System||!!_?.isBuiltin;B=await this.t(x.location,B,K.createNlsConfiguration(x));const j={type:X,identifier:J,manifest:B,location:x.location,isBuiltin:ee,targetPlatform:_?.targetPlatform??e.TargetPlatform.UNDEFINED,publisherDisplayName:_?.publisherDisplayName,metadata:_,isValid:!0,validations:[]};return x.validate?this.validate(j,x):j}}catch(B){x.type!==e.ExtensionType.System&&this.m.error(B)}return null}validate(x,_){let B=!0;const U=(0,a.$Xp)(_.productVersion,_.productDate,_.location,x.manifest,x.isBuiltin);for(const[J,X]of U)J===R.default.Error&&(B=!1,this.m.error(this.z(_.location,X)));return x.isValid=B,x.validations=U,x}async scanExtensionManifest(x){const _=(0,w.$gh)(x,"package.json");let B;try{B=(await this.j.readFile(_)).value.toString()}catch(J){return(0,n.$ql)(J)!==n.FileOperationResult.FILE_NOT_FOUND&&this.m.error(this.z(x,(0,$.localize)(0,null,_.path,J.message))),null}let U;try{U=JSON.parse(B)}catch{const X=[];(0,k.$Vn)(B,X);for(const ee of X)this.m.error(this.z(x,(0,$.localize)(1,null,_.path,ee.offset,ee.length,(0,g.$Eq)(ee.error))));return null}return(0,k.$4n)(U)!=="object"?(this.m.error(this.z(x,(0,$.localize)(2,null,_.path))),null):U}async t(x,_,B){const U=await this.u(x,_,B);if(U)try{const J=[],X=await this.w(U.default,J);if(J.length>0)return J.forEach(j=>{this.m.error(this.z(x,(0,$.localize)(3,null,U.default?.path,(0,g.$Eq)(j.error))))}),_;if((0,k.$4n)(U)!=="object")return this.m.error(this.z(x,(0,$.localize)(4,null,U.default?.path))),_;const ee=U.values||Object.create(null);return(0,D.$Fq)(this.m,_,ee,X)}catch{}return _}async u(x,_,B){const U=(0,w.$gh)(x,"package.nls.json"),J=(q,G)=>{G.forEach(V=>{this.m.error(this.z(x,(0,$.localize)(5,null,q?.path,(0,g.$Eq)(V.error))))})},X=q=>{this.m.error(this.z(x,(0,$.localize)(6,null,q?.path)))},ee=`${_.publisher}.${_.name}`,j=B.translations[ee];if(j)try{const q=f.URI.file(j),G=(await this.j.readFile(q)).value.toString(),V=[],b=(0,k.$Vn)(G,V);return V.length>0?(J(q,V),{values:void 0,default:U}):(0,k.$4n)(b)!=="object"?(X(q),{values:void 0,default:U}):{values:b.contents?b.contents.package:void 0,default:U}}catch{return{values:void 0,default:U}}else{if(!await this.j.exists(U))return;let G;try{G=await this.y(x,B)}catch{return}if(!G.localized)return{values:void 0,default:G.original};try{const V=(await this.j.readFile(G.localized)).value.toString(),b=[],L=(0,k.$Vn)(V,b);return b.length>0?(J(G.localized,b),{values:void 0,default:G.original}):(0,k.$4n)(L)!=="object"?(X(G.localized),{values:void 0,default:G.original}):{values:L,default:G.original}}catch{return{values:void 0,default:G.original}}}}async w(x,_){if(x)try{const B=(await this.j.readFile(x)).value.toString();return(0,k.$Vn)(B,_)}catch{}}y(x,_){return new Promise((B,U)=>{const J=X=>{const ee=(0,w.$gh)(x,`package.nls.${X}.json`);this.j.exists(ee).then(j=>{j&&B({localized:ee,original:(0,w.$gh)(x,"package.nls.json")});const q=X.lastIndexOf("-");q===-1?B({localized:(0,w.$gh)(x,"package.nls.json"),original:null}):(X=X.substring(0,q),J(X))})};if(_.devMode||_.pseudo||!_.language)return B({localized:(0,w.$gh)(x,"package.nls.json"),original:null});J(_.language)})}z(x,_){return`[${x.path}]: ${_}`}};Y=we([ne(1,S.$Cq),ne(2,C.$Jl),ne(3,n.$_k),ne(4,i.$_j)],Y);let ae=class extends Y{constructor(x,_,B,U,J,X,ee){super(_,U,J,X,ee),this.G=x,this.H=B,this.D=this.B(new P.$Dh(3e3)),this.F=this.B(new o.$me),this.onDidChangeCache=this.F.event}async scanExtensions(x){const _=this.M(x),B=await this.I(_);if(this.C=x,B&&B.input&&K.equals(B.input,this.C))return this.m.debug("Using cached extensions scan result",x.type===e.ExtensionType.System?"system":"user",x.location.toString()),this.D.trigger(()=>this.L()),B.result.map(J=>(J.location=f.URI.revive(J.location),J));const U=await super.scanExtensions(x);return await this.J(_,{input:x,result:U}),U}async I(x){try{const _=await this.j.readFile(x),B=JSON.parse(_.value.toString());return{result:B.result,input:(0,d.$ci)(B.input)}}catch(_){this.m.debug("Error while reading the extension cache file:",x.path,(0,A.$_)(_))}return null}async J(x,_){try{await this.j.writeFile(x,O.$Oe.fromString(JSON.stringify(_)))}catch(B){this.m.debug("Error while writing the extension cache file:",x.path,(0,A.$_)(B))}}async L(){if(!this.C)return;const x=this.M(this.C),_=await this.I(x);if(!_)return;const B=_.result,U=JSON.parse(JSON.stringify(await super.scanExtensions(this.C)));if(!y.$fo(U,B))try{this.m.info("Invalidating Cache",B,U),await this.j.del(x),this.F.fire()}catch(J){this.m.error(J)}}M(x){const _=this.N(x);return this.h.extUri.joinPath(_.cacheHome,x.type===e.ExtensionType.System?e.$ln:e.$kn)}N(x){return x.type===e.ExtensionType.System?this.H.defaultProfile:x.profile?this.h.extUri.isEqual(x.location,this.G.extensionsResource)?this.G:this.H.profiles.find(_=>this.h.extUri.isEqual(x.location,_.extensionsResource))??this.G:this.H.defaultProfile}};ae=we([ne(2,N.$Ll),ne(3,S.$Cq),ne(4,C.$Jl),ne(5,n.$_k),ne(6,i.$_j)],ae);function le(de,x){const _=(0,v.$Kp)(de.manifest.publisher,de.manifest.name);return{id:_,identifier:new e.$qn(_),isBuiltin:de.type===e.ExtensionType.System,isUserBuiltin:de.type===e.ExtensionType.User&&de.isBuiltin,isUnderDevelopment:x,extensionLocation:de.location,uuid:de.identifier.uuid,targetPlatform:de.targetPlatform,publisherDisplayName:de.publisherDisplayName,...de.manifest}}class ce extends M{constructor(x,_,B,U,J,X,ee,j,q,G,V,b){super(x,_,(0,w.$gh)(B,".vscode-oss-dev","extensions","control.json"),U,J,X,ee,j,q,G,V,b),this.S=(async()=>{if(h.$z)try{const L=await this.w.readFile(f.URI.file(h.$z));return JSON.parse(L.value.toString())}catch{}return Object.create(null)})()}f(x){return this.S}}t.$Kq=ce}),define(re[160],oe([0,1,60,8,38,5,2,15,16,25,6,24]),function(H,t,E,P,y,O,A,k,g,c,l,u){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Oq=void 0;let h=class extends A.$Wc{constructor(m,R){super(),this.b=m,this.f=R,this.a=new P.$Lh(5)}async postUninstall(m){const R=this.g(m,"uninstall");R&&(this.f.info(m.identifier.id,m.manifest.version,"Running post uninstall script"),await this.a.queue(async()=>{try{await this.h(R.script,"uninstall",R.args,!0,m),this.f.info("Finished running post uninstall script",m.identifier.id,m.manifest.version)}catch(p){this.f.error("Failed to run post uninstall script",m.identifier.id,m.manifest.version),this.f.error(p)}}));try{await c.Promises.rm(this.m(m))}catch(p){this.f.error("Error while removing extension storage path",m.identifier.id),this.f.error(p)}}g(m,R){const p=`vscode:${R}`;if(m.location.scheme===k.Schemas.file&&m.manifest&&m.manifest.scripts&&typeof m.manifest.scripts[p]=="string"){const f=m.manifest.scripts[p].split(" ");return f.length<2||f[0]!=="node"||!f[1]?(this.f.warn(m.identifier.id,m.manifest.version,`${p} should be a node script`),null):{script:(0,g.$lc)(m.location.fsPath,f[1]),args:f.slice(2)||[]}}return null}h(m,R,p,f,$){return new Promise((I,v)=>{const e=this.j(m,R,p,$);let a;const n=r=>{a&&(clearTimeout(a),a=null),r?v(r):I(void 0)};e.on("error",r=>{n((0,y.$qj)(r)||"Unknown")}),e.on("exit",(r,i)=>{n(r?`post-${R} process exited with code ${r}`:void 0)}),f&&(a=setTimeout(()=>{a=null,e.kill(),v("timed out")},5e3))})}j(m,R,p,f){const $={silent:!0,execArgv:void 0},I=(0,E.fork)(m,[`--type=extension-post-${R}`,...p],$);I.stdout.setEncoding("utf8"),I.stderr.setEncoding("utf8");const v=O.Event.fromNodeEventEmitter(I.stdout,"data"),e=O.Event.fromNodeEventEmitter(I.stderr,"data");this.B(v(r=>this.f.info(f.identifier.id,f.manifest.version,`post-${R}`,r))),this.B(e(r=>this.f.error(f.identifier.id,f.manifest.version,`post-${R}`,r)));const a=O.Event.any(O.Event.map(v,r=>({data:`%c${r}`,format:[""]}),this.q),O.Event.map(e,r=>({data:`%c${r}`,format:["color: red"]}),this.q));return O.Event.debounce(a,(r,i)=>r?{data:r.data+i.data,format:[...r.format,...i.format]}:{data:i.data,format:i.format},100,void 0,void 0,void 0,this.q)(r=>{console.group(f.identifier.id),console.log(r.data,...r.format),console.groupEnd()}),I}m(m){return(0,g.$lc)(this.b.defaultProfile.globalStorageHome.fsPath,m.identifier.id.toLowerCase())}};t.$Oq=h,t.$Oq=h=we([ne(0,u.$Ll),ne(1,l.$_j)],h)}),define(re[72],oe([0,1,49,104,53,21]),function(H,t,E,P,y,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Lq=A,t.$Mq=k;function A(g){let c=O.ExtensionManagementErrorCode.Extract;return g instanceof E.$uq&&(g.type==="CorruptZip"?c=O.ExtensionManagementErrorCode.CorruptZip:g.type==="Incomplete"&&(c=O.ExtensionManagementErrorCode.IncompleteZip)),(0,y.$zq)(g,c)}async function k(g){let c;try{c=await(0,E.$xq)(g,"extension/package.json")}catch(l){throw A(l)}try{return JSON.parse(c.toString("utf8"))}catch{throw new O.$ip((0,P.localize)(0,null),O.ExtensionManagementErrorCode.Invalid)}}}),define(re[161],oe([0,1,8,9,2,15,17,44,3,29,25,49,30,18,53,21,27,72,71,10,6,19]),function(H,t,E,P,y,O,A,k,g,c,l,u,h,w,m,R,p,f,$,I,v,e){"use strict";var a;Object.defineProperty(t,"__esModule",{value:!0}),t.$Nq=void 0,k=ye(k);let n=class extends y.$Wc{static{a=this}static{this.c=".sigzip"}constructor(i,s,o,d,S,N,C){super(),this.h=s,this.j=o,this.m=d,this.n=S,this.r=N,this.t=C,this.extensionsDownloadDir=i.extensionsDownloadLocation,this.f=20,this.g=this.F()}async download(i,s,o,d){await this.g;const S=await this.w(i,s);let N=!1;if(o&&this.u(i)){let C;try{C=await this.y(i)}catch(D){try{await this.delete(S)}catch(T){this.t.error(T)}throw D}try{N=await this.n.verify(i,S.fsPath,C.fsPath,d)}catch(D){if(N=D.code,N===$.ExtensionSignatureVerificationCode.PackageIsInvalidZip||N===$.ExtensionSignatureVerificationCode.SignatureArchiveIsInvalidZip){try{await this.delete(S)}catch(T){this.t.error(T)}throw new R.$ip(u.$tq,R.ExtensionManagementErrorCode.CorruptZip)}}finally{try{await this.delete(C)}catch(D){this.t.error(D)}}}return{location:S,verificationStatus:N}}u(i){if(!i.isSigned)return this.t.info(`Extension is not signed: ${i.identifier.id}`),!1;const s=this.m.getValue("extensions.verifySignature");return(0,g.$lg)(s)?s:!0}async w(i,s){try{const o=(0,A.$gh)(this.extensionsDownloadDir,this.G(i)),d=await this.C(i,"vsix",async()=>{await this.z(i,o,S=>this.j.download(i,S,s));try{await this.D(o.fsPath,"extension/package.json")}catch(S){try{await this.h.del(o)}catch(N){this.t.warn(`Error while deleting: ${o.path}`,(0,P.$_)(N))}throw S}},2);return d>1&&this.r.publicLog2("extensiongallery:downloadvsix:retry",{extensionId:i.identifier.id,attempts:d}),o}catch(o){throw(0,m.$zq)(o,R.ExtensionManagementErrorCode.Download)}}async y(i){try{const s=(0,A.$gh)(this.extensionsDownloadDir,`.${(0,c.$2g)()}`),o=await this.C(i,"sigzip",async()=>{await this.j.downloadSignatureArchive(i,s);try{await this.D(s.fsPath,".signature.p7s")}catch(d){try{await this.h.del(s)}catch(S){this.t.warn(`Error while deleting: ${s.path}`,(0,P.$_)(S))}throw d}},2);return o>1&&this.r.publicLog2("extensiongallery:downloadsigzip:retry",{extensionId:i.identifier.id,attempts:o}),s}catch(s){throw(0,m.$zq)(s,R.ExtensionManagementErrorCode.DownloadSignature)}}async z(i,s,o){if(await this.h.exists(s))return;if(s.scheme!==O.Schemas.file){await o(s);return}const d=(0,A.$gh)(this.extensionsDownloadDir,`.${(0,c.$2g)()}`);try{await o(d)}catch(S){try{await this.h.del(d)}catch{}throw S}try{await l.Promises.rename(d.fsPath,s.fsPath,2*60*1e3)}catch(S){try{await this.h.del(d)}catch{}let N=!1;try{N=await this.h.exists(s)}catch{}if(N)this.t.info("Rename failed because the file was downloaded by another source. So ignoring renaming.",i.identifier.id,s.path);else throw this.t.info(`Rename failed because of ${(0,P.$_)(S)}. Deleted the file from downloaded location`,d.path),S}}async C(i,s,o,d){let S=1;for(;;)try{return await o(),S}catch(N){if(S++>d)throw N;this.t.warn(`Failed downloading ${s}. ${(0,P.$_)(N)}. Retry again...`,i.identifier.id)}}async D(i,s){try{await(0,u.$xq)(i,s)}catch(o){throw(0,f.$Lq)(o)}}async delete(i){await this.g,await this.h.del(i)}async F(){try{if(!await this.h.exists(this.extensionsDownloadDir)){this.t.trace("Extension VSIX downloads cache dir does not exist");return}const i=await this.h.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(i.children){const s=[],o=[],d=[];for(const C of i.children)if(C.name.endsWith(a.c))d.push(C.resource);else{const D=p.$Ip.parse(C.name);D&&o.push([D,C])}const S=(0,p.$Np)(o,([C])=>C),N=[];for(const C of S)C.sort((D,T)=>k.rcompare(D[0].version,T[0].version)),s.push(...C.slice(1).map(D=>D[1].resource)),N.push(C[0][1]);N.sort((C,D)=>C.mtime-D.mtime),s.push(...N.slice(0,Math.max(0,N.length-this.f)).map(C=>C.resource)),s.push(...d),await E.Promises.settled(s.map(C=>(this.t.trace("Deleting from cache",C.path),this.h.del(C))))}}catch(i){this.t.error(i)}}G(i){return this.f?p.$Ip.create(i).toString().toLowerCase():(0,c.$2g)()}};t.$Nq=n,t.$Nq=n=a=we([ne(0,w.$Ni),ne(1,I.$_k),ne(2,R.$gp),ne(3,h.$_i),ne(4,$.$mq),ne(5,e.$$l),ne(6,v.$_j)],n)}),define(re[162],oe([0,1,8,14,22,38,9,5,43,2,31,15,16,17,44,3,12,29,25,49,103,61,18,53,21,27,42,54,161,160,72,142,149,26,50,10,11,6,33,19,23,24]),function(H,t,E,P,y,O,A,k,g,c,l,u,h,w,m,R,p,f,$,I,v,e,a,n,r,i,s,o,d,S,N,C,D,T,M,K,Y,ae,le,ce,de,x){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Tq=t.$Sq=t.$Rq=void 0,h=ye(h),m=ye(m),$=ye($),v=ye(v),t.$Rq=(0,Y.$Gi)(r.$jp);const _=".vsctmp";let B=class extends n.$yq{constructor(j,q,G,V,b,L,F,z,Z,Q,se,he){super(j,q,se,G,Q,he),this.eb=b,this.fb=L,this.gb=F,this.hb=z,this.ib=Z,this.db=new Map,this.tb=new l.$Dc;const ue=this.B(z.createInstance(S.$Oq));this.ab=this.B(z.createInstance(U,pe=>ue.postUninstall(pe))),this.bb=this.B(new C.$Pq(he,Z,se,this,this.F)),this.cb=this.B(z.createInstance(d.$Nq));const Ee=this.B(new D.$Qq(this,this.eb,he,L,se,Z,G));this.B(Ee.onDidChangeExtensionsByAnotherSource(pe=>this.sb(pe))),this.ub()}getTargetPlatform(){return this.jb||(this.jb=(0,i.$Sp)(this.ib,this.F)),this.jb}async zip(j){this.F.trace("ExtensionManagementService#zip",j.identifier.id);const q=await this.rb(j),G=await(0,I.zip)((0,w.$gh)(this.cb.extensionsDownloadDir,(0,f.$2g)()).fsPath,q);return p.URI.file(G)}async unzip(j){return this.F.trace("ExtensionManagementService#unzip",j.toString()),(await this.install(j)).identifier}async getManifest(j){const{location:q,cleanup:G}=await this.lb(j),V=h.$mc(q.fsPath);try{return await(0,N.$Mq)(V)}finally{await G()}}getInstalled(j,q=this.H.defaultProfile.extensionsResource,G={version:this.G.version,date:this.G.date}){return this.ab.scanExtensions(j??null,q,G)}scanAllUserInstalledExtensions(){return this.ab.scanAllUserExtensions(!1)}scanInstalledExtensionAtLocation(j){return this.ab.scanUserExtensionAtLocation(j)}async install(j,q={}){this.F.trace("ExtensionManagementService#install",j.toString());const{location:G,cleanup:V}=await this.lb(j);try{const b=await(0,N.$Mq)(h.$mc(G.fsPath)),L=(0,i.$Mp)(b.publisher,b.name);if(b.engines&&b.engines.vscode&&!(0,M.$Zp)(b.engines.vscode,this.G.version,this.G.date))throw new Error(v.localize(0,null,L,this.G.version));const z=(await this.I([{manifest:b,extension:G,options:q}])).find(({identifier:Z})=>(0,i.$Hp)(Z,{id:L}));if(z?.local)return z.local;throw z?.error?z.error:(0,n.$zq)(new Error(`Unknown error while installing extension ${L}`))}finally{await V()}}async installFromLocation(j,q){this.F.trace("ExtensionManagementService#installFromLocation",j.toString());const G=await this.ab.scanUserExtensionAtLocation(j);if(!G||!G.manifest.name||!G.manifest.version)throw new Error(`Cannot find a valid extension from the location ${j.toString()}`);return await this.wb([[G,{source:"resource"}]],q),this.F.info("Successfully installed extension",G.identifier.id,q.toString()),G}async installExtensionsFromProfile(j,q,G){this.F.trace("ExtensionManagementService#installExtensionsFromProfile",j,q.toString(),G.toString());const V=(await this.getInstalled(T.ExtensionType.User,q)).filter(b=>j.some(L=>(0,i.$Hp)(L,b.identifier)));if(V.length){const b=await Promise.all(V.map(L=>this.ab.scanMetadata(L,q)));await this.wb(V.map((L,F)=>[L,b[F]]),G),this.F.info("Successfully installed extensions",V.map(L=>L.identifier.id),G.toString())}return V}async updateMetadata(j,q,G){return this.F.trace("ExtensionManagementService#updateMetadata",j.identifier.id),q.isPreReleaseVersion&&(q.preRelease=!0,q.hasPreReleaseVersion=!0),q.isMachineScoped===!1&&(q.isMachineScoped=void 0),q.isBuiltin===!1&&(q.isBuiltin=void 0),q.pinned===!1&&(q.pinned=void 0),j=await this.ab.updateMetadata(j,q,G),this.bb.invalidate(G),this.w.fire({local:j,profileLocation:G}),j}async reinstallFromGallery(j){if(this.F.trace("ExtensionManagementService#reinstallFromGallery",j.identifier.id),!this.z.isEnabled())throw new Error(v.localize(1,null));const q=await this.getTargetPlatform(),[G]=await this.z.getExtensions([{...j.identifier,preRelease:j.preRelease}],{targetPlatform:q,compatible:!0},y.CancellationToken.None);if(!G)throw new Error(v.localize(2,null));await this.ab.setUninstalled(j);try{await this.ab.removeUninstalledExtension(j)}catch(V){throw new Error(v.localize(3,null,(0,O.$qj)(V)))}return this.installFromGallery(G)}$(j,q,G,V){return this.ab.copyExtension(j,q,G,V)}copyExtensions(j,q){return this.ab.copyExtensions(j,q,{version:this.G.version,date:this.G.date})}markAsUninstalled(...j){return this.ab.setUninstalled(...j)}async cleanUp(){this.F.trace("ExtensionManagementService#cleanUp");try{await this.ab.cleanUp()}catch(j){this.F.error(j)}}async download(j,q,G){const{location:V}=await this.cb.download(j,q,!G);return V}async lb(j){if(j.scheme===u.Schemas.file)return{location:j,async cleanup(){}};this.F.trace("Downloading extension from",j.toString());const q=(0,w.$gh)(this.cb.extensionsDownloadDir,(0,f.$2g)());return await this.gb.download(j,q),this.F.info("Downloaded extension to",q.toString()),{location:q,cleanup:async()=>{try{await this.ib.del(q)}catch(V){this.F.error(V)}}}}X(){return this.H.defaultProfile.extensionsResource}Y(j,q,G){const V=q instanceof p.URI?new i.$Ip({id:(0,i.$Mp)(j.publisher,j.name)},j.version):i.$Ip.create(q);return this.hb.createInstance(J,V,j,q,G,(b,L)=>{if(q instanceof p.URI)return this.qb(V,q,G,L);let F=this.db.get(V.toString());return F||(this.db.set(V.toString(),F=this.pb(V,q,b,G,L)),F.finally(()=>this.db.delete(V.toString()))),F},this.ab)}Z(j,q){return new X(j,q.profileLocation,this.fb)}async pb(j,q,G,V,b){const{verificationStatus:L,location:F}=await this.cb.download(q,G,!V.donotVerifySignature,V.context?.[r.$_o]);try{if(b.isCancellationRequested)throw new A.$7;return await(0,N.$Mq)(F.fsPath),{local:await this.ab.extractUserExtension(j,F.fsPath,{id:q.identifier.uuid,publisherId:q.publisherId,publisherDisplayName:q.publisherDisplayName,targetPlatform:q.properties.targetPlatform,isApplicationScoped:V.isApplicationScoped,isMachineScoped:V.isMachineScoped,isBuiltin:V.isBuiltin,isPreReleaseVersion:q.properties.isPreReleaseVersion,hasPreReleaseVersion:q.properties.isPreReleaseVersion,installedTimestamp:Date.now(),pinned:V.installGivenVersion?!0:!!V.pinned,preRelease:(0,R.$lg)(V.preRelease)?V.preRelease:V.installPreReleaseVersion||q.properties.isPreReleaseVersion,source:"gallery"},!1,b),verificationStatus:L}}catch(z){try{await this.cb.delete(F)}catch(Z){this.F.warn("Error while deleting the downloaded file",F.toString(),(0,A.$_)(Z))}throw(0,n.$zq)(z)}}async qb(j,q,G,V){return{local:await this.ab.extractUserExtension(j,h.$mc(q.fsPath),{isApplicationScoped:G.isApplicationScoped,isMachineScoped:G.isMachineScoped,isBuiltin:G.isBuiltin,installedTimestamp:Date.now(),pinned:G.installGivenVersion?!0:!!G.pinned,source:"vsix"},!0,V)}}async rb(j){const q=async V=>{let b=await $.Promises.readdir(V);b=b.map(z=>h.$lc(V,z));const L=await Promise.all(b.map(z=>$.Promises.stat(z)));let F=Promise.resolve([]);return L.forEach((z,Z)=>{const Q=b[Z];z.isFile()&&(F=F.then(se=>[...se,Q])),z.isDirectory()&&(F=F.then(se=>q(Q).then(he=>[...se,...he])))}),F};return(await q(j.location.fsPath)).map(V=>({path:`extension/${h.$nc(j.location.fsPath,V)}`,localPath:V}))}async sb({added:j,removed:q}){if(q){const G=j&&this.D.extUri.isEqual(q.profileLocation,j.profileLocation)?q.extensions.filter(V=>j.extensions.every(b=>!(0,i.$Hp)(b,V))):q.extensions;for(const V of G)this.F.info("Extensions removed from another source",V.id,q.profileLocation.toString()),this.u.fire({identifier:V,profileLocation:q.profileLocation})}if(j){const V=(await this.getInstalled(T.ExtensionType.User,j.profileLocation)).filter(b=>j.extensions.some(L=>(0,i.$Hp)(L,b.identifier)));this.s.fire(V.map(b=>(this.F.info("Extensions added from another source",b.identifier.id,j.profileLocation.toString()),{identifier:b.identifier,local:b,profileLocation:j.profileLocation,operation:r.InstallOperation.None})))}}async ub(){this.B(this.ab.onExtract(q=>this.tb.add(q)));const j=await this.ib.resolve(this.eb.userExtensionsLocation);for(const q of j.children??[])q.isDirectory&&this.tb.add(q.resource);this.B(this.ib.watch(this.eb.userExtensionsLocation)),this.B(this.ib.onDidFilesChange(q=>this.vb(q)))}async vb(j){if(!j.affects(this.eb.userExtensionsLocation,K.FileChangeType.ADDED))return;const q=[];for(const G of j.rawAdded){if(this.tb.has(G)||!this.D.extUri.isEqual(this.D.extUri.dirname(G),this.eb.userExtensionsLocation)||this.D.extUri.isEqual(G,this.D.extUri.joinPath(this.eb.userExtensionsLocation,".obsolete"))||this.D.extUri.basename(G).startsWith(".")||!(await this.ib.stat(G)).isDirectory)continue;const V=await this.ab.scanUserExtensionAtLocation(G);V&&V.installedTimestamp===void 0&&(this.tb.add(G),q.push(V))}q.length&&(await this.wb(q.map(G=>[G,void 0]),this.H.defaultProfile.extensionsResource),this.F.info("Added extensions to default profile from external source",q.map(G=>G.identifier.id)))}async wb(j,q){const G=j.map(V=>V[0]);await this.xb(G),await this.fb.addExtensionsToProfile(j,q),this.s.fire(G.map(V=>({local:V,identifier:V.identifier,operation:r.InstallOperation.None,profileLocation:q})))}async xb(j){const q=await this.ab.getUninstalledExtensions();for(const G of j){const V=i.$Ip.create(G);q[V.toString()]&&(this.F.trace("Removing the extension from uninstalled list:",V.id),await this.ab.setInstalled(V),this.F.info("Removed the extension from uninstalled list:",V.id))}}};t.$Sq=B,t.$Sq=B=we([ne(0,r.$gp),ne(1,ce.$$l),ne(2,ae.$_j),ne(3,a.$Ni),ne(4,o.$Gq),ne(5,s.$Cq),ne(6,e.$Wo),ne(7,Y.$Ei),ne(8,K.$_k),ne(9,le.$sk),ne(10,de.$Jl),ne(11,x.$Ll)],B);let U=class extends c.$Wc{constructor(j,q,G,V,b,L,F){super(),this.n=j,this.s=q,this.t=G,this.u=V,this.w=b,this.y=L,this.z=F,this.h=this.B(new k.$me),this.onExtract=this.h.event,this.j=new l.$Cc,this.m=new l.$Cc,this.c=(0,w.$gh)(this.t.userExtensionsLocation,".obsolete"),this.g=new E.$Mh}async cleanUp(){await this.J(),await this.I()}async scanExtensions(j,q,G){try{const V={includeInvalid:!0,profileLocation:q,productVersion:G};let b=[];if(j===null||j===T.ExtensionType.System){let L=this.j.get(q);L||(L=this.t.scanAllExtensions({includeInvalid:!0,useCache:!0},V,!1).finally(()=>this.j.delete(q)),this.j.set(q,L)),b.push(...await L)}else if(j===T.ExtensionType.User){let L=this.m.get(q);L||(L=this.t.scanUserExtensions(V).finally(()=>this.m.delete(q)),this.m.set(q,L)),b.push(...await L)}return b=j!==null?b.filter(L=>L.type===j):b,await Promise.all(b.map(L=>this.H(L)))}catch(V){throw(0,n.$zq)(V,r.ExtensionManagementErrorCode.Scanning)}}async scanAllUserExtensions(j){try{const q=await this.t.scanUserExtensions({includeAllVersions:!j,includeInvalid:!0});return await Promise.all(q.map(G=>this.H(G)))}catch(q){throw(0,n.$zq)(q,r.ExtensionManagementErrorCode.Scanning)}}async scanUserExtensionAtLocation(j){try{const q=await this.t.scanExistingExtension(j,T.ExtensionType.User,{includeInvalid:!0});if(q)return await this.H(q)}catch(q){this.z.error(q)}return null}async extractUserExtension(j,q,G,V,b){const L=j.toString(),F=p.URI.file(h.$lc(this.t.userExtensionsLocation.fsPath,`.${(0,f.$2g)()}`)),z=p.URI.file(h.$lc(this.t.userExtensionsLocation.fsPath,L));let Z=await this.s.exists(z);if(Z&&V){try{await this.D(j.id,z,"removeExisting")}catch{throw new r.$ip(v.localize(4,null,z.fsPath,j.id),r.ExtensionManagementErrorCode.Delete)}Z=!1}if(Z)try{await this.t.updateMetadata(z,G)}catch(Q){throw this.y.publicLog2("extension:extract",{extensionId:j.id,code:Q.code}),(0,n.$zq)(Q,r.ExtensionManagementErrorCode.UpdateExistingMetadata)}else try{if(b.isCancellationRequested)throw new A.$7;try{this.z.trace(`Started extracting the extension from ${q} to ${z.fsPath}`),await(0,I.$wq)(q,F.fsPath,{sourcePath:"extension",overwrite:!0},b),this.z.info(`Extracted extension to ${z}:`,j.id)}catch(Q){throw(0,N.$Lq)(Q)}try{await this.t.updateMetadata(F,G)}catch(Q){throw this.y.publicLog2("extension:extract",{extensionId:j.id,code:Q.code}),(0,n.$zq)(Q,r.ExtensionManagementErrorCode.UpdateMetadata)}if(b.isCancellationRequested)throw new A.$7;try{this.z.trace(`Started renaming the extension from ${F.fsPath} to ${z.fsPath}`),await this.G(F.fsPath,z.fsPath),this.z.info("Renamed to",z.fsPath)}catch(Q){if(Q.code==="ENOTEMPTY"){this.z.info("Rename failed because extension was installed by another source. So ignoring renaming.",j.id);try{await this.s.del(F,{recursive:!0})}catch{}}else throw this.z.info(`Rename failed because of ${(0,A.$_)(Q)}. Deleted from extracted location`,F),Q}this.h.fire(z)}catch(Q){try{await this.s.del(F,{recursive:!0})}catch{}throw Q}return this.scanLocalExtension(z,T.ExtensionType.User)}async scanMetadata(j,q){return q?(await this.C(j,q))?.metadata:this.t.scanMetadata(j.location)}async C(j,q){return(await this.u.scanProfileExtensions(q)).find(V=>(0,i.$Hp)(V.identifier,j.identifier))}async updateMetadata(j,q,G){try{G?await this.u.updateMetadata([[j,q]],G):await this.t.updateMetadata(j.location,q)}catch(V){throw this.y.publicLog2("extension:extract",{extensionId:j.identifier.id,code:V.code}),(0,n.$zq)(V,r.ExtensionManagementErrorCode.UpdateMetadata)}return this.scanLocalExtension(j.location,j.type,G)}async getUninstalledExtensions(){try{return await this.F()}catch(j){throw(0,n.$zq)(j,r.ExtensionManagementErrorCode.ReadUninstalled)}}async setUninstalled(...j){const q=j.map(G=>i.$Ip.create(G));await this.F(G=>q.forEach(V=>{G[V.toString()]=!0,this.z.info("Marked extension as uninstalled",V.toString())}))}async setInstalled(j){try{await this.F(q=>delete q[j.toString()])}catch(q){throw(0,n.$zq)(q,r.ExtensionManagementErrorCode.UnsetUninstalled)}}async removeExtension(j,q){if(this.w.extUri.isEqualOrParent(j.location,this.t.userExtensionsLocation))return this.D(j.identifier.id,j.location,q)}async removeUninstalledExtension(j){await this.removeExtension(j,"uninstalled"),await this.F(q=>delete q[i.$Ip.create(j).toString()])}async copyExtension(j,q,G,V){const b=await this.C(j,q),L=await this.C(j,G);if(V={...b?.metadata,...V},L)if(this.w.extUri.isEqual(L.location,j.location))await this.u.updateMetadata([[j,{...L.metadata,...V}]],G);else{const F=await this.scanLocalExtension(L.location,j.type,G);await this.u.removeExtensionFromProfile(F,G),await this.u.addExtensionsToProfile([[j,{...L.metadata,...V}]],G)}else await this.u.addExtensionsToProfile([[j,V]],G);return this.scanLocalExtension(j.location,j.type,G)}async copyExtensions(j,q,G){const V=await this.scanExtensions(T.ExtensionType.User,j,G),b=await Promise.all(V.filter(L=>!L.isApplicationScoped).map(async L=>[L,await this.scanMetadata(L,j)]));await this.u.addExtensionsToProfile(b,q)}async D(j,q,G){this.z.trace(`Deleting ${G} extension from disk`,j,q.fsPath);const V=this.w.extUri.joinPath(this.w.extUri.dirname(q),`${this.w.extUri.basename(q)}.${(0,g.$tj)((0,f.$2g)()).toString(16)}${_}`);await this.G(q.fsPath,V.fsPath),await this.s.del(V,{recursive:!0}),this.z.info(`Deleted ${G} extension from disk`,j,q.fsPath)}F(j){return this.g.queue(async()=>{let q;try{q=(await this.s.readFile(this.c,"utf8")).value.toString()}catch(V){if((0,K.$ql)(V)!==K.FileOperationResult.FILE_NOT_FOUND)throw V}let G={};if(q)try{G=JSON.parse(q)}catch{}return j&&(j(G),Object.keys(G).length?await this.s.writeFile(this.c,P.$Oe.fromString(JSON.stringify(G))):await this.s.del(this.c)),G})}async G(j,q){try{await $.Promises.rename(j,q,2*60*1e3)}catch(G){throw(0,n.$zq)(G,r.ExtensionManagementErrorCode.Rename)}}async scanLocalExtension(j,q,G){try{if(G){const b=(await this.t.scanUserExtensions({profileLocation:G})).find(L=>this.w.extUri.isEqual(L.location,j));if(b)return await this.H(b)}else{const V=await this.t.scanExistingExtension(j,q,{includeInvalid:!0});if(V)return await this.H(V)}throw new r.$ip(v.localize(5,null,j.path),r.ExtensionManagementErrorCode.ScanningExtension)}catch(V){throw(0,n.$zq)(V,r.ExtensionManagementErrorCode.ScanningExtension)}}async H(j){const q=await this.s.resolve(j.location);let G,V;return q.children&&(G=q.children.find(({name:b})=>/^readme(\.txt|\.md|)$/i.test(b))?.resource,V=q.children.find(({name:b})=>/^changelog(\.txt|\.md|)$/i.test(b))?.resource),{identifier:j.identifier,type:j.type,isBuiltin:j.isBuiltin||!!j.metadata?.isBuiltin,location:j.location,manifest:j.manifest,targetPlatform:j.targetPlatform,validations:j.validations,isValid:j.isValid,readmeUrl:G,changelogUrl:V,publisherDisplayName:j.metadata?.publisherDisplayName,publisherId:j.metadata?.publisherId||null,isApplicationScoped:!!j.metadata?.isApplicationScoped,isMachineScoped:!!j.metadata?.isMachineScoped,isPreReleaseVersion:!!j.metadata?.isPreReleaseVersion,hasPreReleaseVersion:!!j.metadata?.hasPreReleaseVersion,preRelease:!!j.metadata?.preRelease,installedTimestamp:j.metadata?.installedTimestamp,updated:!!j.metadata?.updated,pinned:!!j.metadata?.pinned,isWorkspaceScoped:!1,source:j.metadata?.source??(j.identifier.uuid?"gallery":"vsix")}}async I(){const j=await this.getUninstalledExtensions();if(Object.keys(j).length===0){this.z.debug("No uninstalled extensions found.");return}this.z.debug("Removing uninstalled extensions:",Object.keys(j));const q=await this.t.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),G=new Set;for(const b of q)j[i.$Ip.create(b).toString()]||G.add(b.identifier.id.toLowerCase());try{const b=(0,i.$Np)(q,L=>L.identifier);await E.Promises.settled(b.map(async L=>{const F=L.sort((z,Z)=>m.rcompare(z.manifest.version,Z.manifest.version))[0];G.has(F.identifier.id.toLowerCase())||await this.n(await this.H(F))}))}catch(b){this.z.error(b)}const V=q.filter(b=>b.metadata&&j[i.$Ip.create(b).toString()]);await Promise.allSettled(V.map(b=>this.removeUninstalledExtension(b)))}async J(){this.z.trace("ExtensionManagementService#removeTempDeleteFolders");let j;try{j=await this.s.resolve(this.t.userExtensionsLocation)}catch(q){(0,K.$ql)(q)!==K.FileOperationResult.FILE_NOT_FOUND&&this.z.error(q);return}if(j?.children)try{await Promise.allSettled(j.children.map(async q=>{if(!(!q.isDirectory||!q.name.endsWith(_))){this.z.trace("Deleting the temporarily deleted folder",q.resource.toString());try{await this.s.del(q.resource,{recursive:!0}),this.z.trace("Deleted the temporarily deleted folder",q.resource.toString())}catch(G){(0,K.$ql)(G)!==K.FileOperationResult.FILE_NOT_FOUND&&this.z.error(G)}}}))}catch{}}};t.$Tq=U,t.$Tq=U=we([ne(1,K.$_k),ne(2,o.$Gq),ne(3,s.$Cq),ne(4,de.$Jl),ne(5,ce.$$l),ne(6,ae.$_j)],U);let J=class extends n.$Aq{get operation(){return this.options.operation??this.j}get verificationStatus(){return this.k}constructor(j,q,G,V,b,L,F,z,Z,Q,se,he){super(),this.l=j,this.manifest=q,this.source=G,this.options=V,this.m=b,this.n=L,this.o=F,this.p=z,this.q=Z,this.s=Q,this.t=se,this.u=he,this.j=r.InstallOperation.Install,this.identifier=this.l.identifier}async h(j){const G=(await this.n.scanExtensions(T.ExtensionType.User,this.options.profileLocation,this.options.productVersion)).find(F=>(0,i.$Hp)(F.identifier,this.identifier));G&&(this.j=r.InstallOperation.Update);const V={isApplicationScoped:this.options.isApplicationScoped||G?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||G?.isMachineScoped,isBuiltin:this.options.isBuiltin||G?.isBuiltin,isSystem:G?.type===T.ExtensionType.System?!0:void 0,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:this.options.pinned??G?.pinned,source:this.source instanceof p.URI?"vsix":"gallery"};let b;if(this.source instanceof p.URI)if(G){if(this.l.equals(new i.$Ip(G.identifier,G.manifest.version)))try{await this.n.removeExtension(G,"existing")}catch{throw new Error(v.localize(6,null,this.manifest.displayName||this.manifest.name))}}else{const F=await this.w(this.l);if(F)try{await this.n.removeExtension(F,"existing")}catch{throw new Error(v.localize(7,null,this.manifest.displayName||this.manifest.name))}}else{if(V.id=this.source.identifier.uuid,V.publisherId=this.source.publisherId,V.publisherDisplayName=this.source.publisherDisplayName,V.targetPlatform=this.source.properties.targetPlatform,V.updated=!!G,V.isPreReleaseVersion=this.source.properties.isPreReleaseVersion,V.hasPreReleaseVersion=G?.hasPreReleaseVersion||this.source.properties.isPreReleaseVersion,V.preRelease=(0,R.$lg)(this.options.preRelease)?this.options.preRelease:this.options.installPreReleaseVersion||this.source.properties.isPreReleaseVersion||G?.preRelease,G&&G.type!==T.ExtensionType.System&&G.manifest.version===this.source.version)return this.n.updateMetadata(G,V,this.options.profileLocation);b=await this.w(this.l)}if(j.isCancellationRequested)throw(0,n.$zq)(new A.$7);if(!b){const F=await this.m(this.operation,j);b=F.local,this.k=F.verificationStatus}if(this.o.extUri.isEqual(this.q.defaultProfile.extensionsResource,this.options.profileLocation))try{await this.s.initializeDefaultProfileExtensions()}catch(F){throw(0,n.$zq)(F,r.ExtensionManagementErrorCode.IntializeDefaultProfile)}if(j.isCancellationRequested)throw(0,n.$zq)(new A.$7);try{await this.t.addExtensionsToProfile([[b,V]],this.options.profileLocation,!b.isValid)}catch(F){throw(0,n.$zq)(F,r.ExtensionManagementErrorCode.AddToProfile)}const L=await this.n.scanLocalExtension(b.location,T.ExtensionType.User,this.options.profileLocation);if(!L)throw new r.$ip("Cannot find the installed extension",r.ExtensionManagementErrorCode.InstalledExtensionNotFound);return this.source instanceof p.URI&&this.x(b,j),L}async w(j){return(await this.n.getUninstalledExtensions())[j.toString()]?(this.u.trace("Removing the extension from uninstalled list:",j.id),await this.n.setInstalled(j),this.u.info("Removed the extension from uninstalled list:",j.id),(await this.n.scanAllUserExtensions(!0)).find(V=>i.$Ip.create(V).equals(j))):void 0}async x(j,q){try{let[G]=await this.p.getExtensions([{id:j.identifier.id,version:j.manifest.version}],q);if(G||([G]=await this.p.getExtensions([{id:j.identifier.id}],q)),G){const V={id:G.identifier.uuid,publisherDisplayName:G.publisherDisplayName,publisherId:G.publisherId,isPreReleaseVersion:G.properties.isPreReleaseVersion,hasPreReleaseVersion:j.hasPreReleaseVersion||G.properties.isPreReleaseVersion,preRelease:G.properties.isPreReleaseVersion||this.options.installPreReleaseVersion};await this.n.updateMetadata(j,V,this.options.profileLocation)}}catch{}}};J=we([ne(6,de.$Jl),ne(7,r.$gp),ne(8,x.$Ll),ne(9,o.$Gq),ne(10,s.$Cq),ne(11,ae.$_j)],J);class X extends n.$Aq{constructor(j,q,G){super(),this.extension=j,this.j=q,this.k=G}async h(j){await this.k.removeExtensionFromProfile(this.extension,this.j)}}}),define(re[163],oe([0,1,6,24,23,19,42,10,18,12]),function(H,t,E,P,y,O,A,k,g,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$kR=void 0;let l=class extends A.$Dq{constructor(h,w,m,R,p,f){super(c.URI.file(h.extensionsPath),w,m,R,p,f)}};t.$kR=l,t.$kR=l=we([ne(0,g.$Ni),ne(1,k.$_k),ne(2,P.$Ll),ne(3,y.$Jl),ne(4,O.$$l),ne(5,E.$_j)],l)}),define(re[164],oe([0,1,12,18,42,54,10,11,6,33,23,24]),function(H,t,E,P,y,O,A,k,g,c,l,u){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$3fc=void 0;let h=class extends O.$Kq{constructor(m,R,p,f,$,I,v,e){super(E.URI.file($.builtinExtensionsPath),E.URI.file($.extensionsPath),$.userHome,m.defaultProfile,m,R,p,f,$,I,v,e)}};t.$3fc=h,t.$3fc=h=we([ne(0,u.$Ll),ne(1,y.$Cq),ne(2,A.$_k),ne(3,g.$_j),ne(4,P.$Ni),ne(5,c.$sk),ne(6,l.$Jl),ne(7,k.$Ei)],h)}),define(re[73],oe([0,1,8,5,2,132,3,92,11,24]),function(H,t,E,P,y,O,A,k,g,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$fq=t.$dq=t.StorageTarget=t.StorageScope=t.WillSaveStateReason=t.$bq=t.$aq=t.$_p=void 0,t.$cq=w,t.$eq=R,t.$gq=f,t.$_p="__$__isNewStorageMarker",t.$aq="__$__targetStorageMarker",t.$bq=(0,g.$Fi)("storageService");var l;(function($){$[$.NONE=0]="NONE",$[$.SHUTDOWN=1]="SHUTDOWN"})(l||(t.WillSaveStateReason=l={}));var u;(function($){$[$.APPLICATION=-1]="APPLICATION",$[$.PROFILE=0]="PROFILE",$[$.WORKSPACE=1]="WORKSPACE"})(u||(t.StorageScope=u={}));var h;(function($){$[$.USER=0]="USER",$[$.MACHINE=1]="MACHINE"})(h||(t.StorageTarget=h={}));function w($){const I=$.get(t.$aq);if(I)try{return JSON.parse(I)}catch{}return Object.create(null)}class m extends y.$Wc{static{this.a=60*1e3}constructor(I={flushInterval:m.a}){super(),this.m=I,this.b=this.B(new P.$pe),this.c=this.B(new P.$pe),this.onDidChangeTarget=this.c.event,this.f=this.B(new P.$me),this.onWillSaveState=this.f.event,this.h=this.B(new E.$Rh(()=>this.n(),this.m.flushInterval)),this.j=this.B(new y.$Xc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(I,v,e){return P.Event.filter(this.b.event,a=>a.scope===I&&(v===void 0||a.key===v),e)}n(){this.j.value=(0,E.$Vh)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,y.$Rc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,O.mark)("code/willInitStorage");try{await this.O()}finally{(0,O.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(I,v){const{key:e,external:a}=v;if(e===t.$aq){switch(I){case u.APPLICATION:this.H=void 0;break;case u.PROFILE:this.F=void 0;break;case u.WORKSPACE:this.C=void 0;break}this.c.fire({scope:I})}else this.b.fire({scope:I,key:e,target:this.J(I)[e],external:a})}w(I){this.f.fire({reason:I})}get(I,v,e){return this.P(v)?.get(I,e)}getBoolean(I,v,e){return this.P(v)?.getBoolean(I,e)}getNumber(I,v,e){return this.P(v)?.getNumber(I,e)}getObject(I,v,e){return this.P(v)?.getObject(I,e)}storeAll(I,v){this.y(()=>{for(const e of I)this.store(e.key,e.value,e.scope,e.target,v)})}store(I,v,e,a,n=!1){if((0,A.$og)(v)){this.remove(I,e,n);return}this.y(()=>{this.z(I,e,a),this.P(e)?.set(I,v,n)})}remove(I,v,e=!1){this.y(()=>{this.z(I,v,void 0),this.P(v)?.delete(I,e)})}y(I){this.b.pause(),this.c.pause();try{I()}finally{this.b.resume(),this.c.resume()}}keys(I,v){const e=[],a=this.J(I);for(const n of Object.keys(a))a[n]===v&&e.push(n);return e}z(I,v,e,a=!1){const n=this.J(v);typeof e=="number"?n[I]!==e&&(n[I]=e,this.P(v)?.set(t.$aq,JSON.stringify(n),a)):typeof n[I]=="number"&&(delete n[I],this.P(v)?.set(t.$aq,JSON.stringify(n),a))}get D(){return this.C||(this.C=this.L(u.WORKSPACE)),this.C}get G(){return this.F||(this.F=this.L(u.PROFILE)),this.F}get I(){return this.H||(this.H=this.L(u.APPLICATION)),this.H}J(I){switch(I){case u.APPLICATION:return this.I;case u.PROFILE:return this.G;default:return this.D}}L(I){const v=this.P(I);return v?w(v):Object.create(null)}isNew(I){return this.getBoolean(t.$_p,I)===!0}async flush(I=l.NONE){this.f.fire({reason:I});const v=this.P(u.APPLICATION),e=this.P(u.PROFILE),a=this.P(u.WORKSPACE);switch(I){case l.NONE:await E.Promises.settled([v?.whenFlushed()??Promise.resolve(),e?.whenFlushed()??Promise.resolve(),a?.whenFlushed()??Promise.resolve()]);break;case l.SHUTDOWN:await E.Promises.settled([v?.flush(0)??Promise.resolve(),e?.flush(0)??Promise.resolve(),a?.flush(0)??Promise.resolve()]);break}}async log(){const I=this.P(u.APPLICATION)?.items??new Map,v=this.P(u.PROFILE)?.items??new Map,e=this.P(u.WORKSPACE)?.items??new Map;return f(I,v,e,this.Q(u.APPLICATION)??"",this.Q(u.PROFILE)??"",this.Q(u.WORKSPACE)??"")}async optimize(I){return await this.flush(),this.P(I)?.optimize()}async switch(I,v){return this.w(l.NONE),(0,c.$Kl)(I)?this.R(I,v):this.S(I,v)}M(I,v){return!(I.id===v.id||R(v)&&R(I))}N(I,v,e){this.y(()=>{const a=new Set;for(const[n,r]of I)a.add(n),v.get(n)!==r&&this.u(e,{key:n,external:!0});for(const[n]of v.items)a.has(n)||this.u(e,{key:n,external:!0})})}}t.$dq=m;function R($){return $.isDefault||!!$.useDefaultFlags?.globalState}class p extends m{constructor(){super(),this.U=this.B(new k.$0p(new k.$$p,{hint:k.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new k.$0p(new k.$$p,{hint:k.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new k.$0p(new k.$$p,{hint:k.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(I=>this.u(u.WORKSPACE,I))),this.B(this.W.onDidChangeStorage(I=>this.u(u.PROFILE,I))),this.B(this.U.onDidChangeStorage(I=>this.u(u.APPLICATION,I)))}P(I){switch(I){case u.APPLICATION:return this.U;case u.PROFILE:return this.W;default:return this.X}}Q(I){switch(I){case u.APPLICATION:return"inMemory (application)";case u.PROFILE:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(I){return!1}}t.$fq=p;async function f($,I,v,e,a,n){const r=T=>{try{return JSON.parse(T)}catch{return T}},i=new Map,s=new Map;$.forEach((T,M)=>{i.set(M,T),s.set(M,r(T))});const o=new Map,d=new Map;I.forEach((T,M)=>{o.set(M,T),d.set(M,r(T))});const S=new Map,N=new Map;v.forEach((T,M)=>{S.set(M,T),N.set(M,r(T))}),console.group(e!==a?`Storage: Application (path: ${e})`:`Storage: Application & Profile (path: ${e}, default profile)`);const C=[];if(i.forEach((T,M)=>{C.push({key:M,value:T})}),console.table(C),console.groupEnd(),console.log(s),e!==a){console.group(`Storage: Profile (path: ${a}, profile specific)`);const T=[];o.forEach((M,K)=>{T.push({key:K,value:M})}),console.table(T),console.groupEnd(),console.log(d)}console.group(`Storage: Workspace (path: ${n})`);const D=[];S.forEach((T,M)=>{D.push({key:M,value:T})}),console.table(D),console.groupEnd(),console.log(N)}}),define(re[165],oe([0,1,14,29,73]),function(H,t,E,P,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$hq=O;async function O(A,k,g){let c=g&&g.get("storage.serviceMachineId",y.StorageScope.APPLICATION)||null;if(c)return c;try{const u=(await k.readFile(A.serviceMachineIdResource)).value.toString();c=(0,P.$1g)(u)?u:null}catch{c=null}if(!c){c=(0,P.$2g)();try{await k.writeFile(A.serviceMachineIdResource,E.$Oe.fromString(c))}catch{}}return g?.store("storage.serviceMachineId",c,y.StorageScope.APPLICATION,y.StorageTarget.MACHINE),c}}),define(re[166],oe([0,1,165,19,41]),function(H,t,E,P,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$iq=O;async function O(A,k,g,c,l,u,h){const w={"X-Market-Client-Id":`VSCode ${A}`,"User-Agent":`VSCode ${A} (${k.nameShort})`};if((0,y.$zp)(k,g)&&(0,y.$Bp)(c)===P.TelemetryLevel.USAGE){const m=await(0,E.$hq)(g,l,u);w["X-Market-User-Id"]=m,w["VSCode-SessionId"]=h.machineId||m}return w}}),define(re[167],oe([0,1,20,22,9,13,36,3,12,30,18,21,27,26,50,10,6,33,45,166,73,19,179]),function(H,t,E,P,y,O,A,k,g,c,l,u,h,w,m,R,p,f,$,I,v,e,a){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$lq=t.$kq=void 0,t.$jq=ee;const n=O.$o?w.TargetPlatform.WEB:(0,u.$cp)(O.$u,A.$gc),r="X-Market-Search-Activity-Id";var i;(function(L){L[L.None=0]="None",L[L.IncludeVersions=1]="IncludeVersions",L[L.IncludeFiles=2]="IncludeFiles",L[L.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",L[L.IncludeSharedAccounts=8]="IncludeSharedAccounts",L[L.IncludeVersionProperties=16]="IncludeVersionProperties",L[L.ExcludeNonValidated=32]="ExcludeNonValidated",L[L.IncludeInstallationTargets=64]="IncludeInstallationTargets",L[L.IncludeAssetUri=128]="IncludeAssetUri",L[L.IncludeStatistics=256]="IncludeStatistics",L[L.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",L[L.Unpublished=4096]="Unpublished",L[L.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(i||(i={}));function s(...L){return String(L.reduce((F,z)=>F|z,0))}var o;(function(L){L[L.Tag=1]="Tag",L[L.ExtensionId=4]="ExtensionId",L[L.Category=5]="Category",L[L.ExtensionName=7]="ExtensionName",L[L.Target=8]="Target",L[L.Featured=9]="Featured",L[L.SearchText=10]="SearchText",L[L.ExcludeWithFlags=12]="ExcludeWithFlags"})(o||(o={}));const d={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source",Signature:"Microsoft.VisualStudio.Services.VsixSignature"},S={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink",SupportLink:"Microsoft.VisualStudio.Services.Links.Support"},C={pageNumber:1,pageSize:10,sortBy:u.SortBy.NoneOrRelevance,sortOrder:u.SortOrder.Default,flags:i.None,criteria:[],assetTypes:[]};class D{constructor(F=C){this.d=F}get pageNumber(){return this.d.pageNumber}get pageSize(){return this.d.pageSize}get sortBy(){return this.d.sortBy}get sortOrder(){return this.d.sortOrder}get flags(){return this.d.flags}get criteria(){return this.d.criteria}withPage(F,z=this.d.pageSize){return new D({...this.d,pageNumber:F,pageSize:z})}withFilter(F,...z){const Z=[...this.d.criteria,...z.length?z.map(Q=>({filterType:F,value:Q})):[{filterType:F}]];return new D({...this.d,criteria:Z})}withSortBy(F){return new D({...this.d,sortBy:F})}withSortOrder(F){return new D({...this.d,sortOrder:F})}withFlags(...F){return new D({...this.d,flags:F.reduce((z,Z)=>z|Z,0)})}withAssetTypes(...F){return new D({...this.d,assetTypes:F})}withSource(F){return new D({...this.d,source:F})}get raw(){const{criteria:F,pageNumber:z,pageSize:Z,sortBy:Q,sortOrder:se,flags:he,assetTypes:ue}=this.d;return{filters:[{criteria:F,pageNumber:z,pageSize:Z,sortBy:Q,sortOrder:se}],assetTypes:ue,flags:he}}get searchText(){const F=this.d.criteria.filter(z=>z.filterType===o.SearchText)[0];return F&&F.value?F.value:""}get telemetryData(){return{filterTypes:this.d.criteria.map(F=>String(F.filterType)),flags:this.d.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.d.source,searchTextLength:this.searchText.length}}}function T(L,F){const z=(L||[]).filter(Z=>Z.statisticName===F)[0];return z?z.value:0}function M(L){const F="Microsoft.VisualStudio.Code.Translation.";return L.files.filter(Z=>Z.assetType.indexOf(F)===0).reduce((Z,Q)=>{const se=ae(L,Q.assetType);return se&&Z.push([Q.assetType.substring(F.length),se]),Z},[])}function K(L){if(L.properties){const F=L.properties.filter(Q=>Q.key===d.Repository),z=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),Z=F.filter(Q=>z.test(Q.value))[0];return Z?{uri:Z.value,fallbackUri:Z.value}:null}return ae(L,d.Repository)}function Y(L){return{uri:`${L.fallbackAssetUri}/${d.VSIX}?redirect=true${L.targetPlatform?`&targetPlatform=${L.targetPlatform}`:""}`,fallbackUri:`${L.fallbackAssetUri}/${d.VSIX}${L.targetPlatform?`?targetPlatform=${L.targetPlatform}`:""}`}}function ae(L,F){return L.files.filter(Z=>Z.assetType===F)[0]?{uri:`${L.assetUri}/${F}${L.targetPlatform?`?targetPlatform=${L.targetPlatform}`:""}`,fallbackUri:`${L.fallbackAssetUri}/${F}${L.targetPlatform?`?targetPlatform=${L.targetPlatform}`:""}`}:null}function le(L,F){const z=L.properties?L.properties.filter(Q=>Q.key===F):[],Z=z.length>0&&z[0].value;return Z?Z.split(",").map(Q=>(0,h.$Lp)(Q)):[]}function ce(L){const F=L.properties?L.properties.filter(z=>z.key===S.Engine):[];return F.length>0&&F[0].value||""}function de(L){const F=L.properties?L.properties.filter(z=>z.key===S.PreRelease):[];return F.length>0&&F[0].value==="true"}function x(L){const F=L.properties?L.properties.filter(Z=>Z.key===S.LocalizedLanguages):[],z=F.length>0&&F[0].value||"";return z?z.split(","):[]}function _(L){return L.properties?.find(F=>F.key===S.SponsorLink)?.value}function B(L){return L.properties?.find(F=>F.key===S.SupportLink)?.value}function U(L){return L.indexOf("preview")!==-1}function J(L){return L.targetPlatform?(0,u.$bp)(L.targetPlatform):w.TargetPlatform.UNDEFINED}function X(L){const F=(0,E.$Ob)(L.versions.map(J)),z=!!L.tags?.includes(u.$8o),Z=F.indexOf(w.TargetPlatform.WEB);return z?Z===-1&&F.push(w.TargetPlatform.WEB):Z!==-1&&F.splice(Z,1),F}function ee(L,F){for(let z=0;z<L.length;z++){const Z=L[z];if(Z.version===L[z-1]?.version){let Q=z;if(J(Z)===F)for(;Q>0&&L[Q-1].version===Z.version;)Q--;Q!==z&&(L.splice(z,1),L.splice(Q,0,Z))}}return L}function j(L,F,z){L.telemetryData={index:F,querySource:z,queryActivityId:L.queryContext?.[r]}}function q(L,F,z,Z){const Q=L.versions[0],se={manifest:ae(F,d.Manifest),readme:ae(F,d.Details),changelog:ae(F,d.Changelog),license:ae(F,d.License),repository:K(F),download:Y(F),icon:ae(F,d.Icon),signature:ae(F,d.Signature),coreTranslations:M(F)};return{type:"gallery",identifier:{id:(0,h.$Mp)(L.publisher.publisherName,L.extensionName),uuid:L.extensionId},name:L.extensionName,version:F.version,displayName:L.displayName,publisherId:L.publisher.publisherId,publisher:L.publisher.publisherName,publisherDisplayName:L.publisher.displayName,publisherDomain:L.publisher.domain?{link:L.publisher.domain,verified:!!L.publisher.isDomainVerified}:void 0,publisherSponsorLink:_(Q),description:L.shortDescription??"",installCount:T(L.statistics,"install"),rating:T(L.statistics,"averagerating"),ratingCount:T(L.statistics,"ratingcount"),categories:L.categories||[],tags:L.tags||[],releaseDate:Date.parse(L.releaseDate),lastUpdated:Date.parse(L.lastUpdated),allTargetPlatforms:z,assets:se,properties:{dependencies:le(F,S.Dependency),extensionPack:le(F,S.ExtensionPack),engine:ce(F),localizedLanguages:x(F),targetPlatform:J(F),isPreReleaseVersion:de(F)},hasPreReleaseVersion:de(Q),hasReleaseVersion:!0,preview:U(L.flags),isSigned:!!se.signature,queryContext:Z,supportLink:B(Q)}}let G=class{constructor(F,z,Z,Q,se,he,ue,Ee){this.k=z,this.l=Z,this.n=Q,this.o=se,this.q=he,this.u=ue,this.w=Ee;const pe=ue.extensionsGallery,ge=pe?.servicePPEUrl&&Ee.getValue("_extensionsGallery.enablePPE");this.d=ge?pe.servicePPEUrl:pe?.serviceUrl,this.g=ge?void 0:pe?.searchUrl,this.h=pe?.controlUrl,this.j=(0,I.$iq)(ue.version,ue,this.n,this.w,this.q,F,this.o)}x(F=""){return`${this.d}${F}`}isEnabled(){return!!this.d}async getExtensions(F,z,Z){const Q=P.CancellationToken.isCancellationToken(z)?{}:z,se=P.CancellationToken.isCancellationToken(z)?z:Z,he=[],ue=[],Ee=[],pe=[];let ge=!0;for(const ve of F){ve.uuid?ue.push(ve.uuid):he.push(ve.id);const ke=!!(ve.version||ve.preRelease);Ee.push({id:ve.id,uuid:ve.uuid,includePreRelease:ke}),ve.version&&pe.push({id:ve.id,uuid:ve.uuid,version:ve.version}),ge=ge&&!!ve.hasPreRelease&&!ke}if(!ue.length&&!he.length)return[];let fe=new D().withPage(1,F.length);ue.length&&(fe=fe.withFilter(o.ExtensionId,...ue)),he.length&&(fe=fe.withFilter(o.ExtensionName,...he)),(Q.queryAllVersions||ge)&&(fe=fe.withFlags(fe.flags,i.IncludeVersions)),Q.source&&(fe=fe.withSource(Q.source));const{extensions:$e}=await this.z(fe,{targetPlatform:Q.targetPlatform??n,includePreRelease:Ee,versions:pe,compatible:!!Q.compatible,productVersion:Q.productVersion??{version:this.u.version,date:this.u.date}},se);return Q.source&&$e.forEach((ve,ke)=>j(ve,ke,Q.source)),$e}async getCompatibleExtension(F,z,Z,Q={version:this.u.version,date:this.u.date}){if((0,u.$dp)(F.allTargetPlatforms,Z))return null;if(await this.isExtensionCompatible(F,z,Z))return F;const se=new D().withFlags(i.IncludeVersions).withPage(1,1).withFilter(o.ExtensionId,F.identifier.uuid),{extensions:he}=await this.z(se,{targetPlatform:Z,compatible:!0,includePreRelease:z,productVersion:Q},P.CancellationToken.None);return he[0]||null}async isExtensionCompatible(F,z,Z,Q={version:this.u.version,date:this.u.date}){if(!(0,u.$ep)(F.properties.targetPlatform,F.allTargetPlatforms,Z)||!z&&F.properties.isPreReleaseVersion)return!1;let se=F.properties.engine;if(!se){const he=await this.getManifest(F,P.CancellationToken.None);if(!he)throw new Error("Manifest was not found");se=he.engines.vscode}return(0,m.$Zp)(se,Q.version,Q.date)}async y(F,z,Z,Q,se,he,ue={version:this.u.version,date:this.u.date}){if(!(0,u.$ep)(J(z),se,he)||Z!=="any"&&de(z)!==(Z==="prerelease"))return!1;if(Q)try{const Ee=await this.E(F,z);if(!(0,m.$Zp)(Ee,ue.version,ue.date))return!1}catch(Ee){return this.l.error(`Error while getting the engine for the version ${z.version}.`,(0,y.$_)(Ee)),!1}return!0}async query(F,z){let Z=F.text||"";const Q=F.pageSize??50;let se=new D().withPage(1,Q);Z?(Z=Z.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ge,fe,$e)=>(se=se.withFilter(o.Category,$e||fe),"")),Z=Z.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ge,fe,$e)=>(se=se.withFilter(o.Tag,$e||fe),"")),Z=Z.replace(/\bfeatured(\s+|\b|$)/g,()=>(se=se.withFilter(o.Featured),"")),Z=Z.trim(),Z&&(Z=Z.length<200?Z:Z.substring(0,200),se=se.withFilter(o.SearchText,Z)),se=se.withSortBy(u.SortBy.NoneOrRelevance)):F.ids?se=se.withFilter(o.ExtensionId,...F.ids):F.names?se=se.withFilter(o.ExtensionName,...F.names):se=se.withSortBy(u.SortBy.InstallCount),typeof F.sortBy=="number"&&(se=se.withSortBy(F.sortBy)),typeof F.sortOrder=="number"&&(se=se.withSortOrder(F.sortOrder)),F.source&&(se=se.withSource(F.source));const he=async(ge,fe)=>{const{extensions:$e,total:ve}=await this.z(ge,{targetPlatform:n,compatible:!1,includePreRelease:!!F.includePreRelease,productVersion:F.productVersion??{version:this.u.version,date:this.u.date}},fe);return $e.forEach((ke,W)=>j(ke,(ge.pageNumber-1)*ge.pageSize+W,F.source)),{extensions:$e,total:ve}},{extensions:ue,total:Ee}=await he(se,z),pe=async(ge,fe)=>{if(fe.isCancellationRequested)throw new y.$7;const{extensions:$e}=await he(se.withPage(ge+1),fe);return $e};return{firstPage:ue,total:Ee,pageSize:se.pageSize,getPage:pe}}async z(F,z,Z){const Q=F.flags;F.flags&i.IncludeLatestVersionOnly&&F.flags&i.IncludeVersions&&(F=F.withFlags(F.flags&~i.IncludeVersions,i.IncludeLatestVersionOnly)),!(F.flags&i.IncludeLatestVersionOnly)&&!(F.flags&i.IncludeVersions)&&(F=F.withFlags(F.flags,i.IncludeLatestVersionOnly)),z.versions?.length&&(F=F.withFlags(F.flags&~i.IncludeLatestVersionOnly,i.IncludeVersions)),F=F.withFlags(F.flags,i.IncludeAssetUri,i.IncludeCategoryAndTags,i.IncludeFiles,i.IncludeStatistics,i.IncludeVersionProperties);const{galleryExtensions:se,total:he,context:ue}=await this.B(F,Z);if(!(F.flags&i.IncludeLatestVersionOnly)){const fe=[];for(const $e of se){const ve=await this.A($e,z,ue);ve&&fe.push(ve)}return{extensions:fe,total:he}}const pe=[],ge=new Map;for(let fe=0;fe<se.length;fe++){const $e=se[fe],ve={id:(0,h.$Mp)($e.publisher.publisherName,$e.extensionName),uuid:$e.extensionId},ke=(0,k.$lg)(z.includePreRelease)?z.includePreRelease:!!z.includePreRelease.find(te=>(0,h.$Hp)(te,ve))?.includePreRelease;if(z.compatible&&(0,u.$dp)(X($e),z.targetPlatform))continue;const W=await this.A($e,z,ue);!W||W.properties.isPreReleaseVersion&&(!ke||!W.hasReleaseVersion)||!W.properties.isPreReleaseVersion&&W.properties.targetPlatform!==z.targetPlatform&&W.hasPreReleaseVersion?ge.set($e.extensionId,fe):pe.push([fe,W])}if(ge.size){const fe=new a.$ge,$e=new D().withFlags(Q&~i.IncludeLatestVersionOnly,i.IncludeVersions).withPage(1,ge.size).withFilter(o.ExtensionId,...ge.keys()),{extensions:ve}=await this.z($e,z,Z);this.o.publicLog2("galleryService:additionalQuery",{duration:fe.elapsed(),count:ge.size});for(const ke of ve){const W=ge.get(ke.identifier.uuid);pe.push([W,ke])}}return{extensions:pe.sort((fe,$e)=>fe[0]-$e[0]).map(([,fe])=>fe),total:he}}async A(F,z,Z){const Q={id:(0,h.$Mp)(F.publisher.publisherName,F.extensionName),uuid:F.extensionId},se=z.versions?.find(pe=>(0,h.$Hp)(pe,Q))?.version,he=(0,k.$lg)(z.includePreRelease)?z.includePreRelease:!!z.includePreRelease.find(pe=>(0,h.$Hp)(pe,Q))?.includePreRelease,ue=X(F),Ee=ee(F.versions,z.targetPlatform);if(z.compatible&&(0,u.$dp)(ue,z.targetPlatform))return null;for(let pe=0;pe<Ee.length;pe++){const ge=Ee[pe];if(!(se&&ge.version!==se)){if(await this.y((0,h.$Mp)(F.publisher.publisherName,F.extensionName),ge,he?"any":"release",z.compatible,ue,z.targetPlatform,z.productVersion))return q(F,ge,ue,Z);if(se&&ge.version===se)return null}}return se||z.compatible?null:q(F,F.versions[0],ue)}async B(F,z){if(!this.isEnabled())throw new Error("No extension gallery service configured.");F=F.withFlags(F.flags,i.ExcludeNonValidated).withFilter(o.Target,"Microsoft.VisualStudio.Code").withFilter(o.ExcludeWithFlags,s(i.Unpublished));const Z=await this.j,Q=JSON.stringify(F.raw),se={...Z,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(Q.length)},he=new a.$ge;let ue,Ee,pe=0;try{if(ue=await this.k.request({type:"POST",url:this.g&&F.criteria.some(fe=>fe.filterType===o.SearchText)?this.g:this.x("/extensionquery"),data:Q,headers:se},z),ue.res.statusCode&&ue.res.statusCode>=400&&ue.res.statusCode<500)return{galleryExtensions:[],total:pe};const ge=await(0,$.$7p)(ue);if(ge){const fe=ge.results[0],$e=fe.extensions,ve=fe.resultMetadata&&fe.resultMetadata.filter(ke=>ke.metadataType==="ResultCount")[0];return pe=ve&&ve.metadataItems.filter(ke=>ke.name==="TotalCount")[0].count||0,{galleryExtensions:$e,total:pe,context:{[r]:ue.res.headers.activityid}}}return{galleryExtensions:[],total:pe}}catch(ge){if((0,y.$6)(ge))throw Ee=u.ExtensionGalleryErrorCode.Cancelled,ge;{const fe=(0,y.$_)(ge);throw Ee=fe.startsWith("XHR timeout")?u.ExtensionGalleryErrorCode.Timeout:u.ExtensionGalleryErrorCode.Failed,new u.$hp(fe,Ee)}}finally{this.o.publicLog2("galleryService:query",{...F.telemetryData,requestBodySize:String(Q.length),duration:he.elapsed(),success:!!ue&&(0,$.$3p)(ue),responseBodySize:ue?.res.headers["Content-Length"],statusCode:ue?String(ue.res.statusCode):void 0,errorCode:Ee,count:String(pe)})}}async reportStatistic(F,z,Z,Q){if(!this.isEnabled())return;const se=O.$o?this.x(`/itemName/${F}.${z}/version/${Z}/statType/${Q===u.StatisticType.Install?"1":"3"}/vscodewebextension`):this.x(`/publishers/${F}/extensions/${z}/${Z}/stats?statType=${Q}`),he=O.$o?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",Ee={...await this.j,Accept:he};try{await this.k.request({type:"POST",url:se,headers:Ee},P.CancellationToken.None)}catch{}}async download(F,z,Z){this.l.trace("ExtensionGalleryService#download",F.identifier.id);const Q=(0,h.$Pp)(F),se=new Date().getTime(),he=Z===u.InstallOperation.Install?"install":Z===u.InstallOperation.Update?"update":"",ue=he?{uri:`${F.assets.download.uri}${g.URI.parse(F.assets.download.uri).query?"&":"?"}${he}=true`,fallbackUri:`${F.assets.download.fallbackUri}${g.URI.parse(F.assets.download.fallbackUri).query?"&":"?"}${he}=true`}:F.assets.download,Ee=F.queryContext?.[r]?{[r]:F.queryContext[r]}:void 0,pe=await this.D(F.identifier.id,ue,d.VSIX,Ee?{headers:Ee}:void 0);try{await this.q.writeFile(z,pe.stream)}catch(ge){try{await this.q.del(z)}catch(fe){this.l.warn(`Error while deleting the file ${z.toString()}`,(0,y.$_)(fe))}throw new u.$hp((0,y.$_)(ge),u.ExtensionGalleryErrorCode.DownloadFailedWriting)}this.o.publicLog("galleryService:downloadVSIX",{...Q,duration:new Date().getTime()-se})}async downloadSignatureArchive(F,z){if(!F.assets.signature)throw new Error("No signature asset found");this.l.trace("ExtensionGalleryService#downloadSignatureArchive",F.identifier.id);const Z=await this.D(F.identifier.id,F.assets.signature,d.Signature);try{await this.q.writeFile(z,Z.stream)}catch(Q){try{await this.q.del(z)}catch(se){this.l.warn(`Error while deleting the file ${z.toString()}`,(0,y.$_)(se))}throw new u.$hp((0,y.$_)(Q),u.ExtensionGalleryErrorCode.DownloadFailedWriting)}}async getReadme(F,z){if(F.assets.readme){const Z=await this.D(F.identifier.id,F.assets.readme,d.Details,{},z);return await(0,$.$6p)(Z)||""}return""}async getManifest(F,z){if(F.assets.manifest){const Z=await this.D(F.identifier.id,F.assets.manifest,d.Manifest,{},z),Q=await(0,$.$6p)(Z);return Q?JSON.parse(Q):null}return null}async C(F,z,Z){const Q=ae(z,d.Manifest);if(!Q)throw new Error("Manifest was not found");const se={"Accept-Encoding":"gzip"},he=await this.D(F,Q,d.Manifest,{headers:se});return await(0,$.$7p)(he)}async getCoreTranslation(F,z){const Z=F.assets.coreTranslations.filter(Q=>Q[0]===z.toUpperCase())[0];if(Z){const Q=await this.D(F.identifier.id,Z[1],Z[0]),se=await(0,$.$6p)(Q);return se?JSON.parse(se):null}return null}async getChangelog(F,z){if(F.assets.changelog){const Z=await this.D(F.identifier.id,F.assets.changelog,d.Changelog,{},z);return await(0,$.$6p)(Z)||""}return""}async getAllCompatibleVersions(F,z,Z){let Q=new D().withFlags(i.IncludeVersions,i.IncludeCategoryAndTags,i.IncludeFiles,i.IncludeVersionProperties).withPage(1,1);F.identifier.uuid?Q=Q.withFilter(o.ExtensionId,F.identifier.uuid):Q=Q.withFilter(o.ExtensionName,F.identifier.id);const{galleryExtensions:se}=await this.B(Q,P.CancellationToken.None);if(!se.length)return[];const he=X(se[0]);if((0,u.$dp)(he,Z))return[];const ue=[];await Promise.all(se[0].versions.map(async ge=>{try{await this.y(F.identifier.id,ge,z?"any":"release",!0,he,Z)&&ue.push(ge)}catch{}}));const Ee=[],pe=new Set;for(const ge of ee(ue,Z))pe.has(ge.version)||(pe.add(ge.version),Ee.push({version:ge.version,date:ge.lastUpdated,isPreReleaseVersion:de(ge)}));return Ee}async D(F,z,Z,Q={},se=P.CancellationToken.None){const he=await this.j,ue={type:"GET"},Ee={...he,...Q.headers||{}};Q={...Q,...ue,headers:Ee};const pe=z.uri,ge=z.fallbackUri,fe={...Q,url:pe};try{const $e=await this.k.request(fe,se);if($e.res.statusCode===200)return $e;const ve=await(0,$.$6p)($e);throw new Error(`Expected 200, got back ${$e.res.statusCode} instead.

${ve}`)}catch($e){if((0,y.$6)($e))throw $e;const ve=(0,y.$_)($e);this.o.publicLog2("galleryService:cdnFallback",{extension:F,assetType:Z,message:ve});const ke={...Q,url:ge};return this.k.request(ke,se)}}async E(F,z){let Z=ce(z);if(!Z){this.o.publicLog2("galleryService:engineFallback",{extension:F,version:z.version});const Q=await this.C(F,z,P.CancellationToken.None);if(!Q)throw new Error("Manifest was not found");Z=Q.engines.vscode}return Z}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.h)return{malicious:[],deprecated:{},search:[]};const F=await this.k.request({type:"GET",url:this.h},P.CancellationToken.None);if(F.res.statusCode!==200)throw new Error("Could not get extensions report.");const z=await(0,$.$7p)(F),Z=[],Q={},se=[];if(z){for(const he of z.malicious)Z.push({id:he});if(z.migrateToPreRelease)for(const[he,ue]of Object.entries(z.migrateToPreRelease))(!ue.engine||(0,m.$Zp)(ue.engine,this.u.version,this.u.date))&&(Q[he.toLowerCase()]={disallowInstall:!0,extension:{id:ue.id,displayName:ue.displayName,autoMigrate:{storage:!!ue.migrateStorage},preRelease:!0}});if(z.deprecated)for(const[he,ue]of Object.entries(z.deprecated))ue&&(Q[he.toLowerCase()]=(0,k.$lg)(ue)?{}:ue);if(z.search)for(const he of z.search)se.push(he)}return{malicious:Z,deprecated:Q,search:se}}};G=we([ne(1,$.$1p),ne(2,p.$_j),ne(3,l.$Mi),ne(4,e.$$l),ne(5,R.$_k),ne(6,f.$sk),ne(7,c.$_i)],G);let V=class extends G{constructor(F,z,Z,Q,se,he,ue,Ee){super(F,z,Z,Q,se,he,ue,Ee)}};t.$kq=V,t.$kq=V=we([ne(0,v.$bq),ne(1,$.$1p),ne(2,p.$_j),ne(3,l.$Mi),ne(4,e.$$l),ne(5,R.$_k),ne(6,f.$sk),ne(7,c.$_i)],V);let b=class extends G{constructor(F,z,Z,Q,se,he,ue){super(void 0,F,z,Z,Q,se,he,ue)}};t.$lq=b,t.$lq=b=we([ne(0,$.$1p),ne(1,p.$_j),ne(2,l.$Mi),ne(3,e.$$l),ne(4,R.$_k),ne(5,f.$sk),ne(6,c.$_i)],b)}),define(re[168],oe([0,1,12,18,10,6,147,23,24,3,69]),function(H,t,E,P,y,O,A,k,g,c,l){"use strict";var u,h;Object.defineProperty(t,"__esModule",{value:!0}),t.$jR=t.$iR=t.$hR=void 0;let w=class extends g.$Ol{static{u=this}static{this.a="profileAssociationsMigration"}constructor(f,$,I,v,e){super(I,v,$,e),this.U=f,this.W=I}O(){return this.U.getItem(u.b,[]).map($=>({...$,location:(0,c.$fg)($.location)?this.w.extUri.joinPath(this.profilesHome,$.location):E.URI.revive($.location)}))}Q(){const f=this.U.getItem(u.c,{});return this.U.getItem(u.a,!1)?f:this.N(f)}S(){return this.w.extUri.joinPath(E.URI.file(this.W.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};t.$hR=w,t.$hR=w=u=we([ne(0,A.$cR),ne(1,k.$Jl),ne(2,P.$Ni),ne(3,y.$_k),ne(4,O.$_j)],w);let m=h=class extends w{constructor(f,$,I,v,e){super(f,$,I,v,e),this.$=f}P(f){f.length?this.$.setItem(h.b,f.map($=>({...$,location:this.w.extUri.basename($.location)}))):this.$.removeItem(h.b)}O(){const f=super.O();return this.$.getItem("userDataProfilesMigration",!1)||(this.P(f),this.$.setItem("userDataProfilesMigration",!0)),f}R(f){f.emptyWindows||f.workspaces?this.$.setItem(h.c,f):this.$.removeItem(h.c)}Q(){const f="workspaceAndProfileInfo",$=this.$.getItem(f,void 0);if($){this.$.removeItem(f);const v=$.reduce((e,{workspace:a,profile:n})=>(e[E.URI.revive(a).toString()]=E.URI.revive(n).toString(),e),{});this.$.setItem(h.c,{workspaces:v})}const I=super.Q();return this.$.getItem(h.a,!1)||(this.R(I),this.$.setItem(h.a,!0)),I}};t.$iR=m,t.$iR=m=h=we([ne(0,A.$dR),ne(1,k.$Jl),ne(2,P.$Ni),ne(3,y.$_k),ne(4,O.$_j)],m);let R=class extends m{constructor(f,$,I,v){super(new l.$gR(l.SaveStrategy.IMMEDIATE,$,v,I),f,$,I,v)}async init(){return await this.$.init(),super.init()}};t.$jR=R,t.$jR=R=we([ne(0,k.$Jl),ne(1,P.$Ni),ne(2,y.$_k),ne(3,O.$_j)],R)}),define(re[169],oe([0,1,145,8,14,9,3,30,18,146,6,45,144,180]),function(H,t,E,P,y,O,A,k,g,c,l,u,h,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$$r=void 0,t.$_r=p;let m=class extends u.$2p{constructor($,I,v,e){super(e),this.m=$,this.n=I,this.r=v,this.s(),this.B($.onDidChangeConfiguration(a=>{a.affectsConfiguration("http")&&this.s()}))}s(){const $=this.m.getValue("http");this.f=$?.proxy,this.g=!!$?.proxyStrictSSL,this.h=$?.proxyAuthorization}async request($,I){const{f:v,g:e}=this;let a;try{a=await(0,c.$Qm)(this.m,this.r,this.n.args,process.env)}catch(i){this.j||(this.j=!0,this.r.error("resolving shell environment failed",(0,O.$_)(i)))}const n={...process.env,...a},r=$.agent?$.agent:await(0,h.$0r)($.url||"",n,{proxyUrl:v,strictSSL:e});return $.agent=r,$.strictSSL=e,this.h&&($.headers={...$.headers||{},"Proxy-Authorization":this.h}),this.c($.isChromiumNetwork?"electron":"node",$,()=>p($,I))}async resolveProxy($){}async loadCertificates(){return(await new Promise((I,v)=>{H(["@vscode/proxy-agent"],I,v)}).then(ye)).loadSystemCertificates({log:this.r})}};t.$$r=m,t.$$r=m=we([ne(0,k.$_i),ne(1,g.$Ni),ne(2,l.$_j),ne(3,l.$ak)],m);async function R(f){return((0,E.parse)(f.url).protocol==="https:"?await new Promise((v,e)=>{H(["https"],v,e)}).then(ye):await new Promise((v,e)=>{H(["http"],v,e)}).then(ye)).request}async function p(f,$){return P.Promises.withAsyncBody(async(I,v)=>{const e=(0,E.parse)(f.url),a=f.getRawRequest?f.getRawRequest(f):await R(f),n={hostname:e.hostname,port:e.port?parseInt(e.port):e.protocol==="https:"?443:80,protocol:e.protocol,path:e.path,method:f.type||"GET",headers:f.headers,agent:f.agent,rejectUnauthorized:(0,A.$lg)(f.strictSSL)?f.strictSSL:!0};f.user&&f.password&&(n.auth=f.user+":"+f.password);const r=a(n,i=>{const s=(0,A.$jg)(f.followRedirects)?f.followRedirects:3;if(i.statusCode&&i.statusCode>=300&&i.statusCode<400&&s>0&&i.headers.location)p({...f,url:i.headers.location,followRedirects:s-1},$).then(I,v);else{let o=i;!f.isChromiumNetwork&&i.headers["content-encoding"]==="gzip"&&(o=i.pipe((0,w.createGunzip)())),I({res:i,stream:(0,y.$4e)(o)})}});r.on("error",v),f.timeout&&r.setTimeout(f.timeout),f.isChromiumNetwork&&r.removeHeader("Content-Length"),f.data&&typeof f.data=="string"&&r.write(f.data),r.end(),$.onCancellationRequested(()=>{r.abort(),v(new O.$7)})})}});var qe=this&&this.__importDefault||function(H){return H&&H.__esModule?H:{default:H}};define(re[181],oe([0,1,35,8,38,9,2,15,16,13,36,12,25,30,141,61,143,18,120,167,21,71,148,42,54,162,164,10,131,133,51,129,64,68,150,6,137,39,138,153,33,45,169,69,70,19,152,41,154,155,23,157,24,168,156,163,134,136,4,158,182]),function(H,t,E,P,y,O,A,k,g,c,l,u,h,w,m,R,p,f,$,I,v,e,a,n,r,i,s,o,d,S,N,C,D,T,M,K,Y,ae,le,ce,de,x,_,B,U,J,X,ee,j,q,G,V,b,L,F,z,Z,Q,se,he,ue){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.main=pe,ce=qe(ce);class Ee extends A.$Wc{constructor(fe){super(),this.b=fe,this.c()}c(){process.once("exit",()=>this.dispose())}async run(){const[fe,$e]=await this.f();return fe.invokeFunction(async ve=>{const ke=ve.get(K.$_j),W=ve.get(o.$_k),te=ve.get(f.$Ni),ie=ve.get(b.$Ll);ke.info("CLI main",this.b),this.h(ke),await this.j(te,W,ie,fe),await Promise.all($e.map(me=>{(0,P.$wh)(me.flush(),1e3)}))})}async f(){const fe=new D.$Di,$e={_serviceBrand:void 0,...ce.default};fe.set(de.$sk,$e);const ve=new $.$8m(this.b,$e);fe.set(f.$Ni,ve),await Promise.all([this.g(ve.appSettingsHome.with({scheme:k.Schemas.file}).fsPath),this.g(ve.extensionsPath)].map(Pe=>Pe?h.Promises.mkdir(Pe,{recursive:!0}):void 0));const ke=new Q.$bR((0,K.$nk)(ve),ve.logsHome);fe.set(K.$ak,ke);const W=this.B(ke.createLogger("cli",{name:(0,se.localize)(0,null)})),te=[];ke.getLogLevel()===K.LogLevel.Trace&&te.push(new K.$hk(ke.getLogLevel()));const ie=this.B(new Z.$lR(W,te));fe.set(K.$_j,ie);const me=this.B(new d.$Vq(ie));fe.set(o.$_k,me);const be=this.B(new S.$mr(ie));me.registerProvider(k.Schemas.file,be);const Ae=new V.$Ns(me);fe.set(G.$Jl,Ae);const Ie=new B.$fR(B.SaveStrategy.DELAYED,ve,ie,me),Ce=new L.$hR(Ie,Ae,ve,me,ie);fe.set(b.$Ll,Ce),me.registerProvider(k.Schemas.vscodeUserData,new he.$tgc(k.Schemas.file,be,k.Schemas.vscodeUserData,Ce,Ae,ie));const Re=c.$i&&$e.win32RegValueName?this.B(new le.$rgc(ie,$e.win32RegValueName)):ve.policyFile?this.B(new Y.$sgc(ve.policyFile,me,ie)):new ae.$so;fe.set(ae.$qo,Re);const Le=this.B(new m.$So(Ce.defaultProfile.settingsResource,me,Re,ie));fe.set(w.$_i,Le),await Promise.all([Ie.init(),Le.initialize()]);let ze;try{ze=await(0,F.$6fc)(Ie,ie)}catch(Pe){Pe.code!=="ENOENT"&&ie.error(Pe)}const De=await(0,F.$7fc)(Ie,ie),Te=await(0,F.$8fc)(Ie,ie);Ce.init(),fe.set(G.$Jl,new V.$Ns(me));const Fe=new _.$$r(Le,ve,ie,ke);fe.set(x.$1p,Fe),fe.set(R.$Wo,new N.$Ci(p.$AR,void 0,!0)),fe.set(n.$Cq,new N.$Ci(z.$kR,void 0,!0)),fe.set(r.$Gq,new N.$Ci(s.$3fc,void 0,!0)),fe.set(e.$mq,new N.$Ci(e.$oq,void 0,!0)),fe.set(i.$Rq,new N.$Ci(i.$Sq,void 0,!0)),fe.set(v.$gp,new N.$Ci(I.$lq,void 0,!0)),fe.set(T.$5r,new N.$Ci(M.$7r,void 0,!1));const Ue=[],Se=(0,ee.$Ep)($e,Le);if((0,ee.$zp)($e,ve)){$e.aiConfig&&$e.aiConfig.ariaKey&&Ue.push(new j.$_Q(Fe,Se,"monacoworkbench",null,$e.aiConfig.ariaKey));const Pe={appenders:Ue,sendErrorTelemetry:!1,commonProperties:(0,U.$qp)((0,E.release)(),(0,E.hostname)(),process.arch,$e.commit,$e.version,ze,De,Te,Se),piiPaths:(0,ee.$Fp)(ve)};fe.set(J.$$l,new N.$Ci(X.$as,[Pe],!1))}else fe.set(J.$$l,ee.$up);return[new C.$pr(fe),Ue]}g(fe){if(c.$i){const $e=(0,ue.getUNCHost)(fe);$e&&(0,ue.addUNCHostToAllowlist)($e)}return fe}h(fe){(0,O.setUnexpectedErrorHandler)($e=>{const ve=(0,y.$qj)($e,!0);ve&&fe.error(`[uncaught exception in CLI]: ${ve}`)}),process.on("uncaughtException",$e=>{(0,O.$2)($e)||(0,O.$3)($e)}),process.on("unhandledRejection",$e=>(0,O.$3)($e))}async j(fe,$e,ve,ke){let W;if(fe.args.profile&&(W=ve.profiles.find(ie=>ie.name===fe.args.profile),!W))throw new Error(`Profile '${fe.args.profile}' not found.`);const te=(W??ve.defaultProfile).extensionsResource;if(this.b["list-extensions"])return ke.createInstance(a.$pq,new K.$hk(K.LogLevel.Info,!1)).listExtensions(!!this.b["show-versions"],this.b.category,te);if(this.b["install-extension"]||this.b["install-builtin-extension"]){const ie={isMachineScoped:!!this.b["do-not-sync"],installPreReleaseVersion:!!this.b["pre-release"],profileLocation:te};return ke.createInstance(a.$pq,new K.$hk(K.LogLevel.Info,!1)).installExtensions(this.m(this.b["install-extension"]||[]),this.m(this.b["install-builtin-extension"]||[]),ie,!!this.b.force)}else{if(this.b["uninstall-extension"])return ke.createInstance(a.$pq,new K.$hk(K.LogLevel.Info,!1)).uninstallExtensions(this.m(this.b["uninstall-extension"]),!!this.b.force,te);if(this.b["update-extensions"])return ke.createInstance(a.$pq,new K.$hk(K.LogLevel.Info,!1)).updateExtensions(te);if(this.b["locate-extension"])return ke.createInstance(a.$pq,new K.$hk(K.LogLevel.Info,!1)).locateExtension(this.b["locate-extension"]);this.b.telemetry&&console.log(await(0,q.$Jgc)(fe.appRoot,fe.extensionsPath))}}m(fe){return fe.map($e=>/\.vsix$/i.test($e)?u.URI.file((0,g.$kc)($e)?$e:(0,g.$lc)((0,l.cwd)(),$e)):$e)}}async function pe(ge){const fe=new Ee(ge);try{await fe.run()}finally{fe.dispose()}}})}).call(this);

//# sourceMappingURL=https://main.vscode-cdn.net/sourcemaps/c2e20cb17fae44eb26611cb9a4690059cea0e605/core/vs/code/node/cliProcessMain.js.map
