/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ce=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/base/common/platform","vs/base/common/async","vs/platform/files/common/files","vs/base/common/errors","vs/base/common/uri","vs/platform/log/common/log","vs/nls!vs/code/node/sharedProcess/sharedProcessMain","vs/nls","vs/base/common/types","vs/base/common/path","vs/base/common/buffer","vs/platform/environment/common/environment","vs/platform/storage/common/storage","vs/platform/telemetry/common/telemetry","vs/base/common/arrays","vs/platform/userDataProfile/common/userDataProfile","vs/base/common/resources","vs/platform/configuration/common/configuration","vs/base/common/network","vs/platform/product/common/productService","vs/platform/userDataSync/common/userDataSync","vs/base/common/cancellation","vs/base/common/strings","vs/platform/extensionManagement/common/extensionManagement","vs/platform/uriIdentity/common/uriIdentity","vs/base/common/objects","vs/base/node/pfs","vs/base/common/uuid","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/json","vs/base/common/map","vs/base/common/process","vs/platform/extensions/common/extensions","os","vs/base/common/charCode","vs/platform/userDataSync/common/abstractSynchronizer","vs/base/common/errorMessage","vs/base/common/extpath","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/base/common/jsonFormatter","fs","vs/platform/files/common/watcher","vs/platform/configuration/common/configurationRegistry","vs/platform/telemetry/common/telemetryUtils","vs/platform/externalServices/common/serviceMachineId","vs/base/common/stream","vs/base/common/ternarySearchTree","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/base/common/lazy","vs/base/common/stopwatch","vs/base/common/hash","vs/base/common/semver/semver","vs/platform/ipc/common/mainProcessService","vs/platform/native/common/native","vs/platform/policy/common/policy","vs/platform/request/common/request","vs/platform/userDataProfile/common/userDataProfileStorageService","vs/base/common/iterator","vs/base/common/jsonEdit","vs/base/common/marshallingIds","net","vs/base/common/date","vs/base/common/marshalling","child_process","vs/base/parts/ipc/common/ipc.net","vs/base/parts/storage/common/storage","vs/base/node/zip","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/descriptors","vs/platform/extensionRecommendations/common/extensionRecommendations","crypto","vs/platform/instantiation/common/serviceCollection","vs/platform/configuration/common/configurationModels","vs/platform/languagePacks/common/languagePacks","vs/platform/storage/common/storageIpc","vs/platform/tunnel/common/tunnel","vs/platform/userDataSync/common/content","vs/platform/userDataSync/common/userDataSyncAccount","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/extensionManagement/common/extensionStorage","vs/platform/userDataSync/common/userDataSyncMachines","vs/base/common/decorators","vs/base/common/functional","vs/base/common/linkedList","vs/base/common/normalization","vs/base/common/severity","vs/base/common/processes","vs/base/common/glob","vs/base/common/uriIpc","vs/base/parts/ipc/node/ipc.cp","vs/platform/contextkey/common/contextkey","vs/platform/diagnostics/common/diagnostics","vs/platform/download/common/download","vs/platform/files/common/io","vs/base/common/performance","vs/platform/lifecycle/node/sharedProcessLifecycleService","vs/platform/product/common/product","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteHosts","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/remoteTunnel/common/remoteTunnel","vs/platform/sign/common/sign","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/node/extensionSignatureVerificationService","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryLogAppender","vs/platform/telemetry/common/telemetryService","vs/platform/userDataSync/common/ignoredExtensions","vs/platform/workspace/common/workspace","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/extensionManagement/common/extensionEnablementService","vs/platform/userDataSync/common/extensionsSync","vs/platform/userDataSync/common/globalStateSync","vs/platform/userDataSync/common/keybindingsSync","vs/platform/userDataSync/common/settingsSync","vs/platform/userDataSync/common/snippetsSync","vs/platform/userDataSync/common/tasksSync","vs/platform/userDataSync/common/userDataProfilesManifestSync","vs/platform/userDataSync/common/userDataSyncStoreService","vs/base/parts/ipc/node/ipc.net","vs/base/common/amd","vs/base/common/arraysFind","vs/base/common/collections","vs/base/common/assert","vs/base/common/skipList","vs/base/common/cache","vs/base/common/symbols","vs/base/common/uint","vs/base/node/macAddress","vs/base/node/nodeStreams","vs/base/node/ports","vs/base/parts/sandbox/node/electronTypes","vs/nls!vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/common/platform","vs/base/common/desktopEnvironmentInfo","vs/base/common/mime","vs/base/common/console","vs/amdX","vs/base/node/id","vs/base/node/osDisplayProtocolInfo","fs/promises","vs/base/node/osReleaseInfo","vs/base/node/extpath","vs/base/node/processes","vs/base/node/ps","vs/base/parts/ipc/node/ipc.mp","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/log/common/log","vs/nls!vs/platform/remoteTunnel/common/remoteTunnel","vs/nls!vs/platform/remoteTunnel/node/remoteTunnelService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryLogAppender","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/userDataSync/common/abstractSynchronizer","vs/nls!vs/platform/userDataSync/common/keybindingsSync","vs/nls!vs/platform/userDataSync/common/settingsSync","vs/nls!vs/platform/userDataSync/common/userDataAutoSyncService","vs/nls!vs/platform/userDataSync/common/userDataSync","vs/nls!vs/platform/userDataSync/common/userDataSyncLog","vs/nls!vs/platform/userDataSync/common/userDataSyncMachines","vs/nls!vs/platform/userDataSync/common/userDataSyncResourceProvider","vs/nls!vs/platform/workspace/common/workspace","vs/platform/contextkey/common/scanner","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionRecommendations/common/extensionRecommendationsIpc","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/checksum/common/checksumService","vs/platform/checksum/node/checksumService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/baseWatcher","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/code/node/sharedProcess/contrib/logsDataCleaner","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logIpc","vs/platform/log/common/logService","vs/platform/native/common/nativeHostService","vs/platform/policy/common/policyIpc","vs/code/node/sharedProcess/contrib/codeCacheCleaner","vs/code/node/sharedProcess/contrib/languagePackCachedDataCleaner","vs/platform/profiling/common/profiling","vs/platform/profiling/node/profilingService","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/managedSocket","vs/platform/remote/common/remoteAgentConnection","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/extensionManagement/node/extensionsManifestCache","vs/code/node/sharedProcess/contrib/localizationsUpdater","vs/platform/remote/common/sharedProcessTunnelService","vs/platform/download/common/downloadService","vs/platform/request/common/requestIpc","vs/platform/sharedProcess/common/sharedProcess","vs/platform/sign/common/abstractSignService","vs/platform/sign/node/signService","vs/platform/diagnostics/node/diagnosticsService","vs/platform/extensionManagement/common/unsupportedExtensionsMigration","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/languagePacks/node/languagePacks","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/customEndpointTelemetryService","vs/platform/tunnel/node/sharedProcessTunnelService","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/userData/common/fileUserDataProvider","vs/platform/userDataSync/common/extensionsMerge","vs/platform/userDataSync/common/keybindingsMerge","vs/platform/userDataSync/common/snippetsMerge","vs/platform/userDataSync/common/userDataProfilesManifestMerge","vs/platform/userDataSync/common/globalStateMerge","vs/platform/userDataSync/common/settingsMerge","vs/platform/userDataSync/common/userDataSyncLog","vs/platform/windows/node/windowTracker","vs/code/node/sharedProcess/contrib/userDataProfilesCleaner","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/code/node/sharedProcess/contrib/extensions","vs/platform/extensionManagement/common/extensionTipsService","vs/platform/extensionManagement/node/extensionTipsService","vs/platform/externalServices/common/marketplace","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/remoteTunnel/node/remoteTunnelService","vs/platform/storage/common/storageService","vs/platform/userDataProfile/common/userDataProfileIpc","vs/platform/userDataProfile/node/userDataProfileStorageService","vs/platform/userDataSync/common/userDataSyncEnablementService","vs/platform/userDataSync/common/userDataSyncLocalStoreService","vs/platform/userDataSync/common/userDataAutoSyncService","vs/platform/userDataSync/common/userDataSyncResourceProvider","vs/platform/userDataSync/common/userDataSyncService","vs/platform/userDataSync/common/userDataSyncServiceIpc","vs/platform/userDataSync/common/userDataSyncIpc","vs/platform/userDataSync/node/userDataAutoSyncService","vs/platform/workspaces/node/workspaces","vs/code/node/sharedProcess/contrib/storageDataCleaner","vs/platform/remote/node/nodeSocketFactory","vs/platform/tunnel/node/tunnelService","stream","readline","util","path","https","zlib","vs/code/node/sharedProcess/sharedProcessMain"],le=function(ne){for(var e=[],P=0,c=ne.length;P<c;P++)e[P]=ce[ne[P]];return e};define(ce[129],le([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$W=e.LoaderEventType=e.$V=void 0,e.$V=!1;var P;(function(N){N[N.LoaderAvailable=1]="LoaderAvailable",N[N.BeginLoadingScript=10]="BeginLoadingScript",N[N.EndLoadingScriptOK=11]="EndLoadingScriptOK",N[N.EndLoadingScriptError=12]="EndLoadingScriptError",N[N.BeginInvokeFactory=21]="BeginInvokeFactory",N[N.EndInvokeFactory=22]="EndInvokeFactory",N[N.NodeBeginEvaluatingScript=31]="NodeBeginEvaluatingScript",N[N.NodeEndEvaluatingScript=32]="NodeEndEvaluatingScript",N[N.NodeBeginNativeRequire=33]="NodeBeginNativeRequire",N[N.NodeEndNativeRequire=34]="NodeEndNativeRequire",N[N.CachedDataFound=60]="CachedDataFound",N[N.CachedDataMissed=61]="CachedDataMissed",N[N.CachedDataRejected=62]="CachedDataRejected",N[N.CachedDataCreated=63]="CachedDataCreated"})(P||(e.LoaderEventType=P={}));class c{static get(){const O=new Map,T=new Map,k=new Map,A=new Map;function w(l,d){l.has(d.detail)||l.set(d.detail,-d.timestamp)}function E(l,d){const y=l.get(d.detail);y&&(y>=0||l.set(d.detail,y+d.timestamp))}let $=[];typeof ne=="function"&&typeof ne.getStats=="function"&&($=ne.getStats().slice(0).sort((l,d)=>l.timestamp-d.timestamp));for(const l of $)switch(l.type){case P.BeginLoadingScript:w(O,l);break;case P.EndLoadingScriptOK:case P.EndLoadingScriptError:E(O,l);break;case P.BeginInvokeFactory:w(T,l);break;case P.EndInvokeFactory:E(T,l);break;case P.NodeBeginNativeRequire:w(k,l);break;case P.NodeEndNativeRequire:E(k,l);break;case P.NodeBeginEvaluatingScript:w(A,l);break;case P.NodeEndEvaluatingScript:E(A,l);break}let u=0;k.forEach(l=>u+=l);function p(l){const d=[];return l.forEach((y,f)=>d.push([f,y])),d}return{amdLoad:p(O),amdInvoke:p(T),nodeRequire:p(k),nodeEval:p(A),nodeRequireTotal:u}}static toMarkdownTable(O,T){let k="";const A=[];return O.forEach((w,E)=>{A[E]=w.length}),T.forEach(w=>{w.forEach((E,$)=>{typeof E>"u"&&(E=w[$]="-");const u=E.toString().length;A[$]=Math.max(u,A[$])})}),O.forEach((w,E)=>{k+=`| ${w+" ".repeat(A[E]-w.toString().length)} `}),k+=`|
`,O.forEach((w,E)=>{k+=`| ${"-".repeat(A[E])} `}),k+=`|
`,T.forEach(w=>{w.forEach((E,$)=>{typeof E<"u"&&(k+=`| ${E+" ".repeat(A[$]-E.toString().length)} `)}),k+=`|
`}),k}}e.$W=c}),define(ce[130],le([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ob=void 0,e.$hb=P,e.$ib=c,e.$jb=N,e.$kb=O,e.$lb=T,e.$mb=k,e.$nb=A,e.$pb=E,e.$qb=$,e.$rb=u,e.$sb=p,e.$tb=l;function P(d,y){const f=c(d,y);if(f!==-1)return d[f]}function c(d,y,f=d.length-1){for(let b=f;b>=0;b--){const I=d[b];if(y(I))return b}return-1}function N(d,y){const f=O(d,y);return f===-1?void 0:d[f]}function O(d,y,f=0,b=d.length){let I=f,m=b;for(;I<m;){const s=Math.floor((I+m)/2);y(d[s])?I=s+1:m=s}return I-1}function T(d,y){const f=k(d,y);return f===d.length?void 0:d[f]}function k(d,y,f=0,b=d.length){let I=f,m=b;for(;I<m;){const s=Math.floor((I+m)/2);y(d[s])?m=s:I=s+1}return I}function A(d,y,f=0,b=d.length){const I=k(d,y,f,b);return I===d.length?-1:I}class w{static{this.assertInvariants=!1}constructor(y){this.e=y,this.c=0}findLastMonotonous(y){if(w.assertInvariants){if(this.d){for(const b of this.e)if(this.d(b)&&!y(b))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=y}const f=O(this.e,y,this.c);return this.c=f+1,f===-1?void 0:this.e[f]}}e.$ob=w;function E(d,y){if(d.length===0)return;let f=d[0];for(let b=1;b<d.length;b++){const I=d[b];y(I,f)>0&&(f=I)}return f}function $(d,y){if(d.length===0)return;let f=d[0];for(let b=1;b<d.length;b++){const I=d[b];y(I,f)>=0&&(f=I)}return f}function u(d,y){return E(d,(f,b)=>-y(f,b))}function p(d,y){if(d.length===0)return-1;let f=0;for(let b=1;b<d.length;b++){const I=d[b];y(I,d[f])>0&&(f=b)}return f}function l(d,y){for(const f of d){const b=y(f);if(b!==void 0)return b}}}),define(ce[39],le([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharCode=void 0;var P;(function(c){c[c.Null=0]="Null",c[c.Backspace=8]="Backspace",c[c.Tab=9]="Tab",c[c.LineFeed=10]="LineFeed",c[c.CarriageReturn=13]="CarriageReturn",c[c.Space=32]="Space",c[c.ExclamationMark=33]="ExclamationMark",c[c.DoubleQuote=34]="DoubleQuote",c[c.Hash=35]="Hash",c[c.DollarSign=36]="DollarSign",c[c.PercentSign=37]="PercentSign",c[c.Ampersand=38]="Ampersand",c[c.SingleQuote=39]="SingleQuote",c[c.OpenParen=40]="OpenParen",c[c.CloseParen=41]="CloseParen",c[c.Asterisk=42]="Asterisk",c[c.Plus=43]="Plus",c[c.Comma=44]="Comma",c[c.Dash=45]="Dash",c[c.Period=46]="Period",c[c.Slash=47]="Slash",c[c.Digit0=48]="Digit0",c[c.Digit1=49]="Digit1",c[c.Digit2=50]="Digit2",c[c.Digit3=51]="Digit3",c[c.Digit4=52]="Digit4",c[c.Digit5=53]="Digit5",c[c.Digit6=54]="Digit6",c[c.Digit7=55]="Digit7",c[c.Digit8=56]="Digit8",c[c.Digit9=57]="Digit9",c[c.Colon=58]="Colon",c[c.Semicolon=59]="Semicolon",c[c.LessThan=60]="LessThan",c[c.Equals=61]="Equals",c[c.GreaterThan=62]="GreaterThan",c[c.QuestionMark=63]="QuestionMark",c[c.AtSign=64]="AtSign",c[c.A=65]="A",c[c.B=66]="B",c[c.C=67]="C",c[c.D=68]="D",c[c.E=69]="E",c[c.F=70]="F",c[c.G=71]="G",c[c.H=72]="H",c[c.I=73]="I",c[c.J=74]="J",c[c.K=75]="K",c[c.L=76]="L",c[c.M=77]="M",c[c.N=78]="N",c[c.O=79]="O",c[c.P=80]="P",c[c.Q=81]="Q",c[c.R=82]="R",c[c.S=83]="S",c[c.T=84]="T",c[c.U=85]="U",c[c.V=86]="V",c[c.W=87]="W",c[c.X=88]="X",c[c.Y=89]="Y",c[c.Z=90]="Z",c[c.OpenSquareBracket=91]="OpenSquareBracket",c[c.Backslash=92]="Backslash",c[c.CloseSquareBracket=93]="CloseSquareBracket",c[c.Caret=94]="Caret",c[c.Underline=95]="Underline",c[c.BackTick=96]="BackTick",c[c.a=97]="a",c[c.b=98]="b",c[c.c=99]="c",c[c.d=100]="d",c[c.e=101]="e",c[c.f=102]="f",c[c.g=103]="g",c[c.h=104]="h",c[c.i=105]="i",c[c.j=106]="j",c[c.k=107]="k",c[c.l=108]="l",c[c.m=109]="m",c[c.n=110]="n",c[c.o=111]="o",c[c.p=112]="p",c[c.q=113]="q",c[c.r=114]="r",c[c.s=115]="s",c[c.t=116]="t",c[c.u=117]="u",c[c.v=118]="v",c[c.w=119]="w",c[c.x=120]="x",c[c.y=121]="y",c[c.z=122]="z",c[c.OpenCurlyBrace=123]="OpenCurlyBrace",c[c.Pipe=124]="Pipe",c[c.CloseCurlyBrace=125]="CloseCurlyBrace",c[c.Tilde=126]="Tilde",c[c.NoBreakSpace=160]="NoBreakSpace",c[c.U_Combining_Grave_Accent=768]="U_Combining_Grave_Accent",c[c.U_Combining_Acute_Accent=769]="U_Combining_Acute_Accent",c[c.U_Combining_Circumflex_Accent=770]="U_Combining_Circumflex_Accent",c[c.U_Combining_Tilde=771]="U_Combining_Tilde",c[c.U_Combining_Macron=772]="U_Combining_Macron",c[c.U_Combining_Overline=773]="U_Combining_Overline",c[c.U_Combining_Breve=774]="U_Combining_Breve",c[c.U_Combining_Dot_Above=775]="U_Combining_Dot_Above",c[c.U_Combining_Diaeresis=776]="U_Combining_Diaeresis",c[c.U_Combining_Hook_Above=777]="U_Combining_Hook_Above",c[c.U_Combining_Ring_Above=778]="U_Combining_Ring_Above",c[c.U_Combining_Double_Acute_Accent=779]="U_Combining_Double_Acute_Accent",c[c.U_Combining_Caron=780]="U_Combining_Caron",c[c.U_Combining_Vertical_Line_Above=781]="U_Combining_Vertical_Line_Above",c[c.U_Combining_Double_Vertical_Line_Above=782]="U_Combining_Double_Vertical_Line_Above",c[c.U_Combining_Double_Grave_Accent=783]="U_Combining_Double_Grave_Accent",c[c.U_Combining_Candrabindu=784]="U_Combining_Candrabindu",c[c.U_Combining_Inverted_Breve=785]="U_Combining_Inverted_Breve",c[c.U_Combining_Turned_Comma_Above=786]="U_Combining_Turned_Comma_Above",c[c.U_Combining_Comma_Above=787]="U_Combining_Comma_Above",c[c.U_Combining_Reversed_Comma_Above=788]="U_Combining_Reversed_Comma_Above",c[c.U_Combining_Comma_Above_Right=789]="U_Combining_Comma_Above_Right",c[c.U_Combining_Grave_Accent_Below=790]="U_Combining_Grave_Accent_Below",c[c.U_Combining_Acute_Accent_Below=791]="U_Combining_Acute_Accent_Below",c[c.U_Combining_Left_Tack_Below=792]="U_Combining_Left_Tack_Below",c[c.U_Combining_Right_Tack_Below=793]="U_Combining_Right_Tack_Below",c[c.U_Combining_Left_Angle_Above=794]="U_Combining_Left_Angle_Above",c[c.U_Combining_Horn=795]="U_Combining_Horn",c[c.U_Combining_Left_Half_Ring_Below=796]="U_Combining_Left_Half_Ring_Below",c[c.U_Combining_Up_Tack_Below=797]="U_Combining_Up_Tack_Below",c[c.U_Combining_Down_Tack_Below=798]="U_Combining_Down_Tack_Below",c[c.U_Combining_Plus_Sign_Below=799]="U_Combining_Plus_Sign_Below",c[c.U_Combining_Minus_Sign_Below=800]="U_Combining_Minus_Sign_Below",c[c.U_Combining_Palatalized_Hook_Below=801]="U_Combining_Palatalized_Hook_Below",c[c.U_Combining_Retroflex_Hook_Below=802]="U_Combining_Retroflex_Hook_Below",c[c.U_Combining_Dot_Below=803]="U_Combining_Dot_Below",c[c.U_Combining_Diaeresis_Below=804]="U_Combining_Diaeresis_Below",c[c.U_Combining_Ring_Below=805]="U_Combining_Ring_Below",c[c.U_Combining_Comma_Below=806]="U_Combining_Comma_Below",c[c.U_Combining_Cedilla=807]="U_Combining_Cedilla",c[c.U_Combining_Ogonek=808]="U_Combining_Ogonek",c[c.U_Combining_Vertical_Line_Below=809]="U_Combining_Vertical_Line_Below",c[c.U_Combining_Bridge_Below=810]="U_Combining_Bridge_Below",c[c.U_Combining_Inverted_Double_Arch_Below=811]="U_Combining_Inverted_Double_Arch_Below",c[c.U_Combining_Caron_Below=812]="U_Combining_Caron_Below",c[c.U_Combining_Circumflex_Accent_Below=813]="U_Combining_Circumflex_Accent_Below",c[c.U_Combining_Breve_Below=814]="U_Combining_Breve_Below",c[c.U_Combining_Inverted_Breve_Below=815]="U_Combining_Inverted_Breve_Below",c[c.U_Combining_Tilde_Below=816]="U_Combining_Tilde_Below",c[c.U_Combining_Macron_Below=817]="U_Combining_Macron_Below",c[c.U_Combining_Low_Line=818]="U_Combining_Low_Line",c[c.U_Combining_Double_Low_Line=819]="U_Combining_Double_Low_Line",c[c.U_Combining_Tilde_Overlay=820]="U_Combining_Tilde_Overlay",c[c.U_Combining_Short_Stroke_Overlay=821]="U_Combining_Short_Stroke_Overlay",c[c.U_Combining_Long_Stroke_Overlay=822]="U_Combining_Long_Stroke_Overlay",c[c.U_Combining_Short_Solidus_Overlay=823]="U_Combining_Short_Solidus_Overlay",c[c.U_Combining_Long_Solidus_Overlay=824]="U_Combining_Long_Solidus_Overlay",c[c.U_Combining_Right_Half_Ring_Below=825]="U_Combining_Right_Half_Ring_Below",c[c.U_Combining_Inverted_Bridge_Below=826]="U_Combining_Inverted_Bridge_Below",c[c.U_Combining_Square_Below=827]="U_Combining_Square_Below",c[c.U_Combining_Seagull_Below=828]="U_Combining_Seagull_Below",c[c.U_Combining_X_Above=829]="U_Combining_X_Above",c[c.U_Combining_Vertical_Tilde=830]="U_Combining_Vertical_Tilde",c[c.U_Combining_Double_Overline=831]="U_Combining_Double_Overline",c[c.U_Combining_Grave_Tone_Mark=832]="U_Combining_Grave_Tone_Mark",c[c.U_Combining_Acute_Tone_Mark=833]="U_Combining_Acute_Tone_Mark",c[c.U_Combining_Greek_Perispomeni=834]="U_Combining_Greek_Perispomeni",c[c.U_Combining_Greek_Koronis=835]="U_Combining_Greek_Koronis",c[c.U_Combining_Greek_Dialytika_Tonos=836]="U_Combining_Greek_Dialytika_Tonos",c[c.U_Combining_Greek_Ypogegrammeni=837]="U_Combining_Greek_Ypogegrammeni",c[c.U_Combining_Bridge_Above=838]="U_Combining_Bridge_Above",c[c.U_Combining_Equals_Sign_Below=839]="U_Combining_Equals_Sign_Below",c[c.U_Combining_Double_Vertical_Line_Below=840]="U_Combining_Double_Vertical_Line_Below",c[c.U_Combining_Left_Angle_Below=841]="U_Combining_Left_Angle_Below",c[c.U_Combining_Not_Tilde_Above=842]="U_Combining_Not_Tilde_Above",c[c.U_Combining_Homothetic_Above=843]="U_Combining_Homothetic_Above",c[c.U_Combining_Almost_Equal_To_Above=844]="U_Combining_Almost_Equal_To_Above",c[c.U_Combining_Left_Right_Arrow_Below=845]="U_Combining_Left_Right_Arrow_Below",c[c.U_Combining_Upwards_Arrow_Below=846]="U_Combining_Upwards_Arrow_Below",c[c.U_Combining_Grapheme_Joiner=847]="U_Combining_Grapheme_Joiner",c[c.U_Combining_Right_Arrowhead_Above=848]="U_Combining_Right_Arrowhead_Above",c[c.U_Combining_Left_Half_Ring_Above=849]="U_Combining_Left_Half_Ring_Above",c[c.U_Combining_Fermata=850]="U_Combining_Fermata",c[c.U_Combining_X_Below=851]="U_Combining_X_Below",c[c.U_Combining_Left_Arrowhead_Below=852]="U_Combining_Left_Arrowhead_Below",c[c.U_Combining_Right_Arrowhead_Below=853]="U_Combining_Right_Arrowhead_Below",c[c.U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below=854]="U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below",c[c.U_Combining_Right_Half_Ring_Above=855]="U_Combining_Right_Half_Ring_Above",c[c.U_Combining_Dot_Above_Right=856]="U_Combining_Dot_Above_Right",c[c.U_Combining_Asterisk_Below=857]="U_Combining_Asterisk_Below",c[c.U_Combining_Double_Ring_Below=858]="U_Combining_Double_Ring_Below",c[c.U_Combining_Zigzag_Above=859]="U_Combining_Zigzag_Above",c[c.U_Combining_Double_Breve_Below=860]="U_Combining_Double_Breve_Below",c[c.U_Combining_Double_Breve=861]="U_Combining_Double_Breve",c[c.U_Combining_Double_Macron=862]="U_Combining_Double_Macron",c[c.U_Combining_Double_Macron_Below=863]="U_Combining_Double_Macron_Below",c[c.U_Combining_Double_Tilde=864]="U_Combining_Double_Tilde",c[c.U_Combining_Double_Inverted_Breve=865]="U_Combining_Double_Inverted_Breve",c[c.U_Combining_Double_Rightwards_Arrow_Below=866]="U_Combining_Double_Rightwards_Arrow_Below",c[c.U_Combining_Latin_Small_Letter_A=867]="U_Combining_Latin_Small_Letter_A",c[c.U_Combining_Latin_Small_Letter_E=868]="U_Combining_Latin_Small_Letter_E",c[c.U_Combining_Latin_Small_Letter_I=869]="U_Combining_Latin_Small_Letter_I",c[c.U_Combining_Latin_Small_Letter_O=870]="U_Combining_Latin_Small_Letter_O",c[c.U_Combining_Latin_Small_Letter_U=871]="U_Combining_Latin_Small_Letter_U",c[c.U_Combining_Latin_Small_Letter_C=872]="U_Combining_Latin_Small_Letter_C",c[c.U_Combining_Latin_Small_Letter_D=873]="U_Combining_Latin_Small_Letter_D",c[c.U_Combining_Latin_Small_Letter_H=874]="U_Combining_Latin_Small_Letter_H",c[c.U_Combining_Latin_Small_Letter_M=875]="U_Combining_Latin_Small_Letter_M",c[c.U_Combining_Latin_Small_Letter_R=876]="U_Combining_Latin_Small_Letter_R",c[c.U_Combining_Latin_Small_Letter_T=877]="U_Combining_Latin_Small_Letter_T",c[c.U_Combining_Latin_Small_Letter_V=878]="U_Combining_Latin_Small_Letter_V",c[c.U_Combining_Latin_Small_Letter_X=879]="U_Combining_Latin_Small_Letter_X",c[c.LINE_SEPARATOR=8232]="LINE_SEPARATOR",c[c.PARAGRAPH_SEPARATOR=8233]="PARAGRAPH_SEPARATOR",c[c.NEXT_LINE=133]="NEXT_LINE",c[c.U_CIRCUMFLEX=94]="U_CIRCUMFLEX",c[c.U_GRAVE_ACCENT=96]="U_GRAVE_ACCENT",c[c.U_DIAERESIS=168]="U_DIAERESIS",c[c.U_MACRON=175]="U_MACRON",c[c.U_ACUTE_ACCENT=180]="U_ACUTE_ACCENT",c[c.U_CEDILLA=184]="U_CEDILLA",c[c.U_MODIFIER_LETTER_LEFT_ARROWHEAD=706]="U_MODIFIER_LETTER_LEFT_ARROWHEAD",c[c.U_MODIFIER_LETTER_RIGHT_ARROWHEAD=707]="U_MODIFIER_LETTER_RIGHT_ARROWHEAD",c[c.U_MODIFIER_LETTER_UP_ARROWHEAD=708]="U_MODIFIER_LETTER_UP_ARROWHEAD",c[c.U_MODIFIER_LETTER_DOWN_ARROWHEAD=709]="U_MODIFIER_LETTER_DOWN_ARROWHEAD",c[c.U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING=722]="U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING",c[c.U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING=723]="U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING",c[c.U_MODIFIER_LETTER_UP_TACK=724]="U_MODIFIER_LETTER_UP_TACK",c[c.U_MODIFIER_LETTER_DOWN_TACK=725]="U_MODIFIER_LETTER_DOWN_TACK",c[c.U_MODIFIER_LETTER_PLUS_SIGN=726]="U_MODIFIER_LETTER_PLUS_SIGN",c[c.U_MODIFIER_LETTER_MINUS_SIGN=727]="U_MODIFIER_LETTER_MINUS_SIGN",c[c.U_BREVE=728]="U_BREVE",c[c.U_DOT_ABOVE=729]="U_DOT_ABOVE",c[c.U_RING_ABOVE=730]="U_RING_ABOVE",c[c.U_OGONEK=731]="U_OGONEK",c[c.U_SMALL_TILDE=732]="U_SMALL_TILDE",c[c.U_DOUBLE_ACUTE_ACCENT=733]="U_DOUBLE_ACUTE_ACCENT",c[c.U_MODIFIER_LETTER_RHOTIC_HOOK=734]="U_MODIFIER_LETTER_RHOTIC_HOOK",c[c.U_MODIFIER_LETTER_CROSS_ACCENT=735]="U_MODIFIER_LETTER_CROSS_ACCENT",c[c.U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR=741]="U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR",c[c.U_MODIFIER_LETTER_HIGH_TONE_BAR=742]="U_MODIFIER_LETTER_HIGH_TONE_BAR",c[c.U_MODIFIER_LETTER_MID_TONE_BAR=743]="U_MODIFIER_LETTER_MID_TONE_BAR",c[c.U_MODIFIER_LETTER_LOW_TONE_BAR=744]="U_MODIFIER_LETTER_LOW_TONE_BAR",c[c.U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR=745]="U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR",c[c.U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK=746]="U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK",c[c.U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK=747]="U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK",c[c.U_MODIFIER_LETTER_UNASPIRATED=749]="U_MODIFIER_LETTER_UNASPIRATED",c[c.U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD=751]="U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD",c[c.U_MODIFIER_LETTER_LOW_UP_ARROWHEAD=752]="U_MODIFIER_LETTER_LOW_UP_ARROWHEAD",c[c.U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD=753]="U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD",c[c.U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD=754]="U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD",c[c.U_MODIFIER_LETTER_LOW_RING=755]="U_MODIFIER_LETTER_LOW_RING",c[c.U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT=756]="U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT",c[c.U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT=757]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT",c[c.U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT=758]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT",c[c.U_MODIFIER_LETTER_LOW_TILDE=759]="U_MODIFIER_LETTER_LOW_TILDE",c[c.U_MODIFIER_LETTER_RAISED_COLON=760]="U_MODIFIER_LETTER_RAISED_COLON",c[c.U_MODIFIER_LETTER_BEGIN_HIGH_TONE=761]="U_MODIFIER_LETTER_BEGIN_HIGH_TONE",c[c.U_MODIFIER_LETTER_END_HIGH_TONE=762]="U_MODIFIER_LETTER_END_HIGH_TONE",c[c.U_MODIFIER_LETTER_BEGIN_LOW_TONE=763]="U_MODIFIER_LETTER_BEGIN_LOW_TONE",c[c.U_MODIFIER_LETTER_END_LOW_TONE=764]="U_MODIFIER_LETTER_END_LOW_TONE",c[c.U_MODIFIER_LETTER_SHELF=765]="U_MODIFIER_LETTER_SHELF",c[c.U_MODIFIER_LETTER_OPEN_SHELF=766]="U_MODIFIER_LETTER_OPEN_SHELF",c[c.U_MODIFIER_LETTER_LOW_LEFT_ARROW=767]="U_MODIFIER_LETTER_LOW_LEFT_ARROW",c[c.U_GREEK_LOWER_NUMERAL_SIGN=885]="U_GREEK_LOWER_NUMERAL_SIGN",c[c.U_GREEK_TONOS=900]="U_GREEK_TONOS",c[c.U_GREEK_DIALYTIKA_TONOS=901]="U_GREEK_DIALYTIKA_TONOS",c[c.U_GREEK_KORONIS=8125]="U_GREEK_KORONIS",c[c.U_GREEK_PSILI=8127]="U_GREEK_PSILI",c[c.U_GREEK_PERISPOMENI=8128]="U_GREEK_PERISPOMENI",c[c.U_GREEK_DIALYTIKA_AND_PERISPOMENI=8129]="U_GREEK_DIALYTIKA_AND_PERISPOMENI",c[c.U_GREEK_PSILI_AND_VARIA=8141]="U_GREEK_PSILI_AND_VARIA",c[c.U_GREEK_PSILI_AND_OXIA=8142]="U_GREEK_PSILI_AND_OXIA",c[c.U_GREEK_PSILI_AND_PERISPOMENI=8143]="U_GREEK_PSILI_AND_PERISPOMENI",c[c.U_GREEK_DASIA_AND_VARIA=8157]="U_GREEK_DASIA_AND_VARIA",c[c.U_GREEK_DASIA_AND_OXIA=8158]="U_GREEK_DASIA_AND_OXIA",c[c.U_GREEK_DASIA_AND_PERISPOMENI=8159]="U_GREEK_DASIA_AND_PERISPOMENI",c[c.U_GREEK_DIALYTIKA_AND_VARIA=8173]="U_GREEK_DIALYTIKA_AND_VARIA",c[c.U_GREEK_DIALYTIKA_AND_OXIA=8174]="U_GREEK_DIALYTIKA_AND_OXIA",c[c.U_GREEK_VARIA=8175]="U_GREEK_VARIA",c[c.U_GREEK_OXIA=8189]="U_GREEK_OXIA",c[c.U_GREEK_DASIA=8190]="U_GREEK_DASIA",c[c.U_IDEOGRAPHIC_FULL_STOP=12290]="U_IDEOGRAPHIC_FULL_STOP",c[c.U_LEFT_CORNER_BRACKET=12300]="U_LEFT_CORNER_BRACKET",c[c.U_RIGHT_CORNER_BRACKET=12301]="U_RIGHT_CORNER_BRACKET",c[c.U_LEFT_BLACK_LENTICULAR_BRACKET=12304]="U_LEFT_BLACK_LENTICULAR_BRACKET",c[c.U_RIGHT_BLACK_LENTICULAR_BRACKET=12305]="U_RIGHT_BLACK_LENTICULAR_BRACKET",c[c.U_OVERLINE=8254]="U_OVERLINE",c[c.UTF8_BOM=65279]="UTF8_BOM",c[c.U_FULLWIDTH_SEMICOLON=65307]="U_FULLWIDTH_SEMICOLON",c[c.U_FULLWIDTH_COMMA=65292]="U_FULLWIDTH_COMMA"})(P||(e.CharCode=P={}))}),define(ce[131],le([0,1]),function(ne,e){"use strict";var P;Object.defineProperty(e,"__esModule",{value:!0}),e.$O=void 0,e.$K=c,e.$L=N,e.$M=O,e.$N=T;function c(A,w){const E=Object.create(null);for(const $ of A){const u=w($);let p=E[u];p||(p=E[u]=[]),p.push($)}return E}function N(A,w){const E=[],$=[];for(const u of A)w.has(u)||E.push(u);for(const u of w)A.has(u)||$.push(u);return{removed:E,added:$}}function O(A,w){const E=[],$=[];for(const[u,p]of A)w.has(u)||E.push(p);for(const[u,p]of w)A.has(u)||$.push(p);return{removed:E,added:$}}function T(A,w){const E=new Set;for(const $ of w)A.has($)&&E.add($);return E}class k{static{P=Symbol.toStringTag}constructor(w,E){this.b=E,this.a=new Map,this[P]="SetWithKey";for(const $ of w)this.add($)}get size(){return this.a.size}add(w){const E=this.b(w);return this.a.set(E,w),this}delete(w){return this.a.delete(this.b(w))}has(w){return this.a.has(this.b(w))}*entries(){for(const w of this.a.values())yield[w,w]}keys(){return this.values()}*values(){for(const w of this.a.values())yield w}clear(){this.a.clear()}forEach(w,E){this.a.forEach($=>w.call(E,$,$,this))}[Symbol.iterator](){return this.values()}}e.$O=k}),define(ce[88],le([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0h=c,e.$$h=N,e.$_h=O;function P(T){return(k,A,w)=>{let E=null,$=null;if(typeof w.value=="function"?(E="value",$=w.value):typeof w.get=="function"&&(E="get",$=w.get),!$)throw new Error("not supported");w[E]=T($,A)}}function c(T,k,A){let w=null,E=null;if(typeof A.value=="function"?(w="value",E=A.value,E.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof A.get=="function"&&(w="get",E=A.get),!E)throw new Error("not supported");const $=`$memoize$${k}`;A[w]=function(...u){return this.hasOwnProperty($)||Object.defineProperty(this,$,{configurable:!1,enumerable:!1,writable:!1,value:E.apply(this,u)}),this[$]}}function N(T,k,A){return P((w,E)=>{const $=`$debounce$${E}`,u=`$debounce$result$${E}`;return function(...p){this[u]||(this[u]=A?A():void 0),clearTimeout(this[$]),k&&(this[u]=k(this[u],...p),p=[this[u]]),this[$]=setTimeout(()=>{w.apply(this,p),this[u]=A?A():void 0},T)}})}function O(T,k,A){return P((w,E)=>{const $=`$throttle$timer$${E}`,u=`$throttle$result$${E}`,p=`$throttle$lastRun$${E}`,l=`$throttle$pending$${E}`;return function(...d){if(this[u]||(this[u]=A?A():void 0),(this[p]===null||this[p]===void 0)&&(this[p]=-Number.MAX_VALUE),k&&(this[u]=k(this[u],...d)),this[l])return;const y=this[p]+T;y<=Date.now()?(this[p]=Date.now(),w.apply(this,[this[u]]),this[u]=A?A():void 0):(this[l]=!0,this[$]=setTimeout(()=>{this[l]=!1,this[p]=Date.now(),w.apply(this,[this[u]]),this[u]=A?A():void 0},y-Date.now()))}})}}),define(ce[8],le([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eb=e.$db=e.$cb=e.$bb=e.$ab=e.$$=e.$7=e.$Z=e.$Y=void 0,e.setUnexpectedErrorHandler=c,e.$2=N,e.$3=O,e.$4=T,e.$5=k,e.$6=w,e.$8=$,e.$9=u,e.$0=p,e.$_=d;class P{constructor(){this.b=[],this.a=function(r){setTimeout(()=>{throw r.stack?I.isErrorNoTelemetry(r)?new I(r.message+`

`+r.stack):new Error(r.message+`

`+r.stack):r},0)}}addListener(r){return this.b.push(r),()=>{this.d(r)}}c(r){this.b.forEach(i=>{i(r)})}d(r){this.b.splice(this.b.indexOf(r),1)}setUnexpectedErrorHandler(r){this.a=r}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(r){this.a(r),this.c(r)}onUnexpectedExternalError(r){this.a(r)}}e.$Y=P,e.$Z=new P;function c(s){e.$Z.setUnexpectedErrorHandler(s)}function N(s){if(!s||typeof s!="object")return!1;const r=s;return r.code==="EPIPE"&&r.syscall?.toUpperCase()==="WRITE"}function O(s){w(s)||e.$Z.onUnexpectedError(s)}function T(s){w(s)||e.$Z.onUnexpectedExternalError(s)}function k(s){if(s instanceof Error){const{name:r,message:i}=s,a=s.stacktrace||s.stack;return{$isError:!0,name:r,message:i,stack:a,noTelemetry:I.isErrorNoTelemetry(s)}}return s}const A="Canceled";function w(s){return s instanceof E?!0:s instanceof Error&&s.name===A&&s.message===A}class E extends Error{constructor(){super(A),this.name=this.message}}e.$7=E;function $(){const s=new Error(A);return s.name=s.message,s}function u(s){return s?new Error(`Illegal argument: ${s}`):new Error("Illegal argument")}function p(s){return s?new Error(`Illegal state: ${s}`):new Error("Illegal state")}class l extends TypeError{constructor(r){super(r?`${r} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$$=l;function d(s){return s?s.message?s.message:s.stack?s.stack.split(`
`)[0]:String(s):"Error"}class y extends Error{constructor(r){super("NotImplemented"),r&&(this.message=r)}}e.$ab=y;class f extends Error{constructor(r){super("NotSupported"),r&&(this.message=r)}}e.$bb=f;class b extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$cb=b;class I extends Error{constructor(r){super(r),this.name="CodeExpectedError"}static fromError(r){if(r instanceof I)return r;const i=new I;return i.message=r.message,i.stack=r.stack,i}static isErrorNoTelemetry(r){return r.name==="CodeExpectedError"}}e.$db=I;class m extends Error{constructor(r){super(r||"An unexpected bug occurred."),Object.setPrototypeOf(this,m.prototype)}}e.$eb=m}),define(ce[19],le([0,1,8,130]),function(ne,e,P,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cc=e.$bc=e.$ac=e.$$b=e.$0b=e.CompareResult=void 0,e.$ub=N,e.$vb=O,e.$wb=T,e.$xb=k,e.$yb=A,e.$zb=w,e.$Ab=E,e.$Bb=$,e.$Cb=u,e.$Db=p,e.$Eb=l,e.$Fb=d,e.$Gb=y,e.top=f,e.$Ib=b,e.$Jb=m,e.$Kb=s,e.$Lb=r,e.$Mb=i,e.$Nb=a,e.$Ob=t,e.$Pb=n,e.$Qb=o,e.$Rb=h,e.$Sb=g,e.$Tb=R,e.$Ub=L,e.$Vb=S,e.$Wb=v,e.$Xb=C,e.$Yb=F,e.$Zb=D,e.$1b=M,e.$2b=J,e.$3b=H,e.$4b=x,e.$5b=K,e.$6b=ie,e.$7b=V,e.$8b=se,e.$9b=he,e.$_b=X;function N(j,W=0){return j[j.length-(1+W)]}function O(j){if(j.length===0)throw new Error("Invalid tail call");return[j.slice(0,j.length-1),j[j.length-1]]}function T(j,W,te=(_,Q)=>_===Q){if(j===W)return!0;if(!j||!W||j.length!==W.length)return!1;for(let _=0,Q=j.length;_<Q;_++)if(!te(j[_],W[_]))return!1;return!0}function k(j,W){const te=j.length-1;W<te&&(j[W]=j[te]),j.pop()}function A(j,W,te){return w(j.length,_=>te(j[_],W))}function w(j,W){let te=0,_=j-1;for(;te<=_;){const Q=(te+_)/2|0,ae=W(Q);if(ae<0)te=Q+1;else if(ae>0)_=Q-1;else return Q}return-(te+1)}function E(j,W,te){if(j=j|0,j>=W.length)throw new TypeError("invalid index");const _=W[Math.floor(W.length*Math.random())],Q=[],ae=[],ue=[];for(const ge of W){const we=te(ge,_);we<0?Q.push(ge):we>0?ae.push(ge):ue.push(ge)}return j<Q.length?E(j,Q,te):j<Q.length+ue.length?ue[0]:E(j-(Q.length+ue.length),ae,te)}function $(j,W){const te=[];let _;for(const Q of j.slice(0).sort(W))!_||W(_[0],Q)!==0?(_=[Q],te.push(_)):_.push(Q);return te}function*u(j,W){let te,_;for(const Q of j)_!==void 0&&W(_,Q)?te.push(Q):(te&&(yield te),te=[Q]),_=Q;te&&(yield te)}function p(j,W){for(let te=0;te<=j.length;te++)W(te===0?void 0:j[te-1],te===j.length?void 0:j[te])}function l(j,W){for(let te=0;te<j.length;te++)W(te===0?void 0:j[te-1],j[te],te+1===j.length?void 0:j[te+1])}function d(j,W,te){const _=[];function Q(ge,we,Ee){if(we===0&&Ee.length===0)return;const pe=_[_.length-1];pe&&pe.start+pe.deleteCount===ge?(pe.deleteCount+=we,pe.toInsert.push(...Ee)):_.push({start:ge,deleteCount:we,toInsert:Ee})}let ae=0,ue=0;for(;;){if(ae===j.length){Q(ae,0,W.slice(ue));break}if(ue===W.length){Q(ae,j.length-ae,[]);break}const ge=j[ae],we=W[ue],Ee=te(ge,we);Ee===0?(ae+=1,ue+=1):Ee<0?(Q(ae,1,[]),ae+=1):Ee>0&&(Q(ae,0,[we]),ue+=1)}return _}function y(j,W,te){const _=d(j,W,te),Q=[],ae=[];for(const ue of _)Q.push(...j.slice(ue.start,ue.start+ue.deleteCount)),ae.push(...ue.toInsert);return{removed:Q,added:ae}}function f(j,W,te){if(te===0)return[];const _=j.slice(0,te).sort(W);return I(j,W,_,te,j.length),_}function b(j,W,te,_,Q){return te===0?Promise.resolve([]):new Promise((ae,ue)=>{(async()=>{const ge=j.length,we=j.slice(0,te).sort(W);for(let Ee=te,pe=Math.min(te+_,ge);Ee<ge;Ee=pe,pe=Math.min(pe+_,ge)){if(Ee>te&&await new Promise(be=>setTimeout(be)),Q&&Q.isCancellationRequested)throw new P.$7;I(j,W,we,Ee,pe)}return we})().then(ae,ue)})}function I(j,W,te,_,Q){for(const ae=te.length;_<Q;_++){const ue=j[_];if(W(ue,te[ae-1])<0){te.pop();const ge=(0,c.$mb)(te,we=>W(ue,we)<0);te.splice(ge,0,ue)}}}function m(j){return j.filter(W=>!!W)}function s(j){let W=0;for(let te=0;te<j.length;te++)j[te]&&(j[W]=j[te],W+=1);j.length=W}function r(j,W,te){j.splice(te,0,j.splice(W,1)[0])}function i(j){return!Array.isArray(j)||j.length===0}function a(j){return Array.isArray(j)&&j.length>0}function t(j,W=te=>te){const te=new Set;return j.filter(_=>{const Q=W(_);return te.has(Q)?!1:(te.add(Q),!0)})}function n(j){const W=new Set;return te=>{const _=j(te);return W.has(_)?!1:(W.add(_),!0)}}function o(j,W){return j.length>0?j[0]:W}function h(j,W){return j.length>0?j[j.length-1]:W}function g(j,W,te=(_,Q)=>_===Q){let _=0;for(let Q=0,ae=Math.min(j.length,W.length);Q<ae&&te(j[Q],W[Q]);Q++)_++;return _}function R(j,W){let te=typeof W=="number"?j:0;typeof W=="number"?te=j:(te=0,W=j);const _=[];if(te<=W)for(let Q=te;Q<W;Q++)_.push(Q);else for(let Q=te;Q>W;Q--)_.push(Q);return _}function L(j,W,te){return j.reduce((_,Q)=>(_[W(Q)]=te?te(Q):Q,_),Object.create(null))}function S(j,W){return j.push(W),()=>v(j,W)}function v(j,W){const te=j.indexOf(W);if(te>-1)return j.splice(te,1),W}function C(j,W,te){const _=j.slice(0,W),Q=j.slice(W);return _.concat(te,Q)}function F(j,W){let te;if(typeof W=="number"){let _=W;te=()=>{const Q=Math.sin(_++)*179426549;return Q-Math.floor(Q)}}else te=Math.random;for(let _=j.length-1;_>0;_-=1){const Q=Math.floor(te()*(_+1)),ae=j[_];j[_]=j[Q],j[Q]=ae}}function D(j,W){const te=j.indexOf(W);te>-1&&(j.splice(te,1),j.unshift(W))}function M(j,W){const te=j.indexOf(W);te>-1&&(j.splice(te,1),j.push(W))}function J(j,W){for(const te of W)j.push(te)}function H(j,W){return Array.isArray(j)?j.map(W):W(j)}function x(j){return Array.isArray(j)?j:[j]}function K(j){return j[Math.floor(Math.random()*j.length)]}function ie(j,W,te){const _=z(j,W),Q=j.length,ae=te.length;j.length=Q+ae;for(let ue=Q-1;ue>=_;ue--)j[ue+ae]=j[ue];for(let ue=0;ue<ae;ue++)j[ue+_]=te[ue]}function V(j,W,te,_){const Q=z(j,W);let ae=j.splice(Q,te);return ae===void 0&&(ae=[]),ie(j,Q,_),ae}function z(j,W){return W<0?Math.max(W+j.length,0):Math.min(W,j.length)}var ee;(function(j){function W(ae){return ae<0}j.isLessThan=W;function te(ae){return ae<=0}j.isLessThanOrEqual=te;function _(ae){return ae>0}j.isGreaterThan=_;function Q(ae){return ae===0}j.isNeitherLessOrGreaterThan=Q,j.greaterThan=1,j.lessThan=-1,j.neitherLessOrGreaterThan=0})(ee||(e.CompareResult=ee={}));function se(j,W){return(te,_)=>W(j(te),j(_))}function he(...j){return(W,te)=>{for(const _ of j){const Q=_(W,te);if(!ee.isNeitherLessOrGreaterThan(Q))return Q}return ee.neitherLessOrGreaterThan}}const q=(j,W)=>j-W;e.$0b=q;const Z=(j,W)=>(0,e.$0b)(j?1:0,W?1:0);e.$$b=Z;function X(j){return(W,te)=>-j(W,te)}class G{constructor(W){this.g=W,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(W){let te=this.c;for(;te<this.g.length&&W(this.g[te]);)te++;const _=te===this.c?null:this.g.slice(this.c,te);return this.c=te,_}takeFromEndWhile(W){let te=this.d;for(;te>=0&&W(this.g[te]);)te--;const _=te===this.d?null:this.g.slice(te+1,this.d+1);return this.d=te,_}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const W=this.g[this.c];return this.c++,W}removeLast(){const W=this.g[this.d];return this.d--,W}takeCount(W){const te=this.g.slice(this.c,this.c+W);return this.c+=W,te}}e.$ac=G;class U{static{this.empty=new U(W=>{})}constructor(W){this.iterate=W}forEach(W){this.iterate(te=>(W(te),!0))}toArray(){const W=[];return this.iterate(te=>(W.push(te),!0)),W}filter(W){return new U(te=>this.iterate(_=>W(_)?te(_):!0))}map(W){return new U(te=>this.iterate(_=>te(W(_))))}some(W){let te=!1;return this.iterate(_=>(te=W(_),!te)),te}findFirst(W){let te;return this.iterate(_=>W(_)?(te=_,!1):!0),te}findLast(W){let te;return this.iterate(_=>(W(_)&&(te=_),!0)),te}findLastMaxBy(W){let te,_=!0;return this.iterate(Q=>((_||ee.isGreaterThan(W(Q,te)))&&(_=!1,te=Q),!0)),te}}e.$bc=U;class B{constructor(W){this.c=W}static createSortPermutation(W,te){const _=Array.from(W.keys()).sort((Q,ae)=>te(W[Q],W[ae]));return new B(_)}apply(W){return W.map((te,_)=>W[this.c[_]])}inverse(){const W=this.c.slice();for(let te=0;te<this.c.length;te++)W[this.c[te]]=te;return new B(W)}}e.$cc=B}),define(ce[132],le([0,1,8]),function(ne,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=c,e.$gd=N,e.$hd=O,e.$id=T,e.$jd=k,e.$kd=A;function c(w,E){if(!w)throw new Error(E?`Assertion failed (${E})`:"Assertion Failed")}function N(w,E="Unreachable"){throw new Error(E)}function O(w,E="unexpected state"){if(!w)throw new P.$eb(`Assertion Failed: ${E}`)}function T(w){w||(0,P.$3)(new P.$eb("Soft Assertion Failed"))}function k(w){if(!w()){debugger;w(),(0,P.$3)(new P.$eb("Assertion Failed"))}}function A(w,E){let $=0;for(;$<w.length-1;){const u=w[$],p=w[$+1];if(!E(u,p))return!1;$++}return!0}}),define(ce[89],le([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fb=P;function P(c,N){const O=this;let T=!1,k;return function(){if(T)return k;if(T=!0,N)try{k=c.apply(O,arguments)}finally{N()}else k=c.apply(O,arguments);return k}}}),define(ce[63],le([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var P;(function(c){function N(i){return i&&typeof i=="object"&&typeof i[Symbol.iterator]=="function"}c.is=N;const O=Object.freeze([]);function T(){return O}c.empty=T;function*k(i){yield i}c.single=k;function A(i){return N(i)?i:k(i)}c.wrap=A;function w(i){return i||O}c.from=w;function*E(i){for(let a=i.length-1;a>=0;a--)yield i[a]}c.reverse=E;function $(i){return!i||i[Symbol.iterator]().next().done===!0}c.isEmpty=$;function u(i){return i[Symbol.iterator]().next().value}c.first=u;function p(i,a){let t=0;for(const n of i)if(a(n,t++))return!0;return!1}c.some=p;function l(i,a){for(const t of i)if(a(t))return t}c.find=l;function*d(i,a){for(const t of i)a(t)&&(yield t)}c.filter=d;function*y(i,a){let t=0;for(const n of i)yield a(n,t++)}c.map=y;function*f(i,a){let t=0;for(const n of i)yield*a(n,t++)}c.flatMap=f;function*b(...i){for(const a of i)yield*a}c.concat=b;function I(i,a,t){let n=t;for(const o of i)n=a(n,o);return n}c.reduce=I;function*m(i,a,t=i.length){for(a<0&&(a+=i.length),t<0?t+=i.length:t>i.length&&(t=i.length);a<t;a++)yield i[a]}c.slice=m;function s(i,a=Number.POSITIVE_INFINITY){const t=[];if(a===0)return[t,i];const n=i[Symbol.iterator]();for(let o=0;o<a;o++){const h=n.next();if(h.done)return[t,c.empty()];t.push(h.value)}return[t,{[Symbol.iterator](){return n}}]}c.consume=s;async function r(i){const a=[];for await(const t of i)a.push(t);return Promise.resolve(a)}c.asyncToArray=r})(P||(e.Iterable=P={}))}),define(ce[34],le([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0,e.$Tn=T,e.$Un=$,e.$Vn=u,e.$Wn=p,e.$Xn=l,e.$Yn=d,e.$Zn=y,e.$1n=f,e.$2n=b,e.$3n=I,e.$4n=m;var P;(function(s){s[s.None=0]="None",s[s.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",s[s.UnexpectedEndOfString=2]="UnexpectedEndOfString",s[s.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",s[s.InvalidUnicode=4]="InvalidUnicode",s[s.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",s[s.InvalidCharacter=6]="InvalidCharacter"})(P||(e.ScanError=P={}));var c;(function(s){s[s.OpenBraceToken=1]="OpenBraceToken",s[s.CloseBraceToken=2]="CloseBraceToken",s[s.OpenBracketToken=3]="OpenBracketToken",s[s.CloseBracketToken=4]="CloseBracketToken",s[s.CommaToken=5]="CommaToken",s[s.ColonToken=6]="ColonToken",s[s.NullKeyword=7]="NullKeyword",s[s.TrueKeyword=8]="TrueKeyword",s[s.FalseKeyword=9]="FalseKeyword",s[s.StringLiteral=10]="StringLiteral",s[s.NumericLiteral=11]="NumericLiteral",s[s.LineCommentTrivia=12]="LineCommentTrivia",s[s.BlockCommentTrivia=13]="BlockCommentTrivia",s[s.LineBreakTrivia=14]="LineBreakTrivia",s[s.Trivia=15]="Trivia",s[s.Unknown=16]="Unknown",s[s.EOF=17]="EOF"})(c||(e.SyntaxKind=c={}));var N;(function(s){s[s.InvalidSymbol=1]="InvalidSymbol",s[s.InvalidNumberFormat=2]="InvalidNumberFormat",s[s.PropertyNameExpected=3]="PropertyNameExpected",s[s.ValueExpected=4]="ValueExpected",s[s.ColonExpected=5]="ColonExpected",s[s.CommaExpected=6]="CommaExpected",s[s.CloseBraceExpected=7]="CloseBraceExpected",s[s.CloseBracketExpected=8]="CloseBracketExpected",s[s.EndOfFileExpected=9]="EndOfFileExpected",s[s.InvalidCommentToken=10]="InvalidCommentToken",s[s.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",s[s.UnexpectedEndOfString=12]="UnexpectedEndOfString",s[s.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",s[s.InvalidUnicode=14]="InvalidUnicode",s[s.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",s[s.InvalidCharacter=16]="InvalidCharacter"})(N||(e.ParseErrorCode=N={}));var O;(function(s){s.DEFAULT={allowTrailingComma:!0}})(O||(e.ParseOptions=O={}));function T(s,r=!1){let i=0;const a=s.length;let t="",n=0,o=c.Unknown,h=P.None;function g(D){let M=0,J=0;for(;M<D;){const H=s.charCodeAt(i);if(H>=E._0&&H<=E._9)J=J*16+H-E._0;else if(H>=E.A&&H<=E.F)J=J*16+H-E.A+10;else if(H>=E.a&&H<=E.f)J=J*16+H-E.a+10;else break;i++,M++}return M<D&&(J=-1),J}function R(D){i=D,t="",n=0,o=c.Unknown,h=P.None}function L(){const D=i;if(s.charCodeAt(i)===E._0)i++;else for(i++;i<s.length&&w(s.charCodeAt(i));)i++;if(i<s.length&&s.charCodeAt(i)===E.dot)if(i++,i<s.length&&w(s.charCodeAt(i)))for(i++;i<s.length&&w(s.charCodeAt(i));)i++;else return h=P.UnexpectedEndOfNumber,s.substring(D,i);let M=i;if(i<s.length&&(s.charCodeAt(i)===E.E||s.charCodeAt(i)===E.e))if(i++,(i<s.length&&s.charCodeAt(i)===E.plus||s.charCodeAt(i)===E.minus)&&i++,i<s.length&&w(s.charCodeAt(i))){for(i++;i<s.length&&w(s.charCodeAt(i));)i++;M=i}else h=P.UnexpectedEndOfNumber;return s.substring(D,M)}function S(){let D="",M=i;for(;;){if(i>=a){D+=s.substring(M,i),h=P.UnexpectedEndOfString;break}const J=s.charCodeAt(i);if(J===E.doubleQuote){D+=s.substring(M,i),i++;break}if(J===E.backslash){if(D+=s.substring(M,i),i++,i>=a){h=P.UnexpectedEndOfString;break}switch(s.charCodeAt(i++)){case E.doubleQuote:D+='"';break;case E.backslash:D+="\\";break;case E.slash:D+="/";break;case E.b:D+="\b";break;case E.f:D+="\f";break;case E.n:D+=`
`;break;case E.r:D+="\r";break;case E.t:D+="	";break;case E.u:{const x=g(4);x>=0?D+=String.fromCharCode(x):h=P.InvalidUnicode;break}default:h=P.InvalidEscapeCharacter}M=i;continue}if(J>=0&&J<=31)if(A(J)){D+=s.substring(M,i),h=P.UnexpectedEndOfString;break}else h=P.InvalidCharacter;i++}return D}function v(){if(t="",h=P.None,n=i,i>=a)return n=a,o=c.EOF;let D=s.charCodeAt(i);if(k(D)){do i++,t+=String.fromCharCode(D),D=s.charCodeAt(i);while(k(D));return o=c.Trivia}if(A(D))return i++,t+=String.fromCharCode(D),D===E.carriageReturn&&s.charCodeAt(i)===E.lineFeed&&(i++,t+=`
`),o=c.LineBreakTrivia;switch(D){case E.openBrace:return i++,o=c.OpenBraceToken;case E.closeBrace:return i++,o=c.CloseBraceToken;case E.openBracket:return i++,o=c.OpenBracketToken;case E.closeBracket:return i++,o=c.CloseBracketToken;case E.colon:return i++,o=c.ColonToken;case E.comma:return i++,o=c.CommaToken;case E.doubleQuote:return i++,t=S(),o=c.StringLiteral;case E.slash:{const M=i-1;if(s.charCodeAt(i+1)===E.slash){for(i+=2;i<a&&!A(s.charCodeAt(i));)i++;return t=s.substring(M,i),o=c.LineCommentTrivia}if(s.charCodeAt(i+1)===E.asterisk){i+=2;const J=a-1;let H=!1;for(;i<J;){if(s.charCodeAt(i)===E.asterisk&&s.charCodeAt(i+1)===E.slash){i+=2,H=!0;break}i++}return H||(i++,h=P.UnexpectedEndOfComment),t=s.substring(M,i),o=c.BlockCommentTrivia}return t+=String.fromCharCode(D),i++,o=c.Unknown}case E.minus:if(t+=String.fromCharCode(D),i++,i===a||!w(s.charCodeAt(i)))return o=c.Unknown;case E._0:case E._1:case E._2:case E._3:case E._4:case E._5:case E._6:case E._7:case E._8:case E._9:return t+=L(),o=c.NumericLiteral;default:for(;i<a&&C(D);)i++,D=s.charCodeAt(i);if(n!==i){switch(t=s.substring(n,i),t){case"true":return o=c.TrueKeyword;case"false":return o=c.FalseKeyword;case"null":return o=c.NullKeyword}return o=c.Unknown}return t+=String.fromCharCode(D),i++,o=c.Unknown}}function C(D){if(k(D)||A(D))return!1;switch(D){case E.closeBrace:case E.closeBracket:case E.openBrace:case E.openBracket:case E.doubleQuote:case E.colon:case E.comma:case E.slash:return!1}return!0}function F(){let D;do D=v();while(D>=c.LineCommentTrivia&&D<=c.Trivia);return D}return{setPosition:R,getPosition:()=>i,scan:r?F:v,getToken:()=>o,getTokenValue:()=>t,getTokenOffset:()=>n,getTokenLength:()=>i-n,getTokenError:()=>h}}function k(s){return s===E.space||s===E.tab||s===E.verticalTab||s===E.formFeed||s===E.nonBreakingSpace||s===E.ogham||s>=E.enQuad&&s<=E.zeroWidthSpace||s===E.narrowNoBreakSpace||s===E.mathematicalSpace||s===E.ideographicSpace||s===E.byteOrderMark}function A(s){return s===E.lineFeed||s===E.carriageReturn||s===E.lineSeparator||s===E.paragraphSeparator}function w(s){return s>=E._0&&s<=E._9}var E;(function(s){s[s.nullCharacter=0]="nullCharacter",s[s.maxAsciiCharacter=127]="maxAsciiCharacter",s[s.lineFeed=10]="lineFeed",s[s.carriageReturn=13]="carriageReturn",s[s.lineSeparator=8232]="lineSeparator",s[s.paragraphSeparator=8233]="paragraphSeparator",s[s.nextLine=133]="nextLine",s[s.space=32]="space",s[s.nonBreakingSpace=160]="nonBreakingSpace",s[s.enQuad=8192]="enQuad",s[s.emQuad=8193]="emQuad",s[s.enSpace=8194]="enSpace",s[s.emSpace=8195]="emSpace",s[s.threePerEmSpace=8196]="threePerEmSpace",s[s.fourPerEmSpace=8197]="fourPerEmSpace",s[s.sixPerEmSpace=8198]="sixPerEmSpace",s[s.figureSpace=8199]="figureSpace",s[s.punctuationSpace=8200]="punctuationSpace",s[s.thinSpace=8201]="thinSpace",s[s.hairSpace=8202]="hairSpace",s[s.zeroWidthSpace=8203]="zeroWidthSpace",s[s.narrowNoBreakSpace=8239]="narrowNoBreakSpace",s[s.ideographicSpace=12288]="ideographicSpace",s[s.mathematicalSpace=8287]="mathematicalSpace",s[s.ogham=5760]="ogham",s[s._=95]="_",s[s.$=36]="$",s[s._0=48]="_0",s[s._1=49]="_1",s[s._2=50]="_2",s[s._3=51]="_3",s[s._4=52]="_4",s[s._5=53]="_5",s[s._6=54]="_6",s[s._7=55]="_7",s[s._8=56]="_8",s[s._9=57]="_9",s[s.a=97]="a",s[s.b=98]="b",s[s.c=99]="c",s[s.d=100]="d",s[s.e=101]="e",s[s.f=102]="f",s[s.g=103]="g",s[s.h=104]="h",s[s.i=105]="i",s[s.j=106]="j",s[s.k=107]="k",s[s.l=108]="l",s[s.m=109]="m",s[s.n=110]="n",s[s.o=111]="o",s[s.p=112]="p",s[s.q=113]="q",s[s.r=114]="r",s[s.s=115]="s",s[s.t=116]="t",s[s.u=117]="u",s[s.v=118]="v",s[s.w=119]="w",s[s.x=120]="x",s[s.y=121]="y",s[s.z=122]="z",s[s.A=65]="A",s[s.B=66]="B",s[s.C=67]="C",s[s.D=68]="D",s[s.E=69]="E",s[s.F=70]="F",s[s.G=71]="G",s[s.H=72]="H",s[s.I=73]="I",s[s.J=74]="J",s[s.K=75]="K",s[s.L=76]="L",s[s.M=77]="M",s[s.N=78]="N",s[s.O=79]="O",s[s.P=80]="P",s[s.Q=81]="Q",s[s.R=82]="R",s[s.S=83]="S",s[s.T=84]="T",s[s.U=85]="U",s[s.V=86]="V",s[s.W=87]="W",s[s.X=88]="X",s[s.Y=89]="Y",s[s.Z=90]="Z",s[s.ampersand=38]="ampersand",s[s.asterisk=42]="asterisk",s[s.at=64]="at",s[s.backslash=92]="backslash",s[s.bar=124]="bar",s[s.caret=94]="caret",s[s.closeBrace=125]="closeBrace",s[s.closeBracket=93]="closeBracket",s[s.closeParen=41]="closeParen",s[s.colon=58]="colon",s[s.comma=44]="comma",s[s.dot=46]="dot",s[s.doubleQuote=34]="doubleQuote",s[s.equals=61]="equals",s[s.exclamation=33]="exclamation",s[s.greaterThan=62]="greaterThan",s[s.lessThan=60]="lessThan",s[s.minus=45]="minus",s[s.openBrace=123]="openBrace",s[s.openBracket=91]="openBracket",s[s.openParen=40]="openParen",s[s.percent=37]="percent",s[s.plus=43]="plus",s[s.question=63]="question",s[s.semicolon=59]="semicolon",s[s.singleQuote=39]="singleQuote",s[s.slash=47]="slash",s[s.tilde=126]="tilde",s[s.backspace=8]="backspace",s[s.formFeed=12]="formFeed",s[s.byteOrderMark=65279]="byteOrderMark",s[s.tab=9]="tab",s[s.verticalTab=11]="verticalTab"})(E||(E={}));function $(s,r){const i=[],a=new Object;let t;const n={value:{},offset:0,length:0,type:"object",parent:void 0};let o=!1;function h(g,R,L,S){n.value=g,n.offset=R,n.length=L,n.type=S,n.colonOffset=void 0,t=n}try{I(s,{onObjectBegin:(g,R)=>{if(r<=g)throw a;t=void 0,o=r>g,i.push("")},onObjectProperty:(g,R,L)=>{if(r<R||(h(g,R,L,"property"),i[i.length-1]=g,r<=R+L))throw a},onObjectEnd:(g,R)=>{if(r<=g)throw a;t=void 0,i.pop()},onArrayBegin:(g,R)=>{if(r<=g)throw a;t=void 0,i.push(0)},onArrayEnd:(g,R)=>{if(r<=g)throw a;t=void 0,i.pop()},onLiteralValue:(g,R,L)=>{if(r<R||(h(g,R,L,m(g)),r<=R+L))throw a},onSeparator:(g,R,L)=>{if(r<=R)throw a;if(g===":"&&t&&t.type==="property")t.colonOffset=R,o=!1,t=void 0;else if(g===","){const S=i[i.length-1];typeof S=="number"?i[i.length-1]=S+1:(o=!0,i[i.length-1]=""),t=void 0}}})}catch(g){if(g!==a)throw g}return{path:i,previousNode:t,isAtPropertyKey:o,matches:g=>{let R=0;for(let L=0;R<g.length&&L<i.length;L++)if(g[R]===i[L]||g[R]==="*")R++;else if(g[R]!=="**")return!1;return R===g.length}}}function u(s,r=[],i=O.DEFAULT){let a=null,t=[];const n=[];function o(g){Array.isArray(t)?t.push(g):a!==null&&(t[a]=g)}return I(s,{onObjectBegin:()=>{const g={};o(g),n.push(t),t=g,a=null},onObjectProperty:g=>{a=g},onObjectEnd:()=>{t=n.pop()},onArrayBegin:()=>{const g=[];o(g),n.push(t),t=g,a=null},onArrayEnd:()=>{t=n.pop()},onLiteralValue:o,onError:(g,R,L)=>{r.push({error:g,offset:R,length:L})}},i),t[0]}function p(s,r=[],i=O.DEFAULT){let a={type:"array",offset:-1,length:-1,children:[],parent:void 0};function t(g){a.type==="property"&&(a.length=g-a.offset,a=a.parent)}function n(g){return a.children.push(g),g}I(s,{onObjectBegin:g=>{a=n({type:"object",offset:g,length:-1,parent:a,children:[]})},onObjectProperty:(g,R,L)=>{a=n({type:"property",offset:R,length:-1,parent:a,children:[]}),a.children.push({type:"string",value:g,offset:R,length:L,parent:a})},onObjectEnd:(g,R)=>{a.length=g+R-a.offset,a=a.parent,t(g+R)},onArrayBegin:(g,R)=>{a=n({type:"array",offset:g,length:-1,parent:a,children:[]})},onArrayEnd:(g,R)=>{a.length=g+R-a.offset,a=a.parent,t(g+R)},onLiteralValue:(g,R,L)=>{n({type:m(g),offset:R,length:L,parent:a,value:g}),t(R+L)},onSeparator:(g,R,L)=>{a.type==="property"&&(g===":"?a.colonOffset=R:g===","&&t(R))},onError:(g,R,L)=>{r.push({error:g,offset:R,length:L})}},i);const h=a.children[0];return h&&delete h.parent,h}function l(s,r){if(!s)return;let i=s;for(const a of r)if(typeof a=="string"){if(i.type!=="object"||!Array.isArray(i.children))return;let t=!1;for(const n of i.children)if(Array.isArray(n.children)&&n.children[0].value===a){i=n.children[1],t=!0;break}if(!t)return}else{const t=a;if(i.type!=="array"||t<0||!Array.isArray(i.children)||t>=i.children.length)return;i=i.children[t]}return i}function d(s){if(!s.parent||!s.parent.children)return[];const r=d(s.parent);if(s.parent.type==="property"){const i=s.parent.children[0].value;r.push(i)}else if(s.parent.type==="array"){const i=s.parent.children.indexOf(s);i!==-1&&r.push(i)}return r}function y(s){switch(s.type){case"array":return s.children.map(y);case"object":{const r=Object.create(null);for(const i of s.children){const a=i.children[1];a&&(r[i.children[0].value]=y(a))}return r}case"null":case"string":case"number":case"boolean":return s.value;default:return}}function f(s,r,i=!1){return r>=s.offset&&r<s.offset+s.length||i&&r===s.offset+s.length}function b(s,r,i=!1){if(f(s,r,i)){const a=s.children;if(Array.isArray(a))for(let t=0;t<a.length&&a[t].offset<=r;t++){const n=b(a[t],r,i);if(n)return n}return s}}function I(s,r,i=O.DEFAULT){const a=T(s,!1);function t(se){return se?()=>se(a.getTokenOffset(),a.getTokenLength()):()=>!0}function n(se){return se?he=>se(he,a.getTokenOffset(),a.getTokenLength()):()=>!0}const o=t(r.onObjectBegin),h=n(r.onObjectProperty),g=t(r.onObjectEnd),R=t(r.onArrayBegin),L=t(r.onArrayEnd),S=n(r.onLiteralValue),v=n(r.onSeparator),C=t(r.onComment),F=n(r.onError),D=i&&i.disallowComments,M=i&&i.allowTrailingComma;function J(){for(;;){const se=a.scan();switch(a.getTokenError()){case P.InvalidUnicode:H(N.InvalidUnicode);break;case P.InvalidEscapeCharacter:H(N.InvalidEscapeCharacter);break;case P.UnexpectedEndOfNumber:H(N.UnexpectedEndOfNumber);break;case P.UnexpectedEndOfComment:D||H(N.UnexpectedEndOfComment);break;case P.UnexpectedEndOfString:H(N.UnexpectedEndOfString);break;case P.InvalidCharacter:H(N.InvalidCharacter);break}switch(se){case c.LineCommentTrivia:case c.BlockCommentTrivia:D?H(N.InvalidCommentToken):C();break;case c.Unknown:H(N.InvalidSymbol);break;case c.Trivia:case c.LineBreakTrivia:break;default:return se}}}function H(se,he=[],q=[]){if(F(se),he.length+q.length>0){let Z=a.getToken();for(;Z!==c.EOF;){if(he.indexOf(Z)!==-1){J();break}else if(q.indexOf(Z)!==-1)break;Z=J()}}}function x(se){const he=a.getTokenValue();return se?S(he):h(he),J(),!0}function K(){switch(a.getToken()){case c.NumericLiteral:{let se=0;try{se=JSON.parse(a.getTokenValue()),typeof se!="number"&&(H(N.InvalidNumberFormat),se=0)}catch{H(N.InvalidNumberFormat)}S(se);break}case c.NullKeyword:S(null);break;case c.TrueKeyword:S(!0);break;case c.FalseKeyword:S(!1);break;default:return!1}return J(),!0}function ie(){return a.getToken()!==c.StringLiteral?(H(N.PropertyNameExpected,[],[c.CloseBraceToken,c.CommaToken]),!1):(x(!1),a.getToken()===c.ColonToken?(v(":"),J(),ee()||H(N.ValueExpected,[],[c.CloseBraceToken,c.CommaToken])):H(N.ColonExpected,[],[c.CloseBraceToken,c.CommaToken]),!0)}function V(){o(),J();let se=!1;for(;a.getToken()!==c.CloseBraceToken&&a.getToken()!==c.EOF;){if(a.getToken()===c.CommaToken){if(se||H(N.ValueExpected,[],[]),v(","),J(),a.getToken()===c.CloseBraceToken&&M)break}else se&&H(N.CommaExpected,[],[]);ie()||H(N.ValueExpected,[],[c.CloseBraceToken,c.CommaToken]),se=!0}return g(),a.getToken()!==c.CloseBraceToken?H(N.CloseBraceExpected,[c.CloseBraceToken],[]):J(),!0}function z(){R(),J();let se=!1;for(;a.getToken()!==c.CloseBracketToken&&a.getToken()!==c.EOF;){if(a.getToken()===c.CommaToken){if(se||H(N.ValueExpected,[],[]),v(","),J(),a.getToken()===c.CloseBracketToken&&M)break}else se&&H(N.CommaExpected,[],[]);ee()||H(N.ValueExpected,[],[c.CloseBracketToken,c.CommaToken]),se=!0}return L(),a.getToken()!==c.CloseBracketToken?H(N.CloseBracketExpected,[c.CloseBracketToken],[]):J(),!0}function ee(){switch(a.getToken()){case c.OpenBracketToken:return z();case c.OpenBraceToken:return V();case c.StringLiteral:return x(!0);default:return K()}}return J(),a.getToken()===c.EOF?i.allowEmptyContent?!0:(H(N.ValueExpected,[],[]),!1):ee()?(a.getToken()!==c.EOF&&H(N.EndOfFileExpected,[],[]),!0):(H(N.ValueExpected,[],[]),!1)}function m(s){switch(typeof s){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(s){if(Array.isArray(s))return"array"}else return"null";return"object"}default:return"null"}}}),define(ce[45],le([0,1,34]),function(ne,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5n=c,e.$6n=N,e.$7n=k,e.$8n=A;function c(w,E,$){let u,p,l,d,y;if(E){for(d=E.offset,y=d+E.length,l=d;l>0&&!A(w,l-1);)l--;let h=y;for(;h<w.length&&!A(w,h);)h++;p=w.substring(l,h),u=T(p,$)}else p=w,u=0,l=0,d=0,y=w.length;const f=k($,w);let b=!1,I=0,m;$.insertSpaces?m=O(" ",$.tabSize||4):m="	";const s=(0,P.$Tn)(p,!1);let r=!1;function i(){return f+O(m,u+I)}function a(){let h=s.scan();for(b=!1;h===P.SyntaxKind.Trivia||h===P.SyntaxKind.LineBreakTrivia;)b=b||h===P.SyntaxKind.LineBreakTrivia,h=s.scan();return r=h===P.SyntaxKind.Unknown||s.getTokenError()!==P.ScanError.None,h}const t=[];function n(h,g,R){!r&&g<y&&R>d&&w.substring(g,R)!==h&&t.push({offset:g,length:R-g,content:h})}let o=a();if(o!==P.SyntaxKind.EOF){const h=s.getTokenOffset()+l,g=O(m,u);n(g,l,h)}for(;o!==P.SyntaxKind.EOF;){let h=s.getTokenOffset()+s.getTokenLength()+l,g=a(),R="";for(;!b&&(g===P.SyntaxKind.LineCommentTrivia||g===P.SyntaxKind.BlockCommentTrivia);){const S=s.getTokenOffset()+l;n(" ",h,S),h=s.getTokenOffset()+s.getTokenLength()+l,R=g===P.SyntaxKind.LineCommentTrivia?i():"",g=a()}if(g===P.SyntaxKind.CloseBraceToken)o!==P.SyntaxKind.OpenBraceToken&&(I--,R=i());else if(g===P.SyntaxKind.CloseBracketToken)o!==P.SyntaxKind.OpenBracketToken&&(I--,R=i());else{switch(o){case P.SyntaxKind.OpenBracketToken:case P.SyntaxKind.OpenBraceToken:I++,R=i();break;case P.SyntaxKind.CommaToken:case P.SyntaxKind.LineCommentTrivia:R=i();break;case P.SyntaxKind.BlockCommentTrivia:b?R=i():R=" ";break;case P.SyntaxKind.ColonToken:R=" ";break;case P.SyntaxKind.StringLiteral:if(g===P.SyntaxKind.ColonToken){R="";break}case P.SyntaxKind.NullKeyword:case P.SyntaxKind.TrueKeyword:case P.SyntaxKind.FalseKeyword:case P.SyntaxKind.NumericLiteral:case P.SyntaxKind.CloseBraceToken:case P.SyntaxKind.CloseBracketToken:g===P.SyntaxKind.LineCommentTrivia||g===P.SyntaxKind.BlockCommentTrivia?R=" ":g!==P.SyntaxKind.CommaToken&&g!==P.SyntaxKind.EOF&&(r=!0);break;case P.SyntaxKind.Unknown:r=!0;break}b&&(g===P.SyntaxKind.LineCommentTrivia||g===P.SyntaxKind.BlockCommentTrivia)&&(R=i())}const L=s.getTokenOffset()+l;n(R,h,L),o=g}return t}function N(w,E){const $=JSON.stringify(w,void 0,E.insertSpaces?E.tabSize||4:"	");return E.eol!==void 0?$.replace(/\r\n|\r|\n/g,E.eol):$}function O(w,E){let $="";for(let u=0;u<E;u++)$+=w;return $}function T(w,E){let $=0,u=0;const p=E.tabSize||4;for(;$<w.length;){const l=w.charAt($);if(l===" ")u++;else if(l==="	")u+=p;else break;$++}return Math.floor(u/p)}function k(w,E){for(let $=0;$<E.length;$++){const u=E.charAt($);if(u==="\r")return $+1<E.length&&E.charAt($+1)===`
`?`\r
`:"\r";if(u===`
`)return`
`}return w&&w.eol||`
`}function A(w,E){return`\r
`.indexOf(w.charAt(E))!==-1}}),define(ce[64],le([0,1,34,45]),function(ne,e,P,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9n=N,e.$0n=O,e.$$n=T,e.$_n=k,e.$ao=A;function N(w,E,$){return O(w,E,void 0,$)}function O(w,E,$,u,p){const l=E.slice(),d=[],y=(0,P.$Wn)(w,d);let f,b;for(;l.length>0&&(b=l.pop(),f=(0,P.$Xn)(y,l),f===void 0&&$!==void 0);)typeof b=="string"?$={[b]:$}:$=[$];if(f)if(f.type==="object"&&typeof b=="string"&&Array.isArray(f.children)){const I=(0,P.$Xn)(f,[b]);if(I!==void 0)if($===void 0){if(!I.parent)throw new Error("Malformed AST");const m=f.children.indexOf(I.parent);let s,r=I.parent.offset+I.parent.length;if(m>0){const i=f.children[m-1];s=i.offset+i.length}else s=f.offset+1,f.children.length>1&&(r=f.children[1].offset);return T(w,{offset:s,length:r-s,content:""},u)}else return T(w,{offset:I.offset,length:I.length,content:JSON.stringify($)},u);else{if($===void 0)return[];const m=`${JSON.stringify(b)}: ${JSON.stringify($)}`,s=p?p(f.children.map(i=>i.children[0].value)):f.children.length;let r;if(s>0){const i=f.children[s-1];r={offset:i.offset+i.length,length:0,content:","+m}}else f.children.length===0?r={offset:f.offset+1,length:0,content:m}:r={offset:f.offset+1,length:0,content:m+","};return T(w,r,u)}}else if(f.type==="array"&&typeof b=="number"&&Array.isArray(f.children))if($!==void 0){const I=`${JSON.stringify($)}`;let m;if(f.children.length===0||b===0)m={offset:f.offset+1,length:0,content:f.children.length===0?I:I+","};else{const s=b===-1||b>f.children.length?f.children.length:b,r=f.children[s-1];m={offset:r.offset+r.length,length:0,content:","+I}}return T(w,m,u)}else{const I=b,m=f.children[I];let s;if(f.children.length===1)s={offset:f.offset+1,length:f.length-2,content:""};else if(f.children.length-1===I){const r=f.children[I-1],i=r.offset+r.length,a=f.offset+f.length;s={offset:i,length:a-2-i,content:""}}else s={offset:m.offset,length:f.children[I+1].offset-m.offset,content:""};return T(w,s,u)}else throw new Error(`Can not add ${typeof b!="number"?"index":"property"} to parent of type ${f.type}`);else return $===void 0?[]:T(w,{offset:y?y.offset:0,length:y?y.length:0,content:JSON.stringify($)},u)}function T(w,E,$){let u=k(w,E),p=E.offset,l=E.offset+E.content.length;if(E.length===0||E.content.length===0){for(;p>0&&!(0,c.$8n)(u,p-1);)p--;for(;l<u.length&&!(0,c.$8n)(u,l);)l++}const d=(0,c.$5n)(u,{offset:p,length:l-p},$);for(let f=d.length-1;f>=0;f--){const b=d[f];u=k(u,b),p=Math.min(p,b.offset),l=Math.max(l,b.offset+b.length),l+=b.content.length-b.length}const y=w.length-(u.length-l)-p;return[{offset:p,length:y,content:u.substring(p,l)}]}function k(w,E){return w.substring(0,E.offset)+E.content+w.substring(E.offset+E.length)}function A(w,E){const $=E.slice(0).sort((p,l)=>{const d=p.offset-l.offset;return d===0?p.length-l.length:d});let u=w.length;for(let p=$.length-1;p>=0;p--){const l=$[p];if(l.offset+l.length<=u)w=k(w,l);else throw new Error("Overlapping edit");u=l.offset}return w}}),define(ce[54],le([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$X=void 0;class P{constructor(N){this.d=N,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(N){this.c=N}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$X=P}),define(ce[90],le([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7c=void 0;class P{static{this.Undefined=new P(void 0)}constructor(O){this.element=O,this.next=P.Undefined,this.prev=P.Undefined}}class c{constructor(){this.a=P.Undefined,this.b=P.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===P.Undefined}clear(){let O=this.a;for(;O!==P.Undefined;){const T=O.next;O.prev=P.Undefined,O.next=P.Undefined,O=T}this.a=P.Undefined,this.b=P.Undefined,this.c=0}unshift(O){return this.d(O,!1)}push(O){return this.d(O,!0)}d(O,T){const k=new P(O);if(this.a===P.Undefined)this.a=k,this.b=k;else if(T){const w=this.b;this.b=k,k.prev=w,w.next=k}else{const w=this.a;this.a=k,k.next=w,w.prev=k}this.c+=1;let A=!1;return()=>{A||(A=!0,this.e(k))}}shift(){if(this.a!==P.Undefined){const O=this.a.element;return this.e(this.a),O}}pop(){if(this.b!==P.Undefined){const O=this.b.element;return this.e(this.b),O}}e(O){if(O.prev!==P.Undefined&&O.next!==P.Undefined){const T=O.prev;T.next=O.next,O.next.prev=T}else O.prev===P.Undefined&&O.next===P.Undefined?(this.a=P.Undefined,this.b=P.Undefined):O.next===P.Undefined?(this.b=this.b.prev,this.b.next=P.Undefined):O.prev===P.Undefined&&(this.a=this.a.next,this.a.prev=P.Undefined);this.c-=1}*[Symbol.iterator](){let O=this.a;for(;O!==P.Undefined;)yield O.element,O=O.next}}e.$7c=c}),define(ce[35],le([0,1]),function(ne,e){"use strict";var P,c,N;Object.defineProperty(e,"__esModule",{value:!0}),e.$Jc=e.$Ic=e.$Hc=e.$Gc=e.$Fc=e.$Ec=e.Touch=e.$Dc=e.$Cc=void 0,e.$zc=O,e.$Ac=T,e.$Bc=k,e.$Kc=m;function O(s,r,i){let a=s.get(r);return a===void 0&&(a=i,s.set(r,a)),a}function T(s){const r=[];return s.forEach((i,a)=>{r.push(`${a} => ${i}`)}),`Map(${s.size}) {${r.join(", ")}}`}function k(s){const r=[];return s.forEach(i=>{r.push(i)}),`Set(${s.size}) {${r.join(", ")}}`}class A{constructor(r,i){this.uri=r,this.value=i}}function w(s){return Array.isArray(s)}class E{static{this.c=r=>r.toString()}constructor(r,i){if(this[P]="ResourceMap",r instanceof E)this.d=new Map(r.d),this.e=i??E.c;else if(w(r)){this.d=new Map,this.e=i??E.c;for(const[a,t]of r)this.set(a,t)}else this.d=new Map,this.e=r??E.c}set(r,i){return this.d.set(this.e(r),new A(r,i)),this}get(r){return this.d.get(this.e(r))?.value}has(r){return this.d.has(this.e(r))}get size(){return this.d.size}clear(){this.d.clear()}delete(r){return this.d.delete(this.e(r))}forEach(r,i){typeof i<"u"&&(r=r.bind(i));for(const[a,t]of this.d)r(t.value,t.uri,this)}*values(){for(const r of this.d.values())yield r.value}*keys(){for(const r of this.d.values())yield r.uri}*entries(){for(const r of this.d.values())yield[r.uri,r.value]}*[(P=Symbol.toStringTag,Symbol.iterator)](){for(const[,r]of this.d)yield[r.uri,r.value]}}e.$Cc=E;class ${constructor(r,i){this[c]="ResourceSet",!r||typeof r=="function"?this.c=new E(r):(this.c=new E(i),r.forEach(this.add,this))}get size(){return this.c.size}add(r){return this.c.set(r,r),this}clear(){this.c.clear()}delete(r){return this.c.delete(r)}forEach(r,i){this.c.forEach((a,t)=>r.call(i,t,t,this))}has(r){return this.c.has(r)}entries(){return this.c.entries()}keys(){return this.c.keys()}values(){return this.c.keys()}[(c=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$Dc=$;var u;(function(s){s[s.None=0]="None",s[s.AsOld=1]="AsOld",s[s.AsNew=2]="AsNew"})(u||(e.Touch=u={}));class p{constructor(){this[N]="LinkedMap",this.c=new Map,this.d=void 0,this.e=void 0,this.f=0,this.g=0}clear(){this.c.clear(),this.d=void 0,this.e=void 0,this.f=0,this.g++}isEmpty(){return!this.d&&!this.e}get size(){return this.f}get first(){return this.d?.value}get last(){return this.e?.value}has(r){return this.c.has(r)}get(r,i=u.None){const a=this.c.get(r);if(a)return i!==u.None&&this.m(a,i),a.value}set(r,i,a=u.None){let t=this.c.get(r);if(t)t.value=i,a!==u.None&&this.m(t,a);else{switch(t={key:r,value:i,next:void 0,previous:void 0},a){case u.None:this.k(t);break;case u.AsOld:this.j(t);break;case u.AsNew:this.k(t);break;default:this.k(t);break}this.c.set(r,t),this.f++}return this}delete(r){return!!this.remove(r)}remove(r){const i=this.c.get(r);if(i)return this.c.delete(r),this.l(i),this.f--,i.value}shift(){if(!this.d&&!this.e)return;if(!this.d||!this.e)throw new Error("Invalid list");const r=this.d;return this.c.delete(r.key),this.l(r),this.f--,r.value}forEach(r,i){const a=this.g;let t=this.d;for(;t;){if(i?r.bind(i)(t.value,t.key,this):r(t.value,t.key,this),this.g!==a)throw new Error("LinkedMap got modified during iteration.");t=t.next}}keys(){const r=this,i=this.g;let a=this.d;const t={[Symbol.iterator](){return t},next(){if(r.g!==i)throw new Error("LinkedMap got modified during iteration.");if(a){const n={value:a.key,done:!1};return a=a.next,n}else return{value:void 0,done:!0}}};return t}values(){const r=this,i=this.g;let a=this.d;const t={[Symbol.iterator](){return t},next(){if(r.g!==i)throw new Error("LinkedMap got modified during iteration.");if(a){const n={value:a.value,done:!1};return a=a.next,n}else return{value:void 0,done:!0}}};return t}entries(){const r=this,i=this.g;let a=this.d;const t={[Symbol.iterator](){return t},next(){if(r.g!==i)throw new Error("LinkedMap got modified during iteration.");if(a){const n={value:[a.key,a.value],done:!1};return a=a.next,n}else return{value:void 0,done:!0}}};return t}[(N=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}h(r){if(r>=this.size)return;if(r===0){this.clear();return}let i=this.d,a=this.size;for(;i&&a>r;)this.c.delete(i.key),i=i.next,a--;this.d=i,this.f=a,i&&(i.previous=void 0),this.g++}i(r){if(r>=this.size)return;if(r===0){this.clear();return}let i=this.e,a=this.size;for(;i&&a>r;)this.c.delete(i.key),i=i.previous,a--;this.e=i,this.f=a,i&&(i.next=void 0),this.g++}j(r){if(!this.d&&!this.e)this.e=r;else if(this.d)r.next=this.d,this.d.previous=r;else throw new Error("Invalid list");this.d=r,this.g++}k(r){if(!this.d&&!this.e)this.d=r;else if(this.e)r.previous=this.e,this.e.next=r;else throw new Error("Invalid list");this.e=r,this.g++}l(r){if(r===this.d&&r===this.e)this.d=void 0,this.e=void 0;else if(r===this.d){if(!r.next)throw new Error("Invalid list");r.next.previous=void 0,this.d=r.next}else if(r===this.e){if(!r.previous)throw new Error("Invalid list");r.previous.next=void 0,this.e=r.previous}else{const i=r.next,a=r.previous;if(!i||!a)throw new Error("Invalid list");i.previous=a,a.next=i}r.next=void 0,r.previous=void 0,this.g++}m(r,i){if(!this.d||!this.e)throw new Error("Invalid list");if(!(i!==u.AsOld&&i!==u.AsNew)){if(i===u.AsOld){if(r===this.d)return;const a=r.next,t=r.previous;r===this.e?(t.next=void 0,this.e=t):(a.previous=t,t.next=a),r.previous=void 0,r.next=this.d,this.d.previous=r,this.d=r,this.g++}else if(i===u.AsNew){if(r===this.e)return;const a=r.next,t=r.previous;r===this.d?(a.previous=void 0,this.d=a):(a.previous=t,t.next=a),r.next=void 0,r.previous=this.e,this.e.next=r,this.e=r,this.g++}}}toJSON(){const r=[];return this.forEach((i,a)=>{r.push([a,i])}),r}fromJSON(r){this.clear();for(const[i,a]of r)this.set(i,a)}}e.$Ec=p;class l extends p{constructor(r,i=1){super(),this.n=r,this.o=Math.min(Math.max(0,i),1)}get limit(){return this.n}set limit(r){this.n=r,this.p()}get ratio(){return this.o}set ratio(r){this.o=Math.min(Math.max(0,r),1),this.p()}get(r,i=u.AsNew){return super.get(r,i)}peek(r){return super.get(r,u.None)}set(r,i){return super.set(r,i,u.AsNew),this}p(){this.size>this.n&&this.q(Math.round(this.n*this.o))}}class d extends l{constructor(r,i=1){super(r,i)}q(r){this.h(r)}set(r,i){return super.set(r,i),this.p(),this}}e.$Fc=d;class y extends l{constructor(r,i=1){super(r,i)}q(r){this.i(r)}set(r,i){return this.n<=this.size&&!this.has(r)&&this.q(Math.round(this.n*this.o)-1),super.set(r,i),this}}e.$Gc=y;class f{constructor(){this.c=new Map}add(r){return this.c.set(r,(this.c.get(r)||0)+1),this}delete(r){let i=this.c.get(r)||0;return i===0?!1:(i--,i===0?this.c.delete(r):this.c.set(r,i),!0)}has(r){return this.c.has(r)}}e.$Hc=f;class b{constructor(r){if(this.c=new Map,this.d=new Map,r)for(const[i,a]of r)this.set(i,a)}clear(){this.c.clear(),this.d.clear()}set(r,i){this.c.set(r,i),this.d.set(i,r)}get(r){return this.c.get(r)}getKey(r){return this.d.get(r)}delete(r){const i=this.c.get(r);return i===void 0?!1:(this.c.delete(r),this.d.delete(i),!0)}forEach(r,i){this.c.forEach((a,t)=>{r.call(i,a,t,this)})}keys(){return this.c.keys()}values(){return this.c.values()}}e.$Ic=b;class I{constructor(){this.c=new Map}add(r,i){let a=this.c.get(r);a||(a=new Set,this.c.set(r,a)),a.add(i)}delete(r,i){const a=this.c.get(r);a&&(a.delete(i),a.size===0&&this.c.delete(r))}forEach(r,i){const a=this.c.get(r);a&&a.forEach(i)}get(r){const i=this.c.get(r);return i||new Set}}e.$Jc=I;function m(s,r){if(s===r)return!0;if(s.size!==r.size)return!1;for(const[i,a]of s)if(!r.has(i)||r.get(i)!==a)return!1;for(const[i]of r)if(!s.has(i))return!1;return!0}}),define(ce[2],le([0,1,19,131,35,89,63]),function(ne,e,P,c,N,O,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6c=e.$4c=e.$3c=e.$2c=e.$1c=e.$Zc=e.$Yc=e.$Xc=e.$Wc=e.$Vc=e.$Lc=void 0,e.$Mc=E,e.$Nc=$,e.$Oc=u,e.$Pc=d,e.$Qc=y,e.$Rc=f,e.$Sc=b,e.$Tc=I,e.$Uc=m,e.$5c=R;const k=!1;let A=null;class w{constructor(){this.b=new Map}static{this.a=0}c(v){let C=this.b.get(v);return C||(C={parent:null,source:null,isSingleton:!1,value:v,idx:w.a++},this.b.set(v,C)),C}trackDisposable(v){const C=this.c(v);C.source||(C.source=new Error().stack)}setParent(v,C){const F=this.c(v);F.parent=C}markAsDisposed(v){this.b.delete(v)}markAsSingleton(v){this.c(v).isSingleton=!0}f(v,C){const F=C.get(v);if(F)return F;const D=v.parent?this.f(this.c(v.parent),C):v;return C.set(v,D),D}getTrackedDisposables(){const v=new Map;return[...this.b.entries()].filter(([,F])=>F.source!==null&&!this.f(F,v).isSingleton).flatMap(([F])=>F)}computeLeakingDisposables(v=10,C){let F;if(C)F=C;else{const x=new Map,K=[...this.b.values()].filter(V=>V.source!==null&&!this.f(V,x).isSingleton);if(K.length===0)return;const ie=new Set(K.map(V=>V.value));if(F=K.filter(V=>!(V.parent&&ie.has(V.parent))),F.length===0)throw new Error("There are cyclic diposable chains!")}if(!F)return;function D(x){function K(V,z){for(;V.length>0&&z.some(ee=>typeof ee=="string"?ee===V[0]:V[0].match(ee));)V.shift()}const ie=x.source.split(`
`).map(V=>V.trim().replace("at ","")).filter(V=>V!=="");return K(ie,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),ie.reverse()}const M=new N.$Jc;for(const x of F){const K=D(x);for(let ie=0;ie<=K.length;ie++)M.add(K.slice(0,ie).join(`
`),x)}F.sort((0,P.$8b)(x=>x.idx,P.$0b));let J="",H=0;for(const x of F.slice(0,v)){H++;const K=D(x),ie=[];for(let V=0;V<K.length;V++){let z=K[V];z=`(shared with ${M.get(K.slice(0,V+1).join(`
`)).size}/${F.length} leaks) at ${z}`;const se=M.get(K.slice(0,V).join(`
`)),he=(0,c.$K)([...se].map(q=>D(q)[V]),q=>q);delete he[K[V]];for(const[q,Z]of Object.entries(he))ie.unshift(`    - stacktraces of ${Z.length} other leaks continue with ${q}`);ie.unshift(z)}J+=`


==================== Leaking disposable ${H}/${F.length}: ${x.value.constructor.name} ====================
${ie.join(`
`)}
============================================================

`}return F.length>v&&(J+=`


... and ${F.length-v} more leaking disposables

`),{leaks:F,details:J}}}e.$Lc=w;function E(S){A=S}if(k){const S="__is_disposable_tracked__";E(new class{trackDisposable(v){const C=new Error("Potentially leaked disposable").stack;setTimeout(()=>{v[S]||console.log(C)},3e3)}setParent(v,C){if(v&&v!==r.None)try{v[S]=!0}catch{}}markAsDisposed(v){if(v&&v!==r.None)try{v[S]=!0}catch{}}markAsSingleton(v){}})}function $(S){return A?.trackDisposable(S),S}function u(S){A?.markAsDisposed(S)}function p(S,v){A?.setParent(S,v)}function l(S,v){if(A)for(const C of S)A.setParent(C,v)}function d(S){return A?.markAsSingleton(S),S}function y(S){return typeof S=="object"&&S!==null&&typeof S.dispose=="function"&&S.dispose.length===0}function f(S){if(T.Iterable.is(S)){const v=[];for(const C of S)if(C)try{C.dispose()}catch(F){v.push(F)}if(v.length===1)throw v[0];if(v.length>1)throw new AggregateError(v,"Encountered errors while disposing of store");return Array.isArray(S)?[]:S}else if(S)return S.dispose(),S}function b(S){for(const v of S)y(v)&&v.dispose();return[]}function I(...S){const v=m(()=>f(S));return l(S,v),v}function m(S){const v=$({dispose:(0,O.$fb)(()=>{u(v),S()})});return v}class s{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,$(this)}dispose(){this.g||(u(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{f(this.f)}finally{this.f.clear()}}add(v){if(!v)return v;if(v===this)throw new Error("Cannot register a disposable on itself!");return p(v,this),this.g?s.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(v),v}delete(v){if(v){if(v===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(v),v.dispose()}}deleteAndLeak(v){v&&this.f.has(v)&&(this.f.delete(v),p(v,null))}}e.$Vc=s;class r{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new s,$(this),p(this.q,this)}dispose(){u(this),this.q.dispose()}B(v){if(v===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(v)}}e.$Wc=r;class i{constructor(){this.b=!1,$(this)}get value(){return this.b?void 0:this.a}set value(v){this.b||v===this.a||(this.a?.dispose(),v&&p(v,this),this.a=v)}clear(){this.value=void 0}dispose(){this.b=!0,u(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const v=this.a;return this.a=void 0,v&&p(v,null),v}}e.$Xc=i;class a{constructor(v){this.a=new i,this.b=!1,this.a.value=v}get value(){return this.a.value}set value(v){this.b||v===this.a.value||(this.a.value=v)}dispose(){this.b=!0,this.a.dispose()}}e.$Yc=a;class t{constructor(v){this.b=v,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$Zc=t;class n{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,$(this)}set(v){let C=v;return this.unset=()=>C=void 0,this.isset=()=>C!==void 0,this.dispose=()=>{C&&(C(),C=void 0,u(this))},this}}e.$1c=n;class o{constructor(){this.a=new Map}acquire(v,...C){let F=this.a.get(v);F||(F={counter:0,object:this.b(v,...C)},this.a.set(v,F));const{object:D}=F,M=(0,O.$fb)(()=>{--F.counter===0&&(this.c(v,F.object),this.a.delete(v))});return F.counter++,{object:D,dispose:M}}}e.$2c=o;class h{constructor(v){this.a=v}async acquire(v,...C){const F=this.a.acquire(v,...C);try{return{object:await F.object,dispose:()=>F.dispose()}}catch(D){throw F.dispose(),D}}}e.$3c=h;class g{constructor(v){this.object=v}dispose(){}}e.$4c=g;function R(S){const v=new s;try{S(v)}finally{v.dispose()}}class L{constructor(){this.a=new Map,this.b=!1,$(this)}dispose(){u(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{f(this.a.values())}finally{this.a.clear()}}has(v){return this.a.has(v)}get size(){return this.a.size}get(v){return this.a.get(v)}set(v,C,F=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),F||this.a.get(v)?.dispose(),this.a.set(v,C)}deleteAndDispose(v){this.a.get(v)?.dispose(),this.a.delete(v)}deleteAndLeak(v){const C=this.a.get(v);return this.a.delete(v),C}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$6c=L}),define(ce[65],le([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MarshalledId=void 0;var P;(function(c){c[c.Uri=1]="Uri",c[c.Regexp=2]="Regexp",c[c.ScmResource=3]="ScmResource",c[c.ScmResourceGroup=4]="ScmResourceGroup",c[c.ScmProvider=5]="ScmProvider",c[c.CommentController=6]="CommentController",c[c.CommentThread=7]="CommentThread",c[c.CommentThreadInstance=8]="CommentThreadInstance",c[c.CommentThreadReply=9]="CommentThreadReply",c[c.CommentNode=10]="CommentNode",c[c.CommentThreadNode=11]="CommentThreadNode",c[c.TimelineActionContext=12]="TimelineActionContext",c[c.NotebookCellActionContext=13]="NotebookCellActionContext",c[c.NotebookActionContext=14]="NotebookActionContext",c[c.TerminalContext=15]="TerminalContext",c[c.TestItemContext=16]="TestItemContext",c[c.Date=17]="Date",c[c.TestMessageMenuArgs=18]="TestMessageMenuArgs"})(P||(e.MarshalledId=P={}))}),define(ce[91],le([0,1,35]),function(ne,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$om=void 0,e.$mm=N,e.$nm=T;const c=new P.$Fc(1e4);function N(w){return A(w,"NFC",c)}const O=new P.$Fc(1e4);function T(w){return A(w,"NFD",O)}const k=/[^\u0000-\u0080]/;function A(w,E,$){if(!w)return w;const u=$.get(w);if(u)return u;let p;return k.test(w)?p=w.normalize(E):p=w,$.set(w,p),p}e.$om=function(){const w=/[\u0300-\u036f]/g;return function(E){return T(E).replace(w,"")}}()}),function(){function ne(N){const O=[];typeof N=="number"&&O.push("code/timeOrigin",N);function T(A){O.push(A,Date.now())}function k(){const A=[];for(let w=0;w<O.length;w+=2)A.push({name:O[w],startTime:O[w+1]});return A}return{mark:T,getMarks:k}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?ne():{mark(N){performance.mark(N)},getMarks(){let N=performance.timeOrigin;typeof N!="number"&&(N=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const O=[{name:"code/timeOrigin",startTime:Math.round(N)}];for(const T of performance.getEntriesByType("mark"))O.push({name:T.name,startTime:Math.round(N+T.startTime)});return O}};if(typeof process=="object"){const N=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return ne(N)}else return console.trace("perf-util loaded in UNKNOWN environment"),ne()}function P(N){return N.MonacoPerformanceMarks||(N.MonacoPerformanceMarks=e()),N.MonacoPerformanceMarks}var c;typeof global=="object"?c=global:typeof self=="object"?c=self:c={},typeof define=="function"?define("vs/base/common/performance",[],function(){return P(c)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=P(c):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),c.perf=P(c))}(),function(ne,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var P=e();for(var c in P)(typeof exports=="object"?exports:ne)[c]=P[c]}}(typeof self<"u"?self:this,function(){return function(ne){var e={};function P(c){if(e[c])return e[c].exports;var N=e[c]={i:c,l:!1,exports:{}};return ne[c].call(N.exports,N,N.exports,P),N.l=!0,N.exports}return P.m=ne,P.c=e,P.d=function(c,N,O){P.o(c,N)||Object.defineProperty(c,N,{enumerable:!0,get:O})},P.r=function(c){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(c,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(c,"__esModule",{value:!0})},P.t=function(c,N){if(1&N&&(c=P(c)),8&N||4&N&&typeof c=="object"&&c&&c.__esModule)return c;var O=Object.create(null);if(P.r(O),Object.defineProperty(O,"default",{enumerable:!0,value:c}),2&N&&typeof c!="string")for(var T in c)P.d(O,T,function(k){return c[k]}.bind(null,T));return O},P.n=function(c){var N=c&&c.__esModule?function(){return c.default}:function(){return c};return P.d(N,"a",N),N},P.o=function(c,N){return Object.prototype.hasOwnProperty.call(c,N)},P.p="",P(P.s=0)}([function(ne,e,P){(function(c){var N;e=ne.exports=Z,N=typeof c=="object"&&c.env&&c.env.NODE_DEBUG&&/\bsemver\b/i.test(c.env.NODE_DEBUG)?function(){var oe=Array.prototype.slice.call(arguments,0);oe.unshift("SEMVER"),console.log.apply(console,oe)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var O=256,T=Number.MAX_SAFE_INTEGER||9007199254740991,k=e.re=[],A=e.src=[],w=0,E=w++;A[E]="0|[1-9]\\d*";var $=w++;A[$]="[0-9]+";var u=w++;A[u]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var p=w++;A[p]="("+A[E]+")\\.("+A[E]+")\\.("+A[E]+")";var l=w++;A[l]="("+A[$]+")\\.("+A[$]+")\\.("+A[$]+")";var d=w++;A[d]="(?:"+A[E]+"|"+A[u]+")";var y=w++;A[y]="(?:"+A[$]+"|"+A[u]+")";var f=w++;A[f]="(?:-("+A[d]+"(?:\\."+A[d]+")*))";var b=w++;A[b]="(?:-?("+A[y]+"(?:\\."+A[y]+")*))";var I=w++;A[I]="[0-9A-Za-z-]+";var m=w++;A[m]="(?:\\+("+A[I]+"(?:\\."+A[I]+")*))";var s=w++,r="v?"+A[p]+A[f]+"?"+A[m]+"?";A[s]="^"+r+"$";var i="[v=\\s]*"+A[l]+A[b]+"?"+A[m]+"?",a=w++;A[a]="^"+i+"$";var t=w++;A[t]="((?:<|>)?=?)";var n=w++;A[n]=A[$]+"|x|X|\\*";var o=w++;A[o]=A[E]+"|x|X|\\*";var h=w++;A[h]="[v=\\s]*("+A[o]+")(?:\\.("+A[o]+")(?:\\.("+A[o]+")(?:"+A[f]+")?"+A[m]+"?)?)?";var g=w++;A[g]="[v=\\s]*("+A[n]+")(?:\\.("+A[n]+")(?:\\.("+A[n]+")(?:"+A[b]+")?"+A[m]+"?)?)?";var R=w++;A[R]="^"+A[t]+"\\s*"+A[h]+"$";var L=w++;A[L]="^"+A[t]+"\\s*"+A[g]+"$";var S=w++;A[S]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var v=w++;A[v]="(?:~>?)";var C=w++;A[C]="(\\s*)"+A[v]+"\\s+",k[C]=new RegExp(A[C],"g");var F=w++;A[F]="^"+A[v]+A[h]+"$";var D=w++;A[D]="^"+A[v]+A[g]+"$";var M=w++;A[M]="(?:\\^)";var J=w++;A[J]="(\\s*)"+A[M]+"\\s+",k[J]=new RegExp(A[J],"g");var H=w++;A[H]="^"+A[M]+A[h]+"$";var x=w++;A[x]="^"+A[M]+A[g]+"$";var K=w++;A[K]="^"+A[t]+"\\s*("+i+")$|^$";var ie=w++;A[ie]="^"+A[t]+"\\s*("+r+")$|^$";var V=w++;A[V]="(\\s*)"+A[t]+"\\s*("+i+"|"+A[h]+")",k[V]=new RegExp(A[V],"g");var z=w++;A[z]="^\\s*("+A[h]+")\\s+-\\s+("+A[h]+")\\s*$";var ee=w++;A[ee]="^\\s*("+A[g]+")\\s+-\\s+("+A[g]+")\\s*$";var se=w++;A[se]="(<|>)?=?\\s*\\*";for(var he=0;he<35;he++)N(he,A[he]),k[he]||(k[he]=new RegExp(A[he]));function q(oe,de){if(oe instanceof Z)return oe;if(typeof oe!="string"||oe.length>O||!(de?k[a]:k[s]).test(oe))return null;try{return new Z(oe,de)}catch{return null}}function Z(oe,de){if(oe instanceof Z){if(oe.loose===de)return oe;oe=oe.version}else if(typeof oe!="string")throw new TypeError("Invalid Version: "+oe);if(oe.length>O)throw new TypeError("version is longer than "+O+" characters");if(!(this instanceof Z))return new Z(oe,de);N("SemVer",oe,de),this.loose=de;var me=oe.trim().match(de?k[a]:k[s]);if(!me)throw new TypeError("Invalid Version: "+oe);if(this.raw=oe,this.major=+me[1],this.minor=+me[2],this.patch=+me[3],this.major>T||this.major<0)throw new TypeError("Invalid major version");if(this.minor>T||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>T||this.patch<0)throw new TypeError("Invalid patch version");me[4]?this.prerelease=me[4].split(".").map(function(Pe){if(/^[0-9]+$/.test(Pe)){var ke=+Pe;if(ke>=0&&ke<T)return ke}return Pe}):this.prerelease=[],this.build=me[5]?me[5].split("."):[],this.format()}e.parse=q,e.valid=function(oe,de){var me=q(oe,de);return me?me.version:null},e.clean=function(oe,de){var me=q(oe.trim().replace(/^[=v]+/,""),de);return me?me.version:null},e.SemVer=Z,Z.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},Z.prototype.toString=function(){return this.version},Z.prototype.compare=function(oe){return N("SemVer.compare",this.version,this.loose,oe),oe instanceof Z||(oe=new Z(oe,this.loose)),this.compareMain(oe)||this.comparePre(oe)},Z.prototype.compareMain=function(oe){return oe instanceof Z||(oe=new Z(oe,this.loose)),G(this.major,oe.major)||G(this.minor,oe.minor)||G(this.patch,oe.patch)},Z.prototype.comparePre=function(oe){if(oe instanceof Z||(oe=new Z(oe,this.loose)),this.prerelease.length&&!oe.prerelease.length)return-1;if(!this.prerelease.length&&oe.prerelease.length)return 1;if(!this.prerelease.length&&!oe.prerelease.length)return 0;var de=0;do{var me=this.prerelease[de],Pe=oe.prerelease[de];if(N("prerelease compare",de,me,Pe),me===void 0&&Pe===void 0)return 0;if(Pe===void 0)return 1;if(me===void 0)return-1;if(me!==Pe)return G(me,Pe)}while(++de)},Z.prototype.inc=function(oe,de){switch(oe){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",de);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",de);break;case"prepatch":this.prerelease.length=0,this.inc("patch",de),this.inc("pre",de);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",de),this.inc("pre",de);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var me=this.prerelease.length;--me>=0;)typeof this.prerelease[me]=="number"&&(this.prerelease[me]++,me=-2);me===-1&&this.prerelease.push(0)}de&&(this.prerelease[0]===de?isNaN(this.prerelease[1])&&(this.prerelease=[de,0]):this.prerelease=[de,0]);break;default:throw new Error("invalid increment argument: "+oe)}return this.format(),this.raw=this.version,this},e.inc=function(oe,de,me,Pe){typeof me=="string"&&(Pe=me,me=void 0);try{return new Z(oe,me).inc(de,Pe).version}catch{return null}},e.diff=function(oe,de){if(W(oe,de))return null;var me=q(oe),Pe=q(de);if(me.prerelease.length||Pe.prerelease.length){for(var ke in me)if((ke==="major"||ke==="minor"||ke==="patch")&&me[ke]!==Pe[ke])return"pre"+ke;return"prerelease"}for(var ke in me)if((ke==="major"||ke==="minor"||ke==="patch")&&me[ke]!==Pe[ke])return ke},e.compareIdentifiers=G;var X=/^[0-9]+$/;function G(oe,de){var me=X.test(oe),Pe=X.test(de);return me&&Pe&&(oe=+oe,de=+de),me&&!Pe?-1:Pe&&!me?1:oe<de?-1:oe>de?1:0}function U(oe,de,me){return new Z(oe,me).compare(new Z(de,me))}function B(oe,de,me){return U(oe,de,me)>0}function j(oe,de,me){return U(oe,de,me)<0}function W(oe,de,me){return U(oe,de,me)===0}function te(oe,de,me){return U(oe,de,me)!==0}function _(oe,de,me){return U(oe,de,me)>=0}function Q(oe,de,me){return U(oe,de,me)<=0}function ae(oe,de,me,Pe){var ke;switch(de){case"===":typeof oe=="object"&&(oe=oe.version),typeof me=="object"&&(me=me.version),ke=oe===me;break;case"!==":typeof oe=="object"&&(oe=oe.version),typeof me=="object"&&(me=me.version),ke=oe!==me;break;case"":case"=":case"==":ke=W(oe,me,Pe);break;case"!=":ke=te(oe,me,Pe);break;case">":ke=B(oe,me,Pe);break;case">=":ke=_(oe,me,Pe);break;case"<":ke=j(oe,me,Pe);break;case"<=":ke=Q(oe,me,Pe);break;default:throw new TypeError("Invalid operator: "+de)}return ke}function ue(oe,de){if(oe instanceof ue){if(oe.loose===de)return oe;oe=oe.value}if(!(this instanceof ue))return new ue(oe,de);N("comparator",oe,de),this.loose=de,this.parse(oe),this.semver===ge?this.value="":this.value=this.operator+this.semver.version,N("comp",this)}e.rcompareIdentifiers=function(oe,de){return G(de,oe)},e.major=function(oe,de){return new Z(oe,de).major},e.minor=function(oe,de){return new Z(oe,de).minor},e.patch=function(oe,de){return new Z(oe,de).patch},e.compare=U,e.compareLoose=function(oe,de){return U(oe,de,!0)},e.rcompare=function(oe,de,me){return U(de,oe,me)},e.sort=function(oe,de){return oe.sort(function(me,Pe){return e.compare(me,Pe,de)})},e.rsort=function(oe,de){return oe.sort(function(me,Pe){return e.rcompare(me,Pe,de)})},e.gt=B,e.lt=j,e.eq=W,e.neq=te,e.gte=_,e.lte=Q,e.cmp=ae,e.Comparator=ue;var ge={};function we(oe,de){if(oe instanceof we)return oe.loose===de?oe:new we(oe.raw,de);if(oe instanceof ue)return new we(oe.value,de);if(!(this instanceof we))return new we(oe,de);if(this.loose=de,this.raw=oe,this.set=oe.split(/\s*\|\|\s*/).map(function(me){return this.parseRange(me.trim())},this).filter(function(me){return me.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+oe);this.format()}function Ee(oe){return!oe||oe.toLowerCase()==="x"||oe==="*"}function pe(oe,de,me,Pe,ke,Fe,Te,Le,Ue,qe,He,Me,Be){return((de=Ee(me)?"":Ee(Pe)?">="+me+".0.0":Ee(ke)?">="+me+"."+Pe+".0":">="+de)+" "+(Le=Ee(Ue)?"":Ee(qe)?"<"+(+Ue+1)+".0.0":Ee(He)?"<"+Ue+"."+(+qe+1)+".0":Me?"<="+Ue+"."+qe+"."+He+"-"+Me:"<="+Le)).trim()}function be(oe,de){for(var me=0;me<oe.length;me++)if(!oe[me].test(de))return!1;if(de.prerelease.length){for(me=0;me<oe.length;me++)if(N(oe[me].semver),oe[me].semver!==ge&&oe[me].semver.prerelease.length>0){var Pe=oe[me].semver;if(Pe.major===de.major&&Pe.minor===de.minor&&Pe.patch===de.patch)return!0}return!1}return!0}function Se(oe,de,me){try{de=new we(de,me)}catch{return!1}return de.test(oe)}function Ie(oe,de,me,Pe){var ke,Fe,Te,Le,Ue;switch(oe=new Z(oe,Pe),de=new we(de,Pe),me){case">":ke=B,Fe=Q,Te=j,Le=">",Ue=">=";break;case"<":ke=j,Fe=_,Te=B,Le="<",Ue="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Se(oe,de,Pe))return!1;for(var qe=0;qe<de.set.length;++qe){var He=de.set[qe],Me=null,Be=null;if(He.forEach(function(ze){ze.semver===ge&&(ze=new ue(">=0.0.0")),Me=Me||ze,Be=Be||ze,ke(ze.semver,Me.semver,Pe)?Me=ze:Te(ze.semver,Be.semver,Pe)&&(Be=ze)}),Me.operator===Le||Me.operator===Ue||(!Be.operator||Be.operator===Le)&&Fe(oe,Be.semver)||Be.operator===Ue&&Te(oe,Be.semver))return!1}return!0}ue.prototype.parse=function(oe){var de=this.loose?k[K]:k[ie],me=oe.match(de);if(!me)throw new TypeError("Invalid comparator: "+oe);this.operator=me[1],this.operator==="="&&(this.operator=""),me[2]?this.semver=new Z(me[2],this.loose):this.semver=ge},ue.prototype.toString=function(){return this.value},ue.prototype.test=function(oe){return N("Comparator.test",oe,this.loose),this.semver===ge||(typeof oe=="string"&&(oe=new Z(oe,this.loose)),ae(oe,this.operator,this.semver,this.loose))},ue.prototype.intersects=function(oe,de){if(!(oe instanceof ue))throw new TypeError("a Comparator is required");var me;if(this.operator==="")return me=new we(oe.value,de),Se(this.value,me,de);if(oe.operator==="")return me=new we(this.value,de),Se(oe.semver,me,de);var Pe=!(this.operator!==">="&&this.operator!==">"||oe.operator!==">="&&oe.operator!==">"),ke=!(this.operator!=="<="&&this.operator!=="<"||oe.operator!=="<="&&oe.operator!=="<"),Fe=this.semver.version===oe.semver.version,Te=!(this.operator!==">="&&this.operator!=="<="||oe.operator!==">="&&oe.operator!=="<="),Le=ae(this.semver,"<",oe.semver,de)&&(this.operator===">="||this.operator===">")&&(oe.operator==="<="||oe.operator==="<"),Ue=ae(this.semver,">",oe.semver,de)&&(this.operator==="<="||this.operator==="<")&&(oe.operator===">="||oe.operator===">");return Pe||ke||Fe&&Te||Le||Ue},e.Range=we,we.prototype.format=function(){return this.range=this.set.map(function(oe){return oe.join(" ").trim()}).join("||").trim(),this.range},we.prototype.toString=function(){return this.range},we.prototype.parseRange=function(oe){var de=this.loose;oe=oe.trim(),N("range",oe,de);var me=de?k[ee]:k[z];oe=oe.replace(me,pe),N("hyphen replace",oe),oe=oe.replace(k[V],"$1$2$3"),N("comparator trim",oe,k[V]),oe=(oe=(oe=oe.replace(k[C],"$1~")).replace(k[J],"$1^")).split(/\s+/).join(" ");var Pe=de?k[K]:k[ie],ke=oe.split(" ").map(function(Fe){return function(Te,Le){return N("comp",Te),Te=function(Ue,qe){return Ue.trim().split(/\s+/).map(function(He){return function(Me,Be){N("caret",Me,Be);var ze=Be?k[x]:k[H];return Me.replace(ze,function(We,Ne,re,fe,$e){var ye;return N("caret",Me,We,Ne,re,fe,$e),Ee(Ne)?ye="":Ee(re)?ye=">="+Ne+".0.0 <"+(+Ne+1)+".0.0":Ee(fe)?ye=Ne==="0"?">="+Ne+"."+re+".0 <"+Ne+"."+(+re+1)+".0":">="+Ne+"."+re+".0 <"+(+Ne+1)+".0.0":$e?(N("replaceCaret pr",$e),$e.charAt(0)!=="-"&&($e="-"+$e),ye=Ne==="0"?re==="0"?">="+Ne+"."+re+"."+fe+$e+" <"+Ne+"."+re+"."+(+fe+1):">="+Ne+"."+re+"."+fe+$e+" <"+Ne+"."+(+re+1)+".0":">="+Ne+"."+re+"."+fe+$e+" <"+(+Ne+1)+".0.0"):(N("no pr"),ye=Ne==="0"?re==="0"?">="+Ne+"."+re+"."+fe+" <"+Ne+"."+re+"."+(+fe+1):">="+Ne+"."+re+"."+fe+" <"+Ne+"."+(+re+1)+".0":">="+Ne+"."+re+"."+fe+" <"+(+Ne+1)+".0.0"),N("caret return",ye),ye})}(He,qe)}).join(" ")}(Te,Le),N("caret",Te),Te=function(Ue,qe){return Ue.trim().split(/\s+/).map(function(He){return function(Me,Be){var ze=Be?k[D]:k[F];return Me.replace(ze,function(We,Ne,re,fe,$e){var ye;return N("tilde",Me,We,Ne,re,fe,$e),Ee(Ne)?ye="":Ee(re)?ye=">="+Ne+".0.0 <"+(+Ne+1)+".0.0":Ee(fe)?ye=">="+Ne+"."+re+".0 <"+Ne+"."+(+re+1)+".0":$e?(N("replaceTilde pr",$e),$e.charAt(0)!=="-"&&($e="-"+$e),ye=">="+Ne+"."+re+"."+fe+$e+" <"+Ne+"."+(+re+1)+".0"):ye=">="+Ne+"."+re+"."+fe+" <"+Ne+"."+(+re+1)+".0",N("tilde return",ye),ye})}(He,qe)}).join(" ")}(Te,Le),N("tildes",Te),Te=function(Ue,qe){return N("replaceXRanges",Ue,qe),Ue.split(/\s+/).map(function(He){return function(Me,Be){Me=Me.trim();var ze=Be?k[L]:k[R];return Me.replace(ze,function(We,Ne,re,fe,$e,ye){N("xRange",Me,We,Ne,re,fe,$e,ye);var Ae=Ee(re),Ce=Ae||Ee(fe),je=Ce||Ee($e);return Ne==="="&&je&&(Ne=""),Ae?We=Ne===">"||Ne==="<"?"<0.0.0":"*":Ne&&je?(Ce&&(fe=0),je&&($e=0),Ne===">"?(Ne=">=",Ce?(re=+re+1,fe=0,$e=0):je&&(fe=+fe+1,$e=0)):Ne==="<="&&(Ne="<",Ce?re=+re+1:fe=+fe+1),We=Ne+re+"."+fe+"."+$e):Ce?We=">="+re+".0.0 <"+(+re+1)+".0.0":je&&(We=">="+re+"."+fe+".0 <"+re+"."+(+fe+1)+".0"),N("xRange return",We),We})}(He,qe)}).join(" ")}(Te,Le),N("xrange",Te),Te=function(Ue,qe){return N("replaceStars",Ue,qe),Ue.trim().replace(k[se],"")}(Te,Le),N("stars",Te),Te}(Fe,de)}).join(" ").split(/\s+/);return this.loose&&(ke=ke.filter(function(Fe){return!!Fe.match(Pe)})),ke=ke.map(function(Fe){return new ue(Fe,de)})},we.prototype.intersects=function(oe,de){if(!(oe instanceof we))throw new TypeError("a Range is required");return this.set.some(function(me){return me.every(function(Pe){return oe.set.some(function(ke){return ke.every(function(Fe){return Pe.intersects(Fe,de)})})})})},e.toComparators=function(oe,de){return new we(oe,de).set.map(function(me){return me.map(function(Pe){return Pe.value}).join(" ").trim().split(" ")})},we.prototype.test=function(oe){if(!oe)return!1;typeof oe=="string"&&(oe=new Z(oe,this.loose));for(var de=0;de<this.set.length;de++)if(be(this.set[de],oe))return!0;return!1},e.satisfies=Se,e.maxSatisfying=function(oe,de,me){var Pe=null,ke=null;try{var Fe=new we(de,me)}catch{return null}return oe.forEach(function(Te){Fe.test(Te)&&(Pe&&ke.compare(Te)!==-1||(ke=new Z(Pe=Te,me)))}),Pe},e.minSatisfying=function(oe,de,me){var Pe=null,ke=null;try{var Fe=new we(de,me)}catch{return null}return oe.forEach(function(Te){Fe.test(Te)&&(Pe&&ke.compare(Te)!==1||(ke=new Z(Pe=Te,me)))}),Pe},e.validRange=function(oe,de){try{return new we(oe,de).range||"*"}catch{return null}},e.ltr=function(oe,de,me){return Ie(oe,de,"<",me)},e.gtr=function(oe,de,me){return Ie(oe,de,">",me)},e.outside=Ie,e.prerelease=function(oe,de){var me=q(oe,de);return me&&me.prerelease.length?me.prerelease:null},e.intersects=function(oe,de,me){return oe=new we(oe,me),de=new we(de,me),oe.intersects(de)},e.coerce=function(oe){if(oe instanceof Z)return oe;if(typeof oe!="string")return null;var de=oe.match(k[S]);return de==null?null:q((de[1]||"0")+"."+(de[2]||"0")+"."+(de[3]||"0"))}}).call(this,P(1))},function(ne,e){var P,c,N=ne.exports={};function O(){throw new Error("setTimeout has not been defined")}function T(){throw new Error("clearTimeout has not been defined")}function k(y){if(P===setTimeout)return setTimeout(y,0);if((P===O||!P)&&setTimeout)return P=setTimeout,setTimeout(y,0);try{return P(y,0)}catch{try{return P.call(null,y,0)}catch{return P.call(this,y,0)}}}(function(){try{P=typeof setTimeout=="function"?setTimeout:O}catch{P=O}try{c=typeof clearTimeout=="function"?clearTimeout:T}catch{c=T}})();var A,w=[],E=!1,$=-1;function u(){E&&A&&(E=!1,A.length?w=A.concat(w):$=-1,w.length&&p())}function p(){if(!E){var y=k(u);E=!0;for(var f=w.length;f;){for(A=w,w=[];++$<f;)A&&A[$].run();$=-1,f=w.length}A=null,E=!1,function(b){if(c===clearTimeout)return clearTimeout(b);if((c===T||!c)&&clearTimeout)return c=clearTimeout,clearTimeout(b);try{c(b)}catch{try{return c.call(null,b)}catch{return c.call(this,b)}}}(y)}}function l(y,f){this.fun=y,this.array=f}function d(){}N.nextTick=function(y){var f=new Array(arguments.length-1);if(arguments.length>1)for(var b=1;b<arguments.length;b++)f[b-1]=arguments[b];w.push(new l(y,f)),w.length!==1||E||k(p)},l.prototype.run=function(){this.fun.apply(null,this.array)},N.title="browser",N.browser=!0,N.env={},N.argv=[],N.version="",N.versions={},N.on=d,N.addListener=d,N.once=d,N.off=d,N.removeListener=d,N.removeAllListeners=d,N.emit=d,N.prependListener=d,N.prependOnceListener=d,N.listeners=function(y){return[]},N.binding=function(y){throw new Error("process.binding is not supported")},N.cwd=function(){return"/"},N.chdir=function(y){throw new Error("process.chdir is not supported")},N.umask=function(){return 0}}])}),define(ce[133],le([0,1]),function(ne,e){"use strict";var P;Object.defineProperty(e,"__esModule",{value:!0}),e.$Ms=void 0;class c{constructor(k,A,w){this.level=k,this.key=A,this.value=w,this.forward=[]}}const N=void 0;class O{constructor(k,A=2**16){this.comparator=k,this[P]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(A)|0),this.e=new c(this.c,N,N)}get size(){return this.f}clear(){this.e=new c(this.c,N,N),this.f=0}has(k){return!!O.g(this,k,this.comparator)}get(k){return O.g(this,k,this.comparator)?.value}set(k,A){return O.h(this,k,A,this.comparator)&&(this.f+=1),this}delete(k){const A=O.k(this,k,this.comparator);return A&&(this.f-=1),A}forEach(k,A){let w=this.e.forward[0];for(;w;)k.call(A,w.value,w.key,this),w=w.forward[0]}[(P=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let k=this.e.forward[0];for(;k;)yield[k.key,k.value],k=k.forward[0]}*keys(){let k=this.e.forward[0];for(;k;)yield k.key,k=k.forward[0]}*values(){let k=this.e.forward[0];for(;k;)yield k.value,k=k.forward[0]}toString(){let k="[SkipList]:",A=this.e.forward[0];for(;A;)k+=`node(${A.key}, ${A.value}, lvl:${A.level})`,A=A.forward[0];return k}static g(k,A,w){let E=k.e;for(let $=k.d-1;$>=0;$--)for(;E.forward[$]&&w(E.forward[$].key,A)<0;)E=E.forward[$];if(E=E.forward[0],E&&w(E.key,A)===0)return E}static h(k,A,w,E){const $=[];let u=k.e;for(let p=k.d-1;p>=0;p--){for(;u.forward[p]&&E(u.forward[p].key,A)<0;)u=u.forward[p];$[p]=u}if(u=u.forward[0],u&&E(u.key,A)===0)return u.value=w,!1;{const p=O.j(k);if(p>k.d){for(let l=k.d;l<p;l++)$[l]=k.e;k.d=p}u=new c(p,A,w);for(let l=0;l<p;l++)u.forward[l]=$[l].forward[l],$[l].forward[l]=u;return!0}}static j(k,A=.5){let w=1;for(;Math.random()<A&&w<k.c;)w+=1;return w}static k(k,A,w){const E=[];let $=k.e;for(let u=k.d-1;u>=0;u--){for(;$.forward[u]&&w($.forward[u].key,A)<0;)$=$.forward[u];E[u]=$}if($=$.forward[0],!$||w($.key,A)!==0)return!1;for(let u=0;u<k.d&&E[u].forward[u]===$;u++)E[u].forward[u]=$.forward[u];for(;k.d>0&&k.e.forward[k.d-1]===N;)k.d-=1;return!0}}e.$Ms=O}),define(ce[55],le([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ge=void 0;const P=globalThis.performance&&typeof globalThis.performance.now=="function";class c{static create(O){return new c(O)}constructor(O){this.c=P&&O===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$ge=c}),define(ce[3],le([0,1,8,89,2,90,55]),function(ne,e,P,c,N,O,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$we=e.$ve=e.$ue=e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$ie=e.Event=void 0,e.$je=p;const k=!1,A=!1,w=!1;var E;(function(D){D.None=()=>N.$Wc.None;function M(pe){if(w){const{onDidAddListener:be}=pe,Se=d.create();let Ie=0;pe.onDidAddListener=()=>{++Ie===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),Se.print()),be?.()}}}function J(pe,be){return q(pe,()=>{},0,void 0,!0,void 0,be)}D.defer=J;function H(pe){return(be,Se=null,Ie)=>{let oe=!1,de;return de=pe(me=>{if(!oe)return de?de.dispose():oe=!0,be.call(Se,me)},null,Ie),oe&&de.dispose(),de}}D.once=H;function x(pe,be,Se){return se((Ie,oe=null,de)=>pe(me=>Ie.call(oe,be(me)),null,de),Se)}D.map=x;function K(pe,be,Se){return se((Ie,oe=null,de)=>pe(me=>{be(me),Ie.call(oe,me)},null,de),Se)}D.forEach=K;function ie(pe,be,Se){return se((Ie,oe=null,de)=>pe(me=>be(me)&&Ie.call(oe,me),null,de),Se)}D.filter=ie;function V(pe){return pe}D.signal=V;function z(...pe){return(be,Se=null,Ie)=>{const oe=(0,N.$Tc)(...pe.map(de=>de(me=>be.call(Se,me))));return he(oe,Ie)}}D.any=z;function ee(pe,be,Se,Ie){let oe=Se;return x(pe,de=>(oe=be(oe,de),oe),Ie)}D.reduce=ee;function se(pe,be){let Se;const Ie={onWillAddFirstListener(){Se=pe(oe.fire,oe)},onDidRemoveLastListener(){Se?.dispose()}};be||M(Ie);const oe=new i(Ie);return be?.add(oe),oe.event}function he(pe,be){return be instanceof Array?be.push(pe):be&&be.add(pe),pe}function q(pe,be,Se=100,Ie=!1,oe=!1,de,me){let Pe,ke,Fe,Te=0,Le;const Ue={leakWarningThreshold:de,onWillAddFirstListener(){Pe=pe(He=>{Te++,ke=be(ke,He),Ie&&!Fe&&(qe.fire(ke),ke=void 0),Le=()=>{const Me=ke;ke=void 0,Fe=void 0,(!Ie||Te>1)&&qe.fire(Me),Te=0},typeof Se=="number"?(clearTimeout(Fe),Fe=setTimeout(Le,Se)):Fe===void 0&&(Fe=0,queueMicrotask(Le))})},onWillRemoveListener(){oe&&Te>0&&Le?.()},onDidRemoveLastListener(){Le=void 0,Pe.dispose()}};me||M(Ue);const qe=new i(Ue);return me?.add(qe),qe.event}D.debounce=q;function Z(pe,be=0,Se){return D.debounce(pe,(Ie,oe)=>Ie?(Ie.push(oe),Ie):[oe],be,void 0,!0,void 0,Se)}D.accumulate=Z;function X(pe,be=(Ie,oe)=>Ie===oe,Se){let Ie=!0,oe;return ie(pe,de=>{const me=Ie||!be(de,oe);return Ie=!1,oe=de,me},Se)}D.latch=X;function G(pe,be,Se){return[D.filter(pe,be,Se),D.filter(pe,Ie=>!be(Ie),Se)]}D.split=G;function U(pe,be=!1,Se=[],Ie){let oe=Se.slice(),de=pe(ke=>{oe?oe.push(ke):Pe.fire(ke)});Ie&&Ie.add(de);const me=()=>{oe?.forEach(ke=>Pe.fire(ke)),oe=null},Pe=new i({onWillAddFirstListener(){de||(de=pe(ke=>Pe.fire(ke)),Ie&&Ie.add(de))},onDidAddFirstListener(){oe&&(be?setTimeout(me):me())},onDidRemoveLastListener(){de&&de.dispose(),de=null}});return Ie&&Ie.add(Pe),Pe.event}D.buffer=U;function B(pe,be){return(Ie,oe,de)=>{const me=be(new W);return pe(function(Pe){const ke=me.evaluate(Pe);ke!==j&&Ie.call(oe,ke)},void 0,de)}}D.chain=B;const j=Symbol("HaltChainable");class W{constructor(){this.f=[]}map(be){return this.f.push(be),this}forEach(be){return this.f.push(Se=>(be(Se),Se)),this}filter(be){return this.f.push(Se=>be(Se)?Se:j),this}reduce(be,Se){let Ie=Se;return this.f.push(oe=>(Ie=be(Ie,oe),Ie)),this}latch(be=(Se,Ie)=>Se===Ie){let Se=!0,Ie;return this.f.push(oe=>{const de=Se||!be(oe,Ie);return Se=!1,Ie=oe,de?oe:j}),this}evaluate(be){for(const Se of this.f)if(be=Se(be),be===j)break;return be}}function te(pe,be,Se=Ie=>Ie){const Ie=(...Pe)=>me.fire(Se(...Pe)),oe=()=>pe.on(be,Ie),de=()=>pe.removeListener(be,Ie),me=new i({onWillAddFirstListener:oe,onDidRemoveLastListener:de});return me.event}D.fromNodeEventEmitter=te;function _(pe,be,Se=Ie=>Ie){const Ie=(...Pe)=>me.fire(Se(...Pe)),oe=()=>pe.addEventListener(be,Ie),de=()=>pe.removeEventListener(be,Ie),me=new i({onWillAddFirstListener:oe,onDidRemoveLastListener:de});return me.event}D.fromDOMEventEmitter=_;function Q(pe){return new Promise(be=>H(pe)(be))}D.toPromise=Q;function ae(pe){const be=new i;return pe.then(Se=>{be.fire(Se)},()=>{be.fire(void 0)}).finally(()=>{be.dispose()}),be.event}D.fromPromise=ae;function ue(pe,be,Se){return be(Se),pe(Ie=>be(Ie))}D.runAndSubscribe=ue;class ge{constructor(be,Se){this._observable=be,this.f=0,this.g=!1;const Ie={onWillAddFirstListener:()=>{be.addObserver(this)},onDidRemoveLastListener:()=>{be.removeObserver(this)}};Se||M(Ie),this.emitter=new i(Ie),Se&&Se.add(this.emitter)}beginUpdate(be){this.f++}handlePossibleChange(be){}handleChange(be,Se){this.g=!0}endUpdate(be){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function we(pe,be){return new ge(pe,be).emitter.event}D.fromObservable=we;function Ee(pe){return(be,Se,Ie)=>{let oe=0,de=!1;const me={beginUpdate(){oe++},endUpdate(){oe--,oe===0&&(pe.reportChanges(),de&&(de=!1,be.call(Se)))},handlePossibleChange(){},handleChange(){de=!0}};pe.addObserver(me),pe.reportChanges();const Pe={dispose(){pe.removeObserver(me)}};return Ie instanceof N.$Vc?Ie.add(Pe):Array.isArray(Ie)&&Ie.push(Pe),Pe}}D.fromObservableLight=Ee})(E||(e.Event=E={}));class ${static{this.all=new Set}static{this.f=0}constructor(M){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${M}_${$.f++}`,$.all.add(this)}start(M){this.g=new T.$ge,this.listenerCount=M}stop(){if(this.g){const M=this.g.elapsed();this.durations.push(M),this.elapsedOverall+=M,this.invocationCount+=1,this.g=void 0}}}e.$ie=$;let u=-1;function p(D){const M=u;return u=D,{dispose(){u=M}}}class l{static{this.f=1}constructor(M,J,H=(l.f++).toString(16).padStart(3,"0")){this.j=M,this.threshold=J,this.name=H,this.h=0}dispose(){this.g?.clear()}check(M,J){const H=this.threshold;if(H<=0||J<H)return;this.g||(this.g=new Map);const x=this.g.get(M.value)||0;if(this.g.set(M.value,x+1),this.h-=1,this.h<=0){this.h=H*.5;const[K,ie]=this.getMostFrequentStack(),V=`[${this.name}] potential listener LEAK detected, having ${J} listeners already. MOST frequent listener (${ie}):`;console.warn(V),console.warn(K);const z=new y(V,K);this.j(z)}return()=>{const K=this.g.get(M.value)||0;this.g.set(M.value,K-1)}}getMostFrequentStack(){if(!this.g)return;let M,J=0;for(const[H,x]of this.g)(!M||J<x)&&(M=[H,x],J=x);return M}}class d{static create(){const M=new Error;return new d(M.stack??"")}constructor(M){this.value=M}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class y extends Error{constructor(M,J){super(M),this.name="ListenerLeakError",this.stack=J}}e.$ke=y;class f extends Error{constructor(M,J){super(M),this.name="ListenerRefusalError",this.stack=J}}e.$le=f;let b=0;class I{constructor(M){this.value=M,this.id=b++}}const m=2,s=(D,M)=>{if(D instanceof I)M(D);else for(let J=0;J<D.length;J++){const H=D[J];H&&M(H)}};let r;if(k){const D=[];setInterval(()=>{D.length!==0&&(console.warn("[LEAKING LISTENERS] GC'ed these listeners that were NOT yet disposed:"),console.warn(D.join(`
`)),D.length=0)},3e3),r=new FinalizationRegistry(M=>{typeof M=="string"&&D.push(M)})}class i{constructor(M){this.z=0,this.f=M,this.g=u>0||this.f?.leakWarningThreshold?new l(M?.onListenerError??P.$3,this.f?.leakWarningThreshold??u):void 0,this.j=this.f?._profName?new $(this.f._profName):void 0,this.w=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.w?.current===this&&this.w.reset(),this.u){if(A){const M=this.u;queueMicrotask(()=>{s(M,J=>J.stack?.print())})}this.u=void 0,this.z=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(M,J,H)=>{if(this.g&&this.z>this.g.threshold**2){const z=`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far (${this.z} vs ${this.g.threshold})`;console.warn(z);const ee=this.g.getMostFrequentStack()??["UNKNOWN stack",-1],se=new f(`${z}. HINT: Stack shows most frequent listener (${ee[1]}-times)`,ee[0]);return(this.f?.onListenerError||P.$3)(se),N.$Wc.None}if(this.m)return N.$Wc.None;J&&(M=M.bind(J));const x=new I(M);let K,ie;this.g&&this.z>=Math.ceil(this.g.threshold*.2)&&(x.stack=d.create(),K=this.g.check(x.stack,this.z+1)),A&&(x.stack=ie??d.create()),this.u?this.u instanceof I?(this.w??=new t,this.u=[this.u,x]):this.u.push(x):(this.f?.onWillAddFirstListener?.(this),this.u=x,this.f?.onDidAddFirstListener?.(this)),this.z++;const V=(0,N.$Uc)(()=>{r?.unregister(V),K?.(),this.A(x)});if(H instanceof N.$Vc?H.add(V):Array.isArray(H)&&H.push(V),r){const z=new Error().stack.split(`
`).slice(2,3).join(`
`).trim(),ee=/(file:|vscode-file:\/\/vscode-app)?(\/[^:]*:\d+:\d+)/.exec(z);r.register(V,ee?.[2]??z,V)}return V},this.q}A(M){if(this.f?.onWillRemoveListener?.(this),!this.u)return;if(this.z===1){this.u=void 0,this.f?.onDidRemoveLastListener?.(this),this.z=0;return}const J=this.u,H=J.indexOf(M);if(H===-1)throw console.log("disposed?",this.m),console.log("size?",this.z),console.log("arr?",JSON.stringify(this.u)),new Error("Attempted to dispose unknown listener");this.z--,J[H]=void 0;const x=this.w.current===this;if(this.z*m<=J.length){let K=0;for(let ie=0;ie<J.length;ie++)J[ie]?J[K++]=J[ie]:x&&(this.w.end--,K<this.w.i&&this.w.i--);J.length=K}}B(M,J){if(!M)return;const H=this.f?.onListenerError||P.$3;if(!H){M.value(J);return}try{M.value(J)}catch(x){H(x)}}C(M){const J=M.current.u;for(;M.i<M.end;)this.B(J[M.i++],M.value);M.reset()}fire(M){if(this.w?.current&&(this.C(this.w),this.j?.stop()),this.j?.start(this.z),this.u)if(this.u instanceof I)this.B(this.u,M);else{const J=this.w;J.enqueue(this,M,this.u.length),this.C(J)}this.j?.stop()}hasListeners(){return this.z>0}}e.$me=i;const a=()=>new t;e.$ne=a;class t{constructor(){this.i=-1,this.end=0}enqueue(M,J,H){this.i=0,this.end=H,this.current=M,this.value=J}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class n extends i{async fireAsync(M,J,H){if(this.u)for(this.h||(this.h=new O.$7c),s(this.u,x=>this.h.push([x.value,M]));this.h.size>0&&!J.isCancellationRequested;){const[x,K]=this.h.shift(),ie=[],V={...K,token:J,waitUntil:z=>{if(Object.isFrozen(ie))throw new Error("waitUntil can NOT be called asynchronous");H&&(z=H(z,x)),ie.push(z)}};try{x(V)}catch(z){(0,P.$3)(z);continue}Object.freeze(ie),await Promise.allSettled(ie).then(z=>{for(const ee of z)ee.status==="rejected"&&(0,P.$3)(ee.reason)})}}}e.$oe=n;class o extends i{get isPaused(){return this.h!==0}constructor(M){super(M),this.h=0,this.s=new O.$7c,this.t=M?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.t){if(this.s.size>0){const M=Array.from(this.s);this.s.clear(),super.fire(this.t(M))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(M){this.z&&(this.h!==0?this.s.push(M):super.fire(M))}}e.$pe=o;class h extends o{constructor(M){super(M),this.k=M.delay??100}fire(M){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(M)}}e.$qe=h;class g extends i{constructor(M){super(M),this.h=[],this.k=M?.merge}fire(M){this.hasListeners()&&(this.h.push(M),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(J=>super.fire(J)),this.h=[]}))}}e.$re=g;class R{constructor(){this.g=!1,this.h=[],this.f=new i({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(M){const J={event:M,listener:null};this.h.push(J),this.g&&this.m(J);const H=()=>{this.g&&this.o(J);const x=this.h.indexOf(J);this.h.splice(x,1)};return(0,N.$Uc)((0,c.$fb)(H))}j(){this.g=!0,this.h.forEach(M=>this.m(M))}k(){this.g=!1,this.h.forEach(M=>this.o(M))}m(M){M.listener=M.event(J=>this.f.fire(J))}o(M){M.listener?.dispose(),M.listener=null}dispose(){this.f.dispose();for(const M of this.h)M.listener?.dispose();this.h=[]}}e.$se=R;class L{constructor(M,J,H,x){this.f=new N.$Vc;const K=this.f.add(new R),ie=this.f.add(new N.$6c);function V(z){ie.set(z,K.add(x(z)))}for(const z of M)V(z);this.f.add(J(z=>{V(z)})),this.f.add(H(z=>{ie.deleteAndDispose(z)})),this.event=K.event}dispose(){this.f.dispose()}}e.$te=L;class S{constructor(){this.f=[]}wrapEvent(M,J,H){return(x,K,ie)=>M(V=>{const z=this.f[this.f.length-1];if(!J){z?z.buffers.push(()=>x.call(K,V)):x.call(K,V);return}const ee=z;if(!ee){x.call(K,J(H,V));return}ee.items??=[],ee.items.push(V),ee.buffers.length===0&&z.buffers.push(()=>{ee.reducedResult??=H?ee.items.reduce(J,H):ee.items.reduce(J),x.call(K,ee.reducedResult)})},void 0,ie)}bufferEvents(M){const J={buffers:new Array};this.f.push(J);const H=M();return this.f.pop(),J.buffers.forEach(x=>x()),H}}e.$ue=S;class v{constructor(){this.f=!1,this.g=E.None,this.h=N.$Wc.None,this.j=new i({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(M){this.g=M,this.f&&(this.h.dispose(),this.h=M(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$ve=v;class C{static const(M){return new F(M)}constructor(M){this.g=M,this.f=new i,this.onDidChange=this.f.event}get value(){return this.g}set value(M){M!==this.g&&(this.g=M,this.f.fire(void 0))}}e.$we=C;class F{constructor(M){this.value=M,this.onDidChange=E.None}}}),define(ce[26],le([0,1,3]),function(ne,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xe=e.CancellationToken=void 0,e.$ye=k;const c=Object.freeze(function(A,w){const E=setTimeout(A.bind(w),0);return{dispose(){clearTimeout(E)}}});var N;(function(A){function w(E){return E===A.None||E===A.Cancelled||E instanceof O?!0:!E||typeof E!="object"?!1:typeof E.isCancellationRequested=="boolean"&&typeof E.onCancellationRequested=="function"}A.isCancellationToken=w,A.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:P.Event.None}),A.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:c})})(N||(e.CancellationToken=N={}));class O{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?c:(this.b||(this.b=new P.$me),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class T{constructor(w){this.f=void 0,this.g=void 0,this.g=w&&w.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new O),this.f}cancel(){this.f?this.f instanceof O&&this.f.cancel():this.f=N.Cancelled}dispose(w=!1){w&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof O&&this.f.dispose():this.f=N.None}}e.$xe=T;function k(A){const w=new T;return A.add({dispose(){w.cancel()}}),w.token}}),define(ce[134],le([0,1,26]),function(ne,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$af=e.$_e=e.$0e=void 0,e.$$e=N;class c{constructor(A){this.b=A,this.a=null}get(){if(this.a)return this.a;const A=new P.$xe,w=this.b(A.token);return this.a={promise:w,dispose:()=>{this.a=null,A.cancel(),A.dispose()}},this.a}}e.$0e=c;function N(k){return k}class O{constructor(A,w){this.a=void 0,this.b=void 0,typeof A=="function"?(this.c=A,this.d=N):(this.c=w,this.d=A.getCacheKey)}get(A){const w=this.d(A);return this.b!==w&&(this.b=w,this.a=this.c(A)),this.a}}e.$_e=O;class T{get cachedValues(){return this.a}constructor(A,w){this.a=new Map,this.b=new Map,typeof A=="function"?(this.c=A,this.d=N):(this.c=w,this.d=A.getCacheKey)}get(A){const w=this.d(A);if(this.b.has(w))return this.b.get(w);const E=this.c(A);return this.a.set(A,E),this.b.set(w,E),E}}e.$af=T}),define(ce[51],le([0,1,8,2]),function(ne,e,P,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ze=N,e.$Ae=O,e.$Be=T,e.$Ce=k,e.$De=w,e.$Ee=E,e.$Fe=$,e.$Ge=u,e.$He=p,e.$Ie=l,e.$Je=d,e.$Ke=y,e.$Le=f,e.$Me=b,e.$Ne=I;function N(m){const s=m;return s?typeof s.read=="function":!1}function O(m){const s=m;return s?[s.on,s.pause,s.resume,s.destroy].every(r=>typeof r=="function"):!1}function T(m){const s=m;return s?O(s.stream)&&Array.isArray(s.buffer)&&typeof s.ended=="boolean":!1}function k(m,s){return new A(m,s)}class A{constructor(s,r){this.e=s,this.f=r,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(s){if(!this.a.destroyed){if(this.a.flowing)this.g(s);else if(this.b.data.push(s),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(r=>this.d.push(r))}}error(s){this.a.destroyed||(this.a.flowing?this.h(s):this.b.error.push(s))}end(s){this.a.destroyed||(typeof s<"u"&&this.write(s),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(s){this.c.data.slice(0).forEach(r=>r(s))}h(s){this.c.error.length===0?(0,P.$3)(s):this.c.error.slice(0).forEach(r=>r(s))}i(){this.c.end.slice(0).forEach(s=>s())}on(s,r){if(!this.a.destroyed)switch(s){case"data":this.c.data.push(r),this.resume();break;case"end":this.c.end.push(r),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(r),this.a.flowing&&this.k();break}}removeListener(s,r){if(this.a.destroyed)return;let i;switch(s){case"data":i=this.c.data;break;case"end":i=this.c.end;break;case"error":i=this.c.error;break}if(i){const a=i.indexOf(r);a>=0&&i.splice(a,1)}}j(){if(this.b.data.length>0){const s=this.e(this.b.data);this.g(s),this.b.data.length=0;const r=[...this.d];this.d.length=0,r.forEach(i=>i())}}k(){if(this.c.error.length>0){for(const s of this.b.error)this.h(s);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function w(m,s){const r=[];let i;for(;(i=m.read())!==null;)r.push(i);return s(r)}function E(m,s,r){const i=[];let a;for(;(a=m.read())!==null&&i.length<r;)i.push(a);return a===null&&i.length>0?s(i):{read:()=>{if(i.length>0)return i.shift();if(typeof a<"u"){const t=a;return a=void 0,t}return m.read()}}}function $(m,s){return new Promise((r,i)=>{const a=[];u(m,{onData:t=>{s&&a.push(t)},onError:t=>{s?i(t):r(void 0)},onEnd:()=>{r(s?s(a):void 0)}})})}function u(m,s,r){m.on("error",i=>{r?.isCancellationRequested||s.onError(i)}),m.on("end",()=>{r?.isCancellationRequested||s.onEnd()}),m.on("data",i=>{r?.isCancellationRequested||s.onData(i)})}function p(m,s){return new Promise((r,i)=>{const a=new c.$Vc,t=[],n=g=>{if(t.push(g),t.length>s)return a.dispose(),m.pause(),r({stream:m,buffer:t,ended:!1})},o=g=>(a.dispose(),i(g)),h=()=>(a.dispose(),r({stream:m,buffer:t,ended:!0}));a.add((0,c.$Uc)(()=>m.removeListener("error",o))),m.on("error",o),a.add((0,c.$Uc)(()=>m.removeListener("end",h))),m.on("end",h),a.add((0,c.$Uc)(()=>m.removeListener("data",n))),m.on("data",n)})}function l(m,s){const r=k(s);return r.end(m),r}function d(){const m=k(()=>{throw new Error("not supported")});return m.end(),m}function y(m){let s=!1;return{read:()=>s?null:(s=!0,m)}}function f(m,s,r){const i=k(r);return u(m,{onData:a=>i.write(s.data(a)),onError:a=>i.error(s.error?s.error(a):a),onEnd:()=>i.end()}),i}function b(m,s,r){let i=!1;return{read:()=>{const a=s.read();return i?a:(i=!0,a!==null?r([m,a]):m)}}}function I(m,s,r){let i=!1;const a=k(r);return u(s,{onData:t=>i?a.write(t):(i=!0,a.write(r([m,t]))),onError:t=>a.error(t),onEnd:()=>{i||(i=!0,a.write(m)),a.end()}}),a}});var kt=this&&this.__createBinding||(Object.create?function(ne,e,P,c){c===void 0&&(c=P);var N=Object.getOwnPropertyDescriptor(e,P);(!N||("get"in N?!e.__esModule:N.writable||N.configurable))&&(N={enumerable:!0,get:function(){return e[P]}}),Object.defineProperty(ne,c,N)}:function(ne,e,P,c){c===void 0&&(c=P),ne[c]=e[P]}),At=this&&this.__setModuleDefault||(Object.create?function(ne,e){Object.defineProperty(ne,"default",{enumerable:!0,value:e})}:function(ne,e){ne.default=e}),Oe=this&&this.__importStar||function(ne){if(ne&&ne.__esModule)return ne;var e={};if(ne!=null)for(var P in ne)P!=="default"&&Object.prototype.hasOwnProperty.call(ne,P)&&kt(e,ne,P);return At(e,ne),e};define(ce[15],le([0,1,54,51]),function(ne,e,P,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oe=void 0,e.$Pe=w,e.$Qe=E,e.$Re=$,e.$Se=u,e.$Te=p,e.$Ue=l,e.$Ve=d,e.$We=y,e.$Xe=f,e.$Ye=b,e.$Ze=I,e.$1e=m,e.$2e=s,e.$3e=r,e.$4e=i,e.$5e=a,e.$6e=t,e.$7e=n,e.$8e=o,e.$9e=R,c=Oe(c);const N=typeof Buffer<"u",O=new P.$X(()=>new Uint8Array(256));let T,k;class A{static alloc(S){return N?new A(Buffer.allocUnsafe(S)):new A(new Uint8Array(S))}static wrap(S){return N&&!Buffer.isBuffer(S)&&(S=Buffer.from(S.buffer,S.byteOffset,S.byteLength)),new A(S)}static fromString(S,v){return!(v?.dontUseNodeBuffer||!1)&&N?new A(Buffer.from(S)):(T||(T=new TextEncoder),new A(T.encode(S)))}static fromByteArray(S){const v=A.alloc(S.length);for(let C=0,F=S.length;C<F;C++)v.buffer[C]=S[C];return v}static concat(S,v){if(typeof v>"u"){v=0;for(let D=0,M=S.length;D<M;D++)v+=S[D].byteLength}const C=A.alloc(v);let F=0;for(let D=0,M=S.length;D<M;D++){const J=S[D];C.set(J,F),F+=J.byteLength}return C}constructor(S){this.buffer=S,this.byteLength=this.buffer.byteLength}clone(){const S=A.alloc(this.byteLength);return S.set(this),S}toString(){return N?this.buffer.toString():(k||(k=new TextDecoder),k.decode(this.buffer))}slice(S,v){return new A(this.buffer.subarray(S,v))}set(S,v){if(S instanceof A)this.buffer.set(S.buffer,v);else if(S instanceof Uint8Array)this.buffer.set(S,v);else if(S instanceof ArrayBuffer)this.buffer.set(new Uint8Array(S),v);else if(ArrayBuffer.isView(S))this.buffer.set(new Uint8Array(S.buffer,S.byteOffset,S.byteLength),v);else throw new Error("Unknown argument 'array'")}readUInt32BE(S){return u(this.buffer,S)}writeUInt32BE(S,v){p(this.buffer,S,v)}readUInt32LE(S){return l(this.buffer,S)}writeUInt32LE(S,v){d(this.buffer,S,v)}readUInt8(S){return y(this.buffer,S)}writeUInt8(S,v){f(this.buffer,S,v)}indexOf(S,v=0){return w(this.buffer,S instanceof A?S.buffer:S,v)}}e.$Oe=A;function w(L,S,v=0){const C=S.byteLength,F=L.byteLength;if(C===0)return 0;if(C===1)return L.indexOf(S[0]);if(C>F-v)return-1;const D=O.value;D.fill(S.length);for(let x=0;x<S.length;x++)D[S[x]]=S.length-x-1;let M=v+S.length-1,J=M,H=-1;for(;M<F;)if(L[M]===S[J]){if(J===0){H=M;break}M--,J--}else M+=Math.max(S.length-J,D[L[M]]),J=S.length-1;return H}function E(L,S){return L[S+0]<<0>>>0|L[S+1]<<8>>>0}function $(L,S,v){L[v+0]=S&255,S=S>>>8,L[v+1]=S&255}function u(L,S){return L[S]*2**24+L[S+1]*2**16+L[S+2]*2**8+L[S+3]}function p(L,S,v){L[v+3]=S,S=S>>>8,L[v+2]=S,S=S>>>8,L[v+1]=S,S=S>>>8,L[v]=S}function l(L,S){return L[S+0]<<0>>>0|L[S+1]<<8>>>0|L[S+2]<<16>>>0|L[S+3]<<24>>>0}function d(L,S,v){L[v+0]=S&255,S=S>>>8,L[v+1]=S&255,S=S>>>8,L[v+2]=S&255,S=S>>>8,L[v+3]=S&255}function y(L,S){return L[S]}function f(L,S,v){L[v]=S}function b(L){return c.$De(L,S=>A.concat(S))}function I(L){return c.$Ke(L)}function m(L){return c.$Fe(L,S=>A.concat(S))}async function s(L){return L.ended?A.concat(L.buffer):A.concat([...L.buffer,await m(L.stream)])}function r(L){return c.$Ie(L,S=>A.concat(S))}function i(L){return c.$Le(L,{data:S=>typeof S=="string"?A.fromString(S):A.wrap(S)},S=>A.concat(S))}function a(L){return c.$Ce(S=>A.concat(S),L)}function t(L,S){return c.$Me(L,S,v=>A.concat(v))}function n(L,S){return c.$Ne(L,S,v=>A.concat(v))}function o(L){let S=0,v=0,C=0;const F=new Uint8Array(Math.floor(L.length/4*3)),D=J=>{switch(v){case 3:F[C++]=S|J,v=0;break;case 2:F[C++]=S|J>>>2,S=J<<6,v=3;break;case 1:F[C++]=S|J>>>4,S=J<<4,v=2;break;default:S=J<<2,v=1}};for(let J=0;J<L.length;J++){const H=L.charCodeAt(J);if(H>=65&&H<=90)D(H-65);else if(H>=97&&H<=122)D(H-97+26);else if(H>=48&&H<=57)D(H-48+52);else if(H===43||H===45)D(62);else if(H===47||H===95)D(63);else{if(H===61)break;throw new SyntaxError(`Unexpected base64 character ${L[J]}`)}}const M=C;for(;v>0;)D(0);return A.wrap(F).slice(0,M)}const h="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",g="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function R({buffer:L},S=!0,v=!1){const C=v?g:h;let F="";const D=L.byteLength%3;let M=0;for(;M<L.byteLength-D;M+=3){const J=L[M+0],H=L[M+1],x=L[M+2];F+=C[J>>>2],F+=C[(J<<4|H>>>4)&63],F+=C[(H<<2|x>>>6)&63],F+=C[x&63]}if(D===1){const J=L[M+0];F+=C[J>>>2],F+=C[J<<4&63],S&&(F+="==")}else if(D===2){const J=L[M+0],H=L[M+1];F+=C[J>>>2],F+=C[(J<<4|H>>>4)&63],F+=C[H<<2&63],S&&(F+="=")}return F}}),define(ce[135],le([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$he=void 0,e.$he=Symbol("MicrotaskDelay")}),define(ce[13],le([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fg=P,e.$gg=c,e.$hg=N,e.$ig=O,e.$jg=T,e.$kg=k,e.$lg=A,e.$mg=w,e.$ng=E,e.$og=$,e.$pg=u,e.$qg=p,e.$rg=l,e.$sg=y,e.$tg=f,e.$ug=b,e.$vg=I,e.$wg=m;function P(s){return typeof s=="string"}function c(s){return Array.isArray(s)&&s.every(r=>P(r))}function N(s){return typeof s=="object"&&s!==null&&!Array.isArray(s)&&!(s instanceof RegExp)&&!(s instanceof Date)}function O(s){const r=Object.getPrototypeOf(Uint8Array);return typeof s=="object"&&s instanceof r}function T(s){return typeof s=="number"&&!isNaN(s)}function k(s){return!!s&&typeof s[Symbol.iterator]=="function"}function A(s){return s===!0||s===!1}function w(s){return typeof s>"u"}function E(s){return!$(s)}function $(s){return w(s)||s===null}function u(s,r){if(!s)throw new Error(r?`Unexpected type, expected '${r}'`:"Unexpected type")}function p(s){if($(s))throw new Error("Assertion Failed: argument is undefined or null");return s}function l(...s){const r=[];for(let i=0;i<s.length;i++){const a=s[i];if($(a))throw new Error(`Assertion Failed: argument at index ${i} is undefined or null`);r.push(a)}return r}const d=Object.prototype.hasOwnProperty;function y(s){if(!N(s))return!1;for(const r in s)if(d.call(s,r))return!1;return!0}function f(s){return typeof s=="function"}function b(...s){return s.length>0&&s.every(f)}function I(s,r){const i=Math.min(s.length,r.length);for(let a=0;a<i;a++)m(s[a],r[a])}function m(s,r){if(P(r)){if(typeof s!==r)throw new Error(`argument does not match constraint: typeof ${r}`)}else if(f(r)){try{if(s instanceof r)return}catch{}if(!$(s)&&s.constructor===r||r.length===1&&r.call(void 0,s)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}}),define(ce[30],le([0,1,13]),function(ne,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bo=c,e.$co=N,e.$do=T,e.$eo=A,e.$fo=w,e.$go=E,e.$ho=$,e.$io=u,e.$jo=p,e.$ko=l,e.$lo=d,e.$mo=y,e.$no=f;function c(b){if(!b||typeof b!="object"||b instanceof RegExp)return b;const I=Array.isArray(b)?[]:{};return Object.entries(b).forEach(([m,s])=>{I[m]=s&&typeof s=="object"?c(s):s}),I}function N(b){if(!b||typeof b!="object")return b;const I=[b];for(;I.length>0;){const m=I.shift();Object.freeze(m);for(const s in m)if(O.call(m,s)){const r=m[s];typeof r=="object"&&!Object.isFrozen(r)&&!(0,P.$ig)(r)&&I.push(r)}}return b}const O=Object.prototype.hasOwnProperty;function T(b,I){return k(b,I,new Set)}function k(b,I,m){if((0,P.$og)(b))return b;const s=I(b);if(typeof s<"u")return s;if(Array.isArray(b)){const r=[];for(const i of b)r.push(k(i,I,m));return r}if((0,P.$hg)(b)){if(m.has(b))throw new Error("Cannot clone recursive data-structure");m.add(b);const r={};for(const i in b)O.call(b,i)&&(r[i]=k(b[i],I,m));return m.delete(b),r}return b}function A(b,I,m=!0){return(0,P.$hg)(b)?((0,P.$hg)(I)&&Object.keys(I).forEach(s=>{s in b?m&&((0,P.$hg)(b[s])&&(0,P.$hg)(I[s])?A(b[s],I[s],m):b[s]=I[s]):b[s]=I[s]}),b):I}function w(b,I){if(b===I)return!0;if(b==null||I===null||I===void 0||typeof b!=typeof I||typeof b!="object"||Array.isArray(b)!==Array.isArray(I))return!1;let m,s;if(Array.isArray(b)){if(b.length!==I.length)return!1;for(m=0;m<b.length;m++)if(!w(b[m],I[m]))return!1}else{const r=[];for(s in b)r.push(s);r.sort();const i=[];for(s in I)i.push(s);if(i.sort(),!w(r,i))return!1;for(m=0;m<r.length;m++)if(!w(b[r[m]],I[r[m]]))return!1}return!0}function E(b){const I=new Set;return JSON.stringify(b,(m,s)=>{if((0,P.$hg)(s)||Array.isArray(s)){if(I.has(s))return"[Circular]";I.add(s)}return typeof s=="bigint"?`[BigInt ${s.toString()}]`:s})}function $(b,I){const m=Object.create(null);return!b||!I||Object.keys(I).forEach(r=>{const i=b[r],a=I[r];w(i,a)||(m[r]=a)}),m}function u(b,I){const m=I.toLowerCase(),s=Object.keys(b).find(r=>r.toLowerCase()===m);return s?b[s]:b[I]}function p(b,I){const m=Object.create(null);for(const[s,r]of Object.entries(b))I(s,r)&&(m[s]=r);return m}function l(b){let I=[];for(;Object.prototype!==b;)I=I.concat(Object.getOwnPropertyNames(b)),b=Object.getPrototypeOf(b);return I}function d(b){const I=[];for(const m of l(b))typeof b[m]=="function"&&I.push(m);return I}function y(b,I){const m=r=>function(){const i=Array.prototype.slice.call(arguments,0);return I(r,i)},s={};for(const r of b)s[r]=m(r);return s}function f(b,I){const m={};for(const[s,r]of Object.entries(b))m[s]=I(r,s);return m}}),define(ce[136],le([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Constants=void 0,e.$bf=c,e.$cf=N;var P;(function(O){O[O.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",O[O.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",O[O.MAX_UINT_8=255]="MAX_UINT_8",O[O.MAX_UINT_16=65535]="MAX_UINT_16",O[O.MAX_UINT_32=4294967295]="MAX_UINT_32",O[O.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(P||(e.Constants=P={}));function c(O){return O<0?0:O>P.MAX_UINT_8?P.MAX_UINT_8:O|0}function N(O){return O<0?0:O>P.MAX_UINT_32?P.MAX_UINT_32:O|0}}),define(ce[27],le([0,1,134,39,54,136]),function(ne,e,P,c,N,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eg=e.$dg=e.$cg=e.GraphemeBreakType=e.$5f=e.$Wf=e.$Pf=e.$Of=void 0,e.$df=T,e.$ef=A,e.$ff=E,e.$gf=$,e.$hf=u,e.$if=p,e.$jf=l,e.$kf=d,e.$lf=y,e.$mf=f,e.$nf=b,e.$of=I,e.$pf=m,e.$qf=s,e.$rf=r,e.$sf=i,e.$tf=a,e.$uf=t,e.$vf=n,e.$wf=o,e.$xf=h,e.$yf=g,e.$zf=R,e.$Af=L,e.$Bf=S,e.$Cf=v,e.$Df=C,e.$Ef=F,e.$Ff=D,e.$Gf=M,e.$Hf=J,e.$If=H,e.$Jf=x,e.$Kf=K,e.$Lf=ie,e.$Mf=V,e.$Nf=z,e.$Qf=q,e.$Rf=Z,e.$Sf=X,e.$Tf=G,e.$Uf=j,e.$Vf=te,e.$Xf=_,e.$Yf=Q,e.$Zf=ae,e.$1f=ue,e.$2f=we,e.$3f=Ee,e.$4f=be,e.$6f=Se,e.$7f=Ie,e.$8f=oe,e.$9f=de,e.$0f=me,e.$$f=Pe,e.$_f=ke,e.$ag=Fe,e.$bg=He;function T(re){return!re||typeof re!="string"?!0:re.trim().length===0}const k=/{(\d+)}/g;function A(re,...fe){return fe.length===0?re:re.replace(k,function($e,ye){const Ae=parseInt(ye,10);return isNaN(Ae)||Ae<0||Ae>=fe.length?$e:fe[Ae]})}const w=/{([^}]+)}/g;function E(re,fe){return Object.keys(fe).length===0?re:re.replace(w,($e,ye)=>fe[ye]??$e)}function $(re){return re.replace(/[<>"'&]/g,fe=>{switch(fe){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return fe})}function u(re){return re.replace(/[<>&]/g,function(fe){switch(fe){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return fe}})}function p(re){return re.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}function l(re,fe){let $e=0,ye=re.indexOf(fe);for(;ye!==-1;)$e++,ye=re.indexOf(fe,ye+fe.length);return $e}function d(re,fe,$e="\u2026"){return re.length<=fe?re:`${re.substr(0,fe)}${$e}`}function y(re,fe,$e="\u2026"){if(re.length<=fe)return re;const ye=Math.ceil(fe/2)-$e.length/2,Ae=Math.floor(fe/2)-$e.length/2;return`${re.substr(0,ye)}${$e}${re.substr(re.length-Ae)}`}function f(re,fe=" "){const $e=b(re,fe);return I($e,fe)}function b(re,fe){if(!re||!fe)return re;const $e=fe.length;if($e===0||re.length===0)return re;let ye=0;for(;re.indexOf(fe,ye)===ye;)ye=ye+$e;return re.substring(ye)}function I(re,fe){if(!re||!fe)return re;const $e=fe.length,ye=re.length;if($e===0||ye===0)return re;let Ae=ye,Ce=-1;for(;Ce=re.lastIndexOf(fe,Ae-1),!(Ce===-1||Ce+$e!==Ae);){if(Ce===0)return"";Ae=Ce}return re.substring(0,Ae)}function m(re){return re.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}function s(re){return re.replace(/\*/g,"")}function r(re,fe,$e={}){if(!re)throw new Error("Cannot create regex from empty string");fe||(re=p(re)),$e.wholeWord&&(/\B/.test(re.charAt(0))||(re="\\b"+re),/\B/.test(re.charAt(re.length-1))||(re=re+"\\b"));let ye="";return $e.global&&(ye+="g"),$e.matchCase||(ye+="i"),$e.multiline&&(ye+="m"),$e.unicode&&(ye+="u"),new RegExp(re,ye)}function i(re){return re.source==="^"||re.source==="^$"||re.source==="$"||re.source==="^\\s*$"?!1:!!(re.exec("")&&re.lastIndex===0)}function a(re){return re.split(/\r\n|\r|\n/)}function t(re){const fe=[],$e=re.split(/(\r\n|\r|\n)/);for(let ye=0;ye<Math.ceil($e.length/2);ye++)fe.push($e[2*ye]+($e[2*ye+1]??""));return fe}function n(re){for(let fe=0,$e=re.length;fe<$e;fe++){const ye=re.charCodeAt(fe);if(ye!==c.CharCode.Space&&ye!==c.CharCode.Tab)return fe}return-1}function o(re,fe=0,$e=re.length){for(let ye=fe;ye<$e;ye++){const Ae=re.charCodeAt(ye);if(Ae!==c.CharCode.Space&&Ae!==c.CharCode.Tab)return re.substring(fe,ye)}return re.substring(fe,$e)}function h(re,fe=re.length-1){for(let $e=fe;$e>=0;$e--){const ye=re.charCodeAt($e);if(ye!==c.CharCode.Space&&ye!==c.CharCode.Tab)return $e}return-1}function g(re,fe,$e){const ye=[];let Ae=0;for(const Ce of re.matchAll(fe)){if(ye.push(re.slice(Ae,Ce.index)),Ce.index===void 0)throw new Error("match.index should be defined");Ae=Ce.index+Ce[0].length,ye.push($e(Ce[0],...Ce.slice(1),Ce.index,re,Ce.groups))}return ye.push(re.slice(Ae)),Promise.all(ye).then(Ce=>Ce.join(""))}function R(re,fe){return re<fe?-1:re>fe?1:0}function L(re,fe,$e=0,ye=re.length,Ae=0,Ce=fe.length){for(;$e<ye&&Ae<Ce;$e++,Ae++){const Je=re.charCodeAt($e),Qe=fe.charCodeAt(Ae);if(Je<Qe)return-1;if(Je>Qe)return 1}const je=ye-$e,xe=Ce-Ae;return je<xe?-1:je>xe?1:0}function S(re,fe){return v(re,fe,0,re.length,0,fe.length)}function v(re,fe,$e=0,ye=re.length,Ae=0,Ce=fe.length){for(;$e<ye&&Ae<Ce;$e++,Ae++){let Je=re.charCodeAt($e),Qe=fe.charCodeAt(Ae);if(Je===Qe)continue;if(Je>=128||Qe>=128)return L(re.toLowerCase(),fe.toLowerCase(),$e,ye,Ae,Ce);F(Je)&&(Je-=32),F(Qe)&&(Qe-=32);const Ve=Je-Qe;if(Ve!==0)return Ve}const je=ye-$e,xe=Ce-Ae;return je<xe?-1:je>xe?1:0}function C(re){return re>=c.CharCode.Digit0&&re<=c.CharCode.Digit9}function F(re){return re>=c.CharCode.a&&re<=c.CharCode.z}function D(re){return re>=c.CharCode.A&&re<=c.CharCode.Z}function M(re,fe){return re.length===fe.length&&v(re,fe)===0}function J(re,fe){const $e=fe.length;return fe.length>re.length?!1:v(re,fe,0,$e)===0}function H(re,fe){const $e=Math.min(re.length,fe.length);let ye;for(ye=0;ye<$e;ye++)if(re.charCodeAt(ye)!==fe.charCodeAt(ye))return ye;return $e}function x(re,fe){const $e=Math.min(re.length,fe.length);let ye;const Ae=re.length-1,Ce=fe.length-1;for(ye=0;ye<$e;ye++)if(re.charCodeAt(Ae-ye)!==fe.charCodeAt(Ce-ye))return ye;return $e}function K(re){return 55296<=re&&re<=56319}function ie(re){return 56320<=re&&re<=57343}function V(re,fe){return(re-55296<<10)+(fe-56320)+65536}function z(re,fe,$e){const ye=re.charCodeAt($e);if(K(ye)&&$e+1<fe){const Ae=re.charCodeAt($e+1);if(ie(Ae))return V(ye,Ae)}return ye}function ee(re,fe){const $e=re.charCodeAt(fe-1);if(ie($e)&&fe>1){const ye=re.charCodeAt(fe-2);if(K(ye))return V(ye,$e)}return $e}class se{get offset(){return this.e}constructor(fe,$e=0){this.c=fe,this.d=fe.length,this.e=$e}setOffset(fe){this.e=fe}prevCodePoint(){const fe=ee(this.c,this.e);return this.e-=fe>=O.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,fe}nextCodePoint(){const fe=z(this.c,this.d,this.e);return this.e+=fe>=O.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,fe}eol(){return this.e>=this.d}}e.$Of=se;class he{get offset(){return this.c.offset}constructor(fe,$e=0){this.c=new se(fe,$e)}nextGraphemeLength(){const fe=Ue.getInstance(),$e=this.c,ye=$e.offset;let Ae=fe.getGraphemeBreakType($e.nextCodePoint());for(;!$e.eol();){const Ce=$e.offset,je=fe.getGraphemeBreakType($e.nextCodePoint());if(Te(Ae,je)){$e.setOffset(Ce);break}Ae=je}return $e.offset-ye}prevGraphemeLength(){const fe=Ue.getInstance(),$e=this.c,ye=$e.offset;let Ae=fe.getGraphemeBreakType($e.prevCodePoint());for(;$e.offset>0;){const Ce=$e.offset,je=fe.getGraphemeBreakType($e.prevCodePoint());if(Te(je,Ae)){$e.setOffset(Ce);break}Ae=je}return ye-$e.offset}eol(){return this.c.eol()}}e.$Pf=he;function q(re,fe){return new he(re,fe).nextGraphemeLength()}function Z(re,fe){return new he(re,fe).prevGraphemeLength()}function X(re,fe){fe>0&&ie(re.charCodeAt(fe))&&fe--;const $e=fe+q(re,fe);return[$e-Z(re,$e),$e]}function G(re){const fe=new he(re);let $e=0;for(;!fe.eol();)$e++,fe.nextGraphemeLength();return $e}let U;function B(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function j(re){return U||(U=B()),U.test(re)}const W=/^[\t\n\r\x20-\x7E]*$/;function te(re){return W.test(re)}e.$Wf=/[\u2028\u2029]/;function _(re){return e.$Wf.test(re)}function Q(re){return re>=11904&&re<=55215||re>=63744&&re<=64255||re>=65281&&re<=65374}function ae(re){return re>=127462&&re<=127487||re===8986||re===8987||re===9200||re===9203||re>=9728&&re<=10175||re===11088||re===11093||re>=127744&&re<=128591||re>=128640&&re<=128764||re>=128992&&re<=129008||re>=129280&&re<=129535||re>=129648&&re<=129782}function ue(re,fe,$e=""){const ye=re.trimStart();if(ye.length<fe)return ye;const Ae=/\b/g;let Ce=0;for(;Ae.test(ye)&&!(ye.length-Ae.lastIndex<fe);)Ce=Ae.lastIndex,Ae.lastIndex+=1;return Ce===0?ye:$e+ye.substring(Ce).trimStart()}const ge=/(?:(?:\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~])|(:?\x1b\].*?\x07)/g;function*we(re){let fe=0;for(const $e of re.matchAll(ge))fe!==$e.index&&(yield{isCode:!1,str:re.substring(fe,$e.index)}),yield{isCode:!0,str:$e[0]},fe=$e.index+$e[0].length;fe!==re.length&&(yield{isCode:!1,str:re.substring(fe)})}function Ee(re){return re&&(re=re.replace(ge,"")),re}const pe=/\\\[.*?\\\]/g;function be(re){return Ee(re).replace(pe,"")}e.$5f=String.fromCharCode(c.CharCode.UTF8_BOM);function Se(re){return!!(re&&re.length>0&&re.charCodeAt(0)===c.CharCode.UTF8_BOM)}function Ie(re){return Se(re)?re.substr(1):re}function oe(re,fe){if(!re||!fe||re.length<fe.length)return!1;const $e=fe.length,ye=re.toLowerCase();let Ae=0,Ce=-1;for(;Ae<$e;){const je=ye.indexOf(fe[Ae],Ce+1);if(je<0)return!1;Ce=je,Ae++}return!0}function de(re,fe=!1){return re?(fe&&(re=re.replace(/\\./g,"")),re.toLowerCase()!==re):!1}function me(re){return re.charAt(0).toUpperCase()+re.slice(1)}function Pe(re,fe=1){if(fe===0)return"";let $e=-1;do $e=re.indexOf(`
`,$e+1),fe--;while(fe>0&&$e>=0);return $e===-1?re:(re[$e-1]==="\r"&&$e--,re.substr(0,$e))}function ke(re){const fe=c.CharCode.Z-c.CharCode.A+1;return re=re%(2*fe),re<fe?String.fromCharCode(c.CharCode.a+re):String.fromCharCode(c.CharCode.A+re-fe)}function Fe(re){return Ue.getInstance().getGraphemeBreakType(re)}function Te(re,fe){return re===Le.Other?fe!==Le.Extend&&fe!==Le.SpacingMark:re===Le.CR&&fe===Le.LF?!1:re===Le.Control||re===Le.CR||re===Le.LF||fe===Le.Control||fe===Le.CR||fe===Le.LF?!0:!(re===Le.L&&(fe===Le.L||fe===Le.V||fe===Le.LV||fe===Le.LVT)||(re===Le.LV||re===Le.V)&&(fe===Le.V||fe===Le.T)||(re===Le.LVT||re===Le.T)&&fe===Le.T||fe===Le.Extend||fe===Le.ZWJ||fe===Le.SpacingMark||re===Le.Prepend||re===Le.ZWJ&&fe===Le.Extended_Pictographic||re===Le.Regional_Indicator&&fe===Le.Regional_Indicator)}var Le;(function(re){re[re.Other=0]="Other",re[re.Prepend=1]="Prepend",re[re.CR=2]="CR",re[re.LF=3]="LF",re[re.Control=4]="Control",re[re.Extend=5]="Extend",re[re.Regional_Indicator=6]="Regional_Indicator",re[re.SpacingMark=7]="SpacingMark",re[re.L=8]="L",re[re.V=9]="V",re[re.T=10]="T",re[re.LV=11]="LV",re[re.LVT=12]="LVT",re[re.ZWJ=13]="ZWJ",re[re.Extended_Pictographic=14]="Extended_Pictographic"})(Le||(e.GraphemeBreakType=Le={}));class Ue{static{this.c=null}static getInstance(){return Ue.c||(Ue.c=new Ue),Ue.c}constructor(){this.d=qe()}getGraphemeBreakType(fe){if(fe<32)return fe===c.CharCode.LineFeed?Le.LF:fe===c.CharCode.CarriageReturn?Le.CR:Le.Control;if(fe<127)return Le.Other;const $e=this.d,ye=$e.length/3;let Ae=1;for(;Ae<=ye;)if(fe<$e[3*Ae])Ae=2*Ae;else if(fe>$e[3*Ae+1])Ae=2*Ae+1;else return $e[3*Ae+2];return Le.Other}}function qe(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function He(re,fe){if(re===0)return 0;const $e=Me(re,fe);if($e!==void 0)return $e;const ye=new se(fe,re);return ye.prevCodePoint(),ye.offset}function Me(re,fe){const $e=new se(fe,re);let ye=$e.prevCodePoint();for(;Be(ye)||ye===ze.emojiVariantSelector||ye===ze.enclosingKeyCap;){if($e.offset===0)return;ye=$e.prevCodePoint()}if(!ae(ye))return;let Ae=$e.offset;return Ae>0&&$e.prevCodePoint()===ze.zwj&&(Ae=$e.offset),Ae}function Be(re){return 127995<=re&&re<=127999}var ze;(function(re){re[re.zwj=8205]="zwj",re[re.emojiVariantSelector=65039]="emojiVariantSelector",re[re.enclosingKeyCap=8419]="enclosingKeyCap"})(ze||(ze={})),e.$cg="\xA0";class We{static{this.c=new N.$X(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new P.$_e({getCacheKey:JSON.stringify},fe=>{function $e(Ve){const _e=new Map;for(let Ye=0;Ye<Ve.length;Ye+=2)_e.set(Ve[Ye],Ve[Ye+1]);return _e}function ye(Ve,_e){const Ye=new Map(Ve);for(const[nt,at]of _e)Ye.set(nt,at);return Ye}function Ae(Ve,_e){if(!Ve)return _e;const Ye=new Map;for(const[nt,at]of Ve)_e.has(nt)&&Ye.set(nt,at);return Ye}const Ce=this.c.value;let je=fe.filter(Ve=>!Ve.startsWith("_")&&Ve in Ce);je.length===0&&(je=["_default"]);let xe;for(const Ve of je){const _e=$e(Ce[Ve]);xe=Ae(xe,_e)}const Je=$e(Ce._common),Qe=ye(Je,xe);return new We(Qe)})}static getInstance(fe){return We.d.get(Array.from(fe))}static{this.e=new N.$X(()=>Object.keys(We.c.value).filter(fe=>!fe.startsWith("_")))}static getLocales(){return We.e.value}constructor(fe){this.f=fe}isAmbiguous(fe){return this.f.has(fe)}containsAmbiguousCharacter(fe){for(let $e=0;$e<fe.length;$e++){const ye=fe.codePointAt($e);if(typeof ye=="number"&&this.isAmbiguous(ye))return!0}return!1}getPrimaryConfusable(fe){return this.f.get(fe)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$dg=We;class Ne{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(Ne.c())),this.d}static isInvisibleCharacter(fe){return Ne.e().has(fe)}static containsInvisibleCharacter(fe){for(let $e=0;$e<fe.length;$e++){const ye=fe.codePointAt($e);if(typeof ye=="number"&&Ne.isInvisibleCharacter(ye))return!0}return!1}static get codePoints(){return Ne.e()}}e.$eg=Ne}),define(ce[56],le([0,1,27]),function(ne,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zj=e.$xj=void 0,e.$tj=c,e.$uj=N,e.$vj=O,e.$wj=k,e.$yj=d,P=Oe(P);function c(f){return N(f,0)}function N(f,b){switch(typeof f){case"object":return f===null?O(349,b):Array.isArray(f)?A(f,b):w(f,b);case"string":return k(f,b);case"boolean":return T(f,b);case"number":return O(f,b);case"undefined":return O(937,b);default:return O(617,b)}}function O(f,b){return(b<<5)-b+f|0}function T(f,b){return O(f?433:863,b)}function k(f,b){b=O(149417,b);for(let I=0,m=f.length;I<m;I++)b=O(f.charCodeAt(I),b);return b}function A(f,b){return b=O(104579,b),f.reduce((I,m)=>N(m,I),b)}function w(f,b){return b=O(181387,b),Object.keys(f).sort().reduce((I,m)=>(I=k(m,I),N(f[m],I)),b)}class E{constructor(){this.g=0}get value(){return this.g}hash(b){return this.g=N(b,this.g),this.g}}e.$xj=E;var $;(function(f){f[f.BLOCK_SIZE=64]="BLOCK_SIZE",f[f.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})($||($={}));function u(f,b,I=32){const m=I-b,s=~((1<<m)-1);return(f<<b|(s&f)>>>m)>>>0}function p(f,b=0,I=f.byteLength,m=0){for(let s=0;s<I;s++)f[b+s]=m}function l(f,b,I="0"){for(;f.length<b;)f=I+f;return f}function d(f,b=32){return f instanceof ArrayBuffer?Array.from(new Uint8Array(f)).map(I=>I.toString(16).padStart(2,"0")).join(""):l((f>>>0).toString(16),b/4)}class y{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array($.BLOCK_SIZE+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(b){const I=b.length;if(I===0)return;const m=this.p;let s=this.r,r=this.u,i,a;for(r!==0?(i=r,a=-1,r=0):(i=b.charCodeAt(0),a=0);;){let t=i;if(P.$Kf(i))if(a+1<I){const n=b.charCodeAt(a+1);P.$Lf(n)?(a++,t=P.$Mf(i,n)):t=$.UNICODE_REPLACEMENT}else{r=i;break}else P.$Lf(i)&&(t=$.UNICODE_REPLACEMENT);if(s=this.w(m,s,t),a++,a<I)i=b.charCodeAt(a);else break}this.r=s,this.u=r}w(b,I,m){return m<128?b[I++]=m:m<2048?(b[I++]=192|(m&1984)>>>6,b[I++]=128|(m&63)>>>0):m<65536?(b[I++]=224|(m&61440)>>>12,b[I++]=128|(m&4032)>>>6,b[I++]=128|(m&63)>>>0):(b[I++]=240|(m&1835008)>>>18,b[I++]=128|(m&258048)>>>12,b[I++]=128|(m&4032)>>>6,b[I++]=128|(m&63)>>>0),I>=$.BLOCK_SIZE&&(this.y(),I-=$.BLOCK_SIZE,this.t+=$.BLOCK_SIZE,b[0]=b[$.BLOCK_SIZE+0],b[1]=b[$.BLOCK_SIZE+1],b[2]=b[$.BLOCK_SIZE+2]),I}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,$.UNICODE_REPLACEMENT)),this.t+=this.r,this.x()),d(this.h)+d(this.l)+d(this.m)+d(this.n)+d(this.o)}x(){this.p[this.r++]=128,p(this.p,this.r),this.r>56&&(this.y(),p(this.p));const b=8*this.t;this.q.setUint32(56,Math.floor(b/4294967296),!1),this.q.setUint32(60,b%4294967296,!1),this.y()}y(){const b=y.g,I=this.q;for(let h=0;h<64;h+=4)b.setUint32(h,I.getUint32(h,!1),!1);for(let h=64;h<320;h+=4)b.setUint32(h,u(b.getUint32(h-12,!1)^b.getUint32(h-32,!1)^b.getUint32(h-56,!1)^b.getUint32(h-64,!1),1),!1);let m=this.h,s=this.l,r=this.m,i=this.n,a=this.o,t,n,o;for(let h=0;h<80;h++)h<20?(t=s&r|~s&i,n=1518500249):h<40?(t=s^r^i,n=1859775393):h<60?(t=s&r|s&i|r&i,n=2400959708):(t=s^r^i,n=3395469782),o=u(m,5)+t+a+n+b.getUint32(h*4,!1)&4294967295,a=i,i=r,r=u(s,30),s=m,m=o;this.h=this.h+m&4294967295,this.l=this.l+s&4294967295,this.m=this.m+r&4294967295,this.n=this.n+i&4294967295,this.o=this.o+a&4294967295}}e.$zj=y}),define(ce[92],le([0,1,27]),function(ne,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),P=Oe(P);var c;(function(N){N[N.Ignore=0]="Ignore",N[N.Info=1]="Info",N[N.Warning=2]="Warning",N[N.Error=3]="Error"})(c||(c={})),function(N){const O="error",T="warning",k="warn",A="info",w="ignore";function E(u){return u?P.$Gf(O,u)?N.Error:P.$Gf(T,u)||P.$Gf(k,u)?N.Warning:P.$Gf(A,u)?N.Info:N.Ignore:N.Ignore}N.fromValue=E;function $(u){switch(u){case N.Error:return O;case N.Warning:return T;case N.Info:return A;default:return w}}N.toString=$}(c||(c={})),e.default=c}),define(ce[52],le([0,1,19,39,27]),function(ne,e,P,c,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Li=e.$Ki=e.$Ji=e.$Ii=e.$Hi=void 0;class O{constructor(){this.b="",this.c=0}reset(l){return this.b=l,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(l){const d=l.charCodeAt(0),y=this.b.charCodeAt(this.c);return d-y}value(){return this.b[this.c]}}e.$Hi=O;class T{constructor(l=!0){this.e=l}reset(l){return this.b=l,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let l=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===c.CharCode.Period)if(l)this.c++;else break;else l=!1;return this}cmp(l){return this.e?(0,N.$Af)(l,this.b,0,l.length,this.c,this.d):(0,N.$Cf)(l,this.b,0,l.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$Ii=T;class k{constructor(l=!0,d=!0){this.f=l,this.g=d}reset(l){this.d=0,this.e=0,this.b=l,this.c=l.length;for(let d=l.length-1;d>=0;d--,this.c--){const y=this.b.charCodeAt(d);if(!(y===c.CharCode.Slash||this.f&&y===c.CharCode.Backslash))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let l=!0;for(;this.e<this.c;this.e++){const d=this.b.charCodeAt(this.e);if(d===c.CharCode.Slash||this.f&&d===c.CharCode.Backslash)if(l)this.d++;else break;else l=!1}return this}cmp(l){return this.g?(0,N.$Af)(l,this.b,0,l.length,this.d,this.e):(0,N.$Cf)(l,this.b,0,l.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$Ji=k;var A;(function(p){p[p.Scheme=1]="Scheme",p[p.Authority=2]="Authority",p[p.Path=3]="Path",p[p.Query=4]="Query",p[p.Fragment=5]="Fragment"})(A||(A={}));class w{constructor(l,d){this.f=l,this.g=d,this.d=[],this.e=0}reset(l){return this.c=l,this.d=[],this.c.scheme&&this.d.push(A.Scheme),this.c.authority&&this.d.push(A.Authority),this.c.path&&(this.b=new k(!1,!this.f(l)),this.b.reset(l.path),this.b.value()&&this.d.push(A.Path)),this.g(l)||(this.c.query&&this.d.push(A.Query),this.c.fragment&&this.d.push(A.Fragment)),this.e=0,this}next(){return this.d[this.e]===A.Path&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===A.Path&&this.b.hasNext()||this.e<this.d.length-1}cmp(l){if(this.d[this.e]===A.Scheme)return(0,N.$Bf)(l,this.c.scheme);if(this.d[this.e]===A.Authority)return(0,N.$Bf)(l,this.c.authority);if(this.d[this.e]===A.Path)return this.b.cmp(l);if(this.d[this.e]===A.Query)return(0,N.$zf)(l,this.c.query);if(this.d[this.e]===A.Fragment)return(0,N.$zf)(l,this.c.fragment);throw new Error}value(){if(this.d[this.e]===A.Scheme)return this.c.scheme;if(this.d[this.e]===A.Authority)return this.c.authority;if(this.d[this.e]===A.Path)return this.b.value();if(this.d[this.e]===A.Query)return this.c.query;if(this.d[this.e]===A.Fragment)return this.c.fragment;throw new Error}}e.$Ki=w;class E{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const l=this.right;return this.right=l.left,l.left=this,this.updateHeight(),l.updateHeight(),l}rotateRight(){const l=this.left;return this.left=l.right,l.right=this,this.updateHeight(),l.updateHeight(),l}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var $;(function(p){p[p.Left=-1]="Left",p[p.Mid=0]="Mid",p[p.Right=1]="Right"})($||($={}));class u{static forUris(l=()=>!1,d=()=>!1){return new u(new w(l,d))}static forPaths(l=!1){return new u(new k(void 0,!l))}static forStrings(){return new u(new O)}static forConfigKeys(){return new u(new T)}constructor(l){this.b=l}clear(){this.c=void 0}fill(l,d){if(d){const y=d.slice(0);(0,P.$Yb)(y);for(const f of y)this.set(f,l)}else{const y=l.slice(0);(0,P.$Yb)(y);for(const f of y)this.set(f[0],f[1])}}set(l,d){const y=this.b.reset(l);let f;this.c||(this.c=new E,this.c.segment=y.value());const b=[];for(f=this.c;;){const m=y.cmp(f.segment);if(m>0)f.left||(f.left=new E,f.left.segment=y.value()),b.push([$.Left,f]),f=f.left;else if(m<0)f.right||(f.right=new E,f.right.segment=y.value()),b.push([$.Right,f]),f=f.right;else if(y.hasNext())y.next(),f.mid||(f.mid=new E,f.mid.segment=y.value()),b.push([$.Mid,f]),f=f.mid;else break}const I=f.value;f.value=d,f.key=l;for(let m=b.length-1;m>=0;m--){const s=b[m][1];s.updateHeight();const r=s.balanceFactor();if(r<-1||r>1){const i=b[m][0],a=b[m+1][0];if(i===$.Right&&a===$.Right)b[m][1]=s.rotateLeft();else if(i===$.Left&&a===$.Left)b[m][1]=s.rotateRight();else if(i===$.Right&&a===$.Left)s.right=b[m+1][1]=b[m+1][1].rotateRight(),b[m][1]=s.rotateLeft();else if(i===$.Left&&a===$.Right)s.left=b[m+1][1]=b[m+1][1].rotateLeft(),b[m][1]=s.rotateRight();else throw new Error;if(m>0)switch(b[m-1][0]){case $.Left:b[m-1][1].left=b[m][1];break;case $.Right:b[m-1][1].right=b[m][1];break;case $.Mid:b[m-1][1].mid=b[m][1];break}else this.c=b[0][1]}}return I}get(l){return this.d(l)?.value}d(l){const d=this.b.reset(l);let y=this.c;for(;y;){const f=d.cmp(y.segment);if(f>0)y=y.left;else if(f<0)y=y.right;else if(d.hasNext())d.next(),y=y.mid;else break}return y}has(l){const d=this.d(l);return!(d?.value===void 0&&d?.mid===void 0)}delete(l){return this.e(l,!1)}deleteSuperstr(l){return this.e(l,!0)}e(l,d){const y=this.b.reset(l),f=[];let b=this.c;for(;b;){const I=y.cmp(b.segment);if(I>0)f.push([$.Left,b]),b=b.left;else if(I<0)f.push([$.Right,b]),b=b.right;else if(y.hasNext())y.next(),f.push([$.Mid,b]),b=b.mid;else break}if(b){if(d?(b.left=void 0,b.mid=void 0,b.right=void 0,b.height=1):(b.key=void 0,b.value=void 0),!b.mid&&!b.value)if(b.left&&b.right){const I=this.f(b.right);if(I.key){const{key:m,value:s,segment:r}=I;this.e(I.key,!1),b.key=m,b.value=s,b.segment=r}}else{const I=b.left??b.right;if(f.length>0){const[m,s]=f[f.length-1];switch(m){case $.Left:s.left=I;break;case $.Mid:s.mid=I;break;case $.Right:s.right=I;break}}else this.c=I}for(let I=f.length-1;I>=0;I--){const m=f[I][1];m.updateHeight();const s=m.balanceFactor();if(s>1?(m.right.balanceFactor()>=0||(m.right=m.right.rotateRight()),f[I][1]=m.rotateLeft()):s<-1&&(m.left.balanceFactor()<=0||(m.left=m.left.rotateLeft()),f[I][1]=m.rotateRight()),I>0)switch(f[I-1][0]){case $.Left:f[I-1][1].left=f[I][1];break;case $.Right:f[I-1][1].right=f[I][1];break;case $.Mid:f[I-1][1].mid=f[I][1];break}else this.c=f[0][1]}}}f(l){for(;l.left;)l=l.left;return l}findSubstr(l){const d=this.b.reset(l);let y=this.c,f;for(;y;){const b=d.cmp(y.segment);if(b>0)y=y.left;else if(b<0)y=y.right;else if(d.hasNext())d.next(),f=y.value||f,y=y.mid;else break}return y&&y.value||f}findSuperstr(l){return this.g(l,!1)}g(l,d){const y=this.b.reset(l);let f=this.c;for(;f;){const b=y.cmp(f.segment);if(b>0)f=f.left;else if(b<0)f=f.right;else if(y.hasNext())y.next(),f=f.mid;else return f.mid?this.h(f.mid):d?f.value:void 0}}hasElementOrSubtree(l){return this.g(l,!0)!==void 0}forEach(l){for(const[d,y]of this)l(y,d)}*[Symbol.iterator](){yield*this.h(this.c)}h(l){const d=[];return this.j(l,d),d[Symbol.iterator]()}j(l,d){l&&(l.left&&this.j(l.left,d),l.value&&d.push([l.key,l.value]),l.mid&&this.j(l.mid,d),l.right&&this.j(l.right,d))}_isBalanced(){const l=d=>{if(!d)return!0;const y=d.balanceFactor();return y<-1||y>1?!1:l(d.left)&&l(d.right)};return l(this.c)}}e.$Li=u}),define(ce[32],le([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2g=void 0,e.$1g=c;const P=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function c(N){return P.test(N)}e.$2g=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let N;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?N=crypto.getRandomValues.bind(crypto):N=function(k){for(let A=0;A<k.length;A++)k[A]=Math.floor(Math.random()*256);return k};const O=new Uint8Array(16),T=[];for(let k=0;k<256;k++)T.push(k.toString(16).padStart(2,"0"));return function(){N(O),O[6]=O[6]&15|64,O[8]=O[8]&63|128;let A=0,w="";return w+=T[O[A++]],w+=T[O[A++]],w+=T[O[A++]],w+=T[O[A++]],w+="-",w+=T[O[A++]],w+=T[O[A++]],w+="-",w+=T[O[A++]],w+=T[O[A++]],w+="-",w+=T[O[A++]],w+=T[O[A++]],w+="-",w+=T[O[A++]],w+=T[O[A++]],w+=T[O[A++]],w+=T[O[A++]],w+=T[O[A++]],w+=T[O[A++]],w}}()}),define(ce[137],le([0,1,38]),function(ne,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$On=O;const c=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function N(T){const k=T.replace(/\-/g,":").toLowerCase();return!c.has(k)}function O(){const T=(0,P.networkInterfaces)();for(const k in T){const A=T[k];if(A){for(const{mac:w}of A)if(N(w))return w}}throw new Error("Unable to retrieve mac address (unexpected format)")}}),define(ce[138],le([0,1,276,15]),function(ne,e,P,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vX=void 0;class N extends P.Transform{constructor(T){if(super(),typeof T=="number")this.b=T,this.c=1;else{const k=Buffer.isBuffer(T)?T:Buffer.from(T);this.b=k.length===1?k[0]:k,this.c=k.length}}_transform(T,k,A){this.a?this.a=Buffer.concat([this.a,T]):this.a=T;let w=0;for(;w<this.a.length;){const E=typeof this.b=="number"?this.a.indexOf(this.b,w):(0,c.$Pe)(this.a,this.b,w);if(E===-1)break;this.push(this.a.slice(w,E+this.c)),w=E+this.c}this.a=w===this.a.length?void 0:this.a.slice(w),A()}_flush(T){this.a&&this.push(this.a),T()}}e.$vX=N}),define(ce[139],le([0,1,66]),function(ne,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5g=void 0,e.$4g=c,e.$6g=O,P=Oe(P);function c(k,A,w,E=1){let $=!1;return new Promise(u=>{const p=setTimeout(()=>{if(!$)return $=!0,u(0)},w);N(k,A,E,l=>{if(!$)return $=!0,clearTimeout(p),u(l)})})}function N(k,A,w,E){if(A===0)return E(0);const $=new P.Socket;$.once("connect",()=>(T($),N(k+w,A-1,w,E))),$.once("data",()=>{}),$.once("error",u=>(T($),u.code!=="ECONNREFUSED"?N(k+w,A-1,w,E):E(k))),$.connect(k,"127.0.0.1")}e.$5g={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function O(k,A,w,E="127.0.0.1"){let $=!1,u,p=1;const l=P.createServer({pauseOnConnect:!0});function d(y,f){$||($=!0,l.removeAllListeners(),l.close(),u&&clearTimeout(u),f(y))}return new Promise(y=>{u=setTimeout(()=>{d(0,y)},w),l.on("listening",()=>{d(k,y)}),l.on("error",f=>{f&&(f.code==="EADDRINUSE"||f.code==="EACCES")&&p<A?(k++,p++,l.listen(k,E)):d(0,y)}),l.on("close",()=>{d(0,y)}),l.listen(k,E)})}function T(k){try{k.removeAllListeners("connect"),k.removeAllListeners("error"),k.end(),k.destroy(),k.unref()}catch(A){console.error(A)}}}),define(ce[140],le([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NX=P;function P(c){return!!c.parentPort}}),define(ce[141],le([12,11]),function(ne,e){return ne.create("vs/base/common/date",e)}),define(ce[67],le([0,1,141]),function(ne,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1m=w,e.$2m=E,e.$3m=$;const c=60,N=c*60,O=N*24,T=O*7,k=O*30,A=O*365;function w(u,p,l,d){typeof u!="number"&&(u=u.getTime());const y=Math.round((new Date().getTime()-u)/1e3);if(y<-30)return(0,P.localize)(0,null,w(new Date().getTime()+y*1e3,!1));if(!d&&y<30)return(0,P.localize)(1,null);let f;return y<c?(f=y,p?f===1?l?(0,P.localize)(2,null,f):(0,P.localize)(3,null,f):l?(0,P.localize)(4,null,f):(0,P.localize)(5,null,f):f===1?l?(0,P.localize)(6,null,f):(0,P.localize)(7,null,f):l?(0,P.localize)(8,null,f):(0,P.localize)(9,null,f)):y<N?(f=Math.floor(y/c),p?f===1?l?(0,P.localize)(10,null,f):(0,P.localize)(11,null,f):l?(0,P.localize)(12,null,f):(0,P.localize)(13,null,f):f===1?l?(0,P.localize)(14,null,f):(0,P.localize)(15,null,f):l?(0,P.localize)(16,null,f):(0,P.localize)(17,null,f)):y<O?(f=Math.floor(y/N),p?f===1?l?(0,P.localize)(18,null,f):(0,P.localize)(19,null,f):l?(0,P.localize)(20,null,f):(0,P.localize)(21,null,f):f===1?l?(0,P.localize)(22,null,f):(0,P.localize)(23,null,f):l?(0,P.localize)(24,null,f):(0,P.localize)(25,null,f)):y<T?(f=Math.floor(y/O),p?f===1?(0,P.localize)(26,null,f):(0,P.localize)(27,null,f):f===1?(0,P.localize)(28,null,f):(0,P.localize)(29,null,f)):y<k?(f=Math.floor(y/T),p?f===1?l?(0,P.localize)(30,null,f):(0,P.localize)(31,null,f):l?(0,P.localize)(32,null,f):(0,P.localize)(33,null,f):f===1?l?(0,P.localize)(34,null,f):(0,P.localize)(35,null,f):l?(0,P.localize)(36,null,f):(0,P.localize)(37,null,f)):y<A?(f=Math.floor(y/k),p?f===1?l?(0,P.localize)(38,null,f):(0,P.localize)(39,null,f):l?(0,P.localize)(40,null,f):(0,P.localize)(41,null,f):f===1?l?(0,P.localize)(42,null,f):(0,P.localize)(43,null,f):l?(0,P.localize)(44,null,f):(0,P.localize)(45,null,f)):(f=Math.floor(y/A),p?f===1?l?(0,P.localize)(46,null,f):(0,P.localize)(47,null,f):l?(0,P.localize)(48,null,f):(0,P.localize)(49,null,f):f===1?l?(0,P.localize)(50,null,f):(0,P.localize)(51,null,f):l?(0,P.localize)(52,null,f):(0,P.localize)(53,null,f))}function E(u,p){const l=Math.abs(u/1e3);return l<1?p?(0,P.localize)(54,null,u):(0,P.localize)(55,null,u):l<c?p?(0,P.localize)(56,null,Math.round(u)/1e3):(0,P.localize)(57,null,Math.round(u)/1e3):l<N?p?(0,P.localize)(58,null,Math.round(u/(1e3*c))):(0,P.localize)(59,null,Math.round(u/(1e3*c))):l<O?p?(0,P.localize)(60,null,Math.round(u/(1e3*N))):(0,P.localize)(61,null,Math.round(u/(1e3*N))):(0,P.localize)(62,null,Math.round(u/(1e3*O)))}function $(u){return u.getFullYear()+"-"+String(u.getMonth()+1).padStart(2,"0")+"-"+String(u.getDate()).padStart(2,"0")+"T"+String(u.getHours()).padStart(2,"0")+":"+String(u.getMinutes()).padStart(2,"0")+":"+String(u.getSeconds()).padStart(2,"0")+"."+(u.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}}),define(ce[142],le([12,11]),function(ne,e){return ne.create("vs/base/common/errorMessage",e)}),define(ce[41],le([0,1,19,13,142]),function(ne,e,P,c,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qj=A,e.$rj=w,e.$sj=E,P=Oe(P),c=Oe(c),N=Oe(N);function O($,u){return u&&($.stack||$.stacktrace)?N.localize(0,null,k($),T($.stack)||T($.stacktrace)):k($)}function T($){return Array.isArray($)?$.join(`
`):$}function k($){return $.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${$.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof $.code=="string"&&typeof $.errno=="number"&&typeof $.syscall=="string"?N.localize(1,null,$.message):$.message||N.localize(2,null)}function A($=null,u=!1){if(!$)return N.localize(3,null);if(Array.isArray($)){const p=P.$Jb($),l=A(p[0],u);return p.length>1?N.localize(4,null,l,p.length):l}if(c.$fg($))return $;if($.detail){const p=$.detail;if(p.error)return O(p.error,u);if(p.exception)return O(p.exception,u)}return $.stack?O($,u):$.message?$.message:N.localize(5,null)}function w($){const u=$;return u instanceof Error&&Array.isArray(u.actions)}function E($,u){let p;return typeof $=="string"?p=new Error($):p=$,p.actions=u,p}}),define(ce[143],le([12,11]),function(ne,e){return ne.create("vs/base/common/jsonErrorMessages",e)}),define(ce[144],le([0,1,143,34]),function(ne,e,P,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eq=N;function N(O){switch(O){case c.ParseErrorCode.InvalidSymbol:return(0,P.localize)(0,null);case c.ParseErrorCode.InvalidNumberFormat:return(0,P.localize)(1,null);case c.ParseErrorCode.PropertyNameExpected:return(0,P.localize)(2,null);case c.ParseErrorCode.ValueExpected:return(0,P.localize)(3,null);case c.ParseErrorCode.ColonExpected:return(0,P.localize)(4,null);case c.ParseErrorCode.CommaExpected:return(0,P.localize)(5,null);case c.ParseErrorCode.CloseBraceExpected:return(0,P.localize)(6,null);case c.ParseErrorCode.CloseBracketExpected:return(0,P.localize)(7,null);case c.ParseErrorCode.EndOfFileExpected:return(0,P.localize)(8,null);default:return""}}}),define(ce[145],le([12,11]),function(ne,e){return ne.create("vs/base/common/platform",e)}),define(ce[5],le([0,1,145]),function(ne,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$I=e.$H=e.$G=e.$F=e.$E=e.OS=e.OperatingSystem=e.$B=e.$A=e.$z=e.$y=e.$x=e.Language=e.$w=e.$v=e.$u=e.$t=e.$s=e.$r=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.$i=e.Platform=e.$g=void 0,e.$h=i,e.$D=g,e.$J=R,P=Oe(P),e.$g="en";let c=!1,N=!1,O=!1,T=!1,k=!1,A=!1,w=!1,E=!1,$=!1,u=!1,p,l=e.$g,d=e.$g,y,f;const b=globalThis;let I;typeof b.vscode<"u"&&typeof b.vscode.process<"u"?I=b.vscode.process:typeof process<"u"&&typeof process?.versions?.node=="string"&&(I=process);const m=typeof I?.versions?.electron=="string",s=m&&I?.type==="renderer";if(typeof I=="object"){c=I.platform==="win32",N=I.platform==="darwin",O=I.platform==="linux",T=O&&!!I.env.SNAP&&!!I.env.SNAP_REVISION,w=m,$=!!I.env.CI||!!I.env.BUILD_ARTIFACTSTAGINGDIRECTORY,p=e.$g,l=e.$g;const L=I.env.VSCODE_NLS_CONFIG;if(L)try{const S=JSON.parse(L),v=S.availableLanguages["*"];p=S.locale,d=S.osLocale,l=v||e.$g,y=S._translationsConfigFile}catch{}k=!0}else typeof navigator=="object"&&!s?(f=navigator.userAgent,c=f.indexOf("Windows")>=0,N=f.indexOf("Macintosh")>=0,E=(f.indexOf("Macintosh")>=0||f.indexOf("iPad")>=0||f.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,O=f.indexOf("Linux")>=0,u=f?.indexOf("Mobi")>=0,A=!0,p=P.getConfiguredDefaultLocale(P.localize(0,null))||e.$g,l=p,d=navigator.language):console.error("Unable to resolve platform.");var r;(function(L){L[L.Web=0]="Web",L[L.Mac=1]="Mac",L[L.Linux=2]="Linux",L[L.Windows=3]="Windows"})(r||(e.Platform=r={}));function i(L){switch(L){case r.Web:return"Web";case r.Mac:return"Mac";case r.Linux:return"Linux";case r.Windows:return"Windows"}}let a=r.Web;N?a=r.Mac:c?a=r.Windows:O&&(a=r.Linux),e.$i=c,e.$j=N,e.$k=O,e.$l=T,e.$m=k,e.$n=w,e.$o=A,e.$p=A&&typeof b.importScripts=="function",e.$q=e.$p?b.origin:void 0,e.$r=E,e.$s=u,e.$t=$,e.$u=a,e.$v=f,e.$w=l;var t;(function(L){function S(){return e.$w}L.value=S;function v(){return e.$w.length===2?e.$w==="en":e.$w.length>=3?e.$w[0]==="e"&&e.$w[1]==="n"&&e.$w[2]==="-":!1}L.isDefaultVariant=v;function C(){return e.$w==="en"}L.isDefault=C})(t||(e.Language=t={})),e.$x=p,e.$y=d,e.$z=y,e.$A=typeof b.postMessage=="function"&&!b.importScripts,e.$B=(()=>{if(e.$A){const L=[];b.addEventListener("message",v=>{if(v.data&&v.data.vscodeScheduleAsyncWork)for(let C=0,F=L.length;C<F;C++){const D=L[C];if(D.id===v.data.vscodeScheduleAsyncWork){L.splice(C,1),D.callback();return}}});let S=0;return v=>{const C=++S;L.push({id:C,callback:v}),b.postMessage({vscodeScheduleAsyncWork:C},"*")}}return L=>setTimeout(L)})();var n;(function(L){L[L.Windows=1]="Windows",L[L.Macintosh=2]="Macintosh",L[L.Linux=3]="Linux"})(n||(e.OperatingSystem=n={})),e.OS=N||E?n.Macintosh:c?n.Windows:n.Linux;let o=!0,h=!1;function g(){if(!h){h=!0;const L=new Uint8Array(2);L[0]=1,L[1]=2,o=new Uint16Array(L.buffer)[0]===513}return o}e.$E=!!(e.$v&&e.$v.indexOf("Chrome")>=0),e.$F=!!(e.$v&&e.$v.indexOf("Firefox")>=0),e.$G=!!(!e.$E&&e.$v&&e.$v.indexOf("Safari")>=0),e.$H=!!(e.$v&&e.$v.indexOf("Edg/")>=0),e.$I=!!(e.$v&&e.$v.indexOf("Android")>=0);function R(L){return parseFloat(L)>=20}}),define(ce[36],le([0,1,5]),function(ne,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gc=e.$fc=e.env=e.cwd=void 0;let c;const N=globalThis.vscode;if(typeof N<"u"&&typeof N.process<"u"){const O=N.process;c={get platform(){return O.platform},get arch(){return O.arch},get env(){return O.env},cwd(){return O.cwd()}}}else typeof process<"u"?c={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:c={get platform(){return P.$i?"win32":P.$j?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=c.cwd,e.env=c.env,e.$fc=c.platform,e.$gc=c.arch}),define(ce[146],le([0,1,36]),function(ne,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cX=T;var c;(function(k){k.UNKNOWN="UNKNOWN",k.CINNAMON="CINNAMON",k.DEEPIN="DEEPIN",k.GNOME="GNOME",k.KDE3="KDE3",k.KDE4="KDE4",k.KDE5="KDE5",k.KDE6="KDE6",k.PANTHEON="PANTHEON",k.UNITY="UNITY",k.XFCE="XFCE",k.UKUI="UKUI",k.LXQT="LXQT"})(c||(c={}));const N="XDG_CURRENT_DESKTOP",O="KDE_SESSION_VERSION";function T(){const k=P.env[N];if(k){const w=k.split(":").map(E=>E.trim()).filter(E=>E.length>0);for(const E of w)switch(E){case"Unity":{const $=P.env.DESKTOP_SESSION;return $&&$.includes("gnome-fallback")?c.GNOME:c.UNITY}case"Deepin":return c.DEEPIN;case"GNOME":return c.GNOME;case"X-Cinnamon":return c.CINNAMON;case"KDE":{const $=P.env[O];return $==="5"?c.KDE5:$==="6"?c.KDE6:c.KDE4}case"Pantheon":return c.PANTHEON;case"XFCE":return c.XFCE;case"UKUI":return c.UKUI;case"LXQt":return c.LXQT}}const A=P.env.DESKTOP_SESSION;if(A)switch(A){case"deepin":return c.DEEPIN;case"gnome":case"mate":return c.GNOME;case"kde4":case"kde-plasma":return c.KDE4;case"kde":return O in P.env?c.KDE4:c.KDE3;case"xfce":case"xubuntu":return c.XFCE;case"ukui":return c.UKUI}return"GNOME_DESKTOP_SESSION_ID"in P.env?c.GNOME:"KDE_FULL_SESSION"in P.env?O in P.env?c.KDE4:c.KDE3:c.UNKNOWN}}),define(ce[14],le([0,1,36]),function(ne,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vc=e.sep=e.$tc=e.$sc=e.$rc=e.$qc=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=e.$jc=e.$ic=e.$hc=void 0,P=Oe(P);const c=65,N=97,O=90,T=122,k=46,A=47,w=92,E=58,$=63;class u extends Error{constructor(i,a,t){let n;typeof a=="string"&&a.indexOf("not ")===0?(n="must not be",a=a.replace(/^not /,"")):n="must be";const o=i.indexOf(".")!==-1?"property":"argument";let h=`The "${i}" ${o} ${n} of type ${a}`;h+=`. Received type ${typeof t}`,super(h),this.code="ERR_INVALID_ARG_TYPE"}}function p(r,i){if(r===null||typeof r!="object")throw new u(i,"Object",r)}function l(r,i){if(typeof r!="string")throw new u(i,"string",r)}const d=P.$fc==="win32";function y(r){return r===A||r===w}function f(r){return r===A}function b(r){return r>=c&&r<=O||r>=N&&r<=T}function I(r,i,a,t){let n="",o=0,h=-1,g=0,R=0;for(let L=0;L<=r.length;++L){if(L<r.length)R=r.charCodeAt(L);else{if(t(R))break;R=A}if(t(R)){if(!(h===L-1||g===1))if(g===2){if(n.length<2||o!==2||n.charCodeAt(n.length-1)!==k||n.charCodeAt(n.length-2)!==k){if(n.length>2){const S=n.lastIndexOf(a);S===-1?(n="",o=0):(n=n.slice(0,S),o=n.length-1-n.lastIndexOf(a)),h=L,g=0;continue}else if(n.length!==0){n="",o=0,h=L,g=0;continue}}i&&(n+=n.length>0?`${a}..`:"..",o=2)}else n.length>0?n+=`${a}${r.slice(h+1,L)}`:n=r.slice(h+1,L),o=L-h-1;h=L,g=0}else R===k&&g!==-1?++g:g=-1}return n}function m(r,i){p(i,"pathObject");const a=i.dir||i.root,t=i.base||`${i.name||""}${i.ext||""}`;return a?a===i.root?`${a}${t}`:`${a}${r}${t}`:t}e.$hc={resolve(...r){let i="",a="",t=!1;for(let n=r.length-1;n>=-1;n--){let o;if(n>=0){if(o=r[n],l(o,"path"),o.length===0)continue}else i.length===0?o=P.cwd():(o=P.env[`=${i}`]||P.cwd(),(o===void 0||o.slice(0,2).toLowerCase()!==i.toLowerCase()&&o.charCodeAt(2)===w)&&(o=`${i}\\`));const h=o.length;let g=0,R="",L=!1;const S=o.charCodeAt(0);if(h===1)y(S)&&(g=1,L=!0);else if(y(S))if(L=!0,y(o.charCodeAt(1))){let v=2,C=v;for(;v<h&&!y(o.charCodeAt(v));)v++;if(v<h&&v!==C){const F=o.slice(C,v);for(C=v;v<h&&y(o.charCodeAt(v));)v++;if(v<h&&v!==C){for(C=v;v<h&&!y(o.charCodeAt(v));)v++;(v===h||v!==C)&&(R=`\\\\${F}\\${o.slice(C,v)}`,g=v)}}}else g=1;else b(S)&&o.charCodeAt(1)===E&&(R=o.slice(0,2),g=2,h>2&&y(o.charCodeAt(2))&&(L=!0,g=3));if(R.length>0)if(i.length>0){if(R.toLowerCase()!==i.toLowerCase())continue}else i=R;if(t){if(i.length>0)break}else if(a=`${o.slice(g)}\\${a}`,t=L,L&&i.length>0)break}return a=I(a,!t,"\\",y),t?`${i}\\${a}`:`${i}${a}`||"."},normalize(r){l(r,"path");const i=r.length;if(i===0)return".";let a=0,t,n=!1;const o=r.charCodeAt(0);if(i===1)return f(o)?"\\":r;if(y(o))if(n=!0,y(r.charCodeAt(1))){let g=2,R=g;for(;g<i&&!y(r.charCodeAt(g));)g++;if(g<i&&g!==R){const L=r.slice(R,g);for(R=g;g<i&&y(r.charCodeAt(g));)g++;if(g<i&&g!==R){for(R=g;g<i&&!y(r.charCodeAt(g));)g++;if(g===i)return`\\\\${L}\\${r.slice(R)}\\`;g!==R&&(t=`\\\\${L}\\${r.slice(R,g)}`,a=g)}}}else a=1;else b(o)&&r.charCodeAt(1)===E&&(t=r.slice(0,2),a=2,i>2&&y(r.charCodeAt(2))&&(n=!0,a=3));let h=a<i?I(r.slice(a),!n,"\\",y):"";return h.length===0&&!n&&(h="."),h.length>0&&y(r.charCodeAt(i-1))&&(h+="\\"),t===void 0?n?`\\${h}`:h:n?`${t}\\${h}`:`${t}${h}`},isAbsolute(r){l(r,"path");const i=r.length;if(i===0)return!1;const a=r.charCodeAt(0);return y(a)||i>2&&b(a)&&r.charCodeAt(1)===E&&y(r.charCodeAt(2))},join(...r){if(r.length===0)return".";let i,a;for(let o=0;o<r.length;++o){const h=r[o];l(h,"path"),h.length>0&&(i===void 0?i=a=h:i+=`\\${h}`)}if(i===void 0)return".";let t=!0,n=0;if(typeof a=="string"&&y(a.charCodeAt(0))){++n;const o=a.length;o>1&&y(a.charCodeAt(1))&&(++n,o>2&&(y(a.charCodeAt(2))?++n:t=!1))}if(t){for(;n<i.length&&y(i.charCodeAt(n));)n++;n>=2&&(i=`\\${i.slice(n)}`)}return e.$hc.normalize(i)},relative(r,i){if(l(r,"from"),l(i,"to"),r===i)return"";const a=e.$hc.resolve(r),t=e.$hc.resolve(i);if(a===t||(r=a.toLowerCase(),i=t.toLowerCase(),r===i))return"";let n=0;for(;n<r.length&&r.charCodeAt(n)===w;)n++;let o=r.length;for(;o-1>n&&r.charCodeAt(o-1)===w;)o--;const h=o-n;let g=0;for(;g<i.length&&i.charCodeAt(g)===w;)g++;let R=i.length;for(;R-1>g&&i.charCodeAt(R-1)===w;)R--;const L=R-g,S=h<L?h:L;let v=-1,C=0;for(;C<S;C++){const D=r.charCodeAt(n+C);if(D!==i.charCodeAt(g+C))break;D===w&&(v=C)}if(C!==S){if(v===-1)return t}else{if(L>S){if(i.charCodeAt(g+C)===w)return t.slice(g+C+1);if(C===2)return t.slice(g+C)}h>S&&(r.charCodeAt(n+C)===w?v=C:C===2&&(v=3)),v===-1&&(v=0)}let F="";for(C=n+v+1;C<=o;++C)(C===o||r.charCodeAt(C)===w)&&(F+=F.length===0?"..":"\\..");return g+=v,F.length>0?`${F}${t.slice(g,R)}`:(t.charCodeAt(g)===w&&++g,t.slice(g,R))},toNamespacedPath(r){if(typeof r!="string"||r.length===0)return r;const i=e.$hc.resolve(r);if(i.length<=2)return r;if(i.charCodeAt(0)===w){if(i.charCodeAt(1)===w){const a=i.charCodeAt(2);if(a!==$&&a!==k)return`\\\\?\\UNC\\${i.slice(2)}`}}else if(b(i.charCodeAt(0))&&i.charCodeAt(1)===E&&i.charCodeAt(2)===w)return`\\\\?\\${i}`;return r},dirname(r){l(r,"path");const i=r.length;if(i===0)return".";let a=-1,t=0;const n=r.charCodeAt(0);if(i===1)return y(n)?r:".";if(y(n)){if(a=t=1,y(r.charCodeAt(1))){let g=2,R=g;for(;g<i&&!y(r.charCodeAt(g));)g++;if(g<i&&g!==R){for(R=g;g<i&&y(r.charCodeAt(g));)g++;if(g<i&&g!==R){for(R=g;g<i&&!y(r.charCodeAt(g));)g++;if(g===i)return r;g!==R&&(a=t=g+1)}}}}else b(n)&&r.charCodeAt(1)===E&&(a=i>2&&y(r.charCodeAt(2))?3:2,t=a);let o=-1,h=!0;for(let g=i-1;g>=t;--g)if(y(r.charCodeAt(g))){if(!h){o=g;break}}else h=!1;if(o===-1){if(a===-1)return".";o=a}return r.slice(0,o)},basename(r,i){i!==void 0&&l(i,"ext"),l(r,"path");let a=0,t=-1,n=!0,o;if(r.length>=2&&b(r.charCodeAt(0))&&r.charCodeAt(1)===E&&(a=2),i!==void 0&&i.length>0&&i.length<=r.length){if(i===r)return"";let h=i.length-1,g=-1;for(o=r.length-1;o>=a;--o){const R=r.charCodeAt(o);if(y(R)){if(!n){a=o+1;break}}else g===-1&&(n=!1,g=o+1),h>=0&&(R===i.charCodeAt(h)?--h===-1&&(t=o):(h=-1,t=g))}return a===t?t=g:t===-1&&(t=r.length),r.slice(a,t)}for(o=r.length-1;o>=a;--o)if(y(r.charCodeAt(o))){if(!n){a=o+1;break}}else t===-1&&(n=!1,t=o+1);return t===-1?"":r.slice(a,t)},extname(r){l(r,"path");let i=0,a=-1,t=0,n=-1,o=!0,h=0;r.length>=2&&r.charCodeAt(1)===E&&b(r.charCodeAt(0))&&(i=t=2);for(let g=r.length-1;g>=i;--g){const R=r.charCodeAt(g);if(y(R)){if(!o){t=g+1;break}continue}n===-1&&(o=!1,n=g+1),R===k?a===-1?a=g:h!==1&&(h=1):a!==-1&&(h=-1)}return a===-1||n===-1||h===0||h===1&&a===n-1&&a===t+1?"":r.slice(a,n)},format:m.bind(null,"\\"),parse(r){l(r,"path");const i={root:"",dir:"",base:"",ext:"",name:""};if(r.length===0)return i;const a=r.length;let t=0,n=r.charCodeAt(0);if(a===1)return y(n)?(i.root=i.dir=r,i):(i.base=i.name=r,i);if(y(n)){if(t=1,y(r.charCodeAt(1))){let v=2,C=v;for(;v<a&&!y(r.charCodeAt(v));)v++;if(v<a&&v!==C){for(C=v;v<a&&y(r.charCodeAt(v));)v++;if(v<a&&v!==C){for(C=v;v<a&&!y(r.charCodeAt(v));)v++;v===a?t=v:v!==C&&(t=v+1)}}}}else if(b(n)&&r.charCodeAt(1)===E){if(a<=2)return i.root=i.dir=r,i;if(t=2,y(r.charCodeAt(2))){if(a===3)return i.root=i.dir=r,i;t=3}}t>0&&(i.root=r.slice(0,t));let o=-1,h=t,g=-1,R=!0,L=r.length-1,S=0;for(;L>=t;--L){if(n=r.charCodeAt(L),y(n)){if(!R){h=L+1;break}continue}g===-1&&(R=!1,g=L+1),n===k?o===-1?o=L:S!==1&&(S=1):o!==-1&&(S=-1)}return g!==-1&&(o===-1||S===0||S===1&&o===g-1&&o===h+1?i.base=i.name=r.slice(h,g):(i.name=r.slice(h,o),i.base=r.slice(h,g),i.ext=r.slice(o,g))),h>0&&h!==t?i.dir=r.slice(0,h-1):i.dir=i.root,i},sep:"\\",delimiter:";",win32:null,posix:null};const s=(()=>{if(d){const r=/\\/g;return()=>{const i=P.cwd().replace(r,"/");return i.slice(i.indexOf("/"))}}return()=>P.cwd()})();e.$ic={resolve(...r){let i="",a=!1;for(let t=r.length-1;t>=-1&&!a;t--){const n=t>=0?r[t]:s();l(n,"path"),n.length!==0&&(i=`${n}/${i}`,a=n.charCodeAt(0)===A)}return i=I(i,!a,"/",f),a?`/${i}`:i.length>0?i:"."},normalize(r){if(l(r,"path"),r.length===0)return".";const i=r.charCodeAt(0)===A,a=r.charCodeAt(r.length-1)===A;return r=I(r,!i,"/",f),r.length===0?i?"/":a?"./":".":(a&&(r+="/"),i?`/${r}`:r)},isAbsolute(r){return l(r,"path"),r.length>0&&r.charCodeAt(0)===A},join(...r){if(r.length===0)return".";let i;for(let a=0;a<r.length;++a){const t=r[a];l(t,"path"),t.length>0&&(i===void 0?i=t:i+=`/${t}`)}return i===void 0?".":e.$ic.normalize(i)},relative(r,i){if(l(r,"from"),l(i,"to"),r===i||(r=e.$ic.resolve(r),i=e.$ic.resolve(i),r===i))return"";const a=1,t=r.length,n=t-a,o=1,h=i.length-o,g=n<h?n:h;let R=-1,L=0;for(;L<g;L++){const v=r.charCodeAt(a+L);if(v!==i.charCodeAt(o+L))break;v===A&&(R=L)}if(L===g)if(h>g){if(i.charCodeAt(o+L)===A)return i.slice(o+L+1);if(L===0)return i.slice(o+L)}else n>g&&(r.charCodeAt(a+L)===A?R=L:L===0&&(R=0));let S="";for(L=a+R+1;L<=t;++L)(L===t||r.charCodeAt(L)===A)&&(S+=S.length===0?"..":"/..");return`${S}${i.slice(o+R)}`},toNamespacedPath(r){return r},dirname(r){if(l(r,"path"),r.length===0)return".";const i=r.charCodeAt(0)===A;let a=-1,t=!0;for(let n=r.length-1;n>=1;--n)if(r.charCodeAt(n)===A){if(!t){a=n;break}}else t=!1;return a===-1?i?"/":".":i&&a===1?"//":r.slice(0,a)},basename(r,i){i!==void 0&&l(i,"ext"),l(r,"path");let a=0,t=-1,n=!0,o;if(i!==void 0&&i.length>0&&i.length<=r.length){if(i===r)return"";let h=i.length-1,g=-1;for(o=r.length-1;o>=0;--o){const R=r.charCodeAt(o);if(R===A){if(!n){a=o+1;break}}else g===-1&&(n=!1,g=o+1),h>=0&&(R===i.charCodeAt(h)?--h===-1&&(t=o):(h=-1,t=g))}return a===t?t=g:t===-1&&(t=r.length),r.slice(a,t)}for(o=r.length-1;o>=0;--o)if(r.charCodeAt(o)===A){if(!n){a=o+1;break}}else t===-1&&(n=!1,t=o+1);return t===-1?"":r.slice(a,t)},extname(r){l(r,"path");let i=-1,a=0,t=-1,n=!0,o=0;for(let h=r.length-1;h>=0;--h){const g=r.charCodeAt(h);if(g===A){if(!n){a=h+1;break}continue}t===-1&&(n=!1,t=h+1),g===k?i===-1?i=h:o!==1&&(o=1):i!==-1&&(o=-1)}return i===-1||t===-1||o===0||o===1&&i===t-1&&i===a+1?"":r.slice(i,t)},format:m.bind(null,"/"),parse(r){l(r,"path");const i={root:"",dir:"",base:"",ext:"",name:""};if(r.length===0)return i;const a=r.charCodeAt(0)===A;let t;a?(i.root="/",t=1):t=0;let n=-1,o=0,h=-1,g=!0,R=r.length-1,L=0;for(;R>=t;--R){const S=r.charCodeAt(R);if(S===A){if(!g){o=R+1;break}continue}h===-1&&(g=!1,h=R+1),S===k?n===-1?n=R:L!==1&&(L=1):n!==-1&&(L=-1)}if(h!==-1){const S=o===0&&a?1:o;n===-1||L===0||L===1&&n===h-1&&n===o+1?i.base=i.name=r.slice(S,h):(i.name=r.slice(S,n),i.base=r.slice(S,h),i.ext=r.slice(n,h))}return o>0?i.dir=r.slice(0,o-1):a&&(i.dir="/"),i},sep:"/",delimiter:":",win32:null,posix:null},e.$ic.win32=e.$hc.win32=e.$hc,e.$ic.posix=e.$hc.posix=e.$ic,e.$jc=d?e.$hc.normalize:e.$ic.normalize,e.$kc=d?e.$hc.isAbsolute:e.$ic.isAbsolute,e.$lc=d?e.$hc.join:e.$ic.join,e.$mc=d?e.$hc.resolve:e.$ic.resolve,e.$nc=d?e.$hc.relative:e.$ic.relative,e.$oc=d?e.$hc.dirname:e.$ic.dirname,e.$pc=d?e.$hc.basename:e.$ic.basename,e.$qc=d?e.$hc.extname:e.$ic.extname,e.$rc=d?e.$hc.format:e.$ic.format,e.$sc=d?e.$hc.parse:e.$ic.parse,e.$tc=d?e.$hc.toNamespacedPath:e.$ic.toNamespacedPath,e.sep=d?e.$hc.sep:e.$ic.sep,e.$vc=d?e.$hc.delimiter:e.$ic.delimiter}),define(ce[42],le([0,1,39,14,5,27,13]),function(ne,e,P,c,N,O,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xg=k,e.$yg=A,e.$zg=w,e.$Ag=E,e.$Bg=$,e.$Cg=d,e.$Dg=y,e.$Eg=f,e.$Fg=b,e.$Gg=I,e.$Hg=m,e.$Ig=s,e.$Jg=r,e.$Kg=i,e.$Lg=a,e.$Mg=t,e.$Ng=h;function k(g){return g===P.CharCode.Slash||g===P.CharCode.Backslash}function A(g){return g.replace(/[\\/]/g,c.$ic.sep)}function w(g){return g.indexOf("/")===-1&&(g=A(g)),/^[a-zA-Z]:(\/|$)/.test(g)&&(g="/"+g),g}function E(g,R=c.$ic.sep){if(!g)return"";const L=g.length,S=g.charCodeAt(0);if(k(S)){if(k(g.charCodeAt(1))&&!k(g.charCodeAt(2))){let C=3;const F=C;for(;C<L&&!k(g.charCodeAt(C));C++);if(F!==C&&!k(g.charCodeAt(C+1))){for(C+=1;C<L;C++)if(k(g.charCodeAt(C)))return g.slice(0,C+1).replace(/[\\/]/g,R)}}return R}else if(b(S)&&g.charCodeAt(1)===P.CharCode.Colon)return k(g.charCodeAt(2))?g.slice(0,2)+R:g.slice(0,2);let v=g.indexOf("://");if(v!==-1){for(v+=3;v<L;v++)if(k(g.charCodeAt(v)))return g.slice(0,v+1)}return""}function $(g){if(!N.$i||!g||g.length<5)return!1;let R=g.charCodeAt(0);if(R!==P.CharCode.Backslash||(R=g.charCodeAt(1),R!==P.CharCode.Backslash))return!1;let L=2;const S=L;for(;L<g.length&&(R=g.charCodeAt(L),R!==P.CharCode.Backslash);L++);return!(S===L||(R=g.charCodeAt(L+1),isNaN(R)||R===P.CharCode.Backslash))}const u=/[\\/:\*\?"<>\|]/g,p=/[/]/g,l=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function d(g,R=N.$i){const L=R?u:p;return!(!g||g.length===0||/^\s+$/.test(g)||(L.lastIndex=0,L.test(g))||R&&l.test(g)||g==="."||g===".."||R&&g[g.length-1]==="."||R&&g.length!==g.trim().length||g.length>255)}function y(g,R,L){const S=g===R;return!L||S?S:!g||!R?!1:(0,O.$Gf)(g,R)}function f(g,R,L,S=c.sep){if(g===R)return!0;if(!g||!R||R.length>g.length)return!1;if(L){if(!(0,O.$Hf)(g,R))return!1;if(R.length===g.length)return!0;let C=R.length;return R.charAt(R.length-1)===S&&C--,g.charAt(C)===S}return R.charAt(R.length-1)!==S&&(R+=S),g.indexOf(R)===0}function b(g){return g>=P.CharCode.A&&g<=P.CharCode.Z||g>=P.CharCode.a&&g<=P.CharCode.z}function I(g,R){return N.$i&&g.endsWith(":")&&(g+=c.sep),(0,c.$kc)(g)||(g=(0,c.$lc)(R,g)),g=(0,c.$jc)(g),m(g)}function m(g){return N.$i?(g=(0,O.$of)(g,c.sep),g.endsWith(":")&&(g+=c.sep)):(g=(0,O.$of)(g,c.sep),g||(g=c.sep)),g}function s(g){const R=(0,c.$jc)(g);return N.$i?g.length>3?!1:r(R)&&(g.length===2||R.charCodeAt(2)===P.CharCode.Backslash):R===c.$ic.sep}function r(g,R=N.$i){return R?b(g.charCodeAt(0))&&g.charCodeAt(1)===P.CharCode.Colon:!1}function i(g,R=N.$i){return r(g,R)?g[0]:void 0}function a(g,R,L){return R.length>g.length?-1:g===R?0:(L&&(g=g.toLowerCase(),R=R.toLowerCase()),g.indexOf(R))}function t(g){const R=g.split(":");let L,S,v;for(const C of R){const F=Number(C);(0,T.$jg)(F)?S===void 0?S=F:v===void 0&&(v=F):L=L?[L,C].join(":"):C}if(!L)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:L,line:S!==void 0?S:void 0,column:v!==void 0?v:S!==void 0?1:void 0}}const n="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",o="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function h(g,R,L=8){let S="";for(let C=0;C<L;C++){let F;C===0&&N.$i&&!R&&(L===3||L===4)?F=o:F=n,S+=F.charAt(Math.floor(Math.random()*F.length))}let v;return R?v=`${R}-${S}`:v=S,g?(0,c.$lc)(g,v):v}}),define(ce[147],le([0,1,14]),function(ne,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4s=void 0,e.$5s=O,e.$6s=T,e.$7s=k,e.$8s=w,e.$4s=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const c={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},N={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function O(E){const $=(0,P.$qc)(E),u=c[$.toLowerCase()];return u!==void 0?u:T(E)}function T(E){const $=(0,P.$qc)(E);return N[$.toLowerCase()]}function k(E){for(const $ in N)if(N[$]===E)return $}const A=/^(.+)\/(.+?)(;.+)?$/;function w(E,$){const u=A.exec(E);return u?`${u[1].toLowerCase()}/${u[2].toLowerCase()}${u[3]??""}`:$?void 0:E}}),define(ce[93],le([0,1,5]),function(ne,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminateResponseCode=e.Source=void 0,e.$km=O,e.$lm=T;var c;(function(k){k[k.stdout=0]="stdout",k[k.stderr=1]="stderr"})(c||(e.Source=c={}));var N;(function(k){k[k.Success=0]="Success",k[k.Unknown=1]="Unknown",k[k.AccessDenied=2]="AccessDenied",k[k.ProcessNotFound=3]="ProcessNotFound"})(N||(e.TerminateResponseCode=N={}));function O(k,...A){const w=A.reduce((u,p)=>(u[p]=!0,u),{}),E=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(k).filter(u=>!w[u]).forEach(u=>{for(let p=0;p<E.length;p++)if(u.search(E[p])!==-1){delete k[u];break}})}function T(k){k&&(delete k.DEBUG,P.$j&&delete k.DYLD_LIBRARY_PATH,P.$k&&delete k.LD_PRELOAD)}}),define(ce[9],le([0,1,39,65,14,5]),function(ne,e,P,c,N,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URI=void 0,e.$xc=y,e.$yc=r,N=Oe(N);const T=/^\w[\w\d+.-]*$/,k=/^\//,A=/^\/\//;function w(o,h){if(!o.scheme&&h)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${o.authority}", path: "${o.path}", query: "${o.query}", fragment: "${o.fragment}"}`);if(o.scheme&&!T.test(o.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(o.path){if(o.authority){if(!k.test(o.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(A.test(o.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function E(o,h){return!o&&!h?"file":o}function $(o,h){switch(o){case"https":case"http":case"file":h?h[0]!==p&&(h=p+h):h=p;break}return h}const u="",p="/",l=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class d{static isUri(h){return h instanceof d?!0:h?typeof h.authority=="string"&&typeof h.fragment=="string"&&typeof h.path=="string"&&typeof h.query=="string"&&typeof h.scheme=="string"&&typeof h.fsPath=="string"&&typeof h.with=="function"&&typeof h.toString=="function":!1}constructor(h,g,R,L,S,v=!1){typeof h=="object"?(this.scheme=h.scheme||u,this.authority=h.authority||u,this.path=h.path||u,this.query=h.query||u,this.fragment=h.fragment||u):(this.scheme=E(h,v),this.authority=g||u,this.path=$(this.scheme,R||u),this.query=L||u,this.fragment=S||u,w(this,v))}get fsPath(){return r(this,!1)}with(h){if(!h)return this;let{scheme:g,authority:R,path:L,query:S,fragment:v}=h;return g===void 0?g=this.scheme:g===null&&(g=u),R===void 0?R=this.authority:R===null&&(R=u),L===void 0?L=this.path:L===null&&(L=u),S===void 0?S=this.query:S===null&&(S=u),v===void 0?v=this.fragment:v===null&&(v=u),g===this.scheme&&R===this.authority&&L===this.path&&S===this.query&&v===this.fragment?this:new b(g,R,L,S,v)}static parse(h,g=!1){const R=l.exec(h);return R?new b(R[2]||u,n(R[4]||u),n(R[5]||u),n(R[7]||u),n(R[9]||u),g):new b(u,u,u,u,u)}static file(h){let g=u;if(O.$i&&(h=h.replace(/\\/g,p)),h[0]===p&&h[1]===p){const R=h.indexOf(p,2);R===-1?(g=h.substring(2),h=p):(g=h.substring(2,R),h=h.substring(R)||p)}return new b("file",g,h,u,u)}static from(h,g){return new b(h.scheme,h.authority,h.path,h.query,h.fragment,g)}static joinPath(h,...g){if(!h.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let R;return O.$i&&h.scheme==="file"?R=d.file(N.$hc.join(r(h,!0),...g)).path:R=N.$ic.join(h.path,...g),h.with({path:R})}toString(h=!1){return i(this,h)}toJSON(){return this}static revive(h){if(h){if(h instanceof d)return h;{const g=new b(h);return g._formatted=h.external??null,g._fsPath=h._sep===f?h.fsPath??null:null,g}}else return h}}e.URI=d;function y(o){return!o||typeof o!="object"?!1:typeof o.scheme=="string"&&(typeof o.authority=="string"||typeof o.authority>"u")&&(typeof o.path=="string"||typeof o.path>"u")&&(typeof o.query=="string"||typeof o.query>"u")&&(typeof o.fragment=="string"||typeof o.fragment>"u")}const f=O.$i?1:void 0;class b extends d{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=r(this,!1)),this._fsPath}toString(h=!1){return h?i(this,!0):(this._formatted||(this._formatted=i(this,!1)),this._formatted)}toJSON(){const h={$mid:c.MarshalledId.Uri};return this._fsPath&&(h.fsPath=this._fsPath,h._sep=f),this._formatted&&(h.external=this._formatted),this.path&&(h.path=this.path),this.scheme&&(h.scheme=this.scheme),this.authority&&(h.authority=this.authority),this.query&&(h.query=this.query),this.fragment&&(h.fragment=this.fragment),h}}const I={[P.CharCode.Colon]:"%3A",[P.CharCode.Slash]:"%2F",[P.CharCode.QuestionMark]:"%3F",[P.CharCode.Hash]:"%23",[P.CharCode.OpenSquareBracket]:"%5B",[P.CharCode.CloseSquareBracket]:"%5D",[P.CharCode.AtSign]:"%40",[P.CharCode.ExclamationMark]:"%21",[P.CharCode.DollarSign]:"%24",[P.CharCode.Ampersand]:"%26",[P.CharCode.SingleQuote]:"%27",[P.CharCode.OpenParen]:"%28",[P.CharCode.CloseParen]:"%29",[P.CharCode.Asterisk]:"%2A",[P.CharCode.Plus]:"%2B",[P.CharCode.Comma]:"%2C",[P.CharCode.Semicolon]:"%3B",[P.CharCode.Equals]:"%3D",[P.CharCode.Space]:"%20"};function m(o,h,g){let R,L=-1;for(let S=0;S<o.length;S++){const v=o.charCodeAt(S);if(v>=P.CharCode.a&&v<=P.CharCode.z||v>=P.CharCode.A&&v<=P.CharCode.Z||v>=P.CharCode.Digit0&&v<=P.CharCode.Digit9||v===P.CharCode.Dash||v===P.CharCode.Period||v===P.CharCode.Underline||v===P.CharCode.Tilde||h&&v===P.CharCode.Slash||g&&v===P.CharCode.OpenSquareBracket||g&&v===P.CharCode.CloseSquareBracket||g&&v===P.CharCode.Colon)L!==-1&&(R+=encodeURIComponent(o.substring(L,S)),L=-1),R!==void 0&&(R+=o.charAt(S));else{R===void 0&&(R=o.substr(0,S));const C=I[v];C!==void 0?(L!==-1&&(R+=encodeURIComponent(o.substring(L,S)),L=-1),R+=C):L===-1&&(L=S)}}return L!==-1&&(R+=encodeURIComponent(o.substring(L))),R!==void 0?R:o}function s(o){let h;for(let g=0;g<o.length;g++){const R=o.charCodeAt(g);R===P.CharCode.Hash||R===P.CharCode.QuestionMark?(h===void 0&&(h=o.substr(0,g)),h+=I[R]):h!==void 0&&(h+=o[g])}return h!==void 0?h:o}function r(o,h){let g;return o.authority&&o.path.length>1&&o.scheme==="file"?g=`//${o.authority}${o.path}`:o.path.charCodeAt(0)===P.CharCode.Slash&&(o.path.charCodeAt(1)>=P.CharCode.A&&o.path.charCodeAt(1)<=P.CharCode.Z||o.path.charCodeAt(1)>=P.CharCode.a&&o.path.charCodeAt(1)<=P.CharCode.z)&&o.path.charCodeAt(2)===P.CharCode.Colon?h?g=o.path.substr(1):g=o.path[1].toLowerCase()+o.path.substr(2):g=o.path,O.$i&&(g=g.replace(/\//g,"\\")),g}function i(o,h){const g=h?s:m;let R="",{scheme:L,authority:S,path:v,query:C,fragment:F}=o;if(L&&(R+=L,R+=":"),(S||L==="file")&&(R+=p,R+=p),S){let D=S.indexOf("@");if(D!==-1){const M=S.substr(0,D);S=S.substr(D+1),D=M.lastIndexOf(":"),D===-1?R+=g(M,!1,!1):(R+=g(M.substr(0,D),!1,!1),R+=":",R+=g(M.substr(D+1),!1,!0)),R+="@"}S=S.toLowerCase(),D=S.lastIndexOf(":"),D===-1?R+=g(S,!1,!0):(R+=g(S.substr(0,D),!1,!0),R+=S.substr(D))}if(v){if(v.length>=3&&v.charCodeAt(0)===P.CharCode.Slash&&v.charCodeAt(2)===P.CharCode.Colon){const D=v.charCodeAt(1);D>=P.CharCode.A&&D<=P.CharCode.Z&&(v=`/${String.fromCharCode(D+32)}:${v.substr(3)}`)}else if(v.length>=2&&v.charCodeAt(1)===P.CharCode.Colon){const D=v.charCodeAt(0);D>=P.CharCode.A&&D<=P.CharCode.Z&&(v=`${String.fromCharCode(D+32)}:${v.substr(2)}`)}R+=g(v,!0,!1)}return C&&(R+="?",R+=g(C,!1,!1)),F&&(R+="#",R+=h?F:m(F,!1,!1)),R}function a(o){try{return decodeURIComponent(o)}catch{return o.length>3?o.substr(0,3)+a(o.substr(3)):o}}const t=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function n(o){return o.match(t)?o.replace(t,h=>a(h)):o}}),define(ce[148],le([0,1,9]),function(ne,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9q=c,e.$0q=N,e.$$q=O,e.log=k;function c(w){const E=w;return E&&typeof E.type=="string"&&typeof E.severity=="string"}function N(w){const E=[];let $;try{const u=JSON.parse(w.arguments),p=u[u.length-1];p&&p.__$stack&&(u.pop(),$=p.__$stack),E.push(...u)}catch{E.push("Unable to log remote console arguments",w.arguments)}return{args:E,stack:$}}function O(w){if(typeof w!="string")return O(N(w).stack);const E=w;if(E){const $=T(E),u=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec($||"");if(u&&u.length===4)return{uri:P.URI.file(u[1]),line:Number(u[2]),column:Number(u[3])}}}function T(w){if(!w)return w;const E=w.indexOf(`
`);return E===-1?w:w.substring(0,E)}function k(w,E){const{args:$,stack:u}=N(w),p=typeof $[0]=="string"&&$.length===1;let l=T(u);l&&(l=`(${l.trim()})`);let d=[];if(typeof $[0]=="string"?l&&p?d=[`%c[${E}] %c${$[0]} %c${l}`,A("blue"),A(""),A("grey")]:d=[`%c[${E}] %c${$[0]}`,A("blue"),A(""),...$.slice(1)]:d=[`%c[${E}]%`,A("blue"),...$],l&&!p&&d.push(l),typeof console[w.severity]!="function")throw new Error("Unknown console method");console[w.severity].apply(console,d)}function A(w){return`color: ${w}`}}),define(ce[68],le([0,1,15,9,65]),function(ne,e,P,c,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ai=O,e.$bi=T,e.$ci=A;function O(w){return JSON.stringify(w,k)}function T(w){let E=JSON.parse(w);return E=A(E),E}function k(w,E){return E instanceof RegExp?{$mid:N.MarshalledId.Regexp,source:E.source,flags:E.flags}:E}function A(w,E=0){if(!w||E>200)return w;if(typeof w=="object"){switch(w.$mid){case N.MarshalledId.Uri:return c.URI.revive(w);case N.MarshalledId.Regexp:return new RegExp(w.source,w.flags);case N.MarshalledId.Date:return new Date(w.source)}if(w instanceof P.$Oe||w instanceof Uint8Array)return w;if(Array.isArray(w))for(let $=0;$<w.length;++$)w[$]=A(w[$],E+1);else for(const $ in w)Object.hasOwnProperty.call(w,$)&&(w[$]=A(w[$],E+1))}return w}}),define(ce[23],le([0,1,8,5,27,9,14]),function(ne,e,P,c,N,O,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Sg=e.$Rg=e.$Qg=e.Schemas=void 0,e.$Og=A,e.$Pg=w,e.$Tg=$,P=Oe(P),c=Oe(c),T=Oe(T);var k;(function(l){l.inMemory="inmemory",l.vscode="vscode",l.internal="private",l.walkThrough="walkThrough",l.walkThroughSnippet="walkThroughSnippet",l.http="http",l.https="https",l.file="file",l.mailto="mailto",l.untitled="untitled",l.data="data",l.command="command",l.vscodeRemote="vscode-remote",l.vscodeRemoteResource="vscode-remote-resource",l.vscodeManagedRemoteResource="vscode-managed-remote-resource",l.vscodeUserData="vscode-userdata",l.vscodeCustomEditor="vscode-custom-editor",l.vscodeNotebookCell="vscode-notebook-cell",l.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",l.vscodeNotebookCellOutput="vscode-notebook-cell-output",l.vscodeInteractiveInput="vscode-interactive-input",l.vscodeSettings="vscode-settings",l.vscodeWorkspaceTrust="vscode-workspace-trust",l.vscodeTerminal="vscode-terminal",l.vscodeChatCodeBlock="vscode-chat-code-block",l.vscodeCopilotBackingChatCodeBlock="vscode-copilot-chat-code-block",l.vscodeChatCodeCompareBlock="vscode-chat-code-compare-block",l.vscodeChatSesssion="vscode-chat-editor",l.webviewPanel="webview-panel",l.vscodeWebview="vscode-webview",l.extension="extension",l.vscodeFileResource="vscode-file",l.tmp="tmp",l.vsls="vsls",l.vscodeSourceControl="vscode-scm",l.commentsInput="comment",l.codeSetting="code-setting"})(k||(e.Schemas=k={}));function A(l,d){return O.URI.isUri(l)?(0,N.$Gf)(l.scheme,d):(0,N.$Hf)(l,d+":")}function w(l,...d){return d.some(y=>A(l,y))}e.$Qg="vscode-tkn",e.$Rg="tkn";class E{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f="/"}setPreferredWebSchema(d){this.d=d}setDelegate(d){this.e=d}setServerRootPath(d,y){this.f=$(d,y)}getServerRootPath(){return this.f}get g(){return T.$ic.join(this.f,k.vscodeRemoteResource)}set(d,y,f){this.a[d]=y,this.b[d]=f}setConnectionToken(d,y){this.c[d]=y}getPreferredWebSchema(){return this.d}rewrite(d){if(this.e)try{return this.e(d)}catch(s){return P.$3(s),d}const y=d.authority;let f=this.a[y];f&&f.indexOf(":")!==-1&&f.indexOf("[")===-1&&(f=`[${f}]`);const b=this.b[y],I=this.c[y];let m=`path=${encodeURIComponent(d.path)}`;return typeof I=="string"&&(m+=`&${e.$Rg}=${encodeURIComponent(I)}`),O.URI.from({scheme:c.$o?this.d:k.vscodeRemoteResource,authority:`${f}:${b}`,path:this.g,query:m})}}e.$Sg=new E;function $(l,d){return T.$ic.join(d??"/",`${l.quality??"oss"}-${l.commit??"dev"}`)}e.$Ug="vs/../../extensions",e.$Vg="vs/../../node_modules",e.$Wg="vs/../../node_modules.asar",e.$Xg="vs/../../node_modules.asar.unpacked",e.$Yg="vscode-app";class u{static{this.a=e.$Yg}asBrowserUri(d){const y=this.b(d,ne);return this.uriToBrowserUri(y)}uriToBrowserUri(d){return d.scheme===k.vscodeRemote?e.$Sg.rewrite(d):d.scheme===k.file&&(c.$m||c.$q===`${k.vscodeFileResource}://${u.a}`)?d.with({scheme:k.vscodeFileResource,authority:d.authority||u.a,query:null,fragment:null}):d}asFileUri(d){const y=this.b(d,ne);return this.uriToFileUri(y)}uriToFileUri(d){return d.scheme===k.vscodeFileResource?d.with({scheme:k.file,authority:d.authority!==u.a?d.authority:null,query:null,fragment:null}):d}b(d,y){return O.URI.isUri(d)?d:O.URI.parse(y.toUrl(d))}}e.$Zg=new u;var p;(function(l){const d=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);l.CoopAndCoep=Object.freeze(d.get("3"));const y="vscode-coi";function f(I){let m;typeof I=="string"?m=new URL(I).searchParams:I instanceof URL?m=I.searchParams:O.URI.isUri(I)&&(m=new URL(I.toString(!0)).searchParams);const s=m?.get(y);if(s)return d.get(s)}l.getHeadersFromQuery=f;function b(I,m,s){if(!globalThis.crossOriginIsolated)return;const r=m&&s?"3":s?"2":"1";I instanceof URLSearchParams?I.set(y,r):I[y]=r}l.addSearchParam=b})(p||(e.COI=p={}))}),define(ce[149],le([0,1,129,23,5,9]),function(ne,e,P,c,N,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oE=E,N=Oe(N);class T{constructor(u,p,l){this.id=u,this.dependencies=p,this.callback=l}}class k{static{this.INSTANCE=new k}constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=(u,p,l)=>{typeof u!="string"&&(l=p,p=u,u=null),(typeof p!="object"||!Array.isArray(p))&&(l=p,p=null),this.c.push(new T(u,p,l))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(u){if(u.startsWith(window.location.origin)||u.startsWith("vscode-file://vscode-app"))return u;throw new Error(`[trusted_script_src] Invalid script url: ${u}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(u){return u}})))}async load(u){this.g();const p=await(this.a?this.i(u):this.b?this.h(u):this.j(u));if(!p)throw new Error(`Did not receive a define call from script ${u}`);if(Array.isArray(p.dependencies)&&p.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${u}. The dependencies are: ${p.dependencies.join(", ")}`);return typeof p.callback=="function"?p.callback([]):p.callback}h(u){return new Promise((p,l)=>{const d=document.createElement("script");d.setAttribute("async","async"),d.setAttribute("type","text/javascript");const y=()=>{d.removeEventListener("load",f),d.removeEventListener("error",b)},f=I=>{y(),p(this.c.pop())},b=I=>{y(),l(I)};d.addEventListener("load",f),d.addEventListener("error",b),this.f&&(u=this.f.createScriptURL(u)),d.setAttribute("src",u),window.document.getElementsByTagName("head")[0].appendChild(d)})}i(u){return new Promise((p,l)=>{try{this.f&&(u=this.f.createScriptURL(u)),importScripts(u),p(this.c.pop())}catch(d){l(d)}})}async j(u){try{const p=globalThis._VSCODE_NODE_MODULES.fs,l=globalThis._VSCODE_NODE_MODULES.vm,d=globalThis._VSCODE_NODE_MODULES.module,y=O.URI.parse(u).fsPath,f=p.readFileSync(y).toString(),b=d.wrap(f.replace(/^#!.*/,""));return new l.Script(b).runInThisContext().apply(),this.c.pop()}catch(p){throw p}}}const A=new Map;let w={};typeof globalThis.require=="object"&&(w=globalThis.require.paths??{});async function E($,u,p){if(P.$V){p===void 0&&(p=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),w[$]&&($=w[$]);const l=`${$}/${u}`;if(A.has(l))return A.get(l);let d;if(/^\w[\w\d+.-]*:\/\//.test(l))d=l;else{const I=`${p&&!N.$o?c.$Wg:c.$Vg}/${l}`;d=c.$Zg.asBrowserUri(I).toString(!0)}const y=k.INSTANCE.load(d);return A.set(l,y),y}else return await new Promise((l,d)=>{ne([$],l,d)}).then(Oe)}}),define(ce[21],le([0,1,39,42,23,14,5,27,9]),function(ne,e,P,c,N,O,T,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataUri=e.$oh=e.$nh=e.$mh=e.$lh=e.$kh=e.$jh=e.$ih=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=void 0,e.$7g=w,e.$ph=$,e.$qh=p,c=Oe(c),O=Oe(O);function w(l){return(0,A.$yc)(l,!0)}class E{constructor(d){this.a=d}compare(d,y,f=!1){return d===y?0:(0,k.$zf)(this.getComparisonKey(d,f),this.getComparisonKey(y,f))}isEqual(d,y,f=!1){return d===y?!0:!d||!y?!1:this.getComparisonKey(d,f)===this.getComparisonKey(y,f)}getComparisonKey(d,y=!1){return d.with({path:this.a(d)?d.path.toLowerCase():void 0,fragment:y?null:void 0}).toString()}ignorePathCasing(d){return this.a(d)}isEqualOrParent(d,y,f=!1){if(d.scheme===y.scheme){if(d.scheme===N.Schemas.file)return c.$Eg(w(d),w(y),this.a(d))&&d.query===y.query&&(f||d.fragment===y.fragment);if((0,e.$lh)(d.authority,y.authority))return c.$Eg(d.path,y.path,this.a(d),"/")&&d.query===y.query&&(f||d.fragment===y.fragment)}return!1}joinPath(d,...y){return A.URI.joinPath(d,...y)}basenameOrAuthority(d){return(0,e.$dh)(d)||d.authority}basename(d){return O.$ic.basename(d.path)}extname(d){return O.$ic.extname(d.path)}dirname(d){if(d.path.length===0)return d;let y;return d.scheme===N.Schemas.file?y=A.URI.file(O.$oc(w(d))).path:(y=O.$ic.dirname(d.path),d.authority&&y.length&&y.charCodeAt(0)!==P.CharCode.Slash&&(console.error(`dirname("${d.toString})) resulted in a relative path`),y="/")),d.with({path:y})}normalizePath(d){if(!d.path.length)return d;let y;return d.scheme===N.Schemas.file?y=A.URI.file(O.$jc(w(d))).path:y=O.$ic.normalize(d.path),d.with({path:y})}relativePath(d,y){if(d.scheme!==y.scheme||!(0,e.$lh)(d.authority,y.authority))return;if(d.scheme===N.Schemas.file){const I=O.$nc(w(d),w(y));return T.$i?c.$yg(I):I}let f=d.path||"/";const b=y.path||"/";if(this.a(d)){let I=0;for(const m=Math.min(f.length,b.length);I<m&&!(f.charCodeAt(I)!==b.charCodeAt(I)&&f.charAt(I).toLowerCase()!==b.charAt(I).toLowerCase());I++);f=b.substr(0,I)+f.substr(I)}return O.$ic.relative(f,b)}resolvePath(d,y){if(d.scheme===N.Schemas.file){const f=A.URI.file(O.$mc(w(d),y));return d.with({authority:f.authority,path:f.path})}return y=c.$zg(y),d.with({path:O.$ic.resolve(d.path,y)})}isAbsolutePath(d){return!!d.path&&d.path[0]==="/"}isEqualAuthority(d,y){return d===y||d!==void 0&&y!==void 0&&(0,k.$Gf)(d,y)}hasTrailingPathSeparator(d,y=O.sep){if(d.scheme===N.Schemas.file){const f=w(d);return f.length>c.$Ag(f).length&&f[f.length-1]===y}else{const f=d.path;return f.length>1&&f.charCodeAt(f.length-1)===P.CharCode.Slash&&!/^[a-zA-Z]:(\/$|\\$)/.test(d.fsPath)}}removeTrailingPathSeparator(d,y=O.sep){return(0,e.$mh)(d,y)?d.with({path:d.path.substr(0,d.path.length-1)}):d}addTrailingPathSeparator(d,y=O.sep){let f=!1;if(d.scheme===N.Schemas.file){const b=w(d);f=b!==void 0&&b.length===c.$Ag(b).length&&b[b.length-1]===y}else{y="/";const b=d.path;f=b.length===1&&b.charCodeAt(b.length-1)===P.CharCode.Slash}return!f&&!(0,e.$mh)(d,y)?d.with({path:d.path+"/"}):d}}e.$8g=E,e.$9g=new E(()=>!1),e.$0g=new E(l=>l.scheme===N.Schemas.file?!T.$k:!0),e.$$g=new E(l=>!0),e.$_g=e.$9g.isEqual.bind(e.$9g),e.$ah=e.$9g.isEqualOrParent.bind(e.$9g),e.$bh=e.$9g.getComparisonKey.bind(e.$9g),e.$ch=e.$9g.basenameOrAuthority.bind(e.$9g),e.$dh=e.$9g.basename.bind(e.$9g),e.$eh=e.$9g.extname.bind(e.$9g),e.$fh=e.$9g.dirname.bind(e.$9g),e.$gh=e.$9g.joinPath.bind(e.$9g),e.$hh=e.$9g.normalizePath.bind(e.$9g),e.$ih=e.$9g.relativePath.bind(e.$9g),e.$jh=e.$9g.resolvePath.bind(e.$9g),e.$kh=e.$9g.isAbsolutePath.bind(e.$9g),e.$lh=e.$9g.isEqualAuthority.bind(e.$9g),e.$mh=e.$9g.hasTrailingPathSeparator.bind(e.$9g),e.$nh=e.$9g.removeTrailingPathSeparator.bind(e.$9g),e.$oh=e.$9g.addTrailingPathSeparator.bind(e.$9g);function $(l,d){const y=[];for(let f=0;f<l.length;f++){const b=d(l[f]);l.some((I,m)=>m===f?!1:(0,e.$ah)(b,d(I)))||y.push(l[f])}return y}var u;(function(l){l.META_DATA_LABEL="label",l.META_DATA_DESCRIPTION="description",l.META_DATA_SIZE="size",l.META_DATA_MIME="mime";function d(y){const f=new Map;y.path.substring(y.path.indexOf(";")+1,y.path.lastIndexOf(";")).split(";").forEach(m=>{const[s,r]=m.split(":");s&&r&&f.set(s,r)});const I=y.path.substring(0,y.path.indexOf(";"));return I&&f.set(l.META_DATA_MIME,I),f}l.parseMetaData=d})(u||(e.DataUri=u={}));function p(l,d,y){if(d){let f=l.path;return f&&f[0]!==O.$ic.sep&&(f=O.$ic.sep+f),l.with({scheme:y,authority:d,path:f})}return l.with({scheme:y})}}),define(ce[6],le([0,1,26,8,3,2,21,5,135,54]),function(ne,e,P,c,N,O,T,k,A,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9h=e.$7h=e.$6h=e.$5h=e.$4h=e.Promises=e.$3h=e.$2h=e.$1h=e.$Yh=e.$Xh=e.$Wh=e.$Vh=e.$Uh=e.$Th=e.$Sh=e.$Rh=e.$Qh=e.$Ph=e.$Oh=e.$Nh=e.$Mh=e.$Lh=e.$Fh=e.$Eh=e.$Dh=e.$Ch=e.$Bh=e.$Ah=e.$zh=void 0,e.$rh=E,e.$sh=$,e.$th=u,e.$uh=p,e.$vh=l,e.$wh=d,e.$xh=y,e.$yh=f,e.$Gh=o,e.$Hh=h,e.$Ih=g,e.$Jh=R,e.$Kh=L,e.$Zh=z,e.$8h=W;function E(_){return!!_&&typeof _.then=="function"}function $(_){const Q=new P.$xe,ae=_(Q.token),ue=new Promise((ge,we)=>{const Ee=Q.token.onCancellationRequested(()=>{Ee.dispose(),we(new c.$7)});Promise.resolve(ae).then(pe=>{Ee.dispose(),Q.dispose(),ge(pe)},pe=>{Ee.dispose(),Q.dispose(),we(pe)})});return new class{cancel(){Q.cancel(),Q.dispose()}then(ge,we){return ue.then(ge,we)}catch(ge){return this.then(void 0,ge)}finally(ge){return ue.finally(ge)}}}function u(_,Q,ae){return new Promise((ue,ge)=>{const we=Q.onCancellationRequested(()=>{we.dispose(),ue(ae)});_.then(ue,ge).finally(()=>we.dispose())})}function p(_,Q){return new Promise((ae,ue)=>{const ge=Q.onCancellationRequested(()=>{ge.dispose(),ue(new c.$7)});_.then(ae,ue).finally(()=>ge.dispose())})}async function l(_){let Q=-1;const ae=_.map((ue,ge)=>ue.then(we=>(Q=ge,we)));try{return await Promise.race(ae)}finally{_.forEach((ue,ge)=>{ge!==Q&&ue.cancel()})}}function d(_,Q,ae){let ue;const ge=setTimeout(()=>{ue?.(void 0),ae?.()},Q);return Promise.race([_.finally(()=>clearTimeout(ge)),new Promise(we=>ue=we)])}function y(_){return new Promise((Q,ae)=>{const ue=_();E(ue)?ue.then(Q,ae):Q(ue)})}function f(){let _,Q;return{promise:new Promise((ue,ge)=>{_=ue,Q=ge}),resolve:_,reject:Q}}class b{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(Q){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=Q,!this.b){const ae=()=>{if(this.b=null,this.f)return;const ue=this.queue(this.d);return this.d=null,ue};this.b=new Promise(ue=>{this.a.then(ae,ae).then(ue)})}return new Promise((ae,ue)=>{this.b.then(ae,ue)})}return this.a=Q(),new Promise((ae,ue)=>{this.a.then(ge=>{this.a=null,ae(ge)},ge=>{this.a=null,ue(ge)})})}dispose(){this.f=!0}}e.$zh=b;class I{constructor(){this.a=Promise.resolve(null)}queue(Q){return this.a=this.a.then(()=>Q(),()=>Q())}}e.$Ah=I;class m{constructor(){this.a=new Map}queue(Q,ae){const ge=(this.a.get(Q)??Promise.resolve()).catch(()=>{}).then(ae).finally(()=>{this.a.get(Q)===ge&&this.a.delete(Q)});return this.a.set(Q,ge),ge}}e.$Bh=m;const s=(_,Q)=>{let ae=!0;const ue=setTimeout(()=>{ae=!1,Q()},_);return{isTriggered:()=>ae,dispose:()=>{clearTimeout(ue),ae=!1}}},r=_=>{let Q=!0;return queueMicrotask(()=>{Q&&(Q=!1,_())}),{isTriggered:()=>Q,dispose:()=>{Q=!1}}};class i{constructor(Q){this.defaultDelay=Q,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(Q,ae=this.defaultDelay){this.g=Q,this.h(),this.b||(this.b=new Promise((ge,we)=>{this.d=ge,this.f=we}).then(()=>{if(this.b=null,this.d=null,this.g){const ge=this.g;return this.g=null,ge()}}));const ue=()=>{this.a=null,this.d?.(null)};return this.a=ae===A.$he?r(ue):s(ae,ue),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new c.$7),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$Ch=i;class a{constructor(Q){this.a=new i(Q),this.b=new b}trigger(Q,ae){return this.a.trigger(()=>this.b.queue(Q),ae)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$Dh=a;class t{constructor(){this.a=!1,this.b=new Promise((Q,ae)=>{this.d=Q})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$Eh=t;class n extends t{constructor(Q){super(),this.f=setTimeout(()=>this.open(),Q)}open(){clearTimeout(this.f),super.open()}}e.$Fh=n;function o(_,Q){return Q?new Promise((ae,ue)=>{const ge=setTimeout(()=>{we.dispose(),ae()},_),we=Q.onCancellationRequested(()=>{clearTimeout(ge),we.dispose(),ue(new c.$7)})}):$(ae=>o(_,ae))}function h(_,Q=0,ae){const ue=setTimeout(()=>{_(),ae&&ge.dispose()},Q),ge=(0,O.$Uc)(()=>{clearTimeout(ue),ae?.deleteAndLeak(ge)});return ae?.add(ge),ge}function g(_){const Q=[];let ae=0;const ue=_.length;function ge(){return ae<ue?_[ae++]():null}function we(Ee){Ee!=null&&Q.push(Ee);const pe=ge();return pe?pe.then(we):Promise.resolve(Q)}return Promise.resolve(null).then(we)}function R(_,Q=ue=>!!ue,ae=null){let ue=0;const ge=_.length,we=()=>{if(ue>=ge)return Promise.resolve(ae);const Ee=_[ue++];return Promise.resolve(Ee()).then(be=>Q(be)?Promise.resolve(be):we())};return we()}function L(_,Q=ue=>!!ue,ae=null){if(_.length===0)return Promise.resolve(ae);let ue=_.length;const ge=()=>{ue=-1;for(const we of _)we.cancel?.()};return new Promise((we,Ee)=>{for(const pe of _)pe.then(be=>{--ue>=0&&Q(be)?(ge(),we(be)):ue===0&&we(ae)}).catch(be=>{--ue>=0&&(ge(),Ee(be))})})}class S{constructor(Q){this.a=0,this.b=!1,this.f=Q,this.g=[],this.d=0,this.h=new N.$me}whenIdle(){return this.size>0?N.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(Q){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((ae,ue)=>{this.g.push({factory:Q,c:ae,e:ue}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const Q=this.g.shift();this.d++;const ae=Q.factory();ae.then(Q.c,Q.e),ae.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$Lh=S;class v extends S{constructor(){super(1)}}e.$Mh=v;class C{constructor(){this.a=new ee,this.b=0}queue(Q){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,Q())):this.a.run(this.b++,Q())}}e.$Nh=C;class F{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const Q=new q;return this.b.add(Q),Q.p}g(){for(const[,Q]of this.a)if(Q.size>0)return!1;return!0}queueSize(Q,ae=T.$9g){const ue=ae.getComparisonKey(Q);return this.a.get(ue)?.size??0}queueFor(Q,ae,ue=T.$9g){const ge=ue.getComparisonKey(Q);let we=this.a.get(ge);if(!we){we=new v;const Ee=this.f++,pe=N.Event.once(we.onDrained)(()=>{we?.dispose(),this.a.delete(ge),this.h(),this.d?.deleteAndDispose(Ee),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new O.$6c),this.d.set(Ee,pe),this.a.set(ge,we)}return we.queue(ae)}h(){this.g()&&this.j()}j(){for(const Q of this.b)Q.complete();this.b.clear()}dispose(){for(const[,Q]of this.a)Q.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$Oh=F;class D{constructor(Q,ae){this.b=!1,this.a=-1,typeof Q=="function"&&typeof ae=="number"&&this.setIfNotSet(Q,ae)}dispose(){this.cancel(),this.b=!0}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(Q,ae){if(this.b)throw new c.$eb("Calling 'cancelAndSet' on a disposed TimeoutTimer");this.cancel(),this.a=setTimeout(()=>{this.a=-1,Q()},ae)}setIfNotSet(Q,ae){if(this.b)throw new c.$eb("Calling 'setIfNotSet' on a disposed TimeoutTimer");this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,Q()},ae))}}e.$Ph=D;class M{constructor(){this.d=void 0,this.f=!1}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(Q,ae,ue=globalThis){if(this.f)throw new c.$eb("Calling 'cancelAndSet' on a disposed IntervalTimer");this.cancel();const ge=ue.setInterval(()=>{Q()},ae);this.d=(0,O.$Uc)(()=>{ue.clearInterval(ge),this.d=void 0})}dispose(){this.cancel(),this.f=!0}}e.$Qh=M;class J{constructor(Q,ae){this.b=-1,this.a=Q,this.d=ae,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(Q=this.d){this.cancel(),this.b=setTimeout(this.f,Q)}get delay(){return this.d}set delay(Q){this.d=Q}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$Rh=J;class H{constructor(Q,ae){ae%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${ae}ms is not a multiple of 1000ms.`),this.a=Q,this.b=ae,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(Q=this.b){Q%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${Q}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(Q/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$Sh=H;class x extends J{constructor(Q,ae){super(Q,ae),this.j=[]}work(Q){this.j.push(Q),this.isScheduled()||this.schedule()}h(){const Q=this.j;this.j=[],this.a?.(Q)}dispose(){this.j=[],super.dispose()}}e.$Th=x;class K extends O.$Wc{constructor(Q,ae){super(),this.g=Q,this.h=ae,this.a=[],this.b=this.B(new O.$Xc),this.f=!1}get pending(){return this.a.length}work(Q){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+Q.length>this.g.maxBufferedWork)return!1}else if(this.pending+Q.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const ae of Q)this.a.push(ae);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new J(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$Uh=K,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$Wh=(_,Q)=>{(0,k.$B)(()=>{if(ae)return;const ue=Date.now()+15;Q(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,ue-Date.now())}}))});let ae=!1;return{dispose(){ae||(ae=!0)}}}:e.$Wh=(_,Q,ae)=>{const ue=_.requestIdleCallback(Q,typeof ae=="number"?{timeout:ae}:void 0);let ge=!1;return{dispose(){ge||(ge=!0,_.cancelIdleCallback(ue))}}},e.$Vh=_=>(0,e.$Wh)(globalThis,_)}();class ie{constructor(Q,ae){this.g=!1,this.d=()=>{try{this.j=ae()}catch(ue){this.l=ue}finally{this.g=!0}},this.f=(0,e.$Wh)(Q,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$Xh=ie;class V extends ie{constructor(Q){super(globalThis,Q)}}e.$Yh=V;async function z(_,Q,ae){let ue;for(let ge=0;ge<ae;ge++)try{return await _()}catch(we){ue=we,await o(Q)}throw ue}class ee{isRunning(Q){return typeof Q=="number"?this.a?.taskId===Q:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(Q,ae,ue){return this.a={taskId:Q,cancel:()=>ue?.(),promise:ae},ae.then(()=>this.d(Q),()=>this.d(Q)),ae}d(Q){this.a&&Q===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const Q=this.b;this.b=void 0,Q.run().then(Q.promiseResolve,Q.promiseReject)}}queue(Q){if(this.b)this.b.run=Q;else{const{promise:ae,resolve:ue,reject:ge}=f();this.b={run:Q,promise:ae,promiseResolve:ue,promiseReject:ge}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$1h=ee;class se{constructor(Q,ae=()=>Date.now()){this.d=Q,this.f=ae,this.a=0,this.b=0}increment(){const Q=this.f();return Q-this.a>this.d&&(this.a=Q,this.b=0),this.b++,this.b}}e.$2h=se;var he;(function(_){_[_.Resolved=0]="Resolved",_[_.Rejected=1]="Rejected"})(he||(he={}));class q{get isRejected(){return this.d?.outcome===he.Rejected}get isResolved(){return this.d?.outcome===he.Resolved}get isSettled(){return!!this.d}get value(){return this.d?.outcome===he.Resolved?this.d?.value:void 0}constructor(){this.p=new Promise((Q,ae)=>{this.a=Q,this.b=ae})}complete(Q){return new Promise(ae=>{this.a(Q),this.d={outcome:he.Resolved,value:Q},ae()})}error(Q){return new Promise(ae=>{this.b(Q),this.d={outcome:he.Rejected,value:Q},ae()})}cancel(){return this.error(new c.$7)}}e.$3h=q;var Z;(function(_){async function Q(ue){let ge;const we=await Promise.all(ue.map(Ee=>Ee.then(pe=>pe,pe=>{ge||(ge=pe)})));if(typeof ge<"u")throw ge;return we}_.settled=Q;function ae(ue){return new Promise(async(ge,we)=>{try{await ue(ge,we)}catch(Ee){we(Ee)}})}_.withAsyncBody=ae})(Z||(e.Promises=Z={}));class X{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(Q){this.a=void 0,this.b=void 0,this.d=!1,this.promise=Q.then(ae=>(this.a=ae,this.d=!0,ae),ae=>{throw this.b=ae,this.d=!0,ae})}requireValue(){if(!this.d)throw new c.$eb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$4h=X;class G{constructor(Q){this.b=Q,this.a=new w.$X(()=>new X(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}e.$5h=G;var U;(function(_){_[_.Initial=0]="Initial",_[_.DoneOK=1]="DoneOK",_[_.DoneError=2]="DoneError"})(U||(U={}));class B{static fromArray(Q){return new B(ae=>{ae.emitMany(Q)})}static fromPromise(Q){return new B(async ae=>{ae.emitMany(await Q)})}static fromPromises(Q){return new B(async ae=>{await Promise.all(Q.map(async ue=>ae.emitOne(await ue)))})}static merge(Q){return new B(async ae=>{await Promise.all(Q.map(async ue=>{for await(const ge of ue)ae.emitOne(ge)}))})}static{this.EMPTY=B.fromArray([])}constructor(Q,ae){this.a=U.Initial,this.b=[],this.d=null,this.f=ae,this.g=new N.$me,queueMicrotask(async()=>{const ue={emitOne:ge=>this.h(ge),emitMany:ge=>this.j(ge),reject:ge=>this.l(ge)};try{await Promise.resolve(Q(ue)),this.k()}catch(ge){this.l(ge)}finally{ue.emitOne=void 0,ue.emitMany=void 0,ue.reject=void 0}})}[Symbol.asyncIterator](){let Q=0;return{next:async()=>{do{if(this.a===U.DoneError)throw this.d;if(Q<this.b.length)return{done:!1,value:this.b[Q++]};if(this.a===U.DoneOK)return{done:!0,value:void 0};await N.Event.toPromise(this.g.event)}while(!0)},return:async()=>(this.f?.(),{done:!0,value:void 0})}}static map(Q,ae){return new B(async ue=>{for await(const ge of Q)ue.emitOne(ae(ge))})}map(Q){return B.map(this,Q)}static filter(Q,ae){return new B(async ue=>{for await(const ge of Q)ae(ge)&&ue.emitOne(ge)})}filter(Q){return B.filter(this,Q)}static coalesce(Q){return B.filter(Q,ae=>!!ae)}coalesce(){return B.coalesce(this)}static async toPromise(Q){const ae=[];for await(const ue of Q)ae.push(ue);return ae}toPromise(){return B.toPromise(this)}h(Q){this.a===U.Initial&&(this.b.push(Q),this.g.fire())}j(Q){this.a===U.Initial&&(this.b=this.b.concat(Q),this.g.fire())}k(){this.a===U.Initial&&(this.a=U.DoneOK,this.g.fire())}l(Q){this.a===U.Initial&&(this.a=U.DoneError,this.d=Q,this.g.fire())}}e.$6h=B;class j extends B{constructor(Q,ae){super(ae),this.m=Q}cancel(){this.m.cancel()}}e.$7h=j;function W(_){const Q=new P.$xe,ae=_(Q.token);return new j(Q,async ue=>{const ge=Q.token.onCancellationRequested(()=>{ge.dispose(),Q.dispose(),ue.reject(new c.$7)});try{for await(const we of ae){if(Q.token.isCancellationRequested)return;ue.emitOne(we)}ge.dispose(),Q.dispose()}catch(we){ge.dispose(),Q.dispose(),ue.reject(we)}})}class te{constructor(Q){this.a=new q,this.b=new B(ge=>{if(ae){ge.reject(ae);return}return ue&&ge.emitMany(ue),this.d=we=>ge.reject(we),this.f=we=>ge.emitOne(we),this.a.p},Q);let ae,ue;this.f=ge=>{ue||(ue=[]),ue.push(ge)},this.d=ge=>{ae||(ae=ge)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(Q){this.d(Q),this.a.complete()}emitOne(Q){this.f(Q)}}e.$9h=te}),define(ce[94],le([0,1,19,6,39,42,35,14,5,27]),function(ne,e,P,c,N,O,T,k,A,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wk=e.$vk=void 0,e.$uk=E,e.$xk=d,e.$yk=C,e.$zk=F,e.$Ak=D,e.$Bk=M,e.$Ck=J,e.$Dk=ie;function E(){return Object.create(null)}e.$vk="**",e.$wk="/";const $="[/\\\\]",u="[^/\\\\]",p=/\//g;function l(V,z){switch(V){case 0:return"";case 1:return`${u}*?`;default:return`(?:${$}|${u}+${$}${z?`|${$}${u}+`:""})*?`}}function d(V,z){if(!V)return[];const ee=[];let se=!1,he=!1,q="";for(const Z of V){switch(Z){case z:if(!se&&!he){ee.push(q),q="";continue}break;case"{":se=!0;break;case"}":se=!1;break;case"[":he=!0;break;case"]":he=!1;break}q+=Z}return q&&ee.push(q),ee}function y(V){if(!V)return"";let z="";const ee=d(V,e.$wk);if(ee.every(se=>se===e.$vk))z=".*";else{let se=!1;ee.forEach((he,q)=>{if(he===e.$vk){if(se)return;z+=l(2,q===ee.length-1)}else{let Z=!1,X="",G=!1,U="";for(const B of he){if(B!=="}"&&Z){X+=B;continue}if(G&&(B!=="]"||!U)){let j;B==="-"?j=B:(B==="^"||B==="!")&&!U?j="^":B===e.$wk?j="":j=(0,w.$if)(B),U+=j;continue}switch(B){case"{":Z=!0;continue;case"[":G=!0;continue;case"}":{const W=`(?:${d(X,",").map(te=>y(te)).join("|")})`;z+=W,Z=!1,X="";break}case"]":{z+="["+U+"]",G=!1,U="";break}case"?":z+=u;continue;case"*":z+=l(1);continue;default:z+=(0,w.$if)(B)}}q<ee.length-1&&(ee[q+1]!==e.$vk||q+2<ee.length)&&(z+=$)}se=he===e.$vk})}return z}const f=/^\*\*\/\*\.[\w\.-]+$/,b=/^\*\*\/([\w\.-]+)\/?$/,I=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,m=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,s=/^\*\*((\/[\w\.-]+)+)\/?$/,r=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,i=new T.$Fc(1e4),a=function(){return!1},t=function(){return null};function n(V,z){if(!V)return t;let ee;typeof V!="string"?ee=V.pattern:ee=V,ee=ee.trim();const se=`${ee}_${!!z.trimForExclusions}`;let he=i.get(se);if(he)return o(he,V);let q;return f.test(ee)?he=g(ee.substr(4),ee):(q=b.exec(h(ee,z)))?he=R(q[1],ee):(z.trimForExclusions?m:I).test(ee)?he=L(ee,z):(q=s.exec(h(ee,z)))?he=S(q[1].substr(1),ee,!0):(q=r.exec(h(ee,z)))?he=S(q[1],ee,!1):he=v(ee),i.set(se,he),o(he,V)}function o(V,z){if(typeof z=="string")return V;const ee=function(se,he){return(0,O.$Eg)(se,z.base,!A.$k)?V((0,w.$nf)(se.substr(z.base.length),k.sep),he):null};return ee.allBasenames=V.allBasenames,ee.allPaths=V.allPaths,ee.basenames=V.basenames,ee.patterns=V.patterns,ee}function h(V,z){return z.trimForExclusions&&V.endsWith("/**")?V.substr(0,V.length-2):V}function g(V,z){return function(ee,se){return typeof ee=="string"&&ee.endsWith(V)?z:null}}function R(V,z){const ee=`/${V}`,se=`\\${V}`,he=function(Z,X){return typeof Z!="string"?null:X?X===V?z:null:Z===V||Z.endsWith(ee)||Z.endsWith(se)?z:null},q=[V];return he.basenames=q,he.patterns=[z],he.allBasenames=q,he}function L(V,z){const ee=K(V.slice(1,-1).split(",").map(X=>n(X,z)).filter(X=>X!==t),V),se=ee.length;if(!se)return t;if(se===1)return ee[0];const he=function(X,G){for(let U=0,B=ee.length;U<B;U++)if(ee[U](X,G))return V;return null},q=ee.find(X=>!!X.allBasenames);q&&(he.allBasenames=q.allBasenames);const Z=ee.reduce((X,G)=>G.allPaths?X.concat(G.allPaths):X,[]);return Z.length&&(he.allPaths=Z),he}function S(V,z,ee){const se=k.sep===k.$ic.sep,he=se?V:V.replace(p,k.sep),q=k.sep+he,Z=k.$ic.sep+V;let X;return ee?X=function(G,U){return typeof G=="string"&&(G===he||G.endsWith(q)||!se&&(G===V||G.endsWith(Z)))?z:null}:X=function(G,U){return typeof G=="string"&&(G===he||!se&&G===V)?z:null},X.allPaths=[(ee?"*/":"./")+V],X}function v(V){try{const z=new RegExp(`^${y(V)}$`);return function(ee){return z.lastIndex=0,typeof ee=="string"&&z.test(ee)?V:null}}catch{return t}}function C(V,z,ee){return!V||typeof z!="string"?!1:F(V)(z,void 0,ee)}function F(V,z={}){if(!V)return a;if(typeof V=="string"||D(V)){const ee=n(V,z);if(ee===t)return a;const se=function(he,q){return!!ee(he,q)};return ee.allBasenames&&(se.allBasenames=ee.allBasenames),ee.allPaths&&(se.allPaths=ee.allPaths),se}return H(V,z)}function D(V){const z=V;return z?typeof z.base=="string"&&typeof z.pattern=="string":!1}function M(V){return V.allBasenames||[]}function J(V){return V.allPaths||[]}function H(V,z){const ee=K(Object.getOwnPropertyNames(V).map(X=>x(X,V[X],z)).filter(X=>X!==t)),se=ee.length;if(!se)return t;if(!ee.some(X=>!!X.requiresSiblings)){if(se===1)return ee[0];const X=function(B,j){let W;for(let te=0,_=ee.length;te<_;te++){const Q=ee[te](B,j);if(typeof Q=="string")return Q;(0,c.$rh)(Q)&&(W||(W=[]),W.push(Q))}return W?(async()=>{for(const te of W){const _=await te;if(typeof _=="string")return _}return null})():null},G=ee.find(B=>!!B.allBasenames);G&&(X.allBasenames=G.allBasenames);const U=ee.reduce((B,j)=>j.allPaths?B.concat(j.allPaths):B,[]);return U.length&&(X.allPaths=U),X}const he=function(X,G,U){let B,j;for(let W=0,te=ee.length;W<te;W++){const _=ee[W];_.requiresSiblings&&U&&(G||(G=(0,k.$pc)(X)),B||(B=G.substr(0,G.length-(0,k.$qc)(X).length)));const Q=_(X,G,B,U);if(typeof Q=="string")return Q;(0,c.$rh)(Q)&&(j||(j=[]),j.push(Q))}return j?(async()=>{for(const W of j){const te=await W;if(typeof te=="string")return te}return null})():null},q=ee.find(X=>!!X.allBasenames);q&&(he.allBasenames=q.allBasenames);const Z=ee.reduce((X,G)=>G.allPaths?X.concat(G.allPaths):X,[]);return Z.length&&(he.allPaths=Z),he}function x(V,z,ee){if(z===!1)return t;const se=n(V,ee);if(se===t)return t;if(typeof z=="boolean")return se;if(z){const he=z.when;if(typeof he=="string"){const q=(Z,X,G,U)=>{if(!U||!se(Z,X))return null;const B=he.replace("$(basename)",()=>G),j=U(B);return(0,c.$rh)(j)?j.then(W=>W?V:null):j?V:null};return q.requiresSiblings=!0,q}}return se}function K(V,z){const ee=V.filter(X=>!!X.basenames);if(ee.length<2)return V;const se=ee.reduce((X,G)=>{const U=G.basenames;return U?X.concat(U):X},[]);let he;if(z){he=[];for(let X=0,G=se.length;X<G;X++)he.push(z)}else he=ee.reduce((X,G)=>{const U=G.patterns;return U?X.concat(U):X},[]);const q=function(X,G){if(typeof X!="string")return null;if(!G){let B;for(B=X.length;B>0;B--){const j=X.charCodeAt(B-1);if(j===N.CharCode.Slash||j===N.CharCode.Backslash)break}G=X.substr(B)}const U=se.indexOf(G);return U!==-1?he[U]:null};q.basenames=se,q.patterns=he,q.allBasenames=se;const Z=V.filter(X=>!X.basenames);return Z.push(q),Z}function ie(V,z){return(0,P.$wb)(V,z,(ee,se)=>typeof ee=="string"&&typeof se=="string"?ee===se:typeof ee!="string"&&typeof se!="string"?ee.base===se.base&&ee.pattern===se.pattern:!1)}}),define(ce[95],le([0,1,15,65,9]),function(ne,e,P,c,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kn=e.$Jn=void 0,e.$Ln=A,e.$Mn=E,e.$Nn=$;function O(u){return u.toJSON()}class T{constructor(p){this.a=p}transformIncoming(p){const l=this.a.transformIncoming(p);return l===p?p:O(N.URI.from(l))}transformOutgoing(p){const l=this.a.transformOutgoing(p);return l===p?p:O(N.URI.from(l))}transformOutgoingURI(p){const l=this.a.transformOutgoing(p);return l===p?p:N.URI.from(l)}transformOutgoingScheme(p){return this.a.transformOutgoingScheme(p)}}e.$Jn=T,e.$Kn=new class{transformIncoming(u){return u}transformOutgoing(u){return u}transformOutgoingURI(u){return u}transformOutgoingScheme(u){return u}};function k(u,p,l){if(!u||l>200)return null;if(typeof u=="object"){if(u instanceof N.URI)return p.transformOutgoing(u);for(const d in u)if(Object.hasOwnProperty.call(u,d)){const y=k(u[d],p,l+1);y!==null&&(u[d]=y)}}return null}function A(u,p){const l=k(u,p,0);return l===null?u:l}function w(u,p,l,d){if(!u||d>200)return null;if(typeof u=="object"){if(u.$mid===c.MarshalledId.Uri)return l?N.URI.revive(p.transformIncoming(u)):p.transformIncoming(u);if(u instanceof P.$Oe)return null;for(const y in u)if(Object.hasOwnProperty.call(u,y)){const f=w(u[y],p,l,d+1);f!==null&&(u[y]=f)}}return null}function E(u,p){const l=w(u,p,!1,0);return l===null?u:l}function $(u,p){const l=w(u,p,!0,0);return l===null?u:l}}),define(ce[150],le([0,1,38,52,32,137,5]),function(ne,e,P,c,N,O,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pn=void 0,e.$Qn=A,e.$Rn=$,e.$Sn=u,N=Oe(N),e.$Pn=new class{c(p){return this.a||(this.a=c.$Li.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(p)}value(){if(this.b===void 0){let p=0,l=0;const d=(0,P.networkInterfaces)();for(const y in d){const f=d[y];if(f)for(const{mac:b,internal:I}of f)I||(l+=1,this.c(b.toUpperCase())&&(p+=1))}this.b=l>0?p/l:0}return this.b}};let k;async function A(p){return k||(k=(async()=>await w(p)||N.$2g())()),k}async function w(p){try{const l=await new Promise((y,f)=>{ne(["crypto"],y,f)}).then(Oe),d=(0,O.$On)();return l.createHash("sha256").update(d,"utf8").digest("hex")}catch(l){p(l);return}}const E="Software\\Microsoft\\SQMClient";async function $(p){if(T.$i){const l=await new Promise((d,y)=>{ne(["@vscode/windows-registry"],d,y)}).then(Oe);try{return l.GetStringRegKey("HKEY_LOCAL_MACHINE",E,"MachineId")||""}catch(d){return p(d),""}}return""}async function u(p){try{return await(await new Promise((y,f)=>{ne(["@vscode/deviceid"],y,f)}).then(Oe)).getDeviceId()}catch(l){return p(l),""}}}),define(ce[151],le([0,1,46,152,14,36]),function(ne,e,P,c,N,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wX=E,e.$xX=$;const T="XDG_SESSION_TYPE",k="WAYLAND_DISPLAY",A="XDG_RUNTIME_DIR";var w;(function(u){u.Wayland="wayland",u.XWayland="xwayland",u.X11="x11",u.Unknown="unknown"})(w||(w={}));async function E(u){const p=O.env[T];if(p)return p===w.Wayland||p===w.X11?p:w.Unknown;if(O.env[k]){const d=O.env[A];if(d){const y=(0,N.$lc)(d,"wayland-0");try{return await(0,c.access)(y,P.constants.R_OK),w.Wayland}catch(f){return u(f),w.Unknown}}else return w.Unknown}else return w.X11}function $(u,p){if(p)switch(p){case"auto":return u;case"x11":return u===w.Wayland?w.XWayland:w.X11;case"wayland":return w.Wayland;default:return w.Unknown}else return u===w.Wayland?w.XWayland:w.X11}}),define(ce[153],le([0,1,46,152,277,5]),function(ne,e,P,c,N,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3g=T,O=Oe(O);async function T(k){if(O.$j||O.$i)return;let A;for(const w of["/etc/os-release","/usr/lib/os-release","/etc/lsb-release"])try{A=await(0,c.open)(w,P.constants.R_OK);break}catch{}if(!A){k("Unable to retrieve release information from known identifier paths.");return}try{const w=new Set(["ID","DISTRIB_ID","ID_LIKE","VERSION_ID","DISTRIB_RELEASE"]),E={id:"unknown"};for await(const $ of(0,N.createInterface)({input:A.createReadStream(),crlfDelay:1/0})){if(!$.includes("="))continue;const u=$.split("=")[0].toUpperCase().trim();if(w.has(u)){const p=$.split("=")[1].replace(/"/g,"").toLowerCase().trim();u==="ID"||u==="DISTRIB_ID"?E.id=p:u==="ID_LIKE"?E.id_like=p:(u==="VERSION_ID"||u==="DISTRIB_RELEASE")&&(E.version_id=p)}}return E}catch(w){k(w)}}}),define(ce[31],le([0,1,46,38,278,6,42,91,14,5,21,9]),function(ne,e,P,c,N,O,T,k,A,w,E,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.SymlinkSupport=e.RimRafMode=void 0,e.rimrafSync=y,e.readdirSync=I,e.whenDeleted=r,e.configureFlushOnWrite=o,e.writeFileSync=g,P=Oe(P);var u;(function(H){H[H.UNLINK=0]="UNLINK",H[H.MOVE=1]="MOVE"})(u||(e.RimRafMode=u={}));async function p(H,x=u.UNLINK,K){if((0,T.$Ig)(H))throw new Error("rimraf - will refuse to recursively delete root");return x===u.UNLINK?d(H):l(H,K)}async function l(H,x=(0,T.$Ng)((0,c.tmpdir)())){try{try{await P.promises.rename(H,x)}catch(K){return K.code==="ENOENT"?void 0:d(H)}d(x).catch(K=>{})}catch(K){if(K.code!=="ENOENT")throw K}}async function d(H){return P.promises.rm(H,{recursive:!0,force:!0,maxRetries:3})}function y(H){if((0,T.$Ig)(H))throw new Error("rimraf - will refuse to recursively delete root");P.rmSync(H,{recursive:!0,force:!0,maxRetries:3})}async function f(H,x){return m(await(x?b(H):P.promises.readdir(H)))}async function b(H){try{return await P.promises.readdir(H,{withFileTypes:!0})}catch(ie){console.warn("[node.js fs] readdir with filetypes failed with error: ",ie)}const x=[],K=await f(H);for(const ie of K){let V=!1,z=!1,ee=!1;try{const se=await e.Promises.lstat((0,A.$lc)(H,ie));V=se.isFile(),z=se.isDirectory(),ee=se.isSymbolicLink()}catch(se){console.warn("[node.js fs] unexpected error from lstat after readdir: ",se)}x.push({name:ie,isFile:()=>V,isDirectory:()=>z,isSymbolicLink:()=>ee})}return x}function I(H){return m(P.readdirSync(H))}function m(H){return H.map(x=>typeof x=="string"?w.$j?(0,k.$mm)(x):x:(x.name=w.$j?(0,k.$mm)(x.name):x.name,x))}async function s(H){const x=await f(H),K=[];for(const ie of x)await i.existsDirectory((0,A.$lc)(H,ie))&&K.push(ie);return K}function r(H,x=1e3){return new Promise(K=>{let ie=!1;const V=setInterval(()=>{ie||(ie=!0,P.access(H,z=>{ie=!1,z&&(clearInterval(V),K(void 0))}))},x)})}var i;(function(H){async function x(V){let z;try{if(z=await e.Promises.lstat(V),!z.isSymbolicLink())return{stat:z}}catch{}try{return{stat:await e.Promises.stat(V),symbolicLink:z?.isSymbolicLink()?{dangling:!1}:void 0}}catch(ee){if(ee.code==="ENOENT"&&z)return{stat:z,symbolicLink:{dangling:!0}};if(w.$i&&ee.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(V)),symbolicLink:{dangling:!1}}}catch(se){if(se.code==="ENOENT"&&z)return{stat:z,symbolicLink:{dangling:!0}};throw se}throw ee}}H.stat=x;async function K(V){try{const{stat:z,symbolicLink:ee}=await H.stat(V);return z.isFile()&&ee?.dangling!==!0}catch{}return!1}H.existsFile=K;async function ie(V){try{const{stat:z,symbolicLink:ee}=await H.stat(V);return z.isDirectory()&&ee?.dangling!==!0}catch{}return!1}H.existsDirectory=ie})(i||(e.SymlinkSupport=i={}));const a=new O.$Oh;function t(H,x,K){return a.queueFor($.URI.file(H),()=>{const ie=R(K);return new Promise((V,z)=>h(H,x,ie,ee=>ee?z(ee):V()))},E.$0g)}let n=!0;function o(H){n=H}function h(H,x,K,ie){if(!n)return P.writeFile(H,x,{mode:K.mode,flag:K.flag},ie);P.open(H,K.flag,K.mode,(V,z)=>{if(V)return ie(V);P.writeFile(z,x,ee=>{if(ee)return P.close(z,()=>ie(ee));P.fdatasync(z,se=>(se&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",se),o(!1)),P.close(z,he=>ie(he))))})})}function g(H,x,K){const ie=R(K);if(!n)return P.writeFileSync(H,x,{mode:ie.mode,flag:ie.flag});const V=P.openSync(H,ie.flag,ie.mode);try{P.writeFileSync(V,x);try{P.fdatasyncSync(V)}catch(z){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",z),o(!1)}}finally{P.closeSync(V)}}function R(H){return H?{mode:typeof H.mode=="number"?H.mode:438,flag:typeof H.flag=="string"?H.flag:"w"}:{mode:438,flag:"w"}}async function L(H,x,K=6e4){if(H!==x)try{w.$i&&typeof K=="number"?await S(H,x,Date.now(),K):await P.promises.rename(H,x)}catch(ie){if(H.toLowerCase()!==x.toLowerCase()&&ie.code==="EXDEV"||H.endsWith("."))await v(H,x,{preserveSymlinks:!1}),await p(H,u.MOVE);else throw ie}}async function S(H,x,K,ie,V=0){try{return await P.promises.rename(H,x)}catch(z){if(z.code!=="EACCES"&&z.code!=="EPERM"&&z.code!=="EBUSY")throw z;if(Date.now()-K>=ie)throw console.error(`[node.js fs] rename failed after ${V} retries with error: ${z}`),z;if(V===0){let ee=!1;try{const{stat:se}=await i.stat(x);se.isFile()||(ee=!0)}catch{}if(ee)throw z}return await(0,O.$Gh)(Math.min(100,V*10)),S(H,x,K,ie,V+1)}}async function v(H,x,K){return F(H,x,{root:{source:H,target:x},options:K,handledSourcePaths:new Set})}const C=511;async function F(H,x,K){if(K.handledSourcePaths.has(H))return;K.handledSourcePaths.add(H);const{stat:ie,symbolicLink:V}=await i.stat(H);if(V){if(K.options.preserveSymlinks)try{return await J(H,x,K)}catch{}if(V.dangling)return}return ie.isDirectory()?D(H,x,ie.mode&C,K):M(H,x,ie.mode&C)}async function D(H,x,K,ie){await e.Promises.mkdir(x,{recursive:!0,mode:K});const V=await f(H);for(const z of V)await F((0,A.$lc)(H,z),(0,A.$lc)(x,z),ie)}async function M(H,x,K){await e.Promises.copyFile(H,x),await e.Promises.chmod(x,K)}async function J(H,x,K){let ie=await e.Promises.readlink(H);(0,T.$Eg)(ie,K.root.source,!w.$k)&&(ie=(0,A.$lc)(K.root.target,ie.substr(K.root.source.length+1))),await e.Promises.symlink(ie,x)}e.Promises=new class{get access(){return P.promises.access}get stat(){return P.promises.stat}get lstat(){return P.promises.lstat}get utimes(){return P.promises.utimes}get read(){return(H,x,K,ie,V)=>new Promise((z,ee)=>{P.read(H,x,K,ie,V,(se,he,q)=>se?ee(se):z({bytesRead:he,buffer:q}))})}get readFile(){return P.promises.readFile}get write(){return(H,x,K,ie,V)=>new Promise((z,ee)=>{P.write(H,x,K,ie,V,(se,he,q)=>se?ee(se):z({bytesWritten:he,buffer:q}))})}get appendFile(){return P.promises.appendFile}get fdatasync(){return(0,N.promisify)(P.fdatasync)}get truncate(){return P.promises.truncate}get copyFile(){return P.promises.copyFile}get open(){return(0,N.promisify)(P.open)}get close(){return(0,N.promisify)(P.close)}get symlink(){return P.promises.symlink}get readlink(){return P.promises.readlink}get chmod(){return P.promises.chmod}get mkdir(){return P.promises.mkdir}get unlink(){return P.promises.unlink}get rmdir(){return P.promises.rmdir}get realpath(){return(0,N.promisify)(P.realpath)}async exists(H){try{return await e.Promises.access(H),!0}catch{return!1}}get readdir(){return f}get readDirsInDir(){return s}get writeFile(){return t}get rm(){return p}get rename(){return L}get copy(){return v}}}),define(ce[154],le([0,1,46,14,5,27,31]),function(ne,e,P,c,N,O,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$er=k,e.$fr=A,e.$gr=w,e.$hr=E,P=Oe(P);function k(u){if(N.$k)return u;const p=(0,c.$oc)(u);if(u===p)return u;const l=((0,c.$pc)(u)||u).toLowerCase();try{const y=(0,T.readdirSync)(p).filter(f=>f.toLowerCase()===l);if(y.length===1){const f=k(p);if(f)return(0,c.$lc)(f,y[0])}else if(y.length>1){const f=y.indexOf(l);if(f>=0){const b=k(p);if(b)return(0,c.$lc)(b,y[f])}}}catch{}return null}async function A(u,p){if(N.$k)return u;const l=(0,c.$oc)(u);if(u===l)return u;const d=((0,c.$pc)(u)||u).toLowerCase();try{if(p?.isCancellationRequested)return null;const f=(await T.Promises.readdir(l)).filter(b=>b.toLowerCase()===d);if(f.length===1){const b=await A(l,p);if(b)return(0,c.$lc)(b,f[0])}else if(f.length>1){const b=f.indexOf(d);if(b>=0){const I=await A(l,p);if(I)return(0,c.$lc)(I,f[b])}}}catch{}return null}async function w(u){try{return await T.Promises.realpath(u)}catch{const l=$(u);return await T.Promises.access(l,P.constants.R_OK),l}}function E(u){try{return P.realpathSync(u)}catch{const l=$(u);return P.accessSync(l,P.constants.R_OK),l}}function $(u){return(0,O.$of)((0,c.$jc)(u),c.sep)}}),define(ce[155],le([0,1,14,5,36,93,13,31]),function(ne,e,P,c,N,O,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.TerminateResponseCode=e.Source=void 0,e.$xm=A,e.$ym=w,P=Oe(P),c=Oe(c),N=Oe(N),T=Oe(T),k=Oe(k),Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return O.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return O.TerminateResponseCode}});function A($=N.env){return $.comspec||"cmd.exe"}function w($){let u=[],p=!1;const l=function(d){if(p){u.push(d);return}(!$.send(d,f=>{if(f&&console.error(f),p=!1,u.length>0){const b=u.slice(0);u=[],b.forEach(I=>l(I))}})||c.$i)&&(p=!0)};return{send:l}}var E;(function($){async function u(p,l,d){if(P.$kc(p))return p;if(l===void 0&&(l=N.cwd()),P.$oc(p)!=="."||(d===void 0&&T.$fg(N.env.PATH)&&(d=N.env.PATH.split(P.$vc)),d===void 0||d.length===0))return P.$lc(l,p);async function f(b){if(await k.Promises.exists(b)){let I;try{I=await k.Promises.stat(b)}catch(m){m.message.startsWith("EACCES")&&(I=await k.Promises.lstat(b))}return I?!I.isDirectory():!1}return!1}for(const b of d){let I;if(P.$kc(b)?I=P.$lc(b,p):I=P.$lc(l,b,p),await f(I))return I;let m=I+".com";if(await f(m)||(m=I+".exe",await f(m)))return m}return P.$lc(l,p)}$.findExecutable=u})(E||(e.win32=E={}))}),define(ce[156],le([0,1,69,23]),function(ne,e,P,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qs=N;function N(T){return new Promise((k,A)=>{let w;const E=new Map;function $(p,l,d,y,f){const b=E.get(l);if(p===T||b){const I={name:u(d),cmd:d,pid:p,ppid:l,load:y,mem:f};E.set(p,I),p===T&&(w=I),b&&(b.children||(b.children=[]),b.children.push(I),b.children.length>1&&(b.children=b.children.sort((m,s)=>m.pid-s.pid)))}}function u(p){const l=/--utility-sub-type=network/i,d=/--crashes-directory/i,y=/\\pipe\\winpty-control/i,f=/conhost\.exe.+--headless/i,b=/--type=([a-zA-Z-]+)/;if(d.exec(p))return"electron-crash-reporter";if(y.exec(p))return"winpty-agent";if(f.exec(p))return"conpty-agent";let I=b.exec(p);if(I&&I.length===2)return I[1]==="renderer"?"window":I[1]==="utility"?l.exec(p)?"utility-network-service":"utility-process":I[1]==="extensionHost"?"extension-host":I[1];const m=/[a-zA-Z-]+\.js/g;let s="";do I=m.exec(p),I&&(s+=I+" ");while(I);return s&&p.indexOf("node ")<0&&p.indexOf("node.exe")<0?`electron-nodejs (${s})`:p}if(process.platform==="win32"){const p=l=>l.indexOf("\\\\?\\")===0||l.indexOf("\\??\\")===0?l.substring(4):l.indexOf('"\\\\?\\')===0||l.indexOf('"\\??\\')===0?'"'+l.substring(5):l;new Promise((l,d)=>{ne(["@vscode/windows-process-tree"],l,d)}).then(Oe).then(l=>{l.getProcessList(T,d=>{if(!d){A(new Error(`Root process ${T} not found`));return}l.getProcessCpuUsage(d,y=>{const f=new Map;y.forEach(b=>{const I=p(b.commandLine||"");f.set(b.pid,{name:u(I),cmd:I,pid:b.pid,ppid:b.ppid,load:b.cpu||0,mem:b.memory||0})}),w=f.get(T),w?(f.forEach(b=>{const I=f.get(b.ppid);I&&(I.children||(I.children=[]),I.children.push(b))}),f.forEach(b=>{b.children&&(b.children=b.children.sort((I,m)=>I.pid-m.pid))}),k(w)):A(new Error(`Root process ${T} not found`))})},l.ProcessDataFlag.CommandLine|l.ProcessDataFlag.Memory)})}else{let p=function(){let l=[w];const d=[];for(;l.length;){const f=l.shift();f&&(d.push(f.pid),f.children&&(l=l.concat(f.children)))}let y=JSON.stringify(c.$Zg.asFileUri("vs/base/node/cpuUsage.sh").fsPath);y+=" "+d.join(" "),(0,P.exec)(y,{},(f,b,I)=>{if(f||I)A(f||new Error(I.toString()));else{const m=b.toString().split(`
`);for(let s=0;s<d.length;s++){const r=E.get(d[s]);r.load=parseFloat(m[s])}if(!w){A(new Error(`Root process ${T} not found`));return}k(w)}})};(0,P.exec)("which ps",{},(l,d,y)=>{if(l||y)if(process.platform!=="linux")A(l||new Error(y.toString()));else{const f=JSON.stringify(c.$Zg.asFileUri("vs/base/node/ps.sh").fsPath);(0,P.exec)(f,{},(b,I,m)=>{b||m?A(b||new Error(m.toString())):(O(I,$),p())})}else{const f=d.toString().trim();(0,P.exec)(`${f} -ax -o pid=,ppid=,pcpu=,pmem=,command=`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(I,m,s)=>{I||s&&!s.includes("screen size is bogus")?A(I||new Error(s.toString())):(O(m,$),process.platform==="linux"?p():w?k(w):A(new Error(`Root process ${T} not found`)))})}})}})}function O(T,k){const A=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,w=T.toString().split(`
`);for(const E of w){const $=A.exec(E.trim());$&&$.length===6&&k(parseInt($[1]),parseInt($[2]),$[5],parseFloat($[3]),parseFloat($[4]))}}});var ve=this&&this.__decorate||function(ne,e,P,c){var N=arguments.length,O=N<3?e:c===null?c=Object.getOwnPropertyDescriptor(e,P):c,T;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")O=Reflect.decorate(ne,e,P,c);else for(var k=ne.length-1;k>=0;k--)(T=ne[k])&&(O=(N<3?T(O):N>3?T(e,P,O):T(e,P))||O);return N>3&&O&&Object.defineProperty(e,P,O),O};define(ce[43],le([0,1,19,6,15,26,88,8,3,2,68,27,13]),function(ne,e,P,c,N,O,T,k,A,w,E,$,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oi=e.ProxyChannel=e.$ni=e.$ki=e.$ji=e.$ii=e.RequestInitiator=e.$hi=e.$ei=e.$di=void 0,e.$fi=o,e.$gi=h,e.$li=C,e.$mi=F,$=Oe($);var p;(function(V){V[V.Promise=100]="Promise",V[V.PromiseCancel=101]="PromiseCancel",V[V.EventListen=102]="EventListen",V[V.EventDispose=103]="EventDispose"})(p||(p={}));function l(V){switch(V){case p.Promise:return"req";case p.PromiseCancel:return"cancel";case p.EventListen:return"subscribe";case p.EventDispose:return"unsubscribe"}}var d;(function(V){V[V.Initialize=200]="Initialize",V[V.PromiseSuccess=201]="PromiseSuccess",V[V.PromiseError=202]="PromiseError",V[V.PromiseErrorObj=203]="PromiseErrorObj",V[V.EventFire=204]="EventFire"})(d||(d={}));function y(V){switch(V){case d.Initialize:return"init";case d.PromiseSuccess:return"reply:";case d.PromiseError:case d.PromiseErrorObj:return"replyErr:";case d.EventFire:return"event:"}}var f;(function(V){V[V.Uninitialized=0]="Uninitialized",V[V.Idle=1]="Idle"})(f||(f={}));function b(V){let z=0;for(let ee=0;;ee+=7){const se=V.read(1);if(z|=(se.buffer[0]&127)<<ee,!(se.buffer[0]&128))return z}}const I=a(0);function m(V,z){if(z===0){V.write(I);return}let ee=0;for(let he=z;he!==0;he=he>>>7)ee++;const se=N.$Oe.alloc(ee);for(let he=0;z!==0;he++)se.buffer[he]=z&127,z=z>>>7,z>0&&(se.buffer[he]|=128);V.write(se)}class s{constructor(z){this.b=z,this.a=0}read(z){const ee=this.b.slice(this.a,this.a+z);return this.a+=ee.byteLength,ee}}e.$di=s;class r{constructor(){this.a=[]}get buffer(){return N.$Oe.concat(this.a)}write(z){this.a.push(z)}}e.$ei=r;var i;(function(V){V[V.Undefined=0]="Undefined",V[V.String=1]="String",V[V.Buffer=2]="Buffer",V[V.VSBuffer=3]="VSBuffer",V[V.Array=4]="Array",V[V.Object=5]="Object",V[V.Int=6]="Int"})(i||(i={}));function a(V){const z=N.$Oe.alloc(1);return z.writeUInt8(V,0),z}const t={Undefined:a(i.Undefined),String:a(i.String),Buffer:a(i.Buffer),VSBuffer:a(i.VSBuffer),Array:a(i.Array),Object:a(i.Object),Uint:a(i.Int)},n=typeof Buffer<"u";function o(V,z){if(typeof z>"u")V.write(t.Undefined);else if(typeof z=="string"){const ee=N.$Oe.fromString(z);V.write(t.String),m(V,ee.byteLength),V.write(ee)}else if(n&&Buffer.isBuffer(z)){const ee=N.$Oe.wrap(z);V.write(t.Buffer),m(V,ee.byteLength),V.write(ee)}else if(z instanceof N.$Oe)V.write(t.VSBuffer),m(V,z.byteLength),V.write(z);else if(Array.isArray(z)){V.write(t.Array),m(V,z.length);for(const ee of z)o(V,ee)}else if(typeof z=="number"&&(z|0)===z)V.write(t.Uint),m(V,z);else{const ee=N.$Oe.fromString(JSON.stringify(z));V.write(t.Object),m(V,ee.byteLength),V.write(ee)}}function h(V){switch(V.read(1).readUInt8(0)){case i.Undefined:return;case i.String:return V.read(b(V)).toString();case i.Buffer:return V.read(b(V)).buffer;case i.VSBuffer:return V.read(b(V));case i.Array:{const ee=b(V),se=[];for(let he=0;he<ee;he++)se.push(h(V));return se}case i.Object:return JSON.parse(V.read(b(V)).toString());case i.Int:return b(V)}}class g{constructor(z,ee,se=null,he=1e3){this.h=z,this.j=ee,this.k=se,this.l=he,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(q=>this.q(q)),this.m({type:d.Initialize})}registerChannel(z,ee){this.b.set(z,ee),setTimeout(()=>this.w(z),0)}m(z){switch(z.type){case d.Initialize:{const ee=this.o([z.type]);this.k?.logOutgoing(ee,0,R.OtherSide,y(z.type));return}case d.PromiseSuccess:case d.PromiseError:case d.EventFire:case d.PromiseErrorObj:{const ee=this.o([z.type,z.id],z.data);this.k?.logOutgoing(ee,z.id,R.OtherSide,y(z.type),z.data);return}}}o(z,ee=void 0){const se=new r;return o(se,z),o(se,ee),this.p(se.buffer)}p(z){try{return this.h.send(z),z.byteLength}catch{return 0}}q(z){const ee=new s(z),se=h(ee),he=h(ee),q=se[0];switch(q){case p.Promise:return this.k?.logIncoming(z.byteLength,se[1],R.OtherSide,`${l(q)}: ${se[2]}.${se[3]}`,he),this.s({type:q,id:se[1],channelName:se[2],name:se[3],arg:he});case p.EventListen:return this.k?.logIncoming(z.byteLength,se[1],R.OtherSide,`${l(q)}: ${se[2]}.${se[3]}`,he),this.t({type:q,id:se[1],channelName:se[2],name:se[3],arg:he});case p.PromiseCancel:return this.k?.logIncoming(z.byteLength,se[1],R.OtherSide,`${l(q)}`),this.u({type:q,id:se[1]});case p.EventDispose:return this.k?.logIncoming(z.byteLength,se[1],R.OtherSide,`${l(q)}`),this.u({type:q,id:se[1]})}}s(z){const ee=this.b.get(z.channelName);if(!ee){this.v(z);return}const se=new O.$xe;let he;try{he=ee.call(this.j,z.name,z.arg,se.token)}catch(X){he=Promise.reject(X)}const q=z.id;he.then(X=>{this.m({id:q,data:X,type:d.PromiseSuccess})},X=>{X instanceof Error?this.m({id:q,data:{message:X.message,name:X.name,stack:X.stack?X.stack.split(`
`):void 0},type:d.PromiseError}):this.m({id:q,data:X,type:d.PromiseErrorObj})}).finally(()=>{Z.dispose(),this.d.delete(z.id)});const Z=(0,w.$Uc)(()=>se.cancel());this.d.set(z.id,Z)}t(z){const ee=this.b.get(z.channelName);if(!ee){this.v(z);return}const se=z.id,q=ee.listen(this.j,z.name,z.arg)(Z=>this.m({id:se,data:Z,type:d.EventFire}));this.d.set(z.id,q)}u(z){const ee=this.d.get(z.id);ee&&(ee.dispose(),this.d.delete(z.id))}v(z){let ee=this.g.get(z.channelName);ee||(ee=[],this.g.set(z.channelName,ee));const se=setTimeout(()=>{console.error(`Unknown channel: ${z.channelName}`),z.type===p.Promise&&this.m({id:z.id,data:{name:"Unknown channel",message:`Channel name '${z.channelName}' timed out after ${this.l}ms`,stack:void 0},type:d.PromiseError})},this.l);ee.push({request:z,timeoutTimer:se})}w(z){const ee=this.g.get(z);if(ee){for(const se of ee)switch(clearTimeout(se.timeoutTimer),se.request.type){case p.Promise:this.s(se.request);break;case p.EventListen:this.t(se.request);break}this.g.delete(z)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,w.$Rc)(this.d.values()),this.d.clear()}}e.$hi=g;var R;(function(V){V[V.LocalSide=0]="LocalSide",V[V.OtherSide=1]="OtherSide"})(R||(e.RequestInitiator=R={}));class L{constructor(z,ee=null){this.l=z,this.a=!1,this.b=f.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new A.$me,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(se=>this.s(se)),this.j=ee}getChannel(z){const ee=this;return{call(se,he,q){return ee.a?Promise.reject(new k.$7):ee.m(z,se,he,q)},listen(se,he){return ee.a?A.Event.None:ee.o(z,se,he)}}}m(z,ee,se,he=O.CancellationToken.None){const q=this.g++,Z=p.Promise,X={id:q,type:Z,channelName:z,name:ee,arg:se};if(he.isCancellationRequested)return Promise.reject(new k.$7);let G;return new Promise((B,j)=>{if(he.isCancellationRequested)return j(new k.$7);const W=()=>{const ae=ue=>{switch(ue.type){case d.PromiseSuccess:this.f.delete(q),B(ue.data);break;case d.PromiseError:{this.f.delete(q);const ge=new Error(ue.data.message);ge.stack=Array.isArray(ue.data.stack)?ue.data.stack.join(`
`):ue.data.stack,ge.name=ue.data.name,j(ge);break}case d.PromiseErrorObj:this.f.delete(q),j(ue.data);break}};this.f.set(q,ae),this.p(X)};let te=null;this.b===f.Idle?W():(te=(0,c.$sh)(ae=>this.u()),te.then(()=>{te=null,W()}));const _=()=>{te?(te.cancel(),te=null):this.p({id:q,type:p.PromiseCancel}),j(new k.$7)},Q=he.onCancellationRequested(_);G=(0,w.$Tc)((0,w.$Uc)(_),Q),this.d.add(G)}).finally(()=>{G.dispose(),this.d.delete(G)})}o(z,ee,se){const he=this.g++,q=p.EventListen,Z={id:he,type:q,channelName:z,name:ee,arg:se};let X=null;const G=new A.$me({onWillAddFirstListener:()=>{X=(0,c.$sh)(B=>this.u()),X.then(()=>{X=null,this.d.add(G),this.p(Z)})},onDidRemoveLastListener:()=>{X?(X.cancel(),X=null):(this.d.delete(G),this.p({id:he,type:p.EventDispose}))}}),U=B=>G.fire(B.data);return this.f.set(he,U),G.event}p(z){switch(z.type){case p.Promise:case p.EventListen:{const ee=this.q([z.type,z.id,z.channelName,z.name],z.arg);this.j?.logOutgoing(ee,z.id,R.LocalSide,`${l(z.type)}: ${z.channelName}.${z.name}`,z.arg);return}case p.PromiseCancel:case p.EventDispose:{const ee=this.q([z.type,z.id]);this.j?.logOutgoing(ee,z.id,R.LocalSide,l(z.type));return}}}q(z,ee=void 0){const se=new r;return o(se,z),o(se,ee),this.r(se.buffer)}r(z){try{return this.l.send(z),z.byteLength}catch{return 0}}s(z){const ee=new s(z),se=h(ee),he=h(ee),q=se[0];switch(q){case d.Initialize:return this.j?.logIncoming(z.byteLength,0,R.LocalSide,y(q)),this.t({type:se[0]});case d.PromiseSuccess:case d.PromiseError:case d.EventFire:case d.PromiseErrorObj:return this.j?.logIncoming(z.byteLength,se[1],R.LocalSide,y(q),he),this.t({type:se[0],id:se[1],data:he})}}t(z){if(z.type===d.Initialize){this.b=f.Idle,this.k.fire();return}this.f.get(z.id)?.(z)}get onDidInitializePromise(){return A.Event.toPromise(this.onDidInitialize)}u(){return this.b===f.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,w.$Rc)(this.d.values()),this.d.clear()}}e.$ii=L,ve([T.$0h],L.prototype,"onDidInitializePromise",null);class S{get connections(){const z=[];return this.f.forEach(ee=>z.push(ee)),z}constructor(z,ee,se){this.a=new Map,this.f=new Set,this.g=new A.$me,this.onDidAddConnection=this.g.event,this.h=new A.$me,this.onDidRemoveConnection=this.h.event,this.j=new w.$Vc,this.j.add(z(({protocol:he,onDidClientDisconnect:q})=>{const Z=A.Event.once(he.onMessage);this.j.add(Z(X=>{const G=new s(X),U=h(G),B=new g(he,U,ee,se),j=new L(he,ee);this.a.forEach((te,_)=>B.registerChannel(_,te));const W={channelServer:B,channelClient:j,ctx:U};this.f.add(W),this.g.fire(W),this.j.add(q(()=>{B.dispose(),j.dispose(),this.f.delete(W),this.h.fire(W)}))}))}))}getChannel(z,ee){const se=this;return{call(he,q,Z){let X;if((0,u.$tg)(ee)){const U=(0,P.$5b)(se.connections.filter(ee));X=U?Promise.resolve(U):A.Event.toPromise(A.Event.filter(se.onDidAddConnection,ee))}else X=ee.routeCall(se,he,q);const G=X.then(U=>U.channelClient.getChannel(z));return C(G).call(he,q,Z)},listen(he,q){if((0,u.$tg)(ee))return se.k(z,ee,he,q);const Z=ee.routeEvent(se,he,q).then(X=>X.channelClient.getChannel(z));return C(Z).listen(he,q)}}}k(z,ee,se,he){const q=this;let Z;const X=new A.$me({onWillAddFirstListener:()=>{Z=new w.$Vc;const G=new A.$se,U=new Map,B=W=>{const _=W.channelClient.getChannel(z).listen(se,he),Q=G.add(_);U.set(W,Q)},j=W=>{const te=U.get(W);te&&(te.dispose(),U.delete(W))};q.connections.filter(ee).forEach(B),A.Event.filter(q.onDidAddConnection,ee)(B,void 0,Z),q.onDidRemoveConnection(j,void 0,Z),G.event(X.fire,X,Z),Z.add(G)},onDidRemoveLastListener:()=>{Z?.dispose(),Z=void 0}});return X.event}registerChannel(z,ee){this.a.set(z,ee);for(const se of this.f)se.channelServer.registerChannel(z,ee)}dispose(){this.j.dispose();for(const z of this.f)z.channelClient.dispose(),z.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$ji=S;class v{constructor(z,ee,se=null){const he=new r;o(he,ee),z.send(he.buffer),this.a=new L(z,se),this.d=new g(z,ee,se)}getChannel(z){return this.a.getChannel(z)}registerChannel(z,ee){this.d.registerChannel(z,ee)}dispose(){this.a.dispose(),this.d.dispose()}}e.$ki=v;function C(V){return{call(z,ee,se){return V.then(he=>he.call(z,ee,se))},listen(z,ee){const se=new A.$ve;return V.then(he=>se.input=he.listen(z,ee)),se.event}}}function F(V){let z=!1;return{call(ee,se,he){return z?V.call(ee,se,he):(0,c.$Gh)(0).then(()=>z=!0).then(()=>V.call(ee,se,he))},listen(ee,se){if(z)return V.listen(ee,se);const he=new A.$ve;return(0,c.$Gh)(0).then(()=>z=!0).then(()=>he.input=V.listen(ee,se)),he.event}}}class D{constructor(z){this.a=z}routeCall(z){return this.b(z)}routeEvent(z){return this.b(z)}async b(z){for(const ee of z.connections)if(await Promise.resolve(this.a(ee.ctx)))return Promise.resolve(ee);return await A.Event.toPromise(z.onDidAddConnection),await this.b(z)}}e.$ni=D;var M;(function(V){function z(q,Z,X){const G=q,U=X&&X.disableMarshalling,B=new Map;for(const j in G)se(j)&&B.set(j,A.Event.buffer(G[j],!0,void 0,Z));return new class{listen(j,W,te){const _=B.get(W);if(_)return _;const Q=G[W];if(typeof Q=="function"){if(he(W))return Q.call(G,te);if(se(W))return B.set(W,A.Event.buffer(G[W],!0,void 0,Z)),B.get(W)}throw new k.$db(`Event not found: ${W}`)}call(j,W,te){const _=G[W];if(typeof _=="function"){if(!U&&Array.isArray(te))for(let ae=0;ae<te.length;ae++)te[ae]=(0,E.$ci)(te[ae]);let Q=_.apply(G,te);return Q instanceof Promise||(Q=Promise.resolve(Q)),Q}throw new k.$db(`Method not found: ${W}`)}}}V.fromService=z;function ee(q,Z){const X=Z&&Z.disableMarshalling;return new Proxy({},{get(G,U){if(typeof U=="string")return Z?.properties?.has(U)?Z.properties.get(U):he(U)?function(B){return q.listen(U,B)}:se(U)?q.listen(U):async function(...B){let j;Z&&!(0,u.$og)(Z.context)?j=[Z.context,...B]:j=B;const W=await q.call(U,j);return X?W:(0,E.$ci)(W)};throw new k.$db(`Property not found: ${String(U)}`)}})}V.toService=ee;function se(q){return q[0]==="o"&&q[1]==="n"&&$.$Ff(q.charCodeAt(2))}function he(q){return/^onDynamic/.test(q)&&$.$Ff(q.charCodeAt(9))}})(M||(e.ProxyChannel=M={}));const J=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function H(V){if(Array.isArray(V))return V;if(V&&typeof V=="object"&&typeof V.toString=="function"){const z=V.toString();if(z!=="[object Object]")return z}return V}function x(V){return Array.isArray(V)?V.map(H):H(V)}function K(V,z,ee,se,he,q,Z){Z=x(Z);const X=J[he],G=X[se%X.length];let U=[`%c[${V}]%c[${String(z).padStart(7," ")}]%c[len: ${String(ee).padStart(5," ")}]%c${String(se).padStart(5," ")} - ${q}`,"color: darkgreen","color: grey","color: grey",`color: ${G}`];/\($/.test(q)?(U=U.concat(Z),U.push(")")):U.push(Z),console.log.apply(console,U)}class ie{constructor(z,ee){this.d=z,this.f=ee,this.a=0,this.b=0}logOutgoing(z,ee,se,he,q){this.b+=z,K(this.d,this.b,z,ee,se,he,q)}logIncoming(z,ee,se,he,q){this.a+=z,K(this.f,this.a,z,ee,se,he,q)}}e.$oi=ie}),define(ce[70],le([0,1,15,3,2,43]),function(ne,e,P,c,N,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ti=e.$si=e.$ri=e.$qi=e.ProtocolConstants=e.$pi=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var T;(function(t){t.Created="created",t.Read="read",t.Write="write",t.Open="open",t.Error="error",t.Close="close",t.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",t.NodeEndReceived="nodeEndReceived",t.NodeEndSent="nodeEndSent",t.NodeDrainBegin="nodeDrainBegin",t.NodeDrainEnd="nodeDrainEnd",t.zlibInflateError="zlibInflateError",t.zlibInflateData="zlibInflateData",t.zlibInflateInitialWrite="zlibInflateInitialWrite",t.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",t.zlibInflateWrite="zlibInflateWrite",t.zlibInflateFlushFired="zlibInflateFlushFired",t.zlibDeflateError="zlibDeflateError",t.zlibDeflateData="zlibDeflateData",t.zlibDeflateWrite="zlibDeflateWrite",t.zlibDeflateFlushFired="zlibDeflateFlushFired",t.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",t.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",t.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",t.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",t.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",t.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",t.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",t.ProtocolHeaderRead="protocolHeaderRead",t.ProtocolMessageRead="protocolMessageRead",t.ProtocolHeaderWrite="protocolHeaderWrite",t.ProtocolMessageWrite="protocolMessageWrite",t.ProtocolWrite="protocolWrite"})(T||(e.SocketDiagnosticsEventType=T={}));var k;(function(t){t.enableDiagnostics=!1,t.records=[];const n=new WeakMap;let o=0;function h(R,L){if(!n.has(R)){const S=String(++o);n.set(R,S)}return n.get(R)}function g(R,L,S,v){if(!t.enableDiagnostics)return;const C=h(R,L);if(v instanceof P.$Oe||v instanceof Uint8Array||v instanceof ArrayBuffer||ArrayBuffer.isView(v)){const F=P.$Oe.alloc(v.byteLength);F.set(v),t.records.push({timestamp:Date.now(),id:C,label:L,type:S,buff:F})}else t.records.push({timestamp:Date.now(),id:C,label:L,type:S,data:v})}t.traceSocketEvent=g})(k||(e.SocketDiagnostics=k={}));var A;(function(t){t[t.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",t[t.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(A||(e.SocketCloseEventType=A={}));let w=null;function E(){return w||(w=P.$Oe.alloc(0)),w}class ${get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(n){this.a.push(n),this.b+=n.byteLength}read(n){return this.c(n,!0)}peek(n){return this.c(n,!1)}c(n,o){if(n===0)return E();if(n>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===n){const L=this.a[0];return o&&(this.a.shift(),this.b-=n),L}if(this.a[0].byteLength>n){const L=this.a[0].slice(0,n);return o&&(this.a[0]=this.a[0].slice(n),this.b-=n),L}const h=P.$Oe.alloc(n);let g=0,R=0;for(;n>0;){const L=this.a[R];if(L.byteLength>n){const S=L.slice(0,n);h.set(S,g),g+=n,o&&(this.a[R]=L.slice(n),this.b-=n),n-=n}else h.set(L,g),g+=L.byteLength,o?(this.a.shift(),this.b-=L.byteLength):R++,n-=L.byteLength}return h}}e.$pi=$;var u;(function(t){t[t.None=0]="None",t[t.Regular=1]="Regular",t[t.Control=2]="Control",t[t.Ack=3]="Ack",t[t.Disconnect=5]="Disconnect",t[t.ReplayRequest=6]="ReplayRequest",t[t.Pause=7]="Pause",t[t.Resume=8]="Resume",t[t.KeepAlive=9]="KeepAlive"})(u||(u={}));function p(t){switch(t){case u.None:return"None";case u.Regular:return"Regular";case u.Control:return"Control";case u.Ack:return"Ack";case u.Disconnect:return"Disconnect";case u.ReplayRequest:return"ReplayRequest";case u.Pause:return"PauseWriting";case u.Resume:return"ResumeWriting";case u.KeepAlive:return"KeepAlive"}}var l;(function(t){t[t.HeaderLength=13]="HeaderLength",t[t.AcknowledgeTime=2e3]="AcknowledgeTime",t[t.TimeoutTime=2e4]="TimeoutTime",t[t.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",t[t.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",t[t.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(l||(e.ProtocolConstants=l={}));class d{constructor(n,o,h,g){this.type=n,this.id=o,this.ack=h,this.data=g,this.writtenTime=0}get size(){return this.data.byteLength}}class y extends N.$Wc{constructor(n){super(),this.f=this.B(new c.$me),this.onMessage=this.f.event,this.g={readHead:!0,readLen:l.HeaderLength,messageType:u.None,id:0,ack:0},this.a=n,this.b=!1,this.c=new $,this.B(this.a.onData(o=>this.acceptChunk(o))),this.lastReadTime=Date.now()}acceptChunk(n){if(!(!n||n.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(n);this.c.byteLength>=this.g.readLen;){const o=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=o.readUInt32BE(9),this.g.messageType=o.readUInt8(0),this.g.id=o.readUInt32BE(1),this.g.ack=o.readUInt32BE(5),this.a.traceSocketEvent(T.ProtocolHeaderRead,{messageType:p(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const h=this.g.messageType,g=this.g.id,R=this.g.ack;if(this.g.readHead=!0,this.g.readLen=l.HeaderLength,this.g.messageType=u.None,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent(T.ProtocolMessageRead,o),this.f.fire(new d(h,g,R,o)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class f{constructor(n){this.k=null,this.a=!1,this.b=!1,this.c=n,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(n){if(this.a)return;n.writtenTime=Date.now(),this.lastWriteTime=Date.now();const o=P.$Oe.alloc(l.HeaderLength);o.writeUInt8(n.type,0),o.writeUInt32BE(n.id,1),o.writeUInt32BE(n.ack,5),o.writeUInt32BE(n.data.byteLength,9),this.c.traceSocketEvent(T.ProtocolHeaderWrite,{messageType:p(n.type),id:n.id,ack:n.ack,messageSize:n.data.byteLength}),this.c.traceSocketEvent(T.ProtocolMessageWrite,n.data),this.j(o,n.data)}g(n,o){const h=this.f===0;return this.d.push(n,o),this.f+=n.byteLength+o.byteLength,h}h(){const n=P.$Oe.concat(this.d,this.f);return this.d.length=0,this.f=0,n}j(n,o){this.g(n,o)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const n=this.h();this.c.traceSocketEvent(T.ProtocolWrite,{byteLength:n.byteLength}),this.c.write(n)}}class b extends N.$Wc{constructor(n){super(),this.f=new c.$me,this.onMessage=this.f.event,this.g=new c.$me,this.onDidDispose=this.g.event,this.a=n,this.b=this.B(new f(this.a)),this.c=this.B(new y(this.a)),this.B(this.c.onMessage(o=>{o.type===u.Regular&&this.f.fire(o.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(n){this.b.write(new d(u.Regular,0,0,n))}}e.$qi=b;class I extends O.$ki{static fromSocket(n,o){return new I(new b(n),o)}get onDidDispose(){return this.b.onDidDispose}constructor(n,o,h=null){super(n,o,h),this.b=n}dispose(){super.dispose();const n=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),n.end()}}e.$ri=I;class m{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new c.$me({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(n){this.b?this.d.length>0?this.d.push(n):this.a.fire(n):this.d.push(n)}flushBuffer(){this.d=[]}}e.$si=m;class s{constructor(n){this.data=n,this.next=null}}class r{constructor(){this.a=null,this.b=null}length(){let n=0,o=this.a;for(;o;)o=o.next,n++;return n}peek(){return this.a?this.a.data:null}toArray(){const n=[];let o=0,h=this.a;for(;h;)n[o++]=h.data,h=h.next;return n}pop(){if(this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(n){const o=new s(n);if(!this.a){this.a=o,this.b=o;return}this.b.next=o,this.b=o}}class i{static{this.a=10}static{this.b=null}static getInstance(){return i.b||(i.b=new i),i.b}constructor(){this.c=[];const n=Date.now();for(let o=0;o<i.a;o++)this.c[o]=n-1e3*o;setInterval(()=>{for(let o=i.a;o>=1;o--)this.c[o]=this.c[o-1];this.c[0]=Date.now()},1e3)}d(){const n=Date.now(),o=(1+i.a)*1e3;let h=0;for(let g=0;g<i.a;g++)n-this.c[g]<=o&&h++;return 1-h/i.a}hasHighLoad(){return this.d()>=.5}}class a{get unacknowledgedCount(){return this.c-this.d}constructor(n){this.u=new m,this.onControlMessage=this.u.event,this.v=new m,this.onMessage=this.v.event,this.w=new m,this.onDidDispose=this.w.event,this.x=new m,this.onSocketClose=this.x.event,this.y=new m,this.onSocketTimeout=this.y.event,this.s=n.loadEstimator??i.getInstance(),this.t=n.sendKeepAlive??!0,this.a=!1,this.b=new r,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.r=new N.$Vc,this.o=n.socket,this.p=this.r.add(new f(this.o)),this.q=this.r.add(new y(this.o)),this.r.add(this.q.onMessage(o=>this.z(o))),this.r.add(this.o.onClose(o=>this.x.fire(o))),n.initialChunk&&this.q.acceptChunk(n.initialChunk),this.t?this.l=setInterval(()=>{this.D()},l.KeepAliveSendTime):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.r.dispose()}drain(){return this.p.drain()}sendDisconnect(){const n=new d(u.Disconnect,0,0,E());this.p.write(n),this.p.flush()}sendPause(){const n=new d(u.Pause,0,0,E());this.p.write(n)}sendResume(){const n=new d(u.Resume,0,0,E());this.p.write(n)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(n,o){this.a=!0,this.r.dispose(),this.r=new N.$Vc,this.u.flushBuffer(),this.x.flushBuffer(),this.y.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=n,this.p=this.r.add(new f(this.o)),this.q=this.r.add(new y(this.o)),this.r.add(this.q.onMessage(h=>this.z(h))),this.r.add(this.o.onClose(h=>this.x.fire(h))),this.q.acceptChunk(o)}endAcceptReconnection(){this.a=!1,this.h=this.g;const n=new d(u.Ack,0,this.h,E());this.p.write(n);const o=this.b.toArray();for(let h=0,g=o.length;h<g;h++)this.p.write(o[h]);this.B()}acceptDisconnect(){this.w.fire()}z(n){if(n.ack>this.d){this.d=n.ack;do{const o=this.b.peek();if(o&&o.id<=n.ack)this.b.pop();else break}while(!0)}switch(n.type){case u.None:break;case u.Regular:{if(n.id>this.g)if(n.id!==this.g+1){const o=Date.now();o-this.m>1e4&&(this.m=o,this.p.write(new d(u.ReplayRequest,0,0,E())))}else this.g=n.id,this.j=Date.now(),this.A(),this.v.fire(n.data);break}case u.Control:{this.u.fire(n.data);break}case u.Ack:break;case u.Disconnect:{this.w.fire();break}case u.ReplayRequest:{const o=this.b.toArray();for(let h=0,g=o.length;h<g;h++)this.p.write(o[h]);this.B();break}case u.Pause:{this.p.pause();break}case u.Resume:{this.p.resume();break}case u.KeepAlive:break}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(n){const o=++this.c;this.h=this.g;const h=new d(u.Regular,o,this.h,n);this.b.push(h),this.a||(this.p.write(h),this.B())}sendControl(n){const o=new d(u.Control,0,0,n);this.p.write(o)}A(){if(this.g<=this.h||this.k)return;const n=Date.now()-this.j;if(n>=l.AcknowledgeTime){this.C();return}this.k=setTimeout(()=>{this.k=null,this.A()},l.AcknowledgeTime-n+5)}B(){if(this.c<=this.d||this.f||this.a)return;const n=this.b.peek(),o=Date.now()-n.writtenTime,h=Date.now()-this.q.lastReadTime,g=Date.now()-this.n;if(o>=l.TimeoutTime&&h>=l.TimeoutTime&&g>=l.TimeoutTime&&!this.s.hasHighLoad()){this.n=Date.now(),this.y.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:o,timeSinceLastReceivedSomeData:h});return}const R=Math.max(l.TimeoutTime-o,l.TimeoutTime-h,l.TimeoutTime-g,500);this.f=setTimeout(()=>{this.f=null,this.B()},R)}C(){if(this.g<=this.h)return;this.h=this.g;const n=new d(u.Ack,0,this.h,E());this.p.write(n)}D(){this.h=this.g;const n=new d(u.KeepAlive,0,this.h,E());this.p.write(n)}}e.$ti=a}),define(ce[96],le([0,1,69,6,15,26,148,8,3,2,30,155,93,43]),function(ne,e,P,c,N,O,T,k,A,w,E,$,u,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$br=e.$ar=void 0,k=Oe(k);class l extends p.$hi{constructor(f){super({send:b=>{try{process.send?.(b.buffer.toString("base64"))}catch{}},onMessage:A.Event.fromNodeEventEmitter(process,"message",b=>N.$Oe.wrap(Buffer.from(b,"base64")))},f),process.once("disconnect",()=>this.dispose())}}e.$ar=l;class d{constructor(f,b){this.i=f,this.j=b,this.c=new Set,this.g=new Map,this.h=new A.$me,this.onDidProcessExit=this.h.event;const I=b&&b.timeout?b.timeout:6e4;this.b=new c.$Ch(I),this.d=null,this.f=null}getChannel(f){const b=this;return{call(I,m,s){return b.k(f,I,m,s)},listen(I,m){return b.l(f,I,m)}}}k(f,b,I,m=O.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(m.isCancellationRequested)return Promise.reject(k.$8());this.b.cancel();const s=this.n(f),r=(0,c.$sh)(t=>s.call(b,I,t)),i=m.onCancellationRequested(()=>r.cancel()),a=(0,w.$Uc)(()=>r.cancel());return this.c.add(a),r.finally(()=>{i.dispose(),this.c.delete(a),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),r}l(f,b,I){if(!this.b)return A.Event.None;this.b.cancel();let m;const s=new A.$me({onWillAddFirstListener:()=>{m=this.n(f).listen(b,I)(s.fire,s),this.c.add(m)},onDidRemoveLastListener:()=>{this.c.delete(m),m.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return s.event}get m(){if(!this.f){const f=this.j&&this.j.args?this.j.args:[],b=Object.create(null);b.env={...(0,E.$bo)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(b.env={...b.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(b.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(b.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(b.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),b.execArgv===void 0&&(b.execArgv=process.execArgv.filter(o=>!/^--inspect(-brk)?=/.test(o)).filter(o=>!o.startsWith("--vscode-"))),(0,u.$lm)(b.env),this.d=(0,P.fork)(this.i,f,b);const I=new A.$me,s=A.Event.fromNodeEventEmitter(this.d,"message",o=>o)(o=>{if((0,T.$9q)(o)){(0,T.log)(o,`IPC Library: ${this.j.serverName}`);return}I.fire(N.$Oe.wrap(Buffer.from(o,"base64")))}),r=this.j.useQueue?(0,$.$ym)(this.d):this.d,i=o=>this.d&&this.d.connected&&r.send(o.buffer.toString("base64")),a=I.event,t={send:i,onMessage:a};this.f=new p.$ii(t);const n=()=>this.o();process.once("exit",n),this.d.on("error",o=>console.warn('IPC "'+this.j.serverName+'" errored with '+o)),this.d.on("exit",(o,h)=>{process.removeListener("exit",n),s.dispose(),this.c.forEach(g=>(0,w.$Rc)(g)),this.c.clear(),o!==0&&h!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+o+" and signal "+h),this.b?.cancel(),this.o(),this.h.fire({code:o,signal:h})})}return this.f}n(f){let b=this.g.get(f);return b||(b=this.m.getChannel(f),this.g.set(f,b)),b}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$br=d}),define(ce[157],le([0,1,140,15,43,3,13,19]),function(ne,e,P,c,N,O,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$OX=void 0,e.$PX=E;class A{constructor(u){this.a=u,this.onMessage=O.Event.fromNodeEventEmitter(this.a,"message",p=>p.data?c.$Oe.wrap(p.data):c.$Oe.alloc(0)),u.start()}send(u){this.a.postMessage(u.buffer)}disconnect(){this.a.close()}}class w extends N.$ji{static b(u){(0,T.$pg)((0,P.$NX)(process),"Electron Utility Process");const p=new O.$me;return process.parentPort.on("message",l=>{if(u?.handledClientConnection(l))return;const d=(0,k.$Qb)(l.ports);d&&p.fire(d)}),O.Event.map(p.event,l=>({protocol:new A(l),onDidClientDisconnect:O.Event.fromNodeEventEmitter(l,"close")}))}constructor(u){super(w.b(u))}}e.$OX=w;function E($,u,p){const l=d=>{d.data===u&&($.removeListener("message",l),p())};$.on("message",l)}}),define(ce[71],le([0,1,6,3,2,68,13]),function(ne,e,P,c,N,O,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$p=e.$0p=e.StorageState=e.StorageHint=void 0,e.$9p=A;var k;(function(u){u[u.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",u[u.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(k||(e.StorageHint=k={}));function A(u){const p=u;return p?.changed instanceof Map||p?.deleted instanceof Set}var w;(function(u){u[u.None=0]="None",u[u.Initialized=1]="Initialized",u[u.Closed=2]="Closed"})(w||(e.StorageState=w={}));class E extends N.$Wc{static{this.a=100}constructor(p,l=Object.create(null)){super(),this.r=p,this.s=l,this.b=this.B(new c.$pe),this.onDidChangeStorage=this.b.event,this.c=w.None,this.f=new Map,this.g=this.B(new P.$Dh(E.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(p=>this.u(p)))}u(p){this.b.pause();try{p.changed?.forEach((l,d)=>this.w(d,l)),p.deleted?.forEach(l=>this.w(l,void 0))}finally{this.b.resume()}}w(p,l){if(this.c===w.Closed)return;let d=!1;(0,T.$og)(l)?d=this.f.delete(p):this.f.get(p)!==l&&(this.f.set(p,l),d=!0),d&&this.b.fire({key:p,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===w.None&&(this.c=w.Initialized,this.s.hint!==k.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(p,l){const d=this.f.get(p);return(0,T.$og)(d)?l:d}getBoolean(p,l){const d=this.get(p);return(0,T.$og)(d)?l:d==="true"}getNumber(p,l){const d=this.get(p);return(0,T.$og)(d)?l:parseInt(d,10)}getObject(p,l){const d=this.get(p);return(0,T.$og)(d)?l:(0,O.$bi)(d)}async set(p,l,d=!1){if(this.c===w.Closed)return;if((0,T.$og)(l))return this.delete(p,d);const y=(0,T.$hg)(l)||Array.isArray(l)?(0,O.$ai)(l):String(l);if(this.f.get(p)!==y)return this.f.set(p,y),this.j.set(p,y),this.h.delete(p),this.b.fire({key:p,external:d}),this.D()}async delete(p,l=!1){if(!(this.c===w.Closed||!this.f.delete(p)))return this.h.has(p)||this.h.add(p),this.j.delete(p),this.b.fire({key:p,external:l}),this.D()}async optimize(){if(this.c!==w.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=w.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const p={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(p).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(p){if(!(this.c===w.Closed||this.m))return this.D(p)}async D(p){return this.s.hint===k.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),p)}async whenFlushed(){if(this.z)return new Promise(p=>this.n.push(p))}isInMemory(){return this.s.hint===k.STORAGE_IN_MEMORY}}e.$0p=E;class ${constructor(){this.onDidChangeItemsExternal=c.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(p){p.insert?.forEach((l,d)=>this.a.set(d,l)),p.delete?.forEach(l=>this.a.delete(l))}async optimize(){}async close(){}}e.$$p=$}),define(ce[158],le([12,11]),function(ne,e){return ne.create("vs/base/node/zip",e)}),define(ce[72],le([0,1,46,6,14,13,31,158]),function(ne,e,P,c,N,O,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uq=e.$tq=void 0,e.zip=y,e.$wq=f,e.$xq=I,N=Oe(N),k=Oe(k),e.$tq="end of central directory record signature not found";const A=new RegExp(e.$tq);class w extends Error{constructor(s,r){let i=r.message;switch(s){case"CorruptZip":i=`Corrupt ZIP: ${i}`;break}super(i),this.type=s,this.cause=r}}e.$uq=w;function E(m){const s=m.externalFileAttributes>>16||33188;return[448,56,7].map(r=>s&r).reduce((r,i)=>r+i,s&61440)}function $(m){if(m instanceof w)return m;let s;return A.test(m.message)&&(s="CorruptZip"),new w(s,m)}function u(m,s,r,i,a,t){const n=N.$oc(s),o=N.$lc(i,n);if(!o.startsWith(i))return Promise.reject(new Error(k.localize(0,null,s)));const h=N.$lc(i,s);let g;return t.onCancellationRequested(()=>{g?.destroy()}),Promise.resolve(T.Promises.mkdir(o,{recursive:!0})).then(()=>new Promise((R,L)=>{if(!t.isCancellationRequested)try{g=(0,P.createWriteStream)(h,{mode:r}),g.once("close",()=>R()),g.once("error",L),m.once("error",L),m.pipe(g)}catch(S){L(S)}}))}function p(m,s,r,i){let a=(0,c.$sh)(()=>Promise.resolve()),t=0;const n=i.onCancellationRequested(()=>{a.cancel(),m.close()});return new Promise((o,h)=>{const g=new c.$Ah,R=L=>{L.isCancellationRequested||(t++,m.readEntry())};m.once("error",h),m.once("close",()=>a.then(()=>{i.isCancellationRequested||m.entryCount===t?o():h(new w("Incomplete",new Error(k.localize(1,null,t,m.entryCount))))},h)),m.readEntry(),m.on("entry",L=>{if(i.isCancellationRequested)return;if(!r.sourcePathRegex.test(L.fileName)){R(i);return}const S=L.fileName.replace(r.sourcePathRegex,"");if(/\/$/.test(S)){const F=N.$lc(s,S);a=(0,c.$sh)(D=>T.Promises.mkdir(F,{recursive:!0}).then(()=>R(D)).then(void 0,h));return}const v=d(m,L),C=E(L);a=(0,c.$sh)(F=>g.queue(()=>v.then(D=>u(D,S,C,s,r,F).then(()=>R(F)))).then(null,h))})}).finally(()=>n.dispose())}async function l(m,s=!1){const{open:r}=await new Promise((i,a)=>{ne(["yauzl"],i,a)}).then(Oe);return new Promise((i,a)=>{r(m,s?{lazyEntries:!0}:void 0,(t,n)=>{t?a($(t)):i((0,O.$qg)(n))})})}function d(m,s){return new Promise((r,i)=>{m.openReadStream(s,(a,t)=>{a?i($(a)):r((0,O.$qg)(t))})})}async function y(m,s){const{ZipFile:r}=await new Promise((i,a)=>{ne(["yazl"],i,a)}).then(Oe);return new Promise((i,a)=>{const t=new r;s.forEach(o=>{o.contents?t.addBuffer(typeof o.contents=="string"?Buffer.from(o.contents,"utf8"):o.contents,o.path):o.localPath&&t.addFile(o.localPath,o.path)}),t.end();const n=(0,P.createWriteStream)(m);t.outputStream.pipe(n),t.outputStream.once("error",a),n.once("error",a),n.once("finish",()=>i(m))})}function f(m,s,r={},i){const a=new RegExp(r.sourcePath?`^${r.sourcePath}`:"");let t=l(m,!0);return r.overwrite&&(t=t.then(n=>T.Promises.rm(s).then(()=>n))),t.then(n=>p(n,s,{sourcePathRegex:a},i))}function b(m,s){return l(m).then(r=>new Promise((i,a)=>{r.on("entry",t=>{t.fileName===s&&d(r,t).then(n=>i(n),n=>a(n))}),r.once("close",()=>a(new Error(k.localize(2,null,s))))}))}function I(m,s){return b(m,s).then(r=>new Promise((i,a)=>{const t=[];r.once("error",a),r.on("data",n=>t.push(n)),r.on("end",()=>i(Buffer.concat(t)))}))}}),define(ce[159],le([12,11]),function(ne,e){return ne.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ce[160],le([12,11]),function(ne,e){return ne.create("vs/platform/contextkey/common/contextkey",e)}),define(ce[161],le([12,11]),function(ne,e){return ne.create("vs/platform/contextkey/common/scanner",e)}),define(ce[162],le([12,11]),function(ne,e){return ne.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(ce[163],le([12,11]),function(ne,e){return ne.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ce[164],le([12,11]),function(ne,e){return ne.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(ce[165],le([12,11]),function(ne,e){return ne.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(ce[166],le([12,11]),function(ne,e){return ne.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(ce[167],le([12,11]),function(ne,e){return ne.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(ce[168],le([12,11]),function(ne,e){return ne.create("vs/platform/extensions/common/extensionValidator",e)}),define(ce[169],le([12,11]),function(ne,e){return ne.create("vs/platform/files/common/fileService",e)}),define(ce[170],le([12,11]),function(ne,e){return ne.create("vs/platform/files/common/files",e)}),define(ce[171],le([12,11]),function(ne,e){return ne.create("vs/platform/files/common/io",e)}),define(ce[172],le([12,11]),function(ne,e){return ne.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(ce[173],le([12,11]),function(ne,e){return ne.create("vs/platform/languagePacks/common/languagePacks",e)}),define(ce[174],le([12,11]),function(ne,e){return ne.create("vs/platform/log/common/log",e)}),define(ce[175],le([12,11]),function(ne,e){return ne.create("vs/platform/remoteTunnel/common/remoteTunnel",e)}),define(ce[176],le([12,11]),function(ne,e){return ne.create("vs/platform/remoteTunnel/node/remoteTunnelService",e)}),define(ce[177],le([12,11]),function(ne,e){return ne.create("vs/platform/request/common/request",e)}),define(ce[178],le([12,11]),function(ne,e){return ne.create("vs/platform/telemetry/common/telemetryLogAppender",e)}),define(ce[179],le([12,11]),function(ne,e){return ne.create("vs/platform/telemetry/common/telemetryService",e)}),define(ce[180],le([12,11]),function(ne,e){return ne.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(ce[181],le([12,11]),function(ne,e){return ne.create("vs/platform/userDataSync/common/abstractSynchronizer",e)}),define(ce[182],le([12,11]),function(ne,e){return ne.create("vs/platform/userDataSync/common/keybindingsSync",e)}),define(ce[183],le([12,11]),function(ne,e){return ne.create("vs/platform/userDataSync/common/settingsSync",e)}),define(ce[184],le([12,11]),function(ne,e){return ne.create("vs/platform/userDataSync/common/userDataAutoSyncService",e)}),define(ce[185],le([12,11]),function(ne,e){return ne.create("vs/platform/userDataSync/common/userDataSync",e)}),define(ce[186],le([12,11]),function(ne,e){return ne.create("vs/platform/userDataSync/common/userDataSyncLog",e)}),define(ce[187],le([12,11]),function(ne,e){return ne.create("vs/platform/userDataSync/common/userDataSyncMachines",e)}),define(ce[188],le([12,11]),function(ne,e){return ne.create("vs/platform/userDataSync/common/userDataSyncResourceProvider",e)}),define(ce[189],le([12,11]),function(ne,e){return ne.create("vs/platform/workspace/common/workspace",e)}),define(ce[190],le([0,1,39,8,161]),function(ne,e,P,c,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Aj=e.TokenType=void 0;var O;(function(E){E[E.LParen=0]="LParen",E[E.RParen=1]="RParen",E[E.Neg=2]="Neg",E[E.Eq=3]="Eq",E[E.NotEq=4]="NotEq",E[E.Lt=5]="Lt",E[E.LtEq=6]="LtEq",E[E.Gt=7]="Gt",E[E.GtEq=8]="GtEq",E[E.RegexOp=9]="RegexOp",E[E.RegexStr=10]="RegexStr",E[E.True=11]="True",E[E.False=12]="False",E[E.In=13]="In",E[E.Not=14]="Not",E[E.And=15]="And",E[E.Or=16]="Or",E[E.Str=17]="Str",E[E.QuotedStr=18]="QuotedStr",E[E.Error=19]="Error",E[E.EOF=20]="EOF"})(O||(e.TokenType=O={}));function T(...E){switch(E.length){case 1:return(0,N.localize)(0,null,E[0]);case 2:return(0,N.localize)(1,null,E[0],E[1]);case 3:return(0,N.localize)(2,null,E[0],E[1],E[2]);default:return}}const k=(0,N.localize)(3,null),A=(0,N.localize)(4,null);class w{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme($){switch($.type){case O.LParen:return"(";case O.RParen:return")";case O.Neg:return"!";case O.Eq:return $.isTripleEq?"===":"==";case O.NotEq:return $.isTripleEq?"!==":"!=";case O.Lt:return"<";case O.LtEq:return"<=";case O.Gt:return">=";case O.GtEq:return">=";case O.RegexOp:return"=~";case O.RegexStr:return $.lexeme;case O.True:return"true";case O.False:return"false";case O.In:return"in";case O.Not:return"not";case O.And:return"&&";case O.Or:return"||";case O.Str:return $.lexeme;case O.QuotedStr:return $.lexeme;case O.Error:return $.lexeme;case O.EOF:return"EOF";default:throw(0,c.$0)(`unhandled token type: ${JSON.stringify($)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map($=>$.charCodeAt(0)))}static{this.b=new Map([["not",O.Not],["in",O.In],["false",O.False],["true",O.True]])}get errors(){return this.g}reset($){return this.c=$,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case P.CharCode.OpenParen:this.k(O.LParen);break;case P.CharCode.CloseParen:this.k(O.RParen);break;case P.CharCode.ExclamationMark:if(this.h(P.CharCode.Equals)){const u=this.h(P.CharCode.Equals);this.f.push({type:O.NotEq,offset:this.d,isTripleEq:u})}else this.k(O.Neg);break;case P.CharCode.SingleQuote:this.o();break;case P.CharCode.Slash:this.q();break;case P.CharCode.Equals:if(this.h(P.CharCode.Equals)){const u=this.h(P.CharCode.Equals);this.f.push({type:O.Eq,offset:this.d,isTripleEq:u})}else this.h(P.CharCode.Tilde)?this.k(O.RegexOp):this.l(T("==","=~"));break;case P.CharCode.LessThan:this.k(this.h(P.CharCode.Equals)?O.LtEq:O.Lt);break;case P.CharCode.GreaterThan:this.k(this.h(P.CharCode.Equals)?O.GtEq:O.Gt);break;case P.CharCode.Ampersand:this.h(P.CharCode.Ampersand)?this.k(O.And):this.l(T("&&"));break;case P.CharCode.Pipe:this.h(P.CharCode.Pipe)?this.k(O.Or):this.l(T("||"));break;case P.CharCode.Space:case P.CharCode.CarriageReturn:case P.CharCode.Tab:case P.CharCode.LineFeed:case P.CharCode.NoBreakSpace:break;default:this.n()}return this.d=this.e,this.k(O.EOF),Array.from(this.f)}h($){return this.r()||this.c.charCodeAt(this.e)!==$?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?P.CharCode.Null:this.c.charCodeAt(this.e)}k($){this.f.push({type:$,offset:this.d})}l($){const u=this.d,p=this.c.substring(this.d,this.e),l={type:O.Error,offset:this.d,lexeme:p};this.g.push({offset:u,lexeme:p,additionalInfo:$}),this.f.push(l)}n(){this.m.lastIndex=this.d;const $=this.m.exec(this.c);if($){this.e=this.d+$[0].length;const u=this.c.substring(this.d,this.e),p=w.b.get(u);p?this.k(p):this.f.push({type:O.Str,lexeme:u,offset:this.d})}}o(){for(;this.j()!==P.CharCode.SingleQuote&&!this.r();)this.i();if(this.r()){this.l(k);return}this.i(),this.f.push({type:O.QuotedStr,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let $=this.e,u=!1,p=!1;for(;;){if($>=this.c.length){this.e=$,this.l(A);return}const d=this.c.charCodeAt($);if(u)u=!1;else if(d===P.CharCode.Slash&&!p){$++;break}else d===P.CharCode.OpenSquareBracket?p=!0:d===P.CharCode.Backslash?u=!0:d===P.CharCode.CloseSquareBracket&&(p=!1);$++}for(;$<this.c.length&&w.a.has(this.c.charCodeAt($));)$++;this.e=$;const l=this.c.substring(this.d,this.e);this.f.push({type:O.RegexStr,lexeme:l,offset:this.d})}r(){return this.e>=this.c.length}}e.$Aj=w}),define(ce[191],le([0,1,67,88,23,14,36,21,9]),function(ne,e,P,c,N,O,T,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5m=e.$4m=void 0,e.$6m=E,e.$7m=$,e.$4m=/^([^.]+\..+)[:=](.+)$/;class w{get appRoot(){return(0,O.$oc)(N.$Zg.asFileUri("").fsPath)}get userHome(){return A.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return A.URI.file((0,O.$lc)(this.userDataPath,"User"))}get tmpDir(){return A.URI.file(this.b.tmpDir)}get cacheHome(){return A.URI.file(this.userDataPath)}get stateResource(){return(0,k.$gh)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:N.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,k.$gh)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const p=(0,P.$3m)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,O.$lc)(this.userDataPath,"logs",p)}return A.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,k.$gh)(A.URI.file((0,O.$lc)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,k.$gh)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,k.$gh)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,k.$gh)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const p=T.env.VSCODE_PORTABLE;return p?A.URI.file((0,O.$lc)(p,"argv.json")):(0,k.$gh)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return A.URI.file((0,O.$lc)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const p=this.args["builtin-extensions-dir"];return p?(0,O.$mc)(p):(0,O.$jc)((0,O.$lc)(N.$Zg.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const p=this.args["extensions-download-dir"];return p?A.URI.file((0,O.$mc)(p)):A.URI.file((0,O.$lc)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const p=this.args["extensions-dir"];if(p)return(0,O.$mc)(p);const l=T.env.VSCODE_EXTENSIONS;if(l)return l;const d=T.env.VSCODE_PORTABLE;return d?(0,O.$lc)(d,"extensions"):(0,k.$gh)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const p=this.args.extensionDevelopmentPath;if(Array.isArray(p))return p.map(l=>/^[^:/?#]+?:\/\//.test(l)?A.URI.parse(l):A.URI.file((0,O.$jc)(l)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(p=>p==="ui"||p==="workspace"||p==="web"?p:"workspace")}get extensionTestsLocationURI(){const p=this.args.extensionTestsPath;if(p)return/^[^:/?#]+?:\/\//.test(p)?A.URI.parse(p):A.URI.file((0,O.$jc)(p))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const p=this.args["disable-extension"];if(p){if(typeof p=="string")return[p];if(Array.isArray(p)&&p.length>0)return p}return!1}get debugExtensionHost(){return E(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!T.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(p=>!e.$4m.test(p))}get extensionLogLevel(){const p=[];for(const l of this.args.log||[]){const d=e.$4m.exec(l);d&&d[1]&&d[2]&&p.push([d[1],d[2]])}return p.length?p:void 0}get serviceMachineIdResource(){return(0,k.$gh)(A.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get useInMemorySecretStorage(){return!!this.args["use-inmemory-secretstorage"]}get policyFile(){if(this.args["__enable-file-policy"]){const p=T.env.VSCODE_PORTABLE;return p?A.URI.file((0,O.$lc)(p,"policy.json")):(0,k.$gh)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(p){this.args.continueOn=p}get args(){return this.a}constructor(p,l,d){this.a=p,this.b=l,this.c=d,this.editSessionId=this.args.editSessionId}}e.$5m=w,ve([c.$0h],w.prototype,"appRoot",null),ve([c.$0h],w.prototype,"userHome",null),ve([c.$0h],w.prototype,"userDataPath",null),ve([c.$0h],w.prototype,"appSettingsHome",null),ve([c.$0h],w.prototype,"tmpDir",null),ve([c.$0h],w.prototype,"cacheHome",null),ve([c.$0h],w.prototype,"stateResource",null),ve([c.$0h],w.prototype,"userRoamingDataHome",null),ve([c.$0h],w.prototype,"userDataSyncHome",null),ve([c.$0h],w.prototype,"sync",null),ve([c.$0h],w.prototype,"machineSettingsResource",null),ve([c.$0h],w.prototype,"workspaceStorageHome",null),ve([c.$0h],w.prototype,"localHistoryHome",null),ve([c.$0h],w.prototype,"keyboardLayoutResource",null),ve([c.$0h],w.prototype,"argvResource",null),ve([c.$0h],w.prototype,"isExtensionDevelopment",null),ve([c.$0h],w.prototype,"untitledWorkspacesHome",null),ve([c.$0h],w.prototype,"builtinExtensionsPath",null),ve([c.$0h],w.prototype,"extensionsPath",null),ve([c.$0h],w.prototype,"extensionDevelopmentLocationURI",null),ve([c.$0h],w.prototype,"extensionDevelopmentKind",null),ve([c.$0h],w.prototype,"extensionTestsLocationURI",null),ve([c.$0h],w.prototype,"debugExtensionHost",null),ve([c.$0h],w.prototype,"logLevel",null),ve([c.$0h],w.prototype,"extensionLogLevel",null),ve([c.$0h],w.prototype,"serviceMachineIdResource",null),ve([c.$0h],w.prototype,"disableTelemetry",null),ve([c.$0h],w.prototype,"disableWorkspaceTrust",null),ve([c.$0h],w.prototype,"useInMemorySecretStorage",null),ve([c.$0h],w.prototype,"policyFile",null);function E(u,p){return $(u["inspect-extensions"],u["inspect-brk-extensions"],5870,p,u.debugId,u.extensionEnvironment)}function $(u,p,l,d,y,f){const I=Number(p||u)||(d?null:l),m=I?!!p:!1;let s;if(f)try{s=JSON.parse(f)}catch{}return{port:I,break:m,debugId:y,env:s}}}),function(){"use strict";function ne(e,P,c){function N(T,k){const A=O(T,k),w=[A];return e.isAbsolute(A)||w.unshift(c),e.resolve(...w)}function O(T,k){process.env.VSCODE_DEV&&(k="code-oss-dev");const A=process.env.VSCODE_PORTABLE;if(A)return e.join(A,"user-data");let w=process.env.VSCODE_APPDATA;if(w)return e.join(w,k);const E=T["user-data-dir"];if(E)return E;switch(process.platform){case"win32":if(w=process.env.APPDATA,!w){const $=process.env.USERPROFILE;if(typeof $!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");w=e.join($,"AppData","Roaming")}break;case"darwin":w=e.join(P.homedir(),"Library","Application Support");break;case"linux":w=process.env.XDG_CONFIG_HOME||e.join(P.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(w,k)}return{getUserDataPath:N}}if(typeof define=="function")define(ce[192],le([279,38,36]),function(e,P,c){return ne(e,P,c.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),P=require("os");module.exports=ne(e,P,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(ce[193],le([0,1,38,191,192]),function(ne,e,P,c,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8m=void 0,e.$9m=T,e.$0m=k;class O extends c.$5m{constructor(w,E){super(w,{homeDir:(0,P.homedir)(),tmpDir:(0,P.tmpdir)(),userDataDir:(0,N.getUserDataPath)(w,E.nameShort)},E)}}e.$8m=O;function T(A,w){return(0,c.$7m)(A["inspect-ptyhost"],A["inspect-brk-ptyhost"],5877,w,A.extensionEnvironment)}function k(A,w){return(0,c.$7m)(A["inspect-sharedprocess"],A["inspect-brk-sharedprocess"],5879,w,A.extensionEnvironment)}}),define(ce[194],le([0,1,13,164]),function(ne,e,P,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fq=N;function N(T,k,A,w){try{O(T,k,A,w)}catch(E){T.error(E?.message??E)}return k}function O(T,k,A,w){const E=($,u,p)=>{const l=$[u];if((0,P.$fg)(l)){const d=l,y=d.length;if(y>1&&d[0]==="%"&&d[y-1]==="%"){const f=d.substr(1,y-2);let b=A[f];b===void 0&&w&&(b=w[f]);const I=typeof b=="string"?b:b?.message,m=w?.[f],s=typeof m=="string"?m:m?.message;if(!I){s||T.warn(`[${k.name}]: ${(0,c.localize)(0,null,f)}`);return}if(p&&(u==="title"||u==="category")&&s&&s!==I){const r={value:I,original:s};$[u]=r}else $[u]=I}}else if((0,P.$hg)(l))for(const d in l)l.hasOwnProperty(d)&&(d==="commands"?E(l,d,!0):E(l,d,p));else if(Array.isArray(l))for(let d=0;d<l.length;d++)E(l,d,p)};for(const $ in k)k.hasOwnProperty($)&&E(k,$)}}),define(ce[195],le([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fhc=e.$ehc=void 0;class P{constructor(O){this.a=O}get ignoredRecommendations(){throw new Error("not supported")}promptImportantExtensionsInstallNotification(O){return this.a.call("promptImportantExtensionsInstallNotification",[O])}promptWorkspaceRecommendations(O){throw new Error("not supported")}hasToIgnoreRecommendationNotifications(){throw new Error("not supported")}}e.$ehc=P;class c{constructor(O){this.a=O}listen(O,T){throw new Error(`Event not found: ${T}`)}call(O,T,k){switch(T){case"promptImportantExtensionsInstallNotification":return this.a.promptImportantExtensionsInstallNotification(k[0])}throw new Error(`Call not found: ${T}`)}}e.$fhc=c});var it=this&&this.__importDefault||function(ne){return ne&&ne.__esModule?ne:{default:ne}};define(ce[73],le([0,1,21,92,168,57]),function(ne,e,P,c,N,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tp=A,e.$Up=w,e.$Vp=E,e.$Wp=$,e.$Xp=u,e.$Yp=p,e.$Zp=l,c=it(c),N=Oe(N),O=Oe(O);const T=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,k=/^-(\d{4})(\d{2})(\d{2})$/;function A(f){return f=f.trim(),f==="*"||T.test(f)}function w(f){if(!A(f))return null;if(f=f.trim(),f==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const b=f.match(T);return b?{hasCaret:b[1]==="^",hasGreaterEquals:b[1]===">=",majorBase:b[2]==="x"?0:parseInt(b[2],10),majorMustEqual:b[2]!=="x",minorBase:b[4]==="x"?0:parseInt(b[4],10),minorMustEqual:b[4]!=="x",patchBase:b[6]==="x"?0:parseInt(b[6],10),patchMustEqual:b[6]!=="x",preRelease:b[8]||null}:null}function E(f){if(!f)return null;const b=f.majorBase,I=f.majorMustEqual,m=f.minorBase;let s=f.minorMustEqual;const r=f.patchBase;let i=f.patchMustEqual;f.hasCaret&&(b===0||(s=!1),i=!1);let a=0;if(f.preRelease){const t=k.exec(f.preRelease);if(t){const[,n,o,h]=t;a=Date.UTC(Number(n),Number(o)-1,Number(h))}}return{majorBase:b,majorMustEqual:I,minorBase:m,minorMustEqual:s,patchBase:r,patchMustEqual:i,isMinimum:f.hasGreaterEquals,notBefore:a}}function $(f,b,I){let m;typeof f=="string"?m=E(w(f)):m=f;let s;b instanceof Date?s=b.getTime():typeof b=="string"&&(s=new Date(b).getTime());let r;if(typeof I=="string"?r=E(w(I)):r=I,!m||!r)return!1;const i=m.majorBase,a=m.minorBase,t=m.patchBase;let n=r.majorBase,o=r.minorBase,h=r.patchBase;const g=r.notBefore;let R=r.majorMustEqual,L=r.minorMustEqual,S=r.patchMustEqual;return r.isMinimum?i>n?!0:i<n?!1:a>o?!0:a<o||s&&s<g?!1:t>=h:(i===1&&n===0&&(!R||!L||!S)&&(n=1,o=0,h=0,R=!0,L=!1,S=!1),i<n?!1:i>n?!R:a<o?!1:a>o?!L:t<h?!1:t>h?!S:!(s&&s<g))}function u(f,b,I,m,s){const r=[];if(typeof m.publisher<"u"&&typeof m.publisher!="string")return r.push([c.default.Error,N.localize(0,null)]),r;if(typeof m.name!="string")return r.push([c.default.Error,N.localize(1,null,"name")]),r;if(typeof m.version!="string")return r.push([c.default.Error,N.localize(2,null,"version")]),r;if(!m.engines)return r.push([c.default.Error,N.localize(3,null,"engines")]),r;if(typeof m.engines.vscode!="string")return r.push([c.default.Error,N.localize(4,null,"engines.vscode")]),r;if(typeof m.extensionDependencies<"u"&&!y(m.extensionDependencies))return r.push([c.default.Error,N.localize(5,null,"extensionDependencies")]),r;if(typeof m.activationEvents<"u"){if(!y(m.activationEvents))return r.push([c.default.Error,N.localize(6,null,"activationEvents")]),r;if(typeof m.main>"u"&&typeof m.browser>"u")return r.push([c.default.Error,N.localize(7,null,"activationEvents","main","browser")]),r}if(typeof m.extensionKind<"u"&&typeof m.main>"u"&&r.push([c.default.Warning,N.localize(8,null,"extensionKind")]),typeof m.main<"u"){if(typeof m.main!="string")return r.push([c.default.Error,N.localize(9,null,"main")]),r;{const t=(0,P.$gh)(I,m.main);(0,P.$ah)(t,I)||r.push([c.default.Warning,N.localize(10,null,t.path,I.path)])}}if(typeof m.browser<"u"){if(typeof m.browser!="string")return r.push([c.default.Error,N.localize(11,null,"browser")]),r;{const t=(0,P.$gh)(I,m.browser);(0,P.$ah)(t,I)||r.push([c.default.Warning,N.localize(12,null,t.path,I.path)])}}if(!O.valid(m.version))return r.push([c.default.Error,N.localize(13,null)]),r;const i=[];if(!p(f,b,m,s,i))for(const t of i)r.push([c.default.Error,t]);return r}function p(f,b,I,m,s){return m||typeof I.main>"u"&&typeof I.browser>"u"?!0:d(f,b,I.engines.vscode,s)}function l(f,b,I){return f==="*"||d(b,I,f)}function d(f,b,I,m=[]){const s=E(w(I));if(!s)return m.push(N.localize(14,null,I)),!1;if(s.majorBase===0){if(!s.majorMustEqual||!s.minorMustEqual)return m.push(N.localize(15,null,I)),!1}else if(!s.majorMustEqual)return m.push(N.localize(16,null,I)),!1;return $(f,b,s)?!0:(m.push(N.localize(17,null,f,I)),!1)}function y(f){if(!Array.isArray(f))return!1;for(let b=0,I=f.length;b<I;b++)if(typeof f[b]!="string")return!1;return!0}}),define(ce[74],le([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ci=void 0;class P{constructor(N,O=[],T=!1){this.ctor=N,this.staticArguments=O,this.supportsDelayedInstantiation=T}}e.$Ci=P}),define(ce[196],le([0,1,74]),function(ne,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationType=void 0,e.$Ks=O,e.$Ls=T;const c=[];var N;(function(k){k[k.Eager=0]="Eager",k[k.Delayed=1]="Delayed"})(N||(e.InstantiationType=N={}));function O(k,A,w){A instanceof P.$Ci||(A=new P.$Ci(A,[],!!w)),c.push([k,A])}function T(){return c}}),define(ce[197],le([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$or=e.$nr=void 0;class P{constructor(O,T){this.key=O,this.data=T,this.incoming=new Map,this.outgoing=new Map}}e.$nr=P;class c{constructor(O){this.b=O,this.a=new Map}roots(){const O=[];for(const T of this.a.values())T.outgoing.size===0&&O.push(T);return O}insertEdge(O,T){const k=this.lookupOrInsertNode(O),A=this.lookupOrInsertNode(T);k.outgoing.set(A.key,A),A.incoming.set(k.key,k)}removeNode(O){const T=this.b(O);this.a.delete(T);for(const k of this.a.values())k.outgoing.delete(T),k.incoming.delete(T)}lookupOrInsertNode(O){const T=this.b(O);let k=this.a.get(T);return k||(k=new P(T,O),this.a.set(T,k)),k}lookup(O){return this.a.get(this.b(O))}isEmpty(){return this.a.size===0}toString(){const O=[];for(const[T,k]of this.a)O.push(`${T}
	(-> incoming)[${[...k.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...k.outgoing.keys()].join(",")}]
`);return O.join(`
`)}findCycleSlow(){for(const[O,T]of this.a){const k=new Set([O]),A=this.c(T,k);if(A)return A}}c(O,T){for(const[k,A]of O.outgoing){if(T.has(k))return[...T,k].join(" -> ");T.add(k);const w=this.c(A,T);if(w)return w;T.delete(k)}}}e.$or=c}),define(ce[4],le([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ei=e._util=void 0,e.$Fi=N,e.$Gi=O;var P;(function(T){T.serviceIds=new Map,T.DI_TARGET="$di$target",T.DI_DEPENDENCIES="$di$dependencies";function k(A){return A[T.DI_DEPENDENCIES]||[]}T.getServiceDependencies=k})(P||(e._util=P={})),e.$Ei=N("instantiationService");function c(T,k,A){k[P.DI_TARGET]===k?k[P.DI_DEPENDENCIES].push({id:T,index:A}):(k[P.DI_DEPENDENCIES]=[{id:T,index:A}],k[P.DI_TARGET]=k)}function N(T){if(P.serviceIds.has(T))return P.serviceIds.get(T);const k=function(A,w,E){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");c(k,A,E)};return k.toString=()=>T,P.serviceIds.set(T,k),k}function O(T){return T}}),define(ce[198],le([0,1,4]),function(ne,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qgc=void 0,e.$Qgc=(0,P.$Fi)("checksumService")}),define(ce[22],le([0,1,13,9,4]),function(ne,e,P,c,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationTarget=e.$_i=void 0,e.$aj=O,e.$bj=T,e.$cj=A,e.$dj=w,e.$ej=E,e.$fj=$,e.$gj=u,e.$hj=l,e.$ij=d,e.$jj=y,P=Oe(P),e.$_i=(0,N.$Fi)("configurationService");function O(f){return f&&typeof f=="object"&&(!f.overrideIdentifier||typeof f.overrideIdentifier=="string")&&(!f.resource||f.resource instanceof c.URI)}function T(f){return f&&typeof f=="object"&&(!f.overrideIdentifiers||Array.isArray(f.overrideIdentifiers))&&!f.overrideIdentifier&&(!f.resource||f.resource instanceof c.URI)}var k;(function(f){f[f.APPLICATION=1]="APPLICATION",f[f.USER=2]="USER",f[f.USER_LOCAL=3]="USER_LOCAL",f[f.USER_REMOTE=4]="USER_REMOTE",f[f.WORKSPACE=5]="WORKSPACE",f[f.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",f[f.DEFAULT=7]="DEFAULT",f[f.MEMORY=8]="MEMORY"})(k||(e.ConfigurationTarget=k={}));function A(f){switch(f){case k.APPLICATION:return"APPLICATION";case k.USER:return"USER";case k.USER_LOCAL:return"USER_LOCAL";case k.USER_REMOTE:return"USER_REMOTE";case k.WORKSPACE:return"WORKSPACE";case k.WORKSPACE_FOLDER:return"WORKSPACE_FOLDER";case k.DEFAULT:return"DEFAULT";case k.MEMORY:return"MEMORY"}}function w(f){return f.applicationValue!==void 0||f.userValue!==void 0||f.userLocalValue!==void 0||f.userRemoteValue!==void 0||f.workspaceValue!==void 0||f.workspaceFolderValue!==void 0}function E(f,b){const I=Object.create(null);for(const m in f)$(I,m,f[m],b);return I}function $(f,b,I,m){const s=b.split("."),r=s.pop();let i=f;for(let a=0;a<s.length;a++){const t=s[a];let n=i[t];switch(typeof n){case"undefined":n=i[t]=Object.create(null);break;case"object":if(n===null){m(`Ignoring ${b} as ${s.slice(0,a+1).join(".")} is null`);return}break;default:m(`Ignoring ${b} as ${s.slice(0,a+1).join(".")} is ${JSON.stringify(n)}`);return}i=n}if(typeof i=="object"&&i!==null)try{i[r]=I}catch{m(`Ignoring ${b} as ${s.join(".")} is ${JSON.stringify(i)}`)}else m(`Ignoring ${b} as ${s.join(".")} is ${JSON.stringify(i)}`)}function u(f,b){const I=b.split(".");p(f,I)}function p(f,b){const I=b.shift();if(b.length===0){delete f[I];return}if(Object.keys(f).indexOf(I)!==-1){const m=f[I];typeof m=="object"&&!Array.isArray(m)&&(p(m,b),Object.keys(m).length===0&&delete f[I])}}function l(f,b,I){function m(i,a){let t=i;for(const n of a){if(typeof t!="object"||t===null)return;t=t[n]}return t}const s=b.split("."),r=m(f,s);return typeof r>"u"?I:r}function d(f,b,I){Object.keys(b).forEach(m=>{m!=="__proto__"&&(m in f?P.$hg(f[m])&&P.$hg(b[m])?d(f[m],b[m],I):I&&(f[m]=b[m]):f[m]=b[m])})}function y(f){return f.replace(/[\[\]]/g,"")}}),define(ce[97],le([0,1,39,5,27,190,4,160,8]),function(ne,e,P,c,N,O,T,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xj=e.$Wj=e.$Vj=e.$Uj=e.$Tj=e.$Sj=e.$Rj=e.$Qj=e.$Pj=e.$Oj=e.$Nj=e.$Mj=e.$Lj=e.$Kj=e.$Jj=e.$Ij=e.$Hj=e.$Gj=e.$Dj=e.$Cj=e.ContextKeyExprType=void 0,e.$Bj=E,e.$Ej=a,e.$Fj=t,e.$Yj=q;const w=new Map;w.set("false",!1),w.set("true",!0),w.set("isMac",c.$j),w.set("isLinux",c.$k),w.set("isWindows",c.$i),w.set("isWeb",c.$o),w.set("isMacNative",c.$j&&!c.$o),w.set("isEdge",c.$H),w.set("isFirefox",c.$F),w.set("isChrome",c.$E),w.set("isSafari",c.$G);function E(G,U){if(w.get(G)!==void 0)throw(0,A.$9)("contextkey.setConstant(k, v) invoked with already set constant `k`");w.set(G,U)}const $=Object.prototype.hasOwnProperty;var u;(function(G){G[G.False=0]="False",G[G.True=1]="True",G[G.Defined=2]="Defined",G[G.Not=3]="Not",G[G.Equals=4]="Equals",G[G.NotEquals=5]="NotEquals",G[G.And=6]="And",G[G.Regex=7]="Regex",G[G.NotRegex=8]="NotRegex",G[G.Or=9]="Or",G[G.In=10]="In",G[G.NotIn=11]="NotIn",G[G.Greater=12]="Greater",G[G.GreaterEquals=13]="GreaterEquals",G[G.Smaller=14]="Smaller",G[G.SmallerEquals=15]="SmallerEquals"})(u||(e.ContextKeyExprType=u={}));const p={regexParsingWithErrorRecovery:!0},l=(0,k.localize)(0,null),d=(0,k.localize)(1,null),y=(0,k.localize)(2,null),f=(0,k.localize)(3,null),b=(0,k.localize)(4,null),I=(0,k.localize)(5,null),m=(0,k.localize)(6,null),s=(0,k.localize)(7,null);class r{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(U=p){this.k=U,this.d=new O.$Aj,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(U){if(U===""){this.h.push({message:l,offset:0,lexeme:"",additionalInfo:d});return}this.f=this.d.reset(U).scan(),this.g=0,this.h=[];try{const B=this.l();if(!this.E()){const j=this.D(),W=j.type===O.TokenType.Str?I:void 0;throw this.h.push({message:b,offset:j.offset,lexeme:O.$Aj.getLexeme(j),additionalInfo:W}),r.c}return B}catch(B){if(B!==r.c)throw B;return}}l(){return this.m()}m(){const U=[this.o()];for(;this.y(O.TokenType.Or);){const B=this.o();U.push(B)}return U.length===1?U[0]:i.or(...U)}o(){const U=[this.s()];for(;this.y(O.TokenType.And);){const B=this.s();U.push(B)}return U.length===1?U[0]:i.and(...U)}s(){if(this.y(O.TokenType.Neg)){const U=this.D();switch(U.type){case O.TokenType.True:return this.z(),o.INSTANCE;case O.TokenType.False:return this.z(),h.INSTANCE;case O.TokenType.LParen:{this.z();const B=this.l();return this.A(O.TokenType.RParen,f),B?.negate()}case O.TokenType.Str:return this.z(),C.create(U.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",U)}}return this.t()}t(){const U=this.D();switch(U.type){case O.TokenType.True:return this.z(),i.true();case O.TokenType.False:return this.z(),i.false();case O.TokenType.LParen:{this.z();const B=this.l();return this.A(O.TokenType.RParen,f),B}case O.TokenType.Str:{const B=U.lexeme;if(this.z(),this.y(O.TokenType.RegexOp)){const W=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),W.type!==O.TokenType.RegexStr)throw this.B("REGEX",W);const te=W.lexeme,_=te.lastIndexOf("/"),Q=_===te.length-1?void 0:this.w(te.substring(_+1));let ae;try{ae=new RegExp(te.substring(1,_),Q)}catch{throw this.B("REGEX",W)}return x.create(B,ae)}switch(W.type){case O.TokenType.RegexStr:case O.TokenType.Error:{const te=[W.lexeme];this.z();let _=this.D(),Q=0;for(let Ee=0;Ee<W.lexeme.length;Ee++)W.lexeme.charCodeAt(Ee)===P.CharCode.OpenParen?Q++:W.lexeme.charCodeAt(Ee)===P.CharCode.CloseParen&&Q--;for(;!this.E()&&_.type!==O.TokenType.And&&_.type!==O.TokenType.Or;){switch(_.type){case O.TokenType.LParen:Q++;break;case O.TokenType.RParen:Q--;break;case O.TokenType.RegexStr:case O.TokenType.QuotedStr:for(let Ee=0;Ee<_.lexeme.length;Ee++)_.lexeme.charCodeAt(Ee)===P.CharCode.OpenParen?Q++:W.lexeme.charCodeAt(Ee)===P.CharCode.CloseParen&&Q--}if(Q<0)break;te.push(O.$Aj.getLexeme(_)),this.z(),_=this.D()}const ae=te.join(""),ue=ae.lastIndexOf("/"),ge=ue===ae.length-1?void 0:this.w(ae.substring(ue+1));let we;try{we=new RegExp(ae.substring(1,ue),ge)}catch{throw this.B("REGEX",W)}return i.regex(B,we)}case O.TokenType.QuotedStr:{const te=W.lexeme;this.z();let _=null;if(!(0,N.$df)(te)){const Q=te.indexOf("/"),ae=te.lastIndexOf("/");if(Q!==ae&&Q>=0){const ue=te.slice(Q+1,ae),ge=te[ae+1]==="i"?"i":"";try{_=new RegExp(ue,ge)}catch{throw this.B("REGEX",W)}}}if(_===null)throw this.B("REGEX",W);return x.create(B,_)}default:throw this.B("REGEX",this.D())}}if(this.y(O.TokenType.Not)){this.A(O.TokenType.In,y);const W=this.u();return i.notIn(B,W)}switch(this.D().type){case O.TokenType.Eq:{this.z();const W=this.u();if(this.x().type===O.TokenType.QuotedStr)return i.equals(B,W);switch(W){case"true":return i.has(B);case"false":return i.not(B);default:return i.equals(B,W)}}case O.TokenType.NotEq:{this.z();const W=this.u();if(this.x().type===O.TokenType.QuotedStr)return i.notEquals(B,W);switch(W){case"true":return i.not(B);case"false":return i.has(B);default:return i.notEquals(B,W)}}case O.TokenType.Lt:return this.z(),J.create(B,this.u());case O.TokenType.LtEq:return this.z(),H.create(B,this.u());case O.TokenType.Gt:return this.z(),D.create(B,this.u());case O.TokenType.GtEq:return this.z(),M.create(B,this.u());case O.TokenType.In:return this.z(),i.in(B,this.u());default:return i.has(B)}}case O.TokenType.EOF:throw this.h.push({message:m,offset:U.offset,lexeme:"",additionalInfo:s}),r.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const U=this.D();switch(U.type){case O.TokenType.Str:case O.TokenType.QuotedStr:return this.z(),U.lexeme;case O.TokenType.True:return this.z(),"true";case O.TokenType.False:return this.z(),"false";case O.TokenType.In:return this.z(),"in";default:return""}}w(U){return U.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(U){return this.C(U)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(U,B){if(this.C(U))return this.z();throw this.B(B,this.D())}B(U,B,j){const W=(0,k.localize)(8,null,U,O.$Aj.getLexeme(B)),te=B.offset,_=O.$Aj.getLexeme(B);return this.h.push({message:W,offset:te,lexeme:_,additionalInfo:j}),r.c}C(U){return this.D().type===U}D(){return this.f[this.g]}E(){return this.D().type===O.TokenType.EOF}}e.$Cj=r;class i{static false(){return o.INSTANCE}static true(){return h.INSTANCE}static has(U){return g.create(U)}static equals(U,B){return R.create(U,B)}static notEquals(U,B){return v.create(U,B)}static regex(U,B){return x.create(U,B)}static in(U,B){return L.create(U,B)}static notIn(U,B){return S.create(U,B)}static not(U){return C.create(U)}static and(...U){return V.create(U,null,!0)}static or(...U){return z.create(U,null,!0)}static greater(U,B){return D.create(U,B)}static greaterEquals(U,B){return M.create(U,B)}static smaller(U,B){return J.create(U,B)}static smallerEquals(U,B){return H.create(U,B)}static{this.c=new r({regexParsingWithErrorRecovery:!1})}static deserialize(U){return U==null?void 0:this.c.parse(U)}}e.$Dj=i;function a(G){const U=new r({regexParsingWithErrorRecovery:!1});return G.map(B=>(U.parse(B),U.lexingErrors.length>0?U.lexingErrors.map(j=>({errorMessage:j.additionalInfo?(0,k.localize)(9,null,j.additionalInfo):(0,k.localize)(10,null),offset:j.offset,length:j.lexeme.length})):U.parsingErrors.length>0?U.parsingErrors.map(j=>({errorMessage:j.additionalInfo?`${j.message}. ${j.additionalInfo}`:j.message,offset:j.offset,length:j.lexeme.length})):[]))}function t(G,U){const B=G?G.substituteConstants():void 0,j=U?U.substituteConstants():void 0;return!B&&!j?!0:!B||!j?!1:B.equals(j)}function n(G,U){return G.cmp(U)}class o{static{this.INSTANCE=new o}constructor(){this.type=u.False}cmp(U){return this.type-U.type}equals(U){return U.type===this.type}substituteConstants(){return this}evaluate(U){return!1}serialize(){return"false"}keys(){return[]}map(U){return this}negate(){return h.INSTANCE}}e.$Gj=o;class h{static{this.INSTANCE=new h}constructor(){this.type=u.True}cmp(U){return this.type-U.type}equals(U){return U.type===this.type}substituteConstants(){return this}evaluate(U){return!0}serialize(){return"true"}keys(){return[]}map(U){return this}negate(){return o.INSTANCE}}e.$Hj=h;class g{static create(U,B=null){const j=w.get(U);return typeof j=="boolean"?j?h.INSTANCE:o.INSTANCE:new g(U,B)}constructor(U,B){this.key=U,this.c=B,this.type=u.Defined}cmp(U){return U.type!==this.type?this.type-U.type:se(this.key,U.key)}equals(U){return U.type===this.type?this.key===U.key:!1}substituteConstants(){const U=w.get(this.key);return typeof U=="boolean"?U?h.INSTANCE:o.INSTANCE:this}evaluate(U){return!!U.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(U){return U.mapDefined(this.key)}negate(){return this.c||(this.c=C.create(this.key,this)),this.c}}e.$Ij=g;class R{static create(U,B,j=null){if(typeof B=="boolean")return B?g.create(U,j):C.create(U,j);const W=w.get(U);return typeof W=="boolean"?B===(W?"true":"false")?h.INSTANCE:o.INSTANCE:new R(U,B,j)}constructor(U,B,j){this.c=U,this.d=B,this.f=j,this.type=u.Equals}cmp(U){return U.type!==this.type?this.type-U.type:he(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){const U=w.get(this.c);if(typeof U=="boolean"){const B=U?"true":"false";return this.d===B?h.INSTANCE:o.INSTANCE}return this}evaluate(U){return U.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(U){return U.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=v.create(this.c,this.d,this)),this.f}}e.$Jj=R;class L{static create(U,B){return new L(U,B)}constructor(U,B){this.d=U,this.f=B,this.type=u.In,this.c=null}cmp(U){return U.type!==this.type?this.type-U.type:he(this.d,this.f,U.d,U.f)}equals(U){return U.type===this.type?this.d===U.d&&this.f===U.f:!1}substituteConstants(){return this}evaluate(U){const B=U.getValue(this.f),j=U.getValue(this.d);return Array.isArray(B)?B.includes(j):typeof j=="string"&&typeof B=="object"&&B!==null?$.call(B,j):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(U){return U.mapIn(this.d,this.f)}negate(){return this.c||(this.c=S.create(this.d,this.f)),this.c}}e.$Kj=L;class S{static create(U,B){return new S(U,B)}constructor(U,B){this.d=U,this.f=B,this.type=u.NotIn,this.c=L.create(U,B)}cmp(U){return U.type!==this.type?this.type-U.type:this.c.cmp(U.c)}equals(U){return U.type===this.type?this.c.equals(U.c):!1}substituteConstants(){return this}evaluate(U){return!this.c.evaluate(U)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(U){return U.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Lj=S;class v{static create(U,B,j=null){if(typeof B=="boolean")return B?C.create(U,j):g.create(U,j);const W=w.get(U);return typeof W=="boolean"?B===(W?"true":"false")?o.INSTANCE:h.INSTANCE:new v(U,B,j)}constructor(U,B,j){this.c=U,this.d=B,this.f=j,this.type=u.NotEquals}cmp(U){return U.type!==this.type?this.type-U.type:he(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){const U=w.get(this.c);if(typeof U=="boolean"){const B=U?"true":"false";return this.d===B?o.INSTANCE:h.INSTANCE}return this}evaluate(U){return U.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(U){return U.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=R.create(this.c,this.d,this)),this.f}}e.$Mj=v;class C{static create(U,B=null){const j=w.get(U);return typeof j=="boolean"?j?o.INSTANCE:h.INSTANCE:new C(U,B)}constructor(U,B){this.c=U,this.d=B,this.type=u.Not}cmp(U){return U.type!==this.type?this.type-U.type:se(this.c,U.c)}equals(U){return U.type===this.type?this.c===U.c:!1}substituteConstants(){const U=w.get(this.c);return typeof U=="boolean"?U?o.INSTANCE:h.INSTANCE:this}evaluate(U){return!U.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(U){return U.mapNot(this.c)}negate(){return this.d||(this.d=g.create(this.c,this)),this.d}}e.$Nj=C;function F(G,U){if(typeof G=="string"){const B=parseFloat(G);isNaN(B)||(G=B)}return typeof G=="string"||typeof G=="number"?U(G):o.INSTANCE}class D{static create(U,B,j=null){return F(B,W=>new D(U,W,j))}constructor(U,B,j){this.c=U,this.d=B,this.f=j,this.type=u.Greater}cmp(U){return U.type!==this.type?this.type-U.type:he(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){return this}evaluate(U){return typeof this.d=="string"?!1:parseFloat(U.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(U){return U.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=H.create(this.c,this.d,this)),this.f}}e.$Oj=D;class M{static create(U,B,j=null){return F(B,W=>new M(U,W,j))}constructor(U,B,j){this.c=U,this.d=B,this.f=j,this.type=u.GreaterEquals}cmp(U){return U.type!==this.type?this.type-U.type:he(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){return this}evaluate(U){return typeof this.d=="string"?!1:parseFloat(U.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(U){return U.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=J.create(this.c,this.d,this)),this.f}}e.$Pj=M;class J{static create(U,B,j=null){return F(B,W=>new J(U,W,j))}constructor(U,B,j){this.c=U,this.d=B,this.f=j,this.type=u.Smaller}cmp(U){return U.type!==this.type?this.type-U.type:he(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){return this}evaluate(U){return typeof this.d=="string"?!1:parseFloat(U.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(U){return U.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=M.create(this.c,this.d,this)),this.f}}e.$Qj=J;class H{static create(U,B,j=null){return F(B,W=>new H(U,W,j))}constructor(U,B,j){this.c=U,this.d=B,this.f=j,this.type=u.SmallerEquals}cmp(U){return U.type!==this.type?this.type-U.type:he(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){return this}evaluate(U){return typeof this.d=="string"?!1:parseFloat(U.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(U){return U.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=D.create(this.c,this.d,this)),this.f}}e.$Rj=H;class x{static create(U,B){return new x(U,B)}constructor(U,B){this.d=U,this.f=B,this.type=u.Regex,this.c=null}cmp(U){if(U.type!==this.type)return this.type-U.type;if(this.d<U.d)return-1;if(this.d>U.d)return 1;const B=this.f?this.f.source:"",j=U.f?U.f.source:"";return B<j?-1:B>j?1:0}equals(U){if(U.type===this.type){const B=this.f?this.f.source:"",j=U.f?U.f.source:"";return this.d===U.d&&B===j}return!1}substituteConstants(){return this}evaluate(U){const B=U.getValue(this.d);return this.f?this.f.test(B):!1}serialize(){const U=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${U}`}keys(){return[this.d]}map(U){return U.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=K.create(this)),this.c}}e.$Sj=x;class K{static create(U){return new K(U)}constructor(U){this.c=U,this.type=u.NotRegex}cmp(U){return U.type!==this.type?this.type-U.type:this.c.cmp(U.c)}equals(U){return U.type===this.type?this.c.equals(U.c):!1}substituteConstants(){return this}evaluate(U){return!this.c.evaluate(U)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(U){return new K(this.c.map(U))}negate(){return this.c}}e.$Tj=K;function ie(G){let U=null;for(let B=0,j=G.length;B<j;B++){const W=G[B].substituteConstants();if(G[B]!==W&&U===null){U=[];for(let te=0;te<B;te++)U[te]=G[te]}U!==null&&(U[B]=W)}return U===null?G:U}class V{static create(U,B,j){return V.d(U,B,j)}constructor(U,B){this.expr=U,this.c=B,this.type=u.And}cmp(U){if(U.type!==this.type)return this.type-U.type;if(this.expr.length<U.expr.length)return-1;if(this.expr.length>U.expr.length)return 1;for(let B=0,j=this.expr.length;B<j;B++){const W=n(this.expr[B],U.expr[B]);if(W!==0)return W}return 0}equals(U){if(U.type===this.type){if(this.expr.length!==U.expr.length)return!1;for(let B=0,j=this.expr.length;B<j;B++)if(!this.expr[B].equals(U.expr[B]))return!1;return!0}return!1}substituteConstants(){const U=ie(this.expr);return U===this.expr?this:V.create(U,this.c,!1)}evaluate(U){for(let B=0,j=this.expr.length;B<j;B++)if(!this.expr[B].evaluate(U))return!1;return!0}static d(U,B,j){const W=[];let te=!1;for(const _ of U)if(_){if(_.type===u.True){te=!0;continue}if(_.type===u.False)return o.INSTANCE;if(_.type===u.And){W.push(..._.expr);continue}W.push(_)}if(W.length===0&&te)return h.INSTANCE;if(W.length!==0){if(W.length===1)return W[0];W.sort(n);for(let _=1;_<W.length;_++)W[_-1].equals(W[_])&&(W.splice(_,1),_--);if(W.length===1)return W[0];for(;W.length>1;){const _=W[W.length-1];if(_.type!==u.Or)break;W.pop();const Q=W.pop(),ae=W.length===0,ue=z.create(_.expr.map(ge=>V.create([ge,Q],null,j)),null,ae);ue&&(W.push(ue),W.sort(n))}if(W.length===1)return W[0];if(j){for(let _=0;_<W.length;_++)for(let Q=_+1;Q<W.length;Q++)if(W[_].negate().equals(W[Q]))return o.INSTANCE;if(W.length===1)return W[0]}return new V(W,B)}}serialize(){return this.expr.map(U=>U.serialize()).join(" && ")}keys(){const U=[];for(const B of this.expr)U.push(...B.keys());return U}map(U){return new V(this.expr.map(B=>B.map(U)),null)}negate(){if(!this.c){const U=[];for(const B of this.expr)U.push(B.negate());this.c=z.create(U,this,!0)}return this.c}}e.$Uj=V;class z{static create(U,B,j){return z.d(U,B,j)}constructor(U,B){this.expr=U,this.c=B,this.type=u.Or}cmp(U){if(U.type!==this.type)return this.type-U.type;if(this.expr.length<U.expr.length)return-1;if(this.expr.length>U.expr.length)return 1;for(let B=0,j=this.expr.length;B<j;B++){const W=n(this.expr[B],U.expr[B]);if(W!==0)return W}return 0}equals(U){if(U.type===this.type){if(this.expr.length!==U.expr.length)return!1;for(let B=0,j=this.expr.length;B<j;B++)if(!this.expr[B].equals(U.expr[B]))return!1;return!0}return!1}substituteConstants(){const U=ie(this.expr);return U===this.expr?this:z.create(U,this.c,!1)}evaluate(U){for(let B=0,j=this.expr.length;B<j;B++)if(this.expr[B].evaluate(U))return!0;return!1}static d(U,B,j){let W=[],te=!1;if(U){for(let _=0,Q=U.length;_<Q;_++){const ae=U[_];if(ae){if(ae.type===u.False){te=!0;continue}if(ae.type===u.True)return h.INSTANCE;if(ae.type===u.Or){W=W.concat(ae.expr);continue}W.push(ae)}}if(W.length===0&&te)return o.INSTANCE;W.sort(n)}if(W.length!==0){if(W.length===1)return W[0];for(let _=1;_<W.length;_++)W[_-1].equals(W[_])&&(W.splice(_,1),_--);if(W.length===1)return W[0];if(j){for(let _=0;_<W.length;_++)for(let Q=_+1;Q<W.length;Q++)if(W[_].negate().equals(W[Q]))return h.INSTANCE;if(W.length===1)return W[0]}return new z(W,B)}}serialize(){return this.expr.map(U=>U.serialize()).join(" || ")}keys(){const U=[];for(const B of this.expr)U.push(...B.keys());return U}map(U){return new z(this.expr.map(B=>B.map(U)),null)}negate(){if(!this.c){const U=[];for(const B of this.expr)U.push(B.negate());for(;U.length>1;){const B=U.shift(),j=U.shift(),W=[];for(const te of X(B))for(const _ of X(j))W.push(V.create([te,_],null,!1));U.unshift(z.create(W,null,!1))}this.c=z.create(U,this,!0)}return this.c}}e.$Vj=z;class ee extends g{static{this.d=[]}static all(){return ee.d.values()}constructor(U,B,j){super(U,null),this.f=B,typeof j=="object"?ee.d.push({...j,key:U}):j!==!0&&ee.d.push({key:U,description:j,type:B!=null?typeof B:void 0})}bindTo(U){return U.createKey(this.key,this.f)}getValue(U){return U.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(U){return R.create(this.key,U)}notEqualsTo(U){return v.create(this.key,U)}}e.$Wj=ee,e.$Xj=(0,T.$Fi)("contextKeyService");function se(G,U){return G<U?-1:G>U?1:0}function he(G,U,B,j){return G<B?-1:G>B?1:U<j?-1:U>j?1:0}function q(G,U){if(G.type===u.False||U.type===u.True)return!0;if(G.type===u.Or)return U.type===u.Or?Z(G.expr,U.expr):!1;if(U.type===u.Or){for(const B of U.expr)if(q(G,B))return!0;return!1}if(G.type===u.And){if(U.type===u.And)return Z(U.expr,G.expr);for(const B of G.expr)if(q(B,U))return!0;return!1}return G.equals(U)}function Z(G,U){let B=0,j=0;for(;B<G.length&&j<U.length;){const W=G[B].cmp(U[j]);if(W<0)return!1;W===0&&B++,j++}return B===G.length}function X(G){return G.type===u.Or?G.expr:[G]}}),define(ce[98],le([0,1,4]),function(ne,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Um=e.$Sm=e.ID=void 0,e.$Tm=c,e.ID="diagnosticsService",e.$Sm=(0,P.$Fi)(e.ID);function c(O){return!!O.hostName&&!!O.errorMessage}class N{async getPerformanceInfo(T,k){return{}}async getSystemInfo(T,k){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(T,k){return""}async getWorkspaceFileExtensions(T){return{extensions:[]}}async reportWorkspaceStats(T){}}e.$Um=N}),define(ce[99],le([0,1,4]),function(ne,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wo=void 0,e.$Wo=(0,P.$Fi)("downloadService")}),define(ce[16],le([0,1,4]),function(ne,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ni=e.$Mi=void 0,e.$Mi=(0,P.$Fi)("environmentService"),e.$Ni=(0,P.$Gi)(e.$Mi)}),define(ce[75],le([0,1,4]),function(ne,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$g6b=e.RecommendationsNotificationResult=e.RecommendationSource=void 0,e.$f6b=N;var c;(function(T){T[T.FILE=1]="FILE",T[T.WORKSPACE=2]="WORKSPACE",T[T.EXE=3]="EXE"})(c||(e.RecommendationSource=c={}));function N(T){switch(T){case c.FILE:return"file";case c.WORKSPACE:return"workspace";case c.EXE:return"exe"}}var O;(function(T){T.Ignored="ignored",T.Cancelled="cancelled",T.TooMany="toomany",T.IncompatibleWindow="incompatibleWindow",T.Accepted="reacted"})(O||(e.RecommendationsNotificationResult=O={})),e.$g6b=(0,P.$Fi)("IExtensionRecommendationNotificationService")}),define(ce[7],le([0,1,52,14,27,13,9,170,4,5,23,54]),function(ne,e,P,c,N,O,T,k,A,w,E,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hl=e.$El=e.FileKind=e.$Dl=e.$Cl=e.$Bl=e.$Al=e.$zl=e.$yl=e.$xl=e.FileOperationResult=e.$wl=e.$vl=e.$ul=e.$sl=e.FileChangeType=e.$rl=e.FileOperation=e.$ll=e.FileSystemProviderErrorCode=e.FileSystemProviderCapabilities=e.FileChangeFilter=e.FilePermission=e.FileType=e.$_k=void 0,e.$al=u,e.$bl=y,e.$cl=b,e.$dl=I,e.$el=m,e.$fl=s,e.$gl=r,e.$hl=i,e.$il=a,e.$jl=t,e.$kl=n,e.$ml=g,e.$nl=R,e.$ol=L,e.$pl=S,e.$ql=v,e.$tl=J,e.$Fl=z,e.$Gl=ee,e.$Il=he,e.$_k=(0,A.$Fi)("fileService");function u(q){return q.create===!0}var p;(function(q){q[q.Unknown=0]="Unknown",q[q.File=1]="File",q[q.Directory=2]="Directory",q[q.SymbolicLink=64]="SymbolicLink"})(p||(e.FileType=p={}));var l;(function(q){q[q.Readonly=1]="Readonly",q[q.Locked=2]="Locked"})(l||(e.FilePermission=l={}));var d;(function(q){q[q.UPDATED=2]="UPDATED",q[q.ADDED=4]="ADDED",q[q.DELETED=8]="DELETED"})(d||(e.FileChangeFilter=d={}));function y(q){const Z=q;return!!Z&&typeof Z.onDidChange=="function"}var f;(function(q){q[q.None=0]="None",q[q.FileReadWrite=2]="FileReadWrite",q[q.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",q[q.FileReadStream=16]="FileReadStream",q[q.FileFolderCopy=8]="FileFolderCopy",q[q.PathCaseSensitive=1024]="PathCaseSensitive",q[q.Readonly=2048]="Readonly",q[q.Trash=4096]="Trash",q[q.FileWriteUnlock=8192]="FileWriteUnlock",q[q.FileAtomicRead=16384]="FileAtomicRead",q[q.FileAtomicWrite=32768]="FileAtomicWrite",q[q.FileAtomicDelete=65536]="FileAtomicDelete",q[q.FileClone=131072]="FileClone"})(f||(e.FileSystemProviderCapabilities=f={}));function b(q){return!!(q.capabilities&f.FileReadWrite)}function I(q){return!!(q.capabilities&f.FileFolderCopy)}function m(q){return!!(q.capabilities&f.FileClone)}function s(q){return!!(q.capabilities&f.FileOpenReadWriteClose)}function r(q){return!!(q.capabilities&f.FileReadStream)}function i(q){return b(q)?!!(q.capabilities&f.FileAtomicRead):!1}function a(q){return b(q)?!!(q.capabilities&f.FileAtomicWrite):!1}function t(q){return!!(q.capabilities&f.FileAtomicDelete)}function n(q){return!!(q.capabilities&f.Readonly)}var o;(function(q){q.FileExists="EntryExists",q.FileNotFound="EntryNotFound",q.FileNotADirectory="EntryNotADirectory",q.FileIsADirectory="EntryIsADirectory",q.FileExceedsStorageQuota="EntryExceedsStorageQuota",q.FileTooLarge="EntryTooLarge",q.FileWriteLocked="EntryWriteLocked",q.NoPermissions="NoPermissions",q.Unavailable="Unavailable",q.Unknown="Unknown"})(o||(e.FileSystemProviderErrorCode=o={}));class h extends Error{static create(Z,X){const G=new h(Z.toString(),X);return L(G,X),G}constructor(Z,X){super(Z),this.code=X}}e.$ll=h;function g(q,Z){return h.create(q,Z)}function R(q){return q||g((0,k.localize)(0,null),o.Unknown)}function L(q,Z){return q.name=Z?`${Z} (FileSystemError)`:"FileSystemError",q}function S(q){if(!q)return o.Unknown;if(q instanceof h)return q.code;const Z=/^(.+) \(FileSystemError\)$/.exec(q.name);if(!Z)return o.Unknown;switch(Z[1]){case o.FileExists:return o.FileExists;case o.FileIsADirectory:return o.FileIsADirectory;case o.FileNotADirectory:return o.FileNotADirectory;case o.FileNotFound:return o.FileNotFound;case o.FileTooLarge:return o.FileTooLarge;case o.FileWriteLocked:return o.FileWriteLocked;case o.NoPermissions:return o.NoPermissions;case o.Unavailable:return o.Unavailable}return o.Unknown}function v(q){if(q instanceof H)return q.fileOperationResult;switch(S(q)){case o.FileNotFound:return ie.FILE_NOT_FOUND;case o.FileIsADirectory:return ie.FILE_IS_DIRECTORY;case o.FileNotADirectory:return ie.FILE_NOT_DIRECTORY;case o.FileWriteLocked:return ie.FILE_WRITE_LOCKED;case o.NoPermissions:return ie.FILE_PERMISSION_DENIED;case o.FileExists:return ie.FILE_MOVE_CONFLICT;case o.FileTooLarge:return ie.FILE_TOO_LARGE;default:return ie.FILE_OTHER_ERROR}}var C;(function(q){q[q.CREATE=0]="CREATE",q[q.DELETE=1]="DELETE",q[q.MOVE=2]="MOVE",q[q.COPY=3]="COPY",q[q.WRITE=4]="WRITE"})(C||(e.FileOperation=C={}));class F{constructor(Z,X,G){this.resource=Z,this.operation=X,this.target=G}isOperation(Z){return this.operation===Z}}e.$rl=F;var D;(function(q){q[q.UPDATED=0]="UPDATED",q[q.ADDED=1]="ADDED",q[q.DELETED=2]="DELETED"})(D||(e.FileChangeType=D={}));class M{static{this.a=null}constructor(Z,X){this.c=X,this.b=void 0,this.d=new $.$X(()=>{const G=P.$Li.forUris(()=>this.c);return G.fill(this.rawAdded.map(U=>[U,!0])),G}),this.f=new $.$X(()=>{const G=P.$Li.forUris(()=>this.c);return G.fill(this.rawUpdated.map(U=>[U,!0])),G}),this.g=new $.$X(()=>{const G=P.$Li.forUris(()=>this.c);return G.fill(this.rawDeleted.map(U=>[U,!0])),G}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const G of Z){switch(G.type){case D.ADDED:this.rawAdded.push(G.resource);break;case D.UPDATED:this.rawUpdated.push(G.resource);break;case D.DELETED:this.rawDeleted.push(G.resource);break}this.b!==M.a&&(typeof G.cId=="number"?this.b===void 0?this.b=G.cId:this.b!==G.cId&&(this.b=M.a):this.b!==void 0&&(this.b=M.a))}}contains(Z,...X){return this.h(Z,{includeChildren:!1},...X)}affects(Z,...X){return this.h(Z,{includeChildren:!0},...X)}h(Z,X,...G){if(!Z)return!1;const U=G.length>0;return!!((!U||G.includes(D.ADDED))&&(this.d.value.get(Z)||X.includeChildren&&this.d.value.findSuperstr(Z))||(!U||G.includes(D.UPDATED))&&(this.f.value.get(Z)||X.includeChildren&&this.f.value.findSuperstr(Z))||(!U||G.includes(D.DELETED))&&(this.g.value.findSubstr(Z)||X.includeChildren&&this.g.value.findSuperstr(Z)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(Z){return this.b===Z}hasCorrelation(){return typeof this.b=="number"}}e.$sl=M;function J(q,Z,X){return!q||!Z||q===Z||Z.length>q.length?!1:(Z.charAt(Z.length-1)!==c.sep&&(Z+=c.sep),X?(0,N.$Hf)(q,Z):q.indexOf(Z)===0)}class H extends Error{constructor(Z,X,G){super(Z),this.fileOperationResult=X,this.options=G}}e.$ul=H;class x extends H{constructor(Z,X,G,U){super(Z,X,U),this.fileOperationResult=X,this.size=G}}e.$vl=x;class K extends H{constructor(Z,X,G){super(Z,ie.FILE_NOT_MODIFIED_SINCE,G),this.stat=X}}e.$wl=K;var ie;(function(q){q[q.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",q[q.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",q[q.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",q[q.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",q[q.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",q[q.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",q[q.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",q[q.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",q[q.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",q[q.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",q[q.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(ie||(e.FileOperationResult=ie={})),e.$xl={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$yl={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$zl="files.associations",e.$Al="files.exclude",e.$Bl="files.readonlyInclude",e.$Cl="files.readonlyExclude",e.$Dl="files.readonlyFromPermissions";var V;(function(q){q[q.FILE=0]="FILE",q[q.FOLDER=1]="FOLDER",q[q.ROOT_FOLDER=2]="ROOT_FOLDER"})(V||(e.FileKind=V={})),e.$El="";function z(q){if(!(typeof q.size!="number"||typeof q.mtime!="number"))return q.mtime.toString(29)+q.size.toString(31)}async function ee(q,Z){if(!Z.hasProvider(T.URI.from({scheme:q.scheme})))return new Promise(X=>{const G=Z.onDidChangeFileSystemProviderRegistrations(U=>{U.scheme===q.scheme&&U.added&&(G.dispose(),X())})})}class se{static{this.KB=1024}static{this.MB=se.KB*se.KB}static{this.GB=se.MB*se.KB}static{this.TB=se.GB*se.KB}static formatSize(Z){return(0,O.$jg)(Z)||(Z=0),Z<se.KB?(0,k.localize)(1,null,Z.toFixed(0)):Z<se.MB?(0,k.localize)(2,null,(Z/se.KB).toFixed(2)):Z<se.GB?(0,k.localize)(3,null,(Z/se.MB).toFixed(2)):Z<se.TB?(0,k.localize)(4,null,(Z/se.GB).toFixed(2)):(0,k.localize)(5,null,(Z/se.TB).toFixed(2))}}e.$Hl=se;function he(q){const Z=typeof q=="string"||q?.scheme===E.Schemas.vscodeRemote;return typeof q!="string"&&q?.scheme===E.Schemas.file?1024*se.MB:Z?10*se.MB:w.$o?50*se.MB:1024*se.MB}});var Y=this&&this.__param||function(ne,e){return function(P,c){e(P,c,ne)}};define(ce[199],le([0,1,76,51,7]),function(ne,e,P,c,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rgc=void 0;let O=class{constructor(k){this.a=k}async checksum(k){const A=(await this.a.readFileStream(k)).value;return new Promise((w,E)=>{const $=(0,P.createHash)("sha256");(0,c.$Ge)(A,{onData:u=>$.update(u.buffer),onError:u=>E(u),onEnd:()=>w($.digest("base64").replace(/=+$/,""))})})}};e.$Rgc=O,e.$Rgc=O=ve([Y(0,N.$_k)],O)}),define(ce[100],le([0,1,15,8,171,7]),function(ne,e,P,c,N,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uq=T;async function T(E,$,u,p,l,d){let y;try{await k(E,$,u,p,l,d)}catch(f){y=f}finally{y&&l.errorTransformer&&(y=l.errorTransformer(y)),typeof y<"u"&&u.error(y),u.end()}}async function k(E,$,u,p,l,d){A(d);const y=await E.open($,{create:!1});try{A(d);let f=0,b=0,I=l&&typeof l.length=="number"?l.length:void 0,m=P.$Oe.alloc(Math.min(l.bufferSize,typeof I=="number"?I:l.bufferSize)),s=l&&typeof l.position=="number"?l.position:0,r=0;do b=await E.read(y,s,m.buffer,r,m.byteLength-r),s+=b,r+=b,f+=b,typeof I=="number"&&(I-=b),r===m.byteLength&&(await u.write(p(m)),m=P.$Oe.alloc(Math.min(l.bufferSize,typeof I=="number"?I:l.bufferSize)),r=0);while(b>0&&(typeof I!="number"||I>0)&&A(d)&&w(f,l));if(r>0){let i=r;typeof I=="number"&&(i=Math.min(r,I)),u.write(p(m.slice(0,i)))}}catch(f){throw(0,O.$nl)(f)}finally{await E.close(y)}}function A(E){if(E.isCancellationRequested)throw(0,c.$8)();return!0}function w(E,$){if(typeof $?.limits?.size=="number"&&E>$.limits.size)throw(0,O.$ml)((0,N.localize)(0,null),O.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(ce[47],le([0,1,94,2,14,5,9,7]),function(ne,e,P,c,N,O,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1q=e.$Zq=e.$Yq=void 0,e.$Wq=A,e.$Xq=w,e.$2q=p,e.$3q=l,e.$4q=d,e.$5q=y,e.$6q=b,e.$7q=I;function A(m){return typeof m.correlationId=="number"}function w(m){return m.recursive===!0}class E extends c.$Wc{static{this.a=5}constructor(s,r,i,a){super(),this.h=s,this.j=r,this.m=i,this.n=a,this.c=this.B(new c.$Xc),this.f=void 0,this.g=0}s(){const s=new c.$Vc;this.c.value=s,this.b=this.r(s),this.b.setVerboseLogging(this.m),s.add(this.b.onDidChangeFile(r=>this.h(r))),s.add(this.b.onDidLogMessage(r=>this.j(r))),s.add(this.b.onDidError(r=>this.t(r.error,r.request)))}t(s,r){this.u(s,r)?this.g<E.a&&this.f?(this.y(`restarting watcher after unexpected error: ${s}`),this.w(this.f)):this.y(`gave up attempting to restart watcher after unexpected error: ${s}`):this.y(s)}u(s,r){return!(!this.n.restartOnError||r||s.indexOf("No space left on device")!==-1||s.indexOf("EMFILE")!==-1)}w(s){this.g++,this.s(),this.watch(s)}async watch(s){this.f=s,await this.b?.watch(s)}async setVerboseLogging(s){this.m=s,await this.b?.setVerboseLogging(s)}y(s){this.j({type:"error",message:`[File Watcher (${this.n.type})] ${s}`})}z(s){this.j({type:"trace",message:`[File Watcher (${this.n.type})] ${s}`})}dispose(){return this.b=void 0,super.dispose()}}e.$Yq=E;class $ extends E{constructor(s,r,i){super(s,r,i,{type:"node.js",restartOnError:!1})}}e.$Zq=$;class u extends E{constructor(s,r,i){super(s,r,i,{type:"universal",restartOnError:!0})}}e.$1q=u;function p(m){return m.map(s=>({type:s.type,resource:T.URI.revive(s.resource),cId:s.cId}))}function l(m){const s=new f;for(const r of m)s.processEvent(r);return s.coalesce()}function d(m,s){return typeof s=="string"&&!s.startsWith(P.$vk)&&!(0,N.$kc)(s)?{base:m,pattern:s}:s}function y(m,s){const r=[];for(const i of s)r.push((0,P.$zk)(d(m,i)));return r}class f{constructor(){this.a=new Set,this.b=new Map}c(s){return O.$k?s.resource.fsPath:s.resource.fsPath.toLowerCase()}processEvent(s){const r=this.b.get(this.c(s));let i=!1;if(r){const a=r.type,t=s.type;r.resource.fsPath!==s.resource.fsPath&&(s.type===k.FileChangeType.DELETED||s.type===k.FileChangeType.ADDED)?i=!0:a===k.FileChangeType.ADDED&&t===k.FileChangeType.DELETED?(this.b.delete(this.c(s)),this.a.delete(r)):a===k.FileChangeType.DELETED&&t===k.FileChangeType.ADDED?r.type=k.FileChangeType.UPDATED:a===k.FileChangeType.ADDED&&t===k.FileChangeType.UPDATED||(r.type=t)}else i=!0;i&&(this.a.add(s),this.b.set(this.c(s),s))}coalesce(){const s=[],r=[];return Array.from(this.a).filter(i=>i.type!==k.FileChangeType.DELETED?(s.push(i),!1):!0).sort((i,a)=>i.resource.fsPath.length-a.resource.fsPath.length).filter(i=>r.some(a=>(0,k.$tl)(i.resource.fsPath,a,!O.$k))?!1:(r.push(i.resource.fsPath),!0)).concat(s)}}function b(m,s){if(typeof s=="number")switch(m.type){case k.FileChangeType.ADDED:return(s&k.FileChangeFilter.ADDED)===0;case k.FileChangeType.DELETED:return(s&k.FileChangeFilter.DELETED)===0;case k.FileChangeType.UPDATED:return(s&k.FileChangeFilter.UPDATED)===0}return!1}function I(m){if(typeof m=="number"){const s=[];return m&k.FileChangeFilter.ADDED&&s.push("Added"),m&k.FileChangeFilter.DELETED&&s.push("Deleted"),m&k.FileChangeFilter.UPDATED&&s.push("Updated"),s.length===0?"<all>":`[${s.join(", ")}]`}return"<none>"}}),define(ce[200],le([0,1,15,41,8,3,2,51,32,7,47]),function(ne,e,P,c,N,O,T,k,A,w,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7Q=e.$6Q=void 0,e.$6Q="localFilesystem";class $ extends T.$Wc{constructor(p,l){super(),this.a=p,this.b=l,this.onDidChangeCapabilities=O.Event.None,this.f=this.B(new O.$me),this.onDidChangeFile=this.f.event,this.g=this.B(new O.$me),this.onDidWatchError=this.g.event,this.h=(0,A.$2g)(),this.j()}get capabilities(){return this.c||(this.c=w.FileSystemProviderCapabilities.FileReadWrite|w.FileSystemProviderCapabilities.FileOpenReadWriteClose|w.FileSystemProviderCapabilities.FileReadStream|w.FileSystemProviderCapabilities.FileFolderCopy|w.FileSystemProviderCapabilities.FileWriteUnlock|w.FileSystemProviderCapabilities.FileAtomicRead|w.FileSystemProviderCapabilities.FileAtomicWrite|w.FileSystemProviderCapabilities.FileAtomicDelete|w.FileSystemProviderCapabilities.FileClone,this.b.pathCaseSensitive&&(this.c|=w.FileSystemProviderCapabilities.PathCaseSensitive),this.b.trash&&(this.c|=w.FileSystemProviderCapabilities.Trash)),this.c}stat(p){return this.a.call("stat",[p])}readdir(p){return this.a.call("readdir",[p])}async readFile(p,l){const{buffer:d}=await this.a.call("readFile",[p,l]);return d}readFileStream(p,l,d){const y=(0,k.$Ce)(b=>P.$Oe.concat(b.map(I=>P.$Oe.wrap(I))).buffer),f=new T.$Vc;return f.add(this.a.listen("readFileStream",[p,l])(b=>{if(b instanceof P.$Oe)y.write(b.buffer);else{if(b==="end")y.end();else{let I;if(b instanceof Error)I=b;else{const m=b;I=(0,w.$ml)(m.message??(0,c.$qj)(m),m.code??w.FileSystemProviderErrorCode.Unknown)}y.error(I),y.end()}f.dispose()}})),f.add(d.onCancellationRequested(()=>{y.error((0,N.$8)()),y.end(),f.dispose()})),y}writeFile(p,l,d){return this.a.call("writeFile",[p,P.$Oe.wrap(l),d])}open(p,l){return this.a.call("open",[p,l])}close(p){return this.a.call("close",[p])}async read(p,l,d,y,f){const[b,I]=await this.a.call("read",[p,l,f]);return d.set(b.buffer.slice(0,I),y),I}write(p,l,d,y,f){return this.a.call("write",[p,l,P.$Oe.wrap(d),y,f])}mkdir(p){return this.a.call("mkdir",[p])}delete(p,l){return this.a.call("delete",[p,l])}rename(p,l,d){return this.a.call("rename",[p,l,d])}copy(p,l,d){return this.a.call("copy",[p,l,d])}cloneFile(p,l){return this.a.call("cloneFile",[p,l])}j(){this.B(this.a.listen("fileChange",[this.h])(p=>{if(Array.isArray(p)){const l=p;this.f.fire((0,E.$2q)(l))}else{const l=p;this.g.fire(l)}}))}watch(p,l){const d=(0,A.$2g)();return this.a.call("watch",[this.h,d,p,l]),(0,T.$Uc)(()=>this.a.call("unwatch",[this.h,d]))}}e.$7Q=$}),define(ce[201],le([0,1,46,2,47,3,7,9,6]),function(ne,e,P,c,N,O,T,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dr=void 0;class w extends c.$Wc{constructor(){super(),this.a=this.B(new O.$me),this.onDidChangeFile=this.a.event,this.b=this.B(new O.$me),this.onDidLogMessage=this.b.event,this.c=this.B(new O.$me),this.f=this.c.event,this.g=new Set,this.h=new Map,this.j=this.B(new c.$6c),this.m=new Set,this.n=this.B(new A.$Dh(this.y())),this.r=5007,this.s=new A.$3h,this.R=!1,this.B(this.f($=>this.t($)))}t($){this.u($)&&this.z($)}u($){return(0,N.$Wq)($)}async watch($){this.s.isSettled||this.s.complete(),this.s=new A.$3h;try{this.h.clear(),this.g.clear();for(const u of $)this.u(u)?this.h.set(u.correlationId,u):this.g.add(u);for(const[u]of this.j)this.h.has(u)||(this.j.deleteAndDispose(u),this.m.delete(u));return await this.w(!1)}finally{this.s.complete()}}w($){return this.n.trigger(()=>this.N([...this.g,...Array.from(this.h.values()).filter(u=>!this.j.has(u.correlationId))]),$?this.y():0)}y(){return 800}isSuspended($){return typeof $.correlationId!="number"?!1:this.m.has($.correlationId)?"polling":this.j.has($.correlationId)}async z($){if(this.j.has($.correlationId))return;const u=new c.$Vc;this.j.set($.correlationId,u),await this.s.p,!u.isDisposed&&(this.D($,u),this.w(!0))}C($){this.j.deleteAndDispose($.correlationId),this.m.delete($.correlationId),this.w(!1)}D($,u){this.F($,u)?(this.P(`reusing an existing recursive watcher to monitor ${$.path}`),this.m.delete($.correlationId)):(this.G($,u),this.m.add($.correlationId))}F($,u){const p=this.O?.subscribe($.path,(l,d)=>{u.isDisposed||(l?this.D($,u):d?.type===T.FileChangeType.ADDED&&this.H($))});return p?(u.add(p),!0):!1}G($,u){let p=!1;const l=(d,y)=>{if(u.isDisposed)return;const f=this.I(d),b=this.I(y),I=p;p=f,!f&&(b||I)&&this.H($)};this.P(`starting fs.watchFile() on ${$.path} (correlationId: ${$.correlationId})`);try{(0,P.watchFile)($.path,{persistent:!1,interval:this.r},l)}catch(d){this.Q(`fs.watchFile() failed with error ${d} on path ${$.path} (correlationId: ${$.correlationId})`)}u.add((0,c.$Uc)(()=>{this.P(`stopping fs.watchFile() on ${$.path} (correlationId: ${$.correlationId})`);try{(0,P.unwatchFile)($.path,l)}catch(d){this.Q(`fs.unwatchFile() failed with error ${d} on path ${$.path} (correlationId: ${$.correlationId})`)}}))}H($){this.P(`detected ${$.path} exists again, resuming watcher (correlationId: ${$.correlationId})`);const u={resource:k.URI.file($.path),type:T.FileChangeType.ADDED,cId:$.correlationId};this.a.fire([u]),this.J(u,$),this.C($)}I($){return $.ctimeMs===0&&$.ino===0}async stop(){this.j.clearAndDisposeAll(),this.m.clear()}J($,u){if(this.R){const p=` >> normalized ${$.type===T.FileChangeType.ADDED?"[ADDED]":$.type===T.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${$.resource.fsPath}`;this.L(p,u)}}L($,u){this.R&&this.P(`${$}${typeof u.correlationId=="number"?` <${u.correlationId}> `:""}`)}M($){return`${$.path} (excludes: ${$.excludes.length>0?$.excludes:"<none>"}, includes: ${$.includes&&$.includes.length>0?JSON.stringify($.includes):"<all>"}, filter: ${(0,N.$7q)($.filter)}, correlationId: ${typeof $.correlationId=="number"?$.correlationId:"<none>"})`}async setVerboseLogging($){this.R=$}}e.$dr=w}),define(ce[202],le([0,1,46,6,26,42,2,91,14,5,21,9,154,31,7,47]),function(ne,e,P,c,N,O,T,k,A,w,E,$,u,p,l,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ir=void 0,e.$jr=f;class y extends T.$Wc{static{this.a=100}static{this.b=75}get isReusingRecursiveWatcher(){return this.n}get failed(){return this.r}constructor(I,m,s,r,i,a){super(),this.s=I,this.t=m,this.u=s,this.w=r,this.y=i,this.z=a,this.c=this.B(new c.$Uh({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},t=>this.u(t))),this.f=this.B(new c.$Th(t=>this.M(t),y.b)),this.g=(0,d.$5q)(this.s.path,this.s.excludes),this.h=this.s.includes?(0,d.$5q)(this.s.path,this.s.includes):void 0,this.j=(0,d.$Wq)(this.s)?this.s.filter:void 0,this.m=new N.$xe,this.ready=this.C(),this.n=!1,this.r=!1}async C(){try{const I=await this.F(this.s);if(this.m.token.isCancellationRequested)return;const m=await p.Promises.stat(I);if(this.m.token.isCancellationRequested)return;this.B(await this.G(I,m.isDirectory()))}catch(I){I.code!=="ENOENT"?this.O(I):this.Q(`ignoring a path for watching who's stat info failed to resolve: ${this.s.path} (error: ${I})`),this.D()}}D(){this.r=!0,this.w?.()}async F(I){let m=I.path;try{m=await p.Promises.realpath(I.path),I.path===m&&(m=await(0,u.$fr)(I.path,this.m.token)??I.path),I.path!==m&&this.Q(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${I.path}, real: ${m})`)}catch{}return m}async G(I,m){const s=new T.$Vc;return this.H(I,m,s)?(this.Q(`reusing an existing recursive watcher for ${this.s.path}`),this.n=!0):(this.n=!1,await this.I(I,m,s)),s}H(I,m,s){if(m)return!1;const r=$.URI.file(this.s.path),i=this.t?.subscribe(this.s.path,async(a,t)=>{if(!s.isDisposed)if(a){const n=await this.G(I,m);s.isDisposed?n.dispose():s.add(n)}else t&&(typeof t.cId=="number"||typeof this.s.correlationId=="number")&&this.L({resource:r,type:t.type,cId:this.s.correlationId},!0)});return i?(s.add(i),!0):!1}async I(I,m,s){if(w.$j&&(0,O.$Eg)(I,"/Volumes/",!0)){this.O(`Refusing to watch ${I} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`);return}const r=new N.$xe(this.m.token);s.add((0,T.$Uc)(()=>r.dispose(!0)));const i=new T.$Vc;s.add(i);try{const a=$.URI.file(this.s.path),t=(0,A.$pc)(I),n=(0,P.watch)(I);i.add((0,T.$Uc)(()=>{n.removeAllListeners(),n.close()})),this.Q(`Started watching: '${I}'`);const o=new Set;if(m)try{for(const g of await p.Promises.readdir(I))o.add(g)}catch(g){this.O(g)}if(r.token.isCancellationRequested)return;const h=new Map;i.add((0,T.$Uc)(()=>{for(const[,g]of h)g.dispose();h.clear()})),n.on("error",(g,R)=>{r.token.isCancellationRequested||(this.O(`Failed to watch ${I} for changes using fs.watch() (${g}, ${R})`),this.D())}),n.on("change",(g,R)=>{if(r.token.isCancellationRequested)return;this.z&&this.R(`[raw] ["${g}"] ${R}`);let L="";if(R&&(L=R.toString(),w.$j&&(L=(0,k.$mm)(L))),!(!L||g!=="change"&&g!=="rename"))if(m)if(g==="rename"){h.get(L)?.dispose();const S=setTimeout(async()=>{if(h.delete(L),L===t&&!await p.Promises.exists(I)){this.J(a);return}if(r.token.isCancellationRequested)return;const v=await this.N((0,A.$lc)(I,L));if(r.token.isCancellationRequested)return;let C;v?o.has(L)?C=l.FileChangeType.UPDATED:(C=l.FileChangeType.ADDED,o.add(L)):(o.delete(L),C=l.FileChangeType.DELETED),this.L({resource:(0,E.$gh)(a,L),type:C,cId:this.s.correlationId})},y.a);h.set(L,(0,T.$Uc)(()=>clearTimeout(S)))}else{let S;o.has(L)?S=l.FileChangeType.UPDATED:(S=l.FileChangeType.ADDED,o.add(L)),this.L({resource:(0,E.$gh)(a,L),type:S,cId:this.s.correlationId})}else if(g==="rename"||L!==t){const S=setTimeout(async()=>{const v=await p.Promises.exists(I);r.token.isCancellationRequested||(v?(this.L({resource:a,type:l.FileChangeType.UPDATED,cId:this.s.correlationId},!0),i.add(await this.G(I,!1))):this.J(a))},y.a);i.clear(),i.add((0,T.$Uc)(()=>clearTimeout(S)))}else this.L({resource:a,type:l.FileChangeType.UPDATED,cId:this.s.correlationId},!0)})}catch(a){r.token.isCancellationRequested||this.O(`Failed to watch ${I} for changes using fs.watch() (${a.toString()})`),this.D()}}J(I){this.P("Watcher shutdown because watched path got deleted"),this.L({resource:I,type:l.FileChangeType.DELETED,cId:this.s.correlationId},!0),this.f.flush(),this.D()}L(I,m=!1){this.m.token.isCancellationRequested||(this.z&&this.R(`${I.type===l.FileChangeType.ADDED?"[ADDED]":I.type===l.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${I.resource.fsPath}`),!m&&this.g.some(s=>s(I.resource.fsPath))?this.z&&this.R(` >> ignored (excluded) ${I.resource.fsPath}`):!m&&this.h&&this.h.length>0&&!this.h.some(s=>s(I.resource.fsPath))?this.z&&this.R(` >> ignored (not included) ${I.resource.fsPath}`):this.f.work(I))}M(I){const m=(0,d.$3q)(I),s=[];for(const i of m){if((0,d.$6q)(i,this.j)){this.z&&this.R(` >> ignored (filtered) ${i.resource.fsPath}`);continue}s.push(i)}if(s.length===0)return;if(this.z)for(const i of s)this.R(` >> normalized ${i.type===l.FileChangeType.ADDED?"[ADDED]":i.type===l.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${i.resource.fsPath}`);this.c.work(s)?this.c.pending>0&&this.Q(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${s[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.P(`started ignoring events due to too many file change events at once (incoming: ${s.length}, most recent change: ${s[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}async N(I){if(w.$k)return p.Promises.exists(I);try{const m=(0,A.$pc)(I);return(await p.Promises.readdir((0,A.$oc)(I))).some(r=>r===m)}catch(m){return this.Q(m),!1}}setVerboseLogging(I){this.z=I}O(I){this.m.token.isCancellationRequested||this.y?.({type:"error",message:`[File Watcher (node.js)] ${I}`})}P(I){this.m.token.isCancellationRequested||this.y?.({type:"warn",message:`[File Watcher (node.js)] ${I}`})}Q(I){!this.m.token.isCancellationRequested&&this.z&&this.y?.({type:"trace",message:`[File Watcher (node.js)] ${I}`})}R(I){!this.m.token.isCancellationRequested&&this.z&&this.Q(`${I}${typeof this.s.correlationId=="number"?` <${this.s.correlationId}> `:""}`)}dispose(){this.m.dispose(!0),super.dispose()}}e.$ir=y;async function f(b,I,m,s,r=512){const i=await p.Promises.open(b,"r"),a=Buffer.allocUnsafe(r),t=new N.$xe(s);let n,o=!1;const h={path:b,excludes:[],recursive:!1},g=new y(h,void 0,R=>{(async()=>{for(const{type:L}of R)if(L===l.FileChangeType.UPDATED){if(o)return;o=!0;try{for(;!t.token.isCancellationRequested;){const{bytesRead:S}=await p.Promises.read(i,a,0,r,null);if(!S||t.token.isCancellationRequested)break;I(a.slice(0,S))}}catch(S){n=new Error(S),t.dispose(!0)}finally{o=!1}}})()});return await g.ready,m(),new Promise((R,L)=>{t.token.onCancellationRequested(async()=>{g.dispose();try{await p.Promises.close(i)}catch(S){n=new Error(S)}n?L(n):R()})})}}),define(ce[203],le([0,1,3,94,201,5,202,42]),function(ne,e,P,c,N,O,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kr=void 0;class A extends N.$dr{constructor(E){super(),this.O=E,this.onDidError=P.Event.None,this.watchers=new Set}async N(E){E=this.Z(E);const $=[],u=new Set(Array.from(this.watchers));for(const p of E){const l=this.W(p);l&&(0,c.$Dk)(l.request.excludes,p.excludes)&&(0,c.$Dk)(l.request.includes,p.includes)?u.delete(l):$.push(p)}$.length&&this.P(`Request to start watching: ${$.map(p=>this.M(p)).join(",")}`),u.size&&this.P(`Request to stop watching: ${Array.from(u).map(p=>this.M(p.request)).join(",")}`);for(const p of u)this.Y(p);for(const p of $)this.X(p)}W(E){for(const $ of this.watchers)if(typeof E.correlationId=="number"||typeof $.request.correlationId=="number"){if($.request.correlationId===E.correlationId)return $}else if((0,k.$Dg)($.request.path,E.path,!O.$k))return $}X(E){const $=new T.$ir(E,this.O,p=>this.a.fire(p),()=>this.c.fire(E),p=>this.b.fire(p),this.R),u={request:E,instance:$};this.watchers.add(u)}async stop(){await super.stop();for(const E of this.watchers)this.Y(E)}Y(E){this.P("stopping file watcher",E),this.watchers.delete(E),E.instance.dispose()}Z(E){const $=new Map;for(const u of E){const p=O.$k?u.path:u.path.toLowerCase();let l=$.get(u.correlationId);l||(l=new Map,$.set(u.correlationId,l)),l.has(p)&&this.P(`ignoring a request for watching who's path is already watched: ${this.M(u)}`),l.set(p,u)}return Array.from($.values()).map(u=>Array.from(u.values())).flat()}async setVerboseLogging(E){super.setVerboseLogging(E);for(const $ of this.watchers)$.instance.setVerboseLogging(E)}P(E,$){this.R&&this.b.fire({type:"trace",message:this.bb(E,$)})}Q(E){this.b.fire({type:"warn",message:this.bb(E)})}bb(E,$){return $?`[File Watcher (node.js)] ${E} (${this.M($.request)})`:`[File Watcher (node.js)] ${E}`}}e.$kr=A}),define(ce[204],le([0,1,47,203]),function(ne,e,P,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lr=void 0;class N extends P.$Zq{constructor(T,k,A){super(T,k,A),this.s()}r(T){return T.add(new c.$kr(void 0))}}e.$lr=N}),define(ce[205],le([0,1,23,43,96,47]),function(ne,e,P,c,N,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cr=void 0;class T extends O.$1q{constructor(A,w,E){super(A,w,E),this.s()}r(A){const w=A.add(new N.$br(P.$Zg.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return A.add(w.onDidProcessExit(({code:E,signal:$})=>this.t(`terminated by itself with code ${E}, signal: ${$} (ETERM)`))),c.ProxyChannel.toService((0,c.$mi)(w.getChannel("watcher")))}}e.$cr=T}),define(ce[77],le([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Di=void 0;class P{constructor(...N){this.a=new Map;for(const[O,T]of N)this.set(O,T)}set(N,O){const T=this.a.get(N);return this.a.set(N,O),T}has(N){return this.a.has(N)}get(N){return this.a.get(N)}}e.$Di=P}),define(ce[206],le([0,1,6,8,2,74,197,4,77,90]),function(ne,e,P,c,N,O,T,k,A,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qr=e.$pr=void 0;const E=!1;class $ extends Error{constructor(y){super("cyclic dependency between services"),this.message=y.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${y.toString()}`}}class u{constructor(y=new A.$Di,f=!1,b,I=E){this.i=y,this.j=f,this.k=b,this.l=I,this.f=!1,this.g=new Set,this.h=new Set,this.t=new Set,this.i.set(k.$Ei,this),this._globalGraph=I?b?._globalGraph??new T.$or(m=>m):void 0}dispose(){if(!this.f){this.f=!0,(0,N.$Rc)(this.h),this.h.clear();for(const y of this.g)(0,N.$Qc)(y)&&y.dispose();this.g.clear()}}m(){if(this.f)throw new Error("InstantiationService has been disposed")}createChild(y,f){this.m();const b=this,I=new class extends u{dispose(){b.h.delete(I),super.dispose()}}(y,this.j,this,this.l);return this.h.add(I),f?.add(I),I}invokeFunction(y,...f){this.m();const b=l.traceInvocation(this.l,y);let I=!1;try{return y({get:s=>{if(I)throw(0,c.$0)("service accessor is only valid during the invocation of its target method");const r=this.s(s,b);if(!r)throw new Error(`[invokeFunction] unknown service '${s}'`);return r}},...f)}finally{I=!0,b.stop()}}createInstance(y,...f){this.m();let b,I;return y instanceof O.$Ci?(b=l.traceCreation(this.l,y.ctor),I=this.o(y.ctor,y.staticArguments.concat(f),b)):(b=l.traceCreation(this.l,y),I=this.o(y,f,b)),b.stop(),I}o(y,f=[],b){const I=k._util.getServiceDependencies(y).sort((r,i)=>r.index-i.index),m=[];for(const r of I){const i=this.s(r.id,b);i||this.y(`[createInstance] ${y.name} depends on UNKNOWN service ${r.id}.`,!1),m.push(i)}const s=I.length>0?I[0].index:f.length;if(f.length!==s){console.trace(`[createInstance] First service dependency of ${y.name} at position ${s+1} conflicts with ${f.length} static arguments`);const r=s-f.length;r>0?f=f.concat(new Array(r)):f=f.slice(0,s)}return Reflect.construct(y,f.concat(m))}q(y,f){if(this.i.get(y)instanceof O.$Ci)this.i.set(y,f);else if(this.k)this.k.q(y,f);else throw new Error("illegalState - setting UNKNOWN service instance")}r(y){const f=this.i.get(y);return!f&&this.k?this.k.r(y):f}s(y,f){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(y));const b=this.r(y);return b instanceof O.$Ci?this.u(y,b,f.branch(y,!0)):(f.branch(y,!1),b)}u(y,f,b){if(this.t.has(y))throw new Error(`illegal state - RECURSIVELY instantiating service '${y}'`);this.t.add(y);try{return this.v(y,f,b)}finally{this.t.delete(y)}}v(y,f,b){const I=new T.$or(r=>r.id.toString());let m=0;const s=[{id:y,desc:f,_trace:b}];for(;s.length;){const r=s.pop();if(I.lookupOrInsertNode(r),m++>1e3)throw new $(I);for(const i of k._util.getServiceDependencies(r.desc.ctor)){const a=this.r(i.id);if(a||this.y(`[createInstance] ${y} depends on ${i.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(r.id),String(i.id)),a instanceof O.$Ci){const t={id:i.id,desc:a,_trace:r._trace.branch(i.id,!0)};I.insertEdge(r,t),s.push(t)}}}for(;;){const r=I.roots();if(r.length===0){if(!I.isEmpty())throw new $(I);break}for(const{data:i}of r){if(this.r(i.id)instanceof O.$Ci){const t=this.w(i.id,i.desc.ctor,i.desc.staticArguments,i.desc.supportsDelayedInstantiation,i._trace);this.q(i.id,t)}I.removeNode(i)}}return this.r(y)}w(y,f,b=[],I,m){if(this.i.get(y)instanceof O.$Ci)return this.x(y,f,b,I,m,this.g);if(this.k)return this.k.w(y,f,b,I,m);throw new Error(`illegalState - creating UNKNOWN service instance ${f.name}`)}x(y,f,b=[],I,m,s){if(I){const r=new u(void 0,this.j,this,this.l);r.c=String(y);const i=new Map,a=new P.$Yh(()=>{const t=r.o(f,b,m);for(const[n,o]of i){const h=t[n];if(typeof h=="function")for(const g of o)g.disposable=h.apply(t,g.listener)}return i.clear(),s.add(t),t});return new Proxy(Object.create(null),{get(t,n){if(!a.isInitialized&&typeof n=="string"&&(n.startsWith("onDid")||n.startsWith("onWill"))){let g=i.get(n);return g||(g=new w.$7c,i.set(n,g)),(L,S,v)=>{if(a.isInitialized)return a.value[n](L,S,v);{const C={listener:[L,S,v],disposable:void 0},F=g.push(C);return(0,N.$Uc)(()=>{F(),C.disposable?.dispose()})}}}if(n in t)return t[n];const o=a.value;let h=o[n];return typeof h!="function"||(h=h.bind(o),t[n]=h),h},set(t,n,o){return a.value[n]=o,!0},getPrototypeOf(t){return f.prototype}})}else{const r=this.o(f,b,m);return s.add(r),r}}y(y,f){if(f&&console.warn(y),this.j)throw new Error(y)}}e.$pr=u;var p;(function(d){d[d.None=0]="None",d[d.Creation=1]="Creation",d[d.Invocation=2]="Invocation",d[d.Branch=3]="Branch"})(p||(p={}));class l{static{this.all=new Set}static{this.c=new class extends l{constructor(){super(p.None,null)}stop(){}branch(){return this}}}static traceInvocation(y,f){return y?new l(p.Invocation,f.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):l.c}static traceCreation(y,f){return y?new l(p.Creation,f.name):l.c}static{this.f=0}constructor(y,f){this.type=y,this.name=f,this.g=Date.now(),this.h=[]}branch(y,f){const b=new l(p.Branch,y.toString());return this.h.push([y,f,b]),b}stop(){const y=Date.now()-this.g;l.f+=y;let f=!1;function b(m,s){const r=[],i=new Array(m+1).join("	");for(const[a,t,n]of s.h)if(t&&n){f=!0,r.push(`${i}CREATES -> ${a}`);const o=b(m+1,n);o&&r.push(o)}else r.push(`${i}uses -> ${a}`);return r.join(`
`)}const I=[`${this.type===p.Creation?"CREATE":"CALL"} ${this.name}`,`${b(1,this)}`,`DONE, took ${y.toFixed(2)}ms (grand total ${l.f.toFixed(2)}ms)`];(y>2||f)&&l.all.add(I.join(`
`))}}e.$qr=l}),define(ce[58],le([0,1,4]),function(ne,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vgc=e.$ugc=void 0,e.$ugc=(0,P.$Fi)("mainProcessService");class c{constructor(O,T){this.a=O,this.b=T}getChannel(O){return this.a.getChannel(O,this.b)}registerChannel(O,T){this.a.registerChannel(O,T)}}e.$vgc=c}),define(ce[10],le([0,1,174,41,3,56,2,35,5,21,13,9,97,4]),function(ne,e,P,c,N,O,T,k,A,w,E,$,u,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rk=e.$mk=e.$lk=e.$kk=e.$jk=e.$ik=e.$hk=e.$gk=e.$fk=e.$ek=e.$ck=e.LogLevel=e.$ak=e.$_j=void 0,e.$bk=d,e.log=f,e.$nk=h,e.$ok=g,e.$pk=R,e.$qk=L,P=Oe(P),e.$_j=(0,p.$Fi)("logService"),e.$ak=(0,p.$Fi)("loggerService");function l(){return new Date().toISOString()}function d(S){return(0,E.$jg)(S)}var y;(function(S){S[S.Off=0]="Off",S[S.Trace=1]="Trace",S[S.Debug=2]="Debug",S[S.Info=3]="Info",S[S.Warning=4]="Warning",S[S.Error=5]="Error"})(y||(e.LogLevel=y={})),e.$ck=y.Info;function f(S,v,C){switch(v){case y.Trace:S.trace(C);break;case y.Debug:S.debug(C);break;case y.Info:S.info(C);break;case y.Warning:S.warn(C);break;case y.Error:S.error(C);break;case y.Off:break;default:throw new Error(`Invalid log level ${v}`)}}function b(S,v=!1){let C="";for(let F=0;F<S.length;F++){let D=S[F];if(D instanceof Error&&(D=(0,c.$qj)(D,v)),typeof D=="object")try{D=JSON.stringify(D)}catch{}C+=(F>0?" ":"")+D}return C}class I extends T.$Wc{constructor(){super(...arguments),this.b=e.$ck,this.c=this.B(new N.$me),this.onDidChangeLogLevel=this.c.event}setLevel(v){this.b!==v&&(this.b=v,this.c.fire(this.b))}getLevel(){return this.b}f(v){return this.b!==y.Off&&this.b<=v}}e.$ek=I;class m extends I{constructor(v){super(),this.h=v}f(v){return this.h||super.f(v)}trace(v,...C){this.f(y.Trace)&&this.g(y.Trace,b([v,...C],!0))}debug(v,...C){this.f(y.Debug)&&this.g(y.Debug,b([v,...C]))}info(v,...C){this.f(y.Info)&&this.g(y.Info,b([v,...C]))}warn(v,...C){this.f(y.Warning)&&this.g(y.Warning,b([v,...C]))}error(v,...C){if(this.f(y.Error))if(v instanceof Error){const F=Array.prototype.slice.call(arguments);F[0]=v.stack,this.g(y.Error,b(F))}else this.g(y.Error,b([v,...C]))}flush(){}}e.$fk=m;class s extends I{constructor(v=e.$ck){super(),this.setLevel(v),this.g=!A.$i}trace(v,...C){this.f(y.Trace)&&(this.g?console.log(`\x1B[90m[main ${l()}]\x1B[0m`,v,...C):console.log(`[main ${l()}]`,v,...C))}debug(v,...C){this.f(y.Debug)&&(this.g?console.log(`\x1B[90m[main ${l()}]\x1B[0m`,v,...C):console.log(`[main ${l()}]`,v,...C))}info(v,...C){this.f(y.Info)&&(this.g?console.log(`\x1B[90m[main ${l()}]\x1B[0m`,v,...C):console.log(`[main ${l()}]`,v,...C))}warn(v,...C){this.f(y.Warning)&&(this.g?console.warn(`\x1B[93m[main ${l()}]\x1B[0m`,v,...C):console.warn(`[main ${l()}]`,v,...C))}error(v,...C){this.f(y.Error)&&(this.g?console.error(`\x1B[91m[main ${l()}]\x1B[0m`,v,...C):console.error(`[main ${l()}]`,v,...C))}flush(){}}e.$gk=s;class r extends I{constructor(v=e.$ck,C=!0){super(),this.g=C,this.setLevel(v)}trace(v,...C){this.f(y.Trace)&&(this.g?console.log("%cTRACE","color: #888",v,...C):console.log(v,...C))}debug(v,...C){this.f(y.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",v,...C):console.log(v,...C))}info(v,...C){this.f(y.Info)&&(this.g?console.log("%c INFO","color: #33f",v,...C):console.log(v,...C))}warn(v,...C){this.f(y.Warning)&&(this.g?console.log("%c WARN","color: #993",v,...C):console.log(v,...C))}error(v,...C){this.f(y.Error)&&(this.g?console.log("%c  ERR","color: #f33",v,...C):console.error(v,...C))}flush(){}}e.$hk=r;class i extends I{constructor(v,C=e.$ck){super(),this.g=v,this.setLevel(C)}trace(v,...C){this.f(y.Trace)&&this.g.log(y.Trace,[this.h(v),...C])}debug(v,...C){this.f(y.Debug)&&this.g.log(y.Debug,[this.h(v),...C])}info(v,...C){this.f(y.Info)&&this.g.log(y.Info,[this.h(v),...C])}warn(v,...C){this.f(y.Warning)&&this.g.log(y.Warning,[this.h(v),...C])}error(v,...C){this.f(y.Error)&&this.g.log(y.Error,[this.h(v),...C])}h(v){return typeof v=="string"?v:(0,c.$qj)(v,this.f(y.Trace))}flush(){}}e.$ik=i;class a extends I{constructor(v){super(),this.g=v,v.length&&this.setLevel(v[0].getLevel())}setLevel(v){for(const C of this.g)C.setLevel(v);super.setLevel(v)}trace(v,...C){for(const F of this.g)F.trace(v,...C)}debug(v,...C){for(const F of this.g)F.debug(v,...C)}info(v,...C){for(const F of this.g)F.info(v,...C)}warn(v,...C){for(const F of this.g)F.warn(v,...C)}error(v,...C){for(const F of this.g)F.error(v,...C)}flush(){for(const v of this.g)v.flush()}dispose(){for(const v of this.g)v.dispose();super.dispose()}}e.$jk=a;class t extends T.$Wc{constructor(v,C,F){if(super(),this.h=v,this.j=C,this.b=new k.$Cc,this.c=this.B(new N.$me),this.onDidChangeLoggers=this.c.event,this.f=this.B(new N.$me),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new N.$me),this.onDidChangeVisibility=this.g.event,F)for(const D of F)this.b.set(D.resource,{logger:void 0,info:D})}m(v){return(0,E.$fg)(v)?[...this.b.values()].find(C=>C.info.id===v):this.b.get(v)}getLogger(v){return this.m(v)?.logger}createLogger(v,C){const F=this.n(v),D=(0,E.$fg)(v)?v:C?.id??(0,O.$tj)(F.toString()).toString(16);let M=this.b.get(F)?.logger;const J=C?.logLevel==="always"?y.Trace:C?.logLevel;M||(M=this.s(F,J??this.getLogLevel(F)??this.h,{...C,id:D}));const H={logger:M,info:{resource:F,id:D,logLevel:J,name:C?.name,hidden:C?.hidden,extensionId:C?.extensionId,when:C?.when}};return this.registerLogger(H.info),this.b.set(F,H),M}n(v){return(0,E.$fg)(v)?(0,w.$gh)(this.j,`${v}.log`):v}setLogLevel(v,C){if($.URI.isUri(v)){const F=v,D=C,M=this.b.get(F);M&&D!==M.info.logLevel&&(M.info.logLevel=D===this.h?void 0:D,M.logger?.setLevel(D),this.b.set(M.info.resource,M),this.f.fire([F,D]))}else{this.h=v;for(const[F,D]of this.b.entries())this.b.get(F)?.info.logLevel===void 0&&D.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(v,C){const F=this.m(v);F&&C!==!F.info.hidden&&(F.info.hidden=!C,this.b.set(F.info.resource,F),this.g.fire([F.info.resource,C]))}getLogLevel(v){let C;return v&&(C=this.b.get(v)?.info.logLevel),C??this.h}registerLogger(v){const C=this.b.get(v.resource);C?C.info.hidden!==v.hidden&&this.setVisibility(v.resource,!v.hidden):(this.b.set(v.resource,{info:v,logger:void 0}),this.c.fire({added:[v],removed:[]}))}deregisterLogger(v){const C=this.b.get(v);C&&(C.logger&&C.logger.dispose(),this.b.delete(v),this.c.fire({added:[],removed:[C.info]}))}*getRegisteredLoggers(){for(const v of this.b.values())yield v.info}getRegisteredLogger(v){return this.b.get(v)?.info}dispose(){this.b.forEach(v=>v.logger?.dispose()),this.b.clear(),super.dispose()}}e.$kk=t;class n{constructor(){this.onDidChangeLogLevel=new N.$me().event}setLevel(v){}getLevel(){return y.Info}trace(v,...C){}debug(v,...C){}info(v,...C){}warn(v,...C){}error(v,...C){}critical(v,...C){}dispose(){}flush(){}}e.$lk=n;class o extends n{}e.$mk=o;function h(S){if(S.verbose)return y.Trace;if(typeof S.logLevel=="string"){const v=L(S.logLevel.toLowerCase());if(v!==void 0)return v}return e.$ck}function g(S){switch(S){case y.Trace:return"trace";case y.Debug:return"debug";case y.Info:return"info";case y.Warning:return"warn";case y.Error:return"error";case y.Off:return"off"}}function R(S){switch(S){case y.Trace:return{original:"Trace",value:P.localize(0,null)};case y.Debug:return{original:"Debug",value:P.localize(1,null)};case y.Info:return{original:"Info",value:P.localize(2,null)};case y.Warning:return{original:"Warning",value:P.localize(3,null)};case y.Error:return{original:"Error",value:P.localize(4,null)};case y.Off:return{original:"Off",value:P.localize(5,null)}}}function L(S){switch(S){case"trace":return y.Trace;case"debug":return y.Debug;case"info":return y.Info;case"warn":return y.Warning;case"error":return y.Error;case"critical":return y.Error;case"off":return y.Off}}e.$rk=new u.$Wj("logLevel",g(y.Info))}),define(ce[207],le([0,1,6,8,2,23,14,21,31,16,10]),function(ne,e,P,c,N,O,T,k,A,w,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ogc=void 0;let $=class extends N.$Wc{constructor(p,l){super(),this.a=p,this.b=l,this.B(new P.$Rh(()=>{this.c()},10*1e3)).schedule()}async c(){this.b.trace("[logs cleanup]: Starting to clean up old logs.");try{const p=(0,k.$dh)(this.a.logsHome),l=(0,k.$fh)(this.a.logsHome.with({scheme:O.Schemas.file})).fsPath,f=(await A.Promises.readdir(l)).filter(I=>/^\d{8}T\d{6}$/.test(I)).sort().filter(I=>I!==p),b=f.slice(0,Math.max(0,f.length-9));b.length>0&&(this.b.trace(`[logs cleanup]: Removing log folders '${b.join(", ")}'`),await Promise.all(b.map(I=>A.Promises.rm((0,T.$lc)(l,I)))))}catch(p){(0,c.$3)(p)}}};e.$Ogc=$,e.$Ogc=$=ve([Y(0,w.$Mi),Y(1,E.$_j)],$)}),define(ce[208],le([0,1,19,6,8,3,42,2,14,47,10]),function(ne,e,P,c,N,O,T,k,A,w,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8q=void 0;class $ extends k.$Wc{constructor(p,l){super(),this.a=p,this.b=l,this.c=this.B(new O.$me),this.onDidChangeFile=this.c.event,this.g=this.B(new O.$me),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new c.$Dh(0)),this.w=[],this.y=this.B(new c.$Dh(0))}watch(p,l){return l.recursive||this.b?.watcher?.forceUniversal?this.n(p,l):this.z(p,l)}n(p,l){const d={path:this.J(p),excludes:l.excludes,includes:l.includes,recursive:l.recursive,filter:l.filter,correlationId:l.correlationId},y=(0,P.$Vb)(this.j,d);return this.r(),(0,k.$Uc)(()=>{y(),this.r()})}r(){this.m.trigger(()=>this.s()).catch(p=>(0,N.$3)(p))}s(){this.h||(this.h=this.B(this.t(l=>this.c.fire((0,w.$2q)(l)),l=>this.G(l),this.a.getLevel()===E.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===E.LogLevel.Trace)})));const p=this.b?.watcher?.recursive?.usePolling;if(p===!0)for(const l of this.j)(0,w.$Xq)(l)&&(l.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(p))for(const l of this.j)(0,w.$Xq)(l)&&p.includes(l.path)&&(l.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z(p,l){const d={path:this.J(p),excludes:l.excludes,includes:l.includes,recursive:!1,filter:l.filter,correlationId:l.correlationId},y=(0,P.$Vb)(this.w,d);return this.C(),(0,k.$Uc)(()=>{y(),this.C()})}C(){this.y.trigger(()=>this.D()).catch(p=>(0,N.$3)(p))}D(){return this.u||(this.u=this.B(this.F(p=>this.c.fire((0,w.$2q)(p)),p=>this.G(p),this.a.getLevel()===E.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===E.LogLevel.Trace)}))),this.u.watch(this.w)}G(p){p.type==="error"&&this.g.fire(p.message),this.H(p)}H(p){this.a[p.type](p.message)}I(p){return(0,A.$jc)(p.fsPath)}J(p){const l=this.I(p);return(0,T.$Hg)(l)}}e.$8q=$}),define(ce[209],le([0,1,19,6,15,26,3,56,63,2,52,23,101,21,51,169,7,100,10,8]),function(ne,e,P,c,N,O,T,k,A,w,E,$,u,p,l,d,y,f,b,I){"use strict";var m;Object.defineProperty(e,"__esModule",{value:!0}),e.$Vq=void 0;let s=class extends w.$Wc{static{m=this}constructor(i){super(),this.b=i,this.a=256*1024,this.c=this.B(new T.$me),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new T.$me),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new T.$me),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.r=this.B(new T.$me),this.onDidRunOperation=this.r.event,this.X=this.B(new T.$me),this.Y=this.B(new T.$me),this.onDidFilesChange=this.Y.event,this.Z=this.B(new T.$me),this.onDidWatchError=this.Z.event,this.$=new Map,this.cb=this.B(new c.$Oh)}registerProvider(i,a){if(this.h.has(i))throw new Error(`A filesystem provider for the scheme '${i}' is already registered.`);(0,u.mark)(`code/registerFilesystem/${i}`);const t=new w.$Vc;return this.h.set(i,a),this.c.fire({added:!0,scheme:i,provider:a}),t.add(a.onDidChangeFile(n=>{const o=new y.$sl(n,!this.S(a));this.X.fire(o),o.hasCorrelation()||this.Y.fire(o)})),typeof a.onDidWatchError=="function"&&t.add(a.onDidWatchError(n=>this.Z.fire(new Error(n)))),t.add(a.onDidChangeCapabilities(()=>this.g.fire({provider:a,scheme:i}))),(0,w.$Uc)(()=>{this.c.fire({added:!1,scheme:i,provider:a}),this.h.delete(i),(0,w.$Rc)(t)})}getProvider(i){return this.h.get(i)}async activateProvider(i){const a=[];this.f.fire({scheme:i,join(t){a.push(t)}}),!this.h.has(i)&&await c.Promises.settled(a)}async canHandleResource(i){return await this.activateProvider(i.scheme),this.hasProvider(i)}hasProvider(i){return this.h.has(i.scheme)}hasCapability(i,a){const t=this.h.get(i.scheme);return!!(t&&t.capabilities&a)}listCapabilities(){return A.Iterable.map(this.h,([i,a])=>({scheme:i,capabilities:a.capabilities}))}async j(i){if(!(0,p.$kh)(i))throw new y.$ul((0,d.localize)(0,null,this.sb(i)),y.FileOperationResult.FILE_INVALID_PATH);await this.activateProvider(i.scheme);const a=this.h.get(i.scheme);if(!a){const t=new I.$db;throw t.message=(0,d.localize)(1,null,i.toString()),t}return a}async m(i){const a=await this.j(i);if((0,y.$fl)(a)||(0,y.$cl)(a)||(0,y.$gl)(a))return a;throw new Error(`Filesystem provider for scheme '${i.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async n(i){const a=await this.j(i);if((0,y.$fl)(a)||(0,y.$cl)(a))return a;throw new Error(`Filesystem provider for scheme '${i.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(i,a){try{return await this.s(i,a)}catch(t){throw(0,y.$pl)(t)===y.FileSystemProviderErrorCode.FileNotFound?new y.$ul((0,d.localize)(2,null,this.sb(i)),y.FileOperationResult.FILE_NOT_FOUND):(0,y.$nl)(t)}}async s(i,a){const t=await this.j(i),n=this.S(t),o=a?.resolveTo,h=a?.resolveSingleChildDescendants,g=a?.resolveMetadata,R=await t.stat(i);let L;return this.t(t,i,R,void 0,!!g,(S,v)=>(L||(L=E.$Li.forUris(()=>!n),L.set(i,!0),o&&L.fill(!0,o)),L.get(S.resource)||L.findSuperstr(S.resource.with({query:null,fragment:null}))?!0:S.isDirectory&&h?v===1:!1))}async t(i,a,t,n,o,h){const{providerExtUri:g}=this.R(i),R={resource:a,name:g.basename(a),isFile:(t.type&y.FileType.File)!==0,isDirectory:(t.type&y.FileType.Directory)!==0,isSymbolicLink:(t.type&y.FileType.SymbolicLink)!==0,mtime:t.mtime,ctime:t.ctime,size:t.size,readonly:!!((t.permissions??0)&y.FilePermission.Readonly)||!!(i.capabilities&y.FileSystemProviderCapabilities.Readonly),locked:!!((t.permissions??0)&y.FilePermission.Locked),etag:(0,y.$Fl)({mtime:t.mtime,size:t.size}),children:void 0};if(R.isDirectory&&h(R,n)){try{const L=await i.readdir(a),S=await c.Promises.settled(L.map(async([v,C])=>{try{const F=g.joinPath(a,v),D=o?await i.stat(F):{type:C};return await this.t(i,F,D,L.length,o,h)}catch(F){return this.b.trace(F),null}}));R.children=(0,P.$Jb)(S)}catch(L){this.b.trace(L),R.children=[]}return R}return R}async resolveAll(i){return c.Promises.settled(i.map(async a=>{try{return{stat:await this.s(a.resource,a.options),success:!0}}catch(t){return this.b.trace(t),{stat:void 0,success:!1}}}))}async stat(i){const a=await this.j(i),t=await a.stat(i);return this.t(a,i,t,void 0,!0,()=>!1)}async exists(i){const a=await this.j(i);try{return!!await a.stat(i)}catch{return!1}}async canCreateFile(i,a){try{await this.u(i,a)}catch(t){return t}return!0}async u(i,a){if(!a?.overwrite&&await this.exists(i))throw new y.$ul((0,d.localize)(3,null,this.sb(i)),y.FileOperationResult.FILE_MODIFIED_SINCE,a)}async createFile(i,a=N.$Oe.fromString(""),t){await this.u(i,t);const n=await this.writeFile(i,a);return this.r.fire(new y.$rl(i,y.FileOperation.CREATE,n)),n}async writeFile(i,a,t){const n=this.qb(await this.n(i),i),{providerExtUri:o}=this.R(n);let h=t;if((0,y.$il)(n)&&!h?.atomic){const g=n.enforceAtomicWriteFile?.(i);g&&(h={...t,atomic:g})}try{await this.w(n,i,h)||await this.U(n,o.dirname(i));let R;if((0,y.$cl)(n)&&!(a instanceof N.$Oe))if((0,l.$Ae)(a)){const L=await(0,l.$He)(a,3);L.ended?R=N.$Oe.concat(L.buffer):R=L}else R=(0,l.$Ee)(a,L=>N.$Oe.concat(L),3);else R=a;!(0,y.$fl)(n)||(0,y.$cl)(n)&&R instanceof N.$Oe||(0,y.$cl)(n)&&(0,y.$il)(n)&&h?.atomic?await this.hb(n,i,h,R):await this.db(n,i,h,R instanceof N.$Oe?(0,N.$Ze)(R):R),this.r.fire(new y.$rl(i,y.FileOperation.WRITE))}catch(g){throw new y.$ul((0,d.localize)(4,null,this.sb(i),(0,y.$nl)(g).toString()),(0,y.$ql)(g),h)}return this.resolve(i,{resolveMetadata:!0})}async w(i,a,t){const n=!!t?.unlock;if(n&&!(i.capabilities&y.FileSystemProviderCapabilities.FileWriteUnlock))throw new Error((0,d.localize)(5,null,this.sb(a)));if(!!t?.atomic){if(!(i.capabilities&y.FileSystemProviderCapabilities.FileAtomicWrite))throw new Error((0,d.localize)(6,null,this.sb(a)));if(!(i.capabilities&y.FileSystemProviderCapabilities.FileReadWrite))throw new Error((0,d.localize)(7,null,this.sb(a)));if(n)throw new Error((0,d.localize)(8,null,this.sb(a)))}let h;try{h=await i.stat(a)}catch{return}if(h.type&y.FileType.Directory)throw new y.$ul((0,d.localize)(9,null,this.sb(a)),y.FileOperationResult.FILE_IS_DIRECTORY,t);if(this.rb(a,h),typeof t?.mtime=="number"&&typeof t.etag=="string"&&t.etag!==y.$El&&typeof h.mtime=="number"&&typeof h.size=="number"&&t.mtime<h.mtime&&t.etag!==(0,y.$Fl)({mtime:t.mtime,size:h.size}))throw new y.$ul((0,d.localize)(10,null),y.FileOperationResult.FILE_MODIFIED_SINCE,t);return h}async readFile(i,a,t){const n=await this.m(i);return a?.atomic?this.z(n,i,a,t):this.C(n,i,a,t)}async z(i,a,t,n){return new Promise((o,h)=>{this.cb.queueFor(a,async()=>{try{const g=await this.C(i,a,t,n);o(g)}catch(g){h(g)}},this.R(i).providerExtUri)})}async C(i,a,t,n){const o=await this.D(i,a,{...t,preferUnbuffered:!0},n);return{...o,value:await(0,N.$1e)(o.value)}}async readFileStream(i,a,t){const n=await this.m(i);return this.D(n,i,a,t)}async D(i,a,t,n){const o=new O.$xe(n);let h=t;(0,y.$hl)(i)&&i.enforceAtomicReadFile?.(a)&&(h={...t,atomic:!0});const g=this.J(a,h).then(L=>L,L=>{throw o.dispose(!0),L});let R;try{return typeof h?.etag=="string"&&h.etag!==y.$El&&await g,h?.atomic&&(0,y.$hl)(i)||!((0,y.$fl)(i)||(0,y.$gl)(i))||(0,y.$cl)(i)&&h?.preferUnbuffered?R=this.I(i,a,h):(0,y.$gl)(i)?R=this.G(i,a,o.token,h):R=this.H(i,a,o.token,h),R.on("end",()=>o.dispose()),R.on("error",()=>o.dispose()),{...await g,value:R}}catch(L){throw R&&await(0,l.$Fe)(R),this.F(L,a,h)}}F(i,a,t){const n=(0,d.localize)(11,null,this.sb(a),(0,y.$nl)(i).toString());return i instanceof y.$wl?new y.$wl(n,i.stat,t):i instanceof y.$vl?new y.$vl(n,i.fileOperationResult,i.size,i.options):new y.$ul(n,(0,y.$ql)(i),t)}G(i,a,t,n=Object.create(null)){const o=i.readFileStream(a,n,t);return(0,l.$Le)(o,{data:h=>h instanceof N.$Oe?h:N.$Oe.wrap(h),error:h=>this.F(h,a,n)},h=>N.$Oe.concat(h))}H(i,a,t,n=Object.create(null)){const o=(0,N.$5e)();return(0,f.$Uq)(i,a,o,h=>h,{...n,bufferSize:this.a,errorTransformer:h=>this.F(h,a,n)},t),o}I(i,a,t){const n=(0,l.$Ce)(o=>N.$Oe.concat(o));return(async()=>{try{let o;t?.atomic&&(0,y.$hl)(i)?o=await i.readFile(a,{atomic:!0}):o=await i.readFile(a),typeof t?.position=="number"&&(o=o.slice(t.position)),typeof t?.length=="number"&&(o=o.slice(0,t.length)),this.L(a,o.byteLength,t),n.end(N.$Oe.wrap(o))}catch(o){n.error(o),n.end()}})(),n}async J(i,a){const t=await this.resolve(i,{resolveMetadata:!0});if(t.isDirectory)throw new y.$ul((0,d.localize)(12,null,this.sb(i)),y.FileOperationResult.FILE_IS_DIRECTORY,a);if(typeof a?.etag=="string"&&a.etag!==y.$El&&a.etag===t.etag)throw new y.$wl((0,d.localize)(13,null),t,a);return this.L(i,t.size,a),t}L(i,a,t){if(typeof t?.limits?.size=="number"&&a>t.limits.size)throw new y.$vl((0,d.localize)(14,null,this.sb(i)),y.FileOperationResult.FILE_TOO_LARGE,a,t)}async canMove(i,a,t){return this.M(i,a,"move",t)}async canCopy(i,a,t){return this.M(i,a,"copy",t)}async M(i,a,t,n){if(i.toString()!==a.toString())try{const o=t==="move"?this.qb(await this.n(i),i):await this.m(i),h=this.qb(await this.n(a),a);await this.Q(o,i,h,a,t,n)}catch(o){return o}return!0}async move(i,a,t){const n=this.qb(await this.n(i),i),o=this.qb(await this.n(a),a),h=await this.N(n,i,o,a,"move",!!t),g=await this.resolve(a,{resolveMetadata:!0});return this.r.fire(new y.$rl(i,h==="move"?y.FileOperation.MOVE:y.FileOperation.COPY,g)),g}async copy(i,a,t){const n=await this.m(i),o=this.qb(await this.n(a),a),h=await this.N(n,i,o,a,"copy",!!t),g=await this.resolve(a,{resolveMetadata:!0});return this.r.fire(new y.$rl(i,h==="copy"?y.FileOperation.COPY:y.FileOperation.MOVE,g)),g}async N(i,a,t,n,o,h){if(a.toString()===n.toString())return o;const{exists:g,isSameResourceWithDifferentPathCase:R}=await this.Q(i,a,t,n,o,h);if(g&&!R&&h&&await this.del(n,{recursive:!0}),await this.U(t,this.R(t).providerExtUri.dirname(n)),o==="copy"){if(i===t&&(0,y.$dl)(i))await i.copy(a,n,{overwrite:h});else{const L=await this.resolve(a);L.isDirectory?await this.P(i,L,t,n):await this.O(i,a,t,n)}return o}else return i===t?(await i.rename(a,n,{overwrite:h}),o):(await this.N(i,a,t,n,"copy",h),await this.del(a,{recursive:!0}),"copy")}async O(i,a,t,n){if((0,y.$fl)(i)&&(0,y.$fl)(t))return this.jb(i,a,t,n);if((0,y.$fl)(i)&&(0,y.$cl)(t))return this.pb(i,a,t,n);if((0,y.$cl)(i)&&(0,y.$fl)(t))return this.nb(i,a,t,n);if((0,y.$cl)(i)&&(0,y.$cl)(t))return this.lb(i,a,t,n)}async P(i,a,t,n){await t.mkdir(n),Array.isArray(a.children)&&await c.Promises.settled(a.children.map(async o=>{const h=this.R(t).providerExtUri.joinPath(n,o.name);return o.isDirectory?this.P(i,await this.resolve(o.resource),t,h):this.O(i,o.resource,t,h)}))}async Q(i,a,t,n,o,h){let g=!1;if(i===t){const{providerExtUri:L,isPathCaseSensitive:S}=this.R(i);if(S||(g=L.isEqual(a,n)),g&&o==="copy")throw new Error((0,d.localize)(15,null,this.sb(a),this.sb(n)));if(!g&&L.isEqualOrParent(n,a))throw new Error((0,d.localize)(16,null,this.sb(a),this.sb(n)))}const R=await this.exists(n);if(R&&!g){if(!h)throw new y.$ul((0,d.localize)(17,null,this.sb(a),this.sb(n)),y.FileOperationResult.FILE_MOVE_CONFLICT);if(i===t){const{providerExtUri:L}=this.R(i);if(L.isEqualOrParent(a,n))throw new Error((0,d.localize)(18,null,this.sb(a),this.sb(n)))}}return{exists:R,isSameResourceWithDifferentPathCase:g}}R(i){const a=this.S(i);return{providerExtUri:a?p.$9g:p.$$g,isPathCaseSensitive:a}}S(i){return!!(i.capabilities&y.FileSystemProviderCapabilities.PathCaseSensitive)}async createFolder(i){const a=this.qb(await this.j(i),i);await this.U(a,i);const t=await this.resolve(i,{resolveMetadata:!0});return this.r.fire(new y.$rl(i,y.FileOperation.CREATE,t)),t}async U(i,a){const t=[],{providerExtUri:n}=this.R(i);for(;!n.isEqual(a,n.dirname(a));)try{if(!((await i.stat(a)).type&y.FileType.Directory))throw new Error((0,d.localize)(19,null,this.sb(a)));break}catch(o){if((0,y.$pl)(o)!==y.FileSystemProviderErrorCode.FileNotFound)throw o;t.push(n.basename(a)),a=n.dirname(a)}for(let o=t.length-1;o>=0;o--){a=n.joinPath(a,t[o]);try{await i.mkdir(a)}catch(h){if((0,y.$pl)(h)!==y.FileSystemProviderErrorCode.FileExists)throw h}}}async canDelete(i,a){try{await this.W(i,a)}catch(t){return t}return!0}async W(i,a){const t=this.qb(await this.j(i),i),n=!!a?.useTrash;if(n&&!(t.capabilities&y.FileSystemProviderCapabilities.Trash))throw new Error((0,d.localize)(20,null,this.sb(i)));const o=a?.atomic;if(o&&!(t.capabilities&y.FileSystemProviderCapabilities.FileAtomicDelete))throw new Error((0,d.localize)(21,null,this.sb(i)));if(n&&o)throw new Error((0,d.localize)(22,null,this.sb(i)));let h;try{h=await t.stat(i)}catch{}if(h)this.rb(i,h);else throw new y.$ul((0,d.localize)(23,null,this.sb(i)),y.FileOperationResult.FILE_NOT_FOUND);if(!!!a?.recursive){const R=await this.resolve(i);if(R.isDirectory&&Array.isArray(R.children)&&R.children.length>0)throw new Error((0,d.localize)(24,null,this.sb(i)))}return t}async del(i,a){const t=await this.W(i,a);let n=a;if((0,y.$jl)(t)&&!n?.atomic){const R=t.enforceAtomicDelete?.(i);R&&(n={...a,atomic:R})}const o=!!n?.useTrash,h=!!n?.recursive,g=n?.atomic??!1;await t.delete(i,{recursive:h,useTrash:o,atomic:g}),this.r.fire(new y.$rl(i,y.FileOperation.DELETE))}async cloneFile(i,a){const t=await this.j(i),n=this.qb(await this.n(a),a);if(!(t===n&&this.R(t).providerExtUri.isEqual(i,a)))return t===n&&(0,y.$el)(t)?t.cloneFile(i,a):(await this.U(n,this.R(n).providerExtUri.dirname(a)),t===n&&(0,y.$dl)(t)?this.cb.queueFor(i,()=>t.copy(i,a,{overwrite:!0}),this.R(t).providerExtUri):this.cb.queueFor(i,()=>this.O(t,i,n,a),this.R(t).providerExtUri))}static{this.ab=0}createWatcher(i,a){return this.watch(i,{...a,correlationId:m.ab++})}watch(i,a={recursive:!1,excludes:[]}){const t=new w.$Vc;let n=!1,o=()=>{n=!0};t.add((0,w.$Uc)(()=>o())),(async()=>{try{const g=await this.bb(i,a);n?(0,w.$Rc)(g):o=()=>(0,w.$Rc)(g)}catch(g){this.b.error(g)}})();const h=a.correlationId;if(typeof h=="number"){const g=t.add(new T.$me);return t.add(this.X.event(L=>{L.correlates(h)&&g.fire(L)})),{onDidChange:g.event,dispose:()=>t.dispose()}}return t}async bb(i,a){const t=await this.j(i),n=(0,k.$tj)([this.R(t).providerExtUri.getComparisonKey(i),a]);let o=this.$.get(n);return o||(o={count:0,disposable:t.watch(i,a)},this.$.set(n,o)),o.count+=1,(0,w.$Uc)(()=>{o&&(o.count--,o.count===0&&((0,w.$Rc)(o.disposable),this.$.delete(n)))})}dispose(){super.dispose();for(const[,i]of this.$)(0,w.$Rc)(i.disposable);this.$.clear()}async db(i,a,t,n){return this.cb.queueFor(a,async()=>{const o=await i.open(a,{create:!0,unlock:t?.unlock??!1});try{(0,l.$Ae)(n)||(0,l.$Be)(n)?await this.eb(i,o,n):await this.fb(i,o,n)}catch(h){throw(0,y.$nl)(h)}finally{await i.close(o)}},this.R(i).providerExtUri)}async eb(i,a,t){let n=0,o;if((0,l.$Be)(t)){if(t.buffer.length>0){const h=N.$Oe.concat(t.buffer);await this.gb(i,a,h,h.byteLength,n,0),n+=h.byteLength}if(t.ended)return;o=t.stream}else o=t;return new Promise((h,g)=>{(0,l.$Ge)(o,{onData:async R=>{o.pause();try{await this.gb(i,a,R,R.byteLength,n,0)}catch(L){return g(L)}n+=R.byteLength,setTimeout(()=>o.resume())},onError:R=>g(R),onEnd:()=>h()})})}async fb(i,a,t){let n=0,o;for(;(o=t.read())!==null;)await this.gb(i,a,o,o.byteLength,n,0),n+=o.byteLength}async gb(i,a,t,n,o,h){let g=0;for(;g<n;){const R=await i.write(a,o+g,t.buffer,h+g,n-g);g+=R}}async hb(i,a,t,n){return this.cb.queueFor(a,()=>this.ib(i,a,t,n),this.R(i).providerExtUri)}async ib(i,a,t,n){let o;n instanceof N.$Oe?o=n:(0,l.$Ae)(n)?o=await(0,N.$1e)(n):(0,l.$Be)(n)?o=await(0,N.$2e)(n):o=(0,N.$Ye)(n),await i.writeFile(a,o.buffer,{create:!0,overwrite:!0,unlock:t?.unlock??!1,atomic:t?.atomic??!1})}async jb(i,a,t,n){return this.cb.queueFor(n,()=>this.kb(i,a,t,n),this.R(t).providerExtUri)}async kb(i,a,t,n){let o,h;try{o=await i.open(a,{create:!1}),h=await t.open(n,{create:!0,unlock:!1});const g=N.$Oe.alloc(this.a);let R=0,L=0,S=0;do S=await i.read(o,R,g.buffer,L,g.byteLength-L),await this.gb(t,h,g,S,R,L),R+=S,L+=S,L===g.byteLength&&(L=0);while(S>0)}catch(g){throw(0,y.$nl)(g)}finally{await c.Promises.settled([typeof o=="number"?i.close(o):Promise.resolve(),typeof h=="number"?t.close(h):Promise.resolve()])}}async lb(i,a,t,n){return this.cb.queueFor(n,()=>this.mb(i,a,t,n),this.R(t).providerExtUri)}async mb(i,a,t,n){return t.writeFile(n,await i.readFile(a),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async nb(i,a,t,n){return this.cb.queueFor(n,()=>this.ob(i,a,t,n),this.R(t).providerExtUri)}async ob(i,a,t,n){const o=await t.open(n,{create:!0,unlock:!1});try{const h=await i.readFile(a);await this.gb(t,o,N.$Oe.wrap(h),h.byteLength,0,0)}catch(h){throw(0,y.$nl)(h)}finally{await t.close(o)}}async pb(i,a,t,n){const o=await(0,N.$1e)(this.H(i,a,O.CancellationToken.None));await this.hb(t,n,void 0,o)}qb(i,a){if(i.capabilities&y.FileSystemProviderCapabilities.Readonly)throw new y.$ul((0,d.localize)(25,null,this.sb(a)),y.FileOperationResult.FILE_PERMISSION_DENIED);return i}rb(i,a){if((a.permissions??0)&y.FilePermission.Readonly)throw new y.$ul((0,d.localize)(26,null,this.sb(i)),y.FileOperationResult.FILE_PERMISSION_DENIED)}sb(i){return i.scheme===$.Schemas.file?i.fsPath:i.toString(!0)}};e.$Vq=s,e.$Vq=s=m=ve([Y(0,b.$_j)],s)}),define(ce[210],le([0,1,6,35,15,3,42,2,14,5,21,51,31,172,7,100,208,205,204]),function(ne,e,P,c,N,O,T,k,A,w,E,$,u,p,l,d,y,f,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mr=void 0;class I extends y.$8q{static{this.L=!1}constructor(s,r){super(s,r),this.onDidChangeCapabilities=O.Event.None,this.P=new c.$Cc(i=>E.$0g.getComparisonKey(i)),this.X=new Map,this.Y=new Map,this.Z=new Map}get capabilities(){return this.M||(this.M=l.FileSystemProviderCapabilities.FileReadWrite|l.FileSystemProviderCapabilities.FileOpenReadWriteClose|l.FileSystemProviderCapabilities.FileReadStream|l.FileSystemProviderCapabilities.FileFolderCopy|l.FileSystemProviderCapabilities.FileWriteUnlock|l.FileSystemProviderCapabilities.FileAtomicRead|l.FileSystemProviderCapabilities.FileAtomicWrite|l.FileSystemProviderCapabilities.FileAtomicDelete|l.FileSystemProviderCapabilities.FileClone,w.$k&&(this.M|=l.FileSystemProviderCapabilities.PathCaseSensitive)),this.M}async stat(s){try{const{stat:r,symbolicLink:i}=await u.SymlinkSupport.stat(this.I(s));return{type:this.O(r,i),ctime:r.birthtime.getTime(),mtime:r.mtime.getTime(),size:r.size,permissions:r.mode&128?void 0:l.FilePermission.Locked}}catch(r){throw this.hb(r)}}async N(s){try{return await this.stat(s)}catch{return}}async readdir(s){try{const r=await u.Promises.readdir(this.I(s),{withFileTypes:!0}),i=[];return await Promise.all(r.map(async a=>{try{let t;a.isSymbolicLink()?t=(await this.stat((0,E.$gh)(s,a.name))).type:t=this.O(a),i.push([a.name,t])}catch(t){this.a.trace(t)}})),i}catch(r){throw this.hb(r)}}O(s,r){let i;return r?.dangling?i=l.FileType.Unknown:s.isFile()?i=l.FileType.File:s.isDirectory()?i=l.FileType.Directory:i=l.FileType.Unknown,r&&(i|=l.FileType.SymbolicLink),i}async Q(s){const r=this.I(s);this.R(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${r})`);let i;for(;i=this.P.get(s);)this.R(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${r})`),await i.wait();const a=new P.$Eh;return this.P.set(s,a),this.R(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${r})`),(0,k.$Uc)(()=>{this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${r})`),this.P.get(s)===a&&(this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${r})`),this.P.delete(s)),this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${r})`),a.open()})}async readFile(s,r){let i;try{r?.atomic&&(this.R(`[Disk FileSystemProvider]: atomic read operation started (${this.I(s)})`),i=await this.Q(s));const a=this.I(s);return await u.Promises.readFile(a)}catch(a){throw this.hb(a)}finally{i?.dispose()}}R(s){I.L&&this.a.trace(s)}readFileStream(s,r,i){const a=(0,$.$Ce)(t=>N.$Oe.concat(t.map(n=>N.$Oe.wrap(n))).buffer);return(0,d.$Uq)(this,s,a,t=>t.buffer,{...r,bufferSize:256*1024},i),a}async writeFile(s,r,i){return i?.atomic!==!1&&i?.atomic?.postfix&&await this.S(s)?this.U(s,(0,E.$gh)((0,E.$fh)(s),`${(0,E.$dh)(s)}${i.atomic.postfix}`),r,i):this.W(s,r,i)}async S(s){try{const r=this.I(s),{symbolicLink:i}=await u.SymlinkSupport.stat(r);if(i)return!1}catch{}return!0}async U(s,r,i,a){const t=new k.$Vc;try{t.add(await this.Q(s)),t.add(await this.Q(r)),await this.W(r,i,a,!0);try{await this.rename(r,s,{overwrite:!0})}catch(n){try{await this.delete(r,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw n}}finally{t.dispose()}}async W(s,r,i,a){let t;try{const n=this.I(s);if(!i.create||!i.overwrite){if(await u.Promises.exists(n)){if(!i.overwrite)throw(0,l.$ml)((0,p.localize)(0,null),l.FileSystemProviderErrorCode.FileExists)}else if(!i.create)throw(0,l.$ml)((0,p.localize)(1,null),l.FileSystemProviderErrorCode.FileNotFound)}t=await this.open(s,{create:!0,unlock:i.unlock},a),await this.write(t,0,r,0,r.byteLength)}catch(n){throw await this.ib(s,n)}finally{typeof t=="number"&&await this.close(t)}}static{this.$=!0}static configureFlushOnWrite(s){I.$=s}async open(s,r,i){const a=this.I(s);let t;(0,l.$al)(r)&&!i&&(t=await this.Q(s));let n;try{if((0,l.$al)(r)&&r.unlock)try{const{stat:h}=await u.SymlinkSupport.stat(a);h.mode&128||await u.Promises.chmod(a,h.mode|128)}catch(h){h.code!=="ENOENT"&&this.a.trace(h)}let o;if((0,l.$al)(r)){if(w.$i)try{await u.Promises.truncate(a,0),o="r+"}catch(h){h.code!=="ENOENT"&&this.a.trace(h)}o||(o="w")}else o="r";n=await u.Promises.open(a,o)}catch(o){throw t?.dispose(),(0,l.$al)(r)?await this.ib(s,o):this.hb(o)}if(this.X.set(n,0),(0,l.$al)(r)&&this.Z.set(n,s),t){const o=this.Y.get(n);this.R(`[Disk FileSystemProvider]: open() - storing lock for handle ${n} (${a})`),this.Y.set(n,t),o&&(this.R(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${n} (${a})`),o.dispose())}return n}async close(s){const r=this.Y.get(s);try{if(this.X.delete(s),this.Z.delete(s)&&I.$)try{await u.Promises.fdatasync(s)}catch(i){I.configureFlushOnWrite(!1),this.a.error(i)}return await u.Promises.close(s)}catch(i){throw this.hb(i)}finally{r&&(this.Y.get(s)===r&&(this.R(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${s}`),this.Y.delete(s)),this.R(`[Disk FileSystemProvider]: close() - disposing lock for handle ${s}`),r.dispose())}}async read(s,r,i,a,t){const n=this.ab(s,r);let o=null;try{o=(await u.Promises.read(s,i,a,t,n)).bytesRead}catch(h){throw this.hb(h)}finally{this.bb(s,n,o)}return o}ab(s,r){return r===this.X.get(s)?null:r}bb(s,r,i){const a=this.X.get(s);typeof a=="number"&&(typeof r=="number"||(typeof i=="number"?this.X.set(s,a+i):this.X.delete(s)))}async write(s,r,i,a,t){return(0,P.$Zh)(()=>this.cb(s,r,i,a,t),100,3)}async cb(s,r,i,a,t){const n=this.ab(s,r);let o=null;try{o=(await u.Promises.write(s,i,a,t,n)).bytesWritten}catch(h){throw await this.ib(this.Z.get(s),h)}finally{this.bb(s,n,o)}return o}async mkdir(s){try{await u.Promises.mkdir(this.I(s))}catch(r){throw this.hb(r)}}async delete(s,r){try{const i=this.I(s);if(r.recursive){let a;r?.atomic!==!1&&r.atomic.postfix&&(a=(0,A.$lc)((0,A.$oc)(i),`${(0,A.$pc)(i)}${r.atomic.postfix}`)),await u.Promises.rm(i,u.RimRafMode.MOVE,a)}else try{await u.Promises.unlink(i)}catch(a){if(a.code==="EPERM"||a.code==="EISDIR"){let t=!1;try{const{stat:n,symbolicLink:o}=await u.SymlinkSupport.stat(i);t=n.isDirectory()&&!o}catch{}if(t)await u.Promises.rmdir(i);else throw a}else throw a}}catch(i){throw this.hb(i)}}async rename(s,r,i){const a=this.I(s),t=this.I(r);if(a!==t)try{await this.db(s,r,"move",i.overwrite),await u.Promises.rename(a,t)}catch(n){throw(n.code==="EINVAL"||n.code==="EBUSY"||n.code==="ENAMETOOLONG")&&(n=new Error((0,p.localize)(2,null,(0,A.$pc)(a),(0,A.$pc)((0,A.$oc)(t)),n.toString()))),this.hb(n)}}async copy(s,r,i){const a=this.I(s),t=this.I(r);if(a!==t)try{await this.db(s,r,"copy",i.overwrite),await u.Promises.copy(a,t,{preserveSymlinks:!0})}catch(n){throw(n.code==="EINVAL"||n.code==="EBUSY"||n.code==="ENAMETOOLONG")&&(n=new Error((0,p.localize)(3,null,(0,A.$pc)(a),(0,A.$pc)((0,A.$oc)(t)),n.toString()))),this.hb(n)}}async db(s,r,i,a){const t=this.I(s),n=this.I(r);let o=!1;if(!!(this.capabilities&l.FileSystemProviderCapabilities.PathCaseSensitive)||(o=(0,T.$Dg)(t,n,!0)),o){if(i==="copy")throw(0,l.$ml)((0,p.localize)(4,null),l.FileSystemProviderErrorCode.FileExists);if(i==="move")return}const g=await this.N(s);if(!g)throw(0,l.$ml)((0,p.localize)(5,null),l.FileSystemProviderErrorCode.FileNotFound);const R=await this.N(r);if(R){if(!a)throw(0,l.$ml)((0,p.localize)(6,null),l.FileSystemProviderErrorCode.FileExists);g.type&l.FileType.File&&R.type&l.FileType.File||await this.delete(r,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(s,r){return this.eb(s,r,!1)}async eb(s,r,i){const a=this.I(s),t=this.I(r),n=!!(this.capabilities&l.FileSystemProviderCapabilities.PathCaseSensitive);if((0,T.$Dg)(a,t,!n))return;const o=new k.$Vc;try{o.add(await this.Q(s)),o.add(await this.Q(r)),i&&await u.Promises.mkdir((0,A.$oc)(t),{recursive:!0}),await u.Promises.copyFile(a,t)}catch(h){if(h.code==="ENOENT"&&!i)return this.eb(s,r,!0);throw this.hb(h)}finally{o.dispose()}}t(s,r,i){return new f.$cr(a=>s(a),a=>r(a),i)}F(s,r,i){return new b.$lr(a=>s(a),a=>r(a),i)}hb(s){if(s instanceof l.$ll)return s;let r=s,i;switch(s.code){case"ENOENT":i=l.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":i=l.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":i=l.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":i=l.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":i=l.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":r=`${s.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,i=l.FileSystemProviderErrorCode.Unknown;break;default:i=l.FileSystemProviderErrorCode.Unknown}return(0,l.$ml)(r,i)}async ib(s,r){let i=this.hb(r);if(s&&i.code===l.FileSystemProviderErrorCode.NoPermissions)try{const{stat:a}=await u.SymlinkSupport.stat(this.I(s));a.mode&128||(i=(0,l.$ml)(r,l.FileSystemProviderErrorCode.FileWriteLocked))}catch(a){this.a.trace(a)}return i}}e.$mr=I}),define(ce[102],le([0,1,3,2,4,10]),function(ne,e,P,c,N,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$chc=e.$bhc=void 0,e.$bhc=(0,N.$Fi)("sharedProcessLifecycleService");let T=class extends c.$Wc{constructor(A){super(),this.b=A,this.a=this.B(new P.$me),this.onWillShutdown=this.a.event}fireOnWillShutdown(){this.b.trace("Lifecycle#onWillShutdown.fire()"),this.a.fire()}};e.$chc=T,e.$chc=T=ve([Y(0,O.$_j)],T)}),define(ce[211],le([0,1,9,3,10,2]),function(ne,e,P,c,N,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$os=e.$ns=e.$ms=void 0;class T extends N.$kk{constructor($,u,p,l,d){super(u,p,l),this.r=$,this.t=d,this.B(d.listen("onDidChangeLogLevel",$)(y=>{(0,N.$bk)(y)?super.setLogLevel(y):super.setLogLevel(P.URI.revive(y[0]),y[1])})),this.B(d.listen("onDidChangeVisibility",$)(([y,f])=>super.setVisibility(P.URI.revive(y),f))),this.B(d.listen("onDidChangeLoggers",$)(({added:y,removed:f})=>{for(const b of y)super.registerLogger({...b,resource:P.URI.revive(b.resource)});for(const b of f)super.deregisterLogger(b.resource)}))}createConsoleMainLogger(){return new N.$ik({log:($,u)=>{this.t.call("consoleLog",[$,u])}})}registerLogger($){super.registerLogger($),this.t.call("registerLogger",[$,this.r])}deregisterLogger($){super.deregisterLogger($),this.t.call("deregisterLogger",[$,this.r])}setLogLevel($,u){super.setLogLevel($,u),this.t.call("setLogLevel",[$,u])}setVisibility($,u){super.setVisibility($,u),this.t.call("setVisibility",[this.n($),u])}s($,u,p){return new k(this.t,$,u,p,this.r)}static setLogLevel($,u,p){return $.call("setLogLevel",[u,p])}}e.$ms=T;class k extends N.$fk{constructor($,u,p,l,d){super(l?.logLevel==="always"),this.r=$,this.s=u,this.m=!1,this.n=[],this.setLevel(p),this.r.call("createLogger",[u,l,d]).then(()=>{this.u(this.n),this.m=!0})}g($,u){const p=[[$,u]];this.m?this.u(p):this.n.push(...p)}u($){this.r.call("log",[this.s,$])}}class A{constructor($,u){this.a=$,this.b=u}listen($,u){const p=this.b($);switch(u){case"onDidChangeLoggers":return c.Event.map(this.a.onDidChangeLoggers,l=>({added:[...l.added].map(d=>this.c(d,p)),removed:[...l.removed].map(d=>this.c(d,p))}));case"onDidChangeVisibility":return c.Event.map(this.a.onDidChangeVisibility,l=>[p.transformOutgoingURI(l[0]),l[1]]);case"onDidChangeLogLevel":return c.Event.map(this.a.onDidChangeLogLevel,l=>(0,N.$bk)(l)?l:[p.transformOutgoingURI(l[0]),l[1]])}throw new Error(`Event not found: ${u}`)}async call($,u,p){const l=this.b($);switch(u){case"setLogLevel":return(0,N.$bk)(p[0])?this.a.setLogLevel(p[0]):this.a.setLogLevel(P.URI.revive(l.transformIncoming(p[0][0])),p[0][1]);case"getRegisteredLoggers":return Promise.resolve([...this.a.getRegisteredLoggers()].map(d=>this.c(d,l)))}throw new Error(`Call not found: ${u}`)}c($,u){return{...$,resource:u.transformOutgoingURI($.resource)}}}e.$ns=A;class w extends O.$Wc{constructor($,u){super(),u.call("setLogLevel",[$.getLogLevel()]),this.B($.onDidChangeLogLevel(p=>u.call("setLogLevel",[p]))),u.call("getRegisteredLoggers").then(p=>{for(const l of p)$.registerLogger({...l,resource:P.URI.revive(l.resource)})}),this.B(u.listen("onDidChangeVisibility")(([p,l])=>$.setVisibility(P.URI.revive(p),l))),this.B(u.listen("onDidChangeLoggers")(({added:p,removed:l})=>{for(const d of p)$.registerLogger({...d,resource:P.URI.revive(d.resource)});for(const d of l)$.deregisterLogger(d.resource)}))}}e.$os=w}),define(ce[212],le([0,1,2,10]),function(ne,e,P,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lR=void 0;class N extends P.$Wc{constructor(T,k=[]){super(),this.a=new c.$jk([T,...k]),this.B(T.onDidChangeLogLevel(A=>this.setLevel(A)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(T){this.a.setLevel(T)}getLevel(){return this.a.getLevel()}trace(T,...k){this.a.trace(T,...k)}debug(T,...k){this.a.debug(T,...k)}info(T,...k){this.a.info(T,...k)}warn(T,...k){this.a.warn(T,...k)}error(T,...k){this.a.error(T,...k)}flush(){this.a.flush()}}e.$lR=N}),define(ce[59],le([0,1,4]),function(ne,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dfc=void 0,e.$dfc=(0,P.$Fi)("nativeHostService")}),define(ce[213],le([0,1,43,58]),function(ne,e,P,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xgc=void 0;let N=class{constructor(T,k){return this.windowId=T,P.ProxyChannel.toService(k.getChannel("nativeHost"),{context:T,properties:(()=>{const A=new Map;return A.set("windowId",T),A})()})}};e.$xgc=N,e.$xgc=N=ve([Y(1,c.$ugc)],N)}),define(ce[60],le([0,1,3,63,2,4]),function(ne,e,P,c,N,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$so=e.$ro=e.$qo=void 0,e.$qo=(0,O.$Fi)("policy");class T extends N.$Wc{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new P.$me),this.onDidChange=this.h.event}async updatePolicyDefinitions(w){const E=Object.keys(this.f).length;return this.f={...w,...this.f},E!==Object.keys(this.f).length&&await this.j(w),c.Iterable.reduce(this.g.entries(),($,[u,p])=>({...$,[u]:p}),{})}getPolicyValue(w){return this.g.get(w)}serialize(){return c.Iterable.reduce(Object.entries(this.f),(w,[E,$])=>({...w,[E]:{definition:$,value:this.g.get(E)}}),{})}}e.$ro=T;class k{constructor(){this.onDidChange=P.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.$so=k}),define(ce[214],le([0,1,3,2,60]),function(ne,e,P,c,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2fc=e.$1fc=void 0;class O{constructor(A){this.b=A,this.a=new c.$Vc}listen(A,w){switch(w){case"onDidChange":return P.Event.map(this.b.onDidChange,E=>E.reduce(($,u)=>({...$,[u]:this.b.getPolicyValue(u)??null}),{}),this.a)}throw new Error(`Event not found: ${w}`)}call(A,w,E){switch(w){case"updatePolicyDefinitions":return this.b.updatePolicyDefinitions(E)}throw new Error(`Call not found: ${w}`)}dispose(){this.a.dispose()}}e.$1fc=O;class T extends N.$ro{constructor(A,w){super(),this.a=w;for(const E in A){const{definition:$,value:u}=A[E];this.f[E]=$,u!==void 0&&this.g.set(E,u)}this.a.listen("onDidChange")(E=>{for(const $ in E){const u=E[$];u===null?this.g.delete($):this.g.set($,u)}this.h.fire(Object.keys(E))})}async j(A){const w=await this.a.call("updatePolicyDefinitions",A);for(const E in w)this.g.set(E,w[E])}}e.$2fc=T}),define(ce[103],le([0,1,36]),function(ne,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let c;const N=globalThis.vscode;if(typeof N<"u"&&typeof N.context<"u"){const O=N.context.configuration();if(O)c=O.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(c=globalThis._VSCODE_PRODUCT_JSON,P.env.VSCODE_DEV&&Object.assign(c,{nameShort:`${c.nameShort} Dev`,nameLong:`${c.nameLong} Dev`,dataFolderName:`${c.dataFolderName}-dev`,serverDataFolderName:c.serverDataFolderName?`${c.serverDataFolderName}-dev`:void 0}),!c.version){const O=globalThis._VSCODE_PACKAGE_JSON;Object.assign(c,{version:O.version})}}else c={},Object.keys(c).length===0&&Object.assign(c,{version:"1.91.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=c}),define(ce[24],le([0,1,4]),function(ne,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tk=e.$sk=void 0,e.$sk=(0,P.$Fi)("productService"),e.$tk="vscode://schemas/vscode-product"}),define(ce[215],le([0,1,6,8,2,14,31,10,24]),function(ne,e,P,c,N,O,T,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lgc=void 0;let w=class extends N.$Wc{constructor($,u,p){super(),this.b=u,this.c=p,this.a=this.b.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,$&&this.B(new P.$Rh(()=>{this.f($)},3e4)).schedule()}async f($){this.c.trace("[code cache cleanup]: Starting to clean up old code cache folders.");try{const u=Date.now(),p=(0,O.$oc)($),l=(0,O.$pc)($),d=await T.Promises.readdir(p);await Promise.all(d.map(async y=>{if(y===l)return;const f=(0,O.$lc)(p,y),b=await T.Promises.stat(f);if(b.isDirectory()&&u-b.mtime.getTime()>this.a)return this.c.trace(`[code cache cleanup]: Removing code cache folder ${y}.`),T.Promises.rm(f)}))}catch(u){(0,c.$3)(u)}}};e.$Lgc=w,e.$Lgc=w=ve([Y(1,A.$sk),Y(2,k.$_j)],w)}),define(ce[216],le([0,1,6,8,2,14,31,16,10,24]),function(ne,e,P,c,N,O,T,k,A,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mgc=void 0;let E=class extends N.$Wc{constructor(u,p,l){super(),this.b=u,this.c=p,this.f=l,this.a=this.f.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,this.b.isBuilt&&this.B(new P.$Rh(()=>{this.g()},4e4)).schedule()}async g(){this.c.trace("[language pack cache cleanup]: Starting to clean up unused language packs.");try{const u=Object.create(null),p=JSON.parse(await T.Promises.readFile((0,O.$lc)(this.b.userDataPath,"languagepacks.json"),"utf8"));for(const b of Object.keys(p)){const I=p[b];u[`${I.hash}.${b}`]=!0}const l=(0,O.$lc)(this.b.userDataPath,"clp");if(!await T.Promises.exists(l))return;const y=await T.Promises.readdir(l);for(const b of y){if(u[b]){this.c.trace(`[language pack cache cleanup]: Skipping folder ${b}. Language pack still in use.`);continue}this.c.trace(`[language pack cache cleanup]: Removing unused language pack: ${b}`),await T.Promises.rm((0,O.$lc)(l,b))}const f=Date.now();for(const b of Object.keys(u)){const I=(0,O.$lc)(l,b),m=await T.Promises.readdir(I);for(const s of m){if(s==="tcf.json")continue;const r=(0,O.$lc)(I,s),i=await T.Promises.stat(r);i.isDirectory()&&f-i.mtime.getTime()>this.a&&(this.c.trace(`[language pack cache cleanup]: Removing language pack cache folder: ${(0,O.$lc)(b,s)}`),await T.Promises.rm(r))}}}catch(u){(0,c.$3)(u)}}};e.$Mgc=E,e.$Mgc=E=ve([Y(0,k.$Ni),Y(1,A.$_j),Y(2,w.$sk)],E)}),define(ce[217],le([0,1,14,4]),function(ne,e,P,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Utils=e.$JG=void 0,e.$JG=(0,c.$Fi)("IV8InspectProfilingService");var N;(function(O){function T(A){return!!(A.samples&&A.timeDeltas)}O.isValidProfile=T;function k(A,w="noAbsolutePaths"){for(const E of A.nodes)E.callFrame&&E.callFrame.url&&((0,P.$kc)(E.callFrame.url)||/^\w[\w\d+.-]*:\/\/\/?/.test(E.callFrame.url))&&(E.callFrame.url=(0,P.$lc)(w,(0,P.$pc)(E.callFrame.url)));return A}O.rewriteAbsolutePaths=k})(N||(e.Utils=N={}))}),define(ce[218],le([0,1,32]),function(ne,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4gc=void 0;class c{constructor(){this.a=new Map}async startProfiling(O){const k=await(await new Promise((w,E)=>{ne(["v8-inspect-profiler"],w,E)}).then(Oe)).startProfiling({host:O.host,port:O.port,checkForPaused:!0}),A=(0,P.$2g)();return this.a.set(A,k),A}async stopProfiling(O){const T=this.a.get(O);if(!T)throw new Error(`UNKNOWN session '${O}'`);const k=await T.stop();return this.a.delete(O),k.profile}}e.$4gc=c}),define(ce[44],le([0,1,132,13]),function(ne,e,P,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oo=void 0,P=Oe(P),c=Oe(c);class N{constructor(){this.a=new Map}add(T,k){P.ok(c.$fg(T)),P.ok(c.$hg(k)),P.ok(!this.a.has(T),"There is already an extension with this id"),this.a.set(T,k)}knows(T){return this.a.has(T)}as(T){return this.a.get(T)||null}}e.$oo=new N}),define(ce[104],le([0,1,3,44]),function(ne,e,P,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$po=void 0,c=Oe(c),e.$po={JSONContribution:"base.contributions.json"};function N(k){return k.length>0&&k.charAt(k.length-1)==="#"?k.substring(0,k.length-1):k}class O{constructor(){this.b=new P.$me,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(A,w){this.a[N(A)]=w,this.b.fire(A)}notifySchemaChanged(A){this.b.fire(A)}getSchemaContributions(){return{schemas:this.a}}}const T=new O;c.$oo.add(e.$po.JSONContribution,T)}),define(ce[48],le([0,1,19,3,13,159,22,104,44]),function(ne,e,P,c,N,O,T,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Do=e.$Co=e.$Bo=e.$Ao=e.$zo=e.$yo=e.$xo=e.$wo=e.$vo=e.$uo=e.ConfigurationScope=e.$to=e.EditPresentationTypes=void 0,e.$Eo=d,e.$Fo=y,e.$Go=f,e.$Ho=I,e.$Io=m,N=Oe(N),O=Oe(O);var w;(function(s){s.Multiline="multilineText",s.Singleline="singlelineText"})(w||(e.EditPresentationTypes=w={})),e.$to={Configuration:"base.contributions.configuration"};var E;(function(s){s[s.APPLICATION=1]="APPLICATION",s[s.MACHINE=2]="MACHINE",s[s.WINDOW=3]="WINDOW",s[s.RESOURCE=4]="RESOURCE",s[s.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",s[s.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(E||(e.ConfigurationScope=E={})),e.$uo={properties:{},patternProperties:{}},e.$vo={properties:{},patternProperties:{}},e.$wo={properties:{},patternProperties:{}},e.$xo={properties:{},patternProperties:{}},e.$yo={properties:{},patternProperties:{}},e.$zo={properties:{},patternProperties:{}},e.$Ao="vscode://schemas/settings/resourceLanguage",e.$Bo="vscode://schemas/settings/configurationDefaults";const $=A.$oo.as(k.$po.JSONContribution);class u{constructor(){this.h=new Set,this.i=new c.$me,this.onDidSchemaChange=this.i.event,this.j=new c.$me,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:O.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},$.registerSchema(e.$Ao,this.g),this.v()}registerConfiguration(r,i=!0){this.registerConfigurations([r],i)}registerConfigurations(r,i=!0){const a=new Set;this.n(r,i,a),$.registerSchema(e.$Ao,this.g),this.i.fire(),this.j.fire({properties:a})}deregisterConfigurations(r){const i=new Set;this.o(r,i),$.registerSchema(e.$Ao,this.g),this.i.fire(),this.j.fire({properties:i})}updateConfigurations({add:r,remove:i}){const a=new Set;this.o(i,a),this.n(r,!1,a),$.registerSchema(e.$Ao,this.g),this.i.fire(),this.j.fire({properties:a})}registerDefaultConfigurations(r){const i=new Set;this.k(r,i),this.i.fire(),this.j.fire({properties:i,defaultsOverrides:!0})}k(r,i){const a=[];for(const{overrides:t,source:n}of r)for(const o in t)if(i.add(o),e.$Do.test(o)){const h=this.a.get(o),g=h?.valuesSources??new Map;if(n)for(const v of Object.keys(t[o]))g.set(v,n);const R={...h?.value||{},...t[o]};this.a.set(o,{source:n,value:R,valuesSources:g});const L=(0,T.$jj)(o),S={type:"object",default:R,description:O.localize(1,null,L),$ref:e.$Ao,defaultDefaultValue:R,source:N.$fg(n)?void 0:n,defaultValueSource:n};a.push(...d(o)),this.d[o]=S,this.b.properties[o]=S}else{this.a.set(o,{value:t[o],source:n});const h=this.d[o];h&&(this.w(o,h),this.r(o,h))}this.m(a)}deregisterDefaultConfigurations(r){const i=new Set;this.l(r,i),this.i.fire(),this.j.fire({properties:i,defaultsOverrides:!0})}l(r,i){for(const{overrides:a,source:t}of r)for(const n in a){const o=this.a.get(n),h=N.$fg(t)?t:t?.id,g=N.$fg(o?.source)?o?.source:o?.source?.id;if(h===g)if(i.add(n),this.a.delete(n),e.$Do.test(n))delete this.d[n],delete this.b.properties[n];else{const R=this.d[n];R&&(this.w(n,R),this.r(n,R))}}this.u()}deltaConfiguration(r){let i=!1;const a=new Set;r.removedDefaults&&(this.l(r.removedDefaults,a),i=!0),r.addedDefaults&&(this.k(r.addedDefaults,a),i=!0),r.removedConfigurations&&this.o(r.removedConfigurations,a),r.addedConfigurations&&this.n(r.addedConfigurations,!1,a),this.i.fire(),this.j.fire({properties:a,defaultsOverrides:i})}notifyConfigurationSchemaUpdated(...r){this.i.fire()}registerOverrideIdentifiers(r){this.m(r),this.i.fire()}m(r){for(const i of r)this.h.add(i);this.u()}n(r,i,a){r.forEach(t=>{this.p(t,i,t.extensionInfo,t.restrictedProperties,void 0,a),this.c.push(t),this.q(t)})}o(r,i){const a=t=>{if(t.properties)for(const n in t.properties){i.add(n);const o=this.d[n];o?.policy?.name&&this.e.delete(o.policy.name),delete this.d[n],this.s(n,t.properties[n])}t.allOf?.forEach(n=>a(n))};for(const t of r){a(t);const n=this.c.indexOf(t);n!==-1&&this.c.splice(n,1)}}p(r,i=!0,a,t,n=E.WINDOW,o){n=N.$og(r.scope)?n:r.scope;const h=r.properties;if(h)for(const R in h){const L=h[R];if(i&&I(R,L)){delete h[R];continue}if(L.source=a,L.defaultDefaultValue=h[R].default,this.w(R,L),e.$Do.test(R)?L.scope=void 0:(L.scope=N.$og(L.scope)?n:L.scope,L.restricted=N.$og(L.restricted)?!!t?.includes(R):L.restricted),h[R].hasOwnProperty("included")&&!h[R].included){this.f[R]=h[R],delete h[R];continue}else this.d[R]=h[R],h[R].policy?.name&&this.e.set(h[R].policy.name,R);!h[R].deprecationMessage&&h[R].markdownDeprecationMessage&&(h[R].deprecationMessage=h[R].markdownDeprecationMessage),o.add(R)}const g=r.allOf;if(g)for(const R of g)this.p(R,i,a,t,n,o)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(r){const i=a=>{const t=a.properties;if(t)for(const o in t)this.r(o,t[o]);a.allOf?.forEach(i)};i(r)}r(r,i){switch(e.$uo.properties[r]=i,i.scope){case E.APPLICATION:e.$vo.properties[r]=i;break;case E.MACHINE:e.$wo.properties[r]=i;break;case E.MACHINE_OVERRIDABLE:e.$xo.properties[r]=i;break;case E.WINDOW:e.$yo.properties[r]=i;break;case E.RESOURCE:e.$zo.properties[r]=i;break;case E.LANGUAGE_OVERRIDABLE:e.$zo.properties[r]=i,this.g.properties[r]=i;break}}s(r,i){switch(delete e.$uo.properties[r],i.scope){case E.APPLICATION:delete e.$vo.properties[r];break;case E.MACHINE:delete e.$wo.properties[r];break;case E.MACHINE_OVERRIDABLE:delete e.$xo.properties[r];break;case E.WINDOW:delete e.$yo.properties[r];break;case E.RESOURCE:case E.LANGUAGE_OVERRIDABLE:delete e.$zo.properties[r],delete this.g.properties[r];break}}u(){for(const r of this.h.values()){const i=`[${r}]`,a={type:"object",description:O.localize(2,null),errorMessage:O.localize(3,null),$ref:e.$Ao};this.w(i,a),e.$uo.properties[i]=a,e.$vo.properties[i]=a,e.$wo.properties[i]=a,e.$xo.properties[i]=a,e.$yo.properties[i]=a,e.$zo.properties[i]=a}}v(){const r={type:"object",description:O.localize(4,null),errorMessage:O.localize(5,null),$ref:e.$Ao};e.$uo.patternProperties[e.$Co]=r,e.$vo.patternProperties[e.$Co]=r,e.$wo.patternProperties[e.$Co]=r,e.$xo.patternProperties[e.$Co]=r,e.$yo.patternProperties[e.$Co]=r,e.$zo.patternProperties[e.$Co]=r,this.i.fire()}w(r,i){const a=this.a.get(r);let t=a?.value,n=a?.source;N.$mg(t)&&(t=i.defaultDefaultValue,n=void 0),N.$mg(t)&&(t=f(i.type)),i.default=t,i.defaultValueSource=n}}const p="\\[([^\\]]+)\\]",l=new RegExp(p,"g");e.$Co=`^(${p})+$`,e.$Do=new RegExp(e.$Co);function d(s){const r=[];if(e.$Do.test(s)){let i=l.exec(s);for(;i?.length;){const a=i[1].trim();a&&r.push(a),i=l.exec(s)}}return(0,P.$Ob)(r)}function y(s){return s.reduce((r,i)=>`${r}[${i}]`,"")}function f(s){switch(Array.isArray(s)?s[0]:s){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}const b=new u;A.$oo.add(e.$to.Configuration,b);function I(s,r){return s.trim()?e.$Do.test(s)?O.localize(7,null,s):b.getConfigurationProperties()[s]!==void 0?O.localize(8,null,s):r.policy?.name&&b.getPolicyConfigurations().get(r.policy?.name)!==void 0?O.localize(9,null,s,r.policy?.name,b.getPolicyConfigurations().get(r.policy?.name)):null:O.localize(6,null)}function m(){const s=[],r=b.getConfigurationProperties();for(const i of Object.keys(r))s.push([i,r[i].scope]);return s.push(["launch",E.RESOURCE]),s.push(["task",E.RESOURCE]),s}}),define(ce[78],le([0,1,19,3,34,2,35,30,13,9,22,48,7,44]),function(ne,e,P,c,N,O,T,k,A,w,E,$,u,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oo=e.$Mo=e.$Lo=e.$Ko=e.$Jo=void 0,e.$No=m,P=Oe(P),N=Oe(N),k=Oe(k),A=Oe(A);function l(a){return Object.isFrozen(a)?a:k.$co(a)}class d{static createEmptyModel(t){return new d({},[],[],void 0,t)}constructor(t,n,o,h,g){this.b=t,this.c=n,this.d=o,this.raw=h,this.f=g,this.a=new Map}get rawConfiguration(){if(!this.g)if(this.raw?.length){const t=this.raw.map(n=>{if(n instanceof d)return n;const o=new y("",this.f);return o.parseRaw(n),o.configurationModel});this.g=t.reduce((n,o)=>o===n?o:n.merge(o),t[0])}else this.g=this;return this.g}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(t){return t?(0,E.$hj)(this.contents,t):this.contents}inspect(t,n){const o=this;return{get value(){return l(o.rawConfiguration.getValue(t))},get override(){return n?l(o.rawConfiguration.getOverrideValue(t,n)):void 0},get merged(){return l(n?o.rawConfiguration.override(n).getValue(t):o.rawConfiguration.getValue(t))},get overrides(){const h=[];for(const{contents:g,identifiers:R,keys:L}of o.rawConfiguration.overrides){const S=new d(g,L,[],void 0,o.f).getValue(t);S!==void 0&&h.push({identifiers:R,value:S})}return h.length?l(h):void 0}}}getOverrideValue(t,n){const o=this.j(n);return o?t?(0,E.$hj)(o,t):o:void 0}getKeysForOverrideIdentifier(t){const n=[];for(const o of this.overrides)o.identifiers.includes(t)&&n.push(...o.keys);return P.$Ob(n)}getAllOverrideIdentifiers(){const t=[];for(const n of this.overrides)t.push(...n.identifiers);return P.$Ob(t)}override(t){let n=this.a.get(t);return n||(n=this.h(t),this.a.set(t,n)),n}merge(...t){const n=k.$bo(this.contents),o=k.$bo(this.overrides),h=[...this.keys],g=this.raw?.length?[...this.raw]:[this];for(const R of t)if(g.push(...R.raw?.length?R.raw:[R]),!R.isEmpty()){this.i(n,R.contents);for(const L of R.overrides){const[S]=o.filter(v=>P.$wb(v.identifiers,L.identifiers));S?(this.i(S.contents,L.contents),S.keys.push(...L.keys),S.keys=P.$Ob(S.keys)):o.push(k.$bo(L))}for(const L of R.keys)h.indexOf(L)===-1&&h.push(L)}return new d(n,h,o,g.every(R=>R instanceof d)?void 0:g,this.f)}h(t){const n=this.j(t);if(!n||typeof n!="object"||!Object.keys(n).length)return this;const o={};for(const h of P.$Ob([...Object.keys(this.contents),...Object.keys(n)])){let g=this.contents[h];const R=n[h];R&&(typeof g=="object"&&typeof R=="object"?(g=k.$bo(g),this.i(g,R)):g=R),o[h]=g}return new d(o,this.keys,this.overrides,void 0,this.f)}i(t,n){for(const o of Object.keys(n)){if(o in t&&A.$hg(t[o])&&A.$hg(n[o])){this.i(t[o],n[o]);continue}t[o]=k.$bo(n[o])}}j(t){let n=null,o=null;const h=g=>{g&&(o?this.i(o,g):o=k.$bo(g))};for(const g of this.overrides)g.identifiers.length===1&&g.identifiers[0]===t?n=g.contents:g.identifiers.includes(t)&&h(g.contents);return h(n),o}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(t,n){this.k(t,n,!0)}setValue(t,n){this.k(t,n,!1)}removeValue(t){const n=this.keys.indexOf(t);n!==-1&&(this.keys.splice(n,1),(0,E.$gj)(this.contents,t),$.$Do.test(t)&&this.overrides.splice(this.overrides.findIndex(o=>P.$wb(o.identifiers,(0,$.$Eo)(t))),1))}k(t,n,o){(0,E.$fj)(this.contents,t,n,h=>this.f.error(h)),o=o||this.keys.indexOf(t)===-1,o&&this.keys.push(t),$.$Do.test(t)&&this.overrides.push({identifiers:(0,$.$Eo)(t),keys:Object.keys(this.contents[t]),contents:(0,E.$ej)(this.contents[t],h=>this.f.error(h))})}}e.$Jo=d;class y{constructor(t,n){this.f=t,this.g=n,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||d.createEmptyModel(this.g)}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(t,n){if(!A.$og(t)){const o=this.h(t);this.parseRaw(o,n)}}reparse(t){this.a&&this.parseRaw(this.a,t)}parseRaw(t,n){this.a=t;const{contents:o,keys:h,overrides:g,restricted:R,hasExcludedProperties:L}=this.i(t,n);this.b=new d(o,h,g,L?[t]:void 0,this.g),this.c=R||[]}h(t){let n={},o=null,h=[];const g=[],R=[];function L(v){Array.isArray(h)?h.push(v):o!==null&&(h[o]=v)}const S={onObjectBegin:()=>{const v={};L(v),g.push(h),h=v,o=null},onObjectProperty:v=>{o=v},onObjectEnd:()=>{h=g.pop()},onArrayBegin:()=>{const v=[];L(v),g.push(h),h=v,o=null},onArrayEnd:()=>{h=g.pop()},onLiteralValue:L,onError:(v,C,F)=>{R.push({error:v,offset:C,length:F})}};if(t)try{N.$3n(t,S),n=h[0]||{}}catch(v){this.g.error(`Error while parsing settings file ${this.f}: ${v}`),this.d=[v]}return n}i(t,n){const o=p.$oo.as($.$to.Configuration).getConfigurationProperties(),h=this.j(t,o,!0,n);t=h.raw;const g=(0,E.$ej)(t,S=>this.g.error(`Conflict in settings file ${this.f}: ${S}`)),R=Object.keys(t),L=this.l(t,S=>this.g.error(`Conflict in settings file ${this.f}: ${S}`));return{contents:g,keys:R,overrides:L,restricted:h.restricted,hasExcludedProperties:h.hasExcludedProperties}}j(t,n,o,h){let g=!1;if(!h?.scopes&&!h?.skipRestricted&&!h?.exclude?.length)return{raw:t,restricted:[],hasExcludedProperties:g};const R={},L=[];for(const S in t)if($.$Do.test(S)&&o){const v=this.j(t[S],n,!1,h);R[S]=v.raw,g=g||v.hasExcludedProperties,L.push(...v.restricted)}else{const v=n[S],C=v?typeof v.scope<"u"?v.scope:$.ConfigurationScope.WINDOW:void 0;v?.restricted&&L.push(S),!h.exclude?.includes(S)&&(h.include?.includes(S)||(C===void 0||h.scopes===void 0||h.scopes.includes(C))&&!(h.skipRestricted&&v?.restricted))?R[S]=t[S]:g=!0}return{raw:R,restricted:L,hasExcludedProperties:g}}l(t,n){const o=[];for(const h of Object.keys(t))if($.$Do.test(h)){const g={};for(const R in t[h])g[R]=t[h][R];o.push({identifiers:(0,$.$Eo)(h),keys:Object.keys(g),contents:(0,E.$ej)(g,n)})}return o}}e.$Ko=y;class f extends O.$Wc{constructor(t,n,o,h,g){super(),this.c=t,this.f=n,this.g=h,this.h=g,this.b=this.B(new c.$me),this.onDidChange=this.b.event,this.a=new y(this.c.toString(),g),this.B(this.g.watch(o.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(c.Event.any(c.Event.filter(this.g.onDidFilesChange,R=>R.contains(this.c)),c.Event.filter(this.g.onDidRunOperation,R=>(R.isOperation(u.FileOperation.CREATE)||R.isOperation(u.FileOperation.COPY)||R.isOperation(u.FileOperation.DELETE)||R.isOperation(u.FileOperation.WRITE))&&o.isEqual(R.resource,t)))(()=>this.b.fire()))}async loadConfiguration(){try{const t=await this.g.readFile(this.c);return this.a.parse(t.value.toString()||"{}",this.f),this.a.configurationModel}catch{return d.createEmptyModel(this.h)}}reparse(t){return t&&(this.f=t),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$Lo=f;class b{constructor(t,n,o,h,g,R,L,S,v,C,F,D,M){this.a=t,this.b=n,this.c=o,this.overrideIdentifiers=h,this.d=g,this.f=R,this.g=L,this.h=S,this.i=v,this.j=C,this.k=F,this.l=D,this.m=M}get value(){return l(this.c)}n(t){return t?.value!==void 0||t?.override!==void 0||t?.overrides!==void 0?t:void 0}get q(){return this.p||(this.p=this.d.inspect(this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.n(this.q)}get s(){return this.r===void 0&&(this.r=this.f?this.f.inspect(this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.g.inspect(this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.n(this.u)}get w(){return this.v||(this.v=this.h.inspect(this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.n(this.w)}get y(){return this.x||(this.x=this.i.inspect(this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.n(this.y)}get A(){return this.z||(this.z=this.j.inspect(this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.n(this.A)}get D(){return this.B===void 0&&(this.B=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.n(this.D)}get F(){return this.E===void 0&&(this.E=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.n(this.F)}get H(){return this.G===void 0&&(this.G=this.m.inspect(this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.n(this.H)}}class I{constructor(t,n,o,h,g,R,L,S,v,C){this.j=t,this.l=n,this.m=o,this.n=h,this.p=g,this.q=R,this.r=L,this.s=S,this.t=v,this.u=C,this.h=null,this.i=new T.$Cc,this.v=null}getValue(t,n,o){return this.w(t,n,o).getValue(t)}updateValue(t,n,o={}){let h;o.resource?(h=this.t.get(o.resource),h||(h=d.createEmptyModel(this.u),this.t.set(o.resource,h))):h=this.s,n===void 0?h.removeValue(t):h.setValue(t,n),o.resource||(this.h=null)}inspect(t,n,o){const h=this.w(t,n,o),g=this.A(n.resource,o),R=n.resource?this.t.get(n.resource)||this.s:this.s,L=new Set;for(const S of h.overrides)for(const v of S.identifiers)h.getOverrideValue(t,v)!==void 0&&L.add(v);return new b(t,n,h.getValue(t),L.size?[...L]:void 0,this.j,this.l.isEmpty()?void 0:this.l,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,o?this.q:void 0,g||void 0,R)}keys(t){const n=this.A(void 0,t);return{default:this.j.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.q.keys.slice(0),workspaceFolder:n?n.keys.slice(0):[]}}updateDefaultConfiguration(t){this.j=t,this.h=null,this.i.clear()}updatePolicyConfiguration(t){this.l=t}updateApplicationConfiguration(t){this.m=t,this.h=null,this.i.clear()}updateLocalUserConfiguration(t){this.n=t,this.v=null,this.h=null,this.i.clear()}updateRemoteUserConfiguration(t){this.p=t,this.v=null,this.h=null,this.i.clear()}updateWorkspaceConfiguration(t){this.q=t,this.h=null,this.i.clear()}updateFolderConfiguration(t,n){this.r.set(t,n),this.i.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this.i.delete(t)}compareAndUpdateDefaultConfiguration(t,n){const o=[];if(!n){const{added:h,updated:g,removed:R}=r(this.j,t);n=[...h,...g,...R]}for(const h of n)for(const g of(0,$.$Eo)(h)){const R=this.j.getKeysForOverrideIdentifier(g),L=t.getKeysForOverrideIdentifier(g),S=[...L.filter(v=>R.indexOf(v)===-1),...R.filter(v=>L.indexOf(v)===-1),...R.filter(v=>!k.$fo(this.j.override(g).getValue(v),t.override(g).getValue(v)))];o.push([g,S])}return this.updateDefaultConfiguration(t),{keys:n,overrides:o}}compareAndUpdatePolicyConfiguration(t){const{added:n,updated:o,removed:h}=r(this.l,t),g=[...n,...o,...h];return g.length&&this.updatePolicyConfiguration(t),{keys:g,overrides:[]}}compareAndUpdateApplicationConfiguration(t){const{added:n,updated:o,removed:h,overrides:g}=r(this.applicationConfiguration,t),R=[...n,...o,...h];return R.length&&this.updateApplicationConfiguration(t),{keys:R,overrides:g}}compareAndUpdateLocalUserConfiguration(t){const{added:n,updated:o,removed:h,overrides:g}=r(this.localUserConfiguration,t),R=[...n,...o,...h];return R.length&&this.updateLocalUserConfiguration(t),{keys:R,overrides:g}}compareAndUpdateRemoteUserConfiguration(t){const{added:n,updated:o,removed:h,overrides:g}=r(this.remoteUserConfiguration,t),R=[...n,...o,...h];return R.length&&this.updateRemoteUserConfiguration(t),{keys:R,overrides:g}}compareAndUpdateWorkspaceConfiguration(t){const{added:n,updated:o,removed:h,overrides:g}=r(this.workspaceConfiguration,t),R=[...n,...o,...h];return R.length&&this.updateWorkspaceConfiguration(t),{keys:R,overrides:g}}compareAndUpdateFolderConfiguration(t,n){const o=this.folderConfigurations.get(t),{added:h,updated:g,removed:R,overrides:L}=r(o,n),S=[...h,...g,...R];return(S.length||!o)&&this.updateFolderConfiguration(t,n),{keys:S,overrides:L}}compareAndDeleteFolderConfiguration(t){const n=this.folderConfigurations.get(t);if(!n)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:o,updated:h,removed:g,overrides:R}=r(n,void 0);return{keys:[...o,...h,...g],overrides:R}}get defaults(){return this.j}get applicationConfiguration(){return this.m}get userConfiguration(){return this.v||(this.v=this.p.isEmpty()?this.n:this.n.merge(this.p)),this.v}get localUserConfiguration(){return this.n}get remoteUserConfiguration(){return this.p}get workspaceConfiguration(){return this.q}get folderConfigurations(){return this.r}w(t,n,o){let h=this.x(n,o);return n.overrideIdentifier&&(h=h.override(n.overrideIdentifier)),!this.l.isEmpty()&&this.l.getValue(t)!==void 0&&(h=h.merge(this.l)),h}x({resource:t},n){let o=this.y();if(n&&t){const h=n.getFolder(t);h&&(o=this.z(h.uri)||o);const g=this.t.get(t);g&&(o=o.merge(g))}return o}y(){return this.h||(this.h=this.j.merge(this.applicationConfiguration,this.userConfiguration,this.q,this.s)),this.h}z(t){let n=this.i.get(t);if(!n){const o=this.y(),h=this.r.get(t);h?(n=o.merge(h),this.i.set(t,n)):n=o}return n}A(t,n){if(n&&t){const o=n.getFolder(t);if(o)return this.r.get(o.uri)}}toData(){return{defaults:{contents:this.j.contents,overrides:this.j.overrides,keys:this.j.keys},policy:{contents:this.l.contents,overrides:this.l.overrides,keys:this.l.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.q.contents,overrides:this.q.overrides,keys:this.q.keys},folders:[...this.r.keys()].reduce((t,n)=>{const{contents:o,overrides:h,keys:g}=this.r.get(n);return t.push([n,{contents:o,overrides:h,keys:g}]),t},[])}}allKeys(){const t=new Set;return this.j.keys.forEach(n=>t.add(n)),this.userConfiguration.keys.forEach(n=>t.add(n)),this.q.keys.forEach(n=>t.add(n)),this.r.forEach(n=>n.keys.forEach(o=>t.add(o))),[...t.values()]}B(){const t=new Set;return this.j.getAllOverrideIdentifiers().forEach(n=>t.add(n)),this.userConfiguration.getAllOverrideIdentifiers().forEach(n=>t.add(n)),this.q.getAllOverrideIdentifiers().forEach(n=>t.add(n)),this.r.forEach(n=>n.getAllOverrideIdentifiers().forEach(o=>t.add(o))),[...t.values()]}D(t){const n=new Set;return this.j.getKeysForOverrideIdentifier(t).forEach(o=>n.add(o)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(o=>n.add(o)),this.q.getKeysForOverrideIdentifier(t).forEach(o=>n.add(o)),this.r.forEach(o=>o.getKeysForOverrideIdentifier(t).forEach(h=>n.add(h))),[...n.values()]}static parse(t,n){const o=this.E(t.defaults,n),h=this.E(t.policy,n),g=this.E(t.application,n),R=this.E(t.user,n),L=this.E(t.workspace,n),S=t.folders.reduce((v,C)=>(v.set(w.URI.revive(C[0]),this.E(C[1],n)),v),new T.$Cc);return new I(o,h,g,R,d.createEmptyModel(n),L,S,d.createEmptyModel(n),new T.$Cc,n)}static E(t,n){return new d(t.contents,t.keys,t.overrides,void 0,n)}}e.$Mo=I;function m(...a){if(a.length===0)return{keys:[],overrides:[]};if(a.length===1)return a[0];const t=new Set,n=new Map;for(const h of a)h.keys.forEach(g=>t.add(g)),h.overrides.forEach(([g,R])=>{const L=(0,T.$zc)(n,g,new Set);R.forEach(S=>L.add(S))});const o=[];return n.forEach((h,g)=>o.push([g,[...h.values()]])),{keys:[...t.values()],overrides:o}}class s{constructor(t,n,o,h,g){this.change=t,this.f=n,this.g=o,this.h=h,this.i=g,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=46,this.affectedKeys=new Set,this.j=void 0;for(const R of t.keys)this.affectedKeys.add(R);for(const[,R]of t.overrides)for(const L of R)this.affectedKeys.add(L);this.d=this.a;for(const R of this.affectedKeys)this.d+=R+this.a}get previousConfiguration(){return!this.j&&this.f&&(this.j=I.parse(this.f.data,this.i)),this.j}affectsConfiguration(t,n){const o=this.a+t,h=this.d.indexOf(o);if(h<0)return!1;const g=h+o.length;if(g>=this.d.length)return!1;const R=this.d.charCodeAt(g);if(R!==this.b&&R!==this.c)return!1;if(n){const L=this.previousConfiguration?this.previousConfiguration.getValue(t,n,this.f?.workspace):void 0,S=this.g.getValue(t,n,this.h);return!k.$fo(L,S)}return!0}}e.$Oo=s;function r(a,t){const{added:n,removed:o,updated:h}=i(t?.rawConfiguration,a?.rawConfiguration),g=[],R=a?.getAllOverrideIdentifiers()||[],L=t?.getAllOverrideIdentifiers()||[];if(t){const S=L.filter(v=>!R.includes(v));for(const v of S)g.push([v,t.getKeysForOverrideIdentifier(v)])}if(a){const S=R.filter(v=>!L.includes(v));for(const v of S)g.push([v,a.getKeysForOverrideIdentifier(v)])}if(t&&a){for(const S of R)if(L.includes(S)){const v=i({contents:a.getOverrideValue(void 0,S)||{},keys:a.getKeysForOverrideIdentifier(S)},{contents:t.getOverrideValue(void 0,S)||{},keys:t.getKeysForOverrideIdentifier(S)});g.push([S,[...v.added,...v.removed,...v.updated]])}}return{added:n,removed:o,updated:h,overrides:g}}function i(a,t){const n=a?t?a.keys.filter(g=>t.keys.indexOf(g)===-1):[...a.keys]:[],o=t?a?t.keys.filter(g=>a.keys.indexOf(g)===-1):[...t.keys]:[],h=[];if(a&&t){for(const g of t.keys)if(a.keys.indexOf(g)!==-1){const R=(0,E.$hj)(t.contents,g),L=(0,E.$hj)(a.contents,g);k.$fo(R,L)||h.push(g)}}return{added:n,removed:o,updated:h}}}),define(ce[219],le([0,1,19,3,2,30,13,78,48,10,60,44]),function(ne,e,P,c,N,O,T,k,A,w,E,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ro=e.$Qo=e.$Po=void 0;class u extends N.$Wc{get configurationModel(){return this.b}constructor(y){super(),this.c=y,this.a=this.B(new c.$me),this.onDidChangeConfiguration=this.a.event,this.b=k.$Jo.createEmptyModel(this.c)}async initialize(){return this.h(),this.B($.$oo.as(A.$to.Configuration).onDidUpdateConfiguration(({properties:y,defaultsOverrides:f})=>this.f(Array.from(y),f))),this.configurationModel}reload(){return this.h(),this.configurationModel}f(y,f){this.j(y,$.$oo.as(A.$to.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:y})}g(){return{}}h(){this.b=k.$Jo.createEmptyModel(this.c);const y=$.$oo.as(A.$to.Configuration).getConfigurationProperties();this.j(Object.keys(y),y)}j(y,f){const b=this.g();for(const I of y){const m=b[I],s=f[I];m!==void 0?this.b.addValue(I,m):s?this.b.addValue(I,s.default):this.b.removeValue(I)}}}e.$Po=u;class p{constructor(){this.onDidChangeConfiguration=c.Event.None,this.configurationModel=k.$Jo.createEmptyModel(new w.$mk)}async initialize(){return this.configurationModel}}e.$Qo=p;let l=class extends N.$Wc{get configurationModel(){return this.b}constructor(y,f,b){super(),this.c=y,this.f=f,this.g=b,this.a=this.B(new c.$me),this.onDidChangeConfiguration=this.a.event,this.b=k.$Jo.createEmptyModel(this.g)}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.m(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(y=>this.j(y))),this.B(this.c.onDidChangeConfiguration(async({properties:y})=>this.m(await this.h(y),!0))),this.b}async h(y){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",y);const f={},b=[],I=$.$oo.as(A.$to.Configuration).getConfigurationProperties();for(const m of y){const s=I[m];if(!s){b.push(m);continue}if(s.policy){if(s.type!=="string"&&s.type!=="number"){this.g.warn(`Policy ${s.policy.name} has unsupported type ${s.type}`);continue}b.push(m),f[s.policy.name]={type:s.type}}}return(0,T.$sg)(f)||await this.f.updatePolicyDefinitions(f),b}j(y){this.g.trace("PolicyConfiguration#onDidChangePolicies",y);const f=$.$oo.as(A.$to.Configuration).getPolicyConfigurations(),b=(0,P.$Jb)(y.map(I=>f.get(I)));this.m(b,!0)}m(y,f){this.g.trace("PolicyConfiguration#update",y);const b=$.$oo.as(A.$to.Configuration).getConfigurationProperties(),I=[],m=this.b.isEmpty();for(const s of y){const r=b[s]?.policy?.name;if(r){const i=this.f.getPolicyValue(r);(m?i!==void 0:!(0,O.$fo)(this.b.getValue(s),i))&&I.push([s,i])}else this.b.getValue(s)!==void 0&&I.push([s,void 0])}if(I.length){this.g.trace("PolicyConfiguration#changed",I);const s=this.b;this.b=k.$Jo.createEmptyModel(this.g);for(const r of s.keys)this.b.setValue(r,s.getValue(r));for(const[r,i]of I)i===void 0?this.b.removeValue(r):this.b.setValue(r,i);f&&this.a.fire(this.b)}}};e.$Ro=l,e.$Ro=l=ve([Y(1,E.$qo),Y(2,w.$_j)],l)}),define(ce[220],le([0,1,19,6,15,3,34,64,2,35,30,5,21,22,78,48,219,7,60]),function(ne,e,P,c,N,O,T,k,A,w,E,$,u,p,l,d,y,f,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$So=void 0;class I extends A.$Wc{constructor(r,i,a,t){super(),this.m=r,this.n=t,this.h=this.B(new O.$me),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new y.$Po(t)),this.c=a instanceof b.$so?new y.$Qo:this.B(new y.$Ro(this.b,a,t)),this.f=this.B(new l.$Lo(this.m,{},u.$0g,i,t)),this.a=new l.$Mo(this.b.configurationModel,this.c.configurationModel,l.$Jo.createEmptyModel(t),l.$Jo.createEmptyModel(t),l.$Jo.createEmptyModel(t),l.$Jo.createEmptyModel(t),new w.$Cc,l.$Jo.createEmptyModel(t),new w.$Cc,t),this.j=new m(r,i,this),this.g=this.B(new c.$Rh(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:n,properties:o})=>this.s(n,o))),this.B(this.c.onDidChangeConfiguration(n=>this.t(n))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[r,i,a]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new l.$Mo(r,i,l.$Jo.createEmptyModel(this.n),a,l.$Jo.createEmptyModel(this.n),l.$Jo.createEmptyModel(this.n),new w.$Cc,l.$Jo.createEmptyModel(this.n),new w.$Cc,this.n)}getConfigurationData(){return this.a.toData()}getValue(r,i){const a=typeof r=="string"?r:void 0,t=(0,p.$aj)(r)?r:(0,p.$aj)(i)?i:{};return this.a.getValue(a,t,void 0)}async updateValue(r,i,a,t,n){const o=(0,p.$bj)(a)?a:(0,p.$aj)(a)?{resource:a.resource,overrideIdentifiers:a.overrideIdentifier?[a.overrideIdentifier]:void 0}:void 0,h=o?t:a;if(h!==void 0&&h!==p.ConfigurationTarget.USER_LOCAL&&h!==p.ConfigurationTarget.USER)throw new Error(`Unable to write ${r} to target ${h}.`);o?.overrideIdentifiers&&(o.overrideIdentifiers=(0,P.$Ob)(o.overrideIdentifiers),o.overrideIdentifiers=o.overrideIdentifiers.length?o.overrideIdentifiers:void 0);const g=this.inspect(r,{resource:o?.resource,overrideIdentifier:o?.overrideIdentifiers?o.overrideIdentifiers[0]:void 0});if(g.policyValue!==void 0)throw new Error(`Unable to write ${r} because it is configured in system policy.`);if((0,E.$fo)(i,g.defaultValue)&&(i=void 0),o?.overrideIdentifiers?.length&&o.overrideIdentifiers.length>1){const L=o.overrideIdentifiers.sort(),S=this.a.localUserConfiguration.overrides.find(v=>(0,P.$wb)([...v.identifiers].sort(),L));S&&(o.overrideIdentifiers=S.identifiers)}const R=o?.overrideIdentifiers?.length?[(0,d.$Fo)(o.overrideIdentifiers),r]:[r];await this.j.write(R,i),await this.reloadConfiguration()}inspect(r,i={}){return this.a.inspect(r,i,void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const r=await this.f.loadConfiguration();this.r(r)}r(r){const i=this.a.toData(),a=this.a.compareAndUpdateLocalUserConfiguration(r);this.u(a,i,p.ConfigurationTarget.USER)}s(r,i){const a=this.a.toData(),t=this.a.compareAndUpdateDefaultConfiguration(r,i);this.u(t,a,p.ConfigurationTarget.DEFAULT)}t(r){const i=this.a.toData(),a=this.a.compareAndUpdatePolicyConfiguration(r);this.u(a,i,p.ConfigurationTarget.DEFAULT)}u(r,i,a){const t=new l.$Oo(r,{data:i},this.a,void 0,this.n);t.source=a,this.h.fire(t)}}e.$So=I;class m{constructor(r,i,a){this.b=r,this.c=i,this.d=a,this.a=new c.$Mh}write(r,i){return this.a.queue(()=>this.e(r,i))}async e(r,i){let a;try{a=(await this.c.readFile(this.b)).value.toString()}catch(o){if(o.fileOperationResult===f.FileOperationResult.FILE_NOT_FOUND)a="{}";else throw o}const t=[];if((0,T.$Vn)(a,t,{allowTrailingComma:!0,allowEmptyContent:!0}),t.length>0)throw new Error("Unable to write into the settings file. Please open the file to correct errors/warnings in the file and try again.");const n=this.f(a,r,i);a=(0,k.$ao)(a,n),await this.c.writeFile(this.b,N.$Oe.fromString(a))}f(r,i,a){const{tabSize:t,insertSpaces:n,eol:o}=this.h;if(!i.length){const h=JSON.stringify(a,null,n?" ".repeat(t):"	");return[{content:h,length:h.length,offset:0}]}return(0,k.$0n)(r,i,a,{tabSize:t,insertSpaces:n,eol:o})}get h(){if(!this.g){let r=$.OS===$.OperatingSystem.Linux||$.OS===$.OperatingSystem.Macintosh?`
`:`\r
`;const i=this.d.getValue("files.eol",{overrideIdentifier:"jsonc"});i&&typeof i=="string"&&i!=="auto"&&(r=i),this.g={eol:r,insertSpaces:!!this.d.getValue("editor.insertSpaces",{overrideIdentifier:"jsonc"}),tabSize:this.d.getValue("editor.tabSize",{overrideIdentifier:"jsonc"})}}return this.g}}}),define(ce[221],le([0,1,15,3,2,70]),function(ne,e,P,c,N,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ywb=e.$Wwb=e.$Vwb=void 0,e.$Xwb=k;const T=(w,E,$)=>{const u=new Uint8Array(16);for(let d=0;d<16;d++)u[d]=Math.round(Math.random()*256);const p=(0,P.$9e)(P.$Oe.wrap(u));return[`GET ws://localhost${w}?${E}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${p}`].join(`\r
`)+`\r
\r
`};e.$Vwb=T,e.$Wwb=P.$Oe.fromString(`\r
\r
`);async function k(w,E,$,u,p){w.write(P.$Oe.fromString((0,e.$Vwb)(E,$,u)));const l=new N.$Vc;try{return await new Promise((d,y)=>{let f;l.add(w.onData(b=>{f?f=P.$Oe.concat([f,b],f.byteLength+b.byteLength):f=b;const I=f.indexOf(e.$Wwb);if(I===-1)return;d(w),w.pauseData();const m=f.slice(I+e.$Wwb.byteLength);m.byteLength&&p.onData.fire(m)})),l.add(w.onClose(b=>y(b??new Error("socket closed")))),l.add(w.onEnd(()=>y(new Error("socket ended"))))})}catch(d){throw w.dispose(),d}finally{l.dispose()}}class A extends N.$Wc{constructor(E,$){super(),this.g=E,this.a=this.B(new c.$pe),this.onData=(...u)=>(this.a.isPaused&&queueMicrotask(()=>this.a.resume()),this.a.event(...u)),this.b=this.B(new c.$me),this.onDidDispose=this.b.event,this.f=!1,this.B($.onData),this.B($.onData.event(u=>this.a.fire(u))),this.onClose=this.B($.onClose).event,this.onEnd=this.B($.onEnd).event}pauseData(){this.a.pause()}drain(){return Promise.resolve()}end(){this.f=!0,this.h()}traceSocketEvent(E,$){O.SocketDiagnostics.traceSocketEvent(this,this.g,E,$)}dispose(){this.f||this.h(),this.b.fire(),super.dispose()}}e.$Ywb=A}),define(ce[105],le([0,1,8,4]),function(ne,e,P,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tl=e.RemoteAuthorityResolverErrorCode=e.$Sl=e.$Rl=e.RemoteConnectionType=e.$Ql=void 0,e.$Ul=w,e.$Ql=(0,c.$Fi)("remoteAuthorityResolverService");var N;(function(E){E[E.WebSocket=0]="WebSocket",E[E.Managed=1]="Managed"})(N||(e.RemoteConnectionType=N={}));class O{constructor($){this.id=$,this.type=N.Managed}toString(){return`Managed(${this.id})`}}e.$Rl=O;class T{constructor($,u){this.host=$,this.port=u,this.type=N.WebSocket}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$Sl=T;var k;(function(E){E.Unknown="Unknown",E.NotAvailable="NotAvailable",E.TemporarilyNotAvailable="TemporarilyNotAvailable",E.NoResolverFound="NoResolverFound",E.InvalidAuthority="InvalidAuthority"})(k||(e.RemoteAuthorityResolverErrorCode=k={}));class A extends P.$db{static isNotAvailable($){return $ instanceof A&&$._code===k.NotAvailable}static isTemporarilyNotAvailable($){return $ instanceof A&&$._code===k.TemporarilyNotAvailable}static isNoResolverFound($){return $ instanceof A&&$._code===k.NoResolverFound}static isInvalidAuthority($){return $ instanceof A&&$._code===k.InvalidAuthority}static isHandled($){return $ instanceof A&&$.isHandled}constructor($,u=k.Unknown,p){super($),this._message=$,this._code=u,this._detail=p,this.isHandled=u===k.NotAvailable&&p===!0,Object.setPrototypeOf(this,A.prototype)}}e.$Tl=A;function w(E){const $=E.indexOf("+");return $===-1?E:E.substring(0,$)}}),define(ce[222],le([0,1,6,15,26,8,3,2,23,101,55,32,70,105]),function(ne,e,P,c,N,O,T,k,A,w,E,$,u,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0l=e.$9l=e.$8l=e.$7l=e.$6l=e.$5l=e.$4l=e.$3l=e.PersistentConnectionEventType=e.ConnectionType=void 0,e.$Zl=g,e.$1l=R,e.$2l=S,w=Oe(w);const l=30*1e3;var d;(function(X){X[X.Management=1]="Management",X[X.ExtensionHost=2]="ExtensionHost",X[X.Tunnel=3]="Tunnel"})(d||(e.ConnectionType=d={}));function y(X){switch(X){case d.Management:return"Management";case d.ExtensionHost:return"ExtensionHost";case d.Tunnel:return"Tunnel"}}function f(X){const G=new N.$xe;return setTimeout(()=>G.cancel(),X),G.token}function b(X,G){if(X.isCancellationRequested||G.isCancellationRequested)return N.CancellationToken.Cancelled;const U=new N.$xe;return X.onCancellationRequested(()=>U.cancel()),G.onCancellationRequested(()=>U.cancel()),U.token}class I{get didTimeout(){return this.c==="timedout"}constructor(G){this.c="pending",this.d=new k.$Vc,{promise:this.promise,resolve:this.f,reject:this.g}=(0,P.$yh)(),G.isCancellationRequested?this.h():this.d.add(G.onCancellationRequested(()=>this.h()))}registerDisposable(G){this.c==="pending"?this.d.add(G):G.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const G=new Error("Time limit reached");return G.code="ETIMEDOUT",G.syscall="connect",G}resolve(G){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(G))}reject(G){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(G))}}function m(X,G){const U=new I(G);return U.registerDisposable(X.onControlMessage(B=>{const j=JSON.parse(B.toString()),W=z(j);W?U.reject(W):U.resolve(j)})),U.promise}function s(X,G,U,B,j,W,te,_){const Q=new I(_),ae=E.$ge.create(!1);return X.info(`Creating a socket (${te})...`),w.mark(`code/willCreateSocket/${W}`),G.connect(U,B,j,te).then(ue=>{Q.didTimeout?(w.mark(`code/didCreateSocketError/${W}`),X.info(`Creating a socket (${te}) finished after ${ae.elapsed()} ms, but this is too late and has timed out already.`),ue?.dispose()):(w.mark(`code/didCreateSocketOK/${W}`),X.info(`Creating a socket (${te}) was successful after ${ae.elapsed()} ms.`),Q.resolve(ue))},ue=>{w.mark(`code/didCreateSocketError/${W}`),X.info(`Creating a socket (${te}) returned an error after ${ae.elapsed()} ms.`),X.error(ue),Q.reject(ue)}),Q.promise}function r(X,G){const U=new I(G);return X.then(B=>{U.didTimeout||U.resolve(B)},B=>{U.didTimeout||U.reject(B)}),U.promise}async function i(X,G,U,B){const j=q(X,G);X.logService.trace(`${j} 1/6. invoking socketFactory.connect().`);let W;try{W=await s(X.logService,X.remoteSocketFactoryService,X.connectTo,A.$Sg.getServerRootPath(),`reconnectionToken=${X.reconnectionToken}&reconnection=${X.reconnectionProtocol?"true":"false"}`,y(G),`renderer-${y(G)}-${X.reconnectionToken}`,B)}catch(ue){throw X.logService.error(`${j} socketFactory.connect() failed or timed out. Error:`),X.logService.error(ue),ue}X.logService.trace(`${j} 2/6. socketFactory.connect() was successful.`);let te,_;X.reconnectionProtocol?(X.reconnectionProtocol.beginAcceptReconnection(W,null),te=X.reconnectionProtocol,_=!1):(te=new u.$ti({socket:W}),_=!0),X.logService.trace(`${j} 3/6. sending AuthRequest control message.`);const Q=await r(X.signService.createNewMessage((0,$.$2g)()),B),ae={type:"auth",auth:X.connectionToken||"00000000000000000000",data:Q.data};te.sendControl(c.$Oe.fromString(JSON.stringify(ae)));try{const ue=await m(te,b(B,f(1e4)));if(ue.type!=="sign"||typeof ue.data!="string"){const pe=new Error("Unexpected handshake message");throw pe.code="VSCODE_CONNECTION_ERROR",pe}if(X.logService.trace(`${j} 4/6. received SignRequest control message.`),!await r(X.signService.validate(Q,ue.signedData),B)){const pe=new Error("Refused to connect to unsupported server");throw pe.code="VSCODE_CONNECTION_ERROR",pe}const we=await r(X.signService.sign(ue.data),B),Ee={type:"connectionType",commit:X.commit,signedData:we,desiredConnectionType:G};return U&&(Ee.args=U),X.logService.trace(`${j} 5/6. sending ConnectionTypeRequest control message.`),te.sendControl(c.$Oe.fromString(JSON.stringify(Ee))),{protocol:te,ownsProtocol:_}}catch(ue){throw ue&&ue.code==="ETIMEDOUT"&&(X.logService.error(`${j} the handshake timed out. Error:`),X.logService.error(ue)),ue&&ue.code==="VSCODE_CONNECTION_ERROR"&&(X.logService.error(`${j} received error control message when negotiating connection. Error:`),X.logService.error(ue)),_&&V(te),ue}}async function a(X,G,U,B){const j=Date.now(),W=q(X,G),{protocol:te,ownsProtocol:_}=await i(X,G,U,B),Q=new I(B);return Q.registerDisposable(te.onControlMessage(ae=>{const ue=JSON.parse(ae.toString()),ge=z(ue);ge?(X.logService.error(`${W} received error control message when negotiating connection. Error:`),X.logService.error(ge),_&&V(te),Q.reject(ge)):(X.reconnectionProtocol?.endAcceptReconnection(),X.logService.trace(`${W} 6/6. handshake finished, connection is up and running after ${Z(j)}!`),Q.resolve({protocol:te,firstMessage:ue}))})),Q.promise}async function t(X,G){const{protocol:U}=await a(X,d.Management,void 0,G);return{protocol:U}}async function n(X,G,U){const{protocol:B,firstMessage:j}=await a(X,d.ExtensionHost,G,U),W=j&&j.debugPort;return{protocol:B,debugPort:W}}async function o(X,G,U){const B=Date.now(),j=q(X,d.Tunnel),{protocol:W}=await i(X,d.Tunnel,G,U);return X.logService.trace(`${j} 6/6. handshake finished, connection is up and running after ${Z(B)}!`),W}async function h(X,G,U){const{connectTo:B,connectionToken:j}=await X.addressProvider.getAddress();return{commit:X.commit,quality:X.quality,connectTo:B,connectionToken:j,reconnectionToken:G,reconnectionProtocol:U,remoteSocketFactoryService:X.remoteSocketFactoryService,signService:X.signService,logService:X.logService}}async function g(X,G,U){return L(X,async B=>{const{protocol:j}=await t(B,N.CancellationToken.None);return new K(X,G,U,B.reconnectionToken,j)})}async function R(X,G){return L(X,async U=>{const{protocol:B,debugPort:j}=await n(U,G,N.CancellationToken.None);return new ie(X,G,U.reconnectionToken,B,j)})}async function L(X,G){for(let B=1;;B++)try{const j=(0,$.$2g)(),W=await h(X,j,null);return await G(W)}catch(j){if(B<5)X.logService.error(`[remote-connection][attempt ${B}] An error occurred in initial connection! Will retry... Error:`),X.logService.error(j);else throw X.logService.error(`[remote-connection][attempt ${B}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),X.logService.error(j),x.triggerPermanentFailure(0,0,p.$Tl.isHandled(j)),j}}async function S(X,G,U){const B=await h(X,(0,$.$2g)(),null);return await o(B,{host:G,port:U},N.CancellationToken.None)}function v(X){return(0,P.$sh)(G=>new Promise((U,B)=>{const j=setTimeout(U,X*1e3);G.onCancellationRequested(()=>{clearTimeout(j),U()})}))}var C;(function(X){X[X.ConnectionLost=0]="ConnectionLost",X[X.ReconnectionWait=1]="ReconnectionWait",X[X.ReconnectionRunning=2]="ReconnectionRunning",X[X.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",X[X.ConnectionGain=4]="ConnectionGain"})(C||(e.PersistentConnectionEventType=C={}));class F{constructor(G,U){this.reconnectionToken=G,this.millisSinceLastIncomingData=U,this.type=C.ConnectionLost}}e.$3l=F;class D{constructor(G,U,B,j){this.reconnectionToken=G,this.millisSinceLastIncomingData=U,this.durationSeconds=B,this.c=j,this.type=C.ReconnectionWait}skipWait(){this.c.cancel()}}e.$4l=D;class M{constructor(G,U,B){this.reconnectionToken=G,this.millisSinceLastIncomingData=U,this.attempt=B,this.type=C.ReconnectionRunning}}e.$5l=M;class J{constructor(G,U,B){this.reconnectionToken=G,this.millisSinceLastIncomingData=U,this.attempt=B,this.type=C.ConnectionGain}}e.$6l=J;class H{constructor(G,U,B,j){this.reconnectionToken=G,this.millisSinceLastIncomingData=U,this.attempt=B,this.handled=j,this.type=C.ReconnectionPermanentFailure}}e.$7l=H;class x extends k.$Wc{static triggerPermanentFailure(G,U,B){this._permanentFailure=!0,this.f=G,this.g=U,this.h=B,this.j.forEach(j=>j.D(this.f,this.g,this.h))}static debugTriggerReconnection(){this.j.forEach(G=>G.y())}static debugPauseSocketWriting(){this.j.forEach(G=>G.F())}static{this._permanentFailure=!1}static{this.f=0}static{this.g=0}static{this.h=!1}static{this.j=[]}get n(){return this.c||x._permanentFailure}constructor(G,U,B,j,W){super(),this.t=G,this.u=U,this.reconnectionToken=B,this.protocol=j,this.w=W,this.m=this.B(new T.$me),this.onDidStateChange=this.m.event,this.c=!1,this.r=!1,this.s=!1,this.m.fire(new J(this.reconnectionToken,0,0)),this.B(j.onSocketClose(te=>{const _=he(this.t,this.reconnectionToken,!0);te?te.type===u.SocketCloseEventType.NodeSocketCloseEvent?(this.u.logService.info(`${_} received socket close event (hadError: ${te.hadError}).`),te.error&&this.u.logService.error(te.error)):(this.u.logService.info(`${_} received socket close event (wasClean: ${te.wasClean}, code: ${te.code}, reason: ${te.reason}).`),te.event&&this.u.logService.error(te.event)):this.u.logService.info(`${_} received socket close event.`),this.y()})),this.B(j.onSocketTimeout(te=>{const _=he(this.t,this.reconnectionToken,!0);this.u.logService.info(`${_} received socket timeout event (unacknowledgedMsgCount: ${te.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${te.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${te.timeSinceLastReceivedSomeData}).`),this.y()})),x.j.push(this),this.B((0,k.$Uc)(()=>{const te=x.j.indexOf(this);te>=0&&x.j.splice(te,1)})),this.n&&this.D(x.f,x.g,x.h)}dispose(){super.dispose(),this.s=!0}async y(){if(!this.r)try{this.r=!0,await this.z()}finally{this.r=!1}}async z(){if(this.n||this.s)return;const G=he(this.t,this.reconnectionToken,!0);this.u.logService.info(`${G} starting reconnecting loop. You can get more information with the trace log level.`),this.m.fire(new F(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const U=[0,5,5,10,10,10,10,10,30];let B=-1;do{B++;const j=B<U.length?U[B]:U[U.length-1];try{if(j>0){const te=v(j);this.m.fire(new D(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),j,te)),this.u.logService.info(`${G} waiting for ${j} seconds before reconnecting...`);try{await te}catch{}}if(this.n){this.u.logService.error(`${G} permanent failure occurred while running the reconnecting loop.`);break}this.m.fire(new M(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),B+1)),this.u.logService.info(`${G} resolving connection...`);const W=await h(this.u,this.reconnectionToken,this.protocol);this.u.logService.info(`${G} connecting to ${W.connectTo}...`),await this.G(W,f(l)),this.u.logService.info(`${G} reconnected!`),this.m.fire(new J(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),B+1));break}catch(W){if(W.code==="VSCODE_CONNECTION_ERROR"){this.u.logService.error(`${G} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.u.logService.error(W),this.C(this.protocol.getMillisSinceLastIncomingData(),B+1,!1);break}if(B>360){this.u.logService.error(`${G} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.u.logService.error(W),this.C(this.protocol.getMillisSinceLastIncomingData(),B+1,!1);break}if(p.$Tl.isTemporarilyNotAvailable(W)){this.u.logService.info(`${G} A temporarily not available error occurred while trying to reconnect, will try again...`),this.u.logService.trace(W);continue}if((W.code==="ETIMEDOUT"||W.code==="ENETUNREACH"||W.code==="ECONNREFUSED"||W.code==="ECONNRESET")&&W.syscall==="connect"){this.u.logService.info(`${G} A network error occurred while trying to reconnect, will try again...`),this.u.logService.trace(W);continue}if((0,O.$6)(W)){this.u.logService.info(`${G} A promise cancelation error occurred while trying to reconnect, will try again...`),this.u.logService.trace(W);continue}if(W instanceof p.$Tl){this.u.logService.error(`${G} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.u.logService.error(W),this.C(this.protocol.getMillisSinceLastIncomingData(),B+1,p.$Tl.isHandled(W));break}this.u.logService.error(`${G} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.u.logService.error(W),this.C(this.protocol.getMillisSinceLastIncomingData(),B+1,!1);break}}while(!this.n&&!this.s)}C(G,U,B){this.w?x.triggerPermanentFailure(G,U,B):this.D(G,U,B)}D(G,U,B){this.m.fire(new H(this.reconnectionToken,G,U,B)),V(this.protocol)}F(){this.protocol.pauseSocketWriting()}}e.$8l=x;class K extends x{constructor(G,U,B,j,W){super(d.Management,G,j,W,!0),this.client=this.B(new u.$ri(W,{remoteAuthority:U,clientId:B},G.ipcLogger))}async G(G,U){await t(G,U)}}e.$9l=K;class ie extends x{constructor(G,U,B,j,W){super(d.ExtensionHost,G,B,j,!1),this.H=U,this.debugPort=W}async G(G,U){await n(G,this.H,U)}}e.$0l=ie;function V(X){try{X.acceptDisconnect();const G=X.getSocket();X.dispose(),G.dispose()}catch(G){(0,O.$3)(G)}}function z(X){if(X&&X.type==="error"){const G=new Error(`Connection error: ${X.reason}`);return G.code="VSCODE_CONNECTION_ERROR",G}return null}function ee(X,G){for(;X.length<G;)X+=" ";return X}function se(X,G){return`[remote-connection][${ee(y(X),13)}][${G.substr(0,5)}\u2026]`}function he(X,G,U){return`${se(X,G)}[${U?"reconnect":"initial"}]`}function q(X,G){return`${he(G,X.reconnectionToken,!!X.reconnectionProtocol)}[${X.connectTo}]`}function Z(X){return`${Date.now()-X} ms`}}),define(ce[106],le([0,1,23]),function(ne,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gn=c,e.$hn=N,e.$in=O,e.$jn=T;function c(A){return A.scheme===P.Schemas.vscodeRemote?A.authority:void 0}function N(A){if(!A)return;const w=A.indexOf("+");return w<0?A:A.substr(0,w)}function O(A){const{host:w,port:E}=k(A);if(typeof E>"u")throw new Error(`Invalid remote authority: ${A}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:w,port:E}}function T(A,w){let{host:E,port:$}=k(A);return typeof $>"u"&&($=w),{host:E,port:$}}function k(A){const w=A.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(w)return{host:w[1],port:parseInt(w[2],10)};const E=A.match(/^(\[[0-9a-z:]+\])$/);if(E)return{host:E[1],port:void 0};const $=A.match(/(.*):(\d+)$/);return $?{host:$[1],port:parseInt($[2],10)}:{host:A,port:void 0}}}),define(ce[37],le([0,1,27,4,106]),function(ne,e,P,c,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xn=e.$sn=e.$rn=e.$qn=e.TargetPlatform=e.ExtensionType=e.$pn=e.$nn=e.$mn=e.$ln=e.$kn=void 0,e.$on=O,e.$tn=$,e.$un=u,e.$vn=p,e.$wn=l,P=Oe(P),e.$kn="extensions.user.cache",e.$ln="extensions.builtin.cache",e.$mn="undefined_publisher",e.$nn=["ui","workspace","web"];function O(d){if(typeof d=="object"&&d!==null&&d.supported!==!0)return d.description}e.$pn=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","AI","Chat","Other"];var T;(function(d){d[d.System=0]="System",d[d.User=1]="User"})(T||(e.ExtensionType=T={}));var k;(function(d){d.WIN32_X64="win32-x64",d.WIN32_ARM64="win32-arm64",d.LINUX_X64="linux-x64",d.LINUX_ARM64="linux-arm64",d.LINUX_ARMHF="linux-armhf",d.ALPINE_X64="alpine-x64",d.ALPINE_ARM64="alpine-arm64",d.DARWIN_X64="darwin-x64",d.DARWIN_ARM64="darwin-arm64",d.WEB="web",d.UNIVERSAL="universal",d.UNKNOWN="unknown",d.UNDEFINED="undefined"})(k||(e.TargetPlatform=k={}));class A{constructor(y){this.value=y,this._lower=y.toLowerCase()}static equals(y,f){if(typeof y>"u"||y===null)return typeof f>"u"||f===null;if(typeof f>"u"||f===null)return!1;if(typeof y=="string"||typeof f=="string"){const b=typeof y=="string"?y:y.value,I=typeof f=="string"?f:f.value;return P.$Gf(b,I)}return y._lower===f._lower}static toKey(y){return typeof y=="string"?y.toLowerCase():y._lower}}e.$qn=A;class w{get size(){return this.c.size}constructor(y){if(this.c=new Set,y)for(const f of y)this.add(f)}add(y){this.c.add(A.toKey(y))}delete(y){return this.c.delete(A.toKey(y))}has(y){return this.c.has(A.toKey(y))}}e.$rn=w;class E{constructor(){this.c=new Map}clear(){this.c.clear()}delete(y){this.c.delete(A.toKey(y))}get(y){return this.c.get(A.toKey(y))}has(y){return this.c.has(A.toKey(y))}set(y,f){this.c.set(A.toKey(y),f)}values(){return this.c.values()}forEach(y){this.c.forEach(y)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$sn=E;function $(d){return u(d)}function u(d){return d.contributes&&d.contributes.localizations?d.contributes.localizations.length>0:!1}function p(d){return d.contributes&&d.contributes.authentication?d.contributes.authentication.length>0:!1}function l(d,y){if(y){const f=`onResolveRemoteAuthority:${(0,N.$hn)(y)}`;return!!d.activationEvents?.includes(f)}return!1}e.$xn=(0,c.$Fi)("IBuiltinExtensionsScannerService")}),define(ce[28],le([0,1,5,163,37,4]),function(ne,e,P,c,N,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pp=e.$op=e.$np=e.$mp=e.$lp=e.$kp=e.$jp=e.$ip=e.ExtensionManagementErrorCode=e.$hp=e.ExtensionGalleryErrorCode=e.$gp=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.ExtensionInstallSource=e.$_o=e.$$o=e.$0o=e.$9o=e.$8o=e.$7o=e.$6o=void 0,e.$ap=k,e.$bp=A,e.$cp=w,e.$dp=E,e.$ep=$,e.$fp=u,e.$6o="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$7o=new RegExp(e.$6o),e.$8o="__web_extension",e.$9o="skipWalkthrough",e.$0o="extensionInstallSource",e.$$o="dependecyOrPackExtensionInstall",e.$_o="clientTargetPlatform";var T;(function(s){s.COMMAND="command",s.SETTINGS_SYNC="settingsSync"})(T||(e.ExtensionInstallSource=T={}));function k(s){switch(s){case N.TargetPlatform.WIN32_X64:return"Windows 64 bit";case N.TargetPlatform.WIN32_ARM64:return"Windows ARM";case N.TargetPlatform.LINUX_X64:return"Linux 64 bit";case N.TargetPlatform.LINUX_ARM64:return"Linux ARM 64";case N.TargetPlatform.LINUX_ARMHF:return"Linux ARM";case N.TargetPlatform.ALPINE_X64:return"Alpine Linux 64 bit";case N.TargetPlatform.ALPINE_ARM64:return"Alpine ARM 64";case N.TargetPlatform.DARWIN_X64:return"Mac";case N.TargetPlatform.DARWIN_ARM64:return"Mac Silicon";case N.TargetPlatform.WEB:return"Web";case N.TargetPlatform.UNIVERSAL:return N.TargetPlatform.UNIVERSAL;case N.TargetPlatform.UNKNOWN:return N.TargetPlatform.UNKNOWN;case N.TargetPlatform.UNDEFINED:return N.TargetPlatform.UNDEFINED}}function A(s){switch(s){case N.TargetPlatform.WIN32_X64:return N.TargetPlatform.WIN32_X64;case N.TargetPlatform.WIN32_ARM64:return N.TargetPlatform.WIN32_ARM64;case N.TargetPlatform.LINUX_X64:return N.TargetPlatform.LINUX_X64;case N.TargetPlatform.LINUX_ARM64:return N.TargetPlatform.LINUX_ARM64;case N.TargetPlatform.LINUX_ARMHF:return N.TargetPlatform.LINUX_ARMHF;case N.TargetPlatform.ALPINE_X64:return N.TargetPlatform.ALPINE_X64;case N.TargetPlatform.ALPINE_ARM64:return N.TargetPlatform.ALPINE_ARM64;case N.TargetPlatform.DARWIN_X64:return N.TargetPlatform.DARWIN_X64;case N.TargetPlatform.DARWIN_ARM64:return N.TargetPlatform.DARWIN_ARM64;case N.TargetPlatform.WEB:return N.TargetPlatform.WEB;case N.TargetPlatform.UNIVERSAL:return N.TargetPlatform.UNIVERSAL;default:return N.TargetPlatform.UNKNOWN}}function w(s,r){switch(s){case P.Platform.Windows:return r==="x64"?N.TargetPlatform.WIN32_X64:r==="arm64"?N.TargetPlatform.WIN32_ARM64:N.TargetPlatform.UNKNOWN;case P.Platform.Linux:return r==="x64"?N.TargetPlatform.LINUX_X64:r==="arm64"?N.TargetPlatform.LINUX_ARM64:r==="arm"?N.TargetPlatform.LINUX_ARMHF:N.TargetPlatform.UNKNOWN;case"alpine":return r==="x64"?N.TargetPlatform.ALPINE_X64:r==="arm64"?N.TargetPlatform.ALPINE_ARM64:N.TargetPlatform.UNKNOWN;case P.Platform.Mac:return r==="x64"?N.TargetPlatform.DARWIN_X64:r==="arm64"?N.TargetPlatform.DARWIN_ARM64:N.TargetPlatform.UNKNOWN;case P.Platform.Web:return N.TargetPlatform.WEB}}function E(s,r){return r===N.TargetPlatform.WEB&&!s.includes(N.TargetPlatform.WEB)}function $(s,r,i){return E(r,i)?!1:s===N.TargetPlatform.UNDEFINED||s===N.TargetPlatform.UNIVERSAL?!0:s===N.TargetPlatform.UNKNOWN?!1:s===i}function u(s){return s&&typeof s=="object"&&typeof s.id=="string"&&(!s.uuid||typeof s.uuid=="string")}var p;(function(s){s[s.NoneOrRelevance=0]="NoneOrRelevance",s[s.LastUpdatedDate=1]="LastUpdatedDate",s[s.Title=2]="Title",s[s.PublisherName=3]="PublisherName",s[s.InstallCount=4]="InstallCount",s[s.PublishedDate=10]="PublishedDate",s[s.AverageRating=6]="AverageRating",s[s.WeightedRating=12]="WeightedRating"})(p||(e.SortBy=p={}));var l;(function(s){s[s.Default=0]="Default",s[s.Ascending=1]="Ascending",s[s.Descending=2]="Descending"})(l||(e.SortOrder=l={}));var d;(function(s){s.Install="install",s.Uninstall="uninstall"})(d||(e.StatisticType=d={}));var y;(function(s){s[s.None=1]="None",s[s.Install=2]="Install",s[s.Update=3]="Update",s[s.Migrate=4]="Migrate"})(y||(e.InstallOperation=y={})),e.$gp=(0,O.$Fi)("extensionGalleryService");var f;(function(s){s.Timeout="Timeout",s.Cancelled="Cancelled",s.Failed="Failed",s.DownloadFailedWriting="DownloadFailedWriting"})(f||(e.ExtensionGalleryErrorCode=f={}));class b extends Error{constructor(r,i){super(r),this.code=i,this.name=i}}e.$hp=b;var I;(function(s){s.Unsupported="Unsupported",s.Deprecated="Deprecated",s.Malicious="Malicious",s.Incompatible="Incompatible",s.IncompatibleTargetPlatform="IncompatibleTargetPlatform",s.ReleaseVersionNotFound="ReleaseVersionNotFound",s.Invalid="Invalid",s.Download="Download",s.DownloadSignature="DownloadSignature",s.DownloadFailedWriting="DownloadFailedWriting",s.UpdateExistingMetadata="UpdateExistingMetadata",s.UpdateMetadata="UpdateMetadata",s.Extract="Extract",s.Scanning="Scanning",s.ScanningExtension="ScanningExtension",s.ReadUninstalled="ReadUninstalled",s.UnsetUninstalled="UnsetUninstalled",s.Delete="Delete",s.Rename="Rename",s.IntializeDefaultProfile="IntializeDefaultProfile",s.AddToProfile="AddToProfile",s.InstalledExtensionNotFound="InstalledExtensionNotFound",s.PostInstall="PostInstall",s.CorruptZip="CorruptZip",s.IncompleteZip="IncompleteZip",s.Signature="Signature",s.NotAllowed="NotAllowed",s.Gallery="Gallery",s.Cancelled="Cancelled",s.Unknown="Unknown",s.Internal="Internal"})(I||(e.ExtensionManagementErrorCode=I={}));class m extends Error{constructor(r,i){super(r),this.code=i,this.name=i}}e.$ip=m,e.$jp=(0,O.$Fi)("extensionManagementService"),e.$kp="extensionsIdentifiers/disabled",e.$lp="extensionsIdentifiers/enabled",e.$mp=(0,O.$Fi)("IGlobalExtensionEnablementService"),e.$np=(0,O.$Fi)("IExtensionTipsService"),e.$op=(0,c.localize2)(0,"Extensions"),e.$pp=(0,c.localize2)(1,"Preferences")}),define(ce[223],le([0,1,3,2,30,9,95,28]),function(ne,e,P,c,N,O,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sq=e.$rq=e.$qq=void 0;function A(y,f){return y?O.URI.revive(f?f.transformIncoming(y):y):void 0}function w(y,f){return f?f.transformOutgoingURI(y):y}function E(y,f){f=f||T.$Kn;const b=y.manifest;return{...(0,T.$Nn)({...y,manifest:void 0},f),manifest:b}}function $(y,f){return y?.profileLocation?(0,T.$Nn)(y,f??T.$Kn):y}function u(y,f){return f?(0,N.$do)(y,b=>b instanceof O.URI?f.transformOutgoingURI(b):void 0):y}class p{constructor(f,b){this.a=f,this.b=b,this.onInstallExtension=P.Event.buffer(f.onInstallExtension,!0),this.onDidInstallExtensions=P.Event.buffer(f.onDidInstallExtensions,!0),this.onUninstallExtension=P.Event.buffer(f.onUninstallExtension,!0),this.onDidUninstallExtension=P.Event.buffer(f.onDidUninstallExtension,!0),this.onDidUpdateExtensionMetadata=P.Event.buffer(f.onDidUpdateExtensionMetadata,!0)}listen(f,b){const I=this.b(f);switch(b){case"onInstallExtension":return P.Event.map(this.onInstallExtension,m=>({...m,profileLocation:m.profileLocation?w(m.profileLocation,I):m.profileLocation}));case"onDidInstallExtensions":return P.Event.map(this.onDidInstallExtensions,m=>m.map(s=>({...s,local:s.local?u(s.local,I):s.local,profileLocation:s.profileLocation?w(s.profileLocation,I):s.profileLocation})));case"onUninstallExtension":return P.Event.map(this.onUninstallExtension,m=>({...m,profileLocation:m.profileLocation?w(m.profileLocation,I):m.profileLocation}));case"onDidUninstallExtension":return P.Event.map(this.onDidUninstallExtension,m=>({...m,profileLocation:m.profileLocation?w(m.profileLocation,I):m.profileLocation}));case"onDidUpdateExtensionMetadata":return P.Event.map(this.onDidUpdateExtensionMetadata,m=>({local:u(m.local,I),profileLocation:w(m.profileLocation,I)}))}throw new Error("Invalid listen")}async call(f,b,I){const m=this.b(f);switch(b){case"zip":{const s=E(I[0],m),r=await this.a.zip(s);return w(r,m)}case"unzip":return this.a.unzip(A(I[0],m));case"install":return this.a.install(A(I[0],m),$(I[1],m));case"installFromLocation":return this.a.installFromLocation(A(I[0],m),A(I[1],m));case"installExtensionsFromProfile":return this.a.installExtensionsFromProfile(I[0],A(I[1],m),A(I[2],m));case"getManifest":return this.a.getManifest(A(I[0],m));case"getTargetPlatform":return this.a.getTargetPlatform();case"canInstall":return this.a.canInstall(I[0]);case"installFromGallery":return this.a.installFromGallery(I[0],$(I[1],m));case"installGalleryExtensions":{const s=I[0];return this.a.installGalleryExtensions(s.map(({extension:r,options:i})=>({extension:r,options:$(i,m)??{}})))}case"uninstall":return this.a.uninstall(E(I[0],m),$(I[1],m));case"reinstallFromGallery":return this.a.reinstallFromGallery(E(I[0],m));case"getInstalled":return(await this.a.getInstalled(I[0],A(I[1],m),I[2])).map(r=>u(r,m));case"toggleAppliationScope":{const s=await this.a.toggleAppliationScope(E(I[0],m),A(I[1],m));return u(s,m)}case"copyExtensions":return this.a.copyExtensions(A(I[0],m),A(I[1],m));case"updateMetadata":{const s=await this.a.updateMetadata(E(I[0],m),I[1],A(I[2],m));return u(s,m)}case"getExtensionsControlManifest":return this.a.getExtensionsControlManifest();case"download":return this.a.download(I[0],I[1],I[2]);case"cleanUp":return this.a.cleanUp()}throw new Error("Invalid call")}}e.$qq=p;class l extends c.$Wc{get onInstallExtension(){return this.c.event}get onDidInstallExtensions(){return this.f.event}get onUninstallExtension(){return this.g.event}get onDidUninstallExtension(){return this.h.event}get onDidUpdateExtensionMetadata(){return this.j.event}constructor(f){super(),this.m=f,this.c=this.B(new P.$me),this.f=this.B(new P.$me),this.g=this.B(new P.$me),this.h=this.B(new P.$me),this.j=this.B(new P.$me),this.B(this.m.listen("onInstallExtension")(b=>this.n(this.c,{...b,source:this.r(b.source)?O.URI.revive(b.source):b.source,profileLocation:O.URI.revive(b.profileLocation)}))),this.B(this.m.listen("onDidInstallExtensions")(b=>this.n(this.f,b.map(I=>({...I,local:I.local?E(I.local,null):I.local,source:this.r(I.source)?O.URI.revive(I.source):I.source,profileLocation:O.URI.revive(I.profileLocation)}))))),this.B(this.m.listen("onUninstallExtension")(b=>this.n(this.g,{...b,profileLocation:O.URI.revive(b.profileLocation)}))),this.B(this.m.listen("onDidUninstallExtension")(b=>this.n(this.h,{...b,profileLocation:O.URI.revive(b.profileLocation)}))),this.B(this.m.listen("onDidUpdateExtensionMetadata")(b=>this.n(this.j,{profileLocation:O.URI.revive(b.profileLocation),local:E(b.local,null)})))}n(f,b){f.fire(b)}r(f){return f?typeof f.path=="string"&&typeof f.scheme=="string":!1}getTargetPlatform(){return this.s||(this.s=this.m.call("getTargetPlatform")),this.s}async canInstall(f){const b=await this.getTargetPlatform();return f.allTargetPlatforms.some(I=>(0,k.$ep)(I,f.allTargetPlatforms,b))}zip(f){return Promise.resolve(this.m.call("zip",[f]).then(b=>O.URI.revive(b)))}unzip(f){return Promise.resolve(this.m.call("unzip",[f]))}install(f,b){return Promise.resolve(this.m.call("install",[f,b])).then(I=>E(I,null))}installFromLocation(f,b){return Promise.resolve(this.m.call("installFromLocation",[f,b])).then(I=>E(I,null))}async installExtensionsFromProfile(f,b,I){return(await this.m.call("installExtensionsFromProfile",[f,b,I])).map(s=>E(s,null))}getManifest(f){return Promise.resolve(this.m.call("getManifest",[f]))}installFromGallery(f,b){return Promise.resolve(this.m.call("installFromGallery",[f,b])).then(I=>E(I,null))}async installGalleryExtensions(f){return(await this.m.call("installGalleryExtensions",[f])).map(I=>({...I,local:I.local?E(I.local,null):I.local,source:this.r(I.source)?O.URI.revive(I.source):I.source,profileLocation:O.URI.revive(I.profileLocation)}))}uninstall(f,b){if(f.isWorkspaceScoped)throw new Error("Cannot uninstall a workspace extension");return Promise.resolve(this.m.call("uninstall",[f,b]))}reinstallFromGallery(f){return Promise.resolve(this.m.call("reinstallFromGallery",[f])).then(b=>E(b,null))}getInstalled(f=null,b,I){return Promise.resolve(this.m.call("getInstalled",[f,b,I])).then(m=>m.map(s=>E(s,null)))}updateMetadata(f,b,I){return Promise.resolve(this.m.call("updateMetadata",[f,b,I])).then(m=>E(m,null))}toggleAppliationScope(f,b){return this.m.call("toggleAppliationScope",[f,b]).then(I=>E(I,null))}copyExtensions(f,b){return this.m.call("copyExtensions",[f,b])}getExtensionsControlManifest(){return Promise.resolve(this.m.call("getExtensionsControlManifest"))}async download(f,b,I){const m=await this.m.call("download",[f,b,I]);return O.URI.revive(m)}async cleanUp(){return this.m.call("cleanUp")}registerParticipant(){throw new Error("Not Supported")}}e.$rq=l;class d{constructor(f){this.a=f}listen(f,b){throw new Error("Invalid listen")}call(f,b,I){switch(b){case"getConfigBasedTips":return this.a.getConfigBasedTips(O.URI.revive(I[0]));case"getImportantExecutableBasedTips":return this.a.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.a.getOtherExecutableBasedTips()}throw new Error("Invalid call")}}e.$sq=d}),define(ce[224],le([0,1,2,37,7]),function(ne,e,P,c,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pq=void 0;class O extends P.$Wc{constructor(k,A,w,E,$){super(),this.a=k,this.b=A,this.c=w,this.f=$,this.B(E.onDidInstallExtensions(u=>this.g(u))),this.B(E.onDidUninstallExtension(u=>this.h(u)))}g(k){for(const A of k)A.local&&this.invalidate(A.profileLocation)}h(k){k.error||this.invalidate(k.profileLocation)}async invalidate(k){if(k)for(const A of this.a.profiles)this.c.extUri.isEqual(A.extensionsResource,k)&&await this.j(A);else await this.j(this.a.defaultProfile)}async j(k){try{await this.b.del(this.c.extUri.joinPath(k.cacheHome,c.$kn))}catch(A){(0,N.$ql)(A)!==N.FileOperationResult.FILE_NOT_FOUND&&this.f.error(A)}}}e.$Pq=O}),define(ce[79],le([0,1,26,2,5,173,28,4]),function(ne,e,P,c,N,O,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6r=e.$5r=void 0,e.$4r=A;function A(E){return E.tags.find($=>$.startsWith("lp-"))?.split("lp-")[1]}e.$5r=(0,k.$Fi)("languagePackService");let w=class extends c.$Wc{constructor($){super(),this.c=$}async getAvailableLanguages(){const $=new P.$xe;setTimeout(()=>$.cancel(),1e3);let u;try{u=await this.c.query({text:'category:"language packs"',pageSize:20},$.token)}catch{return[]}const l=u.firstPage.filter(d=>d.properties.localizedLanguages?.length&&d.tags.some(y=>y.startsWith("lp-"))).map(d=>{const y=d.properties.localizedLanguages?.[0],f=A(d);return{...this.f(f,y,d),extensionId:d.identifier.id,galleryExtension:d}});return l.push(this.f("en","English")),l}f($,u,p){const l=u??$;let d;if(l!==$&&(d=`(${$})`),$.toLowerCase()===N.$w.toLowerCase()&&(d??="",d+=(0,O.localize)(0,null)),p?.installCount){d??="";const y=p.installCount;let f;y>1e6?f=`${Math.floor(y/1e5)/10}M`:y>1e3?f=`${Math.floor(y/1e3)}K`:f=String(y),d+=` $(cloud-download) ${f}`}return{id:$,label:l,description:d}}};e.$6r=w,e.$6r=w=ve([Y(0,T.$gp)],w)}),define(ce[225],le([0,1,2,79]),function(ne,e,P,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ngc=void 0;let N=class extends P.$Wc{constructor(T){super(),this.a=T,this.b()}b(){this.a.update()}};e.$Ngc=N,e.$Ngc=N=ve([Y(0,c.$5r)],N)}),define(ce[107],le([0,1,2,4]),function(ne,e,P,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wl=e.$Vl=void 0,e.$Vl=(0,c.$Fi)("remoteSocketFactoryService");class N{constructor(){this.a={}}register(T,k){return this.a[T]??=[],this.a[T].push(k),(0,P.$Uc)(()=>{const A=this.a[T]?.indexOf(k);typeof A=="number"&&A>=0&&this.a[T]?.splice(A,1)})}b(T){return(this.a[T.type]||[]).find(A=>A.supports(T))}connect(T,k,A,w){const E=this.b(T);if(!E)throw new Error(`No socket factory found for ${T}`);return E.connect(T,k,A,w)}}e.$Wl=N}),define(ce[226],le([0,1,4]),function(ne,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2gc=e.$1gc=void 0,e.$1gc=(0,P.$Fi)("sharedProcessTunnelService"),e.$2gc="sharedProcessTunnel"}),define(ce[108],le([0,1,4,175]),function(ne,e,P,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_gc=e.$$gc=e.$0gc=e.$9gc=e.$8gc=e.TunnelStates=e.$7gc=e.$6gc=void 0,e.$6gc=(0,P.$Fi)("IRemoteTunnelService"),e.$7gc={active:!1};var N;(function(O){O.disconnected=T=>({type:"disconnected",onTokenFailed:T}),O.connected=(T,k)=>({type:"connected",info:T,serviceInstallFailed:k}),O.connecting=T=>({type:"connecting",progress:T}),O.uninitialized={type:"uninitialized"}})(N||(e.TunnelStates=N={})),e.$8gc="remote.tunnels.access",e.$9gc=e.$8gc+".hostNameOverride",e.$0gc=e.$8gc+".preventSleep",e.$$gc="remoteTunnelService",e.$_gc=(0,c.localize)(0,null)}),define(ce[61],le([0,1,15,8,2,177,48,4,10,44]),function(ne,e,P,c,N,O,T,k,A,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2p=e.$1p=void 0,e.$3p=u,e.$4p=p,e.$5p=l,e.$6p=d,e.$7p=y,e.$8p=f,e.$1p=(0,k.$Fi)("requestService");class E{constructor(s){this.b=s}toJSON(){if(!this.a){const s=Object.create(null);for(const r in this.b)r.toLowerCase()==="authorization"||r.toLowerCase()==="proxy-authorization"?s[r]="*****":s[r]=this.b[r];this.a=s}return this.a}}class $ extends N.$Wc{constructor(s){super(),this.b=0,this.a=s.createLogger("network",{name:(0,O.localize)(0,null),when:A.$rk.isEqualTo((0,A.$ok)(A.LogLevel.Trace)).serialize()})}async c(s,r,i){const a=`${s} #${++this.b}: ${r.url}`;this.a.trace(`${a} - begin`,r.type,new E(r.headers??{}));try{const t=await i();return this.a.trace(`${a} - end`,r.type,t.res.statusCode,t.res.headers),t}catch(t){throw this.a.error(`${a} - error`,r.type,(0,c.$_)(t)),t}}}e.$2p=$;function u(m){return m.res.statusCode&&m.res.statusCode>=200&&m.res.statusCode<300||m.res.statusCode===1223}function p(m){return m.res.statusCode===204}async function l(m){return p(m)?null:(await(0,P.$1e)(m.stream)).toString()}async function d(m){if(!u(m))throw new Error("Server returned "+m.res.statusCode);return l(m)}async function y(m){if(!u(m))throw new Error("Server returned "+m.res.statusCode);if(p(m))return null;const r=(await(0,P.$1e)(m.stream)).toString();try{return JSON.parse(r)}catch(i){throw i.message+=`:
`+r,i}}function f(m){I(m)}let b;function I(m){const s=w.$oo.as(T.$to.Configuration),r=b;b={id:"http",order:15,title:(0,O.localize)(1,null),type:"object",scope:m,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,O.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,O.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,O.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,O.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,O.localize)(6,null),(0,O.localize)(7,null),(0,O.localize)(8,null),(0,O.localize)(9,null)],default:"override",description:(0,O.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,O.localize)(11,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,O.localize)(12,null),restricted:!0}}},s.updateConfigurations({add:[b],remove:r?[r]:[]})}I(T.ConfigurationScope.APPLICATION)}),define(ce[227],le([0,1,26,23,7,61]),function(ne,e,P,c,N,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$AR=void 0;let T=class{constructor(A,w){this.a=A,this.b=w}async download(A,w,E=P.CancellationToken.None){if(A.scheme===c.Schemas.file||A.scheme===c.Schemas.vscodeRemote){await this.b.copy(A,w);return}const $={type:"GET",url:A.toString(!0)},u=await this.a.request($,E);if(u.res.statusCode===200)await this.b.writeFile(w,u.stream);else{const p=await(0,O.$6p)(u);throw new Error(`Expected 200, got back ${u.res.statusCode} instead.

${p}`)}}};e.$AR=T,e.$AR=T=ve([Y(0,O.$1p),Y(1,N.$_k)],T)}),define(ce[228],le([0,1,15,26]),function(ne,e,P,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9r=e.$8r=void 0;class N{constructor(k){this.a=k}listen(k,A){throw new Error("Invalid listen")}call(k,A,w,E=c.CancellationToken.None){switch(A){case"request":return this.a.request(w[0],E).then(async({res:$,stream:u})=>{const p=await(0,P.$1e)(u);return[{statusCode:$.statusCode,headers:$.headers},p]});case"resolveProxy":return this.a.resolveProxy(w[0]);case"loadCertificates":return this.a.loadCertificates()}throw new Error("Invalid call")}}e.$8r=N;class O{constructor(k){this.a=k}async request(k,A){const[w,E]=await this.a.call("request",[k],A);return{res:w,stream:(0,P.$3e)(E)}}async resolveProxy(k){return this.a.call("resolveProxy",[k])}async loadCertificates(){return this.a.call("loadCertificates")}}e.$9r=O}),define(ce[229],le([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Afc=e.$zfc=e.$yfc=void 0,e.$yfc={exit:"vscode:electron-main->shared-process=exit",ipcReady:"vscode:shared-process->electron-main=ipc-ready",initDone:"vscode:shared-process->electron-main=init-done"},e.$zfc={request:"vscode:createSharedProcessChannelConnection",response:"vscode:createSharedProcessChannelConnectionResult"},e.$Afc={request:"vscode:createSharedProcessRawConnection",response:"vscode:createSharedProcessRawConnectionResult"}}),define(ce[230],le([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lbc=void 0;class P{constructor(){this.b=new Map}static{this.a=1}async createNewMessage(N){try{const O=await this.c();if(O){const T=String(P.a++);return this.b.set(T,O),{id:T,data:O.createNewMessage(N)}}}catch{}return{id:"",data:N}}async validate(N,O){if(!N.id)return!0;const T=this.b.get(N.id);if(!T)return!1;this.b.delete(N.id);try{return T.validate(O)==="ok"}catch{return!1}finally{T.dispose?.()}}async sign(N){try{return await this.d(N)}catch{}return N}}e.$lbc=P}),define(ce[109],le([0,1,4]),function(ne,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yl=e.$Xl=void 0,e.$Xl="signService",e.$Yl=(0,P.$Fi)(e.$Xl)}),define(ce[231],le([0,1,230]),function(ne,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qgc=void 0;class c extends P.$lbc{c(){return this.h().then(O=>new O.validator)}d(O){return this.h().then(T=>new T.signer().sign(O))}h(){return new Promise((O,T)=>ne(["vsda"],O,T))}}e.$qgc=c}),define(ce[80],le([0,1,3,2]),function(ne,e,P,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vMb=e.$uMb=e.$tMb=e.$sMb=void 0;class N extends c.$Wc{constructor($,u,p){super(),this.a=$,this.b=u,this.c=p}async getItems(){const $={profile:this.b,workspace:this.c},u=await this.a.call("getItems",$);return new Map(u)}updateItems($){const u={profile:this.b,workspace:this.c};return $.insert&&(u.insert=Array.from($.insert.entries())),$.delete&&(u.delete=Array.from($.delete.values())),this.a.call("updateItems",u)}optimize(){const $={profile:this.b,workspace:this.c};return this.a.call("optimize",$)}}class O extends N{constructor($,u){super($,u,void 0),this.f=this.B(new P.$me),this.onDidChangeItemsExternal=this.f.event,this.g()}g(){this.B(this.a.listen("onDidChangeStorage",{profile:this.b})($=>this.h($)))}h($){(Array.isArray($.changed)||Array.isArray($.deleted))&&this.f.fire({changed:$.changed?new Map($.changed):void 0,deleted:$.deleted?new Set($.deleted):void 0})}}class T extends O{constructor($){super($,void 0)}async close(){this.dispose()}}e.$sMb=T;class k extends O{constructor($,u){super($,u)}async close(){this.dispose()}}e.$tMb=k;class A extends N{constructor($,u){super($,void 0,u),this.onDidChangeItemsExternal=P.Event.None}async close(){this.dispose()}}e.$uMb=A;class w{constructor($){this.a=$}isUsed($){const u={payload:$,profile:void 0,workspace:void 0};return this.a.call("isUsed",u)}}e.$vMb=w}),define(ce[110],le([0,1,5,36,32]),function(ne,e,P,c,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qp=T,e.$rp=k;function O(A){if(P.$u===P.Platform.Linux&&/^penguin(\.|$)/i.test(A))return"chromebook"}function T(A,w,E,$,u,p,l,d,y,f){const b=Object.create(null);b["common.machineId"]=p,b["common.sqmId"]=l,b["common.devDeviceId"]=d,b.sessionID=(0,N.$2g)()+Date.now(),b.commitHash=$,b.version=u,b["common.platformVersion"]=(A||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),b["common.platform"]=(0,P.$h)(P.$u),b["common.nodePlatform"]=c.$fc,b["common.nodeArch"]=E,b["common.product"]=f||"desktop",y&&(b["common.msftInternal"]=y);let I=0;const m=Date.now();Object.defineProperties(b,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-m,enumerable:!0},"common.sequence":{get:()=>I++,enumerable:!0}}),P.$l&&(b["common.snap"]="true");const s=O(w);return s&&(b["common.platformDetail"]=s),b}function k(A){const w=c.env.USERDNSDOMAIN;if(!w)return!1;const E=w.toLowerCase();return A.some($=>E===$)}}),define(ce[18],le([0,1,4]),function(ne,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$jm=e.$im=e.$hm=e.$gm=e.$fm=e.$em=e.$dm=e.$cm=e.$bm=e.$am=e.$_l=e.$$l=void 0,e.$$l=(0,P.$Fi)("telemetryService"),e.$_l=(0,P.$Fi)("customEndpointTelemetryService"),e.$am="telemetry.currentSessionDate",e.$bm="telemetry.firstSessionDate",e.$cm="telemetry.lastSessionDate",e.$dm="telemetry.machineId",e.$em="telemetry.sqmId",e.$fm="telemetry.devDeviceId",e.$gm="telemetry",e.$hm="telemetry.telemetryLevel",e.$im="telemetry.enableCrashReporter",e.$jm="telemetry.enableTelemetry";var c;(function(O){O[O.NONE=0]="NONE",O[O.CRASH=1]="CRASH",O[O.ERROR=2]="ERROR",O[O.USAGE=3]="USAGE"})(c||(e.TelemetryLevel=c={}));var N;(function(O){O.OFF="off",O.CRASH="crash",O.ERROR="error",O.ON="all"})(N||(e.TelemetryConfiguration=N={}))}),define(ce[232],le([0,1,38,6,34,23,14,5,55,9,150,31,156,98,7,24,18]),function(ne,e,P,c,N,O,T,k,A,w,E,$,u,p,l,d,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Us=void 0,e.$Rs=b,e.$Ss=m,e.$Ts=s,P=Oe(P);const f=new Map;async function b(i,a){const t=`${i}::${a.join(":")}`,n=f.get(t);if(n)return n;const o=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],h=new Map,g=new Map,R=2e4;function L(v,C,F,D){const M=C.substring(v.length+1);return c.Promises.withAsyncBody(async J=>{let H;D.readdirCount++;try{H=await $.Promises.readdir(C,{withFileTypes:!0})}catch{J();return}if(D.count>=R){D.count+=H.length,D.maxReached=!0,J();return}let x=H.length;if(x===0){J();return}let K=H;D.count+H.length>R&&(D.maxReached=!0,x=R-D.count,K=H.slice(0,x)),D.count+=H.length;for(const ie of K)if(ie.isDirectory()){if(F.includes(ie.name)||await L(v,(0,T.$lc)(C,ie.name),F,D),--x===0){J();return}}else{const V=ie.name.lastIndexOf(".");if(V>=0){const z=ie.name.substring(V+1);z&&h.set(z,(h.get(z)??0)+1)}for(const z of o)z.relativePathPattern?.test(M)!==!1&&z.filePattern.test(ie.name)&&g.set(z.tag,(g.get(z.tag)??0)+1);if(--x===0){J();return}}})}const S=c.Promises.withAsyncBody(async v=>{const C={count:0,maxReached:!1,readdirCount:0},F=new A.$ge(!0);await L(i,i,a,C);const D=await s(i);v({configFiles:I(g),fileTypes:I(h),fileCount:C.count,maxFilesReached:C.maxReached,launchConfigFiles:D,totalScanTime:F.elapsed(),totalReaddirCount:C.readdirCount})});return f.set(t,S),S}function I(i){return Array.from(i.entries(),([a,t])=>({name:a,count:t})).sort((a,t)=>t.count-a.count)}function m(){const i={os:`${P.type()} ${P.arch()} ${P.release()}`,memory:`${(P.totalmem()/l.$Hl.GB).toFixed(2)}GB (${(P.freemem()/l.$Hl.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(E.$Pn.value()*100)}%`},a=P.cpus();return a&&a.length>0&&(i.cpus=`${a[0].model} (${a.length} x ${a[0].speed})`),i}async function s(i){try{const a=new Map,t=(0,T.$lc)(i,".vscode","launch.json"),n=await $.Promises.readFile(t),o=[],h=(0,N.$Vn)(n.toString(),o);if(o.length)return console.log(`Unable to parse ${t}`),[];if((0,N.$4n)(h)==="object"&&h.configurations)for(const g of h.configurations){const R=g.type;R&&(a.has(R)?a.set(R,a.get(R)+1):a.set(R,1))}return I(a)}catch{return[]}}let r=class{constructor(a,t){this.c=a,this.d=t}f(a){const t=[];return t.push(`OS Version:       ${a.os}`),t.push(`CPUs:             ${a.cpus}`),t.push(`Memory (System):  ${a.memory}`),t.push(`VM:               ${a.vmHint}`),t.join(`
`)}g(a){const t=[];t.push(`Version:          ${this.d.nameShort} ${this.d.version} (${this.d.commit||"Commit unknown"}, ${this.d.date||"Date unknown"})`),t.push(`OS Version:       ${P.type()} ${P.arch()} ${P.release()}`);const n=P.cpus();return n&&n.length>0&&t.push(`CPUs:             ${n[0].model} (${n.length} x ${n[0].speed})`),t.push(`Memory (System):  ${(P.totalmem()/l.$Hl.GB).toFixed(2)}GB (${(P.freemem()/l.$Hl.GB).toFixed(2)}GB free)`),k.$i||t.push(`Load (avg):       ${P.loadavg().map(o=>Math.round(o)).join(", ")}`),t.push(`VM:               ${Math.round(E.$Pn.value()*100)}%`),t.push(`Screen Reader:    ${a.screenReader?"yes":"no"}`),t.push(`Process Argv:     ${a.mainArguments.join(" ")}`),t.push(`GPU Status:       ${this.j(a.gpuFeatureStatus)}`),t.join(`
`)}async getPerformanceInfo(a,t){return Promise.all([(0,u.$Qs)(a.mainPID),this.k(a)]).then(async n=>{let[o,h]=n,g=this.m(a,o);return t.forEach(R=>{if((0,p.$Tm)(R))g+=`
${R.errorMessage}`,h+=`
${R.errorMessage}`;else if(g+=`

Remote: ${R.hostName}`,R.processes&&(g+=`
${this.m(a,R.processes)}`),R.workspaceMetadata){h+=`
|  Remote: ${R.hostName}`;for(const L of Object.keys(R.workspaceMetadata)){const S=R.workspaceMetadata[L];let v=`${S.fileCount} files`;S.maxFilesReached&&(v=`more than ${v}`),h+=`|    Folder (${L}): ${v}`,h+=this.h(S)}}}),{processInfo:g,workspaceInfo:h}})}async getSystemInfo(a,t){const{memory:n,vmHint:o,os:h,cpus:g}=m(),R={os:h,memory:n,cpus:g,vmHint:o,processArgs:`${a.mainArguments.join(" ")}`,gpuStatus:a.gpuFeatureStatus,screenReader:`${a.screenReader?"yes":"no"}`,remoteData:t};return k.$i||(R.load=`${P.loadavg().map(L=>Math.round(L)).join(", ")}`),k.$k&&(R.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(R)}async getDiagnostics(a,t){const n=[];return(0,u.$Qs)(a.mainPID).then(async o=>(n.push(""),n.push(this.g(a)),n.push(""),n.push(this.m(a,o)),a.windows.some(h=>h.folderURIs&&h.folderURIs.length>0&&!h.remoteAuthority)&&(n.push(""),n.push("Workspace Stats: "),n.push(await this.k(a))),t.forEach(h=>{if((0,p.$Tm)(h))n.push(`
${h.errorMessage}`);else if(n.push(`

`),n.push(`Remote:           ${h.hostName}`),n.push(this.f(h.machineInfo)),h.processes&&n.push(this.m(a,h.processes)),h.workspaceMetadata)for(const g of Object.keys(h.workspaceMetadata)){const R=h.workspaceMetadata[g];let L=`${R.fileCount} files`;R.maxFilesReached&&(L=`more than ${L}`),n.push(`Folder (${g}): ${L}`),n.push(this.h(R))}}),n.push(""),n.push(""),n.join(`
`)))}h(a){const t=[];let o=0;const h=(S,v)=>{const C=` ${S}(${v})`;o+C.length>60?(t.push(g),g="|                 ",o=g.length):o+=C.length,g+=C};let g="|      File types:";const R=10,L=a.fileTypes.length>R?R:a.fileTypes.length;for(let S=0;S<L;S++){const v=a.fileTypes[S];h(v.name,v.count)}if(t.push(g),a.configFiles.length>=0&&(g="|      Conf files:",o=0,a.configFiles.forEach(S=>{h(S.name,S.count)}),t.push(g)),a.launchConfigFiles.length>0){let S="|      Launch Configs:";a.launchConfigFiles.forEach(v=>{const C=v.count>1?` ${v.name}(${v.count})`:` ${v.name}`;S+=C}),t.push(S)}return t.join(`
`)}j(a){const t=Math.max(...Object.keys(a).map(n=>n.length));return Object.keys(a).map(n=>`${n}:  ${" ".repeat(t-n.length)}  ${a[n]}`).join(`
                  `)}k(a){const t=[],n=[];return a.windows.forEach(o=>{o.folderURIs.length===0||o.remoteAuthority||(t.push(`|  Window (${o.title})`),o.folderURIs.forEach(h=>{const g=w.URI.revive(h);if(g.scheme===O.Schemas.file){const R=g.fsPath;n.push(b(R,["node_modules",".git"]).then(L=>{let S=`${L.fileCount} files`;L.maxFilesReached&&(S=`more than ${S}`),t.push(`|    Folder (${(0,T.$pc)(R)}): ${S}`),t.push(this.h(L))}).catch(L=>{t.push(`|      Error: Unable to collect workspace stats for folder ${R} (${L.toString()})`)}))}else t.push(`|    Folder (${g.toString()}): Workspace stats not available.`)}))}),Promise.all(n).then(o=>t.join(`
`)).catch(o=>`Unable to collect workspace stats: ${o}`)}m(a,t){const n=new Map;a.windows.forEach(h=>n.set(h.pid,`window [${h.id}] (${h.title})`)),a.pidToNames.forEach(({pid:h,name:g})=>n.set(h,g));const o=[];return o.push("CPU %	Mem MB	   PID	Process"),t&&this.n(a.mainPID,n,o,t,0),o.join(`
`)}n(a,t,n,o,h){const g=h===0;let R;g?R=o.pid===a?`${this.d.applicationName} main`:"remote agent":t.has(o.pid)?R=t.get(o.pid):R=`${"  ".repeat(h)} ${o.name}`;const L=process.platform==="win32"?o.mem:P.totalmem()*(o.mem/100);n.push(`${o.load.toFixed(0).padStart(5," ")}	${(L/l.$Hl.MB).toFixed(0).padStart(6," ")}	${o.pid.toFixed(0).padStart(6," ")}	${R}`),Array.isArray(o.children)&&o.children.forEach(S=>this.n(a,t,n,S,h+1))}async getWorkspaceFileExtensions(a){const t=new Set;for(const{uri:n}of a.folders){const o=w.URI.revive(n);if(o.scheme!==O.Schemas.file)continue;const h=o.fsPath;try{(await b(h,["node_modules",".git"])).fileTypes.forEach(R=>t.add(R.name))}catch{}}return{extensions:[...t]}}async reportWorkspaceStats(a){for(const{uri:t}of a.folders){const n=w.URI.revive(t);if(n.scheme!==O.Schemas.file)continue;const o=n.fsPath;try{const h=await b(o,["node_modules",".git"]);this.c.publicLog2("workspace.stats",{"workspace.id":a.telemetryId,rendererSessionId:a.rendererSessionId}),h.fileTypes.forEach(g=>{this.c.publicLog2("workspace.stats.file",{rendererSessionId:a.rendererSessionId,type:g.name,count:g.count})}),h.launchConfigFiles.forEach(g=>{this.c.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:a.rendererSessionId,type:g.name,count:g.count})}),h.configFiles.forEach(g=>{this.c.publicLog2("workspace.stats.configFiles",{rendererSessionId:a.rendererSessionId,type:g.name,count:g.count})}),this.c.publicLog2("workspace.stats.metadata",{duration:h.totalScanTime,reachedLimit:h.maxFilesReached,fileCount:h.fileCount,readdirCount:h.totalReaddirCount})}catch{}}}};e.$Us=r,e.$Us=r=ve([Y(0,y.$$l),Y(1,d.$sk)],r)}),define(ce[111],le([0,1,8,4,10,18]),function(ne,e,P,c,N,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oq=e.$nq=e.ExtensionSignatureVerificationCode=e.$mq=void 0,e.$mq=(0,c.$Fi)("IExtensionSignatureVerificationService");var T;(function(w){w.Success="Success",w.RequiredArgumentMissing="RequiredArgumentMissing",w.InvalidArgument="InvalidArgument",w.PackageIsUnreadable="PackageIsUnreadable",w.UnhandledException="UnhandledException",w.SignatureManifestIsMissing="SignatureManifestIsMissing",w.SignatureManifestIsUnreadable="SignatureManifestIsUnreadable",w.SignatureIsMissing="SignatureIsMissing",w.SignatureIsUnreadable="SignatureIsUnreadable",w.CertificateIsUnreadable="CertificateIsUnreadable",w.SignatureArchiveIsUnreadable="SignatureArchiveIsUnreadable",w.FileAlreadyExists="FileAlreadyExists",w.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip",w.SignatureArchiveHasSameSignatureFile="SignatureArchiveHasSameSignatureFile",w.PackageIntegrityCheckFailed="PackageIntegrityCheckFailed",w.SignatureIsInvalid="SignatureIsInvalid",w.SignatureManifestIsInvalid="SignatureManifestIsInvalid",w.SignatureIntegrityCheckFailed="SignatureIntegrityCheckFailed",w.EntryIsMissing="EntryIsMissing",w.EntryIsTampered="EntryIsTampered",w.Untrusted="Untrusted",w.CertificateRevoked="CertificateRevoked",w.SignatureIsNotValid="SignatureIsNotValid",w.UnknownError="UnknownError",w.PackageIsInvalidZip="PackageIsInvalidZip",w.SignatureArchiveHasTooManyEntries="SignatureArchiveHasTooManyEntries"})(T||(e.ExtensionSignatureVerificationCode=T={}));class k extends Error{constructor(E){super(E),this.code=E}}e.$nq=k;let A=class{constructor(E,$){this.b=E,this.c=$}d(){return this.a||(this.a=new Promise((E,$)=>ne(["@vscode/vsce-sign"],async u=>E(u),$))),this.a}async verify(E,$,u,p){let l;const d=E.identifier.id;try{l=await this.d()}catch(I){return this.b.error("Could not load vsce-sign module",(0,P.$_)(I)),this.b.info(`Extension signature verification is not done: ${d}`),!1}const y=new Date().getTime();let f;try{this.b.trace(`Verifying extension signature for ${d}...`),f=await l.verify($,u,this.b.getLevel()===N.LogLevel.Trace)}catch(I){f={code:T.UnknownError,didExecute:!1,output:(0,P.$_)(I)}}const b=new Date().getTime()-y;if(this.b.info(`Extension signature verification result for ${d}: ${f.code}. Executed: ${f.didExecute}. Duration: ${b}ms.`),this.b.trace(`Extension signature verification output for ${d}:
${f.output}`),this.c.publicLog2("extensionsignature:verification",{extensionId:d,extensionVersion:E.version,code:f.code,internalCode:f.internalCode,duration:b,didExecute:f.didExecute,clientTargetPlatform:p}),f.code===T.Success)return!0;throw new k(f.code)}};e.$oq=A,e.$oq=A=ve([Y(0,N.$_j),Y(1,O.$$l)],A)}),define(ce[112],le([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Efc=e.$Dfc=void 0;class P{constructor(O){this.b=O}listen(O,T){throw new Error(`Event not found: ${T}`)}call(O,T,{eventName:k,data:A}){return this.b.forEach(w=>w.log(k,A)),Promise.resolve(null)}}e.$Dfc=P;class c{constructor(O){this.b=O}log(O,T){return this.b.call("log",{eventName:O,data:T}).then(void 0,k=>`Failed to log telemetry: ${console.warn(k)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.$Efc=c}),define(ce[49],le([0,1,30,13,106,110,18]),function(ne,e,P,c,N,O,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yp=e.$xp=e.$wp=e.$vp=e.$up=e.$tp=e.$sp=void 0,e.$zp=E,e.$Ap=$,e.$Bp=u,e.$Cp=p,e.$Dp=d,e.$Ep=f,e.$Fp=b,e.$Gp=s;class k{constructor(i){this.value=i,this.isTrustedTelemetryValue=!0}}e.$sp=k;class A{constructor(){this.telemetryLevel=T.TelemetryLevel.NONE,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.devDeviceId="someValue.devDeviceId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$tp=A,e.$up=new A;class w{async publicLog(i,a,t){}async publicLogError(i,a,t){}}e.$vp=w,e.$wp="telemetry",e.$xp="extensionTelemetryLog",e.$yp={log:()=>null,flush:()=>Promise.resolve(null)};function E(r,i){return!i.isBuilt&&!i.disableTelemetry?!0:!(i.disableTelemetry||!r.enableTelemetry)}function $(r,i){return i.extensionTestsLocationURI?!0:!(i.isBuilt||i.disableTelemetry||r.enableTelemetry&&r.aiConfig?.ariaKey)}function u(r){const i=r.getValue(T.$hm),a=r.getValue(T.$im);if(r.getValue(T.$jm)===!1||a===!1)return T.TelemetryLevel.NONE;switch(i??T.TelemetryConfiguration.ON){case T.TelemetryConfiguration.ON:return T.TelemetryLevel.USAGE;case T.TelemetryConfiguration.ERROR:return T.TelemetryLevel.ERROR;case T.TelemetryConfiguration.CRASH:return T.TelemetryLevel.CRASH;case T.TelemetryConfiguration.OFF:return T.TelemetryLevel.NONE}}function p(r){const i={},a={},t={};y(r,t);for(let n in t){n=n.length>150?n.substr(n.length-149):n;const o=t[n];typeof o=="number"?a[n]=o:typeof o=="boolean"?a[n]=o?1:0:typeof o=="string"?(o.length>8192&&console.warn(`Telemetry property: ${n} has been trimmed to 8192, the original length is ${o.length}`),i[n]=o.substring(0,8191)):typeof o<"u"&&o!==null&&(i[n]=o)}return{properties:i,measurements:a}}const l=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function d(r){if(!r)return"none";const i=(0,N.$hn)(r);return l.has(i)?i:"other"}function y(r,i,a=0,t){if(r)for(const n of Object.getOwnPropertyNames(r)){const o=r[n],h=t?t+n:n;Array.isArray(o)?i[h]=(0,P.$go)(o):o instanceof Date?i[h]=o.toISOString():(0,c.$hg)(o)?a<2?y(o,i,a+1,h+"."):i[h]=(0,P.$go)(o):i[h]=o}}function f(r,i){const a=r.msftInternalDomains||[],t=i.getValue("telemetry.internalTesting");return(0,O.$rp)(a)||t}function b(r){return[r.appRoot,r.extensionsPath,r.userHome.fsPath,r.tmpDir.fsPath,r.userDataPath]}function I(r,i){if(!r||!r.includes("/")&&!r.includes("\\"))return r;let a=r;const t=[];for(const g of i)for(;;){const R=g.exec(r);if(!R)break;t.push([R.index,g.lastIndex])}const n=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,o=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let h=0;for(a="";;){const g=o.exec(r);if(!g)break;const R=t.some(([L,S])=>g.index<S&&L<o.lastIndex);!n.test(g[0])&&!R&&(a+=r.substring(h,g.index)+"<REDACTED: user-file-path>",h=o.lastIndex)}return h<r.length&&(a+=r.substr(h)),a}function m(r){if(!r)return r;const i=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"CLI Credentials",regex:/((login|psexec|(certutil|psexec)\.exe).{1,50}(\s-u(ser(name)?)?\s+.{3,100})?\s-(admin|user|vm|root)?p(ass(word)?)?\s+["']?[^$\-\/\s]|(^|[\s\r\n\\])net(\.exe)?.{1,5}(user\s+|share\s+\/user:| user -? secrets ? set) \s + [^ $\s \/])/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const a of i)if(a.regex.test(r))return`<REDACTED: ${a.label}>`;return r}function s(r,i){return(0,P.$do)(r,a=>{if(a instanceof k||Object.hasOwnProperty.call(a,"isTrustedTelemetryValue"))return a.value;if(typeof a=="string"){let t=a.replaceAll("%20"," ");t=I(t,i);for(const n of i)t=t.replace(n,"");return t=m(t),t}})}}),define(ce[33],le([0,1,27,28,37,5,9,8,36,49]),function(ne,e,P,c,N,O,T,k,A,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qp=e.$Ip=void 0,e.$Hp=E,e.$Jp=l,e.$Kp=d,e.$Lp=y,e.$Mp=f,e.$Np=b,e.$Op=I,e.$Pp=m,e.$Rp=s,e.$Sp=i;function E(a,t){return a.uuid&&t.uuid?a.uuid===t.uuid:a.id===t.id?!0:(0,P.$Bf)(a.id,t.id)===0}const $=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class u{static create(t){const n=t.manifest?t.manifest.version:t.version,o=t.manifest?t.targetPlatform:t.properties.targetPlatform;return new u(t.identifier,n,o)}static parse(t){const n=$.exec(t);return n&&n[1]&&n[2]?new u({id:n[1]},n[2],n[4]||void 0):null}constructor(t,n,o=N.TargetPlatform.UNDEFINED){this.identifier=t,this.version=n,this.targetPlatform=o,this.id=t.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!==N.TargetPlatform.UNDEFINED?`-${this.targetPlatform}`:""}`}equals(t){return t instanceof u?E(this,t)&&this.version===t.version&&this.targetPlatform===t.targetPlatform:!1}}e.$Ip=u;const p=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function l(a){const t=p.exec(a);return t&&t[1]?[y(t[1]),t[2]]:[y(a),void 0]}function d(a,t){return`${a}.${t}`}function y(a){return a.toLowerCase()}function f(a,t){return y(d(a??N.$mn,t))}function b(a,t){const n=[],o=h=>{for(const g of n)if(g.some(R=>E(t(R),t(h))))return g;return null};for(const h of a){const g=o(h);g?g.push(h):n.push([h])}return n}function I(a){return{id:a.identifier.id,name:a.manifest.name,galleryId:null,publisherId:a.publisherId,publisherName:a.manifest.publisher,publisherDisplayName:a.publisherDisplayName,dependencies:a.manifest.extensionDependencies&&a.manifest.extensionDependencies.length>0}}function m(a){return{id:new w.$sp(a.identifier.id),name:new w.$sp(a.name),version:a.version,galleryId:a.identifier.uuid,publisherId:a.publisherId,publisherName:a.publisher,publisherDisplayName:a.publisherDisplayName,isPreReleaseVersion:a.properties.isPreReleaseVersion,dependencies:!!(a.properties.dependencies&&a.properties.dependencies.length>0),isSigned:a.isSigned,...a.telemetryData}}e.$Qp=new N.$qn("pprice.better-merge");function s(a,t){const n=[],o=t.manifest.extensionDependencies?.slice(0)??[];for(;o.length;){const h=o.shift();if(h&&n.every(g=>!E(g.identifier,{id:h}))){const g=a.filter(R=>E(R.identifier,{id:h}));g.length===1&&(n.push(g[0]),o.push(...g[0].manifest.extensionDependencies?.slice(0)??[]))}}return n}async function r(a,t){if(!O.$k)return!1;let n;try{n=(await a.readFile(T.URI.file("/etc/os-release"))).value.toString()}catch{try{n=(await a.readFile(T.URI.file("/usr/lib/os-release"))).value.toString()}catch(h){t.debug("Error while getting the os-release file.",(0,k.$_)(h))}}return!!n&&(n.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function i(a,t){const n=await r(a,t),o=(0,c.$cp)(n?"alpine":O.$u,A.$gc);return t.debug("ComputeTargetPlatform:",o),o}}),define(ce[233],le([0,1,26,28,33,37]),function(ne,e,P,c,N,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$y6b=T;async function T(k,A,w,E,$){try{const u=await k.getExtensionsControlManifest();if(!u.deprecated)return;const p=await k.getInstalled(O.ExtensionType.User);for(const[l,d]of Object.entries(u.deprecated)){if(!d?.extension)continue;const{id:y,autoMigrate:f,preRelease:b}=d.extension;if(!f)continue;const I=p.find(s=>(0,N.$Hp)(s.identifier,{id:l}));if(!I)continue;const m=(await A.getExtensions([{id:y,preRelease:b}],{targetPlatform:await k.getTargetPlatform(),compatible:!0},P.CancellationToken.None))[0];if(!m){$.info(`Skipping migrating '${I.identifier.id}' extension because, the comaptible target '${y}' extension is not found`);continue}try{$.info(`Migrating '${I.identifier.id}' extension to '${y}' extension...`);const s=!E.getDisabledExtensions().some(i=>(0,N.$Hp)(i,I.identifier));await k.uninstall(I),$.info(`Uninstalled the unsupported extension '${I.identifier.id}'`);let r=p.find(i=>(0,N.$Hp)(i.identifier,{id:y}));(!r||!r.isPreReleaseVersion&&s)&&(r=await k.installFromGallery(m,{installPreReleaseVersion:!0,isMachineScoped:I.isMachineScoped,operation:c.InstallOperation.Migrate}),$.info(`Installed the pre-release extension '${r.identifier.id}'`),s||(await E.disableExtension(r.identifier),$.info(`Disabled the pre-release extension '${r.identifier.id}' because the unsupported extension '${I.identifier.id}' is disabled`)),f.storage&&(w.addToMigrationList((0,N.$Kp)(I.manifest.publisher,I.manifest.name),(0,N.$Kp)(r.manifest.publisher,r.manifest.name)),$.info("Added pre-release extension to the storage migration list"))),$.info(`Migrated '${I.identifier.id}' extension to '${y}' extension.`)}catch(s){$.error(s)}}}catch(u){$.error(u)}}}),define(ce[234],le([0,1,3,2,35,33,37,7]),function(ne,e,P,c,N,O,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qq=void 0;class A extends c.$Wc{constructor(E,$,u,p,l,d,y){super(),this.f=E,this.g=$,this.h=u,this.j=p,this.m=l,this.n=d,this.r=y,this.a=this.B(new P.$me),this.onDidChangeExtensionsByAnotherSource=this.a.event,this.b=new Map,this.c=this.B(new c.$6c),this.s().then(null,f=>y.error(f))}async s(){await this.g.initializeDefaultProfileExtensions(),await this.u(this.h.profiles),this.t(),await this.H()}t(){this.B(this.h.onDidChangeProfiles(E=>this.u(E.added))),this.B(this.j.onAddExtensions(E=>this.w(E))),this.B(this.j.onDidAddExtensions(E=>this.y(E))),this.B(this.j.onRemoveExtensions(E=>this.z(E))),this.B(this.j.onDidRemoveExtensions(E=>this.C(E))),this.B(this.n.onDidFilesChange(E=>this.D(E)))}async u(E){try{E.length&&await Promise.all(E.map($=>(this.c.set($.id,(0,c.$Tc)(this.n.watch(this.m.extUri.dirname($.extensionsResource)),this.n.watch($.extensionsResource))),this.G($.extensionsResource))))}catch($){throw this.r.error($),$}}async w(E){for(const $ of E.extensions)this.I(this.L($.identifier,$.version),E.profileLocation)}async y(E){for(const $ of E.extensions){const u=this.L($.identifier,$.version);E.error?this.J(u,E.profileLocation):this.I(u,E.profileLocation)}}async z(E){for(const $ of E.extensions)this.J(this.L($.identifier,$.version),E.profileLocation)}async C(E){const $=[],u=[];for(const p of E.extensions){const l=this.L(p.identifier,p.version);E.error?this.I(l,E.profileLocation):(this.J(l,E.profileLocation),this.b.has(l)||(this.r.debug("Extension is removed from all profiles",p.identifier.id,p.version),u.push(this.f.scanInstalledExtensionAtLocation(p.location).then(d=>{d?$.push(d):this.r.info("Extension not found at the location",p.location.toString())},d=>this.r.error(d)))))}try{await Promise.all(u),$.length&&await this.H($)}catch(p){this.r.error(p)}}D(E){for(const $ of this.h.profiles)E.contains($.extensionsResource,k.FileChangeType.UPDATED,k.FileChangeType.ADDED)&&this.F($.extensionsResource)}async F(E){const $=[],u=[],p=await this.j.scanProfileExtensions(E),l=new Set,d=new Set;for(const[y,f]of this.b)f.has(E)&&d.add(y);for(const y of p){const f=this.L(y.identifier,y.version);l.add(f),d.has(f)||($.push(y.identifier),this.I(f,E))}for(const y of d)if(!l.has(y)){const f=this.M(y);f&&(u.push(f.identifier),this.J(y,E))}($.length||u.length)&&this.a.fire({added:$.length?{extensions:$,profileLocation:E}:void 0,removed:u.length?{extensions:u,profileLocation:E}:void 0})}async G(E){const $=await this.j.scanProfileExtensions(E);for(const u of $)this.I(this.L(u.identifier,u.version),E)}async H(E){E||(E=(await this.f.scanAllUserInstalledExtensions()).filter(u=>!this.b.has(this.L(u.identifier,u.manifest.version)))),E.length&&await this.f.markAsUninstalled(...E)}I(E,$){let u=this.b.get(E);u||this.b.set(E,u=new N.$Dc(p=>this.m.extUri.getComparisonKey(p))),u.add($)}J(E,$){const u=this.b.get(E);u&&u.delete($),u?.size||this.b.delete(E)}L(E,$){return`${T.$qn.toKey(E.id)}@${$}`}M(E){const[$,u]=(0,O.$Jp)(E);return u?{identifier:{id:$},version:u}:void 0}}e.$Qq=A}),define(ce[235],le([0,1,76,19,6,2,23,14,31,16,28,33,10,79,9]),function(ne,e,P,c,N,O,T,k,A,w,E,$,u,p,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7r=void 0;let d=class extends p.$6r{constructor(I,m,s,r){super(s),this.h=I,this.j=r,this.g=this.B(new y(m,r)),this.h.registerParticipant({postInstall:async i=>this.m(i),postUninstall:async i=>this.n(i)})}async getBuiltInExtensionTranslationsUri(I,m){const r=(await this.g.getLanguagePacks())[m];if(!r){this.j.warn(`No language pack found for ${m}`);return}const i=r.translations[I];return i?l.URI.file(i):void 0}async getInstalledLanguages(){const I=await this.g.getLanguagePacks(),m=Object.keys(I).map(s=>{const r=I[s];return{...this.f(s,r.label),extensionId:r.extensions[0].extensionIdentifier.id}});return m.push(this.f("en","English")),m.sort((s,r)=>s.label.localeCompare(r.label)),m}async m(I){I&&I.manifest&&I.manifest.contributes&&I.manifest.contributes.localizations&&I.manifest.contributes.localizations.length&&(this.j.info("Adding language packs from the extension",I.identifier.id),await this.update())}async n(I){const m=await this.g.getLanguagePacks();Object.keys(m).some(s=>m[s]&&m[s].extensions.some(r=>(0,$.$Hp)(r.extensionIdentifier,I.identifier)))&&(this.j.info("Removing language packs from the extension",I.identifier.id),await this.update())}async update(){const[I,m]=await Promise.all([this.g.getLanguagePacks(),this.h.getInstalled()]),s=await this.g.update(m);return!(0,c.$wb)(Object.keys(I),Object.keys(s))}};e.$7r=d,e.$7r=d=ve([Y(0,E.$jp),Y(1,w.$Ni),Y(2,E.$gp),Y(3,u.$_j)],d);let y=class extends O.$Wc{constructor(I,m){super(),this.j=m,this.c={},this.f=(0,k.$lc)(I.userDataPath,"languagepacks.json"),this.g=new N.$Mh}getLanguagePacks(){return this.g.size||!this.h?this.s().then(()=>this.c):Promise.resolve(this.c)}update(I){return this.s(m=>{Object.keys(m).forEach(s=>delete m[s]),this.m(m,...I)}).then(()=>this.c)}m(I,...m){for(const s of m)s&&s.manifest&&s.manifest.contributes&&s.manifest.contributes.localizations&&s.manifest.contributes.localizations.length&&this.n(I,s);Object.keys(I).forEach(s=>this.r(I[s]))}n(I,m){const s=m.identifier,r=m.manifest.contributes&&m.manifest.contributes.localizations?m.manifest.contributes.localizations:[];for(const i of r)if(m.location.scheme===T.Schemas.file&&f(i)){let a=I[i.languageId];a||(a={hash:"",extensions:[],translations:{},label:i.localizedLanguageName??i.languageName},I[i.languageId]=a);const t=a.extensions.filter(n=>(0,$.$Hp)(n.extensionIdentifier,s))[0];t?t.version=m.manifest.version:a.extensions.push({extensionIdentifier:s,version:m.manifest.version});for(const n of i.translations)a.translations[n.id]=(0,k.$lc)(m.location.fsPath,n.path)}}r(I){if(I){const m=(0,P.createHash)("md5");for(const s of I.extensions)m.update(s.extensionIdentifier.uuid||s.extensionIdentifier.id).update(s.version);I.hash=m.digest("hex")}}s(I=()=>null){return this.g.queue(()=>{let m=null;return A.Promises.readFile(this.f,"utf8").then(void 0,s=>s.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(s)).then(s=>{try{return JSON.parse(s)}catch{return{}}}).then(s=>(m=I(s),s)).then(s=>{for(const i of Object.keys(s))s[i]||delete s[i];this.c=s,this.h=!0;const r=JSON.stringify(this.c);return this.j.debug("Writing language packs",r),A.Promises.writeFile(this.f,r)}).then(()=>m,s=>this.j.error(s))})}};y=ve([Y(0,w.$Ni),Y(1,u.$_j)],y);function f(b){if(typeof b.languageId!="string"||!Array.isArray(b.translations)||b.translations.length===0)return!1;for(const I of b.translations)if(typeof I.id!="string"||typeof I.path!="string")return!1;return!(b.languageName&&typeof b.languageName!="string"||b.localizedLanguageName&&typeof b.localizedLanguageName!="string")}}),define(ce[236],le([0,1,149,8,30,49]),function(ne,e,P,c,N,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$Q=void 0;const T="https://mobile.events.data.microsoft.com/OneCollector/1.0",k="https://mobile.events.data.microsoft.com/ping";async function A(E,$,u){const p=await(0,P.$oE)("@microsoft/1ds-core-js","dist/ms.core.js"),l=await(0,P.$oE)("@microsoft/1ds-post-js","dist/ms.post.js"),d=new p.AppInsightsCore,y=new l.PostChannel,f={instrumentationKey:E,endpointUrl:T,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[y]]};if(u){f.extensionConfig={};const b={alwaysUseXhrOverride:!0,ignoreMc1Ms0CookieProcessing:!0,httpXHROverride:u};f.extensionConfig[y.identifier]=b}return d.initialize(f,[]),d.addTelemetryInitializer(b=>{b.ext=b.ext??{},b.ext.web=b.ext.web??{},b.ext.web.consentDetails='{"GPC_DataSharingOptIn":false}',$&&(b.ext.utc=b.ext.utc??{},b.ext.utc.flags=8462029)}),d}class w{constructor($,u,p,l,d){this.e=$,this.f=u,this.g=p,this.h=d,this.c=T,this.d=k,this.g||(this.g={}),typeof l=="function"?this.a=l():this.a=l,this.b=null}i($){if(this.a){if(typeof this.a!="string"){$(this.a);return}this.b||(this.b=A(this.a,this.e,this.h)),this.b.then(u=>{$(u)},u=>{(0,c.$3)(u),console.error(u)})}}log($,u){if(!this.a)return;u=(0,N.$eo)(u,this.g),u=(0,O.$Cp)(u);const p=this.f+"/"+$;try{this.i(l=>{l.pluginVersionString=u?.properties.version??"Unknown",l.track({name:p,baseData:{name:p,properties:u?.properties,measurements:u?.measurements}})})}catch{}}flush(){return this.a?new Promise($=>{this.i(u=>{u.unload(!0,()=>{this.a=void 0,$(void 0)})})}):Promise.resolve(void 0)}}e.$$Q=w}),define(ce[113],le([0,1,2,178,16,10,24,49]),function(ne,e,P,c,N,O,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ucc=void 0;let A=class extends P.$Wc{constructor(E,$,u,p,l=""){super(),this.b=l;const d=$.getLogger(k.$wp);if(d)this.a=this.B(d);else{const f=(0,k.$Ap)(p,u)?" (Not Sent)":"",b=()=>(0,k.$zp)(p,u)&&E.getLevel()===O.LogLevel.Trace;this.a=this.B($.createLogger(k.$wp,{name:(0,c.localize)(0,null,f),hidden:!b()})),this.B(E.onDidChangeLogLevel(()=>$.setVisibility(k.$wp,b()))),this.a.info("Below are logs for every telemetry event sent from VS Code once the log level is set to trace."),this.a.info("===========================================================")}}flush(){return Promise.resolve(void 0)}log(E,$){this.a.trace(`${this.b}telemetry/${E}`,(0,k.$Cp)($))}};e.$Ucc=A,e.$Ucc=A=ve([Y(0,O.$_j),Y(1,O.$ak),Y(2,N.$Mi),Y(3,T.$sk)],A)});var it=this&&this.__importDefault||function(ne){return ne&&ne.__esModule?ne:{default:ne}};define(ce[114],le([0,1,2,30,5,27,179,22,48,103,24,44,18,49]),function(ne,e,P,c,N,O,T,k,A,w,E,$,u,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$as=void 0,w=it(w);let l=class{static{this.IDLE_START_EVENT_NAME="UserIdleStart"}static{this.IDLE_STOP_EVENT_NAME="UserIdleStop"}constructor(f,b,I){this.k=b,this.l=I,this.d={},this.i=new P.$Vc,this.j=[],this.b=f.appenders,this.c=f.commonProperties??Object.create(null),this.sessionId=this.c.sessionID,this.machineId=this.c["common.machineId"],this.sqmId=this.c["common.sqmId"],this.devDeviceId=this.c["common.devDeviceId"],this.firstSessionDate=this.c["common.firstSessionDate"],this.msftInternal=this.c["common.msftInternal"],this.f=f.piiPaths||[],this.g=u.TelemetryLevel.USAGE,this.h=!!f.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const m of this.f)this.j.push(new RegExp((0,O.$if)(m),"gi")),m.indexOf("\\")>=0&&this.j.push(new RegExp((0,O.$if)(m.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(m=>{(m.affectsConfiguration(u.$hm)||m.affectsConfiguration(u.$jm)||m.affectsConfiguration(u.$im))&&this.m()}))}setExperimentProperty(f,b){this.d[f]=b}m(){let f=(0,p.$Bp)(this.k);const b=this.l.enabledTelemetryLevels;if(b){this.h=this.sendErrorTelemetry?b.error:!1;const I=b.usage?u.TelemetryLevel.USAGE:b.error?u.TelemetryLevel.ERROR:u.TelemetryLevel.NONE;f=Math.min(f,I)}this.g=f}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}dispose(){this.i.dispose()}n(f,b,I){this.g<b||(I=(0,c.$eo)(I,this.d),I=(0,p.$Gp)(I,this.j),I=(0,c.$eo)(I,this.c),this.b.forEach(m=>m.log(f,I)))}publicLog(f,b){this.n(f,u.TelemetryLevel.USAGE,b)}publicLog2(f,b){this.publicLog(f,b)}publicLogError(f,b){this.h&&this.n(f,u.TelemetryLevel.ERROR,b)}publicLogError2(f,b){this.publicLogError(f,b)}};e.$as=l,e.$as=l=ve([Y(1,k.$_i),Y(2,E.$sk)],l);function d(){const y=(0,T.localize)(0,null,w.default.nameLong),f=w.default.privacyStatementUrl?(0,T.localize)(2,null,"https://aka.ms/vscode-telemetry",w.default.privacyStatementUrl):(0,T.localize)(1,null,"https://aka.ms/vscode-telemetry"),b=N.$o?"":(0,T.localize)(3,null),I=(0,T.localize)(4,null),m=(0,T.localize)(5,null),s=(0,T.localize)(6,null),r=(0,T.localize)(7,null),i=`
|       | ${I} | ${m} | ${s} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,a=(0,T.localize)(8,null);return`
${y} ${f} ${b}

&nbsp;

${r}
${i}

&nbsp;

${a}
`}$.$oo.as(A.$to.Configuration).registerConfiguration({id:u.$gm,order:1,type:"object",title:(0,T.localize)(9,null),properties:{[u.$hm]:{type:"string",enum:[u.TelemetryConfiguration.ON,u.TelemetryConfiguration.ERROR,u.TelemetryConfiguration.CRASH,u.TelemetryConfiguration.OFF],enumDescriptions:[(0,T.localize)(10,null),(0,T.localize)(11,null),(0,T.localize)(12,null),(0,T.localize)(13,null)],markdownDescription:d(),default:u.TelemetryConfiguration.ON,restricted:!0,scope:A.ConfigurationScope.APPLICATION,tags:["usesOnlineServices","telemetry"]}}}),$.$oo.as(A.$to.Configuration).registerConfiguration({id:u.$gm,order:110,type:"object",title:(0,T.localize)(14,null),properties:{[u.$jm]:{type:"boolean",markdownDescription:w.default.privacyStatementUrl?(0,T.localize)(16,null,w.default.nameLong,w.default.privacyStatementUrl):(0,T.localize)(15,null,w.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,T.localize)(17,null,`\`#${u.$hm}#\``),scope:A.ConfigurationScope.APPLICATION,tags:["usesOnlineServices","telemetry"]}}})}),define(ce[237],le([0,1,15,26,280,236]),function(ne,e,P,c,N,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_Q=void 0,N=Oe(N);async function T(E,$){const u=await $.request(E,c.CancellationToken.None),p=(await(0,P.$1e)(u.stream)).toString(),l=u.res.statusCode??200;return{headers:u.res.headers,statusCode:l,responseData:p}}async function k(E){const $={method:E.type,headers:E.headers};return new Promise((p,l)=>{const d=N.request(E.url??"",$,y=>{y.on("data",function(f){p({headers:y.headers,statusCode:y.statusCode??200,responseData:f.toString()})}),y.on("error",function(f){l(f)})});d.write(E.data,y=>{y&&l(y)}),d.end()})}async function A(E,$,u){const p=typeof $.data=="string"?$.data:new TextDecoder().decode($.data),l={type:"POST",headers:{...$.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength($.data).toString()},url:$.urlString,data:p};try{const d=E?await T(l,E):await k(l);u(d.statusCode,d.headers,d.responseData)}catch{u(0,{})}}class w extends O.$$Q{constructor($,u,p,l,d){const y={sendPOST:(f,b)=>{A($,f,b)}};super(u,p,l,d,y)}}e.$_Q=w}),define(ce[238],le([0,1,23,96,22,16,10,24,18,112,113,114]),function(ne,e,P,c,N,O,T,k,A,w,E,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sgc=void 0;let u=class{constructor(l,d,y,f,b,I){this.b=l,this.c=d,this.d=y,this.e=f,this.f=b,this.g=I,this.a=new Map}h(l){if(!this.a.has(l.id)){const d=Object.create(null);d["common.vscodemachineid"]=this.c.machineId,d["common.vscodesessionid"]=this.c.sessionId;const y=[l.id,JSON.stringify(d),l.aiKey],b=new c.$br(P.$Zg.asFileUri("bootstrap-fork").fsPath,{serverName:"Debug Telemetry",timeout:1e3*60*5,args:y,env:{ELECTRON_RUN_AS_NODE:1,VSCODE_PIPE_LOGGING:"true",VSCODE_AMD_ENTRYPOINT:"vs/workbench/contrib/debug/node/telemetryApp"}}).getChannel("telemetryAppender"),I=[new w.$Efc(b),new E.$Ucc(this.d,this.e,this.f,this.g,`[${l.id}] `)];this.a.set(l.id,new $.$as({appenders:I,sendErrorTelemetry:l.sendErrorTelemetry},this.b,this.g))}return this.a.get(l.id)}publicLog(l,d,y){this.h(l).publicLog(d,y)}publicLogError(l,d,y){this.h(l).publicLogError(d,y)}};e.$Sgc=u,e.$Sgc=u=ve([Y(0,N.$_i),Y(1,A.$$l),Y(2,T.$_j),Y(3,T.$ak),Y(4,O.$Mi),Y(5,k.$sk)],u)}),define(ce[81],le([0,1,3,2,5,9,22,4,10]),function(ne,e,P,c,N,O,T,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hw=e.$Gw=e.$Dw=e.$Bw=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.$xw=e.$ww=void 0,e.$yw=$,e.$zw=p,e.$Aw=l,e.$Cw=d,e.$Ew=y,e.$Fw=f,e.$ww=(0,k.$Fi)("tunnelService"),e.$xw=(0,k.$Fi)("sharedTunnelsService");var w;(function(m){m.Http="http",m.Https="https"})(w||(e.TunnelProtocol=w={}));var E;(function(m){m.ConstantPrivate="constantPrivate",m.Private="private",m.Public="public"})(E||(e.TunnelPrivacyId=E={}));function $(m){return!!m.forwardPort}var u;(function(m){m[m.Notify=1]="Notify",m[m.OpenBrowser=2]="OpenBrowser",m[m.OpenPreview=3]="OpenPreview",m[m.Silent=4]="Silent",m[m.Ignore=5]="Ignore",m[m.OpenBrowserOnce=6]="OpenBrowserOnce"})(u||(e.ProvidedOnAutoForward=u={}));function p(m){if(m.scheme!=="http"&&m.scheme!=="https")return;const s=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(m.authority);if(s)return{address:s[1],port:+s[2]}}function l(m){if(m.scheme!=="http"&&m.scheme!=="https"||!m.query)return;const s=m.query.split("&");for(const r of s){const i=r.split("=")[1];if(/^https?:/.exec(i)){const a=p(O.URI.parse(i));if(a)return a}}}e.$Bw=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function d(m){return e.$Bw.indexOf(m)>=0}e.$Dw=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function y(m){return e.$Dw.indexOf(m)>=0}function f(m,s,r,i){if(r===N.OperatingSystem.Windows)return!1;if(r===N.OperatingSystem.Macintosh&&y(s)){const a=/(\d+)\.(\d+)\.(\d+)/g.exec(i);if(a?.length===4&&parseInt(a[1])>=18)return!1}return m<1024}class b{constructor(s,r,i){this.remoteAddress=s,this.localAddress=r,this.b=i,this.a=new P.$me,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$Gw=b;let I=class extends c.$Wc{constructor(s,r){super(),this.r=s,this.s=r,this.a=new P.$me,this.onTunnelOpened=this.a.event,this.b=new P.$me,this.onTunnelClosed=this.b.event,this.c=new P.$me,this.onAddedTunnelProvider=this.c.event,this.f=new Map,this.h=!1,this.j=!0,this.m=[],this.n=new Set}get hasTunnelProvider(){return!!this.g}get t(){const s=this.s.getValue("remote.localPortHost");return!s||s==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(s){return this.g=s,s?(this.c.fire(),{dispose:()=>{this.g=void 0,this.h=!1,this.m=[]}}):(this.h=!1,this.m=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(s){this.h=s.elevation,this.m=s.privacyOptions,this.j=s.protocol}get canChangeProtocol(){return this.j}get canElevate(){return this.h}get canChangePrivacy(){return this.m.length>0}get privacyOptions(){return this.m}get tunnels(){return this.u()}async u(){const s=[],r=Array.from(this.f.values());for(const i of r){const a=Array.from(i.values());for(const t of a){const n=await t.value;n&&typeof n!="string"&&s.push(n)}}return s}async dispose(){super.dispose();for(const s of this.f.values()){for(const{value:r}of s.values())await r.then(i=>typeof i!="string"?i?.dispose():void 0);s.clear()}this.f.clear()}setEnvironmentTunnel(s,r,i,a,t){this.z(s,r,Promise.resolve({tunnelRemoteHost:s,tunnelRemotePort:r,localAddress:i,privacy:a,protocol:t,dispose:()=>Promise.resolve()}))}async getExistingTunnel(s,r){(y(s)||d(s))&&(s=e.$Bw[0]);const i=this.D(s,r);if(i)return++i.refcount,i.value}openTunnel(s,r,i,a,t,n=!1,o,h){this.r.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${r}:${i} on local port ${t}.`);const g=this.g??s;if(!g)return;if(r||(r="localhost"),a||(a=this.t),this.g&&this.n.has(i)){this.r.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const R=this.F(g,r,i,a,t,n,o,h);return R?R.then(L=>{if(L){if(typeof L=="string")return this.r.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.C(r,i),L}else{this.r.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.C(r,i);return}this.r.trace("ForwardedPorts: (TunnelService) New tunnel established.");const S=this.w(L);return(L.tunnelRemoteHost!==r||L.tunnelRemotePort!==i)&&this.r.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),o&&L.privacy!==o&&this.r.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(S),S}):(this.r.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),R)}w(s){return{tunnelRemotePort:s.tunnelRemotePort,tunnelRemoteHost:s.tunnelRemoteHost,tunnelLocalPort:s.tunnelLocalPort,localAddress:s.localAddress,privacy:s.privacy,protocol:s.protocol,dispose:async()=>{this.r.trace(`ForwardedPorts: (TunnelService) dispose request for ${s.tunnelRemoteHost}:${s.tunnelRemotePort} `);const r=this.f.get(s.tunnelRemoteHost);if(r){const i=r.get(s.tunnelRemotePort);i&&(i.refcount--,await this.y(s.tunnelRemoteHost,s.tunnelRemotePort,i))}}}}async y(s,r,i){if(i.refcount<=0){this.r.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${s}:${r}.`);const a=i.value.then(async t=>{t&&typeof t!="string"&&(await t.dispose(!0),this.b.fire({host:t.tunnelRemoteHost,port:t.tunnelRemotePort}))});return this.f.has(s)&&this.f.get(s).delete(r),a}}async closeTunnel(s,r){this.r.trace(`ForwardedPorts: (TunnelService) close request for ${s}:${r} `);const i=this.f.get(s);if(i&&i.has(r)){const a=i.get(r);a.refcount=0,await this.y(s,r,a)}}z(s,r,i){this.f.has(s)||this.f.set(s,new Map),this.f.get(s).set(r,{refcount:1,value:i})}async C(s,r){const i=this.f.get(s);if(i){const a=i.get(r),t=a?await a.value:void 0;(!t||typeof t=="string")&&i.delete(r),i.size===0&&this.f.delete(s)}}D(s,r){const i=[s];d(s)?(i.push(...e.$Bw),i.push(...e.$Dw)):y(s)&&i.push(...e.$Dw);const a=i.map(t=>this.f.get(t));for(const t of a){const n=t?.get(r);if(n)return n}}canTunnel(s){return!!p(s)}G(s,r,i,a,t,n,o){this.r.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${r}:${i} on local port ${a}.`);const h=i;this.n.add(h);const g=a===void 0?i:a,R={elevationRequired:t?this.isPortPrivileged(g):!1},L={remoteAddress:{host:r,port:i},localAddressPort:a,privacy:n,public:n?n!==E.Private:void 0,protocol:o},S=s.forwardPort(L,R);return S?(this.z(r,i,S),S.finally(()=>{this.r.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.n.delete(h)})):this.n.delete(h),S}};e.$Hw=I,e.$Hw=I=ve([Y(0,A.$_j),Y(1,T.$_i)],I)}),define(ce[239],le([0,1,10,81,2,8,6]),function(ne,e,P,c,N,O,T){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.$3gc=void 0;class A extends N.$Wc{constructor(){super(),this.a=null,this.b=null}async getAddress(){return this.a?this.a:(this.b||(this.b=new T.$3h),this.b.p)}setAddress($){this.a=$,this.b&&(this.b.complete($),this.b=null)}setTunnel($){this.B($)}}let w=class extends N.$Wc{static{k=this}static{this.a=0}constructor($,u){super(),this.f=$,this.g=u,this.b=new Map,this.c=new Set}dispose(){super.dispose(),this.b.forEach($=>$.dispose())}async createTunnel(){return{id:String(++k.a)}}async startTunnel($,u,p,l,d,y,f){const b=new A,I=await Promise.resolve(this.f.openTunnel($,b,p,l,d,y,f));if(!I||typeof I=="string")throw this.g.info(`[SharedProcessTunnelService] Could not create a tunnel to ${p}:${l} (remote).`),b.dispose(),new Error("Could not create tunnel");if(this.c.has(u))throw this.c.delete(u),b.dispose(),await I.dispose(),(0,O.$8)();return b.setTunnel(I),this.b.set(u,b),this.g.info(`[SharedProcessTunnelService] Created tunnel ${u}: ${I.localAddress} (local) to ${p}:${l} (remote).`),{tunnelLocalPort:I.tunnelLocalPort,localAddress:I.localAddress}}async setAddress($,u){const p=this.b.get($);p&&p.setAddress(u)}async destroyTunnel($){const u=this.b.get($);if(u){this.g.info(`[SharedProcessTunnelService] Disposing tunnel ${$}.`),this.b.delete($),await u.dispose();return}this.c.add($)}};e.$3gc=w,e.$3gc=w=k=ve([Y(0,c.$xw),Y(1,P.$_j)],w)}),define(ce[29],le([0,1,4]),function(ne,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jl=void 0,e.$Jl=(0,P.$Fi)("IUriIdentityService")}),define(ce[240],le([0,1,29,196,7,21,133,3,2]),function(ne,e,P,c,N,O,T,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ns=void 0;class w{static{this._clock=0}constructor(u){this.uri=u,this.time=w._clock++}touch(){return this.time=w._clock++,this}}let E=class{constructor(u){this.g=u,this.c=new A.$Vc,this.f=2**16;const p=new Map,l=d=>{let y=p.get(d.scheme);return y===void 0&&(y=u.hasProvider(d)&&!this.g.hasCapability(d,N.FileSystemProviderCapabilities.PathCaseSensitive),p.set(d.scheme,y)),y};this.c.add(k.Event.any(u.onDidChangeFileSystemProviderRegistrations,u.onDidChangeFileSystemProviderCapabilities)(d=>{p.delete(d.scheme)})),this.extUri=new O.$8g(l),this.d=new T.$Ms((d,y)=>this.extUri.compare(d,y,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(u){this.g.hasProvider(u)&&(u=(0,O.$hh)(u));const p=this.d.get(u);return p?p.touch().uri.with({fragment:u.fragment}):(this.d.set(u,new w(u)),this.h(),u)}h(){if(this.d.size<this.f)return;const u=[...this.d.entries()].sort((l,d)=>l[1].time<d[1].time?1:l[1].time>d[1].time?-1:0);w._clock=0,this.d.clear();const p=this.f*.5;for(let l=0;l<p;l++)this.d.set(u[l][0],u[l][1].touch())}};e.$Ns=E,e.$Ns=E=ve([Y(0,N.$_k)],E),(0,c.$Ks)(P.$Jl,E,c.InstantiationType.Delayed)}),define(ce[241],le([0,1,3,2,7,52,35]),function(ne,e,P,c,N,O,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tgc=void 0;class k extends c.$Wc{constructor(w,E,$,u,p,l){super(),this.f=w,this.g=E,this.h=$,this.j=u,this.m=p,this.n=l,this.capabilities=this.g.capabilities,this.onDidChangeCapabilities=this.g.onDidChangeCapabilities,this.a=this.B(new P.$me),this.onDidChangeFile=this.a.event,this.b=O.$Li.forUris(()=>!(this.capabilities&N.FileSystemProviderCapabilities.PathCaseSensitive)),this.c=new T.$Dc(d=>this.m.extUri.getComparisonKey(this.t(d))),this.r(),this.B(u.onDidChangeProfiles(()=>this.r())),this.B(this.g.onDidChangeFile(d=>this.s(d)))}r(){this.c.clear();for(const w of this.j.profiles)this.c.add(w.settingsResource),this.c.add(w.keybindingsResource),this.c.add(w.tasksResource),this.c.add(w.extensionsResource)}open(w,E){return this.g.open(this.t(w),E)}close(w){return this.g.close(w)}read(w,E,$,u,p){return this.g.read(w,E,$,u,p)}write(w,E,$,u,p){return this.g.write(w,E,$,u,p)}watch(w,E){this.b.set(w,w);const $=this.g.watch(this.t(w),E);return(0,c.$Uc)(()=>{this.b.delete(w),$.dispose()})}stat(w){return this.g.stat(this.t(w))}mkdir(w){return this.g.mkdir(this.t(w))}rename(w,E,$){return this.g.rename(this.t(w),this.t(E),$)}readFile(w,E){return this.g.readFile(this.t(w),E)}readFileStream(w,E,$){return this.g.readFileStream(this.t(w),E,$)}readdir(w){return this.g.readdir(this.t(w))}enforceAtomicReadFile(w){return this.c.has(w)}writeFile(w,E,$){return this.g.writeFile(this.t(w),E,$)}enforceAtomicWriteFile(w){return this.c.has(w)?{postfix:".vsctmp"}:!1}delete(w,E){return this.g.delete(this.t(w),E)}copy(w,E,$){if((0,N.$dl)(this.g))return this.g.copy(this.t(w),this.t(E),$);throw new Error("copy not supported")}cloneFile(w,E){if((0,N.$el)(this.g))return this.g.cloneFile(this.t(w),this.t(E));throw new Error("clone not supported")}s(w){const E=[];for(const $ of w){if($.resource.scheme!==this.f)continue;const u=this.u($.resource);this.b.findSubstr(u)&&E.push({resource:u,type:$.type,cId:$.cId})}E.length&&(this.n.debug("User data changed"),this.a.fire(E))}t(w){return w.with({scheme:this.f})}u(w){return w.with({scheme:this.h})}}e.$tgc=k}),define(ce[82],le([0,1,64]),function(ne,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.edit=c,e.$$Lb=N,e.$_Lb=O;function c(T,k,A,w){const E=(0,P.$0n)(T,k,A,w)[0];return E&&(T=T.substring(0,E.offset)+E.content+T.substring(E.offset+E.length)),T}function N(T,k,A){let w=A;for(;w>=0;){if(T.charAt(w)===k.charAt(k.length-1)&&k.length===1)return w+1;if(w--,k.length===2&&w>=0&&T.charAt(w)===k.charAt(0))return w+2}return 0}function O(T,k,A){let w=A;for(;w>=0;)if(T.charAt(w)===k.charAt(k.length-1)&&k.length===1||(w++,k.length===2&&w>=0&&T.charAt(w)===k.charAt(1)))return w;return T.length-1}}),define(ce[242],le([0,1,30,57,13]),function(ne,e,P,c,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ybc=O,c=Oe(c);function O(p,l,d,y,f,b){const I=[],m=[],s=[];if(!l){const M=p.filter(({identifier:J})=>f.every(H=>H.toLowerCase()!==J.id.toLowerCase()));return{local:{added:I,removed:m,updated:s},remote:M.length>0?{added:M,updated:[],removed:[],all:M}:null}}p=p.map($),l=l.map($),d=d?d.map($):null;const r=new Map,i=M=>{M.uuid&&r.set(M.id.toLowerCase(),M.uuid)};p.forEach(({identifier:M})=>i(M)),l.forEach(({identifier:M})=>i(M)),d?.forEach(({identifier:M})=>i(M)),y?.forEach(({identifier:M})=>i(M)),b?.forEach(M=>i(M));const a=M=>{const J=M.identifier.uuid||r.get(M.identifier.id.toLowerCase());return J?`uuid:${J}`:`id:${M.identifier.id.toLowerCase()}`},t=(M,J)=>(M.set(a(J),J),M),n=p.reduce(t,new Map),o=l.reduce(t,new Map),h=l.reduce((M,J)=>t(M,(0,P.$bo)(J)),new Map),g=d?d.reduce(t,new Map):null,R=y.reduce(t,new Map),L=f.reduce((M,J)=>{const H=r.get(J.toLowerCase());return M.add(H?`uuid:${H}`:`id:${J.toLowerCase()}`)},new Set),S=b?b.reduce((M,{id:J,uuid:H})=>(H=H??r.get(J.toLowerCase()),M.add(H?`uuid:${H}`:`id:${J.toLowerCase()}`)),new Set):null,v=T(n,o,L,!1);if(v.added.size>0||v.removed.size>0||v.updated.size>0){const M=T(g,n,L,!1),J=T(g,o,L,!0),H=(x,K,ie,V)=>{let z,ee,se;return K.installed?(z=V.pinned,se=V.preRelease,z&&(ee=V.version)):(z=ie.pinned,se=ie.preRelease,z&&(ee=ie.version)),z===void 0&&(z=K.pinned,z&&(ee=K.version)),se===void 0&&(se=K.preRelease),{...V,installed:K.installed||ie.installed,pinned:z,preRelease:se,version:ee??(ie.version&&(!K.installed||c.gt(ie.version,K.version))?ie.version:K.version),state:A(K,ie,g?.get(x))}};for(const x of J.removed.values()){const K=n.get(x);if(!K)continue;const ie=(0,N.$qg)(g?.get(x)),V=S&&!S.has(x)&&ie.installed;K.installed&&V?m.push(K.identifier):h.set(x,K)}for(const x of J.added.values()){const K=(0,N.$qg)(o.get(x)),ie=n.get(x);if(ie){if(v.updated.has(x)){const V=H(x,ie,K,K);k(ie,K,!1,!1)||s.push(u(V,x)),h.set(x,V)}}else K.installed&&I.push(u(K,x))}for(const x of J.updated.values()){const K=(0,N.$qg)(o.get(x)),ie=(0,N.$qg)(g?.get(x)),V=n.get(x);if(V)if(S&&!S.has(x)&&ie.installed&&V.installed&&!K.installed)m.push(V.identifier);else{const ee=H(x,V,K,K);s.push(u(ee,x)),h.set(x,ee)}else K.installed&&I.push(u(K,x))}for(const x of M.added.values())J.added.has(x)||h.set(x,(0,N.$qg)(n.get(x)));for(const x of M.updated.values()){if(J.removed.has(x)||J.updated.has(x))continue;const K=(0,N.$qg)(n.get(x)),ie=(0,N.$qg)(o.get(x));h.set(x,H(x,K,ie,K))}for(const x of M.removed.values())J.updated.has(x)||J.removed.has(x)||R.has(x)||(0,N.$qg)(o.get(x)).installed&&S&&(S.has(x)||!(0,N.$qg)(g?.get(x)).installed||h.delete(x))}const C=[],F=T(o,h,new Set,!0),D=F.added.size>0||F.updated.size>0||F.removed.size>0;return D&&h.forEach((M,J)=>C.push(u(M,J))),{local:{added:I,removed:m,updated:s},remote:D?{added:[...F.added].map(M=>h.get(M)),updated:[...F.updated].map(M=>h.get(M)),removed:[...F.removed].map(M=>o.get(M)),all:C}:null}}function T(p,l,d,y){const f=p?[...p.keys()].filter(r=>!d.has(r)):[],b=[...l.keys()].filter(r=>!d.has(r)),I=b.filter(r=>!f.includes(r)).reduce((r,i)=>(r.add(i),r),new Set),m=f.filter(r=>!b.includes(r)).reduce((r,i)=>(r.add(i),r),new Set),s=new Set;for(const r of f){if(m.has(r))continue;const i=p.get(r),a=l.get(r);(!a||!k(i,a,y,!0))&&s.add(r)}return{added:I,removed:m,updated:s}}function k(p,l,d,y){return!(p.disabled!==l.disabled||!!p.isApplicationScoped!=!!l.isApplicationScoped||y&&p.installed!==l.installed||p.installed&&l.installed&&(p.preRelease!==l.preRelease||p.pinned!==l.pinned||l.pinned&&p.version!==l.version)||!E(p.state,l.state)||d&&p.version!==l.version)}function A(p,l,d){const y=p.state,f=l.state,b=d?.state;if(!l.version||y&&c.gt(p.version,l.version))return y;if(f&&c.gt(l.version,p.version)||!y)return f;if(!f)return y;const I=(0,P.$bo)(y),m=b?w(b,f):{added:Object.keys(f).reduce((r,i)=>(r.add(i),r),new Set),removed:new Set,updated:new Set},s=b?w(b,y):{added:Object.keys(y).reduce((r,i)=>(r.add(i),r),new Set),removed:new Set,updated:new Set};for(const r of[...m.added.values(),...m.updated.values()])I[r]=f[r];for(const r of m.removed.values())s.updated.has(r)||delete I[r];return I}function w(p,l){const d=Object.keys(p),y=Object.keys(l),f=y.filter(m=>!d.includes(m)).reduce((m,s)=>(m.add(s),m),new Set),b=d.filter(m=>!y.includes(m)).reduce((m,s)=>(m.add(s),m),new Set),I=new Set;for(const m of d){if(b.has(m))continue;const s=p[m],r=l[m];(0,P.$fo)(s,r)||I.add(m)}return{added:f,removed:b,updated:I}}function E(p={},l={}){const{added:d,removed:y,updated:f}=w(p,l);return d.size===0&&y.size===0&&f.size===0}function $(p){return{...p,disabled:!!p.disabled,installed:!!p.installed}}function u(p,l){const d={...p,identifier:{id:p.identifier.id,uuid:l.startsWith("uuid:")?l.substring(5):void 0},preRelease:!!p.preRelease,pinned:!!p.pinned};return p.disabled||delete d.disabled,p.installed||delete d.installed,p.state||delete d.state,p.isApplicationScoped||delete d.isApplicationScoped,d}}),define(ce[115],le([0,1,19,22,4]),function(ne,e,P,c,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pOb=e.$oOb=void 0,e.$oOb=(0,N.$Fi)("IIgnoredExtensionsManagementService");let O=class{constructor(k){this.a=k}hasToNeverSyncExtension(k){return this.b().includes(k.toLowerCase())}hasToAlwaysSyncExtension(k){return this.b().includes(`-${k.toLowerCase()}`)}updateIgnoredExtensions(k,A){let w=[...this.a.getValue("settingsSync.ignoredExtensions")].map(E=>E.toLowerCase());return w=w.filter(E=>E!==k&&E!==`-${k}`),A&&w.push(k.toLowerCase()),this.a.updateValue("settingsSync.ignoredExtensions",w.length?w:void 0,c.ConfigurationTarget.USER)}updateSynchronizedExtensions(k,A){let w=[...this.a.getValue("settingsSync.ignoredExtensions")].map(E=>E.toLowerCase());return w=w.filter(E=>E!==k&&E!==`-${k}`),A&&w.push(`-${k.toLowerCase()}`),this.a.updateValue("settingsSync.ignoredExtensions",w.length?w:void 0,c.ConfigurationTarget.USER)}getIgnoredExtensions(k){const A=k.filter(u=>u.isMachineScoped).map(u=>u.identifier.id.toLowerCase()),w=this.b().map(u=>u.toLowerCase()),E=[],$=[];if(Array.isArray(w))for(const u of w)u.startsWith("-")?$.push(u.substring(1)):E.push(u);return(0,P.$Ob)([...A,...E].filter(u=>!$.includes(u)))}b(){let k=this.a.inspect("settingsSync.ignoredExtensions").userValue;return k!==void 0||(k=this.a.inspect("sync.ignoredExtensions").userValue,k!==void 0)?k:(this.a.getValue("settingsSync.ignoredExtensions")||[]).map(A=>A.toLowerCase())}};e.$pOb=O,e.$pOb=O=ve([Y(0,c.$_i)],O)}),define(ce[243],le([0,1,19,34,30,97,82]),function(ne,e,P,c,N,O,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ebc=A,N=Oe(N),T=Oe(T);function k(m){return(0,c.$Vn)(m)||[]}async function A(m,s,r,i,a){const t=k(m),n=k(s),o=r?k(r):null,h=[...t,...n,...o||[]].map(H=>H.key),g=await a.resolveUserBindings(h),R=E(t,n,o,g);if(!R.hasLocalForwarded&&!R.hasRemoteForwarded)return{mergeContent:m,hasChanges:!1,hasConflicts:!1};if(!R.hasLocalForwarded&&R.hasRemoteForwarded)return{mergeContent:s,hasChanges:!0,hasConflicts:!1};if(R.hasLocalForwarded&&!R.hasRemoteForwarded)return{mergeContent:m,hasChanges:!0,hasConflicts:!1};const L=u(t),S=u(n),v=o?u(o):null,C=l(L,S,g),F=v?l(v,L,g):{added:[...L.keys()].reduce((H,x)=>(H.add(x),H),new Set),removed:new Set,updated:new Set},D=v?l(v,S,g):{added:[...S.keys()].reduce((H,x)=>(H.add(x),H),new Set),removed:new Set,updated:new Set},M=w(C,F,D);let J=m;for(const H of M.removed.values())M.conflicts.has(H)||(J=b(J,H,i));for(const H of M.added.values()){if(M.conflicts.has(H))continue;const x=S.get(H);if(x.some(K=>K.command!==`-${H}`&&R.conflicts.has(g[K.key]))){M.conflicts.add(H);continue}J=f(J,x,i)}for(const H of M.updated.values()){if(M.conflicts.has(H))continue;const x=S.get(H);if(x.some(K=>K.command!==`-${H}`&&R.conflicts.has(g[K.key]))){M.conflicts.add(H);continue}J=I(J,H,x,i)}return{mergeContent:J,hasChanges:!0,hasConflicts:M.conflicts.size>0}}function w(m,s,r){const i=new Set,a=new Set,t=new Set,n=new Set;for(const o of s.removed.values())r.updated.has(o)&&n.add(o);for(const o of r.removed.values())n.has(o)||(s.updated.has(o)?n.add(o):a.add(o));for(const o of s.added.values())n.has(o)||r.added.has(o)&&m.updated.has(o)&&n.add(o);for(const o of r.added.values())n.has(o)||(s.added.has(o)?m.updated.has(o)&&n.add(o):i.add(o));for(const o of s.updated.values())n.has(o)||r.updated.has(o)&&m.updated.has(o)&&n.add(o);for(const o of r.updated.values())n.has(o)||(s.updated.has(o)?m.updated.has(o)&&n.add(o):t.add(o));return{added:i,removed:a,updated:t,conflicts:n}}function E(m,s,r,i){const a=new Set,t=$(m,i),n=$(s,i),o=r?$(r,i):null,h=p(t,n);if(h.added.size===0&&h.removed.size===0&&h.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!1,added:a,removed:a,updated:a,conflicts:a};const g=o?p(o,t):{added:[...t.keys()].reduce((F,D)=>(F.add(D),F),new Set),removed:new Set,updated:new Set};if(g.added.size===0&&g.removed.size===0&&g.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!0,added:a,removed:a,updated:a,conflicts:a};const R=o?p(o,n):{added:[...n.keys()].reduce((F,D)=>(F.add(D),F),new Set),removed:new Set,updated:new Set};if(R.added.size===0&&R.removed.size===0&&R.updated.size===0)return{hasLocalForwarded:!0,hasRemoteForwarded:!1,added:a,removed:a,updated:a,conflicts:a};const{added:L,removed:S,updated:v,conflicts:C}=w(h,g,R);return{hasLocalForwarded:!0,hasRemoteForwarded:!0,added:L,removed:S,updated:v,conflicts:C}}function $(m,s){const r=new Map;for(const i of m){const a=s[i.key];let t=r.get(a);t||(t=[],r.set(a,t)),t.push(i)}return r}function u(m){const s=new Map;for(const r of m){const i=r.command[0]==="-"?r.command.substring(1):r.command;let a=s.get(i);a||(a=[],s.set(i,a)),a.push(r)}return s}function p(m,s){const r=[...m.keys()],i=[...s.keys()],a=i.filter(o=>!r.includes(o)).reduce((o,h)=>(o.add(h),o),new Set),t=r.filter(o=>!i.includes(o)).reduce((o,h)=>(o.add(h),o),new Set),n=new Set;for(const o of r){if(t.has(o))continue;const h=m.get(o).map(R=>({...R,key:o})),g=s.get(o).map(R=>({...R,key:o}));(0,P.$wb)(h,g,(R,L)=>y(R,L))||n.add(o)}return{added:a,removed:t,updated:n}}function l(m,s,r){const i=[...m.keys()],a=[...s.keys()],t=a.filter(h=>!i.includes(h)).reduce((h,g)=>(h.add(g),h),new Set),n=i.filter(h=>!a.includes(h)).reduce((h,g)=>(h.add(g),h),new Set),o=new Set;for(const h of i){if(n.has(h))continue;const g=m.get(h).map(L=>({...L,key:r[L.key]})),R=s.get(h).map(L=>({...L,key:r[L.key]}));d(g,R)||o.add(h)}return{added:t,removed:n,updated:o}}function d(m,s){return!(!(0,P.$wb)(m.filter(({command:r})=>r[0]!=="-"),s.filter(({command:r})=>r[0]!=="-"),(r,i)=>y(r,i))||!(0,P.$wb)(m.filter(({command:r})=>r[0]==="-"),s.filter(({command:r})=>r[0]==="-"),(r,i)=>y(r,i)))}function y(m,s){if(m.command!==s.command||m.key!==s.key)return!1;const r=O.$Dj.deserialize(m.when),i=O.$Dj.deserialize(s.when);return!(r&&!i||!r&&i||r&&i&&!r.equals(i)||!N.$fo(m.args,s.args))}function f(m,s,r){for(const i of s)m=T.edit(m,[-1],i,r);return m}function b(m,s,r){const i=k(m);for(let a=i.length-1;a>=0;a--)(i[a].command===s||i[a].command===`-${s}`)&&(m=T.edit(m,[a],void 0,r));return m}function I(m,s,r,i){const a=k(m),t=a.findIndex(n=>n.command===s||n.command===`-${s}`);for(let n=a.length-1;n>=0;n--)(a[n].command===s||a[n].command===`-${s}`)&&(m=T.edit(m,[n],void 0,i));for(let n=r.length-1;n>=0;n--)m=T.edit(m,[t],r[n],i);return m}}),define(ce[244],le([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lbc=P,e.$Mbc=N;function P(O,T,k){const A={},w={},E=new Set;if(!T)return{local:{added:A,updated:w,removed:[...E.values()]},remote:{added:O,updated:{},removed:[]},conflicts:[]};const $=c(O,T);if($.added.size===0&&$.removed.size===0&&$.updated.size===0)return{local:{added:A,updated:w,removed:[...E.values()]},remote:{added:{},updated:{},removed:[]},conflicts:[]};const u=c(k,O),p=c(k,T),l={},d={},y=new Set,f=new Set;for(const b of u.removed.values())p.updated.has(b)?A[b]=T[b]:y.add(b);for(const b of p.removed.values())f.has(b)||(u.updated.has(b)?f.add(b):E.add(b));for(const b of u.updated.values())f.has(b)||(p.updated.has(b)?$.updated.has(b)&&f.add(b):d[b]=O[b]);for(const b of p.updated.values())f.has(b)||(u.updated.has(b)?$.updated.has(b)&&f.add(b):O[b]!==void 0&&(w[b]=T[b]));for(const b of u.added.values())f.has(b)||(p.added.has(b)?$.updated.has(b)&&f.add(b):l[b]=O[b]);for(const b of p.added.values())f.has(b)||(u.added.has(b)?$.updated.has(b)&&f.add(b):A[b]=T[b]);return{local:{added:A,removed:[...E.values()],updated:w},remote:{added:l,removed:[...y.values()],updated:d},conflicts:[...f.values()]}}function c(O,T){const k=O?Object.keys(O):[],A=T?Object.keys(T):[],w=A.filter(u=>!k.includes(u)).reduce((u,p)=>(u.add(p),u),new Set),E=k.filter(u=>!A.includes(u)).reduce((u,p)=>(u.add(p),u),new Set),$=new Set;for(const u of k){if(E.has(u))continue;const p=O[u],l=T[u];p!==l&&$.add(u)}return{added:w,removed:E,updated:$}}function N(O,T){const{added:k,removed:A,updated:w}=c(O,T);return k.size===0&&A.size===0&&w.size===0}}),define(ce[245],le([0,1,30]),function(ne,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ydc=c;function c(O,T,k,A){const w={added:[],removed:[],updated:[]};let E={added:[],removed:[],updated:[]};if(!T){const u=O.filter(({id:p})=>!A.includes(p));return u.length?E.added=u:E=null,{local:w,remote:E}}const $=N(O,T,A);if($.added.length>0||$.removed.length>0||$.updated.length>0){const u=N(k,O,A),p=N(k,T,A);for(const l of p.removed){const d=O.find(y=>y.id===l);d&&w.removed.push(d)}for(const l of p.added){const d=T.find(y=>y.id===l);u.added.includes(l)?$.updated.includes(l)&&w.updated.push(d):w.added.push(d)}for(const l of p.updated)w.updated.push(T.find(d=>d.id===l));for(const l of u.added)p.added.includes(l)||E.added.push(O.find(d=>d.id===l));for(const l of u.updated)p.removed.includes(l)||p.updated.includes(l)||E.updated.push(O.find(d=>d.id===l));for(const l of u.removed){const d=T.find(y=>y.id===l);d&&E.removed.push(d)}}return E.added.length===0&&E.removed.length===0&&E.updated.length===0&&(E=null),{local:w,remote:E}}function N(O,T,k){O=O?O.filter(({id:p})=>!k.includes(p)):[],T=T.filter(({id:p})=>!k.includes(p));const A=O.map(({id:p})=>p),w=T.map(({id:p})=>p),E=w.filter(p=>!A.includes(p)),$=A.filter(p=>!w.includes(p)),u=[];for(const{id:p,name:l,shortName:d,icon:y,useDefaultFlags:f}of O){if($.includes(p))continue;const b=T.find(I=>I.id===p);(!b||b.name!==l||b.shortName!==d||b.icon!==y||!(0,P.$fo)(b.useDefaultFlags,f))&&u.push(p)}return{added:E,removed:$,updated:u}}}),define(ce[25],le([0,1,19,13,185,48,28,4,104,44]),function(ne,e,P,c,N,O,T,k,A,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$snb=e.$rnb=e.$qnb=e.$pnb=e.$onb=e.$nnb=e.$mnb=e.$lnb=e.$knb=e.$inb=e.MergeState=e.Change=e.SyncStatus=e.$hnb=e.$gnb=e.$fnb=e.UserDataSyncErrorCode=e.$dnb=e.$cnb=e.$bnb=e.$anb=e.$_mb=e.$9mb=e.SyncResource=e.$6mb=e.$5mb=void 0,e.$3mb=E,e.$4mb=$,e.$7mb=u,e.$8mb=p,e.$0mb=d,e.$$mb=y,e.$enb=f,e.$jnb=t;function E(){const n=w.$oo.as(O.$to.Configuration).getConfigurationProperties();return Object.keys(n).filter(o=>!!n[o].disallowSyncIgnore)}function $(){const n=w.$oo.as(O.$to.Configuration).getConfigurationProperties(),o=Object.keys(n).filter(R=>!!n[R].ignoreSync),h=Object.keys(n).filter(R=>n[R].scope===O.ConfigurationScope.MACHINE||n[R].scope===O.ConfigurationScope.MACHINE_OVERRIDABLE),g=E();return(0,P.$Ob)([...o,...h,...g])}e.$5mb="settingsSync",e.$6mb="settingsSync.keybindingsPerPlatform";function u(){const n="vscode://schemas/ignoredSettings",o=w.$oo.as(O.$to.Configuration);o.registerConfiguration({id:"settingsSync",order:30,title:(0,N.localize)(0,null),type:"object",properties:{[e.$6mb]:{type:"boolean",description:(0,N.localize)(1,null),default:!0,scope:O.ConfigurationScope.APPLICATION,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredExtensions":{type:"array",markdownDescription:(0,N.localize)(2,null),items:[{type:"string",pattern:T.$6o,errorMessage:(0,N.localize)(3,null)}],default:[],scope:O.ConfigurationScope.APPLICATION,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredSettings":{type:"array",description:(0,N.localize)(4,null),default:[],scope:O.ConfigurationScope.APPLICATION,$ref:n,additionalProperties:!0,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]}}});const h=w.$oo.as(A.$po.JSONContribution),g=()=>{const R=E(),L=$(),S=Object.keys(O.$uo.properties).filter(F=>!L.includes(F)),v=L.filter(F=>!R.includes(F)),C={items:{type:"string",enum:[...S,...v.map(F=>`-${F}`)]}};h.registerSchema(n,C)};return o.onDidUpdateConfiguration(()=>g())}function p(n){return n&&(0,c.$hg)(n)&&(0,c.$fg)(n.id)&&Array.isArray(n.scopes)}var l;(function(n){n.Settings="settings",n.Keybindings="keybindings",n.Snippets="snippets",n.Tasks="tasks",n.Extensions="extensions",n.GlobalState="globalState",n.Profiles="profiles",n.WorkspaceState="workspaceState"})(l||(e.SyncResource=l={})),e.$9mb=[l.Settings,l.Keybindings,l.Snippets,l.Tasks,l.Extensions,l.GlobalState,l.Profiles];function d(n,...o){return n?[n,...o]:o}function y(n,o,h,g){return g.joinPath(h.userDataSyncHome,...d(n,o,`lastSync${o}.json`))}e.$_mb=(0,k.$Fi)("IUserDataSyncStoreManagementService"),e.$anb=(0,k.$Fi)("IUserDataSyncStoreService"),e.$bnb=(0,k.$Fi)("IUserDataSyncLocalStoreService"),e.$cnb="x-operation-id",e.$dnb="X-Execution-Id";function f(n){const o={};return o[e.$dnb]=n,o}var b;(function(n){n.Unauthorized="Unauthorized",n.Forbidden="Forbidden",n.NotFound="NotFound",n.MethodNotFound="MethodNotFound",n.Conflict="Conflict",n.Gone="Gone",n.PreconditionFailed="PreconditionFailed",n.TooLarge="TooLarge",n.UpgradeRequired="UpgradeRequired",n.PreconditionRequired="PreconditionRequired",n.TooManyRequests="RemoteTooManyRequests",n.TooManyRequestsAndRetryAfter="TooManyRequestsAndRetryAfter",n.RequestFailed="RequestFailed",n.RequestCanceled="RequestCanceled",n.RequestTimeout="RequestTimeout",n.RequestProtocolNotSupported="RequestProtocolNotSupported",n.RequestPathNotEscaped="RequestPathNotEscaped",n.RequestHeadersNotObject="RequestHeadersNotObject",n.NoCollection="NoCollection",n.NoRef="NoRef",n.EmptyResponse="EmptyResponse",n.TurnedOff="TurnedOff",n.SessionExpired="SessionExpired",n.ServiceChanged="ServiceChanged",n.DefaultServiceChanged="DefaultServiceChanged",n.LocalTooManyProfiles="LocalTooManyProfiles",n.LocalTooManyRequests="LocalTooManyRequests",n.LocalPreconditionFailed="LocalPreconditionFailed",n.LocalInvalidContent="LocalInvalidContent",n.LocalError="LocalError",n.IncompatibleLocalContent="IncompatibleLocalContent",n.IncompatibleRemoteContent="IncompatibleRemoteContent",n.Unknown="Unknown"})(b||(e.UserDataSyncErrorCode=b={}));class I extends Error{constructor(o,h,g,R){super(o),this.code=h,this.resource=g,this.operationId=R,this.name=`${this.code} (UserDataSyncError) syncResource:${this.resource||"unknown"} operationId:${this.operationId||"unknown"}`}}e.$fnb=I;class m extends I{constructor(o,h,g,R,L){super(o,g,void 0,L),this.url=h,this.serverCode=R}}e.$gnb=m;class s extends I{constructor(o,h){super(o,h)}}e.$hnb=s,function(n){function o(h){if(h instanceof n)return h;const g=/^(.+) \(UserDataSyncError\) syncResource:(.+) operationId:(.+)$/.exec(h.name);if(g&&g[1]){const R=g[2]==="unknown"?void 0:g[2],L=g[3]==="unknown"?void 0:g[3];return new n(h.message,g[1],R,L)}return new n(h.message,b.Unknown)}n.toUserDataSyncError=o}(I||(e.$fnb=I={}));var r;(function(n){n.Uninitialized="uninitialized",n.Idle="idle",n.Syncing="syncing",n.HasConflicts="hasConflicts"})(r||(e.SyncStatus=r={}));var i;(function(n){n[n.None=0]="None",n[n.Added=1]="Added",n[n.Modified=2]="Modified",n[n.Deleted=3]="Deleted"})(i||(e.Change=i={}));var a;(function(n){n.Preview="preview",n.Conflict="conflict",n.Accepted="accepted"})(a||(e.MergeState=a={})),e.$inb="sync.store.url.type";function t(n){return`sync.enable.${n}`}e.$knb=(0,k.$Fi)("IUserDataSyncEnablementService"),e.$lnb=(0,k.$Fi)("IUserDataSyncService"),e.$mnb=(0,k.$Fi)("IUserDataSyncResourceProviderService"),e.$nnb=(0,k.$Fi)("IUserDataAutoSyncService"),e.$onb=(0,k.$Fi)("IUserDataSyncUtilService"),e.$pnb=(0,k.$Fi)("IUserDataSyncLogService"),e.$qnb="userDataSync",e.$rnb="vscode-userdata-sync",e.$snb="preview"}),define(ce[246],le([0,1,30,25]),function(ne,e,P,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$GNb=N,P=Oe(P);function N(T,k,A,w,E){if(!k)return{remote:{added:Object.keys(T),removed:[],updated:[],all:Object.keys(T).length>0?T:null},local:{added:{},removed:[],updated:{}}};const $=O(T,k);if($.added.size===0&&$.removed.size===0&&$.updated.size===0)return{remote:{added:[],removed:[],updated:[],all:null},local:{added:{},removed:[],updated:{}}};const u=A?O(A,k):{added:Object.keys(k).reduce((b,I)=>(b.add(I),b),new Set),removed:new Set,updated:new Set},p=A?O(A,T):{added:Object.keys(T).reduce((b,I)=>(b.add(I),b),new Set),removed:new Set,updated:new Set},l={added:{},removed:[],updated:{}},d=P.$bo(k),y=!A;for(const b of p.added.values())b!==c.$inb&&y&&u.added.has(b)||(d[b]=T[b]);for(const b of p.updated.values())d[b]=T[b];for(const b of p.removed.values())w.unregistered.includes(b)||delete d[b];for(const b of u.added.values()){const I=k[b];if(w.machine.includes(b)){E.info(`GlobalState: Skipped adding ${b} in local storage because it is declared as machine scoped.`);continue}if(A&&p.added.has(b))continue;const m=T[b];m&&m.value===I.value||b===c.$inb&&y&&p.added.has(b)||(m?l.updated[b]=I:l.added[b]=I)}for(const b of u.updated.values()){const I=k[b];if(w.machine.includes(b)){E.info(`GlobalState: Skipped updating ${b} in local storage because it is declared as machine scoped.`);continue}if(p.updated.has(b)||p.removed.has(b))continue;const m=T[b];m&&m.value===I.value||(l.updated[b]=I)}for(const b of u.removed.values()){if(w.machine.includes(b)){E.trace(`GlobalState: Skipped removing ${b} in local storage because it is declared as machine scoped.`);continue}p.updated.has(b)||p.removed.has(b)||l.removed.push(b)}const f=O(k,d);return{local:l,remote:{added:[...f.added],updated:[...f.updated],removed:[...f.removed],all:f.added.size===0&&f.removed.size===0&&f.updated.size===0?null:d}}}function O(T,k){const A=Object.keys(T),w=Object.keys(k),E=w.filter(p=>!A.includes(p)).reduce((p,l)=>(p.add(l),p),new Set),$=A.filter(p=>!w.includes(p)).reduce((p,l)=>(p.add(l),p),new Set),u=new Set;for(const p of A){if($.has(p))continue;const l=T[p],d=k[p];P.$fo(l,d)||u.add(p)}return{added:E,removed:$,updated:u}}}),define(ce[247],le([0,1,19,34,64,45,30,82,25]),function(ne,e,P,c,N,O,T,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aMb=w,e.$bMb=u,e.$cMb=p,e.$dMb=l,e.$eMb=y,e.$fMb=b,T=Oe(T),k=Oe(k);function w(h,g,R){let L=[];R?L=$(R):L=E(g);const S=[],v=[...(0,A.$3mb)()];if(Array.isArray(L))for(const C of L)C.startsWith("-")?v.push(C.substring(1)):S.push(C);return(0,P.$Ob)([...h,...S].filter(C=>!v.includes(C)))}function E(h){let g=h.inspect("settingsSync.ignoredSettings").userValue;return g!==void 0||(g=h.inspect("sync.ignoredSettings").userValue,g!==void 0)?g:h.getValue("settingsSync.ignoredSettings")||[]}function $(h){const g=(0,c.$Vn)(h);return g?g["settingsSync.ignoredSettings"]||g["sync.ignoredSettings"]||[]:[]}function u(h,g){const R=(0,c.$Vn)(h)||{};let L="{}";for(const S of Object.keys(R)){const v=(0,N.$0n)(L,[S],R[S],g);L=(0,N.$ao)(L,v)}return L}function p(h,g,R,L){if(R.length){const S=o(g),v=(0,c.$Vn)(g)||{},C=(0,c.$Vn)(h);if(!C)return h;const F=[];for(const D of R){const M=v[D],J=C[D];M===void 0?h=k.edit(h,[D],void 0,L):J!==void 0?h=k.edit(h,[D],M,L):F.push(r(D,S))}F.sort((D,M)=>D.startOffset-M.startOffset),F.forEach(D=>h=b(D.setting.key,g,h,L))}return h}function l(h,g,R,L,S,v){const C=p(h,g,L,v),F=R!==C,D=R!==g;if(!F&&!D)return{conflictsSettings:[],localContent:null,remoteContent:null,hasConflicts:!1};if(F&&!D)return{conflictsSettings:[],localContent:null,remoteContent:C,hasConflicts:!1};if(D&&!F)return{conflictsSettings:[],localContent:p(g,h,L,v),remoteContent:null,hasConflicts:!1};if(R===null&&y(h)){const U=d(h,g,L)?null:p(g,h,L,v);return{conflictsSettings:[],localContent:U,remoteContent:null,hasConflicts:!1}}let M=h,J=g;const H=(0,c.$Vn)(h),x=(0,c.$Vn)(g),K=R?(0,c.$Vn)(R):null,ie=L.reduce((U,B)=>(U.add(B),U),new Set),V=f(H,x,ie),z=f(K,H,ie),ee=f(K,x,ie),se=new Map,he=new Set,q=U=>{he.add(U);const B=S.filter(({key:j})=>j===U)[0];B?(M=k.edit(M,[U],B.value,v),J=k.edit(J,[U],B.value,v)):se.set(U,{key:U,localValue:H[U],remoteValue:x[U]})};for(const U of z.removed.values())ee.updated.has(U)?q(U):J=k.edit(J,[U],void 0,v);for(const U of ee.removed.values())he.has(U)||(z.updated.has(U)?q(U):M=k.edit(M,[U],void 0,v));for(const U of z.updated.values())he.has(U)||(ee.updated.has(U)?V.updated.has(U)&&q(U):J=k.edit(J,[U],H[U],v));for(const U of ee.updated.values())he.has(U)||(z.updated.has(U)?V.updated.has(U)&&q(U):M=k.edit(M,[U],x[U],v));for(const U of z.added.values())he.has(U)||(ee.added.has(U)?V.updated.has(U)&&q(U):J=b(U,M,J,v));for(const U of ee.added.values())he.has(U)||(z.added.has(U)?V.updated.has(U)&&q(U):M=b(U,J,M,v));const Z=se.size>0||!d(M,J,L),X=Z||!d(M,h,[]),G=Z||!d(J,g,[]);return{localContent:X?M:null,remoteContent:G?J:null,conflictsSettings:[...se.values()],hasConflicts:Z}}function d(h,g,R){if(h===g)return!0;const L=(0,c.$Vn)(h),S=(0,c.$Vn)(g),v=R.reduce((D,M)=>(D.add(M),D),new Set),C=o(h).filter(D=>!(D.setting&&v.has(D.setting.key))),F=o(g).filter(D=>!(D.setting&&v.has(D.setting.key)));if(C.length!==F.length)return!1;for(let D=0;D<C.length;D++){const M=C[D],J=F[D];if(M.setting&&J.setting){if(M.setting.key!==J.setting.key||!T.$fo(L[M.setting.key],S[M.setting.key]))return!1}else if(!M.setting&&!J.setting){if(M.value!==J.value)return!1}else return!1}return!0}function y(h){return h?o(h).length===0:!0}function f(h,g,R){const L=h?Object.keys(h).filter(D=>!R.has(D)):[],S=Object.keys(g).filter(D=>!R.has(D)),v=S.filter(D=>!L.includes(D)).reduce((D,M)=>(D.add(M),D),new Set),C=L.filter(D=>!S.includes(D)).reduce((D,M)=>(D.add(M),D),new Set),F=new Set;if(h)for(const D of L){if(C.has(D))continue;const M=h[D],J=g[D];T.$fo(M,J)||F.add(D)}return{added:v,removed:C,updated:F}}function b(h,g,R,L){const S=(0,c.$Vn)(g),v=o(g),C=o(R),F=I(h,v,C);return m(R,h,S[h],F,C,L)}function I(h,g,R){const L=g.findIndex(v=>v.setting?.key===h),S=g[L-1];if(S){if(S.setting){const C=r(S.setting.key,R);if(C)return{index:R.indexOf(C),insertAfter:!0}}else{const C=i(L,g);if(C){const F=r(C.setting.key,R);if(F){const D=a(R.indexOf(F),R),M=t(g,C,g[L]);if(D){const J=t(R,F,D),H=n(M,J);return H?{index:R.indexOf(H),insertAfter:!0}:{index:R.indexOf(D),insertAfter:!1}}else{const J=t(R,F,R[R.length-1]),H=n(M,J);return H?{index:R.indexOf(H),insertAfter:!0}:{index:R.length-1,insertAfter:!0}}}}}const v=g[L+1];if(v)if(v.setting){const C=r(v.setting.key,R);if(C)return{index:R.indexOf(C),insertAfter:!1}}else{const C=a(L,g);if(C){const F=r(C.setting.key,R);if(F){const D=i(R.indexOf(F),R),M=t(g,g[L],C);if(D){const J=t(R,D,F),H=n(M.reverse(),J.reverse());return H?{index:R.indexOf(H),insertAfter:!1}:{index:R.indexOf(D),insertAfter:!0}}else{const J=t(R,R[0],F),H=n(M.reverse(),J.reverse());return H?{index:R.indexOf(H),insertAfter:!1}:{index:0,insertAfter:!1}}}}}}return{index:R.length-1,insertAfter:!0}}function m(h,g,R,L,S,v){let C;return L.index===-1?C=(0,N.$0n)(h,[g],R,v):C=s(h,g,R,L,S,v).map(F=>(0,N.$$n)(h,F,v)[0]),(0,N.$ao)(h,C)}function s(h,g,R,L,S,v){const C=`${JSON.stringify(g)}: ${JSON.stringify(R)}`,F=(0,O.$7n)(v,h),D=S[L.index];if(L.insertAfter){const M=[];if(D.setting)M.push({offset:D.endOffset,length:0,content:","+C});else{const J=a(L.index,S),H=i(L.index,S),x=H?.setting?.commaOffset;H&&x===void 0&&M.push({offset:H.endOffset,length:0,content:","});const K=x!==void 0&&x>D.endOffset;M.push({offset:K?x+1:D.endOffset,length:0,content:J?F+C+",":F+C})}return M}else{if(D.setting)return[{offset:D.startOffset,length:0,content:C+","}];const M=(S[L.index-1]&&!S[L.index-1].setting?F:"")+C+(a(L.index,S)?",":"")+F;return[{offset:D.startOffset,length:0,content:M}]}}function r(h,g){return g.filter(R=>R.setting?.key===h)[0]}function i(h,g){for(let R=h-1;R>=0;R--)if(g[R].setting)return g[R]}function a(h,g){for(let R=h+1;R<g.length;R++)if(g[R].setting)return g[R]}function t(h,g,R){const L=h.indexOf(g),S=h.indexOf(R);return h.filter((v,C)=>L<C&&C<S)}function n(h,g){if(h.length&&g.length){let R=0;for(;R<g.length&&R<h.length;R++)if(h[R].value!==g[R].value)return g[R-1];return g[R-1]}}function o(h){const g=[];let R=-1,L,S;const v={onObjectBegin:C=>{R++},onObjectProperty:(C,F,D)=>{R===0&&(L=F,S=C)},onObjectEnd:(C,F)=>{R--,R===0&&g.push({startOffset:L,endOffset:C+F,value:h.substring(L,C+F),setting:{key:S,commaOffset:void 0}})},onArrayBegin:(C,F)=>{R++},onArrayEnd:(C,F)=>{R--,R===0&&g.push({startOffset:L,endOffset:C+F,value:h.substring(L,C+F),setting:{key:S,commaOffset:void 0}})},onLiteralValue:(C,F,D)=>{R===0&&g.push({startOffset:L,endOffset:F+D,value:h.substring(L,F+D),setting:{key:S,commaOffset:void 0}})},onSeparator:(C,F,D)=>{if(R===0&&C===","){let M=g.length-1;for(;M>=0&&!g[M].setting;M--);const J=g[M];J&&g.splice(M,1,{startOffset:J.startOffset,endOffset:J.endOffset,value:J.value,setting:{key:J.setting.key,commaOffset:F}})}},onComment:(C,F)=>{R===0&&g.push({startOffset:C,endOffset:C+F,value:h.substring(C,C+F)})}};return(0,c.$3n)(h,v),g}}),define(ce[83],le([0,1,3,2,4,25]),function(ne,e,P,c,N,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$XLb=e.$WLb=void 0,e.$WLb=(0,N.$Fi)("IUserDataSyncAccountService");let T=class extends c.$Wc{get account(){return this.a}constructor(A,w){super(),this.g=A,this.h=w,this.b=this.B(new P.$me),this.onDidChangeAccount=this.b.event,this.c=this.B(new P.$me),this.onTokenFailed=this.c.event,this.f=!1,this.B(A.onTokenFailed(E=>{this.h.info("Settings Sync auth token failed",this.account?.authenticationProviderId,this.f,E),this.updateAccount(void 0),E===O.UserDataSyncErrorCode.Forbidden?this.c.fire(!0):this.c.fire(this.f),this.f=!0})),this.B(A.onTokenSucceed(()=>this.f=!1))}async updateAccount(A){(A&&this.a?A.token!==this.a.token||A.authenticationProviderId!==this.a.authenticationProviderId:A!==this.a)&&(this.a=A,this.a&&this.g.setAuthToken(this.a.token,this.a.authenticationProviderId),this.b.fire(A))}};e.$XLb=T,e.$XLb=T=ve([Y(0,O.$anb),Y(1,O.$pnb)],T)}),define(ce[248],le([0,1,21,186,16,10,25]),function(ne,e,P,c,N,O,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qOb=void 0;let k=class extends O.$ek{constructor(w,E){super(),this.g=this.B(w.createLogger((0,P.$gh)(E.logsHome,`${T.$qnb}.log`),{id:T.$qnb,name:(0,c.localize)(0,null)}))}trace(w,...E){this.g.trace(w,...E)}debug(w,...E){this.g.debug(w,...E)}info(w,...E){this.g.info(w,...E)}warn(w,...E){this.g.warn(w,...E)}error(w,...E){this.g.error(w,...E)}flush(){this.g.flush()}};e.$qOb=k,e.$qOb=k=ve([Y(0,O.$ak),Y(1,N.$Mi)],k)}),define(ce[249],le([0,1,6,3,2]),function(ne,e,P,c,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yfc=void 0;class O extends N.$Wc{constructor({onDidOpenMainWindow:k,onDidFocusMainWindow:A,getActiveWindowId:w}){super(),this.a=this.B(new N.$Vc),c.Event.latch(c.Event.any(k,A))(this.f,this,this.a),this.b=(0,P.$sh)(()=>w()),(async()=>{try{const $=await this.b;this.c=typeof this.c=="number"?this.c:$}catch{}finally{this.b=void 0}})()}f(k){this.b&&(this.b.cancel(),this.b=void 0),this.c=k}async getActiveClientId(){return`window:${this.b?await this.b:this.c}`}}e.$Yfc=O}),define(ce[116],le([0,1,189,14,52,21,9,4,23]),function(ne,e,P,c,N,O,T,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8i=e.$5i=e.$4i=e.$3i=e.$2i=e.$Zi=e.$Yi=e.WorkbenchState=e.$Si=e.$Ri=e.$Oi=void 0,e.$Pi=w,e.$Qi=E,e.$Ti=$,e.$Ui=u,e.$Vi=p,e.$Wi=d,e.$Xi=y,e.$1i=I,e.$6i=m,e.$7i=s,e.$9i=r,e.$0i=i,e.$$i=a,e.$Oi=(0,k.$Fi)("contextService");function w(t){const n=t;return typeof n?.id=="string"&&T.URI.isUri(n.uri)}function E(t){return typeof t?.id=="string"&&!w(t)&&!u(t)}e.$Ri={id:"ext-dev"},e.$Si={id:"empty-window"};function $(t,n){if(typeof t=="string"||typeof t>"u")return typeof t=="string"?{id:(0,c.$pc)(t)}:n?e.$Ri:e.$Si;const o=t;return o.configuration?{id:o.id,configPath:o.configuration}:o.folders.length===1?{id:o.id,uri:o.folders[0].uri}:{id:o.id}}function u(t){const n=t;return typeof n?.id=="string"&&T.URI.isUri(n.configPath)}function p(t){const n=t;if(n?.uri)return{id:n.id,uri:T.URI.revive(n.uri)};const o=t;if(o?.configPath)return{id:o.id,configPath:T.URI.revive(o.configPath)};if(t?.id)return{id:t.id}}var l;(function(t){t[t.EMPTY=1]="EMPTY",t[t.FOLDER=2]="FOLDER",t[t.WORKSPACE=3]="WORKSPACE"})(l||(e.WorkbenchState=l={}));function d(t){const n=t;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&Array.isArray(n.folders))}function y(t){const n=t;return!!(n&&typeof n=="object"&&T.URI.isUri(n.uri)&&typeof n.name=="string"&&typeof n.toResource=="function")}class f{constructor(n,o,h,g,R){this.h=n,this.j=h,this.k=g,this.l=R,this.c=N.$Li.forUris(this.l,()=>!0),this.folders=o}update(n){this.h=n.id,this.k=n.configuration,this.j=n.transient,this.l=n.l,this.folders=n.folders}get folders(){return this.g}set folders(n){this.g=n,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(n){this.k=n}getFolder(n){return n&&this.c.findSubstr(n)||null}n(){this.c=N.$Li.forUris(this.l,()=>!0);for(const n of this.folders)this.c.set(n.uri,n)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$Yi=f;class b{constructor(n,o){this.raw=o,this.uri=n.uri,this.index=n.index,this.name=n.name}toResource(n){return(0,O.$gh)(this.uri,n)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$Zi=b;function I(t){return new b({uri:t,index:0,name:(0,O.$ch)(t)},{uri:t.toString()})}e.$2i="code-workspace",e.$3i=`.${e.$2i}`,e.$4i=[{name:(0,P.localize)(0,null),extensions:[e.$2i]}],e.$5i="workspace.json";function m(t,n){return O.$0g.isEqualOrParent(t,n.untitledWorkspacesHome)}function s(t){let n;return T.URI.isUri(t)?n=t:n=t.configuration,n?.scheme===A.Schemas.tmp}e.$8i="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function r(t){return t.id===e.$8i}function i(t,n){return!m(t,n)&&!s(t)}function a(t){return(typeof t=="string"?(0,c.$qc)(t):(0,O.$eh)(t))===e.$3i}}),define(ce[20],le([0,1,56,3,2,21,9,180,16,7,4,10,116,35,29,6,32,27,13]),function(ne,e,P,c,N,O,T,k,A,w,E,$,u,p,l,d,y,f,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pl=e.$Ol=e.$Ll=e.ProfileResourceType=void 0,e.$Kl=m,e.$Ml=s,e.$Nl=r;var I;(function(t){t.Settings="settings",t.Keybindings="keybindings",t.Snippets="snippets",t.Tasks="tasks",t.Extensions="extensions",t.GlobalState="globalState"})(I||(e.ProfileResourceType=I={}));function m(t){const n=t;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&typeof n.isDefault=="boolean"&&typeof n.name=="string"&&T.URI.isUri(n.location)&&T.URI.isUri(n.globalStorageHome)&&T.URI.isUri(n.settingsResource)&&T.URI.isUri(n.keybindingsResource)&&T.URI.isUri(n.tasksResource)&&T.URI.isUri(n.snippetsHome)&&T.URI.isUri(n.extensionsResource))}e.$Ll=(0,E.$Fi)("IUserDataProfilesService");function s(t,n){return{id:t.id,isDefault:t.isDefault,name:t.name,shortName:t.shortName,icon:t.icon,location:T.URI.revive(t.location).with({scheme:n}),globalStorageHome:T.URI.revive(t.globalStorageHome).with({scheme:n}),settingsResource:T.URI.revive(t.settingsResource).with({scheme:n}),keybindingsResource:T.URI.revive(t.keybindingsResource).with({scheme:n}),tasksResource:T.URI.revive(t.tasksResource).with({scheme:n}),snippetsHome:T.URI.revive(t.snippetsHome).with({scheme:n}),extensionsResource:T.URI.revive(t.extensionsResource).with({scheme:n}),cacheHome:T.URI.revive(t.cacheHome).with({scheme:n}),useDefaultFlags:t.useDefaultFlags,isTransient:t.isTransient}}function r(t,n,o,h,g,R){return{id:t,name:n,location:o,isDefault:!1,shortName:g?.shortName,icon:g?.icon,globalStorageHome:R&&g?.useDefaultFlags?.globalState?R.globalStorageHome:(0,O.$gh)(o,"globalStorage"),settingsResource:R&&g?.useDefaultFlags?.settings?R.settingsResource:(0,O.$gh)(o,"settings.json"),keybindingsResource:R&&g?.useDefaultFlags?.keybindings?R.keybindingsResource:(0,O.$gh)(o,"keybindings.json"),tasksResource:R&&g?.useDefaultFlags?.tasks?R.tasksResource:(0,O.$gh)(o,"tasks.json"),snippetsHome:R&&g?.useDefaultFlags?.snippets?R.snippetsHome:(0,O.$gh)(o,"snippets"),extensionsResource:R&&g?.useDefaultFlags?.extensions?R.extensionsResource:(0,O.$gh)(o,"extensions.json"),cacheHome:(0,O.$gh)(h,t),useDefaultFlags:g?.useDefaultFlags,isTransient:g?.transient}}let i=class extends N.$Wc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(n,o,h,g){super(),this.t=n,this.u=o,this.w=h,this.y=g,this.f=!0,this.h=this.B(new c.$me),this.onDidChangeProfiles=this.h.event,this.j=this.B(new c.$me),this.onWillCreateProfile=this.j.event,this.m=this.B(new c.$me),this.onWillRemoveProfile=this.m.event,this.n=this.B(new c.$me),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],folders:new p.$Cc,workspaces:new p.$Cc,emptyWindows:new Map},this.profilesHome=(0,O.$gh)(this.t.userRoamingDataHome,"profiles"),this.g=(0,O.$gh)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(n){this.f!==n&&(this.z=void 0,this.f=n)}isEnabled(){return this.f}get C(){if(!this.z){const n=this.D(),o=[n];if(this.f)try{for(const R of this.O()){if(!R.name||!(0,b.$fg)(R.name)||!R.location){this.y.warn("Skipping the invalid stored profile",R.location||R.name);continue}o.push(r((0,O.$dh)(R.location),R.name,R.location,this.g,{shortName:R.shortName,icon:R.icon,useDefaultFlags:R.useDefaultFlags},n))}}catch(R){this.y.error(R)}const h=new p.$Cc,g=new Map;if(o.length)try{const R=this.Q();if(R.workspaces)for(const[L,S]of Object.entries(R.workspaces)){const v=T.URI.parse(L),C=o.find(F=>F.id===S);C&&h.set(v,C)}if(R.emptyWindows)for(const[L,S]of Object.entries(R.emptyWindows)){const v=o.find(C=>C.id===S);v&&g.set(L,v)}}catch(R){this.y.error(R)}this.z={profiles:o,workspaces:h,emptyWindows:g}}return this.z}D(){const n=r("__default__profile__",(0,k.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...n,extensionsResource:this.S()??n.extensionsResource,isDefault:!0}}async createTransientProfile(n){const o="Temp",h=new RegExp(`${(0,f.$if)(o)}\\s(\\d+)`);let g=0;for(const L of this.profiles){const S=h.exec(L.name),v=S?parseInt(S[1]):0;g=v>g?v:g}const R=`${o} ${g+1}`;return this.createProfile((0,P.$tj)((0,y.$2g)()).toString(16),R,{transient:!0},n)}async createNamedProfile(n,o,h){return this.createProfile((0,P.$tj)((0,y.$2g)()).toString(16),n,o,h)}async createProfile(n,o,h,g){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const R=await this.F(n,o,h);return g&&await this.setProfileForWorkspace(g,R),R}async F(n,o,h){if(!(0,b.$fg)(o)||!o)throw new Error("Name of the profile is mandatory and must be of type `string`");let g=this.r.get(o);return g||(g=(async()=>{try{if(this.profiles.find(v=>v.name===o||v.id===n))throw new Error(`Profile with ${o} name already exists`);const L=r(n,o,(0,O.$gh)(this.profilesHome,n),this.g,h,this.defaultProfile);await this.u.createFolder(L.location);const S=[];return this.j.fire({profile:L,join(v){S.push(v)}}),await d.Promises.settled(S),this.I([L],[],[]),L}finally{this.r.delete(o)}})(),this.r.set(o,g)),g}async updateProfile(n,o){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let h=this.profiles.find(g=>g.id===n.id);if(!h)throw new Error(`Profile '${n.name}' does not exist`);return h=r(h.id,o.name??h.name,h.location,this.g,{shortName:o.shortName??h.shortName,icon:o.icon===null?void 0:o.icon??h.icon,transient:o.transient??h.isTransient,useDefaultFlags:o.useDefaultFlags??h.useDefaultFlags},this.defaultProfile),this.I([],[],[h]),h}async removeProfile(n){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(n.isDefault)throw new Error("Cannot remove default profile");const o=this.profiles.find(g=>g.id===n.id);if(!o)throw new Error(`Profile '${n.name}' does not exist`);const h=[];this.m.fire({profile:o,join(g){h.push(g)}});try{await Promise.allSettled(h)}catch(g){this.y.error(g)}for(const g of[...this.C.emptyWindows.keys()])o.id===this.C.emptyWindows.get(g)?.id&&this.C.emptyWindows.delete(g);for(const g of[...this.C.workspaces.keys()])o.id===this.C.workspaces.get(g)?.id&&this.C.workspaces.delete(g);this.M(),this.I([],[o],[]);try{await this.u.del(o.cacheHome,{recursive:!0})}catch(g){(0,w.$ql)(g)!==w.FileOperationResult.FILE_NOT_FOUND&&this.y.error(g)}}async setProfileForWorkspace(n,o){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const h=this.profiles.find(g=>g.id===o.id);if(!h)throw new Error(`Profile '${o.name}' does not exist`);this.L(n,h)}unsetWorkspace(n,o){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(n,void 0,o)}async resetWorkspaces(){this.s.folders.clear(),this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const n=await this.u.resolve(this.profilesHome);await Promise.all((n.children||[]).filter(o=>o.isDirectory&&this.profiles.every(h=>!this.w.extUri.isEqual(h.location,o.resource))).map(o=>this.u.del(o.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const n=this.s.profiles.filter(o=>!this.H(o));await Promise.allSettled(n.map(o=>this.removeProfile(o)))}getProfileForWorkspace(n){const o=this.G(n),h=T.URI.isUri(o)?this.C.workspaces.get(o):this.C.emptyWindows.get(o);return h||((0,u.$Pi)(n)?this.s.folders.get(n.uri):(0,u.$Ui)(n)?this.s.workspaces.get(n.configPath):this.s.emptyWindows.get(n.id))}G(n){return(0,u.$Pi)(n)?n.uri:(0,u.$Ui)(n)?n.configPath:n.id}H(n){return!!([...this.C.emptyWindows.values()].some(o=>this.w.extUri.isEqual(o.location,n.location))||[...this.C.workspaces.values()].some(o=>this.w.extUri.isEqual(o.location,n.location))||[...this.s.emptyWindows.values()].some(o=>this.w.extUri.isEqual(o.location,n.location))||[...this.s.workspaces.values()].some(o=>this.w.extUri.isEqual(o.location,n.location))||[...this.s.folders.values()].some(o=>this.w.extUri.isEqual(o.location,n.location)))}I(n,o,h){const g=[...this.profiles,...n],R=[],L=this.s.profiles;this.s.profiles=[];for(let S of g){if(S.isDefault||o.some(C=>S.id===C.id))continue;S=h.find(C=>S.id===C.id)??S;const v=L.find(C=>S.id===C.id);if(S.isTransient)this.s.profiles.push(S);else{if(v){for(const[C,F]of this.s.emptyWindows.entries())if(S.id===F.id){this.L({id:C},S);break}for(const[C,F]of this.s.workspaces.entries())if(S.id===F.id){this.L({id:"",configPath:C},S);break}for(const[C,F]of this.s.folders.entries())if(S.id===F.id){this.L({id:"",uri:C},S);break}}R.push({location:S.location,name:S.name,shortName:S.shortName,icon:S.icon,useDefaultFlags:S.useDefaultFlags})}}this.P(R),this.z=void 0,this.J(n,o,h)}J(n,o,h){this.h.fire({added:n,removed:o,updated:h,all:this.profiles})}L(n,o,h){if(h=o?.isTransient?!0:h,h)(0,u.$Pi)(n)?(this.s.folders.delete(n.uri),o&&this.s.folders.set(n.uri,o)):(0,u.$Ui)(n)?(this.s.workspaces.delete(n.configPath),o&&this.s.workspaces.set(n.configPath,o)):(this.s.emptyWindows.delete(n.id),o&&this.s.emptyWindows.set(n.id,o));else{this.L(n,void 0,!0);const g=this.G(n);T.URI.isUri(g)?(this.C.workspaces.delete(g),o&&this.C.workspaces.set(g,o)):(this.C.emptyWindows.delete(g),o&&this.C.emptyWindows.set(g,o)),this.M()}}M(){const n={};for(const[h,g]of this.C.workspaces.entries())n[h.toString()]=g.id;const o={};for(const[h,g]of this.C.emptyWindows.entries())o[h.toString()]=g.id;this.R({workspaces:n,emptyWindows:o}),this.z=void 0}N(n){const o={},h=this.D();if(n.workspaces)for(const[R,L]of Object.entries(n.workspaces)){const S=T.URI.parse(L);o[R]=this.w.extUri.isEqual(S,h.location)?h.id:this.w.extUri.basename(S)}const g={};if(n.emptyWindows)for(const[R,L]of Object.entries(n.emptyWindows)){const S=T.URI.parse(L);g[R]=this.w.extUri.isEqual(S,h.location)?h.id:this.w.extUri.basename(S)}return{workspaces:o,emptyWindows:g}}O(){return[]}P(n){throw new Error("not implemented")}Q(){return{}}R(n){throw new Error("not implemented")}S(){}};e.$Ol=i,e.$Ol=i=ve([Y(0,A.$Mi),Y(1,w.$_k),Y(2,l.$Jl),Y(3,$.$_j)],i);class a extends i{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(n){this.a=n}Q(){return this.X}R(n){this.X=n}}e.$Pl=a}),define(ce[250],le([0,1,6,2,20]),function(ne,e,P,c,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5gc=void 0;let O=class extends c.$Wc{constructor(k){super(),this.B(new P.$Rh(()=>{k.cleanUp()},10*1e3)).schedule()}};e.$5gc=O,e.$5gc=O=ve([Y(0,N.$Ll)],O)}),define(ce[84],le([0,1,19,6,26,8,3,2,5,13,9,162,28,33,37,10,24,18,29,20]),function(ne,e,P,c,N,O,T,k,A,w,E,$,u,p,l,d,y,f,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Aq=e.$yq=void 0,e.$zq=s,$=Oe($);let m=class extends k.$Wc{get onInstallExtension(){return this.n.event}get onDidInstallExtensions(){return this.s.event}get onUninstallExtension(){return this.t.event}get onDidUninstallExtension(){return this.u.event}get onDidUpdateExtensionMetadata(){return this.w.event}constructor(t,n,o,h,g,R){super(),this.z=t,this.C=n,this.D=o,this.F=h,this.G=g,this.H=R,this.h=0,this.j=new Map,this.m=new Map,this.n=this.B(new T.$me),this.s=this.B(new T.$me),this.t=this.B(new T.$me),this.u=this.B(new T.$me),this.w=this.B(new T.$me),this.y=[],this.B((0,k.$Uc)(()=>{this.j.forEach(({task:L})=>L.cancel()),this.m.forEach(L=>L.cancel()),this.j.clear(),this.m.clear()}))}async canInstall(t){const n=await this.getTargetPlatform();return t.allTargetPlatforms.some(o=>(0,u.$ep)(o,t.allTargetPlatforms,n))}async installFromGallery(t,n={}){try{const h=(await this.installGalleryExtensions([{extension:t,options:n}])).find(({identifier:g})=>(0,p.$Hp)(g,t.identifier));if(h?.local)return h?.local;throw h?.error?h.error:new u.$ip(`Unknown error while installing extension ${t.identifier.id}`,u.ExtensionManagementErrorCode.Unknown)}catch(o){throw s(o)}}async installGalleryExtensions(t){if(!this.z.isEnabled())throw new u.$ip($.localize(0,null),u.ExtensionManagementErrorCode.NotAllowed);const n=[],o=[];return await Promise.allSettled(t.map(async({extension:h,options:g})=>{try{const R=await this.N(h,!!g?.installGivenVersion,!!g?.installPreReleaseVersion,g.productVersion??{version:this.G.version,date:this.G.date});o.push({...R,options:g})}catch(R){n.push({identifier:h.identifier,operation:u.InstallOperation.Install,source:h,error:R,profileLocation:g.profileLocation??this.X()})}})),o.length&&n.push(...await this.I(o)),n}async uninstall(t,n={}){return this.F.trace("ExtensionManagementService#uninstall",t.identifier.id),this.P(t,n)}async toggleAppliationScope(t,n){if((0,l.$tn)(t.manifest)||t.isBuiltin)return t;if(t.isApplicationScoped){let o=await this.updateMetadata(t,{isApplicationScoped:!1},this.H.defaultProfile.extensionsResource);this.D.extUri.isEqual(n,this.H.defaultProfile.extensionsResource)||(o=await this.$(t,this.H.defaultProfile.extensionsResource,n));for(const h of this.H.profiles){const g=(await this.getInstalled(l.ExtensionType.User,h.extensionsResource)).find(R=>(0,p.$Hp)(R.identifier,t.identifier));g?this.w.fire({local:g,profileLocation:h.extensionsResource}):this.u.fire({identifier:t.identifier,profileLocation:h.extensionsResource})}return o}else{const o=this.D.extUri.isEqual(n,this.H.defaultProfile.extensionsResource)?await this.updateMetadata(t,{isApplicationScoped:!0},this.H.defaultProfile.extensionsResource):await this.$(t,n,this.H.defaultProfile.extensionsResource,{isApplicationScoped:!0});return this.s.fire([{identifier:o.identifier,operation:u.InstallOperation.Install,local:o,profileLocation:this.H.defaultProfile.extensionsResource,applicationScoped:!0}]),o}}getExtensionsControlManifest(){const t=new Date().getTime();return(!this.g||t-this.h>1e3*60*5)&&(this.g=this.W(),this.h=t),this.g}registerParticipant(t){this.y.push(t)}async I(t){const n=new Map,o=new Map,h=[],g=(L,S)=>`${p.$Ip.create(L).toString()}-${S.toString()}`,R=(L,S,v,C)=>{const F=this.Y(L,S,v),D=`${(0,p.$Mp)(L.publisher,L.name)}-${v.profileLocation.toString()}`;o.set(D,{task:F,root:C}),this.n.fire({identifier:F.identifier,source:S,profileLocation:v.profileLocation}),this.F.info("Installing extension:",F.identifier.id,v),E.URI.isUri(S)||this.j.set(g(S,v.profileLocation),{task:F,waitingTasks:[]})};try{for(const{manifest:L,extension:S,options:v}of t){const C=v.isApplicationScoped||v.isBuiltin||(0,l.$tn)(L),F={...v,installOnlyNewlyAddedFromExtensionPack:v.installOnlyNewlyAddedFromExtensionPack??!E.URI.isUri(S),isApplicationScoped:C,profileLocation:C?this.H.defaultProfile.extensionsResource:v.profileLocation??this.X(),productVersion:v.productVersion??{version:this.G.version,date:this.G.date}},D=E.URI.isUri(S)?void 0:this.j.get(g(S,F.profileLocation));D?(this.F.info("Extension is already requested to install",D.task.identifier.id,F.profileLocation.toString()),h.push(D.task.waitUntilTaskIsFinished())):R(L,S,F,void 0)}return await Promise.all([...o.values()].map(async({task:L})=>{if(L.options.donotIncludePackAndDependencies)this.F.info("Installing the extension without checking dependencies and pack",L.identifier.id);else try{const S=await this.M(L.identifier,L.manifest,!!L.options.installOnlyNewlyAddedFromExtensionPack,!!L.options.installPreReleaseVersion,L.options.profileLocation,L.options.productVersion),v=await this.getInstalled(void 0,L.options.profileLocation,L.options.productVersion),C={...L.options,context:{...L.options.context,[u.$$o]:!0}};for(const{gallery:F,manifest:D}of(0,P.$Ob)(S,({gallery:M})=>M.identifier.id)){if(o.has(`${F.identifier.id.toLowerCase()}-${C.profileLocation.toString()}`))continue;const M=this.j.get(g(F,C.profileLocation));if(M){if(this.J(L,M.task)){const J=M.task.identifier;this.F.info("Waiting for already requested installing extension",J.id,L.identifier.id,C.profileLocation.toString()),M.waitingTasks.push(L),h.push(T.Event.toPromise(T.Event.filter(this.onDidInstallExtensions,H=>H.some(x=>(0,p.$Hp)(x.identifier,J)))).then(H=>{if(this.F.info("Finished waiting for already requested installing extension",J.id,L.identifier.id,C.profileLocation.toString()),!H.find(K=>(0,p.$Hp)(K.identifier,J))?.local)throw new Error(`Extension ${J.id} is not installed`)}))}}else v.some(({identifier:J})=>(0,p.$Hp)(J,F.identifier))||R(D,F,C,L)}}catch(S){if(E.URI.isUri(L.source))(0,P.$Nb)(L.manifest.extensionDependencies)&&this.F.warn("Cannot install dependencies of extension:",L.identifier.id,S.message),(0,P.$Nb)(L.manifest.extensionPack)&&this.F.warn("Cannot install packed extensions of extension:",L.identifier.id,S.message);else throw this.F.error("Error while preparing to install dependencies and extension packs of the extension:",L.identifier.id),S}})),await this.L([...o.entries()].map(async([L,{task:S}])=>{const v=new Date().getTime();let C;try{C=await S.run(),await this.L(this.y.map(F=>F.postInstall(C,S.source,S.options,N.CancellationToken.None)),u.ExtensionManagementErrorCode.PostInstall)}catch(F){const D=s(F);throw E.URI.isUri(S.source)||r(this.C,S.operation===u.InstallOperation.Update?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,p.$Pp)(S.source),error:D,source:S.options.context?.[u.$0o]}),n.set(L,{error:D,identifier:S.identifier,operation:S.operation,source:S.source,context:S.options.context,profileLocation:S.options.profileLocation,applicationScoped:S.options.isApplicationScoped}),this.F.error("Error while installing the extension",S.identifier.id,(0,O.$_)(D),S.options.profileLocation.toString()),D}if(!E.URI.isUri(S.source)){const F=S.operation===u.InstallOperation.Update,D=F?void 0:(new Date().getTime()-S.source.lastUpdated)/1e3;if(r(this.C,F?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,p.$Pp)(S.source),verificationStatus:S.verificationStatus,duration:new Date().getTime()-v,durationSinceUpdate:D,source:S.options.context?.[u.$0o]}),A.$o&&S.operation!==u.InstallOperation.Update)try{await this.z.reportStatistic(C.manifest.publisher,C.manifest.name,C.manifest.version,u.StatisticType.Install)}catch{}}n.set(L,{local:C,identifier:S.identifier,operation:S.operation,source:S.source,context:S.options.context,profileLocation:S.options.profileLocation,applicationScoped:C.isApplicationScoped})})),h.length&&await this.L(h),[...n.values()]}catch(L){const S=(F,D,M)=>{const J=[];F.manifest.extensionDependencies?.length&&J.push(...F.manifest.extensionDependencies),F.manifest.extensionPack?.length&&J.push(...F.manifest.extensionPack);for(const H of J){if(M.includes(H.toLowerCase()))continue;M.push(H.toLowerCase());const x=n.get(`${H.toLowerCase()}-${D.toString()}`);x?.local&&(M=S(x.local,D,M))}return M},v=F=>({identifier:F.identifier,operation:u.InstallOperation.Install,source:F.source,context:F.options.context,profileLocation:F.options.profileLocation,error:L}),C=[];for(const[F,{task:D,root:M}]of o){const J=n.get(F);J?J.local&&M&&!n.get(`${M.identifier.id.toLowerCase()}-${D.options.profileLocation.toString()}`)?.local&&(C.push(this.Z(J.local,{versionOnly:!0,profileLocation:D.options.profileLocation})),n.set(F,v(D))):(D.cancel(),n.set(F,v(D)))}for(const[F,{task:D}]of o){const M=n.get(F);if(!M?.local||D.options.donotIncludePackAndDependencies)continue;S(M.local,D.options.profileLocation,[M.local.identifier.id.toLowerCase()]).slice(1).some(H=>o.has(`${H.toLowerCase()}-${D.options.profileLocation.toString()}`)&&!n.get(`${H.toLowerCase()}-${D.options.profileLocation.toString()}`)?.local)&&(C.push(this.Z(M.local,{versionOnly:!0,profileLocation:D.options.profileLocation})),n.set(F,v(D)))}throw C.length&&await Promise.allSettled(C.map(async F=>{try{await F.run(),this.F.info("Rollback: Uninstalled extension",F.extension.identifier.id)}catch(D){this.F.warn("Rollback: Error while uninstalling extension",F.extension.identifier.id,(0,O.$_)(D))}})),L}finally{for(const{task:L}of o.values())L.source&&!E.URI.isUri(L.source)&&this.j.delete(g(L.source,L.options.profileLocation));if(n.size){const L=[...n.values()];for(const S of L)S.local&&this.F.info("Extension installed successfully:",S.identifier.id,S.profileLocation.toString());this.s.fire(L)}}}J(t,n){for(const[,{task:o,waitingTasks:h}]of this.j.entries())if(o===t&&(h.includes(n)||h.some(g=>this.J(g,n)))||o===n&&h[0]&&!this.J(t,h[0]))return!1;return!0}async L(t,n){const o=[],h=[],g=await Promise.allSettled(t);for(const L of g)L.status==="fulfilled"?o.push(L.value):h.push(s(L.reason,n));if(!h.length)return o;if(h.length===1)throw h[0];let R=new u.$ip("",u.ExtensionManagementErrorCode.Unknown);for(const L of h)R=new u.$ip(R.message?`${R.message}, ${L.message}`:L.message,L.code!==u.ExtensionManagementErrorCode.Unknown&&L.code!==u.ExtensionManagementErrorCode.Internal?L.code:R.code);throw R}async M(t,n,o,h,g,R){if(!this.z.isEnabled())return[];const L=await this.getInstalled(void 0,g,R),S=[],v=[],C=async(F,D)=>{S.push(F);const M=D.extensionDependencies||[],J=[...M];if(D.extensionPack){const H=o?L.find(x=>(0,p.$Hp)(x.identifier,F)):void 0;for(const x of D.extensionPack)H&&H.manifest.extensionPack&&H.manifest.extensionPack.some(K=>(0,p.$Hp)({id:K},{id:x}))||J.every(K=>!(0,p.$Hp)({id:K},{id:x}))&&J.push(x)}if(J.length){const H=J.filter(x=>S.every(K=>!(0,p.$Hp)(K,{id:x})));if(H.length){const x=await this.z.getExtensions(H.map(K=>({id:K,preRelease:h})),N.CancellationToken.None);for(const K of x){if(S.find(z=>(0,p.$Hp)(z,K.identifier)))continue;const ie=M.some(z=>(0,p.$Hp)({id:z},K.identifier));let V;try{V=await this.N(K,!1,h,R)}catch(z){if(ie)throw z;this.F.info("Skipping the packed extension as it cannot be installed",K.identifier.id,(0,O.$_)(z));continue}v.push({gallery:V.extension,manifest:V.manifest}),await C(V.extension.identifier,V.manifest)}}}};return await C(t,n),v}async N(t,n,o,h){let g;const R=await this.getExtensionsControlManifest();if(R.malicious.some(v=>(0,p.$Hp)(t.identifier,v)))throw new u.$ip($.localize(1,null,t.identifier.id),u.ExtensionManagementErrorCode.Malicious);const L=R.deprecated[t.identifier.id.toLowerCase()];if(L?.extension?.autoMigrate){if(this.F.info(`The '${t.identifier.id}' extension is deprecated, fetching the compatible '${L.extension.id}' extension instead.`),g=(await this.z.getExtensions([{id:L.extension.id,preRelease:L.extension.preRelease}],{targetPlatform:await this.getTargetPlatform(),compatible:!0,productVersion:h},N.CancellationToken.None))[0],!g)throw new u.$ip($.localize(2,null,t.identifier.id,L.extension.id),u.ExtensionManagementErrorCode.Deprecated)}else{if(!await this.canInstall(t)){const v=await this.getTargetPlatform();throw new u.$ip($.localize(3,null,t.identifier.id,this.G.nameLong,(0,u.$ap)(v)),u.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}if(g=await this.O(t,n,o,h),!g)throw!o&&t.properties.isPreReleaseVersion&&(await this.z.getExtensions([t.identifier],N.CancellationToken.None))[0]?new u.$ip($.localize(4,null,t.displayName??t.identifier.id),u.ExtensionManagementErrorCode.ReleaseVersionNotFound):new u.$ip($.localize(5,null,t.identifier.id,this.G.nameLong,this.G.version),u.ExtensionManagementErrorCode.Incompatible)}this.F.info("Getting Manifest...",g.identifier.id);const S=await this.z.getManifest(g,N.CancellationToken.None);if(S===null)throw new u.$ip(`Missing manifest for extension ${g.identifier.id}`,u.ExtensionManagementErrorCode.Invalid);if(S.version!==g.version)throw new u.$ip(`Cannot install '${g.identifier.id}' extension because of version mismatch in Marketplace`,u.ExtensionManagementErrorCode.Invalid);return{extension:g,manifest:S}}async O(t,n,o,h){const g=await this.getTargetPlatform();let R=null;return!n&&t.hasPreReleaseVersion&&t.properties.isPreReleaseVersion!==o&&(R=(await this.z.getExtensions([{...t.identifier,preRelease:o}],{targetPlatform:g,compatible:!0,productVersion:h},N.CancellationToken.None))[0]||null),!R&&await this.z.isExtensionCompatible(t,o,g,h)&&(R=t),R||(n?R=(await this.z.getExtensions([{...t.identifier,version:t.version}],{targetPlatform:g,compatible:!0,productVersion:h},N.CancellationToken.None))[0]||null:R=await this.z.getCompatibleExtension(t,o,g,h)),R}async P(t,n){const o={...n,profileLocation:t.isApplicationScoped?this.H.defaultProfile.extensionsResource:n.profileLocation??this.X()},h=C=>`${C.id.toLowerCase()}${o.versionOnly?`-${t.manifest.version}`:""}${o.profileLocation?`@${o.profileLocation.toString()}`:""}`,g=this.m.get(h(t.identifier));if(g)return this.F.info("Extensions is already requested to uninstall",t.identifier.id),g.waitUntilTaskIsFinished();const R=C=>{const F=this.Z(C,o);return this.m.set(h(F.extension.identifier),F),o.profileLocation?this.F.info("Uninstalling extension from the profile:",`${C.identifier.id}@${C.manifest.version}`,o.profileLocation.toString()):this.F.info("Uninstalling extension:",`${C.identifier.id}@${C.manifest.version}`),this.t.fire({identifier:C.identifier,profileLocation:o.profileLocation,applicationScoped:C.isApplicationScoped}),F},L=(C,F)=>{F?o.profileLocation?this.F.error("Failed to uninstall extension from the profile:",`${C.identifier.id}@${C.manifest.version}`,o.profileLocation.toString(),F.message):this.F.error("Failed to uninstall extension:",`${C.identifier.id}@${C.manifest.version}`,F.message):o.profileLocation?this.F.info("Successfully uninstalled extension from the profile",`${C.identifier.id}@${C.manifest.version}`,o.profileLocation.toString()):this.F.info("Successfully uninstalled extension:",`${C.identifier.id}@${C.manifest.version}`),r(this.C,"extensionGallery:uninstall",{extensionData:(0,p.$Op)(C),error:F}),this.u.fire({identifier:C.identifier,error:F?.code,profileLocation:o.profileLocation,applicationScoped:C.isApplicationScoped})},S=[],v=[];try{S.push(R(t));const C=await this.getInstalled(l.ExtensionType.User,o.profileLocation);if(o.donotIncludePack)this.F.info("Uninstalling the extension without including packed extension",`${t.identifier.id}@${t.manifest.version}`);else{const F=this.S(t,C);for(const D of F)this.m.has(h(D.identifier))?this.F.info("Extensions is already requested to uninstall",D.identifier.id):S.push(R(D))}o.donotCheckDependents?this.F.info("Uninstalling the extension without checking dependents",`${t.identifier.id}@${t.manifest.version}`):this.Q(S.map(F=>F.extension),C,t),await this.L(S.map(async F=>{try{if(await F.run(),await this.L(this.y.map(D=>D.postUninstall(F.extension,o,N.CancellationToken.None))),F.extension.identifier.uuid)try{await this.z.reportStatistic(F.extension.manifest.publisher,F.extension.manifest.name,F.extension.manifest.version,u.StatisticType.Uninstall)}catch{}L(F.extension)}catch(D){const M=s(D);throw L(F.extension,M),M}finally{v.push(F)}}))}catch(C){const F=s(C);for(const D of S){try{D.cancel()}catch{}v.includes(D)||L(D.extension,F)}throw F}finally{for(const C of S)this.m.delete(h(C.extension.identifier))||this.F.warn("Uninstallation task is not found in the cache",C.extension.identifier.id)}}Q(t,n,o){for(const h of t){const g=this.U(h,n);if(g.length){const R=g.filter(L=>!t.some(S=>(0,p.$Hp)(S.identifier,L.identifier)));if(R.length)throw new Error(this.R(h,R,o))}}}R(t,n,o){return o===t?n.length===1?$.localize(6,null,o.manifest.displayName||o.manifest.name,n[0].manifest.displayName||n[0].manifest.name):n.length===2?$.localize(7,null,o.manifest.displayName||o.manifest.name,n[0].manifest.displayName||n[0].manifest.name,n[1].manifest.displayName||n[1].manifest.name):$.localize(8,null,o.manifest.displayName||o.manifest.name,n[0].manifest.displayName||n[0].manifest.name,n[1].manifest.displayName||n[1].manifest.name):n.length===1?$.localize(9,null,o.manifest.displayName||o.manifest.name,t.manifest.displayName||t.manifest.name,n[0].manifest.displayName||n[0].manifest.name):n.length===2?$.localize(10,null,o.manifest.displayName||o.manifest.name,t.manifest.displayName||t.manifest.name,n[0].manifest.displayName||n[0].manifest.name,n[1].manifest.displayName||n[1].manifest.name):$.localize(11,null,o.manifest.displayName||o.manifest.name,t.manifest.displayName||t.manifest.name,n[0].manifest.displayName||n[0].manifest.name,n[1].manifest.displayName||n[1].manifest.name)}S(t,n,o=[]){if(o.indexOf(t)!==-1)return[];o.push(t);const h=t.manifest.extensionPack?t.manifest.extensionPack:[];if(h.length){const g=n.filter(L=>!L.isBuiltin&&h.some(S=>(0,p.$Hp)({id:S},L.identifier))),R=[];for(const L of g)R.push(...this.S(L,n,o));return[...g,...R]}return[]}U(t,n){return n.filter(o=>o.manifest.extensionDependencies&&o.manifest.extensionDependencies.some(h=>(0,p.$Hp)({id:h},t.identifier)))}async W(){try{return this.F.trace("ExtensionManagementService.updateControlCache"),await this.z.getExtensionsControlManifest()}catch(t){return this.F.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest",(0,O.$_)(t)),{malicious:[],deprecated:{},search:[]}}}};e.$yq=m,e.$yq=m=ve([Y(0,u.$gp),Y(1,f.$$l),Y(2,b.$Jl),Y(3,d.$_j),Y(4,y.$sk),Y(5,I.$Ll)],m);function s(a,t){if(a instanceof u.$ip)return a;let n;return a instanceof u.$hp?n=new u.$ip(a.message,a.code===u.ExtensionGalleryErrorCode.DownloadFailedWriting?u.ExtensionManagementErrorCode.DownloadFailedWriting:u.ExtensionManagementErrorCode.Gallery):n=new u.$ip(a.message,(0,O.$6)(a)?u.ExtensionManagementErrorCode.Cancelled:t??u.ExtensionManagementErrorCode.Internal),n.stack=a.stack,n}function r(a,t,{extensionData:n,verificationStatus:o,duration:h,error:g,source:R,durationSinceUpdate:L}){let S,v;(0,w.$ng)(o)&&(o===!0?o="Verified":(o===!1||(S=u.ExtensionManagementErrorCode.Signature,v=o),o="Unverified")),g&&(S=g.code,g.code===u.ExtensionManagementErrorCode.Signature&&(v=g.message)),a.publicLog(t,{...n,verificationStatus:o,success:!g,duration:h,errorcode:S,errorcodeDetail:v,durationSinceUpdate:L,source:R})}class i{constructor(){this.d=new c.$Eh}async waitUntilTaskIsFinished(){return await this.d.wait(),this.g}run(){return this.g||(this.g=(0,c.$sh)(t=>this.h(t))),this.d.open(),this.g}cancel(){this.g||(this.g=(0,c.$sh)(t=>new Promise((n,o)=>{const h=t.onCancellationRequested(()=>{h.dispose(),o(new O.$7)})})),this.d.open()),this.g.cancel()}}e.$Aq=i}),define(ce[53],le([0,1,6,15,2,3,35,9,28,33,7,4,10,20,29,13,8,18]),function(ne,e,P,c,N,O,T,k,A,w,E,$,u,p,l,d,y,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dq=e.$Cq=e.$Bq=e.ExtensionsProfileScanningErrorCode=void 0;var b;(function(i){i.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",i.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(b||(e.ExtensionsProfileScanningErrorCode=b={}));class I extends Error{constructor(a,t){super(a),this.code=t}}e.$Bq=I,e.$Cq=(0,$.$Fi)("IExtensionsProfileScannerService");let m=class extends N.$Wc{constructor(a,t,n,o,h,g){super(),this.j=a,this.m=t,this.n=n,this.r=o,this.s=h,this.t=g,this.b=this.B(new O.$me),this.onAddExtensions=this.b.event,this.c=this.B(new O.$me),this.onDidAddExtensions=this.c.event,this.f=this.B(new O.$me),this.onRemoveExtensions=this.f.event,this.g=this.B(new O.$me),this.onDidRemoveExtensions=this.g.event,this.h=new T.$Cc}scanProfileExtensions(a,t){return this.u(a,void 0,t)}async addExtensionsToProfile(a,t,n){const o=[],h=[];try{return await this.u(t,g=>{const R=[];if(n)R.push(...g);else for(const L of g)a.some(([S])=>(0,w.$Hp)(S.identifier,L.identifier)&&S.manifest.version!==L.version)?o.push(L):R.push(L);for(const[L,S]of a){const v=R.findIndex(F=>(0,w.$Hp)(F.identifier,L.identifier)&&F.version===L.manifest.version),C={identifier:L.identifier,version:L.manifest.version,location:L.location,metadata:S};v===-1?(h.push(C),R.push(C)):R.splice(v,1,C)}return h.length&&this.b.fire({extensions:h,profileLocation:t}),o.length&&this.f.fire({extensions:o,profileLocation:t}),R}),h.length&&this.c.fire({extensions:h,profileLocation:t}),o.length&&this.g.fire({extensions:o,profileLocation:t}),h}catch(g){throw h.length&&this.c.fire({extensions:h,error:g,profileLocation:t}),o.length&&this.g.fire({extensions:o,error:g,profileLocation:t}),g}}async updateMetadata(a,t){const n=[];return await this.u(t,o=>{const h=[];for(const g of o){const R=a.find(([L])=>(0,w.$Hp)(L.identifier,g.identifier)&&L.manifest.version===g.version);R&&(g.metadata={...g.metadata,...R[1]},n.push(g)),h.push(g)}return h}),n}async removeExtensionFromProfile(a,t){const n=[];try{await this.u(t,o=>{const h=[];for(const g of o)(0,w.$Hp)(g.identifier,a.identifier)?n.push(g):h.push(g);return n.length&&this.f.fire({extensions:n,profileLocation:t}),h}),n.length&&this.g.fire({extensions:n,profileLocation:t})}catch(o){throw n.length&&this.g.fire({extensions:n,error:o,profileLocation:t}),o}}async u(a,t,n){return this.F(a).queue(async()=>{let o=[],h;try{const g=await this.m.readFile(a);h=JSON.parse(g.value.toString().trim()||"[]")}catch(g){if((0,E.$ql)(g)!==E.FileOperationResult.FILE_NOT_FOUND)throw g;if(this.r.extUri.isEqual(a,this.n.defaultProfile.extensionsResource)&&(h=await this.D()),!h&&n?.bailOutWhenFileNotFound)throw new I((0,y.$_)(g),b.ERROR_PROFILE_NOT_FOUND)}if(h){Array.isArray(h)||this.w(a);let g=!1;for(const R of h){s(R)||this.w(a);let L;if((0,d.$fg)(R.relativeLocation)&&R.relativeLocation)L=this.z(R.relativeLocation);else if((0,d.$fg)(R.location)){this.t.warn(`Extensions profile: Ignoring extension with invalid location: ${R.location}`);continue}else{L=k.URI.revive(R.location);const S=this.y(L);S&&(g=!0,R.relativeLocation=S)}(0,d.$mg)(R.metadata?.hasPreReleaseVersion)&&R.metadata?.preRelease&&(g=!0,R.metadata.hasPreReleaseVersion=!0),o.push({identifier:R.identifier,location:L,version:R.version,metadata:R.metadata})}g&&await this.m.writeFile(a,c.$Oe.fromString(JSON.stringify(h)))}if(t){o=t(o);const g=o.map(R=>({identifier:R.identifier,version:R.version,location:R.location.toJSON(),relativeLocation:this.y(R.location),metadata:R.metadata}));await this.m.writeFile(a,c.$Oe.fromString(JSON.stringify(g)))}return o})}w(a){const t=new I(`Invalid extensions content in ${a.toString()}`,b.ERROR_INVALID_CONTENT);throw this.s.publicLogError2("extensionsProfileScanningError",{code:t.code}),t}y(a){return this.r.extUri.isEqual(this.r.extUri.dirname(a),this.j)?this.r.extUri.basename(a):void 0}z(a){return this.r.extUri.joinPath(this.j,a)}async D(){return this.C||(this.C=(async()=>{const a=this.r.extUri.joinPath(this.n.defaultProfile.location,"extensions.json"),t=this.r.extUri.joinPath(this.j,".init-default-profile-extensions");let n;try{n=(await this.m.readFile(a)).value.toString()}catch(h){if((0,E.$ql)(h)===E.FileOperationResult.FILE_NOT_FOUND)return;throw h}this.t.info("Migrating extensions from old default profile location",a.toString());let o;try{const h=JSON.parse(n);Array.isArray(h)&&h.every(g=>s(g))?o=h:this.t.warn("Skipping migrating from old default profile locaiton: Found invalid data",h)}catch(h){this.t.error(h)}if(o)try{await this.m.createFile(this.n.defaultProfile.extensionsResource,c.$Oe.fromString(JSON.stringify(o)),{overwrite:!1}),this.t.info("Migrated extensions from old default profile location to new location",a.toString(),this.n.defaultProfile.extensionsResource.toString())}catch(h){if((0,E.$ql)(h)===E.FileOperationResult.FILE_MODIFIED_SINCE)this.t.info("Migration from old default profile location to new location is done by another window",a.toString(),this.n.defaultProfile.extensionsResource.toString());else throw h}try{await this.m.del(a)}catch(h){(0,E.$ql)(h)!==E.FileOperationResult.FILE_NOT_FOUND&&this.t.error(h)}try{await this.m.del(t)}catch(h){(0,E.$ql)(h)!==E.FileOperationResult.FILE_NOT_FOUND&&this.t.error(h)}return o})()),this.C}F(a){let t=this.h.get(a);return t||(t=new P.$Mh,this.h.set(a,t)),t}};e.$Dq=m,e.$Dq=m=ve([Y(1,E.$_k),Y(2,p.$Ll),Y(3,l.$Jl),Y(4,f.$$l),Y(5,u.$_j)],m);function s(i){return(0,d.$hg)(i)&&(0,A.$fp)(i.identifier)&&(r(i.location)||(0,d.$fg)(i.location)&&i.location)&&((0,d.$mg)(i.relativeLocation)||(0,d.$fg)(i.relativeLocation))&&i.version&&(0,d.$fg)(i.version)}function r(i){return i?(0,d.$fg)(i.path)&&(0,d.$fg)(i.scheme):!1}});var it=this&&this.__importDefault||function(ne){return ne&&ne.__esModule?ne:{default:ne}};define(ce[85],le([0,1,19,6,30,15,8,34,144,2,23,14,5,21,57,92,13,9,165,16,33,37,73,7,4,10,24,3,68,53,20,29,194]),function(ne,e,P,c,N,O,T,k,A,w,E,$,u,p,l,d,y,f,b,I,m,s,r,i,a,t,n,o,h,g,R,L,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kq=e.$Iq=e.$Hq=e.$Gq=e.Translations=void 0,e.$Jq=J,N=Oe(N),$=Oe($),u=Oe(u),l=Oe(l),d=it(d);var v;(function(x){function K(ie,V){if(ie===V)return!0;const z=Object.keys(ie),ee=new Set;for(const se of Object.keys(V))ee.add(se);if(z.length!==ee.size)return!1;for(const se of z){if(ie[se]!==V[se])return!1;ee.delete(se)}return ee.size===0}x.equals=K})(v||(e.Translations=v={})),e.$Gq=(0,a.$Fi)("IExtensionsScannerService");let C=class extends w.$Wc{constructor(K,ie,V,z,ee,se,he,q,Z,X,G,U){super(),this.systemExtensionsLocation=K,this.userExtensionsLocation=ie,this.r=V,this.s=z,this.t=ee,this.u=se,this.w=he,this.y=q,this.z=Z,this.C=X,this.D=G,this.F=U,this.g=this.B(new o.$me),this.onDidChangeCache=this.g.event,this.h=(0,p.$gh)(this.userExtensionsLocation,".obsolete"),this.j=this.B(this.F.createInstance(M,this.s,this.h)),this.m=this.B(this.F.createInstance(M,this.s,this.h)),this.n=this.B(this.F.createInstance(D,this.h)),this.H=void 0,this.B(this.j.onDidChangeCache(()=>this.g.fire(s.ExtensionType.System))),this.B(this.m.onDidChangeCache(()=>this.g.fire(s.ExtensionType.User)))}getTargetPlatform(){return this.G||(this.G=(0,m.$Sp)(this.w,this.y)),this.G}async scanAllExtensions(K,ie,V){const[z,ee]=await Promise.all([this.scanSystemExtensions(K),this.scanUserExtensions(ie)]),se=V?await this.scanExtensionsUnderDevelopment(K,[...z,...ee]):[];return this.L(z,ee,se,await this.getTargetPlatform(),!0)}async scanSystemExtensions(K){const ie=[];ie.push(this.M(!!K.useCache,K.language)),ie.push(this.N(K.language,!!K.checkControlFile));const[V,z]=await Promise.all(ie);return this.J([...V,...z],s.ExtensionType.System,K,!1)}async scanUserExtensions(K){const ie=K.profileLocation??this.userExtensionsLocation;this.y.trace("Started scanning user extensions",ie);const V=this.D.extUri.isEqual(K.profileLocation,this.t.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,z=await this.P(ie,!!K.profileLocation,s.ExtensionType.User,!K.includeUninstalled,K.language,!0,V,K.productVersion??this.R()),ee=K.useCache&&!z.devMode&&z.excludeObsolete?this.m:this.n;let se;try{se=await ee.scanExtensions(z)}catch(he){if(he instanceof g.$Bq&&he.code===g.ExtensionsProfileScanningErrorCode.ERROR_PROFILE_NOT_FOUND)await this.I(),se=await ee.scanExtensions(z);else throw he}return se=await this.J(se,s.ExtensionType.User,K,!0),this.y.trace("Scanned user extensions:",se.length),se}async scanExtensionsUnderDevelopment(K,ie){if(this.z.isExtensionDevelopment&&this.z.extensionDevelopmentLocationURI){const V=(await Promise.all(this.z.extensionDevelopmentLocationURI.filter(z=>z.scheme===E.Schemas.file).map(async z=>{const ee=await this.P(z,!1,s.ExtensionType.User,!0,K.language,!1,void 0,K.productVersion??this.R());return(await this.n.scanOneOrMultipleExtensions(ee)).map(he=>(he.type=ie.find(q=>(0,m.$Hp)(q.identifier,he.identifier))?.type??he.type,this.n.validate(he,ee)))}))).flat();return this.J(V,"development",K,!0)}return[]}async scanExistingExtension(K,ie,V){const z=await this.P(K,!1,ie,!0,V.language,!0,void 0,V.productVersion??this.R()),ee=await this.n.scanExtension(z);return!ee||!V.includeInvalid&&!ee.isValid?null:ee}async scanOneOrMultipleExtensions(K,ie,V){const z=await this.P(K,!1,ie,!0,V.language,!0,void 0,V.productVersion??this.R()),ee=await this.n.scanOneOrMultipleExtensions(z);return this.J(ee,ie,V,!0)}async scanMultipleExtensions(K,ie,V){const z=[];return await Promise.all(K.map(async ee=>{const se=await this.scanOneOrMultipleExtensions(ee,ie,V);z.push(...se)})),this.J(z,ie,V,!0)}async scanMetadata(K){const ie=(0,p.$gh)(K,"package.json"),V=(await this.w.readFile(ie)).value.toString();return JSON.parse(V).__metadata}async updateMetadata(K,ie){const V=(0,p.$gh)(K,"package.json"),z=(await this.w.readFile(V)).value.toString(),ee=JSON.parse(z);ie.isMachineScoped===!1&&delete ie.isMachineScoped,ie.isBuiltin===!1&&delete ie.isBuiltin,ee.__metadata={...ee.__metadata,...ie},await this.w.writeFile((0,p.$gh)(K,"package.json"),O.$Oe.fromString(JSON.stringify(ee,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.u.scanProfileExtensions(this.t.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(K){if(K instanceof g.$Bq&&K.code===g.ExtensionsProfileScanningErrorCode.ERROR_PROFILE_NOT_FOUND)await this.I();else throw K}}async I(){return this.H||(this.H=(async()=>{try{this.y.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const K=await this.scanUserExtensions({includeInvalid:!0});if(K.length)await this.u.addExtensionsToProfile(K.map(ie=>[ie,ie.metadata]),this.t.defaultProfile.extensionsResource);else try{await this.w.createFile(this.t.defaultProfile.extensionsResource,O.$Oe.fromString(JSON.stringify([])))}catch(ie){(0,i.$ql)(ie)!==i.FileOperationResult.FILE_NOT_FOUND&&this.y.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,T.$_)(ie))}this.y.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(K){this.y.error(K)}finally{this.H=void 0}})()),this.H}async J(K,ie,V,z){return V.includeAllVersions||(K=this.L(ie===s.ExtensionType.System?K:void 0,ie===s.ExtensionType.User?K:void 0,ie==="development"?K:void 0,await this.getTargetPlatform(),z)),V.includeInvalid||(K=K.filter(ee=>ee.isValid)),K.sort((ee,se)=>{const he=$.$pc(ee.location.fsPath),q=$.$pc(se.location.fsPath);return he<q?-1:he>q?1:0})}L(K,ie,V,z,ee){const se=(q,Z,X)=>{if(q.isValid&&!Z.isValid)return!1;if(q.isValid===Z.isValid){if(ee&&l.gt(q.manifest.version,Z.manifest.version))return this.y.debug(`Skipping extension ${Z.location.path} with lower version ${Z.manifest.version} in favour of ${q.location.path} with version ${q.manifest.version}`),!1;if(l.eq(q.manifest.version,Z.manifest.version)){if(q.type===s.ExtensionType.System)return this.y.debug(`Skipping extension ${Z.location.path} in favour of system extension ${q.location.path} with same version`),!1;if(q.targetPlatform===z)return this.y.debug(`Skipping extension ${Z.location.path} from different target platform ${Z.targetPlatform}`),!1}}return X?this.y.warn(`Overwriting user extension ${q.location.path} with ${Z.location.path}.`):this.y.debug(`Overwriting user extension ${q.location.path} with ${Z.location.path}.`),!0},he=new s.$sn;return K?.forEach(q=>{const Z=he.get(q.identifier.id);(!Z||se(Z,q,!1))&&he.set(q.identifier.id,q)}),ie?.forEach(q=>{const Z=he.get(q.identifier.id);if(!Z&&K&&q.type===s.ExtensionType.System){this.y.debug(`Skipping obsolete system extension ${q.location.path}.`);return}(!Z||se(Z,q,!1))&&he.set(q.identifier.id,q)}),V?.forEach(q=>{const Z=he.get(q.identifier.id);(!Z||se(Z,q,!0))&&he.set(q.identifier.id,q),he.set(q.identifier.id,q)}),[...he.values()]}async M(K,ie){this.y.trace("Started scanning system extensions");const V=await this.P(this.systemExtensionsLocation,!1,s.ExtensionType.System,!0,ie,!0,void 0,this.R()),ee=await(K&&!V.devMode?this.j:this.n).scanExtensions(V);return this.y.trace("Scanned system extensions:",ee.length),ee}async N(K,ie){const V=this.z.isBuilt?[]:this.C.builtInExtensions;if(!V?.length)return[];this.y.trace("Started scanning dev system extensions");const z=ie?await this.O():{},ee=[],se=f.URI.file($.$jc($.$lc(E.$Zg.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const q of V){const Z=z[q.name]||"marketplace";switch(Z){case"disabled":break;case"marketplace":ee.push((0,p.$gh)(se,q.name));break;default:ee.push(f.URI.file(Z));break}}const he=await Promise.all(ee.map(async q=>this.n.scanExtension(await this.P(q,!1,s.ExtensionType.System,!0,K,!0,void 0,this.R()))));return this.y.trace("Scanned dev system extensions:",he.length),(0,P.$Jb)(he)}async O(){try{const K=await this.w.readFile(this.r);return JSON.parse(K.value.toString())}catch{return{}}}async P(K,ie,V,z,ee,se,he,q){const Z=await this.f(ee??u.$w),X=await this.Q(K),G=ie&&!this.D.extUri.isEqual(K,this.t.defaultProfile.extensionsResource)?this.t.defaultProfile.extensionsResource:void 0,U=G?await this.Q(G):void 0;return new F(K,X,G,U,ie,he,V,z,se,q.version,q.date,this.C.commit,!this.z.isBuilt,ee,Z)}async Q(K){try{const ie=await this.w.stat(K);if(typeof ie.mtime=="number")return ie.mtime}catch{}}R(){return{version:this.C.version,date:this.C.date}}};e.$Hq=C,e.$Hq=C=ve([Y(4,R.$Ll),Y(5,g.$Cq),Y(6,i.$_k),Y(7,t.$_j),Y(8,I.$Mi),Y(9,n.$sk),Y(10,L.$Jl),Y(11,a.$Ei)],C);class F{constructor(K,ie,V,z,ee,se,he,q,Z,X,G,U,B,j,W){this.location=K,this.mtime=ie,this.applicationExtensionslocation=V,this.applicationExtensionslocationMtime=z,this.profile=ee,this.profileScanOptions=se,this.type=he,this.excludeObsolete=q,this.validate=Z,this.productVersion=X,this.productDate=G,this.productCommit=U,this.devMode=B,this.language=j,this.translations=W}static createNlsConfiguration(K){return{language:K.language,pseudo:K.language==="pseudo",devMode:K.devMode,translations:K.translations}}static equals(K,ie){return(0,p.$_g)(K.location,ie.location)&&K.mtime===ie.mtime&&(0,p.$_g)(K.applicationExtensionslocation,ie.applicationExtensionslocation)&&K.applicationExtensionslocationMtime===ie.applicationExtensionslocationMtime&&K.profile===ie.profile&&N.$fo(K.profileScanOptions,ie.profileScanOptions)&&K.type===ie.type&&K.excludeObsolete===ie.excludeObsolete&&K.validate===ie.validate&&K.productVersion===ie.productVersion&&K.productDate===ie.productDate&&K.productCommit===ie.productCommit&&K.devMode===ie.devMode&&K.language===ie.language&&v.equals(K.translations,ie.translations)}}e.$Iq=F;let D=class extends w.$Wc{constructor(K,ie,V,z,ee){super(),this.f=K,this.g=ie,this.h=V,this.j=z,this.m=ee}async scanExtensions(K){const ie=K.profile?await this.r(K):await this.n(K);let V={};if(K.excludeObsolete&&K.type===s.ExtensionType.User)try{const z=(await this.j.readFile(this.f)).value.toString();V=JSON.parse(z)}catch{}return(0,y.$sg)(V)?ie:ie.filter(z=>!V[m.$Ip.create(z).toString()])}async n(K){const ie=await this.j.resolve(K.location);if(!ie.children?.length)return[];const V=await Promise.all(ie.children.map(async z=>{if(!z.isDirectory||K.type===s.ExtensionType.User&&(0,p.$dh)(z.resource).indexOf(".")===0)return null;const ee=new F(z.resource,K.mtime,K.applicationExtensionslocation,K.applicationExtensionslocationMtime,K.profile,K.profileScanOptions,K.type,K.excludeObsolete,K.validate,K.productVersion,K.productDate,K.productCommit,K.devMode,K.language,K.translations);return this.scanExtension(ee)}));return(0,P.$Jb)(V).sort((z,ee)=>z.location.path<ee.location.path?-1:1)}async r(K){let ie=await this.s(K.location,()=>!0,K);if(K.applicationExtensionslocation&&!this.h.extUri.isEqual(K.location,K.applicationExtensionslocation)){ie=ie.filter(z=>!z.metadata?.isApplicationScoped);const V=await this.s(K.applicationExtensionslocation,z=>!!z.metadata?.isBuiltin||!!z.metadata?.isApplicationScoped,K);ie.push(...V)}return ie}async s(K,ie,V){const z=await this.g.scanProfileExtensions(K,V.profileScanOptions);if(!z.length)return[];const ee=await Promise.all(z.map(async se=>{if(ie(se)){const he=new F(se.location,V.mtime,V.applicationExtensionslocation,V.applicationExtensionslocationMtime,V.profile,V.profileScanOptions,V.type,V.excludeObsolete,V.validate,V.productVersion,V.productDate,V.productCommit,V.devMode,V.language,V.translations);return this.scanExtension(he,se.metadata)}return null}));return(0,P.$Jb)(ee)}async scanOneOrMultipleExtensions(K){try{if(await this.j.exists((0,p.$gh)(K.location,"package.json"))){const ie=await this.scanExtension(K);return ie?[ie]:[]}else return await this.scanExtensions(K)}catch(ie){return this.m.error(`Error scanning extensions at ${K.location.path}:`,(0,T.$_)(ie)),[]}}async scanExtension(K,ie){try{let V=await this.scanExtensionManifest(K.location);if(V){V.publisher||(V.publisher=s.$mn),ie=ie??V.__metadata,delete V.__metadata;const z=(0,m.$Mp)(V.publisher,V.name),ee=ie?.id?{id:z,uuid:ie.id}:{id:z},se=ie?.isSystem?s.ExtensionType.System:K.type,he=se===s.ExtensionType.System||!!ie?.isBuiltin;V=await this.t(K.location,V,F.createNlsConfiguration(K));const q={type:se,identifier:ee,manifest:V,location:K.location,isBuiltin:he,targetPlatform:ie?.targetPlatform??s.TargetPlatform.UNDEFINED,publisherDisplayName:ie?.publisherDisplayName,metadata:ie,isValid:!0,validations:[]};return K.validate?this.validate(q,K):q}}catch(V){K.type!==s.ExtensionType.System&&this.m.error(V)}return null}validate(K,ie){let V=!0;const z=(0,r.$Xp)(ie.productVersion,ie.productDate,ie.location,K.manifest,K.isBuiltin);for(const[ee,se]of z)ee===d.default.Error&&(V=!1,this.m.error(this.z(ie.location,se)));return K.isValid=V,K.validations=z,K}async scanExtensionManifest(K){const ie=(0,p.$gh)(K,"package.json");let V;try{V=(await this.j.readFile(ie)).value.toString()}catch(ee){return(0,i.$ql)(ee)!==i.FileOperationResult.FILE_NOT_FOUND&&this.m.error(this.z(K,(0,b.localize)(0,null,ie.path,ee.message))),null}let z;try{z=JSON.parse(V)}catch{const se=[];(0,k.$Vn)(V,se);for(const he of se)this.m.error(this.z(K,(0,b.localize)(1,null,ie.path,he.offset,he.length,(0,A.$Eq)(he.error))));return null}return(0,k.$4n)(z)!=="object"?(this.m.error(this.z(K,(0,b.localize)(2,null,ie.path))),null):z}async t(K,ie,V){const z=await this.u(K,ie,V);if(z)try{const ee=[],se=await this.w(z.default,ee);if(ee.length>0)return ee.forEach(q=>{this.m.error(this.z(K,(0,b.localize)(3,null,z.default?.path,(0,A.$Eq)(q.error))))}),ie;if((0,k.$4n)(z)!=="object")return this.m.error(this.z(K,(0,b.localize)(4,null,z.default?.path))),ie;const he=z.values||Object.create(null);return(0,S.$Fq)(this.m,ie,he,se)}catch{}return ie}async u(K,ie,V){const z=(0,p.$gh)(K,"package.nls.json"),ee=(Z,X)=>{X.forEach(G=>{this.m.error(this.z(K,(0,b.localize)(5,null,Z?.path,(0,A.$Eq)(G.error))))})},se=Z=>{this.m.error(this.z(K,(0,b.localize)(6,null,Z?.path)))},he=`${ie.publisher}.${ie.name}`,q=V.translations[he];if(q)try{const Z=f.URI.file(q),X=(await this.j.readFile(Z)).value.toString(),G=[],U=(0,k.$Vn)(X,G);return G.length>0?(ee(Z,G),{values:void 0,default:z}):(0,k.$4n)(U)!=="object"?(se(Z),{values:void 0,default:z}):{values:U.contents?U.contents.package:void 0,default:z}}catch{return{values:void 0,default:z}}else{if(!await this.j.exists(z))return;let X;try{X=await this.y(K,V)}catch{return}if(!X.localized)return{values:void 0,default:X.original};try{const G=(await this.j.readFile(X.localized)).value.toString(),U=[],B=(0,k.$Vn)(G,U);return U.length>0?(ee(X.localized,U),{values:void 0,default:X.original}):(0,k.$4n)(B)!=="object"?(se(X.localized),{values:void 0,default:X.original}):{values:B,default:X.original}}catch{return{values:void 0,default:X.original}}}}async w(K,ie){if(K)try{const V=(await this.j.readFile(K)).value.toString();return(0,k.$Vn)(V,ie)}catch{}}y(K,ie){return new Promise((V,z)=>{const ee=se=>{const he=(0,p.$gh)(K,`package.nls.${se}.json`);this.j.exists(he).then(q=>{q&&V({localized:he,original:(0,p.$gh)(K,"package.nls.json")});const Z=se.lastIndexOf("-");Z===-1?V({localized:(0,p.$gh)(K,"package.nls.json"),original:null}):(se=se.substring(0,Z),ee(se))})};if(ie.devMode||ie.pseudo||!ie.language)return V({localized:(0,p.$gh)(K,"package.nls.json"),original:null});ee(ie.language)})}z(K,ie){return`[${K.path}]: ${ie}`}};D=ve([Y(1,g.$Cq),Y(2,L.$Jl),Y(3,i.$_k),Y(4,t.$_j)],D);let M=class extends D{constructor(K,ie,V,z,ee,se,he){super(ie,z,ee,se,he),this.G=K,this.H=V,this.D=this.B(new c.$Dh(3e3)),this.F=this.B(new o.$me),this.onDidChangeCache=this.F.event}async scanExtensions(K){const ie=this.M(K),V=await this.I(ie);if(this.C=K,V&&V.input&&F.equals(V.input,this.C))return this.m.debug("Using cached extensions scan result",K.type===s.ExtensionType.System?"system":"user",K.location.toString()),this.D.trigger(()=>this.L()),V.result.map(ee=>(ee.location=f.URI.revive(ee.location),ee));const z=await super.scanExtensions(K);return await this.J(ie,{input:K,result:z}),z}async I(K){try{const ie=await this.j.readFile(K),V=JSON.parse(ie.value.toString());return{result:V.result,input:(0,h.$ci)(V.input)}}catch(ie){this.m.debug("Error while reading the extension cache file:",K.path,(0,T.$_)(ie))}return null}async J(K,ie){try{await this.j.writeFile(K,O.$Oe.fromString(JSON.stringify(ie)))}catch(V){this.m.debug("Error while writing the extension cache file:",K.path,(0,T.$_)(V))}}async L(){if(!this.C)return;const K=this.M(this.C),ie=await this.I(K);if(!ie)return;const V=ie.result,z=JSON.parse(JSON.stringify(await super.scanExtensions(this.C)));if(!N.$fo(z,V))try{this.m.info("Invalidating Cache",V,z),await this.j.del(K),this.F.fire()}catch(ee){this.m.error(ee)}}M(K){const ie=this.N(K);return this.h.extUri.joinPath(ie.cacheHome,K.type===s.ExtensionType.System?s.$ln:s.$kn)}N(K){return K.type===s.ExtensionType.System?this.H.defaultProfile:K.profile?this.h.extUri.isEqual(K.location,this.G.extensionsResource)?this.G:this.H.profiles.find(ie=>this.h.extUri.isEqual(K.location,ie.extensionsResource))??this.G:this.H.defaultProfile}};M=ve([Y(2,R.$Ll),Y(3,g.$Cq),Y(4,L.$Jl),Y(5,i.$_k),Y(6,t.$_j)],M);function J(x,K){const ie=(0,m.$Kp)(x.manifest.publisher,x.manifest.name);return{id:ie,identifier:new s.$qn(ie),isBuiltin:x.type===s.ExtensionType.System,isUserBuiltin:x.type===s.ExtensionType.User&&x.isBuiltin,isUnderDevelopment:K,extensionLocation:x.location,uuid:x.identifier.uuid,targetPlatform:x.targetPlatform,publisherDisplayName:x.publisherDisplayName,...x.manifest}}class H extends C{constructor(K,ie,V,z,ee,se,he,q,Z,X,G,U){super(K,ie,(0,p.$gh)(V,".vscode-oss-dev","extensions","control.json"),z,ee,se,he,q,Z,X,G,U),this.S=(async()=>{if(u.$z)try{const B=await this.w.readFile(f.URI.file(u.$z));return JSON.parse(B.value.toString())}catch{}return Object.create(null)})()}f(K){return this.S}}e.$Kq=H}),define(ce[251],le([0,1,69,6,41,3,2,23,14,31,10,20]),function(ne,e,P,c,N,O,T,k,A,w,E,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oq=void 0;let u=class extends T.$Wc{constructor(l,d){super(),this.b=l,this.f=d,this.a=new c.$Lh(5)}async postUninstall(l){const d=this.g(l,"uninstall");d&&(this.f.info(l.identifier.id,l.manifest.version,"Running post uninstall script"),await this.a.queue(async()=>{try{await this.h(d.script,"uninstall",d.args,!0,l),this.f.info("Finished running post uninstall script",l.identifier.id,l.manifest.version)}catch(y){this.f.error("Failed to run post uninstall script",l.identifier.id,l.manifest.version),this.f.error(y)}}));try{await w.Promises.rm(this.m(l))}catch(y){this.f.error("Error while removing extension storage path",l.identifier.id),this.f.error(y)}}g(l,d){const y=`vscode:${d}`;if(l.location.scheme===k.Schemas.file&&l.manifest&&l.manifest.scripts&&typeof l.manifest.scripts[y]=="string"){const f=l.manifest.scripts[y].split(" ");return f.length<2||f[0]!=="node"||!f[1]?(this.f.warn(l.identifier.id,l.manifest.version,`${y} should be a node script`),null):{script:(0,A.$lc)(l.location.fsPath,f[1]),args:f.slice(2)||[]}}return null}h(l,d,y,f,b){return new Promise((I,m)=>{const s=this.j(l,d,y,b);let r;const i=a=>{r&&(clearTimeout(r),r=null),a?m(a):I(void 0)};s.on("error",a=>{i((0,N.$qj)(a)||"Unknown")}),s.on("exit",(a,t)=>{i(a?`post-${d} process exited with code ${a}`:void 0)}),f&&(r=setTimeout(()=>{r=null,s.kill(),m("timed out")},5e3))})}j(l,d,y,f){const b={silent:!0,execArgv:void 0},I=(0,P.fork)(l,[`--type=extension-post-${d}`,...y],b);I.stdout.setEncoding("utf8"),I.stderr.setEncoding("utf8");const m=O.Event.fromNodeEventEmitter(I.stdout,"data"),s=O.Event.fromNodeEventEmitter(I.stderr,"data");this.B(m(a=>this.f.info(f.identifier.id,f.manifest.version,`post-${d}`,a))),this.B(s(a=>this.f.error(f.identifier.id,f.manifest.version,`post-${d}`,a)));const r=O.Event.any(O.Event.map(m,a=>({data:`%c${a}`,format:[""]}),this.q),O.Event.map(s,a=>({data:`%c${a}`,format:["color: red"]}),this.q));return O.Event.debounce(r,(a,t)=>a?{data:a.data+t.data,format:[...a.format,...t.format]}:{data:t.data,format:t.format},100,void 0,void 0,void 0,this.q)(a=>{console.group(f.identifier.id),console.log(a.data,...a.format),console.groupEnd()}),I}m(l){return(0,A.$lc)(this.b.defaultProfile.globalStorageHome.fsPath,l.identifier.id.toLowerCase())}};e.$Oq=u,e.$Oq=u=ve([Y(0,$.$Ll),Y(1,E.$_j)],u)}),define(ce[117],le([0,1,72,167,84,28]),function(ne,e,P,c,N,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lq=T,e.$Mq=k;function T(A){let w=O.ExtensionManagementErrorCode.Extract;return A instanceof P.$uq&&(A.type==="CorruptZip"?w=O.ExtensionManagementErrorCode.CorruptZip:A.type==="Incomplete"&&(w=O.ExtensionManagementErrorCode.IncompleteZip)),(0,N.$zq)(A,w)}async function k(A){let w;try{w=await(0,P.$xq)(A,"extension/package.json")}catch(E){throw T(E)}try{return JSON.parse(w.toString("utf8"))}catch{throw new O.$ip((0,c.localize)(0,null),O.ExtensionManagementErrorCode.Invalid)}}}),define(ce[252],le([0,1,6,8,2,23,21,57,13,32,31,72,22,16,84,28,33,117,111,7,10,18]),function(ne,e,P,c,N,O,T,k,A,w,E,$,u,p,l,d,y,f,b,I,m,s){"use strict";var r;Object.defineProperty(e,"__esModule",{value:!0}),e.$Nq=void 0,k=Oe(k);let i=class extends N.$Wc{static{r=this}static{this.c=".sigzip"}constructor(t,n,o,h,g,R,L){super(),this.h=n,this.j=o,this.m=h,this.n=g,this.r=R,this.t=L,this.extensionsDownloadDir=t.extensionsDownloadLocation,this.f=20,this.g=this.F()}async download(t,n,o,h){await this.g;const g=await this.w(t,n);let R=!1;if(o&&this.u(t)){let L;try{L=await this.y(t)}catch(S){try{await this.delete(g)}catch(v){this.t.error(v)}throw S}try{R=await this.n.verify(t,g.fsPath,L.fsPath,h)}catch(S){if(R=S.code,R===b.ExtensionSignatureVerificationCode.PackageIsInvalidZip||R===b.ExtensionSignatureVerificationCode.SignatureArchiveIsInvalidZip){try{await this.delete(g)}catch(v){this.t.error(v)}throw new d.$ip($.$tq,d.ExtensionManagementErrorCode.CorruptZip)}}finally{try{await this.delete(L)}catch(S){this.t.error(S)}}}return{location:g,verificationStatus:R}}u(t){if(!t.isSigned)return this.t.info(`Extension is not signed: ${t.identifier.id}`),!1;const n=this.m.getValue("extensions.verifySignature");return(0,A.$lg)(n)?n:!0}async w(t,n){try{const o=(0,T.$gh)(this.extensionsDownloadDir,this.G(t)),h=await this.C(t,"vsix",async()=>{await this.z(t,o,g=>this.j.download(t,g,n));try{await this.D(o.fsPath,"extension/package.json")}catch(g){try{await this.h.del(o)}catch(R){this.t.warn(`Error while deleting: ${o.path}`,(0,c.$_)(R))}throw g}},2);return h>1&&this.r.publicLog2("extensiongallery:downloadvsix:retry",{extensionId:t.identifier.id,attempts:h}),o}catch(o){throw(0,l.$zq)(o,d.ExtensionManagementErrorCode.Download)}}async y(t){try{const n=(0,T.$gh)(this.extensionsDownloadDir,`.${(0,w.$2g)()}`),o=await this.C(t,"sigzip",async()=>{await this.j.downloadSignatureArchive(t,n);try{await this.D(n.fsPath,".signature.p7s")}catch(h){try{await this.h.del(n)}catch(g){this.t.warn(`Error while deleting: ${n.path}`,(0,c.$_)(g))}throw h}},2);return o>1&&this.r.publicLog2("extensiongallery:downloadsigzip:retry",{extensionId:t.identifier.id,attempts:o}),n}catch(n){throw(0,l.$zq)(n,d.ExtensionManagementErrorCode.DownloadSignature)}}async z(t,n,o){if(await this.h.exists(n))return;if(n.scheme!==O.Schemas.file){await o(n);return}const h=(0,T.$gh)(this.extensionsDownloadDir,`.${(0,w.$2g)()}`);try{await o(h)}catch(g){try{await this.h.del(h)}catch{}throw g}try{await E.Promises.rename(h.fsPath,n.fsPath,2*60*1e3)}catch(g){try{await this.h.del(h)}catch{}let R=!1;try{R=await this.h.exists(n)}catch{}if(R)this.t.info("Rename failed because the file was downloaded by another source. So ignoring renaming.",t.identifier.id,n.path);else throw this.t.info(`Rename failed because of ${(0,c.$_)(g)}. Deleted the file from downloaded location`,h.path),g}}async C(t,n,o,h){let g=1;for(;;)try{return await o(),g}catch(R){if(g++>h)throw R;this.t.warn(`Failed downloading ${n}. ${(0,c.$_)(R)}. Retry again...`,t.identifier.id)}}async D(t,n){try{await(0,$.$xq)(t,n)}catch(o){throw(0,f.$Lq)(o)}}async delete(t){await this.g,await this.h.del(t)}async F(){try{if(!await this.h.exists(this.extensionsDownloadDir)){this.t.trace("Extension VSIX downloads cache dir does not exist");return}const t=await this.h.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(t.children){const n=[],o=[],h=[];for(const L of t.children)if(L.name.endsWith(r.c))h.push(L.resource);else{const S=y.$Ip.parse(L.name);S&&o.push([S,L])}const g=(0,y.$Np)(o,([L])=>L),R=[];for(const L of g)L.sort((S,v)=>k.rcompare(S[0].version,v[0].version)),n.push(...L.slice(1).map(S=>S[1].resource)),R.push(L[0][1]);R.sort((L,S)=>L.mtime-S.mtime),n.push(...R.slice(0,Math.max(0,R.length-this.f)).map(L=>L.resource)),n.push(...h),await P.Promises.settled(n.map(L=>(this.t.trace("Deleting from cache",L.path),this.h.del(L))))}}catch(t){this.t.error(t)}}G(t){return this.f?y.$Ip.create(t).toString().toLowerCase():(0,w.$2g)()}};e.$Nq=i,e.$Nq=i=r=ve([Y(0,p.$Ni),Y(1,I.$_k),Y(2,d.$gp),Y(3,u.$_i),Y(4,b.$mq),Y(5,s.$$l),Y(6,m.$_j)],i)}),define(ce[118],le([0,1,6,15,26,41,8,3,56,2,35,23,14,21,57,13,9,32,31,72,166,99,16,84,28,33,53,85,252,251,117,224,234,37,73,7,4,10,24,18,29,20]),function(ne,e,P,c,N,O,T,k,A,w,E,$,u,p,l,d,y,f,b,I,m,s,r,i,a,t,n,o,h,g,R,L,S,v,C,F,D,M,J,H,x,K){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tq=e.$Sq=e.$Rq=void 0,u=Oe(u),l=Oe(l),b=Oe(b),m=Oe(m),e.$Rq=(0,D.$Gi)(a.$jp);const ie=".vsctmp";let V=class extends i.$yq{constructor(q,Z,X,G,U,B,j,W,te,_,Q,ae){super(q,Z,Q,X,_,ae),this.eb=U,this.fb=B,this.gb=j,this.hb=W,this.ib=te,this.db=new Map,this.tb=new E.$Dc;const ue=this.B(W.createInstance(g.$Oq));this.ab=this.B(W.createInstance(z,we=>ue.postUninstall(we))),this.bb=this.B(new L.$Pq(ae,te,Q,this,this.F)),this.cb=this.B(W.createInstance(h.$Nq));const ge=this.B(new S.$Qq(this,this.eb,ae,B,Q,te,X));this.B(ge.onDidChangeExtensionsByAnotherSource(we=>this.sb(we))),this.ub()}getTargetPlatform(){return this.jb||(this.jb=(0,t.$Sp)(this.ib,this.F)),this.jb}async zip(q){this.F.trace("ExtensionManagementService#zip",q.identifier.id);const Z=await this.rb(q),X=await(0,I.zip)((0,p.$gh)(this.cb.extensionsDownloadDir,(0,f.$2g)()).fsPath,Z);return y.URI.file(X)}async unzip(q){return this.F.trace("ExtensionManagementService#unzip",q.toString()),(await this.install(q)).identifier}async getManifest(q){const{location:Z,cleanup:X}=await this.lb(q),G=u.$mc(Z.fsPath);try{return await(0,R.$Mq)(G)}finally{await X()}}getInstalled(q,Z=this.H.defaultProfile.extensionsResource,X={version:this.G.version,date:this.G.date}){return this.ab.scanExtensions(q??null,Z,X)}scanAllUserInstalledExtensions(){return this.ab.scanAllUserExtensions(!1)}scanInstalledExtensionAtLocation(q){return this.ab.scanUserExtensionAtLocation(q)}async install(q,Z={}){this.F.trace("ExtensionManagementService#install",q.toString());const{location:X,cleanup:G}=await this.lb(q);try{const U=await(0,R.$Mq)(u.$mc(X.fsPath)),B=(0,t.$Mp)(U.publisher,U.name);if(U.engines&&U.engines.vscode&&!(0,C.$Zp)(U.engines.vscode,this.G.version,this.G.date))throw new Error(m.localize(0,null,B,this.G.version));const W=(await this.I([{manifest:U,extension:X,options:Z}])).find(({identifier:te})=>(0,t.$Hp)(te,{id:B}));if(W?.local)return W.local;throw W?.error?W.error:(0,i.$zq)(new Error(`Unknown error while installing extension ${B}`))}finally{await G()}}async installFromLocation(q,Z){this.F.trace("ExtensionManagementService#installFromLocation",q.toString());const X=await this.ab.scanUserExtensionAtLocation(q);if(!X||!X.manifest.name||!X.manifest.version)throw new Error(`Cannot find a valid extension from the location ${q.toString()}`);return await this.wb([[X,{source:"resource"}]],Z),this.F.info("Successfully installed extension",X.identifier.id,Z.toString()),X}async installExtensionsFromProfile(q,Z,X){this.F.trace("ExtensionManagementService#installExtensionsFromProfile",q,Z.toString(),X.toString());const G=(await this.getInstalled(v.ExtensionType.User,Z)).filter(U=>q.some(B=>(0,t.$Hp)(B,U.identifier)));if(G.length){const U=await Promise.all(G.map(B=>this.ab.scanMetadata(B,Z)));await this.wb(G.map((B,j)=>[B,U[j]]),X),this.F.info("Successfully installed extensions",G.map(B=>B.identifier.id),X.toString())}return G}async updateMetadata(q,Z,X){return this.F.trace("ExtensionManagementService#updateMetadata",q.identifier.id),Z.isPreReleaseVersion&&(Z.preRelease=!0,Z.hasPreReleaseVersion=!0),Z.isMachineScoped===!1&&(Z.isMachineScoped=void 0),Z.isBuiltin===!1&&(Z.isBuiltin=void 0),Z.pinned===!1&&(Z.pinned=void 0),q=await this.ab.updateMetadata(q,Z,X),this.bb.invalidate(X),this.w.fire({local:q,profileLocation:X}),q}async reinstallFromGallery(q){if(this.F.trace("ExtensionManagementService#reinstallFromGallery",q.identifier.id),!this.z.isEnabled())throw new Error(m.localize(1,null));const Z=await this.getTargetPlatform(),[X]=await this.z.getExtensions([{...q.identifier,preRelease:q.preRelease}],{targetPlatform:Z,compatible:!0},N.CancellationToken.None);if(!X)throw new Error(m.localize(2,null));await this.ab.setUninstalled(q);try{await this.ab.removeUninstalledExtension(q)}catch(G){throw new Error(m.localize(3,null,(0,O.$qj)(G)))}return this.installFromGallery(X)}$(q,Z,X,G){return this.ab.copyExtension(q,Z,X,G)}copyExtensions(q,Z){return this.ab.copyExtensions(q,Z,{version:this.G.version,date:this.G.date})}markAsUninstalled(...q){return this.ab.setUninstalled(...q)}async cleanUp(){this.F.trace("ExtensionManagementService#cleanUp");try{await this.ab.cleanUp()}catch(q){this.F.error(q)}}async download(q,Z,X){const{location:G}=await this.cb.download(q,Z,!X);return G}async lb(q){if(q.scheme===$.Schemas.file)return{location:q,async cleanup(){}};this.F.trace("Downloading extension from",q.toString());const Z=(0,p.$gh)(this.cb.extensionsDownloadDir,(0,f.$2g)());return await this.gb.download(q,Z),this.F.info("Downloaded extension to",Z.toString()),{location:Z,cleanup:async()=>{try{await this.ib.del(Z)}catch(G){this.F.error(G)}}}}X(){return this.H.defaultProfile.extensionsResource}Y(q,Z,X){const G=Z instanceof y.URI?new t.$Ip({id:(0,t.$Mp)(q.publisher,q.name)},q.version):t.$Ip.create(Z);return this.hb.createInstance(ee,G,q,Z,X,(U,B)=>{if(Z instanceof y.URI)return this.qb(G,Z,X,B);let j=this.db.get(G.toString());return j||(this.db.set(G.toString(),j=this.pb(G,Z,U,X,B)),j.finally(()=>this.db.delete(G.toString()))),j},this.ab)}Z(q,Z){return new se(q,Z.profileLocation,this.fb)}async pb(q,Z,X,G,U){const{verificationStatus:B,location:j}=await this.cb.download(Z,X,!G.donotVerifySignature,G.context?.[a.$_o]);try{if(U.isCancellationRequested)throw new T.$7;return await(0,R.$Mq)(j.fsPath),{local:await this.ab.extractUserExtension(q,j.fsPath,{id:Z.identifier.uuid,publisherId:Z.publisherId,publisherDisplayName:Z.publisherDisplayName,targetPlatform:Z.properties.targetPlatform,isApplicationScoped:G.isApplicationScoped,isMachineScoped:G.isMachineScoped,isBuiltin:G.isBuiltin,isPreReleaseVersion:Z.properties.isPreReleaseVersion,hasPreReleaseVersion:Z.properties.isPreReleaseVersion,installedTimestamp:Date.now(),pinned:G.installGivenVersion?!0:!!G.pinned,preRelease:(0,d.$lg)(G.preRelease)?G.preRelease:G.installPreReleaseVersion||Z.properties.isPreReleaseVersion,source:"gallery"},!1,U),verificationStatus:B}}catch(W){try{await this.cb.delete(j)}catch(te){this.F.warn("Error while deleting the downloaded file",j.toString(),(0,T.$_)(te))}throw(0,i.$zq)(W)}}async qb(q,Z,X,G){return{local:await this.ab.extractUserExtension(q,u.$mc(Z.fsPath),{isApplicationScoped:X.isApplicationScoped,isMachineScoped:X.isMachineScoped,isBuiltin:X.isBuiltin,installedTimestamp:Date.now(),pinned:X.installGivenVersion?!0:!!X.pinned,source:"vsix"},!0,G)}}async rb(q){const Z=async G=>{let U=await b.Promises.readdir(G);U=U.map(W=>u.$lc(G,W));const B=await Promise.all(U.map(W=>b.Promises.stat(W)));let j=Promise.resolve([]);return B.forEach((W,te)=>{const _=U[te];W.isFile()&&(j=j.then(Q=>[...Q,_])),W.isDirectory()&&(j=j.then(Q=>Z(_).then(ae=>[...Q,...ae])))}),j};return(await Z(q.location.fsPath)).map(G=>({path:`extension/${u.$nc(q.location.fsPath,G)}`,localPath:G}))}async sb({added:q,removed:Z}){if(Z){const X=q&&this.D.extUri.isEqual(Z.profileLocation,q.profileLocation)?Z.extensions.filter(G=>q.extensions.every(U=>!(0,t.$Hp)(U,G))):Z.extensions;for(const G of X)this.F.info("Extensions removed from another source",G.id,Z.profileLocation.toString()),this.u.fire({identifier:G,profileLocation:Z.profileLocation})}if(q){const G=(await this.getInstalled(v.ExtensionType.User,q.profileLocation)).filter(U=>q.extensions.some(B=>(0,t.$Hp)(B,U.identifier)));this.s.fire(G.map(U=>(this.F.info("Extensions added from another source",U.identifier.id,q.profileLocation.toString()),{identifier:U.identifier,local:U,profileLocation:q.profileLocation,operation:a.InstallOperation.None})))}}async ub(){this.B(this.ab.onExtract(Z=>this.tb.add(Z)));const q=await this.ib.resolve(this.eb.userExtensionsLocation);for(const Z of q.children??[])Z.isDirectory&&this.tb.add(Z.resource);this.B(this.ib.watch(this.eb.userExtensionsLocation)),this.B(this.ib.onDidFilesChange(Z=>this.vb(Z)))}async vb(q){if(!q.affects(this.eb.userExtensionsLocation,F.FileChangeType.ADDED))return;const Z=[];for(const X of q.rawAdded){if(this.tb.has(X)||!this.D.extUri.isEqual(this.D.extUri.dirname(X),this.eb.userExtensionsLocation)||this.D.extUri.isEqual(X,this.D.extUri.joinPath(this.eb.userExtensionsLocation,".obsolete"))||this.D.extUri.basename(X).startsWith(".")||!(await this.ib.stat(X)).isDirectory)continue;const G=await this.ab.scanUserExtensionAtLocation(X);G&&G.installedTimestamp===void 0&&(this.tb.add(X),Z.push(G))}Z.length&&(await this.wb(Z.map(X=>[X,void 0]),this.H.defaultProfile.extensionsResource),this.F.info("Added extensions to default profile from external source",Z.map(X=>X.identifier.id)))}async wb(q,Z){const X=q.map(G=>G[0]);await this.xb(X),await this.fb.addExtensionsToProfile(q,Z),this.s.fire(X.map(G=>({local:G,identifier:G.identifier,operation:a.InstallOperation.None,profileLocation:Z})))}async xb(q){const Z=await this.ab.getUninstalledExtensions();for(const X of q){const G=t.$Ip.create(X);Z[G.toString()]&&(this.F.trace("Removing the extension from uninstalled list:",G.id),await this.ab.setInstalled(G),this.F.info("Removed the extension from uninstalled list:",G.id))}}};e.$Sq=V,e.$Sq=V=ve([Y(0,a.$gp),Y(1,H.$$l),Y(2,M.$_j),Y(3,r.$Ni),Y(4,o.$Gq),Y(5,n.$Cq),Y(6,s.$Wo),Y(7,D.$Ei),Y(8,F.$_k),Y(9,J.$sk),Y(10,x.$Jl),Y(11,K.$Ll)],V);let z=class extends w.$Wc{constructor(q,Z,X,G,U,B,j){super(),this.n=q,this.s=Z,this.t=X,this.u=G,this.w=U,this.y=B,this.z=j,this.h=this.B(new k.$me),this.onExtract=this.h.event,this.j=new E.$Cc,this.m=new E.$Cc,this.c=(0,p.$gh)(this.t.userExtensionsLocation,".obsolete"),this.g=new P.$Mh}async cleanUp(){await this.J(),await this.I()}async scanExtensions(q,Z,X){try{const G={includeInvalid:!0,profileLocation:Z,productVersion:X};let U=[];if(q===null||q===v.ExtensionType.System){let B=this.j.get(Z);B||(B=this.t.scanAllExtensions({includeInvalid:!0,useCache:!0},G,!1).finally(()=>this.j.delete(Z)),this.j.set(Z,B)),U.push(...await B)}else if(q===v.ExtensionType.User){let B=this.m.get(Z);B||(B=this.t.scanUserExtensions(G).finally(()=>this.m.delete(Z)),this.m.set(Z,B)),U.push(...await B)}return U=q!==null?U.filter(B=>B.type===q):U,await Promise.all(U.map(B=>this.H(B)))}catch(G){throw(0,i.$zq)(G,a.ExtensionManagementErrorCode.Scanning)}}async scanAllUserExtensions(q){try{const Z=await this.t.scanUserExtensions({includeAllVersions:!q,includeInvalid:!0});return await Promise.all(Z.map(X=>this.H(X)))}catch(Z){throw(0,i.$zq)(Z,a.ExtensionManagementErrorCode.Scanning)}}async scanUserExtensionAtLocation(q){try{const Z=await this.t.scanExistingExtension(q,v.ExtensionType.User,{includeInvalid:!0});if(Z)return await this.H(Z)}catch(Z){this.z.error(Z)}return null}async extractUserExtension(q,Z,X,G,U){const B=q.toString(),j=y.URI.file(u.$lc(this.t.userExtensionsLocation.fsPath,`.${(0,f.$2g)()}`)),W=y.URI.file(u.$lc(this.t.userExtensionsLocation.fsPath,B));let te=await this.s.exists(W);if(te&&G){try{await this.D(q.id,W,"removeExisting")}catch{throw new a.$ip(m.localize(4,null,W.fsPath,q.id),a.ExtensionManagementErrorCode.Delete)}te=!1}if(te)try{await this.t.updateMetadata(W,X)}catch(_){throw this.y.publicLog2("extension:extract",{extensionId:q.id,code:_.code}),(0,i.$zq)(_,a.ExtensionManagementErrorCode.UpdateExistingMetadata)}else try{if(U.isCancellationRequested)throw new T.$7;try{this.z.trace(`Started extracting the extension from ${Z} to ${W.fsPath}`),await(0,I.$wq)(Z,j.fsPath,{sourcePath:"extension",overwrite:!0},U),this.z.info(`Extracted extension to ${W}:`,q.id)}catch(_){throw(0,R.$Lq)(_)}try{await this.t.updateMetadata(j,X)}catch(_){throw this.y.publicLog2("extension:extract",{extensionId:q.id,code:_.code}),(0,i.$zq)(_,a.ExtensionManagementErrorCode.UpdateMetadata)}if(U.isCancellationRequested)throw new T.$7;try{this.z.trace(`Started renaming the extension from ${j.fsPath} to ${W.fsPath}`),await this.G(j.fsPath,W.fsPath),this.z.info("Renamed to",W.fsPath)}catch(_){if(_.code==="ENOTEMPTY"){this.z.info("Rename failed because extension was installed by another source. So ignoring renaming.",q.id);try{await this.s.del(j,{recursive:!0})}catch{}}else throw this.z.info(`Rename failed because of ${(0,T.$_)(_)}. Deleted from extracted location`,j),_}this.h.fire(W)}catch(_){try{await this.s.del(j,{recursive:!0})}catch{}throw _}return this.scanLocalExtension(W,v.ExtensionType.User)}async scanMetadata(q,Z){return Z?(await this.C(q,Z))?.metadata:this.t.scanMetadata(q.location)}async C(q,Z){return(await this.u.scanProfileExtensions(Z)).find(G=>(0,t.$Hp)(G.identifier,q.identifier))}async updateMetadata(q,Z,X){try{X?await this.u.updateMetadata([[q,Z]],X):await this.t.updateMetadata(q.location,Z)}catch(G){throw this.y.publicLog2("extension:extract",{extensionId:q.identifier.id,code:G.code}),(0,i.$zq)(G,a.ExtensionManagementErrorCode.UpdateMetadata)}return this.scanLocalExtension(q.location,q.type,X)}async getUninstalledExtensions(){try{return await this.F()}catch(q){throw(0,i.$zq)(q,a.ExtensionManagementErrorCode.ReadUninstalled)}}async setUninstalled(...q){const Z=q.map(X=>t.$Ip.create(X));await this.F(X=>Z.forEach(G=>{X[G.toString()]=!0,this.z.info("Marked extension as uninstalled",G.toString())}))}async setInstalled(q){try{await this.F(Z=>delete Z[q.toString()])}catch(Z){throw(0,i.$zq)(Z,a.ExtensionManagementErrorCode.UnsetUninstalled)}}async removeExtension(q,Z){if(this.w.extUri.isEqualOrParent(q.location,this.t.userExtensionsLocation))return this.D(q.identifier.id,q.location,Z)}async removeUninstalledExtension(q){await this.removeExtension(q,"uninstalled"),await this.F(Z=>delete Z[t.$Ip.create(q).toString()])}async copyExtension(q,Z,X,G){const U=await this.C(q,Z),B=await this.C(q,X);if(G={...U?.metadata,...G},B)if(this.w.extUri.isEqual(B.location,q.location))await this.u.updateMetadata([[q,{...B.metadata,...G}]],X);else{const j=await this.scanLocalExtension(B.location,q.type,X);await this.u.removeExtensionFromProfile(j,X),await this.u.addExtensionsToProfile([[q,{...B.metadata,...G}]],X)}else await this.u.addExtensionsToProfile([[q,G]],X);return this.scanLocalExtension(q.location,q.type,X)}async copyExtensions(q,Z,X){const G=await this.scanExtensions(v.ExtensionType.User,q,X),U=await Promise.all(G.filter(B=>!B.isApplicationScoped).map(async B=>[B,await this.scanMetadata(B,q)]));await this.u.addExtensionsToProfile(U,Z)}async D(q,Z,X){this.z.trace(`Deleting ${X} extension from disk`,q,Z.fsPath);const G=this.w.extUri.joinPath(this.w.extUri.dirname(Z),`${this.w.extUri.basename(Z)}.${(0,A.$tj)((0,f.$2g)()).toString(16)}${ie}`);await this.G(Z.fsPath,G.fsPath),await this.s.del(G,{recursive:!0}),this.z.info(`Deleted ${X} extension from disk`,q,Z.fsPath)}F(q){return this.g.queue(async()=>{let Z;try{Z=(await this.s.readFile(this.c,"utf8")).value.toString()}catch(G){if((0,F.$ql)(G)!==F.FileOperationResult.FILE_NOT_FOUND)throw G}let X={};if(Z)try{X=JSON.parse(Z)}catch{}return q&&(q(X),Object.keys(X).length?await this.s.writeFile(this.c,c.$Oe.fromString(JSON.stringify(X))):await this.s.del(this.c)),X})}async G(q,Z){try{await b.Promises.rename(q,Z,2*60*1e3)}catch(X){throw(0,i.$zq)(X,a.ExtensionManagementErrorCode.Rename)}}async scanLocalExtension(q,Z,X){try{if(X){const U=(await this.t.scanUserExtensions({profileLocation:X})).find(B=>this.w.extUri.isEqual(B.location,q));if(U)return await this.H(U)}else{const G=await this.t.scanExistingExtension(q,Z,{includeInvalid:!0});if(G)return await this.H(G)}throw new a.$ip(m.localize(5,null,q.path),a.ExtensionManagementErrorCode.ScanningExtension)}catch(G){throw(0,i.$zq)(G,a.ExtensionManagementErrorCode.ScanningExtension)}}async H(q){const Z=await this.s.resolve(q.location);let X,G;return Z.children&&(X=Z.children.find(({name:U})=>/^readme(\.txt|\.md|)$/i.test(U))?.resource,G=Z.children.find(({name:U})=>/^changelog(\.txt|\.md|)$/i.test(U))?.resource),{identifier:q.identifier,type:q.type,isBuiltin:q.isBuiltin||!!q.metadata?.isBuiltin,location:q.location,manifest:q.manifest,targetPlatform:q.targetPlatform,validations:q.validations,isValid:q.isValid,readmeUrl:X,changelogUrl:G,publisherDisplayName:q.metadata?.publisherDisplayName,publisherId:q.metadata?.publisherId||null,isApplicationScoped:!!q.metadata?.isApplicationScoped,isMachineScoped:!!q.metadata?.isMachineScoped,isPreReleaseVersion:!!q.metadata?.isPreReleaseVersion,hasPreReleaseVersion:!!q.metadata?.hasPreReleaseVersion,preRelease:!!q.metadata?.preRelease,installedTimestamp:q.metadata?.installedTimestamp,updated:!!q.metadata?.updated,pinned:!!q.metadata?.pinned,isWorkspaceScoped:!1,source:q.metadata?.source??(q.identifier.uuid?"gallery":"vsix")}}async I(){const q=await this.getUninstalledExtensions();if(Object.keys(q).length===0){this.z.debug("No uninstalled extensions found.");return}this.z.debug("Removing uninstalled extensions:",Object.keys(q));const Z=await this.t.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),X=new Set;for(const U of Z)q[t.$Ip.create(U).toString()]||X.add(U.identifier.id.toLowerCase());try{const U=(0,t.$Np)(Z,B=>B.identifier);await P.Promises.settled(U.map(async B=>{const j=B.sort((W,te)=>l.rcompare(W.manifest.version,te.manifest.version))[0];X.has(j.identifier.id.toLowerCase())||await this.n(await this.H(j))}))}catch(U){this.z.error(U)}const G=Z.filter(U=>U.metadata&&q[t.$Ip.create(U).toString()]);await Promise.allSettled(G.map(U=>this.removeUninstalledExtension(U)))}async J(){this.z.trace("ExtensionManagementService#removeTempDeleteFolders");let q;try{q=await this.s.resolve(this.t.userExtensionsLocation)}catch(Z){(0,F.$ql)(Z)!==F.FileOperationResult.FILE_NOT_FOUND&&this.z.error(Z);return}if(q?.children)try{await Promise.allSettled(q.children.map(async Z=>{if(!(!Z.isDirectory||!Z.name.endsWith(ie))){this.z.trace("Deleting the temporarily deleted folder",Z.resource.toString());try{await this.s.del(Z.resource,{recursive:!0}),this.z.trace("Deleted the temporarily deleted folder",Z.resource.toString())}catch(X){(0,F.$ql)(X)!==F.FileOperationResult.FILE_NOT_FOUND&&this.z.error(X)}}}))}catch{}}};e.$Tq=z,e.$Tq=z=ve([Y(1,F.$_k),Y(2,o.$Gq),Y(3,n.$Cq),Y(4,x.$Jl),Y(5,H.$$l),Y(6,M.$_j)],z);let ee=class extends i.$Aq{get operation(){return this.options.operation??this.j}get verificationStatus(){return this.k}constructor(q,Z,X,G,U,B,j,W,te,_,Q,ae){super(),this.l=q,this.manifest=Z,this.source=X,this.options=G,this.m=U,this.n=B,this.o=j,this.p=W,this.q=te,this.s=_,this.t=Q,this.u=ae,this.j=a.InstallOperation.Install,this.identifier=this.l.identifier}async h(q){const X=(await this.n.scanExtensions(v.ExtensionType.User,this.options.profileLocation,this.options.productVersion)).find(j=>(0,t.$Hp)(j.identifier,this.identifier));X&&(this.j=a.InstallOperation.Update);const G={isApplicationScoped:this.options.isApplicationScoped||X?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||X?.isMachineScoped,isBuiltin:this.options.isBuiltin||X?.isBuiltin,isSystem:X?.type===v.ExtensionType.System?!0:void 0,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:this.options.pinned??X?.pinned,source:this.source instanceof y.URI?"vsix":"gallery"};let U;if(this.source instanceof y.URI)if(X){if(this.l.equals(new t.$Ip(X.identifier,X.manifest.version)))try{await this.n.removeExtension(X,"existing")}catch{throw new Error(m.localize(6,null,this.manifest.displayName||this.manifest.name))}}else{const j=await this.w(this.l);if(j)try{await this.n.removeExtension(j,"existing")}catch{throw new Error(m.localize(7,null,this.manifest.displayName||this.manifest.name))}}else{if(G.id=this.source.identifier.uuid,G.publisherId=this.source.publisherId,G.publisherDisplayName=this.source.publisherDisplayName,G.targetPlatform=this.source.properties.targetPlatform,G.updated=!!X,G.isPreReleaseVersion=this.source.properties.isPreReleaseVersion,G.hasPreReleaseVersion=X?.hasPreReleaseVersion||this.source.properties.isPreReleaseVersion,G.preRelease=(0,d.$lg)(this.options.preRelease)?this.options.preRelease:this.options.installPreReleaseVersion||this.source.properties.isPreReleaseVersion||X?.preRelease,X&&X.type!==v.ExtensionType.System&&X.manifest.version===this.source.version)return this.n.updateMetadata(X,G,this.options.profileLocation);U=await this.w(this.l)}if(q.isCancellationRequested)throw(0,i.$zq)(new T.$7);if(!U){const j=await this.m(this.operation,q);U=j.local,this.k=j.verificationStatus}if(this.o.extUri.isEqual(this.q.defaultProfile.extensionsResource,this.options.profileLocation))try{await this.s.initializeDefaultProfileExtensions()}catch(j){throw(0,i.$zq)(j,a.ExtensionManagementErrorCode.IntializeDefaultProfile)}if(q.isCancellationRequested)throw(0,i.$zq)(new T.$7);try{await this.t.addExtensionsToProfile([[U,G]],this.options.profileLocation,!U.isValid)}catch(j){throw(0,i.$zq)(j,a.ExtensionManagementErrorCode.AddToProfile)}const B=await this.n.scanLocalExtension(U.location,v.ExtensionType.User,this.options.profileLocation);if(!B)throw new a.$ip("Cannot find the installed extension",a.ExtensionManagementErrorCode.InstalledExtensionNotFound);return this.source instanceof y.URI&&this.x(U,q),B}async w(q){return(await this.n.getUninstalledExtensions())[q.toString()]?(this.u.trace("Removing the extension from uninstalled list:",q.id),await this.n.setInstalled(q),this.u.info("Removed the extension from uninstalled list:",q.id),(await this.n.scanAllUserExtensions(!0)).find(G=>t.$Ip.create(G).equals(q))):void 0}async x(q,Z){try{let[X]=await this.p.getExtensions([{id:q.identifier.id,version:q.manifest.version}],Z);if(X||([X]=await this.p.getExtensions([{id:q.identifier.id}],Z)),X){const G={id:X.identifier.uuid,publisherDisplayName:X.publisherDisplayName,publisherId:X.publisherId,isPreReleaseVersion:X.properties.isPreReleaseVersion,hasPreReleaseVersion:q.hasPreReleaseVersion||X.properties.isPreReleaseVersion,preRelease:X.properties.isPreReleaseVersion||this.options.installPreReleaseVersion};await this.n.updateMetadata(q,G,this.options.profileLocation)}}catch{}}};ee=ve([Y(6,x.$Jl),Y(7,a.$gp),Y(8,K.$Ll),Y(9,o.$Gq),Y(10,n.$Cq),Y(11,M.$_j)],ee);class se extends i.$Aq{constructor(q,Z,X){super(),this.extension=q,this.j=Z,this.k=X}async h(q){await this.k.removeExtensionFromProfile(this.extension,this.j)}}}),define(ce[253],le([0,1,10,20,29,18,53,7,16,9]),function(ne,e,P,c,N,O,T,k,A,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kR=void 0;let E=class extends T.$Dq{constructor(u,p,l,d,y,f){super(w.URI.file(u.extensionsPath),p,l,d,y,f)}};e.$kR=E,e.$kR=E=ve([Y(0,A.$Ni),Y(1,k.$_k),Y(2,c.$Ll),Y(3,N.$Jl),Y(4,O.$$l),Y(5,P.$_j)],E)}),define(ce[254],le([0,1,9,16,53,85,7,4,10,24,29,20]),function(ne,e,P,c,N,O,T,k,A,w,E,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3fc=void 0;let u=class extends O.$Kq{constructor(l,d,y,f,b,I,m,s){super(P.URI.file(b.builtinExtensionsPath),P.URI.file(b.extensionsPath),b.userHome,l.defaultProfile,l,d,y,f,b,I,m,s)}};e.$3fc=u,e.$3fc=u=ve([Y(0,$.$Ll),Y(1,N.$Cq),Y(2,T.$_k),Y(3,A.$_j),Y(4,c.$Ni),Y(5,w.$sk),Y(6,E.$Jl),Y(7,k.$Ei)],u)}),define(ce[17],le([0,1,6,3,2,101,13,71,4,20]),function(ne,e,P,c,N,O,T,k,A,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fq=e.$dq=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$bq=e.$aq=e.$_p=void 0,e.$cq=p,e.$eq=d,e.$gq=f,e.$_p="__$__isNewStorageMarker",e.$aq="__$__targetStorageMarker",e.$bq=(0,A.$Fi)("storageService");var E;(function(b){b[b.NONE=0]="NONE",b[b.SHUTDOWN=1]="SHUTDOWN"})(E||(e.WillSaveStateReason=E={}));var $;(function(b){b[b.APPLICATION=-1]="APPLICATION",b[b.PROFILE=0]="PROFILE",b[b.WORKSPACE=1]="WORKSPACE"})($||(e.StorageScope=$={}));var u;(function(b){b[b.USER=0]="USER",b[b.MACHINE=1]="MACHINE"})(u||(e.StorageTarget=u={}));function p(b){const I=b.get(e.$aq);if(I)try{return JSON.parse(I)}catch{}return Object.create(null)}class l extends N.$Wc{static{this.a=60*1e3}constructor(I={flushInterval:l.a}){super(),this.m=I,this.b=this.B(new c.$pe),this.c=this.B(new c.$pe),this.onDidChangeTarget=this.c.event,this.f=this.B(new c.$me),this.onWillSaveState=this.f.event,this.h=this.B(new P.$Rh(()=>this.n(),this.m.flushInterval)),this.j=this.B(new N.$Xc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(I,m,s){return c.Event.filter(this.b.event,r=>r.scope===I&&(m===void 0||r.key===m),s)}n(){this.j.value=(0,P.$Vh)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,N.$Rc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,O.mark)("code/willInitStorage");try{await this.O()}finally{(0,O.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(I,m){const{key:s,external:r}=m;if(s===e.$aq){switch(I){case $.APPLICATION:this.H=void 0;break;case $.PROFILE:this.F=void 0;break;case $.WORKSPACE:this.C=void 0;break}this.c.fire({scope:I})}else this.b.fire({scope:I,key:s,target:this.J(I)[s],external:r})}w(I){this.f.fire({reason:I})}get(I,m,s){return this.P(m)?.get(I,s)}getBoolean(I,m,s){return this.P(m)?.getBoolean(I,s)}getNumber(I,m,s){return this.P(m)?.getNumber(I,s)}getObject(I,m,s){return this.P(m)?.getObject(I,s)}storeAll(I,m){this.y(()=>{for(const s of I)this.store(s.key,s.value,s.scope,s.target,m)})}store(I,m,s,r,i=!1){if((0,T.$og)(m)){this.remove(I,s,i);return}this.y(()=>{this.z(I,s,r),this.P(s)?.set(I,m,i)})}remove(I,m,s=!1){this.y(()=>{this.z(I,m,void 0),this.P(m)?.delete(I,s)})}y(I){this.b.pause(),this.c.pause();try{I()}finally{this.b.resume(),this.c.resume()}}keys(I,m){const s=[],r=this.J(I);for(const i of Object.keys(r))r[i]===m&&s.push(i);return s}z(I,m,s,r=!1){const i=this.J(m);typeof s=="number"?i[I]!==s&&(i[I]=s,this.P(m)?.set(e.$aq,JSON.stringify(i),r)):typeof i[I]=="number"&&(delete i[I],this.P(m)?.set(e.$aq,JSON.stringify(i),r))}get D(){return this.C||(this.C=this.L($.WORKSPACE)),this.C}get G(){return this.F||(this.F=this.L($.PROFILE)),this.F}get I(){return this.H||(this.H=this.L($.APPLICATION)),this.H}J(I){switch(I){case $.APPLICATION:return this.I;case $.PROFILE:return this.G;default:return this.D}}L(I){const m=this.P(I);return m?p(m):Object.create(null)}isNew(I){return this.getBoolean(e.$_p,I)===!0}async flush(I=E.NONE){this.f.fire({reason:I});const m=this.P($.APPLICATION),s=this.P($.PROFILE),r=this.P($.WORKSPACE);switch(I){case E.NONE:await P.Promises.settled([m?.whenFlushed()??Promise.resolve(),s?.whenFlushed()??Promise.resolve(),r?.whenFlushed()??Promise.resolve()]);break;case E.SHUTDOWN:await P.Promises.settled([m?.flush(0)??Promise.resolve(),s?.flush(0)??Promise.resolve(),r?.flush(0)??Promise.resolve()]);break}}async log(){const I=this.P($.APPLICATION)?.items??new Map,m=this.P($.PROFILE)?.items??new Map,s=this.P($.WORKSPACE)?.items??new Map;return f(I,m,s,this.Q($.APPLICATION)??"",this.Q($.PROFILE)??"",this.Q($.WORKSPACE)??"")}async optimize(I){return await this.flush(),this.P(I)?.optimize()}async switch(I,m){return this.w(E.NONE),(0,w.$Kl)(I)?this.R(I,m):this.S(I,m)}M(I,m){return!(I.id===m.id||d(m)&&d(I))}N(I,m,s){this.y(()=>{const r=new Set;for(const[i,a]of I)r.add(i),m.get(i)!==a&&this.u(s,{key:i,external:!0});for(const[i]of m.items)r.has(i)||this.u(s,{key:i,external:!0})})}}e.$dq=l;function d(b){return b.isDefault||!!b.useDefaultFlags?.globalState}class y extends l{constructor(){super(),this.U=this.B(new k.$0p(new k.$$p,{hint:k.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new k.$0p(new k.$$p,{hint:k.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new k.$0p(new k.$$p,{hint:k.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(I=>this.u($.WORKSPACE,I))),this.B(this.W.onDidChangeStorage(I=>this.u($.PROFILE,I))),this.B(this.U.onDidChangeStorage(I=>this.u($.APPLICATION,I)))}P(I){switch(I){case $.APPLICATION:return this.U;case $.PROFILE:return this.W;default:return this.X}}Q(I){switch(I){case $.APPLICATION:return"inMemory (application)";case $.PROFILE:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(I){return!1}}e.$fq=y;async function f(b,I,m,s,r,i){const a=v=>{try{return JSON.parse(v)}catch{return v}},t=new Map,n=new Map;b.forEach((v,C)=>{t.set(C,v),n.set(C,a(v))});const o=new Map,h=new Map;I.forEach((v,C)=>{o.set(C,v),h.set(C,a(v))});const g=new Map,R=new Map;m.forEach((v,C)=>{g.set(C,v),R.set(C,a(v))}),console.group(s!==r?`Storage: Application (path: ${s})`:`Storage: Application & Profile (path: ${s}, default profile)`);const L=[];if(t.forEach((v,C)=>{L.push({key:C,value:v})}),console.table(L),console.groupEnd(),console.log(n),s!==r){console.group(`Storage: Profile (path: ${r}, profile specific)`);const v=[];o.forEach((C,F)=>{v.push({key:F,value:C})}),console.table(v),console.groupEnd(),console.log(h)}console.group(`Storage: Workspace (path: ${i})`);const S=[];g.forEach((v,C)=>{S.push({key:C,value:v})}),console.table(S),console.groupEnd(),console.log(R)}}),define(ce[119],le([0,1,3,2,13,28,33,17]),function(ne,e,P,c,N,O,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$VLb=e.$ULb=void 0;let A=class extends c.$Wc{constructor($,u){super(),this.a=new P.$me,this.onDidChangeEnablement=this.a.event,this.b=this.B(new w($)),this.B(this.b.onDidChange(p=>this.a.fire({extensions:p,source:"storage"}))),this.B(u.onDidInstallExtensions(p=>p.forEach(({local:l,operation:d})=>{l&&d===O.InstallOperation.Migrate&&this.f(l.identifier)})))}async enableExtension($,u){return this.f($)?(this.a.fire({extensions:[$],source:u}),!0):!1}async disableExtension($,u){return this.c($)?(this.a.fire({extensions:[$],source:u}),!0):!1}getDisabledExtensions(){return this.h(O.$kp)}async getDisabledExtensionsAsync(){return this.getDisabledExtensions()}c($){const u=this.getDisabledExtensions();return u.every(p=>!(0,T.$Hp)(p,$))?(u.push($),this.g(u),!0):!1}f($){const u=this.getDisabledExtensions();for(let p=0;p<u.length;p++){const l=u[p];if((0,T.$Hp)(l,$))return u.splice(p,1),this.g(u),!0}return!1}g($){this.j(O.$kp,$)}h($){return this.b.get($,k.StorageScope.PROFILE)}j($,u){this.b.set($,u,k.StorageScope.PROFILE)}};e.$ULb=A,e.$ULb=A=ve([Y(0,k.$bq),Y(1,O.$jp)],A);class w extends c.$Wc{constructor($){super(),this.c=$,this.a=Object.create(null),this.b=this.B(new P.$me),this.onDidChange=this.b.event,this.B($.onDidChangeValue(k.StorageScope.PROFILE,void 0,this.B(new c.$Vc))(u=>this.f(u)))}get($,u){let p;return u===k.StorageScope.PROFILE?((0,N.$og)(this.a[$])&&(this.a[$]=this.g($,u)),p=this.a[$]):p=this.g($,u),JSON.parse(p)}set($,u,p){const l=JSON.stringify(u.map(({id:y,uuid:f})=>({id:y,uuid:f})));this.g($,p)!==l&&(p===k.StorageScope.PROFILE&&(u.length?this.a[$]=l:delete this.a[$]),this.h($,u.length?l:void 0,p))}f($){if(!(0,N.$og)(this.a[$.key])&&this.g($.key,$.scope)!==this.a[$.key]){const p=this.get($.key,$.scope);delete this.a[$.key];const l=this.get($.key,$.scope),d=p.filter(f=>!l.some(b=>(0,T.$Hp)(f,b))),y=l.filter(f=>!p.some(b=>(0,T.$Hp)(b,f)));(d.length||y.length)&&this.b.fire([...d,...y])}}g($,u){return this.c.get($,u,"[]")}h($,u,p){u?this.c.store($,u,p,k.StorageTarget.MACHINE):this.c.remove($,p)}}e.$VLb=w}),define(ce[86],le([0,1,4,3,2,17,33,24,19,10,13]),function(ne,e,P,c,N,O,T,k,A,w,E){"use strict";var $;Object.defineProperty(e,"__esModule",{value:!0}),e.$jw=e.$iw=void 0,e.$iw=(0,P.$Fi)("IExtensionStorageService");const u=/^extensionKeys\/([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;let p=class extends N.$Wc{static{$=this}static{this.a=512*1024}static b(d){return`extensionKeys/${(0,T.$Lp)(d.id)}@${d.version}`}static c(d){const y=u.exec(d);if(y&&y[1])return{id:y[1],version:y[2]}}static async removeOutdatedExtensionVersions(d,y){const f=await d.getInstalled(),b=[];for(const[I,m]of $.f(y)){const s=f.find(r=>(0,T.$Hp)(r.identifier,{id:I}))?.manifest.version;for(const r of m)s!==r&&b.push($.b({id:I,version:r}))}for(const I of b)y.remove(I,O.StorageScope.PROFILE)}static f(d){const y=new Map,f=d.keys(O.StorageScope.PROFILE,O.StorageTarget.MACHINE);for(const b of f){const I=$.c(b);if(I){let m=y.get(I.id.toLowerCase());m||y.set(I.id.toLowerCase(),m=[]),m.push(I.version)}}return y}constructor(d,y,f){super(),this.j=d,this.m=y,this.n=f,this.g=this.B(new c.$me),this.onDidChangeExtensionStorageToSync=this.g.event,this.h=$.f(d),this.B(this.j.onDidChangeValue(O.StorageScope.PROFILE,void 0,this.B(new N.$Vc))(b=>this.r(b)))}r(d){if(this.h.has(d.key.toLowerCase())){this.g.fire();return}const y=$.c(d.key);if(y){if(this.j.get(d.key,O.StorageScope.PROFILE)===void 0)this.h.delete(y.id.toLowerCase());else{let f=this.h.get(y.id.toLowerCase());f||this.h.set(y.id.toLowerCase(),f=[]),f.push(y.version),this.g.fire()}return}}s(d){if((0,E.$fg)(d))return d;const y=d.manifest?d.manifest.publisher:d.publisher,f=d.manifest?d.manifest.name:d.name;return(0,T.$Kp)(y,f)}getExtensionState(d,y){const f=this.s(d),b=this.getExtensionStateRaw(d,y);if(b)try{return JSON.parse(b)}catch(I){this.n.error(`[mainThreadStorage] unexpected error parsing storage contents (extensionId: ${f}, global: ${y}): ${I}`)}}getExtensionStateRaw(d,y){const f=this.s(d),b=this.j.get(f,y?O.StorageScope.PROFILE:O.StorageScope.WORKSPACE);return b&&b?.length>$.a&&this.n.warn(`[mainThreadStorage] large extension state detected (extensionId: ${f}, global: ${y}): ${b.length/1024}kb. Consider to use 'storageUri' or 'globalStorageUri' to store this data on disk instead.`),b}setExtensionState(d,y,f){const b=this.s(d);y===void 0?this.j.remove(b,f?O.StorageScope.PROFILE:O.StorageScope.WORKSPACE):this.j.store(b,JSON.stringify(y),f?O.StorageScope.PROFILE:O.StorageScope.WORKSPACE,O.StorageTarget.MACHINE)}setKeysForSync(d,y){this.j.store($.b(d),JSON.stringify(y),O.StorageScope.PROFILE,O.StorageTarget.MACHINE)}getKeysForSync(d){const y=this.m.extensionSyncedKeys?.[d.id.toLowerCase()],f=this.j.get($.b(d),O.StorageScope.PROFILE),b=f?JSON.parse(f):void 0;return b&&y?(0,A.$Ob)([...b,...y]):b||y}addToMigrationList(d,y){if(d!==y){const f=this.t.filter(b=>!b.includes(d)&&!b.includes(y));f.push([d,y]),this.t=f}}getSourceExtensionToMigrate(d){const y=this.t.find(([,f])=>d===f);return y?y[0]:void 0}get t(){const d=this.j.get("extensionStorage.migrationList",O.StorageScope.APPLICATION,"[]");try{const y=JSON.parse(d);if(Array.isArray(y))return y}catch{}return[]}set t(d){d.length?this.j.store("extensionStorage.migrationList",JSON.stringify(d),O.StorageScope.APPLICATION,O.StorageTarget.MACHINE):this.j.remove("extensionStorage.migrationList",O.StorageScope.APPLICATION)}};e.$jw=p,e.$jw=p=$=ve([Y(0,O.$bq),Y(1,k.$sk),Y(2,w.$_j)],p)}),define(ce[255],le([0,1,2,28,86,233,118,10,17]),function(ne,e,P,c,N,O,T,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ahc=void 0;let w=class extends P.$Wc{constructor($,u,p,l,d,y){super(),$.cleanUp(),(0,O.$y6b)($,u,p,l,y),N.$jw.removeOutdatedExtensionVersions($,d)}};e.$ahc=w,e.$ahc=w=ve([Y(0,T.$Rq),Y(1,c.$gp),Y(2,N.$iw),Y(3,c.$mp),Y(4,A.$bq),Y(5,k.$_j)],w)}),define(ce[256],le([0,1,19,2,21,9,7,24,6,3,14,5,36,33,75,37,17]),function(ne,e,P,c,N,O,T,k,A,w,E,$,u,p,l,d,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vdc=e.$udc=void 0;let f=class extends c.$Wc{constructor(r,i){super(),this.b=r,this.c=i,this.a=new Map,this.c.configBasedExtensionTips&&Object.entries(this.c.configBasedExtensionTips).forEach(([,a])=>this.a.set(a.configPath,a))}getConfigBasedTips(r){return this.f(r)}async getImportantExecutableBasedTips(){return[]}async getOtherExecutableBasedTips(){return[]}async f(r){const i=[];for(const[a,t]of this.a)if(!(t.configScheme&&t.configScheme!==r.scheme))try{const n=(await this.b.readFile((0,N.$gh)(r,a))).value.toString();for(const[o,h]of Object.entries(t.recommendations))(!h.contentPattern||new RegExp(h.contentPattern,"mig").test(n))&&i.push({extensionId:o,extensionName:h.name,configName:t.configName,important:!!h.important,isExtensionPack:!!h.isExtensionPack,whenNotInstalled:h.whenNotInstalled})}catch{}return i}};e.$udc=f,e.$udc=f=ve([Y(0,T.$_k),Y(1,k.$sk)],f);const b="extensionTips/promptedExecutableTips",I="extensionTips/lastPromptedMediumImpExeTime";class m extends f{constructor(r,i,a,t,n,o,h,g){super(h,g),this.r=r,this.s=i,this.t=a,this.u=t,this.w=n,this.z=o,this.g=new Map,this.h=new Map,this.j=new Map,this.m=new Map,this.n=new Map,g.exeBasedExtensionTips&&Object.entries(g.exeBasedExtensionTips).forEach(([R,L])=>{const S=[],v=[],C=[];Object.entries(L.recommendations).forEach(([F,D])=>{D.important?L.important?S.push({extensionId:F,extensionName:D.name,isExtensionPack:!!D.isExtensionPack}):v.push({extensionId:F,extensionName:D.name,isExtensionPack:!!D.isExtensionPack}):C.push({extensionId:F,extensionName:D.name,isExtensionPack:!!D.isExtensionPack})}),S.length&&this.g.set(R,{exeFriendlyName:L.friendlyName,windowsPath:L.windowsPath,recommendations:S}),v.length&&this.h.set(R,{exeFriendlyName:L.friendlyName,windowsPath:L.windowsPath,recommendations:v}),C.length&&this.j.set(R,{exeFriendlyName:L.friendlyName,windowsPath:L.windowsPath,recommendations:C})}),(0,A.$Hh)(async()=>{await this.C(),this.F(),this.G()},3e3,this.q)}async getImportantExecutableBasedTips(){const r=await this.O(this.g),i=await this.O(this.h);return[...r,...i]}getOtherExecutableBasedTips(){return this.O(this.j)}async C(){const r=await this.O(this.g),i=await this.O(this.h),a=await this.u.getInstalled();this.m=this.D(r,a),this.n=this.D(i,a)}D(r,i){const a=new Map;r.forEach(g=>a.set(g.extensionId.toLowerCase(),g));const{installed:t,uninstalled:n}=this.N([...a.keys()],i);for(const g of t){const R=a.get(g);R&&this.t.publicLog2("exeExtensionRecommendations:alreadyInstalled",{extensionId:g,exeName:R.exeName})}for(const g of n){const R=a.get(g);R&&this.t.publicLog2("exeExtensionRecommendations:notInstalled",{extensionId:g,exeName:R.exeName})}const o=this.L(),h=new Map;for(const g of n){const R=a.get(g);if(R&&(!o[R.exeName]||!o[R.exeName].includes(R.extensionId))){let L=h.get(R.exeName);L||(L=[],h.set(R.exeName,L)),L.push(R)}}return h}F(){if(this.m.size===0)return;const[r,i]=[...this.m.entries()][0];this.H(i).then(a=>{switch(a){case l.RecommendationsNotificationResult.Accepted:this.M(i[0].exeName,i);break;case l.RecommendationsNotificationResult.Ignored:this.m.delete(r);break;case l.RecommendationsNotificationResult.IncompatibleWindow:{const t=w.Event.once(w.Event.latch(w.Event.any(this.s.onDidOpenMainWindow,this.s.onDidFocusMainWindow)));this.B(t(()=>this.F()));break}case l.RecommendationsNotificationResult.TooMany:{const t=this.B(new c.$Xc);t.value=(0,A.$Hh)(()=>{t.dispose(),this.F()},60*60*1e3);break}}})}G(){if(this.n.size===0)return;const r=this.I(),i=Date.now()-r,a=7*24*60*60*1e3;if(i<a){const o=this.B(new c.$Xc);o.value=(0,A.$Hh)(()=>{o.dispose(),this.G()},a-i);return}const[t,n]=[...this.n.entries()][0];this.H(n).then(o=>{switch(o){case l.RecommendationsNotificationResult.Accepted:{this.J(Date.now()),this.n.delete(t),this.M(n[0].exeName,n);const h=this.B(new c.$Xc);h.value=(0,A.$Hh)(()=>{h.dispose(),this.G()},a);break}case l.RecommendationsNotificationResult.Ignored:this.n.delete(t),this.G();break;case l.RecommendationsNotificationResult.IncompatibleWindow:{const h=w.Event.once(w.Event.latch(w.Event.any(this.s.onDidOpenMainWindow,this.s.onDidFocusMainWindow)));this.B(h(()=>this.G()));break}case l.RecommendationsNotificationResult.TooMany:{const h=this.B(new c.$Xc);h.value=(0,A.$Hh)(()=>{h.dispose(),this.G()},60*60*1e3);break}}})}async H(r){const i=await this.u.getInstalled(d.ExtensionType.User),a=r.filter(t=>!t.whenNotInstalled||t.whenNotInstalled.every(n=>i.every(o=>!(0,p.$Hp)(o.identifier,{id:n})))).map(({extensionId:t})=>t.toLowerCase());return this.z.promptImportantExtensionsInstallNotification({extensions:a,source:l.RecommendationSource.EXE,name:r[0].exeFriendlyName,searchValue:`@exe:"${r[0].exeName}"`})}I(){let r=this.w.getNumber(I,y.StorageScope.APPLICATION);return r||(r=Date.now(),this.J(r)),r}J(r){this.w.store(I,r,y.StorageScope.APPLICATION,y.StorageTarget.MACHINE)}L(){return JSON.parse(this.w.get(b,y.StorageScope.APPLICATION,"{}"))}M(r,i){const a=this.L();a[r]=i.map(({extensionId:t})=>t.toLowerCase()),this.w.store(b,JSON.stringify(a),y.StorageScope.APPLICATION,y.StorageTarget.USER)}N(r,i){const a=[],t=[],n=i.reduce((o,h)=>(o.add(h.identifier.id.toLowerCase()),o),new Set);return r.forEach(o=>{n.has(o.toLowerCase())?a.push(o):t.push(o)}),{installed:a,uninstalled:t}}async O(r){const i=[],a=new Map;for(const t of r.keys()){const n=r.get(t);if(!n||!(0,P.$Nb)(n.recommendations))continue;const o=[];$.$i?n.windowsPath&&o.push(n.windowsPath.replace("%USERPROFILE%",()=>u.env.USERPROFILE).replace("%ProgramFiles(x86)%",()=>u.env["ProgramFiles(x86)"]).replace("%ProgramFiles%",()=>u.env.ProgramFiles).replace("%APPDATA%",()=>u.env.APPDATA).replace("%WINDIR%",()=>u.env.WINDIR)):(o.push((0,E.$lc)("/usr/local/bin",t)),o.push((0,E.$lc)("/usr/bin",t)),o.push((0,E.$lc)(this.r.fsPath,t)));for(const h of o){let g=a.get(h);if(g===void 0&&(g=await this.b.exists(O.URI.file(h)),a.set(h,g)),g)for(const{extensionId:R,extensionName:L,isExtensionPack:S,whenNotInstalled:v}of n.recommendations)i.push({extensionId:R,extensionName:L,isExtensionPack:S,exeName:t,exeFriendlyName:n.exeFriendlyName,windowsPath:n.windowsPath,whenNotInstalled:v})}}return i}}e.$vdc=m}),define(ce[257],le([0,1,28,7,24,16,75,59,17,18,256]),function(ne,e,P,c,N,O,T,k,A,w,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hhc=void 0;let $=class extends E.$vdc{constructor(p,l,d,y,f,b,I,m){super(p.userHome,f,l,d,y,b,I,m)}};e.$hhc=$,e.$hhc=$=ve([Y(0,O.$Ni),Y(1,w.$$l),Y(2,P.$jp),Y(3,A.$bq),Y(4,k.$dfc),Y(5,T.$g6b),Y(6,c.$_k),Y(7,N.$sk)],$)}),define(ce[50],le([0,1,15,32,17]),function(ne,e,P,c,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hq=O;async function O(T,k,A){let w=A&&A.get("storage.serviceMachineId",N.StorageScope.APPLICATION)||null;if(w)return w;try{const $=(await k.readFile(T.serviceMachineIdResource)).value.toString();w=(0,c.$1g)($)?$:null}catch{w=null}if(!w){w=(0,c.$2g)();try{await k.writeFile(T.serviceMachineIdResource,P.$Oe.fromString(w))}catch{}}return A?.store("storage.serviceMachineId",w,N.StorageScope.APPLICATION,N.StorageTarget.MACHINE),w}}),define(ce[258],le([0,1,50,18,49]),function(ne,e,P,c,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iq=O;async function O(T,k,A,w,E,$,u){const p={"X-Market-Client-Id":`VSCode ${T}`,"User-Agent":`VSCode ${T} (${k.nameShort})`};if((0,N.$zp)(k,A)&&(0,N.$Bp)(w)===c.TelemetryLevel.USAGE){const l=await(0,P.$hq)(A,E,$);p["X-Market-User-Id"]=l,p["VSCode-SessionId"]=u.machineId||l}return p}}),define(ce[259],le([0,1,19,26,8,5,36,13,9,22,16,28,33,37,73,7,10,24,61,258,17,18,55]),function(ne,e,P,c,N,O,T,k,A,w,E,$,u,p,l,d,y,f,b,I,m,s,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lq=e.$kq=void 0,e.$jq=he;const i=O.$o?p.TargetPlatform.WEB:(0,$.$cp)(O.$u,T.$gc),a="X-Market-Search-Activity-Id";var t;(function(B){B[B.None=0]="None",B[B.IncludeVersions=1]="IncludeVersions",B[B.IncludeFiles=2]="IncludeFiles",B[B.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",B[B.IncludeSharedAccounts=8]="IncludeSharedAccounts",B[B.IncludeVersionProperties=16]="IncludeVersionProperties",B[B.ExcludeNonValidated=32]="ExcludeNonValidated",B[B.IncludeInstallationTargets=64]="IncludeInstallationTargets",B[B.IncludeAssetUri=128]="IncludeAssetUri",B[B.IncludeStatistics=256]="IncludeStatistics",B[B.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",B[B.Unpublished=4096]="Unpublished",B[B.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(t||(t={}));function n(...B){return String(B.reduce((j,W)=>j|W,0))}var o;(function(B){B[B.Tag=1]="Tag",B[B.ExtensionId=4]="ExtensionId",B[B.Category=5]="Category",B[B.ExtensionName=7]="ExtensionName",B[B.Target=8]="Target",B[B.Featured=9]="Featured",B[B.SearchText=10]="SearchText",B[B.ExcludeWithFlags=12]="ExcludeWithFlags"})(o||(o={}));const h={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source",Signature:"Microsoft.VisualStudio.Services.VsixSignature"},g={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink",SupportLink:"Microsoft.VisualStudio.Services.Links.Support"},L={pageNumber:1,pageSize:10,sortBy:$.SortBy.NoneOrRelevance,sortOrder:$.SortOrder.Default,flags:t.None,criteria:[],assetTypes:[]};class S{constructor(j=L){this.d=j}get pageNumber(){return this.d.pageNumber}get pageSize(){return this.d.pageSize}get sortBy(){return this.d.sortBy}get sortOrder(){return this.d.sortOrder}get flags(){return this.d.flags}get criteria(){return this.d.criteria}withPage(j,W=this.d.pageSize){return new S({...this.d,pageNumber:j,pageSize:W})}withFilter(j,...W){const te=[...this.d.criteria,...W.length?W.map(_=>({filterType:j,value:_})):[{filterType:j}]];return new S({...this.d,criteria:te})}withSortBy(j){return new S({...this.d,sortBy:j})}withSortOrder(j){return new S({...this.d,sortOrder:j})}withFlags(...j){return new S({...this.d,flags:j.reduce((W,te)=>W|te,0)})}withAssetTypes(...j){return new S({...this.d,assetTypes:j})}withSource(j){return new S({...this.d,source:j})}get raw(){const{criteria:j,pageNumber:W,pageSize:te,sortBy:_,sortOrder:Q,flags:ae,assetTypes:ue}=this.d;return{filters:[{criteria:j,pageNumber:W,pageSize:te,sortBy:_,sortOrder:Q}],assetTypes:ue,flags:ae}}get searchText(){const j=this.d.criteria.filter(W=>W.filterType===o.SearchText)[0];return j&&j.value?j.value:""}get telemetryData(){return{filterTypes:this.d.criteria.map(j=>String(j.filterType)),flags:this.d.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.d.source,searchTextLength:this.searchText.length}}}function v(B,j){const W=(B||[]).filter(te=>te.statisticName===j)[0];return W?W.value:0}function C(B){const j="Microsoft.VisualStudio.Code.Translation.";return B.files.filter(te=>te.assetType.indexOf(j)===0).reduce((te,_)=>{const Q=M(B,_.assetType);return Q&&te.push([_.assetType.substring(j.length),Q]),te},[])}function F(B){if(B.properties){const j=B.properties.filter(_=>_.key===h.Repository),W=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),te=j.filter(_=>W.test(_.value))[0];return te?{uri:te.value,fallbackUri:te.value}:null}return M(B,h.Repository)}function D(B){return{uri:`${B.fallbackAssetUri}/${h.VSIX}?redirect=true${B.targetPlatform?`&targetPlatform=${B.targetPlatform}`:""}`,fallbackUri:`${B.fallbackAssetUri}/${h.VSIX}${B.targetPlatform?`?targetPlatform=${B.targetPlatform}`:""}`}}function M(B,j){return B.files.filter(te=>te.assetType===j)[0]?{uri:`${B.assetUri}/${j}${B.targetPlatform?`?targetPlatform=${B.targetPlatform}`:""}`,fallbackUri:`${B.fallbackAssetUri}/${j}${B.targetPlatform?`?targetPlatform=${B.targetPlatform}`:""}`}:null}function J(B,j){const W=B.properties?B.properties.filter(_=>_.key===j):[],te=W.length>0&&W[0].value;return te?te.split(",").map(_=>(0,u.$Lp)(_)):[]}function H(B){const j=B.properties?B.properties.filter(W=>W.key===g.Engine):[];return j.length>0&&j[0].value||""}function x(B){const j=B.properties?B.properties.filter(W=>W.key===g.PreRelease):[];return j.length>0&&j[0].value==="true"}function K(B){const j=B.properties?B.properties.filter(te=>te.key===g.LocalizedLanguages):[],W=j.length>0&&j[0].value||"";return W?W.split(","):[]}function ie(B){return B.properties?.find(j=>j.key===g.SponsorLink)?.value}function V(B){return B.properties?.find(j=>j.key===g.SupportLink)?.value}function z(B){return B.indexOf("preview")!==-1}function ee(B){return B.targetPlatform?(0,$.$bp)(B.targetPlatform):p.TargetPlatform.UNDEFINED}function se(B){const j=(0,P.$Ob)(B.versions.map(ee)),W=!!B.tags?.includes($.$8o),te=j.indexOf(p.TargetPlatform.WEB);return W?te===-1&&j.push(p.TargetPlatform.WEB):te!==-1&&j.splice(te,1),j}function he(B,j){for(let W=0;W<B.length;W++){const te=B[W];if(te.version===B[W-1]?.version){let _=W;if(ee(te)===j)for(;_>0&&B[_-1].version===te.version;)_--;_!==W&&(B.splice(W,1),B.splice(_,0,te))}}return B}function q(B,j,W){B.telemetryData={index:j,querySource:W,queryActivityId:B.queryContext?.[a]}}function Z(B,j,W,te){const _=B.versions[0],Q={manifest:M(j,h.Manifest),readme:M(j,h.Details),changelog:M(j,h.Changelog),license:M(j,h.License),repository:F(j),download:D(j),icon:M(j,h.Icon),signature:M(j,h.Signature),coreTranslations:C(j)};return{type:"gallery",identifier:{id:(0,u.$Mp)(B.publisher.publisherName,B.extensionName),uuid:B.extensionId},name:B.extensionName,version:j.version,displayName:B.displayName,publisherId:B.publisher.publisherId,publisher:B.publisher.publisherName,publisherDisplayName:B.publisher.displayName,publisherDomain:B.publisher.domain?{link:B.publisher.domain,verified:!!B.publisher.isDomainVerified}:void 0,publisherSponsorLink:ie(_),description:B.shortDescription??"",installCount:v(B.statistics,"install"),rating:v(B.statistics,"averagerating"),ratingCount:v(B.statistics,"ratingcount"),categories:B.categories||[],tags:B.tags||[],releaseDate:Date.parse(B.releaseDate),lastUpdated:Date.parse(B.lastUpdated),allTargetPlatforms:W,assets:Q,properties:{dependencies:J(j,g.Dependency),extensionPack:J(j,g.ExtensionPack),engine:H(j),localizedLanguages:K(j),targetPlatform:ee(j),isPreReleaseVersion:x(j)},hasPreReleaseVersion:x(_),hasReleaseVersion:!0,preview:z(B.flags),isSigned:!!Q.signature,queryContext:te,supportLink:V(_)}}let X=class{constructor(j,W,te,_,Q,ae,ue,ge){this.k=W,this.l=te,this.n=_,this.o=Q,this.q=ae,this.u=ue,this.w=ge;const we=ue.extensionsGallery,Ee=we?.servicePPEUrl&&ge.getValue("_extensionsGallery.enablePPE");this.d=Ee?we.servicePPEUrl:we?.serviceUrl,this.g=Ee?void 0:we?.searchUrl,this.h=we?.controlUrl,this.j=(0,I.$iq)(ue.version,ue,this.n,this.w,this.q,j,this.o)}x(j=""){return`${this.d}${j}`}isEnabled(){return!!this.d}async getExtensions(j,W,te){const _=c.CancellationToken.isCancellationToken(W)?{}:W,Q=c.CancellationToken.isCancellationToken(W)?W:te,ae=[],ue=[],ge=[],we=[];let Ee=!0;for(const Se of j){Se.uuid?ue.push(Se.uuid):ae.push(Se.id);const Ie=!!(Se.version||Se.preRelease);ge.push({id:Se.id,uuid:Se.uuid,includePreRelease:Ie}),Se.version&&we.push({id:Se.id,uuid:Se.uuid,version:Se.version}),Ee=Ee&&!!Se.hasPreRelease&&!Ie}if(!ue.length&&!ae.length)return[];let pe=new S().withPage(1,j.length);ue.length&&(pe=pe.withFilter(o.ExtensionId,...ue)),ae.length&&(pe=pe.withFilter(o.ExtensionName,...ae)),(_.queryAllVersions||Ee)&&(pe=pe.withFlags(pe.flags,t.IncludeVersions)),_.source&&(pe=pe.withSource(_.source));const{extensions:be}=await this.z(pe,{targetPlatform:_.targetPlatform??i,includePreRelease:ge,versions:we,compatible:!!_.compatible,productVersion:_.productVersion??{version:this.u.version,date:this.u.date}},Q);return _.source&&be.forEach((Se,Ie)=>q(Se,Ie,_.source)),be}async getCompatibleExtension(j,W,te,_={version:this.u.version,date:this.u.date}){if((0,$.$dp)(j.allTargetPlatforms,te))return null;if(await this.isExtensionCompatible(j,W,te))return j;const Q=new S().withFlags(t.IncludeVersions).withPage(1,1).withFilter(o.ExtensionId,j.identifier.uuid),{extensions:ae}=await this.z(Q,{targetPlatform:te,compatible:!0,includePreRelease:W,productVersion:_},c.CancellationToken.None);return ae[0]||null}async isExtensionCompatible(j,W,te,_={version:this.u.version,date:this.u.date}){if(!(0,$.$ep)(j.properties.targetPlatform,j.allTargetPlatforms,te)||!W&&j.properties.isPreReleaseVersion)return!1;let Q=j.properties.engine;if(!Q){const ae=await this.getManifest(j,c.CancellationToken.None);if(!ae)throw new Error("Manifest was not found");Q=ae.engines.vscode}return(0,l.$Zp)(Q,_.version,_.date)}async y(j,W,te,_,Q,ae,ue={version:this.u.version,date:this.u.date}){if(!(0,$.$ep)(ee(W),Q,ae)||te!=="any"&&x(W)!==(te==="prerelease"))return!1;if(_)try{const ge=await this.E(j,W);if(!(0,l.$Zp)(ge,ue.version,ue.date))return!1}catch(ge){return this.l.error(`Error while getting the engine for the version ${W.version}.`,(0,N.$_)(ge)),!1}return!0}async query(j,W){let te=j.text||"";const _=j.pageSize??50;let Q=new S().withPage(1,_);te?(te=te.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(Ee,pe,be)=>(Q=Q.withFilter(o.Category,be||pe),"")),te=te.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(Ee,pe,be)=>(Q=Q.withFilter(o.Tag,be||pe),"")),te=te.replace(/\bfeatured(\s+|\b|$)/g,()=>(Q=Q.withFilter(o.Featured),"")),te=te.trim(),te&&(te=te.length<200?te:te.substring(0,200),Q=Q.withFilter(o.SearchText,te)),Q=Q.withSortBy($.SortBy.NoneOrRelevance)):j.ids?Q=Q.withFilter(o.ExtensionId,...j.ids):j.names?Q=Q.withFilter(o.ExtensionName,...j.names):Q=Q.withSortBy($.SortBy.InstallCount),typeof j.sortBy=="number"&&(Q=Q.withSortBy(j.sortBy)),typeof j.sortOrder=="number"&&(Q=Q.withSortOrder(j.sortOrder)),j.source&&(Q=Q.withSource(j.source));const ae=async(Ee,pe)=>{const{extensions:be,total:Se}=await this.z(Ee,{targetPlatform:i,compatible:!1,includePreRelease:!!j.includePreRelease,productVersion:j.productVersion??{version:this.u.version,date:this.u.date}},pe);return be.forEach((Ie,oe)=>q(Ie,(Ee.pageNumber-1)*Ee.pageSize+oe,j.source)),{extensions:be,total:Se}},{extensions:ue,total:ge}=await ae(Q,W),we=async(Ee,pe)=>{if(pe.isCancellationRequested)throw new N.$7;const{extensions:be}=await ae(Q.withPage(Ee+1),pe);return be};return{firstPage:ue,total:ge,pageSize:Q.pageSize,getPage:we}}async z(j,W,te){const _=j.flags;j.flags&t.IncludeLatestVersionOnly&&j.flags&t.IncludeVersions&&(j=j.withFlags(j.flags&~t.IncludeVersions,t.IncludeLatestVersionOnly)),!(j.flags&t.IncludeLatestVersionOnly)&&!(j.flags&t.IncludeVersions)&&(j=j.withFlags(j.flags,t.IncludeLatestVersionOnly)),W.versions?.length&&(j=j.withFlags(j.flags&~t.IncludeLatestVersionOnly,t.IncludeVersions)),j=j.withFlags(j.flags,t.IncludeAssetUri,t.IncludeCategoryAndTags,t.IncludeFiles,t.IncludeStatistics,t.IncludeVersionProperties);const{galleryExtensions:Q,total:ae,context:ue}=await this.B(j,te);if(!(j.flags&t.IncludeLatestVersionOnly)){const pe=[];for(const be of Q){const Se=await this.A(be,W,ue);Se&&pe.push(Se)}return{extensions:pe,total:ae}}const we=[],Ee=new Map;for(let pe=0;pe<Q.length;pe++){const be=Q[pe],Se={id:(0,u.$Mp)(be.publisher.publisherName,be.extensionName),uuid:be.extensionId},Ie=(0,k.$lg)(W.includePreRelease)?W.includePreRelease:!!W.includePreRelease.find(de=>(0,u.$Hp)(de,Se))?.includePreRelease;if(W.compatible&&(0,$.$dp)(se(be),W.targetPlatform))continue;const oe=await this.A(be,W,ue);!oe||oe.properties.isPreReleaseVersion&&(!Ie||!oe.hasReleaseVersion)||!oe.properties.isPreReleaseVersion&&oe.properties.targetPlatform!==W.targetPlatform&&oe.hasPreReleaseVersion?Ee.set(be.extensionId,pe):we.push([pe,oe])}if(Ee.size){const pe=new r.$ge,be=new S().withFlags(_&~t.IncludeLatestVersionOnly,t.IncludeVersions).withPage(1,Ee.size).withFilter(o.ExtensionId,...Ee.keys()),{extensions:Se}=await this.z(be,W,te);this.o.publicLog2("galleryService:additionalQuery",{duration:pe.elapsed(),count:Ee.size});for(const Ie of Se){const oe=Ee.get(Ie.identifier.uuid);we.push([oe,Ie])}}return{extensions:we.sort((pe,be)=>pe[0]-be[0]).map(([,pe])=>pe),total:ae}}async A(j,W,te){const _={id:(0,u.$Mp)(j.publisher.publisherName,j.extensionName),uuid:j.extensionId},Q=W.versions?.find(we=>(0,u.$Hp)(we,_))?.version,ae=(0,k.$lg)(W.includePreRelease)?W.includePreRelease:!!W.includePreRelease.find(we=>(0,u.$Hp)(we,_))?.includePreRelease,ue=se(j),ge=he(j.versions,W.targetPlatform);if(W.compatible&&(0,$.$dp)(ue,W.targetPlatform))return null;for(let we=0;we<ge.length;we++){const Ee=ge[we];if(!(Q&&Ee.version!==Q)){if(await this.y((0,u.$Mp)(j.publisher.publisherName,j.extensionName),Ee,ae?"any":"release",W.compatible,ue,W.targetPlatform,W.productVersion))return Z(j,Ee,ue,te);if(Q&&Ee.version===Q)return null}}return Q||W.compatible?null:Z(j,j.versions[0],ue)}async B(j,W){if(!this.isEnabled())throw new Error("No extension gallery service configured.");j=j.withFlags(j.flags,t.ExcludeNonValidated).withFilter(o.Target,"Microsoft.VisualStudio.Code").withFilter(o.ExcludeWithFlags,n(t.Unpublished));const te=await this.j,_=JSON.stringify(j.raw),Q={...te,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(_.length)},ae=new r.$ge;let ue,ge,we=0;try{if(ue=await this.k.request({type:"POST",url:this.g&&j.criteria.some(pe=>pe.filterType===o.SearchText)?this.g:this.x("/extensionquery"),data:_,headers:Q},W),ue.res.statusCode&&ue.res.statusCode>=400&&ue.res.statusCode<500)return{galleryExtensions:[],total:we};const Ee=await(0,b.$7p)(ue);if(Ee){const pe=Ee.results[0],be=pe.extensions,Se=pe.resultMetadata&&pe.resultMetadata.filter(Ie=>Ie.metadataType==="ResultCount")[0];return we=Se&&Se.metadataItems.filter(Ie=>Ie.name==="TotalCount")[0].count||0,{galleryExtensions:be,total:we,context:{[a]:ue.res.headers.activityid}}}return{galleryExtensions:[],total:we}}catch(Ee){if((0,N.$6)(Ee))throw ge=$.ExtensionGalleryErrorCode.Cancelled,Ee;{const pe=(0,N.$_)(Ee);throw ge=pe.startsWith("XHR timeout")?$.ExtensionGalleryErrorCode.Timeout:$.ExtensionGalleryErrorCode.Failed,new $.$hp(pe,ge)}}finally{this.o.publicLog2("galleryService:query",{...j.telemetryData,requestBodySize:String(_.length),duration:ae.elapsed(),success:!!ue&&(0,b.$3p)(ue),responseBodySize:ue?.res.headers["Content-Length"],statusCode:ue?String(ue.res.statusCode):void 0,errorCode:ge,count:String(we)})}}async reportStatistic(j,W,te,_){if(!this.isEnabled())return;const Q=O.$o?this.x(`/itemName/${j}.${W}/version/${te}/statType/${_===$.StatisticType.Install?"1":"3"}/vscodewebextension`):this.x(`/publishers/${j}/extensions/${W}/${te}/stats?statType=${_}`),ae=O.$o?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",ge={...await this.j,Accept:ae};try{await this.k.request({type:"POST",url:Q,headers:ge},c.CancellationToken.None)}catch{}}async download(j,W,te){this.l.trace("ExtensionGalleryService#download",j.identifier.id);const _=(0,u.$Pp)(j),Q=new Date().getTime(),ae=te===$.InstallOperation.Install?"install":te===$.InstallOperation.Update?"update":"",ue=ae?{uri:`${j.assets.download.uri}${A.URI.parse(j.assets.download.uri).query?"&":"?"}${ae}=true`,fallbackUri:`${j.assets.download.fallbackUri}${A.URI.parse(j.assets.download.fallbackUri).query?"&":"?"}${ae}=true`}:j.assets.download,ge=j.queryContext?.[a]?{[a]:j.queryContext[a]}:void 0,we=await this.D(j.identifier.id,ue,h.VSIX,ge?{headers:ge}:void 0);try{await this.q.writeFile(W,we.stream)}catch(Ee){try{await this.q.del(W)}catch(pe){this.l.warn(`Error while deleting the file ${W.toString()}`,(0,N.$_)(pe))}throw new $.$hp((0,N.$_)(Ee),$.ExtensionGalleryErrorCode.DownloadFailedWriting)}this.o.publicLog("galleryService:downloadVSIX",{..._,duration:new Date().getTime()-Q})}async downloadSignatureArchive(j,W){if(!j.assets.signature)throw new Error("No signature asset found");this.l.trace("ExtensionGalleryService#downloadSignatureArchive",j.identifier.id);const te=await this.D(j.identifier.id,j.assets.signature,h.Signature);try{await this.q.writeFile(W,te.stream)}catch(_){try{await this.q.del(W)}catch(Q){this.l.warn(`Error while deleting the file ${W.toString()}`,(0,N.$_)(Q))}throw new $.$hp((0,N.$_)(_),$.ExtensionGalleryErrorCode.DownloadFailedWriting)}}async getReadme(j,W){if(j.assets.readme){const te=await this.D(j.identifier.id,j.assets.readme,h.Details,{},W);return await(0,b.$6p)(te)||""}return""}async getManifest(j,W){if(j.assets.manifest){const te=await this.D(j.identifier.id,j.assets.manifest,h.Manifest,{},W),_=await(0,b.$6p)(te);return _?JSON.parse(_):null}return null}async C(j,W,te){const _=M(W,h.Manifest);if(!_)throw new Error("Manifest was not found");const Q={"Accept-Encoding":"gzip"},ae=await this.D(j,_,h.Manifest,{headers:Q});return await(0,b.$7p)(ae)}async getCoreTranslation(j,W){const te=j.assets.coreTranslations.filter(_=>_[0]===W.toUpperCase())[0];if(te){const _=await this.D(j.identifier.id,te[1],te[0]),Q=await(0,b.$6p)(_);return Q?JSON.parse(Q):null}return null}async getChangelog(j,W){if(j.assets.changelog){const te=await this.D(j.identifier.id,j.assets.changelog,h.Changelog,{},W);return await(0,b.$6p)(te)||""}return""}async getAllCompatibleVersions(j,W,te){let _=new S().withFlags(t.IncludeVersions,t.IncludeCategoryAndTags,t.IncludeFiles,t.IncludeVersionProperties).withPage(1,1);j.identifier.uuid?_=_.withFilter(o.ExtensionId,j.identifier.uuid):_=_.withFilter(o.ExtensionName,j.identifier.id);const{galleryExtensions:Q}=await this.B(_,c.CancellationToken.None);if(!Q.length)return[];const ae=se(Q[0]);if((0,$.$dp)(ae,te))return[];const ue=[];await Promise.all(Q[0].versions.map(async Ee=>{try{await this.y(j.identifier.id,Ee,W?"any":"release",!0,ae,te)&&ue.push(Ee)}catch{}}));const ge=[],we=new Set;for(const Ee of he(ue,te))we.has(Ee.version)||(we.add(Ee.version),ge.push({version:Ee.version,date:Ee.lastUpdated,isPreReleaseVersion:x(Ee)}));return ge}async D(j,W,te,_={},Q=c.CancellationToken.None){const ae=await this.j,ue={type:"GET"},ge={...ae,..._.headers||{}};_={..._,...ue,headers:ge};const we=W.uri,Ee=W.fallbackUri,pe={..._,url:we};try{const be=await this.k.request(pe,Q);if(be.res.statusCode===200)return be;const Se=await(0,b.$6p)(be);throw new Error(`Expected 200, got back ${be.res.statusCode} instead.

${Se}`)}catch(be){if((0,N.$6)(be))throw be;const Se=(0,N.$_)(be);this.o.publicLog2("galleryService:cdnFallback",{extension:j,assetType:te,message:Se});const Ie={..._,url:Ee};return this.k.request(Ie,Q)}}async E(j,W){let te=H(W);if(!te){this.o.publicLog2("galleryService:engineFallback",{extension:j,version:W.version});const _=await this.C(j,W,c.CancellationToken.None);if(!_)throw new Error("Manifest was not found");te=_.engines.vscode}return te}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.h)return{malicious:[],deprecated:{},search:[]};const j=await this.k.request({type:"GET",url:this.h},c.CancellationToken.None);if(j.res.statusCode!==200)throw new Error("Could not get extensions report.");const W=await(0,b.$7p)(j),te=[],_={},Q=[];if(W){for(const ae of W.malicious)te.push({id:ae});if(W.migrateToPreRelease)for(const[ae,ue]of Object.entries(W.migrateToPreRelease))(!ue.engine||(0,l.$Zp)(ue.engine,this.u.version,this.u.date))&&(_[ae.toLowerCase()]={disallowInstall:!0,extension:{id:ue.id,displayName:ue.displayName,autoMigrate:{storage:!!ue.migrateStorage},preRelease:!0}});if(W.deprecated)for(const[ae,ue]of Object.entries(W.deprecated))ue&&(_[ae.toLowerCase()]=(0,k.$lg)(ue)?{}:ue);if(W.search)for(const ae of W.search)Q.push(ae)}return{malicious:te,deprecated:_,search:Q}}};X=ve([Y(1,b.$1p),Y(2,y.$_j),Y(3,E.$Mi),Y(4,s.$$l),Y(5,d.$_k),Y(6,f.$sk),Y(7,w.$_i)],X);let G=class extends X{constructor(j,W,te,_,Q,ae,ue,ge){super(j,W,te,_,Q,ae,ue,ge)}};e.$kq=G,e.$kq=G=ve([Y(0,m.$bq),Y(1,b.$1p),Y(2,y.$_j),Y(3,E.$Mi),Y(4,s.$$l),Y(5,d.$_k),Y(6,f.$sk),Y(7,w.$_i)],G);let U=class extends X{constructor(j,W,te,_,Q,ae,ue){super(void 0,j,W,te,_,Q,ae,ue)}};e.$lq=U,e.$lq=U=ve([Y(0,b.$1p),Y(1,y.$_j),Y(2,E.$Mi),Y(3,s.$$l),Y(4,d.$_k),Y(5,f.$sk),Y(6,w.$_i)],U)}),define(ce[260],le([0,1,108,3,18,16,2,10,14,69,24,5,6,102,22,176,38,17,13,138,21]),function(ne,e,P,c,N,O,T,k,A,w,E,$,u,p,l,d,y,f,b,I,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dhc=void 0;const s=[P.$9gc,P.$0gc],r="remoteTunnelSession",i="remoteTunnelIsService";let a=class extends T.$Wc{constructor(h,g,R,L,S,v,C){super(),this.y=h,this.z=g,this.C=R,this.D=v,this.F=C,this.f=new c.$me,this.onDidTokenFailed=this.f.event,this.g=new c.$me,this.onDidChangeTunnelStatus=this.g.event,this.h=new c.$me,this.onDidChangeMode=this.h.event,this.n=P.$7gc,this.w=!1,this.I=(F,D)=>{D?this.j.error(F):this.j.info(F)},this.j=this.B(L.createLogger((0,m.$gh)(R.logsHome,`${P.$$gc}.log`),{id:P.$$gc,name:P.$_gc})),this.t=new u.$Ch(100),this.B(this.j.onDidChangeLogLevel(F=>this.j.info("Log level changed to "+(0,k.$ok)(F)))),this.B(S.onWillShutdown(()=>{this.r?.cancel(),this.r=void 0,this.dispose()})),this.B(v.onDidChangeConfiguration(F=>{s.some(D=>F.affectsConfiguration(D))&&this.t.trigger(()=>this.L())})),this.n=this.R(),this.s=P.TunnelStates.uninitialized}async getTunnelStatus(){return this.s}G(h){this.s=h,this.g.fire(h)}H(h){n(this.n,h)||(this.n=h,this.S(h),this.h.fire(this.n),h.active?(this.j.info(`Session updated: ${h.session.accountLabel} (${h.session.providerId}) (service=${h.asService})`),h.session.token&&this.j.info(`Session token updated: ${h.session.accountLabel} (${h.session.providerId})`)):this.j.info("Session reset"))}getMode(){return Promise.resolve(this.n)}async initialize(h){if(this.w)return this.s;this.w=!0,this.H(h);try{await this.t.trigger(()=>this.L())}catch(g){this.j.error(g)}return this.s}J(){if(!this.u){let h;$.$j?h=this.C.appRoot:h=(0,A.$oc)((0,A.$oc)(this.C.appRoot)),this.u=(0,A.$lc)(h,"bin",`${this.z.tunnelApplicationName}${$.$i?".exe":""}`)}return this.u}async startTunnel(h){if(n(this.n,h)&&this.s.type!=="disconnected")return this.s;this.H(h);try{await this.t.trigger(()=>this.L())}catch(g){this.j.error(g)}return this.s}async stopTunnel(){if(this.r&&(this.r.cancel(),this.r=void 0),this.n.active){const h=this.n.asService;this.H(P.$7gc);try{h&&this.O("uninstallService",["service","uninstall"])}catch(g){this.j.error(g)}}try{await this.O("stop",["kill"])}catch(h){this.j.error(h)}this.G(P.TunnelStates.disconnected())}async L(){this.y.publicLog2("remoteTunnel.enablement",{enabled:this.n.active,service:this.n.active&&this.n.asService}),this.r&&(this.r.cancel(),this.r=void 0);let h="",g=!1;const R=(D,M)=>{M?this.j.error(D):h+=D,!this.C.isBuilt&&D.startsWith("   Compiling")&&this.G(P.TunnelStates.connecting((0,d.localize)(0,null)))},L=this.O("status",["status"],R);this.r=L;try{if(await L,this.r!==L)return;let D;try{D=JSON.parse(h.trim().split(`
`).find(M=>M.startsWith("{")))}catch{this.j.error(`Could not parse status output: ${JSON.stringify(h.trim())}`),this.G(P.TunnelStates.disconnected());return}if(g=D.service_installed,this.j.info(D.tunnel?"Other tunnel running, attaching...":"No other tunnel running"),!D.tunnel&&!this.n.active){this.G(P.TunnelStates.disconnected());return}}catch(D){this.j.error(D),this.G(P.TunnelStates.disconnected());return}finally{this.r===L&&(this.r=void 0)}const S=this.n.active?this.n.session:void 0;if(S&&S.token){const D=S.token;this.G(P.TunnelStates.connecting((0,d.localize)(1,null,S.accountLabel,S.providerId)));const M=(H,x)=>{H=H.replaceAll(D,"*".repeat(4)),R(H,x)},J=this.O("login",["user","login","--provider",S.providerId,"--log",(0,k.$ok)(this.j.getLevel())],M,{VSCODE_CLI_ACCESS_TOKEN:D});this.r=J;try{if(await J,this.r!==J)return}catch(H){this.j.error(H),this.r=void 0,this.f.fire(S),this.G(P.TunnelStates.disconnected(S));return}}const v=this.Q();v?this.G(P.TunnelStates.connecting((0,d.localize)(2,null,v))):this.G(P.TunnelStates.connecting((0,d.localize)(3,null)));const C=["--accept-server-license-terms","--log",(0,k.$ok)(this.j.getLevel())];v?C.push("--name",v):C.push("--random-name");let F=!1;return this.n.active&&this.n.asService&&!g&&(F=await this.M(C)===!1),this.N(S,C,F)}async M(h){let g;try{g=await this.O("serviceInstall",["service","install",...h])}catch(R){this.j.error(R),g=1}if(g!==0){const R=(0,d.localize)(4,null);return this.j.warn(R),this.G(P.TunnelStates.connecting(R)),!1}return!0}async N(h,g,R){g.push("--parent-process-id",String(process.pid)),this.P()&&g.push("--no-sleep");let L=!1;const S=this.O("tunnel",g,(v,C)=>{C?this.j.error(v):this.j.info(v),v.includes("Connected to an existing tunnel process")&&(L=!0);const F=v.match(/Open this link in your browser (https:\/\/([^\/\s]+)\/([^\/\s]+)\/([^\/\s]+))/);if(F){const D={link:F[1],domain:F[2],tunnelName:F[4],isAttached:L};this.G(P.TunnelStates.connected(D,R))}else v.match(/error refreshing token/)&&(S.cancel(),this.f.fire(h),this.G(P.TunnelStates.disconnected(h)))});this.r=S,S.finally(()=>{S===this.r&&(this.j.info("tunnel process terminated"),this.r=void 0,this.n=P.$7gc,this.G(P.TunnelStates.disconnected()))})}O(h,g,R=this.I,L){return(0,u.$sh)(S=>new Promise((v,C)=>{S.isCancellationRequested&&v(-1);let F;const D=["ignore","pipe","pipe"];if(S.onCancellationRequested(()=>{F&&(this.j.info(`${h} terminating(${F.pid})`),F.kill())}),!this.C.isBuilt)R(`Building tunnel CLI from sources and run
`,!1),R(`${h} Spawning: cargo run -- tunnel ${g.join(" ")}
`,!1),F=(0,w.spawn)("cargo",["run","--","tunnel",...g],{cwd:(0,A.$lc)(this.C.appRoot,"cli"),stdio:D,env:{...process.env,RUST_BACKTRACE:"1",...L}});else{R(`Running tunnel CLI
`,!1);const M=this.J();R(`${h} Spawning: ${M} tunnel ${g.join(" ")}
`,!1),F=(0,w.spawn)(M,["tunnel",...g],{cwd:(0,y.homedir)(),stdio:D,env:{...process.env,...L}})}F.stdout.pipe(new I.$vX(`
`)).on("data",M=>{if(F){const J=M.toString();R(J,!1)}}),F.stderr.pipe(new I.$vX(`
`)).on("data",M=>{if(F){const J=M.toString();R(J,!0)}}),F.on("exit",M=>{F&&(R(`${h} exit(${F.pid}): + ${M} `,!1),F=void 0,v(M||0))}),F.on("error",M=>{F&&(R(`${h} error(${F.pid}): + ${M} `,!0),F=void 0,C())})}))}async getTunnelName(){return this.Q()}P(){return!!this.D.getValue(P.$0gc)}Q(){let h=this.D.getValue(P.$9gc)||(0,y.hostname)();return h=h.replace(/^-+/g,"").replace(/[^\w-]/g,"").substring(0,20),h||void 0}R(){try{const h=this.F.get(r,f.StorageScope.APPLICATION),g=this.F.getBoolean(i,f.StorageScope.APPLICATION,!1);if(h){const R=JSON.parse(h);if(R&&(0,b.$fg)(R.accountLabel)&&(0,b.$fg)(R.sessionId)&&(0,b.$fg)(R.providerId))return{active:!0,session:R,asService:g};this.j.error("Problems restoring session from storage, invalid format",R)}}catch(h){this.j.error("Problems restoring session from storage",h)}return P.$7gc}S(h){if(h.active){const g={providerId:h.session.providerId,sessionId:h.session.sessionId,accountLabel:h.session.accountLabel};this.F.store(r,JSON.stringify(g),f.StorageScope.APPLICATION,f.StorageTarget.MACHINE),this.F.store(i,h.asService,f.StorageScope.APPLICATION,f.StorageTarget.MACHINE)}else this.F.remove(r,f.StorageScope.APPLICATION),this.F.remove(i,f.StorageScope.APPLICATION)}};e.$dhc=a,e.$dhc=a=ve([Y(0,N.$$l),Y(1,E.$sk),Y(2,O.$Ni),Y(3,k.$ak),Y(4,p.$bhc),Y(5,l.$_i),Y(6,f.$bq)],a);function t(o,h){return o&&h?o.sessionId===h.sessionId&&o.providerId===h.providerId&&o.token===h.token:o===h}const n=(o,h)=>o.active!==h.active?!1:o.active&&h.active?o.asService===h.asService&&t(o.session,h.session):!0}),define(ce[261],le([0,1,6,2,23,21,71,17,80,20]),function(ne,e,P,c,N,O,T,k,A,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ihc=void 0;class E extends k.$dq{constructor(u,p,l,d){super(),this.bb=u,this.cb=p,this.db=l,this.eb=d,this.s=this.cb.defaultProfile,this.U=this.fb(),this.W=this.cb.currentProfile,this.X=this.B(new c.$Vc),this.Y=this.gb(this.W),this.Z=this.bb?.id,this.$=this.B(new c.$Vc),this.ab=this.hb(this.bb)}fb(){const u=this.B(new A.$sMb(this.db.getChannel("storage"))),p=this.B(new T.$0p(u));return this.B(p.onDidChangeStorage(l=>this.u(k.StorageScope.APPLICATION,l))),p}gb(u){this.X.clear(),this.W=u;let p;if((0,k.$eq)(u))p=this.U;else{const l=this.X.add(new A.$tMb(this.db.getChannel("storage"),u));p=this.X.add(new T.$0p(l))}return this.X.add(p.onDidChangeStorage(l=>this.u(k.StorageScope.PROFILE,l))),p}hb(u){this.$.clear(),this.Z=u?.id;let p;if(u){const l=this.$.add(new A.$uMb(this.db.getChannel("storage"),u));p=this.$.add(new T.$0p(l)),this.$.add(p.onDidChangeStorage(d=>this.u(k.StorageScope.WORKSPACE,d)))}return p}async O(){await P.Promises.settled([this.U.init(),this.Y.init(),this.ab?.init()??Promise.resolve()])}P(u){switch(u){case k.StorageScope.APPLICATION:return this.U;case k.StorageScope.PROFILE:return this.Y;default:return this.ab}}Q(u){switch(u){case k.StorageScope.APPLICATION:return this.s.globalStorageHome.with({scheme:N.Schemas.file}).fsPath;case k.StorageScope.PROFILE:return this.W?.globalStorageHome.with({scheme:N.Schemas.file}).fsPath;default:return this.Z?`${(0,O.$gh)(this.eb.workspaceStorageHome,this.Z,"state.vscdb").with({scheme:N.Schemas.file}).fsPath}`:void 0}}async close(){this.t(),this.w(k.WillSaveStateReason.SHUTDOWN),await P.Promises.settled([this.U.close(),this.Y.close(),this.ab?.close()??Promise.resolve()])}async R(u){if(!this.M(this.W,u))return;const p=this.Y,l=p.items;p!==this.U&&await p.close(),this.Y=this.gb(u),await this.Y.init(),this.N(l,this.Y,k.StorageScope.PROFILE)}async S(u,p){const l=this.ab,d=l?.items??new Map;await l?.close(),this.ab=this.hb(u),await this.ab.init(),this.N(d,this.ab,k.StorageScope.WORKSPACE)}hasScope(u){return(0,w.$Kl)(u)?this.W.id===u.id:this.Z===u.id}}e.$ihc=E}),define(ce[262],le([0,1,3,2,20,95]),function(ne,e,P,c,N,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sR=e.$rR=void 0;class T{constructor(w,E){this.a=w,this.b=E}listen(w,E){const $=this.b(w);switch(E){case"onDidChangeProfiles":return P.Event.map(this.a.onDidChangeProfiles,u=>({all:u.all.map(p=>(0,O.$Ln)({...p},$)),added:u.added.map(p=>(0,O.$Ln)({...p},$)),removed:u.removed.map(p=>(0,O.$Ln)({...p},$)),updated:u.updated.map(p=>(0,O.$Ln)({...p},$))}))}throw new Error(`Invalid listen ${E}`)}async call(w,E,$){const u=this.b(w);switch(E){case"createProfile":{const p=await this.a.createProfile($[0],$[1],$[2]);return(0,O.$Ln)({...p},u)}case"updateProfile":{let p=(0,N.$Ml)((0,O.$Mn)($[0],u),this.a.profilesHome.scheme);return p=await this.a.updateProfile(p,$[1]),(0,O.$Ln)({...p},u)}case"removeProfile":{const p=(0,N.$Ml)((0,O.$Mn)($[0],u),this.a.profilesHome.scheme);return this.a.removeProfile(p)}}throw new Error(`Invalid call ${E}`)}}e.$rR=T;class k extends c.$Wc{get defaultProfile(){return this.profiles[0]}get profiles(){return this.a}constructor(w,E,$){super(),this.profilesHome=E,this.f=$,this.a=[],this.b=this.B(new P.$me),this.onDidChangeProfiles=this.b.event,this.c=!0,this.a=w.map(u=>(0,N.$Ml)(u,this.profilesHome.scheme)),this.B(this.f.listen("onDidChangeProfiles")(u=>{const p=u.added.map(y=>(0,N.$Ml)(y,this.profilesHome.scheme)),l=u.removed.map(y=>(0,N.$Ml)(y,this.profilesHome.scheme)),d=u.updated.map(y=>(0,N.$Ml)(y,this.profilesHome.scheme));this.a=u.all.map(y=>(0,N.$Ml)(y,this.profilesHome.scheme)),this.b.fire({added:p,removed:l,updated:d,all:this.profiles})})),this.onDidResetWorkspaces=this.f.listen("onDidResetWorkspaces")}setEnablement(w){this.c=w}isEnabled(){return this.c}async createNamedProfile(w,E,$){const u=await this.f.call("createNamedProfile",[w,E,$]);return(0,N.$Ml)(u,this.profilesHome.scheme)}async createProfile(w,E,$,u){const p=await this.f.call("createProfile",[w,E,$,u]);return(0,N.$Ml)(p,this.profilesHome.scheme)}async createTransientProfile(w){const E=await this.f.call("createTransientProfile",[w]);return(0,N.$Ml)(E,this.profilesHome.scheme)}async setProfileForWorkspace(w,E){await this.f.call("setProfileForWorkspace",[w,E])}removeProfile(w){return this.f.call("removeProfile",[w])}async updateProfile(w,E){const $=await this.f.call("updateProfile",[w,E]);return(0,N.$Ml)($,this.profilesHome.scheme)}resetWorkspaces(){return this.f.call("resetWorkspaces")}cleanUp(){return this.f.call("cleanUp")}cleanUpTransientProfiles(){return this.f.call("cleanUpTransientProfiles")}}e.$sR=k}),define(ce[62],le([0,1,2,71,4,17,3,80,20]),function(ne,e,P,c,N,O,T,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yMb=e.$xMb=e.$wMb=void 0,e.$wMb=(0,N.$Fi)("IUserDataProfileStorageService");let w=class extends P.$Wc{constructor(p,l){super(),this.b=l,p&&(this.a=this.B(new P.$6c))}async readStorageData(p){return this.withProfileScopedStorageService(p,async l=>this.c(l))}async updateStorageData(p,l,d){return this.withProfileScopedStorageService(p,async y=>this.f(y,l,d))}async withProfileScopedStorageService(p,l){if(this.b.hasScope(p))return l(this.b);let d=this.a?.get(p.id);if(!d){d=new $(this.g(p)),this.a?.set(p.id,d);try{await d.initialize()}catch(y){throw this.a?.has(p.id)?this.a.deleteAndDispose(p.id):d.dispose(),y}}try{const y=await l(d);return await d.flush(),y}finally{this.a?.has(p.id)||d.dispose()}}c(p){const l=new Map,d=y=>{for(const f of p.keys(O.StorageScope.PROFILE,y))l.set(f,{value:p.get(f,O.StorageScope.PROFILE),target:y})};return d(O.StorageTarget.USER),d(O.StorageTarget.MACHINE),l}f(p,l,d){p.storeAll(Array.from(l.entries()).map(([y,f])=>({key:y,value:f,scope:O.StorageScope.PROFILE,target:d})),!0)}};e.$xMb=w,e.$xMb=w=ve([Y(1,O.$bq)],w);class E extends w{constructor(p,l,d,y,f){super(p,y),this.j=l;const b=l.getChannel("profileStorageListener"),I=this.B(new P.$Xc);this.h=this.B(new T.$me({onWillAddFirstListener:()=>{I.value=b.listen("onDidChange")(m=>{f.trace("profile storage changes",m),this.h.fire({targetChanges:m.targetChanges.map(s=>(0,A.$Ml)(s,d.profilesHome.scheme)),valueChanges:m.valueChanges.map(s=>({...s,profile:(0,A.$Ml)(s.profile,d.profilesHome.scheme)}))})})},onDidRemoveLastListener:()=>I.value=void 0})),this.onDidChange=this.h.event}async g(p){const l=this.j.getChannel("storage");return(0,O.$eq)(p)?new k.$sMb(l):new k.$tMb(l,p)}}e.$yMb=E;class $ extends O.$dq{constructor(p){super({flushInterval:100}),this.U=p}async O(){const p=await this.U,l=new c.$0p(p);return this.B(l.onDidChangeStorage(d=>{this.u(O.StorageScope.PROFILE,d)})),this.B((0,P.$Uc)(()=>{l.close(),l.dispose(),(0,P.$Qc)(p)&&p.dispose()})),this.s=l,this.s.init()}P(p){return p===O.StorageScope.PROFILE?this.s:void 0}Q(){}async R(){}async S(){}hasScope(){return!1}}}),define(ce[263],le([0,1,17,10,20,58,62]),function(ne,e,P,c,N,O,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zgc=void 0;let k=class extends T.$yMb{constructor(w,E,$,u){super(!0,w,E,$,u)}};e.$Zgc=k,e.$Zgc=k=ve([Y(0,O.$ugc),Y(1,N.$Ll),Y(2,P.$bq),Y(3,c.$_j)],k)}),define(ce[40],le([0,1,19,6,15,26,3,34,2,27,13,181,22,16,7,10,50,17,18,29,25,20]),function(ne,e,P,c,N,O,T,k,A,w,E,$,u,p,l,d,y,f,b,I,m,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$FNb=e.$ENb=e.$DNb=e.$CNb=void 0,e.$zNb=r,e.$ANb=i,e.$BNb=a;function r(g){return!!(g&&g.ref!==void 0&&typeof g.ref=="string"&&g.ref!==""&&g.syncData!==void 0&&(g.syncData===null||i(g.syncData)))}function i(g){return!!(g&&g.version!==void 0&&typeof g.version=="number"&&g.content!==void 0&&typeof g.content=="string"&&(Object.keys(g).length===2||Object.keys(g).length===3&&g.machineId!==void 0&&typeof g.machineId=="string"))}function a(g,R){return`${(0,w.$0f)(g)}${R.isDefault?"":` (${R.name})`}`}let t=class extends A.$Wc{get status(){return this.m}get conflicts(){return{...this.syncResource,conflicts:this.s}}constructor(R,L,S,v,C,F,D,M,J,H,x,K){super(),this.syncResource=R,this.collection=L,this.G=S,this.H=v,this.I=C,this.J=F,this.L=D,this.M=M,this.N=J,this.O=H,this.P=x,this.c=null,this.m=m.SyncStatus.Idle,this.n=this.B(new T.$me),this.onDidChangeStatus=this.n.event,this.s=[],this.t=this.B(new T.$me),this.onDidChangeConflicts=this.t.event,this.u=this.B(new c.$Dh(50)),this.w=this.B(new T.$me),this.onDidChangeLocal=this.w.event,this.z=`${this.collection?`${this.collection}.`:""}${this.syncResource.syncResource}.lastSyncUserData`,this.C=!1,this.F={},this.resource=this.syncResource.syncResource,this.D=a(R.syncResource,R.profile),this.h=K.extUri,this.f=this.h.joinPath(v.userDataSyncHome,...(0,m.$0mb)(R.profile.isDefault?void 0:R.profile.id,R.syncResource)),this.g=this.h.joinPath(this.f,m.$snb),this.y=(0,m.$$mb)(R.profile.isDefault?void 0:R.profile.id,R.syncResource,v,this.h),this.j=(0,y.$hq)(v,S,C)}Q(){this.u.trigger(()=>this.R())}async R(){if(this.status===m.SyncStatus.HasConflicts){this.O.info(`${this.D}: In conflicts state and local change detected. Syncing again...`);const R=await this.c;this.c=null;const L=await this.Y(R.remoteUserData,R.lastSyncUserData,!0,this.ob());this.S(L)}else{this.O.trace(`${this.D}: Checking for local changes...`);const R=await this.getLastSyncUserData();(R?await this.ub(R):!0)&&this.w.fire()}}S(R){this.m!==R&&(this.m=R,this.n.fire(R))}async sync(R,L={}){await this.U(R,!0,this.ob(),L)}async preview(R,L,S={}){return this.U(R,!1,L,S)}async apply(R,L={}){try{this.F={...L};const S=await this.ab(R);return this.S(S),this.c}finally{this.F={}}}async U(R,L,S,v){try{if(this.F={...v},this.status===m.SyncStatus.HasConflicts)return this.O.info(`${this.D}: Skipped synchronizing ${this.resource.toLowerCase()} as there are conflicts.`),this.c;if(this.status===m.SyncStatus.Syncing)return this.O.info(`${this.D}: Skipped synchronizing ${this.resource.toLowerCase()} as it is running already.`),this.c;this.O.trace(`${this.D}: Started synchronizing ${this.resource.toLowerCase()}...`),this.S(m.SyncStatus.Syncing);let C=m.SyncStatus.Idle;try{const F=await this.getLastSyncUserData(),D=await this.X(R,F);return C=await this.Y(D,F,L,S),C===m.SyncStatus.HasConflicts?this.O.info(`${this.D}: Detected conflicts while synchronizing ${this.resource.toLowerCase()}.`):C===m.SyncStatus.Idle&&this.O.trace(`${this.D}: Finished synchronizing ${this.resource.toLowerCase()}.`),this.c||null}finally{this.S(C)}}finally{this.F={}}}async replace(R){const L=this.kb(R);if(!L)return!1;await this.stop();try{this.O.trace(`${this.D}: Started resetting ${this.resource.toLowerCase()}...`),this.S(m.SyncStatus.Syncing);const S=await this.getLastSyncUserData(),v=await this.X(null,S),C=await this.W(v),F=await this.qb({ref:v.ref,syncData:L},S,C,this.ob(),O.CancellationToken.None),D=[];for(const M of F){const J=await this.sb(M,M.remoteResource,void 0,O.CancellationToken.None),{remoteChange:H}=await this.sb(M,M.previewResource,M.remoteContent,O.CancellationToken.None);D.push([M,{...J,remoteChange:H!==m.Change.None?H:m.Change.Modified}])}await this.tb(v,S,D,!1),this.O.info(`${this.D}: Finished resetting ${this.resource.toLowerCase()}.`)}finally{this.S(m.SyncStatus.Idle)}return!0}async W(R){const L=await this.j;return!!R.syncData?.machineId&&R.syncData.machineId===L}async X(R,L){if(L){const S=R?R[this.resource]:void 0;if(L.ref===S||S===void 0&&L.syncData===null)return L}return this.getRemoteUserData(L)}async Y(R,L,S,v){if(R.syncData&&R.syncData.version>this.pb)throw this.N.publicLog2("sync/incompatible",{source:this.resource}),new m.$fnb((0,$.localize)(0,null,this.resource,this.pb,R.syncData.version),m.UserDataSyncErrorCode.IncompatibleLocalContent,this.resource);try{return await this.Z(R,L,S,v)}catch(C){if(C instanceof m.$fnb)switch(C.code){case m.UserDataSyncErrorCode.LocalPreconditionFailed:return this.O.info(`${this.D}: Failed to synchronize ${this.D} as there is a new local version available. Synchronizing again...`),this.Y(R,L,S,v);case m.UserDataSyncErrorCode.Conflict:case m.UserDataSyncErrorCode.PreconditionFailed:return this.O.info(`${this.D}: Failed to synchronize as there is a new remote version available. Synchronizing again...`),R=await this.getRemoteUserData(null),L=await this.getLastSyncUserData(),this.Y(R,L,S,v)}throw C}}async Z(R,L,S,v){try{const C=await this.W(R),F=!C&&L===null&&this.gb()!==void 0,D=S&&!F;this.c||(this.c=(0,c.$sh)(J=>this.eb(R,L,C,D,v,J)));let M=await this.c;if(S&&F){this.O.info(`${this.D}: Accepting remote because it was synced before and the last sync data is not available.`);for(const J of M.resourcePreviews)M=await this.accept(J.remoteResource)||M}return this.cb(M.resourcePreviews),M.resourcePreviews.some(({mergeState:J})=>J===m.MergeState.Conflict)?m.SyncStatus.HasConflicts:S?await this.ab(!1):m.SyncStatus.Syncing}catch(C){throw this.c=null,C}}async merge(R){return await this.$(R,async L=>{const S=await this.rb(L,O.CancellationToken.None);await this.G.writeFile(L.previewResource,N.$Oe.fromString(S?.content||""));const v=S&&!S.hasConflicts?await this.sb(L,L.previewResource,void 0,O.CancellationToken.None):void 0;return L.acceptResult=v,L.mergeState=S.hasConflicts?m.MergeState.Conflict:v?m.MergeState.Accepted:m.MergeState.Preview,L.localChange=v?v.localChange:S.localChange,L.remoteChange=v?v.remoteChange:S.remoteChange,L}),this.c}async accept(R,L){return await this.$(R,async S=>{const v=await this.sb(S,R,L,O.CancellationToken.None);return S.acceptResult=v,S.mergeState=m.MergeState.Accepted,S.localChange=v.localChange,S.remoteChange=v.remoteChange,S}),this.c}async discard(R){return await this.$(R,async L=>{const S=await this.rb(L,O.CancellationToken.None);return await this.G.writeFile(L.previewResource,N.$Oe.fromString(S.content||"")),L.acceptResult=void 0,L.mergeState=m.MergeState.Preview,L.localChange=S.localChange,L.remoteChange=S.remoteChange,L}),this.c}async $(R,L){if(!this.c)return;let S=await this.c;const v=S.resourcePreviews.findIndex(({localResource:C,remoteResource:F,previewResource:D})=>this.h.isEqual(C,R)||this.h.isEqual(F,R)||this.h.isEqual(D,R));v!==-1&&(this.c=(0,c.$sh)(async C=>{const F=[...S.resourcePreviews];return F[v]=await L(F[v]),{...S,resourcePreviews:F}}),S=await this.c,this.cb(S.resourcePreviews),S.resourcePreviews.some(({mergeState:C})=>C===m.MergeState.Conflict)?this.S(m.SyncStatus.HasConflicts):this.S(m.SyncStatus.Syncing))}async ab(R){if(!this.c)return m.SyncStatus.Idle;const L=await this.c;return L.resourcePreviews.some(({mergeState:S})=>S===m.MergeState.Conflict)?m.SyncStatus.HasConflicts:L.resourcePreviews.some(({mergeState:S})=>S!==m.MergeState.Accepted)?m.SyncStatus.Syncing:(await this.tb(L.remoteUserData,L.lastSyncUserData,L.resourcePreviews.map(S=>[S,S.acceptResult]),R),this.c=null,await this.bb(),m.SyncStatus.Idle)}async bb(){try{await this.G.del(this.g,{recursive:!0})}catch{}}cb(R){const L=R.filter(({mergeState:S})=>S===m.MergeState.Conflict);(0,P.$wb)(this.s,L,(S,v)=>this.h.isEqual(S.previewResource,v.previewResource))||(this.s=L,this.t.fire(this.conflicts))}async hasPreviouslySynced(){const R=await this.getLastSyncUserData();return!!R&&R.syncData!==null}async db(R){const L=this.c?await this.c:null;if(L)for(const S of L.resourcePreviews){if(this.h.isEqual(S.acceptedResource,R))return S.acceptResult?S.acceptResult.content:null;if(this.h.isEqual(S.remoteResource,R))return S.remoteContent;if(this.h.isEqual(S.localResource,R))return S.localContent;if(this.h.isEqual(S.baseResource,R))return S.baseContent}return null}async resetLocal(){this.I.remove(this.z,f.StorageScope.APPLICATION);try{await this.G.del(this.y)}catch(R){(0,l.$ql)(R)!==l.FileOperationResult.FILE_NOT_FOUND&&this.O.error(R)}}async eb(R,L,S,v,C,F){const D=await this.qb(R,L,S,C,F),M=[];for(const J of D){const H=J.previewResource.with({scheme:m.$rnb,authority:"accepted"});if(J.localChange===m.Change.None&&J.remoteChange===m.Change.None)M.push({...J,acceptedResource:H,acceptResult:{content:null,localChange:m.Change.None,remoteChange:m.Change.None},mergeState:m.MergeState.Accepted});else{const x=v?await this.rb(J,F):void 0;if(F.isCancellationRequested)break;await this.G.writeFile(J.previewResource,N.$Oe.fromString(x?.content||""));const K=x&&!x.hasConflicts?await this.sb(J,J.previewResource,void 0,F):void 0;M.push({...J,acceptResult:K,mergeState:x?.hasConflicts?m.MergeState.Conflict:K?m.MergeState.Accepted:m.MergeState.Preview,localChange:K?K.localChange:x?x.localChange:J.localChange,remoteChange:K?K.remoteChange:x?x.remoteChange:J.remoteChange})}}return{syncResource:this.resource,profile:this.syncResource.profile,remoteUserData:R,lastSyncUserData:L,resourcePreviews:M,isLastSyncFromCurrentMachine:S}}async getLastSyncUserData(){let R=this.gb();if(R||(R=await this.jb()),!R)return this.O.info(`${this.D}: Last sync data state does not exist.`),null;const L=JSON.parse(R),S=this.M.getResourceSyncStateVersion(this.resource);if(this.C=!!L.version&&!!S&&L.version!==S,this.C)return this.O.info(`${this.D}: Reset last sync state because last sync state version ${L.version} is not compatible with current sync state version ${S}.`),await this.resetLocal(),null;let v,C=1;for(;v===void 0&&C++<6;)try{const F=await this.hb();F&&(F.ref===L.ref?v=F.syncData:this.O.info(`${this.D}: Last sync data stored locally is not same as the last sync state.`));break}catch(F){if(F instanceof l.$ul&&F.fileOperationResult===l.FileOperationResult.FILE_NOT_FOUND){this.O.info(`${this.D}: Last sync resource does not exist locally.`);break}else{if(F instanceof m.$fnb)throw F;this.O.error(F,C)}}if(v===void 0)try{const F=await this.J.resolveResourceContent(this.resource,L.ref,this.collection,this.F);v=F===null?null:this.kb(F),await this.ib({ref:L.ref,syncData:v})}catch(F){if(F instanceof m.$fnb&&F.code===m.UserDataSyncErrorCode.NotFound)this.O.info(`${this.D}: Last sync resource does not exist remotely.`);else throw F}return v===void 0?null:{...L,syncData:v}}async fb(R,L={}){if(L.ref||L.version)throw new Error("Cannot have core properties as additional");const S=this.M.getResourceSyncStateVersion(this.resource),v={ref:R.ref,version:S,...L};this.I.store(this.z,JSON.stringify(v),f.StorageScope.APPLICATION,f.StorageTarget.MACHINE),await this.ib(R)}gb(){return this.I.get(this.z,f.StorageScope.APPLICATION)}async hb(){const R=(await this.G.readFile(this.y)).value.toString();try{const L=R?JSON.parse(R):void 0;if(r(L))return L}catch(L){this.O.error(L)}}async ib(R){await this.G.writeFile(this.y,N.$Oe.fromString(JSON.stringify(R)))}async jb(){try{const R=await this.G.readFile(this.y),L=JSON.parse(R.value.toString());await this.G.del(this.y),L.ref&&L.content!==void 0?(this.I.store(this.z,JSON.stringify({...L,content:void 0}),f.StorageScope.APPLICATION,f.StorageTarget.MACHINE),await this.ib({ref:L.ref,syncData:L.content===null?null:JSON.parse(L.content)})):this.O.info(`${this.D}: Migrating last sync user data. Invalid data.`,L)}catch(R){R instanceof l.$ul&&R.fileOperationResult===l.FileOperationResult.FILE_NOT_FOUND?this.O.info(`${this.D}: Migrating last sync user data. Resource does not exist.`):this.O.error(R)}return this.I.get(this.z,f.StorageScope.APPLICATION)}async getRemoteUserData(R){const{ref:L,content:S}=await this.lb(R);let v=null;return S!==null&&(v=this.kb(S)),{ref:L,syncData:v}}kb(R){try{const L=JSON.parse(R);if(i(L))return L}catch(L){this.O.error(L)}throw new m.$fnb((0,$.localize)(1,null),m.UserDataSyncErrorCode.IncompatibleRemoteContent,this.resource)}async lb(R){const L=R?{ref:R.ref,content:R.syncData?JSON.stringify(R.syncData):null}:null;return this.J.readResource(this.resource,L,this.collection,this.F)}async mb(R,L){const S=await this.j,v={version:this.pb,machineId:S,content:R};try{return L=await this.J.writeResource(this.resource,JSON.stringify(v),L,this.collection,this.F),{ref:L,syncData:v}}catch(C){throw C instanceof m.$fnb&&C.code===m.UserDataSyncErrorCode.TooLarge&&(C=new m.$fnb(C.message,C.code,this.resource)),C}}async nb(R){const L={version:this.pb,content:R};return this.L.writeResource(this.resource,JSON.stringify(L),new Date,this.syncResource.profile.isDefault?void 0:this.syncResource.profile.id)}async stop(){this.status!==m.SyncStatus.Idle&&(this.O.trace(`${this.D}: Stopping synchronizing ${this.resource.toLowerCase()}.`),this.c&&(this.c.cancel(),this.c=null),this.cb([]),await this.bb(),this.S(m.SyncStatus.Idle),this.O.info(`${this.D}: Stopped synchronizing ${this.resource.toLowerCase()}.`))}ob(){return this.P.getValue(m.$5mb)}};e.$CNb=t,e.$CNb=t=ve([Y(2,l.$_k),Y(3,p.$Mi),Y(4,f.$bq),Y(5,m.$anb),Y(6,m.$bnb),Y(7,m.$knb),Y(8,b.$$l),Y(9,m.$pnb),Y(10,u.$_i),Y(11,I.$Jl)],t);let n=class extends t{constructor(R,L,S,v,C,F,D,M,J,H,x,K,ie){super(L,S,v,C,F,D,M,J,H,x,K,ie),this.r=R,this.B(this.G.watch(this.h.dirname(R))),this.B(this.G.onDidFilesChange(V=>this.yb(V)))}async vb(){try{return await this.G.readFile(this.r)}catch{return null}}async wb(R,L,S){try{L?await this.G.writeFile(this.r,N.$Oe.fromString(R),S?void 0:L):await this.G.createFile(this.r,N.$Oe.fromString(R),{overwrite:S})}catch(v){throw v instanceof l.$ul&&v.fileOperationResult===l.FileOperationResult.FILE_NOT_FOUND||v instanceof l.$ul&&v.fileOperationResult===l.FileOperationResult.FILE_MODIFIED_SINCE?new m.$fnb(v.message,m.UserDataSyncErrorCode.LocalPreconditionFailed):v}}async xb(){try{await this.G.del(this.r)}catch(R){if(!(R instanceof l.$ul&&R.fileOperationResult===l.FileOperationResult.FILE_NOT_FOUND))throw R}}yb(R){R.contains(this.r)&&this.Q()}};e.$DNb=n,e.$DNb=n=ve([Y(3,l.$_k),Y(4,p.$Mi),Y(5,f.$bq),Y(6,m.$anb),Y(7,m.$bnb),Y(8,m.$knb),Y(9,b.$$l),Y(10,m.$pnb),Y(11,u.$_i),Y(12,I.$Jl)],n);let o=class extends n{constructor(R,L,S,v,C,F,D,M,J,H,x,K,ie,V){super(R,L,S,v,C,F,D,M,J,H,x,ie,V),this.zb=K,this.Bb=void 0}Ab(R,L){const S=[],v=(0,k.$Vn)(R,S,{allowEmptyContent:!0,allowTrailingComma:!0});return S.length>0||!(0,E.$mg)(v)&&L!==Array.isArray(v)}Cb(){return this.Bb||(this.Bb=this.zb.resolveFormattingOptions(this.r)),this.Bb}};e.$ENb=o,e.$ENb=o=ve([Y(3,l.$_k),Y(4,p.$Mi),Y(5,f.$bq),Y(6,m.$anb),Y(7,m.$bnb),Y(8,m.$knb),Y(9,b.$$l),Y(10,m.$pnb),Y(11,m.$onb),Y(12,u.$_i),Y(13,I.$Jl)],o);let h=class{constructor(R,L,S,v,C,F,D){this.resource=R,this.g=L,this.h=S,this.j=v,this.k=C,this.l=F,this.d=D.extUri,this.f=(0,m.$$mb)(void 0,this.resource,S,this.d)}async initialize({ref:R,content:L}){if(!L){this.j.info("Remote content does not exist.",this.resource);return}const S=this.m(L);if(S)try{await this.o({ref:R,syncData:S})}catch(v){this.j.error(v)}}m(R){try{const L=JSON.parse(R);if(i(L))return L}catch(L){this.j.error(L)}this.j.info("Cannot parse sync data as it is not compatible with the current version.",this.resource)}async n(R,L={}){if(L.ref||L.version)throw new Error("Cannot have core properties as additional");const S={ref:R.ref,version:void 0,...L};this.l.store(`${this.resource}.lastSyncUserData`,JSON.stringify(S),f.StorageScope.APPLICATION,f.StorageTarget.MACHINE),await this.k.writeFile(this.f,N.$Oe.fromString(JSON.stringify(R)))}};e.$FNb=h,e.$FNb=h=ve([Y(1,s.$Ll),Y(2,p.$Mi),Y(3,d.$_j),Y(4,l.$_k),Y(5,f.$bq),Y(6,I.$Jl)],h)}),define(ce[120],le([0,1,6,26,8,3,45,2,27,22,16,119,28,33,86,37,7,4,77,10,17,18,29,20,40,242,115,25,62]),function(ne,e,P,c,N,O,T,k,A,w,E,$,u,p,l,d,y,f,b,I,m,s,r,i,a,t,n,o,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dbc=e.$Cbc=e.$Bbc=void 0,e.$zbc=R,e.$Abc=L;async function g(F,D){const M=JSON.parse(F.content);if(F.version===1||F.version===2){const J=(await D.getInstalled(d.ExtensionType.System)).filter(H=>H.isBuiltin);for(const H of M)F.version===1&&(H.enabled===!1&&(H.disabled=!0),delete H.enabled),F.version===2&&J.every(x=>!(0,p.$Hp)(x.identifier,H.identifier))&&(H.installed=!0)}return M}function R(F){return JSON.parse(F.content)}function L(F,D){return F.sort((M,J)=>!M.identifier.uuid&&J.identifier.uuid?-1:M.identifier.uuid&&!J.identifier.uuid?1:(0,A.$zf)(M.identifier.id,J.identifier.id)),D?(0,T.$6n)(F,{}):JSON.stringify(F)}let S=class extends a.$CNb{constructor(D,M,J,H,x,K,ie,V,z,ee,se,he,q,Z,X,G,U){super({syncResource:o.SyncResource.Extensions,profile:D},M,H,J,x,K,ie,he,q,ee,se,X),this.Cb=V,this.Db=z,this.Eb=U,this.pb=6,this.wb=this.h.joinPath(this.g,"extensions.json"),this.xb=this.wb.with({scheme:o.$rnb,authority:"base"}),this.yb=this.wb.with({scheme:o.$rnb,authority:"local"}),this.zb=this.wb.with({scheme:o.$rnb,authority:"remote"}),this.Ab=this.wb.with({scheme:o.$rnb,authority:"accepted"}),this.Bb=this.Eb.createInstance(v),this.B(O.Event.any(O.Event.filter(this.Cb.onDidInstallExtensions,B=>B.some(({local:j})=>!!j)),O.Event.filter(this.Cb.onDidUninstallExtension,B=>!B.error),O.Event.filter(G.onDidChange,B=>B.valueChanges.some(({profile:j,changes:W})=>this.syncResource.profile.id===j.id&&W.some(te=>te.key===u.$kp))),Z.onDidChangeExtensionStorageToSync)(()=>this.Q()))}async qb(D,M){const J=D.syncData?await g(D.syncData,this.Cb):null,H=M?.skippedExtensions??[],x=M?.builtinExtensions??null,K=M?.syncData?await g(M.syncData,this.Cb):null,{localExtensions:ie,ignoredExtensions:V}=await this.Bb.getLocalExtensions(this.syncResource.profile);J?this.O.trace(`${this.D}: Merging remote extensions with local extensions...`):this.O.trace(`${this.D}: Remote extensions does not exist. Synchronizing extensions for the first time.`);const{local:z,remote:ee}=(0,t.$ybc)(ie,J,K,H,V,x),se={local:z,remote:ee,content:this.Hb(ie,z.added,z.updated,z.removed),localChange:z.added.length>0||z.removed.length>0||z.updated.length>0?o.Change.Modified:o.Change.None,remoteChange:ee!==null?o.Change.Modified:o.Change.None},he=this.Ob(ie,!1);return[{skippedExtensions:H,builtinExtensions:x,baseResource:this.xb,baseContent:K?this.Ob(K,!1):he,localResource:this.yb,localContent:he,localExtensions:ie,remoteResource:this.zb,remoteExtensions:J,remoteContent:J?this.Ob(J,!1):null,previewResource:this.wb,previewResult:se,localChange:se.localChange,remoteChange:se.remoteChange,acceptedResource:this.Ab}]}async ub(D){const M=D.syncData?await g(D.syncData,this.Cb):null,{localExtensions:J,ignoredExtensions:H}=await this.Bb.getLocalExtensions(this.syncResource.profile),{remote:x}=(0,t.$ybc)(J,M,M,D.skippedExtensions||[],H,D.builtinExtensions||[]);return x!==null}Hb(D,M,J,H){const x=[...M,...J],K=new Set,ie=V=>{K.add(V.id.toLowerCase()),V.uuid&&K.add(V.uuid)};x.forEach(({identifier:V})=>ie(V)),H.forEach(ie);for(const V of D)K.has(V.identifier.id.toLowerCase())||V.identifier.uuid&&K.has(V.identifier.uuid)||x.push(V);return this.Ob(x,!1)}async rb(D,M){return{...D.previewResult,hasConflicts:!1}}async sb(D,M,J,H){if(this.h.isEqual(M,this.yb))return this.Kb(D);if(this.h.isEqual(M,this.zb))return this.Lb(D);if(this.h.isEqual(M,this.wb))return D.previewResult;throw new Error(`Invalid Resource: ${M.toString()}`)}async Kb(D){const M=await this.Cb.getInstalled(void 0,this.syncResource.profile.extensionsResource),J=this.Db.getIgnoredExtensions(M),H=(0,t.$ybc)(D.localExtensions,null,null,D.skippedExtensions,J,D.builtinExtensions),{local:x,remote:K}=H;return{content:D.localContent,local:x,remote:K,localChange:x.added.length>0||x.removed.length>0||x.updated.length>0?o.Change.Modified:o.Change.None,remoteChange:K!==null?o.Change.Modified:o.Change.None}}async Lb(D){const M=await this.Cb.getInstalled(void 0,this.syncResource.profile.extensionsResource),J=this.Db.getIgnoredExtensions(M),H=D.remoteContent?JSON.parse(D.remoteContent):null;if(H!==null){const x=(0,t.$ybc)(D.localExtensions,H,D.localExtensions,[],J,D.builtinExtensions),{local:K,remote:ie}=x;return{content:D.remoteContent,local:K,remote:ie,localChange:K.added.length>0||K.removed.length>0||K.updated.length>0?o.Change.Modified:o.Change.None,remoteChange:ie!==null?o.Change.Modified:o.Change.None}}else return{content:D.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:o.Change.None,remoteChange:o.Change.None}}async tb(D,M,J,H){let{skippedExtensions:x,builtinExtensions:K,localExtensions:ie}=J[0][0];const{local:V,remote:z,localChange:ee,remoteChange:se}=J[0][1];if(ee===o.Change.None&&se===o.Change.None&&this.O.info(`${this.D}: No changes found during synchronizing extensions.`),ee!==o.Change.None&&(await this.nb(JSON.stringify(ie)),x=await this.Bb.updateLocalExtensions(V.added,V.removed,V.updated,x,this.syncResource.profile)),z){this.O.trace(`${this.D}: Updating remote extensions...`);const he=JSON.stringify(z.all);D=await this.mb(he,H?null:D.ref),this.O.info(`${this.D}: Updated remote extensions.${z.added.length?` Added: ${JSON.stringify(z.added.map(q=>q.identifier.id))}.`:""}${z.updated.length?` Updated: ${JSON.stringify(z.updated.map(q=>q.identifier.id))}.`:""}${z.removed.length?` Removed: ${JSON.stringify(z.removed.map(q=>q.identifier.id))}.`:""}`)}M?.ref!==D.ref&&(this.O.trace(`${this.D}: Updating last synchronized extensions...`),K=this.Nb(ie,K),await this.fb(D,{skippedExtensions:x,builtinExtensions:K}),this.O.info(`${this.D}: Updated last synchronized extensions.${x.length?` Skipped: ${JSON.stringify(x.map(he=>he.identifier.id))}.`:""}`))}Nb(D,M){const J=new Set,H=[];for(const x of D)J.add(x.identifier.id.toLowerCase()),x.installed||H.push(x.identifier);if(M)for(const x of M)J.has(x.id.toLowerCase())||H.push(x);return H}async resolveContent(D){if(this.h.isEqual(this.zb,D)||this.h.isEqual(this.xb,D)||this.h.isEqual(this.yb,D)||this.h.isEqual(this.Ab,D)){const M=await this.db(D);return M&&this.Ob(JSON.parse(M),!0)}return null}Ob(D,M){return L(D,M)}async hasLocalData(){try{const{localExtensions:D}=await this.Bb.getLocalExtensions(this.syncResource.profile);if(D.some(M=>M.installed||M.disabled))return!0}catch{}return!1}};e.$Bbc=S,e.$Bbc=S=ve([Y(2,E.$Mi),Y(3,y.$_k),Y(4,m.$bq),Y(5,o.$anb),Y(6,o.$bnb),Y(7,u.$jp),Y(8,n.$oOb),Y(9,o.$pnb),Y(10,w.$_i),Y(11,o.$knb),Y(12,s.$$l),Y(13,l.$iw),Y(14,r.$Jl),Y(15,h.$wMb),Y(16,f.$Ei)],S);let v=class{constructor(D,M,J,H,x,K){this.a=D,this.b=M,this.c=J,this.d=H,this.f=x,this.g=K}async getLocalExtensions(D){const M=await this.a.getInstalled(void 0,D.extensionsResource),J=this.d.getIgnoredExtensions(M);return{localExtensions:await this.j(D,async(x,K)=>{const ie=x.getDisabledExtensions();return M.map(V=>{const{identifier:z,isBuiltin:ee,manifest:se,preRelease:he,pinned:q,isApplicationScoped:Z}=V,X={identifier:z,preRelease:he,version:se.version,pinned:!!q};Z&&!(0,d.$tn)(se)&&(X.isApplicationScoped=Z),ie.some(G=>(0,p.$Hp)(G,z))&&(X.disabled=!0),ee||(X.installed=!0);try{const G=K.getKeysForSync({id:z.id,version:se.version});if(G){const U=K.getExtensionState(V,!0)||{};X.state=Object.keys(U).reduce((B,j)=>(G.includes(j)&&(B[j]=U[j]),B),{})}}catch(G){this.g.info(`${(0,a.$BNb)(o.SyncResource.Extensions,D)}: Error while parsing extension state`,(0,N.$_)(G))}return X})}),ignoredExtensions:J}}async updateLocalExtensions(D,M,J,H,x){const K=(0,a.$BNb)(o.SyncResource.Extensions,x),ie=[],V=new Map,z=[],ee=[],se=await this.a.getInstalled(void 0,x.extensionsResource);if((D.length||J.length)&&await this.j(x,async(Z,X)=>{await P.Promises.settled([...D,...J].map(async G=>{const U=se.find(W=>(0,p.$Hp)(W.identifier,G.identifier));if(U&&U.isBuiltin){G.state&&U.manifest.version===G.version&&this.h(G.state,U,U.manifest.version,X),Z.getDisabledExtensions().some(te=>(0,p.$Hp)(te,G.identifier))!==!!G.disabled&&(G.disabled?(this.g.trace(`${K}: Disabling extension...`,G.identifier.id),await Z.disableExtension(G.identifier),this.g.info(`${K}: Disabled extension`,G.identifier.id)):(this.g.trace(`${K}: Enabling extension...`,G.identifier.id),await Z.enableExtension(G.identifier),this.g.info(`${K}: Enabled extension`,G.identifier.id))),z.push(G.identifier);return}const B=G.pinned?G.version:void 0,j=(await this.c.getExtensions([{...G.identifier,version:B,preRelease:B?void 0:G.preRelease}],c.CancellationToken.None))[0];if(G.state&&(U?U.manifest.version===G.version:j)&&this.h(G.state,U||j,U?.manifest.version,X),j)try{Z.getDisabledExtensions().some(te=>(0,p.$Hp)(te,G.identifier))!==!!G.disabled&&(G.disabled?(this.g.trace(`${K}: Disabling extension...`,G.identifier.id,j.version),await Z.disableExtension(j.identifier),this.g.info(`${K}: Disabled extension`,G.identifier.id,j.version)):(this.g.trace(`${K}: Enabling extension...`,G.identifier.id,j.version),await Z.enableExtension(j.identifier),this.g.info(`${K}: Enabled extension`,G.identifier.id,j.version))),(!U||U.preRelease!==G.preRelease||U.pinned!==G.pinned||B&&U.manifest.version!==B)&&(await this.a.canInstall(j)?(ie.push({extension:j,options:{isMachineScoped:!1,donotIncludePackAndDependencies:!0,installGivenVersion:G.pinned&&!!G.version,pinned:G.pinned,installPreReleaseVersion:G.preRelease,profileLocation:x.extensionsResource,isApplicationScoped:G.isApplicationScoped,context:{[u.$9o]:!0,[u.$0o]:u.ExtensionInstallSource.SETTINGS_SYNC}}}),V.set(j.identifier.id.toLowerCase(),G)):(this.g.info(`${K}: Skipped synchronizing extension because it cannot be installed.`,j.displayName||j.identifier.id),ee.push(G)))}catch(W){ee.push(G),this.g.error(W),this.g.info(`${K}: Skipped synchronizing extension`,j.displayName||j.identifier.id)}else ee.push(G),this.g.info(`${K}: Skipped synchronizing extension because the extension is not found.`,G.identifier.id)}))}),M.length){const Z=se.filter(({identifier:X,isBuiltin:G})=>!G&&M.some(U=>(0,p.$Hp)(X,U)));await P.Promises.settled(Z.map(async X=>{this.g.trace(`${K}: Uninstalling local extension...`,X.identifier.id),await this.a.uninstall(X,{donotIncludePack:!0,donotCheckDependents:!0,profileLocation:x.extensionsResource}),this.g.info(`${K}: Uninstalled local extension.`,X.identifier.id),z.push(X.identifier)}))}const he=await this.a.installGalleryExtensions(ie);for(const{identifier:Z,local:X,error:G,source:U}of he){const B=U;if(X)this.g.info(`${K}: Installed extension.`,Z.id,B.version),z.push(Z);else{const j=V.get(Z.id.toLowerCase());j&&(ee.push(j),this.g.info(`${K}: Skipped synchronizing extension`,B.displayName||B.identifier.id)),G instanceof u.$ip&&[u.ExtensionManagementErrorCode.Incompatible,u.ExtensionManagementErrorCode.IncompatibleTargetPlatform].includes(G.code)?this.g.info(`${K}: Skipped synchronizing extension because the compatible extension is not found.`,B.displayName||B.identifier.id):G&&this.g.error(G)}}const q=[];for(const Z of H)z.some(X=>(0,p.$Hp)(X,Z.identifier))||q.push(Z);for(const Z of ee)q.some(X=>(0,p.$Hp)(X.identifier,Z.identifier))||q.push(Z);return q}h(D,M,J,H){const x=H.getExtensionState(M,!0)||{},K=J?H.getKeysForSync({id:M.identifier.id,version:J}):void 0;K?K.forEach(ie=>{x[ie]=D[ie]}):Object.keys(D).forEach(ie=>x[ie]=D[ie]),H.setExtensionState(M,x,!0)}async j(D,M){return this.b.withProfileScopedStorageService(D,async J=>{const H=new k.$Vc,x=H.add(this.f.createChild(new b.$Di([m.$bq,J]))),K=H.add(x.createInstance($.$ULb)),ie=H.add(x.createInstance(l.$jw));try{return await M(K,ie)}finally{H.dispose()}})}};e.$Cbc=v,e.$Cbc=v=ve([Y(0,u.$jp),Y(1,h.$wMb),Y(2,u.$gp),Y(3,n.$oOb),Y(4,f.$Ei),Y(5,o.$pnb)],v);let C=class extends a.$FNb{constructor(D,M,J,H,x,K,ie,V){super(o.SyncResource.Extensions,H,x,K,J,ie,V),this.p=D,this.q=M}async t(D){return D.syncData?await g(D.syncData,this.p):null}u(D,M){const J=[],H=[],x=[];for(const K of D){if(this.q.hasToNeverSyncExtension(K.identifier.id))continue;const ie=M.find(V=>(0,p.$Hp)(V.identifier,K.identifier));ie?(J.push(ie),K.disabled&&x.push(K.identifier)):K.installed&&(H.push({...K.identifier,preRelease:!!K.preRelease}),K.disabled&&x.push(K.identifier))}return{installedExtensions:J,newExtensions:H,disabledExtensions:x,remoteExtensions:D}}};e.$Dbc=C,e.$Dbc=C=ve([Y(0,u.$jp),Y(1,n.$oOb),Y(2,y.$_k),Y(3,i.$Ll),Y(4,E.$Mi),Y(5,I.$_j),Y(6,m.$bq),Y(7,r.$Jl)],C)}),define(ce[121],le([0,1,15,8,3,34,45,5,32,22,16,7,10,50,17,18,29,40,82,246,25,20,62,4]),function(ne,e,P,c,N,O,T,k,A,w,E,$,u,p,l,d,y,f,b,I,m,s,r,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$LNb=e.$KNb=e.$JNb=e.$INb=void 0,e.$HNb=n;const a="globalState.argv.",t=["locale"];function n(S,v){const C=S.storage?Object.keys(S.storage).sort():[],F={};return C.forEach(D=>F[D]=S.storage[D]),S.storage=F,v?(0,T.$6n)(S,{}):JSON.stringify(S)}const o=1;let h=class extends f.$CNb{constructor(v,C,F,D,M,J,H,x,K,ie,V,z,ee,se){super({syncResource:m.SyncResource.GlobalState,profile:v},C,D,x,z,M,J,K,ie,H,V,ee),this.Bb=F,this.pb=o,this.vb=this.h.joinPath(this.g,"globalState.json"),this.wb=this.vb.with({scheme:m.$rnb,authority:"base"}),this.xb=this.vb.with({scheme:m.$rnb,authority:"local"}),this.yb=this.vb.with({scheme:m.$rnb,authority:"remote"}),this.zb=this.vb.with({scheme:m.$rnb,authority:"accepted"}),this.Ab=se.createInstance(g),this.B(D.watch(this.h.dirname(this.H.argvResource))),this.B(N.Event.any(N.Event.filter(D.onDidFilesChange,he=>he.contains(this.H.argvResource)),N.Event.filter(F.onDidChange,he=>!!(he.targetChanges.some(q=>this.syncResource.profile.id===q.id)||he.valueChanges.some(({profile:q,changes:Z})=>this.syncResource.profile.id===q.id&&Z.some(X=>X.target===l.StorageTarget.USER)))))(()=>this.Q()))}async qb(v,C,F){const D=v.syncData?JSON.parse(v.syncData.content):null;C=C===null&&F?v:C;const M=C&&C.syncData?JSON.parse(C.syncData.content):null,J=await this.Ab.getLocalGlobalState(this.syncResource.profile);D?this.O.trace(`${this.D}: Merging remote ui state with local ui state...`):this.O.trace(`${this.D}: Remote ui state does not exist. Synchronizing ui state for the first time.`);const H=await this.Jb(M),{local:x,remote:K}=(0,I.$GNb)(J.storage,D?D.storage:null,M?M.storage:null,H,this.O),ie={content:null,local:x,remote:K,localChange:Object.keys(x.added).length>0||Object.keys(x.updated).length>0||x.removed.length>0?m.Change.Modified:m.Change.None,remoteChange:K.all!==null?m.Change.Modified:m.Change.None},V=n(J,!1);return[{baseResource:this.wb,baseContent:M?n(M,!1):V,localResource:this.xb,localContent:V,localUserData:J,remoteResource:this.yb,remoteContent:D?n(D,!1):null,previewResource:this.vb,previewResult:ie,localChange:ie.localChange,remoteChange:ie.remoteChange,acceptedResource:this.zb,storageKeys:H}]}async ub(v){const C=v.syncData?JSON.parse(v.syncData.content):null;if(C===null)return!0;const F=await this.Ab.getLocalGlobalState(this.syncResource.profile),D=await this.Jb(C),{remote:M}=(0,I.$GNb)(F.storage,C.storage,C.storage,D,this.O);return M.all!==null}async rb(v,C){return{...v.previewResult,hasConflicts:!1}}async sb(v,C,F,D){if(this.h.isEqual(C,this.xb))return this.Gb(v);if(this.h.isEqual(C,this.yb))return this.Hb(v);if(this.h.isEqual(C,this.vb))return v.previewResult;throw new Error(`Invalid Resource: ${C.toString()}`)}async Gb(v){return{content:v.localContent,local:{added:{},removed:[],updated:{}},remote:{added:Object.keys(v.localUserData.storage),removed:[],updated:[],all:v.localUserData.storage},localChange:m.Change.None,remoteChange:m.Change.Modified}}async Hb(v){if(v.remoteContent!==null){const C=JSON.parse(v.remoteContent),{local:F,remote:D}=(0,I.$GNb)(v.localUserData.storage,C.storage,null,v.storageKeys,this.O);return{content:v.remoteContent,local:F,remote:D,localChange:Object.keys(F.added).length>0||Object.keys(F.updated).length>0||F.removed.length>0?m.Change.Modified:m.Change.None,remoteChange:D!==null?m.Change.Modified:m.Change.None}}else return{content:v.remoteContent,local:{added:{},removed:[],updated:{}},remote:{added:[],removed:[],updated:[],all:null},localChange:m.Change.None,remoteChange:m.Change.None}}async tb(v,C,F,D){const{localUserData:M}=F[0][0],{local:J,remote:H,localChange:x,remoteChange:K}=F[0][1];if(x===m.Change.None&&K===m.Change.None&&this.O.info(`${this.D}: No changes found during synchronizing ui state.`),x!==m.Change.None&&(this.O.trace(`${this.D}: Updating local ui state...`),await this.nb(JSON.stringify(M)),await this.Ab.writeLocalGlobalState(J,this.syncResource.profile),this.O.info(`${this.D}: Updated local ui state`)),K!==m.Change.None){this.O.trace(`${this.D}: Updating remote ui state...`);const ie=JSON.stringify({storage:H.all});v=await this.mb(ie,D?null:v.ref),this.O.info(`${this.D}: Updated remote ui state.${H.added.length?` Added: ${H.added}.`:""}${H.updated.length?` Updated: ${H.updated}.`:""}${H.removed.length?` Removed: ${H.removed}.`:""}`)}C?.ref!==v.ref&&(this.O.trace(`${this.D}: Updating last synchronized ui state...`),await this.fb(v),this.O.info(`${this.D}: Updated last synchronized ui state`))}async resolveContent(v){if(this.h.isEqual(this.yb,v)||this.h.isEqual(this.wb,v)||this.h.isEqual(this.xb,v)||this.h.isEqual(this.zb,v)){const C=await this.db(v);return C&&n(JSON.parse(C),!0)}return null}async hasLocalData(){try{const{storage:v}=await this.Ab.getLocalGlobalState(this.syncResource.profile);if(Object.keys(v).length>1||v[`${a}.locale`]?.value!=="en")return!0}catch{}return!1}async Jb(v){const C=await this.Bb.readStorageData(this.syncResource.profile),F=[],D=[];for(const[H,x]of C)x.target===l.StorageTarget.USER?F.push(H):x.target===l.StorageTarget.MACHINE&&D.push(H);const M=[...F,...D],J=v?.storage?Object.keys(v.storage).filter(H=>!H.startsWith(a)&&!M.includes(H)&&C.get(H)!==void 0):[];if(!k.$o){const H=[...m.$9mb.map(x=>(0,m.$jnb)(x)),m.$inb];J.push(...H),D.push(...H)}return{user:F,machine:D,unregistered:J}}};e.$INb=h,e.$INb=h=ve([Y(2,r.$wMb),Y(3,$.$_k),Y(4,m.$anb),Y(5,m.$bnb),Y(6,m.$pnb),Y(7,E.$Mi),Y(8,m.$knb),Y(9,d.$$l),Y(10,w.$_i),Y(11,l.$bq),Y(12,y.$Jl),Y(13,i.$Ei)],h);let g=class{constructor(v,C,F,D){this.a=v,this.b=C,this.c=F,this.d=D}async getLocalGlobalState(v){const C={};if(v.isDefault){const D=await this.f(),M=(0,O.$Vn)(D);for(const J of t)M[J]!==void 0&&(C[`${a}${J}`]={version:1,value:M[J]})}const F=await this.c.readStorageData(v);for(const[D,M]of F)M.value&&M.target===l.StorageTarget.USER&&(C[D]={version:1,value:M.value});return{storage:C}}async f(){try{this.d.debug("GlobalStateSync#getLocalArgvContent",this.b.argvResource);const v=await this.a.readFile(this.b.argvResource);return this.d.debug("GlobalStateSync#getLocalArgvContent - Resolved",this.b.argvResource),v.value.toString()}catch(v){this.d.debug((0,c.$_)(v))}return"{}"}async writeLocalGlobalState({added:v,removed:C,updated:F},D){const M=(0,f.$BNb)(m.SyncResource.GlobalState,D),J={},H=new Map,x=await this.c.readStorageData(D),K=(ie,V)=>{for(const z of ie){if(z.startsWith(a)){J[z.substring(a.length)]=V?V[z].value:void 0;continue}if(V){const ee=V[z];ee.value!==x.get(z)?.value&&H.set(z,ee.value)}else x.get(z)!==void 0&&H.set(z,void 0)}};if(K(Object.keys(v),v),K(Object.keys(F),F),K(C),Object.keys(J).length){this.d.trace(`${M}: Updating locale...`);const ie=await this.f();let V=ie;for(const z of Object.keys(J))V=(0,b.edit)(V,[z],J[z],{});ie!==V&&(this.d.trace(`${M}: Updating locale...`),await this.a.writeFile(this.b.argvResource,P.$Oe.fromString(V)),this.d.info(`${M}: Updated locale.`)),this.d.info(`${M}: Updated locale`)}H.size&&(this.d.trace(`${M}: Updating global state...`),await this.c.updateStorageData(D,H,l.StorageTarget.USER),this.d.info(`${M}: Updated global state`,[...H.keys()]))}};e.$JNb=g,e.$JNb=g=ve([Y(0,$.$_k),Y(1,E.$Mi),Y(2,r.$wMb),Y(3,m.$pnb)],g);let R=class extends f.$FNb{constructor(v,C,F,D,M,J){super(m.SyncResource.GlobalState,F,D,M,C,v,J)}async o(v){const C=v.syncData?JSON.parse(v.syncData.content):null;if(!C){this.j.info("Skipping initializing global state because remote global state does not exist.");return}const F={},D={};for(const M of Object.keys(C.storage))M.startsWith(a)?F[M.substring(a.length)]=C.storage[M].value:this.l.get(M,l.StorageScope.PROFILE)===void 0&&(D[M]=C.storage[M].value);if(Object.keys(F).length){let M="{}";try{M=(await this.k.readFile(this.h.argvResource)).value.toString()}catch{}for(const J of Object.keys(F))M=(0,b.edit)(M,[J],F[J],{});await this.k.writeFile(this.h.argvResource,P.$Oe.fromString(M))}if(Object.keys(D).length){const M=[];for(const J of Object.keys(D))M.push({key:J,value:D[J],scope:l.StorageScope.PROFILE,target:l.StorageTarget.USER});this.l.storeAll(M,!0)}}};e.$KNb=R,e.$KNb=R=ve([Y(0,l.$bq),Y(1,$.$_k),Y(2,s.$Ll),Y(3,E.$Mi),Y(4,m.$pnb),Y(5,y.$Jl)],R);let L=class{constructor(v,C,F,D,M){this.a=v,this.b=C,this.c=F,this.d=D,this.f=M}getSyncStoreType(v){return this.h(v)?.storage[m.$inb]?.value}async sync(v){const C=(0,m.$enb)((0,A.$2g)());try{return await this.g(v,C)}catch(F){if(F instanceof m.$fnb)switch(F.code){case m.UserDataSyncErrorCode.PreconditionFailed:return this.f.info("Failed to synchronize UserDataSyncStoreType as there is a new remote version available. Synchronizing again..."),this.g(v,C)}throw F}}async g(v,C){const F=await this.a.readResource(m.SyncResource.GlobalState,null,void 0,C),D=this.h(F)||{storage:{}};D.storage[m.$inb]={value:v,version:o};const M=await(0,p.$hq)(this.c,this.d,this.b),J={version:o,machineId:M,content:n(D,!1)};await this.a.writeResource(m.SyncResource.GlobalState,JSON.stringify(J),F.ref,void 0,C)}h({content:v}){if(!v)return null;const C=JSON.parse(v);if((0,f.$ANb)(C))return C?JSON.parse(C.content):null;throw new Error("Invalid remote data")}};e.$LNb=L,e.$LNb=L=ve([Y(1,l.$bq),Y(2,E.$Mi),Y(3,$.$_k),Y(4,u.$_j)],L)}),define(ce[122],le([0,1,19,15,3,34,5,13,182,22,16,7,17,18,29,20,40,243,25]),function(ne,e,P,c,N,O,T,k,A,w,E,$,u,p,l,d,y,f,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hbc=e.$Gbc=void 0,e.$Fbc=I;function I(r,i,a){try{const t=JSON.parse(r);if(!i)return(0,k.$mg)(t.all)?null:t.all;switch(T.OS){case T.OperatingSystem.Macintosh:return(0,k.$mg)(t.mac)?null:t.mac;case T.OperatingSystem.Linux:return(0,k.$mg)(t.linux)?null:t.linux;case T.OperatingSystem.Windows:return(0,k.$mg)(t.windows)?null:t.windows}}catch(t){return a.error(t),null}}let m=class extends y.$ENb{constructor(i,a,t,n,o,h,g,R,L,S,v,C,F){super(i.keybindingsResource,{syncResource:b.SyncResource.Keybindings,profile:i},a,R,L,S,t,n,g,C,o,v,h,F),this.pb=2,this.Eb=this.h.joinPath(this.g,"keybindings.json"),this.Fb=this.Eb.with({scheme:b.$rnb,authority:"base"}),this.Gb=this.Eb.with({scheme:b.$rnb,authority:"local"}),this.Hb=this.Eb.with({scheme:b.$rnb,authority:"remote"}),this.Ib=this.Eb.with({scheme:b.$rnb,authority:"accepted"}),this.B(N.Event.filter(h.onDidChangeConfiguration,D=>D.affectsConfiguration("settingsSync.keybindingsPerPlatform"))(()=>this.Q()))}async qb(i,a,t,n){const o=i.syncData?I(i.syncData.content,n.keybindingsPerPlatform??this.Qb(),this.O):null;a=a===null&&t?i:a;const h=a?this.Ob(a):null,g=await this.vb(),R=await this.Cb();let L=null,S=!1,v=!1,C=!1;if(o){let M=g?g.value.toString():"[]";if(M=M||"[]",this.Ab(M,!0))throw new b.$fnb((0,A.localize)(0,null),b.UserDataSyncErrorCode.LocalInvalidContent,this.resource);if(!h||h!==M||h!==o){this.O.trace(`${this.D}: Merging remote keybindings with local keybindings...`);const J=await(0,f.$Ebc)(M,o,h,R,this.zb);J.hasChanges&&(L=J.mergeContent,C=J.hasConflicts,S=C||J.mergeContent!==M,v=C||J.mergeContent!==o)}}else g&&(this.O.trace(`${this.D}: Remote keybindings does not exist. Synchronizing keybindings for the first time.`),L=g.value.toString(),v=!0);const F={content:C?h:L,localChange:S?g?b.Change.Modified:b.Change.Added:b.Change.None,remoteChange:v?b.Change.Modified:b.Change.None,hasConflicts:C},D=g?g.value.toString():null;return[{fileContent:g,baseResource:this.Fb,baseContent:h,localResource:this.Gb,localContent:D,localChange:F.localChange,remoteResource:this.Hb,remoteContent:o,remoteChange:F.remoteChange,previewResource:this.Eb,previewResult:F,acceptedResource:this.Ib}]}async ub(i){const a=this.Ob(i);if(a===null)return!0;const t=await this.vb(),n=t?t.value.toString():"",o=await this.Cb(),h=await(0,f.$Ebc)(n||"[]",a,a,o,this.zb);return h.hasConflicts||h.mergeContent!==a}async rb(i,a){return i.previewResult}async sb(i,a,t,n){if(this.h.isEqual(a,this.Gb))return{content:i.fileContent?i.fileContent.value.toString():null,localChange:b.Change.None,remoteChange:b.Change.Modified};if(this.h.isEqual(a,this.Hb))return{content:i.remoteContent,localChange:b.Change.Modified,remoteChange:b.Change.None};if(this.h.isEqual(a,this.Eb))return t===void 0?{content:i.previewResult.content,localChange:i.previewResult.localChange,remoteChange:i.previewResult.remoteChange}:{content:t,localChange:b.Change.Modified,remoteChange:b.Change.Modified};throw new Error(`Invalid Resource: ${a.toString()}`)}async tb(i,a,t,n){const{fileContent:o}=t[0][0];let{content:h,localChange:g,remoteChange:R}=t[0][1];if(g===b.Change.None&&R===b.Change.None&&this.O.info(`${this.D}: No changes found during synchronizing keybindings.`),h!==null&&(h=h.trim(),h=h||"[]",this.Ab(h,!0)))throw new b.$fnb((0,A.localize)(1,null),b.UserDataSyncErrorCode.LocalInvalidContent,this.resource);if(g!==b.Change.None&&(this.O.trace(`${this.D}: Updating local keybindings...`),o&&await this.nb(this.Pb(o.value.toString())),await this.wb(h||"[]",o,n),this.O.info(`${this.D}: Updated local keybindings`)),R!==b.Change.None){this.O.trace(`${this.D}: Updating remote keybindings...`);const L=this.Pb(h||"[]",i.syncData?.content);i=await this.mb(L,n?null:i.ref),this.O.info(`${this.D}: Updated remote keybindings`)}try{await this.G.del(this.Eb)}catch{}a?.ref!==i.ref&&(this.O.trace(`${this.D}: Updating last synchronized keybindings...`),await this.fb(i,{platformSpecific:this.Qb()}),this.O.info(`${this.D}: Updated last synchronized keybindings`))}async hasLocalData(){try{const i=await this.vb();if(i){const a=(0,O.$Vn)(i.value.toString());if((0,P.$Nb)(a))return!0}}catch(i){if(i.fileOperationResult!==$.FileOperationResult.FILE_NOT_FOUND)return!0}return!1}async resolveContent(i){return this.h.isEqual(this.Hb,i)||this.h.isEqual(this.Fb,i)||this.h.isEqual(this.Gb,i)||this.h.isEqual(this.Ib,i)?this.db(i):null}Ob(i){return!i.syncData||i.platformSpecific!==void 0&&i.platformSpecific!==this.Qb()?null:I(i.syncData.content,this.Qb(),this.O)}Pb(i,a){let t={};try{t=JSON.parse(a||"{}")}catch(n){this.O.error(n)}switch(this.Qb()?delete t.all:t.all=i,T.OS){case T.OperatingSystem.Macintosh:t.mac=i;break;case T.OperatingSystem.Linux:t.linux=i;break;case T.OperatingSystem.Windows:t.windows=i;break}return JSON.stringify(t)}Qb(){return!!this.P.getValue(b.$6mb)}};e.$Gbc=m,e.$Gbc=m=ve([Y(2,b.$anb),Y(3,b.$bnb),Y(4,b.$pnb),Y(5,w.$_i),Y(6,b.$knb),Y(7,$.$_k),Y(8,E.$Mi),Y(9,u.$bq),Y(10,b.$onb),Y(11,p.$$l),Y(12,l.$Jl)],m);let s=class extends y.$FNb{constructor(i,a,t,n,o,h){super(b.SyncResource.Keybindings,a,t,n,i,o,h)}async o(i){const a=i.syncData?this.p(i.syncData.content):null;if(!a){this.j.info("Skipping initializing keybindings because remote keybindings does not exist.");return}if(!await this.i()){this.j.info("Skipping initializing keybindings because local keybindings exist.");return}await this.k.writeFile(this.g.defaultProfile.keybindingsResource,c.$Oe.fromString(a)),await this.n(i)}async i(){try{const i=await this.k.readFile(this.g.defaultProfile.settingsResource),a=(0,O.$Vn)(i.value.toString());return!(0,P.$Nb)(a)}catch(i){return i.fileOperationResult===$.FileOperationResult.FILE_NOT_FOUND}}p(i){try{return I(i,!0,this.j)}catch(a){return this.j.error(a),null}}};e.$Hbc=s,e.$Hbc=s=ve([Y(0,$.$_k),Y(1,d.$Ll),Y(2,E.$Mi),Y(3,b.$pnb),Y(4,u.$bq),Y(5,l.$Jl)],s)}),define(ce[123],le([0,1,15,3,183,22,78,16,28,7,17,18,29,20,40,247,25]),function(ne,e,P,c,N,O,T,k,A,w,E,$,u,p,l,d,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kbc=e.$Jbc=void 0,e.$Ibc=b;function f(s){return s&&s.settings&&typeof s.settings=="string"&&Object.keys(s).length===1}function b(s){const r=JSON.parse(s);return f(r)?r:{settings:s}}let I=class extends l.$ENb{constructor(r,i,a,t,n,o,h,g,R,L,S,v,C,F){super(r.settingsResource,{syncResource:y.SyncResource.Settings,profile:r},i,a,t,n,o,h,S,v,g,R,L,F),this.Eb=C,this.pb=2,this.previewResource=this.h.joinPath(this.g,"settings.json"),this.baseResource=this.previewResource.with({scheme:y.$rnb,authority:"base"}),this.localResource=this.previewResource.with({scheme:y.$rnb,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:y.$rnb,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:y.$rnb,authority:"accepted"}),this.Ob=void 0}async getRemoteUserDataSyncConfiguration(r){const i=await this.getLastSyncUserData(),a=await this.X(r,i),t=this.Lb(a),n=new T.$Ko(y.$5mb,this.O);return t?.settings&&n.parse(t.settings),n.configurationModel.getValue(y.$5mb)||{}}async qb(r,i,a){const t=await this.vb(),n=await this.Cb(),o=this.Lb(r);i=i===null&&a?r:i;const h=i?this.Lb(i):null,g=await this.Pb();let R=null,L=!1,S=!1,v=!1;if(o){let M=t?t.value.toString().trim():"{}";M=M||"{}",this.Qb(M),this.O.trace(`${this.D}: Merging remote settings with local settings...`);const J=(0,d.$dMb)(M,o.settings,h?h.settings:null,g,[],n);R=J.localContent||J.remoteContent,L=J.localContent!==null,S=J.remoteContent!==null,v=J.hasConflicts}else t&&(this.O.trace(`${this.D}: Remote settings does not exist. Synchronizing settings for the first time.`),R=t.value.toString().trim()||"{}",this.Qb(R),S=!0);const C=t?t.value.toString():null,F=h?.settings??null,D={content:v?F:R,localChange:L?y.Change.Modified:y.Change.None,remoteChange:S?y.Change.Modified:y.Change.None,hasConflicts:v};return[{fileContent:t,baseResource:this.baseResource,baseContent:F,localResource:this.localResource,localContent:C,localChange:D.localChange,remoteResource:this.remoteResource,remoteContent:o?o.settings:null,remoteChange:D.remoteChange,previewResource:this.previewResource,previewResult:D,acceptedResource:this.acceptedResource}]}async ub(r){const i=this.Lb(r);if(i===null)return!0;const a=await this.vb(),t=a?a.value.toString().trim():"",n=await this.Pb(),o=await this.Cb();return(0,d.$dMb)(t||"{}",i.settings,i.settings,n,[],o).remoteContent!==null}async rb(r,i){const a=await this.Cb(),t=await this.Pb();return{...r.previewResult,content:r.previewResult.content?(0,d.$cMb)(r.previewResult.content,"{}",t,a):null}}async sb(r,i,a,t){const n=await this.Cb(),o=await this.Pb();if(this.h.isEqual(i,this.localResource))return{content:r.fileContent?(0,d.$cMb)(r.fileContent.value.toString(),"{}",o,n):null,localChange:y.Change.None,remoteChange:y.Change.Modified};if(this.h.isEqual(i,this.remoteResource))return{content:r.remoteContent!==null?(0,d.$cMb)(r.remoteContent,r.fileContent?r.fileContent.value.toString():"{}",o,n):null,localChange:y.Change.Modified,remoteChange:y.Change.None};if(this.h.isEqual(i,this.previewResource))return a===void 0?{content:r.previewResult.content,localChange:r.previewResult.localChange,remoteChange:r.previewResult.remoteChange}:{content:a!==null?(0,d.$cMb)(a,r.fileContent?r.fileContent.value.toString():"{}",o,n):null,localChange:y.Change.Modified,remoteChange:y.Change.Modified};throw new Error(`Invalid Resource: ${i.toString()}`)}async tb(r,i,a,t){const{fileContent:n}=a[0][0];let{content:o,localChange:h,remoteChange:g}=a[0][1];if(h===y.Change.None&&g===y.Change.None&&this.O.info(`${this.D}: No changes found during synchronizing settings.`),o=o?o.trim():"{}",o=o||"{}",this.Qb(o),h!==y.Change.None&&(this.O.trace(`${this.D}: Updating local settings...`),n&&await this.nb(JSON.stringify(this.Nb(n.value.toString()))),await this.wb(o,n,t),await this.P.reloadConfiguration(O.ConfigurationTarget.USER_LOCAL),this.O.info(`${this.D}: Updated local settings`)),g!==y.Change.None){const R=await this.Cb(),L=this.Lb(r),S=await this.Pb(o);o=(0,d.$cMb)(o,L?L.settings:"{}",S,R),this.O.trace(`${this.D}: Updating remote settings...`),r=await this.mb(JSON.stringify(this.Nb(o)),t?null:r.ref),this.O.info(`${this.D}: Updated remote settings`)}try{await this.G.del(this.previewResource)}catch{}i?.ref!==r.ref&&(this.O.trace(`${this.D}: Updating last synchronized settings...`),await this.fb(r),this.O.info(`${this.D}: Updated last synchronized settings`))}async hasLocalData(){try{const r=await this.vb();if(r)return!(0,d.$eMb)(r.value.toString())}catch(r){if(r.fileOperationResult!==w.FileOperationResult.FILE_NOT_FOUND)return!0}return!1}async resolveContent(r){return this.h.isEqual(this.remoteResource,r)||this.h.isEqual(this.localResource,r)||this.h.isEqual(this.acceptedResource,r)||this.h.isEqual(this.baseResource,r)?this.db(r):null}async db(r){let i=await super.db(r);if(i){const a=await this.Cb(),t=await this.Pb();i=(0,d.$cMb)(i,"{}",t,a)}return i}Lb(r){return r.syncData?this.Mb(r.syncData.content):null}Mb(r){try{return b(r)}catch(i){this.O.error(i)}return null}Nb(r){return{settings:r}}async Pb(r){if(!this.Ob){this.Ob=this.zb.resolveDefaultIgnoredSettings();const a=this.B(c.Event.any(c.Event.filter(this.Eb.onDidInstallExtensions,t=>t.some(({local:n})=>!!n)),c.Event.filter(this.Eb.onDidUninstallExtension,t=>!t.error))(()=>{a.dispose(),this.Ob=void 0}))}const i=await this.Ob;return(0,d.$aMb)(i,this.P,r)}Qb(r){if(this.Ab(r,!1))throw new y.$fnb((0,N.localize)(0,null),y.UserDataSyncErrorCode.LocalInvalidContent,this.resource)}};e.$Jbc=I,e.$Jbc=I=ve([Y(2,w.$_k),Y(3,k.$Mi),Y(4,E.$bq),Y(5,y.$anb),Y(6,y.$bnb),Y(7,y.$pnb),Y(8,y.$onb),Y(9,O.$_i),Y(10,y.$knb),Y(11,$.$$l),Y(12,A.$jp),Y(13,u.$Jl)],I);let m=class extends l.$FNb{constructor(r,i,a,t,n,o){super(y.SyncResource.Settings,i,a,t,r,n,o)}async o(r){const i=r.syncData?this.p(r.syncData.content):null;if(!i){this.j.info("Skipping initializing settings because remote settings does not exist.");return}if(!await this.i()){this.j.info("Skipping initializing settings because local settings exist.");return}await this.k.writeFile(this.g.defaultProfile.settingsResource,P.$Oe.fromString(i.settings)),await this.n(r)}async i(){try{const r=await this.k.readFile(this.g.defaultProfile.settingsResource);return(0,d.$eMb)(r.value.toString().trim())}catch(r){return r.fileOperationResult===w.FileOperationResult.FILE_NOT_FOUND}}p(r){try{return b(r)}catch(i){this.j.error(i)}return null}};e.$Kbc=m,e.$Kbc=m=ve([Y(0,w.$_k),Y(1,p.$Ll),Y(2,k.$Mi),Y(3,y.$pnb),Y(4,E.$bq),Y(5,u.$Jl)],m)}),define(ce[124],le([0,1,15,3,30,22,16,7,17,18,29,20,40,244,25]),function(ne,e,P,c,N,O,T,k,A,w,E,$,u,p,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pbc=e.$Obc=void 0,e.$Nbc=d;function d(b){return JSON.parse(b.content)}let y=class extends u.$CNb{constructor(I,m,s,r,i,a,t,n,o,h,g,R){super({syncResource:l.SyncResource.Snippets,profile:I},m,r,s,i,a,t,h,g,n,o,R),this.pb=1,this.vb=I.snippetsHome,this.B(this.G.watch(s.userRoamingDataHome)),this.B(this.G.watch(this.vb)),this.B(c.Event.filter(this.G.onDidFilesChange,L=>L.affects(this.vb))(()=>this.Q()))}async qb(I,m,s){const r=await this.Hb(),i=this.Gb(r),a=I.syncData?this.Fb(I.syncData):null;m=m===null&&s?I:m;const t=m&&m.syncData?this.Fb(m.syncData):null;a?this.O.trace(`${this.D}: Merging remote snippets with local snippets...`):this.O.trace(`${this.D}: Remote snippets does not exist. Synchronizing snippets for the first time.`);const n=(0,p.$Lbc)(i,a,t);return this.Bb(n,r,a||{},t||{})}async ub(I){const m=I.syncData?this.Fb(I.syncData):null;if(m===null)return!0;const s=await this.Hb(),r=this.Gb(s),i=(0,p.$Lbc)(r,m,m);return Object.keys(i.remote.added).length>0||Object.keys(i.remote.updated).length>0||i.remote.removed.length>0||i.conflicts.length>0}async rb(I,m){return I.previewResult}async sb(I,m,s,r){if(this.h.isEqualOrParent(m,this.g.with({scheme:l.$rnb,authority:"local"})))return{content:I.fileContent?I.fileContent.value.toString():null,localChange:l.Change.None,remoteChange:I.fileContent?I.remoteContent!==null?l.Change.Modified:l.Change.Added:l.Change.Deleted};if(this.h.isEqualOrParent(m,this.g.with({scheme:l.$rnb,authority:"remote"})))return{content:I.remoteContent,localChange:I.remoteContent!==null?I.fileContent?l.Change.Modified:l.Change.Added:l.Change.Deleted,remoteChange:l.Change.None};if(this.h.isEqualOrParent(m,this.g))return s===void 0?{content:I.previewResult.content,localChange:I.previewResult.localChange,remoteChange:I.previewResult.remoteChange}:{content:s,localChange:s===null?I.fileContent!==null?l.Change.Deleted:l.Change.None:l.Change.Modified,remoteChange:s===null?I.remoteContent!==null?l.Change.Deleted:l.Change.None:l.Change.Modified};throw new Error(`Invalid Resource: ${m.toString()}`)}async tb(I,m,s,r){const i=s.map(([a,t])=>({...a,acceptResult:t}));i.every(({localChange:a,remoteChange:t})=>a===l.Change.None&&t===l.Change.None)&&this.O.info(`${this.D}: No changes found during synchronizing snippets.`),i.some(({localChange:a})=>a!==l.Change.None)&&(await this.Cb(i),await this.Db(i,r)),i.some(({remoteChange:a})=>a!==l.Change.None)&&(I=await this.Eb(i,I,r)),m?.ref!==I.ref&&(this.O.trace(`${this.D}: Updating last synchronized snippets...`),await this.fb(I),this.O.info(`${this.D}: Updated last synchronized snippets`));for(const{previewResource:a}of i)try{await this.G.del(a)}catch{}}Bb(I,m,s,r){const i=new Map;for(const a of Object.keys(I.local.added)){const t={content:I.local.added[a],hasConflicts:!1,localChange:l.Change.Added,remoteChange:l.Change.None};i.set(a,{baseResource:this.h.joinPath(this.g,a).with({scheme:l.$rnb,authority:"base"}),baseContent:null,fileContent:null,localResource:this.h.joinPath(this.g,a).with({scheme:l.$rnb,authority:"local"}),localContent:null,remoteResource:this.h.joinPath(this.g,a).with({scheme:l.$rnb,authority:"remote"}),remoteContent:s[a],previewResource:this.h.joinPath(this.g,a),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.h.joinPath(this.g,a).with({scheme:l.$rnb,authority:"accepted"})})}for(const a of Object.keys(I.local.updated)){const t={content:I.local.updated[a],hasConflicts:!1,localChange:l.Change.Modified,remoteChange:l.Change.None},n=m[a]?m[a].value.toString():null;i.set(a,{baseResource:this.h.joinPath(this.g,a).with({scheme:l.$rnb,authority:"base"}),baseContent:r[a]??null,localResource:this.h.joinPath(this.g,a).with({scheme:l.$rnb,authority:"local"}),fileContent:m[a],localContent:n,remoteResource:this.h.joinPath(this.g,a).with({scheme:l.$rnb,authority:"remote"}),remoteContent:s[a],previewResource:this.h.joinPath(this.g,a),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.h.joinPath(this.g,a).with({scheme:l.$rnb,authority:"accepted"})})}for(const a of I.local.removed){const t={content:null,hasConflicts:!1,localChange:l.Change.Deleted,remoteChange:l.Change.None},n=m[a]?m[a].value.toString():null;i.set(a,{baseResource:this.h.joinPath(this.g,a).with({scheme:l.$rnb,authority:"base"}),baseContent:r[a]??null,localResource:this.h.joinPath(this.g,a).with({scheme:l.$rnb,authority:"local"}),fileContent:m[a],localContent:n,remoteResource:this.h.joinPath(this.g,a).with({scheme:l.$rnb,authority:"remote"}),remoteContent:null,previewResource:this.h.joinPath(this.g,a),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.h.joinPath(this.g,a).with({scheme:l.$rnb,authority:"accepted"})})}for(const a of Object.keys(I.remote.added)){const t={content:I.remote.added[a],hasConflicts:!1,localChange:l.Change.None,remoteChange:l.Change.Added},n=m[a]?m[a].value.toString():null;i.set(a,{baseResource:this.h.joinPath(this.g,a).with({scheme:l.$rnb,authority:"base"}),baseContent:r[a]??null,localResource:this.h.joinPath(this.g,a).with({scheme:l.$rnb,authority:"local"}),fileContent:m[a],localContent:n,remoteResource:this.h.joinPath(this.g,a).with({scheme:l.$rnb,authority:"remote"}),remoteContent:null,previewResource:this.h.joinPath(this.g,a),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.h.joinPath(this.g,a).with({scheme:l.$rnb,authority:"accepted"})})}for(const a of Object.keys(I.remote.updated)){const t={content:I.remote.updated[a],hasConflicts:!1,localChange:l.Change.None,remoteChange:l.Change.Modified},n=m[a]?m[a].value.toString():null;i.set(a,{baseResource:this.h.joinPath(this.g,a).with({scheme:l.$rnb,authority:"base"}),baseContent:r[a]??null,localResource:this.h.joinPath(this.g,a).with({scheme:l.$rnb,authority:"local"}),fileContent:m[a],localContent:n,remoteResource:this.h.joinPath(this.g,a).with({scheme:l.$rnb,authority:"remote"}),remoteContent:s[a],previewResource:this.h.joinPath(this.g,a),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.h.joinPath(this.g,a).with({scheme:l.$rnb,authority:"accepted"})})}for(const a of I.remote.removed){const t={content:null,hasConflicts:!1,localChange:l.Change.None,remoteChange:l.Change.Deleted};i.set(a,{baseResource:this.h.joinPath(this.g,a).with({scheme:l.$rnb,authority:"base"}),baseContent:r[a]??null,localResource:this.h.joinPath(this.g,a).with({scheme:l.$rnb,authority:"local"}),fileContent:null,localContent:null,remoteResource:this.h.joinPath(this.g,a).with({scheme:l.$rnb,authority:"remote"}),remoteContent:s[a],previewResource:this.h.joinPath(this.g,a),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.h.joinPath(this.g,a).with({scheme:l.$rnb,authority:"accepted"})})}for(const a of I.conflicts){const t={content:r[a]??null,hasConflicts:!0,localChange:m[a]?l.Change.Modified:l.Change.Added,remoteChange:s[a]?l.Change.Modified:l.Change.Added},n=m[a]?m[a].value.toString():null;i.set(a,{baseResource:this.h.joinPath(this.g,a).with({scheme:l.$rnb,authority:"base"}),baseContent:r[a]??null,localResource:this.h.joinPath(this.g,a).with({scheme:l.$rnb,authority:"local"}),fileContent:m[a]||null,localContent:n,remoteResource:this.h.joinPath(this.g,a).with({scheme:l.$rnb,authority:"remote"}),remoteContent:s[a]||null,previewResource:this.h.joinPath(this.g,a),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.h.joinPath(this.g,a).with({scheme:l.$rnb,authority:"accepted"})})}for(const a of Object.keys(m))if(!i.has(a)){const t={content:m[a]?m[a].value.toString():null,hasConflicts:!1,localChange:l.Change.None,remoteChange:l.Change.None},n=m[a]?m[a].value.toString():null;i.set(a,{baseResource:this.h.joinPath(this.g,a).with({scheme:l.$rnb,authority:"base"}),baseContent:r[a]??null,localResource:this.h.joinPath(this.g,a).with({scheme:l.$rnb,authority:"local"}),fileContent:m[a]||null,localContent:n,remoteResource:this.h.joinPath(this.g,a).with({scheme:l.$rnb,authority:"remote"}),remoteContent:s[a]||null,previewResource:this.h.joinPath(this.g,a),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.h.joinPath(this.g,a).with({scheme:l.$rnb,authority:"accepted"})})}return[...i.values()]}async resolveContent(I){return this.h.isEqualOrParent(I,this.g.with({scheme:l.$rnb,authority:"remote"}))||this.h.isEqualOrParent(I,this.g.with({scheme:l.$rnb,authority:"local"}))||this.h.isEqualOrParent(I,this.g.with({scheme:l.$rnb,authority:"base"}))||this.h.isEqualOrParent(I,this.g.with({scheme:l.$rnb,authority:"accepted"}))?this.db(I):null}async hasLocalData(){try{const I=await this.Hb();if(Object.keys(I).length)return!0}catch{}return!1}async Cb(I){const m={};for(const s of I)s.fileContent&&(m[this.h.basename(s.localResource)]=s.fileContent);await this.nb(JSON.stringify(this.Gb(m)))}async Db(I,m){for(const{fileContent:s,acceptResult:r,localResource:i,remoteResource:a,localChange:t}of I)if(t!==l.Change.None){const n=a?this.h.basename(a):this.h.basename(i),o=this.h.joinPath(this.vb,n);t===l.Change.Deleted?(this.O.trace(`${this.D}: Deleting snippet...`,this.h.basename(o)),await this.G.del(o),this.O.info(`${this.D}: Deleted snippet`,this.h.basename(o))):t===l.Change.Added?(this.O.trace(`${this.D}: Creating snippet...`,this.h.basename(o)),await this.G.createFile(o,P.$Oe.fromString(r.content),{overwrite:m}),this.O.info(`${this.D}: Created snippet`,this.h.basename(o))):(this.O.trace(`${this.D}: Updating snippet...`,this.h.basename(o)),await this.G.writeFile(o,P.$Oe.fromString(r.content),m?void 0:s),this.O.info(`${this.D}: Updated snippet`,this.h.basename(o)))}}async Eb(I,m,s){const r=m.syncData?this.Fb(m.syncData):{},i=(0,N.$bo)(r);for(const{acceptResult:a,localResource:t,remoteResource:n,remoteChange:o}of I)if(o!==l.Change.None){const h=t?this.h.basename(t):this.h.basename(n);o===l.Change.Deleted?delete i[h]:i[h]=a.content}return(0,p.$Mbc)(r,i)||(this.O.trace(`${this.D}: Updating remote snippets...`),m=await this.mb(JSON.stringify(i),s?null:m.ref),this.O.info(`${this.D}: Updated remote snippets`)),m}Fb(I){return d(I)}Gb(I){const m={};for(const s of Object.keys(I))m[s]=I[s].value.toString();return m}async Hb(){const I={};let m;try{m=await this.G.resolve(this.vb)}catch(s){if(s instanceof k.$ul&&s.fileOperationResult===k.FileOperationResult.FILE_NOT_FOUND)return I;throw s}for(const s of m.children||[]){const r=s.resource,i=this.h.extname(r);if(i===".json"||i===".code-snippets"){const a=this.h.relativePath(this.vb,r),t=await this.G.readFile(r);I[a]=t}}return I}};e.$Obc=y,e.$Obc=y=ve([Y(2,T.$Mi),Y(3,k.$_k),Y(4,A.$bq),Y(5,l.$anb),Y(6,l.$bnb),Y(7,l.$pnb),Y(8,O.$_i),Y(9,l.$knb),Y(10,w.$$l),Y(11,E.$Jl)],y);let f=class extends u.$FNb{constructor(I,m,s,r,i,a){super(l.SyncResource.Snippets,m,s,r,I,i,a)}async o(I){const m=I.syncData?JSON.parse(I.syncData.content):null;if(!m){this.j.info("Skipping initializing snippets because remote snippets does not exist.");return}if(!await this.i()){this.j.info("Skipping initializing snippets because local snippets exist.");return}for(const r of Object.keys(m)){const i=m[r];if(i){const a=this.d.joinPath(this.g.defaultProfile.snippetsHome,r);await this.k.createFile(a,P.$Oe.fromString(i)),this.j.info("Created snippet",this.d.basename(a))}}await this.n(I)}async i(){try{return!(await this.k.resolve(this.g.defaultProfile.snippetsHome)).children?.length}catch(I){return I.fileOperationResult===k.FileOperationResult.FILE_NOT_FOUND}}};e.$Pbc=f,e.$Pbc=f=ve([Y(0,k.$_k),Y(1,$.$Ll),Y(2,T.$Mi),Y(3,l.$pnb),Y(4,A.$bq),Y(5,E.$Jl)],f)}),define(ce[125],le([0,1,15,22,16,7,17,18,29,20,40,25]),function(ne,e,P,c,N,O,T,k,A,w,E,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sbc=e.$Rbc=void 0,e.$Qbc=u;function u(y,f){try{return JSON.parse(y).tasks??null}catch(b){return f.error(b),null}}let p=class extends E.$DNb{constructor(f,b,I,m,s,r,i,a,t,n,o,h){super(f.tasksResource,{syncResource:$.SyncResource.Tasks,profile:f},b,a,t,n,I,m,i,o,s,r,h),this.pb=1,this.Ab=this.h.joinPath(this.g,"tasks.json"),this.Bb=this.Ab.with({scheme:$.$rnb,authority:"base"}),this.Cb=this.Ab.with({scheme:$.$rnb,authority:"local"}),this.Db=this.Ab.with({scheme:$.$rnb,authority:"remote"}),this.Eb=this.Ab.with({scheme:$.$rnb,authority:"accepted"})}async qb(f,b,I,m){const s=f.syncData?u(f.syncData.content,this.O):null;b=b===null&&I?f:b;const r=b?.syncData?u(b.syncData.content,this.O):null,i=await this.vb();let a=null,t=!1,n=!1,o=!1;if(f.syncData){const R=i?i.value.toString():null;if(!r||r!==R||r!==s){this.O.trace(`${this.D}: Merging remote tasks with local tasks...`);const L=d(R,s,r);a=L.content,o=L.hasConflicts,t=L.hasLocalChanged,n=L.hasRemoteChanged}}else i&&(this.O.trace(`${this.D}: Remote tasks does not exist. Synchronizing tasks for the first time.`),a=i.value.toString(),n=!0);const h={content:o?r:a,localChange:t?i?$.Change.Modified:$.Change.Added:$.Change.None,remoteChange:n?$.Change.Modified:$.Change.None,hasConflicts:o},g=i?i.value.toString():null;return[{fileContent:i,baseResource:this.Bb,baseContent:r,localResource:this.Cb,localContent:g,localChange:h.localChange,remoteResource:this.Db,remoteContent:s,remoteChange:h.remoteChange,previewResource:this.Ab,previewResult:h,acceptedResource:this.Eb}]}async ub(f){const b=f?.syncData?u(f.syncData.content,this.O):null;if(b===null)return!0;const I=await this.vb(),m=I?I.value.toString():null,s=d(m,b,b);return s.hasLocalChanged||s.hasRemoteChanged}async rb(f,b){return f.previewResult}async sb(f,b,I,m){if(this.h.isEqual(b,this.Cb))return{content:f.fileContent?f.fileContent.value.toString():null,localChange:$.Change.None,remoteChange:$.Change.Modified};if(this.h.isEqual(b,this.Db))return{content:f.remoteContent,localChange:$.Change.Modified,remoteChange:$.Change.None};if(this.h.isEqual(b,this.Ab))return I===void 0?{content:f.previewResult.content,localChange:f.previewResult.localChange,remoteChange:f.previewResult.remoteChange}:{content:I,localChange:$.Change.Modified,remoteChange:$.Change.Modified};throw new Error(`Invalid Resource: ${b.toString()}`)}async tb(f,b,I,m){const{fileContent:s}=I[0][0],{content:r,localChange:i,remoteChange:a}=I[0][1];if(i===$.Change.None&&a===$.Change.None&&this.O.info(`${this.D}: No changes found during synchronizing tasks.`),i!==$.Change.None&&(this.O.trace(`${this.D}: Updating local tasks...`),s&&await this.nb(JSON.stringify(this.Kb(s.value.toString()))),r?await this.wb(r,s,m):await this.xb(),this.O.info(`${this.D}: Updated local tasks`)),a!==$.Change.None){this.O.trace(`${this.D}: Updating remote tasks...`);const t=JSON.stringify(this.Kb(r));f=await this.mb(t,m?null:f.ref),this.O.info(`${this.D}: Updated remote tasks`)}try{await this.G.del(this.Ab)}catch{}b?.ref!==f.ref&&(this.O.trace(`${this.D}: Updating last synchronized tasks...`),await this.fb(f),this.O.info(`${this.D}: Updated last synchronized tasks`))}async hasLocalData(){return this.G.exists(this.r)}async resolveContent(f){return this.h.isEqual(this.Db,f)||this.h.isEqual(this.Bb,f)||this.h.isEqual(this.Cb,f)||this.h.isEqual(this.Eb,f)?this.db(f):null}Kb(f){return f?{tasks:f}:{}}};e.$Rbc=p,e.$Rbc=p=ve([Y(2,$.$anb),Y(3,$.$bnb),Y(4,$.$pnb),Y(5,c.$_i),Y(6,$.$knb),Y(7,O.$_k),Y(8,N.$Mi),Y(9,T.$bq),Y(10,k.$$l),Y(11,A.$Jl)],p);let l=class extends E.$FNb{constructor(f,b,I,m,s,r){super($.SyncResource.Tasks,b,I,m,f,s,r),this.c=this.g.defaultProfile.tasksResource}async o(f){const b=f.syncData?u(f.syncData.content,this.j):null;if(!b){this.j.info("Skipping initializing tasks because remote tasks does not exist.");return}if(!await this.p()){this.j.info("Skipping initializing tasks because local tasks exist.");return}await this.k.writeFile(this.c,P.$Oe.fromString(b)),await this.n(f)}async p(){return this.k.exists(this.c)}};e.$Sbc=l,e.$Sbc=l=ve([Y(0,O.$_k),Y(1,w.$Ll),Y(2,N.$Mi),Y(3,$.$pnb),Y(4,T.$bq),Y(5,A.$Jl)],l);function d(y,f,b){if(y===null&&f===null&&b===null)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};if(y===f)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};const I=b!==y,m=b!==f;return!I&&!m?{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1}:I&&!m?{content:y,hasRemoteChanged:!0,hasLocalChanged:!1,hasConflicts:!1}:m&&!I?{content:f,hasLocalChanged:!0,hasRemoteChanged:!1,hasConflicts:!1}:{content:y,hasLocalChanged:!0,hasRemoteChanged:!0,hasConflicts:!0}}}),define(ce[126],le([0,1,45,22,16,7,17,18,29,20,40,245,25]),function(ne,e,P,c,N,O,T,k,A,w,E,$,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zdc=void 0,e.$Adc=l,e.$Bdc=d;let p=class extends E.$CNb{constructor(f,b,I,m,s,r,i,a,t,n,o,h,g){super({syncResource:u.SyncResource.Profiles,profile:f},b,m,s,r,i,a,o,h,t,n,g),this.vb=I,this.pb=2,this.previewResource=this.h.joinPath(this.g,"profiles.json"),this.baseResource=this.previewResource.with({scheme:u.$rnb,authority:"base"}),this.localResource=this.previewResource.with({scheme:u.$rnb,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:u.$rnb,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:u.$rnb,authority:"accepted"}),this.B(I.onDidChangeProfiles(()=>this.Q()))}async getLastSyncedProfiles(){const f=await this.getLastSyncUserData();return f?.syncData?d(f.syncData):null}async getRemoteSyncedProfiles(f){const b=await this.getLastSyncUserData(),I=await this.X(f,b);return I?.syncData?d(I.syncData):null}async qb(f,b,I){if(!this.vb.isEnabled())throw new u.$fnb("Cannot sync profiles because they are disabled",u.UserDataSyncErrorCode.LocalError);const m=f.syncData?d(f.syncData):null,s=b?.syncData?d(b.syncData):null,r=this.Db(),{local:i,remote:a}=(0,$.$ydc)(r,m,s,[]),t={local:i,remote:a,content:s?this.Eb(s):null,localChange:i.added.length>0||i.removed.length>0||i.updated.length>0?u.Change.Modified:u.Change.None,remoteChange:a!==null?u.Change.Modified:u.Change.None},n=l(r,!1);return[{baseResource:this.baseResource,baseContent:s?this.Eb(s):null,localResource:this.localResource,localContent:n,remoteResource:this.remoteResource,remoteContent:m?this.Eb(m):null,remoteProfiles:m,previewResource:this.previewResource,previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.acceptedResource}]}async ub(f){const b=f?.syncData?d(f.syncData):null,I=this.Db(),{remote:m}=(0,$.$ydc)(I,b,b,[]);return!!m?.added.length||!!m?.removed.length||!!m?.updated.length}async rb(f,b){return{...f.previewResult,hasConflicts:!1}}async sb(f,b,I,m){if(this.h.isEqual(b,this.localResource))return this.Ab(f);if(this.h.isEqual(b,this.remoteResource))return this.Bb(f);if(this.h.isEqual(b,this.previewResource))return f.previewResult;throw new Error(`Invalid Resource: ${b.toString()}`)}async Ab(f){const b=this.Db(),I=(0,$.$ydc)(b,null,null,[]),{local:m,remote:s}=I;return{content:f.localContent,local:m,remote:s,localChange:m.added.length>0||m.removed.length>0||m.updated.length>0?u.Change.Modified:u.Change.None,remoteChange:s!==null?u.Change.Modified:u.Change.None}}async Bb(f){const b=f.remoteContent?JSON.parse(f.remoteContent):null,I=[],m=[];for(const s of this.Db()){const r=b?.find(i=>i.id===s.id);r&&(I.push({id:s.id,name:s.name,collection:r.collection}),m.push(s))}if(b!==null){const s=(0,$.$ydc)(m,b,I,[]),{local:r,remote:i}=s;return{content:f.remoteContent,local:r,remote:i,localChange:r.added.length>0||r.removed.length>0||r.updated.length>0?u.Change.Modified:u.Change.None,remoteChange:i!==null?u.Change.Modified:u.Change.None}}else return{content:f.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:u.Change.None,remoteChange:u.Change.None}}async tb(f,b,I,m){const{local:s,remote:r,localChange:i,remoteChange:a}=I[0][1];i===u.Change.None&&a===u.Change.None&&this.O.info(`${this.D}: No changes found during synchronizing profiles.`);const t=I[0][0].remoteProfiles||[];if(t.length+(r?.added.length??0)-(r?.removed.length??0)>20)throw new u.$fnb("Too many profiles to sync. Please remove some profiles and try again.",u.UserDataSyncErrorCode.LocalTooManyProfiles);if(i!==u.Change.None&&(await this.nb(l(this.Db(),!1)),await Promise.all(s.removed.map(async n=>{this.O.trace(`${this.D}: Removing '${n.name}' profile...`),await this.vb.removeProfile(n),this.O.info(`${this.D}: Removed profile '${n.name}'.`)})),await Promise.all(s.added.map(async n=>{this.O.trace(`${this.D}: Creating '${n.name}' profile...`),await this.vb.createProfile(n.id,n.name,{shortName:n.shortName,icon:n.icon,useDefaultFlags:n.useDefaultFlags}),this.O.info(`${this.D}: Created profile '${n.name}'.`)})),await Promise.all(s.updated.map(async n=>{const o=this.vb.profiles.find(h=>h.id===n.id);o?(this.O.trace(`${this.D}: Updating '${n.name}' profile...`),await this.vb.updateProfile(o,{name:n.name,shortName:n.shortName,icon:n.icon,useDefaultFlags:n.useDefaultFlags}),this.O.info(`${this.D}: Updated profile '${n.name}'.`)):this.O.info(`${this.D}: Could not find profile with id '${n.id}' to update.`)}))),a!==u.Change.None){this.O.trace(`${this.D}: Updating remote profiles...`);const n=[],o=t.length+(r?.added.length??0)<=20;if(o)for(const h of r?.added||[]){const g=await this.J.createCollection(this.F);n.push(g),t.push({id:h.id,name:h.name,collection:g,shortName:h.shortName,icon:h.icon,useDefaultFlags:h.useDefaultFlags})}else this.O.info(`${this.D}: Could not create remote profiles as there are too many profiles.`);for(const h of r?.removed||[])t.splice(t.findIndex(({id:g})=>h.id===g),1);for(const h of r?.updated||[]){const g=t.find(({id:R})=>h.id===R);g&&t.splice(t.indexOf(g),1,{...g,id:h.id,name:h.name,shortName:h.shortName,icon:h.icon,useDefaultFlags:h.useDefaultFlags})}try{f=await this.updateRemoteProfiles(t,m?null:f.ref),this.O.info(`${this.D}: Updated remote profiles.${o&&r?.added.length?` Added: ${JSON.stringify(r.added.map(h=>h.name))}.`:""}${r?.updated.length?` Updated: ${JSON.stringify(r.updated.map(h=>h.name))}.`:""}${r?.removed.length?` Removed: ${JSON.stringify(r.removed.map(h=>h.name))}.`:""}`)}catch(h){if(n.length){this.O.info(`${this.D}: Failed to update remote profiles. Cleaning up added collections...`);for(const g of n)await this.J.deleteCollection(g,this.F)}throw h}for(const h of r?.removed||[])await this.J.deleteCollection(h.collection,this.F)}b?.ref!==f.ref&&(this.O.trace(`${this.D}: Updating last synchronized profiles...`),await this.fb(f),this.O.info(`${this.D}: Updated last synchronized profiles.`))}async updateRemoteProfiles(f,b){return this.mb(this.Eb(f),b)}async hasLocalData(){return this.Db().length>0}async resolveContent(f){if(this.h.isEqual(this.remoteResource,f)||this.h.isEqual(this.baseResource,f)||this.h.isEqual(this.localResource,f)||this.h.isEqual(this.acceptedResource,f)){const b=await this.db(f);return b&&(0,P.$6n)(JSON.parse(b),{})}return null}Db(){return this.vb.profiles.filter(f=>!f.isDefault&&!f.isTransient)}Eb(f){return JSON.stringify([...f].sort((b,I)=>b.name.localeCompare(I.name)))}};e.$zdc=p,e.$zdc=p=ve([Y(2,w.$Ll),Y(3,O.$_k),Y(4,N.$Mi),Y(5,T.$bq),Y(6,u.$anb),Y(7,u.$bnb),Y(8,u.$pnb),Y(9,c.$_i),Y(10,u.$knb),Y(11,k.$$l),Y(12,A.$Jl)],p);function l(y,f){const b=[...y].sort((I,m)=>I.name.localeCompare(m.name)).map(I=>({id:I.id,name:I.name}));return f?(0,P.$6n)(b,{}):JSON.stringify(b)}function d(y){return JSON.parse(y.content)}}),define(ce[264],le([0,1,3,2,5,16,17,18,25]),function(ne,e,P,c,N,O,T,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mdc=void 0;const w="sync.enable";let E=class extends c.$Wc{constructor(u,p,l,d){super(),this.c=u,this.f=p,this.g=l,this.h=d,this.a=new P.$me,this.onDidChangeEnablement=this.a.event,this.b=new P.$me,this.onDidChangeResourceEnablement=this.b.event,this.B(u.onDidChangeValue(T.StorageScope.APPLICATION,void 0,this.B(new c.$Vc))(y=>this.m(y)))}isEnabled(){switch(this.g.sync){case"on":return!0;case"off":return!1}return this.c.getBoolean(w,T.StorageScope.APPLICATION,!1)}canToggleEnablement(){return this.h.userDataSyncStore!==void 0&&this.g.sync===void 0}setEnablement(u){u&&!this.canToggleEnablement()||(this.f.publicLog2(w,{enabled:u}),this.c.store(w,u,T.StorageScope.APPLICATION,T.StorageTarget.MACHINE))}isResourceEnabled(u){return this.c.getBoolean((0,A.$jnb)(u),T.StorageScope.APPLICATION,!0)}setResourceEnablement(u,p){if(this.isResourceEnabled(u)!==p){const l=(0,A.$jnb)(u);this.j(l,p)}}getResourceSyncStateVersion(u){}j(u,p){this.c.store(u,p,T.StorageScope.APPLICATION,N.$o?T.StorageTarget.USER:T.StorageTarget.MACHINE)}m(u){if(w===u.key){this.a.fire(this.isEnabled());return}const p=A.$9mb.filter(l=>(0,A.$jnb)(l)===u.key)[0];if(p){this.b.fire([p,this.isResourceEnabled(p)]);return}}};e.$mdc=E,e.$mdc=E=ve([Y(0,T.$bq),Y(1,k.$$l),Y(2,O.$Mi),Y(3,A.$_mb)],E)}),define(ce[265],le([0,1,6,15,67,2,21,22,16,7,20,25]),function(ne,e,P,c,N,O,T,k,A,w,E,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xdc=void 0;let u=class extends O.$Wc{constructor(l,d,y,f,b){super(),this.a=l,this.b=d,this.c=y,this.f=f,this.g=b,this.h()}async h(){for(const d of this.g.profiles)for(const y of $.$9mb)try{await this.m(this.j(y,d.isDefault?void 0:d.id))}catch(f){this.f.error(f)}let l;try{l=await this.b.resolve(this.a.userDataSyncHome)}catch(d){(0,w.$ql)(d)!==w.FileOperationResult.FILE_NOT_FOUND&&this.f.error(d);return}if(l.children){for(const d of l.children)if(d.isDirectory&&!this.g.profiles.some(y=>y.id===d.name))try{this.f.info("Deleting non existing profile from backup",d.resource.path),await this.b.del(d.resource,{recursive:!0})}catch(y){this.f.error(y)}}}async getAllResourceRefs(l,d,y){const f=this.j(l,d,y);try{const b=await this.b.resolve(f);if(b.children)return b.children.filter(m=>m.isFile&&!m.name.startsWith("lastSync")).sort().reverse().map(m=>({ref:m.name,created:this.n(m)}))}catch(b){if((0,w.$ql)(b)!==w.FileOperationResult.FILE_NOT_FOUND)throw b}return[]}async resolveResourceContent(l,d,y,f){const b=this.j(l,y,f),I=(0,T.$gh)(b,d);try{return(await this.b.readFile(I)).value.toString()}catch(m){return this.f.error(m),null}}async writeResource(l,d,y,f,b){const I=this.j(l,f,b),m=(0,T.$gh)(I,`${(0,N.$3m)(y).replace(/-|:|\.\d+Z$/g,"")}.json`);try{await this.b.writeFile(m,c.$Oe.fromString(d))}catch(s){this.f.error(s)}}j(l,d,y=this.a.userDataSyncHome){return(0,T.$gh)(y,...d?[d,l]:[l])}async m(l){try{try{if(!await this.b.exists(l))return}catch{return}const d=await this.b.resolve(l);if(d.children){const y=d.children.filter(m=>m.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(m.name)).sort(),f=1e3*60*60*24*(this.c.getValue("sync.localBackupDuration")||30);let b=y.filter(m=>Date.now()-this.n(m)>f);const I=y.length-b.length;I<10&&(b=b.slice(10-I)),await P.Promises.settled(b.map(async m=>{this.f.info("Deleting from backup",m.resource.path),await this.b.del(m.resource)}))}}catch(d){this.f.error(d)}}n(l){return new Date(parseInt(l.name.substring(0,4)),parseInt(l.name.substring(4,6))-1,parseInt(l.name.substring(6,8)),parseInt(l.name.substring(9,11)),parseInt(l.name.substring(11,13)),parseInt(l.name.substring(13,15))).getTime()}};e.$xdc=u,e.$xdc=u=ve([Y(0,A.$Mi),Y(1,w.$_k),Y(2,k.$_i),Y(3,$.$pnb),Y(4,E.$Ll)],u)}),define(ce[87],le([0,1,3,2,5,27,187,16,7,4,24,50,17,25]),function(ne,e,P,c,N,O,T,k,A,w,E,$,u,p){"use strict";var l;Object.defineProperty(e,"__esModule",{value:!0}),e.$2mb=e.$Zmb=void 0,e.$1mb=s,e.$Zmb=(0,w.$Fi)("IUserDataSyncMachinesService");const d="sync.currentMachineName",y="Safari",f="Chrome",b="Edge",I="Firefox",m="Android";function s(a){switch(a){case y:case f:case b:case I:case m:case(0,N.$h)(N.Platform.Web):return!0}return!1}function r(){return N.$G?y:N.$E?f:N.$H?b:N.$F?I:N.$I?m:(0,N.$h)(N.$o?N.Platform.Web:N.$u)}let i=class extends c.$Wc{static{l=this}static{this.a=1}static{this.b="machines"}constructor(t,n,o,h,g,R){super(),this.h=o,this.j=h,this.m=g,this.n=R,this.c=this.B(new P.$me),this.onDidChange=this.c.event,this.g=null,this.f=(0,$.$hq)(t,n,o)}async getMachines(t){const n=await this.f;return(await this.s(t)).machines.map(h=>({...h,isCurrent:h.id===n}))}async addCurrentMachine(t){const n=await this.f,o=await this.s(t);o.machines.some(({id:h})=>h===n)||(o.machines.push({id:n,name:this.r(o.machines),platform:r()}),await this.t(o))}async removeCurrentMachine(t){const n=await this.f,o=await this.s(t),h=o.machines.filter(({id:g})=>g!==n);h.length!==o.machines.length&&(o.machines=h,await this.t(o))}async renameMachine(t,n,o){const h=await this.s(o),g=h.machines.find(({id:R})=>R===t);if(g){g.name=n,await this.t(h);const R=await this.f;t===R&&this.h.store(d,n,u.StorageScope.APPLICATION,u.StorageTarget.MACHINE)}}async setEnablements(t){const n=await this.s();for(const[o,h]of t){const g=n.machines.find(R=>R.id===o);g&&(g.disabled=h?void 0:!0)}await this.t(n)}r(t){const n=this.h.get(d,u.StorageScope.APPLICATION);if(n)return n;const o=`${this.n.embedderIdentifier?`${this.n.embedderIdentifier} - `:""}${r()} (${this.n.nameShort})`,h=new RegExp(`${(0,O.$if)(o)}\\s#(\\d+)`);let g=0;for(const R of t){const L=h.exec(R.name),S=L?parseInt(L[1]):0;g=S>g?S:g}return`${o} #${g+1}`}async s(t){this.g=await this.u(t);const n=this.w(this.g);if(n.version!==l.a)throw new Error((0,T.localize)(0,null,this.n.nameLong));return n}async t(t){const n=JSON.stringify(t),o=await this.j.writeResource(l.b,n,this.g?.ref||null);this.g={ref:o,content:n},this.c.fire()}async u(t){if(this.g){const n=t&&t.latest?t.latest[l.b]:void 0;if(this.g.ref===n)return this.g;if(n===void 0&&this.g.content===null)return this.g}return this.j.readResource(l.b,this.g)}w(t){if(t.content!==null)try{return JSON.parse(t.content)}catch(n){this.m.error(n)}return{version:l.a,machines:[]}}};e.$2mb=i,e.$2mb=i=l=ve([Y(0,k.$Mi),Y(1,A.$_k),Y(2,u.$bq),Y(3,p.$anb),Y(4,p.$pnb),Y(5,E.$sk)],i)}),define(ce[266],le([0,1,6,67,41,8,3,2,5,21,9,184,24,17,18,25,83,87]),function(ne,e,P,c,N,O,T,k,A,w,E,$,u,p,l,d,y,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ddc=void 0;const b="sync.disableMachineEventually",I="sync.sessionId",m="sync.storeUrl",s="sync.productQuality";let r=class extends k.$Wc{get n(){const t=this.H.get(m,p.StorageScope.APPLICATION);return t?E.URI.parse(t):void 0}set n(t){t?this.H.store(m,t.toString(),p.StorageScope.APPLICATION,p.StorageTarget.MACHINE):this.H.remove(m,p.StorageScope.APPLICATION)}get s(){return this.H.get(s,p.StorageScope.APPLICATION)}set s(t){t?this.H.store(s,t,p.StorageScope.APPLICATION,p.StorageTarget.MACHINE):this.H.remove(s,p.StorageScope.APPLICATION)}constructor(t,n,o,h,g,R,L,S,v,C){super(),this.u=n,this.w=o,this.y=h,this.z=g,this.C=R,this.D=L,this.F=S,this.G=v,this.H=C,this.a=this.B(new k.$Xc),this.b=0,this.c=void 0,this.g=!1,this.h=this.B(new T.$me),this.onError=this.h.event,this.S=[],this.f=this.B(new P.$Dh(this.U())),this.j=this.n,this.n=n.userDataSyncStore?.url,this.r=this.s,this.s=t.quality,this.n&&(this.C.info("Using settings sync service",this.n.toString()),this.B(n.onDidChangeUserDataSyncStore(()=>{(0,w.$_g)(this.n,n.userDataSyncStore?.url)||(this.j=this.n,this.n=n.userDataSyncStore?.url,this.n&&this.C.info("Using settings sync service",this.n.toString()))})),this.y.isEnabled()?this.C.info("Auto Sync is enabled."):this.C.info("Auto Sync is disabled."),this.I(),this.Q()&&this.P(),this.B(L.onDidChangeAccount(()=>this.I())),this.B(o.onDidChangeDonotMakeRequestsUntil(()=>this.I())),this.B(g.onDidChangeLocal(F=>this.triggerSync([F],!1,!1))),this.B(T.Event.filter(this.y.onDidChangeResourceEnablement,([,F])=>F)(()=>this.triggerSync(["resourceEnablement"],!1,!1))),this.B(this.u.onDidChangeUserDataSyncStore(()=>this.triggerSync(["userDataSyncStoreChanged"],!1,!1))))}I(){const{enabled:t,message:n}=this.L();t?this.a.value===void 0&&(this.a.value=new i(this.j,1e3*60*5,this.u,this.w,this.z,this.G,this.C,this.F,this.H),this.a.value.register(this.a.value.onDidStartSync(()=>this.c=new Date().getTime())),this.a.value.register(this.a.value.onDidFinishSync(o=>this.O(o))),this.J()&&this.a.value.start()):(this.f.cancel(),this.a.value!==void 0?(n&&this.C.info(n),this.a.clear()):n&&this.y.isEnabled()&&this.C.info(n))}J(){return!0}L(){return this.y.isEnabled()?this.D.account?this.w.donotMakeRequestsUntil?{enabled:!1,message:`Auto Sync: Suspended until ${(0,c.$3m)(this.w.donotMakeRequestsUntil)} because server is not accepting requests until then.`}:this.g?{enabled:!1,message:"Auto Sync: Suspended until restart."}:{enabled:!0}:{enabled:!1,message:"Auto Sync: Suspended until auth token is available."}:{enabled:!1,message:"Auto Sync: Disabled."}}async turnOn(){this.R(),this.j=this.n,this.M(!0)}async turnOff(t,n,o){try{this.D.account&&!o&&await this.G.removeCurrentMachine(),this.M(!1),this.H.remove(I,p.StorageScope.APPLICATION),t?(this.F.publicLog2("sync/turnOffEveryWhere"),await this.z.reset()):await this.z.resetLocal()}catch(h){if(this.C.error(h),n)this.M(!1);else throw h}}M(t){this.y.isEnabled()!==t&&(this.y.setEnablement(t),this.I())}N(){return!!this.r&&!!this.s&&this.r!==this.s}async O(t){if(!t){this.b=0;return}const n=d.$fnb.toUserDataSyncError(t);n instanceof d.$hnb&&this.F.publicLog2("autosync/error",{code:n.code,service:this.u.userDataSyncStore.url.toString()}),n.code===d.UserDataSyncErrorCode.SessionExpired?(await this.turnOff(!1,!0),this.C.info("Auto Sync: Turned off sync because current session is expired")):n.code===d.UserDataSyncErrorCode.TurnedOff?(await this.turnOff(!1,!0),this.C.info("Auto Sync: Turned off sync because sync is turned off in the cloud")):n.code===d.UserDataSyncErrorCode.LocalTooManyRequests?(this.g=!0,this.C.info("Auto Sync: Suspended sync because of making too many requests to server"),this.I()):n.code===d.UserDataSyncErrorCode.TooManyRequests?(await this.turnOff(!1,!0,!0),this.P(),this.C.info("Auto Sync: Turned off sync because of making too many requests to server")):n.code===d.UserDataSyncErrorCode.MethodNotFound?(await this.turnOff(!1,!0),this.C.info("Auto Sync: Turned off sync because current client is making requests to server that are not supported")):n.code===d.UserDataSyncErrorCode.UpgradeRequired||n.code===d.UserDataSyncErrorCode.Gone?(await this.turnOff(!1,!0,!0),this.P(),this.C.info("Auto Sync: Turned off sync because current client is not compatible with server. Requires client upgrade.")):n.code===d.UserDataSyncErrorCode.IncompatibleLocalContent?(await this.turnOff(!1,!0),this.C.info(`Auto Sync: Turned off sync because server has ${n.resource} content with newer version than of client. Requires client upgrade.`)):n.code===d.UserDataSyncErrorCode.IncompatibleRemoteContent?(await this.turnOff(!1,!0),this.C.info(`Auto Sync: Turned off sync because server has ${n.resource} content with older version than of client. Requires server reset.`)):n.code===d.UserDataSyncErrorCode.ServiceChanged||n.code===d.UserDataSyncErrorCode.DefaultServiceChanged?A.$o&&n.code===d.UserDataSyncErrorCode.DefaultServiceChanged&&!this.N()?(await this.turnOff(!1,!0),this.C.info("Auto Sync: Turned off sync because default sync service is changed.")):(await this.turnOff(!1,!0,!0),await this.turnOn(),this.C.info("Auto Sync: Sync Service changed. Turned off auto sync, reset local state and turned on auto sync.")):(this.C.error(n),this.b++),this.h.fire(n)}async P(){this.H.store(b,!0,p.StorageScope.APPLICATION,p.StorageTarget.MACHINE),await(0,P.$Gh)(1e3*60*10),this.Q()&&(this.R(),!this.y.isEnabled()&&this.D.account&&await this.G.removeCurrentMachine())}Q(){return this.H.getBoolean(b,p.StorageScope.APPLICATION,!1)}R(){this.H.remove(b,p.StorageScope.APPLICATION)}async triggerSync(t,n,o){if(this.a.value===void 0)return this.f.cancel();if(n&&this.c&&Math.round((new Date().getTime()-this.c)/1e3)<10){this.C.debug("Auto Sync: Skipped. Limited to once per 10 seconds.");return}return this.S.push(...t),this.f.trigger(async()=>{this.C.trace("activity sources",...this.S);const h=this.D.account?.authenticationProviderId||"";this.F.publicLog2("sync/triggered",{sources:this.S,providerId:h}),this.S=[],this.a.value&&await this.a.value.sync("Activity",o)},this.b?this.U()*1*Math.min(Math.pow(2,this.b),60):this.U())}U(){return 2e3}};e.$Ddc=r,e.$Ddc=r=ve([Y(0,u.$sk),Y(1,d.$_mb),Y(2,d.$anb),Y(3,d.$knb),Y(4,d.$lnb),Y(5,d.$pnb),Y(6,y.$WLb),Y(7,l.$$l),Y(8,f.$Zmb),Y(9,p.$bq)],r);class i extends k.$Wc{static{this.a="Interval"}constructor(t,n,o,h,g,R,L,S,v){super(),this.m=t,this.n=n,this.r=o,this.s=h,this.u=g,this.w=R,this.y=L,this.z=S,this.C=v,this.b=this.B(new k.$Xc),this.c=this.B(new T.$me),this.onDidStartSync=this.c.event,this.f=this.B(new T.$me),this.onDidFinishSync=this.f.event,this.g=null}start(){this.B(this.onDidFinishSync(()=>this.D())),this.B((0,k.$Uc)(()=>{this.j&&(this.j.cancel(),this.y.info("Auto sync: Cancelled sync that is in progress"),this.j=void 0),this.h?.stop(),this.y.info("Auto Sync: Stopped")})),this.sync(i.a,!1)}D(){this.b.value=(0,P.$Hh)(()=>{this.sync(i.a,!1),this.b.value=void 0},this.n)}sync(t,n){const o=(0,P.$sh)(async h=>{if(this.j)try{this.y.debug("Auto Sync: Waiting until sync is finished."),await this.j}catch(g){if((0,O.$6)(g))return}return this.H(t,n,h)});return this.j=o,this.j.finally(()=>this.j=void 0),this.j}F(){return this.m!==void 0&&!(0,w.$_g)(this.m,this.r.userDataSyncStore?.url)}async G(){const t=await this.r.getPreviousUserDataSyncStore(),n=this.r.userDataSyncStore;return!!n&&!!t&&(!(0,w.$_g)(n.defaultUrl,t.defaultUrl)||!(0,w.$_g)(n.insidersUrl,t.insidersUrl)||!(0,w.$_g)(n.stableUrl,t.stableUrl))}async H(t,n,o){this.y.info(`Auto Sync: Triggered by ${t}`),this.c.fire();let h;try{await this.I(n,o)}catch(g){if(this.y.error(g),h=g,d.$fnb.toUserDataSyncError(g).code===d.UserDataSyncErrorCode.MethodNotFound)try{this.y.info("Auto Sync: Client is making invalid requests. Cleaning up data..."),await this.u.cleanUpRemoteData(),this.y.info("Auto Sync: Retrying sync..."),await this.I(n,o),h=void 0}catch(R){this.y.error(R),h=R}}this.f.fire(h)}async I(t,n){if(this.h=await this.u.createSyncTask(this.g,t),n.isCancellationRequested)return;if(this.g=this.h.manifest,this.g===null&&await this.u.hasPreviouslySynced())throw this.F()?await this.G()?new d.$hnb((0,$.localize)(0,null),d.UserDataSyncErrorCode.DefaultServiceChanged):new d.$hnb((0,$.localize)(1,null),d.UserDataSyncErrorCode.ServiceChanged):new d.$hnb((0,$.localize)(2,null),d.UserDataSyncErrorCode.TurnedOff);const o=this.C.get(I,p.StorageScope.APPLICATION);if(o&&this.g&&o!==this.g.session)throw this.F()?await this.G()?new d.$hnb((0,$.localize)(3,null),d.UserDataSyncErrorCode.DefaultServiceChanged):new d.$hnb((0,$.localize)(4,null),d.UserDataSyncErrorCode.ServiceChanged):new d.$hnb((0,$.localize)(5,null),d.UserDataSyncErrorCode.SessionExpired);const h=await this.w.getMachines(this.g||void 0);if(n.isCancellationRequested)return;const g=h.find(L=>L.isCurrent);if(g?.disabled)throw new d.$hnb((0,$.localize)(6,null),d.UserDataSyncErrorCode.TurnedOff);const R=new Date().getTime();if(await this.h.run(),this.z.publicLog2("settingsSync:sync",{duration:new Date().getTime()-R}),this.g===null)try{this.g=await this.s.manifest(null)}catch(L){throw new d.$hnb((0,N.$qj)(L),L instanceof d.$fnb?L.code:d.UserDataSyncErrorCode.Unknown)}this.g&&this.g.session!==o&&this.C.store(I,this.g.session,p.StorageScope.APPLICATION,p.StorageTarget.MACHINE),!n.isCancellationRequested&&(g||await this.w.addCurrentMachine(this.g||void 0))}register(t){return super.B(t)}}}),define(ce[267],le([0,1,9,188,16,7,50,17,29,25,20,40,124,123,122,22,125,120,121,4,126,45,27]),function(ne,e,P,c,N,O,T,k,A,w,E,$,u,p,l,d,y,f,b,I,m,s,r){"use strict";var i;Object.defineProperty(e,"__esModule",{value:!0}),e.$gec=void 0;let a=class{static{i=this}static{this.a="not-existing-resource"}static{this.b="remote-backup"}static{this.c="local-backup"}constructor(n,o,h,g,R,L,S,v,C,F){this.e=n,this.f=o,this.g=h,this.h=R,this.i=L,this.j=S,this.k=v,this.l=C,this.n=F,this.d=g.extUri}async getRemoteSyncedProfiles(){const n=await this.e.readResource(w.SyncResource.Profiles,null,void 0);if(n.content){const o=this.L(n.content,w.SyncResource.Profiles);return(0,m.$Bdc)(o)}return[]}async getLocalSyncedProfiles(n){const o=await this.f.getAllResourceRefs(w.SyncResource.Profiles,void 0,n);if(o.length){const h=await this.f.resolveResourceContent(w.SyncResource.Profiles,o[0].ref,void 0,n);if(h){const g=this.L(h,w.SyncResource.Profiles);return(0,m.$Bdc)(g)}}return[]}async getLocalSyncedMachines(n){const o=await this.f.getAllResourceRefs("machines",void 0,n);if(o.length){const h=await this.f.resolveResourceContent("machines",o[0].ref,void 0,n);if(h)return JSON.parse(h).machines.map(R=>({...R,isCurrent:!1}))}return[]}async getRemoteSyncResourceHandles(n,o){return(await this.e.getAllResourceRefs(n,o?.collection)).map(({created:g,ref:R})=>({created:g,uri:this.J({remote:!0,syncResource:n,profile:o?.id??this.k.defaultProfile.id,location:void 0,collection:o?.collection,ref:R,node:void 0})}))}async getLocalSyncResourceHandles(n,o,h){return(await this.f.getAllResourceRefs(n,o?.collection,h)).map(({created:R,ref:L})=>({created:R,uri:this.J({remote:!1,syncResource:n,profile:o?.id??this.k.defaultProfile.id,collection:o?.collection,ref:L,node:void 0,location:h})}))}resolveUserDataSyncResource({uri:n}){const o=this.K(n),h=o?this.k.profiles.find(g=>g.id===o.profile):void 0;return o&&h?{profile:h,syncResource:o?.syncResource}:void 0}async getAssociatedResources({uri:n}){const o=this.K(n);if(!o)return[];const h=this.k.profiles.find(g=>g.id===o.profile);switch(o.syncResource){case w.SyncResource.Settings:return this.s(n,h);case w.SyncResource.Keybindings:return this.u(n,h);case w.SyncResource.Tasks:return this.w(n,h);case w.SyncResource.Snippets:return this.y(n,h);case w.SyncResource.GlobalState:return this.D(n,h);case w.SyncResource.Extensions:return this.A(n,h);case w.SyncResource.Profiles:return this.G(n,h);case w.SyncResource.WorkspaceState:return[]}}async getMachineId({uri:n}){const o=this.K(n);if(o){if(o.remote){if(o.ref){const{content:h}=await this.M(o.syncResource,o.ref,o.collection);if(h)return this.L(h,o.syncResource)?.machineId}return}if(o.location){if(o.ref){const h=await this.f.resolveResourceContent(o.syncResource,o.ref,o.collection,o.location);if(h)return this.L(h,o.syncResource)?.machineId}return}return(0,T.$hq)(this.h,this.j,this.i)}}async resolveContent(n){const o=this.K(n);if(!o||o.node===i.a)return null;if(o.ref){const h=await this.o(o.remote,o.syncResource,o.collection,o.ref,o.location);return o.node&&h?this.q(o.syncResource,h,o.node):h}return!o.remote&&!o.node?this.r(o.syncResource,o.profile):null}async o(n,o,h,g,R){if(n){const{content:L}=await this.M(o,g,h);return L}return this.f.resolveResourceContent(o,g,h,R)}q(n,o,h){const g=this.L(o,n);switch(n){case w.SyncResource.Settings:return this.t(g,h);case w.SyncResource.Keybindings:return this.v(g,h);case w.SyncResource.Tasks:return this.x(g,h);case w.SyncResource.Snippets:return this.z(g,h);case w.SyncResource.GlobalState:return this.E(g,h);case w.SyncResource.Extensions:return this.B(g,h);case w.SyncResource.Profiles:return this.H(g,h);case w.SyncResource.WorkspaceState:return null}}async r(n,o){const h=this.k.profiles.find(g=>g.id===o);if(!h)return null;switch(n){case w.SyncResource.GlobalState:return this.F(h);case w.SyncResource.Extensions:return this.C(h);case w.SyncResource.Profiles:return this.I(h);case w.SyncResource.Settings:return null;case w.SyncResource.Keybindings:return null;case w.SyncResource.Tasks:return null;case w.SyncResource.Snippets:return null;case w.SyncResource.WorkspaceState:return null}}s(n,o){const h=this.d.joinPath(n,"settings.json"),g=o?o.settingsResource:this.d.joinPath(n,i.a);return[{resource:h,comparableResource:g}]}t(n,o){switch(o){case"settings.json":return(0,p.$Ibc)(n.content).settings}return null}u(n,o){const h=this.d.joinPath(n,"keybindings.json"),g=o?o.keybindingsResource:this.d.joinPath(n,i.a);return[{resource:h,comparableResource:g}]}v(n,o){switch(o){case"keybindings.json":return(0,l.$Fbc)(n.content,!!this.l.getValue(w.$6mb),this.g)}return null}w(n,o){const h=this.d.joinPath(n,"tasks.json"),g=o?o.tasksResource:this.d.joinPath(n,i.a);return[{resource:h,comparableResource:g}]}x(n,o){switch(o){case"tasks.json":return(0,y.$Qbc)(n.content,this.g)}return null}async y(n,o){const h=await this.resolveContent(n);if(h){const g=this.L(h,w.SyncResource.Snippets);if(g){const R=(0,u.$Nbc)(g),L=[];for(const S of Object.keys(R)){const v=this.d.joinPath(n,S),C=o?this.d.joinPath(o.snippetsHome,S):this.d.joinPath(n,i.a);L.push({resource:v,comparableResource:C})}return L}}return[]}z(n,o){return(0,u.$Nbc)(n)[o]||null}A(n,o){const h=this.d.joinPath(n,"extensions.json"),g=o?this.J({remote:!1,syncResource:w.SyncResource.Extensions,profile:o.id,location:void 0,collection:void 0,ref:void 0,node:void 0}):this.d.joinPath(n,i.a);return[{resource:h,comparableResource:g}]}B(n,o){switch(o){case"extensions.json":return(0,f.$Abc)((0,f.$zbc)(n),!0)}return null}async C(n){const{localExtensions:o}=await this.n.createInstance(f.$Cbc).getLocalExtensions(n);return(0,f.$Abc)(o,!0)}D(n,o){const h=this.d.joinPath(n,"globalState.json"),g=o?this.J({remote:!1,syncResource:w.SyncResource.GlobalState,profile:o.id,location:void 0,collection:void 0,ref:void 0,node:void 0}):this.d.joinPath(n,i.a);return[{resource:h,comparableResource:g}]}E(n,o){switch(o){case"globalState.json":return(0,b.$HNb)(JSON.parse(n.content),!0)}return null}async F(n){const o=await this.n.createInstance(b.$JNb).getLocalGlobalState(n);return(0,b.$HNb)(o,!0)}G(n,o){const h=this.d.joinPath(n,"profiles.json"),g=this.J({remote:!1,syncResource:w.SyncResource.Profiles,profile:this.k.defaultProfile.id,location:void 0,collection:void 0,ref:void 0,node:void 0});return[{resource:h,comparableResource:g}]}H(n,o){switch(o){case"profiles.json":return(0,s.$6n)(JSON.parse(n.content),{})}return null}async I(n){return(0,m.$Adc)(this.k.profiles.filter(o=>!o.isDefault&&!o.isTransient),!0)}J(n){const o=n.remote?i.b:i.c,h=[];return n.location&&(h.push(`scheme:${n.location.scheme}`),h.push(`authority:${n.location.authority}`),h.push((0,r.$mf)(n.location.path,"/"))),h.push(`syncResource:${n.syncResource}`),h.push(`profile:${n.profile}`),n.collection&&h.push(`collection:${n.collection}`),n.ref&&h.push(`ref:${n.ref}`),n.node&&h.push(n.node),this.d.joinPath(P.URI.from({scheme:w.$rnb,authority:o,path:"/",query:n.location?.query,fragment:n.location?.fragment}),...h)}K(n){if(n.scheme!==w.$rnb)return;const o=[];for(;n.path!=="/";)o.unshift(this.d.basename(n)),n=this.d.dirname(n);if(o.length<2)return;const h=n.authority===i.b;let g,R;const L=[];let S,v,C,F,D;for(;o.length;){const M=o.shift();M.startsWith("scheme:")?g=M.substring(7):M.startsWith("authority:")?R=M.substring(10):M.startsWith("syncResource:")?S=M.substring(13):M.startsWith("profile:")?v=M.substring(8):M.startsWith("collection:")?C=M.substring(11):M.startsWith("ref:")?F=M.substring(4):S?D=M:L.push(M)}return{remote:h,syncResource:S,profile:v,collection:C,ref:F,node:D,location:g&&R!==void 0?this.d.joinPath(P.URI.from({scheme:g,authority:R,query:n.query,fragment:n.fragment,path:"/"}),...L):void 0}}L(n,o){try{const h=JSON.parse(n);if((0,$.$ANb)(h))return h}catch(h){this.g.error(h)}throw new w.$fnb((0,c.localize)(0,null),w.UserDataSyncErrorCode.IncompatibleRemoteContent,o)}async M(n,o,h){const g=await this.e.resolveResourceContent(n,o,h);return{ref:o,content:g}}};e.$gec=a,e.$gec=a=i=ve([Y(0,w.$anb),Y(1,w.$bnb),Y(2,w.$pnb),Y(3,A.$Jl),Y(4,N.$Mi),Y(5,k.$bq),Y(6,O.$_k),Y(7,E.$Ll),Y(8,d.$_i),Y(9,I.$Ei)],a)}),define(ce[268],le([0,1,19,6,26,41,3,2,21,13,32,22,28,7,4,17,18,20,120,121,122,123,124,125,126,25]),function(ne,e,P,c,N,O,T,k,A,w,E,$,u,p,l,d,y,f,b,I,m,s,r,i,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cdc=void 0;const n="sync.lastSyncTime";let o=class extends k.$Wc{get status(){return this.f}get conflicts(){return this.j}get lastSyncTime(){return this.t}constructor(S,v,C,F,D,M,J,H,x,K,ie){super(),this.C=S,this.D=v,this.F=C,this.G=F,this.H=D,this.I=M,this.J=J,this.L=H,this.M=x,this.N=K,this.O=ie,this.f=t.SyncStatus.Uninitialized,this.g=this.B(new T.$me),this.onDidChangeStatus=this.g.event,this.h=this.B(new T.$me),this.onDidChangeLocal=this.h.event,this.j=[],this.m=this.B(new T.$me),this.onDidChangeConflicts=this.m.event,this.n=[],this.r=this.B(new T.$me),this.onSyncErrors=this.r.event,this.t=void 0,this.u=this.B(new T.$me),this.onDidChangeLastSyncTime=this.u.event,this.w=this.B(new T.$me),this.onDidResetLocal=this.w.event,this.y=this.B(new T.$me),this.onDidResetRemote=this.y.event,this.z=new Map,this.f=C.userDataSyncStore?t.SyncStatus.Idle:t.SyncStatus.Uninitialized,this.t=this.J.getNumber(n,d.StorageScope.APPLICATION,void 0),this.B((0,k.$Uc)(()=>this.cb())),this.B(new c.$Rh(()=>this.W(),5*1e3)).schedule()}async createSyncTask(S,v){this.db(),this.H.info("Sync started.");const C=new Date().getTime(),F=(0,E.$2g)();try{const H=(0,t.$enb)(F);v&&(H["Cache-Control"]="no-cache"),S=await this.D.manifest(S,H)}catch(H){const x=t.$fnb.toUserDataSyncError(H);throw R(x,F,this.F,this.I),x}const D=!1,M=this;let J;return{manifest:S,async run(){if(D)throw new Error("Can run a task only once");J=(0,c.$sh)(H=>M.P(S,!1,F,H)),await J.finally(()=>J=void 0),M.H.info(`Sync done. Took ${new Date().getTime()-C}ms`),M.ab()},stop(){return J?.cancel(),M.U()}}}async createManualSyncTask(){if(this.db(),this.L.isEnabled())throw new t.$fnb("Cannot start manual sync when sync is enabled",t.UserDataSyncErrorCode.LocalError);this.H.info("Sync started.");const S=new Date().getTime(),v=(0,E.$2g)(),C=(0,t.$enb)(v);let F;try{F=await this.D.manifest(null,C)}catch(J){const H=t.$fnb.toUserDataSyncError(J);throw R(H,v,this.F,this.I),H}await this.resetLocal();const D=this,M=new N.$xe;return{id:v,async merge(){return D.P(F,!0,v,M.token)},async apply(){try{try{await D.R(F,v,M.token)}catch(J){if(t.$fnb.toUserDataSyncError(J).code===t.UserDataSyncErrorCode.MethodNotFound)D.H.info("Client is making invalid requests. Cleaning up data..."),await D.cleanUpRemoteData(),D.H.info("Applying manual sync again..."),await D.R(F,v,M.token);else throw J}}catch(J){throw D.H.error(J),J}D.H.info(`Sync done. Took ${new Date().getTime()-S}ms`),D.ab()},async stop(){M.cancel(),await D.U(),await D.resetLocal()}}}async P(S,v,C,F){this.n=[];try{this.status!==t.SyncStatus.HasConflicts&&this.Z(t.SyncStatus.Syncing);const D=this.getOrCreateActiveProfileSynchronizer(this.M.defaultProfile,void 0);this.n.push(...await this.S(D,S,v,C,F));const M=D.enabled.find(J=>J.resource===t.SyncResource.Profiles);if(M){const J=await M.getLastSyncedProfiles()||[];if(F.isCancellationRequested)return;await this.Q(J,S,v,C,F)}}finally{this.status!==t.SyncStatus.HasConflicts&&this.Z(t.SyncStatus.Idle),this.r.fire(this.n)}}async Q(S,v,C,F,D){for(const M of S){if(D.isCancellationRequested)return;const J=this.M.profiles.find(x=>x.id===M.id);if(!J){this.H.error(`Profile with id:${M.id} and name: ${M.name} does not exist locally to sync.`);continue}this.H.info("Syncing profile.",M.name);const H=this.getOrCreateActiveProfileSynchronizer(J,M);this.n.push(...await this.S(H,v,C,F,D))}for(const[M,J]of this.z.entries())this.M.profiles.some(H=>H.id===J[0].profile.id)||(await J[0].resetLocal(),J[1].dispose(),this.z.delete(M))}async R(S,v,C){const F=this.bb();for(const x of F){if(C.isCancellationRequested)return;await x.apply(v,C)}const D=F.find(x=>x.profile.isDefault);if(!D)return;const M=D.enabled.find(x=>x.resource===t.SyncResource.Profiles);if(!M)return;const H=(await M.getRemoteSyncedProfiles(S?.latest??null)||[]).filter(x=>F.every(K=>K.profile.id!==x.id));H.length&&await this.Q(H,S,!1,v,C)}async S(S,v,C,F,D){return(await S.sync(v,C,F,D)).map(([J,H])=>({profile:S.profile,syncResource:J,error:H}))}async U(){this.status!==t.SyncStatus.Idle&&await Promise.allSettled(this.bb().map(S=>S.stop()))}async resolveContent(S){const v=await this.N.resolveContent(S);if(v)return v;for(const C of this.bb())for(const F of C.enabled){const D=await F.resolveContent(S);if(D)return D}return null}async replace(S){this.db();const v=this.N.resolveUserDataSyncResource(S);if(!v)return;const C=await this.resolveContent(S.uri);C&&await this.X(v.profile,async F=>{if(v.syncResource===F.resource)return await F.replace(C),!0})}async accept(S,v,C,F){this.db(),await this.X(S.profile,async D=>{if(S.syncResource===D.resource)return await D.accept(v,C),F&&await D.apply((0,w.$lg)(F)?!1:F.force,(0,t.$enb)((0,E.$2g)())),!0})}async hasLocalData(){return!!await this.X(this.M.defaultProfile,async v=>{if(v.resource!==t.SyncResource.GlobalState&&await v.hasLocalData())return!0})}async hasPreviouslySynced(){return!!await this.X(this.M.defaultProfile,async v=>{if(await v.hasPreviouslySynced())return!0})}async reset(){this.db(),await this.resetRemote(),await this.resetLocal()}async resetRemote(){this.db();try{await this.D.clear(),this.H.info("Cleared data on server")}catch(S){this.H.error(S)}this.y.fire()}async resetLocal(){this.db(),this.t=void 0,this.J.remove(n,d.StorageScope.APPLICATION);for(const[S]of this.z.values())try{await S.resetLocal()}catch(v){this.H.error(v)}this.cb(),this.w.fire(),this.H.info("Did reset the local sync state.")}async W(){const S=this.J.keys(d.StorageScope.APPLICATION,d.StorageTarget.MACHINE),v=[];for(const F of S){if(!F.endsWith(".lastSyncUserData"))continue;const D=F.split(".");D.length===3&&v.push([F,D[0]])}if(!v.length)return;const C=new k.$Vc;try{let F=this.z.get(this.M.defaultProfile.id)?.[0];F||(F=C.add(this.G.createInstance(h,this.M.defaultProfile,void 0)));const D=F.enabled.find(H=>H.resource===t.SyncResource.Profiles);if(!D)return;const J=(await D.getLastSyncedProfiles())?.map(H=>H.collection)??[];for(const[H,x]of v)J.includes(x)||(this.H.info(`Removing last sync state for stale profile: ${x}`),this.J.remove(H,d.StorageScope.APPLICATION))}finally{C.dispose()}}async cleanUpRemoteData(){const S=await this.N.getRemoteSyncedProfiles(),v=S.map(M=>M.collection),C=await this.D.getAllCollections(),F=C.filter(M=>!v.includes(M));F.length&&(this.H.info(`Deleting ${F.length} redundant collections on server`),await Promise.allSettled(F.map(M=>this.D.deleteCollection(M))),this.H.info("Deleted redundant collections on server"));const D=S.filter(M=>C.includes(M.collection));if(D.length!==S.length){const M=this.G.createInstance(a.$zdc,this.M.defaultProfile,void 0);try{this.H.info("Resetting the last synced state of profiles"),await M.resetLocal(),this.H.info("Did reset the last synced state of profiles"),this.H.info("Updating remote profiles with invalid collections on server"),await M.updateRemoteProfiles(D,null),this.H.info("Updated remote profiles on server")}finally{M.dispose()}}}async saveRemoteActivityData(S){this.db();const v=await this.D.getActivityData();await this.C.writeFile(S,v)}async extractActivityData(S,v){const C=(await this.C.readFile(S)).value.toString(),F=JSON.parse(C);if(F.resources)for(const D in F.resources)for(const M of F.resources[D])await this.O.writeResource(D,M.content,new Date(M.created*1e3),void 0,v);if(F.collections)for(const D in F.collections)for(const M in F.collections[D].resources)for(const J of F.collections[D].resources?.[M]??[])await this.O.writeResource(M,J.content,new Date(J.created*1e3),D,v)}async X(S,v){const C=new k.$Vc;try{const F=this.z.get(S.id);if(F){const x=await this.Y(F[0],v,C);return(0,w.$mg)(x)?null:x}if(S.isDefault){const x=C.add(this.G.createInstance(h,S,void 0)),K=await this.Y(x,v,C);return(0,w.$mg)(K)?null:K}if(this.M.isEnabled())return null;const D=C.add(this.G.createInstance(a.$zdc,S,void 0)),M=await this.D.manifest(null),H=(await D.getRemoteSyncedProfiles(M?.latest??null)||[]).find(x=>x.id===S.id);if(H){const x=C.add(this.G.createInstance(h,S,H.collection)),K=await this.Y(x,v,C);return(0,w.$mg)(K)?null:K}return null}finally{C.dispose()}}async Y(S,v,C){const F=[...S.enabled,...S.disabled.reduce((D,M)=>(M!==t.SyncResource.WorkspaceState&&D.push(C.add(S.createSynchronizer(M))),D),[])];for(const D of F){const M=await v(D);if(!(0,w.$mg)(M))return M}}Z(S){const v=this.f;this.f!==S&&(this.f=S,this.g.fire(S),v===t.SyncStatus.HasConflicts&&this.ab())}$(){const S=this.bb().map(v=>v.conflicts).flat();(0,P.$wb)(this.j,S,(v,C)=>v.profile.id===C.profile.id&&v.syncResource===C.syncResource&&(0,P.$wb)(v.conflicts,C.conflicts,(F,D)=>(0,A.$_g)(F.previewResource,D.previewResource)))||(this.j=S,this.m.fire(S))}ab(){this.status===t.SyncStatus.Idle&&(this.t=new Date().getTime(),this.J.store(n,this.t,d.StorageScope.APPLICATION,d.StorageTarget.MACHINE),this.u.fire(this.t))}getOrCreateActiveProfileSynchronizer(S,v){let C=this.z.get(S.id);if(C&&C[0].collection!==v?.collection&&(this.H.error("Profile synchronizer collection does not match with the remote sync profile collection"),C[1].dispose(),C=void 0,this.z.delete(S.id)),!C){const F=new k.$Vc,D=F.add(this.G.createInstance(h,S,v?.collection));F.add(D.onDidChangeStatus(M=>this.Z(M))),F.add(D.onDidChangeConflicts(M=>this.$())),F.add(D.onDidChangeLocal(M=>this.h.fire(M))),this.z.set(S.id,C=[D,F])}return C[0]}bb(){const S=[];for(const[v]of this.z.values())S.push(v);return S}cb(){this.z.forEach(([,S])=>S.dispose()),this.z.clear()}db(){if(!this.F.userDataSyncStore)throw new Error("Not enabled")}};e.$Cdc=o,e.$Cdc=o=ve([Y(0,p.$_k),Y(1,t.$anb),Y(2,t.$_mb),Y(3,l.$Ei),Y(4,t.$pnb),Y(5,y.$$l),Y(6,d.$bq),Y(7,t.$knb),Y(8,f.$Ll),Y(9,t.$mnb),Y(10,t.$bnb)],o);let h=class extends k.$Wc{get enabled(){return this.f.sort((S,v)=>S[1]-v[1]).map(([S])=>S)}get disabled(){return t.$9mb.filter(S=>!this.r.isResourceEnabled(S))}get status(){return this.g}get conflicts(){return this.m}constructor(S,v,C,F,D,M,J,H,x,K){super(),this.profile=S,this.collection=v,this.r=C,this.t=F,this.u=D,this.w=M,this.y=J,this.z=H,this.C=x,this.D=K,this.f=[],this.g=t.SyncStatus.Idle,this.h=this.B(new T.$me),this.onDidChangeStatus=this.h.event,this.j=this.B(new T.$me),this.onDidChangeLocal=this.j.event,this.m=[],this.n=this.B(new T.$me),this.onDidChangeConflicts=this.n.event,this.B(C.onDidChangeResourceEnablement(([ie,V])=>this.F(ie,V))),this.B((0,k.$Uc)(()=>this.f.splice(0,this.f.length).forEach(([,,ie])=>ie.dispose())));for(const ie of t.$9mb)C.isResourceEnabled(ie)&&this.G(ie)}F(S,v){v?this.G(S):this.H(S)}G(S){if(this.f.some(([D])=>D.resource===S))return;if(S===t.SyncResource.Extensions&&!this.u.isEnabled()){this.z.info("Skipping extensions sync because gallery is not configured");return}if(S===t.SyncResource.Profiles&&(!this.profile.isDefault||!this.C.isEnabled())||S===t.SyncResource.WorkspaceState)return;if(S!==t.SyncResource.Profiles&&this.profile.useDefaultFlags?.[S]){this.z.debug(`Skipping syncing ${S} in ${this.profile.name} because it is already synced by default profile`);return}const v=new k.$Vc,C=v.add(this.createSynchronizer(S));v.add(C.onDidChangeStatus(()=>this.L())),v.add(C.onDidChangeConflicts(()=>this.M())),v.add(C.onDidChangeLocal(()=>this.j.fire(S)));const F=this.N(S);this.f.push([C,F,v])}H(S){const v=this.f.findIndex(([C])=>C.resource===S);if(v!==-1){const[[C,,F]]=this.f.splice(v,1);F.dispose(),this.L(),Promise.allSettled([C.stop(),C.resetLocal()]).then(null,D=>this.z.error(D))}}createSynchronizer(S){switch(S){case t.SyncResource.Settings:return this.t.createInstance(s.$Jbc,this.profile,this.collection);case t.SyncResource.Keybindings:return this.t.createInstance(m.$Gbc,this.profile,this.collection);case t.SyncResource.Snippets:return this.t.createInstance(r.$Obc,this.profile,this.collection);case t.SyncResource.Tasks:return this.t.createInstance(i.$Rbc,this.profile,this.collection);case t.SyncResource.GlobalState:return this.t.createInstance(I.$INb,this.profile,this.collection);case t.SyncResource.Extensions:return this.t.createInstance(b.$Bbc,this.profile,this.collection);case t.SyncResource.Profiles:return this.t.createInstance(a.$zdc,this.profile,this.collection)}}async sync(S,v,C,F){if(F.isCancellationRequested)return[];const D=this.enabled;if(!D.length)return[];try{const M=[],J=(0,t.$enb)(C),H=(this.collection?S?.collections?.[this.collection]?.latest:S?.latest)??null,x=v?await this.I(H):{};for(const K of D){if(F.isCancellationRequested)return[];if(!this.r.isResourceEnabled(K.resource))return[];try{if(v){const ie=await K.preview(H,x,J);if(ie)for(const V of ie.resourcePreviews)(V.localChange!==t.Change.None||V.remoteChange!==t.Change.None)&&V.mergeState===t.MergeState.Preview&&await K.merge(V.previewResource)}else await K.sync(H,J)}catch(ie){const V=t.$fnb.toUserDataSyncError(ie);if(R(V,C,this.w,this.y),g(ie))throw V;this.z.error(ie),this.z.error(`${K.resource}: ${(0,O.$qj)(ie)}`),M.push([K.resource,V])}}return M}finally{this.L()}}async apply(S,v){const C=(0,t.$enb)(S);for(const F of this.enabled){if(v.isCancellationRequested)return;try{await F.apply(!1,C)}catch(D){const M=t.$fnb.toUserDataSyncError(D);if(R(M,S,this.w,this.y),g(D))throw M;this.z.error(D),this.z.error(`${F.resource}: ${(0,O.$qj)(D)}`)}}}async stop(){for(const S of this.enabled)try{S.status!==t.SyncStatus.Idle&&await S.stop()}catch(v){this.z.error(v)}}async resetLocal(){for(const S of this.enabled)try{await S.resetLocal()}catch(v){this.z.error(`${S.resource}: ${(0,O.$qj)(v)}`),this.z.error(v)}}async I(S){if(!this.profile.isDefault)return{};const v=this.D.getValue(t.$5mb),C=this.enabled.find(F=>F instanceof s.$Jbc);if(C){const F=await C.getRemoteUserDataSyncConfiguration(S);return{...v,...F}}return v}J(S){this.g!==S&&(this.g=S,this.h.fire(S))}L(){return this.M(),this.enabled.some(S=>S.status===t.SyncStatus.HasConflicts)?this.J(t.SyncStatus.HasConflicts):this.enabled.some(S=>S.status===t.SyncStatus.Syncing)?this.J(t.SyncStatus.Syncing):this.J(t.SyncStatus.Idle)}M(){const S=this.enabled.filter(v=>v.status===t.SyncStatus.HasConflicts).filter(v=>v.conflicts.conflicts.length>0).map(v=>v.conflicts);(0,P.$wb)(this.m,S,(v,C)=>v.syncResource===C.syncResource&&(0,P.$wb)(v.conflicts,C.conflicts,(F,D)=>(0,A.$_g)(F.previewResource,D.previewResource)))||(this.m=S,this.n.fire(S))}N(S){switch(S){case t.SyncResource.Settings:return 0;case t.SyncResource.Keybindings:return 1;case t.SyncResource.Snippets:return 2;case t.SyncResource.Tasks:return 3;case t.SyncResource.GlobalState:return 4;case t.SyncResource.Extensions:return 5;case t.SyncResource.Profiles:return 6;case t.SyncResource.WorkspaceState:return 7}}};h=ve([Y(2,t.$knb),Y(3,l.$Ei),Y(4,u.$gp),Y(5,t.$_mb),Y(6,y.$$l),Y(7,t.$pnb),Y(8,f.$Ll),Y(9,$.$_i)],h);function g(L){if(L instanceof t.$fnb)switch(L.code){case t.UserDataSyncErrorCode.MethodNotFound:case t.UserDataSyncErrorCode.TooLarge:case t.UserDataSyncErrorCode.TooManyRequests:case t.UserDataSyncErrorCode.TooManyRequestsAndRetryAfter:case t.UserDataSyncErrorCode.LocalTooManyRequests:case t.UserDataSyncErrorCode.LocalTooManyProfiles:case t.UserDataSyncErrorCode.Gone:case t.UserDataSyncErrorCode.UpgradeRequired:case t.UserDataSyncErrorCode.IncompatibleRemoteContent:case t.UserDataSyncErrorCode.IncompatibleLocalContent:return!0}return!1}function R(L,S,v,C){C.publicLog2("sync/error",{code:L.code,serverCode:L instanceof t.$gnb?String(L.serverCode):void 0,url:L instanceof t.$gnb?L.url:void 0,resource:L.resource,executionId:S,service:v.userDataSyncStore.url.toString()})}}),define(ce[269],le([0,1,3,2,9,20,25]),function(ne,e,P,c,N,O,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ygc=e.$Xgc=void 0;function k(u,p){return{...u,profile:(0,O.$Ml)(u.profile,p.profilesHome.scheme)}}function A(u){return{created:u.created,uri:N.URI.revive(u.uri)}}class w{constructor(p,l,d){this.c=p,this.d=l,this.f=d,this.a=new Map,this.b=new P.$me}listen(p,l){switch(l){case"onDidChangeStatus":return this.c.onDidChangeStatus;case"onDidChangeConflicts":return this.c.onDidChangeConflicts;case"onDidChangeLocal":return this.c.onDidChangeLocal;case"onDidChangeLastSyncTime":return this.c.onDidChangeLastSyncTime;case"onSyncErrors":return this.c.onSyncErrors;case"onDidResetLocal":return this.c.onDidResetLocal;case"onDidResetRemote":return this.c.onDidResetRemote;case"manualSync/onSynchronizeResources":return this.b.event}throw new Error(`[UserDataSyncServiceChannel] Event not found: ${l}`)}async call(p,l,d){try{return await this.g(p,l,d)}catch(y){throw this.f.error(y),y}}async g(p,l,d){switch(l){case"_getInitialData":return Promise.resolve([this.c.status,this.c.conflicts,this.c.lastSyncTime]);case"reset":return this.c.reset();case"resetRemote":return this.c.resetRemote();case"resetLocal":return this.c.resetLocal();case"hasPreviouslySynced":return this.c.hasPreviouslySynced();case"hasLocalData":return this.c.hasLocalData();case"resolveContent":return this.c.resolveContent(N.URI.revive(d[0]));case"accept":return this.c.accept(k(d[0],this.d),N.URI.revive(d[1]),d[2],d[3]);case"replace":return this.c.replace(A(d[0]));case"cleanUpRemoteData":return this.c.cleanUpRemoteData();case"getRemoteActivityData":return this.c.saveRemoteActivityData(N.URI.revive(d[0]));case"extractActivityData":return this.c.extractActivityData(N.URI.revive(d[0]),N.URI.revive(d[1]));case"createManualSyncTask":return this.i()}if(l.startsWith("manualSync/")){const y=l.substring(11),f=d[0],b=this.h(f);switch(d=d.slice(1),y){case"merge":return b.merge();case"apply":return b.apply().then(()=>this.a.delete(this.j(b.id)));case"stop":return b.stop().finally(()=>this.a.delete(this.j(b.id)))}}throw new Error("Invalid call")}h(p){const l=this.a.get(this.j(p));if(!l)throw new Error(`Manual sync taks not found: ${p}`);return l}async i(){const p=await this.c.createManualSyncTask();return this.a.set(this.j(p.id),p),p.id}j(p){return`manualSyncTask-${p}`}}e.$Xgc=w;let E=class extends c.$Wc{get status(){return this.b}get onDidChangeLocal(){return this.a.listen("onDidChangeLocal")}get conflicts(){return this.f}get lastSyncTime(){return this.h}get onDidResetLocal(){return this.a.listen("onDidResetLocal")}get onDidResetRemote(){return this.a.listen("onDidResetRemote")}constructor(p,l){super(),this.n=l,this.b=T.SyncStatus.Uninitialized,this.c=this.B(new P.$me),this.onDidChangeStatus=this.c.event,this.f=[],this.g=this.B(new P.$me),this.onDidChangeConflicts=this.g.event,this.h=void 0,this.j=this.B(new P.$me),this.onDidChangeLastSyncTime=this.j.event,this.m=this.B(new P.$me),this.onSyncErrors=this.m.event,this.a={call(d,y,f){return p.call(d,y,f).then(null,b=>{throw T.$fnb.toUserDataSyncError(b)})},listen(d,y){return p.listen(d,y)}},this.a.call("_getInitialData").then(([d,y,f])=>{this.s(d),this.t(y),f&&this.u(f),this.B(this.a.listen("onDidChangeStatus")(b=>this.s(b))),this.B(this.a.listen("onDidChangeLastSyncTime")(b=>this.u(b)))}),this.B(this.a.listen("onDidChangeConflicts")(d=>this.t(d))),this.B(this.a.listen("onSyncErrors")(d=>this.m.fire(d.map(y=>({...y,error:T.$fnb.toUserDataSyncError(y.error)})))))}createSyncTask(){throw new Error("not supported")}async createManualSyncTask(){const p=await this.a.call("createManualSyncTask"),l=this;return new $(p,{async call(y,f,b){return l.a.call(`manualSync/${y}`,[p,...Array.isArray(f)?f:[f]],b)},listen(){throw new Error("not supported")}})}reset(){return this.a.call("reset")}resetRemote(){return this.a.call("resetRemote")}resetLocal(){return this.a.call("resetLocal")}hasPreviouslySynced(){return this.a.call("hasPreviouslySynced")}hasLocalData(){return this.a.call("hasLocalData")}accept(p,l,d,y){return this.a.call("accept",[p,l,d,y])}resolveContent(p){return this.a.call("resolveContent",[p])}cleanUpRemoteData(){return this.a.call("cleanUpRemoteData")}replace(p){return this.a.call("replace",[p])}saveRemoteActivityData(p){return this.a.call("getRemoteActivityData",[p])}extractActivityData(p,l){return this.a.call("extractActivityData",[p,l])}async s(p){this.b=p,this.c.fire(p)}async t(p){this.f=p.map(l=>({syncResource:l.syncResource,profile:(0,O.$Ml)(l.profile,this.n.profilesHome.scheme),conflicts:l.conflicts.map(d=>({...d,baseResource:N.URI.revive(d.baseResource),localResource:N.URI.revive(d.localResource),remoteResource:N.URI.revive(d.remoteResource),previewResource:N.URI.revive(d.previewResource)}))})),this.g.fire(this.f)}u(p){this.h!==p&&(this.h=p,this.j.fire(p))}};e.$Ygc=E,e.$Ygc=E=ve([Y(1,O.$Ll)],E);class $ extends c.$Wc{constructor(p,l){super(),this.id=p,this.a=l}async merge(){return this.a.call("merge")}async apply(){return this.a.call("apply")}stop(){return this.a.call("stop")}dispose(){this.a.call("dispose"),super.dispose()}}}),define(ce[127],le([0,1,6,26,8,3,2,147,5,21,13,9,32,22,16,7,24,61,50,17,25]),function(ne,e,P,c,N,O,T,k,A,w,E,$,u,p,l,d,y,f,b,I,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yNb=e.$xNb=e.$wNb=e.$vNb=e.$uNb=void 0;const s="configurationSync.store",r="sync.previous.store",i="sync.donot-make-requests-until",a="sync.user-session-id",t="sync.machine-session-id",n=100,o=1e3*60*5;let h=class extends T.$Wc{get userDataSyncStore(){return this.b}get c(){return this.h.get(m.$inb,I.StorageScope.APPLICATION)}set c(C){this.h.store(m.$inb,C,I.StorageScope.APPLICATION,A.$o?I.StorageTarget.USER:I.StorageTarget.MACHINE)}constructor(C,F,D){super(),this.f=C,this.g=F,this.h=D,this.a=this.B(new O.$me),this.onDidChangeUserDataSyncStore=this.a.event,this.j();const M=this.B(new T.$Vc);this.B(O.Event.filter(D.onDidChangeValue(I.StorageScope.APPLICATION,m.$inb,M),()=>this.c!==this.userDataSyncStore?.type,M)(()=>this.j()))}j(){this.b=this.m(this.f[s]),this.a.fire()}m(C){if(C&&(C=A.$o&&C.web?{...C,...C.web}:C,(0,E.$fg)(C.url)&&(0,E.$hg)(C.authenticationProviders)&&Object.keys(C.authenticationProviders).every(F=>Array.isArray(C.authenticationProviders[F].scopes)))){const F=C,D=!!F.canSwitch,M=F.url===F.insidersUrl?"insiders":"stable",J=(D?this.c:void 0)||M,H=J==="insiders"?F.insidersUrl:J==="stable"?F.stableUrl:F.url;return{url:$.URI.parse(H),type:J,defaultType:M,defaultUrl:$.URI.parse(F.url),stableUrl:$.URI.parse(F.stableUrl),insidersUrl:$.URI.parse(F.insidersUrl),canSwitch:D,authenticationProviders:Object.keys(F.authenticationProviders).reduce((x,K)=>(x.push({id:K,scopes:F.authenticationProviders[K].scopes}),x),[])}}}};e.$uNb=h,e.$uNb=h=ve([Y(0,y.$sk),Y(1,p.$_i),Y(2,I.$bq)],h);let g=class extends h{constructor(C,F,D){super(C,F,D);const M=this.h.get(r,I.StorageScope.APPLICATION);M&&(this.n=JSON.parse(M));const J=this.f[s];J?this.h.store(r,JSON.stringify(J),I.StorageScope.APPLICATION,I.StorageTarget.MACHINE):this.h.remove(r,I.StorageScope.APPLICATION)}async switch(C){C!==this.c&&(this.c=C,this.j())}async getPreviousUserDataSyncStore(){return this.m(this.n)}};e.$vNb=g,e.$vNb=g=ve([Y(0,y.$sk),Y(1,p.$_i),Y(2,I.$bq)],g);let R=class extends T.$Wc{get donotMakeRequestsUntil(){return this.j}constructor(C,F,D,M,J,H,x){super(),this.n=D,this.r=M,this.s=x,this.g=this.B(new O.$me),this.onTokenFailed=this.g.event,this.h=this.B(new O.$me),this.onTokenSucceed=this.h.event,this.j=void 0,this.m=this.B(new O.$me),this.onDidChangeDonotMakeRequestsUntil=this.m.event,this.w=void 0,this.t(C),this.c=(0,b.$hq)(J,H,x).then(K=>{const ie={"X-Client-Name":`${F.applicationName}${A.$o?"-web":""}`,"X-Client-Version":F.version};return F.commit&&(ie["X-Client-Commit"]=F.commit),ie}),this.f=new S(n,o,this.n,this.r),this.u(),this.B((0,T.$Uc)(()=>{this.w&&(this.w.cancel(),this.w=void 0)}))}setAuthToken(C,F){this.b={token:C,type:F}}t(C){this.a=C?(0,w.$gh)(C,"v1"):void 0}u(){const C=this.s.getNumber(i,I.StorageScope.APPLICATION);C&&Date.now()<C&&this.y(new Date(C))}y(C){this.j?.getTime()!==C?.getTime()&&(this.j=C,this.w&&(this.w.cancel(),this.w=void 0),this.j?(this.s.store(i,this.j.getTime(),I.StorageScope.APPLICATION,I.StorageTarget.MACHINE),this.w=(0,P.$sh)(F=>(0,P.$Gh)(this.j.getTime()-Date.now(),F).then(()=>this.y(void 0))),this.w.then(null,F=>null)):this.s.remove(i,I.StorageScope.APPLICATION),this.m.fire())}async getAllCollections(C={}){if(!this.a)throw new Error("No settings sync store url configured.");const F=(0,w.$gh)(this.a,"collection").toString();C={...C},C["Content-Type"]="application/json";const D=await this.D(F,{type:"GET",headers:C},[],c.CancellationToken.None);return(await(0,f.$7p)(D))?.map(({id:M})=>M)||[]}async createCollection(C={}){if(!this.a)throw new Error("No settings sync store url configured.");const F=(0,w.$gh)(this.a,"collection").toString();C={...C},C["Content-Type"]=k.$4s.text;const D=await this.D(F,{type:"POST",headers:C},[],c.CancellationToken.None),M=await(0,f.$6p)(D);if(!M)throw new m.$gnb("Server did not return the collection id",F,m.UserDataSyncErrorCode.NoCollection,D.res.statusCode,D.res.headers[m.$cnb]);return M}async deleteCollection(C,F={}){if(!this.a)throw new Error("No settings sync store url configured.");const D=C?(0,w.$gh)(this.a,"collection",C).toString():(0,w.$gh)(this.a,"collection").toString();F={...F},await this.D(D,{type:"DELETE",headers:F},[],c.CancellationToken.None)}async getAllResourceRefs(C,F){if(!this.a)throw new Error("No settings sync store url configured.");const D=this.z(this.a,F,C),M={},J=await this.D(D.toString(),{type:"GET",headers:M},[],c.CancellationToken.None);return(await(0,f.$7p)(J)||[]).map(({url:x,created:K})=>({ref:(0,w.$ih)(D,D.with({path:x})),created:K*1e3}))}async resolveResourceContent(C,F,D,M={}){if(!this.a)throw new Error("No settings sync store url configured.");const J=(0,w.$gh)(this.z(this.a,D,C),F).toString();M={...M},M["Cache-Control"]="no-cache";const H=await this.D(J,{type:"GET",headers:M},[],c.CancellationToken.None);return await(0,f.$6p)(H)}async deleteResource(C,F,D){if(!this.a)throw new Error("No settings sync store url configured.");const M=F!==null?(0,w.$gh)(this.z(this.a,D,C),F).toString():this.z(this.a,D,C).toString(),J={};await this.D(M,{type:"DELETE",headers:J},[],c.CancellationToken.None)}async deleteResources(){if(!this.a)throw new Error("No settings sync store url configured.");const C=(0,w.$gh)(this.a,"resource").toString(),F={"Content-Type":k.$4s.text};await this.D(C,{type:"DELETE",headers:F},[],c.CancellationToken.None)}async readResource(C,F,D,M={}){if(!this.a)throw new Error("No settings sync store url configured.");const J=(0,w.$gh)(this.z(this.a,D,C),"latest").toString();M={...M},M["Cache-Control"]="no-cache",F&&(M["If-None-Match"]=F.ref);const H=await this.D(J,{type:"GET",headers:M},[304],c.CancellationToken.None);let x=null;if(H.res.statusCode===304&&(x=F),x===null){const K=H.res.headers.etag;if(!K)throw new m.$gnb("Server did not return the ref",J,m.UserDataSyncErrorCode.NoRef,H.res.statusCode,H.res.headers[m.$cnb]);const ie=await(0,f.$6p)(H);if(!ie&&H.res.statusCode===304)throw new m.$gnb("Empty response",J,m.UserDataSyncErrorCode.EmptyResponse,H.res.statusCode,H.res.headers[m.$cnb]);x={ref:K,content:ie}}return x}async writeResource(C,F,D,M,J={}){if(!this.a)throw new Error("No settings sync store url configured.");const H=this.z(this.a,M,C).toString();J={...J},J["Content-Type"]=k.$4s.text,D&&(J["If-Match"]=D);const x=await this.D(H,{type:"POST",data:F,headers:J},[],c.CancellationToken.None),K=x.res.headers.etag;if(!K)throw new m.$gnb("Server did not return the ref",H,m.UserDataSyncErrorCode.NoRef,x.res.statusCode,x.res.headers[m.$cnb]);return K}async manifest(C,F={}){if(!this.a)throw new Error("No settings sync store url configured.");const D=(0,w.$gh)(this.a,"manifest").toString();F={...F},F["Content-Type"]="application/json",C&&(F["If-None-Match"]=C.ref);const M=await this.D(D,{type:"GET",headers:F},[304],c.CancellationToken.None);let J=null;if(M.res.statusCode===304&&(J=C),!J){const x=M.res.headers.etag;if(!x)throw new m.$gnb("Server did not return the ref",D,m.UserDataSyncErrorCode.NoRef,M.res.statusCode,M.res.headers[m.$cnb]);const K=await(0,f.$6p)(M);if(!K&&M.res.statusCode===304)throw new m.$gnb("Empty response",D,m.UserDataSyncErrorCode.EmptyResponse,M.res.statusCode,M.res.headers[m.$cnb]);K&&(J={...JSON.parse(K),ref:x})}const H=this.s.get(a,I.StorageScope.APPLICATION);return H&&J&&H!==J.session&&this.C(),J===null&&H&&this.C(),J&&this.s.store(a,J.session,I.StorageScope.APPLICATION,I.StorageTarget.MACHINE),J}async clear(){if(!this.a)throw new Error("No settings sync store url configured.");await this.deleteCollection(),await this.deleteResources(),this.C()}async getActivityData(){if(!this.a)throw new Error("No settings sync store url configured.");const C=(0,w.$gh)(this.a,"download").toString(),F={},D=await this.D(C,{type:"GET",headers:F},[],c.CancellationToken.None);if(!(0,f.$3p)(D))throw new m.$gnb("Server returned "+D.res.statusCode,C,m.UserDataSyncErrorCode.EmptyResponse,D.res.statusCode,D.res.headers[m.$cnb]);if((0,f.$4p)(D))throw new m.$gnb("Empty response",C,m.UserDataSyncErrorCode.EmptyResponse,D.res.statusCode,D.res.headers[m.$cnb]);return D.stream}z(C,F,D){return F?(0,w.$gh)(C,"collection",F,"resource",D):(0,w.$gh)(C,"resource",D)}C(){this.s.remove(a,I.StorageScope.APPLICATION),this.s.remove(t,I.StorageScope.APPLICATION)}async D(C,F,D,M){if(!this.b)throw new m.$gnb("No Auth Token Available",C,m.UserDataSyncErrorCode.Unauthorized,void 0,void 0);if(this.j&&Date.now()<this.j.getTime())throw new m.$gnb(`${F.type} request '${C}' failed because of too many requests (429).`,C,m.UserDataSyncErrorCode.TooManyRequestsAndRetryAfter,void 0,void 0);this.y(void 0);const J=await this.c;F.headers={...F.headers||{},...J,"X-Account-Type":this.b.type,authorization:`Bearer ${this.b.token}`},this.F(F.headers),this.r.trace("Sending request to server",{url:C,type:F.type,headers:{...F.headers,authorization:void 0}});let H;try{H=await this.f.request(C,F,M)}catch(z){if(!(z instanceof m.$gnb)){let ee=m.UserDataSyncErrorCode.RequestFailed;const se=(0,N.$_)(z).toLowerCase();se.includes("xhr timeout")?ee=m.UserDataSyncErrorCode.RequestTimeout:se.includes("protocol")&&se.includes("not supported")?ee=m.UserDataSyncErrorCode.RequestProtocolNotSupported:se.includes("request path contains unescaped characters")?ee=m.UserDataSyncErrorCode.RequestPathNotEscaped:se.includes("headers must be an object")?ee=m.UserDataSyncErrorCode.RequestHeadersNotObject:(0,N.$6)(z)&&(ee=m.UserDataSyncErrorCode.RequestCanceled),z=new m.$gnb(`Connection refused for the request '${C}'.`,C,ee,void 0,void 0)}throw this.r.info("Request failed",C),z}const x=H.res.headers[m.$cnb],K={url:C,status:H.res.statusCode,"execution-id":F.headers[m.$dnb],"operation-id":x},ie=(0,f.$3p)(H)||H.res.statusCode&&D.includes(H.res.statusCode);let V="";if(ie?this.r.trace("Request succeeded",K):(V=await(0,f.$5p)(H)||"",this.r.info("Request failed",K,V)),H.res.statusCode===401||H.res.statusCode===403){if(this.b=void 0,H.res.statusCode===401)throw this.g.fire(m.UserDataSyncErrorCode.Unauthorized),new m.$gnb(`${F.type} request '${C}' failed because of Unauthorized (401).`,C,m.UserDataSyncErrorCode.Unauthorized,H.res.statusCode,x);if(H.res.statusCode===403)throw this.g.fire(m.UserDataSyncErrorCode.Forbidden),new m.$gnb(`${F.type} request '${C}' failed because the access is forbidden (403).`,C,m.UserDataSyncErrorCode.Forbidden,H.res.statusCode,x)}if(this.h.fire(),H.res.statusCode===404)throw new m.$gnb(`${F.type} request '${C}' failed because the requested resource is not found (404).`,C,m.UserDataSyncErrorCode.NotFound,H.res.statusCode,x);if(H.res.statusCode===405)throw new m.$gnb(`${F.type} request '${C}' failed because the requested endpoint is not found (405). ${V}`,C,m.UserDataSyncErrorCode.MethodNotFound,H.res.statusCode,x);if(H.res.statusCode===409)throw new m.$gnb(`${F.type} request '${C}' failed because of Conflict (409). There is new data for this resource. Make the request again with latest data.`,C,m.UserDataSyncErrorCode.Conflict,H.res.statusCode,x);if(H.res.statusCode===410)throw new m.$gnb(`${F.type} request '${C}' failed because the requested resource is not longer available (410).`,C,m.UserDataSyncErrorCode.Gone,H.res.statusCode,x);if(H.res.statusCode===412)throw new m.$gnb(`${F.type} request '${C}' failed because of Precondition Failed (412). There is new data for this resource. Make the request again with latest data.`,C,m.UserDataSyncErrorCode.PreconditionFailed,H.res.statusCode,x);if(H.res.statusCode===413)throw new m.$gnb(`${F.type} request '${C}' failed because of too large payload (413).`,C,m.UserDataSyncErrorCode.TooLarge,H.res.statusCode,x);if(H.res.statusCode===426)throw new m.$gnb(`${F.type} request '${C}' failed with status Upgrade Required (426). Please upgrade the client and try again.`,C,m.UserDataSyncErrorCode.UpgradeRequired,H.res.statusCode,x);if(H.res.statusCode===429){const z=H.res.headers["retry-after"];throw z?(this.y(new Date(Date.now()+parseInt(z)*1e3)),new m.$gnb(`${F.type} request '${C}' failed because of too many requests (429).`,C,m.UserDataSyncErrorCode.TooManyRequestsAndRetryAfter,H.res.statusCode,x)):new m.$gnb(`${F.type} request '${C}' failed because of too many requests (429).`,C,m.UserDataSyncErrorCode.TooManyRequests,H.res.statusCode,x)}if(!ie)throw new m.$gnb("Server returned "+H.res.statusCode,C,m.UserDataSyncErrorCode.Unknown,H.res.statusCode,x);return H}F(C){let F=this.s.get(t,I.StorageScope.APPLICATION);F===void 0&&(F=(0,u.$2g)(),this.s.store(t,F,I.StorageScope.APPLICATION,I.StorageTarget.MACHINE)),C["X-Machine-Session-Id"]=F;const D=this.s.get(a,I.StorageScope.APPLICATION);D!==void 0&&(C["X-User-Session-Id"]=D)}};e.$wNb=R,e.$wNb=R=ve([Y(1,y.$sk),Y(2,f.$1p),Y(3,m.$pnb),Y(4,l.$Mi),Y(5,d.$_k),Y(6,I.$bq)],R);let L=class extends R{constructor(C,F,D,M,J,H,x){super(C.userDataSyncStore?.url,F,D,M,J,H,x),this.B(C.onDidChangeUserDataSyncStore(()=>this.t(C.userDataSyncStore?.url)))}};e.$xNb=L,e.$xNb=L=ve([Y(0,m.$_mb),Y(1,y.$sk),Y(2,f.$1p),Y(3,m.$pnb),Y(4,l.$Mi),Y(5,d.$_k),Y(6,I.$bq)],L);class S{constructor(C,F,D,M){this.c=C,this.d=F,this.f=D,this.g=M,this.a=[],this.b=void 0}request(C,F,D){if(this.h()&&this.i(),F.url=C,this.a.length>=this.c)throw this.g.info("Too many requests",...this.a),new m.$gnb(`Too many requests. Only ${this.c} requests allowed in ${this.d/(1e3*60)} minutes.`,C,m.UserDataSyncErrorCode.LocalTooManyRequests,void 0,void 0);return this.b=this.b||new Date,this.a.push(C),this.f.request(F,D)}h(){return this.b!==void 0&&new Date().getTime()-this.b.getTime()>this.d}i(){this.a=[],this.b=void 0}}e.$yNb=S}),define(ce[270],le([0,1,3,2,9,22,24,17,127]),function(ne,e,P,c,N,O,T,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wgc=e.$Vgc=e.$Ugc=e.$Tgc=void 0;class w{constructor(l){this.a=l}listen(l,d){switch(d){case"onDidChangeAccount":return this.a.onDidChangeAccount;case"onTokenFailed":return this.a.onTokenFailed}throw new Error(`[UserDataSyncAccountServiceChannel] Event not found: ${d}`)}call(l,d,y){switch(d){case"_getInitialData":return Promise.resolve(this.a.account);case"updateAccount":return this.a.updateAccount(y)}throw new Error("Invalid call")}}e.$Tgc=w;class E extends c.$Wc{get account(){return this.a}get onTokenFailed(){return this.c.listen("onTokenFailed")}constructor(l){super(),this.c=l,this.b=this.B(new P.$me),this.onDidChangeAccount=this.b.event,this.c.call("_getInitialData").then(d=>{this.a=d,this.B(this.c.listen("onDidChangeAccount")(y=>{this.a=y,this.b.fire(y)}))})}updateAccount(l){return this.c.call("updateAccount",l)}}e.$Ugc=E;class ${constructor(l){this.a=l}listen(l,d){switch(d){case"onDidChangeUserDataSyncStore":return this.a.onDidChangeUserDataSyncStore}throw new Error(`[UserDataSyncStoreManagementServiceChannel] Event not found: ${d}`)}call(l,d,y){switch(d){case"switch":return this.a.switch(y[0]);case"getPreviousUserDataSyncStore":return this.a.getPreviousUserDataSyncStore()}throw new Error("Invalid call")}}e.$Vgc=$;let u=class extends A.$uNb{constructor(l,d,y,f){super(d,y,f),this.n=l,this.B(this.n.listen("onDidChangeUserDataSyncStore")(()=>this.j()))}async switch(l){return this.n.call("switch",[l])}async getPreviousUserDataSyncStore(){const l=await this.n.call("getPreviousUserDataSyncStore");return this.r(l)}r(l){return{url:N.URI.revive(l.url),type:l.type,defaultUrl:N.URI.revive(l.defaultUrl),insidersUrl:N.URI.revive(l.insidersUrl),stableUrl:N.URI.revive(l.stableUrl),canSwitch:l.canSwitch,authenticationProviders:l.authenticationProviders}}};e.$Wgc=u,e.$Wgc=u=ve([Y(1,T.$sk),Y(2,O.$_i),Y(3,k.$bq)],u)}),define(ce[271],le([0,1,3,59,24,17,18,266,25,83,87]),function(ne,e,P,c,N,O,T,k,A,w,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ghc=void 0;let $=class extends k.$Ddc{constructor(p,l,d,y,f,b,I,m,s,r,i){super(p,l,d,y,f,I,m,s,r,i),this.B(P.Event.debounce(P.Event.any(P.Event.map(b.onDidFocusMainWindow,()=>"windowFocus"),P.Event.map(b.onDidOpenMainWindow,()=>"windowOpen")),(a,t)=>a?[...a,t]:[t],1e3)(a=>this.triggerSync(a,!0,!1)))}};e.$ghc=$,e.$ghc=$=ve([Y(0,N.$sk),Y(1,A.$_mb),Y(2,A.$anb),Y(3,A.$knb),Y(4,A.$lnb),Y(5,c.$dfc),Y(6,A.$pnb),Y(7,w.$WLb),Y(8,T.$$l),Y(9,E.$Zmb),Y(10,O.$bq)],$)}),define(ce[272],le([0,1,76,23,5,21]),function(ne,e,P,c,N,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dec=void 0,e.$Eec=T,e.$Fec=k,e.$Gec=A,e.$Dec=128/4;function T(w){function E(){let $=w.scheme===c.Schemas.file?(0,O.$7g)(w):w.toString();return N.$k||($=$.toLowerCase()),(0,P.createHash)("md5").update($).digest("hex")}return{id:E(),configPath:w}}function k(w,E){function $(){if(w.scheme!==c.Schemas.file)return(0,P.createHash)("md5").update(w.toString()).digest("hex");if(!E)return;let p;return N.$k?p=E.ino:N.$j?p=E.birthtime.getTime():N.$i&&(typeof E.birthtimeMs=="number"?p=Math.floor(E.birthtimeMs):p=E.birthtime.getTime()),(0,P.createHash)("md5").update(w.fsPath).update(p?String(p):"").digest("hex")}const u=$();if(typeof u=="string")return{id:u,uri:w}}function A(){return{id:(Date.now()+Math.round(Math.random()*1e3)).toString()}}}),define(ce[273],le([0,1,6,8,2,14,31,16,10,80,116,272,59,58,23]),function(ne,e,P,c,N,O,T,k,A,w,E,$,u,p,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pgc=void 0;let d=class extends N.$Wc{constructor(f,b,I,m){super(),this.a=f,this.b=b,this.c=I,this.f=m,this.B(new P.$Rh(()=>{this.g()},30*1e3)).schedule()}async g(){this.b.trace("[storage cleanup]: Starting to clean up workspace storage folders for unused empty workspaces.");try{const f=this.a.workspaceStorageHome.with({scheme:l.Schemas.file}).fsPath,b=await T.Promises.readdir(f),I=new w.$vMb(this.f.getChannel("storage"));await Promise.all(b.map(async m=>{const s=(0,O.$lc)(f,m);m.length===$.$Dec||m===E.$Ri.id||(await this.c.getWindows({includeAuxiliaryWindows:!1})).some(a=>a.workspace?.id===m)||await I.isUsed(s)||(this.b.trace(`[storage cleanup]: Deleting workspace storage folder ${m} as it seems to be an unused empty workspace.`),await T.Promises.rm(s))}))}catch(f){(0,c.$3)(f)}}};e.$Pgc=d,e.$Pgc=d=ve([Y(0,k.$Ni),Y(1,A.$_j),Y(2,u.$dfc),Y(3,p.$ugc)],d)}),define(ce[128],le([0,1,76,66,38,281,15,8,3,2,14,5,32,43,70]),function(ne,e,P,c,N,O,T,k,A,w,E,$,u,p,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zi=e.$wi=e.$vi=e.$ui=void 0,e.$xi=t,e.$yi=n,e.$Ai=g,e.$Bi=R;const d=3e4;class y{traceSocketEvent(S,v){l.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,S,v)}constructor(S,v=""){this.f=!0,this.debugLabel=v,this.socket=S,this.traceSocketEvent(l.SocketDiagnosticsEventType.Created,{type:"NodeSocket"}),this.a=F=>{if(this.traceSocketEvent(l.SocketDiagnosticsEventType.Error,{code:F?.code,message:F?.message}),F){if(F.code==="EPIPE")return;(0,k.$3)(F)}},this.socket.on("error",this.a);let C;this.b=F=>{this.traceSocketEvent(l.SocketDiagnosticsEventType.Close,{hadError:F}),this.f=!1,C&&clearTimeout(C)},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent(l.SocketDiagnosticsEventType.NodeEndReceived),this.f=!1,C=setTimeout(()=>S.destroy(),d)},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(S){const v=C=>{this.traceSocketEvent(l.SocketDiagnosticsEventType.Read,C),S(T.$Oe.wrap(C))};return this.socket.on("data",v),{dispose:()=>this.socket.off("data",v)}}onClose(S){const v=C=>{S({type:l.SocketCloseEventType.NodeSocketCloseEvent,hadError:C,error:void 0})};return this.socket.on("close",v),{dispose:()=>this.socket.off("close",v)}}onEnd(S){const v=()=>{S()};return this.socket.on("end",v),{dispose:()=>this.socket.off("end",v)}}write(S){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent(l.SocketDiagnosticsEventType.Write,S),this.socket.write(S.buffer,v=>{if(v){if(v.code==="EPIPE")return;(0,k.$3)(v)}})}catch(v){if(v.code==="EPIPE")return;(0,k.$3)(v)}}end(){this.traceSocketEvent(l.SocketDiagnosticsEventType.NodeEndSent),this.socket.end()}drain(){return this.traceSocketEvent(l.SocketDiagnosticsEventType.NodeDrainBegin),new Promise((S,v)=>{if(this.socket.bufferSize===0){this.traceSocketEvent(l.SocketDiagnosticsEventType.NodeDrainEnd),S();return}const C=()=>{this.socket.off("close",C),this.socket.off("end",C),this.socket.off("error",C),this.socket.off("timeout",C),this.socket.off("drain",C),this.traceSocketEvent(l.SocketDiagnosticsEventType.NodeDrainEnd),S()};this.socket.on("close",C),this.socket.on("end",C),this.socket.on("error",C),this.socket.on("timeout",C),this.socket.on("drain",C)})}}e.$ui=y;var f;(function(L){L[L.MinHeaderByteSize=2]="MinHeaderByteSize",L[L.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(f||(f={}));var b;(function(L){L[L.PeekHeader=1]="PeekHeader",L[L.ReadHeader=2]="ReadHeader",L[L.ReadBody=3]="ReadBody",L[L.Fin=4]="Fin"})(b||(b={}));class I extends w.$Wc{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(S,v){this.socket.traceSocketEvent(S,v)}constructor(S,v,C,F){super(),this.f=this.B(new A.$me),this.g=this.B(new A.$me),this.h=!1,this.j={state:b.PeekHeader,readLen:f.MinHeaderByteSize,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0,opcode:0},this.socket=S,this.traceSocketEvent(l.SocketDiagnosticsEventType.Created,{type:"WebSocketNodeSocket",permessageDeflate:v,inflateBytesLength:C?.byteLength||0,recordInflateBytes:F}),this.a=this.B(new m(this,v,C,F,this.f,(D,M)=>this.m(D,M))),this.B(this.a.onError(D=>{console.error(D),(0,k.$3)(D),this.g.fire({type:l.SocketCloseEventType.NodeSocketCloseEvent,hadError:!0,error:D})})),this.b=new l.$pi,this.B(this.socket.onData(D=>this.n(D))),this.B(this.socket.onClose(async D=>{this.a.isProcessingReadQueue()&&await A.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(D)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(S){return this.f.event(S)}onClose(S){return this.g.event(S)}onEnd(S){return this.socket.onEnd(S)}write(S){let v=0;for(;v<S.byteLength;)this.a.writeMessage(S.slice(v,Math.min(v+f.MaxWebSocketMessageLength,S.byteLength)),{compressed:!0,opcode:2}),v+=f.MaxWebSocketMessageLength}m(S,{compressed:v,opcode:C}){if(this.h)return;this.traceSocketEvent(l.SocketDiagnosticsEventType.WebSocketNodeSocketWrite,S);let F=f.MinHeaderByteSize;S.byteLength<126?F+=0:S.byteLength<2**16?F+=2:F+=8;const D=T.$Oe.alloc(F),M=v?64:0,J=C&15;if(D.writeUInt8(128|M|J,0),S.byteLength<126)D.writeUInt8(S.byteLength,1);else if(S.byteLength<2**16){D.writeUInt8(126,1);let H=1;D.writeUInt8(S.byteLength>>>8&255,++H),D.writeUInt8(S.byteLength>>>0&255,++H)}else{D.writeUInt8(127,1);let H=1;D.writeUInt8(0,++H),D.writeUInt8(0,++H),D.writeUInt8(0,++H),D.writeUInt8(0,++H),D.writeUInt8(S.byteLength>>>24&255,++H),D.writeUInt8(S.byteLength>>>16&255,++H),D.writeUInt8(S.byteLength>>>8&255,++H),D.writeUInt8(S.byteLength>>>0&255,++H)}this.socket.write(T.$Oe.concat([D,S]))}end(){this.h=!0,this.socket.end()}n(S){if(S.byteLength!==0){for(this.b.acceptChunk(S);this.b.byteLength>=this.j.readLen;)if(this.j.state===b.PeekHeader){const v=this.b.peek(this.j.readLen),C=v.readUInt8(0),F=(C&128)>>>7,D=(C&64)>>>6,M=C&15,J=v.readUInt8(1),H=(J&128)>>>7,x=J&127;this.j.state=b.ReadHeader,this.j.readLen=f.MinHeaderByteSize+(H?4:0)+(x===126?2:0)+(x===127?8:0),this.j.fin=F,this.j.firstFrameOfMessage&&(this.j.compressed=!!D),this.j.firstFrameOfMessage=!!F,this.j.mask=0,this.j.opcode=M,this.traceSocketEvent(l.SocketDiagnosticsEventType.WebSocketNodeSocketPeekedHeader,{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,opcode:this.j.opcode})}else if(this.j.state===b.ReadHeader){const v=this.b.read(this.j.readLen),C=v.readUInt8(1),F=(C&128)>>>7;let D=C&127,M=1;D===126?D=v.readUInt8(++M)*2**8+v.readUInt8(++M):D===127&&(D=v.readUInt8(++M)*0+v.readUInt8(++M)*0+v.readUInt8(++M)*0+v.readUInt8(++M)*0+v.readUInt8(++M)*2**24+v.readUInt8(++M)*2**16+v.readUInt8(++M)*2**8+v.readUInt8(++M));let J=0;F&&(J=v.readUInt8(++M)*2**24+v.readUInt8(++M)*2**16+v.readUInt8(++M)*2**8+v.readUInt8(++M)),this.j.state=b.ReadBody,this.j.readLen=D,this.j.mask=J,this.traceSocketEvent(l.SocketDiagnosticsEventType.WebSocketNodeSocketPeekedHeader,{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask,opcode:this.j.opcode})}else if(this.j.state===b.ReadBody){const v=this.b.read(this.j.readLen);this.traceSocketEvent(l.SocketDiagnosticsEventType.WebSocketNodeSocketReadData,v),i(v,this.j.mask),this.traceSocketEvent(l.SocketDiagnosticsEventType.WebSocketNodeSocketUnmaskedData,v),this.j.state=b.PeekHeader,this.j.readLen=f.MinHeaderByteSize,this.j.mask=0,this.j.opcode<=2?this.a.acceptFrame(v,this.j.compressed,!!this.j.fin):this.j.opcode===9&&this.a.writeMessage(v,{compressed:!1,opcode:10})}}}async drain(){this.traceSocketEvent(l.SocketDiagnosticsEventType.WebSocketNodeSocketDrainBegin),this.a.isProcessingWriteQueue()&&await A.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent(l.SocketDiagnosticsEventType.WebSocketNodeSocketDrainEnd)}}e.$vi=I;class m extends w.$Wc{get permessageDeflate(){return!!(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:T.$Oe.alloc(0)}constructor(S,v,C,F,D,M){super(),this.n=S,this.r=D,this.s=M,this.a=this.B(new A.$me),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new A.$me),this.onDidFinishProcessingReadQueue=this.j.event,this.m=this.B(new A.$me),this.onDidFinishProcessingWriteQueue=this.m.event,this.t=!1,this.y=!1,v?(this.b=this.B(new s(this.n,F,C,{windowBits:15})),this.f=this.B(new r(this.n,{windowBits:15})),this.B(this.b.onError(J=>this.a.fire(J))),this.B(this.f.onError(J=>this.a.fire(J)))):(this.b=null,this.f=null)}writeMessage(S,v){this.g.push({data:S,options:v}),this.u()}async u(){if(!this.t){for(this.t=!0;this.g.length>0;){const{data:S,options:v}=this.g.shift();if(this.f&&v.compressed){const C=await this.w(this.f,S);this.s(C,v)}else this.s(S,{...v,compressed:!1})}this.t=!1,this.m.fire()}}isProcessingWriteQueue(){return this.t}w(S,v){return new Promise((C,F)=>{S.write(v),S.flush(D=>C(D))})}acceptFrame(S,v,C){this.h.push({data:S,isCompressed:v,isLastFrameOfMessage:C}),this.z()}async z(){if(!this.y){for(this.y=!0;this.h.length>0;){const S=this.h.shift();if(this.b&&S.isCompressed){const v=await this.C(this.b,S.data,S.isLastFrameOfMessage);this.r.fire(v)}else this.r.fire(S.data)}this.y=!1,this.j.fire()}}isProcessingReadQueue(){return this.y}C(S,v,C){return new Promise((F,D)=>{S.write(v),C&&S.write(T.$Oe.fromByteArray([0,0,255,255])),S.flush(M=>F(M))})}}class s extends w.$Wc{get recordedInflateBytes(){return this.j?T.$Oe.concat(this.f):T.$Oe.alloc(0)}constructor(S,v,C,F){super(),this.h=S,this.j=v,this.a=this.B(new A.$me),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,O.createInflateRaw)(F),this.b.on("error",D=>{this.h.traceSocketEvent(l.SocketDiagnosticsEventType.zlibInflateError,{message:D?.message,code:D?.code}),this.a.fire(D)}),this.b.on("data",D=>{this.h.traceSocketEvent(l.SocketDiagnosticsEventType.zlibInflateData,D),this.g.push(T.$Oe.wrap(D))}),C&&(this.h.traceSocketEvent(l.SocketDiagnosticsEventType.zlibInflateInitialWrite,C.buffer),this.b.write(C.buffer),this.b.flush(()=>{this.h.traceSocketEvent(l.SocketDiagnosticsEventType.zlibInflateInitialFlushFired),this.g.length=0}))}write(S){this.j&&this.f.push(S.clone()),this.h.traceSocketEvent(l.SocketDiagnosticsEventType.zlibInflateWrite,S),this.b.write(S.buffer)}flush(S){this.b.flush(()=>{this.h.traceSocketEvent(l.SocketDiagnosticsEventType.zlibInflateFlushFired);const v=T.$Oe.concat(this.g);this.g.length=0,S(v)})}}class r extends w.$Wc{constructor(S,v){super(),this.g=S,this.a=this.B(new A.$me),this.onError=this.a.event,this.f=[],this.b=(0,O.createDeflateRaw)({windowBits:15}),this.b.on("error",C=>{this.g.traceSocketEvent(l.SocketDiagnosticsEventType.zlibDeflateError,{message:C?.message,code:C?.code}),this.a.fire(C)}),this.b.on("data",C=>{this.g.traceSocketEvent(l.SocketDiagnosticsEventType.zlibDeflateData,C),this.f.push(T.$Oe.wrap(C))})}write(S){this.g.traceSocketEvent(l.SocketDiagnosticsEventType.zlibDeflateWrite,S.buffer),this.b.write(S.buffer)}flush(S){this.b.flush(2,()=>{this.g.traceSocketEvent(l.SocketDiagnosticsEventType.zlibDeflateFlushFired);let v=T.$Oe.concat(this.f);this.f.length=0,v=v.slice(0,v.byteLength-4),S(v)})}}function i(L,S){if(S===0)return;const v=L.byteLength>>>2;for(let H=0;H<v;H++){const x=L.readUInt32BE(H*4);L.writeUInt32BE(x^S,H*4)}const C=v*4,F=L.byteLength-C,D=S>>>24&255,M=S>>>16&255,J=S>>>8&255;F>=1&&L.writeUInt8(L.readUInt8(C)^D,C),F>=2&&L.writeUInt8(L.readUInt8(C+1)^M,C+1),F>=3&&L.writeUInt8(L.readUInt8(C+2)^J,C+2)}e.$wi=process.env.XDG_RUNTIME_DIR;const a={[$.Platform.Linux]:107,[$.Platform.Mac]:103};function t(){const L=(0,u.$2g)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${L}-sock`;const S=process.platform!=="darwin"&&e.$wi?e.$wi:(0,N.tmpdir)(),v=(0,E.$lc)(S,`vscode-ipc-${L}.sock`);return o(v),v}function n(L,S,v){const F=(0,P.createHash)("sha256").update(L).digest("hex").substr(0,8);if(process.platform==="win32")return`\\\\.\\pipe\\${F}-${v}-${S}-sock`;const D=v.substr(0,4),M=S.substr(0,6);let J;return process.platform!=="darwin"&&e.$wi&&!process.env.VSCODE_PORTABLE?J=(0,E.$lc)(e.$wi,`vscode-${F}-${D}-${M}.sock`):J=(0,E.$lc)(L,`${D}-${M}.sock`),o(J),J}function o(L){const S=a[$.$u];typeof S=="number"&&L.length>=S&&console.warn(`WARNING: IPC handle "${L}" is longer than ${S} chars, try a shorter --user-data-dir`)}class h extends p.$ji{static b(S){const v=A.Event.fromNodeEventEmitter(S,"connection");return A.Event.map(v,C=>({protocol:new l.$qi(new y(C,"ipc-server-connection")),onDidClientDisconnect:A.Event.once(A.Event.fromNodeEventEmitter(C,"close"))}))}constructor(S){super(h.b(S)),this.d=S}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.$zi=h;function g(L){return new Promise((S,v)=>{const C=(0,c.createServer)();C.on("error",v),C.listen(L,()=>{C.removeListener("error",v),S(new h(C))})})}function R(L,S){return new Promise((v,C)=>{const F=(0,c.createConnection)(L,()=>{F.removeListener("error",C),v(l.$ri.fromSocket(new y(F,`ipc-client${S}`),S))});F.once("error",C)})}}),define(ce[274],le([0,1,66,128,221]),function(ne,e,P,c,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jhc=void 0,P=Oe(P),e.$jhc=new class{supports(O){return!0}connect({host:O,port:T},k,A,w){return new Promise((E,$)=>{const u=P.createConnection({host:O,port:T},()=>{u.removeListener("error",$),u.write((0,N.$Vwb)(k,A,w));const p=l=>{l.toString().indexOf(`\r
\r
`)>=0&&(u.off("data",p),E(new c.$ui(u,w)))};u.on("data",p)});u.setNoDelay(!0),u.once("error",$)})}}}),define(ce[275],le([0,1,66,38,139,128,6,2,5,22,10,24,222,107,109,81,15]),function(ne,e,P,c,N,O,T,k,A,w,E,$,u,p,l,d,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ogc=e.$ngc=e.$mgc=e.$lgc=void 0,P=Oe(P),c=Oe(c);async function f(r,i,a,t,n){let o;for(let h=3;h&&(o?.dispose(),o=await new b(r,i,a,t,n).waitForReady(),!(n&&N.$5g[n]||!N.$5g[o.tunnelLocalPort]));h--);return o}class b extends k.$Wc{constructor(i,a,t,n,o){super(),this.m=a,this.n=o,this.privacy=d.TunnelPrivacyId.Private,this.j=new Map,this.a=i,this.b=P.createServer(),this.c=new T.$Eh,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=h=>this.r(h),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=n,this.tunnelRemoteHost=t}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.j.values()).forEach(a=>{a()})}async waitForReady(){const i=this.n??this.tunnelRemotePort,a=(0,d.$Ew)(this.m)?"0.0.0.0":"127.0.0.1";let t=await(0,N.$6g)(i,2,1e3,a),n=null;return this.b.listen(t,this.m),await this.c.wait(),n=this.b.address(),n||(t=0,this.b.listen(t,this.m),await this.c.wait(),n=this.b.address()),this.tunnelLocalPort=n.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${n.port}`,this}async r(i){i.pause();const a=(0,d.$Cw)(this.tunnelRemoteHost)||(0,d.$Ew)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,t=await(0,u.$2l)(this.a,a,this.tunnelRemotePort),n=t.getSocket(),o=t.readEntireBuffer();t.dispose(),o.byteLength>0&&i.write(o.buffer),i.on("end",()=>{i.localAddress&&this.j.delete(i.localAddress),n.end()}),i.on("close",()=>n.end()),i.on("error",()=>{i.localAddress&&this.j.delete(i.localAddress),n instanceof O.$ui?n.socket.destroy():n.end()}),n instanceof O.$ui?this.t(i,n):this.s(i,n),i.localAddress&&this.j.set(i.localAddress,()=>{i.end(),n.end()})}s(i,a){a.onClose(()=>i.destroy()),a.onEnd(()=>i.end()),a.onData(t=>i.write(t.buffer)),i.on("data",t=>a.write(y.$Oe.wrap(t))),i.resume()}t(i,a){const t=a.socket;t.on("end",()=>i.end()),t.on("close",()=>i.end()),t.on("error",()=>{i.destroy()}),t.pipe(i),i.pipe(t)}}e.$lgc=b;let I=class extends d.$Hw{constructor(i,a,t,n,o){super(a,o),this.H=i,this.I=t,this.J=n}isPortPrivileged(i){return(0,d.$Fw)(i,this.t,A.OS,c.release())}F(i,a,t,n,o,h,g,R){const L=this.D(a,t);if(L)return++L.refcount,L.value;if((0,d.$yw)(i))return this.G(i,a,t,o,h,g,R);{this.r.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${a}:${t} on local port ${o}.`);const S={commit:this.J.commit,quality:this.J.quality,addressProvider:i,remoteSocketFactoryService:this.H,signService:this.I,logService:this.r,ipcLogger:null},v=f(S,n,a,t,o);return this.r.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.z(a,t,v),v}}};e.$mgc=I,e.$mgc=I=ve([Y(0,p.$Vl),Y(1,E.$_j),Y(2,l.$Yl),Y(3,$.$sk),Y(4,w.$_i)],I);let m=class extends I{constructor(i,a,t,n,o){super(i,a,t,n,o)}};e.$ngc=m,e.$ngc=m=ve([Y(0,p.$Vl),Y(1,E.$_j),Y(2,l.$Yl),Y(3,$.$sk),Y(4,w.$_i)],m);let s=class extends k.$Wc{constructor(i,a,t,n,o){super(),this.b=i,this.c=a,this.f=t,this.g=n,this.h=o,this.a=new Map}async openTunnel(i,a,t,n,o,h,g,R,L){if(this.c.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${t}:${n} on local port ${h}.`),!this.a.has(i)){const S=new m(this.b,this.c,this.g,this.f,this.h);this.B(S),this.a.set(i,S),S.onTunnelClosed(async()=>{(await S.tunnels).length===0&&(S.dispose(),this.a.delete(i))})}return this.a.get(i).openTunnel(a,t,n,o,h,g,R,L)}};e.$ogc=s,e.$ogc=s=ve([Y(0,p.$Vl),Y(1,E.$_j),Y(2,$.$sk),Y(3,l.$Yl),Y(4,w.$_i)],s)});var it=this&&this.__importDefault||function(ne){return ne&&ne.__esModule?ne:{default:ne}};define(ce[282],le([0,1,38,41,8,2,23,9,19,3,43,157,215,216,225,207,273,198,199,22,220,98,232,99,227,16,119,259,28,111,223,118,75,7,209,210,74,4,206,77,79,235,10,211,103,24,61,17,110,18,112,113,114,49,238,86,115,25,83,265,270,248,87,264,268,269,127,62,263,249,109,231,81,275,226,239,29,240,5,241,200,218,217,85,254,20,53,214,60,262,237,250,108,267,255,11,212,102,260,253,228,195,59,213,271,257,58,261,107,105,274,193,229,153,146,151]),function(ne,e,P,c,N,O,T,k,A,w,E,$,u,p,l,d,y,f,b,I,m,s,r,i,a,t,n,o,h,g,R,L,S,v,C,F,D,M,J,H,x,K,ie,V,z,ee,se,he,q,Z,X,G,U,B,j,W,te,_,Q,ae,ue,ge,we,Ee,pe,be,Se,Ie,oe,de,me,Pe,ke,Fe,Te,Le,Ue,qe,He,Me,Be,ze,We,Ne,re,fe,$e,ye,Ae,Ce,je,xe,Je,Qe,Ve,_e,Ye,nt,at,Lt,Nt,Ct,Tt,Dt,Ut,Ft,yt,Mt,vt,jt,qt,Bt,ht,zt,Wt,Et){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=St,z=it(z);class Vt extends O.$Wc{constructor(Re){super(),this.f=Re,this.a=this.B(new $.$OX(this)),this.b=void 0,this.c=this.B(new w.$me),this.g()}g(){let Re=!1;const De=()=>{Re||(Re=!0,this.b?.fireOnWillShutdown(),this.dispose())};process.once("exit",De),(0,$.$PX)(process.parentPort,ht.$yfc.exit,De)}async init(){const Re=await this.h();(0,_.$7mb)(),Re.invokeFunction(De=>{const Ke=De.get(ie.$_j),Ge=De.get(Z.$$l),et=De.get(fe.$Ll);Ke.trace("sharedProcess configuration",JSON.stringify(this.f)),this.j(De),this.m(Ke),this.n(Ge,et),this.B(et.onDidChangeProfiles(()=>this.n(Ge,et))),this.r(Ge,Ke)}),this.B((0,O.$Tc)(Re.createInstance(u.$Lgc,this.f.codeCachePath),Re.createInstance(p.$Mgc),Re.createInstance(y.$Pgc),Re.createInstance(d.$Ogc),Re.createInstance(l.$Ngc),Re.createInstance(Ve.$ahc),Re.createInstance(xe.$5gc)))}async h(){const Re=new H.$Di,De={_serviceBrand:void 0,...z.default};Re.set(ee.$sk,De);const Ke=new E.$ni(Ze=>Ze==="main"),Ge=new yt.$vgc(this.a,Ke);Re.set(yt.$ugc,Ge);const et=this.f.policiesData?new ye.$2fc(this.f.policiesData,Ge.getChannel("policy")):new Ae.$so;Re.set(Ae.$qo,et);const Xe=new Bt.$8m(this.f.args,De);Re.set(t.$Ni,Xe);const ot=new V.$ms(void 0,this.f.logLevel,Xe.logsHome,this.f.loggers.map(Ze=>({...Ze,resource:k.URI.revive(Ze.resource)})),Ge.getChannel("logger"));Re.set(ie.$ak,ot);const ft=this.B(ot.createLogger("sharedprocess",{name:(0,_e.localize)(0,null)})),$t=this.B(new ie.$hk(ft.getLevel())),tt=this.B(new Ye.$lR(ft,[$t]));Re.set(ie.$_j,tt),this.b=this.B(new nt.$chc(tt)),Re.set(nt.$bhc,this.b);const st=this.B(new C.$Vq(tt));Re.set(v.$_k,st);const pt=this.B(new F.$mr(tt));st.registerProvider(T.Schemas.file,pt);const dt=new qe.$Ns(st);Re.set(Ue.$Jl,dt);const rt=this.B(new Ce.$sR(this.f.profiles.all,k.URI.revive(this.f.profiles.home).with({scheme:Xe.userRoamingDataHome.scheme}),Ge.getChannel("userDataProfiles")));Re.set(fe.$Ll,rt);const wt=this.B(new Me.$tgc(T.Schemas.file,this.B(new Be.$7Q(Ge.getChannel(Be.$6Q),{pathCaseSensitive:He.$k})),T.Schemas.vscodeUserData,rt,dt,tt));st.registerProvider(T.Schemas.vscodeUserData,wt);const ct=this.B(new m.$So(rt.defaultProfile.settingsResource,st,et,tt));Re.set(I.$_i,ct);const bt=new Mt.$ihc(void 0,{defaultProfile:rt.defaultProfile,currentProfile:rt.defaultProfile},Ge,Xe);Re.set(he.$bq,bt),this.B((0,O.$Uc)(()=>bt.flush())),await Promise.all([ct.initialize(),bt.initialize()]);const It=new Nt.$9r(Ge.getChannel("request"));Re.set(se.$1p,It),Re.set(f.$Qgc,new D.$Ci(b.$Rgc,void 0,!1)),Re.set(We.$JG,new D.$Ci(ze.$4gc,void 0,!1));const Rt=new Dt.$xgc(-1,Ge);Re.set(Tt.$dfc,Rt),Re.set(i.$Wo,new D.$Ci(a.$AR,void 0,!0));const Gt=this.B(new de.$Yfc(Rt)),Kt=new E.$ni(Ze=>Gt.getActiveClientId().then(mt=>Ze===mt));Re.set(S.$g6b,new Ct.$ehc(this.a.getChannel("extensionRecommendationNotification",Kt)));let gt;const lt=[],Pt=(0,B.$Ep)(De,ct);if((0,B.$zp)(De,Xe)){const Ze=new G.$Ucc(tt,ot,Xe,De);if(lt.push(Ze),!(0,B.$Ap)(De,Xe)&&De.aiConfig?.ariaKey){const mt=new je.$_Q(It,Pt,"monacoworkbench",null,De.aiConfig.ariaKey);this.B((0,O.$Uc)(()=>mt.flush())),lt.push(mt)}gt=new U.$as({appenders:lt,commonProperties:(0,q.$qp)((0,P.release)(),(0,P.hostname)(),process.arch,De.commit,De.version,this.f.machineId,this.f.sqmId,this.f.devDeviceId,Pt),sendErrorTelemetry:!0,piiPaths:(0,B.$Fp)(Xe)},ct,De)}else{gt=B.$up;const Ze=B.$yp;lt.push(Ze)}this.a.registerChannel("telemetryAppender",new X.$Dfc(lt)),Re.set(Z.$$l,gt);const Jt=new j.$Sgc(ct,gt,tt,ot,Xe,De);Re.set(Z.$_l,Jt),Re.set($e.$Cq,new D.$Ci(Lt.$kR,void 0,!0)),Re.set(Ne.$Gq,new D.$Ci(re.$3fc,void 0,!0)),Re.set(g.$mq,new D.$Ci(g.$oq,void 0,!0)),Re.set(L.$Rq,new D.$Ci(L.$Sq,void 0,!0)),Re.set(h.$gp,new D.$Ci(o.$kq,void 0,!0)),Re.set(h.$np,new D.$Ci(Ft.$hhc,void 0,!1)),Re.set(x.$5r,new D.$Ci(K.$7r,void 0,!1)),Re.set(s.$Sm,new D.$Ci(r.$Us,void 0,!1)),Re.set(Q.$WLb,new D.$Ci(Q.$XLb,void 0,!0)),Re.set(_.$pnb,new D.$Ci(ge.$qOb,void 0,!0)),Re.set(_.$onb,E.ProxyChannel.toService(this.a.getChannel("userDataSyncUtil",Ze=>Ze.ctx!=="main"))),Re.set(h.$mp,new D.$Ci(n.$ULb,void 0,!1)),Re.set(te.$oOb,new D.$Ci(te.$pOb,void 0,!0)),Re.set(W.$iw,new D.$Ci(W.$jw)),Re.set(_.$_mb,new D.$Ci(Se.$vNb,void 0,!0)),Re.set(_.$anb,new D.$Ci(Se.$xNb,void 0,!0)),Re.set(we.$Zmb,new D.$Ci(we.$2mb,void 0,!0)),Re.set(_.$bnb,new D.$Ci(ae.$xdc,void 0,!1)),Re.set(_.$knb,new D.$Ci(Ee.$mdc,void 0,!0)),Re.set(_.$lnb,new D.$Ci(pe.$Cdc,void 0,!1)),Re.set(Ie.$wMb,new D.$Ci(oe.$Zgc,void 0,!0)),Re.set(_.$mnb,new D.$Ci(Qe.$gec,void 0,!0)),Re.set(me.$Yl,new D.$Ci(Pe.$qgc,void 0,!1));const Ot=new vt.$Wl;return Re.set(vt.$Vl,Ot),Ot.register(jt.RemoteConnectionType.WebSocket,qt.$jhc),Re.set(ke.$xw,new D.$Ci(Fe.$ogc)),Re.set(Te.$1gc,new D.$Ci(Le.$3gc)),Re.set(Je.$6gc,new D.$Ci(at.$dhc)),new J.$pr(Re)}j(Re){const De=new R.$qq(Re.get(h.$jp),()=>null);this.a.registerChannel("extensions",De);const Ke=E.ProxyChannel.fromService(Re.get(x.$5r),this.q);this.a.registerChannel("languagePacks",Ke);const Ge=E.ProxyChannel.fromService(Re.get(s.$Sm),this.q);this.a.registerChannel("diagnostics",Ge);const et=new R.$sq(Re.get(h.$np));this.a.registerChannel("extensionTipsService",et);const Xe=E.ProxyChannel.fromService(Re.get(f.$Qgc),this.q);this.a.registerChannel("checksum",Xe);const ot=E.ProxyChannel.fromService(Re.get(We.$JG),this.q);this.a.registerChannel("v8InspectProfiling",ot);const ft=E.ProxyChannel.fromService(Re.get(we.$Zmb),this.q);this.a.registerChannel("userDataSyncMachines",ft);const $t=E.ProxyChannel.fromService(Re.get(Z.$_l),this.q);this.a.registerChannel("customEndpointTelemetry",$t);const tt=new ue.$Tgc(Re.get(Q.$WLb));this.a.registerChannel("userDataSyncAccount",tt);const st=new ue.$Vgc(Re.get(_.$_mb));this.a.registerChannel("userDataSyncStoreManagement",st);const pt=new be.$Xgc(Re.get(_.$lnb),Re.get(fe.$Ll),Re.get(ie.$_j));this.a.registerChannel("userDataSync",pt);const dt=this.B(Re.get(M.$Ei).createInstance(Ut.$ghc));this.a.registerChannel("userDataAutoSync",E.ProxyChannel.fromService(dt,this.q)),this.a.registerChannel("IUserDataSyncResourceProviderService",E.ProxyChannel.fromService(Re.get(_.$mnb),this.q));const rt=E.ProxyChannel.fromService(Re.get(Te.$1gc),this.q);this.a.registerChannel(Te.$2gc,rt);const wt=E.ProxyChannel.fromService(Re.get(Je.$6gc),this.q);this.a.registerChannel("remoteTunnel",wt)}m(Re){process.on("uncaughtException",De=>(0,N.$3)(De)),process.on("unhandledRejection",De=>(0,N.$3)(De)),(0,N.setUnexpectedErrorHandler)(De=>{const Ke=(0,c.$qj)(De,!0);Ke&&Re.error(`[uncaught exception in sharedProcess]: ${Ke}`)})}n(Re,De){Re.publicLog2("profilesInfo",{count:De.profiles.length})}async r(Re,De){if(He.$k){const[Ke,Ge]=await Promise.all([(0,zt.$3g)(De.error.bind(De)),(0,Et.$wX)(De.error.bind(De))]),et=(0,Wt.$cX)(),Xe=(0,Et.$xX)(Ge,this.f.args["ozone-platform"]);Ke&&Re.publicLog2("clientPlatformInfo",{platformId:Ke.id,platformVersionId:Ke.version_id,platformIdLike:Ke.id_like,desktopEnvironment:et,displayProtocol:Ge,codeDisplayProtocol:Xe})}}handledClientConnection(Re){if(Re.data!==ht.$Afc.response)return!1;const De=(0,A.$Qb)(Re.ports);return De?(this.c.fire(De),!0):!1}}async function St(ut){try{const Re=new Vt(ut);process.parentPort.postMessage(ht.$yfc.ipcReady),await Re.init(),process.parentPort.postMessage(ht.$yfc.initDone)}catch(Re){process.parentPort.postMessage({error:Re.toString()})}}const Ht=setTimeout(()=>{process.parentPort.postMessage({warning:"[SharedProcess] did not receive configuration within 30s..."})},3e4);process.parentPort.once("message",ut=>{clearTimeout(Ht),St(ut.data)})})}).call(this);

//# sourceMappingURL=https://main.vscode-cdn.net/sourcemaps/c2e20cb17fae44eb26611cb9a4690059cea0e605/core/vs/code/node/sharedProcess/sharedProcessMain.js.map
