/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Ee=["exports","require","vs/base/common/uri","vs/base/common/lifecycle","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/nls","vs/nls!vs/workbench/api/node/extensionHostProcess","vs/base/common/async","vs/workbench/api/common/extHostTypes","vs/base/common/platform","vs/platform/log/common/log","vs/base/common/strings","vs/base/common/errors","vs/base/common/network","vs/base/common/path","vs/workbench/api/common/extHostTypeConverters","vs/base/common/types","vs/base/common/arrays","vs/workbench/api/common/extHostRpcService","vs/base/common/cancellation","vs/base/common/buffer","vs/base/common/resources","vs/platform/extensions/common/extensions","vs/base/common/objects","vs/workbench/services/extensions/common/extensions","vs/base/common/charCode","vs/platform/files/common/files","vs/base/common/map","vs/workbench/api/common/extHostInitDataService","vs/editor/common/core/range","vs/base/common/uuid","vs/base/common/extpath","vs/base/node/pfs","vs/workbench/api/common/extHostCommands","vs/platform/contextkey/common/contextkey","vs/platform/registry/common/platform","vs/workbench/services/search/common/search","vs/base/common/glob","vs/base/common/iterator","vs/base/common/marshallingIds","vs/workbench/api/common/extHostConfiguration","vs/base/common/stopwatch","vs/base/common/severity","vs/platform/configuration/common/configuration","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostWorkspace","vs/base/common/lazy","vs/base/common/themables","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostExtensionService","vs/editor/common/core/position","vs/editor/common/model","vs/base/common/errorMessage","vs/base/common/process","vs/base/common/marshalling","child_process","vs/base/common/decorators","vs/base/common/hash","fs","vs/base/common/performance","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostVariableResolverService","vs/base/common/assert","net","os","vs/base/parts/ipc/common/ipc.net","vs/platform/files/common/watcher","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testId","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostEditorTabs","vs/base/common/collections","vs/base/common/functional","vs/base/common/linkedList","vs/base/common/normalization","vs/base/common/codicons","vs/base/common/uint","vs/base/common/ternarySearchTree","vs/base/common/htmlContent","vs/base/parts/ipc/common/ipc","vs/editor/common/languages","vs/platform/instantiation/common/extensions","vs/platform/progress/common/progress","vs/platform/remote/common/remoteHosts","vs/platform/telemetry/common/telemetryUtils","vs/platform/tunnel/common/tunnel","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostWebview","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostTesting","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/stream","vs/base/common/codiconsUtil","vs/editor/common/encodedTokenAttributes","vs/editor/common/model/textModelSearch","vs/base/common/mime","vs/base/common/processes","vs/base/common/labels","vs/base/node/extpath","vs/base/node/processes","vs/platform/instantiation/common/descriptors","vs/editor/common/config/editorOptions","vs/platform/instantiation/common/serviceCollection","vs/platform/product/common/productService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/sign/common/sign","vs/workbench/api/common/cache","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostManagedSockets","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostLanguageModels","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/parts/ipc/node/ipc.net","vs/base/common/arraysFind","vs/base/common/idGenerator","vs/base/common/numbers","vs/base/common/filters","vs/base/common/iconLabels","vs/editor/common/core/characterClassifier","vs/editor/common/core/wordHelper","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeBase","vs/base/common/comparers","vs/base/common/fuzzyScorer","vs/base/common/uriIpc","vs/editor/common/services/semanticTokensDto","vs/platform/environment/common/environment","vs/platform/markers/common/markers","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/sign/node/signService","vs/platform/telemetry/common/telemetry","vs/platform/userDataProfile/common/userDataProfile","vs/platform/storage/common/storage","vs/workbench/common/editor","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/authentication/common/authentication","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTerminalShellIntegration","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostOutput","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/common/amd","vs/base/common/equals","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/naturalLanguage/korean","vs/base/common/observableInternal/debugName","vs/base/common/observableInternal/logging","vs/base/common/observableInternal/base","vs/base/common/prefixTree","vs/base/common/cache","vs/base/common/scrollable","vs/base/common/symbols","vs/base/common/codiconsLibrary","vs/base/common/dataTransfer","vs/base/node/ports","vs/editor/common/core/eolCounter","vs/editor/common/core/editOperation","vs/editor/common/core/selection","vs/editor/common/core/textModelDefaults","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/languages/languageConfiguration","vs/editor/common/languages/linkComputer","vs/editor/common/model/pieceTreeTextBuffer/rbTreeBase","vs/editor/common/model/prefixSumComputer","vs/editor/common/model/mirrorTextModel","vs/editor/common/services/treeViewsDnd","vs/editor/common/tokenizationRegistry","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/platform","vs/base/common/console","vs/amdX","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/common/storage","vs/editor/common/core/stringBuilder","vs/editor/common/core/textChange","vs/editor/common/languageSelector","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBuffer","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBufferBuilder","vs/nls!vs/editor/common/config/editorOptions","vs/nls!vs/editor/common/languages","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/dialogs/common/dialogs","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/log/common/log","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostLanguageFeatures","vs/nls!vs/workbench/api/common/extHostLanguageModels","vs/nls!vs/workbench/api/common/extHostLogService","vs/nls!vs/workbench/api/common/extHostNotebook","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostTunnelService","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/api/node/extHostDebugService","vs/nls!vs/workbench/common/configuration","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/chat/common/chatContextKeys","vs/nls!vs/workbench/contrib/chat/common/languageModels","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/debug/node/debugAdapter","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/contrib/testing/common/constants","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/editor/common/editorResolverService","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/remote/common/tunnelModel","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/contextkey/common/scanner","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/accessibility/common/accessibility","vs/platform/dialogs/common/dialogs","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/io","vs/platform/files/node/watcher/baseWatcher","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logService","vs/platform/log/node/spdlogLog","vs/platform/notification/common/notification","vs/platform/product/common/product","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/managedSocket","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/request/common/request","vs/platform/sign/common/abstractSignService","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminal","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/uriIdentity/common/uriIdentity","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/node/proxyResolver","http","vs/workbench/api/node/uriTransformer","vs/workbench/common/views","vs/workbench/contrib/chat/common/chatContextKeys","vs/workbench/contrib/chat/common/chatAgents","vs/workbench/contrib/chat/common/chatService","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","vs/workbench/contrib/debug/node/terminals","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/notebook/common/notebookKernelService","vs/workbench/contrib/search/common/cellSearchModel","vs/workbench/contrib/testing/common/constants","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/extensions/common/extensionHostEnv","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/contrib/chat/common/languageModels","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostEmbedding","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageModelTools","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostSpeech","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/node/extHostConsoleForwarder","vs/workbench/api/node/extHostLoggerService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/notebook/common/notebookDocumentService","vs/workbench/api/common/extHostAiRelatedInformation","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostEmbeddingVector","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostChatAgents2","vs/workbench/api/common/extHostChatVariables","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostShare","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostDiskFileSystemProvider","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostStoragePaths","vs/workbench/api/node/extHostTerminalService","vs/workbench/services/output/common/output","vs/workbench/common/configuration","vs/workbench/services/editor/common/editorResolverService","vs/workbench/services/path/common/pathService","vs/workbench/services/remote/common/tunnelModel","vs/workbench/contrib/search/common/searchNotebookHelpers","vs/workbench/api/common/extHostNotebook","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/api/node/extHostDebugService","vs/workbench/api/node/extHostTask","vs/workbench/api/node/extHostVariableResolverService","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/services/search/node/ripgrepFileSearch","@vscode/ripgrep","vs/workbench/services/search/node/fileSearch","string_decoder","vs/workbench/services/textfile/common/encoding","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/platform/tunnel/node/tunnelService","vs/workbench/api/node/extHostCLIServer","vs/workbench/api/node/extHostExtensionService","vs/workbench/api/node/extHostTunnelService","vs/workbench/api/node/extHost.node.services","util","vs/base/common/semver/semver","https","tls","@vscode/proxy-agent","events","vscode-regexpp","crypto","zlib","vs/workbench/api/node/extensionHostProcess","minimist"],ye=function(ce){for(var e=[],r=0,h=ce.length;r<h;r++)e[r]=Ee[ce[r]];return e};define(Ee[173],ye([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$W=e.LoaderEventType=e.$V=void 0,e.$V=!1;var r;(function(P){P[P.LoaderAvailable=1]="LoaderAvailable",P[P.BeginLoadingScript=10]="BeginLoadingScript",P[P.EndLoadingScriptOK=11]="EndLoadingScriptOK",P[P.EndLoadingScriptError=12]="EndLoadingScriptError",P[P.BeginInvokeFactory=21]="BeginInvokeFactory",P[P.EndInvokeFactory=22]="EndInvokeFactory",P[P.NodeBeginEvaluatingScript=31]="NodeBeginEvaluatingScript",P[P.NodeEndEvaluatingScript=32]="NodeEndEvaluatingScript",P[P.NodeBeginNativeRequire=33]="NodeBeginNativeRequire",P[P.NodeEndNativeRequire=34]="NodeEndNativeRequire",P[P.CachedDataFound=60]="CachedDataFound",P[P.CachedDataMissed=61]="CachedDataMissed",P[P.CachedDataRejected=62]="CachedDataRejected",P[P.CachedDataCreated=63]="CachedDataCreated"})(r||(e.LoaderEventType=r={}));class h{static get(){const R=new Map,T=new Map,N=new Map,$=new Map;function c(p,a){p.has(a.detail)||p.set(a.detail,-a.timestamp)}function I(p,a){const f=p.get(a.detail);f&&(f>=0||p.set(a.detail,f+a.timestamp))}let E=[];typeof ce=="function"&&typeof ce.getStats=="function"&&(E=ce.getStats().slice(0).sort((p,a)=>p.timestamp-a.timestamp));for(const p of E)switch(p.type){case r.BeginLoadingScript:c(R,p);break;case r.EndLoadingScriptOK:case r.EndLoadingScriptError:I(R,p);break;case r.BeginInvokeFactory:c(T,p);break;case r.EndInvokeFactory:I(T,p);break;case r.NodeBeginNativeRequire:c(N,p);break;case r.NodeEndNativeRequire:I(N,p);break;case r.NodeBeginEvaluatingScript:c($,p);break;case r.NodeEndEvaluatingScript:I($,p);break}let u=0;N.forEach(p=>u+=p);function k(p){const a=[];return p.forEach((f,d)=>a.push([d,f])),a}return{amdLoad:k(R),amdInvoke:k(T),nodeRequire:k(N),nodeEval:k($),nodeRequireTotal:u}}static toMarkdownTable(R,T){let N="";const $=[];return R.forEach((c,I)=>{$[I]=c.length}),T.forEach(c=>{c.forEach((I,E)=>{typeof I>"u"&&(I=c[E]="-");const u=I.toString().length;$[E]=Math.max(u,$[E])})}),R.forEach((c,I)=>{N+=`| ${c+" ".repeat($[I]-c.toString().length)} `}),N+=`|
`,R.forEach((c,I)=>{N+=`| ${"-".repeat($[I])} `}),N+=`|
`,T.forEach(c=>{c.forEach((I,E)=>{typeof I<"u"&&(N+=`| ${I+" ".repeat($[E]-I.toString().length)} `)}),N+=`|
`}),N}}e.$W=h}),define(Ee[132],ye([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ob=void 0,e.$hb=r,e.$ib=h,e.$jb=P,e.$kb=R,e.$lb=T,e.$mb=N,e.$nb=$,e.$pb=I,e.$qb=E,e.$rb=u,e.$sb=k,e.$tb=p;function r(a,f){const d=h(a,f);if(d!==-1)return a[d]}function h(a,f,d=a.length-1){for(let m=d;m>=0;m--){const n=a[m];if(f(n))return m}return-1}function P(a,f){const d=R(a,f);return d===-1?void 0:a[d]}function R(a,f,d=0,m=a.length){let n=d,o=m;for(;n<o;){const t=Math.floor((n+o)/2);f(a[t])?n=t+1:o=t}return n-1}function T(a,f){const d=N(a,f);return d===a.length?void 0:a[d]}function N(a,f,d=0,m=a.length){let n=d,o=m;for(;n<o;){const t=Math.floor((n+o)/2);f(a[t])?o=t:n=t+1}return n}function $(a,f,d=0,m=a.length){const n=N(a,f,d,m);return n===a.length?-1:n}class c{static{this.assertInvariants=!1}constructor(f){this.e=f,this.c=0}findLastMonotonous(f){if(c.assertInvariants){if(this.d){for(const m of this.e)if(this.d(m)&&!f(m))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=f}const d=R(this.e,f,this.c);return this.c=d+1,d===-1?void 0:this.e[d]}}e.$ob=c;function I(a,f){if(a.length===0)return;let d=a[0];for(let m=1;m<a.length;m++){const n=a[m];f(n,d)>0&&(d=n)}return d}function E(a,f){if(a.length===0)return;let d=a[0];for(let m=1;m<a.length;m++){const n=a[m];f(n,d)>=0&&(d=n)}return d}function u(a,f){return I(a,(d,m)=>-f(d,m))}function k(a,f){if(a.length===0)return-1;let d=0;for(let m=1;m<a.length;m++){const n=a[m];f(n,a[d])>0&&(d=m)}return d}function p(a,f){for(const d of a){const m=f(d);if(m!==void 0)return m}}}),define(Ee[27],ye([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharCode=void 0;var r;(function(h){h[h.Null=0]="Null",h[h.Backspace=8]="Backspace",h[h.Tab=9]="Tab",h[h.LineFeed=10]="LineFeed",h[h.CarriageReturn=13]="CarriageReturn",h[h.Space=32]="Space",h[h.ExclamationMark=33]="ExclamationMark",h[h.DoubleQuote=34]="DoubleQuote",h[h.Hash=35]="Hash",h[h.DollarSign=36]="DollarSign",h[h.PercentSign=37]="PercentSign",h[h.Ampersand=38]="Ampersand",h[h.SingleQuote=39]="SingleQuote",h[h.OpenParen=40]="OpenParen",h[h.CloseParen=41]="CloseParen",h[h.Asterisk=42]="Asterisk",h[h.Plus=43]="Plus",h[h.Comma=44]="Comma",h[h.Dash=45]="Dash",h[h.Period=46]="Period",h[h.Slash=47]="Slash",h[h.Digit0=48]="Digit0",h[h.Digit1=49]="Digit1",h[h.Digit2=50]="Digit2",h[h.Digit3=51]="Digit3",h[h.Digit4=52]="Digit4",h[h.Digit5=53]="Digit5",h[h.Digit6=54]="Digit6",h[h.Digit7=55]="Digit7",h[h.Digit8=56]="Digit8",h[h.Digit9=57]="Digit9",h[h.Colon=58]="Colon",h[h.Semicolon=59]="Semicolon",h[h.LessThan=60]="LessThan",h[h.Equals=61]="Equals",h[h.GreaterThan=62]="GreaterThan",h[h.QuestionMark=63]="QuestionMark",h[h.AtSign=64]="AtSign",h[h.A=65]="A",h[h.B=66]="B",h[h.C=67]="C",h[h.D=68]="D",h[h.E=69]="E",h[h.F=70]="F",h[h.G=71]="G",h[h.H=72]="H",h[h.I=73]="I",h[h.J=74]="J",h[h.K=75]="K",h[h.L=76]="L",h[h.M=77]="M",h[h.N=78]="N",h[h.O=79]="O",h[h.P=80]="P",h[h.Q=81]="Q",h[h.R=82]="R",h[h.S=83]="S",h[h.T=84]="T",h[h.U=85]="U",h[h.V=86]="V",h[h.W=87]="W",h[h.X=88]="X",h[h.Y=89]="Y",h[h.Z=90]="Z",h[h.OpenSquareBracket=91]="OpenSquareBracket",h[h.Backslash=92]="Backslash",h[h.CloseSquareBracket=93]="CloseSquareBracket",h[h.Caret=94]="Caret",h[h.Underline=95]="Underline",h[h.BackTick=96]="BackTick",h[h.a=97]="a",h[h.b=98]="b",h[h.c=99]="c",h[h.d=100]="d",h[h.e=101]="e",h[h.f=102]="f",h[h.g=103]="g",h[h.h=104]="h",h[h.i=105]="i",h[h.j=106]="j",h[h.k=107]="k",h[h.l=108]="l",h[h.m=109]="m",h[h.n=110]="n",h[h.o=111]="o",h[h.p=112]="p",h[h.q=113]="q",h[h.r=114]="r",h[h.s=115]="s",h[h.t=116]="t",h[h.u=117]="u",h[h.v=118]="v",h[h.w=119]="w",h[h.x=120]="x",h[h.y=121]="y",h[h.z=122]="z",h[h.OpenCurlyBrace=123]="OpenCurlyBrace",h[h.Pipe=124]="Pipe",h[h.CloseCurlyBrace=125]="CloseCurlyBrace",h[h.Tilde=126]="Tilde",h[h.NoBreakSpace=160]="NoBreakSpace",h[h.U_Combining_Grave_Accent=768]="U_Combining_Grave_Accent",h[h.U_Combining_Acute_Accent=769]="U_Combining_Acute_Accent",h[h.U_Combining_Circumflex_Accent=770]="U_Combining_Circumflex_Accent",h[h.U_Combining_Tilde=771]="U_Combining_Tilde",h[h.U_Combining_Macron=772]="U_Combining_Macron",h[h.U_Combining_Overline=773]="U_Combining_Overline",h[h.U_Combining_Breve=774]="U_Combining_Breve",h[h.U_Combining_Dot_Above=775]="U_Combining_Dot_Above",h[h.U_Combining_Diaeresis=776]="U_Combining_Diaeresis",h[h.U_Combining_Hook_Above=777]="U_Combining_Hook_Above",h[h.U_Combining_Ring_Above=778]="U_Combining_Ring_Above",h[h.U_Combining_Double_Acute_Accent=779]="U_Combining_Double_Acute_Accent",h[h.U_Combining_Caron=780]="U_Combining_Caron",h[h.U_Combining_Vertical_Line_Above=781]="U_Combining_Vertical_Line_Above",h[h.U_Combining_Double_Vertical_Line_Above=782]="U_Combining_Double_Vertical_Line_Above",h[h.U_Combining_Double_Grave_Accent=783]="U_Combining_Double_Grave_Accent",h[h.U_Combining_Candrabindu=784]="U_Combining_Candrabindu",h[h.U_Combining_Inverted_Breve=785]="U_Combining_Inverted_Breve",h[h.U_Combining_Turned_Comma_Above=786]="U_Combining_Turned_Comma_Above",h[h.U_Combining_Comma_Above=787]="U_Combining_Comma_Above",h[h.U_Combining_Reversed_Comma_Above=788]="U_Combining_Reversed_Comma_Above",h[h.U_Combining_Comma_Above_Right=789]="U_Combining_Comma_Above_Right",h[h.U_Combining_Grave_Accent_Below=790]="U_Combining_Grave_Accent_Below",h[h.U_Combining_Acute_Accent_Below=791]="U_Combining_Acute_Accent_Below",h[h.U_Combining_Left_Tack_Below=792]="U_Combining_Left_Tack_Below",h[h.U_Combining_Right_Tack_Below=793]="U_Combining_Right_Tack_Below",h[h.U_Combining_Left_Angle_Above=794]="U_Combining_Left_Angle_Above",h[h.U_Combining_Horn=795]="U_Combining_Horn",h[h.U_Combining_Left_Half_Ring_Below=796]="U_Combining_Left_Half_Ring_Below",h[h.U_Combining_Up_Tack_Below=797]="U_Combining_Up_Tack_Below",h[h.U_Combining_Down_Tack_Below=798]="U_Combining_Down_Tack_Below",h[h.U_Combining_Plus_Sign_Below=799]="U_Combining_Plus_Sign_Below",h[h.U_Combining_Minus_Sign_Below=800]="U_Combining_Minus_Sign_Below",h[h.U_Combining_Palatalized_Hook_Below=801]="U_Combining_Palatalized_Hook_Below",h[h.U_Combining_Retroflex_Hook_Below=802]="U_Combining_Retroflex_Hook_Below",h[h.U_Combining_Dot_Below=803]="U_Combining_Dot_Below",h[h.U_Combining_Diaeresis_Below=804]="U_Combining_Diaeresis_Below",h[h.U_Combining_Ring_Below=805]="U_Combining_Ring_Below",h[h.U_Combining_Comma_Below=806]="U_Combining_Comma_Below",h[h.U_Combining_Cedilla=807]="U_Combining_Cedilla",h[h.U_Combining_Ogonek=808]="U_Combining_Ogonek",h[h.U_Combining_Vertical_Line_Below=809]="U_Combining_Vertical_Line_Below",h[h.U_Combining_Bridge_Below=810]="U_Combining_Bridge_Below",h[h.U_Combining_Inverted_Double_Arch_Below=811]="U_Combining_Inverted_Double_Arch_Below",h[h.U_Combining_Caron_Below=812]="U_Combining_Caron_Below",h[h.U_Combining_Circumflex_Accent_Below=813]="U_Combining_Circumflex_Accent_Below",h[h.U_Combining_Breve_Below=814]="U_Combining_Breve_Below",h[h.U_Combining_Inverted_Breve_Below=815]="U_Combining_Inverted_Breve_Below",h[h.U_Combining_Tilde_Below=816]="U_Combining_Tilde_Below",h[h.U_Combining_Macron_Below=817]="U_Combining_Macron_Below",h[h.U_Combining_Low_Line=818]="U_Combining_Low_Line",h[h.U_Combining_Double_Low_Line=819]="U_Combining_Double_Low_Line",h[h.U_Combining_Tilde_Overlay=820]="U_Combining_Tilde_Overlay",h[h.U_Combining_Short_Stroke_Overlay=821]="U_Combining_Short_Stroke_Overlay",h[h.U_Combining_Long_Stroke_Overlay=822]="U_Combining_Long_Stroke_Overlay",h[h.U_Combining_Short_Solidus_Overlay=823]="U_Combining_Short_Solidus_Overlay",h[h.U_Combining_Long_Solidus_Overlay=824]="U_Combining_Long_Solidus_Overlay",h[h.U_Combining_Right_Half_Ring_Below=825]="U_Combining_Right_Half_Ring_Below",h[h.U_Combining_Inverted_Bridge_Below=826]="U_Combining_Inverted_Bridge_Below",h[h.U_Combining_Square_Below=827]="U_Combining_Square_Below",h[h.U_Combining_Seagull_Below=828]="U_Combining_Seagull_Below",h[h.U_Combining_X_Above=829]="U_Combining_X_Above",h[h.U_Combining_Vertical_Tilde=830]="U_Combining_Vertical_Tilde",h[h.U_Combining_Double_Overline=831]="U_Combining_Double_Overline",h[h.U_Combining_Grave_Tone_Mark=832]="U_Combining_Grave_Tone_Mark",h[h.U_Combining_Acute_Tone_Mark=833]="U_Combining_Acute_Tone_Mark",h[h.U_Combining_Greek_Perispomeni=834]="U_Combining_Greek_Perispomeni",h[h.U_Combining_Greek_Koronis=835]="U_Combining_Greek_Koronis",h[h.U_Combining_Greek_Dialytika_Tonos=836]="U_Combining_Greek_Dialytika_Tonos",h[h.U_Combining_Greek_Ypogegrammeni=837]="U_Combining_Greek_Ypogegrammeni",h[h.U_Combining_Bridge_Above=838]="U_Combining_Bridge_Above",h[h.U_Combining_Equals_Sign_Below=839]="U_Combining_Equals_Sign_Below",h[h.U_Combining_Double_Vertical_Line_Below=840]="U_Combining_Double_Vertical_Line_Below",h[h.U_Combining_Left_Angle_Below=841]="U_Combining_Left_Angle_Below",h[h.U_Combining_Not_Tilde_Above=842]="U_Combining_Not_Tilde_Above",h[h.U_Combining_Homothetic_Above=843]="U_Combining_Homothetic_Above",h[h.U_Combining_Almost_Equal_To_Above=844]="U_Combining_Almost_Equal_To_Above",h[h.U_Combining_Left_Right_Arrow_Below=845]="U_Combining_Left_Right_Arrow_Below",h[h.U_Combining_Upwards_Arrow_Below=846]="U_Combining_Upwards_Arrow_Below",h[h.U_Combining_Grapheme_Joiner=847]="U_Combining_Grapheme_Joiner",h[h.U_Combining_Right_Arrowhead_Above=848]="U_Combining_Right_Arrowhead_Above",h[h.U_Combining_Left_Half_Ring_Above=849]="U_Combining_Left_Half_Ring_Above",h[h.U_Combining_Fermata=850]="U_Combining_Fermata",h[h.U_Combining_X_Below=851]="U_Combining_X_Below",h[h.U_Combining_Left_Arrowhead_Below=852]="U_Combining_Left_Arrowhead_Below",h[h.U_Combining_Right_Arrowhead_Below=853]="U_Combining_Right_Arrowhead_Below",h[h.U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below=854]="U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below",h[h.U_Combining_Right_Half_Ring_Above=855]="U_Combining_Right_Half_Ring_Above",h[h.U_Combining_Dot_Above_Right=856]="U_Combining_Dot_Above_Right",h[h.U_Combining_Asterisk_Below=857]="U_Combining_Asterisk_Below",h[h.U_Combining_Double_Ring_Below=858]="U_Combining_Double_Ring_Below",h[h.U_Combining_Zigzag_Above=859]="U_Combining_Zigzag_Above",h[h.U_Combining_Double_Breve_Below=860]="U_Combining_Double_Breve_Below",h[h.U_Combining_Double_Breve=861]="U_Combining_Double_Breve",h[h.U_Combining_Double_Macron=862]="U_Combining_Double_Macron",h[h.U_Combining_Double_Macron_Below=863]="U_Combining_Double_Macron_Below",h[h.U_Combining_Double_Tilde=864]="U_Combining_Double_Tilde",h[h.U_Combining_Double_Inverted_Breve=865]="U_Combining_Double_Inverted_Breve",h[h.U_Combining_Double_Rightwards_Arrow_Below=866]="U_Combining_Double_Rightwards_Arrow_Below",h[h.U_Combining_Latin_Small_Letter_A=867]="U_Combining_Latin_Small_Letter_A",h[h.U_Combining_Latin_Small_Letter_E=868]="U_Combining_Latin_Small_Letter_E",h[h.U_Combining_Latin_Small_Letter_I=869]="U_Combining_Latin_Small_Letter_I",h[h.U_Combining_Latin_Small_Letter_O=870]="U_Combining_Latin_Small_Letter_O",h[h.U_Combining_Latin_Small_Letter_U=871]="U_Combining_Latin_Small_Letter_U",h[h.U_Combining_Latin_Small_Letter_C=872]="U_Combining_Latin_Small_Letter_C",h[h.U_Combining_Latin_Small_Letter_D=873]="U_Combining_Latin_Small_Letter_D",h[h.U_Combining_Latin_Small_Letter_H=874]="U_Combining_Latin_Small_Letter_H",h[h.U_Combining_Latin_Small_Letter_M=875]="U_Combining_Latin_Small_Letter_M",h[h.U_Combining_Latin_Small_Letter_R=876]="U_Combining_Latin_Small_Letter_R",h[h.U_Combining_Latin_Small_Letter_T=877]="U_Combining_Latin_Small_Letter_T",h[h.U_Combining_Latin_Small_Letter_V=878]="U_Combining_Latin_Small_Letter_V",h[h.U_Combining_Latin_Small_Letter_X=879]="U_Combining_Latin_Small_Letter_X",h[h.LINE_SEPARATOR=8232]="LINE_SEPARATOR",h[h.PARAGRAPH_SEPARATOR=8233]="PARAGRAPH_SEPARATOR",h[h.NEXT_LINE=133]="NEXT_LINE",h[h.U_CIRCUMFLEX=94]="U_CIRCUMFLEX",h[h.U_GRAVE_ACCENT=96]="U_GRAVE_ACCENT",h[h.U_DIAERESIS=168]="U_DIAERESIS",h[h.U_MACRON=175]="U_MACRON",h[h.U_ACUTE_ACCENT=180]="U_ACUTE_ACCENT",h[h.U_CEDILLA=184]="U_CEDILLA",h[h.U_MODIFIER_LETTER_LEFT_ARROWHEAD=706]="U_MODIFIER_LETTER_LEFT_ARROWHEAD",h[h.U_MODIFIER_LETTER_RIGHT_ARROWHEAD=707]="U_MODIFIER_LETTER_RIGHT_ARROWHEAD",h[h.U_MODIFIER_LETTER_UP_ARROWHEAD=708]="U_MODIFIER_LETTER_UP_ARROWHEAD",h[h.U_MODIFIER_LETTER_DOWN_ARROWHEAD=709]="U_MODIFIER_LETTER_DOWN_ARROWHEAD",h[h.U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING=722]="U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING",h[h.U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING=723]="U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING",h[h.U_MODIFIER_LETTER_UP_TACK=724]="U_MODIFIER_LETTER_UP_TACK",h[h.U_MODIFIER_LETTER_DOWN_TACK=725]="U_MODIFIER_LETTER_DOWN_TACK",h[h.U_MODIFIER_LETTER_PLUS_SIGN=726]="U_MODIFIER_LETTER_PLUS_SIGN",h[h.U_MODIFIER_LETTER_MINUS_SIGN=727]="U_MODIFIER_LETTER_MINUS_SIGN",h[h.U_BREVE=728]="U_BREVE",h[h.U_DOT_ABOVE=729]="U_DOT_ABOVE",h[h.U_RING_ABOVE=730]="U_RING_ABOVE",h[h.U_OGONEK=731]="U_OGONEK",h[h.U_SMALL_TILDE=732]="U_SMALL_TILDE",h[h.U_DOUBLE_ACUTE_ACCENT=733]="U_DOUBLE_ACUTE_ACCENT",h[h.U_MODIFIER_LETTER_RHOTIC_HOOK=734]="U_MODIFIER_LETTER_RHOTIC_HOOK",h[h.U_MODIFIER_LETTER_CROSS_ACCENT=735]="U_MODIFIER_LETTER_CROSS_ACCENT",h[h.U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR=741]="U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR",h[h.U_MODIFIER_LETTER_HIGH_TONE_BAR=742]="U_MODIFIER_LETTER_HIGH_TONE_BAR",h[h.U_MODIFIER_LETTER_MID_TONE_BAR=743]="U_MODIFIER_LETTER_MID_TONE_BAR",h[h.U_MODIFIER_LETTER_LOW_TONE_BAR=744]="U_MODIFIER_LETTER_LOW_TONE_BAR",h[h.U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR=745]="U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR",h[h.U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK=746]="U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK",h[h.U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK=747]="U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK",h[h.U_MODIFIER_LETTER_UNASPIRATED=749]="U_MODIFIER_LETTER_UNASPIRATED",h[h.U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD=751]="U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD",h[h.U_MODIFIER_LETTER_LOW_UP_ARROWHEAD=752]="U_MODIFIER_LETTER_LOW_UP_ARROWHEAD",h[h.U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD=753]="U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD",h[h.U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD=754]="U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD",h[h.U_MODIFIER_LETTER_LOW_RING=755]="U_MODIFIER_LETTER_LOW_RING",h[h.U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT=756]="U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT",h[h.U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT=757]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT",h[h.U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT=758]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT",h[h.U_MODIFIER_LETTER_LOW_TILDE=759]="U_MODIFIER_LETTER_LOW_TILDE",h[h.U_MODIFIER_LETTER_RAISED_COLON=760]="U_MODIFIER_LETTER_RAISED_COLON",h[h.U_MODIFIER_LETTER_BEGIN_HIGH_TONE=761]="U_MODIFIER_LETTER_BEGIN_HIGH_TONE",h[h.U_MODIFIER_LETTER_END_HIGH_TONE=762]="U_MODIFIER_LETTER_END_HIGH_TONE",h[h.U_MODIFIER_LETTER_BEGIN_LOW_TONE=763]="U_MODIFIER_LETTER_BEGIN_LOW_TONE",h[h.U_MODIFIER_LETTER_END_LOW_TONE=764]="U_MODIFIER_LETTER_END_LOW_TONE",h[h.U_MODIFIER_LETTER_SHELF=765]="U_MODIFIER_LETTER_SHELF",h[h.U_MODIFIER_LETTER_OPEN_SHELF=766]="U_MODIFIER_LETTER_OPEN_SHELF",h[h.U_MODIFIER_LETTER_LOW_LEFT_ARROW=767]="U_MODIFIER_LETTER_LOW_LEFT_ARROW",h[h.U_GREEK_LOWER_NUMERAL_SIGN=885]="U_GREEK_LOWER_NUMERAL_SIGN",h[h.U_GREEK_TONOS=900]="U_GREEK_TONOS",h[h.U_GREEK_DIALYTIKA_TONOS=901]="U_GREEK_DIALYTIKA_TONOS",h[h.U_GREEK_KORONIS=8125]="U_GREEK_KORONIS",h[h.U_GREEK_PSILI=8127]="U_GREEK_PSILI",h[h.U_GREEK_PERISPOMENI=8128]="U_GREEK_PERISPOMENI",h[h.U_GREEK_DIALYTIKA_AND_PERISPOMENI=8129]="U_GREEK_DIALYTIKA_AND_PERISPOMENI",h[h.U_GREEK_PSILI_AND_VARIA=8141]="U_GREEK_PSILI_AND_VARIA",h[h.U_GREEK_PSILI_AND_OXIA=8142]="U_GREEK_PSILI_AND_OXIA",h[h.U_GREEK_PSILI_AND_PERISPOMENI=8143]="U_GREEK_PSILI_AND_PERISPOMENI",h[h.U_GREEK_DASIA_AND_VARIA=8157]="U_GREEK_DASIA_AND_VARIA",h[h.U_GREEK_DASIA_AND_OXIA=8158]="U_GREEK_DASIA_AND_OXIA",h[h.U_GREEK_DASIA_AND_PERISPOMENI=8159]="U_GREEK_DASIA_AND_PERISPOMENI",h[h.U_GREEK_DIALYTIKA_AND_VARIA=8173]="U_GREEK_DIALYTIKA_AND_VARIA",h[h.U_GREEK_DIALYTIKA_AND_OXIA=8174]="U_GREEK_DIALYTIKA_AND_OXIA",h[h.U_GREEK_VARIA=8175]="U_GREEK_VARIA",h[h.U_GREEK_OXIA=8189]="U_GREEK_OXIA",h[h.U_GREEK_DASIA=8190]="U_GREEK_DASIA",h[h.U_IDEOGRAPHIC_FULL_STOP=12290]="U_IDEOGRAPHIC_FULL_STOP",h[h.U_LEFT_CORNER_BRACKET=12300]="U_LEFT_CORNER_BRACKET",h[h.U_RIGHT_CORNER_BRACKET=12301]="U_RIGHT_CORNER_BRACKET",h[h.U_LEFT_BLACK_LENTICULAR_BRACKET=12304]="U_LEFT_BLACK_LENTICULAR_BRACKET",h[h.U_RIGHT_BLACK_LENTICULAR_BRACKET=12305]="U_RIGHT_BLACK_LENTICULAR_BRACKET",h[h.U_OVERLINE=8254]="U_OVERLINE",h[h.UTF8_BOM=65279]="UTF8_BOM",h[h.U_FULLWIDTH_SEMICOLON=65307]="U_FULLWIDTH_SEMICOLON",h[h.U_FULLWIDTH_COMMA=65292]="U_FULLWIDTH_COMMA"})(r||(e.CharCode=r={}))}),define(Ee[79],ye([1,0]),function(ce,e){"use strict";var r;Object.defineProperty(e,"__esModule",{value:!0}),e.$O=void 0,e.$K=h,e.$L=P,e.$M=R,e.$N=T;function h($,c){const I=Object.create(null);for(const E of $){const u=c(E);let k=I[u];k||(k=I[u]=[]),k.push(E)}return I}function P($,c){const I=[],E=[];for(const u of $)c.has(u)||I.push(u);for(const u of c)$.has(u)||E.push(u);return{removed:I,added:E}}function R($,c){const I=[],E=[];for(const[u,k]of $)c.has(u)||I.push(k);for(const[u,k]of c)$.has(u)||E.push(k);return{removed:I,added:E}}function T($,c){const I=new Set;for(const E of c)$.has(E)&&I.add(E);return I}class N{static{r=Symbol.toStringTag}constructor(c,I){this.b=I,this.a=new Map,this[r]="SetWithKey";for(const E of c)this.add(E)}get size(){return this.a.size}add(c){const I=this.b(c);return this.a.set(I,c),this}delete(c){return this.a.delete(this.b(c))}has(c){return this.a.has(this.b(c))}*entries(){for(const c of this.a.values())yield[c,c]}keys(){return this.values()}*values(){for(const c of this.a.values())yield c}clear(){this.a.clear()}forEach(c,I){this.a.forEach(E=>c.call(I,E,E,this))}[Symbol.iterator](){return this.values()}}e.$O=N}),define(Ee[59],ye([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0h=h,e.$$h=P,e.$_h=R;function r(T){return(N,$,c)=>{let I=null,E=null;if(typeof c.value=="function"?(I="value",E=c.value):typeof c.get=="function"&&(I="get",E=c.get),!E)throw new Error("not supported");c[I]=T(E,$)}}function h(T,N,$){let c=null,I=null;if(typeof $.value=="function"?(c="value",I=$.value,I.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof $.get=="function"&&(c="get",I=$.get),!I)throw new Error("not supported");const E=`$memoize$${N}`;$[c]=function(...u){return this.hasOwnProperty(E)||Object.defineProperty(this,E,{configurable:!1,enumerable:!1,writable:!1,value:I.apply(this,u)}),this[E]}}function P(T,N,$){return r((c,I)=>{const E=`$debounce$${I}`,u=`$debounce$result$${I}`;return function(...k){this[u]||(this[u]=$?$():void 0),clearTimeout(this[E]),N&&(this[u]=N(this[u],...k),k=[this[u]]),this[E]=setTimeout(()=>{c.apply(this,k),this[u]=$?$():void 0},T)}})}function R(T,N,$){return r((c,I)=>{const E=`$throttle$timer$${I}`,u=`$throttle$result$${I}`,k=`$throttle$lastRun$${I}`,p=`$throttle$pending$${I}`;return function(...a){if(this[u]||(this[u]=$?$():void 0),(this[k]===null||this[k]===void 0)&&(this[k]=-Number.MAX_VALUE),N&&(this[u]=N(this[u],...a)),this[p])return;const f=this[k]+T;f<=Date.now()?(this[k]=Date.now(),c.apply(this,[this[u]]),this[u]=$?$():void 0):(this[p]=!0,this[E]=setTimeout(()=>{this[p]=!1,this[k]=Date.now(),c.apply(this,[this[u]]),this[u]=$?$():void 0},f-Date.now()))}})}}),define(Ee[14],ye([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eb=e.$db=e.$cb=e.$bb=e.$ab=e.$$=e.$7=e.$Z=e.$Y=void 0,e.setUnexpectedErrorHandler=h,e.$2=P,e.$3=R,e.$4=T,e.$5=N,e.$6=c,e.$8=E,e.$9=u,e.$0=k,e.$_=a;class r{constructor(){this.b=[],this.a=function(i){setTimeout(()=>{throw i.stack?n.isErrorNoTelemetry(i)?new n(i.message+`

`+i.stack):new Error(i.message+`

`+i.stack):i},0)}}addListener(i){return this.b.push(i),()=>{this.d(i)}}c(i){this.b.forEach(s=>{s(i)})}d(i){this.b.splice(this.b.indexOf(i),1)}setUnexpectedErrorHandler(i){this.a=i}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(i){this.a(i),this.c(i)}onUnexpectedExternalError(i){this.a(i)}}e.$Y=r,e.$Z=new r;function h(t){e.$Z.setUnexpectedErrorHandler(t)}function P(t){if(!t||typeof t!="object")return!1;const i=t;return i.code==="EPIPE"&&i.syscall?.toUpperCase()==="WRITE"}function R(t){c(t)||e.$Z.onUnexpectedError(t)}function T(t){c(t)||e.$Z.onUnexpectedExternalError(t)}function N(t){if(t instanceof Error){const{name:i,message:s}=t,g=t.stacktrace||t.stack;return{$isError:!0,name:i,message:s,stack:g,noTelemetry:n.isErrorNoTelemetry(t)}}return t}const $="Canceled";function c(t){return t instanceof I?!0:t instanceof Error&&t.name===$&&t.message===$}class I extends Error{constructor(){super($),this.name=this.message}}e.$7=I;function E(){const t=new Error($);return t.name=t.message,t}function u(t){return t?new Error(`Illegal argument: ${t}`):new Error("Illegal argument")}function k(t){return t?new Error(`Illegal state: ${t}`):new Error("Illegal state")}class p extends TypeError{constructor(i){super(i?`${i} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$$=p;function a(t){return t?t.message?t.message:t.stack?t.stack.split(`
`)[0]:String(t):"Error"}class f extends Error{constructor(i){super("NotImplemented"),i&&(this.message=i)}}e.$ab=f;class d extends Error{constructor(i){super("NotSupported"),i&&(this.message=i)}}e.$bb=d;class m extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$cb=m;class n extends Error{constructor(i){super(i),this.name="CodeExpectedError"}static fromError(i){if(i instanceof n)return i;const s=new n;return s.message=i.message,s.stack=i.stack,s}static isErrorNoTelemetry(i){return i.name==="CodeExpectedError"}}e.$db=n;class o extends Error{constructor(i){super(i||"An unexpected bug occurred."),Object.setPrototypeOf(this,o.prototype)}}e.$eb=o}),define(Ee[19],ye([1,0,14,132]),function(ce,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cc=e.$bc=e.$ac=e.$$b=e.$0b=e.CompareResult=void 0,e.$ub=P,e.$vb=R,e.$wb=T,e.$xb=N,e.$yb=$,e.$zb=c,e.$Ab=I,e.$Bb=E,e.$Cb=u,e.$Db=k,e.$Eb=p,e.$Fb=a,e.$Gb=f,e.top=d,e.$Ib=m,e.$Jb=o,e.$Kb=t,e.$Lb=i,e.$Mb=s,e.$Nb=g,e.$Ob=l,e.$Pb=w,e.$Qb=S,e.$Rb=D,e.$Sb=y,e.$Tb=C,e.$Ub=A,e.$Vb=b,e.$Wb=v,e.$Xb=L,e.$Yb=O,e.$Zb=M,e.$1b=j,e.$2b=z,e.$3b=F,e.$4b=B,e.$5b=_,e.$6b=re,e.$7b=U,e.$8b=ee,e.$9b=he,e.$_b=$e;function P(oe,te=0){return oe[oe.length-(1+te)]}function R(oe){if(oe.length===0)throw new Error("Invalid tail call");return[oe.slice(0,oe.length-1),oe[oe.length-1]]}function T(oe,te,le=(ue,X)=>ue===X){if(oe===te)return!0;if(!oe||!te||oe.length!==te.length)return!1;for(let ue=0,X=oe.length;ue<X;ue++)if(!le(oe[ue],te[ue]))return!1;return!0}function N(oe,te){const le=oe.length-1;te<le&&(oe[te]=oe[le]),oe.pop()}function $(oe,te,le){return c(oe.length,ue=>le(oe[ue],te))}function c(oe,te){let le=0,ue=oe-1;for(;le<=ue;){const X=(le+ue)/2|0,ae=te(X);if(ae<0)le=X+1;else if(ae>0)ue=X-1;else return X}return-(le+1)}function I(oe,te,le){if(oe=oe|0,oe>=te.length)throw new TypeError("invalid index");const ue=te[Math.floor(te.length*Math.random())],X=[],ae=[],pe=[];for(const be of te){const Fe=le(be,ue);Fe<0?X.push(be):Fe>0?ae.push(be):pe.push(be)}return oe<X.length?I(oe,X,le):oe<X.length+pe.length?pe[0]:I(oe-(X.length+pe.length),ae,le)}function E(oe,te){const le=[];let ue;for(const X of oe.slice(0).sort(te))!ue||te(ue[0],X)!==0?(ue=[X],le.push(ue)):ue.push(X);return le}function*u(oe,te){let le,ue;for(const X of oe)ue!==void 0&&te(ue,X)?le.push(X):(le&&(yield le),le=[X]),ue=X;le&&(yield le)}function k(oe,te){for(let le=0;le<=oe.length;le++)te(le===0?void 0:oe[le-1],le===oe.length?void 0:oe[le])}function p(oe,te){for(let le=0;le<oe.length;le++)te(le===0?void 0:oe[le-1],oe[le],le+1===oe.length?void 0:oe[le+1])}function a(oe,te,le){const ue=[];function X(be,Fe,Ue){if(Fe===0&&Ue.length===0)return;const ke=ue[ue.length-1];ke&&ke.start+ke.deleteCount===be?(ke.deleteCount+=Fe,ke.toInsert.push(...Ue)):ue.push({start:be,deleteCount:Fe,toInsert:Ue})}let ae=0,pe=0;for(;;){if(ae===oe.length){X(ae,0,te.slice(pe));break}if(pe===te.length){X(ae,oe.length-ae,[]);break}const be=oe[ae],Fe=te[pe],Ue=le(be,Fe);Ue===0?(ae+=1,pe+=1):Ue<0?(X(ae,1,[]),ae+=1):Ue>0&&(X(ae,0,[Fe]),pe+=1)}return ue}function f(oe,te,le){const ue=a(oe,te,le),X=[],ae=[];for(const pe of ue)X.push(...oe.slice(pe.start,pe.start+pe.deleteCount)),ae.push(...pe.toInsert);return{removed:X,added:ae}}function d(oe,te,le){if(le===0)return[];const ue=oe.slice(0,le).sort(te);return n(oe,te,ue,le,oe.length),ue}function m(oe,te,le,ue,X){return le===0?Promise.resolve([]):new Promise((ae,pe)=>{(async()=>{const be=oe.length,Fe=oe.slice(0,le).sort(te);for(let Ue=le,ke=Math.min(le+ue,be);Ue<be;Ue=ke,ke=Math.min(ke+ue,be)){if(Ue>le&&await new Promise(Ie=>setTimeout(Ie)),X&&X.isCancellationRequested)throw new r.$7;n(oe,te,Fe,Ue,ke)}return Fe})().then(ae,pe)})}function n(oe,te,le,ue,X){for(const ae=le.length;ue<X;ue++){const pe=oe[ue];if(te(pe,le[ae-1])<0){le.pop();const be=(0,h.$mb)(le,Fe=>te(pe,Fe)<0);le.splice(be,0,pe)}}}function o(oe){return oe.filter(te=>!!te)}function t(oe){let te=0;for(let le=0;le<oe.length;le++)oe[le]&&(oe[te]=oe[le],te+=1);oe.length=te}function i(oe,te,le){oe.splice(le,0,oe.splice(te,1)[0])}function s(oe){return!Array.isArray(oe)||oe.length===0}function g(oe){return Array.isArray(oe)&&oe.length>0}function l(oe,te=le=>le){const le=new Set;return oe.filter(ue=>{const X=te(ue);return le.has(X)?!1:(le.add(X),!0)})}function w(oe){const te=new Set;return le=>{const ue=oe(le);return te.has(ue)?!1:(te.add(ue),!0)}}function S(oe,te){return oe.length>0?oe[0]:te}function D(oe,te){return oe.length>0?oe[oe.length-1]:te}function y(oe,te,le=(ue,X)=>ue===X){let ue=0;for(let X=0,ae=Math.min(oe.length,te.length);X<ae&&le(oe[X],te[X]);X++)ue++;return ue}function C(oe,te){let le=typeof te=="number"?oe:0;typeof te=="number"?le=oe:(le=0,te=oe);const ue=[];if(le<=te)for(let X=le;X<te;X++)ue.push(X);else for(let X=le;X>te;X--)ue.push(X);return ue}function A(oe,te,le){return oe.reduce((ue,X)=>(ue[te(X)]=le?le(X):X,ue),Object.create(null))}function b(oe,te){return oe.push(te),()=>v(oe,te)}function v(oe,te){const le=oe.indexOf(te);if(le>-1)return oe.splice(le,1),te}function L(oe,te,le){const ue=oe.slice(0,te),X=oe.slice(te);return ue.concat(le,X)}function O(oe,te){let le;if(typeof te=="number"){let ue=te;le=()=>{const X=Math.sin(ue++)*179426549;return X-Math.floor(X)}}else le=Math.random;for(let ue=oe.length-1;ue>0;ue-=1){const X=Math.floor(le()*(ue+1)),ae=oe[ue];oe[ue]=oe[X],oe[X]=ae}}function M(oe,te){const le=oe.indexOf(te);le>-1&&(oe.splice(le,1),oe.unshift(te))}function j(oe,te){const le=oe.indexOf(te);le>-1&&(oe.splice(le,1),oe.push(te))}function z(oe,te){for(const le of te)oe.push(le)}function F(oe,te){return Array.isArray(oe)?oe.map(te):te(oe)}function B(oe){return Array.isArray(oe)?oe:[oe]}function _(oe){return oe[Math.floor(Math.random()*oe.length)]}function re(oe,te,le){const ue=G(oe,te),X=oe.length,ae=le.length;oe.length=X+ae;for(let pe=X-1;pe>=ue;pe--)oe[pe+ae]=oe[pe];for(let pe=0;pe<ae;pe++)oe[pe+ue]=le[pe]}function U(oe,te,le,ue){const X=G(oe,te);let ae=oe.splice(X,le);return ae===void 0&&(ae=[]),re(oe,X,ue),ae}function G(oe,te){return te<0?Math.max(te+oe.length,0):Math.min(te,oe.length)}var Q;(function(oe){function te(ae){return ae<0}oe.isLessThan=te;function le(ae){return ae<=0}oe.isLessThanOrEqual=le;function ue(ae){return ae>0}oe.isGreaterThan=ue;function X(ae){return ae===0}oe.isNeitherLessOrGreaterThan=X,oe.greaterThan=1,oe.lessThan=-1,oe.neitherLessOrGreaterThan=0})(Q||(e.CompareResult=Q={}));function ee(oe,te){return(le,ue)=>te(oe(le),oe(ue))}function he(...oe){return(te,le)=>{for(const ue of oe){const X=ue(te,le);if(!Q.isNeitherLessOrGreaterThan(X))return X}return Q.neitherLessOrGreaterThan}}const ne=(oe,te)=>oe-te;e.$0b=ne;const De=(oe,te)=>(0,e.$0b)(oe?1:0,te?1:0);e.$$b=De;function $e(oe){return(te,le)=>-oe(te,le)}class K{constructor(te){this.g=te,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(te){let le=this.c;for(;le<this.g.length&&te(this.g[le]);)le++;const ue=le===this.c?null:this.g.slice(this.c,le);return this.c=le,ue}takeFromEndWhile(te){let le=this.d;for(;le>=0&&te(this.g[le]);)le--;const ue=le===this.d?null:this.g.slice(le+1,this.d+1);return this.d=le,ue}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const te=this.g[this.c];return this.c++,te}removeLast(){const te=this.g[this.d];return this.d--,te}takeCount(te){const le=this.g.slice(this.c,this.c+te);return this.c+=te,le}}e.$ac=K;class W{static{this.empty=new W(te=>{})}constructor(te){this.iterate=te}forEach(te){this.iterate(le=>(te(le),!0))}toArray(){const te=[];return this.iterate(le=>(te.push(le),!0)),te}filter(te){return new W(le=>this.iterate(ue=>te(ue)?le(ue):!0))}map(te){return new W(le=>this.iterate(ue=>le(te(ue))))}some(te){let le=!1;return this.iterate(ue=>(le=te(ue),!le)),le}findFirst(te){let le;return this.iterate(ue=>te(ue)?(le=ue,!1):!0),le}findLast(te){let le;return this.iterate(ue=>(te(ue)&&(le=ue),!0)),le}findLastMaxBy(te){let le,ue=!0;return this.iterate(X=>((ue||Q.isGreaterThan(te(X,le)))&&(ue=!1,le=X),!0)),le}}e.$bc=W;class se{constructor(te){this.c=te}static createSortPermutation(te,le){const ue=Array.from(te.keys()).sort((X,ae)=>le(te[X],te[ae]));return new se(ue)}apply(te){return te.map((le,ue)=>te[this.c[ue]])}inverse(){const te=this.c.slice();for(let le=0;le<this.c.length;le++)te[this.c[le]]=le;return new se(te)}}e.$cc=se}),define(Ee[66],ye([1,0,14]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=h,e.$gd=P,e.$hd=R,e.$id=T,e.$jd=N,e.$kd=$;function h(c,I){if(!c)throw new Error(I?`Assertion failed (${I})`:"Assertion Failed")}function P(c,I="Unreachable"){throw new Error(I)}function R(c,I="unexpected state"){if(!c)throw new r.$eb(`Assertion Failed: ${I}`)}function T(c){c||(0,r.$3)(new r.$eb("Soft Assertion Failed"))}function N(c){if(!c()){debugger;c(),(0,r.$3)(new r.$eb("Assertion Failed"))}}function $(c,I){let E=0;for(;E<c.length-1;){const u=c[E],k=c[E+1];if(!I(u,k))return!1;E++}return!0}});var Un=this&&this.__createBinding||(Object.create?function(ce,e,r,h){h===void 0&&(h=r);var P=Object.getOwnPropertyDescriptor(e,r);(!P||("get"in P?!e.__esModule:P.writable||P.configurable))&&(P={enumerable:!0,get:function(){return e[r]}}),Object.defineProperty(ce,h,P)}:function(ce,e,r,h){h===void 0&&(h=r),ce[h]=e[r]}),Wn=this&&this.__setModuleDefault||(Object.create?function(ce,e){Object.defineProperty(ce,"default",{enumerable:!0,value:e})}:function(ce,e){ce.default=e}),We=this&&this.__importStar||function(ce){if(ce&&ce.__esModule)return ce;var e={};if(ce!=null)for(var r in ce)r!=="default"&&Object.prototype.hasOwnProperty.call(ce,r)&&Un(e,ce,r);return Wn(e,ce),e};define(Ee[174],ye([1,0,19]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8c=void 0,e.$9c=P,e.$0c=R,e.$$c=T,e.$_c=N,e.$ad=$,e.$bd=c,r=We(r);const h=(k,p)=>k===p;e.$8c=h;function P(k=e.$8c){return(p,a)=>r.$wb(p,a,k)}function R(){return(k,p)=>JSON.stringify(k)===JSON.stringify(p)}function T(){return(k,p)=>k.equals(p)}function N(k,p,a){if(a!==void 0){const f=k;return f==null||p===void 0||p===null?p===f:a(f,p)}else{const f=k;return(d,m)=>d==null||m===void 0||m===null?m===d:f(d,m)}}function $(k,p){if(k===p)return!0;if(Array.isArray(k)&&Array.isArray(p)){if(k.length!==p.length)return!1;for(let a=0;a<k.length;a++)if(!$(k[a],p[a]))return!1;return!0}if(k&&typeof k=="object"&&p&&typeof p=="object"&&Object.getPrototypeOf(k)===Object.prototype&&Object.getPrototypeOf(p)===Object.prototype){const a=k,f=p,d=Object.keys(a),m=Object.keys(f),n=new Set(m);if(d.length!==m.length)return!1;for(const o of d)if(!n.has(o)||!$(a[o],f[o]))return!1;return!0}return!1}function c(k){return JSON.stringify(u(k))}let I=0;const E=new WeakMap;function u(k){if(Array.isArray(k))return k.map(u);if(k&&typeof k=="object")if(Object.getPrototypeOf(k)===Object.prototype){const p=k,a=Object.create(null);for(const f of Object.keys(p).sort())a[f]=u(p[f]);return a}else{let p=E.get(k);return p===void 0&&(p=I++,E.set(k,p)),p+"----2b76a038c20c4bcc"}return k}}),define(Ee[80],ye([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fb=r;function r(h,P){const R=this;let T=!1,N;return function(){if(T)return N;if(T=!0,P)try{N=h.apply(R,arguments)}finally{P()}else N=h.apply(R,arguments);return N}}}),define(Ee[133],ye([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4P=e.$3P=void 0;class r{constructor(P){this.a=P,this.b=0}nextId(){return this.a+ ++this.b}}e.$3P=r,e.$4P=new r("id#")}),define(Ee[40],ye([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var r;(function(h){function P(s){return s&&typeof s=="object"&&typeof s[Symbol.iterator]=="function"}h.is=P;const R=Object.freeze([]);function T(){return R}h.empty=T;function*N(s){yield s}h.single=N;function $(s){return P(s)?s:N(s)}h.wrap=$;function c(s){return s||R}h.from=c;function*I(s){for(let g=s.length-1;g>=0;g--)yield s[g]}h.reverse=I;function E(s){return!s||s[Symbol.iterator]().next().done===!0}h.isEmpty=E;function u(s){return s[Symbol.iterator]().next().value}h.first=u;function k(s,g){let l=0;for(const w of s)if(g(w,l++))return!0;return!1}h.some=k;function p(s,g){for(const l of s)if(g(l))return l}h.find=p;function*a(s,g){for(const l of s)g(l)&&(yield l)}h.filter=a;function*f(s,g){let l=0;for(const w of s)yield g(w,l++)}h.map=f;function*d(s,g){let l=0;for(const w of s)yield*g(w,l++)}h.flatMap=d;function*m(...s){for(const g of s)yield*g}h.concat=m;function n(s,g,l){let w=l;for(const S of s)w=g(w,S);return w}h.reduce=n;function*o(s,g,l=s.length){for(g<0&&(g+=s.length),l<0?l+=s.length:l>s.length&&(l=s.length);g<l;g++)yield s[g]}h.slice=o;function t(s,g=Number.POSITIVE_INFINITY){const l=[];if(g===0)return[l,s];const w=s[Symbol.iterator]();for(let S=0;S<g;S++){const D=w.next();if(D.done)return[l,h.empty()];l.push(D.value)}return[l,{[Symbol.iterator](){return w}}]}h.consume=t;async function i(s){const g=[];for await(const l of s)g.push(l);return Promise.resolve(g)}h.asyncToArray=i})(r||(e.Iterable=r={}))}),define(Ee[175],ye([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0,e.$Tn=T,e.$Un=E,e.$Vn=u,e.$Wn=k,e.$Xn=p,e.$Yn=a,e.$Zn=f,e.$1n=d,e.$2n=m,e.$3n=n,e.$4n=o;var r;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(r||(e.ScanError=r={}));var h;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(h||(e.SyntaxKind=h={}));var P;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(P||(e.ParseErrorCode=P={}));var R;(function(t){t.DEFAULT={allowTrailingComma:!0}})(R||(e.ParseOptions=R={}));function T(t,i=!1){let s=0;const g=t.length;let l="",w=0,S=h.Unknown,D=r.None;function y(M){let j=0,z=0;for(;j<M;){const F=t.charCodeAt(s);if(F>=I._0&&F<=I._9)z=z*16+F-I._0;else if(F>=I.A&&F<=I.F)z=z*16+F-I.A+10;else if(F>=I.a&&F<=I.f)z=z*16+F-I.a+10;else break;s++,j++}return j<M&&(z=-1),z}function C(M){s=M,l="",w=0,S=h.Unknown,D=r.None}function A(){const M=s;if(t.charCodeAt(s)===I._0)s++;else for(s++;s<t.length&&c(t.charCodeAt(s));)s++;if(s<t.length&&t.charCodeAt(s)===I.dot)if(s++,s<t.length&&c(t.charCodeAt(s)))for(s++;s<t.length&&c(t.charCodeAt(s));)s++;else return D=r.UnexpectedEndOfNumber,t.substring(M,s);let j=s;if(s<t.length&&(t.charCodeAt(s)===I.E||t.charCodeAt(s)===I.e))if(s++,(s<t.length&&t.charCodeAt(s)===I.plus||t.charCodeAt(s)===I.minus)&&s++,s<t.length&&c(t.charCodeAt(s))){for(s++;s<t.length&&c(t.charCodeAt(s));)s++;j=s}else D=r.UnexpectedEndOfNumber;return t.substring(M,j)}function b(){let M="",j=s;for(;;){if(s>=g){M+=t.substring(j,s),D=r.UnexpectedEndOfString;break}const z=t.charCodeAt(s);if(z===I.doubleQuote){M+=t.substring(j,s),s++;break}if(z===I.backslash){if(M+=t.substring(j,s),s++,s>=g){D=r.UnexpectedEndOfString;break}switch(t.charCodeAt(s++)){case I.doubleQuote:M+='"';break;case I.backslash:M+="\\";break;case I.slash:M+="/";break;case I.b:M+="\b";break;case I.f:M+="\f";break;case I.n:M+=`
`;break;case I.r:M+="\r";break;case I.t:M+="	";break;case I.u:{const B=y(4);B>=0?M+=String.fromCharCode(B):D=r.InvalidUnicode;break}default:D=r.InvalidEscapeCharacter}j=s;continue}if(z>=0&&z<=31)if($(z)){M+=t.substring(j,s),D=r.UnexpectedEndOfString;break}else D=r.InvalidCharacter;s++}return M}function v(){if(l="",D=r.None,w=s,s>=g)return w=g,S=h.EOF;let M=t.charCodeAt(s);if(N(M)){do s++,l+=String.fromCharCode(M),M=t.charCodeAt(s);while(N(M));return S=h.Trivia}if($(M))return s++,l+=String.fromCharCode(M),M===I.carriageReturn&&t.charCodeAt(s)===I.lineFeed&&(s++,l+=`
`),S=h.LineBreakTrivia;switch(M){case I.openBrace:return s++,S=h.OpenBraceToken;case I.closeBrace:return s++,S=h.CloseBraceToken;case I.openBracket:return s++,S=h.OpenBracketToken;case I.closeBracket:return s++,S=h.CloseBracketToken;case I.colon:return s++,S=h.ColonToken;case I.comma:return s++,S=h.CommaToken;case I.doubleQuote:return s++,l=b(),S=h.StringLiteral;case I.slash:{const j=s-1;if(t.charCodeAt(s+1)===I.slash){for(s+=2;s<g&&!$(t.charCodeAt(s));)s++;return l=t.substring(j,s),S=h.LineCommentTrivia}if(t.charCodeAt(s+1)===I.asterisk){s+=2;const z=g-1;let F=!1;for(;s<z;){if(t.charCodeAt(s)===I.asterisk&&t.charCodeAt(s+1)===I.slash){s+=2,F=!0;break}s++}return F||(s++,D=r.UnexpectedEndOfComment),l=t.substring(j,s),S=h.BlockCommentTrivia}return l+=String.fromCharCode(M),s++,S=h.Unknown}case I.minus:if(l+=String.fromCharCode(M),s++,s===g||!c(t.charCodeAt(s)))return S=h.Unknown;case I._0:case I._1:case I._2:case I._3:case I._4:case I._5:case I._6:case I._7:case I._8:case I._9:return l+=A(),S=h.NumericLiteral;default:for(;s<g&&L(M);)s++,M=t.charCodeAt(s);if(w!==s){switch(l=t.substring(w,s),l){case"true":return S=h.TrueKeyword;case"false":return S=h.FalseKeyword;case"null":return S=h.NullKeyword}return S=h.Unknown}return l+=String.fromCharCode(M),s++,S=h.Unknown}}function L(M){if(N(M)||$(M))return!1;switch(M){case I.closeBrace:case I.closeBracket:case I.openBrace:case I.openBracket:case I.doubleQuote:case I.colon:case I.comma:case I.slash:return!1}return!0}function O(){let M;do M=v();while(M>=h.LineCommentTrivia&&M<=h.Trivia);return M}return{setPosition:C,getPosition:()=>s,scan:i?O:v,getToken:()=>S,getTokenValue:()=>l,getTokenOffset:()=>w,getTokenLength:()=>s-w,getTokenError:()=>D}}function N(t){return t===I.space||t===I.tab||t===I.verticalTab||t===I.formFeed||t===I.nonBreakingSpace||t===I.ogham||t>=I.enQuad&&t<=I.zeroWidthSpace||t===I.narrowNoBreakSpace||t===I.mathematicalSpace||t===I.ideographicSpace||t===I.byteOrderMark}function $(t){return t===I.lineFeed||t===I.carriageReturn||t===I.lineSeparator||t===I.paragraphSeparator}function c(t){return t>=I._0&&t<=I._9}var I;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(I||(I={}));function E(t,i){const s=[],g=new Object;let l;const w={value:{},offset:0,length:0,type:"object",parent:void 0};let S=!1;function D(y,C,A,b){w.value=y,w.offset=C,w.length=A,w.type=b,w.colonOffset=void 0,l=w}try{n(t,{onObjectBegin:(y,C)=>{if(i<=y)throw g;l=void 0,S=i>y,s.push("")},onObjectProperty:(y,C,A)=>{if(i<C||(D(y,C,A,"property"),s[s.length-1]=y,i<=C+A))throw g},onObjectEnd:(y,C)=>{if(i<=y)throw g;l=void 0,s.pop()},onArrayBegin:(y,C)=>{if(i<=y)throw g;l=void 0,s.push(0)},onArrayEnd:(y,C)=>{if(i<=y)throw g;l=void 0,s.pop()},onLiteralValue:(y,C,A)=>{if(i<C||(D(y,C,A,o(y)),i<=C+A))throw g},onSeparator:(y,C,A)=>{if(i<=C)throw g;if(y===":"&&l&&l.type==="property")l.colonOffset=C,S=!1,l=void 0;else if(y===","){const b=s[s.length-1];typeof b=="number"?s[s.length-1]=b+1:(S=!0,s[s.length-1]=""),l=void 0}}})}catch(y){if(y!==g)throw y}return{path:s,previousNode:l,isAtPropertyKey:S,matches:y=>{let C=0;for(let A=0;C<y.length&&A<s.length;A++)if(y[C]===s[A]||y[C]==="*")C++;else if(y[C]!=="**")return!1;return C===y.length}}}function u(t,i=[],s=R.DEFAULT){let g=null,l=[];const w=[];function S(y){Array.isArray(l)?l.push(y):g!==null&&(l[g]=y)}return n(t,{onObjectBegin:()=>{const y={};S(y),w.push(l),l=y,g=null},onObjectProperty:y=>{g=y},onObjectEnd:()=>{l=w.pop()},onArrayBegin:()=>{const y=[];S(y),w.push(l),l=y,g=null},onArrayEnd:()=>{l=w.pop()},onLiteralValue:S,onError:(y,C,A)=>{i.push({error:y,offset:C,length:A})}},s),l[0]}function k(t,i=[],s=R.DEFAULT){let g={type:"array",offset:-1,length:-1,children:[],parent:void 0};function l(y){g.type==="property"&&(g.length=y-g.offset,g=g.parent)}function w(y){return g.children.push(y),y}n(t,{onObjectBegin:y=>{g=w({type:"object",offset:y,length:-1,parent:g,children:[]})},onObjectProperty:(y,C,A)=>{g=w({type:"property",offset:C,length:-1,parent:g,children:[]}),g.children.push({type:"string",value:y,offset:C,length:A,parent:g})},onObjectEnd:(y,C)=>{g.length=y+C-g.offset,g=g.parent,l(y+C)},onArrayBegin:(y,C)=>{g=w({type:"array",offset:y,length:-1,parent:g,children:[]})},onArrayEnd:(y,C)=>{g.length=y+C-g.offset,g=g.parent,l(y+C)},onLiteralValue:(y,C,A)=>{w({type:o(y),offset:C,length:A,parent:g,value:y}),l(C+A)},onSeparator:(y,C,A)=>{g.type==="property"&&(y===":"?g.colonOffset=C:y===","&&l(C))},onError:(y,C,A)=>{i.push({error:y,offset:C,length:A})}},s);const D=g.children[0];return D&&delete D.parent,D}function p(t,i){if(!t)return;let s=t;for(const g of i)if(typeof g=="string"){if(s.type!=="object"||!Array.isArray(s.children))return;let l=!1;for(const w of s.children)if(Array.isArray(w.children)&&w.children[0].value===g){s=w.children[1],l=!0;break}if(!l)return}else{const l=g;if(s.type!=="array"||l<0||!Array.isArray(s.children)||l>=s.children.length)return;s=s.children[l]}return s}function a(t){if(!t.parent||!t.parent.children)return[];const i=a(t.parent);if(t.parent.type==="property"){const s=t.parent.children[0].value;i.push(s)}else if(t.parent.type==="array"){const s=t.parent.children.indexOf(t);s!==-1&&i.push(s)}return i}function f(t){switch(t.type){case"array":return t.children.map(f);case"object":{const i=Object.create(null);for(const s of t.children){const g=s.children[1];g&&(i[s.children[0].value]=f(g))}return i}case"null":case"string":case"number":case"boolean":return t.value;default:return}}function d(t,i,s=!1){return i>=t.offset&&i<t.offset+t.length||s&&i===t.offset+t.length}function m(t,i,s=!1){if(d(t,i,s)){const g=t.children;if(Array.isArray(g))for(let l=0;l<g.length&&g[l].offset<=i;l++){const w=m(g[l],i,s);if(w)return w}return t}}function n(t,i,s=R.DEFAULT){const g=T(t,!1);function l(ee){return ee?()=>ee(g.getTokenOffset(),g.getTokenLength()):()=>!0}function w(ee){return ee?he=>ee(he,g.getTokenOffset(),g.getTokenLength()):()=>!0}const S=l(i.onObjectBegin),D=w(i.onObjectProperty),y=l(i.onObjectEnd),C=l(i.onArrayBegin),A=l(i.onArrayEnd),b=w(i.onLiteralValue),v=w(i.onSeparator),L=l(i.onComment),O=w(i.onError),M=s&&s.disallowComments,j=s&&s.allowTrailingComma;function z(){for(;;){const ee=g.scan();switch(g.getTokenError()){case r.InvalidUnicode:F(P.InvalidUnicode);break;case r.InvalidEscapeCharacter:F(P.InvalidEscapeCharacter);break;case r.UnexpectedEndOfNumber:F(P.UnexpectedEndOfNumber);break;case r.UnexpectedEndOfComment:M||F(P.UnexpectedEndOfComment);break;case r.UnexpectedEndOfString:F(P.UnexpectedEndOfString);break;case r.InvalidCharacter:F(P.InvalidCharacter);break}switch(ee){case h.LineCommentTrivia:case h.BlockCommentTrivia:M?F(P.InvalidCommentToken):L();break;case h.Unknown:F(P.InvalidSymbol);break;case h.Trivia:case h.LineBreakTrivia:break;default:return ee}}}function F(ee,he=[],ne=[]){if(O(ee),he.length+ne.length>0){let De=g.getToken();for(;De!==h.EOF;){if(he.indexOf(De)!==-1){z();break}else if(ne.indexOf(De)!==-1)break;De=z()}}}function B(ee){const he=g.getTokenValue();return ee?b(he):D(he),z(),!0}function _(){switch(g.getToken()){case h.NumericLiteral:{let ee=0;try{ee=JSON.parse(g.getTokenValue()),typeof ee!="number"&&(F(P.InvalidNumberFormat),ee=0)}catch{F(P.InvalidNumberFormat)}b(ee);break}case h.NullKeyword:b(null);break;case h.TrueKeyword:b(!0);break;case h.FalseKeyword:b(!1);break;default:return!1}return z(),!0}function re(){return g.getToken()!==h.StringLiteral?(F(P.PropertyNameExpected,[],[h.CloseBraceToken,h.CommaToken]),!1):(B(!1),g.getToken()===h.ColonToken?(v(":"),z(),Q()||F(P.ValueExpected,[],[h.CloseBraceToken,h.CommaToken])):F(P.ColonExpected,[],[h.CloseBraceToken,h.CommaToken]),!0)}function U(){S(),z();let ee=!1;for(;g.getToken()!==h.CloseBraceToken&&g.getToken()!==h.EOF;){if(g.getToken()===h.CommaToken){if(ee||F(P.ValueExpected,[],[]),v(","),z(),g.getToken()===h.CloseBraceToken&&j)break}else ee&&F(P.CommaExpected,[],[]);re()||F(P.ValueExpected,[],[h.CloseBraceToken,h.CommaToken]),ee=!0}return y(),g.getToken()!==h.CloseBraceToken?F(P.CloseBraceExpected,[h.CloseBraceToken],[]):z(),!0}function G(){C(),z();let ee=!1;for(;g.getToken()!==h.CloseBracketToken&&g.getToken()!==h.EOF;){if(g.getToken()===h.CommaToken){if(ee||F(P.ValueExpected,[],[]),v(","),z(),g.getToken()===h.CloseBracketToken&&j)break}else ee&&F(P.CommaExpected,[],[]);Q()||F(P.ValueExpected,[],[h.CloseBracketToken,h.CommaToken]),ee=!0}return A(),g.getToken()!==h.CloseBracketToken?F(P.CloseBracketExpected,[h.CloseBracketToken],[]):z(),!0}function Q(){switch(g.getToken()){case h.OpenBracketToken:return G();case h.OpenBraceToken:return U();case h.StringLiteral:return B(!0);default:return _()}}return z(),g.getToken()===h.EOF?s.allowEmptyContent?!0:(F(P.ValueExpected,[],[]),!1):Q()?(g.getToken()!==h.EOF&&F(P.EndOfFileExpected,[],[]),!0):(F(P.ValueExpected,[],[]),!1)}function o(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}}),define(Ee[49],ye([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$X=void 0;class r{constructor(P){this.d=P,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(P){this.c=P}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$X=r}),define(Ee[81],ye([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7c=void 0;class r{static{this.Undefined=new r(void 0)}constructor(R){this.element=R,this.next=r.Undefined,this.prev=r.Undefined}}class h{constructor(){this.a=r.Undefined,this.b=r.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===r.Undefined}clear(){let R=this.a;for(;R!==r.Undefined;){const T=R.next;R.prev=r.Undefined,R.next=r.Undefined,R=T}this.a=r.Undefined,this.b=r.Undefined,this.c=0}unshift(R){return this.d(R,!1)}push(R){return this.d(R,!0)}d(R,T){const N=new r(R);if(this.a===r.Undefined)this.a=N,this.b=N;else if(T){const c=this.b;this.b=N,N.prev=c,c.next=N}else{const c=this.a;this.a=N,N.next=c,c.prev=N}this.c+=1;let $=!1;return()=>{$||($=!0,this.e(N))}}shift(){if(this.a!==r.Undefined){const R=this.a.element;return this.e(this.a),R}}pop(){if(this.b!==r.Undefined){const R=this.b.element;return this.e(this.b),R}}e(R){if(R.prev!==r.Undefined&&R.next!==r.Undefined){const T=R.prev;T.next=R.next,R.next.prev=T}else R.prev===r.Undefined&&R.next===r.Undefined?(this.a=r.Undefined,this.b=r.Undefined):R.next===r.Undefined?(this.b=this.b.prev,this.b.next=r.Undefined):R.prev===r.Undefined&&(this.a=this.a.next,this.a.prev=r.Undefined);this.c-=1}*[Symbol.iterator](){let R=this.a;for(;R!==r.Undefined;)yield R.element,R=R.next}}e.$7c=h}),define(Ee[29],ye([1,0]),function(ce,e){"use strict";var r,h,P;Object.defineProperty(e,"__esModule",{value:!0}),e.$Jc=e.$Ic=e.$Hc=e.$Gc=e.$Fc=e.$Ec=e.Touch=e.$Dc=e.$Cc=void 0,e.$zc=R,e.$Ac=T,e.$Bc=N,e.$Kc=o;function R(t,i,s){let g=t.get(i);return g===void 0&&(g=s,t.set(i,g)),g}function T(t){const i=[];return t.forEach((s,g)=>{i.push(`${g} => ${s}`)}),`Map(${t.size}) {${i.join(", ")}}`}function N(t){const i=[];return t.forEach(s=>{i.push(s)}),`Set(${t.size}) {${i.join(", ")}}`}class ${constructor(i,s){this.uri=i,this.value=s}}function c(t){return Array.isArray(t)}class I{static{this.c=i=>i.toString()}constructor(i,s){if(this[r]="ResourceMap",i instanceof I)this.d=new Map(i.d),this.e=s??I.c;else if(c(i)){this.d=new Map,this.e=s??I.c;for(const[g,l]of i)this.set(g,l)}else this.d=new Map,this.e=i??I.c}set(i,s){return this.d.set(this.e(i),new $(i,s)),this}get(i){return this.d.get(this.e(i))?.value}has(i){return this.d.has(this.e(i))}get size(){return this.d.size}clear(){this.d.clear()}delete(i){return this.d.delete(this.e(i))}forEach(i,s){typeof s<"u"&&(i=i.bind(s));for(const[g,l]of this.d)i(l.value,l.uri,this)}*values(){for(const i of this.d.values())yield i.value}*keys(){for(const i of this.d.values())yield i.uri}*entries(){for(const i of this.d.values())yield[i.uri,i.value]}*[(r=Symbol.toStringTag,Symbol.iterator)](){for(const[,i]of this.d)yield[i.uri,i.value]}}e.$Cc=I;class E{constructor(i,s){this[h]="ResourceSet",!i||typeof i=="function"?this.c=new I(i):(this.c=new I(s),i.forEach(this.add,this))}get size(){return this.c.size}add(i){return this.c.set(i,i),this}clear(){this.c.clear()}delete(i){return this.c.delete(i)}forEach(i,s){this.c.forEach((g,l)=>i.call(s,l,l,this))}has(i){return this.c.has(i)}entries(){return this.c.entries()}keys(){return this.c.keys()}values(){return this.c.keys()}[(h=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$Dc=E;var u;(function(t){t[t.None=0]="None",t[t.AsOld=1]="AsOld",t[t.AsNew=2]="AsNew"})(u||(e.Touch=u={}));class k{constructor(){this[P]="LinkedMap",this.c=new Map,this.d=void 0,this.e=void 0,this.f=0,this.g=0}clear(){this.c.clear(),this.d=void 0,this.e=void 0,this.f=0,this.g++}isEmpty(){return!this.d&&!this.e}get size(){return this.f}get first(){return this.d?.value}get last(){return this.e?.value}has(i){return this.c.has(i)}get(i,s=u.None){const g=this.c.get(i);if(g)return s!==u.None&&this.m(g,s),g.value}set(i,s,g=u.None){let l=this.c.get(i);if(l)l.value=s,g!==u.None&&this.m(l,g);else{switch(l={key:i,value:s,next:void 0,previous:void 0},g){case u.None:this.k(l);break;case u.AsOld:this.j(l);break;case u.AsNew:this.k(l);break;default:this.k(l);break}this.c.set(i,l),this.f++}return this}delete(i){return!!this.remove(i)}remove(i){const s=this.c.get(i);if(s)return this.c.delete(i),this.l(s),this.f--,s.value}shift(){if(!this.d&&!this.e)return;if(!this.d||!this.e)throw new Error("Invalid list");const i=this.d;return this.c.delete(i.key),this.l(i),this.f--,i.value}forEach(i,s){const g=this.g;let l=this.d;for(;l;){if(s?i.bind(s)(l.value,l.key,this):i(l.value,l.key,this),this.g!==g)throw new Error("LinkedMap got modified during iteration.");l=l.next}}keys(){const i=this,s=this.g;let g=this.d;const l={[Symbol.iterator](){return l},next(){if(i.g!==s)throw new Error("LinkedMap got modified during iteration.");if(g){const w={value:g.key,done:!1};return g=g.next,w}else return{value:void 0,done:!0}}};return l}values(){const i=this,s=this.g;let g=this.d;const l={[Symbol.iterator](){return l},next(){if(i.g!==s)throw new Error("LinkedMap got modified during iteration.");if(g){const w={value:g.value,done:!1};return g=g.next,w}else return{value:void 0,done:!0}}};return l}entries(){const i=this,s=this.g;let g=this.d;const l={[Symbol.iterator](){return l},next(){if(i.g!==s)throw new Error("LinkedMap got modified during iteration.");if(g){const w={value:[g.key,g.value],done:!1};return g=g.next,w}else return{value:void 0,done:!0}}};return l}[(P=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}h(i){if(i>=this.size)return;if(i===0){this.clear();return}let s=this.d,g=this.size;for(;s&&g>i;)this.c.delete(s.key),s=s.next,g--;this.d=s,this.f=g,s&&(s.previous=void 0),this.g++}i(i){if(i>=this.size)return;if(i===0){this.clear();return}let s=this.e,g=this.size;for(;s&&g>i;)this.c.delete(s.key),s=s.previous,g--;this.e=s,this.f=g,s&&(s.next=void 0),this.g++}j(i){if(!this.d&&!this.e)this.e=i;else if(this.d)i.next=this.d,this.d.previous=i;else throw new Error("Invalid list");this.d=i,this.g++}k(i){if(!this.d&&!this.e)this.d=i;else if(this.e)i.previous=this.e,this.e.next=i;else throw new Error("Invalid list");this.e=i,this.g++}l(i){if(i===this.d&&i===this.e)this.d=void 0,this.e=void 0;else if(i===this.d){if(!i.next)throw new Error("Invalid list");i.next.previous=void 0,this.d=i.next}else if(i===this.e){if(!i.previous)throw new Error("Invalid list");i.previous.next=void 0,this.e=i.previous}else{const s=i.next,g=i.previous;if(!s||!g)throw new Error("Invalid list");s.previous=g,g.next=s}i.next=void 0,i.previous=void 0,this.g++}m(i,s){if(!this.d||!this.e)throw new Error("Invalid list");if(!(s!==u.AsOld&&s!==u.AsNew)){if(s===u.AsOld){if(i===this.d)return;const g=i.next,l=i.previous;i===this.e?(l.next=void 0,this.e=l):(g.previous=l,l.next=g),i.previous=void 0,i.next=this.d,this.d.previous=i,this.d=i,this.g++}else if(s===u.AsNew){if(i===this.e)return;const g=i.next,l=i.previous;i===this.d?(g.previous=void 0,this.d=g):(g.previous=l,l.next=g),i.next=void 0,i.previous=this.e,this.e.next=i,this.e=i,this.g++}}}toJSON(){const i=[];return this.forEach((s,g)=>{i.push([g,s])}),i}fromJSON(i){this.clear();for(const[s,g]of i)this.set(s,g)}}e.$Ec=k;class p extends k{constructor(i,s=1){super(),this.n=i,this.o=Math.min(Math.max(0,s),1)}get limit(){return this.n}set limit(i){this.n=i,this.p()}get ratio(){return this.o}set ratio(i){this.o=Math.min(Math.max(0,i),1),this.p()}get(i,s=u.AsNew){return super.get(i,s)}peek(i){return super.get(i,u.None)}set(i,s){return super.set(i,s,u.AsNew),this}p(){this.size>this.n&&this.q(Math.round(this.n*this.o))}}class a extends p{constructor(i,s=1){super(i,s)}q(i){this.h(i)}set(i,s){return super.set(i,s),this.p(),this}}e.$Fc=a;class f extends p{constructor(i,s=1){super(i,s)}q(i){this.i(i)}set(i,s){return this.n<=this.size&&!this.has(i)&&this.q(Math.round(this.n*this.o)-1),super.set(i,s),this}}e.$Gc=f;class d{constructor(){this.c=new Map}add(i){return this.c.set(i,(this.c.get(i)||0)+1),this}delete(i){let s=this.c.get(i)||0;return s===0?!1:(s--,s===0?this.c.delete(i):this.c.set(i,s),!0)}has(i){return this.c.has(i)}}e.$Hc=d;class m{constructor(i){if(this.c=new Map,this.d=new Map,i)for(const[s,g]of i)this.set(s,g)}clear(){this.c.clear(),this.d.clear()}set(i,s){this.c.set(i,s),this.d.set(s,i)}get(i){return this.c.get(i)}getKey(i){return this.d.get(i)}delete(i){const s=this.c.get(i);return s===void 0?!1:(this.c.delete(i),this.d.delete(s),!0)}forEach(i,s){this.c.forEach((g,l)=>{i.call(s,g,l,this)})}keys(){return this.c.keys()}values(){return this.c.values()}}e.$Ic=m;class n{constructor(){this.c=new Map}add(i,s){let g=this.c.get(i);g||(g=new Set,this.c.set(i,g)),g.add(s)}delete(i,s){const g=this.c.get(i);g&&(g.delete(s),g.size===0&&this.c.delete(i))}forEach(i,s){const g=this.c.get(i);g&&g.forEach(s)}get(i){const s=this.c.get(i);return s||new Set}}e.$Jc=n;function o(t,i){if(t===i)return!0;if(t.size!==i.size)return!1;for(const[s,g]of t)if(!i.has(s)||i.get(s)!==g)return!1;for(const[s]of i)if(!t.has(s))return!1;return!0}}),define(Ee[3],ye([1,0,19,79,29,80,40]),function(ce,e,r,h,P,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6c=e.$4c=e.$3c=e.$2c=e.$1c=e.$Zc=e.$Yc=e.$Xc=e.$Wc=e.$Vc=e.$Lc=void 0,e.$Mc=I,e.$Nc=E,e.$Oc=u,e.$Pc=a,e.$Qc=f,e.$Rc=d,e.$Sc=m,e.$Tc=n,e.$Uc=o,e.$5c=C;const N=!1;let $=null;class c{constructor(){this.b=new Map}static{this.a=0}c(v){let L=this.b.get(v);return L||(L={parent:null,source:null,isSingleton:!1,value:v,idx:c.a++},this.b.set(v,L)),L}trackDisposable(v){const L=this.c(v);L.source||(L.source=new Error().stack)}setParent(v,L){const O=this.c(v);O.parent=L}markAsDisposed(v){this.b.delete(v)}markAsSingleton(v){this.c(v).isSingleton=!0}f(v,L){const O=L.get(v);if(O)return O;const M=v.parent?this.f(this.c(v.parent),L):v;return L.set(v,M),M}getTrackedDisposables(){const v=new Map;return[...this.b.entries()].filter(([,O])=>O.source!==null&&!this.f(O,v).isSingleton).flatMap(([O])=>O)}computeLeakingDisposables(v=10,L){let O;if(L)O=L;else{const B=new Map,_=[...this.b.values()].filter(U=>U.source!==null&&!this.f(U,B).isSingleton);if(_.length===0)return;const re=new Set(_.map(U=>U.value));if(O=_.filter(U=>!(U.parent&&re.has(U.parent))),O.length===0)throw new Error("There are cyclic diposable chains!")}if(!O)return;function M(B){function _(U,G){for(;U.length>0&&G.some(Q=>typeof Q=="string"?Q===U[0]:U[0].match(Q));)U.shift()}const re=B.source.split(`
`).map(U=>U.trim().replace("at ","")).filter(U=>U!=="");return _(re,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),re.reverse()}const j=new P.$Jc;for(const B of O){const _=M(B);for(let re=0;re<=_.length;re++)j.add(_.slice(0,re).join(`
`),B)}O.sort((0,r.$8b)(B=>B.idx,r.$0b));let z="",F=0;for(const B of O.slice(0,v)){F++;const _=M(B),re=[];for(let U=0;U<_.length;U++){let G=_[U];G=`(shared with ${j.get(_.slice(0,U+1).join(`
`)).size}/${O.length} leaks) at ${G}`;const ee=j.get(_.slice(0,U).join(`
`)),he=(0,h.$K)([...ee].map(ne=>M(ne)[U]),ne=>ne);delete he[_[U]];for(const[ne,De]of Object.entries(he))re.unshift(`    - stacktraces of ${De.length} other leaks continue with ${ne}`);re.unshift(G)}z+=`


==================== Leaking disposable ${F}/${O.length}: ${B.value.constructor.name} ====================
${re.join(`
`)}
============================================================

`}return O.length>v&&(z+=`


... and ${O.length-v} more leaking disposables

`),{leaks:O,details:z}}}e.$Lc=c;function I(b){$=b}if(N){const b="__is_disposable_tracked__";I(new class{trackDisposable(v){const L=new Error("Potentially leaked disposable").stack;setTimeout(()=>{v[b]||console.log(L)},3e3)}setParent(v,L){if(v&&v!==i.None)try{v[b]=!0}catch{}}markAsDisposed(v){if(v&&v!==i.None)try{v[b]=!0}catch{}}markAsSingleton(v){}})}function E(b){return $?.trackDisposable(b),b}function u(b){$?.markAsDisposed(b)}function k(b,v){$?.setParent(b,v)}function p(b,v){if($)for(const L of b)$.setParent(L,v)}function a(b){return $?.markAsSingleton(b),b}function f(b){return typeof b=="object"&&b!==null&&typeof b.dispose=="function"&&b.dispose.length===0}function d(b){if(T.Iterable.is(b)){const v=[];for(const L of b)if(L)try{L.dispose()}catch(O){v.push(O)}if(v.length===1)throw v[0];if(v.length>1)throw new AggregateError(v,"Encountered errors while disposing of store");return Array.isArray(b)?[]:b}else if(b)return b.dispose(),b}function m(b){for(const v of b)f(v)&&v.dispose();return[]}function n(...b){const v=o(()=>d(b));return p(b,v),v}function o(b){const v=E({dispose:(0,R.$fb)(()=>{u(v),b()})});return v}class t{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,E(this)}dispose(){this.g||(u(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{d(this.f)}finally{this.f.clear()}}add(v){if(!v)return v;if(v===this)throw new Error("Cannot register a disposable on itself!");return k(v,this),this.g?t.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(v),v}delete(v){if(v){if(v===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(v),v.dispose()}}deleteAndLeak(v){v&&this.f.has(v)&&(this.f.delete(v),k(v,null))}}e.$Vc=t;class i{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new t,E(this),k(this.q,this)}dispose(){u(this),this.q.dispose()}B(v){if(v===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(v)}}e.$Wc=i;class s{constructor(){this.b=!1,E(this)}get value(){return this.b?void 0:this.a}set value(v){this.b||v===this.a||(this.a?.dispose(),v&&k(v,this),this.a=v)}clear(){this.value=void 0}dispose(){this.b=!0,u(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const v=this.a;return this.a=void 0,v&&k(v,null),v}}e.$Xc=s;class g{constructor(v){this.a=new s,this.b=!1,this.a.value=v}get value(){return this.a.value}set value(v){this.b||v===this.a.value||(this.a.value=v)}dispose(){this.b=!0,this.a.dispose()}}e.$Yc=g;class l{constructor(v){this.b=v,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$Zc=l;class w{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,E(this)}set(v){let L=v;return this.unset=()=>L=void 0,this.isset=()=>L!==void 0,this.dispose=()=>{L&&(L(),L=void 0,u(this))},this}}e.$1c=w;class S{constructor(){this.a=new Map}acquire(v,...L){let O=this.a.get(v);O||(O={counter:0,object:this.b(v,...L)},this.a.set(v,O));const{object:M}=O,j=(0,R.$fb)(()=>{--O.counter===0&&(this.c(v,O.object),this.a.delete(v))});return O.counter++,{object:M,dispose:j}}}e.$2c=S;class D{constructor(v){this.a=v}async acquire(v,...L){const O=this.a.acquire(v,...L);try{return{object:await O.object,dispose:()=>O.dispose()}}catch(M){throw O.dispose(),M}}}e.$3c=D;class y{constructor(v){this.object=v}dispose(){}}e.$4c=y;function C(b){const v=new t;try{b(v)}finally{v.dispose()}}class A{constructor(){this.a=new Map,this.b=!1,E(this)}dispose(){u(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{d(this.a.values())}finally{this.a.clear()}}has(v){return this.a.has(v)}get size(){return this.a.size}get(v){return this.a.get(v)}set(v,L,O=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),O||this.a.get(v)?.dispose(),this.a.set(v,L)}deleteAndDispose(v){this.a.get(v)?.dispose(),this.a.delete(v)}deleteAndLeak(v){const L=this.a.get(v);return this.a.delete(v),L}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$6c=A}),function(ce,e){typeof define=="function"&&define.amd?define(Ee[176],ye([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(ce=typeof globalThis<"u"?globalThis:ce||self,e(ce.marked={}))}(this,function(ce){"use strict";function e(te,le){for(var ue=0;ue<le.length;ue++){var X=le[ue];X.enumerable=X.enumerable||!1,X.configurable=!0,"value"in X&&(X.writable=!0),Object.defineProperty(te,X.key,X)}}function r(te,le,ue){return le&&e(te.prototype,le),ue&&e(te,ue),Object.defineProperty(te,"prototype",{writable:!1}),te}function h(te,le){if(te){if(typeof te=="string")return P(te,le);var ue=Object.prototype.toString.call(te).slice(8,-1);if(ue==="Object"&&te.constructor&&(ue=te.constructor.name),ue==="Map"||ue==="Set")return Array.from(te);if(ue==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(ue))return P(te,le)}}function P(te,le){(le==null||le>te.length)&&(le=te.length);for(var ue=0,X=new Array(le);ue<le;ue++)X[ue]=te[ue];return X}function R(te,le){var ue=typeof Symbol<"u"&&te[Symbol.iterator]||te["@@iterator"];if(ue)return(ue=ue.call(te)).next.bind(ue);if(Array.isArray(te)||(ue=h(te))||le&&te&&typeof te.length=="number"){ue&&(te=ue);var X=0;return function(){return X>=te.length?{done:!0}:{done:!1,value:te[X++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function T(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}ce.defaults=T();function N(te){ce.defaults=te}var $=/[&<>"']/,c=/[&<>"']/g,I=/[<>"']|&(?!#?\w+;)/,E=/[<>"']|&(?!#?\w+;)/g,u={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},k=function(le){return u[le]};function p(te,le){if(le){if($.test(te))return te.replace(c,k)}else if(I.test(te))return te.replace(E,k);return te}var a=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function f(te){return te.replace(a,function(le,ue){return ue=ue.toLowerCase(),ue==="colon"?":":ue.charAt(0)==="#"?ue.charAt(1)==="x"?String.fromCharCode(parseInt(ue.substring(2),16)):String.fromCharCode(+ue.substring(1)):""})}var d=/(^|[^\[])\^/g;function m(te,le){te=typeof te=="string"?te:te.source,le=le||"";var ue={replace:function(ae,pe){return pe=pe.source||pe,pe=pe.replace(d,"$1"),te=te.replace(ae,pe),ue},getRegex:function(){return new RegExp(te,le)}};return ue}var n=/[^\w:]/g,o=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function t(te,le,ue){if(te){var X;try{X=decodeURIComponent(f(ue)).replace(n,"").toLowerCase()}catch{return null}if(X.indexOf("javascript:")===0||X.indexOf("vbscript:")===0||X.indexOf("data:")===0)return null}le&&!o.test(ue)&&(ue=w(le,ue));try{ue=encodeURI(ue).replace(/%25/g,"%")}catch{return null}return ue}var i={},s=/^[^:]+:\/*[^/]*$/,g=/^([^:]+:)[\s\S]*$/,l=/^([^:]+:\/*[^/]*)[\s\S]*$/;function w(te,le){i[" "+te]||(s.test(te)?i[" "+te]=te+"/":i[" "+te]=C(te,"/",!0)),te=i[" "+te];var ue=te.indexOf(":")===-1;return le.substring(0,2)==="//"?ue?le:te.replace(g,"$1")+le:le.charAt(0)==="/"?ue?le:te.replace(l,"$1")+le:te+le}var S={exec:function(){}};function D(te){for(var le=1,ue,X;le<arguments.length;le++){ue=arguments[le];for(X in ue)Object.prototype.hasOwnProperty.call(ue,X)&&(te[X]=ue[X])}return te}function y(te,le){var ue=te.replace(/\|/g,function(pe,be,Fe){for(var Ue=!1,ke=be;--ke>=0&&Fe[ke]==="\\";)Ue=!Ue;return Ue?"|":" |"}),X=ue.split(/ \|/),ae=0;if(X[0].trim()||X.shift(),X.length>0&&!X[X.length-1].trim()&&X.pop(),X.length>le)X.splice(le);else for(;X.length<le;)X.push("");for(;ae<X.length;ae++)X[ae]=X[ae].trim().replace(/\\\|/g,"|");return X}function C(te,le,ue){var X=te.length;if(X===0)return"";for(var ae=0;ae<X;){var pe=te.charAt(X-ae-1);if(pe===le&&!ue)ae++;else if(pe!==le&&ue)ae++;else break}return te.slice(0,X-ae)}function A(te,le){if(te.indexOf(le[1])===-1)return-1;for(var ue=te.length,X=0,ae=0;ae<ue;ae++)if(te[ae]==="\\")ae++;else if(te[ae]===le[0])X++;else if(te[ae]===le[1]&&(X--,X<0))return ae;return-1}function b(te){te&&te.sanitize&&!te.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function v(te,le){if(le<1)return"";for(var ue="";le>1;)le&1&&(ue+=te),le>>=1,te+=te;return ue+te}function L(te,le,ue,X){var ae=le.href,pe=le.title?p(le.title):null,be=te[1].replace(/\\([\[\]])/g,"$1");if(te[0].charAt(0)!=="!"){X.state.inLink=!0;var Fe={type:"link",raw:ue,href:ae,title:pe,text:be,tokens:X.inlineTokens(be)};return X.state.inLink=!1,Fe}return{type:"image",raw:ue,href:ae,title:pe,text:p(be)}}function O(te,le){var ue=te.match(/^(\s+)(?:```)/);if(ue===null)return le;var X=ue[1];return le.split(`
`).map(function(ae){var pe=ae.match(/^\s+/);if(pe===null)return ae;var be=pe[0];return be.length>=X.length?ae.slice(X.length):ae}).join(`
`)}var M=function(){function te(ue){this.options=ue||ce.defaults}var le=te.prototype;return le.space=function(X){var ae=this.rules.block.newline.exec(X);if(ae&&ae[0].length>0)return{type:"space",raw:ae[0]}},le.code=function(X){var ae=this.rules.block.code.exec(X);if(ae){var pe=ae[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:ae[0],codeBlockStyle:"indented",text:this.options.pedantic?pe:C(pe,`
`)}}},le.fences=function(X){var ae=this.rules.block.fences.exec(X);if(ae){var pe=ae[0],be=O(pe,ae[3]||"");return{type:"code",raw:pe,lang:ae[2]?ae[2].trim():ae[2],text:be}}},le.heading=function(X){var ae=this.rules.block.heading.exec(X);if(ae){var pe=ae[2].trim();if(/#$/.test(pe)){var be=C(pe,"#");(this.options.pedantic||!be||/ $/.test(be))&&(pe=be.trim())}return{type:"heading",raw:ae[0],depth:ae[1].length,text:pe,tokens:this.lexer.inline(pe)}}},le.hr=function(X){var ae=this.rules.block.hr.exec(X);if(ae)return{type:"hr",raw:ae[0]}},le.blockquote=function(X){var ae=this.rules.block.blockquote.exec(X);if(ae){var pe=ae[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:ae[0],tokens:this.lexer.blockTokens(pe,[]),text:pe}}},le.list=function(X){var ae=this.rules.block.list.exec(X);if(ae){var pe,be,Fe,Ue,ke,Ie,Re,q,V,J,x,fe,we=ae[1].trim(),Le=we.length>1,He={type:"list",raw:"",ordered:Le,start:Le?+we.slice(0,-1):"",loose:!1,items:[]};we=Le?"\\d{1,9}\\"+we.slice(-1):"\\"+we,this.options.pedantic&&(we=Le?we:"[*+-]");for(var Ke=new RegExp("^( {0,3}"+we+")((?:[	 ][^\\n]*)?(?:\\n|$))");X&&(fe=!1,!(!(ae=Ke.exec(X))||this.rules.block.hr.test(X)));){if(pe=ae[0],X=X.substring(pe.length),q=ae[2].split(`
`,1)[0],V=X.split(`
`,1)[0],this.options.pedantic?(Ue=2,x=q.trimLeft()):(Ue=ae[2].search(/[^ ]/),Ue=Ue>4?1:Ue,x=q.slice(Ue),Ue+=ae[1].length),Ie=!1,!q&&/^ *$/.test(V)&&(pe+=V+`
`,X=X.substring(V.length+1),fe=!0),!fe)for(var et=new RegExp("^ {0,"+Math.min(3,Ue-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),rt=new RegExp("^ {0,"+Math.min(3,Ue-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),ot=new RegExp("^ {0,"+Math.min(3,Ue-1)+"}(?:```|~~~)"),nt=new RegExp("^ {0,"+Math.min(3,Ue-1)+"}#");X&&(J=X.split(`
`,1)[0],q=J,this.options.pedantic&&(q=q.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(ot.test(q)||nt.test(q)||et.test(q)||rt.test(X)));){if(q.search(/[^ ]/)>=Ue||!q.trim())x+=`
`+q.slice(Ue);else if(!Ie)x+=`
`+q;else break;!Ie&&!q.trim()&&(Ie=!0),pe+=J+`
`,X=X.substring(J.length+1)}He.loose||(Re?He.loose=!0:/\n *\n *$/.test(pe)&&(Re=!0)),this.options.gfm&&(be=/^\[[ xX]\] /.exec(x),be&&(Fe=be[0]!=="[ ] ",x=x.replace(/^\[[ xX]\] +/,""))),He.items.push({type:"list_item",raw:pe,task:!!be,checked:Fe,loose:!1,text:x}),He.raw+=pe}He.items[He.items.length-1].raw=pe.trimRight(),He.items[He.items.length-1].text=x.trimRight(),He.raw=He.raw.trimRight();var ct=He.items.length;for(ke=0;ke<ct;ke++){this.lexer.state.top=!1,He.items[ke].tokens=this.lexer.blockTokens(He.items[ke].text,[]);var mt=He.items[ke].tokens.filter(function(at){return at.type==="space"}),dt=mt.every(function(at){for(var Pe=at.raw.split(""),ze=0,Ze=R(Pe),Te;!(Te=Ze()).done;){var Me=Te.value;if(Me===`
`&&(ze+=1),ze>1)return!0}return!1});!He.loose&&mt.length&&dt&&(He.loose=!0,He.items[ke].loose=!0)}return He}},le.html=function(X){var ae=this.rules.block.html.exec(X);if(ae){var pe={type:"html",raw:ae[0],pre:!this.options.sanitizer&&(ae[1]==="pre"||ae[1]==="script"||ae[1]==="style"),text:ae[0]};if(this.options.sanitize){var be=this.options.sanitizer?this.options.sanitizer(ae[0]):p(ae[0]);pe.type="paragraph",pe.text=be,pe.tokens=this.lexer.inline(be)}return pe}},le.def=function(X){var ae=this.rules.block.def.exec(X);if(ae){ae[3]&&(ae[3]=ae[3].substring(1,ae[3].length-1));var pe=ae[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:pe,raw:ae[0],href:ae[2],title:ae[3]}}},le.table=function(X){var ae=this.rules.block.table.exec(X);if(ae){var pe={type:"table",header:y(ae[1]).map(function(Re){return{text:Re}}),align:ae[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:ae[3]&&ae[3].trim()?ae[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(pe.header.length===pe.align.length){pe.raw=ae[0];var be=pe.align.length,Fe,Ue,ke,Ie;for(Fe=0;Fe<be;Fe++)/^ *-+: *$/.test(pe.align[Fe])?pe.align[Fe]="right":/^ *:-+: *$/.test(pe.align[Fe])?pe.align[Fe]="center":/^ *:-+ *$/.test(pe.align[Fe])?pe.align[Fe]="left":pe.align[Fe]=null;for(be=pe.rows.length,Fe=0;Fe<be;Fe++)pe.rows[Fe]=y(pe.rows[Fe],pe.header.length).map(function(Re){return{text:Re}});for(be=pe.header.length,Ue=0;Ue<be;Ue++)pe.header[Ue].tokens=this.lexer.inline(pe.header[Ue].text);for(be=pe.rows.length,Ue=0;Ue<be;Ue++)for(Ie=pe.rows[Ue],ke=0;ke<Ie.length;ke++)Ie[ke].tokens=this.lexer.inline(Ie[ke].text);return pe}}},le.lheading=function(X){var ae=this.rules.block.lheading.exec(X);if(ae)return{type:"heading",raw:ae[0],depth:ae[2].charAt(0)==="="?1:2,text:ae[1],tokens:this.lexer.inline(ae[1])}},le.paragraph=function(X){var ae=this.rules.block.paragraph.exec(X);if(ae){var pe=ae[1].charAt(ae[1].length-1)===`
`?ae[1].slice(0,-1):ae[1];return{type:"paragraph",raw:ae[0],text:pe,tokens:this.lexer.inline(pe)}}},le.text=function(X){var ae=this.rules.block.text.exec(X);if(ae)return{type:"text",raw:ae[0],text:ae[0],tokens:this.lexer.inline(ae[0])}},le.escape=function(X){var ae=this.rules.inline.escape.exec(X);if(ae)return{type:"escape",raw:ae[0],text:p(ae[1])}},le.tag=function(X){var ae=this.rules.inline.tag.exec(X);if(ae)return!this.lexer.state.inLink&&/^<a /i.test(ae[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(ae[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(ae[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(ae[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:ae[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ae[0]):p(ae[0]):ae[0]}},le.link=function(X){var ae=this.rules.inline.link.exec(X);if(ae){var pe=ae[2].trim();if(!this.options.pedantic&&/^</.test(pe)){if(!/>$/.test(pe))return;var be=C(pe.slice(0,-1),"\\");if((pe.length-be.length)%2===0)return}else{var Fe=A(ae[2],"()");if(Fe>-1){var Ue=ae[0].indexOf("!")===0?5:4,ke=Ue+ae[1].length+Fe;ae[2]=ae[2].substring(0,Fe),ae[0]=ae[0].substring(0,ke).trim(),ae[3]=""}}var Ie=ae[2],Re="";if(this.options.pedantic){var q=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Ie);q&&(Ie=q[1],Re=q[3])}else Re=ae[3]?ae[3].slice(1,-1):"";return Ie=Ie.trim(),/^</.test(Ie)&&(this.options.pedantic&&!/>$/.test(pe)?Ie=Ie.slice(1):Ie=Ie.slice(1,-1)),L(ae,{href:Ie&&Ie.replace(this.rules.inline._escapes,"$1"),title:Re&&Re.replace(this.rules.inline._escapes,"$1")},ae[0],this.lexer)}},le.reflink=function(X,ae){var pe;if((pe=this.rules.inline.reflink.exec(X))||(pe=this.rules.inline.nolink.exec(X))){var be=(pe[2]||pe[1]).replace(/\s+/g," ");if(be=ae[be.toLowerCase()],!be||!be.href){var Fe=pe[0].charAt(0);return{type:"text",raw:Fe,text:Fe}}return L(pe,be,pe[0],this.lexer)}},le.emStrong=function(X,ae,pe){pe===void 0&&(pe="");var be=this.rules.inline.emStrong.lDelim.exec(X);if(be&&!(be[3]&&pe.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var Fe=be[1]||be[2]||"";if(!Fe||Fe&&(pe===""||this.rules.inline.punctuation.exec(pe))){var Ue=be[0].length-1,ke,Ie,Re=Ue,q=0,V=be[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(V.lastIndex=0,ae=ae.slice(-1*X.length+Ue);(be=V.exec(ae))!=null;)if(ke=be[1]||be[2]||be[3]||be[4]||be[5]||be[6],!!ke){if(Ie=ke.length,be[3]||be[4]){Re+=Ie;continue}else if((be[5]||be[6])&&Ue%3&&!((Ue+Ie)%3)){q+=Ie;continue}if(Re-=Ie,!(Re>0)){if(Ie=Math.min(Ie,Ie+Re+q),Math.min(Ue,Ie)%2){var J=X.slice(1,Ue+be.index+Ie);return{type:"em",raw:X.slice(0,Ue+be.index+Ie+1),text:J,tokens:this.lexer.inlineTokens(J)}}var x=X.slice(2,Ue+be.index+Ie-1);return{type:"strong",raw:X.slice(0,Ue+be.index+Ie+1),text:x,tokens:this.lexer.inlineTokens(x)}}}}}},le.codespan=function(X){var ae=this.rules.inline.code.exec(X);if(ae){var pe=ae[2].replace(/\n/g," "),be=/[^ ]/.test(pe),Fe=/^ /.test(pe)&&/ $/.test(pe);return be&&Fe&&(pe=pe.substring(1,pe.length-1)),pe=p(pe,!0),{type:"codespan",raw:ae[0],text:pe}}},le.br=function(X){var ae=this.rules.inline.br.exec(X);if(ae)return{type:"br",raw:ae[0]}},le.del=function(X){var ae=this.rules.inline.del.exec(X);if(ae)return{type:"del",raw:ae[0],text:ae[2],tokens:this.lexer.inlineTokens(ae[2])}},le.autolink=function(X,ae){var pe=this.rules.inline.autolink.exec(X);if(pe){var be,Fe;return pe[2]==="@"?(be=p(this.options.mangle?ae(pe[1]):pe[1]),Fe="mailto:"+be):(be=p(pe[1]),Fe=be),{type:"link",raw:pe[0],text:be,href:Fe,tokens:[{type:"text",raw:be,text:be}]}}},le.url=function(X,ae){var pe;if(pe=this.rules.inline.url.exec(X)){var be,Fe;if(pe[2]==="@")be=p(this.options.mangle?ae(pe[0]):pe[0]),Fe="mailto:"+be;else{var Ue;do Ue=pe[0],pe[0]=this.rules.inline._backpedal.exec(pe[0])[0];while(Ue!==pe[0]);be=p(pe[0]),pe[1]==="www."?Fe="http://"+be:Fe=be}return{type:"link",raw:pe[0],text:be,href:Fe,tokens:[{type:"text",raw:be,text:be}]}}},le.inlineText=function(X,ae){var pe=this.rules.inline.text.exec(X);if(pe){var be;return this.lexer.state.inRawBlock?be=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(pe[0]):p(pe[0]):pe[0]:be=p(this.options.smartypants?ae(pe[0]):pe[0]),{type:"text",raw:pe[0],text:be}}},te}(),j={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:S,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};j._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,j._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,j.def=m(j.def).replace("label",j._label).replace("title",j._title).getRegex(),j.bullet=/(?:[*+-]|\d{1,9}[.)])/,j.listItemStart=m(/^( *)(bull) */).replace("bull",j.bullet).getRegex(),j.list=m(j.list).replace(/bull/g,j.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+j.def.source+")").getRegex(),j._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",j._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,j.html=m(j.html,"i").replace("comment",j._comment).replace("tag",j._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),j.paragraph=m(j._paragraph).replace("hr",j.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",j._tag).getRegex(),j.blockquote=m(j.blockquote).replace("paragraph",j.paragraph).getRegex(),j.normal=D({},j),j.gfm=D({},j.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),j.gfm.table=m(j.gfm.table).replace("hr",j.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",j._tag).getRegex(),j.gfm.paragraph=m(j._paragraph).replace("hr",j.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",j.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",j._tag).getRegex(),j.pedantic=D({},j.normal,{html:m(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",j._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:S,paragraph:m(j.normal._paragraph).replace("hr",j.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",j.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var z={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:S,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:S,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};z._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",z.punctuation=m(z.punctuation).replace(/punctuation/g,z._punctuation).getRegex(),z.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,z.escapedEmSt=/\\\*|\\_/g,z._comment=m(j._comment).replace("(?:-->|$)","-->").getRegex(),z.emStrong.lDelim=m(z.emStrong.lDelim).replace(/punct/g,z._punctuation).getRegex(),z.emStrong.rDelimAst=m(z.emStrong.rDelimAst,"g").replace(/punct/g,z._punctuation).getRegex(),z.emStrong.rDelimUnd=m(z.emStrong.rDelimUnd,"g").replace(/punct/g,z._punctuation).getRegex(),z._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,z._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,z._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,z.autolink=m(z.autolink).replace("scheme",z._scheme).replace("email",z._email).getRegex(),z._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,z.tag=m(z.tag).replace("comment",z._comment).replace("attribute",z._attribute).getRegex(),z._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,z._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,z._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,z.link=m(z.link).replace("label",z._label).replace("href",z._href).replace("title",z._title).getRegex(),z.reflink=m(z.reflink).replace("label",z._label).replace("ref",j._label).getRegex(),z.nolink=m(z.nolink).replace("ref",j._label).getRegex(),z.reflinkSearch=m(z.reflinkSearch,"g").replace("reflink",z.reflink).replace("nolink",z.nolink).getRegex(),z.normal=D({},z),z.pedantic=D({},z.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:m(/^!?\[(label)\]\((.*?)\)/).replace("label",z._label).getRegex(),reflink:m(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",z._label).getRegex()}),z.gfm=D({},z.normal,{escape:m(z.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),z.gfm.url=m(z.gfm.url,"i").replace("email",z.gfm._extended_email).getRegex(),z.breaks=D({},z.gfm,{br:m(z.br).replace("{2,}","*").getRegex(),text:m(z.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function F(te){return te.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function B(te){var le="",ue,X,ae=te.length;for(ue=0;ue<ae;ue++)X=te.charCodeAt(ue),Math.random()>.5&&(X="x"+X.toString(16)),le+="&#"+X+";";return le}var _=function(){function te(ue){this.tokens=[],this.tokens.links=Object.create(null),this.options=ue||ce.defaults,this.options.tokenizer=this.options.tokenizer||new M,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var X={block:j.normal,inline:z.normal};this.options.pedantic?(X.block=j.pedantic,X.inline=z.pedantic):this.options.gfm&&(X.block=j.gfm,this.options.breaks?X.inline=z.breaks:X.inline=z.gfm),this.tokenizer.rules=X}te.lex=function(X,ae){var pe=new te(ae);return pe.lex(X)},te.lexInline=function(X,ae){var pe=new te(ae);return pe.inlineTokens(X)};var le=te.prototype;return le.lex=function(X){X=X.replace(/\r\n|\r/g,`
`),this.blockTokens(X,this.tokens);for(var ae;ae=this.inlineQueue.shift();)this.inlineTokens(ae.src,ae.tokens);return this.tokens},le.blockTokens=function(X,ae){var pe=this;ae===void 0&&(ae=[]),this.options.pedantic?X=X.replace(/\t/g,"    ").replace(/^ +$/gm,""):X=X.replace(/^( *)(\t+)/gm,function(Re,q,V){return q+"    ".repeat(V.length)});for(var be,Fe,Ue,ke;X;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(Re){return(be=Re.call({lexer:pe},X,ae))?(X=X.substring(be.raw.length),ae.push(be),!0):!1}))){if(be=this.tokenizer.space(X)){X=X.substring(be.raw.length),be.raw.length===1&&ae.length>0?ae[ae.length-1].raw+=`
`:ae.push(be);continue}if(be=this.tokenizer.code(X)){X=X.substring(be.raw.length),Fe=ae[ae.length-1],Fe&&(Fe.type==="paragraph"||Fe.type==="text")?(Fe.raw+=`
`+be.raw,Fe.text+=`
`+be.text,this.inlineQueue[this.inlineQueue.length-1].src=Fe.text):ae.push(be);continue}if(be=this.tokenizer.fences(X)){X=X.substring(be.raw.length),ae.push(be);continue}if(be=this.tokenizer.heading(X)){X=X.substring(be.raw.length),ae.push(be);continue}if(be=this.tokenizer.hr(X)){X=X.substring(be.raw.length),ae.push(be);continue}if(be=this.tokenizer.blockquote(X)){X=X.substring(be.raw.length),ae.push(be);continue}if(be=this.tokenizer.list(X)){X=X.substring(be.raw.length),ae.push(be);continue}if(be=this.tokenizer.html(X)){X=X.substring(be.raw.length),ae.push(be);continue}if(be=this.tokenizer.def(X)){X=X.substring(be.raw.length),Fe=ae[ae.length-1],Fe&&(Fe.type==="paragraph"||Fe.type==="text")?(Fe.raw+=`
`+be.raw,Fe.text+=`
`+be.raw,this.inlineQueue[this.inlineQueue.length-1].src=Fe.text):this.tokens.links[be.tag]||(this.tokens.links[be.tag]={href:be.href,title:be.title});continue}if(be=this.tokenizer.table(X)){X=X.substring(be.raw.length),ae.push(be);continue}if(be=this.tokenizer.lheading(X)){X=X.substring(be.raw.length),ae.push(be);continue}if(Ue=X,this.options.extensions&&this.options.extensions.startBlock&&function(){var Re=1/0,q=X.slice(1),V=void 0;pe.options.extensions.startBlock.forEach(function(J){V=J.call({lexer:this},q),typeof V=="number"&&V>=0&&(Re=Math.min(Re,V))}),Re<1/0&&Re>=0&&(Ue=X.substring(0,Re+1))}(),this.state.top&&(be=this.tokenizer.paragraph(Ue))){Fe=ae[ae.length-1],ke&&Fe.type==="paragraph"?(Fe.raw+=`
`+be.raw,Fe.text+=`
`+be.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Fe.text):ae.push(be),ke=Ue.length!==X.length,X=X.substring(be.raw.length);continue}if(be=this.tokenizer.text(X)){X=X.substring(be.raw.length),Fe=ae[ae.length-1],Fe&&Fe.type==="text"?(Fe.raw+=`
`+be.raw,Fe.text+=`
`+be.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Fe.text):ae.push(be);continue}if(X){var Ie="Infinite loop on byte: "+X.charCodeAt(0);if(this.options.silent){console.error(Ie);break}else throw new Error(Ie)}}return this.state.top=!0,ae},le.inline=function(X,ae){return ae===void 0&&(ae=[]),this.inlineQueue.push({src:X,tokens:ae}),ae},le.inlineTokens=function(X,ae){var pe=this;ae===void 0&&(ae=[]);var be,Fe,Ue,ke=X,Ie,Re,q;if(this.tokens.links){var V=Object.keys(this.tokens.links);if(V.length>0)for(;(Ie=this.tokenizer.rules.inline.reflinkSearch.exec(ke))!=null;)V.includes(Ie[0].slice(Ie[0].lastIndexOf("[")+1,-1))&&(ke=ke.slice(0,Ie.index)+"["+v("a",Ie[0].length-2)+"]"+ke.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Ie=this.tokenizer.rules.inline.blockSkip.exec(ke))!=null;)ke=ke.slice(0,Ie.index)+"["+v("a",Ie[0].length-2)+"]"+ke.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Ie=this.tokenizer.rules.inline.escapedEmSt.exec(ke))!=null;)ke=ke.slice(0,Ie.index)+"++"+ke.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;X;)if(Re||(q=""),Re=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(x){return(be=x.call({lexer:pe},X,ae))?(X=X.substring(be.raw.length),ae.push(be),!0):!1}))){if(be=this.tokenizer.escape(X)){X=X.substring(be.raw.length),ae.push(be);continue}if(be=this.tokenizer.tag(X)){X=X.substring(be.raw.length),Fe=ae[ae.length-1],Fe&&be.type==="text"&&Fe.type==="text"?(Fe.raw+=be.raw,Fe.text+=be.text):ae.push(be);continue}if(be=this.tokenizer.link(X)){X=X.substring(be.raw.length),ae.push(be);continue}if(be=this.tokenizer.reflink(X,this.tokens.links)){X=X.substring(be.raw.length),Fe=ae[ae.length-1],Fe&&be.type==="text"&&Fe.type==="text"?(Fe.raw+=be.raw,Fe.text+=be.text):ae.push(be);continue}if(be=this.tokenizer.emStrong(X,ke,q)){X=X.substring(be.raw.length),ae.push(be);continue}if(be=this.tokenizer.codespan(X)){X=X.substring(be.raw.length),ae.push(be);continue}if(be=this.tokenizer.br(X)){X=X.substring(be.raw.length),ae.push(be);continue}if(be=this.tokenizer.del(X)){X=X.substring(be.raw.length),ae.push(be);continue}if(be=this.tokenizer.autolink(X,B)){X=X.substring(be.raw.length),ae.push(be);continue}if(!this.state.inLink&&(be=this.tokenizer.url(X,B))){X=X.substring(be.raw.length),ae.push(be);continue}if(Ue=X,this.options.extensions&&this.options.extensions.startInline&&function(){var x=1/0,fe=X.slice(1),we=void 0;pe.options.extensions.startInline.forEach(function(Le){we=Le.call({lexer:this},fe),typeof we=="number"&&we>=0&&(x=Math.min(x,we))}),x<1/0&&x>=0&&(Ue=X.substring(0,x+1))}(),be=this.tokenizer.inlineText(Ue,F)){X=X.substring(be.raw.length),be.raw.slice(-1)!=="_"&&(q=be.raw.slice(-1)),Re=!0,Fe=ae[ae.length-1],Fe&&Fe.type==="text"?(Fe.raw+=be.raw,Fe.text+=be.text):ae.push(be);continue}if(X){var J="Infinite loop on byte: "+X.charCodeAt(0);if(this.options.silent){console.error(J);break}else throw new Error(J)}}return ae},r(te,null,[{key:"rules",get:function(){return{block:j,inline:z}}}]),te}(),re=function(){function te(ue){this.options=ue||ce.defaults}var le=te.prototype;return le.code=function(X,ae,pe){var be=(ae||"").match(/\S*/)[0];if(this.options.highlight){var Fe=this.options.highlight(X,be);Fe!=null&&Fe!==X&&(pe=!0,X=Fe)}return X=X.replace(/\n$/,"")+`
`,be?'<pre><code class="'+this.options.langPrefix+p(be,!0)+'">'+(pe?X:p(X,!0))+`</code></pre>
`:"<pre><code>"+(pe?X:p(X,!0))+`</code></pre>
`},le.blockquote=function(X){return`<blockquote>
`+X+`</blockquote>
`},le.html=function(X){return X},le.heading=function(X,ae,pe,be){if(this.options.headerIds){var Fe=this.options.headerPrefix+be.slug(pe);return"<h"+ae+' id="'+Fe+'">'+X+"</h"+ae+`>
`}return"<h"+ae+">"+X+"</h"+ae+`>
`},le.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},le.list=function(X,ae,pe){var be=ae?"ol":"ul",Fe=ae&&pe!==1?' start="'+pe+'"':"";return"<"+be+Fe+`>
`+X+"</"+be+`>
`},le.listitem=function(X){return"<li>"+X+`</li>
`},le.checkbox=function(X){return"<input "+(X?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},le.paragraph=function(X){return"<p>"+X+`</p>
`},le.table=function(X,ae){return ae&&(ae="<tbody>"+ae+"</tbody>"),`<table>
<thead>
`+X+`</thead>
`+ae+`</table>
`},le.tablerow=function(X){return`<tr>
`+X+`</tr>
`},le.tablecell=function(X,ae){var pe=ae.header?"th":"td",be=ae.align?"<"+pe+' align="'+ae.align+'">':"<"+pe+">";return be+X+("</"+pe+`>
`)},le.strong=function(X){return"<strong>"+X+"</strong>"},le.em=function(X){return"<em>"+X+"</em>"},le.codespan=function(X){return"<code>"+X+"</code>"},le.br=function(){return this.options.xhtml?"<br/>":"<br>"},le.del=function(X){return"<del>"+X+"</del>"},le.link=function(X,ae,pe){if(X=t(this.options.sanitize,this.options.baseUrl,X),X===null)return pe;var be='<a href="'+p(X)+'"';return ae&&(be+=' title="'+ae+'"'),be+=">"+pe+"</a>",be},le.image=function(X,ae,pe){if(X=t(this.options.sanitize,this.options.baseUrl,X),X===null)return pe;var be='<img src="'+X+'" alt="'+pe+'"';return ae&&(be+=' title="'+ae+'"'),be+=this.options.xhtml?"/>":">",be},le.text=function(X){return X},te}(),U=function(){function te(){}var le=te.prototype;return le.strong=function(X){return X},le.em=function(X){return X},le.codespan=function(X){return X},le.del=function(X){return X},le.html=function(X){return X},le.text=function(X){return X},le.link=function(X,ae,pe){return""+pe},le.image=function(X,ae,pe){return""+pe},le.br=function(){return""},te}(),G=function(){function te(){this.seen={}}var le=te.prototype;return le.serialize=function(X){return X.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},le.getNextSafeSlug=function(X,ae){var pe=X,be=0;if(this.seen.hasOwnProperty(pe)){be=this.seen[X];do be++,pe=X+"-"+be;while(this.seen.hasOwnProperty(pe))}return ae||(this.seen[X]=be,this.seen[pe]=0),pe},le.slug=function(X,ae){ae===void 0&&(ae={});var pe=this.serialize(X);return this.getNextSafeSlug(pe,ae.dryrun)},te}(),Q=function(){function te(ue){this.options=ue||ce.defaults,this.options.renderer=this.options.renderer||new re,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new U,this.slugger=new G}te.parse=function(X,ae){var pe=new te(ae);return pe.parse(X)},te.parseInline=function(X,ae){var pe=new te(ae);return pe.parseInline(X)};var le=te.prototype;return le.parse=function(X,ae){ae===void 0&&(ae=!0);var pe="",be,Fe,Ue,ke,Ie,Re,q,V,J,x,fe,we,Le,He,Ke,et,rt,ot,nt,ct=X.length;for(be=0;be<ct;be++){if(x=X[be],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[x.type]&&(nt=this.options.extensions.renderers[x.type].call({parser:this},x),nt!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(x.type))){pe+=nt||"";continue}switch(x.type){case"space":continue;case"hr":{pe+=this.renderer.hr();continue}case"heading":{pe+=this.renderer.heading(this.parseInline(x.tokens),x.depth,f(this.parseInline(x.tokens,this.textRenderer)),this.slugger);continue}case"code":{pe+=this.renderer.code(x.text,x.lang,x.escaped);continue}case"table":{for(V="",q="",ke=x.header.length,Fe=0;Fe<ke;Fe++)q+=this.renderer.tablecell(this.parseInline(x.header[Fe].tokens),{header:!0,align:x.align[Fe]});for(V+=this.renderer.tablerow(q),J="",ke=x.rows.length,Fe=0;Fe<ke;Fe++){for(Re=x.rows[Fe],q="",Ie=Re.length,Ue=0;Ue<Ie;Ue++)q+=this.renderer.tablecell(this.parseInline(Re[Ue].tokens),{header:!1,align:x.align[Ue]});J+=this.renderer.tablerow(q)}pe+=this.renderer.table(V,J);continue}case"blockquote":{J=this.parse(x.tokens),pe+=this.renderer.blockquote(J);continue}case"list":{for(fe=x.ordered,we=x.start,Le=x.loose,ke=x.items.length,J="",Fe=0;Fe<ke;Fe++)Ke=x.items[Fe],et=Ke.checked,rt=Ke.task,He="",Ke.task&&(ot=this.renderer.checkbox(et),Le?Ke.tokens.length>0&&Ke.tokens[0].type==="paragraph"?(Ke.tokens[0].text=ot+" "+Ke.tokens[0].text,Ke.tokens[0].tokens&&Ke.tokens[0].tokens.length>0&&Ke.tokens[0].tokens[0].type==="text"&&(Ke.tokens[0].tokens[0].text=ot+" "+Ke.tokens[0].tokens[0].text)):Ke.tokens.unshift({type:"text",text:ot}):He+=ot),He+=this.parse(Ke.tokens,Le),J+=this.renderer.listitem(He,rt,et);pe+=this.renderer.list(J,fe,we);continue}case"html":{pe+=this.renderer.html(x.text);continue}case"paragraph":{pe+=this.renderer.paragraph(this.parseInline(x.tokens));continue}case"text":{for(J=x.tokens?this.parseInline(x.tokens):x.text;be+1<ct&&X[be+1].type==="text";)x=X[++be],J+=`
`+(x.tokens?this.parseInline(x.tokens):x.text);pe+=ae?this.renderer.paragraph(J):J;continue}default:{var mt='Token with "'+x.type+'" type was not found.';if(this.options.silent){console.error(mt);return}else throw new Error(mt)}}}return pe},le.parseInline=function(X,ae){ae=ae||this.renderer;var pe="",be,Fe,Ue,ke=X.length;for(be=0;be<ke;be++){if(Fe=X[be],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Fe.type]&&(Ue=this.options.extensions.renderers[Fe.type].call({parser:this},Fe),Ue!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(Fe.type))){pe+=Ue||"";continue}switch(Fe.type){case"escape":{pe+=ae.text(Fe.text);break}case"html":{pe+=ae.html(Fe.text);break}case"link":{pe+=ae.link(Fe.href,Fe.title,this.parseInline(Fe.tokens,ae));break}case"image":{pe+=ae.image(Fe.href,Fe.title,Fe.text);break}case"strong":{pe+=ae.strong(this.parseInline(Fe.tokens,ae));break}case"em":{pe+=ae.em(this.parseInline(Fe.tokens,ae));break}case"codespan":{pe+=ae.codespan(Fe.text);break}case"br":{pe+=ae.br();break}case"del":{pe+=ae.del(this.parseInline(Fe.tokens,ae));break}case"text":{pe+=ae.text(Fe.text);break}default:{var Ie='Token with "'+Fe.type+'" type was not found.';if(this.options.silent){console.error(Ie);return}else throw new Error(Ie)}}}return pe},te}();function ee(te,le,ue){if(typeof te>"u"||te===null)throw new Error("marked(): input parameter is undefined or null");if(typeof te!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(te)+", string expected");if(typeof le=="function"&&(ue=le,le=null),le=D({},ee.defaults,le||{}),b(le),ue){var X=le.highlight,ae;try{ae=_.lex(te,le)}catch(ke){return ue(ke)}var pe=function(Ie){var Re;if(!Ie)try{le.walkTokens&&ee.walkTokens(ae,le.walkTokens),Re=Q.parse(ae,le)}catch(q){Ie=q}return le.highlight=X,Ie?ue(Ie):ue(null,Re)};if(!X||X.length<3||(delete le.highlight,!ae.length))return pe();var be=0;ee.walkTokens(ae,function(ke){ke.type==="code"&&(be++,setTimeout(function(){X(ke.text,ke.lang,function(Ie,Re){if(Ie)return pe(Ie);Re!=null&&Re!==ke.text&&(ke.text=Re,ke.escaped=!0),be--,be===0&&pe()})},0))}),be===0&&pe();return}function Fe(ke){if(ke.message+=`
Please report this to https://github.com/markedjs/marked.`,le.silent)return"<p>An error occurred:</p><pre>"+p(ke.message+"",!0)+"</pre>";throw ke}try{var Ue=_.lex(te,le);if(le.walkTokens){if(le.async)return Promise.all(ee.walkTokens(Ue,le.walkTokens)).then(function(){return Q.parse(Ue,le)}).catch(Fe);ee.walkTokens(Ue,le.walkTokens)}return Q.parse(Ue,le)}catch(ke){Fe(ke)}}ee.options=ee.setOptions=function(te){return D(ee.defaults,te),N(ee.defaults),ee},ee.getDefaults=T,ee.defaults=ce.defaults,ee.use=function(){for(var te=arguments.length,le=new Array(te),ue=0;ue<te;ue++)le[ue]=arguments[ue];var X=D.apply(void 0,[{}].concat(le)),ae=ee.defaults.extensions||{renderers:{},childTokens:{}},pe;le.forEach(function(be){if(be.extensions&&(pe=!0,be.extensions.forEach(function(Ue){if(!Ue.name)throw new Error("extension name required");if(Ue.renderer){var ke=ae.renderers?ae.renderers[Ue.name]:null;ke?ae.renderers[Ue.name]=function(){for(var Ie=arguments.length,Re=new Array(Ie),q=0;q<Ie;q++)Re[q]=arguments[q];var V=Ue.renderer.apply(this,Re);return V===!1&&(V=ke.apply(this,Re)),V}:ae.renderers[Ue.name]=Ue.renderer}if(Ue.tokenizer){if(!Ue.level||Ue.level!=="block"&&Ue.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");ae[Ue.level]?ae[Ue.level].unshift(Ue.tokenizer):ae[Ue.level]=[Ue.tokenizer],Ue.start&&(Ue.level==="block"?ae.startBlock?ae.startBlock.push(Ue.start):ae.startBlock=[Ue.start]:Ue.level==="inline"&&(ae.startInline?ae.startInline.push(Ue.start):ae.startInline=[Ue.start]))}Ue.childTokens&&(ae.childTokens[Ue.name]=Ue.childTokens)})),be.renderer&&function(){var Ue=ee.defaults.renderer||new re,ke=function(q){var V=Ue[q];Ue[q]=function(){for(var J=arguments.length,x=new Array(J),fe=0;fe<J;fe++)x[fe]=arguments[fe];var we=be.renderer[q].apply(Ue,x);return we===!1&&(we=V.apply(Ue,x)),we}};for(var Ie in be.renderer)ke(Ie);X.renderer=Ue}(),be.tokenizer&&function(){var Ue=ee.defaults.tokenizer||new M,ke=function(q){var V=Ue[q];Ue[q]=function(){for(var J=arguments.length,x=new Array(J),fe=0;fe<J;fe++)x[fe]=arguments[fe];var we=be.tokenizer[q].apply(Ue,x);return we===!1&&(we=V.apply(Ue,x)),we}};for(var Ie in be.tokenizer)ke(Ie);X.tokenizer=Ue}(),be.walkTokens){var Fe=ee.defaults.walkTokens;X.walkTokens=function(Ue){var ke=[];return ke.push(be.walkTokens.call(this,Ue)),Fe&&(ke=ke.concat(Fe.call(this,Ue))),ke}}pe&&(X.extensions=ae),ee.setOptions(X)})},ee.walkTokens=function(te,le){for(var ue=[],X=function(){var Fe=pe.value;switch(ue=ue.concat(le.call(ee,Fe)),Fe.type){case"table":{for(var Ue=R(Fe.header),ke;!(ke=Ue()).done;){var Ie=ke.value;ue=ue.concat(ee.walkTokens(Ie.tokens,le))}for(var Re=R(Fe.rows),q;!(q=Re()).done;)for(var V=q.value,J=R(V),x;!(x=J()).done;){var fe=x.value;ue=ue.concat(ee.walkTokens(fe.tokens,le))}break}case"list":{ue=ue.concat(ee.walkTokens(Fe.items,le));break}default:ee.defaults.extensions&&ee.defaults.extensions.childTokens&&ee.defaults.extensions.childTokens[Fe.type]?ee.defaults.extensions.childTokens[Fe.type].forEach(function(we){ue=ue.concat(ee.walkTokens(Fe[we],le))}):Fe.tokens&&(ue=ue.concat(ee.walkTokens(Fe.tokens,le)))}},ae=R(te),pe;!(pe=ae()).done;)X();return ue},ee.parseInline=function(te,le){if(typeof te>"u"||te===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof te!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(te)+", string expected");le=D({},ee.defaults,le||{}),b(le);try{var ue=_.lexInline(te,le);return le.walkTokens&&ee.walkTokens(ue,le.walkTokens),Q.parseInline(ue,le)}catch(X){if(X.message+=`
Please report this to https://github.com/markedjs/marked.`,le.silent)return"<p>An error occurred:</p><pre>"+p(X.message+"",!0)+"</pre>";throw X}},ee.Parser=Q,ee.parser=Q.parse,ee.Renderer=re,ee.TextRenderer=U,ee.Lexer=_,ee.lexer=_.lex,ee.Tokenizer=M,ee.Slugger=G,ee.parse=ee;var he=ee.options,ne=ee.setOptions,De=ee.use,$e=ee.walkTokens,K=ee.parseInline,W=ee,se=Q.parse,oe=_.lex;ce.Lexer=_,ce.Parser=Q,ce.Renderer=re,ce.Slugger=G,ce.TextRenderer=U,ce.Tokenizer=M,ce.getDefaults=T,ce.lexer=oe,ce.marked=ee,ce.options=he,ce.parse=W,ce.parseInline=K,ce.parser=se,ce.setOptions=ne,ce.use=De,ce.walkTokens=$e,Object.defineProperty(ce,"__esModule",{value:!0})}),define(Ee[41],ye([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MarshalledId=void 0;var r;(function(h){h[h.Uri=1]="Uri",h[h.Regexp=2]="Regexp",h[h.ScmResource=3]="ScmResource",h[h.ScmResourceGroup=4]="ScmResourceGroup",h[h.ScmProvider=5]="ScmProvider",h[h.CommentController=6]="CommentController",h[h.CommentThread=7]="CommentThread",h[h.CommentThreadInstance=8]="CommentThreadInstance",h[h.CommentThreadReply=9]="CommentThreadReply",h[h.CommentNode=10]="CommentNode",h[h.CommentThreadNode=11]="CommentThreadNode",h[h.TimelineActionContext=12]="TimelineActionContext",h[h.NotebookCellActionContext=13]="NotebookCellActionContext",h[h.NotebookActionContext=14]="NotebookActionContext",h[h.TerminalContext=15]="TerminalContext",h[h.TestItemContext=16]="TestItemContext",h[h.Date=17]="Date",h[h.TestMessageMenuArgs=18]="TestMessageMenuArgs"})(r||(e.MarshalledId=r={}))}),define(Ee[177],ye([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ek=r;function r(a){const f=R(a);if(f&&f.length>0)return new Uint32Array(f)}let h=0;const P=new Uint32Array(10);function R(a){if(h=0,T(a,E,$.InitialConsonant),h>0||(T(a,u,$.Vowel),h>0)||(T(a,k,$.FinalConsonant),h>0)||(T(a,p,$.CompatibilityJamo),h))return P.subarray(0,h);if(a>=44032&&a<=55203){const f=a-44032,d=f%588,m=Math.floor(f/588),n=Math.floor(d/28),o=d%28-1;if(m<E.length?T(m,E,0):$.InitialConsonant+m-$.CompatibilityJamo<p.length&&T($.InitialConsonant+m,p,$.CompatibilityJamo),n<u.length?T(n,u,0):$.Vowel+n-$.CompatibilityJamo<p.length&&T($.Vowel+n-$.CompatibilityJamo,p,$.CompatibilityJamo),o>=0&&(o<k.length?T(o,k,0):$.FinalConsonant+o-$.CompatibilityJamo<p.length&&T($.FinalConsonant+o-$.CompatibilityJamo,p,$.CompatibilityJamo)),h>0)return P.subarray(0,h)}}function T(a,f,d){a>=d&&a<d+f.length&&N(f[a-d])}function N(a){a!==c.NUL&&(P[h++]=a&255,a>>8&&(P[h++]=a>>8&255),a>>16&&(P[h++]=a>>16&255))}var $;(function(a){a[a.InitialConsonant=4352]="InitialConsonant",a[a.Vowel=4449]="Vowel",a[a.FinalConsonant=4520]="FinalConsonant",a[a.CompatibilityJamo=12593]="CompatibilityJamo"})($||($={}));var c;(function(a){a[a.NUL=0]="NUL",a[a.A=65]="A",a[a.B=66]="B",a[a.C=67]="C",a[a.D=68]="D",a[a.E=69]="E",a[a.F=70]="F",a[a.G=71]="G",a[a.H=72]="H",a[a.I=73]="I",a[a.J=74]="J",a[a.K=75]="K",a[a.L=76]="L",a[a.M=77]="M",a[a.N=78]="N",a[a.O=79]="O",a[a.P=80]="P",a[a.Q=81]="Q",a[a.R=82]="R",a[a.S=83]="S",a[a.T=84]="T",a[a.U=85]="U",a[a.V=86]="V",a[a.W=87]="W",a[a.X=88]="X",a[a.Y=89]="Y",a[a.Z=90]="Z",a[a.a=97]="a",a[a.b=98]="b",a[a.c=99]="c",a[a.d=100]="d",a[a.e=101]="e",a[a.f=102]="f",a[a.g=103]="g",a[a.h=104]="h",a[a.i=105]="i",a[a.j=106]="j",a[a.k=107]="k",a[a.l=108]="l",a[a.m=109]="m",a[a.n=110]="n",a[a.o=111]="o",a[a.p=112]="p",a[a.q=113]="q",a[a.r=114]="r",a[a.s=115]="s",a[a.t=116]="t",a[a.u=117]="u",a[a.v=118]="v",a[a.w=119]="w",a[a.x=120]="x",a[a.y=121]="y",a[a.z=122]="z"})(c||(c={}));var I;(function(a){a[a.fa=24934]="fa",a[a.fg=26470]="fg",a[a.fq=29030]="fq",a[a.fr=29286]="fr",a[a.ft=29798]="ft",a[a.fv=30310]="fv",a[a.fx=30822]="fx",a[a.hk=27496]="hk",a[a.hl=27752]="hl",a[a.ho=28520]="ho",a[a.ml=27757]="ml",a[a.nj=27246]="nj",a[a.nl=27758]="nl",a[a.np=28782]="np",a[a.qt=29809]="qt",a[a.rt=29810]="rt",a[a.sg=26483]="sg",a[a.sw=30579]="sw"})(I||(I={}));const E=new Uint8Array([c.r,c.R,c.s,c.e,c.E,c.f,c.a,c.q,c.Q,c.t,c.T,c.d,c.w,c.W,c.c,c.z,c.x,c.v,c.g]),u=new Uint16Array([c.k,c.o,c.i,c.O,c.j,c.p,c.u,c.P,c.h,I.hk,I.ho,I.hl,c.y,c.n,I.nj,I.np,I.nl,c.b,c.m,I.ml,c.l]),k=new Uint16Array([c.r,c.R,I.rt,c.s,I.sw,I.sg,c.e,c.f,I.fr,I.fa,I.fq,I.ft,I.fx,I.fv,I.fg,c.a,c.q,I.qt,c.t,c.T,c.d,c.w,c.c,c.z,c.x,c.v,c.g]),p=new Uint16Array([c.r,c.R,I.rt,c.s,I.sw,I.sg,c.e,c.E,c.f,I.fr,I.fa,I.fq,I.ft,I.fx,I.fv,I.fg,c.a,c.q,c.Q,I.qt,c.t,c.T,c.d,c.w,c.W,c.c,c.z,c.x,c.v,c.g,c.k,c.o,c.i,c.O,c.j,c.p,c.u,c.P,c.h,I.hk,I.ho,I.hl,c.y,c.n,I.nj,I.np,I.nl,c.b,c.m,I.ml,c.l])}),define(Ee[82],ye([1,0,29]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$om=void 0,e.$mm=P,e.$nm=T;const h=new r.$Fc(1e4);function P(c){return $(c,"NFC",h)}const R=new r.$Fc(1e4);function T(c){return $(c,"NFD",R)}const N=/[^\u0000-\u0080]/;function $(c,I,E){if(!c)return c;const u=E.get(c);if(u)return u;let k;return N.test(c)?k=c.normalize(I):k=c,E.set(c,k),k}e.$om=function(){const c=/[\u0300-\u036f]/g;return function(I){return T(I).replace(c,"")}}()}),define(Ee[134],ye([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Om=e.$Nm=e.$Mm=void 0,e.$Km=r,e.rot=h,e.$Pm=N;function r($,c,I){return Math.min(Math.max($,c),I)}function h($,c){return(c+$%c)%c}class P{constructor(){this.a=0}getNext(){return this.a++}}e.$Mm=P;class R{constructor(){this.a=1,this.b=0}update(c){return this.b=this.b+(c-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$Nm=R;class T{constructor(c){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(c),this.c.fill(0,0,c)}update(c){const I=this.c[this.d];return this.c[this.d]=c,this.d=(this.d+1)%this.c.length,this.e-=I,this.e+=c,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$Om=T;function N($,c,I,E,u,k,p,a){const f=p-I,d=a-E,m=u-I,n=k-E,o=$-I,t=c-E,i=f*f+d*d,s=f*m+d*n,g=f*o+d*t,l=m*m+n*n,w=m*o+n*t,S=1/(i*l-s*s),D=(l*g-s*w)*S,y=(i*w-s*g)*S;return D>=0&&y>=0&&D+y<1}}),define(Ee[178],ye([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cd=void 0,e.$dd=R,e.$ed=u;class r{constructor(p,a,f){this.owner=p,this.debugNameSource=a,this.referenceFn=f}getDebugName(p){return R(p,this)}}e.$cd=r;const h=new Map,P=new WeakMap;function R(k,p){const a=P.get(k);if(a)return a;const f=T(k,p);if(f){let d=h.get(f)??0;d++,h.set(f,d);const m=d===1?f:`${f}#${d}`;return P.set(k,m),m}}function T(k,p){const a=P.get(k);if(a)return a;const f=p.owner?I(p.owner)+".":"";let d;const m=p.debugNameSource;if(m!==void 0)if(typeof m=="function"){if(d=m(),d!==void 0)return f+d}else return f+m;const n=p.referenceFn;if(n!==void 0&&(d=u(n),d!==void 0))return f+d;if(p.owner!==void 0){const o=N(p.owner,k);if(o!==void 0)return f+o}}function N(k,p){for(const a in k)if(k[a]===p)return a}const $=new Map,c=new WeakMap;function I(k){const p=c.get(k);if(p)return p;const a=E(k);let f=$.get(a)??0;f++,$.set(a,f);const d=f===1?a:`${a}#${f}`;return c.set(k,d),d}function E(k){const p=k.constructor;return p?p.name:"Object"}function u(k){const p=k.toString(),f=/\/\*\*\s*@description\s*([^*]*)\*\//.exec(p);return(f?f[1]:void 0)?.trim()}}),define(Ee[179],ye([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nd=void 0,e.$Ld=h,e.$Md=P;let r;function h(a){r=a}function P(){return r}class R{constructor(){this.a=0,this.d=new WeakMap}b(f){return T([N(k("|  ",this.a)),f])}c(f){return f.hadValue?f.didChange?[N(" "),c(I(f.oldValue,70),{color:"red",strikeThrough:!0}),N(" "),c(I(f.newValue,60),{color:"green"})]:[N(" (unchanged)")]:[N(" "),c(I(f.newValue,60),{color:"green"}),N(" (initial)")]}handleObservableChanged(f,d){console.log(...this.b([$("observable value changed"),c(f.debugName,{color:"BlueViolet"}),...this.c(d)]))}formatChanges(f){if(f.size!==0)return c(" (changed deps: "+[...f].map(d=>d.debugName).join(", ")+")",{color:"gray"})}handleDerivedCreated(f){const d=f.handleChange;this.d.set(f,new Set),f.handleChange=(m,n)=>(this.d.get(f).add(m),d.apply(f,[m,n]))}handleDerivedRecomputed(f,d){const m=this.d.get(f);console.log(...this.b([$("derived recomputed"),c(f.debugName,{color:"BlueViolet"}),...this.c(d),this.formatChanges(m),{data:[{fn:f._debugNameData.referenceFn??f._computeFn}]}])),m.clear()}handleFromEventObservableTriggered(f,d){console.log(...this.b([$("observable from event triggered"),c(f.debugName,{color:"BlueViolet"}),...this.c(d),{data:[{fn:f._getValue}]}]))}handleAutorunCreated(f){const d=f.handleChange;this.d.set(f,new Set),f.handleChange=(m,n)=>(this.d.get(f).add(m),d.apply(f,[m,n]))}handleAutorunTriggered(f){const d=this.d.get(f);console.log(...this.b([$("autorun"),c(f.debugName,{color:"BlueViolet"}),this.formatChanges(d),{data:[{fn:f._debugNameData.referenceFn??f._runFn}]}])),d.clear(),this.a++}handleAutorunFinished(f){this.a--}handleBeginTransaction(f){let d=f.getDebugName();d===void 0&&(d=""),console.log(...this.b([$("transaction"),c(d,{color:"BlueViolet"}),{data:[{fn:f._fn}]}])),this.a++}handleEndTransaction(){this.a--}}e.$Nd=R;function T(a){const f=new Array,d=[];let m="";function n(t){if("length"in t)for(const i of t)i&&n(i);else"text"in t?(m+=`%c${t.text}`,f.push(t.style),t.data&&d.push(...t.data)):"data"in t&&d.push(...t.data)}n(a);const o=[m,...f];return o.push(...d),o}function N(a){return c(a,{color:"black"})}function $(a){return c(p(`${a}: `,10),{color:"black",bold:!0})}function c(a,f={color:"black"}){function d(n){return Object.entries(n).reduce((o,[t,i])=>`${o}${t}:${i};`,"")}const m={color:f.color};return f.strikeThrough&&(m["text-decoration"]="line-through"),f.bold&&(m["font-weight"]="bold"),{text:a,style:d(m)}}function I(a,f){switch(typeof a){case"number":return""+a;case"string":return a.length+2<=f?`"${a}"`:`"${a.substr(0,f-7)}"+...`;case"boolean":return a?"true":"false";case"undefined":return"undefined";case"object":return a===null?"null":Array.isArray(a)?E(a,f):u(a,f);case"symbol":return a.toString();case"function":return`[[Function${a.name?" "+a.name:""}]]`;default:return""+a}}function E(a,f){let d="[ ",m=!0;for(const n of a){if(m||(d+=", "),d.length-5>f){d+="...";break}m=!1,d+=`${I(n,f-d.length)}`}return d+=" ]",d}function u(a,f){let d="{ ",m=!0;for(const[n,o]of Object.entries(a)){if(m||(d+=", "),d.length-5>f){d+="...";break}m=!1,d+=`${n}: ${I(o,f-d.length)}`}return d+=" }",d}function k(a,f){let d="";for(let m=1;m<=f;m++)d+=a;return d}function p(a,f){for(;a.length<f;)a+=" ";return a}}),define(Ee[180],ye([1,0,174,178,179]),function(ce,e,r,h,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0d=e.$8d=e.$6d=e.$1d=e.$Zd=void 0,e.$Wd=T,e.$Xd=$,e.$Yd=I,e.$2d=k,e.$3d=a,e.$4d=f,e.$5d=d,e.$7d=n,e.$9d=t;let R;function T(s){R=s}let N;function $(s){N=s}let c;function I(s){c=s}class E{get TChange(){return null}reportChanges(){this.get()}read(g){return g?g.readObservable(this):this.get()}map(g,l){const w=l===void 0?void 0:g,S=l===void 0?g:l;return c({owner:w,debugName:()=>{const D=(0,h.$ed)(S);if(D!==void 0)return D;const C=/^\s*\(?\s*([a-zA-Z_$][a-zA-Z_$0-9]*)\s*\)?\s*=>\s*\1(?:\??)\.([a-zA-Z_$][a-zA-Z_$0-9]*)\s*$/.exec(S.toString());if(C)return`${this.debugName}.${C[2]}`;if(!w)return`${this.debugName} (mapped)`},debugReferenceFn:S},D=>S(this.read(D),D))}recomputeInitiallyAndOnChange(g,l){return g.add(R(this,l)),this}keepObserved(g){return g.add(N(this)),this}get a(){return this.get()}}e.$Zd=E;class u extends E{constructor(){super(...arguments),this.b=new Set}addObserver(g){const l=this.b.size;this.b.add(g),l===0&&this.c()}removeObserver(g){this.b.delete(g)&&this.b.size===0&&this.f()}c(){}f(){}}e.$1d=u;function k(s,g){const l=new m(s,g);try{s(l)}finally{l.finish()}}let p;function a(s){if(p)s(p);else{const g=new m(s,void 0);p=g;try{s(g)}finally{g.finish(),p=void 0}}}async function f(s,g){const l=new m(s,g);try{await s(l)}finally{l.finish()}}function d(s,g,l){s?g(s):k(g,l)}class m{constructor(g,l){this._fn=g,this.b=l,this.a=[],(0,P.$Md)()?.handleBeginTransaction(this)}getDebugName(){return this.b?this.b():(0,h.$ed)(this._fn)}updateObserver(g,l){this.a.push({observer:g,observable:l}),g.beginUpdate(l)}finish(){const g=this.a;for(let l=0;l<g.length;l++){const{observer:w,observable:S}=g[l];w.endUpdate(S)}this.a=null,(0,P.$Md)()?.handleEndTransaction()}}e.$6d=m;function n(s,g){let l;return typeof s=="string"?l=new h.$cd(void 0,s,void 0):l=new h.$cd(s,void 0,void 0),new o(l,g,r.$8c)}class o extends u{get debugName(){return this.e.getDebugName(this)??"ObservableValue"}constructor(g,l,w){super(),this.e=g,this.g=w,this.d=l}get(){return this.d}set(g,l,w){if(w===void 0&&this.g(this.d,g))return;let S;l||(l=S=new m(()=>{},()=>`Setting ${this.debugName}`));try{const D=this.d;this.h(g),(0,P.$Md)()?.handleObservableChanged(this,{oldValue:D,newValue:g,change:w,didChange:!0,hadValue:!0});for(const y of this.b)l.updateObserver(y,this),y.handleChange(this,w)}finally{S&&S.finish()}}toString(){return`${this.debugName}: ${this.d}`}h(g){this.d=g}}e.$8d=o;function t(s,g){let l;return typeof s=="string"?l=new h.$cd(void 0,s,void 0):l=new h.$cd(s,void 0,void 0),new i(l,g,r.$8c)}class i extends o{h(g){this.d!==g&&(this.d&&this.d.dispose(),this.d=g)}dispose(){this.d?.dispose()}}e.$0d=i}),function(){function ce(P){const R=[];typeof P=="number"&&R.push("code/timeOrigin",P);function T($){R.push($,Date.now())}function N(){const $=[];for(let c=0;c<R.length;c+=2)$.push({name:R[c],startTime:R[c+1]});return $}return{mark:T,getMarks:N}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?ce():{mark(P){performance.mark(P)},getMarks(){let P=performance.timeOrigin;typeof P!="number"&&(P=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const R=[{name:"code/timeOrigin",startTime:Math.round(P)}];for(const T of performance.getEntriesByType("mark"))R.push({name:T.name,startTime:Math.round(P+T.startTime)});return R}};if(typeof process=="object"){const P=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return ce(P)}else return console.trace("perf-util loaded in UNKNOWN environment"),ce()}function r(P){return P.MonacoPerformanceMarks||(P.MonacoPerformanceMarks=e()),P.MonacoPerformanceMarks}var h;typeof global=="object"?h=global:typeof self=="object"?h=self:h={},typeof define=="function"?define("vs/base/common/performance",[],function(){return r(h)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=r(h):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),h.perf=r(h))}(),define(Ee[181],ye([1,0,40]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$PI=void 0;const h=Symbol("unset");class P{constructor(){this.a=new T,this.b=0}get size(){return this.b}get nodes(){return this.a.children?.values()||r.Iterable.empty()}insert($,c,I){this.d($,E=>E._value=c,I)}mutate($,c){this.d($,I=>I._value=c(I._value===h?void 0:I._value))}mutatePath($,c){this.d($,()=>{},I=>c(I))}delete($){const c=this.c($);if(!c)return;let I=c.length-1;const E=c[I].node._value;if(E!==h){for(this.b--,c[I].node._value=h;I>0;I--){const{node:u,part:k}=c[I];if(u.children?.size||u._value!==h)break;c[I-1].node.children.delete(k)}return E}}*deleteRecursive($){const c=this.c($);if(!c)return;const I=c[c.length-1].node;for(let E=c.length-1;E>0;E--){const u=c[E-1];if(u.node.children.delete(c[E].part),u.node.children.size>0||u.node._value!==h)break}for(const E of R(I))E._value!==h&&(this.b--,yield E._value)}find($){let c=this.a;for(const I of $){const E=c.children?.get(I);if(!E)return;c=E}return c._value===h?void 0:c._value}hasKeyOrParent($){let c=this.a;for(const I of $){const E=c.children?.get(I);if(!E)return!1;if(E._value!==h)return!0;c=E}return!1}hasKeyOrChildren($){let c=this.a;for(const I of $){const E=c.children?.get(I);if(!E)return!1;c=E}return!0}hasKey($){let c=this.a;for(const I of $){const E=c.children?.get(I);if(!E)return!1;c=E}return c._value!==h}c($){const c=[{part:"",node:this.a}];let I=0;for(const E of $){const u=c[I].node.children?.get(E);if(!u)return;c.push({part:E,node:u}),I++}return c}d($,c,I){let E=this.a;for(const p of $){if(E.children)if(E.children.has(p))E=E.children.get(p);else{const a=new T;E.children.set(p,a),E=a}else{const a=new T;E.children=new Map([[p,a]]),E=a}I?.(E)}const u=E._value===h?0:1;c(E);const k=E._value===h?0:1;this.b+=k-u}*values(){for(const{_value:$}of R(this.a))$!==h&&(yield $)}}e.$PI=P;function*R(N){const $=[N];for(;$.length>0;){const c=$.pop();if(yield c,c.children)for(const I of c.children.values())$.push(I)}}class T{constructor(){this._value=h}get value(){return this._value===h?void 0:this._value}set value($){this._value=$===void 0?h:$}}}),function(ce,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var r=e();for(var h in r)(typeof exports=="object"?exports:ce)[h]=r[h]}}(typeof self<"u"?self:this,function(){return function(ce){var e={};function r(h){if(e[h])return e[h].exports;var P=e[h]={i:h,l:!1,exports:{}};return ce[h].call(P.exports,P,P.exports,r),P.l=!0,P.exports}return r.m=ce,r.c=e,r.d=function(h,P,R){r.o(h,P)||Object.defineProperty(h,P,{enumerable:!0,get:R})},r.r=function(h){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(h,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(h,"__esModule",{value:!0})},r.t=function(h,P){if(1&P&&(h=r(h)),8&P||4&P&&typeof h=="object"&&h&&h.__esModule)return h;var R=Object.create(null);if(r.r(R),Object.defineProperty(R,"default",{enumerable:!0,value:h}),2&P&&typeof h!="string")for(var T in h)r.d(R,T,function(N){return h[N]}.bind(null,T));return R},r.n=function(h){var P=h&&h.__esModule?function(){return h.default}:function(){return h};return r.d(P,"a",P),P},r.o=function(h,P){return Object.prototype.hasOwnProperty.call(h,P)},r.p="",r(r.s=0)}([function(ce,e,r){(function(h){var P;e=ce.exports=De,P=typeof h=="object"&&h.env&&h.env.NODE_DEBUG&&/\bsemver\b/i.test(h.env.NODE_DEBUG)?function(){var V=Array.prototype.slice.call(arguments,0);V.unshift("SEMVER"),console.log.apply(console,V)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var R=256,T=Number.MAX_SAFE_INTEGER||9007199254740991,N=e.re=[],$=e.src=[],c=0,I=c++;$[I]="0|[1-9]\\d*";var E=c++;$[E]="[0-9]+";var u=c++;$[u]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var k=c++;$[k]="("+$[I]+")\\.("+$[I]+")\\.("+$[I]+")";var p=c++;$[p]="("+$[E]+")\\.("+$[E]+")\\.("+$[E]+")";var a=c++;$[a]="(?:"+$[I]+"|"+$[u]+")";var f=c++;$[f]="(?:"+$[E]+"|"+$[u]+")";var d=c++;$[d]="(?:-("+$[a]+"(?:\\."+$[a]+")*))";var m=c++;$[m]="(?:-?("+$[f]+"(?:\\."+$[f]+")*))";var n=c++;$[n]="[0-9A-Za-z-]+";var o=c++;$[o]="(?:\\+("+$[n]+"(?:\\."+$[n]+")*))";var t=c++,i="v?"+$[k]+$[d]+"?"+$[o]+"?";$[t]="^"+i+"$";var s="[v=\\s]*"+$[p]+$[m]+"?"+$[o]+"?",g=c++;$[g]="^"+s+"$";var l=c++;$[l]="((?:<|>)?=?)";var w=c++;$[w]=$[E]+"|x|X|\\*";var S=c++;$[S]=$[I]+"|x|X|\\*";var D=c++;$[D]="[v=\\s]*("+$[S]+")(?:\\.("+$[S]+")(?:\\.("+$[S]+")(?:"+$[d]+")?"+$[o]+"?)?)?";var y=c++;$[y]="[v=\\s]*("+$[w]+")(?:\\.("+$[w]+")(?:\\.("+$[w]+")(?:"+$[m]+")?"+$[o]+"?)?)?";var C=c++;$[C]="^"+$[l]+"\\s*"+$[D]+"$";var A=c++;$[A]="^"+$[l]+"\\s*"+$[y]+"$";var b=c++;$[b]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var v=c++;$[v]="(?:~>?)";var L=c++;$[L]="(\\s*)"+$[v]+"\\s+",N[L]=new RegExp($[L],"g");var O=c++;$[O]="^"+$[v]+$[D]+"$";var M=c++;$[M]="^"+$[v]+$[y]+"$";var j=c++;$[j]="(?:\\^)";var z=c++;$[z]="(\\s*)"+$[j]+"\\s+",N[z]=new RegExp($[z],"g");var F=c++;$[F]="^"+$[j]+$[D]+"$";var B=c++;$[B]="^"+$[j]+$[y]+"$";var _=c++;$[_]="^"+$[l]+"\\s*("+s+")$|^$";var re=c++;$[re]="^"+$[l]+"\\s*("+i+")$|^$";var U=c++;$[U]="(\\s*)"+$[l]+"\\s*("+s+"|"+$[D]+")",N[U]=new RegExp($[U],"g");var G=c++;$[G]="^\\s*("+$[D]+")\\s+-\\s+("+$[D]+")\\s*$";var Q=c++;$[Q]="^\\s*("+$[y]+")\\s+-\\s+("+$[y]+")\\s*$";var ee=c++;$[ee]="(<|>)?=?\\s*\\*";for(var he=0;he<35;he++)P(he,$[he]),N[he]||(N[he]=new RegExp($[he]));function ne(V,J){if(V instanceof De)return V;if(typeof V!="string"||V.length>R||!(J?N[g]:N[t]).test(V))return null;try{return new De(V,J)}catch{return null}}function De(V,J){if(V instanceof De){if(V.loose===J)return V;V=V.version}else if(typeof V!="string")throw new TypeError("Invalid Version: "+V);if(V.length>R)throw new TypeError("version is longer than "+R+" characters");if(!(this instanceof De))return new De(V,J);P("SemVer",V,J),this.loose=J;var x=V.trim().match(J?N[g]:N[t]);if(!x)throw new TypeError("Invalid Version: "+V);if(this.raw=V,this.major=+x[1],this.minor=+x[2],this.patch=+x[3],this.major>T||this.major<0)throw new TypeError("Invalid major version");if(this.minor>T||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>T||this.patch<0)throw new TypeError("Invalid patch version");x[4]?this.prerelease=x[4].split(".").map(function(fe){if(/^[0-9]+$/.test(fe)){var we=+fe;if(we>=0&&we<T)return we}return fe}):this.prerelease=[],this.build=x[5]?x[5].split("."):[],this.format()}e.parse=ne,e.valid=function(V,J){var x=ne(V,J);return x?x.version:null},e.clean=function(V,J){var x=ne(V.trim().replace(/^[=v]+/,""),J);return x?x.version:null},e.SemVer=De,De.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},De.prototype.toString=function(){return this.version},De.prototype.compare=function(V){return P("SemVer.compare",this.version,this.loose,V),V instanceof De||(V=new De(V,this.loose)),this.compareMain(V)||this.comparePre(V)},De.prototype.compareMain=function(V){return V instanceof De||(V=new De(V,this.loose)),K(this.major,V.major)||K(this.minor,V.minor)||K(this.patch,V.patch)},De.prototype.comparePre=function(V){if(V instanceof De||(V=new De(V,this.loose)),this.prerelease.length&&!V.prerelease.length)return-1;if(!this.prerelease.length&&V.prerelease.length)return 1;if(!this.prerelease.length&&!V.prerelease.length)return 0;var J=0;do{var x=this.prerelease[J],fe=V.prerelease[J];if(P("prerelease compare",J,x,fe),x===void 0&&fe===void 0)return 0;if(fe===void 0)return 1;if(x===void 0)return-1;if(x!==fe)return K(x,fe)}while(++J)},De.prototype.inc=function(V,J){switch(V){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",J);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",J);break;case"prepatch":this.prerelease.length=0,this.inc("patch",J),this.inc("pre",J);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",J),this.inc("pre",J);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var x=this.prerelease.length;--x>=0;)typeof this.prerelease[x]=="number"&&(this.prerelease[x]++,x=-2);x===-1&&this.prerelease.push(0)}J&&(this.prerelease[0]===J?isNaN(this.prerelease[1])&&(this.prerelease=[J,0]):this.prerelease=[J,0]);break;default:throw new Error("invalid increment argument: "+V)}return this.format(),this.raw=this.version,this},e.inc=function(V,J,x,fe){typeof x=="string"&&(fe=x,x=void 0);try{return new De(V,x).inc(J,fe).version}catch{return null}},e.diff=function(V,J){if(te(V,J))return null;var x=ne(V),fe=ne(J);if(x.prerelease.length||fe.prerelease.length){for(var we in x)if((we==="major"||we==="minor"||we==="patch")&&x[we]!==fe[we])return"pre"+we;return"prerelease"}for(var we in x)if((we==="major"||we==="minor"||we==="patch")&&x[we]!==fe[we])return we},e.compareIdentifiers=K;var $e=/^[0-9]+$/;function K(V,J){var x=$e.test(V),fe=$e.test(J);return x&&fe&&(V=+V,J=+J),x&&!fe?-1:fe&&!x?1:V<J?-1:V>J?1:0}function W(V,J,x){return new De(V,x).compare(new De(J,x))}function se(V,J,x){return W(V,J,x)>0}function oe(V,J,x){return W(V,J,x)<0}function te(V,J,x){return W(V,J,x)===0}function le(V,J,x){return W(V,J,x)!==0}function ue(V,J,x){return W(V,J,x)>=0}function X(V,J,x){return W(V,J,x)<=0}function ae(V,J,x,fe){var we;switch(J){case"===":typeof V=="object"&&(V=V.version),typeof x=="object"&&(x=x.version),we=V===x;break;case"!==":typeof V=="object"&&(V=V.version),typeof x=="object"&&(x=x.version),we=V!==x;break;case"":case"=":case"==":we=te(V,x,fe);break;case"!=":we=le(V,x,fe);break;case">":we=se(V,x,fe);break;case">=":we=ue(V,x,fe);break;case"<":we=oe(V,x,fe);break;case"<=":we=X(V,x,fe);break;default:throw new TypeError("Invalid operator: "+J)}return we}function pe(V,J){if(V instanceof pe){if(V.loose===J)return V;V=V.value}if(!(this instanceof pe))return new pe(V,J);P("comparator",V,J),this.loose=J,this.parse(V),this.semver===be?this.value="":this.value=this.operator+this.semver.version,P("comp",this)}e.rcompareIdentifiers=function(V,J){return K(J,V)},e.major=function(V,J){return new De(V,J).major},e.minor=function(V,J){return new De(V,J).minor},e.patch=function(V,J){return new De(V,J).patch},e.compare=W,e.compareLoose=function(V,J){return W(V,J,!0)},e.rcompare=function(V,J,x){return W(J,V,x)},e.sort=function(V,J){return V.sort(function(x,fe){return e.compare(x,fe,J)})},e.rsort=function(V,J){return V.sort(function(x,fe){return e.rcompare(x,fe,J)})},e.gt=se,e.lt=oe,e.eq=te,e.neq=le,e.gte=ue,e.lte=X,e.cmp=ae,e.Comparator=pe;var be={};function Fe(V,J){if(V instanceof Fe)return V.loose===J?V:new Fe(V.raw,J);if(V instanceof pe)return new Fe(V.value,J);if(!(this instanceof Fe))return new Fe(V,J);if(this.loose=J,this.raw=V,this.set=V.split(/\s*\|\|\s*/).map(function(x){return this.parseRange(x.trim())},this).filter(function(x){return x.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+V);this.format()}function Ue(V){return!V||V.toLowerCase()==="x"||V==="*"}function ke(V,J,x,fe,we,Le,He,Ke,et,rt,ot,nt,ct){return((J=Ue(x)?"":Ue(fe)?">="+x+".0.0":Ue(we)?">="+x+"."+fe+".0":">="+J)+" "+(Ke=Ue(et)?"":Ue(rt)?"<"+(+et+1)+".0.0":Ue(ot)?"<"+et+"."+(+rt+1)+".0":nt?"<="+et+"."+rt+"."+ot+"-"+nt:"<="+Ke)).trim()}function Ie(V,J){for(var x=0;x<V.length;x++)if(!V[x].test(J))return!1;if(J.prerelease.length){for(x=0;x<V.length;x++)if(P(V[x].semver),V[x].semver!==be&&V[x].semver.prerelease.length>0){var fe=V[x].semver;if(fe.major===J.major&&fe.minor===J.minor&&fe.patch===J.patch)return!0}return!1}return!0}function Re(V,J,x){try{J=new Fe(J,x)}catch{return!1}return J.test(V)}function q(V,J,x,fe){var we,Le,He,Ke,et;switch(V=new De(V,fe),J=new Fe(J,fe),x){case">":we=se,Le=X,He=oe,Ke=">",et=">=";break;case"<":we=oe,Le=ue,He=se,Ke="<",et="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Re(V,J,fe))return!1;for(var rt=0;rt<J.set.length;++rt){var ot=J.set[rt],nt=null,ct=null;if(ot.forEach(function(mt){mt.semver===be&&(mt=new pe(">=0.0.0")),nt=nt||mt,ct=ct||mt,we(mt.semver,nt.semver,fe)?nt=mt:He(mt.semver,ct.semver,fe)&&(ct=mt)}),nt.operator===Ke||nt.operator===et||(!ct.operator||ct.operator===Ke)&&Le(V,ct.semver)||ct.operator===et&&He(V,ct.semver))return!1}return!0}pe.prototype.parse=function(V){var J=this.loose?N[_]:N[re],x=V.match(J);if(!x)throw new TypeError("Invalid comparator: "+V);this.operator=x[1],this.operator==="="&&(this.operator=""),x[2]?this.semver=new De(x[2],this.loose):this.semver=be},pe.prototype.toString=function(){return this.value},pe.prototype.test=function(V){return P("Comparator.test",V,this.loose),this.semver===be||(typeof V=="string"&&(V=new De(V,this.loose)),ae(V,this.operator,this.semver,this.loose))},pe.prototype.intersects=function(V,J){if(!(V instanceof pe))throw new TypeError("a Comparator is required");var x;if(this.operator==="")return x=new Fe(V.value,J),Re(this.value,x,J);if(V.operator==="")return x=new Fe(this.value,J),Re(V.semver,x,J);var fe=!(this.operator!==">="&&this.operator!==">"||V.operator!==">="&&V.operator!==">"),we=!(this.operator!=="<="&&this.operator!=="<"||V.operator!=="<="&&V.operator!=="<"),Le=this.semver.version===V.semver.version,He=!(this.operator!==">="&&this.operator!=="<="||V.operator!==">="&&V.operator!=="<="),Ke=ae(this.semver,"<",V.semver,J)&&(this.operator===">="||this.operator===">")&&(V.operator==="<="||V.operator==="<"),et=ae(this.semver,">",V.semver,J)&&(this.operator==="<="||this.operator==="<")&&(V.operator===">="||V.operator===">");return fe||we||Le&&He||Ke||et},e.Range=Fe,Fe.prototype.format=function(){return this.range=this.set.map(function(V){return V.join(" ").trim()}).join("||").trim(),this.range},Fe.prototype.toString=function(){return this.range},Fe.prototype.parseRange=function(V){var J=this.loose;V=V.trim(),P("range",V,J);var x=J?N[Q]:N[G];V=V.replace(x,ke),P("hyphen replace",V),V=V.replace(N[U],"$1$2$3"),P("comparator trim",V,N[U]),V=(V=(V=V.replace(N[L],"$1~")).replace(N[z],"$1^")).split(/\s+/).join(" ");var fe=J?N[_]:N[re],we=V.split(" ").map(function(Le){return function(He,Ke){return P("comp",He),He=function(et,rt){return et.trim().split(/\s+/).map(function(ot){return function(nt,ct){P("caret",nt,ct);var mt=ct?N[B]:N[F];return nt.replace(mt,function(dt,at,Pe,ze,Ze){var Te;return P("caret",nt,dt,at,Pe,ze,Ze),Ue(at)?Te="":Ue(Pe)?Te=">="+at+".0.0 <"+(+at+1)+".0.0":Ue(ze)?Te=at==="0"?">="+at+"."+Pe+".0 <"+at+"."+(+Pe+1)+".0":">="+at+"."+Pe+".0 <"+(+at+1)+".0.0":Ze?(P("replaceCaret pr",Ze),Ze.charAt(0)!=="-"&&(Ze="-"+Ze),Te=at==="0"?Pe==="0"?">="+at+"."+Pe+"."+ze+Ze+" <"+at+"."+Pe+"."+(+ze+1):">="+at+"."+Pe+"."+ze+Ze+" <"+at+"."+(+Pe+1)+".0":">="+at+"."+Pe+"."+ze+Ze+" <"+(+at+1)+".0.0"):(P("no pr"),Te=at==="0"?Pe==="0"?">="+at+"."+Pe+"."+ze+" <"+at+"."+Pe+"."+(+ze+1):">="+at+"."+Pe+"."+ze+" <"+at+"."+(+Pe+1)+".0":">="+at+"."+Pe+"."+ze+" <"+(+at+1)+".0.0"),P("caret return",Te),Te})}(ot,rt)}).join(" ")}(He,Ke),P("caret",He),He=function(et,rt){return et.trim().split(/\s+/).map(function(ot){return function(nt,ct){var mt=ct?N[M]:N[O];return nt.replace(mt,function(dt,at,Pe,ze,Ze){var Te;return P("tilde",nt,dt,at,Pe,ze,Ze),Ue(at)?Te="":Ue(Pe)?Te=">="+at+".0.0 <"+(+at+1)+".0.0":Ue(ze)?Te=">="+at+"."+Pe+".0 <"+at+"."+(+Pe+1)+".0":Ze?(P("replaceTilde pr",Ze),Ze.charAt(0)!=="-"&&(Ze="-"+Ze),Te=">="+at+"."+Pe+"."+ze+Ze+" <"+at+"."+(+Pe+1)+".0"):Te=">="+at+"."+Pe+"."+ze+" <"+at+"."+(+Pe+1)+".0",P("tilde return",Te),Te})}(ot,rt)}).join(" ")}(He,Ke),P("tildes",He),He=function(et,rt){return P("replaceXRanges",et,rt),et.split(/\s+/).map(function(ot){return function(nt,ct){nt=nt.trim();var mt=ct?N[A]:N[C];return nt.replace(mt,function(dt,at,Pe,ze,Ze,Te){P("xRange",nt,dt,at,Pe,ze,Ze,Te);var Me=Ue(Pe),Y=Me||Ue(ze),de=Y||Ue(Ze);return at==="="&&de&&(at=""),Me?dt=at===">"||at==="<"?"<0.0.0":"*":at&&de?(Y&&(ze=0),de&&(Ze=0),at===">"?(at=">=",Y?(Pe=+Pe+1,ze=0,Ze=0):de&&(ze=+ze+1,Ze=0)):at==="<="&&(at="<",Y?Pe=+Pe+1:ze=+ze+1),dt=at+Pe+"."+ze+"."+Ze):Y?dt=">="+Pe+".0.0 <"+(+Pe+1)+".0.0":de&&(dt=">="+Pe+"."+ze+".0 <"+Pe+"."+(+ze+1)+".0"),P("xRange return",dt),dt})}(ot,rt)}).join(" ")}(He,Ke),P("xrange",He),He=function(et,rt){return P("replaceStars",et,rt),et.trim().replace(N[ee],"")}(He,Ke),P("stars",He),He}(Le,J)}).join(" ").split(/\s+/);return this.loose&&(we=we.filter(function(Le){return!!Le.match(fe)})),we=we.map(function(Le){return new pe(Le,J)})},Fe.prototype.intersects=function(V,J){if(!(V instanceof Fe))throw new TypeError("a Range is required");return this.set.some(function(x){return x.every(function(fe){return V.set.some(function(we){return we.every(function(Le){return fe.intersects(Le,J)})})})})},e.toComparators=function(V,J){return new Fe(V,J).set.map(function(x){return x.map(function(fe){return fe.value}).join(" ").trim().split(" ")})},Fe.prototype.test=function(V){if(!V)return!1;typeof V=="string"&&(V=new De(V,this.loose));for(var J=0;J<this.set.length;J++)if(Ie(this.set[J],V))return!0;return!1},e.satisfies=Re,e.maxSatisfying=function(V,J,x){var fe=null,we=null;try{var Le=new Fe(J,x)}catch{return null}return V.forEach(function(He){Le.test(He)&&(fe&&we.compare(He)!==-1||(we=new De(fe=He,x)))}),fe},e.minSatisfying=function(V,J,x){var fe=null,we=null;try{var Le=new Fe(J,x)}catch{return null}return V.forEach(function(He){Le.test(He)&&(fe&&we.compare(He)!==1||(we=new De(fe=He,x)))}),fe},e.validRange=function(V,J){try{return new Fe(V,J).range||"*"}catch{return null}},e.ltr=function(V,J,x){return q(V,J,"<",x)},e.gtr=function(V,J,x){return q(V,J,">",x)},e.outside=q,e.prerelease=function(V,J){var x=ne(V,J);return x&&x.prerelease.length?x.prerelease:null},e.intersects=function(V,J,x){return V=new Fe(V,x),J=new Fe(J,x),V.intersects(J)},e.coerce=function(V){if(V instanceof De)return V;if(typeof V!="string")return null;var J=V.match(N[b]);return J==null?null:ne((J[1]||"0")+"."+(J[2]||"0")+"."+(J[3]||"0"))}}).call(this,r(1))},function(ce,e){var r,h,P=ce.exports={};function R(){throw new Error("setTimeout has not been defined")}function T(){throw new Error("clearTimeout has not been defined")}function N(f){if(r===setTimeout)return setTimeout(f,0);if((r===R||!r)&&setTimeout)return r=setTimeout,setTimeout(f,0);try{return r(f,0)}catch{try{return r.call(null,f,0)}catch{return r.call(this,f,0)}}}(function(){try{r=typeof setTimeout=="function"?setTimeout:R}catch{r=R}try{h=typeof clearTimeout=="function"?clearTimeout:T}catch{h=T}})();var $,c=[],I=!1,E=-1;function u(){I&&$&&(I=!1,$.length?c=$.concat(c):E=-1,c.length&&k())}function k(){if(!I){var f=N(u);I=!0;for(var d=c.length;d;){for($=c,c=[];++E<d;)$&&$[E].run();E=-1,d=c.length}$=null,I=!1,function(m){if(h===clearTimeout)return clearTimeout(m);if((h===T||!h)&&clearTimeout)return h=clearTimeout,clearTimeout(m);try{h(m)}catch{try{return h.call(null,m)}catch{return h.call(this,m)}}}(f)}}function p(f,d){this.fun=f,this.array=d}function a(){}P.nextTick=function(f){var d=new Array(arguments.length-1);if(arguments.length>1)for(var m=1;m<arguments.length;m++)d[m-1]=arguments[m];c.push(new p(f,d)),c.length!==1||I||N(k)},p.prototype.run=function(){this.fun.apply(null,this.array)},P.title="browser",P.browser=!0,P.env={},P.argv=[],P.version="",P.versions={},P.on=a,P.addListener=a,P.once=a,P.off=a,P.removeListener=a,P.removeAllListeners=a,P.emit=a,P.prependListener=a,P.prependOnceListener=a,P.listeners=function(f){return[]},P.binding=function(f){throw new Error("process.binding is not supported")},P.cwd=function(){return"/"},P.chdir=function(f){throw new Error("process.chdir is not supported")},P.umask=function(){return 0}}])}),define(Ee[43],ye([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ge=void 0;const r=globalThis.performance&&typeof globalThis.performance.now=="function";class h{static create(R){return new h(R)}constructor(R){this.c=r&&R===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$ge=h}),define(Ee[4],ye([1,0,14,80,3,81,43]),function(ce,e,r,h,P,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$we=e.$ve=e.$ue=e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$ie=e.Event=void 0,e.$je=k;const N=!1,$=!1,c=!1;var I;(function(M){M.None=()=>P.$Wc.None;function j(ke){if(c){const{onDidAddListener:Ie}=ke,Re=a.create();let q=0;ke.onDidAddListener=()=>{++q===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),Re.print()),Ie?.()}}}function z(ke,Ie){return ne(ke,()=>{},0,void 0,!0,void 0,Ie)}M.defer=z;function F(ke){return(Ie,Re=null,q)=>{let V=!1,J;return J=ke(x=>{if(!V)return J?J.dispose():V=!0,Ie.call(Re,x)},null,q),V&&J.dispose(),J}}M.once=F;function B(ke,Ie,Re){return ee((q,V=null,J)=>ke(x=>q.call(V,Ie(x)),null,J),Re)}M.map=B;function _(ke,Ie,Re){return ee((q,V=null,J)=>ke(x=>{Ie(x),q.call(V,x)},null,J),Re)}M.forEach=_;function re(ke,Ie,Re){return ee((q,V=null,J)=>ke(x=>Ie(x)&&q.call(V,x),null,J),Re)}M.filter=re;function U(ke){return ke}M.signal=U;function G(...ke){return(Ie,Re=null,q)=>{const V=(0,P.$Tc)(...ke.map(J=>J(x=>Ie.call(Re,x))));return he(V,q)}}M.any=G;function Q(ke,Ie,Re,q){let V=Re;return B(ke,J=>(V=Ie(V,J),V),q)}M.reduce=Q;function ee(ke,Ie){let Re;const q={onWillAddFirstListener(){Re=ke(V.fire,V)},onDidRemoveLastListener(){Re?.dispose()}};Ie||j(q);const V=new s(q);return Ie?.add(V),V.event}function he(ke,Ie){return Ie instanceof Array?Ie.push(ke):Ie&&Ie.add(ke),ke}function ne(ke,Ie,Re=100,q=!1,V=!1,J,x){let fe,we,Le,He=0,Ke;const et={leakWarningThreshold:J,onWillAddFirstListener(){fe=ke(ot=>{He++,we=Ie(we,ot),q&&!Le&&(rt.fire(we),we=void 0),Ke=()=>{const nt=we;we=void 0,Le=void 0,(!q||He>1)&&rt.fire(nt),He=0},typeof Re=="number"?(clearTimeout(Le),Le=setTimeout(Ke,Re)):Le===void 0&&(Le=0,queueMicrotask(Ke))})},onWillRemoveListener(){V&&He>0&&Ke?.()},onDidRemoveLastListener(){Ke=void 0,fe.dispose()}};x||j(et);const rt=new s(et);return x?.add(rt),rt.event}M.debounce=ne;function De(ke,Ie=0,Re){return M.debounce(ke,(q,V)=>q?(q.push(V),q):[V],Ie,void 0,!0,void 0,Re)}M.accumulate=De;function $e(ke,Ie=(q,V)=>q===V,Re){let q=!0,V;return re(ke,J=>{const x=q||!Ie(J,V);return q=!1,V=J,x},Re)}M.latch=$e;function K(ke,Ie,Re){return[M.filter(ke,Ie,Re),M.filter(ke,q=>!Ie(q),Re)]}M.split=K;function W(ke,Ie=!1,Re=[],q){let V=Re.slice(),J=ke(we=>{V?V.push(we):fe.fire(we)});q&&q.add(J);const x=()=>{V?.forEach(we=>fe.fire(we)),V=null},fe=new s({onWillAddFirstListener(){J||(J=ke(we=>fe.fire(we)),q&&q.add(J))},onDidAddFirstListener(){V&&(Ie?setTimeout(x):x())},onDidRemoveLastListener(){J&&J.dispose(),J=null}});return q&&q.add(fe),fe.event}M.buffer=W;function se(ke,Ie){return(q,V,J)=>{const x=Ie(new te);return ke(function(fe){const we=x.evaluate(fe);we!==oe&&q.call(V,we)},void 0,J)}}M.chain=se;const oe=Symbol("HaltChainable");class te{constructor(){this.f=[]}map(Ie){return this.f.push(Ie),this}forEach(Ie){return this.f.push(Re=>(Ie(Re),Re)),this}filter(Ie){return this.f.push(Re=>Ie(Re)?Re:oe),this}reduce(Ie,Re){let q=Re;return this.f.push(V=>(q=Ie(q,V),q)),this}latch(Ie=(Re,q)=>Re===q){let Re=!0,q;return this.f.push(V=>{const J=Re||!Ie(V,q);return Re=!1,q=V,J?V:oe}),this}evaluate(Ie){for(const Re of this.f)if(Ie=Re(Ie),Ie===oe)break;return Ie}}function le(ke,Ie,Re=q=>q){const q=(...fe)=>x.fire(Re(...fe)),V=()=>ke.on(Ie,q),J=()=>ke.removeListener(Ie,q),x=new s({onWillAddFirstListener:V,onDidRemoveLastListener:J});return x.event}M.fromNodeEventEmitter=le;function ue(ke,Ie,Re=q=>q){const q=(...fe)=>x.fire(Re(...fe)),V=()=>ke.addEventListener(Ie,q),J=()=>ke.removeEventListener(Ie,q),x=new s({onWillAddFirstListener:V,onDidRemoveLastListener:J});return x.event}M.fromDOMEventEmitter=ue;function X(ke){return new Promise(Ie=>F(ke)(Ie))}M.toPromise=X;function ae(ke){const Ie=new s;return ke.then(Re=>{Ie.fire(Re)},()=>{Ie.fire(void 0)}).finally(()=>{Ie.dispose()}),Ie.event}M.fromPromise=ae;function pe(ke,Ie,Re){return Ie(Re),ke(q=>Ie(q))}M.runAndSubscribe=pe;class be{constructor(Ie,Re){this._observable=Ie,this.f=0,this.g=!1;const q={onWillAddFirstListener:()=>{Ie.addObserver(this)},onDidRemoveLastListener:()=>{Ie.removeObserver(this)}};Re||j(q),this.emitter=new s(q),Re&&Re.add(this.emitter)}beginUpdate(Ie){this.f++}handlePossibleChange(Ie){}handleChange(Ie,Re){this.g=!0}endUpdate(Ie){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function Fe(ke,Ie){return new be(ke,Ie).emitter.event}M.fromObservable=Fe;function Ue(ke){return(Ie,Re,q)=>{let V=0,J=!1;const x={beginUpdate(){V++},endUpdate(){V--,V===0&&(ke.reportChanges(),J&&(J=!1,Ie.call(Re)))},handlePossibleChange(){},handleChange(){J=!0}};ke.addObserver(x),ke.reportChanges();const fe={dispose(){ke.removeObserver(x)}};return q instanceof P.$Vc?q.add(fe):Array.isArray(q)&&q.push(fe),fe}}M.fromObservableLight=Ue})(I||(e.Event=I={}));class E{static{this.all=new Set}static{this.f=0}constructor(j){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${j}_${E.f++}`,E.all.add(this)}start(j){this.g=new T.$ge,this.listenerCount=j}stop(){if(this.g){const j=this.g.elapsed();this.durations.push(j),this.elapsedOverall+=j,this.invocationCount+=1,this.g=void 0}}}e.$ie=E;let u=-1;function k(M){const j=u;return u=M,{dispose(){u=j}}}class p{static{this.f=1}constructor(j,z,F=(p.f++).toString(16).padStart(3,"0")){this.j=j,this.threshold=z,this.name=F,this.h=0}dispose(){this.g?.clear()}check(j,z){const F=this.threshold;if(F<=0||z<F)return;this.g||(this.g=new Map);const B=this.g.get(j.value)||0;if(this.g.set(j.value,B+1),this.h-=1,this.h<=0){this.h=F*.5;const[_,re]=this.getMostFrequentStack(),U=`[${this.name}] potential listener LEAK detected, having ${z} listeners already. MOST frequent listener (${re}):`;console.warn(U),console.warn(_);const G=new f(U,_);this.j(G)}return()=>{const _=this.g.get(j.value)||0;this.g.set(j.value,_-1)}}getMostFrequentStack(){if(!this.g)return;let j,z=0;for(const[F,B]of this.g)(!j||z<B)&&(j=[F,B],z=B);return j}}class a{static create(){const j=new Error;return new a(j.stack??"")}constructor(j){this.value=j}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class f extends Error{constructor(j,z){super(j),this.name="ListenerLeakError",this.stack=z}}e.$ke=f;class d extends Error{constructor(j,z){super(j),this.name="ListenerRefusalError",this.stack=z}}e.$le=d;let m=0;class n{constructor(j){this.value=j,this.id=m++}}const o=2,t=(M,j)=>{if(M instanceof n)j(M);else for(let z=0;z<M.length;z++){const F=M[z];F&&j(F)}};let i;if(N){const M=[];setInterval(()=>{M.length!==0&&(console.warn("[LEAKING LISTENERS] GC'ed these listeners that were NOT yet disposed:"),console.warn(M.join(`
`)),M.length=0)},3e3),i=new FinalizationRegistry(j=>{typeof j=="string"&&M.push(j)})}class s{constructor(j){this.z=0,this.f=j,this.g=u>0||this.f?.leakWarningThreshold?new p(j?.onListenerError??r.$3,this.f?.leakWarningThreshold??u):void 0,this.j=this.f?._profName?new E(this.f._profName):void 0,this.w=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.w?.current===this&&this.w.reset(),this.u){if($){const j=this.u;queueMicrotask(()=>{t(j,z=>z.stack?.print())})}this.u=void 0,this.z=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(j,z,F)=>{if(this.g&&this.z>this.g.threshold**2){const G=`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far (${this.z} vs ${this.g.threshold})`;console.warn(G);const Q=this.g.getMostFrequentStack()??["UNKNOWN stack",-1],ee=new d(`${G}. HINT: Stack shows most frequent listener (${Q[1]}-times)`,Q[0]);return(this.f?.onListenerError||r.$3)(ee),P.$Wc.None}if(this.m)return P.$Wc.None;z&&(j=j.bind(z));const B=new n(j);let _,re;this.g&&this.z>=Math.ceil(this.g.threshold*.2)&&(B.stack=a.create(),_=this.g.check(B.stack,this.z+1)),$&&(B.stack=re??a.create()),this.u?this.u instanceof n?(this.w??=new l,this.u=[this.u,B]):this.u.push(B):(this.f?.onWillAddFirstListener?.(this),this.u=B,this.f?.onDidAddFirstListener?.(this)),this.z++;const U=(0,P.$Uc)(()=>{i?.unregister(U),_?.(),this.A(B)});if(F instanceof P.$Vc?F.add(U):Array.isArray(F)&&F.push(U),i){const G=new Error().stack.split(`
`).slice(2,3).join(`
`).trim(),Q=/(file:|vscode-file:\/\/vscode-app)?(\/[^:]*:\d+:\d+)/.exec(G);i.register(U,Q?.[2]??G,U)}return U},this.q}A(j){if(this.f?.onWillRemoveListener?.(this),!this.u)return;if(this.z===1){this.u=void 0,this.f?.onDidRemoveLastListener?.(this),this.z=0;return}const z=this.u,F=z.indexOf(j);if(F===-1)throw console.log("disposed?",this.m),console.log("size?",this.z),console.log("arr?",JSON.stringify(this.u)),new Error("Attempted to dispose unknown listener");this.z--,z[F]=void 0;const B=this.w.current===this;if(this.z*o<=z.length){let _=0;for(let re=0;re<z.length;re++)z[re]?z[_++]=z[re]:B&&(this.w.end--,_<this.w.i&&this.w.i--);z.length=_}}B(j,z){if(!j)return;const F=this.f?.onListenerError||r.$3;if(!F){j.value(z);return}try{j.value(z)}catch(B){F(B)}}C(j){const z=j.current.u;for(;j.i<j.end;)this.B(z[j.i++],j.value);j.reset()}fire(j){if(this.w?.current&&(this.C(this.w),this.j?.stop()),this.j?.start(this.z),this.u)if(this.u instanceof n)this.B(this.u,j);else{const z=this.w;z.enqueue(this,j,this.u.length),this.C(z)}this.j?.stop()}hasListeners(){return this.z>0}}e.$me=s;const g=()=>new l;e.$ne=g;class l{constructor(){this.i=-1,this.end=0}enqueue(j,z,F){this.i=0,this.end=F,this.current=j,this.value=z}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class w extends s{async fireAsync(j,z,F){if(this.u)for(this.h||(this.h=new R.$7c),t(this.u,B=>this.h.push([B.value,j]));this.h.size>0&&!z.isCancellationRequested;){const[B,_]=this.h.shift(),re=[],U={..._,token:z,waitUntil:G=>{if(Object.isFrozen(re))throw new Error("waitUntil can NOT be called asynchronous");F&&(G=F(G,B)),re.push(G)}};try{B(U)}catch(G){(0,r.$3)(G);continue}Object.freeze(re),await Promise.allSettled(re).then(G=>{for(const Q of G)Q.status==="rejected"&&(0,r.$3)(Q.reason)})}}}e.$oe=w;class S extends s{get isPaused(){return this.h!==0}constructor(j){super(j),this.h=0,this.s=new R.$7c,this.t=j?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.t){if(this.s.size>0){const j=Array.from(this.s);this.s.clear(),super.fire(this.t(j))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(j){this.z&&(this.h!==0?this.s.push(j):super.fire(j))}}e.$pe=S;class D extends S{constructor(j){super(j),this.k=j.delay??100}fire(j){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(j)}}e.$qe=D;class y extends s{constructor(j){super(j),this.h=[],this.k=j?.merge}fire(j){this.hasListeners()&&(this.h.push(j),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(z=>super.fire(z)),this.h=[]}))}}e.$re=y;class C{constructor(){this.g=!1,this.h=[],this.f=new s({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(j){const z={event:j,listener:null};this.h.push(z),this.g&&this.m(z);const F=()=>{this.g&&this.o(z);const B=this.h.indexOf(z);this.h.splice(B,1)};return(0,P.$Uc)((0,h.$fb)(F))}j(){this.g=!0,this.h.forEach(j=>this.m(j))}k(){this.g=!1,this.h.forEach(j=>this.o(j))}m(j){j.listener=j.event(z=>this.f.fire(z))}o(j){j.listener?.dispose(),j.listener=null}dispose(){this.f.dispose();for(const j of this.h)j.listener?.dispose();this.h=[]}}e.$se=C;class A{constructor(j,z,F,B){this.f=new P.$Vc;const _=this.f.add(new C),re=this.f.add(new P.$6c);function U(G){re.set(G,_.add(B(G)))}for(const G of j)U(G);this.f.add(z(G=>{U(G)})),this.f.add(F(G=>{re.deleteAndDispose(G)})),this.event=_.event}dispose(){this.f.dispose()}}e.$te=A;class b{constructor(){this.f=[]}wrapEvent(j,z,F){return(B,_,re)=>j(U=>{const G=this.f[this.f.length-1];if(!z){G?G.buffers.push(()=>B.call(_,U)):B.call(_,U);return}const Q=G;if(!Q){B.call(_,z(F,U));return}Q.items??=[],Q.items.push(U),Q.buffers.length===0&&G.buffers.push(()=>{Q.reducedResult??=F?Q.items.reduce(z,F):Q.items.reduce(z),B.call(_,Q.reducedResult)})},void 0,re)}bufferEvents(j){const z={buffers:new Array};this.f.push(z);const F=j();return this.f.pop(),z.buffers.forEach(B=>B()),F}}e.$ue=b;class v{constructor(){this.f=!1,this.g=I.None,this.h=P.$Wc.None,this.j=new s({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(j){this.g=j,this.f&&(this.h.dispose(),this.h=j(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$ve=v;class L{static const(j){return new O(j)}constructor(j){this.g=j,this.f=new s,this.onDidChange=this.f.event}get value(){return this.g}set value(j){j!==this.g&&(this.g=j,this.f.fire(void 0))}}e.$we=L;class O{constructor(j){this.value=j,this.onDidChange=I.None}}}),define(Ee[21],ye([1,0,4]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xe=e.CancellationToken=void 0,e.$ye=N;const h=Object.freeze(function($,c){const I=setTimeout($.bind(c),0);return{dispose(){clearTimeout(I)}}});var P;(function($){function c(I){return I===$.None||I===$.Cancelled||I instanceof R?!0:!I||typeof I!="object"?!1:typeof I.isCancellationRequested=="boolean"&&typeof I.onCancellationRequested=="function"}$.isCancellationToken=c,$.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:r.Event.None}),$.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:h})})(P||(e.CancellationToken=P={}));class R{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?h:(this.b||(this.b=new r.$me),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class T{constructor(c){this.f=void 0,this.g=void 0,this.g=c&&c.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new R),this.f}cancel(){this.f?this.f instanceof R&&this.f.cancel():this.f=P.Cancelled}dispose(c=!1){c&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof R&&this.f.dispose():this.f=P.None}}e.$xe=T;function N($){const c=new T;return $.add({dispose(){c.cancel()}}),c.token}}),define(Ee[182],ye([1,0,21]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$af=e.$_e=e.$0e=void 0,e.$$e=P;class h{constructor($){this.b=$,this.a=null}get(){if(this.a)return this.a;const $=new r.$xe,c=this.b($.token);return this.a={promise:c,dispose:()=>{this.a=null,$.cancel(),$.dispose()}},this.a}}e.$0e=h;function P(N){return N}class R{constructor($,c){this.a=void 0,this.b=void 0,typeof $=="function"?(this.c=$,this.d=P):(this.c=c,this.d=$.getCacheKey)}get($){const c=this.d($);return this.b!==c&&(this.b=c,this.a=this.c($)),this.a}}e.$_e=R;class T{get cachedValues(){return this.a}constructor($,c){this.a=new Map,this.b=new Map,typeof $=="function"?(this.c=$,this.d=P):(this.c=c,this.d=$.getCacheKey)}get($){const c=this.d($);if(this.b.has(c))return this.b.get(c);const I=this.c($);return this.a.set($,I),this.b.set(c,I),I}}e.$af=T}),define(Ee[183],ye([1,0,4,3]),function(ce,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_s=e.$$s=e.$0s=e.$9s=e.ScrollbarVisibility=void 0;var P;(function(k){k[k.Auto=1]="Auto",k[k.Hidden=2]="Hidden",k[k.Visible=3]="Visible"})(P||(e.ScrollbarVisibility=P={}));class R{constructor(p,a,f,d,m,n,o){this.c=p,this._scrollStateBrand=void 0,this.c&&(a=a|0,f=f|0,d=d|0,m=m|0,n=n|0,o=o|0),this.rawScrollLeft=d,this.rawScrollTop=o,a<0&&(a=0),d+a>f&&(d=f-a),d<0&&(d=0),m<0&&(m=0),o+m>n&&(o=n-m),o<0&&(o=0),this.width=a,this.scrollWidth=f,this.scrollLeft=d,this.height=m,this.scrollHeight=n,this.scrollTop=o}equals(p){return this.rawScrollLeft===p.rawScrollLeft&&this.rawScrollTop===p.rawScrollTop&&this.width===p.width&&this.scrollWidth===p.scrollWidth&&this.scrollLeft===p.scrollLeft&&this.height===p.height&&this.scrollHeight===p.scrollHeight&&this.scrollTop===p.scrollTop}withScrollDimensions(p,a){return new R(this.c,typeof p.width<"u"?p.width:this.width,typeof p.scrollWidth<"u"?p.scrollWidth:this.scrollWidth,a?this.rawScrollLeft:this.scrollLeft,typeof p.height<"u"?p.height:this.height,typeof p.scrollHeight<"u"?p.scrollHeight:this.scrollHeight,a?this.rawScrollTop:this.scrollTop)}withScrollPosition(p){return new R(this.c,this.width,this.scrollWidth,typeof p.scrollLeft<"u"?p.scrollLeft:this.rawScrollLeft,this.height,this.scrollHeight,typeof p.scrollTop<"u"?p.scrollTop:this.rawScrollTop)}createScrollEvent(p,a){const f=this.width!==p.width,d=this.scrollWidth!==p.scrollWidth,m=this.scrollLeft!==p.scrollLeft,n=this.height!==p.height,o=this.scrollHeight!==p.scrollHeight,t=this.scrollTop!==p.scrollTop;return{inSmoothScrolling:a,oldWidth:p.width,oldScrollWidth:p.scrollWidth,oldScrollLeft:p.scrollLeft,width:this.width,scrollWidth:this.scrollWidth,scrollLeft:this.scrollLeft,oldHeight:p.height,oldScrollHeight:p.scrollHeight,oldScrollTop:p.scrollTop,height:this.height,scrollHeight:this.scrollHeight,scrollTop:this.scrollTop,widthChanged:f,scrollWidthChanged:d,scrollLeftChanged:m,heightChanged:n,scrollHeightChanged:o,scrollTopChanged:t}}}e.$9s=R;class T extends h.$Wc{constructor(p){super(),this._scrollableBrand=void 0,this.j=this.B(new r.$me),this.onScroll=this.j.event,this.c=p.smoothScrollDuration,this.f=p.scheduleAtNextAnimationFrame,this.g=new R(p.forceIntegerValues,0,0,0,0,0,0),this.h=null}dispose(){this.h&&(this.h.dispose(),this.h=null),super.dispose()}setSmoothScrollDuration(p){this.c=p}validateScrollPosition(p){return this.g.withScrollPosition(p)}getScrollDimensions(){return this.g}setScrollDimensions(p,a){const f=this.g.withScrollDimensions(p,a);this.n(f,!!this.h),this.h?.acceptScrollDimensions(this.g)}getFutureScrollPosition(){return this.h?this.h.to:this.g}getCurrentScrollPosition(){return this.g}setScrollPositionNow(p){const a=this.g.withScrollPosition(p);this.h&&(this.h.dispose(),this.h=null),this.n(a,!1)}setScrollPositionSmooth(p,a){if(this.c===0)return this.setScrollPositionNow(p);if(this.h){p={scrollLeft:typeof p.scrollLeft>"u"?this.h.to.scrollLeft:p.scrollLeft,scrollTop:typeof p.scrollTop>"u"?this.h.to.scrollTop:p.scrollTop};const f=this.g.withScrollPosition(p);if(this.h.to.scrollLeft===f.scrollLeft&&this.h.to.scrollTop===f.scrollTop)return;let d;a?d=new I(this.h.from,f,this.h.startTime,this.h.duration):d=this.h.combine(this.g,f,this.c),this.h.dispose(),this.h=d}else{const f=this.g.withScrollPosition(p);this.h=I.start(this.g,f,this.c)}this.h.animationFrameDisposable=this.f(()=>{this.h&&(this.h.animationFrameDisposable=null,this.m())})}hasPendingScrollAnimation(){return!!this.h}m(){if(!this.h)return;const p=this.h.tick(),a=this.g.withScrollPosition(p);if(this.n(a,!0),!!this.h){if(p.isDone){this.h.dispose(),this.h=null;return}this.h.animationFrameDisposable=this.f(()=>{this.h&&(this.h.animationFrameDisposable=null,this.m())})}}n(p,a){const f=this.g;f.equals(p)||(this.g=p,this.j.fire(this.g.createScrollEvent(f,a)))}}e.$0s=T;class N{constructor(p,a,f){this.scrollLeft=p,this.scrollTop=a,this.isDone=f}}e.$$s=N;function $(k,p){const a=p-k;return function(f){return k+a*u(f)}}function c(k,p,a){return function(f){return f<a?k(f/a):p((f-a)/(1-a))}}class I{constructor(p,a,f,d){this.from=p,this.to=a,this.duration=d,this.startTime=f,this.animationFrameDisposable=null,this.e()}e(){this.c=this.f(this.from.scrollLeft,this.to.scrollLeft,this.to.width),this.d=this.f(this.from.scrollTop,this.to.scrollTop,this.to.height)}f(p,a,f){if(Math.abs(p-a)>2.5*f){let m,n;return p<a?(m=p+.75*f,n=a-.75*f):(m=p-.75*f,n=a+.75*f),c($(p,m),$(n,a),.33)}return $(p,a)}dispose(){this.animationFrameDisposable!==null&&(this.animationFrameDisposable.dispose(),this.animationFrameDisposable=null)}acceptScrollDimensions(p){this.to=p.withScrollPosition(this.to),this.e()}tick(){return this.g(Date.now())}g(p){const a=(p-this.startTime)/this.duration;if(a<1){const f=this.c(a),d=this.d(a);return new N(f,d,!1)}return new N(this.to.scrollLeft,this.to.scrollTop,!0)}combine(p,a,f){return I.start(p,a,f)}static start(p,a,f){f=f+10;const d=Date.now()-10;return new I(p,a,d,f)}}e.$_s=I;function E(k){return Math.pow(k,3)}function u(k){return 1-E(1-k)}}),define(Ee[104],ye([1,0,14,3]),function(ce,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ze=P,e.$Ae=R,e.$Be=T,e.$Ce=N,e.$De=c,e.$Ee=I,e.$Fe=E,e.$Ge=u,e.$He=k,e.$Ie=p,e.$Je=a,e.$Ke=f,e.$Le=d,e.$Me=m,e.$Ne=n;function P(o){const t=o;return t?typeof t.read=="function":!1}function R(o){const t=o;return t?[t.on,t.pause,t.resume,t.destroy].every(i=>typeof i=="function"):!1}function T(o){const t=o;return t?R(t.stream)&&Array.isArray(t.buffer)&&typeof t.ended=="boolean":!1}function N(o,t){return new $(o,t)}class ${constructor(t,i){this.e=t,this.f=i,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(t){if(!this.a.destroyed){if(this.a.flowing)this.g(t);else if(this.b.data.push(t),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(i=>this.d.push(i))}}error(t){this.a.destroyed||(this.a.flowing?this.h(t):this.b.error.push(t))}end(t){this.a.destroyed||(typeof t<"u"&&this.write(t),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(t){this.c.data.slice(0).forEach(i=>i(t))}h(t){this.c.error.length===0?(0,r.$3)(t):this.c.error.slice(0).forEach(i=>i(t))}i(){this.c.end.slice(0).forEach(t=>t())}on(t,i){if(!this.a.destroyed)switch(t){case"data":this.c.data.push(i),this.resume();break;case"end":this.c.end.push(i),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(i),this.a.flowing&&this.k();break}}removeListener(t,i){if(this.a.destroyed)return;let s;switch(t){case"data":s=this.c.data;break;case"end":s=this.c.end;break;case"error":s=this.c.error;break}if(s){const g=s.indexOf(i);g>=0&&s.splice(g,1)}}j(){if(this.b.data.length>0){const t=this.e(this.b.data);this.g(t),this.b.data.length=0;const i=[...this.d];this.d.length=0,i.forEach(s=>s())}}k(){if(this.c.error.length>0){for(const t of this.b.error)this.h(t);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function c(o,t){const i=[];let s;for(;(s=o.read())!==null;)i.push(s);return t(i)}function I(o,t,i){const s=[];let g;for(;(g=o.read())!==null&&s.length<i;)s.push(g);return g===null&&s.length>0?t(s):{read:()=>{if(s.length>0)return s.shift();if(typeof g<"u"){const l=g;return g=void 0,l}return o.read()}}}function E(o,t){return new Promise((i,s)=>{const g=[];u(o,{onData:l=>{t&&g.push(l)},onError:l=>{t?s(l):i(void 0)},onEnd:()=>{i(t?t(g):void 0)}})})}function u(o,t,i){o.on("error",s=>{i?.isCancellationRequested||t.onError(s)}),o.on("end",()=>{i?.isCancellationRequested||t.onEnd()}),o.on("data",s=>{i?.isCancellationRequested||t.onData(s)})}function k(o,t){return new Promise((i,s)=>{const g=new h.$Vc,l=[],w=y=>{if(l.push(y),l.length>t)return g.dispose(),o.pause(),i({stream:o,buffer:l,ended:!1})},S=y=>(g.dispose(),s(y)),D=()=>(g.dispose(),i({stream:o,buffer:l,ended:!0}));g.add((0,h.$Uc)(()=>o.removeListener("error",S))),o.on("error",S),g.add((0,h.$Uc)(()=>o.removeListener("end",D))),o.on("end",D),g.add((0,h.$Uc)(()=>o.removeListener("data",w))),o.on("data",w)})}function p(o,t){const i=N(t);return i.end(o),i}function a(){const o=N(()=>{throw new Error("not supported")});return o.end(),o}function f(o){let t=!1;return{read:()=>t?null:(t=!0,o)}}function d(o,t,i){const s=N(i);return u(o,{onData:g=>s.write(t.data(g)),onError:g=>s.error(t.error?t.error(g):g),onEnd:()=>s.end()}),s}function m(o,t,i){let s=!1;return{read:()=>{const g=t.read();return s?g:(s=!0,g!==null?i([o,g]):o)}}}function n(o,t,i){let s=!1;const g=N(i);return u(t,{onData:l=>s?g.write(l):(s=!0,g.write(i([o,l]))),onError:l=>g.error(l),onEnd:()=>{s||(s=!0,g.write(o)),g.end()}}),g}}),define(Ee[22],ye([1,0,49,104]),function(ce,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oe=void 0,e.$Pe=c,e.$Qe=I,e.$Re=E,e.$Se=u,e.$Te=k,e.$Ue=p,e.$Ve=a,e.$We=f,e.$Xe=d,e.$Ye=m,e.$Ze=n,e.$1e=o,e.$2e=t,e.$3e=i,e.$4e=s,e.$5e=g,e.$6e=l,e.$7e=w,e.$8e=S,e.$9e=C,h=We(h);const P=typeof Buffer<"u",R=new r.$X(()=>new Uint8Array(256));let T,N;class ${static alloc(b){return P?new $(Buffer.allocUnsafe(b)):new $(new Uint8Array(b))}static wrap(b){return P&&!Buffer.isBuffer(b)&&(b=Buffer.from(b.buffer,b.byteOffset,b.byteLength)),new $(b)}static fromString(b,v){return!(v?.dontUseNodeBuffer||!1)&&P?new $(Buffer.from(b)):(T||(T=new TextEncoder),new $(T.encode(b)))}static fromByteArray(b){const v=$.alloc(b.length);for(let L=0,O=b.length;L<O;L++)v.buffer[L]=b[L];return v}static concat(b,v){if(typeof v>"u"){v=0;for(let M=0,j=b.length;M<j;M++)v+=b[M].byteLength}const L=$.alloc(v);let O=0;for(let M=0,j=b.length;M<j;M++){const z=b[M];L.set(z,O),O+=z.byteLength}return L}constructor(b){this.buffer=b,this.byteLength=this.buffer.byteLength}clone(){const b=$.alloc(this.byteLength);return b.set(this),b}toString(){return P?this.buffer.toString():(N||(N=new TextDecoder),N.decode(this.buffer))}slice(b,v){return new $(this.buffer.subarray(b,v))}set(b,v){if(b instanceof $)this.buffer.set(b.buffer,v);else if(b instanceof Uint8Array)this.buffer.set(b,v);else if(b instanceof ArrayBuffer)this.buffer.set(new Uint8Array(b),v);else if(ArrayBuffer.isView(b))this.buffer.set(new Uint8Array(b.buffer,b.byteOffset,b.byteLength),v);else throw new Error("Unknown argument 'array'")}readUInt32BE(b){return u(this.buffer,b)}writeUInt32BE(b,v){k(this.buffer,b,v)}readUInt32LE(b){return p(this.buffer,b)}writeUInt32LE(b,v){a(this.buffer,b,v)}readUInt8(b){return f(this.buffer,b)}writeUInt8(b,v){d(this.buffer,b,v)}indexOf(b,v=0){return c(this.buffer,b instanceof $?b.buffer:b,v)}}e.$Oe=$;function c(A,b,v=0){const L=b.byteLength,O=A.byteLength;if(L===0)return 0;if(L===1)return A.indexOf(b[0]);if(L>O-v)return-1;const M=R.value;M.fill(b.length);for(let B=0;B<b.length;B++)M[b[B]]=b.length-B-1;let j=v+b.length-1,z=j,F=-1;for(;j<O;)if(A[j]===b[z]){if(z===0){F=j;break}j--,z--}else j+=Math.max(b.length-z,M[A[j]]),z=b.length-1;return F}function I(A,b){return A[b+0]<<0>>>0|A[b+1]<<8>>>0}function E(A,b,v){A[v+0]=b&255,b=b>>>8,A[v+1]=b&255}function u(A,b){return A[b]*2**24+A[b+1]*2**16+A[b+2]*2**8+A[b+3]}function k(A,b,v){A[v+3]=b,b=b>>>8,A[v+2]=b,b=b>>>8,A[v+1]=b,b=b>>>8,A[v]=b}function p(A,b){return A[b+0]<<0>>>0|A[b+1]<<8>>>0|A[b+2]<<16>>>0|A[b+3]<<24>>>0}function a(A,b,v){A[v+0]=b&255,b=b>>>8,A[v+1]=b&255,b=b>>>8,A[v+2]=b&255,b=b>>>8,A[v+3]=b&255}function f(A,b){return A[b]}function d(A,b,v){A[v]=b}function m(A){return h.$De(A,b=>$.concat(b))}function n(A){return h.$Ke(A)}function o(A){return h.$Fe(A,b=>$.concat(b))}async function t(A){return A.ended?$.concat(A.buffer):$.concat([...A.buffer,await o(A.stream)])}function i(A){return h.$Ie(A,b=>$.concat(b))}function s(A){return h.$Le(A,{data:b=>typeof b=="string"?$.fromString(b):$.wrap(b)},b=>$.concat(b))}function g(A){return h.$Ce(b=>$.concat(b),A)}function l(A,b){return h.$Me(A,b,v=>$.concat(v))}function w(A,b){return h.$Ne(A,b,v=>$.concat(v))}function S(A){let b=0,v=0,L=0;const O=new Uint8Array(Math.floor(A.length/4*3)),M=z=>{switch(v){case 3:O[L++]=b|z,v=0;break;case 2:O[L++]=b|z>>>2,b=z<<6,v=3;break;case 1:O[L++]=b|z>>>4,b=z<<4,v=2;break;default:b=z<<2,v=1}};for(let z=0;z<A.length;z++){const F=A.charCodeAt(z);if(F>=65&&F<=90)M(F-65);else if(F>=97&&F<=122)M(F-97+26);else if(F>=48&&F<=57)M(F-48+52);else if(F===43||F===45)M(62);else if(F===47||F===95)M(63);else{if(F===61)break;throw new SyntaxError(`Unexpected base64 character ${A[z]}`)}}const j=L;for(;v>0;)M(0);return $.wrap(O).slice(0,j)}const D="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",y="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function C({buffer:A},b=!0,v=!1){const L=v?y:D;let O="";const M=A.byteLength%3;let j=0;for(;j<A.byteLength-M;j+=3){const z=A[j+0],F=A[j+1],B=A[j+2];O+=L[z>>>2],O+=L[(z<<4|F>>>4)&63],O+=L[(F<<2|B>>>6)&63],O+=L[B&63]}if(M===1){const z=A[j+0];O+=L[z>>>2],O+=L[z<<4&63],b&&(O+="==")}else if(M===2){const z=A[j+0],F=A[j+1];O+=L[z>>>2],O+=L[(z<<4|F>>>4)&63],O+=L[F<<2&63],b&&(O+="=")}return O}}),define(Ee[184],ye([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$he=void 0,e.$he=Symbol("MicrotaskDelay")}),define(Ee[18],ye([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fg=r,e.$gg=h,e.$hg=P,e.$ig=R,e.$jg=T,e.$kg=N,e.$lg=$,e.$mg=c,e.$ng=I,e.$og=E,e.$pg=u,e.$qg=k,e.$rg=p,e.$sg=f,e.$tg=d,e.$ug=m,e.$vg=n,e.$wg=o;function r(t){return typeof t=="string"}function h(t){return Array.isArray(t)&&t.every(i=>r(i))}function P(t){return typeof t=="object"&&t!==null&&!Array.isArray(t)&&!(t instanceof RegExp)&&!(t instanceof Date)}function R(t){const i=Object.getPrototypeOf(Uint8Array);return typeof t=="object"&&t instanceof i}function T(t){return typeof t=="number"&&!isNaN(t)}function N(t){return!!t&&typeof t[Symbol.iterator]=="function"}function $(t){return t===!0||t===!1}function c(t){return typeof t>"u"}function I(t){return!E(t)}function E(t){return c(t)||t===null}function u(t,i){if(!t)throw new Error(i?`Unexpected type, expected '${i}'`:"Unexpected type")}function k(t){if(E(t))throw new Error("Assertion Failed: argument is undefined or null");return t}function p(...t){const i=[];for(let s=0;s<t.length;s++){const g=t[s];if(E(g))throw new Error(`Assertion Failed: argument at index ${s} is undefined or null`);i.push(g)}return i}const a=Object.prototype.hasOwnProperty;function f(t){if(!P(t))return!1;for(const i in t)if(a.call(t,i))return!1;return!0}function d(t){return typeof t=="function"}function m(...t){return t.length>0&&t.every(d)}function n(t,i){const s=Math.min(t.length,i.length);for(let g=0;g<s;g++)o(t[g],i[g])}function o(t,i){if(r(i)){if(typeof t!==i)throw new Error(`argument does not match constraint: typeof ${i}`)}else if(d(i)){try{if(t instanceof i)return}catch{}if(!E(t)&&t.constructor===i||i.length===1&&i.call(void 0,t)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}}),define(Ee[105],ye([1,0,18]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zj=P,e.$1j=R;const h=Object.create(null);function P(T,N){if((0,r.$fg)(N)){const $=h[N];if($===void 0)throw new Error(`${T} references an unknown codicon: ${N}`);N=$}return h[T]=N,{id:T}}function R(){return h}}),define(Ee[185],ye([1,0,105]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2j=void 0,e.$2j={add:(0,r.$Zj)("add",6e4),plus:(0,r.$Zj)("plus",6e4),gistNew:(0,r.$Zj)("gist-new",6e4),repoCreate:(0,r.$Zj)("repo-create",6e4),lightbulb:(0,r.$Zj)("lightbulb",60001),lightBulb:(0,r.$Zj)("light-bulb",60001),repo:(0,r.$Zj)("repo",60002),repoDelete:(0,r.$Zj)("repo-delete",60002),gistFork:(0,r.$Zj)("gist-fork",60003),repoForked:(0,r.$Zj)("repo-forked",60003),gitPullRequest:(0,r.$Zj)("git-pull-request",60004),gitPullRequestAbandoned:(0,r.$Zj)("git-pull-request-abandoned",60004),recordKeys:(0,r.$Zj)("record-keys",60005),keyboard:(0,r.$Zj)("keyboard",60005),tag:(0,r.$Zj)("tag",60006),gitPullRequestLabel:(0,r.$Zj)("git-pull-request-label",60006),tagAdd:(0,r.$Zj)("tag-add",60006),tagRemove:(0,r.$Zj)("tag-remove",60006),person:(0,r.$Zj)("person",60007),personFollow:(0,r.$Zj)("person-follow",60007),personOutline:(0,r.$Zj)("person-outline",60007),personFilled:(0,r.$Zj)("person-filled",60007),gitBranch:(0,r.$Zj)("git-branch",60008),gitBranchCreate:(0,r.$Zj)("git-branch-create",60008),gitBranchDelete:(0,r.$Zj)("git-branch-delete",60008),sourceControl:(0,r.$Zj)("source-control",60008),mirror:(0,r.$Zj)("mirror",60009),mirrorPublic:(0,r.$Zj)("mirror-public",60009),star:(0,r.$Zj)("star",60010),starAdd:(0,r.$Zj)("star-add",60010),starDelete:(0,r.$Zj)("star-delete",60010),starEmpty:(0,r.$Zj)("star-empty",60010),comment:(0,r.$Zj)("comment",60011),commentAdd:(0,r.$Zj)("comment-add",60011),alert:(0,r.$Zj)("alert",60012),warning:(0,r.$Zj)("warning",60012),search:(0,r.$Zj)("search",60013),searchSave:(0,r.$Zj)("search-save",60013),logOut:(0,r.$Zj)("log-out",60014),signOut:(0,r.$Zj)("sign-out",60014),logIn:(0,r.$Zj)("log-in",60015),signIn:(0,r.$Zj)("sign-in",60015),eye:(0,r.$Zj)("eye",60016),eyeUnwatch:(0,r.$Zj)("eye-unwatch",60016),eyeWatch:(0,r.$Zj)("eye-watch",60016),circleFilled:(0,r.$Zj)("circle-filled",60017),primitiveDot:(0,r.$Zj)("primitive-dot",60017),closeDirty:(0,r.$Zj)("close-dirty",60017),debugBreakpoint:(0,r.$Zj)("debug-breakpoint",60017),debugBreakpointDisabled:(0,r.$Zj)("debug-breakpoint-disabled",60017),debugHint:(0,r.$Zj)("debug-hint",60017),terminalDecorationSuccess:(0,r.$Zj)("terminal-decoration-success",60017),primitiveSquare:(0,r.$Zj)("primitive-square",60018),edit:(0,r.$Zj)("edit",60019),pencil:(0,r.$Zj)("pencil",60019),info:(0,r.$Zj)("info",60020),issueOpened:(0,r.$Zj)("issue-opened",60020),gistPrivate:(0,r.$Zj)("gist-private",60021),gitForkPrivate:(0,r.$Zj)("git-fork-private",60021),lock:(0,r.$Zj)("lock",60021),mirrorPrivate:(0,r.$Zj)("mirror-private",60021),close:(0,r.$Zj)("close",60022),removeClose:(0,r.$Zj)("remove-close",60022),x:(0,r.$Zj)("x",60022),repoSync:(0,r.$Zj)("repo-sync",60023),sync:(0,r.$Zj)("sync",60023),clone:(0,r.$Zj)("clone",60024),desktopDownload:(0,r.$Zj)("desktop-download",60024),beaker:(0,r.$Zj)("beaker",60025),microscope:(0,r.$Zj)("microscope",60025),vm:(0,r.$Zj)("vm",60026),deviceDesktop:(0,r.$Zj)("device-desktop",60026),file:(0,r.$Zj)("file",60027),fileText:(0,r.$Zj)("file-text",60027),more:(0,r.$Zj)("more",60028),ellipsis:(0,r.$Zj)("ellipsis",60028),kebabHorizontal:(0,r.$Zj)("kebab-horizontal",60028),mailReply:(0,r.$Zj)("mail-reply",60029),reply:(0,r.$Zj)("reply",60029),organization:(0,r.$Zj)("organization",60030),organizationFilled:(0,r.$Zj)("organization-filled",60030),organizationOutline:(0,r.$Zj)("organization-outline",60030),newFile:(0,r.$Zj)("new-file",60031),fileAdd:(0,r.$Zj)("file-add",60031),newFolder:(0,r.$Zj)("new-folder",60032),fileDirectoryCreate:(0,r.$Zj)("file-directory-create",60032),trash:(0,r.$Zj)("trash",60033),trashcan:(0,r.$Zj)("trashcan",60033),history:(0,r.$Zj)("history",60034),clock:(0,r.$Zj)("clock",60034),folder:(0,r.$Zj)("folder",60035),fileDirectory:(0,r.$Zj)("file-directory",60035),symbolFolder:(0,r.$Zj)("symbol-folder",60035),logoGithub:(0,r.$Zj)("logo-github",60036),markGithub:(0,r.$Zj)("mark-github",60036),github:(0,r.$Zj)("github",60036),terminal:(0,r.$Zj)("terminal",60037),console:(0,r.$Zj)("console",60037),repl:(0,r.$Zj)("repl",60037),zap:(0,r.$Zj)("zap",60038),symbolEvent:(0,r.$Zj)("symbol-event",60038),error:(0,r.$Zj)("error",60039),stop:(0,r.$Zj)("stop",60039),variable:(0,r.$Zj)("variable",60040),symbolVariable:(0,r.$Zj)("symbol-variable",60040),array:(0,r.$Zj)("array",60042),symbolArray:(0,r.$Zj)("symbol-array",60042),symbolModule:(0,r.$Zj)("symbol-module",60043),symbolPackage:(0,r.$Zj)("symbol-package",60043),symbolNamespace:(0,r.$Zj)("symbol-namespace",60043),symbolObject:(0,r.$Zj)("symbol-object",60043),symbolMethod:(0,r.$Zj)("symbol-method",60044),symbolFunction:(0,r.$Zj)("symbol-function",60044),symbolConstructor:(0,r.$Zj)("symbol-constructor",60044),symbolBoolean:(0,r.$Zj)("symbol-boolean",60047),symbolNull:(0,r.$Zj)("symbol-null",60047),symbolNumeric:(0,r.$Zj)("symbol-numeric",60048),symbolNumber:(0,r.$Zj)("symbol-number",60048),symbolStructure:(0,r.$Zj)("symbol-structure",60049),symbolStruct:(0,r.$Zj)("symbol-struct",60049),symbolParameter:(0,r.$Zj)("symbol-parameter",60050),symbolTypeParameter:(0,r.$Zj)("symbol-type-parameter",60050),symbolKey:(0,r.$Zj)("symbol-key",60051),symbolText:(0,r.$Zj)("symbol-text",60051),symbolReference:(0,r.$Zj)("symbol-reference",60052),goToFile:(0,r.$Zj)("go-to-file",60052),symbolEnum:(0,r.$Zj)("symbol-enum",60053),symbolValue:(0,r.$Zj)("symbol-value",60053),symbolRuler:(0,r.$Zj)("symbol-ruler",60054),symbolUnit:(0,r.$Zj)("symbol-unit",60054),activateBreakpoints:(0,r.$Zj)("activate-breakpoints",60055),archive:(0,r.$Zj)("archive",60056),arrowBoth:(0,r.$Zj)("arrow-both",60057),arrowDown:(0,r.$Zj)("arrow-down",60058),arrowLeft:(0,r.$Zj)("arrow-left",60059),arrowRight:(0,r.$Zj)("arrow-right",60060),arrowSmallDown:(0,r.$Zj)("arrow-small-down",60061),arrowSmallLeft:(0,r.$Zj)("arrow-small-left",60062),arrowSmallRight:(0,r.$Zj)("arrow-small-right",60063),arrowSmallUp:(0,r.$Zj)("arrow-small-up",60064),arrowUp:(0,r.$Zj)("arrow-up",60065),bell:(0,r.$Zj)("bell",60066),bold:(0,r.$Zj)("bold",60067),book:(0,r.$Zj)("book",60068),bookmark:(0,r.$Zj)("bookmark",60069),debugBreakpointConditionalUnverified:(0,r.$Zj)("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:(0,r.$Zj)("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:(0,r.$Zj)("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:(0,r.$Zj)("debug-breakpoint-data-unverified",60072),debugBreakpointData:(0,r.$Zj)("debug-breakpoint-data",60073),debugBreakpointDataDisabled:(0,r.$Zj)("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:(0,r.$Zj)("debug-breakpoint-log-unverified",60074),debugBreakpointLog:(0,r.$Zj)("debug-breakpoint-log",60075),debugBreakpointLogDisabled:(0,r.$Zj)("debug-breakpoint-log-disabled",60075),briefcase:(0,r.$Zj)("briefcase",60076),broadcast:(0,r.$Zj)("broadcast",60077),browser:(0,r.$Zj)("browser",60078),bug:(0,r.$Zj)("bug",60079),calendar:(0,r.$Zj)("calendar",60080),caseSensitive:(0,r.$Zj)("case-sensitive",60081),check:(0,r.$Zj)("check",60082),checklist:(0,r.$Zj)("checklist",60083),chevronDown:(0,r.$Zj)("chevron-down",60084),chevronLeft:(0,r.$Zj)("chevron-left",60085),chevronRight:(0,r.$Zj)("chevron-right",60086),chevronUp:(0,r.$Zj)("chevron-up",60087),chromeClose:(0,r.$Zj)("chrome-close",60088),chromeMaximize:(0,r.$Zj)("chrome-maximize",60089),chromeMinimize:(0,r.$Zj)("chrome-minimize",60090),chromeRestore:(0,r.$Zj)("chrome-restore",60091),circleOutline:(0,r.$Zj)("circle-outline",60092),circle:(0,r.$Zj)("circle",60092),debugBreakpointUnverified:(0,r.$Zj)("debug-breakpoint-unverified",60092),terminalDecorationIncomplete:(0,r.$Zj)("terminal-decoration-incomplete",60092),circleSlash:(0,r.$Zj)("circle-slash",60093),circuitBoard:(0,r.$Zj)("circuit-board",60094),clearAll:(0,r.$Zj)("clear-all",60095),clippy:(0,r.$Zj)("clippy",60096),closeAll:(0,r.$Zj)("close-all",60097),cloudDownload:(0,r.$Zj)("cloud-download",60098),cloudUpload:(0,r.$Zj)("cloud-upload",60099),code:(0,r.$Zj)("code",60100),collapseAll:(0,r.$Zj)("collapse-all",60101),colorMode:(0,r.$Zj)("color-mode",60102),commentDiscussion:(0,r.$Zj)("comment-discussion",60103),creditCard:(0,r.$Zj)("credit-card",60105),dash:(0,r.$Zj)("dash",60108),dashboard:(0,r.$Zj)("dashboard",60109),database:(0,r.$Zj)("database",60110),debugContinue:(0,r.$Zj)("debug-continue",60111),debugDisconnect:(0,r.$Zj)("debug-disconnect",60112),debugPause:(0,r.$Zj)("debug-pause",60113),debugRestart:(0,r.$Zj)("debug-restart",60114),debugStart:(0,r.$Zj)("debug-start",60115),debugStepInto:(0,r.$Zj)("debug-step-into",60116),debugStepOut:(0,r.$Zj)("debug-step-out",60117),debugStepOver:(0,r.$Zj)("debug-step-over",60118),debugStop:(0,r.$Zj)("debug-stop",60119),debug:(0,r.$Zj)("debug",60120),deviceCameraVideo:(0,r.$Zj)("device-camera-video",60121),deviceCamera:(0,r.$Zj)("device-camera",60122),deviceMobile:(0,r.$Zj)("device-mobile",60123),diffAdded:(0,r.$Zj)("diff-added",60124),diffIgnored:(0,r.$Zj)("diff-ignored",60125),diffModified:(0,r.$Zj)("diff-modified",60126),diffRemoved:(0,r.$Zj)("diff-removed",60127),diffRenamed:(0,r.$Zj)("diff-renamed",60128),diff:(0,r.$Zj)("diff",60129),diffSidebyside:(0,r.$Zj)("diff-sidebyside",60129),discard:(0,r.$Zj)("discard",60130),editorLayout:(0,r.$Zj)("editor-layout",60131),emptyWindow:(0,r.$Zj)("empty-window",60132),exclude:(0,r.$Zj)("exclude",60133),extensions:(0,r.$Zj)("extensions",60134),eyeClosed:(0,r.$Zj)("eye-closed",60135),fileBinary:(0,r.$Zj)("file-binary",60136),fileCode:(0,r.$Zj)("file-code",60137),fileMedia:(0,r.$Zj)("file-media",60138),filePdf:(0,r.$Zj)("file-pdf",60139),fileSubmodule:(0,r.$Zj)("file-submodule",60140),fileSymlinkDirectory:(0,r.$Zj)("file-symlink-directory",60141),fileSymlinkFile:(0,r.$Zj)("file-symlink-file",60142),fileZip:(0,r.$Zj)("file-zip",60143),files:(0,r.$Zj)("files",60144),filter:(0,r.$Zj)("filter",60145),flame:(0,r.$Zj)("flame",60146),foldDown:(0,r.$Zj)("fold-down",60147),foldUp:(0,r.$Zj)("fold-up",60148),fold:(0,r.$Zj)("fold",60149),folderActive:(0,r.$Zj)("folder-active",60150),folderOpened:(0,r.$Zj)("folder-opened",60151),gear:(0,r.$Zj)("gear",60152),gift:(0,r.$Zj)("gift",60153),gistSecret:(0,r.$Zj)("gist-secret",60154),gist:(0,r.$Zj)("gist",60155),gitCommit:(0,r.$Zj)("git-commit",60156),gitCompare:(0,r.$Zj)("git-compare",60157),compareChanges:(0,r.$Zj)("compare-changes",60157),gitMerge:(0,r.$Zj)("git-merge",60158),githubAction:(0,r.$Zj)("github-action",60159),githubAlt:(0,r.$Zj)("github-alt",60160),globe:(0,r.$Zj)("globe",60161),grabber:(0,r.$Zj)("grabber",60162),graph:(0,r.$Zj)("graph",60163),gripper:(0,r.$Zj)("gripper",60164),heart:(0,r.$Zj)("heart",60165),home:(0,r.$Zj)("home",60166),horizontalRule:(0,r.$Zj)("horizontal-rule",60167),hubot:(0,r.$Zj)("hubot",60168),inbox:(0,r.$Zj)("inbox",60169),issueReopened:(0,r.$Zj)("issue-reopened",60171),issues:(0,r.$Zj)("issues",60172),italic:(0,r.$Zj)("italic",60173),jersey:(0,r.$Zj)("jersey",60174),json:(0,r.$Zj)("json",60175),kebabVertical:(0,r.$Zj)("kebab-vertical",60176),key:(0,r.$Zj)("key",60177),law:(0,r.$Zj)("law",60178),lightbulbAutofix:(0,r.$Zj)("lightbulb-autofix",60179),linkExternal:(0,r.$Zj)("link-external",60180),link:(0,r.$Zj)("link",60181),listOrdered:(0,r.$Zj)("list-ordered",60182),listUnordered:(0,r.$Zj)("list-unordered",60183),liveShare:(0,r.$Zj)("live-share",60184),loading:(0,r.$Zj)("loading",60185),location:(0,r.$Zj)("location",60186),mailRead:(0,r.$Zj)("mail-read",60187),mail:(0,r.$Zj)("mail",60188),markdown:(0,r.$Zj)("markdown",60189),megaphone:(0,r.$Zj)("megaphone",60190),mention:(0,r.$Zj)("mention",60191),milestone:(0,r.$Zj)("milestone",60192),gitPullRequestMilestone:(0,r.$Zj)("git-pull-request-milestone",60192),mortarBoard:(0,r.$Zj)("mortar-board",60193),move:(0,r.$Zj)("move",60194),multipleWindows:(0,r.$Zj)("multiple-windows",60195),mute:(0,r.$Zj)("mute",60196),noNewline:(0,r.$Zj)("no-newline",60197),note:(0,r.$Zj)("note",60198),octoface:(0,r.$Zj)("octoface",60199),openPreview:(0,r.$Zj)("open-preview",60200),package:(0,r.$Zj)("package",60201),paintcan:(0,r.$Zj)("paintcan",60202),pin:(0,r.$Zj)("pin",60203),play:(0,r.$Zj)("play",60204),run:(0,r.$Zj)("run",60204),plug:(0,r.$Zj)("plug",60205),preserveCase:(0,r.$Zj)("preserve-case",60206),preview:(0,r.$Zj)("preview",60207),project:(0,r.$Zj)("project",60208),pulse:(0,r.$Zj)("pulse",60209),question:(0,r.$Zj)("question",60210),quote:(0,r.$Zj)("quote",60211),radioTower:(0,r.$Zj)("radio-tower",60212),reactions:(0,r.$Zj)("reactions",60213),references:(0,r.$Zj)("references",60214),refresh:(0,r.$Zj)("refresh",60215),regex:(0,r.$Zj)("regex",60216),remoteExplorer:(0,r.$Zj)("remote-explorer",60217),remote:(0,r.$Zj)("remote",60218),remove:(0,r.$Zj)("remove",60219),replaceAll:(0,r.$Zj)("replace-all",60220),replace:(0,r.$Zj)("replace",60221),repoClone:(0,r.$Zj)("repo-clone",60222),repoForcePush:(0,r.$Zj)("repo-force-push",60223),repoPull:(0,r.$Zj)("repo-pull",60224),repoPush:(0,r.$Zj)("repo-push",60225),report:(0,r.$Zj)("report",60226),requestChanges:(0,r.$Zj)("request-changes",60227),rocket:(0,r.$Zj)("rocket",60228),rootFolderOpened:(0,r.$Zj)("root-folder-opened",60229),rootFolder:(0,r.$Zj)("root-folder",60230),rss:(0,r.$Zj)("rss",60231),ruby:(0,r.$Zj)("ruby",60232),saveAll:(0,r.$Zj)("save-all",60233),saveAs:(0,r.$Zj)("save-as",60234),save:(0,r.$Zj)("save",60235),screenFull:(0,r.$Zj)("screen-full",60236),screenNormal:(0,r.$Zj)("screen-normal",60237),searchStop:(0,r.$Zj)("search-stop",60238),server:(0,r.$Zj)("server",60240),settingsGear:(0,r.$Zj)("settings-gear",60241),settings:(0,r.$Zj)("settings",60242),shield:(0,r.$Zj)("shield",60243),smiley:(0,r.$Zj)("smiley",60244),sortPrecedence:(0,r.$Zj)("sort-precedence",60245),splitHorizontal:(0,r.$Zj)("split-horizontal",60246),splitVertical:(0,r.$Zj)("split-vertical",60247),squirrel:(0,r.$Zj)("squirrel",60248),starFull:(0,r.$Zj)("star-full",60249),starHalf:(0,r.$Zj)("star-half",60250),symbolClass:(0,r.$Zj)("symbol-class",60251),symbolColor:(0,r.$Zj)("symbol-color",60252),symbolConstant:(0,r.$Zj)("symbol-constant",60253),symbolEnumMember:(0,r.$Zj)("symbol-enum-member",60254),symbolField:(0,r.$Zj)("symbol-field",60255),symbolFile:(0,r.$Zj)("symbol-file",60256),symbolInterface:(0,r.$Zj)("symbol-interface",60257),symbolKeyword:(0,r.$Zj)("symbol-keyword",60258),symbolMisc:(0,r.$Zj)("symbol-misc",60259),symbolOperator:(0,r.$Zj)("symbol-operator",60260),symbolProperty:(0,r.$Zj)("symbol-property",60261),wrench:(0,r.$Zj)("wrench",60261),wrenchSubaction:(0,r.$Zj)("wrench-subaction",60261),symbolSnippet:(0,r.$Zj)("symbol-snippet",60262),tasklist:(0,r.$Zj)("tasklist",60263),telescope:(0,r.$Zj)("telescope",60264),textSize:(0,r.$Zj)("text-size",60265),threeBars:(0,r.$Zj)("three-bars",60266),thumbsdown:(0,r.$Zj)("thumbsdown",60267),thumbsup:(0,r.$Zj)("thumbsup",60268),tools:(0,r.$Zj)("tools",60269),triangleDown:(0,r.$Zj)("triangle-down",60270),triangleLeft:(0,r.$Zj)("triangle-left",60271),triangleRight:(0,r.$Zj)("triangle-right",60272),triangleUp:(0,r.$Zj)("triangle-up",60273),twitter:(0,r.$Zj)("twitter",60274),unfold:(0,r.$Zj)("unfold",60275),unlock:(0,r.$Zj)("unlock",60276),unmute:(0,r.$Zj)("unmute",60277),unverified:(0,r.$Zj)("unverified",60278),verified:(0,r.$Zj)("verified",60279),versions:(0,r.$Zj)("versions",60280),vmActive:(0,r.$Zj)("vm-active",60281),vmOutline:(0,r.$Zj)("vm-outline",60282),vmRunning:(0,r.$Zj)("vm-running",60283),watch:(0,r.$Zj)("watch",60284),whitespace:(0,r.$Zj)("whitespace",60285),wholeWord:(0,r.$Zj)("whole-word",60286),window:(0,r.$Zj)("window",60287),wordWrap:(0,r.$Zj)("word-wrap",60288),zoomIn:(0,r.$Zj)("zoom-in",60289),zoomOut:(0,r.$Zj)("zoom-out",60290),listFilter:(0,r.$Zj)("list-filter",60291),listFlat:(0,r.$Zj)("list-flat",60292),listSelection:(0,r.$Zj)("list-selection",60293),selection:(0,r.$Zj)("selection",60293),listTree:(0,r.$Zj)("list-tree",60294),debugBreakpointFunctionUnverified:(0,r.$Zj)("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:(0,r.$Zj)("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:(0,r.$Zj)("debug-breakpoint-function-disabled",60296),debugStackframeActive:(0,r.$Zj)("debug-stackframe-active",60297),circleSmallFilled:(0,r.$Zj)("circle-small-filled",60298),debugStackframeDot:(0,r.$Zj)("debug-stackframe-dot",60298),terminalDecorationMark:(0,r.$Zj)("terminal-decoration-mark",60298),debugStackframe:(0,r.$Zj)("debug-stackframe",60299),debugStackframeFocused:(0,r.$Zj)("debug-stackframe-focused",60299),debugBreakpointUnsupported:(0,r.$Zj)("debug-breakpoint-unsupported",60300),symbolString:(0,r.$Zj)("symbol-string",60301),debugReverseContinue:(0,r.$Zj)("debug-reverse-continue",60302),debugStepBack:(0,r.$Zj)("debug-step-back",60303),debugRestartFrame:(0,r.$Zj)("debug-restart-frame",60304),debugAlt:(0,r.$Zj)("debug-alt",60305),callIncoming:(0,r.$Zj)("call-incoming",60306),callOutgoing:(0,r.$Zj)("call-outgoing",60307),menu:(0,r.$Zj)("menu",60308),expandAll:(0,r.$Zj)("expand-all",60309),feedback:(0,r.$Zj)("feedback",60310),gitPullRequestReviewer:(0,r.$Zj)("git-pull-request-reviewer",60310),groupByRefType:(0,r.$Zj)("group-by-ref-type",60311),ungroupByRefType:(0,r.$Zj)("ungroup-by-ref-type",60312),account:(0,r.$Zj)("account",60313),gitPullRequestAssignee:(0,r.$Zj)("git-pull-request-assignee",60313),bellDot:(0,r.$Zj)("bell-dot",60314),debugConsole:(0,r.$Zj)("debug-console",60315),library:(0,r.$Zj)("library",60316),output:(0,r.$Zj)("output",60317),runAll:(0,r.$Zj)("run-all",60318),syncIgnored:(0,r.$Zj)("sync-ignored",60319),pinned:(0,r.$Zj)("pinned",60320),githubInverted:(0,r.$Zj)("github-inverted",60321),serverProcess:(0,r.$Zj)("server-process",60322),serverEnvironment:(0,r.$Zj)("server-environment",60323),pass:(0,r.$Zj)("pass",60324),issueClosed:(0,r.$Zj)("issue-closed",60324),stopCircle:(0,r.$Zj)("stop-circle",60325),playCircle:(0,r.$Zj)("play-circle",60326),record:(0,r.$Zj)("record",60327),debugAltSmall:(0,r.$Zj)("debug-alt-small",60328),vmConnect:(0,r.$Zj)("vm-connect",60329),cloud:(0,r.$Zj)("cloud",60330),merge:(0,r.$Zj)("merge",60331),export:(0,r.$Zj)("export",60332),graphLeft:(0,r.$Zj)("graph-left",60333),magnet:(0,r.$Zj)("magnet",60334),notebook:(0,r.$Zj)("notebook",60335),redo:(0,r.$Zj)("redo",60336),checkAll:(0,r.$Zj)("check-all",60337),pinnedDirty:(0,r.$Zj)("pinned-dirty",60338),passFilled:(0,r.$Zj)("pass-filled",60339),circleLargeFilled:(0,r.$Zj)("circle-large-filled",60340),circleLarge:(0,r.$Zj)("circle-large",60341),circleLargeOutline:(0,r.$Zj)("circle-large-outline",60341),combine:(0,r.$Zj)("combine",60342),gather:(0,r.$Zj)("gather",60342),table:(0,r.$Zj)("table",60343),variableGroup:(0,r.$Zj)("variable-group",60344),typeHierarchy:(0,r.$Zj)("type-hierarchy",60345),typeHierarchySub:(0,r.$Zj)("type-hierarchy-sub",60346),typeHierarchySuper:(0,r.$Zj)("type-hierarchy-super",60347),gitPullRequestCreate:(0,r.$Zj)("git-pull-request-create",60348),runAbove:(0,r.$Zj)("run-above",60349),runBelow:(0,r.$Zj)("run-below",60350),notebookTemplate:(0,r.$Zj)("notebook-template",60351),debugRerun:(0,r.$Zj)("debug-rerun",60352),workspaceTrusted:(0,r.$Zj)("workspace-trusted",60353),workspaceUntrusted:(0,r.$Zj)("workspace-untrusted",60354),workspaceUnknown:(0,r.$Zj)("workspace-unknown",60355),terminalCmd:(0,r.$Zj)("terminal-cmd",60356),terminalDebian:(0,r.$Zj)("terminal-debian",60357),terminalLinux:(0,r.$Zj)("terminal-linux",60358),terminalPowershell:(0,r.$Zj)("terminal-powershell",60359),terminalTmux:(0,r.$Zj)("terminal-tmux",60360),terminalUbuntu:(0,r.$Zj)("terminal-ubuntu",60361),terminalBash:(0,r.$Zj)("terminal-bash",60362),arrowSwap:(0,r.$Zj)("arrow-swap",60363),copy:(0,r.$Zj)("copy",60364),personAdd:(0,r.$Zj)("person-add",60365),filterFilled:(0,r.$Zj)("filter-filled",60366),wand:(0,r.$Zj)("wand",60367),debugLineByLine:(0,r.$Zj)("debug-line-by-line",60368),inspect:(0,r.$Zj)("inspect",60369),layers:(0,r.$Zj)("layers",60370),layersDot:(0,r.$Zj)("layers-dot",60371),layersActive:(0,r.$Zj)("layers-active",60372),compass:(0,r.$Zj)("compass",60373),compassDot:(0,r.$Zj)("compass-dot",60374),compassActive:(0,r.$Zj)("compass-active",60375),azure:(0,r.$Zj)("azure",60376),issueDraft:(0,r.$Zj)("issue-draft",60377),gitPullRequestClosed:(0,r.$Zj)("git-pull-request-closed",60378),gitPullRequestDraft:(0,r.$Zj)("git-pull-request-draft",60379),debugAll:(0,r.$Zj)("debug-all",60380),debugCoverage:(0,r.$Zj)("debug-coverage",60381),runErrors:(0,r.$Zj)("run-errors",60382),folderLibrary:(0,r.$Zj)("folder-library",60383),debugContinueSmall:(0,r.$Zj)("debug-continue-small",60384),beakerStop:(0,r.$Zj)("beaker-stop",60385),graphLine:(0,r.$Zj)("graph-line",60386),graphScatter:(0,r.$Zj)("graph-scatter",60387),pieChart:(0,r.$Zj)("pie-chart",60388),bracket:(0,r.$Zj)("bracket",60175),bracketDot:(0,r.$Zj)("bracket-dot",60389),bracketError:(0,r.$Zj)("bracket-error",60390),lockSmall:(0,r.$Zj)("lock-small",60391),azureDevops:(0,r.$Zj)("azure-devops",60392),verifiedFilled:(0,r.$Zj)("verified-filled",60393),newline:(0,r.$Zj)("newline",60394),layout:(0,r.$Zj)("layout",60395),layoutActivitybarLeft:(0,r.$Zj)("layout-activitybar-left",60396),layoutActivitybarRight:(0,r.$Zj)("layout-activitybar-right",60397),layoutPanelLeft:(0,r.$Zj)("layout-panel-left",60398),layoutPanelCenter:(0,r.$Zj)("layout-panel-center",60399),layoutPanelJustify:(0,r.$Zj)("layout-panel-justify",60400),layoutPanelRight:(0,r.$Zj)("layout-panel-right",60401),layoutPanel:(0,r.$Zj)("layout-panel",60402),layoutSidebarLeft:(0,r.$Zj)("layout-sidebar-left",60403),layoutSidebarRight:(0,r.$Zj)("layout-sidebar-right",60404),layoutStatusbar:(0,r.$Zj)("layout-statusbar",60405),layoutMenubar:(0,r.$Zj)("layout-menubar",60406),layoutCentered:(0,r.$Zj)("layout-centered",60407),target:(0,r.$Zj)("target",60408),indent:(0,r.$Zj)("indent",60409),recordSmall:(0,r.$Zj)("record-small",60410),errorSmall:(0,r.$Zj)("error-small",60411),terminalDecorationError:(0,r.$Zj)("terminal-decoration-error",60411),arrowCircleDown:(0,r.$Zj)("arrow-circle-down",60412),arrowCircleLeft:(0,r.$Zj)("arrow-circle-left",60413),arrowCircleRight:(0,r.$Zj)("arrow-circle-right",60414),arrowCircleUp:(0,r.$Zj)("arrow-circle-up",60415),layoutSidebarRightOff:(0,r.$Zj)("layout-sidebar-right-off",60416),layoutPanelOff:(0,r.$Zj)("layout-panel-off",60417),layoutSidebarLeftOff:(0,r.$Zj)("layout-sidebar-left-off",60418),blank:(0,r.$Zj)("blank",60419),heartFilled:(0,r.$Zj)("heart-filled",60420),map:(0,r.$Zj)("map",60421),mapHorizontal:(0,r.$Zj)("map-horizontal",60421),foldHorizontal:(0,r.$Zj)("fold-horizontal",60421),mapFilled:(0,r.$Zj)("map-filled",60422),mapHorizontalFilled:(0,r.$Zj)("map-horizontal-filled",60422),foldHorizontalFilled:(0,r.$Zj)("fold-horizontal-filled",60422),circleSmall:(0,r.$Zj)("circle-small",60423),bellSlash:(0,r.$Zj)("bell-slash",60424),bellSlashDot:(0,r.$Zj)("bell-slash-dot",60425),commentUnresolved:(0,r.$Zj)("comment-unresolved",60426),gitPullRequestGoToChanges:(0,r.$Zj)("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:(0,r.$Zj)("git-pull-request-new-changes",60428),searchFuzzy:(0,r.$Zj)("search-fuzzy",60429),commentDraft:(0,r.$Zj)("comment-draft",60430),send:(0,r.$Zj)("send",60431),sparkle:(0,r.$Zj)("sparkle",60432),insert:(0,r.$Zj)("insert",60433),mic:(0,r.$Zj)("mic",60434),thumbsdownFilled:(0,r.$Zj)("thumbsdown-filled",60435),thumbsupFilled:(0,r.$Zj)("thumbsup-filled",60436),coffee:(0,r.$Zj)("coffee",60437),snake:(0,r.$Zj)("snake",60438),game:(0,r.$Zj)("game",60439),vr:(0,r.$Zj)("vr",60440),chip:(0,r.$Zj)("chip",60441),piano:(0,r.$Zj)("piano",60442),music:(0,r.$Zj)("music",60443),micFilled:(0,r.$Zj)("mic-filled",60444),repoFetch:(0,r.$Zj)("repo-fetch",60445),copilot:(0,r.$Zj)("copilot",60446),lightbulbSparkle:(0,r.$Zj)("lightbulb-sparkle",60447),robot:(0,r.$Zj)("robot",60448),sparkleFilled:(0,r.$Zj)("sparkle-filled",60449),diffSingle:(0,r.$Zj)("diff-single",60450),diffMultiple:(0,r.$Zj)("diff-multiple",60451),surroundWith:(0,r.$Zj)("surround-with",60452),share:(0,r.$Zj)("share",60453),gitStash:(0,r.$Zj)("git-stash",60454),gitStashApply:(0,r.$Zj)("git-stash-apply",60455),gitStashPop:(0,r.$Zj)("git-stash-pop",60456),vscode:(0,r.$Zj)("vscode",60457),vscodeInsiders:(0,r.$Zj)("vscode-insiders",60458),codeOss:(0,r.$Zj)("code-oss",60459),runCoverage:(0,r.$Zj)("run-coverage",60460),runAllCoverage:(0,r.$Zj)("run-all-coverage",60461),coverage:(0,r.$Zj)("coverage",60462),githubProject:(0,r.$Zj)("github-project",60463),mapVertical:(0,r.$Zj)("map-vertical",60464),foldVertical:(0,r.$Zj)("fold-vertical",60464),mapVerticalFilled:(0,r.$Zj)("map-vertical-filled",60465),foldVerticalFilled:(0,r.$Zj)("fold-vertical-filled",60465),goToSearch:(0,r.$Zj)("go-to-search",60466),percentage:(0,r.$Zj)("percentage",60467),sortPercentage:(0,r.$Zj)("sort-percentage",60467),attach:(0,r.$Zj)("attach",60468)}}),define(Ee[83],ye([1,0,105,185]),function(ce,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5j=e.$4j=void 0,e.$3j=P;function P(){return Object.values(e.$5j)}e.$4j={dialogError:(0,r.$Zj)("dialog-error","error"),dialogWarning:(0,r.$Zj)("dialog-warning","warning"),dialogInfo:(0,r.$Zj)("dialog-info","info"),dialogClose:(0,r.$Zj)("dialog-close","close"),treeItemExpanded:(0,r.$Zj)("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:(0,r.$Zj)("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:(0,r.$Zj)("tree-filter-on-type-off","list-selection"),treeFilterClear:(0,r.$Zj)("tree-filter-clear","close"),treeItemLoading:(0,r.$Zj)("tree-item-loading","loading"),menuSelection:(0,r.$Zj)("menu-selection","check"),menuSubmenu:(0,r.$Zj)("menu-submenu","chevron-right"),menuBarMore:(0,r.$Zj)("menubar-more","more"),scrollbarButtonLeft:(0,r.$Zj)("scrollbar-button-left","triangle-left"),scrollbarButtonRight:(0,r.$Zj)("scrollbar-button-right","triangle-right"),scrollbarButtonUp:(0,r.$Zj)("scrollbar-button-up","triangle-up"),scrollbarButtonDown:(0,r.$Zj)("scrollbar-button-down","triangle-down"),toolBarMore:(0,r.$Zj)("toolbar-more","more"),quickInputBack:(0,r.$Zj)("quick-input-back","arrow-left"),dropDownButton:(0,r.$Zj)("drop-down-button",60084),symbolCustomColor:(0,r.$Zj)("symbol-customcolor",60252),exportIcon:(0,r.$Zj)("export",60332),workspaceUnspecified:(0,r.$Zj)("workspace-unspecified",60355),newLine:(0,r.$Zj)("newline",60394),thumbsDownFilled:(0,r.$Zj)("thumbsdown-filled",60435),thumbsUpFilled:(0,r.$Zj)("thumbsup-filled",60436),gitFetch:(0,r.$Zj)("git-fetch",60445),lightbulbSparkleAutofix:(0,r.$Zj)("lightbulb-sparkle-autofix",60447),debugBreakpointPending:(0,r.$Zj)("debug-breakpoint-pending",60377)},e.$5j={...h.$2j,...e.$4j}}),define(Ee[25],ye([1,0,18]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bo=h,e.$co=P,e.$do=T,e.$eo=$,e.$fo=c,e.$go=I,e.$ho=E,e.$io=u,e.$jo=k,e.$ko=p,e.$lo=a,e.$mo=f,e.$no=d;function h(m){if(!m||typeof m!="object"||m instanceof RegExp)return m;const n=Array.isArray(m)?[]:{};return Object.entries(m).forEach(([o,t])=>{n[o]=t&&typeof t=="object"?h(t):t}),n}function P(m){if(!m||typeof m!="object")return m;const n=[m];for(;n.length>0;){const o=n.shift();Object.freeze(o);for(const t in o)if(R.call(o,t)){const i=o[t];typeof i=="object"&&!Object.isFrozen(i)&&!(0,r.$ig)(i)&&n.push(i)}}return m}const R=Object.prototype.hasOwnProperty;function T(m,n){return N(m,n,new Set)}function N(m,n,o){if((0,r.$og)(m))return m;const t=n(m);if(typeof t<"u")return t;if(Array.isArray(m)){const i=[];for(const s of m)i.push(N(s,n,o));return i}if((0,r.$hg)(m)){if(o.has(m))throw new Error("Cannot clone recursive data-structure");o.add(m);const i={};for(const s in m)R.call(m,s)&&(i[s]=N(m[s],n,o));return o.delete(m),i}return m}function $(m,n,o=!0){return(0,r.$hg)(m)?((0,r.$hg)(n)&&Object.keys(n).forEach(t=>{t in m?o&&((0,r.$hg)(m[t])&&(0,r.$hg)(n[t])?$(m[t],n[t],o):m[t]=n[t]):m[t]=n[t]}),m):n}function c(m,n){if(m===n)return!0;if(m==null||n===null||n===void 0||typeof m!=typeof n||typeof m!="object"||Array.isArray(m)!==Array.isArray(n))return!1;let o,t;if(Array.isArray(m)){if(m.length!==n.length)return!1;for(o=0;o<m.length;o++)if(!c(m[o],n[o]))return!1}else{const i=[];for(t in m)i.push(t);i.sort();const s=[];for(t in n)s.push(t);if(s.sort(),!c(i,s))return!1;for(o=0;o<i.length;o++)if(!c(m[i[o]],n[i[o]]))return!1}return!0}function I(m){const n=new Set;return JSON.stringify(m,(o,t)=>{if((0,r.$hg)(t)||Array.isArray(t)){if(n.has(t))return"[Circular]";n.add(t)}return typeof t=="bigint"?`[BigInt ${t.toString()}]`:t})}function E(m,n){const o=Object.create(null);return!m||!n||Object.keys(n).forEach(i=>{const s=m[i],g=n[i];c(s,g)||(o[i]=g)}),o}function u(m,n){const o=n.toLowerCase(),t=Object.keys(m).find(i=>i.toLowerCase()===o);return t?m[t]:m[n]}function k(m,n){const o=Object.create(null);for(const[t,i]of Object.entries(m))n(t,i)&&(o[t]=i);return o}function p(m){let n=[];for(;Object.prototype!==m;)n=n.concat(Object.getOwnPropertyNames(m)),m=Object.getPrototypeOf(m);return n}function a(m){const n=[];for(const o of p(m))typeof m[o]=="function"&&n.push(o);return n}function f(m,n){const o=i=>function(){const s=Array.prototype.slice.call(arguments,0);return n(i,s)},t={};for(const i of m)t[i]=o(i);return t}function d(m,n){const o={};for(const[t,i]of Object.entries(m))o[t]=n(i,t);return o}}),define(Ee[50],ye([1,0,83]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.ThemeColor=void 0,e.$6j=P;var h;(function(T){function N($){return $&&typeof $=="object"&&typeof $.id=="string"}T.isThemeColor=N})(h||(e.ThemeColor=h={}));function P(T){return{id:T}}var R;(function(T){T.iconNameSegment="[A-Za-z0-9]+",T.iconNameExpression="[A-Za-z0-9-]+",T.iconModifierExpression="~[A-Za-z]+",T.iconNameCharacter="[A-Za-z0-9~-]";const N=new RegExp(`^(${T.iconNameExpression})(${T.iconModifierExpression})?$`);function $(m){const n=N.exec(m.id);if(!n)return $(r.$5j.error);const[,o,t]=n,i=["codicon","codicon-"+o];return t&&i.push("codicon-modifier-"+t.substring(1)),i}T.asClassNameArray=$;function c(m){return $(m).join(" ")}T.asClassName=c;function I(m){return"."+$(m).join(".")}T.asCSSSelector=I;function E(m){return m&&typeof m=="object"&&typeof m.id=="string"&&(typeof m.color>"u"||h.isThemeColor(m.color))}T.isThemeIcon=E;const u=new RegExp(`^\\$\\((${T.iconNameExpression}(?:${T.iconModifierExpression})?)\\)$`);function k(m){const n=u.exec(m);if(!n)return;const[,o]=n;return{id:o}}T.fromString=k;function p(m){return{id:m}}T.fromId=p;function a(m,n){let o=m.id;const t=o.lastIndexOf("~");return t!==-1&&(o=o.substring(0,t)),n&&(o=`${o}~${n}`),{id:o}}T.modify=a;function f(m){const n=m.id.lastIndexOf("~");if(n!==-1)return m.id.substring(n+1)}T.getModifier=f;function d(m,n){return m.id===n.id&&m.color?.id===n.color?.id}T.isEqual=d})(R||(e.ThemeIcon=R={}))}),define(Ee[84],ye([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Constants=void 0,e.$bf=h,e.$cf=P;var r;(function(R){R[R.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",R[R.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",R[R.MAX_UINT_8=255]="MAX_UINT_8",R[R.MAX_UINT_16=65535]="MAX_UINT_16",R[R.MAX_UINT_32=4294967295]="MAX_UINT_32",R[R.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(r||(e.Constants=r={}));function h(R){return R<0?0:R>r.MAX_UINT_8?r.MAX_UINT_8:R|0}function P(R){return R<0?0:R>r.MAX_UINT_32?r.MAX_UINT_32:R|0}}),define(Ee[13],ye([1,0,182,27,49,84]),function(ce,e,r,h,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eg=e.$dg=e.$cg=e.GraphemeBreakType=e.$5f=e.$Wf=e.$Pf=e.$Of=void 0,e.$df=T,e.$ef=$,e.$ff=I,e.$gf=E,e.$hf=u,e.$if=k,e.$jf=p,e.$kf=a,e.$lf=f,e.$mf=d,e.$nf=m,e.$of=n,e.$pf=o,e.$qf=t,e.$rf=i,e.$sf=s,e.$tf=g,e.$uf=l,e.$vf=w,e.$wf=S,e.$xf=D,e.$yf=y,e.$zf=C,e.$Af=A,e.$Bf=b,e.$Cf=v,e.$Df=L,e.$Ef=O,e.$Ff=M,e.$Gf=j,e.$Hf=z,e.$If=F,e.$Jf=B,e.$Kf=_,e.$Lf=re,e.$Mf=U,e.$Nf=G,e.$Qf=ne,e.$Rf=De,e.$Sf=$e,e.$Tf=K,e.$Uf=oe,e.$Vf=le,e.$Xf=ue,e.$Yf=X,e.$Zf=ae,e.$1f=pe,e.$2f=Fe,e.$3f=Ue,e.$4f=Ie,e.$6f=Re,e.$7f=q,e.$8f=V,e.$9f=J,e.$0f=x,e.$$f=fe,e.$_f=we,e.$ag=Le,e.$bg=ot;function T(Pe){return!Pe||typeof Pe!="string"?!0:Pe.trim().length===0}const N=/{(\d+)}/g;function $(Pe,...ze){return ze.length===0?Pe:Pe.replace(N,function(Ze,Te){const Me=parseInt(Te,10);return isNaN(Me)||Me<0||Me>=ze.length?Ze:ze[Me]})}const c=/{([^}]+)}/g;function I(Pe,ze){return Object.keys(ze).length===0?Pe:Pe.replace(c,(Ze,Te)=>ze[Te]??Ze)}function E(Pe){return Pe.replace(/[<>"'&]/g,ze=>{switch(ze){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return ze})}function u(Pe){return Pe.replace(/[<>&]/g,function(ze){switch(ze){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ze}})}function k(Pe){return Pe.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}function p(Pe,ze){let Ze=0,Te=Pe.indexOf(ze);for(;Te!==-1;)Ze++,Te=Pe.indexOf(ze,Te+ze.length);return Ze}function a(Pe,ze,Ze="\u2026"){return Pe.length<=ze?Pe:`${Pe.substr(0,ze)}${Ze}`}function f(Pe,ze,Ze="\u2026"){if(Pe.length<=ze)return Pe;const Te=Math.ceil(ze/2)-Ze.length/2,Me=Math.floor(ze/2)-Ze.length/2;return`${Pe.substr(0,Te)}${Ze}${Pe.substr(Pe.length-Me)}`}function d(Pe,ze=" "){const Ze=m(Pe,ze);return n(Ze,ze)}function m(Pe,ze){if(!Pe||!ze)return Pe;const Ze=ze.length;if(Ze===0||Pe.length===0)return Pe;let Te=0;for(;Pe.indexOf(ze,Te)===Te;)Te=Te+Ze;return Pe.substring(Te)}function n(Pe,ze){if(!Pe||!ze)return Pe;const Ze=ze.length,Te=Pe.length;if(Ze===0||Te===0)return Pe;let Me=Te,Y=-1;for(;Y=Pe.lastIndexOf(ze,Me-1),!(Y===-1||Y+Ze!==Me);){if(Y===0)return"";Me=Y}return Pe.substring(0,Me)}function o(Pe){return Pe.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}function t(Pe){return Pe.replace(/\*/g,"")}function i(Pe,ze,Ze={}){if(!Pe)throw new Error("Cannot create regex from empty string");ze||(Pe=k(Pe)),Ze.wholeWord&&(/\B/.test(Pe.charAt(0))||(Pe="\\b"+Pe),/\B/.test(Pe.charAt(Pe.length-1))||(Pe=Pe+"\\b"));let Te="";return Ze.global&&(Te+="g"),Ze.matchCase||(Te+="i"),Ze.multiline&&(Te+="m"),Ze.unicode&&(Te+="u"),new RegExp(Pe,Te)}function s(Pe){return Pe.source==="^"||Pe.source==="^$"||Pe.source==="$"||Pe.source==="^\\s*$"?!1:!!(Pe.exec("")&&Pe.lastIndex===0)}function g(Pe){return Pe.split(/\r\n|\r|\n/)}function l(Pe){const ze=[],Ze=Pe.split(/(\r\n|\r|\n)/);for(let Te=0;Te<Math.ceil(Ze.length/2);Te++)ze.push(Ze[2*Te]+(Ze[2*Te+1]??""));return ze}function w(Pe){for(let ze=0,Ze=Pe.length;ze<Ze;ze++){const Te=Pe.charCodeAt(ze);if(Te!==h.CharCode.Space&&Te!==h.CharCode.Tab)return ze}return-1}function S(Pe,ze=0,Ze=Pe.length){for(let Te=ze;Te<Ze;Te++){const Me=Pe.charCodeAt(Te);if(Me!==h.CharCode.Space&&Me!==h.CharCode.Tab)return Pe.substring(ze,Te)}return Pe.substring(ze,Ze)}function D(Pe,ze=Pe.length-1){for(let Ze=ze;Ze>=0;Ze--){const Te=Pe.charCodeAt(Ze);if(Te!==h.CharCode.Space&&Te!==h.CharCode.Tab)return Ze}return-1}function y(Pe,ze,Ze){const Te=[];let Me=0;for(const Y of Pe.matchAll(ze)){if(Te.push(Pe.slice(Me,Y.index)),Y.index===void 0)throw new Error("match.index should be defined");Me=Y.index+Y[0].length,Te.push(Ze(Y[0],...Y.slice(1),Y.index,Pe,Y.groups))}return Te.push(Pe.slice(Me)),Promise.all(Te).then(Y=>Y.join(""))}function C(Pe,ze){return Pe<ze?-1:Pe>ze?1:0}function A(Pe,ze,Ze=0,Te=Pe.length,Me=0,Y=ze.length){for(;Ze<Te&&Me<Y;Ze++,Me++){const Xe=Pe.charCodeAt(Ze),_e=ze.charCodeAt(Me);if(Xe<_e)return-1;if(Xe>_e)return 1}const de=Te-Ze,Ae=Y-Me;return de<Ae?-1:de>Ae?1:0}function b(Pe,ze){return v(Pe,ze,0,Pe.length,0,ze.length)}function v(Pe,ze,Ze=0,Te=Pe.length,Me=0,Y=ze.length){for(;Ze<Te&&Me<Y;Ze++,Me++){let Xe=Pe.charCodeAt(Ze),_e=ze.charCodeAt(Me);if(Xe===_e)continue;if(Xe>=128||_e>=128)return A(Pe.toLowerCase(),ze.toLowerCase(),Ze,Te,Me,Y);O(Xe)&&(Xe-=32),O(_e)&&(_e-=32);const ut=Xe-_e;if(ut!==0)return ut}const de=Te-Ze,Ae=Y-Me;return de<Ae?-1:de>Ae?1:0}function L(Pe){return Pe>=h.CharCode.Digit0&&Pe<=h.CharCode.Digit9}function O(Pe){return Pe>=h.CharCode.a&&Pe<=h.CharCode.z}function M(Pe){return Pe>=h.CharCode.A&&Pe<=h.CharCode.Z}function j(Pe,ze){return Pe.length===ze.length&&v(Pe,ze)===0}function z(Pe,ze){const Ze=ze.length;return ze.length>Pe.length?!1:v(Pe,ze,0,Ze)===0}function F(Pe,ze){const Ze=Math.min(Pe.length,ze.length);let Te;for(Te=0;Te<Ze;Te++)if(Pe.charCodeAt(Te)!==ze.charCodeAt(Te))return Te;return Ze}function B(Pe,ze){const Ze=Math.min(Pe.length,ze.length);let Te;const Me=Pe.length-1,Y=ze.length-1;for(Te=0;Te<Ze;Te++)if(Pe.charCodeAt(Me-Te)!==ze.charCodeAt(Y-Te))return Te;return Ze}function _(Pe){return 55296<=Pe&&Pe<=56319}function re(Pe){return 56320<=Pe&&Pe<=57343}function U(Pe,ze){return(Pe-55296<<10)+(ze-56320)+65536}function G(Pe,ze,Ze){const Te=Pe.charCodeAt(Ze);if(_(Te)&&Ze+1<ze){const Me=Pe.charCodeAt(Ze+1);if(re(Me))return U(Te,Me)}return Te}function Q(Pe,ze){const Ze=Pe.charCodeAt(ze-1);if(re(Ze)&&ze>1){const Te=Pe.charCodeAt(ze-2);if(_(Te))return U(Te,Ze)}return Ze}class ee{get offset(){return this.e}constructor(ze,Ze=0){this.c=ze,this.d=ze.length,this.e=Ze}setOffset(ze){this.e=ze}prevCodePoint(){const ze=Q(this.c,this.e);return this.e-=ze>=R.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,ze}nextCodePoint(){const ze=G(this.c,this.d,this.e);return this.e+=ze>=R.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,ze}eol(){return this.e>=this.d}}e.$Of=ee;class he{get offset(){return this.c.offset}constructor(ze,Ze=0){this.c=new ee(ze,Ze)}nextGraphemeLength(){const ze=et.getInstance(),Ze=this.c,Te=Ze.offset;let Me=ze.getGraphemeBreakType(Ze.nextCodePoint());for(;!Ze.eol();){const Y=Ze.offset,de=ze.getGraphemeBreakType(Ze.nextCodePoint());if(He(Me,de)){Ze.setOffset(Y);break}Me=de}return Ze.offset-Te}prevGraphemeLength(){const ze=et.getInstance(),Ze=this.c,Te=Ze.offset;let Me=ze.getGraphemeBreakType(Ze.prevCodePoint());for(;Ze.offset>0;){const Y=Ze.offset,de=ze.getGraphemeBreakType(Ze.prevCodePoint());if(He(de,Me)){Ze.setOffset(Y);break}Me=de}return Te-Ze.offset}eol(){return this.c.eol()}}e.$Pf=he;function ne(Pe,ze){return new he(Pe,ze).nextGraphemeLength()}function De(Pe,ze){return new he(Pe,ze).prevGraphemeLength()}function $e(Pe,ze){ze>0&&re(Pe.charCodeAt(ze))&&ze--;const Ze=ze+ne(Pe,ze);return[Ze-De(Pe,Ze),Ze]}function K(Pe){const ze=new he(Pe);let Ze=0;for(;!ze.eol();)Ze++,ze.nextGraphemeLength();return Ze}let W;function se(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function oe(Pe){return W||(W=se()),W.test(Pe)}const te=/^[\t\n\r\x20-\x7E]*$/;function le(Pe){return te.test(Pe)}e.$Wf=/[\u2028\u2029]/;function ue(Pe){return e.$Wf.test(Pe)}function X(Pe){return Pe>=11904&&Pe<=55215||Pe>=63744&&Pe<=64255||Pe>=65281&&Pe<=65374}function ae(Pe){return Pe>=127462&&Pe<=127487||Pe===8986||Pe===8987||Pe===9200||Pe===9203||Pe>=9728&&Pe<=10175||Pe===11088||Pe===11093||Pe>=127744&&Pe<=128591||Pe>=128640&&Pe<=128764||Pe>=128992&&Pe<=129008||Pe>=129280&&Pe<=129535||Pe>=129648&&Pe<=129782}function pe(Pe,ze,Ze=""){const Te=Pe.trimStart();if(Te.length<ze)return Te;const Me=/\b/g;let Y=0;for(;Me.test(Te)&&!(Te.length-Me.lastIndex<ze);)Y=Me.lastIndex,Me.lastIndex+=1;return Y===0?Te:Ze+Te.substring(Y).trimStart()}const be=/(?:(?:\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~])|(:?\x1b\].*?\x07)/g;function*Fe(Pe){let ze=0;for(const Ze of Pe.matchAll(be))ze!==Ze.index&&(yield{isCode:!1,str:Pe.substring(ze,Ze.index)}),yield{isCode:!0,str:Ze[0]},ze=Ze.index+Ze[0].length;ze!==Pe.length&&(yield{isCode:!1,str:Pe.substring(ze)})}function Ue(Pe){return Pe&&(Pe=Pe.replace(be,"")),Pe}const ke=/\\\[.*?\\\]/g;function Ie(Pe){return Ue(Pe).replace(ke,"")}e.$5f=String.fromCharCode(h.CharCode.UTF8_BOM);function Re(Pe){return!!(Pe&&Pe.length>0&&Pe.charCodeAt(0)===h.CharCode.UTF8_BOM)}function q(Pe){return Re(Pe)?Pe.substr(1):Pe}function V(Pe,ze){if(!Pe||!ze||Pe.length<ze.length)return!1;const Ze=ze.length,Te=Pe.toLowerCase();let Me=0,Y=-1;for(;Me<Ze;){const de=Te.indexOf(ze[Me],Y+1);if(de<0)return!1;Y=de,Me++}return!0}function J(Pe,ze=!1){return Pe?(ze&&(Pe=Pe.replace(/\\./g,"")),Pe.toLowerCase()!==Pe):!1}function x(Pe){return Pe.charAt(0).toUpperCase()+Pe.slice(1)}function fe(Pe,ze=1){if(ze===0)return"";let Ze=-1;do Ze=Pe.indexOf(`
`,Ze+1),ze--;while(ze>0&&Ze>=0);return Ze===-1?Pe:(Pe[Ze-1]==="\r"&&Ze--,Pe.substr(0,Ze))}function we(Pe){const ze=h.CharCode.Z-h.CharCode.A+1;return Pe=Pe%(2*ze),Pe<ze?String.fromCharCode(h.CharCode.a+Pe):String.fromCharCode(h.CharCode.A+Pe-ze)}function Le(Pe){return et.getInstance().getGraphemeBreakType(Pe)}function He(Pe,ze){return Pe===Ke.Other?ze!==Ke.Extend&&ze!==Ke.SpacingMark:Pe===Ke.CR&&ze===Ke.LF?!1:Pe===Ke.Control||Pe===Ke.CR||Pe===Ke.LF||ze===Ke.Control||ze===Ke.CR||ze===Ke.LF?!0:!(Pe===Ke.L&&(ze===Ke.L||ze===Ke.V||ze===Ke.LV||ze===Ke.LVT)||(Pe===Ke.LV||Pe===Ke.V)&&(ze===Ke.V||ze===Ke.T)||(Pe===Ke.LVT||Pe===Ke.T)&&ze===Ke.T||ze===Ke.Extend||ze===Ke.ZWJ||ze===Ke.SpacingMark||Pe===Ke.Prepend||Pe===Ke.ZWJ&&ze===Ke.Extended_Pictographic||Pe===Ke.Regional_Indicator&&ze===Ke.Regional_Indicator)}var Ke;(function(Pe){Pe[Pe.Other=0]="Other",Pe[Pe.Prepend=1]="Prepend",Pe[Pe.CR=2]="CR",Pe[Pe.LF=3]="LF",Pe[Pe.Control=4]="Control",Pe[Pe.Extend=5]="Extend",Pe[Pe.Regional_Indicator=6]="Regional_Indicator",Pe[Pe.SpacingMark=7]="SpacingMark",Pe[Pe.L=8]="L",Pe[Pe.V=9]="V",Pe[Pe.T=10]="T",Pe[Pe.LV=11]="LV",Pe[Pe.LVT=12]="LVT",Pe[Pe.ZWJ=13]="ZWJ",Pe[Pe.Extended_Pictographic=14]="Extended_Pictographic"})(Ke||(e.GraphemeBreakType=Ke={}));class et{static{this.c=null}static getInstance(){return et.c||(et.c=new et),et.c}constructor(){this.d=rt()}getGraphemeBreakType(ze){if(ze<32)return ze===h.CharCode.LineFeed?Ke.LF:ze===h.CharCode.CarriageReturn?Ke.CR:Ke.Control;if(ze<127)return Ke.Other;const Ze=this.d,Te=Ze.length/3;let Me=1;for(;Me<=Te;)if(ze<Ze[3*Me])Me=2*Me;else if(ze>Ze[3*Me+1])Me=2*Me+1;else return Ze[3*Me+2];return Ke.Other}}function rt(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function ot(Pe,ze){if(Pe===0)return 0;const Ze=nt(Pe,ze);if(Ze!==void 0)return Ze;const Te=new ee(ze,Pe);return Te.prevCodePoint(),Te.offset}function nt(Pe,ze){const Ze=new ee(ze,Pe);let Te=Ze.prevCodePoint();for(;ct(Te)||Te===mt.emojiVariantSelector||Te===mt.enclosingKeyCap;){if(Ze.offset===0)return;Te=Ze.prevCodePoint()}if(!ae(Te))return;let Me=Ze.offset;return Me>0&&Ze.prevCodePoint()===mt.zwj&&(Me=Ze.offset),Me}function ct(Pe){return 127995<=Pe&&Pe<=127999}var mt;(function(Pe){Pe[Pe.zwj=8205]="zwj",Pe[Pe.emojiVariantSelector=65039]="emojiVariantSelector",Pe[Pe.enclosingKeyCap=8419]="enclosingKeyCap"})(mt||(mt={})),e.$cg="\xA0";class dt{static{this.c=new P.$X(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new r.$_e({getCacheKey:JSON.stringify},ze=>{function Ze(ut){const gt=new Map;for(let kt=0;kt<ut.length;kt+=2)gt.set(ut[kt],ut[kt+1]);return gt}function Te(ut,gt){const kt=new Map(ut);for(const[Lt,Bt]of gt)kt.set(Lt,Bt);return kt}function Me(ut,gt){if(!ut)return gt;const kt=new Map;for(const[Lt,Bt]of ut)gt.has(Lt)&&kt.set(Lt,Bt);return kt}const Y=this.c.value;let de=ze.filter(ut=>!ut.startsWith("_")&&ut in Y);de.length===0&&(de=["_default"]);let Ae;for(const ut of de){const gt=Ze(Y[ut]);Ae=Me(Ae,gt)}const Xe=Ze(Y._common),_e=Te(Xe,Ae);return new dt(_e)})}static getInstance(ze){return dt.d.get(Array.from(ze))}static{this.e=new P.$X(()=>Object.keys(dt.c.value).filter(ze=>!ze.startsWith("_")))}static getLocales(){return dt.e.value}constructor(ze){this.f=ze}isAmbiguous(ze){return this.f.has(ze)}containsAmbiguousCharacter(ze){for(let Ze=0;Ze<ze.length;Ze++){const Te=ze.codePointAt(Ze);if(typeof Te=="number"&&this.isAmbiguous(Te))return!0}return!1}getPrimaryConfusable(ze){return this.f.get(ze)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$dg=dt;class at{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(at.c())),this.d}static isInvisibleCharacter(ze){return at.e().has(ze)}static containsInvisibleCharacter(ze){for(let Ze=0;Ze<ze.length;Ze++){const Te=ze.codePointAt(Ze);if(typeof Te=="number"&&at.isInvisibleCharacter(Te))return!0}return!1}static get codePoints(){return at.e()}}e.$eg=at}),define(Ee[135],ye([1,0,27,29,177,13]),function(ce,e,r,h,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sk=e.FuzzyScore=e.$Hk=e.$Gk=void 0,e.or=T,e.$Ik=$,e.$Jk=c,e.$Kk=u,e.$Lk=D,e.$Mk=y,e.$Nk=O,e.$Ok=M,e.$Pk=j,e.$Qk=z,e.$Rk=se,e.$Tk=ue,e.$Uk=pe,e.$Vk=be,R=We(R);function T(...ke){return function(Ie,Re){for(let q=0,V=ke.length;q<V;q++){const J=ke[q](Ie,Re);if(J)return J}return null}}e.$Gk=N.bind(void 0,!1),e.$Hk=N.bind(void 0,!0);function N(ke,Ie,Re){if(!Re||Re.length<Ie.length)return null;let q;return ke?q=R.$Hf(Re,Ie):q=Re.indexOf(Ie)===0,q?Ie.length>0?[{start:0,end:Ie.length}]:[]:null}function $(ke,Ie){const Re=Ie.toLowerCase().indexOf(ke.toLowerCase());return Re===-1?null:[{start:Re,end:Re+ke.length}]}function c(ke,Ie){return I(ke.toLowerCase(),Ie.toLowerCase(),0,0)}function I(ke,Ie,Re,q){if(Re===ke.length)return[];if(q===Ie.length)return null;if(ke[Re]===Ie[q]){let V=null;return(V=I(ke,Ie,Re+1,q+1))?t({start:q,end:q+1},V):null}return I(ke,Ie,Re,q+1)}function E(ke){return r.CharCode.a<=ke&&ke<=r.CharCode.z}function u(ke){return r.CharCode.A<=ke&&ke<=r.CharCode.Z}function k(ke){return r.CharCode.Digit0<=ke&&ke<=r.CharCode.Digit9}function p(ke){return ke===r.CharCode.Space||ke===r.CharCode.Tab||ke===r.CharCode.LineFeed||ke===r.CharCode.CarriageReturn}const a=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(ke=>a.add(ke.charCodeAt(0)));function f(ke){return p(ke)||a.has(ke)}function d(ke,Ie){return ke===Ie||f(ke)&&f(Ie)}const m=new Map;function n(ke){if(m.has(ke))return m.get(ke);let Ie;const Re=(0,P.$Ek)(ke);return Re&&(Ie=Re),m.set(ke,Ie),Ie}function o(ke){return E(ke)||u(ke)||k(ke)}function t(ke,Ie){return Ie.length===0?Ie=[ke]:ke.end===Ie[0].start?Ie[0].start=ke.start:Ie.unshift(ke),Ie}function i(ke,Ie){for(let Re=Ie;Re<ke.length;Re++){const q=ke.charCodeAt(Re);if(u(q)||k(q)||Re>0&&!o(ke.charCodeAt(Re-1)))return Re}return ke.length}function s(ke,Ie,Re,q){if(Re===ke.length)return[];if(q===Ie.length)return null;if(ke[Re]!==Ie[q].toLowerCase())return null;{let V=null,J=q+1;for(V=s(ke,Ie,Re+1,q+1);!V&&(J=i(Ie,J))<Ie.length;)V=s(ke,Ie,Re+1,J),J++;return V===null?null:t({start:q,end:q+1},V)}}function g(ke){let Ie=0,Re=0,q=0,V=0,J=0;for(let He=0;He<ke.length;He++)J=ke.charCodeAt(He),u(J)&&Ie++,E(J)&&Re++,o(J)&&q++,k(J)&&V++;const x=Ie/ke.length,fe=Re/ke.length,we=q/ke.length,Le=V/ke.length;return{upperPercent:x,lowerPercent:fe,alphaPercent:we,numericPercent:Le}}function l(ke){const{upperPercent:Ie,lowerPercent:Re}=ke;return Re===0&&Ie>.6}function w(ke){const{upperPercent:Ie,lowerPercent:Re,alphaPercent:q,numericPercent:V}=ke;return Re>.2&&Ie<.8&&q>.6&&V<.2}function S(ke){let Ie=0,Re=0,q=0,V=0;for(let J=0;J<ke.length;J++)q=ke.charCodeAt(J),u(q)&&Ie++,E(q)&&Re++,p(q)&&V++;return(Ie===0||Re===0)&&V===0?ke.length<=30:Ie<=5}function D(ke,Ie){if(!Ie||(Ie=Ie.trim(),Ie.length===0)||!S(ke))return null;Ie.length>60&&(Ie=Ie.substring(0,60));const Re=g(Ie);if(!w(Re)){if(!l(Re))return null;Ie=Ie.toLowerCase()}let q=null,V=0;for(ke=ke.toLowerCase();V<Ie.length&&(q=s(ke,Ie,0,V))===null;)V=i(Ie,V+1);return q}function y(ke,Ie,Re=!1){if(!Ie||Ie.length===0)return null;let q=null,V=0;for(ke=ke.toLowerCase(),Ie=Ie.toLowerCase();V<Ie.length&&(q=C(ke,Ie,0,V,Re),q===null);)V=A(Ie,V+1);return q}function C(ke,Ie,Re,q,V){let J=0;if(Re===ke.length)return[];if(q===Ie.length)return null;if(!d(ke.charCodeAt(Re),Ie.charCodeAt(q))){const we=n(ke.charCodeAt(Re));if(!we)return null;for(let Le=0;Le<we.length;Le++)if(!d(we[Le],Ie.charCodeAt(q+Le)))return null;J+=we.length-1}let x=null,fe=q+J+1;if(x=C(ke,Ie,Re+1,fe,V),!V)for(;!x&&(fe=A(Ie,fe))<Ie.length;)x=C(ke,Ie,Re+1,fe,V),fe++;if(!x)return null;if(ke.charCodeAt(Re)!==Ie.charCodeAt(q)){const we=n(ke.charCodeAt(Re));if(!we)return x;for(let Le=0;Le<we.length;Le++)if(we[Le]!==Ie.charCodeAt(q+Le))return x}return t({start:q,end:q+J+1},x)}function A(ke,Ie){for(let Re=Ie;Re<ke.length;Re++)if(f(ke.charCodeAt(Re))||Re>0&&f(ke.charCodeAt(Re-1)))return Re;return ke.length}const b=T(e.$Hk,D,$),v=T(e.$Hk,D,c),L=new h.$Fc(1e4);function O(ke,Ie,Re=!1){if(typeof ke!="string"||typeof Ie!="string")return null;let q=L.get(ke);q||(q=new RegExp(R.$pf(ke),"i"),L.set(ke,q));const V=q.exec(Ie);return V?[{start:V.index,end:V.index+V[0].length}]:Re?v(ke,Ie):b(ke,Ie)}function M(ke,Ie){const Re=ue(ke,ke.toLowerCase(),0,Ie,Ie.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return Re?z(Re):null}function j(ke,Ie,Re,q,V,J){const x=Math.min(13,ke.length);for(;Re<x;Re++){const fe=ue(ke,Ie,Re,q,V,J,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(fe)return fe}return[0,J]}function z(ke){if(typeof ke>"u")return[];const Ie=[],Re=ke[1];for(let q=ke.length-1;q>1;q--){const V=ke[q]+Re,J=Ie[Ie.length-1];J&&J.end===V?J.end=V+1:Ie.push({start:V,end:V+1})}return Ie}const F=128;function B(){const ke=[],Ie=[];for(let Re=0;Re<=F;Re++)Ie[Re]=0;for(let Re=0;Re<=F;Re++)ke.push(Ie.slice(0));return ke}function _(ke){const Ie=[];for(let Re=0;Re<=ke;Re++)Ie[Re]=0;return Ie}const re=_(2*F),U=_(2*F),G=B(),Q=B(),ee=B(),he=!1;function ne(ke,Ie,Re,q,V){function J(fe,we,Le=" "){for(;fe.length<we;)fe=Le+fe;return fe}let x=` |   |${q.split("").map(fe=>J(fe,3)).join("|")}
`;for(let fe=0;fe<=Re;fe++)fe===0?x+=" |":x+=`${Ie[fe-1]}|`,x+=ke[fe].slice(0,V+1).map(we=>J(we.toString(),3)).join("|")+`
`;return x}function De(ke,Ie,Re,q){ke=ke.substr(Ie),Re=Re.substr(q),console.log(ne(Q,ke,ke.length,Re,Re.length)),console.log(ne(ee,ke,ke.length,Re,Re.length)),console.log(ne(G,ke,ke.length,Re,Re.length))}function $e(ke,Ie){if(Ie<0||Ie>=ke.length)return!1;const Re=ke.codePointAt(Ie);switch(Re){case r.CharCode.Underline:case r.CharCode.Dash:case r.CharCode.Period:case r.CharCode.Space:case r.CharCode.Slash:case r.CharCode.Backslash:case r.CharCode.SingleQuote:case r.CharCode.DoubleQuote:case r.CharCode.Colon:case r.CharCode.DollarSign:case r.CharCode.LessThan:case r.CharCode.GreaterThan:case r.CharCode.OpenParen:case r.CharCode.CloseParen:case r.CharCode.OpenSquareBracket:case r.CharCode.CloseSquareBracket:case r.CharCode.OpenCurlyBrace:case r.CharCode.CloseCurlyBrace:return!0;case void 0:return!1;default:return!!R.$Zf(Re)}}function K(ke,Ie){if(Ie<0||Ie>=ke.length)return!1;switch(ke.charCodeAt(Ie)){case r.CharCode.Space:case r.CharCode.Tab:return!0;default:return!1}}function W(ke,Ie,Re){return Ie[ke]!==Re[ke]}function se(ke,Ie,Re,q,V,J,x=!1){for(;Ie<Re&&V<J;)ke[Ie]===q[V]&&(x&&(re[Ie]=V),Ie+=1),V+=1;return Ie===Re}var oe;(function(ke){ke[ke.Diag=1]="Diag",ke[ke.Left=2]="Left",ke[ke.LeftLeft=3]="LeftLeft"})(oe||(oe={}));var te;(function(ke){ke.Default=[-100,0];function Ie(Re){return!Re||Re.length===2&&Re[0]===-100&&Re[1]===0}ke.isDefault=Ie})(te||(e.FuzzyScore=te={}));class le{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(Ie,Re){this.firstMatchCanBeWeak=Ie,this.boostFullMatch=Re}}e.$Sk=le;function ue(ke,Ie,Re,q,V,J,x=le.default){const fe=ke.length>F?F:ke.length,we=q.length>F?F:q.length;if(Re>=fe||J>=we||fe-Re>we-J||!se(Ie,Re,fe,V,J,we,!0))return;X(fe,we,Re,J,Ie,V);let Le=1,He=1,Ke=Re,et=J;const rt=[!1];for(Le=1,Ke=Re;Ke<fe;Le++,Ke++){const dt=re[Ke],at=U[Ke],Pe=Ke+1<fe?U[Ke+1]:we;for(He=dt-J+1,et=dt;et<Pe;He++,et++){let ze=Number.MIN_SAFE_INTEGER,Ze=!1;et<=at&&(ze=ae(ke,Ie,Ke,Re,q,V,et,we,J,G[Le-1][He-1]===0,rt));let Te=0;ze!==Number.MAX_SAFE_INTEGER&&(Ze=!0,Te=ze+Q[Le-1][He-1]);const Me=et>dt,Y=Me?Q[Le][He-1]+(G[Le][He-1]>0?-5:0):0,de=et>dt+1&&G[Le][He-1]>0,Ae=de?Q[Le][He-2]+(G[Le][He-2]>0?-5:0):0;if(de&&(!Me||Ae>=Y)&&(!Ze||Ae>=Te))Q[Le][He]=Ae,ee[Le][He]=oe.LeftLeft,G[Le][He]=0;else if(Me&&(!Ze||Y>=Te))Q[Le][He]=Y,ee[Le][He]=oe.Left,G[Le][He]=0;else if(Ze)Q[Le][He]=Te,ee[Le][He]=oe.Diag,G[Le][He]=G[Le-1][He-1]+1;else throw new Error("not possible")}}if(he&&De(ke,Re,q,J),!rt[0]&&!x.firstMatchCanBeWeak)return;Le--,He--;const ot=[Q[Le][He],J];let nt=0,ct=0;for(;Le>=1;){let dt=He;do{const at=ee[Le][dt];if(at===oe.LeftLeft)dt=dt-2;else if(at===oe.Left)dt=dt-1;else break}while(dt>=1);nt>1&&Ie[Re+Le-1]===V[J+He-1]&&!W(dt+J-1,q,V)&&nt+1>G[Le][dt]&&(dt=He),dt===He?nt++:nt=1,ct||(ct=dt),Le--,He=dt-1,ot.push(He)}we-J===fe&&x.boostFullMatch&&(ot[0]+=2);const mt=ct-fe;return ot[0]-=mt,ot}function X(ke,Ie,Re,q,V,J){let x=ke-1,fe=Ie-1;for(;x>=Re&&fe>=q;)V[x]===J[fe]&&(U[x]=fe,x--),fe--}function ae(ke,Ie,Re,q,V,J,x,fe,we,Le,He){if(Ie[Re]!==J[x])return Number.MIN_SAFE_INTEGER;let Ke=1,et=!1;return x===Re-q?Ke=ke[Re]===V[x]?7:5:W(x,V,J)&&(x===0||!W(x-1,V,J))?(Ke=ke[Re]===V[x]?7:5,et=!0):$e(J,x)&&(x===0||!$e(J,x-1))?Ke=5:($e(J,x-1)||K(J,x-1))&&(Ke=5,et=!0),Ke>1&&Re===q&&(He[0]=!0),et||(et=W(x,V,J)||$e(J,x-1)||K(J,x-1)),Re===q?x>we&&(Ke-=et?3:5):Le?Ke+=et?2:0:Ke+=et?0:1,x+1===fe&&(Ke-=et?3:5),Ke}function pe(ke,Ie,Re,q,V,J,x){return Fe(ke,Ie,Re,q,V,J,!0,x)}function be(ke,Ie,Re,q,V,J,x){return Fe(ke,Ie,Re,q,V,J,!1,x)}function Fe(ke,Ie,Re,q,V,J,x,fe){let we=ue(ke,Ie,Re,q,V,J,fe);if(we&&!x)return we;if(ke.length>=3){const Le=Math.min(7,ke.length-1);for(let He=Re+1;He<Le;He++){const Ke=Ue(ke,He);if(Ke){const et=ue(Ke,Ke.toLowerCase(),Re,q,V,J,fe);et&&(et[0]-=3,(!we||et[0]>we[0])&&(we=et))}}}return we}function Ue(ke,Ie){if(Ie+1>=ke.length)return;const Re=ke[Ie],q=ke[Ie+1];if(Re!==q)return ke.slice(0,Ie)+q+Re+ke.slice(Ie+2)}}),define(Ee[60],ye([1,0,13]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zj=e.$xj=void 0,e.$tj=h,e.$uj=P,e.$vj=R,e.$wj=N,e.$yj=a,r=We(r);function h(d){return P(d,0)}function P(d,m){switch(typeof d){case"object":return d===null?R(349,m):Array.isArray(d)?$(d,m):c(d,m);case"string":return N(d,m);case"boolean":return T(d,m);case"number":return R(d,m);case"undefined":return R(937,m);default:return R(617,m)}}function R(d,m){return(m<<5)-m+d|0}function T(d,m){return R(d?433:863,m)}function N(d,m){m=R(149417,m);for(let n=0,o=d.length;n<o;n++)m=R(d.charCodeAt(n),m);return m}function $(d,m){return m=R(104579,m),d.reduce((n,o)=>P(o,n),m)}function c(d,m){return m=R(181387,m),Object.keys(d).sort().reduce((n,o)=>(n=N(o,n),P(d[o],n)),m)}class I{constructor(){this.g=0}get value(){return this.g}hash(m){return this.g=P(m,this.g),this.g}}e.$xj=I;var E;(function(d){d[d.BLOCK_SIZE=64]="BLOCK_SIZE",d[d.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(E||(E={}));function u(d,m,n=32){const o=n-m,t=~((1<<o)-1);return(d<<m|(t&d)>>>o)>>>0}function k(d,m=0,n=d.byteLength,o=0){for(let t=0;t<n;t++)d[m+t]=o}function p(d,m,n="0"){for(;d.length<m;)d=n+d;return d}function a(d,m=32){return d instanceof ArrayBuffer?Array.from(new Uint8Array(d)).map(n=>n.toString(16).padStart(2,"0")).join(""):p((d>>>0).toString(16),m/4)}class f{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(E.BLOCK_SIZE+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(m){const n=m.length;if(n===0)return;const o=this.p;let t=this.r,i=this.u,s,g;for(i!==0?(s=i,g=-1,i=0):(s=m.charCodeAt(0),g=0);;){let l=s;if(r.$Kf(s))if(g+1<n){const w=m.charCodeAt(g+1);r.$Lf(w)?(g++,l=r.$Mf(s,w)):l=E.UNICODE_REPLACEMENT}else{i=s;break}else r.$Lf(s)&&(l=E.UNICODE_REPLACEMENT);if(t=this.w(o,t,l),g++,g<n)s=m.charCodeAt(g);else break}this.r=t,this.u=i}w(m,n,o){return o<128?m[n++]=o:o<2048?(m[n++]=192|(o&1984)>>>6,m[n++]=128|(o&63)>>>0):o<65536?(m[n++]=224|(o&61440)>>>12,m[n++]=128|(o&4032)>>>6,m[n++]=128|(o&63)>>>0):(m[n++]=240|(o&1835008)>>>18,m[n++]=128|(o&258048)>>>12,m[n++]=128|(o&4032)>>>6,m[n++]=128|(o&63)>>>0),n>=E.BLOCK_SIZE&&(this.y(),n-=E.BLOCK_SIZE,this.t+=E.BLOCK_SIZE,m[0]=m[E.BLOCK_SIZE+0],m[1]=m[E.BLOCK_SIZE+1],m[2]=m[E.BLOCK_SIZE+2]),n}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,E.UNICODE_REPLACEMENT)),this.t+=this.r,this.x()),a(this.h)+a(this.l)+a(this.m)+a(this.n)+a(this.o)}x(){this.p[this.r++]=128,k(this.p,this.r),this.r>56&&(this.y(),k(this.p));const m=8*this.t;this.q.setUint32(56,Math.floor(m/4294967296),!1),this.q.setUint32(60,m%4294967296,!1),this.y()}y(){const m=f.g,n=this.q;for(let D=0;D<64;D+=4)m.setUint32(D,n.getUint32(D,!1),!1);for(let D=64;D<320;D+=4)m.setUint32(D,u(m.getUint32(D-12,!1)^m.getUint32(D-32,!1)^m.getUint32(D-56,!1)^m.getUint32(D-64,!1),1),!1);let o=this.h,t=this.l,i=this.m,s=this.n,g=this.o,l,w,S;for(let D=0;D<80;D++)D<20?(l=t&i|~t&s,w=1518500249):D<40?(l=t^i^s,w=1859775393):D<60?(l=t&i|t&s|i&s,w=2400959708):(l=t^i^s,w=3395469782),S=u(o,5)+l+g+w+m.getUint32(D*4,!1)&4294967295,g=s,s=i,i=u(t,30),t=o,o=S;this.h=this.h+o&4294967295,this.l=this.l+t&4294967295,this.m=this.m+i&4294967295,this.n=this.n+s&4294967295,this.o=this.o+g&4294967295}}e.$zj=f}),define(Ee[136],ye([1,0,135,13,50]),function(ce,e,r,h,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wk=$,e.$Xk=I,e.$Yk=u,e.$Zk=k,e.$1k=a,e.$2k=f;const R="$(",T=new RegExp(`\\$\\(${P.ThemeIcon.iconNameExpression}(?:${P.ThemeIcon.iconModifierExpression})?\\)`,"g"),N=new RegExp(`(\\\\)?${T.source}`,"g");function $(d){return d.replace(N,(m,n)=>n?m:`\\${m}`)}const c=new RegExp(`\\\\${T.source}`,"g");function I(d){return d.replace(c,m=>`\\${m}`)}const E=new RegExp(`(\\s)?(\\\\)?${T.source}(\\s)?`,"g");function u(d){return d.indexOf(R)===-1?d:d.replace(E,(m,n,o,t)=>o?m:n||t||"")}function k(d){return d?d.replace(/\$\((.*?)\)/g,(m,n)=>` ${n} `).trim():""}const p=new RegExp(`\\$\\(${P.ThemeIcon.iconNameCharacter}+\\)`,"g");function a(d){p.lastIndex=0;let m="";const n=[];let o=0;for(;;){const t=p.lastIndex,i=p.exec(d),s=d.substring(t,i?.index);if(s.length>0){m+=s;for(let g=0;g<s.length;g++)n.push(o)}if(!i)break;o+=i[0].length}return{text:m,iconOffsets:n}}function f(d,m,n=!1){const{text:o,iconOffsets:t}=m;if(!t||t.length===0)return(0,r.$Nk)(d,o,n);const i=(0,h.$nf)(o," "),s=o.length-i.length,g=(0,r.$Nk)(d,i,n);if(g)for(const l of g){const w=t[l.start+s]+s;l.start+=w,l.end+=w}return g}}),define(Ee[44],ye([1,0,13]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),r=We(r);var h;(function(P){P[P.Ignore=0]="Ignore",P[P.Info=1]="Info",P[P.Warning=2]="Warning",P[P.Error=3]="Error"})(h||(h={})),function(P){const R="error",T="warning",N="warn",$="info",c="ignore";function I(u){return u?r.$Gf(R,u)?P.Error:r.$Gf(T,u)||r.$Gf(N,u)?P.Warning:r.$Gf($,u)?P.Info:P.Ignore:P.Ignore}P.fromValue=I;function E(u){switch(u){case P.Error:return R;case P.Warning:return T;case P.Info:return $;default:return c}}P.toString=E}(h||(h={})),e.default=h}),define(Ee[85],ye([1,0,19,27,13]),function(ce,e,r,h,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Li=e.$Ki=e.$Ji=e.$Ii=e.$Hi=void 0;class R{constructor(){this.b="",this.c=0}reset(p){return this.b=p,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(p){const a=p.charCodeAt(0),f=this.b.charCodeAt(this.c);return a-f}value(){return this.b[this.c]}}e.$Hi=R;class T{constructor(p=!0){this.e=p}reset(p){return this.b=p,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let p=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===h.CharCode.Period)if(p)this.c++;else break;else p=!1;return this}cmp(p){return this.e?(0,P.$Af)(p,this.b,0,p.length,this.c,this.d):(0,P.$Cf)(p,this.b,0,p.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$Ii=T;class N{constructor(p=!0,a=!0){this.f=p,this.g=a}reset(p){this.d=0,this.e=0,this.b=p,this.c=p.length;for(let a=p.length-1;a>=0;a--,this.c--){const f=this.b.charCodeAt(a);if(!(f===h.CharCode.Slash||this.f&&f===h.CharCode.Backslash))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let p=!0;for(;this.e<this.c;this.e++){const a=this.b.charCodeAt(this.e);if(a===h.CharCode.Slash||this.f&&a===h.CharCode.Backslash)if(p)this.d++;else break;else p=!1}return this}cmp(p){return this.g?(0,P.$Af)(p,this.b,0,p.length,this.d,this.e):(0,P.$Cf)(p,this.b,0,p.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$Ji=N;var $;(function(k){k[k.Scheme=1]="Scheme",k[k.Authority=2]="Authority",k[k.Path=3]="Path",k[k.Query=4]="Query",k[k.Fragment=5]="Fragment"})($||($={}));class c{constructor(p,a){this.f=p,this.g=a,this.d=[],this.e=0}reset(p){return this.c=p,this.d=[],this.c.scheme&&this.d.push($.Scheme),this.c.authority&&this.d.push($.Authority),this.c.path&&(this.b=new N(!1,!this.f(p)),this.b.reset(p.path),this.b.value()&&this.d.push($.Path)),this.g(p)||(this.c.query&&this.d.push($.Query),this.c.fragment&&this.d.push($.Fragment)),this.e=0,this}next(){return this.d[this.e]===$.Path&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===$.Path&&this.b.hasNext()||this.e<this.d.length-1}cmp(p){if(this.d[this.e]===$.Scheme)return(0,P.$Bf)(p,this.c.scheme);if(this.d[this.e]===$.Authority)return(0,P.$Bf)(p,this.c.authority);if(this.d[this.e]===$.Path)return this.b.cmp(p);if(this.d[this.e]===$.Query)return(0,P.$zf)(p,this.c.query);if(this.d[this.e]===$.Fragment)return(0,P.$zf)(p,this.c.fragment);throw new Error}value(){if(this.d[this.e]===$.Scheme)return this.c.scheme;if(this.d[this.e]===$.Authority)return this.c.authority;if(this.d[this.e]===$.Path)return this.b.value();if(this.d[this.e]===$.Query)return this.c.query;if(this.d[this.e]===$.Fragment)return this.c.fragment;throw new Error}}e.$Ki=c;class I{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const p=this.right;return this.right=p.left,p.left=this,this.updateHeight(),p.updateHeight(),p}rotateRight(){const p=this.left;return this.left=p.right,p.right=this,this.updateHeight(),p.updateHeight(),p}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var E;(function(k){k[k.Left=-1]="Left",k[k.Mid=0]="Mid",k[k.Right=1]="Right"})(E||(E={}));class u{static forUris(p=()=>!1,a=()=>!1){return new u(new c(p,a))}static forPaths(p=!1){return new u(new N(void 0,!p))}static forStrings(){return new u(new R)}static forConfigKeys(){return new u(new T)}constructor(p){this.b=p}clear(){this.c=void 0}fill(p,a){if(a){const f=a.slice(0);(0,r.$Yb)(f);for(const d of f)this.set(d,p)}else{const f=p.slice(0);(0,r.$Yb)(f);for(const d of f)this.set(d[0],d[1])}}set(p,a){const f=this.b.reset(p);let d;this.c||(this.c=new I,this.c.segment=f.value());const m=[];for(d=this.c;;){const o=f.cmp(d.segment);if(o>0)d.left||(d.left=new I,d.left.segment=f.value()),m.push([E.Left,d]),d=d.left;else if(o<0)d.right||(d.right=new I,d.right.segment=f.value()),m.push([E.Right,d]),d=d.right;else if(f.hasNext())f.next(),d.mid||(d.mid=new I,d.mid.segment=f.value()),m.push([E.Mid,d]),d=d.mid;else break}const n=d.value;d.value=a,d.key=p;for(let o=m.length-1;o>=0;o--){const t=m[o][1];t.updateHeight();const i=t.balanceFactor();if(i<-1||i>1){const s=m[o][0],g=m[o+1][0];if(s===E.Right&&g===E.Right)m[o][1]=t.rotateLeft();else if(s===E.Left&&g===E.Left)m[o][1]=t.rotateRight();else if(s===E.Right&&g===E.Left)t.right=m[o+1][1]=m[o+1][1].rotateRight(),m[o][1]=t.rotateLeft();else if(s===E.Left&&g===E.Right)t.left=m[o+1][1]=m[o+1][1].rotateLeft(),m[o][1]=t.rotateRight();else throw new Error;if(o>0)switch(m[o-1][0]){case E.Left:m[o-1][1].left=m[o][1];break;case E.Right:m[o-1][1].right=m[o][1];break;case E.Mid:m[o-1][1].mid=m[o][1];break}else this.c=m[0][1]}}return n}get(p){return this.d(p)?.value}d(p){const a=this.b.reset(p);let f=this.c;for(;f;){const d=a.cmp(f.segment);if(d>0)f=f.left;else if(d<0)f=f.right;else if(a.hasNext())a.next(),f=f.mid;else break}return f}has(p){const a=this.d(p);return!(a?.value===void 0&&a?.mid===void 0)}delete(p){return this.e(p,!1)}deleteSuperstr(p){return this.e(p,!0)}e(p,a){const f=this.b.reset(p),d=[];let m=this.c;for(;m;){const n=f.cmp(m.segment);if(n>0)d.push([E.Left,m]),m=m.left;else if(n<0)d.push([E.Right,m]),m=m.right;else if(f.hasNext())f.next(),d.push([E.Mid,m]),m=m.mid;else break}if(m){if(a?(m.left=void 0,m.mid=void 0,m.right=void 0,m.height=1):(m.key=void 0,m.value=void 0),!m.mid&&!m.value)if(m.left&&m.right){const n=this.f(m.right);if(n.key){const{key:o,value:t,segment:i}=n;this.e(n.key,!1),m.key=o,m.value=t,m.segment=i}}else{const n=m.left??m.right;if(d.length>0){const[o,t]=d[d.length-1];switch(o){case E.Left:t.left=n;break;case E.Mid:t.mid=n;break;case E.Right:t.right=n;break}}else this.c=n}for(let n=d.length-1;n>=0;n--){const o=d[n][1];o.updateHeight();const t=o.balanceFactor();if(t>1?(o.right.balanceFactor()>=0||(o.right=o.right.rotateRight()),d[n][1]=o.rotateLeft()):t<-1&&(o.left.balanceFactor()<=0||(o.left=o.left.rotateLeft()),d[n][1]=o.rotateRight()),n>0)switch(d[n-1][0]){case E.Left:d[n-1][1].left=d[n][1];break;case E.Right:d[n-1][1].right=d[n][1];break;case E.Mid:d[n-1][1].mid=d[n][1];break}else this.c=d[0][1]}}}f(p){for(;p.left;)p=p.left;return p}findSubstr(p){const a=this.b.reset(p);let f=this.c,d;for(;f;){const m=a.cmp(f.segment);if(m>0)f=f.left;else if(m<0)f=f.right;else if(a.hasNext())a.next(),d=f.value||d,f=f.mid;else break}return f&&f.value||d}findSuperstr(p){return this.g(p,!1)}g(p,a){const f=this.b.reset(p);let d=this.c;for(;d;){const m=f.cmp(d.segment);if(m>0)d=d.left;else if(m<0)d=d.right;else if(f.hasNext())f.next(),d=d.mid;else return d.mid?this.h(d.mid):a?d.value:void 0}}hasElementOrSubtree(p){return this.g(p,!0)!==void 0}forEach(p){for(const[a,f]of this)p(f,a)}*[Symbol.iterator](){yield*this.h(this.c)}h(p){const a=[];return this.j(p,a),a[Symbol.iterator]()}j(p,a){p&&(p.left&&this.j(p.left,a),p.value&&a.push([p.key,p.value]),p.mid&&this.j(p.mid,a),p.right&&this.j(p.right,a))}_isBalanced(){const p=a=>{if(!a)return!0;const f=a.balanceFactor();return f<-1||f>1?!1:p(a.left)&&p(a.right)};return p(this.c)}}e.$Li=u}),define(Ee[32],ye([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2g=void 0,e.$1g=h;const r=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function h(P){return r.test(P)}e.$2g=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let P;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?P=crypto.getRandomValues.bind(crypto):P=function(N){for(let $=0;$<N.length;$++)N[$]=Math.floor(Math.random()*256);return N};const R=new Uint8Array(16),T=[];for(let N=0;N<256;N++)T.push(N.toString(16).padStart(2,"0"));return function(){P(R),R[6]=R[6]&15|64,R[8]=R[8]&63|128;let $=0,c="";return c+=T[R[$++]],c+=T[R[$++]],c+=T[R[$++]],c+=T[R[$++]],c+="-",c+=T[R[$++]],c+=T[R[$++]],c+="-",c+=T[R[$++]],c+=T[R[$++]],c+="-",c+=T[R[$++]],c+=T[R[$++]],c+="-",c+=T[R[$++]],c+=T[R[$++]],c+=T[R[$++]],c+=T[R[$++]],c+=T[R[$++]],c+=T[R[$++]],c}}()}),define(Ee[186],ye([1,0,19,40,32]),function(ce,e,r,h,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lu=e.$ju=void 0,e.$hu=R,e.$iu=T,e.$ku=c;function R(E){return{asString:async()=>E,asFile:()=>{},value:typeof E=="string"?E:void 0}}function T(E,u,k){const p={id:(0,P.$2g)(),name:E,uri:u,data:k};return{asString:async()=>"",asFile:()=>p,value:void 0}}class N{constructor(){this.a=new Map}get size(){let u=0;for(const k of this.a)u++;return u}has(u){return this.a.has(this.b(u))}matches(u){const k=[...this.a.keys()];return h.Iterable.some(this,([p,a])=>a.asFile())&&k.push("files"),I($(u),k)}get(u){return this.a.get(this.b(u))?.[0]}append(u,k){const p=this.a.get(u);p?p.push(k):this.a.set(this.b(u),[k])}replace(u,k){this.a.set(this.b(u),[k])}delete(u){this.a.delete(this.b(u))}*[Symbol.iterator](){for(const[u,k]of this.a)for(const p of k)yield[u,p]}b(u){return $(u)}}e.$ju=N;function $(E){return E.toLowerCase()}function c(E,u){return I($(E),u.map($))}function I(E,u){if(E==="*/*")return u.length>0;if(u.includes(E))return!0;const k=E.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!k)return!1;const[p,a,f]=k;return f==="*"?u.some(d=>d.startsWith(a+"/")):!1}e.$lu=Object.freeze({create:E=>(0,r.$Ob)(E.map(u=>u.toString())).join(`\r
`),split:E=>E.split(`\r
`),parse:E=>e.$lu.split(E).filter(u=>!u.startsWith("#"))})}),define(Ee[187],ye([1,0,67]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5g=void 0,e.$4g=h,e.$6g=R,r=We(r);function h(N,$,c,I=1){let E=!1;return new Promise(u=>{const k=setTimeout(()=>{if(!E)return E=!0,u(0)},c);P(N,$,I,p=>{if(!E)return E=!0,clearTimeout(k),u(p)})})}function P(N,$,c,I){if($===0)return I(0);const E=new r.Socket;E.once("connect",()=>(T(E),P(N+c,$-1,c,I))),E.once("data",()=>{}),E.once("error",u=>(T(E),u.code!=="ECONNREFUSED"?P(N+c,$-1,c,I):I(N))),E.connect(N,"127.0.0.1")}e.$5g={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function R(N,$,c,I="127.0.0.1"){let E=!1,u,k=1;const p=r.createServer({pauseOnConnect:!0});function a(f,d){E||(E=!0,p.removeAllListeners(),p.close(),u&&clearTimeout(u),d(f))}return new Promise(f=>{u=setTimeout(()=>{a(0,f)},c),p.on("listening",()=>{a(N,f)}),p.on("error",d=>{d&&(d.code==="EADDRINUSE"||d.code==="EACCES")&&k<$?(N++,k++,p.listen(N,I)):a(0,f)}),p.on("close",()=>{a(0,f)}),p.listen(N,I)})}function T(N){try{N.removeAllListeners("connect"),N.removeAllListeners("error"),N.end(),N.destroy(),N.unref()}catch($){console.error($)}}}),define(Ee[137],ye([1,0,84]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$au=e.$_t=void 0;class h{constructor(N){const $=(0,r.$bf)(N);this.c=$,this.a=h.d($),this.b=new Map}static d(N){const $=new Uint8Array(256);return $.fill(N),$}set(N,$){const c=(0,r.$bf)($);N>=0&&N<256?this.a[N]=c:this.b.set(N,c)}get(N){return N>=0&&N<256?this.a[N]:this.b.get(N)||this.c}clear(){this.a.fill(this.c),this.b.clear()}}e.$_t=h;var P;(function(T){T[T.False=0]="False",T[T.True=1]="True"})(P||(P={}));class R{constructor(){this.a=new h(P.False)}add(N){this.a.set(N,P.True)}has(N){return this.a.get(N)===P.True}clear(){return this.a.clear()}}e.$au=R}),define(Ee[188],ye([1,0,27]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringEOL=void 0,e.$ru=P;var h;(function(R){R[R.Unknown=0]="Unknown",R[R.Invalid=3]="Invalid",R[R.LF=1]="LF",R[R.CRLF=2]="CRLF"})(h||(e.StringEOL=h={}));function P(R){let T=0,N=0,$=0,c=h.Unknown;for(let I=0,E=R.length;I<E;I++){const u=R.charCodeAt(I);u===r.CharCode.CarriageReturn?(T===0&&(N=I),T++,I+1<E&&R.charCodeAt(I+1)===r.CharCode.LineFeed?(c|=h.CRLF,I++):c|=h.Invalid,$=I+1):u===r.CharCode.LineFeed&&(c|=h.LF,T===0&&(N=I),T++,$=I+1)}return T===0&&(N=R.length),[T,N,R.length-$,c]}}),define(Ee[53],ye([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gt=void 0;class r{constructor(P,R){this.lineNumber=P,this.column=R}with(P=this.lineNumber,R=this.column){return P===this.lineNumber&&R===this.column?this:new r(P,R)}delta(P=0,R=0){return this.with(this.lineNumber+P,this.column+R)}equals(P){return r.equals(this,P)}static equals(P,R){return!P&&!R?!0:!!P&&!!R&&P.lineNumber===R.lineNumber&&P.column===R.column}isBefore(P){return r.isBefore(this,P)}static isBefore(P,R){return P.lineNumber<R.lineNumber?!0:R.lineNumber<P.lineNumber?!1:P.column<R.column}isBeforeOrEqual(P){return r.isBeforeOrEqual(this,P)}static isBeforeOrEqual(P,R){return P.lineNumber<R.lineNumber?!0:R.lineNumber<P.lineNumber?!1:P.column<=R.column}static compare(P,R){const T=P.lineNumber|0,N=R.lineNumber|0;if(T===N){const $=P.column|0,c=R.column|0;return $-c}return T-N}clone(){return new r(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(P){return new r(P.lineNumber,P.column)}static isIPosition(P){return P&&typeof P.lineNumber=="number"&&typeof P.column=="number"}toJSON(){return{lineNumber:this.lineNumber,column:this.column}}}e.$Gt=r}),define(Ee[31],ye([1,0,53]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ht=void 0;class h{constructor(R,T,N,$){R>N||R===N&&T>$?(this.startLineNumber=N,this.startColumn=$,this.endLineNumber=R,this.endColumn=T):(this.startLineNumber=R,this.startColumn=T,this.endLineNumber=N,this.endColumn=$)}isEmpty(){return h.isEmpty(this)}static isEmpty(R){return R.startLineNumber===R.endLineNumber&&R.startColumn===R.endColumn}containsPosition(R){return h.containsPosition(this,R)}static containsPosition(R,T){return!(T.lineNumber<R.startLineNumber||T.lineNumber>R.endLineNumber||T.lineNumber===R.startLineNumber&&T.column<R.startColumn||T.lineNumber===R.endLineNumber&&T.column>R.endColumn)}static strictContainsPosition(R,T){return!(T.lineNumber<R.startLineNumber||T.lineNumber>R.endLineNumber||T.lineNumber===R.startLineNumber&&T.column<=R.startColumn||T.lineNumber===R.endLineNumber&&T.column>=R.endColumn)}containsRange(R){return h.containsRange(this,R)}static containsRange(R,T){return!(T.startLineNumber<R.startLineNumber||T.endLineNumber<R.startLineNumber||T.startLineNumber>R.endLineNumber||T.endLineNumber>R.endLineNumber||T.startLineNumber===R.startLineNumber&&T.startColumn<R.startColumn||T.endLineNumber===R.endLineNumber&&T.endColumn>R.endColumn)}strictContainsRange(R){return h.strictContainsRange(this,R)}static strictContainsRange(R,T){return!(T.startLineNumber<R.startLineNumber||T.endLineNumber<R.startLineNumber||T.startLineNumber>R.endLineNumber||T.endLineNumber>R.endLineNumber||T.startLineNumber===R.startLineNumber&&T.startColumn<=R.startColumn||T.endLineNumber===R.endLineNumber&&T.endColumn>=R.endColumn)}plusRange(R){return h.plusRange(this,R)}static plusRange(R,T){let N,$,c,I;return T.startLineNumber<R.startLineNumber?(N=T.startLineNumber,$=T.startColumn):T.startLineNumber===R.startLineNumber?(N=T.startLineNumber,$=Math.min(T.startColumn,R.startColumn)):(N=R.startLineNumber,$=R.startColumn),T.endLineNumber>R.endLineNumber?(c=T.endLineNumber,I=T.endColumn):T.endLineNumber===R.endLineNumber?(c=T.endLineNumber,I=Math.max(T.endColumn,R.endColumn)):(c=R.endLineNumber,I=R.endColumn),new h(N,$,c,I)}intersectRanges(R){return h.intersectRanges(this,R)}static intersectRanges(R,T){let N=R.startLineNumber,$=R.startColumn,c=R.endLineNumber,I=R.endColumn;const E=T.startLineNumber,u=T.startColumn,k=T.endLineNumber,p=T.endColumn;return N<E?(N=E,$=u):N===E&&($=Math.max($,u)),c>k?(c=k,I=p):c===k&&(I=Math.min(I,p)),N>c||N===c&&$>I?null:new h(N,$,c,I)}equalsRange(R){return h.equalsRange(this,R)}static equalsRange(R,T){return!R&&!T?!0:!!R&&!!T&&R.startLineNumber===T.startLineNumber&&R.startColumn===T.startColumn&&R.endLineNumber===T.endLineNumber&&R.endColumn===T.endColumn}getEndPosition(){return h.getEndPosition(this)}static getEndPosition(R){return new r.$Gt(R.endLineNumber,R.endColumn)}getStartPosition(){return h.getStartPosition(this)}static getStartPosition(R){return new r.$Gt(R.startLineNumber,R.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(R,T){return new h(this.startLineNumber,this.startColumn,R,T)}setStartPosition(R,T){return new h(R,T,this.endLineNumber,this.endColumn)}collapseToStart(){return h.collapseToStart(this)}static collapseToStart(R){return new h(R.startLineNumber,R.startColumn,R.startLineNumber,R.startColumn)}collapseToEnd(){return h.collapseToEnd(this)}static collapseToEnd(R){return new h(R.endLineNumber,R.endColumn,R.endLineNumber,R.endColumn)}delta(R){return new h(this.startLineNumber+R,this.startColumn,this.endLineNumber+R,this.endColumn)}static fromPositions(R,T=R){return new h(R.lineNumber,R.column,T.lineNumber,T.column)}static lift(R){return R?new h(R.startLineNumber,R.startColumn,R.endLineNumber,R.endColumn):null}static isIRange(R){return R&&typeof R.startLineNumber=="number"&&typeof R.startColumn=="number"&&typeof R.endLineNumber=="number"&&typeof R.endColumn=="number"}static areIntersectingOrTouching(R,T){return!(R.endLineNumber<T.startLineNumber||R.endLineNumber===T.startLineNumber&&R.endColumn<T.startColumn||T.endLineNumber<R.startLineNumber||T.endLineNumber===R.startLineNumber&&T.endColumn<R.startColumn)}static areIntersecting(R,T){return!(R.endLineNumber<T.startLineNumber||R.endLineNumber===T.startLineNumber&&R.endColumn<=T.startColumn||T.endLineNumber<R.startLineNumber||T.endLineNumber===R.startLineNumber&&T.endColumn<=R.startColumn)}static compareRangesUsingStarts(R,T){if(R&&T){const c=R.startLineNumber|0,I=T.startLineNumber|0;if(c===I){const E=R.startColumn|0,u=T.startColumn|0;if(E===u){const k=R.endLineNumber|0,p=T.endLineNumber|0;if(k===p){const a=R.endColumn|0,f=T.endColumn|0;return a-f}return k-p}return E-u}return c-I}return(R?1:0)-(T?1:0)}static compareRangesUsingEnds(R,T){return R.endLineNumber===T.endLineNumber?R.endColumn===T.endColumn?R.startLineNumber===T.startLineNumber?R.startColumn-T.startColumn:R.startLineNumber-T.startLineNumber:R.endColumn-T.endColumn:R.endLineNumber-T.endLineNumber}static spansMultipleLines(R){return R.endLineNumber>R.startLineNumber}toJSON(){return this}}e.$Ht=h}),define(Ee[189],ye([1,0,31]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$It=void 0;class h{static insert(R,T){return{range:new r.$Ht(R.lineNumber,R.column,R.lineNumber,R.column),text:T,forceMoveMarkers:!0}}static delete(R){return{range:R,text:null}}static replace(R,T){return{range:R,text:T}}static replaceMove(R,T){return{range:R,text:T,forceMoveMarkers:!0}}}e.$It=h}),define(Ee[190],ye([1,0,53,31]),function(ce,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jt=e.SelectionDirection=void 0;var P;(function(T){T[T.LTR=0]="LTR",T[T.RTL=1]="RTL"})(P||(e.SelectionDirection=P={}));class R extends h.$Ht{constructor(N,$,c,I){super(N,$,c,I),this.selectionStartLineNumber=N,this.selectionStartColumn=$,this.positionLineNumber=c,this.positionColumn=I}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(N){return R.selectionsEqual(this,N)}static selectionsEqual(N,$){return N.selectionStartLineNumber===$.selectionStartLineNumber&&N.selectionStartColumn===$.selectionStartColumn&&N.positionLineNumber===$.positionLineNumber&&N.positionColumn===$.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?P.LTR:P.RTL}setEndPosition(N,$){return this.getDirection()===P.LTR?new R(this.startLineNumber,this.startColumn,N,$):new R(N,$,this.startLineNumber,this.startColumn)}getPosition(){return new r.$Gt(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new r.$Gt(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(N,$){return this.getDirection()===P.LTR?new R(N,$,this.endLineNumber,this.endColumn):new R(this.endLineNumber,this.endColumn,N,$)}static fromPositions(N,$=N){return new R(N.lineNumber,N.column,$.lineNumber,$.column)}static fromRange(N,$){return $===P.LTR?new R(N.startLineNumber,N.startColumn,N.endLineNumber,N.endColumn):new R(N.endLineNumber,N.endColumn,N.startLineNumber,N.startColumn)}static liftSelection(N){return new R(N.selectionStartLineNumber,N.selectionStartColumn,N.positionLineNumber,N.positionColumn)}static selectionsArrEqual(N,$){if(N&&!$||!N&&$)return!1;if(!N&&!$)return!0;if(N.length!==$.length)return!1;for(let c=0,I=N.length;c<I;c++)if(!this.selectionsEqual(N[c],$[c]))return!1;return!0}static isISelection(N){return N&&typeof N.selectionStartLineNumber=="number"&&typeof N.selectionStartColumn=="number"&&typeof N.positionLineNumber=="number"&&typeof N.positionColumn=="number"}static createWithDirection(N,$,c,I,E){return E===P.LTR?new R(N,$,c,I):new R(c,I,N,$)}}e.$Jt=R}),define(Ee[191],ye([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$et=void 0,e.$et={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(Ee[192],ye([1,0,27,29,137]),function(ce,e,r,h,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bu=e.WordCharacterClass=void 0,e.$cu=$;var R;(function(c){c[c.Regular=0]="Regular",c[c.Whitespace=1]="Whitespace",c[c.WordSeparator=2]="WordSeparator"})(R||(e.WordCharacterClass=R={}));class T extends P.$_t{constructor(I,E){super(R.Regular),this.e=null,this.f=null,this.g=[],this.intlSegmenterLocales=E,this.intlSegmenterLocales.length>0?this.e=new Intl.Segmenter(this.intlSegmenterLocales,{granularity:"word"}):this.e=null;for(let u=0,k=I.length;u<k;u++)this.set(I.charCodeAt(u),R.WordSeparator);this.set(r.CharCode.Space,R.Whitespace),this.set(r.CharCode.Tab,R.Whitespace)}findPrevIntlWordBeforeOrAtOffset(I,E){let u=null;for(const k of this.h(I)){if(k.index>E)break;u=k}return u}findNextIntlWordAtOrAfterOffset(I,E){for(const u of this.h(I))if(!(u.index<E))return u;return null}h(I){return this.e?this.f===I?this.g:(this.f=I,this.g=this.j(this.e.segment(I)),this.g):[]}j(I){const E=[];for(const u of I)this.k(u)&&E.push(u);return E}k(I){return!!I.isWordLike}}e.$bu=T;const N=new h.$Fc(10);function $(c,I){const E=`${c}/${I.join(",")}`;let u=N.get(E);return u||(u=new T(c,I),N.set(E,u)),u}}),define(Ee[138],ye([1,0,40,3,81]),function(ce,e,r,h,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gt=e.$ft=void 0,e.$ht=T,e.$it=$,e.$jt=c,e.$ft="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function R(E=""){let u="(-?\\d*\\.\\d\\w*)|([^";for(const k of e.$ft)E.indexOf(k)>=0||(u+="\\"+k);return u+="\\s]+)",new RegExp(u,"g")}e.$gt=R();function T(E){let u=e.$gt;if(E&&E instanceof RegExp)if(E.global)u=E;else{let k="g";E.ignoreCase&&(k+="i"),E.multiline&&(k+="m"),E.unicode&&(k+="u"),u=new RegExp(E.source,k)}return u.lastIndex=0,u}const N=new P.$7c;N.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function $(E){const u=N.unshift(E);return(0,h.$Uc)(u)}function c(E,u,k,p,a){if(u=T(u),a||(a=r.Iterable.first(N)),k.length>a.maxLen){let o=E-a.maxLen/2;return o<0?o=0:p+=o,k=k.substring(o,E+a.maxLen/2),c(E,u,k,p,a)}const f=Date.now(),d=E-1-p;let m=-1,n=null;for(let o=1;!(Date.now()-f>=a.timeBudget);o++){const t=d-a.windowSize*o;u.lastIndex=Math.max(0,t);const i=I(u,k,d,m);if(!i&&n||(n=i,t<=0))break;m=t}if(n){const o={word:n[0],startColumn:p+1+n.index,endColumn:p+1+n.index+n[0].length};return u.lastIndex=0,o}return null}function I(E,u,k,p){let a;for(;a=E.exec(u);){const f=a.index||0;if(f<=k&&E.lastIndex>=k)return a;if(p>0&&f>p)return null}return null}}),define(Ee[106],ye([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nu=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageId=void 0;var r;(function($){$[$.Null=0]="Null",$[$.PlainText=1]="PlainText"})(r||(e.LanguageId=r={}));var h;(function($){$[$.NotSet=-1]="NotSet",$[$.None=0]="None",$[$.Italic=1]="Italic",$[$.Bold=2]="Bold",$[$.Underline=4]="Underline",$[$.Strikethrough=8]="Strikethrough"})(h||(e.FontStyle=h={}));var P;(function($){$[$.None=0]="None",$[$.DefaultForeground=1]="DefaultForeground",$[$.DefaultBackground=2]="DefaultBackground"})(P||(e.ColorId=P={}));var R;(function($){$[$.Other=0]="Other",$[$.Comment=1]="Comment",$[$.String=2]="String",$[$.RegEx=3]="RegEx"})(R||(e.StandardTokenType=R={}));var T;(function($){$[$.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",$[$.TOKEN_TYPE_MASK=768]="TOKEN_TYPE_MASK",$[$.BALANCED_BRACKETS_MASK=1024]="BALANCED_BRACKETS_MASK",$[$.FONT_STYLE_MASK=30720]="FONT_STYLE_MASK",$[$.FOREGROUND_MASK=16744448]="FOREGROUND_MASK",$[$.BACKGROUND_MASK=4278190080]="BACKGROUND_MASK",$[$.ITALIC_MASK=2048]="ITALIC_MASK",$[$.BOLD_MASK=4096]="BOLD_MASK",$[$.UNDERLINE_MASK=8192]="UNDERLINE_MASK",$[$.STRIKETHROUGH_MASK=16384]="STRIKETHROUGH_MASK",$[$.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",$[$.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",$[$.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",$[$.SEMANTIC_USE_STRIKETHROUGH=8]="SEMANTIC_USE_STRIKETHROUGH",$[$.SEMANTIC_USE_FOREGROUND=16]="SEMANTIC_USE_FOREGROUND",$[$.SEMANTIC_USE_BACKGROUND=32]="SEMANTIC_USE_BACKGROUND",$[$.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",$[$.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",$[$.BALANCED_BRACKETS_OFFSET=10]="BALANCED_BRACKETS_OFFSET",$[$.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",$[$.FOREGROUND_OFFSET=15]="FOREGROUND_OFFSET",$[$.BACKGROUND_OFFSET=24]="BACKGROUND_OFFSET"})(T||(e.MetadataConsts=T={}));class N{static getLanguageId(c){return(c&T.LANGUAGEID_MASK)>>>T.LANGUAGEID_OFFSET}static getTokenType(c){return(c&T.TOKEN_TYPE_MASK)>>>T.TOKEN_TYPE_OFFSET}static containsBalancedBrackets(c){return(c&T.BALANCED_BRACKETS_MASK)!==0}static getFontStyle(c){return(c&T.FONT_STYLE_MASK)>>>T.FONT_STYLE_OFFSET}static getForeground(c){return(c&T.FOREGROUND_MASK)>>>T.FOREGROUND_OFFSET}static getBackground(c){return(c&T.BACKGROUND_MASK)>>>T.BACKGROUND_OFFSET}static getClassNameFromMetadata(c){let E="mtk"+this.getForeground(c);const u=this.getFontStyle(c);return u&h.Italic&&(E+=" mtki"),u&h.Bold&&(E+=" mtkb"),u&h.Underline&&(E+=" mtku"),u&h.Strikethrough&&(E+=" mtks"),E}static getInlineStyleFromMetadata(c,I){const E=this.getForeground(c),u=this.getFontStyle(c);let k=`color: ${I[E]};`;u&h.Italic&&(k+="font-style: italic;"),u&h.Bold&&(k+="font-weight: bold;");let p="";return u&h.Underline&&(p+=" underline"),u&h.Strikethrough&&(p+=" line-through"),p&&(k+=`text-decoration:${p};`),k}static getPresentationFromMetadata(c){const I=this.getForeground(c),E=this.getFontStyle(c);return{foreground:I,italic:!!(E&h.Italic),bold:!!(E&h.Bold),underline:!!(E&h.Underline),strikethrough:!!(E&h.Strikethrough)}}}e.$nu=N}),define(Ee[193],ye([1,0,27,106]),function(ce,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pu=e.$Ou=e.IndentAction=void 0;var P;(function($){$[$.None=0]="None",$[$.Indent=1]="Indent",$[$.IndentOutdent=2]="IndentOutdent",$[$.Outdent=3]="Outdent"})(P||(e.IndentAction=P={}));class R{constructor(c){if(this.e=null,this.f=!1,this.open=c.open,this.close=c.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray(c.notIn))for(let I=0,E=c.notIn.length;I<E;I++)switch(c.notIn[I]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK(c){switch(c){case h.StandardTokenType.Other:return!0;case h.StandardTokenType.Comment:return this.c;case h.StandardTokenType.String:return this.b;case h.StandardTokenType.RegEx:return this.d}}shouldAutoClose(c,I){if(c.getTokenCount()===0)return!0;const E=c.findTokenIndexAtOffset(I-2),u=c.getStandardTokenType(E);return this.isOK(u)}g(c,I){for(let E=c;E<=I;E++){const u=String.fromCharCode(E);if(!this.open.includes(u)&&!this.close.includes(u))return u}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(r.CharCode.Digit0,r.CharCode.Digit9)),this.e||(this.e=this.g(r.CharCode.a,r.CharCode.z)),this.e||(this.e=this.g(r.CharCode.A,r.CharCode.Z))),this.e}}e.$Ou=R;class T{constructor(c){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const I of c)N(this.autoClosingPairsOpenByStart,I.open.charAt(0),I),N(this.autoClosingPairsOpenByEnd,I.open.charAt(I.open.length-1),I),N(this.autoClosingPairsCloseByStart,I.close.charAt(0),I),N(this.autoClosingPairsCloseByEnd,I.close.charAt(I.close.length-1),I),I.close.length===1&&I.open.length===1&&N(this.autoClosingPairsCloseSingleChar,I.close,I)}}e.$Pu=T;function N($,c,I){$.has(c)?$.get(c).push(I):$.set(c,[I])}}),define(Ee[194],ye([1,0,27,137]),function(ce,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$m4=e.$l4=e.State=void 0,e.$n4=k;var P;(function(p){p[p.Invalid=0]="Invalid",p[p.Start=1]="Start",p[p.H=2]="H",p[p.HT=3]="HT",p[p.HTT=4]="HTT",p[p.HTTP=5]="HTTP",p[p.F=6]="F",p[p.FI=7]="FI",p[p.FIL=8]="FIL",p[p.BeforeColon=9]="BeforeColon",p[p.AfterColon=10]="AfterColon",p[p.AlmostThere=11]="AlmostThere",p[p.End=12]="End",p[p.Accept=13]="Accept",p[p.LastKnownState=14]="LastKnownState"})(P||(e.State=P={}));class R{constructor(a,f,d){const m=new Uint8Array(a*f);for(let n=0,o=a*f;n<o;n++)m[n]=d;this.a=m,this.rows=a,this.cols=f}get(a,f){return this.a[a*this.cols+f]}set(a,f,d){this.a[a*this.cols+f]=d}}class T{constructor(a){let f=0,d=P.Invalid;for(let n=0,o=a.length;n<o;n++){const[t,i,s]=a[n];i>f&&(f=i),t>d&&(d=t),s>d&&(d=s)}f++,d++;const m=new R(d,f,P.Invalid);for(let n=0,o=a.length;n<o;n++){const[t,i,s]=a[n];m.set(t,i,s)}this.a=m,this.b=f}nextState(a,f){return f<0||f>=this.b?P.Invalid:this.a.get(a,f)}}e.$l4=T;let N=null;function $(){return N===null&&(N=new T([[P.Start,r.CharCode.h,P.H],[P.Start,r.CharCode.H,P.H],[P.Start,r.CharCode.f,P.F],[P.Start,r.CharCode.F,P.F],[P.H,r.CharCode.t,P.HT],[P.H,r.CharCode.T,P.HT],[P.HT,r.CharCode.t,P.HTT],[P.HT,r.CharCode.T,P.HTT],[P.HTT,r.CharCode.p,P.HTTP],[P.HTT,r.CharCode.P,P.HTTP],[P.HTTP,r.CharCode.s,P.BeforeColon],[P.HTTP,r.CharCode.S,P.BeforeColon],[P.HTTP,r.CharCode.Colon,P.AfterColon],[P.F,r.CharCode.i,P.FI],[P.F,r.CharCode.I,P.FI],[P.FI,r.CharCode.l,P.FIL],[P.FI,r.CharCode.L,P.FIL],[P.FIL,r.CharCode.e,P.BeforeColon],[P.FIL,r.CharCode.E,P.BeforeColon],[P.BeforeColon,r.CharCode.Colon,P.AfterColon],[P.AfterColon,r.CharCode.Slash,P.AlmostThere],[P.AlmostThere,r.CharCode.Slash,P.End]])),N}var c;(function(p){p[p.None=0]="None",p[p.ForceTermination=1]="ForceTermination",p[p.CannotEndIn=2]="CannotEndIn"})(c||(c={}));let I=null;function E(){if(I===null){I=new h.$_t(c.None);const p=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let f=0;f<p.length;f++)I.set(p.charCodeAt(f),c.ForceTermination);const a=".,;:";for(let f=0;f<a.length;f++)I.set(a.charCodeAt(f),c.CannotEndIn)}return I}class u{static a(a,f,d,m,n){let o=n-1;do{const t=f.charCodeAt(o);if(a.get(t)!==c.CannotEndIn)break;o--}while(o>m);if(m>0){const t=f.charCodeAt(m-1),i=f.charCodeAt(o);(t===r.CharCode.OpenParen&&i===r.CharCode.CloseParen||t===r.CharCode.OpenSquareBracket&&i===r.CharCode.CloseSquareBracket||t===r.CharCode.OpenCurlyBrace&&i===r.CharCode.CloseCurlyBrace)&&o--}return{range:{startLineNumber:d,startColumn:m+1,endLineNumber:d,endColumn:o+2},url:f.substring(m,o+1)}}static computeLinks(a,f=$()){const d=E(),m=[];for(let n=1,o=a.getLineCount();n<=o;n++){const t=a.getLineContent(n),i=t.length;let s=0,g=0,l=0,w=P.Start,S=!1,D=!1,y=!1,C=!1;for(;s<i;){let A=!1;const b=t.charCodeAt(s);if(w===P.Accept){let v;switch(b){case r.CharCode.OpenParen:S=!0,v=c.None;break;case r.CharCode.CloseParen:v=S?c.None:c.ForceTermination;break;case r.CharCode.OpenSquareBracket:y=!0,D=!0,v=c.None;break;case r.CharCode.CloseSquareBracket:y=!1,v=D?c.None:c.ForceTermination;break;case r.CharCode.OpenCurlyBrace:C=!0,v=c.None;break;case r.CharCode.CloseCurlyBrace:v=C?c.None:c.ForceTermination;break;case r.CharCode.SingleQuote:case r.CharCode.DoubleQuote:case r.CharCode.BackTick:l===b?v=c.ForceTermination:l===r.CharCode.SingleQuote||l===r.CharCode.DoubleQuote||l===r.CharCode.BackTick?v=c.None:v=c.ForceTermination;break;case r.CharCode.Asterisk:v=l===r.CharCode.Asterisk?c.ForceTermination:c.None;break;case r.CharCode.Pipe:v=l===r.CharCode.Pipe?c.ForceTermination:c.None;break;case r.CharCode.Space:v=y?c.None:c.ForceTermination;break;default:v=d.get(b)}v===c.ForceTermination&&(m.push(u.a(d,t,n,g,s)),A=!0)}else if(w===P.End){let v;b===r.CharCode.OpenSquareBracket?(D=!0,v=c.None):v=d.get(b),v===c.ForceTermination?A=!0:w=P.Accept}else w=f.nextState(w,b),w===P.Invalid&&(A=!0);A&&(w=P.Start,S=!1,D=!1,C=!1,g=s+1,l=b),s++}w===P.Accept&&m.push(u.a(d,t,n,g,i))}return m}}e.$m4=u;function k(p){return!p||typeof p.getLineCount!="function"||typeof p.getLineContent!="function"?[]:u.computeLinks(p)}}),define(Ee[54],ye([1,0,25]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aw=e.$_v=e.$$v=e.ModelConstants=e.PositionAffinity=e.TrackedRangeStickiness=e.$9v=e.$8v=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.InjectedTextCursorStops=e.MinimapSectionHeaderStyle=e.MinimapPosition=e.GlyphMarginLane=e.OverviewRulerLane=void 0,e.$0v=p,e.$bw=o;var h;(function(t){t[t.Left=1]="Left",t[t.Center=2]="Center",t[t.Right=4]="Right",t[t.Full=7]="Full"})(h||(e.OverviewRulerLane=h={}));var P;(function(t){t[t.Left=1]="Left",t[t.Center=2]="Center",t[t.Right=3]="Right"})(P||(e.GlyphMarginLane=P={}));var R;(function(t){t[t.Inline=1]="Inline",t[t.Gutter=2]="Gutter"})(R||(e.MinimapPosition=R={}));var T;(function(t){t[t.Normal=1]="Normal",t[t.Underlined=2]="Underlined"})(T||(e.MinimapSectionHeaderStyle=T={}));var N;(function(t){t[t.Both=0]="Both",t[t.Right=1]="Right",t[t.Left=2]="Left",t[t.None=3]="None"})(N||(e.InjectedTextCursorStops=N={}));var $;(function(t){t[t.TextDefined=0]="TextDefined",t[t.LF=1]="LF",t[t.CRLF=2]="CRLF"})($||(e.EndOfLinePreference=$={}));var c;(function(t){t[t.LF=1]="LF",t[t.CRLF=2]="CRLF"})(c||(e.DefaultEndOfLine=c={}));var I;(function(t){t[t.LF=0]="LF",t[t.CRLF=1]="CRLF"})(I||(e.EndOfLineSequence=I={}));class E{get originalIndentSize(){return this.a?"tabSize":this.indentSize}constructor(i){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,i.tabSize|0),i.indentSize==="tabSize"?(this.indentSize=this.tabSize,this.a=!0):(this.indentSize=Math.max(1,i.indentSize|0),this.a=!1),this.insertSpaces=!!i.insertSpaces,this.defaultEOL=i.defaultEOL|0,this.trimAutoWhitespace=!!i.trimAutoWhitespace,this.bracketPairColorizationOptions=i.bracketPairColorizationOptions}equals(i){return this.tabSize===i.tabSize&&this.a===i.a&&this.indentSize===i.indentSize&&this.insertSpaces===i.insertSpaces&&this.defaultEOL===i.defaultEOL&&this.trimAutoWhitespace===i.trimAutoWhitespace&&(0,r.$fo)(this.bracketPairColorizationOptions,i.bracketPairColorizationOptions)}createChangeEvent(i){return{tabSize:this.tabSize!==i.tabSize,indentSize:this.indentSize!==i.indentSize,insertSpaces:this.insertSpaces!==i.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==i.trimAutoWhitespace}}}e.$8v=E;class u{constructor(i,s){this._findMatchBrand=void 0,this.range=i,this.matches=s}}e.$9v=u;var k;(function(t){t[t.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",t[t.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",t[t.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",t[t.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(k||(e.TrackedRangeStickiness=k={}));function p(t){return t&&typeof t.read=="function"}var a;(function(t){t[t.Left=0]="Left",t[t.Right=1]="Right",t[t.None=2]="None",t[t.LeftOfInjectedText=3]="LeftOfInjectedText",t[t.RightOfInjectedText=4]="RightOfInjectedText"})(a||(e.PositionAffinity=a={}));var f;(function(t){t[t.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(f||(e.ModelConstants=f={}));class d{constructor(i,s,g,l,w,S){this.identifier=i,this.range=s,this.text=g,this.forceMoveMarkers=l,this.isAutoWhitespaceEdit=w,this._isTracked=S}}e.$$v=d;class m{constructor(i,s,g){this.regex=i,this.wordSeparators=s,this.simpleSearch=g}}e.$_v=m;class n{constructor(i,s,g){this.reverseEdits=i,this.changes=s,this.trimAutoWhitespaceLineNumbers=g}}e.$aw=n;function o(t){return!t.isTooLargeForSyncing()&&!t.isForSimpleWidget}}),define(Ee[195],ye([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ZC=e.NodeColor=e.$YC=void 0,e.$1C=P,e.$2C=R,e.$3C=c,e.$4C=I,e.$5C=E,e.$6C=u,e.$7C=k,e.$8C=p;class r{constructor(f,d){this.piece=f,this.color=d,this.size_left=0,this.lf_left=0,this.parent=this,this.left=this,this.right=this}next(){if(this.right!==e.$ZC)return P(this.right);let f=this;for(;f.parent!==e.$ZC&&f.parent.left!==f;)f=f.parent;return f.parent===e.$ZC?e.$ZC:f.parent}prev(){if(this.left!==e.$ZC)return R(this.left);let f=this;for(;f.parent!==e.$ZC&&f.parent.right!==f;)f=f.parent;return f.parent===e.$ZC?e.$ZC:f.parent}detach(){this.parent=null,this.left=null,this.right=null}}e.$YC=r;var h;(function(a){a[a.Black=0]="Black",a[a.Red=1]="Red"})(h||(e.NodeColor=h={})),e.$ZC=new r(null,h.Black),e.$ZC.parent=e.$ZC,e.$ZC.left=e.$ZC,e.$ZC.right=e.$ZC,e.$ZC.color=h.Black;function P(a){for(;a.left!==e.$ZC;)a=a.left;return a}function R(a){for(;a.right!==e.$ZC;)a=a.right;return a}function T(a){return a===e.$ZC?0:a.size_left+a.piece.length+T(a.right)}function N(a){return a===e.$ZC?0:a.lf_left+a.piece.lineFeedCnt+N(a.right)}function $(){e.$ZC.parent=e.$ZC}function c(a,f){const d=f.right;d.size_left+=f.size_left+(f.piece?f.piece.length:0),d.lf_left+=f.lf_left+(f.piece?f.piece.lineFeedCnt:0),f.right=d.left,d.left!==e.$ZC&&(d.left.parent=f),d.parent=f.parent,f.parent===e.$ZC?a.root=d:f.parent.left===f?f.parent.left=d:f.parent.right=d,d.left=f,f.parent=d}function I(a,f){const d=f.left;f.left=d.right,d.right!==e.$ZC&&(d.right.parent=f),d.parent=f.parent,f.size_left-=d.size_left+(d.piece?d.piece.length:0),f.lf_left-=d.lf_left+(d.piece?d.piece.lineFeedCnt:0),f.parent===e.$ZC?a.root=d:f===f.parent.right?f.parent.right=d:f.parent.left=d,d.right=f,f.parent=d}function E(a,f){let d,m;if(f.left===e.$ZC?(m=f,d=m.right):f.right===e.$ZC?(m=f,d=m.left):(m=P(f.right),d=m.right),m===a.root){a.root=d,d.color=h.Black,f.detach(),$(),a.root.parent=e.$ZC;return}const n=m.color===h.Red;if(m===m.parent.left?m.parent.left=d:m.parent.right=d,m===f?(d.parent=m.parent,p(a,d)):(m.parent===f?d.parent=m:d.parent=m.parent,p(a,d),m.left=f.left,m.right=f.right,m.parent=f.parent,m.color=f.color,f===a.root?a.root=m:f===f.parent.left?f.parent.left=m:f.parent.right=m,m.left!==e.$ZC&&(m.left.parent=m),m.right!==e.$ZC&&(m.right.parent=m),m.size_left=f.size_left,m.lf_left=f.lf_left,p(a,m)),f.detach(),d.parent.left===d){const t=T(d),i=N(d);if(t!==d.parent.size_left||i!==d.parent.lf_left){const s=t-d.parent.size_left,g=i-d.parent.lf_left;d.parent.size_left=t,d.parent.lf_left=i,k(a,d.parent,s,g)}}if(p(a,d.parent),n){$();return}let o;for(;d!==a.root&&d.color===h.Black;)d===d.parent.left?(o=d.parent.right,o.color===h.Red&&(o.color=h.Black,d.parent.color=h.Red,c(a,d.parent),o=d.parent.right),o.left.color===h.Black&&o.right.color===h.Black?(o.color=h.Red,d=d.parent):(o.right.color===h.Black&&(o.left.color=h.Black,o.color=h.Red,I(a,o),o=d.parent.right),o.color=d.parent.color,d.parent.color=h.Black,o.right.color=h.Black,c(a,d.parent),d=a.root)):(o=d.parent.left,o.color===h.Red&&(o.color=h.Black,d.parent.color=h.Red,I(a,d.parent),o=d.parent.left),o.left.color===h.Black&&o.right.color===h.Black?(o.color=h.Red,d=d.parent):(o.left.color===h.Black&&(o.right.color=h.Black,o.color=h.Red,c(a,o),o=d.parent.left),o.color=d.parent.color,d.parent.color=h.Black,o.left.color=h.Black,I(a,d.parent),d=a.root));d.color=h.Black,$()}function u(a,f){for(p(a,f);f!==a.root&&f.parent.color===h.Red;)if(f.parent===f.parent.parent.left){const d=f.parent.parent.right;d.color===h.Red?(f.parent.color=h.Black,d.color=h.Black,f.parent.parent.color=h.Red,f=f.parent.parent):(f===f.parent.right&&(f=f.parent,c(a,f)),f.parent.color=h.Black,f.parent.parent.color=h.Red,I(a,f.parent.parent))}else{const d=f.parent.parent.left;d.color===h.Red?(f.parent.color=h.Black,d.color=h.Black,f.parent.parent.color=h.Red,f=f.parent.parent):(f===f.parent.left&&(f=f.parent,I(a,f)),f.parent.color=h.Black,f.parent.parent.color=h.Red,c(a,f.parent.parent))}a.root.color=h.Black}function k(a,f,d,m){for(;f!==a.root&&f!==e.$ZC;)f.parent.left===f&&(f.parent.size_left+=d,f.parent.lf_left+=m),f=f.parent}function p(a,f){let d=0,m=0;if(f!==a.root){for(;f!==a.root&&f===f.parent.right;)f=f.parent;if(f!==a.root)for(f=f.parent,d=T(f.left)-f.size_left,m=N(f.left)-f.lf_left,f.size_left+=d,f.lf_left+=m;f!==a.root&&(d!==0||m!==0);)f.parent.left===f&&(f.parent.size_left+=d,f.parent.lf_left+=m),f=f.parent}}}),define(Ee[196],ye([1,0,19,84]),function(ce,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gw=e.$fw=e.$ew=void 0;class P{constructor($){this.a=$,this.b=new Uint32Array($.length),this.c=new Int32Array(1),this.c[0]=-1}getCount(){return this.a.length}insertValues($,c){$=(0,h.$cf)($);const I=this.a,E=this.b,u=c.length;return u===0?!1:(this.a=new Uint32Array(I.length+u),this.a.set(I.subarray(0,$),0),this.a.set(I.subarray($),$+u),this.a.set(c,$),$-1<this.c[0]&&(this.c[0]=$-1),this.b=new Uint32Array(this.a.length),this.c[0]>=0&&this.b.set(E.subarray(0,this.c[0]+1)),!0)}setValue($,c){return $=(0,h.$cf)($),c=(0,h.$cf)(c),this.a[$]===c?!1:(this.a[$]=c,$-1<this.c[0]&&(this.c[0]=$-1),!0)}removeValues($,c){$=(0,h.$cf)($),c=(0,h.$cf)(c);const I=this.a,E=this.b;if($>=I.length)return!1;const u=I.length-$;return c>=u&&(c=u),c===0?!1:(this.a=new Uint32Array(I.length-c),this.a.set(I.subarray(0,$),0),this.a.set(I.subarray($+c),$),this.b=new Uint32Array(this.a.length),$-1<this.c[0]&&(this.c[0]=$-1),this.c[0]>=0&&this.b.set(E.subarray(0,this.c[0]+1)),!0)}getTotalSum(){return this.a.length===0?0:this.d(this.a.length-1)}getPrefixSum($){return $<0?0:($=(0,h.$cf)($),this.d($))}d($){if($<=this.c[0])return this.b[$];let c=this.c[0]+1;c===0&&(this.b[0]=this.a[0],c++),$>=this.a.length&&($=this.a.length-1);for(let I=c;I<=$;I++)this.b[I]=this.b[I-1]+this.a[I];return this.c[0]=Math.max(this.c[0],$),this.b[$]}getIndexOf($){$=Math.floor($),this.getTotalSum();let c=0,I=this.a.length-1,E=0,u=0,k=0;for(;c<=I;)if(E=c+(I-c)/2|0,u=this.b[E],k=u-this.a[E],$<k)I=E-1;else if($>=u)c=E+1;else break;return new T(E,$-k)}}e.$ew=P;class R{constructor($){this.a=$,this.b=!1,this.c=-1,this.d=[],this.e=[]}getTotalSum(){return this.g(),this.e.length}getPrefixSum($){return this.g(),$===0?0:this.d[$-1]}getIndexOf($){this.g();const c=this.e[$],I=c>0?this.d[c-1]:0;return new T(c,$-I)}removeValues($,c){this.a.splice($,c),this.f($)}insertValues($,c){this.a=(0,r.$Xb)(this.a,$,c),this.f($)}f($){this.b=!1,this.c=Math.min(this.c,$-1)}g(){if(!this.b){for(let $=this.c+1,c=this.a.length;$<c;$++){const I=this.a[$],E=$>0?this.d[$-1]:0;this.d[$]=E+I;for(let u=0;u<I;u++)this.e[E+u]=$}this.d.length=this.a.length,this.e.length=this.d[this.d.length-1],this.b=!0,this.c=this.a.length-1}}setValue($,c){this.a[$]!==c&&(this.a[$]=c,this.f($))}}e.$fw=R;class T{constructor($,c){this.index=$,this.remainder=c,this._prefixSumIndexOfResultBrand=void 0,this.index=$,this.remainder=c}}e.$gw=T}),define(Ee[197],ye([1,0,13,53,196]),function(ce,e,r,h,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hw=void 0;class R{constructor(N,$,c,I){this.d=N,this.f=$,this.g=c,this.h=I,this.j=null,this.k=null}dispose(){this.f.length=0}get version(){return this.h}getText(){return this.k===null&&(this.k=this.f.join(this.g)),this.k}onEvents(N){N.eol&&N.eol!==this.g&&(this.g=N.eol,this.j=null);const $=N.changes;for(const c of $)this.o(c.range),this.p(new h.$Gt(c.range.startLineNumber,c.range.startColumn),c.text);this.h=N.versionId,this.k=null}l(){if(!this.j){const N=this.g.length,$=this.f.length,c=new Uint32Array($);for(let I=0;I<$;I++)c[I]=this.f[I].length+N;this.j=new P.$ew(c)}}n(N,$){this.f[N]=$,this.j&&this.j.setValue(N,this.f[N].length+this.g.length)}o(N){if(N.startLineNumber===N.endLineNumber){if(N.startColumn===N.endColumn)return;this.n(N.startLineNumber-1,this.f[N.startLineNumber-1].substring(0,N.startColumn-1)+this.f[N.startLineNumber-1].substring(N.endColumn-1));return}this.n(N.startLineNumber-1,this.f[N.startLineNumber-1].substring(0,N.startColumn-1)+this.f[N.endLineNumber-1].substring(N.endColumn-1)),this.f.splice(N.startLineNumber,N.endLineNumber-N.startLineNumber),this.j&&this.j.removeValues(N.startLineNumber,N.endLineNumber-N.startLineNumber)}p(N,$){if($.length===0)return;const c=(0,r.$tf)($);if(c.length===1){this.n(N.lineNumber-1,this.f[N.lineNumber-1].substring(0,N.column-1)+c[0]+this.f[N.lineNumber-1].substring(N.column-1));return}c[c.length-1]+=this.f[N.lineNumber-1].substring(N.column-1),this.n(N.lineNumber-1,this.f[N.lineNumber-1].substring(0,N.column-1)+c[0]);const I=new Uint32Array(c.length-1);for(let E=1;E<c.length;E++)this.f.splice(N.lineNumber+E-1,0,c[E]),I[E-1]=c[E].length+this.g.length;this.j&&this.j.insertValues(N.lineNumber,I)}}e.$hw=R}),define(Ee[107],ye([1,0,27,13,192,53,31,54]),function(ce,e,r,h,P,R,T,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bD=e.$_C=e.$9C=void 0,e.$0C=I,e.$$C=E,e.$aD=f,h=We(h);const $=999;class c{constructor(n,o,t,i){this.searchString=n,this.isRegex=o,this.matchCase=t,this.wordSeparators=i}parseSearchRequest(){if(this.searchString==="")return null;let n;this.isRegex?n=I(this.searchString):n=this.searchString.indexOf(`
`)>=0;let o=null;try{o=h.$rf(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:n,global:!0,unicode:!0})}catch{return null}if(!o)return null;let t=!this.isRegex&&!n;return t&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(t=this.matchCase),new N.$_v(o,this.wordSeparators?(0,P.$cu)(this.wordSeparators,[]):null,t?this.searchString:null)}}e.$9C=c;function I(m){if(!m||m.length===0)return!1;for(let n=0,o=m.length;n<o;n++){const t=m.charCodeAt(n);if(t===r.CharCode.LineFeed)return!0;if(t===r.CharCode.Backslash){if(n++,n>=o)break;const i=m.charCodeAt(n);if(i===r.CharCode.n||i===r.CharCode.r||i===r.CharCode.W)return!0}}return!1}function E(m,n,o){if(!o)return new N.$9v(m,null);const t=[];for(let i=0,s=n.length;i<s;i++)t[i]=n[i];return new N.$9v(m,t)}class u{constructor(n){const o=[];let t=0;for(let i=0,s=n.length;i<s;i++)n.charCodeAt(i)===r.CharCode.LineFeed&&(o[t++]=i);this.a=o}findLineFeedCountBeforeOffset(n){const o=this.a;let t=0,i=o.length-1;if(i===-1||n<=o[0])return 0;for(;t<i;){const s=t+((i-t)/2>>0);o[s]>=n?i=s-1:o[s+1]>=n?(t=s,i=s):t=s+1}return t+1}}class k{static findMatches(n,o,t,i,s){const g=o.parseSearchRequest();return g?g.regex.multiline?this.b(n,t,new d(g.wordSeparators,g.regex),i,s):this.c(n,t,g,i,s):[]}static a(n,o,t,i,s,g){let l,w=0;i?(w=i.findLineFeedCountBeforeOffset(s),l=o+s+w):l=o+s;let S;if(i){const A=i.findLineFeedCountBeforeOffset(s+g.length)-w;S=l+g.length+A}else S=l+g.length;const D=n.getPositionAt(l),y=n.getPositionAt(S);return new T.$Ht(D.lineNumber,D.column,y.lineNumber,y.column)}static b(n,o,t,i,s){const g=n.getOffsetAt(o.getStartPosition()),l=n.getValueInRange(o,N.EndOfLinePreference.LF),w=n.getEOL()===`\r
`?new u(l):null,S=[];let D=0,y;for(t.reset(0);y=t.next(l);)if(S[D++]=E(this.a(n,g,l,w,y.index,y[0]),y,i),D>=s)return S;return S}static c(n,o,t,i,s){const g=[];let l=0;if(o.startLineNumber===o.endLineNumber){const S=n.getLineContent(o.startLineNumber).substring(o.startColumn-1,o.endColumn-1);return l=this.d(t,S,o.startLineNumber,o.startColumn-1,l,g,i,s),g}const w=n.getLineContent(o.startLineNumber).substring(o.startColumn-1);l=this.d(t,w,o.startLineNumber,o.startColumn-1,l,g,i,s);for(let S=o.startLineNumber+1;S<o.endLineNumber&&l<s;S++)l=this.d(t,n.getLineContent(S),S,0,l,g,i,s);if(l<s){const S=n.getLineContent(o.endLineNumber).substring(0,o.endColumn-1);l=this.d(t,S,o.endLineNumber,0,l,g,i,s)}return g}static d(n,o,t,i,s,g,l,w){const S=n.wordSeparators;if(!l&&n.simpleSearch){const C=n.simpleSearch,A=C.length,b=o.length;let v=-A;for(;(v=o.indexOf(C,v+A))!==-1;)if((!S||f(S,o,b,v,A))&&(g[s++]=new N.$9v(new T.$Ht(t,v+1+i,t,v+1+A+i),null),s>=w))return s;return s}const D=new d(n.wordSeparators,n.regex);let y;D.reset(0);do if(y=D.next(o),y&&(g[s++]=E(new T.$Ht(t,y.index+1+i,t,y.index+1+y[0].length+i),y,l),s>=w))return s;while(y);return s}static findNextMatch(n,o,t,i){const s=o.parseSearchRequest();if(!s)return null;const g=new d(s.wordSeparators,s.regex);return s.regex.multiline?this.e(n,t,g,i):this.f(n,t,g,i)}static e(n,o,t,i){const s=new R.$Gt(o.lineNumber,1),g=n.getOffsetAt(s),l=n.getLineCount(),w=n.getValueInRange(new T.$Ht(s.lineNumber,s.column,l,n.getLineMaxColumn(l)),N.EndOfLinePreference.LF),S=n.getEOL()===`\r
`?new u(w):null;t.reset(o.column-1);const D=t.next(w);return D?E(this.a(n,g,w,S,D.index,D[0]),D,i):o.lineNumber!==1||o.column!==1?this.e(n,new R.$Gt(1,1),t,i):null}static f(n,o,t,i){const s=n.getLineCount(),g=o.lineNumber,l=n.getLineContent(g),w=this.g(t,l,g,o.column,i);if(w)return w;for(let S=1;S<=s;S++){const D=(g+S-1)%s,y=n.getLineContent(D+1),C=this.g(t,y,D+1,1,i);if(C)return C}return null}static g(n,o,t,i,s){n.reset(i-1);const g=n.next(o);return g?E(new T.$Ht(t,g.index+1,t,g.index+1+g[0].length),g,s):null}static findPreviousMatch(n,o,t,i){const s=o.parseSearchRequest();if(!s)return null;const g=new d(s.wordSeparators,s.regex);return s.regex.multiline?this.h(n,t,g,i):this.j(n,t,g,i)}static h(n,o,t,i){const s=this.b(n,new T.$Ht(1,1,o.lineNumber,o.column),t,i,10*$);if(s.length>0)return s[s.length-1];const g=n.getLineCount();return o.lineNumber!==g||o.column!==n.getLineMaxColumn(g)?this.h(n,new R.$Gt(g,n.getLineMaxColumn(g)),t,i):null}static j(n,o,t,i){const s=n.getLineCount(),g=o.lineNumber,l=n.getLineContent(g).substring(0,o.column-1),w=this.k(t,l,g,i);if(w)return w;for(let S=1;S<=s;S++){const D=(s+g-S-1)%s,y=n.getLineContent(D+1),C=this.k(t,y,D+1,i);if(C)return C}return null}static k(n,o,t,i){let s=null,g;for(n.reset(0);g=n.next(o);)s=E(new T.$Ht(t,g.index+1,t,g.index+1+g[0].length),g,i);return s}}e.$_C=k;function p(m,n,o,t,i){if(t===0)return!0;const s=n.charCodeAt(t-1);if(m.get(s)!==P.WordCharacterClass.Regular||s===r.CharCode.CarriageReturn||s===r.CharCode.LineFeed)return!0;if(i>0){const g=n.charCodeAt(t);if(m.get(g)!==P.WordCharacterClass.Regular)return!0}return!1}function a(m,n,o,t,i){if(t+i===o)return!0;const s=n.charCodeAt(t+i);if(m.get(s)!==P.WordCharacterClass.Regular||s===r.CharCode.CarriageReturn||s===r.CharCode.LineFeed)return!0;if(i>0){const g=n.charCodeAt(t+i-1);if(m.get(g)!==P.WordCharacterClass.Regular)return!0}return!1}function f(m,n,o,t,i){return p(m,n,o,t,i)&&a(m,n,o,t,i)}class d{constructor(n,o){this._wordSeparators=n,this.a=o,this.b=-1,this.c=0}reset(n){this.a.lastIndex=n,this.b=-1,this.c=0}next(n){const o=n.length;let t;do{if(this.b+this.c===o||(t=this.a.exec(n),!t))return null;const i=t.index,s=t[0].length;if(i===this.b&&s===this.c){if(s===0){h.$Nf(n,o,this.a.lastIndex)>65535?this.a.lastIndex+=2:this.a.lastIndex+=1;continue}return null}if(this.b=i,this.c=s,!this._wordSeparators||f(this._wordSeparators,n,o,i,s))return t}while(t);return null}}e.$bD=d}),define(Ee[139],ye([1,0,27,53,31,54,195,107]),function(ce,e,r,h,P,R,T,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gD=e.$fD=e.$eD=void 0,e.$cD=E,e.$dD=u;const $=65535;function c(m){let n;return m[m.length-1]<65536?n=new Uint16Array(m.length):n=new Uint32Array(m.length),n.set(m,0),n}class I{constructor(n,o,t,i,s){this.lineStarts=n,this.cr=o,this.lf=t,this.crlf=i,this.isBasicASCII=s}}function E(m,n=!0){const o=[0];let t=1;for(let i=0,s=m.length;i<s;i++){const g=m.charCodeAt(i);g===r.CharCode.CarriageReturn?i+1<s&&m.charCodeAt(i+1)===r.CharCode.LineFeed?(o[t++]=i+2,i++):o[t++]=i+1:g===r.CharCode.LineFeed&&(o[t++]=i+1)}return n?c(o):o}function u(m,n){m.length=0,m[0]=0;let o=1,t=0,i=0,s=0,g=!0;for(let w=0,S=n.length;w<S;w++){const D=n.charCodeAt(w);D===r.CharCode.CarriageReturn?w+1<S&&n.charCodeAt(w+1)===r.CharCode.LineFeed?(s++,m[o++]=w+2,w++):(t++,m[o++]=w+1):D===r.CharCode.LineFeed?(i++,m[o++]=w+1):g&&D!==r.CharCode.Tab&&(D<32||D>126)&&(g=!1)}const l=new I(c(m),t,i,s,g);return m.length=0,l}class k{constructor(n,o,t,i,s){this.bufferIndex=n,this.start=o,this.end=t,this.lineFeedCnt=i,this.length=s}}e.$eD=k;class p{constructor(n,o){this.buffer=n,this.lineStarts=o}}e.$fD=p;class a{constructor(n,o){this.a=[],this.c=n,this.d=o,this.b=0,n.root!==T.$ZC&&n.iterate(n.root,t=>(t!==T.$ZC&&this.a.push(t.piece),!0))}read(){return this.a.length===0?this.b===0?(this.b++,this.d):null:this.b>this.a.length-1?null:this.b===0?this.d+this.c.getPieceContent(this.a[this.b++]):this.c.getPieceContent(this.a[this.b++])}}class f{constructor(n){this.a=n,this.b=[]}get(n){for(let o=this.b.length-1;o>=0;o--){const t=this.b[o];if(t.nodeStartOffset<=n&&t.nodeStartOffset+t.node.piece.length>=n)return t}return null}get2(n){for(let o=this.b.length-1;o>=0;o--){const t=this.b[o];if(t.nodeStartLineNumber&&t.nodeStartLineNumber<n&&t.nodeStartLineNumber+t.node.piece.lineFeedCnt>=n)return t}return null}set(n){this.b.length>=this.a&&this.b.shift(),this.b.push(n)}validate(n){let o=!1;const t=this.b;for(let i=0;i<t.length;i++){const s=t[i];if(s.node.parent===null||s.nodeStartOffset>=n){t[i]=null,o=!0;continue}}if(o){const i=[];for(const s of t)s!==null&&i.push(s);this.b=i}}}class d{constructor(n,o,t){this.create(n,o,t)}create(n,o,t){this.a=[new p("",[0])],this.g={line:0,column:0},this.root=T.$ZC,this.b=1,this.c=0,this.d=o,this.e=o.length,this.f=t;let i=null;for(let s=0,g=n.length;s<g;s++)if(n[s].buffer.length>0){n[s].lineStarts||(n[s].lineStarts=E(n[s].buffer));const l=new k(s+1,{line:0,column:0},{line:n[s].lineStarts.length-1,column:n[s].buffer.length-n[s].lineStarts[n[s].lineStarts.length-1]},n[s].lineStarts.length-1,n[s].buffer.length);this.a.push(n[s]),i=this.S(i,l)}this.h=new f(1),this.j={lineNumber:0,value:""},this.y()}normalizeEOL(n){const o=$,t=o-Math.floor(o/3),i=t*2;let s="",g=0;const l=[];if(this.iterate(this.root,w=>{const S=this.R(w),D=S.length;if(g<=t||g+D<i)return s+=S,g+=D,!0;const y=s.replace(/\r\n|\r|\n/g,n);return l.push(new p(y,E(y))),s=S,g=D,!0}),g>0){const w=s.replace(/\r\n|\r|\n/g,n);l.push(new p(w,E(w)))}this.create(l,n,!0)}getEOL(){return this.d}setEOL(n){this.d=n,this.e=this.d.length,this.normalizeEOL(n)}createSnapshot(n){return new a(this,n)}equal(n){if(this.getLength()!==n.getLength()||this.getLineCount()!==n.getLineCount())return!1;let o=0;return this.iterate(this.root,i=>{if(i===T.$ZC)return!0;const s=this.R(i),g=s.length,l=n.G(o),w=n.G(o+g),S=n.getValueInRange2(l,w);return o+=g,s===S})}getOffsetAt(n,o){let t=0,i=this.root;for(;i!==T.$ZC;)if(i.left!==T.$ZC&&i.lf_left+1>=n)i=i.left;else if(i.lf_left+i.piece.lineFeedCnt+1>=n){t+=i.size_left;const s=this.B(i,n-i.lf_left-2);return t+=s+o-1}else n-=i.lf_left+i.piece.lineFeedCnt,t+=i.size_left+i.piece.length,i=i.right;return t}getPositionAt(n){n=Math.floor(n),n=Math.max(0,n);let o=this.root,t=0;const i=n;for(;o!==T.$ZC;)if(o.size_left!==0&&o.size_left>=n)o=o.left;else if(o.size_left+o.piece.length>=n){const s=this.A(o,n-o.size_left);if(t+=o.lf_left+s.index,s.index===0){const g=this.getOffsetAt(t+1,1),l=i-g;return new h.$Gt(t+1,l+1)}return new h.$Gt(t+1,s.remainder+1)}else if(n-=o.size_left+o.piece.length,t+=o.lf_left+o.piece.lineFeedCnt,o.right===T.$ZC){const s=this.getOffsetAt(t+1,1),g=i-n-s;return new h.$Gt(t+1,g+1)}else o=o.right;return new h.$Gt(1,1)}getValueInRange(n,o){if(n.startLineNumber===n.endLineNumber&&n.startColumn===n.endColumn)return"";const t=this.H(n.startLineNumber,n.startColumn),i=this.H(n.endLineNumber,n.endColumn),s=this.getValueInRange2(t,i);return o?o!==this.d||!this.f?s.replace(/\r\n|\r|\n/g,o):o===this.getEOL()&&this.f?s:s.replace(/\r\n|\r|\n/g,o):s}getValueInRange2(n,o){if(n.node===o.node){const l=n.node,w=this.a[l.piece.bufferIndex].buffer,S=this.u(l.piece.bufferIndex,l.piece.start);return w.substring(S+n.remainder,S+o.remainder)}let t=n.node;const i=this.a[t.piece.bufferIndex].buffer,s=this.u(t.piece.bufferIndex,t.piece.start);let g=i.substring(s+n.remainder,s+t.piece.length);for(t=t.next();t!==T.$ZC;){const l=this.a[t.piece.bufferIndex].buffer,w=this.u(t.piece.bufferIndex,t.piece.start);if(t===o.node){g+=l.substring(w,w+o.remainder);break}else g+=l.substr(w,t.piece.length);t=t.next()}return g}getLinesContent(){const n=[];let o=0,t="",i=!1;return this.iterate(this.root,s=>{if(s===T.$ZC)return!0;const g=s.piece;let l=g.length;if(l===0)return!0;const w=this.a[g.bufferIndex].buffer,S=this.a[g.bufferIndex].lineStarts,D=g.start.line,y=g.end.line;let C=S[D]+g.start.column;if(i&&(w.charCodeAt(C)===r.CharCode.LineFeed&&(C++,l--),n[o++]=t,t="",i=!1,l===0))return!0;if(D===y)return!this.f&&w.charCodeAt(C+l-1)===r.CharCode.CarriageReturn?(i=!0,t+=w.substr(C,l-1)):t+=w.substr(C,l),!0;t+=this.f?w.substring(C,Math.max(C,S[D+1]-this.e)):w.substring(C,S[D+1]).replace(/(\r\n|\r|\n)$/,""),n[o++]=t;for(let A=D+1;A<y;A++)t=this.f?w.substring(S[A],S[A+1]-this.e):w.substring(S[A],S[A+1]).replace(/(\r\n|\r|\n)$/,""),n[o++]=t;return!this.f&&w.charCodeAt(S[y]+g.end.column-1)===r.CharCode.CarriageReturn?(i=!0,g.end.column===0?o--:t=w.substr(S[y],g.end.column-1)):t=w.substr(S[y],g.end.column),!0}),i&&(n[o++]=t,t=""),n[o++]=t,n}getLength(){return this.c}getLineCount(){return this.b}getLineContent(n){return this.j.lineNumber===n?this.j.value:(this.j.lineNumber=n,n===this.b?this.j.value=this.getLineRawContent(n):this.f?this.j.value=this.getLineRawContent(n,this.e):this.j.value=this.getLineRawContent(n).replace(/(\r\n|\r|\n)$/,""),this.j.value)}l(n){if(n.remainder===n.node.piece.length){const o=n.node.next();if(!o)return 0;const t=this.a[o.piece.bufferIndex],i=this.u(o.piece.bufferIndex,o.piece.start);return t.buffer.charCodeAt(i)}else{const o=this.a[n.node.piece.bufferIndex],i=this.u(n.node.piece.bufferIndex,n.node.piece.start)+n.remainder;return o.buffer.charCodeAt(i)}}getLineCharCode(n,o){const t=this.H(n,o+1);return this.l(t)}getLineLength(n){if(n===this.getLineCount()){const o=this.getOffsetAt(n,1);return this.getLength()-o}return this.getOffsetAt(n+1,1)-this.getOffsetAt(n,1)-this.e}getCharCode(n){const o=this.G(n);return this.l(o)}getNearestChunk(n){const o=this.G(n);if(o.remainder===o.node.piece.length){const t=o.node.next();if(!t||t===T.$ZC)return"";const i=this.a[t.piece.bufferIndex],s=this.u(t.piece.bufferIndex,t.piece.start);return i.buffer.substring(s,s+t.piece.length)}else{const t=this.a[o.node.piece.bufferIndex],i=this.u(o.node.piece.bufferIndex,o.node.piece.start),s=i+o.remainder,g=i+o.node.piece.length;return t.buffer.substring(s,g)}}findMatchesInNode(n,o,t,i,s,g,l,w,S,D,y){const C=this.a[n.piece.bufferIndex],A=this.u(n.piece.bufferIndex,n.piece.start),b=this.u(n.piece.bufferIndex,s),v=this.u(n.piece.bufferIndex,g);let L;const O={line:0,column:0};let M,j;o._wordSeparators?(M=C.buffer.substring(b,v),j=z=>z+b,o.reset(0)):(M=C.buffer,j=z=>z,o.reset(b));do if(L=o.next(M),L){if(j(L.index)>=v)return D;this.s(n,j(L.index)-A,O);const z=this.t(n.piece.bufferIndex,s,O),F=O.line===s.line?O.column-s.column+i:O.column+1,B=F+L[0].length;if(y[D++]=(0,N.$$C)(new P.$Ht(t+z,F,t+z,B),L,w),j(L.index)+L[0].length>=v||D>=S)return D}while(L);return D}findMatchesLineByLine(n,o,t,i){const s=[];let g=0;const l=new N.$bD(o.wordSeparators,o.regex);let w=this.H(n.startLineNumber,n.startColumn);if(w===null)return[];const S=this.H(n.endLineNumber,n.endColumn);if(S===null)return[];let D=this.s(w.node,w.remainder);const y=this.s(S.node,S.remainder);if(w.node===S.node)return this.findMatchesInNode(w.node,l,n.startLineNumber,n.startColumn,D,y,o,t,i,g,s),s;let C=n.startLineNumber,A=w.node;for(;A!==S.node;){const v=this.t(A.piece.bufferIndex,D,A.piece.end);if(v>=1){const O=this.a[A.piece.bufferIndex].lineStarts,M=this.u(A.piece.bufferIndex,A.piece.start),j=O[D.line+v],z=C===n.startLineNumber?n.startColumn:1;if(g=this.findMatchesInNode(A,l,C,z,D,this.s(A,j-M),o,t,i,g,s),g>=i)return s;C+=v}const L=C===n.startLineNumber?n.startColumn-1:0;if(C===n.endLineNumber){const O=this.getLineContent(C).substring(L,n.endColumn-1);return g=this.n(o,l,O,n.endLineNumber,L,g,s,t,i),s}if(g=this.n(o,l,this.getLineContent(C).substr(L),C,L,g,s,t,i),g>=i)return s;C++,w=this.H(C,1),A=w.node,D=this.s(w.node,w.remainder)}if(C===n.endLineNumber){const v=C===n.startLineNumber?n.startColumn-1:0,L=this.getLineContent(C).substring(v,n.endColumn-1);return g=this.n(o,l,L,n.endLineNumber,v,g,s,t,i),s}const b=C===n.startLineNumber?n.startColumn:1;return g=this.findMatchesInNode(S.node,l,C,b,D,y,o,t,i,g,s),s}n(n,o,t,i,s,g,l,w,S){const D=n.wordSeparators;if(!w&&n.simpleSearch){const C=n.simpleSearch,A=C.length,b=t.length;let v=-A;for(;(v=t.indexOf(C,v+A))!==-1;)if((!D||(0,N.$aD)(D,t,b,v,A))&&(l[g++]=new R.$9v(new P.$Ht(i,v+1+s,i,v+1+A+s),null),g>=S))return g;return g}let y;o.reset(0);do if(y=o.next(t),y&&(l[g++]=(0,N.$$C)(new P.$Ht(i,y.index+1+s,i,y.index+1+y[0].length+s),y,w),g>=S))return g;while(y);return g}insert(n,o,t=!1){if(this.f=this.f&&t,this.j.lineNumber=0,this.j.value="",this.root!==T.$ZC){const{node:i,remainder:s,nodeStartOffset:g}=this.G(n),l=i.piece,w=l.bufferIndex,S=this.s(i,s);if(i.piece.bufferIndex===0&&l.end.line===this.g.line&&l.end.column===this.g.column&&g+l.length===n&&o.length<$){this.F(i,o),this.y();return}if(g===n)this.o(o,i),this.h.validate(n);else if(g+i.piece.length>n){const D=[];let y=new k(l.bufferIndex,S,l.end,this.t(l.bufferIndex,S,l.end),this.u(w,l.end)-this.u(w,S));if(this.K()&&this.M(o)&&this.I(i,s)===10){const v={line:y.start.line+1,column:0};y=new k(y.bufferIndex,v,y.end,this.t(y.bufferIndex,v,y.end),y.length-1),o+=`
`}if(this.K()&&this.L(o))if(this.I(i,s-1)===13){const v=this.s(i,s-1);this.C(i,v),o="\r"+o,i.piece.length===0&&D.push(i)}else this.C(i,S);else this.C(i,S);const C=this.w(o);y.length>0&&this.S(i,y);let A=i;for(let b=0;b<C.length;b++)A=this.S(A,C[b]);this.v(D)}else this.q(o,i)}else{const i=this.w(o);let s=this.T(null,i[0]);for(let g=1;g<i.length;g++)s=this.S(s,i[g])}this.y()}delete(n,o){if(this.j.lineNumber=0,this.j.value="",o<=0||this.root===T.$ZC)return;const t=this.G(n),i=this.G(n+o),s=t.node,g=i.node;if(s===g){const C=this.s(s,t.remainder),A=this.s(s,i.remainder);if(t.nodeStartOffset===n){if(o===s.piece.length){const b=s.next();(0,T.$5C)(this,s),this.N(b),this.y();return}this.D(s,A),this.h.validate(n),this.N(s),this.y();return}if(t.nodeStartOffset+s.piece.length===n+o){this.C(s,C),this.O(s),this.y();return}this.E(s,C,A),this.y();return}const l=[],w=this.s(s,t.remainder);this.C(s,w),this.h.validate(n),s.piece.length===0&&l.push(s);const S=this.s(g,i.remainder);this.D(g,S),g.piece.length===0&&l.push(g);const D=s.next();for(let C=D;C!==T.$ZC&&C!==g;C=C.next())l.push(C);const y=s.piece.length===0?s.prev():s;this.v(l),this.O(y),this.y()}o(n,o){const t=[];if(this.K()&&this.M(n)&&this.L(o)){const g=o.piece,l={line:g.start.line+1,column:0},w=new k(g.bufferIndex,l,g.end,this.t(g.bufferIndex,l,g.end),g.length-1);o.piece=w,n+=`
`,(0,T.$7C)(this,o,-1,-1),o.piece.length===0&&t.push(o)}const i=this.w(n);let s=this.T(o,i[i.length-1]);for(let g=i.length-2;g>=0;g--)s=this.T(s,i[g]);this.N(s),this.v(t)}q(n,o){this.Q(n,o)&&(n+=`
`);const t=this.w(n),i=this.S(o,t[0]);let s=i;for(let g=1;g<t.length;g++)s=this.S(s,t[g]);this.N(i)}s(n,o,t){const i=n.piece,s=n.piece.bufferIndex,g=this.a[s].lineStarts,w=g[i.start.line]+i.start.column+o;let S=i.start.line,D=i.end.line,y=0,C=0,A=0;for(;S<=D&&(y=S+(D-S)/2|0,A=g[y],y!==D);)if(C=g[y+1],w<A)D=y-1;else if(w>=C)S=y+1;else break;return t?(t.line=y,t.column=w-A,null):{line:y,column:w-A}}t(n,o,t){if(t.column===0)return t.line-o.line;const i=this.a[n].lineStarts;if(t.line===i.length-1)return t.line-o.line;const s=i[t.line+1],g=i[t.line]+t.column;if(s>g+1)return t.line-o.line;const l=g-1;return this.a[n].buffer.charCodeAt(l)===13?t.line-o.line+1:t.line-o.line}u(n,o){return this.a[n].lineStarts[o.line]+o.column}v(n){for(let o=0;o<n.length;o++)(0,T.$5C)(this,n[o])}w(n){if(n.length>$){const D=[];for(;n.length>$;){const C=n.charCodeAt($-1);let A;C===r.CharCode.CarriageReturn||C>=55296&&C<=56319?(A=n.substring(0,$-1),n=n.substring($-1)):(A=n.substring(0,$),n=n.substring($));const b=E(A);D.push(new k(this.a.length,{line:0,column:0},{line:b.length-1,column:A.length-b[b.length-1]},b.length-1,A.length)),this.a.push(new p(A,b))}const y=E(n);return D.push(new k(this.a.length,{line:0,column:0},{line:y.length-1,column:n.length-y[y.length-1]},y.length-1,n.length)),this.a.push(new p(n,y)),D}let o=this.a[0].buffer.length;const t=E(n,!1);let i=this.g;if(this.a[0].lineStarts[this.a[0].lineStarts.length-1]===o&&o!==0&&this.L(n)&&this.M(this.a[0].buffer)){this.g={line:this.g.line,column:this.g.column+1},i=this.g;for(let D=0;D<t.length;D++)t[D]+=o+1;this.a[0].lineStarts=this.a[0].lineStarts.concat(t.slice(1)),this.a[0].buffer+="_"+n,o+=1}else{if(o!==0)for(let D=0;D<t.length;D++)t[D]+=o;this.a[0].lineStarts=this.a[0].lineStarts.concat(t.slice(1)),this.a[0].buffer+=n}const s=this.a[0].buffer.length,g=this.a[0].lineStarts.length-1,l=s-this.a[0].lineStarts[g],w={line:g,column:l},S=new k(0,i,w,this.t(0,i,w),s-o);return this.g=w,[S]}getLinesRawContent(){return this.U(this.root)}getLineRawContent(n,o=0){let t=this.root,i="";const s=this.h.get2(n);if(s){t=s.node;const g=this.B(t,n-s.nodeStartLineNumber-1),l=this.a[t.piece.bufferIndex].buffer,w=this.u(t.piece.bufferIndex,t.piece.start);if(s.nodeStartLineNumber+t.piece.lineFeedCnt===n)i=l.substring(w+g,w+t.piece.length);else{const S=this.B(t,n-s.nodeStartLineNumber);return l.substring(w+g,w+S-o)}}else{let g=0;const l=n;for(;t!==T.$ZC;)if(t.left!==T.$ZC&&t.lf_left>=n-1)t=t.left;else if(t.lf_left+t.piece.lineFeedCnt>n-1){const w=this.B(t,n-t.lf_left-2),S=this.B(t,n-t.lf_left-1),D=this.a[t.piece.bufferIndex].buffer,y=this.u(t.piece.bufferIndex,t.piece.start);return g+=t.size_left,this.h.set({node:t,nodeStartOffset:g,nodeStartLineNumber:l-(n-1-t.lf_left)}),D.substring(y+w,y+S-o)}else if(t.lf_left+t.piece.lineFeedCnt===n-1){const w=this.B(t,n-t.lf_left-2),S=this.a[t.piece.bufferIndex].buffer,D=this.u(t.piece.bufferIndex,t.piece.start);i=S.substring(D+w,D+t.piece.length);break}else n-=t.lf_left+t.piece.lineFeedCnt,g+=t.size_left+t.piece.length,t=t.right}for(t=t.next();t!==T.$ZC;){const g=this.a[t.piece.bufferIndex].buffer;if(t.piece.lineFeedCnt>0){const l=this.B(t,0),w=this.u(t.piece.bufferIndex,t.piece.start);return i+=g.substring(w,w+l-o),i}else{const l=this.u(t.piece.bufferIndex,t.piece.start);i+=g.substr(l,t.piece.length)}t=t.next()}return i}y(){let n=this.root,o=1,t=0;for(;n!==T.$ZC;)o+=n.lf_left+n.piece.lineFeedCnt,t+=n.size_left+n.piece.length,n=n.right;this.b=o,this.c=t,this.h.validate(this.c)}A(n,o){const t=n.piece,i=this.s(n,o),s=i.line-t.start.line;if(this.u(t.bufferIndex,t.end)-this.u(t.bufferIndex,t.start)===o){const g=this.t(n.piece.bufferIndex,t.start,i);if(g!==s)return{index:g,remainder:0}}return{index:s,remainder:i.column}}B(n,o){if(o<0)return 0;const t=n.piece,i=this.a[t.bufferIndex].lineStarts,s=t.start.line+o+1;return s>t.end.line?i[t.end.line]+t.end.column-i[t.start.line]-t.start.column:i[s]-i[t.start.line]-t.start.column}C(n,o){const t=n.piece,i=t.lineFeedCnt,s=this.u(t.bufferIndex,t.end),g=o,l=this.u(t.bufferIndex,g),w=this.t(t.bufferIndex,t.start,g),S=w-i,D=l-s,y=t.length+D;n.piece=new k(t.bufferIndex,t.start,g,w,y),(0,T.$7C)(this,n,D,S)}D(n,o){const t=n.piece,i=t.lineFeedCnt,s=this.u(t.bufferIndex,t.start),g=o,l=this.t(t.bufferIndex,g,t.end),w=this.u(t.bufferIndex,g),S=l-i,D=s-w,y=t.length+D;n.piece=new k(t.bufferIndex,g,t.end,l,y),(0,T.$7C)(this,n,D,S)}E(n,o,t){const i=n.piece,s=i.start,g=i.end,l=i.length,w=i.lineFeedCnt,S=o,D=this.t(i.bufferIndex,i.start,S),y=this.u(i.bufferIndex,o)-this.u(i.bufferIndex,s);n.piece=new k(i.bufferIndex,i.start,S,D,y),(0,T.$7C)(this,n,y-l,D-w);const C=new k(i.bufferIndex,t,g,this.t(i.bufferIndex,t,g),this.u(i.bufferIndex,g)-this.u(i.bufferIndex,t)),A=this.S(n,C);this.N(A)}F(n,o){this.Q(o,n)&&(o+=`
`);const t=this.K()&&this.L(o)&&this.M(n),i=this.a[0].buffer.length;this.a[0].buffer+=o;const s=E(o,!1);for(let A=0;A<s.length;A++)s[A]+=i;if(t){const A=this.a[0].lineStarts[this.a[0].lineStarts.length-2];this.a[0].lineStarts.pop(),this.g={line:this.g.line-1,column:i-A}}this.a[0].lineStarts=this.a[0].lineStarts.concat(s.slice(1));const g=this.a[0].lineStarts.length-1,l=this.a[0].buffer.length-this.a[0].lineStarts[g],w={line:g,column:l},S=n.piece.length+o.length,D=n.piece.lineFeedCnt,y=this.t(0,n.piece.start,w),C=y-D;n.piece=new k(n.piece.bufferIndex,n.piece.start,w,y,S),this.g=w,(0,T.$7C)(this,n,o.length,C)}G(n){let o=this.root;const t=this.h.get(n);if(t)return{node:t.node,nodeStartOffset:t.nodeStartOffset,remainder:n-t.nodeStartOffset};let i=0;for(;o!==T.$ZC;)if(o.size_left>n)o=o.left;else if(o.size_left+o.piece.length>=n){i+=o.size_left;const s={node:o,remainder:n-o.size_left,nodeStartOffset:i};return this.h.set(s),s}else n-=o.size_left+o.piece.length,i+=o.size_left+o.piece.length,o=o.right;return null}H(n,o){let t=this.root,i=0;for(;t!==T.$ZC;)if(t.left!==T.$ZC&&t.lf_left>=n-1)t=t.left;else if(t.lf_left+t.piece.lineFeedCnt>n-1){const s=this.B(t,n-t.lf_left-2),g=this.B(t,n-t.lf_left-1);return i+=t.size_left,{node:t,remainder:Math.min(s+o-1,g),nodeStartOffset:i}}else if(t.lf_left+t.piece.lineFeedCnt===n-1){const s=this.B(t,n-t.lf_left-2);if(s+o-1<=t.piece.length)return{node:t,remainder:s+o-1,nodeStartOffset:i};o-=t.piece.length-s;break}else n-=t.lf_left+t.piece.lineFeedCnt,i+=t.size_left+t.piece.length,t=t.right;for(t=t.next();t!==T.$ZC;){if(t.piece.lineFeedCnt>0){const s=this.B(t,0),g=this.J(t);return{node:t,remainder:Math.min(o-1,s),nodeStartOffset:g}}else if(t.piece.length>=o-1){const s=this.J(t);return{node:t,remainder:o-1,nodeStartOffset:s}}else o-=t.piece.length;t=t.next()}return null}I(n,o){if(n.piece.lineFeedCnt<1)return-1;const t=this.a[n.piece.bufferIndex],i=this.u(n.piece.bufferIndex,n.piece.start)+o;return t.buffer.charCodeAt(i)}J(n){if(!n)return 0;let o=n.size_left;for(;n!==this.root;)n.parent.right===n&&(o+=n.parent.size_left+n.parent.piece.length),n=n.parent;return o}K(){return!(this.f&&this.d===`
`)}L(n){if(typeof n=="string")return n.charCodeAt(0)===10;if(n===T.$ZC||n.piece.lineFeedCnt===0)return!1;const o=n.piece,t=this.a[o.bufferIndex].lineStarts,i=o.start.line,s=t[i]+o.start.column;return i===t.length-1||t[i+1]>s+1?!1:this.a[o.bufferIndex].buffer.charCodeAt(s)===10}M(n){return typeof n=="string"?n.charCodeAt(n.length-1)===13:n===T.$ZC||n.piece.lineFeedCnt===0?!1:this.I(n,n.piece.length-1)===13}N(n){if(this.K()&&this.L(n)){const o=n.prev();this.M(o)&&this.P(o,n)}}O(n){if(this.K()&&this.M(n)){const o=n.next();this.L(o)&&this.P(n,o)}}P(n,o){const t=[],i=this.a[n.piece.bufferIndex].lineStarts;let s;n.piece.end.column===0?s={line:n.piece.end.line-1,column:i[n.piece.end.line]-i[n.piece.end.line-1]-1}:s={line:n.piece.end.line,column:n.piece.end.column-1};const g=n.piece.length-1,l=n.piece.lineFeedCnt-1;n.piece=new k(n.piece.bufferIndex,n.piece.start,s,l,g),(0,T.$7C)(this,n,-1,-1),n.piece.length===0&&t.push(n);const w={line:o.piece.start.line+1,column:0},S=o.piece.length-1,D=this.t(o.piece.bufferIndex,w,o.piece.end);o.piece=new k(o.piece.bufferIndex,w,o.piece.end,D,S),(0,T.$7C)(this,o,-1,-1),o.piece.length===0&&t.push(o);const y=this.w(`\r
`);this.S(n,y[0]);for(let C=0;C<t.length;C++)(0,T.$5C)(this,t[C])}Q(n,o){if(this.K()&&this.M(n)){const t=o.next();if(this.L(t)){if(n+=`
`,t.piece.length===1)(0,T.$5C)(this,t);else{const i=t.piece,s={line:i.start.line+1,column:0},g=i.length-1,l=this.t(i.bufferIndex,s,i.end);t.piece=new k(i.bufferIndex,s,i.end,l,g),(0,T.$7C)(this,t,-1,-1)}return!0}}return!1}iterate(n,o){if(n===T.$ZC)return o(T.$ZC);const t=this.iterate(n.left,o);return t&&o(n)&&this.iterate(n.right,o)}R(n){if(n===T.$ZC)return"";const o=this.a[n.piece.bufferIndex],t=n.piece,i=this.u(t.bufferIndex,t.start),s=this.u(t.bufferIndex,t.end);return o.buffer.substring(i,s)}getPieceContent(n){const o=this.a[n.bufferIndex],t=this.u(n.bufferIndex,n.start),i=this.u(n.bufferIndex,n.end);return o.buffer.substring(t,i)}S(n,o){const t=new T.$YC(o,T.NodeColor.Red);if(t.left=T.$ZC,t.right=T.$ZC,t.parent=T.$ZC,t.size_left=0,t.lf_left=0,this.root===T.$ZC)this.root=t,t.color=T.NodeColor.Black;else if(n.right===T.$ZC)n.right=t,t.parent=n;else{const s=(0,T.$1C)(n.right);s.left=t,t.parent=s}return(0,T.$6C)(this,t),t}T(n,o){const t=new T.$YC(o,T.NodeColor.Red);if(t.left=T.$ZC,t.right=T.$ZC,t.parent=T.$ZC,t.size_left=0,t.lf_left=0,this.root===T.$ZC)this.root=t,t.color=T.NodeColor.Black;else if(n.left===T.$ZC)n.left=t,t.parent=n;else{const i=(0,T.$2C)(n.left);i.right=t,t.parent=i}return(0,T.$6C)(this,t),t}U(n){let o="";return this.iterate(n,t=>(o+=this.R(t),!0)),o}}e.$gD=d}),define(Ee[198],ye([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$s_=e.$r_=void 0;class r{constructor(){this.a=new Map}removeDragOperationTransfer(R){if(R&&this.a.has(R)){const T=this.a.get(R);return this.a.delete(R),T}}addDragOperationTransfer(R,T){this.a.set(R,T)}}e.$r_=r;class h{constructor(R){this.identifier=R}}e.$s_=h}),define(Ee[199],ye([1,0,4,3,106]),function(ce,e,r,h,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qu=void 0;class R{constructor(){this.a=new Map,this.b=new Map,this.c=new r.$me,this.onDidChange=this.c.event,this.d=null}handleChange($){this.c.fire({changedLanguages:$,changedColorMap:!1})}register($,c){return this.a.set($,c),this.handleChange([$]),(0,h.$Uc)(()=>{this.a.get($)===c&&(this.a.delete($),this.handleChange([$]))})}get($){return this.a.get($)||null}registerFactory($,c){this.b.get($)?.dispose();const I=new T(this,$,c);return this.b.set($,I),(0,h.$Uc)(()=>{const E=this.b.get($);!E||E!==I||(this.b.delete($),E.dispose())})}async getOrCreate($){const c=this.get($);if(c)return c;const I=this.b.get($);return!I||I.isResolved?null:(await I.resolve(),this.get($))}isResolved($){if(this.get($))return!0;const I=this.b.get($);return!!(!I||I.isResolved)}setColorMap($){this.d=$,this.c.fire({changedLanguages:Array.from(this.a.keys()),changedColorMap:!0})}getColorMap(){return this.d}getDefaultBackground(){return this.d&&this.d.length>P.ColorId.DefaultBackground?this.d[P.ColorId.DefaultBackground]:null}}e.$qu=R;class T extends h.$Wc{get isResolved(){return this.c}constructor($,c,I){super(),this.f=$,this.g=c,this.h=I,this.a=!1,this.b=null,this.c=!1}dispose(){this.a=!0,super.dispose()}async resolve(){return this.b||(this.b=this.j()),this.b}async j(){const $=await this.h.tokenizationSupport;this.c=!0,$&&!this.a&&this.B(this.f.register(this.g,$))}}}),define(Ee[200],ye([7,8]),function(ce,e){return ce.create("vs/base/common/actions",e)}),define(Ee[201],ye([1,0,4,3,200]),function(ce,e,r,h,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oj=e.$nj=e.$mj=e.$lj=e.$kj=void 0,e.$pj=I,P=We(P);class R extends h.$Wc{constructor(u,k="",p="",a=!0,f){super(),this.j=this.B(new r.$me),this.onDidChange=this.j.event,this.z=!0,this.m=u,this.n=k,this.w=p,this.z=a,this.D=f}get id(){return this.m}get label(){return this.n}set label(u){this.F(u)}F(u){this.n!==u&&(this.n=u,this.j.fire({label:u}))}get tooltip(){return this.u||""}set tooltip(u){this.G(u)}G(u){this.u!==u&&(this.u=u,this.j.fire({tooltip:u}))}get class(){return this.w}set class(u){this.H(u)}H(u){this.w!==u&&(this.w=u,this.j.fire({class:u}))}get enabled(){return this.z}set enabled(u){this.I(u)}I(u){this.z!==u&&(this.z=u,this.j.fire({enabled:u}))}get checked(){return this.C}set checked(u){this.J(u)}J(u){this.C!==u&&(this.C=u,this.j.fire({checked:u}))}async run(u,k){this.D&&await this.D(u)}}e.$kj=R;class T extends h.$Wc{constructor(){super(...arguments),this.f=this.B(new r.$me),this.onWillRun=this.f.event,this.m=this.B(new r.$me),this.onDidRun=this.m.event}async run(u,k){if(!u.enabled)return;this.f.fire({action:u});let p;try{await this.u(u,k)}catch(a){p=a}this.m.fire({action:u,error:p})}async u(u,k){await u.run(k)}}e.$lj=T;class N{constructor(){this.id=N.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...u){let k=[];for(const p of u)p.length&&(k.length?k=[...k,new N,...p]:k=p);return k}static{this.ID="vs.actions.separator"}async run(){}}e.$mj=N;class ${get actions(){return this.a}constructor(u,k,p,a){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=u,this.label=k,this.class=a,this.a=p}async run(){}}e.$nj=$;class c extends R{static{this.ID="vs.actions.empty"}constructor(){super(c.ID,P.localize(0,null),void 0,!1)}}e.$oj=c;function I(E){return{id:E.id,label:E.label,tooltip:E.tooltip??E.label,class:E.class,enabled:E.enabled??!0,checked:E.checked,run:async(...u)=>E.run(...u)}}}),define(Ee[202],ye([7,8]),function(ce,e){return ce.create("vs/base/common/date",e)}),define(Ee[203],ye([1,0,202]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1m=c,e.$2m=I,e.$3m=E;const h=60,P=h*60,R=P*24,T=R*7,N=R*30,$=R*365;function c(u,k,p,a){typeof u!="number"&&(u=u.getTime());const f=Math.round((new Date().getTime()-u)/1e3);if(f<-30)return(0,r.localize)(0,null,c(new Date().getTime()+f*1e3,!1));if(!a&&f<30)return(0,r.localize)(1,null);let d;return f<h?(d=f,k?d===1?p?(0,r.localize)(2,null,d):(0,r.localize)(3,null,d):p?(0,r.localize)(4,null,d):(0,r.localize)(5,null,d):d===1?p?(0,r.localize)(6,null,d):(0,r.localize)(7,null,d):p?(0,r.localize)(8,null,d):(0,r.localize)(9,null,d)):f<P?(d=Math.floor(f/h),k?d===1?p?(0,r.localize)(10,null,d):(0,r.localize)(11,null,d):p?(0,r.localize)(12,null,d):(0,r.localize)(13,null,d):d===1?p?(0,r.localize)(14,null,d):(0,r.localize)(15,null,d):p?(0,r.localize)(16,null,d):(0,r.localize)(17,null,d)):f<R?(d=Math.floor(f/P),k?d===1?p?(0,r.localize)(18,null,d):(0,r.localize)(19,null,d):p?(0,r.localize)(20,null,d):(0,r.localize)(21,null,d):d===1?p?(0,r.localize)(22,null,d):(0,r.localize)(23,null,d):p?(0,r.localize)(24,null,d):(0,r.localize)(25,null,d)):f<T?(d=Math.floor(f/R),k?d===1?(0,r.localize)(26,null,d):(0,r.localize)(27,null,d):d===1?(0,r.localize)(28,null,d):(0,r.localize)(29,null,d)):f<N?(d=Math.floor(f/T),k?d===1?p?(0,r.localize)(30,null,d):(0,r.localize)(31,null,d):p?(0,r.localize)(32,null,d):(0,r.localize)(33,null,d):d===1?p?(0,r.localize)(34,null,d):(0,r.localize)(35,null,d):p?(0,r.localize)(36,null,d):(0,r.localize)(37,null,d)):f<$?(d=Math.floor(f/N),k?d===1?p?(0,r.localize)(38,null,d):(0,r.localize)(39,null,d):p?(0,r.localize)(40,null,d):(0,r.localize)(41,null,d):d===1?p?(0,r.localize)(42,null,d):(0,r.localize)(43,null,d):p?(0,r.localize)(44,null,d):(0,r.localize)(45,null,d)):(d=Math.floor(f/$),k?d===1?p?(0,r.localize)(46,null,d):(0,r.localize)(47,null,d):p?(0,r.localize)(48,null,d):(0,r.localize)(49,null,d):d===1?p?(0,r.localize)(50,null,d):(0,r.localize)(51,null,d):p?(0,r.localize)(52,null,d):(0,r.localize)(53,null,d))}function I(u,k){const p=Math.abs(u/1e3);return p<1?k?(0,r.localize)(54,null,u):(0,r.localize)(55,null,u):p<h?k?(0,r.localize)(56,null,Math.round(u)/1e3):(0,r.localize)(57,null,Math.round(u)/1e3):p<P?k?(0,r.localize)(58,null,Math.round(u/(1e3*h))):(0,r.localize)(59,null,Math.round(u/(1e3*h))):p<R?k?(0,r.localize)(60,null,Math.round(u/(1e3*P))):(0,r.localize)(61,null,Math.round(u/(1e3*P))):(0,r.localize)(62,null,Math.round(u/(1e3*R)))}function E(u){return u.getFullYear()+"-"+String(u.getMonth()+1).padStart(2,"0")+"-"+String(u.getDate()).padStart(2,"0")+"T"+String(u.getHours()).padStart(2,"0")+":"+String(u.getMinutes()).padStart(2,"0")+":"+String(u.getSeconds()).padStart(2,"0")+"."+(u.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}}),define(Ee[204],ye([7,8]),function(ce,e){return ce.create("vs/base/common/errorMessage",e)}),define(Ee[55],ye([1,0,19,18,204]),function(ce,e,r,h,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qj=$,e.$rj=c,e.$sj=I,r=We(r),h=We(h),P=We(P);function R(E,u){return u&&(E.stack||E.stacktrace)?P.localize(0,null,N(E),T(E.stack)||T(E.stacktrace)):N(E)}function T(E){return Array.isArray(E)?E.join(`
`):E}function N(E){return E.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${E.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof E.code=="string"&&typeof E.errno=="number"&&typeof E.syscall=="string"?P.localize(1,null,E.message):E.message||P.localize(2,null)}function $(E=null,u=!1){if(!E)return P.localize(3,null);if(Array.isArray(E)){const k=r.$Jb(E),p=$(k[0],u);return k.length>1?P.localize(4,null,p,k.length):p}if(h.$fg(E))return E;if(E.detail){const k=E.detail;if(k.error)return R(k.error,u);if(k.exception)return R(k.exception,u)}return E.stack?R(E,u):E.message?E.message:P.localize(5,null)}function c(E){const u=E;return u instanceof Error&&Array.isArray(u.actions)}function I(E,u){let k;return typeof E=="string"?k=new Error(E):k=E,k.actions=u,k}}),define(Ee[205],ye([7,8]),function(ce,e){return ce.create("vs/base/common/platform",e)}),define(Ee[11],ye([1,0,205]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$I=e.$H=e.$G=e.$F=e.$E=e.OS=e.OperatingSystem=e.$B=e.$A=e.$z=e.$y=e.$x=e.Language=e.$w=e.$v=e.$u=e.$t=e.$s=e.$r=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.$i=e.Platform=e.$g=void 0,e.$h=s,e.$D=y,e.$J=C,r=We(r),e.$g="en";let h=!1,P=!1,R=!1,T=!1,N=!1,$=!1,c=!1,I=!1,E=!1,u=!1,k,p=e.$g,a=e.$g,f,d;const m=globalThis;let n;typeof m.vscode<"u"&&typeof m.vscode.process<"u"?n=m.vscode.process:typeof process<"u"&&typeof process?.versions?.node=="string"&&(n=process);const o=typeof n?.versions?.electron=="string",t=o&&n?.type==="renderer";if(typeof n=="object"){h=n.platform==="win32",P=n.platform==="darwin",R=n.platform==="linux",T=R&&!!n.env.SNAP&&!!n.env.SNAP_REVISION,c=o,E=!!n.env.CI||!!n.env.BUILD_ARTIFACTSTAGINGDIRECTORY,k=e.$g,p=e.$g;const A=n.env.VSCODE_NLS_CONFIG;if(A)try{const b=JSON.parse(A),v=b.availableLanguages["*"];k=b.locale,a=b.osLocale,p=v||e.$g,f=b._translationsConfigFile}catch{}N=!0}else typeof navigator=="object"&&!t?(d=navigator.userAgent,h=d.indexOf("Windows")>=0,P=d.indexOf("Macintosh")>=0,I=(d.indexOf("Macintosh")>=0||d.indexOf("iPad")>=0||d.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,R=d.indexOf("Linux")>=0,u=d?.indexOf("Mobi")>=0,$=!0,k=r.getConfiguredDefaultLocale(r.localize(0,null))||e.$g,p=k,a=navigator.language):console.error("Unable to resolve platform.");var i;(function(A){A[A.Web=0]="Web",A[A.Mac=1]="Mac",A[A.Linux=2]="Linux",A[A.Windows=3]="Windows"})(i||(e.Platform=i={}));function s(A){switch(A){case i.Web:return"Web";case i.Mac:return"Mac";case i.Linux:return"Linux";case i.Windows:return"Windows"}}let g=i.Web;P?g=i.Mac:h?g=i.Windows:R&&(g=i.Linux),e.$i=h,e.$j=P,e.$k=R,e.$l=T,e.$m=N,e.$n=c,e.$o=$,e.$p=$&&typeof m.importScripts=="function",e.$q=e.$p?m.origin:void 0,e.$r=I,e.$s=u,e.$t=E,e.$u=g,e.$v=d,e.$w=p;var l;(function(A){function b(){return e.$w}A.value=b;function v(){return e.$w.length===2?e.$w==="en":e.$w.length>=3?e.$w[0]==="e"&&e.$w[1]==="n"&&e.$w[2]==="-":!1}A.isDefaultVariant=v;function L(){return e.$w==="en"}A.isDefault=L})(l||(e.Language=l={})),e.$x=k,e.$y=a,e.$z=f,e.$A=typeof m.postMessage=="function"&&!m.importScripts,e.$B=(()=>{if(e.$A){const A=[];m.addEventListener("message",v=>{if(v.data&&v.data.vscodeScheduleAsyncWork)for(let L=0,O=A.length;L<O;L++){const M=A[L];if(M.id===v.data.vscodeScheduleAsyncWork){A.splice(L,1),M.callback();return}}});let b=0;return v=>{const L=++b;A.push({id:L,callback:v}),m.postMessage({vscodeScheduleAsyncWork:L},"*")}}return A=>setTimeout(A)})();var w;(function(A){A[A.Windows=1]="Windows",A[A.Macintosh=2]="Macintosh",A[A.Linux=3]="Linux"})(w||(e.OperatingSystem=w={})),e.OS=P||I?w.Macintosh:h?w.Windows:w.Linux;let S=!0,D=!1;function y(){if(!D){D=!0;const A=new Uint8Array(2);A[0]=1,A[1]=2,S=new Uint16Array(A.buffer)[0]===513}return S}e.$E=!!(e.$v&&e.$v.indexOf("Chrome")>=0),e.$F=!!(e.$v&&e.$v.indexOf("Firefox")>=0),e.$G=!!(!e.$E&&e.$v&&e.$v.indexOf("Safari")>=0),e.$H=!!(e.$v&&e.$v.indexOf("Edg/")>=0),e.$I=!!(e.$v&&e.$v.indexOf("Android")>=0);function C(A){return parseFloat(A)>=20}}),define(Ee[56],ye([1,0,11]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gc=e.$fc=e.env=e.cwd=void 0;let h;const P=globalThis.vscode;if(typeof P<"u"&&typeof P.process<"u"){const R=P.process;h={get platform(){return R.platform},get arch(){return R.arch},get env(){return R.env},cwd(){return R.cwd()}}}else typeof process<"u"?h={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:h={get platform(){return r.$i?"win32":r.$j?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=h.cwd,e.env=h.env,e.$fc=h.platform,e.$gc=h.arch}),define(Ee[16],ye([1,0,56]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vc=e.sep=e.$tc=e.$sc=e.$rc=e.$qc=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=e.$jc=e.$ic=e.$hc=void 0,r=We(r);const h=65,P=97,R=90,T=122,N=46,$=47,c=92,I=58,E=63;class u extends Error{constructor(s,g,l){let w;typeof g=="string"&&g.indexOf("not ")===0?(w="must not be",g=g.replace(/^not /,"")):w="must be";const S=s.indexOf(".")!==-1?"property":"argument";let D=`The "${s}" ${S} ${w} of type ${g}`;D+=`. Received type ${typeof l}`,super(D),this.code="ERR_INVALID_ARG_TYPE"}}function k(i,s){if(i===null||typeof i!="object")throw new u(s,"Object",i)}function p(i,s){if(typeof i!="string")throw new u(s,"string",i)}const a=r.$fc==="win32";function f(i){return i===$||i===c}function d(i){return i===$}function m(i){return i>=h&&i<=R||i>=P&&i<=T}function n(i,s,g,l){let w="",S=0,D=-1,y=0,C=0;for(let A=0;A<=i.length;++A){if(A<i.length)C=i.charCodeAt(A);else{if(l(C))break;C=$}if(l(C)){if(!(D===A-1||y===1))if(y===2){if(w.length<2||S!==2||w.charCodeAt(w.length-1)!==N||w.charCodeAt(w.length-2)!==N){if(w.length>2){const b=w.lastIndexOf(g);b===-1?(w="",S=0):(w=w.slice(0,b),S=w.length-1-w.lastIndexOf(g)),D=A,y=0;continue}else if(w.length!==0){w="",S=0,D=A,y=0;continue}}s&&(w+=w.length>0?`${g}..`:"..",S=2)}else w.length>0?w+=`${g}${i.slice(D+1,A)}`:w=i.slice(D+1,A),S=A-D-1;D=A,y=0}else C===N&&y!==-1?++y:y=-1}return w}function o(i,s){k(s,"pathObject");const g=s.dir||s.root,l=s.base||`${s.name||""}${s.ext||""}`;return g?g===s.root?`${g}${l}`:`${g}${i}${l}`:l}e.$hc={resolve(...i){let s="",g="",l=!1;for(let w=i.length-1;w>=-1;w--){let S;if(w>=0){if(S=i[w],p(S,"path"),S.length===0)continue}else s.length===0?S=r.cwd():(S=r.env[`=${s}`]||r.cwd(),(S===void 0||S.slice(0,2).toLowerCase()!==s.toLowerCase()&&S.charCodeAt(2)===c)&&(S=`${s}\\`));const D=S.length;let y=0,C="",A=!1;const b=S.charCodeAt(0);if(D===1)f(b)&&(y=1,A=!0);else if(f(b))if(A=!0,f(S.charCodeAt(1))){let v=2,L=v;for(;v<D&&!f(S.charCodeAt(v));)v++;if(v<D&&v!==L){const O=S.slice(L,v);for(L=v;v<D&&f(S.charCodeAt(v));)v++;if(v<D&&v!==L){for(L=v;v<D&&!f(S.charCodeAt(v));)v++;(v===D||v!==L)&&(C=`\\\\${O}\\${S.slice(L,v)}`,y=v)}}}else y=1;else m(b)&&S.charCodeAt(1)===I&&(C=S.slice(0,2),y=2,D>2&&f(S.charCodeAt(2))&&(A=!0,y=3));if(C.length>0)if(s.length>0){if(C.toLowerCase()!==s.toLowerCase())continue}else s=C;if(l){if(s.length>0)break}else if(g=`${S.slice(y)}\\${g}`,l=A,A&&s.length>0)break}return g=n(g,!l,"\\",f),l?`${s}\\${g}`:`${s}${g}`||"."},normalize(i){p(i,"path");const s=i.length;if(s===0)return".";let g=0,l,w=!1;const S=i.charCodeAt(0);if(s===1)return d(S)?"\\":i;if(f(S))if(w=!0,f(i.charCodeAt(1))){let y=2,C=y;for(;y<s&&!f(i.charCodeAt(y));)y++;if(y<s&&y!==C){const A=i.slice(C,y);for(C=y;y<s&&f(i.charCodeAt(y));)y++;if(y<s&&y!==C){for(C=y;y<s&&!f(i.charCodeAt(y));)y++;if(y===s)return`\\\\${A}\\${i.slice(C)}\\`;y!==C&&(l=`\\\\${A}\\${i.slice(C,y)}`,g=y)}}}else g=1;else m(S)&&i.charCodeAt(1)===I&&(l=i.slice(0,2),g=2,s>2&&f(i.charCodeAt(2))&&(w=!0,g=3));let D=g<s?n(i.slice(g),!w,"\\",f):"";return D.length===0&&!w&&(D="."),D.length>0&&f(i.charCodeAt(s-1))&&(D+="\\"),l===void 0?w?`\\${D}`:D:w?`${l}\\${D}`:`${l}${D}`},isAbsolute(i){p(i,"path");const s=i.length;if(s===0)return!1;const g=i.charCodeAt(0);return f(g)||s>2&&m(g)&&i.charCodeAt(1)===I&&f(i.charCodeAt(2))},join(...i){if(i.length===0)return".";let s,g;for(let S=0;S<i.length;++S){const D=i[S];p(D,"path"),D.length>0&&(s===void 0?s=g=D:s+=`\\${D}`)}if(s===void 0)return".";let l=!0,w=0;if(typeof g=="string"&&f(g.charCodeAt(0))){++w;const S=g.length;S>1&&f(g.charCodeAt(1))&&(++w,S>2&&(f(g.charCodeAt(2))?++w:l=!1))}if(l){for(;w<s.length&&f(s.charCodeAt(w));)w++;w>=2&&(s=`\\${s.slice(w)}`)}return e.$hc.normalize(s)},relative(i,s){if(p(i,"from"),p(s,"to"),i===s)return"";const g=e.$hc.resolve(i),l=e.$hc.resolve(s);if(g===l||(i=g.toLowerCase(),s=l.toLowerCase(),i===s))return"";let w=0;for(;w<i.length&&i.charCodeAt(w)===c;)w++;let S=i.length;for(;S-1>w&&i.charCodeAt(S-1)===c;)S--;const D=S-w;let y=0;for(;y<s.length&&s.charCodeAt(y)===c;)y++;let C=s.length;for(;C-1>y&&s.charCodeAt(C-1)===c;)C--;const A=C-y,b=D<A?D:A;let v=-1,L=0;for(;L<b;L++){const M=i.charCodeAt(w+L);if(M!==s.charCodeAt(y+L))break;M===c&&(v=L)}if(L!==b){if(v===-1)return l}else{if(A>b){if(s.charCodeAt(y+L)===c)return l.slice(y+L+1);if(L===2)return l.slice(y+L)}D>b&&(i.charCodeAt(w+L)===c?v=L:L===2&&(v=3)),v===-1&&(v=0)}let O="";for(L=w+v+1;L<=S;++L)(L===S||i.charCodeAt(L)===c)&&(O+=O.length===0?"..":"\\..");return y+=v,O.length>0?`${O}${l.slice(y,C)}`:(l.charCodeAt(y)===c&&++y,l.slice(y,C))},toNamespacedPath(i){if(typeof i!="string"||i.length===0)return i;const s=e.$hc.resolve(i);if(s.length<=2)return i;if(s.charCodeAt(0)===c){if(s.charCodeAt(1)===c){const g=s.charCodeAt(2);if(g!==E&&g!==N)return`\\\\?\\UNC\\${s.slice(2)}`}}else if(m(s.charCodeAt(0))&&s.charCodeAt(1)===I&&s.charCodeAt(2)===c)return`\\\\?\\${s}`;return i},dirname(i){p(i,"path");const s=i.length;if(s===0)return".";let g=-1,l=0;const w=i.charCodeAt(0);if(s===1)return f(w)?i:".";if(f(w)){if(g=l=1,f(i.charCodeAt(1))){let y=2,C=y;for(;y<s&&!f(i.charCodeAt(y));)y++;if(y<s&&y!==C){for(C=y;y<s&&f(i.charCodeAt(y));)y++;if(y<s&&y!==C){for(C=y;y<s&&!f(i.charCodeAt(y));)y++;if(y===s)return i;y!==C&&(g=l=y+1)}}}}else m(w)&&i.charCodeAt(1)===I&&(g=s>2&&f(i.charCodeAt(2))?3:2,l=g);let S=-1,D=!0;for(let y=s-1;y>=l;--y)if(f(i.charCodeAt(y))){if(!D){S=y;break}}else D=!1;if(S===-1){if(g===-1)return".";S=g}return i.slice(0,S)},basename(i,s){s!==void 0&&p(s,"ext"),p(i,"path");let g=0,l=-1,w=!0,S;if(i.length>=2&&m(i.charCodeAt(0))&&i.charCodeAt(1)===I&&(g=2),s!==void 0&&s.length>0&&s.length<=i.length){if(s===i)return"";let D=s.length-1,y=-1;for(S=i.length-1;S>=g;--S){const C=i.charCodeAt(S);if(f(C)){if(!w){g=S+1;break}}else y===-1&&(w=!1,y=S+1),D>=0&&(C===s.charCodeAt(D)?--D===-1&&(l=S):(D=-1,l=y))}return g===l?l=y:l===-1&&(l=i.length),i.slice(g,l)}for(S=i.length-1;S>=g;--S)if(f(i.charCodeAt(S))){if(!w){g=S+1;break}}else l===-1&&(w=!1,l=S+1);return l===-1?"":i.slice(g,l)},extname(i){p(i,"path");let s=0,g=-1,l=0,w=-1,S=!0,D=0;i.length>=2&&i.charCodeAt(1)===I&&m(i.charCodeAt(0))&&(s=l=2);for(let y=i.length-1;y>=s;--y){const C=i.charCodeAt(y);if(f(C)){if(!S){l=y+1;break}continue}w===-1&&(S=!1,w=y+1),C===N?g===-1?g=y:D!==1&&(D=1):g!==-1&&(D=-1)}return g===-1||w===-1||D===0||D===1&&g===w-1&&g===l+1?"":i.slice(g,w)},format:o.bind(null,"\\"),parse(i){p(i,"path");const s={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return s;const g=i.length;let l=0,w=i.charCodeAt(0);if(g===1)return f(w)?(s.root=s.dir=i,s):(s.base=s.name=i,s);if(f(w)){if(l=1,f(i.charCodeAt(1))){let v=2,L=v;for(;v<g&&!f(i.charCodeAt(v));)v++;if(v<g&&v!==L){for(L=v;v<g&&f(i.charCodeAt(v));)v++;if(v<g&&v!==L){for(L=v;v<g&&!f(i.charCodeAt(v));)v++;v===g?l=v:v!==L&&(l=v+1)}}}}else if(m(w)&&i.charCodeAt(1)===I){if(g<=2)return s.root=s.dir=i,s;if(l=2,f(i.charCodeAt(2))){if(g===3)return s.root=s.dir=i,s;l=3}}l>0&&(s.root=i.slice(0,l));let S=-1,D=l,y=-1,C=!0,A=i.length-1,b=0;for(;A>=l;--A){if(w=i.charCodeAt(A),f(w)){if(!C){D=A+1;break}continue}y===-1&&(C=!1,y=A+1),w===N?S===-1?S=A:b!==1&&(b=1):S!==-1&&(b=-1)}return y!==-1&&(S===-1||b===0||b===1&&S===y-1&&S===D+1?s.base=s.name=i.slice(D,y):(s.name=i.slice(D,S),s.base=i.slice(D,y),s.ext=i.slice(S,y))),D>0&&D!==l?s.dir=i.slice(0,D-1):s.dir=s.root,s},sep:"\\",delimiter:";",win32:null,posix:null};const t=(()=>{if(a){const i=/\\/g;return()=>{const s=r.cwd().replace(i,"/");return s.slice(s.indexOf("/"))}}return()=>r.cwd()})();e.$ic={resolve(...i){let s="",g=!1;for(let l=i.length-1;l>=-1&&!g;l--){const w=l>=0?i[l]:t();p(w,"path"),w.length!==0&&(s=`${w}/${s}`,g=w.charCodeAt(0)===$)}return s=n(s,!g,"/",d),g?`/${s}`:s.length>0?s:"."},normalize(i){if(p(i,"path"),i.length===0)return".";const s=i.charCodeAt(0)===$,g=i.charCodeAt(i.length-1)===$;return i=n(i,!s,"/",d),i.length===0?s?"/":g?"./":".":(g&&(i+="/"),s?`/${i}`:i)},isAbsolute(i){return p(i,"path"),i.length>0&&i.charCodeAt(0)===$},join(...i){if(i.length===0)return".";let s;for(let g=0;g<i.length;++g){const l=i[g];p(l,"path"),l.length>0&&(s===void 0?s=l:s+=`/${l}`)}return s===void 0?".":e.$ic.normalize(s)},relative(i,s){if(p(i,"from"),p(s,"to"),i===s||(i=e.$ic.resolve(i),s=e.$ic.resolve(s),i===s))return"";const g=1,l=i.length,w=l-g,S=1,D=s.length-S,y=w<D?w:D;let C=-1,A=0;for(;A<y;A++){const v=i.charCodeAt(g+A);if(v!==s.charCodeAt(S+A))break;v===$&&(C=A)}if(A===y)if(D>y){if(s.charCodeAt(S+A)===$)return s.slice(S+A+1);if(A===0)return s.slice(S+A)}else w>y&&(i.charCodeAt(g+A)===$?C=A:A===0&&(C=0));let b="";for(A=g+C+1;A<=l;++A)(A===l||i.charCodeAt(A)===$)&&(b+=b.length===0?"..":"/..");return`${b}${s.slice(S+C)}`},toNamespacedPath(i){return i},dirname(i){if(p(i,"path"),i.length===0)return".";const s=i.charCodeAt(0)===$;let g=-1,l=!0;for(let w=i.length-1;w>=1;--w)if(i.charCodeAt(w)===$){if(!l){g=w;break}}else l=!1;return g===-1?s?"/":".":s&&g===1?"//":i.slice(0,g)},basename(i,s){s!==void 0&&p(s,"ext"),p(i,"path");let g=0,l=-1,w=!0,S;if(s!==void 0&&s.length>0&&s.length<=i.length){if(s===i)return"";let D=s.length-1,y=-1;for(S=i.length-1;S>=0;--S){const C=i.charCodeAt(S);if(C===$){if(!w){g=S+1;break}}else y===-1&&(w=!1,y=S+1),D>=0&&(C===s.charCodeAt(D)?--D===-1&&(l=S):(D=-1,l=y))}return g===l?l=y:l===-1&&(l=i.length),i.slice(g,l)}for(S=i.length-1;S>=0;--S)if(i.charCodeAt(S)===$){if(!w){g=S+1;break}}else l===-1&&(w=!1,l=S+1);return l===-1?"":i.slice(g,l)},extname(i){p(i,"path");let s=-1,g=0,l=-1,w=!0,S=0;for(let D=i.length-1;D>=0;--D){const y=i.charCodeAt(D);if(y===$){if(!w){g=D+1;break}continue}l===-1&&(w=!1,l=D+1),y===N?s===-1?s=D:S!==1&&(S=1):s!==-1&&(S=-1)}return s===-1||l===-1||S===0||S===1&&s===l-1&&s===g+1?"":i.slice(s,l)},format:o.bind(null,"/"),parse(i){p(i,"path");const s={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return s;const g=i.charCodeAt(0)===$;let l;g?(s.root="/",l=1):l=0;let w=-1,S=0,D=-1,y=!0,C=i.length-1,A=0;for(;C>=l;--C){const b=i.charCodeAt(C);if(b===$){if(!y){S=C+1;break}continue}D===-1&&(y=!1,D=C+1),b===N?w===-1?w=C:A!==1&&(A=1):w!==-1&&(A=-1)}if(D!==-1){const b=S===0&&g?1:S;w===-1||A===0||A===1&&w===D-1&&w===S+1?s.base=s.name=i.slice(b,D):(s.name=i.slice(b,w),s.base=i.slice(b,D),s.ext=i.slice(w,D))}return S>0?s.dir=i.slice(0,S-1):g&&(s.dir="/"),s},sep:"/",delimiter:":",win32:null,posix:null},e.$ic.win32=e.$hc.win32=e.$hc,e.$ic.posix=e.$hc.posix=e.$ic,e.$jc=a?e.$hc.normalize:e.$ic.normalize,e.$kc=a?e.$hc.isAbsolute:e.$ic.isAbsolute,e.$lc=a?e.$hc.join:e.$ic.join,e.$mc=a?e.$hc.resolve:e.$ic.resolve,e.$nc=a?e.$hc.relative:e.$ic.relative,e.$oc=a?e.$hc.dirname:e.$ic.dirname,e.$pc=a?e.$hc.basename:e.$ic.basename,e.$qc=a?e.$hc.extname:e.$ic.extname,e.$rc=a?e.$hc.format:e.$ic.format,e.$sc=a?e.$hc.parse:e.$ic.parse,e.$tc=a?e.$hc.toNamespacedPath:e.$ic.toNamespacedPath,e.sep=a?e.$hc.sep:e.$ic.sep,e.$vc=a?e.$hc.delimiter:e.$ic.delimiter}),define(Ee[140],ye([1,0,49,16]),function(ce,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tr=N,e.$ur=$,e.$vr=c,e.$wr=I,e.$xr=E,e.$yr=u,e.$zr=k,e.$Ar=p,e.$Br=a,e.$Cr=f,e.$Dr=w,e.$Er=S,e.$Fr=D;const P=new r.$X(()=>{const y=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:y,collatorIsNumeric:y.resolvedOptions().numeric}}),R=new r.$X(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),T=new r.$X(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function N(y,C,A=!1){const b=y||"",v=C||"",L=P.value.collator.compare(b,v);return P.value.collatorIsNumeric&&L===0&&b!==v?b<v?-1:1:L}function $(y,C){const A=R.value.collator;return y=y||"",C=C||"",o(A,y,C)}function c(y,C){const A=R.value.collator;return y=y||"",C=C||"",g(y,C)||o(A,y,C)}function I(y,C){const A=R.value.collator;return y=y||"",C=C||"",s(y,C)||o(A,y,C)}function E(y,C){return y=y||"",C=C||"",y===C?0:y<C?-1:1}function u(y,C){const[A,b]=m(y),[v,L]=m(C);let O=P.value.collator.compare(b,L);if(O===0){if(P.value.collatorIsNumeric&&b!==L)return b<L?-1:1;if(O=P.value.collator.compare(A,v),P.value.collatorIsNumeric&&O===0&&A!==v)return A<v?-1:1}return O}function k(y,C){y=y||"",C=C||"";const A=n(y),b=n(C),v=R.value.collator,L=T.value.collator;return o(L,A,b)||o(v,y,C)}function p(y,C){y=y||"",C=C||"";const A=n(y),b=n(C),v=R.value.collator,L=T.value.collator;return o(L,A,b)||g(y,C)||o(v,y,C)}function a(y,C){y=y||"",C=C||"";const A=n(y),b=n(C),v=R.value.collator,L=T.value.collator;return o(L,A,b)||s(y,C)||o(v,y,C)}function f(y,C){y=y||"",C=C||"";const A=n(y).toLowerCase(),b=n(C).toLowerCase();return A!==b?A<b?-1:1:y!==C?y<C?-1:1:0}const d=/^(.*?)(\.([^.]*))?$/;function m(y,C=!1){const A=y?d.exec(y):[];let b=[A&&A[1]||"",A&&A[3]||""];return C&&(!b[0]&&b[1]||b[0]&&b[0].charAt(0)===".")&&(b=[b[0]+"."+b[1],""]),b}function n(y){const C=y?d.exec(y):[];return C&&C[1]&&C[1].charAt(0)!=="."&&C[3]||""}function o(y,C,A){const b=y.compare(C,A);return b!==0?b:C.length!==A.length?C.length<A.length?-1:1:0}function t(y){const C=y.charAt(0);return C.toLocaleUpperCase()!==C}function i(y){const C=y.charAt(0);return C.toLocaleLowerCase()!==C}function s(y,C){return t(y)&&i(C)?-1:i(y)&&t(C)?1:0}function g(y,C){return i(y)&&t(C)?-1:t(y)&&i(C)?1:0}function l(y,C,A=!1){return A||(y=y&&y.toLowerCase(),C=C&&C.toLowerCase()),y===C?0:y<C?-1:1}function w(y,C,A=!1){const b=y.split(h.sep),v=C.split(h.sep),L=b.length-1,O=v.length-1;let M,j;for(let z=0;;z++){if(M=L===z,j=O===z,M&&j)return N(b[z],v[z],A);if(M)return-1;if(j)return 1;const F=l(b[z],v[z],A);if(F!==0)return F}}function S(y,C,A){const b=y.toLowerCase(),v=C.toLowerCase(),L=D(y,C,A);if(L)return L;const O=b.endsWith(A),M=v.endsWith(A);if(O!==M)return O?-1:1;const j=N(b,v);return j!==0?j:b.localeCompare(v)}function D(y,C,A){const b=y.toLowerCase(),v=C.toLowerCase(),L=b.startsWith(A),O=v.startsWith(A);if(L!==O)return L?-1:1;if(L&&O){if(b.length<v.length)return-1;if(b.length>v.length)return 1}return 0}}),define(Ee[33],ye([1,0,27,16,11,13,18]),function(ce,e,r,h,P,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xg=N,e.$yg=$,e.$zg=c,e.$Ag=I,e.$Bg=E,e.$Cg=a,e.$Dg=f,e.$Eg=d,e.$Fg=m,e.$Gg=n,e.$Hg=o,e.$Ig=t,e.$Jg=i,e.$Kg=s,e.$Lg=g,e.$Mg=l,e.$Ng=D;function N(y){return y===r.CharCode.Slash||y===r.CharCode.Backslash}function $(y){return y.replace(/[\\/]/g,h.$ic.sep)}function c(y){return y.indexOf("/")===-1&&(y=$(y)),/^[a-zA-Z]:(\/|$)/.test(y)&&(y="/"+y),y}function I(y,C=h.$ic.sep){if(!y)return"";const A=y.length,b=y.charCodeAt(0);if(N(b)){if(N(y.charCodeAt(1))&&!N(y.charCodeAt(2))){let L=3;const O=L;for(;L<A&&!N(y.charCodeAt(L));L++);if(O!==L&&!N(y.charCodeAt(L+1))){for(L+=1;L<A;L++)if(N(y.charCodeAt(L)))return y.slice(0,L+1).replace(/[\\/]/g,C)}}return C}else if(m(b)&&y.charCodeAt(1)===r.CharCode.Colon)return N(y.charCodeAt(2))?y.slice(0,2)+C:y.slice(0,2);let v=y.indexOf("://");if(v!==-1){for(v+=3;v<A;v++)if(N(y.charCodeAt(v)))return y.slice(0,v+1)}return""}function E(y){if(!P.$i||!y||y.length<5)return!1;let C=y.charCodeAt(0);if(C!==r.CharCode.Backslash||(C=y.charCodeAt(1),C!==r.CharCode.Backslash))return!1;let A=2;const b=A;for(;A<y.length&&(C=y.charCodeAt(A),C!==r.CharCode.Backslash);A++);return!(b===A||(C=y.charCodeAt(A+1),isNaN(C)||C===r.CharCode.Backslash))}const u=/[\\/:\*\?"<>\|]/g,k=/[/]/g,p=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function a(y,C=P.$i){const A=C?u:k;return!(!y||y.length===0||/^\s+$/.test(y)||(A.lastIndex=0,A.test(y))||C&&p.test(y)||y==="."||y===".."||C&&y[y.length-1]==="."||C&&y.length!==y.trim().length||y.length>255)}function f(y,C,A){const b=y===C;return!A||b?b:!y||!C?!1:(0,R.$Gf)(y,C)}function d(y,C,A,b=h.sep){if(y===C)return!0;if(!y||!C||C.length>y.length)return!1;if(A){if(!(0,R.$Hf)(y,C))return!1;if(C.length===y.length)return!0;let L=C.length;return C.charAt(C.length-1)===b&&L--,y.charAt(L)===b}return C.charAt(C.length-1)!==b&&(C+=b),y.indexOf(C)===0}function m(y){return y>=r.CharCode.A&&y<=r.CharCode.Z||y>=r.CharCode.a&&y<=r.CharCode.z}function n(y,C){return P.$i&&y.endsWith(":")&&(y+=h.sep),(0,h.$kc)(y)||(y=(0,h.$lc)(C,y)),y=(0,h.$jc)(y),o(y)}function o(y){return P.$i?(y=(0,R.$of)(y,h.sep),y.endsWith(":")&&(y+=h.sep)):(y=(0,R.$of)(y,h.sep),y||(y=h.sep)),y}function t(y){const C=(0,h.$jc)(y);return P.$i?y.length>3?!1:i(C)&&(y.length===2||C.charCodeAt(2)===r.CharCode.Backslash):C===h.$ic.sep}function i(y,C=P.$i){return C?m(y.charCodeAt(0))&&y.charCodeAt(1)===r.CharCode.Colon:!1}function s(y,C=P.$i){return i(y,C)?y[0]:void 0}function g(y,C,A){return C.length>y.length?-1:y===C?0:(A&&(y=y.toLowerCase(),C=C.toLowerCase()),y.indexOf(C))}function l(y){const C=y.split(":");let A,b,v;for(const L of C){const O=Number(L);(0,T.$jg)(O)?b===void 0?b=O:v===void 0&&(v=O):A=A?[A,L].join(":"):L}if(!A)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:A,line:b!==void 0?b:void 0,column:v!==void 0?v:b!==void 0?1:void 0}}const w="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",S="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function D(y,C,A=8){let b="";for(let L=0;L<A;L++){let O;L===0&&P.$i&&!C&&(A===3||A===4)?O=S:O=w,b+=O.charAt(Math.floor(Math.random()*O.length))}let v;return C?v=`${C}-${b}`:v=b,y?(0,h.$lc)(y,v):v}}),define(Ee[141],ye([1,0,27,140,135,60,16,11,13]),function(ce,e,r,h,P,R,T,N,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gr=E,e.$Hr=d,e.$Ir=l,e.$Jr=b,e.$Kr=z,e.$Lr=B;const c=0,I=[c,[]];function E(_,re,U,G){if(!_||!re)return I;const Q=_.length,ee=re.length;if(Q<ee)return I;const he=_.toLowerCase();return u(re,U,ee,_,he,Q,G)}function u(_,re,U,G,Q,ee,he){const ne=[],De=[];for(let se=0;se<U;se++){const oe=se*ee,te=oe-ee,le=se>0,ue=_[se],X=re[se];for(let ae=0;ae<ee;ae++){const pe=ae>0,be=oe+ae,Fe=be-1,Ue=te+ae-1,ke=pe?ne[Fe]:0,Ie=le&&pe?ne[Ue]:0,Re=le&&pe?De[Ue]:0;let q;!Ie&&le?q=0:q=k(ue,X,G,Q,ae,Re),q&&Ie+q>=ke&&(he||le||Q.startsWith(re,ae))?(De[be]=Re+1,ne[be]=Ie+q):(De[be]=c,ne[be]=ke)}}const $e=[];let K=U-1,W=ee-1;for(;K>=0&&W>=0;){const se=K*ee+W;De[se]===c||($e.push(W),K--),W--}return[ne[U*ee-1],$e.reverse()]}function k(_,re,U,G,Q,ee){let he=0;if(!p(re,G[Q]))return he;if(he+=1,ee>0&&(he+=ee*5),_===U[Q]&&(he+=1),Q===0)he+=8;else{const ne=a(U.charCodeAt(Q-1));ne?he+=ne:(0,P.$Kk)(U.charCodeAt(Q))&&ee===0&&(he+=2)}return he}function p(_,re){return _===re?!0:_==="/"||_==="\\"?re==="/"||re==="\\":!1}function a(_){switch(_){case r.CharCode.Slash:case r.CharCode.Backslash:return 5;case r.CharCode.Underline:case r.CharCode.Dash:case r.CharCode.Period:case r.CharCode.Space:case r.CharCode.SingleQuote:case r.CharCode.DoubleQuote:case r.CharCode.Colon:return 4;default:return 0}}const f=[void 0,[]];function d(_,re,U=0,G=0){const Q=re;return Q.values&&Q.values.length>1?m(_,Q.values,U,G):n(_,re,U,G)}function m(_,re,U,G){let Q=0;const ee=[];for(const he of re){const[ne,De]=n(_,he,U,G);if(typeof ne!="number")return f;Q+=ne,ee.push(...De)}return[Q,C(ee)]}function n(_,re,U,G){const Q=(0,P.$Tk)(re.original,re.originalLowercase,U,_,_.toLowerCase(),G,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return Q?[Q[0],(0,P.$Qk)(Q)]:f}const o=Object.freeze({score:0}),t=1<<18,i=1<<17,s=65536;function g(_,re,U,G){const Q=G.values?G.values:[G];return(0,R.$tj)({[G.normalized]:{values:Q.map(he=>({value:he.normalized,expectContiguousMatch:he.expectContiguousMatch})),label:_,description:re,allowNonContiguousMatches:U}})}function l(_,re,U,G,Q){if(!_||!re.normalized)return o;const ee=G.getItemLabel(_);if(!ee)return o;const he=G.getItemDescription(_),ne=g(ee,he,U,re),De=Q[ne];if(De)return De;const $e=w(ee,he,G.getItemPath(_),re,U);return Q[ne]=$e,$e}function w(_,re,U,G,Q){const ee=!U||!G.containsPathSeparator;return U&&(N.$k?G.pathNormalized===U:(0,$.$Gf)(G.pathNormalized,U))?{score:t,labelMatch:[{start:0,end:_.length}],descriptionMatch:re?[{start:0,end:re.length}]:void 0}:G.values&&G.values.length>1?S(_,re,U,G.values,ee,Q):D(_,re,U,G,ee,Q)}function S(_,re,U,G,Q,ee){let he=0;const ne=[],De=[];for(const $e of G){const{score:K,labelMatch:W,descriptionMatch:se}=D(_,re,U,$e,Q,ee);if(K===c)return o;he+=K,W&&ne.push(...W),se&&De.push(...se)}return{score:he,labelMatch:C(ne),descriptionMatch:C(De)}}function D(_,re,U,G,Q,ee){if(Q||!re){const[he,ne]=E(_,G.normalized,G.normalizedLowercase,ee&&!G.expectContiguousMatch);if(he){const De=(0,P.$Hk)(G.normalized,_);let $e;if(De){$e=i;const K=Math.round(G.normalized.length/_.length*100);$e+=K}else $e=s;return{score:$e+he,labelMatch:De||y(ne)}}}if(re){let he=re;U&&(he=`${re}${T.sep}`);const ne=he.length,De=`${he}${_}`,[$e,K]=E(De,G.normalized,G.normalizedLowercase,ee&&!G.expectContiguousMatch);if($e){const W=y(K),se=[],oe=[];return W.forEach(te=>{te.start<ne&&te.end>ne?(se.push({start:0,end:te.end-ne}),oe.push({start:te.start,end:ne})):te.start>=ne?se.push({start:te.start-ne,end:te.end-ne}):oe.push(te)}),{score:$e,labelMatch:se,descriptionMatch:oe}}}return o}function y(_){const re=[];if(!_)return re;let U;for(const G of _)U&&U.end===G?U.end+=1:(U={start:G,end:G+1},re.push(U));return re}function C(_){const re=_.sort((Q,ee)=>Q.start-ee.start),U=[];let G;for(const Q of re)!G||!A(G,Q)?(G=Q,U.push(Q)):(G.start=Math.min(G.start,Q.start),G.end=Math.max(G.end,Q.end));return U}function A(_,re){return!(_.end<re.start||re.end<_.start)}function b(_,re,U,G,Q,ee){const he=l(_,U,G,Q,ee),ne=l(re,U,G,Q,ee),De=he.score,$e=ne.score;if((De===t||$e===t)&&De!==$e)return De===t?-1:1;if(De>s||$e>s){if(De!==$e)return De>$e?-1:1;if(De<i&&$e<i){const ue=L(he.labelMatch,ne.labelMatch);if(ue!==0)return ue}const te=Q.getItemLabel(_)||"",le=Q.getItemLabel(re)||"";if(te.length!==le.length)return te.length-le.length}if(De!==$e)return De>$e?-1:1;const K=Array.isArray(he.labelMatch)&&he.labelMatch.length>0,W=Array.isArray(ne.labelMatch)&&ne.labelMatch.length>0;if(K&&!W)return-1;if(W&&!K)return 1;const se=v(_,he,Q),oe=v(re,ne,Q);return se&&oe&&se!==oe?oe>se?-1:1:O(_,re,U,Q)}function v(_,re,U){let G=-1,Q=-1;if(re.descriptionMatch&&re.descriptionMatch.length?G=re.descriptionMatch[0].start:re.labelMatch&&re.labelMatch.length&&(G=re.labelMatch[0].start),re.labelMatch&&re.labelMatch.length){if(Q=re.labelMatch[re.labelMatch.length-1].end,re.descriptionMatch&&re.descriptionMatch.length){const ee=U.getItemDescription(_);ee&&(Q+=ee.length)}}else re.descriptionMatch&&re.descriptionMatch.length&&(Q=re.descriptionMatch[re.descriptionMatch.length-1].end);return Q-G}function L(_,re){if(!_&&!re||(!_||!_.length)&&(!re||!re.length))return 0;if(!re||!re.length)return-1;if(!_||!_.length)return 1;const U=_[0].start,Q=_[_.length-1].end-U,ee=re[0].start,ne=re[re.length-1].end-ee;return Q===ne?0:ne<Q?1:-1}function O(_,re,U,G){const Q=G.getItemLabel(_)||"",ee=G.getItemLabel(re)||"",he=G.getItemDescription(_),ne=G.getItemDescription(re),De=Q.length+(he?he.length:0),$e=ee.length+(ne?ne.length:0);if(De!==$e)return De-$e;const K=G.getItemPath(_),W=G.getItemPath(re);return K&&W&&K.length!==W.length?K.length-W.length:Q!==ee?(0,h.$Er)(Q,ee,U.normalized):he&&ne&&he!==ne?(0,h.$Er)(he,ne,U.normalized):K&&W&&K!==W?(0,h.$Er)(K,W,U.normalized):0}function M(_){return _.startsWith('"')&&_.endsWith('"')}const j=" ";function z(_){typeof _!="string"&&(_="");const re=_.toLowerCase(),{pathNormalized:U,normalized:G,normalizedLowercase:Q}=F(_),ee=U.indexOf(T.sep)>=0,he=M(_);let ne;const De=_.split(j);if(De.length>1)for(const $e of De){const K=M($e),{pathNormalized:W,normalized:se,normalizedLowercase:oe}=F($e);se&&(ne||(ne=[]),ne.push({original:$e,originalLowercase:$e.toLowerCase(),pathNormalized:W,normalized:se,normalizedLowercase:oe,expectContiguousMatch:K}))}return{original:_,originalLowercase:re,pathNormalized:U,normalized:G,normalizedLowercase:Q,values:ne,containsPathSeparator:ee,expectContiguousMatch:he}}function F(_){let re;N.$i?re=_.replace(/\//g,T.sep):re=_.replace(/\\/g,T.sep);const U=(0,$.$qf)(re).replace(/\s|"/g,"");return{pathNormalized:re,normalized:U,normalizedLowercase:U.toLowerCase()}}function B(_){return Array.isArray(_)?z(_.map(re=>re.original).join(j)):z(_.original)}}),define(Ee[108],ye([1,0,16]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4s=void 0,e.$5s=R,e.$6s=T,e.$7s=N,e.$8s=c,e.$4s=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const h={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},P={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function R(I){const E=(0,r.$qc)(I),u=h[E.toLowerCase()];return u!==void 0?u:T(I)}function T(I){const E=(0,r.$qc)(I);return P[E.toLowerCase()]}function N(I){for(const E in P)if(P[E]===I)return E}const $=/^(.+)\/(.+?)(;.+)?$/;function c(I,E){const u=$.exec(I);return u?`${u[1].toLowerCase()}/${u[2].toLowerCase()}${u[3]??""}`:E?void 0:I}}),define(Ee[109],ye([1,0,11]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminateResponseCode=e.Source=void 0,e.$km=R,e.$lm=T;var h;(function(N){N[N.stdout=0]="stdout",N[N.stderr=1]="stderr"})(h||(e.Source=h={}));var P;(function(N){N[N.Success=0]="Success",N[N.Unknown=1]="Unknown",N[N.AccessDenied=2]="AccessDenied",N[N.ProcessNotFound=3]="ProcessNotFound"})(P||(e.TerminateResponseCode=P={}));function R(N,...$){const c=$.reduce((u,k)=>(u[k]=!0,u),{}),I=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(N).filter(u=>!c[u]).forEach(u=>{for(let k=0;k<I.length;k++)if(u.search(I[k])!==-1){delete N[u];break}})}function T(N){N&&(delete N.DEBUG,r.$j&&delete N.DYLD_LIBRARY_PATH,r.$k&&delete N.LD_PRELOAD)}}),define(Ee[2],ye([1,0,27,41,16,11]),function(ce,e,r,h,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URI=void 0,e.$xc=f,e.$yc=i,P=We(P);const T=/^\w[\w\d+.-]*$/,N=/^\//,$=/^\/\//;function c(S,D){if(!S.scheme&&D)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${S.authority}", path: "${S.path}", query: "${S.query}", fragment: "${S.fragment}"}`);if(S.scheme&&!T.test(S.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(S.path){if(S.authority){if(!N.test(S.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if($.test(S.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function I(S,D){return!S&&!D?"file":S}function E(S,D){switch(S){case"https":case"http":case"file":D?D[0]!==k&&(D=k+D):D=k;break}return D}const u="",k="/",p=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class a{static isUri(D){return D instanceof a?!0:D?typeof D.authority=="string"&&typeof D.fragment=="string"&&typeof D.path=="string"&&typeof D.query=="string"&&typeof D.scheme=="string"&&typeof D.fsPath=="string"&&typeof D.with=="function"&&typeof D.toString=="function":!1}constructor(D,y,C,A,b,v=!1){typeof D=="object"?(this.scheme=D.scheme||u,this.authority=D.authority||u,this.path=D.path||u,this.query=D.query||u,this.fragment=D.fragment||u):(this.scheme=I(D,v),this.authority=y||u,this.path=E(this.scheme,C||u),this.query=A||u,this.fragment=b||u,c(this,v))}get fsPath(){return i(this,!1)}with(D){if(!D)return this;let{scheme:y,authority:C,path:A,query:b,fragment:v}=D;return y===void 0?y=this.scheme:y===null&&(y=u),C===void 0?C=this.authority:C===null&&(C=u),A===void 0?A=this.path:A===null&&(A=u),b===void 0?b=this.query:b===null&&(b=u),v===void 0?v=this.fragment:v===null&&(v=u),y===this.scheme&&C===this.authority&&A===this.path&&b===this.query&&v===this.fragment?this:new m(y,C,A,b,v)}static parse(D,y=!1){const C=p.exec(D);return C?new m(C[2]||u,w(C[4]||u),w(C[5]||u),w(C[7]||u),w(C[9]||u),y):new m(u,u,u,u,u)}static file(D){let y=u;if(R.$i&&(D=D.replace(/\\/g,k)),D[0]===k&&D[1]===k){const C=D.indexOf(k,2);C===-1?(y=D.substring(2),D=k):(y=D.substring(2,C),D=D.substring(C)||k)}return new m("file",y,D,u,u)}static from(D,y){return new m(D.scheme,D.authority,D.path,D.query,D.fragment,y)}static joinPath(D,...y){if(!D.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let C;return R.$i&&D.scheme==="file"?C=a.file(P.$hc.join(i(D,!0),...y)).path:C=P.$ic.join(D.path,...y),D.with({path:C})}toString(D=!1){return s(this,D)}toJSON(){return this}static revive(D){if(D){if(D instanceof a)return D;{const y=new m(D);return y._formatted=D.external??null,y._fsPath=D._sep===d?D.fsPath??null:null,y}}else return D}}e.URI=a;function f(S){return!S||typeof S!="object"?!1:typeof S.scheme=="string"&&(typeof S.authority=="string"||typeof S.authority>"u")&&(typeof S.path=="string"||typeof S.path>"u")&&(typeof S.query=="string"||typeof S.query>"u")&&(typeof S.fragment=="string"||typeof S.fragment>"u")}const d=R.$i?1:void 0;class m extends a{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=i(this,!1)),this._fsPath}toString(D=!1){return D?s(this,!0):(this._formatted||(this._formatted=s(this,!1)),this._formatted)}toJSON(){const D={$mid:h.MarshalledId.Uri};return this._fsPath&&(D.fsPath=this._fsPath,D._sep=d),this._formatted&&(D.external=this._formatted),this.path&&(D.path=this.path),this.scheme&&(D.scheme=this.scheme),this.authority&&(D.authority=this.authority),this.query&&(D.query=this.query),this.fragment&&(D.fragment=this.fragment),D}}const n={[r.CharCode.Colon]:"%3A",[r.CharCode.Slash]:"%2F",[r.CharCode.QuestionMark]:"%3F",[r.CharCode.Hash]:"%23",[r.CharCode.OpenSquareBracket]:"%5B",[r.CharCode.CloseSquareBracket]:"%5D",[r.CharCode.AtSign]:"%40",[r.CharCode.ExclamationMark]:"%21",[r.CharCode.DollarSign]:"%24",[r.CharCode.Ampersand]:"%26",[r.CharCode.SingleQuote]:"%27",[r.CharCode.OpenParen]:"%28",[r.CharCode.CloseParen]:"%29",[r.CharCode.Asterisk]:"%2A",[r.CharCode.Plus]:"%2B",[r.CharCode.Comma]:"%2C",[r.CharCode.Semicolon]:"%3B",[r.CharCode.Equals]:"%3D",[r.CharCode.Space]:"%20"};function o(S,D,y){let C,A=-1;for(let b=0;b<S.length;b++){const v=S.charCodeAt(b);if(v>=r.CharCode.a&&v<=r.CharCode.z||v>=r.CharCode.A&&v<=r.CharCode.Z||v>=r.CharCode.Digit0&&v<=r.CharCode.Digit9||v===r.CharCode.Dash||v===r.CharCode.Period||v===r.CharCode.Underline||v===r.CharCode.Tilde||D&&v===r.CharCode.Slash||y&&v===r.CharCode.OpenSquareBracket||y&&v===r.CharCode.CloseSquareBracket||y&&v===r.CharCode.Colon)A!==-1&&(C+=encodeURIComponent(S.substring(A,b)),A=-1),C!==void 0&&(C+=S.charAt(b));else{C===void 0&&(C=S.substr(0,b));const L=n[v];L!==void 0?(A!==-1&&(C+=encodeURIComponent(S.substring(A,b)),A=-1),C+=L):A===-1&&(A=b)}}return A!==-1&&(C+=encodeURIComponent(S.substring(A))),C!==void 0?C:S}function t(S){let D;for(let y=0;y<S.length;y++){const C=S.charCodeAt(y);C===r.CharCode.Hash||C===r.CharCode.QuestionMark?(D===void 0&&(D=S.substr(0,y)),D+=n[C]):D!==void 0&&(D+=S[y])}return D!==void 0?D:S}function i(S,D){let y;return S.authority&&S.path.length>1&&S.scheme==="file"?y=`//${S.authority}${S.path}`:S.path.charCodeAt(0)===r.CharCode.Slash&&(S.path.charCodeAt(1)>=r.CharCode.A&&S.path.charCodeAt(1)<=r.CharCode.Z||S.path.charCodeAt(1)>=r.CharCode.a&&S.path.charCodeAt(1)<=r.CharCode.z)&&S.path.charCodeAt(2)===r.CharCode.Colon?D?y=S.path.substr(1):y=S.path[1].toLowerCase()+S.path.substr(2):y=S.path,R.$i&&(y=y.replace(/\//g,"\\")),y}function s(S,D){const y=D?t:o;let C="",{scheme:A,authority:b,path:v,query:L,fragment:O}=S;if(A&&(C+=A,C+=":"),(b||A==="file")&&(C+=k,C+=k),b){let M=b.indexOf("@");if(M!==-1){const j=b.substr(0,M);b=b.substr(M+1),M=j.lastIndexOf(":"),M===-1?C+=y(j,!1,!1):(C+=y(j.substr(0,M),!1,!1),C+=":",C+=y(j.substr(M+1),!1,!0)),C+="@"}b=b.toLowerCase(),M=b.lastIndexOf(":"),M===-1?C+=y(b,!1,!0):(C+=y(b.substr(0,M),!1,!0),C+=b.substr(M))}if(v){if(v.length>=3&&v.charCodeAt(0)===r.CharCode.Slash&&v.charCodeAt(2)===r.CharCode.Colon){const M=v.charCodeAt(1);M>=r.CharCode.A&&M<=r.CharCode.Z&&(v=`/${String.fromCharCode(M+32)}:${v.substr(3)}`)}else if(v.length>=2&&v.charCodeAt(1)===r.CharCode.Colon){const M=v.charCodeAt(0);M>=r.CharCode.A&&M<=r.CharCode.Z&&(v=`${String.fromCharCode(M+32)}:${v.substr(2)}`)}C+=y(v,!0,!1)}return L&&(C+="?",C+=y(L,!1,!1)),O&&(C+="#",C+=D?O:o(O,!1,!1)),C}function g(S){try{return decodeURIComponent(S)}catch{return S.length>3?S.substr(0,3)+g(S.substr(3)):S}}const l=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function w(S){return S.match(l)?S.replace(l,D=>g(D)):S}}),define(Ee[206],ye([1,0,2]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9q=h,e.$0q=P,e.$$q=R,e.log=N;function h(c){const I=c;return I&&typeof I.type=="string"&&typeof I.severity=="string"}function P(c){const I=[];let E;try{const u=JSON.parse(c.arguments),k=u[u.length-1];k&&k.__$stack&&(u.pop(),E=k.__$stack),I.push(...u)}catch{I.push("Unable to log remote console arguments",c.arguments)}return{args:I,stack:E}}function R(c){if(typeof c!="string")return R(P(c).stack);const I=c;if(I){const E=T(I),u=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(E||"");if(u&&u.length===4)return{uri:r.URI.file(u[1]),line:Number(u[2]),column:Number(u[3])}}}function T(c){if(!c)return c;const I=c.indexOf(`
`);return I===-1?c:c.substring(0,I)}function N(c,I){const{args:E,stack:u}=P(c),k=typeof E[0]=="string"&&E.length===1;let p=T(u);p&&(p=`(${p.trim()})`);let a=[];if(typeof E[0]=="string"?p&&k?a=[`%c[${I}] %c${E[0]} %c${p}`,$("blue"),$(""),$("grey")]:a=[`%c[${I}] %c${E[0]}`,$("blue"),$(""),...E.slice(1)]:a=[`%c[${I}]%`,$("blue"),...E],p&&!k&&a.push(p),typeof console[c.severity]!="function")throw new Error("Unknown console method");console[c.severity].apply(console,a)}function $(c){return`color: ${c}`}}),define(Ee[57],ye([1,0,22,2,41]),function(ce,e,r,h,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ai=R,e.$bi=T,e.$ci=$;function R(c){return JSON.stringify(c,N)}function T(c){let I=JSON.parse(c);return I=$(I),I}function N(c,I){return I instanceof RegExp?{$mid:P.MarshalledId.Regexp,source:I.source,flags:I.flags}:I}function $(c,I=0){if(!c||I>200)return c;if(typeof c=="object"){switch(c.$mid){case P.MarshalledId.Uri:return h.URI.revive(c);case P.MarshalledId.Regexp:return new RegExp(c.source,c.flags);case P.MarshalledId.Date:return new Date(c.source)}if(c instanceof r.$Oe||c instanceof Uint8Array)return c;if(Array.isArray(c))for(let E=0;E<c.length;++E)c[E]=$(c[E],I+1);else for(const E in c)Object.hasOwnProperty.call(c,E)&&(c[E]=$(c[E],I+1))}return c}}),define(Ee[15],ye([1,0,14,11,13,2,16]),function(ce,e,r,h,P,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Sg=e.$Rg=e.$Qg=e.Schemas=void 0,e.$Og=$,e.$Pg=c,e.$Tg=E,r=We(r),h=We(h),T=We(T);var N;(function(p){p.inMemory="inmemory",p.vscode="vscode",p.internal="private",p.walkThrough="walkThrough",p.walkThroughSnippet="walkThroughSnippet",p.http="http",p.https="https",p.file="file",p.mailto="mailto",p.untitled="untitled",p.data="data",p.command="command",p.vscodeRemote="vscode-remote",p.vscodeRemoteResource="vscode-remote-resource",p.vscodeManagedRemoteResource="vscode-managed-remote-resource",p.vscodeUserData="vscode-userdata",p.vscodeCustomEditor="vscode-custom-editor",p.vscodeNotebookCell="vscode-notebook-cell",p.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",p.vscodeNotebookCellOutput="vscode-notebook-cell-output",p.vscodeInteractiveInput="vscode-interactive-input",p.vscodeSettings="vscode-settings",p.vscodeWorkspaceTrust="vscode-workspace-trust",p.vscodeTerminal="vscode-terminal",p.vscodeChatCodeBlock="vscode-chat-code-block",p.vscodeCopilotBackingChatCodeBlock="vscode-copilot-chat-code-block",p.vscodeChatCodeCompareBlock="vscode-chat-code-compare-block",p.vscodeChatSesssion="vscode-chat-editor",p.webviewPanel="webview-panel",p.vscodeWebview="vscode-webview",p.extension="extension",p.vscodeFileResource="vscode-file",p.tmp="tmp",p.vsls="vsls",p.vscodeSourceControl="vscode-scm",p.commentsInput="comment",p.codeSetting="code-setting"})(N||(e.Schemas=N={}));function $(p,a){return R.URI.isUri(p)?(0,P.$Gf)(p.scheme,a):(0,P.$Hf)(p,a+":")}function c(p,...a){return a.some(f=>$(p,f))}e.$Qg="vscode-tkn",e.$Rg="tkn";class I{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f="/"}setPreferredWebSchema(a){this.d=a}setDelegate(a){this.e=a}setServerRootPath(a,f){this.f=E(a,f)}getServerRootPath(){return this.f}get g(){return T.$ic.join(this.f,N.vscodeRemoteResource)}set(a,f,d){this.a[a]=f,this.b[a]=d}setConnectionToken(a,f){this.c[a]=f}getPreferredWebSchema(){return this.d}rewrite(a){if(this.e)try{return this.e(a)}catch(t){return r.$3(t),a}const f=a.authority;let d=this.a[f];d&&d.indexOf(":")!==-1&&d.indexOf("[")===-1&&(d=`[${d}]`);const m=this.b[f],n=this.c[f];let o=`path=${encodeURIComponent(a.path)}`;return typeof n=="string"&&(o+=`&${e.$Rg}=${encodeURIComponent(n)}`),R.URI.from({scheme:h.$o?this.d:N.vscodeRemoteResource,authority:`${d}:${m}`,path:this.g,query:o})}}e.$Sg=new I;function E(p,a){return T.$ic.join(a??"/",`${p.quality??"oss"}-${p.commit??"dev"}`)}e.$Ug="vs/../../extensions",e.$Vg="vs/../../node_modules",e.$Wg="vs/../../node_modules.asar",e.$Xg="vs/../../node_modules.asar.unpacked",e.$Yg="vscode-app";class u{static{this.a=e.$Yg}asBrowserUri(a){const f=this.b(a,ce);return this.uriToBrowserUri(f)}uriToBrowserUri(a){return a.scheme===N.vscodeRemote?e.$Sg.rewrite(a):a.scheme===N.file&&(h.$m||h.$q===`${N.vscodeFileResource}://${u.a}`)?a.with({scheme:N.vscodeFileResource,authority:a.authority||u.a,query:null,fragment:null}):a}asFileUri(a){const f=this.b(a,ce);return this.uriToFileUri(f)}uriToFileUri(a){return a.scheme===N.vscodeFileResource?a.with({scheme:N.file,authority:a.authority!==u.a?a.authority:null,query:null,fragment:null}):a}b(a,f){return R.URI.isUri(a)?a:R.URI.parse(f.toUrl(a))}}e.$Zg=new u;var k;(function(p){const a=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);p.CoopAndCoep=Object.freeze(a.get("3"));const f="vscode-coi";function d(n){let o;typeof n=="string"?o=new URL(n).searchParams:n instanceof URL?o=n.searchParams:R.URI.isUri(n)&&(o=new URL(n.toString(!0)).searchParams);const t=o?.get(f);if(t)return a.get(t)}p.getHeadersFromQuery=d;function m(n,o,t){if(!globalThis.crossOriginIsolated)return;const i=o&&t?"3":t?"2":"1";n instanceof URLSearchParams?n.set(f,i):n[f]=i}p.addSearchParam=m})(k||(e.COI=k={}))}),define(Ee[207],ye([1,0,173,15,11,2]),function(ce,e,r,h,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oE=I,P=We(P);class T{constructor(u,k,p){this.id=u,this.dependencies=k,this.callback=p}}class N{static{this.INSTANCE=new N}constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=(u,k,p)=>{typeof u!="string"&&(p=k,k=u,u=null),(typeof k!="object"||!Array.isArray(k))&&(p=k,k=null),this.c.push(new T(u,k,p))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(u){if(u.startsWith(window.location.origin)||u.startsWith("vscode-file://vscode-app"))return u;throw new Error(`[trusted_script_src] Invalid script url: ${u}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(u){return u}})))}async load(u){this.g();const k=await(this.a?this.i(u):this.b?this.h(u):this.j(u));if(!k)throw new Error(`Did not receive a define call from script ${u}`);if(Array.isArray(k.dependencies)&&k.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${u}. The dependencies are: ${k.dependencies.join(", ")}`);return typeof k.callback=="function"?k.callback([]):k.callback}h(u){return new Promise((k,p)=>{const a=document.createElement("script");a.setAttribute("async","async"),a.setAttribute("type","text/javascript");const f=()=>{a.removeEventListener("load",d),a.removeEventListener("error",m)},d=n=>{f(),k(this.c.pop())},m=n=>{f(),p(n)};a.addEventListener("load",d),a.addEventListener("error",m),this.f&&(u=this.f.createScriptURL(u)),a.setAttribute("src",u),window.document.getElementsByTagName("head")[0].appendChild(a)})}i(u){return new Promise((k,p)=>{try{this.f&&(u=this.f.createScriptURL(u)),importScripts(u),k(this.c.pop())}catch(a){p(a)}})}async j(u){try{const k=globalThis._VSCODE_NODE_MODULES.fs,p=globalThis._VSCODE_NODE_MODULES.vm,a=globalThis._VSCODE_NODE_MODULES.module,f=R.URI.parse(u).fsPath,d=k.readFileSync(f).toString(),m=a.wrap(d.replace(/^#!.*/,""));return new p.Script(m).runInThisContext().apply(),this.c.pop()}catch(k){throw k}}}const $=new Map;let c={};typeof globalThis.require=="object"&&(c=globalThis.require.paths??{});async function I(E,u,k){if(r.$V){k===void 0&&(k=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),c[E]&&(E=c[E]);const p=`${E}/${u}`;if($.has(p))return $.get(p);let a;if(/^\w[\w\d+.-]*:\/\//.test(p))a=p;else{const n=`${k&&!P.$o?h.$Wg:h.$Vg}/${p}`;a=h.$Zg.asBrowserUri(n).toString(!0)}const f=N.INSTANCE.load(a);return $.set(p,f),f}else return await new Promise((p,a)=>{ce([E],p,a)}).then(We)}}),define(Ee[23],ye([1,0,27,33,15,16,11,13,2]),function(ce,e,r,h,P,R,T,N,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataUri=e.$oh=e.$nh=e.$mh=e.$lh=e.$kh=e.$jh=e.$ih=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=void 0,e.$7g=c,e.$ph=E,e.$qh=k,h=We(h),R=We(R);function c(p){return(0,$.$yc)(p,!0)}class I{constructor(a){this.a=a}compare(a,f,d=!1){return a===f?0:(0,N.$zf)(this.getComparisonKey(a,d),this.getComparisonKey(f,d))}isEqual(a,f,d=!1){return a===f?!0:!a||!f?!1:this.getComparisonKey(a,d)===this.getComparisonKey(f,d)}getComparisonKey(a,f=!1){return a.with({path:this.a(a)?a.path.toLowerCase():void 0,fragment:f?null:void 0}).toString()}ignorePathCasing(a){return this.a(a)}isEqualOrParent(a,f,d=!1){if(a.scheme===f.scheme){if(a.scheme===P.Schemas.file)return h.$Eg(c(a),c(f),this.a(a))&&a.query===f.query&&(d||a.fragment===f.fragment);if((0,e.$lh)(a.authority,f.authority))return h.$Eg(a.path,f.path,this.a(a),"/")&&a.query===f.query&&(d||a.fragment===f.fragment)}return!1}joinPath(a,...f){return $.URI.joinPath(a,...f)}basenameOrAuthority(a){return(0,e.$dh)(a)||a.authority}basename(a){return R.$ic.basename(a.path)}extname(a){return R.$ic.extname(a.path)}dirname(a){if(a.path.length===0)return a;let f;return a.scheme===P.Schemas.file?f=$.URI.file(R.$oc(c(a))).path:(f=R.$ic.dirname(a.path),a.authority&&f.length&&f.charCodeAt(0)!==r.CharCode.Slash&&(console.error(`dirname("${a.toString})) resulted in a relative path`),f="/")),a.with({path:f})}normalizePath(a){if(!a.path.length)return a;let f;return a.scheme===P.Schemas.file?f=$.URI.file(R.$jc(c(a))).path:f=R.$ic.normalize(a.path),a.with({path:f})}relativePath(a,f){if(a.scheme!==f.scheme||!(0,e.$lh)(a.authority,f.authority))return;if(a.scheme===P.Schemas.file){const n=R.$nc(c(a),c(f));return T.$i?h.$yg(n):n}let d=a.path||"/";const m=f.path||"/";if(this.a(a)){let n=0;for(const o=Math.min(d.length,m.length);n<o&&!(d.charCodeAt(n)!==m.charCodeAt(n)&&d.charAt(n).toLowerCase()!==m.charAt(n).toLowerCase());n++);d=m.substr(0,n)+d.substr(n)}return R.$ic.relative(d,m)}resolvePath(a,f){if(a.scheme===P.Schemas.file){const d=$.URI.file(R.$mc(c(a),f));return a.with({authority:d.authority,path:d.path})}return f=h.$zg(f),a.with({path:R.$ic.resolve(a.path,f)})}isAbsolutePath(a){return!!a.path&&a.path[0]==="/"}isEqualAuthority(a,f){return a===f||a!==void 0&&f!==void 0&&(0,N.$Gf)(a,f)}hasTrailingPathSeparator(a,f=R.sep){if(a.scheme===P.Schemas.file){const d=c(a);return d.length>h.$Ag(d).length&&d[d.length-1]===f}else{const d=a.path;return d.length>1&&d.charCodeAt(d.length-1)===r.CharCode.Slash&&!/^[a-zA-Z]:(\/$|\\$)/.test(a.fsPath)}}removeTrailingPathSeparator(a,f=R.sep){return(0,e.$mh)(a,f)?a.with({path:a.path.substr(0,a.path.length-1)}):a}addTrailingPathSeparator(a,f=R.sep){let d=!1;if(a.scheme===P.Schemas.file){const m=c(a);d=m!==void 0&&m.length===h.$Ag(m).length&&m[m.length-1]===f}else{f="/";const m=a.path;d=m.length===1&&m.charCodeAt(m.length-1)===r.CharCode.Slash}return!d&&!(0,e.$mh)(a,f)?a.with({path:a.path+"/"}):a}}e.$8g=I,e.$9g=new I(()=>!1),e.$0g=new I(p=>p.scheme===P.Schemas.file?!T.$k:!0),e.$$g=new I(p=>!0),e.$_g=e.$9g.isEqual.bind(e.$9g),e.$ah=e.$9g.isEqualOrParent.bind(e.$9g),e.$bh=e.$9g.getComparisonKey.bind(e.$9g),e.$ch=e.$9g.basenameOrAuthority.bind(e.$9g),e.$dh=e.$9g.basename.bind(e.$9g),e.$eh=e.$9g.extname.bind(e.$9g),e.$fh=e.$9g.dirname.bind(e.$9g),e.$gh=e.$9g.joinPath.bind(e.$9g),e.$hh=e.$9g.normalizePath.bind(e.$9g),e.$ih=e.$9g.relativePath.bind(e.$9g),e.$jh=e.$9g.resolvePath.bind(e.$9g),e.$kh=e.$9g.isAbsolutePath.bind(e.$9g),e.$lh=e.$9g.isEqualAuthority.bind(e.$9g),e.$mh=e.$9g.hasTrailingPathSeparator.bind(e.$9g),e.$nh=e.$9g.removeTrailingPathSeparator.bind(e.$9g),e.$oh=e.$9g.addTrailingPathSeparator.bind(e.$9g);function E(p,a){const f=[];for(let d=0;d<p.length;d++){const m=a(p[d]);p.some((n,o)=>o===d?!1:(0,e.$ah)(m,a(n)))||f.push(p[d])}return f}var u;(function(p){p.META_DATA_LABEL="label",p.META_DATA_DESCRIPTION="description",p.META_DATA_SIZE="size",p.META_DATA_MIME="mime";function a(f){const d=new Map;f.path.substring(f.path.indexOf(";")+1,f.path.lastIndexOf(";")).split(";").forEach(o=>{const[t,i]=o.split(":");t&&i&&d.set(t,i)});const n=f.path.substring(0,f.path.indexOf(";"));return n&&d.set(p.META_DATA_MIME,n),d}p.parseMetaData=a})(u||(e.DataUri=u={}));function k(p,a,f){if(a){let d=p.path;return d&&d[0]!==R.$ic.sep&&(d=R.$ic.sep+d),p.with({scheme:f,authority:a,path:d})}return p.with({scheme:f})}}),define(Ee[9],ye([1,0,21,14,4,3,23,11,184,49]),function(ce,e,r,h,P,R,T,N,$,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9h=e.$7h=e.$6h=e.$5h=e.$4h=e.Promises=e.$3h=e.$2h=e.$1h=e.$Yh=e.$Xh=e.$Wh=e.$Vh=e.$Uh=e.$Th=e.$Sh=e.$Rh=e.$Qh=e.$Ph=e.$Oh=e.$Nh=e.$Mh=e.$Lh=e.$Fh=e.$Eh=e.$Dh=e.$Ch=e.$Bh=e.$Ah=e.$zh=void 0,e.$rh=I,e.$sh=E,e.$th=u,e.$uh=k,e.$vh=p,e.$wh=a,e.$xh=f,e.$yh=d,e.$Gh=S,e.$Hh=D,e.$Ih=y,e.$Jh=C,e.$Kh=A,e.$Zh=G,e.$8h=te;function I(ue){return!!ue&&typeof ue.then=="function"}function E(ue){const X=new r.$xe,ae=ue(X.token),pe=new Promise((be,Fe)=>{const Ue=X.token.onCancellationRequested(()=>{Ue.dispose(),Fe(new h.$7)});Promise.resolve(ae).then(ke=>{Ue.dispose(),X.dispose(),be(ke)},ke=>{Ue.dispose(),X.dispose(),Fe(ke)})});return new class{cancel(){X.cancel(),X.dispose()}then(be,Fe){return pe.then(be,Fe)}catch(be){return this.then(void 0,be)}finally(be){return pe.finally(be)}}}function u(ue,X,ae){return new Promise((pe,be)=>{const Fe=X.onCancellationRequested(()=>{Fe.dispose(),pe(ae)});ue.then(pe,be).finally(()=>Fe.dispose())})}function k(ue,X){return new Promise((ae,pe)=>{const be=X.onCancellationRequested(()=>{be.dispose(),pe(new h.$7)});ue.then(ae,pe).finally(()=>be.dispose())})}async function p(ue){let X=-1;const ae=ue.map((pe,be)=>pe.then(Fe=>(X=be,Fe)));try{return await Promise.race(ae)}finally{ue.forEach((pe,be)=>{be!==X&&pe.cancel()})}}function a(ue,X,ae){let pe;const be=setTimeout(()=>{pe?.(void 0),ae?.()},X);return Promise.race([ue.finally(()=>clearTimeout(be)),new Promise(Fe=>pe=Fe)])}function f(ue){return new Promise((X,ae)=>{const pe=ue();I(pe)?pe.then(X,ae):X(pe)})}function d(){let ue,X;return{promise:new Promise((pe,be)=>{ue=pe,X=be}),resolve:ue,reject:X}}class m{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(X){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=X,!this.b){const ae=()=>{if(this.b=null,this.f)return;const pe=this.queue(this.d);return this.d=null,pe};this.b=new Promise(pe=>{this.a.then(ae,ae).then(pe)})}return new Promise((ae,pe)=>{this.b.then(ae,pe)})}return this.a=X(),new Promise((ae,pe)=>{this.a.then(be=>{this.a=null,ae(be)},be=>{this.a=null,pe(be)})})}dispose(){this.f=!0}}e.$zh=m;class n{constructor(){this.a=Promise.resolve(null)}queue(X){return this.a=this.a.then(()=>X(),()=>X())}}e.$Ah=n;class o{constructor(){this.a=new Map}queue(X,ae){const be=(this.a.get(X)??Promise.resolve()).catch(()=>{}).then(ae).finally(()=>{this.a.get(X)===be&&this.a.delete(X)});return this.a.set(X,be),be}}e.$Bh=o;const t=(ue,X)=>{let ae=!0;const pe=setTimeout(()=>{ae=!1,X()},ue);return{isTriggered:()=>ae,dispose:()=>{clearTimeout(pe),ae=!1}}},i=ue=>{let X=!0;return queueMicrotask(()=>{X&&(X=!1,ue())}),{isTriggered:()=>X,dispose:()=>{X=!1}}};class s{constructor(X){this.defaultDelay=X,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(X,ae=this.defaultDelay){this.g=X,this.h(),this.b||(this.b=new Promise((be,Fe)=>{this.d=be,this.f=Fe}).then(()=>{if(this.b=null,this.d=null,this.g){const be=this.g;return this.g=null,be()}}));const pe=()=>{this.a=null,this.d?.(null)};return this.a=ae===$.$he?i(pe):t(ae,pe),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new h.$7),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$Ch=s;class g{constructor(X){this.a=new s(X),this.b=new m}trigger(X,ae){return this.a.trigger(()=>this.b.queue(X),ae)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$Dh=g;class l{constructor(){this.a=!1,this.b=new Promise((X,ae)=>{this.d=X})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$Eh=l;class w extends l{constructor(X){super(),this.f=setTimeout(()=>this.open(),X)}open(){clearTimeout(this.f),super.open()}}e.$Fh=w;function S(ue,X){return X?new Promise((ae,pe)=>{const be=setTimeout(()=>{Fe.dispose(),ae()},ue),Fe=X.onCancellationRequested(()=>{clearTimeout(be),Fe.dispose(),pe(new h.$7)})}):E(ae=>S(ue,ae))}function D(ue,X=0,ae){const pe=setTimeout(()=>{ue(),ae&&be.dispose()},X),be=(0,R.$Uc)(()=>{clearTimeout(pe),ae?.deleteAndLeak(be)});return ae?.add(be),be}function y(ue){const X=[];let ae=0;const pe=ue.length;function be(){return ae<pe?ue[ae++]():null}function Fe(Ue){Ue!=null&&X.push(Ue);const ke=be();return ke?ke.then(Fe):Promise.resolve(X)}return Promise.resolve(null).then(Fe)}function C(ue,X=pe=>!!pe,ae=null){let pe=0;const be=ue.length,Fe=()=>{if(pe>=be)return Promise.resolve(ae);const Ue=ue[pe++];return Promise.resolve(Ue()).then(Ie=>X(Ie)?Promise.resolve(Ie):Fe())};return Fe()}function A(ue,X=pe=>!!pe,ae=null){if(ue.length===0)return Promise.resolve(ae);let pe=ue.length;const be=()=>{pe=-1;for(const Fe of ue)Fe.cancel?.()};return new Promise((Fe,Ue)=>{for(const ke of ue)ke.then(Ie=>{--pe>=0&&X(Ie)?(be(),Fe(Ie)):pe===0&&Fe(ae)}).catch(Ie=>{--pe>=0&&(be(),Ue(Ie))})})}class b{constructor(X){this.a=0,this.b=!1,this.f=X,this.g=[],this.d=0,this.h=new P.$me}whenIdle(){return this.size>0?P.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(X){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((ae,pe)=>{this.g.push({factory:X,c:ae,e:pe}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const X=this.g.shift();this.d++;const ae=X.factory();ae.then(X.c,X.e),ae.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$Lh=b;class v extends b{constructor(){super(1)}}e.$Mh=v;class L{constructor(){this.a=new Q,this.b=0}queue(X){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,X())):this.a.run(this.b++,X())}}e.$Nh=L;class O{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const X=new ne;return this.b.add(X),X.p}g(){for(const[,X]of this.a)if(X.size>0)return!1;return!0}queueSize(X,ae=T.$9g){const pe=ae.getComparisonKey(X);return this.a.get(pe)?.size??0}queueFor(X,ae,pe=T.$9g){const be=pe.getComparisonKey(X);let Fe=this.a.get(be);if(!Fe){Fe=new v;const Ue=this.f++,ke=P.Event.once(Fe.onDrained)(()=>{Fe?.dispose(),this.a.delete(be),this.h(),this.d?.deleteAndDispose(Ue),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new R.$6c),this.d.set(Ue,ke),this.a.set(be,Fe)}return Fe.queue(ae)}h(){this.g()&&this.j()}j(){for(const X of this.b)X.complete();this.b.clear()}dispose(){for(const[,X]of this.a)X.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$Oh=O;class M{constructor(X,ae){this.b=!1,this.a=-1,typeof X=="function"&&typeof ae=="number"&&this.setIfNotSet(X,ae)}dispose(){this.cancel(),this.b=!0}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(X,ae){if(this.b)throw new h.$eb("Calling 'cancelAndSet' on a disposed TimeoutTimer");this.cancel(),this.a=setTimeout(()=>{this.a=-1,X()},ae)}setIfNotSet(X,ae){if(this.b)throw new h.$eb("Calling 'setIfNotSet' on a disposed TimeoutTimer");this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,X()},ae))}}e.$Ph=M;class j{constructor(){this.d=void 0,this.f=!1}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(X,ae,pe=globalThis){if(this.f)throw new h.$eb("Calling 'cancelAndSet' on a disposed IntervalTimer");this.cancel();const be=pe.setInterval(()=>{X()},ae);this.d=(0,R.$Uc)(()=>{pe.clearInterval(be),this.d=void 0})}dispose(){this.cancel(),this.f=!0}}e.$Qh=j;class z{constructor(X,ae){this.b=-1,this.a=X,this.d=ae,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(X=this.d){this.cancel(),this.b=setTimeout(this.f,X)}get delay(){return this.d}set delay(X){this.d=X}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$Rh=z;class F{constructor(X,ae){ae%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${ae}ms is not a multiple of 1000ms.`),this.a=X,this.b=ae,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(X=this.b){X%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${X}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(X/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$Sh=F;class B extends z{constructor(X,ae){super(X,ae),this.j=[]}work(X){this.j.push(X),this.isScheduled()||this.schedule()}h(){const X=this.j;this.j=[],this.a?.(X)}dispose(){this.j=[],super.dispose()}}e.$Th=B;class _ extends R.$Wc{constructor(X,ae){super(),this.g=X,this.h=ae,this.a=[],this.b=this.B(new R.$Xc),this.f=!1}get pending(){return this.a.length}work(X){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+X.length>this.g.maxBufferedWork)return!1}else if(this.pending+X.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const ae of X)this.a.push(ae);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new z(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$Uh=_,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$Wh=(ue,X)=>{(0,N.$B)(()=>{if(ae)return;const pe=Date.now()+15;X(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,pe-Date.now())}}))});let ae=!1;return{dispose(){ae||(ae=!0)}}}:e.$Wh=(ue,X,ae)=>{const pe=ue.requestIdleCallback(X,typeof ae=="number"?{timeout:ae}:void 0);let be=!1;return{dispose(){be||(be=!0,ue.cancelIdleCallback(pe))}}},e.$Vh=ue=>(0,e.$Wh)(globalThis,ue)}();class re{constructor(X,ae){this.g=!1,this.d=()=>{try{this.j=ae()}catch(pe){this.l=pe}finally{this.g=!0}},this.f=(0,e.$Wh)(X,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$Xh=re;class U extends re{constructor(X){super(globalThis,X)}}e.$Yh=U;async function G(ue,X,ae){let pe;for(let be=0;be<ae;be++)try{return await ue()}catch(Fe){pe=Fe,await S(X)}throw pe}class Q{isRunning(X){return typeof X=="number"?this.a?.taskId===X:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(X,ae,pe){return this.a={taskId:X,cancel:()=>pe?.(),promise:ae},ae.then(()=>this.d(X),()=>this.d(X)),ae}d(X){this.a&&X===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const X=this.b;this.b=void 0,X.run().then(X.promiseResolve,X.promiseReject)}}queue(X){if(this.b)this.b.run=X;else{const{promise:ae,resolve:pe,reject:be}=d();this.b={run:X,promise:ae,promiseResolve:pe,promiseReject:be}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$1h=Q;class ee{constructor(X,ae=()=>Date.now()){this.d=X,this.f=ae,this.a=0,this.b=0}increment(){const X=this.f();return X-this.a>this.d&&(this.a=X,this.b=0),this.b++,this.b}}e.$2h=ee;var he;(function(ue){ue[ue.Resolved=0]="Resolved",ue[ue.Rejected=1]="Rejected"})(he||(he={}));class ne{get isRejected(){return this.d?.outcome===he.Rejected}get isResolved(){return this.d?.outcome===he.Resolved}get isSettled(){return!!this.d}get value(){return this.d?.outcome===he.Resolved?this.d?.value:void 0}constructor(){this.p=new Promise((X,ae)=>{this.a=X,this.b=ae})}complete(X){return new Promise(ae=>{this.a(X),this.d={outcome:he.Resolved,value:X},ae()})}error(X){return new Promise(ae=>{this.b(X),this.d={outcome:he.Rejected,value:X},ae()})}cancel(){return this.error(new h.$7)}}e.$3h=ne;var De;(function(ue){async function X(pe){let be;const Fe=await Promise.all(pe.map(Ue=>Ue.then(ke=>ke,ke=>{be||(be=ke)})));if(typeof be<"u")throw be;return Fe}ue.settled=X;function ae(pe){return new Promise(async(be,Fe)=>{try{await pe(be,Fe)}catch(Ue){Fe(Ue)}})}ue.withAsyncBody=ae})(De||(e.Promises=De={}));class $e{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(X){this.a=void 0,this.b=void 0,this.d=!1,this.promise=X.then(ae=>(this.a=ae,this.d=!0,ae),ae=>{throw this.b=ae,this.d=!0,ae})}requireValue(){if(!this.d)throw new h.$eb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$4h=$e;class K{constructor(X){this.b=X,this.a=new c.$X(()=>new $e(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}e.$5h=K;var W;(function(ue){ue[ue.Initial=0]="Initial",ue[ue.DoneOK=1]="DoneOK",ue[ue.DoneError=2]="DoneError"})(W||(W={}));class se{static fromArray(X){return new se(ae=>{ae.emitMany(X)})}static fromPromise(X){return new se(async ae=>{ae.emitMany(await X)})}static fromPromises(X){return new se(async ae=>{await Promise.all(X.map(async pe=>ae.emitOne(await pe)))})}static merge(X){return new se(async ae=>{await Promise.all(X.map(async pe=>{for await(const be of pe)ae.emitOne(be)}))})}static{this.EMPTY=se.fromArray([])}constructor(X,ae){this.a=W.Initial,this.b=[],this.d=null,this.f=ae,this.g=new P.$me,queueMicrotask(async()=>{const pe={emitOne:be=>this.h(be),emitMany:be=>this.j(be),reject:be=>this.l(be)};try{await Promise.resolve(X(pe)),this.k()}catch(be){this.l(be)}finally{pe.emitOne=void 0,pe.emitMany=void 0,pe.reject=void 0}})}[Symbol.asyncIterator](){let X=0;return{next:async()=>{do{if(this.a===W.DoneError)throw this.d;if(X<this.b.length)return{done:!1,value:this.b[X++]};if(this.a===W.DoneOK)return{done:!0,value:void 0};await P.Event.toPromise(this.g.event)}while(!0)},return:async()=>(this.f?.(),{done:!0,value:void 0})}}static map(X,ae){return new se(async pe=>{for await(const be of X)pe.emitOne(ae(be))})}map(X){return se.map(this,X)}static filter(X,ae){return new se(async pe=>{for await(const be of X)ae(be)&&pe.emitOne(be)})}filter(X){return se.filter(this,X)}static coalesce(X){return se.filter(X,ae=>!!ae)}coalesce(){return se.coalesce(this)}static async toPromise(X){const ae=[];for await(const pe of X)ae.push(pe);return ae}toPromise(){return se.toPromise(this)}h(X){this.a===W.Initial&&(this.b.push(X),this.g.fire())}j(X){this.a===W.Initial&&(this.b=this.b.concat(X),this.g.fire())}k(){this.a===W.Initial&&(this.a=W.DoneOK,this.g.fire())}l(X){this.a===W.Initial&&(this.a=W.DoneError,this.d=X,this.g.fire())}}e.$6h=se;class oe extends se{constructor(X,ae){super(ae),this.m=X}cancel(){this.m.cancel()}}e.$7h=oe;function te(ue){const X=new r.$xe,ae=ue(X.token);return new oe(X,async pe=>{const be=X.token.onCancellationRequested(()=>{be.dispose(),X.dispose(),pe.reject(new h.$7)});try{for await(const Fe of ae){if(X.token.isCancellationRequested)return;pe.emitOne(Fe)}be.dispose(),X.dispose()}catch(Fe){be.dispose(),X.dispose(),pe.reject(Fe)}})}class le{constructor(X){this.a=new ne,this.b=new se(be=>{if(ae){be.reject(ae);return}return pe&&be.emitMany(pe),this.d=Fe=>be.reject(Fe),this.f=Fe=>be.emitOne(Fe),this.a.p},X);let ae,pe;this.f=be=>{pe||(pe=[]),pe.push(be)},this.d=be=>{ae||(ae=be)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(X){this.d(X),this.a.complete()}emitOne(X){this.f(X)}}e.$9h=le}),define(Ee[39],ye([1,0,19,9,27,33,29,16,11,13]),function(ce,e,r,h,P,R,T,N,$,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wk=e.$vk=void 0,e.$uk=I,e.$xk=a,e.$yk=L,e.$zk=O,e.$Ak=M,e.$Bk=j,e.$Ck=z,e.$Dk=re;function I(){return Object.create(null)}e.$vk="**",e.$wk="/";const E="[/\\\\]",u="[^/\\\\]",k=/\//g;function p(U,G){switch(U){case 0:return"";case 1:return`${u}*?`;default:return`(?:${E}|${u}+${E}${G?`|${E}${u}+`:""})*?`}}function a(U,G){if(!U)return[];const Q=[];let ee=!1,he=!1,ne="";for(const De of U){switch(De){case G:if(!ee&&!he){Q.push(ne),ne="";continue}break;case"{":ee=!0;break;case"}":ee=!1;break;case"[":he=!0;break;case"]":he=!1;break}ne+=De}return ne&&Q.push(ne),Q}function f(U){if(!U)return"";let G="";const Q=a(U,e.$wk);if(Q.every(ee=>ee===e.$vk))G=".*";else{let ee=!1;Q.forEach((he,ne)=>{if(he===e.$vk){if(ee)return;G+=p(2,ne===Q.length-1)}else{let De=!1,$e="",K=!1,W="";for(const se of he){if(se!=="}"&&De){$e+=se;continue}if(K&&(se!=="]"||!W)){let oe;se==="-"?oe=se:(se==="^"||se==="!")&&!W?oe="^":se===e.$wk?oe="":oe=(0,c.$if)(se),W+=oe;continue}switch(se){case"{":De=!0;continue;case"[":K=!0;continue;case"}":{const te=`(?:${a($e,",").map(le=>f(le)).join("|")})`;G+=te,De=!1,$e="";break}case"]":{G+="["+W+"]",K=!1,W="";break}case"?":G+=u;continue;case"*":G+=p(1);continue;default:G+=(0,c.$if)(se)}}ne<Q.length-1&&(Q[ne+1]!==e.$vk||ne+2<Q.length)&&(G+=E)}ee=he===e.$vk})}return G}const d=/^\*\*\/\*\.[\w\.-]+$/,m=/^\*\*\/([\w\.-]+)\/?$/,n=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,o=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,t=/^\*\*((\/[\w\.-]+)+)\/?$/,i=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,s=new T.$Fc(1e4),g=function(){return!1},l=function(){return null};function w(U,G){if(!U)return l;let Q;typeof U!="string"?Q=U.pattern:Q=U,Q=Q.trim();const ee=`${Q}_${!!G.trimForExclusions}`;let he=s.get(ee);if(he)return S(he,U);let ne;return d.test(Q)?he=y(Q.substr(4),Q):(ne=m.exec(D(Q,G)))?he=C(ne[1],Q):(G.trimForExclusions?o:n).test(Q)?he=A(Q,G):(ne=t.exec(D(Q,G)))?he=b(ne[1].substr(1),Q,!0):(ne=i.exec(D(Q,G)))?he=b(ne[1],Q,!1):he=v(Q),s.set(ee,he),S(he,U)}function S(U,G){if(typeof G=="string")return U;const Q=function(ee,he){return(0,R.$Eg)(ee,G.base,!$.$k)?U((0,c.$nf)(ee.substr(G.base.length),N.sep),he):null};return Q.allBasenames=U.allBasenames,Q.allPaths=U.allPaths,Q.basenames=U.basenames,Q.patterns=U.patterns,Q}function D(U,G){return G.trimForExclusions&&U.endsWith("/**")?U.substr(0,U.length-2):U}function y(U,G){return function(Q,ee){return typeof Q=="string"&&Q.endsWith(U)?G:null}}function C(U,G){const Q=`/${U}`,ee=`\\${U}`,he=function(De,$e){return typeof De!="string"?null:$e?$e===U?G:null:De===U||De.endsWith(Q)||De.endsWith(ee)?G:null},ne=[U];return he.basenames=ne,he.patterns=[G],he.allBasenames=ne,he}function A(U,G){const Q=_(U.slice(1,-1).split(",").map($e=>w($e,G)).filter($e=>$e!==l),U),ee=Q.length;if(!ee)return l;if(ee===1)return Q[0];const he=function($e,K){for(let W=0,se=Q.length;W<se;W++)if(Q[W]($e,K))return U;return null},ne=Q.find($e=>!!$e.allBasenames);ne&&(he.allBasenames=ne.allBasenames);const De=Q.reduce(($e,K)=>K.allPaths?$e.concat(K.allPaths):$e,[]);return De.length&&(he.allPaths=De),he}function b(U,G,Q){const ee=N.sep===N.$ic.sep,he=ee?U:U.replace(k,N.sep),ne=N.sep+he,De=N.$ic.sep+U;let $e;return Q?$e=function(K,W){return typeof K=="string"&&(K===he||K.endsWith(ne)||!ee&&(K===U||K.endsWith(De)))?G:null}:$e=function(K,W){return typeof K=="string"&&(K===he||!ee&&K===U)?G:null},$e.allPaths=[(Q?"*/":"./")+U],$e}function v(U){try{const G=new RegExp(`^${f(U)}$`);return function(Q){return G.lastIndex=0,typeof Q=="string"&&G.test(Q)?U:null}}catch{return l}}function L(U,G,Q){return!U||typeof G!="string"?!1:O(U)(G,void 0,Q)}function O(U,G={}){if(!U)return g;if(typeof U=="string"||M(U)){const Q=w(U,G);if(Q===l)return g;const ee=function(he,ne){return!!Q(he,ne)};return Q.allBasenames&&(ee.allBasenames=Q.allBasenames),Q.allPaths&&(ee.allPaths=Q.allPaths),ee}return F(U,G)}function M(U){const G=U;return G?typeof G.base=="string"&&typeof G.pattern=="string":!1}function j(U){return U.allBasenames||[]}function z(U){return U.allPaths||[]}function F(U,G){const Q=_(Object.getOwnPropertyNames(U).map($e=>B($e,U[$e],G)).filter($e=>$e!==l)),ee=Q.length;if(!ee)return l;if(!Q.some($e=>!!$e.requiresSiblings)){if(ee===1)return Q[0];const $e=function(se,oe){let te;for(let le=0,ue=Q.length;le<ue;le++){const X=Q[le](se,oe);if(typeof X=="string")return X;(0,h.$rh)(X)&&(te||(te=[]),te.push(X))}return te?(async()=>{for(const le of te){const ue=await le;if(typeof ue=="string")return ue}return null})():null},K=Q.find(se=>!!se.allBasenames);K&&($e.allBasenames=K.allBasenames);const W=Q.reduce((se,oe)=>oe.allPaths?se.concat(oe.allPaths):se,[]);return W.length&&($e.allPaths=W),$e}const he=function($e,K,W){let se,oe;for(let te=0,le=Q.length;te<le;te++){const ue=Q[te];ue.requiresSiblings&&W&&(K||(K=(0,N.$pc)($e)),se||(se=K.substr(0,K.length-(0,N.$qc)($e).length)));const X=ue($e,K,se,W);if(typeof X=="string")return X;(0,h.$rh)(X)&&(oe||(oe=[]),oe.push(X))}return oe?(async()=>{for(const te of oe){const le=await te;if(typeof le=="string")return le}return null})():null},ne=Q.find($e=>!!$e.allBasenames);ne&&(he.allBasenames=ne.allBasenames);const De=Q.reduce(($e,K)=>K.allPaths?$e.concat(K.allPaths):$e,[]);return De.length&&(he.allPaths=De),he}function B(U,G,Q){if(G===!1)return l;const ee=w(U,Q);if(ee===l)return l;if(typeof G=="boolean")return ee;if(G){const he=G.when;if(typeof he=="string"){const ne=(De,$e,K,W)=>{if(!W||!ee(De,$e))return null;const se=he.replace("$(basename)",()=>K),oe=W(se);return(0,h.$rh)(oe)?oe.then(te=>te?U:null):oe?U:null};return ne.requiresSiblings=!0,ne}}return ee}function _(U,G){const Q=U.filter($e=>!!$e.basenames);if(Q.length<2)return U;const ee=Q.reduce(($e,K)=>{const W=K.basenames;return W?$e.concat(W):$e},[]);let he;if(G){he=[];for(let $e=0,K=ee.length;$e<K;$e++)he.push(G)}else he=Q.reduce(($e,K)=>{const W=K.patterns;return W?$e.concat(W):$e},[]);const ne=function($e,K){if(typeof $e!="string")return null;if(!K){let se;for(se=$e.length;se>0;se--){const oe=$e.charCodeAt(se-1);if(oe===P.CharCode.Slash||oe===P.CharCode.Backslash)break}K=$e.substr(se)}const W=ee.indexOf(K);return W!==-1?he[W]:null};ne.basenames=ee,ne.patterns=he,ne.allBasenames=ee;const De=U.filter($e=>!$e.basenames);return De.push(ne),De}function re(U,G){return(0,r.$wb)(U,G,(Q,ee)=>typeof Q=="string"&&typeof ee=="string"?Q===ee:typeof Q!="string"&&typeof ee!="string"?Q.base===ee.base&&Q.pattern===ee.pattern:!1)}}),define(Ee[86],ye([1,0,14,136,23,13,2]),function(ce,e,r,h,P,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3k=e.MarkdownStringTextNewlineStyle=void 0,e.$4k=c,e.$5k=I,e.$6k=E,e.$7k=u,e.$8k=k,e.$9k=p,e.$0k=a,e.$$k=f;var N;(function(d){d[d.Paragraph=0]="Paragraph",d[d.Break=1]="Break"})(N||(e.MarkdownStringTextNewlineStyle=N={}));class ${constructor(m="",n=!1){if(this.value=m,typeof this.value!="string")throw(0,r.$9)("value");typeof n=="boolean"?(this.isTrusted=n,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=n.isTrusted??void 0,this.supportThemeIcons=n.supportThemeIcons??!1,this.supportHtml=n.supportHtml??!1)}appendText(m,n=N.Paragraph){return this.value+=u(this.supportThemeIcons?(0,h.$Wk)(m):m).replace(/([ \t]+)/g,(o,t)=>"&nbsp;".repeat(t.length)).replace(/\>/gm,"\\>").replace(/\n/g,n===N.Break?`\\
`:`

`),this}appendMarkdown(m){return this.value+=m,this}appendCodeblock(m,n){return this.value+=`
${k(n,m)}
`,this}appendLink(m,n,o){return this.value+="[",this.value+=this.c(n,"]"),this.value+="](",this.value+=this.c(String(m),")"),o&&(this.value+=` "${this.c(this.c(o,'"'),")")}"`),this.value+=")",this}c(m,n){const o=new RegExp((0,R.$if)(n),"g");return m.replace(o,(t,i)=>m.charAt(i-1)!=="\\"?`\\${t}`:t)}}e.$3k=$;function c(d){return I(d)?!d.value:Array.isArray(d)?d.every(c):!0}function I(d){return d instanceof $?!0:d&&typeof d=="object"?typeof d.value=="string"&&(typeof d.isTrusted=="boolean"||typeof d.isTrusted=="object"||d.isTrusted===void 0)&&(typeof d.supportThemeIcons=="boolean"||d.supportThemeIcons===void 0):!1}function E(d,m){return d===m?!0:!d||!m?!1:d.value===m.value&&d.isTrusted===m.isTrusted&&d.supportThemeIcons===m.supportThemeIcons&&d.supportHtml===m.supportHtml&&(d.baseUri===m.baseUri||!!d.baseUri&&!!m.baseUri&&(0,P.$_g)(T.URI.from(d.baseUri),T.URI.from(m.baseUri)))}function u(d){return d.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}function k(d,m){const n=d.match(/^`+/gm)?.reduce((t,i)=>t.length>i.length?t:i).length??0,o=n>=3?n+1:3;return[`${"`".repeat(o)}${m}`,d,`${"`".repeat(o)}`].join(`
`)}function p(d){return d.replace(/"/g,"&quot;")}function a(d){return d&&d.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}function f(d){const m=[],n=d.split("|").map(t=>t.trim());d=n[0];const o=n[1];if(o){const t=/height=(\d+)/.exec(o),i=/width=(\d+)/.exec(o),s=t?t[1]:"",g=i?i[1]:"",l=isFinite(parseInt(g)),w=isFinite(parseInt(s));l&&m.push(`width="${g}"`),w&&m.push(`height="${s}"`)}return{href:d,dimensions:m}}}),define(Ee[110],ye([1,0,19,33,16,11,23,13]),function(ce,e,r,h,P,R,T,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rw=$,e.$Sw=I,e.$Tw=u,e.$Uw=k,e.$Vw=d,e.$Ww=n,e.$Xw=o,e.$Yw=t,e.$Zw=i,e.$1w=s;function $(l,w){const{os:S,tildify:D,relative:y}=w;if(y){const b=c(l,y,S);if(typeof b=="string")return b}let C=l.fsPath;if(S===R.OperatingSystem.Windows&&!R.$i?C=C.replace(/\//g,"\\"):S!==R.OperatingSystem.Windows&&R.$i&&(C=C.replace(/\\/g,"/")),S!==R.OperatingSystem.Windows&&D?.userHome){const b=D.userHome.fsPath;let v;l.scheme!==D.userHome.scheme&&l.path[0]===P.$ic.sep&&l.path[1]!==P.$ic.sep?v=D.userHome.with({path:l.path}).fsPath:v=C,C=u(v,b,S)}return(S===R.OperatingSystem.Windows?P.$hc:P.$ic).normalize(I(C,S===R.OperatingSystem.Windows))}function c(l,w,S){const D=S===R.OperatingSystem.Windows?P.$hc:P.$ic,y=S===R.OperatingSystem.Linux?T.$9g:T.$$g,C=w.getWorkspace(),A=(0,r.$Qb)(C.folders);if(!A)return;l.scheme!==A.uri.scheme&&l.path[0]===P.$ic.sep&&l.path[1]!==P.$ic.sep&&(l=A.uri.with({path:l.path}));const b=w.getWorkspaceFolder(l);if(!b)return;let v;if(y.isEqual(b.uri,l)?v="":v=y.relativePath(b.uri,l)??"",v&&(v=D.normalize(v)),C.folders.length>1&&!w.noPrefix){const L=b.name?b.name:y.basenameOrAuthority(b.uri);v=v?`${L} \u2022 ${v}`:L}return v}function I(l,w=R.$i){return(0,h.$Jg)(l,w)?l.charAt(0).toUpperCase()+l.slice(1):l}let E=Object.create(null);function u(l,w,S=R.OS){if(S===R.OperatingSystem.Windows||!l||!w)return l;let D=E.original===w?E.normalized:void 0;D||(D=w,R.$i&&(D=(0,h.$yg)(D)),D=`${(0,N.$of)(D,P.$ic.sep)}${P.$ic.sep}`,E={original:w,normalized:D});let y=l;return R.$i&&(y=(0,h.$yg)(y)),(S===R.OperatingSystem.Linux?y.startsWith(D):(0,N.$Hf)(y,D))?`~/${y.substr(D.length)}`:l}function k(l,w){return l.replace(/^~($|\/|\\)/,`${w}$1`)}const p="\u2026",a="\\\\",f="~";function d(l,w=P.sep){const S=new Array(l.length);let D=!1;for(let y=0;y<l.length;y++){const C=l[y];if(C===""){S[y]=`.${w}`;continue}if(!C){S[y]=C;continue}D=!0;let A="",b=C;b.indexOf(a)===0?(A=b.substr(0,b.indexOf(a)+a.length),b=b.substr(b.indexOf(a)+a.length)):b.indexOf(w)===0?(A=b.substr(0,b.indexOf(w)+w.length),b=b.substr(b.indexOf(w)+w.length)):b.indexOf(f)===0&&(A=b.substr(0,b.indexOf(f)+f.length),b=b.substr(b.indexOf(f)+f.length));const v=b.split(w);for(let L=1;D&&L<=v.length;L++)for(let O=v.length-L;D&&O>=0;O--){D=!1;let M=v.slice(O,O+L).join(w);for(let j=0;!D&&j<l.length;j++)if(j!==y&&l[j]&&l[j].indexOf(M)>-1){const z=O+L===v.length,F=O>0&&l[j].indexOf(w)>-1?w+M:M,B=l[j].endsWith(F);D=!z||B}if(!D){let j="";(v[0].endsWith(":")||A!=="")&&(O===1&&(O=0,L++,M=v[0]+w+M),O>0&&(j=v[0]+w),j=A+j),O>0&&(j=j+p+w),j=j+M,O+L<v.length&&(j=j+w+p),S[y]=j}}D&&(S[y]=C)}return S}var m;(function(l){l[l.TEXT=0]="TEXT",l[l.VARIABLE=1]="VARIABLE",l[l.SEPARATOR=2]="SEPARATOR"})(m||(m={}));function n(l,w=Object.create(null)){const S=[];let D=!1,y="";for(const C of l)if(C==="$"||D&&C==="{")y&&S.push({value:y,type:m.TEXT}),y="",D=!0;else if(C==="}"&&D){const A=w[y];if(typeof A=="string")A.length&&S.push({value:A,type:m.VARIABLE});else if(A){const b=S[S.length-1];(!b||b.type!==m.SEPARATOR)&&S.push({value:A.label,type:m.SEPARATOR})}y="",D=!1}else y+=C;return y&&!D&&S.push({value:y,type:m.TEXT}),S.filter((C,A)=>{if(C.type===m.SEPARATOR){const b=S[A-1],v=S[A+1];return[b,v].every(L=>L&&(L.type===m.VARIABLE||L.type===m.TEXT)&&L.value.length>0)}return!0}).map(C=>C.value).join("")}function o(l,w){return R.$j||w?l.replace(/\(&&\w\)|&&/g,"").replace(/&/g,R.$j?"&":"&&"):l.replace(/&&|&/g,S=>S==="&"?"&&":"&")}function t(l,w){return R.$j||w?l.replace(/\(&&\w\)|&&/g,""):R.$i?l.replace(/&&|&/g,S=>S==="&"?"&&":"&"):l.replace(/&&/g,"_")}function i(l){return l.replace(/&/g,"&&")}function s(l){if(l.endsWith("]")){const w=l.lastIndexOf(" [",l.length-2);if(w!==-1){const S=g(l.substring(0,w)),D=l.substring(w);return{name:S.name+D,parentPath:S.parentPath}}}return g(l)}function g(l){const w=l.indexOf("/")!==-1?P.$ic:P.$hc,S=w.basename(l),D=w.dirname(l);return S.length?{name:S,parentPath:D}:{name:D,parentPath:""}}}),define(Ee[142],ye([1,0,22,41,2]),function(ce,e,r,h,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kn=e.$Jn=void 0,e.$Ln=$,e.$Mn=I,e.$Nn=E;function R(u){return u.toJSON()}class T{constructor(k){this.a=k}transformIncoming(k){const p=this.a.transformIncoming(k);return p===k?k:R(P.URI.from(p))}transformOutgoing(k){const p=this.a.transformOutgoing(k);return p===k?k:R(P.URI.from(p))}transformOutgoingURI(k){const p=this.a.transformOutgoing(k);return p===k?k:P.URI.from(p)}transformOutgoingScheme(k){return this.a.transformOutgoingScheme(k)}}e.$Jn=T,e.$Kn=new class{transformIncoming(u){return u}transformOutgoing(u){return u}transformOutgoingURI(u){return u}transformOutgoingScheme(u){return u}};function N(u,k,p){if(!u||p>200)return null;if(typeof u=="object"){if(u instanceof P.URI)return k.transformOutgoing(u);for(const a in u)if(Object.hasOwnProperty.call(u,a)){const f=N(u[a],k,p+1);f!==null&&(u[a]=f)}}return null}function $(u,k){const p=N(u,k,0);return p===null?u:p}function c(u,k,p,a){if(!u||a>200)return null;if(typeof u=="object"){if(u.$mid===h.MarshalledId.Uri)return p?P.URI.revive(k.transformIncoming(u)):k.transformIncoming(u);if(u instanceof r.$Oe)return null;for(const f in u)if(Object.hasOwnProperty.call(u,f)){const d=c(u[f],k,p,a+1);d!==null&&(u[f]=d)}}return null}function I(u,k){const p=c(u,k,!1,0);return p===null?u:p}function E(u,k){const p=c(u,k,!0,0);return p===null?u:p}}),define(Ee[34],ye([1,0,61,68,411,9,33,82,16,11,23,2]),function(ce,e,r,h,P,R,T,N,$,c,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.SymlinkSupport=e.RimRafMode=void 0,e.rimrafSync=f,e.readdirSync=n,e.whenDeleted=i,e.configureFlushOnWrite=S,e.writeFileSync=y,r=We(r);var u;(function(F){F[F.UNLINK=0]="UNLINK",F[F.MOVE=1]="MOVE"})(u||(e.RimRafMode=u={}));async function k(F,B=u.UNLINK,_){if((0,T.$Ig)(F))throw new Error("rimraf - will refuse to recursively delete root");return B===u.UNLINK?a(F):p(F,_)}async function p(F,B=(0,T.$Ng)((0,h.tmpdir)())){try{try{await r.promises.rename(F,B)}catch(_){return _.code==="ENOENT"?void 0:a(F)}a(B).catch(_=>{})}catch(_){if(_.code!=="ENOENT")throw _}}async function a(F){return r.promises.rm(F,{recursive:!0,force:!0,maxRetries:3})}function f(F){if((0,T.$Ig)(F))throw new Error("rimraf - will refuse to recursively delete root");r.rmSync(F,{recursive:!0,force:!0,maxRetries:3})}async function d(F,B){return o(await(B?m(F):r.promises.readdir(F)))}async function m(F){try{return await r.promises.readdir(F,{withFileTypes:!0})}catch(re){console.warn("[node.js fs] readdir with filetypes failed with error: ",re)}const B=[],_=await d(F);for(const re of _){let U=!1,G=!1,Q=!1;try{const ee=await e.Promises.lstat((0,$.$lc)(F,re));U=ee.isFile(),G=ee.isDirectory(),Q=ee.isSymbolicLink()}catch(ee){console.warn("[node.js fs] unexpected error from lstat after readdir: ",ee)}B.push({name:re,isFile:()=>U,isDirectory:()=>G,isSymbolicLink:()=>Q})}return B}function n(F){return o(r.readdirSync(F))}function o(F){return F.map(B=>typeof B=="string"?c.$j?(0,N.$mm)(B):B:(B.name=c.$j?(0,N.$mm)(B.name):B.name,B))}async function t(F){const B=await d(F),_=[];for(const re of B)await s.existsDirectory((0,$.$lc)(F,re))&&_.push(re);return _}function i(F,B=1e3){return new Promise(_=>{let re=!1;const U=setInterval(()=>{re||(re=!0,r.access(F,G=>{re=!1,G&&(clearInterval(U),_(void 0))}))},B)})}var s;(function(F){async function B(U){let G;try{if(G=await e.Promises.lstat(U),!G.isSymbolicLink())return{stat:G}}catch{}try{return{stat:await e.Promises.stat(U),symbolicLink:G?.isSymbolicLink()?{dangling:!1}:void 0}}catch(Q){if(Q.code==="ENOENT"&&G)return{stat:G,symbolicLink:{dangling:!0}};if(c.$i&&Q.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(U)),symbolicLink:{dangling:!1}}}catch(ee){if(ee.code==="ENOENT"&&G)return{stat:G,symbolicLink:{dangling:!0}};throw ee}throw Q}}F.stat=B;async function _(U){try{const{stat:G,symbolicLink:Q}=await F.stat(U);return G.isFile()&&Q?.dangling!==!0}catch{}return!1}F.existsFile=_;async function re(U){try{const{stat:G,symbolicLink:Q}=await F.stat(U);return G.isDirectory()&&Q?.dangling!==!0}catch{}return!1}F.existsDirectory=re})(s||(e.SymlinkSupport=s={}));const g=new R.$Oh;function l(F,B,_){return g.queueFor(E.URI.file(F),()=>{const re=C(_);return new Promise((U,G)=>D(F,B,re,Q=>Q?G(Q):U()))},I.$0g)}let w=!0;function S(F){w=F}function D(F,B,_,re){if(!w)return r.writeFile(F,B,{mode:_.mode,flag:_.flag},re);r.open(F,_.flag,_.mode,(U,G)=>{if(U)return re(U);r.writeFile(G,B,Q=>{if(Q)return r.close(G,()=>re(Q));r.fdatasync(G,ee=>(ee&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",ee),S(!1)),r.close(G,he=>re(he))))})})}function y(F,B,_){const re=C(_);if(!w)return r.writeFileSync(F,B,{mode:re.mode,flag:re.flag});const U=r.openSync(F,re.flag,re.mode);try{r.writeFileSync(U,B);try{r.fdatasyncSync(U)}catch(G){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",G),S(!1)}}finally{r.closeSync(U)}}function C(F){return F?{mode:typeof F.mode=="number"?F.mode:438,flag:typeof F.flag=="string"?F.flag:"w"}:{mode:438,flag:"w"}}async function A(F,B,_=6e4){if(F!==B)try{c.$i&&typeof _=="number"?await b(F,B,Date.now(),_):await r.promises.rename(F,B)}catch(re){if(F.toLowerCase()!==B.toLowerCase()&&re.code==="EXDEV"||F.endsWith("."))await v(F,B,{preserveSymlinks:!1}),await k(F,u.MOVE);else throw re}}async function b(F,B,_,re,U=0){try{return await r.promises.rename(F,B)}catch(G){if(G.code!=="EACCES"&&G.code!=="EPERM"&&G.code!=="EBUSY")throw G;if(Date.now()-_>=re)throw console.error(`[node.js fs] rename failed after ${U} retries with error: ${G}`),G;if(U===0){let Q=!1;try{const{stat:ee}=await s.stat(B);ee.isFile()||(Q=!0)}catch{}if(Q)throw G}return await(0,R.$Gh)(Math.min(100,U*10)),b(F,B,_,re,U+1)}}async function v(F,B,_){return O(F,B,{root:{source:F,target:B},options:_,handledSourcePaths:new Set})}const L=511;async function O(F,B,_){if(_.handledSourcePaths.has(F))return;_.handledSourcePaths.add(F);const{stat:re,symbolicLink:U}=await s.stat(F);if(U){if(_.options.preserveSymlinks)try{return await z(F,B,_)}catch{}if(U.dangling)return}return re.isDirectory()?M(F,B,re.mode&L,_):j(F,B,re.mode&L)}async function M(F,B,_,re){await e.Promises.mkdir(B,{recursive:!0,mode:_});const U=await d(F);for(const G of U)await O((0,$.$lc)(F,G),(0,$.$lc)(B,G),re)}async function j(F,B,_){await e.Promises.copyFile(F,B),await e.Promises.chmod(B,_)}async function z(F,B,_){let re=await e.Promises.readlink(F);(0,T.$Eg)(re,_.root.source,!c.$k)&&(re=(0,$.$lc)(_.root.target,re.substr(_.root.source.length+1))),await e.Promises.symlink(re,B)}e.Promises=new class{get access(){return r.promises.access}get stat(){return r.promises.stat}get lstat(){return r.promises.lstat}get utimes(){return r.promises.utimes}get read(){return(F,B,_,re,U)=>new Promise((G,Q)=>{r.read(F,B,_,re,U,(ee,he,ne)=>ee?Q(ee):G({bytesRead:he,buffer:ne}))})}get readFile(){return r.promises.readFile}get write(){return(F,B,_,re,U)=>new Promise((G,Q)=>{r.write(F,B,_,re,U,(ee,he,ne)=>ee?Q(ee):G({bytesWritten:he,buffer:ne}))})}get appendFile(){return r.promises.appendFile}get fdatasync(){return(0,P.promisify)(r.fdatasync)}get truncate(){return r.promises.truncate}get copyFile(){return r.promises.copyFile}get open(){return(0,P.promisify)(r.open)}get close(){return(0,P.promisify)(r.close)}get symlink(){return r.promises.symlink}get readlink(){return r.promises.readlink}get chmod(){return r.promises.chmod}get mkdir(){return r.promises.mkdir}get unlink(){return r.promises.unlink}get rmdir(){return r.promises.rmdir}get realpath(){return(0,P.promisify)(r.realpath)}async exists(F){try{return await e.Promises.access(F),!0}catch{return!1}}get readdir(){return d}get readDirsInDir(){return t}get writeFile(){return l}get rm(){return k}get rename(){return A}get copy(){return v}}}),define(Ee[111],ye([1,0,61,16,11,13,34]),function(ce,e,r,h,P,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$er=N,e.$fr=$,e.$gr=c,e.$hr=I,r=We(r);function N(u){if(P.$k)return u;const k=(0,h.$oc)(u);if(u===k)return u;const p=((0,h.$pc)(u)||u).toLowerCase();try{const f=(0,T.readdirSync)(k).filter(d=>d.toLowerCase()===p);if(f.length===1){const d=N(k);if(d)return(0,h.$lc)(d,f[0])}else if(f.length>1){const d=f.indexOf(p);if(d>=0){const m=N(k);if(m)return(0,h.$lc)(m,f[d])}}}catch{}return null}async function $(u,k){if(P.$k)return u;const p=(0,h.$oc)(u);if(u===p)return u;const a=((0,h.$pc)(u)||u).toLowerCase();try{if(k?.isCancellationRequested)return null;const d=(await T.Promises.readdir(p)).filter(m=>m.toLowerCase()===a);if(d.length===1){const m=await $(p,k);if(m)return(0,h.$lc)(m,d[0])}else if(d.length>1){const m=d.indexOf(a);if(m>=0){const n=await $(p,k);if(n)return(0,h.$lc)(n,d[m])}}}catch{}return null}async function c(u){try{return await T.Promises.realpath(u)}catch{const p=E(u);return await T.Promises.access(p,r.constants.R_OK),p}}function I(u){try{return r.realpathSync(u)}catch{const p=E(u);return r.accessSync(p,r.constants.R_OK),p}}function E(u){return(0,R.$of)((0,h.$jc)(u),h.sep)}}),define(Ee[112],ye([1,0,16,11,56,109,18,34]),function(ce,e,r,h,P,R,T,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.TerminateResponseCode=e.Source=void 0,e.$xm=$,e.$ym=c,r=We(r),h=We(h),P=We(P),T=We(T),N=We(N),Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return R.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return R.TerminateResponseCode}});function $(E=P.env){return E.comspec||"cmd.exe"}function c(E){let u=[],k=!1;const p=function(a){if(k){u.push(a);return}(!E.send(a,d=>{if(d&&console.error(d),k=!1,u.length>0){const m=u.slice(0);u=[],m.forEach(n=>p(n))}})||h.$i)&&(k=!0)};return{send:p}}var I;(function(E){async function u(k,p,a){if(r.$kc(k))return k;if(p===void 0&&(p=P.cwd()),r.$oc(k)!=="."||(a===void 0&&T.$fg(P.env.PATH)&&(a=P.env.PATH.split(r.$vc)),a===void 0||a.length===0))return r.$lc(p,k);async function d(m){if(await N.Promises.exists(m)){let n;try{n=await N.Promises.stat(m)}catch(o){o.message.startsWith("EACCES")&&(n=await N.Promises.lstat(m))}return n?!n.isDirectory():!1}return!1}for(const m of a){let n;if(r.$kc(m)?n=r.$lc(m,k):n=r.$lc(p,m,k),await d(n))return n;let o=n+".com";if(await d(o)||(o=n+".exe",await d(o)))return o}return r.$lc(p,k)}E.findExecutable=u})(I||(e.win32=I={}))});var Je=this&&this.__decorate||function(ce,e,r,h){var P=arguments.length,R=P<3?e:h===null?h=Object.getOwnPropertyDescriptor(e,r):h,T;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")R=Reflect.decorate(ce,e,r,h);else for(var N=ce.length-1;N>=0;N--)(T=ce[N])&&(R=(P<3?T(R):P>3?T(e,r,R):T(e,r))||R);return P>3&&R&&Object.defineProperty(e,r,R),R};define(Ee[87],ye([1,0,19,9,22,21,59,14,4,3,57,13,18]),function(ce,e,r,h,P,R,T,N,$,c,I,E,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oi=e.ProxyChannel=e.$ni=e.$ki=e.$ji=e.$ii=e.RequestInitiator=e.$hi=e.$ei=e.$di=void 0,e.$fi=S,e.$gi=D,e.$li=L,e.$mi=O,E=We(E);var k;(function(U){U[U.Promise=100]="Promise",U[U.PromiseCancel=101]="PromiseCancel",U[U.EventListen=102]="EventListen",U[U.EventDispose=103]="EventDispose"})(k||(k={}));function p(U){switch(U){case k.Promise:return"req";case k.PromiseCancel:return"cancel";case k.EventListen:return"subscribe";case k.EventDispose:return"unsubscribe"}}var a;(function(U){U[U.Initialize=200]="Initialize",U[U.PromiseSuccess=201]="PromiseSuccess",U[U.PromiseError=202]="PromiseError",U[U.PromiseErrorObj=203]="PromiseErrorObj",U[U.EventFire=204]="EventFire"})(a||(a={}));function f(U){switch(U){case a.Initialize:return"init";case a.PromiseSuccess:return"reply:";case a.PromiseError:case a.PromiseErrorObj:return"replyErr:";case a.EventFire:return"event:"}}var d;(function(U){U[U.Uninitialized=0]="Uninitialized",U[U.Idle=1]="Idle"})(d||(d={}));function m(U){let G=0;for(let Q=0;;Q+=7){const ee=U.read(1);if(G|=(ee.buffer[0]&127)<<Q,!(ee.buffer[0]&128))return G}}const n=g(0);function o(U,G){if(G===0){U.write(n);return}let Q=0;for(let he=G;he!==0;he=he>>>7)Q++;const ee=P.$Oe.alloc(Q);for(let he=0;G!==0;he++)ee.buffer[he]=G&127,G=G>>>7,G>0&&(ee.buffer[he]|=128);U.write(ee)}class t{constructor(G){this.b=G,this.a=0}read(G){const Q=this.b.slice(this.a,this.a+G);return this.a+=Q.byteLength,Q}}e.$di=t;class i{constructor(){this.a=[]}get buffer(){return P.$Oe.concat(this.a)}write(G){this.a.push(G)}}e.$ei=i;var s;(function(U){U[U.Undefined=0]="Undefined",U[U.String=1]="String",U[U.Buffer=2]="Buffer",U[U.VSBuffer=3]="VSBuffer",U[U.Array=4]="Array",U[U.Object=5]="Object",U[U.Int=6]="Int"})(s||(s={}));function g(U){const G=P.$Oe.alloc(1);return G.writeUInt8(U,0),G}const l={Undefined:g(s.Undefined),String:g(s.String),Buffer:g(s.Buffer),VSBuffer:g(s.VSBuffer),Array:g(s.Array),Object:g(s.Object),Uint:g(s.Int)},w=typeof Buffer<"u";function S(U,G){if(typeof G>"u")U.write(l.Undefined);else if(typeof G=="string"){const Q=P.$Oe.fromString(G);U.write(l.String),o(U,Q.byteLength),U.write(Q)}else if(w&&Buffer.isBuffer(G)){const Q=P.$Oe.wrap(G);U.write(l.Buffer),o(U,Q.byteLength),U.write(Q)}else if(G instanceof P.$Oe)U.write(l.VSBuffer),o(U,G.byteLength),U.write(G);else if(Array.isArray(G)){U.write(l.Array),o(U,G.length);for(const Q of G)S(U,Q)}else if(typeof G=="number"&&(G|0)===G)U.write(l.Uint),o(U,G);else{const Q=P.$Oe.fromString(JSON.stringify(G));U.write(l.Object),o(U,Q.byteLength),U.write(Q)}}function D(U){switch(U.read(1).readUInt8(0)){case s.Undefined:return;case s.String:return U.read(m(U)).toString();case s.Buffer:return U.read(m(U)).buffer;case s.VSBuffer:return U.read(m(U));case s.Array:{const Q=m(U),ee=[];for(let he=0;he<Q;he++)ee.push(D(U));return ee}case s.Object:return JSON.parse(U.read(m(U)).toString());case s.Int:return m(U)}}class y{constructor(G,Q,ee=null,he=1e3){this.h=G,this.j=Q,this.k=ee,this.l=he,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(ne=>this.q(ne)),this.m({type:a.Initialize})}registerChannel(G,Q){this.b.set(G,Q),setTimeout(()=>this.w(G),0)}m(G){switch(G.type){case a.Initialize:{const Q=this.o([G.type]);this.k?.logOutgoing(Q,0,C.OtherSide,f(G.type));return}case a.PromiseSuccess:case a.PromiseError:case a.EventFire:case a.PromiseErrorObj:{const Q=this.o([G.type,G.id],G.data);this.k?.logOutgoing(Q,G.id,C.OtherSide,f(G.type),G.data);return}}}o(G,Q=void 0){const ee=new i;return S(ee,G),S(ee,Q),this.p(ee.buffer)}p(G){try{return this.h.send(G),G.byteLength}catch{return 0}}q(G){const Q=new t(G),ee=D(Q),he=D(Q),ne=ee[0];switch(ne){case k.Promise:return this.k?.logIncoming(G.byteLength,ee[1],C.OtherSide,`${p(ne)}: ${ee[2]}.${ee[3]}`,he),this.s({type:ne,id:ee[1],channelName:ee[2],name:ee[3],arg:he});case k.EventListen:return this.k?.logIncoming(G.byteLength,ee[1],C.OtherSide,`${p(ne)}: ${ee[2]}.${ee[3]}`,he),this.t({type:ne,id:ee[1],channelName:ee[2],name:ee[3],arg:he});case k.PromiseCancel:return this.k?.logIncoming(G.byteLength,ee[1],C.OtherSide,`${p(ne)}`),this.u({type:ne,id:ee[1]});case k.EventDispose:return this.k?.logIncoming(G.byteLength,ee[1],C.OtherSide,`${p(ne)}`),this.u({type:ne,id:ee[1]})}}s(G){const Q=this.b.get(G.channelName);if(!Q){this.v(G);return}const ee=new R.$xe;let he;try{he=Q.call(this.j,G.name,G.arg,ee.token)}catch($e){he=Promise.reject($e)}const ne=G.id;he.then($e=>{this.m({id:ne,data:$e,type:a.PromiseSuccess})},$e=>{$e instanceof Error?this.m({id:ne,data:{message:$e.message,name:$e.name,stack:$e.stack?$e.stack.split(`
`):void 0},type:a.PromiseError}):this.m({id:ne,data:$e,type:a.PromiseErrorObj})}).finally(()=>{De.dispose(),this.d.delete(G.id)});const De=(0,c.$Uc)(()=>ee.cancel());this.d.set(G.id,De)}t(G){const Q=this.b.get(G.channelName);if(!Q){this.v(G);return}const ee=G.id,ne=Q.listen(this.j,G.name,G.arg)(De=>this.m({id:ee,data:De,type:a.EventFire}));this.d.set(G.id,ne)}u(G){const Q=this.d.get(G.id);Q&&(Q.dispose(),this.d.delete(G.id))}v(G){let Q=this.g.get(G.channelName);Q||(Q=[],this.g.set(G.channelName,Q));const ee=setTimeout(()=>{console.error(`Unknown channel: ${G.channelName}`),G.type===k.Promise&&this.m({id:G.id,data:{name:"Unknown channel",message:`Channel name '${G.channelName}' timed out after ${this.l}ms`,stack:void 0},type:a.PromiseError})},this.l);Q.push({request:G,timeoutTimer:ee})}w(G){const Q=this.g.get(G);if(Q){for(const ee of Q)switch(clearTimeout(ee.timeoutTimer),ee.request.type){case k.Promise:this.s(ee.request);break;case k.EventListen:this.t(ee.request);break}this.g.delete(G)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,c.$Rc)(this.d.values()),this.d.clear()}}e.$hi=y;var C;(function(U){U[U.LocalSide=0]="LocalSide",U[U.OtherSide=1]="OtherSide"})(C||(e.RequestInitiator=C={}));class A{constructor(G,Q=null){this.l=G,this.a=!1,this.b=d.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new $.$me,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(ee=>this.s(ee)),this.j=Q}getChannel(G){const Q=this;return{call(ee,he,ne){return Q.a?Promise.reject(new N.$7):Q.m(G,ee,he,ne)},listen(ee,he){return Q.a?$.Event.None:Q.o(G,ee,he)}}}m(G,Q,ee,he=R.CancellationToken.None){const ne=this.g++,De=k.Promise,$e={id:ne,type:De,channelName:G,name:Q,arg:ee};if(he.isCancellationRequested)return Promise.reject(new N.$7);let K;return new Promise((se,oe)=>{if(he.isCancellationRequested)return oe(new N.$7);const te=()=>{const ae=pe=>{switch(pe.type){case a.PromiseSuccess:this.f.delete(ne),se(pe.data);break;case a.PromiseError:{this.f.delete(ne);const be=new Error(pe.data.message);be.stack=Array.isArray(pe.data.stack)?pe.data.stack.join(`
`):pe.data.stack,be.name=pe.data.name,oe(be);break}case a.PromiseErrorObj:this.f.delete(ne),oe(pe.data);break}};this.f.set(ne,ae),this.p($e)};let le=null;this.b===d.Idle?te():(le=(0,h.$sh)(ae=>this.u()),le.then(()=>{le=null,te()}));const ue=()=>{le?(le.cancel(),le=null):this.p({id:ne,type:k.PromiseCancel}),oe(new N.$7)},X=he.onCancellationRequested(ue);K=(0,c.$Tc)((0,c.$Uc)(ue),X),this.d.add(K)}).finally(()=>{K.dispose(),this.d.delete(K)})}o(G,Q,ee){const he=this.g++,ne=k.EventListen,De={id:he,type:ne,channelName:G,name:Q,arg:ee};let $e=null;const K=new $.$me({onWillAddFirstListener:()=>{$e=(0,h.$sh)(se=>this.u()),$e.then(()=>{$e=null,this.d.add(K),this.p(De)})},onDidRemoveLastListener:()=>{$e?($e.cancel(),$e=null):(this.d.delete(K),this.p({id:he,type:k.EventDispose}))}}),W=se=>K.fire(se.data);return this.f.set(he,W),K.event}p(G){switch(G.type){case k.Promise:case k.EventListen:{const Q=this.q([G.type,G.id,G.channelName,G.name],G.arg);this.j?.logOutgoing(Q,G.id,C.LocalSide,`${p(G.type)}: ${G.channelName}.${G.name}`,G.arg);return}case k.PromiseCancel:case k.EventDispose:{const Q=this.q([G.type,G.id]);this.j?.logOutgoing(Q,G.id,C.LocalSide,p(G.type));return}}}q(G,Q=void 0){const ee=new i;return S(ee,G),S(ee,Q),this.r(ee.buffer)}r(G){try{return this.l.send(G),G.byteLength}catch{return 0}}s(G){const Q=new t(G),ee=D(Q),he=D(Q),ne=ee[0];switch(ne){case a.Initialize:return this.j?.logIncoming(G.byteLength,0,C.LocalSide,f(ne)),this.t({type:ee[0]});case a.PromiseSuccess:case a.PromiseError:case a.EventFire:case a.PromiseErrorObj:return this.j?.logIncoming(G.byteLength,ee[1],C.LocalSide,f(ne),he),this.t({type:ee[0],id:ee[1],data:he})}}t(G){if(G.type===a.Initialize){this.b=d.Idle,this.k.fire();return}this.f.get(G.id)?.(G)}get onDidInitializePromise(){return $.Event.toPromise(this.onDidInitialize)}u(){return this.b===d.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,c.$Rc)(this.d.values()),this.d.clear()}}e.$ii=A,Je([T.$0h],A.prototype,"onDidInitializePromise",null);class b{get connections(){const G=[];return this.f.forEach(Q=>G.push(Q)),G}constructor(G,Q,ee){this.a=new Map,this.f=new Set,this.g=new $.$me,this.onDidAddConnection=this.g.event,this.h=new $.$me,this.onDidRemoveConnection=this.h.event,this.j=new c.$Vc,this.j.add(G(({protocol:he,onDidClientDisconnect:ne})=>{const De=$.Event.once(he.onMessage);this.j.add(De($e=>{const K=new t($e),W=D(K),se=new y(he,W,Q,ee),oe=new A(he,Q);this.a.forEach((le,ue)=>se.registerChannel(ue,le));const te={channelServer:se,channelClient:oe,ctx:W};this.f.add(te),this.g.fire(te),this.j.add(ne(()=>{se.dispose(),oe.dispose(),this.f.delete(te),this.h.fire(te)}))}))}))}getChannel(G,Q){const ee=this;return{call(he,ne,De){let $e;if((0,u.$tg)(Q)){const W=(0,r.$5b)(ee.connections.filter(Q));$e=W?Promise.resolve(W):$.Event.toPromise($.Event.filter(ee.onDidAddConnection,Q))}else $e=Q.routeCall(ee,he,ne);const K=$e.then(W=>W.channelClient.getChannel(G));return L(K).call(he,ne,De)},listen(he,ne){if((0,u.$tg)(Q))return ee.k(G,Q,he,ne);const De=Q.routeEvent(ee,he,ne).then($e=>$e.channelClient.getChannel(G));return L(De).listen(he,ne)}}}k(G,Q,ee,he){const ne=this;let De;const $e=new $.$me({onWillAddFirstListener:()=>{De=new c.$Vc;const K=new $.$se,W=new Map,se=te=>{const ue=te.channelClient.getChannel(G).listen(ee,he),X=K.add(ue);W.set(te,X)},oe=te=>{const le=W.get(te);le&&(le.dispose(),W.delete(te))};ne.connections.filter(Q).forEach(se),$.Event.filter(ne.onDidAddConnection,Q)(se,void 0,De),ne.onDidRemoveConnection(oe,void 0,De),K.event($e.fire,$e,De),De.add(K)},onDidRemoveLastListener:()=>{De?.dispose(),De=void 0}});return $e.event}registerChannel(G,Q){this.a.set(G,Q);for(const ee of this.f)ee.channelServer.registerChannel(G,Q)}dispose(){this.j.dispose();for(const G of this.f)G.channelClient.dispose(),G.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$ji=b;class v{constructor(G,Q,ee=null){const he=new i;S(he,Q),G.send(he.buffer),this.a=new A(G,ee),this.d=new y(G,Q,ee)}getChannel(G){return this.a.getChannel(G)}registerChannel(G,Q){this.d.registerChannel(G,Q)}dispose(){this.a.dispose(),this.d.dispose()}}e.$ki=v;function L(U){return{call(G,Q,ee){return U.then(he=>he.call(G,Q,ee))},listen(G,Q){const ee=new $.$ve;return U.then(he=>ee.input=he.listen(G,Q)),ee.event}}}function O(U){let G=!1;return{call(Q,ee,he){return G?U.call(Q,ee,he):(0,h.$Gh)(0).then(()=>G=!0).then(()=>U.call(Q,ee,he))},listen(Q,ee){if(G)return U.listen(Q,ee);const he=new $.$ve;return(0,h.$Gh)(0).then(()=>G=!0).then(()=>he.input=U.listen(Q,ee)),he.event}}}class M{constructor(G){this.a=G}routeCall(G){return this.b(G)}routeEvent(G){return this.b(G)}async b(G){for(const Q of G.connections)if(await Promise.resolve(this.a(Q.ctx)))return Promise.resolve(Q);return await $.Event.toPromise(G.onDidAddConnection),await this.b(G)}}e.$ni=M;var j;(function(U){function G(ne,De,$e){const K=ne,W=$e&&$e.disableMarshalling,se=new Map;for(const oe in K)ee(oe)&&se.set(oe,$.Event.buffer(K[oe],!0,void 0,De));return new class{listen(oe,te,le){const ue=se.get(te);if(ue)return ue;const X=K[te];if(typeof X=="function"){if(he(te))return X.call(K,le);if(ee(te))return se.set(te,$.Event.buffer(K[te],!0,void 0,De)),se.get(te)}throw new N.$db(`Event not found: ${te}`)}call(oe,te,le){const ue=K[te];if(typeof ue=="function"){if(!W&&Array.isArray(le))for(let ae=0;ae<le.length;ae++)le[ae]=(0,I.$ci)(le[ae]);let X=ue.apply(K,le);return X instanceof Promise||(X=Promise.resolve(X)),X}throw new N.$db(`Method not found: ${te}`)}}}U.fromService=G;function Q(ne,De){const $e=De&&De.disableMarshalling;return new Proxy({},{get(K,W){if(typeof W=="string")return De?.properties?.has(W)?De.properties.get(W):he(W)?function(se){return ne.listen(W,se)}:ee(W)?ne.listen(W):async function(...se){let oe;De&&!(0,u.$og)(De.context)?oe=[De.context,...se]:oe=se;const te=await ne.call(W,oe);return $e?te:(0,I.$ci)(te)};throw new N.$db(`Property not found: ${String(W)}`)}})}U.toService=Q;function ee(ne){return ne[0]==="o"&&ne[1]==="n"&&E.$Ff(ne.charCodeAt(2))}function he(ne){return/^onDynamic/.test(ne)&&E.$Ff(ne.charCodeAt(9))}})(j||(e.ProxyChannel=j={}));const z=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function F(U){if(Array.isArray(U))return U;if(U&&typeof U=="object"&&typeof U.toString=="function"){const G=U.toString();if(G!=="[object Object]")return G}return U}function B(U){return Array.isArray(U)?U.map(F):F(U)}function _(U,G,Q,ee,he,ne,De){De=B(De);const $e=z[he],K=$e[ee%$e.length];let W=[`%c[${U}]%c[${String(G).padStart(7," ")}]%c[len: ${String(Q).padStart(5," ")}]%c${String(ee).padStart(5," ")} - ${ne}`,"color: darkgreen","color: grey","color: grey",`color: ${K}`];/\($/.test(ne)?(W=W.concat(De),W.push(")")):W.push(De),console.log.apply(console,W)}class re{constructor(G,Q){this.d=G,this.f=Q,this.a=0,this.b=0}logOutgoing(G,Q,ee,he,ne){this.b+=G,_(this.d,this.b,G,Q,ee,he,ne)}logIncoming(G,Q,ee,he,ne){this.a+=G,_(this.f,this.a,G,Q,ee,he,ne)}}e.$oi=re}),define(Ee[69],ye([1,0,22,4,3,87]),function(ce,e,r,h,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ti=e.$si=e.$ri=e.$qi=e.ProtocolConstants=e.$pi=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var T;(function(l){l.Created="created",l.Read="read",l.Write="write",l.Open="open",l.Error="error",l.Close="close",l.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",l.NodeEndReceived="nodeEndReceived",l.NodeEndSent="nodeEndSent",l.NodeDrainBegin="nodeDrainBegin",l.NodeDrainEnd="nodeDrainEnd",l.zlibInflateError="zlibInflateError",l.zlibInflateData="zlibInflateData",l.zlibInflateInitialWrite="zlibInflateInitialWrite",l.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",l.zlibInflateWrite="zlibInflateWrite",l.zlibInflateFlushFired="zlibInflateFlushFired",l.zlibDeflateError="zlibDeflateError",l.zlibDeflateData="zlibDeflateData",l.zlibDeflateWrite="zlibDeflateWrite",l.zlibDeflateFlushFired="zlibDeflateFlushFired",l.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",l.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",l.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",l.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",l.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",l.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",l.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",l.ProtocolHeaderRead="protocolHeaderRead",l.ProtocolMessageRead="protocolMessageRead",l.ProtocolHeaderWrite="protocolHeaderWrite",l.ProtocolMessageWrite="protocolMessageWrite",l.ProtocolWrite="protocolWrite"})(T||(e.SocketDiagnosticsEventType=T={}));var N;(function(l){l.enableDiagnostics=!1,l.records=[];const w=new WeakMap;let S=0;function D(C,A){if(!w.has(C)){const b=String(++S);w.set(C,b)}return w.get(C)}function y(C,A,b,v){if(!l.enableDiagnostics)return;const L=D(C,A);if(v instanceof r.$Oe||v instanceof Uint8Array||v instanceof ArrayBuffer||ArrayBuffer.isView(v)){const O=r.$Oe.alloc(v.byteLength);O.set(v),l.records.push({timestamp:Date.now(),id:L,label:A,type:b,buff:O})}else l.records.push({timestamp:Date.now(),id:L,label:A,type:b,data:v})}l.traceSocketEvent=y})(N||(e.SocketDiagnostics=N={}));var $;(function(l){l[l.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",l[l.WebSocketCloseEvent=1]="WebSocketCloseEvent"})($||(e.SocketCloseEventType=$={}));let c=null;function I(){return c||(c=r.$Oe.alloc(0)),c}class E{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(w){this.a.push(w),this.b+=w.byteLength}read(w){return this.c(w,!0)}peek(w){return this.c(w,!1)}c(w,S){if(w===0)return I();if(w>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===w){const A=this.a[0];return S&&(this.a.shift(),this.b-=w),A}if(this.a[0].byteLength>w){const A=this.a[0].slice(0,w);return S&&(this.a[0]=this.a[0].slice(w),this.b-=w),A}const D=r.$Oe.alloc(w);let y=0,C=0;for(;w>0;){const A=this.a[C];if(A.byteLength>w){const b=A.slice(0,w);D.set(b,y),y+=w,S&&(this.a[C]=A.slice(w),this.b-=w),w-=w}else D.set(A,y),y+=A.byteLength,S?(this.a.shift(),this.b-=A.byteLength):C++,w-=A.byteLength}return D}}e.$pi=E;var u;(function(l){l[l.None=0]="None",l[l.Regular=1]="Regular",l[l.Control=2]="Control",l[l.Ack=3]="Ack",l[l.Disconnect=5]="Disconnect",l[l.ReplayRequest=6]="ReplayRequest",l[l.Pause=7]="Pause",l[l.Resume=8]="Resume",l[l.KeepAlive=9]="KeepAlive"})(u||(u={}));function k(l){switch(l){case u.None:return"None";case u.Regular:return"Regular";case u.Control:return"Control";case u.Ack:return"Ack";case u.Disconnect:return"Disconnect";case u.ReplayRequest:return"ReplayRequest";case u.Pause:return"PauseWriting";case u.Resume:return"ResumeWriting";case u.KeepAlive:return"KeepAlive"}}var p;(function(l){l[l.HeaderLength=13]="HeaderLength",l[l.AcknowledgeTime=2e3]="AcknowledgeTime",l[l.TimeoutTime=2e4]="TimeoutTime",l[l.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",l[l.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",l[l.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(p||(e.ProtocolConstants=p={}));class a{constructor(w,S,D,y){this.type=w,this.id=S,this.ack=D,this.data=y,this.writtenTime=0}get size(){return this.data.byteLength}}class f extends P.$Wc{constructor(w){super(),this.f=this.B(new h.$me),this.onMessage=this.f.event,this.g={readHead:!0,readLen:p.HeaderLength,messageType:u.None,id:0,ack:0},this.a=w,this.b=!1,this.c=new E,this.B(this.a.onData(S=>this.acceptChunk(S))),this.lastReadTime=Date.now()}acceptChunk(w){if(!(!w||w.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(w);this.c.byteLength>=this.g.readLen;){const S=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=S.readUInt32BE(9),this.g.messageType=S.readUInt8(0),this.g.id=S.readUInt32BE(1),this.g.ack=S.readUInt32BE(5),this.a.traceSocketEvent(T.ProtocolHeaderRead,{messageType:k(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const D=this.g.messageType,y=this.g.id,C=this.g.ack;if(this.g.readHead=!0,this.g.readLen=p.HeaderLength,this.g.messageType=u.None,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent(T.ProtocolMessageRead,S),this.f.fire(new a(D,y,C,S)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class d{constructor(w){this.k=null,this.a=!1,this.b=!1,this.c=w,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(w){if(this.a)return;w.writtenTime=Date.now(),this.lastWriteTime=Date.now();const S=r.$Oe.alloc(p.HeaderLength);S.writeUInt8(w.type,0),S.writeUInt32BE(w.id,1),S.writeUInt32BE(w.ack,5),S.writeUInt32BE(w.data.byteLength,9),this.c.traceSocketEvent(T.ProtocolHeaderWrite,{messageType:k(w.type),id:w.id,ack:w.ack,messageSize:w.data.byteLength}),this.c.traceSocketEvent(T.ProtocolMessageWrite,w.data),this.j(S,w.data)}g(w,S){const D=this.f===0;return this.d.push(w,S),this.f+=w.byteLength+S.byteLength,D}h(){const w=r.$Oe.concat(this.d,this.f);return this.d.length=0,this.f=0,w}j(w,S){this.g(w,S)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const w=this.h();this.c.traceSocketEvent(T.ProtocolWrite,{byteLength:w.byteLength}),this.c.write(w)}}class m extends P.$Wc{constructor(w){super(),this.f=new h.$me,this.onMessage=this.f.event,this.g=new h.$me,this.onDidDispose=this.g.event,this.a=w,this.b=this.B(new d(this.a)),this.c=this.B(new f(this.a)),this.B(this.c.onMessage(S=>{S.type===u.Regular&&this.f.fire(S.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(w){this.b.write(new a(u.Regular,0,0,w))}}e.$qi=m;class n extends R.$ki{static fromSocket(w,S){return new n(new m(w),S)}get onDidDispose(){return this.b.onDidDispose}constructor(w,S,D=null){super(w,S,D),this.b=w}dispose(){super.dispose();const w=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),w.end()}}e.$ri=n;class o{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new h.$me({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(w){this.b?this.d.length>0?this.d.push(w):this.a.fire(w):this.d.push(w)}flushBuffer(){this.d=[]}}e.$si=o;class t{constructor(w){this.data=w,this.next=null}}class i{constructor(){this.a=null,this.b=null}length(){let w=0,S=this.a;for(;S;)S=S.next,w++;return w}peek(){return this.a?this.a.data:null}toArray(){const w=[];let S=0,D=this.a;for(;D;)w[S++]=D.data,D=D.next;return w}pop(){if(this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(w){const S=new t(w);if(!this.a){this.a=S,this.b=S;return}this.b.next=S,this.b=S}}class s{static{this.a=10}static{this.b=null}static getInstance(){return s.b||(s.b=new s),s.b}constructor(){this.c=[];const w=Date.now();for(let S=0;S<s.a;S++)this.c[S]=w-1e3*S;setInterval(()=>{for(let S=s.a;S>=1;S--)this.c[S]=this.c[S-1];this.c[0]=Date.now()},1e3)}d(){const w=Date.now(),S=(1+s.a)*1e3;let D=0;for(let y=0;y<s.a;y++)w-this.c[y]<=S&&D++;return 1-D/s.a}hasHighLoad(){return this.d()>=.5}}class g{get unacknowledgedCount(){return this.c-this.d}constructor(w){this.u=new o,this.onControlMessage=this.u.event,this.v=new o,this.onMessage=this.v.event,this.w=new o,this.onDidDispose=this.w.event,this.x=new o,this.onSocketClose=this.x.event,this.y=new o,this.onSocketTimeout=this.y.event,this.s=w.loadEstimator??s.getInstance(),this.t=w.sendKeepAlive??!0,this.a=!1,this.b=new i,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.r=new P.$Vc,this.o=w.socket,this.p=this.r.add(new d(this.o)),this.q=this.r.add(new f(this.o)),this.r.add(this.q.onMessage(S=>this.z(S))),this.r.add(this.o.onClose(S=>this.x.fire(S))),w.initialChunk&&this.q.acceptChunk(w.initialChunk),this.t?this.l=setInterval(()=>{this.D()},p.KeepAliveSendTime):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.r.dispose()}drain(){return this.p.drain()}sendDisconnect(){const w=new a(u.Disconnect,0,0,I());this.p.write(w),this.p.flush()}sendPause(){const w=new a(u.Pause,0,0,I());this.p.write(w)}sendResume(){const w=new a(u.Resume,0,0,I());this.p.write(w)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(w,S){this.a=!0,this.r.dispose(),this.r=new P.$Vc,this.u.flushBuffer(),this.x.flushBuffer(),this.y.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=w,this.p=this.r.add(new d(this.o)),this.q=this.r.add(new f(this.o)),this.r.add(this.q.onMessage(D=>this.z(D))),this.r.add(this.o.onClose(D=>this.x.fire(D))),this.q.acceptChunk(S)}endAcceptReconnection(){this.a=!1,this.h=this.g;const w=new a(u.Ack,0,this.h,I());this.p.write(w);const S=this.b.toArray();for(let D=0,y=S.length;D<y;D++)this.p.write(S[D]);this.B()}acceptDisconnect(){this.w.fire()}z(w){if(w.ack>this.d){this.d=w.ack;do{const S=this.b.peek();if(S&&S.id<=w.ack)this.b.pop();else break}while(!0)}switch(w.type){case u.None:break;case u.Regular:{if(w.id>this.g)if(w.id!==this.g+1){const S=Date.now();S-this.m>1e4&&(this.m=S,this.p.write(new a(u.ReplayRequest,0,0,I())))}else this.g=w.id,this.j=Date.now(),this.A(),this.v.fire(w.data);break}case u.Control:{this.u.fire(w.data);break}case u.Ack:break;case u.Disconnect:{this.w.fire();break}case u.ReplayRequest:{const S=this.b.toArray();for(let D=0,y=S.length;D<y;D++)this.p.write(S[D]);this.B();break}case u.Pause:{this.p.pause();break}case u.Resume:{this.p.resume();break}case u.KeepAlive:break}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(w){const S=++this.c;this.h=this.g;const D=new a(u.Regular,S,this.h,w);this.b.push(D),this.a||(this.p.write(D),this.B())}sendControl(w){const S=new a(u.Control,0,0,w);this.p.write(S)}A(){if(this.g<=this.h||this.k)return;const w=Date.now()-this.j;if(w>=p.AcknowledgeTime){this.C();return}this.k=setTimeout(()=>{this.k=null,this.A()},p.AcknowledgeTime-w+5)}B(){if(this.c<=this.d||this.f||this.a)return;const w=this.b.peek(),S=Date.now()-w.writtenTime,D=Date.now()-this.q.lastReadTime,y=Date.now()-this.n;if(S>=p.TimeoutTime&&D>=p.TimeoutTime&&y>=p.TimeoutTime&&!this.s.hasHighLoad()){this.n=Date.now(),this.y.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:S,timeSinceLastReceivedSomeData:D});return}const C=Math.max(p.TimeoutTime-S,p.TimeoutTime-D,p.TimeoutTime-y,500);this.f=setTimeout(()=>{this.f=null,this.B()},C)}C(){if(this.g<=this.h)return;this.h=this.g;const w=new a(u.Ack,0,this.h,I());this.p.write(w)}D(){this.h=this.g;const w=new a(u.KeepAlive,0,this.h,I());this.p.write(w)}}e.$ti=g}),define(Ee[208],ye([1,0,58,9,22,21,206,14,4,3,25,112,109,87]),function(ce,e,r,h,P,R,T,N,$,c,I,E,u,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$br=e.$ar=void 0,N=We(N);class p extends k.$hi{constructor(d){super({send:m=>{try{process.send?.(m.buffer.toString("base64"))}catch{}},onMessage:$.Event.fromNodeEventEmitter(process,"message",m=>P.$Oe.wrap(Buffer.from(m,"base64")))},d),process.once("disconnect",()=>this.dispose())}}e.$ar=p;class a{constructor(d,m){this.i=d,this.j=m,this.c=new Set,this.g=new Map,this.h=new $.$me,this.onDidProcessExit=this.h.event;const n=m&&m.timeout?m.timeout:6e4;this.b=new h.$Ch(n),this.d=null,this.f=null}getChannel(d){const m=this;return{call(n,o,t){return m.k(d,n,o,t)},listen(n,o){return m.l(d,n,o)}}}k(d,m,n,o=R.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(o.isCancellationRequested)return Promise.reject(N.$8());this.b.cancel();const t=this.n(d),i=(0,h.$sh)(l=>t.call(m,n,l)),s=o.onCancellationRequested(()=>i.cancel()),g=(0,c.$Uc)(()=>i.cancel());return this.c.add(g),i.finally(()=>{s.dispose(),this.c.delete(g),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),i}l(d,m,n){if(!this.b)return $.Event.None;this.b.cancel();let o;const t=new $.$me({onWillAddFirstListener:()=>{o=this.n(d).listen(m,n)(t.fire,t),this.c.add(o)},onDidRemoveLastListener:()=>{this.c.delete(o),o.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return t.event}get m(){if(!this.f){const d=this.j&&this.j.args?this.j.args:[],m=Object.create(null);m.env={...(0,I.$bo)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(m.env={...m.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(m.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(m.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(m.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),m.execArgv===void 0&&(m.execArgv=process.execArgv.filter(S=>!/^--inspect(-brk)?=/.test(S)).filter(S=>!S.startsWith("--vscode-"))),(0,u.$lm)(m.env),this.d=(0,r.fork)(this.i,d,m);const n=new $.$me,t=$.Event.fromNodeEventEmitter(this.d,"message",S=>S)(S=>{if((0,T.$9q)(S)){(0,T.log)(S,`IPC Library: ${this.j.serverName}`);return}n.fire(P.$Oe.wrap(Buffer.from(S,"base64")))}),i=this.j.useQueue?(0,E.$ym)(this.d):this.d,s=S=>this.d&&this.d.connected&&i.send(S.buffer.toString("base64")),g=n.event,l={send:s,onMessage:g};this.f=new k.$ii(l);const w=()=>this.o();process.once("exit",w),this.d.on("error",S=>console.warn('IPC "'+this.j.serverName+'" errored with '+S)),this.d.on("exit",(S,D)=>{process.removeListener("exit",w),t.dispose(),this.c.forEach(y=>(0,c.$Rc)(y)),this.c.clear(),S!==0&&D!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+S+" and signal "+D),this.b?.cancel(),this.o(),this.h.fire({code:S,signal:D})})}return this.f}n(d){let m=this.g.get(d);return m||(m=this.m.getChannel(d),this.g.set(d,m)),m}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$br=a}),define(Ee[209],ye([1,0,9,4,3,57,18]),function(ce,e,r,h,P,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$p=e.$0p=e.StorageState=e.StorageHint=void 0,e.$9p=$;var N;(function(u){u[u.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",u[u.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(N||(e.StorageHint=N={}));function $(u){const k=u;return k?.changed instanceof Map||k?.deleted instanceof Set}var c;(function(u){u[u.None=0]="None",u[u.Initialized=1]="Initialized",u[u.Closed=2]="Closed"})(c||(e.StorageState=c={}));class I extends P.$Wc{static{this.a=100}constructor(k,p=Object.create(null)){super(),this.r=k,this.s=p,this.b=this.B(new h.$pe),this.onDidChangeStorage=this.b.event,this.c=c.None,this.f=new Map,this.g=this.B(new r.$Dh(I.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(k=>this.u(k)))}u(k){this.b.pause();try{k.changed?.forEach((p,a)=>this.w(a,p)),k.deleted?.forEach(p=>this.w(p,void 0))}finally{this.b.resume()}}w(k,p){if(this.c===c.Closed)return;let a=!1;(0,T.$og)(p)?a=this.f.delete(k):this.f.get(k)!==p&&(this.f.set(k,p),a=!0),a&&this.b.fire({key:k,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===c.None&&(this.c=c.Initialized,this.s.hint!==N.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(k,p){const a=this.f.get(k);return(0,T.$og)(a)?p:a}getBoolean(k,p){const a=this.get(k);return(0,T.$og)(a)?p:a==="true"}getNumber(k,p){const a=this.get(k);return(0,T.$og)(a)?p:parseInt(a,10)}getObject(k,p){const a=this.get(k);return(0,T.$og)(a)?p:(0,R.$bi)(a)}async set(k,p,a=!1){if(this.c===c.Closed)return;if((0,T.$og)(p))return this.delete(k,a);const f=(0,T.$hg)(p)||Array.isArray(p)?(0,R.$ai)(p):String(p);if(this.f.get(k)!==f)return this.f.set(k,f),this.j.set(k,f),this.h.delete(k),this.b.fire({key:k,external:a}),this.D()}async delete(k,p=!1){if(!(this.c===c.Closed||!this.f.delete(k)))return this.h.has(k)||this.h.add(k),this.j.delete(k),this.b.fire({key:k,external:p}),this.D()}async optimize(){if(this.c!==c.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=c.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const k={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(k).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(k){if(!(this.c===c.Closed||this.m))return this.D(k)}async D(k){return this.s.hint===N.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),k)}async whenFlushed(){if(this.z)return new Promise(k=>this.n.push(k))}isInMemory(){return this.s.hint===N.STORAGE_IN_MEMORY}}e.$0p=I;class E{constructor(){this.onDidChangeItemsExternal=h.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(k){k.insert?.forEach((p,a)=>this.a.set(a,p)),k.delete?.forEach(p=>this.a.delete(p))}async optimize(){}async close(){}}e.$$p=E}),define(Ee[210],ye([1,0,13,11,22]),function(ce,e,r,h,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9t=void 0,e.$7t=I,e.$8t=E,r=We(r),h=We(h),P=We(P);let R;function T(){return R||(R=new TextDecoder("UTF-16LE")),R}let N;function $(){return N||(N=new TextDecoder("UTF-16BE")),N}let c;function I(){return c||(c=h.$D()?T():$()),c}function E(p,a,f){const d=new Uint16Array(p.buffer,a,f);return f>0&&(d[0]===65279||d[0]===65534)?u(p,a,f):T().decode(d)}function u(p,a,f){const d=[];let m=0;for(let n=0;n<f;n++){const o=P.$Qe(p,a);a+=2,d[m++]=String.fromCharCode(o)}return d.join("")}class k{constructor(a){this.a=a|0,this.b=new Uint16Array(this.a),this.c=null,this.d=0}reset(){this.c=null,this.d=0}build(){return this.c!==null?(this.f(),this.c.join("")):this.e()}e(){if(this.d===0)return"";const a=new Uint16Array(this.b.buffer,0,this.d);return I().decode(a)}f(){const a=this.e();this.d=0,this.c===null?this.c=[a]:this.c[this.c.length]=a}appendCharCode(a){const f=this.a-this.d;f<=1&&(f===0||r.$Kf(a))&&this.f(),this.b[this.d++]=a}appendASCIICharCode(a){this.d===this.a&&this.f(),this.b[this.d++]=a}appendString(a){const f=a.length;if(this.d+f>=this.a){this.f(),this.c[this.c.length]=a;return}for(let d=0;d<f;d++)this.b[this.d++]=a.charCodeAt(d)}}e.$9t=k}),define(Ee[211],ye([1,0,22,210]),function(ce,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0t=void 0,e.$$t=T,r=We(r);function P($){return $.replace(/\n/g,"\\n").replace(/\r/g,"\\r")}class R{get oldLength(){return this.oldText.length}get oldEnd(){return this.oldPosition+this.oldText.length}get newLength(){return this.newText.length}get newEnd(){return this.newPosition+this.newText.length}constructor(c,I,E,u){this.oldPosition=c,this.oldText=I,this.newPosition=E,this.newText=u}toString(){return this.oldText.length===0?`(insert@${this.oldPosition} "${P(this.newText)}")`:this.newText.length===0?`(delete@${this.oldPosition} "${P(this.oldText)}")`:`(replace@${this.oldPosition} "${P(this.oldText)}" with "${P(this.newText)}")`}static a(c){return 4+2*c.length}static c(c,I,E){const u=I.length;r.$Te(c,u,E),E+=4;for(let k=0;k<u;k++)r.$Re(c,I.charCodeAt(k),E),E+=2;return E}static d(c,I){const E=r.$Se(c,I);return I+=4,(0,h.$8t)(c,I,E)}writeSize(){return 8+R.a(this.oldText)+R.a(this.newText)}write(c,I){return r.$Te(c,this.oldPosition,I),I+=4,r.$Te(c,this.newPosition,I),I+=4,I=R.c(c,this.oldText,I),I=R.c(c,this.newText,I),I}static read(c,I,E){const u=r.$Se(c,I);I+=4;const k=r.$Se(c,I);I+=4;const p=R.d(c,I);I+=R.a(p);const a=R.d(c,I);return I+=R.a(a),E.push(new R(u,p,k,a)),I}}e.$0t=R;function T($,c){return $===null||$.length===0?c:new N($,c).compress()}class N{constructor(c,I){this.a=c,this.c=I,this.d=[],this.e=0,this.f=this.a.length,this.g=0,this.h=this.c.length,this.j=0}compress(){let c=0,I=0,E=this.n(c),u=this.l(I);for(;c<this.f||I<this.h;){if(E===null){this.k(u),u=this.l(++I);continue}if(u===null){this.m(E),E=this.n(++c);continue}if(u.oldEnd<=E.newPosition){this.k(u),u=this.l(++I);continue}if(E.newEnd<=u.oldPosition){this.m(E),E=this.n(++c);continue}if(u.oldPosition<E.newPosition){const[d,m]=N.r(u,E.newPosition-u.oldPosition);this.k(d),u=m;continue}if(E.newPosition<u.oldPosition){const[d,m]=N.q(E,u.oldPosition-E.newPosition);this.m(d),E=m;continue}let a,f;if(u.oldEnd===E.newEnd)a=E,f=u,E=this.n(++c),u=this.l(++I);else if(u.oldEnd<E.newEnd){const[d,m]=N.q(E,u.oldLength);a=d,f=u,E=m,u=this.l(++I)}else{const[d,m]=N.r(u,E.newLength);a=E,f=d,E=this.n(++c),u=m}this.d[this.e++]=new R(a.oldPosition,a.oldText,f.newPosition,f.newText),this.g+=a.newLength-a.oldLength,this.j+=f.newLength-f.oldLength}const k=N.s(this.d);return N.t(k)}k(c){this.d[this.e++]=N.o(this.g,c),this.j+=c.newLength-c.oldLength}l(c){return c<this.h?this.c[c]:null}m(c){this.d[this.e++]=N.p(this.j,c),this.g+=c.newLength-c.oldLength}n(c){return c<this.f?this.a[c]:null}static o(c,I){return new R(I.oldPosition-c,I.oldText,I.newPosition,I.newText)}static p(c,I){return new R(I.oldPosition,I.oldText,I.newPosition+c,I.newText)}static q(c,I){const E=c.newText.substr(0,I),u=c.newText.substr(I);return[new R(c.oldPosition,c.oldText,c.newPosition,E),new R(c.oldEnd,"",c.newPosition+I,u)]}static r(c,I){const E=c.oldText.substr(0,I),u=c.oldText.substr(I);return[new R(c.oldPosition,E,c.newPosition,c.newText),new R(c.oldPosition+I,u,c.newEnd,"")]}static s(c){if(c.length===0)return c;const I=[];let E=0,u=c[0];for(let k=1;k<c.length;k++){const p=c[k];u.oldEnd===p.oldPosition?u=new R(u.oldPosition,u.oldText+p.oldText,u.newPosition,u.newText+p.newText):(I[E++]=u,u=p)}return I[E++]=u,I}static t(c){if(c.length===0)return c;const I=[];let E=0;for(let u=0;u<c.length;u++){const k=c[u];k.oldText!==k.newText&&(I[E++]=k)}return I}}}),define(Ee[212],ye([1,0,39,16]),function(ce,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ou=P,e.$pu=R;function P(T,N,$,c,I,E){if(Array.isArray(T)){let u=0;for(const k of T){const p=P(k,N,$,c,I,E);if(p===10)return p;p>u&&(u=p)}return u}else{if(typeof T=="string")return c?T==="*"?5:T===$?10:0:0;if(T){const{language:u,pattern:k,scheme:p,hasAccessToAllModels:a,notebookType:f}=T;if(!c&&!a)return 0;f&&I&&(N=I);let d=0;if(p)if(p===N.scheme)d=10;else if(p==="*")d=5;else return 0;if(u)if(u===$)d=10;else if(u==="*")d=Math.max(d,5);else return 0;if(f)if(f===E)d=10;else if(f==="*"&&E!==void 0)d=Math.max(d,5);else return 0;if(k){let m;if(typeof k=="string"?m=k:m={...k,base:(0,h.$jc)(k.base)},m===N.fsPath||(0,r.$yk)(m,N.fsPath))d=10;else return 0}return d}else return 0}}function R(T){return typeof T=="string"?!1:Array.isArray(T)?T.some(R):!!T.notebookType}}),define(Ee[213],ye([1,0,4,13,31,54,139,188,211,3]),function(ce,e,r,h,P,R,T,N,$,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hD=void 0,h=We(h);class I extends c.$Wc{constructor(u,k,p,a,f,d,m){super(),this.m=this.B(new r.$me),this.onDidChangeContent=this.m.event,this.f=k,this.j=!d,this.g=a,this.h=f,this.c=new T.$gD(u,p,m)}equals(u){return!(u instanceof I)||this.f!==u.f||this.getEOL()!==u.getEOL()?!1:this.c.equal(u.c)}mightContainRTL(){return this.g}mightContainUnusualLineTerminators(){return this.h}resetMightContainUnusualLineTerminators(){this.h=!1}mightContainNonBasicASCII(){return this.j}getBOM(){return this.f}getEOL(){return this.c.getEOL()}createSnapshot(u){return this.c.createSnapshot(u?this.f:"")}getOffsetAt(u,k){return this.c.getOffsetAt(u,k)}getPositionAt(u){return this.c.getPositionAt(u)}getRangeAt(u,k){const p=u+k,a=this.getPositionAt(u),f=this.getPositionAt(p);return new P.$Ht(a.lineNumber,a.column,f.lineNumber,f.column)}getValueInRange(u,k=R.EndOfLinePreference.TextDefined){if(u.isEmpty())return"";const p=this.n(k);return this.c.getValueInRange(u,p)}getValueLengthInRange(u,k=R.EndOfLinePreference.TextDefined){if(u.isEmpty())return 0;if(u.startLineNumber===u.endLineNumber)return u.endColumn-u.startColumn;const p=this.getOffsetAt(u.startLineNumber,u.startColumn),a=this.getOffsetAt(u.endLineNumber,u.endColumn);let f=0;const d=this.n(k),m=this.getEOL();if(d.length!==m.length){const n=d.length-m.length,o=u.endLineNumber-u.startLineNumber;f=n*o}return a-p+f}getCharacterCountInRange(u,k=R.EndOfLinePreference.TextDefined){if(this.j){let p=0;const a=u.startLineNumber,f=u.endLineNumber;for(let d=a;d<=f;d++){const m=this.getLineContent(d),n=d===a?u.startColumn-1:0,o=d===f?u.endColumn-1:m.length;for(let t=n;t<o;t++)h.$Kf(m.charCodeAt(t))?(p=p+1,t=t+1):p=p+1}return p+=this.n(k).length*(f-a),p}return this.getValueLengthInRange(u,k)}getNearestChunk(u){return this.c.getNearestChunk(u)}getLength(){return this.c.getLength()}getLineCount(){return this.c.getLineCount()}getLinesContent(){return this.c.getLinesContent()}getLineContent(u){return this.c.getLineContent(u)}getLineCharCode(u,k){return this.c.getLineCharCode(u,k)}getCharCode(u){return this.c.getCharCode(u)}getLineLength(u){return this.c.getLineLength(u)}getLineMinColumn(u){return 1}getLineMaxColumn(u){return this.getLineLength(u)+1}getLineFirstNonWhitespaceColumn(u){const k=h.$vf(this.getLineContent(u));return k===-1?0:k+1}getLineLastNonWhitespaceColumn(u){const k=h.$xf(this.getLineContent(u));return k===-1?0:k+2}n(u){switch(u){case R.EndOfLinePreference.LF:return`
`;case R.EndOfLinePreference.CRLF:return`\r
`;case R.EndOfLinePreference.TextDefined:return this.getEOL();default:throw new Error("Unknown EOL preference")}}setEOL(u){this.c.setEOL(u)}applyEdits(u,k,p){let a=this.g,f=this.h,d=this.j,m=!0,n=[];for(let w=0;w<u.length;w++){const S=u[w];m&&S._isTracked&&(m=!1);const D=S.range;if(S.text){let v=!0;d||(v=!h.$Vf(S.text),d=v),!a&&v&&(a=h.$Uf(S.text)),!f&&v&&(f=h.$Xf(S.text))}let y="",C=0,A=0,b=0;if(S.text){let v;[C,A,b,v]=(0,N.$ru)(S.text);const L=this.getEOL(),O=L===`\r
`?N.StringEOL.CRLF:N.StringEOL.LF;v===N.StringEOL.Unknown||v===O?y=S.text:y=S.text.replace(/\r\n|\r|\n/g,L)}n[w]={sortIndex:w,identifier:S.identifier||null,range:D,rangeOffset:this.getOffsetAt(D.startLineNumber,D.startColumn),rangeLength:this.getValueLengthInRange(D),text:y,eolCount:C,firstLineLength:A,lastLineLength:b,forceMoveMarkers:!!S.forceMoveMarkers,isAutoWhitespaceEdit:S.isAutoWhitespaceEdit||!1}}n.sort(I.u);let o=!1;for(let w=0,S=n.length-1;w<S;w++){const D=n[w].range.getEndPosition(),y=n[w+1].range.getStartPosition();if(y.isBeforeOrEqual(D)){if(y.isBefore(D))throw new Error("Overlapping ranges are not allowed!");o=!0}}m&&(n=this.s(n));const t=p||k?I._getInverseEditRanges(n):[],i=[];if(k)for(let w=0;w<n.length;w++){const S=n[w],D=t[w];if(S.isAutoWhitespaceEdit&&S.range.isEmpty())for(let y=D.startLineNumber;y<=D.endLineNumber;y++){let C="";y===D.startLineNumber&&(C=this.getLineContent(S.range.startLineNumber),h.$vf(C)!==-1)||i.push({lineNumber:y,oldContent:C})}}let s=null;if(p){let w=0;s=[];for(let S=0;S<n.length;S++){const D=n[S],y=t[S],C=this.getValueInRange(D.range),A=D.rangeOffset+w;w+=D.text.length-C.length,s[S]={sortIndex:D.sortIndex,identifier:D.identifier,range:y,text:C,textChange:new $.$0t(D.rangeOffset,C,A,D.text)}}o||s.sort((S,D)=>S.sortIndex-D.sortIndex)}this.g=a,this.h=f,this.j=d;const g=this.t(n);let l=null;if(k&&i.length>0){i.sort((w,S)=>S.lineNumber-w.lineNumber),l=[];for(let w=0,S=i.length;w<S;w++){const D=i[w].lineNumber;if(w>0&&i[w-1].lineNumber===D)continue;const y=i[w].oldContent,C=this.getLineContent(D);C.length===0||C===y||h.$vf(C)!==-1||l.push(D)}}return this.m.fire(),new R.$aw(s,g,l)}s(u){return u.length<1e3?u:[this._toSingleEditOperation(u)]}_toSingleEditOperation(u){let k=!1;const p=u[0].range,a=u[u.length-1].range,f=new P.$Ht(p.startLineNumber,p.startColumn,a.endLineNumber,a.endColumn);let d=p.startLineNumber,m=p.startColumn;const n=[];for(let g=0,l=u.length;g<l;g++){const w=u[g],S=w.range;k=k||w.forceMoveMarkers,n.push(this.getValueInRange(new P.$Ht(d,m,S.startLineNumber,S.startColumn))),w.text.length>0&&n.push(w.text),d=S.endLineNumber,m=S.endColumn}const o=n.join(""),[t,i,s]=(0,N.$ru)(o);return{sortIndex:0,identifier:u[0].identifier,range:f,rangeOffset:this.getOffsetAt(f.startLineNumber,f.startColumn),rangeLength:this.getValueLengthInRange(f,R.EndOfLinePreference.TextDefined),text:o,eolCount:t,firstLineLength:i,lastLineLength:s,forceMoveMarkers:k,isAutoWhitespaceEdit:!1}}t(u){u.sort(I.w);const k=[];for(let p=0;p<u.length;p++){const a=u[p],f=a.range.startLineNumber,d=a.range.startColumn,m=a.range.endLineNumber,n=a.range.endColumn;if(f===m&&d===n&&a.text.length===0)continue;a.text?(this.c.delete(a.rangeOffset,a.rangeLength),this.c.insert(a.rangeOffset,a.text,!0)):this.c.delete(a.rangeOffset,a.rangeLength);const o=new P.$Ht(f,d,m,n);k.push({range:o,rangeLength:a.rangeLength,text:a.text,rangeOffset:a.rangeOffset,forceMoveMarkers:a.forceMoveMarkers})}return k}findMatchesLineByLine(u,k,p,a){return this.c.findMatchesLineByLine(u,k,p,a)}getPieceTree(){return this.c}static _getInverseEditRange(u,k){const p=u.startLineNumber,a=u.startColumn,[f,d,m]=(0,N.$ru)(k);let n;if(k.length>0){const o=f+1;o===1?n=new P.$Ht(p,a,p,a+d):n=new P.$Ht(p,a,p+o-1,m+1)}else n=new P.$Ht(p,a,p,a);return n}static _getInverseEditRanges(u){const k=[];let p=0,a=0,f=null;for(let d=0,m=u.length;d<m;d++){const n=u[d];let o,t;f?f.range.endLineNumber===n.range.startLineNumber?(o=p,t=a+(n.range.startColumn-f.range.endColumn)):(o=p+(n.range.startLineNumber-f.range.endLineNumber),t=n.range.startColumn):(o=n.range.startLineNumber,t=n.range.startColumn);let i;if(n.text.length>0){const s=n.eolCount+1;s===1?i=new P.$Ht(o,t,o,t+n.firstLineLength):i=new P.$Ht(o,t,o+s-1,n.lastLineLength+1)}else i=new P.$Ht(o,t,o,t);p=i.endLineNumber,a=i.endColumn,k.push(i),f=n}return k}static u(u,k){const p=P.$Ht.compareRangesUsingEnds(u.range,k.range);return p===0?u.sortIndex-k.sortIndex:p}static w(u,k){const p=P.$Ht.compareRangesUsingEnds(u.range,k.range);return p===0?k.sortIndex-u.sortIndex:-p}}e.$hD=I}),define(Ee[214],ye([1,0,27,13,54,139,213]),function(ce,e,r,h,P,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iD=void 0,h=We(h);class N{constructor(I,E,u,k,p,a,f,d,m){this.a=I,this.b=E,this.c=u,this.d=k,this.e=p,this.f=a,this.g=f,this.h=d,this.j=m}k(I){const E=this.c+this.d+this.e,u=this.c+this.e;return E===0?I===P.DefaultEndOfLine.LF?`
`:`\r
`:u>E/2?`\r
`:`
`}create(I){const E=this.k(I),u=this.a;if(this.j&&(E===`\r
`&&(this.c>0||this.d>0)||E===`
`&&(this.c>0||this.e>0)))for(let p=0,a=u.length;p<a;p++){const f=u[p].buffer.replace(/\r\n|\r|\n/g,E),d=(0,R.$cD)(f);u[p]=new R.$fD(f,d)}const k=new T.$hD(u,this.b,E,this.f,this.g,this.h,this.j);return{textBuffer:k,disposable:k}}getFirstLineText(I){return this.a[0].buffer.substr(0,I).split(/\r\n|\r|\n/)[0]}}class ${constructor(){this.a=[],this.b="",this.c=!1,this.d=0,this.e=[],this.f=0,this.g=0,this.h=0,this.j=!1,this.k=!1,this.l=!0}acceptChunk(I){if(I.length===0)return;this.a.length===0&&h.$6f(I)&&(this.b=h.$5f,I=I.substr(1));const E=I.charCodeAt(I.length-1);E===r.CharCode.CarriageReturn||E>=55296&&E<=56319?(this.m(I.substr(0,I.length-1),!1),this.c=!0,this.d=E):(this.m(I,!1),this.c=!1,this.d=E)}m(I,E){!E&&I.length===0||(this.c?this.n(String.fromCharCode(this.d)+I):this.n(I))}n(I){const E=(0,R.$dD)(this.e,I);this.a.push(new R.$fD(I,E.lineStarts)),this.f+=E.cr,this.g+=E.lf,this.h+=E.crlf,E.isBasicASCII||(this.l=!1,this.j||(this.j=h.$Uf(I)),this.k||(this.k=h.$Xf(I)))}finish(I=!0){return this.o(),new N(this.a,this.b,this.f,this.g,this.h,this.j,this.k,this.l,I)}o(){if(this.a.length===0&&this.m("",!0),this.c){this.c=!1;const I=this.a[this.a.length-1];I.buffer+=String.fromCharCode(this.d);const E=(0,R.$cD)(I.buffer);I.lineStarts=E,this.d===r.CharCode.CarriageReturn&&this.f++}}}e.$iD=$}),define(Ee[143],ye([1,0,22,11]),function(ce,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ndb=$,e.$odb=I,h=We(h);var P;(function(E){E[E.Full=1]="Full",E[E.Delta=2]="Delta"})(P||(P={}));function R(E){for(let u=0,k=E.length;u<k;u+=4){const p=E[u+0],a=E[u+1],f=E[u+2],d=E[u+3];E[u+0]=d,E[u+1]=f,E[u+2]=a,E[u+3]=p}}function T(E){const u=new Uint8Array(E.buffer,E.byteOffset,E.length*4);return h.$D()||R(u),r.$Oe.wrap(u)}function N(E){const u=E.buffer;if(h.$D()||R(u),u.byteOffset%4===0)return new Uint32Array(u.buffer,u.byteOffset,u.length/4);{const k=new Uint8Array(u.byteLength);return k.set(u),new Uint32Array(k.buffer,k.byteOffset,k.length/4)}}function $(E){const u=new Uint32Array(c(E));let k=0;if(u[k++]=E.id,E.type==="full")u[k++]=P.Full,u[k++]=E.data.length,u.set(E.data,k),k+=E.data.length;else{u[k++]=P.Delta,u[k++]=E.deltas.length;for(const p of E.deltas)u[k++]=p.start,u[k++]=p.deleteCount,p.data?(u[k++]=p.data.length,u.set(p.data,k),k+=p.data.length):u[k++]=0}return T(u)}function c(E){let u=0;if(u+=2,E.type==="full")u+=1+E.data.length;else{u+=1,u+=3*E.deltas.length;for(const k of E.deltas)k.data&&(u+=k.data.length)}return u}function I(E){const u=N(E);let k=0;const p=u[k++];if(u[k++]===P.Full){const m=u[k++],n=u.subarray(k,k+m);return k+=m,{id:p,type:"full",data:n}}const f=u[k++],d=[];for(let m=0;m<f;m++){const n=u[k++],o=u[k++],t=u[k++];let i;t>0&&(i=u.subarray(k,k+t),k+=t),d[m]={start:n,deleteCount:o,data:i}}return{id:p,type:"delta",deltas:d}}}),define(Ee[215],ye([7,8]),function(ce,e){return ce.create("vs/editor/common/config/editorOptions",e)}),define(Ee[216],ye([7,8]),function(ce,e){return ce.create("vs/editor/common/languages",e)}),define(Ee[88],ye([1,0,83,2,189,31,199,216]),function(ce,e,r,h,P,R,T,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InlineEditTriggerKind=e.ExternalUriOpenerPriority=e.$Ju=e.$Iu=e.InlayHintKind=e.CommentState=e.CommentMode=e.CommentThreadApplicability=e.CommentThreadState=e.CommentThreadCollapsibleState=e.Command=e.NewSymbolNameTriggerKind=e.NewSymbolNameTag=e.$Hu=e.$Gu=e.SymbolKinds=e.SymbolTag=e.$Eu=e.SymbolKind=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.DocumentPasteTriggerKind=e.CodeActionTriggerType=e.$Cu=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.PartialAcceptTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.CompletionItemKinds=e.CompletionItemKind=e.HoverVerbosityAction=e.$Bu=e.$Au=e.$zu=void 0,e.$Du=g,e.$Fu=w;class ${constructor(G,Q,ee){this.offset=G,this.type=Q,this.language=ee,this._tokenBrand=void 0}toString(){return"("+this.offset+", "+this.type+")"}}e.$zu=$;class c{constructor(G,Q){this.tokens=G,this.endState=Q,this._tokenizationResultBrand=void 0}}e.$Au=c;class I{constructor(G,Q){this.tokens=G,this.endState=Q,this._encodedTokenizationResultBrand=void 0}}e.$Bu=I;var E;(function(U){U[U.Increase=0]="Increase",U[U.Decrease=1]="Decrease"})(E||(e.HoverVerbosityAction=E={}));var u;(function(U){U[U.Method=0]="Method",U[U.Function=1]="Function",U[U.Constructor=2]="Constructor",U[U.Field=3]="Field",U[U.Variable=4]="Variable",U[U.Class=5]="Class",U[U.Struct=6]="Struct",U[U.Interface=7]="Interface",U[U.Module=8]="Module",U[U.Property=9]="Property",U[U.Event=10]="Event",U[U.Operator=11]="Operator",U[U.Unit=12]="Unit",U[U.Value=13]="Value",U[U.Constant=14]="Constant",U[U.Enum=15]="Enum",U[U.EnumMember=16]="EnumMember",U[U.Keyword=17]="Keyword",U[U.Text=18]="Text",U[U.Color=19]="Color",U[U.File=20]="File",U[U.Reference=21]="Reference",U[U.Customcolor=22]="Customcolor",U[U.Folder=23]="Folder",U[U.TypeParameter=24]="TypeParameter",U[U.User=25]="User",U[U.Issue=26]="Issue",U[U.Snippet=27]="Snippet"})(u||(e.CompletionItemKind=u={}));var k;(function(U){const G=new Map;G.set(u.Method,r.$5j.symbolMethod),G.set(u.Function,r.$5j.symbolFunction),G.set(u.Constructor,r.$5j.symbolConstructor),G.set(u.Field,r.$5j.symbolField),G.set(u.Variable,r.$5j.symbolVariable),G.set(u.Class,r.$5j.symbolClass),G.set(u.Struct,r.$5j.symbolStruct),G.set(u.Interface,r.$5j.symbolInterface),G.set(u.Module,r.$5j.symbolModule),G.set(u.Property,r.$5j.symbolProperty),G.set(u.Event,r.$5j.symbolEvent),G.set(u.Operator,r.$5j.symbolOperator),G.set(u.Unit,r.$5j.symbolUnit),G.set(u.Value,r.$5j.symbolValue),G.set(u.Enum,r.$5j.symbolEnum),G.set(u.Constant,r.$5j.symbolConstant),G.set(u.Enum,r.$5j.symbolEnum),G.set(u.EnumMember,r.$5j.symbolEnumMember),G.set(u.Keyword,r.$5j.symbolKeyword),G.set(u.Snippet,r.$5j.symbolSnippet),G.set(u.Text,r.$5j.symbolText),G.set(u.Color,r.$5j.symbolColor),G.set(u.File,r.$5j.symbolFile),G.set(u.Reference,r.$5j.symbolReference),G.set(u.Customcolor,r.$5j.symbolCustomColor),G.set(u.Folder,r.$5j.symbolFolder),G.set(u.TypeParameter,r.$5j.symbolTypeParameter),G.set(u.User,r.$5j.account),G.set(u.Issue,r.$5j.issues);function Q(ne){let De=G.get(ne);return De||(console.info("No codicon found for CompletionItemKind "+ne),De=r.$5j.symbolProperty),De}U.toIcon=Q;const ee=new Map;ee.set("method",u.Method),ee.set("function",u.Function),ee.set("constructor",u.Constructor),ee.set("field",u.Field),ee.set("variable",u.Variable),ee.set("class",u.Class),ee.set("struct",u.Struct),ee.set("interface",u.Interface),ee.set("module",u.Module),ee.set("property",u.Property),ee.set("event",u.Event),ee.set("operator",u.Operator),ee.set("unit",u.Unit),ee.set("value",u.Value),ee.set("constant",u.Constant),ee.set("enum",u.Enum),ee.set("enum-member",u.EnumMember),ee.set("enumMember",u.EnumMember),ee.set("keyword",u.Keyword),ee.set("snippet",u.Snippet),ee.set("text",u.Text),ee.set("color",u.Color),ee.set("file",u.File),ee.set("reference",u.Reference),ee.set("customcolor",u.Customcolor),ee.set("folder",u.Folder),ee.set("type-parameter",u.TypeParameter),ee.set("typeParameter",u.TypeParameter),ee.set("account",u.User),ee.set("issue",u.Issue);function he(ne,De){let $e=ee.get(ne);return typeof $e>"u"&&!De&&($e=u.Property),$e}U.fromString=he})(k||(e.CompletionItemKinds=k={}));var p;(function(U){U[U.Deprecated=1]="Deprecated"})(p||(e.CompletionItemTag=p={}));var a;(function(U){U[U.None=0]="None",U[U.KeepWhitespace=1]="KeepWhitespace",U[U.InsertAsSnippet=4]="InsertAsSnippet"})(a||(e.CompletionItemInsertTextRule=a={}));var f;(function(U){U[U.Word=0]="Word",U[U.Line=1]="Line",U[U.Suggest=2]="Suggest"})(f||(e.PartialAcceptTriggerKind=f={}));var d;(function(U){U[U.Invoke=0]="Invoke",U[U.TriggerCharacter=1]="TriggerCharacter",U[U.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(d||(e.CompletionTriggerKind=d={}));var m;(function(U){U[U.Automatic=0]="Automatic",U[U.Explicit=1]="Explicit"})(m||(e.InlineCompletionTriggerKind=m={}));class n{constructor(G,Q,ee,he){this.range=G,this.text=Q,this.completionKind=ee,this.isSnippetText=he}equals(G){return R.$Ht.lift(this.range).equalsRange(G.range)&&this.text===G.text&&this.completionKind===G.completionKind&&this.isSnippetText===G.isSnippetText}}e.$Cu=n;var o;(function(U){U[U.Invoke=1]="Invoke",U[U.Auto=2]="Auto"})(o||(e.CodeActionTriggerType=o={}));var t;(function(U){U[U.Automatic=0]="Automatic",U[U.PasteAs=1]="PasteAs"})(t||(e.DocumentPasteTriggerKind=t={}));var i;(function(U){U[U.Invoke=1]="Invoke",U[U.TriggerCharacter=2]="TriggerCharacter",U[U.ContentChange=3]="ContentChange"})(i||(e.SignatureHelpTriggerKind=i={}));var s;(function(U){U[U.Text=0]="Text",U[U.Read=1]="Read",U[U.Write=2]="Write"})(s||(e.DocumentHighlightKind=s={}));function g(U){return U&&h.URI.isUri(U.uri)&&R.$Ht.isIRange(U.range)&&(R.$Ht.isIRange(U.originSelectionRange)||R.$Ht.isIRange(U.targetSelectionRange))}var l;(function(U){U[U.File=0]="File",U[U.Module=1]="Module",U[U.Namespace=2]="Namespace",U[U.Package=3]="Package",U[U.Class=4]="Class",U[U.Method=5]="Method",U[U.Property=6]="Property",U[U.Field=7]="Field",U[U.Constructor=8]="Constructor",U[U.Enum=9]="Enum",U[U.Interface=10]="Interface",U[U.Function=11]="Function",U[U.Variable=12]="Variable",U[U.Constant=13]="Constant",U[U.String=14]="String",U[U.Number=15]="Number",U[U.Boolean=16]="Boolean",U[U.Array=17]="Array",U[U.Object=18]="Object",U[U.Key=19]="Key",U[U.Null=20]="Null",U[U.EnumMember=21]="EnumMember",U[U.Struct=22]="Struct",U[U.Event=23]="Event",U[U.Operator=24]="Operator",U[U.TypeParameter=25]="TypeParameter"})(l||(e.SymbolKind=l={})),e.$Eu={[l.Array]:(0,N.localize)(0,null),[l.Boolean]:(0,N.localize)(1,null),[l.Class]:(0,N.localize)(2,null),[l.Constant]:(0,N.localize)(3,null),[l.Constructor]:(0,N.localize)(4,null),[l.Enum]:(0,N.localize)(5,null),[l.EnumMember]:(0,N.localize)(6,null),[l.Event]:(0,N.localize)(7,null),[l.Field]:(0,N.localize)(8,null),[l.File]:(0,N.localize)(9,null),[l.Function]:(0,N.localize)(10,null),[l.Interface]:(0,N.localize)(11,null),[l.Key]:(0,N.localize)(12,null),[l.Method]:(0,N.localize)(13,null),[l.Module]:(0,N.localize)(14,null),[l.Namespace]:(0,N.localize)(15,null),[l.Null]:(0,N.localize)(16,null),[l.Number]:(0,N.localize)(17,null),[l.Object]:(0,N.localize)(18,null),[l.Operator]:(0,N.localize)(19,null),[l.Package]:(0,N.localize)(20,null),[l.Property]:(0,N.localize)(21,null),[l.String]:(0,N.localize)(22,null),[l.Struct]:(0,N.localize)(23,null),[l.TypeParameter]:(0,N.localize)(24,null),[l.Variable]:(0,N.localize)(25,null)};function w(U,G){return(0,N.localize)(26,null,U,e.$Eu[G])}var S;(function(U){U[U.Deprecated=1]="Deprecated"})(S||(e.SymbolTag=S={}));var D;(function(U){const G=new Map;G.set(l.File,r.$5j.symbolFile),G.set(l.Module,r.$5j.symbolModule),G.set(l.Namespace,r.$5j.symbolNamespace),G.set(l.Package,r.$5j.symbolPackage),G.set(l.Class,r.$5j.symbolClass),G.set(l.Method,r.$5j.symbolMethod),G.set(l.Property,r.$5j.symbolProperty),G.set(l.Field,r.$5j.symbolField),G.set(l.Constructor,r.$5j.symbolConstructor),G.set(l.Enum,r.$5j.symbolEnum),G.set(l.Interface,r.$5j.symbolInterface),G.set(l.Function,r.$5j.symbolFunction),G.set(l.Variable,r.$5j.symbolVariable),G.set(l.Constant,r.$5j.symbolConstant),G.set(l.String,r.$5j.symbolString),G.set(l.Number,r.$5j.symbolNumber),G.set(l.Boolean,r.$5j.symbolBoolean),G.set(l.Array,r.$5j.symbolArray),G.set(l.Object,r.$5j.symbolObject),G.set(l.Key,r.$5j.symbolKey),G.set(l.Null,r.$5j.symbolNull),G.set(l.EnumMember,r.$5j.symbolEnumMember),G.set(l.Struct,r.$5j.symbolStruct),G.set(l.Event,r.$5j.symbolEvent),G.set(l.Operator,r.$5j.symbolOperator),G.set(l.TypeParameter,r.$5j.symbolTypeParameter);function Q(ee){let he=G.get(ee);return he||(console.info("No codicon found for SymbolKind "+ee),he=r.$5j.symbolProperty),he}U.toIcon=Q})(D||(e.SymbolKinds=D={}));class y{static asEditOperation(G){return P.$It.replace(R.$Ht.lift(G.range),G.text)}}e.$Gu=y;class C{static{this.Comment=new C("comment")}static{this.Imports=new C("imports")}static{this.Region=new C("region")}static fromValue(G){switch(G){case"comment":return C.Comment;case"imports":return C.Imports;case"region":return C.Region}return new C(G)}constructor(G){this.value=G}}e.$Hu=C;var A;(function(U){U[U.AIGenerated=1]="AIGenerated"})(A||(e.NewSymbolNameTag=A={}));var b;(function(U){U[U.Invoke=0]="Invoke",U[U.Automatic=1]="Automatic"})(b||(e.NewSymbolNameTriggerKind=b={}));var v;(function(U){function G(Q){return!Q||typeof Q!="object"?!1:typeof Q.id=="string"&&typeof Q.title=="string"}U.is=G})(v||(e.Command=v={}));var L;(function(U){U[U.Collapsed=0]="Collapsed",U[U.Expanded=1]="Expanded"})(L||(e.CommentThreadCollapsibleState=L={}));var O;(function(U){U[U.Unresolved=0]="Unresolved",U[U.Resolved=1]="Resolved"})(O||(e.CommentThreadState=O={}));var M;(function(U){U[U.Current=0]="Current",U[U.Outdated=1]="Outdated"})(M||(e.CommentThreadApplicability=M={}));var j;(function(U){U[U.Editing=0]="Editing",U[U.Preview=1]="Preview"})(j||(e.CommentMode=j={}));var z;(function(U){U[U.Published=0]="Published",U[U.Draft=1]="Draft"})(z||(e.CommentState=z={}));var F;(function(U){U[U.Type=1]="Type",U[U.Parameter=2]="Parameter"})(F||(e.InlayHintKind=F={}));class B{constructor(G){this.b=G,this.a=null}dispose(){this.a&&this.a.then(G=>{G&&G.dispose()})}get tokenizationSupport(){return this.a||(this.a=this.b()),this.a}}e.$Iu=B,e.$Ju=new T.$qu;var _;(function(U){U[U.None=0]="None",U[U.Option=1]="Option",U[U.Default=2]="Default",U[U.Preferred=3]="Preferred"})(_||(e.ExternalUriOpenerPriority=_={}));var re;(function(U){U[U.Invoke=0]="Invoke",U[U.Automatic=1]="Automatic"})(re||(e.InlineEditTriggerKind=re={}))}),define(Ee[217],ye([7,8]),function(ce,e){return ce.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Ee[218],ye([7,8]),function(ce,e){return ce.create("vs/platform/contextkey/common/contextkey",e)}),define(Ee[219],ye([7,8]),function(ce,e){return ce.create("vs/platform/contextkey/common/scanner",e)}),define(Ee[220],ye([7,8]),function(ce,e){return ce.create("vs/platform/dialogs/common/dialogs",e)}),define(Ee[221],ye([7,8]),function(ce,e){return ce.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Ee[222],ye([7,8]),function(ce,e){return ce.create("vs/platform/extensions/common/extensionValidator",e)}),define(Ee[223],ye([7,8]),function(ce,e){return ce.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(Ee[224],ye([7,8]),function(ce,e){return ce.create("vs/platform/files/common/files",e)}),define(Ee[225],ye([7,8]),function(ce,e){return ce.create("vs/platform/files/common/io",e)}),define(Ee[226],ye([7,8]),function(ce,e){return ce.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(Ee[227],ye([7,8]),function(ce,e){return ce.create("vs/platform/log/common/log",e)}),define(Ee[228],ye([7,8]),function(ce,e){return ce.create("vs/platform/markers/common/markers",e)}),define(Ee[229],ye([7,8]),function(ce,e){return ce.create("vs/platform/request/common/request",e)}),define(Ee[230],ye([7,8]),function(ce,e){return ce.create("vs/platform/theme/common/iconRegistry",e)}),define(Ee[231],ye([7,8]),function(ce,e){return ce.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(Ee[232],ye([7,8]),function(ce,e){return ce.create("vs/platform/workspace/common/workspace",e)}),define(Ee[233],ye([7,8]),function(ce,e){return ce.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(Ee[234],ye([7,8]),function(ce,e){return ce.create("vs/workbench/api/common/extHostExtensionService",e)}),define(Ee[235],ye([7,8]),function(ce,e){return ce.create("vs/workbench/api/common/extHostLanguageFeatures",e)}),define(Ee[236],ye([7,8]),function(ce,e){return ce.create("vs/workbench/api/common/extHostLanguageModels",e)}),define(Ee[237],ye([7,8]),function(ce,e){return ce.create("vs/workbench/api/common/extHostLogService",e)}),define(Ee[238],ye([7,8]),function(ce,e){return ce.create("vs/workbench/api/common/extHostNotebook",e)}),define(Ee[239],ye([7,8]),function(ce,e){return ce.create("vs/workbench/api/common/extHostStatusBar",e)}),define(Ee[240],ye([7,8]),function(ce,e){return ce.create("vs/workbench/api/common/extHostTelemetry",e)}),define(Ee[241],ye([7,8]),function(ce,e){return ce.create("vs/workbench/api/common/extHostTerminalService",e)}),define(Ee[242],ye([7,8]),function(ce,e){return ce.create("vs/workbench/api/common/extHostTreeViews",e)}),define(Ee[243],ye([7,8]),function(ce,e){return ce.create("vs/workbench/api/common/extHostTunnelService",e)}),define(Ee[244],ye([7,8]),function(ce,e){return ce.create("vs/workbench/api/common/extHostWorkspace",e)}),define(Ee[245],ye([7,8]),function(ce,e){return ce.create("vs/workbench/api/node/extHostDebugService",e)}),define(Ee[246],ye([7,8]),function(ce,e){return ce.create("vs/workbench/common/configuration",e)}),define(Ee[247],ye([7,8]),function(ce,e){return ce.create("vs/workbench/common/editor",e)}),define(Ee[248],ye([7,8]),function(ce,e){return ce.create("vs/workbench/common/views",e)}),define(Ee[249],ye([7,8]),function(ce,e){return ce.create("vs/workbench/contrib/chat/common/chatContextKeys",e)}),define(Ee[250],ye([7,8]),function(ce,e){return ce.create("vs/workbench/contrib/chat/common/languageModels",e)}),define(Ee[251],ye([7,8]),function(ce,e){return ce.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(Ee[252],ye([7,8]),function(ce,e){return ce.create("vs/workbench/contrib/debug/common/debug",e)}),define(Ee[253],ye([7,8]),function(ce,e){return ce.create("vs/workbench/contrib/debug/node/debugAdapter",e)}),define(Ee[254],ye([7,8]),function(ce,e){return ce.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(Ee[255],ye([7,8]),function(ce,e){return ce.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(Ee[256],ye([7,8]),function(ce,e){return ce.create("vs/workbench/contrib/testing/common/constants",e)}),define(Ee[257],ye([7,8]),function(ce,e){return ce.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(Ee[258],ye([7,8]),function(ce,e){return ce.create("vs/workbench/services/editor/common/editorResolverService",e)}),define(Ee[259],ye([7,8]),function(ce,e){return ce.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(Ee[260],ye([7,8]),function(ce,e){return ce.create("vs/workbench/services/remote/common/tunnelModel",e)}),define(Ee[261],ye([7,8]),function(ce,e){return ce.create("vs/workbench/services/search/common/queryBuilder",e)}),define(Ee[262],ye([1,0,27,14,219]),function(ce,e,r,h,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Aj=e.TokenType=void 0;var R;(function(I){I[I.LParen=0]="LParen",I[I.RParen=1]="RParen",I[I.Neg=2]="Neg",I[I.Eq=3]="Eq",I[I.NotEq=4]="NotEq",I[I.Lt=5]="Lt",I[I.LtEq=6]="LtEq",I[I.Gt=7]="Gt",I[I.GtEq=8]="GtEq",I[I.RegexOp=9]="RegexOp",I[I.RegexStr=10]="RegexStr",I[I.True=11]="True",I[I.False=12]="False",I[I.In=13]="In",I[I.Not=14]="Not",I[I.And=15]="And",I[I.Or=16]="Or",I[I.Str=17]="Str",I[I.QuotedStr=18]="QuotedStr",I[I.Error=19]="Error",I[I.EOF=20]="EOF"})(R||(e.TokenType=R={}));function T(...I){switch(I.length){case 1:return(0,P.localize)(0,null,I[0]);case 2:return(0,P.localize)(1,null,I[0],I[1]);case 3:return(0,P.localize)(2,null,I[0],I[1],I[2]);default:return}}const N=(0,P.localize)(3,null),$=(0,P.localize)(4,null);class c{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(E){switch(E.type){case R.LParen:return"(";case R.RParen:return")";case R.Neg:return"!";case R.Eq:return E.isTripleEq?"===":"==";case R.NotEq:return E.isTripleEq?"!==":"!=";case R.Lt:return"<";case R.LtEq:return"<=";case R.Gt:return">=";case R.GtEq:return">=";case R.RegexOp:return"=~";case R.RegexStr:return E.lexeme;case R.True:return"true";case R.False:return"false";case R.In:return"in";case R.Not:return"not";case R.And:return"&&";case R.Or:return"||";case R.Str:return E.lexeme;case R.QuotedStr:return E.lexeme;case R.Error:return E.lexeme;case R.EOF:return"EOF";default:throw(0,h.$0)(`unhandled token type: ${JSON.stringify(E)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(E=>E.charCodeAt(0)))}static{this.b=new Map([["not",R.Not],["in",R.In],["false",R.False],["true",R.True]])}get errors(){return this.g}reset(E){return this.c=E,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case r.CharCode.OpenParen:this.k(R.LParen);break;case r.CharCode.CloseParen:this.k(R.RParen);break;case r.CharCode.ExclamationMark:if(this.h(r.CharCode.Equals)){const u=this.h(r.CharCode.Equals);this.f.push({type:R.NotEq,offset:this.d,isTripleEq:u})}else this.k(R.Neg);break;case r.CharCode.SingleQuote:this.o();break;case r.CharCode.Slash:this.q();break;case r.CharCode.Equals:if(this.h(r.CharCode.Equals)){const u=this.h(r.CharCode.Equals);this.f.push({type:R.Eq,offset:this.d,isTripleEq:u})}else this.h(r.CharCode.Tilde)?this.k(R.RegexOp):this.l(T("==","=~"));break;case r.CharCode.LessThan:this.k(this.h(r.CharCode.Equals)?R.LtEq:R.Lt);break;case r.CharCode.GreaterThan:this.k(this.h(r.CharCode.Equals)?R.GtEq:R.Gt);break;case r.CharCode.Ampersand:this.h(r.CharCode.Ampersand)?this.k(R.And):this.l(T("&&"));break;case r.CharCode.Pipe:this.h(r.CharCode.Pipe)?this.k(R.Or):this.l(T("||"));break;case r.CharCode.Space:case r.CharCode.CarriageReturn:case r.CharCode.Tab:case r.CharCode.LineFeed:case r.CharCode.NoBreakSpace:break;default:this.n()}return this.d=this.e,this.k(R.EOF),Array.from(this.f)}h(E){return this.r()||this.c.charCodeAt(this.e)!==E?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?r.CharCode.Null:this.c.charCodeAt(this.e)}k(E){this.f.push({type:E,offset:this.d})}l(E){const u=this.d,k=this.c.substring(this.d,this.e),p={type:R.Error,offset:this.d,lexeme:k};this.g.push({offset:u,lexeme:k,additionalInfo:E}),this.f.push(p)}n(){this.m.lastIndex=this.d;const E=this.m.exec(this.c);if(E){this.e=this.d+E[0].length;const u=this.c.substring(this.d,this.e),k=c.b.get(u);k?this.k(k):this.f.push({type:R.Str,lexeme:u,offset:this.d})}}o(){for(;this.j()!==r.CharCode.SingleQuote&&!this.r();)this.i();if(this.r()){this.l(N);return}this.i(),this.f.push({type:R.QuotedStr,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let E=this.e,u=!1,k=!1;for(;;){if(E>=this.c.length){this.e=E,this.l($);return}const a=this.c.charCodeAt(E);if(u)u=!1;else if(a===r.CharCode.Slash&&!k){E++;break}else a===r.CharCode.OpenSquareBracket?k=!0:a===r.CharCode.Backslash?u=!0:a===r.CharCode.CloseSquareBracket&&(k=!1);E++}for(;E<this.c.length&&c.a.has(this.c.charCodeAt(E));)E++;this.e=E;const p=this.c.substring(this.d,this.e);this.f.push({type:R.RegexStr,lexeme:p,offset:this.d})}r(){return this.e>=this.c.length}}e.$Aj=c});var zt=this&&this.__importDefault||function(ce){return ce&&ce.__esModule?ce:{default:ce}};define(Ee[263],ye([1,0,23,44,222,412]),function(ce,e,r,h,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tp=$,e.$Up=c,e.$Vp=I,e.$Wp=E,e.$Xp=u,e.$Yp=k,e.$Zp=p,h=zt(h),P=We(P),R=We(R);const T=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,N=/^-(\d{4})(\d{2})(\d{2})$/;function $(d){return d=d.trim(),d==="*"||T.test(d)}function c(d){if(!$(d))return null;if(d=d.trim(),d==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const m=d.match(T);return m?{hasCaret:m[1]==="^",hasGreaterEquals:m[1]===">=",majorBase:m[2]==="x"?0:parseInt(m[2],10),majorMustEqual:m[2]!=="x",minorBase:m[4]==="x"?0:parseInt(m[4],10),minorMustEqual:m[4]!=="x",patchBase:m[6]==="x"?0:parseInt(m[6],10),patchMustEqual:m[6]!=="x",preRelease:m[8]||null}:null}function I(d){if(!d)return null;const m=d.majorBase,n=d.majorMustEqual,o=d.minorBase;let t=d.minorMustEqual;const i=d.patchBase;let s=d.patchMustEqual;d.hasCaret&&(m===0||(t=!1),s=!1);let g=0;if(d.preRelease){const l=N.exec(d.preRelease);if(l){const[,w,S,D]=l;g=Date.UTC(Number(w),Number(S)-1,Number(D))}}return{majorBase:m,majorMustEqual:n,minorBase:o,minorMustEqual:t,patchBase:i,patchMustEqual:s,isMinimum:d.hasGreaterEquals,notBefore:g}}function E(d,m,n){let o;typeof d=="string"?o=I(c(d)):o=d;let t;m instanceof Date?t=m.getTime():typeof m=="string"&&(t=new Date(m).getTime());let i;if(typeof n=="string"?i=I(c(n)):i=n,!o||!i)return!1;const s=o.majorBase,g=o.minorBase,l=o.patchBase;let w=i.majorBase,S=i.minorBase,D=i.patchBase;const y=i.notBefore;let C=i.majorMustEqual,A=i.minorMustEqual,b=i.patchMustEqual;return i.isMinimum?s>w?!0:s<w?!1:g>S?!0:g<S||t&&t<y?!1:l>=D:(s===1&&w===0&&(!C||!A||!b)&&(w=1,S=0,D=0,C=!0,A=!1,b=!1),s<w?!1:s>w?!C:g<S?!1:g>S?!A:l<D?!1:l>D?!b:!(t&&t<y))}function u(d,m,n,o,t){const i=[];if(typeof o.publisher<"u"&&typeof o.publisher!="string")return i.push([h.default.Error,P.localize(0,null)]),i;if(typeof o.name!="string")return i.push([h.default.Error,P.localize(1,null,"name")]),i;if(typeof o.version!="string")return i.push([h.default.Error,P.localize(2,null,"version")]),i;if(!o.engines)return i.push([h.default.Error,P.localize(3,null,"engines")]),i;if(typeof o.engines.vscode!="string")return i.push([h.default.Error,P.localize(4,null,"engines.vscode")]),i;if(typeof o.extensionDependencies<"u"&&!f(o.extensionDependencies))return i.push([h.default.Error,P.localize(5,null,"extensionDependencies")]),i;if(typeof o.activationEvents<"u"){if(!f(o.activationEvents))return i.push([h.default.Error,P.localize(6,null,"activationEvents")]),i;if(typeof o.main>"u"&&typeof o.browser>"u")return i.push([h.default.Error,P.localize(7,null,"activationEvents","main","browser")]),i}if(typeof o.extensionKind<"u"&&typeof o.main>"u"&&i.push([h.default.Warning,P.localize(8,null,"extensionKind")]),typeof o.main<"u"){if(typeof o.main!="string")return i.push([h.default.Error,P.localize(9,null,"main")]),i;{const l=(0,r.$gh)(n,o.main);(0,r.$ah)(l,n)||i.push([h.default.Warning,P.localize(10,null,l.path,n.path)])}}if(typeof o.browser<"u"){if(typeof o.browser!="string")return i.push([h.default.Error,P.localize(11,null,"browser")]),i;{const l=(0,r.$gh)(n,o.browser);(0,r.$ah)(l,n)||i.push([h.default.Warning,P.localize(12,null,l.path,n.path)])}}if(!R.valid(o.version))return i.push([h.default.Error,P.localize(13,null)]),i;const s=[];if(!k(d,m,o,t,s))for(const l of s)i.push([h.default.Error,l]);return i}function k(d,m,n,o,t){return o||typeof n.main>"u"&&typeof n.browser>"u"?!0:a(d,m,n.engines.vscode,t)}function p(d,m,n){return d==="*"||a(m,n,d)}function a(d,m,n,o=[]){const t=I(c(n));if(!t)return o.push(P.localize(14,null,n)),!1;if(t.majorBase===0){if(!t.majorMustEqual||!t.minorMustEqual)return o.push(P.localize(15,null,n)),!1}else if(!t.majorMustEqual)return o.push(P.localize(16,null,n)),!1;return E(d,m,t)?!0:(o.push(P.localize(17,null,d,n)),!1)}function f(d){if(!Array.isArray(d))return!1;for(let m=0,n=d.length;m<n;m++)if(typeof d[m]!="string")return!1;return!0}}),define(Ee[113],ye([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ci=void 0;class r{constructor(P,R=[],T=!1){this.ctor=P,this.staticArguments=R,this.supportsDelayedInstantiation=T}}e.$Ci=r}),define(Ee[89],ye([1,0,113]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationType=void 0,e.$Ks=R,e.$Ls=T;const h=[];var P;(function(N){N[N.Eager=0]="Eager",N[N.Delayed=1]="Delayed"})(P||(e.InstantiationType=P={}));function R(N,$,c){$ instanceof r.$Ci||($=new r.$Ci($,[],!!c)),h.push([N,$])}function T(){return h}}),define(Ee[264],ye([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$or=e.$nr=void 0;class r{constructor(R,T){this.key=R,this.data=T,this.incoming=new Map,this.outgoing=new Map}}e.$nr=r;class h{constructor(R){this.b=R,this.a=new Map}roots(){const R=[];for(const T of this.a.values())T.outgoing.size===0&&R.push(T);return R}insertEdge(R,T){const N=this.lookupOrInsertNode(R),$=this.lookupOrInsertNode(T);N.outgoing.set($.key,$),$.incoming.set(N.key,N)}removeNode(R){const T=this.b(R);this.a.delete(T);for(const N of this.a.values())N.outgoing.delete(T),N.incoming.delete(T)}lookupOrInsertNode(R){const T=this.b(R);let N=this.a.get(T);return N||(N=new r(T,R),this.a.set(T,N)),N}lookup(R){return this.a.get(this.b(R))}isEmpty(){return this.a.size===0}toString(){const R=[];for(const[T,N]of this.a)R.push(`${T}
	(-> incoming)[${[...N.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...N.outgoing.keys()].join(",")}]
`);return R.join(`
`)}findCycleSlow(){for(const[R,T]of this.a){const N=new Set([R]),$=this.c(T,N);if($)return $}}c(R,T){for(const[N,$]of R.outgoing){if(T.has(N))return[...T,N].join(" -> ");T.add(N);const c=this.c($,T);if(c)return c;T.delete(N)}}}e.$or=h}),define(Ee[5],ye([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ei=e._util=void 0,e.$Fi=P,e.$Gi=R;var r;(function(T){T.serviceIds=new Map,T.DI_TARGET="$di$target",T.DI_DEPENDENCIES="$di$dependencies";function N($){return $[T.DI_DEPENDENCIES]||[]}T.getServiceDependencies=N})(r||(e._util=r={})),e.$Ei=P("instantiationService");function h(T,N,$){N[r.DI_TARGET]===N?N[r.DI_DEPENDENCIES].push({id:T,index:$}):(N[r.DI_DEPENDENCIES]=[{id:T,index:$}],N[r.DI_TARGET]=N)}function P(T){if(r.serviceIds.has(T))return r.serviceIds.get(T);const N=function($,c,I){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");h(N,$,I)};return N.toString=()=>T,r.serviceIds.set(T,N),N}function R(T){return T}}),define(Ee[45],ye([1,0,18,2,5]),function(ce,e,r,h,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationTarget=e.$_i=void 0,e.$aj=R,e.$bj=T,e.$cj=$,e.$dj=c,e.$ej=I,e.$fj=E,e.$gj=u,e.$hj=p,e.$ij=a,e.$jj=f,r=We(r),e.$_i=(0,P.$Fi)("configurationService");function R(d){return d&&typeof d=="object"&&(!d.overrideIdentifier||typeof d.overrideIdentifier=="string")&&(!d.resource||d.resource instanceof h.URI)}function T(d){return d&&typeof d=="object"&&(!d.overrideIdentifiers||Array.isArray(d.overrideIdentifiers))&&!d.overrideIdentifier&&(!d.resource||d.resource instanceof h.URI)}var N;(function(d){d[d.APPLICATION=1]="APPLICATION",d[d.USER=2]="USER",d[d.USER_LOCAL=3]="USER_LOCAL",d[d.USER_REMOTE=4]="USER_REMOTE",d[d.WORKSPACE=5]="WORKSPACE",d[d.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",d[d.DEFAULT=7]="DEFAULT",d[d.MEMORY=8]="MEMORY"})(N||(e.ConfigurationTarget=N={}));function $(d){switch(d){case N.APPLICATION:return"APPLICATION";case N.USER:return"USER";case N.USER_LOCAL:return"USER_LOCAL";case N.USER_REMOTE:return"USER_REMOTE";case N.WORKSPACE:return"WORKSPACE";case N.WORKSPACE_FOLDER:return"WORKSPACE_FOLDER";case N.DEFAULT:return"DEFAULT";case N.MEMORY:return"MEMORY"}}function c(d){return d.applicationValue!==void 0||d.userValue!==void 0||d.userLocalValue!==void 0||d.userRemoteValue!==void 0||d.workspaceValue!==void 0||d.workspaceFolderValue!==void 0}function I(d,m){const n=Object.create(null);for(const o in d)E(n,o,d[o],m);return n}function E(d,m,n,o){const t=m.split("."),i=t.pop();let s=d;for(let g=0;g<t.length;g++){const l=t[g];let w=s[l];switch(typeof w){case"undefined":w=s[l]=Object.create(null);break;case"object":if(w===null){o(`Ignoring ${m} as ${t.slice(0,g+1).join(".")} is null`);return}break;default:o(`Ignoring ${m} as ${t.slice(0,g+1).join(".")} is ${JSON.stringify(w)}`);return}s=w}if(typeof s=="object"&&s!==null)try{s[i]=n}catch{o(`Ignoring ${m} as ${t.join(".")} is ${JSON.stringify(s)}`)}else o(`Ignoring ${m} as ${t.join(".")} is ${JSON.stringify(s)}`)}function u(d,m){const n=m.split(".");k(d,n)}function k(d,m){const n=m.shift();if(m.length===0){delete d[n];return}if(Object.keys(d).indexOf(n)!==-1){const o=d[n];typeof o=="object"&&!Array.isArray(o)&&(k(o,m),Object.keys(o).length===0&&delete d[n])}}function p(d,m,n){function o(s,g){let l=s;for(const w of g){if(typeof l!="object"||l===null)return;l=l[w]}return l}const t=m.split("."),i=o(d,t);return typeof i>"u"?n:i}function a(d,m,n){Object.keys(m).forEach(o=>{o!=="__proto__"&&(o in d?r.$hg(d[o])&&r.$hg(m[o])?a(d[o],m[o],n):n&&(d[o]=m[o]):d[o]=m[o])})}function f(d){return d.replace(/[\[\]]/g,"")}}),define(Ee[36],ye([1,0,27,11,13,262,5,218,14]),function(ce,e,r,h,P,R,T,N,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xj=e.$Wj=e.$Vj=e.$Uj=e.$Tj=e.$Sj=e.$Rj=e.$Qj=e.$Pj=e.$Oj=e.$Nj=e.$Mj=e.$Lj=e.$Kj=e.$Jj=e.$Ij=e.$Hj=e.$Gj=e.$Dj=e.$Cj=e.ContextKeyExprType=void 0,e.$Bj=I,e.$Ej=g,e.$Fj=l,e.$Yj=ne;const c=new Map;c.set("false",!1),c.set("true",!0),c.set("isMac",h.$j),c.set("isLinux",h.$k),c.set("isWindows",h.$i),c.set("isWeb",h.$o),c.set("isMacNative",h.$j&&!h.$o),c.set("isEdge",h.$H),c.set("isFirefox",h.$F),c.set("isChrome",h.$E),c.set("isSafari",h.$G);function I(K,W){if(c.get(K)!==void 0)throw(0,$.$9)("contextkey.setConstant(k, v) invoked with already set constant `k`");c.set(K,W)}const E=Object.prototype.hasOwnProperty;var u;(function(K){K[K.False=0]="False",K[K.True=1]="True",K[K.Defined=2]="Defined",K[K.Not=3]="Not",K[K.Equals=4]="Equals",K[K.NotEquals=5]="NotEquals",K[K.And=6]="And",K[K.Regex=7]="Regex",K[K.NotRegex=8]="NotRegex",K[K.Or=9]="Or",K[K.In=10]="In",K[K.NotIn=11]="NotIn",K[K.Greater=12]="Greater",K[K.GreaterEquals=13]="GreaterEquals",K[K.Smaller=14]="Smaller",K[K.SmallerEquals=15]="SmallerEquals"})(u||(e.ContextKeyExprType=u={}));const k={regexParsingWithErrorRecovery:!0},p=(0,N.localize)(0,null),a=(0,N.localize)(1,null),f=(0,N.localize)(2,null),d=(0,N.localize)(3,null),m=(0,N.localize)(4,null),n=(0,N.localize)(5,null),o=(0,N.localize)(6,null),t=(0,N.localize)(7,null);class i{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(W=k){this.k=W,this.d=new R.$Aj,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(W){if(W===""){this.h.push({message:p,offset:0,lexeme:"",additionalInfo:a});return}this.f=this.d.reset(W).scan(),this.g=0,this.h=[];try{const se=this.l();if(!this.E()){const oe=this.D(),te=oe.type===R.TokenType.Str?n:void 0;throw this.h.push({message:m,offset:oe.offset,lexeme:R.$Aj.getLexeme(oe),additionalInfo:te}),i.c}return se}catch(se){if(se!==i.c)throw se;return}}l(){return this.m()}m(){const W=[this.o()];for(;this.y(R.TokenType.Or);){const se=this.o();W.push(se)}return W.length===1?W[0]:s.or(...W)}o(){const W=[this.s()];for(;this.y(R.TokenType.And);){const se=this.s();W.push(se)}return W.length===1?W[0]:s.and(...W)}s(){if(this.y(R.TokenType.Neg)){const W=this.D();switch(W.type){case R.TokenType.True:return this.z(),S.INSTANCE;case R.TokenType.False:return this.z(),D.INSTANCE;case R.TokenType.LParen:{this.z();const se=this.l();return this.A(R.TokenType.RParen,d),se?.negate()}case R.TokenType.Str:return this.z(),L.create(W.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",W)}}return this.t()}t(){const W=this.D();switch(W.type){case R.TokenType.True:return this.z(),s.true();case R.TokenType.False:return this.z(),s.false();case R.TokenType.LParen:{this.z();const se=this.l();return this.A(R.TokenType.RParen,d),se}case R.TokenType.Str:{const se=W.lexeme;if(this.z(),this.y(R.TokenType.RegexOp)){const te=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),te.type!==R.TokenType.RegexStr)throw this.B("REGEX",te);const le=te.lexeme,ue=le.lastIndexOf("/"),X=ue===le.length-1?void 0:this.w(le.substring(ue+1));let ae;try{ae=new RegExp(le.substring(1,ue),X)}catch{throw this.B("REGEX",te)}return B.create(se,ae)}switch(te.type){case R.TokenType.RegexStr:case R.TokenType.Error:{const le=[te.lexeme];this.z();let ue=this.D(),X=0;for(let Ue=0;Ue<te.lexeme.length;Ue++)te.lexeme.charCodeAt(Ue)===r.CharCode.OpenParen?X++:te.lexeme.charCodeAt(Ue)===r.CharCode.CloseParen&&X--;for(;!this.E()&&ue.type!==R.TokenType.And&&ue.type!==R.TokenType.Or;){switch(ue.type){case R.TokenType.LParen:X++;break;case R.TokenType.RParen:X--;break;case R.TokenType.RegexStr:case R.TokenType.QuotedStr:for(let Ue=0;Ue<ue.lexeme.length;Ue++)ue.lexeme.charCodeAt(Ue)===r.CharCode.OpenParen?X++:te.lexeme.charCodeAt(Ue)===r.CharCode.CloseParen&&X--}if(X<0)break;le.push(R.$Aj.getLexeme(ue)),this.z(),ue=this.D()}const ae=le.join(""),pe=ae.lastIndexOf("/"),be=pe===ae.length-1?void 0:this.w(ae.substring(pe+1));let Fe;try{Fe=new RegExp(ae.substring(1,pe),be)}catch{throw this.B("REGEX",te)}return s.regex(se,Fe)}case R.TokenType.QuotedStr:{const le=te.lexeme;this.z();let ue=null;if(!(0,P.$df)(le)){const X=le.indexOf("/"),ae=le.lastIndexOf("/");if(X!==ae&&X>=0){const pe=le.slice(X+1,ae),be=le[ae+1]==="i"?"i":"";try{ue=new RegExp(pe,be)}catch{throw this.B("REGEX",te)}}}if(ue===null)throw this.B("REGEX",te);return B.create(se,ue)}default:throw this.B("REGEX",this.D())}}if(this.y(R.TokenType.Not)){this.A(R.TokenType.In,f);const te=this.u();return s.notIn(se,te)}switch(this.D().type){case R.TokenType.Eq:{this.z();const te=this.u();if(this.x().type===R.TokenType.QuotedStr)return s.equals(se,te);switch(te){case"true":return s.has(se);case"false":return s.not(se);default:return s.equals(se,te)}}case R.TokenType.NotEq:{this.z();const te=this.u();if(this.x().type===R.TokenType.QuotedStr)return s.notEquals(se,te);switch(te){case"true":return s.not(se);case"false":return s.has(se);default:return s.notEquals(se,te)}}case R.TokenType.Lt:return this.z(),z.create(se,this.u());case R.TokenType.LtEq:return this.z(),F.create(se,this.u());case R.TokenType.Gt:return this.z(),M.create(se,this.u());case R.TokenType.GtEq:return this.z(),j.create(se,this.u());case R.TokenType.In:return this.z(),s.in(se,this.u());default:return s.has(se)}}case R.TokenType.EOF:throw this.h.push({message:o,offset:W.offset,lexeme:"",additionalInfo:t}),i.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const W=this.D();switch(W.type){case R.TokenType.Str:case R.TokenType.QuotedStr:return this.z(),W.lexeme;case R.TokenType.True:return this.z(),"true";case R.TokenType.False:return this.z(),"false";case R.TokenType.In:return this.z(),"in";default:return""}}w(W){return W.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(W){return this.C(W)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(W,se){if(this.C(W))return this.z();throw this.B(se,this.D())}B(W,se,oe){const te=(0,N.localize)(8,null,W,R.$Aj.getLexeme(se)),le=se.offset,ue=R.$Aj.getLexeme(se);return this.h.push({message:te,offset:le,lexeme:ue,additionalInfo:oe}),i.c}C(W){return this.D().type===W}D(){return this.f[this.g]}E(){return this.D().type===R.TokenType.EOF}}e.$Cj=i;class s{static false(){return S.INSTANCE}static true(){return D.INSTANCE}static has(W){return y.create(W)}static equals(W,se){return C.create(W,se)}static notEquals(W,se){return v.create(W,se)}static regex(W,se){return B.create(W,se)}static in(W,se){return A.create(W,se)}static notIn(W,se){return b.create(W,se)}static not(W){return L.create(W)}static and(...W){return U.create(W,null,!0)}static or(...W){return G.create(W,null,!0)}static greater(W,se){return M.create(W,se)}static greaterEquals(W,se){return j.create(W,se)}static smaller(W,se){return z.create(W,se)}static smallerEquals(W,se){return F.create(W,se)}static{this.c=new i({regexParsingWithErrorRecovery:!1})}static deserialize(W){return W==null?void 0:this.c.parse(W)}}e.$Dj=s;function g(K){const W=new i({regexParsingWithErrorRecovery:!1});return K.map(se=>(W.parse(se),W.lexingErrors.length>0?W.lexingErrors.map(oe=>({errorMessage:oe.additionalInfo?(0,N.localize)(9,null,oe.additionalInfo):(0,N.localize)(10,null),offset:oe.offset,length:oe.lexeme.length})):W.parsingErrors.length>0?W.parsingErrors.map(oe=>({errorMessage:oe.additionalInfo?`${oe.message}. ${oe.additionalInfo}`:oe.message,offset:oe.offset,length:oe.lexeme.length})):[]))}function l(K,W){const se=K?K.substituteConstants():void 0,oe=W?W.substituteConstants():void 0;return!se&&!oe?!0:!se||!oe?!1:se.equals(oe)}function w(K,W){return K.cmp(W)}class S{static{this.INSTANCE=new S}constructor(){this.type=u.False}cmp(W){return this.type-W.type}equals(W){return W.type===this.type}substituteConstants(){return this}evaluate(W){return!1}serialize(){return"false"}keys(){return[]}map(W){return this}negate(){return D.INSTANCE}}e.$Gj=S;class D{static{this.INSTANCE=new D}constructor(){this.type=u.True}cmp(W){return this.type-W.type}equals(W){return W.type===this.type}substituteConstants(){return this}evaluate(W){return!0}serialize(){return"true"}keys(){return[]}map(W){return this}negate(){return S.INSTANCE}}e.$Hj=D;class y{static create(W,se=null){const oe=c.get(W);return typeof oe=="boolean"?oe?D.INSTANCE:S.INSTANCE:new y(W,se)}constructor(W,se){this.key=W,this.c=se,this.type=u.Defined}cmp(W){return W.type!==this.type?this.type-W.type:ee(this.key,W.key)}equals(W){return W.type===this.type?this.key===W.key:!1}substituteConstants(){const W=c.get(this.key);return typeof W=="boolean"?W?D.INSTANCE:S.INSTANCE:this}evaluate(W){return!!W.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(W){return W.mapDefined(this.key)}negate(){return this.c||(this.c=L.create(this.key,this)),this.c}}e.$Ij=y;class C{static create(W,se,oe=null){if(typeof se=="boolean")return se?y.create(W,oe):L.create(W,oe);const te=c.get(W);return typeof te=="boolean"?se===(te?"true":"false")?D.INSTANCE:S.INSTANCE:new C(W,se,oe)}constructor(W,se,oe){this.c=W,this.d=se,this.f=oe,this.type=u.Equals}cmp(W){return W.type!==this.type?this.type-W.type:he(this.c,this.d,W.c,W.d)}equals(W){return W.type===this.type?this.c===W.c&&this.d===W.d:!1}substituteConstants(){const W=c.get(this.c);if(typeof W=="boolean"){const se=W?"true":"false";return this.d===se?D.INSTANCE:S.INSTANCE}return this}evaluate(W){return W.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(W){return W.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=v.create(this.c,this.d,this)),this.f}}e.$Jj=C;class A{static create(W,se){return new A(W,se)}constructor(W,se){this.d=W,this.f=se,this.type=u.In,this.c=null}cmp(W){return W.type!==this.type?this.type-W.type:he(this.d,this.f,W.d,W.f)}equals(W){return W.type===this.type?this.d===W.d&&this.f===W.f:!1}substituteConstants(){return this}evaluate(W){const se=W.getValue(this.f),oe=W.getValue(this.d);return Array.isArray(se)?se.includes(oe):typeof oe=="string"&&typeof se=="object"&&se!==null?E.call(se,oe):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(W){return W.mapIn(this.d,this.f)}negate(){return this.c||(this.c=b.create(this.d,this.f)),this.c}}e.$Kj=A;class b{static create(W,se){return new b(W,se)}constructor(W,se){this.d=W,this.f=se,this.type=u.NotIn,this.c=A.create(W,se)}cmp(W){return W.type!==this.type?this.type-W.type:this.c.cmp(W.c)}equals(W){return W.type===this.type?this.c.equals(W.c):!1}substituteConstants(){return this}evaluate(W){return!this.c.evaluate(W)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(W){return W.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Lj=b;class v{static create(W,se,oe=null){if(typeof se=="boolean")return se?L.create(W,oe):y.create(W,oe);const te=c.get(W);return typeof te=="boolean"?se===(te?"true":"false")?S.INSTANCE:D.INSTANCE:new v(W,se,oe)}constructor(W,se,oe){this.c=W,this.d=se,this.f=oe,this.type=u.NotEquals}cmp(W){return W.type!==this.type?this.type-W.type:he(this.c,this.d,W.c,W.d)}equals(W){return W.type===this.type?this.c===W.c&&this.d===W.d:!1}substituteConstants(){const W=c.get(this.c);if(typeof W=="boolean"){const se=W?"true":"false";return this.d===se?S.INSTANCE:D.INSTANCE}return this}evaluate(W){return W.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(W){return W.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=C.create(this.c,this.d,this)),this.f}}e.$Mj=v;class L{static create(W,se=null){const oe=c.get(W);return typeof oe=="boolean"?oe?S.INSTANCE:D.INSTANCE:new L(W,se)}constructor(W,se){this.c=W,this.d=se,this.type=u.Not}cmp(W){return W.type!==this.type?this.type-W.type:ee(this.c,W.c)}equals(W){return W.type===this.type?this.c===W.c:!1}substituteConstants(){const W=c.get(this.c);return typeof W=="boolean"?W?S.INSTANCE:D.INSTANCE:this}evaluate(W){return!W.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(W){return W.mapNot(this.c)}negate(){return this.d||(this.d=y.create(this.c,this)),this.d}}e.$Nj=L;function O(K,W){if(typeof K=="string"){const se=parseFloat(K);isNaN(se)||(K=se)}return typeof K=="string"||typeof K=="number"?W(K):S.INSTANCE}class M{static create(W,se,oe=null){return O(se,te=>new M(W,te,oe))}constructor(W,se,oe){this.c=W,this.d=se,this.f=oe,this.type=u.Greater}cmp(W){return W.type!==this.type?this.type-W.type:he(this.c,this.d,W.c,W.d)}equals(W){return W.type===this.type?this.c===W.c&&this.d===W.d:!1}substituteConstants(){return this}evaluate(W){return typeof this.d=="string"?!1:parseFloat(W.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(W){return W.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=F.create(this.c,this.d,this)),this.f}}e.$Oj=M;class j{static create(W,se,oe=null){return O(se,te=>new j(W,te,oe))}constructor(W,se,oe){this.c=W,this.d=se,this.f=oe,this.type=u.GreaterEquals}cmp(W){return W.type!==this.type?this.type-W.type:he(this.c,this.d,W.c,W.d)}equals(W){return W.type===this.type?this.c===W.c&&this.d===W.d:!1}substituteConstants(){return this}evaluate(W){return typeof this.d=="string"?!1:parseFloat(W.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(W){return W.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=z.create(this.c,this.d,this)),this.f}}e.$Pj=j;class z{static create(W,se,oe=null){return O(se,te=>new z(W,te,oe))}constructor(W,se,oe){this.c=W,this.d=se,this.f=oe,this.type=u.Smaller}cmp(W){return W.type!==this.type?this.type-W.type:he(this.c,this.d,W.c,W.d)}equals(W){return W.type===this.type?this.c===W.c&&this.d===W.d:!1}substituteConstants(){return this}evaluate(W){return typeof this.d=="string"?!1:parseFloat(W.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(W){return W.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=j.create(this.c,this.d,this)),this.f}}e.$Qj=z;class F{static create(W,se,oe=null){return O(se,te=>new F(W,te,oe))}constructor(W,se,oe){this.c=W,this.d=se,this.f=oe,this.type=u.SmallerEquals}cmp(W){return W.type!==this.type?this.type-W.type:he(this.c,this.d,W.c,W.d)}equals(W){return W.type===this.type?this.c===W.c&&this.d===W.d:!1}substituteConstants(){return this}evaluate(W){return typeof this.d=="string"?!1:parseFloat(W.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(W){return W.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=M.create(this.c,this.d,this)),this.f}}e.$Rj=F;class B{static create(W,se){return new B(W,se)}constructor(W,se){this.d=W,this.f=se,this.type=u.Regex,this.c=null}cmp(W){if(W.type!==this.type)return this.type-W.type;if(this.d<W.d)return-1;if(this.d>W.d)return 1;const se=this.f?this.f.source:"",oe=W.f?W.f.source:"";return se<oe?-1:se>oe?1:0}equals(W){if(W.type===this.type){const se=this.f?this.f.source:"",oe=W.f?W.f.source:"";return this.d===W.d&&se===oe}return!1}substituteConstants(){return this}evaluate(W){const se=W.getValue(this.d);return this.f?this.f.test(se):!1}serialize(){const W=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${W}`}keys(){return[this.d]}map(W){return W.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=_.create(this)),this.c}}e.$Sj=B;class _{static create(W){return new _(W)}constructor(W){this.c=W,this.type=u.NotRegex}cmp(W){return W.type!==this.type?this.type-W.type:this.c.cmp(W.c)}equals(W){return W.type===this.type?this.c.equals(W.c):!1}substituteConstants(){return this}evaluate(W){return!this.c.evaluate(W)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(W){return new _(this.c.map(W))}negate(){return this.c}}e.$Tj=_;function re(K){let W=null;for(let se=0,oe=K.length;se<oe;se++){const te=K[se].substituteConstants();if(K[se]!==te&&W===null){W=[];for(let le=0;le<se;le++)W[le]=K[le]}W!==null&&(W[se]=te)}return W===null?K:W}class U{static create(W,se,oe){return U.d(W,se,oe)}constructor(W,se){this.expr=W,this.c=se,this.type=u.And}cmp(W){if(W.type!==this.type)return this.type-W.type;if(this.expr.length<W.expr.length)return-1;if(this.expr.length>W.expr.length)return 1;for(let se=0,oe=this.expr.length;se<oe;se++){const te=w(this.expr[se],W.expr[se]);if(te!==0)return te}return 0}equals(W){if(W.type===this.type){if(this.expr.length!==W.expr.length)return!1;for(let se=0,oe=this.expr.length;se<oe;se++)if(!this.expr[se].equals(W.expr[se]))return!1;return!0}return!1}substituteConstants(){const W=re(this.expr);return W===this.expr?this:U.create(W,this.c,!1)}evaluate(W){for(let se=0,oe=this.expr.length;se<oe;se++)if(!this.expr[se].evaluate(W))return!1;return!0}static d(W,se,oe){const te=[];let le=!1;for(const ue of W)if(ue){if(ue.type===u.True){le=!0;continue}if(ue.type===u.False)return S.INSTANCE;if(ue.type===u.And){te.push(...ue.expr);continue}te.push(ue)}if(te.length===0&&le)return D.INSTANCE;if(te.length!==0){if(te.length===1)return te[0];te.sort(w);for(let ue=1;ue<te.length;ue++)te[ue-1].equals(te[ue])&&(te.splice(ue,1),ue--);if(te.length===1)return te[0];for(;te.length>1;){const ue=te[te.length-1];if(ue.type!==u.Or)break;te.pop();const X=te.pop(),ae=te.length===0,pe=G.create(ue.expr.map(be=>U.create([be,X],null,oe)),null,ae);pe&&(te.push(pe),te.sort(w))}if(te.length===1)return te[0];if(oe){for(let ue=0;ue<te.length;ue++)for(let X=ue+1;X<te.length;X++)if(te[ue].negate().equals(te[X]))return S.INSTANCE;if(te.length===1)return te[0]}return new U(te,se)}}serialize(){return this.expr.map(W=>W.serialize()).join(" && ")}keys(){const W=[];for(const se of this.expr)W.push(...se.keys());return W}map(W){return new U(this.expr.map(se=>se.map(W)),null)}negate(){if(!this.c){const W=[];for(const se of this.expr)W.push(se.negate());this.c=G.create(W,this,!0)}return this.c}}e.$Uj=U;class G{static create(W,se,oe){return G.d(W,se,oe)}constructor(W,se){this.expr=W,this.c=se,this.type=u.Or}cmp(W){if(W.type!==this.type)return this.type-W.type;if(this.expr.length<W.expr.length)return-1;if(this.expr.length>W.expr.length)return 1;for(let se=0,oe=this.expr.length;se<oe;se++){const te=w(this.expr[se],W.expr[se]);if(te!==0)return te}return 0}equals(W){if(W.type===this.type){if(this.expr.length!==W.expr.length)return!1;for(let se=0,oe=this.expr.length;se<oe;se++)if(!this.expr[se].equals(W.expr[se]))return!1;return!0}return!1}substituteConstants(){const W=re(this.expr);return W===this.expr?this:G.create(W,this.c,!1)}evaluate(W){for(let se=0,oe=this.expr.length;se<oe;se++)if(this.expr[se].evaluate(W))return!0;return!1}static d(W,se,oe){let te=[],le=!1;if(W){for(let ue=0,X=W.length;ue<X;ue++){const ae=W[ue];if(ae){if(ae.type===u.False){le=!0;continue}if(ae.type===u.True)return D.INSTANCE;if(ae.type===u.Or){te=te.concat(ae.expr);continue}te.push(ae)}}if(te.length===0&&le)return S.INSTANCE;te.sort(w)}if(te.length!==0){if(te.length===1)return te[0];for(let ue=1;ue<te.length;ue++)te[ue-1].equals(te[ue])&&(te.splice(ue,1),ue--);if(te.length===1)return te[0];if(oe){for(let ue=0;ue<te.length;ue++)for(let X=ue+1;X<te.length;X++)if(te[ue].negate().equals(te[X]))return D.INSTANCE;if(te.length===1)return te[0]}return new G(te,se)}}serialize(){return this.expr.map(W=>W.serialize()).join(" || ")}keys(){const W=[];for(const se of this.expr)W.push(...se.keys());return W}map(W){return new G(this.expr.map(se=>se.map(W)),null)}negate(){if(!this.c){const W=[];for(const se of this.expr)W.push(se.negate());for(;W.length>1;){const se=W.shift(),oe=W.shift(),te=[];for(const le of $e(se))for(const ue of $e(oe))te.push(U.create([le,ue],null,!1));W.unshift(G.create(te,null,!1))}this.c=G.create(W,this,!0)}return this.c}}e.$Vj=G;class Q extends y{static{this.d=[]}static all(){return Q.d.values()}constructor(W,se,oe){super(W,null),this.f=se,typeof oe=="object"?Q.d.push({...oe,key:W}):oe!==!0&&Q.d.push({key:W,description:oe,type:se!=null?typeof se:void 0})}bindTo(W){return W.createKey(this.key,this.f)}getValue(W){return W.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(W){return C.create(this.key,W)}notEqualsTo(W){return v.create(this.key,W)}}e.$Wj=Q,e.$Xj=(0,T.$Fi)("contextKeyService");function ee(K,W){return K<W?-1:K>W?1:0}function he(K,W,se,oe){return K<se?-1:K>se?1:W<oe?-1:W>oe?1:0}function ne(K,W){if(K.type===u.False||W.type===u.True)return!0;if(K.type===u.Or)return W.type===u.Or?De(K.expr,W.expr):!1;if(W.type===u.Or){for(const se of W.expr)if(ne(K,se))return!0;return!1}if(K.type===u.And){if(W.type===u.And)return De(W.expr,K.expr);for(const se of K.expr)if(ne(se,W))return!0;return!1}return K.equals(W)}function De(K,W){let se=0,oe=0;for(;se<K.length&&oe<W.length;){const te=K[se].cmp(W[oe]);if(te<0)return!1;te===0&&se++,oe++}return se===K.length}function $e(K){return K.type===u.Or?K.expr:[K]}}),define(Ee[265],ye([1,0,36,5]),function(ce,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nt=e.$lt=e.AccessibilitySupport=e.$kt=void 0,e.$mt=R,e.$kt=(0,h.$Fi)("accessibilityService");var P;(function(T){T[T.Unknown=0]="Unknown",T[T.Disabled=1]="Disabled",T[T.Enabled=2]="Enabled"})(P||(e.AccessibilitySupport=P={})),e.$lt=new r.$Wj("accessibilityModeEnabled",!1);function R(T){return T&&typeof T=="object"&&typeof T.label=="string"&&(typeof T.role>"u"||typeof T.role=="string")}e.$nt="ACCESSIBLE_VIEW_SHOWN_"}),define(Ee[114],ye([1,0,19,25,11,183,84,191,138,215,265]),function(ce,e,r,h,P,R,T,N,$,c,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.RenderLineNumbersType=e.ShowLightbulbIconMode=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0,e.boolean=n,e.clampedInt=t,e.clampedFloat=s,e.stringSet=w,e.cursorStyleToString=O,e.filterValidationDecorations=Ie,r=We(r),h=We(h),P=We(P),c=We(c);var E;(function(Y){Y[Y.None=0]="None",Y[Y.Keep=1]="Keep",Y[Y.Brackets=2]="Brackets",Y[Y.Advanced=3]="Advanced",Y[Y.Full=4]="Full"})(E||(e.EditorAutoIndentStrategy=E={})),e.MINIMAP_GUTTER_WIDTH=8;class u{constructor(de){this.c=de}hasChanged(de){return this.c[de]}}e.ConfigurationChangedEvent=u;class k{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=k;class p{constructor(de,Ae,Xe,_e){this.id=de,this.name=Ae,this.defaultValue=Xe,this.schema=_e}applyUpdate(de,Ae){return f(de,Ae)}compute(de,Ae,Xe){return Xe}}class a{constructor(de,Ae){this.newValue=de,this.didChange=Ae}}e.ApplyUpdateResult=a;function f(Y,de){if(typeof Y!="object"||typeof de!="object"||!Y||!de)return new a(de,Y!==de);if(Array.isArray(Y)||Array.isArray(de)){const Xe=Array.isArray(Y)&&Array.isArray(de)&&r.$wb(Y,de);return new a(de,!Xe)}let Ae=!1;for(const Xe in de)if(de.hasOwnProperty(Xe)){const _e=f(Y[Xe],de[Xe]);_e.didChange&&(Y[Xe]=_e.newValue,Ae=!0)}return new a(Y,Ae)}class d{constructor(de){this.schema=void 0,this.id=de,this.name="_never_",this.defaultValue=void 0}applyUpdate(de,Ae){return f(de,Ae)}validate(de){return this.defaultValue}}class m{constructor(de,Ae,Xe,_e){this.id=de,this.name=Ae,this.defaultValue=Xe,this.schema=_e}applyUpdate(de,Ae){return f(de,Ae)}validate(de){return typeof de>"u"?this.defaultValue:de}compute(de,Ae,Xe){return Xe}}function n(Y,de){return typeof Y>"u"?de:Y==="false"?!1:!!Y}class o extends m{constructor(de,Ae,Xe,_e=void 0){typeof _e<"u"&&(_e.type="boolean",_e.default=Xe),super(de,Ae,Xe,_e)}validate(de){return n(de,this.defaultValue)}}function t(Y,de,Ae,Xe){if(typeof Y>"u")return de;let _e=parseInt(Y,10);return isNaN(_e)?de:(_e=Math.max(Ae,_e),_e=Math.min(Xe,_e),_e|0)}class i extends m{static clampedInt(de,Ae,Xe,_e){return t(de,Ae,Xe,_e)}constructor(de,Ae,Xe,_e,ut,gt=void 0){typeof gt<"u"&&(gt.type="integer",gt.default=Xe,gt.minimum=_e,gt.maximum=ut),super(de,Ae,Xe,gt),this.minimum=_e,this.maximum=ut}validate(de){return i.clampedInt(de,this.defaultValue,this.minimum,this.maximum)}}function s(Y,de,Ae,Xe){if(typeof Y>"u")return de;const _e=g.float(Y,de);return g.clamp(_e,Ae,Xe)}class g extends m{static clamp(de,Ae,Xe){return de<Ae?Ae:de>Xe?Xe:de}static float(de,Ae){if(typeof de=="number")return de;if(typeof de>"u")return Ae;const Xe=parseFloat(de);return isNaN(Xe)?Ae:Xe}constructor(de,Ae,Xe,_e,ut){typeof ut<"u"&&(ut.type="number",ut.default=Xe),super(de,Ae,Xe,ut),this.validationFn=_e}validate(de){return this.validationFn(g.float(de,this.defaultValue))}}class l extends m{static string(de,Ae){return typeof de!="string"?Ae:de}constructor(de,Ae,Xe,_e=void 0){typeof _e<"u"&&(_e.type="string",_e.default=Xe),super(de,Ae,Xe,_e)}validate(de){return l.string(de,this.defaultValue)}}function w(Y,de,Ae,Xe){return typeof Y!="string"?de:Xe&&Y in Xe?Xe[Y]:Ae.indexOf(Y)===-1?de:Y}class S extends m{constructor(de,Ae,Xe,_e,ut=void 0){typeof ut<"u"&&(ut.type="string",ut.enum=_e,ut.default=Xe),super(de,Ae,Xe,ut),this.c=_e}validate(de){return w(de,this.defaultValue,this.c)}}class D extends p{constructor(de,Ae,Xe,_e,ut,gt,kt=void 0){typeof kt<"u"&&(kt.type="string",kt.enum=ut,kt.default=_e),super(de,Ae,Xe,kt),this.c=ut,this.d=gt}validate(de){return typeof de!="string"?this.defaultValue:this.c.indexOf(de)===-1?this.defaultValue:this.d(de)}}function y(Y){switch(Y){case"none":return E.None;case"keep":return E.Keep;case"brackets":return E.Brackets;case"advanced":return E.Advanced;case"full":return E.Full}}class C extends p{constructor(){super(Me.accessibilitySupport,"accessibilitySupport",I.AccessibilitySupport.Unknown,{type:"string",enum:["auto","on","off"],enumDescriptions:[c.localize(0,null),c.localize(1,null),c.localize(2,null)],default:"auto",tags:["accessibility"],description:c.localize(3,null)})}validate(de){switch(de){case"auto":return I.AccessibilitySupport.Unknown;case"off":return I.AccessibilitySupport.Disabled;case"on":return I.AccessibilitySupport.Enabled}return this.defaultValue}compute(de,Ae,Xe){return Xe===I.AccessibilitySupport.Unknown?de.accessibilitySupport:Xe}}class A extends p{constructor(){const de={insertSpace:!0,ignoreEmptyLines:!0};super(Me.comments,"comments",de,{"editor.comments.insertSpace":{type:"boolean",default:de.insertSpace,description:c.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:de.ignoreEmptyLines,description:c.localize(5,null)}})}validate(de){if(!de||typeof de!="object")return this.defaultValue;const Ae=de;return{insertSpace:n(Ae.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:n(Ae.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var b;(function(Y){Y[Y.Hidden=0]="Hidden",Y[Y.Blink=1]="Blink",Y[Y.Smooth=2]="Smooth",Y[Y.Phase=3]="Phase",Y[Y.Expand=4]="Expand",Y[Y.Solid=5]="Solid"})(b||(e.TextEditorCursorBlinkingStyle=b={}));function v(Y){switch(Y){case"blink":return b.Blink;case"smooth":return b.Smooth;case"phase":return b.Phase;case"expand":return b.Expand;case"solid":return b.Solid}}var L;(function(Y){Y[Y.Line=1]="Line",Y[Y.Block=2]="Block",Y[Y.Underline=3]="Underline",Y[Y.LineThin=4]="LineThin",Y[Y.BlockOutline=5]="BlockOutline",Y[Y.UnderlineThin=6]="UnderlineThin"})(L||(e.TextEditorCursorStyle=L={}));function O(Y){switch(Y){case L.Line:return"line";case L.Block:return"block";case L.Underline:return"underline";case L.LineThin:return"line-thin";case L.BlockOutline:return"block-outline";case L.UnderlineThin:return"underline-thin"}}function M(Y){switch(Y){case"line":return L.Line;case"block":return L.Block;case"underline":return L.Underline;case"line-thin":return L.LineThin;case"block-outline":return L.BlockOutline;case"underline-thin":return L.UnderlineThin}}class j extends d{constructor(){super(Me.editorClassName)}compute(de,Ae,Xe){const _e=["monaco-editor"];return Ae.get(Me.extraEditorClassName)&&_e.push(Ae.get(Me.extraEditorClassName)),de.extraEditorClassName&&_e.push(de.extraEditorClassName),Ae.get(Me.mouseStyle)==="default"?_e.push("mouse-default"):Ae.get(Me.mouseStyle)==="copy"&&_e.push("mouse-copy"),Ae.get(Me.showUnused)&&_e.push("showUnused"),Ae.get(Me.showDeprecated)&&_e.push("showDeprecated"),_e.join(" ")}}class z extends o{constructor(){super(Me.emptySelectionClipboard,"emptySelectionClipboard",!0,{description:c.localize(6,null)})}compute(de,Ae,Xe){return Xe&&de.emptySelectionClipboard}}class F extends p{constructor(){const de={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(Me.find,"find",de,{"editor.find.cursorMoveOnType":{type:"boolean",default:de.cursorMoveOnType,description:c.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:de.seedSearchStringFromSelection,enumDescriptions:[c.localize(8,null),c.localize(9,null),c.localize(10,null)],description:c.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:de.autoFindInSelection,enumDescriptions:[c.localize(12,null),c.localize(13,null),c.localize(14,null)],description:c.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:de.globalFindClipboard,description:c.localize(16,null),included:P.$j},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:de.addExtraSpaceOnTop,description:c.localize(17,null)},"editor.find.loop":{type:"boolean",default:de.loop,description:c.localize(18,null)}})}validate(de){if(!de||typeof de!="object")return this.defaultValue;const Ae=de;return{cursorMoveOnType:n(Ae.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof de.seedSearchStringFromSelection=="boolean"?de.seedSearchStringFromSelection?"always":"never":w(Ae.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof de.autoFindInSelection=="boolean"?de.autoFindInSelection?"always":"never":w(Ae.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:n(Ae.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:n(Ae.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:n(Ae.loop,this.defaultValue.loop)}}}class B extends p{static{this.OFF='"liga" off, "calt" off'}static{this.ON='"liga" on, "calt" on'}constructor(){super(Me.fontLigatures,"fontLigatures",B.OFF,{anyOf:[{type:"boolean",description:c.localize(19,null)},{type:"string",description:c.localize(20,null)}],description:c.localize(21,null),default:!1})}validate(de){return typeof de>"u"?this.defaultValue:typeof de=="string"?de==="false"||de.length===0?B.OFF:de==="true"?B.ON:de:de?B.ON:B.OFF}}e.EditorFontLigatures=B;class _ extends p{static{this.OFF="normal"}static{this.TRANSLATE="translate"}constructor(){super(Me.fontVariations,"fontVariations",_.OFF,{anyOf:[{type:"boolean",description:c.localize(22,null)},{type:"string",description:c.localize(23,null)}],description:c.localize(24,null),default:!1})}validate(de){return typeof de>"u"?this.defaultValue:typeof de=="string"?de==="false"?_.OFF:de==="true"?_.TRANSLATE:de:de?_.TRANSLATE:_.OFF}compute(de,Ae,Xe){return de.fontInfo.fontVariationSettings}}e.EditorFontVariations=_;class re extends d{constructor(){super(Me.fontInfo)}compute(de,Ae,Xe){return de.fontInfo}}class U extends m{constructor(){super(Me.fontSize,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:c.localize(25,null)})}validate(de){const Ae=g.float(de,this.defaultValue);return Ae===0?e.EDITOR_FONT_DEFAULTS.fontSize:g.clamp(Ae,6,100)}compute(de,Ae,Xe){return de.fontInfo.fontSize}}class G extends p{static{this.c=["normal","bold","100","200","300","400","500","600","700","800","900"]}static{this.d=1}static{this.e=1e3}constructor(){super(Me.fontWeight,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:G.d,maximum:G.e,errorMessage:c.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:G.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:c.localize(27,null)})}validate(de){return de==="normal"||de==="bold"?de:String(i.clampedInt(de,e.EDITOR_FONT_DEFAULTS.fontWeight,G.d,G.e))}}class Q extends p{constructor(){const de={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},Ae={type:"string",enum:["peek","gotoAndPeek","goto"],default:de.multiple,enumDescriptions:[c.localize(28,null),c.localize(29,null),c.localize(30,null)]},Xe=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(Me.gotoLocation,"gotoLocation",de,{"editor.gotoLocation.multiple":{deprecationMessage:c.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:c.localize(32,null),...Ae},"editor.gotoLocation.multipleTypeDefinitions":{description:c.localize(33,null),...Ae},"editor.gotoLocation.multipleDeclarations":{description:c.localize(34,null),...Ae},"editor.gotoLocation.multipleImplementations":{description:c.localize(35,null),...Ae},"editor.gotoLocation.multipleReferences":{description:c.localize(36,null),...Ae},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:de.alternativeDefinitionCommand,enum:Xe,description:c.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:de.alternativeTypeDefinitionCommand,enum:Xe,description:c.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:de.alternativeDeclarationCommand,enum:Xe,description:c.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:de.alternativeImplementationCommand,enum:Xe,description:c.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:de.alternativeReferenceCommand,enum:Xe,description:c.localize(41,null)}})}validate(de){if(!de||typeof de!="object")return this.defaultValue;const Ae=de;return{multiple:w(Ae.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:Ae.multipleDefinitions??w(Ae.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:Ae.multipleTypeDefinitions??w(Ae.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:Ae.multipleDeclarations??w(Ae.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:Ae.multipleImplementations??w(Ae.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:Ae.multipleReferences??w(Ae.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:l.string(Ae.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:l.string(Ae.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:l.string(Ae.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:l.string(Ae.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:l.string(Ae.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class ee extends p{constructor(){const de={enabled:!0,delay:300,hidingDelay:300,sticky:!0,above:!0};super(Me.hover,"hover",de,{"editor.hover.enabled":{type:"boolean",default:de.enabled,description:c.localize(42,null)},"editor.hover.delay":{type:"number",default:de.delay,minimum:0,maximum:1e4,description:c.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:de.sticky,description:c.localize(44,null)},"editor.hover.hidingDelay":{type:"integer",minimum:0,default:de.hidingDelay,description:c.localize(45,null)},"editor.hover.above":{type:"boolean",default:de.above,description:c.localize(46,null)}})}validate(de){if(!de||typeof de!="object")return this.defaultValue;const Ae=de;return{enabled:n(Ae.enabled,this.defaultValue.enabled),delay:i.clampedInt(Ae.delay,this.defaultValue.delay,0,1e4),sticky:n(Ae.sticky,this.defaultValue.sticky),hidingDelay:i.clampedInt(Ae.hidingDelay,this.defaultValue.hidingDelay,0,6e5),above:n(Ae.above,this.defaultValue.above)}}}var he;(function(Y){Y[Y.None=0]="None",Y[Y.Text=1]="Text",Y[Y.Blocks=2]="Blocks"})(he||(e.RenderMinimap=he={}));class ne extends d{constructor(){super(Me.layoutInfo)}compute(de,Ae,Xe){return ne.computeLayout(Ae,{memory:de.memory,outerWidth:de.outerWidth,outerHeight:de.outerHeight,isDominatedByLongLines:de.isDominatedByLongLines,lineHeight:de.fontInfo.lineHeight,viewLineCount:de.viewLineCount,lineNumbersDigitCount:de.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:de.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:de.fontInfo.maxDigitWidth,pixelRatio:de.pixelRatio,glyphMarginDecorationLaneCount:de.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(de){const Ae=de.height/de.lineHeight,Xe=Math.floor(de.paddingTop/de.lineHeight);let _e=Math.floor(de.paddingBottom/de.lineHeight);de.scrollBeyondLastLine&&(_e=Math.max(_e,Ae-1));const ut=(Xe+de.viewLineCount+_e)/(de.pixelRatio*de.height),gt=Math.floor(de.viewLineCount/ut);return{typicalViewportLineCount:Ae,extraLinesBeforeFirstLine:Xe,extraLinesBeyondLastLine:_e,desiredRatio:ut,minimapLineCount:gt}}static c(de,Ae){const Xe=de.outerWidth,_e=de.outerHeight,ut=de.pixelRatio;if(!de.minimap.enabled)return{renderMinimap:he.None,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(ut*_e),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:_e};const gt=Ae.stableMinimapLayoutInput,kt=gt&&de.outerHeight===gt.outerHeight&&de.lineHeight===gt.lineHeight&&de.typicalHalfwidthCharacterWidth===gt.typicalHalfwidthCharacterWidth&&de.pixelRatio===gt.pixelRatio&&de.scrollBeyondLastLine===gt.scrollBeyondLastLine&&de.paddingTop===gt.paddingTop&&de.paddingBottom===gt.paddingBottom&&de.minimap.enabled===gt.minimap.enabled&&de.minimap.side===gt.minimap.side&&de.minimap.size===gt.minimap.size&&de.minimap.showSlider===gt.minimap.showSlider&&de.minimap.renderCharacters===gt.minimap.renderCharacters&&de.minimap.maxColumn===gt.minimap.maxColumn&&de.minimap.scale===gt.minimap.scale&&de.verticalScrollbarWidth===gt.verticalScrollbarWidth&&de.isViewportWrapping===gt.isViewportWrapping,Lt=de.lineHeight,Bt=de.typicalHalfwidthCharacterWidth,di=de.scrollBeyondLastLine,it=de.minimap.renderCharacters;let At=ut>=2?Math.round(de.minimap.scale*2):de.minimap.scale;const Zt=de.minimap.maxColumn,Kt=de.minimap.size,pt=de.minimap.side,vt=de.verticalScrollbarWidth,ii=de.viewLineCount,xt=de.remainingWidth,Vt=de.isViewportWrapping,Et=it?2:3;let Ft=Math.floor(ut*_e);const li=Ft/ut;let Gt=!1,xe=!1,_t=Et*At,ni=At/ut,ui=1;if(Kt==="fill"||Kt==="fit"){const{typicalViewportLineCount:si,extraLinesBeforeFirstLine:Wt,extraLinesBeyondLastLine:Qt,desiredRatio:oi,minimapLineCount:Rt}=ne.computeContainedMinimapLineCount({viewLineCount:ii,scrollBeyondLastLine:di,paddingTop:de.paddingTop,paddingBottom:de.paddingBottom,height:_e,lineHeight:Lt,pixelRatio:ut});if(ii/Rt>1)Gt=!0,xe=!0,At=1,_t=1,ni=At/ut;else{let wt=!1,ti=At+1;if(Kt==="fit"){const Pt=Math.ceil((Wt+ii+Qt)*_t);Vt&&kt&&xt<=Ae.stableFitRemainingWidth?(wt=!0,ti=Ae.stableFitMaxMinimapScale):wt=Pt>Ft}if(Kt==="fill"||wt){Gt=!0;const Pt=At;_t=Math.min(Lt*ut,Math.max(1,Math.floor(1/oi))),Vt&&kt&&xt<=Ae.stableFitRemainingWidth&&(ti=Ae.stableFitMaxMinimapScale),At=Math.min(ti,Math.max(1,Math.floor(_t/Et))),At>Pt&&(ui=Math.min(2,At/Pt)),ni=At/ut/ui,Ft=Math.ceil(Math.max(si,Wt+ii+Qt)*_t),Vt?(Ae.stableMinimapLayoutInput=de,Ae.stableFitRemainingWidth=xt,Ae.stableFitMaxMinimapScale=At):(Ae.stableMinimapLayoutInput=null,Ae.stableFitRemainingWidth=0)}}}const It=Math.floor(Zt*ni),Mt=Math.min(It,Math.max(0,Math.floor((xt-vt-2)*ni/(Bt+ni)))+e.MINIMAP_GUTTER_WIDTH);let Nt=Math.floor(ut*Mt);const Ut=Nt/ut;Nt=Math.floor(Nt*ui);const ri=it?he.Text:he.Blocks,ei=pt==="left"?0:Xe-Mt-vt;return{renderMinimap:ri,minimapLeft:ei,minimapWidth:Mt,minimapHeightIsEditorHeight:Gt,minimapIsSampling:xe,minimapScale:At,minimapLineHeight:_t,minimapCanvasInnerWidth:Nt,minimapCanvasInnerHeight:Ft,minimapCanvasOuterWidth:Ut,minimapCanvasOuterHeight:li}}static computeLayout(de,Ae){const Xe=Ae.outerWidth|0,_e=Ae.outerHeight|0,ut=Ae.lineHeight|0,gt=Ae.lineNumbersDigitCount|0,kt=Ae.typicalHalfwidthCharacterWidth,Lt=Ae.maxDigitWidth,Bt=Ae.pixelRatio,di=Ae.viewLineCount,it=de.get(Me.wordWrapOverride2),At=it==="inherit"?de.get(Me.wordWrapOverride1):it,Zt=At==="inherit"?de.get(Me.wordWrap):At,Kt=de.get(Me.wordWrapColumn),pt=Ae.isDominatedByLongLines,vt=de.get(Me.glyphMargin),ii=de.get(Me.lineNumbers).renderType!==Ue.Off,xt=de.get(Me.lineNumbersMinChars),Vt=de.get(Me.scrollBeyondLastLine),Et=de.get(Me.padding),Ft=de.get(Me.minimap),li=de.get(Me.scrollbar),Gt=li.verticalScrollbarSize,xe=li.verticalHasArrows,_t=li.arrowSize,ni=li.horizontalScrollbarSize,ui=de.get(Me.folding),It=de.get(Me.showFoldingControls)!=="never";let Mt=de.get(Me.lineDecorationsWidth);ui&&It&&(Mt+=16);let Nt=0;if(ii){const Ht=Math.max(gt,xt);Nt=Math.round(Ht*Lt)}let Ut=0;vt&&(Ut=ut*Ae.glyphMarginDecorationLaneCount);let ri=0,ei=ri+Ut,si=ei+Nt,Wt=si+Mt;const Qt=Xe-Ut-Nt-Mt;let oi=!1,Rt=!1,Dt=-1;At==="inherit"&&pt?(oi=!0,Rt=!0):Zt==="on"||Zt==="bounded"?Rt=!0:Zt==="wordWrapColumn"&&(Dt=Kt);const wt=ne.c({outerWidth:Xe,outerHeight:_e,lineHeight:ut,typicalHalfwidthCharacterWidth:kt,pixelRatio:Bt,scrollBeyondLastLine:Vt,paddingTop:Et.top,paddingBottom:Et.bottom,minimap:Ft,verticalScrollbarWidth:Gt,viewLineCount:di,remainingWidth:Qt,isViewportWrapping:Rt},Ae.memory||new k);wt.renderMinimap!==he.None&&wt.minimapLeft===0&&(ri+=wt.minimapWidth,ei+=wt.minimapWidth,si+=wt.minimapWidth,Wt+=wt.minimapWidth);const ti=Qt-wt.minimapWidth,Pt=Math.max(1,Math.floor((ti-Gt-2)/kt)),hi=xe?_t:0;return Rt&&(Dt=Math.max(1,Pt),Zt==="bounded"&&(Dt=Math.min(Dt,Kt))),{width:Xe,height:_e,glyphMarginLeft:ri,glyphMarginWidth:Ut,glyphMarginDecorationLaneCount:Ae.glyphMarginDecorationLaneCount,lineNumbersLeft:ei,lineNumbersWidth:Nt,decorationsLeft:si,decorationsWidth:Mt,contentLeft:Wt,contentWidth:ti,minimap:wt,viewportColumn:Pt,isWordWrapMinified:oi,isViewportWrapping:Rt,wrappingColumn:Dt,verticalScrollbarWidth:Gt,horizontalScrollbarHeight:ni,overviewRuler:{top:hi,width:Gt,height:_e-2*hi,right:0}}}}e.EditorLayoutInfoComputer=ne;class De extends p{constructor(){super(Me.wrappingStrategy,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[c.localize(47,null),c.localize(48,null)],type:"string",enum:["simple","advanced"],default:"simple",description:c.localize(49,null)}})}validate(de){return w(de,"simple",["simple","advanced"])}compute(de,Ae,Xe){return Ae.get(Me.accessibilitySupport)===I.AccessibilitySupport.Enabled?"advanced":Xe}}var $e;(function(Y){Y.Off="off",Y.OnCode="onCode",Y.On="on"})($e||(e.ShowLightbulbIconMode=$e={}));class K extends p{constructor(){const de={enabled:$e.On};super(Me.lightbulb,"lightbulb",de,{"editor.lightbulb.enabled":{type:"string",tags:["experimental"],enum:[$e.Off,$e.OnCode,$e.On],default:de.enabled,enumDescriptions:[c.localize(50,null),c.localize(51,null),c.localize(52,null)],description:c.localize(53,null)}})}validate(de){return!de||typeof de!="object"?this.defaultValue:{enabled:w(de.enabled,this.defaultValue.enabled,[$e.Off,$e.OnCode,$e.On])}}}class W extends p{constructor(){const de={enabled:!0,maxLineCount:5,defaultModel:"outlineModel",scrollWithEditor:!0};super(Me.stickyScroll,"stickyScroll",de,{"editor.stickyScroll.enabled":{type:"boolean",default:de.enabled,description:c.localize(54,null),tags:["experimental"]},"editor.stickyScroll.maxLineCount":{type:"number",default:de.maxLineCount,minimum:1,maximum:20,description:c.localize(55,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:de.defaultModel,description:c.localize(56,null)},"editor.stickyScroll.scrollWithEditor":{type:"boolean",default:de.scrollWithEditor,description:c.localize(57,null)}})}validate(de){if(!de||typeof de!="object")return this.defaultValue;const Ae=de;return{enabled:n(Ae.enabled,this.defaultValue.enabled),maxLineCount:i.clampedInt(Ae.maxLineCount,this.defaultValue.maxLineCount,1,20),defaultModel:w(Ae.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"]),scrollWithEditor:n(Ae.scrollWithEditor,this.defaultValue.scrollWithEditor)}}}class se extends p{constructor(){const de={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(Me.inlayHints,"inlayHints",de,{"editor.inlayHints.enabled":{type:"string",default:de.enabled,description:c.localize(58,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[c.localize(59,null),c.localize(60,null,P.$j?"Ctrl+Option":"Ctrl+Alt"),c.localize(61,null,P.$j?"Ctrl+Option":"Ctrl+Alt"),c.localize(62,null)]},"editor.inlayHints.fontSize":{type:"number",default:de.fontSize,markdownDescription:c.localize(63,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:de.fontFamily,markdownDescription:c.localize(64,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:de.padding,description:c.localize(65,null)}})}validate(de){if(!de||typeof de!="object")return this.defaultValue;const Ae=de;return typeof Ae.enabled=="boolean"&&(Ae.enabled=Ae.enabled?"on":"off"),{enabled:w(Ae.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:i.clampedInt(Ae.fontSize,this.defaultValue.fontSize,0,100),fontFamily:l.string(Ae.fontFamily,this.defaultValue.fontFamily),padding:n(Ae.padding,this.defaultValue.padding)}}}class oe extends p{constructor(){super(Me.lineDecorationsWidth,"lineDecorationsWidth",10)}validate(de){return typeof de=="string"&&/^\d+(\.\d+)?ch$/.test(de)?-parseFloat(de.substring(0,de.length-2)):i.clampedInt(de,this.defaultValue,0,1e3)}compute(de,Ae,Xe){return Xe<0?i.clampedInt(-Xe*de.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):Xe}}class te extends g{constructor(){super(Me.lineHeight,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,de=>g.clamp(de,0,150),{markdownDescription:c.localize(66,null)})}compute(de,Ae,Xe){return de.fontInfo.lineHeight}}class le extends p{constructor(){const de={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1,showRegionSectionHeaders:!0,showMarkSectionHeaders:!0,sectionHeaderFontSize:9,sectionHeaderLetterSpacing:1};super(Me.minimap,"minimap",de,{"editor.minimap.enabled":{type:"boolean",default:de.enabled,description:c.localize(67,null)},"editor.minimap.autohide":{type:"boolean",default:de.autohide,description:c.localize(68,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[c.localize(69,null),c.localize(70,null),c.localize(71,null)],default:de.size,description:c.localize(72,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:de.side,description:c.localize(73,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:de.showSlider,description:c.localize(74,null)},"editor.minimap.scale":{type:"number",default:de.scale,minimum:1,maximum:3,enum:[1,2,3],description:c.localize(75,null)},"editor.minimap.renderCharacters":{type:"boolean",default:de.renderCharacters,description:c.localize(76,null)},"editor.minimap.maxColumn":{type:"number",default:de.maxColumn,description:c.localize(77,null)},"editor.minimap.showRegionSectionHeaders":{type:"boolean",default:de.showRegionSectionHeaders,description:c.localize(78,null)},"editor.minimap.showMarkSectionHeaders":{type:"boolean",default:de.showMarkSectionHeaders,description:c.localize(79,null)},"editor.minimap.sectionHeaderFontSize":{type:"number",default:de.sectionHeaderFontSize,description:c.localize(80,null)},"editor.minimap.sectionHeaderLetterSpacing":{type:"number",default:de.sectionHeaderLetterSpacing,description:c.localize(81,null)}})}validate(de){if(!de||typeof de!="object")return this.defaultValue;const Ae=de;return{enabled:n(Ae.enabled,this.defaultValue.enabled),autohide:n(Ae.autohide,this.defaultValue.autohide),size:w(Ae.size,this.defaultValue.size,["proportional","fill","fit"]),side:w(Ae.side,this.defaultValue.side,["right","left"]),showSlider:w(Ae.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:n(Ae.renderCharacters,this.defaultValue.renderCharacters),scale:i.clampedInt(Ae.scale,1,1,3),maxColumn:i.clampedInt(Ae.maxColumn,this.defaultValue.maxColumn,1,1e4),showRegionSectionHeaders:n(Ae.showRegionSectionHeaders,this.defaultValue.showRegionSectionHeaders),showMarkSectionHeaders:n(Ae.showMarkSectionHeaders,this.defaultValue.showMarkSectionHeaders),sectionHeaderFontSize:g.clamp(Ae.sectionHeaderFontSize??this.defaultValue.sectionHeaderFontSize,4,32),sectionHeaderLetterSpacing:g.clamp(Ae.sectionHeaderLetterSpacing??this.defaultValue.sectionHeaderLetterSpacing,0,5)}}}function ue(Y){return Y==="ctrlCmd"?P.$j?"metaKey":"ctrlKey":"altKey"}class X extends p{constructor(){super(Me.padding,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:c.localize(82,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:c.localize(83,null)}})}validate(de){if(!de||typeof de!="object")return this.defaultValue;const Ae=de;return{top:i.clampedInt(Ae.top,0,0,1e3),bottom:i.clampedInt(Ae.bottom,0,0,1e3)}}}class ae extends p{constructor(){const de={enabled:!0,cycle:!0};super(Me.parameterHints,"parameterHints",de,{"editor.parameterHints.enabled":{type:"boolean",default:de.enabled,description:c.localize(84,null)},"editor.parameterHints.cycle":{type:"boolean",default:de.cycle,description:c.localize(85,null)}})}validate(de){if(!de||typeof de!="object")return this.defaultValue;const Ae=de;return{enabled:n(Ae.enabled,this.defaultValue.enabled),cycle:n(Ae.cycle,this.defaultValue.cycle)}}}class pe extends d{constructor(){super(Me.pixelRatio)}compute(de,Ae,Xe){return de.pixelRatio}}class be extends p{constructor(){super(Me.placeholder,"placeholder",void 0)}validate(de){return typeof de>"u"?this.defaultValue:typeof de=="string"?de:this.defaultValue}}class Fe extends p{constructor(){const de={other:"on",comments:"off",strings:"off"},Ae=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[c.localize(86,null),c.localize(87,null),c.localize(88,null)]}];super(Me.quickSuggestions,"quickSuggestions",de,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:Ae,default:de.strings,description:c.localize(89,null)},comments:{anyOf:Ae,default:de.comments,description:c.localize(90,null)},other:{anyOf:Ae,default:de.other,description:c.localize(91,null)}},default:de,markdownDescription:c.localize(92,null,"`#editor.suggestOnTriggerCharacters#`")}),this.defaultValue=de}validate(de){if(typeof de=="boolean"){const Bt=de?"on":"off";return{comments:Bt,strings:Bt,other:Bt}}if(!de||typeof de!="object")return this.defaultValue;const{other:Ae,comments:Xe,strings:_e}=de,ut=["on","inline","off"];let gt,kt,Lt;return typeof Ae=="boolean"?gt=Ae?"on":"off":gt=w(Ae,this.defaultValue.other,ut),typeof Xe=="boolean"?kt=Xe?"on":"off":kt=w(Xe,this.defaultValue.comments,ut),typeof _e=="boolean"?Lt=_e?"on":"off":Lt=w(_e,this.defaultValue.strings,ut),{other:gt,comments:kt,strings:Lt}}}var Ue;(function(Y){Y[Y.Off=0]="Off",Y[Y.On=1]="On",Y[Y.Relative=2]="Relative",Y[Y.Interval=3]="Interval",Y[Y.Custom=4]="Custom"})(Ue||(e.RenderLineNumbersType=Ue={}));class ke extends p{constructor(){super(Me.lineNumbers,"lineNumbers",{renderType:Ue.On,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[c.localize(93,null),c.localize(94,null),c.localize(95,null),c.localize(96,null)],default:"on",description:c.localize(97,null)})}validate(de){let Ae=this.defaultValue.renderType,Xe=this.defaultValue.renderFn;return typeof de<"u"&&(typeof de=="function"?(Ae=Ue.Custom,Xe=de):de==="interval"?Ae=Ue.Interval:de==="relative"?Ae=Ue.Relative:de==="on"?Ae=Ue.On:Ae=Ue.Off),{renderType:Ae,renderFn:Xe}}}function Ie(Y){const de=Y.get(Me.renderValidationDecorations);return de==="editable"?Y.get(Me.readOnly):de!=="on"}class Re extends p{constructor(){const de=[],Ae={type:"number",description:c.localize(98,null)};super(Me.rulers,"rulers",de,{type:"array",items:{anyOf:[Ae,{type:["object"],properties:{column:Ae,color:{type:"string",description:c.localize(99,null),format:"color-hex"}}}]},default:de,description:c.localize(100,null)})}validate(de){if(Array.isArray(de)){const Ae=[];for(const Xe of de)if(typeof Xe=="number")Ae.push({column:i.clampedInt(Xe,0,0,1e4),color:null});else if(Xe&&typeof Xe=="object"){const _e=Xe;Ae.push({column:i.clampedInt(_e.column,0,0,1e4),color:_e.color})}return Ae.sort((Xe,_e)=>Xe.column-_e.column),Ae}return this.defaultValue}}class q extends p{constructor(){super(Me.readOnlyMessage,"readOnlyMessage",void 0)}validate(de){return!de||typeof de!="object"?this.defaultValue:de}}function V(Y,de){if(typeof Y!="string")return de;switch(Y){case"hidden":return R.ScrollbarVisibility.Hidden;case"visible":return R.ScrollbarVisibility.Visible;default:return R.ScrollbarVisibility.Auto}}class J extends p{constructor(){const de={vertical:R.ScrollbarVisibility.Auto,horizontal:R.ScrollbarVisibility.Auto,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1,ignoreHorizontalScrollbarInContentHeight:!1};super(Me.scrollbar,"scrollbar",de,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[c.localize(101,null),c.localize(102,null),c.localize(103,null)],default:"auto",description:c.localize(104,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[c.localize(105,null),c.localize(106,null),c.localize(107,null)],default:"auto",description:c.localize(108,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:de.verticalScrollbarSize,description:c.localize(109,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:de.horizontalScrollbarSize,description:c.localize(110,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:de.scrollByPage,description:c.localize(111,null)},"editor.scrollbar.ignoreHorizontalScrollbarInContentHeight":{type:"boolean",default:de.ignoreHorizontalScrollbarInContentHeight,description:c.localize(112,null)}})}validate(de){if(!de||typeof de!="object")return this.defaultValue;const Ae=de,Xe=i.clampedInt(Ae.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),_e=i.clampedInt(Ae.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:i.clampedInt(Ae.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:V(Ae.vertical,this.defaultValue.vertical),horizontal:V(Ae.horizontal,this.defaultValue.horizontal),useShadows:n(Ae.useShadows,this.defaultValue.useShadows),verticalHasArrows:n(Ae.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:n(Ae.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:n(Ae.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:n(Ae.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Xe,horizontalSliderSize:i.clampedInt(Ae.horizontalSliderSize,Xe,0,1e3),verticalScrollbarSize:_e,verticalSliderSize:i.clampedInt(Ae.verticalSliderSize,_e,0,1e3),scrollByPage:n(Ae.scrollByPage,this.defaultValue.scrollByPage),ignoreHorizontalScrollbarInContentHeight:n(Ae.ignoreHorizontalScrollbarInContentHeight,this.defaultValue.ignoreHorizontalScrollbarInContentHeight)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class x extends p{constructor(){const de={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(Me.unicodeHighlighting,"unicodeHighlight",de,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:de.nonBasicASCII,description:c.localize(113,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:de.invisibleCharacters,description:c.localize(114,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:de.ambiguousCharacters,description:c.localize(115,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:de.includeComments,description:c.localize(116,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:de.includeStrings,description:c.localize(117,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:de.allowedCharacters,description:c.localize(118,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:de.allowedLocales,description:c.localize(119,null)}})}applyUpdate(de,Ae){let Xe=!1;Ae.allowedCharacters&&de&&(h.$fo(de.allowedCharacters,Ae.allowedCharacters)||(de={...de,allowedCharacters:Ae.allowedCharacters},Xe=!0)),Ae.allowedLocales&&de&&(h.$fo(de.allowedLocales,Ae.allowedLocales)||(de={...de,allowedLocales:Ae.allowedLocales},Xe=!0));const _e=super.applyUpdate(de,Ae);return Xe?new a(_e.newValue,!0):_e}validate(de){if(!de||typeof de!="object")return this.defaultValue;const Ae=de;return{nonBasicASCII:Ke(Ae.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:n(Ae.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:n(Ae.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:Ke(Ae.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:Ke(Ae.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(de.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(de.allowedLocales,this.defaultValue.allowedLocales)}}c(de,Ae){if(typeof de!="object"||!de)return Ae;const Xe={};for(const[_e,ut]of Object.entries(de))ut===!0&&(Xe[_e]=!0);return Xe}}class fe extends p{constructor(){const de={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1,fontFamily:"default"};super(Me.inlineSuggest,"inlineSuggest",de,{"editor.inlineSuggest.enabled":{type:"boolean",default:de.enabled,description:c.localize(120,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:de.showToolbar,enum:["always","onHover","never"],enumDescriptions:[c.localize(121,null),c.localize(122,null),c.localize(123,null)],description:c.localize(124,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:de.suppressSuggestions,description:c.localize(125,null)},"editor.inlineSuggest.fontFamily":{type:"string",default:de.fontFamily,description:c.localize(126,null)}})}validate(de){if(!de||typeof de!="object")return this.defaultValue;const Ae=de;return{enabled:n(Ae.enabled,this.defaultValue.enabled),mode:w(Ae.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:w(Ae.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),suppressSuggestions:n(Ae.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:n(Ae.keepOnBlur,this.defaultValue.keepOnBlur),fontFamily:l.string(Ae.fontFamily,this.defaultValue.fontFamily)}}}class we extends p{constructor(){const de={enabled:!1,showToolbar:"onHover",fontFamily:"default",keepOnBlur:!1,backgroundColoring:!1};super(Me.inlineEdit,"experimentalInlineEdit",de,{"editor.experimentalInlineEdit.enabled":{type:"boolean",default:de.enabled,description:c.localize(127,null)},"editor.experimentalInlineEdit.showToolbar":{type:"string",default:de.showToolbar,enum:["always","onHover","never"],enumDescriptions:[c.localize(128,null),c.localize(129,null),c.localize(130,null)],description:c.localize(131,null)},"editor.experimentalInlineEdit.fontFamily":{type:"string",default:de.fontFamily,description:c.localize(132,null)},"editor.experimentalInlineEdit.backgroundColoring":{type:"boolean",default:de.backgroundColoring,description:c.localize(133,null)}})}validate(de){if(!de||typeof de!="object")return this.defaultValue;const Ae=de;return{enabled:n(Ae.enabled,this.defaultValue.enabled),showToolbar:w(Ae.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),fontFamily:l.string(Ae.fontFamily,this.defaultValue.fontFamily),keepOnBlur:n(Ae.keepOnBlur,this.defaultValue.keepOnBlur),backgroundColoring:n(Ae.backgroundColoring,this.defaultValue.backgroundColoring)}}}class Le extends p{constructor(){const de={enabled:N.$et.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:N.$et.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(Me.bracketPairColorization,"bracketPairColorization",de,{"editor.bracketPairColorization.enabled":{type:"boolean",default:de.enabled,markdownDescription:c.localize(134,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:de.independentColorPoolPerBracketType,description:c.localize(135,null)}})}validate(de){if(!de||typeof de!="object")return this.defaultValue;const Ae=de;return{enabled:n(Ae.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:n(Ae.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class He extends p{constructor(){const de={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(Me.guides,"guides",de,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[c.localize(136,null),c.localize(137,null),c.localize(138,null)],default:de.bracketPairs,description:c.localize(139,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[c.localize(140,null),c.localize(141,null),c.localize(142,null)],default:de.bracketPairsHorizontal,description:c.localize(143,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:de.highlightActiveBracketPair,description:c.localize(144,null)},"editor.guides.indentation":{type:"boolean",default:de.indentation,description:c.localize(145,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[c.localize(146,null),c.localize(147,null),c.localize(148,null)],default:de.highlightActiveIndentation,description:c.localize(149,null)}})}validate(de){if(!de||typeof de!="object")return this.defaultValue;const Ae=de;return{bracketPairs:Ke(Ae.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:Ke(Ae.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:n(Ae.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:n(Ae.indentation,this.defaultValue.indentation),highlightActiveIndentation:Ke(Ae.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function Ke(Y,de,Ae){const Xe=Ae.indexOf(Y);return Xe===-1?de:Ae[Xe]}class et extends p{constructor(){const de={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(Me.suggest,"suggest",de,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[c.localize(150,null),c.localize(151,null)],default:de.insertMode,description:c.localize(152,null)},"editor.suggest.filterGraceful":{type:"boolean",default:de.filterGraceful,description:c.localize(153,null)},"editor.suggest.localityBonus":{type:"boolean",default:de.localityBonus,description:c.localize(154,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:de.shareSuggestSelections,markdownDescription:c.localize(155,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[c.localize(156,null),c.localize(157,null),c.localize(158,null),c.localize(159,null)],default:de.selectionMode,markdownDescription:c.localize(160,null,"`#editor.quickSuggestions#`","`#editor.suggestOnTriggerCharacters#`")},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:de.snippetsPreventQuickSuggestions,description:c.localize(161,null)},"editor.suggest.showIcons":{type:"boolean",default:de.showIcons,description:c.localize(162,null)},"editor.suggest.showStatusBar":{type:"boolean",default:de.showStatusBar,description:c.localize(163,null)},"editor.suggest.preview":{type:"boolean",default:de.preview,description:c.localize(164,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:de.showInlineDetails,description:c.localize(165,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:c.localize(166,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:c.localize(167,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:c.localize(168,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:c.localize(169,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:c.localize(170,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:c.localize(171,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:c.localize(172,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:c.localize(173,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:c.localize(174,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:c.localize(175,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:c.localize(176,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:c.localize(177,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:c.localize(178,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:c.localize(179,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:c.localize(180,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:c.localize(181,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:c.localize(182,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:c.localize(183,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:c.localize(184,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:c.localize(185,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:c.localize(186,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:c.localize(187,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:c.localize(188,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:c.localize(189,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:c.localize(190,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:c.localize(191,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:c.localize(192,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:c.localize(193,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:c.localize(194,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:c.localize(195,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:c.localize(196,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:c.localize(197,null)}})}validate(de){if(!de||typeof de!="object")return this.defaultValue;const Ae=de;return{insertMode:w(Ae.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:n(Ae.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:n(Ae.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:n(Ae.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:n(Ae.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:w(Ae.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:n(Ae.showIcons,this.defaultValue.showIcons),showStatusBar:n(Ae.showStatusBar,this.defaultValue.showStatusBar),preview:n(Ae.preview,this.defaultValue.preview),previewMode:w(Ae.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:n(Ae.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:n(Ae.showMethods,this.defaultValue.showMethods),showFunctions:n(Ae.showFunctions,this.defaultValue.showFunctions),showConstructors:n(Ae.showConstructors,this.defaultValue.showConstructors),showDeprecated:n(Ae.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:n(Ae.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:n(Ae.showFields,this.defaultValue.showFields),showVariables:n(Ae.showVariables,this.defaultValue.showVariables),showClasses:n(Ae.showClasses,this.defaultValue.showClasses),showStructs:n(Ae.showStructs,this.defaultValue.showStructs),showInterfaces:n(Ae.showInterfaces,this.defaultValue.showInterfaces),showModules:n(Ae.showModules,this.defaultValue.showModules),showProperties:n(Ae.showProperties,this.defaultValue.showProperties),showEvents:n(Ae.showEvents,this.defaultValue.showEvents),showOperators:n(Ae.showOperators,this.defaultValue.showOperators),showUnits:n(Ae.showUnits,this.defaultValue.showUnits),showValues:n(Ae.showValues,this.defaultValue.showValues),showConstants:n(Ae.showConstants,this.defaultValue.showConstants),showEnums:n(Ae.showEnums,this.defaultValue.showEnums),showEnumMembers:n(Ae.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:n(Ae.showKeywords,this.defaultValue.showKeywords),showWords:n(Ae.showWords,this.defaultValue.showWords),showColors:n(Ae.showColors,this.defaultValue.showColors),showFiles:n(Ae.showFiles,this.defaultValue.showFiles),showReferences:n(Ae.showReferences,this.defaultValue.showReferences),showFolders:n(Ae.showFolders,this.defaultValue.showFolders),showTypeParameters:n(Ae.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:n(Ae.showSnippets,this.defaultValue.showSnippets),showUsers:n(Ae.showUsers,this.defaultValue.showUsers),showIssues:n(Ae.showIssues,this.defaultValue.showIssues)}}}class rt extends p{constructor(){super(Me.smartSelect,"smartSelect",{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:c.localize(198,null),default:!0,type:"boolean"},"editor.smartSelect.selectSubwords":{description:c.localize(199,null),default:!0,type:"boolean"}})}validate(de){return!de||typeof de!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:n(de.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace),selectSubwords:n(de.selectSubwords,this.defaultValue.selectSubwords)}}}class ot extends p{constructor(){const de=[];super(Me.wordSegmenterLocales,"wordSegmenterLocales",de,{anyOf:[{description:c.localize(200,null),type:"string"},{description:c.localize(201,null),type:"array",items:{type:"string"}}]})}validate(de){if(typeof de=="string"&&(de=[de]),Array.isArray(de)){const Ae=[];for(const Xe of de)if(typeof Xe=="string")try{Intl.Segmenter.supportedLocalesOf(Xe).length>0&&Ae.push(Xe)}catch{}return Ae}return this.defaultValue}}var nt;(function(Y){Y[Y.None=0]="None",Y[Y.Same=1]="Same",Y[Y.Indent=2]="Indent",Y[Y.DeepIndent=3]="DeepIndent"})(nt||(e.WrappingIndent=nt={}));class ct extends p{constructor(){super(Me.wrappingIndent,"wrappingIndent",nt.Same,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[c.localize(202,null),c.localize(203,null),c.localize(204,null),c.localize(205,null)],description:c.localize(206,null),default:"same"}})}validate(de){switch(de){case"none":return nt.None;case"same":return nt.Same;case"indent":return nt.Indent;case"deepIndent":return nt.DeepIndent}return nt.Same}compute(de,Ae,Xe){return Ae.get(Me.accessibilitySupport)===I.AccessibilitySupport.Enabled?nt.None:Xe}}class mt extends d{constructor(){super(Me.wrappingInfo)}compute(de,Ae,Xe){const _e=Ae.get(Me.layoutInfo);return{isDominatedByLongLines:de.isDominatedByLongLines,isWordWrapMinified:_e.isWordWrapMinified,isViewportWrapping:_e.isViewportWrapping,wrappingColumn:_e.wrappingColumn}}}class dt extends p{constructor(){const de={enabled:!0,showDropSelector:"afterDrop"};super(Me.dropIntoEditor,"dropIntoEditor",de,{"editor.dropIntoEditor.enabled":{type:"boolean",default:de.enabled,markdownDescription:c.localize(207,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:c.localize(208,null),enum:["afterDrop","never"],enumDescriptions:[c.localize(209,null),c.localize(210,null)],default:"afterDrop"}})}validate(de){if(!de||typeof de!="object")return this.defaultValue;const Ae=de;return{enabled:n(Ae.enabled,this.defaultValue.enabled),showDropSelector:w(Ae.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class at extends p{constructor(){const de={enabled:!0,showPasteSelector:"afterPaste"};super(Me.pasteAs,"pasteAs",de,{"editor.pasteAs.enabled":{type:"boolean",default:de.enabled,markdownDescription:c.localize(211,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:c.localize(212,null),enum:["afterPaste","never"],enumDescriptions:[c.localize(213,null),c.localize(214,null)],default:"afterPaste"}})}validate(de){if(!de||typeof de!="object")return this.defaultValue;const Ae=de;return{enabled:n(Ae.enabled,this.defaultValue.enabled),showPasteSelector:w(Ae.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const Pe="Consolas, 'Courier New', monospace",ze="Menlo, Monaco, 'Courier New', monospace",Ze="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:P.$j?ze:P.$k?Ze:Pe,fontWeight:"normal",fontSize:P.$j?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Te(Y){return e.editorOptionsRegistry[Y.id]=Y,Y}var Me;(function(Y){Y[Y.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",Y[Y.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",Y[Y.accessibilitySupport=2]="accessibilitySupport",Y[Y.accessibilityPageSize=3]="accessibilityPageSize",Y[Y.ariaLabel=4]="ariaLabel",Y[Y.ariaRequired=5]="ariaRequired",Y[Y.autoClosingBrackets=6]="autoClosingBrackets",Y[Y.autoClosingComments=7]="autoClosingComments",Y[Y.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",Y[Y.autoClosingDelete=9]="autoClosingDelete",Y[Y.autoClosingOvertype=10]="autoClosingOvertype",Y[Y.autoClosingQuotes=11]="autoClosingQuotes",Y[Y.autoIndent=12]="autoIndent",Y[Y.automaticLayout=13]="automaticLayout",Y[Y.autoSurround=14]="autoSurround",Y[Y.bracketPairColorization=15]="bracketPairColorization",Y[Y.guides=16]="guides",Y[Y.codeLens=17]="codeLens",Y[Y.codeLensFontFamily=18]="codeLensFontFamily",Y[Y.codeLensFontSize=19]="codeLensFontSize",Y[Y.colorDecorators=20]="colorDecorators",Y[Y.colorDecoratorsLimit=21]="colorDecoratorsLimit",Y[Y.columnSelection=22]="columnSelection",Y[Y.comments=23]="comments",Y[Y.contextmenu=24]="contextmenu",Y[Y.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",Y[Y.cursorBlinking=26]="cursorBlinking",Y[Y.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",Y[Y.cursorStyle=28]="cursorStyle",Y[Y.cursorSurroundingLines=29]="cursorSurroundingLines",Y[Y.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",Y[Y.cursorWidth=31]="cursorWidth",Y[Y.disableLayerHinting=32]="disableLayerHinting",Y[Y.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",Y[Y.domReadOnly=34]="domReadOnly",Y[Y.dragAndDrop=35]="dragAndDrop",Y[Y.dropIntoEditor=36]="dropIntoEditor",Y[Y.emptySelectionClipboard=37]="emptySelectionClipboard",Y[Y.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",Y[Y.extraEditorClassName=39]="extraEditorClassName",Y[Y.fastScrollSensitivity=40]="fastScrollSensitivity",Y[Y.find=41]="find",Y[Y.fixedOverflowWidgets=42]="fixedOverflowWidgets",Y[Y.folding=43]="folding",Y[Y.foldingStrategy=44]="foldingStrategy",Y[Y.foldingHighlight=45]="foldingHighlight",Y[Y.foldingImportsByDefault=46]="foldingImportsByDefault",Y[Y.foldingMaximumRegions=47]="foldingMaximumRegions",Y[Y.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",Y[Y.fontFamily=49]="fontFamily",Y[Y.fontInfo=50]="fontInfo",Y[Y.fontLigatures=51]="fontLigatures",Y[Y.fontSize=52]="fontSize",Y[Y.fontWeight=53]="fontWeight",Y[Y.fontVariations=54]="fontVariations",Y[Y.formatOnPaste=55]="formatOnPaste",Y[Y.formatOnType=56]="formatOnType",Y[Y.glyphMargin=57]="glyphMargin",Y[Y.gotoLocation=58]="gotoLocation",Y[Y.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",Y[Y.hover=60]="hover",Y[Y.inDiffEditor=61]="inDiffEditor",Y[Y.inlineSuggest=62]="inlineSuggest",Y[Y.inlineEdit=63]="inlineEdit",Y[Y.letterSpacing=64]="letterSpacing",Y[Y.lightbulb=65]="lightbulb",Y[Y.lineDecorationsWidth=66]="lineDecorationsWidth",Y[Y.lineHeight=67]="lineHeight",Y[Y.lineNumbers=68]="lineNumbers",Y[Y.lineNumbersMinChars=69]="lineNumbersMinChars",Y[Y.linkedEditing=70]="linkedEditing",Y[Y.links=71]="links",Y[Y.matchBrackets=72]="matchBrackets",Y[Y.minimap=73]="minimap",Y[Y.mouseStyle=74]="mouseStyle",Y[Y.mouseWheelScrollSensitivity=75]="mouseWheelScrollSensitivity",Y[Y.mouseWheelZoom=76]="mouseWheelZoom",Y[Y.multiCursorMergeOverlapping=77]="multiCursorMergeOverlapping",Y[Y.multiCursorModifier=78]="multiCursorModifier",Y[Y.multiCursorPaste=79]="multiCursorPaste",Y[Y.multiCursorLimit=80]="multiCursorLimit",Y[Y.occurrencesHighlight=81]="occurrencesHighlight",Y[Y.overviewRulerBorder=82]="overviewRulerBorder",Y[Y.overviewRulerLanes=83]="overviewRulerLanes",Y[Y.padding=84]="padding",Y[Y.pasteAs=85]="pasteAs",Y[Y.parameterHints=86]="parameterHints",Y[Y.peekWidgetDefaultFocus=87]="peekWidgetDefaultFocus",Y[Y.placeholder=88]="placeholder",Y[Y.definitionLinkOpensInPeek=89]="definitionLinkOpensInPeek",Y[Y.quickSuggestions=90]="quickSuggestions",Y[Y.quickSuggestionsDelay=91]="quickSuggestionsDelay",Y[Y.readOnly=92]="readOnly",Y[Y.readOnlyMessage=93]="readOnlyMessage",Y[Y.renameOnType=94]="renameOnType",Y[Y.renderControlCharacters=95]="renderControlCharacters",Y[Y.renderFinalNewline=96]="renderFinalNewline",Y[Y.renderLineHighlight=97]="renderLineHighlight",Y[Y.renderLineHighlightOnlyWhenFocus=98]="renderLineHighlightOnlyWhenFocus",Y[Y.renderValidationDecorations=99]="renderValidationDecorations",Y[Y.renderWhitespace=100]="renderWhitespace",Y[Y.revealHorizontalRightPadding=101]="revealHorizontalRightPadding",Y[Y.roundedSelection=102]="roundedSelection",Y[Y.rulers=103]="rulers",Y[Y.scrollbar=104]="scrollbar",Y[Y.scrollBeyondLastColumn=105]="scrollBeyondLastColumn",Y[Y.scrollBeyondLastLine=106]="scrollBeyondLastLine",Y[Y.scrollPredominantAxis=107]="scrollPredominantAxis",Y[Y.selectionClipboard=108]="selectionClipboard",Y[Y.selectionHighlight=109]="selectionHighlight",Y[Y.selectOnLineNumbers=110]="selectOnLineNumbers",Y[Y.showFoldingControls=111]="showFoldingControls",Y[Y.showUnused=112]="showUnused",Y[Y.snippetSuggestions=113]="snippetSuggestions",Y[Y.smartSelect=114]="smartSelect",Y[Y.smoothScrolling=115]="smoothScrolling",Y[Y.stickyScroll=116]="stickyScroll",Y[Y.stickyTabStops=117]="stickyTabStops",Y[Y.stopRenderingLineAfter=118]="stopRenderingLineAfter",Y[Y.suggest=119]="suggest",Y[Y.suggestFontSize=120]="suggestFontSize",Y[Y.suggestLineHeight=121]="suggestLineHeight",Y[Y.suggestOnTriggerCharacters=122]="suggestOnTriggerCharacters",Y[Y.suggestSelection=123]="suggestSelection",Y[Y.tabCompletion=124]="tabCompletion",Y[Y.tabIndex=125]="tabIndex",Y[Y.unicodeHighlighting=126]="unicodeHighlighting",Y[Y.unusualLineTerminators=127]="unusualLineTerminators",Y[Y.useShadowDOM=128]="useShadowDOM",Y[Y.useTabStops=129]="useTabStops",Y[Y.wordBreak=130]="wordBreak",Y[Y.wordSegmenterLocales=131]="wordSegmenterLocales",Y[Y.wordSeparators=132]="wordSeparators",Y[Y.wordWrap=133]="wordWrap",Y[Y.wordWrapBreakAfterCharacters=134]="wordWrapBreakAfterCharacters",Y[Y.wordWrapBreakBeforeCharacters=135]="wordWrapBreakBeforeCharacters",Y[Y.wordWrapColumn=136]="wordWrapColumn",Y[Y.wordWrapOverride1=137]="wordWrapOverride1",Y[Y.wordWrapOverride2=138]="wordWrapOverride2",Y[Y.wrappingIndent=139]="wrappingIndent",Y[Y.wrappingStrategy=140]="wrappingStrategy",Y[Y.showDeprecated=141]="showDeprecated",Y[Y.inlayHints=142]="inlayHints",Y[Y.editorClassName=143]="editorClassName",Y[Y.pixelRatio=144]="pixelRatio",Y[Y.tabFocusMode=145]="tabFocusMode",Y[Y.layoutInfo=146]="layoutInfo",Y[Y.wrappingInfo=147]="wrappingInfo",Y[Y.defaultColorDecorators=148]="defaultColorDecorators",Y[Y.colorDecoratorsActivatedOn=149]="colorDecoratorsActivatedOn",Y[Y.inlineCompletionsAccessibilityVerbose=150]="inlineCompletionsAccessibilityVerbose"})(Me||(e.EditorOption=Me={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Te(new o(Me.acceptSuggestionOnCommitCharacter,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:c.localize(215,null)})),acceptSuggestionOnEnter:Te(new S(Me.acceptSuggestionOnEnter,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",c.localize(216,null),""],markdownDescription:c.localize(217,null)})),accessibilitySupport:Te(new C),accessibilityPageSize:Te(new i(Me.accessibilityPageSize,"accessibilityPageSize",10,1,T.Constants.MAX_SAFE_SMALL_INTEGER,{description:c.localize(218,null),tags:["accessibility"]})),ariaLabel:Te(new l(Me.ariaLabel,"ariaLabel",c.localize(219,null))),ariaRequired:Te(new o(Me.ariaRequired,"ariaRequired",!1,void 0)),screenReaderAnnounceInlineSuggestion:Te(new o(Me.screenReaderAnnounceInlineSuggestion,"screenReaderAnnounceInlineSuggestion",!0,{description:c.localize(220,null),tags:["accessibility"]})),autoClosingBrackets:Te(new S(Me.autoClosingBrackets,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",c.localize(221,null),c.localize(222,null),""],description:c.localize(223,null)})),autoClosingComments:Te(new S(Me.autoClosingComments,"autoClosingComments","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",c.localize(224,null),c.localize(225,null),""],description:c.localize(226,null)})),autoClosingDelete:Te(new S(Me.autoClosingDelete,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",c.localize(227,null),""],description:c.localize(228,null)})),autoClosingOvertype:Te(new S(Me.autoClosingOvertype,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",c.localize(229,null),""],description:c.localize(230,null)})),autoClosingQuotes:Te(new S(Me.autoClosingQuotes,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",c.localize(231,null),c.localize(232,null),""],description:c.localize(233,null)})),autoIndent:Te(new D(Me.autoIndent,"autoIndent",E.Full,"full",["none","keep","brackets","advanced","full"],y,{enumDescriptions:[c.localize(234,null),c.localize(235,null),c.localize(236,null),c.localize(237,null),c.localize(238,null)],description:c.localize(239,null)})),automaticLayout:Te(new o(Me.automaticLayout,"automaticLayout",!1)),autoSurround:Te(new S(Me.autoSurround,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[c.localize(240,null),c.localize(241,null),c.localize(242,null),""],description:c.localize(243,null)})),bracketPairColorization:Te(new Le),bracketPairGuides:Te(new He),stickyTabStops:Te(new o(Me.stickyTabStops,"stickyTabStops",!1,{description:c.localize(244,null)})),codeLens:Te(new o(Me.codeLens,"codeLens",!0,{description:c.localize(245,null)})),codeLensFontFamily:Te(new l(Me.codeLensFontFamily,"codeLensFontFamily","",{description:c.localize(246,null)})),codeLensFontSize:Te(new i(Me.codeLensFontSize,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:c.localize(247,null)})),colorDecorators:Te(new o(Me.colorDecorators,"colorDecorators",!0,{description:c.localize(248,null)})),colorDecoratorActivatedOn:Te(new S(Me.colorDecoratorsActivatedOn,"colorDecoratorsActivatedOn","clickAndHover",["clickAndHover","hover","click"],{enumDescriptions:[c.localize(249,null),c.localize(250,null),c.localize(251,null)],description:c.localize(252,null)})),colorDecoratorsLimit:Te(new i(Me.colorDecoratorsLimit,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:c.localize(253,null)})),columnSelection:Te(new o(Me.columnSelection,"columnSelection",!1,{description:c.localize(254,null)})),comments:Te(new A),contextmenu:Te(new o(Me.contextmenu,"contextmenu",!0)),copyWithSyntaxHighlighting:Te(new o(Me.copyWithSyntaxHighlighting,"copyWithSyntaxHighlighting",!0,{description:c.localize(255,null)})),cursorBlinking:Te(new D(Me.cursorBlinking,"cursorBlinking",b.Blink,"blink",["blink","smooth","phase","expand","solid"],v,{description:c.localize(256,null)})),cursorSmoothCaretAnimation:Te(new S(Me.cursorSmoothCaretAnimation,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[c.localize(257,null),c.localize(258,null),c.localize(259,null)],description:c.localize(260,null)})),cursorStyle:Te(new D(Me.cursorStyle,"cursorStyle",L.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],M,{description:c.localize(261,null)})),cursorSurroundingLines:Te(new i(Me.cursorSurroundingLines,"cursorSurroundingLines",0,0,T.Constants.MAX_SAFE_SMALL_INTEGER,{description:c.localize(262,null)})),cursorSurroundingLinesStyle:Te(new S(Me.cursorSurroundingLinesStyle,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[c.localize(263,null),c.localize(264,null)],markdownDescription:c.localize(265,null)})),cursorWidth:Te(new i(Me.cursorWidth,"cursorWidth",0,0,T.Constants.MAX_SAFE_SMALL_INTEGER,{markdownDescription:c.localize(266,null)})),disableLayerHinting:Te(new o(Me.disableLayerHinting,"disableLayerHinting",!1)),disableMonospaceOptimizations:Te(new o(Me.disableMonospaceOptimizations,"disableMonospaceOptimizations",!1)),domReadOnly:Te(new o(Me.domReadOnly,"domReadOnly",!1)),dragAndDrop:Te(new o(Me.dragAndDrop,"dragAndDrop",!0,{description:c.localize(267,null)})),emptySelectionClipboard:Te(new z),dropIntoEditor:Te(new dt),stickyScroll:Te(new W),experimentalWhitespaceRendering:Te(new S(Me.experimentalWhitespaceRendering,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[c.localize(268,null),c.localize(269,null),c.localize(270,null)],description:c.localize(271,null)})),extraEditorClassName:Te(new l(Me.extraEditorClassName,"extraEditorClassName","")),fastScrollSensitivity:Te(new g(Me.fastScrollSensitivity,"fastScrollSensitivity",5,Y=>Y<=0?5:Y,{markdownDescription:c.localize(272,null)})),find:Te(new F),fixedOverflowWidgets:Te(new o(Me.fixedOverflowWidgets,"fixedOverflowWidgets",!1)),folding:Te(new o(Me.folding,"folding",!0,{description:c.localize(273,null)})),foldingStrategy:Te(new S(Me.foldingStrategy,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[c.localize(274,null),c.localize(275,null)],description:c.localize(276,null)})),foldingHighlight:Te(new o(Me.foldingHighlight,"foldingHighlight",!0,{description:c.localize(277,null)})),foldingImportsByDefault:Te(new o(Me.foldingImportsByDefault,"foldingImportsByDefault",!1,{description:c.localize(278,null)})),foldingMaximumRegions:Te(new i(Me.foldingMaximumRegions,"foldingMaximumRegions",5e3,10,65e3,{description:c.localize(279,null)})),unfoldOnClickAfterEndOfLine:Te(new o(Me.unfoldOnClickAfterEndOfLine,"unfoldOnClickAfterEndOfLine",!1,{description:c.localize(280,null)})),fontFamily:Te(new l(Me.fontFamily,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:c.localize(281,null)})),fontInfo:Te(new re),fontLigatures2:Te(new B),fontSize:Te(new U),fontWeight:Te(new G),fontVariations:Te(new _),formatOnPaste:Te(new o(Me.formatOnPaste,"formatOnPaste",!1,{description:c.localize(282,null)})),formatOnType:Te(new o(Me.formatOnType,"formatOnType",!1,{description:c.localize(283,null)})),glyphMargin:Te(new o(Me.glyphMargin,"glyphMargin",!0,{description:c.localize(284,null)})),gotoLocation:Te(new Q),hideCursorInOverviewRuler:Te(new o(Me.hideCursorInOverviewRuler,"hideCursorInOverviewRuler",!1,{description:c.localize(285,null)})),hover:Te(new ee),inDiffEditor:Te(new o(Me.inDiffEditor,"inDiffEditor",!1)),letterSpacing:Te(new g(Me.letterSpacing,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,Y=>g.clamp(Y,-5,20),{description:c.localize(286,null)})),lightbulb:Te(new K),lineDecorationsWidth:Te(new oe),lineHeight:Te(new te),lineNumbers:Te(new ke),lineNumbersMinChars:Te(new i(Me.lineNumbersMinChars,"lineNumbersMinChars",5,1,300)),linkedEditing:Te(new o(Me.linkedEditing,"linkedEditing",!1,{description:c.localize(287,null)})),links:Te(new o(Me.links,"links",!0,{description:c.localize(288,null)})),matchBrackets:Te(new S(Me.matchBrackets,"matchBrackets","always",["always","near","never"],{description:c.localize(289,null)})),minimap:Te(new le),mouseStyle:Te(new S(Me.mouseStyle,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Te(new g(Me.mouseWheelScrollSensitivity,"mouseWheelScrollSensitivity",1,Y=>Y===0?1:Y,{markdownDescription:c.localize(290,null)})),mouseWheelZoom:Te(new o(Me.mouseWheelZoom,"mouseWheelZoom",!1,{markdownDescription:P.$j?c.localize(291,null):c.localize(292,null)})),multiCursorMergeOverlapping:Te(new o(Me.multiCursorMergeOverlapping,"multiCursorMergeOverlapping",!0,{description:c.localize(293,null)})),multiCursorModifier:Te(new D(Me.multiCursorModifier,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],ue,{markdownEnumDescriptions:[c.localize(294,null),c.localize(295,null)],markdownDescription:c.localize(296,null)})),multiCursorPaste:Te(new S(Me.multiCursorPaste,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[c.localize(297,null),c.localize(298,null)],markdownDescription:c.localize(299,null)})),multiCursorLimit:Te(new i(Me.multiCursorLimit,"multiCursorLimit",1e4,1,1e5,{markdownDescription:c.localize(300,null)})),occurrencesHighlight:Te(new S(Me.occurrencesHighlight,"occurrencesHighlight","singleFile",["off","singleFile","multiFile"],{markdownEnumDescriptions:[c.localize(301,null),c.localize(302,null),c.localize(303,null)],markdownDescription:c.localize(304,null)})),overviewRulerBorder:Te(new o(Me.overviewRulerBorder,"overviewRulerBorder",!0,{description:c.localize(305,null)})),overviewRulerLanes:Te(new i(Me.overviewRulerLanes,"overviewRulerLanes",3,0,3)),padding:Te(new X),pasteAs:Te(new at),parameterHints:Te(new ae),peekWidgetDefaultFocus:Te(new S(Me.peekWidgetDefaultFocus,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[c.localize(306,null),c.localize(307,null)],description:c.localize(308,null)})),placeholder:Te(new be),definitionLinkOpensInPeek:Te(new o(Me.definitionLinkOpensInPeek,"definitionLinkOpensInPeek",!1,{description:c.localize(309,null)})),quickSuggestions:Te(new Fe),quickSuggestionsDelay:Te(new i(Me.quickSuggestionsDelay,"quickSuggestionsDelay",10,0,T.Constants.MAX_SAFE_SMALL_INTEGER,{description:c.localize(310,null)})),readOnly:Te(new o(Me.readOnly,"readOnly",!1)),readOnlyMessage:Te(new q),renameOnType:Te(new o(Me.renameOnType,"renameOnType",!1,{description:c.localize(311,null),markdownDeprecationMessage:c.localize(312,null)})),renderControlCharacters:Te(new o(Me.renderControlCharacters,"renderControlCharacters",!0,{description:c.localize(313,null),restricted:!0})),renderFinalNewline:Te(new S(Me.renderFinalNewline,"renderFinalNewline",P.$k?"dimmed":"on",["off","on","dimmed"],{description:c.localize(314,null)})),renderLineHighlight:Te(new S(Me.renderLineHighlight,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",c.localize(315,null)],description:c.localize(316,null)})),renderLineHighlightOnlyWhenFocus:Te(new o(Me.renderLineHighlightOnlyWhenFocus,"renderLineHighlightOnlyWhenFocus",!1,{description:c.localize(317,null)})),renderValidationDecorations:Te(new S(Me.renderValidationDecorations,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Te(new S(Me.renderWhitespace,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",c.localize(318,null),c.localize(319,null),c.localize(320,null),""],description:c.localize(321,null)})),revealHorizontalRightPadding:Te(new i(Me.revealHorizontalRightPadding,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:Te(new o(Me.roundedSelection,"roundedSelection",!0,{description:c.localize(322,null)})),rulers:Te(new Re),scrollbar:Te(new J),scrollBeyondLastColumn:Te(new i(Me.scrollBeyondLastColumn,"scrollBeyondLastColumn",4,0,T.Constants.MAX_SAFE_SMALL_INTEGER,{description:c.localize(323,null)})),scrollBeyondLastLine:Te(new o(Me.scrollBeyondLastLine,"scrollBeyondLastLine",!0,{description:c.localize(324,null)})),scrollPredominantAxis:Te(new o(Me.scrollPredominantAxis,"scrollPredominantAxis",!0,{description:c.localize(325,null)})),selectionClipboard:Te(new o(Me.selectionClipboard,"selectionClipboard",!0,{description:c.localize(326,null),included:P.$k})),selectionHighlight:Te(new o(Me.selectionHighlight,"selectionHighlight",!0,{description:c.localize(327,null)})),selectOnLineNumbers:Te(new o(Me.selectOnLineNumbers,"selectOnLineNumbers",!0)),showFoldingControls:Te(new S(Me.showFoldingControls,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[c.localize(328,null),c.localize(329,null),c.localize(330,null)],description:c.localize(331,null)})),showUnused:Te(new o(Me.showUnused,"showUnused",!0,{description:c.localize(332,null)})),showDeprecated:Te(new o(Me.showDeprecated,"showDeprecated",!0,{description:c.localize(333,null)})),inlayHints:Te(new se),snippetSuggestions:Te(new S(Me.snippetSuggestions,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[c.localize(334,null),c.localize(335,null),c.localize(336,null),c.localize(337,null)],description:c.localize(338,null)})),smartSelect:Te(new rt),smoothScrolling:Te(new o(Me.smoothScrolling,"smoothScrolling",!1,{description:c.localize(339,null)})),stopRenderingLineAfter:Te(new i(Me.stopRenderingLineAfter,"stopRenderingLineAfter",1e4,-1,T.Constants.MAX_SAFE_SMALL_INTEGER)),suggest:Te(new et),inlineSuggest:Te(new fe),inlineEdit:Te(new we),inlineCompletionsAccessibilityVerbose:Te(new o(Me.inlineCompletionsAccessibilityVerbose,"inlineCompletionsAccessibilityVerbose",!1,{description:c.localize(340,null)})),suggestFontSize:Te(new i(Me.suggestFontSize,"suggestFontSize",0,0,1e3,{markdownDescription:c.localize(341,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:Te(new i(Me.suggestLineHeight,"suggestLineHeight",0,0,1e3,{markdownDescription:c.localize(342,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:Te(new o(Me.suggestOnTriggerCharacters,"suggestOnTriggerCharacters",!0,{description:c.localize(343,null)})),suggestSelection:Te(new S(Me.suggestSelection,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[c.localize(344,null),c.localize(345,null),c.localize(346,null)],description:c.localize(347,null)})),tabCompletion:Te(new S(Me.tabCompletion,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[c.localize(348,null),c.localize(349,null),c.localize(350,null)],description:c.localize(351,null)})),tabIndex:Te(new i(Me.tabIndex,"tabIndex",0,-1,T.Constants.MAX_SAFE_SMALL_INTEGER)),unicodeHighlight:Te(new x),unusualLineTerminators:Te(new S(Me.unusualLineTerminators,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[c.localize(352,null),c.localize(353,null),c.localize(354,null)],description:c.localize(355,null)})),useShadowDOM:Te(new o(Me.useShadowDOM,"useShadowDOM",!0)),useTabStops:Te(new o(Me.useTabStops,"useTabStops",!0,{description:c.localize(356,null)})),wordBreak:Te(new S(Me.wordBreak,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[c.localize(357,null),c.localize(358,null)],description:c.localize(359,null)})),wordSegmenterLocales:Te(new ot),wordSeparators:Te(new l(Me.wordSeparators,"wordSeparators",$.$ft,{description:c.localize(360,null)})),wordWrap:Te(new S(Me.wordWrap,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[c.localize(361,null),c.localize(362,null),c.localize(363,null),c.localize(364,null)],description:c.localize(365,null)})),wordWrapBreakAfterCharacters:Te(new l(Me.wordWrapBreakAfterCharacters,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Te(new l(Me.wordWrapBreakBeforeCharacters,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Te(new i(Me.wordWrapColumn,"wordWrapColumn",80,1,T.Constants.MAX_SAFE_SMALL_INTEGER,{markdownDescription:c.localize(366,null)})),wordWrapOverride1:Te(new S(Me.wordWrapOverride1,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Te(new S(Me.wordWrapOverride2,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:Te(new j),defaultColorDecorators:Te(new o(Me.defaultColorDecorators,"defaultColorDecorators",!1,{markdownDescription:c.localize(367,null)})),pixelRatio:Te(new pe),tabFocusMode:Te(new o(Me.tabFocusMode,"tabFocusMode",!1,{markdownDescription:c.localize(368,null)})),layoutInfo:Te(new ne),wrappingInfo:Te(new mt),wrappingIndent:Te(new ct),wrappingStrategy:Te(new De)}});var zt=this&&this.__importDefault||function(ce){return ce&&ce.__esModule?ce:{default:ce}};define(Ee[266],ye([1,0,23,44,220,5,110,11,25]),function(ce,e,r,h,P,R,T,N,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfirmResult=e.$4w=e.$3w=e.$2w=void 0,e.$5w=k,e.$6w=p,h=zt(h),e.$2w=(0,R.$Fi)("dialogService");var c;(function(a){a[a.Confirmation=1]="Confirmation",a[a.Prompt=2]="Prompt",a[a.Input=3]="Input"})(c||(c={}));class I{a(f){return this.d(f,c.Confirmation)}b(f){return this.d(f,c.Prompt)}c(f){return this.d(f,c.Input)}d(f,d){const m=[];switch(d){case c.Confirmation:{const n=f;n.primaryButton?m.push(n.primaryButton):m.push((0,P.localize)(0,null)),n.cancelButton?m.push(n.cancelButton):m.push((0,P.localize)(1,null));break}case c.Prompt:{const n=f;Array.isArray(n.buttons)&&n.buttons.length>0&&m.push(...n.buttons.map(o=>o.label)),n.cancelButton&&(n.cancelButton===!0?m.push((0,P.localize)(2,null)):typeof n.cancelButton=="string"?m.push(n.cancelButton):n.cancelButton.label?m.push(n.cancelButton.label):m.push((0,P.localize)(3,null))),m.length===0&&m.push((0,P.localize)(4,null));break}case c.Input:{const n=f;n.primaryButton?m.push(n.primaryButton):m.push((0,P.localize)(5,null)),n.cancelButton?m.push(n.cancelButton):m.push((0,P.localize)(6,null));break}}return m}e(f){if(typeof f=="string")return f;if(typeof f=="number")return f===h.default.Info?"info":f===h.default.Error?"error":f===h.default.Warning?"warning":"none"}f(f,d,m){const n=[...f.buttons??[]];f.cancelButton&&typeof f.cancelButton!="string"&&typeof f.cancelButton!="boolean"&&n.push(f.cancelButton);let o=n[d]?.run({checkboxChecked:m});return o instanceof Promise||(o=Promise.resolve(o)),{result:o,checkboxChecked:m}}}e.$3w=I,e.$4w=(0,R.$Fi)("fileDialogService");var E;(function(a){a[a.SAVE=0]="SAVE",a[a.DONT_SAVE=1]="DONT_SAVE",a[a.CANCEL=2]="CANCEL"})(E||(e.ConfirmResult=E={}));const u=10;function k(a){const f=[];return f.push(...a.slice(0,u).map(d=>typeof d=="string"?d:(0,r.$dh)(d))),a.length>u&&(a.length-u===1?f.push((0,P.localize)(7,null)):f.push((0,P.localize)(8,null,a.length-u))),f.push(""),f.join(`
`)}function p(a,f){const d=(0,$.$bo)(a);let m=(d.buttons??[]).map(i=>(0,T.$Yw)(i)),n=(a.buttons||[]).map((i,s)=>s),o=0,t=d.cancelId??m.length-1;if(m.length>1){const i=typeof t=="number"?m[t]:void 0;if(N.$k||N.$j){if(typeof i=="string"&&m.length>1&&t!==1){m.splice(t,1),m.splice(1,0,i);const s=n[t];n.splice(t,1),n.splice(1,0,s),t=1}N.$k&&m.length>1&&(m=m.reverse(),n=n.reverse(),o=m.length-1,typeof i=="string"&&(t=o-1))}else if(N.$i&&typeof i=="string"&&m.length>1&&t!==m.length-1){m.splice(t,1),m.push(i);const s=n[t];n.splice(t,1),n.push(s),t=m.length-1}}return d.buttons=m,d.defaultId=o,d.cancelId=t,d.noLink=!0,d.title=d.title||f.nameLong,{options:d,buttonIndeces:n}}}),define(Ee[144],ye([1,0,5]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ni=e.$Mi=void 0,e.$Mi=(0,r.$Fi)("environmentService"),e.$Ni=(0,r.$Gi)(e.$Mi)}),define(Ee[267],ye([1,0,5]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$o9b=e.$n9b=void 0,e.$n9b=(0,r.$Fi)("externalTerminal"),e.$o9b="Terminal.app"}),define(Ee[268],ye([1,0,58,59,15,16,11,109,34,112,223,267]),function(ce,e,r,h,P,R,T,N,$,c,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bfc=e.$afc=e.$_ec=void 0,r=We(r),R=We(R),T=We(T),$=We($),c=We(c),I=We(I);const u=I.localize(0,null);class k{async getDefaultTerminalForPlatforms(){return{windows:p.getDefaultTerminalWindows(),linux:await f.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class p extends k{static{this.b="cmd.exe"}openTerminal(t,i){return this.spawnTerminal(r,t,c.$xm(),i)}spawnTerminal(t,i,s,g){const l=i.windowsExec||p.getDefaultTerminalWindows();g&&g[1]===":"&&(g=g[0].toUpperCase()+g.substr(1));const w=R.$pc(l,".exe").toLowerCase();if(w==="cmder")return t.spawn(l,g?[g]:void 0),Promise.resolve(void 0);const S=["/c","start","/wait"];return l.indexOf(" ")>=0&&S.push('""'),S.push(l),w==="wt"&&S.push("-d ."),new Promise((D,y)=>{const C=d(process),A=t.spawn(s,S,{cwd:g,env:C,detached:!0});A.on("error",y),A.on("exit",()=>D())})}async runInTerminal(t,i,s,g,l){const w="windowsExec"in l&&l.windowsExec?l.windowsExec:p.getDefaultTerminalWindows(),S=await p.f();return new Promise((D,y)=>{const C=`"${i} - ${u}"`,A=`"${s.join('" "')}" & pause`,b=Object.assign({},d(process),g);Object.keys(b).filter(j=>b[j]===null).forEach(j=>delete b[j]);const v={cwd:i,env:b,windowsVerbatimArguments:!0};let L,O;R.$pc(w,".exe")==="wt"?(L=w,O=["-d",".",p.b,"/c",A]):S?(L=S,O=["-d",".",w,"/c",A]):(L=p.b,O=["/c","start",C,"/wait",w,"/c",`"${A}"`]),r.spawn(L,O,v).on("error",j=>{y(m(j))}),D(void 0)})}static getDefaultTerminalWindows(){if(!p.d){const t=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");p.d=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${t?"Sysnative":"System32"}\\cmd.exe`}return p.d}static async f(){try{const t=await c.win32.findExecutable("wt");return await $.Promises.exists(t)?t:void 0}catch{return}}}e.$_ec=p,Je([h.$0h],p,"f",null);class a extends k{static{this.b="/usr/bin/osascript"}openTerminal(t,i){return this.spawnTerminal(r,t,i)}runInTerminal(t,i,s,g,l){const w=l.osxExec||E.$o9b;return new Promise((S,D)=>{if(w===E.$o9b||w==="iTerm.app"){const y=w===E.$o9b?"TerminalHelper":"iTermHelper",A=[P.$Zg.asFileUri(`vs/workbench/contrib/externalTerminal/node/${y}.scpt`).fsPath,"-t",t||u,"-w",i];for(const L of s)A.push("-a"),A.push(L);if(g){const L=Object.assign({},d(process),g);for(const O in L){const M=L[O];M===null?(A.push("-u"),A.push(O)):(A.push("-e"),A.push(`${O}=${M}`))}}let b="";const v=r.spawn(a.b,A);v.on("error",L=>{D(m(L))}),v.stderr.on("data",L=>{b+=L.toString()}),v.on("exit",L=>{if(L===0)S(void 0);else if(b){const O=b.split(`
`,1);D(new Error(O[0]))}else D(new Error(I.localize(1,null,y,L)))})}else D(new Error(I.localize(2,null,w)))})}spawnTerminal(t,i,s){const g=i.osxExec||E.$o9b;return new Promise((l,w)=>{const S=["-a",g];s&&S.push(s);const D=d(process),y=t.spawn("/usr/bin/open",S,{cwd:s,env:D});y.on("error",w),y.on("exit",()=>l())})}}e.$afc=a;class f extends k{static{this.b=I.localize(3,null)}openTerminal(t,i){return this.spawnTerminal(r,t,i)}runInTerminal(t,i,s,g,l){const w=l.linuxExec?Promise.resolve(l.linuxExec):f.getDefaultTerminalLinuxReady();return new Promise((S,D)=>{const y=[];w.then(C=>{C.indexOf("gnome-terminal")>=0?y.push("-x"):y.push("-e"),y.push("bash"),y.push("-c");const A=`${n(s)}; echo; read -p "${f.b}" -n1;`;y.push(`''${A}''`);const b=Object.assign({},d(process),g);Object.keys(b).filter(M=>b[M]===null).forEach(M=>delete b[M]);const v={cwd:i,env:b};let L="";const O=r.spawn(C,y,v);O.on("error",M=>{D(m(M))}),O.stderr.on("data",M=>{L+=M.toString()}),O.on("exit",M=>{if(M===0)S(void 0);else if(L){const j=L.split(`
`,1);D(new Error(j[0]))}else D(new Error(I.localize(4,null,C,M)))})})})}static async getDefaultTerminalLinuxReady(){if(!f.d)if(!T.$k)f.d=Promise.resolve("xterm");else{const t=await $.Promises.exists("/etc/debian_version");f.d=new Promise(i=>{t?i("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?i("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?i("konsole"):process.env.COLORTERM?i(process.env.COLORTERM):process.env.TERM?i(process.env.TERM):i("xterm")})}return f.d}spawnTerminal(t,i,s){const g=i.linuxExec?Promise.resolve(i.linuxExec):f.getDefaultTerminalLinuxReady();return new Promise((l,w)=>{g.then(S=>{const D=d(process),y=t.spawn(S,[],{cwd:s,env:D});y.on("error",w),y.on("exit",()=>l())})})}}e.$bfc=f;function d(o){const t={...o.env};return(0,N.$km)(t),t}function m(o){return"errno"in o&&o.errno==="ENOENT"&&"path"in o&&typeof o.path=="string"?new Error(I.localize(5,null,o.path)):o}function n(o){let t="";for(const i of o)i.indexOf(" ")>=0?t+='"'+i+'"':t+=i,t+=" ";return t}}),define(Ee[28],ye([1,0,85,16,13,18,2,224,5,11,15,49]),function(ce,e,r,h,P,R,T,N,$,c,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hl=e.$El=e.FileKind=e.$Dl=e.$Cl=e.$Bl=e.$Al=e.$zl=e.$yl=e.$xl=e.FileOperationResult=e.$wl=e.$vl=e.$ul=e.$sl=e.FileChangeType=e.$rl=e.FileOperation=e.$ll=e.FileSystemProviderErrorCode=e.FileSystemProviderCapabilities=e.FileChangeFilter=e.FilePermission=e.FileType=e.$_k=void 0,e.$al=u,e.$bl=f,e.$cl=m,e.$dl=n,e.$el=o,e.$fl=t,e.$gl=i,e.$hl=s,e.$il=g,e.$jl=l,e.$kl=w,e.$ml=y,e.$nl=C,e.$ol=A,e.$pl=b,e.$ql=v,e.$tl=z,e.$Fl=G,e.$Gl=Q,e.$Il=he,e.$_k=(0,$.$Fi)("fileService");function u(ne){return ne.create===!0}var k;(function(ne){ne[ne.Unknown=0]="Unknown",ne[ne.File=1]="File",ne[ne.Directory=2]="Directory",ne[ne.SymbolicLink=64]="SymbolicLink"})(k||(e.FileType=k={}));var p;(function(ne){ne[ne.Readonly=1]="Readonly",ne[ne.Locked=2]="Locked"})(p||(e.FilePermission=p={}));var a;(function(ne){ne[ne.UPDATED=2]="UPDATED",ne[ne.ADDED=4]="ADDED",ne[ne.DELETED=8]="DELETED"})(a||(e.FileChangeFilter=a={}));function f(ne){const De=ne;return!!De&&typeof De.onDidChange=="function"}var d;(function(ne){ne[ne.None=0]="None",ne[ne.FileReadWrite=2]="FileReadWrite",ne[ne.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",ne[ne.FileReadStream=16]="FileReadStream",ne[ne.FileFolderCopy=8]="FileFolderCopy",ne[ne.PathCaseSensitive=1024]="PathCaseSensitive",ne[ne.Readonly=2048]="Readonly",ne[ne.Trash=4096]="Trash",ne[ne.FileWriteUnlock=8192]="FileWriteUnlock",ne[ne.FileAtomicRead=16384]="FileAtomicRead",ne[ne.FileAtomicWrite=32768]="FileAtomicWrite",ne[ne.FileAtomicDelete=65536]="FileAtomicDelete",ne[ne.FileClone=131072]="FileClone"})(d||(e.FileSystemProviderCapabilities=d={}));function m(ne){return!!(ne.capabilities&d.FileReadWrite)}function n(ne){return!!(ne.capabilities&d.FileFolderCopy)}function o(ne){return!!(ne.capabilities&d.FileClone)}function t(ne){return!!(ne.capabilities&d.FileOpenReadWriteClose)}function i(ne){return!!(ne.capabilities&d.FileReadStream)}function s(ne){return m(ne)?!!(ne.capabilities&d.FileAtomicRead):!1}function g(ne){return m(ne)?!!(ne.capabilities&d.FileAtomicWrite):!1}function l(ne){return!!(ne.capabilities&d.FileAtomicDelete)}function w(ne){return!!(ne.capabilities&d.Readonly)}var S;(function(ne){ne.FileExists="EntryExists",ne.FileNotFound="EntryNotFound",ne.FileNotADirectory="EntryNotADirectory",ne.FileIsADirectory="EntryIsADirectory",ne.FileExceedsStorageQuota="EntryExceedsStorageQuota",ne.FileTooLarge="EntryTooLarge",ne.FileWriteLocked="EntryWriteLocked",ne.NoPermissions="NoPermissions",ne.Unavailable="Unavailable",ne.Unknown="Unknown"})(S||(e.FileSystemProviderErrorCode=S={}));class D extends Error{static create(De,$e){const K=new D(De.toString(),$e);return A(K,$e),K}constructor(De,$e){super(De),this.code=$e}}e.$ll=D;function y(ne,De){return D.create(ne,De)}function C(ne){return ne||y((0,N.localize)(0,null),S.Unknown)}function A(ne,De){return ne.name=De?`${De} (FileSystemError)`:"FileSystemError",ne}function b(ne){if(!ne)return S.Unknown;if(ne instanceof D)return ne.code;const De=/^(.+) \(FileSystemError\)$/.exec(ne.name);if(!De)return S.Unknown;switch(De[1]){case S.FileExists:return S.FileExists;case S.FileIsADirectory:return S.FileIsADirectory;case S.FileNotADirectory:return S.FileNotADirectory;case S.FileNotFound:return S.FileNotFound;case S.FileTooLarge:return S.FileTooLarge;case S.FileWriteLocked:return S.FileWriteLocked;case S.NoPermissions:return S.NoPermissions;case S.Unavailable:return S.Unavailable}return S.Unknown}function v(ne){if(ne instanceof F)return ne.fileOperationResult;switch(b(ne)){case S.FileNotFound:return re.FILE_NOT_FOUND;case S.FileIsADirectory:return re.FILE_IS_DIRECTORY;case S.FileNotADirectory:return re.FILE_NOT_DIRECTORY;case S.FileWriteLocked:return re.FILE_WRITE_LOCKED;case S.NoPermissions:return re.FILE_PERMISSION_DENIED;case S.FileExists:return re.FILE_MOVE_CONFLICT;case S.FileTooLarge:return re.FILE_TOO_LARGE;default:return re.FILE_OTHER_ERROR}}var L;(function(ne){ne[ne.CREATE=0]="CREATE",ne[ne.DELETE=1]="DELETE",ne[ne.MOVE=2]="MOVE",ne[ne.COPY=3]="COPY",ne[ne.WRITE=4]="WRITE"})(L||(e.FileOperation=L={}));class O{constructor(De,$e,K){this.resource=De,this.operation=$e,this.target=K}isOperation(De){return this.operation===De}}e.$rl=O;var M;(function(ne){ne[ne.UPDATED=0]="UPDATED",ne[ne.ADDED=1]="ADDED",ne[ne.DELETED=2]="DELETED"})(M||(e.FileChangeType=M={}));class j{static{this.a=null}constructor(De,$e){this.c=$e,this.b=void 0,this.d=new E.$X(()=>{const K=r.$Li.forUris(()=>this.c);return K.fill(this.rawAdded.map(W=>[W,!0])),K}),this.f=new E.$X(()=>{const K=r.$Li.forUris(()=>this.c);return K.fill(this.rawUpdated.map(W=>[W,!0])),K}),this.g=new E.$X(()=>{const K=r.$Li.forUris(()=>this.c);return K.fill(this.rawDeleted.map(W=>[W,!0])),K}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const K of De){switch(K.type){case M.ADDED:this.rawAdded.push(K.resource);break;case M.UPDATED:this.rawUpdated.push(K.resource);break;case M.DELETED:this.rawDeleted.push(K.resource);break}this.b!==j.a&&(typeof K.cId=="number"?this.b===void 0?this.b=K.cId:this.b!==K.cId&&(this.b=j.a):this.b!==void 0&&(this.b=j.a))}}contains(De,...$e){return this.h(De,{includeChildren:!1},...$e)}affects(De,...$e){return this.h(De,{includeChildren:!0},...$e)}h(De,$e,...K){if(!De)return!1;const W=K.length>0;return!!((!W||K.includes(M.ADDED))&&(this.d.value.get(De)||$e.includeChildren&&this.d.value.findSuperstr(De))||(!W||K.includes(M.UPDATED))&&(this.f.value.get(De)||$e.includeChildren&&this.f.value.findSuperstr(De))||(!W||K.includes(M.DELETED))&&(this.g.value.findSubstr(De)||$e.includeChildren&&this.g.value.findSuperstr(De)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(De){return this.b===De}hasCorrelation(){return typeof this.b=="number"}}e.$sl=j;function z(ne,De,$e){return!ne||!De||ne===De||De.length>ne.length?!1:(De.charAt(De.length-1)!==h.sep&&(De+=h.sep),$e?(0,P.$Hf)(ne,De):ne.indexOf(De)===0)}class F extends Error{constructor(De,$e,K){super(De),this.fileOperationResult=$e,this.options=K}}e.$ul=F;class B extends F{constructor(De,$e,K,W){super(De,$e,W),this.fileOperationResult=$e,this.size=K}}e.$vl=B;class _ extends F{constructor(De,$e,K){super(De,re.FILE_NOT_MODIFIED_SINCE,K),this.stat=$e}}e.$wl=_;var re;(function(ne){ne[ne.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",ne[ne.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",ne[ne.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",ne[ne.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",ne[ne.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",ne[ne.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",ne[ne.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",ne[ne.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",ne[ne.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",ne[ne.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",ne[ne.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(re||(e.FileOperationResult=re={})),e.$xl={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$yl={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$zl="files.associations",e.$Al="files.exclude",e.$Bl="files.readonlyInclude",e.$Cl="files.readonlyExclude",e.$Dl="files.readonlyFromPermissions";var U;(function(ne){ne[ne.FILE=0]="FILE",ne[ne.FOLDER=1]="FOLDER",ne[ne.ROOT_FOLDER=2]="ROOT_FOLDER"})(U||(e.FileKind=U={})),e.$El="";function G(ne){if(!(typeof ne.size!="number"||typeof ne.mtime!="number"))return ne.mtime.toString(29)+ne.size.toString(31)}async function Q(ne,De){if(!De.hasProvider(T.URI.from({scheme:ne.scheme})))return new Promise($e=>{const K=De.onDidChangeFileSystemProviderRegistrations(W=>{W.scheme===ne.scheme&&W.added&&(K.dispose(),$e())})})}class ee{static{this.KB=1024}static{this.MB=ee.KB*ee.KB}static{this.GB=ee.MB*ee.KB}static{this.TB=ee.GB*ee.KB}static formatSize(De){return(0,R.$jg)(De)||(De=0),De<ee.KB?(0,N.localize)(1,null,De.toFixed(0)):De<ee.MB?(0,N.localize)(2,null,(De/ee.KB).toFixed(2)):De<ee.GB?(0,N.localize)(3,null,(De/ee.MB).toFixed(2)):De<ee.TB?(0,N.localize)(4,null,(De/ee.GB).toFixed(2)):(0,N.localize)(5,null,(De/ee.TB).toFixed(2))}}e.$Hl=ee;function he(ne){const De=typeof ne=="string"||ne?.scheme===I.Schemas.vscodeRemote;return typeof ne!="string"&&ne?.scheme===I.Schemas.file?1024*ee.MB:De?10*ee.MB:c.$o?50*ee.MB:1024*ee.MB}}),define(Ee[269],ye([1,0,22,14,225,28]),function(ce,e,r,h,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uq=T;async function T(I,E,u,k,p,a){let f;try{await N(I,E,u,k,p,a)}catch(d){f=d}finally{f&&p.errorTransformer&&(f=p.errorTransformer(f)),typeof f<"u"&&u.error(f),u.end()}}async function N(I,E,u,k,p,a){$(a);const f=await I.open(E,{create:!1});try{$(a);let d=0,m=0,n=p&&typeof p.length=="number"?p.length:void 0,o=r.$Oe.alloc(Math.min(p.bufferSize,typeof n=="number"?n:p.bufferSize)),t=p&&typeof p.position=="number"?p.position:0,i=0;do m=await I.read(f,t,o.buffer,i,o.byteLength-i),t+=m,i+=m,d+=m,typeof n=="number"&&(n-=m),i===o.byteLength&&(await u.write(k(o)),o=r.$Oe.alloc(Math.min(p.bufferSize,typeof n=="number"?n:p.bufferSize)),i=0);while(m>0&&(typeof n!="number"||n>0)&&$(a)&&c(d,p));if(i>0){let s=i;typeof n=="number"&&(s=Math.min(i,n)),u.write(k(o.slice(0,s)))}}catch(d){throw(0,R.$nl)(d)}finally{await I.close(f)}}function $(I){if(I.isCancellationRequested)throw(0,h.$8)();return!0}function c(I,E){if(typeof E?.limits?.size=="number"&&I>E.limits.size)throw(0,R.$ml)((0,P.localize)(0,null),R.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(Ee[70],ye([1,0,39,3,16,11,2,28]),function(ce,e,r,h,P,R,T,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1q=e.$Zq=e.$Yq=void 0,e.$Wq=$,e.$Xq=c,e.$2q=k,e.$3q=p,e.$4q=a,e.$5q=f,e.$6q=m,e.$7q=n;function $(o){return typeof o.correlationId=="number"}function c(o){return o.recursive===!0}class I extends h.$Wc{static{this.a=5}constructor(t,i,s,g){super(),this.h=t,this.j=i,this.m=s,this.n=g,this.c=this.B(new h.$Xc),this.f=void 0,this.g=0}s(){const t=new h.$Vc;this.c.value=t,this.b=this.r(t),this.b.setVerboseLogging(this.m),t.add(this.b.onDidChangeFile(i=>this.h(i))),t.add(this.b.onDidLogMessage(i=>this.j(i))),t.add(this.b.onDidError(i=>this.t(i.error,i.request)))}t(t,i){this.u(t,i)?this.g<I.a&&this.f?(this.y(`restarting watcher after unexpected error: ${t}`),this.w(this.f)):this.y(`gave up attempting to restart watcher after unexpected error: ${t}`):this.y(t)}u(t,i){return!(!this.n.restartOnError||i||t.indexOf("No space left on device")!==-1||t.indexOf("EMFILE")!==-1)}w(t){this.g++,this.s(),this.watch(t)}async watch(t){this.f=t,await this.b?.watch(t)}async setVerboseLogging(t){this.m=t,await this.b?.setVerboseLogging(t)}y(t){this.j({type:"error",message:`[File Watcher (${this.n.type})] ${t}`})}z(t){this.j({type:"trace",message:`[File Watcher (${this.n.type})] ${t}`})}dispose(){return this.b=void 0,super.dispose()}}e.$Yq=I;class E extends I{constructor(t,i,s){super(t,i,s,{type:"node.js",restartOnError:!1})}}e.$Zq=E;class u extends I{constructor(t,i,s){super(t,i,s,{type:"universal",restartOnError:!0})}}e.$1q=u;function k(o){return o.map(t=>({type:t.type,resource:T.URI.revive(t.resource),cId:t.cId}))}function p(o){const t=new d;for(const i of o)t.processEvent(i);return t.coalesce()}function a(o,t){return typeof t=="string"&&!t.startsWith(r.$vk)&&!(0,P.$kc)(t)?{base:o,pattern:t}:t}function f(o,t){const i=[];for(const s of t)i.push((0,r.$zk)(a(o,s)));return i}class d{constructor(){this.a=new Set,this.b=new Map}c(t){return R.$k?t.resource.fsPath:t.resource.fsPath.toLowerCase()}processEvent(t){const i=this.b.get(this.c(t));let s=!1;if(i){const g=i.type,l=t.type;i.resource.fsPath!==t.resource.fsPath&&(t.type===N.FileChangeType.DELETED||t.type===N.FileChangeType.ADDED)?s=!0:g===N.FileChangeType.ADDED&&l===N.FileChangeType.DELETED?(this.b.delete(this.c(t)),this.a.delete(i)):g===N.FileChangeType.DELETED&&l===N.FileChangeType.ADDED?i.type=N.FileChangeType.UPDATED:g===N.FileChangeType.ADDED&&l===N.FileChangeType.UPDATED||(i.type=l)}else s=!0;s&&(this.a.add(t),this.b.set(this.c(t),t))}coalesce(){const t=[],i=[];return Array.from(this.a).filter(s=>s.type!==N.FileChangeType.DELETED?(t.push(s),!1):!0).sort((s,g)=>s.resource.fsPath.length-g.resource.fsPath.length).filter(s=>i.some(g=>(0,N.$tl)(s.resource.fsPath,g,!R.$k))?!1:(i.push(s.resource.fsPath),!0)).concat(t)}}function m(o,t){if(typeof t=="number")switch(o.type){case N.FileChangeType.ADDED:return(t&N.FileChangeFilter.ADDED)===0;case N.FileChangeType.DELETED:return(t&N.FileChangeFilter.DELETED)===0;case N.FileChangeType.UPDATED:return(t&N.FileChangeFilter.UPDATED)===0}return!1}function n(o){if(typeof o=="number"){const t=[];return o&N.FileChangeFilter.ADDED&&t.push("Added"),o&N.FileChangeFilter.DELETED&&t.push("Deleted"),o&N.FileChangeFilter.UPDATED&&t.push("Updated"),t.length===0?"<all>":`[${t.join(", ")}]`}return"<none>"}}),define(Ee[270],ye([1,0,61,3,70,4,28,2,9]),function(ce,e,r,h,P,R,T,N,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dr=void 0;class c extends h.$Wc{constructor(){super(),this.a=this.B(new R.$me),this.onDidChangeFile=this.a.event,this.b=this.B(new R.$me),this.onDidLogMessage=this.b.event,this.c=this.B(new R.$me),this.f=this.c.event,this.g=new Set,this.h=new Map,this.j=this.B(new h.$6c),this.m=new Set,this.n=this.B(new $.$Dh(this.y())),this.r=5007,this.s=new $.$3h,this.R=!1,this.B(this.f(E=>this.t(E)))}t(E){this.u(E)&&this.z(E)}u(E){return(0,P.$Wq)(E)}async watch(E){this.s.isSettled||this.s.complete(),this.s=new $.$3h;try{this.h.clear(),this.g.clear();for(const u of E)this.u(u)?this.h.set(u.correlationId,u):this.g.add(u);for(const[u]of this.j)this.h.has(u)||(this.j.deleteAndDispose(u),this.m.delete(u));return await this.w(!1)}finally{this.s.complete()}}w(E){return this.n.trigger(()=>this.N([...this.g,...Array.from(this.h.values()).filter(u=>!this.j.has(u.correlationId))]),E?this.y():0)}y(){return 800}isSuspended(E){return typeof E.correlationId!="number"?!1:this.m.has(E.correlationId)?"polling":this.j.has(E.correlationId)}async z(E){if(this.j.has(E.correlationId))return;const u=new h.$Vc;this.j.set(E.correlationId,u),await this.s.p,!u.isDisposed&&(this.D(E,u),this.w(!0))}C(E){this.j.deleteAndDispose(E.correlationId),this.m.delete(E.correlationId),this.w(!1)}D(E,u){this.F(E,u)?(this.P(`reusing an existing recursive watcher to monitor ${E.path}`),this.m.delete(E.correlationId)):(this.G(E,u),this.m.add(E.correlationId))}F(E,u){const k=this.O?.subscribe(E.path,(p,a)=>{u.isDisposed||(p?this.D(E,u):a?.type===T.FileChangeType.ADDED&&this.H(E))});return k?(u.add(k),!0):!1}G(E,u){let k=!1;const p=(a,f)=>{if(u.isDisposed)return;const d=this.I(a),m=this.I(f),n=k;k=d,!d&&(m||n)&&this.H(E)};this.P(`starting fs.watchFile() on ${E.path} (correlationId: ${E.correlationId})`);try{(0,r.watchFile)(E.path,{persistent:!1,interval:this.r},p)}catch(a){this.Q(`fs.watchFile() failed with error ${a} on path ${E.path} (correlationId: ${E.correlationId})`)}u.add((0,h.$Uc)(()=>{this.P(`stopping fs.watchFile() on ${E.path} (correlationId: ${E.correlationId})`);try{(0,r.unwatchFile)(E.path,p)}catch(a){this.Q(`fs.unwatchFile() failed with error ${a} on path ${E.path} (correlationId: ${E.correlationId})`)}}))}H(E){this.P(`detected ${E.path} exists again, resuming watcher (correlationId: ${E.correlationId})`);const u={resource:N.URI.file(E.path),type:T.FileChangeType.ADDED,cId:E.correlationId};this.a.fire([u]),this.J(u,E),this.C(E)}I(E){return E.ctimeMs===0&&E.ino===0}async stop(){this.j.clearAndDisposeAll(),this.m.clear()}J(E,u){if(this.R){const k=` >> normalized ${E.type===T.FileChangeType.ADDED?"[ADDED]":E.type===T.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${E.resource.fsPath}`;this.L(k,u)}}L(E,u){this.R&&this.P(`${E}${typeof u.correlationId=="number"?` <${u.correlationId}> `:""}`)}M(E){return`${E.path} (excludes: ${E.excludes.length>0?E.excludes:"<none>"}, includes: ${E.includes&&E.includes.length>0?JSON.stringify(E.includes):"<all>"}, filter: ${(0,P.$7q)(E.filter)}, correlationId: ${typeof E.correlationId=="number"?E.correlationId:"<none>"})`}async setVerboseLogging(E){this.R=E}}e.$dr=c}),define(Ee[271],ye([1,0,61,9,21,33,3,82,16,11,23,2,111,34,28,70]),function(ce,e,r,h,P,R,T,N,$,c,I,E,u,k,p,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ir=void 0,e.$jr=d;class f extends T.$Wc{static{this.a=100}static{this.b=75}get isReusingRecursiveWatcher(){return this.n}get failed(){return this.r}constructor(n,o,t,i,s,g){super(),this.s=n,this.t=o,this.u=t,this.w=i,this.y=s,this.z=g,this.c=this.B(new h.$Uh({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},l=>this.u(l))),this.f=this.B(new h.$Th(l=>this.M(l),f.b)),this.g=(0,a.$5q)(this.s.path,this.s.excludes),this.h=this.s.includes?(0,a.$5q)(this.s.path,this.s.includes):void 0,this.j=(0,a.$Wq)(this.s)?this.s.filter:void 0,this.m=new P.$xe,this.ready=this.C(),this.n=!1,this.r=!1}async C(){try{const n=await this.F(this.s);if(this.m.token.isCancellationRequested)return;const o=await k.Promises.stat(n);if(this.m.token.isCancellationRequested)return;this.B(await this.G(n,o.isDirectory()))}catch(n){n.code!=="ENOENT"?this.O(n):this.Q(`ignoring a path for watching who's stat info failed to resolve: ${this.s.path} (error: ${n})`),this.D()}}D(){this.r=!0,this.w?.()}async F(n){let o=n.path;try{o=await k.Promises.realpath(n.path),n.path===o&&(o=await(0,u.$fr)(n.path,this.m.token)??n.path),n.path!==o&&this.Q(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${n.path}, real: ${o})`)}catch{}return o}async G(n,o){const t=new T.$Vc;return this.H(n,o,t)?(this.Q(`reusing an existing recursive watcher for ${this.s.path}`),this.n=!0):(this.n=!1,await this.I(n,o,t)),t}H(n,o,t){if(o)return!1;const i=E.URI.file(this.s.path),s=this.t?.subscribe(this.s.path,async(g,l)=>{if(!t.isDisposed)if(g){const w=await this.G(n,o);t.isDisposed?w.dispose():t.add(w)}else l&&(typeof l.cId=="number"||typeof this.s.correlationId=="number")&&this.L({resource:i,type:l.type,cId:this.s.correlationId},!0)});return s?(t.add(s),!0):!1}async I(n,o,t){if(c.$j&&(0,R.$Eg)(n,"/Volumes/",!0)){this.O(`Refusing to watch ${n} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`);return}const i=new P.$xe(this.m.token);t.add((0,T.$Uc)(()=>i.dispose(!0)));const s=new T.$Vc;t.add(s);try{const g=E.URI.file(this.s.path),l=(0,$.$pc)(n),w=(0,r.watch)(n);s.add((0,T.$Uc)(()=>{w.removeAllListeners(),w.close()})),this.Q(`Started watching: '${n}'`);const S=new Set;if(o)try{for(const y of await k.Promises.readdir(n))S.add(y)}catch(y){this.O(y)}if(i.token.isCancellationRequested)return;const D=new Map;s.add((0,T.$Uc)(()=>{for(const[,y]of D)y.dispose();D.clear()})),w.on("error",(y,C)=>{i.token.isCancellationRequested||(this.O(`Failed to watch ${n} for changes using fs.watch() (${y}, ${C})`),this.D())}),w.on("change",(y,C)=>{if(i.token.isCancellationRequested)return;this.z&&this.R(`[raw] ["${y}"] ${C}`);let A="";if(C&&(A=C.toString(),c.$j&&(A=(0,N.$mm)(A))),!(!A||y!=="change"&&y!=="rename"))if(o)if(y==="rename"){D.get(A)?.dispose();const b=setTimeout(async()=>{if(D.delete(A),A===l&&!await k.Promises.exists(n)){this.J(g);return}if(i.token.isCancellationRequested)return;const v=await this.N((0,$.$lc)(n,A));if(i.token.isCancellationRequested)return;let L;v?S.has(A)?L=p.FileChangeType.UPDATED:(L=p.FileChangeType.ADDED,S.add(A)):(S.delete(A),L=p.FileChangeType.DELETED),this.L({resource:(0,I.$gh)(g,A),type:L,cId:this.s.correlationId})},f.a);D.set(A,(0,T.$Uc)(()=>clearTimeout(b)))}else{let b;S.has(A)?b=p.FileChangeType.UPDATED:(b=p.FileChangeType.ADDED,S.add(A)),this.L({resource:(0,I.$gh)(g,A),type:b,cId:this.s.correlationId})}else if(y==="rename"||A!==l){const b=setTimeout(async()=>{const v=await k.Promises.exists(n);i.token.isCancellationRequested||(v?(this.L({resource:g,type:p.FileChangeType.UPDATED,cId:this.s.correlationId},!0),s.add(await this.G(n,!1))):this.J(g))},f.a);s.clear(),s.add((0,T.$Uc)(()=>clearTimeout(b)))}else this.L({resource:g,type:p.FileChangeType.UPDATED,cId:this.s.correlationId},!0)})}catch(g){i.token.isCancellationRequested||this.O(`Failed to watch ${n} for changes using fs.watch() (${g.toString()})`),this.D()}}J(n){this.P("Watcher shutdown because watched path got deleted"),this.L({resource:n,type:p.FileChangeType.DELETED,cId:this.s.correlationId},!0),this.f.flush(),this.D()}L(n,o=!1){this.m.token.isCancellationRequested||(this.z&&this.R(`${n.type===p.FileChangeType.ADDED?"[ADDED]":n.type===p.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${n.resource.fsPath}`),!o&&this.g.some(t=>t(n.resource.fsPath))?this.z&&this.R(` >> ignored (excluded) ${n.resource.fsPath}`):!o&&this.h&&this.h.length>0&&!this.h.some(t=>t(n.resource.fsPath))?this.z&&this.R(` >> ignored (not included) ${n.resource.fsPath}`):this.f.work(n))}M(n){const o=(0,a.$3q)(n),t=[];for(const s of o){if((0,a.$6q)(s,this.j)){this.z&&this.R(` >> ignored (filtered) ${s.resource.fsPath}`);continue}t.push(s)}if(t.length===0)return;if(this.z)for(const s of t)this.R(` >> normalized ${s.type===p.FileChangeType.ADDED?"[ADDED]":s.type===p.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${s.resource.fsPath}`);this.c.work(t)?this.c.pending>0&&this.Q(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${t[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.P(`started ignoring events due to too many file change events at once (incoming: ${t.length}, most recent change: ${t[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}async N(n){if(c.$k)return k.Promises.exists(n);try{const o=(0,$.$pc)(n);return(await k.Promises.readdir((0,$.$oc)(n))).some(i=>i===o)}catch(o){return this.Q(o),!1}}setVerboseLogging(n){this.z=n}O(n){this.m.token.isCancellationRequested||this.y?.({type:"error",message:`[File Watcher (node.js)] ${n}`})}P(n){this.m.token.isCancellationRequested||this.y?.({type:"warn",message:`[File Watcher (node.js)] ${n}`})}Q(n){!this.m.token.isCancellationRequested&&this.z&&this.y?.({type:"trace",message:`[File Watcher (node.js)] ${n}`})}R(n){!this.m.token.isCancellationRequested&&this.z&&this.Q(`${n}${typeof this.s.correlationId=="number"?` <${this.s.correlationId}> `:""}`)}dispose(){this.m.dispose(!0),super.dispose()}}e.$ir=f;async function d(m,n,o,t,i=512){const s=await k.Promises.open(m,"r"),g=Buffer.allocUnsafe(i),l=new P.$xe(t);let w,S=!1;const D={path:m,excludes:[],recursive:!1},y=new f(D,void 0,C=>{(async()=>{for(const{type:A}of C)if(A===p.FileChangeType.UPDATED){if(S)return;S=!0;try{for(;!l.token.isCancellationRequested;){const{bytesRead:b}=await k.Promises.read(s,g,0,i,null);if(!b||l.token.isCancellationRequested)break;n(g.slice(0,b))}}catch(b){w=new Error(b),l.dispose(!0)}finally{S=!1}}})()});return await y.ready,o(),new Promise((C,A)=>{l.token.onCancellationRequested(async()=>{y.dispose();try{await k.Promises.close(s)}catch(b){w=new Error(b)}w?A(w):C()})})}}),define(Ee[272],ye([1,0,4,39,270,11,271,33]),function(ce,e,r,h,P,R,T,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kr=void 0;class $ extends P.$dr{constructor(I){super(),this.O=I,this.onDidError=r.Event.None,this.watchers=new Set}async N(I){I=this.Z(I);const E=[],u=new Set(Array.from(this.watchers));for(const k of I){const p=this.W(k);p&&(0,h.$Dk)(p.request.excludes,k.excludes)&&(0,h.$Dk)(p.request.includes,k.includes)?u.delete(p):E.push(k)}E.length&&this.P(`Request to start watching: ${E.map(k=>this.M(k)).join(",")}`),u.size&&this.P(`Request to stop watching: ${Array.from(u).map(k=>this.M(k.request)).join(",")}`);for(const k of u)this.Y(k);for(const k of E)this.X(k)}W(I){for(const E of this.watchers)if(typeof I.correlationId=="number"||typeof E.request.correlationId=="number"){if(E.request.correlationId===I.correlationId)return E}else if((0,N.$Dg)(E.request.path,I.path,!R.$k))return E}X(I){const E=new T.$ir(I,this.O,k=>this.a.fire(k),()=>this.c.fire(I),k=>this.b.fire(k),this.R),u={request:I,instance:E};this.watchers.add(u)}async stop(){await super.stop();for(const I of this.watchers)this.Y(I)}Y(I){this.P("stopping file watcher",I),this.watchers.delete(I),I.instance.dispose()}Z(I){const E=new Map;for(const u of I){const k=R.$k?u.path:u.path.toLowerCase();let p=E.get(u.correlationId);p||(p=new Map,E.set(u.correlationId,p)),p.has(k)&&this.P(`ignoring a request for watching who's path is already watched: ${this.M(u)}`),p.set(k,u)}return Array.from(E.values()).map(u=>Array.from(u.values())).flat()}async setVerboseLogging(I){super.setVerboseLogging(I);for(const E of this.watchers)E.instance.setVerboseLogging(I)}P(I,E){this.R&&this.b.fire({type:"trace",message:this.bb(I,E)})}Q(I){this.b.fire({type:"warn",message:this.bb(I)})}bb(I,E){return E?`[File Watcher (node.js)] ${I} (${this.M(E.request)})`:`[File Watcher (node.js)] ${I}`}}e.$kr=$}),define(Ee[273],ye([1,0,70,272]),function(ce,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lr=void 0;class P extends r.$Zq{constructor(T,N,$){super(T,N,$),this.s()}r(T){return T.add(new h.$kr(void 0))}}e.$lr=P}),define(Ee[274],ye([1,0,15,87,208,70]),function(ce,e,r,h,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cr=void 0;class T extends R.$1q{constructor($,c,I){super($,c,I),this.s()}r($){const c=$.add(new P.$br(r.$Zg.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return $.add(c.onDidProcessExit(({code:I,signal:E})=>this.t(`terminated by itself with code ${I}, signal: ${E} (ETERM)`))),h.ProxyChannel.toService((0,h.$mi)(c.getChannel("watcher")))}}e.$cr=T}),define(Ee[115],ye([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Di=void 0;class r{constructor(...P){this.a=new Map;for(const[R,T]of P)this.set(R,T)}set(P,R){const T=this.a.get(P);return this.a.set(P,R),T}has(P){return this.a.has(P)}get(P){return this.a.get(P)}}e.$Di=r}),define(Ee[275],ye([1,0,9,14,3,113,264,5,115,81]),function(ce,e,r,h,P,R,T,N,$,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qr=e.$pr=void 0;const I=!1;class E extends Error{constructor(f){super("cyclic dependency between services"),this.message=f.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${f.toString()}`}}class u{constructor(f=new $.$Di,d=!1,m,n=I){this.i=f,this.j=d,this.k=m,this.l=n,this.f=!1,this.g=new Set,this.h=new Set,this.t=new Set,this.i.set(N.$Ei,this),this._globalGraph=n?m?._globalGraph??new T.$or(o=>o):void 0}dispose(){if(!this.f){this.f=!0,(0,P.$Rc)(this.h),this.h.clear();for(const f of this.g)(0,P.$Qc)(f)&&f.dispose();this.g.clear()}}m(){if(this.f)throw new Error("InstantiationService has been disposed")}createChild(f,d){this.m();const m=this,n=new class extends u{dispose(){m.h.delete(n),super.dispose()}}(f,this.j,this,this.l);return this.h.add(n),d?.add(n),n}invokeFunction(f,...d){this.m();const m=p.traceInvocation(this.l,f);let n=!1;try{return f({get:t=>{if(n)throw(0,h.$0)("service accessor is only valid during the invocation of its target method");const i=this.s(t,m);if(!i)throw new Error(`[invokeFunction] unknown service '${t}'`);return i}},...d)}finally{n=!0,m.stop()}}createInstance(f,...d){this.m();let m,n;return f instanceof R.$Ci?(m=p.traceCreation(this.l,f.ctor),n=this.o(f.ctor,f.staticArguments.concat(d),m)):(m=p.traceCreation(this.l,f),n=this.o(f,d,m)),m.stop(),n}o(f,d=[],m){const n=N._util.getServiceDependencies(f).sort((i,s)=>i.index-s.index),o=[];for(const i of n){const s=this.s(i.id,m);s||this.y(`[createInstance] ${f.name} depends on UNKNOWN service ${i.id}.`,!1),o.push(s)}const t=n.length>0?n[0].index:d.length;if(d.length!==t){console.trace(`[createInstance] First service dependency of ${f.name} at position ${t+1} conflicts with ${d.length} static arguments`);const i=t-d.length;i>0?d=d.concat(new Array(i)):d=d.slice(0,t)}return Reflect.construct(f,d.concat(o))}q(f,d){if(this.i.get(f)instanceof R.$Ci)this.i.set(f,d);else if(this.k)this.k.q(f,d);else throw new Error("illegalState - setting UNKNOWN service instance")}r(f){const d=this.i.get(f);return!d&&this.k?this.k.r(f):d}s(f,d){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(f));const m=this.r(f);return m instanceof R.$Ci?this.u(f,m,d.branch(f,!0)):(d.branch(f,!1),m)}u(f,d,m){if(this.t.has(f))throw new Error(`illegal state - RECURSIVELY instantiating service '${f}'`);this.t.add(f);try{return this.v(f,d,m)}finally{this.t.delete(f)}}v(f,d,m){const n=new T.$or(i=>i.id.toString());let o=0;const t=[{id:f,desc:d,_trace:m}];for(;t.length;){const i=t.pop();if(n.lookupOrInsertNode(i),o++>1e3)throw new E(n);for(const s of N._util.getServiceDependencies(i.desc.ctor)){const g=this.r(s.id);if(g||this.y(`[createInstance] ${f} depends on ${s.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(i.id),String(s.id)),g instanceof R.$Ci){const l={id:s.id,desc:g,_trace:i._trace.branch(s.id,!0)};n.insertEdge(i,l),t.push(l)}}}for(;;){const i=n.roots();if(i.length===0){if(!n.isEmpty())throw new E(n);break}for(const{data:s}of i){if(this.r(s.id)instanceof R.$Ci){const l=this.w(s.id,s.desc.ctor,s.desc.staticArguments,s.desc.supportsDelayedInstantiation,s._trace);this.q(s.id,l)}n.removeNode(s)}}return this.r(f)}w(f,d,m=[],n,o){if(this.i.get(f)instanceof R.$Ci)return this.x(f,d,m,n,o,this.g);if(this.k)return this.k.w(f,d,m,n,o);throw new Error(`illegalState - creating UNKNOWN service instance ${d.name}`)}x(f,d,m=[],n,o,t){if(n){const i=new u(void 0,this.j,this,this.l);i.c=String(f);const s=new Map,g=new r.$Yh(()=>{const l=i.o(d,m,o);for(const[w,S]of s){const D=l[w];if(typeof D=="function")for(const y of S)y.disposable=D.apply(l,y.listener)}return s.clear(),t.add(l),l});return new Proxy(Object.create(null),{get(l,w){if(!g.isInitialized&&typeof w=="string"&&(w.startsWith("onDid")||w.startsWith("onWill"))){let y=s.get(w);return y||(y=new c.$7c,s.set(w,y)),(A,b,v)=>{if(g.isInitialized)return g.value[w](A,b,v);{const L={listener:[A,b,v],disposable:void 0},O=y.push(L);return(0,P.$Uc)(()=>{O(),L.disposable?.dispose()})}}}if(w in l)return l[w];const S=g.value;let D=S[w];return typeof D!="function"||(D=D.bind(S),l[w]=D),D},set(l,w,S){return g.value[w]=S,!0},getPrototypeOf(l){return d.prototype}})}else{const i=this.o(d,m,o);return t.add(i),i}}y(f,d){if(d&&console.warn(f),this.j)throw new Error(f)}}e.$pr=u;var k;(function(a){a[a.None=0]="None",a[a.Creation=1]="Creation",a[a.Invocation=2]="Invocation",a[a.Branch=3]="Branch"})(k||(k={}));class p{static{this.all=new Set}static{this.c=new class extends p{constructor(){super(k.None,null)}stop(){}branch(){return this}}}static traceInvocation(f,d){return f?new p(k.Invocation,d.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):p.c}static traceCreation(f,d){return f?new p(k.Creation,d.name):p.c}static{this.f=0}constructor(f,d){this.type=f,this.name=d,this.g=Date.now(),this.h=[]}branch(f,d){const m=new p(k.Branch,f.toString());return this.h.push([f,d,m]),m}stop(){const f=Date.now()-this.g;p.f+=f;let d=!1;function m(o,t){const i=[],s=new Array(o+1).join("	");for(const[g,l,w]of t.h)if(l&&w){d=!0,i.push(`${s}CREATES -> ${g}`);const S=m(o+1,w);S&&i.push(S)}else i.push(`${s}uses -> ${g}`);return i.join(`
`)}const n=[`${this.type===k.Creation?"CREATE":"CALL"} ${this.name}`,`${m(1,this)}`,`DONE, took ${f.toFixed(2)}ms (grand total ${p.f.toFixed(2)}ms)`];(f>2||d)&&p.all.add(n.join(`
`))}}e.$qr=p}),define(Ee[12],ye([1,0,227,55,4,60,3,29,11,23,18,2,36,5]),function(ce,e,r,h,P,R,T,N,$,c,I,E,u,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rk=e.$mk=e.$lk=e.$kk=e.$jk=e.$ik=e.$hk=e.$gk=e.$fk=e.$ek=e.$ck=e.LogLevel=e.$ak=e.$_j=void 0,e.$bk=a,e.log=d,e.$nk=D,e.$ok=y,e.$pk=C,e.$qk=A,r=We(r),e.$_j=(0,k.$Fi)("logService"),e.$ak=(0,k.$Fi)("loggerService");function p(){return new Date().toISOString()}function a(b){return(0,I.$jg)(b)}var f;(function(b){b[b.Off=0]="Off",b[b.Trace=1]="Trace",b[b.Debug=2]="Debug",b[b.Info=3]="Info",b[b.Warning=4]="Warning",b[b.Error=5]="Error"})(f||(e.LogLevel=f={})),e.$ck=f.Info;function d(b,v,L){switch(v){case f.Trace:b.trace(L);break;case f.Debug:b.debug(L);break;case f.Info:b.info(L);break;case f.Warning:b.warn(L);break;case f.Error:b.error(L);break;case f.Off:break;default:throw new Error(`Invalid log level ${v}`)}}function m(b,v=!1){let L="";for(let O=0;O<b.length;O++){let M=b[O];if(M instanceof Error&&(M=(0,h.$qj)(M,v)),typeof M=="object")try{M=JSON.stringify(M)}catch{}L+=(O>0?" ":"")+M}return L}class n extends T.$Wc{constructor(){super(...arguments),this.b=e.$ck,this.c=this.B(new P.$me),this.onDidChangeLogLevel=this.c.event}setLevel(v){this.b!==v&&(this.b=v,this.c.fire(this.b))}getLevel(){return this.b}f(v){return this.b!==f.Off&&this.b<=v}}e.$ek=n;class o extends n{constructor(v){super(),this.h=v}f(v){return this.h||super.f(v)}trace(v,...L){this.f(f.Trace)&&this.g(f.Trace,m([v,...L],!0))}debug(v,...L){this.f(f.Debug)&&this.g(f.Debug,m([v,...L]))}info(v,...L){this.f(f.Info)&&this.g(f.Info,m([v,...L]))}warn(v,...L){this.f(f.Warning)&&this.g(f.Warning,m([v,...L]))}error(v,...L){if(this.f(f.Error))if(v instanceof Error){const O=Array.prototype.slice.call(arguments);O[0]=v.stack,this.g(f.Error,m(O))}else this.g(f.Error,m([v,...L]))}flush(){}}e.$fk=o;class t extends n{constructor(v=e.$ck){super(),this.setLevel(v),this.g=!$.$i}trace(v,...L){this.f(f.Trace)&&(this.g?console.log(`\x1B[90m[main ${p()}]\x1B[0m`,v,...L):console.log(`[main ${p()}]`,v,...L))}debug(v,...L){this.f(f.Debug)&&(this.g?console.log(`\x1B[90m[main ${p()}]\x1B[0m`,v,...L):console.log(`[main ${p()}]`,v,...L))}info(v,...L){this.f(f.Info)&&(this.g?console.log(`\x1B[90m[main ${p()}]\x1B[0m`,v,...L):console.log(`[main ${p()}]`,v,...L))}warn(v,...L){this.f(f.Warning)&&(this.g?console.warn(`\x1B[93m[main ${p()}]\x1B[0m`,v,...L):console.warn(`[main ${p()}]`,v,...L))}error(v,...L){this.f(f.Error)&&(this.g?console.error(`\x1B[91m[main ${p()}]\x1B[0m`,v,...L):console.error(`[main ${p()}]`,v,...L))}flush(){}}e.$gk=t;class i extends n{constructor(v=e.$ck,L=!0){super(),this.g=L,this.setLevel(v)}trace(v,...L){this.f(f.Trace)&&(this.g?console.log("%cTRACE","color: #888",v,...L):console.log(v,...L))}debug(v,...L){this.f(f.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",v,...L):console.log(v,...L))}info(v,...L){this.f(f.Info)&&(this.g?console.log("%c INFO","color: #33f",v,...L):console.log(v,...L))}warn(v,...L){this.f(f.Warning)&&(this.g?console.log("%c WARN","color: #993",v,...L):console.log(v,...L))}error(v,...L){this.f(f.Error)&&(this.g?console.log("%c  ERR","color: #f33",v,...L):console.error(v,...L))}flush(){}}e.$hk=i;class s extends n{constructor(v,L=e.$ck){super(),this.g=v,this.setLevel(L)}trace(v,...L){this.f(f.Trace)&&this.g.log(f.Trace,[this.h(v),...L])}debug(v,...L){this.f(f.Debug)&&this.g.log(f.Debug,[this.h(v),...L])}info(v,...L){this.f(f.Info)&&this.g.log(f.Info,[this.h(v),...L])}warn(v,...L){this.f(f.Warning)&&this.g.log(f.Warning,[this.h(v),...L])}error(v,...L){this.f(f.Error)&&this.g.log(f.Error,[this.h(v),...L])}h(v){return typeof v=="string"?v:(0,h.$qj)(v,this.f(f.Trace))}flush(){}}e.$ik=s;class g extends n{constructor(v){super(),this.g=v,v.length&&this.setLevel(v[0].getLevel())}setLevel(v){for(const L of this.g)L.setLevel(v);super.setLevel(v)}trace(v,...L){for(const O of this.g)O.trace(v,...L)}debug(v,...L){for(const O of this.g)O.debug(v,...L)}info(v,...L){for(const O of this.g)O.info(v,...L)}warn(v,...L){for(const O of this.g)O.warn(v,...L)}error(v,...L){for(const O of this.g)O.error(v,...L)}flush(){for(const v of this.g)v.flush()}dispose(){for(const v of this.g)v.dispose();super.dispose()}}e.$jk=g;class l extends T.$Wc{constructor(v,L,O){if(super(),this.h=v,this.j=L,this.b=new N.$Cc,this.c=this.B(new P.$me),this.onDidChangeLoggers=this.c.event,this.f=this.B(new P.$me),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new P.$me),this.onDidChangeVisibility=this.g.event,O)for(const M of O)this.b.set(M.resource,{logger:void 0,info:M})}m(v){return(0,I.$fg)(v)?[...this.b.values()].find(L=>L.info.id===v):this.b.get(v)}getLogger(v){return this.m(v)?.logger}createLogger(v,L){const O=this.n(v),M=(0,I.$fg)(v)?v:L?.id??(0,R.$tj)(O.toString()).toString(16);let j=this.b.get(O)?.logger;const z=L?.logLevel==="always"?f.Trace:L?.logLevel;j||(j=this.s(O,z??this.getLogLevel(O)??this.h,{...L,id:M}));const F={logger:j,info:{resource:O,id:M,logLevel:z,name:L?.name,hidden:L?.hidden,extensionId:L?.extensionId,when:L?.when}};return this.registerLogger(F.info),this.b.set(O,F),j}n(v){return(0,I.$fg)(v)?(0,c.$gh)(this.j,`${v}.log`):v}setLogLevel(v,L){if(E.URI.isUri(v)){const O=v,M=L,j=this.b.get(O);j&&M!==j.info.logLevel&&(j.info.logLevel=M===this.h?void 0:M,j.logger?.setLevel(M),this.b.set(j.info.resource,j),this.f.fire([O,M]))}else{this.h=v;for(const[O,M]of this.b.entries())this.b.get(O)?.info.logLevel===void 0&&M.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(v,L){const O=this.m(v);O&&L!==!O.info.hidden&&(O.info.hidden=!L,this.b.set(O.info.resource,O),this.g.fire([O.info.resource,L]))}getLogLevel(v){let L;return v&&(L=this.b.get(v)?.info.logLevel),L??this.h}registerLogger(v){const L=this.b.get(v.resource);L?L.info.hidden!==v.hidden&&this.setVisibility(v.resource,!v.hidden):(this.b.set(v.resource,{info:v,logger:void 0}),this.c.fire({added:[v],removed:[]}))}deregisterLogger(v){const L=this.b.get(v);L&&(L.logger&&L.logger.dispose(),this.b.delete(v),this.c.fire({added:[],removed:[L.info]}))}*getRegisteredLoggers(){for(const v of this.b.values())yield v.info}getRegisteredLogger(v){return this.b.get(v)?.info}dispose(){this.b.forEach(v=>v.logger?.dispose()),this.b.clear(),super.dispose()}}e.$kk=l;class w{constructor(){this.onDidChangeLogLevel=new P.$me().event}setLevel(v){}getLevel(){return f.Info}trace(v,...L){}debug(v,...L){}info(v,...L){}warn(v,...L){}error(v,...L){}critical(v,...L){}dispose(){}flush(){}}e.$lk=w;class S extends w{}e.$mk=S;function D(b){if(b.verbose)return f.Trace;if(typeof b.logLevel=="string"){const v=A(b.logLevel.toLowerCase());if(v!==void 0)return v}return e.$ck}function y(b){switch(b){case f.Trace:return"trace";case f.Debug:return"debug";case f.Info:return"info";case f.Warning:return"warn";case f.Error:return"error";case f.Off:return"off"}}function C(b){switch(b){case f.Trace:return{original:"Trace",value:r.localize(0,null)};case f.Debug:return{original:"Debug",value:r.localize(1,null)};case f.Info:return{original:"Info",value:r.localize(2,null)};case f.Warning:return{original:"Warning",value:r.localize(3,null)};case f.Error:return{original:"Error",value:r.localize(4,null)};case f.Off:return{original:"Off",value:r.localize(5,null)}}}function A(b){switch(b){case"trace":return f.Trace;case"debug":return f.Debug;case"info":return f.Info;case"warn":return f.Warning;case"error":return f.Error;case"critical":return f.Error;case"off":return f.Off}}e.$rk=new u.$Wj("logLevel",y(f.Info))}),define(Ee[276],ye([1,0,19,9,14,4,33,3,16,70,12]),function(ce,e,r,h,P,R,T,N,$,c,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8q=void 0;class E extends N.$Wc{constructor(k,p){super(),this.a=k,this.b=p,this.c=this.B(new R.$me),this.onDidChangeFile=this.c.event,this.g=this.B(new R.$me),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new h.$Dh(0)),this.w=[],this.y=this.B(new h.$Dh(0))}watch(k,p){return p.recursive||this.b?.watcher?.forceUniversal?this.n(k,p):this.z(k,p)}n(k,p){const a={path:this.J(k),excludes:p.excludes,includes:p.includes,recursive:p.recursive,filter:p.filter,correlationId:p.correlationId},f=(0,r.$Vb)(this.j,a);return this.r(),(0,N.$Uc)(()=>{f(),this.r()})}r(){this.m.trigger(()=>this.s()).catch(k=>(0,P.$3)(k))}s(){this.h||(this.h=this.B(this.t(p=>this.c.fire((0,c.$2q)(p)),p=>this.G(p),this.a.getLevel()===I.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===I.LogLevel.Trace)})));const k=this.b?.watcher?.recursive?.usePolling;if(k===!0)for(const p of this.j)(0,c.$Xq)(p)&&(p.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(k))for(const p of this.j)(0,c.$Xq)(p)&&k.includes(p.path)&&(p.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z(k,p){const a={path:this.J(k),excludes:p.excludes,includes:p.includes,recursive:!1,filter:p.filter,correlationId:p.correlationId},f=(0,r.$Vb)(this.w,a);return this.C(),(0,N.$Uc)(()=>{f(),this.C()})}C(){this.y.trigger(()=>this.D()).catch(k=>(0,P.$3)(k))}D(){return this.u||(this.u=this.B(this.F(k=>this.c.fire((0,c.$2q)(k)),k=>this.G(k),this.a.getLevel()===I.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===I.LogLevel.Trace)}))),this.u.watch(this.w)}G(k){k.type==="error"&&this.g.fire(k.message),this.H(k)}H(k){this.a[k.type](k.message)}I(k){return(0,$.$jc)(k.fsPath)}J(k){const p=this.I(k);return(0,T.$Hg)(p)}}e.$8q=E}),define(Ee[277],ye([1,0,9,29,22,4,33,3,16,11,23,104,34,226,28,269,276,274,273]),function(ce,e,r,h,P,R,T,N,$,c,I,E,u,k,p,a,f,d,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mr=void 0;class n extends f.$8q{static{this.L=!1}constructor(t,i){super(t,i),this.onDidChangeCapabilities=R.Event.None,this.P=new h.$Cc(s=>I.$0g.getComparisonKey(s)),this.X=new Map,this.Y=new Map,this.Z=new Map}get capabilities(){return this.M||(this.M=p.FileSystemProviderCapabilities.FileReadWrite|p.FileSystemProviderCapabilities.FileOpenReadWriteClose|p.FileSystemProviderCapabilities.FileReadStream|p.FileSystemProviderCapabilities.FileFolderCopy|p.FileSystemProviderCapabilities.FileWriteUnlock|p.FileSystemProviderCapabilities.FileAtomicRead|p.FileSystemProviderCapabilities.FileAtomicWrite|p.FileSystemProviderCapabilities.FileAtomicDelete|p.FileSystemProviderCapabilities.FileClone,c.$k&&(this.M|=p.FileSystemProviderCapabilities.PathCaseSensitive)),this.M}async stat(t){try{const{stat:i,symbolicLink:s}=await u.SymlinkSupport.stat(this.I(t));return{type:this.O(i,s),ctime:i.birthtime.getTime(),mtime:i.mtime.getTime(),size:i.size,permissions:i.mode&128?void 0:p.FilePermission.Locked}}catch(i){throw this.hb(i)}}async N(t){try{return await this.stat(t)}catch{return}}async readdir(t){try{const i=await u.Promises.readdir(this.I(t),{withFileTypes:!0}),s=[];return await Promise.all(i.map(async g=>{try{let l;g.isSymbolicLink()?l=(await this.stat((0,I.$gh)(t,g.name))).type:l=this.O(g),s.push([g.name,l])}catch(l){this.a.trace(l)}})),s}catch(i){throw this.hb(i)}}O(t,i){let s;return i?.dangling?s=p.FileType.Unknown:t.isFile()?s=p.FileType.File:t.isDirectory()?s=p.FileType.Directory:s=p.FileType.Unknown,i&&(s|=p.FileType.SymbolicLink),s}async Q(t){const i=this.I(t);this.R(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${i})`);let s;for(;s=this.P.get(t);)this.R(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${i})`),await s.wait();const g=new r.$Eh;return this.P.set(t,g),this.R(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${i})`),(0,N.$Uc)(()=>{this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${i})`),this.P.get(t)===g&&(this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${i})`),this.P.delete(t)),this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${i})`),g.open()})}async readFile(t,i){let s;try{i?.atomic&&(this.R(`[Disk FileSystemProvider]: atomic read operation started (${this.I(t)})`),s=await this.Q(t));const g=this.I(t);return await u.Promises.readFile(g)}catch(g){throw this.hb(g)}finally{s?.dispose()}}R(t){n.L&&this.a.trace(t)}readFileStream(t,i,s){const g=(0,E.$Ce)(l=>P.$Oe.concat(l.map(w=>P.$Oe.wrap(w))).buffer);return(0,a.$Uq)(this,t,g,l=>l.buffer,{...i,bufferSize:256*1024},s),g}async writeFile(t,i,s){return s?.atomic!==!1&&s?.atomic?.postfix&&await this.S(t)?this.U(t,(0,I.$gh)((0,I.$fh)(t),`${(0,I.$dh)(t)}${s.atomic.postfix}`),i,s):this.W(t,i,s)}async S(t){try{const i=this.I(t),{symbolicLink:s}=await u.SymlinkSupport.stat(i);if(s)return!1}catch{}return!0}async U(t,i,s,g){const l=new N.$Vc;try{l.add(await this.Q(t)),l.add(await this.Q(i)),await this.W(i,s,g,!0);try{await this.rename(i,t,{overwrite:!0})}catch(w){try{await this.delete(i,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw w}}finally{l.dispose()}}async W(t,i,s,g){let l;try{const w=this.I(t);if(!s.create||!s.overwrite){if(await u.Promises.exists(w)){if(!s.overwrite)throw(0,p.$ml)((0,k.localize)(0,null),p.FileSystemProviderErrorCode.FileExists)}else if(!s.create)throw(0,p.$ml)((0,k.localize)(1,null),p.FileSystemProviderErrorCode.FileNotFound)}l=await this.open(t,{create:!0,unlock:s.unlock},g),await this.write(l,0,i,0,i.byteLength)}catch(w){throw await this.ib(t,w)}finally{typeof l=="number"&&await this.close(l)}}static{this.$=!0}static configureFlushOnWrite(t){n.$=t}async open(t,i,s){const g=this.I(t);let l;(0,p.$al)(i)&&!s&&(l=await this.Q(t));let w;try{if((0,p.$al)(i)&&i.unlock)try{const{stat:D}=await u.SymlinkSupport.stat(g);D.mode&128||await u.Promises.chmod(g,D.mode|128)}catch(D){D.code!=="ENOENT"&&this.a.trace(D)}let S;if((0,p.$al)(i)){if(c.$i)try{await u.Promises.truncate(g,0),S="r+"}catch(D){D.code!=="ENOENT"&&this.a.trace(D)}S||(S="w")}else S="r";w=await u.Promises.open(g,S)}catch(S){throw l?.dispose(),(0,p.$al)(i)?await this.ib(t,S):this.hb(S)}if(this.X.set(w,0),(0,p.$al)(i)&&this.Z.set(w,t),l){const S=this.Y.get(w);this.R(`[Disk FileSystemProvider]: open() - storing lock for handle ${w} (${g})`),this.Y.set(w,l),S&&(this.R(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${w} (${g})`),S.dispose())}return w}async close(t){const i=this.Y.get(t);try{if(this.X.delete(t),this.Z.delete(t)&&n.$)try{await u.Promises.fdatasync(t)}catch(s){n.configureFlushOnWrite(!1),this.a.error(s)}return await u.Promises.close(t)}catch(s){throw this.hb(s)}finally{i&&(this.Y.get(t)===i&&(this.R(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${t}`),this.Y.delete(t)),this.R(`[Disk FileSystemProvider]: close() - disposing lock for handle ${t}`),i.dispose())}}async read(t,i,s,g,l){const w=this.ab(t,i);let S=null;try{S=(await u.Promises.read(t,s,g,l,w)).bytesRead}catch(D){throw this.hb(D)}finally{this.bb(t,w,S)}return S}ab(t,i){return i===this.X.get(t)?null:i}bb(t,i,s){const g=this.X.get(t);typeof g=="number"&&(typeof i=="number"||(typeof s=="number"?this.X.set(t,g+s):this.X.delete(t)))}async write(t,i,s,g,l){return(0,r.$Zh)(()=>this.cb(t,i,s,g,l),100,3)}async cb(t,i,s,g,l){const w=this.ab(t,i);let S=null;try{S=(await u.Promises.write(t,s,g,l,w)).bytesWritten}catch(D){throw await this.ib(this.Z.get(t),D)}finally{this.bb(t,w,S)}return S}async mkdir(t){try{await u.Promises.mkdir(this.I(t))}catch(i){throw this.hb(i)}}async delete(t,i){try{const s=this.I(t);if(i.recursive){let g;i?.atomic!==!1&&i.atomic.postfix&&(g=(0,$.$lc)((0,$.$oc)(s),`${(0,$.$pc)(s)}${i.atomic.postfix}`)),await u.Promises.rm(s,u.RimRafMode.MOVE,g)}else try{await u.Promises.unlink(s)}catch(g){if(g.code==="EPERM"||g.code==="EISDIR"){let l=!1;try{const{stat:w,symbolicLink:S}=await u.SymlinkSupport.stat(s);l=w.isDirectory()&&!S}catch{}if(l)await u.Promises.rmdir(s);else throw g}else throw g}}catch(s){throw this.hb(s)}}async rename(t,i,s){const g=this.I(t),l=this.I(i);if(g!==l)try{await this.db(t,i,"move",s.overwrite),await u.Promises.rename(g,l)}catch(w){throw(w.code==="EINVAL"||w.code==="EBUSY"||w.code==="ENAMETOOLONG")&&(w=new Error((0,k.localize)(2,null,(0,$.$pc)(g),(0,$.$pc)((0,$.$oc)(l)),w.toString()))),this.hb(w)}}async copy(t,i,s){const g=this.I(t),l=this.I(i);if(g!==l)try{await this.db(t,i,"copy",s.overwrite),await u.Promises.copy(g,l,{preserveSymlinks:!0})}catch(w){throw(w.code==="EINVAL"||w.code==="EBUSY"||w.code==="ENAMETOOLONG")&&(w=new Error((0,k.localize)(3,null,(0,$.$pc)(g),(0,$.$pc)((0,$.$oc)(l)),w.toString()))),this.hb(w)}}async db(t,i,s,g){const l=this.I(t),w=this.I(i);let S=!1;if(!!(this.capabilities&p.FileSystemProviderCapabilities.PathCaseSensitive)||(S=(0,T.$Dg)(l,w,!0)),S){if(s==="copy")throw(0,p.$ml)((0,k.localize)(4,null),p.FileSystemProviderErrorCode.FileExists);if(s==="move")return}const y=await this.N(t);if(!y)throw(0,p.$ml)((0,k.localize)(5,null),p.FileSystemProviderErrorCode.FileNotFound);const C=await this.N(i);if(C){if(!g)throw(0,p.$ml)((0,k.localize)(6,null),p.FileSystemProviderErrorCode.FileExists);y.type&p.FileType.File&&C.type&p.FileType.File||await this.delete(i,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(t,i){return this.eb(t,i,!1)}async eb(t,i,s){const g=this.I(t),l=this.I(i),w=!!(this.capabilities&p.FileSystemProviderCapabilities.PathCaseSensitive);if((0,T.$Dg)(g,l,!w))return;const S=new N.$Vc;try{S.add(await this.Q(t)),S.add(await this.Q(i)),s&&await u.Promises.mkdir((0,$.$oc)(l),{recursive:!0}),await u.Promises.copyFile(g,l)}catch(D){if(D.code==="ENOENT"&&!s)return this.eb(t,i,!0);throw this.hb(D)}finally{S.dispose()}}t(t,i,s){return new d.$cr(g=>t(g),g=>i(g),s)}F(t,i,s){return new m.$lr(g=>t(g),g=>i(g),s)}hb(t){if(t instanceof p.$ll)return t;let i=t,s;switch(t.code){case"ENOENT":s=p.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":s=p.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":s=p.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":s=p.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":s=p.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":i=`${t.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,s=p.FileSystemProviderErrorCode.Unknown;break;default:s=p.FileSystemProviderErrorCode.Unknown}return(0,p.$ml)(i,s)}async ib(t,i){let s=this.hb(i);if(t&&s.code===p.FileSystemProviderErrorCode.NoPermissions)try{const{stat:g}=await u.SymlinkSupport.stat(this.I(t));g.mode&128||(s=(0,p.$ml)(i,p.FileSystemProviderErrorCode.FileWriteLocked))}catch(g){this.a.trace(g)}return s}}e.$mr=n}),define(Ee[278],ye([1,0,3,12]),function(ce,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lR=void 0;class P extends r.$Wc{constructor(T,N=[]){super(),this.a=new h.$jk([T,...N]),this.B(T.onDidChangeLogLevel($=>this.setLevel($)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(T){this.a.setLevel(T)}getLevel(){return this.a.getLevel()}trace(T,...N){this.a.trace(T,...N)}debug(T,...N){this.a.debug(T,...N)}info(T,...N){this.a.info(T,...N)}warn(T,...N){this.a.warn(T,...N)}error(T,...N){this.a.error(T,...N)}flush(){this.a.flush()}}e.$lR=P}),define(Ee[279],ye([1,0,28,12]),function(ce,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aR=void 0;var P;(function(c){c[c.Trace=0]="Trace",c[c.Debug=1]="Debug",c[c.Info=2]="Info",c[c.Warning=3]="Warning",c[c.Error=4]="Error",c[c.Critical=5]="Critical",c[c.Off=6]="Off"})(P||(P={}));async function R(c,I,E,u,k){try{const p=await new Promise((f,d)=>{ce(["@vscode/spdlog"],f,d)}).then(We);p.setFlushOn(P.Trace);const a=await p.createAsyncRotatingLogger(c,I,E,u);return k?a.clearFormatters():a.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),a}catch(p){console.error(p)}return null}function T(c,I,E){switch(I){case h.LogLevel.Trace:c.trace(E);break;case h.LogLevel.Debug:c.debug(E);break;case h.LogLevel.Info:c.info(E);break;case h.LogLevel.Warning:c.warn(E);break;case h.LogLevel.Error:c.error(E);break;case h.LogLevel.Off:break;default:throw new Error(`Invalid log level ${I}`)}}function N(c,I){switch(I){case h.LogLevel.Trace:c.setLevel(P.Trace);break;case h.LogLevel.Debug:c.setLevel(P.Debug);break;case h.LogLevel.Info:c.setLevel(P.Info);break;case h.LogLevel.Warning:c.setLevel(P.Warning);break;case h.LogLevel.Error:c.setLevel(P.Error);break;case h.LogLevel.Off:c.setLevel(P.Off);break;default:throw new Error(`Invalid log level ${I}`)}}class $ extends h.$fk{constructor(I,E,u,k,p){super(),this.m=[],this.setLevel(p),this.n=this.s(I,E,u,k),this.B(this.onDidChangeLogLevel(a=>{this.r&&N(this.r,a)}))}async s(I,E,u,k){const p=u?6:1,a=30/p*r.$Hl.MB,f=await R(I,E,a,p,k);if(f){this.r=f,N(this.r,this.getLevel());for(const{level:d,message:m}of this.m)T(this.r,d,m);this.m=[]}}g(I,E){this.r?T(this.r,I,E):this.getLevel()<=I&&this.m.push({level:I,message:E})}flush(){this.r?this.r.flush():this.n.then(()=>this.flush())}dispose(){this.r?this.u():this.n.then(()=>this.u()),super.dispose()}u(){this.r&&(this.r.drop(),this.r=void 0)}}e.$aR=$});var zt=this&&this.__importDefault||function(ce){return ce&&ce.__esModule?ce:{default:ce}};define(Ee[145],ye([1,0,44,228,5]),function(ce,e,r,h,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yu=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0,r=zt(r);var R;(function($){$[$.Unnecessary=1]="Unnecessary",$[$.Deprecated=2]="Deprecated"})(R||(e.MarkerTag=R={}));var T;(function($){$[$.Hint=1]="Hint",$[$.Info=2]="Info",$[$.Warning=4]="Warning",$[$.Error=8]="Error"})(T||(e.MarkerSeverity=T={})),function($){function c(p,a){return a-p}$.compare=c;const I=Object.create(null);I[$.Error]=(0,h.localize)(0,null),I[$.Warning]=(0,h.localize)(1,null),I[$.Info]=(0,h.localize)(2,null);function E(p){return I[p]||""}$.toString=E;function u(p){switch(p){case r.default.Error:return $.Error;case r.default.Warning:return $.Warning;case r.default.Info:return $.Info;case r.default.Ignore:return $.Hint}}$.fromSeverity=u;function k(p){switch(p){case $.Error:return r.default.Error;case $.Warning:return r.default.Warning;case $.Info:return r.default.Info;case $.Hint:return r.default.Ignore}}$.toSeverity=k}(T||(e.MarkerSeverity=T={}));var N;(function($){const c="";function I(u){return E(u,!0)}$.makeKey=I;function E(u,k){const p=[c];return u.source?p.push(u.source.replace("\xA6","\\\xA6")):p.push(c),u.code?typeof u.code=="string"?p.push(u.code.replace("\xA6","\\\xA6")):p.push(u.code.value.replace("\xA6","\\\xA6")):p.push(c),u.severity!==void 0&&u.severity!==null?p.push(T.toString(u.severity)):p.push(c),u.message&&k?p.push(u.message.replace("\xA6","\\\xA6")):p.push(c),u.startLineNumber!==void 0&&u.startLineNumber!==null?p.push(u.startLineNumber.toString()):p.push(c),u.startColumn!==void 0&&u.startColumn!==null?p.push(u.startColumn.toString()):p.push(c),u.endLineNumber!==void 0&&u.endLineNumber!==null?p.push(u.endLineNumber.toString()):p.push(c),u.endColumn!==void 0&&u.endColumn!==null?p.push(u.endColumn.toString()):p.push(c),p.push(c),p.join("\xA6")}$.makeKeyOptionalMessage=E})(N||(e.IMarkerData=N={})),e.$yu=(0,P.$Fi)("markerService")});var zt=this&&this.__importDefault||function(ce){return ce&&ce.__esModule?ce:{default:ce}};define(Ee[280],ye([1,0,4,44,5]),function(ce,e,r,h,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ow=e.$nw=e.NotificationsFilter=e.NeverShowAgainScope=e.NotificationPriority=e.$lw=e.Severity=void 0,e.$mw=N,h=zt(h),e.Severity=h.default,e.$lw=(0,P.$Fi)("notificationService");var R;(function(E){E[E.DEFAULT=0]="DEFAULT",E[E.SILENT=1]="SILENT",E[E.URGENT=2]="URGENT"})(R||(e.NotificationPriority=R={}));var T;(function(E){E[E.WORKSPACE=0]="WORKSPACE",E[E.PROFILE=1]="PROFILE",E[E.APPLICATION=2]="APPLICATION"})(T||(e.NeverShowAgainScope=T={}));function N(E){if(E){const u=E;return typeof u.id=="string"&&typeof u.label=="string"}return!1}var $;(function(E){E[E.OFF=0]="OFF",E[E.ERROR=1]="ERROR"})($||(e.NotificationsFilter=$={}));class c{constructor(){this.progress=new I,this.onDidClose=r.Event.None,this.onDidChangeVisibility=r.Event.None}updateSeverity(u){}updateMessage(u){}updateActions(u){}close(){}}e.$nw=c;class I{infinite(){}done(){}total(u){}worked(u){}}e.$ow=I}),define(Ee[281],ye([1,0,56]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let h;const P=globalThis.vscode;if(typeof P<"u"&&typeof P.context<"u"){const R=P.context.configuration();if(R)h=R.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(h=globalThis._VSCODE_PRODUCT_JSON,r.env.VSCODE_DEV&&Object.assign(h,{nameShort:`${h.nameShort} Dev`,nameLong:`${h.nameLong} Dev`,dataFolderName:`${h.dataFolderName}-dev`,serverDataFolderName:h.serverDataFolderName?`${h.serverDataFolderName}-dev`:void 0}),!h.version){const R=globalThis._VSCODE_PACKAGE_JSON;Object.assign(h,{version:R.version})}}else h={},Object.keys(h).length===0&&Object.assign(h,{version:"1.91.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=h}),define(Ee[116],ye([1,0,5]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tk=e.$sk=void 0,e.$sk=(0,r.$Fi)("productService"),e.$tk="vscode://schemas/vscode-product"});var Ge=this&&this.__param||function(ce,e){return function(r,h){e(r,h,ce)}};define(Ee[90],ye([1,0,9,21,3,5]),function(ce,e,r,h,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vw=e.$uw=e.$tw=e.$sw=e.$rw=e.$qw=e.ProgressLocation=e.$pw=void 0,e.$pw=(0,R.$Fi)("progressService");var T;(function(E){E[E.Explorer=1]="Explorer",E[E.Scm=3]="Scm",E[E.Extensions=5]="Extensions",E[E.Window=10]="Window",E[E.Notification=15]="Notification",E[E.Dialog=20]="Dialog"})(T||(e.ProgressLocation=T={})),e.$qw=Object.freeze({total(){},worked(){},done(){}});class N{static{this.None=Object.freeze({report(){}})}get value(){return this.a}constructor(u){this.b=u}report(u){this.a=u,this.b(this.a)}}e.$rw=N;class ${get value(){return this.a}constructor(u){this.e=u}report(u){this.b?this.b.push(u):this.b=[u],this.f()}async f(){if(!this.c)try{for(this.c=!0;this.b&&this.b.length;){const u=this.b.shift();this.a=u,await this.e(this.a)}}finally{this.c=!1;const u=this.d;this.d=void 0,u?.()}}drain(){return this.c?new Promise(u=>{const k=this.d;this.d=()=>{k?.(),u()}}):Promise.resolve()}}e.$sw=$;let c=class extends P.$Wc{constructor(u,k){super(),this.a=new r.$3h,k.withProgress(u,p=>(this.b=p,this.c&&p.report(this.c),this.a.p)),this.B((0,P.$Uc)(()=>this.a.complete()))}report(u){this.b?this.b.report(u):this.c=u}};e.$tw=c,e.$tw=c=Je([Ge(1,e.$pw)],c);class I extends P.$Wc{constructor(u){super(),this.g=u,this.a=0,this.b=this.B(new P.$Vc)}start(u){this.stop();const k=++this.a,p=new h.$xe;return this.f=setTimeout(()=>{k===this.a&&(this.c=this.g.show(!0))},u),this.b.add((0,P.$Uc)(()=>clearTimeout(this.f))),this.b.add((0,P.$Uc)(()=>p.cancel())),this.b.add((0,P.$Uc)(()=>this.c?this.c.done():void 0)),{id:k,token:p.token,stop:()=>this.h(k),isCurrent:()=>this.a===k}}stop(){this.h(this.a)}h(u){this.a===u&&this.b.clear()}}e.$uw=I,e.$vw=(0,R.$Fi)("editorProgressService")}),define(Ee[37],ye([1,0,66,18]),function(ce,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oo=void 0,r=We(r),h=We(h);class P{constructor(){this.a=new Map}add(T,N){r.ok(h.$fg(T)),r.ok(h.$hg(N)),r.ok(!this.a.has(T),"There is already an extension with this id"),this.a.set(T,N)}knows(T){return this.a.has(T)}as(T){return this.a.get(T)||null}}e.$oo=new P}),define(Ee[117],ye([1,0,4,37]),function(ce,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$po=void 0,h=We(h),e.$po={JSONContribution:"base.contributions.json"};function P(N){return N.length>0&&N.charAt(N.length-1)==="#"?N.substring(0,N.length-1):N}class R{constructor(){this.b=new r.$me,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema($,c){this.a[P($)]=c,this.b.fire($)}notifySchemaChanged($){this.b.fire($)}getSchemaContributions(){return{schemas:this.a}}}const T=new R;h.$oo.add(e.$po.JSONContribution,T)}),define(Ee[71],ye([1,0,19,4,18,217,45,117,37]),function(ce,e,r,h,P,R,T,N,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Do=e.$Co=e.$Bo=e.$Ao=e.$zo=e.$yo=e.$xo=e.$wo=e.$vo=e.$uo=e.ConfigurationScope=e.$to=e.EditPresentationTypes=void 0,e.$Eo=a,e.$Fo=f,e.$Go=d,e.$Ho=n,e.$Io=o,P=We(P),R=We(R);var c;(function(t){t.Multiline="multilineText",t.Singleline="singlelineText"})(c||(e.EditPresentationTypes=c={})),e.$to={Configuration:"base.contributions.configuration"};var I;(function(t){t[t.APPLICATION=1]="APPLICATION",t[t.MACHINE=2]="MACHINE",t[t.WINDOW=3]="WINDOW",t[t.RESOURCE=4]="RESOURCE",t[t.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",t[t.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(I||(e.ConfigurationScope=I={})),e.$uo={properties:{},patternProperties:{}},e.$vo={properties:{},patternProperties:{}},e.$wo={properties:{},patternProperties:{}},e.$xo={properties:{},patternProperties:{}},e.$yo={properties:{},patternProperties:{}},e.$zo={properties:{},patternProperties:{}},e.$Ao="vscode://schemas/settings/resourceLanguage",e.$Bo="vscode://schemas/settings/configurationDefaults";const E=$.$oo.as(N.$po.JSONContribution);class u{constructor(){this.h=new Set,this.i=new h.$me,this.onDidSchemaChange=this.i.event,this.j=new h.$me,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:R.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},E.registerSchema(e.$Ao,this.g),this.v()}registerConfiguration(i,s=!0){this.registerConfigurations([i],s)}registerConfigurations(i,s=!0){const g=new Set;this.n(i,s,g),E.registerSchema(e.$Ao,this.g),this.i.fire(),this.j.fire({properties:g})}deregisterConfigurations(i){const s=new Set;this.o(i,s),E.registerSchema(e.$Ao,this.g),this.i.fire(),this.j.fire({properties:s})}updateConfigurations({add:i,remove:s}){const g=new Set;this.o(s,g),this.n(i,!1,g),E.registerSchema(e.$Ao,this.g),this.i.fire(),this.j.fire({properties:g})}registerDefaultConfigurations(i){const s=new Set;this.k(i,s),this.i.fire(),this.j.fire({properties:s,defaultsOverrides:!0})}k(i,s){const g=[];for(const{overrides:l,source:w}of i)for(const S in l)if(s.add(S),e.$Do.test(S)){const D=this.a.get(S),y=D?.valuesSources??new Map;if(w)for(const v of Object.keys(l[S]))y.set(v,w);const C={...D?.value||{},...l[S]};this.a.set(S,{source:w,value:C,valuesSources:y});const A=(0,T.$jj)(S),b={type:"object",default:C,description:R.localize(1,null,A),$ref:e.$Ao,defaultDefaultValue:C,source:P.$fg(w)?void 0:w,defaultValueSource:w};g.push(...a(S)),this.d[S]=b,this.b.properties[S]=b}else{this.a.set(S,{value:l[S],source:w});const D=this.d[S];D&&(this.w(S,D),this.r(S,D))}this.m(g)}deregisterDefaultConfigurations(i){const s=new Set;this.l(i,s),this.i.fire(),this.j.fire({properties:s,defaultsOverrides:!0})}l(i,s){for(const{overrides:g,source:l}of i)for(const w in g){const S=this.a.get(w),D=P.$fg(l)?l:l?.id,y=P.$fg(S?.source)?S?.source:S?.source?.id;if(D===y)if(s.add(w),this.a.delete(w),e.$Do.test(w))delete this.d[w],delete this.b.properties[w];else{const C=this.d[w];C&&(this.w(w,C),this.r(w,C))}}this.u()}deltaConfiguration(i){let s=!1;const g=new Set;i.removedDefaults&&(this.l(i.removedDefaults,g),s=!0),i.addedDefaults&&(this.k(i.addedDefaults,g),s=!0),i.removedConfigurations&&this.o(i.removedConfigurations,g),i.addedConfigurations&&this.n(i.addedConfigurations,!1,g),this.i.fire(),this.j.fire({properties:g,defaultsOverrides:s})}notifyConfigurationSchemaUpdated(...i){this.i.fire()}registerOverrideIdentifiers(i){this.m(i),this.i.fire()}m(i){for(const s of i)this.h.add(s);this.u()}n(i,s,g){i.forEach(l=>{this.p(l,s,l.extensionInfo,l.restrictedProperties,void 0,g),this.c.push(l),this.q(l)})}o(i,s){const g=l=>{if(l.properties)for(const w in l.properties){s.add(w);const S=this.d[w];S?.policy?.name&&this.e.delete(S.policy.name),delete this.d[w],this.s(w,l.properties[w])}l.allOf?.forEach(w=>g(w))};for(const l of i){g(l);const w=this.c.indexOf(l);w!==-1&&this.c.splice(w,1)}}p(i,s=!0,g,l,w=I.WINDOW,S){w=P.$og(i.scope)?w:i.scope;const D=i.properties;if(D)for(const C in D){const A=D[C];if(s&&n(C,A)){delete D[C];continue}if(A.source=g,A.defaultDefaultValue=D[C].default,this.w(C,A),e.$Do.test(C)?A.scope=void 0:(A.scope=P.$og(A.scope)?w:A.scope,A.restricted=P.$og(A.restricted)?!!l?.includes(C):A.restricted),D[C].hasOwnProperty("included")&&!D[C].included){this.f[C]=D[C],delete D[C];continue}else this.d[C]=D[C],D[C].policy?.name&&this.e.set(D[C].policy.name,C);!D[C].deprecationMessage&&D[C].markdownDeprecationMessage&&(D[C].deprecationMessage=D[C].markdownDeprecationMessage),S.add(C)}const y=i.allOf;if(y)for(const C of y)this.p(C,s,g,l,w,S)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(i){const s=g=>{const l=g.properties;if(l)for(const S in l)this.r(S,l[S]);g.allOf?.forEach(s)};s(i)}r(i,s){switch(e.$uo.properties[i]=s,s.scope){case I.APPLICATION:e.$vo.properties[i]=s;break;case I.MACHINE:e.$wo.properties[i]=s;break;case I.MACHINE_OVERRIDABLE:e.$xo.properties[i]=s;break;case I.WINDOW:e.$yo.properties[i]=s;break;case I.RESOURCE:e.$zo.properties[i]=s;break;case I.LANGUAGE_OVERRIDABLE:e.$zo.properties[i]=s,this.g.properties[i]=s;break}}s(i,s){switch(delete e.$uo.properties[i],s.scope){case I.APPLICATION:delete e.$vo.properties[i];break;case I.MACHINE:delete e.$wo.properties[i];break;case I.MACHINE_OVERRIDABLE:delete e.$xo.properties[i];break;case I.WINDOW:delete e.$yo.properties[i];break;case I.RESOURCE:case I.LANGUAGE_OVERRIDABLE:delete e.$zo.properties[i],delete this.g.properties[i];break}}u(){for(const i of this.h.values()){const s=`[${i}]`,g={type:"object",description:R.localize(2,null),errorMessage:R.localize(3,null),$ref:e.$Ao};this.w(s,g),e.$uo.properties[s]=g,e.$vo.properties[s]=g,e.$wo.properties[s]=g,e.$xo.properties[s]=g,e.$yo.properties[s]=g,e.$zo.properties[s]=g}}v(){const i={type:"object",description:R.localize(4,null),errorMessage:R.localize(5,null),$ref:e.$Ao};e.$uo.patternProperties[e.$Co]=i,e.$vo.patternProperties[e.$Co]=i,e.$wo.patternProperties[e.$Co]=i,e.$xo.patternProperties[e.$Co]=i,e.$yo.patternProperties[e.$Co]=i,e.$zo.patternProperties[e.$Co]=i,this.i.fire()}w(i,s){const g=this.a.get(i);let l=g?.value,w=g?.source;P.$mg(l)&&(l=s.defaultDefaultValue,w=void 0),P.$mg(l)&&(l=d(s.type)),s.default=l,s.defaultValueSource=w}}const k="\\[([^\\]]+)\\]",p=new RegExp(k,"g");e.$Co=`^(${k})+$`,e.$Do=new RegExp(e.$Co);function a(t){const i=[];if(e.$Do.test(t)){let s=p.exec(t);for(;s?.length;){const g=s[1].trim();g&&i.push(g),s=p.exec(t)}}return(0,r.$Ob)(i)}function f(t){return t.reduce((i,s)=>`${i}[${s}]`,"")}function d(t){switch(Array.isArray(t)?t[0]:t){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}const m=new u;$.$oo.add(e.$to.Configuration,m);function n(t,i){return t.trim()?e.$Do.test(t)?R.localize(7,null,t):m.getConfigurationProperties()[t]!==void 0?R.localize(8,null,t):i.policy?.name&&m.getPolicyConfigurations().get(i.policy?.name)!==void 0?R.localize(9,null,t,i.policy?.name,m.getPolicyConfigurations().get(i.policy?.name)):null:R.localize(6,null)}function o(){const t=[],i=m.getConfigurationProperties();for(const s of Object.keys(i))t.push([s,i[s].scope]);return t.push(["launch",I.RESOURCE]),t.push(["task",I.RESOURCE]),t}}),define(Ee[282],ye([1,0,19,4,175,3,29,25,18,2,45,71,28,37]),function(ce,e,r,h,P,R,T,N,$,c,I,E,u,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oo=e.$Mo=e.$Lo=e.$Ko=e.$Jo=void 0,e.$No=o,r=We(r),P=We(P),N=We(N),$=We($);function p(g){return Object.isFrozen(g)?g:N.$co(g)}class a{static createEmptyModel(l){return new a({},[],[],void 0,l)}constructor(l,w,S,D,y){this.b=l,this.c=w,this.d=S,this.raw=D,this.f=y,this.a=new Map}get rawConfiguration(){if(!this.g)if(this.raw?.length){const l=this.raw.map(w=>{if(w instanceof a)return w;const S=new f("",this.f);return S.parseRaw(w),S.configurationModel});this.g=l.reduce((w,S)=>S===w?S:w.merge(S),l[0])}else this.g=this;return this.g}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(l){return l?(0,I.$hj)(this.contents,l):this.contents}inspect(l,w){const S=this;return{get value(){return p(S.rawConfiguration.getValue(l))},get override(){return w?p(S.rawConfiguration.getOverrideValue(l,w)):void 0},get merged(){return p(w?S.rawConfiguration.override(w).getValue(l):S.rawConfiguration.getValue(l))},get overrides(){const D=[];for(const{contents:y,identifiers:C,keys:A}of S.rawConfiguration.overrides){const b=new a(y,A,[],void 0,S.f).getValue(l);b!==void 0&&D.push({identifiers:C,value:b})}return D.length?p(D):void 0}}}getOverrideValue(l,w){const S=this.j(w);return S?l?(0,I.$hj)(S,l):S:void 0}getKeysForOverrideIdentifier(l){const w=[];for(const S of this.overrides)S.identifiers.includes(l)&&w.push(...S.keys);return r.$Ob(w)}getAllOverrideIdentifiers(){const l=[];for(const w of this.overrides)l.push(...w.identifiers);return r.$Ob(l)}override(l){let w=this.a.get(l);return w||(w=this.h(l),this.a.set(l,w)),w}merge(...l){const w=N.$bo(this.contents),S=N.$bo(this.overrides),D=[...this.keys],y=this.raw?.length?[...this.raw]:[this];for(const C of l)if(y.push(...C.raw?.length?C.raw:[C]),!C.isEmpty()){this.i(w,C.contents);for(const A of C.overrides){const[b]=S.filter(v=>r.$wb(v.identifiers,A.identifiers));b?(this.i(b.contents,A.contents),b.keys.push(...A.keys),b.keys=r.$Ob(b.keys)):S.push(N.$bo(A))}for(const A of C.keys)D.indexOf(A)===-1&&D.push(A)}return new a(w,D,S,y.every(C=>C instanceof a)?void 0:y,this.f)}h(l){const w=this.j(l);if(!w||typeof w!="object"||!Object.keys(w).length)return this;const S={};for(const D of r.$Ob([...Object.keys(this.contents),...Object.keys(w)])){let y=this.contents[D];const C=w[D];C&&(typeof y=="object"&&typeof C=="object"?(y=N.$bo(y),this.i(y,C)):y=C),S[D]=y}return new a(S,this.keys,this.overrides,void 0,this.f)}i(l,w){for(const S of Object.keys(w)){if(S in l&&$.$hg(l[S])&&$.$hg(w[S])){this.i(l[S],w[S]);continue}l[S]=N.$bo(w[S])}}j(l){let w=null,S=null;const D=y=>{y&&(S?this.i(S,y):S=N.$bo(y))};for(const y of this.overrides)y.identifiers.length===1&&y.identifiers[0]===l?w=y.contents:y.identifiers.includes(l)&&D(y.contents);return D(w),S}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(l,w){this.k(l,w,!0)}setValue(l,w){this.k(l,w,!1)}removeValue(l){const w=this.keys.indexOf(l);w!==-1&&(this.keys.splice(w,1),(0,I.$gj)(this.contents,l),E.$Do.test(l)&&this.overrides.splice(this.overrides.findIndex(S=>r.$wb(S.identifiers,(0,E.$Eo)(l))),1))}k(l,w,S){(0,I.$fj)(this.contents,l,w,D=>this.f.error(D)),S=S||this.keys.indexOf(l)===-1,S&&this.keys.push(l),E.$Do.test(l)&&this.overrides.push({identifiers:(0,E.$Eo)(l),keys:Object.keys(this.contents[l]),contents:(0,I.$ej)(this.contents[l],D=>this.f.error(D))})}}e.$Jo=a;class f{constructor(l,w){this.f=l,this.g=w,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||a.createEmptyModel(this.g)}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(l,w){if(!$.$og(l)){const S=this.h(l);this.parseRaw(S,w)}}reparse(l){this.a&&this.parseRaw(this.a,l)}parseRaw(l,w){this.a=l;const{contents:S,keys:D,overrides:y,restricted:C,hasExcludedProperties:A}=this.i(l,w);this.b=new a(S,D,y,A?[l]:void 0,this.g),this.c=C||[]}h(l){let w={},S=null,D=[];const y=[],C=[];function A(v){Array.isArray(D)?D.push(v):S!==null&&(D[S]=v)}const b={onObjectBegin:()=>{const v={};A(v),y.push(D),D=v,S=null},onObjectProperty:v=>{S=v},onObjectEnd:()=>{D=y.pop()},onArrayBegin:()=>{const v=[];A(v),y.push(D),D=v,S=null},onArrayEnd:()=>{D=y.pop()},onLiteralValue:A,onError:(v,L,O)=>{C.push({error:v,offset:L,length:O})}};if(l)try{P.$3n(l,b),w=D[0]||{}}catch(v){this.g.error(`Error while parsing settings file ${this.f}: ${v}`),this.d=[v]}return w}i(l,w){const S=k.$oo.as(E.$to.Configuration).getConfigurationProperties(),D=this.j(l,S,!0,w);l=D.raw;const y=(0,I.$ej)(l,b=>this.g.error(`Conflict in settings file ${this.f}: ${b}`)),C=Object.keys(l),A=this.l(l,b=>this.g.error(`Conflict in settings file ${this.f}: ${b}`));return{contents:y,keys:C,overrides:A,restricted:D.restricted,hasExcludedProperties:D.hasExcludedProperties}}j(l,w,S,D){let y=!1;if(!D?.scopes&&!D?.skipRestricted&&!D?.exclude?.length)return{raw:l,restricted:[],hasExcludedProperties:y};const C={},A=[];for(const b in l)if(E.$Do.test(b)&&S){const v=this.j(l[b],w,!1,D);C[b]=v.raw,y=y||v.hasExcludedProperties,A.push(...v.restricted)}else{const v=w[b],L=v?typeof v.scope<"u"?v.scope:E.ConfigurationScope.WINDOW:void 0;v?.restricted&&A.push(b),!D.exclude?.includes(b)&&(D.include?.includes(b)||(L===void 0||D.scopes===void 0||D.scopes.includes(L))&&!(D.skipRestricted&&v?.restricted))?C[b]=l[b]:y=!0}return{raw:C,restricted:A,hasExcludedProperties:y}}l(l,w){const S=[];for(const D of Object.keys(l))if(E.$Do.test(D)){const y={};for(const C in l[D])y[C]=l[D][C];S.push({identifiers:(0,E.$Eo)(D),keys:Object.keys(y),contents:(0,I.$ej)(y,w)})}return S}}e.$Ko=f;class d extends R.$Wc{constructor(l,w,S,D,y){super(),this.c=l,this.f=w,this.g=D,this.h=y,this.b=this.B(new h.$me),this.onDidChange=this.b.event,this.a=new f(this.c.toString(),y),this.B(this.g.watch(S.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(h.Event.any(h.Event.filter(this.g.onDidFilesChange,C=>C.contains(this.c)),h.Event.filter(this.g.onDidRunOperation,C=>(C.isOperation(u.FileOperation.CREATE)||C.isOperation(u.FileOperation.COPY)||C.isOperation(u.FileOperation.DELETE)||C.isOperation(u.FileOperation.WRITE))&&S.isEqual(C.resource,l)))(()=>this.b.fire()))}async loadConfiguration(){try{const l=await this.g.readFile(this.c);return this.a.parse(l.value.toString()||"{}",this.f),this.a.configurationModel}catch{return a.createEmptyModel(this.h)}}reparse(l){return l&&(this.f=l),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$Lo=d;class m{constructor(l,w,S,D,y,C,A,b,v,L,O,M,j){this.a=l,this.b=w,this.c=S,this.overrideIdentifiers=D,this.d=y,this.f=C,this.g=A,this.h=b,this.i=v,this.j=L,this.k=O,this.l=M,this.m=j}get value(){return p(this.c)}n(l){return l?.value!==void 0||l?.override!==void 0||l?.overrides!==void 0?l:void 0}get q(){return this.p||(this.p=this.d.inspect(this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.n(this.q)}get s(){return this.r===void 0&&(this.r=this.f?this.f.inspect(this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.g.inspect(this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.n(this.u)}get w(){return this.v||(this.v=this.h.inspect(this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.n(this.w)}get y(){return this.x||(this.x=this.i.inspect(this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.n(this.y)}get A(){return this.z||(this.z=this.j.inspect(this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.n(this.A)}get D(){return this.B===void 0&&(this.B=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.n(this.D)}get F(){return this.E===void 0&&(this.E=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.n(this.F)}get H(){return this.G===void 0&&(this.G=this.m.inspect(this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.n(this.H)}}class n{constructor(l,w,S,D,y,C,A,b,v,L){this.j=l,this.l=w,this.m=S,this.n=D,this.p=y,this.q=C,this.r=A,this.s=b,this.t=v,this.u=L,this.h=null,this.i=new T.$Cc,this.v=null}getValue(l,w,S){return this.w(l,w,S).getValue(l)}updateValue(l,w,S={}){let D;S.resource?(D=this.t.get(S.resource),D||(D=a.createEmptyModel(this.u),this.t.set(S.resource,D))):D=this.s,w===void 0?D.removeValue(l):D.setValue(l,w),S.resource||(this.h=null)}inspect(l,w,S){const D=this.w(l,w,S),y=this.A(w.resource,S),C=w.resource?this.t.get(w.resource)||this.s:this.s,A=new Set;for(const b of D.overrides)for(const v of b.identifiers)D.getOverrideValue(l,v)!==void 0&&A.add(v);return new m(l,w,D.getValue(l),A.size?[...A]:void 0,this.j,this.l.isEmpty()?void 0:this.l,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,S?this.q:void 0,y||void 0,C)}keys(l){const w=this.A(void 0,l);return{default:this.j.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.q.keys.slice(0),workspaceFolder:w?w.keys.slice(0):[]}}updateDefaultConfiguration(l){this.j=l,this.h=null,this.i.clear()}updatePolicyConfiguration(l){this.l=l}updateApplicationConfiguration(l){this.m=l,this.h=null,this.i.clear()}updateLocalUserConfiguration(l){this.n=l,this.v=null,this.h=null,this.i.clear()}updateRemoteUserConfiguration(l){this.p=l,this.v=null,this.h=null,this.i.clear()}updateWorkspaceConfiguration(l){this.q=l,this.h=null,this.i.clear()}updateFolderConfiguration(l,w){this.r.set(l,w),this.i.delete(l)}deleteFolderConfiguration(l){this.folderConfigurations.delete(l),this.i.delete(l)}compareAndUpdateDefaultConfiguration(l,w){const S=[];if(!w){const{added:D,updated:y,removed:C}=i(this.j,l);w=[...D,...y,...C]}for(const D of w)for(const y of(0,E.$Eo)(D)){const C=this.j.getKeysForOverrideIdentifier(y),A=l.getKeysForOverrideIdentifier(y),b=[...A.filter(v=>C.indexOf(v)===-1),...C.filter(v=>A.indexOf(v)===-1),...C.filter(v=>!N.$fo(this.j.override(y).getValue(v),l.override(y).getValue(v)))];S.push([y,b])}return this.updateDefaultConfiguration(l),{keys:w,overrides:S}}compareAndUpdatePolicyConfiguration(l){const{added:w,updated:S,removed:D}=i(this.l,l),y=[...w,...S,...D];return y.length&&this.updatePolicyConfiguration(l),{keys:y,overrides:[]}}compareAndUpdateApplicationConfiguration(l){const{added:w,updated:S,removed:D,overrides:y}=i(this.applicationConfiguration,l),C=[...w,...S,...D];return C.length&&this.updateApplicationConfiguration(l),{keys:C,overrides:y}}compareAndUpdateLocalUserConfiguration(l){const{added:w,updated:S,removed:D,overrides:y}=i(this.localUserConfiguration,l),C=[...w,...S,...D];return C.length&&this.updateLocalUserConfiguration(l),{keys:C,overrides:y}}compareAndUpdateRemoteUserConfiguration(l){const{added:w,updated:S,removed:D,overrides:y}=i(this.remoteUserConfiguration,l),C=[...w,...S,...D];return C.length&&this.updateRemoteUserConfiguration(l),{keys:C,overrides:y}}compareAndUpdateWorkspaceConfiguration(l){const{added:w,updated:S,removed:D,overrides:y}=i(this.workspaceConfiguration,l),C=[...w,...S,...D];return C.length&&this.updateWorkspaceConfiguration(l),{keys:C,overrides:y}}compareAndUpdateFolderConfiguration(l,w){const S=this.folderConfigurations.get(l),{added:D,updated:y,removed:C,overrides:A}=i(S,w),b=[...D,...y,...C];return(b.length||!S)&&this.updateFolderConfiguration(l,w),{keys:b,overrides:A}}compareAndDeleteFolderConfiguration(l){const w=this.folderConfigurations.get(l);if(!w)throw new Error("Unknown folder");this.deleteFolderConfiguration(l);const{added:S,updated:D,removed:y,overrides:C}=i(w,void 0);return{keys:[...S,...D,...y],overrides:C}}get defaults(){return this.j}get applicationConfiguration(){return this.m}get userConfiguration(){return this.v||(this.v=this.p.isEmpty()?this.n:this.n.merge(this.p)),this.v}get localUserConfiguration(){return this.n}get remoteUserConfiguration(){return this.p}get workspaceConfiguration(){return this.q}get folderConfigurations(){return this.r}w(l,w,S){let D=this.x(w,S);return w.overrideIdentifier&&(D=D.override(w.overrideIdentifier)),!this.l.isEmpty()&&this.l.getValue(l)!==void 0&&(D=D.merge(this.l)),D}x({resource:l},w){let S=this.y();if(w&&l){const D=w.getFolder(l);D&&(S=this.z(D.uri)||S);const y=this.t.get(l);y&&(S=S.merge(y))}return S}y(){return this.h||(this.h=this.j.merge(this.applicationConfiguration,this.userConfiguration,this.q,this.s)),this.h}z(l){let w=this.i.get(l);if(!w){const S=this.y(),D=this.r.get(l);D?(w=S.merge(D),this.i.set(l,w)):w=S}return w}A(l,w){if(w&&l){const S=w.getFolder(l);if(S)return this.r.get(S.uri)}}toData(){return{defaults:{contents:this.j.contents,overrides:this.j.overrides,keys:this.j.keys},policy:{contents:this.l.contents,overrides:this.l.overrides,keys:this.l.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.q.contents,overrides:this.q.overrides,keys:this.q.keys},folders:[...this.r.keys()].reduce((l,w)=>{const{contents:S,overrides:D,keys:y}=this.r.get(w);return l.push([w,{contents:S,overrides:D,keys:y}]),l},[])}}allKeys(){const l=new Set;return this.j.keys.forEach(w=>l.add(w)),this.userConfiguration.keys.forEach(w=>l.add(w)),this.q.keys.forEach(w=>l.add(w)),this.r.forEach(w=>w.keys.forEach(S=>l.add(S))),[...l.values()]}B(){const l=new Set;return this.j.getAllOverrideIdentifiers().forEach(w=>l.add(w)),this.userConfiguration.getAllOverrideIdentifiers().forEach(w=>l.add(w)),this.q.getAllOverrideIdentifiers().forEach(w=>l.add(w)),this.r.forEach(w=>w.getAllOverrideIdentifiers().forEach(S=>l.add(S))),[...l.values()]}D(l){const w=new Set;return this.j.getKeysForOverrideIdentifier(l).forEach(S=>w.add(S)),this.userConfiguration.getKeysForOverrideIdentifier(l).forEach(S=>w.add(S)),this.q.getKeysForOverrideIdentifier(l).forEach(S=>w.add(S)),this.r.forEach(S=>S.getKeysForOverrideIdentifier(l).forEach(D=>w.add(D))),[...w.values()]}static parse(l,w){const S=this.E(l.defaults,w),D=this.E(l.policy,w),y=this.E(l.application,w),C=this.E(l.user,w),A=this.E(l.workspace,w),b=l.folders.reduce((v,L)=>(v.set(c.URI.revive(L[0]),this.E(L[1],w)),v),new T.$Cc);return new n(S,D,y,C,a.createEmptyModel(w),A,b,a.createEmptyModel(w),new T.$Cc,w)}static E(l,w){return new a(l.contents,l.keys,l.overrides,void 0,w)}}e.$Mo=n;function o(...g){if(g.length===0)return{keys:[],overrides:[]};if(g.length===1)return g[0];const l=new Set,w=new Map;for(const D of g)D.keys.forEach(y=>l.add(y)),D.overrides.forEach(([y,C])=>{const A=(0,T.$zc)(w,y,new Set);C.forEach(b=>A.add(b))});const S=[];return w.forEach((D,y)=>S.push([y,[...D.values()]])),{keys:[...l.values()],overrides:S}}class t{constructor(l,w,S,D,y){this.change=l,this.f=w,this.g=S,this.h=D,this.i=y,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=46,this.affectedKeys=new Set,this.j=void 0;for(const C of l.keys)this.affectedKeys.add(C);for(const[,C]of l.overrides)for(const A of C)this.affectedKeys.add(A);this.d=this.a;for(const C of this.affectedKeys)this.d+=C+this.a}get previousConfiguration(){return!this.j&&this.f&&(this.j=n.parse(this.f.data,this.i)),this.j}affectsConfiguration(l,w){const S=this.a+l,D=this.d.indexOf(S);if(D<0)return!1;const y=D+S.length;if(y>=this.d.length)return!1;const C=this.d.charCodeAt(y);if(C!==this.b&&C!==this.c)return!1;if(w){const A=this.previousConfiguration?this.previousConfiguration.getValue(l,w,this.f?.workspace):void 0,b=this.g.getValue(l,w,this.h);return!N.$fo(A,b)}return!0}}e.$Oo=t;function i(g,l){const{added:w,removed:S,updated:D}=s(l?.rawConfiguration,g?.rawConfiguration),y=[],C=g?.getAllOverrideIdentifiers()||[],A=l?.getAllOverrideIdentifiers()||[];if(l){const b=A.filter(v=>!C.includes(v));for(const v of b)y.push([v,l.getKeysForOverrideIdentifier(v)])}if(g){const b=C.filter(v=>!A.includes(v));for(const v of b)y.push([v,g.getKeysForOverrideIdentifier(v)])}if(l&&g){for(const b of C)if(A.includes(b)){const v=s({contents:g.getOverrideValue(void 0,b)||{},keys:g.getKeysForOverrideIdentifier(b)},{contents:l.getOverrideValue(void 0,b)||{},keys:l.getKeysForOverrideIdentifier(b)});y.push([b,[...v.added,...v.removed,...v.updated]])}}return{added:w,removed:S,updated:D,overrides:y}}function s(g,l){const w=g?l?g.keys.filter(y=>l.keys.indexOf(y)===-1):[...g.keys]:[],S=l?g?l.keys.filter(y=>g.keys.indexOf(y)===-1):[...l.keys]:[],D=[];if(g&&l){for(const y of l.keys)if(g.keys.indexOf(y)!==-1){const C=(0,I.$hj)(l.contents,y),A=(0,I.$hj)(g.contents,y);N.$fo(C,A)||D.push(y)}}return{added:w,removed:S,updated:D}}}),define(Ee[283],ye([1,0,22,4,3,69]),function(ce,e,r,h,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ywb=e.$Wwb=e.$Vwb=void 0,e.$Xwb=N;const T=(c,I,E)=>{const u=new Uint8Array(16);for(let a=0;a<16;a++)u[a]=Math.round(Math.random()*256);const k=(0,r.$9e)(r.$Oe.wrap(u));return[`GET ws://localhost${c}?${I}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${k}`].join(`\r
`)+`\r
\r
`};e.$Vwb=T,e.$Wwb=r.$Oe.fromString(`\r
\r
`);async function N(c,I,E,u,k){c.write(r.$Oe.fromString((0,e.$Vwb)(I,E,u)));const p=new P.$Vc;try{return await new Promise((a,f)=>{let d;p.add(c.onData(m=>{d?d=r.$Oe.concat([d,m],d.byteLength+m.byteLength):d=m;const n=d.indexOf(e.$Wwb);if(n===-1)return;a(c),c.pauseData();const o=d.slice(n+e.$Wwb.byteLength);o.byteLength&&k.onData.fire(o)})),p.add(c.onClose(m=>f(m??new Error("socket closed")))),p.add(c.onEnd(()=>f(new Error("socket ended"))))})}catch(a){throw c.dispose(),a}finally{p.dispose()}}class $ extends P.$Wc{constructor(I,E){super(),this.g=I,this.a=this.B(new h.$pe),this.onData=(...u)=>(this.a.isPaused&&queueMicrotask(()=>this.a.resume()),this.a.event(...u)),this.b=this.B(new h.$me),this.onDidDispose=this.b.event,this.f=!1,this.B(E.onData),this.B(E.onData.event(u=>this.a.fire(u))),this.onClose=this.B(E.onClose).event,this.onEnd=this.B(E.onEnd).event}pauseData(){this.a.pause()}drain(){return Promise.resolve()}end(){this.f=!0,this.h()}traceSocketEvent(I,E){R.SocketDiagnostics.traceSocketEvent(this,this.g,I,E)}dispose(){this.f||this.h(),this.b.fire(),super.dispose()}}e.$Ywb=$}),define(Ee[72],ye([1,0,14,5]),function(ce,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tl=e.RemoteAuthorityResolverErrorCode=e.$Sl=e.$Rl=e.RemoteConnectionType=e.$Ql=void 0,e.$Ul=c,e.$Ql=(0,h.$Fi)("remoteAuthorityResolverService");var P;(function(I){I[I.WebSocket=0]="WebSocket",I[I.Managed=1]="Managed"})(P||(e.RemoteConnectionType=P={}));class R{constructor(E){this.id=E,this.type=P.Managed}toString(){return`Managed(${this.id})`}}e.$Rl=R;class T{constructor(E,u){this.host=E,this.port=u,this.type=P.WebSocket}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$Sl=T;var N;(function(I){I.Unknown="Unknown",I.NotAvailable="NotAvailable",I.TemporarilyNotAvailable="TemporarilyNotAvailable",I.NoResolverFound="NoResolverFound",I.InvalidAuthority="InvalidAuthority"})(N||(e.RemoteAuthorityResolverErrorCode=N={}));class $ extends r.$db{static isNotAvailable(E){return E instanceof $&&E._code===N.NotAvailable}static isTemporarilyNotAvailable(E){return E instanceof $&&E._code===N.TemporarilyNotAvailable}static isNoResolverFound(E){return E instanceof $&&E._code===N.NoResolverFound}static isInvalidAuthority(E){return E instanceof $&&E._code===N.InvalidAuthority}static isHandled(E){return E instanceof $&&E.isHandled}constructor(E,u=N.Unknown,k){super(E),this._message=E,this._code=u,this._detail=k,this.isHandled=u===N.NotAvailable&&k===!0,Object.setPrototypeOf(this,$.prototype)}}e.$Tl=$;function c(I){const E=I.indexOf("+");return E===-1?I:I.substring(0,E)}}),define(Ee[284],ye([1,0,9,22,21,14,4,3,15,62,43,32,69,72]),function(ce,e,r,h,P,R,T,N,$,c,I,E,u,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0l=e.$9l=e.$8l=e.$7l=e.$6l=e.$5l=e.$4l=e.$3l=e.PersistentConnectionEventType=e.ConnectionType=void 0,e.$Zl=y,e.$1l=C,e.$2l=b,c=We(c);const p=30*1e3;var a;(function($e){$e[$e.Management=1]="Management",$e[$e.ExtensionHost=2]="ExtensionHost",$e[$e.Tunnel=3]="Tunnel"})(a||(e.ConnectionType=a={}));function f($e){switch($e){case a.Management:return"Management";case a.ExtensionHost:return"ExtensionHost";case a.Tunnel:return"Tunnel"}}function d($e){const K=new P.$xe;return setTimeout(()=>K.cancel(),$e),K.token}function m($e,K){if($e.isCancellationRequested||K.isCancellationRequested)return P.CancellationToken.Cancelled;const W=new P.$xe;return $e.onCancellationRequested(()=>W.cancel()),K.onCancellationRequested(()=>W.cancel()),W.token}class n{get didTimeout(){return this.c==="timedout"}constructor(K){this.c="pending",this.d=new N.$Vc,{promise:this.promise,resolve:this.f,reject:this.g}=(0,r.$yh)(),K.isCancellationRequested?this.h():this.d.add(K.onCancellationRequested(()=>this.h()))}registerDisposable(K){this.c==="pending"?this.d.add(K):K.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const K=new Error("Time limit reached");return K.code="ETIMEDOUT",K.syscall="connect",K}resolve(K){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(K))}reject(K){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(K))}}function o($e,K){const W=new n(K);return W.registerDisposable($e.onControlMessage(se=>{const oe=JSON.parse(se.toString()),te=G(oe);te?W.reject(te):W.resolve(oe)})),W.promise}function t($e,K,W,se,oe,te,le,ue){const X=new n(ue),ae=I.$ge.create(!1);return $e.info(`Creating a socket (${le})...`),c.mark(`code/willCreateSocket/${te}`),K.connect(W,se,oe,le).then(pe=>{X.didTimeout?(c.mark(`code/didCreateSocketError/${te}`),$e.info(`Creating a socket (${le}) finished after ${ae.elapsed()} ms, but this is too late and has timed out already.`),pe?.dispose()):(c.mark(`code/didCreateSocketOK/${te}`),$e.info(`Creating a socket (${le}) was successful after ${ae.elapsed()} ms.`),X.resolve(pe))},pe=>{c.mark(`code/didCreateSocketError/${te}`),$e.info(`Creating a socket (${le}) returned an error after ${ae.elapsed()} ms.`),$e.error(pe),X.reject(pe)}),X.promise}function i($e,K){const W=new n(K);return $e.then(se=>{W.didTimeout||W.resolve(se)},se=>{W.didTimeout||W.reject(se)}),W.promise}async function s($e,K,W,se){const oe=ne($e,K);$e.logService.trace(`${oe} 1/6. invoking socketFactory.connect().`);let te;try{te=await t($e.logService,$e.remoteSocketFactoryService,$e.connectTo,$.$Sg.getServerRootPath(),`reconnectionToken=${$e.reconnectionToken}&reconnection=${$e.reconnectionProtocol?"true":"false"}`,f(K),`renderer-${f(K)}-${$e.reconnectionToken}`,se)}catch(pe){throw $e.logService.error(`${oe} socketFactory.connect() failed or timed out. Error:`),$e.logService.error(pe),pe}$e.logService.trace(`${oe} 2/6. socketFactory.connect() was successful.`);let le,ue;$e.reconnectionProtocol?($e.reconnectionProtocol.beginAcceptReconnection(te,null),le=$e.reconnectionProtocol,ue=!1):(le=new u.$ti({socket:te}),ue=!0),$e.logService.trace(`${oe} 3/6. sending AuthRequest control message.`);const X=await i($e.signService.createNewMessage((0,E.$2g)()),se),ae={type:"auth",auth:$e.connectionToken||"00000000000000000000",data:X.data};le.sendControl(h.$Oe.fromString(JSON.stringify(ae)));try{const pe=await o(le,m(se,d(1e4)));if(pe.type!=="sign"||typeof pe.data!="string"){const ke=new Error("Unexpected handshake message");throw ke.code="VSCODE_CONNECTION_ERROR",ke}if($e.logService.trace(`${oe} 4/6. received SignRequest control message.`),!await i($e.signService.validate(X,pe.signedData),se)){const ke=new Error("Refused to connect to unsupported server");throw ke.code="VSCODE_CONNECTION_ERROR",ke}const Fe=await i($e.signService.sign(pe.data),se),Ue={type:"connectionType",commit:$e.commit,signedData:Fe,desiredConnectionType:K};return W&&(Ue.args=W),$e.logService.trace(`${oe} 5/6. sending ConnectionTypeRequest control message.`),le.sendControl(h.$Oe.fromString(JSON.stringify(Ue))),{protocol:le,ownsProtocol:ue}}catch(pe){throw pe&&pe.code==="ETIMEDOUT"&&($e.logService.error(`${oe} the handshake timed out. Error:`),$e.logService.error(pe)),pe&&pe.code==="VSCODE_CONNECTION_ERROR"&&($e.logService.error(`${oe} received error control message when negotiating connection. Error:`),$e.logService.error(pe)),ue&&U(le),pe}}async function g($e,K,W,se){const oe=Date.now(),te=ne($e,K),{protocol:le,ownsProtocol:ue}=await s($e,K,W,se),X=new n(se);return X.registerDisposable(le.onControlMessage(ae=>{const pe=JSON.parse(ae.toString()),be=G(pe);be?($e.logService.error(`${te} received error control message when negotiating connection. Error:`),$e.logService.error(be),ue&&U(le),X.reject(be)):($e.reconnectionProtocol?.endAcceptReconnection(),$e.logService.trace(`${te} 6/6. handshake finished, connection is up and running after ${De(oe)}!`),X.resolve({protocol:le,firstMessage:pe}))})),X.promise}async function l($e,K){const{protocol:W}=await g($e,a.Management,void 0,K);return{protocol:W}}async function w($e,K,W){const{protocol:se,firstMessage:oe}=await g($e,a.ExtensionHost,K,W),te=oe&&oe.debugPort;return{protocol:se,debugPort:te}}async function S($e,K,W){const se=Date.now(),oe=ne($e,a.Tunnel),{protocol:te}=await s($e,a.Tunnel,K,W);return $e.logService.trace(`${oe} 6/6. handshake finished, connection is up and running after ${De(se)}!`),te}async function D($e,K,W){const{connectTo:se,connectionToken:oe}=await $e.addressProvider.getAddress();return{commit:$e.commit,quality:$e.quality,connectTo:se,connectionToken:oe,reconnectionToken:K,reconnectionProtocol:W,remoteSocketFactoryService:$e.remoteSocketFactoryService,signService:$e.signService,logService:$e.logService}}async function y($e,K,W){return A($e,async se=>{const{protocol:oe}=await l(se,P.CancellationToken.None);return new _($e,K,W,se.reconnectionToken,oe)})}async function C($e,K){return A($e,async W=>{const{protocol:se,debugPort:oe}=await w(W,K,P.CancellationToken.None);return new re($e,K,W.reconnectionToken,se,oe)})}async function A($e,K){for(let se=1;;se++)try{const oe=(0,E.$2g)(),te=await D($e,oe,null);return await K(te)}catch(oe){if(se<5)$e.logService.error(`[remote-connection][attempt ${se}] An error occurred in initial connection! Will retry... Error:`),$e.logService.error(oe);else throw $e.logService.error(`[remote-connection][attempt ${se}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),$e.logService.error(oe),B.triggerPermanentFailure(0,0,k.$Tl.isHandled(oe)),oe}}async function b($e,K,W){const se=await D($e,(0,E.$2g)(),null);return await S(se,{host:K,port:W},P.CancellationToken.None)}function v($e){return(0,r.$sh)(K=>new Promise((W,se)=>{const oe=setTimeout(W,$e*1e3);K.onCancellationRequested(()=>{clearTimeout(oe),W()})}))}var L;(function($e){$e[$e.ConnectionLost=0]="ConnectionLost",$e[$e.ReconnectionWait=1]="ReconnectionWait",$e[$e.ReconnectionRunning=2]="ReconnectionRunning",$e[$e.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",$e[$e.ConnectionGain=4]="ConnectionGain"})(L||(e.PersistentConnectionEventType=L={}));class O{constructor(K,W){this.reconnectionToken=K,this.millisSinceLastIncomingData=W,this.type=L.ConnectionLost}}e.$3l=O;class M{constructor(K,W,se,oe){this.reconnectionToken=K,this.millisSinceLastIncomingData=W,this.durationSeconds=se,this.c=oe,this.type=L.ReconnectionWait}skipWait(){this.c.cancel()}}e.$4l=M;class j{constructor(K,W,se){this.reconnectionToken=K,this.millisSinceLastIncomingData=W,this.attempt=se,this.type=L.ReconnectionRunning}}e.$5l=j;class z{constructor(K,W,se){this.reconnectionToken=K,this.millisSinceLastIncomingData=W,this.attempt=se,this.type=L.ConnectionGain}}e.$6l=z;class F{constructor(K,W,se,oe){this.reconnectionToken=K,this.millisSinceLastIncomingData=W,this.attempt=se,this.handled=oe,this.type=L.ReconnectionPermanentFailure}}e.$7l=F;class B extends N.$Wc{static triggerPermanentFailure(K,W,se){this._permanentFailure=!0,this.f=K,this.g=W,this.h=se,this.j.forEach(oe=>oe.D(this.f,this.g,this.h))}static debugTriggerReconnection(){this.j.forEach(K=>K.y())}static debugPauseSocketWriting(){this.j.forEach(K=>K.F())}static{this._permanentFailure=!1}static{this.f=0}static{this.g=0}static{this.h=!1}static{this.j=[]}get n(){return this.c||B._permanentFailure}constructor(K,W,se,oe,te){super(),this.t=K,this.u=W,this.reconnectionToken=se,this.protocol=oe,this.w=te,this.m=this.B(new T.$me),this.onDidStateChange=this.m.event,this.c=!1,this.r=!1,this.s=!1,this.m.fire(new z(this.reconnectionToken,0,0)),this.B(oe.onSocketClose(le=>{const ue=he(this.t,this.reconnectionToken,!0);le?le.type===u.SocketCloseEventType.NodeSocketCloseEvent?(this.u.logService.info(`${ue} received socket close event (hadError: ${le.hadError}).`),le.error&&this.u.logService.error(le.error)):(this.u.logService.info(`${ue} received socket close event (wasClean: ${le.wasClean}, code: ${le.code}, reason: ${le.reason}).`),le.event&&this.u.logService.error(le.event)):this.u.logService.info(`${ue} received socket close event.`),this.y()})),this.B(oe.onSocketTimeout(le=>{const ue=he(this.t,this.reconnectionToken,!0);this.u.logService.info(`${ue} received socket timeout event (unacknowledgedMsgCount: ${le.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${le.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${le.timeSinceLastReceivedSomeData}).`),this.y()})),B.j.push(this),this.B((0,N.$Uc)(()=>{const le=B.j.indexOf(this);le>=0&&B.j.splice(le,1)})),this.n&&this.D(B.f,B.g,B.h)}dispose(){super.dispose(),this.s=!0}async y(){if(!this.r)try{this.r=!0,await this.z()}finally{this.r=!1}}async z(){if(this.n||this.s)return;const K=he(this.t,this.reconnectionToken,!0);this.u.logService.info(`${K} starting reconnecting loop. You can get more information with the trace log level.`),this.m.fire(new O(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const W=[0,5,5,10,10,10,10,10,30];let se=-1;do{se++;const oe=se<W.length?W[se]:W[W.length-1];try{if(oe>0){const le=v(oe);this.m.fire(new M(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),oe,le)),this.u.logService.info(`${K} waiting for ${oe} seconds before reconnecting...`);try{await le}catch{}}if(this.n){this.u.logService.error(`${K} permanent failure occurred while running the reconnecting loop.`);break}this.m.fire(new j(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),se+1)),this.u.logService.info(`${K} resolving connection...`);const te=await D(this.u,this.reconnectionToken,this.protocol);this.u.logService.info(`${K} connecting to ${te.connectTo}...`),await this.G(te,d(p)),this.u.logService.info(`${K} reconnected!`),this.m.fire(new z(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),se+1));break}catch(te){if(te.code==="VSCODE_CONNECTION_ERROR"){this.u.logService.error(`${K} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.u.logService.error(te),this.C(this.protocol.getMillisSinceLastIncomingData(),se+1,!1);break}if(se>360){this.u.logService.error(`${K} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.u.logService.error(te),this.C(this.protocol.getMillisSinceLastIncomingData(),se+1,!1);break}if(k.$Tl.isTemporarilyNotAvailable(te)){this.u.logService.info(`${K} A temporarily not available error occurred while trying to reconnect, will try again...`),this.u.logService.trace(te);continue}if((te.code==="ETIMEDOUT"||te.code==="ENETUNREACH"||te.code==="ECONNREFUSED"||te.code==="ECONNRESET")&&te.syscall==="connect"){this.u.logService.info(`${K} A network error occurred while trying to reconnect, will try again...`),this.u.logService.trace(te);continue}if((0,R.$6)(te)){this.u.logService.info(`${K} A promise cancelation error occurred while trying to reconnect, will try again...`),this.u.logService.trace(te);continue}if(te instanceof k.$Tl){this.u.logService.error(`${K} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.u.logService.error(te),this.C(this.protocol.getMillisSinceLastIncomingData(),se+1,k.$Tl.isHandled(te));break}this.u.logService.error(`${K} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.u.logService.error(te),this.C(this.protocol.getMillisSinceLastIncomingData(),se+1,!1);break}}while(!this.n&&!this.s)}C(K,W,se){this.w?B.triggerPermanentFailure(K,W,se):this.D(K,W,se)}D(K,W,se){this.m.fire(new F(this.reconnectionToken,K,W,se)),U(this.protocol)}F(){this.protocol.pauseSocketWriting()}}e.$8l=B;class _ extends B{constructor(K,W,se,oe,te){super(a.Management,K,oe,te,!0),this.client=this.B(new u.$ri(te,{remoteAuthority:W,clientId:se},K.ipcLogger))}async G(K,W){await l(K,W)}}e.$9l=_;class re extends B{constructor(K,W,se,oe,te){super(a.ExtensionHost,K,se,oe,!1),this.H=W,this.debugPort=te}async G(K,W){await w(K,this.H,W)}}e.$0l=re;function U($e){try{$e.acceptDisconnect();const K=$e.getSocket();$e.dispose(),K.dispose()}catch(K){(0,R.$3)(K)}}function G($e){if($e&&$e.type==="error"){const K=new Error(`Connection error: ${$e.reason}`);return K.code="VSCODE_CONNECTION_ERROR",K}return null}function Q($e,K){for(;$e.length<K;)$e+=" ";return $e}function ee($e,K){return`[remote-connection][${Q(f($e),13)}][${K.substr(0,5)}\u2026]`}function he($e,K,W){return`${ee($e,K)}[${W?"reconnect":"initial"}]`}function ne($e,K){return`${he(K,$e.reconnectionToken,!!$e.reconnectionProtocol)}[${$e.connectTo}]`}function De($e){return`${Date.now()-$e} ms`}}),define(Ee[91],ye([1,0,15]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gn=h,e.$hn=P,e.$in=R,e.$jn=T;function h($){return $.scheme===r.Schemas.vscodeRemote?$.authority:void 0}function P($){if(!$)return;const c=$.indexOf("+");return c<0?$:$.substr(0,c)}function R($){const{host:c,port:I}=N($);if(typeof I>"u")throw new Error(`Invalid remote authority: ${$}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:c,port:I}}function T($,c){let{host:I,port:E}=N($);return typeof E>"u"&&(E=c),{host:I,port:E}}function N($){const c=$.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(c)return{host:c[1],port:parseInt(c[2],10)};const I=$.match(/^(\[[0-9a-z:]+\])$/);if(I)return{host:I[1],port:void 0};const E=$.match(/(.*):(\d+)$/);return E?{host:E[1],port:parseInt(E[2],10)}:{host:$,port:void 0}}}),define(Ee[24],ye([1,0,13,5,91]),function(ce,e,r,h,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xn=e.$sn=e.$rn=e.$qn=e.TargetPlatform=e.ExtensionType=e.$pn=e.$nn=e.$mn=e.$ln=e.$kn=void 0,e.$on=R,e.$tn=E,e.$un=u,e.$vn=k,e.$wn=p,r=We(r),e.$kn="extensions.user.cache",e.$ln="extensions.builtin.cache",e.$mn="undefined_publisher",e.$nn=["ui","workspace","web"];function R(a){if(typeof a=="object"&&a!==null&&a.supported!==!0)return a.description}e.$pn=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","AI","Chat","Other"];var T;(function(a){a[a.System=0]="System",a[a.User=1]="User"})(T||(e.ExtensionType=T={}));var N;(function(a){a.WIN32_X64="win32-x64",a.WIN32_ARM64="win32-arm64",a.LINUX_X64="linux-x64",a.LINUX_ARM64="linux-arm64",a.LINUX_ARMHF="linux-armhf",a.ALPINE_X64="alpine-x64",a.ALPINE_ARM64="alpine-arm64",a.DARWIN_X64="darwin-x64",a.DARWIN_ARM64="darwin-arm64",a.WEB="web",a.UNIVERSAL="universal",a.UNKNOWN="unknown",a.UNDEFINED="undefined"})(N||(e.TargetPlatform=N={}));class ${constructor(f){this.value=f,this._lower=f.toLowerCase()}static equals(f,d){if(typeof f>"u"||f===null)return typeof d>"u"||d===null;if(typeof d>"u"||d===null)return!1;if(typeof f=="string"||typeof d=="string"){const m=typeof f=="string"?f:f.value,n=typeof d=="string"?d:d.value;return r.$Gf(m,n)}return f._lower===d._lower}static toKey(f){return typeof f=="string"?f.toLowerCase():f._lower}}e.$qn=$;class c{get size(){return this.c.size}constructor(f){if(this.c=new Set,f)for(const d of f)this.add(d)}add(f){this.c.add($.toKey(f))}delete(f){return this.c.delete($.toKey(f))}has(f){return this.c.has($.toKey(f))}}e.$rn=c;class I{constructor(){this.c=new Map}clear(){this.c.clear()}delete(f){this.c.delete($.toKey(f))}get(f){return this.c.get($.toKey(f))}has(f){return this.c.has($.toKey(f))}set(f,d){this.c.set($.toKey(f),d)}values(){return this.c.values()}forEach(f){this.c.forEach(f)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$sn=I;function E(a){return u(a)}function u(a){return a.contributes&&a.contributes.localizations?a.contributes.localizations.length>0:!1}function k(a){return a.contributes&&a.contributes.authentication?a.contributes.authentication.length>0:!1}function p(a,f){if(f){const d=`onResolveRemoteAuthority:${(0,P.$hn)(f)}`;return!!a.activationEvents?.includes(d)}return!1}e.$xn=(0,h.$Fi)("IBuiltinExtensionsScannerService")}),define(Ee[146],ye([1,0,11,221,24,5]),function(ce,e,r,h,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pp=e.$op=e.$np=e.$mp=e.$lp=e.$kp=e.$jp=e.$ip=e.ExtensionManagementErrorCode=e.$hp=e.ExtensionGalleryErrorCode=e.$gp=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.ExtensionInstallSource=e.$_o=e.$$o=e.$0o=e.$9o=e.$8o=e.$7o=e.$6o=void 0,e.$ap=N,e.$bp=$,e.$cp=c,e.$dp=I,e.$ep=E,e.$fp=u,e.$6o="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$7o=new RegExp(e.$6o),e.$8o="__web_extension",e.$9o="skipWalkthrough",e.$0o="extensionInstallSource",e.$$o="dependecyOrPackExtensionInstall",e.$_o="clientTargetPlatform";var T;(function(t){t.COMMAND="command",t.SETTINGS_SYNC="settingsSync"})(T||(e.ExtensionInstallSource=T={}));function N(t){switch(t){case P.TargetPlatform.WIN32_X64:return"Windows 64 bit";case P.TargetPlatform.WIN32_ARM64:return"Windows ARM";case P.TargetPlatform.LINUX_X64:return"Linux 64 bit";case P.TargetPlatform.LINUX_ARM64:return"Linux ARM 64";case P.TargetPlatform.LINUX_ARMHF:return"Linux ARM";case P.TargetPlatform.ALPINE_X64:return"Alpine Linux 64 bit";case P.TargetPlatform.ALPINE_ARM64:return"Alpine ARM 64";case P.TargetPlatform.DARWIN_X64:return"Mac";case P.TargetPlatform.DARWIN_ARM64:return"Mac Silicon";case P.TargetPlatform.WEB:return"Web";case P.TargetPlatform.UNIVERSAL:return P.TargetPlatform.UNIVERSAL;case P.TargetPlatform.UNKNOWN:return P.TargetPlatform.UNKNOWN;case P.TargetPlatform.UNDEFINED:return P.TargetPlatform.UNDEFINED}}function $(t){switch(t){case P.TargetPlatform.WIN32_X64:return P.TargetPlatform.WIN32_X64;case P.TargetPlatform.WIN32_ARM64:return P.TargetPlatform.WIN32_ARM64;case P.TargetPlatform.LINUX_X64:return P.TargetPlatform.LINUX_X64;case P.TargetPlatform.LINUX_ARM64:return P.TargetPlatform.LINUX_ARM64;case P.TargetPlatform.LINUX_ARMHF:return P.TargetPlatform.LINUX_ARMHF;case P.TargetPlatform.ALPINE_X64:return P.TargetPlatform.ALPINE_X64;case P.TargetPlatform.ALPINE_ARM64:return P.TargetPlatform.ALPINE_ARM64;case P.TargetPlatform.DARWIN_X64:return P.TargetPlatform.DARWIN_X64;case P.TargetPlatform.DARWIN_ARM64:return P.TargetPlatform.DARWIN_ARM64;case P.TargetPlatform.WEB:return P.TargetPlatform.WEB;case P.TargetPlatform.UNIVERSAL:return P.TargetPlatform.UNIVERSAL;default:return P.TargetPlatform.UNKNOWN}}function c(t,i){switch(t){case r.Platform.Windows:return i==="x64"?P.TargetPlatform.WIN32_X64:i==="arm64"?P.TargetPlatform.WIN32_ARM64:P.TargetPlatform.UNKNOWN;case r.Platform.Linux:return i==="x64"?P.TargetPlatform.LINUX_X64:i==="arm64"?P.TargetPlatform.LINUX_ARM64:i==="arm"?P.TargetPlatform.LINUX_ARMHF:P.TargetPlatform.UNKNOWN;case"alpine":return i==="x64"?P.TargetPlatform.ALPINE_X64:i==="arm64"?P.TargetPlatform.ALPINE_ARM64:P.TargetPlatform.UNKNOWN;case r.Platform.Mac:return i==="x64"?P.TargetPlatform.DARWIN_X64:i==="arm64"?P.TargetPlatform.DARWIN_ARM64:P.TargetPlatform.UNKNOWN;case r.Platform.Web:return P.TargetPlatform.WEB}}function I(t,i){return i===P.TargetPlatform.WEB&&!t.includes(P.TargetPlatform.WEB)}function E(t,i,s){return I(i,s)?!1:t===P.TargetPlatform.UNDEFINED||t===P.TargetPlatform.UNIVERSAL?!0:t===P.TargetPlatform.UNKNOWN?!1:t===s}function u(t){return t&&typeof t=="object"&&typeof t.id=="string"&&(!t.uuid||typeof t.uuid=="string")}var k;(function(t){t[t.NoneOrRelevance=0]="NoneOrRelevance",t[t.LastUpdatedDate=1]="LastUpdatedDate",t[t.Title=2]="Title",t[t.PublisherName=3]="PublisherName",t[t.InstallCount=4]="InstallCount",t[t.PublishedDate=10]="PublishedDate",t[t.AverageRating=6]="AverageRating",t[t.WeightedRating=12]="WeightedRating"})(k||(e.SortBy=k={}));var p;(function(t){t[t.Default=0]="Default",t[t.Ascending=1]="Ascending",t[t.Descending=2]="Descending"})(p||(e.SortOrder=p={}));var a;(function(t){t.Install="install",t.Uninstall="uninstall"})(a||(e.StatisticType=a={}));var f;(function(t){t[t.None=1]="None",t[t.Install=2]="Install",t[t.Update=3]="Update",t[t.Migrate=4]="Migrate"})(f||(e.InstallOperation=f={})),e.$gp=(0,R.$Fi)("extensionGalleryService");var d;(function(t){t.Timeout="Timeout",t.Cancelled="Cancelled",t.Failed="Failed",t.DownloadFailedWriting="DownloadFailedWriting"})(d||(e.ExtensionGalleryErrorCode=d={}));class m extends Error{constructor(i,s){super(i),this.code=s,this.name=s}}e.$hp=m;var n;(function(t){t.Unsupported="Unsupported",t.Deprecated="Deprecated",t.Malicious="Malicious",t.Incompatible="Incompatible",t.IncompatibleTargetPlatform="IncompatibleTargetPlatform",t.ReleaseVersionNotFound="ReleaseVersionNotFound",t.Invalid="Invalid",t.Download="Download",t.DownloadSignature="DownloadSignature",t.DownloadFailedWriting="DownloadFailedWriting",t.UpdateExistingMetadata="UpdateExistingMetadata",t.UpdateMetadata="UpdateMetadata",t.Extract="Extract",t.Scanning="Scanning",t.ScanningExtension="ScanningExtension",t.ReadUninstalled="ReadUninstalled",t.UnsetUninstalled="UnsetUninstalled",t.Delete="Delete",t.Rename="Rename",t.IntializeDefaultProfile="IntializeDefaultProfile",t.AddToProfile="AddToProfile",t.InstalledExtensionNotFound="InstalledExtensionNotFound",t.PostInstall="PostInstall",t.CorruptZip="CorruptZip",t.IncompleteZip="IncompleteZip",t.Signature="Signature",t.NotAllowed="NotAllowed",t.Gallery="Gallery",t.Cancelled="Cancelled",t.Unknown="Unknown",t.Internal="Internal"})(n||(e.ExtensionManagementErrorCode=n={}));class o extends Error{constructor(i,s){super(i),this.code=s,this.name=s}}e.$ip=o,e.$jp=(0,R.$Fi)("extensionManagementService"),e.$kp="extensionsIdentifiers/disabled",e.$lp="extensionsIdentifiers/enabled",e.$mp=(0,R.$Fi)("IGlobalExtensionEnablementService"),e.$np=(0,R.$Fi)("IExtensionTipsService"),e.$op=(0,h.localize2)(0,"Extensions"),e.$pp=(0,h.localize2)(1,"Preferences")}),define(Ee[147],ye([1,0,14,24]),function(ce,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$IG=e.$HG=void 0;class P{constructor(){this.a=new Map,this.b=new WeakMap}register(T,N){this.a.set(T,N)}readActivationEvents(T){return this.b.has(T)||this.b.set(T,this.c(T)),this.b.get(T)}createActivationEventsMap(T){const N=Object.create(null);for(const $ of T){const c=this.readActivationEvents($);c.length>0&&(N[h.$qn.toKey($.identifier)]=c)}return N}c(T){if(typeof T.main>"u"&&typeof T.browser>"u")return[];const N=Array.isArray(T.activationEvents)?T.activationEvents.slice(0):[];for(let $=0;$<N.length;$++)N[$]==="onUri"&&(N[$]=`onUri:${h.$qn.toKey(T.identifier)}`);if(!T.contributes)return N;for(const $ in T.contributes){const c=this.a.get($);if(!c)continue;const I=T.contributes[$],E=Array.isArray(I)?I:[I];try{c(E,N)}catch(u){(0,r.$3)(u)}}return N}}e.$HG=P,e.$IG=new P}),define(Ee[285],ye([1,0,3,5]),function(ce,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wl=e.$Vl=void 0,e.$Vl=(0,h.$Fi)("remoteSocketFactoryService");class P{constructor(){this.a={}}register(T,N){return this.a[T]??=[],this.a[T].push(N),(0,r.$Uc)(()=>{const $=this.a[T]?.indexOf(N);typeof $=="number"&&$>=0&&this.a[T]?.splice($,1)})}b(T){return(this.a[T.type]||[]).find($=>$.supports(T))}connect(T,N,$,c){const I=this.b(T);if(!I)throw new Error(`No socket factory found for ${T}`);return I.connect(T,N,$,c)}}e.$Wl=P}),define(Ee[286],ye([1,0,22,14,3,229,71,5,12,37]),function(ce,e,r,h,P,R,T,N,$,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2p=e.$1p=void 0,e.$3p=u,e.$4p=k,e.$5p=p,e.$6p=a,e.$7p=f,e.$8p=d,e.$1p=(0,N.$Fi)("requestService");class I{constructor(t){this.b=t}toJSON(){if(!this.a){const t=Object.create(null);for(const i in this.b)i.toLowerCase()==="authorization"||i.toLowerCase()==="proxy-authorization"?t[i]="*****":t[i]=this.b[i];this.a=t}return this.a}}class E extends P.$Wc{constructor(t){super(),this.b=0,this.a=t.createLogger("network",{name:(0,R.localize)(0,null),when:$.$rk.isEqualTo((0,$.$ok)($.LogLevel.Trace)).serialize()})}async c(t,i,s){const g=`${t} #${++this.b}: ${i.url}`;this.a.trace(`${g} - begin`,i.type,new I(i.headers??{}));try{const l=await s();return this.a.trace(`${g} - end`,i.type,l.res.statusCode,l.res.headers),l}catch(l){throw this.a.error(`${g} - error`,i.type,(0,h.$_)(l)),l}}}e.$2p=E;function u(o){return o.res.statusCode&&o.res.statusCode>=200&&o.res.statusCode<300||o.res.statusCode===1223}function k(o){return o.res.statusCode===204}async function p(o){return k(o)?null:(await(0,r.$1e)(o.stream)).toString()}async function a(o){if(!u(o))throw new Error("Server returned "+o.res.statusCode);return p(o)}async function f(o){if(!u(o))throw new Error("Server returned "+o.res.statusCode);if(k(o))return null;const i=(await(0,r.$1e)(o.stream)).toString();try{return JSON.parse(i)}catch(s){throw s.message+=`:
`+i,s}}function d(o){n(o)}let m;function n(o){const t=c.$oo.as(T.$to.Configuration),i=m;m={id:"http",order:15,title:(0,R.localize)(1,null),type:"object",scope:o,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,R.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,R.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,R.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,R.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,R.localize)(6,null),(0,R.localize)(7,null),(0,R.localize)(8,null),(0,R.localize)(9,null)],default:"override",description:(0,R.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,R.localize)(11,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,R.localize)(12,null),restricted:!0}}},t.updateConfigurations({add:[m],remove:i?[i]:[]})}n(T.ConfigurationScope.APPLICATION)}),define(Ee[287],ye([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lbc=void 0;class r{constructor(){this.b=new Map}static{this.a=1}async createNewMessage(P){try{const R=await this.c();if(R){const T=String(r.a++);return this.b.set(T,R),{id:T,data:R.createNewMessage(P)}}}catch{}return{id:"",data:P}}async validate(P,R){if(!P.id)return!0;const T=this.b.get(P.id);if(!T)return!1;this.b.delete(P.id);try{return T.validate(R)==="ok"}catch{return!1}finally{T.dispose?.()}}async sign(P){try{return await this.d(P)}catch{}return P}}e.$lbc=r}),define(Ee[118],ye([1,0,5]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yl=e.$Xl=void 0,e.$Xl="signService",e.$Yl=(0,r.$Fi)(e.$Xl)}),define(Ee[148],ye([1,0,287]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qgc=void 0;class h extends r.$lbc{c(){return this.h().then(R=>new R.validator)}d(R){return this.h().then(T=>new T.signer().sign(R))}h(){return new Promise((R,T)=>ce(["vsda"],R,T))}}e.$qgc=h}),define(Ee[288],ye([1,0,11,56,32]),function(ce,e,r,h,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qp=T,e.$rp=N;function R($){if(r.$u===r.Platform.Linux&&/^penguin(\.|$)/i.test($))return"chromebook"}function T($,c,I,E,u,k,p,a,f,d){const m=Object.create(null);m["common.machineId"]=k,m["common.sqmId"]=p,m["common.devDeviceId"]=a,m.sessionID=(0,P.$2g)()+Date.now(),m.commitHash=E,m.version=u,m["common.platformVersion"]=($||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),m["common.platform"]=(0,r.$h)(r.$u),m["common.nodePlatform"]=h.$fc,m["common.nodeArch"]=I,m["common.product"]=d||"desktop",f&&(m["common.msftInternal"]=f);let n=0;const o=Date.now();Object.defineProperties(m,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-o,enumerable:!0},"common.sequence":{get:()=>n++,enumerable:!0}}),r.$l&&(m["common.snap"]="true");const t=R(c);return t&&(m["common.platformDetail"]=t),m}function N($){const c=h.env.USERDNSDOMAIN;if(!c)return!1;const I=c.toLowerCase();return $.some(E=>I===E)}}),define(Ee[149],ye([1,0,5]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$jm=e.$im=e.$hm=e.$gm=e.$fm=e.$em=e.$dm=e.$cm=e.$bm=e.$am=e.$_l=e.$$l=void 0,e.$$l=(0,r.$Fi)("telemetryService"),e.$_l=(0,r.$Fi)("customEndpointTelemetryService"),e.$am="telemetry.currentSessionDate",e.$bm="telemetry.firstSessionDate",e.$cm="telemetry.lastSessionDate",e.$dm="telemetry.machineId",e.$em="telemetry.sqmId",e.$fm="telemetry.devDeviceId",e.$gm="telemetry",e.$hm="telemetry.telemetryLevel",e.$im="telemetry.enableCrashReporter",e.$jm="telemetry.enableTelemetry";var h;(function(R){R[R.NONE=0]="NONE",R[R.CRASH=1]="CRASH",R[R.ERROR=2]="ERROR",R[R.USAGE=3]="USAGE"})(h||(e.TelemetryLevel=h={}));var P;(function(R){R.OFF="off",R.CRASH="crash",R.ERROR="error",R.ON="all"})(P||(e.TelemetryConfiguration=P={}))}),define(Ee[92],ye([1,0,25,18,91,288,149]),function(ce,e,r,h,P,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yp=e.$xp=e.$wp=e.$vp=e.$up=e.$tp=e.$sp=void 0,e.$zp=I,e.$Ap=E,e.$Bp=u,e.$Cp=k,e.$Dp=a,e.$Ep=d,e.$Fp=m,e.$Gp=t;class N{constructor(s){this.value=s,this.isTrustedTelemetryValue=!0}}e.$sp=N;class ${constructor(){this.telemetryLevel=T.TelemetryLevel.NONE,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.devDeviceId="someValue.devDeviceId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$tp=$,e.$up=new $;class c{async publicLog(s,g,l){}async publicLogError(s,g,l){}}e.$vp=c,e.$wp="telemetry",e.$xp="extensionTelemetryLog",e.$yp={log:()=>null,flush:()=>Promise.resolve(null)};function I(i,s){return!s.isBuilt&&!s.disableTelemetry?!0:!(s.disableTelemetry||!i.enableTelemetry)}function E(i,s){return s.extensionTestsLocationURI?!0:!(s.isBuilt||s.disableTelemetry||i.enableTelemetry&&i.aiConfig?.ariaKey)}function u(i){const s=i.getValue(T.$hm),g=i.getValue(T.$im);if(i.getValue(T.$jm)===!1||g===!1)return T.TelemetryLevel.NONE;switch(s??T.TelemetryConfiguration.ON){case T.TelemetryConfiguration.ON:return T.TelemetryLevel.USAGE;case T.TelemetryConfiguration.ERROR:return T.TelemetryLevel.ERROR;case T.TelemetryConfiguration.CRASH:return T.TelemetryLevel.CRASH;case T.TelemetryConfiguration.OFF:return T.TelemetryLevel.NONE}}function k(i){const s={},g={},l={};f(i,l);for(let w in l){w=w.length>150?w.substr(w.length-149):w;const S=l[w];typeof S=="number"?g[w]=S:typeof S=="boolean"?g[w]=S?1:0:typeof S=="string"?(S.length>8192&&console.warn(`Telemetry property: ${w} has been trimmed to 8192, the original length is ${S.length}`),s[w]=S.substring(0,8191)):typeof S<"u"&&S!==null&&(s[w]=S)}return{properties:s,measurements:g}}const p=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function a(i){if(!i)return"none";const s=(0,P.$hn)(i);return p.has(s)?s:"other"}function f(i,s,g=0,l){if(i)for(const w of Object.getOwnPropertyNames(i)){const S=i[w],D=l?l+w:w;Array.isArray(S)?s[D]=(0,r.$go)(S):S instanceof Date?s[D]=S.toISOString():(0,h.$hg)(S)?g<2?f(S,s,g+1,D+"."):s[D]=(0,r.$go)(S):s[D]=S}}function d(i,s){const g=i.msftInternalDomains||[],l=s.getValue("telemetry.internalTesting");return(0,R.$rp)(g)||l}function m(i){return[i.appRoot,i.extensionsPath,i.userHome.fsPath,i.tmpDir.fsPath,i.userDataPath]}function n(i,s){if(!i||!i.includes("/")&&!i.includes("\\"))return i;let g=i;const l=[];for(const y of s)for(;;){const C=y.exec(i);if(!C)break;l.push([C.index,y.lastIndex])}const w=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,S=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let D=0;for(g="";;){const y=S.exec(i);if(!y)break;const C=l.some(([A,b])=>y.index<b&&A<S.lastIndex);!w.test(y[0])&&!C&&(g+=i.substring(D,y.index)+"<REDACTED: user-file-path>",D=S.lastIndex)}return D<i.length&&(g+=i.substr(D)),g}function o(i){if(!i)return i;const s=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"CLI Credentials",regex:/((login|psexec|(certutil|psexec)\.exe).{1,50}(\s-u(ser(name)?)?\s+.{3,100})?\s-(admin|user|vm|root)?p(ass(word)?)?\s+["']?[^$\-\/\s]|(^|[\s\r\n\\])net(\.exe)?.{1,5}(user\s+|share\s+\/user:| user -? secrets ? set) \s + [^ $\s \/])/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const g of s)if(g.regex.test(i))return`<REDACTED: ${g.label}>`;return i}function t(i,s){return(0,r.$do)(i,g=>{if(g instanceof N||Object.hasOwnProperty.call(g,"isTrustedTelemetryValue"))return g.value;if(typeof g=="string"){let l=g.replaceAll("%20"," ");l=n(l,s);for(const w of s)l=l.replace(w,"");return l=o(l),l}})}}),define(Ee[289],ye([1,0,13,146,24,11,2,14,56,92]),function(ce,e,r,h,P,R,T,N,$,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qp=e.$Ip=void 0,e.$Hp=I,e.$Jp=p,e.$Kp=a,e.$Lp=f,e.$Mp=d,e.$Np=m,e.$Op=n,e.$Pp=o,e.$Rp=t,e.$Sp=s;function I(g,l){return g.uuid&&l.uuid?g.uuid===l.uuid:g.id===l.id?!0:(0,r.$Bf)(g.id,l.id)===0}const E=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class u{static create(l){const w=l.manifest?l.manifest.version:l.version,S=l.manifest?l.targetPlatform:l.properties.targetPlatform;return new u(l.identifier,w,S)}static parse(l){const w=E.exec(l);return w&&w[1]&&w[2]?new u({id:w[1]},w[2],w[4]||void 0):null}constructor(l,w,S=P.TargetPlatform.UNDEFINED){this.identifier=l,this.version=w,this.targetPlatform=S,this.id=l.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!==P.TargetPlatform.UNDEFINED?`-${this.targetPlatform}`:""}`}equals(l){return l instanceof u?I(this,l)&&this.version===l.version&&this.targetPlatform===l.targetPlatform:!1}}e.$Ip=u;const k=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function p(g){const l=k.exec(g);return l&&l[1]?[f(l[1]),l[2]]:[f(g),void 0]}function a(g,l){return`${g}.${l}`}function f(g){return g.toLowerCase()}function d(g,l){return f(a(g??P.$mn,l))}function m(g,l){const w=[],S=D=>{for(const y of w)if(y.some(C=>I(l(C),l(D))))return y;return null};for(const D of g){const y=S(D);y?y.push(D):w.push([D])}return w}function n(g){return{id:g.identifier.id,name:g.manifest.name,galleryId:null,publisherId:g.publisherId,publisherName:g.manifest.publisher,publisherDisplayName:g.publisherDisplayName,dependencies:g.manifest.extensionDependencies&&g.manifest.extensionDependencies.length>0}}function o(g){return{id:new c.$sp(g.identifier.id),name:new c.$sp(g.name),version:g.version,galleryId:g.identifier.uuid,publisherId:g.publisherId,publisherName:g.publisher,publisherDisplayName:g.publisherDisplayName,isPreReleaseVersion:g.properties.isPreReleaseVersion,dependencies:!!(g.properties.dependencies&&g.properties.dependencies.length>0),isSigned:g.isSigned,...g.telemetryData}}e.$Qp=new P.$qn("pprice.better-merge");function t(g,l){const w=[],S=l.manifest.extensionDependencies?.slice(0)??[];for(;S.length;){const D=S.shift();if(D&&w.every(y=>!I(y.identifier,{id:D}))){const y=g.filter(C=>I(C.identifier,{id:D}));y.length===1&&(w.push(y[0]),S.push(...y[0].manifest.extensionDependencies?.slice(0)??[]))}}return w}async function i(g,l){if(!R.$k)return!1;let w;try{w=(await g.readFile(T.URI.file("/etc/os-release"))).value.toString()}catch{try{w=(await g.readFile(T.URI.file("/usr/lib/os-release"))).value.toString()}catch(D){l.debug("Error while getting the os-release file.",(0,N.$_)(D))}}return!!w&&(w.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function s(g,l){const w=await i(g,l),S=(0,h.$cp)(w?"alpine":R.$u,$.$gc);return l.debug("ComputeTargetPlatform:",S),S}}),define(Ee[290],ye([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ys=r,e.$zs=h,e.$As=P,e.$Bs=R,e.$Cs=T,e.$Ds=N;function r($){return[...$.entries()]}function h($){return $?[...$.entries()]:[]}function P($){return new Map($)}function R($){return new Map($??[])}function T($){return Array.from($.entries()).map(c=>[c[0],r(c[1].map),h(c[1].descriptionMap)])}function N($){return new Map($.map(c=>[c[0],{map:P(c[1]),descriptionMap:R(c[2])}]))}}),define(Ee[291],ye([1,0,5,36,37]),function(ce,e,r,h,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ls=e.$ks=e.$js=e.TerminalExitReason=e.ShellIntegrationStatus=e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.$is=e.ProcessPropertyType=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.PosixShellType=e.TerminalSettingId=e.TerminalSettingPrefix=e.$hs=void 0,e.$hs=new h.$Wj("terminalTabFocusMode",!1,!0);var R;(function(t){t.AutomationProfile="terminal.integrated.automationProfile.",t.DefaultProfile="terminal.integrated.defaultProfile.",t.Profiles="terminal.integrated.profiles."})(R||(e.TerminalSettingPrefix=R={}));var T;(function(t){t.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",t.AutomationProfileLinux="terminal.integrated.automationProfile.linux",t.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",t.AutomationProfileWindows="terminal.integrated.automationProfile.windows",t.ProfilesWindows="terminal.integrated.profiles.windows",t.ProfilesMacOs="terminal.integrated.profiles.osx",t.ProfilesLinux="terminal.integrated.profiles.linux",t.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",t.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",t.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",t.UseWslProfiles="terminal.integrated.useWslProfiles",t.TabsDefaultColor="terminal.integrated.tabs.defaultColor",t.TabsDefaultIcon="terminal.integrated.tabs.defaultIcon",t.TabsEnabled="terminal.integrated.tabs.enabled",t.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",t.TabsHideCondition="terminal.integrated.tabs.hideCondition",t.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",t.TabsShowActions="terminal.integrated.tabs.showActions",t.TabsLocation="terminal.integrated.tabs.location",t.TabsFocusMode="terminal.integrated.tabs.focusMode",t.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",t.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",t.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",t.CopyOnSelection="terminal.integrated.copyOnSelection",t.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",t.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",t.FontFamily="terminal.integrated.fontFamily",t.FontSize="terminal.integrated.fontSize",t.LetterSpacing="terminal.integrated.letterSpacing",t.LineHeight="terminal.integrated.lineHeight",t.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",t.TabStopWidth="terminal.integrated.tabStopWidth",t.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",t.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",t.BellDuration="terminal.integrated.bellDuration",t.FontWeight="terminal.integrated.fontWeight",t.FontWeightBold="terminal.integrated.fontWeightBold",t.CursorBlinking="terminal.integrated.cursorBlinking",t.CursorStyle="terminal.integrated.cursorStyle",t.CursorStyleInactive="terminal.integrated.cursorStyleInactive",t.CursorWidth="terminal.integrated.cursorWidth",t.Scrollback="terminal.integrated.scrollback",t.DetectLocale="terminal.integrated.detectLocale",t.DefaultLocation="terminal.integrated.defaultLocation",t.GpuAcceleration="terminal.integrated.gpuAcceleration",t.TerminalTitleSeparator="terminal.integrated.tabs.separator",t.TerminalTitle="terminal.integrated.tabs.title",t.TerminalDescription="terminal.integrated.tabs.description",t.RightClickBehavior="terminal.integrated.rightClickBehavior",t.MiddleClickBehavior="terminal.integrated.middleClickBehavior",t.Cwd="terminal.integrated.cwd",t.ConfirmOnExit="terminal.integrated.confirmOnExit",t.ConfirmOnKill="terminal.integrated.confirmOnKill",t.EnableBell="terminal.integrated.enableBell",t.EnableVisualBell="terminal.integrated.enableVisualBell",t.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",t.AllowChords="terminal.integrated.allowChords",t.AllowMnemonics="terminal.integrated.allowMnemonics",t.TabFocusMode="terminal.integrated.tabFocusMode",t.EnvMacOs="terminal.integrated.env.osx",t.EnvLinux="terminal.integrated.env.linux",t.EnvWindows="terminal.integrated.env.windows",t.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",t.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",t.ShowExitAlert="terminal.integrated.showExitAlert",t.SplitCwd="terminal.integrated.splitCwd",t.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",t.WordSeparators="terminal.integrated.wordSeparators",t.EnableFileLinks="terminal.integrated.enableFileLinks",t.AllowedLinkSchemes="terminal.integrated.allowedLinkSchemes",t.UnicodeVersion="terminal.integrated.unicodeVersion",t.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",t.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",t.HideOnStartup="terminal.integrated.hideOnStartup",t.CustomGlyphs="terminal.integrated.customGlyphs",t.RescaleOverlappingGlyphs="terminal.integrated.rescaleOverlappingGlyphs",t.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",t.InheritEnv="terminal.integrated.inheritEnv",t.ShowLinkHover="terminal.integrated.showLinkHover",t.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",t.AutoReplies="terminal.integrated.autoReplies",t.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",t.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",t.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",t.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history",t.EnableImages="terminal.integrated.enableImages",t.SmoothScrolling="terminal.integrated.smoothScrolling",t.IgnoreBracketedPasteMode="terminal.integrated.ignoreBracketedPasteMode",t.FocusAfterRun="terminal.integrated.focusAfterRun",t.DeveloperPtyHostLatency="terminal.integrated.developer.ptyHost.latency",t.DeveloperPtyHostStartupDelay="terminal.integrated.developer.ptyHost.startupDelay",t.DevMode="terminal.integrated.developer.devMode"})(T||(e.TerminalSettingId=T={}));var N;(function(t){t.PowerShell="pwsh",t.Bash="bash",t.Fish="fish",t.Sh="sh",t.Csh="csh",t.Ksh="ksh",t.Zsh="zsh",t.Python="python"})(N||(e.PosixShellType=N={}));var $;(function(t){t.CommandPrompt="cmd",t.PowerShell="pwsh",t.Wsl="wsl",t.GitBash="gitbash",t.Python="python"})($||(e.WindowsShellType=$={}));var c;(function(t){t[t.Api=0]="Api",t[t.Process=1]="Process",t[t.Sequence=2]="Sequence",t[t.Config=3]="Config"})(c||(e.TitleEventSource=c={}));var I;(function(t){t.LocalPty="localPty",t.PtyHost="ptyHost",t.PtyHostWindow="ptyHostWindow",t.Logger="logger",t.Heartbeat="heartbeat"})(I||(e.TerminalIpcChannels=I={}));var E;(function(t){t.Cwd="cwd",t.InitialCwd="initialCwd",t.FixedDimensions="fixedDimensions",t.Title="title",t.ShellType="shellType",t.HasChildProcesses="hasChildProcesses",t.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",t.OverrideDimensions="overrideDimensions",t.FailedShellIntegrationActivation="failedShellIntegrationActivation",t.UsedShellIntegrationInjection="usedShellIntegrationInjection"})(E||(e.ProcessPropertyType=E={})),e.$is=(0,r.$Fi)("ptyService");var u;(function(t){t[t.BeatInterval=5e3]="BeatInterval",t[t.ConnectingBeatInterval=2e4]="ConnectingBeatInterval",t[t.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",t[t.SecondWaitMultiplier=1]="SecondWaitMultiplier",t[t.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(u||(e.HeartbeatConstants=u={}));var k;(function(t){t[t.Panel=1]="Panel",t[t.Editor=2]="Editor"})(k||(e.TerminalLocation=k={}));var p;(function(t){t.TerminalView="view",t.Editor="editor"})(p||(e.TerminalLocationString=p={}));var a;(function(t){t[t.GraceTime=6e4]="GraceTime",t[t.ShortGraceTime=6e3]="ShortGraceTime"})(a||(e.LocalReconnectConstants=a={}));var f;(function(t){t[t.HighWatermarkChars=1e5]="HighWatermarkChars",t[t.LowWatermarkChars=5e3]="LowWatermarkChars",t[t.CharCountAckSize=5e3]="CharCountAckSize"})(f||(e.FlowControlConstants=f={}));var d;(function(t){t.GitBash="Git Bash",t.Pwsh="PowerShell"})(d||(e.ProfileSource=d={}));var m;(function(t){t[t.Off=0]="Off",t[t.FinalTerm=1]="FinalTerm",t[t.VSCode=2]="VSCode"})(m||(e.ShellIntegrationStatus=m={}));var n;(function(t){t[t.Unknown=0]="Unknown",t[t.Shutdown=1]="Shutdown",t[t.Process=2]="Process",t[t.User=3]="User",t[t.Extension=4]="Extension"})(n||(e.TerminalExitReason=n={})),e.$js={Backend:"workbench.contributions.terminal.processBackend"};class o{constructor(){this.a=new Map}get backends(){return this.a}registerTerminalBackend(i){const s=this.b(i.remoteAuthority);if(this.a.has(s))throw new Error(`A terminal backend with remote authority '${s}' was already registered.`);this.a.set(s,i)}getTerminalBackend(i){return this.a.get(this.b(i))}b(i){return i?.toLowerCase()??""}}P.$oo.add(e.$js.Backend,new o),e.$ks=(0,r.$Fi)("localPtyService"),e.$ls=(0,r.$Fi)("terminalLogService")}),define(Ee[292],ye([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$exb=void 0;class r{constructor(P){this.b=P,this.a=new Map}dispose(){for(const P of this.a.values())P.dispose()}startBuffering(P,R,T=5){const N=R($=>{const c=typeof $=="string"?$:$.data;let I=this.a.get(P);if(I){I.data.push(c);return}const E=setTimeout(()=>this.flushBuffer(P),T);I={data:[c],timeoutId:E,dispose:()=>{clearTimeout(E),this.flushBuffer(P),N.dispose()}},this.a.set(P,I)});return N}stopBuffering(P){this.a.get(P)?.dispose()}flushBuffer(P){const R=this.a.get(P);R&&(this.a.delete(P),this.b(P,R.data.join("")))}}e.$exb=r}),define(Ee[293],ye([1,0,9,83,105,50,4,18,2,230,117,37]),function(ce,e,r,h,P,R,T,N,$,c,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ax=e.$zx=e.$yx=e.$xx=e.$wx=e.$vx=e.IconFontDefinition=e.IconContribution=e.$sx=void 0,e.$tx=f,e.$ux=d,E=We(E),e.$sx={IconContribution:"base.contributions.icons"};var u;(function(t){function i(s,g){let l=s.defaults;for(;R.ThemeIcon.isThemeIcon(l);){const w=a.getIcon(l.id);if(!w)return;l=w.defaults}return l}t.getDefinition=i})(u||(e.IconContribution=u={}));var k;(function(t){function i(g){return{weight:g.weight,style:g.style,src:g.src.map(l=>({format:l.format,location:l.location.toString()}))}}t.toJSONObject=i;function s(g){const l=w=>(0,N.$fg)(w)?w:void 0;if(g&&Array.isArray(g.src)&&g.src.every(w=>(0,N.$fg)(w.format)&&(0,N.$fg)(w.location)))return{weight:l(g.weight),style:l(g.style),src:g.src.map(w=>({format:w.format,location:$.URI.parse(w.location)}))}}t.fromJSONObject=s})(k||(e.IconFontDefinition=k={}));class p{constructor(){this.a=new T.$me,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,c.localize)(0,null)},fontCharacter:{type:"string",description:(0,c.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${R.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(i,s,g,l){const w=this.b[i];if(w){if(g&&!w.description){w.description=g,this.d.properties[i].markdownDescription=`${g} $(${i})`;const y=this.e.enum.indexOf(i);y!==-1&&(this.e.enumDescriptions[y]=g),this.a.fire()}return w}const S={id:i,description:g,defaults:s,deprecationMessage:l};this.b[i]=S;const D={$ref:"#/definitions/icons"};return l&&(D.deprecationMessage=l),g&&(D.markdownDescription=`${g}: $(${i})`),this.d.properties[i]=D,this.e.enum.push(i),this.e.enumDescriptions.push(g||""),this.a.fire(),{id:i}}deregisterIcon(i){delete this.b[i],delete this.d.properties[i];const s=this.e.enum.indexOf(i);s!==-1&&(this.e.enum.splice(s,1),this.e.enumDescriptions.splice(s,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(i=>this.b[i])}getIcon(i){return this.b[i]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(i,s){const g=this.f[i];return g||(this.f[i]=s,this.a.fire(),s)}deregisterIconFont(i){delete this.f[i]}getIconFont(i){return this.f[i]}toString(){const i=(w,S)=>w.id.localeCompare(S.id),s=w=>{for(;R.ThemeIcon.isThemeIcon(w.defaults);)w=this.b[w.defaults.id];return`codicon codicon-${w?w.id:""}`},g=[];g.push("| preview     | identifier                        | default codicon ID                | description"),g.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const l=Object.keys(this.b).map(w=>this.b[w]);for(const w of l.filter(S=>!!S.description).sort(i))g.push(`|<i class="${s(w)}"></i>|${w.id}|${R.ThemeIcon.isThemeIcon(w.defaults)?w.defaults.id:w.id}|${w.description||""}|`);g.push("| preview     | identifier                        "),g.push("| ----------- | --------------------------------- |");for(const w of l.filter(S=>!R.ThemeIcon.isThemeIcon(S.defaults)).sort(i))g.push(`|<i class="${s(w)}"></i>|${w.id}|`);return g.join(`
`)}}const a=new p;E.$oo.add(e.$sx.IconContribution,a);function f(t,i,s,g){return a.registerIcon(t,i,s,g)}function d(){return a}function m(){const t=(0,P.$1j)();for(const i in t){const s="\\"+t[i].toString(16);a.registerIcon(i,{fontCharacter:s})}}m(),e.$vx="vscode://schemas/icons";const n=E.$oo.as(I.$po.JSONContribution);n.registerSchema(e.$vx,a.getIconSchema());const o=new r.$Rh(()=>n.notifySchemaChanged(e.$vx),200);a.onDidChange(()=>{o.isScheduled()||o.schedule()}),e.$wx=f("widget-close",h.$5j.close,(0,c.localize)(2,null)),e.$xx=f("goto-previous-location",h.$5j.arrowUp,(0,c.localize)(3,null)),e.$yx=f("goto-next-location",h.$5j.arrowDown,(0,c.localize)(4,null)),e.$zx=R.ThemeIcon.modify(h.$5j.sync,"spin"),e.$Ax=R.ThemeIcon.modify(h.$5j.loading,"spin")}),define(Ee[93],ye([1,0,4,3,11,2,45,5,12]),function(ce,e,r,h,P,R,T,N,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hw=e.$Gw=e.$Dw=e.$Bw=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.$xw=e.$ww=void 0,e.$yw=E,e.$zw=k,e.$Aw=p,e.$Cw=a,e.$Ew=f,e.$Fw=d,e.$ww=(0,N.$Fi)("tunnelService"),e.$xw=(0,N.$Fi)("sharedTunnelsService");var c;(function(o){o.Http="http",o.Https="https"})(c||(e.TunnelProtocol=c={}));var I;(function(o){o.ConstantPrivate="constantPrivate",o.Private="private",o.Public="public"})(I||(e.TunnelPrivacyId=I={}));function E(o){return!!o.forwardPort}var u;(function(o){o[o.Notify=1]="Notify",o[o.OpenBrowser=2]="OpenBrowser",o[o.OpenPreview=3]="OpenPreview",o[o.Silent=4]="Silent",o[o.Ignore=5]="Ignore",o[o.OpenBrowserOnce=6]="OpenBrowserOnce"})(u||(e.ProvidedOnAutoForward=u={}));function k(o){if(o.scheme!=="http"&&o.scheme!=="https")return;const t=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(o.authority);if(t)return{address:t[1],port:+t[2]}}function p(o){if(o.scheme!=="http"&&o.scheme!=="https"||!o.query)return;const t=o.query.split("&");for(const i of t){const s=i.split("=")[1];if(/^https?:/.exec(s)){const g=k(R.URI.parse(s));if(g)return g}}}e.$Bw=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function a(o){return e.$Bw.indexOf(o)>=0}e.$Dw=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function f(o){return e.$Dw.indexOf(o)>=0}function d(o,t,i,s){if(i===P.OperatingSystem.Windows)return!1;if(i===P.OperatingSystem.Macintosh&&f(t)){const g=/(\d+)\.(\d+)\.(\d+)/g.exec(s);if(g?.length===4&&parseInt(g[1])>=18)return!1}return o<1024}class m{constructor(t,i,s){this.remoteAddress=t,this.localAddress=i,this.b=s,this.a=new r.$me,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$Gw=m;let n=class extends h.$Wc{constructor(t,i){super(),this.r=t,this.s=i,this.a=new r.$me,this.onTunnelOpened=this.a.event,this.b=new r.$me,this.onTunnelClosed=this.b.event,this.c=new r.$me,this.onAddedTunnelProvider=this.c.event,this.f=new Map,this.h=!1,this.j=!0,this.m=[],this.n=new Set}get hasTunnelProvider(){return!!this.g}get t(){const t=this.s.getValue("remote.localPortHost");return!t||t==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(t){return this.g=t,t?(this.c.fire(),{dispose:()=>{this.g=void 0,this.h=!1,this.m=[]}}):(this.h=!1,this.m=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(t){this.h=t.elevation,this.m=t.privacyOptions,this.j=t.protocol}get canChangeProtocol(){return this.j}get canElevate(){return this.h}get canChangePrivacy(){return this.m.length>0}get privacyOptions(){return this.m}get tunnels(){return this.u()}async u(){const t=[],i=Array.from(this.f.values());for(const s of i){const g=Array.from(s.values());for(const l of g){const w=await l.value;w&&typeof w!="string"&&t.push(w)}}return t}async dispose(){super.dispose();for(const t of this.f.values()){for(const{value:i}of t.values())await i.then(s=>typeof s!="string"?s?.dispose():void 0);t.clear()}this.f.clear()}setEnvironmentTunnel(t,i,s,g,l){this.z(t,i,Promise.resolve({tunnelRemoteHost:t,tunnelRemotePort:i,localAddress:s,privacy:g,protocol:l,dispose:()=>Promise.resolve()}))}async getExistingTunnel(t,i){(f(t)||a(t))&&(t=e.$Bw[0]);const s=this.D(t,i);if(s)return++s.refcount,s.value}openTunnel(t,i,s,g,l,w=!1,S,D){this.r.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${i}:${s} on local port ${l}.`);const y=this.g??t;if(!y)return;if(i||(i="localhost"),g||(g=this.t),this.g&&this.n.has(s)){this.r.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const C=this.F(y,i,s,g,l,w,S,D);return C?C.then(A=>{if(A){if(typeof A=="string")return this.r.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.C(i,s),A}else{this.r.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.C(i,s);return}this.r.trace("ForwardedPorts: (TunnelService) New tunnel established.");const b=this.w(A);return(A.tunnelRemoteHost!==i||A.tunnelRemotePort!==s)&&this.r.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),S&&A.privacy!==S&&this.r.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(b),b}):(this.r.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),C)}w(t){return{tunnelRemotePort:t.tunnelRemotePort,tunnelRemoteHost:t.tunnelRemoteHost,tunnelLocalPort:t.tunnelLocalPort,localAddress:t.localAddress,privacy:t.privacy,protocol:t.protocol,dispose:async()=>{this.r.trace(`ForwardedPorts: (TunnelService) dispose request for ${t.tunnelRemoteHost}:${t.tunnelRemotePort} `);const i=this.f.get(t.tunnelRemoteHost);if(i){const s=i.get(t.tunnelRemotePort);s&&(s.refcount--,await this.y(t.tunnelRemoteHost,t.tunnelRemotePort,s))}}}}async y(t,i,s){if(s.refcount<=0){this.r.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${t}:${i}.`);const g=s.value.then(async l=>{l&&typeof l!="string"&&(await l.dispose(!0),this.b.fire({host:l.tunnelRemoteHost,port:l.tunnelRemotePort}))});return this.f.has(t)&&this.f.get(t).delete(i),g}}async closeTunnel(t,i){this.r.trace(`ForwardedPorts: (TunnelService) close request for ${t}:${i} `);const s=this.f.get(t);if(s&&s.has(i)){const g=s.get(i);g.refcount=0,await this.y(t,i,g)}}z(t,i,s){this.f.has(t)||this.f.set(t,new Map),this.f.get(t).set(i,{refcount:1,value:s})}async C(t,i){const s=this.f.get(t);if(s){const g=s.get(i),l=g?await g.value:void 0;(!l||typeof l=="string")&&s.delete(i),s.size===0&&this.f.delete(t)}}D(t,i){const s=[t];a(t)?(s.push(...e.$Bw),s.push(...e.$Dw)):f(t)&&s.push(...e.$Dw);const g=s.map(l=>this.f.get(l));for(const l of g){const w=l?.get(i);if(w)return w}}canTunnel(t){return!!k(t)}G(t,i,s,g,l,w,S){this.r.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${i}:${s} on local port ${g}.`);const D=s;this.n.add(D);const y=g===void 0?s:g,C={elevationRequired:l?this.isPortPrivileged(y):!1},A={remoteAddress:{host:i,port:s},localAddressPort:g,privacy:w,public:w?w!==I.Private:void 0,protocol:S},b=t.forwardPort(A,C);return b?(this.z(i,s,b),b.finally(()=>{this.r.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.n.delete(D)})):this.n.delete(D),b}};e.$Hw=n,e.$Hw=n=Je([Ge(0,$.$_j),Ge(1,T.$_i)],n)}),define(Ee[294],ye([1,0,5]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jl=void 0,e.$Jl=(0,r.$Fi)("IUriIdentityService")}),define(Ee[295],ye([1,0,5]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.$Iw=void 0,e.$Iw=(0,r.$Fi)("editSessionIdentityService");var h;(function(P){P[P.Complete=100]="Complete",P[P.Partial=50]="Partial",P[P.None=0]="None"})(h||(e.EditSessionIdentityMatch=h={}))}),define(Ee[296],ye([1,0,15]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1M=h,e.$2M=P,e.$3M=R,e.$4M=T,e.$5M=N;function h($){return $.scheme!==r.Schemas.file&&$.scheme!==r.Schemas.vscodeRemote}function P($){if($.folders.length)return $.folders.every(c=>h(c.uri))?$.folders[0].uri:void 0;if($.configuration&&h($.configuration))return $.configuration}function R($){return P($)?.scheme}function T($){return P($)?.authority}function N($){return P($)!==void 0}}),define(Ee[46],ye([1,0,232,16,85,23,2,5,15]),function(ce,e,r,h,P,R,T,N,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8i=e.$5i=e.$4i=e.$3i=e.$2i=e.$Zi=e.$Yi=e.WorkbenchState=e.$Si=e.$Ri=e.$Oi=void 0,e.$Pi=c,e.$Qi=I,e.$Ti=E,e.$Ui=u,e.$Vi=k,e.$Wi=a,e.$Xi=f,e.$1i=n,e.$6i=o,e.$7i=t,e.$9i=i,e.$0i=s,e.$$i=g,e.$Oi=(0,N.$Fi)("contextService");function c(l){const w=l;return typeof w?.id=="string"&&T.URI.isUri(w.uri)}function I(l){return typeof l?.id=="string"&&!c(l)&&!u(l)}e.$Ri={id:"ext-dev"},e.$Si={id:"empty-window"};function E(l,w){if(typeof l=="string"||typeof l>"u")return typeof l=="string"?{id:(0,h.$pc)(l)}:w?e.$Ri:e.$Si;const S=l;return S.configuration?{id:S.id,configPath:S.configuration}:S.folders.length===1?{id:S.id,uri:S.folders[0].uri}:{id:S.id}}function u(l){const w=l;return typeof w?.id=="string"&&T.URI.isUri(w.configPath)}function k(l){const w=l;if(w?.uri)return{id:w.id,uri:T.URI.revive(w.uri)};const S=l;if(S?.configPath)return{id:S.id,configPath:T.URI.revive(S.configPath)};if(l?.id)return{id:l.id}}var p;(function(l){l[l.EMPTY=1]="EMPTY",l[l.FOLDER=2]="FOLDER",l[l.WORKSPACE=3]="WORKSPACE"})(p||(e.WorkbenchState=p={}));function a(l){const w=l;return!!(w&&typeof w=="object"&&typeof w.id=="string"&&Array.isArray(w.folders))}function f(l){const w=l;return!!(w&&typeof w=="object"&&T.URI.isUri(w.uri)&&typeof w.name=="string"&&typeof w.toResource=="function")}class d{constructor(w,S,D,y,C){this.h=w,this.j=D,this.k=y,this.l=C,this.c=P.$Li.forUris(this.l,()=>!0),this.folders=S}update(w){this.h=w.id,this.k=w.configuration,this.j=w.transient,this.l=w.l,this.folders=w.folders}get folders(){return this.g}set folders(w){this.g=w,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(w){this.k=w}getFolder(w){return w&&this.c.findSubstr(w)||null}n(){this.c=P.$Li.forUris(this.l,()=>!0);for(const w of this.folders)this.c.set(w.uri,w)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$Yi=d;class m{constructor(w,S){this.raw=S,this.uri=w.uri,this.index=w.index,this.name=w.name}toResource(w){return(0,R.$gh)(this.uri,w)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$Zi=m;function n(l){return new m({uri:l,index:0,name:(0,R.$ch)(l)},{uri:l.toString()})}e.$2i="code-workspace",e.$3i=`.${e.$2i}`,e.$4i=[{name:(0,r.localize)(0,null),extensions:[e.$2i]}],e.$5i="workspace.json";function o(l,w){return R.$0g.isEqualOrParent(l,w.untitledWorkspacesHome)}function t(l){let w;return T.URI.isUri(l)?w=l:w=l.configuration,w?.scheme===$.Schemas.tmp}e.$8i="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function i(l){return l.id===e.$8i}function s(l,w){return!o(l,w)&&!t(l)}function g(l){return(typeof l=="string"?(0,h.$qc)(l):(0,R.$eh)(l))===e.$3i}}),define(Ee[150],ye([1,0,60,4,3,23,2,231,144,28,5,12,46,29,294,9,32,13,18]),function(ce,e,r,h,P,R,T,N,$,c,I,E,u,k,p,a,f,d,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pl=e.$Ol=e.$Ll=e.ProfileResourceType=void 0,e.$Kl=o,e.$Ml=t,e.$Nl=i;var n;(function(l){l.Settings="settings",l.Keybindings="keybindings",l.Snippets="snippets",l.Tasks="tasks",l.Extensions="extensions",l.GlobalState="globalState"})(n||(e.ProfileResourceType=n={}));function o(l){const w=l;return!!(w&&typeof w=="object"&&typeof w.id=="string"&&typeof w.isDefault=="boolean"&&typeof w.name=="string"&&T.URI.isUri(w.location)&&T.URI.isUri(w.globalStorageHome)&&T.URI.isUri(w.settingsResource)&&T.URI.isUri(w.keybindingsResource)&&T.URI.isUri(w.tasksResource)&&T.URI.isUri(w.snippetsHome)&&T.URI.isUri(w.extensionsResource))}e.$Ll=(0,I.$Fi)("IUserDataProfilesService");function t(l,w){return{id:l.id,isDefault:l.isDefault,name:l.name,shortName:l.shortName,icon:l.icon,location:T.URI.revive(l.location).with({scheme:w}),globalStorageHome:T.URI.revive(l.globalStorageHome).with({scheme:w}),settingsResource:T.URI.revive(l.settingsResource).with({scheme:w}),keybindingsResource:T.URI.revive(l.keybindingsResource).with({scheme:w}),tasksResource:T.URI.revive(l.tasksResource).with({scheme:w}),snippetsHome:T.URI.revive(l.snippetsHome).with({scheme:w}),extensionsResource:T.URI.revive(l.extensionsResource).with({scheme:w}),cacheHome:T.URI.revive(l.cacheHome).with({scheme:w}),useDefaultFlags:l.useDefaultFlags,isTransient:l.isTransient}}function i(l,w,S,D,y,C){return{id:l,name:w,location:S,isDefault:!1,shortName:y?.shortName,icon:y?.icon,globalStorageHome:C&&y?.useDefaultFlags?.globalState?C.globalStorageHome:(0,R.$gh)(S,"globalStorage"),settingsResource:C&&y?.useDefaultFlags?.settings?C.settingsResource:(0,R.$gh)(S,"settings.json"),keybindingsResource:C&&y?.useDefaultFlags?.keybindings?C.keybindingsResource:(0,R.$gh)(S,"keybindings.json"),tasksResource:C&&y?.useDefaultFlags?.tasks?C.tasksResource:(0,R.$gh)(S,"tasks.json"),snippetsHome:C&&y?.useDefaultFlags?.snippets?C.snippetsHome:(0,R.$gh)(S,"snippets"),extensionsResource:C&&y?.useDefaultFlags?.extensions?C.extensionsResource:(0,R.$gh)(S,"extensions.json"),cacheHome:(0,R.$gh)(D,l),useDefaultFlags:y?.useDefaultFlags,isTransient:y?.transient}}let s=class extends P.$Wc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(w,S,D,y){super(),this.t=w,this.u=S,this.w=D,this.y=y,this.f=!0,this.h=this.B(new h.$me),this.onDidChangeProfiles=this.h.event,this.j=this.B(new h.$me),this.onWillCreateProfile=this.j.event,this.m=this.B(new h.$me),this.onWillRemoveProfile=this.m.event,this.n=this.B(new h.$me),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],folders:new k.$Cc,workspaces:new k.$Cc,emptyWindows:new Map},this.profilesHome=(0,R.$gh)(this.t.userRoamingDataHome,"profiles"),this.g=(0,R.$gh)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(w){this.f!==w&&(this.z=void 0,this.f=w)}isEnabled(){return this.f}get C(){if(!this.z){const w=this.D(),S=[w];if(this.f)try{for(const C of this.O()){if(!C.name||!(0,m.$fg)(C.name)||!C.location){this.y.warn("Skipping the invalid stored profile",C.location||C.name);continue}S.push(i((0,R.$dh)(C.location),C.name,C.location,this.g,{shortName:C.shortName,icon:C.icon,useDefaultFlags:C.useDefaultFlags},w))}}catch(C){this.y.error(C)}const D=new k.$Cc,y=new Map;if(S.length)try{const C=this.Q();if(C.workspaces)for(const[A,b]of Object.entries(C.workspaces)){const v=T.URI.parse(A),L=S.find(O=>O.id===b);L&&D.set(v,L)}if(C.emptyWindows)for(const[A,b]of Object.entries(C.emptyWindows)){const v=S.find(L=>L.id===b);v&&y.set(A,v)}}catch(C){this.y.error(C)}this.z={profiles:S,workspaces:D,emptyWindows:y}}return this.z}D(){const w=i("__default__profile__",(0,N.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...w,extensionsResource:this.S()??w.extensionsResource,isDefault:!0}}async createTransientProfile(w){const S="Temp",D=new RegExp(`${(0,d.$if)(S)}\\s(\\d+)`);let y=0;for(const A of this.profiles){const b=D.exec(A.name),v=b?parseInt(b[1]):0;y=v>y?v:y}const C=`${S} ${y+1}`;return this.createProfile((0,r.$tj)((0,f.$2g)()).toString(16),C,{transient:!0},w)}async createNamedProfile(w,S,D){return this.createProfile((0,r.$tj)((0,f.$2g)()).toString(16),w,S,D)}async createProfile(w,S,D,y){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const C=await this.F(w,S,D);return y&&await this.setProfileForWorkspace(y,C),C}async F(w,S,D){if(!(0,m.$fg)(S)||!S)throw new Error("Name of the profile is mandatory and must be of type `string`");let y=this.r.get(S);return y||(y=(async()=>{try{if(this.profiles.find(v=>v.name===S||v.id===w))throw new Error(`Profile with ${S} name already exists`);const A=i(w,S,(0,R.$gh)(this.profilesHome,w),this.g,D,this.defaultProfile);await this.u.createFolder(A.location);const b=[];return this.j.fire({profile:A,join(v){b.push(v)}}),await a.Promises.settled(b),this.I([A],[],[]),A}finally{this.r.delete(S)}})(),this.r.set(S,y)),y}async updateProfile(w,S){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let D=this.profiles.find(y=>y.id===w.id);if(!D)throw new Error(`Profile '${w.name}' does not exist`);return D=i(D.id,S.name??D.name,D.location,this.g,{shortName:S.shortName??D.shortName,icon:S.icon===null?void 0:S.icon??D.icon,transient:S.transient??D.isTransient,useDefaultFlags:S.useDefaultFlags??D.useDefaultFlags},this.defaultProfile),this.I([],[],[D]),D}async removeProfile(w){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(w.isDefault)throw new Error("Cannot remove default profile");const S=this.profiles.find(y=>y.id===w.id);if(!S)throw new Error(`Profile '${w.name}' does not exist`);const D=[];this.m.fire({profile:S,join(y){D.push(y)}});try{await Promise.allSettled(D)}catch(y){this.y.error(y)}for(const y of[...this.C.emptyWindows.keys()])S.id===this.C.emptyWindows.get(y)?.id&&this.C.emptyWindows.delete(y);for(const y of[...this.C.workspaces.keys()])S.id===this.C.workspaces.get(y)?.id&&this.C.workspaces.delete(y);this.M(),this.I([],[S],[]);try{await this.u.del(S.cacheHome,{recursive:!0})}catch(y){(0,c.$ql)(y)!==c.FileOperationResult.FILE_NOT_FOUND&&this.y.error(y)}}async setProfileForWorkspace(w,S){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const D=this.profiles.find(y=>y.id===S.id);if(!D)throw new Error(`Profile '${S.name}' does not exist`);this.L(w,D)}unsetWorkspace(w,S){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(w,void 0,S)}async resetWorkspaces(){this.s.folders.clear(),this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const w=await this.u.resolve(this.profilesHome);await Promise.all((w.children||[]).filter(S=>S.isDirectory&&this.profiles.every(D=>!this.w.extUri.isEqual(D.location,S.resource))).map(S=>this.u.del(S.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const w=this.s.profiles.filter(S=>!this.H(S));await Promise.allSettled(w.map(S=>this.removeProfile(S)))}getProfileForWorkspace(w){const S=this.G(w),D=T.URI.isUri(S)?this.C.workspaces.get(S):this.C.emptyWindows.get(S);return D||((0,u.$Pi)(w)?this.s.folders.get(w.uri):(0,u.$Ui)(w)?this.s.workspaces.get(w.configPath):this.s.emptyWindows.get(w.id))}G(w){return(0,u.$Pi)(w)?w.uri:(0,u.$Ui)(w)?w.configPath:w.id}H(w){return!!([...this.C.emptyWindows.values()].some(S=>this.w.extUri.isEqual(S.location,w.location))||[...this.C.workspaces.values()].some(S=>this.w.extUri.isEqual(S.location,w.location))||[...this.s.emptyWindows.values()].some(S=>this.w.extUri.isEqual(S.location,w.location))||[...this.s.workspaces.values()].some(S=>this.w.extUri.isEqual(S.location,w.location))||[...this.s.folders.values()].some(S=>this.w.extUri.isEqual(S.location,w.location)))}I(w,S,D){const y=[...this.profiles,...w],C=[],A=this.s.profiles;this.s.profiles=[];for(let b of y){if(b.isDefault||S.some(L=>b.id===L.id))continue;b=D.find(L=>b.id===L.id)??b;const v=A.find(L=>b.id===L.id);if(b.isTransient)this.s.profiles.push(b);else{if(v){for(const[L,O]of this.s.emptyWindows.entries())if(b.id===O.id){this.L({id:L},b);break}for(const[L,O]of this.s.workspaces.entries())if(b.id===O.id){this.L({id:"",configPath:L},b);break}for(const[L,O]of this.s.folders.entries())if(b.id===O.id){this.L({id:"",uri:L},b);break}}C.push({location:b.location,name:b.name,shortName:b.shortName,icon:b.icon,useDefaultFlags:b.useDefaultFlags})}}this.P(C),this.z=void 0,this.J(w,S,D)}J(w,S,D){this.h.fire({added:w,removed:S,updated:D,all:this.profiles})}L(w,S,D){if(D=S?.isTransient?!0:D,D)(0,u.$Pi)(w)?(this.s.folders.delete(w.uri),S&&this.s.folders.set(w.uri,S)):(0,u.$Ui)(w)?(this.s.workspaces.delete(w.configPath),S&&this.s.workspaces.set(w.configPath,S)):(this.s.emptyWindows.delete(w.id),S&&this.s.emptyWindows.set(w.id,S));else{this.L(w,void 0,!0);const y=this.G(w);T.URI.isUri(y)?(this.C.workspaces.delete(y),S&&this.C.workspaces.set(y,S)):(this.C.emptyWindows.delete(y),S&&this.C.emptyWindows.set(y,S)),this.M()}}M(){const w={};for(const[D,y]of this.C.workspaces.entries())w[D.toString()]=y.id;const S={};for(const[D,y]of this.C.emptyWindows.entries())S[D.toString()]=y.id;this.R({workspaces:w,emptyWindows:S}),this.z=void 0}N(w){const S={},D=this.D();if(w.workspaces)for(const[C,A]of Object.entries(w.workspaces)){const b=T.URI.parse(A);S[C]=this.w.extUri.isEqual(b,D.location)?D.id:this.w.extUri.basename(b)}const y={};if(w.emptyWindows)for(const[C,A]of Object.entries(w.emptyWindows)){const b=T.URI.parse(A);y[C]=this.w.extUri.isEqual(b,D.location)?D.id:this.w.extUri.basename(b)}return{workspaces:S,emptyWindows:y}}O(){return[]}P(w){throw new Error("not implemented")}Q(){return{}}R(w){throw new Error("not implemented")}S(){}};e.$Ol=s,e.$Ol=s=Je([Ge(0,$.$Mi),Ge(1,c.$_k),Ge(2,p.$Jl),Ge(3,E.$_j)],s);class g extends s{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(w){this.a=w}Q(){return this.X}R(w){this.X=w}}e.$Pl=g}),define(Ee[151],ye([1,0,9,4,3,62,18,209,5,150]),function(ce,e,r,h,P,R,T,N,$,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fq=e.$dq=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$bq=e.$aq=e.$_p=void 0,e.$cq=k,e.$eq=a,e.$gq=d,e.$_p="__$__isNewStorageMarker",e.$aq="__$__targetStorageMarker",e.$bq=(0,$.$Fi)("storageService");var I;(function(m){m[m.NONE=0]="NONE",m[m.SHUTDOWN=1]="SHUTDOWN"})(I||(e.WillSaveStateReason=I={}));var E;(function(m){m[m.APPLICATION=-1]="APPLICATION",m[m.PROFILE=0]="PROFILE",m[m.WORKSPACE=1]="WORKSPACE"})(E||(e.StorageScope=E={}));var u;(function(m){m[m.USER=0]="USER",m[m.MACHINE=1]="MACHINE"})(u||(e.StorageTarget=u={}));function k(m){const n=m.get(e.$aq);if(n)try{return JSON.parse(n)}catch{}return Object.create(null)}class p extends P.$Wc{static{this.a=60*1e3}constructor(n={flushInterval:p.a}){super(),this.m=n,this.b=this.B(new h.$pe),this.c=this.B(new h.$pe),this.onDidChangeTarget=this.c.event,this.f=this.B(new h.$me),this.onWillSaveState=this.f.event,this.h=this.B(new r.$Rh(()=>this.n(),this.m.flushInterval)),this.j=this.B(new P.$Xc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(n,o,t){return h.Event.filter(this.b.event,i=>i.scope===n&&(o===void 0||i.key===o),t)}n(){this.j.value=(0,r.$Vh)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,P.$Rc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,R.mark)("code/willInitStorage");try{await this.O()}finally{(0,R.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(n,o){const{key:t,external:i}=o;if(t===e.$aq){switch(n){case E.APPLICATION:this.H=void 0;break;case E.PROFILE:this.F=void 0;break;case E.WORKSPACE:this.C=void 0;break}this.c.fire({scope:n})}else this.b.fire({scope:n,key:t,target:this.J(n)[t],external:i})}w(n){this.f.fire({reason:n})}get(n,o,t){return this.P(o)?.get(n,t)}getBoolean(n,o,t){return this.P(o)?.getBoolean(n,t)}getNumber(n,o,t){return this.P(o)?.getNumber(n,t)}getObject(n,o,t){return this.P(o)?.getObject(n,t)}storeAll(n,o){this.y(()=>{for(const t of n)this.store(t.key,t.value,t.scope,t.target,o)})}store(n,o,t,i,s=!1){if((0,T.$og)(o)){this.remove(n,t,s);return}this.y(()=>{this.z(n,t,i),this.P(t)?.set(n,o,s)})}remove(n,o,t=!1){this.y(()=>{this.z(n,o,void 0),this.P(o)?.delete(n,t)})}y(n){this.b.pause(),this.c.pause();try{n()}finally{this.b.resume(),this.c.resume()}}keys(n,o){const t=[],i=this.J(n);for(const s of Object.keys(i))i[s]===o&&t.push(s);return t}z(n,o,t,i=!1){const s=this.J(o);typeof t=="number"?s[n]!==t&&(s[n]=t,this.P(o)?.set(e.$aq,JSON.stringify(s),i)):typeof s[n]=="number"&&(delete s[n],this.P(o)?.set(e.$aq,JSON.stringify(s),i))}get D(){return this.C||(this.C=this.L(E.WORKSPACE)),this.C}get G(){return this.F||(this.F=this.L(E.PROFILE)),this.F}get I(){return this.H||(this.H=this.L(E.APPLICATION)),this.H}J(n){switch(n){case E.APPLICATION:return this.I;case E.PROFILE:return this.G;default:return this.D}}L(n){const o=this.P(n);return o?k(o):Object.create(null)}isNew(n){return this.getBoolean(e.$_p,n)===!0}async flush(n=I.NONE){this.f.fire({reason:n});const o=this.P(E.APPLICATION),t=this.P(E.PROFILE),i=this.P(E.WORKSPACE);switch(n){case I.NONE:await r.Promises.settled([o?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve(),i?.whenFlushed()??Promise.resolve()]);break;case I.SHUTDOWN:await r.Promises.settled([o?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve(),i?.flush(0)??Promise.resolve()]);break}}async log(){const n=this.P(E.APPLICATION)?.items??new Map,o=this.P(E.PROFILE)?.items??new Map,t=this.P(E.WORKSPACE)?.items??new Map;return d(n,o,t,this.Q(E.APPLICATION)??"",this.Q(E.PROFILE)??"",this.Q(E.WORKSPACE)??"")}async optimize(n){return await this.flush(),this.P(n)?.optimize()}async switch(n,o){return this.w(I.NONE),(0,c.$Kl)(n)?this.R(n,o):this.S(n,o)}M(n,o){return!(n.id===o.id||a(o)&&a(n))}N(n,o,t){this.y(()=>{const i=new Set;for(const[s,g]of n)i.add(s),o.get(s)!==g&&this.u(t,{key:s,external:!0});for(const[s]of o.items)i.has(s)||this.u(t,{key:s,external:!0})})}}e.$dq=p;function a(m){return m.isDefault||!!m.useDefaultFlags?.globalState}class f extends p{constructor(){super(),this.U=this.B(new N.$0p(new N.$$p,{hint:N.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new N.$0p(new N.$$p,{hint:N.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new N.$0p(new N.$$p,{hint:N.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(n=>this.u(E.WORKSPACE,n))),this.B(this.W.onDidChangeStorage(n=>this.u(E.PROFILE,n))),this.B(this.U.onDidChangeStorage(n=>this.u(E.APPLICATION,n)))}P(n){switch(n){case E.APPLICATION:return this.U;case E.PROFILE:return this.W;default:return this.X}}Q(n){switch(n){case E.APPLICATION:return"inMemory (application)";case E.PROFILE:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(n){return!1}}e.$fq=f;async function d(m,n,o,t,i,s){const g=v=>{try{return JSON.parse(v)}catch{return v}},l=new Map,w=new Map;m.forEach((v,L)=>{l.set(L,v),w.set(L,g(v))});const S=new Map,D=new Map;n.forEach((v,L)=>{S.set(L,v),D.set(L,g(v))});const y=new Map,C=new Map;o.forEach((v,L)=>{y.set(L,v),C.set(L,g(v))}),console.group(t!==i?`Storage: Application (path: ${t})`:`Storage: Application & Profile (path: ${t}, default profile)`);const A=[];if(l.forEach((v,L)=>{A.push({key:L,value:v})}),console.table(A),console.groupEnd(),console.log(w),t!==i){console.group(`Storage: Profile (path: ${i}, profile specific)`);const v=[];S.forEach((L,O)=>{v.push({key:O,value:L})}),console.table(v),console.groupEnd(),console.log(D)}console.group(`Storage: Workspace (path: ${s})`);const b=[];y.forEach((v,L)=>{b.push({key:L,value:v})}),console.table(b),console.groupEnd(),console.log(C)}}),define(Ee[119],ye([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rnc=void 0;class r{static{this.a=!1}constructor(P){this.d=P,this.b=new Map,this.c=1}add(P){const R=this.c++;return this.b.set(R,P),this.e(),R}get(P,R){return this.b.has(P)?this.b.get(P)[R]:void 0}delete(P){this.b.delete(P),this.e()}e(){r.a&&console.log(`${this.d} cache size - ${this.b.size}`)}}e.$Rnc=r}),define(Ee[63],ye([1,0,15,23,28,5]),function(ce,e,r,h,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xnc=e.$Wnc=void 0;class T{constructor(){this.a=new Set(Object.keys(r.Schemas)),this.b=new Map,this.extUri=new h.$8g($=>{const c=this.b.get($.scheme);return!(c===void 0||c&P.FileSystemProviderCapabilities.PathCaseSensitive)})}$acceptProviderInfos($,c){c===null?this.b.delete($.scheme):this.b.set($.scheme,c)}isFreeScheme($){return!this.b.has($)&&!this.a.has($)}getCapabilities($){return this.b.get($)}}e.$Wnc=T,e.$Xnc=(0,R.$Fi)("IExtHostFileSystemInfo")}),define(Ee[30],ye([1,0,5]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bQ=void 0,e.$bQ=(0,r.$Fi)("IExtHostInitDataService")}),define(Ee[297],ye([1,0,237,12,278,30]),function(ce,e,r,h,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6pc=void 0;let T=class extends P.$lR{constructor($,c,I){const E=I.remote.isRemote?"remoteexthost":$?"workerexthost":"exthost",u=I.remote.isRemote?(0,r.localize)(0,null):$?(0,r.localize)(1,null):(0,r.localize)(2,null);super(c.createLogger(E,{name:u}))}};e.$6pc=T,e.$6pc=T=Je([Ge(1,h.$ak),Ge(2,R.$bQ)],T)}),define(Ee[298],ye([1,0,9]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Doc=e.$Coc=void 0;class h{constructor(T,N,$){this.h=new Map,this.a=T,this.b=N,this.c=$,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(c=>(this.f=c,this)),this.g=this.c.onDidChangeStorage(c=>{c.shared===this.b&&c.key===this.a&&(this.f=c.value)}),this.i=new r.$Rh(()=>{const c=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const I of c.values())I.complete()}catch(I){for(const E of c.values())E.error(I)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,T])=>T!==void 0).map(([T])=>T)}get whenReady(){return this.d}get(T,N){let $=this.f[T];return typeof $>"u"&&($=N),$}update(T,N){this.f[T]=N;const $=this.h.get(T);if($!==void 0)return $.p;const c=new r.$3h;return this.h.set(T,c),this.i.isScheduled()||this.i.schedule(),c.p}dispose(){this.g.dispose()}}e.$Coc=h;class P extends h{setKeysForSync(T){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},T)}constructor(T,N){super(T.identifier.value,!0,N),this.j=T}}e.$Doc=P}),define(Ee[299],ye([1,0,4,2]),function(ce,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wpc=void 0;class P{constructor(T){this.c=T,this.a=new r.$me,this.onDidSaveNotebookDocument=this.a.event,this.b=new r.$me,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(T,N,$,c){const E=this.c.getNotebookDocument(h.URI.revive(T)).acceptModelChanged(N.value,$,c);this.b.fire(E)}$acceptDirtyStateChanged(T,N){this.c.getNotebookDocument(h.URI.revive(T)).acceptDirty(N)}$acceptModelSaved(T){const N=this.c.getNotebookDocument(h.URI.revive(T));this.a.fire(N.apiNotebook)}}e.$wpc=P}),define(Ee[20],ye([1,0,5]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$YP=e.$XP=void 0,e.$XP=(0,r.$Fi)("IExtHostRpcService");class h{constructor(R){this.getProxy=R.getProxy.bind(R),this.set=R.set.bind(R),this.dispose=R.dispose.bind(R),this.assertRegistered=R.assertRegistered.bind(R),this.drain=R.drain.bind(R)}}e.$YP=h}),define(Ee[300],ye([1,0,24,4]),function(ce,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Moc=void 0;class P{#e;constructor(T,N){this.b=new h.$me,this.onDidChange=this.b.event,this.a=r.$qn.toKey(T.identifier),this.#e=N,this.#e.onDidChangePassword($=>{$.extensionId===this.a&&this.b.fire({key:$.key})})}get(T){return this.#e.get(this.a,T)}store(T,N){return this.#e.store(this.a,T,N)}delete(T){return this.#e.delete(this.a,T)}}e.$Moc=P}),define(Ee[73],ye([1,0,5]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$boc=e.$aoc=void 0,e.$aoc=(0,r.$Fi)("IURITransformerService");class h{constructor(R){R?(this.transformIncoming=R.transformIncoming.bind(R),this.transformOutgoing=R.transformOutgoing.bind(R),this.transformOutgoingURI=R.transformOutgoingURI.bind(R),this.transformOutgoingScheme=R.transformOutgoingScheme.bind(R)):(this.transformIncoming=T=>T,this.transformOutgoing=T=>T,this.transformOutgoingURI=T=>T,this.transformOutgoingScheme=T=>T)}}e.$boc=h}),define(Ee[301],ye([1,0,302,413,414,67,2,12,415]),function(ce,e,r,h,P,R,T,N,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bqc=I,r=We(r),h=We(h),P=We(P),R=We(R);const c=!1;function I(n,o,t,i,s,g){const l=g.environment.useHostProxy,w=typeof l=="boolean"?l:!g.remote.isRemote,S={resolveProxy:C=>n.resolveProxy(C),lookupProxyAuthorization:f.bind(void 0,i,s,o,{},g.remote.isRemote),getProxyURL:()=>o.getConfiguration("http").get("proxy"),getProxySupport:()=>o.getConfiguration("http").get("proxySupport")||"off",addCertificatesV1:()=>u(o),addCertificatesV2:()=>k(o),log:i,getLogLevel:()=>{const C=i.getLevel();switch(C){case N.LogLevel.Trace:return $.LogLevel.Trace;case N.LogLevel.Debug:return $.LogLevel.Debug;case N.LogLevel.Info:return $.LogLevel.Info;case N.LogLevel.Warning:return $.LogLevel.Warning;case N.LogLevel.Error:return $.LogLevel.Error;case N.LogLevel.Off:return $.LogLevel.Off;default:return A(C)}function A(b){return i.error("Unknown log level",b),$.LogLevel.Debug}},proxyResolveTelemetry:()=>{},useHostProxy:w,loadAdditionalCertificates:async()=>{const C=[];if(g.remote.isRemote&&C.push((0,$.loadSystemCertificates)({log:i})),w){i.trace("ProxyResolver#loadAdditionalCertificates: Loading certificates from main process");const A=n.loadCertificates();A.then(b=>i.trace("ProxyResolver#loadAdditionalCertificates: Loaded certificates from main process",b.length)),C.push(A)}return(await Promise.all(C)).flat()},env:process.env},D=(0,$.createProxyResolver)(S),y=E(S,D);return a(t,y)}function E(n,o){function t(i,s){return Object.assign({},i,s)}return{http:t(r,(0,$.createHttpPatch)(n,r,o)),https:t(h,(0,$.createHttpPatch)(n,h,o)),net:t(R,(0,$.createNetPatch)(n,R)),tls:t(P,(0,$.createTlsPatch)(n,P))}}function u(n){const o=n.getConfiguration("http");return!o.get("experimental.systemCertificatesV2",c)&&!!o.get("systemCertificates")}function k(n){const o=n.getConfiguration("http");return!!o.get("experimental.systemCertificatesV2",c)&&!!o.get("systemCertificates")}const p=new Map;function a(n,o){return n.getExtensionPathIndex().then(t=>{const i=globalThis._VSCODE_NODE_MODULES.module,s=i._load;i._load=function(l,w,S){if(l==="net")return o.net;if(l==="tls")return o.tls;if(l!=="http"&&l!=="https")return s.apply(this,arguments);const D=t.findSubstr(T.URI.file(w.filename));let y=p.get(D);if(y||p.set(D,y={}),!y[l]){const C=o[l];y[l]={...C}}return y[l]}})}async function f(n,o,t,i,s,g,l,w){const S=i[g];l&&(i[g]=l),n.trace("ProxyResolver#lookupProxyAuthorization callback",`proxyURL:${g}`,`proxyAuthenticate:${l}`,`proxyAuthenticateCache:${S}`);const D=l||S,y=Array.isArray(D)?D:typeof D=="string"?[D]:[];if(m(o,y,s),y.some(C=>/^(Negotiate|Kerberos)( |$)/i.test(C))&&!w.kerberosRequested)try{w.kerberosRequested=!0;const C=await new Promise((O,M)=>{ce(["kerberos"],O,M)}).then(We),A=new URL(g),b=t.getConfiguration("http").get("proxyKerberosServicePrincipal")||(process.platform==="win32"?`HTTP/${A.hostname}`:`HTTP@${A.hostname}`);return n.debug("ProxyResolver#lookupProxyAuthorization Kerberos authentication lookup",`proxyURL:${g}`,`spn:${b}`),"Negotiate "+await(await C.initializeClient(b)).step("")}catch(C){n.error("ProxyResolver#lookupProxyAuthorization Kerberos authentication failed",C)}}let d=!1;function m(n,o,t){d||!o.length||(d=!0,n.$publicLog2("proxyAuthenticationRequest",{authenticationType:o.map(i=>i.split(" ")[0]).join(","),extensionHostType:t?"remote":"local"}))}}),define(Ee[303],ye([1,0,142]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Os=P;function h(R){return{transformIncoming:T=>T.scheme==="vscode-remote"?{scheme:"file",path:T.path,query:T.query,fragment:T.fragment}:T.scheme==="file"?{scheme:"vscode-local",path:T.path,query:T.query,fragment:T.fragment}:T,transformOutgoing:T=>T.scheme==="file"?{scheme:"vscode-remote",authority:R,path:T.path,query:T.query,fragment:T.fragment}:T.scheme==="vscode-local"?{scheme:"file",path:T.path,query:T.query,fragment:T.fragment}:T,transformOutgoingScheme:T=>T==="file"?"vscode-remote":T==="vscode-local"?"file":T}}function P(R){return new r.$Jn(h(R))}});var zt=this&&this.__importDefault||function(ce){return ce&&ce.__esModule?ce:{default:ce}};define(Ee[152],ye([1,0,247,18,2,3,5,37,28,15,55,201,44]),function(ce,e,r,h,P,R,T,N,$,c,I,E,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorsOrder=e.CloseDirection=e.$aG=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.$3F=e.EditorInputCapabilities=e.$2F=e.SaveReason=e.Verbosity=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.$RF=e.$QF=e.$PF=e.$OF=e.$NF=void 0,e.$SF=a,e.$TF=f,e.$UF=d,e.$VF=m,e.$WF=n,e.$XF=o,e.$YF=t,e.$ZF=i,e.$1F=s,e.$4F=y,e.$5F=A,e.$6F=b,e.$7F=v,e.$8F=L,e.$9F=O,e.$0F=M,e.$$F=j,e.$_F=U,e.$bG=ee,e.$cG=ne,e.$dG=De,e.$eG=$e,u=zt(u),e.$NF={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.$OF={id:"default",displayName:(0,r.localize)(0,null),providerDisplayName:(0,r.localize)(1,null)},e.$PF="workbench.editor.sidebysideEditor",e.$QF="workbench.editors.textDiffEditor",e.$RF="workbench.editors.binaryResourceDiffEditor";var k;(function(K){K[K.PROGRAMMATIC=1]="PROGRAMMATIC",K[K.USER=2]="USER",K[K.EDIT=3]="EDIT",K[K.NAVIGATION=4]="NAVIGATION",K[K.JUMP=5]="JUMP"})(k||(e.EditorPaneSelectionChangeReason=k={}));var p;(function(K){K[K.IDENTICAL=1]="IDENTICAL",K[K.SIMILAR=2]="SIMILAR",K[K.DIFFERENT=3]="DIFFERENT"})(p||(e.EditorPaneSelectionCompareResult=p={}));function a(K){const W=K;return!!W&&typeof W.getSelection=="function"&&!!W.onDidChangeSelection}function f(K){const W=K;return!!W&&typeof W.getScrollPosition=="function"&&typeof W.setScrollPosition=="function"&&!!W.onDidChangeScroll}function d(K,W,se){for(const oe of se.visibleEditorPanes)if(oe.group.id===W&&K.matches(oe.input))return oe.getViewState()}function m(K){if(y(K))return!1;const W=K;return P.URI.isUri(W?.resource)}function n(K){if(y(K))return!1;const W=K;return W?.original!==void 0&&W.modified!==void 0}function o(K){if(y(K))return!1;const W=K;return!W||W.resources&&!Array.isArray(W.resources)?!1:!!W.resources||!!W.multiDiffSource}function t(K){if(y(K)||n(K))return!1;const W=K;return W?.primary!==void 0&&W.secondary!==void 0}function i(K){if(y(K))return!1;const W=K;return W?W.resource===void 0||W.resource.scheme===c.Schemas.untitled||W.forceUntitled===!0:!1}function s(K){if(y(K))return!1;const W=K;return P.URI.isUri(W?.base?.resource)&&P.URI.isUri(W?.input1?.resource)&&P.URI.isUri(W?.input2?.resource)&&P.URI.isUri(W?.result?.resource)}var g;(function(K){K[K.SHORT=0]="SHORT",K[K.MEDIUM=1]="MEDIUM",K[K.LONG=2]="LONG"})(g||(e.Verbosity=g={}));var l;(function(K){K[K.EXPLICIT=1]="EXPLICIT",K[K.AUTO=2]="AUTO",K[K.FOCUS_CHANGE=3]="FOCUS_CHANGE",K[K.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(l||(e.SaveReason=l={}));class w{constructor(){this.a=new Map}registerSource(W,se){let oe=this.a.get(W);return oe||(oe={source:W,label:se},this.a.set(W,oe)),oe.source}getSourceLabel(W){return this.a.get(W)?.label??W}}e.$2F=new w;var S;(function(K){K[K.None=0]="None",K[K.Readonly=2]="Readonly",K[K.Untitled=4]="Untitled",K[K.Singleton=8]="Singleton",K[K.RequiresTrust=16]="RequiresTrust",K[K.CanSplitInGroup=32]="CanSplitInGroup",K[K.ForceDescription=64]="ForceDescription",K[K.CanDropIntoEditor=128]="CanDropIntoEditor",K[K.MultipleEditors=256]="MultipleEditors",K[K.Scratchpad=512]="Scratchpad"})(S||(e.EditorInputCapabilities=S={}));class D extends R.$Wc{}e.$3F=D;function y(K){return K instanceof D}function C(K){const W=K;return P.URI.isUri(W?.preferredResource)}function A(K){const W=K;return y(W?.primary)&&y(W?.secondary)}function b(K){const W=K;return y(W?.modified)&&y(W?.original)}function v(K,W,se,oe,te){return $e(oe,[(0,E.$pj)({id:"workbench.action.openLargeFile",label:(0,r.localize)(2,null),run:()=>{const le={...se,limits:{size:Number.MAX_VALUE}};K.openEditor(W,le)}}),(0,E.$pj)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,r.localize)(3,null),run:()=>te.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:u.default.Warning})}function L(K){return y(K?.editor)}function O(K){const W=K;return L(K)&&W?.group!==void 0}function M(K){const W=K;return typeof W?.groupId=="number"&&y(W.editor)}function j(K){return typeof K?.groupId=="number"}var z;(function(K){K[K.UNKNOWN=0]="UNKNOWN",K[K.REPLACE=1]="REPLACE",K[K.MOVE=2]="MOVE",K[K.UNPIN=3]="UNPIN"})(z||(e.EditorCloseContext=z={}));var F;(function(K){K[K.GROUP_ACTIVE=0]="GROUP_ACTIVE",K[K.GROUP_INDEX=1]="GROUP_INDEX",K[K.GROUP_LABEL=2]="GROUP_LABEL",K[K.GROUP_LOCKED=3]="GROUP_LOCKED",K[K.EDITORS_SELECTION=4]="EDITORS_SELECTION",K[K.EDITOR_OPEN=5]="EDITOR_OPEN",K[K.EDITOR_CLOSE=6]="EDITOR_CLOSE",K[K.EDITOR_MOVE=7]="EDITOR_MOVE",K[K.EDITOR_ACTIVE=8]="EDITOR_ACTIVE",K[K.EDITOR_LABEL=9]="EDITOR_LABEL",K[K.EDITOR_CAPABILITIES=10]="EDITOR_CAPABILITIES",K[K.EDITOR_PIN=11]="EDITOR_PIN",K[K.EDITOR_TRANSIENT=12]="EDITOR_TRANSIENT",K[K.EDITOR_STICKY=13]="EDITOR_STICKY",K[K.EDITOR_DIRTY=14]="EDITOR_DIRTY",K[K.EDITOR_WILL_DISPOSE=15]="EDITOR_WILL_DISPOSE"})(F||(e.GroupModelChangeKind=F={}));var B;(function(K){K[K.PRIMARY=1]="PRIMARY",K[K.SECONDARY=2]="SECONDARY",K[K.BOTH=3]="BOTH",K[K.ANY=4]="ANY"})(B||(e.SideBySideEditor=B={}));class _{getOriginalUri(W,se){if(!W)return;if(s(W))return e.$aG.getOriginalUri(W.result,se);if(se?.supportSideBySide){const{primary:te,secondary:le}=this.a(W);if(te&&le){if(se?.supportSideBySide===B.BOTH)return{primary:this.getOriginalUri(te,{filterByScheme:se.filterByScheme}),secondary:this.getOriginalUri(le,{filterByScheme:se.filterByScheme})};if(se?.supportSideBySide===B.ANY)return this.getOriginalUri(te,{filterByScheme:se.filterByScheme})??this.getOriginalUri(le,{filterByScheme:se.filterByScheme});W=se.supportSideBySide===B.PRIMARY?te:le}}if(n(W)||o(W)||t(W)||s(W))return;const oe=C(W)?W.preferredResource:W.resource;return!oe||!se||!se.filterByScheme?oe:this.b(oe,se.filterByScheme)}a(W){return A(W)||t(W)?{primary:W.primary,secondary:W.secondary}:b(W)||n(W)?{primary:W.modified,secondary:W.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(W,se){if(!W)return;if(s(W))return e.$aG.getCanonicalUri(W.result,se);if(se?.supportSideBySide){const{primary:te,secondary:le}=this.a(W);if(te&&le){if(se?.supportSideBySide===B.BOTH)return{primary:this.getCanonicalUri(te,{filterByScheme:se.filterByScheme}),secondary:this.getCanonicalUri(le,{filterByScheme:se.filterByScheme})};if(se?.supportSideBySide===B.ANY)return this.getCanonicalUri(te,{filterByScheme:se.filterByScheme})??this.getCanonicalUri(le,{filterByScheme:se.filterByScheme});W=se.supportSideBySide===B.PRIMARY?te:le}}if(n(W)||o(W)||t(W)||s(W))return;const oe=W.resource;return!oe||!se||!se.filterByScheme?oe:this.b(oe,se.filterByScheme)}b(W,se){if(Array.isArray(se)){if(se.some(oe=>W.scheme===oe))return W}else if(se===W.scheme)return W}}var re;(function(K){K[K.UNKNOWN=0]="UNKNOWN",K[K.KEYBOARD=1]="KEYBOARD",K[K.MOUSE=2]="MOUSE"})(re||(e.EditorCloseMethod=re={}));function U(K,W,se,oe){if(!K.isSticky(W))return!1;switch(oe.preventPinnedEditorClose){case"keyboardAndMouse":return se===re.MOUSE||se===re.KEYBOARD;case"mouse":return se===re.MOUSE;case"keyboard":return se===re.KEYBOARD}return!1}e.$aG=new _;var G;(function(K){K[K.LEFT=0]="LEFT",K[K.RIGHT=1]="RIGHT"})(G||(e.CloseDirection=G={}));class Q{constructor(){this.c=new Map,this.d=new Map}start(W){const se=this.a=W.get(T.$Ei);for(const[oe,te]of this.c)this.e(oe,te,se);this.c.clear()}e(W,se,oe){const te=oe.createInstance(se);this.d.set(W,te)}registerFileEditorFactory(W){if(this.b)throw new Error("Can only register one file editor factory.");this.b=W}getFileEditorFactory(){return(0,h.$qg)(this.b)}registerEditorSerializer(W,se){if(this.c.has(W)||this.d.has(W))throw new Error(`A editor serializer with type ID '${W}' was already registered.`);return this.a?this.e(W,se,this.a):this.c.set(W,se),(0,R.$Uc)(()=>{this.c.delete(W),this.d.delete(W)})}getEditorSerializer(W){return this.d.get(typeof W=="string"?W:W.typeId)}}N.$oo.add(e.$NF.EditorFactory,new Q);async function ee(K,W,se){return!K||!K.length?[]:await Promise.all(K.map(async oe=>{const te=P.URI.revive(oe.fileUri);if(!te){se.info("Cannot resolve the path because it is not valid.",oe);return}if(!await W.canHandleResource(te)){se.info("Cannot resolve the path because it cannot be handled",oe);return}let ue=oe.exists,X=oe.type;if(typeof ue!="boolean"||typeof X!="number")try{X=(await W.stat(te)).isDirectory?$.FileType.Directory:$.FileType.Unknown,ue=!0}catch(pe){se.error(pe),ue=!1}if(!ue&&oe.openOnlyIfExists){se.info("Cannot resolve the path because it does not exist",oe);return}if(X===$.FileType.Directory){se.info("Cannot resolve the path because it is a directory",oe);return}const ae={...oe.options,pinned:!0};return ue?{resource:te,options:ae}:{resource:te,options:ae,forceUntitled:!0}}))}var he;(function(K){K[K.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",K[K.SEQUENTIAL=1]="SEQUENTIAL"})(he||(e.EditorsOrder=he={}));function ne(K){const W=K;if(!W)return!1;const se=W;if(se.modified)return ne(se.modified);const oe=W;return!!(oe.contributionsState&&oe.viewState&&Array.isArray(oe.cursorState))}function De(K){return(0,I.$rj)(K)}function $e(K,W,se){const oe=(0,I.$sj)(K,W);return oe.forceMessage=se?.forceMessage,oe.forceSeverity=se?.forceSeverity,oe.allowDialog=se?.allowDialog,oe}}),define(Ee[304],ye([1,0,4,248,5,3,29,37,25,83,293]),function(ce,e,r,h,P,R,T,N,$,c,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mG=e.$lG=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.$kG=e.ViewContentGroups=e.$iG=e.ViewContainerLocation=e.Extensions=e.$hG=e.$gG=e.$fG=void 0,e.$jG=k,e.$fG="views",e.$gG=(0,h.localize)(0,null),e.$hG=(0,I.$tx)("default-view-icon",c.$5j.window,(0,h.localize)(1,null));var E;(function(i){i.ViewContainersRegistry="workbench.registry.view.containers",i.ViewsRegistry="workbench.registry.view"})(E||(e.Extensions=E={}));var u;(function(i){i[i.Sidebar=0]="Sidebar",i[i.Panel=1]="Panel",i[i.AuxiliaryBar=2]="AuxiliaryBar"})(u||(e.ViewContainerLocation=u={})),e.$iG=[u.Sidebar,u.Panel,u.AuxiliaryBar];function k(i){switch(i){case u.Sidebar:return"sidebar";case u.Panel:return"panel";case u.AuxiliaryBar:return"auxiliarybar"}}class p extends R.$Wc{constructor(){super(...arguments),this.c=this.B(new r.$me),this.onDidRegister=this.c.event,this.f=this.B(new r.$me),this.onDidDeregister=this.f.event,this.g=new Map,this.h=[]}get all(){return[...this.g.values()].flat()}registerViewContainer(s,g,l){const w=this.get(s.id);if(w)return w;const S=s;return S.openCommandActionDescriptor=l?.doNotRegisterOpenCommand?void 0:S.openCommandActionDescriptor??{id:S.id},(0,T.$zc)(this.g,g,[]).push(S),l?.isDefault&&this.h.push(S),this.c.fire({viewContainer:S,viewContainerLocation:g}),S}deregisterViewContainer(s){for(const g of this.g.keys()){const l=this.g.get(g),w=l?.indexOf(s);if(w!==-1){l?.splice(w,1),l.length===0&&this.g.delete(g),this.f.fire({viewContainer:s,viewContainerLocation:g});return}}}get(s){return this.all.filter(g=>g.id===s)[0]}getViewContainers(s){return[...this.g.get(s)||[]]}getViewContainerLocation(s){return[...this.g.keys()].filter(g=>this.getViewContainers(g).filter(l=>l?.id===s.id).length>0)[0]}getDefaultViewContainer(s){return this.h.find(g=>this.getViewContainerLocation(g)===s)}}N.$oo.add(E.ViewContainersRegistry,new p);var a;(function(i){i.Open="2_open",i.Debug="4_debug",i.SCM="5_scm",i.More="9_more"})(a||(e.ViewContentGroups=a={}));function f(i,s){const g=i.group??a.More,l=s.group??a.More;return g!==l?g.localeCompare(l):(i.order??5)-(s.order??5)}class d extends R.$Wc{constructor(){super(...arguments),this.c=this.B(new r.$me),this.onViewsRegistered=this.c.event,this.f=this.B(new r.$me),this.onViewsDeregistered=this.f.event,this.g=this.B(new r.$me),this.onDidChangeContainer=this.g.event,this.h=this.B(new r.$me),this.onDidChangeViewWelcomeContent=this.h.event,this.j=[],this.m=new Map,this.n=new T.$Jc}registerViews(s,g){this.registerViews2([{views:s,viewContainer:g}])}registerViews2(s){s.forEach(({views:g,viewContainer:l})=>this.r(g,l)),this.c.fire(s)}deregisterViews(s,g){const l=this.s(s,g);l.length&&this.f.fire({views:l,viewContainer:g})}moveViews(s,g){for(const l of this.m.keys())if(l!==g){const w=this.s(s,l);w.length&&(this.r(w,g),this.g.fire({views:w,from:l,to:g}))}}getViews(s){return this.m.get(s)||[]}getView(s){for(const g of this.j){const l=(this.m.get(g)||[]).filter(w=>w.id===s)[0];if(l)return l}return null}getViewContainer(s){for(const g of this.j)if((this.m.get(g)||[]).filter(w=>w.id===s)[0])return g;return null}registerViewWelcomeContent(s,g){return this.n.add(s,g),this.h.fire(s),(0,R.$Uc)(()=>{this.n.delete(s,g),this.h.fire(s)})}registerViewWelcomeContent2(s,g){const l=new Map;for(const[w,S]of g)this.n.add(s,S),l.set(w,(0,R.$Uc)(()=>{this.n.delete(s,S),this.h.fire(s)}));return this.h.fire(s),l}getViewWelcomeContent(s){const g=[];return this.n.forEach(s,l=>g.push(l)),g.sort(f)}r(s,g){let l=this.m.get(g);l||(l=[],this.m.set(g,l),this.j.push(g));for(const w of s){if(this.getView(w.id)!==null)throw new Error((0,h.localize)(2,null,w.id));l.push(w)}}s(s,g){const l=this.m.get(g);if(!l)return[];const w=[],S=[];for(const D of l)s.includes(D)?w.push(D):S.push(D);return w.length&&(S.length?this.m.set(g,S):(this.m.delete(g),this.j.splice(this.j.indexOf(g),1))),w}}N.$oo.add(E.ViewsRegistry,new d),e.$kG=(0,P.$Fi)("viewDescriptorService");var m;(function(i){i[i.Default=0]="Default",i[i.Expand=1]="Expand"})(m||(e.ViewVisibilityState=m={}));var n;(function(i){i[i.None=0]="None",i[i.Collapsed=1]="Collapsed",i[i.Expanded=2]="Expanded"})(n||(e.TreeItemCollapsibleState=n={}));class o{constructor(s,g){this.c=!1,this.d=!1,(0,$.$eo)(this,s),this.d=!!g,this.resolve=async l=>{if(g&&!this.c){const w=await g(l);w&&(this.tooltip=this.tooltip??w.tooltip,this.command=this.command??w.command)}l.isCancellationRequested||(this.c=!0)}}get hasResolve(){return this.d}resetResolve(){this.c=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.$lG=o;class t extends Error{constructor(s){super((0,h.localize)(3,null,s)),this.name="NoTreeViewError"}static is(s){return s.name==="NoTreeViewError"}}e.$mG=t}),define(Ee[305],ye([1,0,249,36]),function(ce,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$GG=e.$FG=e.$EG=e.$DG=e.$CG=e.$BG=e.$AG=e.$zG=e.$yG=e.$xG=e.$wG=e.$vG=e.$uG=e.$tG=e.$sG=e.$rG=e.$qG=void 0,e.$qG=new h.$Wj("chatSessionResponseVote","",{type:"string",description:(0,r.localize)(0,null)}),e.$rG=new h.$Wj("chatSessionResponseDetectedAgentOrCommand",!1,{type:"boolean",description:(0,r.localize)(1,null)}),e.$sG=new h.$Wj("chatResponseSupportsIssueReporting",!1,{type:"boolean",description:(0,r.localize)(2,null)}),e.$tG=new h.$Wj("chatSessionResponseFiltered",!1,{type:"boolean",description:(0,r.localize)(3,null)}),e.$uG=new h.$Wj("chatSessionRequestInProgress",!1,{type:"boolean",description:(0,r.localize)(4,null)}),e.$vG=new h.$Wj("chatResponse",!1,{type:"boolean",description:(0,r.localize)(5,null)}),e.$wG=new h.$Wj("chatRequest",!1,{type:"boolean",description:(0,r.localize)(6,null)}),e.$xG=new h.$Wj("chatEditApplied",!1,{type:"boolean",description:(0,r.localize)(7,null)}),e.$yG=new h.$Wj("chatInputHasText",!1,{type:"boolean",description:(0,r.localize)(8,null)}),e.$zG=new h.$Wj("chatInputHasFocus",!1,{type:"boolean",description:(0,r.localize)(9,null)}),e.$AG=new h.$Wj("inChatInput",!1,{type:"boolean",description:(0,r.localize)(10,null)}),e.$BG=new h.$Wj("inChat",!1,{type:"boolean",description:(0,r.localize)(11,null)}),e.$CG=new h.$Wj("chatIsEnabled",!1,{type:"boolean",description:(0,r.localize)(12,null)}),e.$DG=new h.$Wj("chatCursorAtTop",!1),e.$EG=new h.$Wj("chatInputHasAgent",!1),e.$FG=new h.$Wj("chatLocation",void 0),e.$GG=new h.$Wj("quickChatHasFocus",!1,{type:"boolean",description:(0,r.localize)(13,null)})}),define(Ee[306],ye([1,0,132,9,21,4,40,3,57,180,13,36,24,5,12,116,286,151,305]),function(ce,e,r,h,P,R,T,N,$,c,I,E,u,k,p,a,f,d,m){"use strict";var n;Object.defineProperty(e,"__esModule",{value:!0}),e.$KH=e.$JH=e.$IH=e.$HH=e.$GH=e.ChatAgentLocation=void 0,e.$LH=g,e.$MH=l;var o;(function(w){w.Panel="panel",w.Terminal="terminal",w.Notebook="notebook",w.Editor="editor"})(o||(e.ChatAgentLocation=o={})),function(w){function S(D){switch(D){case"panel":return w.Panel;case"terminal":return w.Terminal;case"notebook":return w.Notebook;case"editor":return w.Editor}return w.Panel}w.fromRaw=S}(o||(e.ChatAgentLocation=o={})),e.$GH=(0,k.$Fi)("chatAgentService");let t=class{static{this.AGENT_LEADER="@"}constructor(S){this.f=S,this.b=new Map,this.d=new R.$me,this.onDidChangeAgents=this.d.event,this.g=new Map,this.e=m.$CG.bindTo(this.f)}registerAgent(S,D){if(this.getAgent(S))throw new Error(`Agent already registered: ${JSON.stringify(S)}`);const C=this,A=D.slashCommands;D={...D,get slashCommands(){return A.filter(v=>!v.when||C.f.contextMatchesRules(E.$Dj.deserialize(v.when)))}};const b={data:D};return this.b.set(S,b),(0,N.$Uc)(()=>{this.b.delete(S),this.d.fire(void 0)})}registerAgentImplementation(S,D){const y=this.b.get(S);if(!y)throw new Error(`Unknown agent: ${JSON.stringify(S)}`);if(y.impl)throw new Error(`Agent already has implementation: ${JSON.stringify(S)}`);return y.data.isDefault&&this.e.set(!0),y.impl=D,this.d.fire(new i(y.data,D)),(0,N.$Uc)(()=>{y.impl=void 0,this.d.fire(void 0),y.data.isDefault&&this.e.set(!1)})}registerDynamicAgent(S,D){S.isDynamic=!0;const y={data:S,impl:D};return this.b.set(S.id,y),this.d.fire(new i(S,D)),(0,N.$Uc)(()=>{this.b.delete(S.id),this.d.fire(void 0)})}registerAgentCompletionProvider(S,D){return this.g.set(S,D),{dispose:()=>{this.g.delete(S)}}}async getAgentCompletionItems(S,D,y){return await this.g.get(S)?.(D,y)??[]}updateAgent(S,D){const y=this.b.get(S);if(!y?.impl)throw new Error(`No activated agent with id ${JSON.stringify(S)} registered`);y.data.metadata={...y.data.metadata,...D},this.d.fire(new i(y.data,y.impl))}getDefaultAgent(S){return(0,r.$hb)(this.getActivatedAgents(),D=>!!D.isDefault&&D.locations.includes(S))}getContributedDefaultAgent(S){return this.getAgents().find(D=>!!D.isDefault&&D.locations.includes(S))}getSecondaryAgent(){return T.Iterable.find(this.b.values(),S=>!!S.data.metadata.isSecondary)?.data}getAgent(S){if(this.h(S))return this.b.get(S)?.data}h(S){const D=this.b.get(S);return!D?.data.when||this.f.contextMatchesRules(E.$Dj.deserialize(D.data.when))}getAgentByFullyQualifiedId(S){const D=T.Iterable.find(this.b.values(),y=>g(y.data)===S)?.data;if(!(D&&!this.h(D.id)))return D}getAgents(){return Array.from(this.b.values()).map(S=>S.data).filter(S=>this.h(S.id))}getActivatedAgents(){return Array.from(this.b.values()).filter(S=>!!S.impl).filter(S=>this.h(S.data.id)).map(S=>new i(S.data,S.impl))}getAgentsByName(S){return this.getAgents().filter(D=>D.name===S)}agentHasDupeName(S){const D=this.getAgent(S);return D?this.getAgentsByName(D.name).filter(y=>y.extensionId.value!==D.extensionId.value).length>0:!1}async invokeAgent(S,D,y,C,A){const b=this.b.get(S);if(!b?.impl)throw new Error(`No activated agent with id "${S}"`);return await b.impl.invoke(D,y,C,A)}async getFollowups(S,D,y,C,A){const b=this.b.get(S);if(!b?.impl)throw new Error(`No activated agent with id "${S}"`);return b.impl?.provideFollowups?b.impl.provideFollowups(D,y,C,A):[]}};e.$HH=t,e.$HH=t=Je([Ge(0,E.$Xj)],t);class i{constructor(S,D){this.b=S,this.d=D}get id(){return this.b.id}get name(){return this.b.name??""}get fullName(){return this.b.fullName??""}get description(){return this.b.description??""}get extensionId(){return this.b.extensionId}get extensionPublisherId(){return this.b.extensionPublisherId}get extensionPublisherDisplayName(){return this.b.publisherDisplayName}get extensionDisplayName(){return this.b.extensionDisplayName}get isDefault(){return this.b.isDefault}get metadata(){return this.b.metadata}get slashCommands(){return this.b.slashCommands}get defaultImplicitVariables(){return this.b.defaultImplicitVariables}get locations(){return this.b.locations}async invoke(S,D,y,C){return this.d.invoke(S,D,y,C)}async provideFollowups(S,D,y,C){return this.d.provideFollowups?this.d.provideFollowups(S,D,y,C):[]}provideWelcomeMessage(S,D){if(this.d.provideWelcomeMessage)return this.d.provideWelcomeMessage(S,D)}provideSampleQuestions(S,D){if(this.d.provideSampleQuestions)return this.d.provideSampleQuestions(S,D)}}e.$IH=i,e.$JH=(0,k.$Fi)("chatAgentNameService");let s=class{static{n=this}static{this.b="chat.participantNameRegistry"}constructor(S,D,y,C){if(this.g=D,this.h=y,this.i=C,this.e=(0,c.$7d)(this,Object.create(null)),this.f=!1,!S.chatParticipantRegistry)return;this.d=S.chatParticipantRegistry;const A=C.get(n.b,d.StorageScope.APPLICATION);try{this.e.set(JSON.parse(A??"{}"),void 0)}catch{C.remove(n.b,d.StorageScope.APPLICATION)}this.j()}j(){this.f||this.k().catch(S=>this.h.warn("Failed to fetch chat participant registry",S)).then(()=>(0,h.$Gh)(5*60*1e3)).then(()=>this.j())}async k(){const S=await this.g.request({type:"GET",url:this.d},P.CancellationToken.None);if(S.res.statusCode!==200)throw new Error("Could not get extensions report.");const D=await(0,f.$7p)(S);if(!D||D.version!==1)throw new Error("Unexpected chat participant registry response.");const y=D.restrictedChatParticipants;this.e.set(y,void 0),this.i.store(n.b,JSON.stringify(y),d.StorageScope.APPLICATION,d.StorageTarget.MACHINE)}getAgentNameRestriction(S){const D=this.l(S.name,S).get(),y=!S.fullName||this.l(S.fullName.replace(/\s/g,""),S).get();return D&&y}l(S,D){return this.e.map(C=>C[S.toLowerCase()]).map(C=>C?C.some(A=>(0,I.$Gf)(A,A.includes(".")?D.extensionId.value:D.extensionPublisherId)):!0)}dispose(){this.f=!0}};e.$KH=s,e.$KH=s=n=Je([Ge(0,a.$sk),Ge(1,f.$1p),Ge(2,p.$_j),Ge(3,d.$bq)],s);function g(w){return`${w.extensionId.value}.${w.id}`}function l(w){const S="name"in w?w:{...w,name:w.id};return"extensionPublisherId"in S||(S.extensionPublisherId=S.extensionPublisher??""),"extensionDisplayName"in S||(S.extensionDisplayName=""),"extensionId"in S||(S.extensionId=new u.$qn("")),(0,$.$ci)(S)}}),define(Ee[307],ye([1,0,2,31,5]),function(ce,e,r,h,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fH=e.$eH=e.ChatCopyKind=e.ChatAgentVoteDirection=void 0,e.$cH=R,e.$dH=T;function R(c){return!!c&&typeof c=="object"&&"uri"in c&&c.uri instanceof r.URI&&"version"in c&&typeof c.version=="number"&&"ranges"in c&&Array.isArray(c.ranges)&&c.ranges.every(h.$Ht.isIRange)}function T(c){return!!c&&typeof c=="object"&&"documents"in c&&Array.isArray(c.documents)&&c.documents.every(R)}var N;(function(c){c[c.Down=0]="Down",c[c.Up=1]="Up"})(N||(e.ChatAgentVoteDirection=N={}));var $;(function(c){c[c.Action=1]="Action",c[c.Toolbar=2]="Toolbar"})($||(e.ChatCopyKind=$={})),e.$eH=(0,P.$Fi)("IChatService"),e.$fH="accessibility.voice.keywordActivation"}),define(Ee[153],ye([1,0,4,9,251]),function(ce,e,r,h,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qtb=void 0;class R{constructor(){this.f=new Map,this.m=[],this.n=new r.$me,this.o=new r.$me,this.d=1}get onError(){return this.n.event}get onExit(){return this.o.event}onMessage(N){this.k&&this.n.fire(new Error("attempt to set more than one 'Message' callback")),this.k=N}onEvent(N){this.j&&this.n.fire(new Error("attempt to set more than one 'Event' callback")),this.j=N}onRequest(N){this.g&&this.n.fire(new Error("attempt to set more than one 'Request' callback")),this.g=N}sendResponse(N){N.seq>0?this.n.fire(new Error(`attempt to send more than one response for command ${N.command}`)):this.u("response",N)}sendRequest(N,$,c,I){const E={command:N};if($&&Object.keys($).length>0&&(E.arguments=$),this.u("request",E),typeof I=="number"){const u=setTimeout(()=>{clearTimeout(u);const k=this.f.get(E.seq);if(k){this.f.delete(E.seq);const p={type:"response",seq:0,request_seq:E.seq,success:!1,command:N,message:(0,P.localize)(0,null,I,N)};k(p)}},I)}return c&&this.f.set(E.seq,c),E.seq}acceptMessage(N){this.k?this.k(N):(this.m.push(N),this.m.length===1&&this.s())}q(N,$){return N.type!=="event"||$.type!=="event"}async s(){let N;for(;this.m.length;){if((!N||this.q(this.m[0],N))&&await(0,h.$Gh)(0),N=this.m.shift(),!N)return;switch(N.type){case"event":this.j?.(N);break;case"request":this.g?.(N);break;case"response":{const $=N,c=this.f.get($.request_seq);c&&(this.f.delete($.request_seq),c($));break}}}}u(N,$){$.type=N,$.seq=this.d++,this.sendMessage($)}async w(){if(this.f.size===0)return Promise.resolve();const N=new Map;this.f.forEach(($,c)=>N.set(c,$)),await(0,h.$Gh)(500),N.forEach(($,c)=>{$({type:"response",seq:0,request_seq:c,success:!1,command:"canceled",message:"canceled"}),this.f.delete(c)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.m=[]}}e.$qtb=R}),define(Ee[120],ye([1,0,2,252,36,5]),function(ce,e,r,h,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDebugVisualization=e.IDebugVisualizationTreeItem=e.DebugTreeItemCollapsibleState=e.DebugVisualizationType=e.BreakpointWidgetContext=e.$zK=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.DataBreakpointSetType=e.$xK=e.MemoryRangeType=e.State=e.$vK=e.$uK=e.$tK=e.$sK=e.$rK=e.$qK=e.$pK=e.$oK=e.$nK=e.$mK=e.$lK=e.$kK=e.$jK=e.$iK=e.$hK=e.$gK=e.$fK=e.$eK=e.$dK=e.$cK=e.$bK=e.$aK=e.$_J=e.$$J=e.$0J=e.$9J=e.$8J=e.$7J=e.$6J=e.$5J=e.$4J=e.$3J=e.$2J=e.$1J=e.$ZJ=e.$YJ=e.$XJ=e.$WJ=e.$VJ=e.$UJ=e.$TJ=e.$SJ=e.$RJ=e.$QJ=e.$PJ=e.$OJ=e.$NJ=e.$MJ=e.$LJ=e.$KJ=e.$JJ=e.$IJ=e.$HJ=e.$GJ=e.$FJ=e.$EJ=e.$DJ=e.$CJ=e.$BJ=e.$AJ=e.$zJ=e.$yJ=e.$xJ=e.$wJ=e.$vJ=e.$uJ=e.$tJ=e.$sJ=e.$rJ=e.$qJ=e.$pJ=e.$oJ=e.$nJ=e.$mJ=e.$lJ=e.$kJ=void 0,e.$wK=$,e.$yK=I,h=We(h),e.$kJ="workbench.view.debug",e.$lJ="workbench.debug.variablesView",e.$mJ="workbench.debug.watchExpressionsView",e.$nJ="workbench.debug.callStackView",e.$oJ="workbench.debug.loadedScriptsView",e.$pJ="workbench.debug.breakPointsView",e.$qJ="workbench.debug.disassemblyView",e.$rJ="workbench.panel.repl",e.$sJ="workbench.panel.repl.view",e.$tJ=new P.$Wj("debugType",void 0,{type:"string",description:h.localize(0,null)}),e.$uJ=new P.$Wj("debugConfigurationType",void 0,{type:"string",description:h.localize(1,null)}),e.$vJ=new P.$Wj("debugState","inactive",{type:"string",description:h.localize(2,null)}),e.$wJ="debugUx",e.$xJ=new P.$Wj(e.$wJ,"default",{type:"string",description:h.localize(3,null)}),e.$yJ=new P.$Wj("hasDebugged",!1,{type:"boolean",description:h.localize(4,null)}),e.$zJ=new P.$Wj("inDebugMode",!1,{type:"boolean",description:h.localize(5,null)}),e.$AJ=new P.$Wj("inDebugRepl",!1,{type:"boolean",description:h.localize(6,null)}),e.$BJ=new P.$Wj("breakpointWidgetVisible",!1,{type:"boolean",description:h.localize(7,null)}),e.$CJ=new P.$Wj("inBreakpointWidget",!1,{type:"boolean",description:h.localize(8,null)}),e.$DJ=new P.$Wj("breakpointsFocused",!0,{type:"boolean",description:h.localize(9,null)}),e.$EJ=new P.$Wj("watchExpressionsFocused",!0,{type:"boolean",description:h.localize(10,null)}),e.$FJ=new P.$Wj("watchExpressionsExist",!1,{type:"boolean",description:h.localize(11,null)}),e.$GJ=new P.$Wj("variablesFocused",!0,{type:"boolean",description:h.localize(12,null)}),e.$HJ=new P.$Wj("expressionSelected",!1,{type:"boolean",description:h.localize(13,null)}),e.$IJ=new P.$Wj("breakpointInputFocused",!1,{type:"boolean",description:h.localize(14,null)}),e.$JJ=new P.$Wj("callStackItemType",void 0,{type:"string",description:h.localize(15,null)}),e.$KJ=new P.$Wj("callStackSessionIsAttach",!1,{type:"boolean",description:h.localize(16,null)}),e.$LJ=new P.$Wj("callStackItemStopped",!1,{type:"boolean",description:h.localize(17,null)}),e.$MJ=new P.$Wj("callStackSessionHasOneThread",!1,{type:"boolean",description:h.localize(18,null)}),e.$NJ=new P.$Wj("watchItemType",void 0,{type:"string",description:h.localize(19,null)}),e.$OJ=new P.$Wj("canViewMemory",void 0,{type:"boolean",description:h.localize(20,null)}),e.$PJ=new P.$Wj("breakpointItemType",void 0,{type:"string",description:h.localize(21,null)}),e.$QJ=new P.$Wj("breakpointItemBytes",void 0,{type:"boolean",description:h.localize(22,null)}),e.$RJ=new P.$Wj("breakpointHasModes",!1,{type:"boolean",description:h.localize(23,null)}),e.$SJ=new P.$Wj("breakpointSupportsCondition",!1,{type:"boolean",description:h.localize(24,null)}),e.$TJ=new P.$Wj("loadedScriptsSupported",!1,{type:"boolean",description:h.localize(25,null)}),e.$UJ=new P.$Wj("loadedScriptsItemType",void 0,{type:"string",description:h.localize(26,null)}),e.$VJ=new P.$Wj("focusedSessionIsAttach",!1,{type:"boolean",description:h.localize(27,null)}),e.$WJ=new P.$Wj("focusedSessionIsNoDebug",!1,{type:"boolean",description:h.localize(28,null)}),e.$XJ=new P.$Wj("stepBackSupported",!1,{type:"boolean",description:h.localize(29,null)}),e.$YJ=new P.$Wj("restartFrameSupported",!1,{type:"boolean",description:h.localize(30,null)}),e.$ZJ=new P.$Wj("stackFrameSupportsRestart",!1,{type:"boolean",description:h.localize(31,null)}),e.$1J=new P.$Wj("jumpToCursorSupported",!1,{type:"boolean",description:h.localize(32,null)}),e.$2J=new P.$Wj("stepIntoTargetsSupported",!1,{type:"boolean",description:h.localize(33,null)}),e.$3J=new P.$Wj("breakpointsExist",!1,{type:"boolean",description:h.localize(34,null)}),e.$4J=new P.$Wj("debuggersAvailable",!1,{type:"boolean",description:h.localize(35,null)}),e.$5J=new P.$Wj("debugExtensionAvailable",!0,{type:"boolean",description:h.localize(36,null)}),e.$6J=new P.$Wj("debugProtocolVariableMenuContext",void 0,{type:"string",description:h.localize(37,null)}),e.$7J=new P.$Wj("debugSetVariableSupported",!1,{type:"boolean",description:h.localize(38,null)}),e.$8J=new P.$Wj("debugSetDataBreakpointAddressSupported",!1,{type:"boolean",description:h.localize(39,null)}),e.$9J=new P.$Wj("debugSetExpressionSupported",!1,{type:"boolean",description:h.localize(40,null)}),e.$0J=new P.$Wj("breakWhenValueChangesSupported",!1,{type:"boolean",description:h.localize(41,null)}),e.$$J=new P.$Wj("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:h.localize(42,null)}),e.$_J=new P.$Wj("breakWhenValueIsReadSupported",!1,{type:"boolean",description:h.localize(43,null)}),e.$aK=new P.$Wj("terminateDebuggeeSupported",!1,{type:"boolean",description:h.localize(44,null)}),e.$bK=new P.$Wj("suspendDebuggeeSupported",!1,{type:"boolean",description:h.localize(45,null)}),e.$cK=new P.$Wj("variableEvaluateNamePresent",!1,{type:"boolean",description:h.localize(46,null)}),e.$dK=new P.$Wj("variableIsReadonly",!1,{type:"boolean",description:h.localize(47,null)}),e.$eK=new P.$Wj("variableValue",!1,{type:"string",description:h.localize(48,null)}),e.$fK=new P.$Wj("variableType",!1,{type:"string",description:h.localize(49,null)}),e.$gK=new P.$Wj("variableInterfaces",!1,{type:"array",description:h.localize(50,null)}),e.$hK=new P.$Wj("variableName",!1,{type:"string",description:h.localize(51,null)}),e.$iK=new P.$Wj("variableLanguage",!1,{type:"string",description:h.localize(52,null)}),e.$jK=new P.$Wj("variableExtensionId",!1,{type:"string",description:h.localize(53,null)}),e.$kK=new P.$Wj("exceptionWidgetVisible",!1,{type:"boolean",description:h.localize(54,null)}),e.$lK=new P.$Wj("multiSessionRepl",!1,{type:"boolean",description:h.localize(55,null)}),e.$mK=new P.$Wj("multiSessionDebug",!1,{type:"boolean",description:h.localize(56,null)}),e.$nK=new P.$Wj("disassembleRequestSupported",!1,{type:"boolean",description:h.localize(57,null)}),e.$oK=new P.$Wj("disassemblyViewFocus",!1,{type:"boolean",description:h.localize(58,null)}),e.$pK=new P.$Wj("languageSupportsDisassembleRequest",!1,{type:"boolean",description:h.localize(59,null)}),e.$qK=new P.$Wj("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:h.localize(60,null)});const T=n=>h.localize(61,null,n);e.$rK=T,e.$sK="editor.contrib.debug",e.$tK="editor.contrib.breakpoint",e.$uK="debug",e.$vK={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:h.localize(62,null)};var N;(function(n){n[n.Inactive=0]="Inactive",n[n.Initializing=1]="Initializing",n[n.Stopped=2]="Stopped",n[n.Running=3]="Running"})(N||(e.State=N={}));function $(n){switch(n){case N.Initializing:return"initializing";case N.Stopped:return"stopped";case N.Running:return"running";default:return"inactive"}}var c;(function(n){n[n.Valid=0]="Valid",n[n.Unreadable=1]="Unreadable",n[n.Error=2]="Error"})(c||(e.MemoryRangeType=c={})),e.$xK="vscode-debug-memory";function I(n){const o=n.presentationHint??n.source.presentationHint;return o==="deemphasize"||o==="subtle"}var E;(function(n){n[n.Variable=0]="Variable",n[n.Address=1]="Address"})(E||(e.DataBreakpointSetType=E={}));var u;(function(n){n[n.Initial=1]="Initial",n[n.Dynamic=2]="Dynamic"})(u||(e.DebugConfigurationProviderTriggerKind=u={}));var k;(function(n){n.UnverifiedBreakpoints="unverifiedBreakpoints"})(k||(e.DebuggerString=k={})),e.$zK=(0,R.$Fi)("debugService");var p;(function(n){n[n.CONDITION=0]="CONDITION",n[n.HIT_COUNT=1]="HIT_COUNT",n[n.LOG_MESSAGE=2]="LOG_MESSAGE",n[n.TRIGGER_POINT=3]="TRIGGER_POINT"})(p||(e.BreakpointWidgetContext=p={}));var a;(function(n){n[n.Command=0]="Command",n[n.Tree=1]="Tree"})(a||(e.DebugVisualizationType=a={}));var f;(function(n){n[n.None=0]="None",n[n.Collapsed=1]="Collapsed",n[n.Expanded=2]="Expanded"})(f||(e.DebugTreeItemCollapsibleState=f={}));var d;(function(n){n.deserialize=o=>o,n.serialize=o=>o})(d||(e.IDebugVisualizationTreeItem=d={}));var m;(function(n){n.deserialize=o=>({id:o.id,name:o.name,iconPath:o.iconPath&&{light:r.URI.revive(o.iconPath.light),dark:r.URI.revive(o.iconPath.dark)},iconClass:o.iconClass,visualization:o.visualization}),n.serialize=o=>o})(m||(e.IDebugVisualization=m={}))}),define(Ee[308],ye([1,0,13,2,16,25,15,31,21,19]),function(ce,e,r,h,P,R,T,N,$,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4H=void 0,e.$RH=E,e.$SH=u,e.$TH=k,e.$UH=p,e.$VH=a,e.$WH=f,e.$XH=d,e.$YH=n,e.$ZH=i,e.$1H=s,e.$2H=l,e.$3H=S;const I=/{([^}]+)}/g;function E(y,C,A){return y.replace(I,function(b,v){return C&&v.length>0&&v[0]!=="_"?b:A&&A.hasOwnProperty(v)?A[v]:b})}function u(y){const C={};for(const A of Object.keys(y))A.startsWith("!")||(C[A]=y[A]);return C}function k(y){return y.configuration.request==="attach"&&!p(y)&&(!y.parentSession||k(y.parentSession))}function p(y){let C=y.configuration.type;if(C)return C==="vslsShare"&&(C=y.configuration.adapterProxy.configuration.type),(0,r.$Gf)(C,"extensionhost")||(0,r.$Gf)(C,"pwa-extensionhost")?y:y.parentSession?p(y.parentSession):void 0}function a(y){return y.type&&(y.label||y.program||y.runtime)}function f(y,C,A){let b,v=0;const L=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let O=null;for(;O=L.exec(y);){const M=O.index+1,j=M+O[0].length;if(M<=C&&j>=A){b=O[0],v=M;break}}if(b){const M=/\w+/g;let j=null;for(;(j=M.exec(b))&&!(j.index+1+v+j[0].length>=A););j&&(b=b.substring(0,M.lastIndex))}return b?{start:v,end:v+b.length-1}:{start:0,end:0}}async function d(y,C,A,b){if(y.evaluatableExpressionProvider.has(C)){const v=y.evaluatableExpressionProvider.ordered(C),L=(0,c.$Jb)(await Promise.all(v.map(async O=>{try{return await O.provideEvaluatableExpression(C,A,b??$.CancellationToken.None)}catch{return}})));if(L.length>0){let O=L[0].expression;const M=L[0].range;return O||(O=C.getLineContent(A.lineNumber).substring(M.startColumn-1,M.endColumn-1)),{range:M,matchingExpression:O}}}else{const v=C.getLineContent(A.lineNumber),{start:L,end:O}=f(v,A.column,A.column),M=v.substring(L-1,O);return{matchingExpression:M,range:new N.$Ht(A.lineNumber,L,A.lineNumber,L+M.length)}}return null}const m=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function n(y){return!!(y&&y.match(m))}function o(y){if(typeof y.path=="string"&&!(typeof y.sourceReference=="number"&&y.sourceReference>0)){if(n(y.path))return h.URI.parse(y.path);if((0,P.$kc)(y.path))return h.URI.file(y.path)}return y.path}function t(y){if(typeof y.path=="object"){const C=h.URI.revive(y.path);if(C)return C.scheme===T.Schemas.file?C.fsPath:C.toString()}return y.path}function i(y,C){const A=C?o:t,b=(0,R.$bo)(y);return g(b,(v,L)=>{v&&L&&(L.path=A(L))}),b}function s(y,C){const A=C?o:t,b=(0,R.$bo)(y);return g(b,(v,L)=>{!v&&L&&(L.path=A(L))}),b}function g(y,C){switch(y.type){case"event":{const A=y;switch(A.event){case"output":C(!1,A.body.source);break;case"loadedSource":C(!1,A.body.source);break;case"breakpoint":C(!1,A.body.breakpoint.source);break;default:break}break}case"request":{const A=y;switch(A.command){case"setBreakpoints":C(!0,A.arguments.source);break;case"breakpointLocations":C(!0,A.arguments.source);break;case"source":C(!0,A.arguments.source);break;case"gotoTargets":C(!0,A.arguments.source);break;case"launchVSCode":A.arguments.args.forEach(b=>C(!1,b));break;default:break}break}case"response":{const A=y;if(A.success&&A.body)switch(A.command){case"stackTrace":A.body.stackFrames.forEach(b=>C(!1,b.source));break;case"loadedSources":A.body.sources.forEach(b=>C(!1,b));break;case"scopes":A.body.scopes.forEach(b=>C(!1,b.source));break;case"setFunctionBreakpoints":A.body.breakpoints.forEach(b=>C(!1,b.source));break;case"setBreakpoints":A.body.breakpoints.forEach(b=>C(!1,b.source));break;case"disassemble":A.body?.instructions.forEach(v=>C(!1,v.location));break;default:break}break}}}function l(y){return y.filter(C=>!C.presentation?.hidden).sort((C,A)=>C.presentation?A.presentation?C.presentation.group?A.presentation.group?C.presentation.group!==A.presentation.group?C.presentation.group.localeCompare(A.presentation.group):w(C.presentation.order,A.presentation.order):-1:A.presentation.group?1:w(C.presentation.order,A.presentation.order):-1:A.presentation?1:0)}function w(y,C){return typeof y!="number"?typeof C!="number"?0:1:typeof C!="number"?-1:y-C}async function S(y,C){const A=y.getValue("debug.saveBeforeStart",{overrideIdentifier:C.activeTextEditorLanguageId});if(A!=="none"&&(await C.saveAll(),A==="allEditorsInActiveGroup")){const b=C.activeEditorPane;b&&b.input.resource?.scheme===T.Schemas.untitled&&await C.save({editor:b.input,groupId:b.group.id})}await y.reloadConfiguration()}const D=(y,C)=>!y||!C?y===C:y.name===C.name&&y.path===C.path&&y.sourceReference===C.sourceReference;e.$4H=D}),define(Ee[309],ye([1,0,58,67,25,16,11,13,34,253,153]),function(ce,e,r,h,P,R,T,N,$,c,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dqc=e.$cqc=e.$bqc=e.$aqc=e.$_pc=void 0,r=We(r),h=We(h),P=We(P),R=We(R),T=We(T),N=We(N),c=We(c);class E extends I.$qtb{static{this.a=`\r
\r
`}static{this.b=/\r?\n/}static{this.i=/: */}constructor(){super(),this.p=Buffer.allocUnsafe(0),this.r=-1}t(d,m){this.l=m,this.p=Buffer.allocUnsafe(0),this.r=-1,d.on("data",n=>this.v(n))}sendMessage(d){if(this.l){const m=JSON.stringify(d);this.l.write(`Content-Length: ${Buffer.byteLength(m,"utf8")}${E.a}${m}`,"utf8")}}v(d){for(this.p=Buffer.concat([this.p,d]);;){if(this.r>=0){if(this.p.length>=this.r){const m=this.p.toString("utf8",0,this.r);if(this.p=this.p.slice(this.r),this.r=-1,m.length>0)try{this.acceptMessage(JSON.parse(m))}catch(n){this.n.fire(new Error((n.message||n)+`
`+m))}continue}}else{const m=this.p.indexOf(E.a);if(m!==-1){const o=this.p.toString("utf8",0,m).split(E.b);for(const t of o){const i=t.split(E.i);i[0]==="Content-Length"&&(this.r=Number(i[1]))}this.p=this.p.slice(m+E.a.length);continue}}break}}}e.$_pc=E;class u extends E{startSession(){return new Promise((d,m)=>{let n=!1;this.x=this.y(()=>{this.t(this.x,this.x),d(),n=!0}),this.x.on("close",()=>{n?this.n.fire(new Error("connection closed")):m(new Error("connection closed"))}),this.x.on("error",o=>{n?this.n.fire(o):m(o)})})}async stopSession(){await this.w(),this.x&&(this.x.end(),this.x=void 0)}}e.$aqc=u;class k extends u{constructor(d){super(),this.z=d}y(d){return h.createConnection(this.z.port,this.z.host||"127.0.0.1",d)}}e.$bqc=k;class p extends u{constructor(d){super(),this.z=d}y(d){return h.createConnection(this.z.path,d)}}e.$cqc=p;class a extends E{constructor(d,m){super(),this.y=d,this.z=m}async startSession(){const d=this.y.command,m=this.y.args,n=this.y.options||{};try{if(d)if(R.$kc(d)){if(!await $.Promises.exists(d))throw new Error(c.localize(0,null,d))}else d.indexOf("/")<0&&d.indexOf("\\")<0;else throw new Error(c.localize(1,null,this.z));let o=process.env;if(n.env&&Object.keys(n.env).length>0&&(o=P.$eo(P.$bo(process.env),n.env)),d==="node")if(Array.isArray(m)&&m.length>0){const t=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,i={env:o,execArgv:t?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};n.cwd&&(i.cwd=n.cwd);const s=r.fork(m[0],m.slice(1),i);if(!s.pid)throw new Error(c.localize(2,null,m[0]));this.x=s}else throw new Error(c.localize(3,null));else{const t={env:o};n.cwd&&(t.cwd=n.cwd),this.x=r.spawn(d,m,t)}this.x.on("error",t=>{this.n.fire(t)}),this.x.on("exit",(t,i)=>{this.o.fire(t)}),this.x.stdout.on("close",()=>{this.n.fire(new Error("read error"))}),this.x.stdout.on("error",t=>{this.n.fire(t)}),this.x.stdin.on("error",t=>{this.n.fire(t)}),this.x.stderr.resume(),this.t(this.x.stdout,this.x.stdin)}catch(o){this.n.fire(o)}}async stopSession(){return this.x?(await this.w(),T.$i?new Promise((d,m)=>{const n=r.exec(`taskkill /F /T /PID ${this.x.pid}`,function(o,t,i){if(o)return m(o)});n.on("exit",d),n.on("error",m)}):(this.x.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static A(d,m){if(!d)return;const n=Object.create(null);d.runtime&&(d.runtime.indexOf("./")===0?n.runtime=R.$lc(m,d.runtime):n.runtime=d.runtime),d.runtimeArgs&&(n.runtimeArgs=d.runtimeArgs),d.program&&(R.$kc(d.program)?n.program=d.program:n.program=R.$lc(m,d.program)),d.args&&(n.args=d.args);const o=d;return o.win&&(n.win=a.A(o.win,m)),o.winx86&&(n.winx86=a.A(o.winx86,m)),o.windows&&(n.windows=a.A(o.windows,m)),o.osx&&(n.osx=a.A(o.osx,m)),o.linux&&(n.linux=a.A(o.linux,m)),n}static platformAdapterExecutable(d,m){let n=Object.create(null);m=m.toLowerCase();for(const l of d)if(l.contributes){const w=l.contributes.debuggers;w&&w.length>0&&w.filter(S=>typeof S.type=="string"&&N.$Gf(S.type,m)).forEach(S=>{const D=a.A(S,l.extensionLocation.fsPath);n=P.$eo(n,D,l.isBuiltin)})}let o;T.$i&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?o=n.winx86||n.win||n.windows:T.$i?o=n.win||n.windows:T.$j?o=n.osx:T.$k&&(o=n.linux),o=o||n;const t=o.program||n.program,i=o.args||n.args,s=o.runtime||n.runtime,g=o.runtimeArgs||n.runtimeArgs;if(s)return{type:"executable",command:s,args:(g||[]).concat(typeof t=="string"?[t]:[]).concat(i||[])};if(t)return{type:"executable",command:t,args:i||[]}}}e.$dqc=a}),define(Ee[310],ye([1,0,58,33,11]),function(ce,e,r,h,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eqc=T,e.$fqc=$,r=We(r),P=We(P);function R(c,I){return new Promise((E,u)=>{let k="";const p=r.spawn(c,I);p.pid&&p.stdout.on("data",a=>{k+=a.toString()}),p.on("error",a=>{u(a)}),p.on("close",a=>{E(k)})})}async function T(c){if(c)if(P.$i){const I=await new Promise((E,u)=>{ce(["@vscode/windows-process-tree"],E,u)}).then(We);return new Promise(E=>{I.getProcessTree(c,u=>{E(!!u&&u.children.length>0)})})}else return R("/usr/bin/pgrep",["-lP",String(c)]).then(I=>{const E=I.trim();return!(E.length===0||E.indexOf(" tmux")>=0)},I=>!0);return Promise.resolve(!0)}var N;(function(c){c[c.cmd=0]="cmd",c[c.powershell=1]="powershell",c[c.bash=2]="bash"})(N||(N={}));function $(c,I,E,u,k){c=c.trim().toLowerCase();let p;c.indexOf("powershell")>=0||c.indexOf("pwsh")>=0?p=N.powershell:c.indexOf("cmd.exe")>=0?p=N.cmd:c.indexOf("bash")>=0?p=N.bash:P.$i?p=N.cmd:p=N.bash;let a,f=" ";switch(p){case N.powershell:if(a=d=>(d=d.replace(/\'/g,"''"),d.length>0&&d.charAt(d.length-1)==="\\"?`'${d}\\'`:`'${d}'`),u){const d=(0,h.$Kg)(u);d&&(f+=`${d}:; `),f+=`cd ${a(u)}; `}if(k)for(const d in k){const m=k[d];m===null?f+=`Remove-Item env:${d}; `:f+=`\${env:${d}}='${m}'; `}if(I.length>0){const d=I.shift(),m=E?d:a(d);f+=m[0]==="'"?`& ${m} `:`${m} `;for(const n of I)f+=n==="<"||n===">"||E?n:a(n),f+=" "}break;case N.cmd:if(a=d=>(d=d.replace(/\"/g,'""'),d=d.replace(/([><!^&|])/g,"^$1"),' "'.split("").some(m=>d.includes(m))||d.length===0?`"${d}"`:d),u){const d=(0,h.$Kg)(u);d&&(f+=`${d}: && `),f+=`cd ${a(u)} && `}if(k){f+='cmd /C "';for(const d in k){let m=k[d];m===null?f+=`set "${d}=" && `:(m=m.replace(/[&^|<>]/g,n=>`^${n}`),f+=`set "${d}=${m}" && `)}}for(const d of I)f+=d==="<"||d===">"||E?d:a(d),f+=" ";k&&(f+='"');break;case N.bash:{a=m=>(m=m.replace(/(["'\\\$!><#()\[\]*&^| ;{}?`])/g,"\\$1"),m.length===0?'""':m);const d=m=>/[^\w@%\/+=,.:^-]/.test(m)?`'${m.replace(/'/g,"'\\''")}'`:m;if(u&&(f+=`cd ${a(u)} ; `),k){f+="/usr/bin/env";for(const m in k){const n=k[m];n===null?f+=` -u ${d(m)}`:f+=` ${d(`${m}=${n}`)}`}f+=" "}for(const m of I)f+=m==="<"||m===">"||E?m:a(m),f+=" ";break}}return f}}),define(Ee[311],ye([1,0,5]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$RK=e.CellExecutionUpdateType=void 0;var h;(function(P){P[P.Output=1]="Output",P[P.OutputItems=2]="OutputItems",P[P.ExecutionState=3]="ExecutionState"})(h||(e.CellExecutionUpdateType=h={})),e.$RK=(0,r.$Fi)("INotebookExecutionService")}),define(Ee[312],ye([1,0,5]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$VK=e.$UK=e.ProxyKernelState=e.$TK=void 0,e.$TK=100;var h;(function(P){P[P.Disconnected=1]="Disconnected",P[P.Connected=2]="Connected",P[P.Initializing=3]="Initializing"})(h||(e.ProxyKernelState=h={})),e.$UK=(0,r.$Fi)("INotebookKernelService"),e.$VK=(0,r.$Fi)("INotebookKernelHistoryService")}),define(Ee[313],ye([1,0,3,31,54,214,107]),function(ce,e,r,h,P,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cZb=void 0;class N extends r.$Wc{constructor(c,I,E){super(),this._source=c,this.b=I,this.c=E,this.a=void 0}f(c){const I=c.getLineCount();return new h.$Ht(1,1,I,this.g(c,I))}g(c,I){if(I<1||I>c.getLineCount())throw new Error("Illegal value for lineNumber");return c.getLineLength(I)+1}get inputTextBuffer(){if(!this.b){const c=new R.$iD;c.acceptChunk(this._source);const I=c.finish(!0),{textBuffer:E,disposable:u}=I.create(P.DefaultEndOfLine.LF);this.b=E,this.B(u)}return this.b}get outputTextBuffers(){return this.a||(this.a=this.c.map(c=>{const I=new R.$iD;I.acceptChunk(c);const E=I.finish(!0),{textBuffer:u,disposable:k}=E.create(P.DefaultEndOfLine.LF);return this.B(k),u})),this.a}findInInputs(c){const E=new T.$9C(c,!1,!1,null).parseSearchRequest();if(!E)return[];const u=this.f(this.inputTextBuffer);return this.inputTextBuffer.findMatchesLineByLine(u,E,!0,5e3)}findInOutputs(c){const E=new T.$9C(c,!1,!1,null).parseSearchRequest();return E?this.outputTextBuffers.map(u=>{const k=u.findMatchesLineByLine(this.f(u),E,!0,5e3);if(k.length!==0)return{textBuffer:u,matches:k}}).filter(u=>!!u):[]}}e.$cZb=N}),define(Ee[74],ye([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$QI=e.TestPosition=e.TestIdPathParts=void 0;var r;(function(R){R.Delimiter="\0"})(r||(e.TestIdPathParts=r={}));var h;(function(R){R[R.IsSame=0]="IsSame",R[R.Disconnected=1]="Disconnected",R[R.IsChild=2]="IsChild",R[R.IsParent=3]="IsParent"})(h||(e.TestPosition=h={}));class P{static fromExtHostTestItem(T,N,$=T.parent){if(T._isRoot)return new P([N]);const c=[T.id];for(let I=$;I&&I.id!==N;I=I.parent)c.push(I.id);return c.push(N),new P(c.reverse())}static isRoot(T){return!T.includes(r.Delimiter)}static root(T){const N=T.indexOf(r.Delimiter);return N===-1?T:T.slice(0,N)}static fromString(T){return new P(T.split(r.Delimiter))}static join(T,N){return new P([...T.path,N])}static joinToString(T,N){return T.toString()+r.Delimiter+N}static parentId(T){const N=T.lastIndexOf(r.Delimiter);return N===-1?void 0:T.slice(0,N)}static localId(T){const N=T.lastIndexOf(r.Delimiter);return N===-1?T:T.slice(N+r.Delimiter.length)}static isChild(T,N){return N.startsWith(T)&&N[T.length]===r.Delimiter}static compare(T,N){return T===N?h.IsSame:P.isChild(T,N)?h.IsChild:P.isChild(N,T)?h.IsParent:h.Disconnected}static getLengthOfCommonPrefix(T,N){if(T===0)return 0;let $=0;for(;$<T-1;){for(let c=1;c<T;c++){const I=N(c-1),E=N(c);if(I.path[$]!==E.path[$])return $}$++}return $}constructor(T,N=T.length){if(this.path=T,this.d=N,T.length===0||N<1)throw new Error("cannot create test with empty path")}get rootId(){return new P(this.path,1)}get parentId(){return this.d>1?new P(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let T=1;T<=this.d;T++)yield new P(this.path,T)}*idsToRoot(){for(let T=this.d;T>0;T--)yield new P(this.path,T)}compare(T){if(typeof T=="string")return P.compare(this.toString(),T);for(let N=0;N<T.d&&N<this.d;N++)if(T.path[N]!==this.path[N])return h.Disconnected;return T.d>this.d?h.IsChild:T.d<this.d?h.IsParent:h.IsSame}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let T=1;T<this.d;T++)this.c+=r.Delimiter,this.c+=this.path[T]}return this.c}}e.$QI=P}),define(Ee[75],ye([1,0,2,53,31,74]),function(ce,e,r,h,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ZI=e.TestsDiffOp=e.TestDiffOpType=e.IStatementCoverage=e.IDeclarationCoverage=e.IBranchCoverage=e.CoverageDetails=e.DetailType=e.$YI=e.IFileCoverage=e.ICoverageCount=e.TestResultItem=e.$XI=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.$WI=e.$VI=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.$UI=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.$TI=e.$SI=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.$RI=e.TestResultState=void 0;var T;(function(z){z[z.Unset=0]="Unset",z[z.Queued=1]="Queued",z[z.Running=2]="Running",z[z.Passed=3]="Passed",z[z.Failed=4]="Failed",z[z.Skipped=5]="Skipped",z[z.Errored=6]="Errored"})(T||(e.TestResultState=T={})),e.$RI={[T.Unset]:"unset",[T.Queued]:"queued",[T.Running]:"running",[T.Passed]:"passed",[T.Failed]:"failed",[T.Skipped]:"skipped",[T.Errored]:"errored"};var N;(function(z){z[z.Run=1]="Run",z[z.Debug=2]="Debug",z[z.Coverage=3]="Coverage"})(N||(e.ExtTestRunProfileKind=N={}));var $;(function(z){z[z.Run=2]="Run",z[z.Debug=4]="Debug",z[z.Coverage=8]="Coverage",z[z.HasNonDefaultProfile=16]="HasNonDefaultProfile",z[z.HasConfigurable=32]="HasConfigurable",z[z.SupportsContinuousRun=64]="SupportsContinuousRun"})($||(e.TestRunProfileBitset=$={})),e.$SI=[$.Run,$.Debug,$.Coverage,$.HasNonDefaultProfile,$.HasConfigurable,$.SupportsContinuousRun];const c=z=>"runId"in z;e.$TI=c;var I;(function(z){z.serialize=F=>({range:F.range.toJSON(),uri:F.uri.toJSON()}),z.deserialize=(F,B)=>({range:P.$Ht.lift(B.range),uri:F.asCanonicalUri(r.URI.revive(B.uri))})})(I||(e.IRichLocation=I={}));var E;(function(z){z[z.Error=0]="Error",z[z.Output=1]="Output"})(E||(e.TestMessageType=E={}));var u;(function(z){z.serialize=F=>({message:F.message,type:E.Error,expected:F.expected,actual:F.actual,contextValue:F.contextValue,location:F.location&&I.serialize(F.location)}),z.deserialize=(F,B)=>({message:B.message,type:E.Error,expected:B.expected,actual:B.actual,contextValue:B.contextValue,location:B.location&&I.deserialize(F,B.location)})})(u||(e.ITestErrorMessage=u={}));const k=(z,F)=>`${F?"s":"e"}${z}`;e.$UI=k;var p;(function(z){z.serialize=F=>({message:F.message,type:E.Output,offset:F.offset,length:F.length,location:F.location&&I.serialize(F.location)}),z.deserialize=(F,B)=>({message:B.message,type:E.Output,offset:B.offset,length:B.length,location:B.location&&I.deserialize(F,B.location)})})(p||(e.ITestOutputMessage=p={}));var a;(function(z){z.serialize=F=>F.type===E.Error?u.serialize(F):p.serialize(F),z.deserialize=(F,B)=>B.type===E.Error?u.deserialize(F,B):p.deserialize(F,B)})(a||(e.ITestMessage=a={}));var f;(function(z){z.serializeWithoutMessages=F=>({state:F.state,duration:F.duration,messages:[]}),z.serialize=F=>({state:F.state,duration:F.duration,messages:F.messages.map(a.serialize)}),z.deserialize=(F,B)=>({state:B.state,duration:B.duration,messages:B.messages.map(_=>a.deserialize(F,_))})})(f||(e.ITestTaskState=f={}));const d="\0",m=(z,F)=>z+d+F;e.$VI=m;const n=z=>{const F=z.indexOf(d);return{ctrlId:z.slice(0,F),tagId:z.slice(F+1)}};e.$WI=n;var o;(function(z){z.serialize=F=>({extId:F.extId,label:F.label,tags:F.tags,busy:F.busy,children:void 0,uri:F.uri?.toJSON(),range:F.range?.toJSON()||null,description:F.description,error:F.error,sortText:F.sortText}),z.deserialize=(F,B)=>({extId:B.extId,label:B.label,tags:B.tags,busy:B.busy,children:void 0,uri:B.uri?F.asCanonicalUri(r.URI.revive(B.uri)):void 0,range:B.range?P.$Ht.lift(B.range):null,description:B.description,error:B.error,sortText:B.sortText})})(o||(e.ITestItem=o={}));var t;(function(z){z[z.NotExpandable=0]="NotExpandable",z[z.Expandable=1]="Expandable",z[z.BusyExpanding=2]="BusyExpanding",z[z.Expanded=3]="Expanded"})(t||(e.TestItemExpandState=t={}));var i;(function(z){z.serialize=F=>({expand:F.expand,item:o.serialize(F.item)}),z.deserialize=(F,B)=>({controllerId:R.$QI.root(B.item.extId),expand:B.expand,item:o.deserialize(F,B.item)})})(i||(e.InternalTestItem=i={}));var s;(function(z){z.serialize=F=>{let B;return F.item&&(B={},F.item.label!==void 0&&(B.label=F.item.label),F.item.tags!==void 0&&(B.tags=F.item.tags),F.item.busy!==void 0&&(B.busy=F.item.busy),F.item.uri!==void 0&&(B.uri=F.item.uri?.toJSON()),F.item.range!==void 0&&(B.range=F.item.range?.toJSON()),F.item.description!==void 0&&(B.description=F.item.description),F.item.error!==void 0&&(B.error=F.item.error),F.item.sortText!==void 0&&(B.sortText=F.item.sortText)),{extId:F.extId,expand:F.expand,item:B}},z.deserialize=F=>{let B;return F.item&&(B={},F.item.label!==void 0&&(B.label=F.item.label),F.item.tags!==void 0&&(B.tags=F.item.tags),F.item.busy!==void 0&&(B.busy=F.item.busy),F.item.range!==void 0&&(B.range=F.item.range?P.$Ht.lift(F.item.range):null),F.item.description!==void 0&&(B.description=F.item.description),F.item.error!==void 0&&(B.error=F.item.error),F.item.sortText!==void 0&&(B.sortText=F.item.sortText)),{extId:F.extId,expand:F.expand,item:B}}})(s||(e.ITestItemUpdate=s={}));const g=(z,F)=>{F.expand!==void 0&&(z.expand=F.expand),F.item!==void 0&&(z.item=z.item?Object.assign(z.item,F.item):F.item)};e.$XI=g;var l;(function(z){z.serializeWithoutMessages=F=>({...i.serialize(F),ownComputedState:F.ownComputedState,computedState:F.computedState,tasks:F.tasks.map(f.serializeWithoutMessages)}),z.serialize=F=>({...i.serialize(F),ownComputedState:F.ownComputedState,computedState:F.computedState,tasks:F.tasks.map(f.serialize)}),z.deserialize=(F,B)=>({...i.deserialize(F,B),ownComputedState:B.ownComputedState,computedState:B.computedState,tasks:B.tasks.map(_=>f.deserialize(F,_)),retired:!0})})(l||(e.TestResultItem=l={}));var w;(function(z){z.empty=()=>({covered:0,total:0}),z.sum=(F,B)=>{F.covered+=B.covered,F.total+=B.total}})(w||(e.ICoverageCount=w={}));var S;(function(z){z.serialize=F=>({id:F.id,statement:F.statement,branch:F.branch,declaration:F.declaration,testIds:F.testIds,uri:F.uri.toJSON()}),z.deserialize=(F,B)=>({id:B.id,statement:B.statement,branch:B.branch,declaration:B.declaration,testIds:B.testIds,uri:F.asCanonicalUri(r.URI.revive(B.uri))}),z.empty=(F,B)=>({id:F,uri:B,statement:w.empty()})})(S||(e.IFileCoverage=S={}));function D(z){return{...z,location:z.location?.toJSON()}}function y(z){return z.location=z.location?h.$Gt.isIPosition(z.location)?h.$Gt.lift(z.location):P.$Ht.lift(z.location):void 0,z}e.$YI=3;var C;(function(z){z[z.Declaration=0]="Declaration",z[z.Statement=1]="Statement",z[z.Branch=2]="Branch"})(C||(e.DetailType=C={}));var A;(function(z){z.serialize=F=>F.type===C.Declaration?v.serialize(F):L.serialize(F),z.deserialize=F=>F.type===C.Declaration?v.deserialize(F):L.deserialize(F)})(A||(e.CoverageDetails=A={}));var b;(function(z){z.serialize=D,z.deserialize=y})(b||(e.IBranchCoverage=b={}));var v;(function(z){z.serialize=D,z.deserialize=y})(v||(e.IDeclarationCoverage=v={}));var L;(function(z){z.serialize=F=>({...D(F),branches:F.branches?.map(b.serialize)}),z.deserialize=F=>({...y(F),branches:F.branches?.map(b.deserialize)})})(L||(e.IStatementCoverage=L={}));var O;(function(z){z[z.Add=0]="Add",z[z.Update=1]="Update",z[z.DocumentSynced=2]="DocumentSynced",z[z.Remove=3]="Remove",z[z.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",z[z.Retire=5]="Retire",z[z.AddTag=6]="AddTag",z[z.RemoveTag=7]="RemoveTag"})(O||(e.TestDiffOpType=O={}));var M;(function(z){z.deserialize=(F,B)=>B.op===O.Add?{op:B.op,item:i.deserialize(F,B.item)}:B.op===O.Update?{op:B.op,item:s.deserialize(B.item)}:B.op===O.DocumentSynced?{op:B.op,uri:F.asCanonicalUri(r.URI.revive(B.uri)),docv:B.docv}:B,z.serialize=F=>F.op===O.Add?{op:F.op,item:i.serialize(F.item)}:F.op===O.Update?{op:F.op,item:s.serialize(F.item)}:F})(M||(e.TestsDiffOp=M={}));class j{constructor(F){this.k=F,this.c=new Map,this.f=new Map,this.g=new Set,this.h=0,this.j=0,this.tags=this.c}apply(F){const B=this.w();for(const _ of F)switch(_.op){case O.Add:this.l(i.deserialize(this.k,_.item),B);break;case O.Update:this.p(s.deserialize(_.item),B);break;case O.Remove:this.q(_.itemId,B);break;case O.Retire:this.v(_.itemId);break;case O.IncrementPendingExtHosts:this.updatePendingRoots(_.amount);break;case O.AddTag:this.c.set(_.tag.id,_.tag);break;case O.RemoveTag:this.c.delete(_.id);break}B.complete?.()}l(F,B){const _=R.$QI.parentId(F.item.extId)?.toString();let re;if(!_)re=this.x(F),this.g.add(re),this.f.set(F.item.extId,re);else if(this.f.has(_)){const U=this.f.get(_);U.children.add(F.item.extId),re=this.x(F,U),this.f.set(F.item.extId,re)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(F)}`);return}return B.add?.(re),F.expand===t.BusyExpanding&&this.h++,re}p(F,B){const _=this.f.get(F.extId);if(_)return F.expand!==void 0&&(_.expand===t.BusyExpanding&&this.h--,F.expand===t.BusyExpanding&&this.h++),(0,e.$XI)(_,F),B.update?.(_),_}q(F,B){const _=this.f.get(F);if(!_)return;const re=R.$QI.parentId(_.item.extId)?.toString();re?this.f.get(re).children.delete(_.item.extId):this.g.delete(_);const U=[[F]];for(;U.length;)for(const G of U.pop()){const Q=this.f.get(G);Q&&(U.push(Q.children),this.f.delete(G),B.remove?.(Q,Q!==_),Q.expand===t.BusyExpanding&&this.h--)}}v(F){}updatePendingRoots(F){this.j+=F}w(){return{}}}e.$ZI=j}),define(Ee[314],ye([1,0,136,256,75]),function(ce,e,r,h,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestCommandId=e.$8Fb=e.$7Fb=e.TestExplorerViewSorting=e.TestExplorerViewMode=e.Testing=void 0;var R;(function(E){E.ViewletId="workbench.view.extension.test",E.ExplorerViewId="workbench.view.testing",E.OutputPeekContributionId="editor.contrib.testingOutputPeek",E.DecorationsContributionId="editor.contrib.testingDecorations",E.CoverageDecorationsContributionId="editor.contrib.coverageDecorations",E.CoverageViewId="workbench.view.testCoverage",E.ResultsPanelId="workbench.panel.testResults",E.ResultsViewId="workbench.panel.testResults.view",E.MessageLanguageId="vscodeInternalTestMessage"})(R||(e.Testing=R={}));var T;(function(E){E.List="list",E.Tree="true"})(T||(e.TestExplorerViewMode=T={}));var N;(function(E){E.ByLocation="location",E.ByStatus="status",E.ByDuration="duration"})(N||(e.TestExplorerViewSorting=N={}));const $={[P.TestResultState.Errored]:(0,h.localize)(0,null),[P.TestResultState.Failed]:(0,h.localize)(1,null),[P.TestResultState.Passed]:(0,h.localize)(2,null),[P.TestResultState.Queued]:(0,h.localize)(3,null),[P.TestResultState.Running]:(0,h.localize)(4,null),[P.TestResultState.Skipped]:(0,h.localize)(5,null),[P.TestResultState.Unset]:(0,h.localize)(6,null)},c=(E,u)=>(0,h.localize)(7,null,(0,r.$Yk)(E),$[u]);e.$7Fb=c,e.$8Fb={[P.TestRunProfileBitset.Debug]:(0,h.localize)(8,null),[P.TestRunProfileBitset.Run]:(0,h.localize)(9,null),[P.TestRunProfileBitset.Coverage]:(0,h.localize)(10,null)};var I;(function(E){E.CancelTestRefreshAction="testing.cancelTestRefresh",E.CancelTestRunAction="testing.cancelRun",E.ClearTestResultsAction="testing.clearTestResults",E.CollapseAllAction="testing.collapseAll",E.ConfigureTestProfilesAction="testing.configureProfile",E.ContinousRunUsingForTest="testing.continuousRunUsingForTest",E.CoverageAtCursor="testing.coverageAtCursor",E.CoverageByUri="testing.coverage.uri",E.CoverageClear="testing.coverage.close",E.CoverageCurrentFile="testing.coverageCurrentFile",E.CoverageFilterToTest="testing.coverageFilterToTest",E.CoverageFilterToTestInEditor="testing.coverageFilterToTestInEditor",E.CoverageLastRun="testing.coverageLastRun",E.CoverageSelectedAction="testing.coverageSelected",E.CoverageToggleToolbar="testing.coverageToggleToolbar",E.CoverageViewChangeSorting="testing.coverageViewChangeSorting",E.DebugAction="testing.debug",E.DebugAllAction="testing.debugAll",E.DebugAtCursor="testing.debugAtCursor",E.DebugByUri="testing.debug.uri",E.DebugCurrentFile="testing.debugCurrentFile",E.DebugFailedTests="testing.debugFailTests",E.DebugLastRun="testing.debugLastRun",E.DebugSelectedAction="testing.debugSelected",E.FilterAction="workbench.actions.treeView.testExplorer.filter",E.GetExplorerSelection="_testing.getExplorerSelection",E.GetSelectedProfiles="testing.getSelectedProfiles",E.GoToTest="testing.editFocusedTest",E.HideTestAction="testing.hideTest",E.OpenCoverage="testing.openCoverage",E.OpenOutputPeek="testing.openOutputPeek",E.RefreshTestsAction="testing.refreshTests",E.ReRunFailedTests="testing.reRunFailTests",E.ReRunLastRun="testing.reRunLastRun",E.RunAction="testing.run",E.RunAllAction="testing.runAll",E.RunAllWithCoverageAction="testing.coverageAll",E.RunAtCursor="testing.runAtCursor",E.RunByUri="testing.run.uri",E.RunCurrentFile="testing.runCurrentFile",E.RunSelectedAction="testing.runSelected",E.RunUsingProfileAction="testing.runUsing",E.RunWithCoverageAction="testing.coverage",E.SearchForTestExtension="testing.searchForTestExtension",E.SelectDefaultTestProfiles="testing.selectDefaultTestProfiles",E.ShowMostRecentOutputAction="testing.showMostRecentOutput",E.StartContinousRun="testing.startContinuousRun",E.StopContinousRun="testing.stopContinuousRun",E.TestingSortByDurationAction="testing.sortByDuration",E.TestingSortByLocationAction="testing.sortByLocation",E.TestingSortByStatusAction="testing.sortByStatus",E.TestingViewAsListAction="testing.viewAsList",E.TestingViewAsTreeAction="testing.viewAsTree",E.ToggleContinousRunForTest="testing.toggleContinuousRunForTest",E.ToggleInlineTestOutput="testing.toggleInlineTestOutput",E.UnhideAllTestsAction="testing.unhideAllTests",E.UnhideTestAction="testing.unhideTest"})(I||(e.TestCommandId=I={}))}),define(Ee[121],ye([1,0,9,4,3,66,75,74]),function(ce,e,r,h,P,R,T,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$RP=e.$QP=e.$PP=e.$OP=e.$NP=e.TestItemEventOp=void 0;var $;(function(m){m[m.Upsert=0]="Upsert",m[m.SetTags=1]="SetTags",m[m.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",m[m.RemoveChild=3]="RemoveChild",m[m.SetProp=4]="SetProp",m[m.Bulk=5]="Bulk",m[m.DocumentSynced=6]="DocumentSynced"})($||(e.TestItemEventOp=$={}));const c=(m,n)=>m===n,E=Object.entries({range:(m,n)=>m===n?!0:!m||!n?!1:m.equalsRange(n),busy:c,label:c,description:c,error:c,sortText:c,tags:(m,n)=>!(m.length!==n.length||m.some(o=>!n.includes(o)))}),u=(m,n)=>{let o;for(const[t,i]of E)i(m[t],n[t])||(o?o[t]=n[t]:o={[t]:n[t]});return o};class k extends P.$Wc{get root(){return this.s.root}constructor(n){super(),this.s=n,this.f=this.B(new r.$Rh(()=>this.flushDiff(),200)),this.g=this.B(new h.$me),this.tree=new Map,this.j=new Map,this.m=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.z(this.root,void 0)}set resolveHandler(n){this.h=n;for(const o of this.tree.values())this.J(o)}get resolveHandler(){return this.h}collectDiff(){const n=this.m;return this.m=[],n}pushDiff(n){switch(n.op){case T.TestDiffOpType.DocumentSynced:{for(const o of this.m)if(o.op===T.TestDiffOpType.DocumentSynced&&o.uri===n.uri){o.docv=n.docv;return}break}case T.TestDiffOpType.Update:{const o=this.m[this.m.length-1];if(o){if(o.op===T.TestDiffOpType.Update&&o.item.extId===n.item.extId){(0,T.$XI)(o.item,n.item);return}if(o.op===T.TestDiffOpType.Add&&o.item.item.extId===n.item.extId){(0,T.$XI)(o.item,n.item);return}}break}}this.m.push(n),this.f.isScheduled()||this.f.schedule()}expand(n,o){const t=this.tree.get(n);if(t){if((t.expandLevels===void 0||o>t.expandLevels)&&(t.expandLevels=o),t.expand===T.TestItemExpandState.Expandable){const i=this.M(t);return i.isOpen()?this.L(t,o-1):i.wait().then(()=>this.L(t,o-1))}else if(t.expand===T.TestItemExpandState.Expanded)return t.resolveBarrier?.isOpen()===!1?t.resolveBarrier.wait().then(()=>this.L(t,o-1)):this.L(t,o-1)}}dispose(){for(const n of this.tree.values())this.s.getApiFor(n.actual).listener=void 0;this.tree.clear(),this.m=[],super.dispose()}w(n,o){switch(o.op){case $.RemoveChild:this.O(N.$QI.joinToString(n.fullId,o.id));break;case $.Upsert:this.z(o.item,n);break;case $.Bulk:for(const t of o.ops)this.w(n,t);break;case $.SetTags:this.C(o.new,o.old,n.fullId.toString());break;case $.UpdateCanResolveChildren:this.J(n);break;case $.SetProp:this.pushDiff({op:T.TestDiffOpType.Update,item:{extId:n.fullId.toString(),item:o.update}});break;case $.DocumentSynced:this.y(n.actual.uri);break;default:(0,R.$gd)(o)}}y(n){n&&this.pushDiff({op:T.TestDiffOpType.DocumentSynced,uri:n,docv:this.s.getDocumentVersion(n)})}z(n,o){const t=N.$QI.fromExtHostTestItem(n,this.root.id,o?.actual),i=this.s.getApiFor(n);i.parent&&i.parent!==o?.actual&&this.s.getChildren(i.parent).delete(n.id);let s=this.tree.get(t.toString());if(!s){s={fullId:t,actual:n,expandLevels:o?.expandLevels?o.expandLevels-1:void 0,expand:T.TestItemExpandState.NotExpandable},n.tags.forEach(this.D,this),this.tree.set(s.fullId.toString(),s),this.G(n,o),this.pushDiff({op:T.TestDiffOpType.Add,item:{controllerId:this.s.controllerId,expand:s.expand,item:this.s.toITestItem(n)}}),this.I(n,s,o);return}if(s.actual===n){this.H(n,s,o);return}if(s.actual.uri?.toString()!==n.uri?.toString())return this.O(t.toString()),this.z(n,o);const g=this.s.getChildren(s.actual),l=s.actual,w=u(this.s.toITestItem(l),this.s.toITestItem(n));this.s.getApiFor(l).listener=void 0,s.actual=n,s.resolveBarrier=void 0,s.expand=T.TestItemExpandState.NotExpandable,w&&(w.hasOwnProperty("tags")&&(this.C(n.tags,l.tags,t.toString()),delete w.tags),this.w(s,{op:$.SetProp,update:w})),this.I(n,s,o);for(const[D,y]of g)this.s.getChildren(n).get(y.id)||this.O(N.$QI.joinToString(t,y.id));const S=s.expandLevels;S!==void 0&&queueMicrotask(()=>{s.expand===T.TestItemExpandState.Expandable&&(s.expandLevels=void 0,this.expand(t.toString(),S))}),this.y(s.actual.uri)}C(n,o,t){const i=new Set(o.map(s=>s.id));for(const s of n)i.delete(s.id)||this.D(s);this.pushDiff({op:T.TestDiffOpType.Update,item:{extId:t,item:{tags:n.map(s=>(0,T.$VI)(this.s.controllerId,s.id))}}}),i.forEach(this.F,this)}D(n){const o=this.j.get(n.id);o?o.refCount++:(this.j.set(n.id,{refCount:1}),this.pushDiff({op:T.TestDiffOpType.AddTag,tag:{id:(0,T.$VI)(this.s.controllerId,n.id)}}))}F(n){const o=this.j.get(n);o&&!--o.refCount&&(this.j.delete(n),this.pushDiff({op:T.TestDiffOpType.RemoveTag,id:(0,T.$VI)(this.s.controllerId,n)}))}G(n,o){this.s.getApiFor(n).parent=o&&o.actual!==this.root?o.actual:void 0}H(n,o,t){this.G(n,t);const i=this.s.getApiFor(n);i.parent=t?.actual,i.listener=s=>this.w(o,s),this.J(o)}I(n,o,t){this.H(n,o,t);for(const[i,s]of this.s.getChildren(n))this.z(s,o)}J(n){let o;this.h?n.resolveBarrier?o=n.resolveBarrier.isOpen()?T.TestItemExpandState.Expanded:T.TestItemExpandState.BusyExpanding:o=n.actual.canResolveChildren?T.TestItemExpandState.Expandable:T.TestItemExpandState.NotExpandable:o=T.TestItemExpandState.NotExpandable,o!==n.expand&&(n.expand=o,this.pushDiff({op:T.TestDiffOpType.Update,item:{extId:n.fullId.toString(),expand:o}}),o===T.TestItemExpandState.Expandable&&n.expandLevels!==void 0&&this.M(n))}L(n,o){if(o<0)return;const t=[];for(const[i,s]of this.s.getChildren(n.actual)){const g=this.expand(N.$QI.joinToString(n.fullId,s.id),o);(0,r.$rh)(g)&&t.push(g)}if(t.length)return Promise.all(t).then(()=>{})}M(n){if(n.resolveBarrier)return n.resolveBarrier;if(!this.h){const s=new r.$Eh;return s.open(),s}n.expand=T.TestItemExpandState.BusyExpanding,this.N(n);const o=n.resolveBarrier=new r.$Eh,t=s=>{console.error(`Unhandled error in resolveHandler of test controller "${this.s.controllerId}"`,s)};let i;try{i=this.h(n.actual===this.root?void 0:n.actual)}catch(s){t(s)}return(0,r.$rh)(i)?i.catch(t).then(()=>{o.open(),this.J(n)}):(o.open(),this.J(n)),n.resolveBarrier}N(n){this.pushDiff({op:T.TestDiffOpType.Update,item:{extId:n.fullId.toString(),expand:n.expand}})}O(n){const o=this.tree.get(n);if(!o)throw new Error("attempting to remove non-existent child");this.pushDiff({op:T.TestDiffOpType.Remove,itemId:n});const t=[o];for(;t.length;){const i=t.pop();if(i){this.s.getApiFor(i.actual).listener=void 0;for(const s of i.actual.tags)this.F(s.id);this.tree.delete(i.fullId.toString());for(const[s,g]of this.s.getChildren(i.actual))t.push(this.tree.get(N.$QI.joinToString(i.fullId,g.id)))}}}flushDiff(){const n=this.collectDiff();n.length&&this.g.fire(n)}}e.$NP=k;class p extends Error{constructor(n){super(`Attempted to insert a duplicate test item ID ${n}`)}}e.$OP=p;class a extends Error{constructor(n){super(`TestItem with ID "${n}" is invalid. Make sure to create it from the createTestItem method.`)}}e.$PP=a;class f extends Error{constructor(n,o,t){super(`TestItem with ID "${n}" is from controller "${o}" and cannot be added as a child of an item from controller "${t}".`)}}e.$QP=f;const d=(m,n,o)=>{let t=new Map;return{get size(){return t.size},forEach(i,s){for(const g of t.values())i.call(s,g,this)},[Symbol.iterator](){return t.entries()},replace(i){const s=new Map,g=new Set(t.keys()),l={op:$.Bulk,ops:[]};for(const w of i){if(!(w instanceof o))throw new a(w.id);const S=n(w).controllerId;if(S!==m.controllerId)throw new f(w.id,S,m.controllerId);if(s.has(w.id))throw new p(w.id);s.set(w.id,w),g.delete(w.id),l.ops.push({op:$.Upsert,item:w})}for(const w of g.keys())l.ops.push({op:$.RemoveChild,id:w});m.listener?.(l),t=s},add(i){if(!(i instanceof o))throw new a(i.id);t.set(i.id,i),m.listener?.({op:$.Upsert,item:i})},delete(i){t.delete(i)&&m.listener?.({op:$.RemoveChild,id:i})},get(i){return t.get(i)},toJSON(){return Array.from(t.values())}}};e.$RP=d}),define(Ee[154],ye([1,0,121]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TP=e.$SP=void 0;const h=new WeakMap,P=(T,N)=>{const $={controllerId:N};return h.set(T,$),$};e.$SP=P;const R=T=>{const N=h.get(T);if(!N)throw new r.$PP(T?.id||"<unknown>");return N};e.$TP=R}),define(Ee[122],ye([1,0,27,15,2]),function(ce,e,r,h,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$WCb=e.$VCb=e.$UCb=void 0,e.$XCb=R,e.$YCb=N,e.$UCb="vscode-cdn.net",e.$VCb=`vscode-resource.${e.$UCb}`,e.$WCb=`'self' https://*.${e.$UCb}`;function R($,c){return $.scheme===h.Schemas.http||$.scheme===h.Schemas.https?$:(c&&c.authority&&c.isRemote&&$.scheme===h.Schemas.file&&($=P.URI.from({scheme:h.Schemas.vscodeRemote,authority:c.authority,path:$.path})),P.URI.from({scheme:h.Schemas.https,authority:`${$.scheme}+${T($.authority)}.${e.$VCb}`,path:$.path,fragment:$.fragment,query:$.query}))}function T($){return $.replace(/./g,c=>{const I=c.charCodeAt(0);return I>=r.CharCode.a&&I<=r.CharCode.z||I>=r.CharCode.A&&I<=r.CharCode.Z||I>=r.CharCode.Digit0&&I<=r.CharCode.Digit9?c:"-"+I.toString(16).padStart(4,"0")})}function N($){return $.replace(/-([0-9a-f]{4})/g,(c,I)=>String.fromCharCode(parseInt(I,16)))}}),define(Ee[315],ye([1,0,4,3,122]),function(ce,e,r,h,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$nc=void 0;class R{constructor(N,$,c){this.d=N,this.e=$,this.f=c,this.a=0,this.b=new h.$Vc,this.c=new Map,this.b.add($.onDidChangeVisibleTextEditors(()=>{const I=$.getVisibleTextEditors();for(const E of this.c.values())I.indexOf(E.editor)<0&&E.inset.dispose()}))}dispose(){this.c.forEach(N=>N.inset.dispose()),this.b.dispose()}createWebviewEditorInset(N,$,c,I,E){let u;for(const n of this.e.getVisibleTextEditors(!0))if(n.value===N){u=n;break}if(!u)throw new Error("not a visible editor");const k=this,p=this.a++,a=new r.$me,f=new r.$me,d=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(n){return(0,P.$XCb)(n,k.f)}get cspSource(){return P.$WCb}set options(n){this.b=n,k.d.$setOptions(p,n)}get options(){return this.b}set html(n){this.a=n,k.d.$setHtml(p,n)}get html(){return this.a}get onDidReceiveMessage(){return a.event}postMessage(n){return k.d.$postMessage(p,n)}},m=new class{constructor(){this.editor=N,this.line=$,this.height=c,this.webview=d,this.onDidDispose=f.event}dispose(){k.c.has(p)&&(k.c.delete(p),k.d.$disposeEditorInset(p),f.fire(),f.dispose(),a.dispose())}};return this.d.$createEditorInset(p,u.id,u.value.document.uri,$+1,c,I||{},E.identifier,E.extensionLocation),this.c.set(p,{editor:N,inset:m,onDidReceiveMessage:a}),m}$onDidDispose(N){const $=this.c.get(N);$&&$.inset.dispose()}$onDidReceiveMessage(N,$){this.c.get(N)?.onDidReceiveMessage.fire($)}}e.$$nc=R}),define(Ee[155],ye([1,0,5]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vM=e.$uM=e.$tM=void 0,e.$tM="__",e.$uM=(0,r.$Fi)("IAuthenticationService"),e.$vM=(0,r.$Fi)("IAuthenticationExtensionsService")}),define(Ee[316],ye([1,0,5]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$MQ=e.VariableKind=e.$LQ=void 0,e.$LQ=(0,r.$Fi)("configurationResolverService");var h;(function(R){R.Unknown="unknown",R.Env="env",R.Config="config",R.Command="command",R.Input="input",R.ExtensionInstallFolder="extensionInstallFolder",R.WorkspaceFolder="workspaceFolder",R.Cwd="cwd",R.WorkspaceFolderBasename="workspaceFolderBasename",R.UserHome="userHome",R.LineNumber="lineNumber",R.SelectedText="selectedText",R.File="file",R.FileWorkspaceFolder="fileWorkspaceFolder",R.FileWorkspaceFolderBasename="fileWorkspaceFolderBasename",R.RelativeFile="relativeFile",R.RelativeFileDirname="relativeFileDirname",R.FileDirname="fileDirname",R.FileExtname="fileExtname",R.FileBasename="fileBasename",R.FileBasenameNoExtension="fileBasenameNoExtension",R.FileDirnameBasename="fileDirnameBasename",R.ExecPath="execPath",R.ExecInstallFolder="execInstallFolder",R.PathSeparator="pathSeparator",R.PathSeparatorAlias="/"})(h||(e.VariableKind=h={}));class P extends Error{constructor(T,N){super(N),this.variable=T}}e.$MQ=P}),define(Ee[317],ye([1,0,16,56,18,25,11,110,257,316,13]),function(ce,e,r,h,P,R,T,N,$,c,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2Q=void 0,r=We(r),h=We(h),P=We(P),R=We(R);class E{static{this.VARIABLE_LHS="${"}static{this.VARIABLE_REGEXP=/\$\{(.*?)\}/g}constructor(k,p,a,f){this.h=new Map,this.a=k,this.b=p,this.g=a,f&&(this.c=f.then(d=>this.i(d)))}i(k){if(T.$i){const p=Object.create(null);return Object.keys(k).forEach(a=>{p[a.toLowerCase()]=k[a]}),p}return k}resolveWithEnvironment(k,p,a){return this.l({env:this.i(k),userHome:void 0},p?p.uri:void 0,a)}async resolveAsync(k,p){const a={env:await this.c,userHome:await this.g};return this.l(a,k?k.uri:void 0,p)}async j(k,p,a,f){const d=R.$bo(p);T.$i&&d.windows?Object.keys(d.windows).forEach(n=>d[n]=d.windows[n]):T.$j&&d.osx?Object.keys(d.osx).forEach(n=>d[n]=d.osx[n]):T.$k&&d.linux&&Object.keys(d.linux).forEach(n=>d[n]=d.linux[n]),delete d.windows,delete d.osx,delete d.linux;const m={env:await this.c,userHome:await this.g};return this.l(m,k?k.uri:void 0,d,a,f)}async resolveAnyAsync(k,p,a){return this.j(k,p,a)}async resolveAnyMap(k,p,a){const f=new Map;return{newConfig:await this.j(k,p,a,f),resolvedVariables:f}}resolveWithInteractionReplace(k,p,a,f){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(k,p,a,f){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(k,p){if(this.h.has(k))throw new Error("Variable "+k+" is contributed twice.");this.h.set(k,p)}async l(k,p,a,f,d){if(P.$fg(a))return this.m(k,p,a,f,d);if(Array.isArray(a))return Promise.all(a.map(m=>this.l(k,p,m,f,d)));if(P.$hg(a)){const m=Object.create(null),n=await Promise.all(Object.keys(a).map(async o=>[await this.m(k,p,o,f,d),await this.l(k,p,a[o],f,d)]));for(const[o,t]of n)m[o]=t;return m}return a}m(k,p,a,f,d){return(0,I.$yf)(a,E.VARIABLE_REGEXP,async(m,n)=>{if(n.includes(E.VARIABLE_LHS))return m;let o=await this.o(k,m,n,p,f);return d?.set(n,o),o!==m&&P.$fg(o)&&o.match(E.VARIABLE_REGEXP)&&(o=await this.m(k,p,o,f,d)),o})}n(k){return this.b?this.b.getUriLabel(k,{noPrefix:!0}):k.fsPath}async o(k,p,a,f,d){let m;const n=a.split(":");n.length>1&&(a=n[0],m=n[1]);const o=s=>{const g=this.a.getFilePath();if(g)return(0,N.$Sw)(g);throw new c.$MQ(s,(0,$.localize)(0,null,p))},t=s=>{const g=o(s);if(this.a.getWorkspaceFolderPathForFile){const l=this.a.getWorkspaceFolderPathForFile();if(l)return(0,N.$Sw)(l)}throw new c.$MQ(s,(0,$.localize)(1,null,p,r.$pc(g)))},i=s=>{if(m){const g=this.a.getFolderUri(m);if(g)return g;throw new c.$MQ(s,(0,$.localize)(2,null,p,m))}if(f)return f;throw this.a.getWorkspaceFolderCount()>1?new c.$MQ(s,(0,$.localize)(3,null,p)):new c.$MQ(s,(0,$.localize)(4,null,p))};switch(a){case"env":if(m){if(k.env){const s=k.env[T.$i?m.toLowerCase():m];if(P.$fg(s))return s}return""}throw new c.$MQ(c.VariableKind.Env,(0,$.localize)(5,null,p));case"config":if(m){const s=this.a.getConfigurationValue(f,m);if(P.$og(s))throw new c.$MQ(c.VariableKind.Config,(0,$.localize)(6,null,p,m));if(P.$hg(s))throw new c.$MQ(c.VariableKind.Config,(0,$.localize)(7,null,p,m));return s}throw new c.$MQ(c.VariableKind.Config,(0,$.localize)(8,null,p));case"command":return this.p(c.VariableKind.Command,p,m,d,"command");case"input":return this.p(c.VariableKind.Input,p,m,d,"input");case"extensionInstallFolder":if(m){const s=await this.a.getExtension(m);if(!s)throw new c.$MQ(c.VariableKind.ExtensionInstallFolder,(0,$.localize)(9,null,p,m));return this.n(s.extensionLocation)}throw new c.$MQ(c.VariableKind.ExtensionInstallFolder,(0,$.localize)(10,null,p));default:switch(a){case"workspaceRoot":case"workspaceFolder":return(0,N.$Sw)(this.n(i(c.VariableKind.WorkspaceFolder)));case"cwd":return f||m?(0,N.$Sw)(this.n(i(c.VariableKind.Cwd))):h.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,N.$Sw)(r.$pc(this.n(i(c.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(k.userHome)return k.userHome;throw new c.$MQ(c.VariableKind.UserHome,(0,$.localize)(11,null,p))}case"lineNumber":{const s=this.a.getLineNumber();if(s)return s;throw new c.$MQ(c.VariableKind.LineNumber,(0,$.localize)(12,null,p))}case"selectedText":{const s=this.a.getSelectedText();if(s)return s;throw new c.$MQ(c.VariableKind.SelectedText,(0,$.localize)(13,null,p))}case"file":return o(c.VariableKind.File);case"fileWorkspaceFolder":return t(c.VariableKind.FileWorkspaceFolder);case"fileWorkspaceFolderBasename":return r.$pc(t(c.VariableKind.FileWorkspaceFolderBasename));case"relativeFile":return f||m?r.$nc(this.n(i(c.VariableKind.RelativeFile)),o(c.VariableKind.RelativeFile)):o(c.VariableKind.RelativeFile);case"relativeFileDirname":{const s=r.$oc(o(c.VariableKind.RelativeFileDirname));if(f||m){const g=r.$nc(this.n(i(c.VariableKind.RelativeFileDirname)),s);return g.length===0?".":g}return s}case"fileDirname":return r.$oc(o(c.VariableKind.FileDirname));case"fileExtname":return r.$qc(o(c.VariableKind.FileExtname));case"fileBasename":return r.$pc(o(c.VariableKind.FileBasename));case"fileBasenameNoExtension":{const s=r.$pc(o(c.VariableKind.FileBasenameNoExtension));return s.slice(0,s.length-r.$qc(s).length)}case"fileDirnameBasename":return r.$pc(r.$oc(o(c.VariableKind.FileDirnameBasename)));case"execPath":{const s=this.a.getExecPath();return s||p}case"execInstallFolder":{const s=this.a.getAppRoot();return s||p}case"pathSeparator":case"/":return r.sep;default:try{const s=m?`${a}:${m}`:a;return this.p(c.VariableKind.Unknown,p,s,d,void 0)}catch{return p}}}}p(k,p,a,f,d){if(a&&f){const m=d===void 0?f[a]:f[d+":"+a];if(typeof m=="string")return m;throw new c.$MQ(k,(0,$.localize)(14,null,p))}return p}}e.$2Q=E}),define(Ee[156],ye([1,0,5,152]),function(ce,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OpenEditorContext=e.GroupsOrder=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.$fE=void 0,e.$gE=c,e.$hE=u,e.$iE=k,e.$fE=(0,r.$Fi)("editorGroupsService");var P;(function(p){p[p.UP=0]="UP",p[p.DOWN=1]="DOWN",p[p.LEFT=2]="LEFT",p[p.RIGHT=3]="RIGHT"})(P||(e.GroupDirection=P={}));var R;(function(p){p[p.HORIZONTAL=0]="HORIZONTAL",p[p.VERTICAL=1]="VERTICAL"})(R||(e.GroupOrientation=R={}));var T;(function(p){p[p.FIRST=0]="FIRST",p[p.LAST=1]="LAST",p[p.NEXT=2]="NEXT",p[p.PREVIOUS=3]="PREVIOUS"})(T||(e.GroupLocation=T={}));var N;(function(p){p[p.MAXIMIZE=0]="MAXIMIZE",p[p.EXPAND=1]="EXPAND",p[p.EVEN=2]="EVEN"})(N||(e.GroupsArrangement=N={}));var $;(function(p){p[p.COPY_EDITORS=0]="COPY_EDITORS",p[p.MOVE_EDITORS=1]="MOVE_EDITORS"})($||(e.MergeGroupMode=$={}));function c(p){const a=p;return(0,h.$4F)(a?.editor)&&(0,h.$4F)(a?.replacement)}var I;(function(p){p[p.CREATION_TIME=0]="CREATION_TIME",p[p.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",p[p.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(I||(e.GroupsOrder=I={}));var E;(function(p){p[p.NEW_EDITOR=1]="NEW_EDITOR",p[p.MOVE_EDITOR=2]="MOVE_EDITOR",p[p.COPY_EDITOR=3]="COPY_EDITOR"})(E||(e.OpenEditorContext=E={}));function u(p){const a=p;return!!a&&typeof a.id=="number"&&Array.isArray(a.editors)}function k(p){return p.getValue("workbench.editor.openSideBySideDirection")==="down"?P.DOWN:P.RIGHT}}),define(Ee[318],ye([1,0,5,156]),function(ce,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mE=e.$lE=e.$kE=e.$jE=void 0,e.$nE=P,e.$jE=(0,r.$Fi)("editorService"),e.$kE=-1,e.$lE=-2,e.$mE=-3;function P(R){const T=R;return typeof R=="number"||(0,h.$hE)(T)}}),define(Ee[157],ye([1,0,5,144]),function(ce,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$OM=void 0,e.$OM=(0,r.$Gi)(h.$Mi)}),define(Ee[158],ye([1,0,24,4,16,3,9]),function(ce,e,r,h,P,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$occ=e.$ncc=e.$mcc=e.$lcc=e.$kcc=void 0,P=We(P);class N{constructor(m,n){this.versionId=m,this.removedDueToLooping=n}}e.$kcc=N;class ${static isHostExtension(m,n,o){if(n.getExtensionDescription(m))return!1;const t=o.getExtensionDescription(m);return t?!!((t.main||t.browser)&&t.api==="none"):!1}constructor(m,n){this.j=m,this.c=new h.$me,this.onDidChange=this.c.event,this.d=0,this.e=n,this.k()}k(){this.e.sort(a),this.f=new r.$sn,this.g=[],this.h=new Map;for(const m of this.e){if(this.f.has(m.identifier)){console.error("Extension `"+m.identifier.value+"` is already registered");continue}this.f.set(m.identifier,m),this.g.push(m);const n=this.j.readActivationEvents(m);for(const o of n)this.h.has(o)||this.h.set(o,[]),this.h.get(o).push(m)}}set(m){return this.e=m,this.k(),this.d++,this.c.fire(void 0),{versionId:this.d}}deltaExtensions(m,n){this.e=f(this.e,n),this.e=this.e.concat(m);const o=$.l(this.e);return this.e=f(this.e,o.map(t=>t.identifier)),this.k(),this.d++,this.c.fire(void 0),new N(this.d,o)}static l(m){const n=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(g){this.d.has(g)||(this.d.add(g),this.e.push(g))}addArc(g,l){this.addNode(g),this.addNode(l),this.c.has(g)?this.c.get(g).push(l):this.c.set(g,[l])}getArcs(g){return this.c.has(g)?this.c.get(g):[]}hasOnlyGoodArcs(g,l){const w=n.getArcs(g);for(let S=0;S<w.length;S++)if(!l.has(w[S]))return!1;return!0}getNodes(){return this.e}},o=new r.$sn;for(const g of m)if(o.set(g.identifier,g),g.extensionDependencies)for(const l of g.extensionDependencies)n.addArc(r.$qn.toKey(g.identifier),r.$qn.toKey(l));const t=new Set;n.getNodes().filter(g=>n.getArcs(g).length===0).forEach(g=>t.add(g));const i=n.getNodes().filter(g=>!t.has(g));let s;do{s=!1;for(let g=0;g<i.length;g++){const l=i[g];n.hasOnlyGoodArcs(l,t)&&(i.splice(g,1),g--,t.add(l),s=!0)}}while(s);return i.map(g=>o.get(g))}containsActivationEvent(m){return this.h.has(m)}containsExtension(m){return this.f.has(m)}getExtensionDescriptionsForActivationEvent(m){const n=this.h.get(m);return n?n.slice(0):[]}getAllExtensionDescriptions(){return this.g.slice(0)}getSnapshot(){return new c(this.d,this.getAllExtensionDescriptions())}getExtensionDescription(m){const n=this.f.get(m);return n||void 0}getExtensionDescriptionByUUID(m){for(const n of this.g)if(n.uuid===m)return n}getExtensionDescriptionByIdOrUUID(m,n){return this.getExtensionDescription(m)??(n?this.getExtensionDescriptionByUUID(n):void 0)}}e.$lcc=$;class c{constructor(m,n){this.versionId=m,this.extensions=n}}e.$mcc=c;class I{constructor(m){this.d=new k,this.c=new $(m,[])}async acquireLock(m){const n=await this.d.acquire(m);return new E(this,n)}deltaExtensions(m,n,o){if(!m.isAcquiredFor(this))throw new Error("Lock is not held");return this.c.deltaExtensions(n,o)}containsActivationEvent(m){return this.c.containsActivationEvent(m)}containsExtension(m){return this.c.containsExtension(m)}getExtensionDescriptionsForActivationEvent(m){return this.c.getExtensionDescriptionsForActivationEvent(m)}getAllExtensionDescriptions(){return this.c.getAllExtensionDescriptions()}getSnapshot(){return this.c.getSnapshot()}getExtensionDescription(m){return this.c.getExtensionDescription(m)}getExtensionDescriptionByUUID(m){return this.c.getExtensionDescriptionByUUID(m)}getExtensionDescriptionByIdOrUUID(m,n){return this.c.getExtensionDescriptionByIdOrUUID(m,n)}}e.$ncc=I;class E extends R.$Wc{constructor(m,n){super(),this.f=m,this.c=!1,this.B(n)}isAcquiredFor(m){return!this.c&&this.f===m}}e.$occ=E;class u{constructor(m){this.name=m;const n=(0,T.$yh)();this.promise=n.promise,this.c=n.resolve}resolve(m){this.c(m)}}class k{constructor(){this.c=[],this.d=!1}async acquire(m){const n=new u(m);return this.c.push(n),this.e(),n.promise}e(){if(this.d||this.c.length===0)return;const m=this.c.shift();this.d=!0;let n=!0;const o=setTimeout(()=>{n&&console.warn(`The customer named ${m.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),t=()=>{n&&(clearTimeout(o),n=!1,this.d=!1,this.e())};m.resolve((0,R.$Uc)(t))}}var p;(function(d){d[d.Builtin=0]="Builtin",d[d.User=1]="User",d[d.Dev=2]="Dev"})(p||(p={}));function a(d,m){const n=d.isBuiltin?p.Builtin:d.isUnderDevelopment?p.Dev:p.User,o=m.isBuiltin?p.Builtin:m.isUnderDevelopment?p.Dev:p.User;if(n!==o)return n-o;const t=P.$ic.basename(d.extensionLocation.path),i=P.$ic.basename(m.extensionLocation.path);return t<i?-1:t>i?1:0}function f(d,m){const n=new r.$rn(m);return d.filter(o=>!n.has(o.identifier))}}),define(Ee[319],ye([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dn=e.$cn=e.$bn=e.ExtHostConnectionType=void 0,e.$en=N,e.$fn=$;var r;(function(I){I[I.IPC=1]="IPC",I[I.Socket=2]="Socket",I[I.MessagePort=3]="MessagePort"})(r||(e.ExtHostConnectionType=r={}));class h{static{this.ENV_KEY="VSCODE_EXTHOST_IPC_HOOK"}constructor(E){this.pipeName=E,this.type=r.IPC}serialize(E){E[h.ENV_KEY]=this.pipeName}}e.$bn=h;class P{constructor(){this.type=r.Socket}static{this.ENV_KEY="VSCODE_EXTHOST_WILL_SEND_SOCKET"}serialize(E){E[P.ENV_KEY]="1"}}e.$cn=P;class R{constructor(){this.type=r.MessagePort}static{this.ENV_KEY="VSCODE_WILL_SEND_MESSAGE_PORT"}serialize(E){E[R.ENV_KEY]="1"}}e.$dn=R;function T(I){delete I[h.ENV_KEY],delete I[P.ENV_KEY],delete I[R.ENV_KEY]}function N(I,E){T(E),I.serialize(E)}function $(I){if(I[h.ENV_KEY])return c(I,new h(I[h.ENV_KEY]));if(I[P.ENV_KEY])return c(I,new P);if(I[R.ENV_KEY])return c(I,new R);throw new Error("No connection information defined in environment!")}function c(I,E){return T(I),E}}),define(Ee[94],ye([1,0,22]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0,e.$yn=T,e.$zn=N;var h;(function(c){c[c.Desktop=1]="Desktop",c[c.Web=2]="Web"})(h||(e.UIKind=h={}));var P;(function(c){c[c.VersionMismatch=55]="VersionMismatch",c[c.UnexpectedError=81]="UnexpectedError"})(P||(e.ExtensionHostExitCode=P={}));var R;(function(c){c[c.Initialized=0]="Initialized",c[c.Ready=1]="Ready",c[c.Terminate=2]="Terminate"})(R||(e.MessageType=R={}));function T(c){const I=r.$Oe.alloc(1);switch(c){case R.Initialized:I.writeUInt8(1,0);break;case R.Ready:I.writeUInt8(2,0);break;case R.Terminate:I.writeUInt8(3,0);break}return I}function N(c,I){if(c.byteLength!==1)return!1;switch(c.readUInt8(0)){case 1:return I===R.Initialized;case 2:return I===R.Ready;case 3:return I===R.Terminate;default:return!1}}var $;(function(c){c.Start="START_NATIVE_LOG",c.End="END_NATIVE_LOG"})($||(e.NativeLogMarkers=$={}))}),define(Ee[95],ye([1,0,5,4,149,12,30,94,91,92,25,2,3,240]),function(ce,e,r,h,P,R,T,N,$,c,I,E,u,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fQ=e.$dQ=e.$cQ=void 0,e.$eQ=f;let p=class extends u.$Wc{constructor(m,n){super(),this.s=m,this.t=n,this.a=this.B(new h.$me),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new h.$me),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=P.TelemetryLevel.NONE,this.g=!1,this.j=!1,this.r=new Map,this.m=E.URI.revive(this.s.environment.extensionTelemetryLogResource),this.j=this.s.environment.isExtensionTelemetryLoggingOnly,this.n=n.createLogger(this.m,{id:c.$xp,name:(0,k.localize)(0,null,this.j?" (Not Sent)":""),hidden:!0}),this.B(this.n),this.B(n.onDidChangeLogLevel(o=>{(0,R.$bk)(o)&&this.u()})),this.n.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.n.info("===========================================================")}u(){this.t.setVisibility(this.m,this.g&&this.t.getLogLevel()===R.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===P.TelemetryLevel.USAGE}getTelemetryDetails(){return{isCrashEnabled:this.f>=P.TelemetryLevel.CRASH,isErrorsEnabled:this.c.error?this.f>=P.TelemetryLevel.ERROR:!1,isUsageEnabled:this.c.usage?this.f>=P.TelemetryLevel.USAGE:!1}}instantiateLogger(m,n,o){const t=this.getTelemetryDetails(),i=new a(n,o,m,this.n,this.j,this.getBuiltInCommonProperties(m),{isUsageEnabled:t.isUsageEnabled,isErrorsEnabled:t.isErrorsEnabled}),s=this.r.get(m.identifier.value)??[];return this.r.set(m.identifier.value,[...s,i]),i.apiTelemetryLogger}$initializeTelemetryLevel(m,n,o){this.f=m,this.g=n,this.c=o??{usage:!0,error:!0},this.u()}getBuiltInCommonProperties(m){const n=Object.create(null);switch(n["common.extname"]=`${m.publisher}.${m.name}`,n["common.extversion"]=m.version,n["common.vscodemachineid"]=this.s.telemetryInfo.machineId,n["common.vscodesessionid"]=this.s.telemetryInfo.sessionId,n["common.sqmid"]=this.s.telemetryInfo.sqmId,n["common.devDeviceId"]=this.s.telemetryInfo.devDeviceId,n["common.vscodeversion"]=this.s.version,n["common.isnewappinstall"]=f(this.s.telemetryInfo.firstSessionDate),n["common.product"]=this.s.environment.appHost,this.s.uiKind){case N.UIKind.Web:n["common.uikind"]="web";break;case N.UIKind.Desktop:n["common.uikind"]="desktop";break;default:n["common.uikind"]="unknown"}return n["common.remotename"]=(0,$.$hn)((0,c.$Dp)(this.s.remote.authority)),n}$onDidChangeTelemetryLevel(m){this.h=this.getTelemetryConfiguration(),this.f=m;const n=this.getTelemetryDetails();this.r.forEach((o,t)=>{const i=o.filter(s=>!s.isDisposed);i.length===0?this.r.delete(t):this.r.set(t,i)}),this.r.forEach(o=>{for(const t of o)t.updateTelemetryEnablements(n.isUsageEnabled,n.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.u()}onExtensionError(m,n){const t=this.r.get(m.value)?.filter(s=>!s.isDisposed);if(!t)return this.r.delete(m.value),!1;let i=!1;for(const s of t)s.ignoreUnhandledExtHostErrors||(s.logError(n),i=!0);return i}};e.$cQ=p,e.$cQ=p=Je([Ge(0,T.$bQ),Ge(1,R.$ak)],p);class a{static validateSender(m){if(typeof m!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof m.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof m.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof m.flush<"u"&&typeof m.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(m,n,o,t,i,s,g){this.g=o,this.h=t,this.i=i,this.j=s,this.a=new h.$me,this.ignoreUnhandledExtHostErrors=n?.ignoreUnhandledErrors??!1,this.b=n?.ignoreBuiltInCommonProperties??!1,this.c=n?.additionalCommonProperties,this.f=m,this.d={isUsageEnabled:g.isUsageEnabled,isErrorsEnabled:g.isErrorsEnabled}}updateTelemetryEnablements(m,n){this.e&&(this.d={isUsageEnabled:m,isErrorsEnabled:n},this.a.fire(this.e))}mixInCommonPropsAndCleanData(m){let n="properties"in m?m.properties??{}:m;return n=(0,c.$Gp)(n,[]),this.c&&(n=(0,I.$eo)(n,this.c)),this.b||(n=(0,I.$eo)(n,this.j)),"properties"in m?m.properties=n:m=n,m}k(m,n){this.f&&(this.g.publisher==="vscode"?m=this.g.name+"/"+m:m=this.g.identifier.value+"/"+m,n=this.mixInCommonPropsAndCleanData(n||{}),this.i||this.f?.sendEventData(m,n),this.h.trace(m,n))}logUsage(m,n){this.d.isUsageEnabled&&this.k(m,n)}logError(m,n){if(!(!this.d.isErrorsEnabled||!this.f))if(typeof m=="string")this.k(m,n);else{const o={name:m.name,message:m.message,stack:m.stack,cause:m.cause},t=(0,c.$Gp)(o,[]),i=new Error(t.message,{cause:t.cause});i.stack=t.stack,i.name=t.name,n=this.mixInCommonPropsAndCleanData(n||{}),this.i||this.f.sendErrorData(i,n),this.h.trace("exception",n)}}get apiTelemetryLogger(){if(!this.e){const m=this,n={logUsage:m.logUsage.bind(m),get isUsageEnabled(){return m.d.isUsageEnabled},get isErrorsEnabled(){return m.d.isErrorsEnabled},logError:m.logError.bind(m),dispose:m.dispose.bind(m),onDidChangeEnableStates:m.a.event.bind(m)};this.e=Object.freeze(n)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let m=this.f;this.f=void 0,Promise.resolve(m.flush()).then(m=void 0),this.e=void 0}else this.f=void 0}}e.$dQ=a;function f(d){const m=Date.now()-new Date(d).getTime();return isNaN(m)?!1:m<1e3*60*60*24}e.$fQ=(0,r.$Fi)("IExtHostTelemetry")}),define(Ee[26],ye([1,0,4,2,289,147,24,5]),function(ce,e,r,h,P,R,T,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9G=e.ActivationKind=e.$6G=e.$5G=e.$2G=e.ExtensionHostStartup=e.$1G=e.$ZG=e.$YG=e.$XG=void 0,e.$3G=u,e.$4G=k,e.$7G=d,e.$8G=m,e.$XG=Object.freeze({identifier:new T.$qn("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:h.URI.parse("void:location"),isBuiltin:!1,targetPlatform:T.TargetPlatform.UNDEFINED,isUserBuiltin:!1,isUnderDevelopment:!1}),e.$YG="extensions.webWorker",e.$ZG=(0,N.$Fi)("extensionService");class ${constructor(t){this.dependency=t}}e.$1G=$;var c;(function(o){o[o.EagerAutoStart=1]="EagerAutoStart",o[o.EagerManualStart=2]="EagerManualStart",o[o.Lazy=3]="Lazy"})(c||(e.ExtensionHostStartup=c={}));class I{get versionId(){return this.c}get allExtensions(){return this.d}get myExtensions(){return this.e}constructor(t,i,s){this.c=t,this.d=i.slice(0),this.e=s.slice(0),this.f=null}toSnapshot(){return{versionId:this.c,allExtensions:this.d,myExtensions:this.e,activationEvents:R.$IG.createActivationEventsMap(this.d)}}set(t,i,s){if(this.c>t)throw new Error(`ExtensionHostExtensions: invalid versionId ${t} (current: ${this.c})`);const g=[],l=[],w=[],S=[],D=E(this.d),y=E(i),C=(O,M)=>O.extensionLocation.toString()===M.extensionLocation.toString()||O.isBuiltin===M.isBuiltin||O.isUserBuiltin===M.isUserBuiltin||O.isUnderDevelopment===M.isUnderDevelopment;for(const O of this.d){const M=y.get(O.identifier);if(!M){g.push(O.identifier),D.delete(O.identifier);continue}if(!C(O,M)){g.push(O.identifier),D.delete(O.identifier);continue}}for(const O of i){const M=D.get(O.identifier);if(!M){l.push(O);continue}if(!C(M,O)){g.push(M.identifier),D.delete(M.identifier);continue}}const A=new T.$rn(this.e),b=new T.$rn(s);for(const O of this.e)b.has(O)||w.push(O);for(const O of s)A.has(O)||S.push(O);const v=R.$IG.createActivationEventsMap(l),L={versionId:t,toRemove:g,toAdd:l,addActivationEvents:v,myToRemove:w,myToAdd:S};return this.delta(L),L}delta(t){if(this.c>=t.versionId)return null;const{toRemove:i,toAdd:s,myToRemove:g,myToAdd:l}=t,w=new T.$rn(i),S=new T.$rn(g);for(let D=0;D<this.d.length;D++)w.has(this.d[D].identifier)&&(this.d.splice(D,1),D--);for(let D=0;D<this.e.length;D++)S.has(this.e[D])&&(this.e.splice(D,1),D--);for(const D of s)this.d.push(D);for(const D of l)this.e.push(D);return this.f=null,t}containsExtension(t){for(const i of this.e)if(T.$qn.equals(i,t))return!0;return!1}containsActivationEvent(t){return this.f||(this.f=this.g()),this.f.has(t)}g(){const t=new Set;for(const i of this.d){if(!this.containsExtension(i.identifier))continue;const s=R.$IG.readActivationEvents(i);for(const g of s)t.add(g)}return t}}e.$2G=I;function E(o){const t=new T.$sn;for(const i of o)t.set(i.identifier,i);return t}function u(o,t){return o.enabledApiProposals?o.enabledApiProposals.includes(t):!1}function k(o,t){if(!u(o,t))throw new Error(`Extension '${o.identifier.value}' CANNOT use API proposal: ${t}.
Its package.json#enabledApiProposals-property declares: ${o.enabledApiProposals?.join(", ")??"[]"} but NOT ${t}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${o.identifier.value}`)}class p{constructor(t,i,s,g){this.codeLoadingTime=t,this.activateCallTime=i,this.activateResolvedTime=s,this.activationReason=g}}e.$5G=p;class a{constructor(t,i){this.description=t,this.value=i}}e.$6G=a;var f;(function(o){o[o.Normal=0]="Normal",o[o.Immediate=1]="Immediate"})(f||(e.ActivationKind=f={}));function d(o){return{type:o.isBuiltin?T.ExtensionType.System:T.ExtensionType.User,isBuiltin:o.isBuiltin||o.isUserBuiltin,identifier:{id:(0,P.$Mp)(o.publisher,o.name),uuid:o.uuid},manifest:o,location:o.extensionLocation,targetPlatform:o.targetPlatform,validations:[],isValid:!0}}function m(o,t){const i=(0,P.$Kp)(o.manifest.publisher,o.manifest.name);return{id:i,identifier:new T.$qn(i),isBuiltin:o.type===T.ExtensionType.System,isUserBuiltin:o.type===T.ExtensionType.User&&o.isBuiltin,isUnderDevelopment:!!t,extensionLocation:o.location,uuid:o.identifier.uuid,targetPlatform:o.targetPlatform,publisherDisplayName:o.publisherDisplayName,...o.manifest}}class n{constructor(){this.onDidRegisterExtensions=r.Event.None,this.onDidChangeExtensionsStatus=r.Event.None,this.onDidChangeExtensions=r.Event.None,this.onWillActivateByEvent=r.Event.None,this.onDidChangeResponsiveChange=r.Event.None,this.onWillStop=r.Event.None,this.extensions=[]}activateByEvent(t){return Promise.resolve(void 0)}activateById(t,i){return Promise.resolve(void 0)}activationEventIsDone(t){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(t){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(t,i){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(t){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.$9G=n}),define(Ee[320],ye([1,0,14,158,24,26,12,9]),function(ce,e,r,h,P,R,T,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zoc=e.$yoc=e.$xoc=e.$woc=e.$voc=e.$uoc=void 0,r=We(r);class ${static{this.NONE=new $(!1,-1,-1,-1)}constructor(d,m,n,o){this.startup=d,this.codeLoadingTime=m,this.activateCallTime=n,this.activateResolvedTime=o}}e.$uoc=$;class c{constructor(d){this.a=d,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(d,m){return d===-1||m===-1?-1:m-d}build(){return new $(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.$voc=c;class I{constructor(d,m,n,o,t,i){this.activationFailed=d,this.activationFailedError=m,this.activationTimes=n,this.module=o,this.exports=t,this.subscriptions=i}}e.$woc=I;class E extends I{constructor(d){super(!1,null,d,{activate:void 0,deactivate:void 0},void 0,[])}}e.$xoc=E;class u extends I{constructor(){super(!1,null,$.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.$yoc=u;class k extends I{constructor(d){super(!0,d,$.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let p=class{constructor(d,m,n,o){this.g=o,this.a=d,this.b=m,this.c=n,this.d=new P.$sn,this.f=Object.create(null)}dispose(){for(const[d,m]of this.d)m.dispose()}async waitForActivatingExtensions(){const d=[];for(const[m,n]of this.d)d.push(n.wait());await Promise.all(d)}isActivated(d){const m=this.d.get(d);return!!(m&&m.value)}getActivatedExtension(d){const m=this.d.get(d);if(!m||!m.value)throw new Error(`Extension '${d.value}' is not known or not activated`);return m.value}async activateByEvent(d,m){if(this.f[d])return;const n=this.a.getExtensionDescriptionsForActivationEvent(d);await this.h(n.map(o=>({id:o.identifier,reason:{startup:m,extensionId:o.identifier,activationEvent:d}}))),this.f[d]=!0}activateById(d,m){const n=this.a.getExtensionDescription(d);if(!n)throw new Error(`Extension '${d.value}' is not known`);return this.h([{id:n.identifier,reason:m}])}async h(d){const m=d.filter(n=>!this.isActivated(n.id)).map(n=>this.j(n));await Promise.all(m.map(n=>n.wait()))}j(d){if(this.d.has(d.id))return this.d.get(d.id);if(this.l(d.id))return this.k(d,null,[],null);const m=this.a.getExtensionDescription(d.id);if(!m){const t=new Error(`Cannot activate unknown extension '${d.id.value}'`),i=this.k(d,null,[],new k(t));return this.c.onExtensionActivationError(d.id,t,new R.$1G(d.id.value)),i}const n=[],o=typeof m.extensionDependencies>"u"?[]:m.extensionDependencies;for(const t of o){if(this.m(t))continue;const i=this.d.get(t);if(i){n.push(i);continue}if(this.l(t)){n.push(this.j({id:this.b.getExtensionDescription(t).identifier,reason:d.reason}));continue}const s=this.a.getExtensionDescription(t);if(s){if(!s.main&&!s.browser)continue;n.push(this.j({id:s.identifier,reason:d.reason}));continue}const g=m.displayName||m.identifier.value,l=new Error(`Cannot activate the '${g}' extension because it depends on unknown extension '${t}'`),w=this.k(d,m.displayName,[],new k(l));return this.c.onExtensionActivationError(m.identifier,l,new R.$1G(t)),w}return this.k(d,m.displayName,n,null)}k(d,m,n,o){const t=new a(d.id,m,d.reason,n,o,this.c,this.g);return this.d.set(d.id,t),t}l(d){return h.$lcc.isHostExtension(d,this.a,this.b)}m(d){const m=this.b.getExtensionDescription(d);return m?!m.main&&!m.browser:!1}};e.$zoc=p,e.$zoc=p=Je([Ge(3,T.$_j)],p);let a=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(d,m,n,o,t,i,s){this.c=d,this.d=m,this.f=n,this.g=o,this.h=t,this.j=i,this.k=s,this.a=new N.$Eh,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let d=0;d<this.g.length;d++){const m=this.g[d];if(m.value&&!m.value.activationFailed){this.g.splice(d,1),d--;continue}if(m.value&&m.value.activationFailed){const n=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${m.friendlyName}' failed to activate`);n.detail=m.value.activationFailedError,this.h=new k(n),this.j.onExtensionActivationError(this.c,n,null);return}}this.g.length>0&&await Promise.race(this.g.map(d=>d.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(d){const m=new Error;if(d&&d.name&&(m.name=d.name),d&&d.message?m.message=`Activating extension '${this.c.value}' failed: ${d.message}.`:m.message=`Activating extension '${this.c.value}' failed: ${d}.`,d&&d.stack&&(m.stack=d.stack),this.h=new k(m),this.b&&r.$6(d))return;this.j.onExtensionActivationError(this.c,m,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(d)}}};a=Je([Ge(6,T.$_j)],a)}),define(Ee[321],ye([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({activeComment:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.activeComment.d.ts",aiRelatedInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts",aiTextSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiTextSearchProvider.d.ts",attributableCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.attributableCoverage.d.ts",authGetSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts",authLearnMore:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authLearnMore.d.ts",authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",canonicalUriProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts",chatParticipantAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantAdditions.d.ts",chatParticipantPrivate:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantPrivate.d.ts",chatProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts",chatTab:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatTab.d.ts",chatTools:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatTools.d.ts",chatVariableResolver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariableResolver.d.ts",codeActionAI:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts",codeActionRanges:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionRanges.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",commentReactor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReactor.d.ts",commentReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReveal.d.ts",commentThreadApplicability:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentThreadApplicability.d.ts",commentingRangeHint:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentingRangeHint.d.ts",commentsDraftState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts",contribAccessibilityHelpContent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribAccessibilityHelpContent.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribCommentsViewThreadMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentsViewThreadMenus.d.ts",contribDiffEditorGutterToolBarMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribDiffEditorGutterToolBarMenus.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribIssueReporter:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribIssueReporter.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribMultiDiffEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMultiDiffEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribSourceControlHistoryItemGroupMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemGroupMenu.d.ts",contribSourceControlHistoryItemMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemMenu.d.ts",contribSourceControlInputBoxMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlInputBoxMenu.d.ts",contribSourceControlTitleMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlTitleMenu.d.ts",contribStatusBarItems:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",createFileSystemWatcher:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",debugVisualization:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugVisualization.d.ts",defaultChatParticipant:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.defaultChatParticipant.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorHoverVerbosityLevel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorHoverVerbosityLevel.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",embeddings:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.embeddings.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileComments:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findFiles2:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findFiles2.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",inlineEdit:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineEdit.d.ts",interactive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",languageModelSystem:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageModelSystem.d.ts",languageStatusText:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts",lmTools:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.lmTools.d.ts",mappedEditsProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts",multiDocumentHighlightProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.multiDocumentHighlightProvider.d.ts",newSymbolNamesProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.newSymbolNamesProvider.d.ts",notebookCellExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecution.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",notebookVariableProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookVariableProvider.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickDiffProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts",quickPickItemTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmHistoryProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts",scmMultiDiffEditor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmMultiDiffEditor.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmTextDocument:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",shareProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts",showLocal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts",speech:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts",tabInputMultiDiff:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputMultiDiff.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalExecuteCommandEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",terminalSelection:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts",terminalShellIntegration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalShellIntegration.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeViewActiveItem:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts",treeViewMarkdownMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnelFactory:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})});var zt=this&&this.__importDefault||function(ce){return ce&&ce.__esModule?ce:{default:ce}};define(Ee[159],ye([1,0,259,14,44,146,117,37,24,321,116,147]),function(ce,e,r,h,P,R,T,N,$,c,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$WG=e.$VG=e.$UG=e.$TG=e.$SG=e.$RG=void 0,r=We(r),P=zt(P);const u=N.$oo.as(T.$po.JSONContribution);class k{constructor(t,i,s){this.a=t,this.b=i,this.c=s}d(t,i){this.a({type:t,message:i,extensionId:this.b.identifier,extensionPointId:this.c})}error(t){this.d(P.default.Error,t)}warn(t){this.d(P.default.Warning,t)}info(t){this.d(P.default.Info,t)}}e.$RG=k;class p{static a(t){const i=new $.$rn;for(let s=0,g=t.length;s<g;s++)i.add(t[s].description.identifier);return i}static compute(t,i){if(!t||!t.length)return new p(i,[]);if(!i||!i.length)return new p([],t);const s=this.a(t),g=this.a(i),l=i.filter(S=>!s.has(S.description.identifier)),w=t.filter(S=>!g.has(S.description.identifier));return new p(l,w)}constructor(t,i){this.added=t,this.removed=i}}e.$SG=p;class a{constructor(t,i){this.name=t,this.defaultExtensionKind=i,this.a=null,this.b=null,this.c=null}setHandler(t){if(this.a!==null)throw new Error("Handler already set!");return this.a=t,this.d(),{dispose:()=>{this.a=null}}}acceptUsers(t){this.c=p.compute(this.b,t),this.b=t,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(t){(0,h.$3)(t)}}}e.$TG=a;const f={type:"string",enum:["ui","workspace"],enumDescriptions:[r.localize(0,null),r.localize(1,null)]},d="vscode://schemas/vscode-extensions";e.$UG={properties:{engines:{type:"object",description:r.localize(2,null),properties:{vscode:{type:"string",description:r.localize(3,null),default:"^1.22.0"}}},publisher:{description:r.localize(4,null),type:"string"},displayName:{description:r.localize(5,null),type:"string"},categories:{description:r.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:$.$pn},{type:"string",const:"Languages",deprecationMessage:r.localize(7,null)}]}},galleryBanner:{type:"object",description:r.localize(8,null),properties:{color:{description:r.localize(9,null),type:"string"},theme:{description:r.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:r.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:r.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:r.localize(13,null)},enabledApiProposals:{markdownDescription:r.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(c.allApiProposals),markdownEnumDescriptions:Object.values(c.allApiProposals)}},api:{markdownDescription:r.localize(15,null),type:"string",enum:["none"],enumDescriptions:[r.localize(16,null)]},activationEvents:{description:r.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:r.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:r.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:r.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:r.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:r.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:r.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:r.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:r.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:r.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:r.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:r.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:r.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:r.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:r.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:r.localize(32,null)},{label:"onUri",body:"onUri",description:r.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:r.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:r.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:r.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:r.localize(37,null)},{label:"onRenderer",description:r.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:r.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:r.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:r.localize(41,null)},{label:"onIssueReporterOpened",body:"onIssueReporterOpened",description:r.localize(42,null)},{label:"*",description:r.localize(43,null),body:"*"}]}},badges:{type:"array",description:r.localize(44,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:r.localize(45,null)},href:{type:"string",description:r.localize(46,null)},description:{type:"string",description:r.localize(47,null)}}}},markdown:{type:"string",description:r.localize(48,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:r.localize(49,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:r.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:R.$6o}},extensionPack:{description:r.localize(51,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:R.$6o}},extensionKind:{description:r.localize(52,null),type:"array",items:f,default:["workspace"],defaultSnippets:[{body:["ui"],description:r.localize(53,null)},{body:["workspace"],description:r.localize(54,null)},{body:["ui","workspace"],description:r.localize(55,null)},{body:["workspace","ui"],description:r.localize(56,null)},{body:[],description:r.localize(57,null)}]},capabilities:{description:r.localize(58,null),type:"object",properties:{virtualWorkspaces:{description:r.localize(59,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:r.localize(60,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[r.localize(61,null),r.localize(62,null),r.localize(63,null)]},description:{type:"string",markdownDescription:r.localize(64,null)}}},untrustedWorkspaces:{description:r.localize(65,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:r.localize(66,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[r.localize(67,null),r.localize(68,null),r.localize(69,null)]},restrictedConfigurations:{description:r.localize(70,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:r.localize(71,null)}}}}},sponsor:{description:r.localize(72,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:r.localize(73,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:r.localize(74,null),type:"string"},"vscode:uninstall":{description:r.localize(75,null),type:"string"}}},icon:{type:"string",description:r.localize(76,null)},l10n:{type:"string",description:r.localize(77,null)},pricing:{type:"string",markdownDescription:r.localize(78,null),enum:["Free","Trial"],default:"Free"}}};class m{constructor(){this.a=new Map}registerExtensionPoint(t){if(this.a.has(t.extensionPoint))throw new Error("Duplicate extension point: "+t.extensionPoint);const i=new a(t.extensionPoint,t.defaultExtensionKind);return this.a.set(t.extensionPoint,i),t.activationEventsGenerator&&E.$IG.register(t.extensionPoint,t.activationEventsGenerator),e.$UG.properties.contributes.properties[t.extensionPoint]=t.jsonSchema,u.registerSchema(d,e.$UG),i}getExtensionPoints(){return Array.from(this.a.values())}}e.$VG=m;const n={ExtensionsRegistry:"ExtensionsRegistry"};N.$oo.add(n.ExtensionsRegistry,new m),e.$WG=N.$oo.as(n.ExtensionsRegistry),u.registerSchema(d,e.$UG),u.registerSchema(I.$tk,{properties:{extensionEnabledApiProposals:{description:r.localize(79,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(c.allApiProposals),markdownEnumDescriptions:Object.values(c.allApiProposals)}}]}}}})}),define(Ee[322],ye([1,0,4,40,3,13,250,24,5,12,26,159]),function(ce,e,r,h,P,R,T,N,$,c,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_G=e.$$G=e.$0G=e.ChatMessageRole=void 0;var u;(function(a){a[a.System=0]="System",a[a.User=1]="User",a[a.Assistant=2]="Assistant"})(u||(e.ChatMessageRole=u={})),e.$0G=(0,$.$Fi)("ILanguageModelsService");const k={type:"object",properties:{vendor:{type:"string",description:(0,T.localize)(0,null)}}};e.$$G=E.$WG.registerExtensionPoint({extensionPoint:"languageModels",jsonSchema:{description:(0,T.localize)(1,null),oneOf:[k,{type:"array",items:k}]},activationEventsGenerator:(a,f)=>{for(const d of a)f.push(`onLanguageModelChat:${d.vendor}`)}});let p=class{constructor(f,d){this.e=f,this.f=d,this.a=new P.$Vc,this.b=new Map,this.c=new Set,this.d=this.a.add(new r.$me),this.onDidChangeLanguageModels=this.d.event,this.a.add(e.$$G.setHandler(m=>{this.c.clear();for(const o of m){if(!(0,I.$3G)(o.description,"chatProvider")){o.collector.error((0,T.localize)(2,null));continue}for(const t of h.Iterable.wrap(o.value)){if(this.c.has(t.vendor)){o.collector.error((0,T.localize)(3,null,t.vendor));continue}if((0,R.$df)(t.vendor)){o.collector.error((0,T.localize)(4,null));continue}if(t.vendor.trim()!==t.vendor){o.collector.error((0,T.localize)(5,null));continue}this.c.add(t.vendor)}}const n=[];for(const[o,t]of this.b)this.c.has(t.metadata.vendor)||(this.b.delete(o),n.push(o));n.length>0&&this.d.fire({removed:n})}))}dispose(){this.a.dispose(),this.b.clear()}getLanguageModelIds(){return Array.from(this.b.keys())}lookupLanguageModel(f){return this.b.get(f)?.metadata}async selectLanguageModels(f){if(f.vendor)await this.e.activateByEvent(`onLanguageModelChat:${f.vendor}}`);else{const m=Array.from(this.c).map(n=>this.e.activateByEvent(`onLanguageModelChat:${n}`));await Promise.all(m)}const d=[];for(const[m,n]of this.b)(f.vendor===void 0||n.metadata.vendor===f.vendor)&&(f.family===void 0||n.metadata.family===f.family)&&(f.version===void 0||n.metadata.version===f.version)&&(f.identifier===void 0||n.metadata.id===f.identifier)&&(!n.metadata.targetExtensions||n.metadata.targetExtensions.some(o=>N.$qn.equals(o,f.extension)))&&d.push(m);return this.f.trace("[LM] selected language models",f,d),d}registerLanguageModelChat(f,d){if(this.f.trace("[LM] registering language model chat",f,d.metadata),!this.c.has(d.metadata.vendor))throw new Error(`Chat response provider uses UNKNOWN vendor ${d.metadata.vendor}.`);if(this.b.has(f))throw new Error(`Chat response provider with identifier ${f} is already registered.`);return this.b.set(f,d),this.d.fire({added:[{identifier:f,metadata:d.metadata}]}),(0,P.$Uc)(()=>{this.b.delete(f)&&(this.d.fire({removed:[f]}),this.f.trace("[LM] UNregistered language model chat",f,d.metadata))})}makeLanguageModelChatRequest(f,d,m,n,o,t){const i=this.b.get(f);if(!i)throw new Error(`Chat response provider with identifier ${f} is not registered.`);return i.provideChatResponse(m,d,n,o,t)}computeTokenLength(f,d,m){const n=this.b.get(f);if(!n)throw new Error(`Chat response provider with identifier ${f} is not registered.`);return n.provideTokenCount(d,m)}};e.$_G=p,e.$_G=p=Je([Ge(0,I.$ZG),Ge(1,c.$_j)],p)}),define(Ee[323],ye([1,0,254,18,25,159,36,4]),function(ce,e,r,h,P,R,T,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$EI=void 0,r=We(r),h=We(h),P=We(P);const $={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:r.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:r.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:r.localize(2,null),default:""}}};var c;(function(u){function k(p,a,f){if(!p)return;const d=h.$fg(p.type)?p.type:void 0;if(!d||d.length===0){f.error(r.localize(3,null));return}const m=[];if(Array.isArray(p.required))for(const n of p.required)h.$fg(n)&&m.push(n);return{extensionId:a.value,taskType:d,required:m,properties:p.properties?P.$bo(p.properties):{},when:p.when?T.$Dj.deserialize(p.when):void 0}}u.from=k})(c||(c={}));const I=R.$WG.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(u,k)=>{for(const p of u)p.type&&k.push(`onTaskType:${p.type}`)},jsonSchema:{description:r.localize(4,null),type:"array",items:$}});class E{constructor(){this.d=new N.$me,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((k,p)=>{I.setHandler((a,f)=>{this.c=void 0;try{for(const d of f.removed){const m=d.value;for(const n of m)this.a&&n.type&&this.a[n.type]&&delete this.a[n.type]}for(const d of f.added){const m=d.value;for(const n of m){const o=c.from(n,d.description.identifier,d.collector);o&&(this.a[o.taskType]=o)}}(f.removed.length>0||f.added.length>0)&&this.d.fire()}catch{}k(void 0)})})}onReady(){return this.b}get(k){return this.a[k]}all(){return Object.keys(this.a).map(k=>this.a[k])}getJsonSchema(){if(this.c===void 0){const k=[];for(const p of this.all()){const a={type:"object",additionalProperties:!1};p.required.length>0&&(a.required=p.required.slice(0)),p.properties!==void 0?a.properties=P.$bo(p.properties):a.properties=Object.create(null),a.properties.type={type:"string",enum:[p.taskType]},k.push(a)}this.c={oneOf:k}}return this.c}}e.$EI=new E}),define(Ee[324],ye([1,0,255,18,23,25,36,323,45]),function(ce,e,r,h,P,R,T,N,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.$OI=e.JsonSchemaVersion=e.ExecutionEngine=e.$NI=e.$MI=e.$LI=e.$KI=e.$JI=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.$II=e.ShellQuoting=e.$HI=e.$GI=e.$FI=void 0,r=We(r),h=We(h),P=We(P),R=We(R),e.$FI="settings",e.$GI=new T.$Wj("taskRunning",!1,r.localize(0,null)),e.$HI=r.localize2(2,"Tasks");var c;(function(F){F[F.Escape=1]="Escape",F[F.Strong=2]="Strong",F[F.Weak=3]="Weak"})(c||(e.ShellQuoting=c={})),e.$II="$customized",function(F){function B(_){if(!_)return F.Strong;switch(_.toLowerCase()){case"escape":return F.Escape;case"strong":return F.Strong;case"weak":return F.Weak;default:return F.Strong}}F.from=B}(c||(e.ShellQuoting=c={}));var I;(function(F){F.defaults={cwd:"${workspaceFolder}"}})(I||(e.CommandOptions=I={}));var E;(function(F){F[F.Always=1]="Always",F[F.Silent=2]="Silent",F[F.Never=3]="Never"})(E||(e.RevealKind=E={})),function(F){function B(_){switch(_.toLowerCase()){case"always":return F.Always;case"silent":return F.Silent;case"never":return F.Never;default:return F.Always}}F.fromString=B}(E||(e.RevealKind=E={}));var u;(function(F){F[F.Never=1]="Never",F[F.OnProblem=2]="OnProblem",F[F.Always=3]="Always"})(u||(e.RevealProblemKind=u={})),function(F){function B(_){switch(_.toLowerCase()){case"always":return F.Always;case"never":return F.Never;case"onproblem":return F.OnProblem;default:return F.OnProblem}}F.fromString=B}(u||(e.RevealProblemKind=u={}));var k;(function(F){F[F.Shared=1]="Shared",F[F.Dedicated=2]="Dedicated",F[F.New=3]="New"})(k||(e.PanelKind=k={})),function(F){function B(_){switch(_.toLowerCase()){case"shared":return F.Shared;case"dedicated":return F.Dedicated;case"new":return F.New;default:return F.Shared}}F.fromString=B}(k||(e.PanelKind=k={}));var p;(function(F){F.defaults={echo:!0,reveal:E.Always,revealProblems:u.Never,focus:!1,panel:k.Shared,showReuseMessage:!0,clear:!1}})(p||(e.PresentationOptions=p={}));var a;(function(F){F[F.Shell=1]="Shell",F[F.Process=2]="Process",F[F.CustomExecution=3]="CustomExecution"})(a||(e.RuntimeType=a={})),function(F){function B(re){switch(re.toLowerCase()){case"shell":return F.Shell;case"process":return F.Process;case"customExecution":return F.CustomExecution;default:return F.Process}}F.fromString=B;function _(re){switch(re){case F.Shell:return"shell";case F.Process:return"process";case F.CustomExecution:return"customExecution";default:return"process"}}F.toString=_}(a||(e.RuntimeType=a={}));var f;(function(F){function B(_){return h.$fg(_)?_:_.value}F.value=B})(f||(e.CommandString=f={}));var d;(function(F){F.Clean={_id:"clean",isDefault:!1},F.Build={_id:"build",isDefault:!1},F.Rebuild={_id:"rebuild",isDefault:!1},F.Test={_id:"test",isDefault:!1};function B(re){return re===F.Clean._id||re===F.Build._id||re===F.Rebuild._id||re===F.Test._id}F.is=B;function _(re){if(re!==void 0)return h.$fg(re)?B(re)?{_id:re,isDefault:!1}:void 0:re}F.from=_})(d||(e.TaskGroup=d={}));var m;(function(F){F[F.Global=1]="Global",F[F.Workspace=2]="Workspace",F[F.Folder=3]="Folder"})(m||(e.TaskScope=m={}));var n;(function(F){F.Workspace="workspace",F.Extension="extension",F.InMemory="inMemory",F.WorkspaceFile="workspaceFile",F.User="user";function B(_){switch(_){case F.User:return $.ConfigurationTarget.USER;case F.WorkspaceFile:return $.ConfigurationTarget.WORKSPACE;default:return $.ConfigurationTarget.WORKSPACE_FOLDER}}F.toConfigurationTarget=B})(n||(e.TaskSourceKind=n={}));var o;(function(F){F.parallel="parallel",F.sequence="sequence"})(o||(e.DependsOrder=o={}));var t;(function(F){F[F.default=1]="default",F[F.folderOpen=2]="folderOpen"})(t||(e.RunOnOptions=t={}));var i;(function(F){F.defaults={reevaluateOnRerun:!0,runOn:t.default,instanceLimit:1}})(i||(e.RunOptions=i={}));class s{constructor(B,_,re,U,G,Q){this._label="",this._id=B,_&&(this._label=_),re&&(this.type=re),this.runOptions=U,this.configurationProperties=G,this._source=Q}getDefinition(B){}getMapKey(){return this._id}getKey(){}getCommonTaskId(){const B={folder:this.d(),id:this._id};return JSON.stringify(B)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(B,_=!1){if(B===void 0)return!1;if(h.$fg(B))return B===this._label||B===this.configurationProperties.identifier||_&&B===this._id;const re=this.getDefinition(!0);return re!==void 0&&re._key===B._key}getQualifiedLabel(){const B=this.getWorkspaceFolder();return B?`${this._label} (${B.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(B){this.c===void 0&&(this.c=[]),B&&(this.c=this.c.concat(B))}get taskLoadMessages(){return this.c}}e.$JI=s;class g extends s{constructor(B,_,re,U,G,Q,ee,he){super(B,re,void 0,ee,he,_),this.command={},this._source=_,this.hasDefinedMatchers=Q,G&&(this.command=G)}clone(){return new g(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(B=!1){if(B&&this._source.customizes!==void 0)return this._source.customizes;{let _;switch(this.command?this.command.runtime:void 0){case a.Shell:_="shell";break;case a.Process:_="process";break;case a.CustomExecution:_="customExecution";break;case void 0:_="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:_,_key:this._id,id:this._id}}}static is(B){return B instanceof g}getMapKey(){const B=this._source.config.workspaceFolder;return B?`${B.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===n.User?e.$FI:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getKey()??super.getCommonTaskId()}getKey(){const B=this.d();if(!B)return;let _=this.configurationProperties.identifier;this._source.kind!==n.Workspace&&(_+=this._source.kind);const re={type:e.$II,folder:B,id:_};return JSON.stringify(re)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?P.$dh(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(B){return new g(B._id,B._source,B._label,B.type,B.command,B.hasDefinedMatchers,B.runOptions,B.configurationProperties)}}e.$KI=g;class l extends s{constructor(B,_,re,U,G,Q,ee){super(B,re,U,Q,ee,_),this._source=_,this.configures=G}static is(B){return B instanceof l}f(B){return B}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?P.$dh(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===n.User?e.$FI:this._source.config.workspaceFolder?.uri.toString()}getKey(){const B=this.d();if(!B)return;let _=this.configurationProperties.identifier;this._source.kind!==n.Workspace&&(_+=this._source.kind);const re={type:e.$II,folder:B,id:_};return JSON.stringify(re)}}e.$LI=l;class w extends s{constructor(B,_,re,U,G,Q,ee,he,ne){super(B,re,U,he,ne,_),this.defines=G,this.hasDefinedMatchers=ee,this.command=Q,this.icon=ne.icon,this.hide=ne.hide}clone(){return new w(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(B){return B instanceof w}getMapKey(){const B=this._source.workspaceFolder;return B?`${this._source.scope.toString()}|${B.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===m.Folder&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getKey(){const B={type:"contributed",scope:this._source.scope,id:this._id};return B.folder=this.d(),JSON.stringify(B)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(B){return new w(B._id,B._source,B._label,B.type,B.defines,B.command,B.hasDefinedMatchers,B.runOptions,B.configurationProperties)}}e.$MI=w;class S extends s{constructor(B,_,re,U,G,Q){super(B,re,U,G,Q,_),this._source=_}clone(){return new S(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(B){return B instanceof S}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(B){return new S(B._id,B._source,B._label,B.type,B.runOptions,B.configurationProperties)}}e.$NI=S;var D;(function(F){F[F.Process=1]="Process",F[F.Terminal=2]="Terminal"})(D||(e.ExecutionEngine=D={})),function(F){F._default=F.Terminal}(D||(e.ExecutionEngine=D={}));var y;(function(F){F[F.V0_1_0=1]="V0_1_0",F[F.V2_0_0=2]="V2_0_0"})(y||(e.JsonSchemaVersion=y={}));class C{constructor(B){this.c=new Map;for(let _=0;_<B.length;_++)this.c.set(B[_].uri.toString(),_)}compare(B,_){const re=B.getWorkspaceFolder(),U=_.getWorkspaceFolder();if(re&&U){let G=this.c.get(re.uri.toString());G=G===void 0?0:G+1;let Q=this.c.get(U.uri.toString());return Q=Q===void 0?0:Q+1,G===Q?B._label.localeCompare(_._label):G-Q}else return!re&&U?-1:re&&!U?1:0}}e.$OI=C;var A;(function(F){F.DependsOnStarted="dependsOnStarted",F.AcquiredInput="acquiredInput",F.Start="start",F.ProcessStarted="processStarted",F.Active="active",F.Inactive="inactive",F.Changed="changed",F.Terminated="terminated",F.ProcessEnded="processEnded",F.End="end"})(A||(e.TaskEventKind=A={}));var b;(function(F){F.SingleRun="singleRun",F.Background="background"})(b||(e.TaskRunType=b={}));var v;(function(F){F[F.System=0]="System",F[F.User=1]="User",F[F.FolderOpen=2]="FolderOpen",F[F.ConfigurationChange=3]="ConfigurationChange",F[F.Reconnect=4]="Reconnect"})(v||(e.TaskRunSource=v={}));var L;(function(F){function B(he){return{taskId:he._id,taskName:he.configurationProperties.name,runType:he.configurationProperties.isBackground?b.Background:b.SingleRun,group:he.configurationProperties.group,__task:he}}function _(he,ne,De){return{...B(he),kind:A.Start,terminalId:ne,resolvedVariables:De}}F.start=_;function re(he,ne,De){return{...B(he),kind:A.ProcessStarted,terminalId:ne,processId:De}}F.processStarted=re;function U(he,ne,De){return{...B(he),kind:A.ProcessEnded,terminalId:ne,exitCode:De}}F.processEnded=U;function G(he,ne,De){return{...B(he),kind:A.Terminated,exitReason:De,terminalId:ne}}F.terminated=G;function Q(he,ne,De){return{...B(ne),kind:he,terminalId:De}}F.general=Q;function ee(){return{kind:A.Changed}}F.changed=ee})(L||(e.TaskEvent=L={}));var O;(function(F){function B(re){const U=Object.keys(re).sort();let G="";for(const Q of U){let ee=re[Q];ee instanceof Object?ee=B(ee):typeof ee=="string"&&(ee=ee.replace(/,/g,",,")),G+=Q+","+ee+","}return G}function _(re){const G={_key:B(re),type:re.taskType};return Object.assign(G,re),G}F.create=_})(O||(e.KeyedTaskIdentifier=O={}));var M;(function(F){F.AutoDetect="task.autoDetect",F.SaveBeforeRun="task.saveBeforeRun",F.ShowDecorations="task.showDecorations",F.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",F.SlowProviderWarning="task.slowProviderWarning",F.QuickOpenHistory="task.quickOpen.history",F.QuickOpenDetail="task.quickOpen.detail",F.QuickOpenSkip="task.quickOpen.skip",F.QuickOpenShowAll="task.quickOpen.showAll",F.AllowAutomaticTasks="task.allowAutomaticTasks",F.Reconnection="task.reconnection",F.VerboseLogging="task.verboseLogging"})(M||(e.TaskSettingId=M={}));var j;(function(F){F.Tasks="tasks",F.SuppressTaskName="tasks.suppressTaskName",F.Windows="tasks.windows",F.Osx="tasks.osx",F.Linux="tasks.linux",F.ShowOutput="tasks.showOutput",F.IsShellCommand="tasks.isShellCommand",F.ServiceTestSetting="tasks.service.testSetting"})(j||(e.TasksSchemaProperties=j={}));var z;(function(F){function B(_,re){const U=N.$EI.get(_.type);if(U===void 0){const he=R.$bo(_);return delete he._key,O.create(he)}const G=Object.create(null);G.type=U.taskType;const Q=new Set;U.required.forEach(he=>Q.add(he));const ee=U.properties;for(const he of Object.keys(ee)){const ne=_[he];if(ne!=null)G[he]=ne;else if(Q.has(he)){const De=ee[he];if(De.default!==void 0)G[he]=R.$bo(De.default);else switch(De.type){case"boolean":G[he]=!1;break;case"number":case"integer":G[he]=0;break;case"string":G[he]="";break;default:re.error(r.localize(1,null,JSON.stringify(_,void 0,0),he));return}}}return O.create(G)}F.createTaskIdentifier=B})(z||(e.TaskDefinition=z={}))}),define(Ee[325],ye([1,0,14]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qcc=e.$pcc=void 0;class h{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((T,N)=>{this.b=T,this.d=N,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(T){this.f||this.h||(this.f=!0,this.g=T,this.a&&this.b(T))}resolveErr(T){this.f||this.h||(this.h=!0,this.i=T,this.a?this.d(T):(0,r.$3)(T))}then(T,N){return this.j().then(T,N)}catch(T){return this.j().then(void 0,T)}finally(T){return this.j().finally(T)}}e.$pcc=h;class P extends h{constructor(){super(),this.h=!0,this.i=new r.$7}}e.$qcc=P}),define(Ee[51],ye([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pw=e.$Mw=void 0,e.$Nw=P,e.$Ow=R;class r{static{this.count=0}constructor($){this._proxyIdentifierBrand=void 0,this.sid=$,this.nid=++r.count}}e.$Mw=r;const h=[];function P(N){const $=new r(N);return h[$.nid]=$,$}function R(N){return h[N].sid}class T{constructor($){this.value=$}}e.$Pw=T}),define(Ee[6],ye([1,0,51]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sN=e.$rN=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.$qN=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var h;(function(a){a[a.Default=0]="Default",a[a.InCenter=1]="InCenter",a[a.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",a[a.AtTop=3]="AtTop"})(h||(e.TextEditorRevealType=h={}));var P;(function(a){a[a.UnknownInput=0]="UnknownInput",a[a.TextInput=1]="TextInput",a[a.TextDiffInput=2]="TextDiffInput",a[a.TextMergeInput=3]="TextMergeInput",a[a.NotebookInput=4]="NotebookInput",a[a.NotebookDiffInput=5]="NotebookDiffInput",a[a.CustomEditorInput=6]="CustomEditorInput",a[a.WebviewEditorInput=7]="WebviewEditorInput",a[a.TerminalEditorInput=8]="TerminalEditorInput",a[a.InteractiveEditorInput=9]="InteractiveEditorInput",a[a.ChatEditorInput=10]="ChatEditorInput",a[a.MultiDiffEditorInput=11]="MultiDiffEditorInput"})(P||(e.TabInputKind=P={}));var R;(function(a){a[a.TAB_OPEN=0]="TAB_OPEN",a[a.TAB_CLOSE=1]="TAB_CLOSE",a[a.TAB_UPDATE=2]="TAB_UPDATE",a[a.TAB_MOVE=3]="TAB_MOVE"})(R||(e.TabModelOperationKind=R={}));var T;(function(a){a[a.Editable=0]="Editable",a[a.SupportsHotExit=1]="SupportsHotExit"})(T||(e.WebviewEditorCapabilities=T={}));var N;(function(a){a[a.Int8Array=1]="Int8Array",a[a.Uint8Array=2]="Uint8Array",a[a.Uint8ClampedArray=3]="Uint8ClampedArray",a[a.Int16Array=4]="Int16Array",a[a.Uint16Array=5]="Uint16Array",a[a.Int32Array=6]="Int32Array",a[a.Uint32Array=7]="Uint32Array",a[a.Float32Array=8]="Float32Array",a[a.Float64Array=9]="Float64Array",a[a.BigInt64Array=10]="BigInt64Array",a[a.BigUint64Array=11]="BigUint64Array"})(N||(e.WebviewMessageArrayBufferViewType=N={}));var $;(function(a){a[a.Text=1]="Text",a[a.Error=2]="Error",a[a.Rich=3]="Rich"})($||(e.CellOutputKind=$={}));var c;(function(a){a[a.Default=0]="Default",a[a.InCenter=1]="InCenter",a[a.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",a[a.AtTop=3]="AtTop"})(c||(e.NotebookEditorRevealType=c={}));var I;(function(a){a[a.None=0]="None",a[a.Process=1]="Process",a[a.Output=2]="Output",a[a.Hybrid=3]="Hybrid"})(I||(e.CandidatePortSource=I={}));class E{static{this.a=0}static mixin(f){return f._id=E.a++,f}}e.$qN=E;var u;(function(a){a.label="a",a.kind="b",a.detail="c",a.documentation="d",a.sortText="e",a.filterText="f",a.preselect="g",a.insertText="h",a.insertTextRules="i",a.range="j",a.commitCharacters="k",a.additionalTextEdits="l",a.kindModifier="m",a.commandIdent="n",a.commandId="o",a.commandArguments="p"})(u||(e.ISuggestDataDtoField=u={}));var k;(function(a){a.defaultRanges="a",a.completions="b",a.isIncomplete="c",a.duration="d"})(k||(e.ISuggestResultDtoField=k={}));var p;(function(a){a[a.Workspace=0]="Workspace",a[a.TextDocument=1]="TextDocument"})(p||(e.ExtHostTestingResource=p={})),e.$rN={MainThreadAuthentication:(0,r.$Nw)("MainThreadAuthentication"),MainThreadBulkEdits:(0,r.$Nw)("MainThreadBulkEdits"),MainThreadLanguageModels:(0,r.$Nw)("MainThreadLanguageModels"),MainThreadEmbeddings:(0,r.$Nw)("MainThreadEmbeddings"),MainThreadChatAgents2:(0,r.$Nw)("MainThreadChatAgents2"),MainThreadChatVariables:(0,r.$Nw)("MainThreadChatVariables"),MainThreadLanguageModelTools:(0,r.$Nw)("MainThreadChatSkills"),MainThreadClipboard:(0,r.$Nw)("MainThreadClipboard"),MainThreadCommands:(0,r.$Nw)("MainThreadCommands"),MainThreadComments:(0,r.$Nw)("MainThreadComments"),MainThreadConfiguration:(0,r.$Nw)("MainThreadConfiguration"),MainThreadConsole:(0,r.$Nw)("MainThreadConsole"),MainThreadDebugService:(0,r.$Nw)("MainThreadDebugService"),MainThreadDecorations:(0,r.$Nw)("MainThreadDecorations"),MainThreadDiagnostics:(0,r.$Nw)("MainThreadDiagnostics"),MainThreadDialogs:(0,r.$Nw)("MainThreadDiaglogs"),MainThreadDocuments:(0,r.$Nw)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,r.$Nw)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,r.$Nw)("MainThreadTextEditors"),MainThreadEditorInsets:(0,r.$Nw)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,r.$Nw)("MainThreadEditorTabs"),MainThreadErrors:(0,r.$Nw)("MainThreadErrors"),MainThreadTreeViews:(0,r.$Nw)("MainThreadTreeViews"),MainThreadDownloadService:(0,r.$Nw)("MainThreadDownloadService"),MainThreadLanguageFeatures:(0,r.$Nw)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,r.$Nw)("MainThreadLanguages"),MainThreadLogger:(0,r.$Nw)("MainThreadLogger"),MainThreadMessageService:(0,r.$Nw)("MainThreadMessageService"),MainThreadOutputService:(0,r.$Nw)("MainThreadOutputService"),MainThreadProgress:(0,r.$Nw)("MainThreadProgress"),MainThreadQuickDiff:(0,r.$Nw)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,r.$Nw)("MainThreadQuickOpen"),MainThreadStatusBar:(0,r.$Nw)("MainThreadStatusBar"),MainThreadSecretState:(0,r.$Nw)("MainThreadSecretState"),MainThreadStorage:(0,r.$Nw)("MainThreadStorage"),MainThreadSpeech:(0,r.$Nw)("MainThreadSpeechProvider"),MainThreadTelemetry:(0,r.$Nw)("MainThreadTelemetry"),MainThreadTerminalService:(0,r.$Nw)("MainThreadTerminalService"),MainThreadTerminalShellIntegration:(0,r.$Nw)("MainThreadTerminalShellIntegration"),MainThreadWebviews:(0,r.$Nw)("MainThreadWebviews"),MainThreadWebviewPanels:(0,r.$Nw)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,r.$Nw)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,r.$Nw)("MainThreadCustomEditors"),MainThreadUrls:(0,r.$Nw)("MainThreadUrls"),MainThreadUriOpeners:(0,r.$Nw)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,r.$Nw)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,r.$Nw)("MainThreadWorkspace"),MainThreadFileSystem:(0,r.$Nw)("MainThreadFileSystem"),MainThreadFileSystemEventService:(0,r.$Nw)("MainThreadFileSystemEventService"),MainThreadExtensionService:(0,r.$Nw)("MainThreadExtensionService"),MainThreadSCM:(0,r.$Nw)("MainThreadSCM"),MainThreadSearch:(0,r.$Nw)("MainThreadSearch"),MainThreadShare:(0,r.$Nw)("MainThreadShare"),MainThreadTask:(0,r.$Nw)("MainThreadTask"),MainThreadWindow:(0,r.$Nw)("MainThreadWindow"),MainThreadLabelService:(0,r.$Nw)("MainThreadLabelService"),MainThreadNotebook:(0,r.$Nw)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,r.$Nw)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,r.$Nw)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,r.$Nw)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,r.$Nw)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,r.$Nw)("MainThreadInteractive"),MainThreadTheming:(0,r.$Nw)("MainThreadTheming"),MainThreadTunnelService:(0,r.$Nw)("MainThreadTunnelService"),MainThreadManagedSockets:(0,r.$Nw)("MainThreadManagedSockets"),MainThreadTimeline:(0,r.$Nw)("MainThreadTimeline"),MainThreadTesting:(0,r.$Nw)("MainThreadTesting"),MainThreadLocalization:(0,r.$Nw)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,r.$Nw)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,r.$Nw)("MainThreadAiEmbeddingVector")},e.$sN={ExtHostCommands:(0,r.$Nw)("ExtHostCommands"),ExtHostConfiguration:(0,r.$Nw)("ExtHostConfiguration"),ExtHostDiagnostics:(0,r.$Nw)("ExtHostDiagnostics"),ExtHostDebugService:(0,r.$Nw)("ExtHostDebugService"),ExtHostDecorations:(0,r.$Nw)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,r.$Nw)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,r.$Nw)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,r.$Nw)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,r.$Nw)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,r.$Nw)("ExtHostEditors"),ExtHostTreeViews:(0,r.$Nw)("ExtHostTreeViews"),ExtHostFileSystem:(0,r.$Nw)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,r.$Nw)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,r.$Nw)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,r.$Nw)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,r.$Nw)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,r.$Nw)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,r.$Nw)("ExtHostQuickDiff"),ExtHostStatusBar:(0,r.$Nw)("ExtHostStatusBar"),ExtHostShare:(0,r.$Nw)("ExtHostShare"),ExtHostExtensionService:(0,r.$Nw)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,r.$Nw)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,r.$Nw)("ExtHostTerminalService"),ExtHostTerminalShellIntegration:(0,r.$Nw)("ExtHostTerminalShellIntegration"),ExtHostSCM:(0,r.$Nw)("ExtHostSCM"),ExtHostSearch:(0,r.$Nw)("ExtHostSearch"),ExtHostTask:(0,r.$Nw)("ExtHostTask"),ExtHostWorkspace:(0,r.$Nw)("ExtHostWorkspace"),ExtHostWindow:(0,r.$Nw)("ExtHostWindow"),ExtHostWebviews:(0,r.$Nw)("ExtHostWebviews"),ExtHostWebviewPanels:(0,r.$Nw)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,r.$Nw)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,r.$Nw)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,r.$Nw)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,r.$Nw)("ExtHostEditorTabs"),ExtHostProgress:(0,r.$Nw)("ExtHostProgress"),ExtHostComments:(0,r.$Nw)("ExtHostComments"),ExtHostSecretState:(0,r.$Nw)("ExtHostSecretState"),ExtHostStorage:(0,r.$Nw)("ExtHostStorage"),ExtHostUrls:(0,r.$Nw)("ExtHostUrls"),ExtHostUriOpeners:(0,r.$Nw)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,r.$Nw)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,r.$Nw)("ExtHostOutputService"),ExtHostLabelService:(0,r.$Nw)("ExtHostLabelService"),ExtHostNotebook:(0,r.$Nw)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,r.$Nw)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,r.$Nw)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,r.$Nw)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,r.$Nw)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,r.$Nw)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,r.$Nw)("ExtHostInteractive"),ExtHostChatAgents2:(0,r.$Nw)("ExtHostChatAgents"),ExtHostChatVariables:(0,r.$Nw)("ExtHostChatVariables"),ExtHostLanguageModelTools:(0,r.$Nw)("ExtHostChatSkills"),ExtHostChatProvider:(0,r.$Nw)("ExtHostChatProvider"),ExtHostSpeech:(0,r.$Nw)("ExtHostSpeech"),ExtHostEmbeddings:(0,r.$Nw)("ExtHostEmbeddings"),ExtHostAiRelatedInformation:(0,r.$Nw)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,r.$Nw)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,r.$Nw)("ExtHostTheming"),ExtHostTunnelService:(0,r.$Nw)("ExtHostTunnelService"),ExtHostManagedSockets:(0,r.$Nw)("ExtHostManagedSockets"),ExtHostAuthentication:(0,r.$Nw)("ExtHostAuthentication"),ExtHostTimeline:(0,r.$Nw)("ExtHostTimeline"),ExtHostTesting:(0,r.$Nw)("ExtHostTesting"),ExtHostTelemetry:(0,r.$Nw)("ExtHostTelemetry"),ExtHostLocalization:(0,r.$Nw)("ExtHostLocalization")}}),define(Ee[96],ye([1,0,5,12,6,20]),function(ce,e,r,h,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vnc=e.$Unc=e.$Tnc=void 0,P=We(P),e.$Tnc=(0,r.$Fi)("IExtHostApiDeprecationService");let T=class{constructor($,c){this.c=c,this.a=new Set,this.b=$.getProxy(P.$rN.MainThreadTelemetry)}report($,c,I){const E=this.d($,c);this.a.has(E)||(this.a.add(E),c.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${$}' is deprecated. ${I}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:c.identifier.value,apiId:$}))}d($,c){return`${$}-${c.identifier.value}`}};e.$Unc=T,e.$Unc=T=Je([Ge(0,R.$XP),Ge(1,h.$_j)],T),e.$Vnc=Object.freeze(new class{report(N,$,c){}})}),define(Ee[326],ye([1,0,6]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9nc=void 0;class h{constructor(R){const T=R.getProxy(r.$rN.MainThreadClipboard);this.value=Object.freeze({readText(){return T.$readText()},writeText(N){return T.$writeText(N)}})}}e.$9nc=h}),define(Ee[327],ye([1,0,25,6,30,20]),function(ce,e,r,h,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5pc=void 0;let T=class{constructor(I,E){this.a=I.getProxy(h.$rN.MainThreadConsole),this.b=E.consoleForward.includeStack,this.c=E.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("debug","debug"),this.d("error","error")}d(I,E){const u=this,k=console[I];Object.defineProperty(console,I,{set:()=>{},get:()=>function(){u.e(I,E,k,arguments)}})}e(I,E,u,k){this.a.$logExtensionHostMessage({type:"__$console",severity:E,arguments:$(k,this.b)}),this.c&&this.f(I,u,k)}};e.$5pc=T,e.$5pc=T=Je([Ge(0,R.$XP),Ge(1,P.$bQ)],T);const N=1e5;function $(c,I){const E=[];if(c.length)for(let u=0;u<c.length;u++){let k=c[u];if(typeof k>"u")k="undefined";else if(k instanceof Error){const p=k;p.stack?k=p.stack:k=p.toString()}E.push(k)}if(I){const u=new Error().stack;u&&E.push({__$stack:u.split(`
`).slice(3).join(`
`)})}try{const u=(0,r.$go)(E);return u.length>N?"Output omitted for a large object that exceeds the limits":u}catch(u){return`Output omitted for an object that cannot be inspected ('${u.toString()}')`}}}),define(Ee[328],ye([1,0,2,6,26]),function(ce,e,r,h,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$oc=void 0;class R{constructor(N){this.a=N.getProxy(h.$rN.MainThreadDialogs)}showOpenDialog(N,$){return $?.allowUIResources&&(0,P.$4G)(N,"showLocal"),this.a.$showOpenDialog($).then(c=>c?c.map(I=>r.URI.revive(I)):void 0)}showSaveDialog(N){return this.a.$showSaveDialog(N).then($=>$?r.URI.revive($):void 0)}}e.$$oc=R}),define(Ee[329],ye([1,0,21,4,3,6]),function(ce,e,r,h,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bpc=void 0;class T{constructor($){this.b=new Map,this.c=new h.$me,this.onDidChange=this.c.event,this.d=new Set,this.e=0,this.a=$.getProxy(R.$rN.MainThreadEmbeddings)}registerEmbeddingsProvider($,c,I){if(this.d.has(c))throw new Error("An embeddings provider for this model is already registered");const E=this.e++;return this.a.$registerEmbeddingProvider(E,c),this.b.set(E,{id:c,provider:I}),(0,P.$Uc)(()=>{this.a.$unregisterEmbeddingProvider(E),this.b.delete(E)})}async computeEmbeddings($,c,I){I??=r.CancellationToken.None;let E=!1;typeof c=="string"&&(c=[c],E=!0);const u=await this.a.$computeEmbeddings($,c,I);if(u.length!==c.length)throw new Error;if(E){if(u.length!==1)throw new Error;return u[0]}return u}async $provideEmbeddings($,c,I){const E=this.b.get($);if(!E)return[];const u=await E.provider.provideEmbeddings(c,I);return u||[]}get embeddingsModels(){return Array.from(this.d)}$acceptEmbeddingModels($){this.d=new Set($),this.c.fire()}}e.$bpc=T}),define(Ee[330],ye([1,0,3,6]),function(ce,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$spc=void 0;class P{constructor(T){this.b=0,this.a=T.getProxy(h.$rN.MainThreadLabelService)}$registerResourceLabelFormatter(T){const N=this.b++;return this.a.$registerResourceLabelFormatter(N,T),(0,r.$Uc)(()=>{this.a.$unregisterResourceLabelFormatter(N)})}}e.$spc=P}),define(Ee[331],ye([1,0,3,6]),function(ce,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2pc=void 0;class P{constructor(T){this.a=new Map,this.c=new Map,this.b=T.getProxy(h.$rN.MainThreadLanguageModelTools),this.b.$getTools().then(N=>{for(const $ of N)this.c.set($.id,$)})}async invokeTool(T,N,$){return await this.b.$invokeTool(T,N,$)}async $acceptToolDelta(T){T.added&&this.c.set(T.added.id,T.added),T.removed&&this.c.delete(T.removed)}get tools(){return Array.from(this.c.values())}async $invokeTool(T,N,$){const c=this.a.get(T);if(!c)throw new Error(`Unknown tool ${T}`);return await c.tool.invoke(N,$)}registerTool(T,N,$){return this.a.set(N,{extension:T,tool:$}),this.b.$registerTool(N),(0,r.$Uc)(()=>{this.a.delete(N),this.b.$unregisterTool(N)})}}e.$2pc=P}),define(Ee[123],ye([1,0,11,13,2,5,12,6,30,20]),function(ce,e,r,h,P,R,T,N,$,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ooc=e.$Noc=void 0;let I=class{constructor(u,k,p){this.f=p,this.d=new Map,this.a=k.getProxy(N.$rN.MainThreadLocalization),this.b=u.environment.appLanguage,this.c=this.b===r.$g}getMessage(u,k){const{message:p,args:a,comment:f}=k;if(this.c)return(0,h.$ff)(p,a??{});let d=p;f&&f.length>0&&(d+=`/${Array.isArray(f)?f.join(""):f}`);const m=this.d.get(u)?.contents[d];return m||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${d}`),(0,h.$ff)(m??p,a??{})}getBundle(u){return this.d.get(u)?.contents}getBundleUri(u){return this.d.get(u)?.uri}async initializeLocalizedMessages(u){if(this.c||!u.l10n&&!u.isBuiltin||this.d.has(u.identifier.value))return;let k;const p=await this.g(u);if(!p){this.f.error(`No bundle location found for extension ${u.identifier.value}`);return}try{const a=await this.a.$fetchBundleContents(p),f=JSON.parse(a);k=u.isBuiltin?f.contents?.bundle:f}catch(a){this.f.error(`Failed to load translations for ${u.identifier.value} from ${p}: ${a.message}`);return}k&&this.d.set(u.identifier.value,{contents:k,uri:p})}async g(u){if(u.isBuiltin){const k=await this.a.$fetchBuiltInBundleUri(u.identifier.value,this.b);return P.URI.revive(k)}return u.l10n?P.URI.joinPath(u.extensionLocation,u.l10n,`bundle.l10n.${this.b}.json`):void 0}};e.$Noc=I,e.$Noc=I=Je([Ge(0,$.$bQ),Ge(1,c.$XP),Ge(2,T.$_j)],I),e.$Ooc=(0,R.$Fi)("IExtHostLocalizationService")}),define(Ee[160],ye([1,0,12,6,30,20,2,57]),function(ce,e,r,h,P,R,T,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4pc=void 0;let $=class extends r.$kk{constructor(E,u){super(u.logLevel,u.logsLocation,u.loggers.map(k=>(0,N.$ci)(k))),this.r=E.getProxy(h.$rN.MainThreadLogger)}$setLogLevel(E,u){u?this.setLogLevel(T.URI.revive(u),E):this.setLogLevel(E)}setVisibility(E,u){super.setVisibility(E,u),this.r.$setVisibility(E,u)}s(E,u,k){return new c(this.r,E,u,k)}};e.$4pc=$,e.$4pc=$=Je([Ge(0,R.$XP),Ge(1,P.$bQ)],$);class c extends r.$fk{constructor(E,u,k,p){super(p?.logLevel==="always"),this.r=E,this.s=u,this.m=!1,this.n=[],this.setLevel(k),this.r.$createLogger(u,p).then(()=>{this.u(this.n),this.m=!0})}g(E,u){const k=[[E,u]];this.m?this.u(k):this.n.push(...k)}u(E){this.r.$log(this.s,E)}flush(){this.r.$flush(this.s)}}}),define(Ee[124],ye([1,0,6,5,3,20,22]),function(ce,e,r,h,P,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qoc=e.$Poc=void 0,e.$Poc=(0,h.$Fi)("IExtHostManagedSockets");let N=class{constructor(E){this.b=0,this.c=null,this.d=new Map,this.a=E.getProxy(r.$rN.MainThreadManagedSockets)}setFactory(E,u){for(const k of this.d.values())k.dispose();this.c&&this.a.$unregisterSocketFactory(this.c.socketFactoryId),this.c=new $(E,u),this.a.$registerSocketFactory(this.c.socketFactoryId)}async $openRemoteSocket(E){if(!this.c||this.c.socketFactoryId!==E)throw new Error(`No socket factory with id ${E}`);const u=++this.b,k=await this.c.makeConnection(),p=new P.$Vc;return this.d.set(u,new c(u,k,p)),p.add((0,P.$Uc)(()=>this.d.delete(u))),p.add(k.onDidEnd(()=>{this.a.$onDidManagedSocketEnd(u),p.dispose()})),p.add(k.onDidClose(a=>{this.a.$onDidManagedSocketClose(u,a?.stack??a?.message),p.dispose()})),p.add(k.onDidReceiveMessage(a=>this.a.$onDidManagedSocketHaveData(u,T.$Oe.wrap(a)))),u}$remoteSocketWrite(E,u){this.d.get(E)?.actual.send(u.buffer)}$remoteSocketEnd(E){const u=this.d.get(E);u&&(u.actual.end(),u.dispose())}async $remoteSocketDrain(E){await this.d.get(E)?.actual.drain?.()}};e.$Qoc=N,e.$Qoc=N=Je([Ge(0,R.$XP)],N);class ${constructor(E,u){this.socketFactoryId=E,this.makeConnection=u}}class c extends P.$Wc{constructor(E,u,k){super(),this.socketId=E,this.actual=u,this.B(k)}}}),define(Ee[332],ye([1,0,6,12,26]),function(ce,e,r,h,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$upc=void 0;function R(N){return N&&N.title}let T=class{constructor($,c){this.b=c,this.a=$.getProxy(r.$rN.MainThreadMessageService)}showMessage($,c,I,E,u){const k={source:{identifier:$.identifier,label:$.displayName||$.name}};let p;typeof E=="string"||R(E)?p=[E,...u]:(k.modal=E?.modal,k.useCustom=E?.useCustom,k.detail=E?.detail,p=u),k.useCustom&&(0,P.$4G)($,"resolvers");const a=[];let f=!1;for(let d=0;d<p.length;d++){const m=p[d];if(typeof m=="string")a.push({title:m,handle:d,isCloseAffordance:!1});else if(typeof m=="object"){const{title:n,isCloseAffordance:o}=m;a.push({title:n,isCloseAffordance:!!o,handle:d}),o&&(f?this.b.warn(`[${$.identifier}] Only one message item can have 'isCloseAffordance':`,m):f=!0)}else this.b.warn(`[${$.identifier}] Invalid message item:`,m)}return this.a.$showMessage(c,I,k,a).then(d=>{if(typeof d=="number")return p[d]})}};e.$upc=T,e.$upc=T=Je([Ge(1,h.$_j)],T)}),define(Ee[333],ye([1,0,3,18,2,26,6]),function(ce,e,r,h,P,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dpc=void 0;class N{constructor(c){this.b=new Map,this.a=c.getProxy(T.$rN.MainThreadProfileContentHandlers)}registerProfileContentHandler(c,I,E){if((0,R.$4G)(c,"profileContentHandlers"),this.b.has(I))throw new Error(`Handler with id '${I}' already registered`);return this.b.set(I,E),this.a.$registerProfileContentHandler(I,E.name,E.description,c.identifier.value),(0,r.$Uc)(()=>{this.b.delete(I),this.a.$unregisterProfileContentHandler(I)})}async $saveProfile(c,I,E,u){const k=this.b.get(c);if(!k)throw new Error(`Unknown handler with id: ${c}`);return k.saveProfile(I,E,u)}async $readProfile(c,I,E){const u=this.b.get(c);if(!u)throw new Error(`Unknown handler with id: ${c}`);return u.readProfile((0,h.$fg)(I)?I:P.URI.revive(I),E)}}e.$Dpc=N}),define(Ee[125],ye([1,0,6,4,5]),function(ce,e,r,h,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Loc=e.$Koc=void 0;class R{constructor(N){this.b=new h.$me,this.onDidChangePassword=this.b.event,this.a=N.getProxy(r.$rN.MainThreadSecretState)}async $onDidChangePassword(N){this.b.fire(N)}get(N,$){return this.a.$getPassword(N,$)}store(N,$,c){return this.a.$setPassword(N,$,c)}delete(N,$){return this.a.$deletePassword(N,$)}}e.$Koc=R,e.$Loc=(0,P.$Fi)("IExtHostSecretState")}),define(Ee[334],ye([1,0,21,3,6]),function(ce,e,r,h,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kpc=void 0;class R{static{this.a=1}constructor(N){this.c=new Map,this.d=new Map,this.f=new Map,this.b=N.getProxy(P.$rN.MainThreadSpeech)}async $createSpeechToTextSession(N,$,c){const I=this.c.get(N);if(!I)return;const E=new h.$Vc,u=new r.$xe;this.d.set($,u);const k=await I.provideSpeechToTextSession(u.token,c?{language:c}:void 0);k&&(E.add(k.onDidChange(p=>{u.token.isCancellationRequested||this.b.$emitSpeechToTextEvent($,p)})),E.add(u.token.onCancellationRequested(()=>E.dispose())))}async $cancelSpeechToTextSession(N){this.d.get(N)?.dispose(!0),this.d.delete(N)}async $createTextToSpeechSession(N,$,c){const I=this.c.get(N);if(!I)return;const E=new h.$Vc,u=new r.$xe;this.d.set($,u);const k=await I.provideTextToSpeechSession(u.token,c?{language:c}:void 0);k&&(this.f.set($,k),E.add(k.onDidChange(p=>{u.token.isCancellationRequested||this.b.$emitTextToSpeechEvent($,p)})),E.add(u.token.onCancellationRequested(()=>E.dispose())))}async $synthesizeSpeech(N,$){this.f.get(N)?.synthesize($)}async $cancelTextToSpeechSession(N){this.d.get(N)?.dispose(!0),this.d.delete(N),this.f.delete(N)}async $createKeywordRecognitionSession(N,$){const c=this.c.get(N);if(!c)return;const I=new h.$Vc,E=new r.$xe;this.d.set($,E);const u=await c.provideKeywordRecognitionSession(E.token);u&&(I.add(u.onDidChange(k=>{E.token.isCancellationRequested||this.b.$emitKeywordRecognitionEvent($,k)})),I.add(E.token.onCancellationRequested(()=>I.dispose())))}async $cancelKeywordRecognitionSession(N){this.d.get(N)?.dispose(!0),this.d.delete(N)}registerProvider(N,$,c){const I=R.a++;return this.c.set(I,c),this.b.$registerProvider(I,$,{extension:N,displayName:N.value}),(0,h.$Uc)(()=>{this.b.$unregisterProvider(I),this.c.delete(I)})}}e.$Kpc=R}),define(Ee[126],ye([1,0,6,4,5]),function(ce,e,r,h,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Boc=e.$Aoc=void 0;class R{constructor(N,$){this.c=$,this.b=new h.$me,this.onDidChangeStorage=this.b.event,this.a=N.getProxy(r.$rN.MainThreadStorage)}registerExtensionStorageKeysToSync(N,$){this.a.$registerExtensionStorageKeysToSync(N,$)}async initializeExtensionStorage(N,$,c){const I=await this.a.$initializeExtensionStorage(N,$);let E;return I&&(E=this.d(N,$,I)),E||c}setValue(N,$,c){return this.a.$setValue(N,$,c)}$acceptValue(N,$,c){const I=this.d(N,$,c);I&&this.b.fire({shared:N,key:$,value:I})}d(N,$,c){try{return JSON.parse(c)}catch(I){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${$}, global: ${N}): ${I}`)}}}e.$Aoc=R,e.$Boc=(0,P.$Fi)("IExtHostStorage")}),define(Ee[335],ye([1,0,3,15,2,6]),function(ce,e,r,h,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wpc=void 0;class T{static{this.a=new Set([h.Schemas.http,h.Schemas.https])}constructor($){this.c=new Map,this.b=$.getProxy(R.$rN.MainThreadUriOpeners)}registerExternalUriOpener($,c,I,E){if(this.c.has(c))throw new Error(`Opener with id '${c}' already registered`);const u=E.schemes.find(k=>!T.a.has(k));if(u)throw new Error(`Scheme '${u}' is not supported. Only http and https are currently supported.`);return this.c.set(c,I),this.b.$registerUriOpener(c,E.schemes,$,E.label),(0,r.$Uc)(()=>{this.c.delete(c),this.b.$unregisterUriOpener(c)})}async $canOpenUri($,c,I){const E=this.c.get($);if(!E)throw new Error(`Unknown opener with id: ${$}`);const u=P.URI.revive(c);return E.canOpenExternalUri(u,I)}async $openUri($,c,I){const E=this.c.get($);if(!E)throw new Error(`Unknown opener id: '${$}'`);return E.openExternalUri(P.URI.revive(c.resolvedUri),{sourceUri:P.URI.revive(c.sourceUri)},I)}}e.$Wpc=T}),define(Ee[336],ye([1,0,6,2,3,14,24]),function(ce,e,r,h,P,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xpc=void 0;class N{static{this.a=0}constructor(c){this.c=new T.$rn,this.d=new Map,this.b=c.getProxy(r.$rN.MainThreadUrls)}registerUriHandler(c,I){const E=c.identifier;if(this.c.has(E))throw new Error(`Protocol handler already registered for extension ${E}`);const u=N.a++;return this.c.add(E),this.d.set(u,I),this.b.$registerUriHandler(u,E,c.displayName||c.name),(0,P.$Uc)(()=>{this.c.delete(E),this.d.delete(u),this.b.$unregisterUriHandler(u)})}$handleExternalUri(c,I){const E=this.d.get(c);if(!E)return Promise.resolve(void 0);try{E.handleUri(h.URI.revive(I))}catch(u){(0,R.$3)(u)}return Promise.resolve(void 0)}async createAppUri(c){return h.URI.revive(await this.b.$createAppUri(c))}}e.$Xpc=N}),define(Ee[337],ye([1,0,22,6]),function(ce,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dtb=R,e.$etb=N,h=We(h);class P{constructor(){this.buffers=[]}add(c){let I=this.buffers.indexOf(c);return I<0&&(I=this.buffers.length,this.buffers.push(c)),I}}function R($,c){if(c.serializeBuffersForPostMessage){const I=new P,u=JSON.stringify($,(p,a)=>{if(a instanceof ArrayBuffer)return{$$vscode_array_buffer_reference$$:!0,index:I.add(a)};if(ArrayBuffer.isView(a)){const f=T(a);if(f)return{$$vscode_array_buffer_reference$$:!0,index:I.add(a.buffer),view:{type:f,byteLength:a.byteLength,byteOffset:a.byteOffset}}}return a}),k=I.buffers.map(p=>{const a=new Uint8Array(p);return r.$Oe.wrap(a)});return{message:u,buffers:k}}else return{message:JSON.stringify($),buffers:[]}}function T($){switch($.constructor.name){case"Int8Array":return h.WebviewMessageArrayBufferViewType.Int8Array;case"Uint8Array":return h.WebviewMessageArrayBufferViewType.Uint8Array;case"Uint8ClampedArray":return h.WebviewMessageArrayBufferViewType.Uint8ClampedArray;case"Int16Array":return h.WebviewMessageArrayBufferViewType.Int16Array;case"Uint16Array":return h.WebviewMessageArrayBufferViewType.Uint16Array;case"Int32Array":return h.WebviewMessageArrayBufferViewType.Int32Array;case"Uint32Array":return h.WebviewMessageArrayBufferViewType.Uint32Array;case"Float32Array":return h.WebviewMessageArrayBufferViewType.Float32Array;case"Float64Array":return h.WebviewMessageArrayBufferViewType.Float64Array;case"BigInt64Array":return h.WebviewMessageArrayBufferViewType.BigInt64Array;case"BigUint64Array":return h.WebviewMessageArrayBufferViewType.BigUint64Array}}function N($,c){const I=c.map(k=>{const p=new ArrayBuffer(k.byteLength);return new Uint8Array(p).set(k.buffer),p}),E=c.length?(k,p)=>{if(p&&typeof p=="object"&&p.$$vscode_array_buffer_reference$$){const a=p,{index:f}=a,d=I[f];if(a.view)switch(a.view.type){case h.WebviewMessageArrayBufferViewType.Int8Array:return new Int8Array(d,a.view.byteOffset,a.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case h.WebviewMessageArrayBufferViewType.Uint8Array:return new Uint8Array(d,a.view.byteOffset,a.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case h.WebviewMessageArrayBufferViewType.Uint8ClampedArray:return new Uint8ClampedArray(d,a.view.byteOffset,a.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case h.WebviewMessageArrayBufferViewType.Int16Array:return new Int16Array(d,a.view.byteOffset,a.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case h.WebviewMessageArrayBufferViewType.Uint16Array:return new Uint16Array(d,a.view.byteOffset,a.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case h.WebviewMessageArrayBufferViewType.Int32Array:return new Int32Array(d,a.view.byteOffset,a.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case h.WebviewMessageArrayBufferViewType.Uint32Array:return new Uint32Array(d,a.view.byteOffset,a.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case h.WebviewMessageArrayBufferViewType.Float32Array:return new Float32Array(d,a.view.byteOffset,a.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case h.WebviewMessageArrayBufferViewType.Float64Array:return new Float64Array(d,a.view.byteOffset,a.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case h.WebviewMessageArrayBufferViewType.BigInt64Array:return new BigInt64Array(d,a.view.byteOffset,a.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case h.WebviewMessageArrayBufferViewType.BigUint64Array:return new BigUint64Array(d,a.view.byteOffset,a.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return d}return p}:void 0;return{message:JSON.parse($,E),arrayBuffers:I}}}),define(Ee[97],ye([1,0,4,3,15,25,2,263,337,122,6]),function(ce,e,r,h,P,R,T,N,$,c,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$noc=e.$loc=void 0,e.$moc=u,e.$ooc=a,e.$poc=f,R=We(R),I=We(I);class E{#e;#t;#i;#n;#s;#r;#a;#o;#c;#l;#u;#d;constructor(o,t,i,s,g,l,w){this.#a="",this.#c=!1,this.#l=!1,this._onMessageEmitter=new r.$me,this.onDidReceiveMessage=this._onMessageEmitter.event,this.#h=new r.$me,this._onDidDispose=this.#h.event,this.#e=o,this.#t=t,this.#o=i,this.#n=s,this.#s=g,this.#r=l,this.#u=u(l),this.#d=k(l),this.#i=w}#h;dispose(){this.#c=!0,this.#h.fire(),this.#h.dispose(),this._onMessageEmitter.dispose()}asWebviewUri(o){return this.#l=!0,(0,c.$XCb)(o,this.#n)}get cspSource(){const o=this.#r.extensionLocation;if(o.scheme===P.Schemas.https||o.scheme===P.Schemas.http){let t=o.toString();return t.endsWith("/")||(t+="/"),t+" "+c.$WCb}return c.$WCb}get html(){return this.a(),this.#a}set html(o){this.a(),this.#a!==o&&(this.#a=o,this.#d&&!this.#l&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(o)&&(this.#l=!0,this.#i.report("Webview vscode-resource: uris",this.#r,"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),this.#t.$setHtml(this.#e,this.b(o)))}get options(){return this.a(),this.#o}set options(o){this.a(),R.$fo(this.#o,o)||this.#t.$setOptions(this.#e,f(this.#r,this.#s,o)),this.#o=o}async postMessage(o){if(this.#c)return!1;const t=(0,$.$dtb)(o,{serializeBuffersForPostMessage:this.#u});return this.#t.$postMessage(this.#e,t.message,...t.buffers)}a(){if(this.#c)throw new Error("Webview is disposed")}b(o){if(!this.#d)return o;const t=this.#r.extensionLocation?.scheme===P.Schemas.vscodeRemote,i=this.#r.extensionLocation.scheme===P.Schemas.vscodeRemote?this.#r.extensionLocation.authority:void 0;return o.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(s,g,l,w,S,D)=>{const y=T.URI.from({scheme:w||"file",path:decodeURIComponent(S)}),C=(0,c.$XCb)(y,{isRemote:t,authority:i}).toString();return`${g}${C}${D}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(s,g,l,w,S,D)=>{const y=T.URI.from({scheme:w||"file",path:decodeURIComponent(S)}),C=(0,c.$XCb)(y,{isRemote:t,authority:i}).toString();return`${g}${C}${D}`})}}e.$loc=E;function u(n){try{const o=(0,N.$Vp)((0,N.$Up)(n.engines.vscode));return!!o&&o.majorBase>=1&&o.minorBase>=57}catch{return!1}}function k(n){try{const o=(0,N.$Vp)((0,N.$Up)(n.engines.vscode));return o?o.majorBase<1||o.majorBase===1&&o.minorBase<60:!1}catch{return!1}}class p extends h.$Wc{constructor(o,t,i,s,g){super(),this.c=t,this.f=i,this.g=s,this.h=g,this.b=new Map,this.a=o.getProxy(I.$rN.MainThreadWebviews)}dispose(){super.dispose();for(const o of this.b.values())o.dispose();this.b.clear()}$onMessage(o,t,i){const s=this.j(o);if(s){const{message:g}=(0,$.$etb)(t,i.value);s._onMessageEmitter.fire(g)}}$onMissingCsp(o,t){this.g.warn(`${t} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(o,t,i){const s=new E(o,this.a,d(t),this.c,this.f,i,this.h);this.b.set(o,s);const g=s._onDidDispose(()=>{g.dispose(),this.deleteWebview(o)});return s}deleteWebview(o){this.b.delete(o)}j(o){return this.b.get(o)}}e.$noc=p;function a(n){return{id:n.identifier,location:n.extensionLocation}}function f(n,o,t){return{enableCommandUris:t.enableCommandUris,enableScripts:t.enableScripts,enableForms:t.enableForms,portMapping:t.portMapping,localResourceRoots:t.localResourceRoots||m(n,o)}}function d(n){return{enableCommandUris:n.enableCommandUris,enableScripts:n.enableScripts,enableForms:n.enableForms,portMapping:n.portMapping,localResourceRoots:n.localResourceRoots?.map(o=>T.URI.from(o))}}function m(n,o){return[...(o?.getWorkspaceFolders()||[]).map(t=>t.uri),n.extensionLocation]}}),define(Ee[161],ye([1,0,4,15,13,2,5,20,6]),function(ce,e,r,h,P,R,T,N,$){"use strict";var c;Object.defineProperty(e,"__esModule",{value:!0}),e.$1pc=e.$Zpc=void 0;let I=class{static{c=this}static{this.a={focused:!0,active:!0}}getState(){const u=this.d;return{get focused(){return u.focused},get active(){return u.active}}}constructor(u){this.c=new r.$me,this.onDidChangeWindowState=this.c.event,this.d=c.a,this.b=u.getProxy($.$rN.MainThreadWindow),this.b.$getInitialState().then(({isFocused:k,isActive:p})=>{this.onDidChangeWindowProperty("focused",k),this.onDidChangeWindowProperty("active",p)})}$onDidChangeWindowFocus(u){this.onDidChangeWindowProperty("focused",u)}$onDidChangeWindowActive(u){this.onDidChangeWindowProperty("active",u)}onDidChangeWindowProperty(u,k){k!==this.d[u]&&(this.d={...this.d,[u]:k},this.c.fire(this.d))}openUri(u,k){let p;if(typeof u=="string"){p=u;try{u=R.URI.parse(u)}catch{return Promise.reject(`Invalid uri - '${u}'`)}}return(0,P.$df)(u.scheme)?Promise.reject("Invalid scheme - cannot be empty"):u.scheme===h.Schemas.command?Promise.reject(`Invalid scheme '${u.scheme}'`):this.b.$openUri(u,p,k)}async asExternalUri(u,k){if((0,P.$df)(u.scheme))return Promise.reject("Invalid scheme - cannot be empty");const p=await this.b.$asExternalUri(u,k);return R.URI.from(p)}};e.$Zpc=I,e.$Zpc=I=c=Je([Ge(0,N.$XP)],I),e.$1pc=(0,T.$Fi)("IExtHostWindow")}),define(Ee[338],ye([1,0,327,30,20,94]),function(ce,e,r,h,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dqc=void 0;const T=1024*1024;let N=class extends r.$5pc{constructor(c,I){super(c,I),this.g=!1,this.j("stderr","error"),this.j("stdout","log")}f(c,I,E){const u=c==="error"||c==="warn"?process.stderr:process.stdout;this.g=!0,u.write(`
${R.NativeLogMarkers.Start}
`),I.apply(console,E),u.write(`
${R.NativeLogMarkers.End}
`),this.g=!1}j(c,I){const E=process[c],u=E.write;let k="";Object.defineProperty(E,"write",{set:()=>{},get:()=>(p,a,f)=>{if(!this.g){k+=p.toString(a);const d=k.length>T?k.length:k.lastIndexOf(`
`);d!==-1&&(console[I](k.slice(0,d)),k=k.slice(d+1))}u.call(E,p,a,f)}})}};e.$Dqc=N,e.$Dqc=N=Je([Ge(0,P.$XP),Ge(1,h.$bQ)],N)}),define(Ee[339],ye([1,0,160,15,279,32]),function(ce,e,r,h,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pqc=void 0;class T extends r.$4pc{s($,c,I){return $.scheme===h.Schemas.file?new P.$aR(I?.name||(0,R.$2g)(),$.fsPath,!I?.donotRotate,!!I?.donotUseFormatters,c):super.s($,c,I)}registerLogger($){super.registerLogger($),this.r.$registerLogger($)}deregisterLogger($){super.deregisterLogger($),this.r.$deregisterLogger($)}}e.$Pqc=T}),define(Ee[340],ye([1,0,9,22,21,27,14,4,3,41,142,325,51]),function(ce,e,r,h,P,R,T,N,$,c,I,E,u){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.$tcc=e.ResponsiveState=e.RequestInitiator=void 0,e.$rcc=m,e.$scc=n,T=We(T);function p(L,O){try{return JSON.stringify(L,O)}catch{return"null"}}const a="$$ref$$",f={[a]:-1};class d{constructor(O,M){this.jsonString=O,this.referencedBuffers=M}}function m(L,O=null,M=!1){const j=[];return{jsonString:(M?p:JSON.stringify)(L,(F,B)=>{if(typeof B>"u")return f;if(typeof B=="object"){if(B instanceof h.$Oe){const _=j.push(B)-1;return{[a]:_}}if(O)return O(F,B)}return B}),referencedBuffers:j}}function n(L,O,M){return JSON.parse(L,(j,z)=>{if(z){const F=z[a];if(typeof F=="number")return O[F];if(M&&z.$mid===c.MarshalledId.Uri)return M.transformIncoming(z)}return z})}function o(L,O){return JSON.stringify(L,O)}function t(L){return L?(O,M)=>M&&M.$mid===c.MarshalledId.Uri?L.transformOutgoing(M):M:null}var i;(function(L){L[L.LocalSide=0]="LocalSide",L[L.OtherSide=1]="OtherSide"})(i||(e.RequestInitiator=i={}));var s;(function(L){L[L.Responsive=0]="Responsive",L[L.Unresponsive=1]="Unresponsive"})(s||(e.ResponsiveState=s={}));const g=()=>{},l=Symbol.for("rpcProtocol"),w=Symbol.for("rpcProxy");class S extends $.$Wc{static{k=l}static{this.a=3*1e3}constructor(O,M=null,j=null){super(),this[k]=!0,this.b=this.B(new N.$me),this.onDidChangeResponsiveState=this.b.event,this.c=O,this.f=M,this.g=j,this.h=t(this.g),this.j=!1,this.m=[],this.s=[];for(let z=0,F=u.$Mw.count;z<F;z++)this.m[z]=null,this.s[z]=null;this.t=0,this.u=Object.create(null),this.w={},this.y=s.Responsive,this.z=0,this.C=0,this.D=this.B(new r.$Rh(()=>this.H(),1e3)),this.B(this.c.onMessage(z=>this.L(z)))}dispose(){this.j=!0,Object.keys(this.w).forEach(O=>{const M=this.w[O];delete this.w[O],M.resolveErr(T.$8())}),super.dispose()}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}F(O){this.z===0&&(this.C=Date.now()+S.a),this.z++,this.D.isScheduled()||this.D.schedule()}G(O){this.C=Date.now()+S.a,this.z--,this.z===0&&this.D.cancel(),this.I(s.Responsive)}H(){this.z!==0&&(Date.now()>this.C?this.I(s.Unresponsive):this.D.schedule())}I(O){this.y!==O&&(this.y=O,this.b.fire(this.y))}get responsiveState(){return this.y}transformIncomingURIs(O){return this.g?(0,I.$Mn)(O,this.g):O}getProxy(O){const{nid:M,sid:j}=O;return this.s[M]||(this.s[M]=this.J(M,j)),this.s[M]}J(O,M){const j={get:(z,F)=>(typeof F=="string"&&!z[F]&&F.charCodeAt(0)===R.CharCode.DollarSign&&(z[F]=(...B)=>this.U(O,F,B)),F===w?M:z[F])};return new Proxy(Object.create(null),j)}set(O,M){return this.m[O.nid]=M,M}assertRegistered(O){for(let M=0,j=O.length;M<j;M++){const z=O[M];if(!this.m[z.nid])throw new Error(`Missing proxy instance ${z.sid}`)}}L(O){if(this.j)return;const M=O.byteLength,j=y.read(O,0),z=j.readUInt8(),F=j.readUInt32();switch(z){case b.RequestJSONArgs:case b.RequestJSONArgsWithCancellation:{let{rpcId:B,method:_,args:re}=A.deserializeRequestJSONArgs(j);this.g&&(re=(0,I.$Mn)(re,this.g)),this.M(M,F,B,_,re,z===b.RequestJSONArgsWithCancellation);break}case b.RequestMixedArgs:case b.RequestMixedArgsWithCancellation:{let{rpcId:B,method:_,args:re}=A.deserializeRequestMixedArgs(j);this.g&&(re=(0,I.$Mn)(re,this.g)),this.M(M,F,B,_,re,z===b.RequestMixedArgsWithCancellation);break}case b.Acknowledged:{this.f?.logIncoming(M,F,i.LocalSide,"ack"),this.G(F);break}case b.Cancel:{this.N(M,F);break}case b.ReplyOKEmpty:{this.O(M,F,void 0);break}case b.ReplyOKJSON:{let B=A.deserializeReplyOKJSON(j);this.g&&(B=(0,I.$Mn)(B,this.g)),this.O(M,F,B);break}case b.ReplyOKJSONWithBuffers:{const B=A.deserializeReplyOKJSONWithBuffers(j,this.g);this.O(M,F,B);break}case b.ReplyOKVSBuffer:{const B=A.deserializeReplyOKVSBuffer(j);this.O(M,F,B);break}case b.ReplyErrError:{let B=A.deserializeReplyErrError(j);this.g&&(B=(0,I.$Mn)(B,this.g)),this.P(M,F,B);break}case b.ReplyErrEmpty:{this.P(M,F,void 0);break}default:console.error("received unexpected message"),console.error(O)}}M(O,M,j,z,F,B){this.f?.logIncoming(O,M,i.OtherSide,`receiveRequest ${(0,u.$Ow)(j)}.${z}(`,F);const _=String(M);let re,U;if(B){const Q=new P.$xe;F.push(Q.token),re=this.Q(j,z,F),U=()=>Q.cancel()}else re=this.Q(j,z,F),U=g;this.u[_]=U;const G=A.serializeAcknowledged(M);this.f?.logOutgoing(G.byteLength,M,i.OtherSide,"ack"),this.c.send(G),re.then(Q=>{delete this.u[_];const ee=A.serializeReplyOK(M,Q,this.h);this.f?.logOutgoing(ee.byteLength,M,i.OtherSide,"reply:",Q),this.c.send(ee)},Q=>{delete this.u[_];const ee=A.serializeReplyErr(M,Q);this.f?.logOutgoing(ee.byteLength,M,i.OtherSide,"replyErr:",Q),this.c.send(ee)})}N(O,M){this.f?.logIncoming(O,M,i.OtherSide,"receiveCancel");const j=String(M);this.u[j]?.()}O(O,M,j){this.f?.logIncoming(O,M,i.LocalSide,"receiveReply:",j);const z=String(M);if(!this.w.hasOwnProperty(z))return;const F=this.w[z];delete this.w[z],F.resolveOk(j)}P(O,M,j){this.f?.logIncoming(O,M,i.LocalSide,"receiveReplyErr:",j);const z=String(M);if(!this.w.hasOwnProperty(z))return;const F=this.w[z];delete this.w[z];let B;j&&(j.$isError?(B=new Error,B.name=j.name,B.message=j.message,B.stack=j.stack):B=j),F.resolveErr(B)}Q(O,M,j){try{return Promise.resolve(this.S(O,M,j))}catch(z){return Promise.reject(z)}}S(O,M,j){const z=this.m[O];if(!z)throw new Error("Unknown actor "+(0,u.$Ow)(O));const F=z[M];if(typeof F!="function")throw new Error("Unknown method "+M+" on actor "+(0,u.$Ow)(O));return F.apply(z,j)}U(O,M,j){if(this.j)return new E.$qcc;let z=null;if(j.length>0&&P.CancellationToken.isCancellationToken(j[j.length-1])&&(z=j.pop()),z&&z.isCancellationRequested)return Promise.reject(T.$8());const F=A.serializeRequestArguments(j,this.h),B=++this.t,_=String(B),re=new E.$pcc,U=new $.$Vc;z&&U.add(z.onCancellationRequested(()=>{const Q=A.serializeCancel(B);this.f?.logOutgoing(Q.byteLength,B,i.LocalSide,"cancel"),this.c.send(A.serializeCancel(B))})),this.w[_]=new D(re,U),this.F(B);const G=A.serializeRequest(B,O,M,F,!!z);return this.f?.logOutgoing(G.byteLength,B,i.LocalSide,`request: ${(0,u.$Ow)(O)}.${M}(`,j),this.c.send(G),re}}e.$tcc=S;class D{constructor(O,M){this.a=O,this.b=M}resolveOk(O){this.a.resolveOk(O),this.b.dispose()}resolveErr(O){this.a.resolveErr(O),this.b.dispose()}}class y{static alloc(O,M,j){const z=new y(h.$Oe.alloc(j+1+4),0);return z.writeUInt8(O),z.writeUInt32(M),z}static read(O,M){return new y(O,M)}get buffer(){return this.a}constructor(O,M){this.a=O,this.b=M}static sizeUInt8(){return 1}static{this.sizeUInt32=4}writeUInt8(O){this.a.writeUInt8(O,this.b),this.b+=1}readUInt8(){const O=this.a.readUInt8(this.b);return this.b+=1,O}writeUInt32(O){this.a.writeUInt32BE(O,this.b),this.b+=4}readUInt32(){const O=this.a.readUInt32BE(this.b);return this.b+=4,O}static sizeShortString(O){return 1+O.byteLength}writeShortString(O){this.a.writeUInt8(O.byteLength,this.b),this.b+=1,this.a.set(O,this.b),this.b+=O.byteLength}readShortString(){const O=this.a.readUInt8(this.b);this.b+=1;const j=this.a.slice(this.b,this.b+O).toString();return this.b+=O,j}static sizeLongString(O){return 4+O.byteLength}writeLongString(O){this.a.writeUInt32BE(O.byteLength,this.b),this.b+=4,this.a.set(O,this.b),this.b+=O.byteLength}readLongString(){const O=this.a.readUInt32BE(this.b);this.b+=4;const j=this.a.slice(this.b,this.b+O).toString();return this.b+=O,j}writeBuffer(O){this.a.writeUInt32BE(O.byteLength,this.b),this.b+=4,this.a.set(O,this.b),this.b+=O.byteLength}static sizeVSBuffer(O){return 4+O.byteLength}writeVSBuffer(O){this.a.writeUInt32BE(O.byteLength,this.b),this.b+=4,this.a.set(O,this.b),this.b+=O.byteLength}readVSBuffer(){const O=this.a.readUInt32BE(this.b);this.b+=4;const M=this.a.slice(this.b,this.b+O);return this.b+=O,M}static sizeMixedArray(O){let M=0;M+=1;for(let j=0,z=O.length;j<z;j++){const F=O[j];switch(M+=1,F.type){case v.String:M+=this.sizeLongString(F.value);break;case v.VSBuffer:M+=this.sizeVSBuffer(F.value);break;case v.SerializedObjectWithBuffers:M+=this.sizeUInt32,M+=this.sizeLongString(F.value);for(let B=0;B<F.buffers.length;++B)M+=this.sizeVSBuffer(F.buffers[B]);break;case v.Undefined:break}}return M}writeMixedArray(O){this.a.writeUInt8(O.length,this.b),this.b+=1;for(let M=0,j=O.length;M<j;M++){const z=O[M];switch(z.type){case v.String:this.writeUInt8(v.String),this.writeLongString(z.value);break;case v.VSBuffer:this.writeUInt8(v.VSBuffer),this.writeVSBuffer(z.value);break;case v.SerializedObjectWithBuffers:this.writeUInt8(v.SerializedObjectWithBuffers),this.writeUInt32(z.buffers.length),this.writeLongString(z.value);for(let F=0;F<z.buffers.length;++F)this.writeBuffer(z.buffers[F]);break;case v.Undefined:this.writeUInt8(v.Undefined);break}}}readMixedArray(){const O=this.a.readUInt8(this.b);this.b+=1;const M=new Array(O);for(let j=0;j<O;j++)switch(this.readUInt8()){case v.String:M[j]=this.readLongString();break;case v.VSBuffer:M[j]=this.readVSBuffer();break;case v.SerializedObjectWithBuffers:{const F=this.readUInt32(),B=this.readLongString(),_=[];for(let re=0;re<F;++re)_.push(this.readVSBuffer());M[j]=new u.$Pw(n(B,_,null));break}case v.Undefined:M[j]=void 0;break}return M}}var C;(function(L){L[L.Simple=0]="Simple",L[L.Mixed=1]="Mixed"})(C||(C={}));class A{static a(O){for(let M=0,j=O.length;M<j;M++)if(O[M]instanceof h.$Oe||O[M]instanceof u.$Pw||typeof O[M]>"u")return!0;return!1}static serializeRequestArguments(O,M){if(this.a(O)){const j=[];for(let z=0,F=O.length;z<F;z++){const B=O[z];if(B instanceof h.$Oe)j[z]={type:v.VSBuffer,value:B};else if(typeof B>"u")j[z]={type:v.Undefined};else if(B instanceof u.$Pw){const{jsonString:_,referencedBuffers:re}=m(B.value,M);j[z]={type:v.SerializedObjectWithBuffers,value:h.$Oe.fromString(_),buffers:re}}else j[z]={type:v.String,value:h.$Oe.fromString(o(B,M))}}return{type:C.Mixed,args:j}}return{type:C.Simple,args:o(O,M)}}static serializeRequest(O,M,j,z,F){switch(z.type){case C.Simple:return this.b(O,M,j,z.args,F);case C.Mixed:return this.c(O,M,j,z.args,F)}}static b(O,M,j,z,F){const B=h.$Oe.fromString(j),_=h.$Oe.fromString(z);let re=0;re+=y.sizeUInt8(),re+=y.sizeShortString(B),re+=y.sizeLongString(_);const U=y.alloc(F?b.RequestJSONArgsWithCancellation:b.RequestJSONArgs,O,re);return U.writeUInt8(M),U.writeShortString(B),U.writeLongString(_),U.buffer}static deserializeRequestJSONArgs(O){const M=O.readUInt8(),j=O.readShortString(),z=O.readLongString();return{rpcId:M,method:j,args:JSON.parse(z)}}static c(O,M,j,z,F){const B=h.$Oe.fromString(j);let _=0;_+=y.sizeUInt8(),_+=y.sizeShortString(B),_+=y.sizeMixedArray(z);const re=y.alloc(F?b.RequestMixedArgsWithCancellation:b.RequestMixedArgs,O,_);return re.writeUInt8(M),re.writeShortString(B),re.writeMixedArray(z),re.buffer}static deserializeRequestMixedArgs(O){const M=O.readUInt8(),j=O.readShortString(),z=O.readMixedArray(),F=new Array(z.length);for(let B=0,_=z.length;B<_;B++){const re=z[B];typeof re=="string"?F[B]=JSON.parse(re):F[B]=re}return{rpcId:M,method:j,args:F}}static serializeAcknowledged(O){return y.alloc(b.Acknowledged,O,0).buffer}static serializeCancel(O){return y.alloc(b.Cancel,O,0).buffer}static serializeReplyOK(O,M,j){if(typeof M>"u")return this.d(O);if(M instanceof h.$Oe)return this.e(O,M);if(M instanceof u.$Pw){const{jsonString:z,referencedBuffers:F}=m(M.value,j,!0);return this.g(O,z,F)}else return this.f(O,p(M,j))}static d(O){return y.alloc(b.ReplyOKEmpty,O,0).buffer}static e(O,M){let j=0;j+=y.sizeVSBuffer(M);const z=y.alloc(b.ReplyOKVSBuffer,O,j);return z.writeVSBuffer(M),z.buffer}static deserializeReplyOKVSBuffer(O){return O.readVSBuffer()}static f(O,M){const j=h.$Oe.fromString(M);let z=0;z+=y.sizeLongString(j);const F=y.alloc(b.ReplyOKJSON,O,z);return F.writeLongString(j),F.buffer}static g(O,M,j){const z=h.$Oe.fromString(M);let F=0;F+=y.sizeUInt32,F+=y.sizeLongString(z);for(const _ of j)F+=y.sizeVSBuffer(_);const B=y.alloc(b.ReplyOKJSONWithBuffers,O,F);B.writeUInt32(j.length),B.writeLongString(z);for(const _ of j)B.writeBuffer(_);return B.buffer}static deserializeReplyOKJSON(O){const M=O.readLongString();return JSON.parse(M)}static deserializeReplyOKJSONWithBuffers(O,M){const j=O.readUInt32(),z=O.readLongString(),F=[];for(let B=0;B<j;++B)F.push(O.readVSBuffer());return new u.$Pw(n(z,F,M))}static serializeReplyErr(O,M){const j=M?p(T.$5(M),null):void 0;if(typeof j!="string")return this.h(O);const z=h.$Oe.fromString(j);let F=0;F+=y.sizeLongString(z);const B=y.alloc(b.ReplyErrError,O,F);return B.writeLongString(z),B.buffer}static deserializeReplyErrError(O){const M=O.readLongString();return JSON.parse(M)}static h(O){return y.alloc(b.ReplyErrEmpty,O,0).buffer}}var b;(function(L){L[L.RequestJSONArgs=1]="RequestJSONArgs",L[L.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",L[L.RequestMixedArgs=3]="RequestMixedArgs",L[L.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",L[L.Acknowledged=5]="Acknowledged",L[L.Cancel=6]="Cancel",L[L.ReplyOKEmpty=7]="ReplyOKEmpty",L[L.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",L[L.ReplyOKJSON=9]="ReplyOKJSON",L[L.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",L[L.ReplyErrError=11]="ReplyErrError",L[L.ReplyErrEmpty=12]="ReplyErrEmpty"})(b||(b={}));var v;(function(L){L[L.String=1]="String",L[L.VSBuffer=2]="VSBuffer",L[L.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",L[L.Undefined=4]="Undefined"})(v||(v={}))}),define(Ee[341],ye([1,0,22,29,15,89,5]),function(ce,e,r,h,P,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$QK=e.$NK=void 0,e.$OK=I,e.$PK=E,e.$NK=(0,T.$Fi)("notebookDocumentService");const N=["W","X","Y","Z","a","b","c","d","e","f"],$=new RegExp(`^[${N.join("")}]+`),c=7;function I(k){if(k.scheme!==P.Schemas.vscodeNotebookCell)return;const p=k.fragment.indexOf("s");if(p<0)return;const a=parseInt(k.fragment.substring(0,p).replace($,""),c),f=(0,r.$8e)(k.fragment.substring(p+1)).toString();if(!isNaN(a))return{handle:a,notebook:k.with({scheme:f,fragment:null})}}function E(k,p){const a=p.toString(c),d=`${a.length<N.length?N[a.length-1]:"z"}${a}s${(0,r.$9e)(r.$Oe.fromString(k.scheme),!0,!0)}`;return k.with({scheme:P.Schemas.vscodeNotebookCell,fragment:d})}class u{constructor(){this.a=new h.$Cc}getNotebook(p){if(p.scheme===P.Schemas.vscodeNotebookCell){const a=I(p);if(a){const f=this.a.get(a.notebook);if(f)return f}}return this.a.get(p)}addNotebookDocument(p){this.a.set(p.uri,p)}removeNotebookDocument(p){this.a.delete(p.uri)}}e.$QK=u,(0,R.$Ks)(e.$NK,u,R.InstantiationType.Delayed)}),define(Ee[127],ye([1,0,22,39,40,108,15,16,11,36,341]),function(ce,e,r,h,P,R,T,N,$,c,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yL=e.$vL=e.CellStatusbarAlignment=e.$uL=e.NotebookEditorPriority=e.$rL=e.$qL=e.$oL=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.$nL=e.$mL=e.$lL=e.$kL=e.CellKind=e.$jL=e.$iL=e.$hL=e.$gL=e.$fL=void 0,e.$pL=s,e.$sL=l,e.$tL=w,e.$wL=y,e.$xL=A,h=We(h),e.$fL="workbench.editor.notebook",e.$gL="workbench.editor.notebookTextDiffEditor",e.$hL="workbench.editor.interactive",e.$iL="workbench.editor.repl",e.$jL="replNotebook.input.execute";var E;(function(B){B[B.Markup=1]="Markup",B[B.Code=2]="Code"})(E||(e.CellKind=E={})),e.$kL=["application/json","application/javascript","text/html","image/svg+xml",R.$4s.latex,R.$4s.markdown,"image/png","image/jpeg",R.$4s.text],e.$lL=[R.$4s.latex,R.$4s.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",R.$4s.text],e.$mL=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.$nL="_notAvailable";var u;(function(B){B[B.Running=1]="Running",B[B.Idle=2]="Idle"})(u||(e.NotebookRunState=u={}));var k;(function(B){B[B.Unconfirmed=1]="Unconfirmed",B[B.Pending=2]="Pending",B[B.Executing=3]="Executing"})(k||(e.NotebookCellExecutionState=k={}));var p;(function(B){B[B.Unconfirmed=1]="Unconfirmed",B[B.Pending=2]="Pending",B[B.Executing=3]="Executing"})(p||(e.NotebookExecutionState=p={}));var a;(function(B){B[B.WithHardKernelDependency=0]="WithHardKernelDependency",B[B.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",B[B.Pure=2]="Pure",B[B.Never=3]="Never"})(a||(e.NotebookRendererMatch=a={}));var f;(function(B){B.Always="always",B.Never="never",B.Optional="optional"})(f||(e.RendererMessagingSpec=f={}));var d;(function(B){B[B.ModelChange=1]="ModelChange",B[B.Move=2]="Move",B[B.ChangeCellLanguage=5]="ChangeCellLanguage",B[B.Initialize=6]="Initialize",B[B.ChangeCellMetadata=7]="ChangeCellMetadata",B[B.Output=8]="Output",B[B.OutputItem=9]="OutputItem",B[B.ChangeCellContent=10]="ChangeCellContent",B[B.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",B[B.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",B[B.ChangeCellMime=13]="ChangeCellMime",B[B.Unknown=100]="Unknown"})(d||(e.NotebookCellsChangeType=d={}));var m;(function(B){B[B.Handle=0]="Handle",B[B.Index=1]="Index"})(m||(e.SelectionStateType=m={}));var n;(function(B){B[B.Replace=1]="Replace",B[B.Output=2]="Output",B[B.Metadata=3]="Metadata",B[B.CellLanguage=4]="CellLanguage",B[B.DocumentMetadata=5]="DocumentMetadata",B[B.Move=6]="Move",B[B.OutputItems=7]="OutputItems",B[B.PartialMetadata=8]="PartialMetadata",B[B.PartialInternalMetadata=9]="PartialInternalMetadata"})(n||(e.CellEditType=n={}));var o;(function(B){B.scheme=T.Schemas.vscodeNotebookCell;function _(he,ne){return(0,I.$PK)(he,ne)}B.generate=_;function re(he){return(0,I.$OK)(he)}B.parse=re;function U(he,ne){return he.with({scheme:T.Schemas.vscodeNotebookCellOutput,fragment:`op${ne??""},${he.scheme!==T.Schemas.file?he.scheme:""}`})}B.generateCellOutputUri=U;function G(he){if(he.scheme!==T.Schemas.vscodeNotebookCellOutput)return;const ne=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(he.fragment);if(!ne)return;const De=ne[1]&&ne[1]!==""?ne[1]:void 0,$e=ne[2];return{outputId:De,notebook:he.with({scheme:$e||T.Schemas.file,fragment:null})}}B.parseCellOutputUri=G;function Q(he,ne,De){return B.generate(he,ne).with({scheme:De})}B.generateCellPropertyUri=Q;function ee(he,ne){if(he.scheme===ne)return B.parse(he.with({scheme:B.scheme}))}B.parseCellPropertyUri=ee})(o||(e.CellUri=o={}));const t=B=>$.$i?B.replace(/\//g,"\\"):B;class i{constructor(_=[],re=e.$kL){this.e=re,this.d=[...new Set(_)].map(U=>({pattern:U,matches:h.$zk(t(U))}))}sort(_){const re=new Map(P.Iterable.map(_,G=>[G,t(G)]));let U=[];for(const{matches:G}of this.d)for(const[Q,ee]of re)if(G(ee)){U.push(Q),re.delete(Q);break}return re.size&&(U=U.concat([...re.keys()].sort((G,Q)=>this.e.indexOf(G)-this.e.indexOf(Q)))),U}prioritize(_,re){const U=this.f(_);if(U===-1){this.d.unshift({pattern:_,matches:h.$zk(t(_))});return}const G=new Set(re.map(ee=>this.f(ee,U)));G.delete(-1);const Q=Array.from(G).sort();this.d.splice(U+1,0,...Q.map(ee=>this.d[ee]));for(let ee=Q.length-1;ee>=0;ee--)this.d.splice(Q[ee],1)}toArray(){return this.d.map(_=>_.pattern)}f(_,re=this.d.length){const U=t(_);for(let G=0;G<re;G++)if(this.d[G].matches(U))return G;return-1}}e.$oL=i;function s(B,_,re,U=(G,Q)=>G===Q){const G=[];function Q(ne,De,$e){if(De===0&&$e.length===0)return;const K=G[G.length-1];K&&K.start+K.deleteCount===ne?(K.deleteCount+=De,K.toInsert.push(...$e)):G.push({start:ne,deleteCount:De,toInsert:$e})}let ee=0,he=0;for(;;){if(ee===B.length){Q(ee,0,_.slice(he));break}if(he===_.length){Q(ee,B.length-ee,[]);break}const ne=B[ee],De=_[he];if(U(ne,De)){ee+=1,he+=1;continue}re(De)?(Q(ee,1,[]),ee+=1):(Q(ee,0,[De]),he+=1)}return G}e.$qL=new c.$Wj("notebookEditorCursorAtBoundary","none"),e.$rL=new c.$Wj("notebookEditorCursorAtLineBoundary","none");var g;(function(B){B.default="default",B.option="option"})(g||(e.NotebookEditorPriority=g={}));function l(B){const _=B;return!!((typeof _.include=="string"||h.$Ak(_.include))&&(typeof _.exclude=="string"||h.$Ak(_.exclude)))}function w(B,_,re){if(Array.isArray(B.viewType)&&B.viewType.indexOf(_)>=0||B.viewType===_)return!0;if(B.filenamePattern){const U=l(B.filenamePattern)?B.filenamePattern.include:B.filenamePattern,G=l(B.filenamePattern)?B.filenamePattern.exclude:void 0;if(h.$yk(U,(0,N.$pc)(re.fsPath).toLowerCase()))return!(G&&h.$yk(G,(0,N.$pc)(re.fsPath).toLowerCase()))}return!1}e.$uL={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScrollEnabled:"notebook.stickyScroll.enabled",stickyScrollMode:"notebook.stickyScroll.mode",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",markdownLineHeight:"notebook.markdown.lineHeight",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",LinkifyOutputFilePaths:"notebook.output.linkifyFilePaths",minimalErrorRendering:"notebook.output.minimalErrorRendering",formatOnSave:"notebook.formatOnSave.enabled",insertFinalNewline:"notebook.insertFinalNewline",defaultFormatter:"notebook.defaultFormatter",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findFilters:"notebook.find.filters",findScope:"notebook.experimental.find.scope.enabled",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave",gotoSymbolsAllSymbols:"notebook.gotoSymbols.showAllSymbols",outlineShowMarkdownHeadersOnly:"notebook.outline.showMarkdownHeadersOnly",outlineShowCodeCells:"notebook.outline.showCodeCells",outlineShowCodeCellSymbols:"notebook.outline.showCodeCellSymbols",breadcrumbsShowCodeCells:"notebook.breadcrumbs.showCodeCells",scrollToRevealCell:"notebook.scrolling.revealNextCellOnExecute",cellChat:"notebook.experimental.cellChat",cellGenerate:"notebook.experimental.generate",notebookVariablesView:"notebook.experimental.variablesView",InteractiveWindowPromptToSave:"interactiveWindow.promptToSaveOnClose",cellFailureDiagnostics:"notebook.cellFailureDiagnostics",outputBackupSizeLimit:"notebook.backup.sizeLimit"};var S;(function(B){B[B.Left=1]="Left",B[B.Right=2]="Right"})(S||(e.CellStatusbarAlignment=S={}));class D{static{this.d="notebook/"}static create(_){return`${D.d}${_}`}static parse(_){if(_.startsWith(D.d))return _.substring(D.d.length)}}e.$vL=D;function y(B){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(B)}const C=new TextDecoder;function A(B){const _=[];let re=!1;for(const ee of B)(_.length===0||re)&&(_.push(ee),re=!0);let U=L(_);const G=r.$Oe.concat(_.map(ee=>r.$Oe.wrap(ee))),Q=F(G);return U=U||Q.byteLength!==G.byteLength,{data:Q,didCompression:U}}e.$yL="\x1B[A";const b=e.$yL.split("").map(B=>B.charCodeAt(0)),v=10;function L(B){let _=!1;return B.forEach((re,U)=>{if(U===0||re.length<e.$yL.length)return;const G=B[U-1],Q=re.subarray(0,e.$yL.length);if(Q[0]===b[0]&&Q[1]===b[1]&&Q[2]===b[2]){const ee=G.lastIndexOf(v);if(ee===-1)return;_=!0,B[U-1]=G.subarray(0,ee),B[U]=re.subarray(e.$yL.length)}}),_}function O(B){let _=B;do B=_,_=B.replace(/[^\n]\x08/gm,"");while(_.length<B.length);return B}function M(B){for(B=B.replace(/\r+\n/gm,`
`);B.search(/\r[^$]/g)>-1;){const _=B.match(/^(.*)\r+/m)[1];let re=B.match(/\r+(.*)$/m)[1];re=re+_.slice(re.length,_.length),B=B.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,re)}return B}const j=8,z=13;function F(B){return!B.buffer.includes(j)&&!B.buffer.includes(z)?B:r.$Oe.fromString(M(O(C.decode(B.buffer))))}}),define(Ee[10],ye([1,0,19,14,86,29,108,13,18,2,32,24,28,72,127]),function(ce,e,r,h,P,R,T,N,$,c,I,E,u,k,p){"use strict";var a,f,d,m,n,o,t,i,s,g,l,w,S,D,y,C,A;Object.defineProperty(e,"__esModule",{value:!0}),e.InlineEditTriggerKind=e.$MP=e.KeywordRecognitionStatus=e.TextToSpeechStatus=e.SpeechToTextStatus=e.RelatedInformationType=e.$LP=e.$KP=e.$JP=e.$IP=e.$HP=e.$GP=e.$FP=e.$EP=e.LanguageModelChatMessageRole=e.ChatLocation=e.$DP=e.$CP=e.$BP=e.$AP=e.$zP=e.$yP=e.$xP=e.$wP=e.$vP=e.$uP=e.$tP=e.$sP=e.$rP=e.$qP=e.ChatResultFeedbackKind=e.InteractiveEditorResponseFeedbackKind=e.$pP=e.ChatVariableLevel=e.ChatCopyKind=e.InteractiveSessionVoteDirection=e.$oP=e.$nP=e.$mP=e.$lP=e.$kP=e.$jP=e.$iP=e.$hP=e.$gP=e.$fP=e.$eP=e.$dP=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.$cP=e.$bP=e.$aP=e.$_O=e.$0O=e.$9O=e.$8O=e.$7O=e.TestRunProfileKind=e.TestResultState=e.$6O=e.$5O=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.$4O=e.NotebookVariablesRequestKind=e.$3O=e.$2O=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.$1O=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.$ZO=e.$YO=e.$XO=e.$WO=e.$VO=e.ColorThemeKind=e.$UO=e.$TO=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.$SO=e.$RO=e.DebugConsoleMode=e.$QO=e.$PO=e.$OO=e.$NO=e.$MO=e.CommentThreadApplicability=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.$LO=e.$KO=e.FileChangeType=e.$JO=e.NewSymbolNameTriggerKind=e.NewSymbolNameTag=e.$IO=e.$HO=e.$GO=e.$FO=e.InlineCompletionTriggerKind=e.$EO=e.$DO=e.$CO=e.$BO=e.$AO=e.$zO=e.$yO=e.$xO=e.$wO=e.$vO=e.$uO=e.$sO=e.ConfigurationTarget=e.$rO=e.$qO=e.$pO=e.$oO=e.DocumentPasteTriggerKind=e.$nO=e.$mO=e.$lO=e.$kO=e.$jO=e.$iO=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.$hO=e.ViewBadge=e.ProgressLocation=e.$gO=e.$fO=e.TaskScope=e.ShellQuoting=e.$eO=e.$dO=e.$cO=e.TaskPanelKind=e.TaskRevealKind=e.$bO=e.TerminalLocation=e.$aO=e.$_N=e.$$N=e.TerminalShellExecutionCommandLineConfidence=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.$0N=e.$9N=e.$8N=e.$7N=e.SyntaxTokenType=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.PartialAcceptTriggerKind=e.$5N=e.$4N=e.$3N=e.$2N=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.$1N=e.$ZN=e.InlayHintKind=e.SignatureHelpTriggerKind=e.$YN=e.$XN=e.$WN=e.$VN=e.$UN=e.LanguageStatusSeverity=e.$TN=e.$SN=e.$RN=e.$QN=e.$PN=e.$ON=e.CodeActionTriggerKind=e.$NN=e.$MN=e.SymbolTag=e.SymbolKind=e.$LN=e.$KN=e.DocumentHighlightKind=e.HoverVerbosityAction=e.$JN=e.$IN=e.$HN=e.$GN=e.$FN=e.DiagnosticSeverity=e.DiagnosticTag=e.$EN=e.$DN=e.FileEditType=e.$CN=e.$BN=e.$AN=e.EnvironmentVariableMutatorType=e.EndOfLine=e.$zN=e.$yN=e.$xN=e.$wN=e.$vN=e.$uN=e.$tN=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0,e.$6N=_e,e.$tO=Si,e.$$O=Ai;function b(Z){return Object.assign(Z,{apply:function(...me){if(me.length===0)return Reflect.construct(Z,[]);{const Ne=me.length===1?[]:me[1];return Reflect.construct(Z,Ne,me[0].constructor)}},call:function(...me){if(me.length===0)return Reflect.construct(Z,[]);{const[Ne,...Ye]=me;return Reflect.construct(Z,Ye,Ne.constructor)}}})}var v;(function(Z){Z[Z.Top=0]="Top",Z[Z.Bottom=1]="Bottom"})(v||(e.TerminalOutputAnchor=v={}));var L;(function(Z){Z[Z.TerminalCommand=0]="TerminalCommand",Z[Z.Opener=1]="Opener",Z[Z.Command=3]="Command"})(L||(e.TerminalQuickFixType=L={}));let O=a=class{static from(...H){let me=H;return new a(function(){if(me){for(const Ne of me)Ne&&typeof Ne.dispose=="function"&&Ne.dispose();me=void 0}})}#e;constructor(H){this.#e=H}dispose(){typeof this.#e=="function"&&(this.#e(),this.#e=void 0)}};e.$tN=O,e.$tN=O=a=Je([b],O);let M=f=class{static Min(...H){if(H.length===0)throw new TypeError;let me=H[0];for(let Ne=1;Ne<H.length;Ne++){const Ye=H[Ne];Ye.isBefore(me)&&(me=Ye)}return me}static Max(...H){if(H.length===0)throw new TypeError;let me=H[0];for(let Ne=1;Ne<H.length;Ne++){const Ye=H[Ne];Ye.isAfter(me)&&(me=Ye)}return me}static isPosition(H){if(!H)return!1;if(H instanceof f)return!0;const{line:me,character:Ne}=H;return typeof me=="number"&&typeof Ne=="number"}static of(H){if(H instanceof f)return H;if(this.isPosition(H))return new f(H.line,H.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(H,me){if(H<0)throw(0,h.$9)("line must be non-negative");if(me<0)throw(0,h.$9)("character must be non-negative");this.c=H,this.e=me}isBefore(H){return this.c<H.c?!0:H.c<this.c?!1:this.e<H.e}isBeforeOrEqual(H){return this.c<H.c?!0:H.c<this.c?!1:this.e<=H.e}isAfter(H){return!this.isBeforeOrEqual(H)}isAfterOrEqual(H){return!this.isBefore(H)}isEqual(H){return this.c===H.c&&this.e===H.e}compareTo(H){return this.c<H.c?-1:this.c>H.line?1:this.e<H.e?-1:this.e>H.e?1:0}translate(H,me=0){if(H===null||me===null)throw(0,h.$9)();let Ne;return typeof H>"u"?Ne=0:typeof H=="number"?Ne=H:(Ne=typeof H.lineDelta=="number"?H.lineDelta:0,me=typeof H.characterDelta=="number"?H.characterDelta:0),Ne===0&&me===0?this:new f(this.line+Ne,this.character+me)}with(H,me=this.character){if(H===null||me===null)throw(0,h.$9)();let Ne;return typeof H>"u"?Ne=this.line:typeof H=="number"?Ne=H:(Ne=typeof H.line=="number"?H.line:this.line,me=typeof H.character=="number"?H.character:this.character),Ne===this.line&&me===this.character?this:new f(Ne,me)}toJSON(){return{line:this.line,character:this.character}}};e.$uN=M,e.$uN=M=f=Je([b],M);let j=d=class{static isRange(H){return H instanceof d?!0:H?M.isPosition(H.start)&&M.isPosition(H.end):!1}static of(H){if(H instanceof d)return H;if(this.isRange(H))return new d(H.start,H.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(H,me,Ne,Ye){let st,$t;if(typeof H=="number"&&typeof me=="number"&&typeof Ne=="number"&&typeof Ye=="number"?(st=new M(H,me),$t=new M(Ne,Ye)):M.isPosition(H)&&M.isPosition(me)&&(st=M.of(H),$t=M.of(me)),!st||!$t)throw new Error("Invalid arguments");st.isBefore($t)?(this.c=st,this.e=$t):(this.c=$t,this.e=st)}contains(H){return d.isRange(H)?this.contains(H.start)&&this.contains(H.end):M.isPosition(H)?!(M.of(H).isBefore(this.c)||this.e.isBefore(H)):!1}isEqual(H){return this.c.isEqual(H.c)&&this.e.isEqual(H.e)}intersection(H){const me=M.Max(H.start,this.c),Ne=M.Min(H.end,this.e);if(!me.isAfter(Ne))return new d(me,Ne)}union(H){if(this.contains(H))return this;if(H.contains(this))return H;const me=M.Min(H.start,this.c),Ne=M.Max(H.end,this.end);return new d(me,Ne)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(H,me=this.end){if(H===null||me===null)throw(0,h.$9)();let Ne;return H?M.isPosition(H)?Ne=H:(Ne=H.start||this.start,me=H.end||this.end):Ne=this.start,Ne.isEqual(this.c)&&me.isEqual(this.end)?this:new d(Ne,me)}toJSON(){return[this.start,this.end]}};e.$vN=j,e.$vN=j=d=Je([b],j);let z=m=class extends j{static isSelection(H){return H instanceof m?!0:H?j.isRange(H)&&M.isPosition(H.anchor)&&M.isPosition(H.active)&&typeof H.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(H,me,Ne,Ye){let st,$t;if(typeof H=="number"&&typeof me=="number"&&typeof Ne=="number"&&typeof Ye=="number"?(st=new M(H,me),$t=new M(Ne,Ye)):M.isPosition(H)&&M.isPosition(me)&&(st=M.of(H),$t=M.of(me)),!st||!$t)throw new Error("Invalid arguments");super(st,$t),this.f=st,this.g=$t}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.$wN=z,e.$wN=z=m=Je([b],z);const F=Z=>{if(typeof Z!="string"||Z.length===0||!/^[0-9A-Za-z_\-]+$/.test(Z))throw(0,h.$9)("connectionToken")};class B{static isResolvedAuthority(H){return H&&typeof H=="object"&&typeof H.host=="string"&&typeof H.port=="number"&&(H.connectionToken===void 0||typeof H.connectionToken=="string")}constructor(H,me,Ne){if(typeof H!="string"||H.length===0)throw(0,h.$9)("host");if(typeof me!="number"||me===0||Math.round(me)!==me)throw(0,h.$9)("port");typeof Ne<"u"&&F(Ne),this.host=H,this.port=Math.round(me),this.connectionToken=Ne}}e.$xN=B;class _{static isManagedResolvedAuthority(H){return H&&typeof H=="object"&&typeof H.makeConnection=="function"&&(H.connectionToken===void 0||typeof H.connectionToken=="string")}constructor(H,me){this.makeConnection=H,this.connectionToken=me,typeof me<"u"&&F(me)}}e.$yN=_;class re extends Error{static NotAvailable(H,me){return new re(H,k.RemoteAuthorityResolverErrorCode.NotAvailable,me)}static TemporarilyNotAvailable(H){return new re(H,k.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(H,me=k.RemoteAuthorityResolverErrorCode.Unknown,Ne){super(H),this._message=H,this._code=me,this._detail=Ne,Object.setPrototypeOf(this,re.prototype)}}e.$zN=re;var U;(function(Z){Z[Z.LF=1]="LF",Z[Z.CRLF=2]="CRLF"})(U||(e.EndOfLine=U={}));var G;(function(Z){Z[Z.Replace=1]="Replace",Z[Z.Append=2]="Append",Z[Z.Prepend=3]="Prepend"})(G||(e.EnvironmentVariableMutatorType=G={}));let Q=n=class{static isTextEdit(H){return H instanceof n?!0:H?j.isRange(H)&&typeof H.newText=="string":!1}static replace(H,me){return new n(H,me)}static insert(H,me){return n.replace(new j(H,H),me)}static delete(H){return n.replace(H,"")}static setEndOfLine(H){const me=new n(new j(new M(0,0),new M(0,0)),"");return me.newEol=H,me}get range(){return this.c}set range(H){if(H&&!j.isRange(H))throw(0,h.$9)("range");this.c=H}get newText(){return this.e||""}set newText(H){if(H&&typeof H!="string")throw(0,h.$9)("newText");this.e=H}get newEol(){return this.f}set newEol(H){if(H&&typeof H!="number")throw(0,h.$9)("newEol");this.f=H}constructor(H,me){this.c=H,this.e=me}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};e.$AN=Q,e.$AN=Q=n=Je([b],Q);let ee=o=class{static isNotebookCellEdit(H){return H instanceof o?!0:H?bt.isNotebookRange(H)&&Array.isArray(H.newCells):!1}static replaceCells(H,me){return new o(H,me)}static insertCells(H,me){return new o(new bt(H,H),me)}static deleteCells(H){return new o(H,[])}static updateCellMetadata(H,me){const Ne=new o(new bt(H,H),[]);return Ne.newCellMetadata=me,Ne}static updateNotebookMetadata(H){const me=new o(new bt(0,0),[]);return me.newNotebookMetadata=H,me}constructor(H,me){this.range=H,this.newCells=me}};e.$BN=ee,e.$BN=ee=o=Je([b],ee);class he{static isSnippetTextEdit(H){return H instanceof he?!0:H?j.isRange(H.range)&&$e.isSnippetString(H.snippet):!1}static replace(H,me){return new he(H,me)}static insert(H,me){return he.replace(new j(H,H),me)}constructor(H,me){this.range=H,this.snippet=me}}e.$CN=he;var ne;(function(Z){Z[Z.File=1]="File",Z[Z.Text=2]="Text",Z[Z.Cell=3]="Cell",Z[Z.CellReplace=5]="CellReplace",Z[Z.Snippet=6]="Snippet"})(ne||(e.FileEditType=ne={}));let De=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(H,me,Ne,Ye){this.c.push({_type:ne.File,from:H,to:me,options:Ne,metadata:Ye})}createFile(H,me,Ne){this.c.push({_type:ne.File,from:void 0,to:H,options:me,metadata:Ne})}deleteFile(H,me,Ne){this.c.push({_type:ne.File,from:H,to:void 0,options:me,metadata:Ne})}e(H,me,Ne){this.c.push({_type:ne.Cell,metadata:Ne,uri:H,edit:{editType:p.CellEditType.DocumentMetadata,metadata:me},notebookMetadata:me})}f(H,me,Ne,Ye){const st=me.start,$t=me.end;(st!==$t||Ne.length>0)&&this.c.push({_type:ne.CellReplace,uri:H,index:st,count:$t-st,cells:Ne,metadata:Ye})}g(H,me,Ne,Ye){this.c.push({_type:ne.Cell,metadata:Ye,uri:H,edit:{editType:p.CellEditType.Metadata,index:me,metadata:Ne}})}replace(H,me,Ne,Ye){this.c.push({_type:ne.Text,uri:H,edit:new Q(me,Ne),metadata:Ye})}insert(H,me,Ne,Ye){this.replace(H,new j(me,me),Ne,Ye)}delete(H,me,Ne){this.replace(H,me,"",Ne)}has(H){return this.c.some(me=>me._type===ne.Text&&me.uri.toString()===H.toString())}set(H,me){if(me)for(const Ne of me){if(!Ne)continue;let Ye,st;Array.isArray(Ne)?(Ye=Ne[0],st=Ne[1]):Ye=Ne,ee.isNotebookCellEdit(Ye)?Ye.newCellMetadata?this.g(H,Ye.range.start,Ye.newCellMetadata,st):Ye.newNotebookMetadata?this.e(H,Ye.newNotebookMetadata,st):this.f(H,Ye.range,Ye.newCells,st):he.isSnippetTextEdit(Ye)?this.c.push({_type:ne.Snippet,uri:H,range:Ye.range,edit:Ye.snippet,metadata:st}):this.c.push({_type:ne.Text,uri:H,edit:Ye,metadata:st})}else{for(let Ne=0;Ne<this.c.length;Ne++){const Ye=this.c[Ne];switch(Ye._type){case ne.Text:case ne.Snippet:case ne.Cell:case ne.CellReplace:Ye.uri.toString()===H.toString()&&(this.c[Ne]=void 0);break}}(0,r.$Kb)(this.c)}}get(H){const me=[];for(const Ne of this.c)Ne._type===ne.Text&&Ne.uri.toString()===H.toString()&&me.push(Ne.edit);return me}entries(){const H=new R.$Cc;for(const me of this.c)if(me._type===ne.Text){let Ne=H.get(me.uri);Ne||(Ne=[me.uri,[]],H.set(me.uri,Ne)),Ne[1].push(me.edit)}return[...H.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.$DN=De,e.$DN=De=Je([b],De);let $e=t=class{static isSnippetString(H){return H instanceof t?!0:H?typeof H.value=="string":!1}static c(H){return H.replace(/\$|}|\\/g,"\\$&")}constructor(H){this.e=1,this.value=H||""}appendText(H){return this.value+=t.c(H),this}appendTabstop(H=this.e++){return this.value+="$",this.value+=H,this}appendPlaceholder(H,me=this.e++){if(typeof H=="function"){const Ne=new t;Ne.e=this.e,H(Ne),this.e=Ne.e,H=Ne.value}else H=t.c(H);return this.value+="${",this.value+=me,this.value+=":",this.value+=H,this.value+="}",this}appendChoice(H,me=this.e++){const Ne=H.map(Ye=>Ye.replaceAll(/[|\\,]/g,"\\$&")).join(",");return this.value+="${",this.value+=me,this.value+="|",this.value+=Ne,this.value+="|}",this}appendVariable(H,me){if(typeof me=="function"){const Ne=new t;Ne.e=this.e,me(Ne),this.e=Ne.e,me=Ne.value}else typeof me=="string"&&(me=me.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=H,me&&(this.value+=":",this.value+=me),this.value+="}",this}};e.$EN=$e,e.$EN=$e=t=Je([b],$e);var K;(function(Z){Z[Z.Unnecessary=1]="Unnecessary",Z[Z.Deprecated=2]="Deprecated"})(K||(e.DiagnosticTag=K={}));var W;(function(Z){Z[Z.Hint=3]="Hint",Z[Z.Information=2]="Information",Z[Z.Warning=1]="Warning",Z[Z.Error=0]="Error"})(W||(e.DiagnosticSeverity=W={}));let se=i=class{static isLocation(H){return H instanceof i?!0:H?j.isRange(H.range)&&c.URI.isUri(H.uri):!1}constructor(H,me){if(this.uri=H,me)if(j.isRange(me))this.range=j.of(me);else if(M.isPosition(me))this.range=new j(me,me);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.$FN=se,e.$FN=se=i=Je([b],se);let oe=class{static is(H){return H?typeof H.message=="string"&&H.location&&j.isRange(H.location.range)&&c.URI.isUri(H.location.uri):!1}constructor(H,me){this.location=H,this.message=me}static isEqual(H,me){return H===me?!0:!H||!me?!1:H.message===me.message&&H.location.range.isEqual(me.location.range)&&H.location.uri.toString()===me.location.uri.toString()}};e.$GN=oe,e.$GN=oe=Je([b],oe);let te=class{constructor(H,me,Ne=W.Error){if(!j.isRange(H))throw new TypeError("range must be set");if(!me)throw new TypeError("message must be set");this.range=H,this.message=me,this.severity=Ne}toJSON(){return{severity:W[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(H,me){return H===me?!0:!H||!me?!1:H.message===me.message&&H.severity===me.severity&&H.code===me.code&&H.severity===me.severity&&H.source===me.source&&H.range.isEqual(me.range)&&(0,r.$wb)(H.tags,me.tags)&&(0,r.$wb)(H.relatedInformation,me.relatedInformation,oe.isEqual)}};e.$HN=te,e.$HN=te=Je([b],te);let le=class{constructor(H,me){if(!H)throw new Error("Illegal argument, contents must be defined");Array.isArray(H)?this.contents=H:this.contents=[H],this.range=me}};e.$IN=le,e.$IN=le=Je([b],le);let ue=class extends le{constructor(H,me,Ne,Ye){super(H,me),this.canIncreaseHover=Ne,this.canDecreaseHover=Ye}};e.$JN=ue,e.$JN=ue=Je([b],ue);var X;(function(Z){Z[Z.Increase=0]="Increase",Z[Z.Decrease=1]="Decrease"})(X||(e.HoverVerbosityAction=X={}));var ae;(function(Z){Z[Z.Text=0]="Text",Z[Z.Read=1]="Read",Z[Z.Write=2]="Write"})(ae||(e.DocumentHighlightKind=ae={}));let pe=class{constructor(H,me=ae.Text){this.range=H,this.kind=me}toJSON(){return{range:this.range,kind:ae[this.kind]}}};e.$KN=pe,e.$KN=pe=Je([b],pe);let be=class{constructor(H,me){this.uri=H,this.highlights=me}toJSON(){return{uri:this.uri,highlights:this.highlights.map(H=>H.toJSON())}}};e.$LN=be,e.$LN=be=Je([b],be);var Fe;(function(Z){Z[Z.File=0]="File",Z[Z.Module=1]="Module",Z[Z.Namespace=2]="Namespace",Z[Z.Package=3]="Package",Z[Z.Class=4]="Class",Z[Z.Method=5]="Method",Z[Z.Property=6]="Property",Z[Z.Field=7]="Field",Z[Z.Constructor=8]="Constructor",Z[Z.Enum=9]="Enum",Z[Z.Interface=10]="Interface",Z[Z.Function=11]="Function",Z[Z.Variable=12]="Variable",Z[Z.Constant=13]="Constant",Z[Z.String=14]="String",Z[Z.Number=15]="Number",Z[Z.Boolean=16]="Boolean",Z[Z.Array=17]="Array",Z[Z.Object=18]="Object",Z[Z.Key=19]="Key",Z[Z.Null=20]="Null",Z[Z.EnumMember=21]="EnumMember",Z[Z.Struct=22]="Struct",Z[Z.Event=23]="Event",Z[Z.Operator=24]="Operator",Z[Z.TypeParameter=25]="TypeParameter"})(Fe||(e.SymbolKind=Fe={}));var Ue;(function(Z){Z[Z.Deprecated=1]="Deprecated"})(Ue||(e.SymbolTag=Ue={}));let ke=s=class{static validate(H){if(!H.name)throw new Error("name must not be falsy")}constructor(H,me,Ne,Ye,st){this.name=H,this.kind=me,this.containerName=st,typeof Ne=="string"&&(this.containerName=Ne),Ye instanceof se?this.location=Ye:Ne instanceof j&&(this.location=new se(Ye,Ne)),s.validate(this)}toJSON(){return{name:this.name,kind:Fe[this.kind],location:this.location,containerName:this.containerName}}};e.$MN=ke,e.$MN=ke=s=Je([b],ke);let Ie=g=class{static validate(H){if(!H.name)throw new Error("name must not be falsy");if(!H.range.contains(H.selectionRange))throw new Error("selectionRange must be contained in fullRange");H.children?.forEach(g.validate)}constructor(H,me,Ne,Ye,st){this.name=H,this.detail=me,this.kind=Ne,this.range=Ye,this.selectionRange=st,this.children=[],g.validate(this)}};e.$NN=Ie,e.$NN=Ie=g=Je([b],Ie);var Re;(function(Z){Z[Z.Invoke=1]="Invoke",Z[Z.Automatic=2]="Automatic"})(Re||(e.CodeActionTriggerKind=Re={}));let q=class{constructor(H,me){this.title=H,this.kind=me}};e.$ON=q,e.$ON=q=Je([b],q);let V=class{static{l=this}static{this.c="."}constructor(H){this.value=H}append(H){return new l(this.value?this.value+l.c+H:H)}intersects(H){return this.contains(H)||H.contains(this)}contains(H){return this.value===H.value||H.value.startsWith(this.value+l.c)}};e.$PN=V,e.$PN=V=l=Je([b],V),V.Empty=new V(""),V.QuickFix=V.Empty.append("quickfix"),V.Refactor=V.Empty.append("refactor"),V.RefactorExtract=V.Refactor.append("extract"),V.RefactorInline=V.Refactor.append("inline"),V.RefactorMove=V.Refactor.append("move"),V.RefactorRewrite=V.Refactor.append("rewrite"),V.Source=V.Empty.append("source"),V.SourceOrganizeImports=V.Source.append("organizeImports"),V.SourceFixAll=V.Source.append("fixAll"),V.Notebook=V.Empty.append("notebook");let J=class{constructor(H,me){if(this.range=H,this.parent=me,me&&!me.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.$QN=J,e.$QN=J=Je([b],J);class x{constructor(H,me,Ne,Ye,st,$t){this.kind=H,this.name=me,this.detail=Ne,this.uri=Ye,this.range=st,this.selectionRange=$t}}e.$RN=x;class fe{constructor(H,me){this.fromRanges=me,this.from=H}}e.$SN=fe;class we{constructor(H,me){this.fromRanges=me,this.to=H}}e.$TN=we;var Le;(function(Z){Z[Z.Information=0]="Information",Z[Z.Warning=1]="Warning",Z[Z.Error=2]="Error"})(Le||(e.LanguageStatusSeverity=Le={}));let He=class{constructor(H,me){this.range=H,this.command=me}get isResolved(){return!!this.command}};e.$UN=He,e.$UN=He=Je([b],He);let Ke=w=class{#e;static isMarkdownString(H){return H instanceof w?!0:H&&H.appendCodeblock&&H.appendMarkdown&&H.appendText&&H.value!==void 0}constructor(H,me=!1){this.#e=new P.$3k(H,{supportThemeIcons:me})}get value(){return this.#e.value}set value(H){this.#e.value=H}get isTrusted(){return this.#e.isTrusted}set isTrusted(H){this.#e.isTrusted=H}get supportThemeIcons(){return this.#e.supportThemeIcons}set supportThemeIcons(H){this.#e.supportThemeIcons=H}get supportHtml(){return this.#e.supportHtml}set supportHtml(H){this.#e.supportHtml=H}get baseUri(){return this.#e.baseUri}set baseUri(H){this.#e.baseUri=H}appendText(H){return this.#e.appendText(H),this}appendMarkdown(H){return this.#e.appendMarkdown(H),this}appendCodeblock(H,me){return this.#e.appendCodeblock(me??"",H),this}};e.$VN=Ke,e.$VN=Ke=w=Je([b],Ke);let et=class{constructor(H,me){this.label=H,this.documentation=me}};e.$WN=et,e.$WN=et=Je([b],et);let rt=class{constructor(H,me){this.label=H,this.documentation=me,this.parameters=[]}};e.$XN=rt,e.$XN=rt=Je([b],rt);let ot=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.$YN=ot,e.$YN=ot=Je([b],ot);var nt;(function(Z){Z[Z.Invoke=1]="Invoke",Z[Z.TriggerCharacter=2]="TriggerCharacter",Z[Z.ContentChange=3]="ContentChange"})(nt||(e.SignatureHelpTriggerKind=nt={}));var ct;(function(Z){Z[Z.Type=1]="Type",Z[Z.Parameter=2]="Parameter"})(ct||(e.InlayHintKind=ct={}));let mt=class{constructor(H){this.value=H}};e.$ZN=mt,e.$ZN=mt=Je([b],mt);let dt=class{constructor(H,me,Ne){this.position=H,this.label=me,this.kind=Ne}};e.$1N=dt,e.$1N=dt=Je([b],dt);var at;(function(Z){Z[Z.Invoke=0]="Invoke",Z[Z.TriggerCharacter=1]="TriggerCharacter",Z[Z.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(at||(e.CompletionTriggerKind=at={}));var Pe;(function(Z){Z[Z.Text=0]="Text",Z[Z.Method=1]="Method",Z[Z.Function=2]="Function",Z[Z.Constructor=3]="Constructor",Z[Z.Field=4]="Field",Z[Z.Variable=5]="Variable",Z[Z.Class=6]="Class",Z[Z.Interface=7]="Interface",Z[Z.Module=8]="Module",Z[Z.Property=9]="Property",Z[Z.Unit=10]="Unit",Z[Z.Value=11]="Value",Z[Z.Enum=12]="Enum",Z[Z.Keyword=13]="Keyword",Z[Z.Snippet=14]="Snippet",Z[Z.Color=15]="Color",Z[Z.File=16]="File",Z[Z.Reference=17]="Reference",Z[Z.Folder=18]="Folder",Z[Z.EnumMember=19]="EnumMember",Z[Z.Constant=20]="Constant",Z[Z.Struct=21]="Struct",Z[Z.Event=22]="Event",Z[Z.Operator=23]="Operator",Z[Z.TypeParameter=24]="TypeParameter",Z[Z.User=25]="User",Z[Z.Issue=26]="Issue"})(Pe||(e.CompletionItemKind=Pe={}));var ze;(function(Z){Z[Z.Deprecated=1]="Deprecated"})(ze||(e.CompletionItemTag=ze={}));let Ze=class{constructor(H,me){this.label=H,this.kind=me}toJSON(){return{label:this.label,kind:this.kind&&Pe[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.$2N=Ze,e.$2N=Ze=Je([b],Ze);let Te=class{constructor(H=[],me=!1){this.items=H,this.isIncomplete=me}};e.$3N=Te,e.$3N=Te=Je([b],Te);let Me=class{constructor(H,me,Ne){this.insertText=H,this.range=me,this.command=Ne}};e.$4N=Me,e.$4N=Me=Je([b],Me);let Y=class{constructor(H){this.commands=void 0,this.suppressSuggestions=void 0,this.items=H}};e.$5N=Y,e.$5N=Y=Je([b],Y);var de;(function(Z){Z[Z.Unknown=0]="Unknown",Z[Z.Word=1]="Word",Z[Z.Line=2]="Line",Z[Z.Suggest=3]="Suggest"})(de||(e.PartialAcceptTriggerKind=de={}));var Ae;(function(Z){Z[Z.Active=-1]="Active",Z[Z.Beside=-2]="Beside",Z[Z.One=1]="One",Z[Z.Two=2]="Two",Z[Z.Three=3]="Three",Z[Z.Four=4]="Four",Z[Z.Five=5]="Five",Z[Z.Six=6]="Six",Z[Z.Seven=7]="Seven",Z[Z.Eight=8]="Eight",Z[Z.Nine=9]="Nine"})(Ae||(e.ViewColumn=Ae={}));var Xe;(function(Z){Z[Z.Left=1]="Left",Z[Z.Right=2]="Right"})(Xe||(e.StatusBarAlignment=Xe={}));function _e(Z,H){return`${E.$qn.toKey(Z)}.${H}`}var ut;(function(Z){Z[Z.Off=0]="Off",Z[Z.On=1]="On",Z[Z.Relative=2]="Relative",Z[Z.Interval=3]="Interval"})(ut||(e.TextEditorLineNumbersStyle=ut={}));var gt;(function(Z){Z[Z.Manual=1]="Manual",Z[Z.AfterDelay=2]="AfterDelay",Z[Z.FocusOut=3]="FocusOut"})(gt||(e.TextDocumentSaveReason=gt={}));var kt;(function(Z){Z[Z.Default=0]="Default",Z[Z.InCenter=1]="InCenter",Z[Z.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",Z[Z.AtTop=3]="AtTop"})(kt||(e.TextEditorRevealType=kt={}));var Lt;(function(Z){Z[Z.Keyboard=1]="Keyboard",Z[Z.Mouse=2]="Mouse",Z[Z.Command=3]="Command"})(Lt||(e.TextEditorSelectionChangeKind=Lt={}));var Bt;(function(Z){Z[Z.Undo=1]="Undo",Z[Z.Redo=2]="Redo"})(Bt||(e.TextDocumentChangeReason=Bt={}));var di;(function(Z){Z[Z.OpenOpen=0]="OpenOpen",Z[Z.ClosedClosed=1]="ClosedClosed",Z[Z.OpenClosed=2]="OpenClosed",Z[Z.ClosedOpen=3]="ClosedOpen"})(di||(e.DecorationRangeBehavior=di={})),function(Z){function H(me){switch(me){case"keyboard":return Z.Keyboard;case"mouse":return Z.Mouse;case"api":return Z.Command}}Z.fromValue=H}(Lt||(e.TextEditorSelectionChangeKind=Lt={}));var it;(function(Z){Z[Z.Other=0]="Other",Z[Z.Comment=1]="Comment",Z[Z.String=2]="String",Z[Z.RegEx=3]="RegEx"})(it||(e.SyntaxTokenType=it={})),function(Z){function H(me){switch(me){case Z.Other:return"other";case Z.Comment:return"comment";case Z.String:return"string";case Z.RegEx:return"regex"}return"other"}Z.toString=H}(it||(e.SyntaxTokenType=it={}));let At=class{constructor(H,me){if(me&&!c.URI.isUri(me))throw(0,h.$9)("target");if(!j.isRange(H)||H.isEmpty)throw(0,h.$9)("range");this.range=H,this.target=me}};e.$7N=At,e.$7N=At=Je([b],At);let Zt=class{constructor(H,me,Ne,Ye){this.red=H,this.green=me,this.blue=Ne,this.alpha=Ye}};e.$8N=Zt,e.$8N=Zt=Je([b],Zt);let Kt=class{constructor(H,me){if(me&&!(me instanceof Zt))throw(0,h.$9)("color");if(!j.isRange(H)||H.isEmpty)throw(0,h.$9)("range");this.range=H,this.color=me}};e.$9N=Kt,e.$9N=Kt=Je([b],Kt);let pt=class{constructor(H){if(!H||typeof H!="string")throw(0,h.$9)("label");this.label=H}};e.$0N=pt,e.$0N=pt=Je([b],pt);var vt;(function(Z){Z[Z.RGB=0]="RGB",Z[Z.HEX=1]="HEX",Z[Z.HSL=2]="HSL"})(vt||(e.ColorFormat=vt={}));var ii;(function(Z){Z[Z.Error=0]="Error",Z[Z.Warning=1]="Warning",Z[Z.Information=2]="Information"})(ii||(e.SourceControlInputBoxValidationType=ii={}));var xt;(function(Z){Z[Z.Unknown=0]="Unknown",Z[Z.Shutdown=1]="Shutdown",Z[Z.Process=2]="Process",Z[Z.User=3]="User",Z[Z.Extension=4]="Extension"})(xt||(e.TerminalExitReason=xt={}));var Vt;(function(Z){Z[Z.Low=0]="Low",Z[Z.Medium=1]="Medium",Z[Z.High=2]="High"})(Vt||(e.TerminalShellExecutionCommandLineConfidence=Vt={}));class Et{constructor(H,me,Ne){if(this.startIndex=H,this.length=me,this.tooltip=Ne,typeof H!="number"||H<0)throw(0,h.$9)("startIndex");if(typeof me!="number"||me<1)throw(0,h.$9)("length");if(Ne!==void 0&&typeof Ne!="string")throw(0,h.$9)("tooltip")}}e.$$N=Et;class Ft{constructor(H){this.uri=H}}e.$_N=Ft;class li{constructor(H){this.terminalCommand=H}}e.$aO=li;var Gt;(function(Z){Z[Z.Panel=1]="Panel",Z[Z.Editor=2]="Editor"})(Gt||(e.TerminalLocation=Gt={}));class xe{constructor(H){if(this.options=H,typeof H!="object")throw(0,h.$9)("options")}}e.$bO=xe;var _t;(function(Z){Z[Z.Always=1]="Always",Z[Z.Silent=2]="Silent",Z[Z.Never=3]="Never"})(_t||(e.TaskRevealKind=_t={}));var ni;(function(Z){Z[Z.Shared=1]="Shared",Z[Z.Dedicated=2]="Dedicated",Z[Z.New=3]="New"})(ni||(e.TaskPanelKind=ni={}));let ui=class{static{S=this}static{this.Clean=new S("clean","Clean")}static{this.Build=new S("build","Build")}static{this.Rebuild=new S("rebuild","Rebuild")}static{this.Test=new S("test","Test")}static from(H){switch(H){case"clean":return S.Clean;case"build":return S.Build;case"rebuild":return S.Rebuild;case"test":return S.Test;default:return}}constructor(H,me){if(this.label=me,typeof H!="string"||typeof me!="string")throw(0,h.$9)("name");this.c=H}get id(){return this.c}};e.$cO=ui,e.$cO=ui=S=Je([b],ui);function It(Z){let H="";for(let me=0;me<Z.length;me++)H+=Z[me].replace(/,/g,",,")+",";return H}let Mt=class{constructor(H,me,Ne){if(typeof H!="string")throw(0,h.$9)("process");this.e=[],this.c=H,me!==void 0&&(Array.isArray(me)?(this.e=me,this.f=Ne):this.f=me)}get process(){return this.c}set process(H){if(typeof H!="string")throw(0,h.$9)("process");this.c=H}get args(){return this.e}set args(H){Array.isArray(H)||(H=[]),this.e=H}get options(){return this.f}set options(H){this.f=H}computeId(){const H=[];if(H.push("process"),this.c!==void 0&&H.push(this.c),this.e&&this.e.length>0)for(const me of this.e)H.push(me);return It(H)}};e.$dO=Mt,e.$dO=Mt=Je([b],Mt);let Nt=class{constructor(H,me,Ne){if(this.f=[],Array.isArray(me)){if(!H)throw(0,h.$9)("command can't be undefined or null");if(typeof H!="string"&&typeof H.value!="string")throw(0,h.$9)("command");this.e=H,this.f=me,this.g=Ne}else{if(typeof H!="string")throw(0,h.$9)("commandLine");this.c=H,this.g=me}}get commandLine(){return this.c}set commandLine(H){if(typeof H!="string")throw(0,h.$9)("commandLine");this.c=H}get command(){return this.e?this.e:""}set command(H){if(typeof H!="string"&&typeof H.value!="string")throw(0,h.$9)("command");this.e=H}get args(){return this.f}set args(H){this.f=H||[]}get options(){return this.g}set options(H){this.g=H}computeId(){const H=[];if(H.push("shell"),this.c!==void 0&&H.push(this.c),this.e!==void 0&&H.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const me of this.f)H.push(typeof me=="string"?me:me.value);return It(H)}};e.$eO=Nt,e.$eO=Nt=Je([b],Nt);var Ut;(function(Z){Z[Z.Escape=1]="Escape",Z[Z.Strong=2]="Strong",Z[Z.Weak=3]="Weak"})(Ut||(e.ShellQuoting=Ut={}));var ri;(function(Z){Z[Z.Global=1]="Global",Z[Z.Workspace=2]="Workspace"})(ri||(e.TaskScope=ri={}));class ei{constructor(H){this.c=H}computeId(){return"customExecution"+(0,I.$2g)()}set callback(H){this.c=H}get callback(){return this.c}}e.$fO=ei;let si=class{static{D=this}static{this.c="customExecution"}static{this.e="process"}static{this.f="shell"}static{this.g="$empty"}constructor(H,me,Ne,Ye,st,$t){this.k=!1,this.l=this.definition=H;let yt;typeof me=="string"?(this.o=this.name=me,this.w=this.source=Ne,this.execution=Ye,yt=st,this.k=!0):me===ri.Global||me===ri.Workspace?(this.target=me,this.o=this.name=Ne,this.w=this.source=Ye,this.execution=st,yt=$t):(this.target=me,this.o=this.name=Ne,this.w=this.source=Ye,this.execution=st,yt=$t),typeof yt=="string"?(this.r=[yt],this.t=!0):Array.isArray(yt)?(this.r=yt,this.t=!0):(this.r=[],this.t=!1),this.u=!1,this.y=Object.create(null),this.z=Object.create(null)}get _id(){return this.j}set _id(H){this.j=H}get _deprecated(){return this.k}B(){this.j!==void 0&&(this.j=void 0,this.m=void 0,this.C())}C(){this.q instanceof Mt?this.l={type:D.e,id:this.q.computeId()}:this.q instanceof Nt?this.l={type:D.f,id:this.q.computeId()}:this.q instanceof ei?this.l={type:D.c,id:this.q.computeId()}:this.l={type:D.g,id:(0,I.$2g)()}}get definition(){return this.l}set definition(H){if(H==null)throw(0,h.$9)("Kind can't be undefined or null");this.B(),this.l=H}get scope(){return this.m}set target(H){this.B(),this.m=H}get name(){return this.o}set name(H){if(typeof H!="string")throw(0,h.$9)("name");this.B(),this.o=H}get execution(){return this.q}set execution(H){H===null&&(H=void 0),this.B(),this.q=H;const me=this.l.type;(D.g===me||D.e===me||D.f===me||D.c===me)&&this.C()}get problemMatchers(){return this.r}set problemMatchers(H){if(Array.isArray(H))this.B(),this.r=H,this.t=!0;else{this.B(),this.r=[],this.t=!1;return}}get hasDefinedMatchers(){return this.t}get isBackground(){return this.u}set isBackground(H){H!==!0&&H!==!1&&(H=!1),this.B(),this.u=H}get source(){return this.w}set source(H){if(typeof H!="string"||H.length===0)throw(0,h.$9)("source must be a string of length > 0");this.B(),this.w=H}get group(){return this.x}set group(H){H===null&&(H=void 0),this.B(),this.x=H}get detail(){return this.A}set detail(H){H===null&&(H=void 0),this.A=H}get presentationOptions(){return this.y}set presentationOptions(H){H==null&&(H=Object.create(null)),this.B(),this.y=H}get runOptions(){return this.z}set runOptions(H){H==null&&(H=Object.create(null)),this.B(),this.z=H}};e.$gO=si,e.$gO=si=D=Je([b],si);var Wt;(function(Z){Z[Z.SourceControl=1]="SourceControl",Z[Z.Window=10]="Window",Z[Z.Notification=15]="Notification"})(Wt||(e.ProgressLocation=Wt={}));var Qt;(function(Z){function H(me){const Ne=me;return(0,$.$jg)(Ne.value)?Ne.tooltip&&!(0,$.$fg)(Ne.tooltip)?(console.log("INVALID view badge, invalid tooltip",Ne.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",Ne.value),!1)}Z.isViewBadge=H})(Qt||(e.ViewBadge=Qt={}));let oi=y=class{static isTreeItem(H,me){const Ne=H;if(Ne.checkboxState!==void 0){const Ye=(0,$.$jg)(Ne.checkboxState)?Ne.checkboxState:(0,$.$hg)(Ne.checkboxState)&&(0,$.$jg)(Ne.checkboxState.state)?Ne.checkboxState.state:void 0,st=!(0,$.$jg)(Ne.checkboxState)&&(0,$.$hg)(Ne.checkboxState)?Ne.checkboxState.tooltip:void 0;if(Ye===void 0||Ye!==Dt.Checked&&Ye!==Dt.Unchecked||st!==void 0&&!(0,$.$fg)(st))return console.log("INVALID tree item, invalid checkboxState",Ne.checkboxState),!1}if(H instanceof y)return!0;if(Ne.label!==void 0&&!(0,$.$fg)(Ne.label)&&!Ne.label?.label)return console.log("INVALID tree item, invalid label",Ne.label),!1;if(Ne.id!==void 0&&!(0,$.$fg)(Ne.id))return console.log("INVALID tree item, invalid id",Ne.id),!1;if(Ne.iconPath!==void 0&&!(0,$.$fg)(Ne.iconPath)&&!c.URI.isUri(Ne.iconPath)&&(!Ne.iconPath||!(0,$.$fg)(Ne.iconPath.id))){const Ye=Ne.iconPath;if(!Ye||!(0,$.$fg)(Ye.light)&&!c.URI.isUri(Ye.light)&&!(0,$.$fg)(Ye.dark)&&!c.URI.isUri(Ye.dark))return console.log("INVALID tree item, invalid iconPath",Ne.iconPath),!1}return Ne.description!==void 0&&!(0,$.$fg)(Ne.description)&&typeof Ne.description!="boolean"?(console.log("INVALID tree item, invalid description",Ne.description),!1):Ne.resourceUri!==void 0&&!c.URI.isUri(Ne.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",Ne.resourceUri),!1):Ne.tooltip!==void 0&&!(0,$.$fg)(Ne.tooltip)&&!(Ne.tooltip instanceof Ke)?(console.log("INVALID tree item, invalid tooltip",Ne.tooltip),!1):Ne.command!==void 0&&!Ne.command.command?(console.log("INVALID tree item, invalid command",Ne.command),!1):Ne.collapsibleState!==void 0&&Ne.collapsibleState<Rt.None&&Ne.collapsibleState>Rt.Expanded?(console.log("INVALID tree item, invalid collapsibleState",Ne.collapsibleState),!1):Ne.contextValue!==void 0&&!(0,$.$fg)(Ne.contextValue)?(console.log("INVALID tree item, invalid contextValue",Ne.contextValue),!1):Ne.accessibilityInformation!==void 0&&!Ne.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",Ne.accessibilityInformation),!1):!0}constructor(H,me=Rt.None){this.collapsibleState=me,c.URI.isUri(H)?this.resourceUri=H:this.label=H}};e.$hO=oi,e.$hO=oi=y=Je([b],oi);var Rt;(function(Z){Z[Z.None=0]="None",Z[Z.Collapsed=1]="Collapsed",Z[Z.Expanded=2]="Expanded"})(Rt||(e.TreeItemCollapsibleState=Rt={}));var Dt;(function(Z){Z[Z.Unchecked=0]="Unchecked",Z[Z.Checked=1]="Checked"})(Dt||(e.TreeItemCheckboxState=Dt={}));let wt=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(H){this.value=H}};e.$iO=wt,e.$iO=wt=Je([b],wt);class ti extends wt{}e.$jO=ti;class Pt extends ti{#e;constructor(H){super(""),this.#e=H}asFile(){return this.#e}}e.$kO=Pt;class hi{constructor(H,me,Ne,Ye){this.name=H,this.uri=me,this._itemId=Ne,this.c=Ye}data(){return this.c()}}e.$lO=hi;let Ht=class{#e=new Map;constructor(H){for(const[me,Ne]of H??[]){const Ye=this.#e.get(this.#t(me));Ye?Ye.push(Ne):this.#e.set(this.#t(me),[Ne])}}get(H){return this.#e.get(this.#t(H))?.[0]}set(H,me){this.#e.set(this.#t(H),[me])}forEach(H,me){for(const[Ne,Ye]of this.#e)for(const st of Ye)H.call(me,st,Ne,this)}*[Symbol.iterator](){for(const[H,me]of this.#e)for(const Ne of me)yield[H,Ne]}#t(H){return H.toLowerCase()}};e.$mO=Ht,e.$mO=Ht=Je([b],Ht);let bi=class{constructor(H,me,Ne){this.insertText=H,this.title=me,this.kind=Ne}};e.$nO=bi,e.$nO=bi=Je([b],bi);var wi;(function(Z){Z[Z.Automatic=0]="Automatic",Z[Z.PasteAs=1]="PasteAs"})(wi||(e.DocumentPasteTriggerKind=wi={}));class fi{static{this.c="."}constructor(H){this.value=H}append(...H){return new fi((this.value?[this.value,...H]:H).join(fi.c))}intersects(H){return this.contains(H)||H.contains(this)}contains(H){return this.value===H.value||H.value.startsWith(this.value+fi.c)}}e.$oO=fi,fi.Empty=new fi("");class qt{constructor(H,me,Ne){this.title=me,this.insertText=H,this.kind=Ne}}e.$pO=qt;let ai=class{constructor(H,me){this.id=H,this.color=me}static isThemeIcon(H){return typeof H.id!="string"?(console.log("INVALID ThemeIcon, invalid id",H.id),!1):!0}};e.$qO=ai,e.$qO=ai=Je([b],ai),ai.File=new ai("file"),ai.Folder=new ai("folder");let Ii=class{constructor(H){this.id=H}};e.$rO=Ii,e.$rO=Ii=Je([b],Ii);var Tt;(function(Z){Z[Z.Global=1]="Global",Z[Z.Workspace=2]="Workspace",Z[Z.WorkspaceFolder=3]="WorkspaceFolder"})(Tt||(e.ConfigurationTarget=Tt={}));let yi=class{get base(){return this.c}set base(H){this.c=H,this.e=c.URI.file(H)}get baseUri(){return this.e}set baseUri(H){this.e=H,this.c=H.fsPath}constructor(H,me){if(typeof H!="string"&&(!H||!c.URI.isUri(H)&&!c.URI.isUri(H.uri)))throw(0,h.$9)("base");if(typeof me!="string")throw(0,h.$9)("pattern");typeof H=="string"?this.baseUri=c.URI.file(H):c.URI.isUri(H)?this.baseUri=H:this.baseUri=H.uri,this.pattern=me}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.$sO=yi,e.$sO=yi=Je([b],yi);const Pi=new WeakMap;function Si(Z,H){Pi.set(Z,H)}let mi=class{constructor(H,me,Ne,Ye,st){this.enabled=typeof H=="boolean"?H:!0,typeof me=="string"&&(this.condition=me),typeof Ne=="string"&&(this.hitCondition=Ne),typeof Ye=="string"&&(this.logMessage=Ye),typeof st=="string"&&(this.mode=st)}get id(){return this.c||(this.c=Pi.get(this)??(0,I.$2g)()),this.c}};e.$uO=mi,e.$uO=mi=Je([b],mi);let Ci=class extends mi{constructor(H,me,Ne,Ye,st,$t){if(super(me,Ne,Ye,st,$t),H===null)throw(0,h.$9)("location");this.location=H}};e.$vO=Ci,e.$vO=Ci=Je([b],Ci);let Ce=class extends mi{constructor(H,me,Ne,Ye,st,$t){super(me,Ne,Ye,st,$t),this.functionName=H}};e.$wO=Ce,e.$wO=Ce=Je([b],Ce);let je=class extends mi{constructor(H,me,Ne,Ye,st,$t,yt,Yt){if(super(Ye,st,$t,yt,Yt),!me)throw(0,h.$9)("dataId");this.label=H,this.dataId=me,this.canPersist=Ne}};e.$xO=je,e.$xO=je=Je([b],je);let Se=class{constructor(H,me,Ne){this.command=H,this.args=me||[],this.options=Ne}};e.$yO=Se,e.$yO=Se=Je([b],Se);let ie=class{constructor(H,me){this.port=H,this.host=me}};e.$zO=ie,e.$zO=ie=Je([b],ie);let Oe=class{constructor(H){this.path=H}};e.$AO=Oe,e.$AO=Oe=Je([b],Oe);let Ve=class{constructor(H){this.implementation=H}};e.$BO=Ve,e.$BO=Ve=Je([b],Ve);class tt{constructor(H,me,Ne){this.session=H,this.threadId=me,this.frameId=Ne}}e.$CO=tt;class Qe{constructor(H,me){this.session=H,this.threadId=me}}e.$DO=Qe;let ft=class{constructor(H,me){this.range=H,this.expression=me}};e.$EO=ft,e.$EO=ft=Je([b],ft);var Ct;(function(Z){Z[Z.Invoke=0]="Invoke",Z[Z.Automatic=1]="Automatic"})(Ct||(e.InlineCompletionTriggerKind=Ct={}));let Jt=class{constructor(H,me){this.range=H,this.text=me}};e.$FO=Jt,e.$FO=Jt=Je([b],Jt);let ci=class{constructor(H,me,Ne=!0){this.range=H,this.variableName=me,this.caseSensitiveLookup=Ne}};e.$GO=ci,e.$GO=ci=Je([b],ci);let jt=class{constructor(H,me){this.range=H,this.expression=me}};e.$HO=jt,e.$HO=jt=Je([b],jt);let Xt=class{constructor(H,me){this.frameId=H,this.stoppedLocation=me}};e.$IO=Xt,e.$IO=Xt=Je([b],Xt);var Yi;(function(Z){Z[Z.AIGenerated=1]="AIGenerated"})(Yi||(e.NewSymbolNameTag=Yi={}));var Wi;(function(Z){Z[Z.Invoke=0]="Invoke",Z[Z.Automatic=1]="Automatic"})(Wi||(e.NewSymbolNameTriggerKind=Wi={}));class pn{constructor(H,me){this.newSymbolName=H,this.tags=me}}e.$JO=pn;var Li;(function(Z){Z[Z.Changed=1]="Changed",Z[Z.Created=2]="Created",Z[Z.Deleted=3]="Deleted"})(Li||(e.FileChangeType=Li={}));let Ni=C=class extends Error{static FileExists(H){return new C(H,u.FileSystemProviderErrorCode.FileExists,C.FileExists)}static FileNotFound(H){return new C(H,u.FileSystemProviderErrorCode.FileNotFound,C.FileNotFound)}static FileNotADirectory(H){return new C(H,u.FileSystemProviderErrorCode.FileNotADirectory,C.FileNotADirectory)}static FileIsADirectory(H){return new C(H,u.FileSystemProviderErrorCode.FileIsADirectory,C.FileIsADirectory)}static NoPermissions(H){return new C(H,u.FileSystemProviderErrorCode.NoPermissions,C.NoPermissions)}static Unavailable(H){return new C(H,u.FileSystemProviderErrorCode.Unavailable,C.Unavailable)}constructor(H,me=u.FileSystemProviderErrorCode.Unknown,Ne){super(c.URI.isUri(H)?H.toString(!0):H),this.code=Ne?.name??"Unknown",(0,u.$ol)(this,me),Object.setPrototypeOf(this,C.prototype),typeof Error.captureStackTrace=="function"&&typeof Ne=="function"&&Error.captureStackTrace(this,Ne)}};e.$KO=Ni,e.$KO=Ni=C=Je([b],Ni);let qi=class{constructor(H,me,Ne){this.start=H,this.end=me,this.kind=Ne}};e.$LO=qi,e.$LO=qi=Je([b],qi);var xi;(function(Z){Z[Z.Comment=1]="Comment",Z[Z.Imports=2]="Imports",Z[Z.Region=3]="Region"})(xi||(e.FoldingRangeKind=xi={}));var Di;(function(Z){Z[Z.Collapsed=0]="Collapsed",Z[Z.Expanded=1]="Expanded"})(Di||(e.CommentThreadCollapsibleState=Di={}));var _i;(function(Z){Z[Z.Editing=0]="Editing",Z[Z.Preview=1]="Preview"})(_i||(e.CommentMode=_i={}));var en;(function(Z){Z[Z.Published=0]="Published",Z[Z.Draft=1]="Draft"})(en||(e.CommentState=en={}));var Fi;(function(Z){Z[Z.Unresolved=0]="Unresolved",Z[Z.Resolved=1]="Resolved"})(Fi||(e.CommentThreadState=Fi={}));var tn;(function(Z){Z[Z.Current=0]="Current",Z[Z.Outdated=1]="Outdated"})(tn||(e.CommentThreadApplicability=tn={}));class Vi{constructor(H,me=[]){this.tokenTypes=H,this.tokenModifiers=me}}e.$MO=Vi;function nn(Z){return typeof Z>"u"||(0,$.$gg)(Z)}class Gi{constructor(H){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.j=0,this.k=new Map,this.l=new Map,this.m=!1,H){this.m=!0;for(let me=0,Ne=H.tokenTypes.length;me<Ne;me++)this.k.set(H.tokenTypes[me],me);for(let me=0,Ne=H.tokenModifiers.length;me<Ne;me++)this.l.set(H.tokenModifiers[me],me)}}push(H,me,Ne,Ye,st){if(typeof H=="number"&&typeof me=="number"&&typeof Ne=="number"&&typeof Ye=="number"&&(typeof st=="number"||typeof st>"u"))return typeof st>"u"&&(st=0),this.q(H,me,Ne,Ye,st);if(j.isRange(H)&&typeof me=="string"&&nn(Ne))return this.o(H,me,Ne);throw(0,h.$9)()}o(H,me,Ne){if(!this.m)throw new Error("Legend must be provided in constructor");if(H.start.line!==H.end.line)throw new Error("`range` cannot span multiple lines");if(!this.k.has(me))throw new Error("`tokenType` is not in the provided legend");const Ye=H.start.line,st=H.start.character,$t=H.end.character-H.start.character,yt=this.k.get(me);let Yt=0;if(Ne)for(const $i of Ne){if(!this.l.has($i))throw new Error("`tokenModifier` is not in the provided legend");const pi=this.l.get($i);Yt|=1<<pi>>>0}this.q(Ye,st,$t,yt,Yt)}q(H,me,Ne,Ye,st){if(this.f&&(H<this.c||H===this.c&&me<this.e)){this.f=!1;const Yt=this.g.length/5|0;let $i=0,pi=0;for(let Ei=0;Ei<Yt;Ei++){let ki=this.g[5*Ei],Ji=this.g[5*Ei+1];ki===0?(ki=$i,Ji+=pi):ki+=$i,this.g[5*Ei]=ki,this.g[5*Ei+1]=Ji,$i=ki,pi=Ji}}let $t=H,yt=me;this.f&&this.j>0&&($t-=this.c,$t===0&&(yt-=this.e)),this.g[this.j++]=$t,this.g[this.j++]=yt,this.g[this.j++]=Ne,this.g[this.j++]=Ye,this.g[this.j++]=st,this.c=H,this.e=me}static r(H){const me=[],Ne=H.length/5|0;for(let yt=0;yt<Ne;yt++)me[yt]=yt;me.sort((yt,Yt)=>{const $i=H[5*yt],pi=H[5*Yt];if($i===pi){const Ei=H[5*yt+1],ki=H[5*Yt+1];return Ei-ki}return $i-pi});const Ye=new Uint32Array(H.length);let st=0,$t=0;for(let yt=0;yt<Ne;yt++){const Yt=5*me[yt],$i=H[Yt+0],pi=H[Yt+1],Ei=H[Yt+2],ki=H[Yt+3],Ji=H[Yt+4],Bn=$i-st,kr=Bn===0?pi-$t:pi,Xi=5*yt;Ye[Xi+0]=Bn,Ye[Xi+1]=kr,Ye[Xi+2]=Ei,Ye[Xi+3]=ki,Ye[Xi+4]=Ji,st=$i,$t=pi}return Ye}build(H){return this.f?new Mi(new Uint32Array(this.g),H):new Mi(Gi.r(this.g),H)}}e.$NO=Gi;class Mi{constructor(H,me){this.resultId=me,this.data=H}}e.$OO=Mi;class bn{constructor(H,me,Ne){this.start=H,this.deleteCount=me,this.data=Ne}}e.$PO=bn;class Ti{constructor(H,me){this.resultId=me,this.edits=H}}e.$QO=Ti;var rn;(function(Z){Z[Z.Separate=0]="Separate",Z[Z.MergeWithParent=1]="MergeWithParent"})(rn||(e.DebugConsoleMode=rn={}));class wn{constructor(H){this.name=H}}e.$RO=wn;let Hi=class{static{this.Back={iconPath:new ai("arrow-left")}}constructor(){}};e.$SO=Hi,e.$SO=Hi=Je([b],Hi);var ji;(function(Z){Z[Z.Separator=-1]="Separator",Z[Z.Default=0]="Default"})(ji||(e.QuickPickItemKind=ji={}));var Zi;(function(Z){Z[Z.Info=1]="Info",Z[Z.Warning=2]="Warning",Z[Z.Error=3]="Error"})(Zi||(e.InputBoxValidationSeverity=Zi={}));var qe;(function(Z){Z[Z.UI=1]="UI",Z[Z.Workspace=2]="Workspace"})(qe||(e.ExtensionKind=qe={}));class vi{static validate(H){if(typeof H.badge=="string"){let me=(0,N.$Qf)(H.badge,0);if(me<H.badge.length&&(me+=(0,N.$Qf)(H.badge,me)),H.badge.length>me)throw new Error("The 'badge'-property must be undefined or a short character")}else if(H.badge&&!ai.isThemeIcon(H.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!H.color&&!H.badge&&!H.tooltip)throw new Error("The decoration is empty");return!0}constructor(H,me,Ne){this.badge=H,this.tooltip=me,this.color=Ne}}e.$TO=vi;let zi=class{constructor(H){this.kind=H}};e.$UO=zi,e.$UO=zi=Je([b],zi);var lt;(function(Z){Z[Z.Light=1]="Light",Z[Z.Dark=2]="Dark",Z[Z.HighContrast=3]="HighContrast",Z[Z.HighContrastLight=4]="HighContrastLight"})(lt||(e.ColorThemeKind=lt={}));class bt{static isNotebookRange(H){return H instanceof bt?!0:H?typeof H.start=="number"&&typeof H.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(H,me){if(H<0)throw(0,h.$9)("start must be positive");if(me<0)throw(0,h.$9)("end must be positive");H<=me?(this.c=H,this.e=me):(this.c=me,this.e=H)}with(H){let me=this.c,Ne=this.e;return H.start!==void 0&&(me=H.start),H.end!==void 0&&(Ne=H.end),me===this.c&&Ne===this.e?this:new bt(me,Ne)}}e.$VO=bt;class Bi{static validate(H){if(typeof H.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof H.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof H.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(H){return Array.isArray(H)&&H.every(me=>Bi.isNotebookCellData(me))}static isNotebookCellData(H){return!0}constructor(H,me,Ne,Ye,st,$t,yt){this.kind=H,this.value=me,this.languageId=Ne,this.mime=Ye,this.outputs=st??[],this.metadata=$t,this.executionSummary=yt,Bi.validate(this)}}e.$WO=Bi;class vn{constructor(H){this.cells=H}}e.$XO=vn;class gi{static isNotebookCellOutputItem(H){return H instanceof gi?!0:H?typeof H.mime=="string"&&H.data instanceof Uint8Array:!1}static error(H){const me={name:H.name,message:H.message,stack:H.stack};return gi.json(me,"application/vnd.code.notebook.error")}static stdout(H){return gi.text(H,"application/vnd.code.notebook.stdout")}static stderr(H){return gi.text(H,"application/vnd.code.notebook.stderr")}static bytes(H,me="application/octet-stream"){return new gi(H,me)}static#e=new TextEncoder;static text(H,me=T.$4s.text){const Ne=gi.#e.encode(String(H));return new gi(Ne,me)}static json(H,me="text/x-json"){const Ne=JSON.stringify(H,void 0,"	");return gi.text(Ne,me)}constructor(H,me){this.data=H,this.mime=me;const Ne=(0,T.$8s)(me,!0);if(!Ne)throw new Error(`INVALID mime type: ${me}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Ne}}e.$YO=gi;class Ui{static isNotebookCellOutput(H){return H instanceof Ui?!0:!H||typeof H!="object"?!1:typeof H.id=="string"&&Array.isArray(H.items)}static ensureUniqueMimeTypes(H,me=!1){const Ne=new Set,Ye=new Set;for(let st=0;st<H.length;st++){const $t=H[st],yt=(0,T.$8s)($t.mime);if(!Ne.has(yt)||(0,p.$wL)(yt)){Ne.add(yt);continue}Ye.add(st),me&&console.warn(`DUPLICATED mime type '${$t.mime}' will be dropped`)}return Ye.size===0?H:H.filter((st,$t)=>!Ye.has($t))}constructor(H,me,Ne){this.items=Ui.ensureUniqueMimeTypes(H,!0),typeof me=="string"?(this.id=me,this.metadata=Ne):(this.id=(0,I.$2g)(),this.metadata=me??Ne)}}e.$ZO=Ui;var Oi;(function(Z){Z[Z.Markup=1]="Markup",Z[Z.Code=2]="Code"})(Oi||(e.NotebookCellKind=Oi={}));var sn;(function(Z){Z[Z.Idle=1]="Idle",Z[Z.Pending=2]="Pending",Z[Z.Executing=3]="Executing"})(sn||(e.NotebookCellExecutionState=sn={}));var on;(function(Z){Z[Z.Left=1]="Left",Z[Z.Right=2]="Right"})(on||(e.NotebookCellStatusBarAlignment=on={}));var an;(function(Z){Z[Z.Default=0]="Default",Z[Z.InCenter=1]="InCenter",Z[Z.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",Z[Z.AtTop=3]="AtTop"})(an||(e.NotebookEditorRevealType=an={}));class cn{constructor(H,me){this.text=H,this.alignment=me}}e.$1O=cn;var ln;(function(Z){Z[Z.Default=1]="Default",Z[Z.Preferred=2]="Preferred"})(ln||(e.NotebookControllerAffinity=ln={}));var un;(function(Z){Z[Z.Default=1]="Default",Z[Z.Preferred=2]="Preferred",Z[Z.Hidden=-1]="Hidden"})(un||(e.NotebookControllerAffinity2=un={}));class En{constructor(H,me=[]){this.uri=H,this.provides=(0,r.$4b)(me)}}e.$2O=En;class yn{constructor(H){this.label=H}}e.$3O=yn;var hn;(function(Z){Z[Z.Named=1]="Named",Z[Z.Indexed=2]="Indexed"})(hn||(e.NotebookVariablesRequestKind=hn={}));let Ki=class{constructor(H,me){this.label=H,this.timestamp=me}};e.$4O=Ki,e.$4O=Ki=Je([b],Ki);var dn;(function(Z){Z[Z.Production=1]="Production",Z[Z.Development=2]="Development",Z[Z.Test=3]="Test"})(dn||(e.ExtensionMode=dn={}));var fn;(function(Z){Z[Z.Node=1]="Node",Z[Z.Webworker=2]="Webworker"})(fn||(e.ExtensionRuntime=fn={}));var gn;(function(Z){Z[Z.Other=0]="Other",Z[Z.Comment=1]="Comment",Z[Z.String=2]="String",Z[Z.RegEx=3]="RegEx"})(gn||(e.StandardTokenType=gn={}));class Sn{constructor(H,me){this.ranges=H,this.wordPattern=me}}e.$5O=Sn;class Dn{constructor(H){this.c=H}get autoForwardAction(){return this.c}}e.$6O=Dn;var ge;(function(Z){Z[Z.Queued=1]="Queued",Z[Z.Running=2]="Running",Z[Z.Passed=3]="Passed",Z[Z.Failed=4]="Failed",Z[Z.Skipped=5]="Skipped",Z[Z.Errored=6]="Errored"})(ge||(e.TestResultState=ge={}));var ve;(function(Z){Z[Z.Run=1]="Run",Z[Z.Debug=2]="Debug",Z[Z.Coverage=3]="Coverage"})(ve||(e.TestRunProfileKind=ve={}));let Be=class{constructor(H=void 0,me=void 0,Ne=void 0,Ye=!1,st=!0){this.include=H,this.exclude=me,this.profile=Ne,this.continuous=Ye,this.preserveFocus=st}};e.$7O=Be,e.$7O=Be=Je([b],Be);let ht=A=class{static diff(H,me,Ne){const Ye=new A(H);return Ye.expectedOutput=me,Ye.actualOutput=Ne,Ye}constructor(H){this.message=H}};e.$8O=ht,e.$8O=ht=A=Je([b],ht);let St=class{constructor(H){this.id=H}};e.$9O=St,e.$9O=St=Je([b],St);class Ot{constructor(H,me){this.covered=H,this.total=me,Ai(this)}}e.$0O=Ot;function Ai(Z){if(Z){if(Z.covered>Z.total)throw new Error(`The total number of covered items (${Z.covered}) cannot be greater than the total (${Z.total})`);if(Z.total<0)throw new Error(`The number of covered items (${Z.total}) cannot be negative`)}}class Qi{static fromDetails(H,me){const Ne=new Ot(0,0),Ye=new Ot(0,0),st=new Ot(0,0);for(const yt of me)if("branches"in yt){Ne.total+=1,Ne.covered+=yt.executed?1:0;for(const Yt of yt.branches)Ye.total+=1,Ye.covered+=Yt.executed?1:0}else st.total+=1,st.covered+=yt.executed?1:0;const $t=new Qi(H,Ne,Ye.total>0?Ye:void 0,st.total>0?st:void 0);return $t.detailedCoverage=me,$t}constructor(H,me,Ne,Ye,st=[]){this.uri=H,this.statementCoverage=me,this.branchCoverage=Ne,this.declarationCoverage=Ye,this.fromTests=st}}e.$_O=Qi;class qn{get executionCount(){return+this.executed}set executionCount(H){this.executed=H}constructor(H,me,Ne=[]){this.executed=H,this.location=me,this.branches=Ne}}e.$aP=qn;class Vn{get executionCount(){return+this.executed}set executionCount(H){this.executed=H}constructor(H,me,Ne){this.executed=H,this.location=me,this.label=Ne}}e.$bP=Vn;class Gn{get executionCount(){return+this.executed}set executionCount(H){this.executed=H}constructor(H,me,Ne){this.name=H,this.executed=me,this.location=Ne}}e.$cP=Gn;var kn;(function(Z){Z[Z.None=0]="None",Z[Z.Option=1]="Option",Z[Z.Default=2]="Default",Z[Z.Preferred=3]="Preferred"})(kn||(e.ExternalUriOpenerPriority=kn={}));var In;(function(Z){Z[Z.Untrusted=0]="Untrusted",Z[Z.Trusted=1]="Trusted",Z[Z.Unspecified=2]="Unspecified"})(In||(e.WorkspaceTrustState=In={}));var Pn;(function(Z){Z[Z.Notify=1]="Notify",Z[Z.OpenBrowser=2]="OpenBrowser",Z[Z.OpenPreview=3]="OpenPreview",Z[Z.Silent=4]="Silent",Z[Z.Ignore=5]="Ignore",Z[Z.OpenBrowserOnce=6]="OpenBrowserOnce"})(Pn||(e.PortAutoForwardAction=Pn={}));class Hn{constructor(H,me,Ne,Ye,st,$t){this.kind=H,this.name=me,this.detail=Ne,this.uri=Ye,this.range=st,this.selectionRange=$t}}e.$dP=Hn;class Zn{constructor(H){this.uri=H}}e.$eP=Zn;class Kn{constructor(H,me){this.original=H,this.modified=me}}e.$fP=Kn;class Qn{constructor(H,me,Ne,Ye){this.base=H,this.input1=me,this.input2=Ne,this.result=Ye}}e.$gP=Qn;class Jn{constructor(H,me){this.uri=H,this.viewType=me}}e.$hP=Jn;class Xn{constructor(H){this.viewType=H}}e.$iP=Xn;class Yn{constructor(H,me){this.uri=H,this.notebookType=me}}e.$jP=Yn;class xn{constructor(H,me,Ne){this.original=H,this.modified=me,this.notebookType=Ne}}e.$kP=xn;class _n{constructor(){}}e.$lP=_n;class er{constructor(H,me){this.uri=H,this.inputBoxUri=me}}e.$mP=er;class tr{constructor(){}}e.$nP=tr;class ir{constructor(H){this.textDiffs=H}}e.$oP=ir;var Cn;(function(Z){Z[Z.Down=0]="Down",Z[Z.Up=1]="Up"})(Cn||(e.InteractiveSessionVoteDirection=Cn={}));var An;(function(Z){Z[Z.Action=1]="Action",Z[Z.Toolbar=2]="Toolbar"})(An||(e.ChatCopyKind=An={}));var Rn;(function(Z){Z[Z.Short=1]="Short",Z[Z.Medium=2]="Medium",Z[Z.Full=3]="Full"})(Rn||(e.ChatVariableLevel=Rn={}));class nr{constructor(H,me,Ne){this.id=H,this.label=me,this.values=Ne}}e.$pP=nr;var Nn;(function(Z){Z[Z.Unhelpful=0]="Unhelpful",Z[Z.Helpful=1]="Helpful",Z[Z.Undone=2]="Undone",Z[Z.Accepted=3]="Accepted",Z[Z.Bug=4]="Bug"})(Nn||(e.InteractiveEditorResponseFeedbackKind=Nn={}));var Tn;(function(Z){Z[Z.Unhelpful=0]="Unhelpful",Z[Z.Helpful=1]="Helpful"})(Tn||(e.ChatResultFeedbackKind=Tn={}));class rr{constructor(H){if(typeof H!="string"&&H.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof H=="string"?new Ke(H):H}}e.$qP=rr;class sr{constructor(H,me){if(typeof H!="string"&&H.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof H=="string"?new Ke(H):H,this.vulnerabilities=me}}e.$rP=sr;class or{constructor(H,me){this.participant=H,this.command=me}}e.$sP=or;class ar{constructor(H,me,Ne){this.title=H,this.message=me,this.data=Ne}}e.$tP=ar;class cr{constructor(H,me){this.value=H,this.baseUri=me}}e.$uP=cr;class lr{constructor(H,me){this.value=H,this.title=me}}e.$vP=lr;class ur{constructor(H){this.value=H}}e.$wP=ur;class hr{constructor(H,me){this.value=H,this.task=me}}e.$xP=hr;class dr{constructor(H){if(typeof H!="string"&&H.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof H=="string"?new Ke(H):H}}e.$yP=dr;class fr{constructor(H){this.value=H}}e.$zP=fr;class gr{constructor(H,me){this.value=H,this.iconPath=me}}e.$AP=gr;class mr{constructor(H,me){this.uri=H,this.edits=Array.isArray(me)?me:[me]}}e.$BP=mr;class $r{constructor(H,me,Ne,Ye){this.prompt=H,this.command=me,this.references=Ne,this.participant=Ye}}e.$CP=$r;class pr{constructor(H,me,Ne,Ye){this.response=H,this.result=me,this.participant=Ne,this.command=Ye}}e.$DP=pr;var On;(function(Z){Z[Z.Panel=1]="Panel",Z[Z.Terminal=2]="Terminal",Z[Z.Notebook=3]="Notebook",Z[Z.Editor=4]="Editor"})(On||(e.ChatLocation=On={}));var mn;(function(Z){Z[Z.User=1]="User",Z[Z.Assistant=2]="Assistant",Z[Z.System=3]="System"})(mn||(e.LanguageModelChatMessageRole=mn={}));class br{constructor(H,me,Ne){this.name=H,this.content=me,this.isError=Ne??!1}}e.$EP=br;class $n{static User(H,me){const Ne=new $n(mn.User,typeof H=="string"?H:"",me);return Ne.content2=H,Ne}static Assistant(H,me){return new $n(mn.Assistant,H,me)}constructor(H,me,Ne){this.role=H,this.content=me,this.content2=me,this.name=Ne}}e.$FP=$n;class wr{constructor(H,me){this.name=H,this.parameters=me}}e.$GP=wr;class vr{constructor(H){this.value=H}}e.$HP=vr;class Er{constructor(H){this.content=H}}e.$IP=Er;class yr{constructor(H,me){this.content=H,this.name=me}}e.$JP=yr;class Sr{constructor(H,me){this.content=H,this.name=me}}e.$KP=Sr;class Ri extends Error{static NotFound(H){return new Ri(H,Ri.NotFound.name)}static NoPermissions(H){return new Ri(H,Ri.NoPermissions.name)}static Blocked(H){return new Ri(H,Ri.Blocked.name)}constructor(H,me,Ne){super(H,{cause:Ne}),this.name="LanguageModelError",this.code=me??""}}e.$LP=Ri;var Ln;(function(Z){Z[Z.SymbolInformation=1]="SymbolInformation",Z[Z.CommandInformation=2]="CommandInformation",Z[Z.SearchInformation=3]="SearchInformation",Z[Z.SettingInformation=4]="SettingInformation"})(Ln||(e.RelatedInformationType=Ln={}));var Fn;(function(Z){Z[Z.Started=1]="Started",Z[Z.Recognizing=2]="Recognizing",Z[Z.Recognized=3]="Recognized",Z[Z.Stopped=4]="Stopped",Z[Z.Error=5]="Error"})(Fn||(e.SpeechToTextStatus=Fn={}));var Mn;(function(Z){Z[Z.Started=1]="Started",Z[Z.Stopped=2]="Stopped",Z[Z.Error=3]="Error"})(Mn||(e.TextToSpeechStatus=Mn={}));var jn;(function(Z){Z[Z.Recognized=1]="Recognized",Z[Z.Stopped=2]="Stopped"})(jn||(e.KeywordRecognitionStatus=jn={}));class Dr{constructor(H,me){this.text=H,this.range=me}}e.$MP=Dr;var zn;(function(Z){Z[Z.Invoke=0]="Invoke",Z[Z.Automatic=1]="Automatic"})(zn||(e.InlineEditTriggerKind=zn={}))}),define(Ee[342],ye([1,0,6,10]),function(ce,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Snc=void 0;class P{constructor(T){this.a=new Map,this.b=0,this.c=T.getProxy(r.$rN.MainThreadAiRelatedInformation)}async $provideAiRelatedInformation(T,N,$){if(this.a.size===0)throw new Error("No related information providers registered");const c=this.a.get(T);if(!c)throw new Error("related information provider not found");return await c.provideRelatedInformation(N,$)??[]}getRelatedInformation(T,N,$){return this.c.$getAiRelatedInformation(N,$)}registerRelatedInformationProvider(T,N,$){const c=this.b;return this.b++,this.a.set(c,$),this.c.$registerAiRelatedInformationProvider(c,N),new h.$tN(()=>{this.c.$unregisterAiRelatedInformationProvider(c),this.a.delete(c)})}}e.$Snc=P}),define(Ee[128],ye([1,0,4,6,10,24,155,5,20]),function(ce,e,r,h,P,R,T,N,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5nc=e.$4nc=void 0,e.$4nc=(0,N.$Fi)("IExtHostAuthentication");let c=class{constructor(u){this.b=new Map,this.c=new r.$me,this.onDidChangeSessions=this.c.event,this.d=new I,this.f=new I,this.a=u.getProxy(h.$rN.MainThreadAuthentication)}async getSession(u,k,p,a={}){const f=R.$qn.toKey(u.identifier),d=[...p].sort().join(" ");return await this.d.getOrCreate(`${f} ${k} ${d}`,async()=>{await this.a.$ensureProvider(k);const m=u.displayName||u.name;return this.a.$getSession(k,p,f,m,a)})}async getSessions(u,k,p){const a=R.$qn.toKey(u.identifier),f=[...p].sort().join(" ");return await this.f.getOrCreate(`${a} ${f}`,async()=>{await this.a.$ensureProvider(k);const d=u.displayName||u.name;return this.a.$getSessions(k,p,a,d)})}async getAccounts(u){return await this.a.$ensureProvider(u),await this.a.$getAccounts(u)}async removeSession(u,k){const p=this.b.get(u);return p?p.provider.removeSession(k):this.a.$removeSession(u,k)}registerAuthenticationProvider(u,k,p,a){if(this.b.get(u))throw new Error(`An authentication provider with id '${u}' is already registered.`);this.b.set(u,{label:k,provider:p,options:a??{supportsMultipleAccounts:!1}});const f=p.onDidChangeSessions(d=>this.a.$sendDidChangeSessions(u,d));return this.a.$registerAuthenticationProvider(u,k,a?.supportsMultipleAccounts??!1),new P.$tN(()=>{f.dispose(),this.b.delete(u),this.a.$unregisterAuthenticationProvider(u)})}async $createSession(u,k,p){const a=this.b.get(u);if(a)return await a.provider.createSession(k,p);throw new Error(`Unable to find authentication provider with handle: ${u}`)}async $removeSession(u,k){const p=this.b.get(u);if(p)return await p.provider.removeSession(k);throw new Error(`Unable to find authentication provider with handle: ${u}`)}async $getSessions(u,k,p){const a=this.b.get(u);if(a)return await a.provider.getSessions(k,p);throw new Error(`Unable to find authentication provider with handle: ${u}`)}$onDidChangeAuthenticationSessions(u,k){return u.startsWith(T.$tM)||this.c.fire({provider:{id:u,label:k}}),Promise.resolve()}};e.$5nc=c,e.$5nc=c=Je([Ge(0,$.$XP)],c);class I{constructor(){this.a=new Map}getOrCreate(u,k){const p=this.a.get(u);if(p)return p;const a=k().finally(()=>this.a.delete(u));return this.a.set(u,a),a}}}),define(Ee[162],ye([1,0,2,6,10,5,20,12,19,13,16,26]),function(ce,e,r,h,P,R,T,N,$,c,I,E){"use strict";var u;Object.defineProperty(e,"__esModule",{value:!0}),e.$0oc=e.$9oc=void 0;let k=class{static{u=this}static{this.c=0}static{this.d=250}constructor(a,f){this.h=f,this.f=new Map,this.g=a.getProxy(h.$rN.MainThreadDecorations)}registerFileDecorationProvider(a,f){const d=u.c++;this.f.set(d,{provider:a,extensionDescription:f}),this.g.$registerDecorationProvider(d,f.identifier.value);const m=a.onDidChangeFileDecorations&&a.onDidChangeFileDecorations(n=>{if(!n){this.g.$onDidChange(d,null);return}const o=(0,$.$4b)(n);if(o.length<=u.d){this.g.$onDidChange(d,o);return}this.h.warn("[Decorations] CAPPING events from decorations provider",f.identifier.value,o.length);const t=o.map(g=>({uri:g,rank:(0,c.$jf)(g.path,"/")})),i=(0,$.$Bb)(t,(g,l)=>g.rank-l.rank||(0,c.$zf)(g.uri.path,l.uri.path)),s=[];e:for(const g of i){let l;for(const w of g){const S=(0,I.$oc)(w.uri.path);if(l!==S&&(l=S,s.push(w.uri)>=u.d))break e}}this.g.$onDidChange(d,s)});return new P.$tN(()=>{m?.dispose(),this.g.$unregisterDecorationProvider(d),this.f.delete(d)})}async $provideDecorations(a,f,d){if(!this.f.has(a))return Object.create(null);const m=Object.create(null),{provider:n,extensionDescription:o}=this.f.get(a);return await Promise.all(f.map(async t=>{try{const{uri:i,id:s}=t,g=await Promise.resolve(n.provideFileDecoration(r.URI.revive(i),d));if(!g)return;try{P.$TO.validate(g),g.badge&&typeof g.badge!="string"&&(0,E.$4G)(o,"codiconDecoration"),m[s]=[g.propagate,g.tooltip,g.badge,g.color]}catch(l){this.h.warn(`INVALID decoration from extension '${o.identifier.value}': ${l}`)}}catch(i){this.h.error(i)}})),m}};e.$9oc=k,e.$9oc=k=u=Je([Ge(0,T.$XP),Ge(1,N.$_j)],k),e.$0oc=(0,R.$Fi)("IExtHostDecorations")}),define(Ee[343],ye([1,0,14,2,10,6,15,21,13]),function(ce,e,r,h,P,R,T,N,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_oc=void 0;class c{static{this.a=0}constructor(E,u,k){this.d=u,this.e=k,this.b=new Map,this.c=E.getProxy(R.$rN.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(E,u){if(Object.keys(T.Schemas).indexOf(E)>=0)throw new Error(`scheme '${E}' already registered`);const k=c.a++;this.b.set(k,u),this.c.$registerTextContentProvider(k,E);let p;if(typeof u.onDidChange=="function"){let a;p=u.onDidChange(async f=>{if(f.scheme!==E){this.e.warn(`Provider for scheme '${E}' is firing event for schema '${f.scheme}' which will be IGNORED`);return}if(!this.d.getDocument(f))return;a&&await a;const d=this.$provideTextDocumentContent(k,f).then(async m=>{if(!m&&typeof m!="string")return;const n=this.d.getDocument(f);if(!n)return;const o=(0,$.$tf)(m);if(!n.equalLines(o))return this.c.$onVirtualDocumentChange(f,m)}).catch(r.$3).finally(()=>{a===d&&(a=void 0)});a=d})}return new P.$tN(()=>{this.b.delete(k)&&this.c.$unregisterTextContentProvider(k),p&&(p.dispose(),p=void 0)})}$provideTextDocumentContent(E,u){const k=this.b.get(E);return k?Promise.resolve(k.provideTextDocumentContent(h.URI.revive(u),N.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${u.scheme}`))}}e.$_oc=c}),define(Ee[163],ye([1,0,66,15,13,197,138,10,19]),function(ce,e,r,h,P,R,T,N,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2P=e.$1P=void 0,e.$ZP=I;const c=new Map;function I(p,a){a?c.set(p,a):c.delete(p)}function E(p){return c.get(p)}class u extends R.$hw{constructor(a,f,d,m,n,o,t){super(f,d,m,n),this.c=a,this.m=o,this.q=t,this.b=!1}dispose(){(0,r.ok)(!this.b),this.b=!0,this.q=!1}equalLines(a){return(0,$.$wb)(this.f,a)}get document(){if(!this.a){const a=this;this.a={get uri(){return a.d},get fileName(){return a.d.fsPath},get isUntitled(){return a.d.scheme===h.Schemas.untitled},get languageId(){return a.m},get version(){return a.h},get isClosed(){return a.b},get isDirty(){return a.q},save(){return a.r()},getText(f){return f?a.s(f):a.getText()},get eol(){return a.g===`
`?N.EndOfLine.LF:N.EndOfLine.CRLF},get lineCount(){return a.f.length},lineAt(f){return a.t(f)},offsetAt(f){return a.u(f)},positionAt(f){return a.v(f)},validateRange(f){return a.w(f)},validatePosition(f){return a.x(f)},getWordRangeAtPosition(f,d){return a.y(f,d)}}}return Object.freeze(this.a)}_acceptLanguageId(a){(0,r.ok)(!this.b),this.m=a}_acceptIsDirty(a){(0,r.ok)(!this.b),this.q=a}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.c.$trySaveDocument(this.d)}s(a){const f=this.w(a);if(f.isEmpty)return"";if(f.isSingleLine)return this.f[f.start.line].substring(f.start.character,f.end.character);const d=this.g,m=f.start.line,n=f.end.line,o=[];o.push(this.f[m].substring(f.start.character));for(let t=m+1;t<n;t++)o.push(this.f[t]);return o.push(this.f[n].substring(0,f.end.character)),o.join(d)}t(a){let f;if(a instanceof N.$uN?f=a.line:typeof a=="number"&&(f=a),typeof f!="number"||f<0||f>=this.f.length||Math.floor(f)!==f)throw new Error("Illegal value for `line`");return new k(f,this.f[f],f===this.f.length-1)}u(a){return a=this.x(a),this.l(),this.j.getPrefixSum(a.line-1)+a.character}v(a){a=Math.floor(a),a=Math.max(0,a),this.l();const f=this.j.getIndexOf(a),d=this.f[f.index].length;return new N.$uN(f.index,Math.min(f.remainder,d))}w(a){if(!(a instanceof N.$vN))throw new Error("Invalid argument");const f=this.x(a.start),d=this.x(a.end);return f===a.start&&d===a.end?a:new N.$vN(f.line,f.character,d.line,d.character)}x(a){if(!(a instanceof N.$uN))throw new Error("Invalid argument");if(this.f.length===0)return a.with(0,0);let{line:f,character:d}=a,m=!1;if(f<0)f=0,d=0,m=!0;else if(f>=this.f.length)f=this.f.length-1,d=this.f[f].length,m=!0;else{const n=this.f[f].length;d<0?(d=0,m=!0):d>n&&(d=n,m=!0)}return m?new N.$uN(f,d):a}y(a,f){const d=this.x(a);if(!f)f=E(this.m);else if((0,P.$sf)(f))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${f.source}' because it matches the empty string.`);const m=(0,T.$jt)(d.character+1,(0,T.$ht)(f),this.f[d.line],0);if(m)return new N.$vN(d.line,m.startColumn-1,d.line,m.endColumn-1)}}e.$1P=u;class k{constructor(a,f,d){this.a=a,this.b=f,this.c=d}get lineNumber(){return this.a}get text(){return this.b}get range(){return new N.$vN(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new N.$vN(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.$2P=k}),define(Ee[344],ye([1,0,6,10]),function(ce,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cpc=void 0;class P{constructor(T){this.a=new Map,this.b=0,this.c=T.getProxy(r.$rN.MainThreadAiEmbeddingVector)}async $provideAiEmbeddingVector(T,N,$){if(this.a.size===0)throw new Error("No embedding vector providers registered");const c=this.a.get(T);if(!c)throw new Error("Embedding vector provider not found");const I=await c.provideEmbeddingVector(N,$);if(!I)throw new Error("Embedding vector provider returned undefined");return I}registerEmbeddingVectorProvider(T,N,$){const c=this.b;return this.b++,this.a.set(c,$),this.c.$registerAiEmbeddingVectorProvider(N,c),new h.$tN(()=>{this.c.$unregisterAiEmbeddingVectorProvider(c),this.a.delete(c)})}}e.$cpc=P}),define(Ee[76],ye([1,0,6,28,10,22,5,20,63,3,9,23,15]),function(ce,e,r,h,P,R,T,N,$,c,I,E,u){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.$ioc=e.$hoc=void 0,h=We(h);let p=k=class{constructor(f,d){this.b=new Map,this.c=new I.$Oh,this.a=f.getProxy(r.$rN.MainThreadFileSystem);const m=this;this.value=Object.freeze({async stat(n){try{let o;const t=m.b.get(n.scheme);return t?(await m.a.$ensureActivation(n.scheme),o=await t.impl.stat(n)):o=await m.a.$stat(n),{type:o.type,ctime:o.ctime,mtime:o.mtime,size:o.size,permissions:o.permissions===h.FilePermission.Readonly?1:void 0}}catch(o){k.e(o)}},async readDirectory(n){try{const o=m.b.get(n.scheme);return o?(await m.a.$ensureActivation(n.scheme),(await o.impl.readDirectory(n)).slice()):await m.a.$readdir(n)}catch(o){return k.e(o)}},async createDirectory(n){try{const o=m.b.get(n.scheme);return o&&!o.isReadonly?(await m.a.$ensureActivation(n.scheme),await m.d(o.impl,o.extUri,n)):await m.a.$mkdir(n)}catch(o){return k.e(o)}},async readFile(n){try{const o=m.b.get(n.scheme);return o?(await m.a.$ensureActivation(n.scheme),(await o.impl.readFile(n)).slice()):(await m.a.$readFile(n)).buffer}catch(o){return k.e(o)}},async writeFile(n,o){try{const t=m.b.get(n.scheme);return t&&!t.isReadonly?(await m.a.$ensureActivation(n.scheme),await m.d(t.impl,t.extUri,t.extUri.dirname(n)),await m.c.queueFor(n,()=>Promise.resolve(t.impl.writeFile(n,o,{create:!0,overwrite:!0})))):await m.a.$writeFile(n,R.$Oe.wrap(o))}catch(t){return k.e(t)}},async delete(n,o){try{const t=m.b.get(n.scheme);return t&&!t.isReadonly&&!o?.useTrash?(await m.a.$ensureActivation(n.scheme),await t.impl.delete(n,{recursive:!1,...o})):await m.a.$delete(n,{recursive:!1,useTrash:!1,atomic:!1,...o})}catch(t){return k.e(t)}},async rename(n,o,t){try{return await m.a.$rename(n,o,{overwrite:!1,...t})}catch(i){return k.e(i)}},async copy(n,o,t){try{return await m.a.$copy(n,o,{overwrite:!1,...t})}catch(i){return k.e(i)}},isWritableFileSystem(n){const o=d.getCapabilities(n);if(typeof o=="number")return!(o&h.FileSystemProviderCapabilities.Readonly)}})}async d(f,d,m){const n=[];for(;!d.isEqual(m,d.dirname(m));)try{if(!((await f.stat(m)).type&h.FileType.Directory))throw P.$KO.FileExists(`Unable to create folder '${m.scheme===u.Schemas.file?m.fsPath:m.toString(!0)}' that already exists but is not a directory`);break}catch(o){if(h.$pl(o)!==h.FileSystemProviderErrorCode.FileNotFound)throw o;n.push(d.basename(m)),m=d.dirname(m)}for(let o=n.length-1;o>=0;o--){m=d.joinPath(m,n[o]);try{await f.createDirectory(m)}catch(t){if(h.$pl(t)!==h.FileSystemProviderErrorCode.FileExists)throw t}}}static e(f){if(f instanceof P.$KO)throw f;if(f instanceof h.$ll)switch(f.code){case h.FileSystemProviderErrorCode.FileExists:throw P.$KO.FileExists(f.message);case h.FileSystemProviderErrorCode.FileNotFound:throw P.$KO.FileNotFound(f.message);case h.FileSystemProviderErrorCode.FileNotADirectory:throw P.$KO.FileNotADirectory(f.message);case h.FileSystemProviderErrorCode.FileIsADirectory:throw P.$KO.FileIsADirectory(f.message);case h.FileSystemProviderErrorCode.NoPermissions:throw P.$KO.NoPermissions(f.message);case h.FileSystemProviderErrorCode.Unavailable:throw P.$KO.Unavailable(f.message);default:throw new P.$KO(f.message,f.name)}if(!(f instanceof Error))throw new P.$KO(String(f));if(f.name==="ENOPRO"||f.message.includes("ENOPRO"))throw P.$KO.Unavailable(f.message);switch(f.name){case h.FileSystemProviderErrorCode.FileExists:throw P.$KO.FileExists(f.message);case h.FileSystemProviderErrorCode.FileNotFound:throw P.$KO.FileNotFound(f.message);case h.FileSystemProviderErrorCode.FileNotADirectory:throw P.$KO.FileNotADirectory(f.message);case h.FileSystemProviderErrorCode.FileIsADirectory:throw P.$KO.FileIsADirectory(f.message);case h.FileSystemProviderErrorCode.NoPermissions:throw P.$KO.NoPermissions(f.message);case h.FileSystemProviderErrorCode.Unavailable:throw P.$KO.Unavailable(f.message);default:throw new P.$KO(f.message,f.name)}}addFileSystemProvider(f,d,m){return this.b.set(f,{impl:d,extUri:m?.isCaseSensitive?E.$9g:E.$$g,isReadonly:!!m?.isReadonly}),(0,c.$Uc)(()=>this.b.delete(f))}getFileSystemProviderExtUri(f){return this.b.get(f)?.extUri??E.$9g}};e.$hoc=p,e.$hoc=p=k=Je([Ge(0,N.$XP),Ge(1,$.$Xnc)],p),e.$ioc=(0,T.$Fi)("IExtHostConsumerFileSystem")}),define(Ee[98],ye([1,0,5,30,12,76,2]),function(ce,e,r,h,P,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$koc=e.$joc=void 0,e.$joc=(0,r.$Fi)("IExtensionStoragePaths");let N=class{constructor(c,I,E){this.d=I,this.f=E,this.a=c.workspace??void 0,this.b=c.environment,this.whenReady=this.h().then(u=>this.c=u)}async g(c){return T.URI.joinPath(this.b.workspaceStorageHome,c)}async h(){if(!this.a)return Promise.resolve(void 0);const c=this.a.id,I=await this.g(c);try{return await this.f.value.stat(I),this.d.trace("[ExtHostStorage] storage dir already exists",I),I}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",I),await this.f.value.createDirectory(I),await this.f.value.writeFile(T.URI.joinPath(I,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:T.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),I}catch(E){this.d.error("[ExtHostStorage]",E);return}}workspaceValue(c){if(this.c)return T.URI.joinPath(this.c,c.identifier.value)}globalValue(c){return T.URI.joinPath(this.b.globalStorageHome,c.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.$koc=N,e.$koc=N=Je([Ge(0,h.$bQ),Ge(1,P.$_j),Ge(2,R.$ioc)],N)}),define(Ee[345],ye([1,0,10,20,4]),function(ce,e,r,h,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Spc=void 0;let R=class{constructor(N){this.a=new r.$UO(r.ColorThemeKind.Dark),this.b=new P.$me}get activeColorTheme(){return this.a}$onColorThemeChange(N){let $;switch(N){case"light":$=r.ColorThemeKind.Light;break;case"hcDark":$=r.ColorThemeKind.HighContrast;break;case"hcLight":$=r.ColorThemeKind.HighContrastLight;break;default:$=r.ColorThemeKind.Dark}this.a=new r.$UO($),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};e.$Spc=R,e.$Spc=R=Je([Ge(0,h.$XP)],R)}),define(Ee[77],ye([1,0,21,4,3,243,5,12,93,6,30,20,10]),function(ce,e,r,h,P,R,T,N,$,c,I,E,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$FFb=e.$EFb=e.TunnelDtoConverter=void 0,R=We(R),u=We(u);class k extends $.$Gw{}var p;(function(f){function d(n){return{remoteAddress:n.remoteAddress,localAddress:n.localAddress,public:!!n.public,privacy:n.privacy??(n.public?$.TunnelPrivacyId.Public:$.TunnelPrivacyId.Private),protocol:n.protocol}}f.fromApiTunnel=d;function m(n){return{remoteAddress:{host:n.tunnelRemoteHost,port:n.tunnelRemotePort},localAddress:n.localAddress,public:n.privacy!==$.TunnelPrivacyId.ConstantPrivate&&n.privacy!==$.TunnelPrivacyId.ConstantPrivate,privacy:n.privacy,protocol:n.protocol}}f.fromServiceTunnel=m})(p||(e.TunnelDtoConverter=p={})),e.$EFb=(0,T.$Fi)("IExtHostTunnelService");let a=class extends P.$Wc{constructor(d,m,n){super(),this.s=n,this.f=()=>Promise.resolve(!0),this.g=new Map,this.h=new h.$me,this.onDidChangeTunnels=this.h.event,this.n=0,this.r=new Map,this.a=d.getProxy(c.$rN.MainThreadTunnelService)}async openTunnel(d,m){this.s.trace(`ForwardedPorts: (ExtHostTunnelService) ${d.identifier.value} called openTunnel API for ${m.remoteAddress.host}:${m.remoteAddress.port}.`);const n=await this.a.$openTunnel(m,d.displayName);if(n){const o=new k(n.remoteAddress,n.localAddress,()=>this.a.$closeTunnel(n.remoteAddress));return this.B(o),o}}async getTunnels(){return this.a.$getTunnels()}u(){return this.n++}registerPortsAttributesProvider(d,m){d.portRange===void 0&&d.commandPattern===void 0&&this.s.error("PortAttributesProvider must specify either a portRange or a commandPattern");const n=this.u();return this.r.set(n,{selector:d,provider:m}),this.a.$registerPortsAttributesProvider(d,n),new u.$tN(()=>{this.r.delete(n),this.a.$unregisterPortsAttributesProvider(n)})}async $providePortAttributes(d,m,n,o,t){const i=[];for(const g of d){const l=this.r.get(g);if(!l)return[];i.push(...await Promise.all(m.map(async w=>{let S;try{S=await l.provider.providePortAttributes({port:w,pid:n,commandLine:o},t)}catch{S=await l.provider.providePortAttributes(w,n,o,t)}return{providedAttributes:S,port:w}})))}const s=i.filter(g=>!!g.providedAttributes);return s.length>0?s.map(g=>({autoForwardAction:g.providedAttributes.autoForwardAction,port:g.port})):[]}async $registerCandidateFinder(d){}registerTunnelProvider(d,m){if(this.b)throw new Error("A tunnel provider has already been registered. Only the first tunnel provider to be registered will be used.");this.b=async(o,t)=>await d.provideTunnel(o,t,r.CancellationToken.None)??void 0;const n=m.tunnelFeatures?{elevation:!!m.tunnelFeatures?.elevation,privacyOptions:m.tunnelFeatures?.privacyOptions,protocol:m.tunnelFeatures.protocol===void 0?!0:m.tunnelFeatures.protocol}:void 0;return this.a.$setTunnelProvider(n),Promise.resolve((0,P.$Uc)(()=>{this.b=void 0,this.a.$setTunnelProvider(void 0)}))}async setTunnelFactory(d,m){if(d){d.candidatePortSource!==void 0&&this.a.$setCandidatePortSource(d.candidatePortSource),d.showCandidatePort&&(this.f=d.showCandidatePort,this.a.$setCandidateFilter());const n=d.tunnelFactory??(m?this.w(m):void 0);if(n){this.b=n;let o=d.tunnelFeatures?.privacyOptions??[];d.tunnelFeatures?.public&&o.length===0&&(o=[{id:"private",label:R.localize(0,null),themeIcon:"lock"},{id:"public",label:R.localize(1,null),themeIcon:"eye"}]);const t=d.tunnelFeatures?{elevation:!!d.tunnelFeatures?.elevation,public:!!d.tunnelFeatures?.public,privacyOptions:o,protocol:!0}:void 0;this.a.$setTunnelProvider(t)}}else this.b=void 0;return(0,P.$Uc)(()=>{this.b=void 0})}w(d){}async $closeTunnel(d,m){if(this.g.has(d.host)){const n=this.g.get(d.host);n.has(d.port)&&(m&&n.get(d.port).disposeListener.dispose(),await n.get(d.port).tunnel.dispose(),n.delete(d.port))}}async $onDidTunnelsChange(){this.h.fire()}async $forwardPort(d,m){if(this.b)try{this.s.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const n=this.b(d,m);if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),n!==void 0){const o=await n;if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),o===void 0){this.s.error("ForwardedPorts: (ExtHostTunnelService) Resolved tunnel is undefined");return}this.g.has(d.remoteAddress.host)||this.g.set(d.remoteAddress.host,new Map);const t=this.B(o.onDidDispose(()=>(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this.a.$closeTunnel(o.remoteAddress))));return this.g.get(d.remoteAddress.host).set(d.remoteAddress.port,{tunnel:o,disposeListener:t}),p.fromApiTunnel(o)}else this.s.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(n){if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error"),n instanceof Error)return n.message}}async $applyCandidateFilter(d){const m=await Promise.all(d.map(o=>this.f(o.host,o.port,o.detail??""))),n=d.filter((o,t)=>m[t]);return this.s.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${d.map(o=>o.port).join(", ")} to ${n.map(o=>o.port).join(", ")}`),n}};e.$FFb=a,e.$FFb=a=Je([Ge(0,E.$XP),Ge(1,I.$bQ),Ge(2,N.$_j)],a)}),define(Ee[17],ye([1,0,19,22,186,80,86,29,176,57,108,25,181,23,50,18,2,114,31,106,88,54,145,90,154,152,306,322,120,127,74,75,318,10]),function(ce,e,r,h,P,R,T,N,$,c,I,E,u,k,p,a,f,d,m,n,o,t,i,s,g,l,w,S,D,y,C,A,b,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DebugTreeItem=e.PartialAcceptTriggerKind=e.PartialAcceptInfo=e.TerminalQuickFix=e.ChatAgentUserActionEvent=e.ChatAgentResult=e.ChatAgentCompletionItem=e.ChatAgentValueReference=e.ChatLocation=e.ChatAgentRequest=e.ChatResponsePart=e.ChatResponseReferencePart=e.ChatResponseTextEditPart=e.ChatResponseCommandButtonPart=e.ChatTaskResult=e.ChatTask=e.ChatResponseWarningPart=e.ChatResponseProgressPart=e.ChatResponseAnchorPart=e.ChatResponseFilesPart=e.ChatResponseConfirmationPart=e.ChatResponseDetectedParticipantPart=e.ChatResponseMarkdownWithVulnerabilitiesPart=e.ChatResponseMarkdownPart=e.LanguageModelChatMessage=e.LanguageModelChatMessageRole=e.ChatFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.MultiDocumentHighlight=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.MarkdownString=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Location=e.Range=e.Selection=void 0,e.$UP=ee,e.$VP=ne,e.$WP=De,T=We(T),m=We(m),n=We(n),o=We(o),S=We(S),y=We(y),v=We(v);var L;(function(Ce){function je(ie){const{selectionStartLineNumber:Oe,selectionStartColumn:Ve,positionLineNumber:tt,positionColumn:Qe}=ie,ft=new v.$uN(Oe-1,Ve-1),Ct=new v.$uN(tt-1,Qe-1);return new v.$wN(ft,Ct)}Ce.to=je;function Se(ie){const{anchor:Oe,active:Ve}=ie;return{selectionStartLineNumber:Oe.line+1,selectionStartColumn:Oe.character+1,positionLineNumber:Ve.line+1,positionColumn:Ve.character+1}}Ce.from=Se})(L||(e.Selection=L={}));var O;(function(Ce){function je(ie){if(!ie)return;const{start:Oe,end:Ve}=ie;return{startLineNumber:Oe.line+1,startColumn:Oe.character+1,endLineNumber:Ve.line+1,endColumn:Ve.character+1}}Ce.from=je;function Se(ie){if(!ie)return;const{startLineNumber:Oe,startColumn:Ve,endLineNumber:tt,endColumn:Qe}=ie;return new v.$vN(Oe-1,Ve-1,tt-1,Qe-1)}Ce.to=Se})(O||(e.Range=O={}));var M;(function(Ce){function je(ie){return{uri:ie.uri,range:O.from(ie.range)}}Ce.from=je;function Se(ie){return new v.$FN(f.URI.revive(ie.uri),O.to(ie.range))}Ce.to=Se})(M||(e.Location=M={}));var j;(function(Ce){function je(Se){switch(Se){case n.StandardTokenType.Comment:return v.StandardTokenType.Comment;case n.StandardTokenType.Other:return v.StandardTokenType.Other;case n.StandardTokenType.RegEx:return v.StandardTokenType.RegEx;case n.StandardTokenType.String:return v.StandardTokenType.String}}Ce.to=je})(j||(e.TokenType=j={}));var z;(function(Ce){function je(ie){return new v.$uN(ie.lineNumber-1,ie.column-1)}Ce.to=je;function Se(ie){return{lineNumber:ie.line+1,column:ie.character+1}}Ce.from=Se})(z||(e.Position=z={}));var F;(function(Ce){function je(Oe,Ve,tt){return(0,r.$Jb)((0,r.$4b)(Oe).map(Qe=>Se(Qe,Ve,tt)))}Ce.from=je;function Se(Oe,Ve,tt){if(typeof Oe=="string")return{$serialized:!0,language:Oe,isBuiltin:tt?.isBuiltin};if(Oe)return{$serialized:!0,language:Oe.language,scheme:ie(Oe.scheme,Ve),pattern:_e.from(Oe.pattern)??void 0,exclusive:Oe.exclusive,notebookType:Oe.notebookType,isBuiltin:tt?.isBuiltin}}function ie(Oe,Ve){return Ve&&typeof Oe=="string"?Ve.transformOutgoingScheme(Oe):Oe}})(F||(e.DocumentSelector=F={}));var B;(function(Ce){function je(ie){switch(ie){case v.DiagnosticTag.Unnecessary:return i.MarkerTag.Unnecessary;case v.DiagnosticTag.Deprecated:return i.MarkerTag.Deprecated}}Ce.from=je;function Se(ie){switch(ie){case i.MarkerTag.Unnecessary:return v.DiagnosticTag.Unnecessary;case i.MarkerTag.Deprecated:return v.DiagnosticTag.Deprecated;default:return}}Ce.to=Se})(B||(e.DiagnosticTag=B={}));var _;(function(Ce){function je(ie){let Oe;return ie.code&&((0,a.$fg)(ie.code)||(0,a.$jg)(ie.code)?Oe=String(ie.code):Oe={value:String(ie.code.value),target:ie.code.target}),{...O.from(ie.range),message:ie.message,source:ie.source,code:Oe,severity:U.from(ie.severity),relatedInformation:ie.relatedInformation&&ie.relatedInformation.map(re.from),tags:Array.isArray(ie.tags)?(0,r.$Jb)(ie.tags.map(B.from)):void 0}}Ce.from=je;function Se(ie){const Oe=new v.$HN(O.to(ie),ie.message,U.to(ie.severity));return Oe.source=ie.source,Oe.code=(0,a.$fg)(ie.code)?ie.code:ie.code?.value,Oe.relatedInformation=ie.relatedInformation&&ie.relatedInformation.map(re.to),Oe.tags=ie.tags&&(0,r.$Jb)(ie.tags.map(B.to)),Oe}Ce.to=Se})(_||(e.Diagnostic=_={}));var re;(function(Ce){function je(ie){return{...O.from(ie.location.range),message:ie.message,resource:ie.location.uri}}Ce.from=je;function Se(ie){return new v.$GN(new v.$FN(ie.resource,O.to(ie)),ie.message)}Ce.to=Se})(re||(e.DiagnosticRelatedInformation=re={}));var U;(function(Ce){function je(ie){switch(ie){case v.DiagnosticSeverity.Error:return i.MarkerSeverity.Error;case v.DiagnosticSeverity.Warning:return i.MarkerSeverity.Warning;case v.DiagnosticSeverity.Information:return i.MarkerSeverity.Info;case v.DiagnosticSeverity.Hint:return i.MarkerSeverity.Hint}return i.MarkerSeverity.Error}Ce.from=je;function Se(ie){switch(ie){case i.MarkerSeverity.Info:return v.DiagnosticSeverity.Information;case i.MarkerSeverity.Warning:return v.DiagnosticSeverity.Warning;case i.MarkerSeverity.Error:return v.DiagnosticSeverity.Error;case i.MarkerSeverity.Hint:return v.DiagnosticSeverity.Hint;default:return v.DiagnosticSeverity.Error}}Ce.to=Se})(U||(e.DiagnosticSeverity=U={}));var G;(function(Ce){function je(ie){return typeof ie=="number"&&ie>=v.ViewColumn.One?ie-1:ie===v.ViewColumn.Beside?b.$lE:b.$kE}Ce.from=je;function Se(ie){if(typeof ie=="number"&&ie>=0)return ie+1;throw new Error("invalid 'EditorGroupColumn'")}Ce.to=Se})(G||(e.ViewColumn=G={}));function Q(Ce){return typeof Ce.range<"u"}function ee(Ce){return Ce.length===0?!0:!!Q(Ce[0])}var he;(function(Ce){function je(Qe){return Qe.map(Ce.from)}Ce.fromMany=je;function Se(Qe){return Qe&&typeof Qe=="object"&&typeof Qe.language=="string"&&typeof Qe.value=="string"}function ie(Qe){let ft;if(Se(Qe)){const{language:jt,value:Xt}=Qe;ft={value:"```"+jt+`
`+Xt+"\n```\n"}}else v.$VN.isMarkdownString(Qe)?ft={value:Qe.value,isTrusted:Qe.isTrusted,supportThemeIcons:Qe.supportThemeIcons,supportHtml:Qe.supportHtml,baseUri:Qe.baseUri}:typeof Qe=="string"?ft={value:Qe}:ft={value:""};const Ct=Object.create(null);ft.uris=Ct;const Jt=jt=>{try{let Xt=f.URI.parse(jt,!0);Xt=Xt.with({query:Oe(Xt.query,Ct)}),Ct[jt]=Xt}catch{}return""},ci=new $.marked.Renderer;return ci.link=Jt,ci.image=jt=>typeof jt=="string"?Jt(T.$$k(jt).href):"",(0,$.marked)(ft.value,{renderer:ci}),ft}Ce.from=ie;function Oe(Qe,ft){if(!Qe)return Qe;let Ct;try{Ct=(0,c.$bi)(Qe)}catch{}if(!Ct)return Qe;let Jt=!1;return Ct=(0,E.$do)(Ct,ci=>{if(f.URI.isUri(ci)){const jt=`__uri_${Math.random().toString(16).slice(2,8)}`;return ft[jt]=ci,Jt=!0,jt}else return}),Jt?JSON.stringify(Ct):Qe}function Ve(Qe){const ft=new v.$VN(Qe.value,Qe.supportThemeIcons);return ft.isTrusted=Qe.isTrusted,ft.supportHtml=Qe.supportHtml,ft.baseUri=Qe.baseUri?f.URI.from(Qe.baseUri):void 0,ft}Ce.to=Ve;function tt(Qe){if(Qe)return typeof Qe=="string"?Qe:Ce.from(Qe)}Ce.fromStrict=tt})(he||(e.MarkdownString=he={}));function ne(Ce){return ee(Ce)?Ce.map(je=>({range:O.from(je.range),hoverMessage:Array.isArray(je.hoverMessage)?he.fromMany(je.hoverMessage):je.hoverMessage?he.from(je.hoverMessage):void 0,renderOptions:je.renderOptions})):Ce.map(je=>({range:O.from(je)}))}function De(Ce){return typeof Ce>"u"?Ce:typeof Ce=="string"?f.URI.file(Ce):Ce}var $e;(function(Ce){function je(Se){return typeof Se>"u"?Se:{contentText:Se.contentText,contentIconPath:Se.contentIconPath?De(Se.contentIconPath):void 0,border:Se.border,borderColor:Se.borderColor,fontStyle:Se.fontStyle,fontWeight:Se.fontWeight,textDecoration:Se.textDecoration,color:Se.color,backgroundColor:Se.backgroundColor,margin:Se.margin,width:Se.width,height:Se.height}}Ce.from=je})($e||(e.ThemableDecorationAttachmentRenderOptions=$e={}));var K;(function(Ce){function je(Se){return typeof Se>"u"?Se:{backgroundColor:Se.backgroundColor,outline:Se.outline,outlineColor:Se.outlineColor,outlineStyle:Se.outlineStyle,outlineWidth:Se.outlineWidth,border:Se.border,borderColor:Se.borderColor,borderRadius:Se.borderRadius,borderSpacing:Se.borderSpacing,borderStyle:Se.borderStyle,borderWidth:Se.borderWidth,fontStyle:Se.fontStyle,fontWeight:Se.fontWeight,textDecoration:Se.textDecoration,cursor:Se.cursor,color:Se.color,opacity:Se.opacity,letterSpacing:Se.letterSpacing,gutterIconPath:Se.gutterIconPath?De(Se.gutterIconPath):void 0,gutterIconSize:Se.gutterIconSize,overviewRulerColor:Se.overviewRulerColor,before:Se.before?$e.from(Se.before):void 0,after:Se.after?$e.from(Se.after):void 0}}Ce.from=je})(K||(e.ThemableDecorationRenderOptions=K={}));var W;(function(Ce){function je(Se){if(typeof Se>"u")return Se;switch(Se){case v.DecorationRangeBehavior.OpenOpen:return t.TrackedRangeStickiness.AlwaysGrowsWhenTypingAtEdges;case v.DecorationRangeBehavior.ClosedClosed:return t.TrackedRangeStickiness.NeverGrowsWhenTypingAtEdges;case v.DecorationRangeBehavior.OpenClosed:return t.TrackedRangeStickiness.GrowsOnlyWhenTypingBefore;case v.DecorationRangeBehavior.ClosedOpen:return t.TrackedRangeStickiness.GrowsOnlyWhenTypingAfter}}Ce.from=je})(W||(e.DecorationRangeBehavior=W={}));var se;(function(Ce){function je(Se){return{isWholeLine:Se.isWholeLine,rangeBehavior:Se.rangeBehavior?W.from(Se.rangeBehavior):void 0,overviewRulerLane:Se.overviewRulerLane,light:Se.light?K.from(Se.light):void 0,dark:Se.dark?K.from(Se.dark):void 0,backgroundColor:Se.backgroundColor,outline:Se.outline,outlineColor:Se.outlineColor,outlineStyle:Se.outlineStyle,outlineWidth:Se.outlineWidth,border:Se.border,borderColor:Se.borderColor,borderRadius:Se.borderRadius,borderSpacing:Se.borderSpacing,borderStyle:Se.borderStyle,borderWidth:Se.borderWidth,fontStyle:Se.fontStyle,fontWeight:Se.fontWeight,textDecoration:Se.textDecoration,cursor:Se.cursor,color:Se.color,opacity:Se.opacity,letterSpacing:Se.letterSpacing,gutterIconPath:Se.gutterIconPath?De(Se.gutterIconPath):void 0,gutterIconSize:Se.gutterIconSize,overviewRulerColor:Se.overviewRulerColor,before:Se.before?$e.from(Se.before):void 0,after:Se.after?$e.from(Se.after):void 0}}Ce.from=je})(se||(e.DecorationRenderOptions=se={}));var oe;(function(Ce){function je(ie){return{text:ie.newText,eol:ie.newEol&&Me.from(ie.newEol),range:O.from(ie.range)}}Ce.from=je;function Se(ie){const Oe=new v.$AN(O.to(ie.range),ie.text);return Oe.newEol=typeof ie.eol>"u"?void 0:Me.to(ie.eol),Oe}Ce.to=Se})(oe||(e.TextEdit=oe={}));var te;(function(Ce){function je(ie,Oe){const Ve={edits:[]};if(ie instanceof v.$DN){const tt=new N.$Dc;for(const Qe of ie._allEntries())Qe._type===v.FileEditType.File&&f.URI.isUri(Qe.to)&&Qe.from===void 0&&tt.add(Qe.to);for(const Qe of ie._allEntries())if(Qe._type===v.FileEditType.File){let ft;Qe.options?.contents&&(ArrayBuffer.isView(Qe.options.contents)?ft={type:"base64",value:(0,h.$9e)(h.$Oe.wrap(Qe.options.contents))}:ft={type:"dataTransferItem",id:Qe.options.contents._itemId}),Ve.edits.push({oldResource:Qe.from,newResource:Qe.to,options:{...Qe.options,contents:ft},metadata:Qe.metadata})}else Qe._type===v.FileEditType.Text?Ve.edits.push({resource:Qe.uri,textEdit:oe.from(Qe.edit),versionId:tt.has(Qe.uri)?void 0:Oe?.getTextDocumentVersion(Qe.uri),metadata:Qe.metadata}):Qe._type===v.FileEditType.Snippet?Ve.edits.push({resource:Qe.uri,textEdit:{range:O.from(Qe.range),text:Qe.edit.value,insertAsSnippet:!0},versionId:tt.has(Qe.uri)?void 0:Oe?.getTextDocumentVersion(Qe.uri),metadata:Qe.metadata}):Qe._type===v.FileEditType.Cell?Ve.edits.push({metadata:Qe.metadata,resource:Qe.uri,cellEdit:Qe.edit,notebookMetadata:Qe.notebookMetadata,notebookVersionId:Oe?.getNotebookDocumentVersion(Qe.uri)}):Qe._type===v.FileEditType.CellReplace&&Ve.edits.push({metadata:Qe.metadata,resource:Qe.uri,notebookVersionId:Oe?.getNotebookDocumentVersion(Qe.uri),cellEdit:{editType:y.CellEditType.Replace,index:Qe.index,count:Qe.count,cells:Qe.cells.map(At.from)}})}return Ve}Ce.from=je;function Se(ie){const Oe=new v.$DN,Ve=new N.$Cc;for(const tt of ie.edits)if(tt.textEdit){const Qe=tt,ft=f.URI.revive(Qe.resource),Ct=O.to(Qe.textEdit.range),Jt=Qe.textEdit.text,ci=Qe.textEdit.insertAsSnippet;let jt;ci?jt=v.$CN.replace(Ct,new v.$EN(Jt)):jt=v.$AN.replace(Ct,Jt);const Xt=Ve.get(ft);Xt?Xt.push(jt):Ve.set(ft,[jt])}else Oe.renameFile(f.URI.revive(tt.oldResource),f.URI.revive(tt.newResource),tt.options);for(const[tt,Qe]of Ve)Oe.set(tt,Qe);return Oe}Ce.to=Se})(te||(e.WorkspaceEdit=te={}));var le;(function(Ce){const je=Object.create(null);je[v.SymbolKind.File]=o.SymbolKind.File,je[v.SymbolKind.Module]=o.SymbolKind.Module,je[v.SymbolKind.Namespace]=o.SymbolKind.Namespace,je[v.SymbolKind.Package]=o.SymbolKind.Package,je[v.SymbolKind.Class]=o.SymbolKind.Class,je[v.SymbolKind.Method]=o.SymbolKind.Method,je[v.SymbolKind.Property]=o.SymbolKind.Property,je[v.SymbolKind.Field]=o.SymbolKind.Field,je[v.SymbolKind.Constructor]=o.SymbolKind.Constructor,je[v.SymbolKind.Enum]=o.SymbolKind.Enum,je[v.SymbolKind.Interface]=o.SymbolKind.Interface,je[v.SymbolKind.Function]=o.SymbolKind.Function,je[v.SymbolKind.Variable]=o.SymbolKind.Variable,je[v.SymbolKind.Constant]=o.SymbolKind.Constant,je[v.SymbolKind.String]=o.SymbolKind.String,je[v.SymbolKind.Number]=o.SymbolKind.Number,je[v.SymbolKind.Boolean]=o.SymbolKind.Boolean,je[v.SymbolKind.Array]=o.SymbolKind.Array,je[v.SymbolKind.Object]=o.SymbolKind.Object,je[v.SymbolKind.Key]=o.SymbolKind.Key,je[v.SymbolKind.Null]=o.SymbolKind.Null,je[v.SymbolKind.EnumMember]=o.SymbolKind.EnumMember,je[v.SymbolKind.Struct]=o.SymbolKind.Struct,je[v.SymbolKind.Event]=o.SymbolKind.Event,je[v.SymbolKind.Operator]=o.SymbolKind.Operator,je[v.SymbolKind.TypeParameter]=o.SymbolKind.TypeParameter;function Se(Oe){return typeof je[Oe]=="number"?je[Oe]:o.SymbolKind.Property}Ce.from=Se;function ie(Oe){for(const Ve in je)if(je[Ve]===Oe)return Number(Ve);return v.SymbolKind.Property}Ce.to=ie})(le||(e.SymbolKind=le={}));var ue;(function(Ce){function je(ie){switch(ie){case v.SymbolTag.Deprecated:return o.SymbolTag.Deprecated}}Ce.from=je;function Se(ie){switch(ie){case o.SymbolTag.Deprecated:return v.SymbolTag.Deprecated}}Ce.to=Se})(ue||(e.SymbolTag=ue={}));var X;(function(Ce){function je(ie){return{name:ie.name,kind:le.from(ie.kind),tags:ie.tags&&ie.tags.map(ue.from),containerName:ie.containerName,location:Ue.from(ie.location)}}Ce.from=je;function Se(ie){const Oe=new v.$MN(ie.name,le.to(ie.kind),ie.containerName,Ue.to(ie.location));return Oe.tags=ie.tags&&ie.tags.map(ue.to),Oe}Ce.to=Se})(X||(e.WorkspaceSymbol=X={}));var ae;(function(Ce){function je(ie){const Oe={name:ie.name||"!!MISSING: name!!",detail:ie.detail,range:O.from(ie.range),selectionRange:O.from(ie.selectionRange),kind:le.from(ie.kind),tags:ie.tags?.map(ue.from)??[]};return ie.children&&(Oe.children=ie.children.map(je)),Oe}Ce.from=je;function Se(ie){const Oe=new v.$NN(ie.name,ie.detail,le.to(ie.kind),O.to(ie.range),O.to(ie.selectionRange));return(0,r.$Nb)(ie.tags)&&(Oe.tags=ie.tags.map(ue.to)),ie.children&&(Oe.children=ie.children.map(Se)),Oe}Ce.to=Se})(ae||(e.DocumentSymbol=ae={}));var pe;(function(Ce){function je(ie){const Oe=new v.$RN(le.to(ie.kind),ie.name,ie.detail||"",f.URI.revive(ie.uri),O.to(ie.range),O.to(ie.selectionRange));return Oe._sessionId=ie._sessionId,Oe._itemId=ie._itemId,Oe}Ce.to=je;function Se(ie,Oe,Ve){if(Oe=Oe??ie._sessionId,Ve=Ve??ie._itemId,Oe===void 0||Ve===void 0)throw new Error("invalid item");return{_sessionId:Oe,_itemId:Ve,name:ie.name,detail:ie.detail,kind:le.from(ie.kind),uri:ie.uri,range:O.from(ie.range),selectionRange:O.from(ie.selectionRange),tags:ie.tags?.map(ue.from)}}Ce.from=Se})(pe||(e.CallHierarchyItem=pe={}));var be;(function(Ce){function je(Se){return new v.$SN(pe.to(Se.from),Se.fromRanges.map(ie=>O.to(ie)))}Ce.to=je})(be||(e.CallHierarchyIncomingCall=be={}));var Fe;(function(Ce){function je(Se){return new v.$TN(pe.to(Se.to),Se.fromRanges.map(ie=>O.to(ie)))}Ce.to=je})(Fe||(e.CallHierarchyOutgoingCall=Fe={}));var Ue;(function(Ce){function je(ie){return{range:ie.range&&O.from(ie.range),uri:ie.uri}}Ce.from=je;function Se(ie){return new v.$FN(f.URI.revive(ie.uri),O.to(ie.range))}Ce.to=Se})(Ue||(e.location=Ue={}));var ke;(function(Ce){function je(ie){const Oe=ie,Ve=ie;return{originSelectionRange:Oe.originSelectionRange?O.from(Oe.originSelectionRange):void 0,uri:Oe.targetUri?Oe.targetUri:Ve.uri,range:O.from(Oe.targetRange?Oe.targetRange:Ve.range),targetSelectionRange:Oe.targetSelectionRange?O.from(Oe.targetSelectionRange):void 0}}Ce.from=je;function Se(ie){return{targetUri:f.URI.revive(ie.uri),targetRange:O.to(ie.range),targetSelectionRange:ie.targetSelectionRange?O.to(ie.targetSelectionRange):void 0,originSelectionRange:ie.originSelectionRange?O.to(ie.originSelectionRange):void 0}}Ce.to=Se})(ke||(e.DefinitionLink=ke={}));var Ie;(function(Ce){function je(ie){return{range:O.from(ie.range),contents:he.fromMany(ie.contents),canIncreaseVerbosity:ie.canIncreaseVerbosity,canDecreaseVerbosity:ie.canDecreaseVerbosity}}Ce.from=je;function Se(ie){const Oe=ie.contents.map(he.to),Ve=O.to(ie.range),tt=ie.canIncreaseVerbosity,Qe=ie.canDecreaseVerbosity;return new v.$JN(Oe,Ve,tt,Qe)}Ce.to=Se})(Ie||(e.Hover=Ie={}));var Re;(function(Ce){function je(ie){return{range:O.from(ie.range),expression:ie.expression}}Ce.from=je;function Se(ie){return new v.$EO(O.to(ie.range),ie.expression)}Ce.to=Se})(Re||(e.EvaluatableExpression=Re={}));var q;(function(Ce){function je(ie){if(ie instanceof v.$FO)return{type:"text",range:O.from(ie.range),text:ie.text};if(ie instanceof v.$GO)return{type:"variable",range:O.from(ie.range),variableName:ie.variableName,caseSensitiveLookup:ie.caseSensitiveLookup};if(ie instanceof v.$HO)return{type:"expression",range:O.from(ie.range),expression:ie.expression};throw new Error("Unknown 'InlineValue' type")}Ce.from=je;function Se(ie){switch(ie.type){case"text":return{range:O.to(ie.range),text:ie.text};case"variable":return{range:O.to(ie.range),variableName:ie.variableName,caseSensitiveLookup:ie.caseSensitiveLookup};case"expression":return{range:O.to(ie.range),expression:ie.expression}}}Ce.to=Se})(q||(e.InlineValue=q={}));var V;(function(Ce){function je(ie){return{frameId:ie.frameId,stoppedLocation:O.from(ie.stoppedLocation)}}Ce.from=je;function Se(ie){return new v.$IO(ie.frameId,O.to(ie.stoppedLocation))}Ce.to=Se})(V||(e.InlineValueContext=V={}));var J;(function(Ce){function je(ie){return{range:O.from(ie.range),kind:ie.kind}}Ce.from=je;function Se(ie){return new v.$KN(O.to(ie.range),ie.kind)}Ce.to=Se})(J||(e.DocumentHighlight=J={}));var x;(function(Ce){function je(ie){return{uri:ie.uri,highlights:ie.highlights.map(J.from)}}Ce.from=je;function Se(ie){return new v.$LN(f.URI.revive(ie.uri),ie.highlights.map(J.to))}Ce.to=Se})(x||(e.MultiDocumentHighlight=x={}));var fe;(function(Ce){function je(Se){switch(Se){case o.CompletionTriggerKind.TriggerCharacter:return v.CompletionTriggerKind.TriggerCharacter;case o.CompletionTriggerKind.TriggerForIncompleteCompletions:return v.CompletionTriggerKind.TriggerForIncompleteCompletions;case o.CompletionTriggerKind.Invoke:default:return v.CompletionTriggerKind.Invoke}}Ce.to=je})(fe||(e.CompletionTriggerKind=fe={}));var we;(function(Ce){function je(Se){return{triggerKind:fe.to(Se.triggerKind),triggerCharacter:Se.triggerCharacter}}Ce.to=je})(we||(e.CompletionContext=we={}));var Le;(function(Ce){function je(ie){switch(ie){case v.CompletionItemTag.Deprecated:return o.CompletionItemTag.Deprecated}}Ce.from=je;function Se(ie){switch(ie){case o.CompletionItemTag.Deprecated:return v.CompletionItemTag.Deprecated}}Ce.to=Se})(Le||(e.CompletionItemTag=Le={}));var He;(function(Ce){const je=new Map([[v.CompletionItemKind.Method,o.CompletionItemKind.Method],[v.CompletionItemKind.Function,o.CompletionItemKind.Function],[v.CompletionItemKind.Constructor,o.CompletionItemKind.Constructor],[v.CompletionItemKind.Field,o.CompletionItemKind.Field],[v.CompletionItemKind.Variable,o.CompletionItemKind.Variable],[v.CompletionItemKind.Class,o.CompletionItemKind.Class],[v.CompletionItemKind.Interface,o.CompletionItemKind.Interface],[v.CompletionItemKind.Struct,o.CompletionItemKind.Struct],[v.CompletionItemKind.Module,o.CompletionItemKind.Module],[v.CompletionItemKind.Property,o.CompletionItemKind.Property],[v.CompletionItemKind.Unit,o.CompletionItemKind.Unit],[v.CompletionItemKind.Value,o.CompletionItemKind.Value],[v.CompletionItemKind.Constant,o.CompletionItemKind.Constant],[v.CompletionItemKind.Enum,o.CompletionItemKind.Enum],[v.CompletionItemKind.EnumMember,o.CompletionItemKind.EnumMember],[v.CompletionItemKind.Keyword,o.CompletionItemKind.Keyword],[v.CompletionItemKind.Snippet,o.CompletionItemKind.Snippet],[v.CompletionItemKind.Text,o.CompletionItemKind.Text],[v.CompletionItemKind.Color,o.CompletionItemKind.Color],[v.CompletionItemKind.File,o.CompletionItemKind.File],[v.CompletionItemKind.Reference,o.CompletionItemKind.Reference],[v.CompletionItemKind.Folder,o.CompletionItemKind.Folder],[v.CompletionItemKind.Event,o.CompletionItemKind.Event],[v.CompletionItemKind.Operator,o.CompletionItemKind.Operator],[v.CompletionItemKind.TypeParameter,o.CompletionItemKind.TypeParameter],[v.CompletionItemKind.Issue,o.CompletionItemKind.Issue],[v.CompletionItemKind.User,o.CompletionItemKind.User]]);function Se(Ve){return je.get(Ve)??o.CompletionItemKind.Property}Ce.from=Se;const ie=new Map([[o.CompletionItemKind.Method,v.CompletionItemKind.Method],[o.CompletionItemKind.Function,v.CompletionItemKind.Function],[o.CompletionItemKind.Constructor,v.CompletionItemKind.Constructor],[o.CompletionItemKind.Field,v.CompletionItemKind.Field],[o.CompletionItemKind.Variable,v.CompletionItemKind.Variable],[o.CompletionItemKind.Class,v.CompletionItemKind.Class],[o.CompletionItemKind.Interface,v.CompletionItemKind.Interface],[o.CompletionItemKind.Struct,v.CompletionItemKind.Struct],[o.CompletionItemKind.Module,v.CompletionItemKind.Module],[o.CompletionItemKind.Property,v.CompletionItemKind.Property],[o.CompletionItemKind.Unit,v.CompletionItemKind.Unit],[o.CompletionItemKind.Value,v.CompletionItemKind.Value],[o.CompletionItemKind.Constant,v.CompletionItemKind.Constant],[o.CompletionItemKind.Enum,v.CompletionItemKind.Enum],[o.CompletionItemKind.EnumMember,v.CompletionItemKind.EnumMember],[o.CompletionItemKind.Keyword,v.CompletionItemKind.Keyword],[o.CompletionItemKind.Snippet,v.CompletionItemKind.Snippet],[o.CompletionItemKind.Text,v.CompletionItemKind.Text],[o.CompletionItemKind.Color,v.CompletionItemKind.Color],[o.CompletionItemKind.File,v.CompletionItemKind.File],[o.CompletionItemKind.Reference,v.CompletionItemKind.Reference],[o.CompletionItemKind.Folder,v.CompletionItemKind.Folder],[o.CompletionItemKind.Event,v.CompletionItemKind.Event],[o.CompletionItemKind.Operator,v.CompletionItemKind.Operator],[o.CompletionItemKind.TypeParameter,v.CompletionItemKind.TypeParameter],[o.CompletionItemKind.User,v.CompletionItemKind.User],[o.CompletionItemKind.Issue,v.CompletionItemKind.Issue]]);function Oe(Ve){return ie.get(Ve)??v.CompletionItemKind.Property}Ce.to=Oe})(He||(e.CompletionItemKind=He={}));var Ke;(function(Ce){function je(Se,ie){const Oe=new v.$2N(Se.label);return Oe.insertText=Se.insertText,Oe.kind=He.to(Se.kind),Oe.tags=Se.tags?.map(Le.to),Oe.detail=Se.detail,Oe.documentation=T.$5k(Se.documentation)?he.to(Se.documentation):Se.documentation,Oe.sortText=Se.sortText,Oe.filterText=Se.filterText,Oe.preselect=Se.preselect,Oe.commitCharacters=Se.commitCharacters,m.$Ht.isIRange(Se.range)?Oe.range=O.to(Se.range):typeof Se.range=="object"&&(Oe.range={inserting:O.to(Se.range.insert),replacing:O.to(Se.range.replace)}),Oe.keepWhitespace=typeof Se.insertTextRules>"u"?!1:!!(Se.insertTextRules&o.CompletionItemInsertTextRule.KeepWhitespace),typeof Se.insertTextRules<"u"&&Se.insertTextRules&o.CompletionItemInsertTextRule.InsertAsSnippet?Oe.insertText=new v.$EN(Se.insertText):(Oe.insertText=Se.insertText,Oe.textEdit=Oe.range instanceof v.$vN?new v.$AN(Oe.range,Oe.insertText):void 0),Se.additionalTextEdits&&Se.additionalTextEdits.length>0&&(Oe.additionalTextEdits=Se.additionalTextEdits.map(Ve=>oe.to(Ve))),Oe.command=ie&&Se.command?ie.fromInternal(Se.command):void 0,Oe}Ce.to=je})(Ke||(e.CompletionItem=Ke={}));var et;(function(Ce){function je(ie){if(typeof ie.label!="string"&&!Array.isArray(ie.label))throw new TypeError("Invalid label");return{label:ie.label,documentation:he.fromStrict(ie.documentation)}}Ce.from=je;function Se(ie){return{label:ie.label,documentation:T.$5k(ie.documentation)?he.to(ie.documentation):ie.documentation}}Ce.to=Se})(et||(e.ParameterInformation=et={}));var rt;(function(Ce){function je(ie){return{label:ie.label,documentation:he.fromStrict(ie.documentation),parameters:Array.isArray(ie.parameters)?ie.parameters.map(et.from):[],activeParameter:ie.activeParameter}}Ce.from=je;function Se(ie){return{label:ie.label,documentation:T.$5k(ie.documentation)?he.to(ie.documentation):ie.documentation,parameters:Array.isArray(ie.parameters)?ie.parameters.map(et.to):[],activeParameter:ie.activeParameter}}Ce.to=Se})(rt||(e.SignatureInformation=rt={}));var ot;(function(Ce){function je(ie){return{activeSignature:ie.activeSignature,activeParameter:ie.activeParameter,signatures:Array.isArray(ie.signatures)?ie.signatures.map(rt.from):[]}}Ce.from=je;function Se(ie){return{activeSignature:ie.activeSignature,activeParameter:ie.activeParameter,signatures:Array.isArray(ie.signatures)?ie.signatures.map(rt.to):[]}}Ce.to=Se})(ot||(e.SignatureHelp=ot={}));var nt;(function(Ce){function je(Se,ie){const Oe=new v.$1N(z.to(ie.position),typeof ie.label=="string"?ie.label:ie.label.map(ct.to.bind(void 0,Se)),ie.kind&&mt.to(ie.kind));return Oe.textEdits=ie.textEdits&&ie.textEdits.map(oe.to),Oe.tooltip=T.$5k(ie.tooltip)?he.to(ie.tooltip):ie.tooltip,Oe.paddingLeft=ie.paddingLeft,Oe.paddingRight=ie.paddingRight,Oe}Ce.to=je})(nt||(e.InlayHint=nt={}));var ct;(function(Ce){function je(Se,ie){const Oe=new v.$ZN(ie.label);return Oe.tooltip=T.$5k(ie.tooltip)?he.to(ie.tooltip):ie.tooltip,o.Command.is(ie.command)&&(Oe.command=Se.fromInternal(ie.command)),ie.location&&(Oe.location=Ue.to(ie.location)),Oe}Ce.to=je})(ct||(e.InlayHintLabelPart=ct={}));var mt;(function(Ce){function je(ie){return ie}Ce.from=je;function Se(ie){return ie}Ce.to=Se})(mt||(e.InlayHintKind=mt={}));var dt;(function(Ce){function je(ie){return{range:O.from(ie.range),url:ie.target,tooltip:ie.tooltip}}Ce.from=je;function Se(ie){let Oe;if(ie.url)try{Oe=typeof ie.url=="string"?f.URI.parse(ie.url,!0):f.URI.revive(ie.url)}catch{}const Ve=new v.$7N(O.to(ie.range),Oe);return Ve.tooltip=ie.tooltip,Ve}Ce.to=Se})(dt||(e.DocumentLink=dt={}));var at;(function(Ce){function je(ie){const Oe=new v.$0N(ie.label);return ie.textEdit&&(Oe.textEdit=oe.to(ie.textEdit)),ie.additionalTextEdits&&(Oe.additionalTextEdits=ie.additionalTextEdits.map(Ve=>oe.to(Ve))),Oe}Ce.to=je;function Se(ie){return{label:ie.label,textEdit:ie.textEdit?oe.from(ie.textEdit):void 0,additionalTextEdits:ie.additionalTextEdits?ie.additionalTextEdits.map(Oe=>oe.from(Oe)):void 0}}Ce.from=Se})(at||(e.ColorPresentation=at={}));var Pe;(function(Ce){function je(ie){return new v.$8N(ie[0],ie[1],ie[2],ie[3])}Ce.to=je;function Se(ie){return[ie.red,ie.green,ie.blue,ie.alpha]}Ce.from=Se})(Pe||(e.Color=Pe={}));var ze;(function(Ce){function je(ie){return{range:O.from(ie.range)}}Ce.from=je;function Se(ie){return new v.$QN(O.to(ie.range))}Ce.to=Se})(ze||(e.SelectionRange=ze={}));var Ze;(function(Ce){function je(Se){switch(Se){case l.SaveReason.AUTO:return v.TextDocumentSaveReason.AfterDelay;case l.SaveReason.EXPLICIT:return v.TextDocumentSaveReason.Manual;case l.SaveReason.FOCUS_CHANGE:case l.SaveReason.WINDOW_CHANGE:return v.TextDocumentSaveReason.FocusOut}}Ce.to=je})(Ze||(e.TextDocumentSaveReason=Ze={}));var Te;(function(Ce){function je(ie){switch(ie){case v.TextEditorLineNumbersStyle.Off:return d.RenderLineNumbersType.Off;case v.TextEditorLineNumbersStyle.Relative:return d.RenderLineNumbersType.Relative;case v.TextEditorLineNumbersStyle.Interval:return d.RenderLineNumbersType.Interval;case v.TextEditorLineNumbersStyle.On:default:return d.RenderLineNumbersType.On}}Ce.from=je;function Se(ie){switch(ie){case d.RenderLineNumbersType.Off:return v.TextEditorLineNumbersStyle.Off;case d.RenderLineNumbersType.Relative:return v.TextEditorLineNumbersStyle.Relative;case d.RenderLineNumbersType.Interval:return v.TextEditorLineNumbersStyle.Interval;case d.RenderLineNumbersType.On:default:return v.TextEditorLineNumbersStyle.On}}Ce.to=Se})(Te||(e.TextEditorLineNumbersStyle=Te={}));var Me;(function(Ce){function je(ie){if(ie===v.EndOfLine.CRLF)return t.EndOfLineSequence.CRLF;if(ie===v.EndOfLine.LF)return t.EndOfLineSequence.LF}Ce.from=je;function Se(ie){if(ie===t.EndOfLineSequence.CRLF)return v.EndOfLine.CRLF;if(ie===t.EndOfLineSequence.LF)return v.EndOfLine.LF}Ce.to=Se})(Me||(e.EndOfLine=Me={}));var Y;(function(Ce){function je(Se){if(typeof Se=="object")return Se.viewId;switch(Se){case v.ProgressLocation.SourceControl:return s.ProgressLocation.Scm;case v.ProgressLocation.Window:return s.ProgressLocation.Window;case v.ProgressLocation.Notification:return s.ProgressLocation.Notification}throw new Error("Unknown 'ProgressLocation'")}Ce.from=je})(Y||(e.ProgressLocation=Y={}));var de;(function(Ce){function je(ie){const Oe={start:ie.start+1,end:ie.end+1};return ie.kind&&(Oe.kind=Ae.from(ie.kind)),Oe}Ce.from=je;function Se(ie){const Oe={start:ie.start-1,end:ie.end-1};return ie.kind&&(Oe.kind=Ae.to(ie.kind)),Oe}Ce.to=Se})(de||(e.FoldingRange=de={}));var Ae;(function(Ce){function je(ie){if(ie)switch(ie){case v.FoldingRangeKind.Comment:return o.$Hu.Comment;case v.FoldingRangeKind.Imports:return o.$Hu.Imports;case v.FoldingRangeKind.Region:return o.$Hu.Region}}Ce.from=je;function Se(ie){if(ie)switch(ie.value){case o.$Hu.Comment.value:return v.FoldingRangeKind.Comment;case o.$Hu.Imports.value:return v.FoldingRangeKind.Imports;case o.$Hu.Region.value:return v.FoldingRangeKind.Region}}Ce.to=Se})(Ae||(e.FoldingRangeKind=Ae={}));var Xe;(function(Ce){function je(Se){if(Se)return{pinned:typeof Se.preview=="boolean"?!Se.preview:void 0,inactive:Se.background,preserveFocus:Se.preserveFocus,selection:typeof Se.selection=="object"?O.from(Se.selection):void 0,override:typeof Se.override=="boolean"?l.$OF.id:void 0}}Ce.from=je})(Xe||(e.TextEditorOpenOptions=Xe={}));var _e;(function(Ce){function je(Ve){return Ve instanceof v.$sO?Ve.toJSON():typeof Ve=="string"?Ve:Se(Ve)||ie(Ve)?new v.$sO(Ve.baseUri??Ve.base,Ve.pattern).toJSON():Ve}Ce.from=je;function Se(Ve){const tt=Ve;return tt?f.URI.isUri(tt.baseUri)&&typeof tt.pattern=="string":!1}function ie(Ve){const tt=Ve;return tt?typeof tt.base=="string"&&typeof tt.pattern=="string":!1}function Oe(Ve){return typeof Ve=="string"?Ve:new v.$sO(f.URI.revive(Ve.baseUri),Ve.pattern)}Ce.to=Oe})(_e||(e.GlobPattern=_e={}));var ut;(function(Ce){function je(Se){if(Se){if(Array.isArray(Se))return Se.map(je);if(typeof Se=="string")return Se;{const ie=Se;return{language:ie.language,scheme:ie.scheme,pattern:_e.from(ie.pattern),exclusive:ie.exclusive,notebookType:ie.notebookType}}}else return}Ce.from=je})(ut||(e.LanguageSelector=ut={}));var gt;(function(Ce){function je(ie){return!!ie&&typeof ie=="object"&&"documents"in ie&&Array.isArray(ie.documents)&&ie.documents.every(Oe=>Array.isArray(Oe)&&Oe.every(Ve=>Ve&&typeof Ve=="object"&&"uri"in Ve&&f.URI.isUri(Ve.uri)&&"version"in Ve&&typeof Ve.version=="number"&&"ranges"in Ve&&Array.isArray(Ve.ranges)&&Ve.ranges.every(tt=>tt instanceof v.$vN)))}Ce.is=je;function Se(ie){return{documents:ie.documents.map(Oe=>Oe.map(Ve=>({uri:f.URI.from(Ve.uri),version:Ve.version,ranges:Ve.ranges.map(tt=>O.from(tt))})))}}Ce.from=Se})(gt||(e.MappedEditsContext=gt={}));var kt;(function(Ce){function je(ie){return{start:ie.start,end:ie.end}}Ce.from=je;function Se(ie){return new v.$VO(ie.start,ie.end)}Ce.to=Se})(kt||(e.NotebookRange=kt={}));var Lt;(function(Ce){function je(ie){return{timing:typeof ie.runStartTime=="number"&&typeof ie.runEndTime=="number"?{startTime:ie.runStartTime,endTime:ie.runEndTime}:void 0,executionOrder:ie.executionOrder,success:ie.lastRunSuccess}}Ce.to=je;function Se(ie){return{lastRunSuccess:ie.success,runStartTime:ie.timing?.startTime,runEndTime:ie.timing?.endTime,executionOrder:ie.executionOrder}}Ce.from=Se})(Lt||(e.NotebookCellExecutionSummary=Lt={}));var Bt;(function(Ce){function je(Se){if(Se===y.NotebookCellExecutionState.Unconfirmed)return v.NotebookCellExecutionState.Pending;if(Se===y.NotebookCellExecutionState.Pending)return;if(Se===y.NotebookCellExecutionState.Executing)return v.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${Se}`)}Ce.to=je})(Bt||(e.NotebookCellExecutionState=Bt={}));var di;(function(Ce){function je(ie){switch(ie){case v.NotebookCellKind.Markup:return y.CellKind.Markup;case v.NotebookCellKind.Code:default:return y.CellKind.Code}}Ce.from=je;function Se(ie){switch(ie){case y.CellKind.Markup:return v.NotebookCellKind.Markup;case y.CellKind.Code:default:return v.NotebookCellKind.Code}}Ce.to=Se})(di||(e.NotebookCellKind=di={}));var it;(function(Ce){function je(ie){const Oe={metadata:ie.metadata??Object.create(null),cells:[]};for(const Ve of ie.cells)v.$WO.validate(Ve),Oe.cells.push(At.from(Ve));return Oe}Ce.from=je;function Se(ie){const Oe=new v.$XO(ie.cells.map(At.to));return(0,a.$sg)(ie.metadata)||(Oe.metadata=ie.metadata),Oe}Ce.to=Se})(it||(e.NotebookData=it={}));var At;(function(Ce){function je(ie){return{cellKind:di.from(ie.kind),language:ie.languageId,mime:ie.mime,source:ie.value,metadata:ie.metadata,internalMetadata:Lt.from(ie.executionSummary??{}),outputs:ie.outputs?ie.outputs.map(Kt.from):[]}}Ce.from=je;function Se(ie){return new v.$WO(di.to(ie.cellKind),ie.source,ie.language,ie.mime,ie.outputs?ie.outputs.map(Kt.to):void 0,ie.metadata,ie.internalMetadata?Lt.to(ie.internalMetadata):void 0)}Ce.to=Se})(At||(e.NotebookCellData=At={}));var Zt;(function(Ce){function je(ie){return{mime:ie.mime,valueBytes:h.$Oe.wrap(ie.data)}}Ce.from=je;function Se(ie){return new v.$YO(ie.valueBytes.buffer,ie.mime)}Ce.to=Se})(Zt||(e.NotebookCellOutputItem=Zt={}));var Kt;(function(Ce){function je(ie){return{outputId:ie.id,items:ie.items.map(Zt.from),metadata:ie.metadata}}Ce.from=je;function Se(ie){const Oe=ie.items.map(Zt.to);return new v.$ZO(Oe,ie.outputId,ie.metadata)}Ce.to=Se})(Kt||(e.NotebookCellOutput=Kt={}));var pt;(function(Ce){function je(Oe){return ie(Oe)?{include:_e.from(Oe.include)??void 0,exclude:_e.from(Oe.exclude)??void 0}:_e.from(Oe)??void 0}Ce.from=je;function Se(Oe){return ie(Oe)?{include:_e.to(Oe.include),exclude:_e.to(Oe.exclude)}:_e.to(Oe)}Ce.to=Se;function ie(Oe){const Ve=Oe;return Ve?!(0,a.$og)(Ve.include)&&!(0,a.$og)(Ve.exclude):!1}})(pt||(e.NotebookExclusiveDocumentPattern=pt={}));var vt;(function(Ce){function je(Se,ie,Oe){const Ve=typeof Se.command=="string"?{title:"",command:Se.command}:Se.command;return{alignment:Se.alignment===v.NotebookCellStatusBarAlignment.Left?y.CellStatusbarAlignment.Left:y.CellStatusbarAlignment.Right,command:ie.toInternal(Ve,Oe),text:Se.text,tooltip:Se.tooltip,accessibilityInformation:Se.accessibilityInformation,priority:Se.priority}}Ce.from=je})(vt||(e.NotebookStatusBarItem=vt={}));var ii;(function(Ce){function je(Se,ie,Oe){const Ve=typeof Se.command=="string"?{title:"",command:Se.command}:Se.command;return{command:ie.toInternal(Ve,Oe),label:Se.label,description:Se.description,detail:Se.detail,documentation:Se.documentation}}Ce.from=je})(ii||(e.NotebookKernelSourceAction=ii={}));var xt;(function(Ce){function je(Se){return{transientOutputs:Se?.transientOutputs??!1,transientCellMetadata:Se?.transientCellMetadata??{},transientDocumentMetadata:Se?.transientDocumentMetadata??{},cellContentMetadata:Se?.cellContentMetadata??{}}}Ce.from=je})(xt||(e.NotebookDocumentContentOptions=xt={}));var Vt;(function(Ce){function je(ie){return{uri:ie.uri,provides:ie.provides}}Ce.from=je;function Se(ie){return new v.$2O(f.URI.revive(ie.uri),ie.provides)}Ce.to=Se})(Vt||(e.NotebookRendererScript=Vt={}));var Et;(function(Ce){function je(ie){return{message:he.fromStrict(ie.message)||"",type:A.TestMessageType.Error,expected:ie.expectedOutput,actual:ie.actualOutput,contextValue:ie.contextValue,location:ie.location&&{range:O.from(ie.location.range),uri:ie.location.uri}}}Ce.from=je;function Se(ie){const Oe=new v.$8O(typeof ie.message=="string"?ie.message:he.to(ie.message));return Oe.actualOutput=ie.actual,Oe.expectedOutput=ie.expected,Oe.contextValue=ie.contextValue,Oe.location=ie.location?Ue.to(ie.location):void 0,Oe}Ce.to=Se})(Et||(e.TestMessage=Et={}));var Ft;(function(Ce){Ce.namespace=A.$VI,Ce.denamespace=A.$WI})(Ft||(e.TestTag=Ft={}));var li;(function(Ce){function je(ie){const Oe=(0,g.$TP)(ie).controllerId;return{extId:C.$QI.fromExtHostTestItem(ie,Oe).toString(),label:ie.label,uri:f.URI.revive(ie.uri),busy:ie.busy,tags:ie.tags.map(Ve=>Ft.namespace(Oe,Ve.id)),range:m.$Ht.lift(O.from(ie.range)),description:ie.description||null,sortText:ie.sortText||null,error:ie.error&&he.fromStrict(ie.error)||null}}Ce.from=je;function Se(ie){return{parent:void 0,error:void 0,id:C.$QI.fromString(ie.extId).localId,label:ie.label,uri:f.URI.revive(ie.uri),tags:(ie.tags||[]).map(Oe=>{const{tagId:Ve}=Ft.denamespace(Oe);return new v.$9O(Ve)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:O.to(ie.range||void 0),canResolveChildren:!1,busy:ie.busy,description:ie.description||void 0,sortText:ie.sortText||void 0}}Ce.toPlain=Se})(li||(e.TestItem=li={})),function(Ce){function je(ie){return{id:ie.id}}Ce.from=je;function Se(ie){return new v.$9O(ie.id)}Ce.to=Se}(Ft||(e.TestTag=Ft={}));var Gt;(function(Ce){const je=(ie,Oe)=>{const Ve=ie.value;if(!Ve)return;const tt={...li.toPlain(Ve.item),parent:Oe,taskStates:Ve.tasks.map(Qe=>({state:Qe.state,duration:Qe.duration,messages:Qe.messages.filter(ft=>ft.type===A.TestMessageType.Error).map(Et.to)})),children:[]};if(ie.children)for(const Qe of ie.children.values()){const ft=je(Qe,tt);ft&&tt.children.push(ft)}return tt};function Se(ie){const Oe=new u.$PI;for(const Qe of ie.items)Oe.insert(C.$QI.fromString(Qe.item.extId).path,Qe);const Ve=[Oe.nodes],tt=[];for(;Ve.length;)for(const Qe of Ve.pop())Qe.value?tt.push(Qe):Qe.children&&Ve.push(Qe.children.values());return{completedAt:ie.completedAt,results:tt.map(Qe=>je(Qe)).filter(a.$ng)}}Ce.to=Se})(Gt||(e.TestResults=Gt={}));var xe;(function(Ce){function je(Ve){return{covered:Ve.covered,total:Ve.total}}function Se(Ve){return"line"in Ve?z.from(Ve):O.from(Ve)}function ie(Ve){if(typeof Ve.executed=="number"&&Ve.executed<0)throw new Error(`Invalid coverage count ${Ve.executed}`);return"branches"in Ve?{count:Ve.executed,location:Se(Ve.location),type:A.DetailType.Statement,branches:Ve.branches.length?Ve.branches.map(tt=>({count:tt.executed,location:tt.location&&Se(tt.location),label:tt.label})):void 0}:{type:A.DetailType.Declaration,name:Ve.name,count:Ve.executed,location:Se(Ve.location)}}Ce.fromDetails=ie;function Oe(Ve,tt,Qe){return v.$$O(Qe.statementCoverage),v.$$O(Qe.branchCoverage),v.$$O(Qe.declarationCoverage),{id:tt,uri:Qe.uri,statement:je(Qe.statementCoverage),branch:Qe.branchCoverage&&je(Qe.branchCoverage),declaration:Qe.declarationCoverage&&je(Qe.declarationCoverage),testIds:Qe instanceof v.$_O&&Qe.fromTests.length?Qe.fromTests.map(ft=>C.$QI.fromExtHostTestItem(ft,Ve).toString()):void 0}}Ce.fromFile=Oe})(xe||(e.TestCoverage=xe={}));var _t;(function(Ce){function je(Se){switch(Se){case o.CodeActionTriggerType.Invoke:return v.CodeActionTriggerKind.Invoke;case o.CodeActionTriggerType.Auto:return v.CodeActionTriggerKind.Automatic}}Ce.to=je})(_t||(e.CodeActionTriggerKind=_t={}));var ni;(function(Ce){function je(ie){const Oe=new v.$dP(le.to(ie.kind),ie.name,ie.detail||"",f.URI.revive(ie.uri),O.to(ie.range),O.to(ie.selectionRange));return Oe._sessionId=ie._sessionId,Oe._itemId=ie._itemId,Oe}Ce.to=je;function Se(ie,Oe,Ve){if(Oe=Oe??ie._sessionId,Ve=Ve??ie._itemId,Oe===void 0||Ve===void 0)throw new Error("invalid item");return{_sessionId:Oe,_itemId:Ve,kind:le.from(ie.kind),name:ie.name,detail:ie.detail??"",uri:ie.uri,range:O.from(ie.range),selectionRange:O.from(ie.selectionRange),tags:ie.tags?.map(ue.from)}}Ce.from=Se})(ni||(e.TypeHierarchyItem=ni={}));var ui;(function(Ce){function je(Se){if(Se)return{value:Se.value,tooltip:Se.tooltip}}Ce.from=je})(ui||(e.ViewBadge=ui={}));var It;(function(Ce){function je(Ve,tt,Qe){const ft=tt.fileData;return ft?new v.$kO(new v.$lO(ft.name,f.URI.revive(ft.uri),ft.id,(0,R.$fb)(()=>Qe(ft.id)))):Ve===I.$4s.uriList&&tt.uriListData?new v.$jO(Oe(tt.uriListData)):new v.$jO(tt.asString)}Ce.to=je;async function Se(Ve,tt){const Qe=await tt.asString();if(Ve===I.$4s.uriList)return{asString:Qe,fileData:void 0,uriListData:ie(Qe)};const ft=tt.asFile();return{asString:Qe,fileData:ft?{name:ft.name,uri:ft.uri,id:ft._itemId??ft.id}:void 0}}Ce.from=Se;function ie(Ve){return P.$lu.split(Ve).map(tt=>{if(tt.startsWith("#"))return tt;try{return f.URI.parse(tt)}catch{}return tt})}function Oe(Ve){return P.$lu.create(Ve.map(tt=>typeof tt=="string"?tt:f.URI.revive(tt)))}})(It||(e.DataTransferItem=It={}));var Mt;(function(Ce){function je(ie,Oe){const Ve=ie.items.map(([tt,Qe])=>[tt,It.to(tt,Qe,Oe)]);return new v.$mO(Ve)}Ce.toDataTransfer=je;async function Se(ie){const Oe={items:[]},Ve=[];for(const[tt,Qe]of ie)Ve.push((async()=>{Oe.items.push([tt,await It.from(tt,Qe)])})());return await Promise.all(Ve),Oe}Ce.from=Se})(Mt||(e.DataTransfer=Mt={}));var Nt;(function(Ce){function je(ie,Oe){return{kind:"reply",agentId:ie.participant??Oe?.agentId??"",subCommand:ie.command??Oe?.command,message:ie.prompt,title:ie.label}}Ce.from=je;function Se(ie){return{prompt:ie.message,label:ie.title,participant:ie.agentId,command:ie.subCommand}}Ce.to=Se})(Nt||(e.ChatFollowup=Nt={}));var Ut;(function(Ce){function je(ie){switch(ie){case S.ChatMessageRole.System:return v.LanguageModelChatMessageRole.System;case S.ChatMessageRole.User:return v.LanguageModelChatMessageRole.User;case S.ChatMessageRole.Assistant:return v.LanguageModelChatMessageRole.Assistant}}Ce.to=je;function Se(ie){switch(ie){case v.LanguageModelChatMessageRole.System:return S.ChatMessageRole.System;case v.LanguageModelChatMessageRole.User:return S.ChatMessageRole.User;case v.LanguageModelChatMessageRole.Assistant:return S.ChatMessageRole.Assistant}return S.ChatMessageRole.User}Ce.from=Se})(Ut||(e.LanguageModelChatMessageRole=Ut={}));var ri;(function(Ce){function je(ie){let Oe="",Ve;ie.content.type==="text"?Oe=ie.content.value:Ve=new v.$EP(ie.content.name,ie.content.value,ie.content.isError);const tt=Ut.to(ie.role),Qe=new v.$FP(tt,Oe,ie.name);return Ve!==void 0&&(Qe.content2=Ve),Qe}Ce.to=je;function Se(ie){const Oe=Ut.from(ie.role),Ve=ie.name;let tt;return ie.content2 instanceof v.$EP?tt={type:"function_result",name:ie.content2.name,value:ie.content2.content,isError:ie.content2.isError}:tt={type:"text",value:ie.content},{role:Oe,name:Ve,content:tt}}Ce.from=Se})(ri||(e.LanguageModelChatMessage=ri={}));var ei;(function(Ce){function je(ie){return{kind:"markdownContent",content:he.from(ie.value)}}Ce.from=je;function Se(ie){return new v.$qP(he.to(ie.content))}Ce.to=Se})(ei||(e.ChatResponseMarkdownPart=ei={}));var si;(function(Ce){function je(ie){return{kind:"markdownVuln",content:he.from(ie.value),vulnerabilities:ie.vulnerabilities}}Ce.from=je;function Se(ie){return new v.$rP(he.to(ie.content),ie.vulnerabilities)}Ce.to=Se})(si||(e.ChatResponseMarkdownWithVulnerabilitiesPart=si={}));var Wt;(function(Ce){function je(ie){return{kind:"agentDetection",agentId:ie.participant,command:ie.command}}Ce.from=je;function Se(ie){return new v.$sP(ie.agentId,ie.command)}Ce.to=Se})(Wt||(e.ChatResponseDetectedParticipantPart=Wt={}));var Qt;(function(Ce){function je(Se){return{kind:"confirmation",title:Se.title,message:Se.message,data:Se.data}}Ce.from=je})(Qt||(e.ChatResponseConfirmationPart=Qt={}));var oi;(function(Ce){function je(ie){const{value:Oe,baseUri:Ve}=ie;function tt(Qe,ft){return Qe.map(Ct=>{const Jt=f.URI.joinPath(ft,Ct.name);return{label:Ct.name,uri:Jt,children:Ct.children&&tt(Ct.children,Jt)}})}return{kind:"treeData",treeData:{label:(0,k.$dh)(Ve),uri:Ve,children:tt(Oe,Ve)}}}Ce.from=je;function Se(ie){const Oe=(0,c.$ci)(ie.treeData);function Ve(ft){return ft.map(Ct=>({name:Ct.label,children:Ct.children&&Ve(Ct.children)}))}const tt=Oe.uri,Qe=Oe.children?Ve(Oe.children):[];return new v.$uP(Qe,tt)}Ce.to=Se})(oi||(e.ChatResponseFilesPart=oi={}));var Rt;(function(Ce){function je(ie){const Oe=Ve=>f.URI.isUri(Ve);return{kind:"inlineReference",name:ie.title,inlineReference:Oe(ie.value)?ie.value:M.from(ie.value)}}Ce.from=je;function Se(ie){const Oe=(0,c.$ci)(ie);return new v.$vP(f.URI.isUri(Oe.inlineReference)?Oe.inlineReference:M.to(Oe.inlineReference),ie.name)}Ce.to=Se})(Rt||(e.ChatResponseAnchorPart=Rt={}));var Dt;(function(Ce){function je(ie){return{kind:"progressMessage",content:he.from(ie.value)}}Ce.from=je;function Se(ie){return new v.$wP(ie.content.value)}Ce.to=Se})(Dt||(e.ChatResponseProgressPart=Dt={}));var wt;(function(Ce){function je(ie){return{kind:"warning",content:he.from(ie.value)}}Ce.from=je;function Se(ie){return new v.$yP(ie.content.value)}Ce.to=Se})(wt||(e.ChatResponseWarningPart=wt={}));var ti;(function(Ce){function je(Se){return{kind:"progressTask",content:he.from(Se.value)}}Ce.from=je})(ti||(e.ChatTask=ti={}));var Pt;(function(Ce){function je(Se){return{kind:"progressTaskResult",content:typeof Se=="string"?he.from(Se):void 0}}Ce.from=je})(Pt||(e.ChatTaskResult=Pt={}));var hi;(function(Ce){function je(ie,Oe,Ve){return{kind:"command",command:Oe.toInternal(ie.value,Ve)??{command:ie.value.command,title:ie.value.title}}}Ce.from=je;function Se(ie,Oe){return new v.$zP(Oe.fromInternal(ie.command)??{command:ie.command.id,title:ie.command.title})}Ce.to=Se})(hi||(e.ChatResponseCommandButtonPart=hi={}));var Ht;(function(Ce){function je(ie){return{kind:"textEdit",uri:ie.uri,edits:ie.edits.map(Oe=>oe.from(Oe))}}Ce.from=je;function Se(ie){return new v.$BP(f.URI.revive(ie.uri),ie.edits.map(Oe=>oe.to(Oe)))}Ce.to=Se})(Ht||(e.ChatResponseTextEditPart=Ht={}));var bi;(function(Ce){function je(ie){const Oe=p.ThemeIcon.isThemeIcon(ie.iconPath)?ie.iconPath:f.URI.isUri(ie.iconPath)?{light:f.URI.revive(ie.iconPath)}:ie.iconPath&&"light"in ie.iconPath&&"dark"in ie.iconPath&&f.URI.isUri(ie.iconPath.light)&&f.URI.isUri(ie.iconPath.dark)?{light:f.URI.revive(ie.iconPath.light),dark:f.URI.revive(ie.iconPath.dark)}:void 0;return"variableName"in ie.value?{kind:"reference",reference:{variableName:ie.value.variableName,value:f.URI.isUri(ie.value.value)||!ie.value.value?ie.value.value:M.from(ie.value.value)},iconPath:Oe}:{kind:"reference",reference:f.URI.isUri(ie.value)?ie.value:M.from(ie.value),iconPath:Oe}}Ce.from=je;function Se(ie){const Oe=(0,c.$ci)(ie),Ve=tt=>f.URI.isUri(tt)?tt:M.to(tt);return new v.$AP("variableName"in Oe.reference?{variableName:Oe.reference.variableName,value:Oe.reference.value&&Ve(Oe.reference.value)}:Ve(Oe.reference))}Ce.to=Se})(bi||(e.ChatResponseReferencePart=bi={}));var wi;(function(Ce){function je(Oe,Ve,tt){return Oe instanceof v.$qP?ei.from(Oe):Oe instanceof v.$vP?Rt.from(Oe):Oe instanceof v.$AP?bi.from(Oe):Oe instanceof v.$wP?Dt.from(Oe):Oe instanceof v.$uP?oi.from(Oe):Oe instanceof v.$zP?hi.from(Oe,Ve,tt):Oe instanceof v.$BP?Ht.from(Oe):Oe instanceof v.$rP?si.from(Oe):Oe instanceof v.$sP?Wt.from(Oe):Oe instanceof v.$yP?wt.from(Oe):{kind:"markdownContent",content:he.from("")}}Ce.from=je;function Se(Oe,Ve){switch(Oe.kind){case"reference":return bi.to(Oe);case"markdownContent":case"inlineReference":case"progressMessage":case"treeData":case"command":return ie(Oe,Ve)}}Ce.to=Se;function ie(Oe,Ve){switch(Oe.kind){case"markdownContent":return ei.to(Oe);case"inlineReference":return Rt.to(Oe);case"progressMessage":return;case"treeData":return oi.to(Oe);case"command":return hi.to(Oe,Ve)}}Ce.toContent=ie})(wi||(e.ChatResponsePart=wi={}));var fi;(function(Ce){function je(Se){return{prompt:Se.message,command:Se.command,attempt:Se.attempt??0,enableCommandDetection:Se.enableCommandDetection??!0,references:Se.variables.variables.map(ai.to),location:qt.to(Se.location),acceptedConfirmationData:Se.acceptedConfirmationData,rejectedConfirmationData:Se.rejectedConfirmationData}}Ce.to=je})(fi||(e.ChatAgentRequest=fi={}));var qt;(function(Ce){function je(ie){switch(ie){case w.ChatAgentLocation.Notebook:return v.ChatLocation.Notebook;case w.ChatAgentLocation.Terminal:return v.ChatLocation.Terminal;case w.ChatAgentLocation.Panel:return v.ChatLocation.Panel;case w.ChatAgentLocation.Editor:return v.ChatLocation.Editor}}Ce.to=je;function Se(ie){switch(ie){case v.ChatLocation.Notebook:return w.ChatAgentLocation.Notebook;case v.ChatLocation.Terminal:return w.ChatAgentLocation.Terminal;case v.ChatLocation.Panel:return w.ChatAgentLocation.Panel;case v.ChatLocation.Editor:return w.ChatAgentLocation.Editor}}Ce.from=Se})(qt||(e.ChatLocation=qt={}));var ai;(function(Ce){function je(Se){const ie=Se.value;if(!ie)throw new Error("Invalid value reference");return{id:Se.id,name:Se.name,range:Se.range&&[Se.range.start,Se.range.endExclusive],value:(0,f.$xc)(ie)?f.URI.revive(ie):ie&&typeof ie=="object"&&"uri"in ie&&"range"in ie&&(0,f.$xc)(ie.uri)?M.to((0,c.$ci)(ie)):ie,modelDescription:Se.modelDescription}}Ce.to=je})(ai||(e.ChatAgentValueReference=ai={}));var Ii;(function(Ce){function je(Se,ie,Oe){return{id:Se.id,label:Se.label,fullName:Se.fullName,icon:Se.icon?.id,value:Se.values[0].value,insertText:Se.insertText,detail:Se.detail,documentation:Se.documentation,command:ie.toInternal(Se.command,Oe)}}Ce.from=je})(Ii||(e.ChatAgentCompletionItem=Ii={}));var Tt;(function(Ce){function je(Se){return{errorDetails:Se.errorDetails,metadata:Se.metadata}}Ce.to=je})(Tt||(e.ChatAgentResult=Tt={}));var yi;(function(Ce){function je(Se,ie,Oe){if(ie.action.kind==="vote")return;const Ve=Tt.to(Se);if(ie.action.kind==="command"){const tt=ie.action.commandButton.command;return{action:{kind:"command",commandButton:{command:Oe.fromInternal(tt)??{command:tt.id,title:tt.title}}},result:Ve}}else return ie.action.kind==="followUp"?{action:{kind:"followUp",followup:Nt.to(ie.action.followup)},result:Ve}:ie.action.kind==="inlineChat"?{action:{kind:"editor",accepted:ie.action.action==="accepted"},result:Ve}:{action:ie.action,result:Ve}}Ce.to=je})(yi||(e.ChatAgentUserActionEvent=yi={}));var Pi;(function(Ce){function je(Se,ie,Oe){return"terminalCommand"in Se?{terminalCommand:Se.terminalCommand,shouldExecute:Se.shouldExecute}:"uri"in Se?{uri:Se.uri}:ie.toInternal(Se,Oe)}Ce.from=je})(Pi||(e.TerminalQuickFix=Pi={}));var Si;(function(Ce){function je(Se){return{kind:mi.to(Se.kind)}}Ce.to=je})(Si||(e.PartialAcceptInfo=Si={}));var mi;(function(Ce){function je(Se){switch(Se){case o.PartialAcceptTriggerKind.Word:return v.PartialAcceptTriggerKind.Word;case o.PartialAcceptTriggerKind.Line:return v.PartialAcceptTriggerKind.Line;case o.PartialAcceptTriggerKind.Suggest:return v.PartialAcceptTriggerKind.Suggest;default:return v.PartialAcceptTriggerKind.Unknown}}Ce.to=je})(mi||(e.PartialAcceptTriggerKind=mi={}));var Ci;(function(Ce){function je(Se,ie){return{id:ie,label:Se.label,description:Se.description,canEdit:Se.canEdit,collapsibleState:Se.collapsibleState||D.DebugTreeItemCollapsibleState.None,contextValue:Se.contextValue}}Ce.from=je})(Ci||(e.DebugTreeItem=Ci={}))}),define(Ee[346],ye([1,0,6,20,17,51]),function(ce,e,r,h,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6nc=void 0;let T=class{constructor($,c){this.a=$.getProxy(r.$rN.MainThreadBulkEdits),this.b={getTextDocumentVersion:I=>c.getDocument(I)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit($,c,I){const E=new R.$Pw(P.WorkspaceEdit.from($,this.b));return this.a.$tryApplyWorkspaceEdit(E,void 0,I?.isRefactoring??!1)}};e.$6nc=T,e.$6nc=T=Je([Ge(0,h.$XP)],T)}),define(Ee[347],ye([1,0,19,9,55,4,40,3,43,18,2,24,6,17,10,307,26]),function(ce,e,r,h,P,R,T,N,$,c,I,E,u,k,p,a,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7nc=void 0,k=We(k),p=We(p);class d{constructor(t,i,s,g,l){this.j=t,this.k=i,this.l=s,this.m=g,this.n=l,this.b=$.$ge.create(!1),this.c=!1}close(){this.c=!0}get timings(){return{firstProgress:this.d,totalElapsed:this.b.elapsed()}}get apiObject(){if(!this.g){let i=function(g){if(t.c){const l=new Error("Response stream has been closed");throw Error.captureStackTrace(l,g),l}};const t=this;this.b.reset();const s=(g,l)=>{if(typeof this.d>"u"&&"content"in g&&(this.d=this.b.elapsed()),l){const w=this.l.$handleProgressChunk(this.k.requestId,g),S={report:D=>{w?.then(y=>{y&&(p.$VN.isMarkdownString(D.value)?this.l.$handleProgressChunk(this.k.requestId,k.ChatResponseWarningPart.from(D),y):this.l.$handleProgressChunk(this.k.requestId,k.ChatResponseReferencePart.from(D),y))})}};Promise.all([w,l?.(S)]).then(([D,y])=>{D!==void 0&&y!==void 0&&this.l.$handleProgressChunk(this.k.requestId,k.ChatTaskResult.from(y),D)})}else this.l.$handleProgressChunk(this.k.requestId,g)};this.g={markdown(g){i(this.markdown);const l=new p.$qP(g),w=k.ChatResponseMarkdownPart.from(l);return s(w),this},markdownWithVulnerabilities(g,l){i(this.markdown),l&&(0,f.$4G)(t.j,"chatParticipantAdditions");const w=new p.$rP(g,l),S=k.ChatResponseMarkdownWithVulnerabilitiesPart.from(w);return s(S),this},filetree(g,l){i(this.filetree);const w=new p.$uP(g,l),S=k.ChatResponseFilesPart.from(w);return s(S),this},anchor(g,l){i(this.anchor);const w=new p.$vP(g,l),S=k.ChatResponseAnchorPart.from(w);return s(S),this},button(g){i(this.anchor);const l=new p.$zP(g),w=k.ChatResponseCommandButtonPart.from(l,t.m,t.n);return s(w),this},progress(g,l){i(this.progress);const w=new p.$xP(g,l),S=l?k.ChatTask.from(w):k.ChatResponseProgressPart.from(w);return s(S,l),this},warning(g){i(this.progress),(0,f.$4G)(t.j,"chatParticipantAdditions");const l=new p.$yP(g),w=k.ChatResponseWarningPart.from(l);return s(w),this},reference(g,l){if(i(this.reference),"variableName"in g&&(0,f.$4G)(t.j,"chatParticipantAdditions"),"variableName"in g&&!g.value){const w=t.k.variables.variables.find(S=>S.name===g.variableName);if(w){let S;if(w.references?.length)S=w.references.map(D=>({kind:"reference",reference:{variableName:g.variableName,value:D.reference}}));else{const D=new p.$AP(g,l);S=[k.ChatResponseReferencePart.from(D)]}return S.forEach(D=>s(D)),this}}else{const w=new p.$AP(g,l),S=k.ChatResponseReferencePart.from(w);s(S)}return this},textEdit(g,l){i(this.textEdit),(0,f.$4G)(t.j,"chatParticipantAdditions");const w=new p.$BP(g,l),S=k.ChatResponseTextEditPart.from(w);return s(S),this},detectedParticipant(g,l){i(this.detectedParticipant),(0,f.$4G)(t.j,"chatParticipantAdditions");const w=new p.$sP(g,l),S=k.ChatResponseDetectedParticipantPart.from(w);return s(S),this},confirmation(g,l,w){i(this.confirmation),(0,f.$4G)(t.j,"chatParticipantAdditions");const S=new p.$tP(g,l,w),D=k.ChatResponseConfirmationPart.from(S);return s(D),this},push(g){if(i(this.push),(g instanceof p.$BP||g instanceof p.$rP||g instanceof p.$sP||g instanceof p.$yP||g instanceof p.$tP)&&(0,f.$4G)(t.j,"chatParticipantAdditions"),g instanceof p.$AP)this.reference(g.value,g.iconPath);else{const l=k.ChatResponsePart.from(g,t.m,t.n);s(l)}return this}}}return this.g}}class m extends N.$Wc{static{this.b=0}constructor(t,i,s,g){super(),this.n=i,this.s=s,this.t=g,this.c=new Map,this.j=this.B(new N.$6c),this.m=this.B(new N.$6c),this.g=t.getProxy(u.$rN.MainThreadChatAgents2)}transferActiveChat(t){this.g.$transferActiveChatSession(t)}createChatAgent(t,i,s){const g=m.b++,l=new n(t,this.t,i,this.g,g,s);return this.c.set(g,l),l.isAgentEnabled()&&this.g.$registerAgent(g,t.identifier,i,{},void 0),l.apiAgent}createDynamicChatAgent(t,i,s,g){const l=m.b++,w=new n(t,this.t,i,this.g,l,g);return this.c.set(l,w),this.g.$registerAgent(l,t.identifier,i,{isSticky:!0},s),w.apiAgent}async $invokeAgent(t,i,s,g){const l=this.c.get(t);if(!l)throw new Error(`[CHAT](${t}) CANNOT invoke agent because the agent is not registered`);let w=this.j.get(i.sessionId);w||(w=new N.$Vc,this.j.set(i.sessionId,w));const S=new d(l.extension,i,this.g,this.s.converter,w);try{const D=await this.u(i.agentId,s),y=l.invoke(k.ChatAgentRequest.to(i),{history:D},S.apiObject,g);return await(0,h.$th)(Promise.resolve(y).then(C=>{if(C?.metadata)try{JSON.stringify(C.metadata)}catch(b){const v=`result.metadata MUST be JSON.stringify-able. Got error: ${b.message}`;return this.n.error(`[${l.extension.identifier.value}] [@${l.id}] ${v}`,l.extension),{errorDetails:{message:v},timings:S.timings}}let A;return C?.errorDetails&&(A={...C.errorDetails,responseIsIncomplete:!0}),A?.responseIsRedacted&&(0,f.$4G)(l.extension,"chatParticipantPrivate"),{errorDetails:A,timings:S.timings,metadata:C?.metadata}}),g)}catch(D){return this.n.error(D,l.extension),D instanceof p.$LP&&D.cause&&(D=D.cause),{errorDetails:{message:(0,P.$qj)(D),responseIsIncomplete:!0}}}finally{S.close()}}async u(t,i){const s=[];for(const g of i.history){const l=k.ChatAgentResult.to(g.result),w=t===g.request.agentId?l:{...l,metadata:void 0};s.push(new p.$CP(g.request.message,g.request.command,g.request.variables.variables.map(k.ChatAgentValueReference.to),g.request.agentId));const S=(0,r.$Jb)(g.response.map(D=>k.ChatResponsePart.toContent(D,this.s.converter)));s.push(new p.$DP(S,w,g.request.agentId,g.request.command))}return s}$releaseSession(t){this.j.deleteAndDispose(t)}async $provideFollowups(t,i,s,g,l){const w=this.c.get(i);if(!w)return Promise.resolve([]);const S=await this.u(w.id,g),D=k.ChatAgentResult.to(s);return(await w.provideFollowups(D,{history:S},l)).filter(y=>{const C=!y.participant||T.Iterable.some(this.c.values(),A=>A.id===y.participant&&E.$qn.equals(A.extension.identifier,w.extension.identifier));return C||this.n.warn(`[@${w.id}] ChatFollowup refers to an unknown participant: ${y.participant}`),C}).map(y=>k.ChatFollowup.from(y,t))}$acceptFeedback(t,i,s,g){const l=this.c.get(t);if(!l)return;const w=k.ChatAgentResult.to(i);let S;switch(s){case a.ChatAgentVoteDirection.Down:S=p.ChatResultFeedbackKind.Unhelpful;break;case a.ChatAgentVoteDirection.Up:S=p.ChatResultFeedbackKind.Helpful;break}l.acceptFeedback(Object.freeze(g?{result:w,kind:S,reportIssue:g}:{result:w,kind:S}))}$acceptAction(t,i,s){const g=this.c.get(t);if(!g||s.action.kind==="vote")return;const l=k.ChatAgentUserActionEvent.to(i,s,this.s.converter);l&&g.acceptAction(Object.freeze(l))}async $invokeCompletionProvider(t,i,s){const g=this.c.get(t);if(!g)return[];let l=this.m.get(t);return l?l.clear():(l=new N.$Vc,this.m.set(t,l)),(await g.invokeCompletionProvider(i,s)).map(S=>k.ChatAgentCompletionItem.from(S,this.s.converter,l))}async $provideWelcomeMessage(t,i,s){const g=this.c.get(t);if(g)return await g.provideWelcomeMessage(k.ChatLocation.to(i),s)}async $provideSampleQuestions(t,i,s){const g=this.c.get(t);if(g)return(await g.provideSampleQuestions(k.ChatLocation.to(i),s)).map(l=>k.ChatFollowup.from(l,void 0))}}e.$7nc=m;class n{constructor(t,i,s,g,l,w){this.extension=t,this.w=i,this.id=s,this.x=g,this.y=l,this.z=w,this.m=new R.$me,this.n=new R.$me}acceptFeedback(t){this.m.fire(t)}acceptAction(t){this.n.fire(t)}async invokeCompletionProvider(t,i){return this.q?await this.q.provider.provideCompletionItems(t,i)??[]:[]}isAgentEnabled(){return!(this.w==="stable"&&!(0,f.$3G)(this.extension,"chatParticipantPrivate"))}async provideFollowups(t,i,s){if(!this.b)return[];const g=await this.b.provideFollowups(t,i,s);return g?g.filter(l=>!(l&&"commandId"in l)).filter(l=>!(l&&"message"in l)):[]}async provideWelcomeMessage(t,i){if(!this.s)return[];const s=await this.s.provideWelcomeMessage(t,i);return s?s.map(g=>typeof g=="string"?g:k.MarkdownString.from(g)):[]}async provideSampleQuestions(t,i){if(!this.s||!this.s.provideSampleQuestions)return[];const s=await this.s.provideSampleQuestions(t,i);return s||[]}get apiAgent(){let t=!1,i=!1;const s=()=>{t||i||(i=!0,queueMicrotask(()=>{g.isAgentEnabled()&&(this.x.$updateAgent(this.y,{icon:this.c?this.c instanceof I.URI?this.c:"light"in this.c?this.c.light:void 0:void 0,iconDark:this.c&&"dark"in this.c?this.c.dark:void 0,themeIcon:this.c instanceof p.$qO?this.c:void 0,hasFollowups:this.b!==void 0,isSecondary:this.l,helpTextPrefix:!this.g||typeof this.g=="string"?this.g:k.MarkdownString.from(this.g),helpTextVariablesPrefix:!this.j||typeof this.j=="string"?this.j:k.MarkdownString.from(this.j),helpTextPostfix:!this.k||typeof this.k=="string"?this.k:k.MarkdownString.from(this.k),supportIssueReporting:this.o,requester:this.t,supportsSlowVariables:this.u}),i=!1)}))},g=this;return{get id(){return g.id},get iconPath(){return g.c},set iconPath(l){g.c=l,s()},get requestHandler(){return g.z},set requestHandler(l){(0,c.$pg)(typeof l=="function","Invalid request handler"),g.z=l},get followupProvider(){return g.b},set followupProvider(l){g.b=l,s()},get isDefault(){return(0,f.$4G)(g.extension,"defaultChatParticipant"),g.d},set isDefault(l){(0,f.$4G)(g.extension,"defaultChatParticipant"),g.d=l,s()},get helpTextPrefix(){return(0,f.$4G)(g.extension,"defaultChatParticipant"),g.g},set helpTextPrefix(l){(0,f.$4G)(g.extension,"defaultChatParticipant"),g.g=l,s()},get helpTextVariablesPrefix(){return(0,f.$4G)(g.extension,"defaultChatParticipant"),g.j},set helpTextVariablesPrefix(l){(0,f.$4G)(g.extension,"defaultChatParticipant"),g.j=l,s()},get helpTextPostfix(){return(0,f.$4G)(g.extension,"defaultChatParticipant"),g.k},set helpTextPostfix(l){(0,f.$4G)(g.extension,"defaultChatParticipant"),g.k=l,s()},get isSecondary(){return(0,f.$4G)(g.extension,"defaultChatParticipant"),g.l},set isSecondary(l){(0,f.$4G)(g.extension,"defaultChatParticipant"),g.l=l,s()},get supportIssueReporting(){return(0,f.$4G)(g.extension,"chatParticipantPrivate"),g.o},set supportIssueReporting(l){(0,f.$4G)(g.extension,"chatParticipantPrivate"),g.o=l,s()},get onDidReceiveFeedback(){return g.m.event},set participantVariableProvider(l){if((0,f.$4G)(g.extension,"chatParticipantAdditions"),g.q=l,l){if(!l.triggerCharacters.length)throw new Error("triggerCharacters are required");g.x.$registerAgentCompletionsProvider(g.y,g.id,l.triggerCharacters)}else g.x.$unregisterAgentCompletionsProvider(g.y,g.id)},get participantVariableProvider(){return(0,f.$4G)(g.extension,"chatParticipantAdditions"),g.q},set welcomeMessageProvider(l){(0,f.$4G)(g.extension,"defaultChatParticipant"),g.s=l,s()},get welcomeMessageProvider(){return(0,f.$4G)(g.extension,"defaultChatParticipant"),g.s},onDidPerformAction:(0,f.$3G)(this.extension,"chatParticipantAdditions")?this.n.event:void 0,set requester(l){g.t=l,s()},get requester(){return g.t},set supportsSlowReferences(l){(0,f.$4G)(g.extension,"chatParticipantPrivate"),g.u=l,s()},get supportsSlowReferences(){return(0,f.$4G)(g.extension,"chatParticipantPrivate"),g.u},dispose(){t=!0,g.b=void 0,g.m.dispose(),g.x.$unregisterAgent(g.y)}}}invoke(t,i,s,g){return this.z(t,i,s,g)}}}),define(Ee[348],ye([1,0,14,3,50,6,17,10,26]),function(ce,e,r,h,P,R,T,N,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8nc=void 0,T=We(T),N=We(N);class c{static{this.a=0}constructor(u){this.b=new Map,this.c=u.getProxy(R.$rN.MainThreadChatVariables)}async $resolveVariable(u,k,p,a){const f=this.b.get(u);if(f)try{if(f.resolver.resolve2){(0,$.$4G)(f.extension,"chatParticipantAdditions");const d=new I(k,this.c),m=await f.resolver.resolve2(f.data.name,{prompt:p},d.apiObject,a);if(m&&m[0])return m[0].value}else{const d=await f.resolver.resolve(f.data.name,{prompt:p},a);if(d&&d[0])return d[0].value}}catch(d){(0,r.$4)(d)}}registerVariableResolver(u,k,p,a,f,d,m,n,o){const t=c.a++,i=o?P.ThemeIcon.fromId(o):void 0;return this.b.set(t,{extension:u,data:{id:k,name:p,description:a,modelDescription:f,icon:i},resolver:m}),this.c.$registerVariable(t,{id:k,name:p,description:a,modelDescription:f,isSlow:d,fullName:n,icon:i}),(0,h.$Uc)(()=>{this.b.delete(t),this.c.$unregisterVariable(t)})}}e.$8nc=c;class I{constructor(u,k){this.c=u,this.d=k,this.a=!1}close(){this.a=!0}get apiObject(){if(!this.b){let k=function(a){if(u.a){const f=new Error("Response stream has been closed");throw Error.captureStackTrace(f,a),f}};const u=this,p=a=>{this.d.$handleProgressChunk(this.c,a)};this.b={progress(a){k(this.progress);const f=new N.$wP(a),d=T.ChatResponseProgressPart.from(f);return p(d),this},reference(a){k(this.reference);const f=new N.$AP(a),d=T.ChatResponseReferencePart.from(f);return p(d),this},push(a){return k(this.push),a instanceof N.$AP?p(T.ChatResponseReferencePart.from(a)):a instanceof N.$wP&&p(T.ChatResponseProgressPart.from(a)),this}}}return this.b}}}),define(Ee[349],ye([1,0,9,59,4,3,41,2,88,24,17,10,6,26]),function(ce,e,r,h,P,R,T,N,$,c,I,E,u,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_nc=p,$=We($),I=We(I),E=We(E);function p(a,f,d){const m=a.getProxy(u.$rN.MainThreadComments);class n{static{this.a=0}constructor(){this.b=new Map,this.c=new c.$sn,f.registerArgumentProcessor({processArgument:y=>{if(y&&y.$mid===T.MarshalledId.CommentController){const C=this.b.get(y.handle);return C?C.value:y}else if(y&&y.$mid===T.MarshalledId.CommentThread){const C=y,A=this.b.get(C.commentControlHandle);if(!A)return C;const b=A.getCommentThread(C.commentThreadHandle);return b?b.value:C}else if(y&&(y.$mid===T.MarshalledId.CommentThreadReply||y.$mid===T.MarshalledId.CommentThreadInstance)){const C=this.b.get(y.thread.commentControlHandle);if(!C)return y;const A=C.getCommentThread(y.thread.commentThreadHandle);return A?y.$mid===T.MarshalledId.CommentThreadInstance?A.value:{thread:A.value,text:y.text}:y}else if(y&&y.$mid===T.MarshalledId.CommentNode){const C=this.b.get(y.thread.commentControlHandle);if(!C)return y;const A=C.getCommentThread(y.thread.commentThreadHandle);if(!A)return y;const b=y.commentUniqueId,v=A.getCommentByUniqueId(b);return v||y}else if(y&&y.$mid===T.MarshalledId.CommentThreadNode){const C=this.b.get(y.thread.commentControlHandle);if(!C)return y;const A=C.getCommentThread(y.thread.commentThreadHandle);if(!A)return y;const b=y.text,v=y.commentUniqueId,L=A.getCommentByUniqueId(v);return L?(typeof L.body=="string"?L.body=b:L.body=new E.$VN(b),L):y}return y}})}createCommentController(y,C,A){const b=n.a++,v=new t(y,b,C,A);this.b.set(v.handle,v);const L=this.c.get(y.identifier)||[];return L.push(v),this.c.set(y.identifier,L),v.value}async $createCommentThreadTemplate(y,C,A,b){const v=this.b.get(y);v&&v.$createCommentThreadTemplate(C,A,b)}async $setActiveComment(y,C){const A=this.b.get(y);A&&A.$setActiveComment(C??void 0)}async $updateCommentThreadTemplate(y,C,A){const b=this.b.get(y);b&&b.$updateCommentThreadTemplate(C,A)}$deleteCommentThread(y,C){this.b.get(y)?.$deleteCommentThread(C)}async $provideCommentingRanges(y,C,A){const b=this.b.get(y);if(!b||!b.commentingRangeProvider)return Promise.resolve(void 0);const v=await d.ensureDocumentData(N.URI.revive(C));return(0,r.$xh)(async()=>{const L=await b.commentingRangeProvider.provideCommentingRanges(v.document,A);let O;return Array.isArray(L)?O={ranges:L,fileComments:!1}:L?O={ranges:L.ranges||[],fileComments:L.fileComments||!1}:O=L??void 0,O}).then(L=>{let O;return L&&(O={ranges:L.ranges.map(M=>I.Range.from(M)),fileComments:L.fileComments}),O})}$toggleReaction(y,C,A,b,v){const L=this.b.get(y);return!L||!L.reactionHandler?Promise.resolve(void 0):(0,r.$xh)(()=>{const O=L.getCommentThread(C);if(O){const M=O.getCommentByUniqueId(b.uniqueIdInThread);if(L!==void 0&&M&&L.reactionHandler)return L.reactionHandler(M,g(v))}return Promise.resolve(void 0)})}}class o{static{this.a=0}set threadId(y){this.n=y}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(y){(y===void 0!=(this.p===void 0)||!y||!this.p||!y.isEqual(this.p))&&(this.p=y,this.b.range=y,this.c.fire())}get range(){return this.p}set canReply(y){this.d!==y&&(this.d=y,this.b.canReply=y,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(y){this.e=y,this.b.label=y,this.c.fire()}get contextValue(){return this.f}set contextValue(y){this.f=y,this.b.contextValue=y,this.c.fire()}get comments(){return this.q}set comments(y){this.q=y,this.b.comments=y,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(y){this.g=y,this.b.collapsibleState=y,this.c.fire()}get state(){return this.h}set state(y){this.h=y,typeof y=="object"?((0,k.$4G)(this.extensionDescription,"commentThreadApplicability"),this.b.state=y.resolved,this.b.applicability=y.applicability):this.b.state=y,this.c.fire()}get isDisposed(){return this.j}constructor(y,C,A,b,v,L,O,M,j){this.m=C,this.n=A,this.o=b,this.p=v,this.q=L,this.extensionDescription=O,this.r=M,this.handle=o.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new P.$me,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new R.$Xc,this.l.value=new R.$Vc,this.n===void 0&&(this.n=`${y}.${this.handle}`),m.$createCommentThread(C,this.handle,this.n,this.o,I.Range.from(this.p),O.identifier,this.r,j),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=L,this.i.push({dispose:()=>{m.$deleteCommentThread(C,this.handle)}});const z=this;this.value={get uri(){return z.uri},get range(){return z.range},set range(F){z.range=F},get comments(){return z.comments},set comments(F){z.comments=F},get collapsibleState(){return z.collapsibleState},set collapsibleState(F){z.collapsibleState=F},get canReply(){return z.canReply},set canReply(F){z.canReply=F},get contextValue(){return z.contextValue},set contextValue(F){z.contextValue=F},get label(){return z.label},set label(F){z.label=F},get state(){return z.state},set state(F){z.state=F},reveal:F=>z.reveal(F),dispose:()=>{z.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new R.$Vc);const y=A=>Object.prototype.hasOwnProperty.call(this.b,A),C={};y("range")&&(C.range=I.Range.from(this.p)),y("label")&&(C.label=this.label),y("contextValue")&&(C.contextValue=this.contextValue??null),y("comments")&&(C.comments=this.q.map(A=>i(this,A,this.k,this.extensionDescription))),y("collapsibleState")&&(C.collapseState=l(this.g)),y("canReply")&&(C.canReply=this.canReply),y("state")&&(C.state=w(this.h)),y("applicability")&&(C.applicability=S(this.h)),y("isTemplate")&&(C.isTemplate=this.r),this.b={},m.$updateCommentThread(this.m,this.handle,this.n,this.o,C)}getCommentByUniqueId(y){for(const C of this.k){const A=C[0],b=C[1];if(y===b)return A}}async reveal(y){return(0,k.$4G)(this.extensionDescription,"commentReveal"),m.$revealCommentThread(this.m,this.handle,{preserveFocus:!1,focusReply:!1,...y})}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(y=>y.dispose())}}Je([(0,h.$$h)(100)],o.prototype,"eventuallyUpdateCommentThread",null);class t{get id(){return this.j}get label(){return this.k}get handle(){return this.i}get commentingRangeProvider(){return this.b}set commentingRangeProvider(y){this.b=y,y?.resourceHints&&(0,k.$4G)(this.h,"commentingRangeHint"),m.$updateCommentingRanges(this.handle,y?.resourceHints)}get reactionHandler(){return this.c}set reactionHandler(y){this.c=y,m.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!y})}get options(){return this.d}set options(y){this.d=y,m.$updateCommentControllerFeatures(this.handle,{options:this.d})}get activeComment(){return(0,k.$4G)(this.h,"activeComment"),this.e}get activeCommentThread(){return(0,k.$4G)(this.h,"activeComment"),this.f}constructor(y,C,A,b){this.h=y,this.i=C,this.j=A,this.k=b,this.a=new Map,m.$registerCommentController(this.handle,A,b,this.h.identifier.value);const v=this;this.value=Object.freeze({id:v.id,label:v.label,get options(){return v.options},set options(L){v.options=L},get commentingRangeProvider(){return v.commentingRangeProvider},set commentingRangeProvider(L){v.commentingRangeProvider=L},get reactionHandler(){return v.reactionHandler},set reactionHandler(L){v.reactionHandler=L},get activeCommentThread(){return v.activeCommentThread},createCommentThread(L,O,M){return v.createCommentThread(L,O,M).value},dispose:()=>{v.dispose()}}),this.g=[],this.g.push({dispose:()=>{m.$unregisterCommentController(this.handle)}})}createCommentThread(y,C,A){C===void 0&&(0,k.$4G)(this.h,"fileComments");const b=new o(this.id,this.handle,void 0,y,C,A,this.h,!1);return this.a.set(b.handle,b),b}$setActiveComment(y){if(!y){this.e=void 0,this.f=void 0;return}const C=this.a.get(y.commentThreadHandle);C&&(this.e=y.uniqueIdInThread?C.getCommentByUniqueId(y.uniqueIdInThread):void 0,this.f=C)}$createCommentThreadTemplate(y,C,A){const b=new o(this.id,this.handle,void 0,N.URI.revive(y),I.Range.to(C),[],this.h,!0,A);return b.collapsibleState=$.CommentThreadCollapsibleState.Expanded,this.a.set(b.handle,b),b}$updateCommentThreadTemplate(y,C){const A=this.a.get(y);A&&(A.range=I.Range.to(C))}$deleteCommentThread(y){this.a.get(y)?.dispose(),this.a.delete(y)}getCommentThread(y){return this.a.get(y)}dispose(){this.a.forEach(y=>{y.dispose()}),this.g.forEach(y=>y.dispose())}}function i(D,y,C,A){let b=C.get(y);return b||(b=++D.commentHandle,C.set(y,b)),y.state!==void 0&&(0,k.$4G)(A,"commentsDraftState"),y.reactions?.some(v=>v.reactors!==void 0)&&(0,k.$4G)(A,"commentReactor"),{mode:y.mode,contextValue:y.contextValue,uniqueIdInThread:b,body:typeof y.body=="string"?y.body:I.MarkdownString.from(y.body),userName:y.author.name,userIconPath:y.author.iconPath,label:y.label,commentReactions:y.reactions?y.reactions.map(v=>s(v)):void 0,state:y.state,timestamp:y.timestamp?.toJSON()}}function s(D){return{label:D.label,iconPath:D.iconPath?I.$WP(D.iconPath):void 0,count:D.count,hasReacted:D.authorHasReacted,reactors:D.reactors&&D.reactors.length>0&&typeof D.reactors[0]!="string"?D.reactors.map(y=>y.name):D.reactors}}function g(D){return{label:D.label||"",count:D.count||0,iconPath:D.iconPath?N.URI.revive(D.iconPath):"",authorHasReacted:D.hasReacted||!1,reactors:D.reactors?.map(y=>({name:y}))}}function l(D){if(D!==void 0)switch(D){case E.CommentThreadCollapsibleState.Expanded:return $.CommentThreadCollapsibleState.Expanded;case E.CommentThreadCollapsibleState.Collapsed:return $.CommentThreadCollapsibleState.Collapsed}return $.CommentThreadCollapsibleState.Collapsed}function w(D){let y;if(typeof D=="object"?y=D.resolved:y=D,y!==void 0)switch(y){case E.CommentThreadState.Unresolved:return $.CommentThreadState.Unresolved;case E.CommentThreadState.Resolved:return $.CommentThreadState.Resolved}return $.CommentThreadState.Unresolved}function S(D){let y;if(typeof D=="object"&&(y=D.applicability),y!==void 0)switch(y){case E.CommentThreadApplicability.Current:return $.CommentThreadApplicability.Current;case E.CommentThreadApplicability.Outdated:return $.CommentThreadApplicability.Outdated}return $.CommentThreadApplicability.Current}return new n}}),define(Ee[350],ye([1,0,21,60,3,15,23,2,17,97,119,6,10]),function(ce,e,r,h,P,R,T,N,$,c,I,E,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$roc=void 0,$=We($),E=We(E),u=We(u);class k{constructor(s,g){this.document=s,this.b=g,this.a=1,this.c=new I.$Rnc("custom documents")}addEdit(s){return this.c.add([s])}async undo(s,g){await this.f(s).undo(),g||this.disposeBackup()}async redo(s,g){await this.f(s).redo(),g||this.disposeBackup()}disposeEdits(s){for(const g of s)this.c.delete(g)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const s=t(this.document.uri)+this.a++;return(0,T.$gh)(this.b,s)}updateBackup(s){this.d?.delete(),this.d=s}disposeBackup(){this.d?.delete(),this.d=void 0}f(s){const g=this.c.get(s,0);if(!g)throw new Error("No edit found");return g}}class p{constructor(){this.a=new Map}get(s,g){return this.a.get(this.b(s,g))}add(s,g,l){const w=this.b(s,g.uri);if(this.a.has(w))throw new Error(`Document already exists for viewType:${s} resource:${g.uri}`);const S=new k(g,l);return this.a.set(w,S),S}delete(s,g){const l=this.b(s,g.uri);this.a.delete(l)}b(s,g){return`${s}@@@${g}`}}var a;(function(i){i[i.Text=0]="Text",i[i.Custom=1]="Custom"})(a||(a={}));class f{constructor(){this.a=new Map}addTextProvider(s,g,l){return this.b(s,{type:a.Text,extension:g,provider:l})}addCustomProvider(s,g,l){return this.b(s,{type:a.Custom,extension:g,provider:l})}get(s){return this.a.get(s)}b(s,g){if(this.a.has(s))throw new Error(`Provider for viewType:${s} already registered`);return this.a.set(s,g),new u.$tN(()=>this.a.delete(s))}}class d{constructor(s,g,l,w,S){this.d=g,this.f=l,this.g=w,this.h=S,this.b=new f,this.c=new p,this.a=s.getProxy(E.$rN.MainThreadCustomEditors)}registerCustomEditorProvider(s,g,l,w){const S=new P.$Vc;return n(l)?(S.add(this.b.addTextProvider(g,s,l)),this.a.$registerTextEditorProvider((0,c.$ooc)(s),g,w.webviewOptions||{},{supportsMove:!!l.moveCustomTextEditor},(0,c.$moc)(s))):(S.add(this.b.addCustomProvider(g,s,l)),m(l)&&S.add(l.onDidChangeCustomDocument(D=>{const y=this.i(g,D.document.uri);if(o(D)){const C=y.addEdit(D);this.a.$onDidEdit(D.document.uri,g,C,D.label)}else this.a.$onContentChange(D.document.uri,g)})),this.a.$registerCustomEditorProvider((0,c.$ooc)(s),g,w.webviewOptions||{},!!w.supportsMultipleEditorsPerDocument,(0,c.$moc)(s))),u.$tN.from(S,new u.$tN(()=>{this.a.$unregisterEditorProvider(g)}))}async $createCustomDocument(s,g,l,w,S){const D=this.b.get(g);if(!D)throw new Error(`No provider found for '${g}'`);if(D.type!==a.Custom)throw new Error(`Invalid provide type for '${g}'`);const y=N.URI.revive(s),C=await D.provider.openCustomDocument(y,{backupId:l,untitledDocumentData:w?.buffer},S);let A;return m(D.provider)&&this.f&&(A=this.f.workspaceValue(D.extension)??this.f.globalValue(D.extension)),this.c.add(g,C,A),{editable:m(D.provider)}}async $disposeCustomDocument(s,g){const l=this.b.get(g);if(!l)throw new Error(`No provider found for '${g}'`);if(l.type!==a.Custom)throw new Error(`Invalid provider type for '${g}'`);const w=N.URI.revive(s),{document:S}=this.i(g,w);this.c.delete(g,S),S.dispose()}async $resolveCustomEditor(s,g,l,w,S,D){const y=this.b.get(l);if(!y)throw new Error(`No provider found for '${l}'`);const C=$.ViewColumn.to(S),A=this.g.createNewWebview(g,w.contentOptions,y.extension),b=this.h.createNewWebviewPanel(g,l,w.title,C,w.options,A,w.active),v=N.URI.revive(s);switch(y.type){case a.Custom:{const{document:L}=this.i(l,v);return y.provider.resolveCustomEditor(L,b,D)}case a.Text:{const L=this.d.getDocument(v);return y.provider.resolveCustomTextEditor(L,b,D)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(s,g,l){this.i(g,s).disposeEdits(l)}async $onMoveCustomEditor(s,g,l){const w=this.b.get(l);if(!w)throw new Error(`No provider found for '${l}'`);if(!w.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${l}'`);const S=this.h.getWebviewPanel(s);if(!S)throw new Error("No webview found");const D=N.URI.revive(g),y=this.d.getDocument(D);await w.provider.moveCustomTextEditor(y,S,r.CancellationToken.None)}async $undo(s,g,l,w){return this.i(g,s).undo(l,w)}async $redo(s,g,l,w){return this.i(g,s).redo(l,w)}async $revert(s,g,l){const w=this.i(g,s);await this.j(g).revertCustomDocument(w.document,l),w.disposeBackup()}async $onSave(s,g,l){const w=this.i(g,s);await this.j(g).saveCustomDocument(w.document,l),w.disposeBackup()}async $onSaveAs(s,g,l,w){const S=this.i(g,s);return this.j(g).saveCustomDocumentAs(S.document,N.URI.revive(l),w)}async $backup(s,g,l){const w=this.i(g,s),D=await this.j(g).backupCustomDocument(w.document,{destination:w.getNewBackupUri()},l);return w.updateBackup(D),D.id}i(s,g){const l=this.c.get(s,N.URI.revive(g));if(!l)throw new Error("No custom document found");return l}j(s){const l=this.b.get(s)?.provider;if(!l||!m(l))throw new Error("Custom document is not editable");return l}}e.$roc=d;function m(i){return!!i.onDidChangeCustomDocument}function n(i){return typeof i.resolveCustomTextEditor=="function"}function o(i){return typeof i.undo=="function"&&typeof i.redo=="function"}function t(i){const s=i.scheme===R.Schemas.file||i.scheme===R.Schemas.untitled?i.fsPath:i.toString();return(0,h.$tj)(s)+""}}),define(Ee[351],ye([1,0,233,145,2,6,10,17,4,12,29,63]),function(ce,e,r,h,P,R,T,N,$,c,I,E){"use strict";var u;Object.defineProperty(e,"__esModule",{value:!0}),e.$Znc=e.$Ync=void 0,N=We(N);class k{#e;#t;#i;constructor(f,d,m,n,o,t,i,s){this.d=f,this.e=d,this.f=m,this.g=n,this.h=o,this.c=!1,this.f=Math.max(n,m),this.#i=new I.$Cc(g=>t.getComparisonKey(g)),this.#e=i,this.#t=s}dispose(){this.c||(this.#t.fire([...this.#i.keys()]),this.#e?.$clear(this.e),this.#i.clear(),this.c=!0)}get name(){return this.j(),this.d}set(f,d){if(!f){this.clear();return}this.j();let m=[];if(P.URI.isUri(f)){if(!d){this.delete(f);return}this.#i.set(f,d.slice()),m=[f]}else if(Array.isArray(f)){m=[];let t;f=[...f].sort(k.k);for(const i of f){const[s,g]=i;if((!t||s.toString()!==t.toString())&&(t&&this.#i.get(t).length===0&&this.#i.delete(t),t=s,m.push(s),this.#i.set(s,[])),g)this.#i.get(s)?.push(...g);else{const l=this.#i.get(s);l&&(l.length=0)}}}if(this.#t.fire(m),!this.#e)return;const n=[];let o=0;for(const t of m){let i=[];const s=this.#i.get(t);if(s)if(s.length>this.g){i=[];const g=[T.DiagnosticSeverity.Error,T.DiagnosticSeverity.Warning,T.DiagnosticSeverity.Information,T.DiagnosticSeverity.Hint];e:for(let l=0;l<4;l++)for(const w of s)if(w.severity===g[l]&&i.push({...N.Diagnostic.from(w),modelVersionId:this.h(t)})===this.g)break e;i.push({severity:h.MarkerSeverity.Info,message:(0,r.localize)(0,null,s.length-this.g),startLineNumber:i[i.length-1].startLineNumber,startColumn:i[i.length-1].startColumn,endLineNumber:i[i.length-1].endLineNumber,endColumn:i[i.length-1].endColumn})}else i=s.map(g=>({...N.Diagnostic.from(g),modelVersionId:this.h(t)}));if(n.push([t,i]),o+=i.length,o>this.f)break}this.#e.$changeMany(this.e,n)}delete(f){this.j(),this.#t.fire([f]),this.#i.delete(f),this.#e?.$changeMany(this.e,[[f,void 0]])}clear(){this.j(),this.#t.fire([...this.#i.keys()]),this.#i.clear(),this.#e?.$clear(this.e)}forEach(f,d){this.j();for(const[m,n]of this)f.call(d,m,n,this)}*[Symbol.iterator](){this.j();for(const f of this.#i.keys())yield[f,this.get(f)]}get(f){this.j();const d=this.#i.get(f);return Array.isArray(d)?Object.freeze(d.slice(0)):[]}has(f){return this.j(),Array.isArray(this.#i.get(f))}j(){if(this.c)throw new Error("illegal state - object is disposed")}static k(f,d){return f[0].toString()<d[0].toString()?-1:f[0].toString()>d[0].toString()?1:0}}e.$Ync=k;let p=class{static{u=this}static{this.c=0}static{this.d=1e3}static{this.e=1.1*u.d}static _mapper(f){const d=new I.$Cc;for(const m of f)d.set(m,m);return{uris:Object.freeze(Array.from(d.values()))}}constructor(f,d,m,n){this.j=d,this.k=m,this.l=n,this.g=new Map,this.h=new $.$qe({merge:o=>o.flat(),delay:50}),this.onDidChangeDiagnostics=$.Event.map(this.h.event,u._mapper),this.f=f.getProxy(R.$rN.MainThreadDiagnostics)}createDiagnosticCollection(f,d){const{g:m,f:n,h:o,j:t,k:i,l:s}=this,g=new class{$changeMany(S,D){n.$changeMany(S,D),t.trace("[DiagnosticCollection] change many (extension, owner, uris)",f.value,S,D.length===0?"CLEARING":D)}$clear(S){n.$clear(S),t.trace("[DiagnosticCollection] remove all (extension, owner)",f.value,S)}dispose(){n.dispose()}};let l;if(!d)d="_generated_diagnostic_collection_name_#"+u.c++,l=d;else if(!m.has(d))l=d;else{this.j.warn(`DiagnosticCollection with name '${d}' does already exist.`);do l=d+u.c++;while(m.has(l))}return new class extends k{constructor(){super(d,l,u.e,u.d,S=>s.getDocument(S)?.version,i.extUri,g,o),m.set(l,this)}dispose(){super.dispose(),m.delete(l)}}}getDiagnostics(f){if(f)return this.m(f);{const d=new Map,m=[];for(const n of this.g.values())n.forEach((o,t)=>{let i=d.get(o.toString());typeof i>"u"&&(i=m.length,d.set(o.toString(),i),m.push([o,[]])),m[i][1]=m[i][1].concat(...t)});return m}}m(f){let d=[];for(const m of this.g.values())m.has(f)&&(d=d.concat(m.get(f)));return d}$acceptMarkersChange(f){if(!this.n){const d="_generated_mirror",m=new k(d,d,Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER,n=>{},this.k.extUri,void 0,this.h);this.g.set(d,m),this.n=m}for(const[d,m]of f)this.n.set(P.URI.revive(d),m.map(N.Diagnostic.to))}};e.$Znc=p,e.$Znc=p=u=Je([Ge(1,c.$_j),Ge(2,E.$Xnc)],p)}),define(Ee[352],ye([1,0,2,14,10,17,81,51]),function(ce,e,r,h,P,R,T,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$apc=void 0;class ${constructor(I,E,u,k={timeout:1500,errors:3}){this.c=I,this.d=E,this.f=u,this.g=k,this.a=new T.$7c,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(I){return(E,u,k)=>{const a={dispose:this.a.push([E,u,I])};return Array.isArray(k)&&k.push(a),a}}async $participateInSave(I,E){const u=r.URI.revive(I);let k=!1;const p=setTimeout(()=>k=!0,this.g.timeout),a=[];try{for(const f of[...this.a]){if(k)break;const d=this.d.getDocument(u),m=await this.h(f,{document:d,reason:R.TextDocumentSaveReason.to(E)});a.push(m)}}finally{clearTimeout(p)}return a}h([I,E,u],k){const p=this.b.get(I);return typeof p=="number"&&p>this.g.errors?Promise.resolve(!1):this.i(u,I,E,k).then(()=>!0,a=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${u.identifier.value}' threw ERROR`),this.c.error(a),!(a instanceof Error)||a.message!=="concurrent_edits"){const f=this.b.get(I);this.b.set(I,f?f+1:1),typeof f=="number"&&f>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${u.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(I,E,u,k){const p=[],a=Date.now(),{document:f,reason:d}=k,{version:m}=f,n=Object.freeze({document:f,reason:d,waitUntil(o){if(Object.isFrozen(p))throw(0,h.$0)("waitUntil can not be called async");p.push(Promise.resolve(o))}});try{E.apply(u,[n])}catch(o){return Promise.reject(o)}return Object.freeze(p),new Promise((o,t)=>{const i=setTimeout(()=>t(new Error("timeout")),this.g.timeout);return Promise.all(p).then(s=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${I.identifier.value}' finished after ${Date.now()-a}ms`),clearTimeout(i),o(s)}).catch(s=>{clearTimeout(i),t(s)})}).then(o=>{const t={edits:[]};for(const i of o)if(Array.isArray(i)&&i.every(s=>s instanceof P.$AN))for(const{newText:s,newEol:g,range:l}of i)t.edits.push({resource:f.uri,versionId:void 0,textEdit:{range:l&&R.Range.from(l),text:s,eol:g&&R.EndOfLine.from(g)}});if(t.edits.length!==0)return m===f.version?this.f.$tryApplyWorkspaceEdit(new N.$Pw(t)):Promise.reject(new Error("concurrent_edits"))})}}e.$apc=$}),define(Ee[353],ye([1,0,4,3,2,6,163,17,18,25,10]),function(ce,e,r,h,P,R,T,N,$,c,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1nc=void 0,N=We(N);class E{constructor(k,p){this.a=new r.$me,this.b=new r.$me,this.c=new r.$me,this.d=new r.$me,this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new h.$Vc,this.h=new Map,this.f=k.getProxy(R.$rN.MainThreadDocuments),this.g=p,this.g.onDidRemoveDocuments(a=>{for(const f of a)this.b.fire(f.document)},void 0,this.e),this.g.onDidAddDocuments(a=>{for(const f of a)this.a.fire(f.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(k){if(!k)return;const p=this.g.getDocument(k);if(p)return p}getDocument(k){const p=this.getDocumentData(k);if(!p?.document)throw new Error(`Unable to retrieve document from URI '${k}'`);return p.document}ensureDocumentData(k){const p=this.g.getDocument(k);if(p)return Promise.resolve(p);let a=this.h.get(k.toString());return a||(a=this.f.$tryOpenDocument(k).then(f=>{this.h.delete(k.toString());const d=P.URI.revive(f);return(0,$.$qg)(this.g.getDocument(d))},f=>(this.h.delete(k.toString()),Promise.reject(f))),this.h.set(k.toString(),a)),a}createDocumentData(k){return this.f.$tryCreateDocument(k).then(p=>P.URI.revive(p))}$acceptModelLanguageChanged(k,p){const a=P.URI.revive(k),f=this.g.getDocument(a);if(!f)throw new Error("unknown document");this.b.fire(f.document),f._acceptLanguageId(p),this.a.fire(f.document)}$acceptModelSaved(k){const p=P.URI.revive(k),a=this.g.getDocument(p);if(!a)throw new Error("unknown document");this.$acceptDirtyStateChanged(k,!1),this.d.fire(a.document)}$acceptDirtyStateChanged(k,p){const a=P.URI.revive(k),f=this.g.getDocument(a);if(!f)throw new Error("unknown document");f._acceptIsDirty(p),this.c.fire({document:f.document,contentChanges:[],reason:void 0})}$acceptModelChanged(k,p,a){const f=P.URI.revive(k),d=this.g.getDocument(f);if(!d)throw new Error("unknown document");d._acceptIsDirty(a),d.onEvents(p);let m;p.isUndoing?m=I.TextDocumentChangeReason.Undo:p.isRedoing&&(m=I.TextDocumentChangeReason.Redo),this.c.fire((0,c.$co)({document:d.document,contentChanges:p.changes.map(n=>({range:N.Range.to(n.range),rangeOffset:n.rangeOffset,rangeLength:n.rangeLength,text:n.text})),reason:m}))}setWordDefinitionFor(k,p){(0,T.$ZP)(k,p)}}e.$1nc=E}),define(Ee[78],ye([1,0,79,4,18,2,5,6,20,17,10]),function(ce,e,r,h,P,R,T,N,$,c,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$toc=e.$soc=void 0,c=We(c),e.$soc=(0,T.$Fi)("IExtHostEditorTabs");class E{constructor(f,d,m){this.e=m,this.d=d,this.acceptDtoUpdate(f)}get apiObject(){if(!this.a){const f=this,d={get isActive(){return f.b.id===f.e()},get label(){return f.b.label},get input(){return f.c},get isDirty(){return f.b.isDirty},get isPinned(){return f.b.isPinned},get isPreview(){return f.b.isPreview},get group(){return f.d.apiObject}};this.a=Object.freeze(d)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(f){this.b=f,this.c=this.f()}f(){switch(this.b.input.kind){case N.TabInputKind.TextInput:return new I.$eP(R.URI.revive(this.b.input.uri));case N.TabInputKind.TextDiffInput:return new I.$fP(R.URI.revive(this.b.input.original),R.URI.revive(this.b.input.modified));case N.TabInputKind.TextMergeInput:return new I.$gP(R.URI.revive(this.b.input.base),R.URI.revive(this.b.input.input1),R.URI.revive(this.b.input.input2),R.URI.revive(this.b.input.result));case N.TabInputKind.CustomEditorInput:return new I.$hP(R.URI.revive(this.b.input.uri),this.b.input.viewType);case N.TabInputKind.WebviewEditorInput:return new I.$iP(this.b.input.viewType);case N.TabInputKind.NotebookInput:return new I.$jP(R.URI.revive(this.b.input.uri),this.b.input.notebookType);case N.TabInputKind.NotebookDiffInput:return new I.$kP(R.URI.revive(this.b.input.original),R.URI.revive(this.b.input.modified),this.b.input.notebookType);case N.TabInputKind.TerminalEditorInput:return new I.$lP;case N.TabInputKind.InteractiveEditorInput:return new I.$mP(R.URI.revive(this.b.input.uri),R.URI.revive(this.b.input.inputBoxUri));case N.TabInputKind.ChatEditorInput:return new I.$nP;case N.TabInputKind.MultiDiffEditorInput:return new I.$oP(this.b.input.diffEditors.map(f=>new I.$fP(R.URI.revive(f.original),R.URI.revive(f.modified))));default:return}}}class u{constructor(f,d){this.c=[],this.d="",this.b=f,this.e=d;for(const m of f.tabs)m.isActive&&(this.d=m.id),this.c.push(new E(m,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const f=this,d={get isActive(){return f.b.groupId===f.e()},get viewColumn(){return c.ViewColumn.to(f.b.viewColumn)},get activeTab(){return f.c.find(m=>m.tabId===f.d)?.apiObject},get tabs(){return Object.freeze(f.c.map(m=>m.apiObject))}};this.a=Object.freeze(d)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(f){this.b=f}acceptTabOperation(f){if(f.kind===N.TabModelOperationKind.TAB_OPEN){const m=new E(f.tabDto,this,()=>this.activeTabId());return this.c.splice(f.index,0,m),f.tabDto.isActive&&(this.d=m.tabId),m}else if(f.kind===N.TabModelOperationKind.TAB_CLOSE){const m=this.c.splice(f.index,1)[0];if(!m)throw new Error(`Tab close updated received for index ${f.index} which does not exist`);return m.tabId===this.d&&(this.d=""),m}else if(f.kind===N.TabModelOperationKind.TAB_MOVE){if(f.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const m=this.c.splice(f.oldIndex,1)[0];if(!m)throw new Error(`Tab move updated received for index ${f.oldIndex} which does not exist`);return this.c.splice(f.index,0,m),m}const d=this.c.find(m=>m.tabId===f.tabDto.id);if(!d)throw new Error("INVALID tab");return f.tabDto.isActive?this.d=f.tabDto.id:this.d===f.tabDto.id&&!f.tabDto.isActive&&(this.d=""),d.acceptDtoUpdate(f.tabDto),d}activeTabId(){return this.d}}let k=class{constructor(f){this.b=new h.$me,this.c=new h.$me,this.e=[],this.a=f.getProxy(N.$rN.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const f=this,d={onDidChangeTabGroups:f.c.event,onDidChangeTabs:f.b.event,get all(){return Object.freeze(f.e.map(m=>m.apiObject))},get activeTabGroup(){const m=f.d;return(0,P.$qg)(f.e.find(o=>o.groupId===m)?.apiObject)},close:async(m,n)=>{const o=Array.isArray(m)?m:[m];return o.length?p(o[0])?this.j(o,n):this.i(o,n):!0}};this.f=Object.freeze(d)}return this.f}$acceptEditorTabModel(f){const d=new Set(this.e.map(g=>g.groupId)),m=new Set(f.map(g=>g.groupId)),n=(0,r.$L)(d,m),o=this.e.filter(g=>n.removed.includes(g.groupId)).map(g=>g.apiObject),t=[],i=[];this.e=f.map(g=>{const l=new u(g,()=>this.d);return n.added.includes(l.groupId)?t.push(l.apiObject):i.push(l.apiObject),l});const s=(0,P.$qg)(f.find(g=>g.isActive===!0)?.groupId);s!==void 0&&this.d!==s&&(this.d=s),this.c.fire(Object.freeze({opened:t,closed:o,changed:i}))}$acceptTabGroupUpdate(f){const d=this.e.find(m=>m.groupId===f.groupId);if(!d)throw new Error("Update Group IPC call received before group creation.");d.acceptGroupDtoUpdate(f),f.isActive&&(this.d=f.groupId),this.c.fire(Object.freeze({changed:[d.apiObject],opened:[],closed:[]}))}$acceptTabOperation(f){const d=this.e.find(n=>n.groupId===f.groupId);if(!d)throw new Error("Update Tabs IPC call received before group creation.");const m=d.acceptTabOperation(f);switch(f.kind){case N.TabModelOperationKind.TAB_OPEN:this.b.fire(Object.freeze({opened:[m.apiObject],closed:[],changed:[]}));return;case N.TabModelOperationKind.TAB_CLOSE:this.b.fire(Object.freeze({opened:[],closed:[m.apiObject],changed:[]}));return;case N.TabModelOperationKind.TAB_MOVE:case N.TabModelOperationKind.TAB_UPDATE:this.b.fire(Object.freeze({opened:[],closed:[],changed:[m.apiObject]}));return}}g(f){for(const d of this.e)for(const m of d.tabs)if(m.apiObject===f)return m}h(f){return this.e.find(d=>d.apiObject===f)}async i(f,d){const m=[];for(const n of f){const o=this.g(n);if(!o)throw new Error("Tab close: Invalid tab not found!");m.push(o.tabId)}return this.a.$closeTab(m,d)}async j(f,d){const m=[];for(const n of f){const o=this.h(n);if(!o)throw new Error("Group close: Invalid group not found!");m.push(o.groupId)}return this.a.$closeGroup(m,d)}};e.$toc=k,e.$toc=k=Je([Ge(0,$.$XP)],k);function p(a){return a.tabs!==void 0}}),define(Ee[354],ye([1,0,2,6,28,3,10,17,194,13,27,22,26,86]),function(ce,e,r,h,P,R,T,N,$,c,I,E,u,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dpc=void 0,P=We(P),N=We(N);class p{constructor(){this.a=[]}add(d){this.b=void 0,this.a.push(d)}delete(d){const m=this.a.indexOf(d);m>=0&&(this.a.splice(m,1),this.b=void 0)}c(){if(!this.b){const d=this.a.sort(),m=[];let n,o,t=$.State.LastKnownState,i=$.State.LastKnownState;for(const s of d){let g=n?(0,c.$If)(n,s):0;for(g===0?o=$.State.Start:o=i;g<s.length;g++)g+1===s.length?(t=i,i=$.State.BeforeColon):i+=1,m.push([o,s.toUpperCase().charCodeAt(g),i]),m.push([o,s.toLowerCase().charCodeAt(g),i]),o=i;n=s,i=t}m.push([$.State.BeforeColon,I.CharCode.Colon,$.State.AfterColon]),m.push([$.State.AfterColon,I.CharCode.Slash,$.State.End]),this.b=new $.$l4(m)}}provideDocumentLinks(d){this.c();const m=[],n=$.$m4.computeLinks({getLineContent(o){return d.lineAt(o-1).text},getLineCount(){return d.lineCount}},this.b);for(const o of n){const t=N.DocumentLink.to(o);t.target&&m.push(t)}return m}}class a{constructor(d,m){this.i=m,this.b=new p,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=d.getProxy(h.$rN.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(d,m,n,o={}){if(a.j(n),this.d.has(m))throw new Error(`a provider for the scheme '${m}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(d,"*",this.b));const t=this.h++;this.b.add(m),this.d.add(m),this.c.set(t,n);let i=P.FileSystemProviderCapabilities.FileReadWrite;o.isCaseSensitive&&(i+=P.FileSystemProviderCapabilities.PathCaseSensitive),o.isReadonly&&(i+=P.FileSystemProviderCapabilities.Readonly),typeof n.copy=="function"&&(i+=P.FileSystemProviderCapabilities.FileFolderCopy),typeof n.open=="function"&&typeof n.close=="function"&&typeof n.read=="function"&&typeof n.write=="function"&&((0,u.$4G)(d,"fsChunks"),i+=P.FileSystemProviderCapabilities.FileOpenReadWriteClose);let s;o.isReadonly&&(0,k.$5k)(o.isReadonly)&&o.isReadonly.value!==""&&(s={value:o.isReadonly.value,isTrusted:o.isReadonly.isTrusted,supportThemeIcons:o.isReadonly.supportThemeIcons,supportHtml:o.isReadonly.supportHtml,baseUri:o.isReadonly.baseUri,uris:o.isReadonly.uris}),this.a.$registerFileSystemProvider(t,m,i,s).catch(l=>{console.error(`FAILED to register filesystem provider of ${d.identifier.value}-extension for the scheme ${m}`),console.error(l)});const g=n.onDidChangeFile(l=>{const w=[];for(const S of l){const{uri:D,type:y}=S;if(D.scheme!==m)continue;let C;switch(y){case T.FileChangeType.Changed:C=P.FileChangeType.UPDATED;break;case T.FileChangeType.Created:C=P.FileChangeType.ADDED;break;case T.FileChangeType.Deleted:C=P.FileChangeType.DELETED;break;default:throw new Error("Unknown FileChangeType")}w.push({resource:D,type:C})}this.a.$onFileSystemChange(t,w)});return(0,R.$Uc)(()=>{g.dispose(),this.b.delete(m),this.d.delete(m),this.c.delete(t),this.a.$unregisterProvider(t)})}static j(d){if(!d)throw new Error("MISSING provider");if(typeof d.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof d.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof d.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof d.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof d.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof d.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof d.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof d.rename!="function")throw new Error("Provider does NOT implement rename")}static k(d){const{type:m,ctime:n,mtime:o,size:t,permissions:i}=d;return{type:m,ctime:n,mtime:o,size:t,permissions:i}}$stat(d,m){return Promise.resolve(this.l(d).stat(r.URI.revive(m))).then(n=>a.k(n))}$readdir(d,m){return Promise.resolve(this.l(d).readDirectory(r.URI.revive(m)))}$readFile(d,m){return Promise.resolve(this.l(d).readFile(r.URI.revive(m))).then(n=>E.$Oe.wrap(n))}$writeFile(d,m,n,o){return Promise.resolve(this.l(d).writeFile(r.URI.revive(m),n.buffer,o))}$delete(d,m,n){return Promise.resolve(this.l(d).delete(r.URI.revive(m),n))}$rename(d,m,n,o){return Promise.resolve(this.l(d).rename(r.URI.revive(m),r.URI.revive(n),o))}$copy(d,m,n,o){const t=this.l(d);if(!t.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(t.copy(r.URI.revive(m),r.URI.revive(n),o))}$mkdir(d,m){return Promise.resolve(this.l(d).createDirectory(r.URI.revive(m)))}$watch(d,m,n,o){const t=this.l(d).watch(r.URI.revive(n),o);this.f.set(m,t)}$unwatch(d,m){const n=this.f.get(m);n&&(n.dispose(),this.f.delete(m))}$open(d,m,n){const o=this.l(d);if(!o.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(o.open(r.URI.revive(m),n))}$close(d,m){const n=this.l(d);if(!n.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(n.close(m))}$read(d,m,n,o){const t=this.l(d);if(!t.read)throw new Error('FileSystemProvider does not implement "read"');const i=E.$Oe.alloc(o);return Promise.resolve(t.read(m,n,i.buffer,0,o)).then(s=>i.slice(0,s))}$write(d,m,n,o){const t=this.l(d);if(!t.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(t.write(m,n,o.buffer,0,o.byteLength))}l(d){const m=this.c.get(d);if(!m){const n=new Error;throw n.name="ENOPRO",n.message="no provider",n}return m}}e.$dpc=a}),define(Ee[355],ye([1,0,4,39,2,6,17,10,28,49]),function(ce,e,r,h,P,R,T,N,$,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$epc=void 0,T=We(T);class I{get ignoreCreateEvents(){return!!(this.h&1)}get ignoreChangeEvents(){return!!(this.h&2)}get ignoreDeleteEvents(){return!!(this.h&4)}constructor(p,a,f,d,m,n){this.a=Math.random(),this.b=new r.$me,this.c=new r.$me,this.d=new r.$me,this.h=0,n?.ignoreCreateEvents&&(this.h+=1),n?.ignoreChangeEvents&&(this.h+=2),n?.ignoreDeleteEvents&&(this.h+=4);const o=(0,h.$zk)(m),t=typeof m=="string",i=n?.correlate,s=d(g=>{if(!(typeof g.session=="number"&&g.session!==this.a)&&!(i&&typeof g.session>"u")){if(!n?.ignoreCreateEvents)for(const l of g.created){const w=P.URI.revive(l);o(w.fsPath)&&(!t||a.getWorkspaceFolder(w))&&this.b.fire(w)}if(!n?.ignoreChangeEvents)for(const l of g.changed){const w=P.URI.revive(l);o(w.fsPath)&&(!t||a.getWorkspaceFolder(w))&&this.c.fire(w)}if(!n?.ignoreDeleteEvents)for(const l of g.deleted){const w=P.URI.revive(l);o(w.fsPath)&&(!t||a.getWorkspaceFolder(w))&&this.d.fire(w)}}});this.g=N.$tN.from(this.i(p,f,m,n,n?.correlate),this.b,this.c,this.d,s)}i(p,a,f,d,m){const n=N.$tN.from();if(typeof f=="string"||d?.ignoreChangeEvents&&d?.ignoreCreateEvents&&d?.ignoreDeleteEvents)return n;const o=p.getProxy(R.$rN.MainThreadFileSystemEventService);let t=!1;(f.pattern.includes(h.$vk)||f.pattern.includes(h.$wk))&&(t=!0);let i;return m&&(d?.ignoreChangeEvents||d?.ignoreCreateEvents||d?.ignoreDeleteEvents)&&(i=$.FileChangeFilter.UPDATED|$.FileChangeFilter.ADDED|$.FileChangeFilter.DELETED,d?.ignoreChangeEvents&&(i&=~$.FileChangeFilter.UPDATED),d?.ignoreCreateEvents&&(i&=~$.FileChangeFilter.ADDED),d?.ignoreDeleteEvents&&(i&=~$.FileChangeFilter.DELETED)),o.$watch(a.identifier.value,this.a,f.baseUri,{recursive:t,excludes:d?.excludes??[],filter:i},!!m),N.$tN.from({dispose:()=>o.$unwatch(this.a)})}dispose(){this.g.dispose()}get onDidCreate(){return this.b.event}get onDidChange(){return this.c.event}get onDidDelete(){return this.d.event}}class E{constructor(p){this.a=p,this.session=this.a.session,this.b=new c.$X(()=>this.a.created.map(P.URI.revive)),this.c=new c.$X(()=>this.a.changed.map(P.URI.revive)),this.d=new c.$X(()=>this.a.deleted.map(P.URI.revive))}get created(){return this.b.value}get changed(){return this.c.value}get deleted(){return this.d.value}}class u{constructor(p,a,f){this.j=p,this.k=a,this.l=f,this.a=new r.$me,this.b=new r.$me,this.c=new r.$me,this.d=new r.$me,this.g=new r.$oe,this.h=new r.$oe,this.i=new r.$oe,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(p,a,f,d){return new I(this.j,p,a,this.a.event,T.GlobPattern.from(f),d)}$onFileEvent(p){this.a.fire(new E(p))}$onDidRunFileOperation(p,a){switch(p){case $.FileOperation.MOVE:this.b.fire(Object.freeze({files:a.map(f=>({oldUri:P.URI.revive(f.source),newUri:P.URI.revive(f.target)}))}));break;case $.FileOperation.DELETE:this.d.fire(Object.freeze({files:a.map(f=>P.URI.revive(f.target))}));break;case $.FileOperation.CREATE:case $.FileOperation.COPY:this.c.fire(Object.freeze({files:a.map(f=>P.URI.revive(f.target))}));break;default:}}getOnWillRenameFileEvent(p){return this.m(p,this.g)}getOnWillCreateFileEvent(p){return this.m(p,this.h)}getOnWillDeleteFileEvent(p){return this.m(p,this.i)}m(p,a){return(f,d,m)=>{const n=function(t){f.call(d,t)};return n.extension=p,a.event(n,void 0,m)}}async $onWillRunFileOperation(p,a,f,d){switch(p){case $.FileOperation.MOVE:return await this.n(this.g,{files:a.map(m=>({oldUri:P.URI.revive(m.source),newUri:P.URI.revive(m.target)}))},f,d);case $.FileOperation.DELETE:return await this.n(this.i,{files:a.map(m=>P.URI.revive(m.target))},f,d);case $.FileOperation.CREATE:case $.FileOperation.COPY:return await this.n(this.h,{files:a.map(m=>P.URI.revive(m.target))},f,d)}}async n(p,a,f,d){const m=new Set,n=[];if(await p.fireAsync(a,d,async(t,i)=>{const s=Date.now(),g=await Promise.resolve(t);g instanceof N.$DN&&(n.push([i.extension,g]),m.add(i.extension.displayName??i.extension.identifier.value)),Date.now()-s>f&&this.k.warn("SLOW file-participant",i.extension.identifier)}),d.isCancellationRequested||n.length===0)return;const o={edits:[]};for(const[,t]of n){const{edits:i}=T.WorkspaceEdit.from(t,{getTextDocumentVersion:s=>this.l.getDocument(s)?.version,getNotebookDocumentVersion:()=>{}});o.edits=o.edits.concat(i)}return{edit:o,extensionNames:Array.from(m)}}}e.$epc=u}),define(Ee[356],ye([1,0,19,9,21,14,133,3,25,43,13,18,2,31,190,88,143,235,24,17,10,26,119,6]),function(ce,e,r,h,P,R,T,N,$,c,I,E,u,k,p,a,f,d,m,n,o,t,i,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2nc=void 0,a=We(a),n=We(n),s=We(s);class g{constructor(q,V){this.d=q,this.e=V}async provideDocumentSymbols(q,V){const J=this.d.getDocument(q),x=await this.e.provideDocumentSymbols(J,V);if(!(0,r.$Mb)(x))return x[0]instanceof o.$NN?x.map(n.DocumentSymbol.from):g.f(x)}static f(q){q=q.slice(0).sort((x,fe)=>{let we=x.location.range.start.compareTo(fe.location.range.start);return we===0&&(we=fe.location.range.end.compareTo(x.location.range.end)),we});const V=[],J=[];for(const x of q){const fe={name:x.name||"!!MISSING: name!!",kind:n.SymbolKind.from(x.kind),tags:x.tags?.map(n.SymbolTag.from)||[],detail:"",containerName:x.containerName,range:n.Range.from(x.location.range),selectionRange:n.Range.from(x.location.range),children:[]};for(;;){if(J.length===0){J.push(fe),V.push(fe);break}const we=J[J.length-1];if(k.$Ht.containsRange(we.range,fe.range)&&!k.$Ht.equalsRange(we.range,fe.range)){we.children?.push(fe),J.push(fe);break}J.pop()}}return V}}class l{constructor(q,V,J,x,fe,we){this.f=q,this.g=V,this.h=J,this.j=x,this.k=fe,this.l=we,this.d=new i.$Rnc("CodeLens"),this.e=new Map}async provideCodeLenses(q,V){const J=this.f.getDocument(q),x=await this.h.provideCodeLenses(J,V);if(!x||V.isCancellationRequested)return;const fe=this.d.add(x),we=new N.$Vc;this.e.set(fe,we);const Le={cacheId:fe,lenses:[]};for(let He=0;He<x.length;He++)Le.lenses.push({cacheId:[fe,He],range:n.Range.from(x[He].range),command:this.g.toInternal(x[He].command,we)});return Le}async resolveCodeLens(q,V){const J=q.cacheId&&this.d.get(...q.cacheId);if(!J)return;let x;if(typeof this.h.resolveCodeLens!="function"||J.isResolved?x=J:x=await this.h.resolveCodeLens(J,V),x||(x=J),V.isCancellationRequested)return;const fe=q.cacheId&&this.e.get(q.cacheId[0]);if(fe){if(!x.command){const we=new Error("INVALID code lens resolved, lacks command: "+this.j.identifier.value);this.k.onExtensionError(this.j.identifier,we),this.l.error(we);return}return q.command=this.g.toInternal(x.command,fe),q}}releaseCodeLenses(q){this.e.get(q)?.dispose(),this.e.delete(q),this.d.delete(q)}}function w(Re){return Array.isArray(Re)?Re.map(n.DefinitionLink.from):Re?[n.DefinitionLink.from(Re)]:[]}class S{constructor(q,V){this.d=q,this.e=V}async provideDefinition(q,V,J){const x=this.d.getDocument(q),fe=n.Position.to(V),we=await this.e.provideDefinition(x,fe,J);return w(we)}}class D{constructor(q,V){this.d=q,this.e=V}async provideDeclaration(q,V,J){const x=this.d.getDocument(q),fe=n.Position.to(V),we=await this.e.provideDeclaration(x,fe,J);return w(we)}}class y{constructor(q,V){this.d=q,this.e=V}async provideImplementation(q,V,J){const x=this.d.getDocument(q),fe=n.Position.to(V),we=await this.e.provideImplementation(x,fe,J);return w(we)}}class C{constructor(q,V){this.d=q,this.e=V}async provideTypeDefinition(q,V,J){const x=this.d.getDocument(q),fe=n.Position.to(V),we=await this.e.provideTypeDefinition(x,fe,J);return w(we)}}class A{static{this.f=10}constructor(q,V){this.g=q,this.h=V,this.d=0,this.e=new Map}async provideHover(q,V,J,x){const fe=this.g.getDocument(q),we=n.Position.to(V);let Le;if(J&&J.verbosityRequest){const rt=J.verbosityRequest.previousHover.id,ot=this.e.get(rt);if(!ot)throw new Error(`Hover with id ${rt} not found`);const nt={verbosityDelta:J.verbosityRequest.verbosityDelta,previousHover:ot};Le=await this.h.provideHover(fe,we,x,nt)}else Le=await this.h.provideHover(fe,we,x);if(!Le||(0,r.$Mb)(Le.contents))return;Le.range||(Le.range=fe.getWordRangeAtPosition(we)),Le.range||(Le.range=new o.$vN(we,we));const He=n.Hover.from(Le),Ke=this.d;if(this.e.size===A.f){const rt=Math.min(...this.e.keys());this.e.delete(rt)}return this.e.set(Ke,Le),this.d+=1,{...He,id:Ke}}releaseHover(q){this.e.delete(q)}}class b{constructor(q,V){this.d=q,this.e=V}async provideEvaluatableExpression(q,V,J){const x=this.d.getDocument(q),fe=n.Position.to(V),we=await this.e.provideEvaluatableExpression(x,fe,J);if(we)return n.EvaluatableExpression.from(we)}}class v{constructor(q,V){this.d=q,this.e=V}async provideInlineValues(q,V,J,x){const fe=this.d.getDocument(q),we=await this.e.provideInlineValues(fe,n.Range.to(V),n.InlineValueContext.to(J),x);if(Array.isArray(we))return we.map(Le=>n.InlineValue.from(Le))}}class L{constructor(q,V){this.d=q,this.e=V}async provideDocumentHighlights(q,V,J){const x=this.d.getDocument(q),fe=n.Position.to(V),we=await this.e.provideDocumentHighlights(x,fe,J);if(Array.isArray(we))return we.map(n.DocumentHighlight.from)}}class O{constructor(q,V){this.d=q,this.e=V}async provideMultiDocumentHighlights(q,V,J,x){const fe=this.d.getDocument(q),we=J.map(Ke=>this.d.getDocument(Ke)),Le=n.Position.to(V),He=await this.e.provideMultiDocumentHighlights(fe,Le,we,x);if(Array.isArray(He))return He.map(n.MultiDocumentHighlight.from)}}class M{constructor(q,V){this.d=q,this.e=V}async provideLinkedEditingRanges(q,V,J){const x=this.d.getDocument(q),fe=n.Position.to(V),we=await this.e.provideLinkedEditingRanges(x,fe,J);if(we&&Array.isArray(we.ranges))return{ranges:(0,r.$Jb)(we.ranges.map(n.Range.from)),wordPattern:we.wordPattern}}}class j{constructor(q,V){this.d=q,this.e=V}async provideReferences(q,V,J,x){const fe=this.d.getDocument(q),we=n.Position.to(V),Le=await this.e.provideReferences(fe,we,J,x);if(Array.isArray(Le))return Le.map(n.location.from)}}class z{static{this.d=1e3}constructor(q,V,J,x,fe,we,Le){this.g=q,this.h=V,this.j=J,this.k=x,this.l=fe,this.m=we,this.n=Le,this.e=new i.$Rnc("CodeAction"),this.f=new Map}async provideCodeActions(q,V,J,x){const fe=this.g.getDocument(q),we=p.$Jt.isISelection(V)?n.Selection.to(V):n.Range.to(V),Le=[];for(const nt of this.j.getDiagnostics(q))if(we.intersection(nt.range)&&Le.push(nt)>z.d)break;const He={diagnostics:Le,only:J.only?new o.$PN(J.only):void 0,triggerKind:n.CodeActionTriggerKind.to(J.trigger)},Ke=await this.k.provideCodeActions(fe,we,He,x);if(!(0,r.$Nb)(Ke)||x.isCancellationRequested)return;const et=this.e.add(Ke),rt=new N.$Vc;this.f.set(et,rt);const ot=[];for(let nt=0;nt<Ke.length;nt++){const ct=Ke[nt];if(ct)if(z.o(ct))this.n.report("CodeActionProvider.provideCodeActions - return commands",this.m,"Return 'CodeAction' instances instead."),ot.push({_isSynthetic:!0,title:ct.title,command:this.h.toInternal(ct,rt)});else{He.only&&(ct.kind?He.only.contains(ct.kind)||this.l.warn(`${this.m.identifier.value} - Code actions of kind '${He.only.value}' requested but returned code action is of kind '${ct.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.l.warn(`${this.m.identifier.value} - Code actions of kind '${He.only.value}' requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`));const mt=ct.ranges??[];ot.push({cacheId:[et,nt],title:ct.title,command:ct.command&&this.h.toInternal(ct.command,rt),diagnostics:ct.diagnostics&&ct.diagnostics.map(n.Diagnostic.from),edit:ct.edit&&n.WorkspaceEdit.from(ct.edit,void 0),kind:ct.kind&&ct.kind.value,isPreferred:ct.isPreferred,isAI:(0,t.$3G)(this.m,"codeActionAI")?ct.isAI:!1,ranges:(0,t.$3G)(this.m,"codeActionRanges")?(0,r.$Jb)(mt.map(n.Range.from)):void 0,disabled:ct.disabled?.reason})}}return{cacheId:et,actions:ot}}async resolveCodeAction(q,V){const[J,x]=q,fe=this.e.get(J,x);if(!fe||z.o(fe))return{};if(!this.k.resolveCodeAction)return{};const we=await this.k.resolveCodeAction(fe,V)??fe;let Le;we.edit&&(Le=n.WorkspaceEdit.from(we.edit,void 0));let He;if(we.command){const Ke=this.f.get(J);Ke&&(He=this.h.toInternal(we.command,Ke))}return{edit:Le,command:He}}releaseCodeActions(q){this.f.get(q)?.dispose(),this.f.delete(q),this.e.delete(q)}static o(q){return typeof q.command=="string"&&typeof q.title=="string"}}class F{constructor(q,V,J,x,fe){this.e=q,this.f=V,this.g=J,this.h=x,this.j=fe,this.d=new i.$Rnc("DocumentPasteEdit")}async prepareDocumentPaste(q,V,J,x){if(!this.g.prepareDocumentPaste)return;const fe=this.f.getDocument(q),we=V.map(Ke=>n.Range.to(Ke)),Le=n.DataTransfer.toDataTransfer(J,()=>{throw new R.$ab});if(await this.g.prepareDocumentPaste(fe,we,Le,x),x.isCancellationRequested)return;const He=Array.from(Le).filter(([,Ke])=>!(Ke instanceof o.$jO));return n.DataTransfer.from(He)}async providePasteEdits(q,V,J,x,fe,we){if(!this.g.provideDocumentPasteEdits)return[];const Le=this.f.getDocument(V),He=J.map(ot=>n.Range.to(ot)),Ke=n.DataTransfer.toDataTransfer(x,async ot=>(await this.e.$resolvePasteFileData(this.h,q,ot)).buffer),et=await this.g.provideDocumentPasteEdits(Le,He,Ke,{only:fe.only?new o.$oO(fe.only):void 0,triggerKind:fe.triggerKind},we);if(!et||we.isCancellationRequested)return[];const rt=this.d.add(et);return et.map((ot,nt)=>({_cacheId:[rt,nt],title:ot.title??(0,d.localize)(0,null,this.j.displayName||this.j.name),kind:ot.kind,yieldTo:ot.yieldTo?.map(ct=>ct.value),insertText:typeof ot.insertText=="string"?ot.insertText:{snippet:ot.insertText.value},additionalEdit:ot.additionalEdit?n.WorkspaceEdit.from(ot.additionalEdit,void 0):void 0}))}async resolvePasteEdit(q,V){const[J,x]=q,fe=this.d.get(J,x);if(!fe||!this.g.resolveDocumentPasteEdit)return{};const we=await this.g.resolveDocumentPasteEdit(fe,V)??fe;return{additionalEdit:we.additionalEdit?n.WorkspaceEdit.from(we.additionalEdit,void 0):void 0}}releasePasteEdits(q){this.d.delete(q)}}class B{constructor(q,V){this.d=q,this.e=V}async provideDocumentFormattingEdits(q,V,J){const x=this.d.getDocument(q),fe=await this.e.provideDocumentFormattingEdits(x,V,J);if(Array.isArray(fe))return fe.map(n.TextEdit.from)}}class _{constructor(q,V){this.d=q,this.e=V}async provideDocumentRangeFormattingEdits(q,V,J,x){const fe=this.d.getDocument(q),we=n.Range.to(V),Le=await this.e.provideDocumentRangeFormattingEdits(fe,we,J,x);if(Array.isArray(Le))return Le.map(n.TextEdit.from)}async provideDocumentRangesFormattingEdits(q,V,J,x){(0,E.$pg)(typeof this.e.provideDocumentRangesFormattingEdits=="function","INVALID invocation of `provideDocumentRangesFormattingEdits`");const fe=this.d.getDocument(q),we=V.map(n.Range.to),Le=await this.e.provideDocumentRangesFormattingEdits(fe,we,J,x);if(Array.isArray(Le))return Le.map(n.TextEdit.from)}}class re{constructor(q,V){this.d=q,this.e=V,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(q,V,J,x,fe){const we=this.d.getDocument(q),Le=n.Position.to(V),He=await this.e.provideOnTypeFormattingEdits(we,Le,J,x,fe);if(Array.isArray(He))return He.map(n.TextEdit.from)}}class U{constructor(q,V){this.e=q,this.f=V,this.d=new i.$Rnc("WorkspaceSymbols")}async provideWorkspaceSymbols(q,V){const J=await this.e.provideWorkspaceSymbols(q,V);if(!(0,r.$Nb)(J))return{symbols:[]};const x=this.d.add(J),fe={cacheId:x,symbols:[]};for(let we=0;we<J.length;we++){const Le=J[we];if(!Le||!Le.name){this.f.warn("INVALID SymbolInformation",Le);continue}fe.symbols.push({...n.WorkspaceSymbol.from(Le),cacheId:[x,we]})}return fe}async resolveWorkspaceSymbol(q,V){if(typeof this.e.resolveWorkspaceSymbol!="function"||!q.cacheId)return q;const J=this.d.get(...q.cacheId);if(J){const x=await this.e.resolveWorkspaceSymbol(J,V);return x&&(0,$.$eo)(q,n.WorkspaceSymbol.from(x),!0)}}releaseWorkspaceSymbols(q){this.d.delete(q)}}class G{static supportsResolving(q){return typeof q.prepareRename=="function"}constructor(q,V,J){this.d=q,this.e=V,this.f=J}async provideRenameEdits(q,V,J,x){const fe=this.d.getDocument(q),we=n.Position.to(V);try{const Le=await this.e.provideRenameEdits(fe,we,J,x);return Le?n.WorkspaceEdit.from(Le):void 0}catch(Le){const He=G.g(Le);return He?{rejectReason:He,edits:void 0}:Promise.reject(Le)}}async resolveRenameLocation(q,V,J){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const x=this.d.getDocument(q),fe=n.Position.to(V);try{const we=await this.e.prepareRename(x,fe,J);let Le,He;if(o.$vN.isRange(we)?(Le=we,He=x.getText(we)):(0,E.$hg)(we)&&(Le=we.range,He=we.placeholder),!Le||!He)return;if(Le.start.line>fe.line||Le.end.line<fe.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:n.Range.from(Le),text:He}}catch(we){const Le=G.g(we);return Le?{rejectReason:Le,range:void 0,text:void 0}:Promise.reject(we)}}static g(q){return typeof q=="string"?q:q instanceof Error&&typeof q.message=="string"?q.message:void 0}}class Q{static{this.d={[a.NewSymbolNameTriggerKind.Invoke]:o.NewSymbolNameTriggerKind.Invoke,[a.NewSymbolNameTriggerKind.Automatic]:o.NewSymbolNameTriggerKind.Automatic}}constructor(q,V,J){this.e=q,this.f=V,this.g=J}async supportsAutomaticNewSymbolNamesTriggerKind(){return this.f.supportsAutomaticTriggerKind}async provideNewSymbolNames(q,V,J,x){const fe=this.e.getDocument(q),we=n.Range.to(V);try{const Le=Q.d[J],He=await this.f.provideNewSymbolNames(fe,we,Le,x);return He?He.map(Ke=>typeof Ke=="string"?{newSymbolName:Ke}:{newSymbolName:Ke.newSymbolName,tags:Ke.tags}):void 0}catch(Le){this.g.error(Q.h(Le)??JSON.stringify(Le,null,"	"));return}}static h(q){return typeof q=="string"?q:q instanceof Error&&typeof q.message=="string"?q.message:void 0}}class ee{constructor(q,V){this.resultId=q,this.tokens=V}}class he{constructor(q,V){this.f=q,this.g=V,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(q,V,J){const x=this.f.getDocument(q),fe=V!==0?this.d.get(V):null;let we=typeof fe?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(x,fe.resultId,J):await this.g.provideDocumentSemanticTokens(x,J);return fe&&this.d.delete(V),we?(we=he.h(we),this.o(he.n(fe,we),we)):null}async releaseDocumentSemanticColoring(q){this.d.delete(q)}static h(q){return he.j(q)?he.k(q)?q:new o.$OO(new Uint32Array(q.data),q.resultId):he.l(q)?he.m(q)?q:new o.$QO(q.edits.map(V=>new o.$PO(V.start,V.deleteCount,V.data?new Uint32Array(V.data):V.data)),q.resultId):q}static j(q){return q&&!!q.data}static k(q){return q.data instanceof Uint32Array}static l(q){return q&&Array.isArray(q.edits)}static m(q){for(const V of q.edits)if(!(V.data instanceof Uint32Array))return!1;return!0}static n(q,V){if(!he.j(V)||!q||!q.tokens)return V;const J=q.tokens,x=J.length,fe=V.data,we=fe.length;let Le=0;const He=Math.min(x,we);for(;Le<He&&J[Le]===fe[Le];)Le++;if(Le===x&&Le===we)return new o.$QO([],V.resultId);let Ke=0;const et=He-Le;for(;Ke<et&&J[x-Ke-1]===fe[we-Ke-1];)Ke++;return new o.$QO([{start:Le,deleteCount:x-Le-Ke,data:fe.subarray(Le,we-Ke)}],V.resultId)}o(q,V){if(he.j(q)){const J=this.e++;return this.d.set(J,new ee(q.resultId,q.data)),(0,f.$ndb)({id:J,type:"full",data:q.data})}if(he.l(q)){const J=this.e++;return he.j(V)?this.d.set(J,new ee(V.resultId,V.data)):this.d.set(J,new ee(q.resultId)),(0,f.$ndb)({id:J,type:"delta",deltas:(q.edits||[]).map(x=>({start:x.start,deleteCount:x.deleteCount,data:x.data}))})}return null}}class ne{constructor(q,V){this.d=q,this.e=V}async provideDocumentRangeSemanticTokens(q,V,J){const x=this.d.getDocument(q),fe=await this.e.provideDocumentRangeSemanticTokens(x,n.Range.to(V),J);return fe?this.f(fe):null}f(q){return(0,f.$ndb)({id:0,type:"full",data:q.data})}}class De{static supportsResolving(q){return typeof q.resolveCompletionItem=="function"}constructor(q,V,J,x,fe){this.f=q,this.g=V,this.h=J,this.j=x,this.k=fe,this.d=new i.$Rnc("CompletionItem"),this.e=new Map}async provideCompletionItems(q,V,J,x){const fe=this.f.getDocument(q),we=n.Position.to(V),Le=fe.getWordRangeAtPosition(we)||new o.$vN(we,we),He=Le.with({end:we}),Ke=new c.$ge,et=await this.h.provideCompletionItems(fe,we,x,n.CompletionContext.to(J));if(!et||x.isCancellationRequested)return;const rt=Array.isArray(et)?new o.$3N(et):et,ot=De.supportsResolving(this.h)?this.d.add(rt.items):this.d.add([]),nt=new N.$Vc;this.e.set(ot,nt);const ct=[],mt={x:ot,[s.ISuggestResultDtoField.completions]:ct,[s.ISuggestResultDtoField.defaultRanges]:{replace:n.Range.from(Le),insert:n.Range.from(He)},[s.ISuggestResultDtoField.isIncomplete]:rt.isIncomplete||void 0,[s.ISuggestResultDtoField.duration]:Ke.elapsed()};for(let dt=0;dt<rt.items.length;dt++){const at=rt.items[dt],Pe=this.l(at,[ot,dt],He,Le);ct.push(Pe)}return mt}async resolveCompletionItem(q,V){if(typeof this.h.resolveCompletionItem!="function")return;const J=this.d.get(...q);if(!J)return;const x=this.l(J,q),fe=await this.h.resolveCompletionItem(J,V);if(!fe)return;const we=this.l(fe,q);return(x[s.ISuggestDataDtoField.insertText]!==we[s.ISuggestDataDtoField.insertText]||x[s.ISuggestDataDtoField.insertTextRules]!==we[s.ISuggestDataDtoField.insertTextRules])&&this.j.report("CompletionItem.insertText",this.k,"extension MAY NOT change 'insertText' of a CompletionItem during resolve"),(x[s.ISuggestDataDtoField.commandIdent]!==we[s.ISuggestDataDtoField.commandIdent]||x[s.ISuggestDataDtoField.commandId]!==we[s.ISuggestDataDtoField.commandId]||!(0,$.$fo)(x[s.ISuggestDataDtoField.commandArguments],we[s.ISuggestDataDtoField.commandArguments]))&&this.j.report("CompletionItem.command",this.k,"extension MAY NOT change 'command' of a CompletionItem during resolve"),{...x,[s.ISuggestDataDtoField.documentation]:we[s.ISuggestDataDtoField.documentation],[s.ISuggestDataDtoField.detail]:we[s.ISuggestDataDtoField.detail],[s.ISuggestDataDtoField.additionalTextEdits]:we[s.ISuggestDataDtoField.additionalTextEdits],[s.ISuggestDataDtoField.insertText]:we[s.ISuggestDataDtoField.insertText],[s.ISuggestDataDtoField.insertTextRules]:we[s.ISuggestDataDtoField.insertTextRules],[s.ISuggestDataDtoField.commandIdent]:we[s.ISuggestDataDtoField.commandIdent],[s.ISuggestDataDtoField.commandId]:we[s.ISuggestDataDtoField.commandId],[s.ISuggestDataDtoField.commandArguments]:we[s.ISuggestDataDtoField.commandArguments]}}releaseCompletionItems(q){this.e.get(q)?.dispose(),this.e.delete(q),this.d.delete(q)}l(q,V,J,x){const fe=this.e.get(V[0]);if(!fe)throw Error("DisposableStore is missing...");const we=this.g.toInternal(q.command,fe),Le={x:V,[s.ISuggestDataDtoField.label]:q.label,[s.ISuggestDataDtoField.kind]:q.kind!==void 0?n.CompletionItemKind.from(q.kind):void 0,[s.ISuggestDataDtoField.kindModifier]:q.tags&&q.tags.map(n.CompletionItemTag.from),[s.ISuggestDataDtoField.detail]:q.detail,[s.ISuggestDataDtoField.documentation]:typeof q.documentation>"u"?void 0:n.MarkdownString.fromStrict(q.documentation),[s.ISuggestDataDtoField.sortText]:q.sortText!==q.label?q.sortText:void 0,[s.ISuggestDataDtoField.filterText]:q.filterText!==q.label?q.filterText:void 0,[s.ISuggestDataDtoField.preselect]:q.preselect||void 0,[s.ISuggestDataDtoField.insertTextRules]:q.keepWhitespace?a.CompletionItemInsertTextRule.KeepWhitespace:a.CompletionItemInsertTextRule.None,[s.ISuggestDataDtoField.commitCharacters]:q.commitCharacters?.join(""),[s.ISuggestDataDtoField.additionalTextEdits]:q.additionalTextEdits&&q.additionalTextEdits.map(n.TextEdit.from),[s.ISuggestDataDtoField.commandIdent]:we?.$ident,[s.ISuggestDataDtoField.commandId]:we?.id,[s.ISuggestDataDtoField.commandArguments]:we?.$ident?void 0:we?.arguments};q.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),Le[s.ISuggestDataDtoField.insertText]=q.textEdit.newText):typeof q.insertText=="string"?Le[s.ISuggestDataDtoField.insertText]=q.insertText:q.insertText instanceof o.$EN&&(Le[s.ISuggestDataDtoField.insertText]=q.insertText.value,Le[s.ISuggestDataDtoField.insertTextRules]|=a.CompletionItemInsertTextRule.InsertAsSnippet);let He;return q.textEdit?He=q.textEdit.range:q.range&&(He=q.range),o.$vN.isRange(He)?Le[s.ISuggestDataDtoField.range]=n.Range.from(He):He&&(!J?.isEqual(He.inserting)||!x?.isEqual(He.replacing))&&(Le[s.ISuggestDataDtoField.range]={insert:n.Range.from(He.inserting),replace:n.Range.from(He.replacing)}),Le}}class $e{async provideInlineCompletions(q,V,J,x){}disposeCompletions(q){}handleDidShowCompletionItem(q,V,J){}handlePartialAccept(q,V,J,x){}}class K extends $e{constructor(q,V,J,x){super(),this.f=q,this.g=V,this.h=J,this.j=x,this.d=new se,this.e=(0,t.$3G)(this.f,"inlineCompletionsAdditions"),this.k={[a.InlineCompletionTriggerKind.Automatic]:o.InlineCompletionTriggerKind.Automatic,[a.InlineCompletionTriggerKind.Explicit]:o.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,t.$3G)(this.f,"inlineCompletionsAdditions")&&(typeof this.h.handleDidShowCompletionItem=="function"||typeof this.h.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(q,V,J,x){const fe=this.g.getDocument(q),we=n.Position.to(V),Le=await this.h.provideInlineCompletionItems(fe,we,{selectedCompletionInfo:J.selectedSuggestionInfo?{range:n.Range.to(J.selectedSuggestionInfo.range),text:J.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[J.triggerKind]},x);if(!Le||x.isCancellationRequested)return;const He=Array.isArray(Le)?Le:Le.items,Ke=this.e?Array.isArray(Le)?[]:Le.commands||[]:[],et=this.e&&!Array.isArray(Le)?Le.enableForwardStability:void 0;let rt;return{pid:this.d.createReferenceId({dispose(){rt?.dispose()},items:He}),items:He.map((nt,ct)=>{let mt;nt.command&&(rt||(rt=new N.$Vc),mt=this.j.toInternal(nt.command,rt));const dt=nt.insertText;return{insertText:typeof dt=="string"?dt:{snippet:dt.value},filterText:nt.filterText,range:nt.range?n.Range.from(nt.range):void 0,command:mt,idx:ct,completeBracketPairs:this.e?nt.completeBracketPairs:!1}}),commands:Ke.map(nt=>(rt||(rt=new N.$Vc),this.j.toInternal(nt,rt))),suppressSuggestions:!1,enableForwardStability:et}}disposeCompletions(q){this.d.disposeReferenceId(q)?.dispose()}handleDidShowCompletionItem(q,V,J){const x=this.d.get(q)?.items[V];x&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(x,J)}handlePartialAccept(q,V,J,x){const fe=this.d.get(q)?.items[V];fe&&this.h.handleDidPartiallyAcceptCompletionItem&&this.e&&(this.h.handleDidPartiallyAcceptCompletionItem(fe,J),this.h.handleDidPartiallyAcceptCompletionItem(fe,n.PartialAcceptInfo.to(x)))}}class W{async provideInlineEdits(q,V,J){const x=this.f.getDocument(q),fe=await this.g.provideInlineEdit(x,{triggerKind:this.e[V.triggerKind]},J);if(!fe||J.isCancellationRequested)return;let we;const Le=this.d.createReferenceId({dispose(){we?.dispose()},item:fe});let He;fe.accepted&&(we||(we=new N.$Vc),He=this.h.toInternal(fe.accepted,we));let Ke;return fe.rejected&&(we||(we=new N.$Vc),Ke=this.h.toInternal(fe.rejected,we)),{pid:Le,text:fe.text,range:n.Range.from(fe.range),accepted:He,rejected:Ke}}disposeEdit(q){this.d.disposeReferenceId(q)?.dispose()}constructor(q,V,J,x){this.f=V,this.g=J,this.h=x,this.d=new se,this.e={[a.InlineEditTriggerKind.Automatic]:o.InlineEditTriggerKind.Automatic,[a.InlineEditTriggerKind.Invoke]:o.InlineEditTriggerKind.Invoke}}}class se{constructor(){this.d=new Map,this.e=1}createReferenceId(q){const V=this.e++;return this.d.set(V,q),V}disposeReferenceId(q){const V=this.d.get(q);return this.d.delete(q),V}get(q){return this.d.get(q)}}class oe{constructor(q,V){this.e=q,this.f=V,this.d=new i.$Rnc("SignatureHelp")}async provideSignatureHelp(q,V,J,x){const fe=this.e.getDocument(q),we=n.Position.to(V),Le=this.g(J),He=await this.f.provideSignatureHelp(fe,we,x,Le);if(He){const Ke=this.d.add([He]);return{...n.SignatureHelp.from(He),id:Ke}}}g(q){let V;if(q.activeSignatureHelp){const J=n.SignatureHelp.to(q.activeSignatureHelp),x=this.d.get(q.activeSignatureHelp.id,0);x?(V=x,V.activeSignature=J.activeSignature,V.activeParameter=J.activeParameter):V=J}return{...q,activeSignatureHelp:V}}releaseSignatureHelp(q){this.d.delete(q)}}class te{constructor(q,V,J,x,fe){this.f=q,this.g=V,this.h=J,this.j=x,this.k=fe,this.d=new i.$Rnc("InlayHints"),this.e=new Map}async provideInlayHints(q,V,J){const x=this.f.getDocument(q),fe=n.Range.to(V),we=await this.h.provideInlayHints(x,fe,J);if(!Array.isArray(we)||we.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(V)}`);return}if(J.isCancellationRequested)return;const Le=this.d.add(we);this.e.set(Le,new N.$Vc);const He={hints:[],cacheId:Le};for(let Ke=0;Ke<we.length;Ke++)this.l(we[Ke],fe)&&He.hints.push(this.m(we[Ke],[Le,Ke]));return this.j.trace(`[InlayHints] ${He.hints.length} inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(V)}`),He}async resolveInlayHint(q,V){if(typeof this.h.resolveInlayHint!="function")return;const J=this.d.get(...q);if(!J)return;const x=await this.h.resolveInlayHint(J,V);if(x&&this.l(x))return this.m(x,q)}releaseHints(q){this.e.get(q)?.dispose(),this.e.delete(q),this.d.delete(q)}l(q,V){return q.label.length===0||Array.isArray(q.label)&&q.label.every(J=>J.value.length===0)?(console.log("INVALID inlay hint, empty label",q),!1):!(V&&!V.contains(q.position))}m(q,V){const J=this.e.get(V[0]);if(!J)throw Error("DisposableStore is missing...");const x={label:"",cacheId:V,tooltip:n.MarkdownString.fromStrict(q.tooltip),position:n.Position.from(q.position),textEdits:q.textEdits&&q.textEdits.map(n.TextEdit.from),kind:q.kind&&n.InlayHintKind.from(q.kind),paddingLeft:q.paddingLeft,paddingRight:q.paddingRight};if(typeof q.label=="string")x.label=q.label;else{const fe=[];x.label=fe;for(const we of q.label){if(!we.value){console.warn("INVALID inlay hint, empty label part",this.k.identifier.value);continue}const Le={label:we.value,tooltip:n.MarkdownString.fromStrict(we.tooltip)};o.$FN.isLocation(we.location)&&(Le.location=n.location.from(we.location)),we.command&&(Le.command=this.g.toInternal(we.command,J)),fe.push(Le)}}return x}}class le{constructor(q,V){this.e=q,this.f=V,this.d=new i.$Rnc("DocumentLink")}async provideLinks(q,V){const J=this.e.getDocument(q),x=await this.f.provideDocumentLinks(J,V);if(!(!Array.isArray(x)||x.length===0)&&!V.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:x.filter(le.g).map(n.DocumentLink.from)};{const fe=this.d.add(x),we={links:[],cacheId:fe};for(let Le=0;Le<x.length;Le++){if(!le.g(x[Le]))continue;const He=n.DocumentLink.from(x[Le]);He.cacheId=[fe,Le],we.links.push(He)}return we}}}static g(q){return q.target&&q.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(q,V){if(typeof this.f.resolveDocumentLink!="function")return;const J=this.d.get(...q);if(!J)return;const x=await this.f.resolveDocumentLink(J,V);if(!(!x||!le.g(x)))return n.DocumentLink.from(x)}releaseLinks(q){this.d.delete(q)}}class ue{constructor(q,V){this.d=q,this.e=V}async provideColors(q,V){const J=this.d.getDocument(q),x=await this.e.provideDocumentColors(J,V);return Array.isArray(x)?x.map(we=>({color:n.Color.from(we.color),range:n.Range.from(we.range)})):[]}async provideColorPresentations(q,V,J){const x=this.d.getDocument(q),fe=n.Range.to(V.range),we=n.Color.to(V.color),Le=await this.e.provideColorPresentations(we,{document:x,range:fe},J);if(Array.isArray(Le))return Le.map(n.ColorPresentation.from)}}class X{constructor(q,V){this.d=q,this.e=V}async provideFoldingRanges(q,V,J){const x=this.d.getDocument(q),fe=await this.e.provideFoldingRanges(x,V,J);if(Array.isArray(fe))return fe.map(n.FoldingRange.from)}}class ae{constructor(q,V,J){this.d=q,this.e=V,this.f=J}async provideSelectionRanges(q,V,J){const x=this.d.getDocument(q),fe=V.map(n.Position.to),we=await this.e.provideSelectionRanges(x,fe,J);if(!(0,r.$Nb)(we))return[];if(we.length!==fe.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const Le=[];for(let He=0;He<fe.length;He++){const Ke=[];Le.push(Ke);let et=fe[He],rt=we[He];for(;;){if(!rt.range.contains(et))throw new Error("INVALID selection range, must contain the previous range");if(Ke.push(n.SelectionRange.from(rt)),!rt.parent)break;et=rt.range,rt=rt.parent}}return Le}}class pe{constructor(q,V){this.f=q,this.g=V,this.d=new T.$3P(""),this.e=new Map}async prepareSession(q,V,J){const x=this.f.getDocument(q),fe=n.Position.to(V),we=await this.g.prepareCallHierarchy(x,fe,J);if(!we)return;const Le=this.d.nextId();return this.e.set(Le,new Map),Array.isArray(we)?we.map(He=>this.h(Le,He)):[this.h(Le,we)]}async provideCallsTo(q,V,J){const x=this.j(q,V);if(!x)throw new Error("missing call hierarchy item");const fe=await this.g.provideCallHierarchyIncomingCalls(x,J);if(fe)return fe.map(we=>({from:this.h(q,we.from),fromRanges:we.fromRanges.map(Le=>n.Range.from(Le))}))}async provideCallsFrom(q,V,J){const x=this.j(q,V);if(!x)throw new Error("missing call hierarchy item");const fe=await this.g.provideCallHierarchyOutgoingCalls(x,J);if(fe)return fe.map(we=>({to:this.h(q,we.to),fromRanges:we.fromRanges.map(Le=>n.Range.from(Le))}))}releaseSession(q){this.e.delete(q)}h(q,V){const J=this.e.get(q),x=n.CallHierarchyItem.from(V,q,J.size.toString(36));return J.set(x._itemId,V),x}j(q,V){return this.e.get(q)?.get(V)}}class be{constructor(q,V){this.f=q,this.g=V,this.d=new T.$3P(""),this.e=new Map}async prepareSession(q,V,J){const x=this.f.getDocument(q),fe=n.Position.to(V),we=await this.g.prepareTypeHierarchy(x,fe,J);if(!we)return;const Le=this.d.nextId();return this.e.set(Le,new Map),Array.isArray(we)?we.map(He=>this.h(Le,He)):[this.h(Le,we)]}async provideSupertypes(q,V,J){const x=this.j(q,V);if(!x)throw new Error("missing type hierarchy item");const fe=await this.g.provideTypeHierarchySupertypes(x,J);if(fe)return fe.map(we=>this.h(q,we))}async provideSubtypes(q,V,J){const x=this.j(q,V);if(!x)throw new Error("missing type hierarchy item");const fe=await this.g.provideTypeHierarchySubtypes(x,J);if(fe)return fe.map(we=>this.h(q,we))}releaseSession(q){this.e.delete(q)}h(q,V){const J=this.e.get(q),x=n.TypeHierarchyItem.from(V,q,J.size.toString(36));return J.set(x._itemId,V),x}j(q,V){return this.e.get(q)?.get(V)}}class Fe{constructor(q,V,J,x,fe){this.e=q,this.f=V,this.g=J,this.h=x,this.j=fe,this.d=new i.$Rnc("DocumentDropEdit")}async provideDocumentOnDropEdits(q,V,J,x,fe){const we=this.f.getDocument(V),Le=n.Position.to(J),He=n.DataTransfer.toDataTransfer(x,async ot=>(await this.e.$resolveDocumentOnDropFileData(this.h,q,ot)).buffer),Ke=await this.g.provideDocumentDropEdits(we,Le,He,fe);if(!Ke)return;const et=(0,r.$4b)(Ke),rt=this.d.add(et);return et.map((ot,nt)=>({_cacheId:[rt,nt],title:ot.title??(0,d.localize)(1,null,this.j.displayName||this.j.name),kind:ot.kind?.value,yieldTo:ot.yieldTo?.map(ct=>ct.value),insertText:typeof ot.insertText=="string"?ot.insertText:{snippet:ot.insertText.value},additionalEdit:ot.additionalEdit?n.WorkspaceEdit.from(ot.additionalEdit,void 0):void 0}))}async resolveDropEdit(q,V){const[J,x]=q,fe=this.d.get(J,x);if(!fe||!this.g.resolveDocumentDropEdit)return{};const we=await this.g.resolveDocumentDropEdit(fe,V)??fe;return{additionalEdit:we.additionalEdit?n.WorkspaceEdit.from(we.additionalEdit,void 0):void 0}}releaseDropEdits(q){this.d.delete(q)}}class Ue{constructor(q,V){this.d=q,this.e=V}async provideMappedEdits(q,V,J,x){const fe=u.URI.revive(q),we=this.d.getDocument(fe),Le=J.documents.map(et=>et.map(rt=>({uri:u.URI.revive(rt.uri),version:rt.version,ranges:rt.ranges.map(ot=>n.Range.to(ot))}))),He={documents:Le,selections:Le[0]?.[0]?.ranges??[]},Ke=await this.e.provideMappedEdits(we,V,He,x);return Ke?n.WorkspaceEdit.from(Ke):null}}class ke{constructor(q,V){this.adapter=q,this.extension=V}}class Ie{static{this.d=0}constructor(q,V,J,x,fe,we,Le,He){this.g=V,this.h=J,this.j=x,this.k=fe,this.l=we,this.m=Le,this.n=He,this.f=new Map,this.e=q.getProxy(s.$rN.MainThreadLanguageFeatures)}o(q,V){return n.DocumentSelector.from(q,this.g,V)}p(q){return new o.$tN(()=>{this.f.delete(q),this.e.$unregister(q)})}q(){return Ie.d++}async s(q,V,J,x,fe,we=!1){const Le=this.f.get(q);if(!Le||!(Le.adapter instanceof V))return x;const He=Date.now();we||this.l.trace(`[${Le.extension.identifier.value}] INVOKE provider '${J.toString().replace(/[\r\n]/g,"")}'`);const Ke=J(Le.adapter,Le.extension);return Promise.resolve(Ke).catch(et=>{(0,R.$6)(et)||(this.l.error(`[${Le.extension.identifier.value}] provider FAILED`),this.l.error(et),this.n.onExtensionError(Le.extension.identifier,et))}).finally(()=>{we||this.l.trace(`[${Le.extension.identifier.value}] provider DONE after ${Date.now()-He}ms`)}),P.CancellationToken.isCancellationToken(fe)?(0,h.$uh)(Ke,fe):Ke}t(q,V){const J=this.q();return this.f.set(J,new ke(q,V)),J}static u(q){return q.displayName||q.name}static w(q){return q.identifier.value}registerDocumentSymbolProvider(q,V,J,x){const fe=this.t(new g(this.h,J),q),we=x&&x.label||Ie.u(q);return this.e.$registerDocumentSymbolProvider(fe,this.o(V,q),we),this.p(fe)}$provideDocumentSymbols(q,V,J){return this.s(q,g,x=>x.provideDocumentSymbols(u.URI.revive(V),J),void 0,J)}registerCodeLensProvider(q,V,J){const x=this.q(),fe=typeof J.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(x,new ke(new l(this.h,this.j.converter,J,q,this.n,this.l),q)),this.e.$registerCodeLensSupport(x,this.o(V,q),fe);let we=this.p(x);if(fe!==void 0){const Le=J.onDidChangeCodeLenses(He=>this.e.$emitCodeLensEvent(fe));we=o.$tN.from(we,Le)}return we}$provideCodeLenses(q,V,J){return this.s(q,l,x=>x.provideCodeLenses(u.URI.revive(V),J),void 0,J)}$resolveCodeLens(q,V,J){return this.s(q,l,x=>x.resolveCodeLens(V,J),void 0,void 0)}$releaseCodeLenses(q,V){this.s(q,l,J=>Promise.resolve(J.releaseCodeLenses(V)),void 0,void 0)}registerDefinitionProvider(q,V,J){const x=this.t(new S(this.h,J),q);return this.e.$registerDefinitionSupport(x,this.o(V,q)),this.p(x)}$provideDefinition(q,V,J,x){return this.s(q,S,fe=>fe.provideDefinition(u.URI.revive(V),J,x),[],x)}registerDeclarationProvider(q,V,J){const x=this.t(new D(this.h,J),q);return this.e.$registerDeclarationSupport(x,this.o(V,q)),this.p(x)}$provideDeclaration(q,V,J,x){return this.s(q,D,fe=>fe.provideDeclaration(u.URI.revive(V),J,x),[],x)}registerImplementationProvider(q,V,J){const x=this.t(new y(this.h,J),q);return this.e.$registerImplementationSupport(x,this.o(V,q)),this.p(x)}$provideImplementation(q,V,J,x){return this.s(q,y,fe=>fe.provideImplementation(u.URI.revive(V),J,x),[],x)}registerTypeDefinitionProvider(q,V,J){const x=this.t(new C(this.h,J),q);return this.e.$registerTypeDefinitionSupport(x,this.o(V,q)),this.p(x)}$provideTypeDefinition(q,V,J,x){return this.s(q,C,fe=>fe.provideTypeDefinition(u.URI.revive(V),J,x),[],x)}registerHoverProvider(q,V,J,x){const fe=this.t(new A(this.h,J),q);return this.e.$registerHoverProvider(fe,this.o(V,q)),this.p(fe)}$provideHover(q,V,J,x,fe){return this.s(q,A,we=>we.provideHover(u.URI.revive(V),J,x,fe),void 0,fe)}$releaseHover(q,V){this.s(q,A,J=>Promise.resolve(J.releaseHover(V)),void 0,void 0)}registerEvaluatableExpressionProvider(q,V,J,x){const fe=this.t(new b(this.h,J),q);return this.e.$registerEvaluatableExpressionProvider(fe,this.o(V,q)),this.p(fe)}$provideEvaluatableExpression(q,V,J,x){return this.s(q,b,fe=>fe.provideEvaluatableExpression(u.URI.revive(V),J,x),void 0,x)}registerInlineValuesProvider(q,V,J,x){const fe=typeof J.onDidChangeInlineValues=="function"?this.q():void 0,we=this.t(new v(this.h,J),q);this.e.$registerInlineValuesProvider(we,this.o(V,q),fe);let Le=this.p(we);if(fe!==void 0){const He=J.onDidChangeInlineValues(Ke=>this.e.$emitInlineValuesEvent(fe));Le=o.$tN.from(Le,He)}return Le}$provideInlineValues(q,V,J,x,fe){return this.s(q,v,we=>we.provideInlineValues(u.URI.revive(V),J,x,fe),void 0,fe)}registerDocumentHighlightProvider(q,V,J){const x=this.t(new L(this.h,J),q);return this.e.$registerDocumentHighlightProvider(x,this.o(V,q)),this.p(x)}registerMultiDocumentHighlightProvider(q,V,J){const x=this.t(new O(this.h,J),q);return this.e.$registerMultiDocumentHighlightProvider(x,this.o(V,q)),this.p(x)}$provideDocumentHighlights(q,V,J,x){return this.s(q,L,fe=>fe.provideDocumentHighlights(u.URI.revive(V),J,x),void 0,x)}$provideMultiDocumentHighlights(q,V,J,x,fe){return this.s(q,O,we=>we.provideMultiDocumentHighlights(u.URI.revive(V),J,x.map(Le=>u.URI.revive(Le)),fe),void 0,fe)}registerLinkedEditingRangeProvider(q,V,J){const x=this.t(new M(this.h,J),q);return this.e.$registerLinkedEditingRangeProvider(x,this.o(V,q)),this.p(x)}$provideLinkedEditingRanges(q,V,J,x){return this.s(q,M,async fe=>{const we=await fe.provideLinkedEditingRanges(u.URI.revive(V),J,x);if(we)return{ranges:we.ranges,wordPattern:we.wordPattern?Ie.y(we.wordPattern):void 0}},void 0,x)}registerReferenceProvider(q,V,J){const x=this.t(new j(this.h,J),q);return this.e.$registerReferenceSupport(x,this.o(V,q)),this.p(x)}$provideReferences(q,V,J,x,fe){return this.s(q,j,we=>we.provideReferences(u.URI.revive(V),J,x,fe),void 0,fe)}registerCodeActionProvider(q,V,J,x){const fe=new N.$Vc,we=this.t(new z(this.h,this.j.converter,this.k,J,this.l,q,this.m),q);return this.e.$registerCodeActionSupport(we,this.o(V,q),{providedKinds:x?.providedCodeActionKinds?.map(Le=>Le.value),documentation:x?.documentation?.map(Le=>({kind:Le.kind.value,command:this.j.converter.toInternal(Le.command,fe)}))},Ie.u(q),Ie.w(q),!!J.resolveCodeAction),fe.add(this.p(we)),fe}$provideCodeActions(q,V,J,x,fe){return this.s(q,z,we=>we.provideCodeActions(u.URI.revive(V),J,x,fe),void 0,fe)}$resolveCodeAction(q,V,J){return this.s(q,z,x=>x.resolveCodeAction(V,J),{},void 0)}$releaseCodeActions(q,V){this.s(q,z,J=>Promise.resolve(J.releaseCodeActions(V)),void 0,void 0)}registerDocumentFormattingEditProvider(q,V,J){const x=this.t(new B(this.h,J),q);return this.e.$registerDocumentFormattingSupport(x,this.o(V,q),q.identifier,q.displayName||q.name),this.p(x)}$provideDocumentFormattingEdits(q,V,J,x){return this.s(q,B,fe=>fe.provideDocumentFormattingEdits(u.URI.revive(V),J,x),void 0,x)}registerDocumentRangeFormattingEditProvider(q,V,J){const x=typeof J.provideDocumentRangesFormattingEdits=="function",fe=this.t(new _(this.h,J),q);return this.e.$registerRangeFormattingSupport(fe,this.o(V,q),q.identifier,q.displayName||q.name,x),this.p(fe)}$provideDocumentRangeFormattingEdits(q,V,J,x,fe){return this.s(q,_,we=>we.provideDocumentRangeFormattingEdits(u.URI.revive(V),J,x,fe),void 0,fe)}$provideDocumentRangesFormattingEdits(q,V,J,x,fe){return this.s(q,_,we=>we.provideDocumentRangesFormattingEdits(u.URI.revive(V),J,x,fe),void 0,fe)}registerOnTypeFormattingEditProvider(q,V,J,x){const fe=this.t(new re(this.h,J),q);return this.e.$registerOnTypeFormattingSupport(fe,this.o(V,q),x,q.identifier),this.p(fe)}$provideOnTypeFormattingEdits(q,V,J,x,fe,we){return this.s(q,re,Le=>Le.provideOnTypeFormattingEdits(u.URI.revive(V),J,x,fe,we),void 0,we)}registerWorkspaceSymbolProvider(q,V){const J=this.t(new U(V,this.l),q);return this.e.$registerNavigateTypeSupport(J,typeof V.resolveWorkspaceSymbol=="function"),this.p(J)}$provideWorkspaceSymbols(q,V,J){return this.s(q,U,x=>x.provideWorkspaceSymbols(V,J),{symbols:[]},J)}$resolveWorkspaceSymbol(q,V,J){return this.s(q,U,x=>x.resolveWorkspaceSymbol(V,J),void 0,void 0)}$releaseWorkspaceSymbols(q,V){this.s(q,U,J=>J.releaseWorkspaceSymbols(V),void 0,void 0)}registerRenameProvider(q,V,J){const x=this.t(new G(this.h,J,this.l),q);return this.e.$registerRenameSupport(x,this.o(V,q),G.supportsResolving(J)),this.p(x)}$provideRenameEdits(q,V,J,x,fe){return this.s(q,G,we=>we.provideRenameEdits(u.URI.revive(V),J,x,fe),void 0,fe)}$resolveRenameLocation(q,V,J,x){return this.s(q,G,fe=>fe.resolveRenameLocation(u.URI.revive(V),J,x),void 0,x)}registerNewSymbolNamesProvider(q,V,J){const x=this.t(new Q(this.h,J,this.l),q);return this.e.$registerNewSymbolNamesProvider(x,this.o(V,q)),this.p(x)}$supportsAutomaticNewSymbolNamesTriggerKind(q){return this.s(q,Q,V=>V.supportsAutomaticNewSymbolNamesTriggerKind(),!1,void 0)}$provideNewSymbolNames(q,V,J,x,fe){return this.s(q,Q,we=>we.provideNewSymbolNames(u.URI.revive(V),J,x,fe),void 0,fe)}registerDocumentSemanticTokensProvider(q,V,J,x){const fe=this.t(new he(this.h,J),q),we=typeof J.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(fe,this.o(V,q),x,we);let Le=this.p(fe);if(we){const He=J.onDidChangeSemanticTokens(Ke=>this.e.$emitDocumentSemanticTokensEvent(we));Le=o.$tN.from(Le,He)}return Le}$provideDocumentSemanticTokens(q,V,J,x){return this.s(q,he,fe=>fe.provideDocumentSemanticTokens(u.URI.revive(V),J,x),null,x)}$releaseDocumentSemanticTokens(q,V){this.s(q,he,J=>J.releaseDocumentSemanticColoring(V),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(q,V,J,x){const fe=this.t(new ne(this.h,J),q);return this.e.$registerDocumentRangeSemanticTokensProvider(fe,this.o(V,q),x),this.p(fe)}$provideDocumentRangeSemanticTokens(q,V,J,x){return this.s(q,ne,fe=>fe.provideDocumentRangeSemanticTokens(u.URI.revive(V),J,x),null,x)}registerCompletionItemProvider(q,V,J,x){const fe=this.t(new De(this.h,this.j.converter,J,this.m,q),q);return this.e.$registerCompletionsProvider(fe,this.o(V,q),x,De.supportsResolving(J),q.identifier),this.p(fe)}$provideCompletionItems(q,V,J,x,fe){return this.s(q,De,we=>we.provideCompletionItems(u.URI.revive(V),J,x,fe),void 0,fe)}$resolveCompletionItem(q,V,J){return this.s(q,De,x=>x.resolveCompletionItem(V,J),void 0,J)}$releaseCompletionItems(q,V){this.s(q,De,J=>J.releaseCompletionItems(V),void 0,void 0)}registerInlineCompletionsProvider(q,V,J,x){const fe=new K(q,this.h,J,this.j.converter),we=this.t(fe,q);return this.e.$registerInlineCompletionsSupport(we,this.o(V,q),fe.supportsHandleEvents,m.$qn.toKey(q.identifier.value),x?.yieldTo?.map(Le=>m.$qn.toKey(Le))||[]),this.p(we)}$provideInlineCompletions(q,V,J,x,fe){return this.s(q,$e,we=>we.provideInlineCompletions(u.URI.revive(V),J,x,fe),void 0,fe)}$handleInlineCompletionDidShow(q,V,J,x){this.s(q,$e,async fe=>{fe.handleDidShowCompletionItem(V,J,x)},void 0,void 0)}$handleInlineCompletionPartialAccept(q,V,J,x,fe){this.s(q,$e,async we=>{we.handlePartialAccept(V,J,x,fe)},void 0,void 0)}$freeInlineCompletionsList(q,V){this.s(q,$e,async J=>{J.disposeCompletions(V)},void 0,void 0)}registerInlineEditProvider(q,V,J){const x=new W(q,this.h,J,this.j.converter),fe=this.t(x,q);return this.e.$registerInlineEditProvider(fe,this.o(V,q),q.identifier),this.p(fe)}$provideInlineEdit(q,V,J,x){return this.s(q,W,fe=>fe.provideInlineEdits(u.URI.revive(V),J,x),void 0,x)}$freeInlineEdit(q,V){this.s(q,W,async J=>{J.disposeEdit(V)},void 0,void 0)}registerSignatureHelpProvider(q,V,J,x){const fe=Array.isArray(x)?{triggerCharacters:x,retriggerCharacters:[]}:x,we=this.t(new oe(this.h,J),q);return this.e.$registerSignatureHelpProvider(we,this.o(V,q),fe),this.p(we)}$provideSignatureHelp(q,V,J,x,fe){return this.s(q,oe,we=>we.provideSignatureHelp(u.URI.revive(V),J,x,fe),void 0,fe)}$releaseSignatureHelp(q,V){this.s(q,oe,J=>J.releaseSignatureHelp(V),void 0,void 0)}registerInlayHintsProvider(q,V,J){const x=typeof J.onDidChangeInlayHints=="function"?this.q():void 0,fe=this.t(new te(this.h,this.j.converter,J,this.l,q),q);this.e.$registerInlayHintsProvider(fe,this.o(V,q),typeof J.resolveInlayHint=="function",x,Ie.u(q));let we=this.p(fe);if(x!==void 0){const Le=J.onDidChangeInlayHints(He=>this.e.$emitInlayHintsEvent(x));we=o.$tN.from(we,Le)}return we}$provideInlayHints(q,V,J,x){return this.s(q,te,fe=>fe.provideInlayHints(u.URI.revive(V),J,x),void 0,x)}$resolveInlayHint(q,V,J){return this.s(q,te,x=>x.resolveInlayHint(V,J),void 0,J)}$releaseInlayHints(q,V){this.s(q,te,J=>J.releaseHints(V),void 0,void 0)}registerDocumentLinkProvider(q,V,J){const x=this.t(new le(this.h,J),q);return this.e.$registerDocumentLinkProvider(x,this.o(V,q),typeof J.resolveDocumentLink=="function"),this.p(x)}$provideDocumentLinks(q,V,J){return this.s(q,le,x=>x.provideLinks(u.URI.revive(V),J),void 0,J,V.scheme==="output")}$resolveDocumentLink(q,V,J){return this.s(q,le,x=>x.resolveLink(V,J),void 0,void 0,!0)}$releaseDocumentLinks(q,V){this.s(q,le,J=>J.releaseLinks(V),void 0,void 0,!0)}registerColorProvider(q,V,J){const x=this.t(new ue(this.h,J),q);return this.e.$registerDocumentColorProvider(x,this.o(V,q)),this.p(x)}$provideDocumentColors(q,V,J){return this.s(q,ue,x=>x.provideColors(u.URI.revive(V),J),[],J)}$provideColorPresentations(q,V,J,x){return this.s(q,ue,fe=>fe.provideColorPresentations(u.URI.revive(V),J,x),void 0,x)}registerFoldingRangeProvider(q,V,J){const x=this.q(),fe=typeof J.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(x,new ke(new X(this.h,J),q)),this.e.$registerFoldingRangeProvider(x,this.o(V,q),q.identifier,fe);let we=this.p(x);if(fe!==void 0){const Le=J.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(fe));we=o.$tN.from(we,Le)}return we}$provideFoldingRanges(q,V,J,x){return this.s(q,X,fe=>fe.provideFoldingRanges(u.URI.revive(V),J,x),void 0,x)}registerSelectionRangeProvider(q,V,J){const x=this.t(new ae(this.h,J,this.l),q);return this.e.$registerSelectionRangeProvider(x,this.o(V,q)),this.p(x)}$provideSelectionRanges(q,V,J,x){return this.s(q,ae,fe=>fe.provideSelectionRanges(u.URI.revive(V),J,x),[],x)}registerCallHierarchyProvider(q,V,J){const x=this.t(new pe(this.h,J),q);return this.e.$registerCallHierarchyProvider(x,this.o(V,q)),this.p(x)}$prepareCallHierarchy(q,V,J,x){return this.s(q,pe,fe=>Promise.resolve(fe.prepareSession(u.URI.revive(V),J,x)),void 0,x)}$provideCallHierarchyIncomingCalls(q,V,J,x){return this.s(q,pe,fe=>fe.provideCallsTo(V,J,x),void 0,x)}$provideCallHierarchyOutgoingCalls(q,V,J,x){return this.s(q,pe,fe=>fe.provideCallsFrom(V,J,x),void 0,x)}$releaseCallHierarchy(q,V){this.s(q,pe,J=>Promise.resolve(J.releaseSession(V)),void 0,void 0)}registerTypeHierarchyProvider(q,V,J){const x=this.t(new be(this.h,J),q);return this.e.$registerTypeHierarchyProvider(x,this.o(V,q)),this.p(x)}$prepareTypeHierarchy(q,V,J,x){return this.s(q,be,fe=>Promise.resolve(fe.prepareSession(u.URI.revive(V),J,x)),void 0,x)}$provideTypeHierarchySupertypes(q,V,J,x){return this.s(q,be,fe=>fe.provideSupertypes(V,J,x),void 0,x)}$provideTypeHierarchySubtypes(q,V,J,x){return this.s(q,be,fe=>fe.provideSubtypes(V,J,x),void 0,x)}$releaseTypeHierarchy(q,V){this.s(q,be,J=>Promise.resolve(J.releaseSession(V)),void 0,void 0)}registerDocumentOnDropEditProvider(q,V,J,x){const fe=this.q();return this.f.set(fe,new ke(new Fe(this.e,this.h,J,fe,q),q)),this.e.$registerDocumentOnDropEditProvider(fe,this.o(V,q),(0,t.$3G)(q,"documentPaste")&&x?{supportsResolve:!!J.resolveDocumentDropEdit,dropMimeTypes:x.dropMimeTypes}:void 0),this.p(fe)}$provideDocumentOnDropEdits(q,V,J,x,fe,we){return this.s(q,Fe,Le=>Promise.resolve(Le.provideDocumentOnDropEdits(V,u.URI.revive(J),x,fe,we)),void 0,void 0)}$resolveDropEdit(q,V,J){return this.s(q,Fe,x=>x.resolveDropEdit(V,J),{},void 0)}$releaseDocumentOnDropEdits(q,V){this.s(q,Fe,J=>Promise.resolve(J.releaseDropEdits(V)),void 0,void 0)}registerMappedEditsProvider(q,V,J){const x=this.t(new Ue(this.h,J),q);return this.e.$registerMappedEditsProvider(x,this.o(V,q)),this.p(x)}$provideMappedEdits(q,V,J,x,fe){return this.s(q,Ue,we=>Promise.resolve(we.provideMappedEdits(V,J,x,fe)),null,fe)}registerDocumentPasteEditProvider(q,V,J,x){const fe=this.q();return this.f.set(fe,new ke(new F(this.e,this.h,J,fe,q),q)),this.e.$registerPasteEditProvider(fe,this.o(V,q),{supportsCopy:!!J.prepareDocumentPaste,supportsPaste:!!J.provideDocumentPasteEdits,supportsResolve:!!J.resolveDocumentPasteEdit,providedPasteEditKinds:x.providedPasteEditKinds?.map(we=>we.value),copyMimeTypes:x.copyMimeTypes,pasteMimeTypes:x.pasteMimeTypes}),this.p(fe)}$prepareDocumentPaste(q,V,J,x,fe){return this.s(q,F,we=>we.prepareDocumentPaste(u.URI.revive(V),J,x,fe),void 0,fe)}$providePasteEdits(q,V,J,x,fe,we,Le){return this.s(q,F,He=>He.providePasteEdits(V,u.URI.revive(J),x,fe,we,Le),void 0,Le)}$resolvePasteEdit(q,V,J){return this.s(q,F,x=>x.resolvePasteEdit(V,J),{},void 0)}$releasePasteEdits(q,V){this.s(q,F,J=>Promise.resolve(J.releasePasteEdits(V)),void 0,void 0)}static y(q){return{pattern:q.source,flags:q.flags}}static z(q){return{decreaseIndentPattern:Ie.y(q.decreaseIndentPattern),increaseIndentPattern:Ie.y(q.increaseIndentPattern),indentNextLinePattern:q.indentNextLinePattern?Ie.y(q.indentNextLinePattern):void 0,unIndentedLinePattern:q.unIndentedLinePattern?Ie.y(q.unIndentedLinePattern):void 0}}static B(q){return{beforeText:Ie.y(q.beforeText),afterText:q.afterText?Ie.y(q.afterText):void 0,previousLineText:q.previousLineText?Ie.y(q.previousLineText):void 0,action:q.action}}static C(q){return q.map(Ie.B)}static D(q){return{open:q.open,close:q.close,notIn:q.notIn?q.notIn.map(V=>o.SyntaxTokenType.toString(V)):void 0}}static E(q){return q.map(Ie.D)}setLanguageConfiguration(q,V,J){const{wordPattern:x}=J;if(x&&(0,I.$sf)(x))throw new Error(`Invalid language configuration: wordPattern '${x}' is not allowed to match the empty string.`);x?this.h.setWordDefinitionFor(V,x):this.h.setWordDefinitionFor(V,void 0),J.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",q,"Do not use."),J.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",q,"Do not use.");const fe=this.q(),we={comments:J.comments,brackets:J.brackets,wordPattern:J.wordPattern?Ie.y(J.wordPattern):void 0,indentationRules:J.indentationRules?Ie.z(J.indentationRules):void 0,onEnterRules:J.onEnterRules?Ie.C(J.onEnterRules):void 0,__electricCharacterSupport:J.__electricCharacterSupport,__characterPairSupport:J.__characterPairSupport,autoClosingPairs:J.autoClosingPairs?Ie.E(J.autoClosingPairs):void 0};return this.e.$setLanguageConfiguration(fe,V,we),this.p(fe)}$setWordDefinitions(q){for(const V of q)this.h.setWordDefinitionFor(V.languageId,new RegExp(V.regexSource,V.regexFlags))}}e.$2nc=Ie}),define(Ee[129],ye([1,0,9,21,14,4,40,3,236,24,5,12,90,6,128,20,17,10,155,26]),function(ce,e,r,h,P,R,T,N,$,c,I,E,u,k,p,a,f,d,m,n){"use strict";var o;Object.defineProperty(e,"__esModule",{value:!0}),e.$Joc=e.$Ioc=void 0,f=We(f),d=We(d),e.$Ioc=(0,I.$Fi)("IExtHostLanguageModels");class t{constructor(l,w){this.option=l,this.stream=new r.$9h,this.stream=w??new r.$9h}}class i{constructor(){this.a=new Map,this.b=new r.$9h,this.c=!1,this.d=!1;const l=this;this.apiObject={stream:l.b.asyncIterable,text:r.$6h.map(l.b.asyncIterable,w=>{if(w instanceof d.$HP)return w.value}).coalesce()}}*f(){if(this.a.size>0)for(const[,l]of this.a)yield l.stream;else yield this.b}handleFragment(l){if(this.c)return;this.d=!0;let w=this.a.get(l.index);w||(this.a.size===0?w=new t(l.index,this.b):w=new t(l.index),this.a.set(l.index,w));let S;l.part.type==="text"?S=new d.$HP(l.part.value):S=new d.$GP(l.part.name,l.part.parameters),w.stream.emitOne(S)}get isStreaming(){return this.d}reject(l){this.c=!0;for(const w of this.f())w.reject(l)}resolve(){this.c=!0;for(const l of this.f())l.resolve()}}let s=class{static{o=this}static{this.a=1}constructor(l,w,S){this.j=w,this.k=S,this.c=new R.$me,this.d=new R.$me,this.onDidChangeProviders=this.d.event,this.f=new Map,this.g=new Map,this.h=new c.$sn,this.i=new Map,this.r=new Set,this.b=l.getProxy(k.$rN.MainThreadLanguageModels)}dispose(){this.c.dispose(),this.d.dispose()}registerLanguageModel(l,w,S,D){const y=o.a++;this.f.set(y,{extension:l.identifier,provider:S,languageModelId:w});let C;D.auth&&(C={providerLabel:l.displayName||l.name,accountLabel:typeof D.auth=="object"?D.auth.label:void 0}),this.b.$registerLanguageModelProvider(y,`${c.$qn.toKey(l.identifier)}/${y}/${w}`,{extension:l.identifier,id:w,vendor:D.vendor??c.$qn.toKey(l.identifier),name:D.name??"",family:D.family??"",version:D.version,maxInputTokens:D.maxInputTokens,maxOutputTokens:D.maxOutputTokens,auth:C,targetExtensions:D.extensions});const A=S.onDidReceiveLanguageModelResponse2?.(({extensionId:b,participant:v,tokenCount:L})=>{this.b.$whenLanguageModelChatRequestMade(w,new c.$qn(b),v,L)});return(0,N.$Uc)(()=>{this.f.delete(y),this.b.$unregisterProvider(y),A?.dispose()})}async $provideLanguageModelResponse(l,w,S,D,y,C){const A=this.f.get(l);if(!A)return;const b=new u.$rw(async v=>{if(C.isCancellationRequested){this.j.warn(`[CHAT](${A.extension.value}) CANNOT send progress because the REQUEST IS CANCELLED`);return}let L;if(v.part instanceof d.$GP?L={type:"function_use",name:v.part.name,parameters:v.part.parameters}:v.part instanceof d.$HP&&(L={type:"text",value:v.part.value}),!L){this.j.warn(`[CHAT](${A.extension.value}) UNKNOWN part ${JSON.stringify(v)}`);return}this.b.$handleProgressChunk(w,{index:v.index,part:L})});if(A.provider.provideLanguageModelResponse2)return A.provider.provideLanguageModelResponse2(D.map(f.LanguageModelChatMessage.to),y,c.$qn.toKey(S),b,C);{const v=new u.$rw(async L=>{b.report({index:L.index,part:new d.$HP(L.part)})});return A.provider.provideLanguageModelResponse(D.map(f.LanguageModelChatMessage.to),y?.modelOptions??{},c.$qn.toKey(S),v,C)}}$provideTokenLength(l,w,S){const D=this.f.get(l);return D?Promise.resolve(D.provider.provideTokenCount(w,S)):Promise.resolve(0)}$acceptChatModelMetadata(l){if(l.added)for(const{identifier:w,metadata:S}of l.added)this.g.set(w,{metadata:S,apiObjects:new c.$sn});if(l.removed)for(const w of l.removed){this.g.delete(w);for(const[S,D]of this.i)D.languageModelId===w&&(D.res.reject(new P.$7),this.i.delete(S))}l.added?.forEach(w=>this.p(w.metadata)),this.d.fire(void 0)}async selectLanguageModels(l,w){const S=await this.b.$selectChatModels({...w,extension:l.identifier}),D=[],y=this;for(const C of S){const A=this.g.get(C);if(!A)continue;this.o(l.identifier,A.metadata)&&await this.p(A.metadata);let b=A.apiObjects.get(l.identifier);b||(b={id:C,vendor:A.metadata.vendor,family:A.metadata.family,version:A.metadata.version,name:A.metadata.name,maxInputTokens:A.metadata.maxInputTokens,countTokens(v,L){if(!y.g.has(C))throw d.$LP.NotFound(C);return y.q(C,v,L??h.CancellationToken.None)},sendRequest(v,L,O){if(!y.g.has(C))throw d.$LP.NotFound(C);return y.l(l,C,v,L??{},O??h.CancellationToken.None)}},Object.freeze(b),A.apiObjects.set(l.identifier,b)),D.push(b)}return D}async l(l,w,S,D,y){const C=this.m(l,S),A=l.identifier,b=this.g.get(w)?.metadata;if(!b||!this.g.has(w))throw d.$LP.NotFound(`Language model '${w}' is unknown.`);if(this.o(A,b)&&(!await this.n(l,{identifier:b.extension,displayName:b.auth.providerLabel},D.justification,!1)||!this.h.get(A)?.has(b.extension)))throw d.$LP.NoPermissions(`Language model '${w}' cannot be used by '${A.value}'.`);const v=Math.random()*1e6|0,L=this.b.$fetchResponse(A,w,v,C,D,y),O=new r.$Eh,M=new i;this.i.set(v,{languageModelId:w,res:M});let j;if(L.catch(z=>{O.isOpen()?M.reject(z):j=z}).finally(()=>{this.i.delete(v),M.resolve(),O.open()}),await O.wait(),j)throw j.name===d.$LP.name?j:new d.$LP(`Language model '${w}' errored, check cause for more details`,"Unknown",j);return M.apiObject}m(l,w){const S=[];for(const D of w)D.role===d.LanguageModelChatMessageRole.System&&(0,n.$4G)(l,"languageModelSystem"),D.content2 instanceof d.$EP&&(0,n.$4G)(l,"lmTools"),S.push(f.LanguageModelChatMessage.from(D));return S}async $handleResponseFragment(l,w){const S=this.i.get(l);S&&S.res.handleFragment(w)}async n(l,w,S,D){const y=m.$tM+w.identifier.value;if(await this.k.getSession(l,y,[],{silent:!0}))return this.$updateModelAccesslist([{from:l.identifier,to:w.identifier,enabled:!0}]),!0;if(D)return!1;try{const A=S?(0,$.localize)(0,null,w.displayName,S):void 0;return await this.k.getSession(l,y,[],{forceNewSession:{detail:A}}),this.$updateModelAccesslist([{from:l.identifier,to:w.identifier,enabled:!0}]),!0}catch{return!1}}o(l,w){return!!w.auth&&!c.$qn.equals(w.extension,l)}async p(l){if(l.auth)for(const w of this.r)try{await this.n(w,{identifier:l.extension,displayName:""},void 0,!0)}catch(S){this.j.error("Fake Auth request failed"),this.j.error(S)}}async q(l,w,S){if(!this.g.get(l))throw d.$LP.NotFound(`Language model '${l}' is unknown.`);const y=T.Iterable.find(this.f.values(),C=>C.languageModelId===l);return y?y.provider.provideTokenCount(w,S):this.b.$countTokens(l,typeof w=="string"?w:f.LanguageModelChatMessage.from(w),S)}$updateModelAccesslist(l){const w=new Array;for(const{from:S,to:D,enabled:y}of l){const C=this.h.get(S)??new c.$rn;if(C.has(D)!==y){y?C.add(D):C.delete(D),this.h.set(S,C);const b={from:S,to:D};w.push(b),this.c.fire(b)}}}createLanguageModelAccessInformation(l){this.r.add(l);const w=this,S=R.Event.signal(R.Event.filter(this.c.event,y=>c.$qn.equals(y.from,l.identifier))),D=R.Event.signal(this.d.event);return{get onDidChange(){return R.Event.any(S,D)},canSendRequest(y){let C;e:for(const[b,v]of w.g)for(const L of v.apiObjects.values())if(L===y){C=v.metadata;break e}if(!C)return;if(!w.o(l.identifier,C))return!0;const A=w.h.get(l.identifier);if(A)return A.has(C.extension)}}}};e.$Joc=s,e.$Joc=s=o=Je([Ge(0,a.$XP),Ge(1,E.$_j),Ge(2,p.$4nc)],s)});var zt=this&&this.__importDefault||function(ce){return ce&&ce.__esModule?ce:{default:ce}};define(Ee[357],ye([1,0,6,17,10,44,9,3,26]),function(ce,e,r,h,P,R,T,N,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tpc=void 0,h=We(h),R=zt(R);class c{constructor(E,u,k,p){this.c=u,this.d=k,this.e=p,this.b=[],this.f=0,this.g=new Set,this.a=E.getProxy(r.$rN.MainThreadLanguages)}$acceptLanguageIds(E){this.b=E}async getLanguages(){return this.b.slice(0)}async changeLanguage(E,u){await this.a.$changeLanguage(E,u);const k=this.c.getDocumentData(E);if(!k)throw new Error(`document '${E.toString()}' NOT found`);return k.document}async tokenAtPosition(E,u){const k=E.version,p=h.Position.from(u),a=await this.a.$tokensAtPosition(E.uri,p),f={type:P.StandardTokenType.Other,range:E.getWordRangeAtPosition(u)??new P.$vN(u.line,u.character,u.line,u.character)};if(!a)return f;const d={range:h.Range.to(a.range),type:h.TokenType.to(a.type)};return!d.range.contains(u)||k!==E.version?f:d}createLanguageStatusItem(E,u,k){const p=this.f++,a=this.a,f=this.g,d=`${E.identifier.value}/${u}`;if(f.has(d))throw new Error(`LanguageStatusItem with id '${u}' ALREADY exists`);f.add(d);const m={selector:k,id:u,name:E.displayName??E.name,severity:P.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let n;const o=new N.$Vc,t=()=>{if(n?.dispose(),!f.has(d)){console.warn(`LanguageStatusItem (${u}) from ${E.identifier.value} has been disposed and CANNOT be updated anymore`);return}n=(0,T.$Hh)(()=>{o.clear(),this.a.$setLanguageStatus(p,{id:d,name:m.name??E.displayName??E.name,source:E.displayName??E.name,selector:h.DocumentSelector.from(m.selector,this.e),label:m.text,detail:m.detail??"",severity:m.severity===P.LanguageStatusSeverity.Error?R.default.Error:m.severity===P.LanguageStatusSeverity.Warning?R.default.Warning:R.default.Info,command:m.command&&this.d.toInternal(m.command,o),accessibilityInfo:m.accessibilityInformation,busy:m.busy})},0)},i={dispose(){o.dispose(),n?.dispose(),a.$removeLanguageStatus(p),f.delete(d)},get id(){return m.id},get name(){return m.name},set name(s){m.name=s,t()},get selector(){return m.selector},set selector(s){m.selector=s,t()},get text(){return m.text},set text(s){m.text=s,t()},set text2(s){(0,$.$4G)(E,"languageStatusText"),m.text=s,t()},get text2(){return(0,$.$4G)(E,"languageStatusText"),m.text},get detail(){return m.detail},set detail(s){m.detail=s,t()},get severity(){return m.severity},set severity(s){m.severity=s,t()},get accessibilityInformation(){return m.accessibilityInformation},set accessibilityInformation(s){m.accessibilityInformation=s,t()},get command(){return m.command},set command(s){m.command=s,t()},get busy(){return m.busy},set busy(s){m.busy=s,t()}};return t(),i}}e.$tpc=c}),define(Ee[358],ye([1,0,15,2,17,10,127]),function(ce,e,r,h,P,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gpc=e.$fpc=void 0,P=We(P),T=We(T);class N{constructor(E,u,k,p){this.start=E,this.deletedCount=u,this.deletedItems=k,this.items=p}asApiEvent(){return{range:new R.$VO(this.start,this.start+this.deletedCount),addedCells:this.items.map(E=>E.apiCell),removedCells:this.deletedItems}}}class ${static asModelAddData(E){return{EOL:E.eol,lines:E.source,languageId:E.language,uri:E.uri,isDirty:!1,versionId:1}}constructor(E,u,k){this.notebook=E,this.h=u,this.j=k,this.handle=k.handle,this.uri=h.URI.revive(k.uri),this.cellKind=k.cellKind,this.a=k.outputs.map(P.NotebookCellOutput.to),this.e=k.internalMetadata??{},this.b=Object.freeze(k.metadata??{}),this.d=Object.freeze(P.NotebookCellExecutionSummary.to(k.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const E=this,u=this.h.getDocument(this.uri);if(!u)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const k={get index(){return E.notebook.getCellIndex(E)},notebook:E.notebook.apiNotebook,kind:P.NotebookCellKind.to(this.j.cellKind),document:u.document,get mime(){return E.g},set mime(p){E.g=p},get outputs(){return E.a.slice(0)},get metadata(){return E.b},get executionSummary(){return E.d}};this.f=Object.freeze(k)}return this.f}setOutputs(E){this.a=E.map(P.NotebookCellOutput.to)}setOutputItems(E,u,k){const p=k.map(P.NotebookCellOutputItem.to),a=this.a.find(f=>f.id===E);if(a&&(u||(a.items.length=0),a.items.push(...p),a.items.length>1&&a.items.every(f=>T.$wL(f.mime)))){const f=new Map,d=[];a.items.forEach(m=>{let n;f.has(m.mime)?n=f.get(m.mime):(n=[],f.set(m.mime,n),d.push(m.mime)),n.push(m.data)}),a.items.length=0,d.forEach(m=>{const n=T.$xL(f.get(m));a.items.push({mime:m,data:n.data.buffer})})}}setMetadata(E){this.b=Object.freeze(E)}setInternalMetadata(E){this.e=E,this.d=Object.freeze(P.NotebookCellExecutionSummary.to(E))}setMime(E){}}e.$fpc=$;class c{static{this.a=0}constructor(E,u,k,p,a){this.k=E,this.l=u,this.m=k,this.uri=p,this.handle=c.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=a.viewType,this.f=Object.freeze(a.metadata??Object.create(null)),this.r([[0,0,a.cells]],!0,void 0),this.g=a.versionId}dispose(){this.j=!0}get versionId(){return this.g}get apiNotebook(){if(!this.e){const E=this,u={get uri(){return E.uri},get version(){return E.g},get notebookType(){return E.d},get isDirty(){return E.h},get isUntitled(){return E.uri.scheme===r.Schemas.untitled},get isClosed(){return E.j},get metadata(){return E.f},get cellCount(){return E.b.length},cellAt(k){return k=E.n(k),E.b[k].apiCell},getCells(k){return(k?E.p(k):E.b).map(a=>a.apiCell)},save(){return E.q()}};this.e=Object.freeze(u)}return this.e}acceptDocumentPropertiesChanged(E){E.metadata&&(this.f=Object.freeze({...this.f,...E.metadata}))}acceptDirty(E){this.h=E}acceptModelChanged(E,u,k){this.g=E.versionId,this.h=u,this.acceptDocumentPropertiesChanged({metadata:k});const p={notebook:this.apiNotebook,metadata:k,cellChanges:[],contentChanges:[]},a=[];for(const d of E.rawEvents)d.kind===T.NotebookCellsChangeType.ModelChange?this.r(d.changes,!1,p.contentChanges):d.kind===T.NotebookCellsChangeType.Move?this.s(d.index,d.length,d.newIdx,p.contentChanges):d.kind===T.NotebookCellsChangeType.Output?(this.t(d.index,d.outputs),a.push({cell:this.b[d.index].apiCell,outputs:this.b[d.index].apiCell.outputs})):d.kind===T.NotebookCellsChangeType.OutputItem?(this.u(d.index,d.outputId,d.append,d.outputItems),a.push({cell:this.b[d.index].apiCell,outputs:this.b[d.index].apiCell.outputs})):d.kind===T.NotebookCellsChangeType.ChangeCellLanguage?(this.v(d.index,d.language),a.push({cell:this.b[d.index].apiCell,document:this.b[d.index].apiCell.document})):d.kind===T.NotebookCellsChangeType.ChangeCellContent?a.push({cell:this.b[d.index].apiCell,document:this.b[d.index].apiCell.document}):d.kind===T.NotebookCellsChangeType.ChangeCellMime?this.w(d.index,d.mime):d.kind===T.NotebookCellsChangeType.ChangeCellMetadata?(this.x(d.index,d.metadata),a.push({cell:this.b[d.index].apiCell,metadata:this.b[d.index].apiCell.metadata})):d.kind===T.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(d.index,d.internalMetadata),a.push({cell:this.b[d.index].apiCell,executionSummary:this.b[d.index].apiCell.executionSummary}));const f=new Map;for(let d=0;d<a.length;d++){const m=a[d],n=f.get(m.cell);if(n===void 0){const o=p.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...m});f.set(m.cell,o-1)}else p.cellChanges[n]={...p.cellChanges[n],...m}}return Object.freeze(p),Object.freeze(p.cellChanges),Object.freeze(p.contentChanges),p}n(E){return E=E|0,E<0?0:E>=this.b.length?this.b.length-1:E}o(E){let u=E.start|0,k=E.end|0;return u<0&&(u=0),k>this.b.length&&(k=this.b.length),E.with({start:u,end:k})}p(E){E=this.o(E);const u=[];for(let k=E.start;k<E.end;k++)u.push(this.b[k]);return u}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(E,u,k){if(this.j)return;const p=[],a=[],f=[];if(E.reverse().forEach(d=>{const n=d[2].map(i=>{const s=new $(this,this.l,i);return u||a.push($.asModelAddData(i)),s}),o=new N(d[0],d[1],[],n),t=this.b.splice(d[0],d[1],...n);for(const i of t)f.push(i.uri),o.deletedItems.push(i.apiCell);p.push(o)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:a,removedDocuments:f}),k)for(const d of p)k.push(d.asApiEvent())}s(E,u,k,p){const a=this.b.splice(E,u);this.b.splice(k,0,...a);const f=[new N(E,u,a.map(d=>d.apiCell),[]),new N(k,0,[],a)];for(const d of f)p.push(d.asApiEvent())}t(E,u){this.b[E].setOutputs(u)}u(E,u,k,p){this.b[E].setOutputItems(u,k,p)}v(E,u){const k=this.b[E];k.apiCell.document.languageId!==u&&this.m.$acceptModelLanguageChanged(k.uri,u)}w(E,u){const k=this.b[E];k.apiCell.mime=u}x(E,u){this.b[E].setMetadata(u)}y(E,u){this.b[E].setInternalMetadata(u)}getCellFromApiCell(E){return this.b.find(u=>u.apiCell===E)}getCellFromIndex(E){return this.b[E]}getCell(E){return this.b.find(u=>u.handle===E)}getCellIndex(E){return this.b.indexOf(E)}}e.$gpc=c}),define(Ee[359],ye([1,0,4,2,17,10,51]),function(ce,e,r,h,P,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vpc=void 0;class N{constructor(c,I,E,u={timeout:1500,errors:3}){this.b=c,this.c=I,this.d=E,this.f=u,this.a=new r.$oe}dispose(){}getOnWillSaveNotebookDocumentEvent(c){return(I,E,u)=>{const k=function(a){I.call(E,a)};return k.extension=c,this.a.event(k,void 0,u)}}async $participateInSave(c,I,E){const u=h.URI.revive(c),k=this.c.getNotebookDocument(u);if(!k)throw new Error("Unable to resolve notebook document");const p=[];if(await this.a.fireAsync({notebook:k.apiNotebook,reason:P.TextDocumentSaveReason.to(I)},E,async(f,d)=>{const m=Date.now(),n=await await Promise.resolve(f);Date.now()-m>this.f.timeout&&this.b.warn("onWillSaveNotebookDocument-listener from extension",d.extension.identifier),!E.isCancellationRequested&&n&&(n instanceof R.$DN?p.push(n):this.b.warn("onWillSaveNotebookDocument-listener from extension",d.extension.identifier,"ignored due to invalid data"))}),E.isCancellationRequested)return!1;if(p.length===0)return!0;const a={edits:[]};for(const f of p){const{edits:d}=P.WorkspaceEdit.from(f);a.edits=a.edits.concat(d)}return this.d.$tryApplyWorkspaceEdit(new T.$Pw(a))}}e.$vpc=N}),define(Ee[164],ye([1,0,14,17,10]),function(ce,e,r,h,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hpc=void 0,h=We(h),P=We(P);class R{static{this.apiEditorsToExtHost=new WeakMap}constructor(N,$,c,I,E,u){this.id=N,this.f=$,this.notebookData=c,this.a=[],this.b=[],this.d=!1,this.a=E,this.b=I,this.c=u}get apiEditor(){if(!this.e){const N=this;this.e={get notebook(){return N.notebookData.apiNotebook},get selection(){return N.a[0]},set selection($){this.selections=[$]},get selections(){return N.a},set selections($){if(!Array.isArray($)||!$.every(P.$VO.isNotebookRange))throw(0,r.$9)("selections");N.a=$,N.g($)},get visibleRanges(){return N.b},revealRange($,c){N.f.$tryRevealRange(N.id,h.NotebookRange.from($),c??P.NotebookEditorRevealType.Default)},get viewColumn(){return N.c}},R.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility(N){this.d=N}_acceptVisibleRanges(N){this.b=N}_acceptSelections(N){this.a=N}g(N){this.f.$trySetSelections(this.id,N.map(h.NotebookRange.from))}_acceptViewColumn(N){this.c=N}}e.$hpc=R}),define(Ee[360],ye([1,0,4,12,17]),function(ce,e,r,h,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xpc=void 0,P=We(P);let R=class{constructor(N,$){this.c=N,this.d=$,this.a=new r.$me,this.b=new r.$me,this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(N,$){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",N,$);const c=this.d.getEditorById(N);$.visibleRanges&&c._acceptVisibleRanges($.visibleRanges.ranges.map(P.NotebookRange.to)),$.selections&&c._acceptSelections($.selections.selections.map(P.NotebookRange.to)),$.visibleRanges&&this.b.fire({notebookEditor:c.apiEditor,visibleRanges:c.apiEditor.visibleRanges}),$.selections&&this.a.fire(Object.freeze({notebookEditor:c.apiEditor,selections:c.apiEditor.selections}))}$acceptEditorViewColumns(N){for(const $ in N)this.d.getEditorById($)._acceptViewColumn(P.ViewColumn.to(N[$]))}};e.$xpc=R,e.$xpc=R=Je([Ge(0,h.$_j)],R)}),define(Ee[361],ye([1,0,4,6,164]),function(ce,e,r,h,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Apc=void 0;class R{constructor(N,$){this.c=$,this.a=new Map,this.b=N.getProxy(h.$rN.MainThreadNotebookRenderers)}$postRendererMessage(N,$,c){const I=this.c.getEditorById(N);this.a.get($)?.fire({editor:I.apiEditor,message:c})}createRendererMessaging(N,$){if(!N.contributes?.notebookRenderer?.some(I=>I.id===$))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${$})`);return{onDidReceiveMessage:(I,E,u)=>this.d($).event(I,E,u),postMessage:(I,E)=>{P.$hpc.apiEditorsToExtHost.has(I)&&([I,E]=[E,I]);const u=E&&P.$hpc.apiEditorsToExtHost.get(E);return this.b.$postMessage(u?.id,$,I)}}}d(N){let $=this.a.get(N);return $||($=new r.$me({onDidRemoveLastListener:()=>{$?.dispose(),this.a.delete(N)}}),this.a.set(N,$),$)}}e.$Apc=R}),define(Ee[362],ye([1,0,17,90,21,59,14]),function(ce,e,r,h,P,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Epc=void 0;class N{constructor(E){this.b=0,this.c=new Map,this.a=E}async withProgress(E,u,k){const p=this.b++,{title:a,location:f,cancellable:d}=u,m={label:E.displayName||E.name,id:E.identifier.value};return this.a.$startProgress(p,{location:r.ProgressLocation.from(f),title:a,source:m,cancellable:d},E.isUnderDevelopment?void 0:E.identifier.value).catch(T.$4),this.d(p,k,!!d)}d(E,u,k){let p;k&&(p=new P.$xe,this.c.set(E,p));const a=d=>{this.a.$progressEnd(d),this.c.delete(d),p?.dispose()};let f;try{f=u(new c(this.a,E),k&&p?p.token:P.CancellationToken.None)}catch(d){throw a(E),d}return f.then(d=>a(E),d=>a(E)),f}$acceptProgressCanceled(E){const u=this.c.get(E);u&&(u.cancel(),this.c.delete(E))}}e.$Epc=N;function $(I,E){return I.message=E.message,typeof E.increment=="number"&&(typeof I.increment=="number"?I.increment+=E.increment:I.increment=E.increment),I}class c extends h.$rw{constructor(E,u){super(k=>this.throttledReport(k)),this.c=E,this.d=u}throttledReport(E){this.c.$progressReport(this.d,E)}}Je([(0,R.$_h)(100,(I,E)=>$(I,E),()=>Object.create(null))],c.prototype,"throttledReport",null)}),define(Ee[363],ye([1,0,2,6,9,17]),function(ce,e,r,h,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fpc=void 0;class T{static{this.a=0}constructor($,c){this.d=c,this.c=new Map,this.b=$.getProxy(h.$rN.MainThreadQuickDiff)}$provideOriginalResource($,c,I){const E=r.URI.revive(c),u=this.c.get($);return u?(0,P.$xh)(()=>u.provideOriginalResource(E,I)).then(k=>k||null):Promise.resolve(null)}registerQuickDiffProvider($,c,I,E){const u=T.a++;return this.c.set(u,c),this.b.$registerQuickDiffProvider(u,R.DocumentSelector.from($,this.d),I,E),{dispose:()=>{this.b.$unregisterQuickDiffProvider(u),this.c.delete(u)}}}}e.$Fpc=T});var zt=this&&this.__importDefault||function(ce){return ce&&ce.__esModule?ce:{default:ce}};define(Ee[364],ye([1,0,21,4,3,6,2,10,14,19,44,50,26,17]),function(ce,e,r,h,P,R,T,N,$,c,I,E,u,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gpc=p,I=zt(I);function p(a,f,d){const m=a.getProxy(R.$rN.MainThreadQuickOpen);class n{constructor(D,y){this.e=new Map,this.f=0,this.a=D,this.b=y}showQuickPick(D,y,C,A=r.CancellationToken.None){this.c=void 0;const b=Promise.resolve(y),v=++this.f,L=m.$show(v,{title:C?.title,placeHolder:C?.placeHolder,matchOnDescription:C?.matchOnDescription,matchOnDetail:C?.matchOnDetail,ignoreFocusLost:C?.ignoreFocusOut,canPickMany:C?.canPickMany},A),O={},M=L.then(()=>O);return Promise.race([M,b]).then(j=>{if(j===O)return;const z=(0,u.$3G)(D,"quickPickItemTooltip");return b.then(F=>{const B=[];for(let _=0;_<F.length;_++){const re=F[_];if(typeof re=="string")B.push({label:re,handle:_});else if(re.kind===N.QuickPickItemKind.Separator)B.push({type:"separator",label:re.label});else{re.tooltip&&!z&&console.warn(`Extension '${D.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${D.identifier.value}`);const U=re.iconPath?g(re.iconPath):void 0;B.push({label:re.label,iconPath:U?.iconPath,iconClass:U?.iconClass,description:re.description,detail:re.detail,picked:re.picked,alwaysShow:re.alwaysShow,tooltip:z?k.MarkdownString.fromStrict(re.tooltip):void 0,handle:_})}}return C&&typeof C.onDidSelectItem=="function"&&(this.c=_=>{C.onDidSelectItem(F[_])}),m.$setItems(v,B),L.then(_=>{if(typeof _=="number")return F[_];if(Array.isArray(_))return _.map(re=>F[re])})})}).then(void 0,j=>{if(!(0,$.$6)(j))return m.$setError(v,j),Promise.reject(j)})}$onItemSelected(D){this.c?.(D)}showInput(D,y=r.CancellationToken.None){return this.d=D?.validateInput,m.$input(D,typeof this.d=="function",y).then(void 0,C=>{if(!(0,$.$6)(C))return Promise.reject(C)})}async $validateInput(D){if(!this.d)return;const y=await this.d(D);if(!y||typeof y=="string")return y;let C;switch(y.severity){case N.InputBoxValidationSeverity.Info:C=I.default.Info;break;case N.InputBoxValidationSeverity.Warning:C=I.default.Warning;break;case N.InputBoxValidationSeverity.Error:C=I.default.Error;break;default:C=y.message?I.default.Error:I.default.Ignore;break}return{content:y.message,severity:C}}async showWorkspaceFolderPick(D,y=r.CancellationToken.None){const C=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[D]);if(!C)return;const A=await this.a.getWorkspaceFolders2();if(A)return A.find(b=>b.uri.toString()===C.uri.toString())}createQuickPick(D){const y=new l(D,()=>this.e.delete(y._id));return this.e.set(y._id,y),y}createInputBox(D){const y=new w(D,()=>this.e.delete(y._id));return this.e.set(y._id,y),y}$onDidChangeValue(D,y){this.e.get(D)?._fireDidChangeValue(y)}$onDidAccept(D){this.e.get(D)?._fireDidAccept()}$onDidChangeActive(D,y){const C=this.e.get(D);C instanceof l&&C._fireDidChangeActive(y)}$onDidChangeSelection(D,y){const C=this.e.get(D);C instanceof l&&C._fireDidChangeSelection(y)}$onDidTriggerButton(D,y){this.e.get(D)?._fireDidTriggerButton(y)}$onDidTriggerItemButton(D,y,C){const A=this.e.get(D);A instanceof l&&A._fireDidTriggerItemButton(y,C)}$onDidHide(D){this.e.get(D)?._fireDidHide()}}class o{static{this.a=1}constructor(D,y){this.x=D,this.y=y,this._id=l.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new h.$me,this.q=new h.$me,this.r=new h.$me,this.s=new h.$me,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(D){this.b=D,this.z({title:D})}get step(){return this.c}set step(D){this.c=D,this.z({step:D})}get totalSteps(){return this.d}set totalSteps(D){this.d=D,this.z({totalSteps:D})}get enabled(){return this.g}set enabled(D){this.g=D,this.z({enabled:D})}get busy(){return this.j}set busy(D){this.j=D,this.z({busy:D})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(D){this.k=D,this.z({ignoreFocusOut:D})}get value(){return this.l}set value(D){this.l=D,this.z({value:D})}get placeholder(){return this.m}set placeholder(D){this.m=D,this.z({placeholder:D})}get buttons(){return this.n}set buttons(D){this.n=D.slice(),this.o.clear(),D.forEach((y,C)=>{const A=y===N.$SO.Back?-1:C;this.o.set(A,y)}),this.z({buttons:D.map((y,C)=>({...g(y.iconPath),tooltip:y.tooltip,handle:y===N.$SO.Back?-1:C}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(D){this.l=D,this.q.fire(D)}_fireDidTriggerButton(D){const y=this.o.get(D);y&&this.r.fire(y)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,P.$Rc)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),m.$dispose(this._id))}z(D){if(!this.v){for(const y of Object.keys(D)){const C=D[y];this.u[y]=C===void 0?null:C}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){m.$createOrUpdate(this.u),this.u={id:this._id}}}function t(S){if(S instanceof N.$qO)return{id:S.id};const D=s(S),y=i(S);return{dark:typeof D=="string"?T.URI.file(D):D,light:typeof y=="string"?T.URI.file(y):y}}function i(S){return typeof S=="object"&&"light"in S?S.light:S}function s(S){return typeof S=="object"&&"dark"in S?S.dark:S}function g(S){const D=t(S);let y,C;return"id"in D?C=E.ThemeIcon.asClassName(D):y=D,{iconPath:y,iconClass:C}}class l extends o{constructor(D,y){super(D.identifier,y),this.O=D,this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new h.$me,this.L=[],this.M=new h.$me,this.N=new h.$me,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(D){this.B=D.slice(),this.C.clear(),this.D.clear(),D.forEach((A,b)=>{this.C.set(b,A),this.D.set(A,b)});const y=(0,u.$3G)(this.O,"quickPickItemTooltip"),C=[];for(let A=0;A<D.length;A++){const b=D[A];if(b.kind===N.QuickPickItemKind.Separator)C.push({type:"separator",label:b.label});else{b.tooltip&&!y&&console.warn(`Extension '${this.O.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.O.identifier.value}`);const v=b.iconPath?g(b.iconPath):void 0;C.push({handle:A,label:b.label,iconPath:v?.iconPath,iconClass:v?.iconClass,description:b.description,detail:b.detail,picked:b.picked,alwaysShow:b.alwaysShow,tooltip:y?k.MarkdownString.fromStrict(b.tooltip):void 0,buttons:b.buttons?.map((L,O)=>({...g(L.iconPath),tooltip:L.tooltip,handle:O}))})}}this.z({items:C})}get canSelectMany(){return this.E}set canSelectMany(D){this.E=D,this.z({canSelectMany:D})}get matchOnDescription(){return this.F}set matchOnDescription(D){this.F=D,this.z({matchOnDescription:D})}get matchOnDetail(){return this.G}set matchOnDetail(D){this.G=D,this.z({matchOnDetail:D})}get sortByLabel(){return this.H}set sortByLabel(D){this.H=D,this.z({sortByLabel:D})}get keepScrollPosition(){return this.I}set keepScrollPosition(D){this.I=D,this.z({keepScrollPosition:D})}get activeItems(){return this.J}set activeItems(D){this.J=D.filter(y=>this.D.has(y)),this.z({activeItems:this.J.map(y=>this.D.get(y))})}get selectedItems(){return this.L}set selectedItems(D){this.L=D.filter(y=>this.D.has(y)),this.z({selectedItems:this.L.map(y=>this.D.get(y))})}_fireDidChangeActive(D){const y=(0,c.$Jb)(D.map(C=>this.C.get(C)));this.J=y,this.K.fire(y)}_fireDidChangeSelection(D){const y=(0,c.$Jb)(D.map(C=>this.C.get(C)));this.L=y,this.M.fire(y)}_fireDidTriggerItemButton(D,y){const C=this.C.get(D);if(!C||!C.buttons||!C.buttons.length)return;const A=C.buttons[y];A&&this.N.fire({button:A,item:C})}}class w extends o{constructor(D,y){super(D.identifier,y),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(D){this.B=D,this.z({password:D})}get prompt(){return this.C}set prompt(D){this.C=D,this.z({prompt:D})}get valueSelection(){return this.D}set valueSelection(D){this.D=D,this.z({valueSelection:D})}get validationMessage(){return this.E}set validationMessage(D){this.E=D,D?typeof D=="string"?this.z({validationMessage:D,severity:I.default.Error}):this.z({validationMessage:D.message,severity:D.severity??I.default.Error}):this.z({validationMessage:void 0,severity:I.default.Ignore})}}return new n(f,d)}}),define(Ee[365],ye([1,0,2,4,59,3,9,6,19,140,12,24,41,50,17,26,15,11]),function(ce,e,r,h,P,R,T,N,$,c,I,E,u,k,p,a,f,d){"use strict";var m;Object.defineProperty(e,"__esModule",{value:!0}),e.$Ipc=e.$Hpc=void 0;function n(L){return L instanceof r.URI}function o(L,O){return L.scheme===f.Schemas.file&&O.scheme===f.Schemas.file&&d.$k?L.toString()===O.toString():L.toString().toLowerCase()===O.toString().toLowerCase()}function t(L){if(L)return typeof L.iconPath=="string"?r.URI.file(L.iconPath):r.URI.isUri(L.iconPath)||k.ThemeIcon.isThemeIcon(L.iconPath)?L.iconPath:void 0}function i(L){if(L.icon){if(r.URI.isUri(L.icon))return L.icon;if(k.ThemeIcon.isThemeIcon(L.icon))return L.icon;{const O=L.icon;return{light:O.light,dark:O.dark}}}else return}function s(L,O){if(!L.iconPath&&!O.iconPath)return 0;if(L.iconPath){if(!O.iconPath)return 1}else return-1;const M=typeof L.iconPath=="string"?L.iconPath:r.URI.isUri(L.iconPath)?L.iconPath.fsPath:L.iconPath.id,j=typeof O.iconPath=="string"?O.iconPath:r.URI.isUri(O.iconPath)?O.iconPath.fsPath:O.iconPath.id;return(0,c.$Dr)(M,j)}function g(L,O){let M=0;if(L.strikeThrough!==O.strikeThrough)return L.strikeThrough?1:-1;if(L.faded!==O.faded)return L.faded?1:-1;if(L.tooltip!==O.tooltip)return(L.tooltip||"").localeCompare(O.tooltip||"");if(M=s(L,O),M!==0)return M;if(L.light&&O.light)M=s(L.light,O.light);else{if(L.light)return 1;if(O.light)return-1}if(M!==0)return M;if(L.dark&&O.dark)M=s(L.dark,O.dark);else{if(L.dark)return 1;if(O.dark)return-1}return M}function l(L,O){if(L.command!==O.command)return L.command<O.command?-1:1;if(L.title!==O.title)return L.title<O.title?-1:1;if(L.tooltip!==O.tooltip){if(L.tooltip!==void 0&&O.tooltip!==void 0)return L.tooltip<O.tooltip?-1:1;if(L.tooltip!==void 0)return 1;if(O.tooltip!==void 0)return-1}if(L.arguments===O.arguments)return 0;if(L.arguments)if(O.arguments){if(L.arguments.length!==O.arguments.length)return L.arguments.length-O.arguments.length}else return 1;else return-1;for(let M=0;M<L.arguments.length;M++){const j=L.arguments[M],z=O.arguments[M];if(j!==z&&!(n(j)&&n(z)&&o(j,z)))return j<z?-1:1}return 0}function w(L,O){let M=(0,c.$Dr)(L.resourceUri.fsPath,O.resourceUri.fsPath,!0);if(M!==0)return M;if(L.command&&O.command)M=l(L.command,O.command);else{if(L.command)return 1;if(O.command)return-1}if(M!==0)return M;if(L.decorations&&O.decorations)M=g(L.decorations,O.decorations);else{if(L.decorations)return 1;if(O.decorations)return-1}if(L.multiFileDiffEditorModifiedUri&&O.multiFileDiffEditorModifiedUri)M=(0,c.$Dr)(L.multiFileDiffEditorModifiedUri.fsPath,O.multiFileDiffEditorModifiedUri.fsPath,!0);else{if(L.multiFileDiffEditorModifiedUri)return 1;if(O.multiFileDiffEditorModifiedUri)return-1}if(L.multiDiffEditorOriginalUri&&O.multiDiffEditorOriginalUri)M=(0,c.$Dr)(L.multiDiffEditorOriginalUri.fsPath,O.multiDiffEditorOriginalUri.fsPath,!0);else{if(L.multiDiffEditorOriginalUri)return 1;if(O.multiDiffEditorOriginalUri)return-1}return M}function S(L,O){for(let M=0;M<L.length;M++)if(L[M]!==O[M])return!1;return!0}function D(L,O){return L.command===O.command&&L.title===O.title&&L.tooltip===O.tooltip&&(L.arguments&&O.arguments?S(L.arguments,O.arguments):L.arguments===O.arguments)}function y(L,O){return(0,$.$wb)(L,O,D)}class C{#e;#t;get value(){return this.d}set value(O){O=O??"",this.#e.$setInputBoxValue(this.l,O),this.n(O)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(O){this.#e.$setInputBoxPlaceholder(this.l,O),this.f=O}get validateInput(){return(0,a.$4G)(this.k,"scmValidation"),this.g}set validateInput(O){if((0,a.$4G)(this.k,"scmValidation"),O&&typeof O!="function")throw new Error(`[${this.k.identifier.value}]: Invalid SCM input box validation function`);this.g=O,this.#e.$setValidationProviderIsEnabled(this.l,!!O)}get enabled(){return this.h}set enabled(O){O=!!O,this.h!==O&&(this.h=O,this.#e.$setInputBoxEnablement(this.l,O))}get visible(){return this.j}set visible(O){O=!!O,this.j!==O&&(this.j=O,this.#e.$setInputBoxVisibility(this.l,O))}get document(){return(0,a.$4G)(this.k,"scmTextDocument"),this.#t.getDocument(this.m)}constructor(O,M,j,z,F){this.k=O,this.l=z,this.m=F,this.d="",this.e=new h.$me,this.f="",this.h=!0,this.j=!0,this.#t=M,this.#e=j}showValidationMessage(O,M){(0,a.$4G)(this.k,"scmValidation"),this.#e.$showValidationMessage(this.l,O,M)}$onInputBoxValueChange(O){this.n(O)}n(O){this.d=O,this.e.fire(O)}}e.$Hpc=C;class A{static{this.d=0}get disposed(){return this.l}get id(){return this.u}get label(){return this.v}set label(O){this.v=O,this.q.$updateGroupLabel(this.t,this.handle,O)}get hideWhenEmpty(){return this.p}set hideWhenEmpty(O){this.p=O,this.q.$updateGroup(this.t,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(O){this.f=[...O],this.k.fire()}constructor(O,M,j,z,F,B,_){this.q=O,this.s=M,this.t=j,this.u=z,this.v=F,this.multiDiffEditorEnableViewChanges=B,this.w=_,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new h.$me,this.onDidUpdateResourceStates=this.k.event,this.l=!1,this.m=new h.$me,this.onDidDispose=this.m.event,this.n=[],this.o=[],this.p=void 0,this.handle=A.d++}getResourceState(O){return this.g.get(O)}$executeResourceCommand(O,M){const j=this.h.get(O);return j?(0,T.$xh)(()=>this.s.executeCommand(j.command,...j.arguments||[],M)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const O=[...this.f].sort(w),j=(0,$.$Fb)(this.o,O,w).map(B=>{const _=B.toInsert.map(re=>{const U=this.e++;this.g.set(U,re);const G=re.resourceUri;let Q;if(re.command)if(re.command.command==="vscode.open"||re.command.command==="vscode.diff"||re.command.command==="vscode.changes"){const X=new R.$Vc;Q=this.s.converter.toInternal(re.command,X),this.j.set(U,X)}else this.h.set(U,re.command);const ee=(0,a.$3G)(this.w,"scmMultiDiffEditor"),he=ee?re.multiDiffEditorOriginalUri:void 0,ne=ee?re.multiFileDiffEditorModifiedUri:void 0,De=t(re.decorations),$e=re.decorations&&t(re.decorations.light)||De,K=re.decorations&&t(re.decorations.dark)||De,W=[$e,K],se=re.decorations&&re.decorations.tooltip||"",oe=re.decorations&&!!re.decorations.strikeThrough,te=re.decorations&&!!re.decorations.faded,le=re.contextValue||"";return{rawResource:[U,G,W,se,oe,te,le,Q,he,ne],handle:U}});return{start:B.start,deleteCount:B.deleteCount,toInsert:_}}),z=j.map(({start:B,deleteCount:_,toInsert:re})=>[B,_,re.map(U=>U.rawResource)]),F=j.reverse();for(const{start:B,deleteCount:_,toInsert:re}of F){const U=re.map(Q=>Q.handle),G=this.n.splice(B,_,...U);for(const Q of G)this.g.delete(Q),this.h.delete(Q),this.j.get(Q)?.dispose(),this.j.delete(Q)}return this.o=O,z}dispose(){this.l=!0,this.m.fire()}}class b{static{this.d=0}#e;get id(){return this.A}get label(){return this.B}get rootUri(){return this.C}get inputBox(){return this.f}get count(){return this.g}set count(O){this.g!==O&&(this.g=O,this.#e.$updateSourceControl(this.w,{count:O}))}get quickDiffProvider(){return this.h}set quickDiffProvider(O){this.h=O;let M;(0,a.$3G)(this.x,"quickDiffProvider")&&(M=O?.label),this.#e.$updateSourceControl(this.w,{hasQuickDiffProvider:!!O,quickDiffLabel:M})}get historyProvider(){return(0,a.$4G)(this.x,"scmHistoryProvider"),this.j}set historyProvider(O){(0,a.$4G)(this.x,"scmHistoryProvider"),this.j=O,this.k.value=new R.$Vc,this.#e.$updateSourceControl(this.w,{hasHistoryProvider:!!O}),O&&this.k.value.add(O.onDidChangeCurrentHistoryItemGroup(()=>{this.l=O?.currentHistoryItemGroup,this.#e.$onDidChangeHistoryProviderCurrentHistoryItemGroup(this.w,this.l)}))}get commitTemplate(){return this.m}set commitTemplate(O){O!==this.m&&(this.m=O,this.#e.$updateSourceControl(this.w,{commitTemplate:O}))}get acceptInputCommand(){return this.o}set acceptInputCommand(O){this.n.value=new R.$Vc,this.o=O;const M=this.y.converter.toInternal(O,this.n.value);this.#e.$updateSourceControl(this.w,{acceptInputCommand:M})}get actionButton(){return(0,a.$4G)(this.x,"scmActionButton"),this.q}set actionButton(O){(0,a.$4G)(this.x,"scmActionButton"),this.p.value=new R.$Vc,this.q=O;const M=O!==void 0?{command:this.y.converter.toInternal(O.command,this.p.value),secondaryCommands:O.secondaryCommands?.map(j=>j.map(z=>this.y.converter.toInternal(z,this.p.value))),description:O.description,enabled:O.enabled}:void 0;this.#e.$updateSourceControl(this.w,{actionButton:M??null})}get statusBarCommands(){return this.t}set statusBarCommands(O){if(this.z.info("ExtHostSourceControl#statusBarCommands",(O??[]).map(j=>j.command).join(", ")),this.t&&O&&y(this.t,O)){this.z.info("ExtHostSourceControl#statusBarCommands are equal");return}this.s.value=new R.$Vc,this.t=O;const M=(O||[]).map(j=>this.y.converter.toInternal(j,this.s.value));this.#e.$updateSourceControl(this.w,{statusBarCommands:M})}get selected(){return this.u}constructor(O,M,j,z,F,B,_,re){this.x=O,this.y=z,this.z=F,this.A=B,this.B=_,this.C=re,this.e=new Map,this.g=void 0,this.h=void 0,this.k=new R.$Xc,this.m=void 0,this.n=new R.$Xc,this.o=void 0,this.p=new R.$Xc,this.s=new R.$Xc,this.t=void 0,this.u=!1,this.v=new h.$me,this.onDidChangeSelection=this.v.event,this.w=b.d++,this.D=new Map,this.E=new Set,this.#e=j;const U=r.URI.from({scheme:f.Schemas.vscodeSourceControl,path:`${B}/scm${this.w}/input`,query:re?`rootUri=${encodeURIComponent(re.toString())}`:void 0});this.f=new C(O,M,this.#e,this.w,U),this.#e.$registerSourceControl(this.w,B,_,re,U)}createResourceGroup(O,M,j){const z=(0,a.$3G)(this.x,"scmMultiDiffEditor")&&j?.multiDiffEditorEnableViewChanges===!0,F=new A(this.#e,this.y,this.w,O,M,z,this.x),B=h.Event.once(F.onDidDispose)(()=>this.D.delete(F));return this.D.set(F,B),this.eventuallyAddResourceGroups(),F}eventuallyAddResourceGroups(){const O=[],M=[];for(const[j,z]of this.D){z.dispose();const F=j.onDidUpdateResourceStates(()=>{this.E.add(j),this.eventuallyUpdateResourceStates()});h.Event.once(j.onDidDispose)(()=>{this.E.delete(j),F.dispose(),this.e.delete(j.handle),this.#e.$unregisterGroup(this.w,j.handle)}),O.push([j.handle,j.id,j.label,j.features,j.multiDiffEditorEnableViewChanges]);const B=j._takeResourceStateSnapshot();B.length>0&&M.push([j.handle,B]),this.e.set(j.handle,j)}this.#e.$registerGroups(this.w,O,M),this.D.clear()}eventuallyUpdateResourceStates(){const O=[];this.E.forEach(M=>{const j=M._takeResourceStateSnapshot();j.length!==0&&O.push([M.handle,j])}),O.length>0&&this.#e.$spliceResourceStates(this.w,O),this.E.clear()}getResourceGroup(O){return this.e.get(O)}setSelectionState(O){this.u=O,this.v.fire(O)}dispose(){this.n.dispose(),this.p.dispose(),this.s.dispose(),this.e.forEach(O=>O.dispose()),this.#e.$unregisterSourceControl(this.w)}}Je([(0,P.$$h)(100)],b.prototype,"eventuallyAddResourceGroups",null),Je([(0,P.$$h)(100)],b.prototype,"eventuallyUpdateResourceStates",null);let v=class{static{m=this}static{this.d=0}get onDidChangeActiveProvider(){return this.j.event}constructor(O,M,j,z){this.l=M,this.m=j,this.n=z,this.g=new Map,this.h=new E.$sn,this.j=new h.$me,this.e=O.getProxy(N.$rN.MainThreadSCM),this.f=O.getProxy(N.$rN.MainThreadTelemetry),M.registerArgumentProcessor({processArgument:F=>{if(F&&F.$mid===u.MarshalledId.ScmResource){const B=this.g.get(F.sourceControlHandle);if(!B)return F;const _=B.getResourceGroup(F.groupHandle);return _?_.getResourceState(F.handle):F}else if(F&&F.$mid===u.MarshalledId.ScmResourceGroup){const B=this.g.get(F.sourceControlHandle);return B?B.getResourceGroup(F.groupHandle):F}else if(F&&F.$mid===u.MarshalledId.ScmProvider){const B=this.g.get(F.handle);return B||F}return F}})}createSourceControl(O,M,j,z){this.n.trace("ExtHostSCM#createSourceControl",O.identifier.value,M,j,z),this.f.$publicLog2("api/scm/createSourceControl",{extensionId:O.identifier.value});const F=m.d++,B=new b(O,this.m,this.e,this.l,this.n,M,j,z);this.g.set(F,B);const _=this.h.get(O.identifier)||[];return _.push(B),this.h.set(O.identifier,_),B}getLastInputBox(O){this.n.trace("ExtHostSCM#getLastInputBox",O.identifier.value);const M=this.h.get(O.identifier),j=M&&M[M.length-1];return j&&j.inputBox}$provideOriginalResource(O,M,j){const z=r.URI.revive(M);this.n.trace("ExtHostSCM#$provideOriginalResource",O,z.toString());const F=this.g.get(O);return!F||!F.quickDiffProvider||!F.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,T.$xh)(()=>F.quickDiffProvider.provideOriginalResource(z,j)).then(B=>B||null)}$onInputBoxValueChange(O,M){this.n.trace("ExtHostSCM#$onInputBoxValueChange",O);const j=this.g.get(O);return j&&j.inputBox.$onInputBoxValueChange(M),Promise.resolve(void 0)}$executeResourceCommand(O,M,j,z){this.n.trace("ExtHostSCM#$executeResourceCommand",O,M,j);const F=this.g.get(O);if(!F)return Promise.resolve(void 0);const B=F.getResourceGroup(M);return B?B.$executeResourceCommand(j,z):Promise.resolve(void 0)}$validateInput(O,M,j){this.n.trace("ExtHostSCM#$validateInput",O);const z=this.g.get(O);return!z||!z.inputBox.validateInput?Promise.resolve(void 0):(0,T.$xh)(()=>z.inputBox.validateInput(M,j)).then(F=>{if(!F)return Promise.resolve(void 0);const B=p.MarkdownString.fromStrict(F.message);return B?Promise.resolve([B,F.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(O){return this.n.trace("ExtHostSCM#$setSelectedSourceControl",O),O!==void 0&&this.g.get(O)?.setSelectionState(!0),this.k!==void 0&&this.g.get(this.k)?.setSelectionState(!1),this.k=O,Promise.resolve(void 0)}async $resolveHistoryItemGroupCommonAncestor(O,M,j,z){return await this.g.get(O)?.historyProvider?.resolveHistoryItemGroupCommonAncestor(M,j,z)??void 0}async $provideHistoryItems(O,M,j,z){return(await this.g.get(O)?.historyProvider?.provideHistoryItems(M,j,z))?.map(_=>({..._,icon:i(_)}))??void 0}async $provideHistoryItemSummary(O,M,j,z){const F=this.g.get(O)?.historyProvider;if(typeof F?.provideHistoryItemSummary!="function")return;const B=await F.provideHistoryItemSummary(M,j,z);return B?{...B,icon:i(B)}:void 0}async $provideHistoryItemChanges(O,M,j,z){return await this.g.get(O)?.historyProvider?.provideHistoryItemChanges(M,j,z)??void 0}};e.$Ipc=v,e.$Ipc=v=m=Je([Ge(3,I.$_j)],v)}),define(Ee[366],ye([1,0,6,17,2]),function(ce,e,r,h,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jpc=void 0;class R{static{this.a=0}constructor(N,$){this.d=$,this.c=new Map,this.b=N.getProxy(r.$rN.MainThreadShare)}async $provideShare(N,$,c){return await this.c.get(N)?.provideShare({selection:h.Range.to($.selection),resourceUri:P.URI.revive($.resourceUri)},c)??void 0}registerShareProvider(N,$){const c=R.a++;return this.c.set(c,$),this.b.$registerShareProvider(c,h.DocumentSelector.from(N,this.d),$.id,$.label,$.priority),{dispose:()=>{this.b.$unregisterShareProvider(c),this.c.delete(c)}}}}e.$Jpc=R}),define(Ee[367],ye([1,0,10,6,239,3,17,18]),function(ce,e,r,h,P,R,T,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mpc=e.$Lpc=void 0;class ${static{this.a=0}static{this.b=new Map([["statusBarItem.errorBackground",new r.$rO("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new r.$rO("statusBarItem.warningForeground")]])}#e;#t;constructor(u,k,p,a,f,d=r.StatusBarAlignment.Left,m){if(this.i=!1,this.k="",this.q=new R.$Vc,this.#e=u,this.#t=k,f&&a){this.c=(0,r.$6N)(a.identifier,f);const n=p.get(this.c);n&&(d=n.alignLeft?r.StatusBarAlignment.Left:r.StatusBarAlignment.Right,m=n.priority,this.j=!0,this.name=n.name,this.text=n.text,this.tooltip=n.tooltip,this.command=n.command,this.accessibilityInformation=n.accessibilityInformation)}else this.c=String($.a++);this.e=a,this.f=f,this.g=d,this.h=this.u(m)}u(u){if((0,N.$jg)(u))return u===Number.POSITIVE_INFINITY?Number.MAX_VALUE:u===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:u}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.r?.fromApi}get accessibilityInformation(){return this.t}set text(u){this.k=u,this.v()}set name(u){this.m=u,this.v()}set tooltip(u){this.l=u,this.v()}set color(u){this.n=u,this.v()}set backgroundColor(u){u&&!$.b.has(u.id)&&(u=void 0),this.o=u,this.v()}set command(u){this.r?.fromApi!==u&&(this.p&&this.q.add(this.p),this.p=new R.$Vc,typeof u=="string"?this.r={fromApi:u,internal:this.#t.toInternal({title:"",command:u},this.p)}:u?this.r={fromApi:u,internal:this.#t.toInternal(u,this.p)}:this.r=void 0,this.v())}set accessibilityInformation(u){this.t=u,this.v()}show(){this.j=!0,this.v()}hide(){clearTimeout(this.s),this.j=!1,this.#e.$disposeEntry(this.c)}v(){this.i||!this.j||(clearTimeout(this.s),this.s=setTimeout(()=>{this.s=void 0;let u;this.e?this.f?u=`${this.e.identifier.value}.${this.f}`:u=this.e.identifier.value:u=this.f;let k;this.m?k=this.m:k=(0,P.localize)(0,null,this.e.displayName||this.e.name);let p=this.n;this.o&&(p=$.b.get(this.o.id));const a=T.MarkdownString.fromStrict(this.l);this.#e.$setEntry(this.c,u,this.e?.identifier.value,k,this.k,a,this.r?.internal,p,this.o,this.g===r.StatusBarAlignment.Left,this.h,this.t),this.q.clear()},0))}dispose(){this.hide(),this.i=!0}}e.$Lpc=$;class c{constructor(u){this.b=[],this.a=u.createStatusBarEntry(void 0,"status.extensionMessage",r.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,P.localize)(1,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(u){const k={message:u};return this.b.unshift(k),this.c(),new r.$tN(()=>{const p=this.b.indexOf(k);p>=0&&(this.b.splice(p,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class I{constructor(u,k){this.e=new Map,this.a=u.getProxy(h.$rN.MainThreadStatusBar),this.b=k,this.c=new c(this)}$acceptStaticEntries(u){for(const k of u)this.e.set(k.entryId,k)}createStatusBarEntry(u,k,p,a){return new $(this.a,this.b,this.e,u,k,p,a)}setStatusBarMessage(u,k){const p=this.c.setMessage(u);let a;return typeof k=="number"?a=setTimeout(()=>p.dispose(),k):typeof k<"u"&&k.then(()=>p.dispose(),()=>p.dispose()),new r.$tN(()=>{p.dispose(),clearTimeout(a)})}}e.$Mpc=I}),define(Ee[165],ye([1,0,31,154,74,121,75,17,2]),function(ce,e,r,h,P,R,T,N,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aQ=e.$_P=e.$$P=e.$0P=void 0,r=We(r),N=We(N);const c=(n,o,t,i)=>{let s=o;return{enumerable:!0,configurable:!1,get(){return s},set(g){if(!t(s,g)){const l=s;s=g,n.listener?.(i(g,l))}}}},I=(n,o)=>n===o,E={range:(n,o)=>n===o?!0:!n||!o?!1:n.isEqual(o),label:I,description:I,sortText:I,busy:I,error:I,canResolveChildren:I,tags:(n,o)=>!(n.length!==o.length||n.some(t=>!o.find(i=>t.id===i.id)))},u=n=>o=>({op:R.TestItemEventOp.SetProp,update:n(o)}),k=(n,o)=>({range:(()=>{let t;const i=u(s=>({range:r.$Ht.lift(N.Range.from(s))}));return{enumerable:!0,configurable:!1,get(){return t},set(s){n.listener?.({op:R.TestItemEventOp.DocumentSynced}),E.range(t,s)||(t=s,n.listener?.(i(s)))}}})(),label:c(n,o,E.label,u(t=>({label:t}))),description:c(n,void 0,E.description,u(t=>({description:t}))),sortText:c(n,void 0,E.sortText,u(t=>({sortText:t}))),canResolveChildren:c(n,!1,E.canResolveChildren,t=>({op:R.TestItemEventOp.UpdateCanResolveChildren,state:t})),busy:c(n,!1,E.busy,u(t=>({busy:t}))),error:c(n,void 0,E.error,u(t=>({error:N.MarkdownString.fromStrict(t)||null}))),tags:c(n,[],E.tags,(t,i)=>({op:R.TestItemEventOp.SetTags,new:t.map(N.TestTag.from),old:i.map(N.TestTag.from)}))}),p=n=>{const o=P.$QI.fromString(n.extId),t=new f(o.controllerId,o.localId,n.label,$.URI.revive(n.uri)||void 0);return t.range=N.Range.to(n.range||void 0),t.description=n.description||void 0,t.sortText=n.sortText||void 0,t.tags=n.tags.map(i=>N.TestTag.to({id:(0,T.$WI)(i).tagId})),t},a=n=>{let o;for(const t of n.tests){const i=p(t.item);(0,h.$TP)(i).parent=o,o=i}return o};e.$0P=a;class f{constructor(o,t,i,s){if(t.includes(P.TestIdPathParts.Delimiter))throw new Error(`Test IDs may not include the ${JSON.stringify(t)} symbol`);const g=(0,h.$SP)(this,o);Object.defineProperties(this,{id:{value:t,enumerable:!0,writable:!1},uri:{value:s,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return g.parent instanceof d?void 0:g.parent}},children:{value:(0,R.$RP)(g,h.$TP,f),enumerable:!0,writable:!1},...k(g,i)})}}e.$$P=f;class d extends f{constructor(o,t){super(o,o,t,void 0),this._isRoot=!0}}e.$_P=d;class m extends R.$NP{constructor(o,t,i){super({controllerId:o,getDocumentVersion:s=>s&&i.getDocument(s)?.version,getApiFor:h.$TP,getChildren:s=>s.children,root:new d(o,t),toITestItem:N.TestItem.from})}}e.$aQ=m}),define(Ee[35],ye([1,0,18,10,17,25,6,19,12,57,31,53,2,3,5,20,165,22,51,55,43,92,95,32]),function(ce,e,r,h,P,R,T,N,$,c,I,E,u,k,p,a,f,d,m,n,o,t,i,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lQ=e.$kQ=e.$jQ=e.$iQ=e.$hQ=e.$gQ=void 0,h=We(h),P=We(P);let g=class{#e;#t;#i;constructor(C,A,b){this.b=new Map,this.c=new Map,this.#e=C.getProxy(T.$rN.MainThreadCommands),this.d=A,this.#i=b,this.#t=C.getProxy(T.$rN.MainThreadTelemetry),this.converter=new l(this,v=>{const L=this.c.get(v);return L?.result===S.Void?L:void 0},A),this.f=[{processArgument(v){return(0,c.$ci)(v)}},{processArgument(v){return(0,R.$do)(v,function(L){if(I.$Ht.isIRange(L))return P.Range.to(L);if(E.$Gt.isIPosition(L))return P.Position.to(L);if(I.$Ht.isIRange(L.range)&&u.URI.isUri(L.uri))return P.location.to(L);if(L instanceof d.$Oe)return L.buffer.buffer;if(!Array.isArray(L))return L})}}]}registerArgumentProcessor(C){this.f.push(C)}registerApiCommand(C){const A=this.registerCommand(!1,C.id,async(...b)=>{const v=C.args.map((O,M)=>{if(!O.validate(b[M]))throw new Error(`Invalid argument '${O.name}' when running '${C.id}', received: ${typeof b[M]=="object"?JSON.stringify(b[M],null,"	"):b[M]} `);return O.convert(b[M])}),L=await this.executeCommand(C.internalId,...v);return C.result.convert(L,b,this.converter)},void 0,{description:C.description,args:C.args,returns:C.result.description});return this.c.set(C.id,C),new h.$tN(()=>{A.dispose(),this.c.delete(C.id)})}registerCommand(C,A,b,v,L,O){if(this.d.trace("ExtHostCommands#registerCommand",A),!A.trim().length)throw new Error("invalid id");if(this.b.has(A))throw new Error(`command '${A}' already exists`);return this.b.set(A,{callback:b,thisArg:v,metadata:L,extension:O}),C&&this.#e.$registerCommand(A),new h.$tN(()=>{this.b.delete(A)&&C&&this.#e.$unregisterCommand(A)})}executeCommand(C,...A){return this.d.trace("ExtHostCommands#executeCommand",C),this.g(C,A,!0)}async g(C,A,b){if(this.b.has(C))return this.#e.$fireCommandActivationEvent(C),this.h(C,A,!1);{let v=!1;const L=(0,R.$do)(A,function(O){if(O instanceof h.$uN)return P.Position.from(O);if(O instanceof h.$vN)return P.Range.from(O);if(O instanceof h.$FN)return P.location.from(O);if(h.$VO.isNotebookRange(O))return P.NotebookRange.from(O);if(O instanceof ArrayBuffer)return v=!0,d.$Oe.wrap(new Uint8Array(O));if(O instanceof Uint8Array)return v=!0,d.$Oe.wrap(O);if(O instanceof d.$Oe)return v=!0,O;if(!Array.isArray(O))return O});try{const O=await this.#e.$executeCommand(C,v?new m.$Pw(L):L,b);return(0,c.$ci)(O)}catch(O){if(O instanceof Error&&O.message==="$executeCommand:retry")return this.g(C,A,!1);throw O}}}async h(C,A,b){const v=this.b.get(C);if(!v)throw new Error("Unknown command");const{callback:L,thisArg:O,metadata:M}=v;if(M?.args)for(let z=0;z<M.args.length;z++)try{(0,r.$wg)(A[z],M.args[z].constraint)}catch{throw new Error(`Running the contributed command: '${C}' failed. Illegal argument '${M.args[z].name}' - ${M.args[z].description}`)}const j=o.$ge.create();try{return await L.apply(O,A)}catch(z){if(C===this.converter.delegatingCommandId){const F=this.converter.getActualCommand(...A);F&&(C=F.command)}if(this.d.error(z,C,v.extension?.identifier),!b)throw z;if(v.extension?.identifier){const F=this.#i.onExtensionError(v.extension.identifier,z);this.d.trace("forwarded error to extension?",F,v.extension?.identifier)}throw new class extends Error{constructor(){super((0,n.$qj)(z)),this.id=C,this.source=v.extension?.displayName??v.extension?.name}}}finally{this.j(v,C,j.elapsed())}}j(C,A,b){C.extension&&this.#t.$publicLog2("Extension:ActionExecuted",{extensionId:C.extension.identifier.value,id:new t.$sp(A),duration:b})}$executeContributedCommand(C,...A){this.d.trace("ExtHostCommands#$executeContributedCommand",C);const b=this.b.get(C);return b?(A=A.map(v=>this.f.reduce((L,O)=>O.processArgument(L,b.extension?.identifier),v)),this.h(C,A,!0)):Promise.reject(new Error(`Contributed command '${C}' does not exist.`))}getCommands(C=!1){return this.d.trace("ExtHostCommands#getCommands",C),this.#e.$getCommands().then(A=>(C&&(A=A.filter(b=>b[0]!=="_")),A))}$getContributedCommandMetadata(){const C=Object.create(null);for(const[A,b]of this.b){const{metadata:v}=b;v&&(C[A]=v)}return Promise.resolve(C)}};e.$gQ=g,e.$gQ=g=Je([Ge(0,a.$XP),Ge(1,$.$_j),Ge(2,i.$fQ)],g),e.$hQ=(0,p.$Fi)("IExtHostCommands");class l{constructor(C,A,b){this.d=C,this.f=A,this.g=b,this.delegatingCommandId=`__vsc${(0,s.$2g)()}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(C,A){if(!C)return;const b={$ident:void 0,id:C.command,title:C.title,tooltip:C.tooltip};if(!C.command)return b;const v=this.f(C.command);if(v)b.id=v.internalId,b.arguments=v.args.map((L,O)=>L.convert(C.arguments&&C.arguments[O]));else if((0,N.$Nb)(C.arguments)){const L=`${C.command} /${++this.c}`;this.b.set(L,C),A.add((0,k.$Uc)(()=>{this.b.delete(L),this.g.trace("CommandsConverter#DISPOSE",L)})),b.$ident=L,b.id=this.delegatingCommandId,b.arguments=[L],this.g.trace("CommandsConverter#CREATE",C.command,L)}return b}fromInternal(C){return typeof C.$ident=="string"?this.b.get(C.$ident):{command:C.id,title:C.title,arguments:C.arguments}}getActualCommand(...C){return this.b.get(C[0])}h(...C){const A=this.getActualCommand(...C);return this.g.trace("CommandsConverter#EXECUTE",C[0],A?A.command:"MISSING"),A?this.d.executeCommand(A.command,...A.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${C[0]}`)}}e.$iQ=l;class w{static{this.Uri=new w("uri","Uri of a text document",C=>u.URI.isUri(C),C=>C)}static{this.Position=new w("position","A position in a text document",C=>h.$uN.isPosition(C),P.Position.from)}static{this.Range=new w("range","A range in a text document",C=>h.$vN.isRange(C),P.Range.from)}static{this.Selection=new w("selection","A selection in a text document",C=>h.$wN.isSelection(C),P.Selection.from)}static{this.Number=new w("number","",C=>typeof C=="number",C=>C)}static{this.String=new w("string","",C=>typeof C=="string",C=>C)}static{this.StringArray=w.Arr(w.String)}static Arr(C){return new w(`${C.name}_array`,`Array of ${C.name}, ${C.description}`,A=>Array.isArray(A)&&A.every(b=>C.validate(b)),A=>A.map(b=>C.convert(b)))}static{this.CallHierarchyItem=new w("item","A call hierarchy item",C=>C instanceof h.$RN,P.CallHierarchyItem.from)}static{this.TypeHierarchyItem=new w("item","A type hierarchy item",C=>C instanceof h.$dP,P.TypeHierarchyItem.from)}static{this.TestItem=new w("testItem","A VS Code TestItem",C=>C instanceof f.$$P,P.TestItem.from)}constructor(C,A,b,v){this.name=C,this.description=A,this.validate=b,this.convert=v}optional(){return new w(this.name,`(optional) ${this.description}`,C=>C==null||this.validate(C),C=>C===void 0?void 0:C===null?null:this.convert(C))}with(C,A){return new w(C??this.name,A??this.description,this.validate,this.convert)}}e.$jQ=w;class S{static{this.Void=new S("no result",C=>C)}constructor(C,A){this.description=C,this.convert=A}}e.$kQ=S;class D{constructor(C,A,b,v,L){this.id=C,this.internalId=A,this.description=b,this.args=v,this.result=L}}e.$lQ=D}),define(Ee[368],ye([1,0,19,15,2,88,143,36,35,17,10]),function(ce,e,r,h,P,R,T,N,$,c,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3nc=void 0,R=We(R),c=We(c),I=We(I);const E=[new $.$lQ("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[$.$jQ.Uri,$.$jQ.Position],new $.$kQ("A promise that resolves to an array of DocumentHighlight-instances.",k(c.DocumentHighlight.to))),new $.$lQ("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[$.$jQ.Uri],new $.$kQ("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(a,f)=>{if((0,r.$Mb)(a))return;class d extends I.$MN{static to(n){const o=new d(n.name,c.SymbolKind.to(n.kind),n.containerName||"",new I.$FN(f[0],c.Range.to(n.range)));return o.detail=n.detail,o.range=o.location.range,o.selectionRange=c.Range.to(n.selectionRange),o.children=n.children?n.children.map(d.to):[],o}}return a.map(d.to)})),new $.$lQ("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[$.$jQ.Uri,new $.$jQ("options","Formatting options",a=>!0,a=>a)],new $.$kQ("A promise that resolves to an array of TextEdits.",k(c.TextEdit.to))),new $.$lQ("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[$.$jQ.Uri,$.$jQ.Range,new $.$jQ("options","Formatting options",a=>!0,a=>a)],new $.$kQ("A promise that resolves to an array of TextEdits.",k(c.TextEdit.to))),new $.$lQ("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[$.$jQ.Uri,$.$jQ.Position,new $.$jQ("ch","Trigger character",a=>typeof a=="string",a=>a),new $.$jQ("options","Formatting options",a=>!0,a=>a)],new $.$kQ("A promise that resolves to an array of TextEdits.",k(c.TextEdit.to))),new $.$lQ("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[$.$jQ.Uri,$.$jQ.Position],new $.$kQ("A promise that resolves to an array of Location or LocationLink instances.",p)),new $.$lQ("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[$.$jQ.Uri,$.$jQ.Position],new $.$kQ("A promise that resolves to an array of Location or LocationLink instances.",p)),new $.$lQ("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[$.$jQ.Uri,$.$jQ.Position],new $.$kQ("A promise that resolves to an array of Location or LocationLink instances.",p)),new $.$lQ("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[$.$jQ.Uri,$.$jQ.Position],new $.$kQ("A promise that resolves to an array of Location or LocationLink instances.",p)),new $.$lQ("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[$.$jQ.Uri,$.$jQ.Position],new $.$kQ("A promise that resolves to an array of Location-instances.",k(c.location.to))),new $.$lQ("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[$.$jQ.Uri,$.$jQ.Position],new $.$kQ("A promise that resolves to an array of Hover-instances.",k(c.Hover.to))),new $.$lQ("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[$.$jQ.Uri,new $.$jQ("position","A position in a text document",a=>Array.isArray(a)&&a.every(f=>I.$uN.isPosition(f)),a=>a.map(c.Position.from))],new $.$kQ("A promise that resolves to an array of ranges.",a=>a.map(f=>{let d;for(const m of f.reverse())d=new I.$QN(c.Range.to(m),d);return d}))),new $.$lQ("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[$.$jQ.String.with("query","Search string")],new $.$kQ("A promise that resolves to an array of SymbolInformation-instances.",a=>a.map(c.WorkspaceSymbol.to))),new $.$lQ("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[$.$jQ.Uri,$.$jQ.Position],new $.$kQ("A promise that resolves to an array of CallHierarchyItem-instances",a=>a.map(c.CallHierarchyItem.to))),new $.$lQ("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[$.$jQ.CallHierarchyItem],new $.$kQ("A promise that resolves to an array of CallHierarchyIncomingCall-instances",a=>a.map(c.CallHierarchyIncomingCall.to))),new $.$lQ("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[$.$jQ.CallHierarchyItem],new $.$kQ("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",a=>a.map(c.CallHierarchyOutgoingCall.to))),new $.$lQ("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[$.$jQ.Uri,$.$jQ.Position],new $.$kQ("A promise that resolves to a range and placeholder text.",a=>{if(a)return{range:c.Range.to(a.range),placeholder:a.text}})),new $.$lQ("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[$.$jQ.Uri,$.$jQ.Position,$.$jQ.String.with("newName","The new symbol name")],new $.$kQ("A promise that resolves to a WorkspaceEdit.",a=>{if(a){if(a.rejectReason)throw new Error(a.rejectReason);return c.WorkspaceEdit.to(a)}})),new $.$lQ("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[$.$jQ.Uri,$.$jQ.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new $.$kQ("A promise that resolves to an array of DocumentLink-instances.",a=>a.map(c.DocumentLink.to))),new $.$lQ("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[$.$jQ.Uri],new $.$kQ("A promise that resolves to SemanticTokensLegend.",a=>{if(a)return new I.$MO(a.tokenTypes,a.tokenModifiers)})),new $.$lQ("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[$.$jQ.Uri],new $.$kQ("A promise that resolves to SemanticTokens.",a=>{if(!a)return;const f=(0,T.$odb)(a);if(f.type==="full")return new I.$OO(f.data,void 0)})),new $.$lQ("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[$.$jQ.Uri,$.$jQ.Range.optional()],new $.$kQ("A promise that resolves to SemanticTokensLegend.",a=>{if(a)return new I.$MO(a.tokenTypes,a.tokenModifiers)})),new $.$lQ("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[$.$jQ.Uri,$.$jQ.Range],new $.$kQ("A promise that resolves to SemanticTokens.",a=>{if(!a)return;const f=(0,T.$odb)(a);if(f.type==="full")return new I.$OO(f.data,void 0)})),new $.$lQ("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[$.$jQ.Uri,$.$jQ.Position,$.$jQ.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),$.$jQ.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new $.$kQ("A promise that resolves to a CompletionList-instance.",(a,f,d)=>{if(!a)return new I.$3N([]);const m=a.suggestions.map(n=>c.CompletionItem.to(n,d));return new I.$3N(m,a.incomplete)})),new $.$lQ("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[$.$jQ.Uri,$.$jQ.Position,$.$jQ.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new $.$kQ("A promise that resolves to SignatureHelp.",a=>{if(a)return c.SignatureHelp.to(a)})),new $.$lQ("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[$.$jQ.Uri,$.$jQ.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new $.$kQ("A promise that resolves to an array of CodeLens-instances.",(a,f,d)=>k(m=>new I.$UN(c.Range.to(m.range),m.command&&d.fromInternal(m.command)))(a))),new $.$lQ("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[$.$jQ.Uri,new $.$jQ("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",a=>I.$vN.isRange(a),a=>I.$wN.isSelection(a)?c.Selection.from(a):c.Range.from(a)),$.$jQ.String.with("kind","Code action kind to return code actions for").optional(),$.$jQ.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new $.$kQ("A promise that resolves to an array of Command-instances.",(a,f,d)=>k(m=>{if(m._isSynthetic){if(!m.command)throw new Error("Synthetic code actions must have a command");return d.fromInternal(m.command)}else{const n=new I.$ON(m.title,m.kind?new I.$PN(m.kind):void 0);return m.edit&&(n.edit=c.WorkspaceEdit.to(m.edit)),m.command&&(n.command=d.fromInternal(m.command)),n.isPreferred=m.isPreferred,n}})(a))),new $.$lQ("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[$.$jQ.Uri],new $.$kQ("A promise that resolves to an array of ColorInformation objects.",a=>a?a.map(f=>new I.$9N(c.Range.to(f.range),c.Color.to(f.color))):[])),new $.$lQ("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new $.$jQ("color","The color to show and insert",a=>a instanceof I.$8N,c.Color.from),new $.$jQ("context","Context object with uri and range",a=>!0,a=>({uri:a.uri,range:c.Range.from(a.range)}))],new $.$kQ("A promise that resolves to an array of ColorPresentation objects.",a=>a?a.map(c.ColorPresentation.to):[])),new $.$lQ("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[$.$jQ.Uri,$.$jQ.Range],new $.$kQ("A promise that resolves to an array of Inlay objects",(a,f,d)=>a.map(c.InlayHint.to.bind(void 0,d)))),new $.$lQ("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[$.$jQ.Uri],new $.$kQ("A promise that resolves to an array of FoldingRange objects",(a,f)=>{if(a)return a.map(c.FoldingRange.to)})),new $.$lQ("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new $.$kQ("A promise that resolves to an array of NotebookContentProvider static info objects.",k(a=>({viewType:a.viewType,displayName:a.displayName,options:{transientOutputs:a.options.transientOutputs,transientCellMetadata:a.options.transientCellMetadata,transientDocumentMetadata:a.options.transientDocumentMetadata},filenamePattern:a.filenamePattern.map(f=>c.NotebookExclusiveDocumentPattern.to(f))})))),new $.$lQ("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[$.$jQ.Uri,$.$jQ.Range,new $.$jQ("context","An InlineValueContext",a=>a&&typeof a.frameId=="number"&&a.stoppedLocation instanceof I.$vN,a=>c.InlineValueContext.from(a))],new $.$kQ("A promise that resolves to an array of InlineValue objects",a=>a.map(c.InlineValue.to))),new $.$lQ("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new $.$jQ("uriOrString","Uri-instance or string (only http/https)",a=>P.URI.isUri(a)||typeof a=="string"&&(0,h.$Pg)(a,h.Schemas.http,h.Schemas.https),a=>a),new $.$jQ("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",a=>a===void 0||typeof a=="number"||typeof a=="object",a=>a&&(typeof a=="number"?[c.ViewColumn.from(a),void 0]:[c.ViewColumn.from(a.viewColumn),c.TextEditorOpenOptions.from(a)])).optional(),$.$jQ.String.with("label","").optional()],$.$kQ.Void),new $.$lQ("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[$.$jQ.Uri.with("resource","Resource to open"),$.$jQ.String.with("viewId","Custom editor view id. This should be the viewType string for custom editors or the notebookType string for notebooks. Use 'default' to use VS Code's default text editor"),new $.$jQ("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",a=>a===void 0||typeof a=="number"||typeof a=="object",a=>a&&(typeof a=="number"?[c.ViewColumn.from(a),void 0]:[c.ViewColumn.from(a.viewColumn),c.TextEditorOpenOptions.from(a)])).optional()],$.$kQ.Void),new $.$lQ("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[$.$jQ.Uri.with("left","Left-hand side resource of the diff editor"),$.$jQ.Uri.with("right","Right-hand side resource of the diff editor"),$.$jQ.String.with("title","Human readable title for the diff editor").optional(),new $.$jQ("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",a=>a===void 0||typeof a=="object",a=>a&&[c.ViewColumn.from(a.viewColumn),c.TextEditorOpenOptions.from(a)]).optional()],$.$kQ.Void),new $.$lQ("vscode.changes","_workbench.changes","Opens a list of resources in the changes editor to compare their contents.",[$.$jQ.String.with("title","Human readable title for the changes editor"),new $.$jQ("resourceList","List of resources to compare",a=>{for(const f of a){if(f.length!==3)return!1;const[d,m,n]=f;if(!P.URI.isUri(d)||!P.URI.isUri(m)&&m!==void 0&&m!==null||!P.URI.isUri(n)&&n!==void 0&&n!==null)return!1}return!0},a=>a)],$.$kQ.Void),new $.$lQ("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[$.$jQ.Uri,$.$jQ.Position],new $.$kQ("A promise that resolves to an array of TypeHierarchyItem-instances",a=>a.map(c.TypeHierarchyItem.to))),new $.$lQ("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[$.$jQ.TypeHierarchyItem],new $.$kQ("A promise that resolves to an array of TypeHierarchyItem-instances",a=>a.map(c.TypeHierarchyItem.to))),new $.$lQ("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[$.$jQ.TypeHierarchyItem],new $.$kQ("A promise that resolves to an array of TypeHierarchyItem-instances",a=>a.map(c.TypeHierarchyItem.to))),new $.$lQ("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[$.$jQ.TestItem],$.$kQ.Void),new $.$lQ("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[$.$jQ.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],$.$kQ.Void),new $.$lQ("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[$.$jQ.String.with("name","The context key name"),new $.$jQ("value","The context key value",()=>!0,a=>a)],$.$kQ.Void),new $.$lQ("vscode.executeMappedEditsProvider","_executeMappedEditsProvider","Execute Mapped Edits Provider",[$.$jQ.Uri,$.$jQ.StringArray,new $.$jQ("MappedEditsContext","Mapped Edits Context",a=>c.MappedEditsContext.is(a),a=>c.MappedEditsContext.from(a))],new $.$kQ("A promise that resolves to a workspace edit or null",a=>a?c.WorkspaceEdit.to(a):null)),new $.$lQ("vscode.editorChat.start","inlineChat.start","Invoke a new editor chat session",[new $.$jQ("Run arguments","",a=>!0,a=>{if(a)return{initialRange:a.initialRange?c.Range.from(a.initialRange):void 0,initialSelection:I.$wN.isSelection(a.initialSelection)?c.Selection.from(a.initialSelection):void 0,message:a.message,autoSend:a.autoSend,position:a.position?c.Position.from(a.position):void 0}})],$.$kQ.Void)];class u{static register(f){E.forEach(f.registerApiCommand,f),this.a(f)}static a(f){f.registerCommand(!1,"_validateWhenClauses",N.$Ej)}}e.$3nc=u;function k(a){return f=>{if(Array.isArray(f))return f.map(a)}}function p(a){if(!Array.isArray(a))return;const f=[];for(const d of a)R.$Du(d)?f.push(c.DefinitionLink.to(d)):f.push(c.location.to(d));return f}}),define(Ee[369],ye([1,0,2,35]),function(ce,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rpc=void 0;class P{constructor(T,N,$,c,I){this.a=N,this.b=$,this.c=c;const E=new h.$lQ("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new h.$jQ("showOptions","Show Options",u=>!0,u=>u),new h.$jQ("resource","Interactive resource Uri",u=>!0,u=>u),new h.$jQ("controllerId","Notebook controller Id",u=>!0,u=>u),new h.$jQ("title","Interactive editor title",u=>!0,u=>u)],new h.$kQ("Notebook and input URI",u=>{if(I.debug("[ExtHostInteractive] open iw with notebook editor id",u.notebookEditorId),u.notebookEditorId!==void 0){const k=this.a.getEditorById(u.notebookEditorId);return I.debug("[ExtHostInteractive] notebook editor found",k.id),{notebookUri:r.URI.revive(u.notebookUri),inputUri:r.URI.revive(u.inputUri),notebookEditor:k.apiEditor}}return I.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",u.notebookUri,u.inputUri),{notebookUri:r.URI.revive(u.notebookUri),inputUri:r.URI.revive(u.inputUri)}}));this.c.registerApiCommand(E)}$willAddInteractiveDocument(T,N,$,c){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:N,lines:[""],languageId:$,uri:T,isDirty:!1,versionId:1}]})}$willRemoveInteractiveDocument(T,N){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[T]})}}e.$rpc=P}),define(Ee[370],ye([1,0,19,9,21,4,3,29,2,24,12,6,35,17,10,122,311,26,51,312]),function(ce,e,r,h,P,R,T,N,$,c,I,E,u,k,p,a,f,d,m,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ypc=void 0,e.$zpc=w,k=We(k);let o=class{constructor(D,y,C,A,b){this.m=y,this.n=C,this.o=A,this.q=b,this.b=new N.$Cc,this.c=new N.$Cc,this.f=new Map,this.g=0,this.h=new Map,this.i=0,this.j=new Map,this.k=0,this.l=new R.$me,this.onDidChangeNotebookCellExecutionState=this.l.event,this.r=0,this.s={},this.a=D.getProxy(E.$rN.MainThreadNotebookKernels);const v=new u.$lQ("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new u.$jQ("options","Select kernel options",O=>!0,O=>{if(O&&"notebookEditor"in O&&"id"in O){const M=this.n.getIdByEditor(O.notebookEditor);return{id:O.id,extension:O.extension,notebookEditorId:M}}else if(O&&"notebookEditor"in O){const M=this.n.getIdByEditor(O.notebookEditor);if(M===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${O.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:M}}return O})],u.$kQ.Void),L=new u.$lQ("vscode.executeNotebookVariableProvider","_executeNotebookVariableProvider","Execute notebook variable provider",[u.$jQ.Uri],new u.$kQ("A promise that resolves to an array of variables",(O,M)=>O.map(j=>({variable:{name:j.name,value:j.value,expression:j.expression,type:j.type,language:j.language},hasNamedChildren:j.hasNamedChildren,indexedChildrenCount:j.indexedChildrenCount}))));this.o.registerApiCommand(v),this.o.registerApiCommand(L)}createNotebookController(D,y,C,A,b,v){for(const ne of this.j.values())if(ne.controller.id===y&&c.$qn.equals(D.identifier,ne.extensionId))throw new Error(`notebook controller with id '${y}' ALREADY exist`);const L=this.k++,O=this;this.q.trace(`NotebookController[${L}], CREATED by ${D.identifier.value}, ${y}`);const M=()=>console.warn(`NO execute handler from notebook controller '${B.id}' of extension: '${D.identifier}'`);let j=!1;const z=new R.$me,F=new R.$me,B={id:w(D.identifier,y),notebookType:C,extensionId:D.identifier,extensionLocation:D.extensionLocation,label:A||D.identifier.value,preloads:v?v.map(k.NotebookRendererScript.from):[]};let _=b??M,re,U;this.a.$addKernel(L,B).catch(ne=>{console.log(ne),j=!0});let G=0;const Q=()=>{if(j)return;const ne=++G;Promise.resolve().then(()=>{ne===G&&this.a.$updateKernel(L,B)})},ee=new N.$Cc,he={get id(){return y},get notebookType(){return B.notebookType},onDidChangeSelectedNotebooks:z.event,get label(){return B.label},set label(ne){B.label=ne??D.displayName??D.name,Q()},get detail(){return B.detail??""},set detail(ne){B.detail=ne,Q()},get description(){return B.description??""},set description(ne){B.description=ne,Q()},get supportedLanguages(){return B.supportedLanguages},set supportedLanguages(ne){B.supportedLanguages=ne,Q()},get supportsExecutionOrder(){return B.supportsExecutionOrder??!1},set supportsExecutionOrder(ne){B.supportsExecutionOrder=ne,Q()},get rendererScripts(){return B.preloads?B.preloads.map(k.NotebookRendererScript.to):[]},get executeHandler(){return _},set executeHandler(ne){_=ne??M},get interruptHandler(){return re},set interruptHandler(ne){re=ne,B.supportsInterrupt=!!ne,Q()},set variableProvider(ne){(0,d.$4G)(D,"notebookVariableProvider"),U=ne,B.hasVariableProvider=!!ne,ne?.onDidChangeVariables(De=>O.a.$variablesUpdated(De.uri)),Q()},get variableProvider(){return U},createNotebookCellExecution(ne){if(j)throw new Error("notebook controller is DISPOSED");if(!ee.has(ne.notebook.uri))throw O.q.trace(`NotebookController[${L}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(ee.keys()).map(De=>De.toString())),new Error(`notebook controller is NOT associated to notebook: ${ne.notebook.uri.toString()}`);return O._createNotebookCellExecution(ne,w(D.identifier,this.id))},createNotebookExecution(ne){if((0,d.$4G)(D,"notebookExecution"),j)throw new Error("notebook controller is DISPOSED");if(!ee.has(ne.uri))throw O.q.trace(`NotebookController[${L}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(ee.keys()).map(De=>De.toString())),new Error(`notebook controller is NOT associated to notebook: ${ne.uri.toString()}`);return O._createNotebookExecution(ne,w(D.identifier,this.id))},dispose:()=>{j||(this.q.trace(`NotebookController[${L}], DISPOSED`),j=!0,this.j.delete(L),z.dispose(),F.dispose(),this.a.$removeKernel(L))},updateNotebookAffinity(ne,De){De===p.NotebookControllerAffinity2.Hidden&&(0,d.$4G)(D,"notebookControllerAffinityHidden"),O.a.$updateNotebookPriority(L,ne.uri,De)},onDidReceiveMessage:F.event,postMessage(ne,De){return(0,d.$4G)(D,"notebookMessaging"),O.a.$postMessage(L,De&&O.n.getIdByEditor(De),ne)},asWebviewUri(ne){return(0,d.$4G)(D,"notebookMessaging"),(0,a.$XCb)(ne,O.m.remote)}};return this.j.set(L,{extensionId:D.identifier,controller:he,onDidReceiveMessage:F,onDidChangeSelection:z,associatedNotebooks:ee}),he}getIdByController(D){for(const[y,C]of this.j)if(C.controller===D)return w(C.extensionId,D.id);return null}createNotebookControllerDetectionTask(D,y){const C=this.g++,A=this;this.q.trace(`NotebookControllerDetectionTask[${C}], CREATED by ${D.identifier.value}`),this.a.$addKernelDetectionTask(C,y);const b={dispose:()=>{this.f.delete(C),A.a.$removeKernelDetectionTask(C)}};return this.f.set(C,b),b}registerKernelSourceActionProvider(D,y,C){const A=this.i++,b=typeof C.onDidChangeNotebookKernelSourceActions=="function"?A:void 0,v=this;this.h.set(A,C),this.q.trace(`NotebookKernelSourceActionProvider[${A}], CREATED by ${D.identifier.value}`),this.a.$addKernelSourceActionProvider(A,A,y);let L;return b!==void 0&&(L=C.onDidChangeNotebookKernelSourceActions(O=>this.a.$emitNotebookKernelSourceActionsChangeEvent(b))),{dispose:()=>{this.h.delete(A),v.a.$removeKernelSourceActionProvider(A,A),L?.dispose()}}}async $provideKernelSourceActions(D,y){const C=this.h.get(D);if(C){const A=new T.$Vc;return(await C.provideNotebookKernelSourceActions(y)??[]).map(v=>k.NotebookKernelSourceAction.from(v,this.o.converter,A))}return[]}$acceptNotebookAssociation(D,y,C){const A=this.j.get(D);if(A){const b=this.n.getNotebookDocument($.URI.revive(y));C?A.associatedNotebooks.set(b.uri,!0):A.associatedNotebooks.delete(b.uri),this.q.trace(`NotebookController[${D}] ASSOCIATE notebook`,b.uri.toString(),C),A.onDidChangeSelection.fire({selected:C,notebook:b.apiNotebook})}}async $executeCells(D,y,C){const A=this.j.get(D);if(!A)return;const b=this.n.getNotebookDocument($.URI.revive(y)),v=[];for(const L of C){const O=b.getCell(L);O&&v.push(O.apiCell)}try{this.q.trace(`NotebookController[${D}] EXECUTE cells`,b.uri.toString(),v.length),await A.controller.executeHandler.call(A.controller,v,b.apiNotebook,A.controller)}catch(L){this.q.error(`NotebookController[${D}] execute cells FAILED`,L),console.error(L)}}async $cancelCells(D,y,C){const A=this.j.get(D);if(!A)return;const b=this.n.getNotebookDocument($.URI.revive(y));if(A.controller.interruptHandler)await A.controller.interruptHandler.call(A.controller,b.apiNotebook);else for(const v of C){const L=b.getCell(v);L&&this.b.get(L.uri)?.cancel()}if(A.controller.interruptHandler){const v=this.c.get(b.uri);this.c.delete(b.uri),C.length&&Array.isArray(v)&&v.length&&v.forEach(L=>L.dispose())}}async $provideVariables(D,y,C,A,b,v,L){const O=this.j.get(D);if(!O)return;const M=this.n.getNotebookDocument($.URI.revive(C)),j=O.controller.variableProvider;if(!j)return;let z;if(A!==void 0){if(z=this.s[A],!z)return}else this.s={};const F=b==="named"?p.NotebookVariablesRequestKind.Named:p.NotebookVariablesRequestKind.Indexed,B=j.provideVariables(M.apiNotebook,z,F,v,L);let _=0;for await(const re of B){if(L.isCancellationRequested)return;const U={id:this.r++,name:re.variable.name,value:re.variable.value,type:re.variable.type,interfaces:re.variable.interfaces,language:re.variable.language,expression:re.variable.expression,hasNamedChildren:re.hasNamedChildren,indexedChildrenCount:re.indexedChildrenCount,extensionId:O.extensionId.value};if(this.s[U.id]=re.variable,this.a.$receiveVariable(y,U),_++>=n.$TK)return}}$acceptKernelMessageFromRenderer(D,y,C){const A=this.j.get(D);if(!A)return;const b=this.n.getEditorById(y);A.onDidReceiveMessage.fire(Object.freeze({editor:b.apiEditor,message:C}))}$cellExecutionChanged(D,y,C){const b=this.n.getNotebookDocument($.URI.revive(D)).getCell(y);if(b){const v=C?k.NotebookCellExecutionState.to(C):p.NotebookCellExecutionState.Idle;v!==void 0&&this.l.fire({cell:b.apiCell,state:v})}}_createNotebookCellExecution(D,y){if(D.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const A=this.n.getNotebookDocument(D.notebook.uri).getCellFromApiCell(D);if(!A)throw new Error("invalid cell");if(this.b.has(A.uri))throw new Error(`duplicate execution for ${A.uri}`);const b=new i(y,A,this.a);this.b.set(A.uri,b);const v=b.onDidChangeState(()=>{b.state===t.Resolved&&(b.dispose(),v.dispose(),this.b.delete(A.uri))});return b.asApiObject()}_createNotebookExecution(D,y){const C=this.n.getNotebookDocument(D.uri),A=D.getCells().find(L=>{const O=C.getCellFromApiCell(L);return O&&this.b.has(O.uri)});if(A)throw new Error(`duplicate cell execution for ${A.document.uri}`);if(this.c.has(C.uri))throw new Error(`duplicate notebook execution for ${C.uri}`);const b=new g(y,C,this.a),v=b.onDidChangeState(()=>{b.state===s.Resolved&&(b.dispose(),v.dispose(),this.c.delete(C.uri))});return this.c.set(C.uri,[b,v]),b.asApiObject()}};e.$ypc=o,e.$ypc=o=Je([Ge(4,I.$_j)],o);var t;(function(S){S[S.Init=0]="Init",S[S.Started=1]="Started",S[S.Resolved=2]="Resolved"})(t||(t={}));class i extends T.$Wc{static{this.a=0}get state(){return this.f}constructor(D,y,C){super(),this.m=y,this.n=C,this.b=i.a++,this.c=new R.$me,this.onDidChangeState=this.c.event,this.f=t.Init,this.g=this.B(new P.$xe),this.h=new l(10,A=>this.s(A)),this.j=y.internalMetadata.executionOrder,this.n.$createExecution(this.b,D,this.m.notebook.uri,this.m.handle)}cancel(){this.g.cancel()}async r(D){await this.h.addItem(D)}async s(D){const y=Array.isArray(D)?D:[D];return this.n.$updateExecution(this.b,new m.$Pw(y))}t(){if(this.f===t.Init)throw new Error("Must call start before modifying cell output");if(this.f===t.Resolved)throw new Error("Cannot modify cell output after calling resolve")}w(D){let y=this.m;if(D&&(y=this.m.notebook.getCellFromApiCell(D)),!y)throw new Error("INVALID cell");return y.handle}y(D){return D.map(y=>{const C=p.$ZO.ensureUniqueMimeTypes(y.items,!0);return C===y.items?k.NotebookCellOutput.from(y):k.NotebookCellOutput.from({items:C,id:y.id,metadata:y.metadata})})}async z(D,y,C){const A=this.w(y),b=this.y((0,r.$4b)(D));return this.r({editType:f.CellExecutionUpdateType.Output,cellHandle:A,append:C,outputs:b})}async C(D,y,C){return D=p.$ZO.ensureUniqueMimeTypes((0,r.$4b)(D),!0),this.r({editType:f.CellExecutionUpdateType.OutputItems,items:D.map(k.NotebookCellOutputItem.from),outputId:y.id,append:C})}asApiObject(){const D=this;return Object.freeze({get token(){return D.g.token},get cell(){return D.m.apiCell},get executionOrder(){return D.j},set executionOrder(C){D.j=C,D.s([{editType:f.CellExecutionUpdateType.ExecutionState,executionOrder:D.j}])},start(C){if(D.f===t.Resolved||D.f===t.Started)throw new Error("Cannot call start again");D.f=t.Started,D.c.fire(),D.s({editType:f.CellExecutionUpdateType.ExecutionState,runStartTime:C})},end(C,A,b){if(D.f===t.Resolved)throw new Error("Cannot call resolve twice");D.f=t.Resolved,D.c.fire(),D.h.flush();const v=b?{message:b.message,stack:b.stack,location:b?.location?{startLineNumber:b.location.start.line,startColumn:b.location.start.character,endLineNumber:b.location.end.line,endColumn:b.location.end.character}:void 0,uri:b.uri}:void 0;D.n.$completeExecution(D.b,new m.$Pw({runEndTime:A,lastRunSuccess:C,error:v}))},clearOutput(C){return D.t(),D.z([],C,!1)},appendOutput(C,A){return D.t(),D.z(C,A,!0)},replaceOutput(C,A){return D.t(),D.z(C,A,!1)},appendOutputItems(C,A){return D.t(),D.C(C,A,!0)},replaceOutputItems(C,A){return D.t(),D.C(C,A,!1)}})}}var s;(function(S){S[S.Init=0]="Init",S[S.Started=1]="Started",S[S.Resolved=2]="Resolved"})(s||(s={}));class g extends T.$Wc{static{this.a=0}get state(){return this.f}constructor(D,y,C){super(),this.h=y,this.j=C,this.b=g.a++,this.c=new R.$me,this.onDidChangeState=this.c.event,this.f=s.Init,this.g=this.B(new P.$xe),this.j.$createNotebookExecution(this.b,D,this.h.uri)}cancel(){this.g.cancel()}asApiObject(){return Object.freeze({start:()=>{if(this.f===s.Resolved||this.f===s.Started)throw new Error("Cannot call start again");this.f=s.Started,this.c.fire(),this.j.$beginNotebookExecution(this.b)},end:()=>{if(this.f===s.Resolved)throw new Error("Cannot call resolve twice");this.f=s.Resolved,this.c.fire(),this.j.$completeNotebookExecution(this.b)}})}}class l{constructor(D,y){this.f=D,this.g=y,this.a=[],this.b=Date.now()}addItem(D){return this.a.push(D),this.c||(this.c=new h.$3h,this.b=Date.now(),(0,h.$Gh)(this.f).then(()=>this.flush())),Date.now()-this.b>this.f?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const D=this.c;this.c=void 0;const y=this.a;return this.a=[],this.g(y).finally(()=>D.complete())}}function w(S,D){return`${S.value}/${D}`}}),define(Ee[47],ye([1,0,4,6,5,2,20,3,10,241,14,290,21,32,291,292,50,9,17,35,41]),function(ce,e,r,h,P,R,T,N,$,c,I,E,u,k,p,a,f,d,m,n,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hoc=e.$Goc=e.$Foc=e.$Eoc=void 0,e.$Eoc=(0,P.$Fi)("IExtHostTerminalService");class t extends N.$Wc{constructor(b,v,L,O){super(),this.u=b,this._id=v,this.w=L,this.y=O,this.a=!1,this.m={isInteractedWith:!1},this.isOpen=!1,this.s=this.B(new r.$me),this.onWillDispose=this.s.event,this.w=Object.freeze(this.w),this.b=new Promise(j=>this.g=j);const M=this;this.value={get name(){return M.y||""},get processId(){return M.b},get creationOptions(){return M.w},get exitStatus(){return M.j},get state(){return M.m},get selection(){return M.n},get shellIntegration(){return M.shellIntegration},sendText(j,z=!0){M.C(),M.u.$sendText(M._id,j,z)},show(j){M.C(),M.u.$show(M._id,j)},hide(){M.C(),M.u.$hide(M._id)},dispose(){M.a||(M.a=!0,M.u.$dispose(M._id))},get dimensions(){if(!(M.f===void 0||M.h===void 0))return{columns:M.f,rows:M.h}}}}dispose(){this.s.fire(),super.dispose()}async create(b,v){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.u.$createTerminal(this._id,{name:b.name,shellPath:b.shellPath??void 0,shellArgs:b.shellArgs??void 0,cwd:b.cwd??v?.cwd??void 0,env:b.env??void 0,icon:D(b.iconPath)??void 0,color:f.ThemeColor.isThemeColor(b.color)?b.color.id:void 0,initialText:b.message??void 0,strictEnv:b.strictEnv??void 0,hideFromUser:b.hideFromUser??void 0,forceShellIntegration:v?.forceShellIntegration??void 0,isFeatureTerminal:v?.isFeatureTerminal??void 0,isExtensionOwnedTerminal:!0,useShellEnvironment:v?.useShellEnvironment??void 0,location:v?.location||this.z(b.location,v?.resolvedExtHostIdentifier),isTransient:b.isTransient??void 0})}async createExtensionTerminal(b,v,L,O,M){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.u.$createTerminal(this._id,{name:this.y,isExtensionCustomPtyTerminal:!0,icon:O,color:f.ThemeColor.isThemeColor(M)?M.id:void 0,location:v?.location||this.z(b,L),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}z(b,v){return typeof b=="object"?"parentTerminal"in b&&b.parentTerminal&&v?{parentTerminal:v}:"viewColumn"in b?{viewColumn:m.ViewColumn.from(b.viewColumn),preserveFocus:b.preserveFocus}:void 0:b}C(){if(this.a)throw new Error("Terminal has already been disposed")}set name(b){this.y=b}setExitStatus(b,v){this.j=Object.freeze({code:b,reason:v})}setDimensions(b,v){return b===this.f&&v===this.h||b===0||v===0?!1:(this.f=b,this.h=v,!0)}setInteractedWith(){return this.m.isInteractedWith?!1:(this.m={isInteractedWith:!0},!0)}setSelection(b){this.n=b}_setProcessId(b){this.g?(this.g(b),this.g=void 0):this.b.then(v=>{v!==b&&(this.b=Promise.resolve(b))})}}e.$Foc=t;class i{get onProcessReady(){return this.b.event}constructor(b){this.g=b,this.id=0,this.shouldPersist=!1,this.a=new r.$me,this.onProcessData=this.a.event,this.b=new r.$me,this.d=new r.$me,this.onDidChangeProperty=this.d.event,this.f=new r.$me,this.onProcessExit=this.f.event}refreshProperty(b){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${b}`)}updateProperty(b,v){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${b}, value: ${v}`)}async start(){}shutdown(){this.g.close()}input(b){this.g.handleInput?.(b)}resize(b,v){this.g.setDimensions?.({columns:b,rows:v})}clearBuffer(){}async processBinary(b){}acknowledgeDataEvent(b){}async setUnicodeVersion(b){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}startSendingEvents(b){this.g.onDidWrite(v=>this.a.fire(v)),this.g.onDidClose?.((v=void 0)=>{this.f.fire(v===void 0?void 0:v)}),this.g.onDidOverrideDimensions?.(v=>{v&&this.d.fire({type:p.ProcessPropertyType.OverrideDimensions,value:{cols:v.columns,rows:v.rows}})}),this.g.onDidChangeName?.(v=>{this.d.fire({type:p.ProcessPropertyType.Title,value:v})}),this.g.open(b||void 0),b&&this.g.setDimensions?.(b),this.b.fire({pid:-1,cwd:"",windowsPty:void 0})}}let s=1,g=class extends N.$Wc{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map(b=>b.value)}constructor(b,v,L){super(),this.Q=v,this.f=[],this.g=new Map,this.h={},this.j={},this.m={},this.n=new Map,this.w=this.B(new N.$Xc),this.z=new Set,this.C=new Map,this.D=new Map,this.F=new Map,this.G=new Map,this.H=new r.$me,this.onDidCloseTerminal=this.H.event,this.I=new r.$me,this.onDidOpenTerminal=this.I.event,this.J=new r.$me,this.onDidChangeActiveTerminal=this.J.event,this.L=new r.$me,this.onDidChangeTerminalDimensions=this.L.event,this.M=new r.$me,this.onDidChangeTerminalState=this.M.event,this.N=new r.$me,this.onDidChangeShell=this.N.event,this.O=new r.$me({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.onDidWriteTerminalData=this.O.event,this.P=new r.$me({onWillAddFirstListener:()=>this.a.$startSendingCommandEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingCommandEvents()}),this.onDidExecuteTerminalCommand=this.P.event,this.a=L.getProxy(h.$rN.MainThreadTerminalService),this.y=new a.$exb(this.a.$sendProcessData),this.a.$registerProcessSupport(b),this.Q.registerArgumentProcessor({processArgument:O=>{const M=j=>{const z=j;return this.getTerminalById(z.instanceId)?.value};switch(O?.$mid){case o.MarshalledId.TerminalContext:return M(O);default:{if(Array.isArray(O))for(let j=0;j<O.length&&O[j].$mid===o.MarshalledId.TerminalContext;j++)O[j]=M(O[j]);return O}}}}),this.B({dispose:()=>{for(const[O,M]of this.g)M.shutdown(!0)}})}getDefaultShell(b){return(b?this.u:this.s)?.path||""}getDefaultShellArgs(b){return(b?this.u:this.s)?.args||[]}createExtensionTerminal(b,v){const L=new t(this.a,(0,k.$2g)(),b,b.name),O=new i(b.pty);return L.createExtensionTerminal(b.location,v,this.R(b,v).resolvedExtHostIdentifier,D(b.iconPath),y(b.color)).then(M=>{const j=this.S(M,O);this.h[M]=j}),this.f.push(L),L.value}R(b,v){if(v=v||{},b.location&&typeof b.location=="object"&&"parentTerminal"in b.location){const L=b.location.parentTerminal;if(L){const O=this.f.find(M=>M.value===L);O&&(v.resolvedExtHostIdentifier=O._id)}}else b.location&&typeof b.location!="object"?v.location=b.location:v.location&&typeof v.location=="object"&&"splitActiveTerminal"in v.location&&(v.location={splitActiveTerminal:!0});return v}attachPtyToTerminal(b,v){if(!this.getTerminalById(b))throw new Error(`Cannot resolve terminal with id ${b} for virtual process`);const O=new i(v),M=this.S(b,O);this.h[b]=M}async $acceptActiveTerminalChanged(b){const v=this.b;if(b===null){this.b=void 0,v!==this.b&&this.J.fire(this.b);return}const L=this.getTerminalById(b);L&&(this.b=L,v!==this.b&&this.J.fire(this.b.value))}async $acceptTerminalProcessData(b,v){const L=this.getTerminalById(b);L&&this.O.fire({terminal:L.value,data:v})}async $acceptTerminalDimensions(b,v,L){const O=this.getTerminalById(b);O&&O.setDimensions(v,L)&&this.L.fire({terminal:O.value,dimensions:O.value.dimensions})}async $acceptDidExecuteCommand(b,v){const L=this.getTerminalById(b);L&&this.P.fire({terminal:L.value,...v})}async $acceptTerminalMaximumDimensions(b,v,L){this.g.get(b)?.resize(v,L)}async $acceptTerminalTitleChange(b,v){const L=this.getTerminalById(b);L&&(L.name=v)}async $acceptTerminalClosed(b,v,L){const O=this.X(this.f,b);if(O!==null){const M=this.f.splice(O,1)[0];M.setExitStatus(v,L),this.H.fire(M.value)}}$acceptTerminalOpened(b,v,L,O){if(v){const z=this.X(this.f,v);if(z!==null){this.f[z]._id=b,this.I.fire(this.terminals[z]),this.f[z].isOpen=!0;return}}const M={name:O.name,shellPath:O.executable,shellArgs:O.args,cwd:typeof O.cwd=="string"?O.cwd:R.URI.revive(O.cwd),env:O.env,hideFromUser:O.hideFromUser},j=new t(this.a,b,M,L);this.f.push(j),this.I.fire(j.value),j.isOpen=!0}async $acceptTerminalProcessId(b,v){this.getTerminalById(b)?._setProcessId(v)}async $startExtensionTerminal(b,v){const L=this.getTerminalById(b);if(!L)return{message:(0,c.localize)(0,null,b)};L.isOpen||await new Promise(M=>{const j=this.onDidOpenTerminal(async z=>{z===L.value&&(j.dispose(),M())})});const O=this.g.get(b);O?O.startSendingEvents(v):this.j[b]={initialDimensions:v}}S(b,v){const L=new N.$Vc;L.add(v.onProcessReady(M=>this.a.$sendProcessReady(b,M.pid,M.cwd,M.windowsPty))),L.add(v.onDidChangeProperty(M=>this.a.$sendProcessProperty(b,M))),this.y.startBuffering(b,v.onProcessData),L.add(v.onProcessExit(M=>this.U(b,M))),this.g.set(b,v);const O=this.j[b];return O&&v instanceof i&&(v.startSendingEvents(O.initialDimensions),delete this.j[b]),L}$acceptProcessAckDataEvent(b,v){this.g.get(b)?.acknowledgeDataEvent(v)}$acceptProcessInput(b,v){this.g.get(b)?.input(v)}$acceptTerminalInteraction(b){const v=this.getTerminalById(b);v?.setInteractedWith()&&this.M.fire(v.value)}$acceptTerminalSelection(b,v){this.getTerminalById(b)?.setSelection(v)}$acceptProcessResize(b,v,L){try{this.g.get(b)?.resize(v,L)}catch(O){if(O.code!=="EPIPE"&&O.code!=="ERR_IPC_CHANNEL_CLOSED")throw O}}$acceptProcessShutdown(b,v){this.g.get(b)?.shutdown(v)}$acceptProcessRequestInitialCwd(b){this.g.get(b)?.getInitialCwd().then(v=>this.a.$sendProcessProperty(b,{type:p.ProcessPropertyType.InitialCwd,value:v}))}$acceptProcessRequestCwd(b){this.g.get(b)?.getCwd().then(v=>this.a.$sendProcessProperty(b,{type:p.ProcessPropertyType.Cwd,value:v}))}$acceptProcessRequestLatency(b){return Promise.resolve(b)}registerLinkProvider(b){return this.z.add(b),this.z.size===1&&this.a.$startLinkProvider(),new $.$tN(()=>{this.z.delete(b),this.z.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider(b,v,L){if(this.C.has(v))throw new Error(`Terminal profile provider "${v}" already registered`);return this.C.set(v,L),this.a.$registerProfileProvider(v,b.identifier.value),new $.$tN(()=>{this.C.delete(v),this.a.$unregisterProfileProvider(v)})}registerTerminalQuickFixProvider(b,v,L){if(this.D.has(b))throw new Error(`Terminal quick fix provider "${b}" is already registered`);return this.D.set(b,L),this.a.$registerQuickFixProvider(b,v),new $.$tN(()=>{this.D.delete(b),this.a.$unregisterQuickFixProvider(b)})}async $provideTerminalQuickFixes(b,v){const L=new u.$xe().token;if(L.isCancellationRequested)return;const O=this.D.get(b);if(!O)return;const M=await O.provideTerminalQuickFixes(v,L);if(M===null||Array.isArray(M)&&M.length===0)return;const j=new N.$Vc;if(this.w.value=j,!Array.isArray(M))return M?m.TerminalQuickFix.from(M,this.Q.converter,j):void 0;const z=[];for(const F of M){const B=m.TerminalQuickFix.from(F,this.Q.converter,j);B&&z.push(B)}return z}async $createContributedProfileTerminal(b,v){const L=new u.$xe().token;let O=await this.C.get(b)?.provideTerminalProfile(L);if(!L.isCancellationRequested){if(O&&!("options"in O)&&(O={options:O}),!O||!("options"in O))throw new Error(`No terminal profile options provided for id "${b}"`);if("pty"in O.options){this.createExtensionTerminal(O.options,v);return}this.createTerminalFromOptions(O.options,v)}}async $provideLinks(b,v){const L=this.getTerminalById(b);if(!L)return[];this.F.delete(b),this.G.get(b)?.dispose(!0);const M=new u.$xe;this.G.set(b,M);const j=[],z={terminal:L.value,line:v},F=[];for(const re of this.z)F.push(d.Promises.withAsyncBody(async U=>{M.token.onCancellationRequested(()=>U({provider:re,links:[]}));const G=await re.provideTerminalLinks(z,M.token)||[];M.token.isCancellationRequested||U({provider:re,links:G})}));const B=await Promise.all(F);if(M.token.isCancellationRequested)return[];const _=new Map;for(const re of B)re&&re.links.length>0&&j.push(...re.links.map(U=>{const G={id:s++,startIndex:U.startIndex,length:U.length,label:U.tooltip};return _.set(G.id,{provider:re.provider,link:U}),G}));return this.F.set(b,_),j}$activateLink(b,v){const L=this.F.get(b)?.get(v);L&&L.provider.handleTerminalLink(L.link)}U(b,v){this.y.stopBuffering(b),this.g.delete(b),delete this.j[b];const L=this.h[b];L&&(L.dispose(),delete this.h[b]),this.a.$sendProcessExit(b,v)}getTerminalById(b){return this.W(this.f,b)}getTerminalIdByApiObject(b){const v=this.f.findIndex(L=>L.value===b);return v>=0?v:null}W(b,v){const L=this.X(b,v);return L!==null?b[L]:null}X(b,v){const L=b.findIndex(O=>O._id===v);return L>=0?L:null}getEnvironmentVariableCollection(b){let v=this.n.get(b.identifier.value);return v||(v=this.B(new l),this.Z(b.identifier.value,v)),v.getScopedEnvironmentVariableCollection(void 0)}Y(b,v){const L=(0,E.$ys)(v.map),O=(0,E.$zs)(v.descriptionMap);this.a.$setEnvironmentVariableCollection(b,v.persistent,L.length===0?void 0:L,O)}$initEnvironmentVariableCollections(b){b.forEach(v=>{const L=v[0],O=this.B(new l(v[1]));this.Z(L,O)})}$acceptDefaultProfile(b,v){const L=this.s;this.s=b,this.u=v,L?.path!==b.path&&this.N.fire(b.path)}Z(b,v){this.n.set(b,v),this.B(v.onDidChangeCollection(()=>{this.Y(b,v)}))}};e.$Goc=g,e.$Goc=g=Je([Ge(1,n.$hQ),Ge(2,T.$XP)],g);class l extends N.$Wc{get persistent(){return this.b}set persistent(b){this.b=b,this.f.fire()}get onDidChangeCollection(){return this.f&&this.f.event}constructor(b){super(),this.map=new Map,this.a=new Map,this.descriptionMap=new Map,this.b=!0,this.f=new r.$me,this.map=new Map(b)}getScopedEnvironmentVariableCollection(b){const v=this.j(b);let L=this.a.get(v);return L||(L=new w(this,b),this.a.set(v,L),this.B(L.onDidChangeCollection(()=>this.f.fire()))),L}replace(b,v,L,O){this.g(b,{value:v,type:$.EnvironmentVariableMutatorType.Replace,options:L??{applyAtProcessCreation:!0},scope:O})}append(b,v,L,O){this.g(b,{value:v,type:$.EnvironmentVariableMutatorType.Append,options:L??{applyAtProcessCreation:!0},scope:O})}prepend(b,v,L,O){this.g(b,{value:v,type:$.EnvironmentVariableMutatorType.Prepend,options:L??{applyAtProcessCreation:!0},scope:O})}g(b,v){if(v.options&&v.options.applyAtProcessCreation===!1&&!v.options.applyAtShellIntegration)throw new Error("EnvironmentVariableMutatorOptions must apply at either process creation or shell integration");const L=this.h(b,v.scope),O=this.map.get(L),M=v.options?{applyAtProcessCreation:v.options.applyAtProcessCreation??!1,applyAtShellIntegration:v.options.applyAtShellIntegration??!1}:{applyAtProcessCreation:!0};if(!O||O.value!==v.value||O.type!==v.type||O.options?.applyAtProcessCreation!==M.applyAtProcessCreation||O.options?.applyAtShellIntegration!==M.applyAtShellIntegration||O.scope?.workspaceFolder?.index!==v.scope?.workspaceFolder?.index){const j=this.h(b,v.scope),z={variable:b,...v,options:M};this.map.set(j,z),this.f.fire()}}get(b,v){const L=this.h(b,v),O=this.map.get(L);return O?C(O):void 0}h(b,v){const L=this.j(v);return L.length?`${b}:::${L}`:b}j(b){return this.m(b?.workspaceFolder)??""}m(b){return b?b.uri.toString():void 0}getVariableMap(b){const v=new Map;for(const[L,O]of this.map)this.j(O.scope)===this.j(b)&&v.set(O.variable,C(O));return v}delete(b,v){const L=this.h(b,v);this.map.delete(L),this.f.fire()}clear(b){if(b?.workspaceFolder){for(const[v,L]of this.map)L.scope?.workspaceFolder?.index===b.workspaceFolder.index&&this.map.delete(v);this.n(b)}else this.map.clear(),this.descriptionMap.clear();this.f.fire()}setDescription(b,v){const L=this.j(v),O=this.descriptionMap.get(L);if(!O||O.description!==b){let M;typeof b=="string"?M=b:M=b?.value.split(`

`)[0];const j={description:M,scope:v};this.descriptionMap.set(L,j),this.f.fire()}}getDescription(b){const v=this.j(b);return this.descriptionMap.get(v)?.description}n(b){const v=this.j(b);this.descriptionMap.delete(v)}}class w{get persistent(){return this.b.persistent}set persistent(b){this.b.persistent=b}get onDidChangeCollection(){return this.a&&this.a.event}constructor(b,v){this.b=b,this.d=v,this.a=new r.$me}getScoped(b){return this.b.getScopedEnvironmentVariableCollection(b)}replace(b,v,L){this.b.replace(b,v,L,this.d)}append(b,v,L){this.b.append(b,v,L,this.d)}prepend(b,v,L){this.b.prepend(b,v,L,this.d)}get(b){return this.b.get(b,this.d)}forEach(b,v){this.b.getVariableMap(this.d).forEach((L,O)=>b.call(v,O,L,this),this.d)}[Symbol.iterator](){return this.b.getVariableMap(this.d).entries()}delete(b){this.b.delete(b,this.d),this.a.fire(void 0)}clear(){this.b.clear(this.d)}set description(b){this.b.setDescription(b,this.d)}get description(){return this.b.getDescription(this.d)}}let S=class extends g{constructor(b,v){super(!1,b,v)}createTerminal(b,v,L){throw new I.$bb}createTerminalFromOptions(b,v){throw new I.$bb}};e.$Hoc=S,e.$Hoc=S=Je([Ge(0,n.$hQ),Ge(1,T.$XP)],S);function D(A){if(!(!A||typeof A=="string"))return"id"in A?{id:A.id,color:A.color}:A}function y(A){return f.ThemeColor.isThemeColor(A)?A:void 0}function C(A){const b={...A};return delete b.scope,b.options=b.options??void 0,delete b.variable,b}}),define(Ee[166],ye([1,0,10,3,5,6,20,47,4,2,9]),function(ce,e,r,h,P,R,T,N,$,c,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rpc=e.$Qpc=void 0,e.$Qpc=(0,P.$Fi)("IExtHostTerminalShellIntegration");let E=class extends h.$Wc{constructor(f,d){super(),this.h=d,this.b=new Map,this.c=new $.$me,this.onDidChangeTerminalShellIntegration=this.c.event,this.f=new $.$me,this.onDidStartTerminalShellExecution=this.f.event,this.g=new $.$me,this.onDidEndTerminalShellExecution=this.g.event,this.a=f.getProxy(R.$rN.MainThreadTerminalShellIntegration),this.B((0,h.$Uc)(()=>{for(const[m,n]of this.b)n.dispose();this.b.clear()}))}$shellIntegrationChange(f){const d=this.h.getTerminalById(f);if(!d)return;const m=d.value;let n=this.b.get(f);n||(n=new u(d.value,this.f),this.b.set(f,n),n.store.add(d.onWillDispose(()=>this.b.get(f)?.dispose())),n.store.add(n.onDidRequestShellExecution(o=>this.a.$executeCommand(f,o))),n.store.add(n.onDidRequestEndExecution(o=>this.g.fire(o))),n.store.add(n.onDidRequestChangeShellIntegration(o=>this.c.fire(o))),d.shellIntegration=n.value),this.c.fire({terminal:m,shellIntegration:n.value})}$shellExecutionStart(f,d,m,n,o){this.b.has(f)||this.$shellIntegrationChange(f);const t={value:d,confidence:m,isTrusted:n};this.b.get(f)?.startShellExecution(t,o)}$shellExecutionEnd(f,d,m,n,o){const t={value:d,confidence:m,isTrusted:n};this.b.get(f)?.endShellExecution(t,o)}$shellExecutionData(f,d){this.b.get(f)?.emitData(d)}$cwdChange(f,d){this.b.get(f)?.setCwd((0,c.$xc)(d)?c.URI.revive(d):d)}$closeTerminal(f){this.b.get(f)?.dispose(),this.b.delete(f)}};e.$Rpc=E,e.$Rpc=E=Je([Ge(0,T.$XP),Ge(1,N.$Eoc)],E);class u extends h.$Wc{get currentExecution(){return this.a}constructor(f,d){super(),this.j=f,this.m=d,this.b=!1,this.store=this.B(new h.$Vc),this.f=this.B(new $.$me),this.onDidRequestChangeShellIntegration=this.f.event,this.g=this.B(new $.$me),this.onDidRequestShellExecution=this.g.event,this.h=this.B(new $.$me),this.onDidRequestEndExecution=this.h.event;const m=this;this.value={get cwd(){return m.c},executeCommand(n,o){let t=n;o&&(t+=` "${o.map(g=>`${g.replaceAll('"','\\"')}`).join('" "')}"`),m.g.fire(t);const i={value:t,confidence:r.TerminalShellExecutionCommandLineConfidence.High,isTrusted:!0},s=m.startShellExecution(i,m.c,!0).value;return m.b=!0,s}}}startShellExecution(f,d,m){if(this.b&&this.a)this.b=!1;else{this.a&&(this.a.endExecution(void 0),this.h.fire({terminal:this.j,shellIntegration:this.value,execution:this.a.value,exitCode:void 0}));const n=this.a=new k(f,d);m?queueMicrotask(()=>this.m.fire({terminal:this.j,shellIntegration:this.value,execution:n.value})):this.m.fire({terminal:this.j,shellIntegration:this.value,execution:this.a.value})}return this.a}emitData(f){this.currentExecution?.emitData(f)}endShellExecution(f,d){this.a&&(this.a.endExecution(f),this.h.fire({terminal:this.j,shellIntegration:this.value,execution:this.a.value,exitCode:d}),this.a=void 0)}setCwd(f){let d=!1;c.URI.isUri(this.c)?d=!c.URI.isUri(f)||this.c.toString()!==f.toString():this.c!==f&&(d=!0),d&&(this.c=f,this.f.fire({terminal:this.j,shellIntegration:this.value}))}}class k{constructor(f,d){this.c=f,this.cwd=d,this.b=!1;const m=this;this.value={get commandLine(){return m.c},get cwd(){return m.cwd},read(){return m.d()}}}d(){if(!this.a){if(this.b)return I.$6h.EMPTY;this.a=new p}return this.a.createIterable()}emitData(f){this.a?.emitData(f)}endExecution(f){f&&(this.c=f),this.a?.endExecution(),this.a=void 0,this.b=!0}}class p extends h.$Wc{constructor(){super(...arguments),this.b=[]}createIterable(){this.a||(this.a=new I.$Eh);const f=this.a;return new I.$6h(async m=>{this.b.push(m),await f.wait()})}emitData(f){for(const d of this.b)d.emitOne(f)}endExecution(){this.a?.open(),this.a=void 0}}}),define(Ee[167],ye([1,0,66,14,133,17,10]),function(ce,e,r,h,P,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7P=e.$6P=e.$5P=void 0,R=We(R);class N{static{this.c=new P.$3P("TextEditorDecorationType")}constructor(u,k,p){const a=N.c.nextId();u.$registerTextEditorDecorationType(k.identifier,a,R.DecorationRenderOptions.from(p)),this.value=Object.freeze({key:a,dispose(){u.$removeTextEditorDecorationType(a)}})}}e.$5P=N;class ${constructor(u,k){this.g=[],this.h=void 0,this.j=!1,this.c=u,this.d=u.version,this.e=k.undoStopBefore,this.f=k.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(u,k){this.k();let p=null;if(u instanceof T.$uN)p=new T.$vN(u,u);else if(u instanceof T.$vN)p=u;else throw new Error("Unrecognized location");this.l(p,k,!1)}insert(u,k){this.k(),this.l(new T.$vN(u,u),k,!0)}delete(u){this.k();let k=null;if(u instanceof T.$vN)k=u;else throw new Error("Unrecognized location");this.l(k,null,!0)}l(u,k,p){const a=this.c.validateRange(u);this.g.push({range:a,text:k,forceMoveMarkers:p})}setEndOfLine(u){if(this.k(),u!==T.EndOfLine.LF&&u!==T.EndOfLine.CRLF)throw(0,h.$9)("endOfLine");this.h=u}}class c{constructor(u,k,p,a){this.c=u,this.d=k,this._accept(p),this.e=a;const f=this;this.value={get tabSize(){return f.f},set tabSize(d){f.n(d)},get indentSize(){return f.g},set indentSize(d){f.p(d)},get insertSpaces(){return f.j},set insertSpaces(d){f.s(d)},get cursorStyle(){return f.k},set cursorStyle(d){f.t(d)},get lineNumbers(){return f.l},set lineNumbers(d){f.u(d)}}}_accept(u){this.f=u.tabSize,this.g=u.indentSize,this.h=u.originalIndentSize,this.j=u.insertSpaces,this.k=u.cursorStyle,this.l=R.TextEditorLineNumbersStyle.to(u.lineNumbers)}m(u){if(u==="auto")return"auto";if(typeof u=="number"){const k=Math.floor(u);return k>0?k:null}if(typeof u=="string"){const k=parseInt(u,10);return isNaN(k)?null:k>0?k:null}return null}n(u){const k=this.m(u);if(k!==null){if(typeof k=="number"){if(this.f===k)return;this.f=k}this.v("setTabSize",this.c.$trySetOptions(this.d,{tabSize:k}))}}o(u){if(u==="tabSize")return"tabSize";if(typeof u=="number"){const k=Math.floor(u);return k>0?k:null}if(typeof u=="string"){const k=parseInt(u,10);return isNaN(k)?null:k>0?k:null}return null}p(u){const k=this.o(u);if(k!==null){if(typeof k=="number"){if(this.h===k)return;this.g=k,this.h=k}this.v("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:k}))}}q(u){return u==="auto"?"auto":u==="false"?!1:!!u}s(u){const k=this.q(u);if(typeof k=="boolean"){if(this.j===k)return;this.j=k}this.v("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:k}))}t(u){this.k!==u&&(this.k=u,this.v("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:u})))}u(u){this.l!==u&&(this.l=u,this.v("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:R.TextEditorLineNumbersStyle.from(u)})))}assign(u){const k={};let p=!1;if(typeof u.tabSize<"u"){const a=this.m(u.tabSize);a==="auto"?(p=!0,k.tabSize=a):typeof a=="number"&&this.f!==a&&(this.f=a,p=!0,k.tabSize=a)}if(typeof u.indentSize<"u"){const a=this.o(u.indentSize);a==="tabSize"?(p=!0,k.indentSize=a):typeof a=="number"&&this.h!==a&&(this.g=a,this.h=a,p=!0,k.indentSize=a)}if(typeof u.insertSpaces<"u"){const a=this.q(u.insertSpaces);a==="auto"?(p=!0,k.insertSpaces=a):this.j!==a&&(this.j=a,p=!0,k.insertSpaces=a)}typeof u.cursorStyle<"u"&&this.k!==u.cursorStyle&&(this.k=u.cursorStyle,p=!0,k.cursorStyle=u.cursorStyle),typeof u.lineNumbers<"u"&&this.l!==u.lineNumbers&&(this.l=u.lineNumbers,p=!0,k.lineNumbers=R.TextEditorLineNumbersStyle.from(u.lineNumbers)),p&&this.v("setOptions",this.c.$trySetOptions(this.d,k))}v(u,k){k.catch(p=>{this.e.warn(`ExtHostTextEditorOptions '${u}' failed:'`),this.e.warn(p)})}}e.$6P=c;class I{constructor(u,k,p,a,f,d,m,n){this.id=u,this.j=k,this.k=p,this.g=!1,this.h=new Set,this.c=f,this.d=new c(this.j,this.id,d,p),this.e=m,this.f=n;const o=this;this.value=Object.freeze({get document(){return a.value},set document(t){throw new h.$$("document")},get selection(){return o.c&&o.c[0]},set selection(t){if(!(t instanceof T.$wN))throw(0,h.$9)("selection");o.c=[t],o.l()},get selections(){return o.c},set selections(t){if(!Array.isArray(t)||t.some(i=>!(i instanceof T.$wN)))throw(0,h.$9)("selections");o.c=t,o.l()},get visibleRanges(){return o.e},set visibleRanges(t){throw new h.$$("visibleRanges")},get options(){return o.d.value},set options(t){o.g||o.d.assign(t)},get viewColumn(){return o.f},set viewColumn(t){throw new h.$$("viewColumn")},edit(t,i={undoStopBefore:!0,undoStopAfter:!0}){if(o.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const s=new $(a.value,i);return t(s),o.m(s)},insertSnippet(t,i,s={undoStopBefore:!0,undoStopAfter:!0}){if(o.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let g;if(!i||Array.isArray(i)&&i.length===0)g=o.c.map(l=>R.Range.from(l));else if(i instanceof T.$uN){const{lineNumber:l,column:w}=R.Position.from(i);g=[{startLineNumber:l,startColumn:w,endLineNumber:l,endColumn:w}]}else if(i instanceof T.$vN)g=[R.Range.from(i)];else{g=[];for(const l of i)if(l instanceof T.$vN)g.push(R.Range.from(l));else{const{lineNumber:w,column:S}=R.Position.from(l);g.push({startLineNumber:w,startColumn:S,endLineNumber:w,endColumn:S})}}return k.$tryInsertSnippet(u,a.value.version,t.value,g,s)},setDecorations(t,i){const s=i.length===0;s&&!o.h.has(t.key)||(s?o.h.delete(t.key):o.h.add(t.key),o.n(()=>{if(R.$UP(i))return k.$trySetDecorations(u,t.key,R.$VP(i));{const g=new Array(4*i.length);for(let l=0,w=i.length;l<w;l++){const S=i[l];g[4*l]=S.start.line+1,g[4*l+1]=S.start.character+1,g[4*l+2]=S.end.line+1,g[4*l+3]=S.end.character+1}return k.$trySetDecorationsFast(u,t.key,g)}}))},revealRange(t,i){o.n(()=>k.$tryRevealRange(u,R.Range.from(t),i||T.TextEditorRevealType.Default))},show(t){k.$tryShowEditor(u,R.ViewColumn.from(t))},hide(){k.$tryHideEditor(u)}})}dispose(){(0,r.ok)(!this.g),this.g=!0}_acceptOptions(u){(0,r.ok)(!this.g),this.d._accept(u)}_acceptVisibleRanges(u){(0,r.ok)(!this.g),this.e=u}_acceptViewColumn(u){(0,r.ok)(!this.g),this.f=u}_acceptSelections(u){(0,r.ok)(!this.g),this.c=u}async l(){const u=this.c.map(R.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,u)),this.value}m(u){const k=u.finalize();if(k.edits.length===0&&!k.setEndOfLine)return Promise.resolve(!0);const p=k.edits.map(f=>f.range);p.sort((f,d)=>f.end.line===d.end.line?f.end.character===d.end.character?f.start.line===d.start.line?f.start.character-d.start.character:f.start.line-d.start.line:f.end.character-d.end.character:f.end.line-d.end.line);for(let f=0,d=p.length-1;f<d;f++){const m=p[f].end;if(p[f+1].start.isBefore(m))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const a=k.edits.map(f=>({range:R.Range.from(f.range),text:f.text,forceMoveMarkers:f.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,k.documentVersionId,a,{setEndOfLine:typeof k.setEndOfLine=="number"?R.EndOfLine.from(k.setEndOfLine):void 0,undoStopBefore:k.undoStopBefore,undoStopAfter:k.undoStopAfter})}n(u){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):u().then(()=>this,k=>(k instanceof Error&&k.name==="DISPOSED"||this.k.warn(k),null))}}e.$7P=I}),define(Ee[64],ye([1,0,66,4,3,2,5,6,163,20,167,17,12,29,15,40,49]),function(ce,e,r,h,P,R,T,N,$,c,I,E,u,k,p,a,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9P=e.$8P=void 0,r=We(r),E=We(E);class d{constructor(o){this.value=o,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let m=class{constructor(o,t){this.h=o,this.i=t,this.a=null,this.b=new Map,this.c=new k.$Cc,this.d=new h.$me,this.e=new h.$me,this.f=new h.$me,this.g=new h.$me,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(o){this.acceptDocumentsAndEditorsDelta(o)}acceptDocumentsAndEditorsDelta(o){const t=[],i=[],s=[];if(o.removedDocuments)for(const g of o.removedDocuments){const l=R.URI.revive(g),w=this.c.get(l);w?.unref()&&(this.c.delete(l),t.push(w.value))}if(o.addedDocuments)for(const g of o.addedDocuments){const l=R.URI.revive(g.uri);let w=this.c.get(l);if(w&&l.scheme!==p.Schemas.vscodeNotebookCell&&l.scheme!==p.Schemas.vscodeInteractiveInput)throw new Error(`document '${l} already exists!'`);w||(w=new d(new $.$1P(this.h.getProxy(N.$rN.MainThreadDocuments),l,g.lines,g.EOL,g.versionId,g.languageId,g.isDirty)),this.c.set(l,w),i.push(w.value)),w.ref()}if(o.removedEditors)for(const g of o.removedEditors){const l=this.b.get(g);this.b.delete(g),l&&s.push(l)}if(o.addedEditors)for(const g of o.addedEditors){const l=R.URI.revive(g.documentUri);r.ok(this.c.has(l),`document '${l}' does not exist`),r.ok(!this.b.has(g.id),`editor '${g.id}' already exists!`);const w=this.c.get(l).value,S=new I.$7P(g.id,this.h.getProxy(N.$rN.MainThreadTextEditors),this.i,new f.$X(()=>w.document),g.selections.map(E.Selection.to),g.options,g.visibleRanges.map(D=>E.Range.to(D)),typeof g.editorPosition=="number"?E.ViewColumn.to(g.editorPosition):void 0);this.b.set(g.id,S)}o.newActiveEditor!==void 0&&(r.ok(o.newActiveEditor===null||this.b.has(o.newActiveEditor),`active editor '${o.newActiveEditor}' does not exist`),this.a=o.newActiveEditor),(0,P.$Rc)(t),(0,P.$Rc)(s),o.removedDocuments&&this.e.fire(t),o.addedDocuments&&this.d.fire(i),(o.removedEditors||o.addedEditors)&&this.f.fire(this.allEditors().map(g=>g.value)),o.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(o){return this.c.get(o)?.value}allDocuments(){return a.Iterable.map(this.c.values(),o=>o.value)}getEditor(o){return this.b.get(o)}activeEditor(o){if(!this.a)return;const t=this.b.get(this.a);return o?t:t?.value}allEditors(){return[...this.b.values()]}};e.$8P=m,e.$8P=m=Je([Ge(0,c.$XP),Ge(1,u.$_j)],m),e.$9P=(0,T.$Fi)("IExtHostDocumentsAndEditors")}),define(Ee[99],ye([1,0,9,22,21,4,80,60,3,41,18,32,5,12,6,35,64,20,165,17,10,314,74,121,75,26]),function(ce,e,r,h,P,R,T,N,$,c,I,E,u,k,p,a,f,d,m,n,o,t,i,s,g,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3oc=e.$2oc=e.$1oc=e.$Zoc=e.$Yoc=void 0,n=We(n);let w=0;const S=new WeakMap;e.$Yoc=(0,u.$Fi)("IExtHostTesting");let D=class extends $.$Wc{constructor(U,G,Q,ee){super(),this.C=G,this.D=Q,this.F=ee,this.f=this.B(new R.$me),this.g=new Map,this.w=this.B(new R.$me),this.y=new Set,this.z=new Map,this.onResultsChanged=this.f.event,this.results=[],this.h=U.getProxy(p.$rN.MainThreadTesting),this.m=new j(this.h),this.j=new b(this.h,G),Q.registerArgumentProcessor({processArgument:he=>{switch(he?.$mid){case c.MarshalledId.TestItemContext:{const ne=he,De=ne.tests[ne.tests.length-1].item.extId;return this.g.get(i.$QI.root(De))?.collection.tree.get(De)?.actual??(0,m.$0P)(he)}case c.MarshalledId.TestMessageMenuArgs:{const{test:ne,message:De}=he,$e=ne.item.extId;return{test:this.g.get(i.$QI.root($e))?.collection.tree.get($e)?.actual??(0,m.$0P)({$mid:c.MarshalledId.TestItemContext,tests:[ne]}),message:n.TestMessage.to(De)}}default:return he}}}),Q.registerCommand(!1,"testing.getExplorerSelection",async()=>{const he=await Q.executeCommand(t.TestCommandId.GetExplorerSelection),ne=De=>{const $e=this.g.get(i.$QI.root(De));if($e)return i.$QI.isRoot(De)?$e.controller:$e.collection.tree.get(De)?.actual};return{include:he?.include.map(ne).filter(I.$ng)||[],exclude:he?.exclude.map(ne).filter(I.$ng)||[]}})}createTestController(U,G,Q,ee){if(this.g.has(G))throw new Error(`Attempt to insert a duplicate controller with ID "${G}"`);const he=new $.$Vc,ne=he.add(new m.$aQ(G,Q,this.F));ne.root.label=Q;const De=new Map,$e=new Set,K=this.h,W={items:ne.root.children,get label(){return Q},set label(oe){Q=oe,ne.root.label=oe,K.$updateController(G,{label:Q})},get refreshHandler(){return ee},set refreshHandler(oe){ee=oe,K.$updateController(G,{canRefresh:!!oe})},get id(){return G},createRunProfile:(oe,te,le,ue,X,ae)=>{let pe=(0,N.$tj)(oe);for(;De.has(pe);)pe++;return new F(this.h,De,$e,this.w.event,G,pe,oe,te,le,ue,X,ae)},createTestItem(oe,te,le){return new m.$$P(G,oe,te,le)},createTestRun:(oe,te,le=!0)=>this.j.createTestRun(U,G,ne,oe,te,le),invalidateTestResults:oe=>{if(oe===void 0)this.h.$markTestRetired(void 0);else{const te=oe instanceof Array?oe:[oe];this.h.$markTestRetired(te.map(le=>i.$QI.fromExtHostTestItem(le,G).toString()))}},set resolveHandler(oe){ne.resolveHandler=oe},get resolveHandler(){return ne.resolveHandler},dispose:()=>{he.dispose()}};K.$registerTestController(G,Q,!!ee),he.add((0,$.$Uc)(()=>K.$unregisterTestController(G)));const se={controller:W,collection:ne,profiles:De,extension:U,activeProfiles:$e};return this.g.set(G,se),he.add((0,$.$Uc)(()=>this.g.delete(G))),he.add(ne.onDidGenerateDiff(oe=>K.$publishDiff(G,oe.map(g.TestsDiffOp.serialize)))),W}createTestObserver(){return this.m.checkout()}async runTests(U,G=P.CancellationToken.None){const Q=v(U);if(!Q)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const ee=this.g.get(Q.controllerId);if(!ee)throw new Error("Controller not found");await this.h.$runTests({preserveFocus:U.preserveFocus??!0,group:B[Q.kind],targets:[{testIds:U.include?.map(he=>i.$QI.fromExtHostTestItem(he,ee.collection.root.id).toString())??[ee.collection.root.id],profileId:Q.profileId,controllerId:Q.controllerId}],exclude:U.exclude?.map(he=>he.id)},G)}registerTestFollowupProvider(U){return this.y.add(U),{dispose:()=>{this.y.delete(U)}}}$syncTests(){for(const{collection:U}of this.g.values())U.flushDiff();return Promise.resolve()}async $getCoverageDetails(U,G,Q){return(await this.j.getCoverageDetails(U,G,Q))?.map(n.TestCoverage.fromDetails)}async $disposeRun(U){this.j.disposeTestRun(U)}$configureRunProfile(U,G){this.g.get(U)?.profiles.get(G)?.configureHandler?.()}$setDefaultRunProfiles(U){const G=new Map;for(const[Q,ee]of Object.entries(U)){const he=this.g.get(Q);if(!he)continue;const ne=new Map,De=ee.filter(K=>!he.activeProfiles.has(K)),$e=[...he.activeProfiles].filter(K=>!ee.includes(K));for(const K of De)ne.set(K,!0),he.activeProfiles.add(K);for(const K of $e)ne.set(K,!1),he.activeProfiles.delete(K);ne.size&&G.set(Q,ne)}this.w.fire(G)}async $refreshTests(U,G){await this.g.get(U)?.controller.refreshHandler?.(G)}$publishTestResults(U){this.results=Object.freeze(U.map(G=>{const Q=n.TestResults.to(G);return S.set(Q,G.id),Q}).concat(this.results).sort((G,Q)=>Q.completedAt-G.completedAt).slice(0,32)),this.f.fire()}async $expandTest(U,G){const Q=this.g.get(i.$QI.fromString(U).controllerId)?.collection;Q&&(await Q.expand(U,G<0?1/0:G),Q.flushDiff())}$acceptDiff(U){this.m.applyDiff(U.map(G=>g.TestsDiffOp.deserialize({asCanonicalUri:Q=>Q},G)))}async $runControllerTests(U,G){return Promise.all(U.map(Q=>this.G(Q,!1,G)))}async $startContinuousRun(U,G){const Q=new P.$xe(G),ee=await Promise.all(U.map(he=>this.G(he,!0,Q.token)));return!G.isCancellationRequested&&!ee.some(he=>he.error)&&await new Promise(he=>G.onCancellationRequested(he)),Q.dispose(!0),ee}async $provideTestFollowups(U,G){const Q=this.results.find(ne=>S.get(ne)===U.resultId),ee=Q&&_(i.$QI.fromString(U.extId),Q?.results);if(!ee)return[];let he=[];return await Promise.all([...this.y].map(async ne=>{try{const De=await ne.provideFollowup(Q,ee,U.taskIndex,U.messageIndex,G);De&&(he=he.concat(De))}catch(De){this.C.error("Error thrown while providing followup for test message",De)}})),G.isCancellationRequested?[]:he.map(ne=>{const De=w++;return this.z.set(De,ne),{title:ne.title,id:De}})}$disposeTestFollowups(U){for(const G of U)this.z.delete(G)}$executeTestFollowup(U){const G=this.z.get(U);return G?this.D.executeCommand(G.command,...G.arguments||[]):Promise.resolve()}$cancelExtensionTestRun(U){U===void 0?this.j.cancelAllRuns():this.j.cancelRunById(U)}getMetadataForRun(U){for(const G of this.j.trackers){const Q=G.getTaskIdForRun(U);if(Q)return{taskId:Q,runId:G.id}}}async G(U,G,Q){const ee=this.g.get(U.controllerId);if(!ee)return{};const{collection:he,profiles:ne,extension:De}=ee,$e=ne.get(U.profileId);if(!$e)return{};const K=U.testIds.map(te=>he.tree.get(te)).filter(I.$ng),W=U.excludeExtIds.map(te=>ee.collection.tree.get(te)).filter(I.$ng).filter(te=>K.some(le=>le.fullId.compare(te.fullId)===i.TestPosition.IsChild));if(!K.length)return{};const se=new o.$7O(K.some(te=>te.actual instanceof m.$_P)?void 0:K.map(te=>te.actual),W.map(te=>te.actual),$e,G),oe=(0,g.$TI)(U)&&this.j.prepareForMainThreadTestRun(De,se,L.fromInternal(U,ee.collection),$e,Q);try{return await $e.runHandler(se,Q),{}}catch(te){return{error:String(te)}}finally{oe&&oe.hasRunningTasks&&!Q.isCancellationRequested&&await R.Event.toPromise(oe.onEnd)}}};e.$Zoc=D,e.$Zoc=D=Je([Ge(0,d.$XP),Ge(1,k.$_j),Ge(2,a.$hQ),Ge(3,f.$9P)],D);const y=1e4;var C;(function(re){re[re.Running=0]="Running",re[re.Cancelling=1]="Cancelling",re[re.Ended=2]="Ended"})(C||(C={}));class A extends $.$Wc{get hasRunningTasks(){return this.f>0}get id(){return this.z.id}constructor(U,G,Q,ee,he,ne){super(),this.z=U,this.C=G,this.D=Q,this.F=ee,this.G=he,this.c=C.Running,this.f=0,this.g=new Map,this.h=new Set,this.m=this.B(new R.$me),this.y=new Map,this.onEnd=this.m.event,this.j=this.B(new P.$xe(ne));const De=this.B(new r.$Rh(()=>this.H(),y));this.B(this.j.token.onCancellationRequested(()=>De.schedule()));const $e=new R.$me;this.w=$e.event,this.B((0,$.$Uc)(()=>{$e.fire(),$e.dispose()}))}getTaskIdForRun(U){for(const[G,{run:Q}]of this.g)if(Q===U)return G}cancel(){this.c===C.Running?(this.j.cancel(),this.c=C.Cancelling):this.c===C.Cancelling&&this.H()}async getCoverageDetails(U,G,Q){const[,ee]=i.$QI.fromString(U).path,he=this.y.get(U);if(!he)return[];const{report:ne,extIds:De}=he,$e=this.g.get(ee);if(!$e)throw new Error("unreachable: run task was not found");let K;if(G&&ne instanceof o.$_O){const se=De.indexOf(G);if(se===-1)return[];K=ne.fromTests[se]}return await(K?this.F?.loadDetailedCoverageForTest?.($e.run,ne,K,Q):this.F?.loadDetailedCoverage?.($e.run,ne,Q))??[]}createRun(U){const G=this.z.id,Q=this.z.controllerId,ee=(0,E.$2g)(),he=K=>(W,...se)=>{if(De){this.D.warn(`Setting the state of test "${W.id}" is a no-op after the run ends.`);return}this.J(W),K(W,...se)},ne=(K,W)=>{const se=W instanceof Array?W.map(n.TestMessage.from):[n.TestMessage.from(W)];if(K.uri&&K.range){const oe={range:n.Range.from(K.range),uri:K.uri};for(const te of se)te.location=te.location||oe}this.C.$appendTestMessagesInRun(G,ee,i.$QI.fromExtHostTestItem(K,Q).toString(),se)};let De=!1;const $e={isPersisted:this.z.isPersisted,token:this.j.token,name:U,onDidDispose:this.w,addCoverage:K=>{if(De)return;const W=K instanceof o.$_O?K.fromTests:[];if(W.length){(0,l.$4G)(this.G,"attributableCoverage");for(const te of W)this.J(te)}const se=K.uri.toString(),oe=new i.$QI([G,ee,se]).toString();this.y.set(oe,{report:K,extIds:W.map(te=>i.$QI.fromExtHostTestItem(te,Q).toString())}),this.C.$appendCoverage(G,ee,n.TestCoverage.fromFile(Q,oe,K))},enqueued:he(K=>{this.C.$updateTestStateInRun(G,ee,i.$QI.fromExtHostTestItem(K,Q).toString(),g.TestResultState.Queued)}),skipped:he(K=>{this.C.$updateTestStateInRun(G,ee,i.$QI.fromExtHostTestItem(K,Q).toString(),g.TestResultState.Skipped)}),started:he(K=>{this.C.$updateTestStateInRun(G,ee,i.$QI.fromExtHostTestItem(K,Q).toString(),g.TestResultState.Running)}),errored:he((K,W,se)=>{ne(K,W),this.C.$updateTestStateInRun(G,ee,i.$QI.fromExtHostTestItem(K,Q).toString(),g.TestResultState.Errored,se)}),failed:he((K,W,se)=>{ne(K,W),this.C.$updateTestStateInRun(G,ee,i.$QI.fromExtHostTestItem(K,Q).toString(),g.TestResultState.Failed,se)}),passed:he((K,W)=>{this.C.$updateTestStateInRun(G,ee,i.$QI.fromExtHostTestItem(K,this.z.controllerId).toString(),g.TestResultState.Passed,W)}),appendOutput:(K,W,se)=>{De||(se&&this.J(se),this.C.$appendOutputToRun(G,ee,h.$Oe.fromString(K),W&&n.location.from(W),se&&i.$QI.fromExtHostTestItem(se,Q).toString()))},end:()=>{De||(De=!0,this.C.$finishedTestRunTask(G,ee),--this.f||this.I())}};return this.f++,this.g.set(ee,{run:$e}),this.C.$startedTestRunTask(G,{id:ee,name:U,running:!0}),$e}H(){for(const{run:U}of this.g.values())U.end()}I(){this.c!==C.Ended&&(this.c=C.Ended,this.m.fire())}J(U){if(!(U instanceof m.$$P))throw new s.$PP(U.id);if(this.h.has(i.$QI.fromExtHostTestItem(U,this.z.controllerId).toString()))return;const G=[],Q=this.z.colllection.root;for(;;){const ee=n.TestItem.from(U);if(G.unshift(ee),this.h.has(ee.extId)||(this.h.add(ee.extId),U===Q))break;U=U.parent||Q}this.C.$addTestsToRun(this.z.controllerId,this.z.id,G)}dispose(){this.I(),super.dispose()}}class b{get trackers(){return this.c.values()}constructor(U,G){this.g=U,this.h=G,this.c=new Map,this.f=new Map}getCoverageDetails(U,G,Q){const ee=i.$QI.root(U);return this.f.get(ee)?.getCoverageDetails(U,G,Q)||[]}disposeTestRun(U){this.f.get(U)?.dispose(),this.f.delete(U);for(const[G,{id:Q}]of this.c)Q===U&&this.c.delete(G)}prepareForMainThreadTestRun(U,G,Q,ee,he){return this.j(G,Q,ee,U,he)}cancelRunById(U){this.f.get(U)?.cancel()}cancelAllRuns(){for(const U of this.c.values())U.cancel()}createTestRun(U,G,Q,ee,he,ne){const De=this.c.get(ee);if(De)return De.createRun(he);const $e=L.fromPublic(G,Q,ee,ne),K=v(ee);this.g.$startedExtensionTestRun({controllerId:G,continuous:!!ee.continuous,profile:K&&{group:B[K.kind],id:K.profileId},exclude:ee.exclude?.map(se=>i.$QI.fromExtHostTestItem(se,Q.root.id).toString())??[],id:$e.id,include:ee.include?.map(se=>i.$QI.fromExtHostTestItem(se,Q.root.id).toString())??[Q.root.id],preserveFocus:ee.preserveFocus??!0,persist:ne});const W=this.j(ee,$e,ee.profile,U);return R.Event.once(W.onEnd)(()=>{this.g.$finishedExtensionTestRun($e.id)}),W.createRun(he)}j(U,G,Q,ee,he){const ne=new A(G,this.g,this.h,Q,ee,he);return this.c.set(U,ne),this.f.set(ne.id,ne),ne}}e.$1oc=b;const v=re=>{if(re.profile){if(!(re.profile instanceof F))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return re.profile}};class L{static fromPublic(U,G,Q,ee){return new L(U,(0,E.$2g)(),ee,G)}static fromInternal(U,G){return new L(U.controllerId,U.runId,!0,G)}constructor(U,G,Q,ee){this.controllerId=U,this.id=G,this.isPersisted=Q,this.colllection=ee}}e.$2oc=L;class O{get isEmpty(){return this.c.size===0&&this.g.size===0&&this.f.size===0}constructor(U){this.j=U,this.c=new Set,this.f=new Set,this.g=new Set,this.h=new Set}add(U){this.c.add(U)}update(U){Object.assign(U.revived,n.TestItem.toPlain(U.item)),this.c.has(U)||this.f.add(U)}remove(U){if(this.c.has(U)){this.c.delete(U);return}this.f.delete(U);const G=i.$QI.parentId(U.item.extId);if(G&&this.h.has(G.toString())){this.h.add(U.item.extId);return}this.g.add(U)}getChangeEvent(){const{c:U,f:G,g:Q}=this;return{get added(){return[...U].map(ee=>ee.revived)},get updated(){return[...G].map(ee=>ee.revived)},get removed(){return[...Q].map(ee=>ee.revived)}}}complete(){this.isEmpty||this.j.fire(this.getChangeEvent())}}class M extends g.$ZI{constructor(){super(...arguments),this.y=new R.$me,this.onDidChangeTests=this.y.event}get rootTests(){return this.g}getMirroredTestDataById(U){return this.f.get(U)}getMirroredTestDataByReference(U){return this.f.get(U.id)}x(U,G){return{...U,revived:n.TestItem.toPlain(U.item),depth:G?G.depth+1:0,children:new Set}}w(){return new O(this.y)}}class j{constructor(U){this.f=U}checkout(){this.c||(this.c=this.g());const U=this.c;return U.observers++,{onDidChangeTest:U.tests.onDidChangeTests,get tests(){return[...U.tests.rootTests].map(G=>G.revived)},dispose:(0,T.$fb)(()=>{--U.observers===0&&(this.f.$unsubscribeFromDiffs(),this.c=void 0)})}}getMirroredTestDataByReference(U){return this.c?.tests.getMirroredTestDataByReference(U)}applyDiff(U){this.c?.tests.apply(U)}g(){const U=new M({asCanonicalUri:G=>G});return this.f.$subscribeToDiffs(),{observers:0,tests:U}}}const z=(re,U,G,Q)=>{G?Object.assign(G,Q):U.$updateTestRunConfig(re.controllerId,re.profileId,Q)};class F{#e;#t;#i;#n;#s;get label(){return this.f}set label(U){U!==this.f&&(this.f=U,z(this,this.#e,this.#n,{label:U}))}get supportsContinuousRun(){return this.g}set supportsContinuousRun(U){U!==this.g&&(this.g=U,z(this,this.#e,this.#n,{supportsContinuousRun:U}))}get isDefault(){return this.#t.has(this.profileId)}set isDefault(U){U!==this.isDefault&&(U?this.#t.add(this.profileId):this.#t.delete(this.profileId),z(this,this.#e,this.#n,{isDefault:U}))}get tag(){return this._tag}set tag(U){U?.id!==this._tag?.id&&(this._tag=U,z(this,this.#e,this.#n,{tag:U?n.TestTag.namespace(this.controllerId,U.id):null}))}get configureHandler(){return this.c}set configureHandler(U){U!==this.c&&(this.c=U,z(this,this.#e,this.#n,{hasConfigurationHandler:!!U}))}get onDidChangeDefault(){return R.Event.chain(this.#i,U=>U.map(G=>G.get(this.controllerId)?.get(this.profileId)).filter(I.$ng))}constructor(U,G,Q,ee,he,ne,De,$e,K,W=!1,se=void 0,oe=!1){this.controllerId=he,this.profileId=ne,this.f=De,this.kind=$e,this.runHandler=K,this._tag=se,this.g=oe,this.#e=U,this.#s=G,this.#t=Q,this.#i=ee,G.set(ne,this);const te=B[$e];if(typeof te!="number")throw new Error(`Unknown TestRunProfile.group ${$e}`);W&&Q.add(ne),this.#n={profileId:ne,controllerId:he,tag:se?n.TestTag.namespace(this.controllerId,se.id):null,label:De,group:te,isDefault:W,hasConfigurationHandler:!1,supportsContinuousRun:oe},queueMicrotask(()=>{this.#n&&(this.#e.$publishTestRunProfile(this.#n),this.#n=void 0)})}dispose(){this.#s?.delete(this.profileId)&&(this.#s=void 0,this.#e.$removeTestProfile(this.controllerId,this.profileId)),this.#n=void 0}}e.$3oc=F;const B={[o.TestRunProfileKind.Coverage]:g.TestRunProfileBitset.Coverage,[o.TestRunProfileKind.Debug]:g.TestRunProfileBitset.Debug,[o.TestRunProfileKind.Run]:g.TestRunProfileBitset.Run};function _(re,U){for(let G=0;G<re.path.length;G++){const Q=U.find(ee=>ee.id===re.path[G]);if(!Q)return;if(G===re.path.length-1)return Q;U=Q.children}}}),define(Ee[371],ye([1,0,19,4,3,6,167,17,10]),function(ce,e,r,h,P,R,T,N,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0nc=void 0,r=We(r),N=We(N);class c extends P.$Wc{constructor(E,u){super(),this.m=u,this.a=new h.$me,this.b=new h.$me,this.c=new h.$me,this.f=new h.$me,this.g=new h.$me,this.h=new h.$me,this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.f.event,this.onDidChangeActiveTextEditor=this.g.event,this.onDidChangeVisibleTextEditors=this.h.event,this.j=E.getProxy(R.$rN.MainThreadTextEditors),this.B(this.m.onDidChangeVisibleTextEditors(k=>this.h.fire(k))),this.B(this.m.onDidChangeActiveTextEditor(k=>this.g.fire(k)))}getActiveTextEditor(){return this.m.activeEditor()}getVisibleTextEditors(E){const u=this.m.allEditors();return E?u:u.map(k=>k.value)}async showTextDocument(E,u,k){let p;typeof u=="number"?p={position:N.ViewColumn.from(u),preserveFocus:k}:typeof u=="object"?p={position:N.ViewColumn.from(u.viewColumn),preserveFocus:u.preserveFocus,selection:typeof u.selection=="object"?N.Range.from(u.selection):void 0,pinned:typeof u.preview=="boolean"?!u.preview:void 0}:p={preserveFocus:!1};const a=await this.j.$tryShowTextDocument(E.uri,p),f=a&&this.m.getEditor(a);if(f)return f.value;throw a?new Error(`Could NOT open editor for "${E.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${E.uri.toString()}".`)}createTextEditorDecorationType(E,u){return new T.$5P(this.j,E,u).value}$acceptEditorPropertiesChanged(E,u){const k=this.m.getEditor(E);if(!k)throw new Error("unknown text editor");if(u.options&&k._acceptOptions(u.options),u.selections){const p=u.selections.selections.map(N.Selection.to);k._acceptSelections(p)}if(u.visibleRanges){const p=r.$Jb(u.visibleRanges.map(N.Range.to));k._acceptVisibleRanges(p)}if(u.options&&this.b.fire({textEditor:k.value,options:{...u.options,lineNumbers:N.TextEditorLineNumbersStyle.to(u.options.lineNumbers)}}),u.selections){const p=$.TextEditorSelectionChangeKind.fromValue(u.selections.source),a=u.selections.selections.map(N.Selection.to);this.a.fire({textEditor:k.value,selections:a,kind:p})}if(u.visibleRanges){const p=r.$Jb(u.visibleRanges.map(N.Range.to));this.c.fire({textEditor:k.value,visibleRanges:p})}}$acceptEditorPositionData(E){for(const u in E){const k=this.m.getEditor(u);if(!k)throw new Error("Unknown text editor");const p=N.ViewColumn.to(E[u]);k.value.viewColumn!==p&&(k._acceptViewColumn(p),this.f.fire({textEditor:k.value,viewColumn:p}))}}getDiffInformation(E){return Promise.resolve(this.j.$getDiffInformation(E))}}e.$0nc=c}),define(Ee[372],ye([1,0,2,5,6,3,10,17,24,41,18]),function(ce,e,r,h,P,R,T,N,$,c,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Upc=e.$Tpc=void 0,e.$Tpc=(0,h.$Fi)("IExtHostTimeline");class E{constructor(p,a){this.b=new Map,this.c=new Map,this.a=p.getProxy(P.$rN.MainThreadTimeline),a.registerArgumentProcessor({processArgument:(f,d)=>{if(f&&f.$mid===c.MarshalledId.TimelineActionContext)if(this.b.get(f.source)&&$.$qn.equals(d,this.b.get(f.source)?.extension)){const m=f.uri===void 0?void 0:r.URI.revive(f.uri);return this.c.get(f.source)?.get(u(m))?.get(f.handle)}else return;return f}})}async $getTimeline(p,a,f,d){return this.b.get(p)?.provider.provideTimeline(r.URI.revive(a),f,d)}registerTimelineProvider(p,a,f,d){const m=new R.$Vc,n=this.d(a.id,d,m).bind(this);let o;a.onDidChange&&(o=a.onDidChange(i=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...i,id:a.id}),this));const t=this.c;return this.f({...a,scheme:p,onDidChange:void 0,async provideTimeline(i,s,g){s?.resetCache&&(m.clear(),t.get(a.id)?.clear());const l=await a.provideTimeline(i,s,g);if(l==null)return;const w=n(i,s);return{...l,source:a.id,items:l.items.map(w)}},dispose(){for(const i of t.values())i.get(a.id)?.clear();o?.dispose(),m.dispose()}},f)}d(p,a,f){return(d,m)=>{let n;if(m?.cacheResults){let o=this.c.get(p);o===void 0&&(o=new Map,this.c.set(p,o));const t=u(d);n=o.get(t),n===void 0&&(n=new Map,o.set(t,n))}return o=>{const{iconPath:t,...i}=o,s=`${p}|${o.id??o.timestamp}`;n?.set(s,o);let g,l,w;o.iconPath&&(t instanceof T.$qO?w={id:t.id,color:t.color}:r.URI.isUri(t)?(g=t,l=t):{light:g,dark:l}=t);let S;return T.$VN.isMarkdownString(i.tooltip)?S=N.MarkdownString.from(i.tooltip):(0,I.$fg)(i.tooltip)?S=i.tooltip:T.$VN.isMarkdownString(i.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),S=N.MarkdownString.from(i.detail)):(0,I.$fg)(i.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),S=i.detail),{...i,id:i.id??void 0,handle:s,source:p,command:o.command?a.toInternal(o.command,f):void 0,icon:g,iconDark:l,themeIcon:w,tooltip:S,accessibilityInformation:o.accessibilityInformation}}}}f(p,a){if(this.b.get(p.id))throw new Error(`Timeline Provider ${p.id} already exists.`);return this.a.$registerTimelineProvider({id:p.id,label:p.label,scheme:p.scheme}),this.b.set(p.id,{provider:p,extension:a}),(0,R.$Uc)(()=>{for(const d of this.c.values())d.get(p.id)?.clear();this.b.delete(p.id),this.a.$unregisterTimelineProvider(p.id),p.dispose()})}}e.$Upc=E;function u(k){return k?.toString()}}),define(Ee[373],ye([1,0,242,23,2,4,3,304,9,10,18,19,17,86,21,198,26]),function(ce,e,r,h,P,R,T,N,$,c,I,E,u,k,p,a,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vpc=void 0,c=We(c);function d(o,t){if((0,I.$fg)(o))return{label:o};if(o&&typeof o=="object"&&typeof o.label=="string"){let i;return Array.isArray(o.highlights)&&(i=o.highlights.filter(s=>s.length===2&&typeof s[0]=="number"&&typeof s[1]=="number"),i=i.length?i:void 0),{label:o.label,highlights:i}}}class m extends T.$Wc{constructor(t,i,s){super(),this.f=t,this.g=i,this.h=s,this.a=new Map,this.b=new a.$r_;function g(l){return l&&l.$treeViewId&&(l.$treeItemHandle||l.$selectedTreeItems||l.$focusedTreeItem)}i.registerArgumentProcessor({processArgument:l=>g(l)?this.r(l):Array.isArray(l)&&l.length>0?l.map(w=>g(w)?this.r(w):w):l})}registerTreeDataProvider(t,i,s){const g=this.createTreeView(t,{treeDataProvider:i},s);return{dispose:()=>g.dispose()}}createTreeView(t,i,s){if(!i||!i.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const g=i.dragAndDropController?.dropMimeTypes??[],l=i.dragAndDropController?.dragMimeTypes??[],w=!!i.dragAndDropController?.handleDrag,S=!!i.dragAndDropController?.handleDrop,D=this.m(t,i,s),y={showCollapseAll:!!i.showCollapseAll,canSelectMany:!!i.canSelectMany,dropMimeTypes:g,dragMimeTypes:l,hasHandleDrag:w,hasHandleDrop:S,manuallyManageCheckboxes:!!i.manageCheckboxStateManually},C=this.f.$registerTreeViewDataProvider(t,y),A={get onDidCollapseElement(){return D.onDidCollapseElement},get onDidExpandElement(){return D.onDidExpandElement},get selection(){return D.selectedElements},get onDidChangeSelection(){return D.onDidChangeSelection},get activeItem(){return(0,f.$4G)(s,"treeViewActiveItem"),D.focusedElement},get onDidChangeActiveItem(){return(0,f.$4G)(s,"treeViewActiveItem"),D.onDidChangeActiveItem},get visible(){return D.visible},get onDidChangeVisibility(){return D.onDidChangeVisibility},get onDidChangeCheckboxState(){return D.onDidChangeCheckboxState},get message(){return D.message},set message(b){(0,k.$5k)(b)&&(0,f.$4G)(s,"treeViewMarkdownMessage"),D.message=b},get title(){return D.title},set title(b){D.title=b},get description(){return D.description},set description(b){D.description=b},get badge(){return D.badge},set badge(b){b!==void 0&&c.ViewBadge.isViewBadge(b)?D.badge={value:Math.floor(Math.abs(b.value)),tooltip:b.tooltip}:b===void 0&&(D.badge=void 0)},reveal:(b,v)=>D.reveal(b,v),dispose:async()=>{await C,this.a.delete(t),D.dispose()}};return this.B(A),A}$getChildren(t,i){const s=this.a.get(t);return s?s.getChildren(i):Promise.reject(new N.$mG(t))}async $handleDrop(t,i,s,g,l,w,S,D){const y=this.a.get(t);if(!y)return Promise.reject(new N.$mG(t));const C=u.DataTransfer.toDataTransfer(s,async A=>(await this.f.$resolveDropFileData(t,i,A)).buffer);return S===t&&D&&await this.j(C,y,D,l,w),y.onDrop(C,g,l)}async j(t,i,s,g,l){const w=this.b.removeDragOperationTransfer(l);if(w)(await w)?.forEach((S,D)=>{S&&t.set(D,S)});else if(l&&i.handleDrag){const S=i.handleDrag(s,t,g);this.b.addDragOperationTransfer(l,S),await S}return t}async $handleDrag(t,i,s,g){const l=this.a.get(t);if(!l)return Promise.reject(new N.$mG(t));const w=await this.j(new c.$mO,l,i,g,s);if(!(!w||g.isCancellationRequested))return u.DataTransfer.from(w)}async $hasResolve(t){const i=this.a.get(t);if(!i)throw new N.$mG(t);return i.hasResolve}$resolve(t,i,s){const g=this.a.get(t);if(!g)throw new N.$mG(t);return g.resolveTreeItem(i,s)}$setExpanded(t,i,s){const g=this.a.get(t);if(!g)throw new N.$mG(t);g.setExpanded(i,s)}$setSelectionAndFocus(t,i,s){const g=this.a.get(t);if(!g)throw new N.$mG(t);g.setSelectionAndFocus(i,s)}$setVisible(t,i){const s=this.a.get(t);if(!s){if(!i)return;throw new N.$mG(t)}s.setVisible(i)}$changeCheckboxState(t,i){const s=this.a.get(t);if(!s)throw new N.$mG(t);s.setCheckboxState(i)}m(t,i,s){const g=this.B(new n(t,i,this.f,this.g.converter,this.h,s));return this.a.set(t,g),g}r(t){const i=this.a.get(t.$treeViewId);return i&&"$treeItemHandle"in t?i.getExtensionElement(t.$treeItemHandle):i&&"$focusedTreeItem"in t&&t.$focusedTreeItem?i.focusedElement:null}}e.$Vpc=m;class n extends T.$Wc{static{this.a="0"}static{this.b="1"}get visible(){return this.r}get selectedElements(){return this.s.map(t=>this.getExtensionElement(t)).filter(t=>!(0,I.$og)(t))}get focusedElement(){return this.t?this.getExtensionElement(this.t):void 0}constructor(t,i,s,g,l,w){if(super(),this.I=t,this.J=s,this.L=g,this.M=l,this.N=w,this.h=void 0,this.j=new Map,this.m=new Map,this.r=!1,this.s=[],this.t=void 0,this.u=this.B(new R.$me),this.onDidExpandElement=this.u.event,this.w=this.B(new R.$me),this.onDidCollapseElement=this.w.event,this.y=this.B(new R.$me),this.onDidChangeSelection=this.y.event,this.z=this.B(new R.$me),this.onDidChangeActiveItem=this.z.event,this.C=this.B(new R.$me),this.onDidChangeVisibility=this.C.event,this.D=this.B(new R.$me),this.onDidChangeCheckboxState=this.D.event,this.F=this.B(new R.$me),this.G=Promise.resolve(),this.H=Promise.resolve(),this.O="",this.P="",this.Z=new p.$xe,w.contributes&&w.contributes.views)for(const C in w.contributes.views)for(const A of w.contributes.views[C])A.id===t&&(this.P=A.name);this.f=i.treeDataProvider,this.g=i.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData(C=>{Array.isArray(C)&&C.length===0||this.F.fire({message:!1,element:C})}));let S,D;const y=R.Event.debounce(this.F.event,(C,A)=>(C||(C={message:!1,elements:[]}),A.element!==!1&&(S||(S=new Promise(b=>D=b),this.G=this.G.then(()=>S)),Array.isArray(A.element)?C.elements.push(...A.element):C.elements.push(A.element)),A.message&&(C.message=!0),C),200,!0);this.B(y(({message:C,elements:A})=>{A.length&&(this.H=this.H.then(()=>{const b=D;return S=null,this.$(A).then(()=>b())})),C&&this.J.$setMessage(this.I,u.MarkdownString.fromStrict(this.O)??"")}))}async getChildren(t){const i=t?this.getExtensionElement(t):void 0;if(t&&!i)return this.M.error(`No tree item with id '${t}' found.`),Promise.resolve([]);let s=this.X(t);return s||(s=await this.Y(i)),s?s.map(g=>g.item):void 0}getExtensionElement(t){return this.j.get(t)}reveal(t,i){i=i||{select:!0,focus:!1};const s=(0,I.$og)(i.select)?!0:i.select,g=(0,I.$og)(i.focus)?!1:i.focus,l=(0,I.$og)(i.expand)?!1:i.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):t?this.G.then(()=>this.S(t)).then(w=>this.W(t,w[w.length-1]).then(S=>this.J.$reveal(this.I,{item:S.item,parentChain:w.map(D=>D.item)},{select:s,focus:g,expand:l})),w=>this.M.error(w)):this.J.$reveal(this.I,void 0,{select:s,focus:g,expand:l})}get message(){return this.O}set message(t){this.O=t,this.F.fire({message:!0,element:!1})}get title(){return this.P}set title(t){this.P=t,this.J.$setTitle(this.I,t,this.Q)}get description(){return this.Q}set description(t){this.Q=t,this.J.$setTitle(this.I,this.P,t)}get badge(){return this.R}set badge(t){this.R?.value===t?.value&&this.R?.tooltip===t?.tooltip||(this.R=u.ViewBadge.from(t),this.J.$setBadge(this.I,t))}setExpanded(t,i){const s=this.getExtensionElement(t);s&&(i?this.u.fire(Object.freeze({element:s})):this.w.fire(Object.freeze({element:s})))}setSelectionAndFocus(t,i){const s=!(0,E.$wb)(this.s,t);this.s=t;const g=this.t!==i;this.t=i,s&&this.y.fire(Object.freeze({selection:this.selectedElements})),g&&this.z.fire(Object.freeze({activeItem:this.focusedElement}))}setVisible(t){t!==this.r&&(this.r=t,this.C.fire(Object.freeze({visible:this.r})))}async setCheckboxState(t){const i=(await Promise.all(t.map(async s=>{const g=this.getExtensionElement(s.treeItemHandle);return g?{extensionItem:g,treeItem:await this.f.getTreeItem(g),newState:s.newState?c.TreeItemCheckboxState.Checked:c.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(s=>s!==void 0);i.forEach(s=>{s.treeItem.checkboxState=s.newState?c.TreeItemCheckboxState.Checked:c.TreeItemCheckboxState.Unchecked}),this.D.fire({items:i.map(s=>[s.extensionItem,s.newState])})}async handleDrag(t,i,s){const g=[];for(const l of t){const w=this.getExtensionElement(l);w&&g.push(w)}if(!(!this.g?.handleDrag||g.length===0))return await this.g.handleDrag(g,i,s),i}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(t,i,s){const g=i?this.getExtensionElement(i):void 0;if(!(!g&&i||!this.g?.handleDrop))return(0,$.$xh)(()=>this.g?.handleDrop?this.g.handleDrop(g,t,s):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(t,i){if(!this.f.resolveTreeItem)return;const s=this.j.get(t);if(s){const g=this.m.get(s);if(g){const l=await this.f.resolveTreeItem(g.extensionItem,s,i)??g.extensionItem;return this.hb(l),g.item.tooltip=this.eb(l.tooltip),g.item.command=this.fb(g.disposableStore,l.command),g.item}}}S(t){return this.U(t).then(i=>i?this.S(i).then(s=>this.W(i,s[s.length-1]).then(g=>(s.push(g),s))):Promise.resolve([]))}U(t){const i=this.m.get(t);return i?Promise.resolve(i.parent?this.j.get(i.parent.item.handle):void 0):(0,$.$xh)(()=>this.f.getParent(t))}W(t,i){const s=this.m.get(t);return s?Promise.resolve(s):(0,$.$xh)(()=>this.f.getTreeItem(t)).then(g=>this.kb(t,g,i,!0)).then(g=>this.getChildren(i?i.item.handle:void 0).then(()=>{const l=this.getExtensionElement(g);if(l){const w=this.m.get(l);if(w)return Promise.resolve(w)}throw new Error(`Cannot resolve tree item for element ${g} from extension ${this.N.identifier.value}`)}))}X(t){if(t){let i;if(typeof t=="string"){const s=this.getExtensionElement(t);i=s?this.m.get(s):void 0}else i=t;return i&&i.children||void 0}return this.h}async Y(t){this.rb(t);const i=new p.$xe(this.Z.token);try{const s=t?this.m.get(t):void 0,g=await this.f.getChildren(t);if(i.token.isCancellationRequested)return;const l=(0,E.$Jb)(g||[]),w=await Promise.all((0,E.$Jb)(l).map(D=>this.f.getTreeItem(D)));if(i.token.isCancellationRequested)return;const S=w.map((D,y)=>D?this.db(l[y],D,s):null);return(0,E.$Jb)(S)}finally{i.dispose()}}$(t){if(t.some(s=>!s))return this.Z.dispose(!0),this.Z=new p.$xe,this.tb(),this.J.$refresh(this.I);{const s=this.ab(t);if(s.length)return this.bb(s)}return Promise.resolve(void 0)}ab(t){const i=new Set,s=t.map(l=>this.m.get(l));for(const l of s)if(l&&!i.has(l.item.handle)){let w=l;for(;w&&w.parent&&s.findIndex(S=>w&&w.parent&&S&&S.item.handle===w.parent.item.handle)===-1;){const S=this.j.get(w.parent.item.handle);w=S?this.m.get(S):void 0}w&&!w.parent&&i.add(l.item.handle)}const g=[];return i.forEach(l=>{const w=this.j.get(l);if(w){const S=this.m.get(w);S&&(!S.parent||!i.has(S.parent.item.handle))&&g.push(l)}}),g}bb(t){const i={};return Promise.all(t.map(s=>this.cb(s).then(g=>{g&&(i[s]=g.item)}))).then(()=>Object.keys(i).length?this.J.$refresh(this.I,i):void 0)}cb(t){const i=this.getExtensionElement(t);if(i){const s=this.m.get(i);if(s)return this.rb(i),(0,$.$xh)(()=>this.f.getTreeItem(i)).then(g=>{if(g){const l=this.ib(i,g,s.parent);return this.pb(i,l,s,s.parent),s.dispose(),l}return null})}return Promise.resolve(null)}db(t,i,s){const g=this.ib(t,i,s);if(i.id&&this.j.has(g.item.handle))throw new Error((0,r.localize)(0,null,i.id));return this.ob(t,g),this.qb(g,s),g}eb(t){return c.$VN.isMarkdownString(t)?u.MarkdownString.from(t):t}fb(t,i){return i?{...this.L.toInternal(i,t),originalId:i.command}:void 0}gb(t){if(t.checkboxState===void 0)return;let i,s,g;return typeof t.checkboxState=="number"?i=t.checkboxState:(i=t.checkboxState.state,s=t.checkboxState.tooltip,g=t.checkboxState.accessibilityInformation),{isChecked:i===c.TreeItemCheckboxState.Checked,tooltip:s,accessibilityInformation:g}}hb(t){if(!c.$hO.isTreeItem(t,this.N))throw new Error(`Extension ${this.N.identifier.value} has provided an invalid tree item.`)}ib(t,i,s){this.hb(i);const g=this.B(new T.$Vc),l=this.kb(t,i,s),w=this.lb(i);return{item:{handle:l,parentHandle:s?s.item.handle:void 0,label:d(i.label,this.N),description:i.description,resourceUri:i.resourceUri,tooltip:this.eb(i.tooltip),command:this.fb(g,i.command),contextValue:i.contextValue,icon:w,iconDark:this.mb(i)||w,themeIcon:this.jb(i),collapsibleState:(0,I.$og)(i.collapsibleState)?c.TreeItemCollapsibleState.None:i.collapsibleState,accessibilityInformation:i.accessibilityInformation,checkbox:this.gb(i)},extensionItem:i,parent:s,children:void 0,disposableStore:g,dispose(){g.dispose()}}}jb(t){return t.iconPath instanceof c.$qO?t.iconPath:void 0}kb(t,{id:i,label:s,resourceUri:g},l,w){if(i)return`${n.b}/${i}`;const S=d(s,this.N),D=l?l.item.handle:n.a;let y=S?S.label:g?(0,h.$dh)(g):"";y=y.indexOf("/")!==-1?y.replace("/","//"):y;const C=this.m.has(t)?this.m.get(t).item.handle:void 0,A=this.X(l)||[];let b,v=0;do{if(b=`${D}/${v}:${y}`,w||!this.j.has(b)||C===b)break;v++}while(v<=A.length);return b}lb(t){if(t.iconPath&&!(t.iconPath instanceof c.$qO))return typeof t.iconPath=="string"||P.URI.isUri(t.iconPath)?this.nb(t.iconPath):this.nb(t.iconPath.light)}mb(t){if(t.iconPath&&!(t.iconPath instanceof c.$qO)&&t.iconPath.dark)return this.nb(t.iconPath.dark)}nb(t){return P.URI.isUri(t)?t:P.URI.file(t)}ob(t,i){this.j.set(i.item.handle,t),this.m.set(t,i)}pb(t,i,s,g){this.j.delete(i.item.handle),this.m.delete(t),i.item.handle!==s.item.handle&&this.j.delete(s.item.handle),this.ob(t,i);const l=this.X(g)||[],w=l.filter(S=>S.item.handle===s.item.handle)[0];w&&l.splice(l.indexOf(w),1,i)}qb(t,i){i?(i.children||(i.children=[]),i.children.push(t)):(this.h||(this.h=[]),this.h.push(t))}rb(t){if(t){const i=this.m.get(t);if(i){if(i.children)for(const s of i.children){const g=this.j.get(s.item.handle);g&&this.sb(g)}i.children=void 0}}else this.tb()}sb(t){const i=this.m.get(t);if(i){if(i.children)for(const s of i.children){const g=this.j.get(s.item.handle);g&&this.sb(g)}this.m.delete(t),this.j.delete(i.item.handle),i.dispose()}}tb(){this.h=void 0,this.j.clear(),this.m.forEach(t=>t.dispose()),this.m.clear()}dispose(){super.dispose(),this.Z.dispose(),this.tb(),this.J.$disposeTree(this.I)}}}),define(Ee[374],ye([1,0,4,3,2,32,17,97,6,10]),function(ce,e,r,h,P,R,T,N,$,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qoc=void 0,T=We(T),$=We($),c=We(c);class I extends h.$Wc{#e;#t;#i;#n;#s;#r;#a;#o;#c;#l;#u;#d;#h;constructor(p,a,f,d){super(),this.#o=void 0,this.#c=!0,this.#u=!1,this.#d=this.B(new r.$me),this.onDidDispose=this.#d.event,this.#h=this.B(new r.$me),this.onDidChangeViewState=this.#h.event,this.#e=p,this.#t=a,this.#n=f,this.#i=d.viewType,this.#s=d.panelOptions,this.#o=d.viewColumn,this.#r=d.title,this.#l=d.active}dispose(){this.#u||(this.#u=!0,this.#d.fire(),this.#t.$disposeWebview(this.#e),this.#n.dispose(),super.dispose())}get webview(){return this.c(),this.#n}get viewType(){return this.c(),this.#i}get title(){return this.c(),this.#r}set title(p){this.c(),this.#r!==p&&(this.#r=p,this.#t.$setTitle(this.#e,p))}get iconPath(){return this.c(),this.#a}set iconPath(p){this.c(),this.#a!==p&&(this.#a=p,this.#t.$setIconPath(this.#e,P.URI.isUri(p)?{light:p,dark:p}:p))}get options(){return this.#s}get viewColumn(){if(this.c(),!(typeof this.#o=="number"&&this.#o<0))return this.#o}get active(){return this.c(),this.#l}get visible(){return this.c(),this.#c}_updateViewState(p){this.#u||(this.active!==p.active||this.visible!==p.visible||this.viewColumn!==p.viewColumn)&&(this.#l=p.active,this.#c=p.visible,this.#o=p.viewColumn,this.#h.fire({webviewPanel:this}))}reveal(p,a){this.c(),this.#t.$reveal(this.#e,{viewColumn:typeof p>"u"?void 0:T.ViewColumn.from(p),preserveFocus:!!a})}c(){if(this.#u)throw new Error("Webview is disposed")}}class E extends h.$Wc{static c(){return(0,R.$2g)()}constructor(p,a,f){super(),this.j=a,this.m=f,this.g=new Map,this.h=new Map,this.f=p.getProxy($.$rN.MainThreadWebviewPanels)}dispose(){super.dispose(),this.g.forEach(p=>p.dispose()),this.g.clear()}createWebviewPanel(p,a,f,d,m={}){const n=typeof d=="object"?d.viewColumn:d,o={viewColumn:T.ViewColumn.from(n),preserveFocus:typeof d=="object"&&!!d.preserveFocus},t=(0,N.$moc)(p),i=E.c();this.f.$createWebviewPanel((0,N.$ooc)(p),i,a,{title:f,panelOptions:u(m),webviewOptions:(0,N.$poc)(p,this.m,m),serializeBuffersForPostMessage:t},o);const s=this.j.createNewWebview(i,m,p);return this.createNewWebviewPanel(i,a,f,n,m,s,!0)}$onDidChangeWebviewPanelViewStates(p){const a=Object.keys(p);a.sort((f,d)=>{const m=p[f],n=p[d];return m.active?1:n.active?-1:+m.visible-+n.visible});for(const f of a){const d=this.getWebviewPanel(f);if(!d)continue;const m=p[f];d._updateViewState({active:m.active,visible:m.visible,viewColumn:T.ViewColumn.to(m.position)})}}async $onDidDisposeWebviewPanel(p){this.getWebviewPanel(p)?.dispose(),this.g.delete(p),this.j.deleteWebview(p)}registerWebviewPanelSerializer(p,a,f){if(this.h.has(a))throw new Error(`Serializer for '${a}' already registered`);return this.h.set(a,{serializer:f,extension:p}),this.f.$registerSerializer(a,{serializeBuffersForPostMessage:(0,N.$moc)(p)}),new c.$tN(()=>{this.h.delete(a),this.f.$unregisterSerializer(a)})}async $deserializeWebviewPanel(p,a,f,d){const m=this.h.get(a);if(!m)throw new Error(`No serializer found for '${a}'`);const{serializer:n,extension:o}=m,t=this.j.createNewWebview(p,f.webviewOptions,o),i=this.createNewWebviewPanel(p,a,f.title,d,f.panelOptions,t,f.active);await n.deserializeWebviewPanel(i,f.state)}createNewWebviewPanel(p,a,f,d,m,n,o){const t=new I(p,this.f,n,{viewType:a,title:f,viewColumn:d,panelOptions:m,active:o});return this.g.set(p,t),t}getWebviewPanel(p){return this.g.get(p)}}e.$qoc=E;function u(k){return{enableFindWidget:k.enableFindWidget,retainContextWhenHidden:k.retainContextWhenHidden}}}),define(Ee[375],ye([1,0,4,3,97,17,6,10]),function(ce,e,r,h,P,R,T,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ypc=void 0,T=We(T),N=We(N);class $ extends h.$Wc{#e;#t;#i;#n;#s;#r;#a;#o;#c;constructor(E,u,k,p,a,f){super(),this.#s=!1,this.#l=this.B(new r.$me),this.onDidChangeVisibility=this.#l.event,this.#u=this.B(new r.$me),this.onDidDispose=this.#u.event,this.#i=k,this.#a=p,this.#e=E,this.#t=u,this.#n=a,this.#r=f}dispose(){this.#s||(this.#s=!0,this.#u.fire(),this.#n.dispose(),super.dispose())}#l;#u;get title(){return this.a(),this.#a}set title(E){this.a(),this.#a!==E&&(this.#a=E,this.#t.$setWebviewViewTitle(this.#e,E))}get description(){return this.a(),this.#o}set description(E){this.a(),this.#o!==E&&(this.#o=E,this.#t.$setWebviewViewDescription(this.#e,E))}get visible(){return this.#r}get webview(){return this.#n}get viewType(){return this.#i}_setVisible(E){E===this.#r||this.#s||(this.#r=E,this.#l.fire())}get badge(){return this.a(),this.#c}set badge(E){this.a(),!(E?.value===this.#c?.value&&E?.tooltip===this.#c?.tooltip)&&(this.#c=R.ViewBadge.from(E),this.#t.$setWebviewViewBadge(this.#e,E))}show(E){this.a(),this.#t.$show(this.#e,!!E)}a(){if(this.#s)throw new Error("Webview is disposed")}}class c{constructor(E,u){this.d=u,this.b=new Map,this.c=new Map,this.a=E.getProxy(T.$rN.MainThreadWebviewViews)}registerWebviewViewProvider(E,u,k,p){if(this.b.has(u))throw new Error(`View provider for '${u}' already registered`);return this.b.set(u,{provider:k,extension:E}),this.a.$registerWebviewViewProvider((0,P.$ooc)(E),u,{retainContextWhenHidden:p?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,P.$moc)(E)}),new N.$tN(()=>{this.b.delete(u),this.a.$unregisterWebviewViewProvider(u)})}async $resolveWebviewView(E,u,k,p,a){const f=this.b.get(u);if(!f)throw new Error(`No view provider found for '${u}'`);const{provider:d,extension:m}=f,n=this.d.createNewWebview(E,{},m),o=new $(E,this.a,u,k,n,!0);this.c.set(E,o),await d.resolveWebviewView(o,{state:p},a)}async $onDidChangeWebviewViewVisibility(E,u){this.e(E)._setVisible(u)}async $disposeWebviewView(E){const u=this.e(E);this.c.delete(E),u.dispose(),this.d.deleteWebview(E)}e(E){const u=this.c.get(E);if(!u)throw new Error("No webview found");return u}}e.$Ypc=c}),define(Ee[376],ye([1,0,76,15,12,277,28,11]),function(ce,e,r,h,P,R,T,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eqc=void 0;let $=class{constructor(E,u){E.addFileSystemProvider(h.Schemas.file,new c(u),{isCaseSensitive:N.$k})}};e.$Eqc=$,e.$Eqc=$=Je([Ge(0,r.$ioc),Ge(1,P.$_j)],$);class c{constructor(E){this.b=E,this.a=new R.$mr(this.b)}async stat(E){const u=await this.a.stat(E);return{type:u.type,ctime:u.ctime,mtime:u.mtime,size:u.size,permissions:u.permissions===T.FilePermission.Readonly?1:void 0}}readDirectory(E){return this.a.readdir(E)}createDirectory(E){return this.a.mkdir(E)}readFile(E){return this.a.readFile(E)}writeFile(E,u,k){return this.a.writeFile(E,u,{...k,unlock:!1,atomic:!1})}delete(E,u){return this.a.delete(E,{...u,useTrash:!1,atomic:!1})}rename(E,u,k){return this.a.rename(E,u,k)}copy(E,u,k){return this.a.copy(E,u,k)}get onDidChangeFile(){throw new Error("Method not implemented.")}watch(E,u){throw new Error("Method not implemented.")}}}),define(Ee[377],ye([1,0,16,68,32,35,3,6,2,20]),function(ce,e,r,h,P,R,T,N,$,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cqc=void 0;let I=class extends T.$Wc{constructor(u,k){super();const p=u.getProxy(N.$rN.MainThreadDownloadService);k.registerCommand(!1,"_workbench.downloadResource",async a=>{const f=$.URI.file((0,r.$lc)((0,h.tmpdir)(),(0,P.$2g)()));return await p.$download(a,f),f})}};e.$Cqc=I,e.$Cqc=I=Je([Ge(0,c.$XP),Ge(1,R.$hQ)],I)}),define(Ee[378],ye([1,0,61,16,2,98,3,15,9,34]),function(ce,e,r,h,P,R,T,N,$,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oqc=void 0,r=We(r),h=We(h);class I extends R.$koc{constructor(){super(...arguments),this.i=null}async g(i){const s=await super.g(i);if(s.scheme!==N.Schemas.file)return s;if(this.b.skipWorkspaceStorageLock)return this.d.info(`Skipping acquiring lock for ${s.fsPath}.`),s;const g=s.fsPath;let l=0;do{let w;l===0?w=g:w=/[/\\]$/.test(g)?`${g.substr(0,g.length-1)}-${l}`:`${g}-${l}`,await E(w);const S=h.$lc(w,"vscode.lock"),D=await a(this.d,S,!1);if(D)return this.i=D,process.on("exit",()=>{D.dispose()}),P.URI.file(w);l++}while(l<10);return s}onWillDeactivateAll(){this.i?.setWillRelease(6e3)}}e.$Oqc=I;async function E(t){try{await c.Promises.stat(t);return}catch{}try{await c.Promises.mkdir(t,{recursive:!0})}catch{}}const u=1e3,k=10*60*1e3;class p extends T.$Wc{constructor(i,s){super(),this.b=i,this.c=s,this.a=this.B(new $.$Qh),this.a.cancelAndSet(async()=>{const g=await f(i,s);(!g||g.pid!==process.pid)&&(i.info(`Lock '${s}': The lock was lost unexpectedly.`),this.a.cancel());try{await c.Promises.utimes(s,new Date,new Date)}catch(l){i.error(l),i.info(`Lock '${s}': Could not update mtime.`)}},u)}dispose(){super.dispose();try{r.unlinkSync(this.c)}catch{}}async setWillRelease(i){this.b.info(`Lock '${this.c}': Marking the lockfile as scheduled to be released in ${i} ms.`);try{const s={pid:process.pid,willReleaseAt:Date.now()+i};await c.Promises.writeFile(this.c,JSON.stringify(s),{flag:"w"})}catch(s){this.b.error(s)}}}async function a(t,i,s){try{const l={pid:process.pid,willReleaseAt:0};await c.Promises.writeFile(i,JSON.stringify(l),{flag:"wx"})}catch(l){t.error(l)}const g=await f(t,i);return!g||g.pid!==process.pid?s?(t.info(`Lock '${i}': Could not acquire lock, giving up.`),null):(t.info(`Lock '${i}': Could not acquire lock, checking if the file is stale.`),n(t,i)):(t.info(`Lock '${i}': Lock acquired.`),new p(t,i))}async function f(t,i){let s;try{s=await c.Promises.readFile(i)}catch(g){return t.error(g),null}try{return JSON.parse(String(s))}catch(g){return t.error(g),null}}async function d(t,i){let s;try{s=await c.Promises.stat(i)}catch(g){return t.error(g),0}return s.mtime.getTime()}function m(t){try{return process.kill(t,0),!0}catch{return!1}}async function n(t,i){const s=await f(t,i);if(!s)return t.info(`Lock '${i}': Could not read pid of lock holder.`),o(t,i);if(s.willReleaseAt){let D=s.willReleaseAt-Date.now();if(D<5e3){for(D>0?t.info(`Lock '${i}': The lockfile is scheduled to be released in ${D} ms.`):t.info(`Lock '${i}': The lockfile is scheduled to have been released.`);D>0;){if(await(0,$.$Gh)(Math.min(100,D)),await d(t,i)===0)return o(t,i);D=s.willReleaseAt-Date.now()}return o(t,i)}}if(!m(s.pid))return t.info(`Lock '${i}': The pid ${s.pid} appears to be gone.`),o(t,i);const g=await d(t,i),l=Date.now()-g;if(l<=k)return t.info(`Lock '${i}': The lock does not look stale, elapsed: ${l} ms, giving up.`),null;t.info(`Lock '${i}': The lock looks stale, waiting for 2s.`),await(0,$.$Gh)(2e3);const w=await d(t,i),S=Date.now()-w;return S<=k?(t.info(`Lock '${i}': The lock does not look stale, elapsed: ${S} ms, giving up.`),null):(t.info(`Lock '${i}': The lock looks stale even after waiting for 2s.`),o(t,i))}async function o(t,i){t.info(`Lock '${i}': Deleting a stale lock.`);try{await c.Promises.unlink(i)}catch{}return a(t,i,!0)}}),define(Ee[379],ye([1,0,32,20,47,35]),function(ce,e,r,h,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0pc=void 0;let T=class extends P.$Goc{constructor($,c){super(!0,$,c)}createTerminal($,c,I){return this.createTerminalFromOptions({name:$,shellPath:c,shellArgs:I})}createTerminalFromOptions($,c){const I=new P.$Foc(this.a,(0,r.$2g)(),$,$.name);return this.f.push(I),I.create($,this.R($,c)),I.value}};e.$0pc=T,e.$0pc=T=Je([Ge(0,R.$hQ),Ge(1,h.$XP)],T)}),define(Ee[380],ye([1,0,4,37,36,5]),function(ce,e,r,h,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NM=e.$MM=e.OutputChannelUpdateMode=e.$LM=e.$KM=e.$JM=e.$IM=e.$HM=e.$GM=e.$FM=e.$EM=e.$DM=e.$CM=e.$BM=e.$AM=e.$zM=void 0,e.$zM="text/x-code-output",e.$AM="output",e.$BM="Log",e.$CM="text/x-code-log-output",e.$DM="log",e.$EM="workbench.panel.output",e.$FM=new P.$Wj("inOutput",!1),e.$GM=new P.$Wj("activeLogOutput",!1),e.$HM=new P.$Wj("activeLogOutput.levelSettable",!1),e.$IM=new P.$Wj("activeLogOutput.level",""),e.$JM=new P.$Wj("activeLogOutput.levelIsDefault",!1),e.$KM=new P.$Wj("outputView.scrollLock",!1),e.$LM=(0,R.$Fi)("outputService");var T;(function($){$[$.Append=1]="Append",$[$.Replace=2]="Replace",$[$.Clear=3]="Clear"})(T||(e.OutputChannelUpdateMode=T={})),e.$MM={OutputChannels:"workbench.contributions.outputChannels"};class N{constructor(){this.a=new Map,this.b=new r.$me,this.onDidRegisterChannel=this.b.event,this.c=new r.$me,this.onDidRemoveChannel=this.c.event}registerChannel(c){this.a.has(c.id)||(this.a.set(c.id,c),this.b.fire(c.id))}getChannels(){const c=[];return this.a.forEach(I=>c.push(I)),c}getChannel(c){return this.a.get(c)}removeChannel(c){this.a.delete(c),this.c.fire(c)}}h.$oo.add(e.$MM.OutputChannels,new N),e.$NM=new P.$Wj("activeOutputChannel","")}),define(Ee[168],ye([1,0,6,5,20,24,12,380,76,30,63,203,22,18,28,4,3]),function(ce,e,r,h,P,R,T,N,$,c,I,E,u,k,p,a,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cpc=e.$Bpc=void 0;class d extends T.$fk{get disposed(){return this.n}constructor(t,i,s,g,l){super(),this.id=t,this.name=i,this.r=s,this.s=g,this.extension=l,this.m=0,this.n=!1,this.visible=!1,this.setLevel(s.getLevel()),this.B(s.onDidChangeLogLevel(w=>this.setLevel(w)))}get logLevel(){return this.getLevel()}appendLine(t){this.append(t+`
`)}append(t){this.info(t)}clear(){const t=this.m;this.r.flush(),this.s.$update(this.id,N.OutputChannelUpdateMode.Clear,t)}replace(t){const i=this.m;this.info(t),this.s.$update(this.id,N.OutputChannelUpdateMode.Replace,i),this.visible&&this.r.flush()}show(t,i){this.r.flush(),this.s.$reveal(this.id,!!(typeof t=="boolean"?t:i))}hide(){this.s.$close(this.id)}g(t,i){this.m+=u.$Oe.fromString(i).byteLength,(0,T.log)(this.r,t,i),this.visible&&(this.r.flush(),this.s.$update(this.id,N.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.n||(this.s.$dispose(this.id),this.n=!0)}}class m extends d{appendLine(t){this.append(t)}}let n=class{constructor(t,i,s,g,l,w){this.i=i,this.j=s,this.k=g,this.l=l,this.m=w,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=t.getProxy(r.$rN.MainThreadOutputService),this.b=this.k.extUri.joinPath(i.logsLocation,`output_logging_${(0,E.$3m)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(t){this.h=t;for(const[i,s]of this.g)s.visible=i===this.h}createOutputChannel(t,i,s){if(t=t.trim(),!t)throw new Error("illegal argument `name`. must not be falsy");const g=typeof i=="object"&&i.log,l=(0,k.$fg)(i)?i:void 0;if((0,k.$fg)(l)&&!l.trim())throw new Error("illegal argument `languageId`. must not be empty");let w;const S=this.i.environment.extensionLogLevel?.find(([y])=>R.$qn.equals(s.identifier,y))?.[1];S&&(w=(0,T.$qk)(S));const D=g?this.o(t,w,s):this.n(t,l,s);return D.then(y=>{this.g.set(y.id,y),y.visible=y.id===this.h}),g?this.r(t,w??this.m.getLevel(),D):this.q(t,D)}async n(t,i,s){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const g=await this.c,l=this.k.extUri.joinPath(g,`${this.f++}-${t.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),w=this.l.createLogger(l,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),S=await this.a.$register(t,l,i,s.identifier.value);return new d(S,t,w,this.a,s)}async o(t,i,s){const g=await this.p(s),l=t.replace(/[\\/:\*\?"<>\|]/g,""),w=this.k.extUri.joinPath(g,`${l}.log`),S=`${s.identifier.value}.${l}`,D=this.l.createLogger(w,{id:S,name:t,logLevel:i,extensionId:s.identifier.value});return new m(S,t,D,this.a,s)}p(t){let i=this.d.get(t.identifier.value);if(!i){const s=this.k.extUri.joinPath(this.i.logsLocation,t.identifier.value);this.d.set(t.identifier.value,i=(async()=>{try{await this.j.value.createDirectory(s)}catch(g){if((0,p.$pl)(g)!==p.FileSystemProviderErrorCode.FileExists)throw g}return s})())}return i}q(t,i){let s=!1;const g=()=>{if(s)throw new Error("Channel has been closed")};return{get name(){return t},append(l){g(),i.then(w=>w.append(l))},appendLine(l){g(),i.then(w=>w.appendLine(l))},clear(){g(),i.then(l=>l.clear())},replace(l){g(),i.then(w=>w.replace(l))},show(l,w){g(),i.then(S=>S.show(l,w))},hide(){g(),i.then(l=>l.hide())},dispose(){s=!0,i.then(l=>l.dispose())}}}r(t,i,s){const g=new f.$Vc,l=()=>{if(g.isDisposed)throw new Error("Channel has been closed")},w=g.add(new a.$me);function S(D){i=D,w.fire(D)}return s.then(D=>{g.add(D),D.logLevel!==i&&S(D.logLevel),g.add(D.onDidChangeLogLevel(y=>S(y)))}),{...this.q(t,s),get logLevel(){return i},onDidChangeLogLevel:w.event,trace(D,...y){l(),s.then(C=>C.trace(D,...y))},debug(D,...y){l(),s.then(C=>C.debug(D,...y))},info(D,...y){l(),s.then(C=>C.info(D,...y))},warn(D,...y){l(),s.then(C=>C.warn(D,...y))},error(D,...y){l(),s.then(C=>C.error(D,...y))},dispose(){g.dispose()}}}};e.$Bpc=n,e.$Bpc=n=Je([Ge(0,P.$XP),Ge(1,c.$bQ),Ge(2,$.$ioc),Ge(3,I.$Xnc),Ge(4,T.$ak),Ge(5,T.$_j)],n),e.$Cpc=(0,h.$Fi)("IExtHostOutputService")}),define(Ee[169],ye([1,0,5,9]),function(ce,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wm=e.$Vm=void 0,e.$Vm=(0,r.$Fi)("remoteAgentService"),e.$Wm=new class{constructor(){this.maxSampleCount=5,this.sampleDelay=2e3,this.initial=[],this.maxInitialCount=3,this.average=[],this.maxAverageCount=100,this.highLatencyMultiple=2,this.highLatencyMinThreshold=500,this.highLatencyMaxThreshold=1500,this.lastMeasurement=void 0}get latency(){return this.lastMeasurement}async measure(P){let R=1/0;for(let N=0;N<this.maxSampleCount;N++){const $=await P.getRoundTripTime();if($===void 0)return;R=Math.min(R,$/2),await(0,h.$Gh)(this.sampleDelay)}this.average.push(R),this.average.length>this.maxAverageCount&&this.average.shift();let T;return this.initial.length<this.maxInitialCount?this.initial.push(R):T=this.initial.reduce((N,$)=>N+$,0)/this.initial.length,this.lastMeasurement={initial:T,current:R,average:this.average.reduce((N,$)=>N+$,0)/this.average.length,high:typeof T>"u"?!1:R>this.highLatencyMaxThreshold||R>this.highLatencyMinThreshold&&R>T*this.highLatencyMultiple},this.lastMeasurement}}}),define(Ee[381],ye([1,0,246,71,37,46,45,3,4,169,11,25,9,150]),function(ce,e,r,h,P,R,T,N,$,c,I,E,u,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aL=e.$_K=e.$$K=e.$0K=e.$9K=e.$8K=e.$7K=e.$6K=e.$5K=e.$4K=void 0,e.$4K=Object.freeze({id:"application",order:100,title:(0,r.localize)(0,null),type:"object"}),e.$5K=Object.freeze({id:"workbench",order:7,title:(0,r.localize)(1,null),type:"object"}),e.$6K=Object.freeze({id:"security",scope:h.ConfigurationScope.APPLICATION,title:(0,r.localize)(2,null),type:"object",order:7}),e.$7K=Object.freeze({id:"problems",title:(0,r.localize)(3,null),type:"object",order:101}),e.$8K=Object.freeze({id:"window",order:8,title:(0,r.localize)(4,null),type:"object"}),e.$9K={ConfigurationMigration:"base.contributions.configuration.migration"};class p{constructor(){this.migrations=[],this.a=new $.$me,this.onDidRegisterConfigurationMigration=this.a.event}registerConfigurationMigrations(o){this.migrations.push(...o)}}const a=new p;P.$oo.add(e.$9K.ConfigurationMigration,a);let f=class extends N.$Wc{static{this.ID="workbench.contrib.configurationMigration"}constructor(o,t){super(),this.a=o,this.b=t,this.B(this.b.onDidChangeWorkspaceFolders(async i=>{for(const s of i.added)await this.f(s,a.migrations)})),this.c(a.migrations),this.B(a.onDidRegisterConfigurationMigration(i=>this.c(i)))}async c(o){await this.f(void 0,o);for(const t of this.b.getWorkspace().folders)await this.f(t,o)}async f(o,t){await Promise.all([t.map(i=>this.g(i,o?.uri))])}async g(o,t){const i=this.a.inspect(o.key,{resource:t}),s=this.b.getWorkbenchState()===R.WorkbenchState.WORKSPACE?[["user",T.ConfigurationTarget.USER],["userLocal",T.ConfigurationTarget.USER_LOCAL],["userRemote",T.ConfigurationTarget.USER_REMOTE],["workspace",T.ConfigurationTarget.WORKSPACE],["workspaceFolder",T.ConfigurationTarget.WORKSPACE_FOLDER]]:[["user",T.ConfigurationTarget.USER],["userLocal",T.ConfigurationTarget.USER_LOCAL],["userRemote",T.ConfigurationTarget.USER_REMOTE],["workspace",T.ConfigurationTarget.WORKSPACE]];for(const[g,l]of s){const w=i[g];if(!w)continue;const S=[];if(w.value!==void 0){const D=await this.h(o,g,w.value,t,void 0);for(const y of D??[])S.push([y,[]])}for(const{identifiers:D,value:y}of w.overrides??[])if(y!==void 0){const C=await this.h(o,g,y,t,D);for(const A of C??[])S.push([A,D])}S.length&&await Promise.allSettled(S.map(async([[D,y],C])=>this.a.updateValue(D,y.value,{resource:t,overrideIdentifiers:C},l)))}}async h(o,t,i,s,g){const l=S=>{const y=this.a.inspect(S,{resource:s})[t];if(y)return g?y.overrides?.find(({identifiers:C})=>(0,E.$fo)(C,g))?.value:y.value},w=await o.migrateFn(i,l);return Array.isArray(w)?w:[[o.key,w]]}};e.$0K=f,e.$0K=f=Je([Ge(0,T.$_i),Ge(1,R.$Oi)],f);let d=class extends N.$Wc{static{this.ID="workbench.contrib.dynamicWorkbenchSecurityConfiguration"}constructor(o){super(),this.b=o,this.a=new u.$3h,this.ready=this.a.p,this.c()}async c(){try{await this.f()}finally{this.a.complete()}}async f(){if(!I.$i&&(await this.b.getEnvironment())?.os!==I.OperatingSystem.Windows)return;P.$oo.as(h.$to.Configuration).registerConfiguration({...e.$6K,properties:{"security.allowedUNCHosts":{type:"array",items:{type:"string",pattern:"^[^\\\\]+$",patternErrorMessage:(0,r.localize)(5,null)},default:[],markdownDescription:(0,r.localize)(6,null),scope:h.ConfigurationScope.MACHINE},"security.restrictUNCAccess":{type:"boolean",default:!0,markdownDescription:(0,r.localize)(7,null),scope:h.ConfigurationScope.MACHINE}}})}};e.$$K=d,e.$$K=d=Je([Ge(0,c.$Vm)],d),e.$_K="window.newWindowProfile";let m=class extends N.$Wc{static{this.ID="workbench.contrib.dynamicWindowConfiguration"}constructor(o,t){super(),this.c=o,this.f=t,this.g(),this.B(this.c.onDidChangeProfiles(i=>this.g())),this.h(),this.j(),this.B(t.onDidChangeConfiguration(i=>{i.source!==T.ConfigurationTarget.DEFAULT&&i.affectsConfiguration(e.$_K)&&this.h()})),this.B(this.c.onDidChangeProfiles(()=>this.j()))}g(){const o=P.$oo.as(h.$to.Configuration),t={...e.$8K,properties:{[e.$_K]:{type:["string","null"],default:null,enum:[...this.c.profiles.map(i=>i.name),null],enumItemLabels:[...this.c.profiles.map(i=>""),(0,r.localize)(8,null)],description:(0,r.localize)(9,null),scope:h.ConfigurationScope.APPLICATION}}};this.a?o.updateConfigurations({add:[t],remove:[this.a]}):o.registerConfiguration(t),this.a=t}h(){const o=this.f.getValue(e.$_K);this.b=o?this.c.profiles.find(t=>t.name===o):void 0}j(){const o=this.f.getValue(e.$_K);if(!o)return;const t=this.b?this.c.profiles.find(i=>i.id===this.b.id):void 0;o!==t?.name&&this.f.updateValue(e.$_K,t?.name)}};e.$aL=m,e.$aL=m=Je([Ge(0,k.$Ll),Ge(1,T.$_i)],m)}),define(Ee[382],ye([1,0,39,15,16,23,258,381,71,5,37]),function(ce,e,r,h,P,R,T,N,$,c,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ResolvedStatus=e.RegisteredEditorPriority=e.$cL=e.$bL=void 0,e.$dL=a,e.$eL=f,r=We(r),e.$bL=(0,c.$Fi)("editorResolverService"),e.$cL="workbench.editorAssociations";const E=I.$oo.as($.$to.Configuration),u={...N.$5K,properties:{"workbench.editorAssociations":{type:"object",markdownDescription:(0,T.localize)(0,null),additionalProperties:{type:"string"}}}};E.registerConfiguration(u);var k;(function(d){d.builtin="builtin",d.option="option",d.exclusive="exclusive",d.default="default"})(k||(e.RegisteredEditorPriority=k={}));var p;(function(d){d[d.ABORT=1]="ABORT",d[d.NONE=2]="NONE"})(p||(e.ResolvedStatus=p={}));function a(d){switch(d){case k.exclusive:return 5;case k.default:return 4;case k.builtin:return 3;case k.option:default:return 1}}function f(d,m){if(new Set([h.Schemas.extension,h.Schemas.webviewPanel,h.Schemas.vscodeWorkspaceTrust,h.Schemas.vscodeSettings]).has(m.scheme))return!1;const t=typeof d=="string"&&d.indexOf(P.$ic.sep)>=0?`${m.scheme}:${m.path}`:(0,R.$dh)(m);return r.$yk(typeof d=="string"?d.toLowerCase():d,t.toLowerCase())}}),define(Ee[383],ye([1,0,33,15,16,11,23,2,5,296,46,157,169]),function(ce,e,r,h,P,R,T,N,$,c,I,E,u){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.$7M=e.$6M=void 0,e.$6M=(0,$.$Fi)("pathService");let p=k=class{constructor(f,d,m,n){this.d=f,this.e=d,this.f=m,this.g=n,this.a=(async()=>(await this.e.getEnvironment())?.os||R.OS)(),this.b=(async()=>{const o=await this.e.getEnvironment();return this.c=o?.userHome??f})()}hasValidBasename(f,d,m){return typeof d=="string"||typeof d>"u"?this.a.then(n=>this.h(f,n,d)):this.h(f,d,m)}h(f,d,m){return f.scheme===h.Schemas.file||f.scheme===h.Schemas.vscodeRemote?(0,r.$Cg)(m??(0,T.$dh)(f),d===R.OperatingSystem.Windows):!0}get defaultUriScheme(){return k.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(f,d){if(f.remoteAuthority)return h.Schemas.vscodeRemote;const m=(0,c.$3M)(d.getWorkspace());if(m)return m;const n=d.getWorkspace().folders[0];if(n)return n.uri.scheme;const o=d.getWorkspace().configuration;return o?o.scheme:h.Schemas.file}userHome(f){return f?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(f=>f===R.OperatingSystem.Windows?P.$hc:P.$ic)}async fileURI(f){let d="";if(await this.a===R.OperatingSystem.Windows&&(f=f.replace(/\\/g,"/")),f[0]==="/"&&f[1]==="/"){const n=f.indexOf("/",2);n===-1?(d=f.substring(2),f="/"):(d=f.substring(2,n),f=f.substring(n)||"/")}return N.URI.from({scheme:h.Schemas.file,authority:d,path:f,query:"",fragment:""})}};e.$7M=p,e.$7M=p=k=Je([Ge(1,u.$Vm),Ge(2,E.$OM),Ge(3,I.$Oi)],p)}),define(Ee[384],ye([1,0,260,59,4,60,3,2,45,266,12,72,151,93,46,157,26,21,18,25,36]),function(ce,e,r,h,P,R,T,N,$,c,I,E,u,k,p,a,f,d,m,n,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ZM=e.$YM=e.OnPortForward=e.$TM=e.$SM=e.TunnelSource=e.TunnelCloseReason=e.$QM=e.$PM=void 0,e.$RM=l,e.$UM=D,e.$VM=y,e.$WM=C,e.$XM=b,r=We(r);const t=10*1e3,i="remote.tunnels.toRestore",s="remote.tunnels.toRestoreExpiration",g=1e3*60*60*24*14;e.$PM="onTunnel",e.$QM=new o.$Wj("forwardedPortsViewEnabled",!1,r.localize(0,null));function l(O){const M=O.match(/^([a-zA-Z0-9_-]+(?:\.[a-zA-Z0-9_-]+)*:)?([0-9]+)$/);if(M)return{host:M[1]?.substring(0,M[1].length-1)||"localhost",port:Number(M[2])}}var w;(function(O){O.Other="Other",O.User="User",O.AutoForwardEnd="AutoForwardEnd"})(w||(e.TunnelCloseReason=w={}));var S;(function(O){O[O.User=0]="User",O[O.Auto=1]="Auto",O[O.Extension=2]="Extension"})(S||(e.TunnelSource=S={})),e.$SM={source:S.User,description:r.localize(1,null)},e.$TM={source:S.Auto,description:r.localize(2,null)};function D(O,M,j){const z=O.get(C(M,j));if(z)return z;if((0,k.$Cw)(M))for(const F of k.$Bw){const B=C(F,j);if(O.has(B))return O.get(B)}else if((0,k.$Ew)(M))for(const F of k.$Dw){const B=C(F,j);if(O.has(B))return O.get(B)}}function y(O,M,j){const z=D(O,M,j);if(z)return z;const F=(0,k.$Ew)(M)?"localhost":(0,k.$Cw)(M)?"0.0.0.0":void 0;if(F)return D(O,F,j)}function C(O,M){return O+":"+M}var A;(function(O){O.Notify="notify",O.OpenBrowser="openBrowser",O.OpenBrowserOnce="openBrowserOnce",O.OpenPreview="openPreview",O.Silent="silent",O.Ignore="ignore"})(A||(e.OnPortForward=A={}));function b(O){return O&&"host"in O&&typeof O.host=="string"&&"port"in O&&typeof O.port=="number"&&(!("detail"in O)||typeof O.detail=="string")&&(!("pid"in O)||typeof O.pid=="string")}class v extends T.$Wc{static{this.c="remote.portsAttributes"}static{this.f="remote.otherPortsAttributes"}static{this.g=/^(\d+)\-(\d+)$/}static{this.h=/^([a-z0-9\-]+):(\d{1,5})$/}constructor(M){super(),this.r=M,this.j=[],this.n=new P.$me,this.onDidChangeAttributes=this.n.event,this.B(M.onDidChangeConfiguration(j=>{(j.affectsConfiguration(v.c)||j.affectsConfiguration(v.f))&&this.s()})),this.s()}s(){this.j=this.y(),this.n.fire()}getAttributes(M,j,z){let F=this.w(M,j,z,this.j,0);const B={label:void 0,onAutoForward:void 0,elevateIfNeeded:void 0,requireLocalPort:void 0,protocol:void 0};for(;F>=0;){const _=this.j[F];_.key===M?(B.onAutoForward=_.onAutoForward??B.onAutoForward,B.elevateIfNeeded=_.elevateIfNeeded!==void 0?_.elevateIfNeeded:B.elevateIfNeeded,B.label=_.label??B.label,B.requireLocalPort=_.requireLocalPort,B.protocol=_.protocol):(B.onAutoForward=B.onAutoForward??_.onAutoForward,B.elevateIfNeeded=B.elevateIfNeeded!==void 0?B.elevateIfNeeded:_.elevateIfNeeded,B.label=B.label??_.label,B.requireLocalPort=B.requireLocalPort!==void 0?B.requireLocalPort:void 0,B.protocol=B.protocol??_.protocol),F=this.w(M,j,z,this.j,F+1)}return B.onAutoForward!==void 0||B.elevateIfNeeded!==void 0||B.label!==void 0||B.requireLocalPort!==void 0||B.protocol!==void 0?B:this.C()}t(M){return M.start!==void 0&&M.end!==void 0}u(M){return M.host!==void 0&&M.port!==void 0&&(0,m.$fg)(M.host)&&(0,m.$jg)(M.port)}w(M,j,z,F,B){if(B>=F.length)return-1;const _=!(0,k.$Cw)(j)&&!(0,k.$Ew)(j),U=F.slice(B).findIndex(G=>(0,m.$jg)(G.key)?_?!1:G.key===M:this.t(G.key)?_?!1:M>=G.key.start&&M<=G.key.end:this.u(G.key)?M===G.key.port&&j===G.key.host:z?G.key.test(z):!1);return U>=0?U+B:-1}y(){const M=this.r.getValue(v.c);if(!M||!(0,m.$hg)(M))return[];const j=[];for(const F in M){if(F===void 0)continue;const B=M[F];let _;if(Number(F))_=Number(F);else if((0,m.$fg)(F))if(v.g.test(F)){const re=F.match(v.g);_={start:Number(re[1]),end:Number(re[2])}}else if(v.h.test(F)){const re=F.match(v.h);_={host:re[1],port:Number(re[2])}}else{let re;try{re=RegExp(F)}catch{}re&&(_=re)}_&&j.push({key:_,elevateIfNeeded:B.elevateIfNeeded,onAutoForward:B.onAutoForward,label:B.label,requireLocalPort:B.requireLocalPort,protocol:B.protocol})}const z=this.r.getValue(v.f);return z&&(this.m={elevateIfNeeded:z.elevateIfNeeded,label:z.label,onAutoForward:z.onAutoForward,requireLocalPort:z.requireLocalPort,protocol:z.protocol}),this.z(j)}z(M){function j(z,F){return(0,m.$jg)(z.key)?z.key:F.t(z.key)?z.key.start:F.u(z.key)?z.key.port:Number.MAX_VALUE}return M.sort((z,F)=>j(z,this)-j(F,this))}C(){return this.m}static providedActionToAction(M){switch(M){case k.ProvidedOnAutoForward.Notify:return A.Notify;case k.ProvidedOnAutoForward.OpenBrowser:return A.OpenBrowser;case k.ProvidedOnAutoForward.OpenBrowserOnce:return A.OpenBrowserOnce;case k.ProvidedOnAutoForward.OpenPreview:return A.OpenPreview;case k.ProvidedOnAutoForward.Silent:return A.Silent;case k.ProvidedOnAutoForward.Ignore:return A.Ignore;default:return}}async addAttributes(M,j,z){const B=this.r.inspect(v.c).userRemoteValue;let _;!B||!(0,m.$hg)(B)?_={}:_=(0,n.$bo)(B),_[`${M}`]||(_[`${M}`]={});for(const re in j)_[`${M}`][re]=j[re];return this.r.updateValue(v.c,_,z)}}e.$YM=v;let L=class extends T.$Wc{constructor(M,j,z,F,B,_,re,U,G,Q){super(),this.H=M,this.I=j,this.J=z,this.L=F,this.M=B,this.N=_,this.O=re,this.P=U,this.Q=G,this.R=Q,this.c=new Map,this.g=new P.$me,this.onForwardPort=this.g.event,this.h=new P.$me,this.onClosePort=this.h.event,this.j=new P.$me,this.onPortName=this.j.event,this.n=new P.$me,this.onCandidatesChanged=this.n.event,this.t=new P.$me,this.onEnvironmentTunnelsSet=this.t.event,this.u=!1,this.w=void 0,this.z=!1,this.C=new P.$me,this.D=new Map,this.F=new Map,this.G=[],this.db=new Date,this.configPortsAttributes=new v(z),this.s=this.ab(),this.B(this.configPortsAttributes.onDidChangeAttributes(this.jb,this)),this.forwarded=new Map,this.f=new Map,this.H.tunnels.then(async ee=>{const he=await this.getAttributes(ee.map(ne=>({port:ne.tunnelRemotePort,host:ne.tunnelRemoteHost})));for(const ne of ee)if(ne.localAddress){const De=C(ne.tunnelRemoteHost,ne.tunnelRemotePort),$e=y(this.m??new Map,ne.tunnelRemoteHost,ne.tunnelRemotePort);this.forwarded.set(De,{remotePort:ne.tunnelRemotePort,remoteHost:ne.tunnelRemoteHost,localAddress:ne.localAddress,protocol:he?.get(ne.tunnelRemotePort)?.protocol??k.TunnelProtocol.Http,localUri:await this.X(ne.localAddress,he?.get(ne.tunnelRemotePort)),localPort:ne.tunnelLocalPort,runningProcess:$e?.detail,hasRunningProcess:!!$e,pid:$e?.pid,privacy:ne.privacy,source:e.$SM}),this.f.set(De,ne)}}),this.detected=new Map,this.B(this.H.onTunnelOpened(async ee=>{const he=C(ee.tunnelRemoteHost,ee.tunnelRemotePort);if(!y(this.forwarded,ee.tunnelRemoteHost,ee.tunnelRemotePort)&&!y(this.detected,ee.tunnelRemoteHost,ee.tunnelRemotePort)&&!y(this.c,ee.tunnelRemoteHost,ee.tunnelRemotePort)&&ee.localAddress){const ne=y(this.m??new Map,ee.tunnelRemoteHost,ee.tunnelRemotePort),De=(await this.getAttributes([{port:ee.tunnelRemotePort,host:ee.tunnelRemoteHost}]))?.get(ee.tunnelRemotePort);this.forwarded.set(he,{remoteHost:ee.tunnelRemoteHost,remotePort:ee.tunnelRemotePort,localAddress:ee.localAddress,protocol:De?.protocol??k.TunnelProtocol.Http,localUri:await this.X(ee.localAddress,De),localPort:ee.tunnelLocalPort,closeable:!0,runningProcess:ne?.detail,hasRunningProcess:!!ne,pid:ne?.pid,privacy:ee.privacy,source:e.$SM})}await this.cb(),this.f.set(he,ee),this.g.fire(this.forwarded.get(he))})),this.B(this.H.onTunnelClosed(ee=>this.W(ee,w.Other))),this.U()}S(){return this.Q.extensions.find(M=>M.activationEvents?.includes(e.$PM))?(this.R.createKey(e.$QM.key,!0),!0):!1}U(){if(this.S())return;const M=this.B(this.Q.onDidRegisterExtensions(()=>{this.S()&&M.dispose()}))}async W(M,j){const z=C(M.host,M.port);this.forwarded.has(z)&&(this.forwarded.delete(z),await this.cb(),this.h.fire(M))}X(M,j){if(M.startsWith("http"))return N.URI.parse(M);const z=j?.protocol??"http";return N.URI.parse(`${z}://${M}`)}async Y(M){const j=this.N.getWorkspace(),z=j.configuration?(0,R.$tj)(j.configuration.path):j.folders.length>0?(0,R.$tj)(j.folders[0].uri.path):void 0;if(z===void 0){this.O.debug("Could not get workspace hash for forwarded ports storage key.");return}return`${M}.${this.L.remoteAuthority}.${z}`}async Z(){return this.Y(i)}async $(){return this.Y(s)}async ab(){const M=this.I.get(i,u.StorageScope.WORKSPACE);if(M)return this.I.remove(i,u.StorageScope.WORKSPACE),await this.cb(),M;const j=await this.Z();if(j)return this.I.get(j,u.StorageScope.PROFILE)}async restoreForwarded(){if(this.bb(),this.J.getValue("remote.restoreForwardedPorts")){const M=await this.s;if(M&&M!==this.y){const j=JSON.parse(M)??[];this.O.trace(`ForwardedPorts: (TunnelModel) restoring ports ${j.map(z=>z.remotePort).join(", ")}`);for(const z of j){const F=y(this.detected,z.remoteHost,z.remotePort);z.source.source!==S.Extension&&!F||z.source.source===S.Extension&&F?await this.fb({remote:{host:z.remoteHost,port:z.remotePort},local:z.localPort,name:z.name,elevateIfNeeded:!0,source:z.source}):z.source.source===S.Extension&&!F&&this.D.set(C(z.remoteHost,z.remotePort),z)}}}if(this.z=!0,this.C.fire(),!this.w){const M=await this.Z();this.w=this.B(new T.$Vc),this.w.add(this.I.onDidChangeValue(u.StorageScope.PROFILE,void 0,this.w)(async j=>{j.key===M&&(this.s=Promise.resolve(this.I.get(M,u.StorageScope.PROFILE)),await this.restoreForwarded())}))}}bb(){const M=this.I.keys(u.StorageScope.PROFILE,u.StorageTarget.USER).filter(j=>j.startsWith(s));for(const j of M){const z=this.I.getNumber(j,u.StorageScope.PROFILE);if(z&&z<Date.now()){this.s=Promise.resolve(void 0);const F=j.replace(s,i);this.I.remove(j,u.StorageScope.PROFILE),this.I.remove(F,u.StorageScope.PROFILE)}}}async cb(){if(this.J.getValue("remote.restoreForwardedPorts")){const M=Array.from(this.forwarded.values()),j=M.map(_=>({remoteHost:_.remoteHost,remotePort:_.remotePort,localPort:_.localPort,name:_.name,localAddress:_.localAddress,localUri:_.localUri,protocol:_.protocol,source:_.source}));let z;M.length>0&&(z=JSON.stringify(j));const F=await this.Z(),B=await this.$();!z&&F&&B?(this.I.remove(F,u.StorageScope.PROFILE),this.I.remove(B,u.StorageScope.PROFILE)):z!==this.y&&F&&B&&(this.I.store(F,z,u.StorageScope.PROFILE,u.StorageTarget.USER),this.I.store(B,Date.now()+g,u.StorageScope.PROFILE,u.StorageTarget.USER)),this.y=z}}async eb(M,j,z){if(!M.tunnelLocalPort||!z?.requireLocalPort||M.tunnelLocalPort===j)return;const F=new Date;if(this.db.getTime()+t>F.getTime())return;this.db=F;const B=r.localize(3,null,j,M.tunnelRemotePort,M.tunnelLocalPort);return this.P.info(B)}async forward(M,j){return!this.z&&this.L.remoteAuthority&&await P.Event.toPromise(this.C.event),this.fb(M,j)}async fb(M,j){await this.Q.activateByEvent(e.$PM);const z=y(this.forwarded,M.remote.host,M.remote.port);j=j??(j!==null?(await this.getAttributes([M.remote]))?.get(M.remote.port):void 0);const F=M.local!==void 0?M.local:M.remote.port;let B;if(z)return this.hb(z,M,j);{const _=this.L.remoteAuthority,re=_?{getAddress:async()=>(await this.M.resolveAuthority(_)).authority}:void 0,U=C(M.remote.host,M.remote.port);this.c.set(U,!0),M=this.gb(U,M);const G=await this.H.openTunnel(re,M.remote.host,M.remote.port,void 0,F,M.elevateIfNeeded?M.elevateIfNeeded:j?.elevateIfNeeded,M.privacy,j?.protocol);if(typeof G=="string")B=G;else if(G&&G.localAddress){const Q=y(this.m??new Map,M.remote.host,M.remote.port),ee=G.protocol?G.protocol===k.TunnelProtocol.Https?k.TunnelProtocol.Https:k.TunnelProtocol.Http:j?.protocol??k.TunnelProtocol.Http,he={remoteHost:G.tunnelRemoteHost,remotePort:G.tunnelRemotePort,localPort:G.tunnelLocalPort,name:j?.label??M.name,closeable:!0,localAddress:G.localAddress,protocol:ee,localUri:await this.X(G.localAddress,j),runningProcess:Q?.detail,hasRunningProcess:!!Q,pid:Q?.pid,source:M.source??e.$SM,privacy:G.privacy};return this.forwarded.set(U,he),this.f.set(U,G),this.c.delete(U),await this.cb(),await this.eb(G,F,j),this.g.fire(he),G}this.c.delete(U)}return B}gb(M,j){const z=this.D.has(M)?this.D:this.F.has(M)?this.F:void 0;if(z){const F=z.get(M);z.delete(M),F&&(j.name=F.name??j.name,j.local=("local"in F?F.local:"localPort"in F?F.localPort:void 0)??j.local,j.privacy=j.privacy)}return j}async hb(M,j,z){const F=z?.label??j.name;let B;(function(re){re[re.None=0]="None",re[re.Fire=1]="Fire",re[re.Reopen=2]="Reopen"})(B||(B={}));let _=B.None;switch(F!==M.name&&(M.name=F,_=B.Fire),(z?.protocol||M.protocol!==k.TunnelProtocol.Http)&&z?.protocol!==M.protocol&&(j.source=M.source,_=B.Reopen),j.privacy&&M.privacy!==j.privacy&&(_=B.Reopen),_){case B.Fire:{this.g.fire();break}case B.Reopen:await this.close(M.remoteHost,M.remotePort,w.User),await this.fb(j,z)}return y(this.f,j.remote.host,j.remote.port)}async name(M,j,z){const F=y(this.forwarded,M,j),B=C(M,j);if(F){F.name=z,await this.cb(),this.j.fire({host:M,port:j});return}else this.detected.has(B)&&(this.detected.get(B).name=z,this.j.fire({host:M,port:j}))}async close(M,j,z){const F=C(M,j),B=this.forwarded.get(F);return z===w.AutoForwardEnd&&B&&B.source.source===S.Auto&&this.F.set(F,{local:B.localPort,name:B.name,privacy:B.privacy}),await this.H.closeTunnel(M,j),this.W({host:M,port:j},z)}address(M,j){const z=C(M,j);return(this.forwarded.get(z)||this.detected.get(z))?.localAddress}get environmentTunnelsSet(){return this.u}addEnvironmentTunnels(M){if(M)for(const j of M){const z=y(this.m??new Map,j.remoteAddress.host,j.remoteAddress.port),F=typeof j.localAddress=="string"?j.localAddress:C(j.localAddress.host,j.localAddress.port);this.detected.set(C(j.remoteAddress.host,j.remoteAddress.port),{remoteHost:j.remoteAddress.host,remotePort:j.remoteAddress.port,localAddress:F,protocol:k.TunnelProtocol.Http,localUri:this.X(F),closeable:!1,runningProcess:z?.detail,hasRunningProcess:!!z,pid:z?.pid,privacy:k.TunnelPrivacyId.ConstantPrivate,source:{source:S.Extension,description:r.localize(4,null)}}),this.H.setEnvironmentTunnel(j.remoteAddress.host,j.remoteAddress.port,F,k.TunnelPrivacyId.ConstantPrivate,k.TunnelProtocol.Http)}this.u=!0,this.t.fire(),this.g.fire()}setCandidateFilter(M){this.r=M}async setCandidates(M){let j=M;this.r&&(j=await this.r(M));const z=this.ib(j);this.O.trace(`ForwardedPorts: (TunnelModel) removed candidates ${Array.from(z.values()).map(F=>F.port).join(", ")}`),this.n.fire(z)}ib(M){const j=this.m??new Map,z=new Map;return this.m=z,M.forEach(F=>{const B=C(F.host,F.port);z.set(B,{host:F.host,port:F.port,detail:F.detail,pid:F.pid}),j.has(B)&&j.delete(B);const _=y(this.forwarded,F.host,F.port);_&&(_.runningProcess=F.detail,_.hasRunningProcess=!0,_.pid=F.pid)}),j.forEach((F,B)=>{const _=l(B);if(!_)return;const re=y(this.forwarded,_.host,_.port);re&&(re.runningProcess=void 0,re.hasRunningProcess=!1,re.pid=void 0);const U=y(this.detected,_.host,_.port);U&&(U.runningProcess=void 0,U.hasRunningProcess=!1,U.pid=void 0)}),j}get candidates(){return this.m?Array.from(this.m.values()):[]}get candidatesOrUndefined(){return this.m?this.candidates:void 0}async jb(){const M=Array.from(this.forwarded.values()),j=await this.getAttributes(M.map(z=>({port:z.remotePort,host:z.remoteHost})),!1);if(j)for(const z of M){const F=j.get(z.remotePort);(F?.protocol||z.protocol!==k.TunnelProtocol.Http)&&F?.protocol!==z.protocol&&await this.fb({remote:{host:z.remoteHost,port:z.remotePort},local:z.localPort,name:z.name,source:z.source},F),F&&F.label&&F.label!==z.name&&await this.name(z.remoteHost,z.remotePort,F.label)}}async getAttributes(M,j=!0){const z=new Map,F=new Map;M.forEach(G=>{const Q=y(this.m??new Map,k.$Bw[0],G.port)??G;if(Q){z.set(G.port,Q);const ee=b(Q)?Q.pid:void 0;F.has(ee)||F.set(ee,[]),F.get(ee)?.push(G.port)}});const B=new Map;if(M.forEach(G=>{const Q=this.configPortsAttributes.getAttributes(G.port,G.host,z.get(G.port)?.detail);Q&&B.set(G.port,Q)}),this.G.length===0||!j)return B.size>0?B:void 0;const _=await Promise.all(this.G.flatMap(G=>Array.from(F.entries()).map(Q=>{const ee=Q[1],he=z.get(ee[0]);return G.providePortAttributes(ee,he?.pid,he?.detail,d.CancellationToken.None)}))),re=new Map;if(_.forEach(G=>G.forEach(Q=>{Q&&re.set(Q.port,Q)})),!B&&!re)return;const U=new Map;return M.forEach(G=>{const Q=B.get(G.port),ee=re.get(G.port);U.set(G.port,{elevateIfNeeded:Q?.elevateIfNeeded,label:Q?.label,onAutoForward:Q?.onAutoForward??v.providedActionToAction(ee?.autoForwardAction),requireLocalPort:Q?.requireLocalPort,protocol:Q?.protocol})}),U}addAttributesProvider(M){this.G.push(M)}};e.$ZM=L,Je([(0,h.$$h)(1e3)],L.prototype,"cb",null),e.$ZM=L=Je([Ge(0,k.$ww),Ge(1,u.$bq),Ge(2,$.$_i),Ge(3,a.$OM),Ge(4,E.$Ql),Ge(5,p.$Oi),Ge(6,I.$_j),Ge(7,c.$2w),Ge(8,f.$ZG),Ge(9,o.$Xj)],L)}),define(Ee[100],ye([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.$HL=e.$GL=void 0;class r{constructor(T,N){this.line=T,this.character=N}isBefore(T){return!1}isBeforeOrEqual(T){return!1}isAfter(T){return!1}isAfterOrEqual(T){return!1}isEqual(T){return!1}compareTo(T){return 0}translate(T,N){return new r(0,0)}with(T){return new r(0,0)}}e.$GL=r;class h{constructor(T,N,$,c){this.isEmpty=!1,this.isSingleLine=!1,this.start=new r(T,N),this.end=new r($,c)}contains(T){return!1}isEqual(T){return!1}intersection(T){}union(T){return new h(0,0,0,0)}with(T){return new h(0,0,0,0)}}e.$HL=h;var P;(function(R){R[R.Information=1]="Information",R[R.Warning=2]="Warning"})(P||(e.TextSearchCompleteMessageType=P={}))}),define(Ee[38],ye([1,0,19,39,25,33,13,5,16,14,100,9]),function(ce,e,r,h,P,R,T,N,$,c,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8L=e.$6L=e.$YL=e.SearchErrorCode=e.SearchSortOrder=e.ViewMode=e.$VL=e.$UL=e.$TL=e.$SL=e.SearchCompletionExitCode=e.QueryType=e.SearchProviderType=e.$OL=e.$NL=e.$ML=e.$LL=e.$KL=e.$JL=e.$IL=e.TextSearchCompleteMessageType=void 0,e.$PL=d,e.$QL=m,e.$RL=n,e.$WL=D,e.$XL=y,e.$ZL=b,e.$1L=v,e.$2L=L,e.$3L=O,e.$4L=M,e.$5L=j,e.$7L=F,e.$9L=re,e.$0L=U,h=We(h),P=We(P),R=We(R),$=We($),Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return I.TextSearchCompleteMessageType}}),e.$IL="workbench.view.search",e.$JL="workbench.panel.search",e.$KL="workbench.view.search",e.$LL="search-result",e.$ML="search.exclude",e.$NL=2e4;const u="\u27EA ",k=" characters skipped \u27EB",p=(u.length+k.length+5)*2;e.$OL=(0,N.$Fi)("searchService");var a;(function(Q){Q[Q.file=0]="file",Q[Q.text=1]="text",Q[Q.aiText=2]="aiText"})(a||(e.SearchProviderType=a={}));var f;(function(Q){Q[Q.File=1]="File",Q[Q.Text=2]="Text",Q[Q.aiText=3]="aiText"})(f||(e.QueryType=f={}));function d(Q){return!!Q.preview}function m(Q){return!!Q.resource}function n(Q){return!!Q.message}var o;(function(Q){Q[Q.Normal=0]="Normal",Q[Q.NewSearchStarted=1]="NewSearchStarted"})(o||(e.SearchCompletionExitCode=o={}));class t{constructor(ee){this.resource=ee,this.results=[]}}e.$SL=t;class i{constructor(ee,he,ne,De){this.ranges=he,this.webviewIndex=De;const $e=Array.isArray(he)?he:[he];if(ne&&ne.matchLines===1&&s($e)){ee=(0,T.$$f)(ee,ne.matchLines);let K="",W=0,se=0;const oe=Math.floor(ne.charsPerLine/5),te=[];for(const le of $e){const ue=Math.max(le.startColumn-oe,0),X=le.startColumn+ne.charsPerLine;if(ue>se+oe+p){const ae=u+(ue-se)+k;K+=ae+ee.slice(ue,X),W+=ue-(se+ae.length)}else K+=ee.slice(se,X);te.push(new l(0,le.startColumn-W,le.endColumn-W)),se=X}this.preview={text:K,matches:Array.isArray(this.ranges)?te:te[0]}}else{const K=Array.isArray(he)?he[0].startLineNumber:he.startLineNumber;this.preview={text:ee,matches:(0,r.$3b)(he,W=>new g(W.startLineNumber-K,W.startColumn,W.endLineNumber-K,W.endColumn))}}}}e.$TL=i;function s(Q){const ee=Q[0].startLineNumber;for(const he of Q)if(he.startLineNumber!==ee||he.endLineNumber!==ee)return!1;return!0}class g{constructor(ee,he,ne,De){this.startLineNumber=ee,this.startColumn=he,this.endLineNumber=ne,this.endColumn=De}}e.$UL=g;class l extends g{constructor(ee,he,ne){super(ee,he,ee,ne)}}e.$VL=l;var w;(function(Q){Q.List="list",Q.Tree="tree"})(w||(e.ViewMode=w={}));var S;(function(Q){Q.Default="default",Q.FileNames="fileNames",Q.Type="type",Q.Modified="modified",Q.CountDescending="countDescending",Q.CountAscending="countAscending"})(S||(e.SearchSortOrder=S={}));function D(Q,ee=!0){const he=Q&&Q.files&&Q.files.exclude,ne=ee&&Q&&Q.search&&Q.search.exclude;if(!he&&!ne)return;if(!he||!ne)return he||ne;let De=Object.create(null);return De=P.$eo(De,P.$bo(he)),De=P.$eo(De,P.$bo(ne),!0),De}function y(Q,ee){return Q.excludePattern&&h.$yk(Q.excludePattern,ee)?!1:Q.includePattern||Q.usingSearchPaths?Q.includePattern&&h.$yk(Q.includePattern,ee)?!0:Q.usingSearchPaths?!!Q.folderQueries&&Q.folderQueries.some(he=>{const ne=he.folder.fsPath;if(R.$Eg(ee,ne)){const De=$.$nc(ne,ee);return!he.includePattern||!!h.$yk(he.includePattern,De)}else return!1}):!1:!0}var C;(function(Q){Q[Q.unknownEncoding=1]="unknownEncoding",Q[Q.regexParseError=2]="regexParseError",Q[Q.globParseError=3]="globParseError",Q[Q.invalidLiteral=4]="invalidLiteral",Q[Q.rgProcessError=5]="rgProcessError",Q[Q.other=6]="other",Q[Q.canceled=7]="canceled"})(C||(e.SearchErrorCode=C={}));class A extends Error{constructor(ee,he){super(ee),this.code=he}}e.$YL=A;function b(Q){const ee=Q.message;if((0,c.$6)(Q))return new A(ee,C.canceled);try{const he=JSON.parse(ee);return new A(he.message,he.code)}catch{return new A(ee,C.other)}}function v(Q){const ee={message:Q.message,code:Q.code};return new Error(JSON.stringify(ee))}function L(Q){return Q.type==="error"?!0:Q.type==="success"}function O(Q){return Q.type==="success"}function M(Q){return!!Q.path}function j(Q,ee,he=!0){const ne=Q.searchPath?Q.searchPath:Q.relativePath;return he?(0,T.$8f)(ne,ee):h.$yk(ee,ne)}class z{constructor(ee){this.path=ee,this.results=[]}addMatch(ee){this.results.push(ee)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.$6L=z;function F(Q,ee){const he={...Q||{},...ee||{}};return Object.keys(he).filter(ne=>{const De=he[ne];return typeof De=="boolean"&&De})}class B{constructor(ee,he){this.c=null,this.a={...ee.excludePattern||{},...he.excludePattern||{}},this.b=h.$zk(this.a);let ne=ee.includePattern;he.includePattern&&(ne?ne={...ne,...he.includePattern}:ne=he.includePattern),ne&&(this.c=h.$zk(ne))}matchesExcludesSync(ee,he,ne){return!!(this.b&&this.b(ee,he,ne))}includedInQuerySync(ee,he,ne){return!(this.b&&this.b(ee,he,ne)||this.c&&!this.c(ee,he,ne))}includedInQuery(ee,he,ne){const De=this.b(ee,he,ne),$e=()=>this.c?!!this.c(ee,he,ne):!0;return(0,E.$rh)(De)?De.then(K=>K?!1:$e()):$e()}hasSiblingExcludeClauses(){return _(this.a)}}e.$8L=B;function _(Q){for(const ee in Q)if(typeof Q[ee]!="boolean")return!0;return!1}function re(Q){if(!Q)return;let ee;return he=>(ee||(ee=(Q()||Promise.resolve([])).then(ne=>ne?G(ne):{})),ee.then(ne=>!!ne[he]))}function U(Q){if(!Q)return;let ee;return he=>{if(!ee){const ne=Q();ee=ne?G(ne):{}}return!!ee[he]}}function G(Q){const ee={};for(const he of Q)ee[he]=!0;return ee}}),define(Ee[48],ye([1,0,19,9,21,4,3,85,15,134,23,13,2,244,28,5,12,280,46,63,30,20,17,10,73,38,6,57]),function(ce,e,r,h,P,R,T,N,$,c,I,E,u,k,p,a,f,d,m,n,o,t,i,s,g,l,w,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$doc=e.$coc=void 0;function D(M,j,z){return new I.$8g(F=>b(F,z)).isEqual(M,j)}function y(M,j,z){return D(M.uri,j.uri,z)?0:(0,E.$zf)(M.uri.toString(),j.uri.toString())}function C(M,j,z){return M.index!==j.index?M.index<j.index?-1:1:D(M.uri,j.uri,z)?(0,E.$zf)(M.name,j.name):(0,E.$zf)(M.uri.toString(),j.uri.toString())}function A(M,j,z,F){const B=M.slice(0).sort((re,U)=>z(re,U,F)),_=j.slice(0).sort((re,U)=>z(re,U,F));return(0,r.$Gb)(B,_,(re,U)=>z(re,U,F))}function b(M,j){const z=j.getCapabilities(M.scheme);return!(z&&z&p.FileSystemProviderCapabilities.PathCaseSensitive)}class v extends m.$Yi{static toExtHostWorkspace(j,z,F,B){if(!j)return{workspace:null,added:[],removed:[]};const{id:_,name:re,folders:U,configuration:G,transient:Q,isUntitled:ee}=j,he=[],ne=z;z?U.forEach((W,se)=>{const oe=u.URI.revive(W.uri),te=v.o(F||z,oe,B);te?(te.name=W.name,te.index=W.index,he.push(te)):he.push({uri:oe,name:W.name,index:se})}):he.push(...U.map(({uri:W,name:se,index:oe})=>({uri:u.URI.revive(W),name:se,index:oe}))),he.sort((W,se)=>W.index<se.index?-1:1);const De=new v(_,re,he,!!Q,G?u.URI.revive(G):null,!!ee,W=>b(W,B)),{added:$e,removed:K}=A(ne?ne.workspaceFolders:[],De.workspaceFolders,y,B);return{workspace:De,added:$e,removed:K}}static o(j,z,F){for(let B=0;B<j.folders.length;B++){const _=j.workspaceFolders[B];if(D(_.uri,z,F))return _}}constructor(j,z,F,B,_,re,U){super(j,F.map(G=>new m.$Zi(G)),B,_,U),this.t=z,this.u=re,this.q=[],this.s=N.$Li.forUris(U,()=>!0),F.forEach(G=>{this.q.push(G),this.s.set(G.uri,G)})}get name(){return this.t}get isUntitled(){return this.u}get workspaceFolders(){return this.q.slice(0)}getWorkspaceFolder(j,z){return z&&this.s.get(j)&&(j=(0,I.$fh)(j)),this.s.findSubstr(j)}resolveWorkspaceFolder(j){return this.s.get(j)}}let L=class{constructor(j,z,F,B,_){this.c=new R.$me,this.onDidChangeWorkspace=this.c.event,this.g=new R.$me,this.onDidGrantWorkspaceTrust=this.g.event,this.u=[],this.v=!1,this.w=new Map,this.A=0,this.B=new R.$oe,this.C=new Map,this.h=B,this.s=F,this.t=_,this.j=new c.$Mm,this.k=new h.$Eh,this.o=j.getProxy(w.$rN.MainThreadWorkspace),this.q=j.getProxy(w.$rN.MainThreadMessageService);const re=z.workspace;this.l=re?new v(re.id,re.name,[],!!re.transient,re.configuration?u.URI.revive(re.configuration):null,!!re.isUntitled,U=>b(U,F)):void 0}$initializeWorkspace(j,z){this.v=z,this.$acceptWorkspaceData(j),this.k.open()}waitForInitializeCall(){return this.k.wait()}get workspace(){return this.x}get name(){return this.x?this.x.name:void 0}get workspaceFile(){if(this.x&&this.x.configuration)return this.x.isUntitled?u.URI.from({scheme:$.Schemas.untitled,path:(0,I.$dh)((0,I.$fh)(this.x.configuration))}):this.x.configuration}get x(){return this.n||this.l}getWorkspaceFolders(){if(this.x)return this.x.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.k.wait(),!!this.x)return this.x.workspaceFolders.slice(0)}updateWorkspaceFolders(j,z,F,...B){const _=[];if(Array.isArray(B)&&B.forEach(ee=>{u.URI.isUri(ee.uri)&&!_.some(he=>D(he.uri,ee.uri,this.s))&&_.push({uri:ee.uri,name:ee.name||(0,I.$ch)(ee.uri)})}),this.n||[z,F].some(ee=>typeof ee!="number"||ee<0)||F===0&&_.length===0)return!1;const re=this.x?this.x.workspaceFolders:[];if(z+F>re.length)return!1;const U=re.slice(0);U.splice(z,F,..._.map(ee=>({uri:ee.uri,name:ee.name||(0,I.$ch)(ee.uri),index:void 0})));for(let ee=0;ee<U.length;ee++){const he=U[ee];if(U.some((ne,De)=>De!==ee&&D(he.uri,ne.uri,this.s)))return!1}U.forEach((ee,he)=>ee.index=he);const{added:G,removed:Q}=A(re,U,C,this.s);if(G.length===0&&Q.length===0)return!1;if(this.o){const ee=j.displayName||j.name;this.o.$updateWorkspaceFolders(ee,z,F,_).then(void 0,he=>{this.n=void 0;const ne={source:{identifier:j.identifier,label:j.displayName||j.name}};this.q.$showMessage(d.Severity.Error,(0,k.localize)(0,null,ee,he.toString()),ne,[])})}return this.y(U),!0}getWorkspaceFolder(j,z){if(this.x)return this.x.getWorkspaceFolder(j,z)}async getWorkspaceFolder2(j,z){if(await this.k.wait(),!!this.x)return this.x.getWorkspaceFolder(j,z)}async resolveWorkspaceFolder(j){if(await this.k.wait(),!!this.x)return this.x.resolveWorkspaceFolder(j)}getPath(){if(!this.x)return;const{folders:j}=this.x;if(j.length!==0)return j[0].uri.fsPath}getRelativePath(j,z){let F,B="";if(typeof j=="string"?(F=u.URI.file(j),B=j):typeof j<"u"&&(F=j,B=j.fsPath),!F)return B;const _=this.getWorkspaceFolder(F,!0);if(!_)return B;typeof z>"u"&&this.x&&(z=this.x.folders.length>1);let re=(0,I.$ih)(_.uri,F);return z&&_.name&&(re=`${_.name}/${re}`),re}y(j){this.x&&(this.n=v.toExtHostWorkspace({id:this.x.id,name:this.x.name,configuration:this.x.configuration,folders:j,isUntitled:this.x.isUntitled},this.x,void 0,this.s).workspace||void 0)}$acceptWorkspaceData(j){const{workspace:z,added:F,removed:B}=v.toExtHostWorkspace(j,this.l,this.n,this.s);this.l=z||void 0,this.n=void 0,this.c.fire(Object.freeze({added:F,removed:B}))}findFiles(j,z,F,B,_=P.CancellationToken.None){this.h.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${B.value}, entryPoint: findFiles`);let re="",U=!0;return z===null?U=!1:z!==void 0&&(typeof z=="string"?re=z:re=z.pattern),this.z(j,void 0,{exclude:re,maxResults:F,useDefaultExcludes:U,useDefaultSearchExcludes:!1,useIgnoreFiles:!1},_)}findFiles2(j,z={},F,B=P.CancellationToken.None){return this.h.trace(`extHostWorkspace#findFiles2: fileSearch, extension: ${F.value}, entryPoint: findFiles2`),this.z(void 0,j,z,B)}async z(j,z,F,B=P.CancellationToken.None){if(B&&B.isCancellationRequested)return Promise.resolve([]);const _=typeof F.exclude=="string"?F.exclude:F.exclude?F.exclude.pattern:void 0,re={ignoreSymlinks:typeof F.followSymlinks=="boolean"?!F.followSymlinks:void 0,disregardIgnoreFiles:typeof F.useIgnoreFiles=="boolean"?!F.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof F.useGlobalIgnoreFiles=="boolean"?!F.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof F.useParentIgnoreFiles=="boolean"?!F.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof F.useDefaultExcludes=="boolean"?!F.useDefaultExcludes:!1,disregardSearchExcludeSettings:typeof F.useDefaultSearchExcludes=="boolean"?!F.useDefaultSearchExcludes:!1,maxResults:F.maxResults,excludePattern:_,shouldGlobSearch:typeof F.fuzzy=="boolean"?!F.fuzzy:!0,_reason:"startFileSearch"};let U;if(j){const{includePattern:G,folder:Q}=O(i.GlobPattern.from(j));U=Q,re.includePattern=G}else{const{includePattern:G,folder:Q}=O(i.GlobPattern.from(z));U=Q,re.filePattern=G}return this.o.$startFileSearch(U??null,re,B).then(G=>Array.isArray(G)?G.map(Q=>u.URI.revive(Q)):[])}async findTextInFiles(j,z,F,B,_=P.CancellationToken.None){this.h.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${B.value}, entryPoint: findTextInFiles`);const re=this.j.getNext(),U=typeof z.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:z.previewOptions,{includePattern:G,folder:Q}=O(i.GlobPattern.from(z.include)),ee=typeof z.exclude=="string"?z.exclude:z.exclude?z.exclude.pattern:void 0,he={ignoreSymlinks:typeof z.followSymlinks=="boolean"?!z.followSymlinks:void 0,disregardIgnoreFiles:typeof z.useIgnoreFiles=="boolean"?!z.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof z.useGlobalIgnoreFiles=="boolean"?!z.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof z.useParentIgnoreFiles=="boolean"?!z.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof z.useDefaultExcludes=="boolean"?!z.useDefaultExcludes:!0,fileEncoding:z.encoding,maxResults:z.maxResults,previewOptions:U,afterContext:z.afterContext,beforeContext:z.beforeContext,includePattern:G,excludePattern:ee},ne=!1;if(this.u[re]=De=>{if(ne)return;const $e=u.URI.revive(De.resource);De.results.forEach(K=>{const W=(0,S.$ci)(K);(0,l.$PL)(W)?F({uri:$e,preview:{text:W.preview.text,matches:(0,r.$3b)(W.preview.matches,se=>new s.$vN(se.startLineNumber,se.startColumn,se.endLineNumber,se.endColumn))},ranges:(0,r.$3b)(W.ranges,se=>new s.$vN(se.startLineNumber,se.startColumn,se.endLineNumber,se.endColumn))}):F({uri:$e,text:W.text,lineNumber:W.lineNumber})})},_.isCancellationRequested)return{};try{const De=await this.o.$startTextSearch(j,Q??null,he,re,_);return delete this.u[re],De||{}}catch(De){throw delete this.u[re],De}}$handleTextSearchResult(j,z){this.u[z]?.(j)}async save(j){const z=await this.o.$save(j,{saveAs:!1});return u.URI.revive(z)}async saveAs(j){const z=await this.o.$save(j,{saveAs:!0});return u.URI.revive(z)}saveAll(j){return this.o.$saveAll(j)}resolveProxy(j){return this.o.$resolveProxy(j)}loadCertificates(){return this.o.$loadCertificates()}get trusted(){return this.v}requestWorkspaceTrust(j){return this.o.$requestWorkspaceTrust(j)}$onDidGrantWorkspaceTrust(){this.v||(this.v=!0,this.g.fire())}registerEditSessionIdentityProvider(j,z){if(this.w.has(j))throw new Error(`A provider has already been registered for scheme ${j}`);this.w.set(j,z);const F=this.t.transformOutgoingScheme(j),B=this.A++;return this.o.$registerEditSessionIdentityProvider(B,F),(0,T.$Uc)(()=>{this.w.delete(j),this.o.$unregisterEditSessionIdentityProvider(B)})}async $getEditSessionIdentifier(j,z){this.h.info("Getting edit session identifier for workspaceFolder",j);const F=await this.resolveWorkspaceFolder(u.URI.revive(j));if(!F){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",F);const B=this.w.get(F.uri.scheme);if(this.h.info(`Provider for scheme ${F.uri.scheme} is defined: `,!!B),!B)return;const _=await B.provideEditSessionIdentity(F,z);if(this.h.info("Provider returned edit session identifier: ",_),!!_)return _}async $provideEditSessionIdentityMatch(j,z,F,B){this.h.info("Getting edit session identifier for workspaceFolder",j);const _=await this.resolveWorkspaceFolder(u.URI.revive(j));if(!_){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",_);const re=this.w.get(_.uri.scheme);if(this.h.info(`Provider for scheme ${_.uri.scheme} is defined: `,!!re),!re)return;const U=await re.provideEditSessionIdentityMatch?.(z,F,B);if(this.h.info("Provider returned edit session identifier match result: ",U),!!U)return U}getOnWillCreateEditSessionIdentityEvent(j){return(z,F,B)=>{const _=function(U){z.call(F,U)};return _.extension=j,this.B.event(_,void 0,B)}}async $onWillCreateEditSessionIdentity(j,z,F){const B=await this.resolveWorkspaceFolder(u.URI.revive(j));if(B===void 0)throw new Error("Unable to resolve workspace folder");await this.B.fireAsync({workspaceFolder:B},z,async(_,re)=>{const U=Date.now();await Promise.resolve(_),Date.now()-U>F&&this.h.warn("SLOW edit session create-participant",re.extension.identifier)}),z.isCancellationRequested}registerCanonicalUriProvider(j,z){if(this.C.has(j))throw new Error(`A provider has already been registered for scheme ${j}`);this.C.set(j,z);const F=this.t.transformOutgoingScheme(j),B=this.A++;return this.o.$registerCanonicalUriProvider(B,F),(0,T.$Uc)(()=>{this.C.delete(j),this.o.$unregisterCanonicalUriProvider(B)})}async provideCanonicalUri(j,z,F){const B=this.C.get(j.scheme);if(!B)return;const _=await B.provideCanonicalUri?.(u.URI.revive(j),z,F);if(_)return _}async $provideCanonicalUri(j,z,F){return this.provideCanonicalUri(u.URI.revive(j),{targetScheme:z},F)}};e.$coc=L,e.$coc=L=Je([Ge(0,t.$XP),Ge(1,o.$bQ),Ge(2,n.$Xnc),Ge(3,f.$_j),Ge(4,g.$aoc)],L),e.$doc=(0,a.$Fi)("IExtHostWorkspace");function O(M){let j,z;return M&&(typeof M=="string"?j=M:(j=M.pattern,z=u.URI.revive(M.baseUri))),{includePattern:j,folder:z}}}),define(Ee[42],ye([1,0,25,4,48,6,10,45,282,71,18,9,5,20,12,2]),function(ce,e,r,h,P,R,T,N,$,c,I,E,u,k,p,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$goc=e.$foc=e.$eoc=void 0;function f(g,l){if(l){const w=l.split(".");let S=g;for(let D=0;S&&D<w.length;D++)S=S[w[D]];return S}}function d(g){return g instanceof a.URI}function m(g){return g&&g.uri instanceof a.URI&&g.languageId&&typeof g.languageId=="string"}function n(g){return g&&!g.uri&&g.languageId&&typeof g.languageId=="string"}function o(g){return g&&g.uri instanceof a.URI&&(!g.name||typeof g.name=="string")&&(!g.index||typeof g.index=="number")}function t(g){if(d(g))return{resource:g};if(m(g))return{resource:g.uri,overrideIdentifier:g.languageId};if(n(g))return{overrideIdentifier:g.languageId};if(o(g))return{resource:g.uri};if(g===null)return{resource:null}}let i=class{constructor(l,w,S){this.a=l.getProxy(R.$rN.MainThreadConfiguration),this.c=w,this.b=S,this.d=new E.$Eh,this.e=null}getConfigProvider(){return this.d.wait().then(l=>this.e)}$initializeConfiguration(l){this.e=new s(this.a,this.c,l,this.b),this.d.open()}$acceptConfigurationChanged(l,w){this.getConfigProvider().then(S=>S.$acceptConfigurationChanged(l,w))}};e.$eoc=i,e.$eoc=i=Je([Ge(0,k.$XP),Ge(1,P.$doc),Ge(2,p.$_j)],i);class s{constructor(l,w,S,D){this.a=new h.$me,this.b=l,this.f=D,this.c=w,this.e=$.$Mo.parse(S,D),this.d=this.k(S.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(l,w){const S={data:this.e.toData(),workspace:this.c.workspace};this.e=$.$Mo.parse(l,this.f),this.d=this.k(l.configurationScopes),this.a.fire(this.j(w,S))}getConfiguration(l,w,S){const D=t(w)||{},y=this.g(l?f(this.e.getValue(void 0,D,this.c.workspace),l):this.e.getValue(void 0,D,this.c.workspace));l&&this.h(l,D,S?.identifier);function C(b){if(b==null)return null;if(typeof b=="boolean")return b?N.ConfigurationTarget.USER:N.ConfigurationTarget.WORKSPACE;switch(b){case T.ConfigurationTarget.Global:return N.ConfigurationTarget.USER;case T.ConfigurationTarget.Workspace:return N.ConfigurationTarget.WORKSPACE;case T.ConfigurationTarget.WorkspaceFolder:return N.ConfigurationTarget.WORKSPACE_FOLDER}}const A={has(b){return typeof f(y,b)<"u"},get:(b,v)=>{this.h(l?`${l}.${b}`:b,D,S?.identifier);let L=f(y,b);if(typeof L>"u")L=v;else{let O;const M=(j,z)=>{if((0,I.$hg)(j)){let F;const B=()=>{O=O||(0,r.$bo)(y),F=F||f(O,z)};return new Proxy(j,{get:(_,re)=>{if(typeof re=="string"&&re.toLowerCase()==="tojson")return B(),()=>F;if(O)return F=F||f(O,z),F[re];const U=_[re];return typeof re=="string"?M(U,`${z}.${re}`):U},set:(_,re,U)=>(B(),F&&(F[re]=U),!0),deleteProperty:(_,re)=>(B(),F&&delete F[re],!0),defineProperty:(_,re,U)=>(B(),F&&Object.defineProperty(F,re,U),!0)})}return Array.isArray(j)?(0,r.$bo)(j):j};L=M(L,b)}return L},update:(b,v,L,O)=>{b=l?`${l}.${b}`:b;const M=C(L);return v!==void 0?this.b.$updateConfigurationOption(M,b,v,D,O):this.b.$removeConfigurationOption(M,b,D,O)},inspect:b=>{b=l?`${l}.${b}`:b;const v=this.e.inspect(b,D,this.c.workspace);if(v)return{key:b,defaultValue:(0,r.$bo)(v.policy?.value??v.default?.value),globalValue:(0,r.$bo)(v.user?.value??v.application?.value),workspaceValue:(0,r.$bo)(v.workspace?.value),workspaceFolderValue:(0,r.$bo)(v.workspaceFolder?.value),defaultLanguageValue:(0,r.$bo)(v.default?.override),globalLanguageValue:(0,r.$bo)(v.user?.override??v.application?.override),workspaceLanguageValue:(0,r.$bo)(v.workspace?.override),workspaceFolderLanguageValue:(0,r.$bo)(v.workspaceFolder?.override),languageIds:(0,r.$bo)(v.overrideIdentifiers)}}};return typeof y=="object"&&(0,r.$eo)(A,y,!1),Object.freeze(A)}g(l){const w=S=>(0,I.$hg)(S)?new Proxy(S,{get:(D,y)=>w(D[y]),set:(D,y,C)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(y)}' of object`)},deleteProperty:(D,y)=>{throw new Error(`TypeError: Cannot delete read only property '${String(y)}' of object`)},defineProperty:(D,y)=>{throw new Error(`TypeError: Cannot define property '${String(y)}' for a readonly object`)},setPrototypeOf:D=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):S;return w(l)}h(l,w,S){const D=c.$Do.test(l)?c.ConfigurationScope.RESOURCE:this.d.get(l),y=S?`[${S.value}] `:"";if(c.ConfigurationScope.RESOURCE===D){typeof w?.resource>"u"&&this.f.warn(`${y}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${l}', provide the URI of a resource or 'null' for any resource.`);return}if(c.ConfigurationScope.WINDOW===D){w?.resource&&this.f.warn(`${y}Accessing a window scoped configuration for a resource is not expected. To associate '${l}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(l,w){const S=new $.$Oo(l,w,this.e,this.c.workspace,this.f);return Object.freeze({affectsConfiguration:(D,y)=>S.affectsConfiguration(D,t(y))})}k(l){return l.reduce((w,S)=>(w.set(S[0],S[1]),w),new Map)}}e.$foc=s,e.$goc=(0,u.$Fi)("IExtHostConfiguration")}),define(Ee[101],ye([1,0,2,9,4,6,10,48,64,42,21,47,20,30,5,15,11,12,96,324,14]),function(ce,e,r,h,P,R,T,N,$,c,I,E,u,k,p,a,f,d,m,n,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ppc=e.$Opc=e.$Npc=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0,T=We(T),f=We(f);var t;(function(O){function M(z){if(z!=null)return z}O.from=M;function j(z){if(z!=null)return z}O.to=j})(t||(t={}));var i;(function(O){function M(z){if(z!=null)return z}O.from=M;function j(z){if(z!=null)return z}O.to=j})(i||(i={}));var s;(function(O){function M(z){if(z!=null)return z}O.from=M;function j(z){if(z!=null)return z}O.to=j})(s||(s={}));var g;(function(O){function M(F){if(F){const B=F;return B&&!!B.process}else return!1}O.is=M;function j(F){if(F==null)return;const B={process:F.process,args:F.args};return F.options&&(B.options=s.from(F.options)),B}O.from=j;function z(F){if(F!=null)return new T.$dO(F.process,F.args,F.options)}O.to=z})(g||(g={}));var l;(function(O){function M(z){if(z!=null)return z}O.from=M;function j(z){if(z!=null)return z}O.to=j})(l||(l={}));var w;(function(O){function M(F){if(F){const B=F;return B&&(!!B.commandLine||!!B.command)}else return!1}O.is=M;function j(F){if(F==null)return;const B={};return F.commandLine!==void 0?B.commandLine=F.commandLine:(B.command=F.command,B.args=F.args),F.options&&(B.options=l.from(F.options)),B}O.from=j;function z(F){if(!(F==null||F.command===void 0&&F.commandLine===void 0))return F.commandLine?new T.$eO(F.commandLine,F.options):new T.$eO(F.command,F.args?F.args:[],F.options)}O.to=z})(w||(w={}));var S;(function(O){function M(F){if(F){const B=F;return B&&B.customExecution==="customExecution"}else return!1}O.is=M;function j(F){return{customExecution:"customExecution"}}O.from=j;function z(F,B){return B.get(F)}O.to=z})(S||(e.CustomExecutionDTO=S={}));var D;(function(O){function M(j,z){let F;return j.scope!==void 0&&typeof j.scope!="number"?F=j.scope.uri:j.scope!==void 0&&typeof j.scope=="number"&&(j.scope===T.TaskScope.Workspace&&z&&z.workspaceFile?F=z.workspaceFile:F=n.$FI),{id:j._id,workspaceFolder:F}}O.from=M})(D||(e.TaskHandleDTO=D={}));var y;(function(O){function M(j){if(j!=null)return{_id:j.id,isDefault:j.isDefault}}O.from=M})(y||(y={}));var C;(function(O){function M(F,B){if(F==null)return[];const _=[];for(const re of F){const U=j(re,B);U&&_.push(U)}return _}O.fromMany=M;function j(F,B){if(F==null)return;let _;F.execution instanceof T.$dO?_=g.from(F.execution):F.execution instanceof T.$eO?_=w.from(F.execution):F.execution&&F.execution instanceof T.$fO&&(_=S.from(F.execution));const re=t.from(F.definition);let U;return F.scope?typeof F.scope=="number"?U=F.scope:U=F.scope.uri:U=T.TaskScope.Workspace,!re||!U?void 0:{_id:F._id,definition:re,name:F.name,source:{extensionId:B.identifier.value,label:F.source,scope:U},execution:_,isBackground:F.isBackground,group:y.from(F.group),presentationOptions:i.from(F.presentationOptions),problemMatchers:F.problemMatchers,hasDefinedMatchers:F.hasDefinedMatchers,runOptions:F.runOptions?F.runOptions:{reevaluateOnRerun:!0},detail:F.detail}}O.from=j;async function z(F,B,_){if(F==null)return;let re;g.is(F.execution)?re=g.to(F.execution):w.is(F.execution)?re=w.to(F.execution):S.is(F.execution)&&(re=S.to(F._id,_));const U=t.to(F.definition);let G;if(F.source&&(F.source.scope!==void 0?typeof F.source.scope=="number"?G=F.source.scope:G=await B.resolveWorkspaceFolder(r.URI.revive(F.source.scope)):G=T.TaskScope.Workspace),!U||!G)return;const Q=new T.$gO(U,G,F.name,F.source.label,re,F.problemMatchers);return F.isBackground!==void 0&&(Q.isBackground=F.isBackground),F.group!==void 0&&(Q.group=T.$cO.from(F.group._id),Q.group&&F.group.isDefault&&(Q.group=new T.$cO(Q.group.id,Q.group.label),F.group.isDefault===!0&&(Q.group.isDefault=F.group.isDefault))),F.presentationOptions&&(Q.presentationOptions=i.to(F.presentationOptions)),F._id&&(Q._id=F._id),F.detail&&(Q.detail=F.detail),Q}O.to=z})(C||(e.TaskDTO=C={}));var A;(function(O){function M(z){return z}O.from=M;function j(z){if(z)return Object.assign(Object.create(null),z)}O.to=j})(A||(A={}));class b{#e;constructor(M,j,z){this._id=j,this.a=z,this.#e=M}get task(){return this.a}terminate(){this.#e.terminateTask(this)}fireDidStartProcess(M){}fireDidEndProcess(M){}}let v=class{constructor(M,j,z,F,B,_,re,U){this.q=new P.$me,this.r=new P.$me,this.s=new P.$me,this.u=new P.$me,this.a=M.getProxy(R.$rN.MainThreadTask),this.b=z,this.c=F,this.d=B,this.e=_,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=re,this.g=U,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(M,j,z){if(!z)return new T.$tN(()=>{});const F=this.x();return this.j.set(F,{type:j,provider:z,extension:M}),this.a.$registerTaskProvider(F,j),new T.$tN(()=>{this.j.delete(F),this.a.$unregisterTaskProvider(F)})}registerTaskSystem(M,j){this.a.$registerTaskSystem(M,j)}fetchTasks(M){return this.a.$fetchTasks(A.from(M)).then(async j=>{const z=[];for(const F of j){const B=await C.to(F,this.b,this.m);B&&z.push(B)}return z})}get taskExecutions(){const M=[];return this.k.forEach(j=>M.push(j)),M}terminateTask(M){if(!(M instanceof b))throw new Error("No valid task execution provided");return this.a.$terminateTask(M._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(M,j,z){const F=this.m.get(M.id);F&&(this.o.set(M.id,F),this.e.attachPtyToTerminal(j,await F.callback(z))),this.p=M.id,this.q.fire({execution:await this.z(M)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(M){if(!this.l.has(M.id))return;const j=await this.z(M);this.l.delete(M.id),this.k.delete(M.id),this.B(M),this.r.fire({execution:j})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(M){const j=await this.z(M.id);this.s.fire({execution:j,processId:M.processId})}get onDidEndTaskProcess(){return this.u.event}async $onDidEndTaskProcess(M){const j=await this.z(M.id);this.u.fire({execution:j,exitCode:M.exitCode})}$provideTasks(M,j){const z=this.j.get(M);if(!z)return Promise.reject(new Error("no handler found"));const F=[],B=(0,h.$xh)(()=>z.provider.provideTasks(I.CancellationToken.None)).then(_=>this.v(j,F,z,_));return new Promise(_=>{B.then(re=>{Promise.all(F).then(()=>{_(re)})})})}async $resolveTask(M,j){const z=this.j.get(M);if(!z)return Promise.reject(new Error("no handler found"));if(j.definition.type!==z.type)throw new Error(`Unexpected: Task of type [${j.definition.type}] cannot be resolved by provider of type [${z.type}].`);const F=await C.to(j,this.b,this.m);if(!F)throw new Error("Unexpected: Task cannot be resolved.");const B=await z.provider.resolveTask(F,I.CancellationToken.None);if(!B)return;this.A(B,z);const _=C.from(B,z.extension);if(!_)throw new Error("Unexpected: Task cannot be resolved.");if(B.definition!==F.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return S.is(_.execution)&&await this.y(_,B,!0),await this.w(_)}x(){return this.h++}async y(M,j,z){const F=await this.a.$createTaskId(M);!z&&!this.m.has(F)&&(this.n.add(F),this.o.set(F,j.execution)),this.m.set(F,j.execution)}async z(M,j){if(typeof M=="string"){const B=this.l.get(M);if(!B)throw new o.$db("Unexpected: The specified task is missing an execution");return B}const z=this.l.get(M.id);if(z)return z;let F;return j?F=Promise.resolve(new b(this,M.id,j)):F=C.to(M.task,this.b,this.m).then(B=>{if(!B)throw new o.$db("Unexpected: Task does not exist.");return new b(this,M.id,B)}),this.l.set(M.id,F),F.then(B=>(this.k.set(M.id,B),B))}A(M,j){M._deprecated&&this.g.report("Task.constructor",j.extension,"Use the Task constructor that takes a `scope` instead.")}B(M){this.o.get(M.id)&&this.o.delete(M.id),this.n.has(M.id)&&this.p!==M.id&&(this.m.delete(M.id),this.n.delete(M.id));const z=this.n.values();let F=z.next();for(;!F.done;)!this.o.has(F.value)&&this.p!==F.value&&(this.m.delete(F.value),this.n.delete(F.value)),F=z.next()}};e.$Npc=v,e.$Npc=v=Je([Ge(0,u.$XP),Ge(1,k.$bQ),Ge(2,N.$doc),Ge(3,$.$9P),Ge(4,c.$goc),Ge(5,E.$Eoc),Ge(6,d.$_j),Ge(7,m.$Tnc)],v);let L=class extends v{constructor(M,j,z,F,B,_,re,U){super(M,j,z,F,B,_,re,U),this.registerTaskSystem(a.Schemas.vscodeRemote,{scheme:a.Schemas.vscodeRemote,authority:"",platform:f.$h(f.Platform.Web)})}async executeTask(M,j){if(!j.execution)throw new Error("Tasks to execute must include an execution");const z=C.from(j,M);if(z===void 0)throw new Error("Task is not valid");if(S.is(z.execution))await this.y(z,j,!1);else throw new o.$bb;const F=await this.z(await this.a.$getTaskExecution(z),j);return this.a.$executeTask(z).catch(B=>{throw new Error(B)}),F}v(M,j,z,F){const B=[];if(F)for(const _ of F){if(this.A(_,z),!_.definition||!M[_.definition.type]){const U=_.source?_.source:"No task source";this.f.warn(`The task [${U}, ${_.name}] uses an undefined task type. The task will be ignored in the future.`)}const re=C.from(_,z.extension);re&&S.is(re.execution)?(B.push(re),j.push(this.y(re,_,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:B,extension:z.extension}}async w(M){if(S.is(M.execution))return M;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(M,j){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(M,j,z){}};e.$Opc=L,e.$Opc=L=Je([Ge(0,u.$XP),Ge(1,k.$bQ),Ge(2,N.$doc),Ge(3,$.$9P),Ge(4,c.$goc),Ge(5,E.$Eoc),Ge(6,d.$_j),Ge(7,m.$Tnc)],L),e.$Ppc=(0,p.$Fi)("IExtHostTask")}),define(Ee[385],ye([1,0,38,31]),function(ce,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eM=void 0,e.$dM=P,e.$fM=R;function P(T){return"cellResults"in T}e.$eM="rawCell#";function R(T,N){let $=-1;const c=[];let I=[];return T.forEach(u=>{u.range.startLineNumber!==$&&I.length>0&&(c.push([...I]),I=[]),I.push(u),$=u.range.endLineNumber}),I.length>0&&c.push([...I]),c.map(u=>{const k=[],p=u[0].range.startLineNumber,a=u[u.length-1].range.endLineNumber;for(let f=p;f<=a;f++)k.push(N.getLineContent(f));return new r.$TL(k.join(`
`)+`
`,u.map(f=>new h.$Ht(f.range.startLineNumber-1,f.range.startColumn-1,f.range.endLineNumber-1,f.range.endColumn-1)))})}}),define(Ee[386],ye([1,0,238,22,4,3,29,41,13,18,2,28,119,6,35,17,10,51,358,164,25,15,38,313,385,382]),function(ce,e,r,h,P,R,T,N,$,c,I,E,u,k,p,a,f,d,m,n,o,t,i,s,g,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qpc=void 0,E=We(E),a=We(a),f=We(f);class w{static{this.a=0}get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(D=>D.apiEditor)}constructor(D,y,C,A,b,v,L){this.q=C,this.r=A,this.s=b,this.t=v,this.u=L,this.f=new Map,this.g=new T.$Cc,this.h=new Map,this.j=new P.$me,this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new P.$me,this.onDidOpenNotebookDocument=this.m.event,this.n=new P.$me,this.onDidCloseNotebookDocument=this.n.event,this.o=new P.$me,this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new u.$Rnc("NotebookCellStatusBarCache"),this.x=0,this.y=new Map,this.b=D.getProxy(k.$rN.MainThreadNotebook),this.c=D.getProxy(k.$rN.MainThreadNotebookDocuments),this.d=D.getProxy(k.$rN.MainThreadNotebookEditors),this.i=y.converter,y.registerArgumentProcessor({processArgument:O=>{if(O&&O.$mid===N.MarshalledId.NotebookCellActionContext){const M=O.notebookEditor?.notebookUri,j=O.cell.handle,F=this.g.get(M)?.getCell(j);if(F)return F.apiCell}if(O&&O.$mid===N.MarshalledId.NotebookActionContext){const M=O.uri,j=this.g.get(M);if(j)return j.apiNotebook}return O}}),w.C(y)}getEditorById(D){const y=this.h.get(D);if(!y)throw new Error(`unknown text editor: ${D}. known editors: ${[...this.h.keys()]} `);return y}getIdByEditor(D){for(const[y,C]of this.h)if(C.apiEditor===D)return y}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(D,y){const C=this.g.get(D);if(!C&&!y)throw new Error(`NO notebook document for '${D}'`);return C}static w(D,y){if(!y)return;const C=y.filenamePattern.map(A=>a.NotebookExclusiveDocumentPattern.from(A)).filter(A=>A!==void 0);if(y.filenamePattern&&!C){console.warn(`Notebook content provider view options file name pattern is invalid ${y.filenamePattern}`);return}return{extension:D.identifier,providerDisplayName:D.displayName||D.name,displayName:y.displayName,filenamePattern:C,priority:y.exclusive?l.RegisteredEditorPriority.exclusive:void 0}}registerNotebookCellStatusBarItemProvider(D,y,C){const A=w.a++,b=typeof C.onDidChangeCellStatusBarItems=="function"?w.a++:void 0;this.f.set(A,C),this.b.$registerNotebookCellStatusBarItemProvider(A,b,y);let v;return b!==void 0&&(v=C.onDidChangeCellStatusBarItems(L=>this.b.$emitCellStatusBarEvent(b))),new f.$tN(()=>{this.f.delete(A),this.b.$unregisterNotebookCellStatusBarItemProvider(A,b),v?.dispose()})}async createNotebookDocument(D){const y=await this.c.$tryCreateNotebook({viewType:D.viewType,content:D.content&&a.NotebookData.from(D.content)});return I.URI.revive(y)}async openNotebookDocument(D){const y=this.g.get(D);if(y)return y.apiNotebook;const C=await this.c.$tryOpenNotebook(D),A=this.g.get(I.URI.revive(C));return(0,c.$qg)(A?.apiNotebook)}async showNotebookDocument(D,y){I.URI.isUri(D)&&(D=await this.openNotebookDocument(D));let C;typeof y=="object"?C={position:a.ViewColumn.from(y.viewColumn),preserveFocus:y.preserveFocus,selections:y.selections&&y.selections.map(a.NotebookRange.from),pinned:typeof y.preview=="boolean"?!y.preview:void 0}:C={preserveFocus:!1};const A=await this.d.$tryShowNotebookDocument(D.uri,D.notebookType,C),b=A&&this.h.get(A)?.apiEditor;if(b)return b;throw A?new Error(`Could NOT open editor for "${D.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${D.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(D,y,C,A){const b=this.f.get(D),v=I.URI.revive(y),L=this.g.get(v);if(!L||!b)return;const O=L.getCellFromIndex(C);if(!O)return;const M=await b.provideCellStatusBarItems(O.apiCell,A);if(!M)return;const j=new R.$Vc,z=this.p.add([j]),B=(Array.isArray(M)?M:[M]).map(_=>a.NotebookStatusBarItem.from(_,this.i,j));return{cacheId:z,items:B}}$releaseNotebookCellStatusBarItems(D){this.p.delete(D)}registerNotebookSerializer(D,y,C,A,b){if((0,$.$df)(y))throw new Error("viewType cannot be empty or just whitespace");const v=this.x++;return this.y.set(v,{viewType:y,serializer:C,options:A}),this.b.$registerNotebookSerializer(v,{id:D.identifier,location:D.extensionLocation},y,a.NotebookDocumentContentOptions.from(A),w.w(D,b)),(0,R.$Uc)(()=>{this.b.$unregisterNotebookSerializer(v)})}async $dataToNotebook(D,y,C){const A=this.y.get(D);if(!A)throw new Error("NO serializer found");const b=await A.serializer.deserializeNotebook(y.buffer,C);return new d.$Pw(a.NotebookData.from(b))}async $notebookToData(D,y,C){const A=this.y.get(D);if(!A)throw new Error("NO serializer found");const b=await A.serializer.serializeNotebook(a.NotebookData.to(y.value),C);return h.$Oe.wrap(b)}async $saveNotebook(D,y,C,A,b){const v=I.URI.revive(y),L=this.y.get(D);if(this.D(`enter saveNotebook(versionId: ${C}, ${v.toString()})`),!L)throw new Error("NO serializer found");const O=this.g.get(v);if(!O)throw new Error("Document NOT found");if(O.versionId!==C)throw new Error("Document version mismatch");if(!this.s.value.isWritableFileSystem(v.scheme))throw new E.$ul((0,r.localize)(0,null,this.A(v)),E.FileOperationResult.FILE_PERMISSION_DENIED);const M={metadata:(0,o.$jo)(O.apiNotebook.metadata,_=>!(L.options?.transientDocumentMetadata??{})[_]),cells:[]};for(const _ of O.apiNotebook.getCells()){const re=new f.$WO(_.kind,_.document.getText(),_.document.languageId,_.mime,L.options?.transientOutputs?[]:[..._.outputs],_.metadata,_.executionSummary);re.metadata=(0,o.$jo)(_.metadata,U=>!(L.options?.transientCellMetadata??{})[U]),M.cells.push(re)}if(await this.z(v,A),b.isCancellationRequested)throw new Error("canceled");const j=await L.serializer.serializeNotebook(M,b);if(b.isCancellationRequested)throw new Error("canceled");this.D(`serialized versionId: ${C} ${v.toString()}`),await this.s.value.writeFile(v,j),this.D(`Finished write versionId: ${C} ${v.toString()}`);const z=this.s.getFileSystemProviderExtUri(v.scheme),F=await this.s.value.stat(v),B={name:z.basename(v),isFile:(F.type&E.FileType.File)!==0,isDirectory:(F.type&E.FileType.Directory)!==0,isSymbolicLink:(F.type&E.FileType.SymbolicLink)!==0,mtime:F.mtime,ctime:F.ctime,size:F.size,readonly:!!((F.permissions??0)&E.FilePermission.Readonly)||!this.s.value.isWritableFileSystem(v.scheme),locked:!!((F.permissions??0)&E.FilePermission.Locked),etag:E.$Fl({mtime:F.mtime,size:F.size}),children:void 0};return this.D(`exit saveNotebook(versionId: ${C}, ${v.toString()})`),B}async $searchInNotebooks(D,y,C,A,b){const v=this.y.get(D)?.serializer;if(!v)return{limitHit:!1,results:[]};const L=new T.$Dc;await(async(F,B,_)=>{await Promise.all(F.map(async re=>await Promise.all(re.filenamePatterns.map(U=>{const G={_reason:_._reason,folderQueries:_.folderQueries,includePattern:_.includePattern,excludePattern:_.excludePattern,maxResults:_.maxResults,type:i.QueryType.File,filePattern:U};return this.t.doInternalFileSearchWithCustomCallback(G,B,Q=>{Q.forEach(ee=>{L.has(ee)||A.some(ne=>re.isFromSettings&&!ne.isFromSettings?!1:ne.filenamePatterns.some(De=>(0,l.$eL)(De,ee)))||L.add(ee)})}).catch(Q=>{if(Q.code==="ENOENT")return console.warn("Could not find notebook search results, ignoring notebook results."),{limitHit:!1,messages:[]};throw Q})}))))})(C,b,y);const M=new T.$Cc;let j=!1;const z=Array.from(L).map(async F=>{const B=[];try{if(b.isCancellationRequested)return;if(y.maxResults&&[...M.values()].reduce((G,Q)=>G+Q.cellResults.length,0)>y.maxResults){j=!0;return}const _=[],re=this.g.get(F);if(re)re.apiNotebook.getCells().forEach(Q=>_.push({input:Q.document.getText(),outputs:Q.outputs.flatMap(ee=>ee.items.map(he=>he.data.toString()))}));else{const G=await this.s.value.readFile(F),Q=h.$Oe.fromString(G.toString()),ee=await v.deserializeNotebook(Q.buffer,b);if(b.isCancellationRequested)return;a.NotebookData.from(ee).cells.forEach(ne=>_.push({input:ne.source,outputs:ne.outputs.flatMap(De=>De.items.map($e=>$e.valueBytes.toString()))}))}if(b.isCancellationRequested)return;_.forEach((G,Q)=>{const ee=y.contentPattern.pattern,he=new s.$cZb(G.input,void 0,G.outputs),ne=he.findInInputs(ee),De=he.findInOutputs(ee),$e=De.flatMap(K=>(0,g.$fM)(K.matches,K.textBuffer)).map((K,W)=>(K.webviewIndex=W,K));if(ne.length>0||De.length>0){const K={index:Q,contentResults:(0,g.$fM)(ne,he.inputTextBuffer),webviewResults:$e};B.push(K)}});const U={resource:F,cellResults:B};M.set(F,U);return}catch{return}});return await Promise.all(z),{limitHit:j,results:[...M.values()]}}async z(D,y){const C=await this.s.value.stat(D);if(typeof y?.mtime=="number"&&typeof y.etag=="string"&&y.etag!==E.$El&&typeof C.mtime=="number"&&typeof C.size=="number"&&y.mtime<C.mtime&&y.etag!==E.$Fl({mtime:y.mtime,size:C.size}))throw new E.$ul((0,r.localize)(1,null),E.FileOperationResult.FILE_MODIFIED_SINCE,y)}A(D){return D.scheme===t.Schemas.file?D.fsPath:D.toString()}B(D,y,C){if(this.h.has(y))throw new Error(`editor with id ALREADY EXSIST: ${y}`);const A=new n.$hpc(y,this.d,D,C.visibleRanges.map(a.NotebookRange.to),C.selections.map(a.NotebookRange.to),typeof C.viewColumn=="number"?a.ViewColumn.to(C.viewColumn):void 0);this.h.set(y,A)}$acceptDocumentAndEditorsDelta(D){if(D.value.removedDocuments)for(const C of D.value.removedDocuments){const A=I.URI.revive(C),b=this.g.get(A);b&&(b.dispose(),this.g.delete(A),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:b.apiNotebook.getCells().map(v=>v.document.uri)}),this.n.fire(b.apiNotebook));for(const v of this.h.values())v.notebookData.uri.toString()===A.toString()&&this.h.delete(v.id)}if(D.value.addedDocuments){const C=[];for(const A of D.value.addedDocuments){const b=I.URI.revive(A.uri);if(this.g.has(b))throw new Error(`adding EXISTING notebook ${b} `);const v=new m.$gpc(this.c,this.q,this.r,b,A);C.push(...A.cells.map(L=>m.$fpc.asModelAddData(L))),this.g.get(b)?.dispose(),this.g.set(b,v),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:C}),this.m.fire(v.apiNotebook)}}if(D.value.addedEditors)for(const C of D.value.addedEditors){if(this.h.has(C.id))return;const A=I.URI.revive(C.documentUri),b=this.g.get(A);b&&this.B(b,C.id,C)}const y=[];if(D.value.removedEditors)for(const C of D.value.removedEditors){const A=this.h.get(C);A&&(this.h.delete(C),this.k?.id===A.id&&(this.k=void 0),y.push(A))}if(D.value.visibleEditors){this.l=D.value.visibleEditors.map(A=>this.h.get(A)).filter(A=>!!A);const C=new Set;this.l.forEach(A=>C.add(A.id));for(const A of this.h.values()){const b=C.has(A.id);A._acceptVisibility(b)}this.l=[...this.h.values()].map(A=>A).filter(A=>A.visible),this.o.fire(this.visibleNotebookEditors)}D.value.newActiveEditor===null?this.k=void 0:D.value.newActiveEditor&&(this.h.get(D.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${D.value.newActiveEditor}`),this.k=this.h.get(D.value.newActiveEditor)),D.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static C(D){const y=p.$jQ.String.with("notebookType","A notebook type"),C=new p.$lQ("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[y,new p.$jQ("data","Bytes to convert to data",b=>b instanceof Uint8Array,b=>h.$Oe.wrap(b))],new p.$kQ("Notebook Data",b=>a.NotebookData.to(b.value))),A=new p.$lQ("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[y,new p.$jQ("NotebookData","Notebook data to convert to bytes",b=>!0,b=>new d.$Pw(a.NotebookData.from(b)))],new p.$kQ("Bytes",b=>b.buffer));D.registerApiCommand(C),D.registerApiCommand(A)}D(D){this.u.trace(`[Extension Host Notebook] ${D}`)}}e.$qpc=w}),define(Ee[387],ye([1,0,16,21,55,39,23,43,38]),function(ce,e,r,h,P,R,T,N,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ipc=void 0,r=We(r),R=We(R),T=We(T);class c{constructor(u,k,p){this.k=u,this.l=k,this.o=p,this.e=!1,this.f=0,this.g=!1,this.a=u.filePattern,this.b=u.includePattern&&R.$zk(u.includePattern),this.c=u.maxResults||void 0,this.d=u.exists,this.h=new Set,this.j=u.excludePattern&&R.$zk(u.excludePattern)}cancel(){this.g=!0,this.h.forEach(u=>u.cancel()),this.h=new Set}search(u){const k=this.k.folderQueries||[];return new Promise((p,a)=>{const f=d=>{this.f++,u(d)};if(this.g)return p({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(d=>{const m=d.toString(),n=r.$pc(m);this.j&&this.j(m,n)||this.v(f,{base:d,basename:n})}),Promise.all(k.map(d=>this.p(d,f))).then(d=>{p({limitHit:this.e,stats:d[0]||void 0})},d=>{a(new Error((0,P.$qj)(d)))})})}async p(u,k){const p=new h.$xe,a=this.q(u),f=this.r(),d=new $.$8L(this.k,u),m=!d.hasSiblingExcludeClauses();let n;try{this.h.add(p),n=N.$ge.create();const o=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},a,p.token),t=n.elapsed(),i=N.$ge.create();return this.g&&!this.e||(o&&o.forEach(s=>{const g=r.$ic.relative(u.folder.path,s.path);if(m){const l=r.$pc(s.path);this.v(k,{base:u.folder,relativePath:g,basename:l});return}this.s(f,u.folder,g,k)}),this.g&&!this.e)?null:(this.u(f,d,k),{providerTime:t,postProcessTime:i.elapsed()})}finally{p.dispose(),this.h.delete(p)}}q(u){const k=(0,$.$7L)(this.k.includePattern,u.includePattern),p=(0,$.$7L)(this.k.excludePattern,u.excludePattern);return{folder:u.folder,excludes:p,includes:k,useIgnoreFiles:!u.disregardIgnoreFiles,useGlobalIgnoreFiles:!u.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!u.disregardParentIgnoreFiles,followSymlinks:!u.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const u={rootEntries:[],pathToEntries:Object.create(null)};return u.pathToEntries["."]=u.rootEntries,u}s({pathToEntries:u},k,p,a){if(p===this.a){const d=r.$pc(this.a);this.v(a,{base:k,relativePath:this.a,basename:d})}function f(d){const m=r.$pc(d),n=r.$oc(d);let o=u[n];o||(o=u[n]=[],f(n)),o.push({base:k,relativePath:d,basename:m})}f(p)}u({rootEntries:u,pathToEntries:k},p,a){const f=this,d=this.a;function m(n){const o=(0,$.$0L)(()=>n.map(t=>t.basename));for(let t=0,i=n.length;t<i;t++){const s=n[t],{relativePath:g,basename:l}=s;if(p.matchesExcludesSync(g,l,d!==l?o:void 0))continue;const w=k[g];if(w)m(w);else{if(g===d)continue;f.v(a,s)}if(f.e)break}}m(u)}v(u,k){(!this.b||k.relativePath&&this.b(k.relativePath,k.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||u(k))}}class I{constructor(){this.b=new Map}static{this.a=512}fileSearch(u,k,p,a){const f=this.c(u.cacheKey),d=new c(u,k,f&&f.token);let m=0;const n=o=>{m+=o.length,p(o.map(t=>this.d(t)))};return this.e(d,I.a,n,a).then(o=>({limitHit:o.limitHit,stats:o.stats?{fromCache:!1,type:"fileSearchProvider",resultCount:m,detailStats:o.stats}:void 0,messages:[]}))}clearCache(u){this.c(u)?.cancel()}c(u){if(u)return this.b.has(u)||this.b.set(u,new h.$xe),this.b.get(u)}d(u){return u.relativePath?{resource:T.$gh(u.base,u.relativePath)}:{resource:u.base}}e(u,k,p,a){const f=a.onCancellationRequested(()=>{u.cancel()}),d=n=>{n&&(m.push(n),k>0&&m.length>=k&&(p(m),m=[]))};let m=[];return u.search(d).then(n=>(m.length&&p(m),f.dispose(),n),n=>(m.length&&p(m),f.dispose(),Promise.reject(n)))}}e.$ipc=I}),define(Ee[388],ye([1,0,19,79,39,110,29,15,16,23,13,18,2,107,261,45,12,46,156,383,38]),function(ce,e,r,h,P,R,T,N,$,c,I,E,u,k,p,a,f,d,m,n,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8M=void 0,e.$9M=y,r=We(r),h=We(h),P=We(P),$=We($),I=We(I),p=We(p);let t=class{constructor(A,b,v,L,O){this.a=A,this.b=b,this.c=v,this.d=L,this.e=O}text(A,b,v={}){A=this.f(A,v);const L=this.a.getValue(),O=b&&b.some(j=>!this.a.getValue({resource:j}).search.useRipgrep);return{...this.h(b?.map(d.$1i),v),type:o.QueryType.Text,contentPattern:A,previewOptions:v.previewOptions,maxFileSize:v.maxFileSize,usePCRE2:L.search.usePCRE2||O||!1,beforeContext:v.beforeContext,afterContext:v.afterContext,userDisabledExcludesAndIgnoreFiles:v.disregardExcludeSettings&&v.disregardIgnoreFiles}}f(A,b){const v=this.a.getValue();A.isRegExp&&(A.pattern=A.pattern.replace(/\r?\n/g,"\\n"));const L={...A,wordSeparators:v.editor.wordSeparators};return this.j(A,b)&&(L.isCaseSensitive=!0),this.k(A)&&(L.isMultiline=!0),b.notebookSearchConfig?.includeMarkupInput&&(L.notebookInfo||(L.notebookInfo={}),L.notebookInfo.isInNotebookMarkdownInput=b.notebookSearchConfig.includeMarkupInput),b.notebookSearchConfig?.includeMarkupPreview&&(L.notebookInfo||(L.notebookInfo={}),L.notebookInfo.isInNotebookMarkdownPreview=b.notebookSearchConfig.includeMarkupPreview),b.notebookSearchConfig?.includeCodeInput&&(L.notebookInfo||(L.notebookInfo={}),L.notebookInfo.isInNotebookCellInput=b.notebookSearchConfig.includeCodeInput),b.notebookSearchConfig?.includeOutput&&(L.notebookInfo||(L.notebookInfo={}),L.notebookInfo.isInNotebookCellOutput=b.notebookSearchConfig.includeOutput),L}file(A,b={}){return{...this.h(A,b),type:o.QueryType.File,filePattern:b.filePattern?b.filePattern.trim():b.filePattern,exists:b.exists,sortByScore:b.sortByScore,cacheKey:b.cacheKey,shouldGlobMatchFilePattern:b.shouldGlobSearch}}g(A,b){return A?(A=Array.isArray(A)?A.map(w):w(A),b?this.parseSearchPaths(A):{pattern:s(...Array.isArray(A)?A:[A])}):{}}h(A=[],b={}){const v=this.g(b.includePattern,b.expandPatterns),L=this.g(b.excludePattern,b.expandPatterns),O=A.length>1,M=(v.searchPaths&&v.searchPaths.length?v.searchPaths.map(F=>this.q(F,b,L)):A.map(F=>this.r(F,b,L,O))).filter(F=>!!F),j={_reason:b._reason,folderQueries:M,usingSearchPaths:!!(v.searchPaths&&v.searchPaths.length),extraFileResources:b.extraFileResources,excludePattern:L.pattern,includePattern:v.pattern,onlyOpenEditors:b.onlyOpenEditors,maxResults:b.maxResults};if(b.onlyOpenEditors){const F=r.$Jb(this.c.groups.flatMap(re=>re.editors.map(U=>U.resource)));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(F));const B=F.filter(re=>(0,o.$XL)(j,re.fsPath)),_=this.i(B);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(_)),{...j,..._}}const z=b.extraFileResources&&b.extraFileResources.filter(F=>(0,o.$XL)(j,F.fsPath));return j.extraFileResources=z&&z.length?z:void 0,j}i(A){const b=[],v=new T.$Cc,L={};let O=!1;return A.forEach(M=>{if(M.scheme===N.Schemas.walkThrough)return;if((0,c.$kh)(M)){const z=this.b.getWorkspaceFolder(M)?.uri??M.with({path:$.$oc(M.fsPath)});let F=v.get(z);F||(O=!0,F={folder:z,includePattern:{}},b.push(F),v.set(z,F));const B=$.$nc(z.fsPath,M.fsPath);(0,E.$qg)(F.includePattern)[B.replace(/\\/g,"/")]=!0}else M.fsPath&&(O=!0,L[M.fsPath]=!0)}),{folderQueries:b,includePattern:L,usingSearchPaths:!0,excludePattern:O?void 0:{"**/*":!0}}}j(A,b){if(b.isSmartCase){if(A.isRegExp){if(I.$9f(A.pattern,!0))return!0}else if(I.$9f(A.pattern))return!0}return!!A.isCaseSensitive}k(A){return A.isMultiline||A.isRegExp&&(0,k.$0C)(A.pattern)||A.pattern.indexOf(`
`)>=0?!0:!!A.isMultiline}parseSearchPaths(A){const b=_=>$.$kc(_)||/^\.\.?([\/\\]|$)/.test(_),L=(Array.isArray(A)?A:g(A)).map(_=>{const re=this.e.resolvedUserHome;return re?(0,R.$Uw)(_,re.scheme===N.Schemas.file?re.fsPath:re.path):_}),O=h.$K(L,_=>b(_)?"searchPaths":"exprSegments"),M=(O.exprSegments||[]).map(_=>I.$of(_,"/")).map(_=>I.$of(_,"\\")).map(_=>(_[0]==="."&&(_="*"+_),l(_))),j={},z=this.m(O.searchPaths||[]);z&&z.length&&(j.searchPaths=z);const F=M.flat(),B=s(...F);return B&&(j.pattern=B),j}l(A,b){return b.disregardExcludeSettings?void 0:(0,o.$WL)(A,!b.disregardSearchExcludeSettings)}m(A){if(!A||!A.length)return[];const b=A.flatMap(L=>{let{pathPortion:O,globPortion:M}=i(L);return M&&(M=S(M)),this.n(O).flatMap(z=>this.o(z,M))}),v=new Map;return b.forEach(L=>{const O=L.searchPath.toString(),M=v.get(O);M?L.pattern&&(M.pattern=M.pattern||{},M.pattern[L.pattern]=!0):v.set(O,{searchPath:L.searchPath,pattern:L.pattern?s(L.pattern):void 0})}),Array.from(v.values())}n(A){if($.$kc(A)){const b=this.b.getWorkspace().folders;return b[0]&&b[0].uri.scheme!==N.Schemas.file?[{searchPath:b[0].uri.with({path:A})}]:[{searchPath:u.URI.file($.$jc(A))}]}if(this.b.getWorkbenchState()===d.WorkbenchState.FOLDER){const b=this.b.getWorkspace().folders[0].uri;if(A=w(A),A.startsWith("../")||A===".."){const L=$.$ic.resolve(b.path,A);return[{searchPath:b.with({path:L})}]}const v=S(A);return[{searchPath:b,pattern:v}]}else{if(A==="./"||A===".\\")return[];{const b=A.replace(/^\.[\/\\]/,""),L=this.b.getWorkspace().folders.map(O=>{const M=b.match(new RegExp(`^${I.$if(O.name)}(?:/(.*)|$)`));return M?{match:M,folder:O}:null}).filter(E.$ng);if(L.length)return L.map(O=>{const M=O.match[1];return{searchPath:O.folder.uri,pattern:M&&S(M)}});{const O=A.match(/\.[\/\\](.+)[\/\\]?/),M=O?O[1]:A,j=p.localize(0,null,M);throw new Error(j)}}}}o(A,b){const v=A.pattern&&b?`${A.pattern}/${b}`:A.pattern||b,L=[{searchPath:A.searchPath,pattern:v}];return v&&!v.endsWith("**")&&L.push({searchPath:A.searchPath,pattern:v+"/**"}),L}q(A,b,v){const L=this.r((0,d.$1i)(A.searchPath),b,v,!1);return L?{...L,includePattern:A.pattern}:null}r(A,b,v,L){let O;const M=u.URI.isUri(A)?A:A.uri;if(v.searchPaths){const _=v.searchPaths.filter(re=>(0,c.$_g)(re.searchPath,M))[0];if(_&&!_.pattern)return null;_&&(O=_.pattern)}const j=this.a.getValue({resource:M}),F={...this.l(j,b)||{},...O||{}},B=u.URI.isUri(A)?(0,c.$dh)(A):A.name;return{folder:M,folderName:L?B:void 0,excludePattern:Object.keys(F).length>0?F:void 0,fileEncoding:j.files&&j.files.encoding,disregardIgnoreFiles:typeof b.disregardIgnoreFiles=="boolean"?b.disregardIgnoreFiles:!j.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof b.disregardGlobalIgnoreFiles=="boolean"?b.disregardGlobalIgnoreFiles:!j.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof b.disregardParentIgnoreFiles=="boolean"?b.disregardParentIgnoreFiles:!j.search.useParentIgnoreFiles,ignoreSymlinks:typeof b.ignoreSymlinks=="boolean"?b.ignoreSymlinks:!j.search.followSymlinks}}};e.$8M=t,e.$8M=t=Je([Ge(0,a.$_i),Ge(1,d.$Oi),Ge(2,m.$fE),Ge(3,f.$_j),Ge(4,n.$6M)],t);function i(C){const A=C.match(/[\*\{\}\(\)\[\]\?]/);if(A){const b=A.index,v=C.substr(0,b).match(/[/|\\][^/\\]*$/);if(v){let L=C.substr(0,v.index);return L.match(/[/\\]/)||(L+="/"),{pathPortion:L,globPortion:C.substr((v.index||0)+1)}}}return{pathPortion:C}}function s(...C){return C.length?C.reduce((A,b)=>(A[b]=!0,A),Object.create(null)):void 0}function g(C){return P.$xk(C,",").map(A=>A.trim()).filter(A=>!!A.length)}function l(C){return[`**/${C}/**`,`**/${C}`].map(b=>b.replace(/\*\*\/\*\*/g,"**"))}function w(C){return C.replace(/\\/g,"/")}function S(C){return w(C).replace(/^\.\//,"").replace(/\/+$/g,"")}function D(C){return C.replace(/([?*[\]])/g,"[$1]")}function y(C,A){C=r.$Ob(C,L=>L.toString());const b=[],v=A.getWorkspace();return C&&C.forEach(L=>{let O;if(A.getWorkbenchState()===d.WorkbenchState.FOLDER)O=(0,c.$ih)(v.folders[0].uri,L),O&&O!=="."&&(O="./"+O);else{const M=A.getWorkspaceFolder(L);if(M){const j=M.name;if(v.folders.filter(F=>F.name===j).length===1){const F=(0,c.$ih)(M.uri,L);F===""?O=`./${M.name}`:O=`./${M.name}/${F}`}else O=L.fsPath}}O&&b.push(D(O))}),b}}),define(Ee[389],ye([1,0,23,2,21,14,5,388,38,46,9]),function(ce,e,r,h,P,R,T,N,$,c,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wxb=u,e.$Xxb=a,r=We(r),R=We(R);const E=7e3;function u(f,d){const m=d.activationEvents;if(!m)return Promise.resolve(void 0);const n=[],o=[];for(const w of m)if(/^workspaceContains:/.test(w)){const S=w.substr(18);S.indexOf("*")>=0||S.indexOf("?")>=0||f.forceUsingSearch?o.push(S):n.push(S)}if(n.length===0&&o.length===0)return Promise.resolve(void 0);const{promise:t,resolve:i}=(0,I.$yh)(),s=w=>i({activationEvent:w}),g=Promise.all(n.map(w=>k(f,w,s))).then(()=>{}),l=p(f,d.identifier,o,s);return Promise.all([g,l]).then(()=>{i(void 0)}),t}async function k(f,d,m){for(const n of f.folders)if(await f.exists(r.$gh(h.URI.revive(n),d))){m(`workspaceContains:${d}`);return}}async function p(f,d,m,n){if(m.length===0)return Promise.resolve(void 0);const o=new P.$xe,t=f.checkExists(f.folders,m,o.token),i=setTimeout(async()=>{o.cancel(),f.logService.info(`Not activating extension '${d.value}': Timed out while searching for 'workspaceContains' pattern ${m.join(",")}`)},E);let s=!1;try{s=await t}catch(g){R.$6(g)||R.$3(g)}o.dispose(),clearTimeout(i),s&&n(`workspaceContains:${m.join(",")}`)}function a(f,d,m,n){const o=f.get(T.$Ei),t=f.get($.$OL),s=o.createInstance(N.$8M).file(d.map(g=>(0,c.$1i)(h.URI.revive(g))),{_reason:"checkExists",includePattern:m,exists:!0});return t.fileSearch(s,n).then(g=>!!g.limitHit,g=>R.$6(g)?!1:Promise.reject(g))}}),define(Ee[52],ye([1,0,234,16,62,23,9,3,85,2,12,6,42,320,126,48,26,158,14,24,22,298,10,72,5,30,98,20,115,77,47,129,4,389,125,300,15,123,43,11,124]),function(ce,e,r,h,P,R,T,N,$,c,I,E,u,k,p,a,f,d,m,n,o,t,i,s,g,l,w,S,D,y,C,A,b,v,L,O,M,j,z,F,B){"use strict";var _;Object.defineProperty(e,"__esModule",{value:!0}),e.$Voc=e.$Uoc=e.$Toc=e.$Soc=e.$Roc=void 0,r=We(r),h=We(h),P=We(P),m=We(m),e.$Roc=(0,g.$Fi)("IHostUtils");let re=_=class extends N.$Wc{constructor(K,W,se,oe,te,le,ue,X,ae,pe,be,Fe,Ue){super(),this.Y=Fe,this.Z=Ue,this.a=this.B(new b.$me),this.onDidChangeRemoteConnectionData=this.a.event,this.R=new Map,this.W=!1,this.c=W,this.g=se,this.f=ue,this.j=oe,this.m=te,this.s=le,this.t=ae,this.u=pe,this.w=be,this.y=this.g.getProxy(E.$rN.MainThreadWorkspace),this.z=this.g.getProxy(E.$rN.MainThreadTelemetry),this.C=this.g.getProxy(E.$rN.MainThreadExtensionService),this.D=new T.$Eh,this.F=new T.$Eh,this.G=new T.$Eh,this.H=new T.$Eh,this.I=new De(this.f.extensions.activationEvents),this.L=new d.$lcc(this.I,this.f.extensions.allExtensions);const ke=new n.$rn(this.f.extensions.myExtensions);this.J=new d.$lcc(this.I,he(this.L,ke)),F.$t&&(this.s.info(`Creating extension host with the following global extensions: ${Q(this.L)}`),this.s.info(`Creating extension host with the following local extensions: ${Q(this.J)}`)),this.M=new p.$Aoc(this.g,this.s),this.N=new L.$Koc(this.g),this.O=X,this.h=K.createChild(new D.$Di([p.$Boc,this.M],[L.$Loc,this.N])),this.P=this.B(new k.$zoc(this.J,this.L,{onExtensionActivationError:(Ie,Re,q)=>{this.C.$onExtensionActivationError(Ie,m.$5(Re),q)},actualActivateExtension:async(Ie,Re)=>{if(d.$lcc.isHostExtension(Ie,this.J,this.L))return await this.C.$activateExtension(Ie,Re),new k.$yoc;const q=this.J.getExtensionDescription(Ie);return this.fb(q,Re)}},this.s)),this.Q=null,this.S=Object.create(null),this.U=!1,this.X=this.f.remote.connectionData}getRemoteConnectionData(){return this.X}async initialize(){try{await this.vb(),this.D.open(),await this.j.waitForInitializeCall(),P.mark("code/extHost/ready"),this.F.open(),this.f.autoStart&&this.tb()}catch(K){m.$3(K)}}async $(){this.O.onWillDeactivateAll();let K=[];try{K=this.J.getAllExtensionDescriptions().map(te=>te.identifier).filter(te=>this.isActivated(te)).map(te=>this.eb(te))}catch{}await Promise.all(K)}terminate(K,W=0){if(this.W)return;this.W=!0,this.s.info(`Extension host terminating: ${K}`),this.s.flush(),this.u.dispose(),this.P.dispose(),m.setUnexpectedErrorHandler(oe=>{this.s.error(oe)}),this.g.dispose();const se=this.$();Promise.race([(0,T.$Gh)(5e3),se]).finally(()=>{this.c.pid?this.s.info(`Extension host with pid ${this.c.pid} exiting with code ${W}`):this.s.info(`Extension host exiting with code ${W}`),this.s.flush(),this.s.dispose(),this.c.exit(W)})}isActivated(K){return this.G.isOpen()?this.P.isActivated(K):!1}async getExtension(K){const W=await this.C.$getExtension(K);return W&&{...W,identifier:new n.$qn(W.identifier.value),extensionLocation:c.URI.revive(W.extensionLocation)}}ab(K,W){return this.P.activateByEvent(K,W)}bb(K,W){return this.P.activateById(K,W)}activateByIdWithErrors(K,W){return this.bb(K,W).then(()=>{const se=this.P.getActivatedExtension(K);if(se.activationFailed)return Promise.reject(se.activationFailedError)})}getExtensionRegistry(){return this.G.wait().then(K=>this.J)}getExtensionExports(K){if(this.G.isOpen())return this.P.getActivatedExtension(K).exports;try{return this.P.getActivatedExtension(K).exports}catch{return null}}async cb(K){if(K.scheme===M.Schemas.file&&this.c.fsRealpath){const W=K.fsPath;this.R.has(W)||this.R.set(W,this.c.fsRealpath(W));const se=await this.R.get(W);return c.URI.file(se)}return K}async getExtensionPathIndex(){return this.Q||(this.Q=this.db(this.J.getAllExtensionDescriptions()).then(K=>new ne(K))),this.Q}async db(K){const W=$.$Li.forUris(se=>R.$0g.ignorePathCasing(se));return await Promise.all(K.map(async se=>{if(this.wb(se)){const oe=await this.cb(se.extensionLocation);W.set(oe,se)}})),W}eb(K){let W=Promise.resolve(void 0);if(!this.G.isOpen()||!this.P.isActivated(K))return W;const se=this.P.getActivatedExtension(K);if(!se)return W;try{typeof se.module.deactivate=="function"&&(W=Promise.resolve(se.module.deactivate()).then(void 0,oe=>(this.s.error(oe),Promise.resolve(void 0))))}catch(oe){this.s.error(`An error occurred when deactivating the extension '${K.value}':`),this.s.error(oe)}try{(0,N.$Rc)(se.subscriptions)}catch(oe){this.s.error(`An error occurred when deactivating the subscriptions for extension '${K.value}':`),this.s.error(oe)}return W}async fb(K,W){return this.f.remote.isRemote?this.C.$onWillActivateExtension(K.identifier):await this.C.$onWillActivateExtension(K.identifier),this.hb(K,W).then(se=>{const oe=se.activationTimes;return this.C.$onDidActivateExtension(K.identifier,oe.codeLoadingTime,oe.activateCallTime,oe.activateResolvedTime,W),this.gb(K,W,"success",oe),se},se=>{throw this.gb(K,W,"failure"),se})}gb(K,W,se,oe){const te=G(K,W);this.z.$publicLog2("extensionActivationTimes",{...te,...oe||{},outcome:se})}hb(K,W){const se=G(K,W);this.z.$publicLog2("activatePlugin",se);const oe=this.wb(K);if(!oe)return Promise.resolve(new k.$xoc(k.$uoc.NONE));this.s.info(`ExtensionService#_doActivateExtension ${K.identifier.value}, startup: ${W.startup}, activationEvent: '${W.activationEvent}'${K.identifier.value!==W.extensionId.value?`, root cause: ${W.extensionId.value}`:""}`),this.s.flush();const te=new k.$voc(W.startup);return Promise.all([this.xb(K,(0,R.$gh)(K.extensionLocation,oe),te),this.ib(K)]).then(le=>(P.mark(`code/extHost/willActivateExtension/${K.identifier.value}`),_.jb(this.s,K.identifier,le[0],le[1],te))).then(le=>(P.mark(`code/extHost/didActivateExtension/${K.identifier.value}`),le))}ib(K){const W=this.Z.createLanguageModelAccessInformation(K),se=new t.$Doc(K,this.M),oe=new t.$Coc(K.identifier.value,!1,this.M),te=new O.$Moc(K,this.N),le=K.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?i.ExtensionMode.Test:i.ExtensionMode.Development:i.ExtensionMode.Production,ue=this.f.remote.isRemote?i.ExtensionKind.Workspace:i.ExtensionKind.UI;return this.s.trace(`ExtensionService#loadExtensionContext ${K.identifier.value}`),Promise.all([se.whenReady,oe.whenReady,this.O.whenReady]).then(()=>{const X=this;let ae,pe;const be=(0,f.$3G)(K,"ipc")?this.f.messagePorts?.get(n.$qn.toKey(K.identifier)):void 0;return Object.freeze({globalState:se,workspaceState:oe,secrets:te,subscriptions:[],get languageModelAccessInformation(){return W},get extensionUri(){return K.extensionLocation},get extensionPath(){return K.extensionLocation.fsPath},asAbsolutePath(Fe){return h.$lc(K.extensionLocation.fsPath,Fe)},get storagePath(){return X.O.workspaceValue(K)?.fsPath},get globalStoragePath(){return X.O.globalValue(K).fsPath},get logPath(){return h.$lc(X.f.logsLocation.fsPath,K.identifier.value)},get logUri(){return c.URI.joinPath(X.f.logsLocation,K.identifier.value)},get storageUri(){return X.O.workspaceValue(K)},get globalStorageUri(){return X.O.globalValue(K)},get extensionMode(){return le},get extension(){return ae===void 0&&(ae=new ee(X,K.identifier,K,ue,!1)),ae},get extensionRuntime(){return(0,f.$4G)(K,"extensionRuntime"),X.extensionRuntime},get environmentVariableCollection(){return X.u.getEnvironmentVariableCollection(K)},get messagePassingProtocol(){if(!pe){if(!be)return;const Fe=b.Event.buffer(b.Event.fromDOMEventEmitter(be,"message",Ue=>Ue.data));be.start(),pe={onDidReceiveMessage:Fe,postMessage:be.postMessage.bind(be)}}return pe}})})}static jb(K,W,se,oe,te){return se=se||{activate:void 0,deactivate:void 0},this.kb(K,W,se,oe,te).then(le=>new k.$woc(!1,null,te.build(),se,le,oe.subscriptions))}static kb(K,W,se,oe,te){if(typeof se.activate=="function")try{te.activateCallStart(),K.trace(`ExtensionService#_callActivateOptional ${W.value}`);const le=typeof global=="object"?global:self,ue=se.activate.apply(le,[oe]);return te.activateCallStop(),te.activateResolveStart(),Promise.resolve(ue).then(X=>(te.activateResolveStop(),X))}catch(le){return Promise.reject(le)}else return Promise.resolve(se)}lb(K,W){this.bb(K.identifier,{startup:!1,extensionId:K.identifier,activationEvent:W}).then(void 0,se=>{this.s.error(se)})}mb(K,W=0){const oe=Date.now();(0,F.$B)(()=>{for(let te=W;te<K.length;te+=1){const le=K[te];for(const ue of le.activationEvents??[])if(ue==="onStartupFinished")if(Date.now()-oe>50){this.mb(K,te);break}else this.lb(le,ue)}})}nb(){this.C.$setPerformanceMarks(P.getMarks()),this.m.getConfigProvider().then(K=>{const W=K.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),se=this.J.getAllExtensionDescriptions();if(W)this.mb(se);else for(const oe of se)if(oe.activationEvents)for(const te of oe.activationEvents)te==="onStartupFinished"&&this.lb(oe,te)})}ob(){const K=this.ab("*",!0).then(void 0,le=>{this.s.error(le)});this.B(this.j.onDidChangeWorkspace(le=>this.pb(le.added)));const W=this.j.workspace?this.j.workspace.folders:[],se=this.pb(W),oe=this.rb(),te=Promise.all([oe,K,se]).then(()=>{});return Promise.race([te,(0,T.$Gh)(1e4)]).then(()=>{this.nb()}),te}pb(K){return K.length===0?Promise.resolve(void 0):Promise.all(this.J.getAllExtensionDescriptions().map(W=>this.qb(K,W))).then(()=>{})}async qb(K,W){if(this.isActivated(W.identifier))return;const se=!this.f.remote.isRemote&&!!this.f.remote.authority,oe={logService:this.s,folders:K.map(le=>le.uri),forceUsingSearch:se||!this.c.fsExists,exists:le=>this.c.fsExists(le.fsPath),checkExists:(le,ue,X)=>this.y.$checkExists(le,ue,X)},te=await(0,v.$Wxb)(oe,W);if(te)return this.bb(W.identifier,{startup:!0,extensionId:W.identifier,activationEvent:te.activationEvent}).then(void 0,le=>this.s.error(le))}async rb(){if(this.f.remote.authority)return this.ab(`onResolveRemoteAuthority:${this.f.remote.authority}`,!1)}async $extensionTestsExecute(){await this.H.wait();try{return await this.sb()}catch(K){throw console.error(K),K}}async sb(){const{extensionDevelopmentLocationURI:K,extensionTestsLocationURI:W}=this.f.environment;if(!K||!W)throw new Error(r.localize(0,null));const se=await this.xb(null,W,new k.$voc(!1));if(!se||typeof se.run!="function")throw new Error(r.localize(1,null,W.toString()));return new Promise((oe,te)=>{const le=(ae,pe)=>{ae?(F.$t&&this.s.error("Test runner called back with error",ae),te(ae)):(F.$t&&(pe?this.s.info(`Test runner called back with ${pe} failures.`):this.s.info("Test runner called back with successful outcome.")),oe(typeof pe=="number"&&pe>0?1:0))},ue=(0,R.$7g)(W),X=se.run(ue,le);X&&X.then&&X.then(()=>{F.$t&&this.s.info("Test runner finished successfully."),oe(0)}).catch(ae=>{F.$t&&this.s.error("Test runner finished with error",ae),te(ae instanceof Error&&ae.stack?ae.stack:String(ae))})})}tb(){if(this.U)throw new Error("Extension host is already started!");return this.U=!0,this.F.wait().then(()=>this.G.open()).then(()=>Promise.race([this.P.waitForActivatingExtensions(),(0,T.$Gh)(1e3)])).then(()=>this.ob()).then(()=>{this.H.open(),this.s.info("Eager extensions activated")})}registerRemoteAuthorityResolver(K,W){return this.S[K]=W,(0,N.$Uc)(()=>{delete this.S[K]})}async getRemoteExecServer(K){const{resolver:W}=await this.ub(K);return W?.resolveExecServer?.(K,{resolveAttempt:0})}async ub(K){const W=K.indexOf("+");if(W===-1)throw new i.$zN("Not an authority that can be resolved!",s.RemoteAuthorityResolverErrorCode.InvalidAuthority);const se=K.substr(0,W);return await this.D.wait(),await this.ab(`onResolveRemoteAuthority:${se}`,!1),{authorityPrefix:se,resolver:this.S[se]}}async $resolveAuthority(K,W){const se=z.$ge.create(!1),oe=()=>`[resolveAuthority(${(0,s.$Ul)(K)},${W})][${se.elapsed()}ms] `,te=V=>this.s.info(`${oe()}${V}`),le=V=>this.s.warn(`${oe()}${V}`),ue=(V,J=void 0)=>this.s.error(`${oe()}${V}`,J),X=V=>{if(V instanceof i.$zN)return{type:"error",error:{code:V._code,message:V._message,detail:V._detail}};throw V},ae=async V=>{te(`activating resolver for ${V}...`);const{resolver:J,authorityPrefix:x}=await this.ub(V);if(!J)throw ue(`no resolver for ${x}`),new i.$zN(`No remote extension installed to resolve ${x}.`,s.RemoteAuthorityResolverErrorCode.NoResolverFound);return{resolver:J,authorityPrefix:x,remoteAuthority:V}},pe=K.split(/@|%40/g).reverse();te(`activating remote resolvers ${pe.join(" -> ")}`);let be;try{be=await Promise.all(pe.map(ae)).catch(async V=>{if(!(V instanceof i.$zN)||V._code!==s.RemoteAuthorityResolverErrorCode.InvalidAuthority)throw V;return le(`resolving nested authorities failed: ${V.message}`),[await ae(K)]})}catch(V){return X(V)}const Fe=new T.$Qh;Fe.cancelAndSet(()=>te("waiting..."),1e3);let Ue,ke;for(const[V,{authorityPrefix:J,resolver:x,remoteAuthority:fe}]of be.entries())try{if(V===be.length-1)te("invoking final resolve()..."),P.mark(`code/extHost/willResolveAuthority/${J}`),Ue=await x.resolve(fe,{resolveAttempt:W,execServer:ke}),P.mark(`code/extHost/didResolveAuthorityOK/${J}`),te("setting tunnel factory..."),this.B(await this.t.setTunnelFactory(x,i.$yN.isManagedResolvedAuthority(Ue)?Ue:void 0));else{if(te(`invoking resolveExecServer() for ${fe}`),P.mark(`code/extHost/willResolveExecServer/${J}`),ke=await x.resolveExecServer?.(fe,{resolveAttempt:W,execServer:ke}),!ke)throw new i.$zN(`Exec server was not available for ${fe}`,s.RemoteAuthorityResolverErrorCode.NoResolverFound);P.mark(`code/extHost/didResolveExecServerOK/${J}`)}}catch(we){return P.mark(`code/extHost/didResolveAuthorityError/${J}`),ue("returned an error",we),Fe.dispose(),X(we)}Fe.dispose();const Ie={environmentTunnels:Ue.environmentTunnels,features:Ue.tunnelFeatures?{elevation:Ue.tunnelFeatures.elevation,privacyOptions:Ue.tunnelFeatures.privacyOptions,protocol:Ue.tunnelFeatures.protocol===void 0?!0:Ue.tunnelFeatures.protocol}:void 0},Re={extensionHostEnv:Ue.extensionHostEnv,isTrusted:Ue.isTrusted,authenticationSession:Ue.authenticationSessionForInitializingExtensions?{id:Ue.authenticationSessionForInitializingExtensions.id,providerId:Ue.authenticationSessionForInitializingExtensions.providerId}:void 0};te(`returned ${i.$yN.isManagedResolvedAuthority(Ue)?"managed authority":`${Ue.host}:${Ue.port}`}`);let q;if(i.$yN.isManagedResolvedAuthority(Ue)){const V=W;this.Y.setFactory(V,Ue.makeConnection),q={authority:K,connectTo:new s.$Rl(V),connectionToken:Ue.connectionToken}}else q={authority:K,connectTo:new s.$Sl(Ue.host,Ue.port),connectionToken:Ue.connectionToken};return{type:"ok",value:{authority:q,options:Re,tunnelInformation:Ie}}}async $getCanonicalURI(K,W){this.s.info(`$getCanonicalURI invoked for authority (${(0,s.$Ul)(K)})`);const{resolver:se}=await this.ub(K);if(!se)return null;const oe=c.URI.revive(W);if(typeof se.getCanonicalURI>"u")return oe;const te=await(0,T.$xh)(()=>se.getCanonicalURI(oe));return te||oe}async $startExtensionHost(K){K.toAdd.forEach(le=>le.extensionLocation=c.URI.revive(le.extensionLocation));const{globalRegistry:W,myExtensions:se}=U(this.I,this.L,this.J,K),oe=await this.db(se);return(await this.getExtensionPathIndex()).setSearchTree(oe),this.L.set(W.getAllExtensionDescriptions()),this.J.set(se),F.$t&&(this.s.info(`$startExtensionHost: global extensions: ${Q(this.L)}`),this.s.info(`$startExtensionHost: local extensions: ${Q(this.J)}`)),this.tb()}$activateByEvent(K,W){return W===f.ActivationKind.Immediate?this.D.wait().then(se=>this.ab(K,!1)):this.G.wait().then(se=>this.ab(K,!1))}async $activate(K,W){return await this.G.wait(),this.J.getExtensionDescription(K)?(await this.bb(K,W),!0):!1}async $deltaExtensions(K){K.toAdd.forEach(le=>le.extensionLocation=c.URI.revive(le.extensionLocation));const{globalRegistry:W,myExtensions:se}=U(this.I,this.L,this.J,K),oe=await this.db(se);return(await this.getExtensionPathIndex()).setSearchTree(oe),this.L.set(W.getAllExtensionDescriptions()),this.J.set(se),F.$t&&(this.s.info(`$deltaExtensions: global extensions: ${Q(this.L)}`),this.s.info(`$deltaExtensions: local extensions: ${Q(this.J)}`)),Promise.resolve(void 0)}async $test_latency(K){return K}async $test_up(K){return K.byteLength}async $test_down(K){const W=o.$Oe.alloc(K),se=Math.random()%256;for(let oe=0;oe<K;oe++)W.writeUInt8(se,oe);return W}async $updateRemoteConnectionData(K){this.X=K,this.a.fire()}};e.$Soc=re,e.$Soc=re=_=Je([Ge(0,g.$Ei),Ge(1,e.$Roc),Ge(2,S.$XP),Ge(3,a.$doc),Ge(4,u.$goc),Ge(5,I.$_j),Ge(6,l.$bQ),Ge(7,w.$joc),Ge(8,y.$EFb),Ge(9,C.$Eoc),Ge(10,j.$Ooc),Ge(11,B.$Poc),Ge(12,A.$Ioc)],re);function U($e,K,W,se){$e.addActivationEvents(se.addActivationEvents);const oe=new d.$lcc($e,K.getAllExtensionDescriptions());oe.deltaExtensions(se.toAdd,se.toRemove);const te=new n.$rn(W.getAllExtensionDescriptions().map(ue=>ue.identifier));for(const ue of se.myToRemove)te.delete(ue);for(const ue of se.myToAdd)te.add(ue);const le=he(oe,te);return{globalRegistry:oe,myExtensions:le}}function G($e,K){return{id:$e.identifier.value,name:$e.name,extensionVersion:$e.version,publisherDisplayName:$e.publisher,activationEvents:$e.activationEvents?$e.activationEvents.join(","):null,isBuiltin:$e.isBuiltin,reason:K.activationEvent,reasonId:K.extensionId.value}}function Q($e){return $e.getAllExtensionDescriptions().map(K=>K.identifier.value).join(",")}e.$Toc=(0,g.$Fi)("IExtHostExtensionService");class ee{#e;#t;#i;constructor(K,W,se,oe,te){this.#e=K,this.#t=W,this.#i=se.identifier,this.id=se.identifier.value,this.extensionUri=se.extensionLocation,this.extensionPath=h.$jc((0,R.$7g)(se.extensionLocation)),this.packageJSON=se,this.extensionKind=oe,this.isFromDifferentExtensionHost=te}get isActive(){return this.#e.isActivated(this.#i)}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return this.#e.getExtensionExports(this.#i)}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await this.#e.activateByIdWithErrors(this.#i,{startup:!1,extensionId:this.#t,activationEvent:"api"}),this.exports}}e.$Uoc=ee;function he($e,K){return $e.getAllExtensionDescriptions().filter(W=>K.has(W.identifier))}class ne{constructor(K){this.a=K}setSearchTree(K){this.a=K}findSubstr(K){return this.a.findSubstr(K)}forEach(K){return this.a.forEach(K)}}e.$Voc=ne;class De{constructor(K){this.a=new n.$sn,this.addActivationEvents(K)}readActivationEvents(K){return this.a.get(K.identifier)??[]}addActivationEvents(K){for(const W of Object.keys(K))this.a.set(W,K[W])}}}),define(Ee[390],ye([1,0,62,2,6,42,26,24,20,30,5,52,12,13]),function(ce,e,r,h,P,R,T,N,$,c,I,E,u,k){"use strict";var p;Object.defineProperty(e,"__esModule",{value:!0}),e.$7pc=void 0,r=We(r);let a=class{constructor(o,t,i,s,g,l,w){this.c=o,this.d=t,this.e=i,this.f=s,this.g=g,this.h=l,this.i=w,this.a=new Map,this.b=[]}async install(){this.j(),r.mark("code/extHost/willWaitForConfig");const o=await this.f.getConfigProvider();r.mark("code/extHost/didWaitForConfig");const t=await this.g.getExtensionPathIndex();this.register(new d(this.c,t,this.d,o,this.i)),this.register(this.e.createInstance(f)),this.h.remote.isRemote&&this.register(this.e.createInstance(m,t,this.h.environment.appUriScheme))}register(o){if("nodeModuleName"in o)if(Array.isArray(o.nodeModuleName))for(const t of o.nodeModuleName)this.a.set(t,o);else this.a.set(o.nodeModuleName,o);typeof o.alternativeModuleName=="function"&&this.b.push(t=>o.alternativeModuleName(t))}};e.$7pc=a,e.$7pc=a=Je([Ge(2,I.$Ei),Ge(3,R.$goc),Ge(4,E.$Toc),Ge(5,c.$bQ),Ge(6,u.$_j)],a);let f=class{static{p=this}static{this.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]])}constructor(o){if(o.environment.appRoot&&p.a.size){const t=(0,k.$if)(this.c(o.environment.appRoot.fsPath)),i="[a-z0-9_.-]",s=`@${i}+\\/${i}+|${i}+`,g="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${t}/${g}\\/)(${s})(.*)$`,"i")}}alternativeModuleName(o){if(!this.b)return;const t=this.b.exec(this.c(o));if(!t)return;const[,i,s,g]=t,l=p.a.get(s);if(l!==void 0)return console.warn(`${s} as been renamed to ${l}, please update your imports`),i+l+g}c(o){return o.replace(/\\/g,"/")}};f=p=Je([Ge(0,c.$bQ)],f);class d{constructor(o,t,i,s,g){this.c=o,this.d=t,this.e=i,this.f=s,this.g=g,this.nodeModuleName="vscode",this.a=new N.$sn}load(o,t){const i=this.d.findSubstr(t);if(i){let s=this.a.get(i.identifier);return s||(s=this.c(i,this.e,this.f),this.a.set(i.identifier,s)),s}if(!this.b){let s="";this.d.forEach((g,l)=>s+=`	${l} -> ${g.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${t}. These are the extension path mappings: 
${s}`),this.b=this.c(T.$XG,this.e,this.f)}return this.b}}let m=class{constructor(o,t,i){this.e=o,this.f=t,this.nodeModuleName=["open","opn"],this.d=i.getProxy(P.$rN.MainThreadTelemetry);const s=i.getProxy(P.$rN.MainThreadWindow);this.c=(g,l)=>{const w=h.URI.parse(g);return l?this.g(g,l):w.scheme==="http"||w.scheme==="https"?s.$openUri(w,g,{allowTunneling:!0}):w.scheme==="mailto"||w.scheme===this.f?s.$openUri(w,g,{}):this.g(g,l)}}load(o,t,i){const s=this.e.findSubstr(t);return s&&(this.a=s.identifier.value,this.h()),this.b=i(o),this.c}g(o,t){return this.i(),this.b(o,t)}h(){this.a&&this.d.$publicLog2("shimming.open",{extension:this.a})}i(){this.a&&this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};m=Je([Ge(2,$.$XP)],m)}),define(Ee[65],ye([1,0,49,3,16,56,5,64,78,52,10,48,317,42]),function(ce,e,r,h,P,R,T,N,$,c,I,E,u,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xoc=e.$Woc=void 0,P=We(P),R=We(R),e.$Woc=(0,T.$Fi)("IExtHostVariableResolverProvider");class p extends u.$2Q{constructor(d,m,n,o,t,i,s){function g(){if(n){const l=n.activeEditor();if(l)return l.document.uri;const w=o.tabGroups.all.find(S=>S.isActive)?.activeTab;if(w!==void 0){if(w.input instanceof I.$fP||w.input instanceof I.$kP)return w.input.modified;if(w.input instanceof I.$eP||w.input instanceof I.$jP||w.input instanceof I.$hP)return w.input.uri}}}super({getFolderUri:l=>{const w=i.folders.filter(S=>S.name===l);if(w&&w.length>0)return w[0].uri},getWorkspaceFolderCount:()=>i.folders.length,getConfigurationValue:(l,w)=>t.getConfiguration(void 0,l).get(w),getAppRoot:()=>R.cwd(),getExecPath:()=>R.env.VSCODE_EXEC_PATH,getFilePath:()=>{const l=g();if(l)return P.$jc(l.fsPath)},getWorkspaceFolderPathForFile:()=>{if(m){const l=g();if(l){const w=m.getWorkspaceFolder(l);if(w)return P.$jc(w.uri.fsPath)}}},getSelectedText:()=>{if(n){const l=n.activeEditor();if(l&&!l.selection.isEmpty)return l.document.getText(l.selection)}},getLineNumber:()=>{if(n){const l=n.activeEditor();if(l)return String(l.selection.end.line+1)}},getExtension:l=>d.getExtension(l)},void 0,s?Promise.resolve(s):void 0,Promise.resolve(R.env))}}let a=class extends h.$Wc{constructor(d,m,n,o,t){super(),this.b=d,this.c=m,this.g=n,this.h=o,this.j=t,this.a=new r.$X(async()=>{const i=await this.h.getConfigProvider(),g={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async l=>{g.folders=await this.c.getWorkspaceFolders2()||[]})),new p(this.b,this.c,this.g,this.j,i,g,this.m())})}getResolver(){return this.a.value}m(){}};e.$Xoc=a,e.$Xoc=a=Je([Ge(0,c.$Toc),Ge(1,E.$doc),Ge(2,N.$9P),Ge(3,k.$goc),Ge(4,$.$soc)],a)}),define(Ee[102],ye([1,0,9,4,2,3,24,5,6,78,52,20,10,48,153,120,308,42,65,50,35,17,19,99]),function(ce,e,r,h,P,R,T,N,$,c,I,E,u,k,p,a,f,d,m,n,o,t,i,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8oc=e.$7oc=e.$6oc=e.$5oc=e.$4oc=void 0,t=We(t),e.$4oc=(0,N.$Fi)("IExtHostDebugService");let g=class extends R.$Wc{get onDidStartDebugSession(){return this.y.event}get onDidTerminateDebugSession(){return this.z.event}get onDidChangeActiveDebugSession(){return this.C.event}get activeDebugSession(){return this.D?.api}get onDidReceiveDebugSessionCustomEvent(){return this.F.event}get activeDebugConsole(){return this.G.value}constructor(A,b,v,L,O,M,j,z){super(),this.Y=b,this.Z=v,this.$=L,this.ab=O,this.bb=M,this.cb=j,this.db=z,this.w=new Map,this.O=0,this.P=new Map,this.Q=new Map,this.R=new WeakMap,this.S=new Map,this.W=new Map,this.X=0,this.f=0,this.g=[],this.h=0,this.j=[],this.m=0,this.n=[],this.M=new Map,this.N=new Map,this.y=this.B(new h.$me),this.z=this.B(new h.$me),this.C=this.B(new h.$me),this.F=this.B(new h.$me),this.u=A.getProxy($.$rN.MainThreadDebugService),this.I=this.B(new h.$me),this.L=this.B(new h.$me),this.G=new w(this.u),this.H=new Map,this.Z.getExtensionRegistry().then(F=>{this.B(F.onDidChange(B=>{this.fb(F)})),this.fb(F)})}async $getVisualizerTreeItem(A,b){const v=this.gb(b);if(!v)return;const L=await this.Q.get(A)?.getTreeItem?.(v);return L?this.eb(A,L):void 0}registerDebugVisualizationTree(A,b,v){const L=T.$qn.toKey(A.identifier),O=this.ub(L,b);if(this.P.has(O))throw new Error(`A debug visualization provider with id '${b}' is already registered`);return this.Q.set(O,v),this.u.$registerDebugVisualizerTree(O,!!v.editItem),(0,R.$Uc)(()=>{this.u.$unregisterDebugVisualizerTree(O),this.Q.delete(b)})}async $getVisualizerTreeItemChildren(A,b){const v=this.S.get(b)?.item;return v?(await this.Q.get(A)?.getChildren?.(v))?.map(O=>this.eb(A,O))||[]:[]}async $editVisualizerTreeItem(A,b){const v=this.S.get(A);if(!v)return;const L=await this.Q.get(v.provider)?.editItem?.(v.item,b);return this.eb(v.provider,L||v.item)}$disposeVisualizedTree(A){const b=this.S.get(A);if(!b)return;const v=[b.children];for(const L of v)if(L)for(const O of L)v.push(this.S.get(O)?.children),this.S.delete(O)}eb(A,b){let v=this.R.get(b);return v||(v=this.O++,this.R.set(b,v),this.S.set(v,{provider:A,item:b})),t.DebugTreeItem.from(b,v)}asDebugSourceUri(A,b){const v=A;if(typeof v.sourceReference=="number"&&v.sourceReference>0){let L=`debug:${encodeURIComponent(v.path||"")}`,O="?";return b&&(L+=`${O}session=${encodeURIComponent(b.id)}`,O="&"),L+=`${O}ref=${v.sourceReference}`,P.URI.parse(L)}else{if(v.path)return P.URI.file(v.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}fb(A){const b=[];for(const v of A.getAllExtensionDescriptions())if(v.contributes){const L=v.contributes.debuggers;if(L&&L.length>0)for(const O of L)(0,f.$VH)(O)&&b.push(O.type)}this.u.$registerDebugTypes(b)}get activeStackItem(){return this.J}get onDidChangeActiveStackItem(){return this.L.event}get onDidChangeBreakpoints(){return this.I.event}get breakpoints(){const A=[];return this.H.forEach(b=>A.push(b)),A}async $resolveDebugVisualizer(A,b){const v=this.W.get(A);if(!v)throw new Error(`No debug visualizer found with id '${A}'`);let{v:L,provider:O,extensionId:M}=v;if(L.visualization||(L=await O.resolveDebugVisualization?.(L,b)||L,v.v=L),!L.visualization)throw new Error(`No visualization returned from resolveDebugVisualization in '${O}'`);return this.vb(M,L.visualization)}async $executeDebugVisualizerCommand(A){const b=this.W.get(A);if(!b)throw new Error(`No debug visualizer found with id '${A}'`);const v=b.v.visualization;v&&"command"in v&&this.cb.executeCommand(v.command,...v.arguments||[])}gb(A){const b=this.w.get(A.sessionId);return b&&{session:b.api,variable:A.variable,containerId:A.containerId,frameId:A.frameId,threadId:A.threadId}}async $provideDebugVisualizers(A,b,v,L){const O=this.gb(v),M=this.ub(A,b),j=this.P.get(M);if(!O||!j)return[];const z=await j.provideDebugVisualization(O,L);return z?z.map(F=>{const B=++this.X;this.W.set(B,{v:F,provider:j,extensionId:A});const _=F.iconPath?this.wb(F.iconPath):void 0;return{id:B,name:F.name,iconClass:_?.iconClass,iconPath:_?.iconPath,visualization:this.vb(A,F.visualization)}}):[]}$disposeDebugVisualizers(A){for(const b of A)this.W.delete(b)}registerDebugVisualizationProvider(A,b,v){if(!A.contributes?.debugVisualizers?.some(M=>M.id===b))throw new Error(`Extensions may only call registerDebugVisualizationProvider() for renderers they contribute (got ${b})`);const L=T.$qn.toKey(A.identifier),O=this.ub(L,b);if(this.P.has(O))throw new Error(`A debug visualization provider with id '${b}' is already registered`);return this.P.set(O,v),this.u.$registerDebugVisualizer(L,b),(0,R.$Uc)(()=>{this.u.$unregisterDebugVisualizer(L,b),this.P.delete(b)})}addBreakpoints(A){const b=A.filter(O=>{const M=O.id;return this.H.has(M)?!1:(this.H.set(M,O),!0)});this.rb(b,[],[]);const v=[],L=new Map;for(const O of b)if(O instanceof u.$vO){let M=L.get(O.location.uri.toString());M||(M={type:"sourceMulti",uri:O.location.uri,lines:[]},L.set(O.location.uri.toString(),M),v.push(M)),M.lines.push({id:O.id,enabled:O.enabled,condition:O.condition,hitCondition:O.hitCondition,logMessage:O.logMessage,line:O.location.range.start.line,character:O.location.range.start.character,mode:O.mode})}else O instanceof u.$wO&&v.push({type:"function",id:O.id,enabled:O.enabled,hitCondition:O.hitCondition,logMessage:O.logMessage,condition:O.condition,functionName:O.functionName,mode:O.mode});return this.u.$registerBreakpoints(v)}removeBreakpoints(A){const b=A.filter(M=>this.H.delete(M.id));this.rb([],b,[]);const v=b.filter(M=>M instanceof u.$vO).map(M=>M.id),L=b.filter(M=>M instanceof u.$wO).map(M=>M.id),O=b.filter(M=>M instanceof u.$xO).map(M=>M.id);return this.u.$unregisterBreakpoints(v,L,O)}startDebugging(A,b,v){const L=v.testRun&&this.db.getMetadataForRun(v.testRun);return this.u.$startDebugging(A?A.uri:void 0,b,{parentSessionID:v.parentSession?v.parentSession.id:void 0,lifecycleManagedByParent:v.lifecycleManagedByParent,repl:v.consoleMode===u.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:v.noDebug,compact:v.compact,suppressSaveBeforeStart:v.suppressSaveBeforeStart,testRun:L&&{runId:L.runId,taskId:L.taskId},suppressDebugStatusbar:v.suppressDebugStatusbar??v.debugUI?.simple,suppressDebugToolbar:v.suppressDebugToolbar??v.debugUI?.simple,suppressDebugView:v.suppressDebugView??v.debugUI?.simple})}stopDebugging(A){return this.u.$stopDebugging(A?A.id:void 0)}registerDebugConfigurationProvider(A,b,v){if(!b)return new u.$tN(()=>{});const L=this.f++;return this.g.push({type:A,handle:L,provider:b}),this.u.$registerDebugConfigurationProvider(A,v,!!b.provideDebugConfigurations,!!b.resolveDebugConfiguration,!!b.resolveDebugConfigurationWithSubstitutedVariables,L),new u.$tN(()=>{this.g=this.g.filter(O=>O.provider!==b),this.u.$unregisterDebugConfigurationProvider(L)})}registerDebugAdapterDescriptorFactory(A,b,v){if(!v)return new u.$tN(()=>{});if(!this.nb(A,b))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${b}' debugger.`);if(this.kb(b))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const L=this.h++;return this.j.push({type:b,handle:L,factory:v}),this.u.$registerDebugAdapterDescriptorFactory(b,L),new u.$tN(()=>{this.j=this.j.filter(O=>O.factory!==v),this.u.$unregisterDebugAdapterDescriptorFactory(L)})}registerDebugAdapterTrackerFactory(A,b){if(!b)return new u.$tN(()=>{});const v=this.m++;return this.n.push({type:A,handle:v,factory:b}),new u.$tN(()=>{this.n=this.n.filter(L=>L.factory!==b)})}async $runInTerminal(A,b){return Promise.resolve(void 0)}async $substituteVariables(A,b){let v;const L=await this.tb(A);return L&&(v={uri:L.uri,name:L.name,index:L.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.bb.getResolver()).resolveAnyAsync(v,b)}hb(A,b){if(A.type==="implementation")return new D(A.implementation)}ib(){}async $startDASession(A,b){const v=this,L=await this.sb(b);return this.pb(this.kb(L.type),L).then(O=>{if(!O)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${L.type}' (extension might have failed to activate)`);const M=this.jb(O),j=this.hb(M,L);if(!j)throw new Error(`Couldn't create a debug adapter for type '${L.type}'.`);const z=j;return this.M.set(A,z),this.ob(L).then(F=>(F&&this.N.set(A,F),z.onMessage(async B=>{if(B.type==="request"&&B.command==="handshake"){const _=B,re={type:"response",seq:0,command:_.command,request_seq:_.seq,success:!0};this.U||(this.U=this.ib());try{if(this.U){const U=await this.U.sign(_.arguments.value);re.body={signature:U},z.sendResponse(re)}else throw new Error("no signer")}catch(U){re.success=!1,re.message=U.message,z.sendResponse(re)}}else F&&F.onDidSendMessage&&F.onDidSendMessage(B),B=(0,f.$1H)(B,!0),v.u.$acceptDAMessage(A,B)}),z.onError(B=>{F&&F.onError&&F.onError(B),this.u.$acceptDAError(A,B.name,B.message,B.stack)}),z.onExit(B=>{F&&F.onExit&&F.onExit(B??void 0,void 0),this.u.$acceptDAExit(A,B??void 0,void 0)}),F&&F.onWillStartSession&&F.onWillStartSession(),z.startSession()))})}$sendDAMessage(A,b){b=(0,f.$ZH)(b,!1);const v=this.N.get(A);v&&v.onWillReceiveMessage&&v.onWillReceiveMessage(b),this.M.get(A)?.sendMessage(b)}$stopDASession(A){const b=this.N.get(A);this.N.delete(A),b&&b.onWillStopSession&&b.onWillStopSession();const v=this.M.get(A);return this.M.delete(A),v?v.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(A){const b=[],v=[],L=[];if(A.added)for(const O of A.added){const M=O.id;if(M&&!this.H.has(M)){let j;if(O.type==="function")j=new u.$wO(O.functionName,O.enabled,O.condition,O.hitCondition,O.logMessage,O.mode);else if(O.type==="data")j=new u.$xO(O.label,O.dataId,O.canPersist,O.enabled,O.hitCondition,O.condition,O.logMessage,O.mode);else{const z=P.URI.revive(O.uri);j=new u.$vO(new u.$FN(z,new u.$uN(O.line,O.character)),O.enabled,O.condition,O.hitCondition,O.logMessage,O.mode)}(0,u.$tO)(j,M),this.H.set(M,j),b.push(j)}}if(A.removed)for(const O of A.removed){const M=this.H.get(O);M&&(this.H.delete(O),v.push(M))}if(A.changed){for(const O of A.changed)if(O.id){const M=this.H.get(O.id);if(M){if(M instanceof u.$wO&&O.type==="function"){const j=M;j.enabled=O.enabled,j.condition=O.condition,j.hitCondition=O.hitCondition,j.logMessage=O.logMessage,j.functionName=O.functionName}else if(M instanceof u.$vO&&O.type==="source"){const j=M;j.enabled=O.enabled,j.condition=O.condition,j.hitCondition=O.hitCondition,j.logMessage=O.logMessage,j.location=new u.$FN(P.URI.revive(O.uri),new u.$uN(O.line,O.character))}L.push(M)}}}this.rb(b,v,L)}async $acceptStackFrameFocus(A){let b;if(A){const v=await this.sb(A.sessionId);A.kind==="thread"?b=new u.$DO(v.api,A.threadId):b=new u.$CO(v.api,A.threadId,A.frameId)}this.J=b,this.L.fire(this.J)}$provideDebugConfigurations(A,b,v){return(0,r.$xh)(async()=>{const L=this.mb(A);if(!L)throw new Error("no DebugConfigurationProvider found");if(!L.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const O=await this.tb(b);return L.provideDebugConfigurations(O,v)}).then(L=>{if(!L)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return L})}$resolveDebugConfiguration(A,b,v,L){return(0,r.$xh)(async()=>{const O=this.mb(A);if(!O)throw new Error("no DebugConfigurationProvider found");if(!O.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const M=await this.tb(b);return O.resolveDebugConfiguration(M,v,L)})}$resolveDebugConfigurationWithSubstitutedVariables(A,b,v,L){return(0,r.$xh)(async()=>{const O=this.mb(A);if(!O)throw new Error("no DebugConfigurationProvider found");if(!O.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const M=await this.tb(b);return O.resolveDebugConfigurationWithSubstitutedVariables(M,v,L)})}async $provideDebugAdapter(A,b){const v=this.lb(A);if(!v)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const L=await this.sb(b);return this.pb(v,L).then(O=>{if(!O)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${L.type}'`);return this.jb(O)})}async $acceptDebugSessionStarted(A){const b=await this.sb(A);this.y.fire(b.api)}async $acceptDebugSessionTerminated(A){const b=await this.sb(A);b&&(this.z.fire(b.api),this.w.delete(b.id))}async $acceptDebugSessionActiveChanged(A){this.D=A?await this.sb(A):void 0,this.C.fire(this.D?.api)}async $acceptDebugSessionNameChanged(A,b){(await this.sb(A))?._acceptNameChanged(b)}async $acceptDebugSessionCustomEvent(A,b){const L={session:(await this.sb(A)).api,event:b.event,body:b.body};this.F.fire(L)}jb(A){if(A instanceof u.$yO)return{type:"executable",command:A.command,args:A.args,options:A.options};if(A instanceof u.$zO)return{type:"server",port:A.port,host:A.host};if(A instanceof u.$AO)return{type:"pipeServer",path:A.path};if(A instanceof u.$BO)return{type:"implementation",implementation:A.implementation};throw new Error("convertToDto unexpected type")}kb(A){const b=this.j.filter(v=>v.type===A);if(b.length>0)return b[0].factory}lb(A){const b=this.j.filter(v=>v.handle===A);if(b.length>0)return b[0].factory}mb(A){const b=this.g.filter(v=>v.handle===A);if(b.length>0)return b[0].provider}nb(A,b){if(A.contributes){const v=A.contributes.debuggers;if(v&&v.length>0){for(const L of v)if(L.label&&L.type&&L.type===b)return!0}}return!1}ob(A){const v=A.configuration.type,L=this.n.filter(O=>O.type===v||O.type==="*").map(O=>(0,r.$xh)(()=>O.factory.createDebugAdapterTracker(A.api)).then(M=>M,M=>null));return Promise.race([Promise.all(L).then(O=>{const M=(0,i.$Jb)(O);if(M.length>0)return new S(M)}),new Promise(O=>setTimeout(()=>O(void 0),1e3))]).catch(O=>{})}async pb(A,b){const v=b.configuration.debugServer;if(typeof v=="number")return Promise.resolve(new u.$zO(v));if(A){const O=await this.Z.getExtensionRegistry();return(0,r.$xh)(()=>A.createDebugAdapterDescriptor(b.api,this.qb(b,O))).then(M=>{if(M)return M})}const L=await this.Z.getExtensionRegistry();return Promise.resolve(this.qb(b,L))}qb(A,b){}rb(A,b,v){(A.length>0||b.length>0||v.length>0)&&this.I.fire(Object.freeze({added:A,removed:b,changed:v}))}async sb(A){if(A)if(typeof A=="string"){const b=this.w.get(A);if(b)return b}else{let b=this.w.get(A.id);if(!b){const v=await this.tb(A.folderUri),L=A.parent?this.w.get(A.parent):void 0;b=new l(this.u,A.id,A.type,A.name,v,A.configuration,L?.api),this.w.set(b.id,b),this.u.$sessionCached(b.id)}return b}throw new Error("cannot find session")}tb(A){if(A){const b=P.URI.revive(A);return this.Y.resolveWorkspaceFolder(b)}return Promise.resolve(void 0)}ub(A,b){return`${A}\0${b}`}vb(A,b){if(b){if("title"in b&&"command"in b)return{type:a.DebugVisualizationType.Command};if("treeId"in b)return{type:a.DebugVisualizationType.Tree,id:`${A}\0${b.treeId}`};throw new Error("Unsupported debug visualization type")}}wb(A){const b=this.xb(A);let v,L;return"id"in b?L=n.ThemeIcon.asClassName(b):v=b,{iconPath:v,iconClass:L}}xb(A){if(A instanceof u.$qO)return{id:A.id};const b=typeof A=="object"&&"dark"in A?A.dark:A,v=typeof A=="object"&&"light"in A?A.light:A;return{dark:typeof b=="string"?P.URI.file(b):b,light:typeof v=="string"?P.URI.file(v):v}}};e.$5oc=g,e.$5oc=g=Je([Ge(0,E.$XP),Ge(1,k.$doc),Ge(2,I.$Toc),Ge(3,d.$goc),Ge(4,c.$soc),Ge(5,m.$Woc),Ge(6,o.$hQ),Ge(7,s.$Yoc)],g);class l{constructor(A,b,v,L,O,M,j){this.f=A,this.g=b,this.h=v,this.j=L,this.k=O,this.l=M,this.m=j}get api(){const A=this;return this.d??=Object.freeze({id:A.g,type:A.h,get name(){return A.j},set name(b){A.j=b,A.f.$setDebugSessionName(A.g,b)},parentSession:A.m,workspaceFolder:A.k,configuration:A.l,customRequest(b,v){return A.f.$customDebugAdapterRequest(A.g,b,v)},getDebugProtocolBreakpoint(b){return A.f.$getDebugProtocolBreakpoint(A.g,b.id)}})}get id(){return this.g}get type(){return this.h}_acceptNameChanged(A){this.j=A}get configuration(){return this.l}}e.$6oc=l;class w{constructor(A){this.value=Object.freeze({append(b){A.$appendDebugConsole(b)},appendLine(b){this.append(b+`
`)}})}}e.$7oc=w;class S{constructor(A){this.d=A}onWillStartSession(){this.d.forEach(A=>A.onWillStartSession?A.onWillStartSession():void 0)}onWillReceiveMessage(A){this.d.forEach(b=>b.onWillReceiveMessage?b.onWillReceiveMessage(A):void 0)}onDidSendMessage(A){this.d.forEach(b=>b.onDidSendMessage?b.onDidSendMessage(A):void 0)}onWillStopSession(){this.d.forEach(A=>A.onWillStopSession?A.onWillStopSession():void 0)}onError(A){this.d.forEach(b=>b.onError?b.onError(A):void 0)}onExit(A,b){this.d.forEach(v=>v.onExit?v.onExit(A,b):void 0)}}class D extends p.$qtb{constructor(A){super(),this.h=A,A.onDidSendMessage(b=>{this.acceptMessage(b)})}startSession(){return Promise.resolve(void 0)}sendMessage(A){this.h.handleMessage(A)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let y=class extends g{constructor(A,b,v,L,O,M,j,z){super(A,b,v,L,O,M,j,z)}};e.$8oc=y,e.$8oc=y=Je([Ge(0,E.$XP),Ge(1,k.$doc),Ge(2,I.$Toc),Ge(3,d.$goc),Ge(4,c.$soc),Ge(5,m.$Woc),Ge(6,o.$hQ),Ge(7,s.$Yoc)],y)}),define(Ee[391],ye([1,0,14,62,2,6,340,12,89,115,30,275,20,73,52,95]),function(ce,e,r,h,P,R,T,N,$,c,I,E,u,k,p,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9pc=e.$8pc=void 0,r=We(r),h=We(h);class f{static async installEarlyHandler(n){Error.stackTraceLimit=100;const o=n.get(N.$_j),i=n.get(u.$XP).getProxy(R.$rN.MainThreadErrors);r.setUnexpectedErrorHandler(s=>{o.error(s);const g=r.$5(s);i.$onUnexpectedError(g)})}static async installFullHandler(n){const o=n.get(N.$_j),t=n.get(u.$XP),i=n.get(p.$Toc),s=n.get(a.$fQ),g=t.getProxy(R.$rN.MainThreadExtensionService),l=t.getProxy(R.$rN.MainThreadErrors),w=await i.getExtensionPathIndex(),S=new WeakMap;function D(A,b){if(S.has(A))return S.get(A).stack;let v="",L,O;for(const j of b)v+=`
	at ${j.toString()}`,O=j.getFileName(),!L&&O&&(L=w.findSubstr(P.URI.file(O)));const M=`${A.name||"Error"}: ${A.message||""}${v}`;return S.set(A,{extensionIdentifier:L?.identifier,stack:M}),M}const y=Symbol("prepareStackTrace wrapped");let C=D;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return C},set(A){if(A===D||!A||A[y]){C=A||D;return}C=function(b,v){return D(b,v),A.call(Error,b,v)},Object.assign(C,{[y]:!0})}}),r.setUnexpectedErrorHandler(A=>{o.error(A);const b=r.$5(A),v=S.get(A);if(!v?.extensionIdentifier){l.$onUnexpectedError(b);return}g.$onExtensionRuntimeError(v.extensionIdentifier,b);const L=s.onExtensionError(v.extensionIdentifier,A);o.trace("forwarded error to extension?",L,v)})}}e.$8pc=f;class d{constructor(n,o,t,i,s){this.a=t,this.b=new T.$tcc(n,null,i),o=d.e(o,this.b);const g=new c.$Di(...(0,$.$Ls)());g.set(I.$bQ,{_serviceBrand:void 0,...o,messagePorts:s}),g.set(u.$XP,new u.$YP(this.b)),g.set(k.$aoc,new k.$boc(i)),g.set(p.$Roc,t);const l=new E.$pr(g,!0);l.invokeFunction(f.installEarlyHandler),this.d=l.invokeFunction(w=>w.get(N.$_j)),h.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",o),this.c=l.invokeFunction(w=>w.get(p.$Toc)),this.c.initialize(),l.invokeFunction(f.installFullHandler)}async asBrowserUri(n){const o=this.b.getProxy(R.$rN.MainThreadExtensionService);return P.URI.revive(await o.$asBrowserUri(n))}terminate(n){this.c.terminate(n)}static e(n,o){n.extensions.allExtensions.forEach(i=>{i.extensionLocation=P.URI.revive(o.transformIncomingURIs(i.extensionLocation))}),n.environment.appRoot=P.URI.revive(o.transformIncomingURIs(n.environment.appRoot));const t=n.environment.extensionDevelopmentLocationURI;return t&&(n.environment.extensionDevelopmentLocationURI=t.map(i=>P.URI.revive(o.transformIncomingURIs(i)))),n.environment.extensionTestsLocationURI=P.URI.revive(o.transformIncomingURIs(n.environment.extensionTestsLocationURI)),n.environment.globalStorageHome=P.URI.revive(o.transformIncomingURIs(n.environment.globalStorageHome)),n.environment.workspaceStorageHome=P.URI.revive(o.transformIncomingURIs(n.environment.workspaceStorageHome)),n.environment.extensionTelemetryLogResource=P.URI.revive(o.transformIncomingURIs(n.environment.extensionTelemetryLogResource)),n.nlsBaseUrl=P.URI.revive(o.transformIncomingURIs(n.nlsBaseUrl)),n.logsLocation=P.URI.revive(o.transformIncomingURIs(n.logsLocation)),n.workspace=o.transformIncomingURIs(n.workspace),n}}e.$9pc=d}),define(Ee[392],ye([1,0,9,11,245,268,148,102,78,52,20,47,10,65,48,309,310,42,35,99]),function(ce,e,r,h,P,R,T,N,$,c,I,E,u,k,p,a,f,d,m,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gqc=void 0,h=We(h),P=We(P);let o=class extends N.$5oc{constructor(l,w,S,D,y,C,A,b,v){super(l,w,S,D,C,A,b,v),this.Ab=y,this.yb=new s}hb(l,w){switch(l.type){case"server":return new a.$bqc(l);case"pipeServer":return new a.$cqc(l);case"executable":return new a.$dqc(l,w.type)}return super.hb(l,w)}qb(l,w){const S=a.$dqc.platformAdapterExecutable(w.getAllExtensionDescriptions(),l.type);if(S)return new u.$yO(S.command,S.args,S.options)}ib(){return new T.$qgc}async $runInTerminal(l,w){if(l.kind==="integrated"){this.zb||(this.zb=this.B(this.Ab.onDidCloseTerminal(z=>{this.yb.onTerminalClosed(z)})));const S=await this.$.getConfigProvider(),D=this.Ab.getDefaultShell(!0),y=this.Ab.getDefaultShellArgs(!0),C=l.title||P.localize(0,null),A=JSON.stringify({shell:D,shellArgs:y});let b=await this.yb.checkout(A,C),v,L=!1;if(b)v=l.cwd;else{const z={shellPath:D,shellArgs:y,cwd:l.cwd,name:C,iconPath:new u.$qO("debug")};L=!0,b=this.Ab.createTerminalFromOptions(z,{isFeatureTerminal:!0,forceShellIntegration:!0,useShellEnvironment:!0}),this.yb.insert(b,A)}b.show(!0);const O=await b.processId;L?await new Promise(z=>setTimeout(z,1e3)):(b.state.isInteractedWith&&(b.sendText(""),await(0,r.$Gh)(200)),S.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(D.indexOf("powershell")>=0||D.indexOf("pwsh")>=0||D.indexOf("cmd.exe")>=0?b.sendText("cls"):D.indexOf("bash")>=0?b.sendText("clear"):h.$i?b.sendText("cls"):b.sendText("clear")));const M=(0,f.$fqc)(D,l.args,!!l.argsCanBeInterpretedByShell,v,l.env);b.sendText(M);const j=this.onDidTerminateDebugSession(z=>{z.id===w&&(this.yb.free(b),j.dispose())});return O}else if(l.kind==="external")return i(l,await this.$.getConfigProvider());return super.$runInTerminal(l,w)}};e.$gqc=o,e.$gqc=o=Je([Ge(0,I.$XP),Ge(1,p.$doc),Ge(2,c.$Toc),Ge(3,d.$goc),Ge(4,E.$Eoc),Ge(5,$.$soc),Ge(6,k.$Woc),Ge(7,m.$hQ),Ge(8,n.$Yoc)],o);let t;function i(g,l){if(!t)if(h.$i)t=new R.$_ec;else if(h.$j)t=new R.$afc;else if(h.$k)t=new R.$bfc;else throw new Error("external terminals not supported on this platform");const w=l.getConfiguration("terminal");return t.runInTerminal(g.title,g.cwd,g.args,g.env||{},w.external||{})}class s{constructor(){this.b=new Map}static{this.a=1e3}async checkout(l,w,S=!1){const y=[...this.b.entries()].map(([C,A])=>(0,r.$sh)(async b=>{if(C.name!==w||A.lastUsedAt!==-1&&await(0,f.$eqc)(await C.processId))return null;const v=Date.now();return A.lastUsedAt+s.a>v||b.isCancellationRequested?null:A.config!==l?(S&&C.dispose(),null):(A.lastUsedAt=v,C)}));return await(0,r.$Kh)(y,C=>!!C)}insert(l,w){this.b.set(l,{lastUsedAt:Date.now(),config:w})}free(l){const w=this.b.get(l);w&&(w.lastUsedAt=-1)}onTerminalClosed(l){this.b.delete(l)}}}),define(Ee[393],ye([1,0,16,2,112,48,64,42,46,47,20,30,101,15,12,96,23,68,65]),function(ce,e,r,h,P,R,T,N,$,c,I,E,u,k,p,a,f,d,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$pc=void 0,r=We(r),f=We(f);let n=class extends u.$Npc{constructor(t,i,s,g,l,w,S,D,y){super(t,i,s,g,l,w,S,D),this.C=s,this.D=y,i.remote.isRemote&&i.remote.authority?this.registerTaskSystem(k.Schemas.vscodeRemote,{scheme:k.Schemas.vscodeRemote,authority:i.remote.authority,platform:process.platform}):this.registerTaskSystem(k.Schemas.file,{scheme:k.Schemas.file,authority:"",platform:process.platform}),this.a.$registerSupportedExecutions(!0,!0,!0)}async executeTask(t,i){const s=i;if(!i.execution&&s._id===void 0)throw new Error("Tasks to execute must include an execution");if(s._id!==void 0){const g=u.TaskHandleDTO.from(s,this.C),l=await this.a.$getTaskExecution(g);if(l.task===void 0)throw new Error("Task from execution DTO is undefined");const w=await this.z(l,i);return this.a.$executeTask(g).catch(()=>{}),w}else{const g=u.TaskDTO.from(i,t);if(g===void 0)return Promise.reject(new Error("Task is not valid"));u.CustomExecutionDTO.is(g.execution)&&await this.y(g,i,!1);const l=await this.z(await this.a.$getTaskExecution(g),i);return this.a.$executeTask(g).catch(()=>{}),l}}v(t,i,s,g){const l=[];if(g)for(const w of g){this.A(w,s),(!w.definition||!t[w.definition.type])&&this.f.warn(`The task [${w.source}, ${w.name}] uses an undefined task type. The task will be ignored in the future.`);const S=u.TaskDTO.from(w,s.extension);S&&(l.push(S),u.CustomExecutionDTO.is(S.execution)&&i.push(this.y(S,w,!0)))}return{tasks:l,extension:s.extension}}async w(t){return t}async G(t){let i=t&&t.length>0?t[0]:void 0;if(!i){const s=h.URI.file((0,d.homedir)());i=new $.$Zi({uri:s,name:f.$dh(s),index:0})}return{uri:i.uri,name:i.name,index:i.index,toResource:()=>{throw new Error("Not implemented")}}}async $resolveVariables(t,i){const s=h.URI.revive(t),g={process:void 0,variables:Object.create(null)},l=await this.b.resolveWorkspaceFolder(s),w=await this.b.getWorkspaceFolders2()??[],S=await this.D.getResolver(),D=l?{uri:l.uri,name:l.name,index:l.index,toResource:()=>{throw new Error("Not implemented")}}:await this.G(w);for(const y of i.variables)g.variables[y]=await S.resolveAsync(D,y);if(i.process!==void 0){let y;if(i.process.path!==void 0){y=i.process.path.split(r.$vc);for(let C=0;C<y.length;C++)y[C]=await S.resolveAsync(D,y[C])}g.process=await P.win32.findExecutable(await S.resolveAsync(D,i.process.name),i.process.cwd!==void 0?await S.resolveAsync(D,i.process.cwd):void 0,y)}return g}async $jsonTasksSupported(){return!0}async $findExecutable(t,i,s){return P.win32.findExecutable(t,i,s)}};e.$$pc=n,e.$$pc=n=Je([Ge(0,I.$XP),Ge(1,E.$bQ),Ge(2,R.$doc),Ge(3,T.$9P),Ge(4,N.$goc),Ge(5,c.$Eoc),Ge(6,p.$_j),Ge(7,a.$Tnc),Ge(8,m.$Woc)],n)}),define(Ee[394],ye([1,0,68,65]),function(ce,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qqc=void 0;class P extends h.$Xoc{m(){return(0,r.homedir)()}}e.$Qqc=P}),define(Ee[170],ye([1,0,19,9,21,55,15,16,23,2,38]),function(ce,e,r,h,P,R,T,N,$,c,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mpc=e.$kpc=e.$jpc=void 0,e.$lpc=a,N=We(N),$=We($);class E{constructor(m,n,o){this.d=m,this.e=n,this.f=o,this.a=null,this.b=!1,this.c=0}get g(){return this.d.query}search(m,n){const o=this.g.folderQueries||[],t=new P.$xe(n);return new Promise((i,s)=>{this.a=new k(m);let g=!1;const l=(w,S)=>{if(!g&&!this.b){const D=this.h(w);a(w)&&typeof this.g.maxResults=="number"&&this.c+D>this.g.maxResults&&(this.b=!0,g=!0,t.cancel(),w=this.j(w,this.g.maxResults-this.c));const y=this.h(w);this.c+=y,(y>0||!a(w))&&this.a.add(w,S)}};Promise.all(o.map((w,S)=>this.k(w,D=>l(D,S),t.token))).then(w=>{t.dispose(),this.a.flush();const S=w.some(D=>!!D&&!!D.limitHit);i({limitHit:this.b||S,messages:w.flatMap(D=>D?.message?Array.isArray(D.message)?D.message:[D.message]:[]),stats:{type:this.f}})},w=>{t.dispose();const S=(0,R.$qj)(w);s(new Error(S))})})}h(m){return a(m)?Array.isArray(m.ranges)?m.ranges.length:1:0}j(m,n){const o=Array.isArray(m.ranges)?m.ranges:[m.ranges],t=Array.isArray(m.preview.matches)?m.preview.matches:[m.preview.matches];return{ranges:o.slice(0,n),preview:{matches:t.slice(0,n),text:m.preview.text},uri:m.uri}}async k(m,n,o){const t=new I.$8L(this.g,m),i=[],s={report:w=>{if(!this.l(w))return;const S=m.folder.scheme===T.Schemas.file?(0,I.$9L)(()=>this.e.readdir($.$fh(w.uri))):void 0,D=$.$ih(m.folder,w.uri);if(D){const y=t.includedInQuery(D,N.$pc(D),S);(0,h.$rh)(y)?i.push(y.then(C=>{C&&n(w)})):y&&n(w)}}},g=this.n(m);let l;return this.d.query.type===I.QueryType.aiText?l=await this.d.provider.provideAITextSearchResults(this.d.query.contentPattern,g,s,o):l=await this.d.provider.provideTextSearchResults(u(this.d.query.contentPattern),g,s,o),i.length&&await Promise.all(i),l}l(m){if(a(m)){if(Array.isArray(m.ranges)){if(!Array.isArray(m.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(m.preview.matches.length!==m.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(m.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(m){const n=(0,I.$7L)(this.g.includePattern,m.includePattern),o=(0,I.$7L)(this.g.excludePattern,m.excludePattern),t={folder:c.URI.from(m.folder),excludes:o,includes:n,useIgnoreFiles:!m.disregardIgnoreFiles,useGlobalIgnoreFiles:!m.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!m.disregardParentIgnoreFiles,followSymlinks:!m.ignoreSymlinks,encoding:m.fileEncoding&&this.e.toCanonicalName(m.fileEncoding),maxFileSize:this.g.maxFileSize,maxResults:this.g.maxResults??I.$NL,previewOptions:this.g.previewOptions,afterContext:this.g.afterContext,beforeContext:this.g.beforeContext};return"usePCRE2"in this.g&&(t.usePCRE2=this.g.usePCRE2),t}}e.$jpc=E;function u(d){return{isCaseSensitive:d.isCaseSensitive||!1,isRegExp:d.isRegExp||!1,isWordMatch:d.isWordMatch||!1,isMultiline:d.isMultiline||!1,pattern:d.pattern}}class k{constructor(m){this.e=m,this.b=-1,this.d=null,this.a=new f(512,n=>this.g(n))}add(m,n){this.d&&(this.b!==n||!$.$_g(this.c,m.uri))&&(this.f(),this.d=null),this.d||(this.b=n,this.d={resource:m.uri,results:[]}),this.d.results.push(p(m))}f(){const m=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,m)}flush(){this.f(),this.a.flush()}g(m){this.e(m)}}e.$kpc=k;function p(d){return a(d)?{preview:{matches:(0,r.$3b)(d.preview.matches,m=>({startLineNumber:m.start.line,startColumn:m.start.character,endLineNumber:m.end.line,endColumn:m.end.character})),text:d.preview.text},ranges:(0,r.$3b)(d.ranges,m=>({startLineNumber:m.start.line,startColumn:m.start.character,endLineNumber:m.end.line,endColumn:m.end.character}))}:{text:d.text,lineNumber:d.lineNumber}}function a(d){return!!d.preview}class f{static{this.a=4e3}static{this.b=50}constructor(m,n){this.g=m,this.h=n,this.c=0,this.d=[],this.e=0}addItem(m,n){m&&this.j(m,n)}addItems(m,n){m&&this.k(m,n)}j(m,n){this.d.push(m),this.e+=n,this.l()}k(m,n){this.d=this.d.concat(m),this.e+=n,this.l()}l(){this.c<f.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},f.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}e.$mpc=f}),define(Ee[103],ye([1,0,3,6,5,387,20,73,12,2,170]),function(ce,e,r,h,P,R,T,N,$,c,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$opc=e.$npc=void 0,e.$ppc=u,e.$npc=(0,P.$Fi)("IExtHostSearch");let E=class{constructor(a,f,d){this.n=a,this.o=f,this.q=d,this.c=this.n.getProxy(h.$rN.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new Map,this.k=new Set,this.l=new R.$ipc}s(a){return this.o.transformOutgoingScheme(a)}registerTextSearchProvider(a,f){if(this.g.has(a))throw new Error(`a text search provider for the scheme '${a}' is already registered`);this.g.add(a);const d=this.d++;return this.e.set(d,f),this.c.$registerTextSearchProvider(d,this.s(a)),(0,r.$Uc)(()=>{this.g.delete(a),this.e.delete(d),this.c.$unregisterProvider(d)})}registerAITextSearchProvider(a,f){if(this.i.has(a))throw new Error(`an AI text search provider for the scheme '${a}'is already registered`);this.i.add(a);const d=this.d++;return this.h.set(d,f),this.c.$registerAITextSearchProvider(d,this.s(a)),(0,r.$Uc)(()=>{this.i.delete(a),this.h.delete(d),this.c.$unregisterProvider(d)})}registerFileSearchProvider(a,f){if(this.k.has(a))throw new Error(`a file search provider for the scheme '${a}' is already registered`);this.k.add(a);const d=this.d++;return this.j.set(d,f),this.c.$registerFileSearchProvider(d,this.s(a)),(0,r.$Uc)(()=>{this.k.delete(a),this.j.delete(d),this.c.$unregisterProvider(d)})}$provideFileSearchResults(a,f,d,m){const n=u(d),o=this.j.get(a);if(o)return this.l.fileSearch(n,o,t=>{this.c.$handleFileMatch(a,f,t.map(i=>i.resource))},m);throw new Error("3 unknown provider: "+a)}async doInternalFileSearchWithCustomCallback(a,f,d){return{messages:[]}}$clearCache(a){return this.l.clearCache(a),Promise.resolve(void 0)}$provideTextSearchResults(a,f,d,m){const n=this.e.get(a);if(!n||!n.provideTextSearchResults)throw new Error(`Unknown Text Search Provider ${a}`);const o=u(d);return this.t(o,n).search(i=>this.c.$handleTextMatch(a,f,i),m)}$provideAITextSearchResults(a,f,d,m){const n=this.h.get(a);if(!n||!n.provideAITextSearchResults)throw new Error(`Unknown AI Text Search Provider ${a}`);const o=u(d);return this.v(o,n).search(i=>this.c.$handleTextMatch(a,f,i),m)}$enableExtensionHostSearch(){}t(a,f){return new I.$jpc({query:a,provider:f},{readdir:d=>Promise.resolve([]),toCanonicalName:d=>d},"textSearchProvider")}v(a,f){return new I.$jpc({query:a,provider:f},{readdir:d=>Promise.resolve([]),toCanonicalName:d=>d},"aiTextSearchProvider")}};e.$opc=E,e.$opc=E=Je([Ge(0,T.$XP),Ge(1,N.$aoc),Ge(2,$.$_j)],E);function u(p){return{...p,folderQueries:p.folderQueries&&p.folderQueries.map(k),extraFileResources:p.extraFileResources&&p.extraFileResources.map(a=>c.URI.revive(a))}}function k(p){return{...p,folder:c.URI.revive(p.folder)}}});var zt=this&&this.__importDefault||function(ce){return ce&&ce.__esModule?ce:{default:ce}};define(Ee[395],ye([1,0,21,14,4,3,15,44,2,114,212,193,54,24,28,12,91,92,295,6,342,368,96,128,346,347,348,326,315,35,349,42,350,102,162,351,328,343,352,353,64,78,329,344,52,354,76,355,63,30,369,330,356,129,357,123,124,332,386,359,299,360,370,361,168,333,362,363,364,20,365,103,125,366,334,367,126,98,101,95,47,166,99,371,345,372,373,77,17,10,335,73,336,97,374,375,161,48,120,94,26,100,331]),function(ce,e,r,h,P,R,T,N,$,c,I,E,u,k,p,a,f,d,m,n,o,t,i,s,g,l,w,S,D,y,C,A,b,v,L,O,M,j,z,F,B,_,re,U,G,Q,ee,he,ne,De,$e,K,W,se,oe,te,le,ue,X,ae,pe,be,Fe,Ue,ke,Ie,Re,q,V,J,x,fe,we,Le,He,Ke,et,rt,ot,nt,ct,mt,dt,at,Pe,ze,Ze,Te,Me,Y,de,Ae,Xe,_e,ut,gt,kt,Lt,Bt,di,it,At,Zt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3pc=Kt,h=We(h),N=zt(N),E=We(E),p=We(p),Me=We(Me),Y=We(Y);function Kt(pt){const vt=pt.get(De.$bQ),ii=pt.get(ne.$Xnc),xt=pt.get(ee.$ioc),Vt=pt.get(G.$Toc),Et=pt.get(Lt.$doc),Ft=pt.get(nt.$fQ),li=pt.get(A.$goc),Gt=pt.get(Ae.$aoc),xe=pt.get(J.$XP),_t=pt.get(et.$Boc),ni=pt.get(rt.$joc),ui=pt.get(a.$ak),It=pt.get(a.$_j),Mt=pt.get(Te.$EFb),Nt=pt.get(i.$Tnc),Ut=pt.get(kt.$1pc),ri=pt.get(we.$Loc),ei=pt.get(_.$soc),si=pt.get(le.$Poc),Wt=pt.get(s.$4nc),Qt=pt.get(se.$Ioc);xe.set(n.$sN.ExtHostFileSystemInfo,ii),xe.set(n.$sN.ExtHostLogLevelServiceShape,ui),xe.set(n.$sN.ExtHostWorkspace,Et),xe.set(n.$sN.ExtHostConfiguration,li),xe.set(n.$sN.ExtHostExtensionService,Vt),xe.set(n.$sN.ExtHostStorage,_t),xe.set(n.$sN.ExtHostTunnelService,Mt),xe.set(n.$sN.ExtHostWindow,Ut),xe.set(n.$sN.ExtHostSecretState,ri),xe.set(n.$sN.ExtHostTelemetry,Ft),xe.set(n.$sN.ExtHostEditorTabs,ei),xe.set(n.$sN.ExtHostManagedSockets,si),xe.set(n.$sN.ExtHostAuthentication,Wt),xe.set(n.$sN.ExtHostChatProvider,Qt);const oi=xe.set(n.$sN.ExtHostDecorations,pt.get(L.$0oc)),Rt=xe.set(n.$sN.ExtHostDocumentsAndEditors,pt.get(B.$9P)),Dt=xe.set(n.$sN.ExtHostCommands,pt.get(y.$hQ)),wt=xe.set(n.$sN.ExtHostTerminalService,pt.get(ct.$Eoc)),ti=xe.set(n.$sN.ExtHostTerminalShellIntegration,pt.get(mt.$Qpc)),Pt=xe.set(n.$sN.ExtHostDebugService,pt.get(v.$4oc)),hi=xe.set(n.$sN.ExtHostSearch,pt.get(fe.$npc)),Ht=xe.set(n.$sN.ExtHostTask,pt.get(ot.$Ppc)),bi=xe.set(n.$sN.ExtHostOutputService,pt.get(ke.$Cpc)),wi=xe.set(n.$sN.ExtHostLocalization,pt.get(te.$Ooc)),fi=xe.set(n.$sN.ExtHostUrls,new Xe.$Xpc(xe)),qt=xe.set(n.$sN.ExtHostDocuments,new F.$1nc(xe,Rt)),ai=xe.set(n.$sN.ExtHostDocumentContentProviders,new j.$_oc(xe,Rt,It)),Ii=xe.set(n.$sN.ExtHostDocumentSaveParticipant,new z.$apc(It,qt,xe.getProxy(n.$rN.MainThreadBulkEdits))),Tt=xe.set(n.$sN.ExtHostNotebook,new X.$qpc(xe,Dt,Rt,qt,xt,hi,It)),yi=xe.set(n.$sN.ExtHostNotebookDocuments,new pe.$wpc(Tt)),Pi=xe.set(n.$sN.ExtHostNotebookEditors,new be.$xpc(It,Tt)),Si=xe.set(n.$sN.ExtHostNotebookKernels,new Fe.$ypc(xe,vt,Tt,Dt,It)),mi=xe.set(n.$sN.ExtHostNotebookRenderers,new Ue.$Apc(xe,Tt)),Ci=xe.set(n.$sN.ExtHostNotebookDocumentSaveParticipant,new ae.$vpc(It,Tt,xe.getProxy(n.$rN.MainThreadBulkEdits))),Ce=xe.set(n.$sN.ExtHostEditors,new at.$0nc(xe,Rt)),je=xe.set(n.$sN.ExtHostTreeViews,new Ze.$Vpc(xe.getProxy(n.$rN.MainThreadTreeViews),Dt,It)),Se=xe.set(n.$sN.ExtHostEditorInsets,new D.$$nc(xe.getProxy(n.$rN.MainThreadEditorInsets),Ce,vt.remote)),ie=xe.set(n.$sN.ExtHostDiagnostics,new O.$Znc(xe,It,ii,Rt)),Oe=xe.set(n.$sN.ExtHostLanguages,new oe.$tpc(xe,qt,Dt.converter,Gt)),Ve=xe.set(n.$sN.ExtHostLanguageFeatures,new W.$2nc(xe,Gt,qt,Dt,ie,It,Nt,Ft)),tt=xe.set(n.$sN.ExtHostFileSystem,new Q.$dpc(xe,Ve)),Qe=xe.set(n.$sN.ExtHostFileSystemEventService,new he.$epc(xe,It,Rt)),ft=xe.set(n.$sN.ExtHostQuickOpen,(0,V.$Gpc)(xe,Et,Dt)),Ct=xe.set(n.$sN.ExtHostSCM,new x.$Ipc(xe,Dt,qt,It)),Jt=xe.set(n.$sN.ExtHostQuickDiff,new q.$Fpc(xe,Gt)),ci=xe.set(n.$sN.ExtHostShare,new Le.$Jpc(xe,Gt)),jt=xe.set(n.$sN.ExtHostComments,(0,C.$_nc)(xe,Dt,qt)),Xt=xe.set(n.$sN.ExtHostProgress,new Re.$Epc(xe.getProxy(n.$rN.MainThreadProgress))),Yi=xe.set(n.$sN.ExtHostLabelService,new K.$spc(xe)),Wi=xe.set(n.$sN.ExtHostTheming,new Pe.$Spc(xe)),pn=xe.set(n.$sN.ExtHostTimeline,new ze.$Upc(xe,Dt)),Li=xe.set(n.$sN.ExtHostWebviews,new _e.$noc(xe,vt.remote,Et,It,Nt)),Ni=xe.set(n.$sN.ExtHostWebviewPanels,new ut.$qoc(xe,Li,Et)),qi=xe.set(n.$sN.ExtHostCustomEditors,new b.$roc(xe,qt,ni,Li,Ni)),xi=xe.set(n.$sN.ExtHostWebviewViews,new gt.$Ypc(xe,Li)),Di=xe.set(n.$sN.ExtHostTesting,pt.get(dt.$Yoc)),_i=xe.set(n.$sN.ExtHostUriOpeners,new de.$Wpc(xe)),en=xe.set(n.$sN.ExtHostProfileContentHandlers,new Ie.$Dpc(xe));xe.set(n.$sN.ExtHostInteractive,new $e.$rpc(xe,Tt,Rt,Dt,It));const Fi=xe.set(n.$sN.ExtHostChatAgents2,new l.$7nc(xe,It,Dt,vt.quality)),tn=xe.set(n.$sN.ExtHostChatVariables,new w.$8nc(xe)),Vi=xe.set(n.$sN.ExtHostLanguageModelTools,new Zt.$2pc(xe)),nn=xe.set(n.$sN.ExtHostAiRelatedInformation,new o.$Snc(xe)),Gi=xe.set(n.$sN.ExtHostAiEmbeddingVector,new U.$cpc(xe)),Mi=xe.set(n.$sN.ExtHostStatusBar,new Ke.$Mpc(xe,Dt.converter)),bn=xe.set(n.$sN.ExtHostSpeech,new He.$Kpc(xe)),Ti=xe.set(n.$sN.ExtHostEmbeddings,new re.$bpc(xe)),rn=Object.values(n.$sN);xe.assertRegistered(rn);const wn=new g.$6nc(xe,Rt),Hi=new S.$9nc(xe),ji=new ue.$upc(xe,It),Zi=new M.$$oc(xe);return t.$3nc.register(Dt),function(qe,vi,zi){function lt(ge){return(ve,Be,ht)=>{const St=ge(Ot=>{try{ve.call(Be,Ot)}catch(Ai){h.$4(new Error(`[ExtensionListenerError] Extension '${qe.identifier.value}' FAILED to handle event: ${Ai.toString()}`,{cause:Ai})),Ft.onExtensionError(qe.identifier,Ai)}});return ht?.push(St),St}}const bt=function(){let ge=!qe.isUnderDevelopment;function ve(){ge||(It.info(`Extension '${qe.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),ge=!0)}return function Be(ht){if(Array.isArray(ht))ht.forEach(Be);else if(typeof ht=="string")ve();else{const St=ht;typeof St.scheme>"u"&&ve(),typeof St.exclusive=="boolean"&&(0,it.$4G)(qe,"documentFiltersExclusive")}return ht}}(),Bi={getSession(ge,ve,Be){return typeof Be?.forceNewSession=="object"&&Be.forceNewSession.learnMore&&(0,it.$4G)(qe,"authLearnMore"),Be?.account&&(0,it.$4G)(qe,"authGetSessions"),Wt.getSession(qe,ge,ve,Be)},getSessions(ge,ve){return(0,it.$4G)(qe,"authGetSessions"),Wt.getSessions(qe,ge,ve)},getAccounts(ge){return(0,it.$4G)(qe,"authGetSessions"),Wt.getAccounts(ge)},async hasSession(ge,ve){return(0,it.$4G)(qe,"authSession"),!!await Wt.getSession(qe,ge,ve,{silent:!0})},get onDidChangeSessions(){return lt(Wt.onDidChangeSessions)},registerAuthenticationProvider(ge,ve,Be,ht){return Wt.registerAuthenticationProvider(ge,ve,Be,ht)}},vn={registerCommand(ge,ve,Be){return Dt.registerCommand(!0,ge,ve,Be,void 0,qe)},registerTextEditorCommand(ge,ve,Be){return Dt.registerCommand(!0,ge,(...ht)=>{const St=Ce.getActiveTextEditor();if(!St){It.warn("Cannot execute "+ge+" because there is no active text editor.");return}return St.edit(Ot=>{ve.apply(Be,[St,Ot,...ht])}).then(Ot=>{Ot||It.warn("Edits from command "+ge+" were not applied.")},Ot=>{It.warn("An error occurred while running command "+ge,Ot)})},void 0,void 0,qe)},registerDiffInformationCommand:(ge,ve,Be)=>((0,it.$4G)(qe,"diffCommand"),Dt.registerCommand(!0,ge,async(...ht)=>{const St=Rt.activeEditor(!0);if(!St){It.warn("Cannot execute "+ge+" because there is no active text editor.");return}const Ot=await Ce.getDiffInformation(St.id);ve.apply(Be,[Ot,...ht])},void 0,void 0,qe)),executeCommand(ge,...ve){return Dt.executeCommand(ge,...ve)},getCommands(ge=!1){return Dt.getCommands(ge)}},gi={get machineId(){return vt.telemetryInfo.machineId},get sessionId(){return vt.telemetryInfo.sessionId},get language(){return vt.environment.appLanguage},get appName(){return vt.environment.appName},get appRoot(){return vt.environment.appRoot?.fsPath??""},get appHost(){return vt.environment.appHost},get uriScheme(){return vt.environment.appUriScheme},get clipboard(){return Hi.value},get shell(){return wt.getDefaultShell(!1)},get onDidChangeShell(){return lt(wt.onDidChangeShell)},get isTelemetryEnabled(){return Ft.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return lt(Ft.onDidChangeTelemetryEnabled)},get telemetryConfiguration(){return(0,it.$4G)(qe,"telemetry"),Ft.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,it.$4G)(qe,"telemetry"),lt(Ft.onDidChangeTelemetryConfiguration)},get isNewAppInstall(){return(0,nt.$eQ)(vt.telemetryInfo.firstSessionDate)},createTelemetryLogger(ge,ve){return nt.$dQ.validateSender(ge),Ft.instantiateLogger(qe,ge,ve)},openExternal(ge,ve){return Ut.openUri(ge,{allowTunneling:!!vt.remote.authority,allowContributedOpeners:ve?.allowContributedOpeners})},async asExternalUri(ge){if(ge.scheme===vt.environment.appUriScheme)return fi.createAppUri(ge);try{return await Ut.asExternalUri(ge,{allowTunneling:!!vt.remote.authority})}catch(ve){if((0,T.$Og)(ge,T.Schemas.http)||(0,T.$Og)(ge,T.Schemas.https))return ge;throw ve}},get remoteName(){return(0,f.$hn)(vt.remote.authority)},get remoteAuthority(){return(0,it.$4G)(qe,"resolvers"),vt.remote.authority},get uiKind(){return vt.uiKind},get logLevel(){return It.getLevel()},get onDidChangeLogLevel(){return lt(It.onDidChangeLogLevel)},get appQuality(){return(0,it.$4G)(qe,"resolvers"),vt.quality},get appCommit(){return(0,it.$4G)(qe,"resolvers"),vt.commit}};vt.environment.extensionTestsLocationURI||Object.freeze(gi);const Ui={createTestController(ge,ve,Be){return Di.createTestController(qe,ge,ve,Be)},createTestObserver(){return(0,it.$4G)(qe,"testObserver"),Di.createTestObserver()},runTests(ge){return(0,it.$4G)(qe,"testObserver"),Di.runTests(ge)},registerTestFollowupProvider(ge){return(0,it.$4G)(qe,"testObserver"),Di.registerTestFollowupProvider(ge)},get onDidChangeTestResults(){return(0,it.$4G)(qe,"testObserver"),lt(Di.onResultsChanged)},get testResults(){return(0,it.$4G)(qe,"testObserver"),Di.results}},Oi=vt.remote.isRemote?Y.ExtensionKind.Workspace:Y.ExtensionKind.UI,sn={getExtension(ge,ve){(0,it.$3G)(qe,"extensionsAny")||(ve=!1);const Be=vi.mine.getExtensionDescription(ge);if(Be)return new G.$Uoc(Vt,qe.identifier,Be,Oi,!1);if(ve){const ht=vi.all.getExtensionDescription(ge);if(ht)return new G.$Uoc(Vt,qe.identifier,ht,Oi,!0)}},get all(){const ge=[];for(const ve of vi.mine.getAllExtensionDescriptions())ge.push(new G.$Uoc(Vt,qe.identifier,ve,Oi,!1));return ge},get allAcrossExtensionHosts(){(0,it.$4G)(qe,"extensionsAny");const ge=new k.$rn(vi.mine.getAllExtensionDescriptions().map(Be=>Be.identifier)),ve=[];for(const Be of vi.all.getAllExtensionDescriptions()){const ht=!ge.has(Be.identifier);ve.push(new G.$Uoc(Vt,qe.identifier,Be,Oi,ht))}return ve},get onDidChange(){return(0,it.$3G)(qe,"extensionsAny")?lt(P.Event.any(vi.mine.onDidChange,vi.all.onDidChange)):lt(vi.mine.onDidChange)}},on={createDiagnosticCollection(ge){return ie.createDiagnosticCollection(qe.identifier,ge)},get onDidChangeDiagnostics(){return lt(ie.onDidChangeDiagnostics)},getDiagnostics:ge=>ie.getDiagnostics(ge),getLanguages(){return Oe.getLanguages()},setTextDocumentLanguage(ge,ve){return Oe.changeLanguage(ge.uri,ve)},match(ge,ve){const Be=Me.LanguageSelector.from(ge);let ht;return(0,I.$pu)(Be)&&(ht=Tt.notebookDocuments.find(St=>St.apiNotebook.getCells().find(Ot=>Ot.document===ve))?.apiNotebook),(0,I.$ou)(Be,ve.uri,ve.languageId,!0,ht?.uri,ht?.notebookType)},registerCodeActionsProvider(ge,ve,Be){return Ve.registerCodeActionProvider(qe,bt(ge),ve,Be)},registerDocumentPasteEditProvider(ge,ve,Be){return(0,it.$4G)(qe,"documentPaste"),Ve.registerDocumentPasteEditProvider(qe,bt(ge),ve,Be)},registerCodeLensProvider(ge,ve){return Ve.registerCodeLensProvider(qe,bt(ge),ve)},registerDefinitionProvider(ge,ve){return Ve.registerDefinitionProvider(qe,bt(ge),ve)},registerDeclarationProvider(ge,ve){return Ve.registerDeclarationProvider(qe,bt(ge),ve)},registerImplementationProvider(ge,ve){return Ve.registerImplementationProvider(qe,bt(ge),ve)},registerTypeDefinitionProvider(ge,ve){return Ve.registerTypeDefinitionProvider(qe,bt(ge),ve)},registerHoverProvider(ge,ve){return Ve.registerHoverProvider(qe,bt(ge),ve,qe.identifier)},registerEvaluatableExpressionProvider(ge,ve){return Ve.registerEvaluatableExpressionProvider(qe,bt(ge),ve,qe.identifier)},registerInlineValuesProvider(ge,ve){return Ve.registerInlineValuesProvider(qe,bt(ge),ve,qe.identifier)},registerDocumentHighlightProvider(ge,ve){return Ve.registerDocumentHighlightProvider(qe,bt(ge),ve)},registerMultiDocumentHighlightProvider(ge,ve){return Ve.registerMultiDocumentHighlightProvider(qe,bt(ge),ve)},registerLinkedEditingRangeProvider(ge,ve){return Ve.registerLinkedEditingRangeProvider(qe,bt(ge),ve)},registerReferenceProvider(ge,ve){return Ve.registerReferenceProvider(qe,bt(ge),ve)},registerRenameProvider(ge,ve){return Ve.registerRenameProvider(qe,bt(ge),ve)},registerNewSymbolNamesProvider(ge,ve){return(0,it.$4G)(qe,"newSymbolNamesProvider"),Ve.registerNewSymbolNamesProvider(qe,bt(ge),ve)},registerDocumentSymbolProvider(ge,ve,Be){return Ve.registerDocumentSymbolProvider(qe,bt(ge),ve,Be)},registerWorkspaceSymbolProvider(ge){return Ve.registerWorkspaceSymbolProvider(qe,ge)},registerDocumentFormattingEditProvider(ge,ve){return Ve.registerDocumentFormattingEditProvider(qe,bt(ge),ve)},registerDocumentRangeFormattingEditProvider(ge,ve){return Ve.registerDocumentRangeFormattingEditProvider(qe,bt(ge),ve)},registerOnTypeFormattingEditProvider(ge,ve,Be,...ht){return Ve.registerOnTypeFormattingEditProvider(qe,bt(ge),ve,[Be].concat(ht))},registerDocumentSemanticTokensProvider(ge,ve,Be){return Ve.registerDocumentSemanticTokensProvider(qe,bt(ge),ve,Be)},registerDocumentRangeSemanticTokensProvider(ge,ve,Be){return Ve.registerDocumentRangeSemanticTokensProvider(qe,bt(ge),ve,Be)},registerSignatureHelpProvider(ge,ve,Be,...ht){return typeof Be=="object"?Ve.registerSignatureHelpProvider(qe,bt(ge),ve,Be):Ve.registerSignatureHelpProvider(qe,bt(ge),ve,typeof Be>"u"?[]:[Be,...ht])},registerCompletionItemProvider(ge,ve,...Be){return Ve.registerCompletionItemProvider(qe,bt(ge),ve,Be)},registerInlineCompletionItemProvider(ge,ve,Be){return ve.handleDidShowCompletionItem&&(0,it.$4G)(qe,"inlineCompletionsAdditions"),ve.handleDidPartiallyAcceptCompletionItem&&(0,it.$4G)(qe,"inlineCompletionsAdditions"),Be&&(0,it.$4G)(qe,"inlineCompletionsAdditions"),Ve.registerInlineCompletionsProvider(qe,bt(ge),ve,Be)},registerInlineEditProvider(ge,ve){return(0,it.$4G)(qe,"inlineEdit"),Ve.registerInlineEditProvider(qe,bt(ge),ve)},registerDocumentLinkProvider(ge,ve){return Ve.registerDocumentLinkProvider(qe,bt(ge),ve)},registerColorProvider(ge,ve){return Ve.registerColorProvider(qe,bt(ge),ve)},registerFoldingRangeProvider(ge,ve){return Ve.registerFoldingRangeProvider(qe,bt(ge),ve)},registerSelectionRangeProvider(ge,ve){return Ve.registerSelectionRangeProvider(qe,ge,ve)},registerCallHierarchyProvider(ge,ve){return Ve.registerCallHierarchyProvider(qe,ge,ve)},registerTypeHierarchyProvider(ge,ve){return Ve.registerTypeHierarchyProvider(qe,ge,ve)},setLanguageConfiguration:(ge,ve)=>Ve.setLanguageConfiguration(qe,ge,ve),getTokenInformationAtPosition(ge,ve){return(0,it.$4G)(qe,"tokenInformation"),Oe.tokenAtPosition(ge,ve)},registerInlayHintsProvider(ge,ve){return Ve.registerInlayHintsProvider(qe,ge,ve)},createLanguageStatusItem(ge,ve){return Oe.createLanguageStatusItem(qe,ge,ve)},registerDocumentDropEditProvider(ge,ve,Be){return Ve.registerDocumentOnDropEditProvider(qe,ge,ve,(0,it.$3G)(qe,"documentPaste")?Be:void 0)}},an={get activeTextEditor(){return Ce.getActiveTextEditor()},get visibleTextEditors(){return Ce.getVisibleTextEditors()},get activeTerminal(){return wt.activeTerminal},get terminals(){return wt.terminals},async showTextDocument(ge,ve,Be){$.URI.isUri(ge)&&ge.scheme===T.Schemas.vscodeRemote&&!ge.authority&&Nt.report("workspace.showTextDocument",qe,"A URI of 'vscode-remote' scheme requires an authority.");const ht=await($.URI.isUri(ge)?Promise.resolve(cn.openTextDocument(ge)):Promise.resolve(ge));return Ce.showTextDocument(ht,ve,Be)},createTextEditorDecorationType(ge){return Ce.createTextEditorDecorationType(qe,ge)},onDidChangeActiveTextEditor(ge,ve,Be){return lt(Ce.onDidChangeActiveTextEditor)(ge,ve,Be)},onDidChangeVisibleTextEditors(ge,ve,Be){return lt(Ce.onDidChangeVisibleTextEditors)(ge,ve,Be)},onDidChangeTextEditorSelection(ge,ve,Be){return lt(Ce.onDidChangeTextEditorSelection)(ge,ve,Be)},onDidChangeTextEditorOptions(ge,ve,Be){return lt(Ce.onDidChangeTextEditorOptions)(ge,ve,Be)},onDidChangeTextEditorVisibleRanges(ge,ve,Be){return lt(Ce.onDidChangeTextEditorVisibleRanges)(ge,ve,Be)},onDidChangeTextEditorViewColumn(ge,ve,Be){return lt(Ce.onDidChangeTextEditorViewColumn)(ge,ve,Be)},onDidCloseTerminal(ge,ve,Be){return lt(wt.onDidCloseTerminal)(ge,ve,Be)},onDidOpenTerminal(ge,ve,Be){return lt(wt.onDidOpenTerminal)(ge,ve,Be)},onDidChangeActiveTerminal(ge,ve,Be){return lt(wt.onDidChangeActiveTerminal)(ge,ve,Be)},onDidChangeTerminalDimensions(ge,ve,Be){return(0,it.$4G)(qe,"terminalDimensions"),lt(wt.onDidChangeTerminalDimensions)(ge,ve,Be)},onDidChangeTerminalState(ge,ve,Be){return lt(wt.onDidChangeTerminalState)(ge,ve,Be)},onDidWriteTerminalData(ge,ve,Be){return(0,it.$4G)(qe,"terminalDataWriteEvent"),lt(wt.onDidWriteTerminalData)(ge,ve,Be)},onDidExecuteTerminalCommand(ge,ve,Be){return(0,it.$4G)(qe,"terminalExecuteCommandEvent"),lt(wt.onDidExecuteTerminalCommand)(ge,ve,Be)},onDidChangeTerminalShellIntegration(ge,ve,Be){return(0,it.$4G)(qe,"terminalShellIntegration"),lt(ti.onDidChangeTerminalShellIntegration)(ge,ve,Be)},onDidStartTerminalShellExecution(ge,ve,Be){return(0,it.$4G)(qe,"terminalShellIntegration"),lt(ti.onDidStartTerminalShellExecution)(ge,ve,Be)},onDidEndTerminalShellExecution(ge,ve,Be){return(0,it.$4G)(qe,"terminalShellIntegration"),lt(ti.onDidEndTerminalShellExecution)(ge,ve,Be)},get state(){return Ut.getState()},onDidChangeWindowState(ge,ve,Be){return lt(Ut.onDidChangeWindowState)(ge,ve,Be)},showInformationMessage(ge,...ve){return ji.showMessage(qe,N.default.Info,ge,ve[0],ve.slice(1))},showWarningMessage(ge,...ve){return ji.showMessage(qe,N.default.Warning,ge,ve[0],ve.slice(1))},showErrorMessage(ge,...ve){return ji.showMessage(qe,N.default.Error,ge,ve[0],ve.slice(1))},showQuickPick(ge,ve,Be){return ft.showQuickPick(qe,ge,ve,Be)},showWorkspaceFolderPick(ge){return ft.showWorkspaceFolderPick(ge)},showInputBox(ge,ve){return ft.showInput(ge,ve)},showOpenDialog(ge){return Zi.showOpenDialog(qe,ge)},showSaveDialog(ge){return Zi.showSaveDialog(ge)},createStatusBarItem(ge,ve,Be){let ht,St,Ot;return typeof ge=="string"?(ht=ge,St=ve,Ot=Be):(St=ge,Ot=ve),Mi.createStatusBarEntry(qe,ht,St,Ot)},setStatusBarMessage(ge,ve){return Mi.setStatusBarMessage(ge,ve)},withScmProgress(ge){return Nt.report("window.withScmProgress",qe,"Use 'withProgress' instead."),Xt.withProgress(qe,{location:Y.ProgressLocation.SourceControl},(ve,Be)=>ge({report(ht){}}))},withProgress(ge,ve){return Xt.withProgress(qe,ge,ve)},createOutputChannel(ge,ve){return bi.createOutputChannel(ge,ve,qe)},createWebviewPanel(ge,ve,Be,ht){return Ni.createWebviewPanel(qe,ge,ve,Be,ht)},createWebviewTextEditorInset(ge,ve,Be,ht){return(0,it.$4G)(qe,"editorInsets"),Se.createWebviewEditorInset(ge,ve,Be,ht,qe)},createTerminal(ge,ve,Be){return typeof ge=="object"?"pty"in ge?wt.createExtensionTerminal(ge):wt.createTerminalFromOptions(ge):wt.createTerminal(ge,ve,Be)},registerTerminalLinkProvider(ge){return wt.registerLinkProvider(ge)},registerTerminalProfileProvider(ge,ve){return wt.registerProfileProvider(qe,ge,ve)},registerTerminalQuickFixProvider(ge,ve){return(0,it.$4G)(qe,"terminalQuickFixProvider"),wt.registerTerminalQuickFixProvider(ge,qe.identifier.value,ve)},registerTreeDataProvider(ge,ve){return je.registerTreeDataProvider(ge,ve,qe)},createTreeView(ge,ve){return je.createTreeView(ge,ve,qe)},registerWebviewPanelSerializer:(ge,ve)=>Ni.registerWebviewPanelSerializer(qe,ge,ve),registerCustomEditorProvider:(ge,ve,Be={})=>qi.registerCustomEditorProvider(qe,ge,ve,Be),registerFileDecorationProvider(ge){return oi.registerFileDecorationProvider(ge,qe)},registerUriHandler(ge){return fi.registerUriHandler(qe,ge)},createQuickPick(){return ft.createQuickPick(qe)},createInputBox(){return ft.createInputBox(qe)},get activeColorTheme(){return Wi.activeColorTheme},onDidChangeActiveColorTheme(ge,ve,Be){return lt(Wi.onDidChangeActiveColorTheme)(ge,ve,Be)},registerWebviewViewProvider(ge,ve,Be){return xi.registerWebviewViewProvider(qe,ge,ve,Be?.webviewOptions)},get activeNotebookEditor(){return Tt.activeNotebookEditor},onDidChangeActiveNotebookEditor(ge,ve,Be){return lt(Tt.onDidChangeActiveNotebookEditor)(ge,ve,Be)},get visibleNotebookEditors(){return Tt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return lt(Tt.onDidChangeVisibleNotebookEditors)},onDidChangeNotebookEditorSelection(ge,ve,Be){return lt(Pi.onDidChangeNotebookEditorSelection)(ge,ve,Be)},onDidChangeNotebookEditorVisibleRanges(ge,ve,Be){return lt(Pi.onDidChangeNotebookEditorVisibleRanges)(ge,ve,Be)},showNotebookDocument(ge,ve){return Tt.showNotebookDocument(ge,ve)},registerExternalUriOpener(ge,ve,Be){return(0,it.$4G)(qe,"externalUriOpener"),_i.registerExternalUriOpener(qe.identifier,ge,ve,Be)},registerProfileContentHandler(ge,ve){return(0,it.$4G)(qe,"profileContentHandlers"),en.registerProfileContentHandler(qe,ge,ve)},registerQuickDiffProvider(ge,ve,Be,ht){return(0,it.$4G)(qe,"quickDiffProvider"),Jt.registerQuickDiffProvider(bt(ge),ve,Be,ht)},get tabGroups(){return ei.tabGroups},registerShareProvider(ge,ve){return(0,it.$4G)(qe,"shareProvider"),ci.registerShareProvider(bt(ge),ve)}},cn={get rootPath(){return Nt.report("workspace.rootPath",qe,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),Et.getPath()},set rootPath(ge){throw new h.$$("rootPath")},getWorkspaceFolder(ge){return Et.getWorkspaceFolder(ge)},get workspaceFolders(){return Et.getWorkspaceFolders()},get name(){return Et.name},set name(ge){throw new h.$$("name")},get workspaceFile(){return Et.workspaceFile},set workspaceFile(ge){throw new h.$$("workspaceFile")},updateWorkspaceFolders:(ge,ve,...Be)=>Et.updateWorkspaceFolders(qe,ge,ve||0,...Be),onDidChangeWorkspaceFolders:function(ge,ve,Be){return lt(Et.onDidChangeWorkspace)(ge,ve,Be)},asRelativePath:(ge,ve)=>Et.getRelativePath(ge,ve),findFiles:(ge,ve,Be,ht)=>Et.findFiles(ge,ve,Be,qe.identifier,ht),findFiles2:(ge,ve,Be)=>((0,it.$4G)(qe,"findFiles2"),Et.findFiles2(ge,ve,qe.identifier,Be)),findTextInFiles:(ge,ve,Be,ht)=>{(0,it.$4G)(qe,"findTextInFiles");let St,Ot;return typeof ve=="object"?(St=ve,Ot=Be):(St={},Ot=ve,ht=Be),Et.findTextInFiles(ge,St||{},Ot,qe.identifier,ht)},save:ge=>Et.save(ge),saveAs:ge=>Et.saveAs(ge),saveAll:ge=>Et.saveAll(ge),applyEdit(ge,ve){return wn.applyWorkspaceEdit(ge,qe,ve)},createFileSystemWatcher:(ge,ve,Be,ht)=>{let St;return typeof ve=="boolean"?St={ignoreCreateEvents:!!ve,ignoreChangeEvents:!!Be,ignoreDeleteEvents:!!ht,correlate:!1}:ve&&((0,it.$4G)(qe,"createFileSystemWatcher"),St={...ve,correlate:!0}),Qe.createFileSystemWatcher(Et,qe,ge,St)},get textDocuments(){return qt.getAllDocumentData().map(ge=>ge.document)},set textDocuments(ge){throw new h.$$("textDocuments")},openTextDocument(ge){let ve;const Be=ge;if(typeof ge=="string")ve=Promise.resolve($.URI.file(ge));else if($.URI.isUri(ge))ve=Promise.resolve(ge);else if(!Be||typeof Be=="object")ve=qt.createDocumentData(Be);else throw new Error("illegal argument - uriOrFileNameOrOptions");return ve.then(ht=>(ht.scheme===T.Schemas.vscodeRemote&&!ht.authority&&Nt.report("workspace.openTextDocument",qe,"A URI of 'vscode-remote' scheme requires an authority."),qt.ensureDocumentData(ht).then(St=>St.document)))},onDidOpenTextDocument:(ge,ve,Be)=>lt(qt.onDidAddDocument)(ge,ve,Be),onDidCloseTextDocument:(ge,ve,Be)=>lt(qt.onDidRemoveDocument)(ge,ve,Be),onDidChangeTextDocument:(ge,ve,Be)=>lt(qt.onDidChangeDocument)(ge,ve,Be),onDidSaveTextDocument:(ge,ve,Be)=>lt(qt.onDidSaveDocument)(ge,ve,Be),onWillSaveTextDocument:(ge,ve,Be)=>lt(Ii.getOnWillSaveTextDocumentEvent(qe))(ge,ve,Be),get notebookDocuments(){return Tt.notebookDocuments.map(ge=>ge.apiNotebook)},async openNotebookDocument(ge,ve){let Be;if($.URI.isUri(ge))Be=ge,await Tt.openNotebookDocument(ge);else if(typeof ge=="string")Be=$.URI.revive(await Tt.createNotebookDocument({viewType:ge,content:ve}));else throw new Error("Invalid arguments");return Tt.getNotebookDocument(Be).apiNotebook},onDidSaveNotebookDocument(ge,ve,Be){return lt(yi.onDidSaveNotebookDocument)(ge,ve,Be)},onDidChangeNotebookDocument(ge,ve,Be){return lt(yi.onDidChangeNotebookDocument)(ge,ve,Be)},onWillSaveNotebookDocument(ge,ve,Be){return lt(Ci.getOnWillSaveNotebookDocumentEvent(qe))(ge,ve,Be)},get onDidOpenNotebookDocument(){return lt(Tt.onDidOpenNotebookDocument)},get onDidCloseNotebookDocument(){return lt(Tt.onDidCloseNotebookDocument)},registerNotebookSerializer(ge,ve,Be,ht){return Tt.registerNotebookSerializer(qe,ge,ve,Be,(0,it.$3G)(qe,"notebookLiveShare")?ht:void 0)},onDidChangeConfiguration:(ge,ve,Be)=>lt(zi.onDidChangeConfiguration)(ge,ve,Be),getConfiguration(ge,ve){return ve=arguments.length===1?void 0:ve,zi.getConfiguration(ge,ve,qe)},registerTextDocumentContentProvider(ge,ve){return ai.registerTextDocumentContentProvider(ge,ve)},registerTaskProvider:(ge,ve)=>(Nt.report("window.registerTaskProvider",qe,"Use the corresponding function on the 'tasks' namespace instead"),Ht.registerTaskProvider(qe,ge,ve)),registerFileSystemProvider(ge,ve,Be){return(0,R.$Tc)(tt.registerFileSystemProvider(qe,ge,ve,Be),xt.addFileSystemProvider(ge,ve,Be))},get fs(){return xt.value},registerFileSearchProvider:(ge,ve)=>((0,it.$4G)(qe,"fileSearchProvider"),hi.registerFileSearchProvider(ge,ve)),registerTextSearchProvider:(ge,ve)=>((0,it.$4G)(qe,"textSearchProvider"),hi.registerTextSearchProvider(ge,ve)),registerAITextSearchProvider:(ge,ve)=>((0,it.$4G)(qe,"aiTextSearchProvider"),(0,it.$4G)(qe,"textSearchProvider"),hi.registerAITextSearchProvider(ge,ve)),registerRemoteAuthorityResolver:(ge,ve)=>((0,it.$4G)(qe,"resolvers"),Vt.registerRemoteAuthorityResolver(ge,ve)),registerResourceLabelFormatter:ge=>((0,it.$4G)(qe,"resolvers"),Yi.$registerResourceLabelFormatter(ge)),getRemoteExecServer:ge=>((0,it.$4G)(qe,"resolvers"),Vt.getRemoteExecServer(ge)),onDidCreateFiles:(ge,ve,Be)=>lt(Qe.onDidCreateFile)(ge,ve,Be),onDidDeleteFiles:(ge,ve,Be)=>lt(Qe.onDidDeleteFile)(ge,ve,Be),onDidRenameFiles:(ge,ve,Be)=>lt(Qe.onDidRenameFile)(ge,ve,Be),onWillCreateFiles:(ge,ve,Be)=>lt(Qe.getOnWillCreateFileEvent(qe))(ge,ve,Be),onWillDeleteFiles:(ge,ve,Be)=>lt(Qe.getOnWillDeleteFileEvent(qe))(ge,ve,Be),onWillRenameFiles:(ge,ve,Be)=>lt(Qe.getOnWillRenameFileEvent(qe))(ge,ve,Be),openTunnel:ge=>((0,it.$4G)(qe,"tunnels"),Mt.openTunnel(qe,ge).then(ve=>{if(!ve)throw new Error("cannot open tunnel");return ve})),get tunnels(){return(0,it.$4G)(qe,"tunnels"),Mt.getTunnels()},onDidChangeTunnels:(ge,ve,Be)=>((0,it.$4G)(qe,"tunnels"),lt(Mt.onDidChangeTunnels)(ge,ve,Be)),registerPortAttributesProvider:(ge,ve)=>((0,it.$4G)(qe,"portsAttributes"),Mt.registerPortsAttributesProvider(ge,ve)),registerTunnelProvider:(ge,ve)=>((0,it.$4G)(qe,"tunnelFactory"),Mt.registerTunnelProvider(ge,ve)),registerTimelineProvider:(ge,ve)=>((0,it.$4G)(qe,"timeline"),pn.registerTimelineProvider(ge,ve,qe.identifier,Dt.converter)),get isTrusted(){return Et.trusted},requestWorkspaceTrust:ge=>((0,it.$4G)(qe,"workspaceTrust"),Et.requestWorkspaceTrust(ge)),onDidGrantWorkspaceTrust:(ge,ve,Be)=>lt(Et.onDidGrantWorkspaceTrust)(ge,ve,Be),registerEditSessionIdentityProvider:(ge,ve)=>((0,it.$4G)(qe,"editSessionIdentityProvider"),Et.registerEditSessionIdentityProvider(ge,ve)),onWillCreateEditSessionIdentity:(ge,ve,Be)=>((0,it.$4G)(qe,"editSessionIdentityProvider"),lt(Et.getOnWillCreateEditSessionIdentityEvent(qe))(ge,ve,Be)),registerCanonicalUriProvider:(ge,ve)=>((0,it.$4G)(qe,"canonicalUriProvider"),Et.registerCanonicalUriProvider(ge,ve)),getCanonicalUri:(ge,ve,Be)=>((0,it.$4G)(qe,"canonicalUriProvider"),Et.provideCanonicalUri(ge,ve,Be))},ln={get inputBox(){return Nt.report("scm.inputBox",qe,"Use 'SourceControl.inputBox' instead"),Ct.getLastInputBox(qe)},createSourceControl(ge,ve,Be){return Ct.createSourceControl(qe,ge,ve,Be)}},un={createCommentController(ge,ve){return jt.createCommentController(qe,ge,ve)}},En={get activeDebugSession(){return Pt.activeDebugSession},get activeDebugConsole(){return Pt.activeDebugConsole},get breakpoints(){return Pt.breakpoints},get activeStackItem(){return Pt.activeStackItem},registerDebugVisualizationProvider(ge,ve){return(0,it.$4G)(qe,"debugVisualization"),Pt.registerDebugVisualizationProvider(qe,ge,ve)},registerDebugVisualizationTreeProvider(ge,ve){return(0,it.$4G)(qe,"debugVisualization"),Pt.registerDebugVisualizationTree(qe,ge,ve)},onDidStartDebugSession(ge,ve,Be){return lt(Pt.onDidStartDebugSession)(ge,ve,Be)},onDidTerminateDebugSession(ge,ve,Be){return lt(Pt.onDidTerminateDebugSession)(ge,ve,Be)},onDidChangeActiveDebugSession(ge,ve,Be){return lt(Pt.onDidChangeActiveDebugSession)(ge,ve,Be)},onDidReceiveDebugSessionCustomEvent(ge,ve,Be){return lt(Pt.onDidReceiveDebugSessionCustomEvent)(ge,ve,Be)},onDidChangeBreakpoints(ge,ve,Be){return lt(Pt.onDidChangeBreakpoints)(ge,ve,Be)},onDidChangeActiveStackItem(ge,ve,Be){return lt(Pt.onDidChangeActiveStackItem)(ge,ve,Be)},registerDebugConfigurationProvider(ge,ve,Be){return Pt.registerDebugConfigurationProvider(ge,ve,Be||Bt.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(ge,ve){return Pt.registerDebugAdapterDescriptorFactory(qe,ge,ve)},registerDebugAdapterTrackerFactory(ge,ve){return Pt.registerDebugAdapterTrackerFactory(ge,ve)},startDebugging(ge,ve,Be){return!Be||typeof Be=="object"&&"configuration"in Be?Pt.startDebugging(ge,ve,{parentSession:Be}):Pt.startDebugging(ge,ve,Be||{})},stopDebugging(ge){return Pt.stopDebugging(ge)},addBreakpoints(ge){return Pt.addBreakpoints(ge)},removeBreakpoints(ge){return Pt.removeBreakpoints(ge)},asDebugSourceUri(ge,ve){return Pt.asDebugSourceUri(ge,ve)}},yn={registerTaskProvider:(ge,ve)=>Ht.registerTaskProvider(qe,ge,ve),fetchTasks:ge=>Ht.fetchTasks(ge),executeTask:ge=>Ht.executeTask(qe,ge),get taskExecutions(){return Ht.taskExecutions},onDidStartTask:(ge,ve,Be)=>lt(Ht.onDidStartTask)(ge,ve,Be),onDidEndTask:(ge,ve,Be)=>lt(Ht.onDidEndTask)(ge,ve,Be),onDidStartTaskProcess:(ge,ve,Be)=>lt(Ht.onDidStartTaskProcess)(ge,ve,Be),onDidEndTaskProcess:(ge,ve,Be)=>lt(Ht.onDidEndTaskProcess)(ge,ve,Be)},hn={createNotebookController(ge,ve,Be,ht,St){return Si.createNotebookController(qe,ge,ve,Be,ht,(0,it.$3G)(qe,"notebookMessaging")?St:void 0)},registerNotebookCellStatusBarItemProvider:(ge,ve)=>Tt.registerNotebookCellStatusBarItemProvider(qe,ge,ve),createRendererMessaging(ge){return mi.createRendererMessaging(qe,ge)},createNotebookControllerDetectionTask(ge){return(0,it.$4G)(qe,"notebookKernelSource"),Si.createNotebookControllerDetectionTask(qe,ge)},registerKernelSourceActionProvider(ge,ve){return(0,it.$4G)(qe,"notebookKernelSource"),Si.registerKernelSourceActionProvider(qe,ge,ve)},onDidChangeNotebookCellExecutionState(ge,ve,Be){return(0,it.$4G)(qe,"notebookCellExecutionState"),lt(Si.onDidChangeNotebookCellExecutionState)(ge,ve,Be)}},Ki={t(...ge){if(typeof ge[0]=="string"){const ve=ge.shift(),Be=!ge||typeof ge[0]!="object"?ge:ge[0];return wi.getMessage(qe.identifier.value,{message:ve,args:Be})}return wi.getMessage(qe.identifier.value,ge[0])},get bundle(){return wi.getBundle(qe.identifier.value)},get uri(){return wi.getBundleUri(qe.identifier.value)}},dn={_version:1,transferActiveChat(ge){return(0,it.$4G)(qe,"interactive"),Fi.transferActiveChat(ge)}},fn={getRelatedInformation(ge,ve){return(0,it.$4G)(qe,"aiRelatedInformation"),nn.getRelatedInformation(qe,ge,ve)},registerRelatedInformationProvider(ge,ve){return(0,it.$4G)(qe,"aiRelatedInformation"),nn.registerRelatedInformationProvider(qe,ge,ve)},registerEmbeddingVectorProvider(ge,ve){return(0,it.$4G)(qe,"aiRelatedInformation"),Gi.registerEmbeddingVectorProvider(qe,ge,ve)}},gn={_version:1,registerChatResponseProvider(ge,ve,Be){return(0,it.$4G)(qe,"chatProvider"),Qt.registerLanguageModel(qe,ge,ve,Be)},registerChatVariableResolver(ge,ve,Be,ht,St,Ot,Ai,Qi){return(0,it.$4G)(qe,"chatVariableResolver"),tn.registerVariableResolver(qe,ge,ve,Be,ht,St,Ot,Ai,Qi?.id)},registerMappedEditsProvider(ge,ve){return(0,it.$4G)(qe,"mappedEditsProvider"),Ve.registerMappedEditsProvider(qe,ge,ve)},createChatParticipant(ge,ve){return Fi.createChatAgent(qe,ge,ve)},createDynamicChatParticipant(ge,ve,Be){return(0,it.$4G)(qe,"chatParticipantPrivate"),Fi.createDynamicChatAgent(qe,ge,ve,Be)}},Sn={selectChatModels:ge=>vt.quality==="stable"?(console.warn(`[${k.$qn.toKey(qe.identifier)}] This API is disabled in '${vt.environment.appName}'-stable.`),Promise.resolve([])):Qt.selectLanguageModels(qe,ge??{}),onDidChangeChatModels:(ge,ve,Be)=>vt.quality==="stable"?(console.warn(`[${k.$qn.toKey(qe.identifier)}] This API is disabled in '${vt.environment.appName}'-stable.`),P.Event.None(ge,ve,Be)):Qt.onDidChangeProviders(ge,ve,Be),registerChatModelProvider:(ge,ve,Be)=>((0,it.$4G)(qe,"chatProvider"),Qt.registerLanguageModel(qe,ge,ve,Be)),get embeddingModels(){return(0,it.$4G)(qe,"embeddings"),Ti.embeddingsModels},onDidChangeEmbeddingModels:(ge,ve,Be)=>((0,it.$4G)(qe,"embeddings"),Ti.onDidChange(ge,ve,Be)),registerEmbeddingsProvider(ge,ve){return(0,it.$4G)(qe,"embeddings"),Ti.registerEmbeddingsProvider(qe,ge,ve)},async computeEmbeddings(ge,ve,Be){return(0,it.$4G)(qe,"embeddings"),Ti.computeEmbeddings(ge,ve,Be)},registerTool(ge,ve){return(0,it.$4G)(qe,"chatVariableResolver"),Vi.registerTool(qe,ge,ve)},invokeTool(ge,ve,Be){return(0,it.$4G)(qe,"chatVariableResolver"),Vi.invokeTool(ge,ve,Be)},get tools(){return(0,it.$4G)(qe,"chatVariableResolver"),Vi.tools}},Dn={registerSpeechProvider(ge,ve){return(0,it.$4G)(qe,"speech"),bn.registerProvider(qe.identifier,ge,ve)}};return{version:vt.version,ai:fn,authentication:Bi,commands:vn,comments:un,chat:gn,debug:En,env:gi,extensions:sn,interactive:dn,l10n:Ki,languages:on,lm:Sn,notebooks:hn,scm:ln,speech:Dn,tasks:yn,tests:Ui,window:an,workspace:cn,Breakpoint:Y.$uO,TerminalOutputAnchor:Y.TerminalOutputAnchor,ChatResultFeedbackKind:Y.ChatResultFeedbackKind,ChatVariableLevel:Y.ChatVariableLevel,ChatCompletionItem:Y.$pP,CallHierarchyIncomingCall:Y.$SN,CallHierarchyItem:Y.$RN,CallHierarchyOutgoingCall:Y.$TN,CancellationError:h.$7,CancellationTokenSource:r.$xe,CandidatePortSource:n.CandidatePortSource,CodeAction:Y.$ON,CodeActionKind:Y.$PN,CodeActionTriggerKind:Y.CodeActionTriggerKind,CodeLens:Y.$UN,Color:Y.$8N,ColorInformation:Y.$9N,ColorPresentation:Y.$0N,ColorThemeKind:Y.ColorThemeKind,CommentMode:Y.CommentMode,CommentState:Y.CommentState,CommentThreadCollapsibleState:Y.CommentThreadCollapsibleState,CommentThreadState:Y.CommentThreadState,CommentThreadApplicability:Y.CommentThreadApplicability,CompletionItem:Y.$2N,CompletionItemKind:Y.CompletionItemKind,CompletionItemTag:Y.CompletionItemTag,CompletionList:Y.$3N,CompletionTriggerKind:Y.CompletionTriggerKind,ConfigurationTarget:Y.ConfigurationTarget,CustomExecution:Y.$fO,DebugAdapterExecutable:Y.$yO,DebugAdapterInlineImplementation:Y.$BO,DebugAdapterNamedPipeServer:Y.$AO,DebugAdapterServer:Y.$zO,DebugConfigurationProviderTriggerKind:Bt.DebugConfigurationProviderTriggerKind,DebugConsoleMode:Y.DebugConsoleMode,DebugVisualization:Y.$RO,DecorationRangeBehavior:Y.DecorationRangeBehavior,Diagnostic:Y.$HN,DiagnosticRelatedInformation:Y.$GN,DiagnosticSeverity:Y.DiagnosticSeverity,DiagnosticTag:Y.DiagnosticTag,Disposable:Y.$tN,DocumentHighlight:Y.$KN,DocumentHighlightKind:Y.DocumentHighlightKind,MultiDocumentHighlight:Y.$LN,DocumentLink:Y.$7N,DocumentSymbol:Y.$NN,EndOfLine:Y.EndOfLine,EnvironmentVariableMutatorType:Y.EnvironmentVariableMutatorType,EvaluatableExpression:Y.$EO,InlineValueText:Y.$FO,InlineValueVariableLookup:Y.$GO,InlineValueEvaluatableExpression:Y.$HO,InlineCompletionTriggerKind:Y.InlineCompletionTriggerKind,EventEmitter:P.$me,ExtensionKind:Y.ExtensionKind,ExtensionMode:Y.ExtensionMode,ExternalUriOpenerPriority:Y.ExternalUriOpenerPriority,FileChangeType:Y.FileChangeType,FileDecoration:Y.$TO,FileDecoration2:Y.$TO,FileSystemError:Y.$KO,FileType:p.FileType,FilePermission:p.FilePermission,FoldingRange:Y.$LO,FoldingRangeKind:Y.FoldingRangeKind,FunctionBreakpoint:Y.$wO,InlineCompletionItem:Y.$4N,InlineCompletionList:Y.$5N,Hover:Y.$IN,VerboseHover:Y.$JN,HoverVerbosityAction:Y.HoverVerbosityAction,IndentAction:E.IndentAction,Location:Y.$FN,MarkdownString:Y.$VN,OverviewRulerLane:u.OverviewRulerLane,ParameterInformation:Y.$WN,PortAutoForwardAction:Y.PortAutoForwardAction,Position:Y.$uN,ProcessExecution:Y.$dO,ProgressLocation:Y.ProgressLocation,QuickInputButtons:Y.$SO,Range:Y.$vN,RelativePattern:Y.$sO,Selection:Y.$wN,SelectionRange:Y.$QN,SemanticTokens:Y.$OO,SemanticTokensBuilder:Y.$NO,SemanticTokensEdit:Y.$PO,SemanticTokensEdits:Y.$QO,SemanticTokensLegend:Y.$MO,ShellExecution:Y.$eO,ShellQuoting:Y.ShellQuoting,SignatureHelp:Y.$YN,SignatureHelpTriggerKind:Y.SignatureHelpTriggerKind,SignatureInformation:Y.$XN,SnippetString:Y.$EN,SourceBreakpoint:Y.$vO,StandardTokenType:Y.StandardTokenType,StatusBarAlignment:Y.StatusBarAlignment,SymbolInformation:Y.$MN,SymbolKind:Y.SymbolKind,SymbolTag:Y.SymbolTag,Task:Y.$gO,TaskGroup:Y.$cO,TaskPanelKind:Y.TaskPanelKind,TaskRevealKind:Y.TaskRevealKind,TaskScope:Y.TaskScope,TerminalLink:Y.$$N,TerminalQuickFixTerminalCommand:Y.$aO,TerminalQuickFixOpener:Y.$_N,TerminalLocation:Y.TerminalLocation,TerminalProfile:Y.$bO,TerminalExitReason:Y.TerminalExitReason,TerminalShellExecutionCommandLineConfidence:Y.TerminalShellExecutionCommandLineConfidence,TextDocumentSaveReason:Y.TextDocumentSaveReason,TextEdit:Y.$AN,SnippetTextEdit:Y.$CN,TextEditorCursorStyle:c.TextEditorCursorStyle,TextEditorLineNumbersStyle:Y.TextEditorLineNumbersStyle,TextEditorRevealType:Y.TextEditorRevealType,TextEditorSelectionChangeKind:Y.TextEditorSelectionChangeKind,SyntaxTokenType:Y.SyntaxTokenType,TextDocumentChangeReason:Y.TextDocumentChangeReason,ThemeColor:Y.$rO,ThemeIcon:Y.$qO,TreeItem:Y.$hO,TreeItemCheckboxState:Y.TreeItemCheckboxState,TreeItemCollapsibleState:Y.TreeItemCollapsibleState,TypeHierarchyItem:Y.$dP,UIKind:di.UIKind,Uri:$.URI,ViewColumn:Y.ViewColumn,WorkspaceEdit:Y.$DN,DocumentPasteTriggerKind:Y.DocumentPasteTriggerKind,DocumentDropEdit:Y.$nO,DocumentDropOrPasteEditKind:Y.$oO,DocumentPasteEdit:Y.$pO,InlayHint:Y.$1N,InlayHintLabelPart:Y.$ZN,InlayHintKind:Y.InlayHintKind,RemoteAuthorityResolverError:Y.$zN,ResolvedAuthority:Y.$xN,ManagedResolvedAuthority:Y.$yN,SourceControlInputBoxValidationType:Y.SourceControlInputBoxValidationType,ExtensionRuntime:Y.ExtensionRuntime,TimelineItem:Y.$4O,NotebookRange:Y.$VO,NotebookCellKind:Y.NotebookCellKind,NotebookCellExecutionState:Y.NotebookCellExecutionState,NotebookCellData:Y.$WO,NotebookData:Y.$XO,NotebookRendererScript:Y.$2O,NotebookCellStatusBarAlignment:Y.NotebookCellStatusBarAlignment,NotebookEditorRevealType:Y.NotebookEditorRevealType,NotebookCellOutput:Y.$ZO,NotebookCellOutputItem:Y.$YO,NotebookCellStatusBarItem:Y.$1O,NotebookControllerAffinity:Y.NotebookControllerAffinity,NotebookControllerAffinity2:Y.NotebookControllerAffinity2,NotebookEdit:Y.$BN,NotebookKernelSourceAction:Y.$3O,NotebookVariablesRequestKind:Y.NotebookVariablesRequestKind,PortAttributes:Y.$6O,LinkedEditingRanges:Y.$5O,TestResultState:Y.TestResultState,TestRunRequest:Y.$7O,TestMessage:Y.$8O,TestTag:Y.$9O,TestRunProfileKind:Y.TestRunProfileKind,TextSearchCompleteMessageType:At.TextSearchCompleteMessageType,DataTransfer:Y.$mO,DataTransferItem:Y.$iO,TestCoverageCount:Y.$0O,FileCoverage:Y.$_O,FileCoverage2:Y.$_O,StatementCoverage:Y.$aP,BranchCoverage:Y.$bP,DeclarationCoverage:Y.$cP,WorkspaceTrustState:Y.WorkspaceTrustState,LanguageStatusSeverity:Y.LanguageStatusSeverity,QuickPickItemKind:Y.QuickPickItemKind,InputBoxValidationSeverity:Y.InputBoxValidationSeverity,TabInputText:Y.$eP,TabInputTextDiff:Y.$fP,TabInputTextMerge:Y.$gP,TabInputCustom:Y.$hP,TabInputNotebook:Y.$jP,TabInputNotebookDiff:Y.$kP,TabInputWebview:Y.$iP,TabInputTerminal:Y.$lP,TabInputInteractiveWindow:Y.$mP,TabInputChat:Y.$nP,TabInputTextMultiDiff:Y.$oP,TelemetryTrustedValue:d.$sp,LogLevel:a.LogLevel,EditSessionIdentityMatch:m.EditSessionIdentityMatch,InteractiveSessionVoteDirection:Y.InteractiveSessionVoteDirection,ChatCopyKind:Y.ChatCopyKind,InteractiveEditorResponseFeedbackKind:Y.InteractiveEditorResponseFeedbackKind,DebugStackFrame:Y.$CO,DebugThread:Y.$DO,RelatedInformationType:Y.RelatedInformationType,SpeechToTextStatus:Y.SpeechToTextStatus,TextToSpeechStatus:Y.TextToSpeechStatus,PartialAcceptTriggerKind:Y.PartialAcceptTriggerKind,KeywordRecognitionStatus:Y.KeywordRecognitionStatus,ChatResponseMarkdownPart:Y.$qP,ChatResponseFileTreePart:Y.$uP,ChatResponseAnchorPart:Y.$vP,ChatResponseProgressPart:Y.$wP,ChatResponseProgressPart2:Y.$xP,ChatResponseReferencePart:Y.$AP,ChatResponseWarningPart:Y.$yP,ChatResponseTextEditPart:Y.$BP,ChatResponseMarkdownWithVulnerabilitiesPart:Y.$rP,ChatResponseCommandButtonPart:Y.$zP,ChatResponseDetectedParticipantPart:Y.$sP,ChatResponseConfirmationPart:Y.$tP,ChatRequestTurn:Y.$CP,ChatResponseTurn:Y.$DP,ChatLocation:Y.ChatLocation,LanguageModelChatMessageRole:Y.LanguageModelChatMessageRole,LanguageModelChatMessage:Y.$FP,LanguageModelChatMessageFunctionResultPart:Y.$EP,LanguageModelChatResponseTextPart:Y.$HP,LanguageModelChatResponseFunctionUsePart:Y.$GP,LanguageModelChatMessage2:Y.$FP,LanguageModelChatSystemMessage:Y.$IP,LanguageModelChatUserMessage:Y.$JP,LanguageModelChatAssistantMessage:Y.$KP,LanguageModelError:Y.$LP,NewSymbolName:Y.$JO,NewSymbolNameTag:Y.NewSymbolNameTag,NewSymbolNameTriggerKind:Y.NewSymbolNameTriggerKind,InlineEdit:Y.$MP,InlineEditTriggerKind:Y.InlineEditTriggerKind}}}}),define(Ee[396],ye([1,0,89,168,48,162,42,35,64,47,101,102,103,126,77,96,161,76,63,125,95,78,160,12,65,123,124,128,129,166,99]),function(ce,e,r,h,P,R,T,N,$,c,I,E,u,k,p,a,f,d,m,n,o,t,i,s,g,l,w,S,D,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,r.$Ks)(l.$Ooc,l.$Noc,r.InstantiationType.Delayed),(0,r.$Ks)(s.$ak,i.$4pc,r.InstantiationType.Delayed),(0,r.$Ks)(a.$Tnc,a.$Unc,r.InstantiationType.Delayed),(0,r.$Ks)(N.$hQ,N.$gQ,r.InstantiationType.Eager),(0,r.$Ks)(S.$4nc,S.$5nc,r.InstantiationType.Eager),(0,r.$Ks)(D.$Ioc,D.$Joc,r.InstantiationType.Eager),(0,r.$Ks)(T.$goc,T.$eoc,r.InstantiationType.Eager),(0,r.$Ks)(d.$ioc,d.$hoc,r.InstantiationType.Eager),(0,r.$Ks)(C.$Yoc,C.$Zoc,r.InstantiationType.Eager),(0,r.$Ks)(E.$4oc,E.$8oc,r.InstantiationType.Eager),(0,r.$Ks)(R.$0oc,R.$9oc,r.InstantiationType.Eager),(0,r.$Ks)($.$9P,$.$8P,r.InstantiationType.Eager),(0,r.$Ks)(w.$Poc,w.$Qoc,r.InstantiationType.Eager),(0,r.$Ks)(m.$Xnc,m.$Wnc,r.InstantiationType.Eager),(0,r.$Ks)(h.$Cpc,h.$Bpc,r.InstantiationType.Delayed),(0,r.$Ks)(u.$npc,u.$opc,r.InstantiationType.Eager),(0,r.$Ks)(k.$Boc,k.$Aoc,r.InstantiationType.Eager),(0,r.$Ks)(I.$Ppc,I.$Opc,r.InstantiationType.Eager),(0,r.$Ks)(c.$Eoc,c.$Hoc,r.InstantiationType.Eager),(0,r.$Ks)(y.$Qpc,y.$Rpc,r.InstantiationType.Eager),(0,r.$Ks)(p.$EFb,p.$FFb,r.InstantiationType.Eager),(0,r.$Ks)(f.$1pc,f.$Zpc,r.InstantiationType.Eager),(0,r.$Ks)(P.$doc,P.$coc,r.InstantiationType.Eager),(0,r.$Ks)(n.$Loc,n.$Koc,r.InstantiationType.Eager),(0,r.$Ks)(o.$fQ,o.$cQ,r.InstantiationType.Eager),(0,r.$Ks)(t.$soc,t.$toc,r.InstantiationType.Eager),(0,r.$Ks)(g.$Woc,g.$Xoc,r.InstantiationType.Eager)}),define(Ee[130],ye([1,0,19,12,38,100]),function(ce,e,r,h,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jqc=void 0,e.$hqc=T,e.$iqc=N,R=We(R);function T(E){return E.startsWith("**")||E.startsWith("/")?E:`/${E}`}function N(E,u,k,p){const a=(0,r.$3b)(k,$),f=new P.$TL(u,a,p),d=f.preview.matches;return{ranges:(0,r.$3b)(a,c),uri:E,preview:{text:f.preview.text,matches:(0,r.$3b)(d,c)}}}function $(E){return new P.$UL(E.start.line,E.start.character,E.end.line,E.end.character)}function c(E){return new R.$HL(E.startLineNumber,E.startColumn,E.endLineNumber,E.endColumn)}let I=class{constructor(u,k){this.a=u,this.b=k}appendLine(u){this.b.debug(`${this.a}#search`,u)}};e.$jqc=I,e.$jqc=I=Je([Ge(1,h.$_j)],I)}),define(Ee[397],ye([1,0,58,16,82,33,11,13,130,398]),function(ce,e,r,h,P,R,T,N,$,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kqc=E,e.$lqc=f,e.$mqc=m,r=We(r),h=We(h),R=We(R),N=We(N);const I=c.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function E(n,o,t,i,s){const g=u(n,o,t,i,s),l=o.folder.fsPath;return{cmd:r.spawn(I,g.args,{cwd:l}),rgDiskPath:I,siblingClauses:g.siblingClauses,rgArgs:g,cwd:l}}function u(n,o,t,i,s){const g=["--files","--hidden","--case-sensitive","--no-require-git"];p([o],t,!1).forEach(w=>{const S=(0,$.$hqc)(w);if(g.push("-g",S),T.$j){const D=(0,P.$nm)(S);D!==S&&g.push("-g",D)}});const l=k([o],i,void 0,!1);return l.globArgs.forEach(w=>{const S=`!${(0,$.$hqc)(w)}`;if(g.push("-g",S),T.$j){const D=(0,P.$nm)(S);D!==S&&g.push("-g",D)}}),o.disregardIgnoreFiles!==!1?g.push("--no-ignore"):o.disregardParentIgnoreFiles!==!1&&g.push("--no-ignore-parent"),o.ignoreSymlinks||g.push("--follow"),n.exists&&g.push("--quiet"),s&&g.push("--threads",`${s}`),g.push("--no-config"),o.disregardGlobalIgnoreFiles&&g.push("--no-ignore-global"),{args:g,siblingClauses:l.siblingClauses}}function k(n,o,t,i=!0){const s=[];let g={};return n.forEach(l=>{const w=Object.assign({},l.excludePattern||{},o||{}),S=a(w,i?l.folder.fsPath:void 0,t);s.push(...S.globArgs),S.siblingClauses&&(g=Object.assign(g,S.siblingClauses))}),{globArgs:s,siblingClauses:g}}function p(n,o,t=!0){const i=[];return n.forEach(s=>{const g=Object.assign({},o||{},s.includePattern||{}),l=a(g,t?s.folder.fsPath:void 0);i.push(...l.globArgs)}),i}function a(n,o,t){const i=[],s={};return Object.keys(n).forEach(g=>{if(t&&t.has(g)||!g)return;const l=n[g];g=d(o?f(o,g):g),g.startsWith("\\\\")?g="\\\\"+g.substr(2).replace(/\\/g,"/"):g=g.replace(/\\/g,"/"),typeof l=="boolean"&&l?(g.startsWith("\\\\")&&(g+="**"),i.push(m(g))):l&&l.when&&(s[g]=l)}),{globArgs:i,siblingClauses:s}}function f(n,o){return h.$kc(o)?o:h.$lc(n,o)}function d(n){return n=N.$of(n,"\\"),N.$of(n,"/")}function m(n){return R.$Ag(n).toLowerCase()==="c:/"?n.replace(/^c:[/\\]/i,"/"):n}}),define(Ee[399],ye([1,0,58,61,16,400,19,55,39,82,33,11,43,13,18,34,38,397,141]),function(ce,e,r,h,P,R,T,N,$,c,I,E,u,k,p,a,f,d,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oqc=e.$nqc=void 0,r=We(r),h=We(h),P=We(P),T=We(T),$=We($),c=We(c),E=We(E),k=We(k),p=We(p);const n=new Set;process.on("exit",()=>{n.forEach(g=>g())});class o{constructor(l){this.c=null,this.h=null,this.l=!1,this.m=null,this.r=null,this.s=0,this.a=l,this.b=l.filePattern||"",this.d=l.includePattern&&$.$zk(l.includePattern),this.f=l.maxResults||null,this.g=!!l.exists,this.v=Object.create(null),this.k=0,this.j=!1,this.o=0,this.p=0,this.q=[],this.b&&(this.c=l.shouldGlobMatchFilePattern?null:(0,m.$Kr)(this.b).normalizedLowercase),this.u=l.excludePattern&&$.$zk(l.excludePattern),this.t=new Map,l.folderQueries.forEach(w=>{const S=Object.assign({},w.excludePattern||{},this.a.excludePattern||{}),D=w.folder.fsPath;l.folderQueries.map(y=>y.folder.fsPath).filter(y=>y!==D).forEach(y=>{(0,I.$Eg)(y,D)&&(S[P.$nc(D,y)]=!0)}),this.t.set(D,new i(S,D))})}cancel(){this.l=!0,n.forEach(l=>l())}walk(l,w,S,D,y,C){if(this.m=u.$ge.create(!1),this.l)return C(null,this.j);w.forEach(A=>{const b=P.$pc(A.fsPath);this.u&&this.u(A.fsPath,b)||this.J(D,{relativePath:A.fsPath,searchPath:void 0})}),this.r=u.$ge.create(!1),this.w(l,(A,b)=>{this.x(this.y,this,A,S,D,y,v=>{if(v){const L=(0,N.$qj)(v);console.error(L),this.q.push(L),b(v,void 0)}else b(null,void 0)})},(A,b)=>{this.m.stop();const v=A?T.$Jb(A)[0]:null;C(v,this.j)})}w(l,w,S){const D=new Array(l.length),y=new Array(l.length);let C=!1,A=0;if(l.length===0)return S(null,[]);l.forEach((b,v)=>{w(b,(L,O)=>{if(L?(C=!0,D[v]=null,y[v]=L):(D[v]=O,y[v]=null),++A===l.length)return S(C?y:null,D)})})}x(l,w,...S){try{l.apply(w,S)}catch(D){S[S.length-1](D)}}y(l,w,S,D,y){const C=l.folder.fsPath,A=E.$j,b=()=>j&&j.kill();n.add(b);let v=_=>{n.delete(b),v=()=>{},y(_)},L="";const O=this.D(),M=(0,d.$kqc)(this.a,l,this.a.includePattern,this.t.get(l.folder.fsPath).expression,w),j=M.cmd,z=!Object.keys(M.siblingClauses).length,F=M.rgArgs.args.map(_=>_.match(/^-/)?_:`'${_}'`).join(" ");let B=`${M.rgDiskPath} ${F}
 - cwd: ${M.cwd}`;M.rgArgs.siblingClauses&&(B+=`
 - Sibling clauses: ${JSON.stringify(M.rgArgs.siblingClauses)}`),D({message:B}),this.s=0,this.z(j,"utf8",D,(_,re,U)=>{if(_){v(_);return}if(this.j){v();return}const Q=(L+(A?c.$mm(re||""):re)).split(`
`);if(U){const ee=Q.length;Q[ee-1]=Q[ee-1].trim(),Q[ee-1]||Q.pop()}else L=Q.pop()||"";if(Q.length&&Q[0].indexOf(`
`)!==-1){v(new Error("Splitting up files failed"));return}if(this.s+=Q.length,z){for(const ee of Q)if(this.J(S,{base:C,relativePath:ee,searchPath:this.N(l,ee)}),this.j){b();break}(U||this.j)&&v();return}this.G(l,O,C,Q,S),U&&(this.H(O,C,S),v())})}spawnFindCmd(l){const w=this.t.get(l.folder.fsPath),S=w.getBasenameTerms(),D=w.getPathTerms(),y=["-L","."];if(S.length||D.length){y.push("-not","(","(");for(const C of S)y.push("-name",C),y.push("-o");for(const C of D)y.push("-path",C),y.push("-o");y.pop(),y.push(")","-prune",")")}return y.push("-type","f"),r.spawn("find",y,{cwd:l.folder.fsPath})}readStdout(l,w,S){let D="";this.z(l,w,()=>{},(y,C,A)=>{if(y){S(y);return}D+=C,A&&S(null,D)})}z(l,w,S,D){let y=(b,v,L)=>{(b||L)&&(y=()=>{},this.r?.stop()),D(b,v,L)},C=!1;l.stdout?(this.A(l.stdout,w,y),l.stdout.once("data",()=>C=!0)):S({message:"stdout is null"});let A;l.stderr?A=this.B(l.stderr):S({message:"stderr is null"}),l.on("error",b=>{y(b)}),l.on("close",b=>{let v;!C&&(v=this.C(A,w))&&s(v)?y(new Error(`command failed with error code ${b}: ${this.C(A,w)}`)):(this.g&&b===0&&(this.j=!0),y(null,"",!0))})}A(l,w,S){const D=new R.StringDecoder(w);return l.on("data",y=>{S(null,D.write(y))}),D}B(l){const w=[];return l.on("data",S=>{w.push(S)}),w}C(l,w){const S=new R.StringDecoder(w);return l.map(D=>S.write(D)).join("")}D(){const l={rootEntries:[],pathToEntries:Object.create(null)};return l.pathToEntries["."]=l.rootEntries,l}G(l,{pathToEntries:w},S,D,y){D.indexOf(this.b)!==-1&&this.J(y,{base:S,relativePath:this.b,searchPath:this.N(l,this.b)});const C=A=>{const b=P.$pc(A),v=P.$oc(A);let L=w[v];L||(L=w[v]=[],C(v)),L.push({base:S,relativePath:A,basename:b,searchPath:this.N(l,A)})};D.forEach(C)}H({rootEntries:l,pathToEntries:w},S,D){const y=this,C=this.t.get(S),A=this.b;function b(v){y.o++;const L=(0,f.$0L)(()=>v.map(O=>O.basename));for(let O=0,M=v.length;O<M;O++){const j=v[O],{relativePath:z,basename:F}=j;if(C.test(z,F,A!==F?L:void 0))continue;const B=w[z];if(B)b(B);else{if(y.p++,z===A)continue;y.J(D,j)}if(y.j)break}}b(l)}getStats(){return{cmdTime:this.r.elapsed(),fileWalkTime:this.m.elapsed(),directoriesWalked:this.o,filesWalked:this.p,cmdResultCount:this.s}}I(l,w,S,D,y){const C=l.folder,A=(0,f.$0L)(()=>S);this.w(S,(b,v)=>{if(this.l||this.j)return v(null);const L=w?[w,b].join(P.sep):b;if(this.t.get(l.folder.fsPath).test(L,b,this.a.filePattern!==b?A:void 0))return v(null);const O=[C.fsPath,L].join(P.sep);h.lstat(O,(M,j)=>{if(M||this.l||this.j)return v(null);this.L(O,j,(z,F)=>z||this.l||this.j?v(null):F.isDirectory()?(this.o++,this.M(O,j,(B,_)=>B||this.l||this.j||(_=_||"",this.v[_])?v(null):(this.v[_]=!0,a.Promises.readdir(O).then(re=>{if(this.l||this.j)return v(null);this.I(l,L,re,D,U=>v(U||null))},re=>{v(null)})))):(this.p++,L===this.b||this.h&&p.$jg(F.size)&&F.size>this.h||this.J(D,{base:C.fsPath,relativePath:L,searchPath:this.N(l,L)}),v(null,void 0)))})},b=>{const v=b&&T.$Jb(b);return y(v&&v.length>0?v[0]:void 0)})}J(l,w){this.K(w)&&(!this.d||this.d(w.relativePath,P.$pc(w.relativePath)))&&(this.k++,(this.g||this.f&&this.k>this.f)&&(this.j=!0),this.j||l(w))}K(l){if(this.b){if(this.b==="*")return!0;if(this.c)return(0,f.$5L)(l,this.c);if(this.b)return(0,f.$5L)(l,this.b,!1)}return!0}L(l,w,S){return w.isSymbolicLink()?h.stat(l,S):S(null,w)}M(l,w,S){return w.isSymbolicLink()?h.realpath(l,(D,y)=>D?S(D):S(null,y)):S(null,l)}N(l,w){return l.folderName?P.$lc(l.folderName,w):w}}e.$nqc=o;class t{constructor(l,w){this.a=l.folderQueries,this.b=l.extraFileResources||[],this.d=w,this.c=new o(l)}search(l,w,S){this.c.walk(this.a,this.b,this.d,l,w,(D,y)=>{S(D,{limitHit:y,stats:this.c.getStats(),messages:[]})})}cancel(){this.c.cancel()}}e.$oqc=t;class i{constructor(l,w){this.expression=l,this.c=w,this.d(l)}d(l){let w,S;Object.keys(l).filter(D=>l[D]).forEach(D=>{P.$kc(D)?(w=w||$.$uk(),w[D]=l[D]):(S=S||$.$uk(),S[D]=l[D])}),this.a=w&&$.$zk(w,{trimForExclusions:!0}),this.b=S&&$.$zk(S,{trimForExclusions:!0})}test(l,w,S){return this.b&&this.b(l,w,S)||this.a&&this.a(P.$lc(this.c,l),w,S)}getBasenameTerms(){const l=[];return this.a&&l.push(...$.$Bk(this.a)),this.b&&l.push(...$.$Bk(this.b)),l}getPathTerms(){const l=[];return this.a&&l.push(...$.$Ck(this.a)),this.b&&l.push(...$.$Ck(this.b)),l}}function s(g){const l=g.trim().split(`
`),w=l[0].trim();if(w.startsWith("Error parsing regex"))return w;if(w.startsWith("regex parse error"))return k.$0f(l[l.length-1].trim());if(w.startsWith("error parsing glob")||w.startsWith("unsupported encoding"))return w.charAt(0).toUpperCase()+w.substr(1);if(w==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(w.startsWith("Literal "))return w}}),define(Ee[401],ye([1,0,104,22,207,21,19]),function(ce,e,r,h,P,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$GE=e.$FE=e.$xE=e.DecodeStreamErrorKind=e.$wE=e.$vE=e.$uE=e.$sE=e.$rE=e.$qE=e.$pE=void 0,e.$tE=N,e.$yE=a,e.$zE=f,e.$AE=d,e.$BE=m,e.$CE=n,e.$DE=S,e.$EE=D,e.$pE="utf8",e.$qE="utf8bom",e.$rE="utf16be",e.$sE="utf16le";function N(y){return[e.$pE,e.$qE,e.$rE,e.$sE].some(C=>C===y)}e.$uE=[254,255],e.$vE=[255,254],e.$wE=[239,187,191];const $=512,c=512,I=512*8,E=512*128;var u;(function(y){y[y.STREAM_IS_BINARY=1]="STREAM_IS_BINARY"})(u||(e.DecodeStreamErrorKind=u={}));class k extends Error{constructor(C,A){super(C),this.decodeStreamErrorKind=A}}e.$xE=k;class p{static async create(C){let A;if(C!==e.$pE)A=(await(0,P.$oE)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).getDecoder(m(C));else{const b=new TextDecoder;A={write(v){return b.decode(v,{stream:!0})},end(){return b.decode()}}}return new p(A)}constructor(C){this.a=C}write(C){return this.a.write(C)}end(){return this.a.end()}}function a(y,C){const A=C.minBytesRequiredForDetection??C.guessEncoding?I:c;return new Promise((b,v)=>{const L=(0,r.$Ce)(B=>B.join("")),O=[];let M=0,j;const z=new R.$xe,F=async()=>{try{const B=await D({buffer:h.$Oe.concat(O),bytesRead:M},C.guessEncoding,C.candidateGuessEncodings);if(B.seemsBinary&&C.acceptTextOnly)throw new k("Stream is binary but only text is accepted for decoding",u.STREAM_IS_BINARY);B.encoding=await C.overwriteEncoding(B.encoding),j=await p.create(B.encoding);const _=j.write(h.$Oe.concat(O).buffer);L.write(_),O.length=0,M=0,b({stream:L,detected:B})}catch(B){z.cancel(),L.destroy(),v(B)}};(0,r.$Ge)(y,{onData:async B=>{j?L.write(j.write(B.buffer)):(O.push(B),M+=B.byteLength,M>=A&&(y.pause(),await F(),setTimeout(()=>y.resume())))},onError:B=>L.error(B),onEnd:async()=>{j||await F(),L.end(j?.end())}},z.token)})}async function f(y,C,A){const v=(await(0,P.$oE)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).getEncoder(m(C),A);let L=!1,O=!1;return{read(){if(O)return null;const M=y.read();if(typeof M!="string"){if(O=!0,!L&&A?.addBOM)switch(C){case e.$pE:case e.$qE:return h.$Oe.wrap(Uint8Array.from(e.$wE));case e.$rE:return h.$Oe.wrap(Uint8Array.from(e.$uE));case e.$sE:return h.$Oe.wrap(Uint8Array.from(e.$vE))}const j=v.end();return j&&j.length>0?(L=!0,h.$Oe.wrap(j)):null}return L=!0,h.$Oe.wrap(v.write(M))}}}async function d(y){return(await(0,P.$oE)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).encodingExists(m(y))}function m(y){return y===e.$qE||y===null?e.$pE:y}function n(y,C){if(!y||C<e.$uE.length)return null;const A=y.readUInt8(0),b=y.readUInt8(1);if(A===e.$uE[0]&&b===e.$uE[1])return e.$rE;if(A===e.$vE[0]&&b===e.$vE[1])return e.$sE;if(C<e.$wE.length)return null;const v=y.readUInt8(2);return A===e.$wE[0]&&b===e.$wE[1]&&v===e.$wE[2]?e.$qE:null}const o=["ascii","utf-16","utf-32"];async function t(y,C){const A=await(0,P.$oE)("jschardet","dist/jschardet.min.js"),b=y.slice(0,E),v=w(b.buffer);C&&(C=(0,T.$Jb)(C.map(M=>l(M))),C.length===0&&(C=void 0));const L=A.detect(v,C?{detectEncodings:C}:void 0);if(!L||!L.encoding)return null;const O=L.encoding.toLowerCase();return 0<=o.indexOf(O)?null:g(L.encoding)}const i={ibm866:"cp866",big5:"cp950"};function s(y){return y.replace(/[^a-zA-Z0-9]/g,"").toLowerCase()}function g(y){const C=s(y);return i[C]||C}function l(y){const C=s(y);return e.$GE[C].guessableName}function w(y){let C="";for(let A=0;A<y.length;A++)C+=String.fromCharCode(y[A]);return C}function S(y){switch(y){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:{const C=y.match(/windows(\d+)/);return C?"windows-"+C[1]:y}}}function D({buffer:y,bytesRead:C},A,b){let v=n(y,C),L=!1;if(v!==e.$rE&&v!==e.$sE&&y){let O=!0,M=!0,j=!1;for(let z=0;z<C&&z<$;z++){const F=z%2===1,B=y.readUInt8(z)===0;if(B&&(j=!0),O&&(F&&!B||!F&&B)&&(O=!1),M&&(F&&B||!F&&!B)&&(M=!1),B&&!O&&!M)break}j&&(O?v=e.$sE:M?v=e.$rE:L=!0)}return A&&!L&&!v&&y?t(y.slice(0,C),b).then(O=>({seemsBinary:!1,encoding:O})):{seemsBinary:L,encoding:v}}e.$FE={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom",guessableName:"UTF-8"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3,guessableName:"UTF-16LE"},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4,guessableName:"UTF-16BE"},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5,guessableName:"windows-1252"},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16,guessableName:"windows-1250"},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17,guessableName:"ISO-8859-2"},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19,guessableName:"windows-1251"},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20,guessableName:"IBM866"},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21,guessableName:"ISO-8859-5"},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22,guessableName:"KOI8-R"},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25,guessableName:"windows-1253"},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26,guessableName:"ISO-8859-7"},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27,guessableName:"windows-1255"},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28,guessableName:"ISO-8859-8"},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36,guessableName:"Big5"},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38,guessableName:"SHIFT_JIS"},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39,guessableName:"EUC-JP"},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40,guessableName:"EUC-KR"},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45,guessableName:"GB2312"},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}},e.$GE=(()=>{const y={};for(const C in e.$FE)e.$FE[C].guessableName&&(y[C]=e.$FE[C]);return y})()}),define(Ee[171],ye([1,0,401,34,170]),function(ce,e,r,h,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wqc=void 0,h=We(h);class R extends P.$jpc{constructor(N,$,c=h,I="searchProcess"){super({query:N,provider:$},{readdir:E=>c.Promises.readdir(E.fsPath),toCanonicalName:E=>(0,r.$DE)(E)},I)}}e.$wqc=R}),define(Ee[172],ye([1,0,58,416,400,19,79,39,13,2,38,100,417,398,130]),function(ce,e,r,h,P,R,T,N,$,c,I,E,u,k,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qqc=e.$pqc=void 0,e.$rqc=i,e.$sqc=g,e.$tqc=w,e.$uqc=S,e.$vqc=y,r=We(r);const a=k.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class f{constructor(A,b){this.a=A,this.b=b}provideTextSearchResults(A,b,v,L){return this.a.appendLine(`provideTextSearchResults ${A.pattern}, ${JSON.stringify({...b,folder:b.folder.toString()})}`),new Promise((O,M)=>{L.onCancellationRequested(()=>Q());const j={...b,numThreads:this.b},z=i(A,j),F=b.folder.fsPath,B=z.map($e=>$e.match(/^-/)?$e:`'${$e}'`).join(" ");this.a.appendLine(`${a} ${B}
 - cwd: ${F}`);let _=r.spawn(a,z,{cwd:F});_.on("error",$e=>{console.error($e),this.a.appendLine("Error: "+($e&&$e.message)),M((0,I.$1L)(new I.$YL($e&&$e.message,I.SearchErrorCode.rgProcessError)))});let re=!1;const U=new n(b.maxResults,b.folder,b.previewOptions);U.on("result",$e=>{re=!0,he="",v.report($e)});let G=!1;const Q=()=>{G=!0,_?.kill(),U?.cancel()};let ee=!1;U.on("hitLimit",()=>{ee=!0,Q()});let he="";_.stdout.on("data",$e=>{U.handleData($e),re||(he+=$e)});let ne=!1;_.stdout.once("data",()=>ne=!0);let De="";_.stderr.on("data",$e=>{const K=$e.toString();this.a.appendLine(K),De.length+K.length<1e6&&(De+=K)}),_.on("close",()=>{if(this.a.appendLine(ne?"Got data from stdout":"No data from stdout"),this.a.appendLine(re?"Got result from parser":"No result from parser"),he&&this.a.appendLine(`Got data without result: ${he}`),this.a.appendLine(""),G)O({limitHit:ee});else{U.flush(),_=null;let $e;De&&!ne&&($e=d(De))?M((0,I.$1L)(new I.$YL($e.message,$e.code))):O({limitHit:ee})}})})}}e.$pqc=f;function d(C){const A=C.split(`
`),b=A[0].trim();if(A.some(L=>L.startsWith("regex parse error")))return new I.$YL(m(A),I.SearchErrorCode.regexParseError);const v=b.match(/grep config error: unknown encoding: (.*)/);if(v)return new I.$YL(`Unknown encoding: ${v[1]}`,I.SearchErrorCode.unknownEncoding);if(b.startsWith("error parsing glob"))return new I.$YL(b.charAt(0).toUpperCase()+b.substr(1),I.SearchErrorCode.globParseError);if(b.startsWith("the literal"))return new I.$YL(b.charAt(0).toUpperCase()+b.substr(1),I.SearchErrorCode.invalidLiteral);if(b.startsWith("PCRE2: error compiling pattern"))return new I.$YL(b,I.SearchErrorCode.regexParseError)}function m(C){const A=["Regex parse error"],b=C.filter(v=>v.startsWith("PCRE2:"));if(b.length>=1){const v=b[0].replace("PCRE2:","");if(v.indexOf(":")!==-1&&v.split(":").length>=2){const L=v.split(":")[1];A.push(":"+L)}}return A.join("")}class n extends h.EventEmitter{constructor(A,b,v){super(),this.g=A,this.h=b,this.j=v,this.a="",this.b=!1,this.c=!1,this.f=0,this.d=new P.StringDecoder}cancel(){this.b=!0}flush(){this.k(this.d.end())}on(A,b){return super.on(A,b),this}handleData(A){if(this.b)return;const b=typeof A=="string"?A:this.d.write(A);this.k(b)}k(A){let b=A.indexOf(`
`);const v=this.a+A;if(b>=0)b+=this.a.length;else{this.a=v;return}let L=0;for(;b>=0;)this.m(v.substring(L,b).trim()),L=b+1,b=v.indexOf(`
`,L);this.a=v.substring(L)}m(A){if(this.b||!A)return;let b;try{b=JSON.parse(A)}catch{throw new Error(`malformed line from rg: ${A}`)}if(b.type==="match"){const v=o(b.data.path),L=c.URI.joinPath(this.h,v),O=this.n(b.data,L);this.p(O),this.c&&(this.cancel(),this.emit("hitLimit"))}else if(b.type==="context"){const v=o(b.data.path),L=c.URI.joinPath(this.h,v);this.o(b.data,L).forEach(M=>this.p(M))}}n(A,b){const v=A.line_number-1,L=o(A.lines),O=Buffer.from(L);let M=0,j=0,z=v;A.submatches.length===0&&A.submatches.push(L.length?{start:0,end:1,match:{text:L[0]}}:{start:0,end:0,match:{text:""}});const F=(0,R.$Jb)(A.submatches.map((B,_)=>{if(this.c)return null;this.f++,this.f>=this.g&&(this.c=!0);const re=o(B.match),U=O.slice(M,B.start).toString(),G=t(U),Q=G.numLines>0?G.lastLineLength:G.lastLineLength+j,ee=t(re),he=G.numLines+z,ne=ee.numLines+he,De=ee.numLines>0?ee.lastLineLength:ee.lastLineLength+Q;return M=B.end,j=De,z=ne,new E.$HL(he,Q,ne,De)}));return(0,p.$iqc)(b,L,F,this.j)}o(A,b){const v=o(A.lines),L=A.line_number;return v.replace(/\r?\n$/,"").split(`
`).map((O,M)=>({text:O,uri:b,lineNumber:L+M}))}p(A){this.emit("result",A)}}e.$qqc=n;function o(C){return C.bytes?Buffer.from(C.bytes,"base64").toString():C.text}function t(C){const A=/\n/g;let b=0,v=-1,L;for(;L=A.exec(C);)b++,v=L.index;const O=v>=0?C.length-v-1:C.length;return{numLines:b,lastLineLength:O}}function i(C,A){const b=["--hidden","--no-require-git"];b.push(C.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:v,otherIncludes:L}=(0,T.$K)(A.includes,M=>M.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(L&&L.length){const M=new Set;L.forEach(j=>{M.add(j)}),b.push("-g","!*"),M.forEach(j=>{s(j).map(p.$hqc).forEach(z=>{b.push("-g",z)})})}v&&v.length&&v.forEach(M=>{b.push("-g",M)}),A.excludes.map(p.$hqc).forEach(M=>b.push("-g",`!${M}`)),A.maxFileSize&&b.push("--max-filesize",A.maxFileSize+""),A.useIgnoreFiles?A.useParentIgnoreFiles||b.push("--no-ignore-parent"):b.push("--no-ignore"),A.followSymlinks&&b.push("--follow"),A.encoding&&A.encoding!=="utf8"&&b.push("--encoding",A.encoding),A.numThreads&&b.push("--threads",`${A.numThreads}`),C.pattern==="--"&&(C.isRegExp=!0,C.pattern="\\-\\-"),C.isMultiline&&!C.isRegExp&&(C.pattern=(0,$.$if)(C.pattern),C.isRegExp=!0),A.usePCRE2&&b.push("--pcre2"),b.push("--crlf"),C.isRegExp&&(C.pattern=g(C.pattern),b.push("--engine","auto"));let O;if(C.isWordMatch){const j=(0,$.$rf)(C.pattern,!!C.isRegExp,{wholeWord:C.isWordMatch}).source.replace(/\\\//g,"/");b.push("--regexp",j)}else if(C.isRegExp){let M=w(C.pattern);M=S(M),b.push("--regexp",M)}else O=C.pattern,b.push("--fixed-strings");return b.push("--no-config"),A.useGlobalIgnoreFiles||b.push("--no-ignore-global"),b.push("--json"),C.isMultiline&&b.push("--multiline"),A.beforeContext&&b.push("--before-context",A.beforeContext+""),A.afterContext&&b.push("--after-context",A.afterContext+""),b.push("--"),O&&b.push(O),b.push("."),b}function s(C){return y(C).flatMap(b=>{const v=(0,N.$xk)(b,"/");return v.map((L,O)=>v.slice(0,O+1).join("/"))})}function g(C){const A=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;C.match(A);)C=C.replace(A,"$1\\x{$2}");const b=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;C.match(b);)C=C.replace(b,"$1\\x{$2}");return C}const l=C=>C.type==="Assertion"&&C.kind==="lookbehind";function w(C){let A;try{A=new u.RegExpParser().parsePattern(C)}catch{return C}let b="",v=0;const L=(j,z,F)=>{b+=C.slice(v,j)+F,v=z},O=[];return new u.RegExpVisitor({onCharacterEnter(j){if(j.raw!=="\\n")return;const z=O[0];if(!z)L(j.start,j.end,"\\r?\\n");else if(!O.some(l))if(z.type==="CharacterClass")if(z.negate){const F=C.slice(z.start+2,j.start)+C.slice(j.end,z.end-1);z.parent?.type==="Quantifier"?L(z.start,z.end,F?`[^${F}]`:"."):L(z.start,z.end,"(?!\\r?\\n"+(F?`|[${F}]`:"")+")")}else{const F=C.slice(z.start+1,j.start)+C.slice(j.end,z.end-1);L(z.start,z.end,F===""?"\\r?\\n":`(?:[${F}]|\\r?\\n)`)}else z.type==="Quantifier"&&L(j.start,j.end,"(?:\\r?\\n)")},onQuantifierEnter(j){O.unshift(j)},onQuantifierLeave(){O.shift()},onCharacterClassRangeEnter(j){O.unshift(j)},onCharacterClassRangeLeave(){O.shift()},onCharacterClassEnter(j){O.unshift(j)},onCharacterClassLeave(){O.shift()},onAssertionEnter(j){l(j)&&O.push(j)},onAssertionLeave(j){O[0]===j&&O.shift()}}).visit(A),b+=C.slice(v),b}function S(C){return C.replace(/\n/g,"\\r?\\n")}function D(C){let A=!1,b=!1,v="",L="";for(let O=0;O<C.length;O++){const M=C[O];switch(M){case"\\":b?(A?L+="\\"+M:v+="\\"+M,b=!1):b=!0;break;case"{":if(b)A?L+=M:v+=M,b=!1;else{if(A)return{strInBraces:v+"{"+L+"{"+C.substring(O+1)};A=!0}break;case"}":if(b)A?L+=M:v+=M,b=!1;else{if(A)return{fixedStart:v,strInBraces:L,fixedEnd:C.substring(O+1)};v+=M}break;default:A?L+=(b?"\\":"")+M:v+=(b?"\\":"")+M,b=!1;break}}return{strInBraces:v+(A?"{"+L:"")}}function y(C){const{fixedStart:A,strInBraces:b,fixedEnd:v}=D(C);if(A===void 0||v===void 0)return[b];let L=(0,N.$xk)(b,",");L.length||(L=[""]);const O=y(v);return L.flatMap(M=>{const j=A+M;return O.map(z=>j+z)})}}),define(Ee[402],ye([1,0,21,172,90,15]),function(ce,e,r,h,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zqc=void 0;class T{constructor(c,I){this.b=c,this.c=I,this.a=new Set,process.once("exit",()=>this.e())}async provideTextSearchResults(c,I,E,u){const k=await this.c(),p=new h.$pqc(this.b,k),a={...I,numThreads:k};if(I.folder.scheme===R.Schemas.vscodeUserData){const f={...a,folder:I.folder.with({scheme:R.Schemas.file})},d=new P.$rw(m=>E.report({...m,uri:m.uri.with({scheme:I.folder.scheme})}));return this.d(u,m=>p.provideTextSearchResults(c,f,d,m))}else return this.d(u,f=>p.provideTextSearchResults(c,a,E,f))}async d(c,I){const E=N(c);this.a.add(E);const u=await I(E.token);return this.a.delete(E),u}e(){this.a.forEach(c=>c.cancel())}}e.$zqc=T;function N($){const c=new r.$xe;return $.onCancellationRequested(()=>c.cancel()),c}}),define(Ee[403],ye([1,0,34,172,171]),function(ce,e,r,h,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xqc=void 0,r=We(r);class R{constructor($,c){this.a=$,this.b=c}search($,c,I){if((!this.a.folderQueries||!this.a.folderQueries.length)&&(!this.a.extraFileResources||!this.a.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"},messages:[]});const E={appendLine(k){I({message:k})}},u=new P.$wqc(this.a,new h.$pqc(E,this.b),r);return new Promise((k,p)=>u.search(a=>{c(a.map(T))},$).then(a=>k({limitHit:a.limitHit??!1,type:"success",stats:a.stats,messages:[]}),p))}}e.$xqc=R;function T(N){return{path:N.resource&&N.resource.fsPath,results:N.results,numMatches:(N.results||[]).reduce(($,c)=>{if(c.ranges){const I=c;return $+(Array.isArray(I.ranges)?I.ranges.length:1)}else return $+1},0)}}}),define(Ee[404],ye([1,0,19,9,14,4,141,16,43,2,28,38,399,403]),function(ce,e,r,h,P,R,T,N,$,c,I,E,u,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yqc=void 0,r=We(r);class p{static{this.a=512}constructor(o="searchProcess",t){this.d=o,this.f=t,this.b=Object.create(null)}fileSearch(o){let t;const i=d(o),s=new R.$me({onDidAddFirstListener:()=>{t=(0,h.$sh)(async g=>{const l=await this.f?.();return this.doFileSearchWithEngine(u.$oqc,i,w=>s.fire(w),g,p.a,l)}),t.then(g=>s.fire(g),g=>s.fire({type:"error",error:{message:g.message,stack:g.stack}}))},onDidRemoveLastListener:()=>{t.cancel()}});return s.event}textSearch(o){let t;const i=d(o),s=new R.$me({onDidAddFirstListener:()=>{t=(0,h.$sh)(g=>this.g(i,l=>s.fire(l),g)),t.then(g=>s.fire(g),g=>s.fire({type:"error",error:{message:g.message,stack:g.stack}}))},onDidRemoveLastListener:()=>{t.cancel()}});return s.event}async g(o,t,i){o.maxFileSize=this.h().maxFileSize;const s=await this.f?.();return new k.$xqc(o,s).search(i,t,t)}h(){return{maxFileSize:16*I.$Hl.GB}}doFileSearch(o,t,i,s){return this.doFileSearchWithEngine(u.$oqc,o,i,s,p.a,t)}doFileSearchWithEngine(o,t,i,s,g=p.a,l){let w=0;const S=y=>{Array.isArray(y)?(w+=y.length,i(y.map(C=>this.j(C)))):y.relativePath?(w++,i(this.j(y))):i(y)};if(t.sortByScore){let y=this.n(t,S,s);if(!y){const C=t.maxResults?Object.assign({},t,{maxResults:null}):t,A=new o(C,l);y=this.k(A,t,i,S,s)}return new Promise((C,A)=>{y.then(([b,v])=>{const L=v.map(O=>this.j(O));this.q(L,i,g),C(b)},A)})}const D=new o(t,l);return this.s(D,S,g,s).then(y=>({limitHit:y.limitHit,type:"success",stats:{detailStats:y.stats,type:this.d,fromCache:!1,resultCount:w,sortingTime:void 0},messages:[]}))}j(o){return{path:o.base?(0,N.$lc)(o.base,o.relativePath):o.relativePath}}k(o,t,i,s,g){const l=new R.$me;let w=(0,h.$sh)(D=>{let y=[];const C=A=>{Array.isArray(A)?y=A:(s(A),l.fire(A))};return this.s(o,C,-1,D).then(A=>[A,y])}),S;if(t.cacheKey){S=this.l(t.cacheKey);const D={promise:w,event:l.event,resolved:!1};S.resultsToSearchCache[t.filePattern||""]=D,w.then(()=>{D.resolved=!0},y=>{delete S.resultsToSearchCache[t.filePattern||""]}),w=this.t(w)}return w.then(([D,y])=>{const C=S?S.scorerCache:Object.create(null),A=(typeof t.maxResults!="number"||t.maxResults>0)&&$.$ge.create(!1);return this.o(t,y,C,g).then(b=>{const v=A?A.elapsed():-1;return[{type:"success",stats:{detailStats:D.stats,sortingTime:v,fromCache:!1,type:this.d,resultCount:b.length},messages:D.messages,limitHit:D.limitHit||typeof t.maxResults=="number"&&y.length>t.maxResults},b]})})}l(o){const t=this.b[o];return t||(this.b[o]=new a)}n(o,t,i){const s=o.cacheKey&&this.b[o.cacheKey];if(!s)return;const g=this.r(s,o.filePattern||"",t,i);if(g)return g.then(([l,w,S])=>{const D=$.$ge.create(!1);return this.o(o,w,s.scorerCache,i).then(y=>{const C=D.elapsed(),A={fromCache:!0,detailStats:S,type:this.d,resultCount:w.length,sortingTime:C};return[{type:"success",limitHit:l.limitHit||typeof o.maxResults=="number"&&w.length>o.maxResults,stats:A,messages:[]},y]})})}o(o,t,i,s){const g=(0,T.$Kr)(o.filePattern||""),l=(S,D)=>(0,T.$Jr)(S,D,g,!0,f,i),w=typeof o.maxResults=="number"?o.maxResults:E.$NL;return r.$Ib(t,l,w,1e4,s)}q(o,t,i){if(i&&i>0)for(let s=0;s<o.length;s+=i)t(o.slice(s,s+i));else t(o)}r(o,t,i,s){const g=$.$ge.create(!1),l=t.indexOf(N.sep)>=0;let w;for(const C in o.resultsToSearchCache)if(t.startsWith(C)){if(l&&C.indexOf(N.sep)<0&&C!=="")continue;const A=o.resultsToSearchCache[C];w={promise:this.t(A.promise),event:A.event,resolved:A.resolved};break}if(!w)return null;const S=g.elapsed(),D=$.$ge.create(!1),y=w.event(i);return s&&s.onCancellationRequested(()=>{y.dispose()}),w.promise.then(([C,A])=>{if(s&&s.isCancellationRequested)throw(0,P.$8)();const b=[],v=(0,T.$Kr)(t).normalizedLowercase;for(const L of A)(0,E.$5L)(L,v)&&b.push(L);return[C,b,{cacheWasResolved:w.resolved,cacheLookupTime:S,cacheFilterTime:D.elapsed(),cacheEntryCount:A.length}]})}s(o,t,i,s){return new Promise((g,l)=>{let w=[];s?.onCancellationRequested(()=>o.cancel()),o.search(S=>{S&&(i?(w.push(S),i>0&&w.length>=i&&(t(w),w=[])):t(S))},S=>{t(S)},(S,D)=>{w.length&&t(w),S?(t({message:"Search finished. Error: "+S.message}),l(S)):(t({message:"Search finished. Stats: "+JSON.stringify(D.stats)}),g(D))})})}clearCache(o){return delete this.b[o],Promise.resolve(void 0)}t(o){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(t,i){return o.then(t,i)}catch(t){return this.then(void 0,t)}finally(t){return o.finally(t)}}}}e.$yqc=p;class a{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const f=new class{getItemLabel(n){return(0,N.$pc)(n.relativePath)}getItemDescription(n){return(0,N.$oc)(n.relativePath)}getItemPath(n){return n.relativePath}};function d(n){return{...n,folderQueries:n.folderQueries&&n.folderQueries.map(m),extraFileResources:n.extraFileResources&&n.extraFileResources.map(o=>c.URI.revive(o))}}function m(n){return{...n,folder:c.URI.revive(n.folder)}}}),define(Ee[405],ye([1,0,3,15,2,34,12,42,30,20,103,73,38,404,402,130,171]),function(ce,e,r,h,P,R,T,N,$,c,I,E,u,k,p,a,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Aqc=void 0,R=We(R);let d=class extends I.$opc{constructor(n,o,t,i,s){super(n,t,s),this.D=i,this.w=R,this.x=-1,this.y=null,this.z=!1,this.B=new r.$Vc,this.C=!1,this.getNumThreads=this.getNumThreads.bind(this),this.getNumThreadsCached=this.getNumThreadsCached.bind(this),this.E=this.E.bind(this);const g=new a.$jqc("RipgrepSearchUD",this.q);this.B.add(this.registerTextSearchProvider(h.Schemas.vscodeUserData,new p.$zqc(g,this.getNumThreadsCached))),o.remote.isRemote&&o.remote.authority&&this.F(),i.getConfigProvider().then(l=>{this.C||this.B.add(l.onDidChangeConfiguration(this.E))})}E(n){n.affectsConfiguration("search")&&(this.A=void 0)}async getNumThreads(){return(await this.D.getConfigProvider()).getConfiguration("search").get("ripgrep.maxThreads")}async getNumThreadsCached(){return this.A||(this.A=this.getNumThreads()),this.A}dispose(){this.C=!0,this.B.dispose()}$enableExtensionHostSearch(){this.F()}F(){if(this.z)return;this.z=!0;const n=new a.$jqc("RipgrepSearchEH",this.q);this.B.add(this.registerTextSearchProvider(h.Schemas.file,new p.$zqc(n,this.getNumThreadsCached))),this.B.add(this.G(h.Schemas.file,new k.$yqc("fileSearchProvider",this.getNumThreadsCached)))}G(n,o){const t=this.d++;return this.y=o,this.x=t,this.c.$registerFileSearchProvider(t,this.s(n)),(0,r.$Uc)(()=>{this.y=null,this.c.$unregisterProvider(t)})}$provideFileSearchResults(n,o,t,i){const s=(0,I.$ppc)(t);if(n===this.x){const g=Date.now();return this.H(n,o,s,i).then(l=>{const w=Date.now()-g;return this.q.debug(`Ext host file search time: ${w}ms`),l})}return super.$provideFileSearchResults(n,o,t,i)}async doInternalFileSearchWithCustomCallback(n,o,t){const i=g=>{if((0,u.$4L)(g)&&(g=[g]),Array.isArray(g)){t(g.map(l=>P.URI.file(l.path)));return}g.message&&this.q.debug("ExtHostSearch",g.message)};if(!this.y)throw new Error("No internal file search handler");const s=await this.getNumThreadsCached();return this.y.doFileSearch(n,s,i,o)}async H(n,o,t,i){return this.doInternalFileSearchWithCustomCallback(t,i,s=>{this.c.$handleFileMatch(n,o,s)})}$clearCache(n){return this.y?.clearCache(n),super.$clearCache(n)}t(n,o){return new f.$wqc(n,o,void 0,"textSearchProvider")}};e.$Aqc=d,e.$Aqc=d=Je([Ge(0,c.$XP),Ge(1,$.$bQ),Ge(2,E.$aoc),Ge(3,N.$goc),Ge(4,T.$_j)],d)}),define(Ee[131],ye([1,0,418,67,68,419,22,14,4,3,16,11,32,87,69]),function(ce,e,r,h,P,R,T,N,$,c,I,E,u,k,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zi=e.$wi=e.$vi=e.$ui=void 0,e.$xi=l,e.$yi=w,e.$Ai=y,e.$Bi=C;const a=3e4;class f{traceSocketEvent(b,v){p.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,b,v)}constructor(b,v=""){this.f=!0,this.debugLabel=v,this.socket=b,this.traceSocketEvent(p.SocketDiagnosticsEventType.Created,{type:"NodeSocket"}),this.a=O=>{if(this.traceSocketEvent(p.SocketDiagnosticsEventType.Error,{code:O?.code,message:O?.message}),O){if(O.code==="EPIPE")return;(0,N.$3)(O)}},this.socket.on("error",this.a);let L;this.b=O=>{this.traceSocketEvent(p.SocketDiagnosticsEventType.Close,{hadError:O}),this.f=!1,L&&clearTimeout(L)},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent(p.SocketDiagnosticsEventType.NodeEndReceived),this.f=!1,L=setTimeout(()=>b.destroy(),a)},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(b){const v=L=>{this.traceSocketEvent(p.SocketDiagnosticsEventType.Read,L),b(T.$Oe.wrap(L))};return this.socket.on("data",v),{dispose:()=>this.socket.off("data",v)}}onClose(b){const v=L=>{b({type:p.SocketCloseEventType.NodeSocketCloseEvent,hadError:L,error:void 0})};return this.socket.on("close",v),{dispose:()=>this.socket.off("close",v)}}onEnd(b){const v=()=>{b()};return this.socket.on("end",v),{dispose:()=>this.socket.off("end",v)}}write(b){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent(p.SocketDiagnosticsEventType.Write,b),this.socket.write(b.buffer,v=>{if(v){if(v.code==="EPIPE")return;(0,N.$3)(v)}})}catch(v){if(v.code==="EPIPE")return;(0,N.$3)(v)}}end(){this.traceSocketEvent(p.SocketDiagnosticsEventType.NodeEndSent),this.socket.end()}drain(){return this.traceSocketEvent(p.SocketDiagnosticsEventType.NodeDrainBegin),new Promise((b,v)=>{if(this.socket.bufferSize===0){this.traceSocketEvent(p.SocketDiagnosticsEventType.NodeDrainEnd),b();return}const L=()=>{this.socket.off("close",L),this.socket.off("end",L),this.socket.off("error",L),this.socket.off("timeout",L),this.socket.off("drain",L),this.traceSocketEvent(p.SocketDiagnosticsEventType.NodeDrainEnd),b()};this.socket.on("close",L),this.socket.on("end",L),this.socket.on("error",L),this.socket.on("timeout",L),this.socket.on("drain",L)})}}e.$ui=f;var d;(function(A){A[A.MinHeaderByteSize=2]="MinHeaderByteSize",A[A.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(d||(d={}));var m;(function(A){A[A.PeekHeader=1]="PeekHeader",A[A.ReadHeader=2]="ReadHeader",A[A.ReadBody=3]="ReadBody",A[A.Fin=4]="Fin"})(m||(m={}));class n extends c.$Wc{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(b,v){this.socket.traceSocketEvent(b,v)}constructor(b,v,L,O){super(),this.f=this.B(new $.$me),this.g=this.B(new $.$me),this.h=!1,this.j={state:m.PeekHeader,readLen:d.MinHeaderByteSize,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0,opcode:0},this.socket=b,this.traceSocketEvent(p.SocketDiagnosticsEventType.Created,{type:"WebSocketNodeSocket",permessageDeflate:v,inflateBytesLength:L?.byteLength||0,recordInflateBytes:O}),this.a=this.B(new o(this,v,L,O,this.f,(M,j)=>this.m(M,j))),this.B(this.a.onError(M=>{console.error(M),(0,N.$3)(M),this.g.fire({type:p.SocketCloseEventType.NodeSocketCloseEvent,hadError:!0,error:M})})),this.b=new p.$pi,this.B(this.socket.onData(M=>this.n(M))),this.B(this.socket.onClose(async M=>{this.a.isProcessingReadQueue()&&await $.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(M)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(b){return this.f.event(b)}onClose(b){return this.g.event(b)}onEnd(b){return this.socket.onEnd(b)}write(b){let v=0;for(;v<b.byteLength;)this.a.writeMessage(b.slice(v,Math.min(v+d.MaxWebSocketMessageLength,b.byteLength)),{compressed:!0,opcode:2}),v+=d.MaxWebSocketMessageLength}m(b,{compressed:v,opcode:L}){if(this.h)return;this.traceSocketEvent(p.SocketDiagnosticsEventType.WebSocketNodeSocketWrite,b);let O=d.MinHeaderByteSize;b.byteLength<126?O+=0:b.byteLength<2**16?O+=2:O+=8;const M=T.$Oe.alloc(O),j=v?64:0,z=L&15;if(M.writeUInt8(128|j|z,0),b.byteLength<126)M.writeUInt8(b.byteLength,1);else if(b.byteLength<2**16){M.writeUInt8(126,1);let F=1;M.writeUInt8(b.byteLength>>>8&255,++F),M.writeUInt8(b.byteLength>>>0&255,++F)}else{M.writeUInt8(127,1);let F=1;M.writeUInt8(0,++F),M.writeUInt8(0,++F),M.writeUInt8(0,++F),M.writeUInt8(0,++F),M.writeUInt8(b.byteLength>>>24&255,++F),M.writeUInt8(b.byteLength>>>16&255,++F),M.writeUInt8(b.byteLength>>>8&255,++F),M.writeUInt8(b.byteLength>>>0&255,++F)}this.socket.write(T.$Oe.concat([M,b]))}end(){this.h=!0,this.socket.end()}n(b){if(b.byteLength!==0){for(this.b.acceptChunk(b);this.b.byteLength>=this.j.readLen;)if(this.j.state===m.PeekHeader){const v=this.b.peek(this.j.readLen),L=v.readUInt8(0),O=(L&128)>>>7,M=(L&64)>>>6,j=L&15,z=v.readUInt8(1),F=(z&128)>>>7,B=z&127;this.j.state=m.ReadHeader,this.j.readLen=d.MinHeaderByteSize+(F?4:0)+(B===126?2:0)+(B===127?8:0),this.j.fin=O,this.j.firstFrameOfMessage&&(this.j.compressed=!!M),this.j.firstFrameOfMessage=!!O,this.j.mask=0,this.j.opcode=j,this.traceSocketEvent(p.SocketDiagnosticsEventType.WebSocketNodeSocketPeekedHeader,{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,opcode:this.j.opcode})}else if(this.j.state===m.ReadHeader){const v=this.b.read(this.j.readLen),L=v.readUInt8(1),O=(L&128)>>>7;let M=L&127,j=1;M===126?M=v.readUInt8(++j)*2**8+v.readUInt8(++j):M===127&&(M=v.readUInt8(++j)*0+v.readUInt8(++j)*0+v.readUInt8(++j)*0+v.readUInt8(++j)*0+v.readUInt8(++j)*2**24+v.readUInt8(++j)*2**16+v.readUInt8(++j)*2**8+v.readUInt8(++j));let z=0;O&&(z=v.readUInt8(++j)*2**24+v.readUInt8(++j)*2**16+v.readUInt8(++j)*2**8+v.readUInt8(++j)),this.j.state=m.ReadBody,this.j.readLen=M,this.j.mask=z,this.traceSocketEvent(p.SocketDiagnosticsEventType.WebSocketNodeSocketPeekedHeader,{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask,opcode:this.j.opcode})}else if(this.j.state===m.ReadBody){const v=this.b.read(this.j.readLen);this.traceSocketEvent(p.SocketDiagnosticsEventType.WebSocketNodeSocketReadData,v),s(v,this.j.mask),this.traceSocketEvent(p.SocketDiagnosticsEventType.WebSocketNodeSocketUnmaskedData,v),this.j.state=m.PeekHeader,this.j.readLen=d.MinHeaderByteSize,this.j.mask=0,this.j.opcode<=2?this.a.acceptFrame(v,this.j.compressed,!!this.j.fin):this.j.opcode===9&&this.a.writeMessage(v,{compressed:!1,opcode:10})}}}async drain(){this.traceSocketEvent(p.SocketDiagnosticsEventType.WebSocketNodeSocketDrainBegin),this.a.isProcessingWriteQueue()&&await $.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent(p.SocketDiagnosticsEventType.WebSocketNodeSocketDrainEnd)}}e.$vi=n;class o extends c.$Wc{get permessageDeflate(){return!!(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:T.$Oe.alloc(0)}constructor(b,v,L,O,M,j){super(),this.n=b,this.r=M,this.s=j,this.a=this.B(new $.$me),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new $.$me),this.onDidFinishProcessingReadQueue=this.j.event,this.m=this.B(new $.$me),this.onDidFinishProcessingWriteQueue=this.m.event,this.t=!1,this.y=!1,v?(this.b=this.B(new t(this.n,O,L,{windowBits:15})),this.f=this.B(new i(this.n,{windowBits:15})),this.B(this.b.onError(z=>this.a.fire(z))),this.B(this.f.onError(z=>this.a.fire(z)))):(this.b=null,this.f=null)}writeMessage(b,v){this.g.push({data:b,options:v}),this.u()}async u(){if(!this.t){for(this.t=!0;this.g.length>0;){const{data:b,options:v}=this.g.shift();if(this.f&&v.compressed){const L=await this.w(this.f,b);this.s(L,v)}else this.s(b,{...v,compressed:!1})}this.t=!1,this.m.fire()}}isProcessingWriteQueue(){return this.t}w(b,v){return new Promise((L,O)=>{b.write(v),b.flush(M=>L(M))})}acceptFrame(b,v,L){this.h.push({data:b,isCompressed:v,isLastFrameOfMessage:L}),this.z()}async z(){if(!this.y){for(this.y=!0;this.h.length>0;){const b=this.h.shift();if(this.b&&b.isCompressed){const v=await this.C(this.b,b.data,b.isLastFrameOfMessage);this.r.fire(v)}else this.r.fire(b.data)}this.y=!1,this.j.fire()}}isProcessingReadQueue(){return this.y}C(b,v,L){return new Promise((O,M)=>{b.write(v),L&&b.write(T.$Oe.fromByteArray([0,0,255,255])),b.flush(j=>O(j))})}}class t extends c.$Wc{get recordedInflateBytes(){return this.j?T.$Oe.concat(this.f):T.$Oe.alloc(0)}constructor(b,v,L,O){super(),this.h=b,this.j=v,this.a=this.B(new $.$me),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,R.createInflateRaw)(O),this.b.on("error",M=>{this.h.traceSocketEvent(p.SocketDiagnosticsEventType.zlibInflateError,{message:M?.message,code:M?.code}),this.a.fire(M)}),this.b.on("data",M=>{this.h.traceSocketEvent(p.SocketDiagnosticsEventType.zlibInflateData,M),this.g.push(T.$Oe.wrap(M))}),L&&(this.h.traceSocketEvent(p.SocketDiagnosticsEventType.zlibInflateInitialWrite,L.buffer),this.b.write(L.buffer),this.b.flush(()=>{this.h.traceSocketEvent(p.SocketDiagnosticsEventType.zlibInflateInitialFlushFired),this.g.length=0}))}write(b){this.j&&this.f.push(b.clone()),this.h.traceSocketEvent(p.SocketDiagnosticsEventType.zlibInflateWrite,b),this.b.write(b.buffer)}flush(b){this.b.flush(()=>{this.h.traceSocketEvent(p.SocketDiagnosticsEventType.zlibInflateFlushFired);const v=T.$Oe.concat(this.g);this.g.length=0,b(v)})}}class i extends c.$Wc{constructor(b,v){super(),this.g=b,this.a=this.B(new $.$me),this.onError=this.a.event,this.f=[],this.b=(0,R.createDeflateRaw)({windowBits:15}),this.b.on("error",L=>{this.g.traceSocketEvent(p.SocketDiagnosticsEventType.zlibDeflateError,{message:L?.message,code:L?.code}),this.a.fire(L)}),this.b.on("data",L=>{this.g.traceSocketEvent(p.SocketDiagnosticsEventType.zlibDeflateData,L),this.f.push(T.$Oe.wrap(L))})}write(b){this.g.traceSocketEvent(p.SocketDiagnosticsEventType.zlibDeflateWrite,b.buffer),this.b.write(b.buffer)}flush(b){this.b.flush(2,()=>{this.g.traceSocketEvent(p.SocketDiagnosticsEventType.zlibDeflateFlushFired);let v=T.$Oe.concat(this.f);this.f.length=0,v=v.slice(0,v.byteLength-4),b(v)})}}function s(A,b){if(b===0)return;const v=A.byteLength>>>2;for(let F=0;F<v;F++){const B=A.readUInt32BE(F*4);A.writeUInt32BE(B^b,F*4)}const L=v*4,O=A.byteLength-L,M=b>>>24&255,j=b>>>16&255,z=b>>>8&255;O>=1&&A.writeUInt8(A.readUInt8(L)^M,L),O>=2&&A.writeUInt8(A.readUInt8(L+1)^j,L+1),O>=3&&A.writeUInt8(A.readUInt8(L+2)^z,L+2)}e.$wi=process.env.XDG_RUNTIME_DIR;const g={[E.Platform.Linux]:107,[E.Platform.Mac]:103};function l(){const A=(0,u.$2g)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${A}-sock`;const b=process.platform!=="darwin"&&e.$wi?e.$wi:(0,P.tmpdir)(),v=(0,I.$lc)(b,`vscode-ipc-${A}.sock`);return S(v),v}function w(A,b,v){const O=(0,r.createHash)("sha256").update(A).digest("hex").substr(0,8);if(process.platform==="win32")return`\\\\.\\pipe\\${O}-${v}-${b}-sock`;const M=v.substr(0,4),j=b.substr(0,6);let z;return process.platform!=="darwin"&&e.$wi&&!process.env.VSCODE_PORTABLE?z=(0,I.$lc)(e.$wi,`vscode-${O}-${M}-${j}.sock`):z=(0,I.$lc)(A,`${M}-${j}.sock`),S(z),z}function S(A){const b=g[E.$u];typeof b=="number"&&A.length>=b&&console.warn(`WARNING: IPC handle "${A}" is longer than ${b} chars, try a shorter --user-data-dir`)}class D extends k.$ji{static b(b){const v=$.Event.fromNodeEventEmitter(b,"connection");return $.Event.map(v,L=>({protocol:new p.$qi(new f(L,"ipc-server-connection")),onDidClientDisconnect:$.Event.once($.Event.fromNodeEventEmitter(L,"close"))}))}constructor(b){super(D.b(b)),this.d=b}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.$zi=D;function y(A){return new Promise((b,v)=>{const L=(0,h.createServer)();L.on("error",v),L.listen(A,()=>{L.removeListener("error",v),b(new D(L))})})}function C(A,b){return new Promise((v,L)=>{const O=(0,h.createConnection)(A,()=>{O.removeListener("error",L),v(p.$ri.fromSocket(new f(O,`ipc-client${b}`),b))});O.once("error",L)})}}),define(Ee[406],ye([1,0,67,68,187,131,9,3,11,45,12,116,284,285,118,93,22]),function(ce,e,r,h,P,R,T,N,$,c,I,E,u,k,p,a,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ogc=e.$ngc=e.$mgc=e.$lgc=void 0,r=We(r),h=We(h);async function d(i,s,g,l,w){let S;for(let D=3;D&&(S?.dispose(),S=await new m(i,s,g,l,w).waitForReady(),!(w&&P.$5g[w]||!P.$5g[S.tunnelLocalPort]));D--);return S}class m extends N.$Wc{constructor(s,g,l,w,S){super(),this.m=g,this.n=S,this.privacy=a.TunnelPrivacyId.Private,this.j=new Map,this.a=s,this.b=r.createServer(),this.c=new T.$Eh,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=D=>this.r(D),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=w,this.tunnelRemoteHost=l}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.j.values()).forEach(g=>{g()})}async waitForReady(){const s=this.n??this.tunnelRemotePort,g=(0,a.$Ew)(this.m)?"0.0.0.0":"127.0.0.1";let l=await(0,P.$6g)(s,2,1e3,g),w=null;return this.b.listen(l,this.m),await this.c.wait(),w=this.b.address(),w||(l=0,this.b.listen(l,this.m),await this.c.wait(),w=this.b.address()),this.tunnelLocalPort=w.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${w.port}`,this}async r(s){s.pause();const g=(0,a.$Cw)(this.tunnelRemoteHost)||(0,a.$Ew)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,l=await(0,u.$2l)(this.a,g,this.tunnelRemotePort),w=l.getSocket(),S=l.readEntireBuffer();l.dispose(),S.byteLength>0&&s.write(S.buffer),s.on("end",()=>{s.localAddress&&this.j.delete(s.localAddress),w.end()}),s.on("close",()=>w.end()),s.on("error",()=>{s.localAddress&&this.j.delete(s.localAddress),w instanceof R.$ui?w.socket.destroy():w.end()}),w instanceof R.$ui?this.t(s,w):this.s(s,w),s.localAddress&&this.j.set(s.localAddress,()=>{s.end(),w.end()})}s(s,g){g.onClose(()=>s.destroy()),g.onEnd(()=>s.end()),g.onData(l=>s.write(l.buffer)),s.on("data",l=>g.write(f.$Oe.wrap(l))),s.resume()}t(s,g){const l=g.socket;l.on("end",()=>s.end()),l.on("close",()=>s.end()),l.on("error",()=>{s.destroy()}),l.pipe(s),s.pipe(l)}}e.$lgc=m;let n=class extends a.$Hw{constructor(s,g,l,w,S){super(g,S),this.H=s,this.I=l,this.J=w}isPortPrivileged(s){return(0,a.$Fw)(s,this.t,$.OS,h.release())}F(s,g,l,w,S,D,y,C){const A=this.D(g,l);if(A)return++A.refcount,A.value;if((0,a.$yw)(s))return this.G(s,g,l,S,D,y,C);{this.r.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${g}:${l} on local port ${S}.`);const b={commit:this.J.commit,quality:this.J.quality,addressProvider:s,remoteSocketFactoryService:this.H,signService:this.I,logService:this.r,ipcLogger:null},v=d(b,w,g,l,S);return this.r.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.z(g,l,v),v}}};e.$mgc=n,e.$mgc=n=Je([Ge(0,k.$Vl),Ge(1,I.$_j),Ge(2,p.$Yl),Ge(3,E.$sk),Ge(4,c.$_i)],n);let o=class extends n{constructor(s,g,l,w,S){super(s,g,l,w,S)}};e.$ngc=o,e.$ngc=o=Je([Ge(0,k.$Vl),Ge(1,I.$_j),Ge(2,p.$Yl),Ge(3,E.$sk),Ge(4,c.$_i)],o);let t=class extends N.$Wc{constructor(s,g,l,w,S){super(),this.b=s,this.c=g,this.f=l,this.g=w,this.h=S,this.a=new Map}async openTunnel(s,g,l,w,S,D,y,C,A){if(this.c.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${l}:${w} on local port ${D}.`),!this.a.has(s)){const b=new o(this.b,this.c,this.g,this.f,this.h);this.B(b),this.a.set(s,b),b.onTunnelClosed(async()=>{(await b.tunnels).length===0&&(b.dispose(),this.a.delete(s))})}return this.a.get(s).openTunnel(g,l,w,S,D,y,C,A)}};e.$ogc=t,e.$ogc=t=Je([Ge(0,k.$Vl),Ge(1,I.$_j),Ge(2,E.$sk),Ge(3,p.$Yl),Ge(4,c.$_i)],t)}),define(Ee[407],ye([1,0,131,302,61,35,2,12,46]),function(ce,e,r,h,P,R,T,N,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nQ=e.$mQ=void 0,h=We(h),P=We(P);class c{constructor(u,k,p){this.b=u,this.c=k,this.f=p,this.a=h.createServer((a,f)=>this.h(a,f)),this.g().catch(a=>(k.error(a),""))}get ipcHandlePath(){return this.f}async g(){try{this.a.listen(this.ipcHandlePath),this.a.on("error",u=>this.c.error(u))}catch{this.c.error("Could not start open from terminal server.")}return this.f}h(u,k){const p=(f,d)=>{k.writeHead(f,{"content-type":"application/json"}),k.end(JSON.stringify(d||null),m=>m&&this.c.error(m))},a=[];u.setEncoding("utf8"),u.on("data",f=>a.push(f)),u.on("end",async()=>{try{const f=JSON.parse(a.join(""));let d;switch(f.type){case"open":d=await this.i(f);break;case"openExternal":d=await this.j(f);break;case"status":d=await this.l(f);break;case"extensionManagement":d=await this.k(f);break;default:p(404,`Unknown message type: ${f.type}`);break}p(200,d)}catch(f){const d=f instanceof Error?f.message:JSON.stringify(f);p(500,d),this.c.error("Error while processing pipe request",f)}})}async i(u){const{fileURIs:k,folderURIs:p,forceNewWindow:a,diffMode:f,mergeMode:d,addMode:m,forceReuseWindow:n,gotoLineMode:o,waitMarkerFilePath:t,remoteAuthority:i}=u,s=[];if(Array.isArray(p))for(const S of p)try{s.push({folderUri:T.URI.parse(S)})}catch{}if(Array.isArray(k))for(const S of k)try{(0,$.$$i)(S)?s.push({workspaceUri:T.URI.parse(S)}):s.push({fileUri:T.URI.parse(S)})}catch{}const g=t?T.URI.file(t):void 0,w={forceNewWindow:a,diffMode:f,mergeMode:d,addMode:m,gotoLineMode:o,forceReuseWindow:n,preferNewWindow:!n&&!g&&!m,waitMarkerFileURI:g,remoteAuthority:i};this.b.executeCommand("_remoteCLI.windowOpen",s,w)}async j(u){for(const k of u.uris){const p=T.URI.parse(k),a=p.scheme==="file"?p:k;await this.b.executeCommand("_remoteCLI.openExternal",a)}}async k(u){const k=a=>a?.map(f=>/\.vsix$/i.test(f)?T.URI.parse(f):f),p={list:u.list,install:k(u.install),uninstall:k(u.uninstall),force:u.force};return await this.b.executeCommand("_remoteCLI.manageExtensions",p)}async l(u){return await this.b.executeCommand("_remoteCLI.getSystemStatus")}dispose(){this.a.close(),this.f&&process.platform!=="win32"&&P.existsSync(this.f)&&P.unlinkSync(this.f)}}e.$mQ=c;let I=class extends c{constructor(u,k){super(u,k,(0,r.$xi)())}};e.$nQ=I,e.$nQ=I=Je([Ge(0,R.$hQ),Ge(1,N.$_j)],I)}),define(Ee[408],ye([1,0,62,395,390,301,52,377,2,15,10,407,111,338,376]),function(ce,e,r,h,P,R,T,N,$,c,I,E,u,k,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fqc=void 0,r=We(r);class a extends P.$7pc{j(){const m=this,n=globalThis._VSCODE_NODE_MODULES.module,o=n._load;n._load=function(g,l,w){return g=i(g),m.a.has(g)?m.a.get(g).load(g,$.URI.file((0,u.$hr)(l.filename)),S=>o.apply(this,[S,l,w])):o.apply(this,arguments)};const t=n._resolveLookupPaths;n._resolveLookupPaths=(s,g)=>t.call(this,i(s),g);const i=s=>{for(const g of m.b){const l=g(s);if(l){s=l;break}}return s}}}class f extends T.$Soc{constructor(){super(...arguments),this.extensionRuntime=I.ExtensionRuntime.Node}async vb(){this.h.createInstance(k.$Dqc);const m=this.h.invokeFunction(h.$3pc);if(this.h.createInstance(N.$Cqc),this.f.remote.isRemote&&this.f.remote.authority){const t=this.h.createInstance(E.$nQ);process.env.VSCODE_IPC_HOOK_CLI=t.ipcHandlePath}this.h.createInstance(p.$Eqc),await this.h.createInstance(a,m,{mine:this.J,all:this.L}).install(),r.mark("code/extHost/didInitAPI");const o=await this.m.getConfigProvider();await(0,R.$Bqc)(this.j,o,this,this.s,this.z,this.f),r.mark("code/extHost/didInitProxyResolver")}wb(m){return m.main}async xb(m,n,o){if(n.scheme!==c.Schemas.file)throw new Error(`Cannot load URI: '${n}', must be of file-scheme`);let t=null;o.codeLoadingStart(),this.s.trace(`ExtensionService#loadCommonJSModule ${n.toString(!0)}`),this.s.flush();const i=m?.identifier.value;m&&await this.w.initializeLocalizedMessages(m);try{i&&r.mark(`code/extHost/willLoadExtensionCode/${i}`),t=ce.__$__nodeRequire(n.fsPath)}finally{i&&r.mark(`code/extHost/didLoadExtensionCode/${i}`),o.codeLoadingStop()}return t}async $setRemoteEnvironment(m){if(this.f.remote.isRemote)for(const n in m){const o=m[n];o===null?delete process.env[n]:process.env[n]=o}}}e.$Fqc=f}),define(Ee[409],ye([1,0,58,22,4,3,134,11,23,2,34,69,12,283,72,118,93,406,30,20,77,384]),function(ce,e,r,h,P,R,T,N,$,c,I,E,u,k,p,a,f,d,m,n,o,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nqc=void 0,e.$Gqc=i,e.$Hqc=s,e.$Iqc=g,e.$Jqc=l,e.$Kqc=S,e.$Lqc=D,e.$Mqc=y,$=We($),I=We(I);function i(b){const v=b.trim().split(`
`),L=[];return v.forEach(M=>{const j=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(M);j&&j.length>=3&&L.push({pid:parseInt(j[1],10),socket:parseInt(j[2],10)})}),L.reduce((M,j)=>(M[j.socket]=j,M),{})}function s(...b){const v=[].concat(...b.map(l));return[...new Map(v.filter(L=>L.st==="0A").map(L=>{const O=L.local_address.split(":");return{socket:parseInt(L.inode,10),ip:g(O[0]),port:parseInt(O[1],16)}}).map(L=>[L.ip+":"+L.port,L])).values()]}function g(b){let v="";if(b.length===8)for(let L=b.length-2;L>=0;L-=2)v+=parseInt(b.substr(L,2),16),L!==0&&(v+=".");else for(let L=0;L<b.length;L+=8){const O=b.substring(L,L+8);let M="";for(let j=8;j>=2;j-=2)M+=O.substring(j-2,j),(j===6||j===2)&&(M=parseInt(M,16).toString(16),v+=`${M}`,M="",L+j!==b.length-6&&(v+=":"))}return v}function l(b){const v=b.trim().split(`
`),L=v.shift().trim().split(/\s+/).filter(M=>M!=="rx_queue"&&M!=="tm->when");return v.map(M=>M.trim().split(/\s+/).reduce((j,z,F)=>(j[L[F]||F]=z,j),{}))}function w(b){return!!b.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||b.indexOf("out/server-main.js")!==-1||b.indexOf("_productName=VSCode")!==-1}function S(b){const v=b.trim().split(`
`),L=[];return v.forEach(O=>{const M=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(O);M&&M.length>=4&&L.push({pid:parseInt(M[1],10),ppid:parseInt(M[2]),cmd:M[3]})}),L}async function D(b,v,L){const O=L.reduce((j,z)=>(j[z.pid]=z,j),{}),M=[];return b.forEach(({socket:j,ip:z,port:F})=>{const B=v[j]?v[j].pid:void 0,_=B?O[B]?.cmd:void 0;B&&_&&!w(_)&&M.push({host:z,port:F,detail:_,pid:B})}),M}function y(b,v,L){const O=new Map,M=S(v);for(const j of b){const z=L.get(j.port);if(z){O.set(j.port,z);continue}const F=M.find(B=>B.cmd.includes(`${j.port}`));if(F){let B=F,_;do _=M.find(re=>re.ppid===B.pid),_&&(B=_);while(_);O.set(j.port,{host:j.ip,port:j.port,pid:B.pid,detail:B.cmd,ppid:B.ppid})}else O.set(j.port,{host:j.ip,port:j.port,ppid:Number.MAX_VALUE})}return O}let C=class extends o.$FFb{constructor(v,L,O,M){super(v,L,O),this.D=L,this.F=M,this.y=void 0,this.z=new Map,this.C=!1,N.$k&&L.remote.isRemote&&L.remote.authority&&(this.a.$setRemoteTunnelService(process.pid),this.H())}async $registerCandidateFinder(v){if(v&&this.C)return;this.C=v;let L;this.y&&(L=this.y,await this.a.$onFoundNewCandidates(this.y));const O=new T.$Nm;let M=0;for(;this.C;){const j=new Date().getTime(),z=(await this.I()).filter(_=>(0,f.$Cw)(_.host)||(0,f.$Ew)(_.host));this.s.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${z.map(_=>_.port).join(", ")}`);const F=new Date().getTime()-j;this.s.trace(`ForwardedPorts: (ExtHostTunnelService) candidate port scan took ${F} ms.`),M++>3&&O.update(F),(!L||JSON.stringify(L)!==JSON.stringify(z))&&(L=z,await this.a.$onFoundNewCandidates(L));const B=this.G(O.value);this.s.trace(`ForwardedPorts: (ExtHostTunnelService) next candidate port scan in ${B} ms.`),await new Promise(_=>setTimeout(()=>_(),B))}}G(v){return Math.max(v*20,2e3)}async H(){this.y=await this.I(),this.s.trace(`ForwardedPorts: (ExtHostTunnelService) Initial candidates found: ${this.y.map(v=>v.port).join(", ")}`)}async I(){let v="",L="";try{v=await I.Promises.readFile("/proc/net/tcp","utf8"),L=await I.Promises.readFile("/proc/net/tcp6","utf8")}catch{}const O=s(v,L),M=await new Promise(G=>{(0,r.exec)("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(Q,ee,he)=>{G(ee)})}),j=i(M),z=await I.Promises.readdir("/proc"),F=[];for(const G of z)try{const Q=Number(G),ee=$.$gh(c.URI.file("/proc"),G);if((await I.Promises.stat(ee.fsPath)).isDirectory()&&!isNaN(Q)){const ne=await I.Promises.readlink($.$gh(ee,"cwd").fsPath),De=await I.Promises.readFile($.$gh(ee,"cmdline").fsPath,"utf8");F.push({pid:Q,cwd:ne,cmd:De})}}catch{}const B=[],_=O.filter(G=>{const Q=j[G.socket];return Q||B.push(G),Q}),re=D(_,j,F);let U;if(this.s.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${B.length}`),B.length>0){const G=await new Promise(Q=>{(0,r.exec)("ps -F -A -l | grep root",(ee,he,ne)=>{Q(he)})});this.z=y(B,G,this.z),U=Array.from(this.z.values()),this.s.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${U.map(Q=>Q.port).join(", ")}`)}return re.then(G=>U?G.concat(U):G)}w(v){return async L=>{const O=new d.$lgc({commit:this.D.commit,quality:this.D.quality,logService:this.s,ipcLogger:null,remoteSocketFactoryService:{_serviceBrand:void 0,async connect(j,z,F,B){const _=await v.makeConnection();return A.connect(_,z,F,B)},register(){throw new Error("not implemented")}},addressProvider:{getAddress(){return Promise.resolve({connectTo:new p.$Rl(0),connectionToken:v.connectionToken})}},signService:this.F},"localhost",L.remoteAddress.host||"localhost",L.remoteAddress.port,L.localAddressPort);await O.waitForReady();const M=new P.$me;return{localAddress:(0,t.$RM)(O.localAddress)??O.localAddress,remoteAddress:{port:O.tunnelRemotePort,host:O.tunnelRemoteHost},onDidDispose:M.event,dispose:()=>{O.dispose(),M.fire(),M.dispose()}}}}};e.$Nqc=C,e.$Nqc=C=Je([Ge(0,n.$XP),Ge(1,m.$bQ),Ge(2,u.$_j),Ge(3,a.$Yl)],C);class A extends k.$Ywb{static connect(v,L,O,M){const j=new R.$Vc,z={onClose:j.add(new P.$me),onData:j.add(new P.$me),onEnd:j.add(new P.$me)};j.add(v.onDidReceiveMessage(B=>z.onData.fire(h.$Oe.wrap(B)))),j.add(v.onDidEnd(()=>z.onEnd.fire())),j.add(v.onDidClose(B=>z.onClose.fire({type:E.SocketCloseEventType.NodeSocketCloseEvent,error:B,hadError:!!B})));const F=new A(v,M,z);return F.B(j),(0,k.$Xwb)(F,L,O,M,z)}constructor(v,L,O){super(L,O),this.n=v}write(v){this.n.send(v.buffer)}h(){this.n.end()}async drain(){await this.n.drain?.()}}}),define(Ee[410],ye([1,0,89,379,393,392,405,408,409,102,52,103,101,47,77,98,378,339,12,394,65,297,113,118,148]),function(ce,e,r,h,P,R,T,N,$,c,I,E,u,k,p,a,f,d,m,n,o,t,i,s,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,r.$Ks)(I.$Toc,N.$Fqc,r.InstantiationType.Eager),(0,r.$Ks)(m.$ak,d.$Pqc,r.InstantiationType.Delayed),(0,r.$Ks)(m.$_j,new i.$Ci(t.$6pc,[!1],!0)),(0,r.$Ks)(s.$Yl,g.$qgc,r.InstantiationType.Delayed),(0,r.$Ks)(a.$joc,f.$Oqc,r.InstantiationType.Eager),(0,r.$Ks)(c.$4oc,R.$gqc,r.InstantiationType.Eager),(0,r.$Ks)(E.$npc,T.$Aqc,r.InstantiationType.Eager),(0,r.$Ks)(u.$Ppc,P.$$pc,r.InstantiationType.Eager),(0,r.$Ks)(k.$Eoc,h.$0pc,r.InstantiationType.Eager),(0,r.$Ks)(p.$EFb,$.$Nqc,r.InstantiationType.Eager),(0,r.$Ks)(o.$Woc,n.$Qqc,r.InstantiationType.Eager)});var zt=this&&this.__importDefault||function(ce){return ce&&ce.__esModule?ce:{default:ce}};define(Ee[420],ye([1,0,421,67,9,22,14,62,111,34,69,131,114,281,391,303,319,94,396,410]),function(ce,e,r,h,P,R,T,N,$,c,I,E,u,k,p,a,f,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),r=zt(r),h=We(h),N=We(N),k=zt(k),function(){for(let D=0;D<process.execArgv.length;D++)process.execArgv[D]==="--inspect-port=0"&&(process.execArgv.splice(D,1),D--)}();const m=(0,r.default)(process.argv.slice(2),{boolean:["transformURIs","skipWorkspaceStorageLock"],string:["useHostProxy"]});(function(){const S=globalThis._VSCODE_NODE_MODULES.module,D=S._load;S._load=function(y){if(y==="natives")throw new Error('Either the extension or an NPM dependency is using the [unsupported "natives" node module](https://go.microsoft.com/fwlink/?linkid=871887).');return D.apply(this,arguments)}})();const n=process.exit.bind(process),o=process.on.bind(process);function t(S){process.exit=function(D){if(S)n(D);else{const y=new Error("An extension called process.exit() and this was prevented.");console.warn(y.stack)}},process.crash=function(){const D=new Error("An extension called process.crash() and this was prevented.");console.warn(D.stack)},process.env.ELECTRON_RUN_AS_NODE="1",process.on=function(D,y){D==="uncaughtException"&&(y=function(){try{return y.call(void 0,arguments)}catch{}}),o(D,y)}}let i=function(S){n()};function s(){const S=(0,f.$fn)(process.env);if(S.type===f.ExtHostConnectionType.MessagePort)return new Promise((D,y)=>{const C=A=>{const b=A[0],v=new I.$si;b.on("message",L=>v.fire(R.$Oe.wrap(L.data))),b.on("close",()=>{i("renderer closed the MessagePort")}),b.start(),D({onMessage:v.event,send:L=>b.postMessage(L.buffer)})};process.parentPort.on("message",A=>C(A.ports))});if(S.type===f.ExtHostConnectionType.Socket)return new Promise((D,y)=>{let C=null;const A=setTimeout(()=>{i("VSCODE_EXTHOST_IPC_SOCKET timeout")},6e4),b=I.ProtocolConstants.ReconnectionGraceTime,v=I.ProtocolConstants.ReconnectionShortGraceTime,L=new P.$Sh(()=>i("renderer disconnected for too long (1)"),b),O=new P.$Sh(()=>i("renderer disconnected for too long (2)"),v);process.on("message",(j,z)=>{if(j&&j.type==="VSCODE_EXTHOST_IPC_SOCKET"){z.setNoDelay(!0);const F=R.$Oe.wrap(Buffer.from(j.initialDataChunk,"base64"));let B;if(j.skipWebSocketFrames)B=new E.$ui(z,"extHost-socket");else{const _=R.$Oe.wrap(Buffer.from(j.inflateBytes,"base64"));B=new E.$vi(new E.$ui(z,"extHost-socket"),j.permessageDeflate,_,!1)}C?(L.cancel(),O.cancel(),C.beginAcceptReconnection(B,F),C.endAcceptReconnection(),C.sendResume()):(clearTimeout(A),C=new I.$ti({socket:B,initialChunk:F}),C.sendResume(),C.onDidDispose(()=>i("renderer disconnected")),D(C),C.onSocketClose(()=>{L.schedule()}))}if(j&&j.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(O.isScheduled())return;L.isScheduled()&&O.schedule()}});const M={type:"VSCODE_EXTHOST_IPC_READY"};process.send?.(M)});{const D=S.pipeName;return new Promise((y,C)=>{const A=h.createConnection(D,()=>{A.removeListener("error",C);const b=new I.$ti({socket:new E.$ui(A,"extHost-renderer")});b.sendResume(),y(b)});A.once("error",C),A.on("close",()=>{i("renderer closed the socket")})})}}async function g(){const S=await s();return new class{constructor(){this.a=new I.$si,this.onMessage=this.a.event,this.b=!1,this.d=S.onMessage(D=>{(0,d.$zn)(D,d.MessageType.Terminate)?(this.b=!0,this.d.dispose(),i("received terminate message from renderer")):this.a.fire(D)})}send(D){this.b||S.send(D)}async drain(){if(S.drain)return S.drain()}}}function l(S){return new Promise(D=>{const y=S.onMessage(C=>{y.dispose();const A=JSON.parse(C.toString()),b=A.commit,v=k.default.commit;if(b&&v&&b!==v&&n(d.ExtensionHostExitCode.VersionMismatch),A.parentPid){let L=0;setInterval(function(){try{process.kill(A.parentPid,0),L=0}catch(M){M&&M.code==="EPERM"?(L++,L>=3&&i(`parent process ${A.parentPid} does not exist anymore (3 x EPERM): ${M.message} (code: ${M.code}) (errno: ${M.errno})`)):i(`parent process ${A.parentPid} does not exist anymore: ${M.message} (code: ${M.code}) (errno: ${M.errno})`)}},1e3);let O;try{O=globalThis._VSCODE_NODE_MODULES["native-watchdog"],O.start(A.parentPid)}catch(M){(0,T.$3)(M)}}S.send((0,d.$yn)(d.MessageType.Initialized)),D({protocol:S,initData:A})});S.send((0,d.$yn)(d.MessageType.Ready))})}async function w(){const S=[];process.on("unhandledRejection",(L,O)=>{S.push(O),setTimeout(()=>{const M=S.indexOf(O);M>=0&&O.catch(j=>{S.splice(M,1),(0,T.$6)(j)||(console.warn(`rejected promise not handled within 1 second: ${j}`),j&&j.stack&&console.warn(`stack trace: ${j.stack}`),L&&(0,T.$3)(L))})},1e3)}),process.on("rejectionHandled",L=>{const O=S.indexOf(L);O>=0&&S.splice(O,1)}),process.on("uncaughtException",function(L){(0,T.$2)(L)||(0,T.$3)(L)}),N.mark("code/extHost/willConnectToRenderer");const D=await g();N.mark("code/extHost/didConnectToRenderer");const y=await l(D);N.mark("code/extHost/didWaitForInitData");const{initData:C}=y;t(!!C.environment.extensionTestsLocationURI),C.environment.useHostProxy=m.useHostProxy!==void 0?m.useHostProxy!=="false":void 0,C.environment.skipWorkspaceStorageLock=(0,u.boolean)(m.skipWorkspaceStorageLock,!1);const A=new class{constructor(){this.pid=process.pid}exit(O){n(O)}fsExists(O){return c.Promises.exists(O)}fsRealpath(O){return(0,$.$gr)(O)}};let b=null;C.remote.authority&&m.transformURIs&&(b=(0,a.$Os)(C.remote.authority));const v=new p.$9pc(y.protocol,C,A,b);i=L=>v.terminate(L)}w().catch(S=>console.log(S))})}).call(this);

//# sourceMappingURL=https://main.vscode-cdn.net/sourcemaps/c2e20cb17fae44eb26611cb9a4690059cea0e605/core/vs/workbench/api/node/extensionHostProcess.js.map
