/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ke=["exports","require","vs/base/common/uri","vs/platform/instantiation/common/instantiation","vs/base/common/lifecycle","vs/workbench/api/common/extHost.protocol","vs/base/common/event","vs/workbench/api/common/extHostTypes","vs/nls","vs/nls!vs/workbench/api/worker/extensionHostWorker","vs/workbench/api/common/extHostTypeConverters","vs/base/common/async","vs/platform/log/common/log","vs/base/common/strings","vs/base/common/errors","vs/base/common/types","vs/base/common/network","vs/workbench/api/common/extHostRpcService","vs/base/common/arrays","vs/platform/extensions/common/extensions","vs/base/common/path","vs/base/common/platform","vs/base/common/cancellation","vs/base/common/buffer","vs/base/common/resources","vs/workbench/services/extensions/common/extensions","vs/base/common/objects","vs/workbench/api/common/extHostInitDataService","vs/base/common/charCode","vs/base/common/map","vs/platform/files/common/files","vs/platform/registry/common/platform","vs/platform/contextkey/common/contextkey","vs/editor/common/core/range","vs/workbench/api/common/extHostCommands","vs/base/common/themables","vs/base/common/severity","vs/base/common/uuid","vs/base/common/marshallingIds","vs/workbench/services/extensions/common/proxyIdentifier","vs/base/common/iterator","vs/base/common/glob","vs/platform/configuration/common/configuration","vs/workbench/services/search/common/search","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/lazy","vs/base/common/errorMessage","vs/base/common/marshalling","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostFileSystemInfo","vs/editor/common/model","vs/base/common/extpath","vs/platform/configuration/common/configurationRegistry","vs/workbench/contrib/testing/common/testId","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostDocumentsAndEditors","vs/base/common/ternarySearchTree","vs/base/common/htmlContent","vs/platform/instantiation/common/extensions","vs/base/common/assert","vs/platform/remote/common/remoteHosts","vs/platform/telemetry/common/telemetryUtils","vs/base/common/performance","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostWebview","vs/workbench/api/common/extHostFileSystemConsumer","vs/base/common/stopwatch","vs/workbench/api/common/extHostEditorTabs","vs/base/common/decorators","vs/base/common/mime","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/serviceCollection","vs/base/common/hash","vs/platform/progress/common/progress","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/base/common/process","vs/workbench/api/common/cache","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostManagedSockets","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostTunnelService","vs/editor/common/languages","vs/workbench/api/common/extHostLanguageModels","vs/workbench/api/common/extHostTesting","vs/base/common/idGenerator","vs/base/common/codicons","vs/base/common/iconLabels","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeBase","vs/editor/common/core/position","vs/editor/common/model/textModelSearch","vs/base/common/labels","vs/editor/common/services/semanticTokensDto","vs/editor/common/config/editorOptions","vs/platform/environment/common/environment","vs/platform/markers/common/markers","vs/platform/product/common/productService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/telemetry/common/telemetry","vs/platform/userDataProfile/common/userDataProfile","vs/workbench/common/editor","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/authentication/common/authentication","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTerminalShellIntegration","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostOutput","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostVariableResolverService","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/equals","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/naturalLanguage/korean","vs/base/common/numbers","vs/base/common/observableInternal/debugName","vs/base/common/observableInternal/logging","vs/base/common/observableInternal/base","vs/base/common/prefixTree","vs/base/common/scrollable","vs/base/common/stream","vs/base/common/symbols","vs/base/common/filters","vs/base/common/dataTransfer","vs/editor/common/core/eolCounter","vs/editor/common/core/textModelDefaults","vs/editor/common/languages/languageConfiguration","vs/editor/common/encodedTokenAttributes","vs/editor/common/model/pieceTreeTextBuffer/rbTreeBase","vs/editor/common/services/treeViewsDnd","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/base/common/comparers","vs/base/common/uriIpc","vs/base/parts/storage/common/storage","vs/editor/common/core/stringBuilder","vs/editor/common/core/textChange","vs/editor/common/languageSelector","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBuffer","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBufferBuilder","vs/nls!vs/editor/common/config/editorOptions","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/log/common/log","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostLanguageFeatures","vs/nls!vs/workbench/api/common/extHostLanguageModels","vs/nls!vs/workbench/api/common/extHostLogService","vs/nls!vs/workbench/api/common/extHostNotebook","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostTunnelService","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/configuration","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/chat/common/chatContextKeys","vs/nls!vs/workbench/contrib/chat/common/languageModels","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/contrib/testing/common/constants","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/editor/common/editorResolverService","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/contextkey/common/scanner","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/accessibility/common/accessibility","vs/editor/common/core/wordHelper","vs/platform/instantiation/common/instantiationService","vs/base/common/linkedList","vs/platform/log/common/logService","vs/platform/notification/common/notification","vs/platform/configuration/common/configurationModels","vs/platform/request/common/request","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminal","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/tunnel/common/tunnel","vs/platform/uriIdentity/common/uriIdentity","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/platform/storage/common/storage","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/common/views","vs/workbench/contrib/chat/common/chatContextKeys","vs/workbench/contrib/chat/common/chatAgents","vs/workbench/contrib/chat/common/chatService","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/notebook/common/notebookKernelService","vs/workbench/contrib/search/common/cellSearchModel","vs/workbench/contrib/testing/common/constants","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/environment/common/environmentService","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/contrib/chat/common/languageModels","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostEmbedding","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageModelTools","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostSpeech","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/worker/extHostConsoleForwarder","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/notebook/common/notebookDocumentService","vs/workbench/api/common/extHostAiRelatedInformation","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostEmbeddingVector","vs/workbench/api/common/extHostTheming","vs/base/common/functional","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostChatAgents2","vs/workbench/api/common/extHostChatVariables","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostDocuments","vs/base/common/collections","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostShare","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/services/output/common/output","vs/workbench/common/configuration","vs/workbench/services/editor/common/editorResolverService","vs/workbench/services/path/common/pathService","vs/workbench/contrib/search/common/searchNotebookHelpers","vs/workbench/api/common/extHostNotebook","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/base/common/semver/semver","vs/base/common/uint","vs/base/common/codiconsUtil","vs/base/common/arraysFind","vs/editor/common/model/mirrorTextModel","vs/editor/common/languages/linkComputer","vs/editor/common/core/selection","vs/workbench/api/worker/extensionHostWorker"],Ce=function(oe){for(var e=[],w=0,S=oe.length;w<S;w++)e[w]=ke[oe[w]];return e};define(ke[72],Ce([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0h=S,e.$$h=k,e.$_h=O;function w(A){return(T,p,a)=>{let R=null,y=null;if(typeof a.value=="function"?(R="value",y=a.value):typeof a.get=="function"&&(R="get",y=a.get),!y)throw new Error("not supported");a[R]=A(y,p)}}function S(A,T,p){let a=null,R=null;if(typeof p.value=="function"?(a="value",R=p.value,R.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof p.get=="function"&&(a="get",R=p.get),!R)throw new Error("not supported");const y=`$memoize$${T}`;p[a]=function(...u){return this.hasOwnProperty(y)||Object.defineProperty(this,y,{configurable:!1,enumerable:!1,writable:!1,value:R.apply(this,u)}),this[y]}}function k(A,T,p){return w((a,R)=>{const y=`$debounce$${R}`,u=`$debounce$result$${R}`;return function(...E){this[u]||(this[u]=p?p():void 0),clearTimeout(this[y]),T&&(this[u]=T(this[u],...E),E=[this[u]]),this[y]=setTimeout(()=>{a.apply(this,E),this[u]=p?p():void 0},A)}})}function O(A,T,p){return w((a,R)=>{const y=`$throttle$timer$${R}`,u=`$throttle$result$${R}`,E=`$throttle$lastRun$${R}`,d=`$throttle$pending$${R}`;return function(...n){if(this[u]||(this[u]=p?p():void 0),(this[E]===null||this[E]===void 0)&&(this[E]=-Number.MAX_VALUE),T&&(this[u]=T(this[u],...n)),this[d])return;const s=this[E]+A;s<=Date.now()?(this[E]=Date.now(),a.apply(this,[this[u]]),this[u]=p?p():void 0):(this[d]=!0,this[y]=setTimeout(()=>{this[d]=!1,this[E]=Date.now(),a.apply(this,[this[u]]),this[u]=p?p():void 0},s-Date.now()))}})}});var Bn=this&&this.__createBinding||(Object.create?function(oe,e,w,S){S===void 0&&(S=w);var k=Object.getOwnPropertyDescriptor(e,w);(!k||("get"in k?!e.__esModule:k.writable||k.configurable))&&(k={enumerable:!0,get:function(){return e[w]}}),Object.defineProperty(oe,S,k)}:function(oe,e,w,S){S===void 0&&(S=w),oe[S]=e[w]}),Wn=this&&this.__setModuleDefault||(Object.create?function(oe,e){Object.defineProperty(oe,"default",{enumerable:!0,value:e})}:function(oe,e){oe.default=e}),qe=this&&this.__importStar||function(oe){if(oe&&oe.__esModule)return oe;var e={};if(oe!=null)for(var w in oe)w!=="default"&&Object.prototype.hasOwnProperty.call(oe,w)&&Bn(e,oe,w);return Wn(e,oe),e};define(ke[134],Ce([1,0,18]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8c=void 0,e.$9c=k,e.$0c=O,e.$$c=A,e.$_c=T,e.$ad=p,e.$bd=a,w=qe(w);const S=(E,d)=>E===d;e.$8c=S;function k(E=e.$8c){return(d,n)=>w.$wb(d,n,E)}function O(){return(E,d)=>JSON.stringify(E)===JSON.stringify(d)}function A(){return(E,d)=>E.equals(d)}function T(E,d,n){if(n!==void 0){const s=E;return s==null||d===void 0||d===null?d===s:n(s,d)}else{const s=E;return(o,h)=>o==null||h===void 0||h===null?h===o:s(o,h)}}function p(E,d){if(E===d)return!0;if(Array.isArray(E)&&Array.isArray(d)){if(E.length!==d.length)return!1;for(let n=0;n<E.length;n++)if(!p(E[n],d[n]))return!1;return!0}if(E&&typeof E=="object"&&d&&typeof d=="object"&&Object.getPrototypeOf(E)===Object.prototype&&Object.getPrototypeOf(d)===Object.prototype){const n=E,s=d,o=Object.keys(n),h=Object.keys(s),i=new Set(h);if(o.length!==h.length)return!1;for(const r of o)if(!i.has(r)||!p(n[r],s[r]))return!1;return!0}return!1}function a(E){return JSON.stringify(u(E))}let R=0;const y=new WeakMap;function u(E){if(Array.isArray(E))return E.map(u);if(E&&typeof E=="object")if(Object.getPrototypeOf(E)===Object.prototype){const d=E,n=Object.create(null);for(const s of Object.keys(d).sort())n[s]=u(d[s]);return n}else{let d=y.get(E);return d===void 0&&(d=R++,y.set(E,d)),d+"----2b76a038c20c4bcc"}return E}}),define(ke[97],Ce([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4P=e.$3P=void 0;class w{constructor(k){this.a=k,this.b=0}nextId(){return this.a+ ++this.b}}e.$3P=w,e.$4P=new w("id#")}),define(ke[135],Ce([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0,e.$Tn=A,e.$Un=y,e.$Vn=u,e.$Wn=E,e.$Xn=d,e.$Yn=n,e.$Zn=s,e.$1n=o,e.$2n=h,e.$3n=i,e.$4n=r;var w;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(w||(e.ScanError=w={}));var S;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(S||(e.SyntaxKind=S={}));var k;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(k||(e.ParseErrorCode=k={}));var O;(function(t){t.DEFAULT={allowTrailingComma:!0}})(O||(e.ParseOptions=O={}));function A(t,c=!1){let l=0;const m=t.length;let f="",$=0,I=S.Unknown,D=w.None;function v(B){let G=0,W=0;for(;G<B;){const F=t.charCodeAt(l);if(F>=R._0&&F<=R._9)W=W*16+F-R._0;else if(F>=R.A&&F<=R.F)W=W*16+F-R.A+10;else if(F>=R.a&&F<=R.f)W=W*16+F-R.a+10;else break;l++,G++}return G<B&&(W=-1),W}function C(B){l=B,f="",$=0,I=S.Unknown,D=w.None}function P(){const B=l;if(t.charCodeAt(l)===R._0)l++;else for(l++;l<t.length&&a(t.charCodeAt(l));)l++;if(l<t.length&&t.charCodeAt(l)===R.dot)if(l++,l<t.length&&a(t.charCodeAt(l)))for(l++;l<t.length&&a(t.charCodeAt(l));)l++;else return D=w.UnexpectedEndOfNumber,t.substring(B,l);let G=l;if(l<t.length&&(t.charCodeAt(l)===R.E||t.charCodeAt(l)===R.e))if(l++,(l<t.length&&t.charCodeAt(l)===R.plus||t.charCodeAt(l)===R.minus)&&l++,l<t.length&&a(t.charCodeAt(l))){for(l++;l<t.length&&a(t.charCodeAt(l));)l++;G=l}else D=w.UnexpectedEndOfNumber;return t.substring(B,G)}function g(){let B="",G=l;for(;;){if(l>=m){B+=t.substring(G,l),D=w.UnexpectedEndOfString;break}const W=t.charCodeAt(l);if(W===R.doubleQuote){B+=t.substring(G,l),l++;break}if(W===R.backslash){if(B+=t.substring(G,l),l++,l>=m){D=w.UnexpectedEndOfString;break}switch(t.charCodeAt(l++)){case R.doubleQuote:B+='"';break;case R.backslash:B+="\\";break;case R.slash:B+="/";break;case R.b:B+="\b";break;case R.f:B+="\f";break;case R.n:B+=`
`;break;case R.r:B+="\r";break;case R.t:B+="	";break;case R.u:{const q=v(4);q>=0?B+=String.fromCharCode(q):D=w.InvalidUnicode;break}default:D=w.InvalidEscapeCharacter}G=l;continue}if(W>=0&&W<=31)if(p(W)){B+=t.substring(G,l),D=w.UnexpectedEndOfString;break}else D=w.InvalidCharacter;l++}return B}function b(){if(f="",D=w.None,$=l,l>=m)return $=m,I=S.EOF;let B=t.charCodeAt(l);if(T(B)){do l++,f+=String.fromCharCode(B),B=t.charCodeAt(l);while(T(B));return I=S.Trivia}if(p(B))return l++,f+=String.fromCharCode(B),B===R.carriageReturn&&t.charCodeAt(l)===R.lineFeed&&(l++,f+=`
`),I=S.LineBreakTrivia;switch(B){case R.openBrace:return l++,I=S.OpenBraceToken;case R.closeBrace:return l++,I=S.CloseBraceToken;case R.openBracket:return l++,I=S.OpenBracketToken;case R.closeBracket:return l++,I=S.CloseBracketToken;case R.colon:return l++,I=S.ColonToken;case R.comma:return l++,I=S.CommaToken;case R.doubleQuote:return l++,f=g(),I=S.StringLiteral;case R.slash:{const G=l-1;if(t.charCodeAt(l+1)===R.slash){for(l+=2;l<m&&!p(t.charCodeAt(l));)l++;return f=t.substring(G,l),I=S.LineCommentTrivia}if(t.charCodeAt(l+1)===R.asterisk){l+=2;const W=m-1;let F=!1;for(;l<W;){if(t.charCodeAt(l)===R.asterisk&&t.charCodeAt(l+1)===R.slash){l+=2,F=!0;break}l++}return F||(l++,D=w.UnexpectedEndOfComment),f=t.substring(G,l),I=S.BlockCommentTrivia}return f+=String.fromCharCode(B),l++,I=S.Unknown}case R.minus:if(f+=String.fromCharCode(B),l++,l===m||!a(t.charCodeAt(l)))return I=S.Unknown;case R._0:case R._1:case R._2:case R._3:case R._4:case R._5:case R._6:case R._7:case R._8:case R._9:return f+=P(),I=S.NumericLiteral;default:for(;l<m&&L(B);)l++,B=t.charCodeAt(l);if($!==l){switch(f=t.substring($,l),f){case"true":return I=S.TrueKeyword;case"false":return I=S.FalseKeyword;case"null":return I=S.NullKeyword}return I=S.Unknown}return f+=String.fromCharCode(B),l++,I=S.Unknown}}function L(B){if(T(B)||p(B))return!1;switch(B){case R.closeBrace:case R.closeBracket:case R.openBrace:case R.openBracket:case R.doubleQuote:case R.colon:case R.comma:case R.slash:return!1}return!0}function N(){let B;do B=b();while(B>=S.LineCommentTrivia&&B<=S.Trivia);return B}return{setPosition:C,getPosition:()=>l,scan:c?N:b,getToken:()=>I,getTokenValue:()=>f,getTokenOffset:()=>$,getTokenLength:()=>l-$,getTokenError:()=>D}}function T(t){return t===R.space||t===R.tab||t===R.verticalTab||t===R.formFeed||t===R.nonBreakingSpace||t===R.ogham||t>=R.enQuad&&t<=R.zeroWidthSpace||t===R.narrowNoBreakSpace||t===R.mathematicalSpace||t===R.ideographicSpace||t===R.byteOrderMark}function p(t){return t===R.lineFeed||t===R.carriageReturn||t===R.lineSeparator||t===R.paragraphSeparator}function a(t){return t>=R._0&&t<=R._9}var R;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(R||(R={}));function y(t,c){const l=[],m=new Object;let f;const $={value:{},offset:0,length:0,type:"object",parent:void 0};let I=!1;function D(v,C,P,g){$.value=v,$.offset=C,$.length=P,$.type=g,$.colonOffset=void 0,f=$}try{i(t,{onObjectBegin:(v,C)=>{if(c<=v)throw m;f=void 0,I=c>v,l.push("")},onObjectProperty:(v,C,P)=>{if(c<C||(D(v,C,P,"property"),l[l.length-1]=v,c<=C+P))throw m},onObjectEnd:(v,C)=>{if(c<=v)throw m;f=void 0,l.pop()},onArrayBegin:(v,C)=>{if(c<=v)throw m;f=void 0,l.push(0)},onArrayEnd:(v,C)=>{if(c<=v)throw m;f=void 0,l.pop()},onLiteralValue:(v,C,P)=>{if(c<C||(D(v,C,P,r(v)),c<=C+P))throw m},onSeparator:(v,C,P)=>{if(c<=C)throw m;if(v===":"&&f&&f.type==="property")f.colonOffset=C,I=!1,f=void 0;else if(v===","){const g=l[l.length-1];typeof g=="number"?l[l.length-1]=g+1:(I=!0,l[l.length-1]=""),f=void 0}}})}catch(v){if(v!==m)throw v}return{path:l,previousNode:f,isAtPropertyKey:I,matches:v=>{let C=0;for(let P=0;C<v.length&&P<l.length;P++)if(v[C]===l[P]||v[C]==="*")C++;else if(v[C]!=="**")return!1;return C===v.length}}}function u(t,c=[],l=O.DEFAULT){let m=null,f=[];const $=[];function I(v){Array.isArray(f)?f.push(v):m!==null&&(f[m]=v)}return i(t,{onObjectBegin:()=>{const v={};I(v),$.push(f),f=v,m=null},onObjectProperty:v=>{m=v},onObjectEnd:()=>{f=$.pop()},onArrayBegin:()=>{const v=[];I(v),$.push(f),f=v,m=null},onArrayEnd:()=>{f=$.pop()},onLiteralValue:I,onError:(v,C,P)=>{c.push({error:v,offset:C,length:P})}},l),f[0]}function E(t,c=[],l=O.DEFAULT){let m={type:"array",offset:-1,length:-1,children:[],parent:void 0};function f(v){m.type==="property"&&(m.length=v-m.offset,m=m.parent)}function $(v){return m.children.push(v),v}i(t,{onObjectBegin:v=>{m=$({type:"object",offset:v,length:-1,parent:m,children:[]})},onObjectProperty:(v,C,P)=>{m=$({type:"property",offset:C,length:-1,parent:m,children:[]}),m.children.push({type:"string",value:v,offset:C,length:P,parent:m})},onObjectEnd:(v,C)=>{m.length=v+C-m.offset,m=m.parent,f(v+C)},onArrayBegin:(v,C)=>{m=$({type:"array",offset:v,length:-1,parent:m,children:[]})},onArrayEnd:(v,C)=>{m.length=v+C-m.offset,m=m.parent,f(v+C)},onLiteralValue:(v,C,P)=>{$({type:r(v),offset:C,length:P,parent:m,value:v}),f(C+P)},onSeparator:(v,C,P)=>{m.type==="property"&&(v===":"?m.colonOffset=C:v===","&&f(C))},onError:(v,C,P)=>{c.push({error:v,offset:C,length:P})}},l);const D=m.children[0];return D&&delete D.parent,D}function d(t,c){if(!t)return;let l=t;for(const m of c)if(typeof m=="string"){if(l.type!=="object"||!Array.isArray(l.children))return;let f=!1;for(const $ of l.children)if(Array.isArray($.children)&&$.children[0].value===m){l=$.children[1],f=!0;break}if(!f)return}else{const f=m;if(l.type!=="array"||f<0||!Array.isArray(l.children)||f>=l.children.length)return;l=l.children[f]}return l}function n(t){if(!t.parent||!t.parent.children)return[];const c=n(t.parent);if(t.parent.type==="property"){const l=t.parent.children[0].value;c.push(l)}else if(t.parent.type==="array"){const l=t.parent.children.indexOf(t);l!==-1&&c.push(l)}return c}function s(t){switch(t.type){case"array":return t.children.map(s);case"object":{const c=Object.create(null);for(const l of t.children){const m=l.children[1];m&&(c[l.children[0].value]=s(m))}return c}case"null":case"string":case"number":case"boolean":return t.value;default:return}}function o(t,c,l=!1){return c>=t.offset&&c<t.offset+t.length||l&&c===t.offset+t.length}function h(t,c,l=!1){if(o(t,c,l)){const m=t.children;if(Array.isArray(m))for(let f=0;f<m.length&&m[f].offset<=c;f++){const $=h(m[f],c,l);if($)return $}return t}}function i(t,c,l=O.DEFAULT){const m=A(t,!1);function f(ce){return ce?()=>ce(m.getTokenOffset(),m.getTokenLength()):()=>!0}function $(ce){return ce?be=>ce(be,m.getTokenOffset(),m.getTokenLength()):()=>!0}const I=f(c.onObjectBegin),D=$(c.onObjectProperty),v=f(c.onObjectEnd),C=f(c.onArrayBegin),P=f(c.onArrayEnd),g=$(c.onLiteralValue),b=$(c.onSeparator),L=f(c.onComment),N=$(c.onError),B=l&&l.disallowComments,G=l&&l.allowTrailingComma;function W(){for(;;){const ce=m.scan();switch(m.getTokenError()){case w.InvalidUnicode:F(k.InvalidUnicode);break;case w.InvalidEscapeCharacter:F(k.InvalidEscapeCharacter);break;case w.UnexpectedEndOfNumber:F(k.UnexpectedEndOfNumber);break;case w.UnexpectedEndOfComment:B||F(k.UnexpectedEndOfComment);break;case w.UnexpectedEndOfString:F(k.UnexpectedEndOfString);break;case w.InvalidCharacter:F(k.InvalidCharacter);break}switch(ce){case S.LineCommentTrivia:case S.BlockCommentTrivia:B?F(k.InvalidCommentToken):L();break;case S.Unknown:F(k.InvalidSymbol);break;case S.Trivia:case S.LineBreakTrivia:break;default:return ce}}}function F(ce,be=[],se=[]){if(N(ce),be.length+se.length>0){let Ie=m.getToken();for(;Ie!==S.EOF;){if(be.indexOf(Ie)!==-1){W();break}else if(se.indexOf(Ie)!==-1)break;Ie=W()}}}function q(ce){const be=m.getTokenValue();return ce?g(be):D(be),W(),!0}function ue(){switch(m.getToken()){case S.NumericLiteral:{let ce=0;try{ce=JSON.parse(m.getTokenValue()),typeof ce!="number"&&(F(k.InvalidNumberFormat),ce=0)}catch{F(k.InvalidNumberFormat)}g(ce);break}case S.NullKeyword:g(null);break;case S.TrueKeyword:g(!0);break;case S.FalseKeyword:g(!1);break;default:return!1}return W(),!0}function ge(){return m.getToken()!==S.StringLiteral?(F(k.PropertyNameExpected,[],[S.CloseBraceToken,S.CommaToken]),!1):(q(!1),m.getToken()===S.ColonToken?(b(":"),W(),re()||F(k.ValueExpected,[],[S.CloseBraceToken,S.CommaToken])):F(k.ColonExpected,[],[S.CloseBraceToken,S.CommaToken]),!0)}function te(){I(),W();let ce=!1;for(;m.getToken()!==S.CloseBraceToken&&m.getToken()!==S.EOF;){if(m.getToken()===S.CommaToken){if(ce||F(k.ValueExpected,[],[]),b(","),W(),m.getToken()===S.CloseBraceToken&&G)break}else ce&&F(k.CommaExpected,[],[]);ge()||F(k.ValueExpected,[],[S.CloseBraceToken,S.CommaToken]),ce=!0}return v(),m.getToken()!==S.CloseBraceToken?F(k.CloseBraceExpected,[S.CloseBraceToken],[]):W(),!0}function me(){C(),W();let ce=!1;for(;m.getToken()!==S.CloseBracketToken&&m.getToken()!==S.EOF;){if(m.getToken()===S.CommaToken){if(ce||F(k.ValueExpected,[],[]),b(","),W(),m.getToken()===S.CloseBracketToken&&G)break}else ce&&F(k.CommaExpected,[],[]);re()||F(k.ValueExpected,[],[S.CloseBracketToken,S.CommaToken]),ce=!0}return P(),m.getToken()!==S.CloseBracketToken?F(k.CloseBracketExpected,[S.CloseBracketToken],[]):W(),!0}function re(){switch(m.getToken()){case S.OpenBracketToken:return me();case S.OpenBraceToken:return te();case S.StringLiteral:return q(!0);default:return ue()}}return W(),m.getToken()===S.EOF?l.allowEmptyContent?!0:(F(k.ValueExpected,[],[]),!1):re()?(m.getToken()!==S.EOF&&F(k.EndOfFileExpected,[],[]),!0):(F(k.ValueExpected,[],[]),!1)}function r(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}}),function(oe,e){typeof define=="function"&&define.amd?define(ke[136],Ce([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(oe=typeof globalThis<"u"?globalThis:oe||self,e(oe.marked={}))}(this,function(oe){"use strict";function e(ae,we){for(var he=0;he<we.length;he++){var X=we[he];X.enumerable=X.enumerable||!1,X.configurable=!0,"value"in X&&(X.writable=!0),Object.defineProperty(ae,X.key,X)}}function w(ae,we,he){return we&&e(ae.prototype,we),he&&e(ae,he),Object.defineProperty(ae,"prototype",{writable:!1}),ae}function S(ae,we){if(ae){if(typeof ae=="string")return k(ae,we);var he=Object.prototype.toString.call(ae).slice(8,-1);if(he==="Object"&&ae.constructor&&(he=ae.constructor.name),he==="Map"||he==="Set")return Array.from(ae);if(he==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(he))return k(ae,we)}}function k(ae,we){(we==null||we>ae.length)&&(we=ae.length);for(var he=0,X=new Array(we);he<we;he++)X[he]=ae[he];return X}function O(ae,we){var he=typeof Symbol<"u"&&ae[Symbol.iterator]||ae["@@iterator"];if(he)return(he=he.call(ae)).next.bind(he);if(Array.isArray(ae)||(he=S(ae))||we&&ae&&typeof ae.length=="number"){he&&(ae=he);var X=0;return function(){return X>=ae.length?{done:!0}:{done:!1,value:ae[X++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function A(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}oe.defaults=A();function T(ae){oe.defaults=ae}var p=/[&<>"']/,a=/[&<>"']/g,R=/[<>"']|&(?!#?\w+;)/,y=/[<>"']|&(?!#?\w+;)/g,u={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},E=function(we){return u[we]};function d(ae,we){if(we){if(p.test(ae))return ae.replace(a,E)}else if(R.test(ae))return ae.replace(y,E);return ae}var n=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function s(ae){return ae.replace(n,function(we,he){return he=he.toLowerCase(),he==="colon"?":":he.charAt(0)==="#"?he.charAt(1)==="x"?String.fromCharCode(parseInt(he.substring(2),16)):String.fromCharCode(+he.substring(1)):""})}var o=/(^|[^\[])\^/g;function h(ae,we){ae=typeof ae=="string"?ae:ae.source,we=we||"";var he={replace:function(Y,pe){return pe=pe.source||pe,pe=pe.replace(o,"$1"),ae=ae.replace(Y,pe),he},getRegex:function(){return new RegExp(ae,we)}};return he}var i=/[^\w:]/g,r=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function t(ae,we,he){if(ae){var X;try{X=decodeURIComponent(s(he)).replace(i,"").toLowerCase()}catch{return null}if(X.indexOf("javascript:")===0||X.indexOf("vbscript:")===0||X.indexOf("data:")===0)return null}we&&!r.test(he)&&(he=$(we,he));try{he=encodeURI(he).replace(/%25/g,"%")}catch{return null}return he}var c={},l=/^[^:]+:\/*[^/]*$/,m=/^([^:]+:)[\s\S]*$/,f=/^([^:]+:\/*[^/]*)[\s\S]*$/;function $(ae,we){c[" "+ae]||(l.test(ae)?c[" "+ae]=ae+"/":c[" "+ae]=C(ae,"/",!0)),ae=c[" "+ae];var he=ae.indexOf(":")===-1;return we.substring(0,2)==="//"?he?we:ae.replace(m,"$1")+we:we.charAt(0)==="/"?he?we:ae.replace(f,"$1")+we:ae+we}var I={exec:function(){}};function D(ae){for(var we=1,he,X;we<arguments.length;we++){he=arguments[we];for(X in he)Object.prototype.hasOwnProperty.call(he,X)&&(ae[X]=he[X])}return ae}function v(ae,we){var he=ae.replace(/\|/g,function(pe,$e,Te){for(var ze=!1,Se=$e;--Se>=0&&Te[Se]==="\\";)ze=!ze;return ze?"|":" |"}),X=he.split(/ \|/),Y=0;if(X[0].trim()||X.shift(),X.length>0&&!X[X.length-1].trim()&&X.pop(),X.length>we)X.splice(we);else for(;X.length<we;)X.push("");for(;Y<X.length;Y++)X[Y]=X[Y].trim().replace(/\\\|/g,"|");return X}function C(ae,we,he){var X=ae.length;if(X===0)return"";for(var Y=0;Y<X;){var pe=ae.charAt(X-Y-1);if(pe===we&&!he)Y++;else if(pe!==we&&he)Y++;else break}return ae.slice(0,X-Y)}function P(ae,we){if(ae.indexOf(we[1])===-1)return-1;for(var he=ae.length,X=0,Y=0;Y<he;Y++)if(ae[Y]==="\\")Y++;else if(ae[Y]===we[0])X++;else if(ae[Y]===we[1]&&(X--,X<0))return Y;return-1}function g(ae){ae&&ae.sanitize&&!ae.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function b(ae,we){if(we<1)return"";for(var he="";we>1;)we&1&&(he+=ae),we>>=1,ae+=ae;return he+ae}function L(ae,we,he,X){var Y=we.href,pe=we.title?d(we.title):null,$e=ae[1].replace(/\\([\[\]])/g,"$1");if(ae[0].charAt(0)!=="!"){X.state.inLink=!0;var Te={type:"link",raw:he,href:Y,title:pe,text:$e,tokens:X.inlineTokens($e)};return X.state.inLink=!1,Te}return{type:"image",raw:he,href:Y,title:pe,text:d($e)}}function N(ae,we){var he=ae.match(/^(\s+)(?:```)/);if(he===null)return we;var X=he[1];return we.split(`
`).map(function(Y){var pe=Y.match(/^\s+/);if(pe===null)return Y;var $e=pe[0];return $e.length>=X.length?Y.slice(X.length):Y}).join(`
`)}var B=function(){function ae(he){this.options=he||oe.defaults}var we=ae.prototype;return we.space=function(X){var Y=this.rules.block.newline.exec(X);if(Y&&Y[0].length>0)return{type:"space",raw:Y[0]}},we.code=function(X){var Y=this.rules.block.code.exec(X);if(Y){var pe=Y[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:Y[0],codeBlockStyle:"indented",text:this.options.pedantic?pe:C(pe,`
`)}}},we.fences=function(X){var Y=this.rules.block.fences.exec(X);if(Y){var pe=Y[0],$e=N(pe,Y[3]||"");return{type:"code",raw:pe,lang:Y[2]?Y[2].trim():Y[2],text:$e}}},we.heading=function(X){var Y=this.rules.block.heading.exec(X);if(Y){var pe=Y[2].trim();if(/#$/.test(pe)){var $e=C(pe,"#");(this.options.pedantic||!$e||/ $/.test($e))&&(pe=$e.trim())}return{type:"heading",raw:Y[0],depth:Y[1].length,text:pe,tokens:this.lexer.inline(pe)}}},we.hr=function(X){var Y=this.rules.block.hr.exec(X);if(Y)return{type:"hr",raw:Y[0]}},we.blockquote=function(X){var Y=this.rules.block.blockquote.exec(X);if(Y){var pe=Y[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:Y[0],tokens:this.lexer.blockTokens(pe,[]),text:pe}}},we.list=function(X){var Y=this.rules.block.list.exec(X);if(Y){var pe,$e,Te,ze,Se,Re,Oe,z,U,K,Q,ne,fe=Y[1].trim(),Ae=fe.length>1,je={type:"list",raw:"",ordered:Ae,start:Ae?+fe.slice(0,-1):"",loose:!1,items:[]};fe=Ae?"\\d{1,9}\\"+fe.slice(-1):"\\"+fe,this.options.pedantic&&(fe=Ae?fe:"[*+-]");for(var Ke=new RegExp("^( {0,3}"+fe+")((?:[	 ][^\\n]*)?(?:\\n|$))");X&&(ne=!1,!(!(Y=Ke.exec(X))||this.rules.block.hr.test(X)));){if(pe=Y[0],X=X.substring(pe.length),z=Y[2].split(`
`,1)[0],U=X.split(`
`,1)[0],this.options.pedantic?(ze=2,Q=z.trimLeft()):(ze=Y[2].search(/[^ ]/),ze=ze>4?1:ze,Q=z.slice(ze),ze+=Y[1].length),Re=!1,!z&&/^ *$/.test(U)&&(pe+=U+`
`,X=X.substring(U.length+1),ne=!0),!ne)for(var _e=new RegExp("^ {0,"+Math.min(3,ze-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),it=new RegExp("^ {0,"+Math.min(3,ze-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),nt=new RegExp("^ {0,"+Math.min(3,ze-1)+"}(?:```|~~~)"),tt=new RegExp("^ {0,"+Math.min(3,ze-1)+"}#");X&&(K=X.split(`
`,1)[0],z=K,this.options.pedantic&&(z=z.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(nt.test(z)||tt.test(z)||_e.test(z)||it.test(X)));){if(z.search(/[^ ]/)>=ze||!z.trim())Q+=`
`+z.slice(ze);else if(!Re)Q+=`
`+z;else break;!Re&&!z.trim()&&(Re=!0),pe+=K+`
`,X=X.substring(K.length+1)}je.loose||(Oe?je.loose=!0:/\n *\n *$/.test(pe)&&(Oe=!0)),this.options.gfm&&($e=/^\[[ xX]\] /.exec(Q),$e&&(Te=$e[0]!=="[ ] ",Q=Q.replace(/^\[[ xX]\] +/,""))),je.items.push({type:"list_item",raw:pe,task:!!$e,checked:Te,loose:!1,text:Q}),je.raw+=pe}je.items[je.items.length-1].raw=pe.trimRight(),je.items[je.items.length-1].text=Q.trimRight(),je.raw=je.raw.trimRight();var rt=je.items.length;for(Se=0;Se<rt;Se++){this.lexer.state.top=!1,je.items[Se].tokens=this.lexer.blockTokens(je.items[Se].text,[]);var $t=je.items[Se].tokens.filter(function(st){return st.type==="space"}),lt=$t.every(function(st){for(var ut=st.raw.split(""),ft=0,mt=O(ut),We;!(We=mt()).done;){var Be=We.value;if(Be===`
`&&(ft+=1),ft>1)return!0}return!1});!je.loose&&$t.length&&lt&&(je.loose=!0,je.items[Se].loose=!0)}return je}},we.html=function(X){var Y=this.rules.block.html.exec(X);if(Y){var pe={type:"html",raw:Y[0],pre:!this.options.sanitizer&&(Y[1]==="pre"||Y[1]==="script"||Y[1]==="style"),text:Y[0]};if(this.options.sanitize){var $e=this.options.sanitizer?this.options.sanitizer(Y[0]):d(Y[0]);pe.type="paragraph",pe.text=$e,pe.tokens=this.lexer.inline($e)}return pe}},we.def=function(X){var Y=this.rules.block.def.exec(X);if(Y){Y[3]&&(Y[3]=Y[3].substring(1,Y[3].length-1));var pe=Y[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:pe,raw:Y[0],href:Y[2],title:Y[3]}}},we.table=function(X){var Y=this.rules.block.table.exec(X);if(Y){var pe={type:"table",header:v(Y[1]).map(function(Oe){return{text:Oe}}),align:Y[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:Y[3]&&Y[3].trim()?Y[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(pe.header.length===pe.align.length){pe.raw=Y[0];var $e=pe.align.length,Te,ze,Se,Re;for(Te=0;Te<$e;Te++)/^ *-+: *$/.test(pe.align[Te])?pe.align[Te]="right":/^ *:-+: *$/.test(pe.align[Te])?pe.align[Te]="center":/^ *:-+ *$/.test(pe.align[Te])?pe.align[Te]="left":pe.align[Te]=null;for($e=pe.rows.length,Te=0;Te<$e;Te++)pe.rows[Te]=v(pe.rows[Te],pe.header.length).map(function(Oe){return{text:Oe}});for($e=pe.header.length,ze=0;ze<$e;ze++)pe.header[ze].tokens=this.lexer.inline(pe.header[ze].text);for($e=pe.rows.length,ze=0;ze<$e;ze++)for(Re=pe.rows[ze],Se=0;Se<Re.length;Se++)Re[Se].tokens=this.lexer.inline(Re[Se].text);return pe}}},we.lheading=function(X){var Y=this.rules.block.lheading.exec(X);if(Y)return{type:"heading",raw:Y[0],depth:Y[2].charAt(0)==="="?1:2,text:Y[1],tokens:this.lexer.inline(Y[1])}},we.paragraph=function(X){var Y=this.rules.block.paragraph.exec(X);if(Y){var pe=Y[1].charAt(Y[1].length-1)===`
`?Y[1].slice(0,-1):Y[1];return{type:"paragraph",raw:Y[0],text:pe,tokens:this.lexer.inline(pe)}}},we.text=function(X){var Y=this.rules.block.text.exec(X);if(Y)return{type:"text",raw:Y[0],text:Y[0],tokens:this.lexer.inline(Y[0])}},we.escape=function(X){var Y=this.rules.inline.escape.exec(X);if(Y)return{type:"escape",raw:Y[0],text:d(Y[1])}},we.tag=function(X){var Y=this.rules.inline.tag.exec(X);if(Y)return!this.lexer.state.inLink&&/^<a /i.test(Y[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(Y[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(Y[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(Y[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:Y[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(Y[0]):d(Y[0]):Y[0]}},we.link=function(X){var Y=this.rules.inline.link.exec(X);if(Y){var pe=Y[2].trim();if(!this.options.pedantic&&/^</.test(pe)){if(!/>$/.test(pe))return;var $e=C(pe.slice(0,-1),"\\");if((pe.length-$e.length)%2===0)return}else{var Te=P(Y[2],"()");if(Te>-1){var ze=Y[0].indexOf("!")===0?5:4,Se=ze+Y[1].length+Te;Y[2]=Y[2].substring(0,Te),Y[0]=Y[0].substring(0,Se).trim(),Y[3]=""}}var Re=Y[2],Oe="";if(this.options.pedantic){var z=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Re);z&&(Re=z[1],Oe=z[3])}else Oe=Y[3]?Y[3].slice(1,-1):"";return Re=Re.trim(),/^</.test(Re)&&(this.options.pedantic&&!/>$/.test(pe)?Re=Re.slice(1):Re=Re.slice(1,-1)),L(Y,{href:Re&&Re.replace(this.rules.inline._escapes,"$1"),title:Oe&&Oe.replace(this.rules.inline._escapes,"$1")},Y[0],this.lexer)}},we.reflink=function(X,Y){var pe;if((pe=this.rules.inline.reflink.exec(X))||(pe=this.rules.inline.nolink.exec(X))){var $e=(pe[2]||pe[1]).replace(/\s+/g," ");if($e=Y[$e.toLowerCase()],!$e||!$e.href){var Te=pe[0].charAt(0);return{type:"text",raw:Te,text:Te}}return L(pe,$e,pe[0],this.lexer)}},we.emStrong=function(X,Y,pe){pe===void 0&&(pe="");var $e=this.rules.inline.emStrong.lDelim.exec(X);if($e&&!($e[3]&&pe.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var Te=$e[1]||$e[2]||"";if(!Te||Te&&(pe===""||this.rules.inline.punctuation.exec(pe))){var ze=$e[0].length-1,Se,Re,Oe=ze,z=0,U=$e[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(U.lastIndex=0,Y=Y.slice(-1*X.length+ze);($e=U.exec(Y))!=null;)if(Se=$e[1]||$e[2]||$e[3]||$e[4]||$e[5]||$e[6],!!Se){if(Re=Se.length,$e[3]||$e[4]){Oe+=Re;continue}else if(($e[5]||$e[6])&&ze%3&&!((ze+Re)%3)){z+=Re;continue}if(Oe-=Re,!(Oe>0)){if(Re=Math.min(Re,Re+Oe+z),Math.min(ze,Re)%2){var K=X.slice(1,ze+$e.index+Re);return{type:"em",raw:X.slice(0,ze+$e.index+Re+1),text:K,tokens:this.lexer.inlineTokens(K)}}var Q=X.slice(2,ze+$e.index+Re-1);return{type:"strong",raw:X.slice(0,ze+$e.index+Re+1),text:Q,tokens:this.lexer.inlineTokens(Q)}}}}}},we.codespan=function(X){var Y=this.rules.inline.code.exec(X);if(Y){var pe=Y[2].replace(/\n/g," "),$e=/[^ ]/.test(pe),Te=/^ /.test(pe)&&/ $/.test(pe);return $e&&Te&&(pe=pe.substring(1,pe.length-1)),pe=d(pe,!0),{type:"codespan",raw:Y[0],text:pe}}},we.br=function(X){var Y=this.rules.inline.br.exec(X);if(Y)return{type:"br",raw:Y[0]}},we.del=function(X){var Y=this.rules.inline.del.exec(X);if(Y)return{type:"del",raw:Y[0],text:Y[2],tokens:this.lexer.inlineTokens(Y[2])}},we.autolink=function(X,Y){var pe=this.rules.inline.autolink.exec(X);if(pe){var $e,Te;return pe[2]==="@"?($e=d(this.options.mangle?Y(pe[1]):pe[1]),Te="mailto:"+$e):($e=d(pe[1]),Te=$e),{type:"link",raw:pe[0],text:$e,href:Te,tokens:[{type:"text",raw:$e,text:$e}]}}},we.url=function(X,Y){var pe;if(pe=this.rules.inline.url.exec(X)){var $e,Te;if(pe[2]==="@")$e=d(this.options.mangle?Y(pe[0]):pe[0]),Te="mailto:"+$e;else{var ze;do ze=pe[0],pe[0]=this.rules.inline._backpedal.exec(pe[0])[0];while(ze!==pe[0]);$e=d(pe[0]),pe[1]==="www."?Te="http://"+$e:Te=$e}return{type:"link",raw:pe[0],text:$e,href:Te,tokens:[{type:"text",raw:$e,text:$e}]}}},we.inlineText=function(X,Y){var pe=this.rules.inline.text.exec(X);if(pe){var $e;return this.lexer.state.inRawBlock?$e=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(pe[0]):d(pe[0]):pe[0]:$e=d(this.options.smartypants?Y(pe[0]):pe[0]),{type:"text",raw:pe[0],text:$e}}},ae}(),G={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:I,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};G._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,G._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,G.def=h(G.def).replace("label",G._label).replace("title",G._title).getRegex(),G.bullet=/(?:[*+-]|\d{1,9}[.)])/,G.listItemStart=h(/^( *)(bull) */).replace("bull",G.bullet).getRegex(),G.list=h(G.list).replace(/bull/g,G.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+G.def.source+")").getRegex(),G._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",G._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,G.html=h(G.html,"i").replace("comment",G._comment).replace("tag",G._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),G.paragraph=h(G._paragraph).replace("hr",G.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",G._tag).getRegex(),G.blockquote=h(G.blockquote).replace("paragraph",G.paragraph).getRegex(),G.normal=D({},G),G.gfm=D({},G.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),G.gfm.table=h(G.gfm.table).replace("hr",G.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",G._tag).getRegex(),G.gfm.paragraph=h(G._paragraph).replace("hr",G.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",G.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",G._tag).getRegex(),G.pedantic=D({},G.normal,{html:h(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",G._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:I,paragraph:h(G.normal._paragraph).replace("hr",G.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",G.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var W={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:I,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:I,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};W._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",W.punctuation=h(W.punctuation).replace(/punctuation/g,W._punctuation).getRegex(),W.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,W.escapedEmSt=/\\\*|\\_/g,W._comment=h(G._comment).replace("(?:-->|$)","-->").getRegex(),W.emStrong.lDelim=h(W.emStrong.lDelim).replace(/punct/g,W._punctuation).getRegex(),W.emStrong.rDelimAst=h(W.emStrong.rDelimAst,"g").replace(/punct/g,W._punctuation).getRegex(),W.emStrong.rDelimUnd=h(W.emStrong.rDelimUnd,"g").replace(/punct/g,W._punctuation).getRegex(),W._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,W._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,W._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,W.autolink=h(W.autolink).replace("scheme",W._scheme).replace("email",W._email).getRegex(),W._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,W.tag=h(W.tag).replace("comment",W._comment).replace("attribute",W._attribute).getRegex(),W._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,W._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,W._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,W.link=h(W.link).replace("label",W._label).replace("href",W._href).replace("title",W._title).getRegex(),W.reflink=h(W.reflink).replace("label",W._label).replace("ref",G._label).getRegex(),W.nolink=h(W.nolink).replace("ref",G._label).getRegex(),W.reflinkSearch=h(W.reflinkSearch,"g").replace("reflink",W.reflink).replace("nolink",W.nolink).getRegex(),W.normal=D({},W),W.pedantic=D({},W.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:h(/^!?\[(label)\]\((.*?)\)/).replace("label",W._label).getRegex(),reflink:h(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",W._label).getRegex()}),W.gfm=D({},W.normal,{escape:h(W.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),W.gfm.url=h(W.gfm.url,"i").replace("email",W.gfm._extended_email).getRegex(),W.breaks=D({},W.gfm,{br:h(W.br).replace("{2,}","*").getRegex(),text:h(W.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function F(ae){return ae.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function q(ae){var we="",he,X,Y=ae.length;for(he=0;he<Y;he++)X=ae.charCodeAt(he),Math.random()>.5&&(X="x"+X.toString(16)),we+="&#"+X+";";return we}var ue=function(){function ae(he){this.tokens=[],this.tokens.links=Object.create(null),this.options=he||oe.defaults,this.options.tokenizer=this.options.tokenizer||new B,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var X={block:G.normal,inline:W.normal};this.options.pedantic?(X.block=G.pedantic,X.inline=W.pedantic):this.options.gfm&&(X.block=G.gfm,this.options.breaks?X.inline=W.breaks:X.inline=W.gfm),this.tokenizer.rules=X}ae.lex=function(X,Y){var pe=new ae(Y);return pe.lex(X)},ae.lexInline=function(X,Y){var pe=new ae(Y);return pe.inlineTokens(X)};var we=ae.prototype;return we.lex=function(X){X=X.replace(/\r\n|\r/g,`
`),this.blockTokens(X,this.tokens);for(var Y;Y=this.inlineQueue.shift();)this.inlineTokens(Y.src,Y.tokens);return this.tokens},we.blockTokens=function(X,Y){var pe=this;Y===void 0&&(Y=[]),this.options.pedantic?X=X.replace(/\t/g,"    ").replace(/^ +$/gm,""):X=X.replace(/^( *)(\t+)/gm,function(Oe,z,U){return z+"    ".repeat(U.length)});for(var $e,Te,ze,Se;X;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(Oe){return($e=Oe.call({lexer:pe},X,Y))?(X=X.substring($e.raw.length),Y.push($e),!0):!1}))){if($e=this.tokenizer.space(X)){X=X.substring($e.raw.length),$e.raw.length===1&&Y.length>0?Y[Y.length-1].raw+=`
`:Y.push($e);continue}if($e=this.tokenizer.code(X)){X=X.substring($e.raw.length),Te=Y[Y.length-1],Te&&(Te.type==="paragraph"||Te.type==="text")?(Te.raw+=`
`+$e.raw,Te.text+=`
`+$e.text,this.inlineQueue[this.inlineQueue.length-1].src=Te.text):Y.push($e);continue}if($e=this.tokenizer.fences(X)){X=X.substring($e.raw.length),Y.push($e);continue}if($e=this.tokenizer.heading(X)){X=X.substring($e.raw.length),Y.push($e);continue}if($e=this.tokenizer.hr(X)){X=X.substring($e.raw.length),Y.push($e);continue}if($e=this.tokenizer.blockquote(X)){X=X.substring($e.raw.length),Y.push($e);continue}if($e=this.tokenizer.list(X)){X=X.substring($e.raw.length),Y.push($e);continue}if($e=this.tokenizer.html(X)){X=X.substring($e.raw.length),Y.push($e);continue}if($e=this.tokenizer.def(X)){X=X.substring($e.raw.length),Te=Y[Y.length-1],Te&&(Te.type==="paragraph"||Te.type==="text")?(Te.raw+=`
`+$e.raw,Te.text+=`
`+$e.raw,this.inlineQueue[this.inlineQueue.length-1].src=Te.text):this.tokens.links[$e.tag]||(this.tokens.links[$e.tag]={href:$e.href,title:$e.title});continue}if($e=this.tokenizer.table(X)){X=X.substring($e.raw.length),Y.push($e);continue}if($e=this.tokenizer.lheading(X)){X=X.substring($e.raw.length),Y.push($e);continue}if(ze=X,this.options.extensions&&this.options.extensions.startBlock&&function(){var Oe=1/0,z=X.slice(1),U=void 0;pe.options.extensions.startBlock.forEach(function(K){U=K.call({lexer:this},z),typeof U=="number"&&U>=0&&(Oe=Math.min(Oe,U))}),Oe<1/0&&Oe>=0&&(ze=X.substring(0,Oe+1))}(),this.state.top&&($e=this.tokenizer.paragraph(ze))){Te=Y[Y.length-1],Se&&Te.type==="paragraph"?(Te.raw+=`
`+$e.raw,Te.text+=`
`+$e.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Te.text):Y.push($e),Se=ze.length!==X.length,X=X.substring($e.raw.length);continue}if($e=this.tokenizer.text(X)){X=X.substring($e.raw.length),Te=Y[Y.length-1],Te&&Te.type==="text"?(Te.raw+=`
`+$e.raw,Te.text+=`
`+$e.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Te.text):Y.push($e);continue}if(X){var Re="Infinite loop on byte: "+X.charCodeAt(0);if(this.options.silent){console.error(Re);break}else throw new Error(Re)}}return this.state.top=!0,Y},we.inline=function(X,Y){return Y===void 0&&(Y=[]),this.inlineQueue.push({src:X,tokens:Y}),Y},we.inlineTokens=function(X,Y){var pe=this;Y===void 0&&(Y=[]);var $e,Te,ze,Se=X,Re,Oe,z;if(this.tokens.links){var U=Object.keys(this.tokens.links);if(U.length>0)for(;(Re=this.tokenizer.rules.inline.reflinkSearch.exec(Se))!=null;)U.includes(Re[0].slice(Re[0].lastIndexOf("[")+1,-1))&&(Se=Se.slice(0,Re.index)+"["+b("a",Re[0].length-2)+"]"+Se.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Re=this.tokenizer.rules.inline.blockSkip.exec(Se))!=null;)Se=Se.slice(0,Re.index)+"["+b("a",Re[0].length-2)+"]"+Se.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Re=this.tokenizer.rules.inline.escapedEmSt.exec(Se))!=null;)Se=Se.slice(0,Re.index)+"++"+Se.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;X;)if(Oe||(z=""),Oe=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(Q){return($e=Q.call({lexer:pe},X,Y))?(X=X.substring($e.raw.length),Y.push($e),!0):!1}))){if($e=this.tokenizer.escape(X)){X=X.substring($e.raw.length),Y.push($e);continue}if($e=this.tokenizer.tag(X)){X=X.substring($e.raw.length),Te=Y[Y.length-1],Te&&$e.type==="text"&&Te.type==="text"?(Te.raw+=$e.raw,Te.text+=$e.text):Y.push($e);continue}if($e=this.tokenizer.link(X)){X=X.substring($e.raw.length),Y.push($e);continue}if($e=this.tokenizer.reflink(X,this.tokens.links)){X=X.substring($e.raw.length),Te=Y[Y.length-1],Te&&$e.type==="text"&&Te.type==="text"?(Te.raw+=$e.raw,Te.text+=$e.text):Y.push($e);continue}if($e=this.tokenizer.emStrong(X,Se,z)){X=X.substring($e.raw.length),Y.push($e);continue}if($e=this.tokenizer.codespan(X)){X=X.substring($e.raw.length),Y.push($e);continue}if($e=this.tokenizer.br(X)){X=X.substring($e.raw.length),Y.push($e);continue}if($e=this.tokenizer.del(X)){X=X.substring($e.raw.length),Y.push($e);continue}if($e=this.tokenizer.autolink(X,q)){X=X.substring($e.raw.length),Y.push($e);continue}if(!this.state.inLink&&($e=this.tokenizer.url(X,q))){X=X.substring($e.raw.length),Y.push($e);continue}if(ze=X,this.options.extensions&&this.options.extensions.startInline&&function(){var Q=1/0,ne=X.slice(1),fe=void 0;pe.options.extensions.startInline.forEach(function(Ae){fe=Ae.call({lexer:this},ne),typeof fe=="number"&&fe>=0&&(Q=Math.min(Q,fe))}),Q<1/0&&Q>=0&&(ze=X.substring(0,Q+1))}(),$e=this.tokenizer.inlineText(ze,F)){X=X.substring($e.raw.length),$e.raw.slice(-1)!=="_"&&(z=$e.raw.slice(-1)),Oe=!0,Te=Y[Y.length-1],Te&&Te.type==="text"?(Te.raw+=$e.raw,Te.text+=$e.text):Y.push($e);continue}if(X){var K="Infinite loop on byte: "+X.charCodeAt(0);if(this.options.silent){console.error(K);break}else throw new Error(K)}}return Y},w(ae,null,[{key:"rules",get:function(){return{block:G,inline:W}}}]),ae}(),ge=function(){function ae(he){this.options=he||oe.defaults}var we=ae.prototype;return we.code=function(X,Y,pe){var $e=(Y||"").match(/\S*/)[0];if(this.options.highlight){var Te=this.options.highlight(X,$e);Te!=null&&Te!==X&&(pe=!0,X=Te)}return X=X.replace(/\n$/,"")+`
`,$e?'<pre><code class="'+this.options.langPrefix+d($e,!0)+'">'+(pe?X:d(X,!0))+`</code></pre>
`:"<pre><code>"+(pe?X:d(X,!0))+`</code></pre>
`},we.blockquote=function(X){return`<blockquote>
`+X+`</blockquote>
`},we.html=function(X){return X},we.heading=function(X,Y,pe,$e){if(this.options.headerIds){var Te=this.options.headerPrefix+$e.slug(pe);return"<h"+Y+' id="'+Te+'">'+X+"</h"+Y+`>
`}return"<h"+Y+">"+X+"</h"+Y+`>
`},we.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},we.list=function(X,Y,pe){var $e=Y?"ol":"ul",Te=Y&&pe!==1?' start="'+pe+'"':"";return"<"+$e+Te+`>
`+X+"</"+$e+`>
`},we.listitem=function(X){return"<li>"+X+`</li>
`},we.checkbox=function(X){return"<input "+(X?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},we.paragraph=function(X){return"<p>"+X+`</p>
`},we.table=function(X,Y){return Y&&(Y="<tbody>"+Y+"</tbody>"),`<table>
<thead>
`+X+`</thead>
`+Y+`</table>
`},we.tablerow=function(X){return`<tr>
`+X+`</tr>
`},we.tablecell=function(X,Y){var pe=Y.header?"th":"td",$e=Y.align?"<"+pe+' align="'+Y.align+'">':"<"+pe+">";return $e+X+("</"+pe+`>
`)},we.strong=function(X){return"<strong>"+X+"</strong>"},we.em=function(X){return"<em>"+X+"</em>"},we.codespan=function(X){return"<code>"+X+"</code>"},we.br=function(){return this.options.xhtml?"<br/>":"<br>"},we.del=function(X){return"<del>"+X+"</del>"},we.link=function(X,Y,pe){if(X=t(this.options.sanitize,this.options.baseUrl,X),X===null)return pe;var $e='<a href="'+d(X)+'"';return Y&&($e+=' title="'+Y+'"'),$e+=">"+pe+"</a>",$e},we.image=function(X,Y,pe){if(X=t(this.options.sanitize,this.options.baseUrl,X),X===null)return pe;var $e='<img src="'+X+'" alt="'+pe+'"';return Y&&($e+=' title="'+Y+'"'),$e+=this.options.xhtml?"/>":">",$e},we.text=function(X){return X},ae}(),te=function(){function ae(){}var we=ae.prototype;return we.strong=function(X){return X},we.em=function(X){return X},we.codespan=function(X){return X},we.del=function(X){return X},we.html=function(X){return X},we.text=function(X){return X},we.link=function(X,Y,pe){return""+pe},we.image=function(X,Y,pe){return""+pe},we.br=function(){return""},ae}(),me=function(){function ae(){this.seen={}}var we=ae.prototype;return we.serialize=function(X){return X.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},we.getNextSafeSlug=function(X,Y){var pe=X,$e=0;if(this.seen.hasOwnProperty(pe)){$e=this.seen[X];do $e++,pe=X+"-"+$e;while(this.seen.hasOwnProperty(pe))}return Y||(this.seen[X]=$e,this.seen[pe]=0),pe},we.slug=function(X,Y){Y===void 0&&(Y={});var pe=this.serialize(X);return this.getNextSafeSlug(pe,Y.dryrun)},ae}(),re=function(){function ae(he){this.options=he||oe.defaults,this.options.renderer=this.options.renderer||new ge,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new te,this.slugger=new me}ae.parse=function(X,Y){var pe=new ae(Y);return pe.parse(X)},ae.parseInline=function(X,Y){var pe=new ae(Y);return pe.parseInline(X)};var we=ae.prototype;return we.parse=function(X,Y){Y===void 0&&(Y=!0);var pe="",$e,Te,ze,Se,Re,Oe,z,U,K,Q,ne,fe,Ae,je,Ke,_e,it,nt,tt,rt=X.length;for($e=0;$e<rt;$e++){if(Q=X[$e],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Q.type]&&(tt=this.options.extensions.renderers[Q.type].call({parser:this},Q),tt!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(Q.type))){pe+=tt||"";continue}switch(Q.type){case"space":continue;case"hr":{pe+=this.renderer.hr();continue}case"heading":{pe+=this.renderer.heading(this.parseInline(Q.tokens),Q.depth,s(this.parseInline(Q.tokens,this.textRenderer)),this.slugger);continue}case"code":{pe+=this.renderer.code(Q.text,Q.lang,Q.escaped);continue}case"table":{for(U="",z="",Se=Q.header.length,Te=0;Te<Se;Te++)z+=this.renderer.tablecell(this.parseInline(Q.header[Te].tokens),{header:!0,align:Q.align[Te]});for(U+=this.renderer.tablerow(z),K="",Se=Q.rows.length,Te=0;Te<Se;Te++){for(Oe=Q.rows[Te],z="",Re=Oe.length,ze=0;ze<Re;ze++)z+=this.renderer.tablecell(this.parseInline(Oe[ze].tokens),{header:!1,align:Q.align[ze]});K+=this.renderer.tablerow(z)}pe+=this.renderer.table(U,K);continue}case"blockquote":{K=this.parse(Q.tokens),pe+=this.renderer.blockquote(K);continue}case"list":{for(ne=Q.ordered,fe=Q.start,Ae=Q.loose,Se=Q.items.length,K="",Te=0;Te<Se;Te++)Ke=Q.items[Te],_e=Ke.checked,it=Ke.task,je="",Ke.task&&(nt=this.renderer.checkbox(_e),Ae?Ke.tokens.length>0&&Ke.tokens[0].type==="paragraph"?(Ke.tokens[0].text=nt+" "+Ke.tokens[0].text,Ke.tokens[0].tokens&&Ke.tokens[0].tokens.length>0&&Ke.tokens[0].tokens[0].type==="text"&&(Ke.tokens[0].tokens[0].text=nt+" "+Ke.tokens[0].tokens[0].text)):Ke.tokens.unshift({type:"text",text:nt}):je+=nt),je+=this.parse(Ke.tokens,Ae),K+=this.renderer.listitem(je,it,_e);pe+=this.renderer.list(K,ne,fe);continue}case"html":{pe+=this.renderer.html(Q.text);continue}case"paragraph":{pe+=this.renderer.paragraph(this.parseInline(Q.tokens));continue}case"text":{for(K=Q.tokens?this.parseInline(Q.tokens):Q.text;$e+1<rt&&X[$e+1].type==="text";)Q=X[++$e],K+=`
`+(Q.tokens?this.parseInline(Q.tokens):Q.text);pe+=Y?this.renderer.paragraph(K):K;continue}default:{var $t='Token with "'+Q.type+'" type was not found.';if(this.options.silent){console.error($t);return}else throw new Error($t)}}}return pe},we.parseInline=function(X,Y){Y=Y||this.renderer;var pe="",$e,Te,ze,Se=X.length;for($e=0;$e<Se;$e++){if(Te=X[$e],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Te.type]&&(ze=this.options.extensions.renderers[Te.type].call({parser:this},Te),ze!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(Te.type))){pe+=ze||"";continue}switch(Te.type){case"escape":{pe+=Y.text(Te.text);break}case"html":{pe+=Y.html(Te.text);break}case"link":{pe+=Y.link(Te.href,Te.title,this.parseInline(Te.tokens,Y));break}case"image":{pe+=Y.image(Te.href,Te.title,Te.text);break}case"strong":{pe+=Y.strong(this.parseInline(Te.tokens,Y));break}case"em":{pe+=Y.em(this.parseInline(Te.tokens,Y));break}case"codespan":{pe+=Y.codespan(Te.text);break}case"br":{pe+=Y.br();break}case"del":{pe+=Y.del(this.parseInline(Te.tokens,Y));break}case"text":{pe+=Y.text(Te.text);break}default:{var Re='Token with "'+Te.type+'" type was not found.';if(this.options.silent){console.error(Re);return}else throw new Error(Re)}}}return pe},ae}();function ce(ae,we,he){if(typeof ae>"u"||ae===null)throw new Error("marked(): input parameter is undefined or null");if(typeof ae!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(ae)+", string expected");if(typeof we=="function"&&(he=we,we=null),we=D({},ce.defaults,we||{}),g(we),he){var X=we.highlight,Y;try{Y=ue.lex(ae,we)}catch(Se){return he(Se)}var pe=function(Re){var Oe;if(!Re)try{we.walkTokens&&ce.walkTokens(Y,we.walkTokens),Oe=re.parse(Y,we)}catch(z){Re=z}return we.highlight=X,Re?he(Re):he(null,Oe)};if(!X||X.length<3||(delete we.highlight,!Y.length))return pe();var $e=0;ce.walkTokens(Y,function(Se){Se.type==="code"&&($e++,setTimeout(function(){X(Se.text,Se.lang,function(Re,Oe){if(Re)return pe(Re);Oe!=null&&Oe!==Se.text&&(Se.text=Oe,Se.escaped=!0),$e--,$e===0&&pe()})},0))}),$e===0&&pe();return}function Te(Se){if(Se.message+=`
Please report this to https://github.com/markedjs/marked.`,we.silent)return"<p>An error occurred:</p><pre>"+d(Se.message+"",!0)+"</pre>";throw Se}try{var ze=ue.lex(ae,we);if(we.walkTokens){if(we.async)return Promise.all(ce.walkTokens(ze,we.walkTokens)).then(function(){return re.parse(ze,we)}).catch(Te);ce.walkTokens(ze,we.walkTokens)}return re.parse(ze,we)}catch(Se){Te(Se)}}ce.options=ce.setOptions=function(ae){return D(ce.defaults,ae),T(ce.defaults),ce},ce.getDefaults=A,ce.defaults=oe.defaults,ce.use=function(){for(var ae=arguments.length,we=new Array(ae),he=0;he<ae;he++)we[he]=arguments[he];var X=D.apply(void 0,[{}].concat(we)),Y=ce.defaults.extensions||{renderers:{},childTokens:{}},pe;we.forEach(function($e){if($e.extensions&&(pe=!0,$e.extensions.forEach(function(ze){if(!ze.name)throw new Error("extension name required");if(ze.renderer){var Se=Y.renderers?Y.renderers[ze.name]:null;Se?Y.renderers[ze.name]=function(){for(var Re=arguments.length,Oe=new Array(Re),z=0;z<Re;z++)Oe[z]=arguments[z];var U=ze.renderer.apply(this,Oe);return U===!1&&(U=Se.apply(this,Oe)),U}:Y.renderers[ze.name]=ze.renderer}if(ze.tokenizer){if(!ze.level||ze.level!=="block"&&ze.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");Y[ze.level]?Y[ze.level].unshift(ze.tokenizer):Y[ze.level]=[ze.tokenizer],ze.start&&(ze.level==="block"?Y.startBlock?Y.startBlock.push(ze.start):Y.startBlock=[ze.start]:ze.level==="inline"&&(Y.startInline?Y.startInline.push(ze.start):Y.startInline=[ze.start]))}ze.childTokens&&(Y.childTokens[ze.name]=ze.childTokens)})),$e.renderer&&function(){var ze=ce.defaults.renderer||new ge,Se=function(z){var U=ze[z];ze[z]=function(){for(var K=arguments.length,Q=new Array(K),ne=0;ne<K;ne++)Q[ne]=arguments[ne];var fe=$e.renderer[z].apply(ze,Q);return fe===!1&&(fe=U.apply(ze,Q)),fe}};for(var Re in $e.renderer)Se(Re);X.renderer=ze}(),$e.tokenizer&&function(){var ze=ce.defaults.tokenizer||new B,Se=function(z){var U=ze[z];ze[z]=function(){for(var K=arguments.length,Q=new Array(K),ne=0;ne<K;ne++)Q[ne]=arguments[ne];var fe=$e.tokenizer[z].apply(ze,Q);return fe===!1&&(fe=U.apply(ze,Q)),fe}};for(var Re in $e.tokenizer)Se(Re);X.tokenizer=ze}(),$e.walkTokens){var Te=ce.defaults.walkTokens;X.walkTokens=function(ze){var Se=[];return Se.push($e.walkTokens.call(this,ze)),Te&&(Se=Se.concat(Te.call(this,ze))),Se}}pe&&(X.extensions=Y),ce.setOptions(X)})},ce.walkTokens=function(ae,we){for(var he=[],X=function(){var Te=pe.value;switch(he=he.concat(we.call(ce,Te)),Te.type){case"table":{for(var ze=O(Te.header),Se;!(Se=ze()).done;){var Re=Se.value;he=he.concat(ce.walkTokens(Re.tokens,we))}for(var Oe=O(Te.rows),z;!(z=Oe()).done;)for(var U=z.value,K=O(U),Q;!(Q=K()).done;){var ne=Q.value;he=he.concat(ce.walkTokens(ne.tokens,we))}break}case"list":{he=he.concat(ce.walkTokens(Te.items,we));break}default:ce.defaults.extensions&&ce.defaults.extensions.childTokens&&ce.defaults.extensions.childTokens[Te.type]?ce.defaults.extensions.childTokens[Te.type].forEach(function(fe){he=he.concat(ce.walkTokens(Te[fe],we))}):Te.tokens&&(he=he.concat(ce.walkTokens(Te.tokens,we)))}},Y=O(ae),pe;!(pe=Y()).done;)X();return he},ce.parseInline=function(ae,we){if(typeof ae>"u"||ae===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof ae!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(ae)+", string expected");we=D({},ce.defaults,we||{}),g(we);try{var he=ue.lexInline(ae,we);return we.walkTokens&&ce.walkTokens(he,we.walkTokens),re.parseInline(he,we)}catch(X){if(X.message+=`
Please report this to https://github.com/markedjs/marked.`,we.silent)return"<p>An error occurred:</p><pre>"+d(X.message+"",!0)+"</pre>";throw X}},ce.Parser=re,ce.parser=re.parse,ce.Renderer=ge,ce.TextRenderer=te,ce.Lexer=ue,ce.lexer=ue.lex,ce.Tokenizer=B,ce.Slugger=me,ce.parse=ce;var be=ce.options,se=ce.setOptions,Ie=ce.use,Ue=ce.walkTokens,Z=ce.parseInline,V=ce,_=re.parse,ye=ue.lex;oe.Lexer=ue,oe.Parser=re,oe.Renderer=ge,oe.Slugger=me,oe.TextRenderer=te,oe.Tokenizer=B,oe.getDefaults=A,oe.lexer=ye,oe.marked=ce,oe.options=be,oe.parse=V,oe.parseInline=Z,oe.parser=_,oe.setOptions=se,oe.use=Ie,oe.walkTokens=Ue,Object.defineProperty(oe,"__esModule",{value:!0})}),define(ke[137],Ce([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ek=w;function w(n){const s=O(n);if(s&&s.length>0)return new Uint32Array(s)}let S=0;const k=new Uint32Array(10);function O(n){if(S=0,A(n,y,p.InitialConsonant),S>0||(A(n,u,p.Vowel),S>0)||(A(n,E,p.FinalConsonant),S>0)||(A(n,d,p.CompatibilityJamo),S))return k.subarray(0,S);if(n>=44032&&n<=55203){const s=n-44032,o=s%588,h=Math.floor(s/588),i=Math.floor(o/28),r=o%28-1;if(h<y.length?A(h,y,0):p.InitialConsonant+h-p.CompatibilityJamo<d.length&&A(p.InitialConsonant+h,d,p.CompatibilityJamo),i<u.length?A(i,u,0):p.Vowel+i-p.CompatibilityJamo<d.length&&A(p.Vowel+i-p.CompatibilityJamo,d,p.CompatibilityJamo),r>=0&&(r<E.length?A(r,E,0):p.FinalConsonant+r-p.CompatibilityJamo<d.length&&A(p.FinalConsonant+r-p.CompatibilityJamo,d,p.CompatibilityJamo)),S>0)return k.subarray(0,S)}}function A(n,s,o){n>=o&&n<o+s.length&&T(s[n-o])}function T(n){n!==a.NUL&&(k[S++]=n&255,n>>8&&(k[S++]=n>>8&255),n>>16&&(k[S++]=n>>16&255))}var p;(function(n){n[n.InitialConsonant=4352]="InitialConsonant",n[n.Vowel=4449]="Vowel",n[n.FinalConsonant=4520]="FinalConsonant",n[n.CompatibilityJamo=12593]="CompatibilityJamo"})(p||(p={}));var a;(function(n){n[n.NUL=0]="NUL",n[n.A=65]="A",n[n.B=66]="B",n[n.C=67]="C",n[n.D=68]="D",n[n.E=69]="E",n[n.F=70]="F",n[n.G=71]="G",n[n.H=72]="H",n[n.I=73]="I",n[n.J=74]="J",n[n.K=75]="K",n[n.L=76]="L",n[n.M=77]="M",n[n.N=78]="N",n[n.O=79]="O",n[n.P=80]="P",n[n.Q=81]="Q",n[n.R=82]="R",n[n.S=83]="S",n[n.T=84]="T",n[n.U=85]="U",n[n.V=86]="V",n[n.W=87]="W",n[n.X=88]="X",n[n.Y=89]="Y",n[n.Z=90]="Z",n[n.a=97]="a",n[n.b=98]="b",n[n.c=99]="c",n[n.d=100]="d",n[n.e=101]="e",n[n.f=102]="f",n[n.g=103]="g",n[n.h=104]="h",n[n.i=105]="i",n[n.j=106]="j",n[n.k=107]="k",n[n.l=108]="l",n[n.m=109]="m",n[n.n=110]="n",n[n.o=111]="o",n[n.p=112]="p",n[n.q=113]="q",n[n.r=114]="r",n[n.s=115]="s",n[n.t=116]="t",n[n.u=117]="u",n[n.v=118]="v",n[n.w=119]="w",n[n.x=120]="x",n[n.y=121]="y",n[n.z=122]="z"})(a||(a={}));var R;(function(n){n[n.fa=24934]="fa",n[n.fg=26470]="fg",n[n.fq=29030]="fq",n[n.fr=29286]="fr",n[n.ft=29798]="ft",n[n.fv=30310]="fv",n[n.fx=30822]="fx",n[n.hk=27496]="hk",n[n.hl=27752]="hl",n[n.ho=28520]="ho",n[n.ml=27757]="ml",n[n.nj=27246]="nj",n[n.nl=27758]="nl",n[n.np=28782]="np",n[n.qt=29809]="qt",n[n.rt=29810]="rt",n[n.sg=26483]="sg",n[n.sw=30579]="sw"})(R||(R={}));const y=new Uint8Array([a.r,a.R,a.s,a.e,a.E,a.f,a.a,a.q,a.Q,a.t,a.T,a.d,a.w,a.W,a.c,a.z,a.x,a.v,a.g]),u=new Uint16Array([a.k,a.o,a.i,a.O,a.j,a.p,a.u,a.P,a.h,R.hk,R.ho,R.hl,a.y,a.n,R.nj,R.np,R.nl,a.b,a.m,R.ml,a.l]),E=new Uint16Array([a.r,a.R,R.rt,a.s,R.sw,R.sg,a.e,a.f,R.fr,R.fa,R.fq,R.ft,R.fx,R.fv,R.fg,a.a,a.q,R.qt,a.t,a.T,a.d,a.w,a.c,a.z,a.x,a.v,a.g]),d=new Uint16Array([a.r,a.R,R.rt,a.s,R.sw,R.sg,a.e,a.E,a.f,R.fr,R.fa,R.fq,R.ft,R.fx,R.fv,R.fg,a.a,a.q,a.Q,R.qt,a.t,a.T,a.d,a.w,a.W,a.c,a.z,a.x,a.v,a.g,a.k,a.o,a.i,a.O,a.j,a.p,a.u,a.P,a.h,R.hk,R.ho,R.hl,a.y,a.n,R.nj,R.np,R.nl,a.b,a.m,R.ml,a.l])}),define(ke[138],Ce([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Om=e.$Nm=e.$Mm=void 0,e.$Km=w,e.rot=S,e.$Pm=T;function w(p,a,R){return Math.min(Math.max(p,a),R)}function S(p,a){return(a+p%a)%a}class k{constructor(){this.a=0}getNext(){return this.a++}}e.$Mm=k;class O{constructor(){this.a=1,this.b=0}update(a){return this.b=this.b+(a-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$Nm=O;class A{constructor(a){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(a),this.c.fill(0,0,a)}update(a){const R=this.c[this.d];return this.c[this.d]=a,this.d=(this.d+1)%this.c.length,this.e-=R,this.e+=a,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$Om=A;function T(p,a,R,y,u,E,d,n){const s=d-R,o=n-y,h=u-R,i=E-y,r=p-R,t=a-y,c=s*s+o*o,l=s*h+o*i,m=s*r+o*t,f=h*h+i*i,$=h*r+i*t,I=1/(c*f-l*l),D=(f*m-l*$)*I,v=(c*$-l*m)*I;return D>=0&&v>=0&&D+v<1}}),define(ke[139],Ce([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cd=void 0,e.$dd=O,e.$ed=u;class w{constructor(d,n,s){this.owner=d,this.debugNameSource=n,this.referenceFn=s}getDebugName(d){return O(d,this)}}e.$cd=w;const S=new Map,k=new WeakMap;function O(E,d){const n=k.get(E);if(n)return n;const s=A(E,d);if(s){let o=S.get(s)??0;o++,S.set(s,o);const h=o===1?s:`${s}#${o}`;return k.set(E,h),h}}function A(E,d){const n=k.get(E);if(n)return n;const s=d.owner?R(d.owner)+".":"";let o;const h=d.debugNameSource;if(h!==void 0)if(typeof h=="function"){if(o=h(),o!==void 0)return s+o}else return s+h;const i=d.referenceFn;if(i!==void 0&&(o=u(i),o!==void 0))return s+o;if(d.owner!==void 0){const r=T(d.owner,E);if(r!==void 0)return s+r}}function T(E,d){for(const n in E)if(E[n]===d)return n}const p=new Map,a=new WeakMap;function R(E){const d=a.get(E);if(d)return d;const n=y(E);let s=p.get(n)??0;s++,p.set(n,s);const o=s===1?n:`${n}#${s}`;return a.set(E,o),o}function y(E){const d=E.constructor;return d?d.name:"Object"}function u(E){const d=E.toString(),s=/\/\*\*\s*@description\s*([^*]*)\*\//.exec(d);return(s?s[1]:void 0)?.trim()}}),define(ke[140],Ce([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nd=void 0,e.$Ld=S,e.$Md=k;let w;function S(n){w=n}function k(){return w}class O{constructor(){this.a=0,this.d=new WeakMap}b(s){return A([T(E("|  ",this.a)),s])}c(s){return s.hadValue?s.didChange?[T(" "),a(R(s.oldValue,70),{color:"red",strikeThrough:!0}),T(" "),a(R(s.newValue,60),{color:"green"})]:[T(" (unchanged)")]:[T(" "),a(R(s.newValue,60),{color:"green"}),T(" (initial)")]}handleObservableChanged(s,o){console.log(...this.b([p("observable value changed"),a(s.debugName,{color:"BlueViolet"}),...this.c(o)]))}formatChanges(s){if(s.size!==0)return a(" (changed deps: "+[...s].map(o=>o.debugName).join(", ")+")",{color:"gray"})}handleDerivedCreated(s){const o=s.handleChange;this.d.set(s,new Set),s.handleChange=(h,i)=>(this.d.get(s).add(h),o.apply(s,[h,i]))}handleDerivedRecomputed(s,o){const h=this.d.get(s);console.log(...this.b([p("derived recomputed"),a(s.debugName,{color:"BlueViolet"}),...this.c(o),this.formatChanges(h),{data:[{fn:s._debugNameData.referenceFn??s._computeFn}]}])),h.clear()}handleFromEventObservableTriggered(s,o){console.log(...this.b([p("observable from event triggered"),a(s.debugName,{color:"BlueViolet"}),...this.c(o),{data:[{fn:s._getValue}]}]))}handleAutorunCreated(s){const o=s.handleChange;this.d.set(s,new Set),s.handleChange=(h,i)=>(this.d.get(s).add(h),o.apply(s,[h,i]))}handleAutorunTriggered(s){const o=this.d.get(s);console.log(...this.b([p("autorun"),a(s.debugName,{color:"BlueViolet"}),this.formatChanges(o),{data:[{fn:s._debugNameData.referenceFn??s._runFn}]}])),o.clear(),this.a++}handleAutorunFinished(s){this.a--}handleBeginTransaction(s){let o=s.getDebugName();o===void 0&&(o=""),console.log(...this.b([p("transaction"),a(o,{color:"BlueViolet"}),{data:[{fn:s._fn}]}])),this.a++}handleEndTransaction(){this.a--}}e.$Nd=O;function A(n){const s=new Array,o=[];let h="";function i(t){if("length"in t)for(const c of t)c&&i(c);else"text"in t?(h+=`%c${t.text}`,s.push(t.style),t.data&&o.push(...t.data)):"data"in t&&o.push(...t.data)}i(n);const r=[h,...s];return r.push(...o),r}function T(n){return a(n,{color:"black"})}function p(n){return a(d(`${n}: `,10),{color:"black",bold:!0})}function a(n,s={color:"black"}){function o(i){return Object.entries(i).reduce((r,[t,c])=>`${r}${t}:${c};`,"")}const h={color:s.color};return s.strikeThrough&&(h["text-decoration"]="line-through"),s.bold&&(h["font-weight"]="bold"),{text:n,style:o(h)}}function R(n,s){switch(typeof n){case"number":return""+n;case"string":return n.length+2<=s?`"${n}"`:`"${n.substr(0,s-7)}"+...`;case"boolean":return n?"true":"false";case"undefined":return"undefined";case"object":return n===null?"null":Array.isArray(n)?y(n,s):u(n,s);case"symbol":return n.toString();case"function":return`[[Function${n.name?" "+n.name:""}]]`;default:return""+n}}function y(n,s){let o="[ ",h=!0;for(const i of n){if(h||(o+=", "),o.length-5>s){o+="...";break}h=!1,o+=`${R(i,s-o.length)}`}return o+=" ]",o}function u(n,s){let o="{ ",h=!0;for(const[i,r]of Object.entries(n)){if(h||(o+=", "),o.length-5>s){o+="...";break}h=!1,o+=`${i}: ${R(r,s-o.length)}`}return o+=" }",o}function E(n,s){let o="";for(let h=1;h<=s;h++)o+=n;return o}function d(n,s){for(;n.length<s;)n+=" ";return n}}),define(ke[141],Ce([1,0,134,139,140]),function(oe,e,w,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0d=e.$8d=e.$6d=e.$1d=e.$Zd=void 0,e.$Wd=A,e.$Xd=p,e.$Yd=R,e.$2d=E,e.$3d=n,e.$4d=s,e.$5d=o,e.$7d=i,e.$9d=t;let O;function A(l){O=l}let T;function p(l){T=l}let a;function R(l){a=l}class y{get TChange(){return null}reportChanges(){this.get()}read(m){return m?m.readObservable(this):this.get()}map(m,f){const $=f===void 0?void 0:m,I=f===void 0?m:f;return a({owner:$,debugName:()=>{const D=(0,S.$ed)(I);if(D!==void 0)return D;const C=/^\s*\(?\s*([a-zA-Z_$][a-zA-Z_$0-9]*)\s*\)?\s*=>\s*\1(?:\??)\.([a-zA-Z_$][a-zA-Z_$0-9]*)\s*$/.exec(I.toString());if(C)return`${this.debugName}.${C[2]}`;if(!$)return`${this.debugName} (mapped)`},debugReferenceFn:I},D=>I(this.read(D),D))}recomputeInitiallyAndOnChange(m,f){return m.add(O(this,f)),this}keepObserved(m){return m.add(T(this)),this}get a(){return this.get()}}e.$Zd=y;class u extends y{constructor(){super(...arguments),this.b=new Set}addObserver(m){const f=this.b.size;this.b.add(m),f===0&&this.c()}removeObserver(m){this.b.delete(m)&&this.b.size===0&&this.f()}c(){}f(){}}e.$1d=u;function E(l,m){const f=new h(l,m);try{l(f)}finally{f.finish()}}let d;function n(l){if(d)l(d);else{const m=new h(l,void 0);d=m;try{l(m)}finally{m.finish(),d=void 0}}}async function s(l,m){const f=new h(l,m);try{await l(f)}finally{f.finish()}}function o(l,m,f){l?m(l):E(m,f)}class h{constructor(m,f){this._fn=m,this.b=f,this.a=[],(0,k.$Md)()?.handleBeginTransaction(this)}getDebugName(){return this.b?this.b():(0,S.$ed)(this._fn)}updateObserver(m,f){this.a.push({observer:m,observable:f}),m.beginUpdate(f)}finish(){const m=this.a;for(let f=0;f<m.length;f++){const{observer:$,observable:I}=m[f];$.endUpdate(I)}this.a=null,(0,k.$Md)()?.handleEndTransaction()}}e.$6d=h;function i(l,m){let f;return typeof l=="string"?f=new S.$cd(void 0,l,void 0):f=new S.$cd(l,void 0,void 0),new r(f,m,w.$8c)}class r extends u{get debugName(){return this.e.getDebugName(this)??"ObservableValue"}constructor(m,f,$){super(),this.e=m,this.g=$,this.d=f}get(){return this.d}set(m,f,$){if($===void 0&&this.g(this.d,m))return;let I;f||(f=I=new h(()=>{},()=>`Setting ${this.debugName}`));try{const D=this.d;this.h(m),(0,k.$Md)()?.handleObservableChanged(this,{oldValue:D,newValue:m,change:$,didChange:!0,hadValue:!0});for(const v of this.b)f.updateObserver(v,this),v.handleChange(this,$)}finally{I&&I.finish()}}toString(){return`${this.debugName}: ${this.d}`}h(m){this.d=m}}e.$8d=r;function t(l,m){let f;return typeof l=="string"?f=new S.$cd(void 0,l,void 0):f=new S.$cd(l,void 0,void 0),new c(f,m,w.$8c)}class c extends r{h(m){this.d!==m&&(this.d&&this.d.dispose(),this.d=m)}dispose(){this.d?.dispose()}}e.$0d=c}),function(){function oe(k){const O=[];typeof k=="number"&&O.push("code/timeOrigin",k);function A(p){O.push(p,Date.now())}function T(){const p=[];for(let a=0;a<O.length;a+=2)p.push({name:O[a],startTime:O[a+1]});return p}return{mark:A,getMarks:T}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?oe():{mark(k){performance.mark(k)},getMarks(){let k=performance.timeOrigin;typeof k!="number"&&(k=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const O=[{name:"code/timeOrigin",startTime:Math.round(k)}];for(const A of performance.getEntriesByType("mark"))O.push({name:A.name,startTime:Math.round(k+A.startTime)});return O}};if(typeof process=="object"){const k=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return oe(k)}else return console.trace("perf-util loaded in UNKNOWN environment"),oe()}function w(k){return k.MonacoPerformanceMarks||(k.MonacoPerformanceMarks=e()),k.MonacoPerformanceMarks}var S;typeof global=="object"?S=global:typeof self=="object"?S=self:S={},typeof define=="function"?define("vs/base/common/performance",[],function(){return w(S)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=w(S):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),S.perf=w(S))}(),define(ke[142],Ce([1,0,40]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$PI=void 0;const S=Symbol("unset");class k{constructor(){this.a=new A,this.b=0}get size(){return this.b}get nodes(){return this.a.children?.values()||w.Iterable.empty()}insert(p,a,R){this.d(p,y=>y._value=a,R)}mutate(p,a){this.d(p,R=>R._value=a(R._value===S?void 0:R._value))}mutatePath(p,a){this.d(p,()=>{},R=>a(R))}delete(p){const a=this.c(p);if(!a)return;let R=a.length-1;const y=a[R].node._value;if(y!==S){for(this.b--,a[R].node._value=S;R>0;R--){const{node:u,part:E}=a[R];if(u.children?.size||u._value!==S)break;a[R-1].node.children.delete(E)}return y}}*deleteRecursive(p){const a=this.c(p);if(!a)return;const R=a[a.length-1].node;for(let y=a.length-1;y>0;y--){const u=a[y-1];if(u.node.children.delete(a[y].part),u.node.children.size>0||u.node._value!==S)break}for(const y of O(R))y._value!==S&&(this.b--,yield y._value)}find(p){let a=this.a;for(const R of p){const y=a.children?.get(R);if(!y)return;a=y}return a._value===S?void 0:a._value}hasKeyOrParent(p){let a=this.a;for(const R of p){const y=a.children?.get(R);if(!y)return!1;if(y._value!==S)return!0;a=y}return!1}hasKeyOrChildren(p){let a=this.a;for(const R of p){const y=a.children?.get(R);if(!y)return!1;a=y}return!0}hasKey(p){let a=this.a;for(const R of p){const y=a.children?.get(R);if(!y)return!1;a=y}return a._value!==S}c(p){const a=[{part:"",node:this.a}];let R=0;for(const y of p){const u=a[R].node.children?.get(y);if(!u)return;a.push({part:y,node:u}),R++}return a}d(p,a,R){let y=this.a;for(const d of p){if(y.children)if(y.children.has(d))y=y.children.get(d);else{const n=new A;y.children.set(d,n),y=n}else{const n=new A;y.children=new Map([[d,n]]),y=n}R?.(y)}const u=y._value===S?0:1;a(y);const E=y._value===S?0:1;this.b+=E-u}*values(){for(const{_value:p}of O(this.a))p!==S&&(yield p)}}e.$PI=k;function*O(T){const p=[T];for(;p.length>0;){const a=p.pop();if(yield a,a.children)for(const R of a.children.values())p.push(R)}}class A{constructor(){this._value=S}get value(){return this._value===S?void 0:this._value}set value(p){this._value=p===void 0?S:p}}}),function(oe,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var w=e();for(var S in w)(typeof exports=="object"?exports:oe)[S]=w[S]}}(typeof self<"u"?self:this,function(){return function(oe){var e={};function w(S){if(e[S])return e[S].exports;var k=e[S]={i:S,l:!1,exports:{}};return oe[S].call(k.exports,k,k.exports,w),k.l=!0,k.exports}return w.m=oe,w.c=e,w.d=function(S,k,O){w.o(S,k)||Object.defineProperty(S,k,{enumerable:!0,get:O})},w.r=function(S){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(S,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(S,"__esModule",{value:!0})},w.t=function(S,k){if(1&k&&(S=w(S)),8&k||4&k&&typeof S=="object"&&S&&S.__esModule)return S;var O=Object.create(null);if(w.r(O),Object.defineProperty(O,"default",{enumerable:!0,value:S}),2&k&&typeof S!="string")for(var A in S)w.d(O,A,function(T){return S[T]}.bind(null,A));return O},w.n=function(S){var k=S&&S.__esModule?function(){return S.default}:function(){return S};return w.d(k,"a",k),k},w.o=function(S,k){return Object.prototype.hasOwnProperty.call(S,k)},w.p="",w(w.s=0)}([function(oe,e,w){(function(S){var k;e=oe.exports=Ie,k=typeof S=="object"&&S.env&&S.env.NODE_DEBUG&&/\bsemver\b/i.test(S.env.NODE_DEBUG)?function(){var U=Array.prototype.slice.call(arguments,0);U.unshift("SEMVER"),console.log.apply(console,U)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var O=256,A=Number.MAX_SAFE_INTEGER||9007199254740991,T=e.re=[],p=e.src=[],a=0,R=a++;p[R]="0|[1-9]\\d*";var y=a++;p[y]="[0-9]+";var u=a++;p[u]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var E=a++;p[E]="("+p[R]+")\\.("+p[R]+")\\.("+p[R]+")";var d=a++;p[d]="("+p[y]+")\\.("+p[y]+")\\.("+p[y]+")";var n=a++;p[n]="(?:"+p[R]+"|"+p[u]+")";var s=a++;p[s]="(?:"+p[y]+"|"+p[u]+")";var o=a++;p[o]="(?:-("+p[n]+"(?:\\."+p[n]+")*))";var h=a++;p[h]="(?:-?("+p[s]+"(?:\\."+p[s]+")*))";var i=a++;p[i]="[0-9A-Za-z-]+";var r=a++;p[r]="(?:\\+("+p[i]+"(?:\\."+p[i]+")*))";var t=a++,c="v?"+p[E]+p[o]+"?"+p[r]+"?";p[t]="^"+c+"$";var l="[v=\\s]*"+p[d]+p[h]+"?"+p[r]+"?",m=a++;p[m]="^"+l+"$";var f=a++;p[f]="((?:<|>)?=?)";var $=a++;p[$]=p[y]+"|x|X|\\*";var I=a++;p[I]=p[R]+"|x|X|\\*";var D=a++;p[D]="[v=\\s]*("+p[I]+")(?:\\.("+p[I]+")(?:\\.("+p[I]+")(?:"+p[o]+")?"+p[r]+"?)?)?";var v=a++;p[v]="[v=\\s]*("+p[$]+")(?:\\.("+p[$]+")(?:\\.("+p[$]+")(?:"+p[h]+")?"+p[r]+"?)?)?";var C=a++;p[C]="^"+p[f]+"\\s*"+p[D]+"$";var P=a++;p[P]="^"+p[f]+"\\s*"+p[v]+"$";var g=a++;p[g]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var b=a++;p[b]="(?:~>?)";var L=a++;p[L]="(\\s*)"+p[b]+"\\s+",T[L]=new RegExp(p[L],"g");var N=a++;p[N]="^"+p[b]+p[D]+"$";var B=a++;p[B]="^"+p[b]+p[v]+"$";var G=a++;p[G]="(?:\\^)";var W=a++;p[W]="(\\s*)"+p[G]+"\\s+",T[W]=new RegExp(p[W],"g");var F=a++;p[F]="^"+p[G]+p[D]+"$";var q=a++;p[q]="^"+p[G]+p[v]+"$";var ue=a++;p[ue]="^"+p[f]+"\\s*("+l+")$|^$";var ge=a++;p[ge]="^"+p[f]+"\\s*("+c+")$|^$";var te=a++;p[te]="(\\s*)"+p[f]+"\\s*("+l+"|"+p[D]+")",T[te]=new RegExp(p[te],"g");var me=a++;p[me]="^\\s*("+p[D]+")\\s+-\\s+("+p[D]+")\\s*$";var re=a++;p[re]="^\\s*("+p[v]+")\\s+-\\s+("+p[v]+")\\s*$";var ce=a++;p[ce]="(<|>)?=?\\s*\\*";for(var be=0;be<35;be++)k(be,p[be]),T[be]||(T[be]=new RegExp(p[be]));function se(U,K){if(U instanceof Ie)return U;if(typeof U!="string"||U.length>O||!(K?T[m]:T[t]).test(U))return null;try{return new Ie(U,K)}catch{return null}}function Ie(U,K){if(U instanceof Ie){if(U.loose===K)return U;U=U.version}else if(typeof U!="string")throw new TypeError("Invalid Version: "+U);if(U.length>O)throw new TypeError("version is longer than "+O+" characters");if(!(this instanceof Ie))return new Ie(U,K);k("SemVer",U,K),this.loose=K;var Q=U.trim().match(K?T[m]:T[t]);if(!Q)throw new TypeError("Invalid Version: "+U);if(this.raw=U,this.major=+Q[1],this.minor=+Q[2],this.patch=+Q[3],this.major>A||this.major<0)throw new TypeError("Invalid major version");if(this.minor>A||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>A||this.patch<0)throw new TypeError("Invalid patch version");Q[4]?this.prerelease=Q[4].split(".").map(function(ne){if(/^[0-9]+$/.test(ne)){var fe=+ne;if(fe>=0&&fe<A)return fe}return ne}):this.prerelease=[],this.build=Q[5]?Q[5].split("."):[],this.format()}e.parse=se,e.valid=function(U,K){var Q=se(U,K);return Q?Q.version:null},e.clean=function(U,K){var Q=se(U.trim().replace(/^[=v]+/,""),K);return Q?Q.version:null},e.SemVer=Ie,Ie.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},Ie.prototype.toString=function(){return this.version},Ie.prototype.compare=function(U){return k("SemVer.compare",this.version,this.loose,U),U instanceof Ie||(U=new Ie(U,this.loose)),this.compareMain(U)||this.comparePre(U)},Ie.prototype.compareMain=function(U){return U instanceof Ie||(U=new Ie(U,this.loose)),Z(this.major,U.major)||Z(this.minor,U.minor)||Z(this.patch,U.patch)},Ie.prototype.comparePre=function(U){if(U instanceof Ie||(U=new Ie(U,this.loose)),this.prerelease.length&&!U.prerelease.length)return-1;if(!this.prerelease.length&&U.prerelease.length)return 1;if(!this.prerelease.length&&!U.prerelease.length)return 0;var K=0;do{var Q=this.prerelease[K],ne=U.prerelease[K];if(k("prerelease compare",K,Q,ne),Q===void 0&&ne===void 0)return 0;if(ne===void 0)return 1;if(Q===void 0)return-1;if(Q!==ne)return Z(Q,ne)}while(++K)},Ie.prototype.inc=function(U,K){switch(U){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",K);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",K);break;case"prepatch":this.prerelease.length=0,this.inc("patch",K),this.inc("pre",K);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",K),this.inc("pre",K);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var Q=this.prerelease.length;--Q>=0;)typeof this.prerelease[Q]=="number"&&(this.prerelease[Q]++,Q=-2);Q===-1&&this.prerelease.push(0)}K&&(this.prerelease[0]===K?isNaN(this.prerelease[1])&&(this.prerelease=[K,0]):this.prerelease=[K,0]);break;default:throw new Error("invalid increment argument: "+U)}return this.format(),this.raw=this.version,this},e.inc=function(U,K,Q,ne){typeof Q=="string"&&(ne=Q,Q=void 0);try{return new Ie(U,Q).inc(K,ne).version}catch{return null}},e.diff=function(U,K){if(ae(U,K))return null;var Q=se(U),ne=se(K);if(Q.prerelease.length||ne.prerelease.length){for(var fe in Q)if((fe==="major"||fe==="minor"||fe==="patch")&&Q[fe]!==ne[fe])return"pre"+fe;return"prerelease"}for(var fe in Q)if((fe==="major"||fe==="minor"||fe==="patch")&&Q[fe]!==ne[fe])return fe},e.compareIdentifiers=Z;var Ue=/^[0-9]+$/;function Z(U,K){var Q=Ue.test(U),ne=Ue.test(K);return Q&&ne&&(U=+U,K=+K),Q&&!ne?-1:ne&&!Q?1:U<K?-1:U>K?1:0}function V(U,K,Q){return new Ie(U,Q).compare(new Ie(K,Q))}function _(U,K,Q){return V(U,K,Q)>0}function ye(U,K,Q){return V(U,K,Q)<0}function ae(U,K,Q){return V(U,K,Q)===0}function we(U,K,Q){return V(U,K,Q)!==0}function he(U,K,Q){return V(U,K,Q)>=0}function X(U,K,Q){return V(U,K,Q)<=0}function Y(U,K,Q,ne){var fe;switch(K){case"===":typeof U=="object"&&(U=U.version),typeof Q=="object"&&(Q=Q.version),fe=U===Q;break;case"!==":typeof U=="object"&&(U=U.version),typeof Q=="object"&&(Q=Q.version),fe=U!==Q;break;case"":case"=":case"==":fe=ae(U,Q,ne);break;case"!=":fe=we(U,Q,ne);break;case">":fe=_(U,Q,ne);break;case">=":fe=he(U,Q,ne);break;case"<":fe=ye(U,Q,ne);break;case"<=":fe=X(U,Q,ne);break;default:throw new TypeError("Invalid operator: "+K)}return fe}function pe(U,K){if(U instanceof pe){if(U.loose===K)return U;U=U.value}if(!(this instanceof pe))return new pe(U,K);k("comparator",U,K),this.loose=K,this.parse(U),this.semver===$e?this.value="":this.value=this.operator+this.semver.version,k("comp",this)}e.rcompareIdentifiers=function(U,K){return Z(K,U)},e.major=function(U,K){return new Ie(U,K).major},e.minor=function(U,K){return new Ie(U,K).minor},e.patch=function(U,K){return new Ie(U,K).patch},e.compare=V,e.compareLoose=function(U,K){return V(U,K,!0)},e.rcompare=function(U,K,Q){return V(K,U,Q)},e.sort=function(U,K){return U.sort(function(Q,ne){return e.compare(Q,ne,K)})},e.rsort=function(U,K){return U.sort(function(Q,ne){return e.rcompare(Q,ne,K)})},e.gt=_,e.lt=ye,e.eq=ae,e.neq=we,e.gte=he,e.lte=X,e.cmp=Y,e.Comparator=pe;var $e={};function Te(U,K){if(U instanceof Te)return U.loose===K?U:new Te(U.raw,K);if(U instanceof pe)return new Te(U.value,K);if(!(this instanceof Te))return new Te(U,K);if(this.loose=K,this.raw=U,this.set=U.split(/\s*\|\|\s*/).map(function(Q){return this.parseRange(Q.trim())},this).filter(function(Q){return Q.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+U);this.format()}function ze(U){return!U||U.toLowerCase()==="x"||U==="*"}function Se(U,K,Q,ne,fe,Ae,je,Ke,_e,it,nt,tt,rt){return((K=ze(Q)?"":ze(ne)?">="+Q+".0.0":ze(fe)?">="+Q+"."+ne+".0":">="+K)+" "+(Ke=ze(_e)?"":ze(it)?"<"+(+_e+1)+".0.0":ze(nt)?"<"+_e+"."+(+it+1)+".0":tt?"<="+_e+"."+it+"."+nt+"-"+tt:"<="+Ke)).trim()}function Re(U,K){for(var Q=0;Q<U.length;Q++)if(!U[Q].test(K))return!1;if(K.prerelease.length){for(Q=0;Q<U.length;Q++)if(k(U[Q].semver),U[Q].semver!==$e&&U[Q].semver.prerelease.length>0){var ne=U[Q].semver;if(ne.major===K.major&&ne.minor===K.minor&&ne.patch===K.patch)return!0}return!1}return!0}function Oe(U,K,Q){try{K=new Te(K,Q)}catch{return!1}return K.test(U)}function z(U,K,Q,ne){var fe,Ae,je,Ke,_e;switch(U=new Ie(U,ne),K=new Te(K,ne),Q){case">":fe=_,Ae=X,je=ye,Ke=">",_e=">=";break;case"<":fe=ye,Ae=he,je=_,Ke="<",_e="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Oe(U,K,ne))return!1;for(var it=0;it<K.set.length;++it){var nt=K.set[it],tt=null,rt=null;if(nt.forEach(function($t){$t.semver===$e&&($t=new pe(">=0.0.0")),tt=tt||$t,rt=rt||$t,fe($t.semver,tt.semver,ne)?tt=$t:je($t.semver,rt.semver,ne)&&(rt=$t)}),tt.operator===Ke||tt.operator===_e||(!rt.operator||rt.operator===Ke)&&Ae(U,rt.semver)||rt.operator===_e&&je(U,rt.semver))return!1}return!0}pe.prototype.parse=function(U){var K=this.loose?T[ue]:T[ge],Q=U.match(K);if(!Q)throw new TypeError("Invalid comparator: "+U);this.operator=Q[1],this.operator==="="&&(this.operator=""),Q[2]?this.semver=new Ie(Q[2],this.loose):this.semver=$e},pe.prototype.toString=function(){return this.value},pe.prototype.test=function(U){return k("Comparator.test",U,this.loose),this.semver===$e||(typeof U=="string"&&(U=new Ie(U,this.loose)),Y(U,this.operator,this.semver,this.loose))},pe.prototype.intersects=function(U,K){if(!(U instanceof pe))throw new TypeError("a Comparator is required");var Q;if(this.operator==="")return Q=new Te(U.value,K),Oe(this.value,Q,K);if(U.operator==="")return Q=new Te(this.value,K),Oe(U.semver,Q,K);var ne=!(this.operator!==">="&&this.operator!==">"||U.operator!==">="&&U.operator!==">"),fe=!(this.operator!=="<="&&this.operator!=="<"||U.operator!=="<="&&U.operator!=="<"),Ae=this.semver.version===U.semver.version,je=!(this.operator!==">="&&this.operator!=="<="||U.operator!==">="&&U.operator!=="<="),Ke=Y(this.semver,"<",U.semver,K)&&(this.operator===">="||this.operator===">")&&(U.operator==="<="||U.operator==="<"),_e=Y(this.semver,">",U.semver,K)&&(this.operator==="<="||this.operator==="<")&&(U.operator===">="||U.operator===">");return ne||fe||Ae&&je||Ke||_e},e.Range=Te,Te.prototype.format=function(){return this.range=this.set.map(function(U){return U.join(" ").trim()}).join("||").trim(),this.range},Te.prototype.toString=function(){return this.range},Te.prototype.parseRange=function(U){var K=this.loose;U=U.trim(),k("range",U,K);var Q=K?T[re]:T[me];U=U.replace(Q,Se),k("hyphen replace",U),U=U.replace(T[te],"$1$2$3"),k("comparator trim",U,T[te]),U=(U=(U=U.replace(T[L],"$1~")).replace(T[W],"$1^")).split(/\s+/).join(" ");var ne=K?T[ue]:T[ge],fe=U.split(" ").map(function(Ae){return function(je,Ke){return k("comp",je),je=function(_e,it){return _e.trim().split(/\s+/).map(function(nt){return function(tt,rt){k("caret",tt,rt);var $t=rt?T[q]:T[F];return tt.replace($t,function(lt,st,ut,ft,mt){var We;return k("caret",tt,lt,st,ut,ft,mt),ze(st)?We="":ze(ut)?We=">="+st+".0.0 <"+(+st+1)+".0.0":ze(ft)?We=st==="0"?">="+st+"."+ut+".0 <"+st+"."+(+ut+1)+".0":">="+st+"."+ut+".0 <"+(+st+1)+".0.0":mt?(k("replaceCaret pr",mt),mt.charAt(0)!=="-"&&(mt="-"+mt),We=st==="0"?ut==="0"?">="+st+"."+ut+"."+ft+mt+" <"+st+"."+ut+"."+(+ft+1):">="+st+"."+ut+"."+ft+mt+" <"+st+"."+(+ut+1)+".0":">="+st+"."+ut+"."+ft+mt+" <"+(+st+1)+".0.0"):(k("no pr"),We=st==="0"?ut==="0"?">="+st+"."+ut+"."+ft+" <"+st+"."+ut+"."+(+ft+1):">="+st+"."+ut+"."+ft+" <"+st+"."+(+ut+1)+".0":">="+st+"."+ut+"."+ft+" <"+(+st+1)+".0.0"),k("caret return",We),We})}(nt,it)}).join(" ")}(je,Ke),k("caret",je),je=function(_e,it){return _e.trim().split(/\s+/).map(function(nt){return function(tt,rt){var $t=rt?T[B]:T[N];return tt.replace($t,function(lt,st,ut,ft,mt){var We;return k("tilde",tt,lt,st,ut,ft,mt),ze(st)?We="":ze(ut)?We=">="+st+".0.0 <"+(+st+1)+".0.0":ze(ft)?We=">="+st+"."+ut+".0 <"+st+"."+(+ut+1)+".0":mt?(k("replaceTilde pr",mt),mt.charAt(0)!=="-"&&(mt="-"+mt),We=">="+st+"."+ut+"."+ft+mt+" <"+st+"."+(+ut+1)+".0"):We=">="+st+"."+ut+"."+ft+" <"+st+"."+(+ut+1)+".0",k("tilde return",We),We})}(nt,it)}).join(" ")}(je,Ke),k("tildes",je),je=function(_e,it){return k("replaceXRanges",_e,it),_e.split(/\s+/).map(function(nt){return function(tt,rt){tt=tt.trim();var $t=rt?T[P]:T[C];return tt.replace($t,function(lt,st,ut,ft,mt,We){k("xRange",tt,lt,st,ut,ft,mt,We);var Be=ze(ut),H=Be||ze(ft),x=H||ze(mt);return st==="="&&x&&(st=""),Be?lt=st===">"||st==="<"?"<0.0.0":"*":st&&x?(H&&(ft=0),x&&(mt=0),st===">"?(st=">=",H?(ut=+ut+1,ft=0,mt=0):x&&(ft=+ft+1,mt=0)):st==="<="&&(st="<",H?ut=+ut+1:ft=+ft+1),lt=st+ut+"."+ft+"."+mt):H?lt=">="+ut+".0.0 <"+(+ut+1)+".0.0":x&&(lt=">="+ut+"."+ft+".0 <"+ut+"."+(+ft+1)+".0"),k("xRange return",lt),lt})}(nt,it)}).join(" ")}(je,Ke),k("xrange",je),je=function(_e,it){return k("replaceStars",_e,it),_e.trim().replace(T[ce],"")}(je,Ke),k("stars",je),je}(Ae,K)}).join(" ").split(/\s+/);return this.loose&&(fe=fe.filter(function(Ae){return!!Ae.match(ne)})),fe=fe.map(function(Ae){return new pe(Ae,K)})},Te.prototype.intersects=function(U,K){if(!(U instanceof Te))throw new TypeError("a Range is required");return this.set.some(function(Q){return Q.every(function(ne){return U.set.some(function(fe){return fe.every(function(Ae){return ne.intersects(Ae,K)})})})})},e.toComparators=function(U,K){return new Te(U,K).set.map(function(Q){return Q.map(function(ne){return ne.value}).join(" ").trim().split(" ")})},Te.prototype.test=function(U){if(!U)return!1;typeof U=="string"&&(U=new Ie(U,this.loose));for(var K=0;K<this.set.length;K++)if(Re(this.set[K],U))return!0;return!1},e.satisfies=Oe,e.maxSatisfying=function(U,K,Q){var ne=null,fe=null;try{var Ae=new Te(K,Q)}catch{return null}return U.forEach(function(je){Ae.test(je)&&(ne&&fe.compare(je)!==-1||(fe=new Ie(ne=je,Q)))}),ne},e.minSatisfying=function(U,K,Q){var ne=null,fe=null;try{var Ae=new Te(K,Q)}catch{return null}return U.forEach(function(je){Ae.test(je)&&(ne&&fe.compare(je)!==1||(fe=new Ie(ne=je,Q)))}),ne},e.validRange=function(U,K){try{return new Te(U,K).range||"*"}catch{return null}},e.ltr=function(U,K,Q){return z(U,K,"<",Q)},e.gtr=function(U,K,Q){return z(U,K,">",Q)},e.outside=z,e.prerelease=function(U,K){var Q=se(U,K);return Q&&Q.prerelease.length?Q.prerelease:null},e.intersects=function(U,K,Q){return U=new Te(U,Q),K=new Te(K,Q),U.intersects(K)},e.coerce=function(U){if(U instanceof Ie)return U;if(typeof U!="string")return null;var K=U.match(T[g]);return K==null?null:se((K[1]||"0")+"."+(K[2]||"0")+"."+(K[3]||"0"))}}).call(this,w(1))},function(oe,e){var w,S,k=oe.exports={};function O(){throw new Error("setTimeout has not been defined")}function A(){throw new Error("clearTimeout has not been defined")}function T(s){if(w===setTimeout)return setTimeout(s,0);if((w===O||!w)&&setTimeout)return w=setTimeout,setTimeout(s,0);try{return w(s,0)}catch{try{return w.call(null,s,0)}catch{return w.call(this,s,0)}}}(function(){try{w=typeof setTimeout=="function"?setTimeout:O}catch{w=O}try{S=typeof clearTimeout=="function"?clearTimeout:A}catch{S=A}})();var p,a=[],R=!1,y=-1;function u(){R&&p&&(R=!1,p.length?a=p.concat(a):y=-1,a.length&&E())}function E(){if(!R){var s=T(u);R=!0;for(var o=a.length;o;){for(p=a,a=[];++y<o;)p&&p[y].run();y=-1,o=a.length}p=null,R=!1,function(h){if(S===clearTimeout)return clearTimeout(h);if((S===A||!S)&&clearTimeout)return S=clearTimeout,clearTimeout(h);try{S(h)}catch{try{return S.call(null,h)}catch{return S.call(this,h)}}}(s)}}function d(s,o){this.fun=s,this.array=o}function n(){}k.nextTick=function(s){var o=new Array(arguments.length-1);if(arguments.length>1)for(var h=1;h<arguments.length;h++)o[h-1]=arguments[h];a.push(new d(s,o)),a.length!==1||R||T(E)},d.prototype.run=function(){this.fun.apply(null,this.array)},k.title="browser",k.browser=!0,k.env={},k.argv=[],k.version="",k.versions={},k.on=n,k.addListener=n,k.once=n,k.off=n,k.removeListener=n,k.removeAllListeners=n,k.emit=n,k.prependListener=n,k.prependOnceListener=n,k.listeners=function(s){return[]},k.binding=function(s){throw new Error("process.binding is not supported")},k.cwd=function(){return"/"},k.chdir=function(s){throw new Error("process.chdir is not supported")},k.umask=function(){return 0}}])}),define(ke[143],Ce([1,0,6,4]),function(oe,e,w,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_s=e.$$s=e.$0s=e.$9s=e.ScrollbarVisibility=void 0;var k;(function(E){E[E.Auto=1]="Auto",E[E.Hidden=2]="Hidden",E[E.Visible=3]="Visible"})(k||(e.ScrollbarVisibility=k={}));class O{constructor(d,n,s,o,h,i,r){this.c=d,this._scrollStateBrand=void 0,this.c&&(n=n|0,s=s|0,o=o|0,h=h|0,i=i|0,r=r|0),this.rawScrollLeft=o,this.rawScrollTop=r,n<0&&(n=0),o+n>s&&(o=s-n),o<0&&(o=0),h<0&&(h=0),r+h>i&&(r=i-h),r<0&&(r=0),this.width=n,this.scrollWidth=s,this.scrollLeft=o,this.height=h,this.scrollHeight=i,this.scrollTop=r}equals(d){return this.rawScrollLeft===d.rawScrollLeft&&this.rawScrollTop===d.rawScrollTop&&this.width===d.width&&this.scrollWidth===d.scrollWidth&&this.scrollLeft===d.scrollLeft&&this.height===d.height&&this.scrollHeight===d.scrollHeight&&this.scrollTop===d.scrollTop}withScrollDimensions(d,n){return new O(this.c,typeof d.width<"u"?d.width:this.width,typeof d.scrollWidth<"u"?d.scrollWidth:this.scrollWidth,n?this.rawScrollLeft:this.scrollLeft,typeof d.height<"u"?d.height:this.height,typeof d.scrollHeight<"u"?d.scrollHeight:this.scrollHeight,n?this.rawScrollTop:this.scrollTop)}withScrollPosition(d){return new O(this.c,this.width,this.scrollWidth,typeof d.scrollLeft<"u"?d.scrollLeft:this.rawScrollLeft,this.height,this.scrollHeight,typeof d.scrollTop<"u"?d.scrollTop:this.rawScrollTop)}createScrollEvent(d,n){const s=this.width!==d.width,o=this.scrollWidth!==d.scrollWidth,h=this.scrollLeft!==d.scrollLeft,i=this.height!==d.height,r=this.scrollHeight!==d.scrollHeight,t=this.scrollTop!==d.scrollTop;return{inSmoothScrolling:n,oldWidth:d.width,oldScrollWidth:d.scrollWidth,oldScrollLeft:d.scrollLeft,width:this.width,scrollWidth:this.scrollWidth,scrollLeft:this.scrollLeft,oldHeight:d.height,oldScrollHeight:d.scrollHeight,oldScrollTop:d.scrollTop,height:this.height,scrollHeight:this.scrollHeight,scrollTop:this.scrollTop,widthChanged:s,scrollWidthChanged:o,scrollLeftChanged:h,heightChanged:i,scrollHeightChanged:r,scrollTopChanged:t}}}e.$9s=O;class A extends S.$Wc{constructor(d){super(),this._scrollableBrand=void 0,this.j=this.B(new w.$me),this.onScroll=this.j.event,this.c=d.smoothScrollDuration,this.f=d.scheduleAtNextAnimationFrame,this.g=new O(d.forceIntegerValues,0,0,0,0,0,0),this.h=null}dispose(){this.h&&(this.h.dispose(),this.h=null),super.dispose()}setSmoothScrollDuration(d){this.c=d}validateScrollPosition(d){return this.g.withScrollPosition(d)}getScrollDimensions(){return this.g}setScrollDimensions(d,n){const s=this.g.withScrollDimensions(d,n);this.n(s,!!this.h),this.h?.acceptScrollDimensions(this.g)}getFutureScrollPosition(){return this.h?this.h.to:this.g}getCurrentScrollPosition(){return this.g}setScrollPositionNow(d){const n=this.g.withScrollPosition(d);this.h&&(this.h.dispose(),this.h=null),this.n(n,!1)}setScrollPositionSmooth(d,n){if(this.c===0)return this.setScrollPositionNow(d);if(this.h){d={scrollLeft:typeof d.scrollLeft>"u"?this.h.to.scrollLeft:d.scrollLeft,scrollTop:typeof d.scrollTop>"u"?this.h.to.scrollTop:d.scrollTop};const s=this.g.withScrollPosition(d);if(this.h.to.scrollLeft===s.scrollLeft&&this.h.to.scrollTop===s.scrollTop)return;let o;n?o=new R(this.h.from,s,this.h.startTime,this.h.duration):o=this.h.combine(this.g,s,this.c),this.h.dispose(),this.h=o}else{const s=this.g.withScrollPosition(d);this.h=R.start(this.g,s,this.c)}this.h.animationFrameDisposable=this.f(()=>{this.h&&(this.h.animationFrameDisposable=null,this.m())})}hasPendingScrollAnimation(){return!!this.h}m(){if(!this.h)return;const d=this.h.tick(),n=this.g.withScrollPosition(d);if(this.n(n,!0),!!this.h){if(d.isDone){this.h.dispose(),this.h=null;return}this.h.animationFrameDisposable=this.f(()=>{this.h&&(this.h.animationFrameDisposable=null,this.m())})}}n(d,n){const s=this.g;s.equals(d)||(this.g=d,this.j.fire(this.g.createScrollEvent(s,n)))}}e.$0s=A;class T{constructor(d,n,s){this.scrollLeft=d,this.scrollTop=n,this.isDone=s}}e.$$s=T;function p(E,d){const n=d-E;return function(s){return E+n*u(s)}}function a(E,d,n){return function(s){return s<n?E(s/n):d((s-n)/(1-n))}}class R{constructor(d,n,s,o){this.from=d,this.to=n,this.duration=o,this.startTime=s,this.animationFrameDisposable=null,this.e()}e(){this.c=this.f(this.from.scrollLeft,this.to.scrollLeft,this.to.width),this.d=this.f(this.from.scrollTop,this.to.scrollTop,this.to.height)}f(d,n,s){if(Math.abs(d-n)>2.5*s){let h,i;return d<n?(h=d+.75*s,i=n-.75*s):(h=d-.75*s,i=n+.75*s),a(p(d,h),p(i,n),.33)}return p(d,n)}dispose(){this.animationFrameDisposable!==null&&(this.animationFrameDisposable.dispose(),this.animationFrameDisposable=null)}acceptScrollDimensions(d){this.to=d.withScrollPosition(this.to),this.e()}tick(){return this.g(Date.now())}g(d){const n=(d-this.startTime)/this.duration;if(n<1){const s=this.c(n),o=this.d(n);return new T(s,o,!1)}return new T(this.to.scrollLeft,this.to.scrollTop,!0)}combine(d,n,s){return R.start(d,n,s)}static start(d,n,s){s=s+10;const o=Date.now()-10;return new R(d,n,o,s)}}e.$_s=R;function y(E){return Math.pow(E,3)}function u(E){return 1-y(1-E)}}),define(ke[144],Ce([1,0,14,4]),function(oe,e,w,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ze=k,e.$Ae=O,e.$Be=A,e.$Ce=T,e.$De=a,e.$Ee=R,e.$Fe=y,e.$Ge=u,e.$He=E,e.$Ie=d,e.$Je=n,e.$Ke=s,e.$Le=o,e.$Me=h,e.$Ne=i;function k(r){const t=r;return t?typeof t.read=="function":!1}function O(r){const t=r;return t?[t.on,t.pause,t.resume,t.destroy].every(c=>typeof c=="function"):!1}function A(r){const t=r;return t?O(t.stream)&&Array.isArray(t.buffer)&&typeof t.ended=="boolean":!1}function T(r,t){return new p(r,t)}class p{constructor(t,c){this.e=t,this.f=c,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(t){if(!this.a.destroyed){if(this.a.flowing)this.g(t);else if(this.b.data.push(t),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(c=>this.d.push(c))}}error(t){this.a.destroyed||(this.a.flowing?this.h(t):this.b.error.push(t))}end(t){this.a.destroyed||(typeof t<"u"&&this.write(t),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(t){this.c.data.slice(0).forEach(c=>c(t))}h(t){this.c.error.length===0?(0,w.$3)(t):this.c.error.slice(0).forEach(c=>c(t))}i(){this.c.end.slice(0).forEach(t=>t())}on(t,c){if(!this.a.destroyed)switch(t){case"data":this.c.data.push(c),this.resume();break;case"end":this.c.end.push(c),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(c),this.a.flowing&&this.k();break}}removeListener(t,c){if(this.a.destroyed)return;let l;switch(t){case"data":l=this.c.data;break;case"end":l=this.c.end;break;case"error":l=this.c.error;break}if(l){const m=l.indexOf(c);m>=0&&l.splice(m,1)}}j(){if(this.b.data.length>0){const t=this.e(this.b.data);this.g(t),this.b.data.length=0;const c=[...this.d];this.d.length=0,c.forEach(l=>l())}}k(){if(this.c.error.length>0){for(const t of this.b.error)this.h(t);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function a(r,t){const c=[];let l;for(;(l=r.read())!==null;)c.push(l);return t(c)}function R(r,t,c){const l=[];let m;for(;(m=r.read())!==null&&l.length<c;)l.push(m);return m===null&&l.length>0?t(l):{read:()=>{if(l.length>0)return l.shift();if(typeof m<"u"){const f=m;return m=void 0,f}return r.read()}}}function y(r,t){return new Promise((c,l)=>{const m=[];u(r,{onData:f=>{t&&m.push(f)},onError:f=>{t?l(f):c(void 0)},onEnd:()=>{c(t?t(m):void 0)}})})}function u(r,t,c){r.on("error",l=>{c?.isCancellationRequested||t.onError(l)}),r.on("end",()=>{c?.isCancellationRequested||t.onEnd()}),r.on("data",l=>{c?.isCancellationRequested||t.onData(l)})}function E(r,t){return new Promise((c,l)=>{const m=new S.$Vc,f=[],$=v=>{if(f.push(v),f.length>t)return m.dispose(),r.pause(),c({stream:r,buffer:f,ended:!1})},I=v=>(m.dispose(),l(v)),D=()=>(m.dispose(),c({stream:r,buffer:f,ended:!0}));m.add((0,S.$Uc)(()=>r.removeListener("error",I))),r.on("error",I),m.add((0,S.$Uc)(()=>r.removeListener("end",D))),r.on("end",D),m.add((0,S.$Uc)(()=>r.removeListener("data",$))),r.on("data",$)})}function d(r,t){const c=T(t);return c.end(r),c}function n(){const r=T(()=>{throw new Error("not supported")});return r.end(),r}function s(r){let t=!1;return{read:()=>t?null:(t=!0,r)}}function o(r,t,c){const l=T(c);return u(r,{onData:m=>l.write(t.data(m)),onError:m=>l.error(t.error?t.error(m):m),onEnd:()=>l.end()}),l}function h(r,t,c){let l=!1;return{read:()=>{const m=t.read();return l?m:(l=!0,m!==null?c([r,m]):r)}}}function i(r,t,c){let l=!1;const m=T(c);return u(t,{onData:f=>l?m.write(f):(l=!0,m.write(c([r,f]))),onError:f=>m.error(f),onEnd:()=>{l||(l=!0,m.write(r)),m.end()}}),m}}),define(ke[23],Ce([1,0,47,144]),function(oe,e,w,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oe=void 0,e.$Pe=a,e.$Qe=R,e.$Re=y,e.$Se=u,e.$Te=E,e.$Ue=d,e.$Ve=n,e.$We=s,e.$Xe=o,e.$Ye=h,e.$Ze=i,e.$1e=r,e.$2e=t,e.$3e=c,e.$4e=l,e.$5e=m,e.$6e=f,e.$7e=$,e.$8e=I,e.$9e=C,S=qe(S);const k=typeof Buffer<"u",O=new w.$X(()=>new Uint8Array(256));let A,T;class p{static alloc(g){return k?new p(Buffer.allocUnsafe(g)):new p(new Uint8Array(g))}static wrap(g){return k&&!Buffer.isBuffer(g)&&(g=Buffer.from(g.buffer,g.byteOffset,g.byteLength)),new p(g)}static fromString(g,b){return!(b?.dontUseNodeBuffer||!1)&&k?new p(Buffer.from(g)):(A||(A=new TextEncoder),new p(A.encode(g)))}static fromByteArray(g){const b=p.alloc(g.length);for(let L=0,N=g.length;L<N;L++)b.buffer[L]=g[L];return b}static concat(g,b){if(typeof b>"u"){b=0;for(let B=0,G=g.length;B<G;B++)b+=g[B].byteLength}const L=p.alloc(b);let N=0;for(let B=0,G=g.length;B<G;B++){const W=g[B];L.set(W,N),N+=W.byteLength}return L}constructor(g){this.buffer=g,this.byteLength=this.buffer.byteLength}clone(){const g=p.alloc(this.byteLength);return g.set(this),g}toString(){return k?this.buffer.toString():(T||(T=new TextDecoder),T.decode(this.buffer))}slice(g,b){return new p(this.buffer.subarray(g,b))}set(g,b){if(g instanceof p)this.buffer.set(g.buffer,b);else if(g instanceof Uint8Array)this.buffer.set(g,b);else if(g instanceof ArrayBuffer)this.buffer.set(new Uint8Array(g),b);else if(ArrayBuffer.isView(g))this.buffer.set(new Uint8Array(g.buffer,g.byteOffset,g.byteLength),b);else throw new Error("Unknown argument 'array'")}readUInt32BE(g){return u(this.buffer,g)}writeUInt32BE(g,b){E(this.buffer,g,b)}readUInt32LE(g){return d(this.buffer,g)}writeUInt32LE(g,b){n(this.buffer,g,b)}readUInt8(g){return s(this.buffer,g)}writeUInt8(g,b){o(this.buffer,g,b)}indexOf(g,b=0){return a(this.buffer,g instanceof p?g.buffer:g,b)}}e.$Oe=p;function a(P,g,b=0){const L=g.byteLength,N=P.byteLength;if(L===0)return 0;if(L===1)return P.indexOf(g[0]);if(L>N-b)return-1;const B=O.value;B.fill(g.length);for(let q=0;q<g.length;q++)B[g[q]]=g.length-q-1;let G=b+g.length-1,W=G,F=-1;for(;G<N;)if(P[G]===g[W]){if(W===0){F=G;break}G--,W--}else G+=Math.max(g.length-W,B[P[G]]),W=g.length-1;return F}function R(P,g){return P[g+0]<<0>>>0|P[g+1]<<8>>>0}function y(P,g,b){P[b+0]=g&255,g=g>>>8,P[b+1]=g&255}function u(P,g){return P[g]*2**24+P[g+1]*2**16+P[g+2]*2**8+P[g+3]}function E(P,g,b){P[b+3]=g,g=g>>>8,P[b+2]=g,g=g>>>8,P[b+1]=g,g=g>>>8,P[b]=g}function d(P,g){return P[g+0]<<0>>>0|P[g+1]<<8>>>0|P[g+2]<<16>>>0|P[g+3]<<24>>>0}function n(P,g,b){P[b+0]=g&255,g=g>>>8,P[b+1]=g&255,g=g>>>8,P[b+2]=g&255,g=g>>>8,P[b+3]=g&255}function s(P,g){return P[g]}function o(P,g,b){P[b]=g}function h(P){return S.$De(P,g=>p.concat(g))}function i(P){return S.$Ke(P)}function r(P){return S.$Fe(P,g=>p.concat(g))}async function t(P){return P.ended?p.concat(P.buffer):p.concat([...P.buffer,await r(P.stream)])}function c(P){return S.$Ie(P,g=>p.concat(g))}function l(P){return S.$Le(P,{data:g=>typeof g=="string"?p.fromString(g):p.wrap(g)},g=>p.concat(g))}function m(P){return S.$Ce(g=>p.concat(g),P)}function f(P,g){return S.$Me(P,g,b=>p.concat(b))}function $(P,g){return S.$Ne(P,g,b=>p.concat(b))}function I(P){let g=0,b=0,L=0;const N=new Uint8Array(Math.floor(P.length/4*3)),B=W=>{switch(b){case 3:N[L++]=g|W,b=0;break;case 2:N[L++]=g|W>>>2,g=W<<6,b=3;break;case 1:N[L++]=g|W>>>4,g=W<<4,b=2;break;default:g=W<<2,b=1}};for(let W=0;W<P.length;W++){const F=P.charCodeAt(W);if(F>=65&&F<=90)B(F-65);else if(F>=97&&F<=122)B(F-97+26);else if(F>=48&&F<=57)B(F-48+52);else if(F===43||F===45)B(62);else if(F===47||F===95)B(63);else{if(F===61)break;throw new SyntaxError(`Unexpected base64 character ${P[W]}`)}}const G=L;for(;b>0;)B(0);return p.wrap(N).slice(0,G)}const D="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",v="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function C({buffer:P},g=!0,b=!1){const L=b?v:D;let N="";const B=P.byteLength%3;let G=0;for(;G<P.byteLength-B;G+=3){const W=P[G+0],F=P[G+1],q=P[G+2];N+=L[W>>>2],N+=L[(W<<4|F>>>4)&63],N+=L[(F<<2|q>>>6)&63],N+=L[q&63]}if(B===1){const W=P[G+0];N+=L[W>>>2],N+=L[W<<4&63],g&&(N+="==")}else if(B===2){const W=P[G+0],F=P[G+1];N+=L[W>>>2],N+=L[(W<<4|F>>>4)&63],N+=L[F<<2&63],g&&(N+="=")}return N}}),define(ke[145],Ce([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$he=void 0,e.$he=Symbol("MicrotaskDelay")}),define(ke[35],Ce([1,0,98]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.ThemeColor=void 0,e.$6j=k;var S;(function(A){function T(p){return p&&typeof p=="object"&&typeof p.id=="string"}A.isThemeColor=T})(S||(e.ThemeColor=S={}));function k(A){return{id:A}}var O;(function(A){A.iconNameSegment="[A-Za-z0-9]+",A.iconNameExpression="[A-Za-z0-9-]+",A.iconModifierExpression="~[A-Za-z]+",A.iconNameCharacter="[A-Za-z0-9~-]";const T=new RegExp(`^(${A.iconNameExpression})(${A.iconModifierExpression})?$`);function p(h){const i=T.exec(h.id);if(!i)return p(w.$5j.error);const[,r,t]=i,c=["codicon","codicon-"+r];return t&&c.push("codicon-modifier-"+t.substring(1)),c}A.asClassNameArray=p;function a(h){return p(h).join(" ")}A.asClassName=a;function R(h){return"."+p(h).join(".")}A.asCSSSelector=R;function y(h){return h&&typeof h=="object"&&typeof h.id=="string"&&(typeof h.color>"u"||S.isThemeColor(h.color))}A.isThemeIcon=y;const u=new RegExp(`^\\$\\((${A.iconNameExpression}(?:${A.iconModifierExpression})?)\\)$`);function E(h){const i=u.exec(h);if(!i)return;const[,r]=i;return{id:r}}A.fromString=E;function d(h){return{id:h}}A.fromId=d;function n(h,i){let r=h.id;const t=r.lastIndexOf("~");return t!==-1&&(r=r.substring(0,t)),i&&(r=`${r}~${i}`),{id:r}}A.modify=n;function s(h){const i=h.id.lastIndexOf("~");if(i!==-1)return h.id.substring(i+1)}A.getModifier=s;function o(h,i){return h.id===i.id&&h.color?.id===i.color?.id}A.isEqual=o})(O||(e.ThemeIcon=O={}))}),define(ke[146],Ce([1,0,28,29,137,13]),function(oe,e,w,S,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sk=e.FuzzyScore=e.$Hk=e.$Gk=void 0,e.or=A,e.$Ik=p,e.$Jk=a,e.$Kk=u,e.$Lk=D,e.$Mk=v,e.$Nk=N,e.$Ok=B,e.$Pk=G,e.$Qk=W,e.$Rk=_,e.$Tk=he,e.$Uk=pe,e.$Vk=$e,O=qe(O);function A(...Se){return function(Re,Oe){for(let z=0,U=Se.length;z<U;z++){const K=Se[z](Re,Oe);if(K)return K}return null}}e.$Gk=T.bind(void 0,!1),e.$Hk=T.bind(void 0,!0);function T(Se,Re,Oe){if(!Oe||Oe.length<Re.length)return null;let z;return Se?z=O.$Hf(Oe,Re):z=Oe.indexOf(Re)===0,z?Re.length>0?[{start:0,end:Re.length}]:[]:null}function p(Se,Re){const Oe=Re.toLowerCase().indexOf(Se.toLowerCase());return Oe===-1?null:[{start:Oe,end:Oe+Se.length}]}function a(Se,Re){return R(Se.toLowerCase(),Re.toLowerCase(),0,0)}function R(Se,Re,Oe,z){if(Oe===Se.length)return[];if(z===Re.length)return null;if(Se[Oe]===Re[z]){let U=null;return(U=R(Se,Re,Oe+1,z+1))?t({start:z,end:z+1},U):null}return R(Se,Re,Oe,z+1)}function y(Se){return w.CharCode.a<=Se&&Se<=w.CharCode.z}function u(Se){return w.CharCode.A<=Se&&Se<=w.CharCode.Z}function E(Se){return w.CharCode.Digit0<=Se&&Se<=w.CharCode.Digit9}function d(Se){return Se===w.CharCode.Space||Se===w.CharCode.Tab||Se===w.CharCode.LineFeed||Se===w.CharCode.CarriageReturn}const n=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(Se=>n.add(Se.charCodeAt(0)));function s(Se){return d(Se)||n.has(Se)}function o(Se,Re){return Se===Re||s(Se)&&s(Re)}const h=new Map;function i(Se){if(h.has(Se))return h.get(Se);let Re;const Oe=(0,k.$Ek)(Se);return Oe&&(Re=Oe),h.set(Se,Re),Re}function r(Se){return y(Se)||u(Se)||E(Se)}function t(Se,Re){return Re.length===0?Re=[Se]:Se.end===Re[0].start?Re[0].start=Se.start:Re.unshift(Se),Re}function c(Se,Re){for(let Oe=Re;Oe<Se.length;Oe++){const z=Se.charCodeAt(Oe);if(u(z)||E(z)||Oe>0&&!r(Se.charCodeAt(Oe-1)))return Oe}return Se.length}function l(Se,Re,Oe,z){if(Oe===Se.length)return[];if(z===Re.length)return null;if(Se[Oe]!==Re[z].toLowerCase())return null;{let U=null,K=z+1;for(U=l(Se,Re,Oe+1,z+1);!U&&(K=c(Re,K))<Re.length;)U=l(Se,Re,Oe+1,K),K++;return U===null?null:t({start:z,end:z+1},U)}}function m(Se){let Re=0,Oe=0,z=0,U=0,K=0;for(let je=0;je<Se.length;je++)K=Se.charCodeAt(je),u(K)&&Re++,y(K)&&Oe++,r(K)&&z++,E(K)&&U++;const Q=Re/Se.length,ne=Oe/Se.length,fe=z/Se.length,Ae=U/Se.length;return{upperPercent:Q,lowerPercent:ne,alphaPercent:fe,numericPercent:Ae}}function f(Se){const{upperPercent:Re,lowerPercent:Oe}=Se;return Oe===0&&Re>.6}function $(Se){const{upperPercent:Re,lowerPercent:Oe,alphaPercent:z,numericPercent:U}=Se;return Oe>.2&&Re<.8&&z>.6&&U<.2}function I(Se){let Re=0,Oe=0,z=0,U=0;for(let K=0;K<Se.length;K++)z=Se.charCodeAt(K),u(z)&&Re++,y(z)&&Oe++,d(z)&&U++;return(Re===0||Oe===0)&&U===0?Se.length<=30:Re<=5}function D(Se,Re){if(!Re||(Re=Re.trim(),Re.length===0)||!I(Se))return null;Re.length>60&&(Re=Re.substring(0,60));const Oe=m(Re);if(!$(Oe)){if(!f(Oe))return null;Re=Re.toLowerCase()}let z=null,U=0;for(Se=Se.toLowerCase();U<Re.length&&(z=l(Se,Re,0,U))===null;)U=c(Re,U+1);return z}function v(Se,Re,Oe=!1){if(!Re||Re.length===0)return null;let z=null,U=0;for(Se=Se.toLowerCase(),Re=Re.toLowerCase();U<Re.length&&(z=C(Se,Re,0,U,Oe),z===null);)U=P(Re,U+1);return z}function C(Se,Re,Oe,z,U){let K=0;if(Oe===Se.length)return[];if(z===Re.length)return null;if(!o(Se.charCodeAt(Oe),Re.charCodeAt(z))){const fe=i(Se.charCodeAt(Oe));if(!fe)return null;for(let Ae=0;Ae<fe.length;Ae++)if(!o(fe[Ae],Re.charCodeAt(z+Ae)))return null;K+=fe.length-1}let Q=null,ne=z+K+1;if(Q=C(Se,Re,Oe+1,ne,U),!U)for(;!Q&&(ne=P(Re,ne))<Re.length;)Q=C(Se,Re,Oe+1,ne,U),ne++;if(!Q)return null;if(Se.charCodeAt(Oe)!==Re.charCodeAt(z)){const fe=i(Se.charCodeAt(Oe));if(!fe)return Q;for(let Ae=0;Ae<fe.length;Ae++)if(fe[Ae]!==Re.charCodeAt(z+Ae))return Q}return t({start:z,end:z+K+1},Q)}function P(Se,Re){for(let Oe=Re;Oe<Se.length;Oe++)if(s(Se.charCodeAt(Oe))||Oe>0&&s(Se.charCodeAt(Oe-1)))return Oe;return Se.length}const g=A(e.$Hk,D,p),b=A(e.$Hk,D,a),L=new S.$Fc(1e4);function N(Se,Re,Oe=!1){if(typeof Se!="string"||typeof Re!="string")return null;let z=L.get(Se);z||(z=new RegExp(O.$pf(Se),"i"),L.set(Se,z));const U=z.exec(Re);return U?[{start:U.index,end:U.index+U[0].length}]:Oe?b(Se,Re):g(Se,Re)}function B(Se,Re){const Oe=he(Se,Se.toLowerCase(),0,Re,Re.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return Oe?W(Oe):null}function G(Se,Re,Oe,z,U,K){const Q=Math.min(13,Se.length);for(;Oe<Q;Oe++){const ne=he(Se,Re,Oe,z,U,K,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(ne)return ne}return[0,K]}function W(Se){if(typeof Se>"u")return[];const Re=[],Oe=Se[1];for(let z=Se.length-1;z>1;z--){const U=Se[z]+Oe,K=Re[Re.length-1];K&&K.end===U?K.end=U+1:Re.push({start:U,end:U+1})}return Re}const F=128;function q(){const Se=[],Re=[];for(let Oe=0;Oe<=F;Oe++)Re[Oe]=0;for(let Oe=0;Oe<=F;Oe++)Se.push(Re.slice(0));return Se}function ue(Se){const Re=[];for(let Oe=0;Oe<=Se;Oe++)Re[Oe]=0;return Re}const ge=ue(2*F),te=ue(2*F),me=q(),re=q(),ce=q(),be=!1;function se(Se,Re,Oe,z,U){function K(ne,fe,Ae=" "){for(;ne.length<fe;)ne=Ae+ne;return ne}let Q=` |   |${z.split("").map(ne=>K(ne,3)).join("|")}
`;for(let ne=0;ne<=Oe;ne++)ne===0?Q+=" |":Q+=`${Re[ne-1]}|`,Q+=Se[ne].slice(0,U+1).map(fe=>K(fe.toString(),3)).join("|")+`
`;return Q}function Ie(Se,Re,Oe,z){Se=Se.substr(Re),Oe=Oe.substr(z),console.log(se(re,Se,Se.length,Oe,Oe.length)),console.log(se(ce,Se,Se.length,Oe,Oe.length)),console.log(se(me,Se,Se.length,Oe,Oe.length))}function Ue(Se,Re){if(Re<0||Re>=Se.length)return!1;const Oe=Se.codePointAt(Re);switch(Oe){case w.CharCode.Underline:case w.CharCode.Dash:case w.CharCode.Period:case w.CharCode.Space:case w.CharCode.Slash:case w.CharCode.Backslash:case w.CharCode.SingleQuote:case w.CharCode.DoubleQuote:case w.CharCode.Colon:case w.CharCode.DollarSign:case w.CharCode.LessThan:case w.CharCode.GreaterThan:case w.CharCode.OpenParen:case w.CharCode.CloseParen:case w.CharCode.OpenSquareBracket:case w.CharCode.CloseSquareBracket:case w.CharCode.OpenCurlyBrace:case w.CharCode.CloseCurlyBrace:return!0;case void 0:return!1;default:return!!O.$Zf(Oe)}}function Z(Se,Re){if(Re<0||Re>=Se.length)return!1;switch(Se.charCodeAt(Re)){case w.CharCode.Space:case w.CharCode.Tab:return!0;default:return!1}}function V(Se,Re,Oe){return Re[Se]!==Oe[Se]}function _(Se,Re,Oe,z,U,K,Q=!1){for(;Re<Oe&&U<K;)Se[Re]===z[U]&&(Q&&(ge[Re]=U),Re+=1),U+=1;return Re===Oe}var ye;(function(Se){Se[Se.Diag=1]="Diag",Se[Se.Left=2]="Left",Se[Se.LeftLeft=3]="LeftLeft"})(ye||(ye={}));var ae;(function(Se){Se.Default=[-100,0];function Re(Oe){return!Oe||Oe.length===2&&Oe[0]===-100&&Oe[1]===0}Se.isDefault=Re})(ae||(e.FuzzyScore=ae={}));class we{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(Re,Oe){this.firstMatchCanBeWeak=Re,this.boostFullMatch=Oe}}e.$Sk=we;function he(Se,Re,Oe,z,U,K,Q=we.default){const ne=Se.length>F?F:Se.length,fe=z.length>F?F:z.length;if(Oe>=ne||K>=fe||ne-Oe>fe-K||!_(Re,Oe,ne,U,K,fe,!0))return;X(ne,fe,Oe,K,Re,U);let Ae=1,je=1,Ke=Oe,_e=K;const it=[!1];for(Ae=1,Ke=Oe;Ke<ne;Ae++,Ke++){const lt=ge[Ke],st=te[Ke],ut=Ke+1<ne?te[Ke+1]:fe;for(je=lt-K+1,_e=lt;_e<ut;je++,_e++){let ft=Number.MIN_SAFE_INTEGER,mt=!1;_e<=st&&(ft=Y(Se,Re,Ke,Oe,z,U,_e,fe,K,me[Ae-1][je-1]===0,it));let We=0;ft!==Number.MAX_SAFE_INTEGER&&(mt=!0,We=ft+re[Ae-1][je-1]);const Be=_e>lt,H=Be?re[Ae][je-1]+(me[Ae][je-1]>0?-5:0):0,x=_e>lt+1&&me[Ae][je-1]>0,Ee=x?re[Ae][je-2]+(me[Ae][je-2]>0?-5:0):0;if(x&&(!Be||Ee>=H)&&(!mt||Ee>=We))re[Ae][je]=Ee,ce[Ae][je]=ye.LeftLeft,me[Ae][je]=0;else if(Be&&(!mt||H>=We))re[Ae][je]=H,ce[Ae][je]=ye.Left,me[Ae][je]=0;else if(mt)re[Ae][je]=We,ce[Ae][je]=ye.Diag,me[Ae][je]=me[Ae-1][je-1]+1;else throw new Error("not possible")}}if(be&&Ie(Se,Oe,z,K),!it[0]&&!Q.firstMatchCanBeWeak)return;Ae--,je--;const nt=[re[Ae][je],K];let tt=0,rt=0;for(;Ae>=1;){let lt=je;do{const st=ce[Ae][lt];if(st===ye.LeftLeft)lt=lt-2;else if(st===ye.Left)lt=lt-1;else break}while(lt>=1);tt>1&&Re[Oe+Ae-1]===U[K+je-1]&&!V(lt+K-1,z,U)&&tt+1>me[Ae][lt]&&(lt=je),lt===je?tt++:tt=1,rt||(rt=lt),Ae--,je=lt-1,nt.push(je)}fe-K===ne&&Q.boostFullMatch&&(nt[0]+=2);const $t=rt-ne;return nt[0]-=$t,nt}function X(Se,Re,Oe,z,U,K){let Q=Se-1,ne=Re-1;for(;Q>=Oe&&ne>=z;)U[Q]===K[ne]&&(te[Q]=ne,Q--),ne--}function Y(Se,Re,Oe,z,U,K,Q,ne,fe,Ae,je){if(Re[Oe]!==K[Q])return Number.MIN_SAFE_INTEGER;let Ke=1,_e=!1;return Q===Oe-z?Ke=Se[Oe]===U[Q]?7:5:V(Q,U,K)&&(Q===0||!V(Q-1,U,K))?(Ke=Se[Oe]===U[Q]?7:5,_e=!0):Ue(K,Q)&&(Q===0||!Ue(K,Q-1))?Ke=5:(Ue(K,Q-1)||Z(K,Q-1))&&(Ke=5,_e=!0),Ke>1&&Oe===z&&(je[0]=!0),_e||(_e=V(Q,U,K)||Ue(K,Q-1)||Z(K,Q-1)),Oe===z?Q>fe&&(Ke-=_e?3:5):Ae?Ke+=_e?2:0:Ke+=_e?0:1,Q+1===ne&&(Ke-=_e?3:5),Ke}function pe(Se,Re,Oe,z,U,K,Q){return Te(Se,Re,Oe,z,U,K,!0,Q)}function $e(Se,Re,Oe,z,U,K,Q){return Te(Se,Re,Oe,z,U,K,!1,Q)}function Te(Se,Re,Oe,z,U,K,Q,ne){let fe=he(Se,Re,Oe,z,U,K,ne);if(fe&&!Q)return fe;if(Se.length>=3){const Ae=Math.min(7,Se.length-1);for(let je=Oe+1;je<Ae;je++){const Ke=ze(Se,je);if(Ke){const _e=he(Ke,Ke.toLowerCase(),Oe,z,U,K,ne);_e&&(_e[0]-=3,(!fe||_e[0]>fe[0])&&(fe=_e))}}}return fe}function ze(Se,Re){if(Re+1>=Se.length)return;const Oe=Se[Re],z=Se[Re+1];if(Oe!==z)return Se.slice(0,Re)+z+Oe+Se.slice(Re+2)}}),define(ke[99],Ce([1,0,146,13,35]),function(oe,e,w,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wk=p,e.$Xk=R,e.$Yk=u,e.$Zk=E,e.$1k=n,e.$2k=s;const O="$(",A=new RegExp(`\\$\\(${k.ThemeIcon.iconNameExpression}(?:${k.ThemeIcon.iconModifierExpression})?\\)`,"g"),T=new RegExp(`(\\\\)?${A.source}`,"g");function p(o){return o.replace(T,(h,i)=>i?h:`\\${h}`)}const a=new RegExp(`\\\\${A.source}`,"g");function R(o){return o.replace(a,h=>`\\${h}`)}const y=new RegExp(`(\\s)?(\\\\)?${A.source}(\\s)?`,"g");function u(o){return o.indexOf(O)===-1?o:o.replace(y,(h,i,r,t)=>r?h:i||t||"")}function E(o){return o?o.replace(/\$\((.*?)\)/g,(h,i)=>` ${i} `).trim():""}const d=new RegExp(`\\$\\(${k.ThemeIcon.iconNameCharacter}+\\)`,"g");function n(o){d.lastIndex=0;let h="";const i=[];let r=0;for(;;){const t=d.lastIndex,c=d.exec(o),l=o.substring(t,c?.index);if(l.length>0){h+=l;for(let m=0;m<l.length;m++)i.push(r)}if(!c)break;r+=c[0].length}return{text:h,iconOffsets:i}}function s(o,h,i=!1){const{text:r,iconOffsets:t}=h;if(!t||t.length===0)return(0,w.$Nk)(o,r,i);const c=(0,S.$nf)(r," "),l=r.length-c.length,m=(0,w.$Nk)(o,c,i);if(m)for(const f of m){const $=t[f.start+l]+l;f.start+=$,f.end+=$}return m}}),define(ke[36],Ce([1,0,13]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),w=qe(w);var S;(function(k){k[k.Ignore=0]="Ignore",k[k.Info=1]="Info",k[k.Warning=2]="Warning",k[k.Error=3]="Error"})(S||(S={})),function(k){const O="error",A="warning",T="warn",p="info",a="ignore";function R(u){return u?w.$Gf(O,u)?k.Error:w.$Gf(A,u)||w.$Gf(T,u)?k.Warning:w.$Gf(p,u)?k.Info:k.Ignore:k.Ignore}k.fromValue=R;function y(u){switch(u){case k.Error:return O;case k.Warning:return A;case k.Info:return p;default:return a}}k.toString=y}(S||(S={})),e.default=S}),define(ke[59],Ce([1,0,18,28,13]),function(oe,e,w,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Li=e.$Ki=e.$Ji=e.$Ii=e.$Hi=void 0;class O{constructor(){this.b="",this.c=0}reset(d){return this.b=d,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(d){const n=d.charCodeAt(0),s=this.b.charCodeAt(this.c);return n-s}value(){return this.b[this.c]}}e.$Hi=O;class A{constructor(d=!0){this.e=d}reset(d){return this.b=d,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let d=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===S.CharCode.Period)if(d)this.c++;else break;else d=!1;return this}cmp(d){return this.e?(0,k.$Af)(d,this.b,0,d.length,this.c,this.d):(0,k.$Cf)(d,this.b,0,d.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$Ii=A;class T{constructor(d=!0,n=!0){this.f=d,this.g=n}reset(d){this.d=0,this.e=0,this.b=d,this.c=d.length;for(let n=d.length-1;n>=0;n--,this.c--){const s=this.b.charCodeAt(n);if(!(s===S.CharCode.Slash||this.f&&s===S.CharCode.Backslash))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let d=!0;for(;this.e<this.c;this.e++){const n=this.b.charCodeAt(this.e);if(n===S.CharCode.Slash||this.f&&n===S.CharCode.Backslash)if(d)this.d++;else break;else d=!1}return this}cmp(d){return this.g?(0,k.$Af)(d,this.b,0,d.length,this.d,this.e):(0,k.$Cf)(d,this.b,0,d.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$Ji=T;var p;(function(E){E[E.Scheme=1]="Scheme",E[E.Authority=2]="Authority",E[E.Path=3]="Path",E[E.Query=4]="Query",E[E.Fragment=5]="Fragment"})(p||(p={}));class a{constructor(d,n){this.f=d,this.g=n,this.d=[],this.e=0}reset(d){return this.c=d,this.d=[],this.c.scheme&&this.d.push(p.Scheme),this.c.authority&&this.d.push(p.Authority),this.c.path&&(this.b=new T(!1,!this.f(d)),this.b.reset(d.path),this.b.value()&&this.d.push(p.Path)),this.g(d)||(this.c.query&&this.d.push(p.Query),this.c.fragment&&this.d.push(p.Fragment)),this.e=0,this}next(){return this.d[this.e]===p.Path&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===p.Path&&this.b.hasNext()||this.e<this.d.length-1}cmp(d){if(this.d[this.e]===p.Scheme)return(0,k.$Bf)(d,this.c.scheme);if(this.d[this.e]===p.Authority)return(0,k.$Bf)(d,this.c.authority);if(this.d[this.e]===p.Path)return this.b.cmp(d);if(this.d[this.e]===p.Query)return(0,k.$zf)(d,this.c.query);if(this.d[this.e]===p.Fragment)return(0,k.$zf)(d,this.c.fragment);throw new Error}value(){if(this.d[this.e]===p.Scheme)return this.c.scheme;if(this.d[this.e]===p.Authority)return this.c.authority;if(this.d[this.e]===p.Path)return this.b.value();if(this.d[this.e]===p.Query)return this.c.query;if(this.d[this.e]===p.Fragment)return this.c.fragment;throw new Error}}e.$Ki=a;class R{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const d=this.right;return this.right=d.left,d.left=this,this.updateHeight(),d.updateHeight(),d}rotateRight(){const d=this.left;return this.left=d.right,d.right=this,this.updateHeight(),d.updateHeight(),d}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var y;(function(E){E[E.Left=-1]="Left",E[E.Mid=0]="Mid",E[E.Right=1]="Right"})(y||(y={}));class u{static forUris(d=()=>!1,n=()=>!1){return new u(new a(d,n))}static forPaths(d=!1){return new u(new T(void 0,!d))}static forStrings(){return new u(new O)}static forConfigKeys(){return new u(new A)}constructor(d){this.b=d}clear(){this.c=void 0}fill(d,n){if(n){const s=n.slice(0);(0,w.$Yb)(s);for(const o of s)this.set(o,d)}else{const s=d.slice(0);(0,w.$Yb)(s);for(const o of s)this.set(o[0],o[1])}}set(d,n){const s=this.b.reset(d);let o;this.c||(this.c=new R,this.c.segment=s.value());const h=[];for(o=this.c;;){const r=s.cmp(o.segment);if(r>0)o.left||(o.left=new R,o.left.segment=s.value()),h.push([y.Left,o]),o=o.left;else if(r<0)o.right||(o.right=new R,o.right.segment=s.value()),h.push([y.Right,o]),o=o.right;else if(s.hasNext())s.next(),o.mid||(o.mid=new R,o.mid.segment=s.value()),h.push([y.Mid,o]),o=o.mid;else break}const i=o.value;o.value=n,o.key=d;for(let r=h.length-1;r>=0;r--){const t=h[r][1];t.updateHeight();const c=t.balanceFactor();if(c<-1||c>1){const l=h[r][0],m=h[r+1][0];if(l===y.Right&&m===y.Right)h[r][1]=t.rotateLeft();else if(l===y.Left&&m===y.Left)h[r][1]=t.rotateRight();else if(l===y.Right&&m===y.Left)t.right=h[r+1][1]=h[r+1][1].rotateRight(),h[r][1]=t.rotateLeft();else if(l===y.Left&&m===y.Right)t.left=h[r+1][1]=h[r+1][1].rotateLeft(),h[r][1]=t.rotateRight();else throw new Error;if(r>0)switch(h[r-1][0]){case y.Left:h[r-1][1].left=h[r][1];break;case y.Right:h[r-1][1].right=h[r][1];break;case y.Mid:h[r-1][1].mid=h[r][1];break}else this.c=h[0][1]}}return i}get(d){return this.d(d)?.value}d(d){const n=this.b.reset(d);let s=this.c;for(;s;){const o=n.cmp(s.segment);if(o>0)s=s.left;else if(o<0)s=s.right;else if(n.hasNext())n.next(),s=s.mid;else break}return s}has(d){const n=this.d(d);return!(n?.value===void 0&&n?.mid===void 0)}delete(d){return this.e(d,!1)}deleteSuperstr(d){return this.e(d,!0)}e(d,n){const s=this.b.reset(d),o=[];let h=this.c;for(;h;){const i=s.cmp(h.segment);if(i>0)o.push([y.Left,h]),h=h.left;else if(i<0)o.push([y.Right,h]),h=h.right;else if(s.hasNext())s.next(),o.push([y.Mid,h]),h=h.mid;else break}if(h){if(n?(h.left=void 0,h.mid=void 0,h.right=void 0,h.height=1):(h.key=void 0,h.value=void 0),!h.mid&&!h.value)if(h.left&&h.right){const i=this.f(h.right);if(i.key){const{key:r,value:t,segment:c}=i;this.e(i.key,!1),h.key=r,h.value=t,h.segment=c}}else{const i=h.left??h.right;if(o.length>0){const[r,t]=o[o.length-1];switch(r){case y.Left:t.left=i;break;case y.Mid:t.mid=i;break;case y.Right:t.right=i;break}}else this.c=i}for(let i=o.length-1;i>=0;i--){const r=o[i][1];r.updateHeight();const t=r.balanceFactor();if(t>1?(r.right.balanceFactor()>=0||(r.right=r.right.rotateRight()),o[i][1]=r.rotateLeft()):t<-1&&(r.left.balanceFactor()<=0||(r.left=r.left.rotateLeft()),o[i][1]=r.rotateRight()),i>0)switch(o[i-1][0]){case y.Left:o[i-1][1].left=o[i][1];break;case y.Right:o[i-1][1].right=o[i][1];break;case y.Mid:o[i-1][1].mid=o[i][1];break}else this.c=o[0][1]}}}f(d){for(;d.left;)d=d.left;return d}findSubstr(d){const n=this.b.reset(d);let s=this.c,o;for(;s;){const h=n.cmp(s.segment);if(h>0)s=s.left;else if(h<0)s=s.right;else if(n.hasNext())n.next(),o=s.value||o,s=s.mid;else break}return s&&s.value||o}findSuperstr(d){return this.g(d,!1)}g(d,n){const s=this.b.reset(d);let o=this.c;for(;o;){const h=s.cmp(o.segment);if(h>0)o=o.left;else if(h<0)o=o.right;else if(s.hasNext())s.next(),o=o.mid;else return o.mid?this.h(o.mid):n?o.value:void 0}}hasElementOrSubtree(d){return this.g(d,!0)!==void 0}forEach(d){for(const[n,s]of this)d(s,n)}*[Symbol.iterator](){yield*this.h(this.c)}h(d){const n=[];return this.j(d,n),n[Symbol.iterator]()}j(d,n){d&&(d.left&&this.j(d.left,n),d.value&&n.push([d.key,d.value]),d.mid&&this.j(d.mid,n),d.right&&this.j(d.right,n))}_isBalanced(){const d=n=>{if(!n)return!0;const s=n.balanceFactor();return s<-1||s>1?!1:d(n.left)&&d(n.right)};return d(this.c)}}e.$Li=u}),define(ke[37],Ce([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2g=void 0,e.$1g=S;const w=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function S(k){return w.test(k)}e.$2g=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let k;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?k=crypto.getRandomValues.bind(crypto):k=function(T){for(let p=0;p<T.length;p++)T[p]=Math.floor(Math.random()*256);return T};const O=new Uint8Array(16),A=[];for(let T=0;T<256;T++)A.push(T.toString(16).padStart(2,"0"));return function(){k(O),O[6]=O[6]&15|64,O[8]=O[8]&63|128;let p=0,a="";return a+=A[O[p++]],a+=A[O[p++]],a+=A[O[p++]],a+=A[O[p++]],a+="-",a+=A[O[p++]],a+=A[O[p++]],a+="-",a+=A[O[p++]],a+=A[O[p++]],a+="-",a+=A[O[p++]],a+=A[O[p++]],a+="-",a+=A[O[p++]],a+=A[O[p++]],a+=A[O[p++]],a+=A[O[p++]],a+=A[O[p++]],a+=A[O[p++]],a}}()}),define(ke[147],Ce([1,0,18,40,37]),function(oe,e,w,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lu=e.$ju=void 0,e.$hu=O,e.$iu=A,e.$ku=a;function O(y){return{asString:async()=>y,asFile:()=>{},value:typeof y=="string"?y:void 0}}function A(y,u,E){const d={id:(0,k.$2g)(),name:y,uri:u,data:E};return{asString:async()=>"",asFile:()=>d,value:void 0}}class T{constructor(){this.a=new Map}get size(){let u=0;for(const E of this.a)u++;return u}has(u){return this.a.has(this.b(u))}matches(u){const E=[...this.a.keys()];return S.Iterable.some(this,([d,n])=>n.asFile())&&E.push("files"),R(p(u),E)}get(u){return this.a.get(this.b(u))?.[0]}append(u,E){const d=this.a.get(u);d?d.push(E):this.a.set(this.b(u),[E])}replace(u,E){this.a.set(this.b(u),[E])}delete(u){this.a.delete(this.b(u))}*[Symbol.iterator](){for(const[u,E]of this.a)for(const d of E)yield[u,d]}b(u){return p(u)}}e.$ju=T;function p(y){return y.toLowerCase()}function a(y,u){return R(p(y),u.map(p))}function R(y,u){if(y==="*/*")return u.length>0;if(u.includes(y))return!0;const E=y.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!E)return!1;const[d,n,s]=E;return s==="*"?u.some(o=>o.startsWith(n+"/")):!1}e.$lu=Object.freeze({create:y=>(0,w.$Ob)(y.map(u=>u.toString())).join(`\r
`),split:y=>y.split(`\r
`),parse:y=>e.$lu.split(y).filter(u=>!u.startsWith("#"))})}),define(ke[148],Ce([1,0,28]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringEOL=void 0,e.$ru=k;var S;(function(O){O[O.Unknown=0]="Unknown",O[O.Invalid=3]="Invalid",O[O.LF=1]="LF",O[O.CRLF=2]="CRLF"})(S||(e.StringEOL=S={}));function k(O){let A=0,T=0,p=0,a=S.Unknown;for(let R=0,y=O.length;R<y;R++){const u=O.charCodeAt(R);u===w.CharCode.CarriageReturn?(A===0&&(T=R),A++,R+1<y&&O.charCodeAt(R+1)===w.CharCode.LineFeed?(a|=S.CRLF,R++):a|=S.Invalid,p=R+1):u===w.CharCode.LineFeed&&(a|=S.LF,A===0&&(T=R),A++,p=R+1)}return A===0&&(T=O.length),[A,T,O.length-p,a]}}),define(ke[149],Ce([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$et=void 0,e.$et={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(ke[150],Ce([1,0,28,151]),function(oe,e,w,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pu=e.$Ou=e.IndentAction=void 0;var k;(function(p){p[p.None=0]="None",p[p.Indent=1]="Indent",p[p.IndentOutdent=2]="IndentOutdent",p[p.Outdent=3]="Outdent"})(k||(e.IndentAction=k={}));class O{constructor(a){if(this.e=null,this.f=!1,this.open=a.open,this.close=a.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray(a.notIn))for(let R=0,y=a.notIn.length;R<y;R++)switch(a.notIn[R]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK(a){switch(a){case S.StandardTokenType.Other:return!0;case S.StandardTokenType.Comment:return this.c;case S.StandardTokenType.String:return this.b;case S.StandardTokenType.RegEx:return this.d}}shouldAutoClose(a,R){if(a.getTokenCount()===0)return!0;const y=a.findTokenIndexAtOffset(R-2),u=a.getStandardTokenType(y);return this.isOK(u)}g(a,R){for(let y=a;y<=R;y++){const u=String.fromCharCode(y);if(!this.open.includes(u)&&!this.close.includes(u))return u}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(w.CharCode.Digit0,w.CharCode.Digit9)),this.e||(this.e=this.g(w.CharCode.a,w.CharCode.z)),this.e||(this.e=this.g(w.CharCode.A,w.CharCode.Z))),this.e}}e.$Ou=O;class A{constructor(a){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const R of a)T(this.autoClosingPairsOpenByStart,R.open.charAt(0),R),T(this.autoClosingPairsOpenByEnd,R.open.charAt(R.open.length-1),R),T(this.autoClosingPairsCloseByStart,R.close.charAt(0),R),T(this.autoClosingPairsCloseByEnd,R.close.charAt(R.close.length-1),R),R.close.length===1&&R.open.length===1&&T(this.autoClosingPairsCloseSingleChar,R.close,R)}}e.$Pu=A;function T(p,a,R){p.has(a)?p.get(a).push(R):p.set(a,[R])}}),define(ke[152],Ce([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ZC=e.NodeColor=e.$YC=void 0,e.$1C=k,e.$2C=O,e.$3C=a,e.$4C=R,e.$5C=y,e.$6C=u,e.$7C=E,e.$8C=d;class w{constructor(s,o){this.piece=s,this.color=o,this.size_left=0,this.lf_left=0,this.parent=this,this.left=this,this.right=this}next(){if(this.right!==e.$ZC)return k(this.right);let s=this;for(;s.parent!==e.$ZC&&s.parent.left!==s;)s=s.parent;return s.parent===e.$ZC?e.$ZC:s.parent}prev(){if(this.left!==e.$ZC)return O(this.left);let s=this;for(;s.parent!==e.$ZC&&s.parent.right!==s;)s=s.parent;return s.parent===e.$ZC?e.$ZC:s.parent}detach(){this.parent=null,this.left=null,this.right=null}}e.$YC=w;var S;(function(n){n[n.Black=0]="Black",n[n.Red=1]="Red"})(S||(e.NodeColor=S={})),e.$ZC=new w(null,S.Black),e.$ZC.parent=e.$ZC,e.$ZC.left=e.$ZC,e.$ZC.right=e.$ZC,e.$ZC.color=S.Black;function k(n){for(;n.left!==e.$ZC;)n=n.left;return n}function O(n){for(;n.right!==e.$ZC;)n=n.right;return n}function A(n){return n===e.$ZC?0:n.size_left+n.piece.length+A(n.right)}function T(n){return n===e.$ZC?0:n.lf_left+n.piece.lineFeedCnt+T(n.right)}function p(){e.$ZC.parent=e.$ZC}function a(n,s){const o=s.right;o.size_left+=s.size_left+(s.piece?s.piece.length:0),o.lf_left+=s.lf_left+(s.piece?s.piece.lineFeedCnt:0),s.right=o.left,o.left!==e.$ZC&&(o.left.parent=s),o.parent=s.parent,s.parent===e.$ZC?n.root=o:s.parent.left===s?s.parent.left=o:s.parent.right=o,o.left=s,s.parent=o}function R(n,s){const o=s.left;s.left=o.right,o.right!==e.$ZC&&(o.right.parent=s),o.parent=s.parent,s.size_left-=o.size_left+(o.piece?o.piece.length:0),s.lf_left-=o.lf_left+(o.piece?o.piece.lineFeedCnt:0),s.parent===e.$ZC?n.root=o:s===s.parent.right?s.parent.right=o:s.parent.left=o,o.right=s,s.parent=o}function y(n,s){let o,h;if(s.left===e.$ZC?(h=s,o=h.right):s.right===e.$ZC?(h=s,o=h.left):(h=k(s.right),o=h.right),h===n.root){n.root=o,o.color=S.Black,s.detach(),p(),n.root.parent=e.$ZC;return}const i=h.color===S.Red;if(h===h.parent.left?h.parent.left=o:h.parent.right=o,h===s?(o.parent=h.parent,d(n,o)):(h.parent===s?o.parent=h:o.parent=h.parent,d(n,o),h.left=s.left,h.right=s.right,h.parent=s.parent,h.color=s.color,s===n.root?n.root=h:s===s.parent.left?s.parent.left=h:s.parent.right=h,h.left!==e.$ZC&&(h.left.parent=h),h.right!==e.$ZC&&(h.right.parent=h),h.size_left=s.size_left,h.lf_left=s.lf_left,d(n,h)),s.detach(),o.parent.left===o){const t=A(o),c=T(o);if(t!==o.parent.size_left||c!==o.parent.lf_left){const l=t-o.parent.size_left,m=c-o.parent.lf_left;o.parent.size_left=t,o.parent.lf_left=c,E(n,o.parent,l,m)}}if(d(n,o.parent),i){p();return}let r;for(;o!==n.root&&o.color===S.Black;)o===o.parent.left?(r=o.parent.right,r.color===S.Red&&(r.color=S.Black,o.parent.color=S.Red,a(n,o.parent),r=o.parent.right),r.left.color===S.Black&&r.right.color===S.Black?(r.color=S.Red,o=o.parent):(r.right.color===S.Black&&(r.left.color=S.Black,r.color=S.Red,R(n,r),r=o.parent.right),r.color=o.parent.color,o.parent.color=S.Black,r.right.color=S.Black,a(n,o.parent),o=n.root)):(r=o.parent.left,r.color===S.Red&&(r.color=S.Black,o.parent.color=S.Red,R(n,o.parent),r=o.parent.left),r.left.color===S.Black&&r.right.color===S.Black?(r.color=S.Red,o=o.parent):(r.left.color===S.Black&&(r.right.color=S.Black,r.color=S.Red,a(n,r),r=o.parent.left),r.color=o.parent.color,o.parent.color=S.Black,r.left.color=S.Black,R(n,o.parent),o=n.root));o.color=S.Black,p()}function u(n,s){for(d(n,s);s!==n.root&&s.parent.color===S.Red;)if(s.parent===s.parent.parent.left){const o=s.parent.parent.right;o.color===S.Red?(s.parent.color=S.Black,o.color=S.Black,s.parent.parent.color=S.Red,s=s.parent.parent):(s===s.parent.right&&(s=s.parent,a(n,s)),s.parent.color=S.Black,s.parent.parent.color=S.Red,R(n,s.parent.parent))}else{const o=s.parent.parent.left;o.color===S.Red?(s.parent.color=S.Black,o.color=S.Black,s.parent.parent.color=S.Red,s=s.parent.parent):(s===s.parent.left&&(s=s.parent,R(n,s)),s.parent.color=S.Black,s.parent.parent.color=S.Red,a(n,s.parent.parent))}n.root.color=S.Black}function E(n,s,o,h){for(;s!==n.root&&s!==e.$ZC;)s.parent.left===s&&(s.parent.size_left+=o,s.parent.lf_left+=h),s=s.parent}function d(n,s){let o=0,h=0;if(s!==n.root){for(;s!==n.root&&s===s.parent.right;)s=s.parent;if(s!==n.root)for(s=s.parent,o=A(s.left)-s.size_left,h=T(s.left)-s.lf_left,s.size_left+=o,s.lf_left+=h;s!==n.root&&(o!==0||h!==0);)s.parent.left===s&&(s.parent.size_left+=o,s.parent.lf_left+=h),s=s.parent}}}),define(ke[100],Ce([1,0,28,101,33,52,152,102]),function(oe,e,w,S,k,O,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gD=e.$fD=e.$eD=void 0,e.$cD=y,e.$dD=u;const p=65535;function a(h){let i;return h[h.length-1]<65536?i=new Uint16Array(h.length):i=new Uint32Array(h.length),i.set(h,0),i}class R{constructor(i,r,t,c,l){this.lineStarts=i,this.cr=r,this.lf=t,this.crlf=c,this.isBasicASCII=l}}function y(h,i=!0){const r=[0];let t=1;for(let c=0,l=h.length;c<l;c++){const m=h.charCodeAt(c);m===w.CharCode.CarriageReturn?c+1<l&&h.charCodeAt(c+1)===w.CharCode.LineFeed?(r[t++]=c+2,c++):r[t++]=c+1:m===w.CharCode.LineFeed&&(r[t++]=c+1)}return i?a(r):r}function u(h,i){h.length=0,h[0]=0;let r=1,t=0,c=0,l=0,m=!0;for(let $=0,I=i.length;$<I;$++){const D=i.charCodeAt($);D===w.CharCode.CarriageReturn?$+1<I&&i.charCodeAt($+1)===w.CharCode.LineFeed?(l++,h[r++]=$+2,$++):(t++,h[r++]=$+1):D===w.CharCode.LineFeed?(c++,h[r++]=$+1):m&&D!==w.CharCode.Tab&&(D<32||D>126)&&(m=!1)}const f=new R(a(h),t,c,l,m);return h.length=0,f}class E{constructor(i,r,t,c,l){this.bufferIndex=i,this.start=r,this.end=t,this.lineFeedCnt=c,this.length=l}}e.$eD=E;class d{constructor(i,r){this.buffer=i,this.lineStarts=r}}e.$fD=d;class n{constructor(i,r){this.a=[],this.c=i,this.d=r,this.b=0,i.root!==A.$ZC&&i.iterate(i.root,t=>(t!==A.$ZC&&this.a.push(t.piece),!0))}read(){return this.a.length===0?this.b===0?(this.b++,this.d):null:this.b>this.a.length-1?null:this.b===0?this.d+this.c.getPieceContent(this.a[this.b++]):this.c.getPieceContent(this.a[this.b++])}}class s{constructor(i){this.a=i,this.b=[]}get(i){for(let r=this.b.length-1;r>=0;r--){const t=this.b[r];if(t.nodeStartOffset<=i&&t.nodeStartOffset+t.node.piece.length>=i)return t}return null}get2(i){for(let r=this.b.length-1;r>=0;r--){const t=this.b[r];if(t.nodeStartLineNumber&&t.nodeStartLineNumber<i&&t.nodeStartLineNumber+t.node.piece.lineFeedCnt>=i)return t}return null}set(i){this.b.length>=this.a&&this.b.shift(),this.b.push(i)}validate(i){let r=!1;const t=this.b;for(let c=0;c<t.length;c++){const l=t[c];if(l.node.parent===null||l.nodeStartOffset>=i){t[c]=null,r=!0;continue}}if(r){const c=[];for(const l of t)l!==null&&c.push(l);this.b=c}}}class o{constructor(i,r,t){this.create(i,r,t)}create(i,r,t){this.a=[new d("",[0])],this.g={line:0,column:0},this.root=A.$ZC,this.b=1,this.c=0,this.d=r,this.e=r.length,this.f=t;let c=null;for(let l=0,m=i.length;l<m;l++)if(i[l].buffer.length>0){i[l].lineStarts||(i[l].lineStarts=y(i[l].buffer));const f=new E(l+1,{line:0,column:0},{line:i[l].lineStarts.length-1,column:i[l].buffer.length-i[l].lineStarts[i[l].lineStarts.length-1]},i[l].lineStarts.length-1,i[l].buffer.length);this.a.push(i[l]),c=this.S(c,f)}this.h=new s(1),this.j={lineNumber:0,value:""},this.y()}normalizeEOL(i){const r=p,t=r-Math.floor(r/3),c=t*2;let l="",m=0;const f=[];if(this.iterate(this.root,$=>{const I=this.R($),D=I.length;if(m<=t||m+D<c)return l+=I,m+=D,!0;const v=l.replace(/\r\n|\r|\n/g,i);return f.push(new d(v,y(v))),l=I,m=D,!0}),m>0){const $=l.replace(/\r\n|\r|\n/g,i);f.push(new d($,y($)))}this.create(f,i,!0)}getEOL(){return this.d}setEOL(i){this.d=i,this.e=this.d.length,this.normalizeEOL(i)}createSnapshot(i){return new n(this,i)}equal(i){if(this.getLength()!==i.getLength()||this.getLineCount()!==i.getLineCount())return!1;let r=0;return this.iterate(this.root,c=>{if(c===A.$ZC)return!0;const l=this.R(c),m=l.length,f=i.G(r),$=i.G(r+m),I=i.getValueInRange2(f,$);return r+=m,l===I})}getOffsetAt(i,r){let t=0,c=this.root;for(;c!==A.$ZC;)if(c.left!==A.$ZC&&c.lf_left+1>=i)c=c.left;else if(c.lf_left+c.piece.lineFeedCnt+1>=i){t+=c.size_left;const l=this.B(c,i-c.lf_left-2);return t+=l+r-1}else i-=c.lf_left+c.piece.lineFeedCnt,t+=c.size_left+c.piece.length,c=c.right;return t}getPositionAt(i){i=Math.floor(i),i=Math.max(0,i);let r=this.root,t=0;const c=i;for(;r!==A.$ZC;)if(r.size_left!==0&&r.size_left>=i)r=r.left;else if(r.size_left+r.piece.length>=i){const l=this.A(r,i-r.size_left);if(t+=r.lf_left+l.index,l.index===0){const m=this.getOffsetAt(t+1,1),f=c-m;return new S.$Gt(t+1,f+1)}return new S.$Gt(t+1,l.remainder+1)}else if(i-=r.size_left+r.piece.length,t+=r.lf_left+r.piece.lineFeedCnt,r.right===A.$ZC){const l=this.getOffsetAt(t+1,1),m=c-i-l;return new S.$Gt(t+1,m+1)}else r=r.right;return new S.$Gt(1,1)}getValueInRange(i,r){if(i.startLineNumber===i.endLineNumber&&i.startColumn===i.endColumn)return"";const t=this.H(i.startLineNumber,i.startColumn),c=this.H(i.endLineNumber,i.endColumn),l=this.getValueInRange2(t,c);return r?r!==this.d||!this.f?l.replace(/\r\n|\r|\n/g,r):r===this.getEOL()&&this.f?l:l.replace(/\r\n|\r|\n/g,r):l}getValueInRange2(i,r){if(i.node===r.node){const f=i.node,$=this.a[f.piece.bufferIndex].buffer,I=this.u(f.piece.bufferIndex,f.piece.start);return $.substring(I+i.remainder,I+r.remainder)}let t=i.node;const c=this.a[t.piece.bufferIndex].buffer,l=this.u(t.piece.bufferIndex,t.piece.start);let m=c.substring(l+i.remainder,l+t.piece.length);for(t=t.next();t!==A.$ZC;){const f=this.a[t.piece.bufferIndex].buffer,$=this.u(t.piece.bufferIndex,t.piece.start);if(t===r.node){m+=f.substring($,$+r.remainder);break}else m+=f.substr($,t.piece.length);t=t.next()}return m}getLinesContent(){const i=[];let r=0,t="",c=!1;return this.iterate(this.root,l=>{if(l===A.$ZC)return!0;const m=l.piece;let f=m.length;if(f===0)return!0;const $=this.a[m.bufferIndex].buffer,I=this.a[m.bufferIndex].lineStarts,D=m.start.line,v=m.end.line;let C=I[D]+m.start.column;if(c&&($.charCodeAt(C)===w.CharCode.LineFeed&&(C++,f--),i[r++]=t,t="",c=!1,f===0))return!0;if(D===v)return!this.f&&$.charCodeAt(C+f-1)===w.CharCode.CarriageReturn?(c=!0,t+=$.substr(C,f-1)):t+=$.substr(C,f),!0;t+=this.f?$.substring(C,Math.max(C,I[D+1]-this.e)):$.substring(C,I[D+1]).replace(/(\r\n|\r|\n)$/,""),i[r++]=t;for(let P=D+1;P<v;P++)t=this.f?$.substring(I[P],I[P+1]-this.e):$.substring(I[P],I[P+1]).replace(/(\r\n|\r|\n)$/,""),i[r++]=t;return!this.f&&$.charCodeAt(I[v]+m.end.column-1)===w.CharCode.CarriageReturn?(c=!0,m.end.column===0?r--:t=$.substr(I[v],m.end.column-1)):t=$.substr(I[v],m.end.column),!0}),c&&(i[r++]=t,t=""),i[r++]=t,i}getLength(){return this.c}getLineCount(){return this.b}getLineContent(i){return this.j.lineNumber===i?this.j.value:(this.j.lineNumber=i,i===this.b?this.j.value=this.getLineRawContent(i):this.f?this.j.value=this.getLineRawContent(i,this.e):this.j.value=this.getLineRawContent(i).replace(/(\r\n|\r|\n)$/,""),this.j.value)}l(i){if(i.remainder===i.node.piece.length){const r=i.node.next();if(!r)return 0;const t=this.a[r.piece.bufferIndex],c=this.u(r.piece.bufferIndex,r.piece.start);return t.buffer.charCodeAt(c)}else{const r=this.a[i.node.piece.bufferIndex],c=this.u(i.node.piece.bufferIndex,i.node.piece.start)+i.remainder;return r.buffer.charCodeAt(c)}}getLineCharCode(i,r){const t=this.H(i,r+1);return this.l(t)}getLineLength(i){if(i===this.getLineCount()){const r=this.getOffsetAt(i,1);return this.getLength()-r}return this.getOffsetAt(i+1,1)-this.getOffsetAt(i,1)-this.e}getCharCode(i){const r=this.G(i);return this.l(r)}getNearestChunk(i){const r=this.G(i);if(r.remainder===r.node.piece.length){const t=r.node.next();if(!t||t===A.$ZC)return"";const c=this.a[t.piece.bufferIndex],l=this.u(t.piece.bufferIndex,t.piece.start);return c.buffer.substring(l,l+t.piece.length)}else{const t=this.a[r.node.piece.bufferIndex],c=this.u(r.node.piece.bufferIndex,r.node.piece.start),l=c+r.remainder,m=c+r.node.piece.length;return t.buffer.substring(l,m)}}findMatchesInNode(i,r,t,c,l,m,f,$,I,D,v){const C=this.a[i.piece.bufferIndex],P=this.u(i.piece.bufferIndex,i.piece.start),g=this.u(i.piece.bufferIndex,l),b=this.u(i.piece.bufferIndex,m);let L;const N={line:0,column:0};let B,G;r._wordSeparators?(B=C.buffer.substring(g,b),G=W=>W+g,r.reset(0)):(B=C.buffer,G=W=>W,r.reset(g));do if(L=r.next(B),L){if(G(L.index)>=b)return D;this.s(i,G(L.index)-P,N);const W=this.t(i.piece.bufferIndex,l,N),F=N.line===l.line?N.column-l.column+c:N.column+1,q=F+L[0].length;if(v[D++]=(0,T.$$C)(new k.$Ht(t+W,F,t+W,q),L,$),G(L.index)+L[0].length>=b||D>=I)return D}while(L);return D}findMatchesLineByLine(i,r,t,c){const l=[];let m=0;const f=new T.$bD(r.wordSeparators,r.regex);let $=this.H(i.startLineNumber,i.startColumn);if($===null)return[];const I=this.H(i.endLineNumber,i.endColumn);if(I===null)return[];let D=this.s($.node,$.remainder);const v=this.s(I.node,I.remainder);if($.node===I.node)return this.findMatchesInNode($.node,f,i.startLineNumber,i.startColumn,D,v,r,t,c,m,l),l;let C=i.startLineNumber,P=$.node;for(;P!==I.node;){const b=this.t(P.piece.bufferIndex,D,P.piece.end);if(b>=1){const N=this.a[P.piece.bufferIndex].lineStarts,B=this.u(P.piece.bufferIndex,P.piece.start),G=N[D.line+b],W=C===i.startLineNumber?i.startColumn:1;if(m=this.findMatchesInNode(P,f,C,W,D,this.s(P,G-B),r,t,c,m,l),m>=c)return l;C+=b}const L=C===i.startLineNumber?i.startColumn-1:0;if(C===i.endLineNumber){const N=this.getLineContent(C).substring(L,i.endColumn-1);return m=this.n(r,f,N,i.endLineNumber,L,m,l,t,c),l}if(m=this.n(r,f,this.getLineContent(C).substr(L),C,L,m,l,t,c),m>=c)return l;C++,$=this.H(C,1),P=$.node,D=this.s($.node,$.remainder)}if(C===i.endLineNumber){const b=C===i.startLineNumber?i.startColumn-1:0,L=this.getLineContent(C).substring(b,i.endColumn-1);return m=this.n(r,f,L,i.endLineNumber,b,m,l,t,c),l}const g=C===i.startLineNumber?i.startColumn:1;return m=this.findMatchesInNode(I.node,f,C,g,D,v,r,t,c,m,l),l}n(i,r,t,c,l,m,f,$,I){const D=i.wordSeparators;if(!$&&i.simpleSearch){const C=i.simpleSearch,P=C.length,g=t.length;let b=-P;for(;(b=t.indexOf(C,b+P))!==-1;)if((!D||(0,T.$aD)(D,t,g,b,P))&&(f[m++]=new O.$9v(new k.$Ht(c,b+1+l,c,b+1+P+l),null),m>=I))return m;return m}let v;r.reset(0);do if(v=r.next(t),v&&(f[m++]=(0,T.$$C)(new k.$Ht(c,v.index+1+l,c,v.index+1+v[0].length+l),v,$),m>=I))return m;while(v);return m}insert(i,r,t=!1){if(this.f=this.f&&t,this.j.lineNumber=0,this.j.value="",this.root!==A.$ZC){const{node:c,remainder:l,nodeStartOffset:m}=this.G(i),f=c.piece,$=f.bufferIndex,I=this.s(c,l);if(c.piece.bufferIndex===0&&f.end.line===this.g.line&&f.end.column===this.g.column&&m+f.length===i&&r.length<p){this.F(c,r),this.y();return}if(m===i)this.o(r,c),this.h.validate(i);else if(m+c.piece.length>i){const D=[];let v=new E(f.bufferIndex,I,f.end,this.t(f.bufferIndex,I,f.end),this.u($,f.end)-this.u($,I));if(this.K()&&this.M(r)&&this.I(c,l)===10){const b={line:v.start.line+1,column:0};v=new E(v.bufferIndex,b,v.end,this.t(v.bufferIndex,b,v.end),v.length-1),r+=`
`}if(this.K()&&this.L(r))if(this.I(c,l-1)===13){const b=this.s(c,l-1);this.C(c,b),r="\r"+r,c.piece.length===0&&D.push(c)}else this.C(c,I);else this.C(c,I);const C=this.w(r);v.length>0&&this.S(c,v);let P=c;for(let g=0;g<C.length;g++)P=this.S(P,C[g]);this.v(D)}else this.q(r,c)}else{const c=this.w(r);let l=this.T(null,c[0]);for(let m=1;m<c.length;m++)l=this.S(l,c[m])}this.y()}delete(i,r){if(this.j.lineNumber=0,this.j.value="",r<=0||this.root===A.$ZC)return;const t=this.G(i),c=this.G(i+r),l=t.node,m=c.node;if(l===m){const C=this.s(l,t.remainder),P=this.s(l,c.remainder);if(t.nodeStartOffset===i){if(r===l.piece.length){const g=l.next();(0,A.$5C)(this,l),this.N(g),this.y();return}this.D(l,P),this.h.validate(i),this.N(l),this.y();return}if(t.nodeStartOffset+l.piece.length===i+r){this.C(l,C),this.O(l),this.y();return}this.E(l,C,P),this.y();return}const f=[],$=this.s(l,t.remainder);this.C(l,$),this.h.validate(i),l.piece.length===0&&f.push(l);const I=this.s(m,c.remainder);this.D(m,I),m.piece.length===0&&f.push(m);const D=l.next();for(let C=D;C!==A.$ZC&&C!==m;C=C.next())f.push(C);const v=l.piece.length===0?l.prev():l;this.v(f),this.O(v),this.y()}o(i,r){const t=[];if(this.K()&&this.M(i)&&this.L(r)){const m=r.piece,f={line:m.start.line+1,column:0},$=new E(m.bufferIndex,f,m.end,this.t(m.bufferIndex,f,m.end),m.length-1);r.piece=$,i+=`
`,(0,A.$7C)(this,r,-1,-1),r.piece.length===0&&t.push(r)}const c=this.w(i);let l=this.T(r,c[c.length-1]);for(let m=c.length-2;m>=0;m--)l=this.T(l,c[m]);this.N(l),this.v(t)}q(i,r){this.Q(i,r)&&(i+=`
`);const t=this.w(i),c=this.S(r,t[0]);let l=c;for(let m=1;m<t.length;m++)l=this.S(l,t[m]);this.N(c)}s(i,r,t){const c=i.piece,l=i.piece.bufferIndex,m=this.a[l].lineStarts,$=m[c.start.line]+c.start.column+r;let I=c.start.line,D=c.end.line,v=0,C=0,P=0;for(;I<=D&&(v=I+(D-I)/2|0,P=m[v],v!==D);)if(C=m[v+1],$<P)D=v-1;else if($>=C)I=v+1;else break;return t?(t.line=v,t.column=$-P,null):{line:v,column:$-P}}t(i,r,t){if(t.column===0)return t.line-r.line;const c=this.a[i].lineStarts;if(t.line===c.length-1)return t.line-r.line;const l=c[t.line+1],m=c[t.line]+t.column;if(l>m+1)return t.line-r.line;const f=m-1;return this.a[i].buffer.charCodeAt(f)===13?t.line-r.line+1:t.line-r.line}u(i,r){return this.a[i].lineStarts[r.line]+r.column}v(i){for(let r=0;r<i.length;r++)(0,A.$5C)(this,i[r])}w(i){if(i.length>p){const D=[];for(;i.length>p;){const C=i.charCodeAt(p-1);let P;C===w.CharCode.CarriageReturn||C>=55296&&C<=56319?(P=i.substring(0,p-1),i=i.substring(p-1)):(P=i.substring(0,p),i=i.substring(p));const g=y(P);D.push(new E(this.a.length,{line:0,column:0},{line:g.length-1,column:P.length-g[g.length-1]},g.length-1,P.length)),this.a.push(new d(P,g))}const v=y(i);return D.push(new E(this.a.length,{line:0,column:0},{line:v.length-1,column:i.length-v[v.length-1]},v.length-1,i.length)),this.a.push(new d(i,v)),D}let r=this.a[0].buffer.length;const t=y(i,!1);let c=this.g;if(this.a[0].lineStarts[this.a[0].lineStarts.length-1]===r&&r!==0&&this.L(i)&&this.M(this.a[0].buffer)){this.g={line:this.g.line,column:this.g.column+1},c=this.g;for(let D=0;D<t.length;D++)t[D]+=r+1;this.a[0].lineStarts=this.a[0].lineStarts.concat(t.slice(1)),this.a[0].buffer+="_"+i,r+=1}else{if(r!==0)for(let D=0;D<t.length;D++)t[D]+=r;this.a[0].lineStarts=this.a[0].lineStarts.concat(t.slice(1)),this.a[0].buffer+=i}const l=this.a[0].buffer.length,m=this.a[0].lineStarts.length-1,f=l-this.a[0].lineStarts[m],$={line:m,column:f},I=new E(0,c,$,this.t(0,c,$),l-r);return this.g=$,[I]}getLinesRawContent(){return this.U(this.root)}getLineRawContent(i,r=0){let t=this.root,c="";const l=this.h.get2(i);if(l){t=l.node;const m=this.B(t,i-l.nodeStartLineNumber-1),f=this.a[t.piece.bufferIndex].buffer,$=this.u(t.piece.bufferIndex,t.piece.start);if(l.nodeStartLineNumber+t.piece.lineFeedCnt===i)c=f.substring($+m,$+t.piece.length);else{const I=this.B(t,i-l.nodeStartLineNumber);return f.substring($+m,$+I-r)}}else{let m=0;const f=i;for(;t!==A.$ZC;)if(t.left!==A.$ZC&&t.lf_left>=i-1)t=t.left;else if(t.lf_left+t.piece.lineFeedCnt>i-1){const $=this.B(t,i-t.lf_left-2),I=this.B(t,i-t.lf_left-1),D=this.a[t.piece.bufferIndex].buffer,v=this.u(t.piece.bufferIndex,t.piece.start);return m+=t.size_left,this.h.set({node:t,nodeStartOffset:m,nodeStartLineNumber:f-(i-1-t.lf_left)}),D.substring(v+$,v+I-r)}else if(t.lf_left+t.piece.lineFeedCnt===i-1){const $=this.B(t,i-t.lf_left-2),I=this.a[t.piece.bufferIndex].buffer,D=this.u(t.piece.bufferIndex,t.piece.start);c=I.substring(D+$,D+t.piece.length);break}else i-=t.lf_left+t.piece.lineFeedCnt,m+=t.size_left+t.piece.length,t=t.right}for(t=t.next();t!==A.$ZC;){const m=this.a[t.piece.bufferIndex].buffer;if(t.piece.lineFeedCnt>0){const f=this.B(t,0),$=this.u(t.piece.bufferIndex,t.piece.start);return c+=m.substring($,$+f-r),c}else{const f=this.u(t.piece.bufferIndex,t.piece.start);c+=m.substr(f,t.piece.length)}t=t.next()}return c}y(){let i=this.root,r=1,t=0;for(;i!==A.$ZC;)r+=i.lf_left+i.piece.lineFeedCnt,t+=i.size_left+i.piece.length,i=i.right;this.b=r,this.c=t,this.h.validate(this.c)}A(i,r){const t=i.piece,c=this.s(i,r),l=c.line-t.start.line;if(this.u(t.bufferIndex,t.end)-this.u(t.bufferIndex,t.start)===r){const m=this.t(i.piece.bufferIndex,t.start,c);if(m!==l)return{index:m,remainder:0}}return{index:l,remainder:c.column}}B(i,r){if(r<0)return 0;const t=i.piece,c=this.a[t.bufferIndex].lineStarts,l=t.start.line+r+1;return l>t.end.line?c[t.end.line]+t.end.column-c[t.start.line]-t.start.column:c[l]-c[t.start.line]-t.start.column}C(i,r){const t=i.piece,c=t.lineFeedCnt,l=this.u(t.bufferIndex,t.end),m=r,f=this.u(t.bufferIndex,m),$=this.t(t.bufferIndex,t.start,m),I=$-c,D=f-l,v=t.length+D;i.piece=new E(t.bufferIndex,t.start,m,$,v),(0,A.$7C)(this,i,D,I)}D(i,r){const t=i.piece,c=t.lineFeedCnt,l=this.u(t.bufferIndex,t.start),m=r,f=this.t(t.bufferIndex,m,t.end),$=this.u(t.bufferIndex,m),I=f-c,D=l-$,v=t.length+D;i.piece=new E(t.bufferIndex,m,t.end,f,v),(0,A.$7C)(this,i,D,I)}E(i,r,t){const c=i.piece,l=c.start,m=c.end,f=c.length,$=c.lineFeedCnt,I=r,D=this.t(c.bufferIndex,c.start,I),v=this.u(c.bufferIndex,r)-this.u(c.bufferIndex,l);i.piece=new E(c.bufferIndex,c.start,I,D,v),(0,A.$7C)(this,i,v-f,D-$);const C=new E(c.bufferIndex,t,m,this.t(c.bufferIndex,t,m),this.u(c.bufferIndex,m)-this.u(c.bufferIndex,t)),P=this.S(i,C);this.N(P)}F(i,r){this.Q(r,i)&&(r+=`
`);const t=this.K()&&this.L(r)&&this.M(i),c=this.a[0].buffer.length;this.a[0].buffer+=r;const l=y(r,!1);for(let P=0;P<l.length;P++)l[P]+=c;if(t){const P=this.a[0].lineStarts[this.a[0].lineStarts.length-2];this.a[0].lineStarts.pop(),this.g={line:this.g.line-1,column:c-P}}this.a[0].lineStarts=this.a[0].lineStarts.concat(l.slice(1));const m=this.a[0].lineStarts.length-1,f=this.a[0].buffer.length-this.a[0].lineStarts[m],$={line:m,column:f},I=i.piece.length+r.length,D=i.piece.lineFeedCnt,v=this.t(0,i.piece.start,$),C=v-D;i.piece=new E(i.piece.bufferIndex,i.piece.start,$,v,I),this.g=$,(0,A.$7C)(this,i,r.length,C)}G(i){let r=this.root;const t=this.h.get(i);if(t)return{node:t.node,nodeStartOffset:t.nodeStartOffset,remainder:i-t.nodeStartOffset};let c=0;for(;r!==A.$ZC;)if(r.size_left>i)r=r.left;else if(r.size_left+r.piece.length>=i){c+=r.size_left;const l={node:r,remainder:i-r.size_left,nodeStartOffset:c};return this.h.set(l),l}else i-=r.size_left+r.piece.length,c+=r.size_left+r.piece.length,r=r.right;return null}H(i,r){let t=this.root,c=0;for(;t!==A.$ZC;)if(t.left!==A.$ZC&&t.lf_left>=i-1)t=t.left;else if(t.lf_left+t.piece.lineFeedCnt>i-1){const l=this.B(t,i-t.lf_left-2),m=this.B(t,i-t.lf_left-1);return c+=t.size_left,{node:t,remainder:Math.min(l+r-1,m),nodeStartOffset:c}}else if(t.lf_left+t.piece.lineFeedCnt===i-1){const l=this.B(t,i-t.lf_left-2);if(l+r-1<=t.piece.length)return{node:t,remainder:l+r-1,nodeStartOffset:c};r-=t.piece.length-l;break}else i-=t.lf_left+t.piece.lineFeedCnt,c+=t.size_left+t.piece.length,t=t.right;for(t=t.next();t!==A.$ZC;){if(t.piece.lineFeedCnt>0){const l=this.B(t,0),m=this.J(t);return{node:t,remainder:Math.min(r-1,l),nodeStartOffset:m}}else if(t.piece.length>=r-1){const l=this.J(t);return{node:t,remainder:r-1,nodeStartOffset:l}}else r-=t.piece.length;t=t.next()}return null}I(i,r){if(i.piece.lineFeedCnt<1)return-1;const t=this.a[i.piece.bufferIndex],c=this.u(i.piece.bufferIndex,i.piece.start)+r;return t.buffer.charCodeAt(c)}J(i){if(!i)return 0;let r=i.size_left;for(;i!==this.root;)i.parent.right===i&&(r+=i.parent.size_left+i.parent.piece.length),i=i.parent;return r}K(){return!(this.f&&this.d===`
`)}L(i){if(typeof i=="string")return i.charCodeAt(0)===10;if(i===A.$ZC||i.piece.lineFeedCnt===0)return!1;const r=i.piece,t=this.a[r.bufferIndex].lineStarts,c=r.start.line,l=t[c]+r.start.column;return c===t.length-1||t[c+1]>l+1?!1:this.a[r.bufferIndex].buffer.charCodeAt(l)===10}M(i){return typeof i=="string"?i.charCodeAt(i.length-1)===13:i===A.$ZC||i.piece.lineFeedCnt===0?!1:this.I(i,i.piece.length-1)===13}N(i){if(this.K()&&this.L(i)){const r=i.prev();this.M(r)&&this.P(r,i)}}O(i){if(this.K()&&this.M(i)){const r=i.next();this.L(r)&&this.P(i,r)}}P(i,r){const t=[],c=this.a[i.piece.bufferIndex].lineStarts;let l;i.piece.end.column===0?l={line:i.piece.end.line-1,column:c[i.piece.end.line]-c[i.piece.end.line-1]-1}:l={line:i.piece.end.line,column:i.piece.end.column-1};const m=i.piece.length-1,f=i.piece.lineFeedCnt-1;i.piece=new E(i.piece.bufferIndex,i.piece.start,l,f,m),(0,A.$7C)(this,i,-1,-1),i.piece.length===0&&t.push(i);const $={line:r.piece.start.line+1,column:0},I=r.piece.length-1,D=this.t(r.piece.bufferIndex,$,r.piece.end);r.piece=new E(r.piece.bufferIndex,$,r.piece.end,D,I),(0,A.$7C)(this,r,-1,-1),r.piece.length===0&&t.push(r);const v=this.w(`\r
`);this.S(i,v[0]);for(let C=0;C<t.length;C++)(0,A.$5C)(this,t[C])}Q(i,r){if(this.K()&&this.M(i)){const t=r.next();if(this.L(t)){if(i+=`
`,t.piece.length===1)(0,A.$5C)(this,t);else{const c=t.piece,l={line:c.start.line+1,column:0},m=c.length-1,f=this.t(c.bufferIndex,l,c.end);t.piece=new E(c.bufferIndex,l,c.end,f,m),(0,A.$7C)(this,t,-1,-1)}return!0}}return!1}iterate(i,r){if(i===A.$ZC)return r(A.$ZC);const t=this.iterate(i.left,r);return t&&r(i)&&this.iterate(i.right,r)}R(i){if(i===A.$ZC)return"";const r=this.a[i.piece.bufferIndex],t=i.piece,c=this.u(t.bufferIndex,t.start),l=this.u(t.bufferIndex,t.end);return r.buffer.substring(c,l)}getPieceContent(i){const r=this.a[i.bufferIndex],t=this.u(i.bufferIndex,i.start),c=this.u(i.bufferIndex,i.end);return r.buffer.substring(t,c)}S(i,r){const t=new A.$YC(r,A.NodeColor.Red);if(t.left=A.$ZC,t.right=A.$ZC,t.parent=A.$ZC,t.size_left=0,t.lf_left=0,this.root===A.$ZC)this.root=t,t.color=A.NodeColor.Black;else if(i.right===A.$ZC)i.right=t,t.parent=i;else{const l=(0,A.$1C)(i.right);l.left=t,t.parent=l}return(0,A.$6C)(this,t),t}T(i,r){const t=new A.$YC(r,A.NodeColor.Red);if(t.left=A.$ZC,t.right=A.$ZC,t.parent=A.$ZC,t.size_left=0,t.lf_left=0,this.root===A.$ZC)this.root=t,t.color=A.NodeColor.Black;else if(i.left===A.$ZC)i.left=t,t.parent=i;else{const c=(0,A.$2C)(i.left);c.right=t,t.parent=c}return(0,A.$6C)(this,t),t}U(i){let r="";return this.iterate(i,t=>(r+=this.R(t),!0)),r}}e.$gD=o}),define(ke[153],Ce([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$s_=e.$r_=void 0;class w{constructor(){this.a=new Map}removeDragOperationTransfer(O){if(O&&this.a.has(O)){const A=this.a.get(O);return this.a.delete(O),A}}addDragOperationTransfer(O,A){this.a.set(O,A)}}e.$r_=w;class S{constructor(O){this.identifier=O}}e.$s_=S}),define(ke[154],Ce([8,9]),function(oe,e){return oe.create("vs/base/common/actions",e)}),define(ke[155],Ce([1,0,6,4,154]),function(oe,e,w,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oj=e.$nj=e.$mj=e.$lj=e.$kj=void 0,e.$pj=R,k=qe(k);class O extends S.$Wc{constructor(u,E="",d="",n=!0,s){super(),this.j=this.B(new w.$me),this.onDidChange=this.j.event,this.z=!0,this.m=u,this.n=E,this.w=d,this.z=n,this.D=s}get id(){return this.m}get label(){return this.n}set label(u){this.F(u)}F(u){this.n!==u&&(this.n=u,this.j.fire({label:u}))}get tooltip(){return this.u||""}set tooltip(u){this.G(u)}G(u){this.u!==u&&(this.u=u,this.j.fire({tooltip:u}))}get class(){return this.w}set class(u){this.H(u)}H(u){this.w!==u&&(this.w=u,this.j.fire({class:u}))}get enabled(){return this.z}set enabled(u){this.I(u)}I(u){this.z!==u&&(this.z=u,this.j.fire({enabled:u}))}get checked(){return this.C}set checked(u){this.J(u)}J(u){this.C!==u&&(this.C=u,this.j.fire({checked:u}))}async run(u,E){this.D&&await this.D(u)}}e.$kj=O;class A extends S.$Wc{constructor(){super(...arguments),this.f=this.B(new w.$me),this.onWillRun=this.f.event,this.m=this.B(new w.$me),this.onDidRun=this.m.event}async run(u,E){if(!u.enabled)return;this.f.fire({action:u});let d;try{await this.u(u,E)}catch(n){d=n}this.m.fire({action:u,error:d})}async u(u,E){await u.run(E)}}e.$lj=A;class T{constructor(){this.id=T.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...u){let E=[];for(const d of u)d.length&&(E.length?E=[...E,new T,...d]:E=d);return E}static{this.ID="vs.actions.separator"}async run(){}}e.$mj=T;class p{get actions(){return this.a}constructor(u,E,d,n){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=u,this.label=E,this.class=n,this.a=d}async run(){}}e.$nj=p;class a extends O{static{this.ID="vs.actions.empty"}constructor(){super(a.ID,k.localize(0,null),void 0,!1)}}e.$oj=a;function R(y){return{id:y.id,label:y.label,tooltip:y.tooltip??y.label,class:y.class,enabled:y.enabled??!0,checked:y.checked,run:async(...u)=>y.run(...u)}}}),define(ke[156],Ce([8,9]),function(oe,e){return oe.create("vs/base/common/date",e)}),define(ke[157],Ce([1,0,156]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1m=a,e.$2m=R,e.$3m=y;const S=60,k=S*60,O=k*24,A=O*7,T=O*30,p=O*365;function a(u,E,d,n){typeof u!="number"&&(u=u.getTime());const s=Math.round((new Date().getTime()-u)/1e3);if(s<-30)return(0,w.localize)(0,null,a(new Date().getTime()+s*1e3,!1));if(!n&&s<30)return(0,w.localize)(1,null);let o;return s<S?(o=s,E?o===1?d?(0,w.localize)(2,null,o):(0,w.localize)(3,null,o):d?(0,w.localize)(4,null,o):(0,w.localize)(5,null,o):o===1?d?(0,w.localize)(6,null,o):(0,w.localize)(7,null,o):d?(0,w.localize)(8,null,o):(0,w.localize)(9,null,o)):s<k?(o=Math.floor(s/S),E?o===1?d?(0,w.localize)(10,null,o):(0,w.localize)(11,null,o):d?(0,w.localize)(12,null,o):(0,w.localize)(13,null,o):o===1?d?(0,w.localize)(14,null,o):(0,w.localize)(15,null,o):d?(0,w.localize)(16,null,o):(0,w.localize)(17,null,o)):s<O?(o=Math.floor(s/k),E?o===1?d?(0,w.localize)(18,null,o):(0,w.localize)(19,null,o):d?(0,w.localize)(20,null,o):(0,w.localize)(21,null,o):o===1?d?(0,w.localize)(22,null,o):(0,w.localize)(23,null,o):d?(0,w.localize)(24,null,o):(0,w.localize)(25,null,o)):s<A?(o=Math.floor(s/O),E?o===1?(0,w.localize)(26,null,o):(0,w.localize)(27,null,o):o===1?(0,w.localize)(28,null,o):(0,w.localize)(29,null,o)):s<T?(o=Math.floor(s/A),E?o===1?d?(0,w.localize)(30,null,o):(0,w.localize)(31,null,o):d?(0,w.localize)(32,null,o):(0,w.localize)(33,null,o):o===1?d?(0,w.localize)(34,null,o):(0,w.localize)(35,null,o):d?(0,w.localize)(36,null,o):(0,w.localize)(37,null,o)):s<p?(o=Math.floor(s/T),E?o===1?d?(0,w.localize)(38,null,o):(0,w.localize)(39,null,o):d?(0,w.localize)(40,null,o):(0,w.localize)(41,null,o):o===1?d?(0,w.localize)(42,null,o):(0,w.localize)(43,null,o):d?(0,w.localize)(44,null,o):(0,w.localize)(45,null,o)):(o=Math.floor(s/p),E?o===1?d?(0,w.localize)(46,null,o):(0,w.localize)(47,null,o):d?(0,w.localize)(48,null,o):(0,w.localize)(49,null,o):o===1?d?(0,w.localize)(50,null,o):(0,w.localize)(51,null,o):d?(0,w.localize)(52,null,o):(0,w.localize)(53,null,o))}function R(u,E){const d=Math.abs(u/1e3);return d<1?E?(0,w.localize)(54,null,u):(0,w.localize)(55,null,u):d<S?E?(0,w.localize)(56,null,Math.round(u)/1e3):(0,w.localize)(57,null,Math.round(u)/1e3):d<k?E?(0,w.localize)(58,null,Math.round(u/(1e3*S))):(0,w.localize)(59,null,Math.round(u/(1e3*S))):d<O?E?(0,w.localize)(60,null,Math.round(u/(1e3*k))):(0,w.localize)(61,null,Math.round(u/(1e3*k))):(0,w.localize)(62,null,Math.round(u/(1e3*O)))}function y(u){return u.getFullYear()+"-"+String(u.getMonth()+1).padStart(2,"0")+"-"+String(u.getDate()).padStart(2,"0")+"T"+String(u.getHours()).padStart(2,"0")+":"+String(u.getMinutes()).padStart(2,"0")+":"+String(u.getSeconds()).padStart(2,"0")+"."+(u.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}}),define(ke[158],Ce([8,9]),function(oe,e){return oe.create("vs/base/common/errorMessage",e)}),define(ke[48],Ce([1,0,18,15,158]),function(oe,e,w,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qj=p,e.$rj=a,e.$sj=R,w=qe(w),S=qe(S),k=qe(k);function O(y,u){return u&&(y.stack||y.stacktrace)?k.localize(0,null,T(y),A(y.stack)||A(y.stacktrace)):T(y)}function A(y){return Array.isArray(y)?y.join(`
`):y}function T(y){return y.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${y.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof y.code=="string"&&typeof y.errno=="number"&&typeof y.syscall=="string"?k.localize(1,null,y.message):y.message||k.localize(2,null)}function p(y=null,u=!1){if(!y)return k.localize(3,null);if(Array.isArray(y)){const E=w.$Jb(y),d=p(E[0],u);return E.length>1?k.localize(4,null,d,E.length):d}if(S.$fg(y))return y;if(y.detail){const E=y.detail;if(E.error)return O(E.error,u);if(E.exception)return O(E.exception,u)}return y.stack?O(y,u):y.message?y.message:k.localize(5,null)}function a(y){const u=y;return u instanceof Error&&Array.isArray(u.actions)}function R(y,u){let E;return typeof y=="string"?E=new Error(y):E=y,E.actions=u,E}}),define(ke[159],Ce([1,0,47,20]),function(oe,e,w,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tr=T,e.$ur=p,e.$vr=a,e.$wr=R,e.$xr=y,e.$yr=u,e.$zr=E,e.$Ar=d,e.$Br=n,e.$Cr=s,e.$Dr=$,e.$Er=I,e.$Fr=D;const k=new w.$X(()=>{const v=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:v,collatorIsNumeric:v.resolvedOptions().numeric}}),O=new w.$X(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),A=new w.$X(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function T(v,C,P=!1){const g=v||"",b=C||"",L=k.value.collator.compare(g,b);return k.value.collatorIsNumeric&&L===0&&g!==b?g<b?-1:1:L}function p(v,C){const P=O.value.collator;return v=v||"",C=C||"",r(P,v,C)}function a(v,C){const P=O.value.collator;return v=v||"",C=C||"",m(v,C)||r(P,v,C)}function R(v,C){const P=O.value.collator;return v=v||"",C=C||"",l(v,C)||r(P,v,C)}function y(v,C){return v=v||"",C=C||"",v===C?0:v<C?-1:1}function u(v,C){const[P,g]=h(v),[b,L]=h(C);let N=k.value.collator.compare(g,L);if(N===0){if(k.value.collatorIsNumeric&&g!==L)return g<L?-1:1;if(N=k.value.collator.compare(P,b),k.value.collatorIsNumeric&&N===0&&P!==b)return P<b?-1:1}return N}function E(v,C){v=v||"",C=C||"";const P=i(v),g=i(C),b=O.value.collator,L=A.value.collator;return r(L,P,g)||r(b,v,C)}function d(v,C){v=v||"",C=C||"";const P=i(v),g=i(C),b=O.value.collator,L=A.value.collator;return r(L,P,g)||m(v,C)||r(b,v,C)}function n(v,C){v=v||"",C=C||"";const P=i(v),g=i(C),b=O.value.collator,L=A.value.collator;return r(L,P,g)||l(v,C)||r(b,v,C)}function s(v,C){v=v||"",C=C||"";const P=i(v).toLowerCase(),g=i(C).toLowerCase();return P!==g?P<g?-1:1:v!==C?v<C?-1:1:0}const o=/^(.*?)(\.([^.]*))?$/;function h(v,C=!1){const P=v?o.exec(v):[];let g=[P&&P[1]||"",P&&P[3]||""];return C&&(!g[0]&&g[1]||g[0]&&g[0].charAt(0)===".")&&(g=[g[0]+"."+g[1],""]),g}function i(v){const C=v?o.exec(v):[];return C&&C[1]&&C[1].charAt(0)!=="."&&C[3]||""}function r(v,C,P){const g=v.compare(C,P);return g!==0?g:C.length!==P.length?C.length<P.length?-1:1:0}function t(v){const C=v.charAt(0);return C.toLocaleUpperCase()!==C}function c(v){const C=v.charAt(0);return C.toLocaleLowerCase()!==C}function l(v,C){return t(v)&&c(C)?-1:c(v)&&t(C)?1:0}function m(v,C){return c(v)&&t(C)?-1:t(v)&&c(C)?1:0}function f(v,C,P=!1){return P||(v=v&&v.toLowerCase(),C=C&&C.toLowerCase()),v===C?0:v<C?-1:1}function $(v,C,P=!1){const g=v.split(S.sep),b=C.split(S.sep),L=g.length-1,N=b.length-1;let B,G;for(let W=0;;W++){if(B=L===W,G=N===W,B&&G)return T(g[W],b[W],P);if(B)return-1;if(G)return 1;const F=f(g[W],b[W],P);if(F!==0)return F}}function I(v,C,P){const g=v.toLowerCase(),b=C.toLowerCase(),L=D(v,C,P);if(L)return L;const N=g.endsWith(P),B=b.endsWith(P);if(N!==B)return N?-1:1;const G=T(g,b);return G!==0?G:g.localeCompare(b)}function D(v,C,P){const g=v.toLowerCase(),b=C.toLowerCase(),L=g.startsWith(P),N=b.startsWith(P);if(L!==N)return L?-1:1;if(L&&N){if(g.length<b.length)return-1;if(g.length>b.length)return 1}return 0}}),define(ke[53],Ce([1,0,28,20,21,13,15]),function(oe,e,w,S,k,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xg=T,e.$yg=p,e.$zg=a,e.$Ag=R,e.$Bg=y,e.$Cg=n,e.$Dg=s,e.$Eg=o,e.$Fg=h,e.$Gg=i,e.$Hg=r,e.$Ig=t,e.$Jg=c,e.$Kg=l,e.$Lg=m,e.$Mg=f,e.$Ng=D;function T(v){return v===w.CharCode.Slash||v===w.CharCode.Backslash}function p(v){return v.replace(/[\\/]/g,S.$ic.sep)}function a(v){return v.indexOf("/")===-1&&(v=p(v)),/^[a-zA-Z]:(\/|$)/.test(v)&&(v="/"+v),v}function R(v,C=S.$ic.sep){if(!v)return"";const P=v.length,g=v.charCodeAt(0);if(T(g)){if(T(v.charCodeAt(1))&&!T(v.charCodeAt(2))){let L=3;const N=L;for(;L<P&&!T(v.charCodeAt(L));L++);if(N!==L&&!T(v.charCodeAt(L+1))){for(L+=1;L<P;L++)if(T(v.charCodeAt(L)))return v.slice(0,L+1).replace(/[\\/]/g,C)}}return C}else if(h(g)&&v.charCodeAt(1)===w.CharCode.Colon)return T(v.charCodeAt(2))?v.slice(0,2)+C:v.slice(0,2);let b=v.indexOf("://");if(b!==-1){for(b+=3;b<P;b++)if(T(v.charCodeAt(b)))return v.slice(0,b+1)}return""}function y(v){if(!k.$i||!v||v.length<5)return!1;let C=v.charCodeAt(0);if(C!==w.CharCode.Backslash||(C=v.charCodeAt(1),C!==w.CharCode.Backslash))return!1;let P=2;const g=P;for(;P<v.length&&(C=v.charCodeAt(P),C!==w.CharCode.Backslash);P++);return!(g===P||(C=v.charCodeAt(P+1),isNaN(C)||C===w.CharCode.Backslash))}const u=/[\\/:\*\?"<>\|]/g,E=/[/]/g,d=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function n(v,C=k.$i){const P=C?u:E;return!(!v||v.length===0||/^\s+$/.test(v)||(P.lastIndex=0,P.test(v))||C&&d.test(v)||v==="."||v===".."||C&&v[v.length-1]==="."||C&&v.length!==v.trim().length||v.length>255)}function s(v,C,P){const g=v===C;return!P||g?g:!v||!C?!1:(0,O.$Gf)(v,C)}function o(v,C,P,g=S.sep){if(v===C)return!0;if(!v||!C||C.length>v.length)return!1;if(P){if(!(0,O.$Hf)(v,C))return!1;if(C.length===v.length)return!0;let L=C.length;return C.charAt(C.length-1)===g&&L--,v.charAt(L)===g}return C.charAt(C.length-1)!==g&&(C+=g),v.indexOf(C)===0}function h(v){return v>=w.CharCode.A&&v<=w.CharCode.Z||v>=w.CharCode.a&&v<=w.CharCode.z}function i(v,C){return k.$i&&v.endsWith(":")&&(v+=S.sep),(0,S.$kc)(v)||(v=(0,S.$lc)(C,v)),v=(0,S.$jc)(v),r(v)}function r(v){return k.$i?(v=(0,O.$of)(v,S.sep),v.endsWith(":")&&(v+=S.sep)):(v=(0,O.$of)(v,S.sep),v||(v=S.sep)),v}function t(v){const C=(0,S.$jc)(v);return k.$i?v.length>3?!1:c(C)&&(v.length===2||C.charCodeAt(2)===w.CharCode.Backslash):C===S.$ic.sep}function c(v,C=k.$i){return C?h(v.charCodeAt(0))&&v.charCodeAt(1)===w.CharCode.Colon:!1}function l(v,C=k.$i){return c(v,C)?v[0]:void 0}function m(v,C,P){return C.length>v.length?-1:v===C?0:(P&&(v=v.toLowerCase(),C=C.toLowerCase()),v.indexOf(C))}function f(v){const C=v.split(":");let P,g,b;for(const L of C){const N=Number(L);(0,A.$jg)(N)?g===void 0?g=N:b===void 0&&(b=N):P=P?[P,L].join(":"):L}if(!P)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:P,line:g!==void 0?g:void 0,column:b!==void 0?b:g!==void 0?1:void 0}}const $="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",I="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function D(v,C,P=8){let g="";for(let L=0;L<P;L++){let N;L===0&&k.$i&&!C&&(P===3||P===4)?N=I:N=$,g+=N.charAt(Math.floor(Math.random()*N.length))}let b;return C?b=`${C}-${g}`:b=g,v?(0,S.$lc)(v,b):b}}),define(ke[73],Ce([1,0,20]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4s=void 0,e.$5s=O,e.$6s=A,e.$7s=T,e.$8s=a,e.$4s=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const S={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},k={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function O(R){const y=(0,w.$qc)(R),u=S[y.toLowerCase()];return u!==void 0?u:A(R)}function A(R){const y=(0,w.$qc)(R);return k[y.toLowerCase()]}function T(R){for(const y in k)if(k[y]===R)return y}const p=/^(.+)\/(.+?)(;.+)?$/;function a(R,y){const u=p.exec(R);return u?`${u[1].toLowerCase()}/${u[2].toLowerCase()}${u[3]??""}`:y?void 0:R}}),define(ke[49],Ce([1,0,23,2,38]),function(oe,e,w,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ai=O,e.$bi=A,e.$ci=p;function O(a){return JSON.stringify(a,T)}function A(a){let R=JSON.parse(a);return R=p(R),R}function T(a,R){return R instanceof RegExp?{$mid:k.MarshalledId.Regexp,source:R.source,flags:R.flags}:R}function p(a,R=0){if(!a||R>200)return a;if(typeof a=="object"){switch(a.$mid){case k.MarshalledId.Uri:return S.URI.revive(a);case k.MarshalledId.Regexp:return new RegExp(a.source,a.flags);case k.MarshalledId.Date:return new Date(a.source)}if(a instanceof w.$Oe||a instanceof Uint8Array)return a;if(Array.isArray(a))for(let y=0;y<a.length;++y)a[y]=p(a[y],R+1);else for(const y in a)Object.hasOwnProperty.call(a,y)&&(a[y]=p(a[y],R+1))}return a}}),define(ke[16],Ce([1,0,14,21,13,2,20]),function(oe,e,w,S,k,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Sg=e.$Rg=e.$Qg=e.Schemas=void 0,e.$Og=p,e.$Pg=a,e.$Tg=y,w=qe(w),S=qe(S),A=qe(A);var T;(function(d){d.inMemory="inmemory",d.vscode="vscode",d.internal="private",d.walkThrough="walkThrough",d.walkThroughSnippet="walkThroughSnippet",d.http="http",d.https="https",d.file="file",d.mailto="mailto",d.untitled="untitled",d.data="data",d.command="command",d.vscodeRemote="vscode-remote",d.vscodeRemoteResource="vscode-remote-resource",d.vscodeManagedRemoteResource="vscode-managed-remote-resource",d.vscodeUserData="vscode-userdata",d.vscodeCustomEditor="vscode-custom-editor",d.vscodeNotebookCell="vscode-notebook-cell",d.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",d.vscodeNotebookCellOutput="vscode-notebook-cell-output",d.vscodeInteractiveInput="vscode-interactive-input",d.vscodeSettings="vscode-settings",d.vscodeWorkspaceTrust="vscode-workspace-trust",d.vscodeTerminal="vscode-terminal",d.vscodeChatCodeBlock="vscode-chat-code-block",d.vscodeCopilotBackingChatCodeBlock="vscode-copilot-chat-code-block",d.vscodeChatCodeCompareBlock="vscode-chat-code-compare-block",d.vscodeChatSesssion="vscode-chat-editor",d.webviewPanel="webview-panel",d.vscodeWebview="vscode-webview",d.extension="extension",d.vscodeFileResource="vscode-file",d.tmp="tmp",d.vsls="vsls",d.vscodeSourceControl="vscode-scm",d.commentsInput="comment",d.codeSetting="code-setting"})(T||(e.Schemas=T={}));function p(d,n){return O.URI.isUri(d)?(0,k.$Gf)(d.scheme,n):(0,k.$Hf)(d,n+":")}function a(d,...n){return n.some(s=>p(d,s))}e.$Qg="vscode-tkn",e.$Rg="tkn";class R{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f="/"}setPreferredWebSchema(n){this.d=n}setDelegate(n){this.e=n}setServerRootPath(n,s){this.f=y(n,s)}getServerRootPath(){return this.f}get g(){return A.$ic.join(this.f,T.vscodeRemoteResource)}set(n,s,o){this.a[n]=s,this.b[n]=o}setConnectionToken(n,s){this.c[n]=s}getPreferredWebSchema(){return this.d}rewrite(n){if(this.e)try{return this.e(n)}catch(t){return w.$3(t),n}const s=n.authority;let o=this.a[s];o&&o.indexOf(":")!==-1&&o.indexOf("[")===-1&&(o=`[${o}]`);const h=this.b[s],i=this.c[s];let r=`path=${encodeURIComponent(n.path)}`;return typeof i=="string"&&(r+=`&${e.$Rg}=${encodeURIComponent(i)}`),O.URI.from({scheme:S.$o?this.d:T.vscodeRemoteResource,authority:`${o}:${h}`,path:this.g,query:r})}}e.$Sg=new R;function y(d,n){return A.$ic.join(n??"/",`${d.quality??"oss"}-${d.commit??"dev"}`)}e.$Ug="vs/../../extensions",e.$Vg="vs/../../node_modules",e.$Wg="vs/../../node_modules.asar",e.$Xg="vs/../../node_modules.asar.unpacked",e.$Yg="vscode-app";class u{static{this.a=e.$Yg}asBrowserUri(n){const s=this.b(n,oe);return this.uriToBrowserUri(s)}uriToBrowserUri(n){return n.scheme===T.vscodeRemote?e.$Sg.rewrite(n):n.scheme===T.file&&(S.$m||S.$q===`${T.vscodeFileResource}://${u.a}`)?n.with({scheme:T.vscodeFileResource,authority:n.authority||u.a,query:null,fragment:null}):n}asFileUri(n){const s=this.b(n,oe);return this.uriToFileUri(s)}uriToFileUri(n){return n.scheme===T.vscodeFileResource?n.with({scheme:T.file,authority:n.authority!==u.a?n.authority:null,query:null,fragment:null}):n}b(n,s){return O.URI.isUri(n)?n:O.URI.parse(s.toUrl(n))}}e.$Zg=new u;var E;(function(d){const n=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);d.CoopAndCoep=Object.freeze(n.get("3"));const s="vscode-coi";function o(i){let r;typeof i=="string"?r=new URL(i).searchParams:i instanceof URL?r=i.searchParams:O.URI.isUri(i)&&(r=new URL(i.toString(!0)).searchParams);const t=r?.get(s);if(t)return n.get(t)}d.getHeadersFromQuery=o;function h(i,r,t){if(!globalThis.crossOriginIsolated)return;const c=r&&t?"3":t?"2":"1";i instanceof URLSearchParams?i.set(s,c):i[s]=c}d.addSearchParam=h})(E||(e.COI=E={}))}),define(ke[24],Ce([1,0,28,53,16,20,21,13,2]),function(oe,e,w,S,k,O,A,T,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataUri=e.$oh=e.$nh=e.$mh=e.$lh=e.$kh=e.$jh=e.$ih=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=void 0,e.$7g=a,e.$ph=y,e.$qh=E,S=qe(S),O=qe(O);function a(d){return(0,p.$yc)(d,!0)}class R{constructor(n){this.a=n}compare(n,s,o=!1){return n===s?0:(0,T.$zf)(this.getComparisonKey(n,o),this.getComparisonKey(s,o))}isEqual(n,s,o=!1){return n===s?!0:!n||!s?!1:this.getComparisonKey(n,o)===this.getComparisonKey(s,o)}getComparisonKey(n,s=!1){return n.with({path:this.a(n)?n.path.toLowerCase():void 0,fragment:s?null:void 0}).toString()}ignorePathCasing(n){return this.a(n)}isEqualOrParent(n,s,o=!1){if(n.scheme===s.scheme){if(n.scheme===k.Schemas.file)return S.$Eg(a(n),a(s),this.a(n))&&n.query===s.query&&(o||n.fragment===s.fragment);if((0,e.$lh)(n.authority,s.authority))return S.$Eg(n.path,s.path,this.a(n),"/")&&n.query===s.query&&(o||n.fragment===s.fragment)}return!1}joinPath(n,...s){return p.URI.joinPath(n,...s)}basenameOrAuthority(n){return(0,e.$dh)(n)||n.authority}basename(n){return O.$ic.basename(n.path)}extname(n){return O.$ic.extname(n.path)}dirname(n){if(n.path.length===0)return n;let s;return n.scheme===k.Schemas.file?s=p.URI.file(O.$oc(a(n))).path:(s=O.$ic.dirname(n.path),n.authority&&s.length&&s.charCodeAt(0)!==w.CharCode.Slash&&(console.error(`dirname("${n.toString})) resulted in a relative path`),s="/")),n.with({path:s})}normalizePath(n){if(!n.path.length)return n;let s;return n.scheme===k.Schemas.file?s=p.URI.file(O.$jc(a(n))).path:s=O.$ic.normalize(n.path),n.with({path:s})}relativePath(n,s){if(n.scheme!==s.scheme||!(0,e.$lh)(n.authority,s.authority))return;if(n.scheme===k.Schemas.file){const i=O.$nc(a(n),a(s));return A.$i?S.$yg(i):i}let o=n.path||"/";const h=s.path||"/";if(this.a(n)){let i=0;for(const r=Math.min(o.length,h.length);i<r&&!(o.charCodeAt(i)!==h.charCodeAt(i)&&o.charAt(i).toLowerCase()!==h.charAt(i).toLowerCase());i++);o=h.substr(0,i)+o.substr(i)}return O.$ic.relative(o,h)}resolvePath(n,s){if(n.scheme===k.Schemas.file){const o=p.URI.file(O.$mc(a(n),s));return n.with({authority:o.authority,path:o.path})}return s=S.$zg(s),n.with({path:O.$ic.resolve(n.path,s)})}isAbsolutePath(n){return!!n.path&&n.path[0]==="/"}isEqualAuthority(n,s){return n===s||n!==void 0&&s!==void 0&&(0,T.$Gf)(n,s)}hasTrailingPathSeparator(n,s=O.sep){if(n.scheme===k.Schemas.file){const o=a(n);return o.length>S.$Ag(o).length&&o[o.length-1]===s}else{const o=n.path;return o.length>1&&o.charCodeAt(o.length-1)===w.CharCode.Slash&&!/^[a-zA-Z]:(\/$|\\$)/.test(n.fsPath)}}removeTrailingPathSeparator(n,s=O.sep){return(0,e.$mh)(n,s)?n.with({path:n.path.substr(0,n.path.length-1)}):n}addTrailingPathSeparator(n,s=O.sep){let o=!1;if(n.scheme===k.Schemas.file){const h=a(n);o=h!==void 0&&h.length===S.$Ag(h).length&&h[h.length-1]===s}else{s="/";const h=n.path;o=h.length===1&&h.charCodeAt(h.length-1)===w.CharCode.Slash}return!o&&!(0,e.$mh)(n,s)?n.with({path:n.path+"/"}):n}}e.$8g=R,e.$9g=new R(()=>!1),e.$0g=new R(d=>d.scheme===k.Schemas.file?!A.$k:!0),e.$$g=new R(d=>!0),e.$_g=e.$9g.isEqual.bind(e.$9g),e.$ah=e.$9g.isEqualOrParent.bind(e.$9g),e.$bh=e.$9g.getComparisonKey.bind(e.$9g),e.$ch=e.$9g.basenameOrAuthority.bind(e.$9g),e.$dh=e.$9g.basename.bind(e.$9g),e.$eh=e.$9g.extname.bind(e.$9g),e.$fh=e.$9g.dirname.bind(e.$9g),e.$gh=e.$9g.joinPath.bind(e.$9g),e.$hh=e.$9g.normalizePath.bind(e.$9g),e.$ih=e.$9g.relativePath.bind(e.$9g),e.$jh=e.$9g.resolvePath.bind(e.$9g),e.$kh=e.$9g.isAbsolutePath.bind(e.$9g),e.$lh=e.$9g.isEqualAuthority.bind(e.$9g),e.$mh=e.$9g.hasTrailingPathSeparator.bind(e.$9g),e.$nh=e.$9g.removeTrailingPathSeparator.bind(e.$9g),e.$oh=e.$9g.addTrailingPathSeparator.bind(e.$9g);function y(d,n){const s=[];for(let o=0;o<d.length;o++){const h=n(d[o]);d.some((i,r)=>r===o?!1:(0,e.$ah)(h,n(i)))||s.push(d[o])}return s}var u;(function(d){d.META_DATA_LABEL="label",d.META_DATA_DESCRIPTION="description",d.META_DATA_SIZE="size",d.META_DATA_MIME="mime";function n(s){const o=new Map;s.path.substring(s.path.indexOf(";")+1,s.path.lastIndexOf(";")).split(";").forEach(r=>{const[t,c]=r.split(":");t&&c&&o.set(t,c)});const i=s.path.substring(0,s.path.indexOf(";"));return i&&o.set(d.META_DATA_MIME,i),o}d.parseMetaData=n})(u||(e.DataUri=u={}));function E(d,n,s){if(n){let o=d.path;return o&&o[0]!==O.$ic.sep&&(o=O.$ic.sep+o),d.with({scheme:s,authority:n,path:o})}return d.with({scheme:s})}}),define(ke[11],Ce([1,0,22,14,6,4,24,21,145,47]),function(oe,e,w,S,k,O,A,T,p,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9h=e.$7h=e.$6h=e.$5h=e.$4h=e.Promises=e.$3h=e.$2h=e.$1h=e.$Yh=e.$Xh=e.$Wh=e.$Vh=e.$Uh=e.$Th=e.$Sh=e.$Rh=e.$Qh=e.$Ph=e.$Oh=e.$Nh=e.$Mh=e.$Lh=e.$Fh=e.$Eh=e.$Dh=e.$Ch=e.$Bh=e.$Ah=e.$zh=void 0,e.$rh=R,e.$sh=y,e.$th=u,e.$uh=E,e.$vh=d,e.$wh=n,e.$xh=s,e.$yh=o,e.$Gh=I,e.$Hh=D,e.$Ih=v,e.$Jh=C,e.$Kh=P,e.$Zh=me,e.$8h=ae;function R(he){return!!he&&typeof he.then=="function"}function y(he){const X=new w.$xe,Y=he(X.token),pe=new Promise(($e,Te)=>{const ze=X.token.onCancellationRequested(()=>{ze.dispose(),Te(new S.$7)});Promise.resolve(Y).then(Se=>{ze.dispose(),X.dispose(),$e(Se)},Se=>{ze.dispose(),X.dispose(),Te(Se)})});return new class{cancel(){X.cancel(),X.dispose()}then($e,Te){return pe.then($e,Te)}catch($e){return this.then(void 0,$e)}finally($e){return pe.finally($e)}}}function u(he,X,Y){return new Promise((pe,$e)=>{const Te=X.onCancellationRequested(()=>{Te.dispose(),pe(Y)});he.then(pe,$e).finally(()=>Te.dispose())})}function E(he,X){return new Promise((Y,pe)=>{const $e=X.onCancellationRequested(()=>{$e.dispose(),pe(new S.$7)});he.then(Y,pe).finally(()=>$e.dispose())})}async function d(he){let X=-1;const Y=he.map((pe,$e)=>pe.then(Te=>(X=$e,Te)));try{return await Promise.race(Y)}finally{he.forEach((pe,$e)=>{$e!==X&&pe.cancel()})}}function n(he,X,Y){let pe;const $e=setTimeout(()=>{pe?.(void 0),Y?.()},X);return Promise.race([he.finally(()=>clearTimeout($e)),new Promise(Te=>pe=Te)])}function s(he){return new Promise((X,Y)=>{const pe=he();R(pe)?pe.then(X,Y):X(pe)})}function o(){let he,X;return{promise:new Promise((pe,$e)=>{he=pe,X=$e}),resolve:he,reject:X}}class h{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(X){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=X,!this.b){const Y=()=>{if(this.b=null,this.f)return;const pe=this.queue(this.d);return this.d=null,pe};this.b=new Promise(pe=>{this.a.then(Y,Y).then(pe)})}return new Promise((Y,pe)=>{this.b.then(Y,pe)})}return this.a=X(),new Promise((Y,pe)=>{this.a.then($e=>{this.a=null,Y($e)},$e=>{this.a=null,pe($e)})})}dispose(){this.f=!0}}e.$zh=h;class i{constructor(){this.a=Promise.resolve(null)}queue(X){return this.a=this.a.then(()=>X(),()=>X())}}e.$Ah=i;class r{constructor(){this.a=new Map}queue(X,Y){const $e=(this.a.get(X)??Promise.resolve()).catch(()=>{}).then(Y).finally(()=>{this.a.get(X)===$e&&this.a.delete(X)});return this.a.set(X,$e),$e}}e.$Bh=r;const t=(he,X)=>{let Y=!0;const pe=setTimeout(()=>{Y=!1,X()},he);return{isTriggered:()=>Y,dispose:()=>{clearTimeout(pe),Y=!1}}},c=he=>{let X=!0;return queueMicrotask(()=>{X&&(X=!1,he())}),{isTriggered:()=>X,dispose:()=>{X=!1}}};class l{constructor(X){this.defaultDelay=X,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(X,Y=this.defaultDelay){this.g=X,this.h(),this.b||(this.b=new Promise(($e,Te)=>{this.d=$e,this.f=Te}).then(()=>{if(this.b=null,this.d=null,this.g){const $e=this.g;return this.g=null,$e()}}));const pe=()=>{this.a=null,this.d?.(null)};return this.a=Y===p.$he?c(pe):t(Y,pe),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new S.$7),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$Ch=l;class m{constructor(X){this.a=new l(X),this.b=new h}trigger(X,Y){return this.a.trigger(()=>this.b.queue(X),Y)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$Dh=m;class f{constructor(){this.a=!1,this.b=new Promise((X,Y)=>{this.d=X})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$Eh=f;class $ extends f{constructor(X){super(),this.f=setTimeout(()=>this.open(),X)}open(){clearTimeout(this.f),super.open()}}e.$Fh=$;function I(he,X){return X?new Promise((Y,pe)=>{const $e=setTimeout(()=>{Te.dispose(),Y()},he),Te=X.onCancellationRequested(()=>{clearTimeout($e),Te.dispose(),pe(new S.$7)})}):y(Y=>I(he,Y))}function D(he,X=0,Y){const pe=setTimeout(()=>{he(),Y&&$e.dispose()},X),$e=(0,O.$Uc)(()=>{clearTimeout(pe),Y?.deleteAndLeak($e)});return Y?.add($e),$e}function v(he){const X=[];let Y=0;const pe=he.length;function $e(){return Y<pe?he[Y++]():null}function Te(ze){ze!=null&&X.push(ze);const Se=$e();return Se?Se.then(Te):Promise.resolve(X)}return Promise.resolve(null).then(Te)}function C(he,X=pe=>!!pe,Y=null){let pe=0;const $e=he.length,Te=()=>{if(pe>=$e)return Promise.resolve(Y);const ze=he[pe++];return Promise.resolve(ze()).then(Re=>X(Re)?Promise.resolve(Re):Te())};return Te()}function P(he,X=pe=>!!pe,Y=null){if(he.length===0)return Promise.resolve(Y);let pe=he.length;const $e=()=>{pe=-1;for(const Te of he)Te.cancel?.()};return new Promise((Te,ze)=>{for(const Se of he)Se.then(Re=>{--pe>=0&&X(Re)?($e(),Te(Re)):pe===0&&Te(Y)}).catch(Re=>{--pe>=0&&($e(),ze(Re))})})}class g{constructor(X){this.a=0,this.b=!1,this.f=X,this.g=[],this.d=0,this.h=new k.$me}whenIdle(){return this.size>0?k.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(X){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((Y,pe)=>{this.g.push({factory:X,c:Y,e:pe}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const X=this.g.shift();this.d++;const Y=X.factory();Y.then(X.c,X.e),Y.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$Lh=g;class b extends g{constructor(){super(1)}}e.$Mh=b;class L{constructor(){this.a=new re,this.b=0}queue(X){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,X())):this.a.run(this.b++,X())}}e.$Nh=L;class N{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const X=new se;return this.b.add(X),X.p}g(){for(const[,X]of this.a)if(X.size>0)return!1;return!0}queueSize(X,Y=A.$9g){const pe=Y.getComparisonKey(X);return this.a.get(pe)?.size??0}queueFor(X,Y,pe=A.$9g){const $e=pe.getComparisonKey(X);let Te=this.a.get($e);if(!Te){Te=new b;const ze=this.f++,Se=k.Event.once(Te.onDrained)(()=>{Te?.dispose(),this.a.delete($e),this.h(),this.d?.deleteAndDispose(ze),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new O.$6c),this.d.set(ze,Se),this.a.set($e,Te)}return Te.queue(Y)}h(){this.g()&&this.j()}j(){for(const X of this.b)X.complete();this.b.clear()}dispose(){for(const[,X]of this.a)X.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$Oh=N;class B{constructor(X,Y){this.b=!1,this.a=-1,typeof X=="function"&&typeof Y=="number"&&this.setIfNotSet(X,Y)}dispose(){this.cancel(),this.b=!0}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(X,Y){if(this.b)throw new S.$eb("Calling 'cancelAndSet' on a disposed TimeoutTimer");this.cancel(),this.a=setTimeout(()=>{this.a=-1,X()},Y)}setIfNotSet(X,Y){if(this.b)throw new S.$eb("Calling 'setIfNotSet' on a disposed TimeoutTimer");this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,X()},Y))}}e.$Ph=B;class G{constructor(){this.d=void 0,this.f=!1}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(X,Y,pe=globalThis){if(this.f)throw new S.$eb("Calling 'cancelAndSet' on a disposed IntervalTimer");this.cancel();const $e=pe.setInterval(()=>{X()},Y);this.d=(0,O.$Uc)(()=>{pe.clearInterval($e),this.d=void 0})}dispose(){this.cancel(),this.f=!0}}e.$Qh=G;class W{constructor(X,Y){this.b=-1,this.a=X,this.d=Y,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(X=this.d){this.cancel(),this.b=setTimeout(this.f,X)}get delay(){return this.d}set delay(X){this.d=X}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$Rh=W;class F{constructor(X,Y){Y%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${Y}ms is not a multiple of 1000ms.`),this.a=X,this.b=Y,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(X=this.b){X%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${X}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(X/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$Sh=F;class q extends W{constructor(X,Y){super(X,Y),this.j=[]}work(X){this.j.push(X),this.isScheduled()||this.schedule()}h(){const X=this.j;this.j=[],this.a?.(X)}dispose(){this.j=[],super.dispose()}}e.$Th=q;class ue extends O.$Wc{constructor(X,Y){super(),this.g=X,this.h=Y,this.a=[],this.b=this.B(new O.$Xc),this.f=!1}get pending(){return this.a.length}work(X){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+X.length>this.g.maxBufferedWork)return!1}else if(this.pending+X.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const Y of X)this.a.push(Y);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new W(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$Uh=ue,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$Wh=(he,X)=>{(0,T.$B)(()=>{if(Y)return;const pe=Date.now()+15;X(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,pe-Date.now())}}))});let Y=!1;return{dispose(){Y||(Y=!0)}}}:e.$Wh=(he,X,Y)=>{const pe=he.requestIdleCallback(X,typeof Y=="number"?{timeout:Y}:void 0);let $e=!1;return{dispose(){$e||($e=!0,he.cancelIdleCallback(pe))}}},e.$Vh=he=>(0,e.$Wh)(globalThis,he)}();class ge{constructor(X,Y){this.g=!1,this.d=()=>{try{this.j=Y()}catch(pe){this.l=pe}finally{this.g=!0}},this.f=(0,e.$Wh)(X,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$Xh=ge;class te extends ge{constructor(X){super(globalThis,X)}}e.$Yh=te;async function me(he,X,Y){let pe;for(let $e=0;$e<Y;$e++)try{return await he()}catch(Te){pe=Te,await I(X)}throw pe}class re{isRunning(X){return typeof X=="number"?this.a?.taskId===X:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(X,Y,pe){return this.a={taskId:X,cancel:()=>pe?.(),promise:Y},Y.then(()=>this.d(X),()=>this.d(X)),Y}d(X){this.a&&X===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const X=this.b;this.b=void 0,X.run().then(X.promiseResolve,X.promiseReject)}}queue(X){if(this.b)this.b.run=X;else{const{promise:Y,resolve:pe,reject:$e}=o();this.b={run:X,promise:Y,promiseResolve:pe,promiseReject:$e}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$1h=re;class ce{constructor(X,Y=()=>Date.now()){this.d=X,this.f=Y,this.a=0,this.b=0}increment(){const X=this.f();return X-this.a>this.d&&(this.a=X,this.b=0),this.b++,this.b}}e.$2h=ce;var be;(function(he){he[he.Resolved=0]="Resolved",he[he.Rejected=1]="Rejected"})(be||(be={}));class se{get isRejected(){return this.d?.outcome===be.Rejected}get isResolved(){return this.d?.outcome===be.Resolved}get isSettled(){return!!this.d}get value(){return this.d?.outcome===be.Resolved?this.d?.value:void 0}constructor(){this.p=new Promise((X,Y)=>{this.a=X,this.b=Y})}complete(X){return new Promise(Y=>{this.a(X),this.d={outcome:be.Resolved,value:X},Y()})}error(X){return new Promise(Y=>{this.b(X),this.d={outcome:be.Rejected,value:X},Y()})}cancel(){return this.error(new S.$7)}}e.$3h=se;var Ie;(function(he){async function X(pe){let $e;const Te=await Promise.all(pe.map(ze=>ze.then(Se=>Se,Se=>{$e||($e=Se)})));if(typeof $e<"u")throw $e;return Te}he.settled=X;function Y(pe){return new Promise(async($e,Te)=>{try{await pe($e,Te)}catch(ze){Te(ze)}})}he.withAsyncBody=Y})(Ie||(e.Promises=Ie={}));class Ue{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(X){this.a=void 0,this.b=void 0,this.d=!1,this.promise=X.then(Y=>(this.a=Y,this.d=!0,Y),Y=>{throw this.b=Y,this.d=!0,Y})}requireValue(){if(!this.d)throw new S.$eb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$4h=Ue;class Z{constructor(X){this.b=X,this.a=new a.$X(()=>new Ue(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}e.$5h=Z;var V;(function(he){he[he.Initial=0]="Initial",he[he.DoneOK=1]="DoneOK",he[he.DoneError=2]="DoneError"})(V||(V={}));class _{static fromArray(X){return new _(Y=>{Y.emitMany(X)})}static fromPromise(X){return new _(async Y=>{Y.emitMany(await X)})}static fromPromises(X){return new _(async Y=>{await Promise.all(X.map(async pe=>Y.emitOne(await pe)))})}static merge(X){return new _(async Y=>{await Promise.all(X.map(async pe=>{for await(const $e of pe)Y.emitOne($e)}))})}static{this.EMPTY=_.fromArray([])}constructor(X,Y){this.a=V.Initial,this.b=[],this.d=null,this.f=Y,this.g=new k.$me,queueMicrotask(async()=>{const pe={emitOne:$e=>this.h($e),emitMany:$e=>this.j($e),reject:$e=>this.l($e)};try{await Promise.resolve(X(pe)),this.k()}catch($e){this.l($e)}finally{pe.emitOne=void 0,pe.emitMany=void 0,pe.reject=void 0}})}[Symbol.asyncIterator](){let X=0;return{next:async()=>{do{if(this.a===V.DoneError)throw this.d;if(X<this.b.length)return{done:!1,value:this.b[X++]};if(this.a===V.DoneOK)return{done:!0,value:void 0};await k.Event.toPromise(this.g.event)}while(!0)},return:async()=>(this.f?.(),{done:!0,value:void 0})}}static map(X,Y){return new _(async pe=>{for await(const $e of X)pe.emitOne(Y($e))})}map(X){return _.map(this,X)}static filter(X,Y){return new _(async pe=>{for await(const $e of X)Y($e)&&pe.emitOne($e)})}filter(X){return _.filter(this,X)}static coalesce(X){return _.filter(X,Y=>!!Y)}coalesce(){return _.coalesce(this)}static async toPromise(X){const Y=[];for await(const pe of X)Y.push(pe);return Y}toPromise(){return _.toPromise(this)}h(X){this.a===V.Initial&&(this.b.push(X),this.g.fire())}j(X){this.a===V.Initial&&(this.b=this.b.concat(X),this.g.fire())}k(){this.a===V.Initial&&(this.a=V.DoneOK,this.g.fire())}l(X){this.a===V.Initial&&(this.a=V.DoneError,this.d=X,this.g.fire())}}e.$6h=_;class ye extends _{constructor(X,Y){super(Y),this.m=X}cancel(){this.m.cancel()}}e.$7h=ye;function ae(he){const X=new w.$xe,Y=he(X.token);return new ye(X,async pe=>{const $e=X.token.onCancellationRequested(()=>{$e.dispose(),X.dispose(),pe.reject(new S.$7)});try{for await(const Te of Y){if(X.token.isCancellationRequested)return;pe.emitOne(Te)}$e.dispose(),X.dispose()}catch(Te){$e.dispose(),X.dispose(),pe.reject(Te)}})}class we{constructor(X){this.a=new se,this.b=new _($e=>{if(Y){$e.reject(Y);return}return pe&&$e.emitMany(pe),this.d=Te=>$e.reject(Te),this.f=Te=>$e.emitOne(Te),this.a.p},X);let Y,pe;this.f=$e=>{pe||(pe=[]),pe.push($e)},this.d=$e=>{Y||(Y=$e)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(X){this.d(X),this.a.complete()}emitOne(X){this.f(X)}}e.$9h=we}),define(ke[41],Ce([1,0,18,11,28,53,29,20,21,13]),function(oe,e,w,S,k,O,A,T,p,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wk=e.$vk=void 0,e.$uk=R,e.$xk=n,e.$yk=L,e.$zk=N,e.$Ak=B,e.$Bk=G,e.$Ck=W,e.$Dk=ge;function R(){return Object.create(null)}e.$vk="**",e.$wk="/";const y="[/\\\\]",u="[^/\\\\]",E=/\//g;function d(te,me){switch(te){case 0:return"";case 1:return`${u}*?`;default:return`(?:${y}|${u}+${y}${me?`|${y}${u}+`:""})*?`}}function n(te,me){if(!te)return[];const re=[];let ce=!1,be=!1,se="";for(const Ie of te){switch(Ie){case me:if(!ce&&!be){re.push(se),se="";continue}break;case"{":ce=!0;break;case"}":ce=!1;break;case"[":be=!0;break;case"]":be=!1;break}se+=Ie}return se&&re.push(se),re}function s(te){if(!te)return"";let me="";const re=n(te,e.$wk);if(re.every(ce=>ce===e.$vk))me=".*";else{let ce=!1;re.forEach((be,se)=>{if(be===e.$vk){if(ce)return;me+=d(2,se===re.length-1)}else{let Ie=!1,Ue="",Z=!1,V="";for(const _ of be){if(_!=="}"&&Ie){Ue+=_;continue}if(Z&&(_!=="]"||!V)){let ye;_==="-"?ye=_:(_==="^"||_==="!")&&!V?ye="^":_===e.$wk?ye="":ye=(0,a.$if)(_),V+=ye;continue}switch(_){case"{":Ie=!0;continue;case"[":Z=!0;continue;case"}":{const ae=`(?:${n(Ue,",").map(we=>s(we)).join("|")})`;me+=ae,Ie=!1,Ue="";break}case"]":{me+="["+V+"]",Z=!1,V="";break}case"?":me+=u;continue;case"*":me+=d(1);continue;default:me+=(0,a.$if)(_)}}se<re.length-1&&(re[se+1]!==e.$vk||se+2<re.length)&&(me+=y)}ce=be===e.$vk})}return me}const o=/^\*\*\/\*\.[\w\.-]+$/,h=/^\*\*\/([\w\.-]+)\/?$/,i=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,r=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,t=/^\*\*((\/[\w\.-]+)+)\/?$/,c=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,l=new A.$Fc(1e4),m=function(){return!1},f=function(){return null};function $(te,me){if(!te)return f;let re;typeof te!="string"?re=te.pattern:re=te,re=re.trim();const ce=`${re}_${!!me.trimForExclusions}`;let be=l.get(ce);if(be)return I(be,te);let se;return o.test(re)?be=v(re.substr(4),re):(se=h.exec(D(re,me)))?be=C(se[1],re):(me.trimForExclusions?r:i).test(re)?be=P(re,me):(se=t.exec(D(re,me)))?be=g(se[1].substr(1),re,!0):(se=c.exec(D(re,me)))?be=g(se[1],re,!1):be=b(re),l.set(ce,be),I(be,te)}function I(te,me){if(typeof me=="string")return te;const re=function(ce,be){return(0,O.$Eg)(ce,me.base,!p.$k)?te((0,a.$nf)(ce.substr(me.base.length),T.sep),be):null};return re.allBasenames=te.allBasenames,re.allPaths=te.allPaths,re.basenames=te.basenames,re.patterns=te.patterns,re}function D(te,me){return me.trimForExclusions&&te.endsWith("/**")?te.substr(0,te.length-2):te}function v(te,me){return function(re,ce){return typeof re=="string"&&re.endsWith(te)?me:null}}function C(te,me){const re=`/${te}`,ce=`\\${te}`,be=function(Ie,Ue){return typeof Ie!="string"?null:Ue?Ue===te?me:null:Ie===te||Ie.endsWith(re)||Ie.endsWith(ce)?me:null},se=[te];return be.basenames=se,be.patterns=[me],be.allBasenames=se,be}function P(te,me){const re=ue(te.slice(1,-1).split(",").map(Ue=>$(Ue,me)).filter(Ue=>Ue!==f),te),ce=re.length;if(!ce)return f;if(ce===1)return re[0];const be=function(Ue,Z){for(let V=0,_=re.length;V<_;V++)if(re[V](Ue,Z))return te;return null},se=re.find(Ue=>!!Ue.allBasenames);se&&(be.allBasenames=se.allBasenames);const Ie=re.reduce((Ue,Z)=>Z.allPaths?Ue.concat(Z.allPaths):Ue,[]);return Ie.length&&(be.allPaths=Ie),be}function g(te,me,re){const ce=T.sep===T.$ic.sep,be=ce?te:te.replace(E,T.sep),se=T.sep+be,Ie=T.$ic.sep+te;let Ue;return re?Ue=function(Z,V){return typeof Z=="string"&&(Z===be||Z.endsWith(se)||!ce&&(Z===te||Z.endsWith(Ie)))?me:null}:Ue=function(Z,V){return typeof Z=="string"&&(Z===be||!ce&&Z===te)?me:null},Ue.allPaths=[(re?"*/":"./")+te],Ue}function b(te){try{const me=new RegExp(`^${s(te)}$`);return function(re){return me.lastIndex=0,typeof re=="string"&&me.test(re)?te:null}}catch{return f}}function L(te,me,re){return!te||typeof me!="string"?!1:N(te)(me,void 0,re)}function N(te,me={}){if(!te)return m;if(typeof te=="string"||B(te)){const re=$(te,me);if(re===f)return m;const ce=function(be,se){return!!re(be,se)};return re.allBasenames&&(ce.allBasenames=re.allBasenames),re.allPaths&&(ce.allPaths=re.allPaths),ce}return F(te,me)}function B(te){const me=te;return me?typeof me.base=="string"&&typeof me.pattern=="string":!1}function G(te){return te.allBasenames||[]}function W(te){return te.allPaths||[]}function F(te,me){const re=ue(Object.getOwnPropertyNames(te).map(Ue=>q(Ue,te[Ue],me)).filter(Ue=>Ue!==f)),ce=re.length;if(!ce)return f;if(!re.some(Ue=>!!Ue.requiresSiblings)){if(ce===1)return re[0];const Ue=function(_,ye){let ae;for(let we=0,he=re.length;we<he;we++){const X=re[we](_,ye);if(typeof X=="string")return X;(0,S.$rh)(X)&&(ae||(ae=[]),ae.push(X))}return ae?(async()=>{for(const we of ae){const he=await we;if(typeof he=="string")return he}return null})():null},Z=re.find(_=>!!_.allBasenames);Z&&(Ue.allBasenames=Z.allBasenames);const V=re.reduce((_,ye)=>ye.allPaths?_.concat(ye.allPaths):_,[]);return V.length&&(Ue.allPaths=V),Ue}const be=function(Ue,Z,V){let _,ye;for(let ae=0,we=re.length;ae<we;ae++){const he=re[ae];he.requiresSiblings&&V&&(Z||(Z=(0,T.$pc)(Ue)),_||(_=Z.substr(0,Z.length-(0,T.$qc)(Ue).length)));const X=he(Ue,Z,_,V);if(typeof X=="string")return X;(0,S.$rh)(X)&&(ye||(ye=[]),ye.push(X))}return ye?(async()=>{for(const ae of ye){const we=await ae;if(typeof we=="string")return we}return null})():null},se=re.find(Ue=>!!Ue.allBasenames);se&&(be.allBasenames=se.allBasenames);const Ie=re.reduce((Ue,Z)=>Z.allPaths?Ue.concat(Z.allPaths):Ue,[]);return Ie.length&&(be.allPaths=Ie),be}function q(te,me,re){if(me===!1)return f;const ce=$(te,re);if(ce===f)return f;if(typeof me=="boolean")return ce;if(me){const be=me.when;if(typeof be=="string"){const se=(Ie,Ue,Z,V)=>{if(!V||!ce(Ie,Ue))return null;const _=be.replace("$(basename)",()=>Z),ye=V(_);return(0,S.$rh)(ye)?ye.then(ae=>ae?te:null):ye?te:null};return se.requiresSiblings=!0,se}}return ce}function ue(te,me){const re=te.filter(Ue=>!!Ue.basenames);if(re.length<2)return te;const ce=re.reduce((Ue,Z)=>{const V=Z.basenames;return V?Ue.concat(V):Ue},[]);let be;if(me){be=[];for(let Ue=0,Z=ce.length;Ue<Z;Ue++)be.push(me)}else be=re.reduce((Ue,Z)=>{const V=Z.patterns;return V?Ue.concat(V):Ue},[]);const se=function(Ue,Z){if(typeof Ue!="string")return null;if(!Z){let _;for(_=Ue.length;_>0;_--){const ye=Ue.charCodeAt(_-1);if(ye===k.CharCode.Slash||ye===k.CharCode.Backslash)break}Z=Ue.substr(_)}const V=ce.indexOf(Z);return V!==-1?be[V]:null};se.basenames=ce,se.patterns=be,se.allBasenames=ce;const Ie=te.filter(Ue=>!Ue.basenames);return Ie.push(se),Ie}function ge(te,me){return(0,w.$wb)(te,me,(re,ce)=>typeof re=="string"&&typeof ce=="string"?re===ce:typeof re!="string"&&typeof ce!="string"?re.base===ce.base&&re.pattern===ce.pattern:!1)}}),define(ke[60],Ce([1,0,14,99,24,13,2]),function(oe,e,w,S,k,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3k=e.MarkdownStringTextNewlineStyle=void 0,e.$4k=a,e.$5k=R,e.$6k=y,e.$7k=u,e.$8k=E,e.$9k=d,e.$0k=n,e.$$k=s;var T;(function(o){o[o.Paragraph=0]="Paragraph",o[o.Break=1]="Break"})(T||(e.MarkdownStringTextNewlineStyle=T={}));class p{constructor(h="",i=!1){if(this.value=h,typeof this.value!="string")throw(0,w.$9)("value");typeof i=="boolean"?(this.isTrusted=i,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=i.isTrusted??void 0,this.supportThemeIcons=i.supportThemeIcons??!1,this.supportHtml=i.supportHtml??!1)}appendText(h,i=T.Paragraph){return this.value+=u(this.supportThemeIcons?(0,S.$Wk)(h):h).replace(/([ \t]+)/g,(r,t)=>"&nbsp;".repeat(t.length)).replace(/\>/gm,"\\>").replace(/\n/g,i===T.Break?`\\
`:`

`),this}appendMarkdown(h){return this.value+=h,this}appendCodeblock(h,i){return this.value+=`
${E(i,h)}
`,this}appendLink(h,i,r){return this.value+="[",this.value+=this.c(i,"]"),this.value+="](",this.value+=this.c(String(h),")"),r&&(this.value+=` "${this.c(this.c(r,'"'),")")}"`),this.value+=")",this}c(h,i){const r=new RegExp((0,O.$if)(i),"g");return h.replace(r,(t,c)=>h.charAt(c-1)!=="\\"?`\\${t}`:t)}}e.$3k=p;function a(o){return R(o)?!o.value:Array.isArray(o)?o.every(a):!0}function R(o){return o instanceof p?!0:o&&typeof o=="object"?typeof o.value=="string"&&(typeof o.isTrusted=="boolean"||typeof o.isTrusted=="object"||o.isTrusted===void 0)&&(typeof o.supportThemeIcons=="boolean"||o.supportThemeIcons===void 0):!1}function y(o,h){return o===h?!0:!o||!h?!1:o.value===h.value&&o.isTrusted===h.isTrusted&&o.supportThemeIcons===h.supportThemeIcons&&o.supportHtml===h.supportHtml&&(o.baseUri===h.baseUri||!!o.baseUri&&!!h.baseUri&&(0,k.$_g)(A.URI.from(o.baseUri),A.URI.from(h.baseUri)))}function u(o){return o.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}function E(o,h){const i=o.match(/^`+/gm)?.reduce((t,c)=>t.length>c.length?t:c).length??0,r=i>=3?i+1:3;return[`${"`".repeat(r)}${h}`,o,`${"`".repeat(r)}`].join(`
`)}function d(o){return o.replace(/"/g,"&quot;")}function n(o){return o&&o.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}function s(o){const h=[],i=o.split("|").map(t=>t.trim());o=i[0];const r=i[1];if(r){const t=/height=(\d+)/.exec(r),c=/width=(\d+)/.exec(r),l=t?t[1]:"",m=c?c[1]:"",f=isFinite(parseInt(m)),$=isFinite(parseInt(l));f&&h.push(`width="${m}"`),$&&h.push(`height="${l}"`)}return{href:o,dimensions:h}}}),define(ke[103],Ce([1,0,18,53,20,21,24,13]),function(oe,e,w,S,k,O,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rw=p,e.$Sw=R,e.$Tw=u,e.$Uw=E,e.$Vw=o,e.$Ww=i,e.$Xw=r,e.$Yw=t,e.$Zw=c,e.$1w=l;function p(f,$){const{os:I,tildify:D,relative:v}=$;if(v){const g=a(f,v,I);if(typeof g=="string")return g}let C=f.fsPath;if(I===O.OperatingSystem.Windows&&!O.$i?C=C.replace(/\//g,"\\"):I!==O.OperatingSystem.Windows&&O.$i&&(C=C.replace(/\\/g,"/")),I!==O.OperatingSystem.Windows&&D?.userHome){const g=D.userHome.fsPath;let b;f.scheme!==D.userHome.scheme&&f.path[0]===k.$ic.sep&&f.path[1]!==k.$ic.sep?b=D.userHome.with({path:f.path}).fsPath:b=C,C=u(b,g,I)}return(I===O.OperatingSystem.Windows?k.$hc:k.$ic).normalize(R(C,I===O.OperatingSystem.Windows))}function a(f,$,I){const D=I===O.OperatingSystem.Windows?k.$hc:k.$ic,v=I===O.OperatingSystem.Linux?A.$9g:A.$$g,C=$.getWorkspace(),P=(0,w.$Qb)(C.folders);if(!P)return;f.scheme!==P.uri.scheme&&f.path[0]===k.$ic.sep&&f.path[1]!==k.$ic.sep&&(f=P.uri.with({path:f.path}));const g=$.getWorkspaceFolder(f);if(!g)return;let b;if(v.isEqual(g.uri,f)?b="":b=v.relativePath(g.uri,f)??"",b&&(b=D.normalize(b)),C.folders.length>1&&!$.noPrefix){const L=g.name?g.name:v.basenameOrAuthority(g.uri);b=b?`${L} \u2022 ${b}`:L}return b}function R(f,$=O.$i){return(0,S.$Jg)(f,$)?f.charAt(0).toUpperCase()+f.slice(1):f}let y=Object.create(null);function u(f,$,I=O.OS){if(I===O.OperatingSystem.Windows||!f||!$)return f;let D=y.original===$?y.normalized:void 0;D||(D=$,O.$i&&(D=(0,S.$yg)(D)),D=`${(0,T.$of)(D,k.$ic.sep)}${k.$ic.sep}`,y={original:$,normalized:D});let v=f;return O.$i&&(v=(0,S.$yg)(v)),(I===O.OperatingSystem.Linux?v.startsWith(D):(0,T.$Hf)(v,D))?`~/${v.substr(D.length)}`:f}function E(f,$){return f.replace(/^~($|\/|\\)/,`${$}$1`)}const d="\u2026",n="\\\\",s="~";function o(f,$=k.sep){const I=new Array(f.length);let D=!1;for(let v=0;v<f.length;v++){const C=f[v];if(C===""){I[v]=`.${$}`;continue}if(!C){I[v]=C;continue}D=!0;let P="",g=C;g.indexOf(n)===0?(P=g.substr(0,g.indexOf(n)+n.length),g=g.substr(g.indexOf(n)+n.length)):g.indexOf($)===0?(P=g.substr(0,g.indexOf($)+$.length),g=g.substr(g.indexOf($)+$.length)):g.indexOf(s)===0&&(P=g.substr(0,g.indexOf(s)+s.length),g=g.substr(g.indexOf(s)+s.length));const b=g.split($);for(let L=1;D&&L<=b.length;L++)for(let N=b.length-L;D&&N>=0;N--){D=!1;let B=b.slice(N,N+L).join($);for(let G=0;!D&&G<f.length;G++)if(G!==v&&f[G]&&f[G].indexOf(B)>-1){const W=N+L===b.length,F=N>0&&f[G].indexOf($)>-1?$+B:B,q=f[G].endsWith(F);D=!W||q}if(!D){let G="";(b[0].endsWith(":")||P!=="")&&(N===1&&(N=0,L++,B=b[0]+$+B),N>0&&(G=b[0]+$),G=P+G),N>0&&(G=G+d+$),G=G+B,N+L<b.length&&(G=G+$+d),I[v]=G}}D&&(I[v]=C)}return I}var h;(function(f){f[f.TEXT=0]="TEXT",f[f.VARIABLE=1]="VARIABLE",f[f.SEPARATOR=2]="SEPARATOR"})(h||(h={}));function i(f,$=Object.create(null)){const I=[];let D=!1,v="";for(const C of f)if(C==="$"||D&&C==="{")v&&I.push({value:v,type:h.TEXT}),v="",D=!0;else if(C==="}"&&D){const P=$[v];if(typeof P=="string")P.length&&I.push({value:P,type:h.VARIABLE});else if(P){const g=I[I.length-1];(!g||g.type!==h.SEPARATOR)&&I.push({value:P.label,type:h.SEPARATOR})}v="",D=!1}else v+=C;return v&&!D&&I.push({value:v,type:h.TEXT}),I.filter((C,P)=>{if(C.type===h.SEPARATOR){const g=I[P-1],b=I[P+1];return[g,b].every(L=>L&&(L.type===h.VARIABLE||L.type===h.TEXT)&&L.value.length>0)}return!0}).map(C=>C.value).join("")}function r(f,$){return O.$j||$?f.replace(/\(&&\w\)|&&/g,"").replace(/&/g,O.$j?"&":"&&"):f.replace(/&&|&/g,I=>I==="&"?"&&":"&")}function t(f,$){return O.$j||$?f.replace(/\(&&\w\)|&&/g,""):O.$i?f.replace(/&&|&/g,I=>I==="&"?"&&":"&"):f.replace(/&&/g,"_")}function c(f){return f.replace(/&/g,"&&")}function l(f){if(f.endsWith("]")){const $=f.lastIndexOf(" [",f.length-2);if($!==-1){const I=m(f.substring(0,$)),D=f.substring($);return{name:I.name+D,parentPath:I.parentPath}}}return m(f)}function m(f){const $=f.indexOf("/")!==-1?k.$ic:k.$hc,I=$.basename(f),D=$.dirname(f);return I.length?{name:I,parentPath:D}:{name:D,parentPath:""}}}),define(ke[160],Ce([1,0,23,38,2]),function(oe,e,w,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kn=e.$Jn=void 0,e.$Ln=p,e.$Mn=R,e.$Nn=y;function O(u){return u.toJSON()}class A{constructor(E){this.a=E}transformIncoming(E){const d=this.a.transformIncoming(E);return d===E?E:O(k.URI.from(d))}transformOutgoing(E){const d=this.a.transformOutgoing(E);return d===E?E:O(k.URI.from(d))}transformOutgoingURI(E){const d=this.a.transformOutgoing(E);return d===E?E:k.URI.from(d)}transformOutgoingScheme(E){return this.a.transformOutgoingScheme(E)}}e.$Jn=A,e.$Kn=new class{transformIncoming(u){return u}transformOutgoing(u){return u}transformOutgoingURI(u){return u}transformOutgoingScheme(u){return u}};function T(u,E,d){if(!u||d>200)return null;if(typeof u=="object"){if(u instanceof k.URI)return E.transformOutgoing(u);for(const n in u)if(Object.hasOwnProperty.call(u,n)){const s=T(u[n],E,d+1);s!==null&&(u[n]=s)}}return null}function p(u,E){const d=T(u,E,0);return d===null?u:d}function a(u,E,d,n){if(!u||n>200)return null;if(typeof u=="object"){if(u.$mid===S.MarshalledId.Uri)return d?k.URI.revive(E.transformIncoming(u)):E.transformIncoming(u);if(u instanceof w.$Oe)return null;for(const s in u)if(Object.hasOwnProperty.call(u,s)){const o=a(u[s],E,d,n+1);o!==null&&(u[s]=o)}}return null}function R(u,E){const d=a(u,E,!1,0);return d===null?u:d}function y(u,E){const d=a(u,E,!0,0);return d===null?u:d}}),define(ke[161],Ce([1,0,11,6,4,49,15]),function(oe,e,w,S,k,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$p=e.$0p=e.StorageState=e.StorageHint=void 0,e.$9p=p;var T;(function(u){u[u.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",u[u.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(T||(e.StorageHint=T={}));function p(u){const E=u;return E?.changed instanceof Map||E?.deleted instanceof Set}var a;(function(u){u[u.None=0]="None",u[u.Initialized=1]="Initialized",u[u.Closed=2]="Closed"})(a||(e.StorageState=a={}));class R extends k.$Wc{static{this.a=100}constructor(E,d=Object.create(null)){super(),this.r=E,this.s=d,this.b=this.B(new S.$pe),this.onDidChangeStorage=this.b.event,this.c=a.None,this.f=new Map,this.g=this.B(new w.$Dh(R.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(E=>this.u(E)))}u(E){this.b.pause();try{E.changed?.forEach((d,n)=>this.w(n,d)),E.deleted?.forEach(d=>this.w(d,void 0))}finally{this.b.resume()}}w(E,d){if(this.c===a.Closed)return;let n=!1;(0,A.$og)(d)?n=this.f.delete(E):this.f.get(E)!==d&&(this.f.set(E,d),n=!0),n&&this.b.fire({key:E,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===a.None&&(this.c=a.Initialized,this.s.hint!==T.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(E,d){const n=this.f.get(E);return(0,A.$og)(n)?d:n}getBoolean(E,d){const n=this.get(E);return(0,A.$og)(n)?d:n==="true"}getNumber(E,d){const n=this.get(E);return(0,A.$og)(n)?d:parseInt(n,10)}getObject(E,d){const n=this.get(E);return(0,A.$og)(n)?d:(0,O.$bi)(n)}async set(E,d,n=!1){if(this.c===a.Closed)return;if((0,A.$og)(d))return this.delete(E,n);const s=(0,A.$hg)(d)||Array.isArray(d)?(0,O.$ai)(d):String(d);if(this.f.get(E)!==s)return this.f.set(E,s),this.j.set(E,s),this.h.delete(E),this.b.fire({key:E,external:n}),this.D()}async delete(E,d=!1){if(!(this.c===a.Closed||!this.f.delete(E)))return this.h.has(E)||this.h.add(E),this.j.delete(E),this.b.fire({key:E,external:d}),this.D()}async optimize(){if(this.c!==a.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=a.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const E={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(E).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(E){if(!(this.c===a.Closed||this.m))return this.D(E)}async D(E){return this.s.hint===T.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),E)}async whenFlushed(){if(this.z)return new Promise(E=>this.n.push(E))}isInMemory(){return this.s.hint===T.STORAGE_IN_MEMORY}}e.$0p=R;class y{constructor(){this.onDidChangeItemsExternal=S.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(E){E.insert?.forEach((d,n)=>this.a.set(n,d)),E.delete?.forEach(d=>this.a.delete(d))}async optimize(){}async close(){}}e.$$p=y}),define(ke[162],Ce([1,0,13,21,23]),function(oe,e,w,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9t=void 0,e.$7t=R,e.$8t=y,w=qe(w),S=qe(S),k=qe(k);let O;function A(){return O||(O=new TextDecoder("UTF-16LE")),O}let T;function p(){return T||(T=new TextDecoder("UTF-16BE")),T}let a;function R(){return a||(a=S.$D()?A():p()),a}function y(d,n,s){const o=new Uint16Array(d.buffer,n,s);return s>0&&(o[0]===65279||o[0]===65534)?u(d,n,s):A().decode(o)}function u(d,n,s){const o=[];let h=0;for(let i=0;i<s;i++){const r=k.$Qe(d,n);n+=2,o[h++]=String.fromCharCode(r)}return o.join("")}class E{constructor(n){this.a=n|0,this.b=new Uint16Array(this.a),this.c=null,this.d=0}reset(){this.c=null,this.d=0}build(){return this.c!==null?(this.f(),this.c.join("")):this.e()}e(){if(this.d===0)return"";const n=new Uint16Array(this.b.buffer,0,this.d);return R().decode(n)}f(){const n=this.e();this.d=0,this.c===null?this.c=[n]:this.c[this.c.length]=n}appendCharCode(n){const s=this.a-this.d;s<=1&&(s===0||w.$Kf(n))&&this.f(),this.b[this.d++]=n}appendASCIICharCode(n){this.d===this.a&&this.f(),this.b[this.d++]=n}appendString(n){const s=n.length;if(this.d+s>=this.a){this.f(),this.c[this.c.length]=n;return}for(let o=0;o<s;o++)this.b[this.d++]=n.charCodeAt(o)}}e.$9t=E}),define(ke[163],Ce([1,0,23,162]),function(oe,e,w,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0t=void 0,e.$$t=A,w=qe(w);function k(p){return p.replace(/\n/g,"\\n").replace(/\r/g,"\\r")}class O{get oldLength(){return this.oldText.length}get oldEnd(){return this.oldPosition+this.oldText.length}get newLength(){return this.newText.length}get newEnd(){return this.newPosition+this.newText.length}constructor(a,R,y,u){this.oldPosition=a,this.oldText=R,this.newPosition=y,this.newText=u}toString(){return this.oldText.length===0?`(insert@${this.oldPosition} "${k(this.newText)}")`:this.newText.length===0?`(delete@${this.oldPosition} "${k(this.oldText)}")`:`(replace@${this.oldPosition} "${k(this.oldText)}" with "${k(this.newText)}")`}static a(a){return 4+2*a.length}static c(a,R,y){const u=R.length;w.$Te(a,u,y),y+=4;for(let E=0;E<u;E++)w.$Re(a,R.charCodeAt(E),y),y+=2;return y}static d(a,R){const y=w.$Se(a,R);return R+=4,(0,S.$8t)(a,R,y)}writeSize(){return 8+O.a(this.oldText)+O.a(this.newText)}write(a,R){return w.$Te(a,this.oldPosition,R),R+=4,w.$Te(a,this.newPosition,R),R+=4,R=O.c(a,this.oldText,R),R=O.c(a,this.newText,R),R}static read(a,R,y){const u=w.$Se(a,R);R+=4;const E=w.$Se(a,R);R+=4;const d=O.d(a,R);R+=O.a(d);const n=O.d(a,R);return R+=O.a(n),y.push(new O(u,d,E,n)),R}}e.$0t=O;function A(p,a){return p===null||p.length===0?a:new T(p,a).compress()}class T{constructor(a,R){this.a=a,this.c=R,this.d=[],this.e=0,this.f=this.a.length,this.g=0,this.h=this.c.length,this.j=0}compress(){let a=0,R=0,y=this.n(a),u=this.l(R);for(;a<this.f||R<this.h;){if(y===null){this.k(u),u=this.l(++R);continue}if(u===null){this.m(y),y=this.n(++a);continue}if(u.oldEnd<=y.newPosition){this.k(u),u=this.l(++R);continue}if(y.newEnd<=u.oldPosition){this.m(y),y=this.n(++a);continue}if(u.oldPosition<y.newPosition){const[o,h]=T.r(u,y.newPosition-u.oldPosition);this.k(o),u=h;continue}if(y.newPosition<u.oldPosition){const[o,h]=T.q(y,u.oldPosition-y.newPosition);this.m(o),y=h;continue}let n,s;if(u.oldEnd===y.newEnd)n=y,s=u,y=this.n(++a),u=this.l(++R);else if(u.oldEnd<y.newEnd){const[o,h]=T.q(y,u.oldLength);n=o,s=u,y=h,u=this.l(++R)}else{const[o,h]=T.r(u,y.newLength);n=y,s=o,y=this.n(++a),u=h}this.d[this.e++]=new O(n.oldPosition,n.oldText,s.newPosition,s.newText),this.g+=n.newLength-n.oldLength,this.j+=s.newLength-s.oldLength}const E=T.s(this.d);return T.t(E)}k(a){this.d[this.e++]=T.o(this.g,a),this.j+=a.newLength-a.oldLength}l(a){return a<this.h?this.c[a]:null}m(a){this.d[this.e++]=T.p(this.j,a),this.g+=a.newLength-a.oldLength}n(a){return a<this.f?this.a[a]:null}static o(a,R){return new O(R.oldPosition-a,R.oldText,R.newPosition,R.newText)}static p(a,R){return new O(R.oldPosition,R.oldText,R.newPosition+a,R.newText)}static q(a,R){const y=a.newText.substr(0,R),u=a.newText.substr(R);return[new O(a.oldPosition,a.oldText,a.newPosition,y),new O(a.oldEnd,"",a.newPosition+R,u)]}static r(a,R){const y=a.oldText.substr(0,R),u=a.oldText.substr(R);return[new O(a.oldPosition,y,a.newPosition,a.newText),new O(a.oldPosition+R,u,a.newEnd,"")]}static s(a){if(a.length===0)return a;const R=[];let y=0,u=a[0];for(let E=1;E<a.length;E++){const d=a[E];u.oldEnd===d.oldPosition?u=new O(u.oldPosition,u.oldText+d.oldText,u.newPosition,u.newText+d.newText):(R[y++]=u,u=d)}return R[y++]=u,R}static t(a){if(a.length===0)return a;const R=[];let y=0;for(let u=0;u<a.length;u++){const E=a[u];E.oldText!==E.newText&&(R[y++]=E)}return R}}}),define(ke[164],Ce([1,0,41,20]),function(oe,e,w,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ou=k,e.$pu=O;function k(A,T,p,a,R,y){if(Array.isArray(A)){let u=0;for(const E of A){const d=k(E,T,p,a,R,y);if(d===10)return d;d>u&&(u=d)}return u}else{if(typeof A=="string")return a?A==="*"?5:A===p?10:0:0;if(A){const{language:u,pattern:E,scheme:d,hasAccessToAllModels:n,notebookType:s}=A;if(!a&&!n)return 0;s&&R&&(T=R);let o=0;if(d)if(d===T.scheme)o=10;else if(d==="*")o=5;else return 0;if(u)if(u===p)o=10;else if(u==="*")o=Math.max(o,5);else return 0;if(s)if(s===y)o=10;else if(s==="*"&&y!==void 0)o=Math.max(o,5);else return 0;if(E){let h;if(typeof E=="string"?h=E:h={...E,base:(0,S.$jc)(E.base)},h===T.fsPath||(0,w.$yk)(h,T.fsPath))o=10;else return 0}return o}else return 0}}function O(A){return typeof A=="string"?!1:Array.isArray(A)?A.some(O):!!A.notebookType}}),define(ke[165],Ce([1,0,6,13,33,52,100,148,163,4]),function(oe,e,w,S,k,O,A,T,p,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hD=void 0,S=qe(S);class R extends a.$Wc{constructor(u,E,d,n,s,o,h){super(),this.m=this.B(new w.$me),this.onDidChangeContent=this.m.event,this.f=E,this.j=!o,this.g=n,this.h=s,this.c=new A.$gD(u,d,h)}equals(u){return!(u instanceof R)||this.f!==u.f||this.getEOL()!==u.getEOL()?!1:this.c.equal(u.c)}mightContainRTL(){return this.g}mightContainUnusualLineTerminators(){return this.h}resetMightContainUnusualLineTerminators(){this.h=!1}mightContainNonBasicASCII(){return this.j}getBOM(){return this.f}getEOL(){return this.c.getEOL()}createSnapshot(u){return this.c.createSnapshot(u?this.f:"")}getOffsetAt(u,E){return this.c.getOffsetAt(u,E)}getPositionAt(u){return this.c.getPositionAt(u)}getRangeAt(u,E){const d=u+E,n=this.getPositionAt(u),s=this.getPositionAt(d);return new k.$Ht(n.lineNumber,n.column,s.lineNumber,s.column)}getValueInRange(u,E=O.EndOfLinePreference.TextDefined){if(u.isEmpty())return"";const d=this.n(E);return this.c.getValueInRange(u,d)}getValueLengthInRange(u,E=O.EndOfLinePreference.TextDefined){if(u.isEmpty())return 0;if(u.startLineNumber===u.endLineNumber)return u.endColumn-u.startColumn;const d=this.getOffsetAt(u.startLineNumber,u.startColumn),n=this.getOffsetAt(u.endLineNumber,u.endColumn);let s=0;const o=this.n(E),h=this.getEOL();if(o.length!==h.length){const i=o.length-h.length,r=u.endLineNumber-u.startLineNumber;s=i*r}return n-d+s}getCharacterCountInRange(u,E=O.EndOfLinePreference.TextDefined){if(this.j){let d=0;const n=u.startLineNumber,s=u.endLineNumber;for(let o=n;o<=s;o++){const h=this.getLineContent(o),i=o===n?u.startColumn-1:0,r=o===s?u.endColumn-1:h.length;for(let t=i;t<r;t++)S.$Kf(h.charCodeAt(t))?(d=d+1,t=t+1):d=d+1}return d+=this.n(E).length*(s-n),d}return this.getValueLengthInRange(u,E)}getNearestChunk(u){return this.c.getNearestChunk(u)}getLength(){return this.c.getLength()}getLineCount(){return this.c.getLineCount()}getLinesContent(){return this.c.getLinesContent()}getLineContent(u){return this.c.getLineContent(u)}getLineCharCode(u,E){return this.c.getLineCharCode(u,E)}getCharCode(u){return this.c.getCharCode(u)}getLineLength(u){return this.c.getLineLength(u)}getLineMinColumn(u){return 1}getLineMaxColumn(u){return this.getLineLength(u)+1}getLineFirstNonWhitespaceColumn(u){const E=S.$vf(this.getLineContent(u));return E===-1?0:E+1}getLineLastNonWhitespaceColumn(u){const E=S.$xf(this.getLineContent(u));return E===-1?0:E+2}n(u){switch(u){case O.EndOfLinePreference.LF:return`
`;case O.EndOfLinePreference.CRLF:return`\r
`;case O.EndOfLinePreference.TextDefined:return this.getEOL();default:throw new Error("Unknown EOL preference")}}setEOL(u){this.c.setEOL(u)}applyEdits(u,E,d){let n=this.g,s=this.h,o=this.j,h=!0,i=[];for(let $=0;$<u.length;$++){const I=u[$];h&&I._isTracked&&(h=!1);const D=I.range;if(I.text){let b=!0;o||(b=!S.$Vf(I.text),o=b),!n&&b&&(n=S.$Uf(I.text)),!s&&b&&(s=S.$Xf(I.text))}let v="",C=0,P=0,g=0;if(I.text){let b;[C,P,g,b]=(0,T.$ru)(I.text);const L=this.getEOL(),N=L===`\r
`?T.StringEOL.CRLF:T.StringEOL.LF;b===T.StringEOL.Unknown||b===N?v=I.text:v=I.text.replace(/\r\n|\r|\n/g,L)}i[$]={sortIndex:$,identifier:I.identifier||null,range:D,rangeOffset:this.getOffsetAt(D.startLineNumber,D.startColumn),rangeLength:this.getValueLengthInRange(D),text:v,eolCount:C,firstLineLength:P,lastLineLength:g,forceMoveMarkers:!!I.forceMoveMarkers,isAutoWhitespaceEdit:I.isAutoWhitespaceEdit||!1}}i.sort(R.u);let r=!1;for(let $=0,I=i.length-1;$<I;$++){const D=i[$].range.getEndPosition(),v=i[$+1].range.getStartPosition();if(v.isBeforeOrEqual(D)){if(v.isBefore(D))throw new Error("Overlapping ranges are not allowed!");r=!0}}h&&(i=this.s(i));const t=d||E?R._getInverseEditRanges(i):[],c=[];if(E)for(let $=0;$<i.length;$++){const I=i[$],D=t[$];if(I.isAutoWhitespaceEdit&&I.range.isEmpty())for(let v=D.startLineNumber;v<=D.endLineNumber;v++){let C="";v===D.startLineNumber&&(C=this.getLineContent(I.range.startLineNumber),S.$vf(C)!==-1)||c.push({lineNumber:v,oldContent:C})}}let l=null;if(d){let $=0;l=[];for(let I=0;I<i.length;I++){const D=i[I],v=t[I],C=this.getValueInRange(D.range),P=D.rangeOffset+$;$+=D.text.length-C.length,l[I]={sortIndex:D.sortIndex,identifier:D.identifier,range:v,text:C,textChange:new p.$0t(D.rangeOffset,C,P,D.text)}}r||l.sort((I,D)=>I.sortIndex-D.sortIndex)}this.g=n,this.h=s,this.j=o;const m=this.t(i);let f=null;if(E&&c.length>0){c.sort(($,I)=>I.lineNumber-$.lineNumber),f=[];for(let $=0,I=c.length;$<I;$++){const D=c[$].lineNumber;if($>0&&c[$-1].lineNumber===D)continue;const v=c[$].oldContent,C=this.getLineContent(D);C.length===0||C===v||S.$vf(C)!==-1||f.push(D)}}return this.m.fire(),new O.$aw(l,m,f)}s(u){return u.length<1e3?u:[this._toSingleEditOperation(u)]}_toSingleEditOperation(u){let E=!1;const d=u[0].range,n=u[u.length-1].range,s=new k.$Ht(d.startLineNumber,d.startColumn,n.endLineNumber,n.endColumn);let o=d.startLineNumber,h=d.startColumn;const i=[];for(let m=0,f=u.length;m<f;m++){const $=u[m],I=$.range;E=E||$.forceMoveMarkers,i.push(this.getValueInRange(new k.$Ht(o,h,I.startLineNumber,I.startColumn))),$.text.length>0&&i.push($.text),o=I.endLineNumber,h=I.endColumn}const r=i.join(""),[t,c,l]=(0,T.$ru)(r);return{sortIndex:0,identifier:u[0].identifier,range:s,rangeOffset:this.getOffsetAt(s.startLineNumber,s.startColumn),rangeLength:this.getValueLengthInRange(s,O.EndOfLinePreference.TextDefined),text:r,eolCount:t,firstLineLength:c,lastLineLength:l,forceMoveMarkers:E,isAutoWhitespaceEdit:!1}}t(u){u.sort(R.w);const E=[];for(let d=0;d<u.length;d++){const n=u[d],s=n.range.startLineNumber,o=n.range.startColumn,h=n.range.endLineNumber,i=n.range.endColumn;if(s===h&&o===i&&n.text.length===0)continue;n.text?(this.c.delete(n.rangeOffset,n.rangeLength),this.c.insert(n.rangeOffset,n.text,!0)):this.c.delete(n.rangeOffset,n.rangeLength);const r=new k.$Ht(s,o,h,i);E.push({range:r,rangeLength:n.rangeLength,text:n.text,rangeOffset:n.rangeOffset,forceMoveMarkers:n.forceMoveMarkers})}return E}findMatchesLineByLine(u,E,d,n){return this.c.findMatchesLineByLine(u,E,d,n)}getPieceTree(){return this.c}static _getInverseEditRange(u,E){const d=u.startLineNumber,n=u.startColumn,[s,o,h]=(0,T.$ru)(E);let i;if(E.length>0){const r=s+1;r===1?i=new k.$Ht(d,n,d,n+o):i=new k.$Ht(d,n,d+r-1,h+1)}else i=new k.$Ht(d,n,d,n);return i}static _getInverseEditRanges(u){const E=[];let d=0,n=0,s=null;for(let o=0,h=u.length;o<h;o++){const i=u[o];let r,t;s?s.range.endLineNumber===i.range.startLineNumber?(r=d,t=n+(i.range.startColumn-s.range.endColumn)):(r=d+(i.range.startLineNumber-s.range.endLineNumber),t=i.range.startColumn):(r=i.range.startLineNumber,t=i.range.startColumn);let c;if(i.text.length>0){const l=i.eolCount+1;l===1?c=new k.$Ht(r,t,r,t+i.firstLineLength):c=new k.$Ht(r,t,r+l-1,i.lastLineLength+1)}else c=new k.$Ht(r,t,r,t);d=c.endLineNumber,n=c.endColumn,E.push(c),s=i}return E}static u(u,E){const d=k.$Ht.compareRangesUsingEnds(u.range,E.range);return d===0?u.sortIndex-E.sortIndex:d}static w(u,E){const d=k.$Ht.compareRangesUsingEnds(u.range,E.range);return d===0?E.sortIndex-u.sortIndex:-d}}e.$hD=R}),define(ke[166],Ce([1,0,28,13,52,100,165]),function(oe,e,w,S,k,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iD=void 0,S=qe(S);class T{constructor(R,y,u,E,d,n,s,o,h){this.a=R,this.b=y,this.c=u,this.d=E,this.e=d,this.f=n,this.g=s,this.h=o,this.j=h}k(R){const y=this.c+this.d+this.e,u=this.c+this.e;return y===0?R===k.DefaultEndOfLine.LF?`
`:`\r
`:u>y/2?`\r
`:`
`}create(R){const y=this.k(R),u=this.a;if(this.j&&(y===`\r
`&&(this.c>0||this.d>0)||y===`
`&&(this.c>0||this.e>0)))for(let d=0,n=u.length;d<n;d++){const s=u[d].buffer.replace(/\r\n|\r|\n/g,y),o=(0,O.$cD)(s);u[d]=new O.$fD(s,o)}const E=new A.$hD(u,this.b,y,this.f,this.g,this.h,this.j);return{textBuffer:E,disposable:E}}getFirstLineText(R){return this.a[0].buffer.substr(0,R).split(/\r\n|\r|\n/)[0]}}class p{constructor(){this.a=[],this.b="",this.c=!1,this.d=0,this.e=[],this.f=0,this.g=0,this.h=0,this.j=!1,this.k=!1,this.l=!0}acceptChunk(R){if(R.length===0)return;this.a.length===0&&S.$6f(R)&&(this.b=S.$5f,R=R.substr(1));const y=R.charCodeAt(R.length-1);y===w.CharCode.CarriageReturn||y>=55296&&y<=56319?(this.m(R.substr(0,R.length-1),!1),this.c=!0,this.d=y):(this.m(R,!1),this.c=!1,this.d=y)}m(R,y){!y&&R.length===0||(this.c?this.n(String.fromCharCode(this.d)+R):this.n(R))}n(R){const y=(0,O.$dD)(this.e,R);this.a.push(new O.$fD(R,y.lineStarts)),this.f+=y.cr,this.g+=y.lf,this.h+=y.crlf,y.isBasicASCII||(this.l=!1,this.j||(this.j=S.$Uf(R)),this.k||(this.k=S.$Xf(R)))}finish(R=!0){return this.o(),new T(this.a,this.b,this.f,this.g,this.h,this.j,this.k,this.l,R)}o(){if(this.a.length===0&&this.m("",!0),this.c){this.c=!1;const R=this.a[this.a.length-1];R.buffer+=String.fromCharCode(this.d);const y=(0,O.$cD)(R.buffer);R.lineStarts=y,this.d===w.CharCode.CarriageReturn&&this.f++}}}e.$iD=p}),define(ke[104],Ce([1,0,23,21]),function(oe,e,w,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ndb=p,e.$odb=R,S=qe(S);var k;(function(y){y[y.Full=1]="Full",y[y.Delta=2]="Delta"})(k||(k={}));function O(y){for(let u=0,E=y.length;u<E;u+=4){const d=y[u+0],n=y[u+1],s=y[u+2],o=y[u+3];y[u+0]=o,y[u+1]=s,y[u+2]=n,y[u+3]=d}}function A(y){const u=new Uint8Array(y.buffer,y.byteOffset,y.length*4);return S.$D()||O(u),w.$Oe.wrap(u)}function T(y){const u=y.buffer;if(S.$D()||O(u),u.byteOffset%4===0)return new Uint32Array(u.buffer,u.byteOffset,u.length/4);{const E=new Uint8Array(u.byteLength);return E.set(u),new Uint32Array(E.buffer,E.byteOffset,E.length/4)}}function p(y){const u=new Uint32Array(a(y));let E=0;if(u[E++]=y.id,y.type==="full")u[E++]=k.Full,u[E++]=y.data.length,u.set(y.data,E),E+=y.data.length;else{u[E++]=k.Delta,u[E++]=y.deltas.length;for(const d of y.deltas)u[E++]=d.start,u[E++]=d.deleteCount,d.data?(u[E++]=d.data.length,u.set(d.data,E),E+=d.data.length):u[E++]=0}return A(u)}function a(y){let u=0;if(u+=2,y.type==="full")u+=1+y.data.length;else{u+=1,u+=3*y.deltas.length;for(const E of y.deltas)E.data&&(u+=E.data.length)}return u}function R(y){const u=T(y);let E=0;const d=u[E++];if(u[E++]===k.Full){const h=u[E++],i=u.subarray(E,E+h);return E+=h,{id:d,type:"full",data:i}}const s=u[E++],o=[];for(let h=0;h<s;h++){const i=u[E++],r=u[E++],t=u[E++];let c;t>0&&(c=u.subarray(E,E+t),E+=t),o[h]={start:i,deleteCount:r,data:c}}return{id:d,type:"delta",deltas:o}}}),define(ke[167],Ce([8,9]),function(oe,e){return oe.create("vs/editor/common/config/editorOptions",e)}),define(ke[168],Ce([8,9]),function(oe,e){return oe.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ke[169],Ce([8,9]),function(oe,e){return oe.create("vs/platform/contextkey/common/contextkey",e)}),define(ke[170],Ce([8,9]),function(oe,e){return oe.create("vs/platform/contextkey/common/scanner",e)}),define(ke[171],Ce([8,9]),function(oe,e){return oe.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ke[172],Ce([8,9]),function(oe,e){return oe.create("vs/platform/extensions/common/extensionValidator",e)}),define(ke[173],Ce([8,9]),function(oe,e){return oe.create("vs/platform/files/common/files",e)}),define(ke[174],Ce([8,9]),function(oe,e){return oe.create("vs/platform/log/common/log",e)}),define(ke[175],Ce([8,9]),function(oe,e){return oe.create("vs/platform/markers/common/markers",e)}),define(ke[176],Ce([8,9]),function(oe,e){return oe.create("vs/platform/request/common/request",e)}),define(ke[177],Ce([8,9]),function(oe,e){return oe.create("vs/platform/theme/common/iconRegistry",e)}),define(ke[178],Ce([8,9]),function(oe,e){return oe.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(ke[179],Ce([8,9]),function(oe,e){return oe.create("vs/platform/workspace/common/workspace",e)}),define(ke[180],Ce([8,9]),function(oe,e){return oe.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(ke[181],Ce([8,9]),function(oe,e){return oe.create("vs/workbench/api/common/extHostExtensionService",e)}),define(ke[182],Ce([8,9]),function(oe,e){return oe.create("vs/workbench/api/common/extHostLanguageFeatures",e)}),define(ke[183],Ce([8,9]),function(oe,e){return oe.create("vs/workbench/api/common/extHostLanguageModels",e)}),define(ke[184],Ce([8,9]),function(oe,e){return oe.create("vs/workbench/api/common/extHostLogService",e)}),define(ke[185],Ce([8,9]),function(oe,e){return oe.create("vs/workbench/api/common/extHostNotebook",e)}),define(ke[186],Ce([8,9]),function(oe,e){return oe.create("vs/workbench/api/common/extHostStatusBar",e)}),define(ke[187],Ce([8,9]),function(oe,e){return oe.create("vs/workbench/api/common/extHostTelemetry",e)}),define(ke[188],Ce([8,9]),function(oe,e){return oe.create("vs/workbench/api/common/extHostTerminalService",e)}),define(ke[189],Ce([8,9]),function(oe,e){return oe.create("vs/workbench/api/common/extHostTreeViews",e)}),define(ke[190],Ce([8,9]),function(oe,e){return oe.create("vs/workbench/api/common/extHostTunnelService",e)}),define(ke[191],Ce([8,9]),function(oe,e){return oe.create("vs/workbench/api/common/extHostWorkspace",e)}),define(ke[192],Ce([8,9]),function(oe,e){return oe.create("vs/workbench/common/configuration",e)}),define(ke[193],Ce([8,9]),function(oe,e){return oe.create("vs/workbench/common/editor",e)}),define(ke[194],Ce([8,9]),function(oe,e){return oe.create("vs/workbench/common/views",e)}),define(ke[195],Ce([8,9]),function(oe,e){return oe.create("vs/workbench/contrib/chat/common/chatContextKeys",e)}),define(ke[196],Ce([8,9]),function(oe,e){return oe.create("vs/workbench/contrib/chat/common/languageModels",e)}),define(ke[197],Ce([8,9]),function(oe,e){return oe.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(ke[198],Ce([8,9]),function(oe,e){return oe.create("vs/workbench/contrib/debug/common/debug",e)}),define(ke[199],Ce([8,9]),function(oe,e){return oe.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(ke[200],Ce([8,9]),function(oe,e){return oe.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(ke[201],Ce([8,9]),function(oe,e){return oe.create("vs/workbench/contrib/testing/common/constants",e)}),define(ke[202],Ce([8,9]),function(oe,e){return oe.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(ke[203],Ce([8,9]),function(oe,e){return oe.create("vs/workbench/services/editor/common/editorResolverService",e)}),define(ke[204],Ce([8,9]),function(oe,e){return oe.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(ke[205],Ce([8,9]),function(oe,e){return oe.create("vs/workbench/services/search/common/queryBuilder",e)}),define(ke[206],Ce([1,0,28,14,170]),function(oe,e,w,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Aj=e.TokenType=void 0;var O;(function(R){R[R.LParen=0]="LParen",R[R.RParen=1]="RParen",R[R.Neg=2]="Neg",R[R.Eq=3]="Eq",R[R.NotEq=4]="NotEq",R[R.Lt=5]="Lt",R[R.LtEq=6]="LtEq",R[R.Gt=7]="Gt",R[R.GtEq=8]="GtEq",R[R.RegexOp=9]="RegexOp",R[R.RegexStr=10]="RegexStr",R[R.True=11]="True",R[R.False=12]="False",R[R.In=13]="In",R[R.Not=14]="Not",R[R.And=15]="And",R[R.Or=16]="Or",R[R.Str=17]="Str",R[R.QuotedStr=18]="QuotedStr",R[R.Error=19]="Error",R[R.EOF=20]="EOF"})(O||(e.TokenType=O={}));function A(...R){switch(R.length){case 1:return(0,k.localize)(0,null,R[0]);case 2:return(0,k.localize)(1,null,R[0],R[1]);case 3:return(0,k.localize)(2,null,R[0],R[1],R[2]);default:return}}const T=(0,k.localize)(3,null),p=(0,k.localize)(4,null);class a{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(y){switch(y.type){case O.LParen:return"(";case O.RParen:return")";case O.Neg:return"!";case O.Eq:return y.isTripleEq?"===":"==";case O.NotEq:return y.isTripleEq?"!==":"!=";case O.Lt:return"<";case O.LtEq:return"<=";case O.Gt:return">=";case O.GtEq:return">=";case O.RegexOp:return"=~";case O.RegexStr:return y.lexeme;case O.True:return"true";case O.False:return"false";case O.In:return"in";case O.Not:return"not";case O.And:return"&&";case O.Or:return"||";case O.Str:return y.lexeme;case O.QuotedStr:return y.lexeme;case O.Error:return y.lexeme;case O.EOF:return"EOF";default:throw(0,S.$0)(`unhandled token type: ${JSON.stringify(y)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(y=>y.charCodeAt(0)))}static{this.b=new Map([["not",O.Not],["in",O.In],["false",O.False],["true",O.True]])}get errors(){return this.g}reset(y){return this.c=y,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case w.CharCode.OpenParen:this.k(O.LParen);break;case w.CharCode.CloseParen:this.k(O.RParen);break;case w.CharCode.ExclamationMark:if(this.h(w.CharCode.Equals)){const u=this.h(w.CharCode.Equals);this.f.push({type:O.NotEq,offset:this.d,isTripleEq:u})}else this.k(O.Neg);break;case w.CharCode.SingleQuote:this.o();break;case w.CharCode.Slash:this.q();break;case w.CharCode.Equals:if(this.h(w.CharCode.Equals)){const u=this.h(w.CharCode.Equals);this.f.push({type:O.Eq,offset:this.d,isTripleEq:u})}else this.h(w.CharCode.Tilde)?this.k(O.RegexOp):this.l(A("==","=~"));break;case w.CharCode.LessThan:this.k(this.h(w.CharCode.Equals)?O.LtEq:O.Lt);break;case w.CharCode.GreaterThan:this.k(this.h(w.CharCode.Equals)?O.GtEq:O.Gt);break;case w.CharCode.Ampersand:this.h(w.CharCode.Ampersand)?this.k(O.And):this.l(A("&&"));break;case w.CharCode.Pipe:this.h(w.CharCode.Pipe)?this.k(O.Or):this.l(A("||"));break;case w.CharCode.Space:case w.CharCode.CarriageReturn:case w.CharCode.Tab:case w.CharCode.LineFeed:case w.CharCode.NoBreakSpace:break;default:this.n()}return this.d=this.e,this.k(O.EOF),Array.from(this.f)}h(y){return this.r()||this.c.charCodeAt(this.e)!==y?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?w.CharCode.Null:this.c.charCodeAt(this.e)}k(y){this.f.push({type:y,offset:this.d})}l(y){const u=this.d,E=this.c.substring(this.d,this.e),d={type:O.Error,offset:this.d,lexeme:E};this.g.push({offset:u,lexeme:E,additionalInfo:y}),this.f.push(d)}n(){this.m.lastIndex=this.d;const y=this.m.exec(this.c);if(y){this.e=this.d+y[0].length;const u=this.c.substring(this.d,this.e),E=a.b.get(u);E?this.k(E):this.f.push({type:O.Str,lexeme:u,offset:this.d})}}o(){for(;this.j()!==w.CharCode.SingleQuote&&!this.r();)this.i();if(this.r()){this.l(T);return}this.i(),this.f.push({type:O.QuotedStr,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let y=this.e,u=!1,E=!1;for(;;){if(y>=this.c.length){this.e=y,this.l(p);return}const n=this.c.charCodeAt(y);if(u)u=!1;else if(n===w.CharCode.Slash&&!E){y++;break}else n===w.CharCode.OpenSquareBracket?E=!0:n===w.CharCode.Backslash?u=!0:n===w.CharCode.CloseSquareBracket&&(E=!1);y++}for(;y<this.c.length&&a.a.has(this.c.charCodeAt(y));)y++;this.e=y;const d=this.c.substring(this.d,this.e);this.f.push({type:O.RegexStr,lexeme:d,offset:this.d})}r(){return this.e>=this.c.length}}e.$Aj=a});var ti=this&&this.__importDefault||function(oe){return oe&&oe.__esModule?oe:{default:oe}};define(ke[207],Ce([1,0,24,36,172,322]),function(oe,e,w,S,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tp=p,e.$Up=a,e.$Vp=R,e.$Wp=y,e.$Xp=u,e.$Yp=E,e.$Zp=d,S=ti(S),k=qe(k),O=qe(O);const A=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,T=/^-(\d{4})(\d{2})(\d{2})$/;function p(o){return o=o.trim(),o==="*"||A.test(o)}function a(o){if(!p(o))return null;if(o=o.trim(),o==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const h=o.match(A);return h?{hasCaret:h[1]==="^",hasGreaterEquals:h[1]===">=",majorBase:h[2]==="x"?0:parseInt(h[2],10),majorMustEqual:h[2]!=="x",minorBase:h[4]==="x"?0:parseInt(h[4],10),minorMustEqual:h[4]!=="x",patchBase:h[6]==="x"?0:parseInt(h[6],10),patchMustEqual:h[6]!=="x",preRelease:h[8]||null}:null}function R(o){if(!o)return null;const h=o.majorBase,i=o.majorMustEqual,r=o.minorBase;let t=o.minorMustEqual;const c=o.patchBase;let l=o.patchMustEqual;o.hasCaret&&(h===0||(t=!1),l=!1);let m=0;if(o.preRelease){const f=T.exec(o.preRelease);if(f){const[,$,I,D]=f;m=Date.UTC(Number($),Number(I)-1,Number(D))}}return{majorBase:h,majorMustEqual:i,minorBase:r,minorMustEqual:t,patchBase:c,patchMustEqual:l,isMinimum:o.hasGreaterEquals,notBefore:m}}function y(o,h,i){let r;typeof o=="string"?r=R(a(o)):r=o;let t;h instanceof Date?t=h.getTime():typeof h=="string"&&(t=new Date(h).getTime());let c;if(typeof i=="string"?c=R(a(i)):c=i,!r||!c)return!1;const l=r.majorBase,m=r.minorBase,f=r.patchBase;let $=c.majorBase,I=c.minorBase,D=c.patchBase;const v=c.notBefore;let C=c.majorMustEqual,P=c.minorMustEqual,g=c.patchMustEqual;return c.isMinimum?l>$?!0:l<$?!1:m>I?!0:m<I||t&&t<v?!1:f>=D:(l===1&&$===0&&(!C||!P||!g)&&($=1,I=0,D=0,C=!0,P=!1,g=!1),l<$?!1:l>$?!C:m<I?!1:m>I?!P:f<D?!1:f>D?!g:!(t&&t<v))}function u(o,h,i,r,t){const c=[];if(typeof r.publisher<"u"&&typeof r.publisher!="string")return c.push([S.default.Error,k.localize(0,null)]),c;if(typeof r.name!="string")return c.push([S.default.Error,k.localize(1,null,"name")]),c;if(typeof r.version!="string")return c.push([S.default.Error,k.localize(2,null,"version")]),c;if(!r.engines)return c.push([S.default.Error,k.localize(3,null,"engines")]),c;if(typeof r.engines.vscode!="string")return c.push([S.default.Error,k.localize(4,null,"engines.vscode")]),c;if(typeof r.extensionDependencies<"u"&&!s(r.extensionDependencies))return c.push([S.default.Error,k.localize(5,null,"extensionDependencies")]),c;if(typeof r.activationEvents<"u"){if(!s(r.activationEvents))return c.push([S.default.Error,k.localize(6,null,"activationEvents")]),c;if(typeof r.main>"u"&&typeof r.browser>"u")return c.push([S.default.Error,k.localize(7,null,"activationEvents","main","browser")]),c}if(typeof r.extensionKind<"u"&&typeof r.main>"u"&&c.push([S.default.Warning,k.localize(8,null,"extensionKind")]),typeof r.main<"u"){if(typeof r.main!="string")return c.push([S.default.Error,k.localize(9,null,"main")]),c;{const f=(0,w.$gh)(i,r.main);(0,w.$ah)(f,i)||c.push([S.default.Warning,k.localize(10,null,f.path,i.path)])}}if(typeof r.browser<"u"){if(typeof r.browser!="string")return c.push([S.default.Error,k.localize(11,null,"browser")]),c;{const f=(0,w.$gh)(i,r.browser);(0,w.$ah)(f,i)||c.push([S.default.Warning,k.localize(12,null,f.path,i.path)])}}if(!O.valid(r.version))return c.push([S.default.Error,k.localize(13,null)]),c;const l=[];if(!E(o,h,r,t,l))for(const f of l)c.push([S.default.Error,f]);return c}function E(o,h,i,r,t){return r||typeof i.main>"u"&&typeof i.browser>"u"?!0:n(o,h,i.engines.vscode,t)}function d(o,h,i){return o==="*"||n(h,i,o)}function n(o,h,i,r=[]){const t=R(a(i));if(!t)return r.push(k.localize(14,null,i)),!1;if(t.majorBase===0){if(!t.majorMustEqual||!t.minorMustEqual)return r.push(k.localize(15,null,i)),!1}else if(!t.majorMustEqual)return r.push(k.localize(16,null,i)),!1;return y(o,h,t)?!0:(r.push(k.localize(17,null,o,i)),!1)}function s(o){if(!Array.isArray(o))return!1;for(let h=0,i=o.length;h<i;h++)if(typeof o[h]!="string")return!1;return!0}}),define(ke[74],Ce([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ci=void 0;class w{constructor(k,O=[],A=!1){this.ctor=k,this.staticArguments=O,this.supportsDelayedInstantiation=A}}e.$Ci=w}),define(ke[61],Ce([1,0,74]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationType=void 0,e.$Ks=O,e.$Ls=A;const S=[];var k;(function(T){T[T.Eager=0]="Eager",T[T.Delayed=1]="Delayed"})(k||(e.InstantiationType=k={}));function O(T,p,a){p instanceof w.$Ci||(p=new w.$Ci(p,[],!!a)),S.push([T,p])}function A(){return S}}),define(ke[208],Ce([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$or=e.$nr=void 0;class w{constructor(O,A){this.key=O,this.data=A,this.incoming=new Map,this.outgoing=new Map}}e.$nr=w;class S{constructor(O){this.b=O,this.a=new Map}roots(){const O=[];for(const A of this.a.values())A.outgoing.size===0&&O.push(A);return O}insertEdge(O,A){const T=this.lookupOrInsertNode(O),p=this.lookupOrInsertNode(A);T.outgoing.set(p.key,p),p.incoming.set(T.key,T)}removeNode(O){const A=this.b(O);this.a.delete(A);for(const T of this.a.values())T.outgoing.delete(A),T.incoming.delete(A)}lookupOrInsertNode(O){const A=this.b(O);let T=this.a.get(A);return T||(T=new w(A,O),this.a.set(A,T)),T}lookup(O){return this.a.get(this.b(O))}isEmpty(){return this.a.size===0}toString(){const O=[];for(const[A,T]of this.a)O.push(`${A}
	(-> incoming)[${[...T.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...T.outgoing.keys()].join(",")}]
`);return O.join(`
`)}findCycleSlow(){for(const[O,A]of this.a){const T=new Set([O]),p=this.c(A,T);if(p)return p}}c(O,A){for(const[T,p]of O.outgoing){if(A.has(T))return[...A,T].join(" -> ");A.add(T);const a=this.c(p,A);if(a)return a;A.delete(T)}}}e.$or=S}),define(ke[3],Ce([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ei=e._util=void 0,e.$Fi=k,e.$Gi=O;var w;(function(A){A.serviceIds=new Map,A.DI_TARGET="$di$target",A.DI_DEPENDENCIES="$di$dependencies";function T(p){return p[A.DI_DEPENDENCIES]||[]}A.getServiceDependencies=T})(w||(e._util=w={})),e.$Ei=k("instantiationService");function S(A,T,p){T[w.DI_TARGET]===T?T[w.DI_DEPENDENCIES].push({id:A,index:p}):(T[w.DI_DEPENDENCIES]=[{id:A,index:p}],T[w.DI_TARGET]=T)}function k(A){if(w.serviceIds.has(A))return w.serviceIds.get(A);const T=function(p,a,R){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");S(T,p,R)};return T.toString=()=>A,w.serviceIds.set(A,T),T}function O(A){return A}}),define(ke[42],Ce([1,0,15,2,3]),function(oe,e,w,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationTarget=e.$_i=void 0,e.$aj=O,e.$bj=A,e.$cj=p,e.$dj=a,e.$ej=R,e.$fj=y,e.$gj=u,e.$hj=d,e.$ij=n,e.$jj=s,w=qe(w),e.$_i=(0,k.$Fi)("configurationService");function O(o){return o&&typeof o=="object"&&(!o.overrideIdentifier||typeof o.overrideIdentifier=="string")&&(!o.resource||o.resource instanceof S.URI)}function A(o){return o&&typeof o=="object"&&(!o.overrideIdentifiers||Array.isArray(o.overrideIdentifiers))&&!o.overrideIdentifier&&(!o.resource||o.resource instanceof S.URI)}var T;(function(o){o[o.APPLICATION=1]="APPLICATION",o[o.USER=2]="USER",o[o.USER_LOCAL=3]="USER_LOCAL",o[o.USER_REMOTE=4]="USER_REMOTE",o[o.WORKSPACE=5]="WORKSPACE",o[o.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",o[o.DEFAULT=7]="DEFAULT",o[o.MEMORY=8]="MEMORY"})(T||(e.ConfigurationTarget=T={}));function p(o){switch(o){case T.APPLICATION:return"APPLICATION";case T.USER:return"USER";case T.USER_LOCAL:return"USER_LOCAL";case T.USER_REMOTE:return"USER_REMOTE";case T.WORKSPACE:return"WORKSPACE";case T.WORKSPACE_FOLDER:return"WORKSPACE_FOLDER";case T.DEFAULT:return"DEFAULT";case T.MEMORY:return"MEMORY"}}function a(o){return o.applicationValue!==void 0||o.userValue!==void 0||o.userLocalValue!==void 0||o.userRemoteValue!==void 0||o.workspaceValue!==void 0||o.workspaceFolderValue!==void 0}function R(o,h){const i=Object.create(null);for(const r in o)y(i,r,o[r],h);return i}function y(o,h,i,r){const t=h.split("."),c=t.pop();let l=o;for(let m=0;m<t.length;m++){const f=t[m];let $=l[f];switch(typeof $){case"undefined":$=l[f]=Object.create(null);break;case"object":if($===null){r(`Ignoring ${h} as ${t.slice(0,m+1).join(".")} is null`);return}break;default:r(`Ignoring ${h} as ${t.slice(0,m+1).join(".")} is ${JSON.stringify($)}`);return}l=$}if(typeof l=="object"&&l!==null)try{l[c]=i}catch{r(`Ignoring ${h} as ${t.join(".")} is ${JSON.stringify(l)}`)}else r(`Ignoring ${h} as ${t.join(".")} is ${JSON.stringify(l)}`)}function u(o,h){const i=h.split(".");E(o,i)}function E(o,h){const i=h.shift();if(h.length===0){delete o[i];return}if(Object.keys(o).indexOf(i)!==-1){const r=o[i];typeof r=="object"&&!Array.isArray(r)&&(E(r,h),Object.keys(r).length===0&&delete o[i])}}function d(o,h,i){function r(l,m){let f=l;for(const $ of m){if(typeof f!="object"||f===null)return;f=f[$]}return f}const t=h.split("."),c=r(o,t);return typeof c>"u"?i:c}function n(o,h,i){Object.keys(h).forEach(r=>{r!=="__proto__"&&(r in o?w.$hg(o[r])&&w.$hg(h[r])?n(o[r],h[r],i):i&&(o[r]=h[r]):o[r]=h[r])})}function s(o){return o.replace(/[\[\]]/g,"")}}),define(ke[32],Ce([1,0,28,21,13,206,3,169,14]),function(oe,e,w,S,k,O,A,T,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xj=e.$Wj=e.$Vj=e.$Uj=e.$Tj=e.$Sj=e.$Rj=e.$Qj=e.$Pj=e.$Oj=e.$Nj=e.$Mj=e.$Lj=e.$Kj=e.$Jj=e.$Ij=e.$Hj=e.$Gj=e.$Dj=e.$Cj=e.ContextKeyExprType=void 0,e.$Bj=R,e.$Ej=m,e.$Fj=f,e.$Yj=se;const a=new Map;a.set("false",!1),a.set("true",!0),a.set("isMac",S.$j),a.set("isLinux",S.$k),a.set("isWindows",S.$i),a.set("isWeb",S.$o),a.set("isMacNative",S.$j&&!S.$o),a.set("isEdge",S.$H),a.set("isFirefox",S.$F),a.set("isChrome",S.$E),a.set("isSafari",S.$G);function R(Z,V){if(a.get(Z)!==void 0)throw(0,p.$9)("contextkey.setConstant(k, v) invoked with already set constant `k`");a.set(Z,V)}const y=Object.prototype.hasOwnProperty;var u;(function(Z){Z[Z.False=0]="False",Z[Z.True=1]="True",Z[Z.Defined=2]="Defined",Z[Z.Not=3]="Not",Z[Z.Equals=4]="Equals",Z[Z.NotEquals=5]="NotEquals",Z[Z.And=6]="And",Z[Z.Regex=7]="Regex",Z[Z.NotRegex=8]="NotRegex",Z[Z.Or=9]="Or",Z[Z.In=10]="In",Z[Z.NotIn=11]="NotIn",Z[Z.Greater=12]="Greater",Z[Z.GreaterEquals=13]="GreaterEquals",Z[Z.Smaller=14]="Smaller",Z[Z.SmallerEquals=15]="SmallerEquals"})(u||(e.ContextKeyExprType=u={}));const E={regexParsingWithErrorRecovery:!0},d=(0,T.localize)(0,null),n=(0,T.localize)(1,null),s=(0,T.localize)(2,null),o=(0,T.localize)(3,null),h=(0,T.localize)(4,null),i=(0,T.localize)(5,null),r=(0,T.localize)(6,null),t=(0,T.localize)(7,null);class c{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(V=E){this.k=V,this.d=new O.$Aj,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(V){if(V===""){this.h.push({message:d,offset:0,lexeme:"",additionalInfo:n});return}this.f=this.d.reset(V).scan(),this.g=0,this.h=[];try{const _=this.l();if(!this.E()){const ye=this.D(),ae=ye.type===O.TokenType.Str?i:void 0;throw this.h.push({message:h,offset:ye.offset,lexeme:O.$Aj.getLexeme(ye),additionalInfo:ae}),c.c}return _}catch(_){if(_!==c.c)throw _;return}}l(){return this.m()}m(){const V=[this.o()];for(;this.y(O.TokenType.Or);){const _=this.o();V.push(_)}return V.length===1?V[0]:l.or(...V)}o(){const V=[this.s()];for(;this.y(O.TokenType.And);){const _=this.s();V.push(_)}return V.length===1?V[0]:l.and(...V)}s(){if(this.y(O.TokenType.Neg)){const V=this.D();switch(V.type){case O.TokenType.True:return this.z(),I.INSTANCE;case O.TokenType.False:return this.z(),D.INSTANCE;case O.TokenType.LParen:{this.z();const _=this.l();return this.A(O.TokenType.RParen,o),_?.negate()}case O.TokenType.Str:return this.z(),L.create(V.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",V)}}return this.t()}t(){const V=this.D();switch(V.type){case O.TokenType.True:return this.z(),l.true();case O.TokenType.False:return this.z(),l.false();case O.TokenType.LParen:{this.z();const _=this.l();return this.A(O.TokenType.RParen,o),_}case O.TokenType.Str:{const _=V.lexeme;if(this.z(),this.y(O.TokenType.RegexOp)){const ae=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),ae.type!==O.TokenType.RegexStr)throw this.B("REGEX",ae);const we=ae.lexeme,he=we.lastIndexOf("/"),X=he===we.length-1?void 0:this.w(we.substring(he+1));let Y;try{Y=new RegExp(we.substring(1,he),X)}catch{throw this.B("REGEX",ae)}return q.create(_,Y)}switch(ae.type){case O.TokenType.RegexStr:case O.TokenType.Error:{const we=[ae.lexeme];this.z();let he=this.D(),X=0;for(let ze=0;ze<ae.lexeme.length;ze++)ae.lexeme.charCodeAt(ze)===w.CharCode.OpenParen?X++:ae.lexeme.charCodeAt(ze)===w.CharCode.CloseParen&&X--;for(;!this.E()&&he.type!==O.TokenType.And&&he.type!==O.TokenType.Or;){switch(he.type){case O.TokenType.LParen:X++;break;case O.TokenType.RParen:X--;break;case O.TokenType.RegexStr:case O.TokenType.QuotedStr:for(let ze=0;ze<he.lexeme.length;ze++)he.lexeme.charCodeAt(ze)===w.CharCode.OpenParen?X++:ae.lexeme.charCodeAt(ze)===w.CharCode.CloseParen&&X--}if(X<0)break;we.push(O.$Aj.getLexeme(he)),this.z(),he=this.D()}const Y=we.join(""),pe=Y.lastIndexOf("/"),$e=pe===Y.length-1?void 0:this.w(Y.substring(pe+1));let Te;try{Te=new RegExp(Y.substring(1,pe),$e)}catch{throw this.B("REGEX",ae)}return l.regex(_,Te)}case O.TokenType.QuotedStr:{const we=ae.lexeme;this.z();let he=null;if(!(0,k.$df)(we)){const X=we.indexOf("/"),Y=we.lastIndexOf("/");if(X!==Y&&X>=0){const pe=we.slice(X+1,Y),$e=we[Y+1]==="i"?"i":"";try{he=new RegExp(pe,$e)}catch{throw this.B("REGEX",ae)}}}if(he===null)throw this.B("REGEX",ae);return q.create(_,he)}default:throw this.B("REGEX",this.D())}}if(this.y(O.TokenType.Not)){this.A(O.TokenType.In,s);const ae=this.u();return l.notIn(_,ae)}switch(this.D().type){case O.TokenType.Eq:{this.z();const ae=this.u();if(this.x().type===O.TokenType.QuotedStr)return l.equals(_,ae);switch(ae){case"true":return l.has(_);case"false":return l.not(_);default:return l.equals(_,ae)}}case O.TokenType.NotEq:{this.z();const ae=this.u();if(this.x().type===O.TokenType.QuotedStr)return l.notEquals(_,ae);switch(ae){case"true":return l.not(_);case"false":return l.has(_);default:return l.notEquals(_,ae)}}case O.TokenType.Lt:return this.z(),W.create(_,this.u());case O.TokenType.LtEq:return this.z(),F.create(_,this.u());case O.TokenType.Gt:return this.z(),B.create(_,this.u());case O.TokenType.GtEq:return this.z(),G.create(_,this.u());case O.TokenType.In:return this.z(),l.in(_,this.u());default:return l.has(_)}}case O.TokenType.EOF:throw this.h.push({message:r,offset:V.offset,lexeme:"",additionalInfo:t}),c.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const V=this.D();switch(V.type){case O.TokenType.Str:case O.TokenType.QuotedStr:return this.z(),V.lexeme;case O.TokenType.True:return this.z(),"true";case O.TokenType.False:return this.z(),"false";case O.TokenType.In:return this.z(),"in";default:return""}}w(V){return V.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(V){return this.C(V)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(V,_){if(this.C(V))return this.z();throw this.B(_,this.D())}B(V,_,ye){const ae=(0,T.localize)(8,null,V,O.$Aj.getLexeme(_)),we=_.offset,he=O.$Aj.getLexeme(_);return this.h.push({message:ae,offset:we,lexeme:he,additionalInfo:ye}),c.c}C(V){return this.D().type===V}D(){return this.f[this.g]}E(){return this.D().type===O.TokenType.EOF}}e.$Cj=c;class l{static false(){return I.INSTANCE}static true(){return D.INSTANCE}static has(V){return v.create(V)}static equals(V,_){return C.create(V,_)}static notEquals(V,_){return b.create(V,_)}static regex(V,_){return q.create(V,_)}static in(V,_){return P.create(V,_)}static notIn(V,_){return g.create(V,_)}static not(V){return L.create(V)}static and(...V){return te.create(V,null,!0)}static or(...V){return me.create(V,null,!0)}static greater(V,_){return B.create(V,_)}static greaterEquals(V,_){return G.create(V,_)}static smaller(V,_){return W.create(V,_)}static smallerEquals(V,_){return F.create(V,_)}static{this.c=new c({regexParsingWithErrorRecovery:!1})}static deserialize(V){return V==null?void 0:this.c.parse(V)}}e.$Dj=l;function m(Z){const V=new c({regexParsingWithErrorRecovery:!1});return Z.map(_=>(V.parse(_),V.lexingErrors.length>0?V.lexingErrors.map(ye=>({errorMessage:ye.additionalInfo?(0,T.localize)(9,null,ye.additionalInfo):(0,T.localize)(10,null),offset:ye.offset,length:ye.lexeme.length})):V.parsingErrors.length>0?V.parsingErrors.map(ye=>({errorMessage:ye.additionalInfo?`${ye.message}. ${ye.additionalInfo}`:ye.message,offset:ye.offset,length:ye.lexeme.length})):[]))}function f(Z,V){const _=Z?Z.substituteConstants():void 0,ye=V?V.substituteConstants():void 0;return!_&&!ye?!0:!_||!ye?!1:_.equals(ye)}function $(Z,V){return Z.cmp(V)}class I{static{this.INSTANCE=new I}constructor(){this.type=u.False}cmp(V){return this.type-V.type}equals(V){return V.type===this.type}substituteConstants(){return this}evaluate(V){return!1}serialize(){return"false"}keys(){return[]}map(V){return this}negate(){return D.INSTANCE}}e.$Gj=I;class D{static{this.INSTANCE=new D}constructor(){this.type=u.True}cmp(V){return this.type-V.type}equals(V){return V.type===this.type}substituteConstants(){return this}evaluate(V){return!0}serialize(){return"true"}keys(){return[]}map(V){return this}negate(){return I.INSTANCE}}e.$Hj=D;class v{static create(V,_=null){const ye=a.get(V);return typeof ye=="boolean"?ye?D.INSTANCE:I.INSTANCE:new v(V,_)}constructor(V,_){this.key=V,this.c=_,this.type=u.Defined}cmp(V){return V.type!==this.type?this.type-V.type:ce(this.key,V.key)}equals(V){return V.type===this.type?this.key===V.key:!1}substituteConstants(){const V=a.get(this.key);return typeof V=="boolean"?V?D.INSTANCE:I.INSTANCE:this}evaluate(V){return!!V.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(V){return V.mapDefined(this.key)}negate(){return this.c||(this.c=L.create(this.key,this)),this.c}}e.$Ij=v;class C{static create(V,_,ye=null){if(typeof _=="boolean")return _?v.create(V,ye):L.create(V,ye);const ae=a.get(V);return typeof ae=="boolean"?_===(ae?"true":"false")?D.INSTANCE:I.INSTANCE:new C(V,_,ye)}constructor(V,_,ye){this.c=V,this.d=_,this.f=ye,this.type=u.Equals}cmp(V){return V.type!==this.type?this.type-V.type:be(this.c,this.d,V.c,V.d)}equals(V){return V.type===this.type?this.c===V.c&&this.d===V.d:!1}substituteConstants(){const V=a.get(this.c);if(typeof V=="boolean"){const _=V?"true":"false";return this.d===_?D.INSTANCE:I.INSTANCE}return this}evaluate(V){return V.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(V){return V.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=b.create(this.c,this.d,this)),this.f}}e.$Jj=C;class P{static create(V,_){return new P(V,_)}constructor(V,_){this.d=V,this.f=_,this.type=u.In,this.c=null}cmp(V){return V.type!==this.type?this.type-V.type:be(this.d,this.f,V.d,V.f)}equals(V){return V.type===this.type?this.d===V.d&&this.f===V.f:!1}substituteConstants(){return this}evaluate(V){const _=V.getValue(this.f),ye=V.getValue(this.d);return Array.isArray(_)?_.includes(ye):typeof ye=="string"&&typeof _=="object"&&_!==null?y.call(_,ye):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(V){return V.mapIn(this.d,this.f)}negate(){return this.c||(this.c=g.create(this.d,this.f)),this.c}}e.$Kj=P;class g{static create(V,_){return new g(V,_)}constructor(V,_){this.d=V,this.f=_,this.type=u.NotIn,this.c=P.create(V,_)}cmp(V){return V.type!==this.type?this.type-V.type:this.c.cmp(V.c)}equals(V){return V.type===this.type?this.c.equals(V.c):!1}substituteConstants(){return this}evaluate(V){return!this.c.evaluate(V)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(V){return V.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Lj=g;class b{static create(V,_,ye=null){if(typeof _=="boolean")return _?L.create(V,ye):v.create(V,ye);const ae=a.get(V);return typeof ae=="boolean"?_===(ae?"true":"false")?I.INSTANCE:D.INSTANCE:new b(V,_,ye)}constructor(V,_,ye){this.c=V,this.d=_,this.f=ye,this.type=u.NotEquals}cmp(V){return V.type!==this.type?this.type-V.type:be(this.c,this.d,V.c,V.d)}equals(V){return V.type===this.type?this.c===V.c&&this.d===V.d:!1}substituteConstants(){const V=a.get(this.c);if(typeof V=="boolean"){const _=V?"true":"false";return this.d===_?I.INSTANCE:D.INSTANCE}return this}evaluate(V){return V.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(V){return V.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=C.create(this.c,this.d,this)),this.f}}e.$Mj=b;class L{static create(V,_=null){const ye=a.get(V);return typeof ye=="boolean"?ye?I.INSTANCE:D.INSTANCE:new L(V,_)}constructor(V,_){this.c=V,this.d=_,this.type=u.Not}cmp(V){return V.type!==this.type?this.type-V.type:ce(this.c,V.c)}equals(V){return V.type===this.type?this.c===V.c:!1}substituteConstants(){const V=a.get(this.c);return typeof V=="boolean"?V?I.INSTANCE:D.INSTANCE:this}evaluate(V){return!V.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(V){return V.mapNot(this.c)}negate(){return this.d||(this.d=v.create(this.c,this)),this.d}}e.$Nj=L;function N(Z,V){if(typeof Z=="string"){const _=parseFloat(Z);isNaN(_)||(Z=_)}return typeof Z=="string"||typeof Z=="number"?V(Z):I.INSTANCE}class B{static create(V,_,ye=null){return N(_,ae=>new B(V,ae,ye))}constructor(V,_,ye){this.c=V,this.d=_,this.f=ye,this.type=u.Greater}cmp(V){return V.type!==this.type?this.type-V.type:be(this.c,this.d,V.c,V.d)}equals(V){return V.type===this.type?this.c===V.c&&this.d===V.d:!1}substituteConstants(){return this}evaluate(V){return typeof this.d=="string"?!1:parseFloat(V.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(V){return V.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=F.create(this.c,this.d,this)),this.f}}e.$Oj=B;class G{static create(V,_,ye=null){return N(_,ae=>new G(V,ae,ye))}constructor(V,_,ye){this.c=V,this.d=_,this.f=ye,this.type=u.GreaterEquals}cmp(V){return V.type!==this.type?this.type-V.type:be(this.c,this.d,V.c,V.d)}equals(V){return V.type===this.type?this.c===V.c&&this.d===V.d:!1}substituteConstants(){return this}evaluate(V){return typeof this.d=="string"?!1:parseFloat(V.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(V){return V.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=W.create(this.c,this.d,this)),this.f}}e.$Pj=G;class W{static create(V,_,ye=null){return N(_,ae=>new W(V,ae,ye))}constructor(V,_,ye){this.c=V,this.d=_,this.f=ye,this.type=u.Smaller}cmp(V){return V.type!==this.type?this.type-V.type:be(this.c,this.d,V.c,V.d)}equals(V){return V.type===this.type?this.c===V.c&&this.d===V.d:!1}substituteConstants(){return this}evaluate(V){return typeof this.d=="string"?!1:parseFloat(V.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(V){return V.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=G.create(this.c,this.d,this)),this.f}}e.$Qj=W;class F{static create(V,_,ye=null){return N(_,ae=>new F(V,ae,ye))}constructor(V,_,ye){this.c=V,this.d=_,this.f=ye,this.type=u.SmallerEquals}cmp(V){return V.type!==this.type?this.type-V.type:be(this.c,this.d,V.c,V.d)}equals(V){return V.type===this.type?this.c===V.c&&this.d===V.d:!1}substituteConstants(){return this}evaluate(V){return typeof this.d=="string"?!1:parseFloat(V.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(V){return V.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=B.create(this.c,this.d,this)),this.f}}e.$Rj=F;class q{static create(V,_){return new q(V,_)}constructor(V,_){this.d=V,this.f=_,this.type=u.Regex,this.c=null}cmp(V){if(V.type!==this.type)return this.type-V.type;if(this.d<V.d)return-1;if(this.d>V.d)return 1;const _=this.f?this.f.source:"",ye=V.f?V.f.source:"";return _<ye?-1:_>ye?1:0}equals(V){if(V.type===this.type){const _=this.f?this.f.source:"",ye=V.f?V.f.source:"";return this.d===V.d&&_===ye}return!1}substituteConstants(){return this}evaluate(V){const _=V.getValue(this.d);return this.f?this.f.test(_):!1}serialize(){const V=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${V}`}keys(){return[this.d]}map(V){return V.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=ue.create(this)),this.c}}e.$Sj=q;class ue{static create(V){return new ue(V)}constructor(V){this.c=V,this.type=u.NotRegex}cmp(V){return V.type!==this.type?this.type-V.type:this.c.cmp(V.c)}equals(V){return V.type===this.type?this.c.equals(V.c):!1}substituteConstants(){return this}evaluate(V){return!this.c.evaluate(V)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(V){return new ue(this.c.map(V))}negate(){return this.c}}e.$Tj=ue;function ge(Z){let V=null;for(let _=0,ye=Z.length;_<ye;_++){const ae=Z[_].substituteConstants();if(Z[_]!==ae&&V===null){V=[];for(let we=0;we<_;we++)V[we]=Z[we]}V!==null&&(V[_]=ae)}return V===null?Z:V}class te{static create(V,_,ye){return te.d(V,_,ye)}constructor(V,_){this.expr=V,this.c=_,this.type=u.And}cmp(V){if(V.type!==this.type)return this.type-V.type;if(this.expr.length<V.expr.length)return-1;if(this.expr.length>V.expr.length)return 1;for(let _=0,ye=this.expr.length;_<ye;_++){const ae=$(this.expr[_],V.expr[_]);if(ae!==0)return ae}return 0}equals(V){if(V.type===this.type){if(this.expr.length!==V.expr.length)return!1;for(let _=0,ye=this.expr.length;_<ye;_++)if(!this.expr[_].equals(V.expr[_]))return!1;return!0}return!1}substituteConstants(){const V=ge(this.expr);return V===this.expr?this:te.create(V,this.c,!1)}evaluate(V){for(let _=0,ye=this.expr.length;_<ye;_++)if(!this.expr[_].evaluate(V))return!1;return!0}static d(V,_,ye){const ae=[];let we=!1;for(const he of V)if(he){if(he.type===u.True){we=!0;continue}if(he.type===u.False)return I.INSTANCE;if(he.type===u.And){ae.push(...he.expr);continue}ae.push(he)}if(ae.length===0&&we)return D.INSTANCE;if(ae.length!==0){if(ae.length===1)return ae[0];ae.sort($);for(let he=1;he<ae.length;he++)ae[he-1].equals(ae[he])&&(ae.splice(he,1),he--);if(ae.length===1)return ae[0];for(;ae.length>1;){const he=ae[ae.length-1];if(he.type!==u.Or)break;ae.pop();const X=ae.pop(),Y=ae.length===0,pe=me.create(he.expr.map($e=>te.create([$e,X],null,ye)),null,Y);pe&&(ae.push(pe),ae.sort($))}if(ae.length===1)return ae[0];if(ye){for(let he=0;he<ae.length;he++)for(let X=he+1;X<ae.length;X++)if(ae[he].negate().equals(ae[X]))return I.INSTANCE;if(ae.length===1)return ae[0]}return new te(ae,_)}}serialize(){return this.expr.map(V=>V.serialize()).join(" && ")}keys(){const V=[];for(const _ of this.expr)V.push(..._.keys());return V}map(V){return new te(this.expr.map(_=>_.map(V)),null)}negate(){if(!this.c){const V=[];for(const _ of this.expr)V.push(_.negate());this.c=me.create(V,this,!0)}return this.c}}e.$Uj=te;class me{static create(V,_,ye){return me.d(V,_,ye)}constructor(V,_){this.expr=V,this.c=_,this.type=u.Or}cmp(V){if(V.type!==this.type)return this.type-V.type;if(this.expr.length<V.expr.length)return-1;if(this.expr.length>V.expr.length)return 1;for(let _=0,ye=this.expr.length;_<ye;_++){const ae=$(this.expr[_],V.expr[_]);if(ae!==0)return ae}return 0}equals(V){if(V.type===this.type){if(this.expr.length!==V.expr.length)return!1;for(let _=0,ye=this.expr.length;_<ye;_++)if(!this.expr[_].equals(V.expr[_]))return!1;return!0}return!1}substituteConstants(){const V=ge(this.expr);return V===this.expr?this:me.create(V,this.c,!1)}evaluate(V){for(let _=0,ye=this.expr.length;_<ye;_++)if(this.expr[_].evaluate(V))return!0;return!1}static d(V,_,ye){let ae=[],we=!1;if(V){for(let he=0,X=V.length;he<X;he++){const Y=V[he];if(Y){if(Y.type===u.False){we=!0;continue}if(Y.type===u.True)return D.INSTANCE;if(Y.type===u.Or){ae=ae.concat(Y.expr);continue}ae.push(Y)}}if(ae.length===0&&we)return I.INSTANCE;ae.sort($)}if(ae.length!==0){if(ae.length===1)return ae[0];for(let he=1;he<ae.length;he++)ae[he-1].equals(ae[he])&&(ae.splice(he,1),he--);if(ae.length===1)return ae[0];if(ye){for(let he=0;he<ae.length;he++)for(let X=he+1;X<ae.length;X++)if(ae[he].negate().equals(ae[X]))return D.INSTANCE;if(ae.length===1)return ae[0]}return new me(ae,_)}}serialize(){return this.expr.map(V=>V.serialize()).join(" || ")}keys(){const V=[];for(const _ of this.expr)V.push(..._.keys());return V}map(V){return new me(this.expr.map(_=>_.map(V)),null)}negate(){if(!this.c){const V=[];for(const _ of this.expr)V.push(_.negate());for(;V.length>1;){const _=V.shift(),ye=V.shift(),ae=[];for(const we of Ue(_))for(const he of Ue(ye))ae.push(te.create([we,he],null,!1));V.unshift(me.create(ae,null,!1))}this.c=me.create(V,this,!0)}return this.c}}e.$Vj=me;class re extends v{static{this.d=[]}static all(){return re.d.values()}constructor(V,_,ye){super(V,null),this.f=_,typeof ye=="object"?re.d.push({...ye,key:V}):ye!==!0&&re.d.push({key:V,description:ye,type:_!=null?typeof _:void 0})}bindTo(V){return V.createKey(this.key,this.f)}getValue(V){return V.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(V){return C.create(this.key,V)}notEqualsTo(V){return b.create(this.key,V)}}e.$Wj=re,e.$Xj=(0,A.$Fi)("contextKeyService");function ce(Z,V){return Z<V?-1:Z>V?1:0}function be(Z,V,_,ye){return Z<_?-1:Z>_?1:V<ye?-1:V>ye?1:0}function se(Z,V){if(Z.type===u.False||V.type===u.True)return!0;if(Z.type===u.Or)return V.type===u.Or?Ie(Z.expr,V.expr):!1;if(V.type===u.Or){for(const _ of V.expr)if(se(Z,_))return!0;return!1}if(Z.type===u.And){if(V.type===u.And)return Ie(V.expr,Z.expr);for(const _ of Z.expr)if(se(_,V))return!0;return!1}return Z.equals(V)}function Ie(Z,V){let _=0,ye=0;for(;_<Z.length&&ye<V.length;){const ae=Z[_].cmp(V[ye]);if(ae<0)return!1;ae===0&&_++,ye++}return _===Z.length}function Ue(Z){return Z.type===u.Or?Z.expr:[Z]}}),define(ke[209],Ce([1,0,32,3]),function(oe,e,w,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nt=e.$lt=e.AccessibilitySupport=e.$kt=void 0,e.$mt=O,e.$kt=(0,S.$Fi)("accessibilityService");var k;(function(A){A[A.Unknown=0]="Unknown",A[A.Disabled=1]="Disabled",A[A.Enabled=2]="Enabled"})(k||(e.AccessibilitySupport=k={})),e.$lt=new w.$Wj("accessibilityModeEnabled",!1);function O(A){return A&&typeof A=="object"&&typeof A.label=="string"&&(typeof A.role>"u"||typeof A.role=="string")}e.$nt="ACCESSIBLE_VIEW_SHOWN_"}),define(ke[105],Ce([1,0,18,26,21,143,323,149,210,167,209]),function(oe,e,w,S,k,O,A,T,p,a,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.RenderLineNumbersType=e.ShowLightbulbIconMode=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0,e.boolean=i,e.clampedInt=t,e.clampedFloat=l,e.stringSet=$,e.cursorStyleToString=N,e.filterValidationDecorations=Re,w=qe(w),S=qe(S),k=qe(k),a=qe(a);var y;(function(H){H[H.None=0]="None",H[H.Keep=1]="Keep",H[H.Brackets=2]="Brackets",H[H.Advanced=3]="Advanced",H[H.Full=4]="Full"})(y||(e.EditorAutoIndentStrategy=y={})),e.MINIMAP_GUTTER_WIDTH=8;class u{constructor(x){this.c=x}hasChanged(x){return this.c[x]}}e.ConfigurationChangedEvent=u;class E{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=E;class d{constructor(x,Ee,Je,xe){this.id=x,this.name=Ee,this.defaultValue=Je,this.schema=xe}applyUpdate(x,Ee){return s(x,Ee)}compute(x,Ee,Je){return Je}}class n{constructor(x,Ee){this.newValue=x,this.didChange=Ee}}e.ApplyUpdateResult=n;function s(H,x){if(typeof H!="object"||typeof x!="object"||!H||!x)return new n(x,H!==x);if(Array.isArray(H)||Array.isArray(x)){const Je=Array.isArray(H)&&Array.isArray(x)&&w.$wb(H,x);return new n(x,!Je)}let Ee=!1;for(const Je in x)if(x.hasOwnProperty(Je)){const xe=s(H[Je],x[Je]);xe.didChange&&(H[Je]=xe.newValue,Ee=!0)}return new n(H,Ee)}class o{constructor(x){this.schema=void 0,this.id=x,this.name="_never_",this.defaultValue=void 0}applyUpdate(x,Ee){return s(x,Ee)}validate(x){return this.defaultValue}}class h{constructor(x,Ee,Je,xe){this.id=x,this.name=Ee,this.defaultValue=Je,this.schema=xe}applyUpdate(x,Ee){return s(x,Ee)}validate(x){return typeof x>"u"?this.defaultValue:x}compute(x,Ee,Je){return Je}}function i(H,x){return typeof H>"u"?x:H==="false"?!1:!!H}class r extends h{constructor(x,Ee,Je,xe=void 0){typeof xe<"u"&&(xe.type="boolean",xe.default=Je),super(x,Ee,Je,xe)}validate(x){return i(x,this.defaultValue)}}function t(H,x,Ee,Je){if(typeof H>"u")return x;let xe=parseInt(H,10);return isNaN(xe)?x:(xe=Math.max(Ee,xe),xe=Math.min(Je,xe),xe|0)}class c extends h{static clampedInt(x,Ee,Je,xe){return t(x,Ee,Je,xe)}constructor(x,Ee,Je,xe,ht,pt=void 0){typeof pt<"u"&&(pt.type="integer",pt.default=Je,pt.minimum=xe,pt.maximum=ht),super(x,Ee,Je,pt),this.minimum=xe,this.maximum=ht}validate(x){return c.clampedInt(x,this.defaultValue,this.minimum,this.maximum)}}function l(H,x,Ee,Je){if(typeof H>"u")return x;const xe=m.float(H,x);return m.clamp(xe,Ee,Je)}class m extends h{static clamp(x,Ee,Je){return x<Ee?Ee:x>Je?Je:x}static float(x,Ee){if(typeof x=="number")return x;if(typeof x>"u")return Ee;const Je=parseFloat(x);return isNaN(Je)?Ee:Je}constructor(x,Ee,Je,xe,ht){typeof ht<"u"&&(ht.type="number",ht.default=Je),super(x,Ee,Je,ht),this.validationFn=xe}validate(x){return this.validationFn(m.float(x,this.defaultValue))}}class f extends h{static string(x,Ee){return typeof x!="string"?Ee:x}constructor(x,Ee,Je,xe=void 0){typeof xe<"u"&&(xe.type="string",xe.default=Je),super(x,Ee,Je,xe)}validate(x){return f.string(x,this.defaultValue)}}function $(H,x,Ee,Je){return typeof H!="string"?x:Je&&H in Je?Je[H]:Ee.indexOf(H)===-1?x:H}class I extends h{constructor(x,Ee,Je,xe,ht=void 0){typeof ht<"u"&&(ht.type="string",ht.enum=xe,ht.default=Je),super(x,Ee,Je,ht),this.c=xe}validate(x){return $(x,this.defaultValue,this.c)}}class D extends d{constructor(x,Ee,Je,xe,ht,pt,Ft=void 0){typeof Ft<"u"&&(Ft.type="string",Ft.enum=ht,Ft.default=xe),super(x,Ee,Je,Ft),this.c=ht,this.d=pt}validate(x){return typeof x!="string"?this.defaultValue:this.c.indexOf(x)===-1?this.defaultValue:this.d(x)}}function v(H){switch(H){case"none":return y.None;case"keep":return y.Keep;case"brackets":return y.Brackets;case"advanced":return y.Advanced;case"full":return y.Full}}class C extends d{constructor(){super(Be.accessibilitySupport,"accessibilitySupport",R.AccessibilitySupport.Unknown,{type:"string",enum:["auto","on","off"],enumDescriptions:[a.localize(0,null),a.localize(1,null),a.localize(2,null)],default:"auto",tags:["accessibility"],description:a.localize(3,null)})}validate(x){switch(x){case"auto":return R.AccessibilitySupport.Unknown;case"off":return R.AccessibilitySupport.Disabled;case"on":return R.AccessibilitySupport.Enabled}return this.defaultValue}compute(x,Ee,Je){return Je===R.AccessibilitySupport.Unknown?x.accessibilitySupport:Je}}class P extends d{constructor(){const x={insertSpace:!0,ignoreEmptyLines:!0};super(Be.comments,"comments",x,{"editor.comments.insertSpace":{type:"boolean",default:x.insertSpace,description:a.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:x.ignoreEmptyLines,description:a.localize(5,null)}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const Ee=x;return{insertSpace:i(Ee.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:i(Ee.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var g;(function(H){H[H.Hidden=0]="Hidden",H[H.Blink=1]="Blink",H[H.Smooth=2]="Smooth",H[H.Phase=3]="Phase",H[H.Expand=4]="Expand",H[H.Solid=5]="Solid"})(g||(e.TextEditorCursorBlinkingStyle=g={}));function b(H){switch(H){case"blink":return g.Blink;case"smooth":return g.Smooth;case"phase":return g.Phase;case"expand":return g.Expand;case"solid":return g.Solid}}var L;(function(H){H[H.Line=1]="Line",H[H.Block=2]="Block",H[H.Underline=3]="Underline",H[H.LineThin=4]="LineThin",H[H.BlockOutline=5]="BlockOutline",H[H.UnderlineThin=6]="UnderlineThin"})(L||(e.TextEditorCursorStyle=L={}));function N(H){switch(H){case L.Line:return"line";case L.Block:return"block";case L.Underline:return"underline";case L.LineThin:return"line-thin";case L.BlockOutline:return"block-outline";case L.UnderlineThin:return"underline-thin"}}function B(H){switch(H){case"line":return L.Line;case"block":return L.Block;case"underline":return L.Underline;case"line-thin":return L.LineThin;case"block-outline":return L.BlockOutline;case"underline-thin":return L.UnderlineThin}}class G extends o{constructor(){super(Be.editorClassName)}compute(x,Ee,Je){const xe=["monaco-editor"];return Ee.get(Be.extraEditorClassName)&&xe.push(Ee.get(Be.extraEditorClassName)),x.extraEditorClassName&&xe.push(x.extraEditorClassName),Ee.get(Be.mouseStyle)==="default"?xe.push("mouse-default"):Ee.get(Be.mouseStyle)==="copy"&&xe.push("mouse-copy"),Ee.get(Be.showUnused)&&xe.push("showUnused"),Ee.get(Be.showDeprecated)&&xe.push("showDeprecated"),xe.join(" ")}}class W extends r{constructor(){super(Be.emptySelectionClipboard,"emptySelectionClipboard",!0,{description:a.localize(6,null)})}compute(x,Ee,Je){return Je&&x.emptySelectionClipboard}}class F extends d{constructor(){const x={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(Be.find,"find",x,{"editor.find.cursorMoveOnType":{type:"boolean",default:x.cursorMoveOnType,description:a.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:x.seedSearchStringFromSelection,enumDescriptions:[a.localize(8,null),a.localize(9,null),a.localize(10,null)],description:a.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:x.autoFindInSelection,enumDescriptions:[a.localize(12,null),a.localize(13,null),a.localize(14,null)],description:a.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:x.globalFindClipboard,description:a.localize(16,null),included:k.$j},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:x.addExtraSpaceOnTop,description:a.localize(17,null)},"editor.find.loop":{type:"boolean",default:x.loop,description:a.localize(18,null)}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const Ee=x;return{cursorMoveOnType:i(Ee.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof x.seedSearchStringFromSelection=="boolean"?x.seedSearchStringFromSelection?"always":"never":$(Ee.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof x.autoFindInSelection=="boolean"?x.autoFindInSelection?"always":"never":$(Ee.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:i(Ee.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:i(Ee.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:i(Ee.loop,this.defaultValue.loop)}}}class q extends d{static{this.OFF='"liga" off, "calt" off'}static{this.ON='"liga" on, "calt" on'}constructor(){super(Be.fontLigatures,"fontLigatures",q.OFF,{anyOf:[{type:"boolean",description:a.localize(19,null)},{type:"string",description:a.localize(20,null)}],description:a.localize(21,null),default:!1})}validate(x){return typeof x>"u"?this.defaultValue:typeof x=="string"?x==="false"||x.length===0?q.OFF:x==="true"?q.ON:x:x?q.ON:q.OFF}}e.EditorFontLigatures=q;class ue extends d{static{this.OFF="normal"}static{this.TRANSLATE="translate"}constructor(){super(Be.fontVariations,"fontVariations",ue.OFF,{anyOf:[{type:"boolean",description:a.localize(22,null)},{type:"string",description:a.localize(23,null)}],description:a.localize(24,null),default:!1})}validate(x){return typeof x>"u"?this.defaultValue:typeof x=="string"?x==="false"?ue.OFF:x==="true"?ue.TRANSLATE:x:x?ue.TRANSLATE:ue.OFF}compute(x,Ee,Je){return x.fontInfo.fontVariationSettings}}e.EditorFontVariations=ue;class ge extends o{constructor(){super(Be.fontInfo)}compute(x,Ee,Je){return x.fontInfo}}class te extends h{constructor(){super(Be.fontSize,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:a.localize(25,null)})}validate(x){const Ee=m.float(x,this.defaultValue);return Ee===0?e.EDITOR_FONT_DEFAULTS.fontSize:m.clamp(Ee,6,100)}compute(x,Ee,Je){return x.fontInfo.fontSize}}class me extends d{static{this.c=["normal","bold","100","200","300","400","500","600","700","800","900"]}static{this.d=1}static{this.e=1e3}constructor(){super(Be.fontWeight,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:me.d,maximum:me.e,errorMessage:a.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:me.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:a.localize(27,null)})}validate(x){return x==="normal"||x==="bold"?x:String(c.clampedInt(x,e.EDITOR_FONT_DEFAULTS.fontWeight,me.d,me.e))}}class re extends d{constructor(){const x={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},Ee={type:"string",enum:["peek","gotoAndPeek","goto"],default:x.multiple,enumDescriptions:[a.localize(28,null),a.localize(29,null),a.localize(30,null)]},Je=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(Be.gotoLocation,"gotoLocation",x,{"editor.gotoLocation.multiple":{deprecationMessage:a.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:a.localize(32,null),...Ee},"editor.gotoLocation.multipleTypeDefinitions":{description:a.localize(33,null),...Ee},"editor.gotoLocation.multipleDeclarations":{description:a.localize(34,null),...Ee},"editor.gotoLocation.multipleImplementations":{description:a.localize(35,null),...Ee},"editor.gotoLocation.multipleReferences":{description:a.localize(36,null),...Ee},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:x.alternativeDefinitionCommand,enum:Je,description:a.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:x.alternativeTypeDefinitionCommand,enum:Je,description:a.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:x.alternativeDeclarationCommand,enum:Je,description:a.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:x.alternativeImplementationCommand,enum:Je,description:a.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:x.alternativeReferenceCommand,enum:Je,description:a.localize(41,null)}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const Ee=x;return{multiple:$(Ee.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:Ee.multipleDefinitions??$(Ee.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:Ee.multipleTypeDefinitions??$(Ee.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:Ee.multipleDeclarations??$(Ee.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:Ee.multipleImplementations??$(Ee.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:Ee.multipleReferences??$(Ee.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:f.string(Ee.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:f.string(Ee.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:f.string(Ee.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:f.string(Ee.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:f.string(Ee.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class ce extends d{constructor(){const x={enabled:!0,delay:300,hidingDelay:300,sticky:!0,above:!0};super(Be.hover,"hover",x,{"editor.hover.enabled":{type:"boolean",default:x.enabled,description:a.localize(42,null)},"editor.hover.delay":{type:"number",default:x.delay,minimum:0,maximum:1e4,description:a.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:x.sticky,description:a.localize(44,null)},"editor.hover.hidingDelay":{type:"integer",minimum:0,default:x.hidingDelay,description:a.localize(45,null)},"editor.hover.above":{type:"boolean",default:x.above,description:a.localize(46,null)}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const Ee=x;return{enabled:i(Ee.enabled,this.defaultValue.enabled),delay:c.clampedInt(Ee.delay,this.defaultValue.delay,0,1e4),sticky:i(Ee.sticky,this.defaultValue.sticky),hidingDelay:c.clampedInt(Ee.hidingDelay,this.defaultValue.hidingDelay,0,6e5),above:i(Ee.above,this.defaultValue.above)}}}var be;(function(H){H[H.None=0]="None",H[H.Text=1]="Text",H[H.Blocks=2]="Blocks"})(be||(e.RenderMinimap=be={}));class se extends o{constructor(){super(Be.layoutInfo)}compute(x,Ee,Je){return se.computeLayout(Ee,{memory:x.memory,outerWidth:x.outerWidth,outerHeight:x.outerHeight,isDominatedByLongLines:x.isDominatedByLongLines,lineHeight:x.fontInfo.lineHeight,viewLineCount:x.viewLineCount,lineNumbersDigitCount:x.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:x.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:x.fontInfo.maxDigitWidth,pixelRatio:x.pixelRatio,glyphMarginDecorationLaneCount:x.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(x){const Ee=x.height/x.lineHeight,Je=Math.floor(x.paddingTop/x.lineHeight);let xe=Math.floor(x.paddingBottom/x.lineHeight);x.scrollBeyondLastLine&&(xe=Math.max(xe,Ee-1));const ht=(Je+x.viewLineCount+xe)/(x.pixelRatio*x.height),pt=Math.floor(x.viewLineCount/ht);return{typicalViewportLineCount:Ee,extraLinesBeforeFirstLine:Je,extraLinesBeyondLastLine:xe,desiredRatio:ht,minimapLineCount:pt}}static c(x,Ee){const Je=x.outerWidth,xe=x.outerHeight,ht=x.pixelRatio;if(!x.minimap.enabled)return{renderMinimap:be.None,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(ht*xe),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:xe};const pt=Ee.stableMinimapLayoutInput,Ft=pt&&x.outerHeight===pt.outerHeight&&x.lineHeight===pt.lineHeight&&x.typicalHalfwidthCharacterWidth===pt.typicalHalfwidthCharacterWidth&&x.pixelRatio===pt.pixelRatio&&x.scrollBeyondLastLine===pt.scrollBeyondLastLine&&x.paddingTop===pt.paddingTop&&x.paddingBottom===pt.paddingBottom&&x.minimap.enabled===pt.minimap.enabled&&x.minimap.side===pt.minimap.side&&x.minimap.size===pt.minimap.size&&x.minimap.showSlider===pt.minimap.showSlider&&x.minimap.renderCharacters===pt.minimap.renderCharacters&&x.minimap.maxColumn===pt.minimap.maxColumn&&x.minimap.scale===pt.minimap.scale&&x.verticalScrollbarWidth===pt.verticalScrollbarWidth&&x.isViewportWrapping===pt.isViewportWrapping,Ut=x.lineHeight,Zt=x.typicalHalfwidthCharacterWidth,di=x.scrollBeyondLastLine,Ye=x.minimap.renderCharacters;let Pt=ht>=2?Math.round(x.minimap.scale*2):x.minimap.scale;const Gt=x.minimap.maxColumn,Kt=x.minimap.size,gt=x.minimap.side,vt=x.verticalScrollbarWidth,ii=x.viewLineCount,Yt=x.remainingWidth,Wt=x.isViewportWrapping,yt=Ye?2:3;let Ot=Math.floor(ht*xe);const ui=Ot/ht;let Vt=!1,Xe=!1,xt=yt*Pt,ni=Pt/ht,li=1;if(Kt==="fill"||Kt==="fit"){const{typicalViewportLineCount:si,extraLinesBeforeFirstLine:jt,extraLinesBeyondLastLine:Ht,desiredRatio:oi,minimapLineCount:Rt}=se.computeContainedMinimapLineCount({viewLineCount:ii,scrollBeyondLastLine:di,paddingTop:x.paddingTop,paddingBottom:x.paddingBottom,height:xe,lineHeight:Ut,pixelRatio:ht});if(ii/Rt>1)Vt=!0,Xe=!0,Pt=1,xt=1,ni=Pt/ht;else{let wt=!1,ei=Pt+1;if(Kt==="fit"){const Ct=Math.ceil((jt+ii+Ht)*xt);Wt&&Ft&&Yt<=Ee.stableFitRemainingWidth?(wt=!0,ei=Ee.stableFitMaxMinimapScale):wt=Ct>Ot}if(Kt==="fill"||wt){Vt=!0;const Ct=Pt;xt=Math.min(Ut*ht,Math.max(1,Math.floor(1/oi))),Wt&&Ft&&Yt<=Ee.stableFitRemainingWidth&&(ei=Ee.stableFitMaxMinimapScale),Pt=Math.min(ei,Math.max(1,Math.floor(xt/yt))),Pt>Ct&&(li=Math.min(2,Pt/Ct)),ni=Pt/ht/li,Ot=Math.ceil(Math.max(si,jt+ii+Ht)*xt),Wt?(Ee.stableMinimapLayoutInput=x,Ee.stableFitRemainingWidth=Yt,Ee.stableFitMaxMinimapScale=Pt):(Ee.stableMinimapLayoutInput=null,Ee.stableFitRemainingWidth=0)}}}const kt=Math.floor(Gt*ni),Lt=Math.min(kt,Math.max(0,Math.floor((Yt-vt-2)*ni/(Zt+ni)))+e.MINIMAP_GUTTER_WIDTH);let At=Math.floor(ht*Lt);const zt=At/ht;At=Math.floor(At*li);const ri=Ye?be.Text:be.Blocks,_t=gt==="left"?0:Je-Lt-vt;return{renderMinimap:ri,minimapLeft:_t,minimapWidth:Lt,minimapHeightIsEditorHeight:Vt,minimapIsSampling:Xe,minimapScale:Pt,minimapLineHeight:xt,minimapCanvasInnerWidth:At,minimapCanvasInnerHeight:Ot,minimapCanvasOuterWidth:zt,minimapCanvasOuterHeight:ui}}static computeLayout(x,Ee){const Je=Ee.outerWidth|0,xe=Ee.outerHeight|0,ht=Ee.lineHeight|0,pt=Ee.lineNumbersDigitCount|0,Ft=Ee.typicalHalfwidthCharacterWidth,Ut=Ee.maxDigitWidth,Zt=Ee.pixelRatio,di=Ee.viewLineCount,Ye=x.get(Be.wordWrapOverride2),Pt=Ye==="inherit"?x.get(Be.wordWrapOverride1):Ye,Gt=Pt==="inherit"?x.get(Be.wordWrap):Pt,Kt=x.get(Be.wordWrapColumn),gt=Ee.isDominatedByLongLines,vt=x.get(Be.glyphMargin),ii=x.get(Be.lineNumbers).renderType!==ze.Off,Yt=x.get(Be.lineNumbersMinChars),Wt=x.get(Be.scrollBeyondLastLine),yt=x.get(Be.padding),Ot=x.get(Be.minimap),ui=x.get(Be.scrollbar),Vt=ui.verticalScrollbarSize,Xe=ui.verticalHasArrows,xt=ui.arrowSize,ni=ui.horizontalScrollbarSize,li=x.get(Be.folding),kt=x.get(Be.showFoldingControls)!=="never";let Lt=x.get(Be.lineDecorationsWidth);li&&kt&&(Lt+=16);let At=0;if(ii){const qt=Math.max(pt,Yt);At=Math.round(qt*Ut)}let zt=0;vt&&(zt=ht*Ee.glyphMarginDecorationLaneCount);let ri=0,_t=ri+zt,si=_t+At,jt=si+Lt;const Ht=Je-zt-At-Lt;let oi=!1,Rt=!1,St=-1;Pt==="inherit"&&gt?(oi=!0,Rt=!0):Gt==="on"||Gt==="bounded"?Rt=!0:Gt==="wordWrapColumn"&&(St=Kt);const wt=se.c({outerWidth:Je,outerHeight:xe,lineHeight:ht,typicalHalfwidthCharacterWidth:Ft,pixelRatio:Zt,scrollBeyondLastLine:Wt,paddingTop:yt.top,paddingBottom:yt.bottom,minimap:Ot,verticalScrollbarWidth:Vt,viewLineCount:di,remainingWidth:Ht,isViewportWrapping:Rt},Ee.memory||new E);wt.renderMinimap!==be.None&&wt.minimapLeft===0&&(ri+=wt.minimapWidth,_t+=wt.minimapWidth,si+=wt.minimapWidth,jt+=wt.minimapWidth);const ei=Ht-wt.minimapWidth,Ct=Math.max(1,Math.floor((ei-Vt-2)/Ft)),hi=Xe?xt:0;return Rt&&(St=Math.max(1,Ct),Gt==="bounded"&&(St=Math.min(St,Kt))),{width:Je,height:xe,glyphMarginLeft:ri,glyphMarginWidth:zt,glyphMarginDecorationLaneCount:Ee.glyphMarginDecorationLaneCount,lineNumbersLeft:_t,lineNumbersWidth:At,decorationsLeft:si,decorationsWidth:Lt,contentLeft:jt,contentWidth:ei,minimap:wt,viewportColumn:Ct,isWordWrapMinified:oi,isViewportWrapping:Rt,wrappingColumn:St,verticalScrollbarWidth:Vt,horizontalScrollbarHeight:ni,overviewRuler:{top:hi,width:Vt,height:xe-2*hi,right:0}}}}e.EditorLayoutInfoComputer=se;class Ie extends d{constructor(){super(Be.wrappingStrategy,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[a.localize(47,null),a.localize(48,null)],type:"string",enum:["simple","advanced"],default:"simple",description:a.localize(49,null)}})}validate(x){return $(x,"simple",["simple","advanced"])}compute(x,Ee,Je){return Ee.get(Be.accessibilitySupport)===R.AccessibilitySupport.Enabled?"advanced":Je}}var Ue;(function(H){H.Off="off",H.OnCode="onCode",H.On="on"})(Ue||(e.ShowLightbulbIconMode=Ue={}));class Z extends d{constructor(){const x={enabled:Ue.On};super(Be.lightbulb,"lightbulb",x,{"editor.lightbulb.enabled":{type:"string",tags:["experimental"],enum:[Ue.Off,Ue.OnCode,Ue.On],default:x.enabled,enumDescriptions:[a.localize(50,null),a.localize(51,null),a.localize(52,null)],description:a.localize(53,null)}})}validate(x){return!x||typeof x!="object"?this.defaultValue:{enabled:$(x.enabled,this.defaultValue.enabled,[Ue.Off,Ue.OnCode,Ue.On])}}}class V extends d{constructor(){const x={enabled:!0,maxLineCount:5,defaultModel:"outlineModel",scrollWithEditor:!0};super(Be.stickyScroll,"stickyScroll",x,{"editor.stickyScroll.enabled":{type:"boolean",default:x.enabled,description:a.localize(54,null),tags:["experimental"]},"editor.stickyScroll.maxLineCount":{type:"number",default:x.maxLineCount,minimum:1,maximum:20,description:a.localize(55,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:x.defaultModel,description:a.localize(56,null)},"editor.stickyScroll.scrollWithEditor":{type:"boolean",default:x.scrollWithEditor,description:a.localize(57,null)}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const Ee=x;return{enabled:i(Ee.enabled,this.defaultValue.enabled),maxLineCount:c.clampedInt(Ee.maxLineCount,this.defaultValue.maxLineCount,1,20),defaultModel:$(Ee.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"]),scrollWithEditor:i(Ee.scrollWithEditor,this.defaultValue.scrollWithEditor)}}}class _ extends d{constructor(){const x={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(Be.inlayHints,"inlayHints",x,{"editor.inlayHints.enabled":{type:"string",default:x.enabled,description:a.localize(58,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[a.localize(59,null),a.localize(60,null,k.$j?"Ctrl+Option":"Ctrl+Alt"),a.localize(61,null,k.$j?"Ctrl+Option":"Ctrl+Alt"),a.localize(62,null)]},"editor.inlayHints.fontSize":{type:"number",default:x.fontSize,markdownDescription:a.localize(63,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:x.fontFamily,markdownDescription:a.localize(64,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:x.padding,description:a.localize(65,null)}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const Ee=x;return typeof Ee.enabled=="boolean"&&(Ee.enabled=Ee.enabled?"on":"off"),{enabled:$(Ee.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:c.clampedInt(Ee.fontSize,this.defaultValue.fontSize,0,100),fontFamily:f.string(Ee.fontFamily,this.defaultValue.fontFamily),padding:i(Ee.padding,this.defaultValue.padding)}}}class ye extends d{constructor(){super(Be.lineDecorationsWidth,"lineDecorationsWidth",10)}validate(x){return typeof x=="string"&&/^\d+(\.\d+)?ch$/.test(x)?-parseFloat(x.substring(0,x.length-2)):c.clampedInt(x,this.defaultValue,0,1e3)}compute(x,Ee,Je){return Je<0?c.clampedInt(-Je*x.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):Je}}class ae extends m{constructor(){super(Be.lineHeight,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,x=>m.clamp(x,0,150),{markdownDescription:a.localize(66,null)})}compute(x,Ee,Je){return x.fontInfo.lineHeight}}class we extends d{constructor(){const x={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1,showRegionSectionHeaders:!0,showMarkSectionHeaders:!0,sectionHeaderFontSize:9,sectionHeaderLetterSpacing:1};super(Be.minimap,"minimap",x,{"editor.minimap.enabled":{type:"boolean",default:x.enabled,description:a.localize(67,null)},"editor.minimap.autohide":{type:"boolean",default:x.autohide,description:a.localize(68,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[a.localize(69,null),a.localize(70,null),a.localize(71,null)],default:x.size,description:a.localize(72,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:x.side,description:a.localize(73,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:x.showSlider,description:a.localize(74,null)},"editor.minimap.scale":{type:"number",default:x.scale,minimum:1,maximum:3,enum:[1,2,3],description:a.localize(75,null)},"editor.minimap.renderCharacters":{type:"boolean",default:x.renderCharacters,description:a.localize(76,null)},"editor.minimap.maxColumn":{type:"number",default:x.maxColumn,description:a.localize(77,null)},"editor.minimap.showRegionSectionHeaders":{type:"boolean",default:x.showRegionSectionHeaders,description:a.localize(78,null)},"editor.minimap.showMarkSectionHeaders":{type:"boolean",default:x.showMarkSectionHeaders,description:a.localize(79,null)},"editor.minimap.sectionHeaderFontSize":{type:"number",default:x.sectionHeaderFontSize,description:a.localize(80,null)},"editor.minimap.sectionHeaderLetterSpacing":{type:"number",default:x.sectionHeaderLetterSpacing,description:a.localize(81,null)}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const Ee=x;return{enabled:i(Ee.enabled,this.defaultValue.enabled),autohide:i(Ee.autohide,this.defaultValue.autohide),size:$(Ee.size,this.defaultValue.size,["proportional","fill","fit"]),side:$(Ee.side,this.defaultValue.side,["right","left"]),showSlider:$(Ee.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:i(Ee.renderCharacters,this.defaultValue.renderCharacters),scale:c.clampedInt(Ee.scale,1,1,3),maxColumn:c.clampedInt(Ee.maxColumn,this.defaultValue.maxColumn,1,1e4),showRegionSectionHeaders:i(Ee.showRegionSectionHeaders,this.defaultValue.showRegionSectionHeaders),showMarkSectionHeaders:i(Ee.showMarkSectionHeaders,this.defaultValue.showMarkSectionHeaders),sectionHeaderFontSize:m.clamp(Ee.sectionHeaderFontSize??this.defaultValue.sectionHeaderFontSize,4,32),sectionHeaderLetterSpacing:m.clamp(Ee.sectionHeaderLetterSpacing??this.defaultValue.sectionHeaderLetterSpacing,0,5)}}}function he(H){return H==="ctrlCmd"?k.$j?"metaKey":"ctrlKey":"altKey"}class X extends d{constructor(){super(Be.padding,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:a.localize(82,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:a.localize(83,null)}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const Ee=x;return{top:c.clampedInt(Ee.top,0,0,1e3),bottom:c.clampedInt(Ee.bottom,0,0,1e3)}}}class Y extends d{constructor(){const x={enabled:!0,cycle:!0};super(Be.parameterHints,"parameterHints",x,{"editor.parameterHints.enabled":{type:"boolean",default:x.enabled,description:a.localize(84,null)},"editor.parameterHints.cycle":{type:"boolean",default:x.cycle,description:a.localize(85,null)}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const Ee=x;return{enabled:i(Ee.enabled,this.defaultValue.enabled),cycle:i(Ee.cycle,this.defaultValue.cycle)}}}class pe extends o{constructor(){super(Be.pixelRatio)}compute(x,Ee,Je){return x.pixelRatio}}class $e extends d{constructor(){super(Be.placeholder,"placeholder",void 0)}validate(x){return typeof x>"u"?this.defaultValue:typeof x=="string"?x:this.defaultValue}}class Te extends d{constructor(){const x={other:"on",comments:"off",strings:"off"},Ee=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[a.localize(86,null),a.localize(87,null),a.localize(88,null)]}];super(Be.quickSuggestions,"quickSuggestions",x,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:Ee,default:x.strings,description:a.localize(89,null)},comments:{anyOf:Ee,default:x.comments,description:a.localize(90,null)},other:{anyOf:Ee,default:x.other,description:a.localize(91,null)}},default:x,markdownDescription:a.localize(92,null,"`#editor.suggestOnTriggerCharacters#`")}),this.defaultValue=x}validate(x){if(typeof x=="boolean"){const Zt=x?"on":"off";return{comments:Zt,strings:Zt,other:Zt}}if(!x||typeof x!="object")return this.defaultValue;const{other:Ee,comments:Je,strings:xe}=x,ht=["on","inline","off"];let pt,Ft,Ut;return typeof Ee=="boolean"?pt=Ee?"on":"off":pt=$(Ee,this.defaultValue.other,ht),typeof Je=="boolean"?Ft=Je?"on":"off":Ft=$(Je,this.defaultValue.comments,ht),typeof xe=="boolean"?Ut=xe?"on":"off":Ut=$(xe,this.defaultValue.strings,ht),{other:pt,comments:Ft,strings:Ut}}}var ze;(function(H){H[H.Off=0]="Off",H[H.On=1]="On",H[H.Relative=2]="Relative",H[H.Interval=3]="Interval",H[H.Custom=4]="Custom"})(ze||(e.RenderLineNumbersType=ze={}));class Se extends d{constructor(){super(Be.lineNumbers,"lineNumbers",{renderType:ze.On,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[a.localize(93,null),a.localize(94,null),a.localize(95,null),a.localize(96,null)],default:"on",description:a.localize(97,null)})}validate(x){let Ee=this.defaultValue.renderType,Je=this.defaultValue.renderFn;return typeof x<"u"&&(typeof x=="function"?(Ee=ze.Custom,Je=x):x==="interval"?Ee=ze.Interval:x==="relative"?Ee=ze.Relative:x==="on"?Ee=ze.On:Ee=ze.Off),{renderType:Ee,renderFn:Je}}}function Re(H){const x=H.get(Be.renderValidationDecorations);return x==="editable"?H.get(Be.readOnly):x!=="on"}class Oe extends d{constructor(){const x=[],Ee={type:"number",description:a.localize(98,null)};super(Be.rulers,"rulers",x,{type:"array",items:{anyOf:[Ee,{type:["object"],properties:{column:Ee,color:{type:"string",description:a.localize(99,null),format:"color-hex"}}}]},default:x,description:a.localize(100,null)})}validate(x){if(Array.isArray(x)){const Ee=[];for(const Je of x)if(typeof Je=="number")Ee.push({column:c.clampedInt(Je,0,0,1e4),color:null});else if(Je&&typeof Je=="object"){const xe=Je;Ee.push({column:c.clampedInt(xe.column,0,0,1e4),color:xe.color})}return Ee.sort((Je,xe)=>Je.column-xe.column),Ee}return this.defaultValue}}class z extends d{constructor(){super(Be.readOnlyMessage,"readOnlyMessage",void 0)}validate(x){return!x||typeof x!="object"?this.defaultValue:x}}function U(H,x){if(typeof H!="string")return x;switch(H){case"hidden":return O.ScrollbarVisibility.Hidden;case"visible":return O.ScrollbarVisibility.Visible;default:return O.ScrollbarVisibility.Auto}}class K extends d{constructor(){const x={vertical:O.ScrollbarVisibility.Auto,horizontal:O.ScrollbarVisibility.Auto,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1,ignoreHorizontalScrollbarInContentHeight:!1};super(Be.scrollbar,"scrollbar",x,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[a.localize(101,null),a.localize(102,null),a.localize(103,null)],default:"auto",description:a.localize(104,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[a.localize(105,null),a.localize(106,null),a.localize(107,null)],default:"auto",description:a.localize(108,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:x.verticalScrollbarSize,description:a.localize(109,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:x.horizontalScrollbarSize,description:a.localize(110,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:x.scrollByPage,description:a.localize(111,null)},"editor.scrollbar.ignoreHorizontalScrollbarInContentHeight":{type:"boolean",default:x.ignoreHorizontalScrollbarInContentHeight,description:a.localize(112,null)}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const Ee=x,Je=c.clampedInt(Ee.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),xe=c.clampedInt(Ee.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:c.clampedInt(Ee.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:U(Ee.vertical,this.defaultValue.vertical),horizontal:U(Ee.horizontal,this.defaultValue.horizontal),useShadows:i(Ee.useShadows,this.defaultValue.useShadows),verticalHasArrows:i(Ee.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:i(Ee.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:i(Ee.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:i(Ee.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Je,horizontalSliderSize:c.clampedInt(Ee.horizontalSliderSize,Je,0,1e3),verticalScrollbarSize:xe,verticalSliderSize:c.clampedInt(Ee.verticalSliderSize,xe,0,1e3),scrollByPage:i(Ee.scrollByPage,this.defaultValue.scrollByPage),ignoreHorizontalScrollbarInContentHeight:i(Ee.ignoreHorizontalScrollbarInContentHeight,this.defaultValue.ignoreHorizontalScrollbarInContentHeight)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class Q extends d{constructor(){const x={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(Be.unicodeHighlighting,"unicodeHighlight",x,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:x.nonBasicASCII,description:a.localize(113,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:x.invisibleCharacters,description:a.localize(114,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:x.ambiguousCharacters,description:a.localize(115,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:x.includeComments,description:a.localize(116,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:x.includeStrings,description:a.localize(117,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:x.allowedCharacters,description:a.localize(118,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:x.allowedLocales,description:a.localize(119,null)}})}applyUpdate(x,Ee){let Je=!1;Ee.allowedCharacters&&x&&(S.$fo(x.allowedCharacters,Ee.allowedCharacters)||(x={...x,allowedCharacters:Ee.allowedCharacters},Je=!0)),Ee.allowedLocales&&x&&(S.$fo(x.allowedLocales,Ee.allowedLocales)||(x={...x,allowedLocales:Ee.allowedLocales},Je=!0));const xe=super.applyUpdate(x,Ee);return Je?new n(xe.newValue,!0):xe}validate(x){if(!x||typeof x!="object")return this.defaultValue;const Ee=x;return{nonBasicASCII:Ke(Ee.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:i(Ee.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:i(Ee.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:Ke(Ee.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:Ke(Ee.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(x.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(x.allowedLocales,this.defaultValue.allowedLocales)}}c(x,Ee){if(typeof x!="object"||!x)return Ee;const Je={};for(const[xe,ht]of Object.entries(x))ht===!0&&(Je[xe]=!0);return Je}}class ne extends d{constructor(){const x={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1,fontFamily:"default"};super(Be.inlineSuggest,"inlineSuggest",x,{"editor.inlineSuggest.enabled":{type:"boolean",default:x.enabled,description:a.localize(120,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:x.showToolbar,enum:["always","onHover","never"],enumDescriptions:[a.localize(121,null),a.localize(122,null),a.localize(123,null)],description:a.localize(124,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:x.suppressSuggestions,description:a.localize(125,null)},"editor.inlineSuggest.fontFamily":{type:"string",default:x.fontFamily,description:a.localize(126,null)}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const Ee=x;return{enabled:i(Ee.enabled,this.defaultValue.enabled),mode:$(Ee.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:$(Ee.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),suppressSuggestions:i(Ee.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:i(Ee.keepOnBlur,this.defaultValue.keepOnBlur),fontFamily:f.string(Ee.fontFamily,this.defaultValue.fontFamily)}}}class fe extends d{constructor(){const x={enabled:!1,showToolbar:"onHover",fontFamily:"default",keepOnBlur:!1,backgroundColoring:!1};super(Be.inlineEdit,"experimentalInlineEdit",x,{"editor.experimentalInlineEdit.enabled":{type:"boolean",default:x.enabled,description:a.localize(127,null)},"editor.experimentalInlineEdit.showToolbar":{type:"string",default:x.showToolbar,enum:["always","onHover","never"],enumDescriptions:[a.localize(128,null),a.localize(129,null),a.localize(130,null)],description:a.localize(131,null)},"editor.experimentalInlineEdit.fontFamily":{type:"string",default:x.fontFamily,description:a.localize(132,null)},"editor.experimentalInlineEdit.backgroundColoring":{type:"boolean",default:x.backgroundColoring,description:a.localize(133,null)}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const Ee=x;return{enabled:i(Ee.enabled,this.defaultValue.enabled),showToolbar:$(Ee.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),fontFamily:f.string(Ee.fontFamily,this.defaultValue.fontFamily),keepOnBlur:i(Ee.keepOnBlur,this.defaultValue.keepOnBlur),backgroundColoring:i(Ee.backgroundColoring,this.defaultValue.backgroundColoring)}}}class Ae extends d{constructor(){const x={enabled:T.$et.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:T.$et.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(Be.bracketPairColorization,"bracketPairColorization",x,{"editor.bracketPairColorization.enabled":{type:"boolean",default:x.enabled,markdownDescription:a.localize(134,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:x.independentColorPoolPerBracketType,description:a.localize(135,null)}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const Ee=x;return{enabled:i(Ee.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:i(Ee.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class je extends d{constructor(){const x={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(Be.guides,"guides",x,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[a.localize(136,null),a.localize(137,null),a.localize(138,null)],default:x.bracketPairs,description:a.localize(139,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[a.localize(140,null),a.localize(141,null),a.localize(142,null)],default:x.bracketPairsHorizontal,description:a.localize(143,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:x.highlightActiveBracketPair,description:a.localize(144,null)},"editor.guides.indentation":{type:"boolean",default:x.indentation,description:a.localize(145,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[a.localize(146,null),a.localize(147,null),a.localize(148,null)],default:x.highlightActiveIndentation,description:a.localize(149,null)}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const Ee=x;return{bracketPairs:Ke(Ee.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:Ke(Ee.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:i(Ee.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:i(Ee.indentation,this.defaultValue.indentation),highlightActiveIndentation:Ke(Ee.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function Ke(H,x,Ee){const Je=Ee.indexOf(H);return Je===-1?x:Ee[Je]}class _e extends d{constructor(){const x={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(Be.suggest,"suggest",x,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[a.localize(150,null),a.localize(151,null)],default:x.insertMode,description:a.localize(152,null)},"editor.suggest.filterGraceful":{type:"boolean",default:x.filterGraceful,description:a.localize(153,null)},"editor.suggest.localityBonus":{type:"boolean",default:x.localityBonus,description:a.localize(154,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:x.shareSuggestSelections,markdownDescription:a.localize(155,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[a.localize(156,null),a.localize(157,null),a.localize(158,null),a.localize(159,null)],default:x.selectionMode,markdownDescription:a.localize(160,null,"`#editor.quickSuggestions#`","`#editor.suggestOnTriggerCharacters#`")},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:x.snippetsPreventQuickSuggestions,description:a.localize(161,null)},"editor.suggest.showIcons":{type:"boolean",default:x.showIcons,description:a.localize(162,null)},"editor.suggest.showStatusBar":{type:"boolean",default:x.showStatusBar,description:a.localize(163,null)},"editor.suggest.preview":{type:"boolean",default:x.preview,description:a.localize(164,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:x.showInlineDetails,description:a.localize(165,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:a.localize(166,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:a.localize(167,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:a.localize(168,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:a.localize(169,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:a.localize(170,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:a.localize(171,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:a.localize(172,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:a.localize(173,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:a.localize(174,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:a.localize(175,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:a.localize(176,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:a.localize(177,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:a.localize(178,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:a.localize(179,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:a.localize(180,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:a.localize(181,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:a.localize(182,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:a.localize(183,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:a.localize(184,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:a.localize(185,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:a.localize(186,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:a.localize(187,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:a.localize(188,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:a.localize(189,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:a.localize(190,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:a.localize(191,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:a.localize(192,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:a.localize(193,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:a.localize(194,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:a.localize(195,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:a.localize(196,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:a.localize(197,null)}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const Ee=x;return{insertMode:$(Ee.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:i(Ee.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:i(Ee.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:i(Ee.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:i(Ee.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:$(Ee.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:i(Ee.showIcons,this.defaultValue.showIcons),showStatusBar:i(Ee.showStatusBar,this.defaultValue.showStatusBar),preview:i(Ee.preview,this.defaultValue.preview),previewMode:$(Ee.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:i(Ee.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:i(Ee.showMethods,this.defaultValue.showMethods),showFunctions:i(Ee.showFunctions,this.defaultValue.showFunctions),showConstructors:i(Ee.showConstructors,this.defaultValue.showConstructors),showDeprecated:i(Ee.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:i(Ee.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:i(Ee.showFields,this.defaultValue.showFields),showVariables:i(Ee.showVariables,this.defaultValue.showVariables),showClasses:i(Ee.showClasses,this.defaultValue.showClasses),showStructs:i(Ee.showStructs,this.defaultValue.showStructs),showInterfaces:i(Ee.showInterfaces,this.defaultValue.showInterfaces),showModules:i(Ee.showModules,this.defaultValue.showModules),showProperties:i(Ee.showProperties,this.defaultValue.showProperties),showEvents:i(Ee.showEvents,this.defaultValue.showEvents),showOperators:i(Ee.showOperators,this.defaultValue.showOperators),showUnits:i(Ee.showUnits,this.defaultValue.showUnits),showValues:i(Ee.showValues,this.defaultValue.showValues),showConstants:i(Ee.showConstants,this.defaultValue.showConstants),showEnums:i(Ee.showEnums,this.defaultValue.showEnums),showEnumMembers:i(Ee.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:i(Ee.showKeywords,this.defaultValue.showKeywords),showWords:i(Ee.showWords,this.defaultValue.showWords),showColors:i(Ee.showColors,this.defaultValue.showColors),showFiles:i(Ee.showFiles,this.defaultValue.showFiles),showReferences:i(Ee.showReferences,this.defaultValue.showReferences),showFolders:i(Ee.showFolders,this.defaultValue.showFolders),showTypeParameters:i(Ee.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:i(Ee.showSnippets,this.defaultValue.showSnippets),showUsers:i(Ee.showUsers,this.defaultValue.showUsers),showIssues:i(Ee.showIssues,this.defaultValue.showIssues)}}}class it extends d{constructor(){super(Be.smartSelect,"smartSelect",{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:a.localize(198,null),default:!0,type:"boolean"},"editor.smartSelect.selectSubwords":{description:a.localize(199,null),default:!0,type:"boolean"}})}validate(x){return!x||typeof x!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:i(x.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace),selectSubwords:i(x.selectSubwords,this.defaultValue.selectSubwords)}}}class nt extends d{constructor(){const x=[];super(Be.wordSegmenterLocales,"wordSegmenterLocales",x,{anyOf:[{description:a.localize(200,null),type:"string"},{description:a.localize(201,null),type:"array",items:{type:"string"}}]})}validate(x){if(typeof x=="string"&&(x=[x]),Array.isArray(x)){const Ee=[];for(const Je of x)if(typeof Je=="string")try{Intl.Segmenter.supportedLocalesOf(Je).length>0&&Ee.push(Je)}catch{}return Ee}return this.defaultValue}}var tt;(function(H){H[H.None=0]="None",H[H.Same=1]="Same",H[H.Indent=2]="Indent",H[H.DeepIndent=3]="DeepIndent"})(tt||(e.WrappingIndent=tt={}));class rt extends d{constructor(){super(Be.wrappingIndent,"wrappingIndent",tt.Same,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[a.localize(202,null),a.localize(203,null),a.localize(204,null),a.localize(205,null)],description:a.localize(206,null),default:"same"}})}validate(x){switch(x){case"none":return tt.None;case"same":return tt.Same;case"indent":return tt.Indent;case"deepIndent":return tt.DeepIndent}return tt.Same}compute(x,Ee,Je){return Ee.get(Be.accessibilitySupport)===R.AccessibilitySupport.Enabled?tt.None:Je}}class $t extends o{constructor(){super(Be.wrappingInfo)}compute(x,Ee,Je){const xe=Ee.get(Be.layoutInfo);return{isDominatedByLongLines:x.isDominatedByLongLines,isWordWrapMinified:xe.isWordWrapMinified,isViewportWrapping:xe.isViewportWrapping,wrappingColumn:xe.wrappingColumn}}}class lt extends d{constructor(){const x={enabled:!0,showDropSelector:"afterDrop"};super(Be.dropIntoEditor,"dropIntoEditor",x,{"editor.dropIntoEditor.enabled":{type:"boolean",default:x.enabled,markdownDescription:a.localize(207,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:a.localize(208,null),enum:["afterDrop","never"],enumDescriptions:[a.localize(209,null),a.localize(210,null)],default:"afterDrop"}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const Ee=x;return{enabled:i(Ee.enabled,this.defaultValue.enabled),showDropSelector:$(Ee.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class st extends d{constructor(){const x={enabled:!0,showPasteSelector:"afterPaste"};super(Be.pasteAs,"pasteAs",x,{"editor.pasteAs.enabled":{type:"boolean",default:x.enabled,markdownDescription:a.localize(211,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:a.localize(212,null),enum:["afterPaste","never"],enumDescriptions:[a.localize(213,null),a.localize(214,null)],default:"afterPaste"}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const Ee=x;return{enabled:i(Ee.enabled,this.defaultValue.enabled),showPasteSelector:$(Ee.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const ut="Consolas, 'Courier New', monospace",ft="Menlo, Monaco, 'Courier New', monospace",mt="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:k.$j?ft:k.$k?mt:ut,fontWeight:"normal",fontSize:k.$j?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function We(H){return e.editorOptionsRegistry[H.id]=H,H}var Be;(function(H){H[H.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",H[H.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",H[H.accessibilitySupport=2]="accessibilitySupport",H[H.accessibilityPageSize=3]="accessibilityPageSize",H[H.ariaLabel=4]="ariaLabel",H[H.ariaRequired=5]="ariaRequired",H[H.autoClosingBrackets=6]="autoClosingBrackets",H[H.autoClosingComments=7]="autoClosingComments",H[H.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",H[H.autoClosingDelete=9]="autoClosingDelete",H[H.autoClosingOvertype=10]="autoClosingOvertype",H[H.autoClosingQuotes=11]="autoClosingQuotes",H[H.autoIndent=12]="autoIndent",H[H.automaticLayout=13]="automaticLayout",H[H.autoSurround=14]="autoSurround",H[H.bracketPairColorization=15]="bracketPairColorization",H[H.guides=16]="guides",H[H.codeLens=17]="codeLens",H[H.codeLensFontFamily=18]="codeLensFontFamily",H[H.codeLensFontSize=19]="codeLensFontSize",H[H.colorDecorators=20]="colorDecorators",H[H.colorDecoratorsLimit=21]="colorDecoratorsLimit",H[H.columnSelection=22]="columnSelection",H[H.comments=23]="comments",H[H.contextmenu=24]="contextmenu",H[H.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",H[H.cursorBlinking=26]="cursorBlinking",H[H.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",H[H.cursorStyle=28]="cursorStyle",H[H.cursorSurroundingLines=29]="cursorSurroundingLines",H[H.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",H[H.cursorWidth=31]="cursorWidth",H[H.disableLayerHinting=32]="disableLayerHinting",H[H.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",H[H.domReadOnly=34]="domReadOnly",H[H.dragAndDrop=35]="dragAndDrop",H[H.dropIntoEditor=36]="dropIntoEditor",H[H.emptySelectionClipboard=37]="emptySelectionClipboard",H[H.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",H[H.extraEditorClassName=39]="extraEditorClassName",H[H.fastScrollSensitivity=40]="fastScrollSensitivity",H[H.find=41]="find",H[H.fixedOverflowWidgets=42]="fixedOverflowWidgets",H[H.folding=43]="folding",H[H.foldingStrategy=44]="foldingStrategy",H[H.foldingHighlight=45]="foldingHighlight",H[H.foldingImportsByDefault=46]="foldingImportsByDefault",H[H.foldingMaximumRegions=47]="foldingMaximumRegions",H[H.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",H[H.fontFamily=49]="fontFamily",H[H.fontInfo=50]="fontInfo",H[H.fontLigatures=51]="fontLigatures",H[H.fontSize=52]="fontSize",H[H.fontWeight=53]="fontWeight",H[H.fontVariations=54]="fontVariations",H[H.formatOnPaste=55]="formatOnPaste",H[H.formatOnType=56]="formatOnType",H[H.glyphMargin=57]="glyphMargin",H[H.gotoLocation=58]="gotoLocation",H[H.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",H[H.hover=60]="hover",H[H.inDiffEditor=61]="inDiffEditor",H[H.inlineSuggest=62]="inlineSuggest",H[H.inlineEdit=63]="inlineEdit",H[H.letterSpacing=64]="letterSpacing",H[H.lightbulb=65]="lightbulb",H[H.lineDecorationsWidth=66]="lineDecorationsWidth",H[H.lineHeight=67]="lineHeight",H[H.lineNumbers=68]="lineNumbers",H[H.lineNumbersMinChars=69]="lineNumbersMinChars",H[H.linkedEditing=70]="linkedEditing",H[H.links=71]="links",H[H.matchBrackets=72]="matchBrackets",H[H.minimap=73]="minimap",H[H.mouseStyle=74]="mouseStyle",H[H.mouseWheelScrollSensitivity=75]="mouseWheelScrollSensitivity",H[H.mouseWheelZoom=76]="mouseWheelZoom",H[H.multiCursorMergeOverlapping=77]="multiCursorMergeOverlapping",H[H.multiCursorModifier=78]="multiCursorModifier",H[H.multiCursorPaste=79]="multiCursorPaste",H[H.multiCursorLimit=80]="multiCursorLimit",H[H.occurrencesHighlight=81]="occurrencesHighlight",H[H.overviewRulerBorder=82]="overviewRulerBorder",H[H.overviewRulerLanes=83]="overviewRulerLanes",H[H.padding=84]="padding",H[H.pasteAs=85]="pasteAs",H[H.parameterHints=86]="parameterHints",H[H.peekWidgetDefaultFocus=87]="peekWidgetDefaultFocus",H[H.placeholder=88]="placeholder",H[H.definitionLinkOpensInPeek=89]="definitionLinkOpensInPeek",H[H.quickSuggestions=90]="quickSuggestions",H[H.quickSuggestionsDelay=91]="quickSuggestionsDelay",H[H.readOnly=92]="readOnly",H[H.readOnlyMessage=93]="readOnlyMessage",H[H.renameOnType=94]="renameOnType",H[H.renderControlCharacters=95]="renderControlCharacters",H[H.renderFinalNewline=96]="renderFinalNewline",H[H.renderLineHighlight=97]="renderLineHighlight",H[H.renderLineHighlightOnlyWhenFocus=98]="renderLineHighlightOnlyWhenFocus",H[H.renderValidationDecorations=99]="renderValidationDecorations",H[H.renderWhitespace=100]="renderWhitespace",H[H.revealHorizontalRightPadding=101]="revealHorizontalRightPadding",H[H.roundedSelection=102]="roundedSelection",H[H.rulers=103]="rulers",H[H.scrollbar=104]="scrollbar",H[H.scrollBeyondLastColumn=105]="scrollBeyondLastColumn",H[H.scrollBeyondLastLine=106]="scrollBeyondLastLine",H[H.scrollPredominantAxis=107]="scrollPredominantAxis",H[H.selectionClipboard=108]="selectionClipboard",H[H.selectionHighlight=109]="selectionHighlight",H[H.selectOnLineNumbers=110]="selectOnLineNumbers",H[H.showFoldingControls=111]="showFoldingControls",H[H.showUnused=112]="showUnused",H[H.snippetSuggestions=113]="snippetSuggestions",H[H.smartSelect=114]="smartSelect",H[H.smoothScrolling=115]="smoothScrolling",H[H.stickyScroll=116]="stickyScroll",H[H.stickyTabStops=117]="stickyTabStops",H[H.stopRenderingLineAfter=118]="stopRenderingLineAfter",H[H.suggest=119]="suggest",H[H.suggestFontSize=120]="suggestFontSize",H[H.suggestLineHeight=121]="suggestLineHeight",H[H.suggestOnTriggerCharacters=122]="suggestOnTriggerCharacters",H[H.suggestSelection=123]="suggestSelection",H[H.tabCompletion=124]="tabCompletion",H[H.tabIndex=125]="tabIndex",H[H.unicodeHighlighting=126]="unicodeHighlighting",H[H.unusualLineTerminators=127]="unusualLineTerminators",H[H.useShadowDOM=128]="useShadowDOM",H[H.useTabStops=129]="useTabStops",H[H.wordBreak=130]="wordBreak",H[H.wordSegmenterLocales=131]="wordSegmenterLocales",H[H.wordSeparators=132]="wordSeparators",H[H.wordWrap=133]="wordWrap",H[H.wordWrapBreakAfterCharacters=134]="wordWrapBreakAfterCharacters",H[H.wordWrapBreakBeforeCharacters=135]="wordWrapBreakBeforeCharacters",H[H.wordWrapColumn=136]="wordWrapColumn",H[H.wordWrapOverride1=137]="wordWrapOverride1",H[H.wordWrapOverride2=138]="wordWrapOverride2",H[H.wrappingIndent=139]="wrappingIndent",H[H.wrappingStrategy=140]="wrappingStrategy",H[H.showDeprecated=141]="showDeprecated",H[H.inlayHints=142]="inlayHints",H[H.editorClassName=143]="editorClassName",H[H.pixelRatio=144]="pixelRatio",H[H.tabFocusMode=145]="tabFocusMode",H[H.layoutInfo=146]="layoutInfo",H[H.wrappingInfo=147]="wrappingInfo",H[H.defaultColorDecorators=148]="defaultColorDecorators",H[H.colorDecoratorsActivatedOn=149]="colorDecoratorsActivatedOn",H[H.inlineCompletionsAccessibilityVerbose=150]="inlineCompletionsAccessibilityVerbose"})(Be||(e.EditorOption=Be={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:We(new r(Be.acceptSuggestionOnCommitCharacter,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:a.localize(215,null)})),acceptSuggestionOnEnter:We(new I(Be.acceptSuggestionOnEnter,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",a.localize(216,null),""],markdownDescription:a.localize(217,null)})),accessibilitySupport:We(new C),accessibilityPageSize:We(new c(Be.accessibilityPageSize,"accessibilityPageSize",10,1,A.Constants.MAX_SAFE_SMALL_INTEGER,{description:a.localize(218,null),tags:["accessibility"]})),ariaLabel:We(new f(Be.ariaLabel,"ariaLabel",a.localize(219,null))),ariaRequired:We(new r(Be.ariaRequired,"ariaRequired",!1,void 0)),screenReaderAnnounceInlineSuggestion:We(new r(Be.screenReaderAnnounceInlineSuggestion,"screenReaderAnnounceInlineSuggestion",!0,{description:a.localize(220,null),tags:["accessibility"]})),autoClosingBrackets:We(new I(Be.autoClosingBrackets,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",a.localize(221,null),a.localize(222,null),""],description:a.localize(223,null)})),autoClosingComments:We(new I(Be.autoClosingComments,"autoClosingComments","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",a.localize(224,null),a.localize(225,null),""],description:a.localize(226,null)})),autoClosingDelete:We(new I(Be.autoClosingDelete,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",a.localize(227,null),""],description:a.localize(228,null)})),autoClosingOvertype:We(new I(Be.autoClosingOvertype,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",a.localize(229,null),""],description:a.localize(230,null)})),autoClosingQuotes:We(new I(Be.autoClosingQuotes,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",a.localize(231,null),a.localize(232,null),""],description:a.localize(233,null)})),autoIndent:We(new D(Be.autoIndent,"autoIndent",y.Full,"full",["none","keep","brackets","advanced","full"],v,{enumDescriptions:[a.localize(234,null),a.localize(235,null),a.localize(236,null),a.localize(237,null),a.localize(238,null)],description:a.localize(239,null)})),automaticLayout:We(new r(Be.automaticLayout,"automaticLayout",!1)),autoSurround:We(new I(Be.autoSurround,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[a.localize(240,null),a.localize(241,null),a.localize(242,null),""],description:a.localize(243,null)})),bracketPairColorization:We(new Ae),bracketPairGuides:We(new je),stickyTabStops:We(new r(Be.stickyTabStops,"stickyTabStops",!1,{description:a.localize(244,null)})),codeLens:We(new r(Be.codeLens,"codeLens",!0,{description:a.localize(245,null)})),codeLensFontFamily:We(new f(Be.codeLensFontFamily,"codeLensFontFamily","",{description:a.localize(246,null)})),codeLensFontSize:We(new c(Be.codeLensFontSize,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:a.localize(247,null)})),colorDecorators:We(new r(Be.colorDecorators,"colorDecorators",!0,{description:a.localize(248,null)})),colorDecoratorActivatedOn:We(new I(Be.colorDecoratorsActivatedOn,"colorDecoratorsActivatedOn","clickAndHover",["clickAndHover","hover","click"],{enumDescriptions:[a.localize(249,null),a.localize(250,null),a.localize(251,null)],description:a.localize(252,null)})),colorDecoratorsLimit:We(new c(Be.colorDecoratorsLimit,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:a.localize(253,null)})),columnSelection:We(new r(Be.columnSelection,"columnSelection",!1,{description:a.localize(254,null)})),comments:We(new P),contextmenu:We(new r(Be.contextmenu,"contextmenu",!0)),copyWithSyntaxHighlighting:We(new r(Be.copyWithSyntaxHighlighting,"copyWithSyntaxHighlighting",!0,{description:a.localize(255,null)})),cursorBlinking:We(new D(Be.cursorBlinking,"cursorBlinking",g.Blink,"blink",["blink","smooth","phase","expand","solid"],b,{description:a.localize(256,null)})),cursorSmoothCaretAnimation:We(new I(Be.cursorSmoothCaretAnimation,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[a.localize(257,null),a.localize(258,null),a.localize(259,null)],description:a.localize(260,null)})),cursorStyle:We(new D(Be.cursorStyle,"cursorStyle",L.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],B,{description:a.localize(261,null)})),cursorSurroundingLines:We(new c(Be.cursorSurroundingLines,"cursorSurroundingLines",0,0,A.Constants.MAX_SAFE_SMALL_INTEGER,{description:a.localize(262,null)})),cursorSurroundingLinesStyle:We(new I(Be.cursorSurroundingLinesStyle,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[a.localize(263,null),a.localize(264,null)],markdownDescription:a.localize(265,null)})),cursorWidth:We(new c(Be.cursorWidth,"cursorWidth",0,0,A.Constants.MAX_SAFE_SMALL_INTEGER,{markdownDescription:a.localize(266,null)})),disableLayerHinting:We(new r(Be.disableLayerHinting,"disableLayerHinting",!1)),disableMonospaceOptimizations:We(new r(Be.disableMonospaceOptimizations,"disableMonospaceOptimizations",!1)),domReadOnly:We(new r(Be.domReadOnly,"domReadOnly",!1)),dragAndDrop:We(new r(Be.dragAndDrop,"dragAndDrop",!0,{description:a.localize(267,null)})),emptySelectionClipboard:We(new W),dropIntoEditor:We(new lt),stickyScroll:We(new V),experimentalWhitespaceRendering:We(new I(Be.experimentalWhitespaceRendering,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[a.localize(268,null),a.localize(269,null),a.localize(270,null)],description:a.localize(271,null)})),extraEditorClassName:We(new f(Be.extraEditorClassName,"extraEditorClassName","")),fastScrollSensitivity:We(new m(Be.fastScrollSensitivity,"fastScrollSensitivity",5,H=>H<=0?5:H,{markdownDescription:a.localize(272,null)})),find:We(new F),fixedOverflowWidgets:We(new r(Be.fixedOverflowWidgets,"fixedOverflowWidgets",!1)),folding:We(new r(Be.folding,"folding",!0,{description:a.localize(273,null)})),foldingStrategy:We(new I(Be.foldingStrategy,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[a.localize(274,null),a.localize(275,null)],description:a.localize(276,null)})),foldingHighlight:We(new r(Be.foldingHighlight,"foldingHighlight",!0,{description:a.localize(277,null)})),foldingImportsByDefault:We(new r(Be.foldingImportsByDefault,"foldingImportsByDefault",!1,{description:a.localize(278,null)})),foldingMaximumRegions:We(new c(Be.foldingMaximumRegions,"foldingMaximumRegions",5e3,10,65e3,{description:a.localize(279,null)})),unfoldOnClickAfterEndOfLine:We(new r(Be.unfoldOnClickAfterEndOfLine,"unfoldOnClickAfterEndOfLine",!1,{description:a.localize(280,null)})),fontFamily:We(new f(Be.fontFamily,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:a.localize(281,null)})),fontInfo:We(new ge),fontLigatures2:We(new q),fontSize:We(new te),fontWeight:We(new me),fontVariations:We(new ue),formatOnPaste:We(new r(Be.formatOnPaste,"formatOnPaste",!1,{description:a.localize(282,null)})),formatOnType:We(new r(Be.formatOnType,"formatOnType",!1,{description:a.localize(283,null)})),glyphMargin:We(new r(Be.glyphMargin,"glyphMargin",!0,{description:a.localize(284,null)})),gotoLocation:We(new re),hideCursorInOverviewRuler:We(new r(Be.hideCursorInOverviewRuler,"hideCursorInOverviewRuler",!1,{description:a.localize(285,null)})),hover:We(new ce),inDiffEditor:We(new r(Be.inDiffEditor,"inDiffEditor",!1)),letterSpacing:We(new m(Be.letterSpacing,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,H=>m.clamp(H,-5,20),{description:a.localize(286,null)})),lightbulb:We(new Z),lineDecorationsWidth:We(new ye),lineHeight:We(new ae),lineNumbers:We(new Se),lineNumbersMinChars:We(new c(Be.lineNumbersMinChars,"lineNumbersMinChars",5,1,300)),linkedEditing:We(new r(Be.linkedEditing,"linkedEditing",!1,{description:a.localize(287,null)})),links:We(new r(Be.links,"links",!0,{description:a.localize(288,null)})),matchBrackets:We(new I(Be.matchBrackets,"matchBrackets","always",["always","near","never"],{description:a.localize(289,null)})),minimap:We(new we),mouseStyle:We(new I(Be.mouseStyle,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:We(new m(Be.mouseWheelScrollSensitivity,"mouseWheelScrollSensitivity",1,H=>H===0?1:H,{markdownDescription:a.localize(290,null)})),mouseWheelZoom:We(new r(Be.mouseWheelZoom,"mouseWheelZoom",!1,{markdownDescription:k.$j?a.localize(291,null):a.localize(292,null)})),multiCursorMergeOverlapping:We(new r(Be.multiCursorMergeOverlapping,"multiCursorMergeOverlapping",!0,{description:a.localize(293,null)})),multiCursorModifier:We(new D(Be.multiCursorModifier,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],he,{markdownEnumDescriptions:[a.localize(294,null),a.localize(295,null)],markdownDescription:a.localize(296,null)})),multiCursorPaste:We(new I(Be.multiCursorPaste,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[a.localize(297,null),a.localize(298,null)],markdownDescription:a.localize(299,null)})),multiCursorLimit:We(new c(Be.multiCursorLimit,"multiCursorLimit",1e4,1,1e5,{markdownDescription:a.localize(300,null)})),occurrencesHighlight:We(new I(Be.occurrencesHighlight,"occurrencesHighlight","singleFile",["off","singleFile","multiFile"],{markdownEnumDescriptions:[a.localize(301,null),a.localize(302,null),a.localize(303,null)],markdownDescription:a.localize(304,null)})),overviewRulerBorder:We(new r(Be.overviewRulerBorder,"overviewRulerBorder",!0,{description:a.localize(305,null)})),overviewRulerLanes:We(new c(Be.overviewRulerLanes,"overviewRulerLanes",3,0,3)),padding:We(new X),pasteAs:We(new st),parameterHints:We(new Y),peekWidgetDefaultFocus:We(new I(Be.peekWidgetDefaultFocus,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[a.localize(306,null),a.localize(307,null)],description:a.localize(308,null)})),placeholder:We(new $e),definitionLinkOpensInPeek:We(new r(Be.definitionLinkOpensInPeek,"definitionLinkOpensInPeek",!1,{description:a.localize(309,null)})),quickSuggestions:We(new Te),quickSuggestionsDelay:We(new c(Be.quickSuggestionsDelay,"quickSuggestionsDelay",10,0,A.Constants.MAX_SAFE_SMALL_INTEGER,{description:a.localize(310,null)})),readOnly:We(new r(Be.readOnly,"readOnly",!1)),readOnlyMessage:We(new z),renameOnType:We(new r(Be.renameOnType,"renameOnType",!1,{description:a.localize(311,null),markdownDeprecationMessage:a.localize(312,null)})),renderControlCharacters:We(new r(Be.renderControlCharacters,"renderControlCharacters",!0,{description:a.localize(313,null),restricted:!0})),renderFinalNewline:We(new I(Be.renderFinalNewline,"renderFinalNewline",k.$k?"dimmed":"on",["off","on","dimmed"],{description:a.localize(314,null)})),renderLineHighlight:We(new I(Be.renderLineHighlight,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",a.localize(315,null)],description:a.localize(316,null)})),renderLineHighlightOnlyWhenFocus:We(new r(Be.renderLineHighlightOnlyWhenFocus,"renderLineHighlightOnlyWhenFocus",!1,{description:a.localize(317,null)})),renderValidationDecorations:We(new I(Be.renderValidationDecorations,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:We(new I(Be.renderWhitespace,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",a.localize(318,null),a.localize(319,null),a.localize(320,null),""],description:a.localize(321,null)})),revealHorizontalRightPadding:We(new c(Be.revealHorizontalRightPadding,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:We(new r(Be.roundedSelection,"roundedSelection",!0,{description:a.localize(322,null)})),rulers:We(new Oe),scrollbar:We(new K),scrollBeyondLastColumn:We(new c(Be.scrollBeyondLastColumn,"scrollBeyondLastColumn",4,0,A.Constants.MAX_SAFE_SMALL_INTEGER,{description:a.localize(323,null)})),scrollBeyondLastLine:We(new r(Be.scrollBeyondLastLine,"scrollBeyondLastLine",!0,{description:a.localize(324,null)})),scrollPredominantAxis:We(new r(Be.scrollPredominantAxis,"scrollPredominantAxis",!0,{description:a.localize(325,null)})),selectionClipboard:We(new r(Be.selectionClipboard,"selectionClipboard",!0,{description:a.localize(326,null),included:k.$k})),selectionHighlight:We(new r(Be.selectionHighlight,"selectionHighlight",!0,{description:a.localize(327,null)})),selectOnLineNumbers:We(new r(Be.selectOnLineNumbers,"selectOnLineNumbers",!0)),showFoldingControls:We(new I(Be.showFoldingControls,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[a.localize(328,null),a.localize(329,null),a.localize(330,null)],description:a.localize(331,null)})),showUnused:We(new r(Be.showUnused,"showUnused",!0,{description:a.localize(332,null)})),showDeprecated:We(new r(Be.showDeprecated,"showDeprecated",!0,{description:a.localize(333,null)})),inlayHints:We(new _),snippetSuggestions:We(new I(Be.snippetSuggestions,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[a.localize(334,null),a.localize(335,null),a.localize(336,null),a.localize(337,null)],description:a.localize(338,null)})),smartSelect:We(new it),smoothScrolling:We(new r(Be.smoothScrolling,"smoothScrolling",!1,{description:a.localize(339,null)})),stopRenderingLineAfter:We(new c(Be.stopRenderingLineAfter,"stopRenderingLineAfter",1e4,-1,A.Constants.MAX_SAFE_SMALL_INTEGER)),suggest:We(new _e),inlineSuggest:We(new ne),inlineEdit:We(new fe),inlineCompletionsAccessibilityVerbose:We(new r(Be.inlineCompletionsAccessibilityVerbose,"inlineCompletionsAccessibilityVerbose",!1,{description:a.localize(340,null)})),suggestFontSize:We(new c(Be.suggestFontSize,"suggestFontSize",0,0,1e3,{markdownDescription:a.localize(341,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:We(new c(Be.suggestLineHeight,"suggestLineHeight",0,0,1e3,{markdownDescription:a.localize(342,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:We(new r(Be.suggestOnTriggerCharacters,"suggestOnTriggerCharacters",!0,{description:a.localize(343,null)})),suggestSelection:We(new I(Be.suggestSelection,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[a.localize(344,null),a.localize(345,null),a.localize(346,null)],description:a.localize(347,null)})),tabCompletion:We(new I(Be.tabCompletion,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[a.localize(348,null),a.localize(349,null),a.localize(350,null)],description:a.localize(351,null)})),tabIndex:We(new c(Be.tabIndex,"tabIndex",0,-1,A.Constants.MAX_SAFE_SMALL_INTEGER)),unicodeHighlight:We(new Q),unusualLineTerminators:We(new I(Be.unusualLineTerminators,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[a.localize(352,null),a.localize(353,null),a.localize(354,null)],description:a.localize(355,null)})),useShadowDOM:We(new r(Be.useShadowDOM,"useShadowDOM",!0)),useTabStops:We(new r(Be.useTabStops,"useTabStops",!0,{description:a.localize(356,null)})),wordBreak:We(new I(Be.wordBreak,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[a.localize(357,null),a.localize(358,null)],description:a.localize(359,null)})),wordSegmenterLocales:We(new nt),wordSeparators:We(new f(Be.wordSeparators,"wordSeparators",p.$ft,{description:a.localize(360,null)})),wordWrap:We(new I(Be.wordWrap,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[a.localize(361,null),a.localize(362,null),a.localize(363,null),a.localize(364,null)],description:a.localize(365,null)})),wordWrapBreakAfterCharacters:We(new f(Be.wordWrapBreakAfterCharacters,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:We(new f(Be.wordWrapBreakBeforeCharacters,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:We(new c(Be.wordWrapColumn,"wordWrapColumn",80,1,A.Constants.MAX_SAFE_SMALL_INTEGER,{markdownDescription:a.localize(366,null)})),wordWrapOverride1:We(new I(Be.wordWrapOverride1,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:We(new I(Be.wordWrapOverride2,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:We(new G),defaultColorDecorators:We(new r(Be.defaultColorDecorators,"defaultColorDecorators",!1,{markdownDescription:a.localize(367,null)})),pixelRatio:We(new pe),tabFocusMode:We(new r(Be.tabFocusMode,"tabFocusMode",!1,{markdownDescription:a.localize(368,null)})),layoutInfo:We(new se),wrappingInfo:We(new $t),wrappingIndent:We(new rt),wrappingStrategy:We(new Ie)}}),define(ke[106],Ce([1,0,3]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ni=e.$Mi=void 0,e.$Mi=(0,w.$Fi)("environmentService"),e.$Ni=(0,w.$Gi)(e.$Mi)}),define(ke[30],Ce([1,0,59,20,13,15,2,173,3,21,16,47]),function(oe,e,w,S,k,O,A,T,p,a,R,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hl=e.$El=e.FileKind=e.$Dl=e.$Cl=e.$Bl=e.$Al=e.$zl=e.$yl=e.$xl=e.FileOperationResult=e.$wl=e.$vl=e.$ul=e.$sl=e.FileChangeType=e.$rl=e.FileOperation=e.$ll=e.FileSystemProviderErrorCode=e.FileSystemProviderCapabilities=e.FileChangeFilter=e.FilePermission=e.FileType=e.$_k=void 0,e.$al=u,e.$bl=s,e.$cl=h,e.$dl=i,e.$el=r,e.$fl=t,e.$gl=c,e.$hl=l,e.$il=m,e.$jl=f,e.$kl=$,e.$ml=v,e.$nl=C,e.$ol=P,e.$pl=g,e.$ql=b,e.$tl=W,e.$Fl=me,e.$Gl=re,e.$Il=be,e.$_k=(0,p.$Fi)("fileService");function u(se){return se.create===!0}var E;(function(se){se[se.Unknown=0]="Unknown",se[se.File=1]="File",se[se.Directory=2]="Directory",se[se.SymbolicLink=64]="SymbolicLink"})(E||(e.FileType=E={}));var d;(function(se){se[se.Readonly=1]="Readonly",se[se.Locked=2]="Locked"})(d||(e.FilePermission=d={}));var n;(function(se){se[se.UPDATED=2]="UPDATED",se[se.ADDED=4]="ADDED",se[se.DELETED=8]="DELETED"})(n||(e.FileChangeFilter=n={}));function s(se){const Ie=se;return!!Ie&&typeof Ie.onDidChange=="function"}var o;(function(se){se[se.None=0]="None",se[se.FileReadWrite=2]="FileReadWrite",se[se.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",se[se.FileReadStream=16]="FileReadStream",se[se.FileFolderCopy=8]="FileFolderCopy",se[se.PathCaseSensitive=1024]="PathCaseSensitive",se[se.Readonly=2048]="Readonly",se[se.Trash=4096]="Trash",se[se.FileWriteUnlock=8192]="FileWriteUnlock",se[se.FileAtomicRead=16384]="FileAtomicRead",se[se.FileAtomicWrite=32768]="FileAtomicWrite",se[se.FileAtomicDelete=65536]="FileAtomicDelete",se[se.FileClone=131072]="FileClone"})(o||(e.FileSystemProviderCapabilities=o={}));function h(se){return!!(se.capabilities&o.FileReadWrite)}function i(se){return!!(se.capabilities&o.FileFolderCopy)}function r(se){return!!(se.capabilities&o.FileClone)}function t(se){return!!(se.capabilities&o.FileOpenReadWriteClose)}function c(se){return!!(se.capabilities&o.FileReadStream)}function l(se){return h(se)?!!(se.capabilities&o.FileAtomicRead):!1}function m(se){return h(se)?!!(se.capabilities&o.FileAtomicWrite):!1}function f(se){return!!(se.capabilities&o.FileAtomicDelete)}function $(se){return!!(se.capabilities&o.Readonly)}var I;(function(se){se.FileExists="EntryExists",se.FileNotFound="EntryNotFound",se.FileNotADirectory="EntryNotADirectory",se.FileIsADirectory="EntryIsADirectory",se.FileExceedsStorageQuota="EntryExceedsStorageQuota",se.FileTooLarge="EntryTooLarge",se.FileWriteLocked="EntryWriteLocked",se.NoPermissions="NoPermissions",se.Unavailable="Unavailable",se.Unknown="Unknown"})(I||(e.FileSystemProviderErrorCode=I={}));class D extends Error{static create(Ie,Ue){const Z=new D(Ie.toString(),Ue);return P(Z,Ue),Z}constructor(Ie,Ue){super(Ie),this.code=Ue}}e.$ll=D;function v(se,Ie){return D.create(se,Ie)}function C(se){return se||v((0,T.localize)(0,null),I.Unknown)}function P(se,Ie){return se.name=Ie?`${Ie} (FileSystemError)`:"FileSystemError",se}function g(se){if(!se)return I.Unknown;if(se instanceof D)return se.code;const Ie=/^(.+) \(FileSystemError\)$/.exec(se.name);if(!Ie)return I.Unknown;switch(Ie[1]){case I.FileExists:return I.FileExists;case I.FileIsADirectory:return I.FileIsADirectory;case I.FileNotADirectory:return I.FileNotADirectory;case I.FileNotFound:return I.FileNotFound;case I.FileTooLarge:return I.FileTooLarge;case I.FileWriteLocked:return I.FileWriteLocked;case I.NoPermissions:return I.NoPermissions;case I.Unavailable:return I.Unavailable}return I.Unknown}function b(se){if(se instanceof F)return se.fileOperationResult;switch(g(se)){case I.FileNotFound:return ge.FILE_NOT_FOUND;case I.FileIsADirectory:return ge.FILE_IS_DIRECTORY;case I.FileNotADirectory:return ge.FILE_NOT_DIRECTORY;case I.FileWriteLocked:return ge.FILE_WRITE_LOCKED;case I.NoPermissions:return ge.FILE_PERMISSION_DENIED;case I.FileExists:return ge.FILE_MOVE_CONFLICT;case I.FileTooLarge:return ge.FILE_TOO_LARGE;default:return ge.FILE_OTHER_ERROR}}var L;(function(se){se[se.CREATE=0]="CREATE",se[se.DELETE=1]="DELETE",se[se.MOVE=2]="MOVE",se[se.COPY=3]="COPY",se[se.WRITE=4]="WRITE"})(L||(e.FileOperation=L={}));class N{constructor(Ie,Ue,Z){this.resource=Ie,this.operation=Ue,this.target=Z}isOperation(Ie){return this.operation===Ie}}e.$rl=N;var B;(function(se){se[se.UPDATED=0]="UPDATED",se[se.ADDED=1]="ADDED",se[se.DELETED=2]="DELETED"})(B||(e.FileChangeType=B={}));class G{static{this.a=null}constructor(Ie,Ue){this.c=Ue,this.b=void 0,this.d=new y.$X(()=>{const Z=w.$Li.forUris(()=>this.c);return Z.fill(this.rawAdded.map(V=>[V,!0])),Z}),this.f=new y.$X(()=>{const Z=w.$Li.forUris(()=>this.c);return Z.fill(this.rawUpdated.map(V=>[V,!0])),Z}),this.g=new y.$X(()=>{const Z=w.$Li.forUris(()=>this.c);return Z.fill(this.rawDeleted.map(V=>[V,!0])),Z}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const Z of Ie){switch(Z.type){case B.ADDED:this.rawAdded.push(Z.resource);break;case B.UPDATED:this.rawUpdated.push(Z.resource);break;case B.DELETED:this.rawDeleted.push(Z.resource);break}this.b!==G.a&&(typeof Z.cId=="number"?this.b===void 0?this.b=Z.cId:this.b!==Z.cId&&(this.b=G.a):this.b!==void 0&&(this.b=G.a))}}contains(Ie,...Ue){return this.h(Ie,{includeChildren:!1},...Ue)}affects(Ie,...Ue){return this.h(Ie,{includeChildren:!0},...Ue)}h(Ie,Ue,...Z){if(!Ie)return!1;const V=Z.length>0;return!!((!V||Z.includes(B.ADDED))&&(this.d.value.get(Ie)||Ue.includeChildren&&this.d.value.findSuperstr(Ie))||(!V||Z.includes(B.UPDATED))&&(this.f.value.get(Ie)||Ue.includeChildren&&this.f.value.findSuperstr(Ie))||(!V||Z.includes(B.DELETED))&&(this.g.value.findSubstr(Ie)||Ue.includeChildren&&this.g.value.findSuperstr(Ie)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(Ie){return this.b===Ie}hasCorrelation(){return typeof this.b=="number"}}e.$sl=G;function W(se,Ie,Ue){return!se||!Ie||se===Ie||Ie.length>se.length?!1:(Ie.charAt(Ie.length-1)!==S.sep&&(Ie+=S.sep),Ue?(0,k.$Hf)(se,Ie):se.indexOf(Ie)===0)}class F extends Error{constructor(Ie,Ue,Z){super(Ie),this.fileOperationResult=Ue,this.options=Z}}e.$ul=F;class q extends F{constructor(Ie,Ue,Z,V){super(Ie,Ue,V),this.fileOperationResult=Ue,this.size=Z}}e.$vl=q;class ue extends F{constructor(Ie,Ue,Z){super(Ie,ge.FILE_NOT_MODIFIED_SINCE,Z),this.stat=Ue}}e.$wl=ue;var ge;(function(se){se[se.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",se[se.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",se[se.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",se[se.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",se[se.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",se[se.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",se[se.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",se[se.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",se[se.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",se[se.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",se[se.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(ge||(e.FileOperationResult=ge={})),e.$xl={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$yl={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$zl="files.associations",e.$Al="files.exclude",e.$Bl="files.readonlyInclude",e.$Cl="files.readonlyExclude",e.$Dl="files.readonlyFromPermissions";var te;(function(se){se[se.FILE=0]="FILE",se[se.FOLDER=1]="FOLDER",se[se.ROOT_FOLDER=2]="ROOT_FOLDER"})(te||(e.FileKind=te={})),e.$El="";function me(se){if(!(typeof se.size!="number"||typeof se.mtime!="number"))return se.mtime.toString(29)+se.size.toString(31)}async function re(se,Ie){if(!Ie.hasProvider(A.URI.from({scheme:se.scheme})))return new Promise(Ue=>{const Z=Ie.onDidChangeFileSystemProviderRegistrations(V=>{V.scheme===se.scheme&&V.added&&(Z.dispose(),Ue())})})}class ce{static{this.KB=1024}static{this.MB=ce.KB*ce.KB}static{this.GB=ce.MB*ce.KB}static{this.TB=ce.GB*ce.KB}static formatSize(Ie){return(0,O.$jg)(Ie)||(Ie=0),Ie<ce.KB?(0,T.localize)(1,null,Ie.toFixed(0)):Ie<ce.MB?(0,T.localize)(2,null,(Ie/ce.KB).toFixed(2)):Ie<ce.GB?(0,T.localize)(3,null,(Ie/ce.MB).toFixed(2)):Ie<ce.TB?(0,T.localize)(4,null,(Ie/ce.GB).toFixed(2)):(0,T.localize)(5,null,(Ie/ce.TB).toFixed(2))}}e.$Hl=ce;function be(se){const Ie=typeof se=="string"||se?.scheme===R.Schemas.vscodeRemote;return typeof se!="string"&&se?.scheme===R.Schemas.file?1024*ce.MB:Ie?10*ce.MB:a.$o?50*ce.MB:1024*ce.MB}}),define(ke[75],Ce([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Di=void 0;class w{constructor(...k){this.a=new Map;for(const[O,A]of k)this.set(O,A)}set(k,O){const A=this.a.get(k);return this.a.set(k,O),A}has(k){return this.a.has(k)}get(k){return this.a.get(k)}}e.$Di=w}),define(ke[211],Ce([1,0,11,14,4,74,208,3,75,212]),function(oe,e,w,S,k,O,A,T,p,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qr=e.$pr=void 0;const R=!1;class y extends Error{constructor(s){super("cyclic dependency between services"),this.message=s.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${s.toString()}`}}class u{constructor(s=new p.$Di,o=!1,h,i=R){this.i=s,this.j=o,this.k=h,this.l=i,this.f=!1,this.g=new Set,this.h=new Set,this.t=new Set,this.i.set(T.$Ei,this),this._globalGraph=i?h?._globalGraph??new A.$or(r=>r):void 0}dispose(){if(!this.f){this.f=!0,(0,k.$Rc)(this.h),this.h.clear();for(const s of this.g)(0,k.$Qc)(s)&&s.dispose();this.g.clear()}}m(){if(this.f)throw new Error("InstantiationService has been disposed")}createChild(s,o){this.m();const h=this,i=new class extends u{dispose(){h.h.delete(i),super.dispose()}}(s,this.j,this,this.l);return this.h.add(i),o?.add(i),i}invokeFunction(s,...o){this.m();const h=d.traceInvocation(this.l,s);let i=!1;try{return s({get:t=>{if(i)throw(0,S.$0)("service accessor is only valid during the invocation of its target method");const c=this.s(t,h);if(!c)throw new Error(`[invokeFunction] unknown service '${t}'`);return c}},...o)}finally{i=!0,h.stop()}}createInstance(s,...o){this.m();let h,i;return s instanceof O.$Ci?(h=d.traceCreation(this.l,s.ctor),i=this.o(s.ctor,s.staticArguments.concat(o),h)):(h=d.traceCreation(this.l,s),i=this.o(s,o,h)),h.stop(),i}o(s,o=[],h){const i=T._util.getServiceDependencies(s).sort((c,l)=>c.index-l.index),r=[];for(const c of i){const l=this.s(c.id,h);l||this.y(`[createInstance] ${s.name} depends on UNKNOWN service ${c.id}.`,!1),r.push(l)}const t=i.length>0?i[0].index:o.length;if(o.length!==t){console.trace(`[createInstance] First service dependency of ${s.name} at position ${t+1} conflicts with ${o.length} static arguments`);const c=t-o.length;c>0?o=o.concat(new Array(c)):o=o.slice(0,t)}return Reflect.construct(s,o.concat(r))}q(s,o){if(this.i.get(s)instanceof O.$Ci)this.i.set(s,o);else if(this.k)this.k.q(s,o);else throw new Error("illegalState - setting UNKNOWN service instance")}r(s){const o=this.i.get(s);return!o&&this.k?this.k.r(s):o}s(s,o){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(s));const h=this.r(s);return h instanceof O.$Ci?this.u(s,h,o.branch(s,!0)):(o.branch(s,!1),h)}u(s,o,h){if(this.t.has(s))throw new Error(`illegal state - RECURSIVELY instantiating service '${s}'`);this.t.add(s);try{return this.v(s,o,h)}finally{this.t.delete(s)}}v(s,o,h){const i=new A.$or(c=>c.id.toString());let r=0;const t=[{id:s,desc:o,_trace:h}];for(;t.length;){const c=t.pop();if(i.lookupOrInsertNode(c),r++>1e3)throw new y(i);for(const l of T._util.getServiceDependencies(c.desc.ctor)){const m=this.r(l.id);if(m||this.y(`[createInstance] ${s} depends on ${l.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(c.id),String(l.id)),m instanceof O.$Ci){const f={id:l.id,desc:m,_trace:c._trace.branch(l.id,!0)};i.insertEdge(c,f),t.push(f)}}}for(;;){const c=i.roots();if(c.length===0){if(!i.isEmpty())throw new y(i);break}for(const{data:l}of c){if(this.r(l.id)instanceof O.$Ci){const f=this.w(l.id,l.desc.ctor,l.desc.staticArguments,l.desc.supportsDelayedInstantiation,l._trace);this.q(l.id,f)}i.removeNode(l)}}return this.r(s)}w(s,o,h=[],i,r){if(this.i.get(s)instanceof O.$Ci)return this.x(s,o,h,i,r,this.g);if(this.k)return this.k.w(s,o,h,i,r);throw new Error(`illegalState - creating UNKNOWN service instance ${o.name}`)}x(s,o,h=[],i,r,t){if(i){const c=new u(void 0,this.j,this,this.l);c.c=String(s);const l=new Map,m=new w.$Yh(()=>{const f=c.o(o,h,r);for(const[$,I]of l){const D=f[$];if(typeof D=="function")for(const v of I)v.disposable=D.apply(f,v.listener)}return l.clear(),t.add(f),f});return new Proxy(Object.create(null),{get(f,$){if(!m.isInitialized&&typeof $=="string"&&($.startsWith("onDid")||$.startsWith("onWill"))){let v=l.get($);return v||(v=new a.$7c,l.set($,v)),(P,g,b)=>{if(m.isInitialized)return m.value[$](P,g,b);{const L={listener:[P,g,b],disposable:void 0},N=v.push(L);return(0,k.$Uc)(()=>{N(),L.disposable?.dispose()})}}}if($ in f)return f[$];const I=m.value;let D=I[$];return typeof D!="function"||(D=D.bind(I),f[$]=D),D},set(f,$,I){return m.value[$]=I,!0},getPrototypeOf(f){return o.prototype}})}else{const c=this.o(o,h,r);return t.add(c),c}}y(s,o){if(o&&console.warn(s),this.j)throw new Error(s)}}e.$pr=u;var E;(function(n){n[n.None=0]="None",n[n.Creation=1]="Creation",n[n.Invocation=2]="Invocation",n[n.Branch=3]="Branch"})(E||(E={}));class d{static{this.all=new Set}static{this.c=new class extends d{constructor(){super(E.None,null)}stop(){}branch(){return this}}}static traceInvocation(s,o){return s?new d(E.Invocation,o.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):d.c}static traceCreation(s,o){return s?new d(E.Creation,o.name):d.c}static{this.f=0}constructor(s,o){this.type=s,this.name=o,this.g=Date.now(),this.h=[]}branch(s,o){const h=new d(E.Branch,s.toString());return this.h.push([s,o,h]),h}stop(){const s=Date.now()-this.g;d.f+=s;let o=!1;function h(r,t){const c=[],l=new Array(r+1).join("	");for(const[m,f,$]of t.h)if(f&&$){o=!0,c.push(`${l}CREATES -> ${m}`);const I=h(r+1,$);I&&c.push(I)}else c.push(`${l}uses -> ${m}`);return c.join(`
`)}const i=[`${this.type===E.Creation?"CREATE":"CALL"} ${this.name}`,`${h(1,this)}`,`DONE, took ${s.toFixed(2)}ms (grand total ${d.f.toFixed(2)}ms)`];(s>2||o)&&d.all.add(i.join(`
`))}}e.$qr=d}),define(ke[12],Ce([1,0,174,48,6,76,4,29,21,24,15,2,32,3]),function(oe,e,w,S,k,O,A,T,p,a,R,y,u,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rk=e.$mk=e.$lk=e.$kk=e.$jk=e.$ik=e.$hk=e.$gk=e.$fk=e.$ek=e.$ck=e.LogLevel=e.$ak=e.$_j=void 0,e.$bk=n,e.log=o,e.$nk=D,e.$ok=v,e.$pk=C,e.$qk=P,w=qe(w),e.$_j=(0,E.$Fi)("logService"),e.$ak=(0,E.$Fi)("loggerService");function d(){return new Date().toISOString()}function n(g){return(0,R.$jg)(g)}var s;(function(g){g[g.Off=0]="Off",g[g.Trace=1]="Trace",g[g.Debug=2]="Debug",g[g.Info=3]="Info",g[g.Warning=4]="Warning",g[g.Error=5]="Error"})(s||(e.LogLevel=s={})),e.$ck=s.Info;function o(g,b,L){switch(b){case s.Trace:g.trace(L);break;case s.Debug:g.debug(L);break;case s.Info:g.info(L);break;case s.Warning:g.warn(L);break;case s.Error:g.error(L);break;case s.Off:break;default:throw new Error(`Invalid log level ${b}`)}}function h(g,b=!1){let L="";for(let N=0;N<g.length;N++){let B=g[N];if(B instanceof Error&&(B=(0,S.$qj)(B,b)),typeof B=="object")try{B=JSON.stringify(B)}catch{}L+=(N>0?" ":"")+B}return L}class i extends A.$Wc{constructor(){super(...arguments),this.b=e.$ck,this.c=this.B(new k.$me),this.onDidChangeLogLevel=this.c.event}setLevel(b){this.b!==b&&(this.b=b,this.c.fire(this.b))}getLevel(){return this.b}f(b){return this.b!==s.Off&&this.b<=b}}e.$ek=i;class r extends i{constructor(b){super(),this.h=b}f(b){return this.h||super.f(b)}trace(b,...L){this.f(s.Trace)&&this.g(s.Trace,h([b,...L],!0))}debug(b,...L){this.f(s.Debug)&&this.g(s.Debug,h([b,...L]))}info(b,...L){this.f(s.Info)&&this.g(s.Info,h([b,...L]))}warn(b,...L){this.f(s.Warning)&&this.g(s.Warning,h([b,...L]))}error(b,...L){if(this.f(s.Error))if(b instanceof Error){const N=Array.prototype.slice.call(arguments);N[0]=b.stack,this.g(s.Error,h(N))}else this.g(s.Error,h([b,...L]))}flush(){}}e.$fk=r;class t extends i{constructor(b=e.$ck){super(),this.setLevel(b),this.g=!p.$i}trace(b,...L){this.f(s.Trace)&&(this.g?console.log(`\x1B[90m[main ${d()}]\x1B[0m`,b,...L):console.log(`[main ${d()}]`,b,...L))}debug(b,...L){this.f(s.Debug)&&(this.g?console.log(`\x1B[90m[main ${d()}]\x1B[0m`,b,...L):console.log(`[main ${d()}]`,b,...L))}info(b,...L){this.f(s.Info)&&(this.g?console.log(`\x1B[90m[main ${d()}]\x1B[0m`,b,...L):console.log(`[main ${d()}]`,b,...L))}warn(b,...L){this.f(s.Warning)&&(this.g?console.warn(`\x1B[93m[main ${d()}]\x1B[0m`,b,...L):console.warn(`[main ${d()}]`,b,...L))}error(b,...L){this.f(s.Error)&&(this.g?console.error(`\x1B[91m[main ${d()}]\x1B[0m`,b,...L):console.error(`[main ${d()}]`,b,...L))}flush(){}}e.$gk=t;class c extends i{constructor(b=e.$ck,L=!0){super(),this.g=L,this.setLevel(b)}trace(b,...L){this.f(s.Trace)&&(this.g?console.log("%cTRACE","color: #888",b,...L):console.log(b,...L))}debug(b,...L){this.f(s.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",b,...L):console.log(b,...L))}info(b,...L){this.f(s.Info)&&(this.g?console.log("%c INFO","color: #33f",b,...L):console.log(b,...L))}warn(b,...L){this.f(s.Warning)&&(this.g?console.log("%c WARN","color: #993",b,...L):console.log(b,...L))}error(b,...L){this.f(s.Error)&&(this.g?console.log("%c  ERR","color: #f33",b,...L):console.error(b,...L))}flush(){}}e.$hk=c;class l extends i{constructor(b,L=e.$ck){super(),this.g=b,this.setLevel(L)}trace(b,...L){this.f(s.Trace)&&this.g.log(s.Trace,[this.h(b),...L])}debug(b,...L){this.f(s.Debug)&&this.g.log(s.Debug,[this.h(b),...L])}info(b,...L){this.f(s.Info)&&this.g.log(s.Info,[this.h(b),...L])}warn(b,...L){this.f(s.Warning)&&this.g.log(s.Warning,[this.h(b),...L])}error(b,...L){this.f(s.Error)&&this.g.log(s.Error,[this.h(b),...L])}h(b){return typeof b=="string"?b:(0,S.$qj)(b,this.f(s.Trace))}flush(){}}e.$ik=l;class m extends i{constructor(b){super(),this.g=b,b.length&&this.setLevel(b[0].getLevel())}setLevel(b){for(const L of this.g)L.setLevel(b);super.setLevel(b)}trace(b,...L){for(const N of this.g)N.trace(b,...L)}debug(b,...L){for(const N of this.g)N.debug(b,...L)}info(b,...L){for(const N of this.g)N.info(b,...L)}warn(b,...L){for(const N of this.g)N.warn(b,...L)}error(b,...L){for(const N of this.g)N.error(b,...L)}flush(){for(const b of this.g)b.flush()}dispose(){for(const b of this.g)b.dispose();super.dispose()}}e.$jk=m;class f extends A.$Wc{constructor(b,L,N){if(super(),this.h=b,this.j=L,this.b=new T.$Cc,this.c=this.B(new k.$me),this.onDidChangeLoggers=this.c.event,this.f=this.B(new k.$me),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new k.$me),this.onDidChangeVisibility=this.g.event,N)for(const B of N)this.b.set(B.resource,{logger:void 0,info:B})}m(b){return(0,R.$fg)(b)?[...this.b.values()].find(L=>L.info.id===b):this.b.get(b)}getLogger(b){return this.m(b)?.logger}createLogger(b,L){const N=this.n(b),B=(0,R.$fg)(b)?b:L?.id??(0,O.$tj)(N.toString()).toString(16);let G=this.b.get(N)?.logger;const W=L?.logLevel==="always"?s.Trace:L?.logLevel;G||(G=this.s(N,W??this.getLogLevel(N)??this.h,{...L,id:B}));const F={logger:G,info:{resource:N,id:B,logLevel:W,name:L?.name,hidden:L?.hidden,extensionId:L?.extensionId,when:L?.when}};return this.registerLogger(F.info),this.b.set(N,F),G}n(b){return(0,R.$fg)(b)?(0,a.$gh)(this.j,`${b}.log`):b}setLogLevel(b,L){if(y.URI.isUri(b)){const N=b,B=L,G=this.b.get(N);G&&B!==G.info.logLevel&&(G.info.logLevel=B===this.h?void 0:B,G.logger?.setLevel(B),this.b.set(G.info.resource,G),this.f.fire([N,B]))}else{this.h=b;for(const[N,B]of this.b.entries())this.b.get(N)?.info.logLevel===void 0&&B.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(b,L){const N=this.m(b);N&&L!==!N.info.hidden&&(N.info.hidden=!L,this.b.set(N.info.resource,N),this.g.fire([N.info.resource,L]))}getLogLevel(b){let L;return b&&(L=this.b.get(b)?.info.logLevel),L??this.h}registerLogger(b){const L=this.b.get(b.resource);L?L.info.hidden!==b.hidden&&this.setVisibility(b.resource,!b.hidden):(this.b.set(b.resource,{info:b,logger:void 0}),this.c.fire({added:[b],removed:[]}))}deregisterLogger(b){const L=this.b.get(b);L&&(L.logger&&L.logger.dispose(),this.b.delete(b),this.c.fire({added:[],removed:[L.info]}))}*getRegisteredLoggers(){for(const b of this.b.values())yield b.info}getRegisteredLogger(b){return this.b.get(b)?.info}dispose(){this.b.forEach(b=>b.logger?.dispose()),this.b.clear(),super.dispose()}}e.$kk=f;class ${constructor(){this.onDidChangeLogLevel=new k.$me().event}setLevel(b){}getLevel(){return s.Info}trace(b,...L){}debug(b,...L){}info(b,...L){}warn(b,...L){}error(b,...L){}critical(b,...L){}dispose(){}flush(){}}e.$lk=$;class I extends ${}e.$mk=I;function D(g){if(g.verbose)return s.Trace;if(typeof g.logLevel=="string"){const b=P(g.logLevel.toLowerCase());if(b!==void 0)return b}return e.$ck}function v(g){switch(g){case s.Trace:return"trace";case s.Debug:return"debug";case s.Info:return"info";case s.Warning:return"warn";case s.Error:return"error";case s.Off:return"off"}}function C(g){switch(g){case s.Trace:return{original:"Trace",value:w.localize(0,null)};case s.Debug:return{original:"Debug",value:w.localize(1,null)};case s.Info:return{original:"Info",value:w.localize(2,null)};case s.Warning:return{original:"Warning",value:w.localize(3,null)};case s.Error:return{original:"Error",value:w.localize(4,null)};case s.Off:return{original:"Off",value:w.localize(5,null)}}}function P(g){switch(g){case"trace":return s.Trace;case"debug":return s.Debug;case"info":return s.Info;case"warn":return s.Warning;case"error":return s.Error;case"critical":return s.Error;case"off":return s.Off}}e.$rk=new u.$Wj("logLevel",v(s.Info))}),define(ke[213],Ce([1,0,4,12]),function(oe,e,w,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lR=void 0;class k extends w.$Wc{constructor(A,T=[]){super(),this.a=new S.$jk([A,...T]),this.B(A.onDidChangeLogLevel(p=>this.setLevel(p)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(A){this.a.setLevel(A)}getLevel(){return this.a.getLevel()}trace(A,...T){this.a.trace(A,...T)}debug(A,...T){this.a.debug(A,...T)}info(A,...T){this.a.info(A,...T)}warn(A,...T){this.a.warn(A,...T)}error(A,...T){this.a.error(A,...T)}flush(){this.a.flush()}}e.$lR=k});var ti=this&&this.__importDefault||function(oe){return oe&&oe.__esModule?oe:{default:oe}};define(ke[107],Ce([1,0,36,175,3]),function(oe,e,w,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yu=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0,w=ti(w);var O;(function(p){p[p.Unnecessary=1]="Unnecessary",p[p.Deprecated=2]="Deprecated"})(O||(e.MarkerTag=O={}));var A;(function(p){p[p.Hint=1]="Hint",p[p.Info=2]="Info",p[p.Warning=4]="Warning",p[p.Error=8]="Error"})(A||(e.MarkerSeverity=A={})),function(p){function a(d,n){return n-d}p.compare=a;const R=Object.create(null);R[p.Error]=(0,S.localize)(0,null),R[p.Warning]=(0,S.localize)(1,null),R[p.Info]=(0,S.localize)(2,null);function y(d){return R[d]||""}p.toString=y;function u(d){switch(d){case w.default.Error:return p.Error;case w.default.Warning:return p.Warning;case w.default.Info:return p.Info;case w.default.Ignore:return p.Hint}}p.fromSeverity=u;function E(d){switch(d){case p.Error:return w.default.Error;case p.Warning:return w.default.Warning;case p.Info:return w.default.Info;case p.Hint:return w.default.Ignore}}p.toSeverity=E}(A||(e.MarkerSeverity=A={}));var T;(function(p){const a="";function R(u){return y(u,!0)}p.makeKey=R;function y(u,E){const d=[a];return u.source?d.push(u.source.replace("\xA6","\\\xA6")):d.push(a),u.code?typeof u.code=="string"?d.push(u.code.replace("\xA6","\\\xA6")):d.push(u.code.value.replace("\xA6","\\\xA6")):d.push(a),u.severity!==void 0&&u.severity!==null?d.push(A.toString(u.severity)):d.push(a),u.message&&E?d.push(u.message.replace("\xA6","\\\xA6")):d.push(a),u.startLineNumber!==void 0&&u.startLineNumber!==null?d.push(u.startLineNumber.toString()):d.push(a),u.startColumn!==void 0&&u.startColumn!==null?d.push(u.startColumn.toString()):d.push(a),u.endLineNumber!==void 0&&u.endLineNumber!==null?d.push(u.endLineNumber.toString()):d.push(a),u.endColumn!==void 0&&u.endColumn!==null?d.push(u.endColumn.toString()):d.push(a),d.push(a),d.join("\xA6")}p.makeKeyOptionalMessage=y})(T||(e.IMarkerData=T={})),e.$yu=(0,k.$Fi)("markerService")});var ti=this&&this.__importDefault||function(oe){return oe&&oe.__esModule?oe:{default:oe}};define(ke[214],Ce([1,0,6,36,3]),function(oe,e,w,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ow=e.$nw=e.NotificationsFilter=e.NeverShowAgainScope=e.NotificationPriority=e.$lw=e.Severity=void 0,e.$mw=T,S=ti(S),e.Severity=S.default,e.$lw=(0,k.$Fi)("notificationService");var O;(function(y){y[y.DEFAULT=0]="DEFAULT",y[y.SILENT=1]="SILENT",y[y.URGENT=2]="URGENT"})(O||(e.NotificationPriority=O={}));var A;(function(y){y[y.WORKSPACE=0]="WORKSPACE",y[y.PROFILE=1]="PROFILE",y[y.APPLICATION=2]="APPLICATION"})(A||(e.NeverShowAgainScope=A={}));function T(y){if(y){const u=y;return typeof u.id=="string"&&typeof u.label=="string"}return!1}var p;(function(y){y[y.OFF=0]="OFF",y[y.ERROR=1]="ERROR"})(p||(e.NotificationsFilter=p={}));class a{constructor(){this.progress=new R,this.onDidClose=w.Event.None,this.onDidChangeVisibility=w.Event.None}updateSeverity(u){}updateMessage(u){}updateActions(u){}close(){}}e.$nw=a;class R{infinite(){}done(){}total(u){}worked(u){}}e.$ow=R}),define(ke[108],Ce([1,0,3]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tk=e.$sk=void 0,e.$sk=(0,w.$Fi)("productService"),e.$tk="vscode://schemas/vscode-product"});var He=this&&this.__decorate||function(oe,e,w,S){var k=arguments.length,O=k<3?e:S===null?S=Object.getOwnPropertyDescriptor(e,w):S,A;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")O=Reflect.decorate(oe,e,w,S);else for(var T=oe.length-1;T>=0;T--)(A=oe[T])&&(O=(k<3?A(O):k>3?A(e,w,O):A(e,w))||O);return k>3&&O&&Object.defineProperty(e,w,O),O},Ve=this&&this.__param||function(oe,e){return function(w,S){e(w,S,oe)}};define(ke[77],Ce([1,0,11,22,4,3]),function(oe,e,w,S,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vw=e.$uw=e.$tw=e.$sw=e.$rw=e.$qw=e.ProgressLocation=e.$pw=void 0,e.$pw=(0,O.$Fi)("progressService");var A;(function(y){y[y.Explorer=1]="Explorer",y[y.Scm=3]="Scm",y[y.Extensions=5]="Extensions",y[y.Window=10]="Window",y[y.Notification=15]="Notification",y[y.Dialog=20]="Dialog"})(A||(e.ProgressLocation=A={})),e.$qw=Object.freeze({total(){},worked(){},done(){}});class T{static{this.None=Object.freeze({report(){}})}get value(){return this.a}constructor(u){this.b=u}report(u){this.a=u,this.b(this.a)}}e.$rw=T;class p{get value(){return this.a}constructor(u){this.e=u}report(u){this.b?this.b.push(u):this.b=[u],this.f()}async f(){if(!this.c)try{for(this.c=!0;this.b&&this.b.length;){const u=this.b.shift();this.a=u,await this.e(this.a)}}finally{this.c=!1;const u=this.d;this.d=void 0,u?.()}}drain(){return this.c?new Promise(u=>{const E=this.d;this.d=()=>{E?.(),u()}}):Promise.resolve()}}e.$sw=p;let a=class extends k.$Wc{constructor(u,E){super(),this.a=new w.$3h,E.withProgress(u,d=>(this.b=d,this.c&&d.report(this.c),this.a.p)),this.B((0,k.$Uc)(()=>this.a.complete()))}report(u){this.b?this.b.report(u):this.c=u}};e.$tw=a,e.$tw=a=He([Ve(1,e.$pw)],a);class R extends k.$Wc{constructor(u){super(),this.g=u,this.a=0,this.b=this.B(new k.$Vc)}start(u){this.stop();const E=++this.a,d=new S.$xe;return this.f=setTimeout(()=>{E===this.a&&(this.c=this.g.show(!0))},u),this.b.add((0,k.$Uc)(()=>clearTimeout(this.f))),this.b.add((0,k.$Uc)(()=>d.cancel())),this.b.add((0,k.$Uc)(()=>this.c?this.c.done():void 0)),{id:E,token:d.token,stop:()=>this.h(E),isCurrent:()=>this.a===E}}stop(){this.h(this.a)}h(u){this.a===u&&this.b.clear()}}e.$uw=R,e.$vw=(0,O.$Fi)("editorProgressService")}),define(ke[31],Ce([1,0,62,15]),function(oe,e,w,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oo=void 0,w=qe(w),S=qe(S);class k{constructor(){this.a=new Map}add(A,T){w.ok(S.$fg(A)),w.ok(S.$hg(T)),w.ok(!this.a.has(A),"There is already an extension with this id"),this.a.set(A,T)}knows(A){return this.a.has(A)}as(A){return this.a.get(A)||null}}e.$oo=new k}),define(ke[78],Ce([1,0,6,31]),function(oe,e,w,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$po=void 0,S=qe(S),e.$po={JSONContribution:"base.contributions.json"};function k(T){return T.length>0&&T.charAt(T.length-1)==="#"?T.substring(0,T.length-1):T}class O{constructor(){this.b=new w.$me,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(p,a){this.a[k(p)]=a,this.b.fire(p)}notifySchemaChanged(p){this.b.fire(p)}getSchemaContributions(){return{schemas:this.a}}}const A=new O;S.$oo.add(e.$po.JSONContribution,A)}),define(ke[54],Ce([1,0,18,6,15,168,42,78,31]),function(oe,e,w,S,k,O,A,T,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Do=e.$Co=e.$Bo=e.$Ao=e.$zo=e.$yo=e.$xo=e.$wo=e.$vo=e.$uo=e.ConfigurationScope=e.$to=e.EditPresentationTypes=void 0,e.$Eo=n,e.$Fo=s,e.$Go=o,e.$Ho=i,e.$Io=r,k=qe(k),O=qe(O);var a;(function(t){t.Multiline="multilineText",t.Singleline="singlelineText"})(a||(e.EditPresentationTypes=a={})),e.$to={Configuration:"base.contributions.configuration"};var R;(function(t){t[t.APPLICATION=1]="APPLICATION",t[t.MACHINE=2]="MACHINE",t[t.WINDOW=3]="WINDOW",t[t.RESOURCE=4]="RESOURCE",t[t.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",t[t.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(R||(e.ConfigurationScope=R={})),e.$uo={properties:{},patternProperties:{}},e.$vo={properties:{},patternProperties:{}},e.$wo={properties:{},patternProperties:{}},e.$xo={properties:{},patternProperties:{}},e.$yo={properties:{},patternProperties:{}},e.$zo={properties:{},patternProperties:{}},e.$Ao="vscode://schemas/settings/resourceLanguage",e.$Bo="vscode://schemas/settings/configurationDefaults";const y=p.$oo.as(T.$po.JSONContribution);class u{constructor(){this.h=new Set,this.i=new S.$me,this.onDidSchemaChange=this.i.event,this.j=new S.$me,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:O.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},y.registerSchema(e.$Ao,this.g),this.v()}registerConfiguration(c,l=!0){this.registerConfigurations([c],l)}registerConfigurations(c,l=!0){const m=new Set;this.n(c,l,m),y.registerSchema(e.$Ao,this.g),this.i.fire(),this.j.fire({properties:m})}deregisterConfigurations(c){const l=new Set;this.o(c,l),y.registerSchema(e.$Ao,this.g),this.i.fire(),this.j.fire({properties:l})}updateConfigurations({add:c,remove:l}){const m=new Set;this.o(l,m),this.n(c,!1,m),y.registerSchema(e.$Ao,this.g),this.i.fire(),this.j.fire({properties:m})}registerDefaultConfigurations(c){const l=new Set;this.k(c,l),this.i.fire(),this.j.fire({properties:l,defaultsOverrides:!0})}k(c,l){const m=[];for(const{overrides:f,source:$}of c)for(const I in f)if(l.add(I),e.$Do.test(I)){const D=this.a.get(I),v=D?.valuesSources??new Map;if($)for(const b of Object.keys(f[I]))v.set(b,$);const C={...D?.value||{},...f[I]};this.a.set(I,{source:$,value:C,valuesSources:v});const P=(0,A.$jj)(I),g={type:"object",default:C,description:O.localize(1,null,P),$ref:e.$Ao,defaultDefaultValue:C,source:k.$fg($)?void 0:$,defaultValueSource:$};m.push(...n(I)),this.d[I]=g,this.b.properties[I]=g}else{this.a.set(I,{value:f[I],source:$});const D=this.d[I];D&&(this.w(I,D),this.r(I,D))}this.m(m)}deregisterDefaultConfigurations(c){const l=new Set;this.l(c,l),this.i.fire(),this.j.fire({properties:l,defaultsOverrides:!0})}l(c,l){for(const{overrides:m,source:f}of c)for(const $ in m){const I=this.a.get($),D=k.$fg(f)?f:f?.id,v=k.$fg(I?.source)?I?.source:I?.source?.id;if(D===v)if(l.add($),this.a.delete($),e.$Do.test($))delete this.d[$],delete this.b.properties[$];else{const C=this.d[$];C&&(this.w($,C),this.r($,C))}}this.u()}deltaConfiguration(c){let l=!1;const m=new Set;c.removedDefaults&&(this.l(c.removedDefaults,m),l=!0),c.addedDefaults&&(this.k(c.addedDefaults,m),l=!0),c.removedConfigurations&&this.o(c.removedConfigurations,m),c.addedConfigurations&&this.n(c.addedConfigurations,!1,m),this.i.fire(),this.j.fire({properties:m,defaultsOverrides:l})}notifyConfigurationSchemaUpdated(...c){this.i.fire()}registerOverrideIdentifiers(c){this.m(c),this.i.fire()}m(c){for(const l of c)this.h.add(l);this.u()}n(c,l,m){c.forEach(f=>{this.p(f,l,f.extensionInfo,f.restrictedProperties,void 0,m),this.c.push(f),this.q(f)})}o(c,l){const m=f=>{if(f.properties)for(const $ in f.properties){l.add($);const I=this.d[$];I?.policy?.name&&this.e.delete(I.policy.name),delete this.d[$],this.s($,f.properties[$])}f.allOf?.forEach($=>m($))};for(const f of c){m(f);const $=this.c.indexOf(f);$!==-1&&this.c.splice($,1)}}p(c,l=!0,m,f,$=R.WINDOW,I){$=k.$og(c.scope)?$:c.scope;const D=c.properties;if(D)for(const C in D){const P=D[C];if(l&&i(C,P)){delete D[C];continue}if(P.source=m,P.defaultDefaultValue=D[C].default,this.w(C,P),e.$Do.test(C)?P.scope=void 0:(P.scope=k.$og(P.scope)?$:P.scope,P.restricted=k.$og(P.restricted)?!!f?.includes(C):P.restricted),D[C].hasOwnProperty("included")&&!D[C].included){this.f[C]=D[C],delete D[C];continue}else this.d[C]=D[C],D[C].policy?.name&&this.e.set(D[C].policy.name,C);!D[C].deprecationMessage&&D[C].markdownDeprecationMessage&&(D[C].deprecationMessage=D[C].markdownDeprecationMessage),I.add(C)}const v=c.allOf;if(v)for(const C of v)this.p(C,l,m,f,$,I)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(c){const l=m=>{const f=m.properties;if(f)for(const I in f)this.r(I,f[I]);m.allOf?.forEach(l)};l(c)}r(c,l){switch(e.$uo.properties[c]=l,l.scope){case R.APPLICATION:e.$vo.properties[c]=l;break;case R.MACHINE:e.$wo.properties[c]=l;break;case R.MACHINE_OVERRIDABLE:e.$xo.properties[c]=l;break;case R.WINDOW:e.$yo.properties[c]=l;break;case R.RESOURCE:e.$zo.properties[c]=l;break;case R.LANGUAGE_OVERRIDABLE:e.$zo.properties[c]=l,this.g.properties[c]=l;break}}s(c,l){switch(delete e.$uo.properties[c],l.scope){case R.APPLICATION:delete e.$vo.properties[c];break;case R.MACHINE:delete e.$wo.properties[c];break;case R.MACHINE_OVERRIDABLE:delete e.$xo.properties[c];break;case R.WINDOW:delete e.$yo.properties[c];break;case R.RESOURCE:case R.LANGUAGE_OVERRIDABLE:delete e.$zo.properties[c],delete this.g.properties[c];break}}u(){for(const c of this.h.values()){const l=`[${c}]`,m={type:"object",description:O.localize(2,null),errorMessage:O.localize(3,null),$ref:e.$Ao};this.w(l,m),e.$uo.properties[l]=m,e.$vo.properties[l]=m,e.$wo.properties[l]=m,e.$xo.properties[l]=m,e.$yo.properties[l]=m,e.$zo.properties[l]=m}}v(){const c={type:"object",description:O.localize(4,null),errorMessage:O.localize(5,null),$ref:e.$Ao};e.$uo.patternProperties[e.$Co]=c,e.$vo.patternProperties[e.$Co]=c,e.$wo.patternProperties[e.$Co]=c,e.$xo.patternProperties[e.$Co]=c,e.$yo.patternProperties[e.$Co]=c,e.$zo.patternProperties[e.$Co]=c,this.i.fire()}w(c,l){const m=this.a.get(c);let f=m?.value,$=m?.source;k.$mg(f)&&(f=l.defaultDefaultValue,$=void 0),k.$mg(f)&&(f=o(l.type)),l.default=f,l.defaultValueSource=$}}const E="\\[([^\\]]+)\\]",d=new RegExp(E,"g");e.$Co=`^(${E})+$`,e.$Do=new RegExp(e.$Co);function n(t){const c=[];if(e.$Do.test(t)){let l=d.exec(t);for(;l?.length;){const m=l[1].trim();m&&c.push(m),l=d.exec(t)}}return(0,w.$Ob)(c)}function s(t){return t.reduce((c,l)=>`${c}[${l}]`,"")}function o(t){switch(Array.isArray(t)?t[0]:t){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}const h=new u;p.$oo.add(e.$to.Configuration,h);function i(t,c){return t.trim()?e.$Do.test(t)?O.localize(7,null,t):h.getConfigurationProperties()[t]!==void 0?O.localize(8,null,t):c.policy?.name&&h.getPolicyConfigurations().get(c.policy?.name)!==void 0?O.localize(9,null,t,c.policy?.name,h.getPolicyConfigurations().get(c.policy?.name)):null:O.localize(6,null)}function r(){const t=[],c=h.getConfigurationProperties();for(const l of Object.keys(c))t.push([l,c[l].scope]);return t.push(["launch",R.RESOURCE]),t.push(["task",R.RESOURCE]),t}}),define(ke[215],Ce([1,0,18,6,135,4,29,26,15,2,42,54,30,31]),function(oe,e,w,S,k,O,A,T,p,a,R,y,u,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oo=e.$Mo=e.$Lo=e.$Ko=e.$Jo=void 0,e.$No=r,w=qe(w),k=qe(k),T=qe(T),p=qe(p);function d(m){return Object.isFrozen(m)?m:T.$co(m)}class n{static createEmptyModel(f){return new n({},[],[],void 0,f)}constructor(f,$,I,D,v){this.b=f,this.c=$,this.d=I,this.raw=D,this.f=v,this.a=new Map}get rawConfiguration(){if(!this.g)if(this.raw?.length){const f=this.raw.map($=>{if($ instanceof n)return $;const I=new s("",this.f);return I.parseRaw($),I.configurationModel});this.g=f.reduce(($,I)=>I===$?I:$.merge(I),f[0])}else this.g=this;return this.g}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(f){return f?(0,R.$hj)(this.contents,f):this.contents}inspect(f,$){const I=this;return{get value(){return d(I.rawConfiguration.getValue(f))},get override(){return $?d(I.rawConfiguration.getOverrideValue(f,$)):void 0},get merged(){return d($?I.rawConfiguration.override($).getValue(f):I.rawConfiguration.getValue(f))},get overrides(){const D=[];for(const{contents:v,identifiers:C,keys:P}of I.rawConfiguration.overrides){const g=new n(v,P,[],void 0,I.f).getValue(f);g!==void 0&&D.push({identifiers:C,value:g})}return D.length?d(D):void 0}}}getOverrideValue(f,$){const I=this.j($);return I?f?(0,R.$hj)(I,f):I:void 0}getKeysForOverrideIdentifier(f){const $=[];for(const I of this.overrides)I.identifiers.includes(f)&&$.push(...I.keys);return w.$Ob($)}getAllOverrideIdentifiers(){const f=[];for(const $ of this.overrides)f.push(...$.identifiers);return w.$Ob(f)}override(f){let $=this.a.get(f);return $||($=this.h(f),this.a.set(f,$)),$}merge(...f){const $=T.$bo(this.contents),I=T.$bo(this.overrides),D=[...this.keys],v=this.raw?.length?[...this.raw]:[this];for(const C of f)if(v.push(...C.raw?.length?C.raw:[C]),!C.isEmpty()){this.i($,C.contents);for(const P of C.overrides){const[g]=I.filter(b=>w.$wb(b.identifiers,P.identifiers));g?(this.i(g.contents,P.contents),g.keys.push(...P.keys),g.keys=w.$Ob(g.keys)):I.push(T.$bo(P))}for(const P of C.keys)D.indexOf(P)===-1&&D.push(P)}return new n($,D,I,v.every(C=>C instanceof n)?void 0:v,this.f)}h(f){const $=this.j(f);if(!$||typeof $!="object"||!Object.keys($).length)return this;const I={};for(const D of w.$Ob([...Object.keys(this.contents),...Object.keys($)])){let v=this.contents[D];const C=$[D];C&&(typeof v=="object"&&typeof C=="object"?(v=T.$bo(v),this.i(v,C)):v=C),I[D]=v}return new n(I,this.keys,this.overrides,void 0,this.f)}i(f,$){for(const I of Object.keys($)){if(I in f&&p.$hg(f[I])&&p.$hg($[I])){this.i(f[I],$[I]);continue}f[I]=T.$bo($[I])}}j(f){let $=null,I=null;const D=v=>{v&&(I?this.i(I,v):I=T.$bo(v))};for(const v of this.overrides)v.identifiers.length===1&&v.identifiers[0]===f?$=v.contents:v.identifiers.includes(f)&&D(v.contents);return D($),I}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(f,$){this.k(f,$,!0)}setValue(f,$){this.k(f,$,!1)}removeValue(f){const $=this.keys.indexOf(f);$!==-1&&(this.keys.splice($,1),(0,R.$gj)(this.contents,f),y.$Do.test(f)&&this.overrides.splice(this.overrides.findIndex(I=>w.$wb(I.identifiers,(0,y.$Eo)(f))),1))}k(f,$,I){(0,R.$fj)(this.contents,f,$,D=>this.f.error(D)),I=I||this.keys.indexOf(f)===-1,I&&this.keys.push(f),y.$Do.test(f)&&this.overrides.push({identifiers:(0,y.$Eo)(f),keys:Object.keys(this.contents[f]),contents:(0,R.$ej)(this.contents[f],D=>this.f.error(D))})}}e.$Jo=n;class s{constructor(f,$){this.f=f,this.g=$,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||n.createEmptyModel(this.g)}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(f,$){if(!p.$og(f)){const I=this.h(f);this.parseRaw(I,$)}}reparse(f){this.a&&this.parseRaw(this.a,f)}parseRaw(f,$){this.a=f;const{contents:I,keys:D,overrides:v,restricted:C,hasExcludedProperties:P}=this.i(f,$);this.b=new n(I,D,v,P?[f]:void 0,this.g),this.c=C||[]}h(f){let $={},I=null,D=[];const v=[],C=[];function P(b){Array.isArray(D)?D.push(b):I!==null&&(D[I]=b)}const g={onObjectBegin:()=>{const b={};P(b),v.push(D),D=b,I=null},onObjectProperty:b=>{I=b},onObjectEnd:()=>{D=v.pop()},onArrayBegin:()=>{const b=[];P(b),v.push(D),D=b,I=null},onArrayEnd:()=>{D=v.pop()},onLiteralValue:P,onError:(b,L,N)=>{C.push({error:b,offset:L,length:N})}};if(f)try{k.$3n(f,g),$=D[0]||{}}catch(b){this.g.error(`Error while parsing settings file ${this.f}: ${b}`),this.d=[b]}return $}i(f,$){const I=E.$oo.as(y.$to.Configuration).getConfigurationProperties(),D=this.j(f,I,!0,$);f=D.raw;const v=(0,R.$ej)(f,g=>this.g.error(`Conflict in settings file ${this.f}: ${g}`)),C=Object.keys(f),P=this.l(f,g=>this.g.error(`Conflict in settings file ${this.f}: ${g}`));return{contents:v,keys:C,overrides:P,restricted:D.restricted,hasExcludedProperties:D.hasExcludedProperties}}j(f,$,I,D){let v=!1;if(!D?.scopes&&!D?.skipRestricted&&!D?.exclude?.length)return{raw:f,restricted:[],hasExcludedProperties:v};const C={},P=[];for(const g in f)if(y.$Do.test(g)&&I){const b=this.j(f[g],$,!1,D);C[g]=b.raw,v=v||b.hasExcludedProperties,P.push(...b.restricted)}else{const b=$[g],L=b?typeof b.scope<"u"?b.scope:y.ConfigurationScope.WINDOW:void 0;b?.restricted&&P.push(g),!D.exclude?.includes(g)&&(D.include?.includes(g)||(L===void 0||D.scopes===void 0||D.scopes.includes(L))&&!(D.skipRestricted&&b?.restricted))?C[g]=f[g]:v=!0}return{raw:C,restricted:P,hasExcludedProperties:v}}l(f,$){const I=[];for(const D of Object.keys(f))if(y.$Do.test(D)){const v={};for(const C in f[D])v[C]=f[D][C];I.push({identifiers:(0,y.$Eo)(D),keys:Object.keys(v),contents:(0,R.$ej)(v,$)})}return I}}e.$Ko=s;class o extends O.$Wc{constructor(f,$,I,D,v){super(),this.c=f,this.f=$,this.g=D,this.h=v,this.b=this.B(new S.$me),this.onDidChange=this.b.event,this.a=new s(this.c.toString(),v),this.B(this.g.watch(I.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(S.Event.any(S.Event.filter(this.g.onDidFilesChange,C=>C.contains(this.c)),S.Event.filter(this.g.onDidRunOperation,C=>(C.isOperation(u.FileOperation.CREATE)||C.isOperation(u.FileOperation.COPY)||C.isOperation(u.FileOperation.DELETE)||C.isOperation(u.FileOperation.WRITE))&&I.isEqual(C.resource,f)))(()=>this.b.fire()))}async loadConfiguration(){try{const f=await this.g.readFile(this.c);return this.a.parse(f.value.toString()||"{}",this.f),this.a.configurationModel}catch{return n.createEmptyModel(this.h)}}reparse(f){return f&&(this.f=f),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$Lo=o;class h{constructor(f,$,I,D,v,C,P,g,b,L,N,B,G){this.a=f,this.b=$,this.c=I,this.overrideIdentifiers=D,this.d=v,this.f=C,this.g=P,this.h=g,this.i=b,this.j=L,this.k=N,this.l=B,this.m=G}get value(){return d(this.c)}n(f){return f?.value!==void 0||f?.override!==void 0||f?.overrides!==void 0?f:void 0}get q(){return this.p||(this.p=this.d.inspect(this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.n(this.q)}get s(){return this.r===void 0&&(this.r=this.f?this.f.inspect(this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.g.inspect(this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.n(this.u)}get w(){return this.v||(this.v=this.h.inspect(this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.n(this.w)}get y(){return this.x||(this.x=this.i.inspect(this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.n(this.y)}get A(){return this.z||(this.z=this.j.inspect(this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.n(this.A)}get D(){return this.B===void 0&&(this.B=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.n(this.D)}get F(){return this.E===void 0&&(this.E=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.n(this.F)}get H(){return this.G===void 0&&(this.G=this.m.inspect(this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.n(this.H)}}class i{constructor(f,$,I,D,v,C,P,g,b,L){this.j=f,this.l=$,this.m=I,this.n=D,this.p=v,this.q=C,this.r=P,this.s=g,this.t=b,this.u=L,this.h=null,this.i=new A.$Cc,this.v=null}getValue(f,$,I){return this.w(f,$,I).getValue(f)}updateValue(f,$,I={}){let D;I.resource?(D=this.t.get(I.resource),D||(D=n.createEmptyModel(this.u),this.t.set(I.resource,D))):D=this.s,$===void 0?D.removeValue(f):D.setValue(f,$),I.resource||(this.h=null)}inspect(f,$,I){const D=this.w(f,$,I),v=this.A($.resource,I),C=$.resource?this.t.get($.resource)||this.s:this.s,P=new Set;for(const g of D.overrides)for(const b of g.identifiers)D.getOverrideValue(f,b)!==void 0&&P.add(b);return new h(f,$,D.getValue(f),P.size?[...P]:void 0,this.j,this.l.isEmpty()?void 0:this.l,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,I?this.q:void 0,v||void 0,C)}keys(f){const $=this.A(void 0,f);return{default:this.j.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.q.keys.slice(0),workspaceFolder:$?$.keys.slice(0):[]}}updateDefaultConfiguration(f){this.j=f,this.h=null,this.i.clear()}updatePolicyConfiguration(f){this.l=f}updateApplicationConfiguration(f){this.m=f,this.h=null,this.i.clear()}updateLocalUserConfiguration(f){this.n=f,this.v=null,this.h=null,this.i.clear()}updateRemoteUserConfiguration(f){this.p=f,this.v=null,this.h=null,this.i.clear()}updateWorkspaceConfiguration(f){this.q=f,this.h=null,this.i.clear()}updateFolderConfiguration(f,$){this.r.set(f,$),this.i.delete(f)}deleteFolderConfiguration(f){this.folderConfigurations.delete(f),this.i.delete(f)}compareAndUpdateDefaultConfiguration(f,$){const I=[];if(!$){const{added:D,updated:v,removed:C}=c(this.j,f);$=[...D,...v,...C]}for(const D of $)for(const v of(0,y.$Eo)(D)){const C=this.j.getKeysForOverrideIdentifier(v),P=f.getKeysForOverrideIdentifier(v),g=[...P.filter(b=>C.indexOf(b)===-1),...C.filter(b=>P.indexOf(b)===-1),...C.filter(b=>!T.$fo(this.j.override(v).getValue(b),f.override(v).getValue(b)))];I.push([v,g])}return this.updateDefaultConfiguration(f),{keys:$,overrides:I}}compareAndUpdatePolicyConfiguration(f){const{added:$,updated:I,removed:D}=c(this.l,f),v=[...$,...I,...D];return v.length&&this.updatePolicyConfiguration(f),{keys:v,overrides:[]}}compareAndUpdateApplicationConfiguration(f){const{added:$,updated:I,removed:D,overrides:v}=c(this.applicationConfiguration,f),C=[...$,...I,...D];return C.length&&this.updateApplicationConfiguration(f),{keys:C,overrides:v}}compareAndUpdateLocalUserConfiguration(f){const{added:$,updated:I,removed:D,overrides:v}=c(this.localUserConfiguration,f),C=[...$,...I,...D];return C.length&&this.updateLocalUserConfiguration(f),{keys:C,overrides:v}}compareAndUpdateRemoteUserConfiguration(f){const{added:$,updated:I,removed:D,overrides:v}=c(this.remoteUserConfiguration,f),C=[...$,...I,...D];return C.length&&this.updateRemoteUserConfiguration(f),{keys:C,overrides:v}}compareAndUpdateWorkspaceConfiguration(f){const{added:$,updated:I,removed:D,overrides:v}=c(this.workspaceConfiguration,f),C=[...$,...I,...D];return C.length&&this.updateWorkspaceConfiguration(f),{keys:C,overrides:v}}compareAndUpdateFolderConfiguration(f,$){const I=this.folderConfigurations.get(f),{added:D,updated:v,removed:C,overrides:P}=c(I,$),g=[...D,...v,...C];return(g.length||!I)&&this.updateFolderConfiguration(f,$),{keys:g,overrides:P}}compareAndDeleteFolderConfiguration(f){const $=this.folderConfigurations.get(f);if(!$)throw new Error("Unknown folder");this.deleteFolderConfiguration(f);const{added:I,updated:D,removed:v,overrides:C}=c($,void 0);return{keys:[...I,...D,...v],overrides:C}}get defaults(){return this.j}get applicationConfiguration(){return this.m}get userConfiguration(){return this.v||(this.v=this.p.isEmpty()?this.n:this.n.merge(this.p)),this.v}get localUserConfiguration(){return this.n}get remoteUserConfiguration(){return this.p}get workspaceConfiguration(){return this.q}get folderConfigurations(){return this.r}w(f,$,I){let D=this.x($,I);return $.overrideIdentifier&&(D=D.override($.overrideIdentifier)),!this.l.isEmpty()&&this.l.getValue(f)!==void 0&&(D=D.merge(this.l)),D}x({resource:f},$){let I=this.y();if($&&f){const D=$.getFolder(f);D&&(I=this.z(D.uri)||I);const v=this.t.get(f);v&&(I=I.merge(v))}return I}y(){return this.h||(this.h=this.j.merge(this.applicationConfiguration,this.userConfiguration,this.q,this.s)),this.h}z(f){let $=this.i.get(f);if(!$){const I=this.y(),D=this.r.get(f);D?($=I.merge(D),this.i.set(f,$)):$=I}return $}A(f,$){if($&&f){const I=$.getFolder(f);if(I)return this.r.get(I.uri)}}toData(){return{defaults:{contents:this.j.contents,overrides:this.j.overrides,keys:this.j.keys},policy:{contents:this.l.contents,overrides:this.l.overrides,keys:this.l.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.q.contents,overrides:this.q.overrides,keys:this.q.keys},folders:[...this.r.keys()].reduce((f,$)=>{const{contents:I,overrides:D,keys:v}=this.r.get($);return f.push([$,{contents:I,overrides:D,keys:v}]),f},[])}}allKeys(){const f=new Set;return this.j.keys.forEach($=>f.add($)),this.userConfiguration.keys.forEach($=>f.add($)),this.q.keys.forEach($=>f.add($)),this.r.forEach($=>$.keys.forEach(I=>f.add(I))),[...f.values()]}B(){const f=new Set;return this.j.getAllOverrideIdentifiers().forEach($=>f.add($)),this.userConfiguration.getAllOverrideIdentifiers().forEach($=>f.add($)),this.q.getAllOverrideIdentifiers().forEach($=>f.add($)),this.r.forEach($=>$.getAllOverrideIdentifiers().forEach(I=>f.add(I))),[...f.values()]}D(f){const $=new Set;return this.j.getKeysForOverrideIdentifier(f).forEach(I=>$.add(I)),this.userConfiguration.getKeysForOverrideIdentifier(f).forEach(I=>$.add(I)),this.q.getKeysForOverrideIdentifier(f).forEach(I=>$.add(I)),this.r.forEach(I=>I.getKeysForOverrideIdentifier(f).forEach(D=>$.add(D))),[...$.values()]}static parse(f,$){const I=this.E(f.defaults,$),D=this.E(f.policy,$),v=this.E(f.application,$),C=this.E(f.user,$),P=this.E(f.workspace,$),g=f.folders.reduce((b,L)=>(b.set(a.URI.revive(L[0]),this.E(L[1],$)),b),new A.$Cc);return new i(I,D,v,C,n.createEmptyModel($),P,g,n.createEmptyModel($),new A.$Cc,$)}static E(f,$){return new n(f.contents,f.keys,f.overrides,void 0,$)}}e.$Mo=i;function r(...m){if(m.length===0)return{keys:[],overrides:[]};if(m.length===1)return m[0];const f=new Set,$=new Map;for(const D of m)D.keys.forEach(v=>f.add(v)),D.overrides.forEach(([v,C])=>{const P=(0,A.$zc)($,v,new Set);C.forEach(g=>P.add(g))});const I=[];return $.forEach((D,v)=>I.push([v,[...D.values()]])),{keys:[...f.values()],overrides:I}}class t{constructor(f,$,I,D,v){this.change=f,this.f=$,this.g=I,this.h=D,this.i=v,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=46,this.affectedKeys=new Set,this.j=void 0;for(const C of f.keys)this.affectedKeys.add(C);for(const[,C]of f.overrides)for(const P of C)this.affectedKeys.add(P);this.d=this.a;for(const C of this.affectedKeys)this.d+=C+this.a}get previousConfiguration(){return!this.j&&this.f&&(this.j=i.parse(this.f.data,this.i)),this.j}affectsConfiguration(f,$){const I=this.a+f,D=this.d.indexOf(I);if(D<0)return!1;const v=D+I.length;if(v>=this.d.length)return!1;const C=this.d.charCodeAt(v);if(C!==this.b&&C!==this.c)return!1;if($){const P=this.previousConfiguration?this.previousConfiguration.getValue(f,$,this.f?.workspace):void 0,g=this.g.getValue(f,$,this.h);return!T.$fo(P,g)}return!0}}e.$Oo=t;function c(m,f){const{added:$,removed:I,updated:D}=l(f?.rawConfiguration,m?.rawConfiguration),v=[],C=m?.getAllOverrideIdentifiers()||[],P=f?.getAllOverrideIdentifiers()||[];if(f){const g=P.filter(b=>!C.includes(b));for(const b of g)v.push([b,f.getKeysForOverrideIdentifier(b)])}if(m){const g=C.filter(b=>!P.includes(b));for(const b of g)v.push([b,m.getKeysForOverrideIdentifier(b)])}if(f&&m){for(const g of C)if(P.includes(g)){const b=l({contents:m.getOverrideValue(void 0,g)||{},keys:m.getKeysForOverrideIdentifier(g)},{contents:f.getOverrideValue(void 0,g)||{},keys:f.getKeysForOverrideIdentifier(g)});v.push([g,[...b.added,...b.removed,...b.updated]])}}return{added:$,removed:I,updated:D,overrides:v}}function l(m,f){const $=m?f?m.keys.filter(v=>f.keys.indexOf(v)===-1):[...m.keys]:[],I=f?m?f.keys.filter(v=>m.keys.indexOf(v)===-1):[...f.keys]:[],D=[];if(m&&f){for(const v of f.keys)if(m.keys.indexOf(v)!==-1){const C=(0,R.$hj)(f.contents,v),P=(0,R.$hj)(m.contents,v);T.$fo(C,P)||D.push(v)}}return{added:$,removed:I,updated:D}}}),define(ke[109],Ce([1,0,14,3]),function(oe,e,w,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tl=e.RemoteAuthorityResolverErrorCode=e.$Sl=e.$Rl=e.RemoteConnectionType=e.$Ql=void 0,e.$Ul=a,e.$Ql=(0,S.$Fi)("remoteAuthorityResolverService");var k;(function(R){R[R.WebSocket=0]="WebSocket",R[R.Managed=1]="Managed"})(k||(e.RemoteConnectionType=k={}));class O{constructor(y){this.id=y,this.type=k.Managed}toString(){return`Managed(${this.id})`}}e.$Rl=O;class A{constructor(y,u){this.host=y,this.port=u,this.type=k.WebSocket}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$Sl=A;var T;(function(R){R.Unknown="Unknown",R.NotAvailable="NotAvailable",R.TemporarilyNotAvailable="TemporarilyNotAvailable",R.NoResolverFound="NoResolverFound",R.InvalidAuthority="InvalidAuthority"})(T||(e.RemoteAuthorityResolverErrorCode=T={}));class p extends w.$db{static isNotAvailable(y){return y instanceof p&&y._code===T.NotAvailable}static isTemporarilyNotAvailable(y){return y instanceof p&&y._code===T.TemporarilyNotAvailable}static isNoResolverFound(y){return y instanceof p&&y._code===T.NoResolverFound}static isInvalidAuthority(y){return y instanceof p&&y._code===T.InvalidAuthority}static isHandled(y){return y instanceof p&&y.isHandled}constructor(y,u=T.Unknown,E){super(y),this._message=y,this._code=u,this._detail=E,this.isHandled=u===T.NotAvailable&&E===!0,Object.setPrototypeOf(this,p.prototype)}}e.$Tl=p;function a(R){const y=R.indexOf("+");return y===-1?R:R.substring(0,y)}}),define(ke[63],Ce([1,0,16]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gn=S,e.$hn=k,e.$in=O,e.$jn=A;function S(p){return p.scheme===w.Schemas.vscodeRemote?p.authority:void 0}function k(p){if(!p)return;const a=p.indexOf("+");return a<0?p:p.substr(0,a)}function O(p){const{host:a,port:R}=T(p);if(typeof R>"u")throw new Error(`Invalid remote authority: ${p}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:a,port:R}}function A(p,a){let{host:R,port:y}=T(p);return typeof y>"u"&&(y=a),{host:R,port:y}}function T(p){const a=p.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(a)return{host:a[1],port:parseInt(a[2],10)};const R=p.match(/^(\[[0-9a-z:]+\])$/);if(R)return{host:R[1],port:void 0};const y=p.match(/(.*):(\d+)$/);return y?{host:y[1],port:parseInt(y[2],10)}:{host:p,port:void 0}}}),define(ke[19],Ce([1,0,13,3,63]),function(oe,e,w,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xn=e.$sn=e.$rn=e.$qn=e.TargetPlatform=e.ExtensionType=e.$pn=e.$nn=e.$mn=e.$ln=e.$kn=void 0,e.$on=O,e.$tn=y,e.$un=u,e.$vn=E,e.$wn=d,w=qe(w),e.$kn="extensions.user.cache",e.$ln="extensions.builtin.cache",e.$mn="undefined_publisher",e.$nn=["ui","workspace","web"];function O(n){if(typeof n=="object"&&n!==null&&n.supported!==!0)return n.description}e.$pn=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","AI","Chat","Other"];var A;(function(n){n[n.System=0]="System",n[n.User=1]="User"})(A||(e.ExtensionType=A={}));var T;(function(n){n.WIN32_X64="win32-x64",n.WIN32_ARM64="win32-arm64",n.LINUX_X64="linux-x64",n.LINUX_ARM64="linux-arm64",n.LINUX_ARMHF="linux-armhf",n.ALPINE_X64="alpine-x64",n.ALPINE_ARM64="alpine-arm64",n.DARWIN_X64="darwin-x64",n.DARWIN_ARM64="darwin-arm64",n.WEB="web",n.UNIVERSAL="universal",n.UNKNOWN="unknown",n.UNDEFINED="undefined"})(T||(e.TargetPlatform=T={}));class p{constructor(s){this.value=s,this._lower=s.toLowerCase()}static equals(s,o){if(typeof s>"u"||s===null)return typeof o>"u"||o===null;if(typeof o>"u"||o===null)return!1;if(typeof s=="string"||typeof o=="string"){const h=typeof s=="string"?s:s.value,i=typeof o=="string"?o:o.value;return w.$Gf(h,i)}return s._lower===o._lower}static toKey(s){return typeof s=="string"?s.toLowerCase():s._lower}}e.$qn=p;class a{get size(){return this.c.size}constructor(s){if(this.c=new Set,s)for(const o of s)this.add(o)}add(s){this.c.add(p.toKey(s))}delete(s){return this.c.delete(p.toKey(s))}has(s){return this.c.has(p.toKey(s))}}e.$rn=a;class R{constructor(){this.c=new Map}clear(){this.c.clear()}delete(s){this.c.delete(p.toKey(s))}get(s){return this.c.get(p.toKey(s))}has(s){return this.c.has(p.toKey(s))}set(s,o){this.c.set(p.toKey(s),o)}values(){return this.c.values()}forEach(s){this.c.forEach(s)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$sn=R;function y(n){return u(n)}function u(n){return n.contributes&&n.contributes.localizations?n.contributes.localizations.length>0:!1}function E(n){return n.contributes&&n.contributes.authentication?n.contributes.authentication.length>0:!1}function d(n,s){if(s){const o=`onResolveRemoteAuthority:${(0,k.$hn)(s)}`;return!!n.activationEvents?.includes(o)}return!1}e.$xn=(0,S.$Fi)("IBuiltinExtensionsScannerService")}),define(ke[110],Ce([1,0,21,171,19,3]),function(oe,e,w,S,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pp=e.$op=e.$np=e.$mp=e.$lp=e.$kp=e.$jp=e.$ip=e.ExtensionManagementErrorCode=e.$hp=e.ExtensionGalleryErrorCode=e.$gp=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.ExtensionInstallSource=e.$_o=e.$$o=e.$0o=e.$9o=e.$8o=e.$7o=e.$6o=void 0,e.$ap=T,e.$bp=p,e.$cp=a,e.$dp=R,e.$ep=y,e.$fp=u,e.$6o="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$7o=new RegExp(e.$6o),e.$8o="__web_extension",e.$9o="skipWalkthrough",e.$0o="extensionInstallSource",e.$$o="dependecyOrPackExtensionInstall",e.$_o="clientTargetPlatform";var A;(function(t){t.COMMAND="command",t.SETTINGS_SYNC="settingsSync"})(A||(e.ExtensionInstallSource=A={}));function T(t){switch(t){case k.TargetPlatform.WIN32_X64:return"Windows 64 bit";case k.TargetPlatform.WIN32_ARM64:return"Windows ARM";case k.TargetPlatform.LINUX_X64:return"Linux 64 bit";case k.TargetPlatform.LINUX_ARM64:return"Linux ARM 64";case k.TargetPlatform.LINUX_ARMHF:return"Linux ARM";case k.TargetPlatform.ALPINE_X64:return"Alpine Linux 64 bit";case k.TargetPlatform.ALPINE_ARM64:return"Alpine ARM 64";case k.TargetPlatform.DARWIN_X64:return"Mac";case k.TargetPlatform.DARWIN_ARM64:return"Mac Silicon";case k.TargetPlatform.WEB:return"Web";case k.TargetPlatform.UNIVERSAL:return k.TargetPlatform.UNIVERSAL;case k.TargetPlatform.UNKNOWN:return k.TargetPlatform.UNKNOWN;case k.TargetPlatform.UNDEFINED:return k.TargetPlatform.UNDEFINED}}function p(t){switch(t){case k.TargetPlatform.WIN32_X64:return k.TargetPlatform.WIN32_X64;case k.TargetPlatform.WIN32_ARM64:return k.TargetPlatform.WIN32_ARM64;case k.TargetPlatform.LINUX_X64:return k.TargetPlatform.LINUX_X64;case k.TargetPlatform.LINUX_ARM64:return k.TargetPlatform.LINUX_ARM64;case k.TargetPlatform.LINUX_ARMHF:return k.TargetPlatform.LINUX_ARMHF;case k.TargetPlatform.ALPINE_X64:return k.TargetPlatform.ALPINE_X64;case k.TargetPlatform.ALPINE_ARM64:return k.TargetPlatform.ALPINE_ARM64;case k.TargetPlatform.DARWIN_X64:return k.TargetPlatform.DARWIN_X64;case k.TargetPlatform.DARWIN_ARM64:return k.TargetPlatform.DARWIN_ARM64;case k.TargetPlatform.WEB:return k.TargetPlatform.WEB;case k.TargetPlatform.UNIVERSAL:return k.TargetPlatform.UNIVERSAL;default:return k.TargetPlatform.UNKNOWN}}function a(t,c){switch(t){case w.Platform.Windows:return c==="x64"?k.TargetPlatform.WIN32_X64:c==="arm64"?k.TargetPlatform.WIN32_ARM64:k.TargetPlatform.UNKNOWN;case w.Platform.Linux:return c==="x64"?k.TargetPlatform.LINUX_X64:c==="arm64"?k.TargetPlatform.LINUX_ARM64:c==="arm"?k.TargetPlatform.LINUX_ARMHF:k.TargetPlatform.UNKNOWN;case"alpine":return c==="x64"?k.TargetPlatform.ALPINE_X64:c==="arm64"?k.TargetPlatform.ALPINE_ARM64:k.TargetPlatform.UNKNOWN;case w.Platform.Mac:return c==="x64"?k.TargetPlatform.DARWIN_X64:c==="arm64"?k.TargetPlatform.DARWIN_ARM64:k.TargetPlatform.UNKNOWN;case w.Platform.Web:return k.TargetPlatform.WEB}}function R(t,c){return c===k.TargetPlatform.WEB&&!t.includes(k.TargetPlatform.WEB)}function y(t,c,l){return R(c,l)?!1:t===k.TargetPlatform.UNDEFINED||t===k.TargetPlatform.UNIVERSAL?!0:t===k.TargetPlatform.UNKNOWN?!1:t===l}function u(t){return t&&typeof t=="object"&&typeof t.id=="string"&&(!t.uuid||typeof t.uuid=="string")}var E;(function(t){t[t.NoneOrRelevance=0]="NoneOrRelevance",t[t.LastUpdatedDate=1]="LastUpdatedDate",t[t.Title=2]="Title",t[t.PublisherName=3]="PublisherName",t[t.InstallCount=4]="InstallCount",t[t.PublishedDate=10]="PublishedDate",t[t.AverageRating=6]="AverageRating",t[t.WeightedRating=12]="WeightedRating"})(E||(e.SortBy=E={}));var d;(function(t){t[t.Default=0]="Default",t[t.Ascending=1]="Ascending",t[t.Descending=2]="Descending"})(d||(e.SortOrder=d={}));var n;(function(t){t.Install="install",t.Uninstall="uninstall"})(n||(e.StatisticType=n={}));var s;(function(t){t[t.None=1]="None",t[t.Install=2]="Install",t[t.Update=3]="Update",t[t.Migrate=4]="Migrate"})(s||(e.InstallOperation=s={})),e.$gp=(0,O.$Fi)("extensionGalleryService");var o;(function(t){t.Timeout="Timeout",t.Cancelled="Cancelled",t.Failed="Failed",t.DownloadFailedWriting="DownloadFailedWriting"})(o||(e.ExtensionGalleryErrorCode=o={}));class h extends Error{constructor(c,l){super(c),this.code=l,this.name=l}}e.$hp=h;var i;(function(t){t.Unsupported="Unsupported",t.Deprecated="Deprecated",t.Malicious="Malicious",t.Incompatible="Incompatible",t.IncompatibleTargetPlatform="IncompatibleTargetPlatform",t.ReleaseVersionNotFound="ReleaseVersionNotFound",t.Invalid="Invalid",t.Download="Download",t.DownloadSignature="DownloadSignature",t.DownloadFailedWriting="DownloadFailedWriting",t.UpdateExistingMetadata="UpdateExistingMetadata",t.UpdateMetadata="UpdateMetadata",t.Extract="Extract",t.Scanning="Scanning",t.ScanningExtension="ScanningExtension",t.ReadUninstalled="ReadUninstalled",t.UnsetUninstalled="UnsetUninstalled",t.Delete="Delete",t.Rename="Rename",t.IntializeDefaultProfile="IntializeDefaultProfile",t.AddToProfile="AddToProfile",t.InstalledExtensionNotFound="InstalledExtensionNotFound",t.PostInstall="PostInstall",t.CorruptZip="CorruptZip",t.IncompleteZip="IncompleteZip",t.Signature="Signature",t.NotAllowed="NotAllowed",t.Gallery="Gallery",t.Cancelled="Cancelled",t.Unknown="Unknown",t.Internal="Internal"})(i||(e.ExtensionManagementErrorCode=i={}));class r extends Error{constructor(c,l){super(c),this.code=l,this.name=l}}e.$ip=r,e.$jp=(0,O.$Fi)("extensionManagementService"),e.$kp="extensionsIdentifiers/disabled",e.$lp="extensionsIdentifiers/enabled",e.$mp=(0,O.$Fi)("IGlobalExtensionEnablementService"),e.$np=(0,O.$Fi)("IExtensionTipsService"),e.$op=(0,S.localize2)(0,"Extensions"),e.$pp=(0,S.localize2)(1,"Preferences")}),define(ke[111],Ce([1,0,14,19]),function(oe,e,w,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$IG=e.$HG=void 0;class k{constructor(){this.a=new Map,this.b=new WeakMap}register(A,T){this.a.set(A,T)}readActivationEvents(A){return this.b.has(A)||this.b.set(A,this.c(A)),this.b.get(A)}createActivationEventsMap(A){const T=Object.create(null);for(const p of A){const a=this.readActivationEvents(p);a.length>0&&(T[S.$qn.toKey(p.identifier)]=a)}return T}c(A){if(typeof A.main>"u"&&typeof A.browser>"u")return[];const T=Array.isArray(A.activationEvents)?A.activationEvents.slice(0):[];for(let p=0;p<T.length;p++)T[p]==="onUri"&&(T[p]=`onUri:${S.$qn.toKey(A.identifier)}`);if(!A.contributes)return T;for(const p in A.contributes){const a=this.a.get(p);if(!a)continue;const R=A.contributes[p],y=Array.isArray(R)?R:[R];try{a(y,T)}catch(u){(0,w.$3)(u)}}return T}}e.$HG=k,e.$IG=new k}),define(ke[216],Ce([1,0,23,14,4,176,54,3,12,31]),function(oe,e,w,S,k,O,A,T,p,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2p=e.$1p=void 0,e.$3p=u,e.$4p=E,e.$5p=d,e.$6p=n,e.$7p=s,e.$8p=o,e.$1p=(0,T.$Fi)("requestService");class R{constructor(t){this.b=t}toJSON(){if(!this.a){const t=Object.create(null);for(const c in this.b)c.toLowerCase()==="authorization"||c.toLowerCase()==="proxy-authorization"?t[c]="*****":t[c]=this.b[c];this.a=t}return this.a}}class y extends k.$Wc{constructor(t){super(),this.b=0,this.a=t.createLogger("network",{name:(0,O.localize)(0,null),when:p.$rk.isEqualTo((0,p.$ok)(p.LogLevel.Trace)).serialize()})}async c(t,c,l){const m=`${t} #${++this.b}: ${c.url}`;this.a.trace(`${m} - begin`,c.type,new R(c.headers??{}));try{const f=await l();return this.a.trace(`${m} - end`,c.type,f.res.statusCode,f.res.headers),f}catch(f){throw this.a.error(`${m} - error`,c.type,(0,S.$_)(f)),f}}}e.$2p=y;function u(r){return r.res.statusCode&&r.res.statusCode>=200&&r.res.statusCode<300||r.res.statusCode===1223}function E(r){return r.res.statusCode===204}async function d(r){return E(r)?null:(await(0,w.$1e)(r.stream)).toString()}async function n(r){if(!u(r))throw new Error("Server returned "+r.res.statusCode);return d(r)}async function s(r){if(!u(r))throw new Error("Server returned "+r.res.statusCode);if(E(r))return null;const c=(await(0,w.$1e)(r.stream)).toString();try{return JSON.parse(c)}catch(l){throw l.message+=`:
`+c,l}}function o(r){i(r)}let h;function i(r){const t=a.$oo.as(A.$to.Configuration),c=h;h={id:"http",order:15,title:(0,O.localize)(1,null),type:"object",scope:r,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,O.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,O.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,O.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,O.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,O.localize)(6,null),(0,O.localize)(7,null),(0,O.localize)(8,null),(0,O.localize)(9,null)],default:"override",description:(0,O.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,O.localize)(11,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,O.localize)(12,null),restricted:!0}}},t.updateConfigurations({add:[h],remove:c?[c]:[]})}i(A.ConfigurationScope.APPLICATION)}),define(ke[217],Ce([1,0,21,79,37]),function(oe,e,w,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qp=A,e.$rp=T;function O(p){if(w.$u===w.Platform.Linux&&/^penguin(\.|$)/i.test(p))return"chromebook"}function A(p,a,R,y,u,E,d,n,s,o){const h=Object.create(null);h["common.machineId"]=E,h["common.sqmId"]=d,h["common.devDeviceId"]=n,h.sessionID=(0,k.$2g)()+Date.now(),h.commitHash=y,h.version=u,h["common.platformVersion"]=(p||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),h["common.platform"]=(0,w.$h)(w.$u),h["common.nodePlatform"]=S.$fc,h["common.nodeArch"]=R,h["common.product"]=o||"desktop",s&&(h["common.msftInternal"]=s);let i=0;const r=Date.now();Object.defineProperties(h,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-r,enumerable:!0},"common.sequence":{get:()=>i++,enumerable:!0}}),w.$l&&(h["common.snap"]="true");const t=O(a);return t&&(h["common.platformDetail"]=t),h}function T(p){const a=S.env.USERDNSDOMAIN;if(!a)return!1;const R=a.toLowerCase();return p.some(y=>R===y)}}),define(ke[112],Ce([1,0,3]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$jm=e.$im=e.$hm=e.$gm=e.$fm=e.$em=e.$dm=e.$cm=e.$bm=e.$am=e.$_l=e.$$l=void 0,e.$$l=(0,w.$Fi)("telemetryService"),e.$_l=(0,w.$Fi)("customEndpointTelemetryService"),e.$am="telemetry.currentSessionDate",e.$bm="telemetry.firstSessionDate",e.$cm="telemetry.lastSessionDate",e.$dm="telemetry.machineId",e.$em="telemetry.sqmId",e.$fm="telemetry.devDeviceId",e.$gm="telemetry",e.$hm="telemetry.telemetryLevel",e.$im="telemetry.enableCrashReporter",e.$jm="telemetry.enableTelemetry";var S;(function(O){O[O.NONE=0]="NONE",O[O.CRASH=1]="CRASH",O[O.ERROR=2]="ERROR",O[O.USAGE=3]="USAGE"})(S||(e.TelemetryLevel=S={}));var k;(function(O){O.OFF="off",O.CRASH="crash",O.ERROR="error",O.ON="all"})(k||(e.TelemetryConfiguration=k={}))}),define(ke[64],Ce([1,0,26,15,63,217,112]),function(oe,e,w,S,k,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yp=e.$xp=e.$wp=e.$vp=e.$up=e.$tp=e.$sp=void 0,e.$zp=R,e.$Ap=y,e.$Bp=u,e.$Cp=E,e.$Dp=n,e.$Ep=o,e.$Fp=h,e.$Gp=t;class T{constructor(l){this.value=l,this.isTrustedTelemetryValue=!0}}e.$sp=T;class p{constructor(){this.telemetryLevel=A.TelemetryLevel.NONE,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.devDeviceId="someValue.devDeviceId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$tp=p,e.$up=new p;class a{async publicLog(l,m,f){}async publicLogError(l,m,f){}}e.$vp=a,e.$wp="telemetry",e.$xp="extensionTelemetryLog",e.$yp={log:()=>null,flush:()=>Promise.resolve(null)};function R(c,l){return!l.isBuilt&&!l.disableTelemetry?!0:!(l.disableTelemetry||!c.enableTelemetry)}function y(c,l){return l.extensionTestsLocationURI?!0:!(l.isBuilt||l.disableTelemetry||c.enableTelemetry&&c.aiConfig?.ariaKey)}function u(c){const l=c.getValue(A.$hm),m=c.getValue(A.$im);if(c.getValue(A.$jm)===!1||m===!1)return A.TelemetryLevel.NONE;switch(l??A.TelemetryConfiguration.ON){case A.TelemetryConfiguration.ON:return A.TelemetryLevel.USAGE;case A.TelemetryConfiguration.ERROR:return A.TelemetryLevel.ERROR;case A.TelemetryConfiguration.CRASH:return A.TelemetryLevel.CRASH;case A.TelemetryConfiguration.OFF:return A.TelemetryLevel.NONE}}function E(c){const l={},m={},f={};s(c,f);for(let $ in f){$=$.length>150?$.substr($.length-149):$;const I=f[$];typeof I=="number"?m[$]=I:typeof I=="boolean"?m[$]=I?1:0:typeof I=="string"?(I.length>8192&&console.warn(`Telemetry property: ${$} has been trimmed to 8192, the original length is ${I.length}`),l[$]=I.substring(0,8191)):typeof I<"u"&&I!==null&&(l[$]=I)}return{properties:l,measurements:m}}const d=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function n(c){if(!c)return"none";const l=(0,k.$hn)(c);return d.has(l)?l:"other"}function s(c,l,m=0,f){if(c)for(const $ of Object.getOwnPropertyNames(c)){const I=c[$],D=f?f+$:$;Array.isArray(I)?l[D]=(0,w.$go)(I):I instanceof Date?l[D]=I.toISOString():(0,S.$hg)(I)?m<2?s(I,l,m+1,D+"."):l[D]=(0,w.$go)(I):l[D]=I}}function o(c,l){const m=c.msftInternalDomains||[],f=l.getValue("telemetry.internalTesting");return(0,O.$rp)(m)||f}function h(c){return[c.appRoot,c.extensionsPath,c.userHome.fsPath,c.tmpDir.fsPath,c.userDataPath]}function i(c,l){if(!c||!c.includes("/")&&!c.includes("\\"))return c;let m=c;const f=[];for(const v of l)for(;;){const C=v.exec(c);if(!C)break;f.push([C.index,v.lastIndex])}const $=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,I=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let D=0;for(m="";;){const v=I.exec(c);if(!v)break;const C=f.some(([P,g])=>v.index<g&&P<I.lastIndex);!$.test(v[0])&&!C&&(m+=c.substring(D,v.index)+"<REDACTED: user-file-path>",D=I.lastIndex)}return D<c.length&&(m+=c.substr(D)),m}function r(c){if(!c)return c;const l=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"CLI Credentials",regex:/((login|psexec|(certutil|psexec)\.exe).{1,50}(\s-u(ser(name)?)?\s+.{3,100})?\s-(admin|user|vm|root)?p(ass(word)?)?\s+["']?[^$\-\/\s]|(^|[\s\r\n\\])net(\.exe)?.{1,5}(user\s+|share\s+\/user:| user -? secrets ? set) \s + [^ $\s \/])/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const m of l)if(m.regex.test(c))return`<REDACTED: ${m.label}>`;return c}function t(c,l){return(0,w.$do)(c,m=>{if(m instanceof T||Object.hasOwnProperty.call(m,"isTrustedTelemetryValue"))return m.value;if(typeof m=="string"){let f=m.replaceAll("%20"," ");f=i(f,l);for(const $ of l)f=f.replace($,"");return f=r(f),f}})}}),define(ke[218],Ce([1,0,13,110,19,21,2,14,79,64]),function(oe,e,w,S,k,O,A,T,p,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qp=e.$Ip=void 0,e.$Hp=R,e.$Jp=d,e.$Kp=n,e.$Lp=s,e.$Mp=o,e.$Np=h,e.$Op=i,e.$Pp=r,e.$Rp=t,e.$Sp=l;function R(m,f){return m.uuid&&f.uuid?m.uuid===f.uuid:m.id===f.id?!0:(0,w.$Bf)(m.id,f.id)===0}const y=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class u{static create(f){const $=f.manifest?f.manifest.version:f.version,I=f.manifest?f.targetPlatform:f.properties.targetPlatform;return new u(f.identifier,$,I)}static parse(f){const $=y.exec(f);return $&&$[1]&&$[2]?new u({id:$[1]},$[2],$[4]||void 0):null}constructor(f,$,I=k.TargetPlatform.UNDEFINED){this.identifier=f,this.version=$,this.targetPlatform=I,this.id=f.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!==k.TargetPlatform.UNDEFINED?`-${this.targetPlatform}`:""}`}equals(f){return f instanceof u?R(this,f)&&this.version===f.version&&this.targetPlatform===f.targetPlatform:!1}}e.$Ip=u;const E=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function d(m){const f=E.exec(m);return f&&f[1]?[s(f[1]),f[2]]:[s(m),void 0]}function n(m,f){return`${m}.${f}`}function s(m){return m.toLowerCase()}function o(m,f){return s(n(m??k.$mn,f))}function h(m,f){const $=[],I=D=>{for(const v of $)if(v.some(C=>R(f(C),f(D))))return v;return null};for(const D of m){const v=I(D);v?v.push(D):$.push([D])}return $}function i(m){return{id:m.identifier.id,name:m.manifest.name,galleryId:null,publisherId:m.publisherId,publisherName:m.manifest.publisher,publisherDisplayName:m.publisherDisplayName,dependencies:m.manifest.extensionDependencies&&m.manifest.extensionDependencies.length>0}}function r(m){return{id:new a.$sp(m.identifier.id),name:new a.$sp(m.name),version:m.version,galleryId:m.identifier.uuid,publisherId:m.publisherId,publisherName:m.publisher,publisherDisplayName:m.publisherDisplayName,isPreReleaseVersion:m.properties.isPreReleaseVersion,dependencies:!!(m.properties.dependencies&&m.properties.dependencies.length>0),isSigned:m.isSigned,...m.telemetryData}}e.$Qp=new k.$qn("pprice.better-merge");function t(m,f){const $=[],I=f.manifest.extensionDependencies?.slice(0)??[];for(;I.length;){const D=I.shift();if(D&&$.every(v=>!R(v.identifier,{id:D}))){const v=m.filter(C=>R(C.identifier,{id:D}));v.length===1&&($.push(v[0]),I.push(...v[0].manifest.extensionDependencies?.slice(0)??[]))}}return $}async function c(m,f){if(!O.$k)return!1;let $;try{$=(await m.readFile(A.URI.file("/etc/os-release"))).value.toString()}catch{try{$=(await m.readFile(A.URI.file("/usr/lib/os-release"))).value.toString()}catch(D){f.debug("Error while getting the os-release file.",(0,T.$_)(D))}}return!!$&&($.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function l(m,f){const $=await c(m,f),I=(0,S.$cp)($?"alpine":O.$u,p.$gc);return f.debug("ComputeTargetPlatform:",I),I}}),define(ke[219],Ce([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ys=w,e.$zs=S,e.$As=k,e.$Bs=O,e.$Cs=A,e.$Ds=T;function w(p){return[...p.entries()]}function S(p){return p?[...p.entries()]:[]}function k(p){return new Map(p)}function O(p){return new Map(p??[])}function A(p){return Array.from(p.entries()).map(a=>[a[0],w(a[1].map),S(a[1].descriptionMap)])}function T(p){return new Map(p.map(a=>[a[0],{map:k(a[1]),descriptionMap:O(a[2])}]))}}),define(ke[220],Ce([1,0,3,32,31]),function(oe,e,w,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ls=e.$ks=e.$js=e.TerminalExitReason=e.ShellIntegrationStatus=e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.$is=e.ProcessPropertyType=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.PosixShellType=e.TerminalSettingId=e.TerminalSettingPrefix=e.$hs=void 0,e.$hs=new S.$Wj("terminalTabFocusMode",!1,!0);var O;(function(t){t.AutomationProfile="terminal.integrated.automationProfile.",t.DefaultProfile="terminal.integrated.defaultProfile.",t.Profiles="terminal.integrated.profiles."})(O||(e.TerminalSettingPrefix=O={}));var A;(function(t){t.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",t.AutomationProfileLinux="terminal.integrated.automationProfile.linux",t.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",t.AutomationProfileWindows="terminal.integrated.automationProfile.windows",t.ProfilesWindows="terminal.integrated.profiles.windows",t.ProfilesMacOs="terminal.integrated.profiles.osx",t.ProfilesLinux="terminal.integrated.profiles.linux",t.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",t.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",t.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",t.UseWslProfiles="terminal.integrated.useWslProfiles",t.TabsDefaultColor="terminal.integrated.tabs.defaultColor",t.TabsDefaultIcon="terminal.integrated.tabs.defaultIcon",t.TabsEnabled="terminal.integrated.tabs.enabled",t.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",t.TabsHideCondition="terminal.integrated.tabs.hideCondition",t.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",t.TabsShowActions="terminal.integrated.tabs.showActions",t.TabsLocation="terminal.integrated.tabs.location",t.TabsFocusMode="terminal.integrated.tabs.focusMode",t.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",t.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",t.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",t.CopyOnSelection="terminal.integrated.copyOnSelection",t.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",t.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",t.FontFamily="terminal.integrated.fontFamily",t.FontSize="terminal.integrated.fontSize",t.LetterSpacing="terminal.integrated.letterSpacing",t.LineHeight="terminal.integrated.lineHeight",t.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",t.TabStopWidth="terminal.integrated.tabStopWidth",t.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",t.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",t.BellDuration="terminal.integrated.bellDuration",t.FontWeight="terminal.integrated.fontWeight",t.FontWeightBold="terminal.integrated.fontWeightBold",t.CursorBlinking="terminal.integrated.cursorBlinking",t.CursorStyle="terminal.integrated.cursorStyle",t.CursorStyleInactive="terminal.integrated.cursorStyleInactive",t.CursorWidth="terminal.integrated.cursorWidth",t.Scrollback="terminal.integrated.scrollback",t.DetectLocale="terminal.integrated.detectLocale",t.DefaultLocation="terminal.integrated.defaultLocation",t.GpuAcceleration="terminal.integrated.gpuAcceleration",t.TerminalTitleSeparator="terminal.integrated.tabs.separator",t.TerminalTitle="terminal.integrated.tabs.title",t.TerminalDescription="terminal.integrated.tabs.description",t.RightClickBehavior="terminal.integrated.rightClickBehavior",t.MiddleClickBehavior="terminal.integrated.middleClickBehavior",t.Cwd="terminal.integrated.cwd",t.ConfirmOnExit="terminal.integrated.confirmOnExit",t.ConfirmOnKill="terminal.integrated.confirmOnKill",t.EnableBell="terminal.integrated.enableBell",t.EnableVisualBell="terminal.integrated.enableVisualBell",t.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",t.AllowChords="terminal.integrated.allowChords",t.AllowMnemonics="terminal.integrated.allowMnemonics",t.TabFocusMode="terminal.integrated.tabFocusMode",t.EnvMacOs="terminal.integrated.env.osx",t.EnvLinux="terminal.integrated.env.linux",t.EnvWindows="terminal.integrated.env.windows",t.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",t.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",t.ShowExitAlert="terminal.integrated.showExitAlert",t.SplitCwd="terminal.integrated.splitCwd",t.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",t.WordSeparators="terminal.integrated.wordSeparators",t.EnableFileLinks="terminal.integrated.enableFileLinks",t.AllowedLinkSchemes="terminal.integrated.allowedLinkSchemes",t.UnicodeVersion="terminal.integrated.unicodeVersion",t.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",t.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",t.HideOnStartup="terminal.integrated.hideOnStartup",t.CustomGlyphs="terminal.integrated.customGlyphs",t.RescaleOverlappingGlyphs="terminal.integrated.rescaleOverlappingGlyphs",t.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",t.InheritEnv="terminal.integrated.inheritEnv",t.ShowLinkHover="terminal.integrated.showLinkHover",t.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",t.AutoReplies="terminal.integrated.autoReplies",t.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",t.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",t.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",t.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history",t.EnableImages="terminal.integrated.enableImages",t.SmoothScrolling="terminal.integrated.smoothScrolling",t.IgnoreBracketedPasteMode="terminal.integrated.ignoreBracketedPasteMode",t.FocusAfterRun="terminal.integrated.focusAfterRun",t.DeveloperPtyHostLatency="terminal.integrated.developer.ptyHost.latency",t.DeveloperPtyHostStartupDelay="terminal.integrated.developer.ptyHost.startupDelay",t.DevMode="terminal.integrated.developer.devMode"})(A||(e.TerminalSettingId=A={}));var T;(function(t){t.PowerShell="pwsh",t.Bash="bash",t.Fish="fish",t.Sh="sh",t.Csh="csh",t.Ksh="ksh",t.Zsh="zsh",t.Python="python"})(T||(e.PosixShellType=T={}));var p;(function(t){t.CommandPrompt="cmd",t.PowerShell="pwsh",t.Wsl="wsl",t.GitBash="gitbash",t.Python="python"})(p||(e.WindowsShellType=p={}));var a;(function(t){t[t.Api=0]="Api",t[t.Process=1]="Process",t[t.Sequence=2]="Sequence",t[t.Config=3]="Config"})(a||(e.TitleEventSource=a={}));var R;(function(t){t.LocalPty="localPty",t.PtyHost="ptyHost",t.PtyHostWindow="ptyHostWindow",t.Logger="logger",t.Heartbeat="heartbeat"})(R||(e.TerminalIpcChannels=R={}));var y;(function(t){t.Cwd="cwd",t.InitialCwd="initialCwd",t.FixedDimensions="fixedDimensions",t.Title="title",t.ShellType="shellType",t.HasChildProcesses="hasChildProcesses",t.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",t.OverrideDimensions="overrideDimensions",t.FailedShellIntegrationActivation="failedShellIntegrationActivation",t.UsedShellIntegrationInjection="usedShellIntegrationInjection"})(y||(e.ProcessPropertyType=y={})),e.$is=(0,w.$Fi)("ptyService");var u;(function(t){t[t.BeatInterval=5e3]="BeatInterval",t[t.ConnectingBeatInterval=2e4]="ConnectingBeatInterval",t[t.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",t[t.SecondWaitMultiplier=1]="SecondWaitMultiplier",t[t.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(u||(e.HeartbeatConstants=u={}));var E;(function(t){t[t.Panel=1]="Panel",t[t.Editor=2]="Editor"})(E||(e.TerminalLocation=E={}));var d;(function(t){t.TerminalView="view",t.Editor="editor"})(d||(e.TerminalLocationString=d={}));var n;(function(t){t[t.GraceTime=6e4]="GraceTime",t[t.ShortGraceTime=6e3]="ShortGraceTime"})(n||(e.LocalReconnectConstants=n={}));var s;(function(t){t[t.HighWatermarkChars=1e5]="HighWatermarkChars",t[t.LowWatermarkChars=5e3]="LowWatermarkChars",t[t.CharCountAckSize=5e3]="CharCountAckSize"})(s||(e.FlowControlConstants=s={}));var o;(function(t){t.GitBash="Git Bash",t.Pwsh="PowerShell"})(o||(e.ProfileSource=o={}));var h;(function(t){t[t.Off=0]="Off",t[t.FinalTerm=1]="FinalTerm",t[t.VSCode=2]="VSCode"})(h||(e.ShellIntegrationStatus=h={}));var i;(function(t){t[t.Unknown=0]="Unknown",t[t.Shutdown=1]="Shutdown",t[t.Process=2]="Process",t[t.User=3]="User",t[t.Extension=4]="Extension"})(i||(e.TerminalExitReason=i={})),e.$js={Backend:"workbench.contributions.terminal.processBackend"};class r{constructor(){this.a=new Map}get backends(){return this.a}registerTerminalBackend(c){const l=this.b(c.remoteAuthority);if(this.a.has(l))throw new Error(`A terminal backend with remote authority '${l}' was already registered.`);this.a.set(l,c)}getTerminalBackend(c){return this.a.get(this.b(c))}b(c){return c?.toLowerCase()??""}}k.$oo.add(e.$js.Backend,new r),e.$ks=(0,w.$Fi)("localPtyService"),e.$ls=(0,w.$Fi)("terminalLogService")}),define(ke[221],Ce([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$exb=void 0;class w{constructor(k){this.b=k,this.a=new Map}dispose(){for(const k of this.a.values())k.dispose()}startBuffering(k,O,A=5){const T=O(p=>{const a=typeof p=="string"?p:p.data;let R=this.a.get(k);if(R){R.data.push(a);return}const y=setTimeout(()=>this.flushBuffer(k),A);R={data:[a],timeoutId:y,dispose:()=>{clearTimeout(y),this.flushBuffer(k),T.dispose()}},this.a.set(k,R)});return T}stopBuffering(k){this.a.get(k)?.dispose()}flushBuffer(k){const O=this.a.get(k);O&&(this.a.delete(k),this.b(k,O.data.join("")))}}e.$exb=w}),define(ke[222],Ce([1,0,11,98,324,35,6,15,2,177,78,31]),function(oe,e,w,S,k,O,A,T,p,a,R,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ax=e.$zx=e.$yx=e.$xx=e.$wx=e.$vx=e.IconFontDefinition=e.IconContribution=e.$sx=void 0,e.$tx=s,e.$ux=o,y=qe(y),e.$sx={IconContribution:"base.contributions.icons"};var u;(function(t){function c(l,m){let f=l.defaults;for(;O.ThemeIcon.isThemeIcon(f);){const $=n.getIcon(f.id);if(!$)return;f=$.defaults}return f}t.getDefinition=c})(u||(e.IconContribution=u={}));var E;(function(t){function c(m){return{weight:m.weight,style:m.style,src:m.src.map(f=>({format:f.format,location:f.location.toString()}))}}t.toJSONObject=c;function l(m){const f=$=>(0,T.$fg)($)?$:void 0;if(m&&Array.isArray(m.src)&&m.src.every($=>(0,T.$fg)($.format)&&(0,T.$fg)($.location)))return{weight:f(m.weight),style:f(m.style),src:m.src.map($=>({format:$.format,location:p.URI.parse($.location)}))}}t.fromJSONObject=l})(E||(e.IconFontDefinition=E={}));class d{constructor(){this.a=new A.$me,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,a.localize)(0,null)},fontCharacter:{type:"string",description:(0,a.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${O.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(c,l,m,f){const $=this.b[c];if($){if(m&&!$.description){$.description=m,this.d.properties[c].markdownDescription=`${m} $(${c})`;const v=this.e.enum.indexOf(c);v!==-1&&(this.e.enumDescriptions[v]=m),this.a.fire()}return $}const I={id:c,description:m,defaults:l,deprecationMessage:f};this.b[c]=I;const D={$ref:"#/definitions/icons"};return f&&(D.deprecationMessage=f),m&&(D.markdownDescription=`${m}: $(${c})`),this.d.properties[c]=D,this.e.enum.push(c),this.e.enumDescriptions.push(m||""),this.a.fire(),{id:c}}deregisterIcon(c){delete this.b[c],delete this.d.properties[c];const l=this.e.enum.indexOf(c);l!==-1&&(this.e.enum.splice(l,1),this.e.enumDescriptions.splice(l,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(c=>this.b[c])}getIcon(c){return this.b[c]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(c,l){const m=this.f[c];return m||(this.f[c]=l,this.a.fire(),l)}deregisterIconFont(c){delete this.f[c]}getIconFont(c){return this.f[c]}toString(){const c=($,I)=>$.id.localeCompare(I.id),l=$=>{for(;O.ThemeIcon.isThemeIcon($.defaults);)$=this.b[$.defaults.id];return`codicon codicon-${$?$.id:""}`},m=[];m.push("| preview     | identifier                        | default codicon ID                | description"),m.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const f=Object.keys(this.b).map($=>this.b[$]);for(const $ of f.filter(I=>!!I.description).sort(c))m.push(`|<i class="${l($)}"></i>|${$.id}|${O.ThemeIcon.isThemeIcon($.defaults)?$.defaults.id:$.id}|${$.description||""}|`);m.push("| preview     | identifier                        "),m.push("| ----------- | --------------------------------- |");for(const $ of f.filter(I=>!O.ThemeIcon.isThemeIcon(I.defaults)).sort(c))m.push(`|<i class="${l($)}"></i>|${$.id}|`);return m.join(`
`)}}const n=new d;y.$oo.add(e.$sx.IconContribution,n);function s(t,c,l,m){return n.registerIcon(t,c,l,m)}function o(){return n}function h(){const t=(0,k.$1j)();for(const c in t){const l="\\"+t[c].toString(16);n.registerIcon(c,{fontCharacter:l})}}h(),e.$vx="vscode://schemas/icons";const i=y.$oo.as(R.$po.JSONContribution);i.registerSchema(e.$vx,n.getIconSchema());const r=new w.$Rh(()=>i.notifySchemaChanged(e.$vx),200);n.onDidChange(()=>{r.isScheduled()||r.schedule()}),e.$wx=s("widget-close",S.$5j.close,(0,a.localize)(2,null)),e.$xx=s("goto-previous-location",S.$5j.arrowUp,(0,a.localize)(3,null)),e.$yx=s("goto-next-location",S.$5j.arrowDown,(0,a.localize)(4,null)),e.$zx=O.ThemeIcon.modify(S.$5j.sync,"spin"),e.$Ax=O.ThemeIcon.modify(S.$5j.loading,"spin")}),define(ke[223],Ce([1,0,6,4,21,2,42,3,12]),function(oe,e,w,S,k,O,A,T,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hw=e.$Gw=e.$Dw=e.$Bw=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.$xw=e.$ww=void 0,e.$yw=y,e.$zw=E,e.$Aw=d,e.$Cw=n,e.$Ew=s,e.$Fw=o,e.$ww=(0,T.$Fi)("tunnelService"),e.$xw=(0,T.$Fi)("sharedTunnelsService");var a;(function(r){r.Http="http",r.Https="https"})(a||(e.TunnelProtocol=a={}));var R;(function(r){r.ConstantPrivate="constantPrivate",r.Private="private",r.Public="public"})(R||(e.TunnelPrivacyId=R={}));function y(r){return!!r.forwardPort}var u;(function(r){r[r.Notify=1]="Notify",r[r.OpenBrowser=2]="OpenBrowser",r[r.OpenPreview=3]="OpenPreview",r[r.Silent=4]="Silent",r[r.Ignore=5]="Ignore",r[r.OpenBrowserOnce=6]="OpenBrowserOnce"})(u||(e.ProvidedOnAutoForward=u={}));function E(r){if(r.scheme!=="http"&&r.scheme!=="https")return;const t=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(r.authority);if(t)return{address:t[1],port:+t[2]}}function d(r){if(r.scheme!=="http"&&r.scheme!=="https"||!r.query)return;const t=r.query.split("&");for(const c of t){const l=c.split("=")[1];if(/^https?:/.exec(l)){const m=E(O.URI.parse(l));if(m)return m}}}e.$Bw=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function n(r){return e.$Bw.indexOf(r)>=0}e.$Dw=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function s(r){return e.$Dw.indexOf(r)>=0}function o(r,t,c,l){if(c===k.OperatingSystem.Windows)return!1;if(c===k.OperatingSystem.Macintosh&&s(t)){const m=/(\d+)\.(\d+)\.(\d+)/g.exec(l);if(m?.length===4&&parseInt(m[1])>=18)return!1}return r<1024}class h{constructor(t,c,l){this.remoteAddress=t,this.localAddress=c,this.b=l,this.a=new w.$me,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$Gw=h;let i=class extends S.$Wc{constructor(t,c){super(),this.r=t,this.s=c,this.a=new w.$me,this.onTunnelOpened=this.a.event,this.b=new w.$me,this.onTunnelClosed=this.b.event,this.c=new w.$me,this.onAddedTunnelProvider=this.c.event,this.f=new Map,this.h=!1,this.j=!0,this.m=[],this.n=new Set}get hasTunnelProvider(){return!!this.g}get t(){const t=this.s.getValue("remote.localPortHost");return!t||t==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(t){return this.g=t,t?(this.c.fire(),{dispose:()=>{this.g=void 0,this.h=!1,this.m=[]}}):(this.h=!1,this.m=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(t){this.h=t.elevation,this.m=t.privacyOptions,this.j=t.protocol}get canChangeProtocol(){return this.j}get canElevate(){return this.h}get canChangePrivacy(){return this.m.length>0}get privacyOptions(){return this.m}get tunnels(){return this.u()}async u(){const t=[],c=Array.from(this.f.values());for(const l of c){const m=Array.from(l.values());for(const f of m){const $=await f.value;$&&typeof $!="string"&&t.push($)}}return t}async dispose(){super.dispose();for(const t of this.f.values()){for(const{value:c}of t.values())await c.then(l=>typeof l!="string"?l?.dispose():void 0);t.clear()}this.f.clear()}setEnvironmentTunnel(t,c,l,m,f){this.z(t,c,Promise.resolve({tunnelRemoteHost:t,tunnelRemotePort:c,localAddress:l,privacy:m,protocol:f,dispose:()=>Promise.resolve()}))}async getExistingTunnel(t,c){(s(t)||n(t))&&(t=e.$Bw[0]);const l=this.D(t,c);if(l)return++l.refcount,l.value}openTunnel(t,c,l,m,f,$=!1,I,D){this.r.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${c}:${l} on local port ${f}.`);const v=this.g??t;if(!v)return;if(c||(c="localhost"),m||(m=this.t),this.g&&this.n.has(l)){this.r.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const C=this.F(v,c,l,m,f,$,I,D);return C?C.then(P=>{if(P){if(typeof P=="string")return this.r.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.C(c,l),P}else{this.r.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.C(c,l);return}this.r.trace("ForwardedPorts: (TunnelService) New tunnel established.");const g=this.w(P);return(P.tunnelRemoteHost!==c||P.tunnelRemotePort!==l)&&this.r.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),I&&P.privacy!==I&&this.r.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(g),g}):(this.r.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),C)}w(t){return{tunnelRemotePort:t.tunnelRemotePort,tunnelRemoteHost:t.tunnelRemoteHost,tunnelLocalPort:t.tunnelLocalPort,localAddress:t.localAddress,privacy:t.privacy,protocol:t.protocol,dispose:async()=>{this.r.trace(`ForwardedPorts: (TunnelService) dispose request for ${t.tunnelRemoteHost}:${t.tunnelRemotePort} `);const c=this.f.get(t.tunnelRemoteHost);if(c){const l=c.get(t.tunnelRemotePort);l&&(l.refcount--,await this.y(t.tunnelRemoteHost,t.tunnelRemotePort,l))}}}}async y(t,c,l){if(l.refcount<=0){this.r.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${t}:${c}.`);const m=l.value.then(async f=>{f&&typeof f!="string"&&(await f.dispose(!0),this.b.fire({host:f.tunnelRemoteHost,port:f.tunnelRemotePort}))});return this.f.has(t)&&this.f.get(t).delete(c),m}}async closeTunnel(t,c){this.r.trace(`ForwardedPorts: (TunnelService) close request for ${t}:${c} `);const l=this.f.get(t);if(l&&l.has(c)){const m=l.get(c);m.refcount=0,await this.y(t,c,m)}}z(t,c,l){this.f.has(t)||this.f.set(t,new Map),this.f.get(t).set(c,{refcount:1,value:l})}async C(t,c){const l=this.f.get(t);if(l){const m=l.get(c),f=m?await m.value:void 0;(!f||typeof f=="string")&&l.delete(c),l.size===0&&this.f.delete(t)}}D(t,c){const l=[t];n(t)?(l.push(...e.$Bw),l.push(...e.$Dw)):s(t)&&l.push(...e.$Dw);const m=l.map(f=>this.f.get(f));for(const f of m){const $=f?.get(c);if($)return $}}canTunnel(t){return!!E(t)}G(t,c,l,m,f,$,I){this.r.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${c}:${l} on local port ${m}.`);const D=l;this.n.add(D);const v=m===void 0?l:m,C={elevationRequired:f?this.isPortPrivileged(v):!1},P={remoteAddress:{host:c,port:l},localAddressPort:m,privacy:$,public:$?$!==R.Private:void 0,protocol:I},g=t.forwardPort(P,C);return g?(this.z(c,l,g),g.finally(()=>{this.r.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.n.delete(D)})):this.n.delete(D),g}};e.$Hw=i,e.$Hw=i=He([Ve(0,p.$_j),Ve(1,A.$_i)],i)}),define(ke[224],Ce([1,0,3]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jl=void 0,e.$Jl=(0,w.$Fi)("IUriIdentityService")}),define(ke[225],Ce([1,0,3]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.$Iw=void 0,e.$Iw=(0,w.$Fi)("editSessionIdentityService");var S;(function(k){k[k.Complete=100]="Complete",k[k.Partial=50]="Partial",k[k.None=0]="None"})(S||(e.EditSessionIdentityMatch=S={}))}),define(ke[226],Ce([1,0,16]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1M=S,e.$2M=k,e.$3M=O,e.$4M=A,e.$5M=T;function S(p){return p.scheme!==w.Schemas.file&&p.scheme!==w.Schemas.vscodeRemote}function k(p){if(p.folders.length)return p.folders.every(a=>S(a.uri))?p.folders[0].uri:void 0;if(p.configuration&&S(p.configuration))return p.configuration}function O(p){return k(p)?.scheme}function A(p){return k(p)?.authority}function T(p){return k(p)!==void 0}}),define(ke[50],Ce([1,0,179,20,59,24,2,3,16]),function(oe,e,w,S,k,O,A,T,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8i=e.$5i=e.$4i=e.$3i=e.$2i=e.$Zi=e.$Yi=e.WorkbenchState=e.$Si=e.$Ri=e.$Oi=void 0,e.$Pi=a,e.$Qi=R,e.$Ti=y,e.$Ui=u,e.$Vi=E,e.$Wi=n,e.$Xi=s,e.$1i=i,e.$6i=r,e.$7i=t,e.$9i=c,e.$0i=l,e.$$i=m,e.$Oi=(0,T.$Fi)("contextService");function a(f){const $=f;return typeof $?.id=="string"&&A.URI.isUri($.uri)}function R(f){return typeof f?.id=="string"&&!a(f)&&!u(f)}e.$Ri={id:"ext-dev"},e.$Si={id:"empty-window"};function y(f,$){if(typeof f=="string"||typeof f>"u")return typeof f=="string"?{id:(0,S.$pc)(f)}:$?e.$Ri:e.$Si;const I=f;return I.configuration?{id:I.id,configPath:I.configuration}:I.folders.length===1?{id:I.id,uri:I.folders[0].uri}:{id:I.id}}function u(f){const $=f;return typeof $?.id=="string"&&A.URI.isUri($.configPath)}function E(f){const $=f;if($?.uri)return{id:$.id,uri:A.URI.revive($.uri)};const I=f;if(I?.configPath)return{id:I.id,configPath:A.URI.revive(I.configPath)};if(f?.id)return{id:f.id}}var d;(function(f){f[f.EMPTY=1]="EMPTY",f[f.FOLDER=2]="FOLDER",f[f.WORKSPACE=3]="WORKSPACE"})(d||(e.WorkbenchState=d={}));function n(f){const $=f;return!!($&&typeof $=="object"&&typeof $.id=="string"&&Array.isArray($.folders))}function s(f){const $=f;return!!($&&typeof $=="object"&&A.URI.isUri($.uri)&&typeof $.name=="string"&&typeof $.toResource=="function")}class o{constructor($,I,D,v,C){this.h=$,this.j=D,this.k=v,this.l=C,this.c=k.$Li.forUris(this.l,()=>!0),this.folders=I}update($){this.h=$.id,this.k=$.configuration,this.j=$.transient,this.l=$.l,this.folders=$.folders}get folders(){return this.g}set folders($){this.g=$,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration($){this.k=$}getFolder($){return $&&this.c.findSubstr($)||null}n(){this.c=k.$Li.forUris(this.l,()=>!0);for(const $ of this.folders)this.c.set($.uri,$)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$Yi=o;class h{constructor($,I){this.raw=I,this.uri=$.uri,this.index=$.index,this.name=$.name}toResource($){return(0,O.$gh)(this.uri,$)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$Zi=h;function i(f){return new h({uri:f,index:0,name:(0,O.$ch)(f)},{uri:f.toString()})}e.$2i="code-workspace",e.$3i=`.${e.$2i}`,e.$4i=[{name:(0,w.localize)(0,null),extensions:[e.$2i]}],e.$5i="workspace.json";function r(f,$){return O.$0g.isEqualOrParent(f,$.untitledWorkspacesHome)}function t(f){let $;return A.URI.isUri(f)?$=f:$=f.configuration,$?.scheme===p.Schemas.tmp}e.$8i="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function c(f){return f.id===e.$8i}function l(f,$){return!r(f,$)&&!t(f)}function m(f){return(typeof f=="string"?(0,S.$qc)(f):(0,O.$eh)(f))===e.$3i}}),define(ke[113],Ce([1,0,76,6,4,24,2,178,106,30,3,12,50,29,224,11,37,13,15]),function(oe,e,w,S,k,O,A,T,p,a,R,y,u,E,d,n,s,o,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pl=e.$Ol=e.$Ll=e.ProfileResourceType=void 0,e.$Kl=r,e.$Ml=t,e.$Nl=c;var i;(function(f){f.Settings="settings",f.Keybindings="keybindings",f.Snippets="snippets",f.Tasks="tasks",f.Extensions="extensions",f.GlobalState="globalState"})(i||(e.ProfileResourceType=i={}));function r(f){const $=f;return!!($&&typeof $=="object"&&typeof $.id=="string"&&typeof $.isDefault=="boolean"&&typeof $.name=="string"&&A.URI.isUri($.location)&&A.URI.isUri($.globalStorageHome)&&A.URI.isUri($.settingsResource)&&A.URI.isUri($.keybindingsResource)&&A.URI.isUri($.tasksResource)&&A.URI.isUri($.snippetsHome)&&A.URI.isUri($.extensionsResource))}e.$Ll=(0,R.$Fi)("IUserDataProfilesService");function t(f,$){return{id:f.id,isDefault:f.isDefault,name:f.name,shortName:f.shortName,icon:f.icon,location:A.URI.revive(f.location).with({scheme:$}),globalStorageHome:A.URI.revive(f.globalStorageHome).with({scheme:$}),settingsResource:A.URI.revive(f.settingsResource).with({scheme:$}),keybindingsResource:A.URI.revive(f.keybindingsResource).with({scheme:$}),tasksResource:A.URI.revive(f.tasksResource).with({scheme:$}),snippetsHome:A.URI.revive(f.snippetsHome).with({scheme:$}),extensionsResource:A.URI.revive(f.extensionsResource).with({scheme:$}),cacheHome:A.URI.revive(f.cacheHome).with({scheme:$}),useDefaultFlags:f.useDefaultFlags,isTransient:f.isTransient}}function c(f,$,I,D,v,C){return{id:f,name:$,location:I,isDefault:!1,shortName:v?.shortName,icon:v?.icon,globalStorageHome:C&&v?.useDefaultFlags?.globalState?C.globalStorageHome:(0,O.$gh)(I,"globalStorage"),settingsResource:C&&v?.useDefaultFlags?.settings?C.settingsResource:(0,O.$gh)(I,"settings.json"),keybindingsResource:C&&v?.useDefaultFlags?.keybindings?C.keybindingsResource:(0,O.$gh)(I,"keybindings.json"),tasksResource:C&&v?.useDefaultFlags?.tasks?C.tasksResource:(0,O.$gh)(I,"tasks.json"),snippetsHome:C&&v?.useDefaultFlags?.snippets?C.snippetsHome:(0,O.$gh)(I,"snippets"),extensionsResource:C&&v?.useDefaultFlags?.extensions?C.extensionsResource:(0,O.$gh)(I,"extensions.json"),cacheHome:(0,O.$gh)(D,f),useDefaultFlags:v?.useDefaultFlags,isTransient:v?.transient}}let l=class extends k.$Wc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor($,I,D,v){super(),this.t=$,this.u=I,this.w=D,this.y=v,this.f=!0,this.h=this.B(new S.$me),this.onDidChangeProfiles=this.h.event,this.j=this.B(new S.$me),this.onWillCreateProfile=this.j.event,this.m=this.B(new S.$me),this.onWillRemoveProfile=this.m.event,this.n=this.B(new S.$me),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],folders:new E.$Cc,workspaces:new E.$Cc,emptyWindows:new Map},this.profilesHome=(0,O.$gh)(this.t.userRoamingDataHome,"profiles"),this.g=(0,O.$gh)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement($){this.f!==$&&(this.z=void 0,this.f=$)}isEnabled(){return this.f}get C(){if(!this.z){const $=this.D(),I=[$];if(this.f)try{for(const C of this.O()){if(!C.name||!(0,h.$fg)(C.name)||!C.location){this.y.warn("Skipping the invalid stored profile",C.location||C.name);continue}I.push(c((0,O.$dh)(C.location),C.name,C.location,this.g,{shortName:C.shortName,icon:C.icon,useDefaultFlags:C.useDefaultFlags},$))}}catch(C){this.y.error(C)}const D=new E.$Cc,v=new Map;if(I.length)try{const C=this.Q();if(C.workspaces)for(const[P,g]of Object.entries(C.workspaces)){const b=A.URI.parse(P),L=I.find(N=>N.id===g);L&&D.set(b,L)}if(C.emptyWindows)for(const[P,g]of Object.entries(C.emptyWindows)){const b=I.find(L=>L.id===g);b&&v.set(P,b)}}catch(C){this.y.error(C)}this.z={profiles:I,workspaces:D,emptyWindows:v}}return this.z}D(){const $=c("__default__profile__",(0,T.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...$,extensionsResource:this.S()??$.extensionsResource,isDefault:!0}}async createTransientProfile($){const I="Temp",D=new RegExp(`${(0,o.$if)(I)}\\s(\\d+)`);let v=0;for(const P of this.profiles){const g=D.exec(P.name),b=g?parseInt(g[1]):0;v=b>v?b:v}const C=`${I} ${v+1}`;return this.createProfile((0,w.$tj)((0,s.$2g)()).toString(16),C,{transient:!0},$)}async createNamedProfile($,I,D){return this.createProfile((0,w.$tj)((0,s.$2g)()).toString(16),$,I,D)}async createProfile($,I,D,v){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const C=await this.F($,I,D);return v&&await this.setProfileForWorkspace(v,C),C}async F($,I,D){if(!(0,h.$fg)(I)||!I)throw new Error("Name of the profile is mandatory and must be of type `string`");let v=this.r.get(I);return v||(v=(async()=>{try{if(this.profiles.find(b=>b.name===I||b.id===$))throw new Error(`Profile with ${I} name already exists`);const P=c($,I,(0,O.$gh)(this.profilesHome,$),this.g,D,this.defaultProfile);await this.u.createFolder(P.location);const g=[];return this.j.fire({profile:P,join(b){g.push(b)}}),await n.Promises.settled(g),this.I([P],[],[]),P}finally{this.r.delete(I)}})(),this.r.set(I,v)),v}async updateProfile($,I){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let D=this.profiles.find(v=>v.id===$.id);if(!D)throw new Error(`Profile '${$.name}' does not exist`);return D=c(D.id,I.name??D.name,D.location,this.g,{shortName:I.shortName??D.shortName,icon:I.icon===null?void 0:I.icon??D.icon,transient:I.transient??D.isTransient,useDefaultFlags:I.useDefaultFlags??D.useDefaultFlags},this.defaultProfile),this.I([],[],[D]),D}async removeProfile($){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if($.isDefault)throw new Error("Cannot remove default profile");const I=this.profiles.find(v=>v.id===$.id);if(!I)throw new Error(`Profile '${$.name}' does not exist`);const D=[];this.m.fire({profile:I,join(v){D.push(v)}});try{await Promise.allSettled(D)}catch(v){this.y.error(v)}for(const v of[...this.C.emptyWindows.keys()])I.id===this.C.emptyWindows.get(v)?.id&&this.C.emptyWindows.delete(v);for(const v of[...this.C.workspaces.keys()])I.id===this.C.workspaces.get(v)?.id&&this.C.workspaces.delete(v);this.M(),this.I([],[I],[]);try{await this.u.del(I.cacheHome,{recursive:!0})}catch(v){(0,a.$ql)(v)!==a.FileOperationResult.FILE_NOT_FOUND&&this.y.error(v)}}async setProfileForWorkspace($,I){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const D=this.profiles.find(v=>v.id===I.id);if(!D)throw new Error(`Profile '${I.name}' does not exist`);this.L($,D)}unsetWorkspace($,I){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L($,void 0,I)}async resetWorkspaces(){this.s.folders.clear(),this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const $=await this.u.resolve(this.profilesHome);await Promise.all(($.children||[]).filter(I=>I.isDirectory&&this.profiles.every(D=>!this.w.extUri.isEqual(D.location,I.resource))).map(I=>this.u.del(I.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const $=this.s.profiles.filter(I=>!this.H(I));await Promise.allSettled($.map(I=>this.removeProfile(I)))}getProfileForWorkspace($){const I=this.G($),D=A.URI.isUri(I)?this.C.workspaces.get(I):this.C.emptyWindows.get(I);return D||((0,u.$Pi)($)?this.s.folders.get($.uri):(0,u.$Ui)($)?this.s.workspaces.get($.configPath):this.s.emptyWindows.get($.id))}G($){return(0,u.$Pi)($)?$.uri:(0,u.$Ui)($)?$.configPath:$.id}H($){return!!([...this.C.emptyWindows.values()].some(I=>this.w.extUri.isEqual(I.location,$.location))||[...this.C.workspaces.values()].some(I=>this.w.extUri.isEqual(I.location,$.location))||[...this.s.emptyWindows.values()].some(I=>this.w.extUri.isEqual(I.location,$.location))||[...this.s.workspaces.values()].some(I=>this.w.extUri.isEqual(I.location,$.location))||[...this.s.folders.values()].some(I=>this.w.extUri.isEqual(I.location,$.location)))}I($,I,D){const v=[...this.profiles,...$],C=[],P=this.s.profiles;this.s.profiles=[];for(let g of v){if(g.isDefault||I.some(L=>g.id===L.id))continue;g=D.find(L=>g.id===L.id)??g;const b=P.find(L=>g.id===L.id);if(g.isTransient)this.s.profiles.push(g);else{if(b){for(const[L,N]of this.s.emptyWindows.entries())if(g.id===N.id){this.L({id:L},g);break}for(const[L,N]of this.s.workspaces.entries())if(g.id===N.id){this.L({id:"",configPath:L},g);break}for(const[L,N]of this.s.folders.entries())if(g.id===N.id){this.L({id:"",uri:L},g);break}}C.push({location:g.location,name:g.name,shortName:g.shortName,icon:g.icon,useDefaultFlags:g.useDefaultFlags})}}this.P(C),this.z=void 0,this.J($,I,D)}J($,I,D){this.h.fire({added:$,removed:I,updated:D,all:this.profiles})}L($,I,D){if(D=I?.isTransient?!0:D,D)(0,u.$Pi)($)?(this.s.folders.delete($.uri),I&&this.s.folders.set($.uri,I)):(0,u.$Ui)($)?(this.s.workspaces.delete($.configPath),I&&this.s.workspaces.set($.configPath,I)):(this.s.emptyWindows.delete($.id),I&&this.s.emptyWindows.set($.id,I));else{this.L($,void 0,!0);const v=this.G($);A.URI.isUri(v)?(this.C.workspaces.delete(v),I&&this.C.workspaces.set(v,I)):(this.C.emptyWindows.delete(v),I&&this.C.emptyWindows.set(v,I)),this.M()}}M(){const $={};for(const[D,v]of this.C.workspaces.entries())$[D.toString()]=v.id;const I={};for(const[D,v]of this.C.emptyWindows.entries())I[D.toString()]=v.id;this.R({workspaces:$,emptyWindows:I}),this.z=void 0}N($){const I={},D=this.D();if($.workspaces)for(const[C,P]of Object.entries($.workspaces)){const g=A.URI.parse(P);I[C]=this.w.extUri.isEqual(g,D.location)?D.id:this.w.extUri.basename(g)}const v={};if($.emptyWindows)for(const[C,P]of Object.entries($.emptyWindows)){const g=A.URI.parse(P);v[C]=this.w.extUri.isEqual(g,D.location)?D.id:this.w.extUri.basename(g)}return{workspaces:I,emptyWindows:v}}O(){return[]}P($){throw new Error("not implemented")}Q(){return{}}R($){throw new Error("not implemented")}S(){}};e.$Ol=l,e.$Ol=l=He([Ve(0,p.$Mi),Ve(1,a.$_k),Ve(2,d.$Jl),Ve(3,y.$_j)],l);class m extends l{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P($){this.a=$}Q(){return this.X}R($){this.X=$}}e.$Pl=m}),define(ke[227],Ce([1,0,11,6,4,65,15,161,3,113]),function(oe,e,w,S,k,O,A,T,p,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fq=e.$dq=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$bq=e.$aq=e.$_p=void 0,e.$cq=E,e.$eq=n,e.$gq=o,e.$_p="__$__isNewStorageMarker",e.$aq="__$__targetStorageMarker",e.$bq=(0,p.$Fi)("storageService");var R;(function(h){h[h.NONE=0]="NONE",h[h.SHUTDOWN=1]="SHUTDOWN"})(R||(e.WillSaveStateReason=R={}));var y;(function(h){h[h.APPLICATION=-1]="APPLICATION",h[h.PROFILE=0]="PROFILE",h[h.WORKSPACE=1]="WORKSPACE"})(y||(e.StorageScope=y={}));var u;(function(h){h[h.USER=0]="USER",h[h.MACHINE=1]="MACHINE"})(u||(e.StorageTarget=u={}));function E(h){const i=h.get(e.$aq);if(i)try{return JSON.parse(i)}catch{}return Object.create(null)}class d extends k.$Wc{static{this.a=60*1e3}constructor(i={flushInterval:d.a}){super(),this.m=i,this.b=this.B(new S.$pe),this.c=this.B(new S.$pe),this.onDidChangeTarget=this.c.event,this.f=this.B(new S.$me),this.onWillSaveState=this.f.event,this.h=this.B(new w.$Rh(()=>this.n(),this.m.flushInterval)),this.j=this.B(new k.$Xc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(i,r,t){return S.Event.filter(this.b.event,c=>c.scope===i&&(r===void 0||c.key===r),t)}n(){this.j.value=(0,w.$Vh)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,k.$Rc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,O.mark)("code/willInitStorage");try{await this.O()}finally{(0,O.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(i,r){const{key:t,external:c}=r;if(t===e.$aq){switch(i){case y.APPLICATION:this.H=void 0;break;case y.PROFILE:this.F=void 0;break;case y.WORKSPACE:this.C=void 0;break}this.c.fire({scope:i})}else this.b.fire({scope:i,key:t,target:this.J(i)[t],external:c})}w(i){this.f.fire({reason:i})}get(i,r,t){return this.P(r)?.get(i,t)}getBoolean(i,r,t){return this.P(r)?.getBoolean(i,t)}getNumber(i,r,t){return this.P(r)?.getNumber(i,t)}getObject(i,r,t){return this.P(r)?.getObject(i,t)}storeAll(i,r){this.y(()=>{for(const t of i)this.store(t.key,t.value,t.scope,t.target,r)})}store(i,r,t,c,l=!1){if((0,A.$og)(r)){this.remove(i,t,l);return}this.y(()=>{this.z(i,t,c),this.P(t)?.set(i,r,l)})}remove(i,r,t=!1){this.y(()=>{this.z(i,r,void 0),this.P(r)?.delete(i,t)})}y(i){this.b.pause(),this.c.pause();try{i()}finally{this.b.resume(),this.c.resume()}}keys(i,r){const t=[],c=this.J(i);for(const l of Object.keys(c))c[l]===r&&t.push(l);return t}z(i,r,t,c=!1){const l=this.J(r);typeof t=="number"?l[i]!==t&&(l[i]=t,this.P(r)?.set(e.$aq,JSON.stringify(l),c)):typeof l[i]=="number"&&(delete l[i],this.P(r)?.set(e.$aq,JSON.stringify(l),c))}get D(){return this.C||(this.C=this.L(y.WORKSPACE)),this.C}get G(){return this.F||(this.F=this.L(y.PROFILE)),this.F}get I(){return this.H||(this.H=this.L(y.APPLICATION)),this.H}J(i){switch(i){case y.APPLICATION:return this.I;case y.PROFILE:return this.G;default:return this.D}}L(i){const r=this.P(i);return r?E(r):Object.create(null)}isNew(i){return this.getBoolean(e.$_p,i)===!0}async flush(i=R.NONE){this.f.fire({reason:i});const r=this.P(y.APPLICATION),t=this.P(y.PROFILE),c=this.P(y.WORKSPACE);switch(i){case R.NONE:await w.Promises.settled([r?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve(),c?.whenFlushed()??Promise.resolve()]);break;case R.SHUTDOWN:await w.Promises.settled([r?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve(),c?.flush(0)??Promise.resolve()]);break}}async log(){const i=this.P(y.APPLICATION)?.items??new Map,r=this.P(y.PROFILE)?.items??new Map,t=this.P(y.WORKSPACE)?.items??new Map;return o(i,r,t,this.Q(y.APPLICATION)??"",this.Q(y.PROFILE)??"",this.Q(y.WORKSPACE)??"")}async optimize(i){return await this.flush(),this.P(i)?.optimize()}async switch(i,r){return this.w(R.NONE),(0,a.$Kl)(i)?this.R(i,r):this.S(i,r)}M(i,r){return!(i.id===r.id||n(r)&&n(i))}N(i,r,t){this.y(()=>{const c=new Set;for(const[l,m]of i)c.add(l),r.get(l)!==m&&this.u(t,{key:l,external:!0});for(const[l]of r.items)c.has(l)||this.u(t,{key:l,external:!0})})}}e.$dq=d;function n(h){return h.isDefault||!!h.useDefaultFlags?.globalState}class s extends d{constructor(){super(),this.U=this.B(new T.$0p(new T.$$p,{hint:T.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new T.$0p(new T.$$p,{hint:T.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new T.$0p(new T.$$p,{hint:T.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(i=>this.u(y.WORKSPACE,i))),this.B(this.W.onDidChangeStorage(i=>this.u(y.PROFILE,i))),this.B(this.U.onDidChangeStorage(i=>this.u(y.APPLICATION,i)))}P(i){switch(i){case y.APPLICATION:return this.U;case y.PROFILE:return this.W;default:return this.X}}Q(i){switch(i){case y.APPLICATION:return"inMemory (application)";case y.PROFILE:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(i){return!1}}e.$fq=s;async function o(h,i,r,t,c,l){const m=b=>{try{return JSON.parse(b)}catch{return b}},f=new Map,$=new Map;h.forEach((b,L)=>{f.set(L,b),$.set(L,m(b))});const I=new Map,D=new Map;i.forEach((b,L)=>{I.set(L,b),D.set(L,m(b))});const v=new Map,C=new Map;r.forEach((b,L)=>{v.set(L,b),C.set(L,m(b))}),console.group(t!==c?`Storage: Application (path: ${t})`:`Storage: Application & Profile (path: ${t}, default profile)`);const P=[];if(f.forEach((b,L)=>{P.push({key:L,value:b})}),console.table(P),console.groupEnd(),console.log($),t!==c){console.group(`Storage: Profile (path: ${c}, profile specific)`);const b=[];I.forEach((L,N)=>{b.push({key:N,value:L})}),console.table(b),console.groupEnd(),console.log(D)}console.group(`Storage: Workspace (path: ${l})`);const g=[];v.forEach((b,L)=>{g.push({key:L,value:b})}),console.table(g),console.groupEnd(),console.log(C)}}),define(ke[80],Ce([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rnc=void 0;class w{static{this.a=!1}constructor(k){this.d=k,this.b=new Map,this.c=1}add(k){const O=this.c++;return this.b.set(O,k),this.e(),O}get(k,O){return this.b.has(k)?this.b.get(k)[O]:void 0}delete(k){this.b.delete(k),this.e()}e(){w.a&&console.log(`${this.d} cache size - ${this.b.size}`)}}e.$Rnc=w}),define(ke[51],Ce([1,0,16,24,30,3]),function(oe,e,w,S,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xnc=e.$Wnc=void 0;class A{constructor(){this.a=new Set(Object.keys(w.Schemas)),this.b=new Map,this.extUri=new S.$8g(p=>{const a=this.b.get(p.scheme);return!(a===void 0||a&k.FileSystemProviderCapabilities.PathCaseSensitive)})}$acceptProviderInfos(p,a){a===null?this.b.delete(p.scheme):this.b.set(p.scheme,a)}isFreeScheme(p){return!this.b.has(p)&&!this.a.has(p)}getCapabilities(p){return this.b.get(p)}}e.$Wnc=A,e.$Xnc=(0,O.$Fi)("IExtHostFileSystemInfo")}),define(ke[27],Ce([1,0,3]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bQ=void 0,e.$bQ=(0,w.$Fi)("IExtHostInitDataService")}),define(ke[228],Ce([1,0,184,12,213,27]),function(oe,e,w,S,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6pc=void 0;let A=class extends k.$lR{constructor(p,a,R){const y=R.remote.isRemote?"remoteexthost":p?"workerexthost":"exthost",u=R.remote.isRemote?(0,w.localize)(0,null):p?(0,w.localize)(1,null):(0,w.localize)(2,null);super(a.createLogger(y,{name:u}))}};e.$6pc=A,e.$6pc=A=He([Ve(1,S.$ak),Ve(2,O.$bQ)],A)}),define(ke[229],Ce([1,0,11]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Doc=e.$Coc=void 0;class S{constructor(A,T,p){this.h=new Map,this.a=A,this.b=T,this.c=p,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(a=>(this.f=a,this)),this.g=this.c.onDidChangeStorage(a=>{a.shared===this.b&&a.key===this.a&&(this.f=a.value)}),this.i=new w.$Rh(()=>{const a=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const R of a.values())R.complete()}catch(R){for(const y of a.values())y.error(R)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,A])=>A!==void 0).map(([A])=>A)}get whenReady(){return this.d}get(A,T){let p=this.f[A];return typeof p>"u"&&(p=T),p}update(A,T){this.f[A]=T;const p=this.h.get(A);if(p!==void 0)return p.p;const a=new w.$3h;return this.h.set(A,a),this.i.isScheduled()||this.i.schedule(),a.p}dispose(){this.g.dispose()}}e.$Coc=S;class k extends S{setKeysForSync(A){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},A)}constructor(A,T){super(A.identifier.value,!0,T),this.j=A}}e.$Doc=k}),define(ke[230],Ce([1,0,6,2]),function(oe,e,w,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wpc=void 0;class k{constructor(A){this.c=A,this.a=new w.$me,this.onDidSaveNotebookDocument=this.a.event,this.b=new w.$me,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(A,T,p,a){const y=this.c.getNotebookDocument(S.URI.revive(A)).acceptModelChanged(T.value,p,a);this.b.fire(y)}$acceptDirtyStateChanged(A,T){this.c.getNotebookDocument(S.URI.revive(A)).acceptDirty(T)}$acceptModelSaved(A){const T=this.c.getNotebookDocument(S.URI.revive(A));this.a.fire(T.apiNotebook)}}e.$wpc=k}),define(ke[17],Ce([1,0,3]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$YP=e.$XP=void 0,e.$XP=(0,w.$Fi)("IExtHostRpcService");class S{constructor(O){this.getProxy=O.getProxy.bind(O),this.set=O.set.bind(O),this.dispose=O.dispose.bind(O),this.assertRegistered=O.assertRegistered.bind(O),this.drain=O.drain.bind(O)}}e.$YP=S}),define(ke[231],Ce([1,0,19,6]),function(oe,e,w,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Moc=void 0;class k{#e;constructor(A,T){this.b=new S.$me,this.onDidChange=this.b.event,this.a=w.$qn.toKey(A.identifier),this.#e=T,this.#e.onDidChangePassword(p=>{p.extensionId===this.a&&this.b.fire({key:p.key})})}get(A){return this.#e.get(this.a,A)}store(A,T){return this.#e.store(this.a,A,T)}delete(A){return this.#e.delete(this.a,A)}}e.$Moc=k}),define(ke[66],Ce([1,0,3]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$boc=e.$aoc=void 0,e.$aoc=(0,w.$Fi)("IURITransformerService");class S{constructor(O){O?(this.transformIncoming=O.transformIncoming.bind(O),this.transformOutgoing=O.transformOutgoing.bind(O),this.transformOutgoingURI=O.transformOutgoingURI.bind(O),this.transformOutgoingScheme=O.transformOutgoingScheme.bind(O)):(this.transformIncoming=A=>A,this.transformOutgoing=A=>A,this.transformOutgoingURI=A=>A,this.transformOutgoingScheme=A=>A)}}e.$boc=S});var ti=this&&this.__importDefault||function(oe){return oe&&oe.__esModule?oe:{default:oe}};define(ke[114],Ce([1,0,193,15,2,4,3,31,30,16,48,155,36]),function(oe,e,w,S,k,O,A,T,p,a,R,y,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorsOrder=e.CloseDirection=e.$aG=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.$3F=e.EditorInputCapabilities=e.$2F=e.SaveReason=e.Verbosity=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.$RF=e.$QF=e.$PF=e.$OF=e.$NF=void 0,e.$SF=n,e.$TF=s,e.$UF=o,e.$VF=h,e.$WF=i,e.$XF=r,e.$YF=t,e.$ZF=c,e.$1F=l,e.$4F=v,e.$5F=P,e.$6F=g,e.$7F=b,e.$8F=L,e.$9F=N,e.$0F=B,e.$$F=G,e.$_F=te,e.$bG=ce,e.$cG=se,e.$dG=Ie,e.$eG=Ue,u=ti(u),e.$NF={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.$OF={id:"default",displayName:(0,w.localize)(0,null),providerDisplayName:(0,w.localize)(1,null)},e.$PF="workbench.editor.sidebysideEditor",e.$QF="workbench.editors.textDiffEditor",e.$RF="workbench.editors.binaryResourceDiffEditor";var E;(function(Z){Z[Z.PROGRAMMATIC=1]="PROGRAMMATIC",Z[Z.USER=2]="USER",Z[Z.EDIT=3]="EDIT",Z[Z.NAVIGATION=4]="NAVIGATION",Z[Z.JUMP=5]="JUMP"})(E||(e.EditorPaneSelectionChangeReason=E={}));var d;(function(Z){Z[Z.IDENTICAL=1]="IDENTICAL",Z[Z.SIMILAR=2]="SIMILAR",Z[Z.DIFFERENT=3]="DIFFERENT"})(d||(e.EditorPaneSelectionCompareResult=d={}));function n(Z){const V=Z;return!!V&&typeof V.getSelection=="function"&&!!V.onDidChangeSelection}function s(Z){const V=Z;return!!V&&typeof V.getScrollPosition=="function"&&typeof V.setScrollPosition=="function"&&!!V.onDidChangeScroll}function o(Z,V,_){for(const ye of _.visibleEditorPanes)if(ye.group.id===V&&Z.matches(ye.input))return ye.getViewState()}function h(Z){if(v(Z))return!1;const V=Z;return k.URI.isUri(V?.resource)}function i(Z){if(v(Z))return!1;const V=Z;return V?.original!==void 0&&V.modified!==void 0}function r(Z){if(v(Z))return!1;const V=Z;return!V||V.resources&&!Array.isArray(V.resources)?!1:!!V.resources||!!V.multiDiffSource}function t(Z){if(v(Z)||i(Z))return!1;const V=Z;return V?.primary!==void 0&&V.secondary!==void 0}function c(Z){if(v(Z))return!1;const V=Z;return V?V.resource===void 0||V.resource.scheme===a.Schemas.untitled||V.forceUntitled===!0:!1}function l(Z){if(v(Z))return!1;const V=Z;return k.URI.isUri(V?.base?.resource)&&k.URI.isUri(V?.input1?.resource)&&k.URI.isUri(V?.input2?.resource)&&k.URI.isUri(V?.result?.resource)}var m;(function(Z){Z[Z.SHORT=0]="SHORT",Z[Z.MEDIUM=1]="MEDIUM",Z[Z.LONG=2]="LONG"})(m||(e.Verbosity=m={}));var f;(function(Z){Z[Z.EXPLICIT=1]="EXPLICIT",Z[Z.AUTO=2]="AUTO",Z[Z.FOCUS_CHANGE=3]="FOCUS_CHANGE",Z[Z.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(f||(e.SaveReason=f={}));class ${constructor(){this.a=new Map}registerSource(V,_){let ye=this.a.get(V);return ye||(ye={source:V,label:_},this.a.set(V,ye)),ye.source}getSourceLabel(V){return this.a.get(V)?.label??V}}e.$2F=new $;var I;(function(Z){Z[Z.None=0]="None",Z[Z.Readonly=2]="Readonly",Z[Z.Untitled=4]="Untitled",Z[Z.Singleton=8]="Singleton",Z[Z.RequiresTrust=16]="RequiresTrust",Z[Z.CanSplitInGroup=32]="CanSplitInGroup",Z[Z.ForceDescription=64]="ForceDescription",Z[Z.CanDropIntoEditor=128]="CanDropIntoEditor",Z[Z.MultipleEditors=256]="MultipleEditors",Z[Z.Scratchpad=512]="Scratchpad"})(I||(e.EditorInputCapabilities=I={}));class D extends O.$Wc{}e.$3F=D;function v(Z){return Z instanceof D}function C(Z){const V=Z;return k.URI.isUri(V?.preferredResource)}function P(Z){const V=Z;return v(V?.primary)&&v(V?.secondary)}function g(Z){const V=Z;return v(V?.modified)&&v(V?.original)}function b(Z,V,_,ye,ae){return Ue(ye,[(0,y.$pj)({id:"workbench.action.openLargeFile",label:(0,w.localize)(2,null),run:()=>{const we={..._,limits:{size:Number.MAX_VALUE}};Z.openEditor(V,we)}}),(0,y.$pj)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,w.localize)(3,null),run:()=>ae.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:u.default.Warning})}function L(Z){return v(Z?.editor)}function N(Z){const V=Z;return L(Z)&&V?.group!==void 0}function B(Z){const V=Z;return typeof V?.groupId=="number"&&v(V.editor)}function G(Z){return typeof Z?.groupId=="number"}var W;(function(Z){Z[Z.UNKNOWN=0]="UNKNOWN",Z[Z.REPLACE=1]="REPLACE",Z[Z.MOVE=2]="MOVE",Z[Z.UNPIN=3]="UNPIN"})(W||(e.EditorCloseContext=W={}));var F;(function(Z){Z[Z.GROUP_ACTIVE=0]="GROUP_ACTIVE",Z[Z.GROUP_INDEX=1]="GROUP_INDEX",Z[Z.GROUP_LABEL=2]="GROUP_LABEL",Z[Z.GROUP_LOCKED=3]="GROUP_LOCKED",Z[Z.EDITORS_SELECTION=4]="EDITORS_SELECTION",Z[Z.EDITOR_OPEN=5]="EDITOR_OPEN",Z[Z.EDITOR_CLOSE=6]="EDITOR_CLOSE",Z[Z.EDITOR_MOVE=7]="EDITOR_MOVE",Z[Z.EDITOR_ACTIVE=8]="EDITOR_ACTIVE",Z[Z.EDITOR_LABEL=9]="EDITOR_LABEL",Z[Z.EDITOR_CAPABILITIES=10]="EDITOR_CAPABILITIES",Z[Z.EDITOR_PIN=11]="EDITOR_PIN",Z[Z.EDITOR_TRANSIENT=12]="EDITOR_TRANSIENT",Z[Z.EDITOR_STICKY=13]="EDITOR_STICKY",Z[Z.EDITOR_DIRTY=14]="EDITOR_DIRTY",Z[Z.EDITOR_WILL_DISPOSE=15]="EDITOR_WILL_DISPOSE"})(F||(e.GroupModelChangeKind=F={}));var q;(function(Z){Z[Z.PRIMARY=1]="PRIMARY",Z[Z.SECONDARY=2]="SECONDARY",Z[Z.BOTH=3]="BOTH",Z[Z.ANY=4]="ANY"})(q||(e.SideBySideEditor=q={}));class ue{getOriginalUri(V,_){if(!V)return;if(l(V))return e.$aG.getOriginalUri(V.result,_);if(_?.supportSideBySide){const{primary:ae,secondary:we}=this.a(V);if(ae&&we){if(_?.supportSideBySide===q.BOTH)return{primary:this.getOriginalUri(ae,{filterByScheme:_.filterByScheme}),secondary:this.getOriginalUri(we,{filterByScheme:_.filterByScheme})};if(_?.supportSideBySide===q.ANY)return this.getOriginalUri(ae,{filterByScheme:_.filterByScheme})??this.getOriginalUri(we,{filterByScheme:_.filterByScheme});V=_.supportSideBySide===q.PRIMARY?ae:we}}if(i(V)||r(V)||t(V)||l(V))return;const ye=C(V)?V.preferredResource:V.resource;return!ye||!_||!_.filterByScheme?ye:this.b(ye,_.filterByScheme)}a(V){return P(V)||t(V)?{primary:V.primary,secondary:V.secondary}:g(V)||i(V)?{primary:V.modified,secondary:V.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(V,_){if(!V)return;if(l(V))return e.$aG.getCanonicalUri(V.result,_);if(_?.supportSideBySide){const{primary:ae,secondary:we}=this.a(V);if(ae&&we){if(_?.supportSideBySide===q.BOTH)return{primary:this.getCanonicalUri(ae,{filterByScheme:_.filterByScheme}),secondary:this.getCanonicalUri(we,{filterByScheme:_.filterByScheme})};if(_?.supportSideBySide===q.ANY)return this.getCanonicalUri(ae,{filterByScheme:_.filterByScheme})??this.getCanonicalUri(we,{filterByScheme:_.filterByScheme});V=_.supportSideBySide===q.PRIMARY?ae:we}}if(i(V)||r(V)||t(V)||l(V))return;const ye=V.resource;return!ye||!_||!_.filterByScheme?ye:this.b(ye,_.filterByScheme)}b(V,_){if(Array.isArray(_)){if(_.some(ye=>V.scheme===ye))return V}else if(_===V.scheme)return V}}var ge;(function(Z){Z[Z.UNKNOWN=0]="UNKNOWN",Z[Z.KEYBOARD=1]="KEYBOARD",Z[Z.MOUSE=2]="MOUSE"})(ge||(e.EditorCloseMethod=ge={}));function te(Z,V,_,ye){if(!Z.isSticky(V))return!1;switch(ye.preventPinnedEditorClose){case"keyboardAndMouse":return _===ge.MOUSE||_===ge.KEYBOARD;case"mouse":return _===ge.MOUSE;case"keyboard":return _===ge.KEYBOARD}return!1}e.$aG=new ue;var me;(function(Z){Z[Z.LEFT=0]="LEFT",Z[Z.RIGHT=1]="RIGHT"})(me||(e.CloseDirection=me={}));class re{constructor(){this.c=new Map,this.d=new Map}start(V){const _=this.a=V.get(A.$Ei);for(const[ye,ae]of this.c)this.e(ye,ae,_);this.c.clear()}e(V,_,ye){const ae=ye.createInstance(_);this.d.set(V,ae)}registerFileEditorFactory(V){if(this.b)throw new Error("Can only register one file editor factory.");this.b=V}getFileEditorFactory(){return(0,S.$qg)(this.b)}registerEditorSerializer(V,_){if(this.c.has(V)||this.d.has(V))throw new Error(`A editor serializer with type ID '${V}' was already registered.`);return this.a?this.e(V,_,this.a):this.c.set(V,_),(0,O.$Uc)(()=>{this.c.delete(V),this.d.delete(V)})}getEditorSerializer(V){return this.d.get(typeof V=="string"?V:V.typeId)}}T.$oo.add(e.$NF.EditorFactory,new re);async function ce(Z,V,_){return!Z||!Z.length?[]:await Promise.all(Z.map(async ye=>{const ae=k.URI.revive(ye.fileUri);if(!ae){_.info("Cannot resolve the path because it is not valid.",ye);return}if(!await V.canHandleResource(ae)){_.info("Cannot resolve the path because it cannot be handled",ye);return}let he=ye.exists,X=ye.type;if(typeof he!="boolean"||typeof X!="number")try{X=(await V.stat(ae)).isDirectory?p.FileType.Directory:p.FileType.Unknown,he=!0}catch(pe){_.error(pe),he=!1}if(!he&&ye.openOnlyIfExists){_.info("Cannot resolve the path because it does not exist",ye);return}if(X===p.FileType.Directory){_.info("Cannot resolve the path because it is a directory",ye);return}const Y={...ye.options,pinned:!0};return he?{resource:ae,options:Y}:{resource:ae,options:Y,forceUntitled:!0}}))}var be;(function(Z){Z[Z.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",Z[Z.SEQUENTIAL=1]="SEQUENTIAL"})(be||(e.EditorsOrder=be={}));function se(Z){const V=Z;if(!V)return!1;const _=V;if(_.modified)return se(_.modified);const ye=V;return!!(ye.contributionsState&&ye.viewState&&Array.isArray(ye.cursorState))}function Ie(Z){return(0,R.$rj)(Z)}function Ue(Z,V,_){const ye=(0,R.$sj)(Z,V);return ye.forceMessage=_?.forceMessage,ye.forceSeverity=_?.forceSeverity,ye.allowDialog=_?.allowDialog,ye}}),define(ke[232],Ce([1,0,6,194,3,4,29,31,26,98,222]),function(oe,e,w,S,k,O,A,T,p,a,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mG=e.$lG=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.$kG=e.ViewContentGroups=e.$iG=e.ViewContainerLocation=e.Extensions=e.$hG=e.$gG=e.$fG=void 0,e.$jG=E,e.$fG="views",e.$gG=(0,S.localize)(0,null),e.$hG=(0,R.$tx)("default-view-icon",a.$5j.window,(0,S.localize)(1,null));var y;(function(c){c.ViewContainersRegistry="workbench.registry.view.containers",c.ViewsRegistry="workbench.registry.view"})(y||(e.Extensions=y={}));var u;(function(c){c[c.Sidebar=0]="Sidebar",c[c.Panel=1]="Panel",c[c.AuxiliaryBar=2]="AuxiliaryBar"})(u||(e.ViewContainerLocation=u={})),e.$iG=[u.Sidebar,u.Panel,u.AuxiliaryBar];function E(c){switch(c){case u.Sidebar:return"sidebar";case u.Panel:return"panel";case u.AuxiliaryBar:return"auxiliarybar"}}class d extends O.$Wc{constructor(){super(...arguments),this.c=this.B(new w.$me),this.onDidRegister=this.c.event,this.f=this.B(new w.$me),this.onDidDeregister=this.f.event,this.g=new Map,this.h=[]}get all(){return[...this.g.values()].flat()}registerViewContainer(l,m,f){const $=this.get(l.id);if($)return $;const I=l;return I.openCommandActionDescriptor=f?.doNotRegisterOpenCommand?void 0:I.openCommandActionDescriptor??{id:I.id},(0,A.$zc)(this.g,m,[]).push(I),f?.isDefault&&this.h.push(I),this.c.fire({viewContainer:I,viewContainerLocation:m}),I}deregisterViewContainer(l){for(const m of this.g.keys()){const f=this.g.get(m),$=f?.indexOf(l);if($!==-1){f?.splice($,1),f.length===0&&this.g.delete(m),this.f.fire({viewContainer:l,viewContainerLocation:m});return}}}get(l){return this.all.filter(m=>m.id===l)[0]}getViewContainers(l){return[...this.g.get(l)||[]]}getViewContainerLocation(l){return[...this.g.keys()].filter(m=>this.getViewContainers(m).filter(f=>f?.id===l.id).length>0)[0]}getDefaultViewContainer(l){return this.h.find(m=>this.getViewContainerLocation(m)===l)}}T.$oo.add(y.ViewContainersRegistry,new d);var n;(function(c){c.Open="2_open",c.Debug="4_debug",c.SCM="5_scm",c.More="9_more"})(n||(e.ViewContentGroups=n={}));function s(c,l){const m=c.group??n.More,f=l.group??n.More;return m!==f?m.localeCompare(f):(c.order??5)-(l.order??5)}class o extends O.$Wc{constructor(){super(...arguments),this.c=this.B(new w.$me),this.onViewsRegistered=this.c.event,this.f=this.B(new w.$me),this.onViewsDeregistered=this.f.event,this.g=this.B(new w.$me),this.onDidChangeContainer=this.g.event,this.h=this.B(new w.$me),this.onDidChangeViewWelcomeContent=this.h.event,this.j=[],this.m=new Map,this.n=new A.$Jc}registerViews(l,m){this.registerViews2([{views:l,viewContainer:m}])}registerViews2(l){l.forEach(({views:m,viewContainer:f})=>this.r(m,f)),this.c.fire(l)}deregisterViews(l,m){const f=this.s(l,m);f.length&&this.f.fire({views:f,viewContainer:m})}moveViews(l,m){for(const f of this.m.keys())if(f!==m){const $=this.s(l,f);$.length&&(this.r($,m),this.g.fire({views:$,from:f,to:m}))}}getViews(l){return this.m.get(l)||[]}getView(l){for(const m of this.j){const f=(this.m.get(m)||[]).filter($=>$.id===l)[0];if(f)return f}return null}getViewContainer(l){for(const m of this.j)if((this.m.get(m)||[]).filter($=>$.id===l)[0])return m;return null}registerViewWelcomeContent(l,m){return this.n.add(l,m),this.h.fire(l),(0,O.$Uc)(()=>{this.n.delete(l,m),this.h.fire(l)})}registerViewWelcomeContent2(l,m){const f=new Map;for(const[$,I]of m)this.n.add(l,I),f.set($,(0,O.$Uc)(()=>{this.n.delete(l,I),this.h.fire(l)}));return this.h.fire(l),f}getViewWelcomeContent(l){const m=[];return this.n.forEach(l,f=>m.push(f)),m.sort(s)}r(l,m){let f=this.m.get(m);f||(f=[],this.m.set(m,f),this.j.push(m));for(const $ of l){if(this.getView($.id)!==null)throw new Error((0,S.localize)(2,null,$.id));f.push($)}}s(l,m){const f=this.m.get(m);if(!f)return[];const $=[],I=[];for(const D of f)l.includes(D)?$.push(D):I.push(D);return $.length&&(I.length?this.m.set(m,I):(this.m.delete(m),this.j.splice(this.j.indexOf(m),1))),$}}T.$oo.add(y.ViewsRegistry,new o),e.$kG=(0,k.$Fi)("viewDescriptorService");var h;(function(c){c[c.Default=0]="Default",c[c.Expand=1]="Expand"})(h||(e.ViewVisibilityState=h={}));var i;(function(c){c[c.None=0]="None",c[c.Collapsed=1]="Collapsed",c[c.Expanded=2]="Expanded"})(i||(e.TreeItemCollapsibleState=i={}));class r{constructor(l,m){this.c=!1,this.d=!1,(0,p.$eo)(this,l),this.d=!!m,this.resolve=async f=>{if(m&&!this.c){const $=await m(f);$&&(this.tooltip=this.tooltip??$.tooltip,this.command=this.command??$.command)}f.isCancellationRequested||(this.c=!0)}}get hasResolve(){return this.d}resetResolve(){this.c=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.$lG=r;class t extends Error{constructor(l){super((0,S.localize)(3,null,l)),this.name="NoTreeViewError"}static is(l){return l.name==="NoTreeViewError"}}e.$mG=t}),define(ke[233],Ce([1,0,195,32]),function(oe,e,w,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$GG=e.$FG=e.$EG=e.$DG=e.$CG=e.$BG=e.$AG=e.$zG=e.$yG=e.$xG=e.$wG=e.$vG=e.$uG=e.$tG=e.$sG=e.$rG=e.$qG=void 0,e.$qG=new S.$Wj("chatSessionResponseVote","",{type:"string",description:(0,w.localize)(0,null)}),e.$rG=new S.$Wj("chatSessionResponseDetectedAgentOrCommand",!1,{type:"boolean",description:(0,w.localize)(1,null)}),e.$sG=new S.$Wj("chatResponseSupportsIssueReporting",!1,{type:"boolean",description:(0,w.localize)(2,null)}),e.$tG=new S.$Wj("chatSessionResponseFiltered",!1,{type:"boolean",description:(0,w.localize)(3,null)}),e.$uG=new S.$Wj("chatSessionRequestInProgress",!1,{type:"boolean",description:(0,w.localize)(4,null)}),e.$vG=new S.$Wj("chatResponse",!1,{type:"boolean",description:(0,w.localize)(5,null)}),e.$wG=new S.$Wj("chatRequest",!1,{type:"boolean",description:(0,w.localize)(6,null)}),e.$xG=new S.$Wj("chatEditApplied",!1,{type:"boolean",description:(0,w.localize)(7,null)}),e.$yG=new S.$Wj("chatInputHasText",!1,{type:"boolean",description:(0,w.localize)(8,null)}),e.$zG=new S.$Wj("chatInputHasFocus",!1,{type:"boolean",description:(0,w.localize)(9,null)}),e.$AG=new S.$Wj("inChatInput",!1,{type:"boolean",description:(0,w.localize)(10,null)}),e.$BG=new S.$Wj("inChat",!1,{type:"boolean",description:(0,w.localize)(11,null)}),e.$CG=new S.$Wj("chatIsEnabled",!1,{type:"boolean",description:(0,w.localize)(12,null)}),e.$DG=new S.$Wj("chatCursorAtTop",!1),e.$EG=new S.$Wj("chatInputHasAgent",!1),e.$FG=new S.$Wj("chatLocation",void 0),e.$GG=new S.$Wj("quickChatHasFocus",!1,{type:"boolean",description:(0,w.localize)(13,null)})}),define(ke[234],Ce([1,0,325,11,22,6,40,4,49,141,13,32,19,3,12,108,216,227,233]),function(oe,e,w,S,k,O,A,T,p,a,R,y,u,E,d,n,s,o,h){"use strict";var i;Object.defineProperty(e,"__esModule",{value:!0}),e.$KH=e.$JH=e.$IH=e.$HH=e.$GH=e.ChatAgentLocation=void 0,e.$LH=m,e.$MH=f;var r;(function($){$.Panel="panel",$.Terminal="terminal",$.Notebook="notebook",$.Editor="editor"})(r||(e.ChatAgentLocation=r={})),function($){function I(D){switch(D){case"panel":return $.Panel;case"terminal":return $.Terminal;case"notebook":return $.Notebook;case"editor":return $.Editor}return $.Panel}$.fromRaw=I}(r||(e.ChatAgentLocation=r={})),e.$GH=(0,E.$Fi)("chatAgentService");let t=class{static{this.AGENT_LEADER="@"}constructor(I){this.f=I,this.b=new Map,this.d=new O.$me,this.onDidChangeAgents=this.d.event,this.g=new Map,this.e=h.$CG.bindTo(this.f)}registerAgent(I,D){if(this.getAgent(I))throw new Error(`Agent already registered: ${JSON.stringify(I)}`);const C=this,P=D.slashCommands;D={...D,get slashCommands(){return P.filter(b=>!b.when||C.f.contextMatchesRules(y.$Dj.deserialize(b.when)))}};const g={data:D};return this.b.set(I,g),(0,T.$Uc)(()=>{this.b.delete(I),this.d.fire(void 0)})}registerAgentImplementation(I,D){const v=this.b.get(I);if(!v)throw new Error(`Unknown agent: ${JSON.stringify(I)}`);if(v.impl)throw new Error(`Agent already has implementation: ${JSON.stringify(I)}`);return v.data.isDefault&&this.e.set(!0),v.impl=D,this.d.fire(new c(v.data,D)),(0,T.$Uc)(()=>{v.impl=void 0,this.d.fire(void 0),v.data.isDefault&&this.e.set(!1)})}registerDynamicAgent(I,D){I.isDynamic=!0;const v={data:I,impl:D};return this.b.set(I.id,v),this.d.fire(new c(I,D)),(0,T.$Uc)(()=>{this.b.delete(I.id),this.d.fire(void 0)})}registerAgentCompletionProvider(I,D){return this.g.set(I,D),{dispose:()=>{this.g.delete(I)}}}async getAgentCompletionItems(I,D,v){return await this.g.get(I)?.(D,v)??[]}updateAgent(I,D){const v=this.b.get(I);if(!v?.impl)throw new Error(`No activated agent with id ${JSON.stringify(I)} registered`);v.data.metadata={...v.data.metadata,...D},this.d.fire(new c(v.data,v.impl))}getDefaultAgent(I){return(0,w.$hb)(this.getActivatedAgents(),D=>!!D.isDefault&&D.locations.includes(I))}getContributedDefaultAgent(I){return this.getAgents().find(D=>!!D.isDefault&&D.locations.includes(I))}getSecondaryAgent(){return A.Iterable.find(this.b.values(),I=>!!I.data.metadata.isSecondary)?.data}getAgent(I){if(this.h(I))return this.b.get(I)?.data}h(I){const D=this.b.get(I);return!D?.data.when||this.f.contextMatchesRules(y.$Dj.deserialize(D.data.when))}getAgentByFullyQualifiedId(I){const D=A.Iterable.find(this.b.values(),v=>m(v.data)===I)?.data;if(!(D&&!this.h(D.id)))return D}getAgents(){return Array.from(this.b.values()).map(I=>I.data).filter(I=>this.h(I.id))}getActivatedAgents(){return Array.from(this.b.values()).filter(I=>!!I.impl).filter(I=>this.h(I.data.id)).map(I=>new c(I.data,I.impl))}getAgentsByName(I){return this.getAgents().filter(D=>D.name===I)}agentHasDupeName(I){const D=this.getAgent(I);return D?this.getAgentsByName(D.name).filter(v=>v.extensionId.value!==D.extensionId.value).length>0:!1}async invokeAgent(I,D,v,C,P){const g=this.b.get(I);if(!g?.impl)throw new Error(`No activated agent with id "${I}"`);return await g.impl.invoke(D,v,C,P)}async getFollowups(I,D,v,C,P){const g=this.b.get(I);if(!g?.impl)throw new Error(`No activated agent with id "${I}"`);return g.impl?.provideFollowups?g.impl.provideFollowups(D,v,C,P):[]}};e.$HH=t,e.$HH=t=He([Ve(0,y.$Xj)],t);class c{constructor(I,D){this.b=I,this.d=D}get id(){return this.b.id}get name(){return this.b.name??""}get fullName(){return this.b.fullName??""}get description(){return this.b.description??""}get extensionId(){return this.b.extensionId}get extensionPublisherId(){return this.b.extensionPublisherId}get extensionPublisherDisplayName(){return this.b.publisherDisplayName}get extensionDisplayName(){return this.b.extensionDisplayName}get isDefault(){return this.b.isDefault}get metadata(){return this.b.metadata}get slashCommands(){return this.b.slashCommands}get defaultImplicitVariables(){return this.b.defaultImplicitVariables}get locations(){return this.b.locations}async invoke(I,D,v,C){return this.d.invoke(I,D,v,C)}async provideFollowups(I,D,v,C){return this.d.provideFollowups?this.d.provideFollowups(I,D,v,C):[]}provideWelcomeMessage(I,D){if(this.d.provideWelcomeMessage)return this.d.provideWelcomeMessage(I,D)}provideSampleQuestions(I,D){if(this.d.provideSampleQuestions)return this.d.provideSampleQuestions(I,D)}}e.$IH=c,e.$JH=(0,E.$Fi)("chatAgentNameService");let l=class{static{i=this}static{this.b="chat.participantNameRegistry"}constructor(I,D,v,C){if(this.g=D,this.h=v,this.i=C,this.e=(0,a.$7d)(this,Object.create(null)),this.f=!1,!I.chatParticipantRegistry)return;this.d=I.chatParticipantRegistry;const P=C.get(i.b,o.StorageScope.APPLICATION);try{this.e.set(JSON.parse(P??"{}"),void 0)}catch{C.remove(i.b,o.StorageScope.APPLICATION)}this.j()}j(){this.f||this.k().catch(I=>this.h.warn("Failed to fetch chat participant registry",I)).then(()=>(0,S.$Gh)(5*60*1e3)).then(()=>this.j())}async k(){const I=await this.g.request({type:"GET",url:this.d},k.CancellationToken.None);if(I.res.statusCode!==200)throw new Error("Could not get extensions report.");const D=await(0,s.$7p)(I);if(!D||D.version!==1)throw new Error("Unexpected chat participant registry response.");const v=D.restrictedChatParticipants;this.e.set(v,void 0),this.i.store(i.b,JSON.stringify(v),o.StorageScope.APPLICATION,o.StorageTarget.MACHINE)}getAgentNameRestriction(I){const D=this.l(I.name,I).get(),v=!I.fullName||this.l(I.fullName.replace(/\s/g,""),I).get();return D&&v}l(I,D){return this.e.map(C=>C[I.toLowerCase()]).map(C=>C?C.some(P=>(0,R.$Gf)(P,P.includes(".")?D.extensionId.value:D.extensionPublisherId)):!0)}dispose(){this.f=!0}};e.$KH=l,e.$KH=l=i=He([Ve(0,n.$sk),Ve(1,s.$1p),Ve(2,d.$_j),Ve(3,o.$bq)],l);function m($){return`${$.extensionId.value}.${$.id}`}function f($){const I="name"in $?$:{...$,name:$.id};return"extensionPublisherId"in I||(I.extensionPublisherId=I.extensionPublisher??""),"extensionDisplayName"in I||(I.extensionDisplayName=""),"extensionId"in I||(I.extensionId=new u.$qn("")),(0,p.$ci)(I)}}),define(ke[235],Ce([1,0,2,33,3]),function(oe,e,w,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fH=e.$eH=e.ChatCopyKind=e.ChatAgentVoteDirection=void 0,e.$cH=O,e.$dH=A;function O(a){return!!a&&typeof a=="object"&&"uri"in a&&a.uri instanceof w.URI&&"version"in a&&typeof a.version=="number"&&"ranges"in a&&Array.isArray(a.ranges)&&a.ranges.every(S.$Ht.isIRange)}function A(a){return!!a&&typeof a=="object"&&"documents"in a&&Array.isArray(a.documents)&&a.documents.every(O)}var T;(function(a){a[a.Down=0]="Down",a[a.Up=1]="Up"})(T||(e.ChatAgentVoteDirection=T={}));var p;(function(a){a[a.Action=1]="Action",a[a.Toolbar=2]="Toolbar"})(p||(e.ChatCopyKind=p={})),e.$eH=(0,k.$Fi)("IChatService"),e.$fH="accessibility.voice.keywordActivation"}),define(ke[236],Ce([1,0,6,11,197]),function(oe,e,w,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qtb=void 0;class O{constructor(){this.f=new Map,this.m=[],this.n=new w.$me,this.o=new w.$me,this.d=1}get onError(){return this.n.event}get onExit(){return this.o.event}onMessage(T){this.k&&this.n.fire(new Error("attempt to set more than one 'Message' callback")),this.k=T}onEvent(T){this.j&&this.n.fire(new Error("attempt to set more than one 'Event' callback")),this.j=T}onRequest(T){this.g&&this.n.fire(new Error("attempt to set more than one 'Request' callback")),this.g=T}sendResponse(T){T.seq>0?this.n.fire(new Error(`attempt to send more than one response for command ${T.command}`)):this.u("response",T)}sendRequest(T,p,a,R){const y={command:T};if(p&&Object.keys(p).length>0&&(y.arguments=p),this.u("request",y),typeof R=="number"){const u=setTimeout(()=>{clearTimeout(u);const E=this.f.get(y.seq);if(E){this.f.delete(y.seq);const d={type:"response",seq:0,request_seq:y.seq,success:!1,command:T,message:(0,k.localize)(0,null,R,T)};E(d)}},R)}return a&&this.f.set(y.seq,a),y.seq}acceptMessage(T){this.k?this.k(T):(this.m.push(T),this.m.length===1&&this.s())}q(T,p){return T.type!=="event"||p.type!=="event"}async s(){let T;for(;this.m.length;){if((!T||this.q(this.m[0],T))&&await(0,S.$Gh)(0),T=this.m.shift(),!T)return;switch(T.type){case"event":this.j?.(T);break;case"request":this.g?.(T);break;case"response":{const p=T,a=this.f.get(p.request_seq);a&&(this.f.delete(p.request_seq),a(p));break}}}}u(T,p){p.type=T,p.seq=this.d++,this.sendMessage(p)}async w(){if(this.f.size===0)return Promise.resolve();const T=new Map;this.f.forEach((p,a)=>T.set(a,p)),await(0,S.$Gh)(500),T.forEach((p,a)=>{p({type:"response",seq:0,request_seq:a,success:!1,command:"canceled",message:"canceled"}),this.f.delete(a)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.m=[]}}e.$qtb=O}),define(ke[81],Ce([1,0,2,198,32,3]),function(oe,e,w,S,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDebugVisualization=e.IDebugVisualizationTreeItem=e.DebugTreeItemCollapsibleState=e.DebugVisualizationType=e.BreakpointWidgetContext=e.$zK=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.DataBreakpointSetType=e.$xK=e.MemoryRangeType=e.State=e.$vK=e.$uK=e.$tK=e.$sK=e.$rK=e.$qK=e.$pK=e.$oK=e.$nK=e.$mK=e.$lK=e.$kK=e.$jK=e.$iK=e.$hK=e.$gK=e.$fK=e.$eK=e.$dK=e.$cK=e.$bK=e.$aK=e.$_J=e.$$J=e.$0J=e.$9J=e.$8J=e.$7J=e.$6J=e.$5J=e.$4J=e.$3J=e.$2J=e.$1J=e.$ZJ=e.$YJ=e.$XJ=e.$WJ=e.$VJ=e.$UJ=e.$TJ=e.$SJ=e.$RJ=e.$QJ=e.$PJ=e.$OJ=e.$NJ=e.$MJ=e.$LJ=e.$KJ=e.$JJ=e.$IJ=e.$HJ=e.$GJ=e.$FJ=e.$EJ=e.$DJ=e.$CJ=e.$BJ=e.$AJ=e.$zJ=e.$yJ=e.$xJ=e.$wJ=e.$vJ=e.$uJ=e.$tJ=e.$sJ=e.$rJ=e.$qJ=e.$pJ=e.$oJ=e.$nJ=e.$mJ=e.$lJ=e.$kJ=void 0,e.$wK=p,e.$yK=R,S=qe(S),e.$kJ="workbench.view.debug",e.$lJ="workbench.debug.variablesView",e.$mJ="workbench.debug.watchExpressionsView",e.$nJ="workbench.debug.callStackView",e.$oJ="workbench.debug.loadedScriptsView",e.$pJ="workbench.debug.breakPointsView",e.$qJ="workbench.debug.disassemblyView",e.$rJ="workbench.panel.repl",e.$sJ="workbench.panel.repl.view",e.$tJ=new k.$Wj("debugType",void 0,{type:"string",description:S.localize(0,null)}),e.$uJ=new k.$Wj("debugConfigurationType",void 0,{type:"string",description:S.localize(1,null)}),e.$vJ=new k.$Wj("debugState","inactive",{type:"string",description:S.localize(2,null)}),e.$wJ="debugUx",e.$xJ=new k.$Wj(e.$wJ,"default",{type:"string",description:S.localize(3,null)}),e.$yJ=new k.$Wj("hasDebugged",!1,{type:"boolean",description:S.localize(4,null)}),e.$zJ=new k.$Wj("inDebugMode",!1,{type:"boolean",description:S.localize(5,null)}),e.$AJ=new k.$Wj("inDebugRepl",!1,{type:"boolean",description:S.localize(6,null)}),e.$BJ=new k.$Wj("breakpointWidgetVisible",!1,{type:"boolean",description:S.localize(7,null)}),e.$CJ=new k.$Wj("inBreakpointWidget",!1,{type:"boolean",description:S.localize(8,null)}),e.$DJ=new k.$Wj("breakpointsFocused",!0,{type:"boolean",description:S.localize(9,null)}),e.$EJ=new k.$Wj("watchExpressionsFocused",!0,{type:"boolean",description:S.localize(10,null)}),e.$FJ=new k.$Wj("watchExpressionsExist",!1,{type:"boolean",description:S.localize(11,null)}),e.$GJ=new k.$Wj("variablesFocused",!0,{type:"boolean",description:S.localize(12,null)}),e.$HJ=new k.$Wj("expressionSelected",!1,{type:"boolean",description:S.localize(13,null)}),e.$IJ=new k.$Wj("breakpointInputFocused",!1,{type:"boolean",description:S.localize(14,null)}),e.$JJ=new k.$Wj("callStackItemType",void 0,{type:"string",description:S.localize(15,null)}),e.$KJ=new k.$Wj("callStackSessionIsAttach",!1,{type:"boolean",description:S.localize(16,null)}),e.$LJ=new k.$Wj("callStackItemStopped",!1,{type:"boolean",description:S.localize(17,null)}),e.$MJ=new k.$Wj("callStackSessionHasOneThread",!1,{type:"boolean",description:S.localize(18,null)}),e.$NJ=new k.$Wj("watchItemType",void 0,{type:"string",description:S.localize(19,null)}),e.$OJ=new k.$Wj("canViewMemory",void 0,{type:"boolean",description:S.localize(20,null)}),e.$PJ=new k.$Wj("breakpointItemType",void 0,{type:"string",description:S.localize(21,null)}),e.$QJ=new k.$Wj("breakpointItemBytes",void 0,{type:"boolean",description:S.localize(22,null)}),e.$RJ=new k.$Wj("breakpointHasModes",!1,{type:"boolean",description:S.localize(23,null)}),e.$SJ=new k.$Wj("breakpointSupportsCondition",!1,{type:"boolean",description:S.localize(24,null)}),e.$TJ=new k.$Wj("loadedScriptsSupported",!1,{type:"boolean",description:S.localize(25,null)}),e.$UJ=new k.$Wj("loadedScriptsItemType",void 0,{type:"string",description:S.localize(26,null)}),e.$VJ=new k.$Wj("focusedSessionIsAttach",!1,{type:"boolean",description:S.localize(27,null)}),e.$WJ=new k.$Wj("focusedSessionIsNoDebug",!1,{type:"boolean",description:S.localize(28,null)}),e.$XJ=new k.$Wj("stepBackSupported",!1,{type:"boolean",description:S.localize(29,null)}),e.$YJ=new k.$Wj("restartFrameSupported",!1,{type:"boolean",description:S.localize(30,null)}),e.$ZJ=new k.$Wj("stackFrameSupportsRestart",!1,{type:"boolean",description:S.localize(31,null)}),e.$1J=new k.$Wj("jumpToCursorSupported",!1,{type:"boolean",description:S.localize(32,null)}),e.$2J=new k.$Wj("stepIntoTargetsSupported",!1,{type:"boolean",description:S.localize(33,null)}),e.$3J=new k.$Wj("breakpointsExist",!1,{type:"boolean",description:S.localize(34,null)}),e.$4J=new k.$Wj("debuggersAvailable",!1,{type:"boolean",description:S.localize(35,null)}),e.$5J=new k.$Wj("debugExtensionAvailable",!0,{type:"boolean",description:S.localize(36,null)}),e.$6J=new k.$Wj("debugProtocolVariableMenuContext",void 0,{type:"string",description:S.localize(37,null)}),e.$7J=new k.$Wj("debugSetVariableSupported",!1,{type:"boolean",description:S.localize(38,null)}),e.$8J=new k.$Wj("debugSetDataBreakpointAddressSupported",!1,{type:"boolean",description:S.localize(39,null)}),e.$9J=new k.$Wj("debugSetExpressionSupported",!1,{type:"boolean",description:S.localize(40,null)}),e.$0J=new k.$Wj("breakWhenValueChangesSupported",!1,{type:"boolean",description:S.localize(41,null)}),e.$$J=new k.$Wj("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:S.localize(42,null)}),e.$_J=new k.$Wj("breakWhenValueIsReadSupported",!1,{type:"boolean",description:S.localize(43,null)}),e.$aK=new k.$Wj("terminateDebuggeeSupported",!1,{type:"boolean",description:S.localize(44,null)}),e.$bK=new k.$Wj("suspendDebuggeeSupported",!1,{type:"boolean",description:S.localize(45,null)}),e.$cK=new k.$Wj("variableEvaluateNamePresent",!1,{type:"boolean",description:S.localize(46,null)}),e.$dK=new k.$Wj("variableIsReadonly",!1,{type:"boolean",description:S.localize(47,null)}),e.$eK=new k.$Wj("variableValue",!1,{type:"string",description:S.localize(48,null)}),e.$fK=new k.$Wj("variableType",!1,{type:"string",description:S.localize(49,null)}),e.$gK=new k.$Wj("variableInterfaces",!1,{type:"array",description:S.localize(50,null)}),e.$hK=new k.$Wj("variableName",!1,{type:"string",description:S.localize(51,null)}),e.$iK=new k.$Wj("variableLanguage",!1,{type:"string",description:S.localize(52,null)}),e.$jK=new k.$Wj("variableExtensionId",!1,{type:"string",description:S.localize(53,null)}),e.$kK=new k.$Wj("exceptionWidgetVisible",!1,{type:"boolean",description:S.localize(54,null)}),e.$lK=new k.$Wj("multiSessionRepl",!1,{type:"boolean",description:S.localize(55,null)}),e.$mK=new k.$Wj("multiSessionDebug",!1,{type:"boolean",description:S.localize(56,null)}),e.$nK=new k.$Wj("disassembleRequestSupported",!1,{type:"boolean",description:S.localize(57,null)}),e.$oK=new k.$Wj("disassemblyViewFocus",!1,{type:"boolean",description:S.localize(58,null)}),e.$pK=new k.$Wj("languageSupportsDisassembleRequest",!1,{type:"boolean",description:S.localize(59,null)}),e.$qK=new k.$Wj("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:S.localize(60,null)});const A=i=>S.localize(61,null,i);e.$rK=A,e.$sK="editor.contrib.debug",e.$tK="editor.contrib.breakpoint",e.$uK="debug",e.$vK={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:S.localize(62,null)};var T;(function(i){i[i.Inactive=0]="Inactive",i[i.Initializing=1]="Initializing",i[i.Stopped=2]="Stopped",i[i.Running=3]="Running"})(T||(e.State=T={}));function p(i){switch(i){case T.Initializing:return"initializing";case T.Stopped:return"stopped";case T.Running:return"running";default:return"inactive"}}var a;(function(i){i[i.Valid=0]="Valid",i[i.Unreadable=1]="Unreadable",i[i.Error=2]="Error"})(a||(e.MemoryRangeType=a={})),e.$xK="vscode-debug-memory";function R(i){const r=i.presentationHint??i.source.presentationHint;return r==="deemphasize"||r==="subtle"}var y;(function(i){i[i.Variable=0]="Variable",i[i.Address=1]="Address"})(y||(e.DataBreakpointSetType=y={}));var u;(function(i){i[i.Initial=1]="Initial",i[i.Dynamic=2]="Dynamic"})(u||(e.DebugConfigurationProviderTriggerKind=u={}));var E;(function(i){i.UnverifiedBreakpoints="unverifiedBreakpoints"})(E||(e.DebuggerString=E={})),e.$zK=(0,O.$Fi)("debugService");var d;(function(i){i[i.CONDITION=0]="CONDITION",i[i.HIT_COUNT=1]="HIT_COUNT",i[i.LOG_MESSAGE=2]="LOG_MESSAGE",i[i.TRIGGER_POINT=3]="TRIGGER_POINT"})(d||(e.BreakpointWidgetContext=d={}));var n;(function(i){i[i.Command=0]="Command",i[i.Tree=1]="Tree"})(n||(e.DebugVisualizationType=n={}));var s;(function(i){i[i.None=0]="None",i[i.Collapsed=1]="Collapsed",i[i.Expanded=2]="Expanded"})(s||(e.DebugTreeItemCollapsibleState=s={}));var o;(function(i){i.deserialize=r=>r,i.serialize=r=>r})(o||(e.IDebugVisualizationTreeItem=o={}));var h;(function(i){i.deserialize=r=>({id:r.id,name:r.name,iconPath:r.iconPath&&{light:w.URI.revive(r.iconPath.light),dark:w.URI.revive(r.iconPath.dark)},iconClass:r.iconClass,visualization:r.visualization}),i.serialize=r=>r})(h||(e.IDebugVisualization=h={}))}),define(ke[237],Ce([1,0,13,2,20,26,16,33,22,18]),function(oe,e,w,S,k,O,A,T,p,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4H=void 0,e.$RH=y,e.$SH=u,e.$TH=E,e.$UH=d,e.$VH=n,e.$WH=s,e.$XH=o,e.$YH=i,e.$ZH=c,e.$1H=l,e.$2H=f,e.$3H=I;const R=/{([^}]+)}/g;function y(v,C,P){return v.replace(R,function(g,b){return C&&b.length>0&&b[0]!=="_"?g:P&&P.hasOwnProperty(b)?P[b]:g})}function u(v){const C={};for(const P of Object.keys(v))P.startsWith("!")||(C[P]=v[P]);return C}function E(v){return v.configuration.request==="attach"&&!d(v)&&(!v.parentSession||E(v.parentSession))}function d(v){let C=v.configuration.type;if(C)return C==="vslsShare"&&(C=v.configuration.adapterProxy.configuration.type),(0,w.$Gf)(C,"extensionhost")||(0,w.$Gf)(C,"pwa-extensionhost")?v:v.parentSession?d(v.parentSession):void 0}function n(v){return v.type&&(v.label||v.program||v.runtime)}function s(v,C,P){let g,b=0;const L=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let N=null;for(;N=L.exec(v);){const B=N.index+1,G=B+N[0].length;if(B<=C&&G>=P){g=N[0],b=B;break}}if(g){const B=/\w+/g;let G=null;for(;(G=B.exec(g))&&!(G.index+1+b+G[0].length>=P););G&&(g=g.substring(0,B.lastIndex))}return g?{start:b,end:b+g.length-1}:{start:0,end:0}}async function o(v,C,P,g){if(v.evaluatableExpressionProvider.has(C)){const b=v.evaluatableExpressionProvider.ordered(C),L=(0,a.$Jb)(await Promise.all(b.map(async N=>{try{return await N.provideEvaluatableExpression(C,P,g??p.CancellationToken.None)}catch{return}})));if(L.length>0){let N=L[0].expression;const B=L[0].range;return N||(N=C.getLineContent(P.lineNumber).substring(B.startColumn-1,B.endColumn-1)),{range:B,matchingExpression:N}}}else{const b=C.getLineContent(P.lineNumber),{start:L,end:N}=s(b,P.column,P.column),B=b.substring(L-1,N);return{matchingExpression:B,range:new T.$Ht(P.lineNumber,L,P.lineNumber,L+B.length)}}return null}const h=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function i(v){return!!(v&&v.match(h))}function r(v){if(typeof v.path=="string"&&!(typeof v.sourceReference=="number"&&v.sourceReference>0)){if(i(v.path))return S.URI.parse(v.path);if((0,k.$kc)(v.path))return S.URI.file(v.path)}return v.path}function t(v){if(typeof v.path=="object"){const C=S.URI.revive(v.path);if(C)return C.scheme===A.Schemas.file?C.fsPath:C.toString()}return v.path}function c(v,C){const P=C?r:t,g=(0,O.$bo)(v);return m(g,(b,L)=>{b&&L&&(L.path=P(L))}),g}function l(v,C){const P=C?r:t,g=(0,O.$bo)(v);return m(g,(b,L)=>{!b&&L&&(L.path=P(L))}),g}function m(v,C){switch(v.type){case"event":{const P=v;switch(P.event){case"output":C(!1,P.body.source);break;case"loadedSource":C(!1,P.body.source);break;case"breakpoint":C(!1,P.body.breakpoint.source);break;default:break}break}case"request":{const P=v;switch(P.command){case"setBreakpoints":C(!0,P.arguments.source);break;case"breakpointLocations":C(!0,P.arguments.source);break;case"source":C(!0,P.arguments.source);break;case"gotoTargets":C(!0,P.arguments.source);break;case"launchVSCode":P.arguments.args.forEach(g=>C(!1,g));break;default:break}break}case"response":{const P=v;if(P.success&&P.body)switch(P.command){case"stackTrace":P.body.stackFrames.forEach(g=>C(!1,g.source));break;case"loadedSources":P.body.sources.forEach(g=>C(!1,g));break;case"scopes":P.body.scopes.forEach(g=>C(!1,g.source));break;case"setFunctionBreakpoints":P.body.breakpoints.forEach(g=>C(!1,g.source));break;case"setBreakpoints":P.body.breakpoints.forEach(g=>C(!1,g.source));break;case"disassemble":P.body?.instructions.forEach(b=>C(!1,b.location));break;default:break}break}}}function f(v){return v.filter(C=>!C.presentation?.hidden).sort((C,P)=>C.presentation?P.presentation?C.presentation.group?P.presentation.group?C.presentation.group!==P.presentation.group?C.presentation.group.localeCompare(P.presentation.group):$(C.presentation.order,P.presentation.order):-1:P.presentation.group?1:$(C.presentation.order,P.presentation.order):-1:P.presentation?1:0)}function $(v,C){return typeof v!="number"?typeof C!="number"?0:1:typeof C!="number"?-1:v-C}async function I(v,C){const P=v.getValue("debug.saveBeforeStart",{overrideIdentifier:C.activeTextEditorLanguageId});if(P!=="none"&&(await C.saveAll(),P==="allEditorsInActiveGroup")){const g=C.activeEditorPane;g&&g.input.resource?.scheme===A.Schemas.untitled&&await C.save({editor:g.input,groupId:g.group.id})}await v.reloadConfiguration()}const D=(v,C)=>!v||!C?v===C:v.name===C.name&&v.path===C.path&&v.sourceReference===C.sourceReference;e.$4H=D}),define(ke[238],Ce([1,0,3]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$RK=e.CellExecutionUpdateType=void 0;var S;(function(k){k[k.Output=1]="Output",k[k.OutputItems=2]="OutputItems",k[k.ExecutionState=3]="ExecutionState"})(S||(e.CellExecutionUpdateType=S={})),e.$RK=(0,w.$Fi)("INotebookExecutionService")}),define(ke[239],Ce([1,0,3]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$VK=e.$UK=e.ProxyKernelState=e.$TK=void 0,e.$TK=100;var S;(function(k){k[k.Disconnected=1]="Disconnected",k[k.Connected=2]="Connected",k[k.Initializing=3]="Initializing"})(S||(e.ProxyKernelState=S={})),e.$UK=(0,w.$Fi)("INotebookKernelService"),e.$VK=(0,w.$Fi)("INotebookKernelHistoryService")}),define(ke[240],Ce([1,0,4,33,52,166,102]),function(oe,e,w,S,k,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cZb=void 0;class T extends w.$Wc{constructor(a,R,y){super(),this._source=a,this.b=R,this.c=y,this.a=void 0}f(a){const R=a.getLineCount();return new S.$Ht(1,1,R,this.g(a,R))}g(a,R){if(R<1||R>a.getLineCount())throw new Error("Illegal value for lineNumber");return a.getLineLength(R)+1}get inputTextBuffer(){if(!this.b){const a=new O.$iD;a.acceptChunk(this._source);const R=a.finish(!0),{textBuffer:y,disposable:u}=R.create(k.DefaultEndOfLine.LF);this.b=y,this.B(u)}return this.b}get outputTextBuffers(){return this.a||(this.a=this.c.map(a=>{const R=new O.$iD;R.acceptChunk(a);const y=R.finish(!0),{textBuffer:u,disposable:E}=y.create(k.DefaultEndOfLine.LF);return this.B(E),u})),this.a}findInInputs(a){const y=new A.$9C(a,!1,!1,null).parseSearchRequest();if(!y)return[];const u=this.f(this.inputTextBuffer);return this.inputTextBuffer.findMatchesLineByLine(u,y,!0,5e3)}findInOutputs(a){const y=new A.$9C(a,!1,!1,null).parseSearchRequest();return y?this.outputTextBuffers.map(u=>{const E=u.findMatchesLineByLine(this.f(u),y,!0,5e3);if(E.length!==0)return{textBuffer:u,matches:E}}).filter(u=>!!u):[]}}e.$cZb=T}),define(ke[55],Ce([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$QI=e.TestPosition=e.TestIdPathParts=void 0;var w;(function(O){O.Delimiter="\0"})(w||(e.TestIdPathParts=w={}));var S;(function(O){O[O.IsSame=0]="IsSame",O[O.Disconnected=1]="Disconnected",O[O.IsChild=2]="IsChild",O[O.IsParent=3]="IsParent"})(S||(e.TestPosition=S={}));class k{static fromExtHostTestItem(A,T,p=A.parent){if(A._isRoot)return new k([T]);const a=[A.id];for(let R=p;R&&R.id!==T;R=R.parent)a.push(R.id);return a.push(T),new k(a.reverse())}static isRoot(A){return!A.includes(w.Delimiter)}static root(A){const T=A.indexOf(w.Delimiter);return T===-1?A:A.slice(0,T)}static fromString(A){return new k(A.split(w.Delimiter))}static join(A,T){return new k([...A.path,T])}static joinToString(A,T){return A.toString()+w.Delimiter+T}static parentId(A){const T=A.lastIndexOf(w.Delimiter);return T===-1?void 0:A.slice(0,T)}static localId(A){const T=A.lastIndexOf(w.Delimiter);return T===-1?A:A.slice(T+w.Delimiter.length)}static isChild(A,T){return T.startsWith(A)&&T[A.length]===w.Delimiter}static compare(A,T){return A===T?S.IsSame:k.isChild(A,T)?S.IsChild:k.isChild(T,A)?S.IsParent:S.Disconnected}static getLengthOfCommonPrefix(A,T){if(A===0)return 0;let p=0;for(;p<A-1;){for(let a=1;a<A;a++){const R=T(a-1),y=T(a);if(R.path[p]!==y.path[p])return p}p++}return p}constructor(A,T=A.length){if(this.path=A,this.d=T,A.length===0||T<1)throw new Error("cannot create test with empty path")}get rootId(){return new k(this.path,1)}get parentId(){return this.d>1?new k(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let A=1;A<=this.d;A++)yield new k(this.path,A)}*idsToRoot(){for(let A=this.d;A>0;A--)yield new k(this.path,A)}compare(A){if(typeof A=="string")return k.compare(this.toString(),A);for(let T=0;T<A.d&&T<this.d;T++)if(A.path[T]!==this.path[T])return S.Disconnected;return A.d>this.d?S.IsChild:A.d<this.d?S.IsParent:S.IsSame}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let A=1;A<this.d;A++)this.c+=w.Delimiter,this.c+=this.path[A]}return this.c}}e.$QI=k}),define(ke[56],Ce([1,0,2,101,33,55]),function(oe,e,w,S,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ZI=e.TestsDiffOp=e.TestDiffOpType=e.IStatementCoverage=e.IDeclarationCoverage=e.IBranchCoverage=e.CoverageDetails=e.DetailType=e.$YI=e.IFileCoverage=e.ICoverageCount=e.TestResultItem=e.$XI=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.$WI=e.$VI=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.$UI=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.$TI=e.$SI=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.$RI=e.TestResultState=void 0;var A;(function(W){W[W.Unset=0]="Unset",W[W.Queued=1]="Queued",W[W.Running=2]="Running",W[W.Passed=3]="Passed",W[W.Failed=4]="Failed",W[W.Skipped=5]="Skipped",W[W.Errored=6]="Errored"})(A||(e.TestResultState=A={})),e.$RI={[A.Unset]:"unset",[A.Queued]:"queued",[A.Running]:"running",[A.Passed]:"passed",[A.Failed]:"failed",[A.Skipped]:"skipped",[A.Errored]:"errored"};var T;(function(W){W[W.Run=1]="Run",W[W.Debug=2]="Debug",W[W.Coverage=3]="Coverage"})(T||(e.ExtTestRunProfileKind=T={}));var p;(function(W){W[W.Run=2]="Run",W[W.Debug=4]="Debug",W[W.Coverage=8]="Coverage",W[W.HasNonDefaultProfile=16]="HasNonDefaultProfile",W[W.HasConfigurable=32]="HasConfigurable",W[W.SupportsContinuousRun=64]="SupportsContinuousRun"})(p||(e.TestRunProfileBitset=p={})),e.$SI=[p.Run,p.Debug,p.Coverage,p.HasNonDefaultProfile,p.HasConfigurable,p.SupportsContinuousRun];const a=W=>"runId"in W;e.$TI=a;var R;(function(W){W.serialize=F=>({range:F.range.toJSON(),uri:F.uri.toJSON()}),W.deserialize=(F,q)=>({range:k.$Ht.lift(q.range),uri:F.asCanonicalUri(w.URI.revive(q.uri))})})(R||(e.IRichLocation=R={}));var y;(function(W){W[W.Error=0]="Error",W[W.Output=1]="Output"})(y||(e.TestMessageType=y={}));var u;(function(W){W.serialize=F=>({message:F.message,type:y.Error,expected:F.expected,actual:F.actual,contextValue:F.contextValue,location:F.location&&R.serialize(F.location)}),W.deserialize=(F,q)=>({message:q.message,type:y.Error,expected:q.expected,actual:q.actual,contextValue:q.contextValue,location:q.location&&R.deserialize(F,q.location)})})(u||(e.ITestErrorMessage=u={}));const E=(W,F)=>`${F?"s":"e"}${W}`;e.$UI=E;var d;(function(W){W.serialize=F=>({message:F.message,type:y.Output,offset:F.offset,length:F.length,location:F.location&&R.serialize(F.location)}),W.deserialize=(F,q)=>({message:q.message,type:y.Output,offset:q.offset,length:q.length,location:q.location&&R.deserialize(F,q.location)})})(d||(e.ITestOutputMessage=d={}));var n;(function(W){W.serialize=F=>F.type===y.Error?u.serialize(F):d.serialize(F),W.deserialize=(F,q)=>q.type===y.Error?u.deserialize(F,q):d.deserialize(F,q)})(n||(e.ITestMessage=n={}));var s;(function(W){W.serializeWithoutMessages=F=>({state:F.state,duration:F.duration,messages:[]}),W.serialize=F=>({state:F.state,duration:F.duration,messages:F.messages.map(n.serialize)}),W.deserialize=(F,q)=>({state:q.state,duration:q.duration,messages:q.messages.map(ue=>n.deserialize(F,ue))})})(s||(e.ITestTaskState=s={}));const o="\0",h=(W,F)=>W+o+F;e.$VI=h;const i=W=>{const F=W.indexOf(o);return{ctrlId:W.slice(0,F),tagId:W.slice(F+1)}};e.$WI=i;var r;(function(W){W.serialize=F=>({extId:F.extId,label:F.label,tags:F.tags,busy:F.busy,children:void 0,uri:F.uri?.toJSON(),range:F.range?.toJSON()||null,description:F.description,error:F.error,sortText:F.sortText}),W.deserialize=(F,q)=>({extId:q.extId,label:q.label,tags:q.tags,busy:q.busy,children:void 0,uri:q.uri?F.asCanonicalUri(w.URI.revive(q.uri)):void 0,range:q.range?k.$Ht.lift(q.range):null,description:q.description,error:q.error,sortText:q.sortText})})(r||(e.ITestItem=r={}));var t;(function(W){W[W.NotExpandable=0]="NotExpandable",W[W.Expandable=1]="Expandable",W[W.BusyExpanding=2]="BusyExpanding",W[W.Expanded=3]="Expanded"})(t||(e.TestItemExpandState=t={}));var c;(function(W){W.serialize=F=>({expand:F.expand,item:r.serialize(F.item)}),W.deserialize=(F,q)=>({controllerId:O.$QI.root(q.item.extId),expand:q.expand,item:r.deserialize(F,q.item)})})(c||(e.InternalTestItem=c={}));var l;(function(W){W.serialize=F=>{let q;return F.item&&(q={},F.item.label!==void 0&&(q.label=F.item.label),F.item.tags!==void 0&&(q.tags=F.item.tags),F.item.busy!==void 0&&(q.busy=F.item.busy),F.item.uri!==void 0&&(q.uri=F.item.uri?.toJSON()),F.item.range!==void 0&&(q.range=F.item.range?.toJSON()),F.item.description!==void 0&&(q.description=F.item.description),F.item.error!==void 0&&(q.error=F.item.error),F.item.sortText!==void 0&&(q.sortText=F.item.sortText)),{extId:F.extId,expand:F.expand,item:q}},W.deserialize=F=>{let q;return F.item&&(q={},F.item.label!==void 0&&(q.label=F.item.label),F.item.tags!==void 0&&(q.tags=F.item.tags),F.item.busy!==void 0&&(q.busy=F.item.busy),F.item.range!==void 0&&(q.range=F.item.range?k.$Ht.lift(F.item.range):null),F.item.description!==void 0&&(q.description=F.item.description),F.item.error!==void 0&&(q.error=F.item.error),F.item.sortText!==void 0&&(q.sortText=F.item.sortText)),{extId:F.extId,expand:F.expand,item:q}}})(l||(e.ITestItemUpdate=l={}));const m=(W,F)=>{F.expand!==void 0&&(W.expand=F.expand),F.item!==void 0&&(W.item=W.item?Object.assign(W.item,F.item):F.item)};e.$XI=m;var f;(function(W){W.serializeWithoutMessages=F=>({...c.serialize(F),ownComputedState:F.ownComputedState,computedState:F.computedState,tasks:F.tasks.map(s.serializeWithoutMessages)}),W.serialize=F=>({...c.serialize(F),ownComputedState:F.ownComputedState,computedState:F.computedState,tasks:F.tasks.map(s.serialize)}),W.deserialize=(F,q)=>({...c.deserialize(F,q),ownComputedState:q.ownComputedState,computedState:q.computedState,tasks:q.tasks.map(ue=>s.deserialize(F,ue)),retired:!0})})(f||(e.TestResultItem=f={}));var $;(function(W){W.empty=()=>({covered:0,total:0}),W.sum=(F,q)=>{F.covered+=q.covered,F.total+=q.total}})($||(e.ICoverageCount=$={}));var I;(function(W){W.serialize=F=>({id:F.id,statement:F.statement,branch:F.branch,declaration:F.declaration,testIds:F.testIds,uri:F.uri.toJSON()}),W.deserialize=(F,q)=>({id:q.id,statement:q.statement,branch:q.branch,declaration:q.declaration,testIds:q.testIds,uri:F.asCanonicalUri(w.URI.revive(q.uri))}),W.empty=(F,q)=>({id:F,uri:q,statement:$.empty()})})(I||(e.IFileCoverage=I={}));function D(W){return{...W,location:W.location?.toJSON()}}function v(W){return W.location=W.location?S.$Gt.isIPosition(W.location)?S.$Gt.lift(W.location):k.$Ht.lift(W.location):void 0,W}e.$YI=3;var C;(function(W){W[W.Declaration=0]="Declaration",W[W.Statement=1]="Statement",W[W.Branch=2]="Branch"})(C||(e.DetailType=C={}));var P;(function(W){W.serialize=F=>F.type===C.Declaration?b.serialize(F):L.serialize(F),W.deserialize=F=>F.type===C.Declaration?b.deserialize(F):L.deserialize(F)})(P||(e.CoverageDetails=P={}));var g;(function(W){W.serialize=D,W.deserialize=v})(g||(e.IBranchCoverage=g={}));var b;(function(W){W.serialize=D,W.deserialize=v})(b||(e.IDeclarationCoverage=b={}));var L;(function(W){W.serialize=F=>({...D(F),branches:F.branches?.map(g.serialize)}),W.deserialize=F=>({...v(F),branches:F.branches?.map(g.deserialize)})})(L||(e.IStatementCoverage=L={}));var N;(function(W){W[W.Add=0]="Add",W[W.Update=1]="Update",W[W.DocumentSynced=2]="DocumentSynced",W[W.Remove=3]="Remove",W[W.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",W[W.Retire=5]="Retire",W[W.AddTag=6]="AddTag",W[W.RemoveTag=7]="RemoveTag"})(N||(e.TestDiffOpType=N={}));var B;(function(W){W.deserialize=(F,q)=>q.op===N.Add?{op:q.op,item:c.deserialize(F,q.item)}:q.op===N.Update?{op:q.op,item:l.deserialize(q.item)}:q.op===N.DocumentSynced?{op:q.op,uri:F.asCanonicalUri(w.URI.revive(q.uri)),docv:q.docv}:q,W.serialize=F=>F.op===N.Add?{op:F.op,item:c.serialize(F.item)}:F.op===N.Update?{op:F.op,item:l.serialize(F.item)}:F})(B||(e.TestsDiffOp=B={}));class G{constructor(F){this.k=F,this.c=new Map,this.f=new Map,this.g=new Set,this.h=0,this.j=0,this.tags=this.c}apply(F){const q=this.w();for(const ue of F)switch(ue.op){case N.Add:this.l(c.deserialize(this.k,ue.item),q);break;case N.Update:this.p(l.deserialize(ue.item),q);break;case N.Remove:this.q(ue.itemId,q);break;case N.Retire:this.v(ue.itemId);break;case N.IncrementPendingExtHosts:this.updatePendingRoots(ue.amount);break;case N.AddTag:this.c.set(ue.tag.id,ue.tag);break;case N.RemoveTag:this.c.delete(ue.id);break}q.complete?.()}l(F,q){const ue=O.$QI.parentId(F.item.extId)?.toString();let ge;if(!ue)ge=this.x(F),this.g.add(ge),this.f.set(F.item.extId,ge);else if(this.f.has(ue)){const te=this.f.get(ue);te.children.add(F.item.extId),ge=this.x(F,te),this.f.set(F.item.extId,ge)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(F)}`);return}return q.add?.(ge),F.expand===t.BusyExpanding&&this.h++,ge}p(F,q){const ue=this.f.get(F.extId);if(ue)return F.expand!==void 0&&(ue.expand===t.BusyExpanding&&this.h--,F.expand===t.BusyExpanding&&this.h++),(0,e.$XI)(ue,F),q.update?.(ue),ue}q(F,q){const ue=this.f.get(F);if(!ue)return;const ge=O.$QI.parentId(ue.item.extId)?.toString();ge?this.f.get(ge).children.delete(ue.item.extId):this.g.delete(ue);const te=[[F]];for(;te.length;)for(const me of te.pop()){const re=this.f.get(me);re&&(te.push(re.children),this.f.delete(me),q.remove?.(re,re!==ue),re.expand===t.BusyExpanding&&this.h--)}}v(F){}updatePendingRoots(F){this.j+=F}w(){return{}}}e.$ZI=G}),define(ke[241],Ce([1,0,99,201,56]),function(oe,e,w,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestCommandId=e.$8Fb=e.$7Fb=e.TestExplorerViewSorting=e.TestExplorerViewMode=e.Testing=void 0;var O;(function(y){y.ViewletId="workbench.view.extension.test",y.ExplorerViewId="workbench.view.testing",y.OutputPeekContributionId="editor.contrib.testingOutputPeek",y.DecorationsContributionId="editor.contrib.testingDecorations",y.CoverageDecorationsContributionId="editor.contrib.coverageDecorations",y.CoverageViewId="workbench.view.testCoverage",y.ResultsPanelId="workbench.panel.testResults",y.ResultsViewId="workbench.panel.testResults.view",y.MessageLanguageId="vscodeInternalTestMessage"})(O||(e.Testing=O={}));var A;(function(y){y.List="list",y.Tree="true"})(A||(e.TestExplorerViewMode=A={}));var T;(function(y){y.ByLocation="location",y.ByStatus="status",y.ByDuration="duration"})(T||(e.TestExplorerViewSorting=T={}));const p={[k.TestResultState.Errored]:(0,S.localize)(0,null),[k.TestResultState.Failed]:(0,S.localize)(1,null),[k.TestResultState.Passed]:(0,S.localize)(2,null),[k.TestResultState.Queued]:(0,S.localize)(3,null),[k.TestResultState.Running]:(0,S.localize)(4,null),[k.TestResultState.Skipped]:(0,S.localize)(5,null),[k.TestResultState.Unset]:(0,S.localize)(6,null)},a=(y,u)=>(0,S.localize)(7,null,(0,w.$Yk)(y),p[u]);e.$7Fb=a,e.$8Fb={[k.TestRunProfileBitset.Debug]:(0,S.localize)(8,null),[k.TestRunProfileBitset.Run]:(0,S.localize)(9,null),[k.TestRunProfileBitset.Coverage]:(0,S.localize)(10,null)};var R;(function(y){y.CancelTestRefreshAction="testing.cancelTestRefresh",y.CancelTestRunAction="testing.cancelRun",y.ClearTestResultsAction="testing.clearTestResults",y.CollapseAllAction="testing.collapseAll",y.ConfigureTestProfilesAction="testing.configureProfile",y.ContinousRunUsingForTest="testing.continuousRunUsingForTest",y.CoverageAtCursor="testing.coverageAtCursor",y.CoverageByUri="testing.coverage.uri",y.CoverageClear="testing.coverage.close",y.CoverageCurrentFile="testing.coverageCurrentFile",y.CoverageFilterToTest="testing.coverageFilterToTest",y.CoverageFilterToTestInEditor="testing.coverageFilterToTestInEditor",y.CoverageLastRun="testing.coverageLastRun",y.CoverageSelectedAction="testing.coverageSelected",y.CoverageToggleToolbar="testing.coverageToggleToolbar",y.CoverageViewChangeSorting="testing.coverageViewChangeSorting",y.DebugAction="testing.debug",y.DebugAllAction="testing.debugAll",y.DebugAtCursor="testing.debugAtCursor",y.DebugByUri="testing.debug.uri",y.DebugCurrentFile="testing.debugCurrentFile",y.DebugFailedTests="testing.debugFailTests",y.DebugLastRun="testing.debugLastRun",y.DebugSelectedAction="testing.debugSelected",y.FilterAction="workbench.actions.treeView.testExplorer.filter",y.GetExplorerSelection="_testing.getExplorerSelection",y.GetSelectedProfiles="testing.getSelectedProfiles",y.GoToTest="testing.editFocusedTest",y.HideTestAction="testing.hideTest",y.OpenCoverage="testing.openCoverage",y.OpenOutputPeek="testing.openOutputPeek",y.RefreshTestsAction="testing.refreshTests",y.ReRunFailedTests="testing.reRunFailTests",y.ReRunLastRun="testing.reRunLastRun",y.RunAction="testing.run",y.RunAllAction="testing.runAll",y.RunAllWithCoverageAction="testing.coverageAll",y.RunAtCursor="testing.runAtCursor",y.RunByUri="testing.run.uri",y.RunCurrentFile="testing.runCurrentFile",y.RunSelectedAction="testing.runSelected",y.RunUsingProfileAction="testing.runUsing",y.RunWithCoverageAction="testing.coverage",y.SearchForTestExtension="testing.searchForTestExtension",y.SelectDefaultTestProfiles="testing.selectDefaultTestProfiles",y.ShowMostRecentOutputAction="testing.showMostRecentOutput",y.StartContinousRun="testing.startContinuousRun",y.StopContinousRun="testing.stopContinuousRun",y.TestingSortByDurationAction="testing.sortByDuration",y.TestingSortByLocationAction="testing.sortByLocation",y.TestingSortByStatusAction="testing.sortByStatus",y.TestingViewAsListAction="testing.viewAsList",y.TestingViewAsTreeAction="testing.viewAsTree",y.ToggleContinousRunForTest="testing.toggleContinuousRunForTest",y.ToggleInlineTestOutput="testing.toggleInlineTestOutput",y.UnhideAllTestsAction="testing.unhideAllTests",y.UnhideTestAction="testing.unhideTest"})(R||(e.TestCommandId=R={}))}),define(ke[82],Ce([1,0,11,6,4,62,56,55]),function(oe,e,w,S,k,O,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$RP=e.$QP=e.$PP=e.$OP=e.$NP=e.TestItemEventOp=void 0;var p;(function(h){h[h.Upsert=0]="Upsert",h[h.SetTags=1]="SetTags",h[h.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",h[h.RemoveChild=3]="RemoveChild",h[h.SetProp=4]="SetProp",h[h.Bulk=5]="Bulk",h[h.DocumentSynced=6]="DocumentSynced"})(p||(e.TestItemEventOp=p={}));const a=(h,i)=>h===i,y=Object.entries({range:(h,i)=>h===i?!0:!h||!i?!1:h.equalsRange(i),busy:a,label:a,description:a,error:a,sortText:a,tags:(h,i)=>!(h.length!==i.length||h.some(r=>!i.includes(r)))}),u=(h,i)=>{let r;for(const[t,c]of y)c(h[t],i[t])||(r?r[t]=i[t]:r={[t]:i[t]});return r};class E extends k.$Wc{get root(){return this.s.root}constructor(i){super(),this.s=i,this.f=this.B(new w.$Rh(()=>this.flushDiff(),200)),this.g=this.B(new S.$me),this.tree=new Map,this.j=new Map,this.m=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.z(this.root,void 0)}set resolveHandler(i){this.h=i;for(const r of this.tree.values())this.J(r)}get resolveHandler(){return this.h}collectDiff(){const i=this.m;return this.m=[],i}pushDiff(i){switch(i.op){case A.TestDiffOpType.DocumentSynced:{for(const r of this.m)if(r.op===A.TestDiffOpType.DocumentSynced&&r.uri===i.uri){r.docv=i.docv;return}break}case A.TestDiffOpType.Update:{const r=this.m[this.m.length-1];if(r){if(r.op===A.TestDiffOpType.Update&&r.item.extId===i.item.extId){(0,A.$XI)(r.item,i.item);return}if(r.op===A.TestDiffOpType.Add&&r.item.item.extId===i.item.extId){(0,A.$XI)(r.item,i.item);return}}break}}this.m.push(i),this.f.isScheduled()||this.f.schedule()}expand(i,r){const t=this.tree.get(i);if(t){if((t.expandLevels===void 0||r>t.expandLevels)&&(t.expandLevels=r),t.expand===A.TestItemExpandState.Expandable){const c=this.M(t);return c.isOpen()?this.L(t,r-1):c.wait().then(()=>this.L(t,r-1))}else if(t.expand===A.TestItemExpandState.Expanded)return t.resolveBarrier?.isOpen()===!1?t.resolveBarrier.wait().then(()=>this.L(t,r-1)):this.L(t,r-1)}}dispose(){for(const i of this.tree.values())this.s.getApiFor(i.actual).listener=void 0;this.tree.clear(),this.m=[],super.dispose()}w(i,r){switch(r.op){case p.RemoveChild:this.O(T.$QI.joinToString(i.fullId,r.id));break;case p.Upsert:this.z(r.item,i);break;case p.Bulk:for(const t of r.ops)this.w(i,t);break;case p.SetTags:this.C(r.new,r.old,i.fullId.toString());break;case p.UpdateCanResolveChildren:this.J(i);break;case p.SetProp:this.pushDiff({op:A.TestDiffOpType.Update,item:{extId:i.fullId.toString(),item:r.update}});break;case p.DocumentSynced:this.y(i.actual.uri);break;default:(0,O.$gd)(r)}}y(i){i&&this.pushDiff({op:A.TestDiffOpType.DocumentSynced,uri:i,docv:this.s.getDocumentVersion(i)})}z(i,r){const t=T.$QI.fromExtHostTestItem(i,this.root.id,r?.actual),c=this.s.getApiFor(i);c.parent&&c.parent!==r?.actual&&this.s.getChildren(c.parent).delete(i.id);let l=this.tree.get(t.toString());if(!l){l={fullId:t,actual:i,expandLevels:r?.expandLevels?r.expandLevels-1:void 0,expand:A.TestItemExpandState.NotExpandable},i.tags.forEach(this.D,this),this.tree.set(l.fullId.toString(),l),this.G(i,r),this.pushDiff({op:A.TestDiffOpType.Add,item:{controllerId:this.s.controllerId,expand:l.expand,item:this.s.toITestItem(i)}}),this.I(i,l,r);return}if(l.actual===i){this.H(i,l,r);return}if(l.actual.uri?.toString()!==i.uri?.toString())return this.O(t.toString()),this.z(i,r);const m=this.s.getChildren(l.actual),f=l.actual,$=u(this.s.toITestItem(f),this.s.toITestItem(i));this.s.getApiFor(f).listener=void 0,l.actual=i,l.resolveBarrier=void 0,l.expand=A.TestItemExpandState.NotExpandable,$&&($.hasOwnProperty("tags")&&(this.C(i.tags,f.tags,t.toString()),delete $.tags),this.w(l,{op:p.SetProp,update:$})),this.I(i,l,r);for(const[D,v]of m)this.s.getChildren(i).get(v.id)||this.O(T.$QI.joinToString(t,v.id));const I=l.expandLevels;I!==void 0&&queueMicrotask(()=>{l.expand===A.TestItemExpandState.Expandable&&(l.expandLevels=void 0,this.expand(t.toString(),I))}),this.y(l.actual.uri)}C(i,r,t){const c=new Set(r.map(l=>l.id));for(const l of i)c.delete(l.id)||this.D(l);this.pushDiff({op:A.TestDiffOpType.Update,item:{extId:t,item:{tags:i.map(l=>(0,A.$VI)(this.s.controllerId,l.id))}}}),c.forEach(this.F,this)}D(i){const r=this.j.get(i.id);r?r.refCount++:(this.j.set(i.id,{refCount:1}),this.pushDiff({op:A.TestDiffOpType.AddTag,tag:{id:(0,A.$VI)(this.s.controllerId,i.id)}}))}F(i){const r=this.j.get(i);r&&!--r.refCount&&(this.j.delete(i),this.pushDiff({op:A.TestDiffOpType.RemoveTag,id:(0,A.$VI)(this.s.controllerId,i)}))}G(i,r){this.s.getApiFor(i).parent=r&&r.actual!==this.root?r.actual:void 0}H(i,r,t){this.G(i,t);const c=this.s.getApiFor(i);c.parent=t?.actual,c.listener=l=>this.w(r,l),this.J(r)}I(i,r,t){this.H(i,r,t);for(const[c,l]of this.s.getChildren(i))this.z(l,r)}J(i){let r;this.h?i.resolveBarrier?r=i.resolveBarrier.isOpen()?A.TestItemExpandState.Expanded:A.TestItemExpandState.BusyExpanding:r=i.actual.canResolveChildren?A.TestItemExpandState.Expandable:A.TestItemExpandState.NotExpandable:r=A.TestItemExpandState.NotExpandable,r!==i.expand&&(i.expand=r,this.pushDiff({op:A.TestDiffOpType.Update,item:{extId:i.fullId.toString(),expand:r}}),r===A.TestItemExpandState.Expandable&&i.expandLevels!==void 0&&this.M(i))}L(i,r){if(r<0)return;const t=[];for(const[c,l]of this.s.getChildren(i.actual)){const m=this.expand(T.$QI.joinToString(i.fullId,l.id),r);(0,w.$rh)(m)&&t.push(m)}if(t.length)return Promise.all(t).then(()=>{})}M(i){if(i.resolveBarrier)return i.resolveBarrier;if(!this.h){const l=new w.$Eh;return l.open(),l}i.expand=A.TestItemExpandState.BusyExpanding,this.N(i);const r=i.resolveBarrier=new w.$Eh,t=l=>{console.error(`Unhandled error in resolveHandler of test controller "${this.s.controllerId}"`,l)};let c;try{c=this.h(i.actual===this.root?void 0:i.actual)}catch(l){t(l)}return(0,w.$rh)(c)?c.catch(t).then(()=>{r.open(),this.J(i)}):(r.open(),this.J(i)),i.resolveBarrier}N(i){this.pushDiff({op:A.TestDiffOpType.Update,item:{extId:i.fullId.toString(),expand:i.expand}})}O(i){const r=this.tree.get(i);if(!r)throw new Error("attempting to remove non-existent child");this.pushDiff({op:A.TestDiffOpType.Remove,itemId:i});const t=[r];for(;t.length;){const c=t.pop();if(c){this.s.getApiFor(c.actual).listener=void 0;for(const l of c.actual.tags)this.F(l.id);this.tree.delete(c.fullId.toString());for(const[l,m]of this.s.getChildren(c.actual))t.push(this.tree.get(T.$QI.joinToString(c.fullId,m.id)))}}}flushDiff(){const i=this.collectDiff();i.length&&this.g.fire(i)}}e.$NP=E;class d extends Error{constructor(i){super(`Attempted to insert a duplicate test item ID ${i}`)}}e.$OP=d;class n extends Error{constructor(i){super(`TestItem with ID "${i}" is invalid. Make sure to create it from the createTestItem method.`)}}e.$PP=n;class s extends Error{constructor(i,r,t){super(`TestItem with ID "${i}" is from controller "${r}" and cannot be added as a child of an item from controller "${t}".`)}}e.$QP=s;const o=(h,i,r)=>{let t=new Map;return{get size(){return t.size},forEach(c,l){for(const m of t.values())c.call(l,m,this)},[Symbol.iterator](){return t.entries()},replace(c){const l=new Map,m=new Set(t.keys()),f={op:p.Bulk,ops:[]};for(const $ of c){if(!($ instanceof r))throw new n($.id);const I=i($).controllerId;if(I!==h.controllerId)throw new s($.id,I,h.controllerId);if(l.has($.id))throw new d($.id);l.set($.id,$),m.delete($.id),f.ops.push({op:p.Upsert,item:$})}for(const $ of m.keys())f.ops.push({op:p.RemoveChild,id:$});h.listener?.(f),t=l},add(c){if(!(c instanceof r))throw new n(c.id);t.set(c.id,c),h.listener?.({op:p.Upsert,item:c})},delete(c){t.delete(c)&&h.listener?.({op:p.RemoveChild,id:c})},get(c){return t.get(c)},toJSON(){return Array.from(t.values())}}};e.$RP=o}),define(ke[115],Ce([1,0,82]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TP=e.$SP=void 0;const S=new WeakMap,k=(A,T)=>{const p={controllerId:T};return S.set(A,p),p};e.$SP=k;const O=A=>{const T=S.get(A);if(!T)throw new w.$PP(A?.id||"<unknown>");return T};e.$TP=O}),define(ke[83],Ce([1,0,28,16,2]),function(oe,e,w,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$WCb=e.$VCb=e.$UCb=void 0,e.$XCb=O,e.$YCb=T,e.$UCb="vscode-cdn.net",e.$VCb=`vscode-resource.${e.$UCb}`,e.$WCb=`'self' https://*.${e.$UCb}`;function O(p,a){return p.scheme===S.Schemas.http||p.scheme===S.Schemas.https?p:(a&&a.authority&&a.isRemote&&p.scheme===S.Schemas.file&&(p=k.URI.from({scheme:S.Schemas.vscodeRemote,authority:a.authority,path:p.path})),k.URI.from({scheme:S.Schemas.https,authority:`${p.scheme}+${A(p.authority)}.${e.$VCb}`,path:p.path,fragment:p.fragment,query:p.query}))}function A(p){return p.replace(/./g,a=>{const R=a.charCodeAt(0);return R>=w.CharCode.a&&R<=w.CharCode.z||R>=w.CharCode.A&&R<=w.CharCode.Z||R>=w.CharCode.Digit0&&R<=w.CharCode.Digit9?a:"-"+R.toString(16).padStart(4,"0")})}function T(p){return p.replace(/-([0-9a-f]{4})/g,(a,R)=>String.fromCharCode(parseInt(R,16)))}}),define(ke[242],Ce([1,0,6,4,83]),function(oe,e,w,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$nc=void 0;class O{constructor(T,p,a){this.d=T,this.e=p,this.f=a,this.a=0,this.b=new S.$Vc,this.c=new Map,this.b.add(p.onDidChangeVisibleTextEditors(()=>{const R=p.getVisibleTextEditors();for(const y of this.c.values())R.indexOf(y.editor)<0&&y.inset.dispose()}))}dispose(){this.c.forEach(T=>T.inset.dispose()),this.b.dispose()}createWebviewEditorInset(T,p,a,R,y){let u;for(const i of this.e.getVisibleTextEditors(!0))if(i.value===T){u=i;break}if(!u)throw new Error("not a visible editor");const E=this,d=this.a++,n=new w.$me,s=new w.$me,o=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(i){return(0,k.$XCb)(i,E.f)}get cspSource(){return k.$WCb}set options(i){this.b=i,E.d.$setOptions(d,i)}get options(){return this.b}set html(i){this.a=i,E.d.$setHtml(d,i)}get html(){return this.a}get onDidReceiveMessage(){return n.event}postMessage(i){return E.d.$postMessage(d,i)}},h=new class{constructor(){this.editor=T,this.line=p,this.height=a,this.webview=o,this.onDidDispose=s.event}dispose(){E.c.has(d)&&(E.c.delete(d),E.d.$disposeEditorInset(d),s.fire(),s.dispose(),n.dispose())}};return this.d.$createEditorInset(d,u.id,u.value.document.uri,p+1,a,R||{},y.identifier,y.extensionLocation),this.c.set(d,{editor:T,inset:h,onDidReceiveMessage:n}),h}$onDidDispose(T){const p=this.c.get(T);p&&p.inset.dispose()}$onDidReceiveMessage(T,p){this.c.get(T)?.onDidReceiveMessage.fire(p)}}e.$$nc=O}),define(ke[116],Ce([1,0,3]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vM=e.$uM=e.$tM=void 0,e.$tM="__",e.$uM=(0,w.$Fi)("IAuthenticationService"),e.$vM=(0,w.$Fi)("IAuthenticationExtensionsService")}),define(ke[243],Ce([1,0,3]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$MQ=e.VariableKind=e.$LQ=void 0,e.$LQ=(0,w.$Fi)("configurationResolverService");var S;(function(O){O.Unknown="unknown",O.Env="env",O.Config="config",O.Command="command",O.Input="input",O.ExtensionInstallFolder="extensionInstallFolder",O.WorkspaceFolder="workspaceFolder",O.Cwd="cwd",O.WorkspaceFolderBasename="workspaceFolderBasename",O.UserHome="userHome",O.LineNumber="lineNumber",O.SelectedText="selectedText",O.File="file",O.FileWorkspaceFolder="fileWorkspaceFolder",O.FileWorkspaceFolderBasename="fileWorkspaceFolderBasename",O.RelativeFile="relativeFile",O.RelativeFileDirname="relativeFileDirname",O.FileDirname="fileDirname",O.FileExtname="fileExtname",O.FileBasename="fileBasename",O.FileBasenameNoExtension="fileBasenameNoExtension",O.FileDirnameBasename="fileDirnameBasename",O.ExecPath="execPath",O.ExecInstallFolder="execInstallFolder",O.PathSeparator="pathSeparator",O.PathSeparatorAlias="/"})(S||(e.VariableKind=S={}));class k extends Error{constructor(A,T){super(T),this.variable=A}}e.$MQ=k}),define(ke[244],Ce([1,0,20,79,15,26,21,103,202,243,13]),function(oe,e,w,S,k,O,A,T,p,a,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2Q=void 0,w=qe(w),S=qe(S),k=qe(k),O=qe(O);class y{static{this.VARIABLE_LHS="${"}static{this.VARIABLE_REGEXP=/\$\{(.*?)\}/g}constructor(E,d,n,s){this.h=new Map,this.a=E,this.b=d,this.g=n,s&&(this.c=s.then(o=>this.i(o)))}i(E){if(A.$i){const d=Object.create(null);return Object.keys(E).forEach(n=>{d[n.toLowerCase()]=E[n]}),d}return E}resolveWithEnvironment(E,d,n){return this.l({env:this.i(E),userHome:void 0},d?d.uri:void 0,n)}async resolveAsync(E,d){const n={env:await this.c,userHome:await this.g};return this.l(n,E?E.uri:void 0,d)}async j(E,d,n,s){const o=O.$bo(d);A.$i&&o.windows?Object.keys(o.windows).forEach(i=>o[i]=o.windows[i]):A.$j&&o.osx?Object.keys(o.osx).forEach(i=>o[i]=o.osx[i]):A.$k&&o.linux&&Object.keys(o.linux).forEach(i=>o[i]=o.linux[i]),delete o.windows,delete o.osx,delete o.linux;const h={env:await this.c,userHome:await this.g};return this.l(h,E?E.uri:void 0,o,n,s)}async resolveAnyAsync(E,d,n){return this.j(E,d,n)}async resolveAnyMap(E,d,n){const s=new Map;return{newConfig:await this.j(E,d,n,s),resolvedVariables:s}}resolveWithInteractionReplace(E,d,n,s){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(E,d,n,s){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(E,d){if(this.h.has(E))throw new Error("Variable "+E+" is contributed twice.");this.h.set(E,d)}async l(E,d,n,s,o){if(k.$fg(n))return this.m(E,d,n,s,o);if(Array.isArray(n))return Promise.all(n.map(h=>this.l(E,d,h,s,o)));if(k.$hg(n)){const h=Object.create(null),i=await Promise.all(Object.keys(n).map(async r=>[await this.m(E,d,r,s,o),await this.l(E,d,n[r],s,o)]));for(const[r,t]of i)h[r]=t;return h}return n}m(E,d,n,s,o){return(0,R.$yf)(n,y.VARIABLE_REGEXP,async(h,i)=>{if(i.includes(y.VARIABLE_LHS))return h;let r=await this.o(E,h,i,d,s);return o?.set(i,r),r!==h&&k.$fg(r)&&r.match(y.VARIABLE_REGEXP)&&(r=await this.m(E,d,r,s,o)),r})}n(E){return this.b?this.b.getUriLabel(E,{noPrefix:!0}):E.fsPath}async o(E,d,n,s,o){let h;const i=n.split(":");i.length>1&&(n=i[0],h=i[1]);const r=l=>{const m=this.a.getFilePath();if(m)return(0,T.$Sw)(m);throw new a.$MQ(l,(0,p.localize)(0,null,d))},t=l=>{const m=r(l);if(this.a.getWorkspaceFolderPathForFile){const f=this.a.getWorkspaceFolderPathForFile();if(f)return(0,T.$Sw)(f)}throw new a.$MQ(l,(0,p.localize)(1,null,d,w.$pc(m)))},c=l=>{if(h){const m=this.a.getFolderUri(h);if(m)return m;throw new a.$MQ(l,(0,p.localize)(2,null,d,h))}if(s)return s;throw this.a.getWorkspaceFolderCount()>1?new a.$MQ(l,(0,p.localize)(3,null,d)):new a.$MQ(l,(0,p.localize)(4,null,d))};switch(n){case"env":if(h){if(E.env){const l=E.env[A.$i?h.toLowerCase():h];if(k.$fg(l))return l}return""}throw new a.$MQ(a.VariableKind.Env,(0,p.localize)(5,null,d));case"config":if(h){const l=this.a.getConfigurationValue(s,h);if(k.$og(l))throw new a.$MQ(a.VariableKind.Config,(0,p.localize)(6,null,d,h));if(k.$hg(l))throw new a.$MQ(a.VariableKind.Config,(0,p.localize)(7,null,d,h));return l}throw new a.$MQ(a.VariableKind.Config,(0,p.localize)(8,null,d));case"command":return this.p(a.VariableKind.Command,d,h,o,"command");case"input":return this.p(a.VariableKind.Input,d,h,o,"input");case"extensionInstallFolder":if(h){const l=await this.a.getExtension(h);if(!l)throw new a.$MQ(a.VariableKind.ExtensionInstallFolder,(0,p.localize)(9,null,d,h));return this.n(l.extensionLocation)}throw new a.$MQ(a.VariableKind.ExtensionInstallFolder,(0,p.localize)(10,null,d));default:switch(n){case"workspaceRoot":case"workspaceFolder":return(0,T.$Sw)(this.n(c(a.VariableKind.WorkspaceFolder)));case"cwd":return s||h?(0,T.$Sw)(this.n(c(a.VariableKind.Cwd))):S.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,T.$Sw)(w.$pc(this.n(c(a.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(E.userHome)return E.userHome;throw new a.$MQ(a.VariableKind.UserHome,(0,p.localize)(11,null,d))}case"lineNumber":{const l=this.a.getLineNumber();if(l)return l;throw new a.$MQ(a.VariableKind.LineNumber,(0,p.localize)(12,null,d))}case"selectedText":{const l=this.a.getSelectedText();if(l)return l;throw new a.$MQ(a.VariableKind.SelectedText,(0,p.localize)(13,null,d))}case"file":return r(a.VariableKind.File);case"fileWorkspaceFolder":return t(a.VariableKind.FileWorkspaceFolder);case"fileWorkspaceFolderBasename":return w.$pc(t(a.VariableKind.FileWorkspaceFolderBasename));case"relativeFile":return s||h?w.$nc(this.n(c(a.VariableKind.RelativeFile)),r(a.VariableKind.RelativeFile)):r(a.VariableKind.RelativeFile);case"relativeFileDirname":{const l=w.$oc(r(a.VariableKind.RelativeFileDirname));if(s||h){const m=w.$nc(this.n(c(a.VariableKind.RelativeFileDirname)),l);return m.length===0?".":m}return l}case"fileDirname":return w.$oc(r(a.VariableKind.FileDirname));case"fileExtname":return w.$qc(r(a.VariableKind.FileExtname));case"fileBasename":return w.$pc(r(a.VariableKind.FileBasename));case"fileBasenameNoExtension":{const l=w.$pc(r(a.VariableKind.FileBasenameNoExtension));return l.slice(0,l.length-w.$qc(l).length)}case"fileDirnameBasename":return w.$pc(w.$oc(r(a.VariableKind.FileDirnameBasename)));case"execPath":{const l=this.a.getExecPath();return l||d}case"execInstallFolder":{const l=this.a.getAppRoot();return l||d}case"pathSeparator":case"/":return w.sep;default:try{const l=h?`${n}:${h}`:n;return this.p(a.VariableKind.Unknown,d,l,o,void 0)}catch{return d}}}}p(E,d,n,s,o){if(n&&s){const h=o===void 0?s[n]:s[o+":"+n];if(typeof h=="string")return h;throw new a.$MQ(E,(0,p.localize)(14,null,d))}return d}}e.$2Q=y}),define(ke[117],Ce([1,0,3,114]),function(oe,e,w,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OpenEditorContext=e.GroupsOrder=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.$fE=void 0,e.$gE=a,e.$hE=u,e.$iE=E,e.$fE=(0,w.$Fi)("editorGroupsService");var k;(function(d){d[d.UP=0]="UP",d[d.DOWN=1]="DOWN",d[d.LEFT=2]="LEFT",d[d.RIGHT=3]="RIGHT"})(k||(e.GroupDirection=k={}));var O;(function(d){d[d.HORIZONTAL=0]="HORIZONTAL",d[d.VERTICAL=1]="VERTICAL"})(O||(e.GroupOrientation=O={}));var A;(function(d){d[d.FIRST=0]="FIRST",d[d.LAST=1]="LAST",d[d.NEXT=2]="NEXT",d[d.PREVIOUS=3]="PREVIOUS"})(A||(e.GroupLocation=A={}));var T;(function(d){d[d.MAXIMIZE=0]="MAXIMIZE",d[d.EXPAND=1]="EXPAND",d[d.EVEN=2]="EVEN"})(T||(e.GroupsArrangement=T={}));var p;(function(d){d[d.COPY_EDITORS=0]="COPY_EDITORS",d[d.MOVE_EDITORS=1]="MOVE_EDITORS"})(p||(e.MergeGroupMode=p={}));function a(d){const n=d;return(0,S.$4F)(n?.editor)&&(0,S.$4F)(n?.replacement)}var R;(function(d){d[d.CREATION_TIME=0]="CREATION_TIME",d[d.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",d[d.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(R||(e.GroupsOrder=R={}));var y;(function(d){d[d.NEW_EDITOR=1]="NEW_EDITOR",d[d.MOVE_EDITOR=2]="MOVE_EDITOR",d[d.COPY_EDITOR=3]="COPY_EDITOR"})(y||(e.OpenEditorContext=y={}));function u(d){const n=d;return!!n&&typeof n.id=="number"&&Array.isArray(n.editors)}function E(d){return d.getValue("workbench.editor.openSideBySideDirection")==="down"?k.DOWN:k.RIGHT}}),define(ke[245],Ce([1,0,3,117]),function(oe,e,w,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mE=e.$lE=e.$kE=e.$jE=void 0,e.$nE=k,e.$jE=(0,w.$Fi)("editorService"),e.$kE=-1,e.$lE=-2,e.$mE=-3;function k(O){const A=O;return typeof O=="number"||(0,S.$hE)(A)}}),define(ke[246],Ce([1,0,3,106]),function(oe,e,w,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$OM=void 0,e.$OM=(0,w.$Gi)(S.$Mi)}),define(ke[118],Ce([1,0,19,6,20,4,11]),function(oe,e,w,S,k,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$occ=e.$ncc=e.$mcc=e.$lcc=e.$kcc=void 0,k=qe(k);class T{constructor(h,i){this.versionId=h,this.removedDueToLooping=i}}e.$kcc=T;class p{static isHostExtension(h,i,r){if(i.getExtensionDescription(h))return!1;const t=r.getExtensionDescription(h);return t?!!((t.main||t.browser)&&t.api==="none"):!1}constructor(h,i){this.j=h,this.c=new S.$me,this.onDidChange=this.c.event,this.d=0,this.e=i,this.k()}k(){this.e.sort(n),this.f=new w.$sn,this.g=[],this.h=new Map;for(const h of this.e){if(this.f.has(h.identifier)){console.error("Extension `"+h.identifier.value+"` is already registered");continue}this.f.set(h.identifier,h),this.g.push(h);const i=this.j.readActivationEvents(h);for(const r of i)this.h.has(r)||this.h.set(r,[]),this.h.get(r).push(h)}}set(h){return this.e=h,this.k(),this.d++,this.c.fire(void 0),{versionId:this.d}}deltaExtensions(h,i){this.e=s(this.e,i),this.e=this.e.concat(h);const r=p.l(this.e);return this.e=s(this.e,r.map(t=>t.identifier)),this.k(),this.d++,this.c.fire(void 0),new T(this.d,r)}static l(h){const i=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(m){this.d.has(m)||(this.d.add(m),this.e.push(m))}addArc(m,f){this.addNode(m),this.addNode(f),this.c.has(m)?this.c.get(m).push(f):this.c.set(m,[f])}getArcs(m){return this.c.has(m)?this.c.get(m):[]}hasOnlyGoodArcs(m,f){const $=i.getArcs(m);for(let I=0;I<$.length;I++)if(!f.has($[I]))return!1;return!0}getNodes(){return this.e}},r=new w.$sn;for(const m of h)if(r.set(m.identifier,m),m.extensionDependencies)for(const f of m.extensionDependencies)i.addArc(w.$qn.toKey(m.identifier),w.$qn.toKey(f));const t=new Set;i.getNodes().filter(m=>i.getArcs(m).length===0).forEach(m=>t.add(m));const c=i.getNodes().filter(m=>!t.has(m));let l;do{l=!1;for(let m=0;m<c.length;m++){const f=c[m];i.hasOnlyGoodArcs(f,t)&&(c.splice(m,1),m--,t.add(f),l=!0)}}while(l);return c.map(m=>r.get(m))}containsActivationEvent(h){return this.h.has(h)}containsExtension(h){return this.f.has(h)}getExtensionDescriptionsForActivationEvent(h){const i=this.h.get(h);return i?i.slice(0):[]}getAllExtensionDescriptions(){return this.g.slice(0)}getSnapshot(){return new a(this.d,this.getAllExtensionDescriptions())}getExtensionDescription(h){const i=this.f.get(h);return i||void 0}getExtensionDescriptionByUUID(h){for(const i of this.g)if(i.uuid===h)return i}getExtensionDescriptionByIdOrUUID(h,i){return this.getExtensionDescription(h)??(i?this.getExtensionDescriptionByUUID(i):void 0)}}e.$lcc=p;class a{constructor(h,i){this.versionId=h,this.extensions=i}}e.$mcc=a;class R{constructor(h){this.d=new E,this.c=new p(h,[])}async acquireLock(h){const i=await this.d.acquire(h);return new y(this,i)}deltaExtensions(h,i,r){if(!h.isAcquiredFor(this))throw new Error("Lock is not held");return this.c.deltaExtensions(i,r)}containsActivationEvent(h){return this.c.containsActivationEvent(h)}containsExtension(h){return this.c.containsExtension(h)}getExtensionDescriptionsForActivationEvent(h){return this.c.getExtensionDescriptionsForActivationEvent(h)}getAllExtensionDescriptions(){return this.c.getAllExtensionDescriptions()}getSnapshot(){return this.c.getSnapshot()}getExtensionDescription(h){return this.c.getExtensionDescription(h)}getExtensionDescriptionByUUID(h){return this.c.getExtensionDescriptionByUUID(h)}getExtensionDescriptionByIdOrUUID(h,i){return this.c.getExtensionDescriptionByIdOrUUID(h,i)}}e.$ncc=R;class y extends O.$Wc{constructor(h,i){super(),this.f=h,this.c=!1,this.B(i)}isAcquiredFor(h){return!this.c&&this.f===h}}e.$occ=y;class u{constructor(h){this.name=h;const i=(0,A.$yh)();this.promise=i.promise,this.c=i.resolve}resolve(h){this.c(h)}}class E{constructor(){this.c=[],this.d=!1}async acquire(h){const i=new u(h);return this.c.push(i),this.e(),i.promise}e(){if(this.d||this.c.length===0)return;const h=this.c.shift();this.d=!0;let i=!0;const r=setTimeout(()=>{i&&console.warn(`The customer named ${h.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),t=()=>{i&&(clearTimeout(r),i=!1,this.d=!1,this.e())};h.resolve((0,O.$Uc)(t))}}var d;(function(o){o[o.Builtin=0]="Builtin",o[o.User=1]="User",o[o.Dev=2]="Dev"})(d||(d={}));function n(o,h){const i=o.isBuiltin?d.Builtin:o.isUnderDevelopment?d.Dev:d.User,r=h.isBuiltin?d.Builtin:h.isUnderDevelopment?d.Dev:d.User;if(i!==r)return i-r;const t=k.$ic.basename(o.extensionLocation.path),c=k.$ic.basename(h.extensionLocation.path);return t<c?-1:t>c?1:0}function s(o,h){const i=new w.$rn(h);return o.filter(r=>!i.has(r.identifier))}}),define(ke[84],Ce([1,0,23]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0,e.$yn=A,e.$zn=T;var S;(function(a){a[a.Desktop=1]="Desktop",a[a.Web=2]="Web"})(S||(e.UIKind=S={}));var k;(function(a){a[a.VersionMismatch=55]="VersionMismatch",a[a.UnexpectedError=81]="UnexpectedError"})(k||(e.ExtensionHostExitCode=k={}));var O;(function(a){a[a.Initialized=0]="Initialized",a[a.Ready=1]="Ready",a[a.Terminate=2]="Terminate"})(O||(e.MessageType=O={}));function A(a){const R=w.$Oe.alloc(1);switch(a){case O.Initialized:R.writeUInt8(1,0);break;case O.Ready:R.writeUInt8(2,0);break;case O.Terminate:R.writeUInt8(3,0);break}return R}function T(a,R){if(a.byteLength!==1)return!1;switch(a.readUInt8(0)){case 1:return R===O.Initialized;case 2:return R===O.Ready;case 3:return R===O.Terminate;default:return!1}}var p;(function(a){a.Start="START_NATIVE_LOG",a.End="END_NATIVE_LOG"})(p||(e.NativeLogMarkers=p={}))}),define(ke[67],Ce([1,0,3,6,112,12,27,84,63,64,26,2,4,187]),function(oe,e,w,S,k,O,A,T,p,a,R,y,u,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fQ=e.$dQ=e.$cQ=void 0,e.$eQ=s;let d=class extends u.$Wc{constructor(h,i){super(),this.s=h,this.t=i,this.a=this.B(new S.$me),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new S.$me),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=k.TelemetryLevel.NONE,this.g=!1,this.j=!1,this.r=new Map,this.m=y.URI.revive(this.s.environment.extensionTelemetryLogResource),this.j=this.s.environment.isExtensionTelemetryLoggingOnly,this.n=i.createLogger(this.m,{id:a.$xp,name:(0,E.localize)(0,null,this.j?" (Not Sent)":""),hidden:!0}),this.B(this.n),this.B(i.onDidChangeLogLevel(r=>{(0,O.$bk)(r)&&this.u()})),this.n.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.n.info("===========================================================")}u(){this.t.setVisibility(this.m,this.g&&this.t.getLogLevel()===O.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===k.TelemetryLevel.USAGE}getTelemetryDetails(){return{isCrashEnabled:this.f>=k.TelemetryLevel.CRASH,isErrorsEnabled:this.c.error?this.f>=k.TelemetryLevel.ERROR:!1,isUsageEnabled:this.c.usage?this.f>=k.TelemetryLevel.USAGE:!1}}instantiateLogger(h,i,r){const t=this.getTelemetryDetails(),c=new n(i,r,h,this.n,this.j,this.getBuiltInCommonProperties(h),{isUsageEnabled:t.isUsageEnabled,isErrorsEnabled:t.isErrorsEnabled}),l=this.r.get(h.identifier.value)??[];return this.r.set(h.identifier.value,[...l,c]),c.apiTelemetryLogger}$initializeTelemetryLevel(h,i,r){this.f=h,this.g=i,this.c=r??{usage:!0,error:!0},this.u()}getBuiltInCommonProperties(h){const i=Object.create(null);switch(i["common.extname"]=`${h.publisher}.${h.name}`,i["common.extversion"]=h.version,i["common.vscodemachineid"]=this.s.telemetryInfo.machineId,i["common.vscodesessionid"]=this.s.telemetryInfo.sessionId,i["common.sqmid"]=this.s.telemetryInfo.sqmId,i["common.devDeviceId"]=this.s.telemetryInfo.devDeviceId,i["common.vscodeversion"]=this.s.version,i["common.isnewappinstall"]=s(this.s.telemetryInfo.firstSessionDate),i["common.product"]=this.s.environment.appHost,this.s.uiKind){case T.UIKind.Web:i["common.uikind"]="web";break;case T.UIKind.Desktop:i["common.uikind"]="desktop";break;default:i["common.uikind"]="unknown"}return i["common.remotename"]=(0,p.$hn)((0,a.$Dp)(this.s.remote.authority)),i}$onDidChangeTelemetryLevel(h){this.h=this.getTelemetryConfiguration(),this.f=h;const i=this.getTelemetryDetails();this.r.forEach((r,t)=>{const c=r.filter(l=>!l.isDisposed);c.length===0?this.r.delete(t):this.r.set(t,c)}),this.r.forEach(r=>{for(const t of r)t.updateTelemetryEnablements(i.isUsageEnabled,i.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.u()}onExtensionError(h,i){const t=this.r.get(h.value)?.filter(l=>!l.isDisposed);if(!t)return this.r.delete(h.value),!1;let c=!1;for(const l of t)l.ignoreUnhandledExtHostErrors||(l.logError(i),c=!0);return c}};e.$cQ=d,e.$cQ=d=He([Ve(0,A.$bQ),Ve(1,O.$ak)],d);class n{static validateSender(h){if(typeof h!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof h.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof h.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof h.flush<"u"&&typeof h.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(h,i,r,t,c,l,m){this.g=r,this.h=t,this.i=c,this.j=l,this.a=new S.$me,this.ignoreUnhandledExtHostErrors=i?.ignoreUnhandledErrors??!1,this.b=i?.ignoreBuiltInCommonProperties??!1,this.c=i?.additionalCommonProperties,this.f=h,this.d={isUsageEnabled:m.isUsageEnabled,isErrorsEnabled:m.isErrorsEnabled}}updateTelemetryEnablements(h,i){this.e&&(this.d={isUsageEnabled:h,isErrorsEnabled:i},this.a.fire(this.e))}mixInCommonPropsAndCleanData(h){let i="properties"in h?h.properties??{}:h;return i=(0,a.$Gp)(i,[]),this.c&&(i=(0,R.$eo)(i,this.c)),this.b||(i=(0,R.$eo)(i,this.j)),"properties"in h?h.properties=i:h=i,h}k(h,i){this.f&&(this.g.publisher==="vscode"?h=this.g.name+"/"+h:h=this.g.identifier.value+"/"+h,i=this.mixInCommonPropsAndCleanData(i||{}),this.i||this.f?.sendEventData(h,i),this.h.trace(h,i))}logUsage(h,i){this.d.isUsageEnabled&&this.k(h,i)}logError(h,i){if(!(!this.d.isErrorsEnabled||!this.f))if(typeof h=="string")this.k(h,i);else{const r={name:h.name,message:h.message,stack:h.stack,cause:h.cause},t=(0,a.$Gp)(r,[]),c=new Error(t.message,{cause:t.cause});c.stack=t.stack,c.name=t.name,i=this.mixInCommonPropsAndCleanData(i||{}),this.i||this.f.sendErrorData(c,i),this.h.trace("exception",i)}}get apiTelemetryLogger(){if(!this.e){const h=this,i={logUsage:h.logUsage.bind(h),get isUsageEnabled(){return h.d.isUsageEnabled},get isErrorsEnabled(){return h.d.isErrorsEnabled},logError:h.logError.bind(h),dispose:h.dispose.bind(h),onDidChangeEnableStates:h.a.event.bind(h)};this.e=Object.freeze(i)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let h=this.f;this.f=void 0,Promise.resolve(h.flush()).then(h=void 0),this.e=void 0}else this.f=void 0}}e.$dQ=n;function s(o){const h=Date.now()-new Date(o).getTime();return isNaN(h)?!1:h<1e3*60*60*24}e.$fQ=(0,w.$Fi)("IExtHostTelemetry")}),define(ke[25],Ce([1,0,6,2,218,111,19,3]),function(oe,e,w,S,k,O,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9G=e.ActivationKind=e.$6G=e.$5G=e.$2G=e.ExtensionHostStartup=e.$1G=e.$ZG=e.$YG=e.$XG=void 0,e.$3G=u,e.$4G=E,e.$7G=o,e.$8G=h,e.$XG=Object.freeze({identifier:new A.$qn("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:S.URI.parse("void:location"),isBuiltin:!1,targetPlatform:A.TargetPlatform.UNDEFINED,isUserBuiltin:!1,isUnderDevelopment:!1}),e.$YG="extensions.webWorker",e.$ZG=(0,T.$Fi)("extensionService");class p{constructor(t){this.dependency=t}}e.$1G=p;var a;(function(r){r[r.EagerAutoStart=1]="EagerAutoStart",r[r.EagerManualStart=2]="EagerManualStart",r[r.Lazy=3]="Lazy"})(a||(e.ExtensionHostStartup=a={}));class R{get versionId(){return this.c}get allExtensions(){return this.d}get myExtensions(){return this.e}constructor(t,c,l){this.c=t,this.d=c.slice(0),this.e=l.slice(0),this.f=null}toSnapshot(){return{versionId:this.c,allExtensions:this.d,myExtensions:this.e,activationEvents:O.$IG.createActivationEventsMap(this.d)}}set(t,c,l){if(this.c>t)throw new Error(`ExtensionHostExtensions: invalid versionId ${t} (current: ${this.c})`);const m=[],f=[],$=[],I=[],D=y(this.d),v=y(c),C=(N,B)=>N.extensionLocation.toString()===B.extensionLocation.toString()||N.isBuiltin===B.isBuiltin||N.isUserBuiltin===B.isUserBuiltin||N.isUnderDevelopment===B.isUnderDevelopment;for(const N of this.d){const B=v.get(N.identifier);if(!B){m.push(N.identifier),D.delete(N.identifier);continue}if(!C(N,B)){m.push(N.identifier),D.delete(N.identifier);continue}}for(const N of c){const B=D.get(N.identifier);if(!B){f.push(N);continue}if(!C(B,N)){m.push(B.identifier),D.delete(B.identifier);continue}}const P=new A.$rn(this.e),g=new A.$rn(l);for(const N of this.e)g.has(N)||$.push(N);for(const N of l)P.has(N)||I.push(N);const b=O.$IG.createActivationEventsMap(f),L={versionId:t,toRemove:m,toAdd:f,addActivationEvents:b,myToRemove:$,myToAdd:I};return this.delta(L),L}delta(t){if(this.c>=t.versionId)return null;const{toRemove:c,toAdd:l,myToRemove:m,myToAdd:f}=t,$=new A.$rn(c),I=new A.$rn(m);for(let D=0;D<this.d.length;D++)$.has(this.d[D].identifier)&&(this.d.splice(D,1),D--);for(let D=0;D<this.e.length;D++)I.has(this.e[D])&&(this.e.splice(D,1),D--);for(const D of l)this.d.push(D);for(const D of f)this.e.push(D);return this.f=null,t}containsExtension(t){for(const c of this.e)if(A.$qn.equals(c,t))return!0;return!1}containsActivationEvent(t){return this.f||(this.f=this.g()),this.f.has(t)}g(){const t=new Set;for(const c of this.d){if(!this.containsExtension(c.identifier))continue;const l=O.$IG.readActivationEvents(c);for(const m of l)t.add(m)}return t}}e.$2G=R;function y(r){const t=new A.$sn;for(const c of r)t.set(c.identifier,c);return t}function u(r,t){return r.enabledApiProposals?r.enabledApiProposals.includes(t):!1}function E(r,t){if(!u(r,t))throw new Error(`Extension '${r.identifier.value}' CANNOT use API proposal: ${t}.
Its package.json#enabledApiProposals-property declares: ${r.enabledApiProposals?.join(", ")??"[]"} but NOT ${t}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${r.identifier.value}`)}class d{constructor(t,c,l,m){this.codeLoadingTime=t,this.activateCallTime=c,this.activateResolvedTime=l,this.activationReason=m}}e.$5G=d;class n{constructor(t,c){this.description=t,this.value=c}}e.$6G=n;var s;(function(r){r[r.Normal=0]="Normal",r[r.Immediate=1]="Immediate"})(s||(e.ActivationKind=s={}));function o(r){return{type:r.isBuiltin?A.ExtensionType.System:A.ExtensionType.User,isBuiltin:r.isBuiltin||r.isUserBuiltin,identifier:{id:(0,k.$Mp)(r.publisher,r.name),uuid:r.uuid},manifest:r,location:r.extensionLocation,targetPlatform:r.targetPlatform,validations:[],isValid:!0}}function h(r,t){const c=(0,k.$Kp)(r.manifest.publisher,r.manifest.name);return{id:c,identifier:new A.$qn(c),isBuiltin:r.type===A.ExtensionType.System,isUserBuiltin:r.type===A.ExtensionType.User&&r.isBuiltin,isUnderDevelopment:!!t,extensionLocation:r.location,uuid:r.identifier.uuid,targetPlatform:r.targetPlatform,publisherDisplayName:r.publisherDisplayName,...r.manifest}}class i{constructor(){this.onDidRegisterExtensions=w.Event.None,this.onDidChangeExtensionsStatus=w.Event.None,this.onDidChangeExtensions=w.Event.None,this.onWillActivateByEvent=w.Event.None,this.onDidChangeResponsiveChange=w.Event.None,this.onWillStop=w.Event.None,this.extensions=[]}activateByEvent(t){return Promise.resolve(void 0)}activateById(t,c){return Promise.resolve(void 0)}activationEventIsDone(t){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(t){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(t,c){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(t){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.$9G=i}),define(ke[247],Ce([1,0,14,118,19,25,12,11]),function(oe,e,w,S,k,O,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zoc=e.$yoc=e.$xoc=e.$woc=e.$voc=e.$uoc=void 0,w=qe(w);class p{static{this.NONE=new p(!1,-1,-1,-1)}constructor(o,h,i,r){this.startup=o,this.codeLoadingTime=h,this.activateCallTime=i,this.activateResolvedTime=r}}e.$uoc=p;class a{constructor(o){this.a=o,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(o,h){return o===-1||h===-1?-1:h-o}build(){return new p(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.$voc=a;class R{constructor(o,h,i,r,t,c){this.activationFailed=o,this.activationFailedError=h,this.activationTimes=i,this.module=r,this.exports=t,this.subscriptions=c}}e.$woc=R;class y extends R{constructor(o){super(!1,null,o,{activate:void 0,deactivate:void 0},void 0,[])}}e.$xoc=y;class u extends R{constructor(){super(!1,null,p.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.$yoc=u;class E extends R{constructor(o){super(!0,o,p.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let d=class{constructor(o,h,i,r){this.g=r,this.a=o,this.b=h,this.c=i,this.d=new k.$sn,this.f=Object.create(null)}dispose(){for(const[o,h]of this.d)h.dispose()}async waitForActivatingExtensions(){const o=[];for(const[h,i]of this.d)o.push(i.wait());await Promise.all(o)}isActivated(o){const h=this.d.get(o);return!!(h&&h.value)}getActivatedExtension(o){const h=this.d.get(o);if(!h||!h.value)throw new Error(`Extension '${o.value}' is not known or not activated`);return h.value}async activateByEvent(o,h){if(this.f[o])return;const i=this.a.getExtensionDescriptionsForActivationEvent(o);await this.h(i.map(r=>({id:r.identifier,reason:{startup:h,extensionId:r.identifier,activationEvent:o}}))),this.f[o]=!0}activateById(o,h){const i=this.a.getExtensionDescription(o);if(!i)throw new Error(`Extension '${o.value}' is not known`);return this.h([{id:i.identifier,reason:h}])}async h(o){const h=o.filter(i=>!this.isActivated(i.id)).map(i=>this.j(i));await Promise.all(h.map(i=>i.wait()))}j(o){if(this.d.has(o.id))return this.d.get(o.id);if(this.l(o.id))return this.k(o,null,[],null);const h=this.a.getExtensionDescription(o.id);if(!h){const t=new Error(`Cannot activate unknown extension '${o.id.value}'`),c=this.k(o,null,[],new E(t));return this.c.onExtensionActivationError(o.id,t,new O.$1G(o.id.value)),c}const i=[],r=typeof h.extensionDependencies>"u"?[]:h.extensionDependencies;for(const t of r){if(this.m(t))continue;const c=this.d.get(t);if(c){i.push(c);continue}if(this.l(t)){i.push(this.j({id:this.b.getExtensionDescription(t).identifier,reason:o.reason}));continue}const l=this.a.getExtensionDescription(t);if(l){if(!l.main&&!l.browser)continue;i.push(this.j({id:l.identifier,reason:o.reason}));continue}const m=h.displayName||h.identifier.value,f=new Error(`Cannot activate the '${m}' extension because it depends on unknown extension '${t}'`),$=this.k(o,h.displayName,[],new E(f));return this.c.onExtensionActivationError(h.identifier,f,new O.$1G(t)),$}return this.k(o,h.displayName,i,null)}k(o,h,i,r){const t=new n(o.id,h,o.reason,i,r,this.c,this.g);return this.d.set(o.id,t),t}l(o){return S.$lcc.isHostExtension(o,this.a,this.b)}m(o){const h=this.b.getExtensionDescription(o);return h?!h.main&&!h.browser:!1}};e.$zoc=d,e.$zoc=d=He([Ve(3,A.$_j)],d);let n=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(o,h,i,r,t,c,l){this.c=o,this.d=h,this.f=i,this.g=r,this.h=t,this.j=c,this.k=l,this.a=new T.$Eh,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let o=0;o<this.g.length;o++){const h=this.g[o];if(h.value&&!h.value.activationFailed){this.g.splice(o,1),o--;continue}if(h.value&&h.value.activationFailed){const i=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${h.friendlyName}' failed to activate`);i.detail=h.value.activationFailedError,this.h=new E(i),this.j.onExtensionActivationError(this.c,i,null);return}}this.g.length>0&&await Promise.race(this.g.map(o=>o.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(o){const h=new Error;if(o&&o.name&&(h.name=o.name),o&&o.message?h.message=`Activating extension '${this.c.value}' failed: ${o.message}.`:h.message=`Activating extension '${this.c.value}' failed: ${o}.`,o&&o.stack&&(h.stack=o.stack),this.h=new E(h),this.b&&w.$6(o))return;this.j.onExtensionActivationError(this.c,h,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(o)}}};n=He([Ve(6,A.$_j)],n)}),define(ke[248],Ce([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({activeComment:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.activeComment.d.ts",aiRelatedInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts",aiTextSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiTextSearchProvider.d.ts",attributableCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.attributableCoverage.d.ts",authGetSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts",authLearnMore:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authLearnMore.d.ts",authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",canonicalUriProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts",chatParticipantAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantAdditions.d.ts",chatParticipantPrivate:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantPrivate.d.ts",chatProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts",chatTab:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatTab.d.ts",chatTools:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatTools.d.ts",chatVariableResolver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariableResolver.d.ts",codeActionAI:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts",codeActionRanges:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionRanges.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",commentReactor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReactor.d.ts",commentReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReveal.d.ts",commentThreadApplicability:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentThreadApplicability.d.ts",commentingRangeHint:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentingRangeHint.d.ts",commentsDraftState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts",contribAccessibilityHelpContent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribAccessibilityHelpContent.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribCommentsViewThreadMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentsViewThreadMenus.d.ts",contribDiffEditorGutterToolBarMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribDiffEditorGutterToolBarMenus.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribIssueReporter:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribIssueReporter.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribMultiDiffEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMultiDiffEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribSourceControlHistoryItemGroupMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemGroupMenu.d.ts",contribSourceControlHistoryItemMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemMenu.d.ts",contribSourceControlInputBoxMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlInputBoxMenu.d.ts",contribSourceControlTitleMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlTitleMenu.d.ts",contribStatusBarItems:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",createFileSystemWatcher:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",debugVisualization:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugVisualization.d.ts",defaultChatParticipant:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.defaultChatParticipant.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorHoverVerbosityLevel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorHoverVerbosityLevel.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",embeddings:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.embeddings.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileComments:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findFiles2:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findFiles2.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",inlineEdit:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineEdit.d.ts",interactive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",languageModelSystem:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageModelSystem.d.ts",languageStatusText:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts",lmTools:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.lmTools.d.ts",mappedEditsProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts",multiDocumentHighlightProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.multiDocumentHighlightProvider.d.ts",newSymbolNamesProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.newSymbolNamesProvider.d.ts",notebookCellExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecution.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",notebookVariableProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookVariableProvider.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickDiffProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts",quickPickItemTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmHistoryProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts",scmMultiDiffEditor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmMultiDiffEditor.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmTextDocument:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",shareProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts",showLocal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts",speech:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts",tabInputMultiDiff:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputMultiDiff.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalExecuteCommandEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",terminalSelection:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts",terminalShellIntegration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalShellIntegration.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeViewActiveItem:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts",treeViewMarkdownMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnelFactory:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})});var ti=this&&this.__importDefault||function(oe){return oe&&oe.__esModule?oe:{default:oe}};define(ke[119],Ce([1,0,204,14,36,110,78,31,19,248,108,111]),function(oe,e,w,S,k,O,A,T,p,a,R,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$WG=e.$VG=e.$UG=e.$TG=e.$SG=e.$RG=void 0,w=qe(w),k=ti(k);const u=T.$oo.as(A.$po.JSONContribution);class E{constructor(t,c,l){this.a=t,this.b=c,this.c=l}d(t,c){this.a({type:t,message:c,extensionId:this.b.identifier,extensionPointId:this.c})}error(t){this.d(k.default.Error,t)}warn(t){this.d(k.default.Warning,t)}info(t){this.d(k.default.Info,t)}}e.$RG=E;class d{static a(t){const c=new p.$rn;for(let l=0,m=t.length;l<m;l++)c.add(t[l].description.identifier);return c}static compute(t,c){if(!t||!t.length)return new d(c,[]);if(!c||!c.length)return new d([],t);const l=this.a(t),m=this.a(c),f=c.filter(I=>!l.has(I.description.identifier)),$=t.filter(I=>!m.has(I.description.identifier));return new d(f,$)}constructor(t,c){this.added=t,this.removed=c}}e.$SG=d;class n{constructor(t,c){this.name=t,this.defaultExtensionKind=c,this.a=null,this.b=null,this.c=null}setHandler(t){if(this.a!==null)throw new Error("Handler already set!");return this.a=t,this.d(),{dispose:()=>{this.a=null}}}acceptUsers(t){this.c=d.compute(this.b,t),this.b=t,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(t){(0,S.$3)(t)}}}e.$TG=n;const s={type:"string",enum:["ui","workspace"],enumDescriptions:[w.localize(0,null),w.localize(1,null)]},o="vscode://schemas/vscode-extensions";e.$UG={properties:{engines:{type:"object",description:w.localize(2,null),properties:{vscode:{type:"string",description:w.localize(3,null),default:"^1.22.0"}}},publisher:{description:w.localize(4,null),type:"string"},displayName:{description:w.localize(5,null),type:"string"},categories:{description:w.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:p.$pn},{type:"string",const:"Languages",deprecationMessage:w.localize(7,null)}]}},galleryBanner:{type:"object",description:w.localize(8,null),properties:{color:{description:w.localize(9,null),type:"string"},theme:{description:w.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:w.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:w.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:w.localize(13,null)},enabledApiProposals:{markdownDescription:w.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(a.allApiProposals),markdownEnumDescriptions:Object.values(a.allApiProposals)}},api:{markdownDescription:w.localize(15,null),type:"string",enum:["none"],enumDescriptions:[w.localize(16,null)]},activationEvents:{description:w.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:w.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:w.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:w.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:w.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:w.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:w.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:w.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:w.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:w.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:w.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:w.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:w.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:w.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:w.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:w.localize(32,null)},{label:"onUri",body:"onUri",description:w.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:w.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:w.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:w.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:w.localize(37,null)},{label:"onRenderer",description:w.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:w.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:w.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:w.localize(41,null)},{label:"onIssueReporterOpened",body:"onIssueReporterOpened",description:w.localize(42,null)},{label:"*",description:w.localize(43,null),body:"*"}]}},badges:{type:"array",description:w.localize(44,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:w.localize(45,null)},href:{type:"string",description:w.localize(46,null)},description:{type:"string",description:w.localize(47,null)}}}},markdown:{type:"string",description:w.localize(48,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:w.localize(49,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:w.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:O.$6o}},extensionPack:{description:w.localize(51,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:O.$6o}},extensionKind:{description:w.localize(52,null),type:"array",items:s,default:["workspace"],defaultSnippets:[{body:["ui"],description:w.localize(53,null)},{body:["workspace"],description:w.localize(54,null)},{body:["ui","workspace"],description:w.localize(55,null)},{body:["workspace","ui"],description:w.localize(56,null)},{body:[],description:w.localize(57,null)}]},capabilities:{description:w.localize(58,null),type:"object",properties:{virtualWorkspaces:{description:w.localize(59,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:w.localize(60,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[w.localize(61,null),w.localize(62,null),w.localize(63,null)]},description:{type:"string",markdownDescription:w.localize(64,null)}}},untrustedWorkspaces:{description:w.localize(65,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:w.localize(66,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[w.localize(67,null),w.localize(68,null),w.localize(69,null)]},restrictedConfigurations:{description:w.localize(70,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:w.localize(71,null)}}}}},sponsor:{description:w.localize(72,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:w.localize(73,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:w.localize(74,null),type:"string"},"vscode:uninstall":{description:w.localize(75,null),type:"string"}}},icon:{type:"string",description:w.localize(76,null)},l10n:{type:"string",description:w.localize(77,null)},pricing:{type:"string",markdownDescription:w.localize(78,null),enum:["Free","Trial"],default:"Free"}}};class h{constructor(){this.a=new Map}registerExtensionPoint(t){if(this.a.has(t.extensionPoint))throw new Error("Duplicate extension point: "+t.extensionPoint);const c=new n(t.extensionPoint,t.defaultExtensionKind);return this.a.set(t.extensionPoint,c),t.activationEventsGenerator&&y.$IG.register(t.extensionPoint,t.activationEventsGenerator),e.$UG.properties.contributes.properties[t.extensionPoint]=t.jsonSchema,u.registerSchema(o,e.$UG),c}getExtensionPoints(){return Array.from(this.a.values())}}e.$VG=h;const i={ExtensionsRegistry:"ExtensionsRegistry"};T.$oo.add(i.ExtensionsRegistry,new h),e.$WG=T.$oo.as(i.ExtensionsRegistry),u.registerSchema(o,e.$UG),u.registerSchema(R.$tk,{properties:{extensionEnabledApiProposals:{description:w.localize(79,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(a.allApiProposals),markdownEnumDescriptions:Object.values(a.allApiProposals)}}]}}}})}),define(ke[249],Ce([1,0,6,40,4,13,196,19,3,12,25,119]),function(oe,e,w,S,k,O,A,T,p,a,R,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_G=e.$$G=e.$0G=e.ChatMessageRole=void 0;var u;(function(n){n[n.System=0]="System",n[n.User=1]="User",n[n.Assistant=2]="Assistant"})(u||(e.ChatMessageRole=u={})),e.$0G=(0,p.$Fi)("ILanguageModelsService");const E={type:"object",properties:{vendor:{type:"string",description:(0,A.localize)(0,null)}}};e.$$G=y.$WG.registerExtensionPoint({extensionPoint:"languageModels",jsonSchema:{description:(0,A.localize)(1,null),oneOf:[E,{type:"array",items:E}]},activationEventsGenerator:(n,s)=>{for(const o of n)s.push(`onLanguageModelChat:${o.vendor}`)}});let d=class{constructor(s,o){this.e=s,this.f=o,this.a=new k.$Vc,this.b=new Map,this.c=new Set,this.d=this.a.add(new w.$me),this.onDidChangeLanguageModels=this.d.event,this.a.add(e.$$G.setHandler(h=>{this.c.clear();for(const r of h){if(!(0,R.$3G)(r.description,"chatProvider")){r.collector.error((0,A.localize)(2,null));continue}for(const t of S.Iterable.wrap(r.value)){if(this.c.has(t.vendor)){r.collector.error((0,A.localize)(3,null,t.vendor));continue}if((0,O.$df)(t.vendor)){r.collector.error((0,A.localize)(4,null));continue}if(t.vendor.trim()!==t.vendor){r.collector.error((0,A.localize)(5,null));continue}this.c.add(t.vendor)}}const i=[];for(const[r,t]of this.b)this.c.has(t.metadata.vendor)||(this.b.delete(r),i.push(r));i.length>0&&this.d.fire({removed:i})}))}dispose(){this.a.dispose(),this.b.clear()}getLanguageModelIds(){return Array.from(this.b.keys())}lookupLanguageModel(s){return this.b.get(s)?.metadata}async selectLanguageModels(s){if(s.vendor)await this.e.activateByEvent(`onLanguageModelChat:${s.vendor}}`);else{const h=Array.from(this.c).map(i=>this.e.activateByEvent(`onLanguageModelChat:${i}`));await Promise.all(h)}const o=[];for(const[h,i]of this.b)(s.vendor===void 0||i.metadata.vendor===s.vendor)&&(s.family===void 0||i.metadata.family===s.family)&&(s.version===void 0||i.metadata.version===s.version)&&(s.identifier===void 0||i.metadata.id===s.identifier)&&(!i.metadata.targetExtensions||i.metadata.targetExtensions.some(r=>T.$qn.equals(r,s.extension)))&&o.push(h);return this.f.trace("[LM] selected language models",s,o),o}registerLanguageModelChat(s,o){if(this.f.trace("[LM] registering language model chat",s,o.metadata),!this.c.has(o.metadata.vendor))throw new Error(`Chat response provider uses UNKNOWN vendor ${o.metadata.vendor}.`);if(this.b.has(s))throw new Error(`Chat response provider with identifier ${s} is already registered.`);return this.b.set(s,o),this.d.fire({added:[{identifier:s,metadata:o.metadata}]}),(0,k.$Uc)(()=>{this.b.delete(s)&&(this.d.fire({removed:[s]}),this.f.trace("[LM] UNregistered language model chat",s,o.metadata))})}makeLanguageModelChatRequest(s,o,h,i,r,t){const c=this.b.get(s);if(!c)throw new Error(`Chat response provider with identifier ${s} is not registered.`);return c.provideChatResponse(h,o,i,r,t)}computeTokenLength(s,o,h){const i=this.b.get(s);if(!i)throw new Error(`Chat response provider with identifier ${s} is not registered.`);return i.provideTokenCount(o,h)}};e.$_G=d,e.$_G=d=He([Ve(0,R.$ZG),Ve(1,a.$_j)],d)}),define(ke[250],Ce([1,0,199,15,26,119,32,6]),function(oe,e,w,S,k,O,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$EI=void 0,w=qe(w),S=qe(S),k=qe(k);const p={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:w.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:w.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:w.localize(2,null),default:""}}};var a;(function(u){function E(d,n,s){if(!d)return;const o=S.$fg(d.type)?d.type:void 0;if(!o||o.length===0){s.error(w.localize(3,null));return}const h=[];if(Array.isArray(d.required))for(const i of d.required)S.$fg(i)&&h.push(i);return{extensionId:n.value,taskType:o,required:h,properties:d.properties?k.$bo(d.properties):{},when:d.when?A.$Dj.deserialize(d.when):void 0}}u.from=E})(a||(a={}));const R=O.$WG.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(u,E)=>{for(const d of u)d.type&&E.push(`onTaskType:${d.type}`)},jsonSchema:{description:w.localize(4,null),type:"array",items:p}});class y{constructor(){this.d=new T.$me,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((E,d)=>{R.setHandler((n,s)=>{this.c=void 0;try{for(const o of s.removed){const h=o.value;for(const i of h)this.a&&i.type&&this.a[i.type]&&delete this.a[i.type]}for(const o of s.added){const h=o.value;for(const i of h){const r=a.from(i,o.description.identifier,o.collector);r&&(this.a[r.taskType]=r)}}(s.removed.length>0||s.added.length>0)&&this.d.fire()}catch{}E(void 0)})})}onReady(){return this.b}get(E){return this.a[E]}all(){return Object.keys(this.a).map(E=>this.a[E])}getJsonSchema(){if(this.c===void 0){const E=[];for(const d of this.all()){const n={type:"object",additionalProperties:!1};d.required.length>0&&(n.required=d.required.slice(0)),d.properties!==void 0?n.properties=k.$bo(d.properties):n.properties=Object.create(null),n.properties.type={type:"string",enum:[d.taskType]},E.push(n)}this.c={oneOf:E}}return this.c}}e.$EI=new y}),define(ke[251],Ce([1,0,200,15,24,26,32,250,42]),function(oe,e,w,S,k,O,A,T,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.$OI=e.JsonSchemaVersion=e.ExecutionEngine=e.$NI=e.$MI=e.$LI=e.$KI=e.$JI=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.$II=e.ShellQuoting=e.$HI=e.$GI=e.$FI=void 0,w=qe(w),S=qe(S),k=qe(k),O=qe(O),e.$FI="settings",e.$GI=new A.$Wj("taskRunning",!1,w.localize(0,null)),e.$HI=w.localize2(2,"Tasks");var a;(function(F){F[F.Escape=1]="Escape",F[F.Strong=2]="Strong",F[F.Weak=3]="Weak"})(a||(e.ShellQuoting=a={})),e.$II="$customized",function(F){function q(ue){if(!ue)return F.Strong;switch(ue.toLowerCase()){case"escape":return F.Escape;case"strong":return F.Strong;case"weak":return F.Weak;default:return F.Strong}}F.from=q}(a||(e.ShellQuoting=a={}));var R;(function(F){F.defaults={cwd:"${workspaceFolder}"}})(R||(e.CommandOptions=R={}));var y;(function(F){F[F.Always=1]="Always",F[F.Silent=2]="Silent",F[F.Never=3]="Never"})(y||(e.RevealKind=y={})),function(F){function q(ue){switch(ue.toLowerCase()){case"always":return F.Always;case"silent":return F.Silent;case"never":return F.Never;default:return F.Always}}F.fromString=q}(y||(e.RevealKind=y={}));var u;(function(F){F[F.Never=1]="Never",F[F.OnProblem=2]="OnProblem",F[F.Always=3]="Always"})(u||(e.RevealProblemKind=u={})),function(F){function q(ue){switch(ue.toLowerCase()){case"always":return F.Always;case"never":return F.Never;case"onproblem":return F.OnProblem;default:return F.OnProblem}}F.fromString=q}(u||(e.RevealProblemKind=u={}));var E;(function(F){F[F.Shared=1]="Shared",F[F.Dedicated=2]="Dedicated",F[F.New=3]="New"})(E||(e.PanelKind=E={})),function(F){function q(ue){switch(ue.toLowerCase()){case"shared":return F.Shared;case"dedicated":return F.Dedicated;case"new":return F.New;default:return F.Shared}}F.fromString=q}(E||(e.PanelKind=E={}));var d;(function(F){F.defaults={echo:!0,reveal:y.Always,revealProblems:u.Never,focus:!1,panel:E.Shared,showReuseMessage:!0,clear:!1}})(d||(e.PresentationOptions=d={}));var n;(function(F){F[F.Shell=1]="Shell",F[F.Process=2]="Process",F[F.CustomExecution=3]="CustomExecution"})(n||(e.RuntimeType=n={})),function(F){function q(ge){switch(ge.toLowerCase()){case"shell":return F.Shell;case"process":return F.Process;case"customExecution":return F.CustomExecution;default:return F.Process}}F.fromString=q;function ue(ge){switch(ge){case F.Shell:return"shell";case F.Process:return"process";case F.CustomExecution:return"customExecution";default:return"process"}}F.toString=ue}(n||(e.RuntimeType=n={}));var s;(function(F){function q(ue){return S.$fg(ue)?ue:ue.value}F.value=q})(s||(e.CommandString=s={}));var o;(function(F){F.Clean={_id:"clean",isDefault:!1},F.Build={_id:"build",isDefault:!1},F.Rebuild={_id:"rebuild",isDefault:!1},F.Test={_id:"test",isDefault:!1};function q(ge){return ge===F.Clean._id||ge===F.Build._id||ge===F.Rebuild._id||ge===F.Test._id}F.is=q;function ue(ge){if(ge!==void 0)return S.$fg(ge)?q(ge)?{_id:ge,isDefault:!1}:void 0:ge}F.from=ue})(o||(e.TaskGroup=o={}));var h;(function(F){F[F.Global=1]="Global",F[F.Workspace=2]="Workspace",F[F.Folder=3]="Folder"})(h||(e.TaskScope=h={}));var i;(function(F){F.Workspace="workspace",F.Extension="extension",F.InMemory="inMemory",F.WorkspaceFile="workspaceFile",F.User="user";function q(ue){switch(ue){case F.User:return p.ConfigurationTarget.USER;case F.WorkspaceFile:return p.ConfigurationTarget.WORKSPACE;default:return p.ConfigurationTarget.WORKSPACE_FOLDER}}F.toConfigurationTarget=q})(i||(e.TaskSourceKind=i={}));var r;(function(F){F.parallel="parallel",F.sequence="sequence"})(r||(e.DependsOrder=r={}));var t;(function(F){F[F.default=1]="default",F[F.folderOpen=2]="folderOpen"})(t||(e.RunOnOptions=t={}));var c;(function(F){F.defaults={reevaluateOnRerun:!0,runOn:t.default,instanceLimit:1}})(c||(e.RunOptions=c={}));class l{constructor(q,ue,ge,te,me,re){this._label="",this._id=q,ue&&(this._label=ue),ge&&(this.type=ge),this.runOptions=te,this.configurationProperties=me,this._source=re}getDefinition(q){}getMapKey(){return this._id}getKey(){}getCommonTaskId(){const q={folder:this.d(),id:this._id};return JSON.stringify(q)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(q,ue=!1){if(q===void 0)return!1;if(S.$fg(q))return q===this._label||q===this.configurationProperties.identifier||ue&&q===this._id;const ge=this.getDefinition(!0);return ge!==void 0&&ge._key===q._key}getQualifiedLabel(){const q=this.getWorkspaceFolder();return q?`${this._label} (${q.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(q){this.c===void 0&&(this.c=[]),q&&(this.c=this.c.concat(q))}get taskLoadMessages(){return this.c}}e.$JI=l;class m extends l{constructor(q,ue,ge,te,me,re,ce,be){super(q,ge,void 0,ce,be,ue),this.command={},this._source=ue,this.hasDefinedMatchers=re,me&&(this.command=me)}clone(){return new m(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(q=!1){if(q&&this._source.customizes!==void 0)return this._source.customizes;{let ue;switch(this.command?this.command.runtime:void 0){case n.Shell:ue="shell";break;case n.Process:ue="process";break;case n.CustomExecution:ue="customExecution";break;case void 0:ue="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:ue,_key:this._id,id:this._id}}}static is(q){return q instanceof m}getMapKey(){const q=this._source.config.workspaceFolder;return q?`${q.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===i.User?e.$FI:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getKey()??super.getCommonTaskId()}getKey(){const q=this.d();if(!q)return;let ue=this.configurationProperties.identifier;this._source.kind!==i.Workspace&&(ue+=this._source.kind);const ge={type:e.$II,folder:q,id:ue};return JSON.stringify(ge)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?k.$dh(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(q){return new m(q._id,q._source,q._label,q.type,q.command,q.hasDefinedMatchers,q.runOptions,q.configurationProperties)}}e.$KI=m;class f extends l{constructor(q,ue,ge,te,me,re,ce){super(q,ge,te,re,ce,ue),this._source=ue,this.configures=me}static is(q){return q instanceof f}f(q){return q}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?k.$dh(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===i.User?e.$FI:this._source.config.workspaceFolder?.uri.toString()}getKey(){const q=this.d();if(!q)return;let ue=this.configurationProperties.identifier;this._source.kind!==i.Workspace&&(ue+=this._source.kind);const ge={type:e.$II,folder:q,id:ue};return JSON.stringify(ge)}}e.$LI=f;class $ extends l{constructor(q,ue,ge,te,me,re,ce,be,se){super(q,ge,te,be,se,ue),this.defines=me,this.hasDefinedMatchers=ce,this.command=re,this.icon=se.icon,this.hide=se.hide}clone(){return new $(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(q){return q instanceof $}getMapKey(){const q=this._source.workspaceFolder;return q?`${this._source.scope.toString()}|${q.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===h.Folder&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getKey(){const q={type:"contributed",scope:this._source.scope,id:this._id};return q.folder=this.d(),JSON.stringify(q)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(q){return new $(q._id,q._source,q._label,q.type,q.defines,q.command,q.hasDefinedMatchers,q.runOptions,q.configurationProperties)}}e.$MI=$;class I extends l{constructor(q,ue,ge,te,me,re){super(q,ge,te,me,re,ue),this._source=ue}clone(){return new I(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(q){return q instanceof I}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(q){return new I(q._id,q._source,q._label,q.type,q.runOptions,q.configurationProperties)}}e.$NI=I;var D;(function(F){F[F.Process=1]="Process",F[F.Terminal=2]="Terminal"})(D||(e.ExecutionEngine=D={})),function(F){F._default=F.Terminal}(D||(e.ExecutionEngine=D={}));var v;(function(F){F[F.V0_1_0=1]="V0_1_0",F[F.V2_0_0=2]="V2_0_0"})(v||(e.JsonSchemaVersion=v={}));class C{constructor(q){this.c=new Map;for(let ue=0;ue<q.length;ue++)this.c.set(q[ue].uri.toString(),ue)}compare(q,ue){const ge=q.getWorkspaceFolder(),te=ue.getWorkspaceFolder();if(ge&&te){let me=this.c.get(ge.uri.toString());me=me===void 0?0:me+1;let re=this.c.get(te.uri.toString());return re=re===void 0?0:re+1,me===re?q._label.localeCompare(ue._label):me-re}else return!ge&&te?-1:ge&&!te?1:0}}e.$OI=C;var P;(function(F){F.DependsOnStarted="dependsOnStarted",F.AcquiredInput="acquiredInput",F.Start="start",F.ProcessStarted="processStarted",F.Active="active",F.Inactive="inactive",F.Changed="changed",F.Terminated="terminated",F.ProcessEnded="processEnded",F.End="end"})(P||(e.TaskEventKind=P={}));var g;(function(F){F.SingleRun="singleRun",F.Background="background"})(g||(e.TaskRunType=g={}));var b;(function(F){F[F.System=0]="System",F[F.User=1]="User",F[F.FolderOpen=2]="FolderOpen",F[F.ConfigurationChange=3]="ConfigurationChange",F[F.Reconnect=4]="Reconnect"})(b||(e.TaskRunSource=b={}));var L;(function(F){function q(be){return{taskId:be._id,taskName:be.configurationProperties.name,runType:be.configurationProperties.isBackground?g.Background:g.SingleRun,group:be.configurationProperties.group,__task:be}}function ue(be,se,Ie){return{...q(be),kind:P.Start,terminalId:se,resolvedVariables:Ie}}F.start=ue;function ge(be,se,Ie){return{...q(be),kind:P.ProcessStarted,terminalId:se,processId:Ie}}F.processStarted=ge;function te(be,se,Ie){return{...q(be),kind:P.ProcessEnded,terminalId:se,exitCode:Ie}}F.processEnded=te;function me(be,se,Ie){return{...q(be),kind:P.Terminated,exitReason:Ie,terminalId:se}}F.terminated=me;function re(be,se,Ie){return{...q(se),kind:be,terminalId:Ie}}F.general=re;function ce(){return{kind:P.Changed}}F.changed=ce})(L||(e.TaskEvent=L={}));var N;(function(F){function q(ge){const te=Object.keys(ge).sort();let me="";for(const re of te){let ce=ge[re];ce instanceof Object?ce=q(ce):typeof ce=="string"&&(ce=ce.replace(/,/g,",,")),me+=re+","+ce+","}return me}function ue(ge){const me={_key:q(ge),type:ge.taskType};return Object.assign(me,ge),me}F.create=ue})(N||(e.KeyedTaskIdentifier=N={}));var B;(function(F){F.AutoDetect="task.autoDetect",F.SaveBeforeRun="task.saveBeforeRun",F.ShowDecorations="task.showDecorations",F.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",F.SlowProviderWarning="task.slowProviderWarning",F.QuickOpenHistory="task.quickOpen.history",F.QuickOpenDetail="task.quickOpen.detail",F.QuickOpenSkip="task.quickOpen.skip",F.QuickOpenShowAll="task.quickOpen.showAll",F.AllowAutomaticTasks="task.allowAutomaticTasks",F.Reconnection="task.reconnection",F.VerboseLogging="task.verboseLogging"})(B||(e.TaskSettingId=B={}));var G;(function(F){F.Tasks="tasks",F.SuppressTaskName="tasks.suppressTaskName",F.Windows="tasks.windows",F.Osx="tasks.osx",F.Linux="tasks.linux",F.ShowOutput="tasks.showOutput",F.IsShellCommand="tasks.isShellCommand",F.ServiceTestSetting="tasks.service.testSetting"})(G||(e.TasksSchemaProperties=G={}));var W;(function(F){function q(ue,ge){const te=T.$EI.get(ue.type);if(te===void 0){const be=O.$bo(ue);return delete be._key,N.create(be)}const me=Object.create(null);me.type=te.taskType;const re=new Set;te.required.forEach(be=>re.add(be));const ce=te.properties;for(const be of Object.keys(ce)){const se=ue[be];if(se!=null)me[be]=se;else if(re.has(be)){const Ie=ce[be];if(Ie.default!==void 0)me[be]=O.$bo(Ie.default);else switch(Ie.type){case"boolean":me[be]=!1;break;case"number":case"integer":me[be]=0;break;case"string":me[be]="";break;default:ge.error(w.localize(1,null,JSON.stringify(ue,void 0,0),be));return}}}return N.create(me)}F.createTaskIdentifier=q})(W||(e.TaskDefinition=W={}))}),define(ke[252],Ce([1,0,14]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qcc=e.$pcc=void 0;class S{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((A,T)=>{this.b=A,this.d=T,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(A){this.f||this.h||(this.f=!0,this.g=A,this.a&&this.b(A))}resolveErr(A){this.f||this.h||(this.h=!0,this.i=A,this.a?this.d(A):(0,w.$3)(A))}then(A,T){return this.j().then(A,T)}catch(A){return this.j().then(void 0,A)}finally(A){return this.j().finally(A)}}e.$pcc=S;class k extends S{constructor(){super(),this.h=!0,this.i=new w.$7}}e.$qcc=k}),define(ke[39],Ce([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pw=e.$Mw=void 0,e.$Nw=k,e.$Ow=O;class w{static{this.count=0}constructor(p){this._proxyIdentifierBrand=void 0,this.sid=p,this.nid=++w.count}}e.$Mw=w;const S=[];function k(T){const p=new w(T);return S[p.nid]=p,p}function O(T){return S[T].sid}class A{constructor(p){this.value=p}}e.$Pw=A}),define(ke[5],Ce([1,0,39]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sN=e.$rN=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.$qN=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var S;(function(n){n[n.Default=0]="Default",n[n.InCenter=1]="InCenter",n[n.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",n[n.AtTop=3]="AtTop"})(S||(e.TextEditorRevealType=S={}));var k;(function(n){n[n.UnknownInput=0]="UnknownInput",n[n.TextInput=1]="TextInput",n[n.TextDiffInput=2]="TextDiffInput",n[n.TextMergeInput=3]="TextMergeInput",n[n.NotebookInput=4]="NotebookInput",n[n.NotebookDiffInput=5]="NotebookDiffInput",n[n.CustomEditorInput=6]="CustomEditorInput",n[n.WebviewEditorInput=7]="WebviewEditorInput",n[n.TerminalEditorInput=8]="TerminalEditorInput",n[n.InteractiveEditorInput=9]="InteractiveEditorInput",n[n.ChatEditorInput=10]="ChatEditorInput",n[n.MultiDiffEditorInput=11]="MultiDiffEditorInput"})(k||(e.TabInputKind=k={}));var O;(function(n){n[n.TAB_OPEN=0]="TAB_OPEN",n[n.TAB_CLOSE=1]="TAB_CLOSE",n[n.TAB_UPDATE=2]="TAB_UPDATE",n[n.TAB_MOVE=3]="TAB_MOVE"})(O||(e.TabModelOperationKind=O={}));var A;(function(n){n[n.Editable=0]="Editable",n[n.SupportsHotExit=1]="SupportsHotExit"})(A||(e.WebviewEditorCapabilities=A={}));var T;(function(n){n[n.Int8Array=1]="Int8Array",n[n.Uint8Array=2]="Uint8Array",n[n.Uint8ClampedArray=3]="Uint8ClampedArray",n[n.Int16Array=4]="Int16Array",n[n.Uint16Array=5]="Uint16Array",n[n.Int32Array=6]="Int32Array",n[n.Uint32Array=7]="Uint32Array",n[n.Float32Array=8]="Float32Array",n[n.Float64Array=9]="Float64Array",n[n.BigInt64Array=10]="BigInt64Array",n[n.BigUint64Array=11]="BigUint64Array"})(T||(e.WebviewMessageArrayBufferViewType=T={}));var p;(function(n){n[n.Text=1]="Text",n[n.Error=2]="Error",n[n.Rich=3]="Rich"})(p||(e.CellOutputKind=p={}));var a;(function(n){n[n.Default=0]="Default",n[n.InCenter=1]="InCenter",n[n.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",n[n.AtTop=3]="AtTop"})(a||(e.NotebookEditorRevealType=a={}));var R;(function(n){n[n.None=0]="None",n[n.Process=1]="Process",n[n.Output=2]="Output",n[n.Hybrid=3]="Hybrid"})(R||(e.CandidatePortSource=R={}));class y{static{this.a=0}static mixin(s){return s._id=y.a++,s}}e.$qN=y;var u;(function(n){n.label="a",n.kind="b",n.detail="c",n.documentation="d",n.sortText="e",n.filterText="f",n.preselect="g",n.insertText="h",n.insertTextRules="i",n.range="j",n.commitCharacters="k",n.additionalTextEdits="l",n.kindModifier="m",n.commandIdent="n",n.commandId="o",n.commandArguments="p"})(u||(e.ISuggestDataDtoField=u={}));var E;(function(n){n.defaultRanges="a",n.completions="b",n.isIncomplete="c",n.duration="d"})(E||(e.ISuggestResultDtoField=E={}));var d;(function(n){n[n.Workspace=0]="Workspace",n[n.TextDocument=1]="TextDocument"})(d||(e.ExtHostTestingResource=d={})),e.$rN={MainThreadAuthentication:(0,w.$Nw)("MainThreadAuthentication"),MainThreadBulkEdits:(0,w.$Nw)("MainThreadBulkEdits"),MainThreadLanguageModels:(0,w.$Nw)("MainThreadLanguageModels"),MainThreadEmbeddings:(0,w.$Nw)("MainThreadEmbeddings"),MainThreadChatAgents2:(0,w.$Nw)("MainThreadChatAgents2"),MainThreadChatVariables:(0,w.$Nw)("MainThreadChatVariables"),MainThreadLanguageModelTools:(0,w.$Nw)("MainThreadChatSkills"),MainThreadClipboard:(0,w.$Nw)("MainThreadClipboard"),MainThreadCommands:(0,w.$Nw)("MainThreadCommands"),MainThreadComments:(0,w.$Nw)("MainThreadComments"),MainThreadConfiguration:(0,w.$Nw)("MainThreadConfiguration"),MainThreadConsole:(0,w.$Nw)("MainThreadConsole"),MainThreadDebugService:(0,w.$Nw)("MainThreadDebugService"),MainThreadDecorations:(0,w.$Nw)("MainThreadDecorations"),MainThreadDiagnostics:(0,w.$Nw)("MainThreadDiagnostics"),MainThreadDialogs:(0,w.$Nw)("MainThreadDiaglogs"),MainThreadDocuments:(0,w.$Nw)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,w.$Nw)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,w.$Nw)("MainThreadTextEditors"),MainThreadEditorInsets:(0,w.$Nw)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,w.$Nw)("MainThreadEditorTabs"),MainThreadErrors:(0,w.$Nw)("MainThreadErrors"),MainThreadTreeViews:(0,w.$Nw)("MainThreadTreeViews"),MainThreadDownloadService:(0,w.$Nw)("MainThreadDownloadService"),MainThreadLanguageFeatures:(0,w.$Nw)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,w.$Nw)("MainThreadLanguages"),MainThreadLogger:(0,w.$Nw)("MainThreadLogger"),MainThreadMessageService:(0,w.$Nw)("MainThreadMessageService"),MainThreadOutputService:(0,w.$Nw)("MainThreadOutputService"),MainThreadProgress:(0,w.$Nw)("MainThreadProgress"),MainThreadQuickDiff:(0,w.$Nw)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,w.$Nw)("MainThreadQuickOpen"),MainThreadStatusBar:(0,w.$Nw)("MainThreadStatusBar"),MainThreadSecretState:(0,w.$Nw)("MainThreadSecretState"),MainThreadStorage:(0,w.$Nw)("MainThreadStorage"),MainThreadSpeech:(0,w.$Nw)("MainThreadSpeechProvider"),MainThreadTelemetry:(0,w.$Nw)("MainThreadTelemetry"),MainThreadTerminalService:(0,w.$Nw)("MainThreadTerminalService"),MainThreadTerminalShellIntegration:(0,w.$Nw)("MainThreadTerminalShellIntegration"),MainThreadWebviews:(0,w.$Nw)("MainThreadWebviews"),MainThreadWebviewPanels:(0,w.$Nw)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,w.$Nw)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,w.$Nw)("MainThreadCustomEditors"),MainThreadUrls:(0,w.$Nw)("MainThreadUrls"),MainThreadUriOpeners:(0,w.$Nw)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,w.$Nw)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,w.$Nw)("MainThreadWorkspace"),MainThreadFileSystem:(0,w.$Nw)("MainThreadFileSystem"),MainThreadFileSystemEventService:(0,w.$Nw)("MainThreadFileSystemEventService"),MainThreadExtensionService:(0,w.$Nw)("MainThreadExtensionService"),MainThreadSCM:(0,w.$Nw)("MainThreadSCM"),MainThreadSearch:(0,w.$Nw)("MainThreadSearch"),MainThreadShare:(0,w.$Nw)("MainThreadShare"),MainThreadTask:(0,w.$Nw)("MainThreadTask"),MainThreadWindow:(0,w.$Nw)("MainThreadWindow"),MainThreadLabelService:(0,w.$Nw)("MainThreadLabelService"),MainThreadNotebook:(0,w.$Nw)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,w.$Nw)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,w.$Nw)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,w.$Nw)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,w.$Nw)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,w.$Nw)("MainThreadInteractive"),MainThreadTheming:(0,w.$Nw)("MainThreadTheming"),MainThreadTunnelService:(0,w.$Nw)("MainThreadTunnelService"),MainThreadManagedSockets:(0,w.$Nw)("MainThreadManagedSockets"),MainThreadTimeline:(0,w.$Nw)("MainThreadTimeline"),MainThreadTesting:(0,w.$Nw)("MainThreadTesting"),MainThreadLocalization:(0,w.$Nw)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,w.$Nw)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,w.$Nw)("MainThreadAiEmbeddingVector")},e.$sN={ExtHostCommands:(0,w.$Nw)("ExtHostCommands"),ExtHostConfiguration:(0,w.$Nw)("ExtHostConfiguration"),ExtHostDiagnostics:(0,w.$Nw)("ExtHostDiagnostics"),ExtHostDebugService:(0,w.$Nw)("ExtHostDebugService"),ExtHostDecorations:(0,w.$Nw)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,w.$Nw)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,w.$Nw)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,w.$Nw)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,w.$Nw)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,w.$Nw)("ExtHostEditors"),ExtHostTreeViews:(0,w.$Nw)("ExtHostTreeViews"),ExtHostFileSystem:(0,w.$Nw)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,w.$Nw)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,w.$Nw)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,w.$Nw)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,w.$Nw)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,w.$Nw)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,w.$Nw)("ExtHostQuickDiff"),ExtHostStatusBar:(0,w.$Nw)("ExtHostStatusBar"),ExtHostShare:(0,w.$Nw)("ExtHostShare"),ExtHostExtensionService:(0,w.$Nw)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,w.$Nw)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,w.$Nw)("ExtHostTerminalService"),ExtHostTerminalShellIntegration:(0,w.$Nw)("ExtHostTerminalShellIntegration"),ExtHostSCM:(0,w.$Nw)("ExtHostSCM"),ExtHostSearch:(0,w.$Nw)("ExtHostSearch"),ExtHostTask:(0,w.$Nw)("ExtHostTask"),ExtHostWorkspace:(0,w.$Nw)("ExtHostWorkspace"),ExtHostWindow:(0,w.$Nw)("ExtHostWindow"),ExtHostWebviews:(0,w.$Nw)("ExtHostWebviews"),ExtHostWebviewPanels:(0,w.$Nw)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,w.$Nw)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,w.$Nw)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,w.$Nw)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,w.$Nw)("ExtHostEditorTabs"),ExtHostProgress:(0,w.$Nw)("ExtHostProgress"),ExtHostComments:(0,w.$Nw)("ExtHostComments"),ExtHostSecretState:(0,w.$Nw)("ExtHostSecretState"),ExtHostStorage:(0,w.$Nw)("ExtHostStorage"),ExtHostUrls:(0,w.$Nw)("ExtHostUrls"),ExtHostUriOpeners:(0,w.$Nw)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,w.$Nw)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,w.$Nw)("ExtHostOutputService"),ExtHostLabelService:(0,w.$Nw)("ExtHostLabelService"),ExtHostNotebook:(0,w.$Nw)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,w.$Nw)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,w.$Nw)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,w.$Nw)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,w.$Nw)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,w.$Nw)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,w.$Nw)("ExtHostInteractive"),ExtHostChatAgents2:(0,w.$Nw)("ExtHostChatAgents"),ExtHostChatVariables:(0,w.$Nw)("ExtHostChatVariables"),ExtHostLanguageModelTools:(0,w.$Nw)("ExtHostChatSkills"),ExtHostChatProvider:(0,w.$Nw)("ExtHostChatProvider"),ExtHostSpeech:(0,w.$Nw)("ExtHostSpeech"),ExtHostEmbeddings:(0,w.$Nw)("ExtHostEmbeddings"),ExtHostAiRelatedInformation:(0,w.$Nw)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,w.$Nw)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,w.$Nw)("ExtHostTheming"),ExtHostTunnelService:(0,w.$Nw)("ExtHostTunnelService"),ExtHostManagedSockets:(0,w.$Nw)("ExtHostManagedSockets"),ExtHostAuthentication:(0,w.$Nw)("ExtHostAuthentication"),ExtHostTimeline:(0,w.$Nw)("ExtHostTimeline"),ExtHostTesting:(0,w.$Nw)("ExtHostTesting"),ExtHostTelemetry:(0,w.$Nw)("ExtHostTelemetry"),ExtHostLocalization:(0,w.$Nw)("ExtHostLocalization")}}),define(ke[85],Ce([1,0,3,12,5,17]),function(oe,e,w,S,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vnc=e.$Unc=e.$Tnc=void 0,k=qe(k),e.$Tnc=(0,w.$Fi)("IExtHostApiDeprecationService");let A=class{constructor(p,a){this.c=a,this.a=new Set,this.b=p.getProxy(k.$rN.MainThreadTelemetry)}report(p,a,R){const y=this.d(p,a);this.a.has(y)||(this.a.add(y),a.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${p}' is deprecated. ${R}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:a.identifier.value,apiId:p}))}d(p,a){return`${p}-${a.identifier.value}`}};e.$Unc=A,e.$Unc=A=He([Ve(0,O.$XP),Ve(1,S.$_j)],A),e.$Vnc=Object.freeze(new class{report(T,p,a){}})}),define(ke[253],Ce([1,0,5]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9nc=void 0;class S{constructor(O){const A=O.getProxy(w.$rN.MainThreadClipboard);this.value=Object.freeze({readText(){return A.$readText()},writeText(T){return A.$writeText(T)}})}}e.$9nc=S}),define(ke[254],Ce([1,0,26,5,27,17]),function(oe,e,w,S,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5pc=void 0;let A=class{constructor(R,y){this.a=R.getProxy(S.$rN.MainThreadConsole),this.b=y.consoleForward.includeStack,this.c=y.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("debug","debug"),this.d("error","error")}d(R,y){const u=this,E=console[R];Object.defineProperty(console,R,{set:()=>{},get:()=>function(){u.e(R,y,E,arguments)}})}e(R,y,u,E){this.a.$logExtensionHostMessage({type:"__$console",severity:y,arguments:p(E,this.b)}),this.c&&this.f(R,u,E)}};e.$5pc=A,e.$5pc=A=He([Ve(0,O.$XP),Ve(1,k.$bQ)],A);const T=1e5;function p(a,R){const y=[];if(a.length)for(let u=0;u<a.length;u++){let E=a[u];if(typeof E>"u")E="undefined";else if(E instanceof Error){const d=E;d.stack?E=d.stack:E=d.toString()}y.push(E)}if(R){const u=new Error().stack;u&&y.push({__$stack:u.split(`
`).slice(3).join(`
`)})}try{const u=(0,w.$go)(y);return u.length>T?"Output omitted for a large object that exceeds the limits":u}catch(u){return`Output omitted for an object that cannot be inspected ('${u.toString()}')`}}}),define(ke[255],Ce([1,0,2,5,25]),function(oe,e,w,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$oc=void 0;class O{constructor(T){this.a=T.getProxy(S.$rN.MainThreadDialogs)}showOpenDialog(T,p){return p?.allowUIResources&&(0,k.$4G)(T,"showLocal"),this.a.$showOpenDialog(p).then(a=>a?a.map(R=>w.URI.revive(R)):void 0)}showSaveDialog(T){return this.a.$showSaveDialog(T).then(p=>p?w.URI.revive(p):void 0)}}e.$$oc=O}),define(ke[256],Ce([1,0,22,6,4,5]),function(oe,e,w,S,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bpc=void 0;class A{constructor(p){this.b=new Map,this.c=new S.$me,this.onDidChange=this.c.event,this.d=new Set,this.e=0,this.a=p.getProxy(O.$rN.MainThreadEmbeddings)}registerEmbeddingsProvider(p,a,R){if(this.d.has(a))throw new Error("An embeddings provider for this model is already registered");const y=this.e++;return this.a.$registerEmbeddingProvider(y,a),this.b.set(y,{id:a,provider:R}),(0,k.$Uc)(()=>{this.a.$unregisterEmbeddingProvider(y),this.b.delete(y)})}async computeEmbeddings(p,a,R){R??=w.CancellationToken.None;let y=!1;typeof a=="string"&&(a=[a],y=!0);const u=await this.a.$computeEmbeddings(p,a,R);if(u.length!==a.length)throw new Error;if(y){if(u.length!==1)throw new Error;return u[0]}return u}async $provideEmbeddings(p,a,R){const y=this.b.get(p);if(!y)return[];const u=await y.provider.provideEmbeddings(a,R);return u||[]}get embeddingsModels(){return Array.from(this.d)}$acceptEmbeddingModels(p){this.d=new Set(p),this.c.fire()}}e.$bpc=A}),define(ke[257],Ce([1,0,4,5]),function(oe,e,w,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$spc=void 0;class k{constructor(A){this.b=0,this.a=A.getProxy(S.$rN.MainThreadLabelService)}$registerResourceLabelFormatter(A){const T=this.b++;return this.a.$registerResourceLabelFormatter(T,A),(0,w.$Uc)(()=>{this.a.$unregisterResourceLabelFormatter(T)})}}e.$spc=k}),define(ke[258],Ce([1,0,4,5]),function(oe,e,w,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2pc=void 0;class k{constructor(A){this.a=new Map,this.c=new Map,this.b=A.getProxy(S.$rN.MainThreadLanguageModelTools),this.b.$getTools().then(T=>{for(const p of T)this.c.set(p.id,p)})}async invokeTool(A,T,p){return await this.b.$invokeTool(A,T,p)}async $acceptToolDelta(A){A.added&&this.c.set(A.added.id,A.added),A.removed&&this.c.delete(A.removed)}get tools(){return Array.from(this.c.values())}async $invokeTool(A,T,p){const a=this.a.get(A);if(!a)throw new Error(`Unknown tool ${A}`);return await a.tool.invoke(T,p)}registerTool(A,T,p){return this.a.set(T,{extension:A,tool:p}),this.b.$registerTool(T),(0,w.$Uc)(()=>{this.a.delete(T),this.b.$unregisterTool(T)})}}e.$2pc=k}),define(ke[86],Ce([1,0,21,13,2,3,12,5,27,17]),function(oe,e,w,S,k,O,A,T,p,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ooc=e.$Noc=void 0;let R=class{constructor(u,E,d){this.f=d,this.d=new Map,this.a=E.getProxy(T.$rN.MainThreadLocalization),this.b=u.environment.appLanguage,this.c=this.b===w.$g}getMessage(u,E){const{message:d,args:n,comment:s}=E;if(this.c)return(0,S.$ff)(d,n??{});let o=d;s&&s.length>0&&(o+=`/${Array.isArray(s)?s.join(""):s}`);const h=this.d.get(u)?.contents[o];return h||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${o}`),(0,S.$ff)(h??d,n??{})}getBundle(u){return this.d.get(u)?.contents}getBundleUri(u){return this.d.get(u)?.uri}async initializeLocalizedMessages(u){if(this.c||!u.l10n&&!u.isBuiltin||this.d.has(u.identifier.value))return;let E;const d=await this.g(u);if(!d){this.f.error(`No bundle location found for extension ${u.identifier.value}`);return}try{const n=await this.a.$fetchBundleContents(d),s=JSON.parse(n);E=u.isBuiltin?s.contents?.bundle:s}catch(n){this.f.error(`Failed to load translations for ${u.identifier.value} from ${d}: ${n.message}`);return}E&&this.d.set(u.identifier.value,{contents:E,uri:d})}async g(u){if(u.isBuiltin){const E=await this.a.$fetchBuiltInBundleUri(u.identifier.value,this.b);return k.URI.revive(E)}return u.l10n?k.URI.joinPath(u.extensionLocation,u.l10n,`bundle.l10n.${this.b}.json`):void 0}};e.$Noc=R,e.$Noc=R=He([Ve(0,p.$bQ),Ve(1,a.$XP),Ve(2,A.$_j)],R),e.$Ooc=(0,O.$Fi)("IExtHostLocalizationService")}),define(ke[259],Ce([1,0,12,5,27,17,2,49]),function(oe,e,w,S,k,O,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4pc=void 0;let p=class extends w.$kk{constructor(y,u){super(u.logLevel,u.logsLocation,u.loggers.map(E=>(0,T.$ci)(E))),this.r=y.getProxy(S.$rN.MainThreadLogger)}$setLogLevel(y,u){u?this.setLogLevel(A.URI.revive(u),y):this.setLogLevel(y)}setVisibility(y,u){super.setVisibility(y,u),this.r.$setVisibility(y,u)}s(y,u,E){return new a(this.r,y,u,E)}};e.$4pc=p,e.$4pc=p=He([Ve(0,O.$XP),Ve(1,k.$bQ)],p);class a extends w.$fk{constructor(y,u,E,d){super(d?.logLevel==="always"),this.r=y,this.s=u,this.m=!1,this.n=[],this.setLevel(E),this.r.$createLogger(u,d).then(()=>{this.u(this.n),this.m=!0})}g(y,u){const E=[[y,u]];this.m?this.u(E):this.n.push(...E)}u(y){this.r.$log(this.s,y)}flush(){this.r.$flush(this.s)}}}),define(ke[87],Ce([1,0,5,3,4,17,23]),function(oe,e,w,S,k,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qoc=e.$Poc=void 0,e.$Poc=(0,S.$Fi)("IExtHostManagedSockets");let T=class{constructor(y){this.b=0,this.c=null,this.d=new Map,this.a=y.getProxy(w.$rN.MainThreadManagedSockets)}setFactory(y,u){for(const E of this.d.values())E.dispose();this.c&&this.a.$unregisterSocketFactory(this.c.socketFactoryId),this.c=new p(y,u),this.a.$registerSocketFactory(this.c.socketFactoryId)}async $openRemoteSocket(y){if(!this.c||this.c.socketFactoryId!==y)throw new Error(`No socket factory with id ${y}`);const u=++this.b,E=await this.c.makeConnection(),d=new k.$Vc;return this.d.set(u,new a(u,E,d)),d.add((0,k.$Uc)(()=>this.d.delete(u))),d.add(E.onDidEnd(()=>{this.a.$onDidManagedSocketEnd(u),d.dispose()})),d.add(E.onDidClose(n=>{this.a.$onDidManagedSocketClose(u,n?.stack??n?.message),d.dispose()})),d.add(E.onDidReceiveMessage(n=>this.a.$onDidManagedSocketHaveData(u,A.$Oe.wrap(n)))),u}$remoteSocketWrite(y,u){this.d.get(y)?.actual.send(u.buffer)}$remoteSocketEnd(y){const u=this.d.get(y);u&&(u.actual.end(),u.dispose())}async $remoteSocketDrain(y){await this.d.get(y)?.actual.drain?.()}};e.$Qoc=T,e.$Qoc=T=He([Ve(0,O.$XP)],T);class p{constructor(y,u){this.socketFactoryId=y,this.makeConnection=u}}class a extends k.$Wc{constructor(y,u,E){super(),this.socketId=y,this.actual=u,this.B(E)}}}),define(ke[260],Ce([1,0,5,12,25]),function(oe,e,w,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$upc=void 0;function O(T){return T&&T.title}let A=class{constructor(p,a){this.b=a,this.a=p.getProxy(w.$rN.MainThreadMessageService)}showMessage(p,a,R,y,u){const E={source:{identifier:p.identifier,label:p.displayName||p.name}};let d;typeof y=="string"||O(y)?d=[y,...u]:(E.modal=y?.modal,E.useCustom=y?.useCustom,E.detail=y?.detail,d=u),E.useCustom&&(0,k.$4G)(p,"resolvers");const n=[];let s=!1;for(let o=0;o<d.length;o++){const h=d[o];if(typeof h=="string")n.push({title:h,handle:o,isCloseAffordance:!1});else if(typeof h=="object"){const{title:i,isCloseAffordance:r}=h;n.push({title:i,isCloseAffordance:!!r,handle:o}),r&&(s?this.b.warn(`[${p.identifier}] Only one message item can have 'isCloseAffordance':`,h):s=!0)}else this.b.warn(`[${p.identifier}] Invalid message item:`,h)}return this.a.$showMessage(a,R,E,n).then(o=>{if(typeof o=="number")return d[o]})}};e.$upc=A,e.$upc=A=He([Ve(1,S.$_j)],A)}),define(ke[261],Ce([1,0,4,15,2,25,5]),function(oe,e,w,S,k,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dpc=void 0;class T{constructor(a){this.b=new Map,this.a=a.getProxy(A.$rN.MainThreadProfileContentHandlers)}registerProfileContentHandler(a,R,y){if((0,O.$4G)(a,"profileContentHandlers"),this.b.has(R))throw new Error(`Handler with id '${R}' already registered`);return this.b.set(R,y),this.a.$registerProfileContentHandler(R,y.name,y.description,a.identifier.value),(0,w.$Uc)(()=>{this.b.delete(R),this.a.$unregisterProfileContentHandler(R)})}async $saveProfile(a,R,y,u){const E=this.b.get(a);if(!E)throw new Error(`Unknown handler with id: ${a}`);return E.saveProfile(R,y,u)}async $readProfile(a,R,y){const u=this.b.get(a);if(!u)throw new Error(`Unknown handler with id: ${a}`);return u.readProfile((0,S.$fg)(R)?R:k.URI.revive(R),y)}}e.$Dpc=T}),define(ke[88],Ce([1,0,5,6,3]),function(oe,e,w,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Loc=e.$Koc=void 0;class O{constructor(T){this.b=new S.$me,this.onDidChangePassword=this.b.event,this.a=T.getProxy(w.$rN.MainThreadSecretState)}async $onDidChangePassword(T){this.b.fire(T)}get(T,p){return this.a.$getPassword(T,p)}store(T,p,a){return this.a.$setPassword(T,p,a)}delete(T,p){return this.a.$deletePassword(T,p)}}e.$Koc=O,e.$Loc=(0,k.$Fi)("IExtHostSecretState")}),define(ke[262],Ce([1,0,22,4,5]),function(oe,e,w,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kpc=void 0;class O{static{this.a=1}constructor(T){this.c=new Map,this.d=new Map,this.f=new Map,this.b=T.getProxy(k.$rN.MainThreadSpeech)}async $createSpeechToTextSession(T,p,a){const R=this.c.get(T);if(!R)return;const y=new S.$Vc,u=new w.$xe;this.d.set(p,u);const E=await R.provideSpeechToTextSession(u.token,a?{language:a}:void 0);E&&(y.add(E.onDidChange(d=>{u.token.isCancellationRequested||this.b.$emitSpeechToTextEvent(p,d)})),y.add(u.token.onCancellationRequested(()=>y.dispose())))}async $cancelSpeechToTextSession(T){this.d.get(T)?.dispose(!0),this.d.delete(T)}async $createTextToSpeechSession(T,p,a){const R=this.c.get(T);if(!R)return;const y=new S.$Vc,u=new w.$xe;this.d.set(p,u);const E=await R.provideTextToSpeechSession(u.token,a?{language:a}:void 0);E&&(this.f.set(p,E),y.add(E.onDidChange(d=>{u.token.isCancellationRequested||this.b.$emitTextToSpeechEvent(p,d)})),y.add(u.token.onCancellationRequested(()=>y.dispose())))}async $synthesizeSpeech(T,p){this.f.get(T)?.synthesize(p)}async $cancelTextToSpeechSession(T){this.d.get(T)?.dispose(!0),this.d.delete(T),this.f.delete(T)}async $createKeywordRecognitionSession(T,p){const a=this.c.get(T);if(!a)return;const R=new S.$Vc,y=new w.$xe;this.d.set(p,y);const u=await a.provideKeywordRecognitionSession(y.token);u&&(R.add(u.onDidChange(E=>{y.token.isCancellationRequested||this.b.$emitKeywordRecognitionEvent(p,E)})),R.add(y.token.onCancellationRequested(()=>R.dispose())))}async $cancelKeywordRecognitionSession(T){this.d.get(T)?.dispose(!0),this.d.delete(T)}registerProvider(T,p,a){const R=O.a++;return this.c.set(R,a),this.b.$registerProvider(R,p,{extension:T,displayName:T.value}),(0,S.$Uc)(()=>{this.b.$unregisterProvider(R),this.c.delete(R)})}}e.$Kpc=O}),define(ke[89],Ce([1,0,5,6,3]),function(oe,e,w,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Boc=e.$Aoc=void 0;class O{constructor(T,p){this.c=p,this.b=new S.$me,this.onDidChangeStorage=this.b.event,this.a=T.getProxy(w.$rN.MainThreadStorage)}registerExtensionStorageKeysToSync(T,p){this.a.$registerExtensionStorageKeysToSync(T,p)}async initializeExtensionStorage(T,p,a){const R=await this.a.$initializeExtensionStorage(T,p);let y;return R&&(y=this.d(T,p,R)),y||a}setValue(T,p,a){return this.a.$setValue(T,p,a)}$acceptValue(T,p,a){const R=this.d(T,p,a);R&&this.b.fire({shared:T,key:p,value:R})}d(T,p,a){try{return JSON.parse(a)}catch(R){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${p}, global: ${T}): ${R}`)}}}e.$Aoc=O,e.$Boc=(0,k.$Fi)("IExtHostStorage")}),define(ke[263],Ce([1,0,4,16,2,5]),function(oe,e,w,S,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wpc=void 0;class A{static{this.a=new Set([S.Schemas.http,S.Schemas.https])}constructor(p){this.c=new Map,this.b=p.getProxy(O.$rN.MainThreadUriOpeners)}registerExternalUriOpener(p,a,R,y){if(this.c.has(a))throw new Error(`Opener with id '${a}' already registered`);const u=y.schemes.find(E=>!A.a.has(E));if(u)throw new Error(`Scheme '${u}' is not supported. Only http and https are currently supported.`);return this.c.set(a,R),this.b.$registerUriOpener(a,y.schemes,p,y.label),(0,w.$Uc)(()=>{this.c.delete(a),this.b.$unregisterUriOpener(a)})}async $canOpenUri(p,a,R){const y=this.c.get(p);if(!y)throw new Error(`Unknown opener with id: ${p}`);const u=k.URI.revive(a);return y.canOpenExternalUri(u,R)}async $openUri(p,a,R){const y=this.c.get(p);if(!y)throw new Error(`Unknown opener id: '${p}'`);return y.openExternalUri(k.URI.revive(a.resolvedUri),{sourceUri:k.URI.revive(a.sourceUri)},R)}}e.$Wpc=A}),define(ke[264],Ce([1,0,5,2,4,14,19]),function(oe,e,w,S,k,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xpc=void 0;class T{static{this.a=0}constructor(a){this.c=new A.$rn,this.d=new Map,this.b=a.getProxy(w.$rN.MainThreadUrls)}registerUriHandler(a,R){const y=a.identifier;if(this.c.has(y))throw new Error(`Protocol handler already registered for extension ${y}`);const u=T.a++;return this.c.add(y),this.d.set(u,R),this.b.$registerUriHandler(u,y,a.displayName||a.name),(0,k.$Uc)(()=>{this.c.delete(y),this.d.delete(u),this.b.$unregisterUriHandler(u)})}$handleExternalUri(a,R){const y=this.d.get(a);if(!y)return Promise.resolve(void 0);try{y.handleUri(S.URI.revive(R))}catch(u){(0,O.$3)(u)}return Promise.resolve(void 0)}async createAppUri(a){return S.URI.revive(await this.b.$createAppUri(a))}}e.$Xpc=T}),define(ke[265],Ce([1,0,23,5]),function(oe,e,w,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dtb=O,e.$etb=T,S=qe(S);class k{constructor(){this.buffers=[]}add(a){let R=this.buffers.indexOf(a);return R<0&&(R=this.buffers.length,this.buffers.push(a)),R}}function O(p,a){if(a.serializeBuffersForPostMessage){const R=new k,u=JSON.stringify(p,(d,n)=>{if(n instanceof ArrayBuffer)return{$$vscode_array_buffer_reference$$:!0,index:R.add(n)};if(ArrayBuffer.isView(n)){const s=A(n);if(s)return{$$vscode_array_buffer_reference$$:!0,index:R.add(n.buffer),view:{type:s,byteLength:n.byteLength,byteOffset:n.byteOffset}}}return n}),E=R.buffers.map(d=>{const n=new Uint8Array(d);return w.$Oe.wrap(n)});return{message:u,buffers:E}}else return{message:JSON.stringify(p),buffers:[]}}function A(p){switch(p.constructor.name){case"Int8Array":return S.WebviewMessageArrayBufferViewType.Int8Array;case"Uint8Array":return S.WebviewMessageArrayBufferViewType.Uint8Array;case"Uint8ClampedArray":return S.WebviewMessageArrayBufferViewType.Uint8ClampedArray;case"Int16Array":return S.WebviewMessageArrayBufferViewType.Int16Array;case"Uint16Array":return S.WebviewMessageArrayBufferViewType.Uint16Array;case"Int32Array":return S.WebviewMessageArrayBufferViewType.Int32Array;case"Uint32Array":return S.WebviewMessageArrayBufferViewType.Uint32Array;case"Float32Array":return S.WebviewMessageArrayBufferViewType.Float32Array;case"Float64Array":return S.WebviewMessageArrayBufferViewType.Float64Array;case"BigInt64Array":return S.WebviewMessageArrayBufferViewType.BigInt64Array;case"BigUint64Array":return S.WebviewMessageArrayBufferViewType.BigUint64Array}}function T(p,a){const R=a.map(E=>{const d=new ArrayBuffer(E.byteLength);return new Uint8Array(d).set(E.buffer),d}),y=a.length?(E,d)=>{if(d&&typeof d=="object"&&d.$$vscode_array_buffer_reference$$){const n=d,{index:s}=n,o=R[s];if(n.view)switch(n.view.type){case S.WebviewMessageArrayBufferViewType.Int8Array:return new Int8Array(o,n.view.byteOffset,n.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case S.WebviewMessageArrayBufferViewType.Uint8Array:return new Uint8Array(o,n.view.byteOffset,n.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case S.WebviewMessageArrayBufferViewType.Uint8ClampedArray:return new Uint8ClampedArray(o,n.view.byteOffset,n.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case S.WebviewMessageArrayBufferViewType.Int16Array:return new Int16Array(o,n.view.byteOffset,n.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case S.WebviewMessageArrayBufferViewType.Uint16Array:return new Uint16Array(o,n.view.byteOffset,n.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case S.WebviewMessageArrayBufferViewType.Int32Array:return new Int32Array(o,n.view.byteOffset,n.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case S.WebviewMessageArrayBufferViewType.Uint32Array:return new Uint32Array(o,n.view.byteOffset,n.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case S.WebviewMessageArrayBufferViewType.Float32Array:return new Float32Array(o,n.view.byteOffset,n.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case S.WebviewMessageArrayBufferViewType.Float64Array:return new Float64Array(o,n.view.byteOffset,n.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case S.WebviewMessageArrayBufferViewType.BigInt64Array:return new BigInt64Array(o,n.view.byteOffset,n.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case S.WebviewMessageArrayBufferViewType.BigUint64Array:return new BigUint64Array(o,n.view.byteOffset,n.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return o}return d}:void 0;return{message:JSON.parse(p,y),arrayBuffers:R}}}),define(ke[68],Ce([1,0,6,4,16,26,2,207,265,83,5]),function(oe,e,w,S,k,O,A,T,p,a,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$noc=e.$loc=void 0,e.$moc=u,e.$ooc=n,e.$poc=s,O=qe(O),R=qe(R);class y{#e;#t;#i;#n;#s;#r;#a;#o;#c;#u;#l;#d;constructor(r,t,c,l,m,f,$){this.#a="",this.#c=!1,this.#u=!1,this._onMessageEmitter=new w.$me,this.onDidReceiveMessage=this._onMessageEmitter.event,this.#h=new w.$me,this._onDidDispose=this.#h.event,this.#e=r,this.#t=t,this.#o=c,this.#n=l,this.#s=m,this.#r=f,this.#l=u(f),this.#d=E(f),this.#i=$}#h;dispose(){this.#c=!0,this.#h.fire(),this.#h.dispose(),this._onMessageEmitter.dispose()}asWebviewUri(r){return this.#u=!0,(0,a.$XCb)(r,this.#n)}get cspSource(){const r=this.#r.extensionLocation;if(r.scheme===k.Schemas.https||r.scheme===k.Schemas.http){let t=r.toString();return t.endsWith("/")||(t+="/"),t+" "+a.$WCb}return a.$WCb}get html(){return this.a(),this.#a}set html(r){this.a(),this.#a!==r&&(this.#a=r,this.#d&&!this.#u&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(r)&&(this.#u=!0,this.#i.report("Webview vscode-resource: uris",this.#r,"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),this.#t.$setHtml(this.#e,this.b(r)))}get options(){return this.a(),this.#o}set options(r){this.a(),O.$fo(this.#o,r)||this.#t.$setOptions(this.#e,s(this.#r,this.#s,r)),this.#o=r}async postMessage(r){if(this.#c)return!1;const t=(0,p.$dtb)(r,{serializeBuffersForPostMessage:this.#l});return this.#t.$postMessage(this.#e,t.message,...t.buffers)}a(){if(this.#c)throw new Error("Webview is disposed")}b(r){if(!this.#d)return r;const t=this.#r.extensionLocation?.scheme===k.Schemas.vscodeRemote,c=this.#r.extensionLocation.scheme===k.Schemas.vscodeRemote?this.#r.extensionLocation.authority:void 0;return r.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(l,m,f,$,I,D)=>{const v=A.URI.from({scheme:$||"file",path:decodeURIComponent(I)}),C=(0,a.$XCb)(v,{isRemote:t,authority:c}).toString();return`${m}${C}${D}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(l,m,f,$,I,D)=>{const v=A.URI.from({scheme:$||"file",path:decodeURIComponent(I)}),C=(0,a.$XCb)(v,{isRemote:t,authority:c}).toString();return`${m}${C}${D}`})}}e.$loc=y;function u(i){try{const r=(0,T.$Vp)((0,T.$Up)(i.engines.vscode));return!!r&&r.majorBase>=1&&r.minorBase>=57}catch{return!1}}function E(i){try{const r=(0,T.$Vp)((0,T.$Up)(i.engines.vscode));return r?r.majorBase<1||r.majorBase===1&&r.minorBase<60:!1}catch{return!1}}class d extends S.$Wc{constructor(r,t,c,l,m){super(),this.c=t,this.f=c,this.g=l,this.h=m,this.b=new Map,this.a=r.getProxy(R.$rN.MainThreadWebviews)}dispose(){super.dispose();for(const r of this.b.values())r.dispose();this.b.clear()}$onMessage(r,t,c){const l=this.j(r);if(l){const{message:m}=(0,p.$etb)(t,c.value);l._onMessageEmitter.fire(m)}}$onMissingCsp(r,t){this.g.warn(`${t} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(r,t,c){const l=new y(r,this.a,o(t),this.c,this.f,c,this.h);this.b.set(r,l);const m=l._onDidDispose(()=>{m.dispose(),this.deleteWebview(r)});return l}deleteWebview(r){this.b.delete(r)}j(r){return this.b.get(r)}}e.$noc=d;function n(i){return{id:i.identifier,location:i.extensionLocation}}function s(i,r,t){return{enableCommandUris:t.enableCommandUris,enableScripts:t.enableScripts,enableForms:t.enableForms,portMapping:t.portMapping,localResourceRoots:t.localResourceRoots||h(i,r)}}function o(i){return{enableCommandUris:i.enableCommandUris,enableScripts:i.enableScripts,enableForms:i.enableForms,portMapping:i.portMapping,localResourceRoots:i.localResourceRoots?.map(r=>A.URI.from(r))}}function h(i,r){return[...(r?.getWorkspaceFolders()||[]).map(t=>t.uri),i.extensionLocation]}}),define(ke[120],Ce([1,0,6,16,13,2,3,17,5]),function(oe,e,w,S,k,O,A,T,p){"use strict";var a;Object.defineProperty(e,"__esModule",{value:!0}),e.$1pc=e.$Zpc=void 0;let R=class{static{a=this}static{this.a={focused:!0,active:!0}}getState(){const u=this.d;return{get focused(){return u.focused},get active(){return u.active}}}constructor(u){this.c=new w.$me,this.onDidChangeWindowState=this.c.event,this.d=a.a,this.b=u.getProxy(p.$rN.MainThreadWindow),this.b.$getInitialState().then(({isFocused:E,isActive:d})=>{this.onDidChangeWindowProperty("focused",E),this.onDidChangeWindowProperty("active",d)})}$onDidChangeWindowFocus(u){this.onDidChangeWindowProperty("focused",u)}$onDidChangeWindowActive(u){this.onDidChangeWindowProperty("active",u)}onDidChangeWindowProperty(u,E){E!==this.d[u]&&(this.d={...this.d,[u]:E},this.c.fire(this.d))}openUri(u,E){let d;if(typeof u=="string"){d=u;try{u=O.URI.parse(u)}catch{return Promise.reject(`Invalid uri - '${u}'`)}}return(0,k.$df)(u.scheme)?Promise.reject("Invalid scheme - cannot be empty"):u.scheme===S.Schemas.command?Promise.reject(`Invalid scheme '${u.scheme}'`):this.b.$openUri(u,d,E)}async asExternalUri(u,E){if((0,k.$df)(u.scheme))return Promise.reject("Invalid scheme - cannot be empty");const d=await this.b.$asExternalUri(u,E);return O.URI.from(d)}};e.$Zpc=R,e.$Zpc=R=a=He([Ve(0,T.$XP)],R),e.$1pc=(0,A.$Fi)("IExtHostWindow")}),define(ke[266],Ce([1,0,254,27,17]),function(oe,e,w,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$csc=void 0;let O=class extends w.$5pc{constructor(T,p){super(T,p)}f(T,p,a){p.apply(console,a)}};e.$csc=O,e.$csc=O=He([Ve(0,k.$XP),Ve(1,S.$bQ)],O)}),define(ke[267],Ce([1,0,11,23,22,28,14,6,4,38,160,252,39]),function(oe,e,w,S,k,O,A,T,p,a,R,y,u){"use strict";var E;Object.defineProperty(e,"__esModule",{value:!0}),e.$tcc=e.ResponsiveState=e.RequestInitiator=void 0,e.$rcc=h,e.$scc=i,A=qe(A);function d(L,N){try{return JSON.stringify(L,N)}catch{return"null"}}const n="$$ref$$",s={[n]:-1};class o{constructor(N,B){this.jsonString=N,this.referencedBuffers=B}}function h(L,N=null,B=!1){const G=[];return{jsonString:(B?d:JSON.stringify)(L,(F,q)=>{if(typeof q>"u")return s;if(typeof q=="object"){if(q instanceof S.$Oe){const ue=G.push(q)-1;return{[n]:ue}}if(N)return N(F,q)}return q}),referencedBuffers:G}}function i(L,N,B){return JSON.parse(L,(G,W)=>{if(W){const F=W[n];if(typeof F=="number")return N[F];if(B&&W.$mid===a.MarshalledId.Uri)return B.transformIncoming(W)}return W})}function r(L,N){return JSON.stringify(L,N)}function t(L){return L?(N,B)=>B&&B.$mid===a.MarshalledId.Uri?L.transformOutgoing(B):B:null}var c;(function(L){L[L.LocalSide=0]="LocalSide",L[L.OtherSide=1]="OtherSide"})(c||(e.RequestInitiator=c={}));var l;(function(L){L[L.Responsive=0]="Responsive",L[L.Unresponsive=1]="Unresponsive"})(l||(e.ResponsiveState=l={}));const m=()=>{},f=Symbol.for("rpcProtocol"),$=Symbol.for("rpcProxy");class I extends p.$Wc{static{E=f}static{this.a=3*1e3}constructor(N,B=null,G=null){super(),this[E]=!0,this.b=this.B(new T.$me),this.onDidChangeResponsiveState=this.b.event,this.c=N,this.f=B,this.g=G,this.h=t(this.g),this.j=!1,this.m=[],this.s=[];for(let W=0,F=u.$Mw.count;W<F;W++)this.m[W]=null,this.s[W]=null;this.t=0,this.u=Object.create(null),this.w={},this.y=l.Responsive,this.z=0,this.C=0,this.D=this.B(new w.$Rh(()=>this.H(),1e3)),this.B(this.c.onMessage(W=>this.L(W)))}dispose(){this.j=!0,Object.keys(this.w).forEach(N=>{const B=this.w[N];delete this.w[N],B.resolveErr(A.$8())}),super.dispose()}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}F(N){this.z===0&&(this.C=Date.now()+I.a),this.z++,this.D.isScheduled()||this.D.schedule()}G(N){this.C=Date.now()+I.a,this.z--,this.z===0&&this.D.cancel(),this.I(l.Responsive)}H(){this.z!==0&&(Date.now()>this.C?this.I(l.Unresponsive):this.D.schedule())}I(N){this.y!==N&&(this.y=N,this.b.fire(this.y))}get responsiveState(){return this.y}transformIncomingURIs(N){return this.g?(0,R.$Mn)(N,this.g):N}getProxy(N){const{nid:B,sid:G}=N;return this.s[B]||(this.s[B]=this.J(B,G)),this.s[B]}J(N,B){const G={get:(W,F)=>(typeof F=="string"&&!W[F]&&F.charCodeAt(0)===O.CharCode.DollarSign&&(W[F]=(...q)=>this.U(N,F,q)),F===$?B:W[F])};return new Proxy(Object.create(null),G)}set(N,B){return this.m[N.nid]=B,B}assertRegistered(N){for(let B=0,G=N.length;B<G;B++){const W=N[B];if(!this.m[W.nid])throw new Error(`Missing proxy instance ${W.sid}`)}}L(N){if(this.j)return;const B=N.byteLength,G=v.read(N,0),W=G.readUInt8(),F=G.readUInt32();switch(W){case g.RequestJSONArgs:case g.RequestJSONArgsWithCancellation:{let{rpcId:q,method:ue,args:ge}=P.deserializeRequestJSONArgs(G);this.g&&(ge=(0,R.$Mn)(ge,this.g)),this.M(B,F,q,ue,ge,W===g.RequestJSONArgsWithCancellation);break}case g.RequestMixedArgs:case g.RequestMixedArgsWithCancellation:{let{rpcId:q,method:ue,args:ge}=P.deserializeRequestMixedArgs(G);this.g&&(ge=(0,R.$Mn)(ge,this.g)),this.M(B,F,q,ue,ge,W===g.RequestMixedArgsWithCancellation);break}case g.Acknowledged:{this.f?.logIncoming(B,F,c.LocalSide,"ack"),this.G(F);break}case g.Cancel:{this.N(B,F);break}case g.ReplyOKEmpty:{this.O(B,F,void 0);break}case g.ReplyOKJSON:{let q=P.deserializeReplyOKJSON(G);this.g&&(q=(0,R.$Mn)(q,this.g)),this.O(B,F,q);break}case g.ReplyOKJSONWithBuffers:{const q=P.deserializeReplyOKJSONWithBuffers(G,this.g);this.O(B,F,q);break}case g.ReplyOKVSBuffer:{const q=P.deserializeReplyOKVSBuffer(G);this.O(B,F,q);break}case g.ReplyErrError:{let q=P.deserializeReplyErrError(G);this.g&&(q=(0,R.$Mn)(q,this.g)),this.P(B,F,q);break}case g.ReplyErrEmpty:{this.P(B,F,void 0);break}default:console.error("received unexpected message"),console.error(N)}}M(N,B,G,W,F,q){this.f?.logIncoming(N,B,c.OtherSide,`receiveRequest ${(0,u.$Ow)(G)}.${W}(`,F);const ue=String(B);let ge,te;if(q){const re=new k.$xe;F.push(re.token),ge=this.Q(G,W,F),te=()=>re.cancel()}else ge=this.Q(G,W,F),te=m;this.u[ue]=te;const me=P.serializeAcknowledged(B);this.f?.logOutgoing(me.byteLength,B,c.OtherSide,"ack"),this.c.send(me),ge.then(re=>{delete this.u[ue];const ce=P.serializeReplyOK(B,re,this.h);this.f?.logOutgoing(ce.byteLength,B,c.OtherSide,"reply:",re),this.c.send(ce)},re=>{delete this.u[ue];const ce=P.serializeReplyErr(B,re);this.f?.logOutgoing(ce.byteLength,B,c.OtherSide,"replyErr:",re),this.c.send(ce)})}N(N,B){this.f?.logIncoming(N,B,c.OtherSide,"receiveCancel");const G=String(B);this.u[G]?.()}O(N,B,G){this.f?.logIncoming(N,B,c.LocalSide,"receiveReply:",G);const W=String(B);if(!this.w.hasOwnProperty(W))return;const F=this.w[W];delete this.w[W],F.resolveOk(G)}P(N,B,G){this.f?.logIncoming(N,B,c.LocalSide,"receiveReplyErr:",G);const W=String(B);if(!this.w.hasOwnProperty(W))return;const F=this.w[W];delete this.w[W];let q;G&&(G.$isError?(q=new Error,q.name=G.name,q.message=G.message,q.stack=G.stack):q=G),F.resolveErr(q)}Q(N,B,G){try{return Promise.resolve(this.S(N,B,G))}catch(W){return Promise.reject(W)}}S(N,B,G){const W=this.m[N];if(!W)throw new Error("Unknown actor "+(0,u.$Ow)(N));const F=W[B];if(typeof F!="function")throw new Error("Unknown method "+B+" on actor "+(0,u.$Ow)(N));return F.apply(W,G)}U(N,B,G){if(this.j)return new y.$qcc;let W=null;if(G.length>0&&k.CancellationToken.isCancellationToken(G[G.length-1])&&(W=G.pop()),W&&W.isCancellationRequested)return Promise.reject(A.$8());const F=P.serializeRequestArguments(G,this.h),q=++this.t,ue=String(q),ge=new y.$pcc,te=new p.$Vc;W&&te.add(W.onCancellationRequested(()=>{const re=P.serializeCancel(q);this.f?.logOutgoing(re.byteLength,q,c.LocalSide,"cancel"),this.c.send(P.serializeCancel(q))})),this.w[ue]=new D(ge,te),this.F(q);const me=P.serializeRequest(q,N,B,F,!!W);return this.f?.logOutgoing(me.byteLength,q,c.LocalSide,`request: ${(0,u.$Ow)(N)}.${B}(`,G),this.c.send(me),ge}}e.$tcc=I;class D{constructor(N,B){this.a=N,this.b=B}resolveOk(N){this.a.resolveOk(N),this.b.dispose()}resolveErr(N){this.a.resolveErr(N),this.b.dispose()}}class v{static alloc(N,B,G){const W=new v(S.$Oe.alloc(G+1+4),0);return W.writeUInt8(N),W.writeUInt32(B),W}static read(N,B){return new v(N,B)}get buffer(){return this.a}constructor(N,B){this.a=N,this.b=B}static sizeUInt8(){return 1}static{this.sizeUInt32=4}writeUInt8(N){this.a.writeUInt8(N,this.b),this.b+=1}readUInt8(){const N=this.a.readUInt8(this.b);return this.b+=1,N}writeUInt32(N){this.a.writeUInt32BE(N,this.b),this.b+=4}readUInt32(){const N=this.a.readUInt32BE(this.b);return this.b+=4,N}static sizeShortString(N){return 1+N.byteLength}writeShortString(N){this.a.writeUInt8(N.byteLength,this.b),this.b+=1,this.a.set(N,this.b),this.b+=N.byteLength}readShortString(){const N=this.a.readUInt8(this.b);this.b+=1;const G=this.a.slice(this.b,this.b+N).toString();return this.b+=N,G}static sizeLongString(N){return 4+N.byteLength}writeLongString(N){this.a.writeUInt32BE(N.byteLength,this.b),this.b+=4,this.a.set(N,this.b),this.b+=N.byteLength}readLongString(){const N=this.a.readUInt32BE(this.b);this.b+=4;const G=this.a.slice(this.b,this.b+N).toString();return this.b+=N,G}writeBuffer(N){this.a.writeUInt32BE(N.byteLength,this.b),this.b+=4,this.a.set(N,this.b),this.b+=N.byteLength}static sizeVSBuffer(N){return 4+N.byteLength}writeVSBuffer(N){this.a.writeUInt32BE(N.byteLength,this.b),this.b+=4,this.a.set(N,this.b),this.b+=N.byteLength}readVSBuffer(){const N=this.a.readUInt32BE(this.b);this.b+=4;const B=this.a.slice(this.b,this.b+N);return this.b+=N,B}static sizeMixedArray(N){let B=0;B+=1;for(let G=0,W=N.length;G<W;G++){const F=N[G];switch(B+=1,F.type){case b.String:B+=this.sizeLongString(F.value);break;case b.VSBuffer:B+=this.sizeVSBuffer(F.value);break;case b.SerializedObjectWithBuffers:B+=this.sizeUInt32,B+=this.sizeLongString(F.value);for(let q=0;q<F.buffers.length;++q)B+=this.sizeVSBuffer(F.buffers[q]);break;case b.Undefined:break}}return B}writeMixedArray(N){this.a.writeUInt8(N.length,this.b),this.b+=1;for(let B=0,G=N.length;B<G;B++){const W=N[B];switch(W.type){case b.String:this.writeUInt8(b.String),this.writeLongString(W.value);break;case b.VSBuffer:this.writeUInt8(b.VSBuffer),this.writeVSBuffer(W.value);break;case b.SerializedObjectWithBuffers:this.writeUInt8(b.SerializedObjectWithBuffers),this.writeUInt32(W.buffers.length),this.writeLongString(W.value);for(let F=0;F<W.buffers.length;++F)this.writeBuffer(W.buffers[F]);break;case b.Undefined:this.writeUInt8(b.Undefined);break}}}readMixedArray(){const N=this.a.readUInt8(this.b);this.b+=1;const B=new Array(N);for(let G=0;G<N;G++)switch(this.readUInt8()){case b.String:B[G]=this.readLongString();break;case b.VSBuffer:B[G]=this.readVSBuffer();break;case b.SerializedObjectWithBuffers:{const F=this.readUInt32(),q=this.readLongString(),ue=[];for(let ge=0;ge<F;++ge)ue.push(this.readVSBuffer());B[G]=new u.$Pw(i(q,ue,null));break}case b.Undefined:B[G]=void 0;break}return B}}var C;(function(L){L[L.Simple=0]="Simple",L[L.Mixed=1]="Mixed"})(C||(C={}));class P{static a(N){for(let B=0,G=N.length;B<G;B++)if(N[B]instanceof S.$Oe||N[B]instanceof u.$Pw||typeof N[B]>"u")return!0;return!1}static serializeRequestArguments(N,B){if(this.a(N)){const G=[];for(let W=0,F=N.length;W<F;W++){const q=N[W];if(q instanceof S.$Oe)G[W]={type:b.VSBuffer,value:q};else if(typeof q>"u")G[W]={type:b.Undefined};else if(q instanceof u.$Pw){const{jsonString:ue,referencedBuffers:ge}=h(q.value,B);G[W]={type:b.SerializedObjectWithBuffers,value:S.$Oe.fromString(ue),buffers:ge}}else G[W]={type:b.String,value:S.$Oe.fromString(r(q,B))}}return{type:C.Mixed,args:G}}return{type:C.Simple,args:r(N,B)}}static serializeRequest(N,B,G,W,F){switch(W.type){case C.Simple:return this.b(N,B,G,W.args,F);case C.Mixed:return this.c(N,B,G,W.args,F)}}static b(N,B,G,W,F){const q=S.$Oe.fromString(G),ue=S.$Oe.fromString(W);let ge=0;ge+=v.sizeUInt8(),ge+=v.sizeShortString(q),ge+=v.sizeLongString(ue);const te=v.alloc(F?g.RequestJSONArgsWithCancellation:g.RequestJSONArgs,N,ge);return te.writeUInt8(B),te.writeShortString(q),te.writeLongString(ue),te.buffer}static deserializeRequestJSONArgs(N){const B=N.readUInt8(),G=N.readShortString(),W=N.readLongString();return{rpcId:B,method:G,args:JSON.parse(W)}}static c(N,B,G,W,F){const q=S.$Oe.fromString(G);let ue=0;ue+=v.sizeUInt8(),ue+=v.sizeShortString(q),ue+=v.sizeMixedArray(W);const ge=v.alloc(F?g.RequestMixedArgsWithCancellation:g.RequestMixedArgs,N,ue);return ge.writeUInt8(B),ge.writeShortString(q),ge.writeMixedArray(W),ge.buffer}static deserializeRequestMixedArgs(N){const B=N.readUInt8(),G=N.readShortString(),W=N.readMixedArray(),F=new Array(W.length);for(let q=0,ue=W.length;q<ue;q++){const ge=W[q];typeof ge=="string"?F[q]=JSON.parse(ge):F[q]=ge}return{rpcId:B,method:G,args:F}}static serializeAcknowledged(N){return v.alloc(g.Acknowledged,N,0).buffer}static serializeCancel(N){return v.alloc(g.Cancel,N,0).buffer}static serializeReplyOK(N,B,G){if(typeof B>"u")return this.d(N);if(B instanceof S.$Oe)return this.e(N,B);if(B instanceof u.$Pw){const{jsonString:W,referencedBuffers:F}=h(B.value,G,!0);return this.g(N,W,F)}else return this.f(N,d(B,G))}static d(N){return v.alloc(g.ReplyOKEmpty,N,0).buffer}static e(N,B){let G=0;G+=v.sizeVSBuffer(B);const W=v.alloc(g.ReplyOKVSBuffer,N,G);return W.writeVSBuffer(B),W.buffer}static deserializeReplyOKVSBuffer(N){return N.readVSBuffer()}static f(N,B){const G=S.$Oe.fromString(B);let W=0;W+=v.sizeLongString(G);const F=v.alloc(g.ReplyOKJSON,N,W);return F.writeLongString(G),F.buffer}static g(N,B,G){const W=S.$Oe.fromString(B);let F=0;F+=v.sizeUInt32,F+=v.sizeLongString(W);for(const ue of G)F+=v.sizeVSBuffer(ue);const q=v.alloc(g.ReplyOKJSONWithBuffers,N,F);q.writeUInt32(G.length),q.writeLongString(W);for(const ue of G)q.writeBuffer(ue);return q.buffer}static deserializeReplyOKJSON(N){const B=N.readLongString();return JSON.parse(B)}static deserializeReplyOKJSONWithBuffers(N,B){const G=N.readUInt32(),W=N.readLongString(),F=[];for(let q=0;q<G;++q)F.push(N.readVSBuffer());return new u.$Pw(i(W,F,B))}static serializeReplyErr(N,B){const G=B?d(A.$5(B),null):void 0;if(typeof G!="string")return this.h(N);const W=S.$Oe.fromString(G);let F=0;F+=v.sizeLongString(W);const q=v.alloc(g.ReplyErrError,N,F);return q.writeLongString(W),q.buffer}static deserializeReplyErrError(N){const B=N.readLongString();return JSON.parse(B)}static h(N){return v.alloc(g.ReplyErrEmpty,N,0).buffer}}var g;(function(L){L[L.RequestJSONArgs=1]="RequestJSONArgs",L[L.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",L[L.RequestMixedArgs=3]="RequestMixedArgs",L[L.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",L[L.Acknowledged=5]="Acknowledged",L[L.Cancel=6]="Cancel",L[L.ReplyOKEmpty=7]="ReplyOKEmpty",L[L.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",L[L.ReplyOKJSON=9]="ReplyOKJSON",L[L.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",L[L.ReplyErrError=11]="ReplyErrError",L[L.ReplyErrEmpty=12]="ReplyErrEmpty"})(g||(g={}));var b;(function(L){L[L.String=1]="String",L[L.VSBuffer=2]="VSBuffer",L[L.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",L[L.Undefined=4]="Undefined"})(b||(b={}))}),define(ke[268],Ce([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$esc=void 0;const w=function(O){const A=T=>{globalThis.removeEventListener("message",A);const p=T.data;Object.defineProperties(globalThis,{postMessage:{value(a,R){p.postMessage(a,R)}},onmessage:{get(){return p.onmessage},set(a){p.onmessage=a}}}),p.addEventListener("message",a=>{globalThis.dispatchEvent(new MessageEvent("message",{data:a.data,ports:a.ports?[...a.ports]:void 0}))}),p.start(),globalThis.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(O)};globalThis.addEventListener("message",A)}.toString();class S extends EventTarget{constructor(O,A,T){super(),this.onmessage=null,this.onmessageerror=null,this.onerror=null;const p=`((${w})('${A}'))`,a=new Blob([p],{type:"application/javascript"}),R=URL.createObjectURL(a),y=new MessageChannel,u=R,E={type:"_newWorker",id:u,port:y.port2,url:R,options:T};O(E,[y.port2]),this.postMessage=y.port1.postMessage.bind(y.port1),this.terminate=()=>{O({type:"_terminateWorker",id:u}),URL.revokeObjectURL(R),y.port1.close(),y.port2.close()},Object.defineProperties(this,{onmessage:{get(){return y.port1.onmessage},set(d){y.port1.onmessage=d}},onmessageerror:{get(){return y.port1.onmessageerror},set(d){y.port1.onmessageerror=d}}}),y.port1.addEventListener("messageerror",d=>{const n=new MessageEvent("messageerror",{data:d.data});this.dispatchEvent(n)}),y.port1.addEventListener("message",d=>{const n=new MessageEvent("message",{data:d.data});this.dispatchEvent(n)}),y.port1.start()}}e.$esc=S}),define(ke[269],Ce([1,0,23,29,16,61,3]),function(oe,e,w,S,k,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$QK=e.$NK=void 0,e.$OK=R,e.$PK=y,e.$NK=(0,A.$Fi)("notebookDocumentService");const T=["W","X","Y","Z","a","b","c","d","e","f"],p=new RegExp(`^[${T.join("")}]+`),a=7;function R(E){if(E.scheme!==k.Schemas.vscodeNotebookCell)return;const d=E.fragment.indexOf("s");if(d<0)return;const n=parseInt(E.fragment.substring(0,d).replace(p,""),a),s=(0,w.$8e)(E.fragment.substring(d+1)).toString();if(!isNaN(n))return{handle:n,notebook:E.with({scheme:s,fragment:null})}}function y(E,d){const n=d.toString(a),o=`${n.length<T.length?T[n.length-1]:"z"}${n}s${(0,w.$9e)(w.$Oe.fromString(E.scheme),!0,!0)}`;return E.with({scheme:k.Schemas.vscodeNotebookCell,fragment:o})}class u{constructor(){this.a=new S.$Cc}getNotebook(d){if(d.scheme===k.Schemas.vscodeNotebookCell){const n=R(d);if(n){const s=this.a.get(n.notebook);if(s)return s}}return this.a.get(d)}addNotebookDocument(d){this.a.set(d.uri,d)}removeNotebookDocument(d){this.a.delete(d.uri)}}e.$QK=u,(0,O.$Ks)(e.$NK,u,O.InstantiationType.Delayed)}),define(ke[90],Ce([1,0,23,41,40,73,16,20,21,32,269]),function(oe,e,w,S,k,O,A,T,p,a,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yL=e.$vL=e.CellStatusbarAlignment=e.$uL=e.NotebookEditorPriority=e.$rL=e.$qL=e.$oL=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.$nL=e.$mL=e.$lL=e.$kL=e.CellKind=e.$jL=e.$iL=e.$hL=e.$gL=e.$fL=void 0,e.$pL=l,e.$sL=f,e.$tL=$,e.$wL=v,e.$xL=P,S=qe(S),e.$fL="workbench.editor.notebook",e.$gL="workbench.editor.notebookTextDiffEditor",e.$hL="workbench.editor.interactive",e.$iL="workbench.editor.repl",e.$jL="replNotebook.input.execute";var y;(function(q){q[q.Markup=1]="Markup",q[q.Code=2]="Code"})(y||(e.CellKind=y={})),e.$kL=["application/json","application/javascript","text/html","image/svg+xml",O.$4s.latex,O.$4s.markdown,"image/png","image/jpeg",O.$4s.text],e.$lL=[O.$4s.latex,O.$4s.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",O.$4s.text],e.$mL=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.$nL="_notAvailable";var u;(function(q){q[q.Running=1]="Running",q[q.Idle=2]="Idle"})(u||(e.NotebookRunState=u={}));var E;(function(q){q[q.Unconfirmed=1]="Unconfirmed",q[q.Pending=2]="Pending",q[q.Executing=3]="Executing"})(E||(e.NotebookCellExecutionState=E={}));var d;(function(q){q[q.Unconfirmed=1]="Unconfirmed",q[q.Pending=2]="Pending",q[q.Executing=3]="Executing"})(d||(e.NotebookExecutionState=d={}));var n;(function(q){q[q.WithHardKernelDependency=0]="WithHardKernelDependency",q[q.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",q[q.Pure=2]="Pure",q[q.Never=3]="Never"})(n||(e.NotebookRendererMatch=n={}));var s;(function(q){q.Always="always",q.Never="never",q.Optional="optional"})(s||(e.RendererMessagingSpec=s={}));var o;(function(q){q[q.ModelChange=1]="ModelChange",q[q.Move=2]="Move",q[q.ChangeCellLanguage=5]="ChangeCellLanguage",q[q.Initialize=6]="Initialize",q[q.ChangeCellMetadata=7]="ChangeCellMetadata",q[q.Output=8]="Output",q[q.OutputItem=9]="OutputItem",q[q.ChangeCellContent=10]="ChangeCellContent",q[q.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",q[q.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",q[q.ChangeCellMime=13]="ChangeCellMime",q[q.Unknown=100]="Unknown"})(o||(e.NotebookCellsChangeType=o={}));var h;(function(q){q[q.Handle=0]="Handle",q[q.Index=1]="Index"})(h||(e.SelectionStateType=h={}));var i;(function(q){q[q.Replace=1]="Replace",q[q.Output=2]="Output",q[q.Metadata=3]="Metadata",q[q.CellLanguage=4]="CellLanguage",q[q.DocumentMetadata=5]="DocumentMetadata",q[q.Move=6]="Move",q[q.OutputItems=7]="OutputItems",q[q.PartialMetadata=8]="PartialMetadata",q[q.PartialInternalMetadata=9]="PartialInternalMetadata"})(i||(e.CellEditType=i={}));var r;(function(q){q.scheme=A.Schemas.vscodeNotebookCell;function ue(be,se){return(0,R.$PK)(be,se)}q.generate=ue;function ge(be){return(0,R.$OK)(be)}q.parse=ge;function te(be,se){return be.with({scheme:A.Schemas.vscodeNotebookCellOutput,fragment:`op${se??""},${be.scheme!==A.Schemas.file?be.scheme:""}`})}q.generateCellOutputUri=te;function me(be){if(be.scheme!==A.Schemas.vscodeNotebookCellOutput)return;const se=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(be.fragment);if(!se)return;const Ie=se[1]&&se[1]!==""?se[1]:void 0,Ue=se[2];return{outputId:Ie,notebook:be.with({scheme:Ue||A.Schemas.file,fragment:null})}}q.parseCellOutputUri=me;function re(be,se,Ie){return q.generate(be,se).with({scheme:Ie})}q.generateCellPropertyUri=re;function ce(be,se){if(be.scheme===se)return q.parse(be.with({scheme:q.scheme}))}q.parseCellPropertyUri=ce})(r||(e.CellUri=r={}));const t=q=>p.$i?q.replace(/\//g,"\\"):q;class c{constructor(ue=[],ge=e.$kL){this.e=ge,this.d=[...new Set(ue)].map(te=>({pattern:te,matches:S.$zk(t(te))}))}sort(ue){const ge=new Map(k.Iterable.map(ue,me=>[me,t(me)]));let te=[];for(const{matches:me}of this.d)for(const[re,ce]of ge)if(me(ce)){te.push(re),ge.delete(re);break}return ge.size&&(te=te.concat([...ge.keys()].sort((me,re)=>this.e.indexOf(me)-this.e.indexOf(re)))),te}prioritize(ue,ge){const te=this.f(ue);if(te===-1){this.d.unshift({pattern:ue,matches:S.$zk(t(ue))});return}const me=new Set(ge.map(ce=>this.f(ce,te)));me.delete(-1);const re=Array.from(me).sort();this.d.splice(te+1,0,...re.map(ce=>this.d[ce]));for(let ce=re.length-1;ce>=0;ce--)this.d.splice(re[ce],1)}toArray(){return this.d.map(ue=>ue.pattern)}f(ue,ge=this.d.length){const te=t(ue);for(let me=0;me<ge;me++)if(this.d[me].matches(te))return me;return-1}}e.$oL=c;function l(q,ue,ge,te=(me,re)=>me===re){const me=[];function re(se,Ie,Ue){if(Ie===0&&Ue.length===0)return;const Z=me[me.length-1];Z&&Z.start+Z.deleteCount===se?(Z.deleteCount+=Ie,Z.toInsert.push(...Ue)):me.push({start:se,deleteCount:Ie,toInsert:Ue})}let ce=0,be=0;for(;;){if(ce===q.length){re(ce,0,ue.slice(be));break}if(be===ue.length){re(ce,q.length-ce,[]);break}const se=q[ce],Ie=ue[be];if(te(se,Ie)){ce+=1,be+=1;continue}ge(Ie)?(re(ce,1,[]),ce+=1):(re(ce,0,[Ie]),be+=1)}return me}e.$qL=new a.$Wj("notebookEditorCursorAtBoundary","none"),e.$rL=new a.$Wj("notebookEditorCursorAtLineBoundary","none");var m;(function(q){q.default="default",q.option="option"})(m||(e.NotebookEditorPriority=m={}));function f(q){const ue=q;return!!((typeof ue.include=="string"||S.$Ak(ue.include))&&(typeof ue.exclude=="string"||S.$Ak(ue.exclude)))}function $(q,ue,ge){if(Array.isArray(q.viewType)&&q.viewType.indexOf(ue)>=0||q.viewType===ue)return!0;if(q.filenamePattern){const te=f(q.filenamePattern)?q.filenamePattern.include:q.filenamePattern,me=f(q.filenamePattern)?q.filenamePattern.exclude:void 0;if(S.$yk(te,(0,T.$pc)(ge.fsPath).toLowerCase()))return!(me&&S.$yk(me,(0,T.$pc)(ge.fsPath).toLowerCase()))}return!1}e.$uL={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScrollEnabled:"notebook.stickyScroll.enabled",stickyScrollMode:"notebook.stickyScroll.mode",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",markdownLineHeight:"notebook.markdown.lineHeight",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",LinkifyOutputFilePaths:"notebook.output.linkifyFilePaths",minimalErrorRendering:"notebook.output.minimalErrorRendering",formatOnSave:"notebook.formatOnSave.enabled",insertFinalNewline:"notebook.insertFinalNewline",defaultFormatter:"notebook.defaultFormatter",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findFilters:"notebook.find.filters",findScope:"notebook.experimental.find.scope.enabled",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave",gotoSymbolsAllSymbols:"notebook.gotoSymbols.showAllSymbols",outlineShowMarkdownHeadersOnly:"notebook.outline.showMarkdownHeadersOnly",outlineShowCodeCells:"notebook.outline.showCodeCells",outlineShowCodeCellSymbols:"notebook.outline.showCodeCellSymbols",breadcrumbsShowCodeCells:"notebook.breadcrumbs.showCodeCells",scrollToRevealCell:"notebook.scrolling.revealNextCellOnExecute",cellChat:"notebook.experimental.cellChat",cellGenerate:"notebook.experimental.generate",notebookVariablesView:"notebook.experimental.variablesView",InteractiveWindowPromptToSave:"interactiveWindow.promptToSaveOnClose",cellFailureDiagnostics:"notebook.cellFailureDiagnostics",outputBackupSizeLimit:"notebook.backup.sizeLimit"};var I;(function(q){q[q.Left=1]="Left",q[q.Right=2]="Right"})(I||(e.CellStatusbarAlignment=I={}));class D{static{this.d="notebook/"}static create(ue){return`${D.d}${ue}`}static parse(ue){if(ue.startsWith(D.d))return ue.substring(D.d.length)}}e.$vL=D;function v(q){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(q)}const C=new TextDecoder;function P(q){const ue=[];let ge=!1;for(const ce of q)(ue.length===0||ge)&&(ue.push(ce),ge=!0);let te=L(ue);const me=w.$Oe.concat(ue.map(ce=>w.$Oe.wrap(ce))),re=F(me);return te=te||re.byteLength!==me.byteLength,{data:re,didCompression:te}}e.$yL="\x1B[A";const g=e.$yL.split("").map(q=>q.charCodeAt(0)),b=10;function L(q){let ue=!1;return q.forEach((ge,te)=>{if(te===0||ge.length<e.$yL.length)return;const me=q[te-1],re=ge.subarray(0,e.$yL.length);if(re[0]===g[0]&&re[1]===g[1]&&re[2]===g[2]){const ce=me.lastIndexOf(b);if(ce===-1)return;ue=!0,q[te-1]=me.subarray(0,ce),q[te]=ge.subarray(e.$yL.length)}}),ue}function N(q){let ue=q;do q=ue,ue=q.replace(/[^\n]\x08/gm,"");while(ue.length<q.length);return q}function B(q){for(q=q.replace(/\r+\n/gm,`
`);q.search(/\r[^$]/g)>-1;){const ue=q.match(/^(.*)\r+/m)[1];let ge=q.match(/\r+(.*)$/m)[1];ge=ge+ue.slice(ge.length,ue.length),q=q.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,ge)}return q}const G=8,W=13;function F(q){return!q.buffer.includes(G)&&!q.buffer.includes(W)?q:w.$Oe.fromString(B(N(C.decode(q.buffer))))}}),define(ke[7],Ce([1,0,18,14,60,29,73,13,15,2,37,19,30,109,90]),function(oe,e,w,S,k,O,A,T,p,a,R,y,u,E,d){"use strict";var n,s,o,h,i,r,t,c,l,m,f,$,I,D,v,C,P;Object.defineProperty(e,"__esModule",{value:!0}),e.InlineEditTriggerKind=e.$MP=e.KeywordRecognitionStatus=e.TextToSpeechStatus=e.SpeechToTextStatus=e.RelatedInformationType=e.$LP=e.$KP=e.$JP=e.$IP=e.$HP=e.$GP=e.$FP=e.$EP=e.LanguageModelChatMessageRole=e.ChatLocation=e.$DP=e.$CP=e.$BP=e.$AP=e.$zP=e.$yP=e.$xP=e.$wP=e.$vP=e.$uP=e.$tP=e.$sP=e.$rP=e.$qP=e.ChatResultFeedbackKind=e.InteractiveEditorResponseFeedbackKind=e.$pP=e.ChatVariableLevel=e.ChatCopyKind=e.InteractiveSessionVoteDirection=e.$oP=e.$nP=e.$mP=e.$lP=e.$kP=e.$jP=e.$iP=e.$hP=e.$gP=e.$fP=e.$eP=e.$dP=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.$cP=e.$bP=e.$aP=e.$_O=e.$0O=e.$9O=e.$8O=e.$7O=e.TestRunProfileKind=e.TestResultState=e.$6O=e.$5O=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.$4O=e.NotebookVariablesRequestKind=e.$3O=e.$2O=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.$1O=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.$ZO=e.$YO=e.$XO=e.$WO=e.$VO=e.ColorThemeKind=e.$UO=e.$TO=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.$SO=e.$RO=e.DebugConsoleMode=e.$QO=e.$PO=e.$OO=e.$NO=e.$MO=e.CommentThreadApplicability=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.$LO=e.$KO=e.FileChangeType=e.$JO=e.NewSymbolNameTriggerKind=e.NewSymbolNameTag=e.$IO=e.$HO=e.$GO=e.$FO=e.InlineCompletionTriggerKind=e.$EO=e.$DO=e.$CO=e.$BO=e.$AO=e.$zO=e.$yO=e.$xO=e.$wO=e.$vO=e.$uO=e.$sO=e.ConfigurationTarget=e.$rO=e.$qO=e.$pO=e.$oO=e.DocumentPasteTriggerKind=e.$nO=e.$mO=e.$lO=e.$kO=e.$jO=e.$iO=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.$hO=e.ViewBadge=e.ProgressLocation=e.$gO=e.$fO=e.TaskScope=e.ShellQuoting=e.$eO=e.$dO=e.$cO=e.TaskPanelKind=e.TaskRevealKind=e.$bO=e.TerminalLocation=e.$aO=e.$_N=e.$$N=e.TerminalShellExecutionCommandLineConfidence=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.$0N=e.$9N=e.$8N=e.$7N=e.SyntaxTokenType=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.PartialAcceptTriggerKind=e.$5N=e.$4N=e.$3N=e.$2N=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.$1N=e.$ZN=e.InlayHintKind=e.SignatureHelpTriggerKind=e.$YN=e.$XN=e.$WN=e.$VN=e.$UN=e.LanguageStatusSeverity=e.$TN=e.$SN=e.$RN=e.$QN=e.$PN=e.$ON=e.CodeActionTriggerKind=e.$NN=e.$MN=e.SymbolTag=e.SymbolKind=e.$LN=e.$KN=e.DocumentHighlightKind=e.HoverVerbosityAction=e.$JN=e.$IN=e.$HN=e.$GN=e.$FN=e.DiagnosticSeverity=e.DiagnosticTag=e.$EN=e.$DN=e.FileEditType=e.$CN=e.$BN=e.$AN=e.EnvironmentVariableMutatorType=e.EndOfLine=e.$zN=e.$yN=e.$xN=e.$wN=e.$vN=e.$uN=e.$tN=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0,e.$6N=xe,e.$tO=Di,e.$$O=Ri;function g(j){return Object.assign(j,{apply:function(...ie){if(ie.length===0)return Reflect.construct(j,[]);{const De=ie.length===1?[]:ie[1];return Reflect.construct(j,De,ie[0].constructor)}},call:function(...ie){if(ie.length===0)return Reflect.construct(j,[]);{const[De,...Qe]=ie;return Reflect.construct(j,Qe,De.constructor)}}})}var b;(function(j){j[j.Top=0]="Top",j[j.Bottom=1]="Bottom"})(b||(e.TerminalOutputAnchor=b={}));var L;(function(j){j[j.TerminalCommand=0]="TerminalCommand",j[j.Opener=1]="Opener",j[j.Command=3]="Command"})(L||(e.TerminalQuickFixType=L={}));let N=n=class{static from(...M){let ie=M;return new n(function(){if(ie){for(const De of ie)De&&typeof De.dispose=="function"&&De.dispose();ie=void 0}})}#e;constructor(M){this.#e=M}dispose(){typeof this.#e=="function"&&(this.#e(),this.#e=void 0)}};e.$tN=N,e.$tN=N=n=He([g],N);let B=s=class{static Min(...M){if(M.length===0)throw new TypeError;let ie=M[0];for(let De=1;De<M.length;De++){const Qe=M[De];Qe.isBefore(ie)&&(ie=Qe)}return ie}static Max(...M){if(M.length===0)throw new TypeError;let ie=M[0];for(let De=1;De<M.length;De++){const Qe=M[De];Qe.isAfter(ie)&&(ie=Qe)}return ie}static isPosition(M){if(!M)return!1;if(M instanceof s)return!0;const{line:ie,character:De}=M;return typeof ie=="number"&&typeof De=="number"}static of(M){if(M instanceof s)return M;if(this.isPosition(M))return new s(M.line,M.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(M,ie){if(M<0)throw(0,S.$9)("line must be non-negative");if(ie<0)throw(0,S.$9)("character must be non-negative");this.c=M,this.e=ie}isBefore(M){return this.c<M.c?!0:M.c<this.c?!1:this.e<M.e}isBeforeOrEqual(M){return this.c<M.c?!0:M.c<this.c?!1:this.e<=M.e}isAfter(M){return!this.isBeforeOrEqual(M)}isAfterOrEqual(M){return!this.isBefore(M)}isEqual(M){return this.c===M.c&&this.e===M.e}compareTo(M){return this.c<M.c?-1:this.c>M.line?1:this.e<M.e?-1:this.e>M.e?1:0}translate(M,ie=0){if(M===null||ie===null)throw(0,S.$9)();let De;return typeof M>"u"?De=0:typeof M=="number"?De=M:(De=typeof M.lineDelta=="number"?M.lineDelta:0,ie=typeof M.characterDelta=="number"?M.characterDelta:0),De===0&&ie===0?this:new s(this.line+De,this.character+ie)}with(M,ie=this.character){if(M===null||ie===null)throw(0,S.$9)();let De;return typeof M>"u"?De=this.line:typeof M=="number"?De=M:(De=typeof M.line=="number"?M.line:this.line,ie=typeof M.character=="number"?M.character:this.character),De===this.line&&ie===this.character?this:new s(De,ie)}toJSON(){return{line:this.line,character:this.character}}};e.$uN=B,e.$uN=B=s=He([g],B);let G=o=class{static isRange(M){return M instanceof o?!0:M?B.isPosition(M.start)&&B.isPosition(M.end):!1}static of(M){if(M instanceof o)return M;if(this.isRange(M))return new o(M.start,M.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(M,ie,De,Qe){let et,dt;if(typeof M=="number"&&typeof ie=="number"&&typeof De=="number"&&typeof Qe=="number"?(et=new B(M,ie),dt=new B(De,Qe)):B.isPosition(M)&&B.isPosition(ie)&&(et=B.of(M),dt=B.of(ie)),!et||!dt)throw new Error("Invalid arguments");et.isBefore(dt)?(this.c=et,this.e=dt):(this.c=dt,this.e=et)}contains(M){return o.isRange(M)?this.contains(M.start)&&this.contains(M.end):B.isPosition(M)?!(B.of(M).isBefore(this.c)||this.e.isBefore(M)):!1}isEqual(M){return this.c.isEqual(M.c)&&this.e.isEqual(M.e)}intersection(M){const ie=B.Max(M.start,this.c),De=B.Min(M.end,this.e);if(!ie.isAfter(De))return new o(ie,De)}union(M){if(this.contains(M))return this;if(M.contains(this))return M;const ie=B.Min(M.start,this.c),De=B.Max(M.end,this.end);return new o(ie,De)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(M,ie=this.end){if(M===null||ie===null)throw(0,S.$9)();let De;return M?B.isPosition(M)?De=M:(De=M.start||this.start,ie=M.end||this.end):De=this.start,De.isEqual(this.c)&&ie.isEqual(this.end)?this:new o(De,ie)}toJSON(){return[this.start,this.end]}};e.$vN=G,e.$vN=G=o=He([g],G);let W=h=class extends G{static isSelection(M){return M instanceof h?!0:M?G.isRange(M)&&B.isPosition(M.anchor)&&B.isPosition(M.active)&&typeof M.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(M,ie,De,Qe){let et,dt;if(typeof M=="number"&&typeof ie=="number"&&typeof De=="number"&&typeof Qe=="number"?(et=new B(M,ie),dt=new B(De,Qe)):B.isPosition(M)&&B.isPosition(ie)&&(et=B.of(M),dt=B.of(ie)),!et||!dt)throw new Error("Invalid arguments");super(et,dt),this.f=et,this.g=dt}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.$wN=W,e.$wN=W=h=He([g],W);const F=j=>{if(typeof j!="string"||j.length===0||!/^[0-9A-Za-z_\-]+$/.test(j))throw(0,S.$9)("connectionToken")};class q{static isResolvedAuthority(M){return M&&typeof M=="object"&&typeof M.host=="string"&&typeof M.port=="number"&&(M.connectionToken===void 0||typeof M.connectionToken=="string")}constructor(M,ie,De){if(typeof M!="string"||M.length===0)throw(0,S.$9)("host");if(typeof ie!="number"||ie===0||Math.round(ie)!==ie)throw(0,S.$9)("port");typeof De<"u"&&F(De),this.host=M,this.port=Math.round(ie),this.connectionToken=De}}e.$xN=q;class ue{static isManagedResolvedAuthority(M){return M&&typeof M=="object"&&typeof M.makeConnection=="function"&&(M.connectionToken===void 0||typeof M.connectionToken=="string")}constructor(M,ie){this.makeConnection=M,this.connectionToken=ie,typeof ie<"u"&&F(ie)}}e.$yN=ue;class ge extends Error{static NotAvailable(M,ie){return new ge(M,E.RemoteAuthorityResolverErrorCode.NotAvailable,ie)}static TemporarilyNotAvailable(M){return new ge(M,E.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(M,ie=E.RemoteAuthorityResolverErrorCode.Unknown,De){super(M),this._message=M,this._code=ie,this._detail=De,Object.setPrototypeOf(this,ge.prototype)}}e.$zN=ge;var te;(function(j){j[j.LF=1]="LF",j[j.CRLF=2]="CRLF"})(te||(e.EndOfLine=te={}));var me;(function(j){j[j.Replace=1]="Replace",j[j.Append=2]="Append",j[j.Prepend=3]="Prepend"})(me||(e.EnvironmentVariableMutatorType=me={}));let re=i=class{static isTextEdit(M){return M instanceof i?!0:M?G.isRange(M)&&typeof M.newText=="string":!1}static replace(M,ie){return new i(M,ie)}static insert(M,ie){return i.replace(new G(M,M),ie)}static delete(M){return i.replace(M,"")}static setEndOfLine(M){const ie=new i(new G(new B(0,0),new B(0,0)),"");return ie.newEol=M,ie}get range(){return this.c}set range(M){if(M&&!G.isRange(M))throw(0,S.$9)("range");this.c=M}get newText(){return this.e||""}set newText(M){if(M&&typeof M!="string")throw(0,S.$9)("newText");this.e=M}get newEol(){return this.f}set newEol(M){if(M&&typeof M!="number")throw(0,S.$9)("newEol");this.f=M}constructor(M,ie){this.c=M,this.e=ie}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};e.$AN=re,e.$AN=re=i=He([g],re);let ce=r=class{static isNotebookCellEdit(M){return M instanceof r?!0:M?bt.isNotebookRange(M)&&Array.isArray(M.newCells):!1}static replaceCells(M,ie){return new r(M,ie)}static insertCells(M,ie){return new r(new bt(M,M),ie)}static deleteCells(M){return new r(M,[])}static updateCellMetadata(M,ie){const De=new r(new bt(M,M),[]);return De.newCellMetadata=ie,De}static updateNotebookMetadata(M){const ie=new r(new bt(0,0),[]);return ie.newNotebookMetadata=M,ie}constructor(M,ie){this.range=M,this.newCells=ie}};e.$BN=ce,e.$BN=ce=r=He([g],ce);class be{static isSnippetTextEdit(M){return M instanceof be?!0:M?G.isRange(M.range)&&Ue.isSnippetString(M.snippet):!1}static replace(M,ie){return new be(M,ie)}static insert(M,ie){return be.replace(new G(M,M),ie)}constructor(M,ie){this.range=M,this.snippet=ie}}e.$CN=be;var se;(function(j){j[j.File=1]="File",j[j.Text=2]="Text",j[j.Cell=3]="Cell",j[j.CellReplace=5]="CellReplace",j[j.Snippet=6]="Snippet"})(se||(e.FileEditType=se={}));let Ie=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(M,ie,De,Qe){this.c.push({_type:se.File,from:M,to:ie,options:De,metadata:Qe})}createFile(M,ie,De){this.c.push({_type:se.File,from:void 0,to:M,options:ie,metadata:De})}deleteFile(M,ie,De){this.c.push({_type:se.File,from:M,to:void 0,options:ie,metadata:De})}e(M,ie,De){this.c.push({_type:se.Cell,metadata:De,uri:M,edit:{editType:d.CellEditType.DocumentMetadata,metadata:ie},notebookMetadata:ie})}f(M,ie,De,Qe){const et=ie.start,dt=ie.end;(et!==dt||De.length>0)&&this.c.push({_type:se.CellReplace,uri:M,index:et,count:dt-et,cells:De,metadata:Qe})}g(M,ie,De,Qe){this.c.push({_type:se.Cell,metadata:Qe,uri:M,edit:{editType:d.CellEditType.Metadata,index:ie,metadata:De}})}replace(M,ie,De,Qe){this.c.push({_type:se.Text,uri:M,edit:new re(ie,De),metadata:Qe})}insert(M,ie,De,Qe){this.replace(M,new G(ie,ie),De,Qe)}delete(M,ie,De){this.replace(M,ie,"",De)}has(M){return this.c.some(ie=>ie._type===se.Text&&ie.uri.toString()===M.toString())}set(M,ie){if(ie)for(const De of ie){if(!De)continue;let Qe,et;Array.isArray(De)?(Qe=De[0],et=De[1]):Qe=De,ce.isNotebookCellEdit(Qe)?Qe.newCellMetadata?this.g(M,Qe.range.start,Qe.newCellMetadata,et):Qe.newNotebookMetadata?this.e(M,Qe.newNotebookMetadata,et):this.f(M,Qe.range,Qe.newCells,et):be.isSnippetTextEdit(Qe)?this.c.push({_type:se.Snippet,uri:M,range:Qe.range,edit:Qe.snippet,metadata:et}):this.c.push({_type:se.Text,uri:M,edit:Qe,metadata:et})}else{for(let De=0;De<this.c.length;De++){const Qe=this.c[De];switch(Qe._type){case se.Text:case se.Snippet:case se.Cell:case se.CellReplace:Qe.uri.toString()===M.toString()&&(this.c[De]=void 0);break}}(0,w.$Kb)(this.c)}}get(M){const ie=[];for(const De of this.c)De._type===se.Text&&De.uri.toString()===M.toString()&&ie.push(De.edit);return ie}entries(){const M=new O.$Cc;for(const ie of this.c)if(ie._type===se.Text){let De=M.get(ie.uri);De||(De=[ie.uri,[]],M.set(ie.uri,De)),De[1].push(ie.edit)}return[...M.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.$DN=Ie,e.$DN=Ie=He([g],Ie);let Ue=t=class{static isSnippetString(M){return M instanceof t?!0:M?typeof M.value=="string":!1}static c(M){return M.replace(/\$|}|\\/g,"\\$&")}constructor(M){this.e=1,this.value=M||""}appendText(M){return this.value+=t.c(M),this}appendTabstop(M=this.e++){return this.value+="$",this.value+=M,this}appendPlaceholder(M,ie=this.e++){if(typeof M=="function"){const De=new t;De.e=this.e,M(De),this.e=De.e,M=De.value}else M=t.c(M);return this.value+="${",this.value+=ie,this.value+=":",this.value+=M,this.value+="}",this}appendChoice(M,ie=this.e++){const De=M.map(Qe=>Qe.replaceAll(/[|\\,]/g,"\\$&")).join(",");return this.value+="${",this.value+=ie,this.value+="|",this.value+=De,this.value+="|}",this}appendVariable(M,ie){if(typeof ie=="function"){const De=new t;De.e=this.e,ie(De),this.e=De.e,ie=De.value}else typeof ie=="string"&&(ie=ie.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=M,ie&&(this.value+=":",this.value+=ie),this.value+="}",this}};e.$EN=Ue,e.$EN=Ue=t=He([g],Ue);var Z;(function(j){j[j.Unnecessary=1]="Unnecessary",j[j.Deprecated=2]="Deprecated"})(Z||(e.DiagnosticTag=Z={}));var V;(function(j){j[j.Hint=3]="Hint",j[j.Information=2]="Information",j[j.Warning=1]="Warning",j[j.Error=0]="Error"})(V||(e.DiagnosticSeverity=V={}));let _=c=class{static isLocation(M){return M instanceof c?!0:M?G.isRange(M.range)&&a.URI.isUri(M.uri):!1}constructor(M,ie){if(this.uri=M,ie)if(G.isRange(ie))this.range=G.of(ie);else if(B.isPosition(ie))this.range=new G(ie,ie);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.$FN=_,e.$FN=_=c=He([g],_);let ye=class{static is(M){return M?typeof M.message=="string"&&M.location&&G.isRange(M.location.range)&&a.URI.isUri(M.location.uri):!1}constructor(M,ie){this.location=M,this.message=ie}static isEqual(M,ie){return M===ie?!0:!M||!ie?!1:M.message===ie.message&&M.location.range.isEqual(ie.location.range)&&M.location.uri.toString()===ie.location.uri.toString()}};e.$GN=ye,e.$GN=ye=He([g],ye);let ae=class{constructor(M,ie,De=V.Error){if(!G.isRange(M))throw new TypeError("range must be set");if(!ie)throw new TypeError("message must be set");this.range=M,this.message=ie,this.severity=De}toJSON(){return{severity:V[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(M,ie){return M===ie?!0:!M||!ie?!1:M.message===ie.message&&M.severity===ie.severity&&M.code===ie.code&&M.severity===ie.severity&&M.source===ie.source&&M.range.isEqual(ie.range)&&(0,w.$wb)(M.tags,ie.tags)&&(0,w.$wb)(M.relatedInformation,ie.relatedInformation,ye.isEqual)}};e.$HN=ae,e.$HN=ae=He([g],ae);let we=class{constructor(M,ie){if(!M)throw new Error("Illegal argument, contents must be defined");Array.isArray(M)?this.contents=M:this.contents=[M],this.range=ie}};e.$IN=we,e.$IN=we=He([g],we);let he=class extends we{constructor(M,ie,De,Qe){super(M,ie),this.canIncreaseHover=De,this.canDecreaseHover=Qe}};e.$JN=he,e.$JN=he=He([g],he);var X;(function(j){j[j.Increase=0]="Increase",j[j.Decrease=1]="Decrease"})(X||(e.HoverVerbosityAction=X={}));var Y;(function(j){j[j.Text=0]="Text",j[j.Read=1]="Read",j[j.Write=2]="Write"})(Y||(e.DocumentHighlightKind=Y={}));let pe=class{constructor(M,ie=Y.Text){this.range=M,this.kind=ie}toJSON(){return{range:this.range,kind:Y[this.kind]}}};e.$KN=pe,e.$KN=pe=He([g],pe);let $e=class{constructor(M,ie){this.uri=M,this.highlights=ie}toJSON(){return{uri:this.uri,highlights:this.highlights.map(M=>M.toJSON())}}};e.$LN=$e,e.$LN=$e=He([g],$e);var Te;(function(j){j[j.File=0]="File",j[j.Module=1]="Module",j[j.Namespace=2]="Namespace",j[j.Package=3]="Package",j[j.Class=4]="Class",j[j.Method=5]="Method",j[j.Property=6]="Property",j[j.Field=7]="Field",j[j.Constructor=8]="Constructor",j[j.Enum=9]="Enum",j[j.Interface=10]="Interface",j[j.Function=11]="Function",j[j.Variable=12]="Variable",j[j.Constant=13]="Constant",j[j.String=14]="String",j[j.Number=15]="Number",j[j.Boolean=16]="Boolean",j[j.Array=17]="Array",j[j.Object=18]="Object",j[j.Key=19]="Key",j[j.Null=20]="Null",j[j.EnumMember=21]="EnumMember",j[j.Struct=22]="Struct",j[j.Event=23]="Event",j[j.Operator=24]="Operator",j[j.TypeParameter=25]="TypeParameter"})(Te||(e.SymbolKind=Te={}));var ze;(function(j){j[j.Deprecated=1]="Deprecated"})(ze||(e.SymbolTag=ze={}));let Se=l=class{static validate(M){if(!M.name)throw new Error("name must not be falsy")}constructor(M,ie,De,Qe,et){this.name=M,this.kind=ie,this.containerName=et,typeof De=="string"&&(this.containerName=De),Qe instanceof _?this.location=Qe:De instanceof G&&(this.location=new _(Qe,De)),l.validate(this)}toJSON(){return{name:this.name,kind:Te[this.kind],location:this.location,containerName:this.containerName}}};e.$MN=Se,e.$MN=Se=l=He([g],Se);let Re=m=class{static validate(M){if(!M.name)throw new Error("name must not be falsy");if(!M.range.contains(M.selectionRange))throw new Error("selectionRange must be contained in fullRange");M.children?.forEach(m.validate)}constructor(M,ie,De,Qe,et){this.name=M,this.detail=ie,this.kind=De,this.range=Qe,this.selectionRange=et,this.children=[],m.validate(this)}};e.$NN=Re,e.$NN=Re=m=He([g],Re);var Oe;(function(j){j[j.Invoke=1]="Invoke",j[j.Automatic=2]="Automatic"})(Oe||(e.CodeActionTriggerKind=Oe={}));let z=class{constructor(M,ie){this.title=M,this.kind=ie}};e.$ON=z,e.$ON=z=He([g],z);let U=class{static{f=this}static{this.c="."}constructor(M){this.value=M}append(M){return new f(this.value?this.value+f.c+M:M)}intersects(M){return this.contains(M)||M.contains(this)}contains(M){return this.value===M.value||M.value.startsWith(this.value+f.c)}};e.$PN=U,e.$PN=U=f=He([g],U),U.Empty=new U(""),U.QuickFix=U.Empty.append("quickfix"),U.Refactor=U.Empty.append("refactor"),U.RefactorExtract=U.Refactor.append("extract"),U.RefactorInline=U.Refactor.append("inline"),U.RefactorMove=U.Refactor.append("move"),U.RefactorRewrite=U.Refactor.append("rewrite"),U.Source=U.Empty.append("source"),U.SourceOrganizeImports=U.Source.append("organizeImports"),U.SourceFixAll=U.Source.append("fixAll"),U.Notebook=U.Empty.append("notebook");let K=class{constructor(M,ie){if(this.range=M,this.parent=ie,ie&&!ie.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.$QN=K,e.$QN=K=He([g],K);class Q{constructor(M,ie,De,Qe,et,dt){this.kind=M,this.name=ie,this.detail=De,this.uri=Qe,this.range=et,this.selectionRange=dt}}e.$RN=Q;class ne{constructor(M,ie){this.fromRanges=ie,this.from=M}}e.$SN=ne;class fe{constructor(M,ie){this.fromRanges=ie,this.to=M}}e.$TN=fe;var Ae;(function(j){j[j.Information=0]="Information",j[j.Warning=1]="Warning",j[j.Error=2]="Error"})(Ae||(e.LanguageStatusSeverity=Ae={}));let je=class{constructor(M,ie){this.range=M,this.command=ie}get isResolved(){return!!this.command}};e.$UN=je,e.$UN=je=He([g],je);let Ke=$=class{#e;static isMarkdownString(M){return M instanceof $?!0:M&&M.appendCodeblock&&M.appendMarkdown&&M.appendText&&M.value!==void 0}constructor(M,ie=!1){this.#e=new k.$3k(M,{supportThemeIcons:ie})}get value(){return this.#e.value}set value(M){this.#e.value=M}get isTrusted(){return this.#e.isTrusted}set isTrusted(M){this.#e.isTrusted=M}get supportThemeIcons(){return this.#e.supportThemeIcons}set supportThemeIcons(M){this.#e.supportThemeIcons=M}get supportHtml(){return this.#e.supportHtml}set supportHtml(M){this.#e.supportHtml=M}get baseUri(){return this.#e.baseUri}set baseUri(M){this.#e.baseUri=M}appendText(M){return this.#e.appendText(M),this}appendMarkdown(M){return this.#e.appendMarkdown(M),this}appendCodeblock(M,ie){return this.#e.appendCodeblock(ie??"",M),this}};e.$VN=Ke,e.$VN=Ke=$=He([g],Ke);let _e=class{constructor(M,ie){this.label=M,this.documentation=ie}};e.$WN=_e,e.$WN=_e=He([g],_e);let it=class{constructor(M,ie){this.label=M,this.documentation=ie,this.parameters=[]}};e.$XN=it,e.$XN=it=He([g],it);let nt=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.$YN=nt,e.$YN=nt=He([g],nt);var tt;(function(j){j[j.Invoke=1]="Invoke",j[j.TriggerCharacter=2]="TriggerCharacter",j[j.ContentChange=3]="ContentChange"})(tt||(e.SignatureHelpTriggerKind=tt={}));var rt;(function(j){j[j.Type=1]="Type",j[j.Parameter=2]="Parameter"})(rt||(e.InlayHintKind=rt={}));let $t=class{constructor(M){this.value=M}};e.$ZN=$t,e.$ZN=$t=He([g],$t);let lt=class{constructor(M,ie,De){this.position=M,this.label=ie,this.kind=De}};e.$1N=lt,e.$1N=lt=He([g],lt);var st;(function(j){j[j.Invoke=0]="Invoke",j[j.TriggerCharacter=1]="TriggerCharacter",j[j.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(st||(e.CompletionTriggerKind=st={}));var ut;(function(j){j[j.Text=0]="Text",j[j.Method=1]="Method",j[j.Function=2]="Function",j[j.Constructor=3]="Constructor",j[j.Field=4]="Field",j[j.Variable=5]="Variable",j[j.Class=6]="Class",j[j.Interface=7]="Interface",j[j.Module=8]="Module",j[j.Property=9]="Property",j[j.Unit=10]="Unit",j[j.Value=11]="Value",j[j.Enum=12]="Enum",j[j.Keyword=13]="Keyword",j[j.Snippet=14]="Snippet",j[j.Color=15]="Color",j[j.File=16]="File",j[j.Reference=17]="Reference",j[j.Folder=18]="Folder",j[j.EnumMember=19]="EnumMember",j[j.Constant=20]="Constant",j[j.Struct=21]="Struct",j[j.Event=22]="Event",j[j.Operator=23]="Operator",j[j.TypeParameter=24]="TypeParameter",j[j.User=25]="User",j[j.Issue=26]="Issue"})(ut||(e.CompletionItemKind=ut={}));var ft;(function(j){j[j.Deprecated=1]="Deprecated"})(ft||(e.CompletionItemTag=ft={}));let mt=class{constructor(M,ie){this.label=M,this.kind=ie}toJSON(){return{label:this.label,kind:this.kind&&ut[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.$2N=mt,e.$2N=mt=He([g],mt);let We=class{constructor(M=[],ie=!1){this.items=M,this.isIncomplete=ie}};e.$3N=We,e.$3N=We=He([g],We);let Be=class{constructor(M,ie,De){this.insertText=M,this.range=ie,this.command=De}};e.$4N=Be,e.$4N=Be=He([g],Be);let H=class{constructor(M){this.commands=void 0,this.suppressSuggestions=void 0,this.items=M}};e.$5N=H,e.$5N=H=He([g],H);var x;(function(j){j[j.Unknown=0]="Unknown",j[j.Word=1]="Word",j[j.Line=2]="Line",j[j.Suggest=3]="Suggest"})(x||(e.PartialAcceptTriggerKind=x={}));var Ee;(function(j){j[j.Active=-1]="Active",j[j.Beside=-2]="Beside",j[j.One=1]="One",j[j.Two=2]="Two",j[j.Three=3]="Three",j[j.Four=4]="Four",j[j.Five=5]="Five",j[j.Six=6]="Six",j[j.Seven=7]="Seven",j[j.Eight=8]="Eight",j[j.Nine=9]="Nine"})(Ee||(e.ViewColumn=Ee={}));var Je;(function(j){j[j.Left=1]="Left",j[j.Right=2]="Right"})(Je||(e.StatusBarAlignment=Je={}));function xe(j,M){return`${y.$qn.toKey(j)}.${M}`}var ht;(function(j){j[j.Off=0]="Off",j[j.On=1]="On",j[j.Relative=2]="Relative",j[j.Interval=3]="Interval"})(ht||(e.TextEditorLineNumbersStyle=ht={}));var pt;(function(j){j[j.Manual=1]="Manual",j[j.AfterDelay=2]="AfterDelay",j[j.FocusOut=3]="FocusOut"})(pt||(e.TextDocumentSaveReason=pt={}));var Ft;(function(j){j[j.Default=0]="Default",j[j.InCenter=1]="InCenter",j[j.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",j[j.AtTop=3]="AtTop"})(Ft||(e.TextEditorRevealType=Ft={}));var Ut;(function(j){j[j.Keyboard=1]="Keyboard",j[j.Mouse=2]="Mouse",j[j.Command=3]="Command"})(Ut||(e.TextEditorSelectionChangeKind=Ut={}));var Zt;(function(j){j[j.Undo=1]="Undo",j[j.Redo=2]="Redo"})(Zt||(e.TextDocumentChangeReason=Zt={}));var di;(function(j){j[j.OpenOpen=0]="OpenOpen",j[j.ClosedClosed=1]="ClosedClosed",j[j.OpenClosed=2]="OpenClosed",j[j.ClosedOpen=3]="ClosedOpen"})(di||(e.DecorationRangeBehavior=di={})),function(j){function M(ie){switch(ie){case"keyboard":return j.Keyboard;case"mouse":return j.Mouse;case"api":return j.Command}}j.fromValue=M}(Ut||(e.TextEditorSelectionChangeKind=Ut={}));var Ye;(function(j){j[j.Other=0]="Other",j[j.Comment=1]="Comment",j[j.String=2]="String",j[j.RegEx=3]="RegEx"})(Ye||(e.SyntaxTokenType=Ye={})),function(j){function M(ie){switch(ie){case j.Other:return"other";case j.Comment:return"comment";case j.String:return"string";case j.RegEx:return"regex"}return"other"}j.toString=M}(Ye||(e.SyntaxTokenType=Ye={}));let Pt=class{constructor(M,ie){if(ie&&!a.URI.isUri(ie))throw(0,S.$9)("target");if(!G.isRange(M)||M.isEmpty)throw(0,S.$9)("range");this.range=M,this.target=ie}};e.$7N=Pt,e.$7N=Pt=He([g],Pt);let Gt=class{constructor(M,ie,De,Qe){this.red=M,this.green=ie,this.blue=De,this.alpha=Qe}};e.$8N=Gt,e.$8N=Gt=He([g],Gt);let Kt=class{constructor(M,ie){if(ie&&!(ie instanceof Gt))throw(0,S.$9)("color");if(!G.isRange(M)||M.isEmpty)throw(0,S.$9)("range");this.range=M,this.color=ie}};e.$9N=Kt,e.$9N=Kt=He([g],Kt);let gt=class{constructor(M){if(!M||typeof M!="string")throw(0,S.$9)("label");this.label=M}};e.$0N=gt,e.$0N=gt=He([g],gt);var vt;(function(j){j[j.RGB=0]="RGB",j[j.HEX=1]="HEX",j[j.HSL=2]="HSL"})(vt||(e.ColorFormat=vt={}));var ii;(function(j){j[j.Error=0]="Error",j[j.Warning=1]="Warning",j[j.Information=2]="Information"})(ii||(e.SourceControlInputBoxValidationType=ii={}));var Yt;(function(j){j[j.Unknown=0]="Unknown",j[j.Shutdown=1]="Shutdown",j[j.Process=2]="Process",j[j.User=3]="User",j[j.Extension=4]="Extension"})(Yt||(e.TerminalExitReason=Yt={}));var Wt;(function(j){j[j.Low=0]="Low",j[j.Medium=1]="Medium",j[j.High=2]="High"})(Wt||(e.TerminalShellExecutionCommandLineConfidence=Wt={}));class yt{constructor(M,ie,De){if(this.startIndex=M,this.length=ie,this.tooltip=De,typeof M!="number"||M<0)throw(0,S.$9)("startIndex");if(typeof ie!="number"||ie<1)throw(0,S.$9)("length");if(De!==void 0&&typeof De!="string")throw(0,S.$9)("tooltip")}}e.$$N=yt;class Ot{constructor(M){this.uri=M}}e.$_N=Ot;class ui{constructor(M){this.terminalCommand=M}}e.$aO=ui;var Vt;(function(j){j[j.Panel=1]="Panel",j[j.Editor=2]="Editor"})(Vt||(e.TerminalLocation=Vt={}));class Xe{constructor(M){if(this.options=M,typeof M!="object")throw(0,S.$9)("options")}}e.$bO=Xe;var xt;(function(j){j[j.Always=1]="Always",j[j.Silent=2]="Silent",j[j.Never=3]="Never"})(xt||(e.TaskRevealKind=xt={}));var ni;(function(j){j[j.Shared=1]="Shared",j[j.Dedicated=2]="Dedicated",j[j.New=3]="New"})(ni||(e.TaskPanelKind=ni={}));let li=class{static{I=this}static{this.Clean=new I("clean","Clean")}static{this.Build=new I("build","Build")}static{this.Rebuild=new I("rebuild","Rebuild")}static{this.Test=new I("test","Test")}static from(M){switch(M){case"clean":return I.Clean;case"build":return I.Build;case"rebuild":return I.Rebuild;case"test":return I.Test;default:return}}constructor(M,ie){if(this.label=ie,typeof M!="string"||typeof ie!="string")throw(0,S.$9)("name");this.c=M}get id(){return this.c}};e.$cO=li,e.$cO=li=I=He([g],li);function kt(j){let M="";for(let ie=0;ie<j.length;ie++)M+=j[ie].replace(/,/g,",,")+",";return M}let Lt=class{constructor(M,ie,De){if(typeof M!="string")throw(0,S.$9)("process");this.e=[],this.c=M,ie!==void 0&&(Array.isArray(ie)?(this.e=ie,this.f=De):this.f=ie)}get process(){return this.c}set process(M){if(typeof M!="string")throw(0,S.$9)("process");this.c=M}get args(){return this.e}set args(M){Array.isArray(M)||(M=[]),this.e=M}get options(){return this.f}set options(M){this.f=M}computeId(){const M=[];if(M.push("process"),this.c!==void 0&&M.push(this.c),this.e&&this.e.length>0)for(const ie of this.e)M.push(ie);return kt(M)}};e.$dO=Lt,e.$dO=Lt=He([g],Lt);let At=class{constructor(M,ie,De){if(this.f=[],Array.isArray(ie)){if(!M)throw(0,S.$9)("command can't be undefined or null");if(typeof M!="string"&&typeof M.value!="string")throw(0,S.$9)("command");this.e=M,this.f=ie,this.g=De}else{if(typeof M!="string")throw(0,S.$9)("commandLine");this.c=M,this.g=ie}}get commandLine(){return this.c}set commandLine(M){if(typeof M!="string")throw(0,S.$9)("commandLine");this.c=M}get command(){return this.e?this.e:""}set command(M){if(typeof M!="string"&&typeof M.value!="string")throw(0,S.$9)("command");this.e=M}get args(){return this.f}set args(M){this.f=M||[]}get options(){return this.g}set options(M){this.g=M}computeId(){const M=[];if(M.push("shell"),this.c!==void 0&&M.push(this.c),this.e!==void 0&&M.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const ie of this.f)M.push(typeof ie=="string"?ie:ie.value);return kt(M)}};e.$eO=At,e.$eO=At=He([g],At);var zt;(function(j){j[j.Escape=1]="Escape",j[j.Strong=2]="Strong",j[j.Weak=3]="Weak"})(zt||(e.ShellQuoting=zt={}));var ri;(function(j){j[j.Global=1]="Global",j[j.Workspace=2]="Workspace"})(ri||(e.TaskScope=ri={}));class _t{constructor(M){this.c=M}computeId(){return"customExecution"+(0,R.$2g)()}set callback(M){this.c=M}get callback(){return this.c}}e.$fO=_t;let si=class{static{D=this}static{this.c="customExecution"}static{this.e="process"}static{this.f="shell"}static{this.g="$empty"}constructor(M,ie,De,Qe,et,dt){this.k=!1,this.l=this.definition=M;let Et;typeof ie=="string"?(this.o=this.name=ie,this.w=this.source=De,this.execution=Qe,Et=et,this.k=!0):ie===ri.Global||ie===ri.Workspace?(this.target=ie,this.o=this.name=De,this.w=this.source=Qe,this.execution=et,Et=dt):(this.target=ie,this.o=this.name=De,this.w=this.source=Qe,this.execution=et,Et=dt),typeof Et=="string"?(this.r=[Et],this.t=!0):Array.isArray(Et)?(this.r=Et,this.t=!0):(this.r=[],this.t=!1),this.u=!1,this.y=Object.create(null),this.z=Object.create(null)}get _id(){return this.j}set _id(M){this.j=M}get _deprecated(){return this.k}B(){this.j!==void 0&&(this.j=void 0,this.m=void 0,this.C())}C(){this.q instanceof Lt?this.l={type:D.e,id:this.q.computeId()}:this.q instanceof At?this.l={type:D.f,id:this.q.computeId()}:this.q instanceof _t?this.l={type:D.c,id:this.q.computeId()}:this.l={type:D.g,id:(0,R.$2g)()}}get definition(){return this.l}set definition(M){if(M==null)throw(0,S.$9)("Kind can't be undefined or null");this.B(),this.l=M}get scope(){return this.m}set target(M){this.B(),this.m=M}get name(){return this.o}set name(M){if(typeof M!="string")throw(0,S.$9)("name");this.B(),this.o=M}get execution(){return this.q}set execution(M){M===null&&(M=void 0),this.B(),this.q=M;const ie=this.l.type;(D.g===ie||D.e===ie||D.f===ie||D.c===ie)&&this.C()}get problemMatchers(){return this.r}set problemMatchers(M){if(Array.isArray(M))this.B(),this.r=M,this.t=!0;else{this.B(),this.r=[],this.t=!1;return}}get hasDefinedMatchers(){return this.t}get isBackground(){return this.u}set isBackground(M){M!==!0&&M!==!1&&(M=!1),this.B(),this.u=M}get source(){return this.w}set source(M){if(typeof M!="string"||M.length===0)throw(0,S.$9)("source must be a string of length > 0");this.B(),this.w=M}get group(){return this.x}set group(M){M===null&&(M=void 0),this.B(),this.x=M}get detail(){return this.A}set detail(M){M===null&&(M=void 0),this.A=M}get presentationOptions(){return this.y}set presentationOptions(M){M==null&&(M=Object.create(null)),this.B(),this.y=M}get runOptions(){return this.z}set runOptions(M){M==null&&(M=Object.create(null)),this.B(),this.z=M}};e.$gO=si,e.$gO=si=D=He([g],si);var jt;(function(j){j[j.SourceControl=1]="SourceControl",j[j.Window=10]="Window",j[j.Notification=15]="Notification"})(jt||(e.ProgressLocation=jt={}));var Ht;(function(j){function M(ie){const De=ie;return(0,p.$jg)(De.value)?De.tooltip&&!(0,p.$fg)(De.tooltip)?(console.log("INVALID view badge, invalid tooltip",De.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",De.value),!1)}j.isViewBadge=M})(Ht||(e.ViewBadge=Ht={}));let oi=v=class{static isTreeItem(M,ie){const De=M;if(De.checkboxState!==void 0){const Qe=(0,p.$jg)(De.checkboxState)?De.checkboxState:(0,p.$hg)(De.checkboxState)&&(0,p.$jg)(De.checkboxState.state)?De.checkboxState.state:void 0,et=!(0,p.$jg)(De.checkboxState)&&(0,p.$hg)(De.checkboxState)?De.checkboxState.tooltip:void 0;if(Qe===void 0||Qe!==St.Checked&&Qe!==St.Unchecked||et!==void 0&&!(0,p.$fg)(et))return console.log("INVALID tree item, invalid checkboxState",De.checkboxState),!1}if(M instanceof v)return!0;if(De.label!==void 0&&!(0,p.$fg)(De.label)&&!De.label?.label)return console.log("INVALID tree item, invalid label",De.label),!1;if(De.id!==void 0&&!(0,p.$fg)(De.id))return console.log("INVALID tree item, invalid id",De.id),!1;if(De.iconPath!==void 0&&!(0,p.$fg)(De.iconPath)&&!a.URI.isUri(De.iconPath)&&(!De.iconPath||!(0,p.$fg)(De.iconPath.id))){const Qe=De.iconPath;if(!Qe||!(0,p.$fg)(Qe.light)&&!a.URI.isUri(Qe.light)&&!(0,p.$fg)(Qe.dark)&&!a.URI.isUri(Qe.dark))return console.log("INVALID tree item, invalid iconPath",De.iconPath),!1}return De.description!==void 0&&!(0,p.$fg)(De.description)&&typeof De.description!="boolean"?(console.log("INVALID tree item, invalid description",De.description),!1):De.resourceUri!==void 0&&!a.URI.isUri(De.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",De.resourceUri),!1):De.tooltip!==void 0&&!(0,p.$fg)(De.tooltip)&&!(De.tooltip instanceof Ke)?(console.log("INVALID tree item, invalid tooltip",De.tooltip),!1):De.command!==void 0&&!De.command.command?(console.log("INVALID tree item, invalid command",De.command),!1):De.collapsibleState!==void 0&&De.collapsibleState<Rt.None&&De.collapsibleState>Rt.Expanded?(console.log("INVALID tree item, invalid collapsibleState",De.collapsibleState),!1):De.contextValue!==void 0&&!(0,p.$fg)(De.contextValue)?(console.log("INVALID tree item, invalid contextValue",De.contextValue),!1):De.accessibilityInformation!==void 0&&!De.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",De.accessibilityInformation),!1):!0}constructor(M,ie=Rt.None){this.collapsibleState=ie,a.URI.isUri(M)?this.resourceUri=M:this.label=M}};e.$hO=oi,e.$hO=oi=v=He([g],oi);var Rt;(function(j){j[j.None=0]="None",j[j.Collapsed=1]="Collapsed",j[j.Expanded=2]="Expanded"})(Rt||(e.TreeItemCollapsibleState=Rt={}));var St;(function(j){j[j.Unchecked=0]="Unchecked",j[j.Checked=1]="Checked"})(St||(e.TreeItemCheckboxState=St={}));let wt=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(M){this.value=M}};e.$iO=wt,e.$iO=wt=He([g],wt);class ei extends wt{}e.$jO=ei;class Ct extends ei{#e;constructor(M){super(""),this.#e=M}asFile(){return this.#e}}e.$kO=Ct;class hi{constructor(M,ie,De,Qe){this.name=M,this.uri=ie,this._itemId=De,this.c=Qe}data(){return this.c()}}e.$lO=hi;let qt=class{#e=new Map;constructor(M){for(const[ie,De]of M??[]){const Qe=this.#e.get(this.#t(ie));Qe?Qe.push(De):this.#e.set(this.#t(ie),[De])}}get(M){return this.#e.get(this.#t(M))?.[0]}set(M,ie){this.#e.set(this.#t(M),[ie])}forEach(M,ie){for(const[De,Qe]of this.#e)for(const et of Qe)M.call(ie,et,De,this)}*[Symbol.iterator](){for(const[M,ie]of this.#e)for(const De of ie)yield[M,De]}#t(M){return M.toLowerCase()}};e.$mO=qt,e.$mO=qt=He([g],qt);let bi=class{constructor(M,ie,De){this.insertText=M,this.title=ie,this.kind=De}};e.$nO=bi,e.$nO=bi=He([g],bi);var wi;(function(j){j[j.Automatic=0]="Automatic",j[j.PasteAs=1]="PasteAs"})(wi||(e.DocumentPasteTriggerKind=wi={}));class fi{static{this.c="."}constructor(M){this.value=M}append(...M){return new fi((this.value?[this.value,...M]:M).join(fi.c))}intersects(M){return this.contains(M)||M.contains(this)}contains(M){return this.value===M.value||M.value.startsWith(this.value+fi.c)}}e.$oO=fi,fi.Empty=new fi("");class Bt{constructor(M,ie,De){this.title=ie,this.insertText=M,this.kind=De}}e.$pO=Bt;let ai=class{constructor(M,ie){this.id=M,this.color=ie}static isThemeIcon(M){return typeof M.id!="string"?(console.log("INVALID ThemeIcon, invalid id",M.id),!1):!0}};e.$qO=ai,e.$qO=ai=He([g],ai),ai.File=new ai("file"),ai.Folder=new ai("folder");let Ci=class{constructor(M){this.id=M}};e.$rO=Ci,e.$rO=Ci=He([g],Ci);var Nt;(function(j){j[j.Global=1]="Global",j[j.Workspace=2]="Workspace",j[j.WorkspaceFolder=3]="WorkspaceFolder"})(Nt||(e.ConfigurationTarget=Nt={}));let Ei=class{get base(){return this.c}set base(M){this.c=M,this.e=a.URI.file(M)}get baseUri(){return this.e}set baseUri(M){this.e=M,this.c=M.fsPath}constructor(M,ie){if(typeof M!="string"&&(!M||!a.URI.isUri(M)&&!a.URI.isUri(M.uri)))throw(0,S.$9)("base");if(typeof ie!="string")throw(0,S.$9)("pattern");typeof M=="string"?this.baseUri=a.URI.file(M):a.URI.isUri(M)?this.baseUri=M:this.baseUri=M.uri,this.pattern=ie}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.$sO=Ei,e.$sO=Ei=He([g],Ei);const Ii=new WeakMap;function Di(j,M){Ii.set(j,M)}let mi=class{constructor(M,ie,De,Qe,et){this.enabled=typeof M=="boolean"?M:!0,typeof ie=="string"&&(this.condition=ie),typeof De=="string"&&(this.hitCondition=De),typeof Qe=="string"&&(this.logMessage=Qe),typeof et=="string"&&(this.mode=et)}get id(){return this.c||(this.c=Ii.get(this)??(0,R.$2g)()),this.c}};e.$uO=mi,e.$uO=mi=He([g],mi);let Pi=class extends mi{constructor(M,ie,De,Qe,et,dt){if(super(ie,De,Qe,et,dt),M===null)throw(0,S.$9)("location");this.location=M}};e.$vO=Pi,e.$vO=Pi=He([g],Pi);let ve=class extends mi{constructor(M,ie,De,Qe,et,dt){super(ie,De,Qe,et,dt),this.functionName=M}};e.$wO=ve,e.$wO=ve=He([g],ve);let Ne=class extends mi{constructor(M,ie,De,Qe,et,dt,Et,Xt){if(super(Qe,et,dt,Et,Xt),!ie)throw(0,S.$9)("dataId");this.label=M,this.dataId=ie,this.canPersist=De}};e.$xO=Ne,e.$xO=Ne=He([g],Ne);let de=class{constructor(M,ie,De){this.command=M,this.args=ie||[],this.options=De}};e.$yO=de,e.$yO=de=He([g],de);let J=class{constructor(M,ie){this.port=M,this.host=ie}};e.$zO=J,e.$zO=J=He([g],J);let Pe=class{constructor(M){this.path=M}};e.$AO=Pe,e.$AO=Pe=He([g],Pe);let Me=class{constructor(M){this.implementation=M}};e.$BO=Me,e.$BO=Me=He([g],Me);class Ze{constructor(M,ie,De){this.session=M,this.threadId=ie,this.frameId=De}}e.$CO=Ze;class Ge{constructor(M,ie){this.session=M,this.threadId=ie}}e.$DO=Ge;let ct=class{constructor(M,ie){this.range=M,this.expression=ie}};e.$EO=ct,e.$EO=ct=He([g],ct);var It;(function(j){j[j.Invoke=0]="Invoke",j[j.Automatic=1]="Automatic"})(It||(e.InlineCompletionTriggerKind=It={}));let Qt=class{constructor(M,ie){this.range=M,this.text=ie}};e.$FO=Qt,e.$FO=Qt=He([g],Qt);let ci=class{constructor(M,ie,De=!0){this.range=M,this.variableName=ie,this.caseSensitiveLookup=De}};e.$GO=ci,e.$GO=ci=He([g],ci);let Mt=class{constructor(M,ie){this.range=M,this.expression=ie}};e.$HO=Mt,e.$HO=Mt=He([g],Mt);let Jt=class{constructor(M,ie){this.frameId=M,this.stoppedLocation=ie}};e.$IO=Jt,e.$IO=Jt=He([g],Jt);var Yi;(function(j){j[j.AIGenerated=1]="AIGenerated"})(Yi||(e.NewSymbolNameTag=Yi={}));var Wi;(function(j){j[j.Invoke=0]="Invoke",j[j.Automatic=1]="Automatic"})(Wi||(e.NewSymbolNameTriggerKind=Wi={}));class $n{constructor(M,ie){this.newSymbolName=M,this.tags=ie}}e.$JO=$n;var Fi;(function(j){j[j.Changed=1]="Changed",j[j.Created=2]="Created",j[j.Deleted=3]="Deleted"})(Fi||(e.FileChangeType=Fi={}));let Ni=C=class extends Error{static FileExists(M){return new C(M,u.FileSystemProviderErrorCode.FileExists,C.FileExists)}static FileNotFound(M){return new C(M,u.FileSystemProviderErrorCode.FileNotFound,C.FileNotFound)}static FileNotADirectory(M){return new C(M,u.FileSystemProviderErrorCode.FileNotADirectory,C.FileNotADirectory)}static FileIsADirectory(M){return new C(M,u.FileSystemProviderErrorCode.FileIsADirectory,C.FileIsADirectory)}static NoPermissions(M){return new C(M,u.FileSystemProviderErrorCode.NoPermissions,C.NoPermissions)}static Unavailable(M){return new C(M,u.FileSystemProviderErrorCode.Unavailable,C.Unavailable)}constructor(M,ie=u.FileSystemProviderErrorCode.Unknown,De){super(a.URI.isUri(M)?M.toString(!0):M),this.code=De?.name??"Unknown",(0,u.$ol)(this,ie),Object.setPrototypeOf(this,C.prototype),typeof Error.captureStackTrace=="function"&&typeof De=="function"&&Error.captureStackTrace(this,De)}};e.$KO=Ni,e.$KO=Ni=C=He([g],Ni);let Vi=class{constructor(M,ie,De){this.start=M,this.end=ie,this.kind=De}};e.$LO=Vi,e.$LO=Vi=He([g],Vi);var xi;(function(j){j[j.Comment=1]="Comment",j[j.Imports=2]="Imports",j[j.Region=3]="Region"})(xi||(e.FoldingRangeKind=xi={}));var Si;(function(j){j[j.Collapsed=0]="Collapsed",j[j.Expanded=1]="Expanded"})(Si||(e.CommentThreadCollapsibleState=Si={}));var _i;(function(j){j[j.Editing=0]="Editing",j[j.Preview=1]="Preview"})(_i||(e.CommentMode=_i={}));var en;(function(j){j[j.Published=0]="Published",j[j.Draft=1]="Draft"})(en||(e.CommentState=en={}));var Li;(function(j){j[j.Unresolved=0]="Unresolved",j[j.Resolved=1]="Resolved"})(Li||(e.CommentThreadState=Li={}));var tn;(function(j){j[j.Current=0]="Current",j[j.Outdated=1]="Outdated"})(tn||(e.CommentThreadApplicability=tn={}));class qi{constructor(M,ie=[]){this.tokenTypes=M,this.tokenModifiers=ie}}e.$MO=qi;function nn(j){return typeof j>"u"||(0,p.$gg)(j)}class Gi{constructor(M){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.j=0,this.k=new Map,this.l=new Map,this.m=!1,M){this.m=!0;for(let ie=0,De=M.tokenTypes.length;ie<De;ie++)this.k.set(M.tokenTypes[ie],ie);for(let ie=0,De=M.tokenModifiers.length;ie<De;ie++)this.l.set(M.tokenModifiers[ie],ie)}}push(M,ie,De,Qe,et){if(typeof M=="number"&&typeof ie=="number"&&typeof De=="number"&&typeof Qe=="number"&&(typeof et=="number"||typeof et>"u"))return typeof et>"u"&&(et=0),this.q(M,ie,De,Qe,et);if(G.isRange(M)&&typeof ie=="string"&&nn(De))return this.o(M,ie,De);throw(0,S.$9)()}o(M,ie,De){if(!this.m)throw new Error("Legend must be provided in constructor");if(M.start.line!==M.end.line)throw new Error("`range` cannot span multiple lines");if(!this.k.has(ie))throw new Error("`tokenType` is not in the provided legend");const Qe=M.start.line,et=M.start.character,dt=M.end.character-M.start.character,Et=this.k.get(ie);let Xt=0;if(De)for(const pi of De){if(!this.l.has(pi))throw new Error("`tokenModifier` is not in the provided legend");const $i=this.l.get(pi);Xt|=1<<$i>>>0}this.q(Qe,et,dt,Et,Xt)}q(M,ie,De,Qe,et){if(this.f&&(M<this.c||M===this.c&&ie<this.e)){this.f=!1;const Xt=this.g.length/5|0;let pi=0,$i=0;for(let yi=0;yi<Xt;yi++){let ki=this.g[5*yi],Xi=this.g[5*yi+1];ki===0?(ki=pi,Xi+=$i):ki+=pi,this.g[5*yi]=ki,this.g[5*yi+1]=Xi,pi=ki,$i=Xi}}let dt=M,Et=ie;this.f&&this.j>0&&(dt-=this.c,dt===0&&(Et-=this.e)),this.g[this.j++]=dt,this.g[this.j++]=Et,this.g[this.j++]=De,this.g[this.j++]=Qe,this.g[this.j++]=et,this.c=M,this.e=ie}static r(M){const ie=[],De=M.length/5|0;for(let Et=0;Et<De;Et++)ie[Et]=Et;ie.sort((Et,Xt)=>{const pi=M[5*Et],$i=M[5*Xt];if(pi===$i){const yi=M[5*Et+1],ki=M[5*Xt+1];return yi-ki}return pi-$i});const Qe=new Uint32Array(M.length);let et=0,dt=0;for(let Et=0;Et<De;Et++){const Xt=5*ie[Et],pi=M[Xt+0],$i=M[Xt+1],yi=M[Xt+2],ki=M[Xt+3],Xi=M[Xt+4],jn=pi-et,kr=jn===0?$i-dt:$i,Zi=5*Et;Qe[Zi+0]=jn,Qe[Zi+1]=kr,Qe[Zi+2]=yi,Qe[Zi+3]=ki,Qe[Zi+4]=Xi,et=pi,dt=$i}return Qe}build(M){return this.f?new Mi(new Uint32Array(this.g),M):new Mi(Gi.r(this.g),M)}}e.$NO=Gi;class Mi{constructor(M,ie){this.resultId=ie,this.data=M}}e.$OO=Mi;class bn{constructor(M,ie,De){this.start=M,this.deleteCount=ie,this.data=De}}e.$PO=bn;class Ti{constructor(M,ie){this.resultId=ie,this.edits=M}}e.$QO=Ti;var rn;(function(j){j[j.Separate=0]="Separate",j[j.MergeWithParent=1]="MergeWithParent"})(rn||(e.DebugConsoleMode=rn={}));class wn{constructor(M){this.name=M}}e.$RO=wn;let Ki=class{static{this.Back={iconPath:new ai("arrow-left")}}constructor(){}};e.$SO=Ki,e.$SO=Ki=He([g],Ki);var Ui;(function(j){j[j.Separator=-1]="Separator",j[j.Default=0]="Default"})(Ui||(e.QuickPickItemKind=Ui={}));var Hi;(function(j){j[j.Info=1]="Info",j[j.Warning=2]="Warning",j[j.Error=3]="Error"})(Hi||(e.InputBoxValidationSeverity=Hi={}));var Le;(function(j){j[j.UI=1]="UI",j[j.Workspace=2]="Workspace"})(Le||(e.ExtensionKind=Le={}));class vi{static validate(M){if(typeof M.badge=="string"){let ie=(0,T.$Qf)(M.badge,0);if(ie<M.badge.length&&(ie+=(0,T.$Qf)(M.badge,ie)),M.badge.length>ie)throw new Error("The 'badge'-property must be undefined or a short character")}else if(M.badge&&!ai.isThemeIcon(M.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!M.color&&!M.badge&&!M.tooltip)throw new Error("The decoration is empty");return!0}constructor(M,ie,De){this.badge=M,this.tooltip=ie,this.color=De}}e.$TO=vi;let zi=class{constructor(M){this.kind=M}};e.$UO=zi,e.$UO=zi=He([g],zi);var ot;(function(j){j[j.Light=1]="Light",j[j.Dark=2]="Dark",j[j.HighContrast=3]="HighContrast",j[j.HighContrastLight=4]="HighContrastLight"})(ot||(e.ColorThemeKind=ot={}));class bt{static isNotebookRange(M){return M instanceof bt?!0:M?typeof M.start=="number"&&typeof M.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(M,ie){if(M<0)throw(0,S.$9)("start must be positive");if(ie<0)throw(0,S.$9)("end must be positive");M<=ie?(this.c=M,this.e=ie):(this.c=ie,this.e=M)}with(M){let ie=this.c,De=this.e;return M.start!==void 0&&(ie=M.start),M.end!==void 0&&(De=M.end),ie===this.c&&De===this.e?this:new bt(ie,De)}}e.$VO=bt;class ji{static validate(M){if(typeof M.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof M.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof M.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(M){return Array.isArray(M)&&M.every(ie=>ji.isNotebookCellData(ie))}static isNotebookCellData(M){return!0}constructor(M,ie,De,Qe,et,dt,Et){this.kind=M,this.value=ie,this.languageId=De,this.mime=Qe,this.outputs=et??[],this.metadata=dt,this.executionSummary=Et,ji.validate(this)}}e.$WO=ji;class vn{constructor(M){this.cells=M}}e.$XO=vn;class gi{static isNotebookCellOutputItem(M){return M instanceof gi?!0:M?typeof M.mime=="string"&&M.data instanceof Uint8Array:!1}static error(M){const ie={name:M.name,message:M.message,stack:M.stack};return gi.json(ie,"application/vnd.code.notebook.error")}static stdout(M){return gi.text(M,"application/vnd.code.notebook.stdout")}static stderr(M){return gi.text(M,"application/vnd.code.notebook.stderr")}static bytes(M,ie="application/octet-stream"){return new gi(M,ie)}static#e=new TextEncoder;static text(M,ie=A.$4s.text){const De=gi.#e.encode(String(M));return new gi(De,ie)}static json(M,ie="text/x-json"){const De=JSON.stringify(M,void 0,"	");return gi.text(De,ie)}constructor(M,ie){this.data=M,this.mime=ie;const De=(0,A.$8s)(ie,!0);if(!De)throw new Error(`INVALID mime type: ${ie}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=De}}e.$YO=gi;class Bi{static isNotebookCellOutput(M){return M instanceof Bi?!0:!M||typeof M!="object"?!1:typeof M.id=="string"&&Array.isArray(M.items)}static ensureUniqueMimeTypes(M,ie=!1){const De=new Set,Qe=new Set;for(let et=0;et<M.length;et++){const dt=M[et],Et=(0,A.$8s)(dt.mime);if(!De.has(Et)||(0,d.$wL)(Et)){De.add(Et);continue}Qe.add(et),ie&&console.warn(`DUPLICATED mime type '${dt.mime}' will be dropped`)}return Qe.size===0?M:M.filter((et,dt)=>!Qe.has(dt))}constructor(M,ie,De){this.items=Bi.ensureUniqueMimeTypes(M,!0),typeof ie=="string"?(this.id=ie,this.metadata=De):(this.id=(0,R.$2g)(),this.metadata=ie??De)}}e.$ZO=Bi;var Oi;(function(j){j[j.Markup=1]="Markup",j[j.Code=2]="Code"})(Oi||(e.NotebookCellKind=Oi={}));var sn;(function(j){j[j.Idle=1]="Idle",j[j.Pending=2]="Pending",j[j.Executing=3]="Executing"})(sn||(e.NotebookCellExecutionState=sn={}));var on;(function(j){j[j.Left=1]="Left",j[j.Right=2]="Right"})(on||(e.NotebookCellStatusBarAlignment=on={}));var an;(function(j){j[j.Default=0]="Default",j[j.InCenter=1]="InCenter",j[j.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",j[j.AtTop=3]="AtTop"})(an||(e.NotebookEditorRevealType=an={}));class cn{constructor(M,ie){this.text=M,this.alignment=ie}}e.$1O=cn;var un;(function(j){j[j.Default=1]="Default",j[j.Preferred=2]="Preferred"})(un||(e.NotebookControllerAffinity=un={}));var ln;(function(j){j[j.Default=1]="Default",j[j.Preferred=2]="Preferred",j[j.Hidden=-1]="Hidden"})(ln||(e.NotebookControllerAffinity2=ln={}));class yn{constructor(M,ie=[]){this.uri=M,this.provides=(0,w.$4b)(ie)}}e.$2O=yn;class En{constructor(M){this.label=M}}e.$3O=En;var hn;(function(j){j[j.Named=1]="Named",j[j.Indexed=2]="Indexed"})(hn||(e.NotebookVariablesRequestKind=hn={}));let Qi=class{constructor(M,ie){this.label=M,this.timestamp=ie}};e.$4O=Qi,e.$4O=Qi=He([g],Qi);var dn;(function(j){j[j.Production=1]="Production",j[j.Development=2]="Development",j[j.Test=3]="Test"})(dn||(e.ExtensionMode=dn={}));var fn;(function(j){j[j.Node=1]="Node",j[j.Webworker=2]="Webworker"})(fn||(e.ExtensionRuntime=fn={}));var gn;(function(j){j[j.Other=0]="Other",j[j.Comment=1]="Comment",j[j.String=2]="String",j[j.RegEx=3]="RegEx"})(gn||(e.StandardTokenType=gn={}));class Dn{constructor(M,ie){this.ranges=M,this.wordPattern=ie}}e.$5O=Dn;class Sn{constructor(M){this.c=M}get autoForwardAction(){return this.c}}e.$6O=Sn;var ee;(function(j){j[j.Queued=1]="Queued",j[j.Running=2]="Running",j[j.Passed=3]="Passed",j[j.Failed=4]="Failed",j[j.Skipped=5]="Skipped",j[j.Errored=6]="Errored"})(ee||(e.TestResultState=ee={}));var le;(function(j){j[j.Run=1]="Run",j[j.Debug=2]="Debug",j[j.Coverage=3]="Coverage"})(le||(e.TestRunProfileKind=le={}));let Fe=class{constructor(M=void 0,ie=void 0,De=void 0,Qe=!1,et=!0){this.include=M,this.exclude=ie,this.profile=De,this.continuous=Qe,this.preserveFocus=et}};e.$7O=Fe,e.$7O=Fe=He([g],Fe);let at=P=class{static diff(M,ie,De){const Qe=new P(M);return Qe.expectedOutput=ie,Qe.actualOutput=De,Qe}constructor(M){this.message=M}};e.$8O=at,e.$8O=at=P=He([g],at);let Dt=class{constructor(M){this.id=M}};e.$9O=Dt,e.$9O=Dt=He([g],Dt);class Tt{constructor(M,ie){this.covered=M,this.total=ie,Ri(this)}}e.$0O=Tt;function Ri(j){if(j){if(j.covered>j.total)throw new Error(`The total number of covered items (${j.covered}) cannot be greater than the total (${j.total})`);if(j.total<0)throw new Error(`The number of covered items (${j.total}) cannot be negative`)}}class Ji{static fromDetails(M,ie){const De=new Tt(0,0),Qe=new Tt(0,0),et=new Tt(0,0);for(const Et of ie)if("branches"in Et){De.total+=1,De.covered+=Et.executed?1:0;for(const Xt of Et.branches)Qe.total+=1,Qe.covered+=Xt.executed?1:0}else et.total+=1,et.covered+=Et.executed?1:0;const dt=new Ji(M,De,Qe.total>0?Qe:void 0,et.total>0?et:void 0);return dt.detailedCoverage=ie,dt}constructor(M,ie,De,Qe,et=[]){this.uri=M,this.statementCoverage=ie,this.branchCoverage=De,this.declarationCoverage=Qe,this.fromTests=et}}e.$_O=Ji;class Vn{get executionCount(){return+this.executed}set executionCount(M){this.executed=M}constructor(M,ie,De=[]){this.executed=M,this.location=ie,this.branches=De}}e.$aP=Vn;class qn{get executionCount(){return+this.executed}set executionCount(M){this.executed=M}constructor(M,ie,De){this.executed=M,this.location=ie,this.label=De}}e.$bP=qn;class Gn{get executionCount(){return+this.executed}set executionCount(M){this.executed=M}constructor(M,ie,De){this.name=M,this.executed=ie,this.location=De}}e.$cP=Gn;var kn;(function(j){j[j.None=0]="None",j[j.Option=1]="Option",j[j.Default=2]="Default",j[j.Preferred=3]="Preferred"})(kn||(e.ExternalUriOpenerPriority=kn={}));var Cn;(function(j){j[j.Untrusted=0]="Untrusted",j[j.Trusted=1]="Trusted",j[j.Unspecified=2]="Unspecified"})(Cn||(e.WorkspaceTrustState=Cn={}));var In;(function(j){j[j.Notify=1]="Notify",j[j.OpenBrowser=2]="OpenBrowser",j[j.OpenPreview=3]="OpenPreview",j[j.Silent=4]="Silent",j[j.Ignore=5]="Ignore",j[j.OpenBrowserOnce=6]="OpenBrowserOnce"})(In||(e.PortAutoForwardAction=In={}));class Kn{constructor(M,ie,De,Qe,et,dt){this.kind=M,this.name=ie,this.detail=De,this.uri=Qe,this.range=et,this.selectionRange=dt}}e.$dP=Kn;class Hn{constructor(M){this.uri=M}}e.$eP=Hn;class Qn{constructor(M,ie){this.original=M,this.modified=ie}}e.$fP=Qn;class Jn{constructor(M,ie,De,Qe){this.base=M,this.input1=ie,this.input2=De,this.result=Qe}}e.$gP=Jn;class Xn{constructor(M,ie){this.uri=M,this.viewType=ie}}e.$hP=Xn;class Zn{constructor(M){this.viewType=M}}e.$iP=Zn;class Yn{constructor(M,ie){this.uri=M,this.notebookType=ie}}e.$jP=Yn;class xn{constructor(M,ie,De){this.original=M,this.modified=ie,this.notebookType=De}}e.$kP=xn;class _n{constructor(){}}e.$lP=_n;class er{constructor(M,ie){this.uri=M,this.inputBoxUri=ie}}e.$mP=er;class tr{constructor(){}}e.$nP=tr;class ir{constructor(M){this.textDiffs=M}}e.$oP=ir;var Pn;(function(j){j[j.Down=0]="Down",j[j.Up=1]="Up"})(Pn||(e.InteractiveSessionVoteDirection=Pn={}));var Rn;(function(j){j[j.Action=1]="Action",j[j.Toolbar=2]="Toolbar"})(Rn||(e.ChatCopyKind=Rn={}));var An;(function(j){j[j.Short=1]="Short",j[j.Medium=2]="Medium",j[j.Full=3]="Full"})(An||(e.ChatVariableLevel=An={}));class nr{constructor(M,ie,De){this.id=M,this.label=ie,this.values=De}}e.$pP=nr;var Nn;(function(j){j[j.Unhelpful=0]="Unhelpful",j[j.Helpful=1]="Helpful",j[j.Undone=2]="Undone",j[j.Accepted=3]="Accepted",j[j.Bug=4]="Bug"})(Nn||(e.InteractiveEditorResponseFeedbackKind=Nn={}));var Tn;(function(j){j[j.Unhelpful=0]="Unhelpful",j[j.Helpful=1]="Helpful"})(Tn||(e.ChatResultFeedbackKind=Tn={}));class rr{constructor(M){if(typeof M!="string"&&M.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof M=="string"?new Ke(M):M}}e.$qP=rr;class sr{constructor(M,ie){if(typeof M!="string"&&M.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof M=="string"?new Ke(M):M,this.vulnerabilities=ie}}e.$rP=sr;class or{constructor(M,ie){this.participant=M,this.command=ie}}e.$sP=or;class ar{constructor(M,ie,De){this.title=M,this.message=ie,this.data=De}}e.$tP=ar;class cr{constructor(M,ie){this.value=M,this.baseUri=ie}}e.$uP=cr;class ur{constructor(M,ie){this.value=M,this.title=ie}}e.$vP=ur;class lr{constructor(M){this.value=M}}e.$wP=lr;class hr{constructor(M,ie){this.value=M,this.task=ie}}e.$xP=hr;class dr{constructor(M){if(typeof M!="string"&&M.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof M=="string"?new Ke(M):M}}e.$yP=dr;class fr{constructor(M){this.value=M}}e.$zP=fr;class gr{constructor(M,ie){this.value=M,this.iconPath=ie}}e.$AP=gr;class mr{constructor(M,ie){this.uri=M,this.edits=Array.isArray(ie)?ie:[ie]}}e.$BP=mr;class pr{constructor(M,ie,De,Qe){this.prompt=M,this.command=ie,this.references=De,this.participant=Qe}}e.$CP=pr;class $r{constructor(M,ie,De,Qe){this.response=M,this.result=ie,this.participant=De,this.command=Qe}}e.$DP=$r;var On;(function(j){j[j.Panel=1]="Panel",j[j.Terminal=2]="Terminal",j[j.Notebook=3]="Notebook",j[j.Editor=4]="Editor"})(On||(e.ChatLocation=On={}));var mn;(function(j){j[j.User=1]="User",j[j.Assistant=2]="Assistant",j[j.System=3]="System"})(mn||(e.LanguageModelChatMessageRole=mn={}));class br{constructor(M,ie,De){this.name=M,this.content=ie,this.isError=De??!1}}e.$EP=br;class pn{static User(M,ie){const De=new pn(mn.User,typeof M=="string"?M:"",ie);return De.content2=M,De}static Assistant(M,ie){return new pn(mn.Assistant,M,ie)}constructor(M,ie,De){this.role=M,this.content=ie,this.content2=ie,this.name=De}}e.$FP=pn;class wr{constructor(M,ie){this.name=M,this.parameters=ie}}e.$GP=wr;class vr{constructor(M){this.value=M}}e.$HP=vr;class yr{constructor(M){this.content=M}}e.$IP=yr;class Er{constructor(M,ie){this.content=M,this.name=ie}}e.$JP=Er;class Dr{constructor(M,ie){this.content=M,this.name=ie}}e.$KP=Dr;class Ai extends Error{static NotFound(M){return new Ai(M,Ai.NotFound.name)}static NoPermissions(M){return new Ai(M,Ai.NoPermissions.name)}static Blocked(M){return new Ai(M,Ai.Blocked.name)}constructor(M,ie,De){super(M,{cause:De}),this.name="LanguageModelError",this.code=ie??""}}e.$LP=Ai;var Fn;(function(j){j[j.SymbolInformation=1]="SymbolInformation",j[j.CommandInformation=2]="CommandInformation",j[j.SearchInformation=3]="SearchInformation",j[j.SettingInformation=4]="SettingInformation"})(Fn||(e.RelatedInformationType=Fn={}));var Ln;(function(j){j[j.Started=1]="Started",j[j.Recognizing=2]="Recognizing",j[j.Recognized=3]="Recognized",j[j.Stopped=4]="Stopped",j[j.Error=5]="Error"})(Ln||(e.SpeechToTextStatus=Ln={}));var Mn;(function(j){j[j.Started=1]="Started",j[j.Stopped=2]="Stopped",j[j.Error=3]="Error"})(Mn||(e.TextToSpeechStatus=Mn={}));var Un;(function(j){j[j.Recognized=1]="Recognized",j[j.Stopped=2]="Stopped"})(Un||(e.KeywordRecognitionStatus=Un={}));class Sr{constructor(M,ie){this.text=M,this.range=ie}}e.$MP=Sr;var zn;(function(j){j[j.Invoke=0]="Invoke",j[j.Automatic=1]="Automatic"})(zn||(e.InlineEditTriggerKind=zn={}))}),define(ke[270],Ce([1,0,5,7]),function(oe,e,w,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Snc=void 0;class k{constructor(A){this.a=new Map,this.b=0,this.c=A.getProxy(w.$rN.MainThreadAiRelatedInformation)}async $provideAiRelatedInformation(A,T,p){if(this.a.size===0)throw new Error("No related information providers registered");const a=this.a.get(A);if(!a)throw new Error("related information provider not found");return await a.provideRelatedInformation(T,p)??[]}getRelatedInformation(A,T,p){return this.c.$getAiRelatedInformation(T,p)}registerRelatedInformationProvider(A,T,p){const a=this.b;return this.b++,this.a.set(a,p),this.c.$registerAiRelatedInformationProvider(a,T),new S.$tN(()=>{this.c.$unregisterAiRelatedInformationProvider(a),this.a.delete(a)})}}e.$Snc=k}),define(ke[91],Ce([1,0,6,5,7,19,116,3,17]),function(oe,e,w,S,k,O,A,T,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5nc=e.$4nc=void 0,e.$4nc=(0,T.$Fi)("IExtHostAuthentication");let a=class{constructor(u){this.b=new Map,this.c=new w.$me,this.onDidChangeSessions=this.c.event,this.d=new R,this.f=new R,this.a=u.getProxy(S.$rN.MainThreadAuthentication)}async getSession(u,E,d,n={}){const s=O.$qn.toKey(u.identifier),o=[...d].sort().join(" ");return await this.d.getOrCreate(`${s} ${E} ${o}`,async()=>{await this.a.$ensureProvider(E);const h=u.displayName||u.name;return this.a.$getSession(E,d,s,h,n)})}async getSessions(u,E,d){const n=O.$qn.toKey(u.identifier),s=[...d].sort().join(" ");return await this.f.getOrCreate(`${n} ${s}`,async()=>{await this.a.$ensureProvider(E);const o=u.displayName||u.name;return this.a.$getSessions(E,d,n,o)})}async getAccounts(u){return await this.a.$ensureProvider(u),await this.a.$getAccounts(u)}async removeSession(u,E){const d=this.b.get(u);return d?d.provider.removeSession(E):this.a.$removeSession(u,E)}registerAuthenticationProvider(u,E,d,n){if(this.b.get(u))throw new Error(`An authentication provider with id '${u}' is already registered.`);this.b.set(u,{label:E,provider:d,options:n??{supportsMultipleAccounts:!1}});const s=d.onDidChangeSessions(o=>this.a.$sendDidChangeSessions(u,o));return this.a.$registerAuthenticationProvider(u,E,n?.supportsMultipleAccounts??!1),new k.$tN(()=>{s.dispose(),this.b.delete(u),this.a.$unregisterAuthenticationProvider(u)})}async $createSession(u,E,d){const n=this.b.get(u);if(n)return await n.provider.createSession(E,d);throw new Error(`Unable to find authentication provider with handle: ${u}`)}async $removeSession(u,E){const d=this.b.get(u);if(d)return await d.provider.removeSession(E);throw new Error(`Unable to find authentication provider with handle: ${u}`)}async $getSessions(u,E,d){const n=this.b.get(u);if(n)return await n.provider.getSessions(E,d);throw new Error(`Unable to find authentication provider with handle: ${u}`)}$onDidChangeAuthenticationSessions(u,E){return u.startsWith(A.$tM)||this.c.fire({provider:{id:u,label:E}}),Promise.resolve()}};e.$5nc=a,e.$5nc=a=He([Ve(0,p.$XP)],a);class R{constructor(){this.a=new Map}getOrCreate(u,E){const d=this.a.get(u);if(d)return d;const n=E().finally(()=>this.a.delete(u));return this.a.set(u,n),n}}}),define(ke[121],Ce([1,0,2,5,7,3,17,12,18,13,20,25]),function(oe,e,w,S,k,O,A,T,p,a,R,y){"use strict";var u;Object.defineProperty(e,"__esModule",{value:!0}),e.$0oc=e.$9oc=void 0;let E=class{static{u=this}static{this.c=0}static{this.d=250}constructor(n,s){this.h=s,this.f=new Map,this.g=n.getProxy(S.$rN.MainThreadDecorations)}registerFileDecorationProvider(n,s){const o=u.c++;this.f.set(o,{provider:n,extensionDescription:s}),this.g.$registerDecorationProvider(o,s.identifier.value);const h=n.onDidChangeFileDecorations&&n.onDidChangeFileDecorations(i=>{if(!i){this.g.$onDidChange(o,null);return}const r=(0,p.$4b)(i);if(r.length<=u.d){this.g.$onDidChange(o,r);return}this.h.warn("[Decorations] CAPPING events from decorations provider",s.identifier.value,r.length);const t=r.map(m=>({uri:m,rank:(0,a.$jf)(m.path,"/")})),c=(0,p.$Bb)(t,(m,f)=>m.rank-f.rank||(0,a.$zf)(m.uri.path,f.uri.path)),l=[];e:for(const m of c){let f;for(const $ of m){const I=(0,R.$oc)($.uri.path);if(f!==I&&(f=I,l.push($.uri)>=u.d))break e}}this.g.$onDidChange(o,l)});return new k.$tN(()=>{h?.dispose(),this.g.$unregisterDecorationProvider(o),this.f.delete(o)})}async $provideDecorations(n,s,o){if(!this.f.has(n))return Object.create(null);const h=Object.create(null),{provider:i,extensionDescription:r}=this.f.get(n);return await Promise.all(s.map(async t=>{try{const{uri:c,id:l}=t,m=await Promise.resolve(i.provideFileDecoration(w.URI.revive(c),o));if(!m)return;try{k.$TO.validate(m),m.badge&&typeof m.badge!="string"&&(0,y.$4G)(r,"codiconDecoration"),h[l]=[m.propagate,m.tooltip,m.badge,m.color]}catch(f){this.h.warn(`INVALID decoration from extension '${r.identifier.value}': ${f}`)}}catch(c){this.h.error(c)}})),h}};e.$9oc=E,e.$9oc=E=u=He([Ve(0,A.$XP),Ve(1,T.$_j)],E),e.$0oc=(0,O.$Fi)("IExtHostDecorations")}),define(ke[271],Ce([1,0,14,2,7,5,16,22,13]),function(oe,e,w,S,k,O,A,T,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_oc=void 0;class a{static{this.a=0}constructor(y,u,E){this.d=u,this.e=E,this.b=new Map,this.c=y.getProxy(O.$rN.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(y,u){if(Object.keys(A.Schemas).indexOf(y)>=0)throw new Error(`scheme '${y}' already registered`);const E=a.a++;this.b.set(E,u),this.c.$registerTextContentProvider(E,y);let d;if(typeof u.onDidChange=="function"){let n;d=u.onDidChange(async s=>{if(s.scheme!==y){this.e.warn(`Provider for scheme '${y}' is firing event for schema '${s.scheme}' which will be IGNORED`);return}if(!this.d.getDocument(s))return;n&&await n;const o=this.$provideTextDocumentContent(E,s).then(async h=>{if(!h&&typeof h!="string")return;const i=this.d.getDocument(s);if(!i)return;const r=(0,p.$tf)(h);if(!i.equalLines(r))return this.c.$onVirtualDocumentChange(s,h)}).catch(w.$3).finally(()=>{n===o&&(n=void 0)});n=o})}return new k.$tN(()=>{this.b.delete(E)&&this.c.$unregisterTextContentProvider(E),d&&(d.dispose(),d=void 0)})}$provideTextDocumentContent(y,u){const E=this.b.get(y);return E?Promise.resolve(E.provideTextDocumentContent(S.URI.revive(u),T.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${u.scheme}`))}}e.$_oc=a}),define(ke[122],Ce([1,0,62,16,13,326,210,7,18]),function(oe,e,w,S,k,O,A,T,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2P=e.$1P=void 0,e.$ZP=R;const a=new Map;function R(d,n){n?a.set(d,n):a.delete(d)}function y(d){return a.get(d)}class u extends O.$hw{constructor(n,s,o,h,i,r,t){super(s,o,h,i),this.c=n,this.m=r,this.q=t,this.b=!1}dispose(){(0,w.ok)(!this.b),this.b=!0,this.q=!1}equalLines(n){return(0,p.$wb)(this.f,n)}get document(){if(!this.a){const n=this;this.a={get uri(){return n.d},get fileName(){return n.d.fsPath},get isUntitled(){return n.d.scheme===S.Schemas.untitled},get languageId(){return n.m},get version(){return n.h},get isClosed(){return n.b},get isDirty(){return n.q},save(){return n.r()},getText(s){return s?n.s(s):n.getText()},get eol(){return n.g===`
`?T.EndOfLine.LF:T.EndOfLine.CRLF},get lineCount(){return n.f.length},lineAt(s){return n.t(s)},offsetAt(s){return n.u(s)},positionAt(s){return n.v(s)},validateRange(s){return n.w(s)},validatePosition(s){return n.x(s)},getWordRangeAtPosition(s,o){return n.y(s,o)}}}return Object.freeze(this.a)}_acceptLanguageId(n){(0,w.ok)(!this.b),this.m=n}_acceptIsDirty(n){(0,w.ok)(!this.b),this.q=n}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.c.$trySaveDocument(this.d)}s(n){const s=this.w(n);if(s.isEmpty)return"";if(s.isSingleLine)return this.f[s.start.line].substring(s.start.character,s.end.character);const o=this.g,h=s.start.line,i=s.end.line,r=[];r.push(this.f[h].substring(s.start.character));for(let t=h+1;t<i;t++)r.push(this.f[t]);return r.push(this.f[i].substring(0,s.end.character)),r.join(o)}t(n){let s;if(n instanceof T.$uN?s=n.line:typeof n=="number"&&(s=n),typeof s!="number"||s<0||s>=this.f.length||Math.floor(s)!==s)throw new Error("Illegal value for `line`");return new E(s,this.f[s],s===this.f.length-1)}u(n){return n=this.x(n),this.l(),this.j.getPrefixSum(n.line-1)+n.character}v(n){n=Math.floor(n),n=Math.max(0,n),this.l();const s=this.j.getIndexOf(n),o=this.f[s.index].length;return new T.$uN(s.index,Math.min(s.remainder,o))}w(n){if(!(n instanceof T.$vN))throw new Error("Invalid argument");const s=this.x(n.start),o=this.x(n.end);return s===n.start&&o===n.end?n:new T.$vN(s.line,s.character,o.line,o.character)}x(n){if(!(n instanceof T.$uN))throw new Error("Invalid argument");if(this.f.length===0)return n.with(0,0);let{line:s,character:o}=n,h=!1;if(s<0)s=0,o=0,h=!0;else if(s>=this.f.length)s=this.f.length-1,o=this.f[s].length,h=!0;else{const i=this.f[s].length;o<0?(o=0,h=!0):o>i&&(o=i,h=!0)}return h?new T.$uN(s,o):n}y(n,s){const o=this.x(n);if(!s)s=y(this.m);else if((0,k.$sf)(s))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${s.source}' because it matches the empty string.`);const h=(0,A.$jt)(o.character+1,(0,A.$ht)(s),this.f[o.line],0);if(h)return new T.$vN(o.line,h.startColumn-1,o.line,h.endColumn-1)}}e.$1P=u;class E{constructor(n,s,o){this.a=n,this.b=s,this.c=o}get lineNumber(){return this.a}get text(){return this.b}get range(){return new T.$vN(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new T.$vN(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.$2P=E}),define(ke[272],Ce([1,0,5,7]),function(oe,e,w,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cpc=void 0;class k{constructor(A){this.a=new Map,this.b=0,this.c=A.getProxy(w.$rN.MainThreadAiEmbeddingVector)}async $provideAiEmbeddingVector(A,T,p){if(this.a.size===0)throw new Error("No embedding vector providers registered");const a=this.a.get(A);if(!a)throw new Error("Embedding vector provider not found");const R=await a.provideEmbeddingVector(T,p);if(!R)throw new Error("Embedding vector provider returned undefined");return R}registerEmbeddingVectorProvider(A,T,p){const a=this.b;return this.b++,this.a.set(a,p),this.c.$registerAiEmbeddingVectorProvider(T,a),new S.$tN(()=>{this.c.$unregisterAiEmbeddingVectorProvider(a),this.a.delete(a)})}}e.$cpc=k}),define(ke[69],Ce([1,0,5,30,7,23,3,17,51,4,11,24,16]),function(oe,e,w,S,k,O,A,T,p,a,R,y,u){"use strict";var E;Object.defineProperty(e,"__esModule",{value:!0}),e.$ioc=e.$hoc=void 0,S=qe(S);let d=E=class{constructor(s,o){this.b=new Map,this.c=new R.$Oh,this.a=s.getProxy(w.$rN.MainThreadFileSystem);const h=this;this.value=Object.freeze({async stat(i){try{let r;const t=h.b.get(i.scheme);return t?(await h.a.$ensureActivation(i.scheme),r=await t.impl.stat(i)):r=await h.a.$stat(i),{type:r.type,ctime:r.ctime,mtime:r.mtime,size:r.size,permissions:r.permissions===S.FilePermission.Readonly?1:void 0}}catch(r){E.e(r)}},async readDirectory(i){try{const r=h.b.get(i.scheme);return r?(await h.a.$ensureActivation(i.scheme),(await r.impl.readDirectory(i)).slice()):await h.a.$readdir(i)}catch(r){return E.e(r)}},async createDirectory(i){try{const r=h.b.get(i.scheme);return r&&!r.isReadonly?(await h.a.$ensureActivation(i.scheme),await h.d(r.impl,r.extUri,i)):await h.a.$mkdir(i)}catch(r){return E.e(r)}},async readFile(i){try{const r=h.b.get(i.scheme);return r?(await h.a.$ensureActivation(i.scheme),(await r.impl.readFile(i)).slice()):(await h.a.$readFile(i)).buffer}catch(r){return E.e(r)}},async writeFile(i,r){try{const t=h.b.get(i.scheme);return t&&!t.isReadonly?(await h.a.$ensureActivation(i.scheme),await h.d(t.impl,t.extUri,t.extUri.dirname(i)),await h.c.queueFor(i,()=>Promise.resolve(t.impl.writeFile(i,r,{create:!0,overwrite:!0})))):await h.a.$writeFile(i,O.$Oe.wrap(r))}catch(t){return E.e(t)}},async delete(i,r){try{const t=h.b.get(i.scheme);return t&&!t.isReadonly&&!r?.useTrash?(await h.a.$ensureActivation(i.scheme),await t.impl.delete(i,{recursive:!1,...r})):await h.a.$delete(i,{recursive:!1,useTrash:!1,atomic:!1,...r})}catch(t){return E.e(t)}},async rename(i,r,t){try{return await h.a.$rename(i,r,{overwrite:!1,...t})}catch(c){return E.e(c)}},async copy(i,r,t){try{return await h.a.$copy(i,r,{overwrite:!1,...t})}catch(c){return E.e(c)}},isWritableFileSystem(i){const r=o.getCapabilities(i);if(typeof r=="number")return!(r&S.FileSystemProviderCapabilities.Readonly)}})}async d(s,o,h){const i=[];for(;!o.isEqual(h,o.dirname(h));)try{if(!((await s.stat(h)).type&S.FileType.Directory))throw k.$KO.FileExists(`Unable to create folder '${h.scheme===u.Schemas.file?h.fsPath:h.toString(!0)}' that already exists but is not a directory`);break}catch(r){if(S.$pl(r)!==S.FileSystemProviderErrorCode.FileNotFound)throw r;i.push(o.basename(h)),h=o.dirname(h)}for(let r=i.length-1;r>=0;r--){h=o.joinPath(h,i[r]);try{await s.createDirectory(h)}catch(t){if(S.$pl(t)!==S.FileSystemProviderErrorCode.FileExists)throw t}}}static e(s){if(s instanceof k.$KO)throw s;if(s instanceof S.$ll)switch(s.code){case S.FileSystemProviderErrorCode.FileExists:throw k.$KO.FileExists(s.message);case S.FileSystemProviderErrorCode.FileNotFound:throw k.$KO.FileNotFound(s.message);case S.FileSystemProviderErrorCode.FileNotADirectory:throw k.$KO.FileNotADirectory(s.message);case S.FileSystemProviderErrorCode.FileIsADirectory:throw k.$KO.FileIsADirectory(s.message);case S.FileSystemProviderErrorCode.NoPermissions:throw k.$KO.NoPermissions(s.message);case S.FileSystemProviderErrorCode.Unavailable:throw k.$KO.Unavailable(s.message);default:throw new k.$KO(s.message,s.name)}if(!(s instanceof Error))throw new k.$KO(String(s));if(s.name==="ENOPRO"||s.message.includes("ENOPRO"))throw k.$KO.Unavailable(s.message);switch(s.name){case S.FileSystemProviderErrorCode.FileExists:throw k.$KO.FileExists(s.message);case S.FileSystemProviderErrorCode.FileNotFound:throw k.$KO.FileNotFound(s.message);case S.FileSystemProviderErrorCode.FileNotADirectory:throw k.$KO.FileNotADirectory(s.message);case S.FileSystemProviderErrorCode.FileIsADirectory:throw k.$KO.FileIsADirectory(s.message);case S.FileSystemProviderErrorCode.NoPermissions:throw k.$KO.NoPermissions(s.message);case S.FileSystemProviderErrorCode.Unavailable:throw k.$KO.Unavailable(s.message);default:throw new k.$KO(s.message,s.name)}}addFileSystemProvider(s,o,h){return this.b.set(s,{impl:o,extUri:h?.isCaseSensitive?y.$9g:y.$$g,isReadonly:!!h?.isReadonly}),(0,a.$Uc)(()=>this.b.delete(s))}getFileSystemProviderExtUri(s){return this.b.get(s)?.extUri??y.$9g}};e.$hoc=d,e.$hoc=d=E=He([Ve(0,T.$XP),Ve(1,p.$Xnc)],d),e.$ioc=(0,A.$Fi)("IExtHostConsumerFileSystem")}),define(ke[92],Ce([1,0,3,27,12,69,2]),function(oe,e,w,S,k,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$koc=e.$joc=void 0,e.$joc=(0,w.$Fi)("IExtensionStoragePaths");let T=class{constructor(a,R,y){this.d=R,this.f=y,this.a=a.workspace??void 0,this.b=a.environment,this.whenReady=this.h().then(u=>this.c=u)}async g(a){return A.URI.joinPath(this.b.workspaceStorageHome,a)}async h(){if(!this.a)return Promise.resolve(void 0);const a=this.a.id,R=await this.g(a);try{return await this.f.value.stat(R),this.d.trace("[ExtHostStorage] storage dir already exists",R),R}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",R),await this.f.value.createDirectory(R),await this.f.value.writeFile(A.URI.joinPath(R,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:A.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),R}catch(y){this.d.error("[ExtHostStorage]",y);return}}workspaceValue(a){if(this.c)return A.URI.joinPath(this.c,a.identifier.value)}globalValue(a){return A.URI.joinPath(this.b.globalStorageHome,a.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.$koc=T,e.$koc=T=He([Ve(0,S.$bQ),Ve(1,k.$_j),Ve(2,O.$ioc)],T)}),define(ke[273],Ce([1,0,7,17,6]),function(oe,e,w,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Spc=void 0;let O=class{constructor(T){this.a=new w.$UO(w.ColorThemeKind.Dark),this.b=new k.$me}get activeColorTheme(){return this.a}$onColorThemeChange(T){let p;switch(T){case"light":p=w.ColorThemeKind.Light;break;case"hcDark":p=w.ColorThemeKind.HighContrast;break;case"hcLight":p=w.ColorThemeKind.HighContrastLight;break;default:p=w.ColorThemeKind.Dark}this.a=new w.$UO(p),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};e.$Spc=O,e.$Spc=O=He([Ve(0,S.$XP)],O)}),define(ke[93],Ce([1,0,22,6,4,190,3,12,223,5,27,17,7]),function(oe,e,w,S,k,O,A,T,p,a,R,y,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$FFb=e.$EFb=e.TunnelDtoConverter=void 0,O=qe(O),u=qe(u);class E extends p.$Gw{}var d;(function(s){function o(i){return{remoteAddress:i.remoteAddress,localAddress:i.localAddress,public:!!i.public,privacy:i.privacy??(i.public?p.TunnelPrivacyId.Public:p.TunnelPrivacyId.Private),protocol:i.protocol}}s.fromApiTunnel=o;function h(i){return{remoteAddress:{host:i.tunnelRemoteHost,port:i.tunnelRemotePort},localAddress:i.localAddress,public:i.privacy!==p.TunnelPrivacyId.ConstantPrivate&&i.privacy!==p.TunnelPrivacyId.ConstantPrivate,privacy:i.privacy,protocol:i.protocol}}s.fromServiceTunnel=h})(d||(e.TunnelDtoConverter=d={})),e.$EFb=(0,A.$Fi)("IExtHostTunnelService");let n=class extends k.$Wc{constructor(o,h,i){super(),this.s=i,this.f=()=>Promise.resolve(!0),this.g=new Map,this.h=new S.$me,this.onDidChangeTunnels=this.h.event,this.n=0,this.r=new Map,this.a=o.getProxy(a.$rN.MainThreadTunnelService)}async openTunnel(o,h){this.s.trace(`ForwardedPorts: (ExtHostTunnelService) ${o.identifier.value} called openTunnel API for ${h.remoteAddress.host}:${h.remoteAddress.port}.`);const i=await this.a.$openTunnel(h,o.displayName);if(i){const r=new E(i.remoteAddress,i.localAddress,()=>this.a.$closeTunnel(i.remoteAddress));return this.B(r),r}}async getTunnels(){return this.a.$getTunnels()}u(){return this.n++}registerPortsAttributesProvider(o,h){o.portRange===void 0&&o.commandPattern===void 0&&this.s.error("PortAttributesProvider must specify either a portRange or a commandPattern");const i=this.u();return this.r.set(i,{selector:o,provider:h}),this.a.$registerPortsAttributesProvider(o,i),new u.$tN(()=>{this.r.delete(i),this.a.$unregisterPortsAttributesProvider(i)})}async $providePortAttributes(o,h,i,r,t){const c=[];for(const m of o){const f=this.r.get(m);if(!f)return[];c.push(...await Promise.all(h.map(async $=>{let I;try{I=await f.provider.providePortAttributes({port:$,pid:i,commandLine:r},t)}catch{I=await f.provider.providePortAttributes($,i,r,t)}return{providedAttributes:I,port:$}})))}const l=c.filter(m=>!!m.providedAttributes);return l.length>0?l.map(m=>({autoForwardAction:m.providedAttributes.autoForwardAction,port:m.port})):[]}async $registerCandidateFinder(o){}registerTunnelProvider(o,h){if(this.b)throw new Error("A tunnel provider has already been registered. Only the first tunnel provider to be registered will be used.");this.b=async(r,t)=>await o.provideTunnel(r,t,w.CancellationToken.None)??void 0;const i=h.tunnelFeatures?{elevation:!!h.tunnelFeatures?.elevation,privacyOptions:h.tunnelFeatures?.privacyOptions,protocol:h.tunnelFeatures.protocol===void 0?!0:h.tunnelFeatures.protocol}:void 0;return this.a.$setTunnelProvider(i),Promise.resolve((0,k.$Uc)(()=>{this.b=void 0,this.a.$setTunnelProvider(void 0)}))}async setTunnelFactory(o,h){if(o){o.candidatePortSource!==void 0&&this.a.$setCandidatePortSource(o.candidatePortSource),o.showCandidatePort&&(this.f=o.showCandidatePort,this.a.$setCandidateFilter());const i=o.tunnelFactory??(h?this.w(h):void 0);if(i){this.b=i;let r=o.tunnelFeatures?.privacyOptions??[];o.tunnelFeatures?.public&&r.length===0&&(r=[{id:"private",label:O.localize(0,null),themeIcon:"lock"},{id:"public",label:O.localize(1,null),themeIcon:"eye"}]);const t=o.tunnelFeatures?{elevation:!!o.tunnelFeatures?.elevation,public:!!o.tunnelFeatures?.public,privacyOptions:r,protocol:!0}:void 0;this.a.$setTunnelProvider(t)}}else this.b=void 0;return(0,k.$Uc)(()=>{this.b=void 0})}w(o){}async $closeTunnel(o,h){if(this.g.has(o.host)){const i=this.g.get(o.host);i.has(o.port)&&(h&&i.get(o.port).disposeListener.dispose(),await i.get(o.port).tunnel.dispose(),i.delete(o.port))}}async $onDidTunnelsChange(){this.h.fire()}async $forwardPort(o,h){if(this.b)try{this.s.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const i=this.b(o,h);if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),i!==void 0){const r=await i;if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),r===void 0){this.s.error("ForwardedPorts: (ExtHostTunnelService) Resolved tunnel is undefined");return}this.g.has(o.remoteAddress.host)||this.g.set(o.remoteAddress.host,new Map);const t=this.B(r.onDidDispose(()=>(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this.a.$closeTunnel(r.remoteAddress))));return this.g.get(o.remoteAddress.host).set(o.remoteAddress.port,{tunnel:r,disposeListener:t}),d.fromApiTunnel(r)}else this.s.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(i){if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error"),i instanceof Error)return i.message}}async $applyCandidateFilter(o){const h=await Promise.all(o.map(r=>this.f(r.host,r.port,r.detail??""))),i=o.filter((r,t)=>h[t]);return this.s.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${o.map(r=>r.port).join(", ")} to ${i.map(r=>r.port).join(", ")}`),i}};e.$FFb=n,e.$FFb=n=He([Ve(0,y.$XP),Ve(1,R.$bQ),Ve(2,T.$_j)],n)}),define(ke[10],Ce([1,0,18,23,147,274,60,29,136,49,73,26,142,24,35,15,2,105,33,151,94,52,107,77,115,114,234,249,81,90,55,56,245,7]),function(oe,e,w,S,k,O,A,T,p,a,R,y,u,E,d,n,s,o,h,i,r,t,c,l,m,f,$,I,D,v,C,P,g,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DebugTreeItem=e.PartialAcceptTriggerKind=e.PartialAcceptInfo=e.TerminalQuickFix=e.ChatAgentUserActionEvent=e.ChatAgentResult=e.ChatAgentCompletionItem=e.ChatAgentValueReference=e.ChatLocation=e.ChatAgentRequest=e.ChatResponsePart=e.ChatResponseReferencePart=e.ChatResponseTextEditPart=e.ChatResponseCommandButtonPart=e.ChatTaskResult=e.ChatTask=e.ChatResponseWarningPart=e.ChatResponseProgressPart=e.ChatResponseAnchorPart=e.ChatResponseFilesPart=e.ChatResponseConfirmationPart=e.ChatResponseDetectedParticipantPart=e.ChatResponseMarkdownWithVulnerabilitiesPart=e.ChatResponseMarkdownPart=e.LanguageModelChatMessage=e.LanguageModelChatMessageRole=e.ChatFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.MultiDocumentHighlight=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.MarkdownString=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Location=e.Range=e.Selection=void 0,e.$UP=ce,e.$VP=se,e.$WP=Ie,A=qe(A),h=qe(h),i=qe(i),r=qe(r),I=qe(I),v=qe(v),b=qe(b);var L;(function(ve){function Ne(J){const{selectionStartLineNumber:Pe,selectionStartColumn:Me,positionLineNumber:Ze,positionColumn:Ge}=J,ct=new b.$uN(Pe-1,Me-1),It=new b.$uN(Ze-1,Ge-1);return new b.$wN(ct,It)}ve.to=Ne;function de(J){const{anchor:Pe,active:Me}=J;return{selectionStartLineNumber:Pe.line+1,selectionStartColumn:Pe.character+1,positionLineNumber:Me.line+1,positionColumn:Me.character+1}}ve.from=de})(L||(e.Selection=L={}));var N;(function(ve){function Ne(J){if(!J)return;const{start:Pe,end:Me}=J;return{startLineNumber:Pe.line+1,startColumn:Pe.character+1,endLineNumber:Me.line+1,endColumn:Me.character+1}}ve.from=Ne;function de(J){if(!J)return;const{startLineNumber:Pe,startColumn:Me,endLineNumber:Ze,endColumn:Ge}=J;return new b.$vN(Pe-1,Me-1,Ze-1,Ge-1)}ve.to=de})(N||(e.Range=N={}));var B;(function(ve){function Ne(J){return{uri:J.uri,range:N.from(J.range)}}ve.from=Ne;function de(J){return new b.$FN(s.URI.revive(J.uri),N.to(J.range))}ve.to=de})(B||(e.Location=B={}));var G;(function(ve){function Ne(de){switch(de){case i.StandardTokenType.Comment:return b.StandardTokenType.Comment;case i.StandardTokenType.Other:return b.StandardTokenType.Other;case i.StandardTokenType.RegEx:return b.StandardTokenType.RegEx;case i.StandardTokenType.String:return b.StandardTokenType.String}}ve.to=Ne})(G||(e.TokenType=G={}));var W;(function(ve){function Ne(J){return new b.$uN(J.lineNumber-1,J.column-1)}ve.to=Ne;function de(J){return{lineNumber:J.line+1,column:J.character+1}}ve.from=de})(W||(e.Position=W={}));var F;(function(ve){function Ne(Pe,Me,Ze){return(0,w.$Jb)((0,w.$4b)(Pe).map(Ge=>de(Ge,Me,Ze)))}ve.from=Ne;function de(Pe,Me,Ze){if(typeof Pe=="string")return{$serialized:!0,language:Pe,isBuiltin:Ze?.isBuiltin};if(Pe)return{$serialized:!0,language:Pe.language,scheme:J(Pe.scheme,Me),pattern:xe.from(Pe.pattern)??void 0,exclusive:Pe.exclusive,notebookType:Pe.notebookType,isBuiltin:Ze?.isBuiltin}}function J(Pe,Me){return Me&&typeof Pe=="string"?Me.transformOutgoingScheme(Pe):Pe}})(F||(e.DocumentSelector=F={}));var q;(function(ve){function Ne(J){switch(J){case b.DiagnosticTag.Unnecessary:return c.MarkerTag.Unnecessary;case b.DiagnosticTag.Deprecated:return c.MarkerTag.Deprecated}}ve.from=Ne;function de(J){switch(J){case c.MarkerTag.Unnecessary:return b.DiagnosticTag.Unnecessary;case c.MarkerTag.Deprecated:return b.DiagnosticTag.Deprecated;default:return}}ve.to=de})(q||(e.DiagnosticTag=q={}));var ue;(function(ve){function Ne(J){let Pe;return J.code&&((0,n.$fg)(J.code)||(0,n.$jg)(J.code)?Pe=String(J.code):Pe={value:String(J.code.value),target:J.code.target}),{...N.from(J.range),message:J.message,source:J.source,code:Pe,severity:te.from(J.severity),relatedInformation:J.relatedInformation&&J.relatedInformation.map(ge.from),tags:Array.isArray(J.tags)?(0,w.$Jb)(J.tags.map(q.from)):void 0}}ve.from=Ne;function de(J){const Pe=new b.$HN(N.to(J),J.message,te.to(J.severity));return Pe.source=J.source,Pe.code=(0,n.$fg)(J.code)?J.code:J.code?.value,Pe.relatedInformation=J.relatedInformation&&J.relatedInformation.map(ge.to),Pe.tags=J.tags&&(0,w.$Jb)(J.tags.map(q.to)),Pe}ve.to=de})(ue||(e.Diagnostic=ue={}));var ge;(function(ve){function Ne(J){return{...N.from(J.location.range),message:J.message,resource:J.location.uri}}ve.from=Ne;function de(J){return new b.$GN(new b.$FN(J.resource,N.to(J)),J.message)}ve.to=de})(ge||(e.DiagnosticRelatedInformation=ge={}));var te;(function(ve){function Ne(J){switch(J){case b.DiagnosticSeverity.Error:return c.MarkerSeverity.Error;case b.DiagnosticSeverity.Warning:return c.MarkerSeverity.Warning;case b.DiagnosticSeverity.Information:return c.MarkerSeverity.Info;case b.DiagnosticSeverity.Hint:return c.MarkerSeverity.Hint}return c.MarkerSeverity.Error}ve.from=Ne;function de(J){switch(J){case c.MarkerSeverity.Info:return b.DiagnosticSeverity.Information;case c.MarkerSeverity.Warning:return b.DiagnosticSeverity.Warning;case c.MarkerSeverity.Error:return b.DiagnosticSeverity.Error;case c.MarkerSeverity.Hint:return b.DiagnosticSeverity.Hint;default:return b.DiagnosticSeverity.Error}}ve.to=de})(te||(e.DiagnosticSeverity=te={}));var me;(function(ve){function Ne(J){return typeof J=="number"&&J>=b.ViewColumn.One?J-1:J===b.ViewColumn.Beside?g.$lE:g.$kE}ve.from=Ne;function de(J){if(typeof J=="number"&&J>=0)return J+1;throw new Error("invalid 'EditorGroupColumn'")}ve.to=de})(me||(e.ViewColumn=me={}));function re(ve){return typeof ve.range<"u"}function ce(ve){return ve.length===0?!0:!!re(ve[0])}var be;(function(ve){function Ne(Ge){return Ge.map(ve.from)}ve.fromMany=Ne;function de(Ge){return Ge&&typeof Ge=="object"&&typeof Ge.language=="string"&&typeof Ge.value=="string"}function J(Ge){let ct;if(de(Ge)){const{language:Mt,value:Jt}=Ge;ct={value:"```"+Mt+`
`+Jt+"\n```\n"}}else b.$VN.isMarkdownString(Ge)?ct={value:Ge.value,isTrusted:Ge.isTrusted,supportThemeIcons:Ge.supportThemeIcons,supportHtml:Ge.supportHtml,baseUri:Ge.baseUri}:typeof Ge=="string"?ct={value:Ge}:ct={value:""};const It=Object.create(null);ct.uris=It;const Qt=Mt=>{try{let Jt=s.URI.parse(Mt,!0);Jt=Jt.with({query:Pe(Jt.query,It)}),It[Mt]=Jt}catch{}return""},ci=new p.marked.Renderer;return ci.link=Qt,ci.image=Mt=>typeof Mt=="string"?Qt(A.$$k(Mt).href):"",(0,p.marked)(ct.value,{renderer:ci}),ct}ve.from=J;function Pe(Ge,ct){if(!Ge)return Ge;let It;try{It=(0,a.$bi)(Ge)}catch{}if(!It)return Ge;let Qt=!1;return It=(0,y.$do)(It,ci=>{if(s.URI.isUri(ci)){const Mt=`__uri_${Math.random().toString(16).slice(2,8)}`;return ct[Mt]=ci,Qt=!0,Mt}else return}),Qt?JSON.stringify(It):Ge}function Me(Ge){const ct=new b.$VN(Ge.value,Ge.supportThemeIcons);return ct.isTrusted=Ge.isTrusted,ct.supportHtml=Ge.supportHtml,ct.baseUri=Ge.baseUri?s.URI.from(Ge.baseUri):void 0,ct}ve.to=Me;function Ze(Ge){if(Ge)return typeof Ge=="string"?Ge:ve.from(Ge)}ve.fromStrict=Ze})(be||(e.MarkdownString=be={}));function se(ve){return ce(ve)?ve.map(Ne=>({range:N.from(Ne.range),hoverMessage:Array.isArray(Ne.hoverMessage)?be.fromMany(Ne.hoverMessage):Ne.hoverMessage?be.from(Ne.hoverMessage):void 0,renderOptions:Ne.renderOptions})):ve.map(Ne=>({range:N.from(Ne)}))}function Ie(ve){return typeof ve>"u"?ve:typeof ve=="string"?s.URI.file(ve):ve}var Ue;(function(ve){function Ne(de){return typeof de>"u"?de:{contentText:de.contentText,contentIconPath:de.contentIconPath?Ie(de.contentIconPath):void 0,border:de.border,borderColor:de.borderColor,fontStyle:de.fontStyle,fontWeight:de.fontWeight,textDecoration:de.textDecoration,color:de.color,backgroundColor:de.backgroundColor,margin:de.margin,width:de.width,height:de.height}}ve.from=Ne})(Ue||(e.ThemableDecorationAttachmentRenderOptions=Ue={}));var Z;(function(ve){function Ne(de){return typeof de>"u"?de:{backgroundColor:de.backgroundColor,outline:de.outline,outlineColor:de.outlineColor,outlineStyle:de.outlineStyle,outlineWidth:de.outlineWidth,border:de.border,borderColor:de.borderColor,borderRadius:de.borderRadius,borderSpacing:de.borderSpacing,borderStyle:de.borderStyle,borderWidth:de.borderWidth,fontStyle:de.fontStyle,fontWeight:de.fontWeight,textDecoration:de.textDecoration,cursor:de.cursor,color:de.color,opacity:de.opacity,letterSpacing:de.letterSpacing,gutterIconPath:de.gutterIconPath?Ie(de.gutterIconPath):void 0,gutterIconSize:de.gutterIconSize,overviewRulerColor:de.overviewRulerColor,before:de.before?Ue.from(de.before):void 0,after:de.after?Ue.from(de.after):void 0}}ve.from=Ne})(Z||(e.ThemableDecorationRenderOptions=Z={}));var V;(function(ve){function Ne(de){if(typeof de>"u")return de;switch(de){case b.DecorationRangeBehavior.OpenOpen:return t.TrackedRangeStickiness.AlwaysGrowsWhenTypingAtEdges;case b.DecorationRangeBehavior.ClosedClosed:return t.TrackedRangeStickiness.NeverGrowsWhenTypingAtEdges;case b.DecorationRangeBehavior.OpenClosed:return t.TrackedRangeStickiness.GrowsOnlyWhenTypingBefore;case b.DecorationRangeBehavior.ClosedOpen:return t.TrackedRangeStickiness.GrowsOnlyWhenTypingAfter}}ve.from=Ne})(V||(e.DecorationRangeBehavior=V={}));var _;(function(ve){function Ne(de){return{isWholeLine:de.isWholeLine,rangeBehavior:de.rangeBehavior?V.from(de.rangeBehavior):void 0,overviewRulerLane:de.overviewRulerLane,light:de.light?Z.from(de.light):void 0,dark:de.dark?Z.from(de.dark):void 0,backgroundColor:de.backgroundColor,outline:de.outline,outlineColor:de.outlineColor,outlineStyle:de.outlineStyle,outlineWidth:de.outlineWidth,border:de.border,borderColor:de.borderColor,borderRadius:de.borderRadius,borderSpacing:de.borderSpacing,borderStyle:de.borderStyle,borderWidth:de.borderWidth,fontStyle:de.fontStyle,fontWeight:de.fontWeight,textDecoration:de.textDecoration,cursor:de.cursor,color:de.color,opacity:de.opacity,letterSpacing:de.letterSpacing,gutterIconPath:de.gutterIconPath?Ie(de.gutterIconPath):void 0,gutterIconSize:de.gutterIconSize,overviewRulerColor:de.overviewRulerColor,before:de.before?Ue.from(de.before):void 0,after:de.after?Ue.from(de.after):void 0}}ve.from=Ne})(_||(e.DecorationRenderOptions=_={}));var ye;(function(ve){function Ne(J){return{text:J.newText,eol:J.newEol&&Be.from(J.newEol),range:N.from(J.range)}}ve.from=Ne;function de(J){const Pe=new b.$AN(N.to(J.range),J.text);return Pe.newEol=typeof J.eol>"u"?void 0:Be.to(J.eol),Pe}ve.to=de})(ye||(e.TextEdit=ye={}));var ae;(function(ve){function Ne(J,Pe){const Me={edits:[]};if(J instanceof b.$DN){const Ze=new T.$Dc;for(const Ge of J._allEntries())Ge._type===b.FileEditType.File&&s.URI.isUri(Ge.to)&&Ge.from===void 0&&Ze.add(Ge.to);for(const Ge of J._allEntries())if(Ge._type===b.FileEditType.File){let ct;Ge.options?.contents&&(ArrayBuffer.isView(Ge.options.contents)?ct={type:"base64",value:(0,S.$9e)(S.$Oe.wrap(Ge.options.contents))}:ct={type:"dataTransferItem",id:Ge.options.contents._itemId}),Me.edits.push({oldResource:Ge.from,newResource:Ge.to,options:{...Ge.options,contents:ct},metadata:Ge.metadata})}else Ge._type===b.FileEditType.Text?Me.edits.push({resource:Ge.uri,textEdit:ye.from(Ge.edit),versionId:Ze.has(Ge.uri)?void 0:Pe?.getTextDocumentVersion(Ge.uri),metadata:Ge.metadata}):Ge._type===b.FileEditType.Snippet?Me.edits.push({resource:Ge.uri,textEdit:{range:N.from(Ge.range),text:Ge.edit.value,insertAsSnippet:!0},versionId:Ze.has(Ge.uri)?void 0:Pe?.getTextDocumentVersion(Ge.uri),metadata:Ge.metadata}):Ge._type===b.FileEditType.Cell?Me.edits.push({metadata:Ge.metadata,resource:Ge.uri,cellEdit:Ge.edit,notebookMetadata:Ge.notebookMetadata,notebookVersionId:Pe?.getNotebookDocumentVersion(Ge.uri)}):Ge._type===b.FileEditType.CellReplace&&Me.edits.push({metadata:Ge.metadata,resource:Ge.uri,notebookVersionId:Pe?.getNotebookDocumentVersion(Ge.uri),cellEdit:{editType:v.CellEditType.Replace,index:Ge.index,count:Ge.count,cells:Ge.cells.map(Pt.from)}})}return Me}ve.from=Ne;function de(J){const Pe=new b.$DN,Me=new T.$Cc;for(const Ze of J.edits)if(Ze.textEdit){const Ge=Ze,ct=s.URI.revive(Ge.resource),It=N.to(Ge.textEdit.range),Qt=Ge.textEdit.text,ci=Ge.textEdit.insertAsSnippet;let Mt;ci?Mt=b.$CN.replace(It,new b.$EN(Qt)):Mt=b.$AN.replace(It,Qt);const Jt=Me.get(ct);Jt?Jt.push(Mt):Me.set(ct,[Mt])}else Pe.renameFile(s.URI.revive(Ze.oldResource),s.URI.revive(Ze.newResource),Ze.options);for(const[Ze,Ge]of Me)Pe.set(Ze,Ge);return Pe}ve.to=de})(ae||(e.WorkspaceEdit=ae={}));var we;(function(ve){const Ne=Object.create(null);Ne[b.SymbolKind.File]=r.SymbolKind.File,Ne[b.SymbolKind.Module]=r.SymbolKind.Module,Ne[b.SymbolKind.Namespace]=r.SymbolKind.Namespace,Ne[b.SymbolKind.Package]=r.SymbolKind.Package,Ne[b.SymbolKind.Class]=r.SymbolKind.Class,Ne[b.SymbolKind.Method]=r.SymbolKind.Method,Ne[b.SymbolKind.Property]=r.SymbolKind.Property,Ne[b.SymbolKind.Field]=r.SymbolKind.Field,Ne[b.SymbolKind.Constructor]=r.SymbolKind.Constructor,Ne[b.SymbolKind.Enum]=r.SymbolKind.Enum,Ne[b.SymbolKind.Interface]=r.SymbolKind.Interface,Ne[b.SymbolKind.Function]=r.SymbolKind.Function,Ne[b.SymbolKind.Variable]=r.SymbolKind.Variable,Ne[b.SymbolKind.Constant]=r.SymbolKind.Constant,Ne[b.SymbolKind.String]=r.SymbolKind.String,Ne[b.SymbolKind.Number]=r.SymbolKind.Number,Ne[b.SymbolKind.Boolean]=r.SymbolKind.Boolean,Ne[b.SymbolKind.Array]=r.SymbolKind.Array,Ne[b.SymbolKind.Object]=r.SymbolKind.Object,Ne[b.SymbolKind.Key]=r.SymbolKind.Key,Ne[b.SymbolKind.Null]=r.SymbolKind.Null,Ne[b.SymbolKind.EnumMember]=r.SymbolKind.EnumMember,Ne[b.SymbolKind.Struct]=r.SymbolKind.Struct,Ne[b.SymbolKind.Event]=r.SymbolKind.Event,Ne[b.SymbolKind.Operator]=r.SymbolKind.Operator,Ne[b.SymbolKind.TypeParameter]=r.SymbolKind.TypeParameter;function de(Pe){return typeof Ne[Pe]=="number"?Ne[Pe]:r.SymbolKind.Property}ve.from=de;function J(Pe){for(const Me in Ne)if(Ne[Me]===Pe)return Number(Me);return b.SymbolKind.Property}ve.to=J})(we||(e.SymbolKind=we={}));var he;(function(ve){function Ne(J){switch(J){case b.SymbolTag.Deprecated:return r.SymbolTag.Deprecated}}ve.from=Ne;function de(J){switch(J){case r.SymbolTag.Deprecated:return b.SymbolTag.Deprecated}}ve.to=de})(he||(e.SymbolTag=he={}));var X;(function(ve){function Ne(J){return{name:J.name,kind:we.from(J.kind),tags:J.tags&&J.tags.map(he.from),containerName:J.containerName,location:ze.from(J.location)}}ve.from=Ne;function de(J){const Pe=new b.$MN(J.name,we.to(J.kind),J.containerName,ze.to(J.location));return Pe.tags=J.tags&&J.tags.map(he.to),Pe}ve.to=de})(X||(e.WorkspaceSymbol=X={}));var Y;(function(ve){function Ne(J){const Pe={name:J.name||"!!MISSING: name!!",detail:J.detail,range:N.from(J.range),selectionRange:N.from(J.selectionRange),kind:we.from(J.kind),tags:J.tags?.map(he.from)??[]};return J.children&&(Pe.children=J.children.map(Ne)),Pe}ve.from=Ne;function de(J){const Pe=new b.$NN(J.name,J.detail,we.to(J.kind),N.to(J.range),N.to(J.selectionRange));return(0,w.$Nb)(J.tags)&&(Pe.tags=J.tags.map(he.to)),J.children&&(Pe.children=J.children.map(de)),Pe}ve.to=de})(Y||(e.DocumentSymbol=Y={}));var pe;(function(ve){function Ne(J){const Pe=new b.$RN(we.to(J.kind),J.name,J.detail||"",s.URI.revive(J.uri),N.to(J.range),N.to(J.selectionRange));return Pe._sessionId=J._sessionId,Pe._itemId=J._itemId,Pe}ve.to=Ne;function de(J,Pe,Me){if(Pe=Pe??J._sessionId,Me=Me??J._itemId,Pe===void 0||Me===void 0)throw new Error("invalid item");return{_sessionId:Pe,_itemId:Me,name:J.name,detail:J.detail,kind:we.from(J.kind),uri:J.uri,range:N.from(J.range),selectionRange:N.from(J.selectionRange),tags:J.tags?.map(he.from)}}ve.from=de})(pe||(e.CallHierarchyItem=pe={}));var $e;(function(ve){function Ne(de){return new b.$SN(pe.to(de.from),de.fromRanges.map(J=>N.to(J)))}ve.to=Ne})($e||(e.CallHierarchyIncomingCall=$e={}));var Te;(function(ve){function Ne(de){return new b.$TN(pe.to(de.to),de.fromRanges.map(J=>N.to(J)))}ve.to=Ne})(Te||(e.CallHierarchyOutgoingCall=Te={}));var ze;(function(ve){function Ne(J){return{range:J.range&&N.from(J.range),uri:J.uri}}ve.from=Ne;function de(J){return new b.$FN(s.URI.revive(J.uri),N.to(J.range))}ve.to=de})(ze||(e.location=ze={}));var Se;(function(ve){function Ne(J){const Pe=J,Me=J;return{originSelectionRange:Pe.originSelectionRange?N.from(Pe.originSelectionRange):void 0,uri:Pe.targetUri?Pe.targetUri:Me.uri,range:N.from(Pe.targetRange?Pe.targetRange:Me.range),targetSelectionRange:Pe.targetSelectionRange?N.from(Pe.targetSelectionRange):void 0}}ve.from=Ne;function de(J){return{targetUri:s.URI.revive(J.uri),targetRange:N.to(J.range),targetSelectionRange:J.targetSelectionRange?N.to(J.targetSelectionRange):void 0,originSelectionRange:J.originSelectionRange?N.to(J.originSelectionRange):void 0}}ve.to=de})(Se||(e.DefinitionLink=Se={}));var Re;(function(ve){function Ne(J){return{range:N.from(J.range),contents:be.fromMany(J.contents),canIncreaseVerbosity:J.canIncreaseVerbosity,canDecreaseVerbosity:J.canDecreaseVerbosity}}ve.from=Ne;function de(J){const Pe=J.contents.map(be.to),Me=N.to(J.range),Ze=J.canIncreaseVerbosity,Ge=J.canDecreaseVerbosity;return new b.$JN(Pe,Me,Ze,Ge)}ve.to=de})(Re||(e.Hover=Re={}));var Oe;(function(ve){function Ne(J){return{range:N.from(J.range),expression:J.expression}}ve.from=Ne;function de(J){return new b.$EO(N.to(J.range),J.expression)}ve.to=de})(Oe||(e.EvaluatableExpression=Oe={}));var z;(function(ve){function Ne(J){if(J instanceof b.$FO)return{type:"text",range:N.from(J.range),text:J.text};if(J instanceof b.$GO)return{type:"variable",range:N.from(J.range),variableName:J.variableName,caseSensitiveLookup:J.caseSensitiveLookup};if(J instanceof b.$HO)return{type:"expression",range:N.from(J.range),expression:J.expression};throw new Error("Unknown 'InlineValue' type")}ve.from=Ne;function de(J){switch(J.type){case"text":return{range:N.to(J.range),text:J.text};case"variable":return{range:N.to(J.range),variableName:J.variableName,caseSensitiveLookup:J.caseSensitiveLookup};case"expression":return{range:N.to(J.range),expression:J.expression}}}ve.to=de})(z||(e.InlineValue=z={}));var U;(function(ve){function Ne(J){return{frameId:J.frameId,stoppedLocation:N.from(J.stoppedLocation)}}ve.from=Ne;function de(J){return new b.$IO(J.frameId,N.to(J.stoppedLocation))}ve.to=de})(U||(e.InlineValueContext=U={}));var K;(function(ve){function Ne(J){return{range:N.from(J.range),kind:J.kind}}ve.from=Ne;function de(J){return new b.$KN(N.to(J.range),J.kind)}ve.to=de})(K||(e.DocumentHighlight=K={}));var Q;(function(ve){function Ne(J){return{uri:J.uri,highlights:J.highlights.map(K.from)}}ve.from=Ne;function de(J){return new b.$LN(s.URI.revive(J.uri),J.highlights.map(K.to))}ve.to=de})(Q||(e.MultiDocumentHighlight=Q={}));var ne;(function(ve){function Ne(de){switch(de){case r.CompletionTriggerKind.TriggerCharacter:return b.CompletionTriggerKind.TriggerCharacter;case r.CompletionTriggerKind.TriggerForIncompleteCompletions:return b.CompletionTriggerKind.TriggerForIncompleteCompletions;case r.CompletionTriggerKind.Invoke:default:return b.CompletionTriggerKind.Invoke}}ve.to=Ne})(ne||(e.CompletionTriggerKind=ne={}));var fe;(function(ve){function Ne(de){return{triggerKind:ne.to(de.triggerKind),triggerCharacter:de.triggerCharacter}}ve.to=Ne})(fe||(e.CompletionContext=fe={}));var Ae;(function(ve){function Ne(J){switch(J){case b.CompletionItemTag.Deprecated:return r.CompletionItemTag.Deprecated}}ve.from=Ne;function de(J){switch(J){case r.CompletionItemTag.Deprecated:return b.CompletionItemTag.Deprecated}}ve.to=de})(Ae||(e.CompletionItemTag=Ae={}));var je;(function(ve){const Ne=new Map([[b.CompletionItemKind.Method,r.CompletionItemKind.Method],[b.CompletionItemKind.Function,r.CompletionItemKind.Function],[b.CompletionItemKind.Constructor,r.CompletionItemKind.Constructor],[b.CompletionItemKind.Field,r.CompletionItemKind.Field],[b.CompletionItemKind.Variable,r.CompletionItemKind.Variable],[b.CompletionItemKind.Class,r.CompletionItemKind.Class],[b.CompletionItemKind.Interface,r.CompletionItemKind.Interface],[b.CompletionItemKind.Struct,r.CompletionItemKind.Struct],[b.CompletionItemKind.Module,r.CompletionItemKind.Module],[b.CompletionItemKind.Property,r.CompletionItemKind.Property],[b.CompletionItemKind.Unit,r.CompletionItemKind.Unit],[b.CompletionItemKind.Value,r.CompletionItemKind.Value],[b.CompletionItemKind.Constant,r.CompletionItemKind.Constant],[b.CompletionItemKind.Enum,r.CompletionItemKind.Enum],[b.CompletionItemKind.EnumMember,r.CompletionItemKind.EnumMember],[b.CompletionItemKind.Keyword,r.CompletionItemKind.Keyword],[b.CompletionItemKind.Snippet,r.CompletionItemKind.Snippet],[b.CompletionItemKind.Text,r.CompletionItemKind.Text],[b.CompletionItemKind.Color,r.CompletionItemKind.Color],[b.CompletionItemKind.File,r.CompletionItemKind.File],[b.CompletionItemKind.Reference,r.CompletionItemKind.Reference],[b.CompletionItemKind.Folder,r.CompletionItemKind.Folder],[b.CompletionItemKind.Event,r.CompletionItemKind.Event],[b.CompletionItemKind.Operator,r.CompletionItemKind.Operator],[b.CompletionItemKind.TypeParameter,r.CompletionItemKind.TypeParameter],[b.CompletionItemKind.Issue,r.CompletionItemKind.Issue],[b.CompletionItemKind.User,r.CompletionItemKind.User]]);function de(Me){return Ne.get(Me)??r.CompletionItemKind.Property}ve.from=de;const J=new Map([[r.CompletionItemKind.Method,b.CompletionItemKind.Method],[r.CompletionItemKind.Function,b.CompletionItemKind.Function],[r.CompletionItemKind.Constructor,b.CompletionItemKind.Constructor],[r.CompletionItemKind.Field,b.CompletionItemKind.Field],[r.CompletionItemKind.Variable,b.CompletionItemKind.Variable],[r.CompletionItemKind.Class,b.CompletionItemKind.Class],[r.CompletionItemKind.Interface,b.CompletionItemKind.Interface],[r.CompletionItemKind.Struct,b.CompletionItemKind.Struct],[r.CompletionItemKind.Module,b.CompletionItemKind.Module],[r.CompletionItemKind.Property,b.CompletionItemKind.Property],[r.CompletionItemKind.Unit,b.CompletionItemKind.Unit],[r.CompletionItemKind.Value,b.CompletionItemKind.Value],[r.CompletionItemKind.Constant,b.CompletionItemKind.Constant],[r.CompletionItemKind.Enum,b.CompletionItemKind.Enum],[r.CompletionItemKind.EnumMember,b.CompletionItemKind.EnumMember],[r.CompletionItemKind.Keyword,b.CompletionItemKind.Keyword],[r.CompletionItemKind.Snippet,b.CompletionItemKind.Snippet],[r.CompletionItemKind.Text,b.CompletionItemKind.Text],[r.CompletionItemKind.Color,b.CompletionItemKind.Color],[r.CompletionItemKind.File,b.CompletionItemKind.File],[r.CompletionItemKind.Reference,b.CompletionItemKind.Reference],[r.CompletionItemKind.Folder,b.CompletionItemKind.Folder],[r.CompletionItemKind.Event,b.CompletionItemKind.Event],[r.CompletionItemKind.Operator,b.CompletionItemKind.Operator],[r.CompletionItemKind.TypeParameter,b.CompletionItemKind.TypeParameter],[r.CompletionItemKind.User,b.CompletionItemKind.User],[r.CompletionItemKind.Issue,b.CompletionItemKind.Issue]]);function Pe(Me){return J.get(Me)??b.CompletionItemKind.Property}ve.to=Pe})(je||(e.CompletionItemKind=je={}));var Ke;(function(ve){function Ne(de,J){const Pe=new b.$2N(de.label);return Pe.insertText=de.insertText,Pe.kind=je.to(de.kind),Pe.tags=de.tags?.map(Ae.to),Pe.detail=de.detail,Pe.documentation=A.$5k(de.documentation)?be.to(de.documentation):de.documentation,Pe.sortText=de.sortText,Pe.filterText=de.filterText,Pe.preselect=de.preselect,Pe.commitCharacters=de.commitCharacters,h.$Ht.isIRange(de.range)?Pe.range=N.to(de.range):typeof de.range=="object"&&(Pe.range={inserting:N.to(de.range.insert),replacing:N.to(de.range.replace)}),Pe.keepWhitespace=typeof de.insertTextRules>"u"?!1:!!(de.insertTextRules&r.CompletionItemInsertTextRule.KeepWhitespace),typeof de.insertTextRules<"u"&&de.insertTextRules&r.CompletionItemInsertTextRule.InsertAsSnippet?Pe.insertText=new b.$EN(de.insertText):(Pe.insertText=de.insertText,Pe.textEdit=Pe.range instanceof b.$vN?new b.$AN(Pe.range,Pe.insertText):void 0),de.additionalTextEdits&&de.additionalTextEdits.length>0&&(Pe.additionalTextEdits=de.additionalTextEdits.map(Me=>ye.to(Me))),Pe.command=J&&de.command?J.fromInternal(de.command):void 0,Pe}ve.to=Ne})(Ke||(e.CompletionItem=Ke={}));var _e;(function(ve){function Ne(J){if(typeof J.label!="string"&&!Array.isArray(J.label))throw new TypeError("Invalid label");return{label:J.label,documentation:be.fromStrict(J.documentation)}}ve.from=Ne;function de(J){return{label:J.label,documentation:A.$5k(J.documentation)?be.to(J.documentation):J.documentation}}ve.to=de})(_e||(e.ParameterInformation=_e={}));var it;(function(ve){function Ne(J){return{label:J.label,documentation:be.fromStrict(J.documentation),parameters:Array.isArray(J.parameters)?J.parameters.map(_e.from):[],activeParameter:J.activeParameter}}ve.from=Ne;function de(J){return{label:J.label,documentation:A.$5k(J.documentation)?be.to(J.documentation):J.documentation,parameters:Array.isArray(J.parameters)?J.parameters.map(_e.to):[],activeParameter:J.activeParameter}}ve.to=de})(it||(e.SignatureInformation=it={}));var nt;(function(ve){function Ne(J){return{activeSignature:J.activeSignature,activeParameter:J.activeParameter,signatures:Array.isArray(J.signatures)?J.signatures.map(it.from):[]}}ve.from=Ne;function de(J){return{activeSignature:J.activeSignature,activeParameter:J.activeParameter,signatures:Array.isArray(J.signatures)?J.signatures.map(it.to):[]}}ve.to=de})(nt||(e.SignatureHelp=nt={}));var tt;(function(ve){function Ne(de,J){const Pe=new b.$1N(W.to(J.position),typeof J.label=="string"?J.label:J.label.map(rt.to.bind(void 0,de)),J.kind&&$t.to(J.kind));return Pe.textEdits=J.textEdits&&J.textEdits.map(ye.to),Pe.tooltip=A.$5k(J.tooltip)?be.to(J.tooltip):J.tooltip,Pe.paddingLeft=J.paddingLeft,Pe.paddingRight=J.paddingRight,Pe}ve.to=Ne})(tt||(e.InlayHint=tt={}));var rt;(function(ve){function Ne(de,J){const Pe=new b.$ZN(J.label);return Pe.tooltip=A.$5k(J.tooltip)?be.to(J.tooltip):J.tooltip,r.Command.is(J.command)&&(Pe.command=de.fromInternal(J.command)),J.location&&(Pe.location=ze.to(J.location)),Pe}ve.to=Ne})(rt||(e.InlayHintLabelPart=rt={}));var $t;(function(ve){function Ne(J){return J}ve.from=Ne;function de(J){return J}ve.to=de})($t||(e.InlayHintKind=$t={}));var lt;(function(ve){function Ne(J){return{range:N.from(J.range),url:J.target,tooltip:J.tooltip}}ve.from=Ne;function de(J){let Pe;if(J.url)try{Pe=typeof J.url=="string"?s.URI.parse(J.url,!0):s.URI.revive(J.url)}catch{}const Me=new b.$7N(N.to(J.range),Pe);return Me.tooltip=J.tooltip,Me}ve.to=de})(lt||(e.DocumentLink=lt={}));var st;(function(ve){function Ne(J){const Pe=new b.$0N(J.label);return J.textEdit&&(Pe.textEdit=ye.to(J.textEdit)),J.additionalTextEdits&&(Pe.additionalTextEdits=J.additionalTextEdits.map(Me=>ye.to(Me))),Pe}ve.to=Ne;function de(J){return{label:J.label,textEdit:J.textEdit?ye.from(J.textEdit):void 0,additionalTextEdits:J.additionalTextEdits?J.additionalTextEdits.map(Pe=>ye.from(Pe)):void 0}}ve.from=de})(st||(e.ColorPresentation=st={}));var ut;(function(ve){function Ne(J){return new b.$8N(J[0],J[1],J[2],J[3])}ve.to=Ne;function de(J){return[J.red,J.green,J.blue,J.alpha]}ve.from=de})(ut||(e.Color=ut={}));var ft;(function(ve){function Ne(J){return{range:N.from(J.range)}}ve.from=Ne;function de(J){return new b.$QN(N.to(J.range))}ve.to=de})(ft||(e.SelectionRange=ft={}));var mt;(function(ve){function Ne(de){switch(de){case f.SaveReason.AUTO:return b.TextDocumentSaveReason.AfterDelay;case f.SaveReason.EXPLICIT:return b.TextDocumentSaveReason.Manual;case f.SaveReason.FOCUS_CHANGE:case f.SaveReason.WINDOW_CHANGE:return b.TextDocumentSaveReason.FocusOut}}ve.to=Ne})(mt||(e.TextDocumentSaveReason=mt={}));var We;(function(ve){function Ne(J){switch(J){case b.TextEditorLineNumbersStyle.Off:return o.RenderLineNumbersType.Off;case b.TextEditorLineNumbersStyle.Relative:return o.RenderLineNumbersType.Relative;case b.TextEditorLineNumbersStyle.Interval:return o.RenderLineNumbersType.Interval;case b.TextEditorLineNumbersStyle.On:default:return o.RenderLineNumbersType.On}}ve.from=Ne;function de(J){switch(J){case o.RenderLineNumbersType.Off:return b.TextEditorLineNumbersStyle.Off;case o.RenderLineNumbersType.Relative:return b.TextEditorLineNumbersStyle.Relative;case o.RenderLineNumbersType.Interval:return b.TextEditorLineNumbersStyle.Interval;case o.RenderLineNumbersType.On:default:return b.TextEditorLineNumbersStyle.On}}ve.to=de})(We||(e.TextEditorLineNumbersStyle=We={}));var Be;(function(ve){function Ne(J){if(J===b.EndOfLine.CRLF)return t.EndOfLineSequence.CRLF;if(J===b.EndOfLine.LF)return t.EndOfLineSequence.LF}ve.from=Ne;function de(J){if(J===t.EndOfLineSequence.CRLF)return b.EndOfLine.CRLF;if(J===t.EndOfLineSequence.LF)return b.EndOfLine.LF}ve.to=de})(Be||(e.EndOfLine=Be={}));var H;(function(ve){function Ne(de){if(typeof de=="object")return de.viewId;switch(de){case b.ProgressLocation.SourceControl:return l.ProgressLocation.Scm;case b.ProgressLocation.Window:return l.ProgressLocation.Window;case b.ProgressLocation.Notification:return l.ProgressLocation.Notification}throw new Error("Unknown 'ProgressLocation'")}ve.from=Ne})(H||(e.ProgressLocation=H={}));var x;(function(ve){function Ne(J){const Pe={start:J.start+1,end:J.end+1};return J.kind&&(Pe.kind=Ee.from(J.kind)),Pe}ve.from=Ne;function de(J){const Pe={start:J.start-1,end:J.end-1};return J.kind&&(Pe.kind=Ee.to(J.kind)),Pe}ve.to=de})(x||(e.FoldingRange=x={}));var Ee;(function(ve){function Ne(J){if(J)switch(J){case b.FoldingRangeKind.Comment:return r.$Hu.Comment;case b.FoldingRangeKind.Imports:return r.$Hu.Imports;case b.FoldingRangeKind.Region:return r.$Hu.Region}}ve.from=Ne;function de(J){if(J)switch(J.value){case r.$Hu.Comment.value:return b.FoldingRangeKind.Comment;case r.$Hu.Imports.value:return b.FoldingRangeKind.Imports;case r.$Hu.Region.value:return b.FoldingRangeKind.Region}}ve.to=de})(Ee||(e.FoldingRangeKind=Ee={}));var Je;(function(ve){function Ne(de){if(de)return{pinned:typeof de.preview=="boolean"?!de.preview:void 0,inactive:de.background,preserveFocus:de.preserveFocus,selection:typeof de.selection=="object"?N.from(de.selection):void 0,override:typeof de.override=="boolean"?f.$OF.id:void 0}}ve.from=Ne})(Je||(e.TextEditorOpenOptions=Je={}));var xe;(function(ve){function Ne(Me){return Me instanceof b.$sO?Me.toJSON():typeof Me=="string"?Me:de(Me)||J(Me)?new b.$sO(Me.baseUri??Me.base,Me.pattern).toJSON():Me}ve.from=Ne;function de(Me){const Ze=Me;return Ze?s.URI.isUri(Ze.baseUri)&&typeof Ze.pattern=="string":!1}function J(Me){const Ze=Me;return Ze?typeof Ze.base=="string"&&typeof Ze.pattern=="string":!1}function Pe(Me){return typeof Me=="string"?Me:new b.$sO(s.URI.revive(Me.baseUri),Me.pattern)}ve.to=Pe})(xe||(e.GlobPattern=xe={}));var ht;(function(ve){function Ne(de){if(de){if(Array.isArray(de))return de.map(Ne);if(typeof de=="string")return de;{const J=de;return{language:J.language,scheme:J.scheme,pattern:xe.from(J.pattern),exclusive:J.exclusive,notebookType:J.notebookType}}}else return}ve.from=Ne})(ht||(e.LanguageSelector=ht={}));var pt;(function(ve){function Ne(J){return!!J&&typeof J=="object"&&"documents"in J&&Array.isArray(J.documents)&&J.documents.every(Pe=>Array.isArray(Pe)&&Pe.every(Me=>Me&&typeof Me=="object"&&"uri"in Me&&s.URI.isUri(Me.uri)&&"version"in Me&&typeof Me.version=="number"&&"ranges"in Me&&Array.isArray(Me.ranges)&&Me.ranges.every(Ze=>Ze instanceof b.$vN)))}ve.is=Ne;function de(J){return{documents:J.documents.map(Pe=>Pe.map(Me=>({uri:s.URI.from(Me.uri),version:Me.version,ranges:Me.ranges.map(Ze=>N.from(Ze))})))}}ve.from=de})(pt||(e.MappedEditsContext=pt={}));var Ft;(function(ve){function Ne(J){return{start:J.start,end:J.end}}ve.from=Ne;function de(J){return new b.$VO(J.start,J.end)}ve.to=de})(Ft||(e.NotebookRange=Ft={}));var Ut;(function(ve){function Ne(J){return{timing:typeof J.runStartTime=="number"&&typeof J.runEndTime=="number"?{startTime:J.runStartTime,endTime:J.runEndTime}:void 0,executionOrder:J.executionOrder,success:J.lastRunSuccess}}ve.to=Ne;function de(J){return{lastRunSuccess:J.success,runStartTime:J.timing?.startTime,runEndTime:J.timing?.endTime,executionOrder:J.executionOrder}}ve.from=de})(Ut||(e.NotebookCellExecutionSummary=Ut={}));var Zt;(function(ve){function Ne(de){if(de===v.NotebookCellExecutionState.Unconfirmed)return b.NotebookCellExecutionState.Pending;if(de===v.NotebookCellExecutionState.Pending)return;if(de===v.NotebookCellExecutionState.Executing)return b.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${de}`)}ve.to=Ne})(Zt||(e.NotebookCellExecutionState=Zt={}));var di;(function(ve){function Ne(J){switch(J){case b.NotebookCellKind.Markup:return v.CellKind.Markup;case b.NotebookCellKind.Code:default:return v.CellKind.Code}}ve.from=Ne;function de(J){switch(J){case v.CellKind.Markup:return b.NotebookCellKind.Markup;case v.CellKind.Code:default:return b.NotebookCellKind.Code}}ve.to=de})(di||(e.NotebookCellKind=di={}));var Ye;(function(ve){function Ne(J){const Pe={metadata:J.metadata??Object.create(null),cells:[]};for(const Me of J.cells)b.$WO.validate(Me),Pe.cells.push(Pt.from(Me));return Pe}ve.from=Ne;function de(J){const Pe=new b.$XO(J.cells.map(Pt.to));return(0,n.$sg)(J.metadata)||(Pe.metadata=J.metadata),Pe}ve.to=de})(Ye||(e.NotebookData=Ye={}));var Pt;(function(ve){function Ne(J){return{cellKind:di.from(J.kind),language:J.languageId,mime:J.mime,source:J.value,metadata:J.metadata,internalMetadata:Ut.from(J.executionSummary??{}),outputs:J.outputs?J.outputs.map(Kt.from):[]}}ve.from=Ne;function de(J){return new b.$WO(di.to(J.cellKind),J.source,J.language,J.mime,J.outputs?J.outputs.map(Kt.to):void 0,J.metadata,J.internalMetadata?Ut.to(J.internalMetadata):void 0)}ve.to=de})(Pt||(e.NotebookCellData=Pt={}));var Gt;(function(ve){function Ne(J){return{mime:J.mime,valueBytes:S.$Oe.wrap(J.data)}}ve.from=Ne;function de(J){return new b.$YO(J.valueBytes.buffer,J.mime)}ve.to=de})(Gt||(e.NotebookCellOutputItem=Gt={}));var Kt;(function(ve){function Ne(J){return{outputId:J.id,items:J.items.map(Gt.from),metadata:J.metadata}}ve.from=Ne;function de(J){const Pe=J.items.map(Gt.to);return new b.$ZO(Pe,J.outputId,J.metadata)}ve.to=de})(Kt||(e.NotebookCellOutput=Kt={}));var gt;(function(ve){function Ne(Pe){return J(Pe)?{include:xe.from(Pe.include)??void 0,exclude:xe.from(Pe.exclude)??void 0}:xe.from(Pe)??void 0}ve.from=Ne;function de(Pe){return J(Pe)?{include:xe.to(Pe.include),exclude:xe.to(Pe.exclude)}:xe.to(Pe)}ve.to=de;function J(Pe){const Me=Pe;return Me?!(0,n.$og)(Me.include)&&!(0,n.$og)(Me.exclude):!1}})(gt||(e.NotebookExclusiveDocumentPattern=gt={}));var vt;(function(ve){function Ne(de,J,Pe){const Me=typeof de.command=="string"?{title:"",command:de.command}:de.command;return{alignment:de.alignment===b.NotebookCellStatusBarAlignment.Left?v.CellStatusbarAlignment.Left:v.CellStatusbarAlignment.Right,command:J.toInternal(Me,Pe),text:de.text,tooltip:de.tooltip,accessibilityInformation:de.accessibilityInformation,priority:de.priority}}ve.from=Ne})(vt||(e.NotebookStatusBarItem=vt={}));var ii;(function(ve){function Ne(de,J,Pe){const Me=typeof de.command=="string"?{title:"",command:de.command}:de.command;return{command:J.toInternal(Me,Pe),label:de.label,description:de.description,detail:de.detail,documentation:de.documentation}}ve.from=Ne})(ii||(e.NotebookKernelSourceAction=ii={}));var Yt;(function(ve){function Ne(de){return{transientOutputs:de?.transientOutputs??!1,transientCellMetadata:de?.transientCellMetadata??{},transientDocumentMetadata:de?.transientDocumentMetadata??{},cellContentMetadata:de?.cellContentMetadata??{}}}ve.from=Ne})(Yt||(e.NotebookDocumentContentOptions=Yt={}));var Wt;(function(ve){function Ne(J){return{uri:J.uri,provides:J.provides}}ve.from=Ne;function de(J){return new b.$2O(s.URI.revive(J.uri),J.provides)}ve.to=de})(Wt||(e.NotebookRendererScript=Wt={}));var yt;(function(ve){function Ne(J){return{message:be.fromStrict(J.message)||"",type:P.TestMessageType.Error,expected:J.expectedOutput,actual:J.actualOutput,contextValue:J.contextValue,location:J.location&&{range:N.from(J.location.range),uri:J.location.uri}}}ve.from=Ne;function de(J){const Pe=new b.$8O(typeof J.message=="string"?J.message:be.to(J.message));return Pe.actualOutput=J.actual,Pe.expectedOutput=J.expected,Pe.contextValue=J.contextValue,Pe.location=J.location?ze.to(J.location):void 0,Pe}ve.to=de})(yt||(e.TestMessage=yt={}));var Ot;(function(ve){ve.namespace=P.$VI,ve.denamespace=P.$WI})(Ot||(e.TestTag=Ot={}));var ui;(function(ve){function Ne(J){const Pe=(0,m.$TP)(J).controllerId;return{extId:C.$QI.fromExtHostTestItem(J,Pe).toString(),label:J.label,uri:s.URI.revive(J.uri),busy:J.busy,tags:J.tags.map(Me=>Ot.namespace(Pe,Me.id)),range:h.$Ht.lift(N.from(J.range)),description:J.description||null,sortText:J.sortText||null,error:J.error&&be.fromStrict(J.error)||null}}ve.from=Ne;function de(J){return{parent:void 0,error:void 0,id:C.$QI.fromString(J.extId).localId,label:J.label,uri:s.URI.revive(J.uri),tags:(J.tags||[]).map(Pe=>{const{tagId:Me}=Ot.denamespace(Pe);return new b.$9O(Me)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:N.to(J.range||void 0),canResolveChildren:!1,busy:J.busy,description:J.description||void 0,sortText:J.sortText||void 0}}ve.toPlain=de})(ui||(e.TestItem=ui={})),function(ve){function Ne(J){return{id:J.id}}ve.from=Ne;function de(J){return new b.$9O(J.id)}ve.to=de}(Ot||(e.TestTag=Ot={}));var Vt;(function(ve){const Ne=(J,Pe)=>{const Me=J.value;if(!Me)return;const Ze={...ui.toPlain(Me.item),parent:Pe,taskStates:Me.tasks.map(Ge=>({state:Ge.state,duration:Ge.duration,messages:Ge.messages.filter(ct=>ct.type===P.TestMessageType.Error).map(yt.to)})),children:[]};if(J.children)for(const Ge of J.children.values()){const ct=Ne(Ge,Ze);ct&&Ze.children.push(ct)}return Ze};function de(J){const Pe=new u.$PI;for(const Ge of J.items)Pe.insert(C.$QI.fromString(Ge.item.extId).path,Ge);const Me=[Pe.nodes],Ze=[];for(;Me.length;)for(const Ge of Me.pop())Ge.value?Ze.push(Ge):Ge.children&&Me.push(Ge.children.values());return{completedAt:J.completedAt,results:Ze.map(Ge=>Ne(Ge)).filter(n.$ng)}}ve.to=de})(Vt||(e.TestResults=Vt={}));var Xe;(function(ve){function Ne(Me){return{covered:Me.covered,total:Me.total}}function de(Me){return"line"in Me?W.from(Me):N.from(Me)}function J(Me){if(typeof Me.executed=="number"&&Me.executed<0)throw new Error(`Invalid coverage count ${Me.executed}`);return"branches"in Me?{count:Me.executed,location:de(Me.location),type:P.DetailType.Statement,branches:Me.branches.length?Me.branches.map(Ze=>({count:Ze.executed,location:Ze.location&&de(Ze.location),label:Ze.label})):void 0}:{type:P.DetailType.Declaration,name:Me.name,count:Me.executed,location:de(Me.location)}}ve.fromDetails=J;function Pe(Me,Ze,Ge){return b.$$O(Ge.statementCoverage),b.$$O(Ge.branchCoverage),b.$$O(Ge.declarationCoverage),{id:Ze,uri:Ge.uri,statement:Ne(Ge.statementCoverage),branch:Ge.branchCoverage&&Ne(Ge.branchCoverage),declaration:Ge.declarationCoverage&&Ne(Ge.declarationCoverage),testIds:Ge instanceof b.$_O&&Ge.fromTests.length?Ge.fromTests.map(ct=>C.$QI.fromExtHostTestItem(ct,Me).toString()):void 0}}ve.fromFile=Pe})(Xe||(e.TestCoverage=Xe={}));var xt;(function(ve){function Ne(de){switch(de){case r.CodeActionTriggerType.Invoke:return b.CodeActionTriggerKind.Invoke;case r.CodeActionTriggerType.Auto:return b.CodeActionTriggerKind.Automatic}}ve.to=Ne})(xt||(e.CodeActionTriggerKind=xt={}));var ni;(function(ve){function Ne(J){const Pe=new b.$dP(we.to(J.kind),J.name,J.detail||"",s.URI.revive(J.uri),N.to(J.range),N.to(J.selectionRange));return Pe._sessionId=J._sessionId,Pe._itemId=J._itemId,Pe}ve.to=Ne;function de(J,Pe,Me){if(Pe=Pe??J._sessionId,Me=Me??J._itemId,Pe===void 0||Me===void 0)throw new Error("invalid item");return{_sessionId:Pe,_itemId:Me,kind:we.from(J.kind),name:J.name,detail:J.detail??"",uri:J.uri,range:N.from(J.range),selectionRange:N.from(J.selectionRange),tags:J.tags?.map(he.from)}}ve.from=de})(ni||(e.TypeHierarchyItem=ni={}));var li;(function(ve){function Ne(de){if(de)return{value:de.value,tooltip:de.tooltip}}ve.from=Ne})(li||(e.ViewBadge=li={}));var kt;(function(ve){function Ne(Me,Ze,Ge){const ct=Ze.fileData;return ct?new b.$kO(new b.$lO(ct.name,s.URI.revive(ct.uri),ct.id,(0,O.$fb)(()=>Ge(ct.id)))):Me===R.$4s.uriList&&Ze.uriListData?new b.$jO(Pe(Ze.uriListData)):new b.$jO(Ze.asString)}ve.to=Ne;async function de(Me,Ze){const Ge=await Ze.asString();if(Me===R.$4s.uriList)return{asString:Ge,fileData:void 0,uriListData:J(Ge)};const ct=Ze.asFile();return{asString:Ge,fileData:ct?{name:ct.name,uri:ct.uri,id:ct._itemId??ct.id}:void 0}}ve.from=de;function J(Me){return k.$lu.split(Me).map(Ze=>{if(Ze.startsWith("#"))return Ze;try{return s.URI.parse(Ze)}catch{}return Ze})}function Pe(Me){return k.$lu.create(Me.map(Ze=>typeof Ze=="string"?Ze:s.URI.revive(Ze)))}})(kt||(e.DataTransferItem=kt={}));var Lt;(function(ve){function Ne(J,Pe){const Me=J.items.map(([Ze,Ge])=>[Ze,kt.to(Ze,Ge,Pe)]);return new b.$mO(Me)}ve.toDataTransfer=Ne;async function de(J){const Pe={items:[]},Me=[];for(const[Ze,Ge]of J)Me.push((async()=>{Pe.items.push([Ze,await kt.from(Ze,Ge)])})());return await Promise.all(Me),Pe}ve.from=de})(Lt||(e.DataTransfer=Lt={}));var At;(function(ve){function Ne(J,Pe){return{kind:"reply",agentId:J.participant??Pe?.agentId??"",subCommand:J.command??Pe?.command,message:J.prompt,title:J.label}}ve.from=Ne;function de(J){return{prompt:J.message,label:J.title,participant:J.agentId,command:J.subCommand}}ve.to=de})(At||(e.ChatFollowup=At={}));var zt;(function(ve){function Ne(J){switch(J){case I.ChatMessageRole.System:return b.LanguageModelChatMessageRole.System;case I.ChatMessageRole.User:return b.LanguageModelChatMessageRole.User;case I.ChatMessageRole.Assistant:return b.LanguageModelChatMessageRole.Assistant}}ve.to=Ne;function de(J){switch(J){case b.LanguageModelChatMessageRole.System:return I.ChatMessageRole.System;case b.LanguageModelChatMessageRole.User:return I.ChatMessageRole.User;case b.LanguageModelChatMessageRole.Assistant:return I.ChatMessageRole.Assistant}return I.ChatMessageRole.User}ve.from=de})(zt||(e.LanguageModelChatMessageRole=zt={}));var ri;(function(ve){function Ne(J){let Pe="",Me;J.content.type==="text"?Pe=J.content.value:Me=new b.$EP(J.content.name,J.content.value,J.content.isError);const Ze=zt.to(J.role),Ge=new b.$FP(Ze,Pe,J.name);return Me!==void 0&&(Ge.content2=Me),Ge}ve.to=Ne;function de(J){const Pe=zt.from(J.role),Me=J.name;let Ze;return J.content2 instanceof b.$EP?Ze={type:"function_result",name:J.content2.name,value:J.content2.content,isError:J.content2.isError}:Ze={type:"text",value:J.content},{role:Pe,name:Me,content:Ze}}ve.from=de})(ri||(e.LanguageModelChatMessage=ri={}));var _t;(function(ve){function Ne(J){return{kind:"markdownContent",content:be.from(J.value)}}ve.from=Ne;function de(J){return new b.$qP(be.to(J.content))}ve.to=de})(_t||(e.ChatResponseMarkdownPart=_t={}));var si;(function(ve){function Ne(J){return{kind:"markdownVuln",content:be.from(J.value),vulnerabilities:J.vulnerabilities}}ve.from=Ne;function de(J){return new b.$rP(be.to(J.content),J.vulnerabilities)}ve.to=de})(si||(e.ChatResponseMarkdownWithVulnerabilitiesPart=si={}));var jt;(function(ve){function Ne(J){return{kind:"agentDetection",agentId:J.participant,command:J.command}}ve.from=Ne;function de(J){return new b.$sP(J.agentId,J.command)}ve.to=de})(jt||(e.ChatResponseDetectedParticipantPart=jt={}));var Ht;(function(ve){function Ne(de){return{kind:"confirmation",title:de.title,message:de.message,data:de.data}}ve.from=Ne})(Ht||(e.ChatResponseConfirmationPart=Ht={}));var oi;(function(ve){function Ne(J){const{value:Pe,baseUri:Me}=J;function Ze(Ge,ct){return Ge.map(It=>{const Qt=s.URI.joinPath(ct,It.name);return{label:It.name,uri:Qt,children:It.children&&Ze(It.children,Qt)}})}return{kind:"treeData",treeData:{label:(0,E.$dh)(Me),uri:Me,children:Ze(Pe,Me)}}}ve.from=Ne;function de(J){const Pe=(0,a.$ci)(J.treeData);function Me(ct){return ct.map(It=>({name:It.label,children:It.children&&Me(It.children)}))}const Ze=Pe.uri,Ge=Pe.children?Me(Pe.children):[];return new b.$uP(Ge,Ze)}ve.to=de})(oi||(e.ChatResponseFilesPart=oi={}));var Rt;(function(ve){function Ne(J){const Pe=Me=>s.URI.isUri(Me);return{kind:"inlineReference",name:J.title,inlineReference:Pe(J.value)?J.value:B.from(J.value)}}ve.from=Ne;function de(J){const Pe=(0,a.$ci)(J);return new b.$vP(s.URI.isUri(Pe.inlineReference)?Pe.inlineReference:B.to(Pe.inlineReference),J.name)}ve.to=de})(Rt||(e.ChatResponseAnchorPart=Rt={}));var St;(function(ve){function Ne(J){return{kind:"progressMessage",content:be.from(J.value)}}ve.from=Ne;function de(J){return new b.$wP(J.content.value)}ve.to=de})(St||(e.ChatResponseProgressPart=St={}));var wt;(function(ve){function Ne(J){return{kind:"warning",content:be.from(J.value)}}ve.from=Ne;function de(J){return new b.$yP(J.content.value)}ve.to=de})(wt||(e.ChatResponseWarningPart=wt={}));var ei;(function(ve){function Ne(de){return{kind:"progressTask",content:be.from(de.value)}}ve.from=Ne})(ei||(e.ChatTask=ei={}));var Ct;(function(ve){function Ne(de){return{kind:"progressTaskResult",content:typeof de=="string"?be.from(de):void 0}}ve.from=Ne})(Ct||(e.ChatTaskResult=Ct={}));var hi;(function(ve){function Ne(J,Pe,Me){return{kind:"command",command:Pe.toInternal(J.value,Me)??{command:J.value.command,title:J.value.title}}}ve.from=Ne;function de(J,Pe){return new b.$zP(Pe.fromInternal(J.command)??{command:J.command.id,title:J.command.title})}ve.to=de})(hi||(e.ChatResponseCommandButtonPart=hi={}));var qt;(function(ve){function Ne(J){return{kind:"textEdit",uri:J.uri,edits:J.edits.map(Pe=>ye.from(Pe))}}ve.from=Ne;function de(J){return new b.$BP(s.URI.revive(J.uri),J.edits.map(Pe=>ye.to(Pe)))}ve.to=de})(qt||(e.ChatResponseTextEditPart=qt={}));var bi;(function(ve){function Ne(J){const Pe=d.ThemeIcon.isThemeIcon(J.iconPath)?J.iconPath:s.URI.isUri(J.iconPath)?{light:s.URI.revive(J.iconPath)}:J.iconPath&&"light"in J.iconPath&&"dark"in J.iconPath&&s.URI.isUri(J.iconPath.light)&&s.URI.isUri(J.iconPath.dark)?{light:s.URI.revive(J.iconPath.light),dark:s.URI.revive(J.iconPath.dark)}:void 0;return"variableName"in J.value?{kind:"reference",reference:{variableName:J.value.variableName,value:s.URI.isUri(J.value.value)||!J.value.value?J.value.value:B.from(J.value.value)},iconPath:Pe}:{kind:"reference",reference:s.URI.isUri(J.value)?J.value:B.from(J.value),iconPath:Pe}}ve.from=Ne;function de(J){const Pe=(0,a.$ci)(J),Me=Ze=>s.URI.isUri(Ze)?Ze:B.to(Ze);return new b.$AP("variableName"in Pe.reference?{variableName:Pe.reference.variableName,value:Pe.reference.value&&Me(Pe.reference.value)}:Me(Pe.reference))}ve.to=de})(bi||(e.ChatResponseReferencePart=bi={}));var wi;(function(ve){function Ne(Pe,Me,Ze){return Pe instanceof b.$qP?_t.from(Pe):Pe instanceof b.$vP?Rt.from(Pe):Pe instanceof b.$AP?bi.from(Pe):Pe instanceof b.$wP?St.from(Pe):Pe instanceof b.$uP?oi.from(Pe):Pe instanceof b.$zP?hi.from(Pe,Me,Ze):Pe instanceof b.$BP?qt.from(Pe):Pe instanceof b.$rP?si.from(Pe):Pe instanceof b.$sP?jt.from(Pe):Pe instanceof b.$yP?wt.from(Pe):{kind:"markdownContent",content:be.from("")}}ve.from=Ne;function de(Pe,Me){switch(Pe.kind){case"reference":return bi.to(Pe);case"markdownContent":case"inlineReference":case"progressMessage":case"treeData":case"command":return J(Pe,Me)}}ve.to=de;function J(Pe,Me){switch(Pe.kind){case"markdownContent":return _t.to(Pe);case"inlineReference":return Rt.to(Pe);case"progressMessage":return;case"treeData":return oi.to(Pe);case"command":return hi.to(Pe,Me)}}ve.toContent=J})(wi||(e.ChatResponsePart=wi={}));var fi;(function(ve){function Ne(de){return{prompt:de.message,command:de.command,attempt:de.attempt??0,enableCommandDetection:de.enableCommandDetection??!0,references:de.variables.variables.map(ai.to),location:Bt.to(de.location),acceptedConfirmationData:de.acceptedConfirmationData,rejectedConfirmationData:de.rejectedConfirmationData}}ve.to=Ne})(fi||(e.ChatAgentRequest=fi={}));var Bt;(function(ve){function Ne(J){switch(J){case $.ChatAgentLocation.Notebook:return b.ChatLocation.Notebook;case $.ChatAgentLocation.Terminal:return b.ChatLocation.Terminal;case $.ChatAgentLocation.Panel:return b.ChatLocation.Panel;case $.ChatAgentLocation.Editor:return b.ChatLocation.Editor}}ve.to=Ne;function de(J){switch(J){case b.ChatLocation.Notebook:return $.ChatAgentLocation.Notebook;case b.ChatLocation.Terminal:return $.ChatAgentLocation.Terminal;case b.ChatLocation.Panel:return $.ChatAgentLocation.Panel;case b.ChatLocation.Editor:return $.ChatAgentLocation.Editor}}ve.from=de})(Bt||(e.ChatLocation=Bt={}));var ai;(function(ve){function Ne(de){const J=de.value;if(!J)throw new Error("Invalid value reference");return{id:de.id,name:de.name,range:de.range&&[de.range.start,de.range.endExclusive],value:(0,s.$xc)(J)?s.URI.revive(J):J&&typeof J=="object"&&"uri"in J&&"range"in J&&(0,s.$xc)(J.uri)?B.to((0,a.$ci)(J)):J,modelDescription:de.modelDescription}}ve.to=Ne})(ai||(e.ChatAgentValueReference=ai={}));var Ci;(function(ve){function Ne(de,J,Pe){return{id:de.id,label:de.label,fullName:de.fullName,icon:de.icon?.id,value:de.values[0].value,insertText:de.insertText,detail:de.detail,documentation:de.documentation,command:J.toInternal(de.command,Pe)}}ve.from=Ne})(Ci||(e.ChatAgentCompletionItem=Ci={}));var Nt;(function(ve){function Ne(de){return{errorDetails:de.errorDetails,metadata:de.metadata}}ve.to=Ne})(Nt||(e.ChatAgentResult=Nt={}));var Ei;(function(ve){function Ne(de,J,Pe){if(J.action.kind==="vote")return;const Me=Nt.to(de);if(J.action.kind==="command"){const Ze=J.action.commandButton.command;return{action:{kind:"command",commandButton:{command:Pe.fromInternal(Ze)??{command:Ze.id,title:Ze.title}}},result:Me}}else return J.action.kind==="followUp"?{action:{kind:"followUp",followup:At.to(J.action.followup)},result:Me}:J.action.kind==="inlineChat"?{action:{kind:"editor",accepted:J.action.action==="accepted"},result:Me}:{action:J.action,result:Me}}ve.to=Ne})(Ei||(e.ChatAgentUserActionEvent=Ei={}));var Ii;(function(ve){function Ne(de,J,Pe){return"terminalCommand"in de?{terminalCommand:de.terminalCommand,shouldExecute:de.shouldExecute}:"uri"in de?{uri:de.uri}:J.toInternal(de,Pe)}ve.from=Ne})(Ii||(e.TerminalQuickFix=Ii={}));var Di;(function(ve){function Ne(de){return{kind:mi.to(de.kind)}}ve.to=Ne})(Di||(e.PartialAcceptInfo=Di={}));var mi;(function(ve){function Ne(de){switch(de){case r.PartialAcceptTriggerKind.Word:return b.PartialAcceptTriggerKind.Word;case r.PartialAcceptTriggerKind.Line:return b.PartialAcceptTriggerKind.Line;case r.PartialAcceptTriggerKind.Suggest:return b.PartialAcceptTriggerKind.Suggest;default:return b.PartialAcceptTriggerKind.Unknown}}ve.to=Ne})(mi||(e.PartialAcceptTriggerKind=mi={}));var Pi;(function(ve){function Ne(de,J){return{id:J,label:de.label,description:de.description,canEdit:de.canEdit,collapsibleState:de.collapsibleState||D.DebugTreeItemCollapsibleState.None,contextValue:de.contextValue}}ve.from=Ne})(Pi||(e.DebugTreeItem=Pi={}))}),define(ke[275],Ce([1,0,5,17,10,39]),function(oe,e,w,S,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6nc=void 0;let A=class{constructor(p,a){this.a=p.getProxy(w.$rN.MainThreadBulkEdits),this.b={getTextDocumentVersion:R=>a.getDocument(R)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(p,a,R){const y=new O.$Pw(k.WorkspaceEdit.from(p,this.b));return this.a.$tryApplyWorkspaceEdit(y,void 0,R?.isRefactoring??!1)}};e.$6nc=A,e.$6nc=A=He([Ve(0,S.$XP)],A)}),define(ke[276],Ce([1,0,18,11,48,6,40,4,70,15,2,19,5,10,7,235,25]),function(oe,e,w,S,k,O,A,T,p,a,R,y,u,E,d,n,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7nc=void 0,E=qe(E),d=qe(d);class o{constructor(t,c,l,m,f){this.j=t,this.k=c,this.l=l,this.m=m,this.n=f,this.b=p.$ge.create(!1),this.c=!1}close(){this.c=!0}get timings(){return{firstProgress:this.d,totalElapsed:this.b.elapsed()}}get apiObject(){if(!this.g){let c=function(m){if(t.c){const f=new Error("Response stream has been closed");throw Error.captureStackTrace(f,m),f}};const t=this;this.b.reset();const l=(m,f)=>{if(typeof this.d>"u"&&"content"in m&&(this.d=this.b.elapsed()),f){const $=this.l.$handleProgressChunk(this.k.requestId,m),I={report:D=>{$?.then(v=>{v&&(d.$VN.isMarkdownString(D.value)?this.l.$handleProgressChunk(this.k.requestId,E.ChatResponseWarningPart.from(D),v):this.l.$handleProgressChunk(this.k.requestId,E.ChatResponseReferencePart.from(D),v))})}};Promise.all([$,f?.(I)]).then(([D,v])=>{D!==void 0&&v!==void 0&&this.l.$handleProgressChunk(this.k.requestId,E.ChatTaskResult.from(v),D)})}else this.l.$handleProgressChunk(this.k.requestId,m)};this.g={markdown(m){c(this.markdown);const f=new d.$qP(m),$=E.ChatResponseMarkdownPart.from(f);return l($),this},markdownWithVulnerabilities(m,f){c(this.markdown),f&&(0,s.$4G)(t.j,"chatParticipantAdditions");const $=new d.$rP(m,f),I=E.ChatResponseMarkdownWithVulnerabilitiesPart.from($);return l(I),this},filetree(m,f){c(this.filetree);const $=new d.$uP(m,f),I=E.ChatResponseFilesPart.from($);return l(I),this},anchor(m,f){c(this.anchor);const $=new d.$vP(m,f),I=E.ChatResponseAnchorPart.from($);return l(I),this},button(m){c(this.anchor);const f=new d.$zP(m),$=E.ChatResponseCommandButtonPart.from(f,t.m,t.n);return l($),this},progress(m,f){c(this.progress);const $=new d.$xP(m,f),I=f?E.ChatTask.from($):E.ChatResponseProgressPart.from($);return l(I,f),this},warning(m){c(this.progress),(0,s.$4G)(t.j,"chatParticipantAdditions");const f=new d.$yP(m),$=E.ChatResponseWarningPart.from(f);return l($),this},reference(m,f){if(c(this.reference),"variableName"in m&&(0,s.$4G)(t.j,"chatParticipantAdditions"),"variableName"in m&&!m.value){const $=t.k.variables.variables.find(I=>I.name===m.variableName);if($){let I;if($.references?.length)I=$.references.map(D=>({kind:"reference",reference:{variableName:m.variableName,value:D.reference}}));else{const D=new d.$AP(m,f);I=[E.ChatResponseReferencePart.from(D)]}return I.forEach(D=>l(D)),this}}else{const $=new d.$AP(m,f),I=E.ChatResponseReferencePart.from($);l(I)}return this},textEdit(m,f){c(this.textEdit),(0,s.$4G)(t.j,"chatParticipantAdditions");const $=new d.$BP(m,f),I=E.ChatResponseTextEditPart.from($);return l(I),this},detectedParticipant(m,f){c(this.detectedParticipant),(0,s.$4G)(t.j,"chatParticipantAdditions");const $=new d.$sP(m,f),I=E.ChatResponseDetectedParticipantPart.from($);return l(I),this},confirmation(m,f,$){c(this.confirmation),(0,s.$4G)(t.j,"chatParticipantAdditions");const I=new d.$tP(m,f,$),D=E.ChatResponseConfirmationPart.from(I);return l(D),this},push(m){if(c(this.push),(m instanceof d.$BP||m instanceof d.$rP||m instanceof d.$sP||m instanceof d.$yP||m instanceof d.$tP)&&(0,s.$4G)(t.j,"chatParticipantAdditions"),m instanceof d.$AP)this.reference(m.value,m.iconPath);else{const f=E.ChatResponsePart.from(m,t.m,t.n);l(f)}return this}}}return this.g}}class h extends T.$Wc{static{this.b=0}constructor(t,c,l,m){super(),this.n=c,this.s=l,this.t=m,this.c=new Map,this.j=this.B(new T.$6c),this.m=this.B(new T.$6c),this.g=t.getProxy(u.$rN.MainThreadChatAgents2)}transferActiveChat(t){this.g.$transferActiveChatSession(t)}createChatAgent(t,c,l){const m=h.b++,f=new i(t,this.t,c,this.g,m,l);return this.c.set(m,f),f.isAgentEnabled()&&this.g.$registerAgent(m,t.identifier,c,{},void 0),f.apiAgent}createDynamicChatAgent(t,c,l,m){const f=h.b++,$=new i(t,this.t,c,this.g,f,m);return this.c.set(f,$),this.g.$registerAgent(f,t.identifier,c,{isSticky:!0},l),$.apiAgent}async $invokeAgent(t,c,l,m){const f=this.c.get(t);if(!f)throw new Error(`[CHAT](${t}) CANNOT invoke agent because the agent is not registered`);let $=this.j.get(c.sessionId);$||($=new T.$Vc,this.j.set(c.sessionId,$));const I=new o(f.extension,c,this.g,this.s.converter,$);try{const D=await this.u(c.agentId,l),v=f.invoke(E.ChatAgentRequest.to(c),{history:D},I.apiObject,m);return await(0,S.$th)(Promise.resolve(v).then(C=>{if(C?.metadata)try{JSON.stringify(C.metadata)}catch(g){const b=`result.metadata MUST be JSON.stringify-able. Got error: ${g.message}`;return this.n.error(`[${f.extension.identifier.value}] [@${f.id}] ${b}`,f.extension),{errorDetails:{message:b},timings:I.timings}}let P;return C?.errorDetails&&(P={...C.errorDetails,responseIsIncomplete:!0}),P?.responseIsRedacted&&(0,s.$4G)(f.extension,"chatParticipantPrivate"),{errorDetails:P,timings:I.timings,metadata:C?.metadata}}),m)}catch(D){return this.n.error(D,f.extension),D instanceof d.$LP&&D.cause&&(D=D.cause),{errorDetails:{message:(0,k.$qj)(D),responseIsIncomplete:!0}}}finally{I.close()}}async u(t,c){const l=[];for(const m of c.history){const f=E.ChatAgentResult.to(m.result),$=t===m.request.agentId?f:{...f,metadata:void 0};l.push(new d.$CP(m.request.message,m.request.command,m.request.variables.variables.map(E.ChatAgentValueReference.to),m.request.agentId));const I=(0,w.$Jb)(m.response.map(D=>E.ChatResponsePart.toContent(D,this.s.converter)));l.push(new d.$DP(I,$,m.request.agentId,m.request.command))}return l}$releaseSession(t){this.j.deleteAndDispose(t)}async $provideFollowups(t,c,l,m,f){const $=this.c.get(c);if(!$)return Promise.resolve([]);const I=await this.u($.id,m),D=E.ChatAgentResult.to(l);return(await $.provideFollowups(D,{history:I},f)).filter(v=>{const C=!v.participant||A.Iterable.some(this.c.values(),P=>P.id===v.participant&&y.$qn.equals(P.extension.identifier,$.extension.identifier));return C||this.n.warn(`[@${$.id}] ChatFollowup refers to an unknown participant: ${v.participant}`),C}).map(v=>E.ChatFollowup.from(v,t))}$acceptFeedback(t,c,l,m){const f=this.c.get(t);if(!f)return;const $=E.ChatAgentResult.to(c);let I;switch(l){case n.ChatAgentVoteDirection.Down:I=d.ChatResultFeedbackKind.Unhelpful;break;case n.ChatAgentVoteDirection.Up:I=d.ChatResultFeedbackKind.Helpful;break}f.acceptFeedback(Object.freeze(m?{result:$,kind:I,reportIssue:m}:{result:$,kind:I}))}$acceptAction(t,c,l){const m=this.c.get(t);if(!m||l.action.kind==="vote")return;const f=E.ChatAgentUserActionEvent.to(c,l,this.s.converter);f&&m.acceptAction(Object.freeze(f))}async $invokeCompletionProvider(t,c,l){const m=this.c.get(t);if(!m)return[];let f=this.m.get(t);return f?f.clear():(f=new T.$Vc,this.m.set(t,f)),(await m.invokeCompletionProvider(c,l)).map(I=>E.ChatAgentCompletionItem.from(I,this.s.converter,f))}async $provideWelcomeMessage(t,c,l){const m=this.c.get(t);if(m)return await m.provideWelcomeMessage(E.ChatLocation.to(c),l)}async $provideSampleQuestions(t,c,l){const m=this.c.get(t);if(m)return(await m.provideSampleQuestions(E.ChatLocation.to(c),l)).map(f=>E.ChatFollowup.from(f,void 0))}}e.$7nc=h;class i{constructor(t,c,l,m,f,$){this.extension=t,this.w=c,this.id=l,this.x=m,this.y=f,this.z=$,this.m=new O.$me,this.n=new O.$me}acceptFeedback(t){this.m.fire(t)}acceptAction(t){this.n.fire(t)}async invokeCompletionProvider(t,c){return this.q?await this.q.provider.provideCompletionItems(t,c)??[]:[]}isAgentEnabled(){return!(this.w==="stable"&&!(0,s.$3G)(this.extension,"chatParticipantPrivate"))}async provideFollowups(t,c,l){if(!this.b)return[];const m=await this.b.provideFollowups(t,c,l);return m?m.filter(f=>!(f&&"commandId"in f)).filter(f=>!(f&&"message"in f)):[]}async provideWelcomeMessage(t,c){if(!this.s)return[];const l=await this.s.provideWelcomeMessage(t,c);return l?l.map(m=>typeof m=="string"?m:E.MarkdownString.from(m)):[]}async provideSampleQuestions(t,c){if(!this.s||!this.s.provideSampleQuestions)return[];const l=await this.s.provideSampleQuestions(t,c);return l||[]}get apiAgent(){let t=!1,c=!1;const l=()=>{t||c||(c=!0,queueMicrotask(()=>{m.isAgentEnabled()&&(this.x.$updateAgent(this.y,{icon:this.c?this.c instanceof R.URI?this.c:"light"in this.c?this.c.light:void 0:void 0,iconDark:this.c&&"dark"in this.c?this.c.dark:void 0,themeIcon:this.c instanceof d.$qO?this.c:void 0,hasFollowups:this.b!==void 0,isSecondary:this.l,helpTextPrefix:!this.g||typeof this.g=="string"?this.g:E.MarkdownString.from(this.g),helpTextVariablesPrefix:!this.j||typeof this.j=="string"?this.j:E.MarkdownString.from(this.j),helpTextPostfix:!this.k||typeof this.k=="string"?this.k:E.MarkdownString.from(this.k),supportIssueReporting:this.o,requester:this.t,supportsSlowVariables:this.u}),c=!1)}))},m=this;return{get id(){return m.id},get iconPath(){return m.c},set iconPath(f){m.c=f,l()},get requestHandler(){return m.z},set requestHandler(f){(0,a.$pg)(typeof f=="function","Invalid request handler"),m.z=f},get followupProvider(){return m.b},set followupProvider(f){m.b=f,l()},get isDefault(){return(0,s.$4G)(m.extension,"defaultChatParticipant"),m.d},set isDefault(f){(0,s.$4G)(m.extension,"defaultChatParticipant"),m.d=f,l()},get helpTextPrefix(){return(0,s.$4G)(m.extension,"defaultChatParticipant"),m.g},set helpTextPrefix(f){(0,s.$4G)(m.extension,"defaultChatParticipant"),m.g=f,l()},get helpTextVariablesPrefix(){return(0,s.$4G)(m.extension,"defaultChatParticipant"),m.j},set helpTextVariablesPrefix(f){(0,s.$4G)(m.extension,"defaultChatParticipant"),m.j=f,l()},get helpTextPostfix(){return(0,s.$4G)(m.extension,"defaultChatParticipant"),m.k},set helpTextPostfix(f){(0,s.$4G)(m.extension,"defaultChatParticipant"),m.k=f,l()},get isSecondary(){return(0,s.$4G)(m.extension,"defaultChatParticipant"),m.l},set isSecondary(f){(0,s.$4G)(m.extension,"defaultChatParticipant"),m.l=f,l()},get supportIssueReporting(){return(0,s.$4G)(m.extension,"chatParticipantPrivate"),m.o},set supportIssueReporting(f){(0,s.$4G)(m.extension,"chatParticipantPrivate"),m.o=f,l()},get onDidReceiveFeedback(){return m.m.event},set participantVariableProvider(f){if((0,s.$4G)(m.extension,"chatParticipantAdditions"),m.q=f,f){if(!f.triggerCharacters.length)throw new Error("triggerCharacters are required");m.x.$registerAgentCompletionsProvider(m.y,m.id,f.triggerCharacters)}else m.x.$unregisterAgentCompletionsProvider(m.y,m.id)},get participantVariableProvider(){return(0,s.$4G)(m.extension,"chatParticipantAdditions"),m.q},set welcomeMessageProvider(f){(0,s.$4G)(m.extension,"defaultChatParticipant"),m.s=f,l()},get welcomeMessageProvider(){return(0,s.$4G)(m.extension,"defaultChatParticipant"),m.s},onDidPerformAction:(0,s.$3G)(this.extension,"chatParticipantAdditions")?this.n.event:void 0,set requester(f){m.t=f,l()},get requester(){return m.t},set supportsSlowReferences(f){(0,s.$4G)(m.extension,"chatParticipantPrivate"),m.u=f,l()},get supportsSlowReferences(){return(0,s.$4G)(m.extension,"chatParticipantPrivate"),m.u},dispose(){t=!0,m.b=void 0,m.m.dispose(),m.x.$unregisterAgent(m.y)}}}invoke(t,c,l,m){return this.z(t,c,l,m)}}}),define(ke[277],Ce([1,0,14,4,35,5,10,7,25]),function(oe,e,w,S,k,O,A,T,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8nc=void 0,A=qe(A),T=qe(T);class a{static{this.a=0}constructor(u){this.b=new Map,this.c=u.getProxy(O.$rN.MainThreadChatVariables)}async $resolveVariable(u,E,d,n){const s=this.b.get(u);if(s)try{if(s.resolver.resolve2){(0,p.$4G)(s.extension,"chatParticipantAdditions");const o=new R(E,this.c),h=await s.resolver.resolve2(s.data.name,{prompt:d},o.apiObject,n);if(h&&h[0])return h[0].value}else{const o=await s.resolver.resolve(s.data.name,{prompt:d},n);if(o&&o[0])return o[0].value}}catch(o){(0,w.$4)(o)}}registerVariableResolver(u,E,d,n,s,o,h,i,r){const t=a.a++,c=r?k.ThemeIcon.fromId(r):void 0;return this.b.set(t,{extension:u,data:{id:E,name:d,description:n,modelDescription:s,icon:c},resolver:h}),this.c.$registerVariable(t,{id:E,name:d,description:n,modelDescription:s,isSlow:o,fullName:i,icon:c}),(0,S.$Uc)(()=>{this.b.delete(t),this.c.$unregisterVariable(t)})}}e.$8nc=a;class R{constructor(u,E){this.c=u,this.d=E,this.a=!1}close(){this.a=!0}get apiObject(){if(!this.b){let E=function(n){if(u.a){const s=new Error("Response stream has been closed");throw Error.captureStackTrace(s,n),s}};const u=this,d=n=>{this.d.$handleProgressChunk(this.c,n)};this.b={progress(n){E(this.progress);const s=new T.$wP(n),o=A.ChatResponseProgressPart.from(s);return d(o),this},reference(n){E(this.reference);const s=new T.$AP(n),o=A.ChatResponseReferencePart.from(s);return d(o),this},push(n){return E(this.push),n instanceof T.$AP?d(A.ChatResponseReferencePart.from(n)):n instanceof T.$wP&&d(A.ChatResponseProgressPart.from(n)),this}}}return this.b}}}),define(ke[278],Ce([1,0,11,72,6,4,38,2,94,19,10,7,5,25]),function(oe,e,w,S,k,O,A,T,p,a,R,y,u,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_nc=d,p=qe(p),R=qe(R),y=qe(y);function d(n,s,o){const h=n.getProxy(u.$rN.MainThreadComments);class i{static{this.a=0}constructor(){this.b=new Map,this.c=new a.$sn,s.registerArgumentProcessor({processArgument:v=>{if(v&&v.$mid===A.MarshalledId.CommentController){const C=this.b.get(v.handle);return C?C.value:v}else if(v&&v.$mid===A.MarshalledId.CommentThread){const C=v,P=this.b.get(C.commentControlHandle);if(!P)return C;const g=P.getCommentThread(C.commentThreadHandle);return g?g.value:C}else if(v&&(v.$mid===A.MarshalledId.CommentThreadReply||v.$mid===A.MarshalledId.CommentThreadInstance)){const C=this.b.get(v.thread.commentControlHandle);if(!C)return v;const P=C.getCommentThread(v.thread.commentThreadHandle);return P?v.$mid===A.MarshalledId.CommentThreadInstance?P.value:{thread:P.value,text:v.text}:v}else if(v&&v.$mid===A.MarshalledId.CommentNode){const C=this.b.get(v.thread.commentControlHandle);if(!C)return v;const P=C.getCommentThread(v.thread.commentThreadHandle);if(!P)return v;const g=v.commentUniqueId,b=P.getCommentByUniqueId(g);return b||v}else if(v&&v.$mid===A.MarshalledId.CommentThreadNode){const C=this.b.get(v.thread.commentControlHandle);if(!C)return v;const P=C.getCommentThread(v.thread.commentThreadHandle);if(!P)return v;const g=v.text,b=v.commentUniqueId,L=P.getCommentByUniqueId(b);return L?(typeof L.body=="string"?L.body=g:L.body=new y.$VN(g),L):v}return v}})}createCommentController(v,C,P){const g=i.a++,b=new t(v,g,C,P);this.b.set(b.handle,b);const L=this.c.get(v.identifier)||[];return L.push(b),this.c.set(v.identifier,L),b.value}async $createCommentThreadTemplate(v,C,P,g){const b=this.b.get(v);b&&b.$createCommentThreadTemplate(C,P,g)}async $setActiveComment(v,C){const P=this.b.get(v);P&&P.$setActiveComment(C??void 0)}async $updateCommentThreadTemplate(v,C,P){const g=this.b.get(v);g&&g.$updateCommentThreadTemplate(C,P)}$deleteCommentThread(v,C){this.b.get(v)?.$deleteCommentThread(C)}async $provideCommentingRanges(v,C,P){const g=this.b.get(v);if(!g||!g.commentingRangeProvider)return Promise.resolve(void 0);const b=await o.ensureDocumentData(T.URI.revive(C));return(0,w.$xh)(async()=>{const L=await g.commentingRangeProvider.provideCommentingRanges(b.document,P);let N;return Array.isArray(L)?N={ranges:L,fileComments:!1}:L?N={ranges:L.ranges||[],fileComments:L.fileComments||!1}:N=L??void 0,N}).then(L=>{let N;return L&&(N={ranges:L.ranges.map(B=>R.Range.from(B)),fileComments:L.fileComments}),N})}$toggleReaction(v,C,P,g,b){const L=this.b.get(v);return!L||!L.reactionHandler?Promise.resolve(void 0):(0,w.$xh)(()=>{const N=L.getCommentThread(C);if(N){const B=N.getCommentByUniqueId(g.uniqueIdInThread);if(L!==void 0&&B&&L.reactionHandler)return L.reactionHandler(B,m(b))}return Promise.resolve(void 0)})}}class r{static{this.a=0}set threadId(v){this.n=v}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(v){(v===void 0!=(this.p===void 0)||!v||!this.p||!v.isEqual(this.p))&&(this.p=v,this.b.range=v,this.c.fire())}get range(){return this.p}set canReply(v){this.d!==v&&(this.d=v,this.b.canReply=v,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(v){this.e=v,this.b.label=v,this.c.fire()}get contextValue(){return this.f}set contextValue(v){this.f=v,this.b.contextValue=v,this.c.fire()}get comments(){return this.q}set comments(v){this.q=v,this.b.comments=v,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(v){this.g=v,this.b.collapsibleState=v,this.c.fire()}get state(){return this.h}set state(v){this.h=v,typeof v=="object"?((0,E.$4G)(this.extensionDescription,"commentThreadApplicability"),this.b.state=v.resolved,this.b.applicability=v.applicability):this.b.state=v,this.c.fire()}get isDisposed(){return this.j}constructor(v,C,P,g,b,L,N,B,G){this.m=C,this.n=P,this.o=g,this.p=b,this.q=L,this.extensionDescription=N,this.r=B,this.handle=r.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new k.$me,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new O.$Xc,this.l.value=new O.$Vc,this.n===void 0&&(this.n=`${v}.${this.handle}`),h.$createCommentThread(C,this.handle,this.n,this.o,R.Range.from(this.p),N.identifier,this.r,G),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=L,this.i.push({dispose:()=>{h.$deleteCommentThread(C,this.handle)}});const W=this;this.value={get uri(){return W.uri},get range(){return W.range},set range(F){W.range=F},get comments(){return W.comments},set comments(F){W.comments=F},get collapsibleState(){return W.collapsibleState},set collapsibleState(F){W.collapsibleState=F},get canReply(){return W.canReply},set canReply(F){W.canReply=F},get contextValue(){return W.contextValue},set contextValue(F){W.contextValue=F},get label(){return W.label},set label(F){W.label=F},get state(){return W.state},set state(F){W.state=F},reveal:F=>W.reveal(F),dispose:()=>{W.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new O.$Vc);const v=P=>Object.prototype.hasOwnProperty.call(this.b,P),C={};v("range")&&(C.range=R.Range.from(this.p)),v("label")&&(C.label=this.label),v("contextValue")&&(C.contextValue=this.contextValue??null),v("comments")&&(C.comments=this.q.map(P=>c(this,P,this.k,this.extensionDescription))),v("collapsibleState")&&(C.collapseState=f(this.g)),v("canReply")&&(C.canReply=this.canReply),v("state")&&(C.state=$(this.h)),v("applicability")&&(C.applicability=I(this.h)),v("isTemplate")&&(C.isTemplate=this.r),this.b={},h.$updateCommentThread(this.m,this.handle,this.n,this.o,C)}getCommentByUniqueId(v){for(const C of this.k){const P=C[0],g=C[1];if(v===g)return P}}async reveal(v){return(0,E.$4G)(this.extensionDescription,"commentReveal"),h.$revealCommentThread(this.m,this.handle,{preserveFocus:!1,focusReply:!1,...v})}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(v=>v.dispose())}}He([(0,S.$$h)(100)],r.prototype,"eventuallyUpdateCommentThread",null);class t{get id(){return this.j}get label(){return this.k}get handle(){return this.i}get commentingRangeProvider(){return this.b}set commentingRangeProvider(v){this.b=v,v?.resourceHints&&(0,E.$4G)(this.h,"commentingRangeHint"),h.$updateCommentingRanges(this.handle,v?.resourceHints)}get reactionHandler(){return this.c}set reactionHandler(v){this.c=v,h.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!v})}get options(){return this.d}set options(v){this.d=v,h.$updateCommentControllerFeatures(this.handle,{options:this.d})}get activeComment(){return(0,E.$4G)(this.h,"activeComment"),this.e}get activeCommentThread(){return(0,E.$4G)(this.h,"activeComment"),this.f}constructor(v,C,P,g){this.h=v,this.i=C,this.j=P,this.k=g,this.a=new Map,h.$registerCommentController(this.handle,P,g,this.h.identifier.value);const b=this;this.value=Object.freeze({id:b.id,label:b.label,get options(){return b.options},set options(L){b.options=L},get commentingRangeProvider(){return b.commentingRangeProvider},set commentingRangeProvider(L){b.commentingRangeProvider=L},get reactionHandler(){return b.reactionHandler},set reactionHandler(L){b.reactionHandler=L},get activeCommentThread(){return b.activeCommentThread},createCommentThread(L,N,B){return b.createCommentThread(L,N,B).value},dispose:()=>{b.dispose()}}),this.g=[],this.g.push({dispose:()=>{h.$unregisterCommentController(this.handle)}})}createCommentThread(v,C,P){C===void 0&&(0,E.$4G)(this.h,"fileComments");const g=new r(this.id,this.handle,void 0,v,C,P,this.h,!1);return this.a.set(g.handle,g),g}$setActiveComment(v){if(!v){this.e=void 0,this.f=void 0;return}const C=this.a.get(v.commentThreadHandle);C&&(this.e=v.uniqueIdInThread?C.getCommentByUniqueId(v.uniqueIdInThread):void 0,this.f=C)}$createCommentThreadTemplate(v,C,P){const g=new r(this.id,this.handle,void 0,T.URI.revive(v),R.Range.to(C),[],this.h,!0,P);return g.collapsibleState=p.CommentThreadCollapsibleState.Expanded,this.a.set(g.handle,g),g}$updateCommentThreadTemplate(v,C){const P=this.a.get(v);P&&(P.range=R.Range.to(C))}$deleteCommentThread(v){this.a.get(v)?.dispose(),this.a.delete(v)}getCommentThread(v){return this.a.get(v)}dispose(){this.a.forEach(v=>{v.dispose()}),this.g.forEach(v=>v.dispose())}}function c(D,v,C,P){let g=C.get(v);return g||(g=++D.commentHandle,C.set(v,g)),v.state!==void 0&&(0,E.$4G)(P,"commentsDraftState"),v.reactions?.some(b=>b.reactors!==void 0)&&(0,E.$4G)(P,"commentReactor"),{mode:v.mode,contextValue:v.contextValue,uniqueIdInThread:g,body:typeof v.body=="string"?v.body:R.MarkdownString.from(v.body),userName:v.author.name,userIconPath:v.author.iconPath,label:v.label,commentReactions:v.reactions?v.reactions.map(b=>l(b)):void 0,state:v.state,timestamp:v.timestamp?.toJSON()}}function l(D){return{label:D.label,iconPath:D.iconPath?R.$WP(D.iconPath):void 0,count:D.count,hasReacted:D.authorHasReacted,reactors:D.reactors&&D.reactors.length>0&&typeof D.reactors[0]!="string"?D.reactors.map(v=>v.name):D.reactors}}function m(D){return{label:D.label||"",count:D.count||0,iconPath:D.iconPath?T.URI.revive(D.iconPath):"",authorHasReacted:D.hasReacted||!1,reactors:D.reactors?.map(v=>({name:v}))}}function f(D){if(D!==void 0)switch(D){case y.CommentThreadCollapsibleState.Expanded:return p.CommentThreadCollapsibleState.Expanded;case y.CommentThreadCollapsibleState.Collapsed:return p.CommentThreadCollapsibleState.Collapsed}return p.CommentThreadCollapsibleState.Collapsed}function $(D){let v;if(typeof D=="object"?v=D.resolved:v=D,v!==void 0)switch(v){case y.CommentThreadState.Unresolved:return p.CommentThreadState.Unresolved;case y.CommentThreadState.Resolved:return p.CommentThreadState.Resolved}return p.CommentThreadState.Unresolved}function I(D){let v;if(typeof D=="object"&&(v=D.applicability),v!==void 0)switch(v){case y.CommentThreadApplicability.Current:return p.CommentThreadApplicability.Current;case y.CommentThreadApplicability.Outdated:return p.CommentThreadApplicability.Outdated}return p.CommentThreadApplicability.Current}return new i}}),define(ke[279],Ce([1,0,22,76,4,16,24,2,10,68,80,5,7]),function(oe,e,w,S,k,O,A,T,p,a,R,y,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$roc=void 0,p=qe(p),y=qe(y),u=qe(u);class E{constructor(l,m){this.document=l,this.b=m,this.a=1,this.c=new R.$Rnc("custom documents")}addEdit(l){return this.c.add([l])}async undo(l,m){await this.f(l).undo(),m||this.disposeBackup()}async redo(l,m){await this.f(l).redo(),m||this.disposeBackup()}disposeEdits(l){for(const m of l)this.c.delete(m)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const l=t(this.document.uri)+this.a++;return(0,A.$gh)(this.b,l)}updateBackup(l){this.d?.delete(),this.d=l}disposeBackup(){this.d?.delete(),this.d=void 0}f(l){const m=this.c.get(l,0);if(!m)throw new Error("No edit found");return m}}class d{constructor(){this.a=new Map}get(l,m){return this.a.get(this.b(l,m))}add(l,m,f){const $=this.b(l,m.uri);if(this.a.has($))throw new Error(`Document already exists for viewType:${l} resource:${m.uri}`);const I=new E(m,f);return this.a.set($,I),I}delete(l,m){const f=this.b(l,m.uri);this.a.delete(f)}b(l,m){return`${l}@@@${m}`}}var n;(function(c){c[c.Text=0]="Text",c[c.Custom=1]="Custom"})(n||(n={}));class s{constructor(){this.a=new Map}addTextProvider(l,m,f){return this.b(l,{type:n.Text,extension:m,provider:f})}addCustomProvider(l,m,f){return this.b(l,{type:n.Custom,extension:m,provider:f})}get(l){return this.a.get(l)}b(l,m){if(this.a.has(l))throw new Error(`Provider for viewType:${l} already registered`);return this.a.set(l,m),new u.$tN(()=>this.a.delete(l))}}class o{constructor(l,m,f,$,I){this.d=m,this.f=f,this.g=$,this.h=I,this.b=new s,this.c=new d,this.a=l.getProxy(y.$rN.MainThreadCustomEditors)}registerCustomEditorProvider(l,m,f,$){const I=new k.$Vc;return i(f)?(I.add(this.b.addTextProvider(m,l,f)),this.a.$registerTextEditorProvider((0,a.$ooc)(l),m,$.webviewOptions||{},{supportsMove:!!f.moveCustomTextEditor},(0,a.$moc)(l))):(I.add(this.b.addCustomProvider(m,l,f)),h(f)&&I.add(f.onDidChangeCustomDocument(D=>{const v=this.i(m,D.document.uri);if(r(D)){const C=v.addEdit(D);this.a.$onDidEdit(D.document.uri,m,C,D.label)}else this.a.$onContentChange(D.document.uri,m)})),this.a.$registerCustomEditorProvider((0,a.$ooc)(l),m,$.webviewOptions||{},!!$.supportsMultipleEditorsPerDocument,(0,a.$moc)(l))),u.$tN.from(I,new u.$tN(()=>{this.a.$unregisterEditorProvider(m)}))}async $createCustomDocument(l,m,f,$,I){const D=this.b.get(m);if(!D)throw new Error(`No provider found for '${m}'`);if(D.type!==n.Custom)throw new Error(`Invalid provide type for '${m}'`);const v=T.URI.revive(l),C=await D.provider.openCustomDocument(v,{backupId:f,untitledDocumentData:$?.buffer},I);let P;return h(D.provider)&&this.f&&(P=this.f.workspaceValue(D.extension)??this.f.globalValue(D.extension)),this.c.add(m,C,P),{editable:h(D.provider)}}async $disposeCustomDocument(l,m){const f=this.b.get(m);if(!f)throw new Error(`No provider found for '${m}'`);if(f.type!==n.Custom)throw new Error(`Invalid provider type for '${m}'`);const $=T.URI.revive(l),{document:I}=this.i(m,$);this.c.delete(m,I),I.dispose()}async $resolveCustomEditor(l,m,f,$,I,D){const v=this.b.get(f);if(!v)throw new Error(`No provider found for '${f}'`);const C=p.ViewColumn.to(I),P=this.g.createNewWebview(m,$.contentOptions,v.extension),g=this.h.createNewWebviewPanel(m,f,$.title,C,$.options,P,$.active),b=T.URI.revive(l);switch(v.type){case n.Custom:{const{document:L}=this.i(f,b);return v.provider.resolveCustomEditor(L,g,D)}case n.Text:{const L=this.d.getDocument(b);return v.provider.resolveCustomTextEditor(L,g,D)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(l,m,f){this.i(m,l).disposeEdits(f)}async $onMoveCustomEditor(l,m,f){const $=this.b.get(f);if(!$)throw new Error(`No provider found for '${f}'`);if(!$.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${f}'`);const I=this.h.getWebviewPanel(l);if(!I)throw new Error("No webview found");const D=T.URI.revive(m),v=this.d.getDocument(D);await $.provider.moveCustomTextEditor(v,I,w.CancellationToken.None)}async $undo(l,m,f,$){return this.i(m,l).undo(f,$)}async $redo(l,m,f,$){return this.i(m,l).redo(f,$)}async $revert(l,m,f){const $=this.i(m,l);await this.j(m).revertCustomDocument($.document,f),$.disposeBackup()}async $onSave(l,m,f){const $=this.i(m,l);await this.j(m).saveCustomDocument($.document,f),$.disposeBackup()}async $onSaveAs(l,m,f,$){const I=this.i(m,l);return this.j(m).saveCustomDocumentAs(I.document,T.URI.revive(f),$)}async $backup(l,m,f){const $=this.i(m,l),D=await this.j(m).backupCustomDocument($.document,{destination:$.getNewBackupUri()},f);return $.updateBackup(D),D.id}i(l,m){const f=this.c.get(l,T.URI.revive(m));if(!f)throw new Error("No custom document found");return f}j(l){const f=this.b.get(l)?.provider;if(!f||!h(f))throw new Error("Custom document is not editable");return f}}e.$roc=o;function h(c){return!!c.onDidChangeCustomDocument}function i(c){return typeof c.resolveCustomTextEditor=="function"}function r(c){return typeof c.undo=="function"&&typeof c.redo=="function"}function t(c){const l=c.scheme===O.Schemas.file||c.scheme===O.Schemas.untitled?c.fsPath:c.toString();return(0,S.$tj)(l)+""}}),define(ke[280],Ce([1,0,180,107,2,5,7,10,6,12,29,51]),function(oe,e,w,S,k,O,A,T,p,a,R,y){"use strict";var u;Object.defineProperty(e,"__esModule",{value:!0}),e.$Znc=e.$Ync=void 0,T=qe(T);class E{#e;#t;#i;constructor(s,o,h,i,r,t,c,l){this.d=s,this.e=o,this.f=h,this.g=i,this.h=r,this.c=!1,this.f=Math.max(i,h),this.#i=new R.$Cc(m=>t.getComparisonKey(m)),this.#e=c,this.#t=l}dispose(){this.c||(this.#t.fire([...this.#i.keys()]),this.#e?.$clear(this.e),this.#i.clear(),this.c=!0)}get name(){return this.j(),this.d}set(s,o){if(!s){this.clear();return}this.j();let h=[];if(k.URI.isUri(s)){if(!o){this.delete(s);return}this.#i.set(s,o.slice()),h=[s]}else if(Array.isArray(s)){h=[];let t;s=[...s].sort(E.k);for(const c of s){const[l,m]=c;if((!t||l.toString()!==t.toString())&&(t&&this.#i.get(t).length===0&&this.#i.delete(t),t=l,h.push(l),this.#i.set(l,[])),m)this.#i.get(l)?.push(...m);else{const f=this.#i.get(l);f&&(f.length=0)}}}if(this.#t.fire(h),!this.#e)return;const i=[];let r=0;for(const t of h){let c=[];const l=this.#i.get(t);if(l)if(l.length>this.g){c=[];const m=[A.DiagnosticSeverity.Error,A.DiagnosticSeverity.Warning,A.DiagnosticSeverity.Information,A.DiagnosticSeverity.Hint];e:for(let f=0;f<4;f++)for(const $ of l)if($.severity===m[f]&&c.push({...T.Diagnostic.from($),modelVersionId:this.h(t)})===this.g)break e;c.push({severity:S.MarkerSeverity.Info,message:(0,w.localize)(0,null,l.length-this.g),startLineNumber:c[c.length-1].startLineNumber,startColumn:c[c.length-1].startColumn,endLineNumber:c[c.length-1].endLineNumber,endColumn:c[c.length-1].endColumn})}else c=l.map(m=>({...T.Diagnostic.from(m),modelVersionId:this.h(t)}));if(i.push([t,c]),r+=c.length,r>this.f)break}this.#e.$changeMany(this.e,i)}delete(s){this.j(),this.#t.fire([s]),this.#i.delete(s),this.#e?.$changeMany(this.e,[[s,void 0]])}clear(){this.j(),this.#t.fire([...this.#i.keys()]),this.#i.clear(),this.#e?.$clear(this.e)}forEach(s,o){this.j();for(const[h,i]of this)s.call(o,h,i,this)}*[Symbol.iterator](){this.j();for(const s of this.#i.keys())yield[s,this.get(s)]}get(s){this.j();const o=this.#i.get(s);return Array.isArray(o)?Object.freeze(o.slice(0)):[]}has(s){return this.j(),Array.isArray(this.#i.get(s))}j(){if(this.c)throw new Error("illegal state - object is disposed")}static k(s,o){return s[0].toString()<o[0].toString()?-1:s[0].toString()>o[0].toString()?1:0}}e.$Ync=E;let d=class{static{u=this}static{this.c=0}static{this.d=1e3}static{this.e=1.1*u.d}static _mapper(s){const o=new R.$Cc;for(const h of s)o.set(h,h);return{uris:Object.freeze(Array.from(o.values()))}}constructor(s,o,h,i){this.j=o,this.k=h,this.l=i,this.g=new Map,this.h=new p.$qe({merge:r=>r.flat(),delay:50}),this.onDidChangeDiagnostics=p.Event.map(this.h.event,u._mapper),this.f=s.getProxy(O.$rN.MainThreadDiagnostics)}createDiagnosticCollection(s,o){const{g:h,f:i,h:r,j:t,k:c,l}=this,m=new class{$changeMany(I,D){i.$changeMany(I,D),t.trace("[DiagnosticCollection] change many (extension, owner, uris)",s.value,I,D.length===0?"CLEARING":D)}$clear(I){i.$clear(I),t.trace("[DiagnosticCollection] remove all (extension, owner)",s.value,I)}dispose(){i.dispose()}};let f;if(!o)o="_generated_diagnostic_collection_name_#"+u.c++,f=o;else if(!h.has(o))f=o;else{this.j.warn(`DiagnosticCollection with name '${o}' does already exist.`);do f=o+u.c++;while(h.has(f))}return new class extends E{constructor(){super(o,f,u.e,u.d,I=>l.getDocument(I)?.version,c.extUri,m,r),h.set(f,this)}dispose(){super.dispose(),h.delete(f)}}}getDiagnostics(s){if(s)return this.m(s);{const o=new Map,h=[];for(const i of this.g.values())i.forEach((r,t)=>{let c=o.get(r.toString());typeof c>"u"&&(c=h.length,o.set(r.toString(),c),h.push([r,[]])),h[c][1]=h[c][1].concat(...t)});return h}}m(s){let o=[];for(const h of this.g.values())h.has(s)&&(o=o.concat(h.get(s)));return o}$acceptMarkersChange(s){if(!this.n){const o="_generated_mirror",h=new E(o,o,Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER,i=>{},this.k.extUri,void 0,this.h);this.g.set(o,h),this.n=h}for(const[o,h]of s)this.n.set(k.URI.revive(o),h.map(T.Diagnostic.to))}};e.$Znc=d,e.$Znc=d=u=He([Ve(1,a.$_j),Ve(2,y.$Xnc)],d)}),define(ke[281],Ce([1,0,2,14,7,10,212,39]),function(oe,e,w,S,k,O,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$apc=void 0;class p{constructor(R,y,u,E={timeout:1500,errors:3}){this.c=R,this.d=y,this.f=u,this.g=E,this.a=new A.$7c,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(R){return(y,u,E)=>{const n={dispose:this.a.push([y,u,R])};return Array.isArray(E)&&E.push(n),n}}async $participateInSave(R,y){const u=w.URI.revive(R);let E=!1;const d=setTimeout(()=>E=!0,this.g.timeout),n=[];try{for(const s of[...this.a]){if(E)break;const o=this.d.getDocument(u),h=await this.h(s,{document:o,reason:O.TextDocumentSaveReason.to(y)});n.push(h)}}finally{clearTimeout(d)}return n}h([R,y,u],E){const d=this.b.get(R);return typeof d=="number"&&d>this.g.errors?Promise.resolve(!1):this.i(u,R,y,E).then(()=>!0,n=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${u.identifier.value}' threw ERROR`),this.c.error(n),!(n instanceof Error)||n.message!=="concurrent_edits"){const s=this.b.get(R);this.b.set(R,s?s+1:1),typeof s=="number"&&s>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${u.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(R,y,u,E){const d=[],n=Date.now(),{document:s,reason:o}=E,{version:h}=s,i=Object.freeze({document:s,reason:o,waitUntil(r){if(Object.isFrozen(d))throw(0,S.$0)("waitUntil can not be called async");d.push(Promise.resolve(r))}});try{y.apply(u,[i])}catch(r){return Promise.reject(r)}return Object.freeze(d),new Promise((r,t)=>{const c=setTimeout(()=>t(new Error("timeout")),this.g.timeout);return Promise.all(d).then(l=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${R.identifier.value}' finished after ${Date.now()-n}ms`),clearTimeout(c),r(l)}).catch(l=>{clearTimeout(c),t(l)})}).then(r=>{const t={edits:[]};for(const c of r)if(Array.isArray(c)&&c.every(l=>l instanceof k.$AN))for(const{newText:l,newEol:m,range:f}of c)t.edits.push({resource:s.uri,versionId:void 0,textEdit:{range:f&&O.Range.from(f),text:l,eol:m&&O.EndOfLine.from(m)}});if(t.edits.length!==0)return h===s.version?this.f.$tryApplyWorkspaceEdit(new T.$Pw(t)):Promise.reject(new Error("concurrent_edits"))})}}e.$apc=p}),define(ke[282],Ce([1,0,6,4,2,5,122,10,15,26,7]),function(oe,e,w,S,k,O,A,T,p,a,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1nc=void 0,T=qe(T);class y{constructor(E,d){this.a=new w.$me,this.b=new w.$me,this.c=new w.$me,this.d=new w.$me,this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new S.$Vc,this.h=new Map,this.f=E.getProxy(O.$rN.MainThreadDocuments),this.g=d,this.g.onDidRemoveDocuments(n=>{for(const s of n)this.b.fire(s.document)},void 0,this.e),this.g.onDidAddDocuments(n=>{for(const s of n)this.a.fire(s.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(E){if(!E)return;const d=this.g.getDocument(E);if(d)return d}getDocument(E){const d=this.getDocumentData(E);if(!d?.document)throw new Error(`Unable to retrieve document from URI '${E}'`);return d.document}ensureDocumentData(E){const d=this.g.getDocument(E);if(d)return Promise.resolve(d);let n=this.h.get(E.toString());return n||(n=this.f.$tryOpenDocument(E).then(s=>{this.h.delete(E.toString());const o=k.URI.revive(s);return(0,p.$qg)(this.g.getDocument(o))},s=>(this.h.delete(E.toString()),Promise.reject(s))),this.h.set(E.toString(),n)),n}createDocumentData(E){return this.f.$tryCreateDocument(E).then(d=>k.URI.revive(d))}$acceptModelLanguageChanged(E,d){const n=k.URI.revive(E),s=this.g.getDocument(n);if(!s)throw new Error("unknown document");this.b.fire(s.document),s._acceptLanguageId(d),this.a.fire(s.document)}$acceptModelSaved(E){const d=k.URI.revive(E),n=this.g.getDocument(d);if(!n)throw new Error("unknown document");this.$acceptDirtyStateChanged(E,!1),this.d.fire(n.document)}$acceptDirtyStateChanged(E,d){const n=k.URI.revive(E),s=this.g.getDocument(n);if(!s)throw new Error("unknown document");s._acceptIsDirty(d),this.c.fire({document:s.document,contentChanges:[],reason:void 0})}$acceptModelChanged(E,d,n){const s=k.URI.revive(E),o=this.g.getDocument(s);if(!o)throw new Error("unknown document");o._acceptIsDirty(n),o.onEvents(d);let h;d.isUndoing?h=R.TextDocumentChangeReason.Undo:d.isRedoing&&(h=R.TextDocumentChangeReason.Redo),this.c.fire((0,a.$co)({document:o.document,contentChanges:d.changes.map(i=>({range:T.Range.to(i.range),rangeOffset:i.rangeOffset,rangeLength:i.rangeLength,text:i.text})),reason:h}))}setWordDefinitionFor(E,d){(0,A.$ZP)(E,d)}}e.$1nc=y}),define(ke[71],Ce([1,0,283,6,15,2,3,5,17,10,7]),function(oe,e,w,S,k,O,A,T,p,a,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$toc=e.$soc=void 0,a=qe(a),e.$soc=(0,A.$Fi)("IExtHostEditorTabs");class y{constructor(s,o,h){this.e=h,this.d=o,this.acceptDtoUpdate(s)}get apiObject(){if(!this.a){const s=this,o={get isActive(){return s.b.id===s.e()},get label(){return s.b.label},get input(){return s.c},get isDirty(){return s.b.isDirty},get isPinned(){return s.b.isPinned},get isPreview(){return s.b.isPreview},get group(){return s.d.apiObject}};this.a=Object.freeze(o)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(s){this.b=s,this.c=this.f()}f(){switch(this.b.input.kind){case T.TabInputKind.TextInput:return new R.$eP(O.URI.revive(this.b.input.uri));case T.TabInputKind.TextDiffInput:return new R.$fP(O.URI.revive(this.b.input.original),O.URI.revive(this.b.input.modified));case T.TabInputKind.TextMergeInput:return new R.$gP(O.URI.revive(this.b.input.base),O.URI.revive(this.b.input.input1),O.URI.revive(this.b.input.input2),O.URI.revive(this.b.input.result));case T.TabInputKind.CustomEditorInput:return new R.$hP(O.URI.revive(this.b.input.uri),this.b.input.viewType);case T.TabInputKind.WebviewEditorInput:return new R.$iP(this.b.input.viewType);case T.TabInputKind.NotebookInput:return new R.$jP(O.URI.revive(this.b.input.uri),this.b.input.notebookType);case T.TabInputKind.NotebookDiffInput:return new R.$kP(O.URI.revive(this.b.input.original),O.URI.revive(this.b.input.modified),this.b.input.notebookType);case T.TabInputKind.TerminalEditorInput:return new R.$lP;case T.TabInputKind.InteractiveEditorInput:return new R.$mP(O.URI.revive(this.b.input.uri),O.URI.revive(this.b.input.inputBoxUri));case T.TabInputKind.ChatEditorInput:return new R.$nP;case T.TabInputKind.MultiDiffEditorInput:return new R.$oP(this.b.input.diffEditors.map(s=>new R.$fP(O.URI.revive(s.original),O.URI.revive(s.modified))));default:return}}}class u{constructor(s,o){this.c=[],this.d="",this.b=s,this.e=o;for(const h of s.tabs)h.isActive&&(this.d=h.id),this.c.push(new y(h,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const s=this,o={get isActive(){return s.b.groupId===s.e()},get viewColumn(){return a.ViewColumn.to(s.b.viewColumn)},get activeTab(){return s.c.find(h=>h.tabId===s.d)?.apiObject},get tabs(){return Object.freeze(s.c.map(h=>h.apiObject))}};this.a=Object.freeze(o)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(s){this.b=s}acceptTabOperation(s){if(s.kind===T.TabModelOperationKind.TAB_OPEN){const h=new y(s.tabDto,this,()=>this.activeTabId());return this.c.splice(s.index,0,h),s.tabDto.isActive&&(this.d=h.tabId),h}else if(s.kind===T.TabModelOperationKind.TAB_CLOSE){const h=this.c.splice(s.index,1)[0];if(!h)throw new Error(`Tab close updated received for index ${s.index} which does not exist`);return h.tabId===this.d&&(this.d=""),h}else if(s.kind===T.TabModelOperationKind.TAB_MOVE){if(s.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const h=this.c.splice(s.oldIndex,1)[0];if(!h)throw new Error(`Tab move updated received for index ${s.oldIndex} which does not exist`);return this.c.splice(s.index,0,h),h}const o=this.c.find(h=>h.tabId===s.tabDto.id);if(!o)throw new Error("INVALID tab");return s.tabDto.isActive?this.d=s.tabDto.id:this.d===s.tabDto.id&&!s.tabDto.isActive&&(this.d=""),o.acceptDtoUpdate(s.tabDto),o}activeTabId(){return this.d}}let E=class{constructor(s){this.b=new S.$me,this.c=new S.$me,this.e=[],this.a=s.getProxy(T.$rN.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const s=this,o={onDidChangeTabGroups:s.c.event,onDidChangeTabs:s.b.event,get all(){return Object.freeze(s.e.map(h=>h.apiObject))},get activeTabGroup(){const h=s.d;return(0,k.$qg)(s.e.find(r=>r.groupId===h)?.apiObject)},close:async(h,i)=>{const r=Array.isArray(h)?h:[h];return r.length?d(r[0])?this.j(r,i):this.i(r,i):!0}};this.f=Object.freeze(o)}return this.f}$acceptEditorTabModel(s){const o=new Set(this.e.map(m=>m.groupId)),h=new Set(s.map(m=>m.groupId)),i=(0,w.$L)(o,h),r=this.e.filter(m=>i.removed.includes(m.groupId)).map(m=>m.apiObject),t=[],c=[];this.e=s.map(m=>{const f=new u(m,()=>this.d);return i.added.includes(f.groupId)?t.push(f.apiObject):c.push(f.apiObject),f});const l=(0,k.$qg)(s.find(m=>m.isActive===!0)?.groupId);l!==void 0&&this.d!==l&&(this.d=l),this.c.fire(Object.freeze({opened:t,closed:r,changed:c}))}$acceptTabGroupUpdate(s){const o=this.e.find(h=>h.groupId===s.groupId);if(!o)throw new Error("Update Group IPC call received before group creation.");o.acceptGroupDtoUpdate(s),s.isActive&&(this.d=s.groupId),this.c.fire(Object.freeze({changed:[o.apiObject],opened:[],closed:[]}))}$acceptTabOperation(s){const o=this.e.find(i=>i.groupId===s.groupId);if(!o)throw new Error("Update Tabs IPC call received before group creation.");const h=o.acceptTabOperation(s);switch(s.kind){case T.TabModelOperationKind.TAB_OPEN:this.b.fire(Object.freeze({opened:[h.apiObject],closed:[],changed:[]}));return;case T.TabModelOperationKind.TAB_CLOSE:this.b.fire(Object.freeze({opened:[],closed:[h.apiObject],changed:[]}));return;case T.TabModelOperationKind.TAB_MOVE:case T.TabModelOperationKind.TAB_UPDATE:this.b.fire(Object.freeze({opened:[],closed:[],changed:[h.apiObject]}));return}}g(s){for(const o of this.e)for(const h of o.tabs)if(h.apiObject===s)return h}h(s){return this.e.find(o=>o.apiObject===s)}async i(s,o){const h=[];for(const i of s){const r=this.g(i);if(!r)throw new Error("Tab close: Invalid tab not found!");h.push(r.tabId)}return this.a.$closeTab(h,o)}async j(s,o){const h=[];for(const i of s){const r=this.h(i);if(!r)throw new Error("Group close: Invalid group not found!");h.push(r.groupId)}return this.a.$closeGroup(h,o)}};e.$toc=E,e.$toc=E=He([Ve(0,p.$XP)],E);function d(n){return n.tabs!==void 0}}),define(ke[284],Ce([1,0,2,5,30,4,7,10,327,13,28,23,25,60]),function(oe,e,w,S,k,O,A,T,p,a,R,y,u,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dpc=void 0,k=qe(k),T=qe(T);class d{constructor(){this.a=[]}add(o){this.b=void 0,this.a.push(o)}delete(o){const h=this.a.indexOf(o);h>=0&&(this.a.splice(h,1),this.b=void 0)}c(){if(!this.b){const o=this.a.sort(),h=[];let i,r,t=p.State.LastKnownState,c=p.State.LastKnownState;for(const l of o){let m=i?(0,a.$If)(i,l):0;for(m===0?r=p.State.Start:r=c;m<l.length;m++)m+1===l.length?(t=c,c=p.State.BeforeColon):c+=1,h.push([r,l.toUpperCase().charCodeAt(m),c]),h.push([r,l.toLowerCase().charCodeAt(m),c]),r=c;i=l,c=t}h.push([p.State.BeforeColon,R.CharCode.Colon,p.State.AfterColon]),h.push([p.State.AfterColon,R.CharCode.Slash,p.State.End]),this.b=new p.$l4(h)}}provideDocumentLinks(o){this.c();const h=[],i=p.$m4.computeLinks({getLineContent(r){return o.lineAt(r-1).text},getLineCount(){return o.lineCount}},this.b);for(const r of i){const t=T.DocumentLink.to(r);t.target&&h.push(t)}return h}}class n{constructor(o,h){this.i=h,this.b=new d,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=o.getProxy(S.$rN.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(o,h,i,r={}){if(n.j(i),this.d.has(h))throw new Error(`a provider for the scheme '${h}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(o,"*",this.b));const t=this.h++;this.b.add(h),this.d.add(h),this.c.set(t,i);let c=k.FileSystemProviderCapabilities.FileReadWrite;r.isCaseSensitive&&(c+=k.FileSystemProviderCapabilities.PathCaseSensitive),r.isReadonly&&(c+=k.FileSystemProviderCapabilities.Readonly),typeof i.copy=="function"&&(c+=k.FileSystemProviderCapabilities.FileFolderCopy),typeof i.open=="function"&&typeof i.close=="function"&&typeof i.read=="function"&&typeof i.write=="function"&&((0,u.$4G)(o,"fsChunks"),c+=k.FileSystemProviderCapabilities.FileOpenReadWriteClose);let l;r.isReadonly&&(0,E.$5k)(r.isReadonly)&&r.isReadonly.value!==""&&(l={value:r.isReadonly.value,isTrusted:r.isReadonly.isTrusted,supportThemeIcons:r.isReadonly.supportThemeIcons,supportHtml:r.isReadonly.supportHtml,baseUri:r.isReadonly.baseUri,uris:r.isReadonly.uris}),this.a.$registerFileSystemProvider(t,h,c,l).catch(f=>{console.error(`FAILED to register filesystem provider of ${o.identifier.value}-extension for the scheme ${h}`),console.error(f)});const m=i.onDidChangeFile(f=>{const $=[];for(const I of f){const{uri:D,type:v}=I;if(D.scheme!==h)continue;let C;switch(v){case A.FileChangeType.Changed:C=k.FileChangeType.UPDATED;break;case A.FileChangeType.Created:C=k.FileChangeType.ADDED;break;case A.FileChangeType.Deleted:C=k.FileChangeType.DELETED;break;default:throw new Error("Unknown FileChangeType")}$.push({resource:D,type:C})}this.a.$onFileSystemChange(t,$)});return(0,O.$Uc)(()=>{m.dispose(),this.b.delete(h),this.d.delete(h),this.c.delete(t),this.a.$unregisterProvider(t)})}static j(o){if(!o)throw new Error("MISSING provider");if(typeof o.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof o.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof o.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof o.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof o.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof o.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof o.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof o.rename!="function")throw new Error("Provider does NOT implement rename")}static k(o){const{type:h,ctime:i,mtime:r,size:t,permissions:c}=o;return{type:h,ctime:i,mtime:r,size:t,permissions:c}}$stat(o,h){return Promise.resolve(this.l(o).stat(w.URI.revive(h))).then(i=>n.k(i))}$readdir(o,h){return Promise.resolve(this.l(o).readDirectory(w.URI.revive(h)))}$readFile(o,h){return Promise.resolve(this.l(o).readFile(w.URI.revive(h))).then(i=>y.$Oe.wrap(i))}$writeFile(o,h,i,r){return Promise.resolve(this.l(o).writeFile(w.URI.revive(h),i.buffer,r))}$delete(o,h,i){return Promise.resolve(this.l(o).delete(w.URI.revive(h),i))}$rename(o,h,i,r){return Promise.resolve(this.l(o).rename(w.URI.revive(h),w.URI.revive(i),r))}$copy(o,h,i,r){const t=this.l(o);if(!t.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(t.copy(w.URI.revive(h),w.URI.revive(i),r))}$mkdir(o,h){return Promise.resolve(this.l(o).createDirectory(w.URI.revive(h)))}$watch(o,h,i,r){const t=this.l(o).watch(w.URI.revive(i),r);this.f.set(h,t)}$unwatch(o,h){const i=this.f.get(h);i&&(i.dispose(),this.f.delete(h))}$open(o,h,i){const r=this.l(o);if(!r.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(r.open(w.URI.revive(h),i))}$close(o,h){const i=this.l(o);if(!i.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(i.close(h))}$read(o,h,i,r){const t=this.l(o);if(!t.read)throw new Error('FileSystemProvider does not implement "read"');const c=y.$Oe.alloc(r);return Promise.resolve(t.read(h,i,c.buffer,0,r)).then(l=>c.slice(0,l))}$write(o,h,i,r){const t=this.l(o);if(!t.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(t.write(h,i,r.buffer,0,r.byteLength))}l(o){const h=this.c.get(o);if(!h){const i=new Error;throw i.name="ENOPRO",i.message="no provider",i}return h}}e.$dpc=n}),define(ke[285],Ce([1,0,6,41,2,5,10,7,30,47]),function(oe,e,w,S,k,O,A,T,p,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$epc=void 0,A=qe(A);class R{get ignoreCreateEvents(){return!!(this.h&1)}get ignoreChangeEvents(){return!!(this.h&2)}get ignoreDeleteEvents(){return!!(this.h&4)}constructor(d,n,s,o,h,i){this.a=Math.random(),this.b=new w.$me,this.c=new w.$me,this.d=new w.$me,this.h=0,i?.ignoreCreateEvents&&(this.h+=1),i?.ignoreChangeEvents&&(this.h+=2),i?.ignoreDeleteEvents&&(this.h+=4);const r=(0,S.$zk)(h),t=typeof h=="string",c=i?.correlate,l=o(m=>{if(!(typeof m.session=="number"&&m.session!==this.a)&&!(c&&typeof m.session>"u")){if(!i?.ignoreCreateEvents)for(const f of m.created){const $=k.URI.revive(f);r($.fsPath)&&(!t||n.getWorkspaceFolder($))&&this.b.fire($)}if(!i?.ignoreChangeEvents)for(const f of m.changed){const $=k.URI.revive(f);r($.fsPath)&&(!t||n.getWorkspaceFolder($))&&this.c.fire($)}if(!i?.ignoreDeleteEvents)for(const f of m.deleted){const $=k.URI.revive(f);r($.fsPath)&&(!t||n.getWorkspaceFolder($))&&this.d.fire($)}}});this.g=T.$tN.from(this.i(d,s,h,i,i?.correlate),this.b,this.c,this.d,l)}i(d,n,s,o,h){const i=T.$tN.from();if(typeof s=="string"||o?.ignoreChangeEvents&&o?.ignoreCreateEvents&&o?.ignoreDeleteEvents)return i;const r=d.getProxy(O.$rN.MainThreadFileSystemEventService);let t=!1;(s.pattern.includes(S.$vk)||s.pattern.includes(S.$wk))&&(t=!0);let c;return h&&(o?.ignoreChangeEvents||o?.ignoreCreateEvents||o?.ignoreDeleteEvents)&&(c=p.FileChangeFilter.UPDATED|p.FileChangeFilter.ADDED|p.FileChangeFilter.DELETED,o?.ignoreChangeEvents&&(c&=~p.FileChangeFilter.UPDATED),o?.ignoreCreateEvents&&(c&=~p.FileChangeFilter.ADDED),o?.ignoreDeleteEvents&&(c&=~p.FileChangeFilter.DELETED)),r.$watch(n.identifier.value,this.a,s.baseUri,{recursive:t,excludes:o?.excludes??[],filter:c},!!h),T.$tN.from({dispose:()=>r.$unwatch(this.a)})}dispose(){this.g.dispose()}get onDidCreate(){return this.b.event}get onDidChange(){return this.c.event}get onDidDelete(){return this.d.event}}class y{constructor(d){this.a=d,this.session=this.a.session,this.b=new a.$X(()=>this.a.created.map(k.URI.revive)),this.c=new a.$X(()=>this.a.changed.map(k.URI.revive)),this.d=new a.$X(()=>this.a.deleted.map(k.URI.revive))}get created(){return this.b.value}get changed(){return this.c.value}get deleted(){return this.d.value}}class u{constructor(d,n,s){this.j=d,this.k=n,this.l=s,this.a=new w.$me,this.b=new w.$me,this.c=new w.$me,this.d=new w.$me,this.g=new w.$oe,this.h=new w.$oe,this.i=new w.$oe,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(d,n,s,o){return new R(this.j,d,n,this.a.event,A.GlobPattern.from(s),o)}$onFileEvent(d){this.a.fire(new y(d))}$onDidRunFileOperation(d,n){switch(d){case p.FileOperation.MOVE:this.b.fire(Object.freeze({files:n.map(s=>({oldUri:k.URI.revive(s.source),newUri:k.URI.revive(s.target)}))}));break;case p.FileOperation.DELETE:this.d.fire(Object.freeze({files:n.map(s=>k.URI.revive(s.target))}));break;case p.FileOperation.CREATE:case p.FileOperation.COPY:this.c.fire(Object.freeze({files:n.map(s=>k.URI.revive(s.target))}));break;default:}}getOnWillRenameFileEvent(d){return this.m(d,this.g)}getOnWillCreateFileEvent(d){return this.m(d,this.h)}getOnWillDeleteFileEvent(d){return this.m(d,this.i)}m(d,n){return(s,o,h)=>{const i=function(t){s.call(o,t)};return i.extension=d,n.event(i,void 0,h)}}async $onWillRunFileOperation(d,n,s,o){switch(d){case p.FileOperation.MOVE:return await this.n(this.g,{files:n.map(h=>({oldUri:k.URI.revive(h.source),newUri:k.URI.revive(h.target)}))},s,o);case p.FileOperation.DELETE:return await this.n(this.i,{files:n.map(h=>k.URI.revive(h.target))},s,o);case p.FileOperation.CREATE:case p.FileOperation.COPY:return await this.n(this.h,{files:n.map(h=>k.URI.revive(h.target))},s,o)}}async n(d,n,s,o){const h=new Set,i=[];if(await d.fireAsync(n,o,async(t,c)=>{const l=Date.now(),m=await Promise.resolve(t);m instanceof T.$DN&&(i.push([c.extension,m]),h.add(c.extension.displayName??c.extension.identifier.value)),Date.now()-l>s&&this.k.warn("SLOW file-participant",c.extension.identifier)}),o.isCancellationRequested||i.length===0)return;const r={edits:[]};for(const[,t]of i){const{edits:c}=A.WorkspaceEdit.from(t,{getTextDocumentVersion:l=>this.l.getDocument(l)?.version,getNotebookDocumentVersion:()=>{}});r.edits=r.edits.concat(c)}return{edit:r,extensionNames:Array.from(h)}}}e.$epc=u}),define(ke[286],Ce([1,0,18,11,22,14,97,4,26,70,13,15,2,33,328,94,104,182,19,10,7,25,80,5]),function(oe,e,w,S,k,O,A,T,p,a,R,y,u,E,d,n,s,o,h,i,r,t,c,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2nc=void 0,n=qe(n),i=qe(i),l=qe(l);class m{constructor(z,U){this.d=z,this.e=U}async provideDocumentSymbols(z,U){const K=this.d.getDocument(z),Q=await this.e.provideDocumentSymbols(K,U);if(!(0,w.$Mb)(Q))return Q[0]instanceof r.$NN?Q.map(i.DocumentSymbol.from):m.f(Q)}static f(z){z=z.slice(0).sort((Q,ne)=>{let fe=Q.location.range.start.compareTo(ne.location.range.start);return fe===0&&(fe=ne.location.range.end.compareTo(Q.location.range.end)),fe});const U=[],K=[];for(const Q of z){const ne={name:Q.name||"!!MISSING: name!!",kind:i.SymbolKind.from(Q.kind),tags:Q.tags?.map(i.SymbolTag.from)||[],detail:"",containerName:Q.containerName,range:i.Range.from(Q.location.range),selectionRange:i.Range.from(Q.location.range),children:[]};for(;;){if(K.length===0){K.push(ne),U.push(ne);break}const fe=K[K.length-1];if(E.$Ht.containsRange(fe.range,ne.range)&&!E.$Ht.equalsRange(fe.range,ne.range)){fe.children?.push(ne),K.push(ne);break}K.pop()}}return U}}class f{constructor(z,U,K,Q,ne,fe){this.f=z,this.g=U,this.h=K,this.j=Q,this.k=ne,this.l=fe,this.d=new c.$Rnc("CodeLens"),this.e=new Map}async provideCodeLenses(z,U){const K=this.f.getDocument(z),Q=await this.h.provideCodeLenses(K,U);if(!Q||U.isCancellationRequested)return;const ne=this.d.add(Q),fe=new T.$Vc;this.e.set(ne,fe);const Ae={cacheId:ne,lenses:[]};for(let je=0;je<Q.length;je++)Ae.lenses.push({cacheId:[ne,je],range:i.Range.from(Q[je].range),command:this.g.toInternal(Q[je].command,fe)});return Ae}async resolveCodeLens(z,U){const K=z.cacheId&&this.d.get(...z.cacheId);if(!K)return;let Q;if(typeof this.h.resolveCodeLens!="function"||K.isResolved?Q=K:Q=await this.h.resolveCodeLens(K,U),Q||(Q=K),U.isCancellationRequested)return;const ne=z.cacheId&&this.e.get(z.cacheId[0]);if(ne){if(!Q.command){const fe=new Error("INVALID code lens resolved, lacks command: "+this.j.identifier.value);this.k.onExtensionError(this.j.identifier,fe),this.l.error(fe);return}return z.command=this.g.toInternal(Q.command,ne),z}}releaseCodeLenses(z){this.e.get(z)?.dispose(),this.e.delete(z),this.d.delete(z)}}function $(Oe){return Array.isArray(Oe)?Oe.map(i.DefinitionLink.from):Oe?[i.DefinitionLink.from(Oe)]:[]}class I{constructor(z,U){this.d=z,this.e=U}async provideDefinition(z,U,K){const Q=this.d.getDocument(z),ne=i.Position.to(U),fe=await this.e.provideDefinition(Q,ne,K);return $(fe)}}class D{constructor(z,U){this.d=z,this.e=U}async provideDeclaration(z,U,K){const Q=this.d.getDocument(z),ne=i.Position.to(U),fe=await this.e.provideDeclaration(Q,ne,K);return $(fe)}}class v{constructor(z,U){this.d=z,this.e=U}async provideImplementation(z,U,K){const Q=this.d.getDocument(z),ne=i.Position.to(U),fe=await this.e.provideImplementation(Q,ne,K);return $(fe)}}class C{constructor(z,U){this.d=z,this.e=U}async provideTypeDefinition(z,U,K){const Q=this.d.getDocument(z),ne=i.Position.to(U),fe=await this.e.provideTypeDefinition(Q,ne,K);return $(fe)}}class P{static{this.f=10}constructor(z,U){this.g=z,this.h=U,this.d=0,this.e=new Map}async provideHover(z,U,K,Q){const ne=this.g.getDocument(z),fe=i.Position.to(U);let Ae;if(K&&K.verbosityRequest){const it=K.verbosityRequest.previousHover.id,nt=this.e.get(it);if(!nt)throw new Error(`Hover with id ${it} not found`);const tt={verbosityDelta:K.verbosityRequest.verbosityDelta,previousHover:nt};Ae=await this.h.provideHover(ne,fe,Q,tt)}else Ae=await this.h.provideHover(ne,fe,Q);if(!Ae||(0,w.$Mb)(Ae.contents))return;Ae.range||(Ae.range=ne.getWordRangeAtPosition(fe)),Ae.range||(Ae.range=new r.$vN(fe,fe));const je=i.Hover.from(Ae),Ke=this.d;if(this.e.size===P.f){const it=Math.min(...this.e.keys());this.e.delete(it)}return this.e.set(Ke,Ae),this.d+=1,{...je,id:Ke}}releaseHover(z){this.e.delete(z)}}class g{constructor(z,U){this.d=z,this.e=U}async provideEvaluatableExpression(z,U,K){const Q=this.d.getDocument(z),ne=i.Position.to(U),fe=await this.e.provideEvaluatableExpression(Q,ne,K);if(fe)return i.EvaluatableExpression.from(fe)}}class b{constructor(z,U){this.d=z,this.e=U}async provideInlineValues(z,U,K,Q){const ne=this.d.getDocument(z),fe=await this.e.provideInlineValues(ne,i.Range.to(U),i.InlineValueContext.to(K),Q);if(Array.isArray(fe))return fe.map(Ae=>i.InlineValue.from(Ae))}}class L{constructor(z,U){this.d=z,this.e=U}async provideDocumentHighlights(z,U,K){const Q=this.d.getDocument(z),ne=i.Position.to(U),fe=await this.e.provideDocumentHighlights(Q,ne,K);if(Array.isArray(fe))return fe.map(i.DocumentHighlight.from)}}class N{constructor(z,U){this.d=z,this.e=U}async provideMultiDocumentHighlights(z,U,K,Q){const ne=this.d.getDocument(z),fe=K.map(Ke=>this.d.getDocument(Ke)),Ae=i.Position.to(U),je=await this.e.provideMultiDocumentHighlights(ne,Ae,fe,Q);if(Array.isArray(je))return je.map(i.MultiDocumentHighlight.from)}}class B{constructor(z,U){this.d=z,this.e=U}async provideLinkedEditingRanges(z,U,K){const Q=this.d.getDocument(z),ne=i.Position.to(U),fe=await this.e.provideLinkedEditingRanges(Q,ne,K);if(fe&&Array.isArray(fe.ranges))return{ranges:(0,w.$Jb)(fe.ranges.map(i.Range.from)),wordPattern:fe.wordPattern}}}class G{constructor(z,U){this.d=z,this.e=U}async provideReferences(z,U,K,Q){const ne=this.d.getDocument(z),fe=i.Position.to(U),Ae=await this.e.provideReferences(ne,fe,K,Q);if(Array.isArray(Ae))return Ae.map(i.location.from)}}class W{static{this.d=1e3}constructor(z,U,K,Q,ne,fe,Ae){this.g=z,this.h=U,this.j=K,this.k=Q,this.l=ne,this.m=fe,this.n=Ae,this.e=new c.$Rnc("CodeAction"),this.f=new Map}async provideCodeActions(z,U,K,Q){const ne=this.g.getDocument(z),fe=d.$Jt.isISelection(U)?i.Selection.to(U):i.Range.to(U),Ae=[];for(const tt of this.j.getDiagnostics(z))if(fe.intersection(tt.range)&&Ae.push(tt)>W.d)break;const je={diagnostics:Ae,only:K.only?new r.$PN(K.only):void 0,triggerKind:i.CodeActionTriggerKind.to(K.trigger)},Ke=await this.k.provideCodeActions(ne,fe,je,Q);if(!(0,w.$Nb)(Ke)||Q.isCancellationRequested)return;const _e=this.e.add(Ke),it=new T.$Vc;this.f.set(_e,it);const nt=[];for(let tt=0;tt<Ke.length;tt++){const rt=Ke[tt];if(rt)if(W.o(rt))this.n.report("CodeActionProvider.provideCodeActions - return commands",this.m,"Return 'CodeAction' instances instead."),nt.push({_isSynthetic:!0,title:rt.title,command:this.h.toInternal(rt,it)});else{je.only&&(rt.kind?je.only.contains(rt.kind)||this.l.warn(`${this.m.identifier.value} - Code actions of kind '${je.only.value}' requested but returned code action is of kind '${rt.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.l.warn(`${this.m.identifier.value} - Code actions of kind '${je.only.value}' requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`));const $t=rt.ranges??[];nt.push({cacheId:[_e,tt],title:rt.title,command:rt.command&&this.h.toInternal(rt.command,it),diagnostics:rt.diagnostics&&rt.diagnostics.map(i.Diagnostic.from),edit:rt.edit&&i.WorkspaceEdit.from(rt.edit,void 0),kind:rt.kind&&rt.kind.value,isPreferred:rt.isPreferred,isAI:(0,t.$3G)(this.m,"codeActionAI")?rt.isAI:!1,ranges:(0,t.$3G)(this.m,"codeActionRanges")?(0,w.$Jb)($t.map(i.Range.from)):void 0,disabled:rt.disabled?.reason})}}return{cacheId:_e,actions:nt}}async resolveCodeAction(z,U){const[K,Q]=z,ne=this.e.get(K,Q);if(!ne||W.o(ne))return{};if(!this.k.resolveCodeAction)return{};const fe=await this.k.resolveCodeAction(ne,U)??ne;let Ae;fe.edit&&(Ae=i.WorkspaceEdit.from(fe.edit,void 0));let je;if(fe.command){const Ke=this.f.get(K);Ke&&(je=this.h.toInternal(fe.command,Ke))}return{edit:Ae,command:je}}releaseCodeActions(z){this.f.get(z)?.dispose(),this.f.delete(z),this.e.delete(z)}static o(z){return typeof z.command=="string"&&typeof z.title=="string"}}class F{constructor(z,U,K,Q,ne){this.e=z,this.f=U,this.g=K,this.h=Q,this.j=ne,this.d=new c.$Rnc("DocumentPasteEdit")}async prepareDocumentPaste(z,U,K,Q){if(!this.g.prepareDocumentPaste)return;const ne=this.f.getDocument(z),fe=U.map(Ke=>i.Range.to(Ke)),Ae=i.DataTransfer.toDataTransfer(K,()=>{throw new O.$ab});if(await this.g.prepareDocumentPaste(ne,fe,Ae,Q),Q.isCancellationRequested)return;const je=Array.from(Ae).filter(([,Ke])=>!(Ke instanceof r.$jO));return i.DataTransfer.from(je)}async providePasteEdits(z,U,K,Q,ne,fe){if(!this.g.provideDocumentPasteEdits)return[];const Ae=this.f.getDocument(U),je=K.map(nt=>i.Range.to(nt)),Ke=i.DataTransfer.toDataTransfer(Q,async nt=>(await this.e.$resolvePasteFileData(this.h,z,nt)).buffer),_e=await this.g.provideDocumentPasteEdits(Ae,je,Ke,{only:ne.only?new r.$oO(ne.only):void 0,triggerKind:ne.triggerKind},fe);if(!_e||fe.isCancellationRequested)return[];const it=this.d.add(_e);return _e.map((nt,tt)=>({_cacheId:[it,tt],title:nt.title??(0,o.localize)(0,null,this.j.displayName||this.j.name),kind:nt.kind,yieldTo:nt.yieldTo?.map(rt=>rt.value),insertText:typeof nt.insertText=="string"?nt.insertText:{snippet:nt.insertText.value},additionalEdit:nt.additionalEdit?i.WorkspaceEdit.from(nt.additionalEdit,void 0):void 0}))}async resolvePasteEdit(z,U){const[K,Q]=z,ne=this.d.get(K,Q);if(!ne||!this.g.resolveDocumentPasteEdit)return{};const fe=await this.g.resolveDocumentPasteEdit(ne,U)??ne;return{additionalEdit:fe.additionalEdit?i.WorkspaceEdit.from(fe.additionalEdit,void 0):void 0}}releasePasteEdits(z){this.d.delete(z)}}class q{constructor(z,U){this.d=z,this.e=U}async provideDocumentFormattingEdits(z,U,K){const Q=this.d.getDocument(z),ne=await this.e.provideDocumentFormattingEdits(Q,U,K);if(Array.isArray(ne))return ne.map(i.TextEdit.from)}}class ue{constructor(z,U){this.d=z,this.e=U}async provideDocumentRangeFormattingEdits(z,U,K,Q){const ne=this.d.getDocument(z),fe=i.Range.to(U),Ae=await this.e.provideDocumentRangeFormattingEdits(ne,fe,K,Q);if(Array.isArray(Ae))return Ae.map(i.TextEdit.from)}async provideDocumentRangesFormattingEdits(z,U,K,Q){(0,y.$pg)(typeof this.e.provideDocumentRangesFormattingEdits=="function","INVALID invocation of `provideDocumentRangesFormattingEdits`");const ne=this.d.getDocument(z),fe=U.map(i.Range.to),Ae=await this.e.provideDocumentRangesFormattingEdits(ne,fe,K,Q);if(Array.isArray(Ae))return Ae.map(i.TextEdit.from)}}class ge{constructor(z,U){this.d=z,this.e=U,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(z,U,K,Q,ne){const fe=this.d.getDocument(z),Ae=i.Position.to(U),je=await this.e.provideOnTypeFormattingEdits(fe,Ae,K,Q,ne);if(Array.isArray(je))return je.map(i.TextEdit.from)}}class te{constructor(z,U){this.e=z,this.f=U,this.d=new c.$Rnc("WorkspaceSymbols")}async provideWorkspaceSymbols(z,U){const K=await this.e.provideWorkspaceSymbols(z,U);if(!(0,w.$Nb)(K))return{symbols:[]};const Q=this.d.add(K),ne={cacheId:Q,symbols:[]};for(let fe=0;fe<K.length;fe++){const Ae=K[fe];if(!Ae||!Ae.name){this.f.warn("INVALID SymbolInformation",Ae);continue}ne.symbols.push({...i.WorkspaceSymbol.from(Ae),cacheId:[Q,fe]})}return ne}async resolveWorkspaceSymbol(z,U){if(typeof this.e.resolveWorkspaceSymbol!="function"||!z.cacheId)return z;const K=this.d.get(...z.cacheId);if(K){const Q=await this.e.resolveWorkspaceSymbol(K,U);return Q&&(0,p.$eo)(z,i.WorkspaceSymbol.from(Q),!0)}}releaseWorkspaceSymbols(z){this.d.delete(z)}}class me{static supportsResolving(z){return typeof z.prepareRename=="function"}constructor(z,U,K){this.d=z,this.e=U,this.f=K}async provideRenameEdits(z,U,K,Q){const ne=this.d.getDocument(z),fe=i.Position.to(U);try{const Ae=await this.e.provideRenameEdits(ne,fe,K,Q);return Ae?i.WorkspaceEdit.from(Ae):void 0}catch(Ae){const je=me.g(Ae);return je?{rejectReason:je,edits:void 0}:Promise.reject(Ae)}}async resolveRenameLocation(z,U,K){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const Q=this.d.getDocument(z),ne=i.Position.to(U);try{const fe=await this.e.prepareRename(Q,ne,K);let Ae,je;if(r.$vN.isRange(fe)?(Ae=fe,je=Q.getText(fe)):(0,y.$hg)(fe)&&(Ae=fe.range,je=fe.placeholder),!Ae||!je)return;if(Ae.start.line>ne.line||Ae.end.line<ne.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:i.Range.from(Ae),text:je}}catch(fe){const Ae=me.g(fe);return Ae?{rejectReason:Ae,range:void 0,text:void 0}:Promise.reject(fe)}}static g(z){return typeof z=="string"?z:z instanceof Error&&typeof z.message=="string"?z.message:void 0}}class re{static{this.d={[n.NewSymbolNameTriggerKind.Invoke]:r.NewSymbolNameTriggerKind.Invoke,[n.NewSymbolNameTriggerKind.Automatic]:r.NewSymbolNameTriggerKind.Automatic}}constructor(z,U,K){this.e=z,this.f=U,this.g=K}async supportsAutomaticNewSymbolNamesTriggerKind(){return this.f.supportsAutomaticTriggerKind}async provideNewSymbolNames(z,U,K,Q){const ne=this.e.getDocument(z),fe=i.Range.to(U);try{const Ae=re.d[K],je=await this.f.provideNewSymbolNames(ne,fe,Ae,Q);return je?je.map(Ke=>typeof Ke=="string"?{newSymbolName:Ke}:{newSymbolName:Ke.newSymbolName,tags:Ke.tags}):void 0}catch(Ae){this.g.error(re.h(Ae)??JSON.stringify(Ae,null,"	"));return}}static h(z){return typeof z=="string"?z:z instanceof Error&&typeof z.message=="string"?z.message:void 0}}class ce{constructor(z,U){this.resultId=z,this.tokens=U}}class be{constructor(z,U){this.f=z,this.g=U,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(z,U,K){const Q=this.f.getDocument(z),ne=U!==0?this.d.get(U):null;let fe=typeof ne?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(Q,ne.resultId,K):await this.g.provideDocumentSemanticTokens(Q,K);return ne&&this.d.delete(U),fe?(fe=be.h(fe),this.o(be.n(ne,fe),fe)):null}async releaseDocumentSemanticColoring(z){this.d.delete(z)}static h(z){return be.j(z)?be.k(z)?z:new r.$OO(new Uint32Array(z.data),z.resultId):be.l(z)?be.m(z)?z:new r.$QO(z.edits.map(U=>new r.$PO(U.start,U.deleteCount,U.data?new Uint32Array(U.data):U.data)),z.resultId):z}static j(z){return z&&!!z.data}static k(z){return z.data instanceof Uint32Array}static l(z){return z&&Array.isArray(z.edits)}static m(z){for(const U of z.edits)if(!(U.data instanceof Uint32Array))return!1;return!0}static n(z,U){if(!be.j(U)||!z||!z.tokens)return U;const K=z.tokens,Q=K.length,ne=U.data,fe=ne.length;let Ae=0;const je=Math.min(Q,fe);for(;Ae<je&&K[Ae]===ne[Ae];)Ae++;if(Ae===Q&&Ae===fe)return new r.$QO([],U.resultId);let Ke=0;const _e=je-Ae;for(;Ke<_e&&K[Q-Ke-1]===ne[fe-Ke-1];)Ke++;return new r.$QO([{start:Ae,deleteCount:Q-Ae-Ke,data:ne.subarray(Ae,fe-Ke)}],U.resultId)}o(z,U){if(be.j(z)){const K=this.e++;return this.d.set(K,new ce(z.resultId,z.data)),(0,s.$ndb)({id:K,type:"full",data:z.data})}if(be.l(z)){const K=this.e++;return be.j(U)?this.d.set(K,new ce(U.resultId,U.data)):this.d.set(K,new ce(z.resultId)),(0,s.$ndb)({id:K,type:"delta",deltas:(z.edits||[]).map(Q=>({start:Q.start,deleteCount:Q.deleteCount,data:Q.data}))})}return null}}class se{constructor(z,U){this.d=z,this.e=U}async provideDocumentRangeSemanticTokens(z,U,K){const Q=this.d.getDocument(z),ne=await this.e.provideDocumentRangeSemanticTokens(Q,i.Range.to(U),K);return ne?this.f(ne):null}f(z){return(0,s.$ndb)({id:0,type:"full",data:z.data})}}class Ie{static supportsResolving(z){return typeof z.resolveCompletionItem=="function"}constructor(z,U,K,Q,ne){this.f=z,this.g=U,this.h=K,this.j=Q,this.k=ne,this.d=new c.$Rnc("CompletionItem"),this.e=new Map}async provideCompletionItems(z,U,K,Q){const ne=this.f.getDocument(z),fe=i.Position.to(U),Ae=ne.getWordRangeAtPosition(fe)||new r.$vN(fe,fe),je=Ae.with({end:fe}),Ke=new a.$ge,_e=await this.h.provideCompletionItems(ne,fe,Q,i.CompletionContext.to(K));if(!_e||Q.isCancellationRequested)return;const it=Array.isArray(_e)?new r.$3N(_e):_e,nt=Ie.supportsResolving(this.h)?this.d.add(it.items):this.d.add([]),tt=new T.$Vc;this.e.set(nt,tt);const rt=[],$t={x:nt,[l.ISuggestResultDtoField.completions]:rt,[l.ISuggestResultDtoField.defaultRanges]:{replace:i.Range.from(Ae),insert:i.Range.from(je)},[l.ISuggestResultDtoField.isIncomplete]:it.isIncomplete||void 0,[l.ISuggestResultDtoField.duration]:Ke.elapsed()};for(let lt=0;lt<it.items.length;lt++){const st=it.items[lt],ut=this.l(st,[nt,lt],je,Ae);rt.push(ut)}return $t}async resolveCompletionItem(z,U){if(typeof this.h.resolveCompletionItem!="function")return;const K=this.d.get(...z);if(!K)return;const Q=this.l(K,z),ne=await this.h.resolveCompletionItem(K,U);if(!ne)return;const fe=this.l(ne,z);return(Q[l.ISuggestDataDtoField.insertText]!==fe[l.ISuggestDataDtoField.insertText]||Q[l.ISuggestDataDtoField.insertTextRules]!==fe[l.ISuggestDataDtoField.insertTextRules])&&this.j.report("CompletionItem.insertText",this.k,"extension MAY NOT change 'insertText' of a CompletionItem during resolve"),(Q[l.ISuggestDataDtoField.commandIdent]!==fe[l.ISuggestDataDtoField.commandIdent]||Q[l.ISuggestDataDtoField.commandId]!==fe[l.ISuggestDataDtoField.commandId]||!(0,p.$fo)(Q[l.ISuggestDataDtoField.commandArguments],fe[l.ISuggestDataDtoField.commandArguments]))&&this.j.report("CompletionItem.command",this.k,"extension MAY NOT change 'command' of a CompletionItem during resolve"),{...Q,[l.ISuggestDataDtoField.documentation]:fe[l.ISuggestDataDtoField.documentation],[l.ISuggestDataDtoField.detail]:fe[l.ISuggestDataDtoField.detail],[l.ISuggestDataDtoField.additionalTextEdits]:fe[l.ISuggestDataDtoField.additionalTextEdits],[l.ISuggestDataDtoField.insertText]:fe[l.ISuggestDataDtoField.insertText],[l.ISuggestDataDtoField.insertTextRules]:fe[l.ISuggestDataDtoField.insertTextRules],[l.ISuggestDataDtoField.commandIdent]:fe[l.ISuggestDataDtoField.commandIdent],[l.ISuggestDataDtoField.commandId]:fe[l.ISuggestDataDtoField.commandId],[l.ISuggestDataDtoField.commandArguments]:fe[l.ISuggestDataDtoField.commandArguments]}}releaseCompletionItems(z){this.e.get(z)?.dispose(),this.e.delete(z),this.d.delete(z)}l(z,U,K,Q){const ne=this.e.get(U[0]);if(!ne)throw Error("DisposableStore is missing...");const fe=this.g.toInternal(z.command,ne),Ae={x:U,[l.ISuggestDataDtoField.label]:z.label,[l.ISuggestDataDtoField.kind]:z.kind!==void 0?i.CompletionItemKind.from(z.kind):void 0,[l.ISuggestDataDtoField.kindModifier]:z.tags&&z.tags.map(i.CompletionItemTag.from),[l.ISuggestDataDtoField.detail]:z.detail,[l.ISuggestDataDtoField.documentation]:typeof z.documentation>"u"?void 0:i.MarkdownString.fromStrict(z.documentation),[l.ISuggestDataDtoField.sortText]:z.sortText!==z.label?z.sortText:void 0,[l.ISuggestDataDtoField.filterText]:z.filterText!==z.label?z.filterText:void 0,[l.ISuggestDataDtoField.preselect]:z.preselect||void 0,[l.ISuggestDataDtoField.insertTextRules]:z.keepWhitespace?n.CompletionItemInsertTextRule.KeepWhitespace:n.CompletionItemInsertTextRule.None,[l.ISuggestDataDtoField.commitCharacters]:z.commitCharacters?.join(""),[l.ISuggestDataDtoField.additionalTextEdits]:z.additionalTextEdits&&z.additionalTextEdits.map(i.TextEdit.from),[l.ISuggestDataDtoField.commandIdent]:fe?.$ident,[l.ISuggestDataDtoField.commandId]:fe?.id,[l.ISuggestDataDtoField.commandArguments]:fe?.$ident?void 0:fe?.arguments};z.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),Ae[l.ISuggestDataDtoField.insertText]=z.textEdit.newText):typeof z.insertText=="string"?Ae[l.ISuggestDataDtoField.insertText]=z.insertText:z.insertText instanceof r.$EN&&(Ae[l.ISuggestDataDtoField.insertText]=z.insertText.value,Ae[l.ISuggestDataDtoField.insertTextRules]|=n.CompletionItemInsertTextRule.InsertAsSnippet);let je;return z.textEdit?je=z.textEdit.range:z.range&&(je=z.range),r.$vN.isRange(je)?Ae[l.ISuggestDataDtoField.range]=i.Range.from(je):je&&(!K?.isEqual(je.inserting)||!Q?.isEqual(je.replacing))&&(Ae[l.ISuggestDataDtoField.range]={insert:i.Range.from(je.inserting),replace:i.Range.from(je.replacing)}),Ae}}class Ue{async provideInlineCompletions(z,U,K,Q){}disposeCompletions(z){}handleDidShowCompletionItem(z,U,K){}handlePartialAccept(z,U,K,Q){}}class Z extends Ue{constructor(z,U,K,Q){super(),this.f=z,this.g=U,this.h=K,this.j=Q,this.d=new _,this.e=(0,t.$3G)(this.f,"inlineCompletionsAdditions"),this.k={[n.InlineCompletionTriggerKind.Automatic]:r.InlineCompletionTriggerKind.Automatic,[n.InlineCompletionTriggerKind.Explicit]:r.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,t.$3G)(this.f,"inlineCompletionsAdditions")&&(typeof this.h.handleDidShowCompletionItem=="function"||typeof this.h.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(z,U,K,Q){const ne=this.g.getDocument(z),fe=i.Position.to(U),Ae=await this.h.provideInlineCompletionItems(ne,fe,{selectedCompletionInfo:K.selectedSuggestionInfo?{range:i.Range.to(K.selectedSuggestionInfo.range),text:K.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[K.triggerKind]},Q);if(!Ae||Q.isCancellationRequested)return;const je=Array.isArray(Ae)?Ae:Ae.items,Ke=this.e?Array.isArray(Ae)?[]:Ae.commands||[]:[],_e=this.e&&!Array.isArray(Ae)?Ae.enableForwardStability:void 0;let it;return{pid:this.d.createReferenceId({dispose(){it?.dispose()},items:je}),items:je.map((tt,rt)=>{let $t;tt.command&&(it||(it=new T.$Vc),$t=this.j.toInternal(tt.command,it));const lt=tt.insertText;return{insertText:typeof lt=="string"?lt:{snippet:lt.value},filterText:tt.filterText,range:tt.range?i.Range.from(tt.range):void 0,command:$t,idx:rt,completeBracketPairs:this.e?tt.completeBracketPairs:!1}}),commands:Ke.map(tt=>(it||(it=new T.$Vc),this.j.toInternal(tt,it))),suppressSuggestions:!1,enableForwardStability:_e}}disposeCompletions(z){this.d.disposeReferenceId(z)?.dispose()}handleDidShowCompletionItem(z,U,K){const Q=this.d.get(z)?.items[U];Q&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(Q,K)}handlePartialAccept(z,U,K,Q){const ne=this.d.get(z)?.items[U];ne&&this.h.handleDidPartiallyAcceptCompletionItem&&this.e&&(this.h.handleDidPartiallyAcceptCompletionItem(ne,K),this.h.handleDidPartiallyAcceptCompletionItem(ne,i.PartialAcceptInfo.to(Q)))}}class V{async provideInlineEdits(z,U,K){const Q=this.f.getDocument(z),ne=await this.g.provideInlineEdit(Q,{triggerKind:this.e[U.triggerKind]},K);if(!ne||K.isCancellationRequested)return;let fe;const Ae=this.d.createReferenceId({dispose(){fe?.dispose()},item:ne});let je;ne.accepted&&(fe||(fe=new T.$Vc),je=this.h.toInternal(ne.accepted,fe));let Ke;return ne.rejected&&(fe||(fe=new T.$Vc),Ke=this.h.toInternal(ne.rejected,fe)),{pid:Ae,text:ne.text,range:i.Range.from(ne.range),accepted:je,rejected:Ke}}disposeEdit(z){this.d.disposeReferenceId(z)?.dispose()}constructor(z,U,K,Q){this.f=U,this.g=K,this.h=Q,this.d=new _,this.e={[n.InlineEditTriggerKind.Automatic]:r.InlineEditTriggerKind.Automatic,[n.InlineEditTriggerKind.Invoke]:r.InlineEditTriggerKind.Invoke}}}class _{constructor(){this.d=new Map,this.e=1}createReferenceId(z){const U=this.e++;return this.d.set(U,z),U}disposeReferenceId(z){const U=this.d.get(z);return this.d.delete(z),U}get(z){return this.d.get(z)}}class ye{constructor(z,U){this.e=z,this.f=U,this.d=new c.$Rnc("SignatureHelp")}async provideSignatureHelp(z,U,K,Q){const ne=this.e.getDocument(z),fe=i.Position.to(U),Ae=this.g(K),je=await this.f.provideSignatureHelp(ne,fe,Q,Ae);if(je){const Ke=this.d.add([je]);return{...i.SignatureHelp.from(je),id:Ke}}}g(z){let U;if(z.activeSignatureHelp){const K=i.SignatureHelp.to(z.activeSignatureHelp),Q=this.d.get(z.activeSignatureHelp.id,0);Q?(U=Q,U.activeSignature=K.activeSignature,U.activeParameter=K.activeParameter):U=K}return{...z,activeSignatureHelp:U}}releaseSignatureHelp(z){this.d.delete(z)}}class ae{constructor(z,U,K,Q,ne){this.f=z,this.g=U,this.h=K,this.j=Q,this.k=ne,this.d=new c.$Rnc("InlayHints"),this.e=new Map}async provideInlayHints(z,U,K){const Q=this.f.getDocument(z),ne=i.Range.to(U),fe=await this.h.provideInlayHints(Q,ne,K);if(!Array.isArray(fe)||fe.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(U)}`);return}if(K.isCancellationRequested)return;const Ae=this.d.add(fe);this.e.set(Ae,new T.$Vc);const je={hints:[],cacheId:Ae};for(let Ke=0;Ke<fe.length;Ke++)this.l(fe[Ke],ne)&&je.hints.push(this.m(fe[Ke],[Ae,Ke]));return this.j.trace(`[InlayHints] ${je.hints.length} inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(U)}`),je}async resolveInlayHint(z,U){if(typeof this.h.resolveInlayHint!="function")return;const K=this.d.get(...z);if(!K)return;const Q=await this.h.resolveInlayHint(K,U);if(Q&&this.l(Q))return this.m(Q,z)}releaseHints(z){this.e.get(z)?.dispose(),this.e.delete(z),this.d.delete(z)}l(z,U){return z.label.length===0||Array.isArray(z.label)&&z.label.every(K=>K.value.length===0)?(console.log("INVALID inlay hint, empty label",z),!1):!(U&&!U.contains(z.position))}m(z,U){const K=this.e.get(U[0]);if(!K)throw Error("DisposableStore is missing...");const Q={label:"",cacheId:U,tooltip:i.MarkdownString.fromStrict(z.tooltip),position:i.Position.from(z.position),textEdits:z.textEdits&&z.textEdits.map(i.TextEdit.from),kind:z.kind&&i.InlayHintKind.from(z.kind),paddingLeft:z.paddingLeft,paddingRight:z.paddingRight};if(typeof z.label=="string")Q.label=z.label;else{const ne=[];Q.label=ne;for(const fe of z.label){if(!fe.value){console.warn("INVALID inlay hint, empty label part",this.k.identifier.value);continue}const Ae={label:fe.value,tooltip:i.MarkdownString.fromStrict(fe.tooltip)};r.$FN.isLocation(fe.location)&&(Ae.location=i.location.from(fe.location)),fe.command&&(Ae.command=this.g.toInternal(fe.command,K)),ne.push(Ae)}}return Q}}class we{constructor(z,U){this.e=z,this.f=U,this.d=new c.$Rnc("DocumentLink")}async provideLinks(z,U){const K=this.e.getDocument(z),Q=await this.f.provideDocumentLinks(K,U);if(!(!Array.isArray(Q)||Q.length===0)&&!U.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:Q.filter(we.g).map(i.DocumentLink.from)};{const ne=this.d.add(Q),fe={links:[],cacheId:ne};for(let Ae=0;Ae<Q.length;Ae++){if(!we.g(Q[Ae]))continue;const je=i.DocumentLink.from(Q[Ae]);je.cacheId=[ne,Ae],fe.links.push(je)}return fe}}}static g(z){return z.target&&z.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(z,U){if(typeof this.f.resolveDocumentLink!="function")return;const K=this.d.get(...z);if(!K)return;const Q=await this.f.resolveDocumentLink(K,U);if(!(!Q||!we.g(Q)))return i.DocumentLink.from(Q)}releaseLinks(z){this.d.delete(z)}}class he{constructor(z,U){this.d=z,this.e=U}async provideColors(z,U){const K=this.d.getDocument(z),Q=await this.e.provideDocumentColors(K,U);return Array.isArray(Q)?Q.map(fe=>({color:i.Color.from(fe.color),range:i.Range.from(fe.range)})):[]}async provideColorPresentations(z,U,K){const Q=this.d.getDocument(z),ne=i.Range.to(U.range),fe=i.Color.to(U.color),Ae=await this.e.provideColorPresentations(fe,{document:Q,range:ne},K);if(Array.isArray(Ae))return Ae.map(i.ColorPresentation.from)}}class X{constructor(z,U){this.d=z,this.e=U}async provideFoldingRanges(z,U,K){const Q=this.d.getDocument(z),ne=await this.e.provideFoldingRanges(Q,U,K);if(Array.isArray(ne))return ne.map(i.FoldingRange.from)}}class Y{constructor(z,U,K){this.d=z,this.e=U,this.f=K}async provideSelectionRanges(z,U,K){const Q=this.d.getDocument(z),ne=U.map(i.Position.to),fe=await this.e.provideSelectionRanges(Q,ne,K);if(!(0,w.$Nb)(fe))return[];if(fe.length!==ne.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const Ae=[];for(let je=0;je<ne.length;je++){const Ke=[];Ae.push(Ke);let _e=ne[je],it=fe[je];for(;;){if(!it.range.contains(_e))throw new Error("INVALID selection range, must contain the previous range");if(Ke.push(i.SelectionRange.from(it)),!it.parent)break;_e=it.range,it=it.parent}}return Ae}}class pe{constructor(z,U){this.f=z,this.g=U,this.d=new A.$3P(""),this.e=new Map}async prepareSession(z,U,K){const Q=this.f.getDocument(z),ne=i.Position.to(U),fe=await this.g.prepareCallHierarchy(Q,ne,K);if(!fe)return;const Ae=this.d.nextId();return this.e.set(Ae,new Map),Array.isArray(fe)?fe.map(je=>this.h(Ae,je)):[this.h(Ae,fe)]}async provideCallsTo(z,U,K){const Q=this.j(z,U);if(!Q)throw new Error("missing call hierarchy item");const ne=await this.g.provideCallHierarchyIncomingCalls(Q,K);if(ne)return ne.map(fe=>({from:this.h(z,fe.from),fromRanges:fe.fromRanges.map(Ae=>i.Range.from(Ae))}))}async provideCallsFrom(z,U,K){const Q=this.j(z,U);if(!Q)throw new Error("missing call hierarchy item");const ne=await this.g.provideCallHierarchyOutgoingCalls(Q,K);if(ne)return ne.map(fe=>({to:this.h(z,fe.to),fromRanges:fe.fromRanges.map(Ae=>i.Range.from(Ae))}))}releaseSession(z){this.e.delete(z)}h(z,U){const K=this.e.get(z),Q=i.CallHierarchyItem.from(U,z,K.size.toString(36));return K.set(Q._itemId,U),Q}j(z,U){return this.e.get(z)?.get(U)}}class $e{constructor(z,U){this.f=z,this.g=U,this.d=new A.$3P(""),this.e=new Map}async prepareSession(z,U,K){const Q=this.f.getDocument(z),ne=i.Position.to(U),fe=await this.g.prepareTypeHierarchy(Q,ne,K);if(!fe)return;const Ae=this.d.nextId();return this.e.set(Ae,new Map),Array.isArray(fe)?fe.map(je=>this.h(Ae,je)):[this.h(Ae,fe)]}async provideSupertypes(z,U,K){const Q=this.j(z,U);if(!Q)throw new Error("missing type hierarchy item");const ne=await this.g.provideTypeHierarchySupertypes(Q,K);if(ne)return ne.map(fe=>this.h(z,fe))}async provideSubtypes(z,U,K){const Q=this.j(z,U);if(!Q)throw new Error("missing type hierarchy item");const ne=await this.g.provideTypeHierarchySubtypes(Q,K);if(ne)return ne.map(fe=>this.h(z,fe))}releaseSession(z){this.e.delete(z)}h(z,U){const K=this.e.get(z),Q=i.TypeHierarchyItem.from(U,z,K.size.toString(36));return K.set(Q._itemId,U),Q}j(z,U){return this.e.get(z)?.get(U)}}class Te{constructor(z,U,K,Q,ne){this.e=z,this.f=U,this.g=K,this.h=Q,this.j=ne,this.d=new c.$Rnc("DocumentDropEdit")}async provideDocumentOnDropEdits(z,U,K,Q,ne){const fe=this.f.getDocument(U),Ae=i.Position.to(K),je=i.DataTransfer.toDataTransfer(Q,async nt=>(await this.e.$resolveDocumentOnDropFileData(this.h,z,nt)).buffer),Ke=await this.g.provideDocumentDropEdits(fe,Ae,je,ne);if(!Ke)return;const _e=(0,w.$4b)(Ke),it=this.d.add(_e);return _e.map((nt,tt)=>({_cacheId:[it,tt],title:nt.title??(0,o.localize)(1,null,this.j.displayName||this.j.name),kind:nt.kind?.value,yieldTo:nt.yieldTo?.map(rt=>rt.value),insertText:typeof nt.insertText=="string"?nt.insertText:{snippet:nt.insertText.value},additionalEdit:nt.additionalEdit?i.WorkspaceEdit.from(nt.additionalEdit,void 0):void 0}))}async resolveDropEdit(z,U){const[K,Q]=z,ne=this.d.get(K,Q);if(!ne||!this.g.resolveDocumentDropEdit)return{};const fe=await this.g.resolveDocumentDropEdit(ne,U)??ne;return{additionalEdit:fe.additionalEdit?i.WorkspaceEdit.from(fe.additionalEdit,void 0):void 0}}releaseDropEdits(z){this.d.delete(z)}}class ze{constructor(z,U){this.d=z,this.e=U}async provideMappedEdits(z,U,K,Q){const ne=u.URI.revive(z),fe=this.d.getDocument(ne),Ae=K.documents.map(_e=>_e.map(it=>({uri:u.URI.revive(it.uri),version:it.version,ranges:it.ranges.map(nt=>i.Range.to(nt))}))),je={documents:Ae,selections:Ae[0]?.[0]?.ranges??[]},Ke=await this.e.provideMappedEdits(fe,U,je,Q);return Ke?i.WorkspaceEdit.from(Ke):null}}class Se{constructor(z,U){this.adapter=z,this.extension=U}}class Re{static{this.d=0}constructor(z,U,K,Q,ne,fe,Ae,je){this.g=U,this.h=K,this.j=Q,this.k=ne,this.l=fe,this.m=Ae,this.n=je,this.f=new Map,this.e=z.getProxy(l.$rN.MainThreadLanguageFeatures)}o(z,U){return i.DocumentSelector.from(z,this.g,U)}p(z){return new r.$tN(()=>{this.f.delete(z),this.e.$unregister(z)})}q(){return Re.d++}async s(z,U,K,Q,ne,fe=!1){const Ae=this.f.get(z);if(!Ae||!(Ae.adapter instanceof U))return Q;const je=Date.now();fe||this.l.trace(`[${Ae.extension.identifier.value}] INVOKE provider '${K.toString().replace(/[\r\n]/g,"")}'`);const Ke=K(Ae.adapter,Ae.extension);return Promise.resolve(Ke).catch(_e=>{(0,O.$6)(_e)||(this.l.error(`[${Ae.extension.identifier.value}] provider FAILED`),this.l.error(_e),this.n.onExtensionError(Ae.extension.identifier,_e))}).finally(()=>{fe||this.l.trace(`[${Ae.extension.identifier.value}] provider DONE after ${Date.now()-je}ms`)}),k.CancellationToken.isCancellationToken(ne)?(0,S.$uh)(Ke,ne):Ke}t(z,U){const K=this.q();return this.f.set(K,new Se(z,U)),K}static u(z){return z.displayName||z.name}static w(z){return z.identifier.value}registerDocumentSymbolProvider(z,U,K,Q){const ne=this.t(new m(this.h,K),z),fe=Q&&Q.label||Re.u(z);return this.e.$registerDocumentSymbolProvider(ne,this.o(U,z),fe),this.p(ne)}$provideDocumentSymbols(z,U,K){return this.s(z,m,Q=>Q.provideDocumentSymbols(u.URI.revive(U),K),void 0,K)}registerCodeLensProvider(z,U,K){const Q=this.q(),ne=typeof K.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(Q,new Se(new f(this.h,this.j.converter,K,z,this.n,this.l),z)),this.e.$registerCodeLensSupport(Q,this.o(U,z),ne);let fe=this.p(Q);if(ne!==void 0){const Ae=K.onDidChangeCodeLenses(je=>this.e.$emitCodeLensEvent(ne));fe=r.$tN.from(fe,Ae)}return fe}$provideCodeLenses(z,U,K){return this.s(z,f,Q=>Q.provideCodeLenses(u.URI.revive(U),K),void 0,K)}$resolveCodeLens(z,U,K){return this.s(z,f,Q=>Q.resolveCodeLens(U,K),void 0,void 0)}$releaseCodeLenses(z,U){this.s(z,f,K=>Promise.resolve(K.releaseCodeLenses(U)),void 0,void 0)}registerDefinitionProvider(z,U,K){const Q=this.t(new I(this.h,K),z);return this.e.$registerDefinitionSupport(Q,this.o(U,z)),this.p(Q)}$provideDefinition(z,U,K,Q){return this.s(z,I,ne=>ne.provideDefinition(u.URI.revive(U),K,Q),[],Q)}registerDeclarationProvider(z,U,K){const Q=this.t(new D(this.h,K),z);return this.e.$registerDeclarationSupport(Q,this.o(U,z)),this.p(Q)}$provideDeclaration(z,U,K,Q){return this.s(z,D,ne=>ne.provideDeclaration(u.URI.revive(U),K,Q),[],Q)}registerImplementationProvider(z,U,K){const Q=this.t(new v(this.h,K),z);return this.e.$registerImplementationSupport(Q,this.o(U,z)),this.p(Q)}$provideImplementation(z,U,K,Q){return this.s(z,v,ne=>ne.provideImplementation(u.URI.revive(U),K,Q),[],Q)}registerTypeDefinitionProvider(z,U,K){const Q=this.t(new C(this.h,K),z);return this.e.$registerTypeDefinitionSupport(Q,this.o(U,z)),this.p(Q)}$provideTypeDefinition(z,U,K,Q){return this.s(z,C,ne=>ne.provideTypeDefinition(u.URI.revive(U),K,Q),[],Q)}registerHoverProvider(z,U,K,Q){const ne=this.t(new P(this.h,K),z);return this.e.$registerHoverProvider(ne,this.o(U,z)),this.p(ne)}$provideHover(z,U,K,Q,ne){return this.s(z,P,fe=>fe.provideHover(u.URI.revive(U),K,Q,ne),void 0,ne)}$releaseHover(z,U){this.s(z,P,K=>Promise.resolve(K.releaseHover(U)),void 0,void 0)}registerEvaluatableExpressionProvider(z,U,K,Q){const ne=this.t(new g(this.h,K),z);return this.e.$registerEvaluatableExpressionProvider(ne,this.o(U,z)),this.p(ne)}$provideEvaluatableExpression(z,U,K,Q){return this.s(z,g,ne=>ne.provideEvaluatableExpression(u.URI.revive(U),K,Q),void 0,Q)}registerInlineValuesProvider(z,U,K,Q){const ne=typeof K.onDidChangeInlineValues=="function"?this.q():void 0,fe=this.t(new b(this.h,K),z);this.e.$registerInlineValuesProvider(fe,this.o(U,z),ne);let Ae=this.p(fe);if(ne!==void 0){const je=K.onDidChangeInlineValues(Ke=>this.e.$emitInlineValuesEvent(ne));Ae=r.$tN.from(Ae,je)}return Ae}$provideInlineValues(z,U,K,Q,ne){return this.s(z,b,fe=>fe.provideInlineValues(u.URI.revive(U),K,Q,ne),void 0,ne)}registerDocumentHighlightProvider(z,U,K){const Q=this.t(new L(this.h,K),z);return this.e.$registerDocumentHighlightProvider(Q,this.o(U,z)),this.p(Q)}registerMultiDocumentHighlightProvider(z,U,K){const Q=this.t(new N(this.h,K),z);return this.e.$registerMultiDocumentHighlightProvider(Q,this.o(U,z)),this.p(Q)}$provideDocumentHighlights(z,U,K,Q){return this.s(z,L,ne=>ne.provideDocumentHighlights(u.URI.revive(U),K,Q),void 0,Q)}$provideMultiDocumentHighlights(z,U,K,Q,ne){return this.s(z,N,fe=>fe.provideMultiDocumentHighlights(u.URI.revive(U),K,Q.map(Ae=>u.URI.revive(Ae)),ne),void 0,ne)}registerLinkedEditingRangeProvider(z,U,K){const Q=this.t(new B(this.h,K),z);return this.e.$registerLinkedEditingRangeProvider(Q,this.o(U,z)),this.p(Q)}$provideLinkedEditingRanges(z,U,K,Q){return this.s(z,B,async ne=>{const fe=await ne.provideLinkedEditingRanges(u.URI.revive(U),K,Q);if(fe)return{ranges:fe.ranges,wordPattern:fe.wordPattern?Re.y(fe.wordPattern):void 0}},void 0,Q)}registerReferenceProvider(z,U,K){const Q=this.t(new G(this.h,K),z);return this.e.$registerReferenceSupport(Q,this.o(U,z)),this.p(Q)}$provideReferences(z,U,K,Q,ne){return this.s(z,G,fe=>fe.provideReferences(u.URI.revive(U),K,Q,ne),void 0,ne)}registerCodeActionProvider(z,U,K,Q){const ne=new T.$Vc,fe=this.t(new W(this.h,this.j.converter,this.k,K,this.l,z,this.m),z);return this.e.$registerCodeActionSupport(fe,this.o(U,z),{providedKinds:Q?.providedCodeActionKinds?.map(Ae=>Ae.value),documentation:Q?.documentation?.map(Ae=>({kind:Ae.kind.value,command:this.j.converter.toInternal(Ae.command,ne)}))},Re.u(z),Re.w(z),!!K.resolveCodeAction),ne.add(this.p(fe)),ne}$provideCodeActions(z,U,K,Q,ne){return this.s(z,W,fe=>fe.provideCodeActions(u.URI.revive(U),K,Q,ne),void 0,ne)}$resolveCodeAction(z,U,K){return this.s(z,W,Q=>Q.resolveCodeAction(U,K),{},void 0)}$releaseCodeActions(z,U){this.s(z,W,K=>Promise.resolve(K.releaseCodeActions(U)),void 0,void 0)}registerDocumentFormattingEditProvider(z,U,K){const Q=this.t(new q(this.h,K),z);return this.e.$registerDocumentFormattingSupport(Q,this.o(U,z),z.identifier,z.displayName||z.name),this.p(Q)}$provideDocumentFormattingEdits(z,U,K,Q){return this.s(z,q,ne=>ne.provideDocumentFormattingEdits(u.URI.revive(U),K,Q),void 0,Q)}registerDocumentRangeFormattingEditProvider(z,U,K){const Q=typeof K.provideDocumentRangesFormattingEdits=="function",ne=this.t(new ue(this.h,K),z);return this.e.$registerRangeFormattingSupport(ne,this.o(U,z),z.identifier,z.displayName||z.name,Q),this.p(ne)}$provideDocumentRangeFormattingEdits(z,U,K,Q,ne){return this.s(z,ue,fe=>fe.provideDocumentRangeFormattingEdits(u.URI.revive(U),K,Q,ne),void 0,ne)}$provideDocumentRangesFormattingEdits(z,U,K,Q,ne){return this.s(z,ue,fe=>fe.provideDocumentRangesFormattingEdits(u.URI.revive(U),K,Q,ne),void 0,ne)}registerOnTypeFormattingEditProvider(z,U,K,Q){const ne=this.t(new ge(this.h,K),z);return this.e.$registerOnTypeFormattingSupport(ne,this.o(U,z),Q,z.identifier),this.p(ne)}$provideOnTypeFormattingEdits(z,U,K,Q,ne,fe){return this.s(z,ge,Ae=>Ae.provideOnTypeFormattingEdits(u.URI.revive(U),K,Q,ne,fe),void 0,fe)}registerWorkspaceSymbolProvider(z,U){const K=this.t(new te(U,this.l),z);return this.e.$registerNavigateTypeSupport(K,typeof U.resolveWorkspaceSymbol=="function"),this.p(K)}$provideWorkspaceSymbols(z,U,K){return this.s(z,te,Q=>Q.provideWorkspaceSymbols(U,K),{symbols:[]},K)}$resolveWorkspaceSymbol(z,U,K){return this.s(z,te,Q=>Q.resolveWorkspaceSymbol(U,K),void 0,void 0)}$releaseWorkspaceSymbols(z,U){this.s(z,te,K=>K.releaseWorkspaceSymbols(U),void 0,void 0)}registerRenameProvider(z,U,K){const Q=this.t(new me(this.h,K,this.l),z);return this.e.$registerRenameSupport(Q,this.o(U,z),me.supportsResolving(K)),this.p(Q)}$provideRenameEdits(z,U,K,Q,ne){return this.s(z,me,fe=>fe.provideRenameEdits(u.URI.revive(U),K,Q,ne),void 0,ne)}$resolveRenameLocation(z,U,K,Q){return this.s(z,me,ne=>ne.resolveRenameLocation(u.URI.revive(U),K,Q),void 0,Q)}registerNewSymbolNamesProvider(z,U,K){const Q=this.t(new re(this.h,K,this.l),z);return this.e.$registerNewSymbolNamesProvider(Q,this.o(U,z)),this.p(Q)}$supportsAutomaticNewSymbolNamesTriggerKind(z){return this.s(z,re,U=>U.supportsAutomaticNewSymbolNamesTriggerKind(),!1,void 0)}$provideNewSymbolNames(z,U,K,Q,ne){return this.s(z,re,fe=>fe.provideNewSymbolNames(u.URI.revive(U),K,Q,ne),void 0,ne)}registerDocumentSemanticTokensProvider(z,U,K,Q){const ne=this.t(new be(this.h,K),z),fe=typeof K.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(ne,this.o(U,z),Q,fe);let Ae=this.p(ne);if(fe){const je=K.onDidChangeSemanticTokens(Ke=>this.e.$emitDocumentSemanticTokensEvent(fe));Ae=r.$tN.from(Ae,je)}return Ae}$provideDocumentSemanticTokens(z,U,K,Q){return this.s(z,be,ne=>ne.provideDocumentSemanticTokens(u.URI.revive(U),K,Q),null,Q)}$releaseDocumentSemanticTokens(z,U){this.s(z,be,K=>K.releaseDocumentSemanticColoring(U),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(z,U,K,Q){const ne=this.t(new se(this.h,K),z);return this.e.$registerDocumentRangeSemanticTokensProvider(ne,this.o(U,z),Q),this.p(ne)}$provideDocumentRangeSemanticTokens(z,U,K,Q){return this.s(z,se,ne=>ne.provideDocumentRangeSemanticTokens(u.URI.revive(U),K,Q),null,Q)}registerCompletionItemProvider(z,U,K,Q){const ne=this.t(new Ie(this.h,this.j.converter,K,this.m,z),z);return this.e.$registerCompletionsProvider(ne,this.o(U,z),Q,Ie.supportsResolving(K),z.identifier),this.p(ne)}$provideCompletionItems(z,U,K,Q,ne){return this.s(z,Ie,fe=>fe.provideCompletionItems(u.URI.revive(U),K,Q,ne),void 0,ne)}$resolveCompletionItem(z,U,K){return this.s(z,Ie,Q=>Q.resolveCompletionItem(U,K),void 0,K)}$releaseCompletionItems(z,U){this.s(z,Ie,K=>K.releaseCompletionItems(U),void 0,void 0)}registerInlineCompletionsProvider(z,U,K,Q){const ne=new Z(z,this.h,K,this.j.converter),fe=this.t(ne,z);return this.e.$registerInlineCompletionsSupport(fe,this.o(U,z),ne.supportsHandleEvents,h.$qn.toKey(z.identifier.value),Q?.yieldTo?.map(Ae=>h.$qn.toKey(Ae))||[]),this.p(fe)}$provideInlineCompletions(z,U,K,Q,ne){return this.s(z,Ue,fe=>fe.provideInlineCompletions(u.URI.revive(U),K,Q,ne),void 0,ne)}$handleInlineCompletionDidShow(z,U,K,Q){this.s(z,Ue,async ne=>{ne.handleDidShowCompletionItem(U,K,Q)},void 0,void 0)}$handleInlineCompletionPartialAccept(z,U,K,Q,ne){this.s(z,Ue,async fe=>{fe.handlePartialAccept(U,K,Q,ne)},void 0,void 0)}$freeInlineCompletionsList(z,U){this.s(z,Ue,async K=>{K.disposeCompletions(U)},void 0,void 0)}registerInlineEditProvider(z,U,K){const Q=new V(z,this.h,K,this.j.converter),ne=this.t(Q,z);return this.e.$registerInlineEditProvider(ne,this.o(U,z),z.identifier),this.p(ne)}$provideInlineEdit(z,U,K,Q){return this.s(z,V,ne=>ne.provideInlineEdits(u.URI.revive(U),K,Q),void 0,Q)}$freeInlineEdit(z,U){this.s(z,V,async K=>{K.disposeEdit(U)},void 0,void 0)}registerSignatureHelpProvider(z,U,K,Q){const ne=Array.isArray(Q)?{triggerCharacters:Q,retriggerCharacters:[]}:Q,fe=this.t(new ye(this.h,K),z);return this.e.$registerSignatureHelpProvider(fe,this.o(U,z),ne),this.p(fe)}$provideSignatureHelp(z,U,K,Q,ne){return this.s(z,ye,fe=>fe.provideSignatureHelp(u.URI.revive(U),K,Q,ne),void 0,ne)}$releaseSignatureHelp(z,U){this.s(z,ye,K=>K.releaseSignatureHelp(U),void 0,void 0)}registerInlayHintsProvider(z,U,K){const Q=typeof K.onDidChangeInlayHints=="function"?this.q():void 0,ne=this.t(new ae(this.h,this.j.converter,K,this.l,z),z);this.e.$registerInlayHintsProvider(ne,this.o(U,z),typeof K.resolveInlayHint=="function",Q,Re.u(z));let fe=this.p(ne);if(Q!==void 0){const Ae=K.onDidChangeInlayHints(je=>this.e.$emitInlayHintsEvent(Q));fe=r.$tN.from(fe,Ae)}return fe}$provideInlayHints(z,U,K,Q){return this.s(z,ae,ne=>ne.provideInlayHints(u.URI.revive(U),K,Q),void 0,Q)}$resolveInlayHint(z,U,K){return this.s(z,ae,Q=>Q.resolveInlayHint(U,K),void 0,K)}$releaseInlayHints(z,U){this.s(z,ae,K=>K.releaseHints(U),void 0,void 0)}registerDocumentLinkProvider(z,U,K){const Q=this.t(new we(this.h,K),z);return this.e.$registerDocumentLinkProvider(Q,this.o(U,z),typeof K.resolveDocumentLink=="function"),this.p(Q)}$provideDocumentLinks(z,U,K){return this.s(z,we,Q=>Q.provideLinks(u.URI.revive(U),K),void 0,K,U.scheme==="output")}$resolveDocumentLink(z,U,K){return this.s(z,we,Q=>Q.resolveLink(U,K),void 0,void 0,!0)}$releaseDocumentLinks(z,U){this.s(z,we,K=>K.releaseLinks(U),void 0,void 0,!0)}registerColorProvider(z,U,K){const Q=this.t(new he(this.h,K),z);return this.e.$registerDocumentColorProvider(Q,this.o(U,z)),this.p(Q)}$provideDocumentColors(z,U,K){return this.s(z,he,Q=>Q.provideColors(u.URI.revive(U),K),[],K)}$provideColorPresentations(z,U,K,Q){return this.s(z,he,ne=>ne.provideColorPresentations(u.URI.revive(U),K,Q),void 0,Q)}registerFoldingRangeProvider(z,U,K){const Q=this.q(),ne=typeof K.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(Q,new Se(new X(this.h,K),z)),this.e.$registerFoldingRangeProvider(Q,this.o(U,z),z.identifier,ne);let fe=this.p(Q);if(ne!==void 0){const Ae=K.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(ne));fe=r.$tN.from(fe,Ae)}return fe}$provideFoldingRanges(z,U,K,Q){return this.s(z,X,ne=>ne.provideFoldingRanges(u.URI.revive(U),K,Q),void 0,Q)}registerSelectionRangeProvider(z,U,K){const Q=this.t(new Y(this.h,K,this.l),z);return this.e.$registerSelectionRangeProvider(Q,this.o(U,z)),this.p(Q)}$provideSelectionRanges(z,U,K,Q){return this.s(z,Y,ne=>ne.provideSelectionRanges(u.URI.revive(U),K,Q),[],Q)}registerCallHierarchyProvider(z,U,K){const Q=this.t(new pe(this.h,K),z);return this.e.$registerCallHierarchyProvider(Q,this.o(U,z)),this.p(Q)}$prepareCallHierarchy(z,U,K,Q){return this.s(z,pe,ne=>Promise.resolve(ne.prepareSession(u.URI.revive(U),K,Q)),void 0,Q)}$provideCallHierarchyIncomingCalls(z,U,K,Q){return this.s(z,pe,ne=>ne.provideCallsTo(U,K,Q),void 0,Q)}$provideCallHierarchyOutgoingCalls(z,U,K,Q){return this.s(z,pe,ne=>ne.provideCallsFrom(U,K,Q),void 0,Q)}$releaseCallHierarchy(z,U){this.s(z,pe,K=>Promise.resolve(K.releaseSession(U)),void 0,void 0)}registerTypeHierarchyProvider(z,U,K){const Q=this.t(new $e(this.h,K),z);return this.e.$registerTypeHierarchyProvider(Q,this.o(U,z)),this.p(Q)}$prepareTypeHierarchy(z,U,K,Q){return this.s(z,$e,ne=>Promise.resolve(ne.prepareSession(u.URI.revive(U),K,Q)),void 0,Q)}$provideTypeHierarchySupertypes(z,U,K,Q){return this.s(z,$e,ne=>ne.provideSupertypes(U,K,Q),void 0,Q)}$provideTypeHierarchySubtypes(z,U,K,Q){return this.s(z,$e,ne=>ne.provideSubtypes(U,K,Q),void 0,Q)}$releaseTypeHierarchy(z,U){this.s(z,$e,K=>Promise.resolve(K.releaseSession(U)),void 0,void 0)}registerDocumentOnDropEditProvider(z,U,K,Q){const ne=this.q();return this.f.set(ne,new Se(new Te(this.e,this.h,K,ne,z),z)),this.e.$registerDocumentOnDropEditProvider(ne,this.o(U,z),(0,t.$3G)(z,"documentPaste")&&Q?{supportsResolve:!!K.resolveDocumentDropEdit,dropMimeTypes:Q.dropMimeTypes}:void 0),this.p(ne)}$provideDocumentOnDropEdits(z,U,K,Q,ne,fe){return this.s(z,Te,Ae=>Promise.resolve(Ae.provideDocumentOnDropEdits(U,u.URI.revive(K),Q,ne,fe)),void 0,void 0)}$resolveDropEdit(z,U,K){return this.s(z,Te,Q=>Q.resolveDropEdit(U,K),{},void 0)}$releaseDocumentOnDropEdits(z,U){this.s(z,Te,K=>Promise.resolve(K.releaseDropEdits(U)),void 0,void 0)}registerMappedEditsProvider(z,U,K){const Q=this.t(new ze(this.h,K),z);return this.e.$registerMappedEditsProvider(Q,this.o(U,z)),this.p(Q)}$provideMappedEdits(z,U,K,Q,ne){return this.s(z,ze,fe=>Promise.resolve(fe.provideMappedEdits(U,K,Q,ne)),null,ne)}registerDocumentPasteEditProvider(z,U,K,Q){const ne=this.q();return this.f.set(ne,new Se(new F(this.e,this.h,K,ne,z),z)),this.e.$registerPasteEditProvider(ne,this.o(U,z),{supportsCopy:!!K.prepareDocumentPaste,supportsPaste:!!K.provideDocumentPasteEdits,supportsResolve:!!K.resolveDocumentPasteEdit,providedPasteEditKinds:Q.providedPasteEditKinds?.map(fe=>fe.value),copyMimeTypes:Q.copyMimeTypes,pasteMimeTypes:Q.pasteMimeTypes}),this.p(ne)}$prepareDocumentPaste(z,U,K,Q,ne){return this.s(z,F,fe=>fe.prepareDocumentPaste(u.URI.revive(U),K,Q,ne),void 0,ne)}$providePasteEdits(z,U,K,Q,ne,fe,Ae){return this.s(z,F,je=>je.providePasteEdits(U,u.URI.revive(K),Q,ne,fe,Ae),void 0,Ae)}$resolvePasteEdit(z,U,K){return this.s(z,F,Q=>Q.resolvePasteEdit(U,K),{},void 0)}$releasePasteEdits(z,U){this.s(z,F,K=>Promise.resolve(K.releasePasteEdits(U)),void 0,void 0)}static y(z){return{pattern:z.source,flags:z.flags}}static z(z){return{decreaseIndentPattern:Re.y(z.decreaseIndentPattern),increaseIndentPattern:Re.y(z.increaseIndentPattern),indentNextLinePattern:z.indentNextLinePattern?Re.y(z.indentNextLinePattern):void 0,unIndentedLinePattern:z.unIndentedLinePattern?Re.y(z.unIndentedLinePattern):void 0}}static B(z){return{beforeText:Re.y(z.beforeText),afterText:z.afterText?Re.y(z.afterText):void 0,previousLineText:z.previousLineText?Re.y(z.previousLineText):void 0,action:z.action}}static C(z){return z.map(Re.B)}static D(z){return{open:z.open,close:z.close,notIn:z.notIn?z.notIn.map(U=>r.SyntaxTokenType.toString(U)):void 0}}static E(z){return z.map(Re.D)}setLanguageConfiguration(z,U,K){const{wordPattern:Q}=K;if(Q&&(0,R.$sf)(Q))throw new Error(`Invalid language configuration: wordPattern '${Q}' is not allowed to match the empty string.`);Q?this.h.setWordDefinitionFor(U,Q):this.h.setWordDefinitionFor(U,void 0),K.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",z,"Do not use."),K.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",z,"Do not use.");const ne=this.q(),fe={comments:K.comments,brackets:K.brackets,wordPattern:K.wordPattern?Re.y(K.wordPattern):void 0,indentationRules:K.indentationRules?Re.z(K.indentationRules):void 0,onEnterRules:K.onEnterRules?Re.C(K.onEnterRules):void 0,__electricCharacterSupport:K.__electricCharacterSupport,__characterPairSupport:K.__characterPairSupport,autoClosingPairs:K.autoClosingPairs?Re.E(K.autoClosingPairs):void 0};return this.e.$setLanguageConfiguration(ne,U,fe),this.p(ne)}$setWordDefinitions(z){for(const U of z)this.h.setWordDefinitionFor(U.languageId,new RegExp(U.regexSource,U.regexFlags))}}e.$2nc=Re}),define(ke[95],Ce([1,0,11,22,14,6,40,4,183,19,3,12,77,5,91,17,10,7,116,25]),function(oe,e,w,S,k,O,A,T,p,a,R,y,u,E,d,n,s,o,h,i){"use strict";var r;Object.defineProperty(e,"__esModule",{value:!0}),e.$Joc=e.$Ioc=void 0,s=qe(s),o=qe(o),e.$Ioc=(0,R.$Fi)("IExtHostLanguageModels");class t{constructor(f,$){this.option=f,this.stream=new w.$9h,this.stream=$??new w.$9h}}class c{constructor(){this.a=new Map,this.b=new w.$9h,this.c=!1,this.d=!1;const f=this;this.apiObject={stream:f.b.asyncIterable,text:w.$6h.map(f.b.asyncIterable,$=>{if($ instanceof o.$HP)return $.value}).coalesce()}}*f(){if(this.a.size>0)for(const[,f]of this.a)yield f.stream;else yield this.b}handleFragment(f){if(this.c)return;this.d=!0;let $=this.a.get(f.index);$||(this.a.size===0?$=new t(f.index,this.b):$=new t(f.index),this.a.set(f.index,$));let I;f.part.type==="text"?I=new o.$HP(f.part.value):I=new o.$GP(f.part.name,f.part.parameters),$.stream.emitOne(I)}get isStreaming(){return this.d}reject(f){this.c=!0;for(const $ of this.f())$.reject(f)}resolve(){this.c=!0;for(const f of this.f())f.resolve()}}let l=class{static{r=this}static{this.a=1}constructor(f,$,I){this.j=$,this.k=I,this.c=new O.$me,this.d=new O.$me,this.onDidChangeProviders=this.d.event,this.f=new Map,this.g=new Map,this.h=new a.$sn,this.i=new Map,this.r=new Set,this.b=f.getProxy(E.$rN.MainThreadLanguageModels)}dispose(){this.c.dispose(),this.d.dispose()}registerLanguageModel(f,$,I,D){const v=r.a++;this.f.set(v,{extension:f.identifier,provider:I,languageModelId:$});let C;D.auth&&(C={providerLabel:f.displayName||f.name,accountLabel:typeof D.auth=="object"?D.auth.label:void 0}),this.b.$registerLanguageModelProvider(v,`${a.$qn.toKey(f.identifier)}/${v}/${$}`,{extension:f.identifier,id:$,vendor:D.vendor??a.$qn.toKey(f.identifier),name:D.name??"",family:D.family??"",version:D.version,maxInputTokens:D.maxInputTokens,maxOutputTokens:D.maxOutputTokens,auth:C,targetExtensions:D.extensions});const P=I.onDidReceiveLanguageModelResponse2?.(({extensionId:g,participant:b,tokenCount:L})=>{this.b.$whenLanguageModelChatRequestMade($,new a.$qn(g),b,L)});return(0,T.$Uc)(()=>{this.f.delete(v),this.b.$unregisterProvider(v),P?.dispose()})}async $provideLanguageModelResponse(f,$,I,D,v,C){const P=this.f.get(f);if(!P)return;const g=new u.$rw(async b=>{if(C.isCancellationRequested){this.j.warn(`[CHAT](${P.extension.value}) CANNOT send progress because the REQUEST IS CANCELLED`);return}let L;if(b.part instanceof o.$GP?L={type:"function_use",name:b.part.name,parameters:b.part.parameters}:b.part instanceof o.$HP&&(L={type:"text",value:b.part.value}),!L){this.j.warn(`[CHAT](${P.extension.value}) UNKNOWN part ${JSON.stringify(b)}`);return}this.b.$handleProgressChunk($,{index:b.index,part:L})});if(P.provider.provideLanguageModelResponse2)return P.provider.provideLanguageModelResponse2(D.map(s.LanguageModelChatMessage.to),v,a.$qn.toKey(I),g,C);{const b=new u.$rw(async L=>{g.report({index:L.index,part:new o.$HP(L.part)})});return P.provider.provideLanguageModelResponse(D.map(s.LanguageModelChatMessage.to),v?.modelOptions??{},a.$qn.toKey(I),b,C)}}$provideTokenLength(f,$,I){const D=this.f.get(f);return D?Promise.resolve(D.provider.provideTokenCount($,I)):Promise.resolve(0)}$acceptChatModelMetadata(f){if(f.added)for(const{identifier:$,metadata:I}of f.added)this.g.set($,{metadata:I,apiObjects:new a.$sn});if(f.removed)for(const $ of f.removed){this.g.delete($);for(const[I,D]of this.i)D.languageModelId===$&&(D.res.reject(new k.$7),this.i.delete(I))}f.added?.forEach($=>this.p($.metadata)),this.d.fire(void 0)}async selectLanguageModels(f,$){const I=await this.b.$selectChatModels({...$,extension:f.identifier}),D=[],v=this;for(const C of I){const P=this.g.get(C);if(!P)continue;this.o(f.identifier,P.metadata)&&await this.p(P.metadata);let g=P.apiObjects.get(f.identifier);g||(g={id:C,vendor:P.metadata.vendor,family:P.metadata.family,version:P.metadata.version,name:P.metadata.name,maxInputTokens:P.metadata.maxInputTokens,countTokens(b,L){if(!v.g.has(C))throw o.$LP.NotFound(C);return v.q(C,b,L??S.CancellationToken.None)},sendRequest(b,L,N){if(!v.g.has(C))throw o.$LP.NotFound(C);return v.l(f,C,b,L??{},N??S.CancellationToken.None)}},Object.freeze(g),P.apiObjects.set(f.identifier,g)),D.push(g)}return D}async l(f,$,I,D,v){const C=this.m(f,I),P=f.identifier,g=this.g.get($)?.metadata;if(!g||!this.g.has($))throw o.$LP.NotFound(`Language model '${$}' is unknown.`);if(this.o(P,g)&&(!await this.n(f,{identifier:g.extension,displayName:g.auth.providerLabel},D.justification,!1)||!this.h.get(P)?.has(g.extension)))throw o.$LP.NoPermissions(`Language model '${$}' cannot be used by '${P.value}'.`);const b=Math.random()*1e6|0,L=this.b.$fetchResponse(P,$,b,C,D,v),N=new w.$Eh,B=new c;this.i.set(b,{languageModelId:$,res:B});let G;if(L.catch(W=>{N.isOpen()?B.reject(W):G=W}).finally(()=>{this.i.delete(b),B.resolve(),N.open()}),await N.wait(),G)throw G.name===o.$LP.name?G:new o.$LP(`Language model '${$}' errored, check cause for more details`,"Unknown",G);return B.apiObject}m(f,$){const I=[];for(const D of $)D.role===o.LanguageModelChatMessageRole.System&&(0,i.$4G)(f,"languageModelSystem"),D.content2 instanceof o.$EP&&(0,i.$4G)(f,"lmTools"),I.push(s.LanguageModelChatMessage.from(D));return I}async $handleResponseFragment(f,$){const I=this.i.get(f);I&&I.res.handleFragment($)}async n(f,$,I,D){const v=h.$tM+$.identifier.value;if(await this.k.getSession(f,v,[],{silent:!0}))return this.$updateModelAccesslist([{from:f.identifier,to:$.identifier,enabled:!0}]),!0;if(D)return!1;try{const P=I?(0,p.localize)(0,null,$.displayName,I):void 0;return await this.k.getSession(f,v,[],{forceNewSession:{detail:P}}),this.$updateModelAccesslist([{from:f.identifier,to:$.identifier,enabled:!0}]),!0}catch{return!1}}o(f,$){return!!$.auth&&!a.$qn.equals($.extension,f)}async p(f){if(f.auth)for(const $ of this.r)try{await this.n($,{identifier:f.extension,displayName:""},void 0,!0)}catch(I){this.j.error("Fake Auth request failed"),this.j.error(I)}}async q(f,$,I){if(!this.g.get(f))throw o.$LP.NotFound(`Language model '${f}' is unknown.`);const v=A.Iterable.find(this.f.values(),C=>C.languageModelId===f);return v?v.provider.provideTokenCount($,I):this.b.$countTokens(f,typeof $=="string"?$:s.LanguageModelChatMessage.from($),I)}$updateModelAccesslist(f){const $=new Array;for(const{from:I,to:D,enabled:v}of f){const C=this.h.get(I)??new a.$rn;if(C.has(D)!==v){v?C.add(D):C.delete(D),this.h.set(I,C);const g={from:I,to:D};$.push(g),this.c.fire(g)}}}createLanguageModelAccessInformation(f){this.r.add(f);const $=this,I=O.Event.signal(O.Event.filter(this.c.event,v=>a.$qn.equals(v.from,f.identifier))),D=O.Event.signal(this.d.event);return{get onDidChange(){return O.Event.any(I,D)},canSendRequest(v){let C;e:for(const[g,b]of $.g)for(const L of b.apiObjects.values())if(L===v){C=b.metadata;break e}if(!C)return;if(!$.o(f.identifier,C))return!0;const P=$.h.get(f.identifier);if(P)return P.has(C.extension)}}}};e.$Joc=l,e.$Joc=l=r=He([Ve(0,n.$XP),Ve(1,y.$_j),Ve(2,d.$4nc)],l)});var ti=this&&this.__importDefault||function(oe){return oe&&oe.__esModule?oe:{default:oe}};define(ke[287],Ce([1,0,5,10,7,36,11,4,25]),function(oe,e,w,S,k,O,A,T,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tpc=void 0,S=qe(S),O=ti(O);class a{constructor(y,u,E,d){this.c=u,this.d=E,this.e=d,this.b=[],this.f=0,this.g=new Set,this.a=y.getProxy(w.$rN.MainThreadLanguages)}$acceptLanguageIds(y){this.b=y}async getLanguages(){return this.b.slice(0)}async changeLanguage(y,u){await this.a.$changeLanguage(y,u);const E=this.c.getDocumentData(y);if(!E)throw new Error(`document '${y.toString()}' NOT found`);return E.document}async tokenAtPosition(y,u){const E=y.version,d=S.Position.from(u),n=await this.a.$tokensAtPosition(y.uri,d),s={type:k.StandardTokenType.Other,range:y.getWordRangeAtPosition(u)??new k.$vN(u.line,u.character,u.line,u.character)};if(!n)return s;const o={range:S.Range.to(n.range),type:S.TokenType.to(n.type)};return!o.range.contains(u)||E!==y.version?s:o}createLanguageStatusItem(y,u,E){const d=this.f++,n=this.a,s=this.g,o=`${y.identifier.value}/${u}`;if(s.has(o))throw new Error(`LanguageStatusItem with id '${u}' ALREADY exists`);s.add(o);const h={selector:E,id:u,name:y.displayName??y.name,severity:k.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let i;const r=new T.$Vc,t=()=>{if(i?.dispose(),!s.has(o)){console.warn(`LanguageStatusItem (${u}) from ${y.identifier.value} has been disposed and CANNOT be updated anymore`);return}i=(0,A.$Hh)(()=>{r.clear(),this.a.$setLanguageStatus(d,{id:o,name:h.name??y.displayName??y.name,source:y.displayName??y.name,selector:S.DocumentSelector.from(h.selector,this.e),label:h.text,detail:h.detail??"",severity:h.severity===k.LanguageStatusSeverity.Error?O.default.Error:h.severity===k.LanguageStatusSeverity.Warning?O.default.Warning:O.default.Info,command:h.command&&this.d.toInternal(h.command,r),accessibilityInfo:h.accessibilityInformation,busy:h.busy})},0)},c={dispose(){r.dispose(),i?.dispose(),n.$removeLanguageStatus(d),s.delete(o)},get id(){return h.id},get name(){return h.name},set name(l){h.name=l,t()},get selector(){return h.selector},set selector(l){h.selector=l,t()},get text(){return h.text},set text(l){h.text=l,t()},set text2(l){(0,p.$4G)(y,"languageStatusText"),h.text=l,t()},get text2(){return(0,p.$4G)(y,"languageStatusText"),h.text},get detail(){return h.detail},set detail(l){h.detail=l,t()},get severity(){return h.severity},set severity(l){h.severity=l,t()},get accessibilityInformation(){return h.accessibilityInformation},set accessibilityInformation(l){h.accessibilityInformation=l,t()},get command(){return h.command},set command(l){h.command=l,t()},get busy(){return h.busy},set busy(l){h.busy=l,t()}};return t(),c}}e.$tpc=a}),define(ke[288],Ce([1,0,16,2,10,7,90]),function(oe,e,w,S,k,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gpc=e.$fpc=void 0,k=qe(k),A=qe(A);class T{constructor(y,u,E,d){this.start=y,this.deletedCount=u,this.deletedItems=E,this.items=d}asApiEvent(){return{range:new O.$VO(this.start,this.start+this.deletedCount),addedCells:this.items.map(y=>y.apiCell),removedCells:this.deletedItems}}}class p{static asModelAddData(y){return{EOL:y.eol,lines:y.source,languageId:y.language,uri:y.uri,isDirty:!1,versionId:1}}constructor(y,u,E){this.notebook=y,this.h=u,this.j=E,this.handle=E.handle,this.uri=S.URI.revive(E.uri),this.cellKind=E.cellKind,this.a=E.outputs.map(k.NotebookCellOutput.to),this.e=E.internalMetadata??{},this.b=Object.freeze(E.metadata??{}),this.d=Object.freeze(k.NotebookCellExecutionSummary.to(E.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const y=this,u=this.h.getDocument(this.uri);if(!u)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const E={get index(){return y.notebook.getCellIndex(y)},notebook:y.notebook.apiNotebook,kind:k.NotebookCellKind.to(this.j.cellKind),document:u.document,get mime(){return y.g},set mime(d){y.g=d},get outputs(){return y.a.slice(0)},get metadata(){return y.b},get executionSummary(){return y.d}};this.f=Object.freeze(E)}return this.f}setOutputs(y){this.a=y.map(k.NotebookCellOutput.to)}setOutputItems(y,u,E){const d=E.map(k.NotebookCellOutputItem.to),n=this.a.find(s=>s.id===y);if(n&&(u||(n.items.length=0),n.items.push(...d),n.items.length>1&&n.items.every(s=>A.$wL(s.mime)))){const s=new Map,o=[];n.items.forEach(h=>{let i;s.has(h.mime)?i=s.get(h.mime):(i=[],s.set(h.mime,i),o.push(h.mime)),i.push(h.data)}),n.items.length=0,o.forEach(h=>{const i=A.$xL(s.get(h));n.items.push({mime:h,data:i.data.buffer})})}}setMetadata(y){this.b=Object.freeze(y)}setInternalMetadata(y){this.e=y,this.d=Object.freeze(k.NotebookCellExecutionSummary.to(y))}setMime(y){}}e.$fpc=p;class a{static{this.a=0}constructor(y,u,E,d,n){this.k=y,this.l=u,this.m=E,this.uri=d,this.handle=a.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=n.viewType,this.f=Object.freeze(n.metadata??Object.create(null)),this.r([[0,0,n.cells]],!0,void 0),this.g=n.versionId}dispose(){this.j=!0}get versionId(){return this.g}get apiNotebook(){if(!this.e){const y=this,u={get uri(){return y.uri},get version(){return y.g},get notebookType(){return y.d},get isDirty(){return y.h},get isUntitled(){return y.uri.scheme===w.Schemas.untitled},get isClosed(){return y.j},get metadata(){return y.f},get cellCount(){return y.b.length},cellAt(E){return E=y.n(E),y.b[E].apiCell},getCells(E){return(E?y.p(E):y.b).map(n=>n.apiCell)},save(){return y.q()}};this.e=Object.freeze(u)}return this.e}acceptDocumentPropertiesChanged(y){y.metadata&&(this.f=Object.freeze({...this.f,...y.metadata}))}acceptDirty(y){this.h=y}acceptModelChanged(y,u,E){this.g=y.versionId,this.h=u,this.acceptDocumentPropertiesChanged({metadata:E});const d={notebook:this.apiNotebook,metadata:E,cellChanges:[],contentChanges:[]},n=[];for(const o of y.rawEvents)o.kind===A.NotebookCellsChangeType.ModelChange?this.r(o.changes,!1,d.contentChanges):o.kind===A.NotebookCellsChangeType.Move?this.s(o.index,o.length,o.newIdx,d.contentChanges):o.kind===A.NotebookCellsChangeType.Output?(this.t(o.index,o.outputs),n.push({cell:this.b[o.index].apiCell,outputs:this.b[o.index].apiCell.outputs})):o.kind===A.NotebookCellsChangeType.OutputItem?(this.u(o.index,o.outputId,o.append,o.outputItems),n.push({cell:this.b[o.index].apiCell,outputs:this.b[o.index].apiCell.outputs})):o.kind===A.NotebookCellsChangeType.ChangeCellLanguage?(this.v(o.index,o.language),n.push({cell:this.b[o.index].apiCell,document:this.b[o.index].apiCell.document})):o.kind===A.NotebookCellsChangeType.ChangeCellContent?n.push({cell:this.b[o.index].apiCell,document:this.b[o.index].apiCell.document}):o.kind===A.NotebookCellsChangeType.ChangeCellMime?this.w(o.index,o.mime):o.kind===A.NotebookCellsChangeType.ChangeCellMetadata?(this.x(o.index,o.metadata),n.push({cell:this.b[o.index].apiCell,metadata:this.b[o.index].apiCell.metadata})):o.kind===A.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(o.index,o.internalMetadata),n.push({cell:this.b[o.index].apiCell,executionSummary:this.b[o.index].apiCell.executionSummary}));const s=new Map;for(let o=0;o<n.length;o++){const h=n[o],i=s.get(h.cell);if(i===void 0){const r=d.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...h});s.set(h.cell,r-1)}else d.cellChanges[i]={...d.cellChanges[i],...h}}return Object.freeze(d),Object.freeze(d.cellChanges),Object.freeze(d.contentChanges),d}n(y){return y=y|0,y<0?0:y>=this.b.length?this.b.length-1:y}o(y){let u=y.start|0,E=y.end|0;return u<0&&(u=0),E>this.b.length&&(E=this.b.length),y.with({start:u,end:E})}p(y){y=this.o(y);const u=[];for(let E=y.start;E<y.end;E++)u.push(this.b[E]);return u}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(y,u,E){if(this.j)return;const d=[],n=[],s=[];if(y.reverse().forEach(o=>{const i=o[2].map(c=>{const l=new p(this,this.l,c);return u||n.push(p.asModelAddData(c)),l}),r=new T(o[0],o[1],[],i),t=this.b.splice(o[0],o[1],...i);for(const c of t)s.push(c.uri),r.deletedItems.push(c.apiCell);d.push(r)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:n,removedDocuments:s}),E)for(const o of d)E.push(o.asApiEvent())}s(y,u,E,d){const n=this.b.splice(y,u);this.b.splice(E,0,...n);const s=[new T(y,u,n.map(o=>o.apiCell),[]),new T(E,0,[],n)];for(const o of s)d.push(o.asApiEvent())}t(y,u){this.b[y].setOutputs(u)}u(y,u,E,d){this.b[y].setOutputItems(u,E,d)}v(y,u){const E=this.b[y];E.apiCell.document.languageId!==u&&this.m.$acceptModelLanguageChanged(E.uri,u)}w(y,u){const E=this.b[y];E.apiCell.mime=u}x(y,u){this.b[y].setMetadata(u)}y(y,u){this.b[y].setInternalMetadata(u)}getCellFromApiCell(y){return this.b.find(u=>u.apiCell===y)}getCellFromIndex(y){return this.b[y]}getCell(y){return this.b.find(u=>u.handle===y)}getCellIndex(y){return this.b.indexOf(y)}}e.$gpc=a}),define(ke[289],Ce([1,0,6,2,10,7,39]),function(oe,e,w,S,k,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vpc=void 0;class T{constructor(a,R,y,u={timeout:1500,errors:3}){this.b=a,this.c=R,this.d=y,this.f=u,this.a=new w.$oe}dispose(){}getOnWillSaveNotebookDocumentEvent(a){return(R,y,u)=>{const E=function(n){R.call(y,n)};return E.extension=a,this.a.event(E,void 0,u)}}async $participateInSave(a,R,y){const u=S.URI.revive(a),E=this.c.getNotebookDocument(u);if(!E)throw new Error("Unable to resolve notebook document");const d=[];if(await this.a.fireAsync({notebook:E.apiNotebook,reason:k.TextDocumentSaveReason.to(R)},y,async(s,o)=>{const h=Date.now(),i=await await Promise.resolve(s);Date.now()-h>this.f.timeout&&this.b.warn("onWillSaveNotebookDocument-listener from extension",o.extension.identifier),!y.isCancellationRequested&&i&&(i instanceof O.$DN?d.push(i):this.b.warn("onWillSaveNotebookDocument-listener from extension",o.extension.identifier,"ignored due to invalid data"))}),y.isCancellationRequested)return!1;if(d.length===0)return!0;const n={edits:[]};for(const s of d){const{edits:o}=k.WorkspaceEdit.from(s);n.edits=n.edits.concat(o)}return this.d.$tryApplyWorkspaceEdit(new A.$Pw(n))}}e.$vpc=T}),define(ke[123],Ce([1,0,14,10,7]),function(oe,e,w,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hpc=void 0,S=qe(S),k=qe(k);class O{static{this.apiEditorsToExtHost=new WeakMap}constructor(T,p,a,R,y,u){this.id=T,this.f=p,this.notebookData=a,this.a=[],this.b=[],this.d=!1,this.a=y,this.b=R,this.c=u}get apiEditor(){if(!this.e){const T=this;this.e={get notebook(){return T.notebookData.apiNotebook},get selection(){return T.a[0]},set selection(p){this.selections=[p]},get selections(){return T.a},set selections(p){if(!Array.isArray(p)||!p.every(k.$VO.isNotebookRange))throw(0,w.$9)("selections");T.a=p,T.g(p)},get visibleRanges(){return T.b},revealRange(p,a){T.f.$tryRevealRange(T.id,S.NotebookRange.from(p),a??k.NotebookEditorRevealType.Default)},get viewColumn(){return T.c}},O.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility(T){this.d=T}_acceptVisibleRanges(T){this.b=T}_acceptSelections(T){this.a=T}g(T){this.f.$trySetSelections(this.id,T.map(S.NotebookRange.from))}_acceptViewColumn(T){this.c=T}}e.$hpc=O}),define(ke[290],Ce([1,0,6,12,10]),function(oe,e,w,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xpc=void 0,k=qe(k);let O=class{constructor(T,p){this.c=T,this.d=p,this.a=new w.$me,this.b=new w.$me,this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(T,p){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",T,p);const a=this.d.getEditorById(T);p.visibleRanges&&a._acceptVisibleRanges(p.visibleRanges.ranges.map(k.NotebookRange.to)),p.selections&&a._acceptSelections(p.selections.selections.map(k.NotebookRange.to)),p.visibleRanges&&this.b.fire({notebookEditor:a.apiEditor,visibleRanges:a.apiEditor.visibleRanges}),p.selections&&this.a.fire(Object.freeze({notebookEditor:a.apiEditor,selections:a.apiEditor.selections}))}$acceptEditorViewColumns(T){for(const p in T)this.d.getEditorById(p)._acceptViewColumn(k.ViewColumn.to(T[p]))}};e.$xpc=O,e.$xpc=O=He([Ve(0,S.$_j)],O)}),define(ke[291],Ce([1,0,6,5,123]),function(oe,e,w,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Apc=void 0;class O{constructor(T,p){this.c=p,this.a=new Map,this.b=T.getProxy(S.$rN.MainThreadNotebookRenderers)}$postRendererMessage(T,p,a){const R=this.c.getEditorById(T);this.a.get(p)?.fire({editor:R.apiEditor,message:a})}createRendererMessaging(T,p){if(!T.contributes?.notebookRenderer?.some(R=>R.id===p))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${p})`);return{onDidReceiveMessage:(R,y,u)=>this.d(p).event(R,y,u),postMessage:(R,y)=>{k.$hpc.apiEditorsToExtHost.has(R)&&([R,y]=[y,R]);const u=y&&k.$hpc.apiEditorsToExtHost.get(y);return this.b.$postMessage(u?.id,p,R)}}}d(T){let p=this.a.get(T);return p||(p=new w.$me({onDidRemoveLastListener:()=>{p?.dispose(),this.a.delete(T)}}),this.a.set(T,p),p)}}e.$Apc=O}),define(ke[292],Ce([1,0,10,77,22,72,14]),function(oe,e,w,S,k,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Epc=void 0;class T{constructor(y){this.b=0,this.c=new Map,this.a=y}async withProgress(y,u,E){const d=this.b++,{title:n,location:s,cancellable:o}=u,h={label:y.displayName||y.name,id:y.identifier.value};return this.a.$startProgress(d,{location:w.ProgressLocation.from(s),title:n,source:h,cancellable:o},y.isUnderDevelopment?void 0:y.identifier.value).catch(A.$4),this.d(d,E,!!o)}d(y,u,E){let d;E&&(d=new k.$xe,this.c.set(y,d));const n=o=>{this.a.$progressEnd(o),this.c.delete(o),d?.dispose()};let s;try{s=u(new a(this.a,y),E&&d?d.token:k.CancellationToken.None)}catch(o){throw n(y),o}return s.then(o=>n(y),o=>n(y)),s}$acceptProgressCanceled(y){const u=this.c.get(y);u&&(u.cancel(),this.c.delete(y))}}e.$Epc=T;function p(R,y){return R.message=y.message,typeof y.increment=="number"&&(typeof R.increment=="number"?R.increment+=y.increment:R.increment=y.increment),R}class a extends S.$rw{constructor(y,u){super(E=>this.throttledReport(E)),this.c=y,this.d=u}throttledReport(y){this.c.$progressReport(this.d,y)}}He([(0,O.$_h)(100,(R,y)=>p(R,y),()=>Object.create(null))],a.prototype,"throttledReport",null)}),define(ke[293],Ce([1,0,2,5,11,10]),function(oe,e,w,S,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fpc=void 0;class A{static{this.a=0}constructor(p,a){this.d=a,this.c=new Map,this.b=p.getProxy(S.$rN.MainThreadQuickDiff)}$provideOriginalResource(p,a,R){const y=w.URI.revive(a),u=this.c.get(p);return u?(0,k.$xh)(()=>u.provideOriginalResource(y,R)).then(E=>E||null):Promise.resolve(null)}registerQuickDiffProvider(p,a,R,y){const u=A.a++;return this.c.set(u,a),this.b.$registerQuickDiffProvider(u,O.DocumentSelector.from(p,this.d),R,y),{dispose:()=>{this.b.$unregisterQuickDiffProvider(u),this.c.delete(u)}}}}e.$Fpc=A});var ti=this&&this.__importDefault||function(oe){return oe&&oe.__esModule?oe:{default:oe}};define(ke[294],Ce([1,0,22,6,4,5,2,7,14,18,36,35,25,10]),function(oe,e,w,S,k,O,A,T,p,a,R,y,u,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gpc=d,R=ti(R);function d(n,s,o){const h=n.getProxy(O.$rN.MainThreadQuickOpen);class i{constructor(D,v){this.e=new Map,this.f=0,this.a=D,this.b=v}showQuickPick(D,v,C,P=w.CancellationToken.None){this.c=void 0;const g=Promise.resolve(v),b=++this.f,L=h.$show(b,{title:C?.title,placeHolder:C?.placeHolder,matchOnDescription:C?.matchOnDescription,matchOnDetail:C?.matchOnDetail,ignoreFocusLost:C?.ignoreFocusOut,canPickMany:C?.canPickMany},P),N={},B=L.then(()=>N);return Promise.race([B,g]).then(G=>{if(G===N)return;const W=(0,u.$3G)(D,"quickPickItemTooltip");return g.then(F=>{const q=[];for(let ue=0;ue<F.length;ue++){const ge=F[ue];if(typeof ge=="string")q.push({label:ge,handle:ue});else if(ge.kind===T.QuickPickItemKind.Separator)q.push({type:"separator",label:ge.label});else{ge.tooltip&&!W&&console.warn(`Extension '${D.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${D.identifier.value}`);const te=ge.iconPath?m(ge.iconPath):void 0;q.push({label:ge.label,iconPath:te?.iconPath,iconClass:te?.iconClass,description:ge.description,detail:ge.detail,picked:ge.picked,alwaysShow:ge.alwaysShow,tooltip:W?E.MarkdownString.fromStrict(ge.tooltip):void 0,handle:ue})}}return C&&typeof C.onDidSelectItem=="function"&&(this.c=ue=>{C.onDidSelectItem(F[ue])}),h.$setItems(b,q),L.then(ue=>{if(typeof ue=="number")return F[ue];if(Array.isArray(ue))return ue.map(ge=>F[ge])})})}).then(void 0,G=>{if(!(0,p.$6)(G))return h.$setError(b,G),Promise.reject(G)})}$onItemSelected(D){this.c?.(D)}showInput(D,v=w.CancellationToken.None){return this.d=D?.validateInput,h.$input(D,typeof this.d=="function",v).then(void 0,C=>{if(!(0,p.$6)(C))return Promise.reject(C)})}async $validateInput(D){if(!this.d)return;const v=await this.d(D);if(!v||typeof v=="string")return v;let C;switch(v.severity){case T.InputBoxValidationSeverity.Info:C=R.default.Info;break;case T.InputBoxValidationSeverity.Warning:C=R.default.Warning;break;case T.InputBoxValidationSeverity.Error:C=R.default.Error;break;default:C=v.message?R.default.Error:R.default.Ignore;break}return{content:v.message,severity:C}}async showWorkspaceFolderPick(D,v=w.CancellationToken.None){const C=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[D]);if(!C)return;const P=await this.a.getWorkspaceFolders2();if(P)return P.find(g=>g.uri.toString()===C.uri.toString())}createQuickPick(D){const v=new f(D,()=>this.e.delete(v._id));return this.e.set(v._id,v),v}createInputBox(D){const v=new $(D,()=>this.e.delete(v._id));return this.e.set(v._id,v),v}$onDidChangeValue(D,v){this.e.get(D)?._fireDidChangeValue(v)}$onDidAccept(D){this.e.get(D)?._fireDidAccept()}$onDidChangeActive(D,v){const C=this.e.get(D);C instanceof f&&C._fireDidChangeActive(v)}$onDidChangeSelection(D,v){const C=this.e.get(D);C instanceof f&&C._fireDidChangeSelection(v)}$onDidTriggerButton(D,v){this.e.get(D)?._fireDidTriggerButton(v)}$onDidTriggerItemButton(D,v,C){const P=this.e.get(D);P instanceof f&&P._fireDidTriggerItemButton(v,C)}$onDidHide(D){this.e.get(D)?._fireDidHide()}}class r{static{this.a=1}constructor(D,v){this.x=D,this.y=v,this._id=f.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new S.$me,this.q=new S.$me,this.r=new S.$me,this.s=new S.$me,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(D){this.b=D,this.z({title:D})}get step(){return this.c}set step(D){this.c=D,this.z({step:D})}get totalSteps(){return this.d}set totalSteps(D){this.d=D,this.z({totalSteps:D})}get enabled(){return this.g}set enabled(D){this.g=D,this.z({enabled:D})}get busy(){return this.j}set busy(D){this.j=D,this.z({busy:D})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(D){this.k=D,this.z({ignoreFocusOut:D})}get value(){return this.l}set value(D){this.l=D,this.z({value:D})}get placeholder(){return this.m}set placeholder(D){this.m=D,this.z({placeholder:D})}get buttons(){return this.n}set buttons(D){this.n=D.slice(),this.o.clear(),D.forEach((v,C)=>{const P=v===T.$SO.Back?-1:C;this.o.set(P,v)}),this.z({buttons:D.map((v,C)=>({...m(v.iconPath),tooltip:v.tooltip,handle:v===T.$SO.Back?-1:C}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(D){this.l=D,this.q.fire(D)}_fireDidTriggerButton(D){const v=this.o.get(D);v&&this.r.fire(v)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,k.$Rc)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),h.$dispose(this._id))}z(D){if(!this.v){for(const v of Object.keys(D)){const C=D[v];this.u[v]=C===void 0?null:C}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){h.$createOrUpdate(this.u),this.u={id:this._id}}}function t(I){if(I instanceof T.$qO)return{id:I.id};const D=l(I),v=c(I);return{dark:typeof D=="string"?A.URI.file(D):D,light:typeof v=="string"?A.URI.file(v):v}}function c(I){return typeof I=="object"&&"light"in I?I.light:I}function l(I){return typeof I=="object"&&"dark"in I?I.dark:I}function m(I){const D=t(I);let v,C;return"id"in D?C=y.ThemeIcon.asClassName(D):v=D,{iconPath:v,iconClass:C}}class f extends r{constructor(D,v){super(D.identifier,v),this.O=D,this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new S.$me,this.L=[],this.M=new S.$me,this.N=new S.$me,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(D){this.B=D.slice(),this.C.clear(),this.D.clear(),D.forEach((P,g)=>{this.C.set(g,P),this.D.set(P,g)});const v=(0,u.$3G)(this.O,"quickPickItemTooltip"),C=[];for(let P=0;P<D.length;P++){const g=D[P];if(g.kind===T.QuickPickItemKind.Separator)C.push({type:"separator",label:g.label});else{g.tooltip&&!v&&console.warn(`Extension '${this.O.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.O.identifier.value}`);const b=g.iconPath?m(g.iconPath):void 0;C.push({handle:P,label:g.label,iconPath:b?.iconPath,iconClass:b?.iconClass,description:g.description,detail:g.detail,picked:g.picked,alwaysShow:g.alwaysShow,tooltip:v?E.MarkdownString.fromStrict(g.tooltip):void 0,buttons:g.buttons?.map((L,N)=>({...m(L.iconPath),tooltip:L.tooltip,handle:N}))})}}this.z({items:C})}get canSelectMany(){return this.E}set canSelectMany(D){this.E=D,this.z({canSelectMany:D})}get matchOnDescription(){return this.F}set matchOnDescription(D){this.F=D,this.z({matchOnDescription:D})}get matchOnDetail(){return this.G}set matchOnDetail(D){this.G=D,this.z({matchOnDetail:D})}get sortByLabel(){return this.H}set sortByLabel(D){this.H=D,this.z({sortByLabel:D})}get keepScrollPosition(){return this.I}set keepScrollPosition(D){this.I=D,this.z({keepScrollPosition:D})}get activeItems(){return this.J}set activeItems(D){this.J=D.filter(v=>this.D.has(v)),this.z({activeItems:this.J.map(v=>this.D.get(v))})}get selectedItems(){return this.L}set selectedItems(D){this.L=D.filter(v=>this.D.has(v)),this.z({selectedItems:this.L.map(v=>this.D.get(v))})}_fireDidChangeActive(D){const v=(0,a.$Jb)(D.map(C=>this.C.get(C)));this.J=v,this.K.fire(v)}_fireDidChangeSelection(D){const v=(0,a.$Jb)(D.map(C=>this.C.get(C)));this.L=v,this.M.fire(v)}_fireDidTriggerItemButton(D,v){const C=this.C.get(D);if(!C||!C.buttons||!C.buttons.length)return;const P=C.buttons[v];P&&this.N.fire({button:P,item:C})}}class $ extends r{constructor(D,v){super(D.identifier,v),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(D){this.B=D,this.z({password:D})}get prompt(){return this.C}set prompt(D){this.C=D,this.z({prompt:D})}get valueSelection(){return this.D}set valueSelection(D){this.D=D,this.z({valueSelection:D})}get validationMessage(){return this.E}set validationMessage(D){this.E=D,D?typeof D=="string"?this.z({validationMessage:D,severity:R.default.Error}):this.z({validationMessage:D.message,severity:D.severity??R.default.Error}):this.z({validationMessage:void 0,severity:R.default.Ignore})}}return new i(s,o)}}),define(ke[295],Ce([1,0,2,6,72,4,11,5,18,159,12,19,38,35,10,25,16,21]),function(oe,e,w,S,k,O,A,T,p,a,R,y,u,E,d,n,s,o){"use strict";var h;Object.defineProperty(e,"__esModule",{value:!0}),e.$Ipc=e.$Hpc=void 0;function i(L){return L instanceof w.URI}function r(L,N){return L.scheme===s.Schemas.file&&N.scheme===s.Schemas.file&&o.$k?L.toString()===N.toString():L.toString().toLowerCase()===N.toString().toLowerCase()}function t(L){if(L)return typeof L.iconPath=="string"?w.URI.file(L.iconPath):w.URI.isUri(L.iconPath)||E.ThemeIcon.isThemeIcon(L.iconPath)?L.iconPath:void 0}function c(L){if(L.icon){if(w.URI.isUri(L.icon))return L.icon;if(E.ThemeIcon.isThemeIcon(L.icon))return L.icon;{const N=L.icon;return{light:N.light,dark:N.dark}}}else return}function l(L,N){if(!L.iconPath&&!N.iconPath)return 0;if(L.iconPath){if(!N.iconPath)return 1}else return-1;const B=typeof L.iconPath=="string"?L.iconPath:w.URI.isUri(L.iconPath)?L.iconPath.fsPath:L.iconPath.id,G=typeof N.iconPath=="string"?N.iconPath:w.URI.isUri(N.iconPath)?N.iconPath.fsPath:N.iconPath.id;return(0,a.$Dr)(B,G)}function m(L,N){let B=0;if(L.strikeThrough!==N.strikeThrough)return L.strikeThrough?1:-1;if(L.faded!==N.faded)return L.faded?1:-1;if(L.tooltip!==N.tooltip)return(L.tooltip||"").localeCompare(N.tooltip||"");if(B=l(L,N),B!==0)return B;if(L.light&&N.light)B=l(L.light,N.light);else{if(L.light)return 1;if(N.light)return-1}if(B!==0)return B;if(L.dark&&N.dark)B=l(L.dark,N.dark);else{if(L.dark)return 1;if(N.dark)return-1}return B}function f(L,N){if(L.command!==N.command)return L.command<N.command?-1:1;if(L.title!==N.title)return L.title<N.title?-1:1;if(L.tooltip!==N.tooltip){if(L.tooltip!==void 0&&N.tooltip!==void 0)return L.tooltip<N.tooltip?-1:1;if(L.tooltip!==void 0)return 1;if(N.tooltip!==void 0)return-1}if(L.arguments===N.arguments)return 0;if(L.arguments)if(N.arguments){if(L.arguments.length!==N.arguments.length)return L.arguments.length-N.arguments.length}else return 1;else return-1;for(let B=0;B<L.arguments.length;B++){const G=L.arguments[B],W=N.arguments[B];if(G!==W&&!(i(G)&&i(W)&&r(G,W)))return G<W?-1:1}return 0}function $(L,N){let B=(0,a.$Dr)(L.resourceUri.fsPath,N.resourceUri.fsPath,!0);if(B!==0)return B;if(L.command&&N.command)B=f(L.command,N.command);else{if(L.command)return 1;if(N.command)return-1}if(B!==0)return B;if(L.decorations&&N.decorations)B=m(L.decorations,N.decorations);else{if(L.decorations)return 1;if(N.decorations)return-1}if(L.multiFileDiffEditorModifiedUri&&N.multiFileDiffEditorModifiedUri)B=(0,a.$Dr)(L.multiFileDiffEditorModifiedUri.fsPath,N.multiFileDiffEditorModifiedUri.fsPath,!0);else{if(L.multiFileDiffEditorModifiedUri)return 1;if(N.multiFileDiffEditorModifiedUri)return-1}if(L.multiDiffEditorOriginalUri&&N.multiDiffEditorOriginalUri)B=(0,a.$Dr)(L.multiDiffEditorOriginalUri.fsPath,N.multiDiffEditorOriginalUri.fsPath,!0);else{if(L.multiDiffEditorOriginalUri)return 1;if(N.multiDiffEditorOriginalUri)return-1}return B}function I(L,N){for(let B=0;B<L.length;B++)if(L[B]!==N[B])return!1;return!0}function D(L,N){return L.command===N.command&&L.title===N.title&&L.tooltip===N.tooltip&&(L.arguments&&N.arguments?I(L.arguments,N.arguments):L.arguments===N.arguments)}function v(L,N){return(0,p.$wb)(L,N,D)}class C{#e;#t;get value(){return this.d}set value(N){N=N??"",this.#e.$setInputBoxValue(this.l,N),this.n(N)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(N){this.#e.$setInputBoxPlaceholder(this.l,N),this.f=N}get validateInput(){return(0,n.$4G)(this.k,"scmValidation"),this.g}set validateInput(N){if((0,n.$4G)(this.k,"scmValidation"),N&&typeof N!="function")throw new Error(`[${this.k.identifier.value}]: Invalid SCM input box validation function`);this.g=N,this.#e.$setValidationProviderIsEnabled(this.l,!!N)}get enabled(){return this.h}set enabled(N){N=!!N,this.h!==N&&(this.h=N,this.#e.$setInputBoxEnablement(this.l,N))}get visible(){return this.j}set visible(N){N=!!N,this.j!==N&&(this.j=N,this.#e.$setInputBoxVisibility(this.l,N))}get document(){return(0,n.$4G)(this.k,"scmTextDocument"),this.#t.getDocument(this.m)}constructor(N,B,G,W,F){this.k=N,this.l=W,this.m=F,this.d="",this.e=new S.$me,this.f="",this.h=!0,this.j=!0,this.#t=B,this.#e=G}showValidationMessage(N,B){(0,n.$4G)(this.k,"scmValidation"),this.#e.$showValidationMessage(this.l,N,B)}$onInputBoxValueChange(N){this.n(N)}n(N){this.d=N,this.e.fire(N)}}e.$Hpc=C;class P{static{this.d=0}get disposed(){return this.l}get id(){return this.u}get label(){return this.v}set label(N){this.v=N,this.q.$updateGroupLabel(this.t,this.handle,N)}get hideWhenEmpty(){return this.p}set hideWhenEmpty(N){this.p=N,this.q.$updateGroup(this.t,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(N){this.f=[...N],this.k.fire()}constructor(N,B,G,W,F,q,ue){this.q=N,this.s=B,this.t=G,this.u=W,this.v=F,this.multiDiffEditorEnableViewChanges=q,this.w=ue,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new S.$me,this.onDidUpdateResourceStates=this.k.event,this.l=!1,this.m=new S.$me,this.onDidDispose=this.m.event,this.n=[],this.o=[],this.p=void 0,this.handle=P.d++}getResourceState(N){return this.g.get(N)}$executeResourceCommand(N,B){const G=this.h.get(N);return G?(0,A.$xh)(()=>this.s.executeCommand(G.command,...G.arguments||[],B)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const N=[...this.f].sort($),G=(0,p.$Fb)(this.o,N,$).map(q=>{const ue=q.toInsert.map(ge=>{const te=this.e++;this.g.set(te,ge);const me=ge.resourceUri;let re;if(ge.command)if(ge.command.command==="vscode.open"||ge.command.command==="vscode.diff"||ge.command.command==="vscode.changes"){const X=new O.$Vc;re=this.s.converter.toInternal(ge.command,X),this.j.set(te,X)}else this.h.set(te,ge.command);const ce=(0,n.$3G)(this.w,"scmMultiDiffEditor"),be=ce?ge.multiDiffEditorOriginalUri:void 0,se=ce?ge.multiFileDiffEditorModifiedUri:void 0,Ie=t(ge.decorations),Ue=ge.decorations&&t(ge.decorations.light)||Ie,Z=ge.decorations&&t(ge.decorations.dark)||Ie,V=[Ue,Z],_=ge.decorations&&ge.decorations.tooltip||"",ye=ge.decorations&&!!ge.decorations.strikeThrough,ae=ge.decorations&&!!ge.decorations.faded,we=ge.contextValue||"";return{rawResource:[te,me,V,_,ye,ae,we,re,be,se],handle:te}});return{start:q.start,deleteCount:q.deleteCount,toInsert:ue}}),W=G.map(({start:q,deleteCount:ue,toInsert:ge})=>[q,ue,ge.map(te=>te.rawResource)]),F=G.reverse();for(const{start:q,deleteCount:ue,toInsert:ge}of F){const te=ge.map(re=>re.handle),me=this.n.splice(q,ue,...te);for(const re of me)this.g.delete(re),this.h.delete(re),this.j.get(re)?.dispose(),this.j.delete(re)}return this.o=N,W}dispose(){this.l=!0,this.m.fire()}}class g{static{this.d=0}#e;get id(){return this.A}get label(){return this.B}get rootUri(){return this.C}get inputBox(){return this.f}get count(){return this.g}set count(N){this.g!==N&&(this.g=N,this.#e.$updateSourceControl(this.w,{count:N}))}get quickDiffProvider(){return this.h}set quickDiffProvider(N){this.h=N;let B;(0,n.$3G)(this.x,"quickDiffProvider")&&(B=N?.label),this.#e.$updateSourceControl(this.w,{hasQuickDiffProvider:!!N,quickDiffLabel:B})}get historyProvider(){return(0,n.$4G)(this.x,"scmHistoryProvider"),this.j}set historyProvider(N){(0,n.$4G)(this.x,"scmHistoryProvider"),this.j=N,this.k.value=new O.$Vc,this.#e.$updateSourceControl(this.w,{hasHistoryProvider:!!N}),N&&this.k.value.add(N.onDidChangeCurrentHistoryItemGroup(()=>{this.l=N?.currentHistoryItemGroup,this.#e.$onDidChangeHistoryProviderCurrentHistoryItemGroup(this.w,this.l)}))}get commitTemplate(){return this.m}set commitTemplate(N){N!==this.m&&(this.m=N,this.#e.$updateSourceControl(this.w,{commitTemplate:N}))}get acceptInputCommand(){return this.o}set acceptInputCommand(N){this.n.value=new O.$Vc,this.o=N;const B=this.y.converter.toInternal(N,this.n.value);this.#e.$updateSourceControl(this.w,{acceptInputCommand:B})}get actionButton(){return(0,n.$4G)(this.x,"scmActionButton"),this.q}set actionButton(N){(0,n.$4G)(this.x,"scmActionButton"),this.p.value=new O.$Vc,this.q=N;const B=N!==void 0?{command:this.y.converter.toInternal(N.command,this.p.value),secondaryCommands:N.secondaryCommands?.map(G=>G.map(W=>this.y.converter.toInternal(W,this.p.value))),description:N.description,enabled:N.enabled}:void 0;this.#e.$updateSourceControl(this.w,{actionButton:B??null})}get statusBarCommands(){return this.t}set statusBarCommands(N){if(this.z.info("ExtHostSourceControl#statusBarCommands",(N??[]).map(G=>G.command).join(", ")),this.t&&N&&v(this.t,N)){this.z.info("ExtHostSourceControl#statusBarCommands are equal");return}this.s.value=new O.$Vc,this.t=N;const B=(N||[]).map(G=>this.y.converter.toInternal(G,this.s.value));this.#e.$updateSourceControl(this.w,{statusBarCommands:B})}get selected(){return this.u}constructor(N,B,G,W,F,q,ue,ge){this.x=N,this.y=W,this.z=F,this.A=q,this.B=ue,this.C=ge,this.e=new Map,this.g=void 0,this.h=void 0,this.k=new O.$Xc,this.m=void 0,this.n=new O.$Xc,this.o=void 0,this.p=new O.$Xc,this.s=new O.$Xc,this.t=void 0,this.u=!1,this.v=new S.$me,this.onDidChangeSelection=this.v.event,this.w=g.d++,this.D=new Map,this.E=new Set,this.#e=G;const te=w.URI.from({scheme:s.Schemas.vscodeSourceControl,path:`${q}/scm${this.w}/input`,query:ge?`rootUri=${encodeURIComponent(ge.toString())}`:void 0});this.f=new C(N,B,this.#e,this.w,te),this.#e.$registerSourceControl(this.w,q,ue,ge,te)}createResourceGroup(N,B,G){const W=(0,n.$3G)(this.x,"scmMultiDiffEditor")&&G?.multiDiffEditorEnableViewChanges===!0,F=new P(this.#e,this.y,this.w,N,B,W,this.x),q=S.Event.once(F.onDidDispose)(()=>this.D.delete(F));return this.D.set(F,q),this.eventuallyAddResourceGroups(),F}eventuallyAddResourceGroups(){const N=[],B=[];for(const[G,W]of this.D){W.dispose();const F=G.onDidUpdateResourceStates(()=>{this.E.add(G),this.eventuallyUpdateResourceStates()});S.Event.once(G.onDidDispose)(()=>{this.E.delete(G),F.dispose(),this.e.delete(G.handle),this.#e.$unregisterGroup(this.w,G.handle)}),N.push([G.handle,G.id,G.label,G.features,G.multiDiffEditorEnableViewChanges]);const q=G._takeResourceStateSnapshot();q.length>0&&B.push([G.handle,q]),this.e.set(G.handle,G)}this.#e.$registerGroups(this.w,N,B),this.D.clear()}eventuallyUpdateResourceStates(){const N=[];this.E.forEach(B=>{const G=B._takeResourceStateSnapshot();G.length!==0&&N.push([B.handle,G])}),N.length>0&&this.#e.$spliceResourceStates(this.w,N),this.E.clear()}getResourceGroup(N){return this.e.get(N)}setSelectionState(N){this.u=N,this.v.fire(N)}dispose(){this.n.dispose(),this.p.dispose(),this.s.dispose(),this.e.forEach(N=>N.dispose()),this.#e.$unregisterSourceControl(this.w)}}He([(0,k.$$h)(100)],g.prototype,"eventuallyAddResourceGroups",null),He([(0,k.$$h)(100)],g.prototype,"eventuallyUpdateResourceStates",null);let b=class{static{h=this}static{this.d=0}get onDidChangeActiveProvider(){return this.j.event}constructor(N,B,G,W){this.l=B,this.m=G,this.n=W,this.g=new Map,this.h=new y.$sn,this.j=new S.$me,this.e=N.getProxy(T.$rN.MainThreadSCM),this.f=N.getProxy(T.$rN.MainThreadTelemetry),B.registerArgumentProcessor({processArgument:F=>{if(F&&F.$mid===u.MarshalledId.ScmResource){const q=this.g.get(F.sourceControlHandle);if(!q)return F;const ue=q.getResourceGroup(F.groupHandle);return ue?ue.getResourceState(F.handle):F}else if(F&&F.$mid===u.MarshalledId.ScmResourceGroup){const q=this.g.get(F.sourceControlHandle);return q?q.getResourceGroup(F.groupHandle):F}else if(F&&F.$mid===u.MarshalledId.ScmProvider){const q=this.g.get(F.handle);return q||F}return F}})}createSourceControl(N,B,G,W){this.n.trace("ExtHostSCM#createSourceControl",N.identifier.value,B,G,W),this.f.$publicLog2("api/scm/createSourceControl",{extensionId:N.identifier.value});const F=h.d++,q=new g(N,this.m,this.e,this.l,this.n,B,G,W);this.g.set(F,q);const ue=this.h.get(N.identifier)||[];return ue.push(q),this.h.set(N.identifier,ue),q}getLastInputBox(N){this.n.trace("ExtHostSCM#getLastInputBox",N.identifier.value);const B=this.h.get(N.identifier),G=B&&B[B.length-1];return G&&G.inputBox}$provideOriginalResource(N,B,G){const W=w.URI.revive(B);this.n.trace("ExtHostSCM#$provideOriginalResource",N,W.toString());const F=this.g.get(N);return!F||!F.quickDiffProvider||!F.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,A.$xh)(()=>F.quickDiffProvider.provideOriginalResource(W,G)).then(q=>q||null)}$onInputBoxValueChange(N,B){this.n.trace("ExtHostSCM#$onInputBoxValueChange",N);const G=this.g.get(N);return G&&G.inputBox.$onInputBoxValueChange(B),Promise.resolve(void 0)}$executeResourceCommand(N,B,G,W){this.n.trace("ExtHostSCM#$executeResourceCommand",N,B,G);const F=this.g.get(N);if(!F)return Promise.resolve(void 0);const q=F.getResourceGroup(B);return q?q.$executeResourceCommand(G,W):Promise.resolve(void 0)}$validateInput(N,B,G){this.n.trace("ExtHostSCM#$validateInput",N);const W=this.g.get(N);return!W||!W.inputBox.validateInput?Promise.resolve(void 0):(0,A.$xh)(()=>W.inputBox.validateInput(B,G)).then(F=>{if(!F)return Promise.resolve(void 0);const q=d.MarkdownString.fromStrict(F.message);return q?Promise.resolve([q,F.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(N){return this.n.trace("ExtHostSCM#$setSelectedSourceControl",N),N!==void 0&&this.g.get(N)?.setSelectionState(!0),this.k!==void 0&&this.g.get(this.k)?.setSelectionState(!1),this.k=N,Promise.resolve(void 0)}async $resolveHistoryItemGroupCommonAncestor(N,B,G,W){return await this.g.get(N)?.historyProvider?.resolveHistoryItemGroupCommonAncestor(B,G,W)??void 0}async $provideHistoryItems(N,B,G,W){return(await this.g.get(N)?.historyProvider?.provideHistoryItems(B,G,W))?.map(ue=>({...ue,icon:c(ue)}))??void 0}async $provideHistoryItemSummary(N,B,G,W){const F=this.g.get(N)?.historyProvider;if(typeof F?.provideHistoryItemSummary!="function")return;const q=await F.provideHistoryItemSummary(B,G,W);return q?{...q,icon:c(q)}:void 0}async $provideHistoryItemChanges(N,B,G,W){return await this.g.get(N)?.historyProvider?.provideHistoryItemChanges(B,G,W)??void 0}};e.$Ipc=b,e.$Ipc=b=h=He([Ve(3,R.$_j)],b)}),define(ke[296],Ce([1,0,5,10,2]),function(oe,e,w,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jpc=void 0;class O{static{this.a=0}constructor(T,p){this.d=p,this.c=new Map,this.b=T.getProxy(w.$rN.MainThreadShare)}async $provideShare(T,p,a){return await this.c.get(T)?.provideShare({selection:S.Range.to(p.selection),resourceUri:k.URI.revive(p.resourceUri)},a)??void 0}registerShareProvider(T,p){const a=O.a++;return this.c.set(a,p),this.b.$registerShareProvider(a,S.DocumentSelector.from(T,this.d),p.id,p.label,p.priority),{dispose:()=>{this.b.$unregisterShareProvider(a),this.c.delete(a)}}}}e.$Jpc=O}),define(ke[297],Ce([1,0,7,5,186,4,10,15]),function(oe,e,w,S,k,O,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mpc=e.$Lpc=void 0;class p{static{this.a=0}static{this.b=new Map([["statusBarItem.errorBackground",new w.$rO("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new w.$rO("statusBarItem.warningForeground")]])}#e;#t;constructor(u,E,d,n,s,o=w.StatusBarAlignment.Left,h){if(this.i=!1,this.k="",this.q=new O.$Vc,this.#e=u,this.#t=E,s&&n){this.c=(0,w.$6N)(n.identifier,s);const i=d.get(this.c);i&&(o=i.alignLeft?w.StatusBarAlignment.Left:w.StatusBarAlignment.Right,h=i.priority,this.j=!0,this.name=i.name,this.text=i.text,this.tooltip=i.tooltip,this.command=i.command,this.accessibilityInformation=i.accessibilityInformation)}else this.c=String(p.a++);this.e=n,this.f=s,this.g=o,this.h=this.u(h)}u(u){if((0,T.$jg)(u))return u===Number.POSITIVE_INFINITY?Number.MAX_VALUE:u===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:u}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.r?.fromApi}get accessibilityInformation(){return this.t}set text(u){this.k=u,this.v()}set name(u){this.m=u,this.v()}set tooltip(u){this.l=u,this.v()}set color(u){this.n=u,this.v()}set backgroundColor(u){u&&!p.b.has(u.id)&&(u=void 0),this.o=u,this.v()}set command(u){this.r?.fromApi!==u&&(this.p&&this.q.add(this.p),this.p=new O.$Vc,typeof u=="string"?this.r={fromApi:u,internal:this.#t.toInternal({title:"",command:u},this.p)}:u?this.r={fromApi:u,internal:this.#t.toInternal(u,this.p)}:this.r=void 0,this.v())}set accessibilityInformation(u){this.t=u,this.v()}show(){this.j=!0,this.v()}hide(){clearTimeout(this.s),this.j=!1,this.#e.$disposeEntry(this.c)}v(){this.i||!this.j||(clearTimeout(this.s),this.s=setTimeout(()=>{this.s=void 0;let u;this.e?this.f?u=`${this.e.identifier.value}.${this.f}`:u=this.e.identifier.value:u=this.f;let E;this.m?E=this.m:E=(0,k.localize)(0,null,this.e.displayName||this.e.name);let d=this.n;this.o&&(d=p.b.get(this.o.id));const n=A.MarkdownString.fromStrict(this.l);this.#e.$setEntry(this.c,u,this.e?.identifier.value,E,this.k,n,this.r?.internal,d,this.o,this.g===w.StatusBarAlignment.Left,this.h,this.t),this.q.clear()},0))}dispose(){this.hide(),this.i=!0}}e.$Lpc=p;class a{constructor(u){this.b=[],this.a=u.createStatusBarEntry(void 0,"status.extensionMessage",w.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,k.localize)(1,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(u){const E={message:u};return this.b.unshift(E),this.c(),new w.$tN(()=>{const d=this.b.indexOf(E);d>=0&&(this.b.splice(d,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class R{constructor(u,E){this.e=new Map,this.a=u.getProxy(S.$rN.MainThreadStatusBar),this.b=E,this.c=new a(this)}$acceptStaticEntries(u){for(const E of u)this.e.set(E.entryId,E)}createStatusBarEntry(u,E,d,n){return new p(this.a,this.b,this.e,u,E,d,n)}setStatusBarMessage(u,E){const d=this.c.setMessage(u);let n;return typeof E=="number"?n=setTimeout(()=>d.dispose(),E):typeof E<"u"&&E.then(()=>d.dispose(),()=>d.dispose()),new w.$tN(()=>{d.dispose(),clearTimeout(n)})}}e.$Mpc=R}),define(ke[124],Ce([1,0,33,115,55,82,56,10,2]),function(oe,e,w,S,k,O,A,T,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aQ=e.$_P=e.$$P=e.$0P=void 0,w=qe(w),T=qe(T);const a=(i,r,t,c)=>{let l=r;return{enumerable:!0,configurable:!1,get(){return l},set(m){if(!t(l,m)){const f=l;l=m,i.listener?.(c(m,f))}}}},R=(i,r)=>i===r,y={range:(i,r)=>i===r?!0:!i||!r?!1:i.isEqual(r),label:R,description:R,sortText:R,busy:R,error:R,canResolveChildren:R,tags:(i,r)=>!(i.length!==r.length||i.some(t=>!r.find(c=>t.id===c.id)))},u=i=>r=>({op:O.TestItemEventOp.SetProp,update:i(r)}),E=(i,r)=>({range:(()=>{let t;const c=u(l=>({range:w.$Ht.lift(T.Range.from(l))}));return{enumerable:!0,configurable:!1,get(){return t},set(l){i.listener?.({op:O.TestItemEventOp.DocumentSynced}),y.range(t,l)||(t=l,i.listener?.(c(l)))}}})(),label:a(i,r,y.label,u(t=>({label:t}))),description:a(i,void 0,y.description,u(t=>({description:t}))),sortText:a(i,void 0,y.sortText,u(t=>({sortText:t}))),canResolveChildren:a(i,!1,y.canResolveChildren,t=>({op:O.TestItemEventOp.UpdateCanResolveChildren,state:t})),busy:a(i,!1,y.busy,u(t=>({busy:t}))),error:a(i,void 0,y.error,u(t=>({error:T.MarkdownString.fromStrict(t)||null}))),tags:a(i,[],y.tags,(t,c)=>({op:O.TestItemEventOp.SetTags,new:t.map(T.TestTag.from),old:c.map(T.TestTag.from)}))}),d=i=>{const r=k.$QI.fromString(i.extId),t=new s(r.controllerId,r.localId,i.label,p.URI.revive(i.uri)||void 0);return t.range=T.Range.to(i.range||void 0),t.description=i.description||void 0,t.sortText=i.sortText||void 0,t.tags=i.tags.map(c=>T.TestTag.to({id:(0,A.$WI)(c).tagId})),t},n=i=>{let r;for(const t of i.tests){const c=d(t.item);(0,S.$TP)(c).parent=r,r=c}return r};e.$0P=n;class s{constructor(r,t,c,l){if(t.includes(k.TestIdPathParts.Delimiter))throw new Error(`Test IDs may not include the ${JSON.stringify(t)} symbol`);const m=(0,S.$SP)(this,r);Object.defineProperties(this,{id:{value:t,enumerable:!0,writable:!1},uri:{value:l,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return m.parent instanceof o?void 0:m.parent}},children:{value:(0,O.$RP)(m,S.$TP,s),enumerable:!0,writable:!1},...E(m,c)})}}e.$$P=s;class o extends s{constructor(r,t){super(r,r,t,void 0),this._isRoot=!0}}e.$_P=o;class h extends O.$NP{constructor(r,t,c){super({controllerId:r,getDocumentVersion:l=>l&&c.getDocument(l)?.version,getApiFor:S.$TP,getChildren:l=>l.children,root:new o(r,t),toITestItem:T.TestItem.from})}}e.$aQ=h}),define(ke[34],Ce([1,0,15,7,10,26,5,18,12,49,33,101,2,4,3,17,124,23,39,48,70,64,67,37]),function(oe,e,w,S,k,O,A,T,p,a,R,y,u,E,d,n,s,o,h,i,r,t,c,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lQ=e.$kQ=e.$jQ=e.$iQ=e.$hQ=e.$gQ=void 0,S=qe(S),k=qe(k);let m=class{#e;#t;#i;constructor(C,P,g){this.b=new Map,this.c=new Map,this.#e=C.getProxy(A.$rN.MainThreadCommands),this.d=P,this.#i=g,this.#t=C.getProxy(A.$rN.MainThreadTelemetry),this.converter=new f(this,b=>{const L=this.c.get(b);return L?.result===I.Void?L:void 0},P),this.f=[{processArgument(b){return(0,a.$ci)(b)}},{processArgument(b){return(0,O.$do)(b,function(L){if(R.$Ht.isIRange(L))return k.Range.to(L);if(y.$Gt.isIPosition(L))return k.Position.to(L);if(R.$Ht.isIRange(L.range)&&u.URI.isUri(L.uri))return k.location.to(L);if(L instanceof o.$Oe)return L.buffer.buffer;if(!Array.isArray(L))return L})}}]}registerArgumentProcessor(C){this.f.push(C)}registerApiCommand(C){const P=this.registerCommand(!1,C.id,async(...g)=>{const b=C.args.map((N,B)=>{if(!N.validate(g[B]))throw new Error(`Invalid argument '${N.name}' when running '${C.id}', received: ${typeof g[B]=="object"?JSON.stringify(g[B],null,"	"):g[B]} `);return N.convert(g[B])}),L=await this.executeCommand(C.internalId,...b);return C.result.convert(L,g,this.converter)},void 0,{description:C.description,args:C.args,returns:C.result.description});return this.c.set(C.id,C),new S.$tN(()=>{P.dispose(),this.c.delete(C.id)})}registerCommand(C,P,g,b,L,N){if(this.d.trace("ExtHostCommands#registerCommand",P),!P.trim().length)throw new Error("invalid id");if(this.b.has(P))throw new Error(`command '${P}' already exists`);return this.b.set(P,{callback:g,thisArg:b,metadata:L,extension:N}),C&&this.#e.$registerCommand(P),new S.$tN(()=>{this.b.delete(P)&&C&&this.#e.$unregisterCommand(P)})}executeCommand(C,...P){return this.d.trace("ExtHostCommands#executeCommand",C),this.g(C,P,!0)}async g(C,P,g){if(this.b.has(C))return this.#e.$fireCommandActivationEvent(C),this.h(C,P,!1);{let b=!1;const L=(0,O.$do)(P,function(N){if(N instanceof S.$uN)return k.Position.from(N);if(N instanceof S.$vN)return k.Range.from(N);if(N instanceof S.$FN)return k.location.from(N);if(S.$VO.isNotebookRange(N))return k.NotebookRange.from(N);if(N instanceof ArrayBuffer)return b=!0,o.$Oe.wrap(new Uint8Array(N));if(N instanceof Uint8Array)return b=!0,o.$Oe.wrap(N);if(N instanceof o.$Oe)return b=!0,N;if(!Array.isArray(N))return N});try{const N=await this.#e.$executeCommand(C,b?new h.$Pw(L):L,g);return(0,a.$ci)(N)}catch(N){if(N instanceof Error&&N.message==="$executeCommand:retry")return this.g(C,P,!1);throw N}}}async h(C,P,g){const b=this.b.get(C);if(!b)throw new Error("Unknown command");const{callback:L,thisArg:N,metadata:B}=b;if(B?.args)for(let W=0;W<B.args.length;W++)try{(0,w.$wg)(P[W],B.args[W].constraint)}catch{throw new Error(`Running the contributed command: '${C}' failed. Illegal argument '${B.args[W].name}' - ${B.args[W].description}`)}const G=r.$ge.create();try{return await L.apply(N,P)}catch(W){if(C===this.converter.delegatingCommandId){const F=this.converter.getActualCommand(...P);F&&(C=F.command)}if(this.d.error(W,C,b.extension?.identifier),!g)throw W;if(b.extension?.identifier){const F=this.#i.onExtensionError(b.extension.identifier,W);this.d.trace("forwarded error to extension?",F,b.extension?.identifier)}throw new class extends Error{constructor(){super((0,i.$qj)(W)),this.id=C,this.source=b.extension?.displayName??b.extension?.name}}}finally{this.j(b,C,G.elapsed())}}j(C,P,g){C.extension&&this.#t.$publicLog2("Extension:ActionExecuted",{extensionId:C.extension.identifier.value,id:new t.$sp(P),duration:g})}$executeContributedCommand(C,...P){this.d.trace("ExtHostCommands#$executeContributedCommand",C);const g=this.b.get(C);return g?(P=P.map(b=>this.f.reduce((L,N)=>N.processArgument(L,g.extension?.identifier),b)),this.h(C,P,!0)):Promise.reject(new Error(`Contributed command '${C}' does not exist.`))}getCommands(C=!1){return this.d.trace("ExtHostCommands#getCommands",C),this.#e.$getCommands().then(P=>(C&&(P=P.filter(g=>g[0]!=="_")),P))}$getContributedCommandMetadata(){const C=Object.create(null);for(const[P,g]of this.b){const{metadata:b}=g;b&&(C[P]=b)}return Promise.resolve(C)}};e.$gQ=m,e.$gQ=m=He([Ve(0,n.$XP),Ve(1,p.$_j),Ve(2,c.$fQ)],m),e.$hQ=(0,d.$Fi)("IExtHostCommands");class f{constructor(C,P,g){this.d=C,this.f=P,this.g=g,this.delegatingCommandId=`__vsc${(0,l.$2g)()}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(C,P){if(!C)return;const g={$ident:void 0,id:C.command,title:C.title,tooltip:C.tooltip};if(!C.command)return g;const b=this.f(C.command);if(b)g.id=b.internalId,g.arguments=b.args.map((L,N)=>L.convert(C.arguments&&C.arguments[N]));else if((0,T.$Nb)(C.arguments)){const L=`${C.command} /${++this.c}`;this.b.set(L,C),P.add((0,E.$Uc)(()=>{this.b.delete(L),this.g.trace("CommandsConverter#DISPOSE",L)})),g.$ident=L,g.id=this.delegatingCommandId,g.arguments=[L],this.g.trace("CommandsConverter#CREATE",C.command,L)}return g}fromInternal(C){return typeof C.$ident=="string"?this.b.get(C.$ident):{command:C.id,title:C.title,arguments:C.arguments}}getActualCommand(...C){return this.b.get(C[0])}h(...C){const P=this.getActualCommand(...C);return this.g.trace("CommandsConverter#EXECUTE",C[0],P?P.command:"MISSING"),P?this.d.executeCommand(P.command,...P.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${C[0]}`)}}e.$iQ=f;class ${static{this.Uri=new $("uri","Uri of a text document",C=>u.URI.isUri(C),C=>C)}static{this.Position=new $("position","A position in a text document",C=>S.$uN.isPosition(C),k.Position.from)}static{this.Range=new $("range","A range in a text document",C=>S.$vN.isRange(C),k.Range.from)}static{this.Selection=new $("selection","A selection in a text document",C=>S.$wN.isSelection(C),k.Selection.from)}static{this.Number=new $("number","",C=>typeof C=="number",C=>C)}static{this.String=new $("string","",C=>typeof C=="string",C=>C)}static{this.StringArray=$.Arr($.String)}static Arr(C){return new $(`${C.name}_array`,`Array of ${C.name}, ${C.description}`,P=>Array.isArray(P)&&P.every(g=>C.validate(g)),P=>P.map(g=>C.convert(g)))}static{this.CallHierarchyItem=new $("item","A call hierarchy item",C=>C instanceof S.$RN,k.CallHierarchyItem.from)}static{this.TypeHierarchyItem=new $("item","A type hierarchy item",C=>C instanceof S.$dP,k.TypeHierarchyItem.from)}static{this.TestItem=new $("testItem","A VS Code TestItem",C=>C instanceof s.$$P,k.TestItem.from)}constructor(C,P,g,b){this.name=C,this.description=P,this.validate=g,this.convert=b}optional(){return new $(this.name,`(optional) ${this.description}`,C=>C==null||this.validate(C),C=>C===void 0?void 0:C===null?null:this.convert(C))}with(C,P){return new $(C??this.name,P??this.description,this.validate,this.convert)}}e.$jQ=$;class I{static{this.Void=new I("no result",C=>C)}constructor(C,P){this.description=C,this.convert=P}}e.$kQ=I;class D{constructor(C,P,g,b,L){this.id=C,this.internalId=P,this.description=g,this.args=b,this.result=L}}e.$lQ=D}),define(ke[298],Ce([1,0,18,16,2,94,104,32,34,10,7]),function(oe,e,w,S,k,O,A,T,p,a,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3nc=void 0,O=qe(O),a=qe(a),R=qe(R);const y=[new p.$lQ("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[p.$jQ.Uri,p.$jQ.Position],new p.$kQ("A promise that resolves to an array of DocumentHighlight-instances.",E(a.DocumentHighlight.to))),new p.$lQ("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[p.$jQ.Uri],new p.$kQ("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(n,s)=>{if((0,w.$Mb)(n))return;class o extends R.$MN{static to(i){const r=new o(i.name,a.SymbolKind.to(i.kind),i.containerName||"",new R.$FN(s[0],a.Range.to(i.range)));return r.detail=i.detail,r.range=r.location.range,r.selectionRange=a.Range.to(i.selectionRange),r.children=i.children?i.children.map(o.to):[],r}}return n.map(o.to)})),new p.$lQ("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[p.$jQ.Uri,new p.$jQ("options","Formatting options",n=>!0,n=>n)],new p.$kQ("A promise that resolves to an array of TextEdits.",E(a.TextEdit.to))),new p.$lQ("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[p.$jQ.Uri,p.$jQ.Range,new p.$jQ("options","Formatting options",n=>!0,n=>n)],new p.$kQ("A promise that resolves to an array of TextEdits.",E(a.TextEdit.to))),new p.$lQ("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[p.$jQ.Uri,p.$jQ.Position,new p.$jQ("ch","Trigger character",n=>typeof n=="string",n=>n),new p.$jQ("options","Formatting options",n=>!0,n=>n)],new p.$kQ("A promise that resolves to an array of TextEdits.",E(a.TextEdit.to))),new p.$lQ("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[p.$jQ.Uri,p.$jQ.Position],new p.$kQ("A promise that resolves to an array of Location or LocationLink instances.",d)),new p.$lQ("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[p.$jQ.Uri,p.$jQ.Position],new p.$kQ("A promise that resolves to an array of Location or LocationLink instances.",d)),new p.$lQ("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[p.$jQ.Uri,p.$jQ.Position],new p.$kQ("A promise that resolves to an array of Location or LocationLink instances.",d)),new p.$lQ("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[p.$jQ.Uri,p.$jQ.Position],new p.$kQ("A promise that resolves to an array of Location or LocationLink instances.",d)),new p.$lQ("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[p.$jQ.Uri,p.$jQ.Position],new p.$kQ("A promise that resolves to an array of Location-instances.",E(a.location.to))),new p.$lQ("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[p.$jQ.Uri,p.$jQ.Position],new p.$kQ("A promise that resolves to an array of Hover-instances.",E(a.Hover.to))),new p.$lQ("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[p.$jQ.Uri,new p.$jQ("position","A position in a text document",n=>Array.isArray(n)&&n.every(s=>R.$uN.isPosition(s)),n=>n.map(a.Position.from))],new p.$kQ("A promise that resolves to an array of ranges.",n=>n.map(s=>{let o;for(const h of s.reverse())o=new R.$QN(a.Range.to(h),o);return o}))),new p.$lQ("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[p.$jQ.String.with("query","Search string")],new p.$kQ("A promise that resolves to an array of SymbolInformation-instances.",n=>n.map(a.WorkspaceSymbol.to))),new p.$lQ("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[p.$jQ.Uri,p.$jQ.Position],new p.$kQ("A promise that resolves to an array of CallHierarchyItem-instances",n=>n.map(a.CallHierarchyItem.to))),new p.$lQ("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[p.$jQ.CallHierarchyItem],new p.$kQ("A promise that resolves to an array of CallHierarchyIncomingCall-instances",n=>n.map(a.CallHierarchyIncomingCall.to))),new p.$lQ("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[p.$jQ.CallHierarchyItem],new p.$kQ("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",n=>n.map(a.CallHierarchyOutgoingCall.to))),new p.$lQ("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[p.$jQ.Uri,p.$jQ.Position],new p.$kQ("A promise that resolves to a range and placeholder text.",n=>{if(n)return{range:a.Range.to(n.range),placeholder:n.text}})),new p.$lQ("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[p.$jQ.Uri,p.$jQ.Position,p.$jQ.String.with("newName","The new symbol name")],new p.$kQ("A promise that resolves to a WorkspaceEdit.",n=>{if(n){if(n.rejectReason)throw new Error(n.rejectReason);return a.WorkspaceEdit.to(n)}})),new p.$lQ("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[p.$jQ.Uri,p.$jQ.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new p.$kQ("A promise that resolves to an array of DocumentLink-instances.",n=>n.map(a.DocumentLink.to))),new p.$lQ("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[p.$jQ.Uri],new p.$kQ("A promise that resolves to SemanticTokensLegend.",n=>{if(n)return new R.$MO(n.tokenTypes,n.tokenModifiers)})),new p.$lQ("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[p.$jQ.Uri],new p.$kQ("A promise that resolves to SemanticTokens.",n=>{if(!n)return;const s=(0,A.$odb)(n);if(s.type==="full")return new R.$OO(s.data,void 0)})),new p.$lQ("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[p.$jQ.Uri,p.$jQ.Range.optional()],new p.$kQ("A promise that resolves to SemanticTokensLegend.",n=>{if(n)return new R.$MO(n.tokenTypes,n.tokenModifiers)})),new p.$lQ("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[p.$jQ.Uri,p.$jQ.Range],new p.$kQ("A promise that resolves to SemanticTokens.",n=>{if(!n)return;const s=(0,A.$odb)(n);if(s.type==="full")return new R.$OO(s.data,void 0)})),new p.$lQ("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[p.$jQ.Uri,p.$jQ.Position,p.$jQ.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),p.$jQ.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new p.$kQ("A promise that resolves to a CompletionList-instance.",(n,s,o)=>{if(!n)return new R.$3N([]);const h=n.suggestions.map(i=>a.CompletionItem.to(i,o));return new R.$3N(h,n.incomplete)})),new p.$lQ("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[p.$jQ.Uri,p.$jQ.Position,p.$jQ.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new p.$kQ("A promise that resolves to SignatureHelp.",n=>{if(n)return a.SignatureHelp.to(n)})),new p.$lQ("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[p.$jQ.Uri,p.$jQ.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new p.$kQ("A promise that resolves to an array of CodeLens-instances.",(n,s,o)=>E(h=>new R.$UN(a.Range.to(h.range),h.command&&o.fromInternal(h.command)))(n))),new p.$lQ("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[p.$jQ.Uri,new p.$jQ("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",n=>R.$vN.isRange(n),n=>R.$wN.isSelection(n)?a.Selection.from(n):a.Range.from(n)),p.$jQ.String.with("kind","Code action kind to return code actions for").optional(),p.$jQ.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new p.$kQ("A promise that resolves to an array of Command-instances.",(n,s,o)=>E(h=>{if(h._isSynthetic){if(!h.command)throw new Error("Synthetic code actions must have a command");return o.fromInternal(h.command)}else{const i=new R.$ON(h.title,h.kind?new R.$PN(h.kind):void 0);return h.edit&&(i.edit=a.WorkspaceEdit.to(h.edit)),h.command&&(i.command=o.fromInternal(h.command)),i.isPreferred=h.isPreferred,i}})(n))),new p.$lQ("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[p.$jQ.Uri],new p.$kQ("A promise that resolves to an array of ColorInformation objects.",n=>n?n.map(s=>new R.$9N(a.Range.to(s.range),a.Color.to(s.color))):[])),new p.$lQ("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new p.$jQ("color","The color to show and insert",n=>n instanceof R.$8N,a.Color.from),new p.$jQ("context","Context object with uri and range",n=>!0,n=>({uri:n.uri,range:a.Range.from(n.range)}))],new p.$kQ("A promise that resolves to an array of ColorPresentation objects.",n=>n?n.map(a.ColorPresentation.to):[])),new p.$lQ("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[p.$jQ.Uri,p.$jQ.Range],new p.$kQ("A promise that resolves to an array of Inlay objects",(n,s,o)=>n.map(a.InlayHint.to.bind(void 0,o)))),new p.$lQ("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[p.$jQ.Uri],new p.$kQ("A promise that resolves to an array of FoldingRange objects",(n,s)=>{if(n)return n.map(a.FoldingRange.to)})),new p.$lQ("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new p.$kQ("A promise that resolves to an array of NotebookContentProvider static info objects.",E(n=>({viewType:n.viewType,displayName:n.displayName,options:{transientOutputs:n.options.transientOutputs,transientCellMetadata:n.options.transientCellMetadata,transientDocumentMetadata:n.options.transientDocumentMetadata},filenamePattern:n.filenamePattern.map(s=>a.NotebookExclusiveDocumentPattern.to(s))})))),new p.$lQ("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[p.$jQ.Uri,p.$jQ.Range,new p.$jQ("context","An InlineValueContext",n=>n&&typeof n.frameId=="number"&&n.stoppedLocation instanceof R.$vN,n=>a.InlineValueContext.from(n))],new p.$kQ("A promise that resolves to an array of InlineValue objects",n=>n.map(a.InlineValue.to))),new p.$lQ("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new p.$jQ("uriOrString","Uri-instance or string (only http/https)",n=>k.URI.isUri(n)||typeof n=="string"&&(0,S.$Pg)(n,S.Schemas.http,S.Schemas.https),n=>n),new p.$jQ("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",n=>n===void 0||typeof n=="number"||typeof n=="object",n=>n&&(typeof n=="number"?[a.ViewColumn.from(n),void 0]:[a.ViewColumn.from(n.viewColumn),a.TextEditorOpenOptions.from(n)])).optional(),p.$jQ.String.with("label","").optional()],p.$kQ.Void),new p.$lQ("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[p.$jQ.Uri.with("resource","Resource to open"),p.$jQ.String.with("viewId","Custom editor view id. This should be the viewType string for custom editors or the notebookType string for notebooks. Use 'default' to use VS Code's default text editor"),new p.$jQ("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",n=>n===void 0||typeof n=="number"||typeof n=="object",n=>n&&(typeof n=="number"?[a.ViewColumn.from(n),void 0]:[a.ViewColumn.from(n.viewColumn),a.TextEditorOpenOptions.from(n)])).optional()],p.$kQ.Void),new p.$lQ("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[p.$jQ.Uri.with("left","Left-hand side resource of the diff editor"),p.$jQ.Uri.with("right","Right-hand side resource of the diff editor"),p.$jQ.String.with("title","Human readable title for the diff editor").optional(),new p.$jQ("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",n=>n===void 0||typeof n=="object",n=>n&&[a.ViewColumn.from(n.viewColumn),a.TextEditorOpenOptions.from(n)]).optional()],p.$kQ.Void),new p.$lQ("vscode.changes","_workbench.changes","Opens a list of resources in the changes editor to compare their contents.",[p.$jQ.String.with("title","Human readable title for the changes editor"),new p.$jQ("resourceList","List of resources to compare",n=>{for(const s of n){if(s.length!==3)return!1;const[o,h,i]=s;if(!k.URI.isUri(o)||!k.URI.isUri(h)&&h!==void 0&&h!==null||!k.URI.isUri(i)&&i!==void 0&&i!==null)return!1}return!0},n=>n)],p.$kQ.Void),new p.$lQ("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[p.$jQ.Uri,p.$jQ.Position],new p.$kQ("A promise that resolves to an array of TypeHierarchyItem-instances",n=>n.map(a.TypeHierarchyItem.to))),new p.$lQ("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[p.$jQ.TypeHierarchyItem],new p.$kQ("A promise that resolves to an array of TypeHierarchyItem-instances",n=>n.map(a.TypeHierarchyItem.to))),new p.$lQ("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[p.$jQ.TypeHierarchyItem],new p.$kQ("A promise that resolves to an array of TypeHierarchyItem-instances",n=>n.map(a.TypeHierarchyItem.to))),new p.$lQ("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[p.$jQ.TestItem],p.$kQ.Void),new p.$lQ("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[p.$jQ.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],p.$kQ.Void),new p.$lQ("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[p.$jQ.String.with("name","The context key name"),new p.$jQ("value","The context key value",()=>!0,n=>n)],p.$kQ.Void),new p.$lQ("vscode.executeMappedEditsProvider","_executeMappedEditsProvider","Execute Mapped Edits Provider",[p.$jQ.Uri,p.$jQ.StringArray,new p.$jQ("MappedEditsContext","Mapped Edits Context",n=>a.MappedEditsContext.is(n),n=>a.MappedEditsContext.from(n))],new p.$kQ("A promise that resolves to a workspace edit or null",n=>n?a.WorkspaceEdit.to(n):null)),new p.$lQ("vscode.editorChat.start","inlineChat.start","Invoke a new editor chat session",[new p.$jQ("Run arguments","",n=>!0,n=>{if(n)return{initialRange:n.initialRange?a.Range.from(n.initialRange):void 0,initialSelection:R.$wN.isSelection(n.initialSelection)?a.Selection.from(n.initialSelection):void 0,message:n.message,autoSend:n.autoSend,position:n.position?a.Position.from(n.position):void 0}})],p.$kQ.Void)];class u{static register(s){y.forEach(s.registerApiCommand,s),this.a(s)}static a(s){s.registerCommand(!1,"_validateWhenClauses",T.$Ej)}}e.$3nc=u;function E(n){return s=>{if(Array.isArray(s))return s.map(n)}}function d(n){if(!Array.isArray(n))return;const s=[];for(const o of n)O.$Du(o)?s.push(a.DefinitionLink.to(o)):s.push(a.location.to(o));return s}}),define(ke[299],Ce([1,0,2,34]),function(oe,e,w,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rpc=void 0;class k{constructor(A,T,p,a,R){this.a=T,this.b=p,this.c=a;const y=new S.$lQ("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new S.$jQ("showOptions","Show Options",u=>!0,u=>u),new S.$jQ("resource","Interactive resource Uri",u=>!0,u=>u),new S.$jQ("controllerId","Notebook controller Id",u=>!0,u=>u),new S.$jQ("title","Interactive editor title",u=>!0,u=>u)],new S.$kQ("Notebook and input URI",u=>{if(R.debug("[ExtHostInteractive] open iw with notebook editor id",u.notebookEditorId),u.notebookEditorId!==void 0){const E=this.a.getEditorById(u.notebookEditorId);return R.debug("[ExtHostInteractive] notebook editor found",E.id),{notebookUri:w.URI.revive(u.notebookUri),inputUri:w.URI.revive(u.inputUri),notebookEditor:E.apiEditor}}return R.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",u.notebookUri,u.inputUri),{notebookUri:w.URI.revive(u.notebookUri),inputUri:w.URI.revive(u.inputUri)}}));this.c.registerApiCommand(y)}$willAddInteractiveDocument(A,T,p,a){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:T,lines:[""],languageId:p,uri:A,isDirty:!1,versionId:1}]})}$willRemoveInteractiveDocument(A,T){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[A]})}}e.$rpc=k}),define(ke[300],Ce([1,0,18,11,22,6,4,29,2,19,12,5,34,10,7,83,238,25,39,239]),function(oe,e,w,S,k,O,A,T,p,a,R,y,u,E,d,n,s,o,h,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ypc=void 0,e.$zpc=$,E=qe(E);let r=class{constructor(D,v,C,P,g){this.m=v,this.n=C,this.o=P,this.q=g,this.b=new T.$Cc,this.c=new T.$Cc,this.f=new Map,this.g=0,this.h=new Map,this.i=0,this.j=new Map,this.k=0,this.l=new O.$me,this.onDidChangeNotebookCellExecutionState=this.l.event,this.r=0,this.s={},this.a=D.getProxy(y.$rN.MainThreadNotebookKernels);const b=new u.$lQ("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new u.$jQ("options","Select kernel options",N=>!0,N=>{if(N&&"notebookEditor"in N&&"id"in N){const B=this.n.getIdByEditor(N.notebookEditor);return{id:N.id,extension:N.extension,notebookEditorId:B}}else if(N&&"notebookEditor"in N){const B=this.n.getIdByEditor(N.notebookEditor);if(B===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${N.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:B}}return N})],u.$kQ.Void),L=new u.$lQ("vscode.executeNotebookVariableProvider","_executeNotebookVariableProvider","Execute notebook variable provider",[u.$jQ.Uri],new u.$kQ("A promise that resolves to an array of variables",(N,B)=>N.map(G=>({variable:{name:G.name,value:G.value,expression:G.expression,type:G.type,language:G.language},hasNamedChildren:G.hasNamedChildren,indexedChildrenCount:G.indexedChildrenCount}))));this.o.registerApiCommand(b),this.o.registerApiCommand(L)}createNotebookController(D,v,C,P,g,b){for(const se of this.j.values())if(se.controller.id===v&&a.$qn.equals(D.identifier,se.extensionId))throw new Error(`notebook controller with id '${v}' ALREADY exist`);const L=this.k++,N=this;this.q.trace(`NotebookController[${L}], CREATED by ${D.identifier.value}, ${v}`);const B=()=>console.warn(`NO execute handler from notebook controller '${q.id}' of extension: '${D.identifier}'`);let G=!1;const W=new O.$me,F=new O.$me,q={id:$(D.identifier,v),notebookType:C,extensionId:D.identifier,extensionLocation:D.extensionLocation,label:P||D.identifier.value,preloads:b?b.map(E.NotebookRendererScript.from):[]};let ue=g??B,ge,te;this.a.$addKernel(L,q).catch(se=>{console.log(se),G=!0});let me=0;const re=()=>{if(G)return;const se=++me;Promise.resolve().then(()=>{se===me&&this.a.$updateKernel(L,q)})},ce=new T.$Cc,be={get id(){return v},get notebookType(){return q.notebookType},onDidChangeSelectedNotebooks:W.event,get label(){return q.label},set label(se){q.label=se??D.displayName??D.name,re()},get detail(){return q.detail??""},set detail(se){q.detail=se,re()},get description(){return q.description??""},set description(se){q.description=se,re()},get supportedLanguages(){return q.supportedLanguages},set supportedLanguages(se){q.supportedLanguages=se,re()},get supportsExecutionOrder(){return q.supportsExecutionOrder??!1},set supportsExecutionOrder(se){q.supportsExecutionOrder=se,re()},get rendererScripts(){return q.preloads?q.preloads.map(E.NotebookRendererScript.to):[]},get executeHandler(){return ue},set executeHandler(se){ue=se??B},get interruptHandler(){return ge},set interruptHandler(se){ge=se,q.supportsInterrupt=!!se,re()},set variableProvider(se){(0,o.$4G)(D,"notebookVariableProvider"),te=se,q.hasVariableProvider=!!se,se?.onDidChangeVariables(Ie=>N.a.$variablesUpdated(Ie.uri)),re()},get variableProvider(){return te},createNotebookCellExecution(se){if(G)throw new Error("notebook controller is DISPOSED");if(!ce.has(se.notebook.uri))throw N.q.trace(`NotebookController[${L}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(ce.keys()).map(Ie=>Ie.toString())),new Error(`notebook controller is NOT associated to notebook: ${se.notebook.uri.toString()}`);return N._createNotebookCellExecution(se,$(D.identifier,this.id))},createNotebookExecution(se){if((0,o.$4G)(D,"notebookExecution"),G)throw new Error("notebook controller is DISPOSED");if(!ce.has(se.uri))throw N.q.trace(`NotebookController[${L}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(ce.keys()).map(Ie=>Ie.toString())),new Error(`notebook controller is NOT associated to notebook: ${se.uri.toString()}`);return N._createNotebookExecution(se,$(D.identifier,this.id))},dispose:()=>{G||(this.q.trace(`NotebookController[${L}], DISPOSED`),G=!0,this.j.delete(L),W.dispose(),F.dispose(),this.a.$removeKernel(L))},updateNotebookAffinity(se,Ie){Ie===d.NotebookControllerAffinity2.Hidden&&(0,o.$4G)(D,"notebookControllerAffinityHidden"),N.a.$updateNotebookPriority(L,se.uri,Ie)},onDidReceiveMessage:F.event,postMessage(se,Ie){return(0,o.$4G)(D,"notebookMessaging"),N.a.$postMessage(L,Ie&&N.n.getIdByEditor(Ie),se)},asWebviewUri(se){return(0,o.$4G)(D,"notebookMessaging"),(0,n.$XCb)(se,N.m.remote)}};return this.j.set(L,{extensionId:D.identifier,controller:be,onDidReceiveMessage:F,onDidChangeSelection:W,associatedNotebooks:ce}),be}getIdByController(D){for(const[v,C]of this.j)if(C.controller===D)return $(C.extensionId,D.id);return null}createNotebookControllerDetectionTask(D,v){const C=this.g++,P=this;this.q.trace(`NotebookControllerDetectionTask[${C}], CREATED by ${D.identifier.value}`),this.a.$addKernelDetectionTask(C,v);const g={dispose:()=>{this.f.delete(C),P.a.$removeKernelDetectionTask(C)}};return this.f.set(C,g),g}registerKernelSourceActionProvider(D,v,C){const P=this.i++,g=typeof C.onDidChangeNotebookKernelSourceActions=="function"?P:void 0,b=this;this.h.set(P,C),this.q.trace(`NotebookKernelSourceActionProvider[${P}], CREATED by ${D.identifier.value}`),this.a.$addKernelSourceActionProvider(P,P,v);let L;return g!==void 0&&(L=C.onDidChangeNotebookKernelSourceActions(N=>this.a.$emitNotebookKernelSourceActionsChangeEvent(g))),{dispose:()=>{this.h.delete(P),b.a.$removeKernelSourceActionProvider(P,P),L?.dispose()}}}async $provideKernelSourceActions(D,v){const C=this.h.get(D);if(C){const P=new A.$Vc;return(await C.provideNotebookKernelSourceActions(v)??[]).map(b=>E.NotebookKernelSourceAction.from(b,this.o.converter,P))}return[]}$acceptNotebookAssociation(D,v,C){const P=this.j.get(D);if(P){const g=this.n.getNotebookDocument(p.URI.revive(v));C?P.associatedNotebooks.set(g.uri,!0):P.associatedNotebooks.delete(g.uri),this.q.trace(`NotebookController[${D}] ASSOCIATE notebook`,g.uri.toString(),C),P.onDidChangeSelection.fire({selected:C,notebook:g.apiNotebook})}}async $executeCells(D,v,C){const P=this.j.get(D);if(!P)return;const g=this.n.getNotebookDocument(p.URI.revive(v)),b=[];for(const L of C){const N=g.getCell(L);N&&b.push(N.apiCell)}try{this.q.trace(`NotebookController[${D}] EXECUTE cells`,g.uri.toString(),b.length),await P.controller.executeHandler.call(P.controller,b,g.apiNotebook,P.controller)}catch(L){this.q.error(`NotebookController[${D}] execute cells FAILED`,L),console.error(L)}}async $cancelCells(D,v,C){const P=this.j.get(D);if(!P)return;const g=this.n.getNotebookDocument(p.URI.revive(v));if(P.controller.interruptHandler)await P.controller.interruptHandler.call(P.controller,g.apiNotebook);else for(const b of C){const L=g.getCell(b);L&&this.b.get(L.uri)?.cancel()}if(P.controller.interruptHandler){const b=this.c.get(g.uri);this.c.delete(g.uri),C.length&&Array.isArray(b)&&b.length&&b.forEach(L=>L.dispose())}}async $provideVariables(D,v,C,P,g,b,L){const N=this.j.get(D);if(!N)return;const B=this.n.getNotebookDocument(p.URI.revive(C)),G=N.controller.variableProvider;if(!G)return;let W;if(P!==void 0){if(W=this.s[P],!W)return}else this.s={};const F=g==="named"?d.NotebookVariablesRequestKind.Named:d.NotebookVariablesRequestKind.Indexed,q=G.provideVariables(B.apiNotebook,W,F,b,L);let ue=0;for await(const ge of q){if(L.isCancellationRequested)return;const te={id:this.r++,name:ge.variable.name,value:ge.variable.value,type:ge.variable.type,interfaces:ge.variable.interfaces,language:ge.variable.language,expression:ge.variable.expression,hasNamedChildren:ge.hasNamedChildren,indexedChildrenCount:ge.indexedChildrenCount,extensionId:N.extensionId.value};if(this.s[te.id]=ge.variable,this.a.$receiveVariable(v,te),ue++>=i.$TK)return}}$acceptKernelMessageFromRenderer(D,v,C){const P=this.j.get(D);if(!P)return;const g=this.n.getEditorById(v);P.onDidReceiveMessage.fire(Object.freeze({editor:g.apiEditor,message:C}))}$cellExecutionChanged(D,v,C){const g=this.n.getNotebookDocument(p.URI.revive(D)).getCell(v);if(g){const b=C?E.NotebookCellExecutionState.to(C):d.NotebookCellExecutionState.Idle;b!==void 0&&this.l.fire({cell:g.apiCell,state:b})}}_createNotebookCellExecution(D,v){if(D.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const P=this.n.getNotebookDocument(D.notebook.uri).getCellFromApiCell(D);if(!P)throw new Error("invalid cell");if(this.b.has(P.uri))throw new Error(`duplicate execution for ${P.uri}`);const g=new c(v,P,this.a);this.b.set(P.uri,g);const b=g.onDidChangeState(()=>{g.state===t.Resolved&&(g.dispose(),b.dispose(),this.b.delete(P.uri))});return g.asApiObject()}_createNotebookExecution(D,v){const C=this.n.getNotebookDocument(D.uri),P=D.getCells().find(L=>{const N=C.getCellFromApiCell(L);return N&&this.b.has(N.uri)});if(P)throw new Error(`duplicate cell execution for ${P.document.uri}`);if(this.c.has(C.uri))throw new Error(`duplicate notebook execution for ${C.uri}`);const g=new m(v,C,this.a),b=g.onDidChangeState(()=>{g.state===l.Resolved&&(g.dispose(),b.dispose(),this.c.delete(C.uri))});return this.c.set(C.uri,[g,b]),g.asApiObject()}};e.$ypc=r,e.$ypc=r=He([Ve(4,R.$_j)],r);var t;(function(I){I[I.Init=0]="Init",I[I.Started=1]="Started",I[I.Resolved=2]="Resolved"})(t||(t={}));class c extends A.$Wc{static{this.a=0}get state(){return this.f}constructor(D,v,C){super(),this.m=v,this.n=C,this.b=c.a++,this.c=new O.$me,this.onDidChangeState=this.c.event,this.f=t.Init,this.g=this.B(new k.$xe),this.h=new f(10,P=>this.s(P)),this.j=v.internalMetadata.executionOrder,this.n.$createExecution(this.b,D,this.m.notebook.uri,this.m.handle)}cancel(){this.g.cancel()}async r(D){await this.h.addItem(D)}async s(D){const v=Array.isArray(D)?D:[D];return this.n.$updateExecution(this.b,new h.$Pw(v))}t(){if(this.f===t.Init)throw new Error("Must call start before modifying cell output");if(this.f===t.Resolved)throw new Error("Cannot modify cell output after calling resolve")}w(D){let v=this.m;if(D&&(v=this.m.notebook.getCellFromApiCell(D)),!v)throw new Error("INVALID cell");return v.handle}y(D){return D.map(v=>{const C=d.$ZO.ensureUniqueMimeTypes(v.items,!0);return C===v.items?E.NotebookCellOutput.from(v):E.NotebookCellOutput.from({items:C,id:v.id,metadata:v.metadata})})}async z(D,v,C){const P=this.w(v),g=this.y((0,w.$4b)(D));return this.r({editType:s.CellExecutionUpdateType.Output,cellHandle:P,append:C,outputs:g})}async C(D,v,C){return D=d.$ZO.ensureUniqueMimeTypes((0,w.$4b)(D),!0),this.r({editType:s.CellExecutionUpdateType.OutputItems,items:D.map(E.NotebookCellOutputItem.from),outputId:v.id,append:C})}asApiObject(){const D=this;return Object.freeze({get token(){return D.g.token},get cell(){return D.m.apiCell},get executionOrder(){return D.j},set executionOrder(C){D.j=C,D.s([{editType:s.CellExecutionUpdateType.ExecutionState,executionOrder:D.j}])},start(C){if(D.f===t.Resolved||D.f===t.Started)throw new Error("Cannot call start again");D.f=t.Started,D.c.fire(),D.s({editType:s.CellExecutionUpdateType.ExecutionState,runStartTime:C})},end(C,P,g){if(D.f===t.Resolved)throw new Error("Cannot call resolve twice");D.f=t.Resolved,D.c.fire(),D.h.flush();const b=g?{message:g.message,stack:g.stack,location:g?.location?{startLineNumber:g.location.start.line,startColumn:g.location.start.character,endLineNumber:g.location.end.line,endColumn:g.location.end.character}:void 0,uri:g.uri}:void 0;D.n.$completeExecution(D.b,new h.$Pw({runEndTime:P,lastRunSuccess:C,error:b}))},clearOutput(C){return D.t(),D.z([],C,!1)},appendOutput(C,P){return D.t(),D.z(C,P,!0)},replaceOutput(C,P){return D.t(),D.z(C,P,!1)},appendOutputItems(C,P){return D.t(),D.C(C,P,!0)},replaceOutputItems(C,P){return D.t(),D.C(C,P,!1)}})}}var l;(function(I){I[I.Init=0]="Init",I[I.Started=1]="Started",I[I.Resolved=2]="Resolved"})(l||(l={}));class m extends A.$Wc{static{this.a=0}get state(){return this.f}constructor(D,v,C){super(),this.h=v,this.j=C,this.b=m.a++,this.c=new O.$me,this.onDidChangeState=this.c.event,this.f=l.Init,this.g=this.B(new k.$xe),this.j.$createNotebookExecution(this.b,D,this.h.uri)}cancel(){this.g.cancel()}asApiObject(){return Object.freeze({start:()=>{if(this.f===l.Resolved||this.f===l.Started)throw new Error("Cannot call start again");this.f=l.Started,this.c.fire(),this.j.$beginNotebookExecution(this.b)},end:()=>{if(this.f===l.Resolved)throw new Error("Cannot call resolve twice");this.f=l.Resolved,this.c.fire(),this.j.$completeNotebookExecution(this.b)}})}}class f{constructor(D,v){this.f=D,this.g=v,this.a=[],this.b=Date.now()}addItem(D){return this.a.push(D),this.c||(this.c=new S.$3h,this.b=Date.now(),(0,S.$Gh)(this.f).then(()=>this.flush())),Date.now()-this.b>this.f?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const D=this.c;this.c=void 0;const v=this.a;return this.a=[],this.g(v).finally(()=>D.complete())}}function $(I,D){return`${I.value}/${D}`}}),define(ke[57],Ce([1,0,6,5,3,2,17,4,7,188,14,219,22,37,220,221,35,11,10,34,38]),function(oe,e,w,S,k,O,A,T,p,a,R,y,u,E,d,n,s,o,h,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hoc=e.$Goc=e.$Foc=e.$Eoc=void 0,e.$Eoc=(0,k.$Fi)("IExtHostTerminalService");class t extends T.$Wc{constructor(g,b,L,N){super(),this.u=g,this._id=b,this.w=L,this.y=N,this.a=!1,this.m={isInteractedWith:!1},this.isOpen=!1,this.s=this.B(new w.$me),this.onWillDispose=this.s.event,this.w=Object.freeze(this.w),this.b=new Promise(G=>this.g=G);const B=this;this.value={get name(){return B.y||""},get processId(){return B.b},get creationOptions(){return B.w},get exitStatus(){return B.j},get state(){return B.m},get selection(){return B.n},get shellIntegration(){return B.shellIntegration},sendText(G,W=!0){B.C(),B.u.$sendText(B._id,G,W)},show(G){B.C(),B.u.$show(B._id,G)},hide(){B.C(),B.u.$hide(B._id)},dispose(){B.a||(B.a=!0,B.u.$dispose(B._id))},get dimensions(){if(!(B.f===void 0||B.h===void 0))return{columns:B.f,rows:B.h}}}}dispose(){this.s.fire(),super.dispose()}async create(g,b){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.u.$createTerminal(this._id,{name:g.name,shellPath:g.shellPath??void 0,shellArgs:g.shellArgs??void 0,cwd:g.cwd??b?.cwd??void 0,env:g.env??void 0,icon:D(g.iconPath)??void 0,color:s.ThemeColor.isThemeColor(g.color)?g.color.id:void 0,initialText:g.message??void 0,strictEnv:g.strictEnv??void 0,hideFromUser:g.hideFromUser??void 0,forceShellIntegration:b?.forceShellIntegration??void 0,isFeatureTerminal:b?.isFeatureTerminal??void 0,isExtensionOwnedTerminal:!0,useShellEnvironment:b?.useShellEnvironment??void 0,location:b?.location||this.z(g.location,b?.resolvedExtHostIdentifier),isTransient:g.isTransient??void 0})}async createExtensionTerminal(g,b,L,N,B){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.u.$createTerminal(this._id,{name:this.y,isExtensionCustomPtyTerminal:!0,icon:N,color:s.ThemeColor.isThemeColor(B)?B.id:void 0,location:b?.location||this.z(g,L),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}z(g,b){return typeof g=="object"?"parentTerminal"in g&&g.parentTerminal&&b?{parentTerminal:b}:"viewColumn"in g?{viewColumn:h.ViewColumn.from(g.viewColumn),preserveFocus:g.preserveFocus}:void 0:g}C(){if(this.a)throw new Error("Terminal has already been disposed")}set name(g){this.y=g}setExitStatus(g,b){this.j=Object.freeze({code:g,reason:b})}setDimensions(g,b){return g===this.f&&b===this.h||g===0||b===0?!1:(this.f=g,this.h=b,!0)}setInteractedWith(){return this.m.isInteractedWith?!1:(this.m={isInteractedWith:!0},!0)}setSelection(g){this.n=g}_setProcessId(g){this.g?(this.g(g),this.g=void 0):this.b.then(b=>{b!==g&&(this.b=Promise.resolve(g))})}}e.$Foc=t;class c{get onProcessReady(){return this.b.event}constructor(g){this.g=g,this.id=0,this.shouldPersist=!1,this.a=new w.$me,this.onProcessData=this.a.event,this.b=new w.$me,this.d=new w.$me,this.onDidChangeProperty=this.d.event,this.f=new w.$me,this.onProcessExit=this.f.event}refreshProperty(g){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${g}`)}updateProperty(g,b){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${g}, value: ${b}`)}async start(){}shutdown(){this.g.close()}input(g){this.g.handleInput?.(g)}resize(g,b){this.g.setDimensions?.({columns:g,rows:b})}clearBuffer(){}async processBinary(g){}acknowledgeDataEvent(g){}async setUnicodeVersion(g){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}startSendingEvents(g){this.g.onDidWrite(b=>this.a.fire(b)),this.g.onDidClose?.((b=void 0)=>{this.f.fire(b===void 0?void 0:b)}),this.g.onDidOverrideDimensions?.(b=>{b&&this.d.fire({type:d.ProcessPropertyType.OverrideDimensions,value:{cols:b.columns,rows:b.rows}})}),this.g.onDidChangeName?.(b=>{this.d.fire({type:d.ProcessPropertyType.Title,value:b})}),this.g.open(g||void 0),g&&this.g.setDimensions?.(g),this.b.fire({pid:-1,cwd:"",windowsPty:void 0})}}let l=1,m=class extends T.$Wc{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map(g=>g.value)}constructor(g,b,L){super(),this.Q=b,this.f=[],this.g=new Map,this.h={},this.j={},this.m={},this.n=new Map,this.w=this.B(new T.$Xc),this.z=new Set,this.C=new Map,this.D=new Map,this.F=new Map,this.G=new Map,this.H=new w.$me,this.onDidCloseTerminal=this.H.event,this.I=new w.$me,this.onDidOpenTerminal=this.I.event,this.J=new w.$me,this.onDidChangeActiveTerminal=this.J.event,this.L=new w.$me,this.onDidChangeTerminalDimensions=this.L.event,this.M=new w.$me,this.onDidChangeTerminalState=this.M.event,this.N=new w.$me,this.onDidChangeShell=this.N.event,this.O=new w.$me({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.onDidWriteTerminalData=this.O.event,this.P=new w.$me({onWillAddFirstListener:()=>this.a.$startSendingCommandEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingCommandEvents()}),this.onDidExecuteTerminalCommand=this.P.event,this.a=L.getProxy(S.$rN.MainThreadTerminalService),this.y=new n.$exb(this.a.$sendProcessData),this.a.$registerProcessSupport(g),this.Q.registerArgumentProcessor({processArgument:N=>{const B=G=>{const W=G;return this.getTerminalById(W.instanceId)?.value};switch(N?.$mid){case r.MarshalledId.TerminalContext:return B(N);default:{if(Array.isArray(N))for(let G=0;G<N.length&&N[G].$mid===r.MarshalledId.TerminalContext;G++)N[G]=B(N[G]);return N}}}}),this.B({dispose:()=>{for(const[N,B]of this.g)B.shutdown(!0)}})}getDefaultShell(g){return(g?this.u:this.s)?.path||""}getDefaultShellArgs(g){return(g?this.u:this.s)?.args||[]}createExtensionTerminal(g,b){const L=new t(this.a,(0,E.$2g)(),g,g.name),N=new c(g.pty);return L.createExtensionTerminal(g.location,b,this.R(g,b).resolvedExtHostIdentifier,D(g.iconPath),v(g.color)).then(B=>{const G=this.S(B,N);this.h[B]=G}),this.f.push(L),L.value}R(g,b){if(b=b||{},g.location&&typeof g.location=="object"&&"parentTerminal"in g.location){const L=g.location.parentTerminal;if(L){const N=this.f.find(B=>B.value===L);N&&(b.resolvedExtHostIdentifier=N._id)}}else g.location&&typeof g.location!="object"?b.location=g.location:b.location&&typeof b.location=="object"&&"splitActiveTerminal"in b.location&&(b.location={splitActiveTerminal:!0});return b}attachPtyToTerminal(g,b){if(!this.getTerminalById(g))throw new Error(`Cannot resolve terminal with id ${g} for virtual process`);const N=new c(b),B=this.S(g,N);this.h[g]=B}async $acceptActiveTerminalChanged(g){const b=this.b;if(g===null){this.b=void 0,b!==this.b&&this.J.fire(this.b);return}const L=this.getTerminalById(g);L&&(this.b=L,b!==this.b&&this.J.fire(this.b.value))}async $acceptTerminalProcessData(g,b){const L=this.getTerminalById(g);L&&this.O.fire({terminal:L.value,data:b})}async $acceptTerminalDimensions(g,b,L){const N=this.getTerminalById(g);N&&N.setDimensions(b,L)&&this.L.fire({terminal:N.value,dimensions:N.value.dimensions})}async $acceptDidExecuteCommand(g,b){const L=this.getTerminalById(g);L&&this.P.fire({terminal:L.value,...b})}async $acceptTerminalMaximumDimensions(g,b,L){this.g.get(g)?.resize(b,L)}async $acceptTerminalTitleChange(g,b){const L=this.getTerminalById(g);L&&(L.name=b)}async $acceptTerminalClosed(g,b,L){const N=this.X(this.f,g);if(N!==null){const B=this.f.splice(N,1)[0];B.setExitStatus(b,L),this.H.fire(B.value)}}$acceptTerminalOpened(g,b,L,N){if(b){const W=this.X(this.f,b);if(W!==null){this.f[W]._id=g,this.I.fire(this.terminals[W]),this.f[W].isOpen=!0;return}}const B={name:N.name,shellPath:N.executable,shellArgs:N.args,cwd:typeof N.cwd=="string"?N.cwd:O.URI.revive(N.cwd),env:N.env,hideFromUser:N.hideFromUser},G=new t(this.a,g,B,L);this.f.push(G),this.I.fire(G.value),G.isOpen=!0}async $acceptTerminalProcessId(g,b){this.getTerminalById(g)?._setProcessId(b)}async $startExtensionTerminal(g,b){const L=this.getTerminalById(g);if(!L)return{message:(0,a.localize)(0,null,g)};L.isOpen||await new Promise(B=>{const G=this.onDidOpenTerminal(async W=>{W===L.value&&(G.dispose(),B())})});const N=this.g.get(g);N?N.startSendingEvents(b):this.j[g]={initialDimensions:b}}S(g,b){const L=new T.$Vc;L.add(b.onProcessReady(B=>this.a.$sendProcessReady(g,B.pid,B.cwd,B.windowsPty))),L.add(b.onDidChangeProperty(B=>this.a.$sendProcessProperty(g,B))),this.y.startBuffering(g,b.onProcessData),L.add(b.onProcessExit(B=>this.U(g,B))),this.g.set(g,b);const N=this.j[g];return N&&b instanceof c&&(b.startSendingEvents(N.initialDimensions),delete this.j[g]),L}$acceptProcessAckDataEvent(g,b){this.g.get(g)?.acknowledgeDataEvent(b)}$acceptProcessInput(g,b){this.g.get(g)?.input(b)}$acceptTerminalInteraction(g){const b=this.getTerminalById(g);b?.setInteractedWith()&&this.M.fire(b.value)}$acceptTerminalSelection(g,b){this.getTerminalById(g)?.setSelection(b)}$acceptProcessResize(g,b,L){try{this.g.get(g)?.resize(b,L)}catch(N){if(N.code!=="EPIPE"&&N.code!=="ERR_IPC_CHANNEL_CLOSED")throw N}}$acceptProcessShutdown(g,b){this.g.get(g)?.shutdown(b)}$acceptProcessRequestInitialCwd(g){this.g.get(g)?.getInitialCwd().then(b=>this.a.$sendProcessProperty(g,{type:d.ProcessPropertyType.InitialCwd,value:b}))}$acceptProcessRequestCwd(g){this.g.get(g)?.getCwd().then(b=>this.a.$sendProcessProperty(g,{type:d.ProcessPropertyType.Cwd,value:b}))}$acceptProcessRequestLatency(g){return Promise.resolve(g)}registerLinkProvider(g){return this.z.add(g),this.z.size===1&&this.a.$startLinkProvider(),new p.$tN(()=>{this.z.delete(g),this.z.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider(g,b,L){if(this.C.has(b))throw new Error(`Terminal profile provider "${b}" already registered`);return this.C.set(b,L),this.a.$registerProfileProvider(b,g.identifier.value),new p.$tN(()=>{this.C.delete(b),this.a.$unregisterProfileProvider(b)})}registerTerminalQuickFixProvider(g,b,L){if(this.D.has(g))throw new Error(`Terminal quick fix provider "${g}" is already registered`);return this.D.set(g,L),this.a.$registerQuickFixProvider(g,b),new p.$tN(()=>{this.D.delete(g),this.a.$unregisterQuickFixProvider(g)})}async $provideTerminalQuickFixes(g,b){const L=new u.$xe().token;if(L.isCancellationRequested)return;const N=this.D.get(g);if(!N)return;const B=await N.provideTerminalQuickFixes(b,L);if(B===null||Array.isArray(B)&&B.length===0)return;const G=new T.$Vc;if(this.w.value=G,!Array.isArray(B))return B?h.TerminalQuickFix.from(B,this.Q.converter,G):void 0;const W=[];for(const F of B){const q=h.TerminalQuickFix.from(F,this.Q.converter,G);q&&W.push(q)}return W}async $createContributedProfileTerminal(g,b){const L=new u.$xe().token;let N=await this.C.get(g)?.provideTerminalProfile(L);if(!L.isCancellationRequested){if(N&&!("options"in N)&&(N={options:N}),!N||!("options"in N))throw new Error(`No terminal profile options provided for id "${g}"`);if("pty"in N.options){this.createExtensionTerminal(N.options,b);return}this.createTerminalFromOptions(N.options,b)}}async $provideLinks(g,b){const L=this.getTerminalById(g);if(!L)return[];this.F.delete(g),this.G.get(g)?.dispose(!0);const B=new u.$xe;this.G.set(g,B);const G=[],W={terminal:L.value,line:b},F=[];for(const ge of this.z)F.push(o.Promises.withAsyncBody(async te=>{B.token.onCancellationRequested(()=>te({provider:ge,links:[]}));const me=await ge.provideTerminalLinks(W,B.token)||[];B.token.isCancellationRequested||te({provider:ge,links:me})}));const q=await Promise.all(F);if(B.token.isCancellationRequested)return[];const ue=new Map;for(const ge of q)ge&&ge.links.length>0&&G.push(...ge.links.map(te=>{const me={id:l++,startIndex:te.startIndex,length:te.length,label:te.tooltip};return ue.set(me.id,{provider:ge.provider,link:te}),me}));return this.F.set(g,ue),G}$activateLink(g,b){const L=this.F.get(g)?.get(b);L&&L.provider.handleTerminalLink(L.link)}U(g,b){this.y.stopBuffering(g),this.g.delete(g),delete this.j[g];const L=this.h[g];L&&(L.dispose(),delete this.h[g]),this.a.$sendProcessExit(g,b)}getTerminalById(g){return this.W(this.f,g)}getTerminalIdByApiObject(g){const b=this.f.findIndex(L=>L.value===g);return b>=0?b:null}W(g,b){const L=this.X(g,b);return L!==null?g[L]:null}X(g,b){const L=g.findIndex(N=>N._id===b);return L>=0?L:null}getEnvironmentVariableCollection(g){let b=this.n.get(g.identifier.value);return b||(b=this.B(new f),this.Z(g.identifier.value,b)),b.getScopedEnvironmentVariableCollection(void 0)}Y(g,b){const L=(0,y.$ys)(b.map),N=(0,y.$zs)(b.descriptionMap);this.a.$setEnvironmentVariableCollection(g,b.persistent,L.length===0?void 0:L,N)}$initEnvironmentVariableCollections(g){g.forEach(b=>{const L=b[0],N=this.B(new f(b[1]));this.Z(L,N)})}$acceptDefaultProfile(g,b){const L=this.s;this.s=g,this.u=b,L?.path!==g.path&&this.N.fire(g.path)}Z(g,b){this.n.set(g,b),this.B(b.onDidChangeCollection(()=>{this.Y(g,b)}))}};e.$Goc=m,e.$Goc=m=He([Ve(1,i.$hQ),Ve(2,A.$XP)],m);class f extends T.$Wc{get persistent(){return this.b}set persistent(g){this.b=g,this.f.fire()}get onDidChangeCollection(){return this.f&&this.f.event}constructor(g){super(),this.map=new Map,this.a=new Map,this.descriptionMap=new Map,this.b=!0,this.f=new w.$me,this.map=new Map(g)}getScopedEnvironmentVariableCollection(g){const b=this.j(g);let L=this.a.get(b);return L||(L=new $(this,g),this.a.set(b,L),this.B(L.onDidChangeCollection(()=>this.f.fire()))),L}replace(g,b,L,N){this.g(g,{value:b,type:p.EnvironmentVariableMutatorType.Replace,options:L??{applyAtProcessCreation:!0},scope:N})}append(g,b,L,N){this.g(g,{value:b,type:p.EnvironmentVariableMutatorType.Append,options:L??{applyAtProcessCreation:!0},scope:N})}prepend(g,b,L,N){this.g(g,{value:b,type:p.EnvironmentVariableMutatorType.Prepend,options:L??{applyAtProcessCreation:!0},scope:N})}g(g,b){if(b.options&&b.options.applyAtProcessCreation===!1&&!b.options.applyAtShellIntegration)throw new Error("EnvironmentVariableMutatorOptions must apply at either process creation or shell integration");const L=this.h(g,b.scope),N=this.map.get(L),B=b.options?{applyAtProcessCreation:b.options.applyAtProcessCreation??!1,applyAtShellIntegration:b.options.applyAtShellIntegration??!1}:{applyAtProcessCreation:!0};if(!N||N.value!==b.value||N.type!==b.type||N.options?.applyAtProcessCreation!==B.applyAtProcessCreation||N.options?.applyAtShellIntegration!==B.applyAtShellIntegration||N.scope?.workspaceFolder?.index!==b.scope?.workspaceFolder?.index){const G=this.h(g,b.scope),W={variable:g,...b,options:B};this.map.set(G,W),this.f.fire()}}get(g,b){const L=this.h(g,b),N=this.map.get(L);return N?C(N):void 0}h(g,b){const L=this.j(b);return L.length?`${g}:::${L}`:g}j(g){return this.m(g?.workspaceFolder)??""}m(g){return g?g.uri.toString():void 0}getVariableMap(g){const b=new Map;for(const[L,N]of this.map)this.j(N.scope)===this.j(g)&&b.set(N.variable,C(N));return b}delete(g,b){const L=this.h(g,b);this.map.delete(L),this.f.fire()}clear(g){if(g?.workspaceFolder){for(const[b,L]of this.map)L.scope?.workspaceFolder?.index===g.workspaceFolder.index&&this.map.delete(b);this.n(g)}else this.map.clear(),this.descriptionMap.clear();this.f.fire()}setDescription(g,b){const L=this.j(b),N=this.descriptionMap.get(L);if(!N||N.description!==g){let B;typeof g=="string"?B=g:B=g?.value.split(`

`)[0];const G={description:B,scope:b};this.descriptionMap.set(L,G),this.f.fire()}}getDescription(g){const b=this.j(g);return this.descriptionMap.get(b)?.description}n(g){const b=this.j(g);this.descriptionMap.delete(b)}}class ${get persistent(){return this.b.persistent}set persistent(g){this.b.persistent=g}get onDidChangeCollection(){return this.a&&this.a.event}constructor(g,b){this.b=g,this.d=b,this.a=new w.$me}getScoped(g){return this.b.getScopedEnvironmentVariableCollection(g)}replace(g,b,L){this.b.replace(g,b,L,this.d)}append(g,b,L){this.b.append(g,b,L,this.d)}prepend(g,b,L){this.b.prepend(g,b,L,this.d)}get(g){return this.b.get(g,this.d)}forEach(g,b){this.b.getVariableMap(this.d).forEach((L,N)=>g.call(b,N,L,this),this.d)}[Symbol.iterator](){return this.b.getVariableMap(this.d).entries()}delete(g){this.b.delete(g,this.d),this.a.fire(void 0)}clear(){this.b.clear(this.d)}set description(g){this.b.setDescription(g,this.d)}get description(){return this.b.getDescription(this.d)}}let I=class extends m{constructor(g,b){super(!1,g,b)}createTerminal(g,b,L){throw new R.$bb}createTerminalFromOptions(g,b){throw new R.$bb}};e.$Hoc=I,e.$Hoc=I=He([Ve(0,i.$hQ),Ve(1,A.$XP)],I);function D(P){if(!(!P||typeof P=="string"))return"id"in P?{id:P.id,color:P.color}:P}function v(P){return s.ThemeColor.isThemeColor(P)?P:void 0}function C(P){const g={...P};return delete g.scope,g.options=g.options??void 0,delete g.variable,g}}),define(ke[125],Ce([1,0,7,4,3,5,17,57,6,2,11]),function(oe,e,w,S,k,O,A,T,p,a,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rpc=e.$Qpc=void 0,e.$Qpc=(0,k.$Fi)("IExtHostTerminalShellIntegration");let y=class extends S.$Wc{constructor(s,o){super(),this.h=o,this.b=new Map,this.c=new p.$me,this.onDidChangeTerminalShellIntegration=this.c.event,this.f=new p.$me,this.onDidStartTerminalShellExecution=this.f.event,this.g=new p.$me,this.onDidEndTerminalShellExecution=this.g.event,this.a=s.getProxy(O.$rN.MainThreadTerminalShellIntegration),this.B((0,S.$Uc)(()=>{for(const[h,i]of this.b)i.dispose();this.b.clear()}))}$shellIntegrationChange(s){const o=this.h.getTerminalById(s);if(!o)return;const h=o.value;let i=this.b.get(s);i||(i=new u(o.value,this.f),this.b.set(s,i),i.store.add(o.onWillDispose(()=>this.b.get(s)?.dispose())),i.store.add(i.onDidRequestShellExecution(r=>this.a.$executeCommand(s,r))),i.store.add(i.onDidRequestEndExecution(r=>this.g.fire(r))),i.store.add(i.onDidRequestChangeShellIntegration(r=>this.c.fire(r))),o.shellIntegration=i.value),this.c.fire({terminal:h,shellIntegration:i.value})}$shellExecutionStart(s,o,h,i,r){this.b.has(s)||this.$shellIntegrationChange(s);const t={value:o,confidence:h,isTrusted:i};this.b.get(s)?.startShellExecution(t,r)}$shellExecutionEnd(s,o,h,i,r){const t={value:o,confidence:h,isTrusted:i};this.b.get(s)?.endShellExecution(t,r)}$shellExecutionData(s,o){this.b.get(s)?.emitData(o)}$cwdChange(s,o){this.b.get(s)?.setCwd((0,a.$xc)(o)?a.URI.revive(o):o)}$closeTerminal(s){this.b.get(s)?.dispose(),this.b.delete(s)}};e.$Rpc=y,e.$Rpc=y=He([Ve(0,A.$XP),Ve(1,T.$Eoc)],y);class u extends S.$Wc{get currentExecution(){return this.a}constructor(s,o){super(),this.j=s,this.m=o,this.b=!1,this.store=this.B(new S.$Vc),this.f=this.B(new p.$me),this.onDidRequestChangeShellIntegration=this.f.event,this.g=this.B(new p.$me),this.onDidRequestShellExecution=this.g.event,this.h=this.B(new p.$me),this.onDidRequestEndExecution=this.h.event;const h=this;this.value={get cwd(){return h.c},executeCommand(i,r){let t=i;r&&(t+=` "${r.map(m=>`${m.replaceAll('"','\\"')}`).join('" "')}"`),h.g.fire(t);const c={value:t,confidence:w.TerminalShellExecutionCommandLineConfidence.High,isTrusted:!0},l=h.startShellExecution(c,h.c,!0).value;return h.b=!0,l}}}startShellExecution(s,o,h){if(this.b&&this.a)this.b=!1;else{this.a&&(this.a.endExecution(void 0),this.h.fire({terminal:this.j,shellIntegration:this.value,execution:this.a.value,exitCode:void 0}));const i=this.a=new E(s,o);h?queueMicrotask(()=>this.m.fire({terminal:this.j,shellIntegration:this.value,execution:i.value})):this.m.fire({terminal:this.j,shellIntegration:this.value,execution:this.a.value})}return this.a}emitData(s){this.currentExecution?.emitData(s)}endShellExecution(s,o){this.a&&(this.a.endExecution(s),this.h.fire({terminal:this.j,shellIntegration:this.value,execution:this.a.value,exitCode:o}),this.a=void 0)}setCwd(s){let o=!1;a.URI.isUri(this.c)?o=!a.URI.isUri(s)||this.c.toString()!==s.toString():this.c!==s&&(o=!0),o&&(this.c=s,this.f.fire({terminal:this.j,shellIntegration:this.value}))}}class E{constructor(s,o){this.c=s,this.cwd=o,this.b=!1;const h=this;this.value={get commandLine(){return h.c},get cwd(){return h.cwd},read(){return h.d()}}}d(){if(!this.a){if(this.b)return R.$6h.EMPTY;this.a=new d}return this.a.createIterable()}emitData(s){this.a?.emitData(s)}endExecution(s){s&&(this.c=s),this.a?.endExecution(),this.a=void 0,this.b=!0}}class d extends S.$Wc{constructor(){super(...arguments),this.b=[]}createIterable(){this.a||(this.a=new R.$Eh);const s=this.a;return new R.$6h(async h=>{this.b.push(h),await s.wait()})}emitData(s){for(const o of this.b)o.emitOne(s)}endExecution(){this.a?.open(),this.a=void 0}}}),define(ke[126],Ce([1,0,62,14,97,10,7]),function(oe,e,w,S,k,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7P=e.$6P=e.$5P=void 0,O=qe(O);class T{static{this.c=new k.$3P("TextEditorDecorationType")}constructor(u,E,d){const n=T.c.nextId();u.$registerTextEditorDecorationType(E.identifier,n,O.DecorationRenderOptions.from(d)),this.value=Object.freeze({key:n,dispose(){u.$removeTextEditorDecorationType(n)}})}}e.$5P=T;class p{constructor(u,E){this.g=[],this.h=void 0,this.j=!1,this.c=u,this.d=u.version,this.e=E.undoStopBefore,this.f=E.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(u,E){this.k();let d=null;if(u instanceof A.$uN)d=new A.$vN(u,u);else if(u instanceof A.$vN)d=u;else throw new Error("Unrecognized location");this.l(d,E,!1)}insert(u,E){this.k(),this.l(new A.$vN(u,u),E,!0)}delete(u){this.k();let E=null;if(u instanceof A.$vN)E=u;else throw new Error("Unrecognized location");this.l(E,null,!0)}l(u,E,d){const n=this.c.validateRange(u);this.g.push({range:n,text:E,forceMoveMarkers:d})}setEndOfLine(u){if(this.k(),u!==A.EndOfLine.LF&&u!==A.EndOfLine.CRLF)throw(0,S.$9)("endOfLine");this.h=u}}class a{constructor(u,E,d,n){this.c=u,this.d=E,this._accept(d),this.e=n;const s=this;this.value={get tabSize(){return s.f},set tabSize(o){s.n(o)},get indentSize(){return s.g},set indentSize(o){s.p(o)},get insertSpaces(){return s.j},set insertSpaces(o){s.s(o)},get cursorStyle(){return s.k},set cursorStyle(o){s.t(o)},get lineNumbers(){return s.l},set lineNumbers(o){s.u(o)}}}_accept(u){this.f=u.tabSize,this.g=u.indentSize,this.h=u.originalIndentSize,this.j=u.insertSpaces,this.k=u.cursorStyle,this.l=O.TextEditorLineNumbersStyle.to(u.lineNumbers)}m(u){if(u==="auto")return"auto";if(typeof u=="number"){const E=Math.floor(u);return E>0?E:null}if(typeof u=="string"){const E=parseInt(u,10);return isNaN(E)?null:E>0?E:null}return null}n(u){const E=this.m(u);if(E!==null){if(typeof E=="number"){if(this.f===E)return;this.f=E}this.v("setTabSize",this.c.$trySetOptions(this.d,{tabSize:E}))}}o(u){if(u==="tabSize")return"tabSize";if(typeof u=="number"){const E=Math.floor(u);return E>0?E:null}if(typeof u=="string"){const E=parseInt(u,10);return isNaN(E)?null:E>0?E:null}return null}p(u){const E=this.o(u);if(E!==null){if(typeof E=="number"){if(this.h===E)return;this.g=E,this.h=E}this.v("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:E}))}}q(u){return u==="auto"?"auto":u==="false"?!1:!!u}s(u){const E=this.q(u);if(typeof E=="boolean"){if(this.j===E)return;this.j=E}this.v("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:E}))}t(u){this.k!==u&&(this.k=u,this.v("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:u})))}u(u){this.l!==u&&(this.l=u,this.v("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:O.TextEditorLineNumbersStyle.from(u)})))}assign(u){const E={};let d=!1;if(typeof u.tabSize<"u"){const n=this.m(u.tabSize);n==="auto"?(d=!0,E.tabSize=n):typeof n=="number"&&this.f!==n&&(this.f=n,d=!0,E.tabSize=n)}if(typeof u.indentSize<"u"){const n=this.o(u.indentSize);n==="tabSize"?(d=!0,E.indentSize=n):typeof n=="number"&&this.h!==n&&(this.g=n,this.h=n,d=!0,E.indentSize=n)}if(typeof u.insertSpaces<"u"){const n=this.q(u.insertSpaces);n==="auto"?(d=!0,E.insertSpaces=n):this.j!==n&&(this.j=n,d=!0,E.insertSpaces=n)}typeof u.cursorStyle<"u"&&this.k!==u.cursorStyle&&(this.k=u.cursorStyle,d=!0,E.cursorStyle=u.cursorStyle),typeof u.lineNumbers<"u"&&this.l!==u.lineNumbers&&(this.l=u.lineNumbers,d=!0,E.lineNumbers=O.TextEditorLineNumbersStyle.from(u.lineNumbers)),d&&this.v("setOptions",this.c.$trySetOptions(this.d,E))}v(u,E){E.catch(d=>{this.e.warn(`ExtHostTextEditorOptions '${u}' failed:'`),this.e.warn(d)})}}e.$6P=a;class R{constructor(u,E,d,n,s,o,h,i){this.id=u,this.j=E,this.k=d,this.g=!1,this.h=new Set,this.c=s,this.d=new a(this.j,this.id,o,d),this.e=h,this.f=i;const r=this;this.value=Object.freeze({get document(){return n.value},set document(t){throw new S.$$("document")},get selection(){return r.c&&r.c[0]},set selection(t){if(!(t instanceof A.$wN))throw(0,S.$9)("selection");r.c=[t],r.l()},get selections(){return r.c},set selections(t){if(!Array.isArray(t)||t.some(c=>!(c instanceof A.$wN)))throw(0,S.$9)("selections");r.c=t,r.l()},get visibleRanges(){return r.e},set visibleRanges(t){throw new S.$$("visibleRanges")},get options(){return r.d.value},set options(t){r.g||r.d.assign(t)},get viewColumn(){return r.f},set viewColumn(t){throw new S.$$("viewColumn")},edit(t,c={undoStopBefore:!0,undoStopAfter:!0}){if(r.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const l=new p(n.value,c);return t(l),r.m(l)},insertSnippet(t,c,l={undoStopBefore:!0,undoStopAfter:!0}){if(r.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let m;if(!c||Array.isArray(c)&&c.length===0)m=r.c.map(f=>O.Range.from(f));else if(c instanceof A.$uN){const{lineNumber:f,column:$}=O.Position.from(c);m=[{startLineNumber:f,startColumn:$,endLineNumber:f,endColumn:$}]}else if(c instanceof A.$vN)m=[O.Range.from(c)];else{m=[];for(const f of c)if(f instanceof A.$vN)m.push(O.Range.from(f));else{const{lineNumber:$,column:I}=O.Position.from(f);m.push({startLineNumber:$,startColumn:I,endLineNumber:$,endColumn:I})}}return E.$tryInsertSnippet(u,n.value.version,t.value,m,l)},setDecorations(t,c){const l=c.length===0;l&&!r.h.has(t.key)||(l?r.h.delete(t.key):r.h.add(t.key),r.n(()=>{if(O.$UP(c))return E.$trySetDecorations(u,t.key,O.$VP(c));{const m=new Array(4*c.length);for(let f=0,$=c.length;f<$;f++){const I=c[f];m[4*f]=I.start.line+1,m[4*f+1]=I.start.character+1,m[4*f+2]=I.end.line+1,m[4*f+3]=I.end.character+1}return E.$trySetDecorationsFast(u,t.key,m)}}))},revealRange(t,c){r.n(()=>E.$tryRevealRange(u,O.Range.from(t),c||A.TextEditorRevealType.Default))},show(t){E.$tryShowEditor(u,O.ViewColumn.from(t))},hide(){E.$tryHideEditor(u)}})}dispose(){(0,w.ok)(!this.g),this.g=!0}_acceptOptions(u){(0,w.ok)(!this.g),this.d._accept(u)}_acceptVisibleRanges(u){(0,w.ok)(!this.g),this.e=u}_acceptViewColumn(u){(0,w.ok)(!this.g),this.f=u}_acceptSelections(u){(0,w.ok)(!this.g),this.c=u}async l(){const u=this.c.map(O.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,u)),this.value}m(u){const E=u.finalize();if(E.edits.length===0&&!E.setEndOfLine)return Promise.resolve(!0);const d=E.edits.map(s=>s.range);d.sort((s,o)=>s.end.line===o.end.line?s.end.character===o.end.character?s.start.line===o.start.line?s.start.character-o.start.character:s.start.line-o.start.line:s.end.character-o.end.character:s.end.line-o.end.line);for(let s=0,o=d.length-1;s<o;s++){const h=d[s].end;if(d[s+1].start.isBefore(h))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const n=E.edits.map(s=>({range:O.Range.from(s.range),text:s.text,forceMoveMarkers:s.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,E.documentVersionId,n,{setEndOfLine:typeof E.setEndOfLine=="number"?O.EndOfLine.from(E.setEndOfLine):void 0,undoStopBefore:E.undoStopBefore,undoStopAfter:E.undoStopAfter})}n(u){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):u().then(()=>this,E=>(E instanceof Error&&E.name==="DISPOSED"||this.k.warn(E),null))}}e.$7P=R}),define(ke[58],Ce([1,0,62,6,4,2,3,5,122,17,126,10,12,29,16,40,47]),function(oe,e,w,S,k,O,A,T,p,a,R,y,u,E,d,n,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9P=e.$8P=void 0,w=qe(w),y=qe(y);class o{constructor(r){this.value=r,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let h=class{constructor(r,t){this.h=r,this.i=t,this.a=null,this.b=new Map,this.c=new E.$Cc,this.d=new S.$me,this.e=new S.$me,this.f=new S.$me,this.g=new S.$me,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(r){this.acceptDocumentsAndEditorsDelta(r)}acceptDocumentsAndEditorsDelta(r){const t=[],c=[],l=[];if(r.removedDocuments)for(const m of r.removedDocuments){const f=O.URI.revive(m),$=this.c.get(f);$?.unref()&&(this.c.delete(f),t.push($.value))}if(r.addedDocuments)for(const m of r.addedDocuments){const f=O.URI.revive(m.uri);let $=this.c.get(f);if($&&f.scheme!==d.Schemas.vscodeNotebookCell&&f.scheme!==d.Schemas.vscodeInteractiveInput)throw new Error(`document '${f} already exists!'`);$||($=new o(new p.$1P(this.h.getProxy(T.$rN.MainThreadDocuments),f,m.lines,m.EOL,m.versionId,m.languageId,m.isDirty)),this.c.set(f,$),c.push($.value)),$.ref()}if(r.removedEditors)for(const m of r.removedEditors){const f=this.b.get(m);this.b.delete(m),f&&l.push(f)}if(r.addedEditors)for(const m of r.addedEditors){const f=O.URI.revive(m.documentUri);w.ok(this.c.has(f),`document '${f}' does not exist`),w.ok(!this.b.has(m.id),`editor '${m.id}' already exists!`);const $=this.c.get(f).value,I=new R.$7P(m.id,this.h.getProxy(T.$rN.MainThreadTextEditors),this.i,new s.$X(()=>$.document),m.selections.map(y.Selection.to),m.options,m.visibleRanges.map(D=>y.Range.to(D)),typeof m.editorPosition=="number"?y.ViewColumn.to(m.editorPosition):void 0);this.b.set(m.id,I)}r.newActiveEditor!==void 0&&(w.ok(r.newActiveEditor===null||this.b.has(r.newActiveEditor),`active editor '${r.newActiveEditor}' does not exist`),this.a=r.newActiveEditor),(0,k.$Rc)(t),(0,k.$Rc)(l),r.removedDocuments&&this.e.fire(t),r.addedDocuments&&this.d.fire(c),(r.removedEditors||r.addedEditors)&&this.f.fire(this.allEditors().map(m=>m.value)),r.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(r){return this.c.get(r)?.value}allDocuments(){return n.Iterable.map(this.c.values(),r=>r.value)}getEditor(r){return this.b.get(r)}activeEditor(r){if(!this.a)return;const t=this.b.get(this.a);return r?t:t?.value}allEditors(){return[...this.b.values()]}};e.$8P=h,e.$8P=h=He([Ve(0,a.$XP),Ve(1,u.$_j)],h),e.$9P=(0,A.$Fi)("IExtHostDocumentsAndEditors")}),define(ke[96],Ce([1,0,11,23,22,6,274,76,4,38,15,37,3,12,5,34,58,17,124,10,7,241,55,82,56,25]),function(oe,e,w,S,k,O,A,T,p,a,R,y,u,E,d,n,s,o,h,i,r,t,c,l,m,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3oc=e.$2oc=e.$1oc=e.$Zoc=e.$Yoc=void 0,i=qe(i);let $=0;const I=new WeakMap;e.$Yoc=(0,u.$Fi)("IExtHostTesting");let D=class extends p.$Wc{constructor(te,me,re,ce){super(),this.C=me,this.D=re,this.F=ce,this.f=this.B(new O.$me),this.g=new Map,this.w=this.B(new O.$me),this.y=new Set,this.z=new Map,this.onResultsChanged=this.f.event,this.results=[],this.h=te.getProxy(d.$rN.MainThreadTesting),this.m=new G(this.h),this.j=new g(this.h,me),re.registerArgumentProcessor({processArgument:be=>{switch(be?.$mid){case a.MarshalledId.TestItemContext:{const se=be,Ie=se.tests[se.tests.length-1].item.extId;return this.g.get(c.$QI.root(Ie))?.collection.tree.get(Ie)?.actual??(0,h.$0P)(be)}case a.MarshalledId.TestMessageMenuArgs:{const{test:se,message:Ie}=be,Ue=se.item.extId;return{test:this.g.get(c.$QI.root(Ue))?.collection.tree.get(Ue)?.actual??(0,h.$0P)({$mid:a.MarshalledId.TestItemContext,tests:[se]}),message:i.TestMessage.to(Ie)}}default:return be}}}),re.registerCommand(!1,"testing.getExplorerSelection",async()=>{const be=await re.executeCommand(t.TestCommandId.GetExplorerSelection),se=Ie=>{const Ue=this.g.get(c.$QI.root(Ie));if(Ue)return c.$QI.isRoot(Ie)?Ue.controller:Ue.collection.tree.get(Ie)?.actual};return{include:be?.include.map(se).filter(R.$ng)||[],exclude:be?.exclude.map(se).filter(R.$ng)||[]}})}createTestController(te,me,re,ce){if(this.g.has(me))throw new Error(`Attempt to insert a duplicate controller with ID "${me}"`);const be=new p.$Vc,se=be.add(new h.$aQ(me,re,this.F));se.root.label=re;const Ie=new Map,Ue=new Set,Z=this.h,V={items:se.root.children,get label(){return re},set label(ye){re=ye,se.root.label=ye,Z.$updateController(me,{label:re})},get refreshHandler(){return ce},set refreshHandler(ye){ce=ye,Z.$updateController(me,{canRefresh:!!ye})},get id(){return me},createRunProfile:(ye,ae,we,he,X,Y)=>{let pe=(0,T.$tj)(ye);for(;Ie.has(pe);)pe++;return new F(this.h,Ie,Ue,this.w.event,me,pe,ye,ae,we,he,X,Y)},createTestItem(ye,ae,we){return new h.$$P(me,ye,ae,we)},createTestRun:(ye,ae,we=!0)=>this.j.createTestRun(te,me,se,ye,ae,we),invalidateTestResults:ye=>{if(ye===void 0)this.h.$markTestRetired(void 0);else{const ae=ye instanceof Array?ye:[ye];this.h.$markTestRetired(ae.map(we=>c.$QI.fromExtHostTestItem(we,me).toString()))}},set resolveHandler(ye){se.resolveHandler=ye},get resolveHandler(){return se.resolveHandler},dispose:()=>{be.dispose()}};Z.$registerTestController(me,re,!!ce),be.add((0,p.$Uc)(()=>Z.$unregisterTestController(me)));const _={controller:V,collection:se,profiles:Ie,extension:te,activeProfiles:Ue};return this.g.set(me,_),be.add((0,p.$Uc)(()=>this.g.delete(me))),be.add(se.onDidGenerateDiff(ye=>Z.$publishDiff(me,ye.map(m.TestsDiffOp.serialize)))),V}createTestObserver(){return this.m.checkout()}async runTests(te,me=k.CancellationToken.None){const re=b(te);if(!re)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const ce=this.g.get(re.controllerId);if(!ce)throw new Error("Controller not found");await this.h.$runTests({preserveFocus:te.preserveFocus??!0,group:q[re.kind],targets:[{testIds:te.include?.map(be=>c.$QI.fromExtHostTestItem(be,ce.collection.root.id).toString())??[ce.collection.root.id],profileId:re.profileId,controllerId:re.controllerId}],exclude:te.exclude?.map(be=>be.id)},me)}registerTestFollowupProvider(te){return this.y.add(te),{dispose:()=>{this.y.delete(te)}}}$syncTests(){for(const{collection:te}of this.g.values())te.flushDiff();return Promise.resolve()}async $getCoverageDetails(te,me,re){return(await this.j.getCoverageDetails(te,me,re))?.map(i.TestCoverage.fromDetails)}async $disposeRun(te){this.j.disposeTestRun(te)}$configureRunProfile(te,me){this.g.get(te)?.profiles.get(me)?.configureHandler?.()}$setDefaultRunProfiles(te){const me=new Map;for(const[re,ce]of Object.entries(te)){const be=this.g.get(re);if(!be)continue;const se=new Map,Ie=ce.filter(Z=>!be.activeProfiles.has(Z)),Ue=[...be.activeProfiles].filter(Z=>!ce.includes(Z));for(const Z of Ie)se.set(Z,!0),be.activeProfiles.add(Z);for(const Z of Ue)se.set(Z,!1),be.activeProfiles.delete(Z);se.size&&me.set(re,se)}this.w.fire(me)}async $refreshTests(te,me){await this.g.get(te)?.controller.refreshHandler?.(me)}$publishTestResults(te){this.results=Object.freeze(te.map(me=>{const re=i.TestResults.to(me);return I.set(re,me.id),re}).concat(this.results).sort((me,re)=>re.completedAt-me.completedAt).slice(0,32)),this.f.fire()}async $expandTest(te,me){const re=this.g.get(c.$QI.fromString(te).controllerId)?.collection;re&&(await re.expand(te,me<0?1/0:me),re.flushDiff())}$acceptDiff(te){this.m.applyDiff(te.map(me=>m.TestsDiffOp.deserialize({asCanonicalUri:re=>re},me)))}async $runControllerTests(te,me){return Promise.all(te.map(re=>this.G(re,!1,me)))}async $startContinuousRun(te,me){const re=new k.$xe(me),ce=await Promise.all(te.map(be=>this.G(be,!0,re.token)));return!me.isCancellationRequested&&!ce.some(be=>be.error)&&await new Promise(be=>me.onCancellationRequested(be)),re.dispose(!0),ce}async $provideTestFollowups(te,me){const re=this.results.find(se=>I.get(se)===te.resultId),ce=re&&ue(c.$QI.fromString(te.extId),re?.results);if(!ce)return[];let be=[];return await Promise.all([...this.y].map(async se=>{try{const Ie=await se.provideFollowup(re,ce,te.taskIndex,te.messageIndex,me);Ie&&(be=be.concat(Ie))}catch(Ie){this.C.error("Error thrown while providing followup for test message",Ie)}})),me.isCancellationRequested?[]:be.map(se=>{const Ie=$++;return this.z.set(Ie,se),{title:se.title,id:Ie}})}$disposeTestFollowups(te){for(const me of te)this.z.delete(me)}$executeTestFollowup(te){const me=this.z.get(te);return me?this.D.executeCommand(me.command,...me.arguments||[]):Promise.resolve()}$cancelExtensionTestRun(te){te===void 0?this.j.cancelAllRuns():this.j.cancelRunById(te)}getMetadataForRun(te){for(const me of this.j.trackers){const re=me.getTaskIdForRun(te);if(re)return{taskId:re,runId:me.id}}}async G(te,me,re){const ce=this.g.get(te.controllerId);if(!ce)return{};const{collection:be,profiles:se,extension:Ie}=ce,Ue=se.get(te.profileId);if(!Ue)return{};const Z=te.testIds.map(ae=>be.tree.get(ae)).filter(R.$ng),V=te.excludeExtIds.map(ae=>ce.collection.tree.get(ae)).filter(R.$ng).filter(ae=>Z.some(we=>we.fullId.compare(ae.fullId)===c.TestPosition.IsChild));if(!Z.length)return{};const _=new r.$7O(Z.some(ae=>ae.actual instanceof h.$_P)?void 0:Z.map(ae=>ae.actual),V.map(ae=>ae.actual),Ue,me),ye=(0,m.$TI)(te)&&this.j.prepareForMainThreadTestRun(Ie,_,L.fromInternal(te,ce.collection),Ue,re);try{return await Ue.runHandler(_,re),{}}catch(ae){return{error:String(ae)}}finally{ye&&ye.hasRunningTasks&&!re.isCancellationRequested&&await O.Event.toPromise(ye.onEnd)}}};e.$Zoc=D,e.$Zoc=D=He([Ve(0,o.$XP),Ve(1,E.$_j),Ve(2,n.$hQ),Ve(3,s.$9P)],D);const v=1e4;var C;(function(ge){ge[ge.Running=0]="Running",ge[ge.Cancelling=1]="Cancelling",ge[ge.Ended=2]="Ended"})(C||(C={}));class P extends p.$Wc{get hasRunningTasks(){return this.f>0}get id(){return this.z.id}constructor(te,me,re,ce,be,se){super(),this.z=te,this.C=me,this.D=re,this.F=ce,this.G=be,this.c=C.Running,this.f=0,this.g=new Map,this.h=new Set,this.m=this.B(new O.$me),this.y=new Map,this.onEnd=this.m.event,this.j=this.B(new k.$xe(se));const Ie=this.B(new w.$Rh(()=>this.H(),v));this.B(this.j.token.onCancellationRequested(()=>Ie.schedule()));const Ue=new O.$me;this.w=Ue.event,this.B((0,p.$Uc)(()=>{Ue.fire(),Ue.dispose()}))}getTaskIdForRun(te){for(const[me,{run:re}]of this.g)if(re===te)return me}cancel(){this.c===C.Running?(this.j.cancel(),this.c=C.Cancelling):this.c===C.Cancelling&&this.H()}async getCoverageDetails(te,me,re){const[,ce]=c.$QI.fromString(te).path,be=this.y.get(te);if(!be)return[];const{report:se,extIds:Ie}=be,Ue=this.g.get(ce);if(!Ue)throw new Error("unreachable: run task was not found");let Z;if(me&&se instanceof r.$_O){const _=Ie.indexOf(me);if(_===-1)return[];Z=se.fromTests[_]}return await(Z?this.F?.loadDetailedCoverageForTest?.(Ue.run,se,Z,re):this.F?.loadDetailedCoverage?.(Ue.run,se,re))??[]}createRun(te){const me=this.z.id,re=this.z.controllerId,ce=(0,y.$2g)(),be=Z=>(V,..._)=>{if(Ie){this.D.warn(`Setting the state of test "${V.id}" is a no-op after the run ends.`);return}this.J(V),Z(V,..._)},se=(Z,V)=>{const _=V instanceof Array?V.map(i.TestMessage.from):[i.TestMessage.from(V)];if(Z.uri&&Z.range){const ye={range:i.Range.from(Z.range),uri:Z.uri};for(const ae of _)ae.location=ae.location||ye}this.C.$appendTestMessagesInRun(me,ce,c.$QI.fromExtHostTestItem(Z,re).toString(),_)};let Ie=!1;const Ue={isPersisted:this.z.isPersisted,token:this.j.token,name:te,onDidDispose:this.w,addCoverage:Z=>{if(Ie)return;const V=Z instanceof r.$_O?Z.fromTests:[];if(V.length){(0,f.$4G)(this.G,"attributableCoverage");for(const ae of V)this.J(ae)}const _=Z.uri.toString(),ye=new c.$QI([me,ce,_]).toString();this.y.set(ye,{report:Z,extIds:V.map(ae=>c.$QI.fromExtHostTestItem(ae,re).toString())}),this.C.$appendCoverage(me,ce,i.TestCoverage.fromFile(re,ye,Z))},enqueued:be(Z=>{this.C.$updateTestStateInRun(me,ce,c.$QI.fromExtHostTestItem(Z,re).toString(),m.TestResultState.Queued)}),skipped:be(Z=>{this.C.$updateTestStateInRun(me,ce,c.$QI.fromExtHostTestItem(Z,re).toString(),m.TestResultState.Skipped)}),started:be(Z=>{this.C.$updateTestStateInRun(me,ce,c.$QI.fromExtHostTestItem(Z,re).toString(),m.TestResultState.Running)}),errored:be((Z,V,_)=>{se(Z,V),this.C.$updateTestStateInRun(me,ce,c.$QI.fromExtHostTestItem(Z,re).toString(),m.TestResultState.Errored,_)}),failed:be((Z,V,_)=>{se(Z,V),this.C.$updateTestStateInRun(me,ce,c.$QI.fromExtHostTestItem(Z,re).toString(),m.TestResultState.Failed,_)}),passed:be((Z,V)=>{this.C.$updateTestStateInRun(me,ce,c.$QI.fromExtHostTestItem(Z,this.z.controllerId).toString(),m.TestResultState.Passed,V)}),appendOutput:(Z,V,_)=>{Ie||(_&&this.J(_),this.C.$appendOutputToRun(me,ce,S.$Oe.fromString(Z),V&&i.location.from(V),_&&c.$QI.fromExtHostTestItem(_,re).toString()))},end:()=>{Ie||(Ie=!0,this.C.$finishedTestRunTask(me,ce),--this.f||this.I())}};return this.f++,this.g.set(ce,{run:Ue}),this.C.$startedTestRunTask(me,{id:ce,name:te,running:!0}),Ue}H(){for(const{run:te}of this.g.values())te.end()}I(){this.c!==C.Ended&&(this.c=C.Ended,this.m.fire())}J(te){if(!(te instanceof h.$$P))throw new l.$PP(te.id);if(this.h.has(c.$QI.fromExtHostTestItem(te,this.z.controllerId).toString()))return;const me=[],re=this.z.colllection.root;for(;;){const ce=i.TestItem.from(te);if(me.unshift(ce),this.h.has(ce.extId)||(this.h.add(ce.extId),te===re))break;te=te.parent||re}this.C.$addTestsToRun(this.z.controllerId,this.z.id,me)}dispose(){this.I(),super.dispose()}}class g{get trackers(){return this.c.values()}constructor(te,me){this.g=te,this.h=me,this.c=new Map,this.f=new Map}getCoverageDetails(te,me,re){const ce=c.$QI.root(te);return this.f.get(ce)?.getCoverageDetails(te,me,re)||[]}disposeTestRun(te){this.f.get(te)?.dispose(),this.f.delete(te);for(const[me,{id:re}]of this.c)re===te&&this.c.delete(me)}prepareForMainThreadTestRun(te,me,re,ce,be){return this.j(me,re,ce,te,be)}cancelRunById(te){this.f.get(te)?.cancel()}cancelAllRuns(){for(const te of this.c.values())te.cancel()}createTestRun(te,me,re,ce,be,se){const Ie=this.c.get(ce);if(Ie)return Ie.createRun(be);const Ue=L.fromPublic(me,re,ce,se),Z=b(ce);this.g.$startedExtensionTestRun({controllerId:me,continuous:!!ce.continuous,profile:Z&&{group:q[Z.kind],id:Z.profileId},exclude:ce.exclude?.map(_=>c.$QI.fromExtHostTestItem(_,re.root.id).toString())??[],id:Ue.id,include:ce.include?.map(_=>c.$QI.fromExtHostTestItem(_,re.root.id).toString())??[re.root.id],preserveFocus:ce.preserveFocus??!0,persist:se});const V=this.j(ce,Ue,ce.profile,te);return O.Event.once(V.onEnd)(()=>{this.g.$finishedExtensionTestRun(Ue.id)}),V.createRun(be)}j(te,me,re,ce,be){const se=new P(me,this.g,this.h,re,ce,be);return this.c.set(te,se),this.f.set(se.id,se),se}}e.$1oc=g;const b=ge=>{if(ge.profile){if(!(ge.profile instanceof F))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return ge.profile}};class L{static fromPublic(te,me,re,ce){return new L(te,(0,y.$2g)(),ce,me)}static fromInternal(te,me){return new L(te.controllerId,te.runId,!0,me)}constructor(te,me,re,ce){this.controllerId=te,this.id=me,this.isPersisted=re,this.colllection=ce}}e.$2oc=L;class N{get isEmpty(){return this.c.size===0&&this.g.size===0&&this.f.size===0}constructor(te){this.j=te,this.c=new Set,this.f=new Set,this.g=new Set,this.h=new Set}add(te){this.c.add(te)}update(te){Object.assign(te.revived,i.TestItem.toPlain(te.item)),this.c.has(te)||this.f.add(te)}remove(te){if(this.c.has(te)){this.c.delete(te);return}this.f.delete(te);const me=c.$QI.parentId(te.item.extId);if(me&&this.h.has(me.toString())){this.h.add(te.item.extId);return}this.g.add(te)}getChangeEvent(){const{c:te,f:me,g:re}=this;return{get added(){return[...te].map(ce=>ce.revived)},get updated(){return[...me].map(ce=>ce.revived)},get removed(){return[...re].map(ce=>ce.revived)}}}complete(){this.isEmpty||this.j.fire(this.getChangeEvent())}}class B extends m.$ZI{constructor(){super(...arguments),this.y=new O.$me,this.onDidChangeTests=this.y.event}get rootTests(){return this.g}getMirroredTestDataById(te){return this.f.get(te)}getMirroredTestDataByReference(te){return this.f.get(te.id)}x(te,me){return{...te,revived:i.TestItem.toPlain(te.item),depth:me?me.depth+1:0,children:new Set}}w(){return new N(this.y)}}class G{constructor(te){this.f=te}checkout(){this.c||(this.c=this.g());const te=this.c;return te.observers++,{onDidChangeTest:te.tests.onDidChangeTests,get tests(){return[...te.tests.rootTests].map(me=>me.revived)},dispose:(0,A.$fb)(()=>{--te.observers===0&&(this.f.$unsubscribeFromDiffs(),this.c=void 0)})}}getMirroredTestDataByReference(te){return this.c?.tests.getMirroredTestDataByReference(te)}applyDiff(te){this.c?.tests.apply(te)}g(){const te=new B({asCanonicalUri:me=>me});return this.f.$subscribeToDiffs(),{observers:0,tests:te}}}const W=(ge,te,me,re)=>{me?Object.assign(me,re):te.$updateTestRunConfig(ge.controllerId,ge.profileId,re)};class F{#e;#t;#i;#n;#s;get label(){return this.f}set label(te){te!==this.f&&(this.f=te,W(this,this.#e,this.#n,{label:te}))}get supportsContinuousRun(){return this.g}set supportsContinuousRun(te){te!==this.g&&(this.g=te,W(this,this.#e,this.#n,{supportsContinuousRun:te}))}get isDefault(){return this.#t.has(this.profileId)}set isDefault(te){te!==this.isDefault&&(te?this.#t.add(this.profileId):this.#t.delete(this.profileId),W(this,this.#e,this.#n,{isDefault:te}))}get tag(){return this._tag}set tag(te){te?.id!==this._tag?.id&&(this._tag=te,W(this,this.#e,this.#n,{tag:te?i.TestTag.namespace(this.controllerId,te.id):null}))}get configureHandler(){return this.c}set configureHandler(te){te!==this.c&&(this.c=te,W(this,this.#e,this.#n,{hasConfigurationHandler:!!te}))}get onDidChangeDefault(){return O.Event.chain(this.#i,te=>te.map(me=>me.get(this.controllerId)?.get(this.profileId)).filter(R.$ng))}constructor(te,me,re,ce,be,se,Ie,Ue,Z,V=!1,_=void 0,ye=!1){this.controllerId=be,this.profileId=se,this.f=Ie,this.kind=Ue,this.runHandler=Z,this._tag=_,this.g=ye,this.#e=te,this.#s=me,this.#t=re,this.#i=ce,me.set(se,this);const ae=q[Ue];if(typeof ae!="number")throw new Error(`Unknown TestRunProfile.group ${Ue}`);V&&re.add(se),this.#n={profileId:se,controllerId:be,tag:_?i.TestTag.namespace(this.controllerId,_.id):null,label:Ie,group:ae,isDefault:V,hasConfigurationHandler:!1,supportsContinuousRun:ye},queueMicrotask(()=>{this.#n&&(this.#e.$publishTestRunProfile(this.#n),this.#n=void 0)})}dispose(){this.#s?.delete(this.profileId)&&(this.#s=void 0,this.#e.$removeTestProfile(this.controllerId,this.profileId)),this.#n=void 0}}e.$3oc=F;const q={[r.TestRunProfileKind.Coverage]:m.TestRunProfileBitset.Coverage,[r.TestRunProfileKind.Debug]:m.TestRunProfileBitset.Debug,[r.TestRunProfileKind.Run]:m.TestRunProfileBitset.Run};function ue(ge,te){for(let me=0;me<ge.path.length;me++){const re=te.find(ce=>ce.id===ge.path[me]);if(!re)return;if(me===ge.path.length-1)return re;te=re.children}}}),define(ke[301],Ce([1,0,18,6,4,5,126,10,7]),function(oe,e,w,S,k,O,A,T,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0nc=void 0,w=qe(w),T=qe(T);class a extends k.$Wc{constructor(y,u){super(),this.m=u,this.a=new S.$me,this.b=new S.$me,this.c=new S.$me,this.f=new S.$me,this.g=new S.$me,this.h=new S.$me,this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.f.event,this.onDidChangeActiveTextEditor=this.g.event,this.onDidChangeVisibleTextEditors=this.h.event,this.j=y.getProxy(O.$rN.MainThreadTextEditors),this.B(this.m.onDidChangeVisibleTextEditors(E=>this.h.fire(E))),this.B(this.m.onDidChangeActiveTextEditor(E=>this.g.fire(E)))}getActiveTextEditor(){return this.m.activeEditor()}getVisibleTextEditors(y){const u=this.m.allEditors();return y?u:u.map(E=>E.value)}async showTextDocument(y,u,E){let d;typeof u=="number"?d={position:T.ViewColumn.from(u),preserveFocus:E}:typeof u=="object"?d={position:T.ViewColumn.from(u.viewColumn),preserveFocus:u.preserveFocus,selection:typeof u.selection=="object"?T.Range.from(u.selection):void 0,pinned:typeof u.preview=="boolean"?!u.preview:void 0}:d={preserveFocus:!1};const n=await this.j.$tryShowTextDocument(y.uri,d),s=n&&this.m.getEditor(n);if(s)return s.value;throw n?new Error(`Could NOT open editor for "${y.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${y.uri.toString()}".`)}createTextEditorDecorationType(y,u){return new A.$5P(this.j,y,u).value}$acceptEditorPropertiesChanged(y,u){const E=this.m.getEditor(y);if(!E)throw new Error("unknown text editor");if(u.options&&E._acceptOptions(u.options),u.selections){const d=u.selections.selections.map(T.Selection.to);E._acceptSelections(d)}if(u.visibleRanges){const d=w.$Jb(u.visibleRanges.map(T.Range.to));E._acceptVisibleRanges(d)}if(u.options&&this.b.fire({textEditor:E.value,options:{...u.options,lineNumbers:T.TextEditorLineNumbersStyle.to(u.options.lineNumbers)}}),u.selections){const d=p.TextEditorSelectionChangeKind.fromValue(u.selections.source),n=u.selections.selections.map(T.Selection.to);this.a.fire({textEditor:E.value,selections:n,kind:d})}if(u.visibleRanges){const d=w.$Jb(u.visibleRanges.map(T.Range.to));this.c.fire({textEditor:E.value,visibleRanges:d})}}$acceptEditorPositionData(y){for(const u in y){const E=this.m.getEditor(u);if(!E)throw new Error("Unknown text editor");const d=T.ViewColumn.to(y[u]);E.value.viewColumn!==d&&(E._acceptViewColumn(d),this.f.fire({textEditor:E.value,viewColumn:d}))}}getDiffInformation(y){return Promise.resolve(this.j.$getDiffInformation(y))}}e.$0nc=a}),define(ke[302],Ce([1,0,2,3,5,4,7,10,19,38,15]),function(oe,e,w,S,k,O,A,T,p,a,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Upc=e.$Tpc=void 0,e.$Tpc=(0,S.$Fi)("IExtHostTimeline");class y{constructor(d,n){this.b=new Map,this.c=new Map,this.a=d.getProxy(k.$rN.MainThreadTimeline),n.registerArgumentProcessor({processArgument:(s,o)=>{if(s&&s.$mid===a.MarshalledId.TimelineActionContext)if(this.b.get(s.source)&&p.$qn.equals(o,this.b.get(s.source)?.extension)){const h=s.uri===void 0?void 0:w.URI.revive(s.uri);return this.c.get(s.source)?.get(u(h))?.get(s.handle)}else return;return s}})}async $getTimeline(d,n,s,o){return this.b.get(d)?.provider.provideTimeline(w.URI.revive(n),s,o)}registerTimelineProvider(d,n,s,o){const h=new O.$Vc,i=this.d(n.id,o,h).bind(this);let r;n.onDidChange&&(r=n.onDidChange(c=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...c,id:n.id}),this));const t=this.c;return this.f({...n,scheme:d,onDidChange:void 0,async provideTimeline(c,l,m){l?.resetCache&&(h.clear(),t.get(n.id)?.clear());const f=await n.provideTimeline(c,l,m);if(f==null)return;const $=i(c,l);return{...f,source:n.id,items:f.items.map($)}},dispose(){for(const c of t.values())c.get(n.id)?.clear();r?.dispose(),h.dispose()}},s)}d(d,n,s){return(o,h)=>{let i;if(h?.cacheResults){let r=this.c.get(d);r===void 0&&(r=new Map,this.c.set(d,r));const t=u(o);i=r.get(t),i===void 0&&(i=new Map,r.set(t,i))}return r=>{const{iconPath:t,...c}=r,l=`${d}|${r.id??r.timestamp}`;i?.set(l,r);let m,f,$;r.iconPath&&(t instanceof A.$qO?$={id:t.id,color:t.color}:w.URI.isUri(t)?(m=t,f=t):{light:m,dark:f}=t);let I;return A.$VN.isMarkdownString(c.tooltip)?I=T.MarkdownString.from(c.tooltip):(0,R.$fg)(c.tooltip)?I=c.tooltip:A.$VN.isMarkdownString(c.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),I=T.MarkdownString.from(c.detail)):(0,R.$fg)(c.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),I=c.detail),{...c,id:c.id??void 0,handle:l,source:d,command:r.command?n.toInternal(r.command,s):void 0,icon:m,iconDark:f,themeIcon:$,tooltip:I,accessibilityInformation:r.accessibilityInformation}}}}f(d,n){if(this.b.get(d.id))throw new Error(`Timeline Provider ${d.id} already exists.`);return this.a.$registerTimelineProvider({id:d.id,label:d.label,scheme:d.scheme}),this.b.set(d.id,{provider:d,extension:n}),(0,O.$Uc)(()=>{for(const o of this.c.values())o.get(d.id)?.clear();this.b.delete(d.id),this.a.$unregisterTimelineProvider(d.id),d.dispose()})}}e.$Upc=y;function u(E){return E?.toString()}}),define(ke[303],Ce([1,0,189,24,2,6,4,232,11,7,15,18,10,60,22,153,25]),function(oe,e,w,S,k,O,A,T,p,a,R,y,u,E,d,n,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vpc=void 0,a=qe(a);function o(r,t){if((0,R.$fg)(r))return{label:r};if(r&&typeof r=="object"&&typeof r.label=="string"){let c;return Array.isArray(r.highlights)&&(c=r.highlights.filter(l=>l.length===2&&typeof l[0]=="number"&&typeof l[1]=="number"),c=c.length?c:void 0),{label:r.label,highlights:c}}}class h extends A.$Wc{constructor(t,c,l){super(),this.f=t,this.g=c,this.h=l,this.a=new Map,this.b=new n.$r_;function m(f){return f&&f.$treeViewId&&(f.$treeItemHandle||f.$selectedTreeItems||f.$focusedTreeItem)}c.registerArgumentProcessor({processArgument:f=>m(f)?this.r(f):Array.isArray(f)&&f.length>0?f.map($=>m($)?this.r($):$):f})}registerTreeDataProvider(t,c,l){const m=this.createTreeView(t,{treeDataProvider:c},l);return{dispose:()=>m.dispose()}}createTreeView(t,c,l){if(!c||!c.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const m=c.dragAndDropController?.dropMimeTypes??[],f=c.dragAndDropController?.dragMimeTypes??[],$=!!c.dragAndDropController?.handleDrag,I=!!c.dragAndDropController?.handleDrop,D=this.m(t,c,l),v={showCollapseAll:!!c.showCollapseAll,canSelectMany:!!c.canSelectMany,dropMimeTypes:m,dragMimeTypes:f,hasHandleDrag:$,hasHandleDrop:I,manuallyManageCheckboxes:!!c.manageCheckboxStateManually},C=this.f.$registerTreeViewDataProvider(t,v),P={get onDidCollapseElement(){return D.onDidCollapseElement},get onDidExpandElement(){return D.onDidExpandElement},get selection(){return D.selectedElements},get onDidChangeSelection(){return D.onDidChangeSelection},get activeItem(){return(0,s.$4G)(l,"treeViewActiveItem"),D.focusedElement},get onDidChangeActiveItem(){return(0,s.$4G)(l,"treeViewActiveItem"),D.onDidChangeActiveItem},get visible(){return D.visible},get onDidChangeVisibility(){return D.onDidChangeVisibility},get onDidChangeCheckboxState(){return D.onDidChangeCheckboxState},get message(){return D.message},set message(g){(0,E.$5k)(g)&&(0,s.$4G)(l,"treeViewMarkdownMessage"),D.message=g},get title(){return D.title},set title(g){D.title=g},get description(){return D.description},set description(g){D.description=g},get badge(){return D.badge},set badge(g){g!==void 0&&a.ViewBadge.isViewBadge(g)?D.badge={value:Math.floor(Math.abs(g.value)),tooltip:g.tooltip}:g===void 0&&(D.badge=void 0)},reveal:(g,b)=>D.reveal(g,b),dispose:async()=>{await C,this.a.delete(t),D.dispose()}};return this.B(P),P}$getChildren(t,c){const l=this.a.get(t);return l?l.getChildren(c):Promise.reject(new T.$mG(t))}async $handleDrop(t,c,l,m,f,$,I,D){const v=this.a.get(t);if(!v)return Promise.reject(new T.$mG(t));const C=u.DataTransfer.toDataTransfer(l,async P=>(await this.f.$resolveDropFileData(t,c,P)).buffer);return I===t&&D&&await this.j(C,v,D,f,$),v.onDrop(C,m,f)}async j(t,c,l,m,f){const $=this.b.removeDragOperationTransfer(f);if($)(await $)?.forEach((I,D)=>{I&&t.set(D,I)});else if(f&&c.handleDrag){const I=c.handleDrag(l,t,m);this.b.addDragOperationTransfer(f,I),await I}return t}async $handleDrag(t,c,l,m){const f=this.a.get(t);if(!f)return Promise.reject(new T.$mG(t));const $=await this.j(new a.$mO,f,c,m,l);if(!(!$||m.isCancellationRequested))return u.DataTransfer.from($)}async $hasResolve(t){const c=this.a.get(t);if(!c)throw new T.$mG(t);return c.hasResolve}$resolve(t,c,l){const m=this.a.get(t);if(!m)throw new T.$mG(t);return m.resolveTreeItem(c,l)}$setExpanded(t,c,l){const m=this.a.get(t);if(!m)throw new T.$mG(t);m.setExpanded(c,l)}$setSelectionAndFocus(t,c,l){const m=this.a.get(t);if(!m)throw new T.$mG(t);m.setSelectionAndFocus(c,l)}$setVisible(t,c){const l=this.a.get(t);if(!l){if(!c)return;throw new T.$mG(t)}l.setVisible(c)}$changeCheckboxState(t,c){const l=this.a.get(t);if(!l)throw new T.$mG(t);l.setCheckboxState(c)}m(t,c,l){const m=this.B(new i(t,c,this.f,this.g.converter,this.h,l));return this.a.set(t,m),m}r(t){const c=this.a.get(t.$treeViewId);return c&&"$treeItemHandle"in t?c.getExtensionElement(t.$treeItemHandle):c&&"$focusedTreeItem"in t&&t.$focusedTreeItem?c.focusedElement:null}}e.$Vpc=h;class i extends A.$Wc{static{this.a="0"}static{this.b="1"}get visible(){return this.r}get selectedElements(){return this.s.map(t=>this.getExtensionElement(t)).filter(t=>!(0,R.$og)(t))}get focusedElement(){return this.t?this.getExtensionElement(this.t):void 0}constructor(t,c,l,m,f,$){if(super(),this.I=t,this.J=l,this.L=m,this.M=f,this.N=$,this.h=void 0,this.j=new Map,this.m=new Map,this.r=!1,this.s=[],this.t=void 0,this.u=this.B(new O.$me),this.onDidExpandElement=this.u.event,this.w=this.B(new O.$me),this.onDidCollapseElement=this.w.event,this.y=this.B(new O.$me),this.onDidChangeSelection=this.y.event,this.z=this.B(new O.$me),this.onDidChangeActiveItem=this.z.event,this.C=this.B(new O.$me),this.onDidChangeVisibility=this.C.event,this.D=this.B(new O.$me),this.onDidChangeCheckboxState=this.D.event,this.F=this.B(new O.$me),this.G=Promise.resolve(),this.H=Promise.resolve(),this.O="",this.P="",this.Z=new d.$xe,$.contributes&&$.contributes.views)for(const C in $.contributes.views)for(const P of $.contributes.views[C])P.id===t&&(this.P=P.name);this.f=c.treeDataProvider,this.g=c.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData(C=>{Array.isArray(C)&&C.length===0||this.F.fire({message:!1,element:C})}));let I,D;const v=O.Event.debounce(this.F.event,(C,P)=>(C||(C={message:!1,elements:[]}),P.element!==!1&&(I||(I=new Promise(g=>D=g),this.G=this.G.then(()=>I)),Array.isArray(P.element)?C.elements.push(...P.element):C.elements.push(P.element)),P.message&&(C.message=!0),C),200,!0);this.B(v(({message:C,elements:P})=>{P.length&&(this.H=this.H.then(()=>{const g=D;return I=null,this.$(P).then(()=>g())})),C&&this.J.$setMessage(this.I,u.MarkdownString.fromStrict(this.O)??"")}))}async getChildren(t){const c=t?this.getExtensionElement(t):void 0;if(t&&!c)return this.M.error(`No tree item with id '${t}' found.`),Promise.resolve([]);let l=this.X(t);return l||(l=await this.Y(c)),l?l.map(m=>m.item):void 0}getExtensionElement(t){return this.j.get(t)}reveal(t,c){c=c||{select:!0,focus:!1};const l=(0,R.$og)(c.select)?!0:c.select,m=(0,R.$og)(c.focus)?!1:c.focus,f=(0,R.$og)(c.expand)?!1:c.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):t?this.G.then(()=>this.S(t)).then($=>this.W(t,$[$.length-1]).then(I=>this.J.$reveal(this.I,{item:I.item,parentChain:$.map(D=>D.item)},{select:l,focus:m,expand:f})),$=>this.M.error($)):this.J.$reveal(this.I,void 0,{select:l,focus:m,expand:f})}get message(){return this.O}set message(t){this.O=t,this.F.fire({message:!0,element:!1})}get title(){return this.P}set title(t){this.P=t,this.J.$setTitle(this.I,t,this.Q)}get description(){return this.Q}set description(t){this.Q=t,this.J.$setTitle(this.I,this.P,t)}get badge(){return this.R}set badge(t){this.R?.value===t?.value&&this.R?.tooltip===t?.tooltip||(this.R=u.ViewBadge.from(t),this.J.$setBadge(this.I,t))}setExpanded(t,c){const l=this.getExtensionElement(t);l&&(c?this.u.fire(Object.freeze({element:l})):this.w.fire(Object.freeze({element:l})))}setSelectionAndFocus(t,c){const l=!(0,y.$wb)(this.s,t);this.s=t;const m=this.t!==c;this.t=c,l&&this.y.fire(Object.freeze({selection:this.selectedElements})),m&&this.z.fire(Object.freeze({activeItem:this.focusedElement}))}setVisible(t){t!==this.r&&(this.r=t,this.C.fire(Object.freeze({visible:this.r})))}async setCheckboxState(t){const c=(await Promise.all(t.map(async l=>{const m=this.getExtensionElement(l.treeItemHandle);return m?{extensionItem:m,treeItem:await this.f.getTreeItem(m),newState:l.newState?a.TreeItemCheckboxState.Checked:a.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(l=>l!==void 0);c.forEach(l=>{l.treeItem.checkboxState=l.newState?a.TreeItemCheckboxState.Checked:a.TreeItemCheckboxState.Unchecked}),this.D.fire({items:c.map(l=>[l.extensionItem,l.newState])})}async handleDrag(t,c,l){const m=[];for(const f of t){const $=this.getExtensionElement(f);$&&m.push($)}if(!(!this.g?.handleDrag||m.length===0))return await this.g.handleDrag(m,c,l),c}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(t,c,l){const m=c?this.getExtensionElement(c):void 0;if(!(!m&&c||!this.g?.handleDrop))return(0,p.$xh)(()=>this.g?.handleDrop?this.g.handleDrop(m,t,l):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(t,c){if(!this.f.resolveTreeItem)return;const l=this.j.get(t);if(l){const m=this.m.get(l);if(m){const f=await this.f.resolveTreeItem(m.extensionItem,l,c)??m.extensionItem;return this.hb(f),m.item.tooltip=this.eb(f.tooltip),m.item.command=this.fb(m.disposableStore,f.command),m.item}}}S(t){return this.U(t).then(c=>c?this.S(c).then(l=>this.W(c,l[l.length-1]).then(m=>(l.push(m),l))):Promise.resolve([]))}U(t){const c=this.m.get(t);return c?Promise.resolve(c.parent?this.j.get(c.parent.item.handle):void 0):(0,p.$xh)(()=>this.f.getParent(t))}W(t,c){const l=this.m.get(t);return l?Promise.resolve(l):(0,p.$xh)(()=>this.f.getTreeItem(t)).then(m=>this.kb(t,m,c,!0)).then(m=>this.getChildren(c?c.item.handle:void 0).then(()=>{const f=this.getExtensionElement(m);if(f){const $=this.m.get(f);if($)return Promise.resolve($)}throw new Error(`Cannot resolve tree item for element ${m} from extension ${this.N.identifier.value}`)}))}X(t){if(t){let c;if(typeof t=="string"){const l=this.getExtensionElement(t);c=l?this.m.get(l):void 0}else c=t;return c&&c.children||void 0}return this.h}async Y(t){this.rb(t);const c=new d.$xe(this.Z.token);try{const l=t?this.m.get(t):void 0,m=await this.f.getChildren(t);if(c.token.isCancellationRequested)return;const f=(0,y.$Jb)(m||[]),$=await Promise.all((0,y.$Jb)(f).map(D=>this.f.getTreeItem(D)));if(c.token.isCancellationRequested)return;const I=$.map((D,v)=>D?this.db(f[v],D,l):null);return(0,y.$Jb)(I)}finally{c.dispose()}}$(t){if(t.some(l=>!l))return this.Z.dispose(!0),this.Z=new d.$xe,this.tb(),this.J.$refresh(this.I);{const l=this.ab(t);if(l.length)return this.bb(l)}return Promise.resolve(void 0)}ab(t){const c=new Set,l=t.map(f=>this.m.get(f));for(const f of l)if(f&&!c.has(f.item.handle)){let $=f;for(;$&&$.parent&&l.findIndex(I=>$&&$.parent&&I&&I.item.handle===$.parent.item.handle)===-1;){const I=this.j.get($.parent.item.handle);$=I?this.m.get(I):void 0}$&&!$.parent&&c.add(f.item.handle)}const m=[];return c.forEach(f=>{const $=this.j.get(f);if($){const I=this.m.get($);I&&(!I.parent||!c.has(I.parent.item.handle))&&m.push(f)}}),m}bb(t){const c={};return Promise.all(t.map(l=>this.cb(l).then(m=>{m&&(c[l]=m.item)}))).then(()=>Object.keys(c).length?this.J.$refresh(this.I,c):void 0)}cb(t){const c=this.getExtensionElement(t);if(c){const l=this.m.get(c);if(l)return this.rb(c),(0,p.$xh)(()=>this.f.getTreeItem(c)).then(m=>{if(m){const f=this.ib(c,m,l.parent);return this.pb(c,f,l,l.parent),l.dispose(),f}return null})}return Promise.resolve(null)}db(t,c,l){const m=this.ib(t,c,l);if(c.id&&this.j.has(m.item.handle))throw new Error((0,w.localize)(0,null,c.id));return this.ob(t,m),this.qb(m,l),m}eb(t){return a.$VN.isMarkdownString(t)?u.MarkdownString.from(t):t}fb(t,c){return c?{...this.L.toInternal(c,t),originalId:c.command}:void 0}gb(t){if(t.checkboxState===void 0)return;let c,l,m;return typeof t.checkboxState=="number"?c=t.checkboxState:(c=t.checkboxState.state,l=t.checkboxState.tooltip,m=t.checkboxState.accessibilityInformation),{isChecked:c===a.TreeItemCheckboxState.Checked,tooltip:l,accessibilityInformation:m}}hb(t){if(!a.$hO.isTreeItem(t,this.N))throw new Error(`Extension ${this.N.identifier.value} has provided an invalid tree item.`)}ib(t,c,l){this.hb(c);const m=this.B(new A.$Vc),f=this.kb(t,c,l),$=this.lb(c);return{item:{handle:f,parentHandle:l?l.item.handle:void 0,label:o(c.label,this.N),description:c.description,resourceUri:c.resourceUri,tooltip:this.eb(c.tooltip),command:this.fb(m,c.command),contextValue:c.contextValue,icon:$,iconDark:this.mb(c)||$,themeIcon:this.jb(c),collapsibleState:(0,R.$og)(c.collapsibleState)?a.TreeItemCollapsibleState.None:c.collapsibleState,accessibilityInformation:c.accessibilityInformation,checkbox:this.gb(c)},extensionItem:c,parent:l,children:void 0,disposableStore:m,dispose(){m.dispose()}}}jb(t){return t.iconPath instanceof a.$qO?t.iconPath:void 0}kb(t,{id:c,label:l,resourceUri:m},f,$){if(c)return`${i.b}/${c}`;const I=o(l,this.N),D=f?f.item.handle:i.a;let v=I?I.label:m?(0,S.$dh)(m):"";v=v.indexOf("/")!==-1?v.replace("/","//"):v;const C=this.m.has(t)?this.m.get(t).item.handle:void 0,P=this.X(f)||[];let g,b=0;do{if(g=`${D}/${b}:${v}`,$||!this.j.has(g)||C===g)break;b++}while(b<=P.length);return g}lb(t){if(t.iconPath&&!(t.iconPath instanceof a.$qO))return typeof t.iconPath=="string"||k.URI.isUri(t.iconPath)?this.nb(t.iconPath):this.nb(t.iconPath.light)}mb(t){if(t.iconPath&&!(t.iconPath instanceof a.$qO)&&t.iconPath.dark)return this.nb(t.iconPath.dark)}nb(t){return k.URI.isUri(t)?t:k.URI.file(t)}ob(t,c){this.j.set(c.item.handle,t),this.m.set(t,c)}pb(t,c,l,m){this.j.delete(c.item.handle),this.m.delete(t),c.item.handle!==l.item.handle&&this.j.delete(l.item.handle),this.ob(t,c);const f=this.X(m)||[],$=f.filter(I=>I.item.handle===l.item.handle)[0];$&&f.splice(f.indexOf($),1,c)}qb(t,c){c?(c.children||(c.children=[]),c.children.push(t)):(this.h||(this.h=[]),this.h.push(t))}rb(t){if(t){const c=this.m.get(t);if(c){if(c.children)for(const l of c.children){const m=this.j.get(l.item.handle);m&&this.sb(m)}c.children=void 0}}else this.tb()}sb(t){const c=this.m.get(t);if(c){if(c.children)for(const l of c.children){const m=this.j.get(l.item.handle);m&&this.sb(m)}this.m.delete(t),this.j.delete(c.item.handle),c.dispose()}}tb(){this.h=void 0,this.j.clear(),this.m.forEach(t=>t.dispose()),this.m.clear()}dispose(){super.dispose(),this.Z.dispose(),this.tb(),this.J.$disposeTree(this.I)}}}),define(ke[304],Ce([1,0,6,4,2,37,10,68,5,7]),function(oe,e,w,S,k,O,A,T,p,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qoc=void 0,A=qe(A),p=qe(p),a=qe(a);class R extends S.$Wc{#e;#t;#i;#n;#s;#r;#a;#o;#c;#u;#l;#d;#h;constructor(d,n,s,o){super(),this.#o=void 0,this.#c=!0,this.#l=!1,this.#d=this.B(new w.$me),this.onDidDispose=this.#d.event,this.#h=this.B(new w.$me),this.onDidChangeViewState=this.#h.event,this.#e=d,this.#t=n,this.#n=s,this.#i=o.viewType,this.#s=o.panelOptions,this.#o=o.viewColumn,this.#r=o.title,this.#u=o.active}dispose(){this.#l||(this.#l=!0,this.#d.fire(),this.#t.$disposeWebview(this.#e),this.#n.dispose(),super.dispose())}get webview(){return this.c(),this.#n}get viewType(){return this.c(),this.#i}get title(){return this.c(),this.#r}set title(d){this.c(),this.#r!==d&&(this.#r=d,this.#t.$setTitle(this.#e,d))}get iconPath(){return this.c(),this.#a}set iconPath(d){this.c(),this.#a!==d&&(this.#a=d,this.#t.$setIconPath(this.#e,k.URI.isUri(d)?{light:d,dark:d}:d))}get options(){return this.#s}get viewColumn(){if(this.c(),!(typeof this.#o=="number"&&this.#o<0))return this.#o}get active(){return this.c(),this.#u}get visible(){return this.c(),this.#c}_updateViewState(d){this.#l||(this.active!==d.active||this.visible!==d.visible||this.viewColumn!==d.viewColumn)&&(this.#u=d.active,this.#c=d.visible,this.#o=d.viewColumn,this.#h.fire({webviewPanel:this}))}reveal(d,n){this.c(),this.#t.$reveal(this.#e,{viewColumn:typeof d>"u"?void 0:A.ViewColumn.from(d),preserveFocus:!!n})}c(){if(this.#l)throw new Error("Webview is disposed")}}class y extends S.$Wc{static c(){return(0,O.$2g)()}constructor(d,n,s){super(),this.j=n,this.m=s,this.g=new Map,this.h=new Map,this.f=d.getProxy(p.$rN.MainThreadWebviewPanels)}dispose(){super.dispose(),this.g.forEach(d=>d.dispose()),this.g.clear()}createWebviewPanel(d,n,s,o,h={}){const i=typeof o=="object"?o.viewColumn:o,r={viewColumn:A.ViewColumn.from(i),preserveFocus:typeof o=="object"&&!!o.preserveFocus},t=(0,T.$moc)(d),c=y.c();this.f.$createWebviewPanel((0,T.$ooc)(d),c,n,{title:s,panelOptions:u(h),webviewOptions:(0,T.$poc)(d,this.m,h),serializeBuffersForPostMessage:t},r);const l=this.j.createNewWebview(c,h,d);return this.createNewWebviewPanel(c,n,s,i,h,l,!0)}$onDidChangeWebviewPanelViewStates(d){const n=Object.keys(d);n.sort((s,o)=>{const h=d[s],i=d[o];return h.active?1:i.active?-1:+h.visible-+i.visible});for(const s of n){const o=this.getWebviewPanel(s);if(!o)continue;const h=d[s];o._updateViewState({active:h.active,visible:h.visible,viewColumn:A.ViewColumn.to(h.position)})}}async $onDidDisposeWebviewPanel(d){this.getWebviewPanel(d)?.dispose(),this.g.delete(d),this.j.deleteWebview(d)}registerWebviewPanelSerializer(d,n,s){if(this.h.has(n))throw new Error(`Serializer for '${n}' already registered`);return this.h.set(n,{serializer:s,extension:d}),this.f.$registerSerializer(n,{serializeBuffersForPostMessage:(0,T.$moc)(d)}),new a.$tN(()=>{this.h.delete(n),this.f.$unregisterSerializer(n)})}async $deserializeWebviewPanel(d,n,s,o){const h=this.h.get(n);if(!h)throw new Error(`No serializer found for '${n}'`);const{serializer:i,extension:r}=h,t=this.j.createNewWebview(d,s.webviewOptions,r),c=this.createNewWebviewPanel(d,n,s.title,o,s.panelOptions,t,s.active);await i.deserializeWebviewPanel(c,s.state)}createNewWebviewPanel(d,n,s,o,h,i,r){const t=new R(d,this.f,i,{viewType:n,title:s,viewColumn:o,panelOptions:h,active:r});return this.g.set(d,t),t}getWebviewPanel(d){return this.g.get(d)}}e.$qoc=y;function u(E){return{enableFindWidget:E.enableFindWidget,retainContextWhenHidden:E.retainContextWhenHidden}}}),define(ke[305],Ce([1,0,6,4,68,10,5,7]),function(oe,e,w,S,k,O,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ypc=void 0,A=qe(A),T=qe(T);class p extends S.$Wc{#e;#t;#i;#n;#s;#r;#a;#o;#c;constructor(y,u,E,d,n,s){super(),this.#s=!1,this.#u=this.B(new w.$me),this.onDidChangeVisibility=this.#u.event,this.#l=this.B(new w.$me),this.onDidDispose=this.#l.event,this.#i=E,this.#a=d,this.#e=y,this.#t=u,this.#n=n,this.#r=s}dispose(){this.#s||(this.#s=!0,this.#l.fire(),this.#n.dispose(),super.dispose())}#u;#l;get title(){return this.a(),this.#a}set title(y){this.a(),this.#a!==y&&(this.#a=y,this.#t.$setWebviewViewTitle(this.#e,y))}get description(){return this.a(),this.#o}set description(y){this.a(),this.#o!==y&&(this.#o=y,this.#t.$setWebviewViewDescription(this.#e,y))}get visible(){return this.#r}get webview(){return this.#n}get viewType(){return this.#i}_setVisible(y){y===this.#r||this.#s||(this.#r=y,this.#u.fire())}get badge(){return this.a(),this.#c}set badge(y){this.a(),!(y?.value===this.#c?.value&&y?.tooltip===this.#c?.tooltip)&&(this.#c=O.ViewBadge.from(y),this.#t.$setWebviewViewBadge(this.#e,y))}show(y){this.a(),this.#t.$show(this.#e,!!y)}a(){if(this.#s)throw new Error("Webview is disposed")}}class a{constructor(y,u){this.d=u,this.b=new Map,this.c=new Map,this.a=y.getProxy(A.$rN.MainThreadWebviewViews)}registerWebviewViewProvider(y,u,E,d){if(this.b.has(u))throw new Error(`View provider for '${u}' already registered`);return this.b.set(u,{provider:E,extension:y}),this.a.$registerWebviewViewProvider((0,k.$ooc)(y),u,{retainContextWhenHidden:d?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,k.$moc)(y)}),new T.$tN(()=>{this.b.delete(u),this.a.$unregisterWebviewViewProvider(u)})}async $resolveWebviewView(y,u,E,d,n){const s=this.b.get(u);if(!s)throw new Error(`No view provider found for '${u}'`);const{provider:o,extension:h}=s,i=this.d.createNewWebview(y,{},h),r=new p(y,this.a,u,E,i,!0);this.c.set(y,r),await o.resolveWebviewView(r,{state:d},n)}async $onDidChangeWebviewViewVisibility(y,u){this.e(y)._setVisible(u)}async $disposeWebviewView(y){const u=this.e(y);this.c.delete(y),u.dispose(),this.d.deleteWebview(y)}e(y){const u=this.c.get(y);if(!u)throw new Error("No webview found");return u}}e.$Ypc=a}),define(ke[306],Ce([1,0,6,31,32,3]),function(oe,e,w,S,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NM=e.$MM=e.OutputChannelUpdateMode=e.$LM=e.$KM=e.$JM=e.$IM=e.$HM=e.$GM=e.$FM=e.$EM=e.$DM=e.$CM=e.$BM=e.$AM=e.$zM=void 0,e.$zM="text/x-code-output",e.$AM="output",e.$BM="Log",e.$CM="text/x-code-log-output",e.$DM="log",e.$EM="workbench.panel.output",e.$FM=new k.$Wj("inOutput",!1),e.$GM=new k.$Wj("activeLogOutput",!1),e.$HM=new k.$Wj("activeLogOutput.levelSettable",!1),e.$IM=new k.$Wj("activeLogOutput.level",""),e.$JM=new k.$Wj("activeLogOutput.levelIsDefault",!1),e.$KM=new k.$Wj("outputView.scrollLock",!1),e.$LM=(0,O.$Fi)("outputService");var A;(function(p){p[p.Append=1]="Append",p[p.Replace=2]="Replace",p[p.Clear=3]="Clear"})(A||(e.OutputChannelUpdateMode=A={})),e.$MM={OutputChannels:"workbench.contributions.outputChannels"};class T{constructor(){this.a=new Map,this.b=new w.$me,this.onDidRegisterChannel=this.b.event,this.c=new w.$me,this.onDidRemoveChannel=this.c.event}registerChannel(a){this.a.has(a.id)||(this.a.set(a.id,a),this.b.fire(a.id))}getChannels(){const a=[];return this.a.forEach(R=>a.push(R)),a}getChannel(a){return this.a.get(a)}removeChannel(a){this.a.delete(a),this.c.fire(a)}}S.$oo.add(e.$MM.OutputChannels,new T),e.$NM=new k.$Wj("activeOutputChannel","")}),define(ke[127],Ce([1,0,5,3,17,19,12,306,69,27,51,157,23,15,30,6,4]),function(oe,e,w,S,k,O,A,T,p,a,R,y,u,E,d,n,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cpc=e.$Bpc=void 0;class o extends A.$fk{get disposed(){return this.n}constructor(t,c,l,m,f){super(),this.id=t,this.name=c,this.r=l,this.s=m,this.extension=f,this.m=0,this.n=!1,this.visible=!1,this.setLevel(l.getLevel()),this.B(l.onDidChangeLogLevel($=>this.setLevel($)))}get logLevel(){return this.getLevel()}appendLine(t){this.append(t+`
`)}append(t){this.info(t)}clear(){const t=this.m;this.r.flush(),this.s.$update(this.id,T.OutputChannelUpdateMode.Clear,t)}replace(t){const c=this.m;this.info(t),this.s.$update(this.id,T.OutputChannelUpdateMode.Replace,c),this.visible&&this.r.flush()}show(t,c){this.r.flush(),this.s.$reveal(this.id,!!(typeof t=="boolean"?t:c))}hide(){this.s.$close(this.id)}g(t,c){this.m+=u.$Oe.fromString(c).byteLength,(0,A.log)(this.r,t,c),this.visible&&(this.r.flush(),this.s.$update(this.id,T.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.n||(this.s.$dispose(this.id),this.n=!0)}}class h extends o{appendLine(t){this.append(t)}}let i=class{constructor(t,c,l,m,f,$){this.i=c,this.j=l,this.k=m,this.l=f,this.m=$,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=t.getProxy(w.$rN.MainThreadOutputService),this.b=this.k.extUri.joinPath(c.logsLocation,`output_logging_${(0,y.$3m)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(t){this.h=t;for(const[c,l]of this.g)l.visible=c===this.h}createOutputChannel(t,c,l){if(t=t.trim(),!t)throw new Error("illegal argument `name`. must not be falsy");const m=typeof c=="object"&&c.log,f=(0,E.$fg)(c)?c:void 0;if((0,E.$fg)(f)&&!f.trim())throw new Error("illegal argument `languageId`. must not be empty");let $;const I=this.i.environment.extensionLogLevel?.find(([v])=>O.$qn.equals(l.identifier,v))?.[1];I&&($=(0,A.$qk)(I));const D=m?this.o(t,$,l):this.n(t,f,l);return D.then(v=>{this.g.set(v.id,v),v.visible=v.id===this.h}),m?this.r(t,$??this.m.getLevel(),D):this.q(t,D)}async n(t,c,l){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const m=await this.c,f=this.k.extUri.joinPath(m,`${this.f++}-${t.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),$=this.l.createLogger(f,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),I=await this.a.$register(t,f,c,l.identifier.value);return new o(I,t,$,this.a,l)}async o(t,c,l){const m=await this.p(l),f=t.replace(/[\\/:\*\?"<>\|]/g,""),$=this.k.extUri.joinPath(m,`${f}.log`),I=`${l.identifier.value}.${f}`,D=this.l.createLogger($,{id:I,name:t,logLevel:c,extensionId:l.identifier.value});return new h(I,t,D,this.a,l)}p(t){let c=this.d.get(t.identifier.value);if(!c){const l=this.k.extUri.joinPath(this.i.logsLocation,t.identifier.value);this.d.set(t.identifier.value,c=(async()=>{try{await this.j.value.createDirectory(l)}catch(m){if((0,d.$pl)(m)!==d.FileSystemProviderErrorCode.FileExists)throw m}return l})())}return c}q(t,c){let l=!1;const m=()=>{if(l)throw new Error("Channel has been closed")};return{get name(){return t},append(f){m(),c.then($=>$.append(f))},appendLine(f){m(),c.then($=>$.appendLine(f))},clear(){m(),c.then(f=>f.clear())},replace(f){m(),c.then($=>$.replace(f))},show(f,$){m(),c.then(I=>I.show(f,$))},hide(){m(),c.then(f=>f.hide())},dispose(){l=!0,c.then(f=>f.dispose())}}}r(t,c,l){const m=new s.$Vc,f=()=>{if(m.isDisposed)throw new Error("Channel has been closed")},$=m.add(new n.$me);function I(D){c=D,$.fire(D)}return l.then(D=>{m.add(D),D.logLevel!==c&&I(D.logLevel),m.add(D.onDidChangeLogLevel(v=>I(v)))}),{...this.q(t,l),get logLevel(){return c},onDidChangeLogLevel:$.event,trace(D,...v){f(),l.then(C=>C.trace(D,...v))},debug(D,...v){f(),l.then(C=>C.debug(D,...v))},info(D,...v){f(),l.then(C=>C.info(D,...v))},warn(D,...v){f(),l.then(C=>C.warn(D,...v))},error(D,...v){f(),l.then(C=>C.error(D,...v))},dispose(){m.dispose()}}}};e.$Bpc=i,e.$Bpc=i=He([Ve(0,k.$XP),Ve(1,a.$bQ),Ve(2,p.$ioc),Ve(3,R.$Xnc),Ve(4,A.$ak),Ve(5,A.$_j)],i),e.$Cpc=(0,S.$Fi)("IExtHostOutputService")}),define(ke[128],Ce([1,0,3,11]),function(oe,e,w,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wm=e.$Vm=void 0,e.$Vm=(0,w.$Fi)("remoteAgentService"),e.$Wm=new class{constructor(){this.maxSampleCount=5,this.sampleDelay=2e3,this.initial=[],this.maxInitialCount=3,this.average=[],this.maxAverageCount=100,this.highLatencyMultiple=2,this.highLatencyMinThreshold=500,this.highLatencyMaxThreshold=1500,this.lastMeasurement=void 0}get latency(){return this.lastMeasurement}async measure(k){let O=1/0;for(let T=0;T<this.maxSampleCount;T++){const p=await k.getRoundTripTime();if(p===void 0)return;O=Math.min(O,p/2),await(0,S.$Gh)(this.sampleDelay)}this.average.push(O),this.average.length>this.maxAverageCount&&this.average.shift();let A;return this.initial.length<this.maxInitialCount?this.initial.push(O):A=this.initial.reduce((T,p)=>T+p,0)/this.initial.length,this.lastMeasurement={initial:A,current:O,average:this.average.reduce((T,p)=>T+p,0)/this.average.length,high:typeof A>"u"?!1:O>this.highLatencyMaxThreshold||O>this.highLatencyMinThreshold&&O>A*this.highLatencyMultiple},this.lastMeasurement}}}),define(ke[307],Ce([1,0,192,54,31,50,42,4,6,128,21,26,11,113]),function(oe,e,w,S,k,O,A,T,p,a,R,y,u,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aL=e.$_K=e.$$K=e.$0K=e.$9K=e.$8K=e.$7K=e.$6K=e.$5K=e.$4K=void 0,e.$4K=Object.freeze({id:"application",order:100,title:(0,w.localize)(0,null),type:"object"}),e.$5K=Object.freeze({id:"workbench",order:7,title:(0,w.localize)(1,null),type:"object"}),e.$6K=Object.freeze({id:"security",scope:S.ConfigurationScope.APPLICATION,title:(0,w.localize)(2,null),type:"object",order:7}),e.$7K=Object.freeze({id:"problems",title:(0,w.localize)(3,null),type:"object",order:101}),e.$8K=Object.freeze({id:"window",order:8,title:(0,w.localize)(4,null),type:"object"}),e.$9K={ConfigurationMigration:"base.contributions.configuration.migration"};class d{constructor(){this.migrations=[],this.a=new p.$me,this.onDidRegisterConfigurationMigration=this.a.event}registerConfigurationMigrations(r){this.migrations.push(...r)}}const n=new d;k.$oo.add(e.$9K.ConfigurationMigration,n);let s=class extends T.$Wc{static{this.ID="workbench.contrib.configurationMigration"}constructor(r,t){super(),this.a=r,this.b=t,this.B(this.b.onDidChangeWorkspaceFolders(async c=>{for(const l of c.added)await this.f(l,n.migrations)})),this.c(n.migrations),this.B(n.onDidRegisterConfigurationMigration(c=>this.c(c)))}async c(r){await this.f(void 0,r);for(const t of this.b.getWorkspace().folders)await this.f(t,r)}async f(r,t){await Promise.all([t.map(c=>this.g(c,r?.uri))])}async g(r,t){const c=this.a.inspect(r.key,{resource:t}),l=this.b.getWorkbenchState()===O.WorkbenchState.WORKSPACE?[["user",A.ConfigurationTarget.USER],["userLocal",A.ConfigurationTarget.USER_LOCAL],["userRemote",A.ConfigurationTarget.USER_REMOTE],["workspace",A.ConfigurationTarget.WORKSPACE],["workspaceFolder",A.ConfigurationTarget.WORKSPACE_FOLDER]]:[["user",A.ConfigurationTarget.USER],["userLocal",A.ConfigurationTarget.USER_LOCAL],["userRemote",A.ConfigurationTarget.USER_REMOTE],["workspace",A.ConfigurationTarget.WORKSPACE]];for(const[m,f]of l){const $=c[m];if(!$)continue;const I=[];if($.value!==void 0){const D=await this.h(r,m,$.value,t,void 0);for(const v of D??[])I.push([v,[]])}for(const{identifiers:D,value:v}of $.overrides??[])if(v!==void 0){const C=await this.h(r,m,v,t,D);for(const P of C??[])I.push([P,D])}I.length&&await Promise.allSettled(I.map(async([[D,v],C])=>this.a.updateValue(D,v.value,{resource:t,overrideIdentifiers:C},f)))}}async h(r,t,c,l,m){const f=I=>{const v=this.a.inspect(I,{resource:l})[t];if(v)return m?v.overrides?.find(({identifiers:C})=>(0,y.$fo)(C,m))?.value:v.value},$=await r.migrateFn(c,f);return Array.isArray($)?$:[[r.key,$]]}};e.$0K=s,e.$0K=s=He([Ve(0,A.$_i),Ve(1,O.$Oi)],s);let o=class extends T.$Wc{static{this.ID="workbench.contrib.dynamicWorkbenchSecurityConfiguration"}constructor(r){super(),this.b=r,this.a=new u.$3h,this.ready=this.a.p,this.c()}async c(){try{await this.f()}finally{this.a.complete()}}async f(){if(!R.$i&&(await this.b.getEnvironment())?.os!==R.OperatingSystem.Windows)return;k.$oo.as(S.$to.Configuration).registerConfiguration({...e.$6K,properties:{"security.allowedUNCHosts":{type:"array",items:{type:"string",pattern:"^[^\\\\]+$",patternErrorMessage:(0,w.localize)(5,null)},default:[],markdownDescription:(0,w.localize)(6,null),scope:S.ConfigurationScope.MACHINE},"security.restrictUNCAccess":{type:"boolean",default:!0,markdownDescription:(0,w.localize)(7,null),scope:S.ConfigurationScope.MACHINE}}})}};e.$$K=o,e.$$K=o=He([Ve(0,a.$Vm)],o),e.$_K="window.newWindowProfile";let h=class extends T.$Wc{static{this.ID="workbench.contrib.dynamicWindowConfiguration"}constructor(r,t){super(),this.c=r,this.f=t,this.g(),this.B(this.c.onDidChangeProfiles(c=>this.g())),this.h(),this.j(),this.B(t.onDidChangeConfiguration(c=>{c.source!==A.ConfigurationTarget.DEFAULT&&c.affectsConfiguration(e.$_K)&&this.h()})),this.B(this.c.onDidChangeProfiles(()=>this.j()))}g(){const r=k.$oo.as(S.$to.Configuration),t={...e.$8K,properties:{[e.$_K]:{type:["string","null"],default:null,enum:[...this.c.profiles.map(c=>c.name),null],enumItemLabels:[...this.c.profiles.map(c=>""),(0,w.localize)(8,null)],description:(0,w.localize)(9,null),scope:S.ConfigurationScope.APPLICATION}}};this.a?r.updateConfigurations({add:[t],remove:[this.a]}):r.registerConfiguration(t),this.a=t}h(){const r=this.f.getValue(e.$_K);this.b=r?this.c.profiles.find(t=>t.name===r):void 0}j(){const r=this.f.getValue(e.$_K);if(!r)return;const t=this.b?this.c.profiles.find(c=>c.id===this.b.id):void 0;r!==t?.name&&this.f.updateValue(e.$_K,t?.name)}};e.$aL=h,e.$aL=h=He([Ve(0,E.$Ll),Ve(1,A.$_i)],h)}),define(ke[308],Ce([1,0,41,16,20,24,203,307,54,3,31]),function(oe,e,w,S,k,O,A,T,p,a,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ResolvedStatus=e.RegisteredEditorPriority=e.$cL=e.$bL=void 0,e.$dL=n,e.$eL=s,w=qe(w),e.$bL=(0,a.$Fi)("editorResolverService"),e.$cL="workbench.editorAssociations";const y=R.$oo.as(p.$to.Configuration),u={...T.$5K,properties:{"workbench.editorAssociations":{type:"object",markdownDescription:(0,A.localize)(0,null),additionalProperties:{type:"string"}}}};y.registerConfiguration(u);var E;(function(o){o.builtin="builtin",o.option="option",o.exclusive="exclusive",o.default="default"})(E||(e.RegisteredEditorPriority=E={}));var d;(function(o){o[o.ABORT=1]="ABORT",o[o.NONE=2]="NONE"})(d||(e.ResolvedStatus=d={}));function n(o){switch(o){case E.exclusive:return 5;case E.default:return 4;case E.builtin:return 3;case E.option:default:return 1}}function s(o,h){if(new Set([S.Schemas.extension,S.Schemas.webviewPanel,S.Schemas.vscodeWorkspaceTrust,S.Schemas.vscodeSettings]).has(h.scheme))return!1;const t=typeof o=="string"&&o.indexOf(k.$ic.sep)>=0?`${h.scheme}:${h.path}`:(0,O.$dh)(h);return w.$yk(typeof o=="string"?o.toLowerCase():o,t.toLowerCase())}}),define(ke[309],Ce([1,0,53,16,20,21,24,2,3,226,50,246,128]),function(oe,e,w,S,k,O,A,T,p,a,R,y,u){"use strict";var E;Object.defineProperty(e,"__esModule",{value:!0}),e.$7M=e.$6M=void 0,e.$6M=(0,p.$Fi)("pathService");let d=E=class{constructor(s,o,h,i){this.d=s,this.e=o,this.f=h,this.g=i,this.a=(async()=>(await this.e.getEnvironment())?.os||O.OS)(),this.b=(async()=>{const r=await this.e.getEnvironment();return this.c=r?.userHome??s})()}hasValidBasename(s,o,h){return typeof o=="string"||typeof o>"u"?this.a.then(i=>this.h(s,i,o)):this.h(s,o,h)}h(s,o,h){return s.scheme===S.Schemas.file||s.scheme===S.Schemas.vscodeRemote?(0,w.$Cg)(h??(0,A.$dh)(s),o===O.OperatingSystem.Windows):!0}get defaultUriScheme(){return E.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(s,o){if(s.remoteAuthority)return S.Schemas.vscodeRemote;const h=(0,a.$3M)(o.getWorkspace());if(h)return h;const i=o.getWorkspace().folders[0];if(i)return i.uri.scheme;const r=o.getWorkspace().configuration;return r?r.scheme:S.Schemas.file}userHome(s){return s?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(s=>s===O.OperatingSystem.Windows?k.$hc:k.$ic)}async fileURI(s){let o="";if(await this.a===O.OperatingSystem.Windows&&(s=s.replace(/\\/g,"/")),s[0]==="/"&&s[1]==="/"){const i=s.indexOf("/",2);i===-1?(o=s.substring(2),s="/"):(o=s.substring(2,i),s=s.substring(i)||"/")}return T.URI.from({scheme:S.Schemas.file,authority:o,path:s,query:"",fragment:""})}};e.$7M=d,e.$7M=d=E=He([Ve(1,u.$Vm),Ve(2,y.$OM),Ve(3,R.$Oi)],d)}),define(ke[129],Ce([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.$HL=e.$GL=void 0;class w{constructor(A,T){this.line=A,this.character=T}isBefore(A){return!1}isBeforeOrEqual(A){return!1}isAfter(A){return!1}isAfterOrEqual(A){return!1}isEqual(A){return!1}compareTo(A){return 0}translate(A,T){return new w(0,0)}with(A){return new w(0,0)}}e.$GL=w;class S{constructor(A,T,p,a){this.isEmpty=!1,this.isSingleLine=!1,this.start=new w(A,T),this.end=new w(p,a)}contains(A){return!1}isEqual(A){return!1}intersection(A){}union(A){return new S(0,0,0,0)}with(A){return new S(0,0,0,0)}}e.$HL=S;var k;(function(O){O[O.Information=1]="Information",O[O.Warning=2]="Warning"})(k||(e.TextSearchCompleteMessageType=k={}))}),define(ke[43],Ce([1,0,18,41,26,53,13,3,20,14,129,11]),function(oe,e,w,S,k,O,A,T,p,a,R,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8L=e.$6L=e.$YL=e.SearchErrorCode=e.SearchSortOrder=e.ViewMode=e.$VL=e.$UL=e.$TL=e.$SL=e.SearchCompletionExitCode=e.QueryType=e.SearchProviderType=e.$OL=e.$NL=e.$ML=e.$LL=e.$KL=e.$JL=e.$IL=e.TextSearchCompleteMessageType=void 0,e.$PL=o,e.$QL=h,e.$RL=i,e.$WL=D,e.$XL=v,e.$ZL=g,e.$1L=b,e.$2L=L,e.$3L=N,e.$4L=B,e.$5L=G,e.$7L=F,e.$9L=ge,e.$0L=te,S=qe(S),k=qe(k),O=qe(O),p=qe(p),Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return R.TextSearchCompleteMessageType}}),e.$IL="workbench.view.search",e.$JL="workbench.panel.search",e.$KL="workbench.view.search",e.$LL="search-result",e.$ML="search.exclude",e.$NL=2e4;const u="\u27EA ",E=" characters skipped \u27EB",d=(u.length+E.length+5)*2;e.$OL=(0,T.$Fi)("searchService");var n;(function(re){re[re.file=0]="file",re[re.text=1]="text",re[re.aiText=2]="aiText"})(n||(e.SearchProviderType=n={}));var s;(function(re){re[re.File=1]="File",re[re.Text=2]="Text",re[re.aiText=3]="aiText"})(s||(e.QueryType=s={}));function o(re){return!!re.preview}function h(re){return!!re.resource}function i(re){return!!re.message}var r;(function(re){re[re.Normal=0]="Normal",re[re.NewSearchStarted=1]="NewSearchStarted"})(r||(e.SearchCompletionExitCode=r={}));class t{constructor(ce){this.resource=ce,this.results=[]}}e.$SL=t;class c{constructor(ce,be,se,Ie){this.ranges=be,this.webviewIndex=Ie;const Ue=Array.isArray(be)?be:[be];if(se&&se.matchLines===1&&l(Ue)){ce=(0,A.$$f)(ce,se.matchLines);let Z="",V=0,_=0;const ye=Math.floor(se.charsPerLine/5),ae=[];for(const we of Ue){const he=Math.max(we.startColumn-ye,0),X=we.startColumn+se.charsPerLine;if(he>_+ye+d){const Y=u+(he-_)+E;Z+=Y+ce.slice(he,X),V+=he-(_+Y.length)}else Z+=ce.slice(_,X);ae.push(new f(0,we.startColumn-V,we.endColumn-V)),_=X}this.preview={text:Z,matches:Array.isArray(this.ranges)?ae:ae[0]}}else{const Z=Array.isArray(be)?be[0].startLineNumber:be.startLineNumber;this.preview={text:ce,matches:(0,w.$3b)(be,V=>new m(V.startLineNumber-Z,V.startColumn,V.endLineNumber-Z,V.endColumn))}}}}e.$TL=c;function l(re){const ce=re[0].startLineNumber;for(const be of re)if(be.startLineNumber!==ce||be.endLineNumber!==ce)return!1;return!0}class m{constructor(ce,be,se,Ie){this.startLineNumber=ce,this.startColumn=be,this.endLineNumber=se,this.endColumn=Ie}}e.$UL=m;class f extends m{constructor(ce,be,se){super(ce,be,ce,se)}}e.$VL=f;var $;(function(re){re.List="list",re.Tree="tree"})($||(e.ViewMode=$={}));var I;(function(re){re.Default="default",re.FileNames="fileNames",re.Type="type",re.Modified="modified",re.CountDescending="countDescending",re.CountAscending="countAscending"})(I||(e.SearchSortOrder=I={}));function D(re,ce=!0){const be=re&&re.files&&re.files.exclude,se=ce&&re&&re.search&&re.search.exclude;if(!be&&!se)return;if(!be||!se)return be||se;let Ie=Object.create(null);return Ie=k.$eo(Ie,k.$bo(be)),Ie=k.$eo(Ie,k.$bo(se),!0),Ie}function v(re,ce){return re.excludePattern&&S.$yk(re.excludePattern,ce)?!1:re.includePattern||re.usingSearchPaths?re.includePattern&&S.$yk(re.includePattern,ce)?!0:re.usingSearchPaths?!!re.folderQueries&&re.folderQueries.some(be=>{const se=be.folder.fsPath;if(O.$Eg(ce,se)){const Ie=p.$nc(se,ce);return!be.includePattern||!!S.$yk(be.includePattern,Ie)}else return!1}):!1:!0}var C;(function(re){re[re.unknownEncoding=1]="unknownEncoding",re[re.regexParseError=2]="regexParseError",re[re.globParseError=3]="globParseError",re[re.invalidLiteral=4]="invalidLiteral",re[re.rgProcessError=5]="rgProcessError",re[re.other=6]="other",re[re.canceled=7]="canceled"})(C||(e.SearchErrorCode=C={}));class P extends Error{constructor(ce,be){super(ce),this.code=be}}e.$YL=P;function g(re){const ce=re.message;if((0,a.$6)(re))return new P(ce,C.canceled);try{const be=JSON.parse(ce);return new P(be.message,be.code)}catch{return new P(ce,C.other)}}function b(re){const ce={message:re.message,code:re.code};return new Error(JSON.stringify(ce))}function L(re){return re.type==="error"?!0:re.type==="success"}function N(re){return re.type==="success"}function B(re){return!!re.path}function G(re,ce,be=!0){const se=re.searchPath?re.searchPath:re.relativePath;return be?(0,A.$8f)(se,ce):S.$yk(ce,se)}class W{constructor(ce){this.path=ce,this.results=[]}addMatch(ce){this.results.push(ce)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.$6L=W;function F(re,ce){const be={...re||{},...ce||{}};return Object.keys(be).filter(se=>{const Ie=be[se];return typeof Ie=="boolean"&&Ie})}class q{constructor(ce,be){this.c=null,this.a={...ce.excludePattern||{},...be.excludePattern||{}},this.b=S.$zk(this.a);let se=ce.includePattern;be.includePattern&&(se?se={...se,...be.includePattern}:se=be.includePattern),se&&(this.c=S.$zk(se))}matchesExcludesSync(ce,be,se){return!!(this.b&&this.b(ce,be,se))}includedInQuerySync(ce,be,se){return!(this.b&&this.b(ce,be,se)||this.c&&!this.c(ce,be,se))}includedInQuery(ce,be,se){const Ie=this.b(ce,be,se),Ue=()=>this.c?!!this.c(ce,be,se):!0;return(0,y.$rh)(Ie)?Ie.then(Z=>Z?!1:Ue()):Ue()}hasSiblingExcludeClauses(){return ue(this.a)}}e.$8L=q;function ue(re){for(const ce in re)if(typeof re[ce]!="boolean")return!0;return!1}function ge(re){if(!re)return;let ce;return be=>(ce||(ce=(re()||Promise.resolve([])).then(se=>se?me(se):{})),ce.then(se=>!!se[be]))}function te(re){if(!re)return;let ce;return be=>{if(!ce){const se=re();ce=se?me(se):{}}return!!ce[be]}}function me(re){const ce={};for(const be of re)ce[be]=!0;return ce}}),define(ke[44],Ce([1,0,18,11,22,6,4,59,16,138,24,13,2,191,30,3,12,214,50,51,27,17,10,7,66,43,5,49]),function(oe,e,w,S,k,O,A,T,p,a,R,y,u,E,d,n,s,o,h,i,r,t,c,l,m,f,$,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$doc=e.$coc=void 0;function D(B,G,W){return new R.$8g(F=>g(F,W)).isEqual(B,G)}function v(B,G,W){return D(B.uri,G.uri,W)?0:(0,y.$zf)(B.uri.toString(),G.uri.toString())}function C(B,G,W){return B.index!==G.index?B.index<G.index?-1:1:D(B.uri,G.uri,W)?(0,y.$zf)(B.name,G.name):(0,y.$zf)(B.uri.toString(),G.uri.toString())}function P(B,G,W,F){const q=B.slice(0).sort((ge,te)=>W(ge,te,F)),ue=G.slice(0).sort((ge,te)=>W(ge,te,F));return(0,w.$Gb)(q,ue,(ge,te)=>W(ge,te,F))}function g(B,G){const W=G.getCapabilities(B.scheme);return!(W&&W&d.FileSystemProviderCapabilities.PathCaseSensitive)}class b extends h.$Yi{static toExtHostWorkspace(G,W,F,q){if(!G)return{workspace:null,added:[],removed:[]};const{id:ue,name:ge,folders:te,configuration:me,transient:re,isUntitled:ce}=G,be=[],se=W;W?te.forEach((V,_)=>{const ye=u.URI.revive(V.uri),ae=b.o(F||W,ye,q);ae?(ae.name=V.name,ae.index=V.index,be.push(ae)):be.push({uri:ye,name:V.name,index:_})}):be.push(...te.map(({uri:V,name:_,index:ye})=>({uri:u.URI.revive(V),name:_,index:ye}))),be.sort((V,_)=>V.index<_.index?-1:1);const Ie=new b(ue,ge,be,!!re,me?u.URI.revive(me):null,!!ce,V=>g(V,q)),{added:Ue,removed:Z}=P(se?se.workspaceFolders:[],Ie.workspaceFolders,v,q);return{workspace:Ie,added:Ue,removed:Z}}static o(G,W,F){for(let q=0;q<G.folders.length;q++){const ue=G.workspaceFolders[q];if(D(ue.uri,W,F))return ue}}constructor(G,W,F,q,ue,ge,te){super(G,F.map(me=>new h.$Zi(me)),q,ue,te),this.t=W,this.u=ge,this.q=[],this.s=T.$Li.forUris(te,()=>!0),F.forEach(me=>{this.q.push(me),this.s.set(me.uri,me)})}get name(){return this.t}get isUntitled(){return this.u}get workspaceFolders(){return this.q.slice(0)}getWorkspaceFolder(G,W){return W&&this.s.get(G)&&(G=(0,R.$fh)(G)),this.s.findSubstr(G)}resolveWorkspaceFolder(G){return this.s.get(G)}}let L=class{constructor(G,W,F,q,ue){this.c=new O.$me,this.onDidChangeWorkspace=this.c.event,this.g=new O.$me,this.onDidGrantWorkspaceTrust=this.g.event,this.u=[],this.v=!1,this.w=new Map,this.A=0,this.B=new O.$oe,this.C=new Map,this.h=q,this.s=F,this.t=ue,this.j=new a.$Mm,this.k=new S.$Eh,this.o=G.getProxy($.$rN.MainThreadWorkspace),this.q=G.getProxy($.$rN.MainThreadMessageService);const ge=W.workspace;this.l=ge?new b(ge.id,ge.name,[],!!ge.transient,ge.configuration?u.URI.revive(ge.configuration):null,!!ge.isUntitled,te=>g(te,F)):void 0}$initializeWorkspace(G,W){this.v=W,this.$acceptWorkspaceData(G),this.k.open()}waitForInitializeCall(){return this.k.wait()}get workspace(){return this.x}get name(){return this.x?this.x.name:void 0}get workspaceFile(){if(this.x&&this.x.configuration)return this.x.isUntitled?u.URI.from({scheme:p.Schemas.untitled,path:(0,R.$dh)((0,R.$fh)(this.x.configuration))}):this.x.configuration}get x(){return this.n||this.l}getWorkspaceFolders(){if(this.x)return this.x.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.k.wait(),!!this.x)return this.x.workspaceFolders.slice(0)}updateWorkspaceFolders(G,W,F,...q){const ue=[];if(Array.isArray(q)&&q.forEach(ce=>{u.URI.isUri(ce.uri)&&!ue.some(be=>D(be.uri,ce.uri,this.s))&&ue.push({uri:ce.uri,name:ce.name||(0,R.$ch)(ce.uri)})}),this.n||[W,F].some(ce=>typeof ce!="number"||ce<0)||F===0&&ue.length===0)return!1;const ge=this.x?this.x.workspaceFolders:[];if(W+F>ge.length)return!1;const te=ge.slice(0);te.splice(W,F,...ue.map(ce=>({uri:ce.uri,name:ce.name||(0,R.$ch)(ce.uri),index:void 0})));for(let ce=0;ce<te.length;ce++){const be=te[ce];if(te.some((se,Ie)=>Ie!==ce&&D(be.uri,se.uri,this.s)))return!1}te.forEach((ce,be)=>ce.index=be);const{added:me,removed:re}=P(ge,te,C,this.s);if(me.length===0&&re.length===0)return!1;if(this.o){const ce=G.displayName||G.name;this.o.$updateWorkspaceFolders(ce,W,F,ue).then(void 0,be=>{this.n=void 0;const se={source:{identifier:G.identifier,label:G.displayName||G.name}};this.q.$showMessage(o.Severity.Error,(0,E.localize)(0,null,ce,be.toString()),se,[])})}return this.y(te),!0}getWorkspaceFolder(G,W){if(this.x)return this.x.getWorkspaceFolder(G,W)}async getWorkspaceFolder2(G,W){if(await this.k.wait(),!!this.x)return this.x.getWorkspaceFolder(G,W)}async resolveWorkspaceFolder(G){if(await this.k.wait(),!!this.x)return this.x.resolveWorkspaceFolder(G)}getPath(){if(!this.x)return;const{folders:G}=this.x;if(G.length!==0)return G[0].uri.fsPath}getRelativePath(G,W){let F,q="";if(typeof G=="string"?(F=u.URI.file(G),q=G):typeof G<"u"&&(F=G,q=G.fsPath),!F)return q;const ue=this.getWorkspaceFolder(F,!0);if(!ue)return q;typeof W>"u"&&this.x&&(W=this.x.folders.length>1);let ge=(0,R.$ih)(ue.uri,F);return W&&ue.name&&(ge=`${ue.name}/${ge}`),ge}y(G){this.x&&(this.n=b.toExtHostWorkspace({id:this.x.id,name:this.x.name,configuration:this.x.configuration,folders:G,isUntitled:this.x.isUntitled},this.x,void 0,this.s).workspace||void 0)}$acceptWorkspaceData(G){const{workspace:W,added:F,removed:q}=b.toExtHostWorkspace(G,this.l,this.n,this.s);this.l=W||void 0,this.n=void 0,this.c.fire(Object.freeze({added:F,removed:q}))}findFiles(G,W,F,q,ue=k.CancellationToken.None){this.h.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${q.value}, entryPoint: findFiles`);let ge="",te=!0;return W===null?te=!1:W!==void 0&&(typeof W=="string"?ge=W:ge=W.pattern),this.z(G,void 0,{exclude:ge,maxResults:F,useDefaultExcludes:te,useDefaultSearchExcludes:!1,useIgnoreFiles:!1},ue)}findFiles2(G,W={},F,q=k.CancellationToken.None){return this.h.trace(`extHostWorkspace#findFiles2: fileSearch, extension: ${F.value}, entryPoint: findFiles2`),this.z(void 0,G,W,q)}async z(G,W,F,q=k.CancellationToken.None){if(q&&q.isCancellationRequested)return Promise.resolve([]);const ue=typeof F.exclude=="string"?F.exclude:F.exclude?F.exclude.pattern:void 0,ge={ignoreSymlinks:typeof F.followSymlinks=="boolean"?!F.followSymlinks:void 0,disregardIgnoreFiles:typeof F.useIgnoreFiles=="boolean"?!F.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof F.useGlobalIgnoreFiles=="boolean"?!F.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof F.useParentIgnoreFiles=="boolean"?!F.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof F.useDefaultExcludes=="boolean"?!F.useDefaultExcludes:!1,disregardSearchExcludeSettings:typeof F.useDefaultSearchExcludes=="boolean"?!F.useDefaultSearchExcludes:!1,maxResults:F.maxResults,excludePattern:ue,shouldGlobSearch:typeof F.fuzzy=="boolean"?!F.fuzzy:!0,_reason:"startFileSearch"};let te;if(G){const{includePattern:me,folder:re}=N(c.GlobPattern.from(G));te=re,ge.includePattern=me}else{const{includePattern:me,folder:re}=N(c.GlobPattern.from(W));te=re,ge.filePattern=me}return this.o.$startFileSearch(te??null,ge,q).then(me=>Array.isArray(me)?me.map(re=>u.URI.revive(re)):[])}async findTextInFiles(G,W,F,q,ue=k.CancellationToken.None){this.h.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${q.value}, entryPoint: findTextInFiles`);const ge=this.j.getNext(),te=typeof W.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:W.previewOptions,{includePattern:me,folder:re}=N(c.GlobPattern.from(W.include)),ce=typeof W.exclude=="string"?W.exclude:W.exclude?W.exclude.pattern:void 0,be={ignoreSymlinks:typeof W.followSymlinks=="boolean"?!W.followSymlinks:void 0,disregardIgnoreFiles:typeof W.useIgnoreFiles=="boolean"?!W.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof W.useGlobalIgnoreFiles=="boolean"?!W.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof W.useParentIgnoreFiles=="boolean"?!W.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof W.useDefaultExcludes=="boolean"?!W.useDefaultExcludes:!0,fileEncoding:W.encoding,maxResults:W.maxResults,previewOptions:te,afterContext:W.afterContext,beforeContext:W.beforeContext,includePattern:me,excludePattern:ce},se=!1;if(this.u[ge]=Ie=>{if(se)return;const Ue=u.URI.revive(Ie.resource);Ie.results.forEach(Z=>{const V=(0,I.$ci)(Z);(0,f.$PL)(V)?F({uri:Ue,preview:{text:V.preview.text,matches:(0,w.$3b)(V.preview.matches,_=>new l.$vN(_.startLineNumber,_.startColumn,_.endLineNumber,_.endColumn))},ranges:(0,w.$3b)(V.ranges,_=>new l.$vN(_.startLineNumber,_.startColumn,_.endLineNumber,_.endColumn))}):F({uri:Ue,text:V.text,lineNumber:V.lineNumber})})},ue.isCancellationRequested)return{};try{const Ie=await this.o.$startTextSearch(G,re??null,be,ge,ue);return delete this.u[ge],Ie||{}}catch(Ie){throw delete this.u[ge],Ie}}$handleTextSearchResult(G,W){this.u[W]?.(G)}async save(G){const W=await this.o.$save(G,{saveAs:!1});return u.URI.revive(W)}async saveAs(G){const W=await this.o.$save(G,{saveAs:!0});return u.URI.revive(W)}saveAll(G){return this.o.$saveAll(G)}resolveProxy(G){return this.o.$resolveProxy(G)}loadCertificates(){return this.o.$loadCertificates()}get trusted(){return this.v}requestWorkspaceTrust(G){return this.o.$requestWorkspaceTrust(G)}$onDidGrantWorkspaceTrust(){this.v||(this.v=!0,this.g.fire())}registerEditSessionIdentityProvider(G,W){if(this.w.has(G))throw new Error(`A provider has already been registered for scheme ${G}`);this.w.set(G,W);const F=this.t.transformOutgoingScheme(G),q=this.A++;return this.o.$registerEditSessionIdentityProvider(q,F),(0,A.$Uc)(()=>{this.w.delete(G),this.o.$unregisterEditSessionIdentityProvider(q)})}async $getEditSessionIdentifier(G,W){this.h.info("Getting edit session identifier for workspaceFolder",G);const F=await this.resolveWorkspaceFolder(u.URI.revive(G));if(!F){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",F);const q=this.w.get(F.uri.scheme);if(this.h.info(`Provider for scheme ${F.uri.scheme} is defined: `,!!q),!q)return;const ue=await q.provideEditSessionIdentity(F,W);if(this.h.info("Provider returned edit session identifier: ",ue),!!ue)return ue}async $provideEditSessionIdentityMatch(G,W,F,q){this.h.info("Getting edit session identifier for workspaceFolder",G);const ue=await this.resolveWorkspaceFolder(u.URI.revive(G));if(!ue){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",ue);const ge=this.w.get(ue.uri.scheme);if(this.h.info(`Provider for scheme ${ue.uri.scheme} is defined: `,!!ge),!ge)return;const te=await ge.provideEditSessionIdentityMatch?.(W,F,q);if(this.h.info("Provider returned edit session identifier match result: ",te),!!te)return te}getOnWillCreateEditSessionIdentityEvent(G){return(W,F,q)=>{const ue=function(te){W.call(F,te)};return ue.extension=G,this.B.event(ue,void 0,q)}}async $onWillCreateEditSessionIdentity(G,W,F){const q=await this.resolveWorkspaceFolder(u.URI.revive(G));if(q===void 0)throw new Error("Unable to resolve workspace folder");await this.B.fireAsync({workspaceFolder:q},W,async(ue,ge)=>{const te=Date.now();await Promise.resolve(ue),Date.now()-te>F&&this.h.warn("SLOW edit session create-participant",ge.extension.identifier)}),W.isCancellationRequested}registerCanonicalUriProvider(G,W){if(this.C.has(G))throw new Error(`A provider has already been registered for scheme ${G}`);this.C.set(G,W);const F=this.t.transformOutgoingScheme(G),q=this.A++;return this.o.$registerCanonicalUriProvider(q,F),(0,A.$Uc)(()=>{this.C.delete(G),this.o.$unregisterCanonicalUriProvider(q)})}async provideCanonicalUri(G,W,F){const q=this.C.get(G.scheme);if(!q)return;const ue=await q.provideCanonicalUri?.(u.URI.revive(G),W,F);if(ue)return ue}async $provideCanonicalUri(G,W,F){return this.provideCanonicalUri(u.URI.revive(G),{targetScheme:W},F)}};e.$coc=L,e.$coc=L=He([Ve(0,t.$XP),Ve(1,r.$bQ),Ve(2,i.$Xnc),Ve(3,s.$_j),Ve(4,m.$aoc)],L),e.$doc=(0,n.$Fi)("IExtHostWorkspace");function N(B){let G,W;return B&&(typeof B=="string"?G=B:(G=B.pattern,W=u.URI.revive(B.baseUri))),{includePattern:G,folder:W}}}),define(ke[45],Ce([1,0,26,6,44,5,7,42,215,54,15,11,3,17,12,2]),function(oe,e,w,S,k,O,A,T,p,a,R,y,u,E,d,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$goc=e.$foc=e.$eoc=void 0;function s(m,f){if(f){const $=f.split(".");let I=m;for(let D=0;I&&D<$.length;D++)I=I[$[D]];return I}}function o(m){return m instanceof n.URI}function h(m){return m&&m.uri instanceof n.URI&&m.languageId&&typeof m.languageId=="string"}function i(m){return m&&!m.uri&&m.languageId&&typeof m.languageId=="string"}function r(m){return m&&m.uri instanceof n.URI&&(!m.name||typeof m.name=="string")&&(!m.index||typeof m.index=="number")}function t(m){if(o(m))return{resource:m};if(h(m))return{resource:m.uri,overrideIdentifier:m.languageId};if(i(m))return{overrideIdentifier:m.languageId};if(r(m))return{resource:m.uri};if(m===null)return{resource:null}}let c=class{constructor(f,$,I){this.a=f.getProxy(O.$rN.MainThreadConfiguration),this.c=$,this.b=I,this.d=new y.$Eh,this.e=null}getConfigProvider(){return this.d.wait().then(f=>this.e)}$initializeConfiguration(f){this.e=new l(this.a,this.c,f,this.b),this.d.open()}$acceptConfigurationChanged(f,$){this.getConfigProvider().then(I=>I.$acceptConfigurationChanged(f,$))}};e.$eoc=c,e.$eoc=c=He([Ve(0,E.$XP),Ve(1,k.$doc),Ve(2,d.$_j)],c);class l{constructor(f,$,I,D){this.a=new S.$me,this.b=f,this.f=D,this.c=$,this.e=p.$Mo.parse(I,D),this.d=this.k(I.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(f,$){const I={data:this.e.toData(),workspace:this.c.workspace};this.e=p.$Mo.parse(f,this.f),this.d=this.k(f.configurationScopes),this.a.fire(this.j($,I))}getConfiguration(f,$,I){const D=t($)||{},v=this.g(f?s(this.e.getValue(void 0,D,this.c.workspace),f):this.e.getValue(void 0,D,this.c.workspace));f&&this.h(f,D,I?.identifier);function C(g){if(g==null)return null;if(typeof g=="boolean")return g?T.ConfigurationTarget.USER:T.ConfigurationTarget.WORKSPACE;switch(g){case A.ConfigurationTarget.Global:return T.ConfigurationTarget.USER;case A.ConfigurationTarget.Workspace:return T.ConfigurationTarget.WORKSPACE;case A.ConfigurationTarget.WorkspaceFolder:return T.ConfigurationTarget.WORKSPACE_FOLDER}}const P={has(g){return typeof s(v,g)<"u"},get:(g,b)=>{this.h(f?`${f}.${g}`:g,D,I?.identifier);let L=s(v,g);if(typeof L>"u")L=b;else{let N;const B=(G,W)=>{if((0,R.$hg)(G)){let F;const q=()=>{N=N||(0,w.$bo)(v),F=F||s(N,W)};return new Proxy(G,{get:(ue,ge)=>{if(typeof ge=="string"&&ge.toLowerCase()==="tojson")return q(),()=>F;if(N)return F=F||s(N,W),F[ge];const te=ue[ge];return typeof ge=="string"?B(te,`${W}.${ge}`):te},set:(ue,ge,te)=>(q(),F&&(F[ge]=te),!0),deleteProperty:(ue,ge)=>(q(),F&&delete F[ge],!0),defineProperty:(ue,ge,te)=>(q(),F&&Object.defineProperty(F,ge,te),!0)})}return Array.isArray(G)?(0,w.$bo)(G):G};L=B(L,g)}return L},update:(g,b,L,N)=>{g=f?`${f}.${g}`:g;const B=C(L);return b!==void 0?this.b.$updateConfigurationOption(B,g,b,D,N):this.b.$removeConfigurationOption(B,g,D,N)},inspect:g=>{g=f?`${f}.${g}`:g;const b=this.e.inspect(g,D,this.c.workspace);if(b)return{key:g,defaultValue:(0,w.$bo)(b.policy?.value??b.default?.value),globalValue:(0,w.$bo)(b.user?.value??b.application?.value),workspaceValue:(0,w.$bo)(b.workspace?.value),workspaceFolderValue:(0,w.$bo)(b.workspaceFolder?.value),defaultLanguageValue:(0,w.$bo)(b.default?.override),globalLanguageValue:(0,w.$bo)(b.user?.override??b.application?.override),workspaceLanguageValue:(0,w.$bo)(b.workspace?.override),workspaceFolderLanguageValue:(0,w.$bo)(b.workspaceFolder?.override),languageIds:(0,w.$bo)(b.overrideIdentifiers)}}};return typeof v=="object"&&(0,w.$eo)(P,v,!1),Object.freeze(P)}g(f){const $=I=>(0,R.$hg)(I)?new Proxy(I,{get:(D,v)=>$(D[v]),set:(D,v,C)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(v)}' of object`)},deleteProperty:(D,v)=>{throw new Error(`TypeError: Cannot delete read only property '${String(v)}' of object`)},defineProperty:(D,v)=>{throw new Error(`TypeError: Cannot define property '${String(v)}' for a readonly object`)},setPrototypeOf:D=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):I;return $(f)}h(f,$,I){const D=a.$Do.test(f)?a.ConfigurationScope.RESOURCE:this.d.get(f),v=I?`[${I.value}] `:"";if(a.ConfigurationScope.RESOURCE===D){typeof $?.resource>"u"&&this.f.warn(`${v}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${f}', provide the URI of a resource or 'null' for any resource.`);return}if(a.ConfigurationScope.WINDOW===D){$?.resource&&this.f.warn(`${v}Accessing a window scoped configuration for a resource is not expected. To associate '${f}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(f,$){const I=new p.$Oo(f,$,this.e,this.c.workspace,this.f);return Object.freeze({affectsConfiguration:(D,v)=>I.affectsConfiguration(D,t(v))})}k(f){return f.reduce(($,I)=>($.set(I[0],I[1]),$),new Map)}}e.$foc=l,e.$goc=(0,u.$Fi)("IExtHostConfiguration")}),define(ke[130],Ce([1,0,2,11,6,5,7,44,58,45,22,57,17,27,3,16,21,12,85,251,14]),function(oe,e,w,S,k,O,A,T,p,a,R,y,u,E,d,n,s,o,h,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ppc=e.$Opc=e.$Npc=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0,A=qe(A),s=qe(s);var t;(function(N){function B(W){if(W!=null)return W}N.from=B;function G(W){if(W!=null)return W}N.to=G})(t||(t={}));var c;(function(N){function B(W){if(W!=null)return W}N.from=B;function G(W){if(W!=null)return W}N.to=G})(c||(c={}));var l;(function(N){function B(W){if(W!=null)return W}N.from=B;function G(W){if(W!=null)return W}N.to=G})(l||(l={}));var m;(function(N){function B(F){if(F){const q=F;return q&&!!q.process}else return!1}N.is=B;function G(F){if(F==null)return;const q={process:F.process,args:F.args};return F.options&&(q.options=l.from(F.options)),q}N.from=G;function W(F){if(F!=null)return new A.$dO(F.process,F.args,F.options)}N.to=W})(m||(m={}));var f;(function(N){function B(W){if(W!=null)return W}N.from=B;function G(W){if(W!=null)return W}N.to=G})(f||(f={}));var $;(function(N){function B(F){if(F){const q=F;return q&&(!!q.commandLine||!!q.command)}else return!1}N.is=B;function G(F){if(F==null)return;const q={};return F.commandLine!==void 0?q.commandLine=F.commandLine:(q.command=F.command,q.args=F.args),F.options&&(q.options=f.from(F.options)),q}N.from=G;function W(F){if(!(F==null||F.command===void 0&&F.commandLine===void 0))return F.commandLine?new A.$eO(F.commandLine,F.options):new A.$eO(F.command,F.args?F.args:[],F.options)}N.to=W})($||($={}));var I;(function(N){function B(F){if(F){const q=F;return q&&q.customExecution==="customExecution"}else return!1}N.is=B;function G(F){return{customExecution:"customExecution"}}N.from=G;function W(F,q){return q.get(F)}N.to=W})(I||(e.CustomExecutionDTO=I={}));var D;(function(N){function B(G,W){let F;return G.scope!==void 0&&typeof G.scope!="number"?F=G.scope.uri:G.scope!==void 0&&typeof G.scope=="number"&&(G.scope===A.TaskScope.Workspace&&W&&W.workspaceFile?F=W.workspaceFile:F=i.$FI),{id:G._id,workspaceFolder:F}}N.from=B})(D||(e.TaskHandleDTO=D={}));var v;(function(N){function B(G){if(G!=null)return{_id:G.id,isDefault:G.isDefault}}N.from=B})(v||(v={}));var C;(function(N){function B(F,q){if(F==null)return[];const ue=[];for(const ge of F){const te=G(ge,q);te&&ue.push(te)}return ue}N.fromMany=B;function G(F,q){if(F==null)return;let ue;F.execution instanceof A.$dO?ue=m.from(F.execution):F.execution instanceof A.$eO?ue=$.from(F.execution):F.execution&&F.execution instanceof A.$fO&&(ue=I.from(F.execution));const ge=t.from(F.definition);let te;return F.scope?typeof F.scope=="number"?te=F.scope:te=F.scope.uri:te=A.TaskScope.Workspace,!ge||!te?void 0:{_id:F._id,definition:ge,name:F.name,source:{extensionId:q.identifier.value,label:F.source,scope:te},execution:ue,isBackground:F.isBackground,group:v.from(F.group),presentationOptions:c.from(F.presentationOptions),problemMatchers:F.problemMatchers,hasDefinedMatchers:F.hasDefinedMatchers,runOptions:F.runOptions?F.runOptions:{reevaluateOnRerun:!0},detail:F.detail}}N.from=G;async function W(F,q,ue){if(F==null)return;let ge;m.is(F.execution)?ge=m.to(F.execution):$.is(F.execution)?ge=$.to(F.execution):I.is(F.execution)&&(ge=I.to(F._id,ue));const te=t.to(F.definition);let me;if(F.source&&(F.source.scope!==void 0?typeof F.source.scope=="number"?me=F.source.scope:me=await q.resolveWorkspaceFolder(w.URI.revive(F.source.scope)):me=A.TaskScope.Workspace),!te||!me)return;const re=new A.$gO(te,me,F.name,F.source.label,ge,F.problemMatchers);return F.isBackground!==void 0&&(re.isBackground=F.isBackground),F.group!==void 0&&(re.group=A.$cO.from(F.group._id),re.group&&F.group.isDefault&&(re.group=new A.$cO(re.group.id,re.group.label),F.group.isDefault===!0&&(re.group.isDefault=F.group.isDefault))),F.presentationOptions&&(re.presentationOptions=c.to(F.presentationOptions)),F._id&&(re._id=F._id),F.detail&&(re.detail=F.detail),re}N.to=W})(C||(e.TaskDTO=C={}));var P;(function(N){function B(W){return W}N.from=B;function G(W){if(W)return Object.assign(Object.create(null),W)}N.to=G})(P||(P={}));class g{#e;constructor(B,G,W){this._id=G,this.a=W,this.#e=B}get task(){return this.a}terminate(){this.#e.terminateTask(this)}fireDidStartProcess(B){}fireDidEndProcess(B){}}let b=class{constructor(B,G,W,F,q,ue,ge,te){this.q=new k.$me,this.r=new k.$me,this.s=new k.$me,this.u=new k.$me,this.a=B.getProxy(O.$rN.MainThreadTask),this.b=W,this.c=F,this.d=q,this.e=ue,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=ge,this.g=te,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(B,G,W){if(!W)return new A.$tN(()=>{});const F=this.x();return this.j.set(F,{type:G,provider:W,extension:B}),this.a.$registerTaskProvider(F,G),new A.$tN(()=>{this.j.delete(F),this.a.$unregisterTaskProvider(F)})}registerTaskSystem(B,G){this.a.$registerTaskSystem(B,G)}fetchTasks(B){return this.a.$fetchTasks(P.from(B)).then(async G=>{const W=[];for(const F of G){const q=await C.to(F,this.b,this.m);q&&W.push(q)}return W})}get taskExecutions(){const B=[];return this.k.forEach(G=>B.push(G)),B}terminateTask(B){if(!(B instanceof g))throw new Error("No valid task execution provided");return this.a.$terminateTask(B._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(B,G,W){const F=this.m.get(B.id);F&&(this.o.set(B.id,F),this.e.attachPtyToTerminal(G,await F.callback(W))),this.p=B.id,this.q.fire({execution:await this.z(B)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(B){if(!this.l.has(B.id))return;const G=await this.z(B);this.l.delete(B.id),this.k.delete(B.id),this.B(B),this.r.fire({execution:G})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(B){const G=await this.z(B.id);this.s.fire({execution:G,processId:B.processId})}get onDidEndTaskProcess(){return this.u.event}async $onDidEndTaskProcess(B){const G=await this.z(B.id);this.u.fire({execution:G,exitCode:B.exitCode})}$provideTasks(B,G){const W=this.j.get(B);if(!W)return Promise.reject(new Error("no handler found"));const F=[],q=(0,S.$xh)(()=>W.provider.provideTasks(R.CancellationToken.None)).then(ue=>this.v(G,F,W,ue));return new Promise(ue=>{q.then(ge=>{Promise.all(F).then(()=>{ue(ge)})})})}async $resolveTask(B,G){const W=this.j.get(B);if(!W)return Promise.reject(new Error("no handler found"));if(G.definition.type!==W.type)throw new Error(`Unexpected: Task of type [${G.definition.type}] cannot be resolved by provider of type [${W.type}].`);const F=await C.to(G,this.b,this.m);if(!F)throw new Error("Unexpected: Task cannot be resolved.");const q=await W.provider.resolveTask(F,R.CancellationToken.None);if(!q)return;this.A(q,W);const ue=C.from(q,W.extension);if(!ue)throw new Error("Unexpected: Task cannot be resolved.");if(q.definition!==F.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return I.is(ue.execution)&&await this.y(ue,q,!0),await this.w(ue)}x(){return this.h++}async y(B,G,W){const F=await this.a.$createTaskId(B);!W&&!this.m.has(F)&&(this.n.add(F),this.o.set(F,G.execution)),this.m.set(F,G.execution)}async z(B,G){if(typeof B=="string"){const q=this.l.get(B);if(!q)throw new r.$db("Unexpected: The specified task is missing an execution");return q}const W=this.l.get(B.id);if(W)return W;let F;return G?F=Promise.resolve(new g(this,B.id,G)):F=C.to(B.task,this.b,this.m).then(q=>{if(!q)throw new r.$db("Unexpected: Task does not exist.");return new g(this,B.id,q)}),this.l.set(B.id,F),F.then(q=>(this.k.set(B.id,q),q))}A(B,G){B._deprecated&&this.g.report("Task.constructor",G.extension,"Use the Task constructor that takes a `scope` instead.")}B(B){this.o.get(B.id)&&this.o.delete(B.id),this.n.has(B.id)&&this.p!==B.id&&(this.m.delete(B.id),this.n.delete(B.id));const W=this.n.values();let F=W.next();for(;!F.done;)!this.o.has(F.value)&&this.p!==F.value&&(this.m.delete(F.value),this.n.delete(F.value)),F=W.next()}};e.$Npc=b,e.$Npc=b=He([Ve(0,u.$XP),Ve(1,E.$bQ),Ve(2,T.$doc),Ve(3,p.$9P),Ve(4,a.$goc),Ve(5,y.$Eoc),Ve(6,o.$_j),Ve(7,h.$Tnc)],b);let L=class extends b{constructor(B,G,W,F,q,ue,ge,te){super(B,G,W,F,q,ue,ge,te),this.registerTaskSystem(n.Schemas.vscodeRemote,{scheme:n.Schemas.vscodeRemote,authority:"",platform:s.$h(s.Platform.Web)})}async executeTask(B,G){if(!G.execution)throw new Error("Tasks to execute must include an execution");const W=C.from(G,B);if(W===void 0)throw new Error("Task is not valid");if(I.is(W.execution))await this.y(W,G,!1);else throw new r.$bb;const F=await this.z(await this.a.$getTaskExecution(W),G);return this.a.$executeTask(W).catch(q=>{throw new Error(q)}),F}v(B,G,W,F){const q=[];if(F)for(const ue of F){if(this.A(ue,W),!ue.definition||!B[ue.definition.type]){const te=ue.source?ue.source:"No task source";this.f.warn(`The task [${te}, ${ue.name}] uses an undefined task type. The task will be ignored in the future.`)}const ge=C.from(ue,W.extension);ge&&I.is(ge.execution)?(q.push(ge),G.push(this.y(ge,ue,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:q,extension:W.extension}}async w(B){if(I.is(B.execution))return B;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(B,G){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(B,G,W){}};e.$Opc=L,e.$Opc=L=He([Ve(0,u.$XP),Ve(1,E.$bQ),Ve(2,T.$doc),Ve(3,p.$9P),Ve(4,a.$goc),Ve(5,y.$Eoc),Ve(6,o.$_j),Ve(7,h.$Tnc)],L),e.$Ppc=(0,d.$Fi)("IExtHostTask")}),define(ke[310],Ce([1,0,43,33]),function(oe,e,w,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eM=void 0,e.$dM=k,e.$fM=O;function k(A){return"cellResults"in A}e.$eM="rawCell#";function O(A,T){let p=-1;const a=[];let R=[];return A.forEach(u=>{u.range.startLineNumber!==p&&R.length>0&&(a.push([...R]),R=[]),R.push(u),p=u.range.endLineNumber}),R.length>0&&a.push([...R]),a.map(u=>{const E=[],d=u[0].range.startLineNumber,n=u[u.length-1].range.endLineNumber;for(let s=d;s<=n;s++)E.push(T.getLineContent(s));return new w.$TL(E.join(`
`)+`
`,u.map(s=>new S.$Ht(s.range.startLineNumber-1,s.range.startColumn-1,s.range.endLineNumber-1,s.range.endColumn-1)))})}}),define(ke[311],Ce([1,0,185,23,6,4,29,38,13,15,2,30,80,5,34,10,7,39,288,123,26,16,43,240,310,308]),function(oe,e,w,S,k,O,A,T,p,a,R,y,u,E,d,n,s,o,h,i,r,t,c,l,m,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qpc=void 0,y=qe(y),n=qe(n),s=qe(s);class ${static{this.a=0}get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(D=>D.apiEditor)}constructor(D,v,C,P,g,b,L){this.q=C,this.r=P,this.s=g,this.t=b,this.u=L,this.f=new Map,this.g=new A.$Cc,this.h=new Map,this.j=new k.$me,this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new k.$me,this.onDidOpenNotebookDocument=this.m.event,this.n=new k.$me,this.onDidCloseNotebookDocument=this.n.event,this.o=new k.$me,this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new u.$Rnc("NotebookCellStatusBarCache"),this.x=0,this.y=new Map,this.b=D.getProxy(E.$rN.MainThreadNotebook),this.c=D.getProxy(E.$rN.MainThreadNotebookDocuments),this.d=D.getProxy(E.$rN.MainThreadNotebookEditors),this.i=v.converter,v.registerArgumentProcessor({processArgument:N=>{if(N&&N.$mid===T.MarshalledId.NotebookCellActionContext){const B=N.notebookEditor?.notebookUri,G=N.cell.handle,F=this.g.get(B)?.getCell(G);if(F)return F.apiCell}if(N&&N.$mid===T.MarshalledId.NotebookActionContext){const B=N.uri,G=this.g.get(B);if(G)return G.apiNotebook}return N}}),$.C(v)}getEditorById(D){const v=this.h.get(D);if(!v)throw new Error(`unknown text editor: ${D}. known editors: ${[...this.h.keys()]} `);return v}getIdByEditor(D){for(const[v,C]of this.h)if(C.apiEditor===D)return v}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(D,v){const C=this.g.get(D);if(!C&&!v)throw new Error(`NO notebook document for '${D}'`);return C}static w(D,v){if(!v)return;const C=v.filenamePattern.map(P=>n.NotebookExclusiveDocumentPattern.from(P)).filter(P=>P!==void 0);if(v.filenamePattern&&!C){console.warn(`Notebook content provider view options file name pattern is invalid ${v.filenamePattern}`);return}return{extension:D.identifier,providerDisplayName:D.displayName||D.name,displayName:v.displayName,filenamePattern:C,priority:v.exclusive?f.RegisteredEditorPriority.exclusive:void 0}}registerNotebookCellStatusBarItemProvider(D,v,C){const P=$.a++,g=typeof C.onDidChangeCellStatusBarItems=="function"?$.a++:void 0;this.f.set(P,C),this.b.$registerNotebookCellStatusBarItemProvider(P,g,v);let b;return g!==void 0&&(b=C.onDidChangeCellStatusBarItems(L=>this.b.$emitCellStatusBarEvent(g))),new s.$tN(()=>{this.f.delete(P),this.b.$unregisterNotebookCellStatusBarItemProvider(P,g),b?.dispose()})}async createNotebookDocument(D){const v=await this.c.$tryCreateNotebook({viewType:D.viewType,content:D.content&&n.NotebookData.from(D.content)});return R.URI.revive(v)}async openNotebookDocument(D){const v=this.g.get(D);if(v)return v.apiNotebook;const C=await this.c.$tryOpenNotebook(D),P=this.g.get(R.URI.revive(C));return(0,a.$qg)(P?.apiNotebook)}async showNotebookDocument(D,v){R.URI.isUri(D)&&(D=await this.openNotebookDocument(D));let C;typeof v=="object"?C={position:n.ViewColumn.from(v.viewColumn),preserveFocus:v.preserveFocus,selections:v.selections&&v.selections.map(n.NotebookRange.from),pinned:typeof v.preview=="boolean"?!v.preview:void 0}:C={preserveFocus:!1};const P=await this.d.$tryShowNotebookDocument(D.uri,D.notebookType,C),g=P&&this.h.get(P)?.apiEditor;if(g)return g;throw P?new Error(`Could NOT open editor for "${D.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${D.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(D,v,C,P){const g=this.f.get(D),b=R.URI.revive(v),L=this.g.get(b);if(!L||!g)return;const N=L.getCellFromIndex(C);if(!N)return;const B=await g.provideCellStatusBarItems(N.apiCell,P);if(!B)return;const G=new O.$Vc,W=this.p.add([G]),q=(Array.isArray(B)?B:[B]).map(ue=>n.NotebookStatusBarItem.from(ue,this.i,G));return{cacheId:W,items:q}}$releaseNotebookCellStatusBarItems(D){this.p.delete(D)}registerNotebookSerializer(D,v,C,P,g){if((0,p.$df)(v))throw new Error("viewType cannot be empty or just whitespace");const b=this.x++;return this.y.set(b,{viewType:v,serializer:C,options:P}),this.b.$registerNotebookSerializer(b,{id:D.identifier,location:D.extensionLocation},v,n.NotebookDocumentContentOptions.from(P),$.w(D,g)),(0,O.$Uc)(()=>{this.b.$unregisterNotebookSerializer(b)})}async $dataToNotebook(D,v,C){const P=this.y.get(D);if(!P)throw new Error("NO serializer found");const g=await P.serializer.deserializeNotebook(v.buffer,C);return new o.$Pw(n.NotebookData.from(g))}async $notebookToData(D,v,C){const P=this.y.get(D);if(!P)throw new Error("NO serializer found");const g=await P.serializer.serializeNotebook(n.NotebookData.to(v.value),C);return S.$Oe.wrap(g)}async $saveNotebook(D,v,C,P,g){const b=R.URI.revive(v),L=this.y.get(D);if(this.D(`enter saveNotebook(versionId: ${C}, ${b.toString()})`),!L)throw new Error("NO serializer found");const N=this.g.get(b);if(!N)throw new Error("Document NOT found");if(N.versionId!==C)throw new Error("Document version mismatch");if(!this.s.value.isWritableFileSystem(b.scheme))throw new y.$ul((0,w.localize)(0,null,this.A(b)),y.FileOperationResult.FILE_PERMISSION_DENIED);const B={metadata:(0,r.$jo)(N.apiNotebook.metadata,ue=>!(L.options?.transientDocumentMetadata??{})[ue]),cells:[]};for(const ue of N.apiNotebook.getCells()){const ge=new s.$WO(ue.kind,ue.document.getText(),ue.document.languageId,ue.mime,L.options?.transientOutputs?[]:[...ue.outputs],ue.metadata,ue.executionSummary);ge.metadata=(0,r.$jo)(ue.metadata,te=>!(L.options?.transientCellMetadata??{})[te]),B.cells.push(ge)}if(await this.z(b,P),g.isCancellationRequested)throw new Error("canceled");const G=await L.serializer.serializeNotebook(B,g);if(g.isCancellationRequested)throw new Error("canceled");this.D(`serialized versionId: ${C} ${b.toString()}`),await this.s.value.writeFile(b,G),this.D(`Finished write versionId: ${C} ${b.toString()}`);const W=this.s.getFileSystemProviderExtUri(b.scheme),F=await this.s.value.stat(b),q={name:W.basename(b),isFile:(F.type&y.FileType.File)!==0,isDirectory:(F.type&y.FileType.Directory)!==0,isSymbolicLink:(F.type&y.FileType.SymbolicLink)!==0,mtime:F.mtime,ctime:F.ctime,size:F.size,readonly:!!((F.permissions??0)&y.FilePermission.Readonly)||!this.s.value.isWritableFileSystem(b.scheme),locked:!!((F.permissions??0)&y.FilePermission.Locked),etag:y.$Fl({mtime:F.mtime,size:F.size}),children:void 0};return this.D(`exit saveNotebook(versionId: ${C}, ${b.toString()})`),q}async $searchInNotebooks(D,v,C,P,g){const b=this.y.get(D)?.serializer;if(!b)return{limitHit:!1,results:[]};const L=new A.$Dc;await(async(F,q,ue)=>{await Promise.all(F.map(async ge=>await Promise.all(ge.filenamePatterns.map(te=>{const me={_reason:ue._reason,folderQueries:ue.folderQueries,includePattern:ue.includePattern,excludePattern:ue.excludePattern,maxResults:ue.maxResults,type:c.QueryType.File,filePattern:te};return this.t.doInternalFileSearchWithCustomCallback(me,q,re=>{re.forEach(ce=>{L.has(ce)||P.some(se=>ge.isFromSettings&&!se.isFromSettings?!1:se.filenamePatterns.some(Ie=>(0,f.$eL)(Ie,ce)))||L.add(ce)})}).catch(re=>{if(re.code==="ENOENT")return console.warn("Could not find notebook search results, ignoring notebook results."),{limitHit:!1,messages:[]};throw re})}))))})(C,g,v);const B=new A.$Cc;let G=!1;const W=Array.from(L).map(async F=>{const q=[];try{if(g.isCancellationRequested)return;if(v.maxResults&&[...B.values()].reduce((me,re)=>me+re.cellResults.length,0)>v.maxResults){G=!0;return}const ue=[],ge=this.g.get(F);if(ge)ge.apiNotebook.getCells().forEach(re=>ue.push({input:re.document.getText(),outputs:re.outputs.flatMap(ce=>ce.items.map(be=>be.data.toString()))}));else{const me=await this.s.value.readFile(F),re=S.$Oe.fromString(me.toString()),ce=await b.deserializeNotebook(re.buffer,g);if(g.isCancellationRequested)return;n.NotebookData.from(ce).cells.forEach(se=>ue.push({input:se.source,outputs:se.outputs.flatMap(Ie=>Ie.items.map(Ue=>Ue.valueBytes.toString()))}))}if(g.isCancellationRequested)return;ue.forEach((me,re)=>{const ce=v.contentPattern.pattern,be=new l.$cZb(me.input,void 0,me.outputs),se=be.findInInputs(ce),Ie=be.findInOutputs(ce),Ue=Ie.flatMap(Z=>(0,m.$fM)(Z.matches,Z.textBuffer)).map((Z,V)=>(Z.webviewIndex=V,Z));if(se.length>0||Ie.length>0){const Z={index:re,contentResults:(0,m.$fM)(se,be.inputTextBuffer),webviewResults:Ue};q.push(Z)}});const te={resource:F,cellResults:q};B.set(F,te);return}catch{return}});return await Promise.all(W),{limitHit:G,results:[...B.values()]}}async z(D,v){const C=await this.s.value.stat(D);if(typeof v?.mtime=="number"&&typeof v.etag=="string"&&v.etag!==y.$El&&typeof C.mtime=="number"&&typeof C.size=="number"&&v.mtime<C.mtime&&v.etag!==y.$Fl({mtime:v.mtime,size:C.size}))throw new y.$ul((0,w.localize)(1,null),y.FileOperationResult.FILE_MODIFIED_SINCE,v)}A(D){return D.scheme===t.Schemas.file?D.fsPath:D.toString()}B(D,v,C){if(this.h.has(v))throw new Error(`editor with id ALREADY EXSIST: ${v}`);const P=new i.$hpc(v,this.d,D,C.visibleRanges.map(n.NotebookRange.to),C.selections.map(n.NotebookRange.to),typeof C.viewColumn=="number"?n.ViewColumn.to(C.viewColumn):void 0);this.h.set(v,P)}$acceptDocumentAndEditorsDelta(D){if(D.value.removedDocuments)for(const C of D.value.removedDocuments){const P=R.URI.revive(C),g=this.g.get(P);g&&(g.dispose(),this.g.delete(P),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:g.apiNotebook.getCells().map(b=>b.document.uri)}),this.n.fire(g.apiNotebook));for(const b of this.h.values())b.notebookData.uri.toString()===P.toString()&&this.h.delete(b.id)}if(D.value.addedDocuments){const C=[];for(const P of D.value.addedDocuments){const g=R.URI.revive(P.uri);if(this.g.has(g))throw new Error(`adding EXISTING notebook ${g} `);const b=new h.$gpc(this.c,this.q,this.r,g,P);C.push(...P.cells.map(L=>h.$fpc.asModelAddData(L))),this.g.get(g)?.dispose(),this.g.set(g,b),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:C}),this.m.fire(b.apiNotebook)}}if(D.value.addedEditors)for(const C of D.value.addedEditors){if(this.h.has(C.id))return;const P=R.URI.revive(C.documentUri),g=this.g.get(P);g&&this.B(g,C.id,C)}const v=[];if(D.value.removedEditors)for(const C of D.value.removedEditors){const P=this.h.get(C);P&&(this.h.delete(C),this.k?.id===P.id&&(this.k=void 0),v.push(P))}if(D.value.visibleEditors){this.l=D.value.visibleEditors.map(P=>this.h.get(P)).filter(P=>!!P);const C=new Set;this.l.forEach(P=>C.add(P.id));for(const P of this.h.values()){const g=C.has(P.id);P._acceptVisibility(g)}this.l=[...this.h.values()].map(P=>P).filter(P=>P.visible),this.o.fire(this.visibleNotebookEditors)}D.value.newActiveEditor===null?this.k=void 0:D.value.newActiveEditor&&(this.h.get(D.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${D.value.newActiveEditor}`),this.k=this.h.get(D.value.newActiveEditor)),D.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static C(D){const v=d.$jQ.String.with("notebookType","A notebook type"),C=new d.$lQ("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[v,new d.$jQ("data","Bytes to convert to data",g=>g instanceof Uint8Array,g=>S.$Oe.wrap(g))],new d.$kQ("Notebook Data",g=>n.NotebookData.to(g.value))),P=new d.$lQ("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[v,new d.$jQ("NotebookData","Notebook data to convert to bytes",g=>!0,g=>new o.$Pw(n.NotebookData.from(g)))],new d.$kQ("Bytes",g=>g.buffer));D.registerApiCommand(C),D.registerApiCommand(P)}D(D){this.u.trace(`[Extension Host Notebook] ${D}`)}}e.$qpc=$}),define(ke[312],Ce([1,0,20,22,48,41,24,70,43]),function(oe,e,w,S,k,O,A,T,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ipc=void 0,w=qe(w),O=qe(O),A=qe(A);class a{constructor(u,E,d){this.k=u,this.l=E,this.o=d,this.e=!1,this.f=0,this.g=!1,this.a=u.filePattern,this.b=u.includePattern&&O.$zk(u.includePattern),this.c=u.maxResults||void 0,this.d=u.exists,this.h=new Set,this.j=u.excludePattern&&O.$zk(u.excludePattern)}cancel(){this.g=!0,this.h.forEach(u=>u.cancel()),this.h=new Set}search(u){const E=this.k.folderQueries||[];return new Promise((d,n)=>{const s=o=>{this.f++,u(o)};if(this.g)return d({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(o=>{const h=o.toString(),i=w.$pc(h);this.j&&this.j(h,i)||this.v(s,{base:o,basename:i})}),Promise.all(E.map(o=>this.p(o,s))).then(o=>{d({limitHit:this.e,stats:o[0]||void 0})},o=>{n(new Error((0,k.$qj)(o)))})})}async p(u,E){const d=new S.$xe,n=this.q(u),s=this.r(),o=new p.$8L(this.k,u),h=!o.hasSiblingExcludeClauses();let i;try{this.h.add(d),i=T.$ge.create();const r=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},n,d.token),t=i.elapsed(),c=T.$ge.create();return this.g&&!this.e||(r&&r.forEach(l=>{const m=w.$ic.relative(u.folder.path,l.path);if(h){const f=w.$pc(l.path);this.v(E,{base:u.folder,relativePath:m,basename:f});return}this.s(s,u.folder,m,E)}),this.g&&!this.e)?null:(this.u(s,o,E),{providerTime:t,postProcessTime:c.elapsed()})}finally{d.dispose(),this.h.delete(d)}}q(u){const E=(0,p.$7L)(this.k.includePattern,u.includePattern),d=(0,p.$7L)(this.k.excludePattern,u.excludePattern);return{folder:u.folder,excludes:d,includes:E,useIgnoreFiles:!u.disregardIgnoreFiles,useGlobalIgnoreFiles:!u.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!u.disregardParentIgnoreFiles,followSymlinks:!u.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const u={rootEntries:[],pathToEntries:Object.create(null)};return u.pathToEntries["."]=u.rootEntries,u}s({pathToEntries:u},E,d,n){if(d===this.a){const o=w.$pc(this.a);this.v(n,{base:E,relativePath:this.a,basename:o})}function s(o){const h=w.$pc(o),i=w.$oc(o);let r=u[i];r||(r=u[i]=[],s(i)),r.push({base:E,relativePath:o,basename:h})}s(d)}u({rootEntries:u,pathToEntries:E},d,n){const s=this,o=this.a;function h(i){const r=(0,p.$0L)(()=>i.map(t=>t.basename));for(let t=0,c=i.length;t<c;t++){const l=i[t],{relativePath:m,basename:f}=l;if(d.matchesExcludesSync(m,f,o!==f?r:void 0))continue;const $=E[m];if($)h($);else{if(m===o)continue;s.v(n,l)}if(s.e)break}}h(u)}v(u,E){(!this.b||E.relativePath&&this.b(E.relativePath,E.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||u(E))}}class R{constructor(){this.b=new Map}static{this.a=512}fileSearch(u,E,d,n){const s=this.c(u.cacheKey),o=new a(u,E,s&&s.token);let h=0;const i=r=>{h+=r.length,d(r.map(t=>this.d(t)))};return this.e(o,R.a,i,n).then(r=>({limitHit:r.limitHit,stats:r.stats?{fromCache:!1,type:"fileSearchProvider",resultCount:h,detailStats:r.stats}:void 0,messages:[]}))}clearCache(u){this.c(u)?.cancel()}c(u){if(u)return this.b.has(u)||this.b.set(u,new S.$xe),this.b.get(u)}d(u){return u.relativePath?{resource:A.$gh(u.base,u.relativePath)}:{resource:u.base}}e(u,E,d,n){const s=n.onCancellationRequested(()=>{u.cancel()}),o=i=>{i&&(h.push(i),E>0&&h.length>=E&&(d(h),h=[]))};let h=[];return u.search(o).then(i=>(h.length&&d(h),s.dispose(),i),i=>(h.length&&d(h),s.dispose(),Promise.reject(i)))}}e.$ipc=R}),define(ke[313],Ce([1,0,18,283,41,103,29,16,20,24,13,15,2,102,205,42,12,50,117,309,43]),function(oe,e,w,S,k,O,A,T,p,a,R,y,u,E,d,n,s,o,h,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8M=void 0,e.$9M=v,w=qe(w),S=qe(S),k=qe(k),p=qe(p),R=qe(R),d=qe(d);let t=class{constructor(P,g,b,L,N){this.a=P,this.b=g,this.c=b,this.d=L,this.e=N}text(P,g,b={}){P=this.f(P,b);const L=this.a.getValue(),N=g&&g.some(G=>!this.a.getValue({resource:G}).search.useRipgrep);return{...this.h(g?.map(o.$1i),b),type:r.QueryType.Text,contentPattern:P,previewOptions:b.previewOptions,maxFileSize:b.maxFileSize,usePCRE2:L.search.usePCRE2||N||!1,beforeContext:b.beforeContext,afterContext:b.afterContext,userDisabledExcludesAndIgnoreFiles:b.disregardExcludeSettings&&b.disregardIgnoreFiles}}f(P,g){const b=this.a.getValue();P.isRegExp&&(P.pattern=P.pattern.replace(/\r?\n/g,"\\n"));const L={...P,wordSeparators:b.editor.wordSeparators};return this.j(P,g)&&(L.isCaseSensitive=!0),this.k(P)&&(L.isMultiline=!0),g.notebookSearchConfig?.includeMarkupInput&&(L.notebookInfo||(L.notebookInfo={}),L.notebookInfo.isInNotebookMarkdownInput=g.notebookSearchConfig.includeMarkupInput),g.notebookSearchConfig?.includeMarkupPreview&&(L.notebookInfo||(L.notebookInfo={}),L.notebookInfo.isInNotebookMarkdownPreview=g.notebookSearchConfig.includeMarkupPreview),g.notebookSearchConfig?.includeCodeInput&&(L.notebookInfo||(L.notebookInfo={}),L.notebookInfo.isInNotebookCellInput=g.notebookSearchConfig.includeCodeInput),g.notebookSearchConfig?.includeOutput&&(L.notebookInfo||(L.notebookInfo={}),L.notebookInfo.isInNotebookCellOutput=g.notebookSearchConfig.includeOutput),L}file(P,g={}){return{...this.h(P,g),type:r.QueryType.File,filePattern:g.filePattern?g.filePattern.trim():g.filePattern,exists:g.exists,sortByScore:g.sortByScore,cacheKey:g.cacheKey,shouldGlobMatchFilePattern:g.shouldGlobSearch}}g(P,g){return P?(P=Array.isArray(P)?P.map($):$(P),g?this.parseSearchPaths(P):{pattern:l(...Array.isArray(P)?P:[P])}):{}}h(P=[],g={}){const b=this.g(g.includePattern,g.expandPatterns),L=this.g(g.excludePattern,g.expandPatterns),N=P.length>1,B=(b.searchPaths&&b.searchPaths.length?b.searchPaths.map(F=>this.q(F,g,L)):P.map(F=>this.r(F,g,L,N))).filter(F=>!!F),G={_reason:g._reason,folderQueries:B,usingSearchPaths:!!(b.searchPaths&&b.searchPaths.length),extraFileResources:g.extraFileResources,excludePattern:L.pattern,includePattern:b.pattern,onlyOpenEditors:g.onlyOpenEditors,maxResults:g.maxResults};if(g.onlyOpenEditors){const F=w.$Jb(this.c.groups.flatMap(ge=>ge.editors.map(te=>te.resource)));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(F));const q=F.filter(ge=>(0,r.$XL)(G,ge.fsPath)),ue=this.i(q);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(ue)),{...G,...ue}}const W=g.extraFileResources&&g.extraFileResources.filter(F=>(0,r.$XL)(G,F.fsPath));return G.extraFileResources=W&&W.length?W:void 0,G}i(P){const g=[],b=new A.$Cc,L={};let N=!1;return P.forEach(B=>{if(B.scheme===T.Schemas.walkThrough)return;if((0,a.$kh)(B)){const W=this.b.getWorkspaceFolder(B)?.uri??B.with({path:p.$oc(B.fsPath)});let F=b.get(W);F||(N=!0,F={folder:W,includePattern:{}},g.push(F),b.set(W,F));const q=p.$nc(W.fsPath,B.fsPath);(0,y.$qg)(F.includePattern)[q.replace(/\\/g,"/")]=!0}else B.fsPath&&(N=!0,L[B.fsPath]=!0)}),{folderQueries:g,includePattern:L,usingSearchPaths:!0,excludePattern:N?void 0:{"**/*":!0}}}j(P,g){if(g.isSmartCase){if(P.isRegExp){if(R.$9f(P.pattern,!0))return!0}else if(R.$9f(P.pattern))return!0}return!!P.isCaseSensitive}k(P){return P.isMultiline||P.isRegExp&&(0,E.$0C)(P.pattern)||P.pattern.indexOf(`
`)>=0?!0:!!P.isMultiline}parseSearchPaths(P){const g=ue=>p.$kc(ue)||/^\.\.?([\/\\]|$)/.test(ue),L=(Array.isArray(P)?P:m(P)).map(ue=>{const ge=this.e.resolvedUserHome;return ge?(0,O.$Uw)(ue,ge.scheme===T.Schemas.file?ge.fsPath:ge.path):ue}),N=S.$K(L,ue=>g(ue)?"searchPaths":"exprSegments"),B=(N.exprSegments||[]).map(ue=>R.$of(ue,"/")).map(ue=>R.$of(ue,"\\")).map(ue=>(ue[0]==="."&&(ue="*"+ue),f(ue))),G={},W=this.m(N.searchPaths||[]);W&&W.length&&(G.searchPaths=W);const F=B.flat(),q=l(...F);return q&&(G.pattern=q),G}l(P,g){return g.disregardExcludeSettings?void 0:(0,r.$WL)(P,!g.disregardSearchExcludeSettings)}m(P){if(!P||!P.length)return[];const g=P.flatMap(L=>{let{pathPortion:N,globPortion:B}=c(L);return B&&(B=I(B)),this.n(N).flatMap(W=>this.o(W,B))}),b=new Map;return g.forEach(L=>{const N=L.searchPath.toString(),B=b.get(N);B?L.pattern&&(B.pattern=B.pattern||{},B.pattern[L.pattern]=!0):b.set(N,{searchPath:L.searchPath,pattern:L.pattern?l(L.pattern):void 0})}),Array.from(b.values())}n(P){if(p.$kc(P)){const g=this.b.getWorkspace().folders;return g[0]&&g[0].uri.scheme!==T.Schemas.file?[{searchPath:g[0].uri.with({path:P})}]:[{searchPath:u.URI.file(p.$jc(P))}]}if(this.b.getWorkbenchState()===o.WorkbenchState.FOLDER){const g=this.b.getWorkspace().folders[0].uri;if(P=$(P),P.startsWith("../")||P===".."){const L=p.$ic.resolve(g.path,P);return[{searchPath:g.with({path:L})}]}const b=I(P);return[{searchPath:g,pattern:b}]}else{if(P==="./"||P===".\\")return[];{const g=P.replace(/^\.[\/\\]/,""),L=this.b.getWorkspace().folders.map(N=>{const B=g.match(new RegExp(`^${R.$if(N.name)}(?:/(.*)|$)`));return B?{match:B,folder:N}:null}).filter(y.$ng);if(L.length)return L.map(N=>{const B=N.match[1];return{searchPath:N.folder.uri,pattern:B&&I(B)}});{const N=P.match(/\.[\/\\](.+)[\/\\]?/),B=N?N[1]:P,G=d.localize(0,null,B);throw new Error(G)}}}}o(P,g){const b=P.pattern&&g?`${P.pattern}/${g}`:P.pattern||g,L=[{searchPath:P.searchPath,pattern:b}];return b&&!b.endsWith("**")&&L.push({searchPath:P.searchPath,pattern:b+"/**"}),L}q(P,g,b){const L=this.r((0,o.$1i)(P.searchPath),g,b,!1);return L?{...L,includePattern:P.pattern}:null}r(P,g,b,L){let N;const B=u.URI.isUri(P)?P:P.uri;if(b.searchPaths){const ue=b.searchPaths.filter(ge=>(0,a.$_g)(ge.searchPath,B))[0];if(ue&&!ue.pattern)return null;ue&&(N=ue.pattern)}const G=this.a.getValue({resource:B}),F={...this.l(G,g)||{},...N||{}},q=u.URI.isUri(P)?(0,a.$dh)(P):P.name;return{folder:B,folderName:L?q:void 0,excludePattern:Object.keys(F).length>0?F:void 0,fileEncoding:G.files&&G.files.encoding,disregardIgnoreFiles:typeof g.disregardIgnoreFiles=="boolean"?g.disregardIgnoreFiles:!G.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof g.disregardGlobalIgnoreFiles=="boolean"?g.disregardGlobalIgnoreFiles:!G.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof g.disregardParentIgnoreFiles=="boolean"?g.disregardParentIgnoreFiles:!G.search.useParentIgnoreFiles,ignoreSymlinks:typeof g.ignoreSymlinks=="boolean"?g.ignoreSymlinks:!G.search.followSymlinks}}};e.$8M=t,e.$8M=t=He([Ve(0,n.$_i),Ve(1,o.$Oi),Ve(2,h.$fE),Ve(3,s.$_j),Ve(4,i.$6M)],t);function c(C){const P=C.match(/[\*\{\}\(\)\[\]\?]/);if(P){const g=P.index,b=C.substr(0,g).match(/[/|\\][^/\\]*$/);if(b){let L=C.substr(0,b.index);return L.match(/[/\\]/)||(L+="/"),{pathPortion:L,globPortion:C.substr((b.index||0)+1)}}}return{pathPortion:C}}function l(...C){return C.length?C.reduce((P,g)=>(P[g]=!0,P),Object.create(null)):void 0}function m(C){return k.$xk(C,",").map(P=>P.trim()).filter(P=>!!P.length)}function f(C){return[`**/${C}/**`,`**/${C}`].map(g=>g.replace(/\*\*\/\*\*/g,"**"))}function $(C){return C.replace(/\\/g,"/")}function I(C){return $(C).replace(/^\.\//,"").replace(/\/+$/g,"")}function D(C){return C.replace(/([?*[\]])/g,"[$1]")}function v(C,P){C=w.$Ob(C,L=>L.toString());const g=[],b=P.getWorkspace();return C&&C.forEach(L=>{let N;if(P.getWorkbenchState()===o.WorkbenchState.FOLDER)N=(0,a.$ih)(b.folders[0].uri,L),N&&N!=="."&&(N="./"+N);else{const B=P.getWorkspaceFolder(L);if(B){const G=B.name;if(b.folders.filter(F=>F.name===G).length===1){const F=(0,a.$ih)(B.uri,L);F===""?N=`./${B.name}`:N=`./${B.name}/${F}`}else N=L.fsPath}}N&&g.push(D(N))}),g}}),define(ke[314],Ce([1,0,24,2,22,14,3,313,43,50,11]),function(oe,e,w,S,k,O,A,T,p,a,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wxb=u,e.$Xxb=n,w=qe(w),O=qe(O);const y=7e3;function u(s,o){const h=o.activationEvents;if(!h)return Promise.resolve(void 0);const i=[],r=[];for(const $ of h)if(/^workspaceContains:/.test($)){const I=$.substr(18);I.indexOf("*")>=0||I.indexOf("?")>=0||s.forceUsingSearch?r.push(I):i.push(I)}if(i.length===0&&r.length===0)return Promise.resolve(void 0);const{promise:t,resolve:c}=(0,R.$yh)(),l=$=>c({activationEvent:$}),m=Promise.all(i.map($=>E(s,$,l))).then(()=>{}),f=d(s,o.identifier,r,l);return Promise.all([m,f]).then(()=>{c(void 0)}),t}async function E(s,o,h){for(const i of s.folders)if(await s.exists(w.$gh(S.URI.revive(i),o))){h(`workspaceContains:${o}`);return}}async function d(s,o,h,i){if(h.length===0)return Promise.resolve(void 0);const r=new k.$xe,t=s.checkExists(s.folders,h,r.token),c=setTimeout(async()=>{r.cancel(),s.logService.info(`Not activating extension '${o.value}': Timed out while searching for 'workspaceContains' pattern ${h.join(",")}`)},y);let l=!1;try{l=await t}catch(m){O.$6(m)||O.$3(m)}r.dispose(),clearTimeout(c),l&&i(`workspaceContains:${h.join(",")}`)}function n(s,o,h,i){const r=s.get(A.$Ei),t=s.get(p.$OL),l=r.createInstance(T.$8M).file(o.map(m=>(0,a.$1i)(S.URI.revive(m))),{_reason:"checkExists",includePattern:h,exists:!0});return t.fileSearch(l,i).then(m=>!!m.limitHit,m=>O.$6(m)?!1:Promise.reject(m))}}),define(ke[46],Ce([1,0,181,20,65,24,11,4,59,2,12,5,45,247,89,44,25,118,14,19,23,229,7,109,3,27,92,17,75,93,57,95,6,314,88,231,16,86,70,21,87]),function(oe,e,w,S,k,O,A,T,p,a,R,y,u,E,d,n,s,o,h,i,r,t,c,l,m,f,$,I,D,v,C,P,g,b,L,N,B,G,W,F,q){"use strict";var ue;Object.defineProperty(e,"__esModule",{value:!0}),e.$Voc=e.$Uoc=e.$Toc=e.$Soc=e.$Roc=void 0,w=qe(w),S=qe(S),k=qe(k),h=qe(h),e.$Roc=(0,m.$Fi)("IHostUtils");let ge=ue=class extends T.$Wc{constructor(Z,V,_,ye,ae,we,he,X,Y,pe,$e,Te,ze){super(),this.Y=Te,this.Z=ze,this.a=this.B(new g.$me),this.onDidChangeRemoteConnectionData=this.a.event,this.R=new Map,this.W=!1,this.c=V,this.g=_,this.f=he,this.j=ye,this.m=ae,this.s=we,this.t=Y,this.u=pe,this.w=$e,this.y=this.g.getProxy(y.$rN.MainThreadWorkspace),this.z=this.g.getProxy(y.$rN.MainThreadTelemetry),this.C=this.g.getProxy(y.$rN.MainThreadExtensionService),this.D=new A.$Eh,this.F=new A.$Eh,this.G=new A.$Eh,this.H=new A.$Eh,this.I=new Ie(this.f.extensions.activationEvents),this.L=new o.$lcc(this.I,this.f.extensions.allExtensions);const Se=new i.$rn(this.f.extensions.myExtensions);this.J=new o.$lcc(this.I,be(this.L,Se)),F.$t&&(this.s.info(`Creating extension host with the following global extensions: ${re(this.L)}`),this.s.info(`Creating extension host with the following local extensions: ${re(this.J)}`)),this.M=new d.$Aoc(this.g,this.s),this.N=new L.$Koc(this.g),this.O=X,this.h=Z.createChild(new D.$Di([d.$Boc,this.M],[L.$Loc,this.N])),this.P=this.B(new E.$zoc(this.J,this.L,{onExtensionActivationError:(Re,Oe,z)=>{this.C.$onExtensionActivationError(Re,h.$5(Oe),z)},actualActivateExtension:async(Re,Oe)=>{if(o.$lcc.isHostExtension(Re,this.J,this.L))return await this.C.$activateExtension(Re,Oe),new E.$yoc;const z=this.J.getExtensionDescription(Re);return this.fb(z,Oe)}},this.s)),this.Q=null,this.S=Object.create(null),this.U=!1,this.X=this.f.remote.connectionData}getRemoteConnectionData(){return this.X}async initialize(){try{await this.vb(),this.D.open(),await this.j.waitForInitializeCall(),k.mark("code/extHost/ready"),this.F.open(),this.f.autoStart&&this.tb()}catch(Z){h.$3(Z)}}async $(){this.O.onWillDeactivateAll();let Z=[];try{Z=this.J.getAllExtensionDescriptions().map(ae=>ae.identifier).filter(ae=>this.isActivated(ae)).map(ae=>this.eb(ae))}catch{}await Promise.all(Z)}terminate(Z,V=0){if(this.W)return;this.W=!0,this.s.info(`Extension host terminating: ${Z}`),this.s.flush(),this.u.dispose(),this.P.dispose(),h.setUnexpectedErrorHandler(ye=>{this.s.error(ye)}),this.g.dispose();const _=this.$();Promise.race([(0,A.$Gh)(5e3),_]).finally(()=>{this.c.pid?this.s.info(`Extension host with pid ${this.c.pid} exiting with code ${V}`):this.s.info(`Extension host exiting with code ${V}`),this.s.flush(),this.s.dispose(),this.c.exit(V)})}isActivated(Z){return this.G.isOpen()?this.P.isActivated(Z):!1}async getExtension(Z){const V=await this.C.$getExtension(Z);return V&&{...V,identifier:new i.$qn(V.identifier.value),extensionLocation:a.URI.revive(V.extensionLocation)}}ab(Z,V){return this.P.activateByEvent(Z,V)}bb(Z,V){return this.P.activateById(Z,V)}activateByIdWithErrors(Z,V){return this.bb(Z,V).then(()=>{const _=this.P.getActivatedExtension(Z);if(_.activationFailed)return Promise.reject(_.activationFailedError)})}getExtensionRegistry(){return this.G.wait().then(Z=>this.J)}getExtensionExports(Z){if(this.G.isOpen())return this.P.getActivatedExtension(Z).exports;try{return this.P.getActivatedExtension(Z).exports}catch{return null}}async cb(Z){if(Z.scheme===B.Schemas.file&&this.c.fsRealpath){const V=Z.fsPath;this.R.has(V)||this.R.set(V,this.c.fsRealpath(V));const _=await this.R.get(V);return a.URI.file(_)}return Z}async getExtensionPathIndex(){return this.Q||(this.Q=this.db(this.J.getAllExtensionDescriptions()).then(Z=>new se(Z))),this.Q}async db(Z){const V=p.$Li.forUris(_=>O.$0g.ignorePathCasing(_));return await Promise.all(Z.map(async _=>{if(this.wb(_)){const ye=await this.cb(_.extensionLocation);V.set(ye,_)}})),V}eb(Z){let V=Promise.resolve(void 0);if(!this.G.isOpen()||!this.P.isActivated(Z))return V;const _=this.P.getActivatedExtension(Z);if(!_)return V;try{typeof _.module.deactivate=="function"&&(V=Promise.resolve(_.module.deactivate()).then(void 0,ye=>(this.s.error(ye),Promise.resolve(void 0))))}catch(ye){this.s.error(`An error occurred when deactivating the extension '${Z.value}':`),this.s.error(ye)}try{(0,T.$Rc)(_.subscriptions)}catch(ye){this.s.error(`An error occurred when deactivating the subscriptions for extension '${Z.value}':`),this.s.error(ye)}return V}async fb(Z,V){return this.f.remote.isRemote?this.C.$onWillActivateExtension(Z.identifier):await this.C.$onWillActivateExtension(Z.identifier),this.hb(Z,V).then(_=>{const ye=_.activationTimes;return this.C.$onDidActivateExtension(Z.identifier,ye.codeLoadingTime,ye.activateCallTime,ye.activateResolvedTime,V),this.gb(Z,V,"success",ye),_},_=>{throw this.gb(Z,V,"failure"),_})}gb(Z,V,_,ye){const ae=me(Z,V);this.z.$publicLog2("extensionActivationTimes",{...ae,...ye||{},outcome:_})}hb(Z,V){const _=me(Z,V);this.z.$publicLog2("activatePlugin",_);const ye=this.wb(Z);if(!ye)return Promise.resolve(new E.$xoc(E.$uoc.NONE));this.s.info(`ExtensionService#_doActivateExtension ${Z.identifier.value}, startup: ${V.startup}, activationEvent: '${V.activationEvent}'${Z.identifier.value!==V.extensionId.value?`, root cause: ${V.extensionId.value}`:""}`),this.s.flush();const ae=new E.$voc(V.startup);return Promise.all([this.xb(Z,(0,O.$gh)(Z.extensionLocation,ye),ae),this.ib(Z)]).then(we=>(k.mark(`code/extHost/willActivateExtension/${Z.identifier.value}`),ue.jb(this.s,Z.identifier,we[0],we[1],ae))).then(we=>(k.mark(`code/extHost/didActivateExtension/${Z.identifier.value}`),we))}ib(Z){const V=this.Z.createLanguageModelAccessInformation(Z),_=new t.$Doc(Z,this.M),ye=new t.$Coc(Z.identifier.value,!1,this.M),ae=new N.$Moc(Z,this.N),we=Z.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?c.ExtensionMode.Test:c.ExtensionMode.Development:c.ExtensionMode.Production,he=this.f.remote.isRemote?c.ExtensionKind.Workspace:c.ExtensionKind.UI;return this.s.trace(`ExtensionService#loadExtensionContext ${Z.identifier.value}`),Promise.all([_.whenReady,ye.whenReady,this.O.whenReady]).then(()=>{const X=this;let Y,pe;const $e=(0,s.$3G)(Z,"ipc")?this.f.messagePorts?.get(i.$qn.toKey(Z.identifier)):void 0;return Object.freeze({globalState:_,workspaceState:ye,secrets:ae,subscriptions:[],get languageModelAccessInformation(){return V},get extensionUri(){return Z.extensionLocation},get extensionPath(){return Z.extensionLocation.fsPath},asAbsolutePath(Te){return S.$lc(Z.extensionLocation.fsPath,Te)},get storagePath(){return X.O.workspaceValue(Z)?.fsPath},get globalStoragePath(){return X.O.globalValue(Z).fsPath},get logPath(){return S.$lc(X.f.logsLocation.fsPath,Z.identifier.value)},get logUri(){return a.URI.joinPath(X.f.logsLocation,Z.identifier.value)},get storageUri(){return X.O.workspaceValue(Z)},get globalStorageUri(){return X.O.globalValue(Z)},get extensionMode(){return we},get extension(){return Y===void 0&&(Y=new ce(X,Z.identifier,Z,he,!1)),Y},get extensionRuntime(){return(0,s.$4G)(Z,"extensionRuntime"),X.extensionRuntime},get environmentVariableCollection(){return X.u.getEnvironmentVariableCollection(Z)},get messagePassingProtocol(){if(!pe){if(!$e)return;const Te=g.Event.buffer(g.Event.fromDOMEventEmitter($e,"message",ze=>ze.data));$e.start(),pe={onDidReceiveMessage:Te,postMessage:$e.postMessage.bind($e)}}return pe}})})}static jb(Z,V,_,ye,ae){return _=_||{activate:void 0,deactivate:void 0},this.kb(Z,V,_,ye,ae).then(we=>new E.$woc(!1,null,ae.build(),_,we,ye.subscriptions))}static kb(Z,V,_,ye,ae){if(typeof _.activate=="function")try{ae.activateCallStart(),Z.trace(`ExtensionService#_callActivateOptional ${V.value}`);const we=typeof global=="object"?global:self,he=_.activate.apply(we,[ye]);return ae.activateCallStop(),ae.activateResolveStart(),Promise.resolve(he).then(X=>(ae.activateResolveStop(),X))}catch(we){return Promise.reject(we)}else return Promise.resolve(_)}lb(Z,V){this.bb(Z.identifier,{startup:!1,extensionId:Z.identifier,activationEvent:V}).then(void 0,_=>{this.s.error(_)})}mb(Z,V=0){const ye=Date.now();(0,F.$B)(()=>{for(let ae=V;ae<Z.length;ae+=1){const we=Z[ae];for(const he of we.activationEvents??[])if(he==="onStartupFinished")if(Date.now()-ye>50){this.mb(Z,ae);break}else this.lb(we,he)}})}nb(){this.C.$setPerformanceMarks(k.getMarks()),this.m.getConfigProvider().then(Z=>{const V=Z.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),_=this.J.getAllExtensionDescriptions();if(V)this.mb(_);else for(const ye of _)if(ye.activationEvents)for(const ae of ye.activationEvents)ae==="onStartupFinished"&&this.lb(ye,ae)})}ob(){const Z=this.ab("*",!0).then(void 0,we=>{this.s.error(we)});this.B(this.j.onDidChangeWorkspace(we=>this.pb(we.added)));const V=this.j.workspace?this.j.workspace.folders:[],_=this.pb(V),ye=this.rb(),ae=Promise.all([ye,Z,_]).then(()=>{});return Promise.race([ae,(0,A.$Gh)(1e4)]).then(()=>{this.nb()}),ae}pb(Z){return Z.length===0?Promise.resolve(void 0):Promise.all(this.J.getAllExtensionDescriptions().map(V=>this.qb(Z,V))).then(()=>{})}async qb(Z,V){if(this.isActivated(V.identifier))return;const _=!this.f.remote.isRemote&&!!this.f.remote.authority,ye={logService:this.s,folders:Z.map(we=>we.uri),forceUsingSearch:_||!this.c.fsExists,exists:we=>this.c.fsExists(we.fsPath),checkExists:(we,he,X)=>this.y.$checkExists(we,he,X)},ae=await(0,b.$Wxb)(ye,V);if(ae)return this.bb(V.identifier,{startup:!0,extensionId:V.identifier,activationEvent:ae.activationEvent}).then(void 0,we=>this.s.error(we))}async rb(){if(this.f.remote.authority)return this.ab(`onResolveRemoteAuthority:${this.f.remote.authority}`,!1)}async $extensionTestsExecute(){await this.H.wait();try{return await this.sb()}catch(Z){throw console.error(Z),Z}}async sb(){const{extensionDevelopmentLocationURI:Z,extensionTestsLocationURI:V}=this.f.environment;if(!Z||!V)throw new Error(w.localize(0,null));const _=await this.xb(null,V,new E.$voc(!1));if(!_||typeof _.run!="function")throw new Error(w.localize(1,null,V.toString()));return new Promise((ye,ae)=>{const we=(Y,pe)=>{Y?(F.$t&&this.s.error("Test runner called back with error",Y),ae(Y)):(F.$t&&(pe?this.s.info(`Test runner called back with ${pe} failures.`):this.s.info("Test runner called back with successful outcome.")),ye(typeof pe=="number"&&pe>0?1:0))},he=(0,O.$7g)(V),X=_.run(he,we);X&&X.then&&X.then(()=>{F.$t&&this.s.info("Test runner finished successfully."),ye(0)}).catch(Y=>{F.$t&&this.s.error("Test runner finished with error",Y),ae(Y instanceof Error&&Y.stack?Y.stack:String(Y))})})}tb(){if(this.U)throw new Error("Extension host is already started!");return this.U=!0,this.F.wait().then(()=>this.G.open()).then(()=>Promise.race([this.P.waitForActivatingExtensions(),(0,A.$Gh)(1e3)])).then(()=>this.ob()).then(()=>{this.H.open(),this.s.info("Eager extensions activated")})}registerRemoteAuthorityResolver(Z,V){return this.S[Z]=V,(0,T.$Uc)(()=>{delete this.S[Z]})}async getRemoteExecServer(Z){const{resolver:V}=await this.ub(Z);return V?.resolveExecServer?.(Z,{resolveAttempt:0})}async ub(Z){const V=Z.indexOf("+");if(V===-1)throw new c.$zN("Not an authority that can be resolved!",l.RemoteAuthorityResolverErrorCode.InvalidAuthority);const _=Z.substr(0,V);return await this.D.wait(),await this.ab(`onResolveRemoteAuthority:${_}`,!1),{authorityPrefix:_,resolver:this.S[_]}}async $resolveAuthority(Z,V){const _=W.$ge.create(!1),ye=()=>`[resolveAuthority(${(0,l.$Ul)(Z)},${V})][${_.elapsed()}ms] `,ae=U=>this.s.info(`${ye()}${U}`),we=U=>this.s.warn(`${ye()}${U}`),he=(U,K=void 0)=>this.s.error(`${ye()}${U}`,K),X=U=>{if(U instanceof c.$zN)return{type:"error",error:{code:U._code,message:U._message,detail:U._detail}};throw U},Y=async U=>{ae(`activating resolver for ${U}...`);const{resolver:K,authorityPrefix:Q}=await this.ub(U);if(!K)throw he(`no resolver for ${Q}`),new c.$zN(`No remote extension installed to resolve ${Q}.`,l.RemoteAuthorityResolverErrorCode.NoResolverFound);return{resolver:K,authorityPrefix:Q,remoteAuthority:U}},pe=Z.split(/@|%40/g).reverse();ae(`activating remote resolvers ${pe.join(" -> ")}`);let $e;try{$e=await Promise.all(pe.map(Y)).catch(async U=>{if(!(U instanceof c.$zN)||U._code!==l.RemoteAuthorityResolverErrorCode.InvalidAuthority)throw U;return we(`resolving nested authorities failed: ${U.message}`),[await Y(Z)]})}catch(U){return X(U)}const Te=new A.$Qh;Te.cancelAndSet(()=>ae("waiting..."),1e3);let ze,Se;for(const[U,{authorityPrefix:K,resolver:Q,remoteAuthority:ne}]of $e.entries())try{if(U===$e.length-1)ae("invoking final resolve()..."),k.mark(`code/extHost/willResolveAuthority/${K}`),ze=await Q.resolve(ne,{resolveAttempt:V,execServer:Se}),k.mark(`code/extHost/didResolveAuthorityOK/${K}`),ae("setting tunnel factory..."),this.B(await this.t.setTunnelFactory(Q,c.$yN.isManagedResolvedAuthority(ze)?ze:void 0));else{if(ae(`invoking resolveExecServer() for ${ne}`),k.mark(`code/extHost/willResolveExecServer/${K}`),Se=await Q.resolveExecServer?.(ne,{resolveAttempt:V,execServer:Se}),!Se)throw new c.$zN(`Exec server was not available for ${ne}`,l.RemoteAuthorityResolverErrorCode.NoResolverFound);k.mark(`code/extHost/didResolveExecServerOK/${K}`)}}catch(fe){return k.mark(`code/extHost/didResolveAuthorityError/${K}`),he("returned an error",fe),Te.dispose(),X(fe)}Te.dispose();const Re={environmentTunnels:ze.environmentTunnels,features:ze.tunnelFeatures?{elevation:ze.tunnelFeatures.elevation,privacyOptions:ze.tunnelFeatures.privacyOptions,protocol:ze.tunnelFeatures.protocol===void 0?!0:ze.tunnelFeatures.protocol}:void 0},Oe={extensionHostEnv:ze.extensionHostEnv,isTrusted:ze.isTrusted,authenticationSession:ze.authenticationSessionForInitializingExtensions?{id:ze.authenticationSessionForInitializingExtensions.id,providerId:ze.authenticationSessionForInitializingExtensions.providerId}:void 0};ae(`returned ${c.$yN.isManagedResolvedAuthority(ze)?"managed authority":`${ze.host}:${ze.port}`}`);let z;if(c.$yN.isManagedResolvedAuthority(ze)){const U=V;this.Y.setFactory(U,ze.makeConnection),z={authority:Z,connectTo:new l.$Rl(U),connectionToken:ze.connectionToken}}else z={authority:Z,connectTo:new l.$Sl(ze.host,ze.port),connectionToken:ze.connectionToken};return{type:"ok",value:{authority:z,options:Oe,tunnelInformation:Re}}}async $getCanonicalURI(Z,V){this.s.info(`$getCanonicalURI invoked for authority (${(0,l.$Ul)(Z)})`);const{resolver:_}=await this.ub(Z);if(!_)return null;const ye=a.URI.revive(V);if(typeof _.getCanonicalURI>"u")return ye;const ae=await(0,A.$xh)(()=>_.getCanonicalURI(ye));return ae||ye}async $startExtensionHost(Z){Z.toAdd.forEach(we=>we.extensionLocation=a.URI.revive(we.extensionLocation));const{globalRegistry:V,myExtensions:_}=te(this.I,this.L,this.J,Z),ye=await this.db(_);return(await this.getExtensionPathIndex()).setSearchTree(ye),this.L.set(V.getAllExtensionDescriptions()),this.J.set(_),F.$t&&(this.s.info(`$startExtensionHost: global extensions: ${re(this.L)}`),this.s.info(`$startExtensionHost: local extensions: ${re(this.J)}`)),this.tb()}$activateByEvent(Z,V){return V===s.ActivationKind.Immediate?this.D.wait().then(_=>this.ab(Z,!1)):this.G.wait().then(_=>this.ab(Z,!1))}async $activate(Z,V){return await this.G.wait(),this.J.getExtensionDescription(Z)?(await this.bb(Z,V),!0):!1}async $deltaExtensions(Z){Z.toAdd.forEach(we=>we.extensionLocation=a.URI.revive(we.extensionLocation));const{globalRegistry:V,myExtensions:_}=te(this.I,this.L,this.J,Z),ye=await this.db(_);return(await this.getExtensionPathIndex()).setSearchTree(ye),this.L.set(V.getAllExtensionDescriptions()),this.J.set(_),F.$t&&(this.s.info(`$deltaExtensions: global extensions: ${re(this.L)}`),this.s.info(`$deltaExtensions: local extensions: ${re(this.J)}`)),Promise.resolve(void 0)}async $test_latency(Z){return Z}async $test_up(Z){return Z.byteLength}async $test_down(Z){const V=r.$Oe.alloc(Z),_=Math.random()%256;for(let ye=0;ye<Z;ye++)V.writeUInt8(_,ye);return V}async $updateRemoteConnectionData(Z){this.X=Z,this.a.fire()}};e.$Soc=ge,e.$Soc=ge=ue=He([Ve(0,m.$Ei),Ve(1,e.$Roc),Ve(2,I.$XP),Ve(3,n.$doc),Ve(4,u.$goc),Ve(5,R.$_j),Ve(6,f.$bQ),Ve(7,$.$joc),Ve(8,v.$EFb),Ve(9,C.$Eoc),Ve(10,G.$Ooc),Ve(11,q.$Poc),Ve(12,P.$Ioc)],ge);function te(Ue,Z,V,_){Ue.addActivationEvents(_.addActivationEvents);const ye=new o.$lcc(Ue,Z.getAllExtensionDescriptions());ye.deltaExtensions(_.toAdd,_.toRemove);const ae=new i.$rn(V.getAllExtensionDescriptions().map(he=>he.identifier));for(const he of _.myToRemove)ae.delete(he);for(const he of _.myToAdd)ae.add(he);const we=be(ye,ae);return{globalRegistry:ye,myExtensions:we}}function me(Ue,Z){return{id:Ue.identifier.value,name:Ue.name,extensionVersion:Ue.version,publisherDisplayName:Ue.publisher,activationEvents:Ue.activationEvents?Ue.activationEvents.join(","):null,isBuiltin:Ue.isBuiltin,reason:Z.activationEvent,reasonId:Z.extensionId.value}}function re(Ue){return Ue.getAllExtensionDescriptions().map(Z=>Z.identifier.value).join(",")}e.$Toc=(0,m.$Fi)("IExtHostExtensionService");class ce{#e;#t;#i;constructor(Z,V,_,ye,ae){this.#e=Z,this.#t=V,this.#i=_.identifier,this.id=_.identifier.value,this.extensionUri=_.extensionLocation,this.extensionPath=S.$jc((0,O.$7g)(_.extensionLocation)),this.packageJSON=_,this.extensionKind=ye,this.isFromDifferentExtensionHost=ae}get isActive(){return this.#e.isActivated(this.#i)}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return this.#e.getExtensionExports(this.#i)}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await this.#e.activateByIdWithErrors(this.#i,{startup:!1,extensionId:this.#t,activationEvent:"api"}),this.exports}}e.$Uoc=ce;function be(Ue,Z){return Ue.getAllExtensionDescriptions().filter(V=>Z.has(V.identifier))}class se{constructor(Z){this.a=Z}setSearchTree(Z){this.a=Z}findSubstr(Z){return this.a.findSubstr(Z)}forEach(Z){return this.a.forEach(Z)}}e.$Voc=se;class Ie{constructor(Z){this.a=new i.$sn,this.addActivationEvents(Z)}readActivationEvents(Z){return this.a.get(Z.identifier)??[]}addActivationEvents(Z){for(const V of Object.keys(Z))this.a.set(V,Z[V])}}}),define(ke[315],Ce([1,0,65,2,5,45,25,19,17,27,3,46,12,13]),function(oe,e,w,S,k,O,A,T,p,a,R,y,u,E){"use strict";var d;Object.defineProperty(e,"__esModule",{value:!0}),e.$7pc=void 0,w=qe(w);let n=class{constructor(r,t,c,l,m,f,$){this.c=r,this.d=t,this.e=c,this.f=l,this.g=m,this.h=f,this.i=$,this.a=new Map,this.b=[]}async install(){this.j(),w.mark("code/extHost/willWaitForConfig");const r=await this.f.getConfigProvider();w.mark("code/extHost/didWaitForConfig");const t=await this.g.getExtensionPathIndex();this.register(new o(this.c,t,this.d,r,this.i)),this.register(this.e.createInstance(s)),this.h.remote.isRemote&&this.register(this.e.createInstance(h,t,this.h.environment.appUriScheme))}register(r){if("nodeModuleName"in r)if(Array.isArray(r.nodeModuleName))for(const t of r.nodeModuleName)this.a.set(t,r);else this.a.set(r.nodeModuleName,r);typeof r.alternativeModuleName=="function"&&this.b.push(t=>r.alternativeModuleName(t))}};e.$7pc=n,e.$7pc=n=He([Ve(2,R.$Ei),Ve(3,O.$goc),Ve(4,y.$Toc),Ve(5,a.$bQ),Ve(6,u.$_j)],n);let s=class{static{d=this}static{this.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]])}constructor(r){if(r.environment.appRoot&&d.a.size){const t=(0,E.$if)(this.c(r.environment.appRoot.fsPath)),c="[a-z0-9_.-]",l=`@${c}+\\/${c}+|${c}+`,m="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${t}/${m}\\/)(${l})(.*)$`,"i")}}alternativeModuleName(r){if(!this.b)return;const t=this.b.exec(this.c(r));if(!t)return;const[,c,l,m]=t,f=d.a.get(l);if(f!==void 0)return console.warn(`${l} as been renamed to ${f}, please update your imports`),c+f+m}c(r){return r.replace(/\\/g,"/")}};s=d=He([Ve(0,a.$bQ)],s);class o{constructor(r,t,c,l,m){this.c=r,this.d=t,this.e=c,this.f=l,this.g=m,this.nodeModuleName="vscode",this.a=new T.$sn}load(r,t){const c=this.d.findSubstr(t);if(c){let l=this.a.get(c.identifier);return l||(l=this.c(c,this.e,this.f),this.a.set(c.identifier,l)),l}if(!this.b){let l="";this.d.forEach((m,f)=>l+=`	${f} -> ${m.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${t}. These are the extension path mappings: 
${l}`),this.b=this.c(A.$XG,this.e,this.f)}return this.b}}let h=class{constructor(r,t,c){this.e=r,this.f=t,this.nodeModuleName=["open","opn"],this.d=c.getProxy(k.$rN.MainThreadTelemetry);const l=c.getProxy(k.$rN.MainThreadWindow);this.c=(m,f)=>{const $=S.URI.parse(m);return f?this.g(m,f):$.scheme==="http"||$.scheme==="https"?l.$openUri($,m,{allowTunneling:!0}):$.scheme==="mailto"||$.scheme===this.f?l.$openUri($,m,{}):this.g(m,f)}}load(r,t,c){const l=this.e.findSubstr(t);return l&&(this.a=l.identifier.value,this.h()),this.b=c(r),this.c}g(r,t){return this.i(),this.b(r,t)}h(){this.a&&this.d.$publicLog2("shimming.open",{extension:this.a})}i(){this.a&&this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};h=He([Ve(2,p.$XP)],h)}),define(ke[131],Ce([1,0,47,4,20,79,3,58,71,46,7,44,244,45]),function(oe,e,w,S,k,O,A,T,p,a,R,y,u,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xoc=e.$Woc=void 0,k=qe(k),O=qe(O),e.$Woc=(0,A.$Fi)("IExtHostVariableResolverProvider");class d extends u.$2Q{constructor(o,h,i,r,t,c,l){function m(){if(i){const f=i.activeEditor();if(f)return f.document.uri;const $=r.tabGroups.all.find(I=>I.isActive)?.activeTab;if($!==void 0){if($.input instanceof R.$fP||$.input instanceof R.$kP)return $.input.modified;if($.input instanceof R.$eP||$.input instanceof R.$jP||$.input instanceof R.$hP)return $.input.uri}}}super({getFolderUri:f=>{const $=c.folders.filter(I=>I.name===f);if($&&$.length>0)return $[0].uri},getWorkspaceFolderCount:()=>c.folders.length,getConfigurationValue:(f,$)=>t.getConfiguration(void 0,f).get($),getAppRoot:()=>O.cwd(),getExecPath:()=>O.env.VSCODE_EXEC_PATH,getFilePath:()=>{const f=m();if(f)return k.$jc(f.fsPath)},getWorkspaceFolderPathForFile:()=>{if(h){const f=m();if(f){const $=h.getWorkspaceFolder(f);if($)return k.$jc($.uri.fsPath)}}},getSelectedText:()=>{if(i){const f=i.activeEditor();if(f&&!f.selection.isEmpty)return f.document.getText(f.selection)}},getLineNumber:()=>{if(i){const f=i.activeEditor();if(f)return String(f.selection.end.line+1)}},getExtension:f=>o.getExtension(f)},void 0,l?Promise.resolve(l):void 0,Promise.resolve(O.env))}}let n=class extends S.$Wc{constructor(o,h,i,r,t){super(),this.b=o,this.c=h,this.g=i,this.h=r,this.j=t,this.a=new w.$X(async()=>{const c=await this.h.getConfigProvider(),m={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async f=>{m.folders=await this.c.getWorkspaceFolders2()||[]})),new d(this.b,this.c,this.g,this.j,c,m,this.m())})}getResolver(){return this.a.value}m(){}};e.$Xoc=n,e.$Xoc=n=He([Ve(0,a.$Toc),Ve(1,y.$doc),Ve(2,T.$9P),Ve(3,E.$goc),Ve(4,p.$soc)],n)}),define(ke[132],Ce([1,0,11,6,2,4,19,3,5,71,46,17,7,44,236,81,237,45,131,35,34,10,18,96]),function(oe,e,w,S,k,O,A,T,p,a,R,y,u,E,d,n,s,o,h,i,r,t,c,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8oc=e.$7oc=e.$6oc=e.$5oc=e.$4oc=void 0,t=qe(t),e.$4oc=(0,T.$Fi)("IExtHostDebugService");let m=class extends O.$Wc{get onDidStartDebugSession(){return this.y.event}get onDidTerminateDebugSession(){return this.z.event}get onDidChangeActiveDebugSession(){return this.C.event}get activeDebugSession(){return this.D?.api}get onDidReceiveDebugSessionCustomEvent(){return this.F.event}get activeDebugConsole(){return this.G.value}constructor(P,g,b,L,N,B,G,W){super(),this.Y=g,this.Z=b,this.$=L,this.ab=N,this.bb=B,this.cb=G,this.db=W,this.w=new Map,this.O=0,this.P=new Map,this.Q=new Map,this.R=new WeakMap,this.S=new Map,this.W=new Map,this.X=0,this.f=0,this.g=[],this.h=0,this.j=[],this.m=0,this.n=[],this.M=new Map,this.N=new Map,this.y=this.B(new S.$me),this.z=this.B(new S.$me),this.C=this.B(new S.$me),this.F=this.B(new S.$me),this.u=P.getProxy(p.$rN.MainThreadDebugService),this.I=this.B(new S.$me),this.L=this.B(new S.$me),this.G=new $(this.u),this.H=new Map,this.Z.getExtensionRegistry().then(F=>{this.B(F.onDidChange(q=>{this.fb(F)})),this.fb(F)})}async $getVisualizerTreeItem(P,g){const b=this.gb(g);if(!b)return;const L=await this.Q.get(P)?.getTreeItem?.(b);return L?this.eb(P,L):void 0}registerDebugVisualizationTree(P,g,b){const L=A.$qn.toKey(P.identifier),N=this.ub(L,g);if(this.P.has(N))throw new Error(`A debug visualization provider with id '${g}' is already registered`);return this.Q.set(N,b),this.u.$registerDebugVisualizerTree(N,!!b.editItem),(0,O.$Uc)(()=>{this.u.$unregisterDebugVisualizerTree(N),this.Q.delete(g)})}async $getVisualizerTreeItemChildren(P,g){const b=this.S.get(g)?.item;return b?(await this.Q.get(P)?.getChildren?.(b))?.map(N=>this.eb(P,N))||[]:[]}async $editVisualizerTreeItem(P,g){const b=this.S.get(P);if(!b)return;const L=await this.Q.get(b.provider)?.editItem?.(b.item,g);return this.eb(b.provider,L||b.item)}$disposeVisualizedTree(P){const g=this.S.get(P);if(!g)return;const b=[g.children];for(const L of b)if(L)for(const N of L)b.push(this.S.get(N)?.children),this.S.delete(N)}eb(P,g){let b=this.R.get(g);return b||(b=this.O++,this.R.set(g,b),this.S.set(b,{provider:P,item:g})),t.DebugTreeItem.from(g,b)}asDebugSourceUri(P,g){const b=P;if(typeof b.sourceReference=="number"&&b.sourceReference>0){let L=`debug:${encodeURIComponent(b.path||"")}`,N="?";return g&&(L+=`${N}session=${encodeURIComponent(g.id)}`,N="&"),L+=`${N}ref=${b.sourceReference}`,k.URI.parse(L)}else{if(b.path)return k.URI.file(b.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}fb(P){const g=[];for(const b of P.getAllExtensionDescriptions())if(b.contributes){const L=b.contributes.debuggers;if(L&&L.length>0)for(const N of L)(0,s.$VH)(N)&&g.push(N.type)}this.u.$registerDebugTypes(g)}get activeStackItem(){return this.J}get onDidChangeActiveStackItem(){return this.L.event}get onDidChangeBreakpoints(){return this.I.event}get breakpoints(){const P=[];return this.H.forEach(g=>P.push(g)),P}async $resolveDebugVisualizer(P,g){const b=this.W.get(P);if(!b)throw new Error(`No debug visualizer found with id '${P}'`);let{v:L,provider:N,extensionId:B}=b;if(L.visualization||(L=await N.resolveDebugVisualization?.(L,g)||L,b.v=L),!L.visualization)throw new Error(`No visualization returned from resolveDebugVisualization in '${N}'`);return this.vb(B,L.visualization)}async $executeDebugVisualizerCommand(P){const g=this.W.get(P);if(!g)throw new Error(`No debug visualizer found with id '${P}'`);const b=g.v.visualization;b&&"command"in b&&this.cb.executeCommand(b.command,...b.arguments||[])}gb(P){const g=this.w.get(P.sessionId);return g&&{session:g.api,variable:P.variable,containerId:P.containerId,frameId:P.frameId,threadId:P.threadId}}async $provideDebugVisualizers(P,g,b,L){const N=this.gb(b),B=this.ub(P,g),G=this.P.get(B);if(!N||!G)return[];const W=await G.provideDebugVisualization(N,L);return W?W.map(F=>{const q=++this.X;this.W.set(q,{v:F,provider:G,extensionId:P});const ue=F.iconPath?this.wb(F.iconPath):void 0;return{id:q,name:F.name,iconClass:ue?.iconClass,iconPath:ue?.iconPath,visualization:this.vb(P,F.visualization)}}):[]}$disposeDebugVisualizers(P){for(const g of P)this.W.delete(g)}registerDebugVisualizationProvider(P,g,b){if(!P.contributes?.debugVisualizers?.some(B=>B.id===g))throw new Error(`Extensions may only call registerDebugVisualizationProvider() for renderers they contribute (got ${g})`);const L=A.$qn.toKey(P.identifier),N=this.ub(L,g);if(this.P.has(N))throw new Error(`A debug visualization provider with id '${g}' is already registered`);return this.P.set(N,b),this.u.$registerDebugVisualizer(L,g),(0,O.$Uc)(()=>{this.u.$unregisterDebugVisualizer(L,g),this.P.delete(g)})}addBreakpoints(P){const g=P.filter(N=>{const B=N.id;return this.H.has(B)?!1:(this.H.set(B,N),!0)});this.rb(g,[],[]);const b=[],L=new Map;for(const N of g)if(N instanceof u.$vO){let B=L.get(N.location.uri.toString());B||(B={type:"sourceMulti",uri:N.location.uri,lines:[]},L.set(N.location.uri.toString(),B),b.push(B)),B.lines.push({id:N.id,enabled:N.enabled,condition:N.condition,hitCondition:N.hitCondition,logMessage:N.logMessage,line:N.location.range.start.line,character:N.location.range.start.character,mode:N.mode})}else N instanceof u.$wO&&b.push({type:"function",id:N.id,enabled:N.enabled,hitCondition:N.hitCondition,logMessage:N.logMessage,condition:N.condition,functionName:N.functionName,mode:N.mode});return this.u.$registerBreakpoints(b)}removeBreakpoints(P){const g=P.filter(B=>this.H.delete(B.id));this.rb([],g,[]);const b=g.filter(B=>B instanceof u.$vO).map(B=>B.id),L=g.filter(B=>B instanceof u.$wO).map(B=>B.id),N=g.filter(B=>B instanceof u.$xO).map(B=>B.id);return this.u.$unregisterBreakpoints(b,L,N)}startDebugging(P,g,b){const L=b.testRun&&this.db.getMetadataForRun(b.testRun);return this.u.$startDebugging(P?P.uri:void 0,g,{parentSessionID:b.parentSession?b.parentSession.id:void 0,lifecycleManagedByParent:b.lifecycleManagedByParent,repl:b.consoleMode===u.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:b.noDebug,compact:b.compact,suppressSaveBeforeStart:b.suppressSaveBeforeStart,testRun:L&&{runId:L.runId,taskId:L.taskId},suppressDebugStatusbar:b.suppressDebugStatusbar??b.debugUI?.simple,suppressDebugToolbar:b.suppressDebugToolbar??b.debugUI?.simple,suppressDebugView:b.suppressDebugView??b.debugUI?.simple})}stopDebugging(P){return this.u.$stopDebugging(P?P.id:void 0)}registerDebugConfigurationProvider(P,g,b){if(!g)return new u.$tN(()=>{});const L=this.f++;return this.g.push({type:P,handle:L,provider:g}),this.u.$registerDebugConfigurationProvider(P,b,!!g.provideDebugConfigurations,!!g.resolveDebugConfiguration,!!g.resolveDebugConfigurationWithSubstitutedVariables,L),new u.$tN(()=>{this.g=this.g.filter(N=>N.provider!==g),this.u.$unregisterDebugConfigurationProvider(L)})}registerDebugAdapterDescriptorFactory(P,g,b){if(!b)return new u.$tN(()=>{});if(!this.nb(P,g))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${g}' debugger.`);if(this.kb(g))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const L=this.h++;return this.j.push({type:g,handle:L,factory:b}),this.u.$registerDebugAdapterDescriptorFactory(g,L),new u.$tN(()=>{this.j=this.j.filter(N=>N.factory!==b),this.u.$unregisterDebugAdapterDescriptorFactory(L)})}registerDebugAdapterTrackerFactory(P,g){if(!g)return new u.$tN(()=>{});const b=this.m++;return this.n.push({type:P,handle:b,factory:g}),new u.$tN(()=>{this.n=this.n.filter(L=>L.factory!==g)})}async $runInTerminal(P,g){return Promise.resolve(void 0)}async $substituteVariables(P,g){let b;const L=await this.tb(P);return L&&(b={uri:L.uri,name:L.name,index:L.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.bb.getResolver()).resolveAnyAsync(b,g)}hb(P,g){if(P.type==="implementation")return new D(P.implementation)}ib(){}async $startDASession(P,g){const b=this,L=await this.sb(g);return this.pb(this.kb(L.type),L).then(N=>{if(!N)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${L.type}' (extension might have failed to activate)`);const B=this.jb(N),G=this.hb(B,L);if(!G)throw new Error(`Couldn't create a debug adapter for type '${L.type}'.`);const W=G;return this.M.set(P,W),this.ob(L).then(F=>(F&&this.N.set(P,F),W.onMessage(async q=>{if(q.type==="request"&&q.command==="handshake"){const ue=q,ge={type:"response",seq:0,command:ue.command,request_seq:ue.seq,success:!0};this.U||(this.U=this.ib());try{if(this.U){const te=await this.U.sign(ue.arguments.value);ge.body={signature:te},W.sendResponse(ge)}else throw new Error("no signer")}catch(te){ge.success=!1,ge.message=te.message,W.sendResponse(ge)}}else F&&F.onDidSendMessage&&F.onDidSendMessage(q),q=(0,s.$1H)(q,!0),b.u.$acceptDAMessage(P,q)}),W.onError(q=>{F&&F.onError&&F.onError(q),this.u.$acceptDAError(P,q.name,q.message,q.stack)}),W.onExit(q=>{F&&F.onExit&&F.onExit(q??void 0,void 0),this.u.$acceptDAExit(P,q??void 0,void 0)}),F&&F.onWillStartSession&&F.onWillStartSession(),W.startSession()))})}$sendDAMessage(P,g){g=(0,s.$ZH)(g,!1);const b=this.N.get(P);b&&b.onWillReceiveMessage&&b.onWillReceiveMessage(g),this.M.get(P)?.sendMessage(g)}$stopDASession(P){const g=this.N.get(P);this.N.delete(P),g&&g.onWillStopSession&&g.onWillStopSession();const b=this.M.get(P);return this.M.delete(P),b?b.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(P){const g=[],b=[],L=[];if(P.added)for(const N of P.added){const B=N.id;if(B&&!this.H.has(B)){let G;if(N.type==="function")G=new u.$wO(N.functionName,N.enabled,N.condition,N.hitCondition,N.logMessage,N.mode);else if(N.type==="data")G=new u.$xO(N.label,N.dataId,N.canPersist,N.enabled,N.hitCondition,N.condition,N.logMessage,N.mode);else{const W=k.URI.revive(N.uri);G=new u.$vO(new u.$FN(W,new u.$uN(N.line,N.character)),N.enabled,N.condition,N.hitCondition,N.logMessage,N.mode)}(0,u.$tO)(G,B),this.H.set(B,G),g.push(G)}}if(P.removed)for(const N of P.removed){const B=this.H.get(N);B&&(this.H.delete(N),b.push(B))}if(P.changed){for(const N of P.changed)if(N.id){const B=this.H.get(N.id);if(B){if(B instanceof u.$wO&&N.type==="function"){const G=B;G.enabled=N.enabled,G.condition=N.condition,G.hitCondition=N.hitCondition,G.logMessage=N.logMessage,G.functionName=N.functionName}else if(B instanceof u.$vO&&N.type==="source"){const G=B;G.enabled=N.enabled,G.condition=N.condition,G.hitCondition=N.hitCondition,G.logMessage=N.logMessage,G.location=new u.$FN(k.URI.revive(N.uri),new u.$uN(N.line,N.character))}L.push(B)}}}this.rb(g,b,L)}async $acceptStackFrameFocus(P){let g;if(P){const b=await this.sb(P.sessionId);P.kind==="thread"?g=new u.$DO(b.api,P.threadId):g=new u.$CO(b.api,P.threadId,P.frameId)}this.J=g,this.L.fire(this.J)}$provideDebugConfigurations(P,g,b){return(0,w.$xh)(async()=>{const L=this.mb(P);if(!L)throw new Error("no DebugConfigurationProvider found");if(!L.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const N=await this.tb(g);return L.provideDebugConfigurations(N,b)}).then(L=>{if(!L)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return L})}$resolveDebugConfiguration(P,g,b,L){return(0,w.$xh)(async()=>{const N=this.mb(P);if(!N)throw new Error("no DebugConfigurationProvider found");if(!N.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const B=await this.tb(g);return N.resolveDebugConfiguration(B,b,L)})}$resolveDebugConfigurationWithSubstitutedVariables(P,g,b,L){return(0,w.$xh)(async()=>{const N=this.mb(P);if(!N)throw new Error("no DebugConfigurationProvider found");if(!N.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const B=await this.tb(g);return N.resolveDebugConfigurationWithSubstitutedVariables(B,b,L)})}async $provideDebugAdapter(P,g){const b=this.lb(P);if(!b)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const L=await this.sb(g);return this.pb(b,L).then(N=>{if(!N)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${L.type}'`);return this.jb(N)})}async $acceptDebugSessionStarted(P){const g=await this.sb(P);this.y.fire(g.api)}async $acceptDebugSessionTerminated(P){const g=await this.sb(P);g&&(this.z.fire(g.api),this.w.delete(g.id))}async $acceptDebugSessionActiveChanged(P){this.D=P?await this.sb(P):void 0,this.C.fire(this.D?.api)}async $acceptDebugSessionNameChanged(P,g){(await this.sb(P))?._acceptNameChanged(g)}async $acceptDebugSessionCustomEvent(P,g){const L={session:(await this.sb(P)).api,event:g.event,body:g.body};this.F.fire(L)}jb(P){if(P instanceof u.$yO)return{type:"executable",command:P.command,args:P.args,options:P.options};if(P instanceof u.$zO)return{type:"server",port:P.port,host:P.host};if(P instanceof u.$AO)return{type:"pipeServer",path:P.path};if(P instanceof u.$BO)return{type:"implementation",implementation:P.implementation};throw new Error("convertToDto unexpected type")}kb(P){const g=this.j.filter(b=>b.type===P);if(g.length>0)return g[0].factory}lb(P){const g=this.j.filter(b=>b.handle===P);if(g.length>0)return g[0].factory}mb(P){const g=this.g.filter(b=>b.handle===P);if(g.length>0)return g[0].provider}nb(P,g){if(P.contributes){const b=P.contributes.debuggers;if(b&&b.length>0){for(const L of b)if(L.label&&L.type&&L.type===g)return!0}}return!1}ob(P){const b=P.configuration.type,L=this.n.filter(N=>N.type===b||N.type==="*").map(N=>(0,w.$xh)(()=>N.factory.createDebugAdapterTracker(P.api)).then(B=>B,B=>null));return Promise.race([Promise.all(L).then(N=>{const B=(0,c.$Jb)(N);if(B.length>0)return new I(B)}),new Promise(N=>setTimeout(()=>N(void 0),1e3))]).catch(N=>{})}async pb(P,g){const b=g.configuration.debugServer;if(typeof b=="number")return Promise.resolve(new u.$zO(b));if(P){const N=await this.Z.getExtensionRegistry();return(0,w.$xh)(()=>P.createDebugAdapterDescriptor(g.api,this.qb(g,N))).then(B=>{if(B)return B})}const L=await this.Z.getExtensionRegistry();return Promise.resolve(this.qb(g,L))}qb(P,g){}rb(P,g,b){(P.length>0||g.length>0||b.length>0)&&this.I.fire(Object.freeze({added:P,removed:g,changed:b}))}async sb(P){if(P)if(typeof P=="string"){const g=this.w.get(P);if(g)return g}else{let g=this.w.get(P.id);if(!g){const b=await this.tb(P.folderUri),L=P.parent?this.w.get(P.parent):void 0;g=new f(this.u,P.id,P.type,P.name,b,P.configuration,L?.api),this.w.set(g.id,g),this.u.$sessionCached(g.id)}return g}throw new Error("cannot find session")}tb(P){if(P){const g=k.URI.revive(P);return this.Y.resolveWorkspaceFolder(g)}return Promise.resolve(void 0)}ub(P,g){return`${P}\0${g}`}vb(P,g){if(g){if("title"in g&&"command"in g)return{type:n.DebugVisualizationType.Command};if("treeId"in g)return{type:n.DebugVisualizationType.Tree,id:`${P}\0${g.treeId}`};throw new Error("Unsupported debug visualization type")}}wb(P){const g=this.xb(P);let b,L;return"id"in g?L=i.ThemeIcon.asClassName(g):b=g,{iconPath:b,iconClass:L}}xb(P){if(P instanceof u.$qO)return{id:P.id};const g=typeof P=="object"&&"dark"in P?P.dark:P,b=typeof P=="object"&&"light"in P?P.light:P;return{dark:typeof g=="string"?k.URI.file(g):g,light:typeof b=="string"?k.URI.file(b):b}}};e.$5oc=m,e.$5oc=m=He([Ve(0,y.$XP),Ve(1,E.$doc),Ve(2,R.$Toc),Ve(3,o.$goc),Ve(4,a.$soc),Ve(5,h.$Woc),Ve(6,r.$hQ),Ve(7,l.$Yoc)],m);class f{constructor(P,g,b,L,N,B,G){this.f=P,this.g=g,this.h=b,this.j=L,this.k=N,this.l=B,this.m=G}get api(){const P=this;return this.d??=Object.freeze({id:P.g,type:P.h,get name(){return P.j},set name(g){P.j=g,P.f.$setDebugSessionName(P.g,g)},parentSession:P.m,workspaceFolder:P.k,configuration:P.l,customRequest(g,b){return P.f.$customDebugAdapterRequest(P.g,g,b)},getDebugProtocolBreakpoint(g){return P.f.$getDebugProtocolBreakpoint(P.g,g.id)}})}get id(){return this.g}get type(){return this.h}_acceptNameChanged(P){this.j=P}get configuration(){return this.l}}e.$6oc=f;class ${constructor(P){this.value=Object.freeze({append(g){P.$appendDebugConsole(g)},appendLine(g){this.append(g+`
`)}})}}e.$7oc=$;class I{constructor(P){this.d=P}onWillStartSession(){this.d.forEach(P=>P.onWillStartSession?P.onWillStartSession():void 0)}onWillReceiveMessage(P){this.d.forEach(g=>g.onWillReceiveMessage?g.onWillReceiveMessage(P):void 0)}onDidSendMessage(P){this.d.forEach(g=>g.onDidSendMessage?g.onDidSendMessage(P):void 0)}onWillStopSession(){this.d.forEach(P=>P.onWillStopSession?P.onWillStopSession():void 0)}onError(P){this.d.forEach(g=>g.onError?g.onError(P):void 0)}onExit(P,g){this.d.forEach(b=>b.onExit?b.onExit(P,g):void 0)}}class D extends d.$qtb{constructor(P){super(),this.h=P,P.onDidSendMessage(g=>{this.acceptMessage(g)})}startSession(){return Promise.resolve(void 0)}sendMessage(P){this.h.handleMessage(P)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let v=class extends m{constructor(P,g,b,L,N,B,G,W){super(P,g,b,L,N,B,G,W)}};e.$8oc=v,e.$8oc=v=He([Ve(0,y.$XP),Ve(1,E.$doc),Ve(2,R.$Toc),Ve(3,o.$goc),Ve(4,a.$soc),Ve(5,h.$Woc),Ve(6,r.$hQ),Ve(7,l.$Yoc)],v)}),define(ke[316],Ce([1,0,14,65,2,5,267,12,61,75,27,211,17,66,46,67]),function(oe,e,w,S,k,O,A,T,p,a,R,y,u,E,d,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9pc=e.$8pc=void 0,w=qe(w),S=qe(S);class s{static async installEarlyHandler(i){Error.stackTraceLimit=100;const r=i.get(T.$_j),c=i.get(u.$XP).getProxy(O.$rN.MainThreadErrors);w.setUnexpectedErrorHandler(l=>{r.error(l);const m=w.$5(l);c.$onUnexpectedError(m)})}static async installFullHandler(i){const r=i.get(T.$_j),t=i.get(u.$XP),c=i.get(d.$Toc),l=i.get(n.$fQ),m=t.getProxy(O.$rN.MainThreadExtensionService),f=t.getProxy(O.$rN.MainThreadErrors),$=await c.getExtensionPathIndex(),I=new WeakMap;function D(P,g){if(I.has(P))return I.get(P).stack;let b="",L,N;for(const G of g)b+=`
	at ${G.toString()}`,N=G.getFileName(),!L&&N&&(L=$.findSubstr(k.URI.file(N)));const B=`${P.name||"Error"}: ${P.message||""}${b}`;return I.set(P,{extensionIdentifier:L?.identifier,stack:B}),B}const v=Symbol("prepareStackTrace wrapped");let C=D;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return C},set(P){if(P===D||!P||P[v]){C=P||D;return}C=function(g,b){return D(g,b),P.call(Error,g,b)},Object.assign(C,{[v]:!0})}}),w.setUnexpectedErrorHandler(P=>{r.error(P);const g=w.$5(P),b=I.get(P);if(!b?.extensionIdentifier){f.$onUnexpectedError(g);return}m.$onExtensionRuntimeError(b.extensionIdentifier,g);const L=l.onExtensionError(b.extensionIdentifier,P);r.trace("forwarded error to extension?",L,b)})}}e.$8pc=s;class o{constructor(i,r,t,c,l){this.a=t,this.b=new A.$tcc(i,null,c),r=o.e(r,this.b);const m=new a.$Di(...(0,p.$Ls)());m.set(R.$bQ,{_serviceBrand:void 0,...r,messagePorts:l}),m.set(u.$XP,new u.$YP(this.b)),m.set(E.$aoc,new E.$boc(c)),m.set(d.$Roc,t);const f=new y.$pr(m,!0);f.invokeFunction(s.installEarlyHandler),this.d=f.invokeFunction($=>$.get(T.$_j)),S.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",r),this.c=f.invokeFunction($=>$.get(d.$Toc)),this.c.initialize(),f.invokeFunction(s.installFullHandler)}async asBrowserUri(i){const r=this.b.getProxy(O.$rN.MainThreadExtensionService);return k.URI.revive(await r.$asBrowserUri(i))}terminate(i){this.c.terminate(i)}static e(i,r){i.extensions.allExtensions.forEach(c=>{c.extensionLocation=k.URI.revive(r.transformIncomingURIs(c.extensionLocation))}),i.environment.appRoot=k.URI.revive(r.transformIncomingURIs(i.environment.appRoot));const t=i.environment.extensionDevelopmentLocationURI;return t&&(i.environment.extensionDevelopmentLocationURI=t.map(c=>k.URI.revive(r.transformIncomingURIs(c)))),i.environment.extensionTestsLocationURI=k.URI.revive(r.transformIncomingURIs(i.environment.extensionTestsLocationURI)),i.environment.globalStorageHome=k.URI.revive(r.transformIncomingURIs(i.environment.globalStorageHome)),i.environment.workspaceStorageHome=k.URI.revive(r.transformIncomingURIs(i.environment.workspaceStorageHome)),i.environment.extensionTelemetryLogResource=k.URI.revive(r.transformIncomingURIs(i.environment.extensionTelemetryLogResource)),i.nlsBaseUrl=k.URI.revive(r.transformIncomingURIs(i.nlsBaseUrl)),i.logsLocation=k.URI.revive(r.transformIncomingURIs(i.logsLocation)),i.workspace=r.transformIncomingURIs(i.workspace),i}}e.$9pc=o}),define(ke[317],Ce([1,0,18,11,22,48,16,20,24,2,43]),function(oe,e,w,S,k,O,A,T,p,a,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mpc=e.$kpc=e.$jpc=void 0,e.$lpc=n,T=qe(T),p=qe(p);class y{constructor(h,i,r){this.d=h,this.e=i,this.f=r,this.a=null,this.b=!1,this.c=0}get g(){return this.d.query}search(h,i){const r=this.g.folderQueries||[],t=new k.$xe(i);return new Promise((c,l)=>{this.a=new E(h);let m=!1;const f=($,I)=>{if(!m&&!this.b){const D=this.h($);n($)&&typeof this.g.maxResults=="number"&&this.c+D>this.g.maxResults&&(this.b=!0,m=!0,t.cancel(),$=this.j($,this.g.maxResults-this.c));const v=this.h($);this.c+=v,(v>0||!n($))&&this.a.add($,I)}};Promise.all(r.map(($,I)=>this.k($,D=>f(D,I),t.token))).then($=>{t.dispose(),this.a.flush();const I=$.some(D=>!!D&&!!D.limitHit);c({limitHit:this.b||I,messages:$.flatMap(D=>D?.message?Array.isArray(D.message)?D.message:[D.message]:[]),stats:{type:this.f}})},$=>{t.dispose();const I=(0,O.$qj)($);l(new Error(I))})})}h(h){return n(h)?Array.isArray(h.ranges)?h.ranges.length:1:0}j(h,i){const r=Array.isArray(h.ranges)?h.ranges:[h.ranges],t=Array.isArray(h.preview.matches)?h.preview.matches:[h.preview.matches];return{ranges:r.slice(0,i),preview:{matches:t.slice(0,i),text:h.preview.text},uri:h.uri}}async k(h,i,r){const t=new R.$8L(this.g,h),c=[],l={report:$=>{if(!this.l($))return;const I=h.folder.scheme===A.Schemas.file?(0,R.$9L)(()=>this.e.readdir(p.$fh($.uri))):void 0,D=p.$ih(h.folder,$.uri);if(D){const v=t.includedInQuery(D,T.$pc(D),I);(0,S.$rh)(v)?c.push(v.then(C=>{C&&i($)})):v&&i($)}}},m=this.n(h);let f;return this.d.query.type===R.QueryType.aiText?f=await this.d.provider.provideAITextSearchResults(this.d.query.contentPattern,m,l,r):f=await this.d.provider.provideTextSearchResults(u(this.d.query.contentPattern),m,l,r),c.length&&await Promise.all(c),f}l(h){if(n(h)){if(Array.isArray(h.ranges)){if(!Array.isArray(h.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(h.preview.matches.length!==h.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(h.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(h){const i=(0,R.$7L)(this.g.includePattern,h.includePattern),r=(0,R.$7L)(this.g.excludePattern,h.excludePattern),t={folder:a.URI.from(h.folder),excludes:r,includes:i,useIgnoreFiles:!h.disregardIgnoreFiles,useGlobalIgnoreFiles:!h.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!h.disregardParentIgnoreFiles,followSymlinks:!h.ignoreSymlinks,encoding:h.fileEncoding&&this.e.toCanonicalName(h.fileEncoding),maxFileSize:this.g.maxFileSize,maxResults:this.g.maxResults??R.$NL,previewOptions:this.g.previewOptions,afterContext:this.g.afterContext,beforeContext:this.g.beforeContext};return"usePCRE2"in this.g&&(t.usePCRE2=this.g.usePCRE2),t}}e.$jpc=y;function u(o){return{isCaseSensitive:o.isCaseSensitive||!1,isRegExp:o.isRegExp||!1,isWordMatch:o.isWordMatch||!1,isMultiline:o.isMultiline||!1,pattern:o.pattern}}class E{constructor(h){this.e=h,this.b=-1,this.d=null,this.a=new s(512,i=>this.g(i))}add(h,i){this.d&&(this.b!==i||!p.$_g(this.c,h.uri))&&(this.f(),this.d=null),this.d||(this.b=i,this.d={resource:h.uri,results:[]}),this.d.results.push(d(h))}f(){const h=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,h)}flush(){this.f(),this.a.flush()}g(h){this.e(h)}}e.$kpc=E;function d(o){return n(o)?{preview:{matches:(0,w.$3b)(o.preview.matches,h=>({startLineNumber:h.start.line,startColumn:h.start.character,endLineNumber:h.end.line,endColumn:h.end.character})),text:o.preview.text},ranges:(0,w.$3b)(o.ranges,h=>({startLineNumber:h.start.line,startColumn:h.start.character,endLineNumber:h.end.line,endColumn:h.end.character}))}:{text:o.text,lineNumber:o.lineNumber}}function n(o){return!!o.preview}class s{static{this.a=4e3}static{this.b=50}constructor(h,i){this.g=h,this.h=i,this.c=0,this.d=[],this.e=0}addItem(h,i){h&&this.j(h,i)}addItems(h,i){h&&this.k(h,i)}j(h,i){this.d.push(h),this.e+=i,this.l()}k(h,i){this.d=this.d.concat(h),this.e+=i,this.l()}l(){this.c<s.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},s.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}e.$mpc=s}),define(ke[133],Ce([1,0,4,5,3,312,17,66,12,2,317]),function(oe,e,w,S,k,O,A,T,p,a,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$opc=e.$npc=void 0,e.$ppc=u,e.$npc=(0,k.$Fi)("IExtHostSearch");let y=class{constructor(n,s,o){this.n=n,this.o=s,this.q=o,this.c=this.n.getProxy(S.$rN.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new Map,this.k=new Set,this.l=new O.$ipc}s(n){return this.o.transformOutgoingScheme(n)}registerTextSearchProvider(n,s){if(this.g.has(n))throw new Error(`a text search provider for the scheme '${n}' is already registered`);this.g.add(n);const o=this.d++;return this.e.set(o,s),this.c.$registerTextSearchProvider(o,this.s(n)),(0,w.$Uc)(()=>{this.g.delete(n),this.e.delete(o),this.c.$unregisterProvider(o)})}registerAITextSearchProvider(n,s){if(this.i.has(n))throw new Error(`an AI text search provider for the scheme '${n}'is already registered`);this.i.add(n);const o=this.d++;return this.h.set(o,s),this.c.$registerAITextSearchProvider(o,this.s(n)),(0,w.$Uc)(()=>{this.i.delete(n),this.h.delete(o),this.c.$unregisterProvider(o)})}registerFileSearchProvider(n,s){if(this.k.has(n))throw new Error(`a file search provider for the scheme '${n}' is already registered`);this.k.add(n);const o=this.d++;return this.j.set(o,s),this.c.$registerFileSearchProvider(o,this.s(n)),(0,w.$Uc)(()=>{this.k.delete(n),this.j.delete(o),this.c.$unregisterProvider(o)})}$provideFileSearchResults(n,s,o,h){const i=u(o),r=this.j.get(n);if(r)return this.l.fileSearch(i,r,t=>{this.c.$handleFileMatch(n,s,t.map(c=>c.resource))},h);throw new Error("3 unknown provider: "+n)}async doInternalFileSearchWithCustomCallback(n,s,o){return{messages:[]}}$clearCache(n){return this.l.clearCache(n),Promise.resolve(void 0)}$provideTextSearchResults(n,s,o,h){const i=this.e.get(n);if(!i||!i.provideTextSearchResults)throw new Error(`Unknown Text Search Provider ${n}`);const r=u(o);return this.t(r,i).search(c=>this.c.$handleTextMatch(n,s,c),h)}$provideAITextSearchResults(n,s,o,h){const i=this.h.get(n);if(!i||!i.provideAITextSearchResults)throw new Error(`Unknown AI Text Search Provider ${n}`);const r=u(o);return this.v(r,i).search(c=>this.c.$handleTextMatch(n,s,c),h)}$enableExtensionHostSearch(){}t(n,s){return new R.$jpc({query:n,provider:s},{readdir:o=>Promise.resolve([]),toCanonicalName:o=>o},"textSearchProvider")}v(n,s){return new R.$jpc({query:n,provider:s},{readdir:o=>Promise.resolve([]),toCanonicalName:o=>o},"aiTextSearchProvider")}};e.$opc=y,e.$opc=y=He([Ve(0,A.$XP),Ve(1,T.$aoc),Ve(2,p.$_j)],y);function u(d){return{...d,folderQueries:d.folderQueries&&d.folderQueries.map(E),extraFileResources:d.extraFileResources&&d.extraFileResources.map(n=>a.URI.revive(n))}}function E(d){return{...d,folder:a.URI.revive(d.folder)}}});var ti=this&&this.__importDefault||function(oe){return oe&&oe.__esModule?oe:{default:oe}};define(ke[318],Ce([1,0,22,14,6,4,16,36,2,105,164,150,52,19,30,12,63,64,225,5,270,298,85,91,275,276,277,253,242,34,278,45,279,132,121,280,255,271,281,282,58,71,256,272,46,284,69,285,51,27,299,257,286,95,287,86,87,260,311,289,230,290,300,291,127,261,292,293,294,17,295,133,88,296,262,297,89,92,130,67,57,125,96,301,273,302,303,93,10,7,263,66,264,68,304,305,120,44,81,84,25,129,258]),function(oe,e,w,S,k,O,A,T,p,a,R,y,u,E,d,n,s,o,h,i,r,t,c,l,m,f,$,I,D,v,C,P,g,b,L,N,B,G,W,F,q,ue,ge,te,me,re,ce,be,se,Ie,Ue,Z,V,_,ye,ae,we,he,X,Y,pe,$e,Te,ze,Se,Re,Oe,z,U,K,Q,ne,fe,Ae,je,Ke,_e,it,nt,tt,rt,$t,lt,st,ut,ft,mt,We,Be,H,x,Ee,Je,xe,ht,pt,Ft,Ut,Zt,di,Ye,Pt,Gt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3pc=Kt,S=qe(S),T=ti(T),y=qe(y),d=qe(d),Be=qe(Be),H=qe(H);function Kt(gt){const vt=gt.get(Ie.$bQ),ii=gt.get(se.$Xnc),Yt=gt.get(ce.$ioc),Wt=gt.get(me.$Toc),yt=gt.get(Ut.$doc),Ot=gt.get(tt.$fQ),ui=gt.get(P.$goc),Vt=gt.get(Ee.$aoc),Xe=gt.get(K.$XP),xt=gt.get(_e.$Boc),ni=gt.get(it.$joc),li=gt.get(n.$ak),kt=gt.get(n.$_j),Lt=gt.get(We.$EFb),At=gt.get(c.$Tnc),zt=gt.get(Ft.$1pc),ri=gt.get(fe.$Loc),_t=gt.get(ue.$soc),si=gt.get(we.$Poc),jt=gt.get(l.$4nc),Ht=gt.get(_.$Ioc);Xe.set(i.$sN.ExtHostFileSystemInfo,ii),Xe.set(i.$sN.ExtHostLogLevelServiceShape,li),Xe.set(i.$sN.ExtHostWorkspace,yt),Xe.set(i.$sN.ExtHostConfiguration,ui),Xe.set(i.$sN.ExtHostExtensionService,Wt),Xe.set(i.$sN.ExtHostStorage,xt),Xe.set(i.$sN.ExtHostTunnelService,Lt),Xe.set(i.$sN.ExtHostWindow,zt),Xe.set(i.$sN.ExtHostSecretState,ri),Xe.set(i.$sN.ExtHostTelemetry,Ot),Xe.set(i.$sN.ExtHostEditorTabs,_t),Xe.set(i.$sN.ExtHostManagedSockets,si),Xe.set(i.$sN.ExtHostAuthentication,jt),Xe.set(i.$sN.ExtHostChatProvider,Ht);const oi=Xe.set(i.$sN.ExtHostDecorations,gt.get(L.$0oc)),Rt=Xe.set(i.$sN.ExtHostDocumentsAndEditors,gt.get(q.$9P)),St=Xe.set(i.$sN.ExtHostCommands,gt.get(v.$hQ)),wt=Xe.set(i.$sN.ExtHostTerminalService,gt.get(rt.$Eoc)),ei=Xe.set(i.$sN.ExtHostTerminalShellIntegration,gt.get($t.$Qpc)),Ct=Xe.set(i.$sN.ExtHostDebugService,gt.get(b.$4oc)),hi=Xe.set(i.$sN.ExtHostSearch,gt.get(ne.$npc)),qt=Xe.set(i.$sN.ExtHostTask,gt.get(nt.$Ppc)),bi=Xe.set(i.$sN.ExtHostOutputService,gt.get(Se.$Cpc)),wi=Xe.set(i.$sN.ExtHostLocalization,gt.get(ae.$Ooc)),fi=Xe.set(i.$sN.ExtHostUrls,new Je.$Xpc(Xe)),Bt=Xe.set(i.$sN.ExtHostDocuments,new F.$1nc(Xe,Rt)),ai=Xe.set(i.$sN.ExtHostDocumentContentProviders,new G.$_oc(Xe,Rt,kt)),Ci=Xe.set(i.$sN.ExtHostDocumentSaveParticipant,new W.$apc(kt,Bt,Xe.getProxy(i.$rN.MainThreadBulkEdits))),Nt=Xe.set(i.$sN.ExtHostNotebook,new X.$qpc(Xe,St,Rt,Bt,Yt,hi,kt)),Ei=Xe.set(i.$sN.ExtHostNotebookDocuments,new pe.$wpc(Nt)),Ii=Xe.set(i.$sN.ExtHostNotebookEditors,new $e.$xpc(kt,Nt)),Di=Xe.set(i.$sN.ExtHostNotebookKernels,new Te.$ypc(Xe,vt,Nt,St,kt)),mi=Xe.set(i.$sN.ExtHostNotebookRenderers,new ze.$Apc(Xe,Nt)),Pi=Xe.set(i.$sN.ExtHostNotebookDocumentSaveParticipant,new Y.$vpc(kt,Nt,Xe.getProxy(i.$rN.MainThreadBulkEdits))),ve=Xe.set(i.$sN.ExtHostEditors,new st.$0nc(Xe,Rt)),Ne=Xe.set(i.$sN.ExtHostTreeViews,new mt.$Vpc(Xe.getProxy(i.$rN.MainThreadTreeViews),St,kt)),de=Xe.set(i.$sN.ExtHostEditorInsets,new D.$$nc(Xe.getProxy(i.$rN.MainThreadEditorInsets),ve,vt.remote)),J=Xe.set(i.$sN.ExtHostDiagnostics,new N.$Znc(Xe,kt,ii,Rt)),Pe=Xe.set(i.$sN.ExtHostLanguages,new ye.$tpc(Xe,Bt,St.converter,Vt)),Me=Xe.set(i.$sN.ExtHostLanguageFeatures,new V.$2nc(Xe,Vt,Bt,St,J,kt,At,Ot)),Ze=Xe.set(i.$sN.ExtHostFileSystem,new re.$dpc(Xe,Me)),Ge=Xe.set(i.$sN.ExtHostFileSystemEventService,new be.$epc(Xe,kt,Rt)),ct=Xe.set(i.$sN.ExtHostQuickOpen,(0,U.$Gpc)(Xe,yt,St)),It=Xe.set(i.$sN.ExtHostSCM,new Q.$Ipc(Xe,St,Bt,kt)),Qt=Xe.set(i.$sN.ExtHostQuickDiff,new z.$Fpc(Xe,Vt)),ci=Xe.set(i.$sN.ExtHostShare,new Ae.$Jpc(Xe,Vt)),Mt=Xe.set(i.$sN.ExtHostComments,(0,C.$_nc)(Xe,St,Bt)),Jt=Xe.set(i.$sN.ExtHostProgress,new Oe.$Epc(Xe.getProxy(i.$rN.MainThreadProgress))),Yi=Xe.set(i.$sN.ExtHostLabelService,new Z.$spc(Xe)),Wi=Xe.set(i.$sN.ExtHostTheming,new ut.$Spc(Xe)),$n=Xe.set(i.$sN.ExtHostTimeline,new ft.$Upc(Xe,St)),Fi=Xe.set(i.$sN.ExtHostWebviews,new xe.$noc(Xe,vt.remote,yt,kt,At)),Ni=Xe.set(i.$sN.ExtHostWebviewPanels,new ht.$qoc(Xe,Fi,yt)),Vi=Xe.set(i.$sN.ExtHostCustomEditors,new g.$roc(Xe,Bt,ni,Fi,Ni)),xi=Xe.set(i.$sN.ExtHostWebviewViews,new pt.$Ypc(Xe,Fi)),Si=Xe.set(i.$sN.ExtHostTesting,gt.get(lt.$Yoc)),_i=Xe.set(i.$sN.ExtHostUriOpeners,new x.$Wpc(Xe)),en=Xe.set(i.$sN.ExtHostProfileContentHandlers,new Re.$Dpc(Xe));Xe.set(i.$sN.ExtHostInteractive,new Ue.$rpc(Xe,Nt,Rt,St,kt));const Li=Xe.set(i.$sN.ExtHostChatAgents2,new f.$7nc(Xe,kt,St,vt.quality)),tn=Xe.set(i.$sN.ExtHostChatVariables,new $.$8nc(Xe)),qi=Xe.set(i.$sN.ExtHostLanguageModelTools,new Gt.$2pc(Xe)),nn=Xe.set(i.$sN.ExtHostAiRelatedInformation,new r.$Snc(Xe)),Gi=Xe.set(i.$sN.ExtHostAiEmbeddingVector,new te.$cpc(Xe)),Mi=Xe.set(i.$sN.ExtHostStatusBar,new Ke.$Mpc(Xe,St.converter)),bn=Xe.set(i.$sN.ExtHostSpeech,new je.$Kpc(Xe)),Ti=Xe.set(i.$sN.ExtHostEmbeddings,new ge.$bpc(Xe)),rn=Object.values(i.$sN);Xe.assertRegistered(rn);const wn=new m.$6nc(Xe,Rt),Ki=new I.$9nc(Xe),Ui=new he.$upc(Xe,kt),Hi=new B.$$oc(Xe);return t.$3nc.register(St),function(Le,vi,zi){function ot(ee){return(le,Fe,at)=>{const Dt=ee(Tt=>{try{le.call(Fe,Tt)}catch(Ri){S.$4(new Error(`[ExtensionListenerError] Extension '${Le.identifier.value}' FAILED to handle event: ${Ri.toString()}`,{cause:Ri})),Ot.onExtensionError(Le.identifier,Ri)}});return at?.push(Dt),Dt}}const bt=function(){let ee=!Le.isUnderDevelopment;function le(){ee||(kt.info(`Extension '${Le.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),ee=!0)}return function Fe(at){if(Array.isArray(at))at.forEach(Fe);else if(typeof at=="string")le();else{const Dt=at;typeof Dt.scheme>"u"&&le(),typeof Dt.exclusive=="boolean"&&(0,Ye.$4G)(Le,"documentFiltersExclusive")}return at}}(),ji={getSession(ee,le,Fe){return typeof Fe?.forceNewSession=="object"&&Fe.forceNewSession.learnMore&&(0,Ye.$4G)(Le,"authLearnMore"),Fe?.account&&(0,Ye.$4G)(Le,"authGetSessions"),jt.getSession(Le,ee,le,Fe)},getSessions(ee,le){return(0,Ye.$4G)(Le,"authGetSessions"),jt.getSessions(Le,ee,le)},getAccounts(ee){return(0,Ye.$4G)(Le,"authGetSessions"),jt.getAccounts(ee)},async hasSession(ee,le){return(0,Ye.$4G)(Le,"authSession"),!!await jt.getSession(Le,ee,le,{silent:!0})},get onDidChangeSessions(){return ot(jt.onDidChangeSessions)},registerAuthenticationProvider(ee,le,Fe,at){return jt.registerAuthenticationProvider(ee,le,Fe,at)}},vn={registerCommand(ee,le,Fe){return St.registerCommand(!0,ee,le,Fe,void 0,Le)},registerTextEditorCommand(ee,le,Fe){return St.registerCommand(!0,ee,(...at)=>{const Dt=ve.getActiveTextEditor();if(!Dt){kt.warn("Cannot execute "+ee+" because there is no active text editor.");return}return Dt.edit(Tt=>{le.apply(Fe,[Dt,Tt,...at])}).then(Tt=>{Tt||kt.warn("Edits from command "+ee+" were not applied.")},Tt=>{kt.warn("An error occurred while running command "+ee,Tt)})},void 0,void 0,Le)},registerDiffInformationCommand:(ee,le,Fe)=>((0,Ye.$4G)(Le,"diffCommand"),St.registerCommand(!0,ee,async(...at)=>{const Dt=Rt.activeEditor(!0);if(!Dt){kt.warn("Cannot execute "+ee+" because there is no active text editor.");return}const Tt=await ve.getDiffInformation(Dt.id);le.apply(Fe,[Tt,...at])},void 0,void 0,Le)),executeCommand(ee,...le){return St.executeCommand(ee,...le)},getCommands(ee=!1){return St.getCommands(ee)}},gi={get machineId(){return vt.telemetryInfo.machineId},get sessionId(){return vt.telemetryInfo.sessionId},get language(){return vt.environment.appLanguage},get appName(){return vt.environment.appName},get appRoot(){return vt.environment.appRoot?.fsPath??""},get appHost(){return vt.environment.appHost},get uriScheme(){return vt.environment.appUriScheme},get clipboard(){return Ki.value},get shell(){return wt.getDefaultShell(!1)},get onDidChangeShell(){return ot(wt.onDidChangeShell)},get isTelemetryEnabled(){return Ot.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return ot(Ot.onDidChangeTelemetryEnabled)},get telemetryConfiguration(){return(0,Ye.$4G)(Le,"telemetry"),Ot.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,Ye.$4G)(Le,"telemetry"),ot(Ot.onDidChangeTelemetryConfiguration)},get isNewAppInstall(){return(0,tt.$eQ)(vt.telemetryInfo.firstSessionDate)},createTelemetryLogger(ee,le){return tt.$dQ.validateSender(ee),Ot.instantiateLogger(Le,ee,le)},openExternal(ee,le){return zt.openUri(ee,{allowTunneling:!!vt.remote.authority,allowContributedOpeners:le?.allowContributedOpeners})},async asExternalUri(ee){if(ee.scheme===vt.environment.appUriScheme)return fi.createAppUri(ee);try{return await zt.asExternalUri(ee,{allowTunneling:!!vt.remote.authority})}catch(le){if((0,A.$Og)(ee,A.Schemas.http)||(0,A.$Og)(ee,A.Schemas.https))return ee;throw le}},get remoteName(){return(0,s.$hn)(vt.remote.authority)},get remoteAuthority(){return(0,Ye.$4G)(Le,"resolvers"),vt.remote.authority},get uiKind(){return vt.uiKind},get logLevel(){return kt.getLevel()},get onDidChangeLogLevel(){return ot(kt.onDidChangeLogLevel)},get appQuality(){return(0,Ye.$4G)(Le,"resolvers"),vt.quality},get appCommit(){return(0,Ye.$4G)(Le,"resolvers"),vt.commit}};vt.environment.extensionTestsLocationURI||Object.freeze(gi);const Bi={createTestController(ee,le,Fe){return Si.createTestController(Le,ee,le,Fe)},createTestObserver(){return(0,Ye.$4G)(Le,"testObserver"),Si.createTestObserver()},runTests(ee){return(0,Ye.$4G)(Le,"testObserver"),Si.runTests(ee)},registerTestFollowupProvider(ee){return(0,Ye.$4G)(Le,"testObserver"),Si.registerTestFollowupProvider(ee)},get onDidChangeTestResults(){return(0,Ye.$4G)(Le,"testObserver"),ot(Si.onResultsChanged)},get testResults(){return(0,Ye.$4G)(Le,"testObserver"),Si.results}},Oi=vt.remote.isRemote?H.ExtensionKind.Workspace:H.ExtensionKind.UI,sn={getExtension(ee,le){(0,Ye.$3G)(Le,"extensionsAny")||(le=!1);const Fe=vi.mine.getExtensionDescription(ee);if(Fe)return new me.$Uoc(Wt,Le.identifier,Fe,Oi,!1);if(le){const at=vi.all.getExtensionDescription(ee);if(at)return new me.$Uoc(Wt,Le.identifier,at,Oi,!0)}},get all(){const ee=[];for(const le of vi.mine.getAllExtensionDescriptions())ee.push(new me.$Uoc(Wt,Le.identifier,le,Oi,!1));return ee},get allAcrossExtensionHosts(){(0,Ye.$4G)(Le,"extensionsAny");const ee=new E.$rn(vi.mine.getAllExtensionDescriptions().map(Fe=>Fe.identifier)),le=[];for(const Fe of vi.all.getAllExtensionDescriptions()){const at=!ee.has(Fe.identifier);le.push(new me.$Uoc(Wt,Le.identifier,Fe,Oi,at))}return le},get onDidChange(){return(0,Ye.$3G)(Le,"extensionsAny")?ot(k.Event.any(vi.mine.onDidChange,vi.all.onDidChange)):ot(vi.mine.onDidChange)}},on={createDiagnosticCollection(ee){return J.createDiagnosticCollection(Le.identifier,ee)},get onDidChangeDiagnostics(){return ot(J.onDidChangeDiagnostics)},getDiagnostics:ee=>J.getDiagnostics(ee),getLanguages(){return Pe.getLanguages()},setTextDocumentLanguage(ee,le){return Pe.changeLanguage(ee.uri,le)},match(ee,le){const Fe=Be.LanguageSelector.from(ee);let at;return(0,R.$pu)(Fe)&&(at=Nt.notebookDocuments.find(Dt=>Dt.apiNotebook.getCells().find(Tt=>Tt.document===le))?.apiNotebook),(0,R.$ou)(Fe,le.uri,le.languageId,!0,at?.uri,at?.notebookType)},registerCodeActionsProvider(ee,le,Fe){return Me.registerCodeActionProvider(Le,bt(ee),le,Fe)},registerDocumentPasteEditProvider(ee,le,Fe){return(0,Ye.$4G)(Le,"documentPaste"),Me.registerDocumentPasteEditProvider(Le,bt(ee),le,Fe)},registerCodeLensProvider(ee,le){return Me.registerCodeLensProvider(Le,bt(ee),le)},registerDefinitionProvider(ee,le){return Me.registerDefinitionProvider(Le,bt(ee),le)},registerDeclarationProvider(ee,le){return Me.registerDeclarationProvider(Le,bt(ee),le)},registerImplementationProvider(ee,le){return Me.registerImplementationProvider(Le,bt(ee),le)},registerTypeDefinitionProvider(ee,le){return Me.registerTypeDefinitionProvider(Le,bt(ee),le)},registerHoverProvider(ee,le){return Me.registerHoverProvider(Le,bt(ee),le,Le.identifier)},registerEvaluatableExpressionProvider(ee,le){return Me.registerEvaluatableExpressionProvider(Le,bt(ee),le,Le.identifier)},registerInlineValuesProvider(ee,le){return Me.registerInlineValuesProvider(Le,bt(ee),le,Le.identifier)},registerDocumentHighlightProvider(ee,le){return Me.registerDocumentHighlightProvider(Le,bt(ee),le)},registerMultiDocumentHighlightProvider(ee,le){return Me.registerMultiDocumentHighlightProvider(Le,bt(ee),le)},registerLinkedEditingRangeProvider(ee,le){return Me.registerLinkedEditingRangeProvider(Le,bt(ee),le)},registerReferenceProvider(ee,le){return Me.registerReferenceProvider(Le,bt(ee),le)},registerRenameProvider(ee,le){return Me.registerRenameProvider(Le,bt(ee),le)},registerNewSymbolNamesProvider(ee,le){return(0,Ye.$4G)(Le,"newSymbolNamesProvider"),Me.registerNewSymbolNamesProvider(Le,bt(ee),le)},registerDocumentSymbolProvider(ee,le,Fe){return Me.registerDocumentSymbolProvider(Le,bt(ee),le,Fe)},registerWorkspaceSymbolProvider(ee){return Me.registerWorkspaceSymbolProvider(Le,ee)},registerDocumentFormattingEditProvider(ee,le){return Me.registerDocumentFormattingEditProvider(Le,bt(ee),le)},registerDocumentRangeFormattingEditProvider(ee,le){return Me.registerDocumentRangeFormattingEditProvider(Le,bt(ee),le)},registerOnTypeFormattingEditProvider(ee,le,Fe,...at){return Me.registerOnTypeFormattingEditProvider(Le,bt(ee),le,[Fe].concat(at))},registerDocumentSemanticTokensProvider(ee,le,Fe){return Me.registerDocumentSemanticTokensProvider(Le,bt(ee),le,Fe)},registerDocumentRangeSemanticTokensProvider(ee,le,Fe){return Me.registerDocumentRangeSemanticTokensProvider(Le,bt(ee),le,Fe)},registerSignatureHelpProvider(ee,le,Fe,...at){return typeof Fe=="object"?Me.registerSignatureHelpProvider(Le,bt(ee),le,Fe):Me.registerSignatureHelpProvider(Le,bt(ee),le,typeof Fe>"u"?[]:[Fe,...at])},registerCompletionItemProvider(ee,le,...Fe){return Me.registerCompletionItemProvider(Le,bt(ee),le,Fe)},registerInlineCompletionItemProvider(ee,le,Fe){return le.handleDidShowCompletionItem&&(0,Ye.$4G)(Le,"inlineCompletionsAdditions"),le.handleDidPartiallyAcceptCompletionItem&&(0,Ye.$4G)(Le,"inlineCompletionsAdditions"),Fe&&(0,Ye.$4G)(Le,"inlineCompletionsAdditions"),Me.registerInlineCompletionsProvider(Le,bt(ee),le,Fe)},registerInlineEditProvider(ee,le){return(0,Ye.$4G)(Le,"inlineEdit"),Me.registerInlineEditProvider(Le,bt(ee),le)},registerDocumentLinkProvider(ee,le){return Me.registerDocumentLinkProvider(Le,bt(ee),le)},registerColorProvider(ee,le){return Me.registerColorProvider(Le,bt(ee),le)},registerFoldingRangeProvider(ee,le){return Me.registerFoldingRangeProvider(Le,bt(ee),le)},registerSelectionRangeProvider(ee,le){return Me.registerSelectionRangeProvider(Le,ee,le)},registerCallHierarchyProvider(ee,le){return Me.registerCallHierarchyProvider(Le,ee,le)},registerTypeHierarchyProvider(ee,le){return Me.registerTypeHierarchyProvider(Le,ee,le)},setLanguageConfiguration:(ee,le)=>Me.setLanguageConfiguration(Le,ee,le),getTokenInformationAtPosition(ee,le){return(0,Ye.$4G)(Le,"tokenInformation"),Pe.tokenAtPosition(ee,le)},registerInlayHintsProvider(ee,le){return Me.registerInlayHintsProvider(Le,ee,le)},createLanguageStatusItem(ee,le){return Pe.createLanguageStatusItem(Le,ee,le)},registerDocumentDropEditProvider(ee,le,Fe){return Me.registerDocumentOnDropEditProvider(Le,ee,le,(0,Ye.$3G)(Le,"documentPaste")?Fe:void 0)}},an={get activeTextEditor(){return ve.getActiveTextEditor()},get visibleTextEditors(){return ve.getVisibleTextEditors()},get activeTerminal(){return wt.activeTerminal},get terminals(){return wt.terminals},async showTextDocument(ee,le,Fe){p.URI.isUri(ee)&&ee.scheme===A.Schemas.vscodeRemote&&!ee.authority&&At.report("workspace.showTextDocument",Le,"A URI of 'vscode-remote' scheme requires an authority.");const at=await(p.URI.isUri(ee)?Promise.resolve(cn.openTextDocument(ee)):Promise.resolve(ee));return ve.showTextDocument(at,le,Fe)},createTextEditorDecorationType(ee){return ve.createTextEditorDecorationType(Le,ee)},onDidChangeActiveTextEditor(ee,le,Fe){return ot(ve.onDidChangeActiveTextEditor)(ee,le,Fe)},onDidChangeVisibleTextEditors(ee,le,Fe){return ot(ve.onDidChangeVisibleTextEditors)(ee,le,Fe)},onDidChangeTextEditorSelection(ee,le,Fe){return ot(ve.onDidChangeTextEditorSelection)(ee,le,Fe)},onDidChangeTextEditorOptions(ee,le,Fe){return ot(ve.onDidChangeTextEditorOptions)(ee,le,Fe)},onDidChangeTextEditorVisibleRanges(ee,le,Fe){return ot(ve.onDidChangeTextEditorVisibleRanges)(ee,le,Fe)},onDidChangeTextEditorViewColumn(ee,le,Fe){return ot(ve.onDidChangeTextEditorViewColumn)(ee,le,Fe)},onDidCloseTerminal(ee,le,Fe){return ot(wt.onDidCloseTerminal)(ee,le,Fe)},onDidOpenTerminal(ee,le,Fe){return ot(wt.onDidOpenTerminal)(ee,le,Fe)},onDidChangeActiveTerminal(ee,le,Fe){return ot(wt.onDidChangeActiveTerminal)(ee,le,Fe)},onDidChangeTerminalDimensions(ee,le,Fe){return(0,Ye.$4G)(Le,"terminalDimensions"),ot(wt.onDidChangeTerminalDimensions)(ee,le,Fe)},onDidChangeTerminalState(ee,le,Fe){return ot(wt.onDidChangeTerminalState)(ee,le,Fe)},onDidWriteTerminalData(ee,le,Fe){return(0,Ye.$4G)(Le,"terminalDataWriteEvent"),ot(wt.onDidWriteTerminalData)(ee,le,Fe)},onDidExecuteTerminalCommand(ee,le,Fe){return(0,Ye.$4G)(Le,"terminalExecuteCommandEvent"),ot(wt.onDidExecuteTerminalCommand)(ee,le,Fe)},onDidChangeTerminalShellIntegration(ee,le,Fe){return(0,Ye.$4G)(Le,"terminalShellIntegration"),ot(ei.onDidChangeTerminalShellIntegration)(ee,le,Fe)},onDidStartTerminalShellExecution(ee,le,Fe){return(0,Ye.$4G)(Le,"terminalShellIntegration"),ot(ei.onDidStartTerminalShellExecution)(ee,le,Fe)},onDidEndTerminalShellExecution(ee,le,Fe){return(0,Ye.$4G)(Le,"terminalShellIntegration"),ot(ei.onDidEndTerminalShellExecution)(ee,le,Fe)},get state(){return zt.getState()},onDidChangeWindowState(ee,le,Fe){return ot(zt.onDidChangeWindowState)(ee,le,Fe)},showInformationMessage(ee,...le){return Ui.showMessage(Le,T.default.Info,ee,le[0],le.slice(1))},showWarningMessage(ee,...le){return Ui.showMessage(Le,T.default.Warning,ee,le[0],le.slice(1))},showErrorMessage(ee,...le){return Ui.showMessage(Le,T.default.Error,ee,le[0],le.slice(1))},showQuickPick(ee,le,Fe){return ct.showQuickPick(Le,ee,le,Fe)},showWorkspaceFolderPick(ee){return ct.showWorkspaceFolderPick(ee)},showInputBox(ee,le){return ct.showInput(ee,le)},showOpenDialog(ee){return Hi.showOpenDialog(Le,ee)},showSaveDialog(ee){return Hi.showSaveDialog(ee)},createStatusBarItem(ee,le,Fe){let at,Dt,Tt;return typeof ee=="string"?(at=ee,Dt=le,Tt=Fe):(Dt=ee,Tt=le),Mi.createStatusBarEntry(Le,at,Dt,Tt)},setStatusBarMessage(ee,le){return Mi.setStatusBarMessage(ee,le)},withScmProgress(ee){return At.report("window.withScmProgress",Le,"Use 'withProgress' instead."),Jt.withProgress(Le,{location:H.ProgressLocation.SourceControl},(le,Fe)=>ee({report(at){}}))},withProgress(ee,le){return Jt.withProgress(Le,ee,le)},createOutputChannel(ee,le){return bi.createOutputChannel(ee,le,Le)},createWebviewPanel(ee,le,Fe,at){return Ni.createWebviewPanel(Le,ee,le,Fe,at)},createWebviewTextEditorInset(ee,le,Fe,at){return(0,Ye.$4G)(Le,"editorInsets"),de.createWebviewEditorInset(ee,le,Fe,at,Le)},createTerminal(ee,le,Fe){return typeof ee=="object"?"pty"in ee?wt.createExtensionTerminal(ee):wt.createTerminalFromOptions(ee):wt.createTerminal(ee,le,Fe)},registerTerminalLinkProvider(ee){return wt.registerLinkProvider(ee)},registerTerminalProfileProvider(ee,le){return wt.registerProfileProvider(Le,ee,le)},registerTerminalQuickFixProvider(ee,le){return(0,Ye.$4G)(Le,"terminalQuickFixProvider"),wt.registerTerminalQuickFixProvider(ee,Le.identifier.value,le)},registerTreeDataProvider(ee,le){return Ne.registerTreeDataProvider(ee,le,Le)},createTreeView(ee,le){return Ne.createTreeView(ee,le,Le)},registerWebviewPanelSerializer:(ee,le)=>Ni.registerWebviewPanelSerializer(Le,ee,le),registerCustomEditorProvider:(ee,le,Fe={})=>Vi.registerCustomEditorProvider(Le,ee,le,Fe),registerFileDecorationProvider(ee){return oi.registerFileDecorationProvider(ee,Le)},registerUriHandler(ee){return fi.registerUriHandler(Le,ee)},createQuickPick(){return ct.createQuickPick(Le)},createInputBox(){return ct.createInputBox(Le)},get activeColorTheme(){return Wi.activeColorTheme},onDidChangeActiveColorTheme(ee,le,Fe){return ot(Wi.onDidChangeActiveColorTheme)(ee,le,Fe)},registerWebviewViewProvider(ee,le,Fe){return xi.registerWebviewViewProvider(Le,ee,le,Fe?.webviewOptions)},get activeNotebookEditor(){return Nt.activeNotebookEditor},onDidChangeActiveNotebookEditor(ee,le,Fe){return ot(Nt.onDidChangeActiveNotebookEditor)(ee,le,Fe)},get visibleNotebookEditors(){return Nt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return ot(Nt.onDidChangeVisibleNotebookEditors)},onDidChangeNotebookEditorSelection(ee,le,Fe){return ot(Ii.onDidChangeNotebookEditorSelection)(ee,le,Fe)},onDidChangeNotebookEditorVisibleRanges(ee,le,Fe){return ot(Ii.onDidChangeNotebookEditorVisibleRanges)(ee,le,Fe)},showNotebookDocument(ee,le){return Nt.showNotebookDocument(ee,le)},registerExternalUriOpener(ee,le,Fe){return(0,Ye.$4G)(Le,"externalUriOpener"),_i.registerExternalUriOpener(Le.identifier,ee,le,Fe)},registerProfileContentHandler(ee,le){return(0,Ye.$4G)(Le,"profileContentHandlers"),en.registerProfileContentHandler(Le,ee,le)},registerQuickDiffProvider(ee,le,Fe,at){return(0,Ye.$4G)(Le,"quickDiffProvider"),Qt.registerQuickDiffProvider(bt(ee),le,Fe,at)},get tabGroups(){return _t.tabGroups},registerShareProvider(ee,le){return(0,Ye.$4G)(Le,"shareProvider"),ci.registerShareProvider(bt(ee),le)}},cn={get rootPath(){return At.report("workspace.rootPath",Le,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),yt.getPath()},set rootPath(ee){throw new S.$$("rootPath")},getWorkspaceFolder(ee){return yt.getWorkspaceFolder(ee)},get workspaceFolders(){return yt.getWorkspaceFolders()},get name(){return yt.name},set name(ee){throw new S.$$("name")},get workspaceFile(){return yt.workspaceFile},set workspaceFile(ee){throw new S.$$("workspaceFile")},updateWorkspaceFolders:(ee,le,...Fe)=>yt.updateWorkspaceFolders(Le,ee,le||0,...Fe),onDidChangeWorkspaceFolders:function(ee,le,Fe){return ot(yt.onDidChangeWorkspace)(ee,le,Fe)},asRelativePath:(ee,le)=>yt.getRelativePath(ee,le),findFiles:(ee,le,Fe,at)=>yt.findFiles(ee,le,Fe,Le.identifier,at),findFiles2:(ee,le,Fe)=>((0,Ye.$4G)(Le,"findFiles2"),yt.findFiles2(ee,le,Le.identifier,Fe)),findTextInFiles:(ee,le,Fe,at)=>{(0,Ye.$4G)(Le,"findTextInFiles");let Dt,Tt;return typeof le=="object"?(Dt=le,Tt=Fe):(Dt={},Tt=le,at=Fe),yt.findTextInFiles(ee,Dt||{},Tt,Le.identifier,at)},save:ee=>yt.save(ee),saveAs:ee=>yt.saveAs(ee),saveAll:ee=>yt.saveAll(ee),applyEdit(ee,le){return wn.applyWorkspaceEdit(ee,Le,le)},createFileSystemWatcher:(ee,le,Fe,at)=>{let Dt;return typeof le=="boolean"?Dt={ignoreCreateEvents:!!le,ignoreChangeEvents:!!Fe,ignoreDeleteEvents:!!at,correlate:!1}:le&&((0,Ye.$4G)(Le,"createFileSystemWatcher"),Dt={...le,correlate:!0}),Ge.createFileSystemWatcher(yt,Le,ee,Dt)},get textDocuments(){return Bt.getAllDocumentData().map(ee=>ee.document)},set textDocuments(ee){throw new S.$$("textDocuments")},openTextDocument(ee){let le;const Fe=ee;if(typeof ee=="string")le=Promise.resolve(p.URI.file(ee));else if(p.URI.isUri(ee))le=Promise.resolve(ee);else if(!Fe||typeof Fe=="object")le=Bt.createDocumentData(Fe);else throw new Error("illegal argument - uriOrFileNameOrOptions");return le.then(at=>(at.scheme===A.Schemas.vscodeRemote&&!at.authority&&At.report("workspace.openTextDocument",Le,"A URI of 'vscode-remote' scheme requires an authority."),Bt.ensureDocumentData(at).then(Dt=>Dt.document)))},onDidOpenTextDocument:(ee,le,Fe)=>ot(Bt.onDidAddDocument)(ee,le,Fe),onDidCloseTextDocument:(ee,le,Fe)=>ot(Bt.onDidRemoveDocument)(ee,le,Fe),onDidChangeTextDocument:(ee,le,Fe)=>ot(Bt.onDidChangeDocument)(ee,le,Fe),onDidSaveTextDocument:(ee,le,Fe)=>ot(Bt.onDidSaveDocument)(ee,le,Fe),onWillSaveTextDocument:(ee,le,Fe)=>ot(Ci.getOnWillSaveTextDocumentEvent(Le))(ee,le,Fe),get notebookDocuments(){return Nt.notebookDocuments.map(ee=>ee.apiNotebook)},async openNotebookDocument(ee,le){let Fe;if(p.URI.isUri(ee))Fe=ee,await Nt.openNotebookDocument(ee);else if(typeof ee=="string")Fe=p.URI.revive(await Nt.createNotebookDocument({viewType:ee,content:le}));else throw new Error("Invalid arguments");return Nt.getNotebookDocument(Fe).apiNotebook},onDidSaveNotebookDocument(ee,le,Fe){return ot(Ei.onDidSaveNotebookDocument)(ee,le,Fe)},onDidChangeNotebookDocument(ee,le,Fe){return ot(Ei.onDidChangeNotebookDocument)(ee,le,Fe)},onWillSaveNotebookDocument(ee,le,Fe){return ot(Pi.getOnWillSaveNotebookDocumentEvent(Le))(ee,le,Fe)},get onDidOpenNotebookDocument(){return ot(Nt.onDidOpenNotebookDocument)},get onDidCloseNotebookDocument(){return ot(Nt.onDidCloseNotebookDocument)},registerNotebookSerializer(ee,le,Fe,at){return Nt.registerNotebookSerializer(Le,ee,le,Fe,(0,Ye.$3G)(Le,"notebookLiveShare")?at:void 0)},onDidChangeConfiguration:(ee,le,Fe)=>ot(zi.onDidChangeConfiguration)(ee,le,Fe),getConfiguration(ee,le){return le=arguments.length===1?void 0:le,zi.getConfiguration(ee,le,Le)},registerTextDocumentContentProvider(ee,le){return ai.registerTextDocumentContentProvider(ee,le)},registerTaskProvider:(ee,le)=>(At.report("window.registerTaskProvider",Le,"Use the corresponding function on the 'tasks' namespace instead"),qt.registerTaskProvider(Le,ee,le)),registerFileSystemProvider(ee,le,Fe){return(0,O.$Tc)(Ze.registerFileSystemProvider(Le,ee,le,Fe),Yt.addFileSystemProvider(ee,le,Fe))},get fs(){return Yt.value},registerFileSearchProvider:(ee,le)=>((0,Ye.$4G)(Le,"fileSearchProvider"),hi.registerFileSearchProvider(ee,le)),registerTextSearchProvider:(ee,le)=>((0,Ye.$4G)(Le,"textSearchProvider"),hi.registerTextSearchProvider(ee,le)),registerAITextSearchProvider:(ee,le)=>((0,Ye.$4G)(Le,"aiTextSearchProvider"),(0,Ye.$4G)(Le,"textSearchProvider"),hi.registerAITextSearchProvider(ee,le)),registerRemoteAuthorityResolver:(ee,le)=>((0,Ye.$4G)(Le,"resolvers"),Wt.registerRemoteAuthorityResolver(ee,le)),registerResourceLabelFormatter:ee=>((0,Ye.$4G)(Le,"resolvers"),Yi.$registerResourceLabelFormatter(ee)),getRemoteExecServer:ee=>((0,Ye.$4G)(Le,"resolvers"),Wt.getRemoteExecServer(ee)),onDidCreateFiles:(ee,le,Fe)=>ot(Ge.onDidCreateFile)(ee,le,Fe),onDidDeleteFiles:(ee,le,Fe)=>ot(Ge.onDidDeleteFile)(ee,le,Fe),onDidRenameFiles:(ee,le,Fe)=>ot(Ge.onDidRenameFile)(ee,le,Fe),onWillCreateFiles:(ee,le,Fe)=>ot(Ge.getOnWillCreateFileEvent(Le))(ee,le,Fe),onWillDeleteFiles:(ee,le,Fe)=>ot(Ge.getOnWillDeleteFileEvent(Le))(ee,le,Fe),onWillRenameFiles:(ee,le,Fe)=>ot(Ge.getOnWillRenameFileEvent(Le))(ee,le,Fe),openTunnel:ee=>((0,Ye.$4G)(Le,"tunnels"),Lt.openTunnel(Le,ee).then(le=>{if(!le)throw new Error("cannot open tunnel");return le})),get tunnels(){return(0,Ye.$4G)(Le,"tunnels"),Lt.getTunnels()},onDidChangeTunnels:(ee,le,Fe)=>((0,Ye.$4G)(Le,"tunnels"),ot(Lt.onDidChangeTunnels)(ee,le,Fe)),registerPortAttributesProvider:(ee,le)=>((0,Ye.$4G)(Le,"portsAttributes"),Lt.registerPortsAttributesProvider(ee,le)),registerTunnelProvider:(ee,le)=>((0,Ye.$4G)(Le,"tunnelFactory"),Lt.registerTunnelProvider(ee,le)),registerTimelineProvider:(ee,le)=>((0,Ye.$4G)(Le,"timeline"),$n.registerTimelineProvider(ee,le,Le.identifier,St.converter)),get isTrusted(){return yt.trusted},requestWorkspaceTrust:ee=>((0,Ye.$4G)(Le,"workspaceTrust"),yt.requestWorkspaceTrust(ee)),onDidGrantWorkspaceTrust:(ee,le,Fe)=>ot(yt.onDidGrantWorkspaceTrust)(ee,le,Fe),registerEditSessionIdentityProvider:(ee,le)=>((0,Ye.$4G)(Le,"editSessionIdentityProvider"),yt.registerEditSessionIdentityProvider(ee,le)),onWillCreateEditSessionIdentity:(ee,le,Fe)=>((0,Ye.$4G)(Le,"editSessionIdentityProvider"),ot(yt.getOnWillCreateEditSessionIdentityEvent(Le))(ee,le,Fe)),registerCanonicalUriProvider:(ee,le)=>((0,Ye.$4G)(Le,"canonicalUriProvider"),yt.registerCanonicalUriProvider(ee,le)),getCanonicalUri:(ee,le,Fe)=>((0,Ye.$4G)(Le,"canonicalUriProvider"),yt.provideCanonicalUri(ee,le,Fe))},un={get inputBox(){return At.report("scm.inputBox",Le,"Use 'SourceControl.inputBox' instead"),It.getLastInputBox(Le)},createSourceControl(ee,le,Fe){return It.createSourceControl(Le,ee,le,Fe)}},ln={createCommentController(ee,le){return Mt.createCommentController(Le,ee,le)}},yn={get activeDebugSession(){return Ct.activeDebugSession},get activeDebugConsole(){return Ct.activeDebugConsole},get breakpoints(){return Ct.breakpoints},get activeStackItem(){return Ct.activeStackItem},registerDebugVisualizationProvider(ee,le){return(0,Ye.$4G)(Le,"debugVisualization"),Ct.registerDebugVisualizationProvider(Le,ee,le)},registerDebugVisualizationTreeProvider(ee,le){return(0,Ye.$4G)(Le,"debugVisualization"),Ct.registerDebugVisualizationTree(Le,ee,le)},onDidStartDebugSession(ee,le,Fe){return ot(Ct.onDidStartDebugSession)(ee,le,Fe)},onDidTerminateDebugSession(ee,le,Fe){return ot(Ct.onDidTerminateDebugSession)(ee,le,Fe)},onDidChangeActiveDebugSession(ee,le,Fe){return ot(Ct.onDidChangeActiveDebugSession)(ee,le,Fe)},onDidReceiveDebugSessionCustomEvent(ee,le,Fe){return ot(Ct.onDidReceiveDebugSessionCustomEvent)(ee,le,Fe)},onDidChangeBreakpoints(ee,le,Fe){return ot(Ct.onDidChangeBreakpoints)(ee,le,Fe)},onDidChangeActiveStackItem(ee,le,Fe){return ot(Ct.onDidChangeActiveStackItem)(ee,le,Fe)},registerDebugConfigurationProvider(ee,le,Fe){return Ct.registerDebugConfigurationProvider(ee,le,Fe||Zt.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(ee,le){return Ct.registerDebugAdapterDescriptorFactory(Le,ee,le)},registerDebugAdapterTrackerFactory(ee,le){return Ct.registerDebugAdapterTrackerFactory(ee,le)},startDebugging(ee,le,Fe){return!Fe||typeof Fe=="object"&&"configuration"in Fe?Ct.startDebugging(ee,le,{parentSession:Fe}):Ct.startDebugging(ee,le,Fe||{})},stopDebugging(ee){return Ct.stopDebugging(ee)},addBreakpoints(ee){return Ct.addBreakpoints(ee)},removeBreakpoints(ee){return Ct.removeBreakpoints(ee)},asDebugSourceUri(ee,le){return Ct.asDebugSourceUri(ee,le)}},En={registerTaskProvider:(ee,le)=>qt.registerTaskProvider(Le,ee,le),fetchTasks:ee=>qt.fetchTasks(ee),executeTask:ee=>qt.executeTask(Le,ee),get taskExecutions(){return qt.taskExecutions},onDidStartTask:(ee,le,Fe)=>ot(qt.onDidStartTask)(ee,le,Fe),onDidEndTask:(ee,le,Fe)=>ot(qt.onDidEndTask)(ee,le,Fe),onDidStartTaskProcess:(ee,le,Fe)=>ot(qt.onDidStartTaskProcess)(ee,le,Fe),onDidEndTaskProcess:(ee,le,Fe)=>ot(qt.onDidEndTaskProcess)(ee,le,Fe)},hn={createNotebookController(ee,le,Fe,at,Dt){return Di.createNotebookController(Le,ee,le,Fe,at,(0,Ye.$3G)(Le,"notebookMessaging")?Dt:void 0)},registerNotebookCellStatusBarItemProvider:(ee,le)=>Nt.registerNotebookCellStatusBarItemProvider(Le,ee,le),createRendererMessaging(ee){return mi.createRendererMessaging(Le,ee)},createNotebookControllerDetectionTask(ee){return(0,Ye.$4G)(Le,"notebookKernelSource"),Di.createNotebookControllerDetectionTask(Le,ee)},registerKernelSourceActionProvider(ee,le){return(0,Ye.$4G)(Le,"notebookKernelSource"),Di.registerKernelSourceActionProvider(Le,ee,le)},onDidChangeNotebookCellExecutionState(ee,le,Fe){return(0,Ye.$4G)(Le,"notebookCellExecutionState"),ot(Di.onDidChangeNotebookCellExecutionState)(ee,le,Fe)}},Qi={t(...ee){if(typeof ee[0]=="string"){const le=ee.shift(),Fe=!ee||typeof ee[0]!="object"?ee:ee[0];return wi.getMessage(Le.identifier.value,{message:le,args:Fe})}return wi.getMessage(Le.identifier.value,ee[0])},get bundle(){return wi.getBundle(Le.identifier.value)},get uri(){return wi.getBundleUri(Le.identifier.value)}},dn={_version:1,transferActiveChat(ee){return(0,Ye.$4G)(Le,"interactive"),Li.transferActiveChat(ee)}},fn={getRelatedInformation(ee,le){return(0,Ye.$4G)(Le,"aiRelatedInformation"),nn.getRelatedInformation(Le,ee,le)},registerRelatedInformationProvider(ee,le){return(0,Ye.$4G)(Le,"aiRelatedInformation"),nn.registerRelatedInformationProvider(Le,ee,le)},registerEmbeddingVectorProvider(ee,le){return(0,Ye.$4G)(Le,"aiRelatedInformation"),Gi.registerEmbeddingVectorProvider(Le,ee,le)}},gn={_version:1,registerChatResponseProvider(ee,le,Fe){return(0,Ye.$4G)(Le,"chatProvider"),Ht.registerLanguageModel(Le,ee,le,Fe)},registerChatVariableResolver(ee,le,Fe,at,Dt,Tt,Ri,Ji){return(0,Ye.$4G)(Le,"chatVariableResolver"),tn.registerVariableResolver(Le,ee,le,Fe,at,Dt,Tt,Ri,Ji?.id)},registerMappedEditsProvider(ee,le){return(0,Ye.$4G)(Le,"mappedEditsProvider"),Me.registerMappedEditsProvider(Le,ee,le)},createChatParticipant(ee,le){return Li.createChatAgent(Le,ee,le)},createDynamicChatParticipant(ee,le,Fe){return(0,Ye.$4G)(Le,"chatParticipantPrivate"),Li.createDynamicChatAgent(Le,ee,le,Fe)}},Dn={selectChatModels:ee=>vt.quality==="stable"?(console.warn(`[${E.$qn.toKey(Le.identifier)}] This API is disabled in '${vt.environment.appName}'-stable.`),Promise.resolve([])):Ht.selectLanguageModels(Le,ee??{}),onDidChangeChatModels:(ee,le,Fe)=>vt.quality==="stable"?(console.warn(`[${E.$qn.toKey(Le.identifier)}] This API is disabled in '${vt.environment.appName}'-stable.`),k.Event.None(ee,le,Fe)):Ht.onDidChangeProviders(ee,le,Fe),registerChatModelProvider:(ee,le,Fe)=>((0,Ye.$4G)(Le,"chatProvider"),Ht.registerLanguageModel(Le,ee,le,Fe)),get embeddingModels(){return(0,Ye.$4G)(Le,"embeddings"),Ti.embeddingsModels},onDidChangeEmbeddingModels:(ee,le,Fe)=>((0,Ye.$4G)(Le,"embeddings"),Ti.onDidChange(ee,le,Fe)),registerEmbeddingsProvider(ee,le){return(0,Ye.$4G)(Le,"embeddings"),Ti.registerEmbeddingsProvider(Le,ee,le)},async computeEmbeddings(ee,le,Fe){return(0,Ye.$4G)(Le,"embeddings"),Ti.computeEmbeddings(ee,le,Fe)},registerTool(ee,le){return(0,Ye.$4G)(Le,"chatVariableResolver"),qi.registerTool(Le,ee,le)},invokeTool(ee,le,Fe){return(0,Ye.$4G)(Le,"chatVariableResolver"),qi.invokeTool(ee,le,Fe)},get tools(){return(0,Ye.$4G)(Le,"chatVariableResolver"),qi.tools}},Sn={registerSpeechProvider(ee,le){return(0,Ye.$4G)(Le,"speech"),bn.registerProvider(Le.identifier,ee,le)}};return{version:vt.version,ai:fn,authentication:ji,commands:vn,comments:ln,chat:gn,debug:yn,env:gi,extensions:sn,interactive:dn,l10n:Qi,languages:on,lm:Dn,notebooks:hn,scm:un,speech:Sn,tasks:En,tests:Bi,window:an,workspace:cn,Breakpoint:H.$uO,TerminalOutputAnchor:H.TerminalOutputAnchor,ChatResultFeedbackKind:H.ChatResultFeedbackKind,ChatVariableLevel:H.ChatVariableLevel,ChatCompletionItem:H.$pP,CallHierarchyIncomingCall:H.$SN,CallHierarchyItem:H.$RN,CallHierarchyOutgoingCall:H.$TN,CancellationError:S.$7,CancellationTokenSource:w.$xe,CandidatePortSource:i.CandidatePortSource,CodeAction:H.$ON,CodeActionKind:H.$PN,CodeActionTriggerKind:H.CodeActionTriggerKind,CodeLens:H.$UN,Color:H.$8N,ColorInformation:H.$9N,ColorPresentation:H.$0N,ColorThemeKind:H.ColorThemeKind,CommentMode:H.CommentMode,CommentState:H.CommentState,CommentThreadCollapsibleState:H.CommentThreadCollapsibleState,CommentThreadState:H.CommentThreadState,CommentThreadApplicability:H.CommentThreadApplicability,CompletionItem:H.$2N,CompletionItemKind:H.CompletionItemKind,CompletionItemTag:H.CompletionItemTag,CompletionList:H.$3N,CompletionTriggerKind:H.CompletionTriggerKind,ConfigurationTarget:H.ConfigurationTarget,CustomExecution:H.$fO,DebugAdapterExecutable:H.$yO,DebugAdapterInlineImplementation:H.$BO,DebugAdapterNamedPipeServer:H.$AO,DebugAdapterServer:H.$zO,DebugConfigurationProviderTriggerKind:Zt.DebugConfigurationProviderTriggerKind,DebugConsoleMode:H.DebugConsoleMode,DebugVisualization:H.$RO,DecorationRangeBehavior:H.DecorationRangeBehavior,Diagnostic:H.$HN,DiagnosticRelatedInformation:H.$GN,DiagnosticSeverity:H.DiagnosticSeverity,DiagnosticTag:H.DiagnosticTag,Disposable:H.$tN,DocumentHighlight:H.$KN,DocumentHighlightKind:H.DocumentHighlightKind,MultiDocumentHighlight:H.$LN,DocumentLink:H.$7N,DocumentSymbol:H.$NN,EndOfLine:H.EndOfLine,EnvironmentVariableMutatorType:H.EnvironmentVariableMutatorType,EvaluatableExpression:H.$EO,InlineValueText:H.$FO,InlineValueVariableLookup:H.$GO,InlineValueEvaluatableExpression:H.$HO,InlineCompletionTriggerKind:H.InlineCompletionTriggerKind,EventEmitter:k.$me,ExtensionKind:H.ExtensionKind,ExtensionMode:H.ExtensionMode,ExternalUriOpenerPriority:H.ExternalUriOpenerPriority,FileChangeType:H.FileChangeType,FileDecoration:H.$TO,FileDecoration2:H.$TO,FileSystemError:H.$KO,FileType:d.FileType,FilePermission:d.FilePermission,FoldingRange:H.$LO,FoldingRangeKind:H.FoldingRangeKind,FunctionBreakpoint:H.$wO,InlineCompletionItem:H.$4N,InlineCompletionList:H.$5N,Hover:H.$IN,VerboseHover:H.$JN,HoverVerbosityAction:H.HoverVerbosityAction,IndentAction:y.IndentAction,Location:H.$FN,MarkdownString:H.$VN,OverviewRulerLane:u.OverviewRulerLane,ParameterInformation:H.$WN,PortAutoForwardAction:H.PortAutoForwardAction,Position:H.$uN,ProcessExecution:H.$dO,ProgressLocation:H.ProgressLocation,QuickInputButtons:H.$SO,Range:H.$vN,RelativePattern:H.$sO,Selection:H.$wN,SelectionRange:H.$QN,SemanticTokens:H.$OO,SemanticTokensBuilder:H.$NO,SemanticTokensEdit:H.$PO,SemanticTokensEdits:H.$QO,SemanticTokensLegend:H.$MO,ShellExecution:H.$eO,ShellQuoting:H.ShellQuoting,SignatureHelp:H.$YN,SignatureHelpTriggerKind:H.SignatureHelpTriggerKind,SignatureInformation:H.$XN,SnippetString:H.$EN,SourceBreakpoint:H.$vO,StandardTokenType:H.StandardTokenType,StatusBarAlignment:H.StatusBarAlignment,SymbolInformation:H.$MN,SymbolKind:H.SymbolKind,SymbolTag:H.SymbolTag,Task:H.$gO,TaskGroup:H.$cO,TaskPanelKind:H.TaskPanelKind,TaskRevealKind:H.TaskRevealKind,TaskScope:H.TaskScope,TerminalLink:H.$$N,TerminalQuickFixTerminalCommand:H.$aO,TerminalQuickFixOpener:H.$_N,TerminalLocation:H.TerminalLocation,TerminalProfile:H.$bO,TerminalExitReason:H.TerminalExitReason,TerminalShellExecutionCommandLineConfidence:H.TerminalShellExecutionCommandLineConfidence,TextDocumentSaveReason:H.TextDocumentSaveReason,TextEdit:H.$AN,SnippetTextEdit:H.$CN,TextEditorCursorStyle:a.TextEditorCursorStyle,TextEditorLineNumbersStyle:H.TextEditorLineNumbersStyle,TextEditorRevealType:H.TextEditorRevealType,TextEditorSelectionChangeKind:H.TextEditorSelectionChangeKind,SyntaxTokenType:H.SyntaxTokenType,TextDocumentChangeReason:H.TextDocumentChangeReason,ThemeColor:H.$rO,ThemeIcon:H.$qO,TreeItem:H.$hO,TreeItemCheckboxState:H.TreeItemCheckboxState,TreeItemCollapsibleState:H.TreeItemCollapsibleState,TypeHierarchyItem:H.$dP,UIKind:di.UIKind,Uri:p.URI,ViewColumn:H.ViewColumn,WorkspaceEdit:H.$DN,DocumentPasteTriggerKind:H.DocumentPasteTriggerKind,DocumentDropEdit:H.$nO,DocumentDropOrPasteEditKind:H.$oO,DocumentPasteEdit:H.$pO,InlayHint:H.$1N,InlayHintLabelPart:H.$ZN,InlayHintKind:H.InlayHintKind,RemoteAuthorityResolverError:H.$zN,ResolvedAuthority:H.$xN,ManagedResolvedAuthority:H.$yN,SourceControlInputBoxValidationType:H.SourceControlInputBoxValidationType,ExtensionRuntime:H.ExtensionRuntime,TimelineItem:H.$4O,NotebookRange:H.$VO,NotebookCellKind:H.NotebookCellKind,NotebookCellExecutionState:H.NotebookCellExecutionState,NotebookCellData:H.$WO,NotebookData:H.$XO,NotebookRendererScript:H.$2O,NotebookCellStatusBarAlignment:H.NotebookCellStatusBarAlignment,NotebookEditorRevealType:H.NotebookEditorRevealType,NotebookCellOutput:H.$ZO,NotebookCellOutputItem:H.$YO,NotebookCellStatusBarItem:H.$1O,NotebookControllerAffinity:H.NotebookControllerAffinity,NotebookControllerAffinity2:H.NotebookControllerAffinity2,NotebookEdit:H.$BN,NotebookKernelSourceAction:H.$3O,NotebookVariablesRequestKind:H.NotebookVariablesRequestKind,PortAttributes:H.$6O,LinkedEditingRanges:H.$5O,TestResultState:H.TestResultState,TestRunRequest:H.$7O,TestMessage:H.$8O,TestTag:H.$9O,TestRunProfileKind:H.TestRunProfileKind,TextSearchCompleteMessageType:Pt.TextSearchCompleteMessageType,DataTransfer:H.$mO,DataTransferItem:H.$iO,TestCoverageCount:H.$0O,FileCoverage:H.$_O,FileCoverage2:H.$_O,StatementCoverage:H.$aP,BranchCoverage:H.$bP,DeclarationCoverage:H.$cP,WorkspaceTrustState:H.WorkspaceTrustState,LanguageStatusSeverity:H.LanguageStatusSeverity,QuickPickItemKind:H.QuickPickItemKind,InputBoxValidationSeverity:H.InputBoxValidationSeverity,TabInputText:H.$eP,TabInputTextDiff:H.$fP,TabInputTextMerge:H.$gP,TabInputCustom:H.$hP,TabInputNotebook:H.$jP,TabInputNotebookDiff:H.$kP,TabInputWebview:H.$iP,TabInputTerminal:H.$lP,TabInputInteractiveWindow:H.$mP,TabInputChat:H.$nP,TabInputTextMultiDiff:H.$oP,TelemetryTrustedValue:o.$sp,LogLevel:n.LogLevel,EditSessionIdentityMatch:h.EditSessionIdentityMatch,InteractiveSessionVoteDirection:H.InteractiveSessionVoteDirection,ChatCopyKind:H.ChatCopyKind,InteractiveEditorResponseFeedbackKind:H.InteractiveEditorResponseFeedbackKind,DebugStackFrame:H.$CO,DebugThread:H.$DO,RelatedInformationType:H.RelatedInformationType,SpeechToTextStatus:H.SpeechToTextStatus,TextToSpeechStatus:H.TextToSpeechStatus,PartialAcceptTriggerKind:H.PartialAcceptTriggerKind,KeywordRecognitionStatus:H.KeywordRecognitionStatus,ChatResponseMarkdownPart:H.$qP,ChatResponseFileTreePart:H.$uP,ChatResponseAnchorPart:H.$vP,ChatResponseProgressPart:H.$wP,ChatResponseProgressPart2:H.$xP,ChatResponseReferencePart:H.$AP,ChatResponseWarningPart:H.$yP,ChatResponseTextEditPart:H.$BP,ChatResponseMarkdownWithVulnerabilitiesPart:H.$rP,ChatResponseCommandButtonPart:H.$zP,ChatResponseDetectedParticipantPart:H.$sP,ChatResponseConfirmationPart:H.$tP,ChatRequestTurn:H.$CP,ChatResponseTurn:H.$DP,ChatLocation:H.ChatLocation,LanguageModelChatMessageRole:H.LanguageModelChatMessageRole,LanguageModelChatMessage:H.$FP,LanguageModelChatMessageFunctionResultPart:H.$EP,LanguageModelChatResponseTextPart:H.$HP,LanguageModelChatResponseFunctionUsePart:H.$GP,LanguageModelChatMessage2:H.$FP,LanguageModelChatSystemMessage:H.$IP,LanguageModelChatUserMessage:H.$JP,LanguageModelChatAssistantMessage:H.$KP,LanguageModelError:H.$LP,NewSymbolName:H.$JO,NewSymbolNameTag:H.NewSymbolNameTag,NewSymbolNameTriggerKind:H.NewSymbolNameTriggerKind,InlineEdit:H.$MP,InlineEditTriggerKind:H.InlineEditTriggerKind}}}}),define(ke[319],Ce([1,0,61,127,44,121,45,34,58,57,130,132,133,89,93,85,120,69,51,88,67,71,259,12,131,86,87,91,95,125,96]),function(oe,e,w,S,k,O,A,T,p,a,R,y,u,E,d,n,s,o,h,i,r,t,c,l,m,f,$,I,D,v,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,w.$Ks)(f.$Ooc,f.$Noc,w.InstantiationType.Delayed),(0,w.$Ks)(l.$ak,c.$4pc,w.InstantiationType.Delayed),(0,w.$Ks)(n.$Tnc,n.$Unc,w.InstantiationType.Delayed),(0,w.$Ks)(T.$hQ,T.$gQ,w.InstantiationType.Eager),(0,w.$Ks)(I.$4nc,I.$5nc,w.InstantiationType.Eager),(0,w.$Ks)(D.$Ioc,D.$Joc,w.InstantiationType.Eager),(0,w.$Ks)(A.$goc,A.$eoc,w.InstantiationType.Eager),(0,w.$Ks)(o.$ioc,o.$hoc,w.InstantiationType.Eager),(0,w.$Ks)(C.$Yoc,C.$Zoc,w.InstantiationType.Eager),(0,w.$Ks)(y.$4oc,y.$8oc,w.InstantiationType.Eager),(0,w.$Ks)(O.$0oc,O.$9oc,w.InstantiationType.Eager),(0,w.$Ks)(p.$9P,p.$8P,w.InstantiationType.Eager),(0,w.$Ks)($.$Poc,$.$Qoc,w.InstantiationType.Eager),(0,w.$Ks)(h.$Xnc,h.$Wnc,w.InstantiationType.Eager),(0,w.$Ks)(S.$Cpc,S.$Bpc,w.InstantiationType.Delayed),(0,w.$Ks)(u.$npc,u.$opc,w.InstantiationType.Eager),(0,w.$Ks)(E.$Boc,E.$Aoc,w.InstantiationType.Eager),(0,w.$Ks)(R.$Ppc,R.$Opc,w.InstantiationType.Eager),(0,w.$Ks)(a.$Eoc,a.$Hoc,w.InstantiationType.Eager),(0,w.$Ks)(v.$Qpc,v.$Rpc,w.InstantiationType.Eager),(0,w.$Ks)(d.$EFb,d.$FFb,w.InstantiationType.Eager),(0,w.$Ks)(s.$1pc,s.$Zpc,w.InstantiationType.Eager),(0,w.$Ks)(k.$doc,k.$coc,w.InstantiationType.Eager),(0,w.$Ks)(i.$Loc,i.$Koc,w.InstantiationType.Eager),(0,w.$Ks)(r.$fQ,r.$cQ,w.InstantiationType.Eager),(0,w.$Ks)(t.$soc,t.$toc,w.InstantiationType.Eager),(0,w.$Ks)(m.$Woc,m.$Xoc,w.InstantiationType.Eager)}),define(ke[320],Ce([1,0,318,46,2,315,7,11,266]),function(oe,e,w,S,k,O,A,T,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dsc=void 0;class a extends O.$7pc{j(){}getModule(E,d){for(const n of this.b){const s=n(E);if(s){E=s;break}}if(this.a.has(E))return this.a.get(E).load(E,d,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class R extends S.$Soc{constructor(){super(...arguments),this.extensionRuntime=A.ExtensionRuntime.Webworker}async vb(){this.h.createInstance(p.$csc);const E=this.h.invokeFunction(w.$3pc);this.r=this.h.createInstance(a,E,{mine:this.J,all:this.L}),await this.r.install(),performance.mark("code/extHost/didInitAPI"),await this.Bb()}wb(E){return E.browser}async xb(E,d,n){d=d.with({path:y(d.path,".js")});const s=E?.identifier.value;s&&performance.mark(`code/extHost/willFetchExtensionCode/${s}`);const o=k.URI.revive(await this.C.$asBrowserUri(d)),h=await fetch(o.toString(!0));if(s&&performance.mark(`code/extHost/didFetchExtensionCode/${s}`),h.status!==200)throw new Error(h.statusText);const i=await h.text(),r=`${d.toString(!0)}#vscode-extension`,t=`${i}
//# sourceURL=${r}`;let c;try{c=new Function("module","exports","require",t)}catch($){throw console.error(s?`Loading code for extension ${s} failed: ${$.message}`:`Loading code failed: ${$.message}`),console.error(`${d.toString(!0)}${typeof $.line=="number"?` line ${$.line}`:""}${typeof $.column=="number"?` column ${$.column}`:""}`),console.error($),$}E&&await this.w.initializeLocalizedMessages(E);const l={},m={exports:l},f=$=>{const I=this.r.getModule($,d);if(I===void 0)throw new Error(`Cannot load module '${$}'`);return I};try{return n.codeLoadingStart(),s&&performance.mark(`code/extHost/willLoadExtensionCode/${s}`),c(m,l,f),m.exports!==l?m.exports:l}finally{s&&performance.mark(`code/extHost/didLoadExtensionCode/${s}`),n.codeLoadingStop()}}async $setRemoteEnvironment(E){}async Bb(E=5e3){if(!this.f.environment.isExtensionDevelopmentDebug)return;const d=Date.now()+E;for(;Date.now()<d&&!("__jsDebugIsReady"in globalThis);)await(0,T.$Gh)(10)}}e.$dsc=R;function y(u,E){return u.endsWith(E)?u:u+E}}),define(ke[321],Ce([1,0,74,61,12,46,228,92,320]),function(oe,e,w,S,k,O,A,T,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,S.$Ks)(k.$_j,new w.$Ci(A.$6pc,[!0],!0)),(0,S.$Ks)(O.$Toc,p.$dsc,S.InstantiationType.Eager),(0,S.$Ks)(T.$joc,T.$koc,S.InstantiationType.Eager)}),define(ke[329],Ce([1,0,23,6,84,316,268,20,65,16,2,319,321]),function(oe,e,w,S,k,O,A,T,p,a,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=t,T=qe(T),p=qe(p);const y=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const u=postMessage.bind(self);self.postMessage=()=>console.trace("'postMessage' has been blocked");function E(c){return/^(file|vscode-remote):/i.test(c)}const d=fetch.bind(self);function n(c){self.fetch=async function(l,m){return l instanceof Request||E(String(l))&&(l=(await c(R.URI.parse(String(l)))).toString(!0)),d(l,m)},self.XMLHttpRequest=class extends XMLHttpRequest{open(l,m,f,$,I){(async()=>(E(m.toString())&&(m=(await c(R.URI.parse(m.toString()))).toString(!0)),super.open(l,m,f??!0,$,I)))()}}}if(self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const c=self.Worker;Worker=function(l,m){if(/^file:/i.test(l.toString()))l=a.$Zg.uriToBrowserUri(R.URI.parse(l.toString())).toString(!0);else if(/^vscode-remote:/i.test(l.toString()))throw new Error("Creating workers from remote extensions is currently not supported.");const $=`(${function(C){function P(L){return typeof L=="string"||L instanceof URL?String(L).replace(/^file:\/\//i,"vscode-file://vscode-app"):L}const g=fetch.bind(self);self.fetch=function(L,N){return L instanceof Request?g(L,N):g(P(L),N)},self.XMLHttpRequest=class extends XMLHttpRequest{open(L,N,B,G,W){return super.open(L,P(N),B??!0,G,W)}};const b=importScripts.bind(self);self.importScripts=(...L)=>{b(...L.map(P))},b(C)}.toString()}('${l}'))`;m=m||{},m.name=`${name} -> ${m.name||T.$pc(l.toString())}`;const I=new Blob([$],{type:"application/javascript"}),D=URL.createObjectURL(I);return new c(D,m)}}else self.Worker=class extends A.$esc{constructor(c,l){super(u,c,{name:T.$pc(c.toString()),...l})}};const s=new class{constructor(){this.pid=void 0}exit(c){y()}};class o{constructor(){const l=new MessageChannel,m=new S.$me;let f=!1;u(l.port2,[l.port2]),l.port1.onmessage=$=>{const{data:I}=$;if(!(I instanceof ArrayBuffer)){console.warn("UNKNOWN data received",I);return}const D=w.$Oe.wrap(new Uint8Array(I,0,I.byteLength));if((0,k.$zn)(D,k.MessageType.Terminate)){f=!0,i("received terminate message from renderer");return}m.fire(D)},this.protocol={onMessage:m.event,send:$=>{if(!f){const I=$.buffer.buffer.slice($.buffer.byteOffset,$.buffer.byteOffset+$.buffer.byteLength);l.port1.postMessage(I,[I])}}}}}function h(c){return new Promise(l=>{const m=c.onMessage(f=>{m.dispose();const $=JSON.parse(f.toString());c.send((0,k.$yn)(k.MessageType.Initialized)),l({protocol:c,initData:$})});c.send((0,k.$yn)(k.MessageType.Ready))})}let i=c=>y();function r(c){return!!c&&typeof c=="object"&&c.type==="vscode.init"&&c.data instanceof Map}function t(){p.mark("code/extHost/willConnectToRenderer");const c=new o;return{onmessage(l){r(l)&&h(c.protocol).then(m=>{p.mark("code/extHost/didWaitForInitData");const f=new O.$9pc(m.protocol,m.initData,s,null,l.data);n($=>f.asBrowserUri($)),i=$=>f.terminate($)})}}}})}).call(this);

//# sourceMappingURL=https://main.vscode-cdn.net/sourcemaps/c2e20cb17fae44eb26611cb9a4690059cea0e605/core/vs/workbench/api/worker/extensionHostWorker.js.map
